var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 108344;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 108384;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(109211);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,107,0,0,0,115,119,101,101,112,88,46,100,117,114,97,116,105,111,110,0,1,0,0,0,108,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,109,0,0,0,1,0,0,0,129,0,0,0,1,0,0,0,130,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,131,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,82,95,109,0,0,0,0,0,0,0,1,0,0,0,134,0,0,0,115,111,117,114,99,101,46,73,0,0,0,0,0,0,0,0,1,0,0,0,136,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,71,95,109,32,94,32,50,46,48,0,1,0,0,0,137,0,0,0,1,0,0,0,141,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,65,95,97,118,103,0,0,0,0,0,1,0,0,0,146,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,0,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,147,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,148,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,82,95,109,0,0,0,0,0,0,0,1,0,0,0,152,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,65,95,97,118,103,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,40,6,0,0,74,0,0,0,3,0,0,0,74,0,0,0,108,0,0,0,0,0,0,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,97,103,110,101,116,105,99,46,70,108,117,120,84,117,98,101,115,46,69,120,97,109,112,108,101,115,46,77,111,118,105,110,103,67,111,105,108,65,99,116,117,97,116,111,114,46,70,111,114,99,101,83,116,114,111,107,101,66,101,104,97,118,105,111,117,114,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,103,110,101,116,105,99,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,97,103,110,101,116,105,99,46,70,108,117,120,84,117,98,101,115,46,69,120,97,109,112,108,101,115,46,77,111,118,105,110,103,67,111,105,108,65,99,116,117,97,116,111,114,46,70,111,114,99,101,83,116,114,111,107,101,66,101,104,97,118,105,111,117,114,95,105,110,102,111,46,120,109,108,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,78,111,78,97,109,101,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,116,105,109,101,32,60,32,115,119,101,101,112,88,46,115,116,97,114,116,84,105,109,101,0,116,105,109,101,32,60,32,115,119,101,101,112,88,46,115,116,97,114,116,84,105,109,101,32,43,32,115,119,101,101,112,88,46,100,117,114,97,116,105,111,110,0,0,0,0,0,0,0,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,32,60,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,48,0,0,0,0,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,32,60,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,48,0,0,0,0,1,0,0,0,105,0,0,0,1,0,0,0,105,0,0,0,1,0,0,0,120,0,0,0,1,0,0,0,111,0,0,0,184,10,0,0,192,10,0,0,200,10,0,0,208,10,0,0,208,9,0,0,232,9,0,0,24,10,0,0,104,10,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,99,116,117,97,116,111,114,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,97,120,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,99,116,117,97,116,111,114,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,105,110,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,95,116,97,98,108,101,79,110,70,105,108,101,82,101,97,100,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,101,109,112,116,121,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,50,46,48,32,42,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,48,32,47,32,48,46,48,48,54,53,48,48,48,48,48,48,48,48,48,48,48,48,48,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,1,0,0,0,26,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,27,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,31,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,1,0,0,0,32,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,1,0,0,0,33,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,82,95,109,0,0,0,1,0,0,0,36,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,50,46,82,95,109,0,0,0,1,0,0,0,41,0,0,0,115,119,101,101,112,88,46,100,117,114,97,116,105,111,110,0,1,0,0,0,42,0,0,0,1,0,0,0,48,0,0,0,1,0,0,0,49,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,50,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,82,95,109,0,0,0,0,0,0,0,1,0,0,0,58,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,65,95,97,118,103,0,0,0,0,0,1,0,0,0,74,0,0,0,115,111,117,114,99,101,46,73,0,0,0,0,0,0,0,0,1,0,0,0,76,0,0,0,1,0,0,0,77,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,78,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,82,95,109,0,0,0,0,0,0,0,1,0,0,0,82,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,65,95,97,118,103,0,0,0,0,0,1,0,0,0,83,0,0,0,40,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,84,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,71,95,109,32,94,32,50,46,48,0,1,0,0,0,85,0,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,37,115,40,110,111,109,105,110,97,108,61,37,103,41,0,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,1,0,0,0,180,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,1,0,0,0,181,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,50,46,82,95,109,0,0,0,1,0,0,0,199,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,203,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,44,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,41,41,0,0,0,0,0,192,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,50,46,48,32,42,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,48,32,47,32,48,46,48,48,54,53,48,48,48,48,48,48,48,48,48,48,48,48,48,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,1,0,0,0,208,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,1,0,0,0,209,0,0,0,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,82,95,109,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,76,105,110,101,97,114,83,101,103,109,101,110,116,115,32,97,110,100,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,67,111,110,115,116,97,110,116,83,101,103,109,101,110,116,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,84,97,98,108,101,115,46,109,111,0,0,0,248,19,0,0,76,1,0,0,5,0,0,0,78,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,119,101,101,112,88,46,100,117,114,97,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,119,101,101,112,88,46,100,117,114,97,116,105,111,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,192,20,0,0,162,1,0,0,5,0,0,0,163,1,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,108,95,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,108,95,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,103,110,101,116,105,99,47,70,108,117,120,84,117,98,101,115,46,109,111,0,0,0,0,0,0,144,21,0,0,239,12,0,0,9,0,0,0,240,12,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,21,0,0,237,12,0,0,9,0,0,0,237,12,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,21,0,0,236,12,0,0,9,0,0,0,236,12,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,76,101,97,107,49,46,114,95,48,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,21,0,0,233,12,0,0,9,0,0,0,235,12,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,98,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,21,0,0,177,11,0,0,9,0,0,0,177,11,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,103,95,109,97,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,21,0,0,176,11,0,0,9,0,0,0,176,11,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,232,25,0,0,240,6,0,0,7,0,0,0,241,6,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,232,25,0,0,237,6,0,0,7,0,0,0,238,6,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,232,25,0,0,235,6,0,0,7,0,0,0,236,6,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,232,25,0,0,170,17,0,0,7,0,0,0,171,17,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,232,25,0,0,167,17,0,0,7,0,0,0,169,17,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,232,25,0,0,95,5,0,0,7,0,0,0,96,5,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,232,25,0,0,94,5,0,0,7,0,0,0,94,5,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,21,0,0,229,8,0,0,9,0,0,0,231,8,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,97,114,109,97,116,117,114,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,21,0,0,223,8,0,0,9,0,0,0,223,8,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,114,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,114,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,72,35,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,114,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,114,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,32,36,0,0,64,0,0,0,3,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,109,95,97,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,109,95,97,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,21,0,0,98,2,0,0,11,0,0,0,99,2,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,109,97,116,101,114,105,97,108,46,84,95,111,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,109,97,116,101,114,105,97,108,46,84,95,111,112,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,21,0,0,180,14,0,0,9,0,0,0,180,14,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,109,97,116,101,114,105,97,108,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,109,97,116,101,114,105,97,108,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,21,0,0,176,14,0,0,9,0,0,0,176,14,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,99,116,117,97,116,111,114,46,114,95,99,111,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,99,116,117,97,116,111,114,46,114,95,99,111,114,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,144,21,0,0,79,2,0,0,11,0,0,0,80,2,0,0,50,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,97,103,110,101,116,105,99,95,70,108,117,120,84,117,98,101,115,95,69,120,97,109,112,108,101,115,95,77,111,118,105,110,103,67,111,105,108,65,99,116,117,97,116,111,114,95,70,111,114,99,101,83,116,114,111,107,101,66,101,104,97,118,105,111,117,114,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,44,49,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,44,48,93,32,61,32,122,101,114,111,115,40,49,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,93,32,61], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,122,101,114,111,115,40,48,44,49,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,36,100,117,109,109,121,32,61,32,120,91,49,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,97,103,110,101,116,105,99,95,70,108,117,120,84,117,98,101,115,95,69,120,97,109,112,108,101,115,95,77,111,118,105,110,103,67,111,105,108,65,99,116,117,97,116,111,114,95,70,111,114,99,101,83,116,114,111,107,101,66,101,104,97,118,105,111,117,114,59,10,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,115,111,117,114,99,101,32,101,114,114,111,114,10,0,0,0,0,0,85,110,107,110,111,119,110,32,115,109,111,111,116,104,110,101,115,115,32,107,105,110,100,10,0,0,0,0,0,0,0,0,70,117,110,99,116,105,111,110,32,34,117,115,101,114,116,97,98,34,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,10,0,0,84,104,101,32,102,105,108,101,32,110,97,109,101,32,102,111,114,32,97,32,116,97,98,108,101,32,40,61,32,34,37,115,34,41,32,105,115,32,100,101,102,105,110,101,100,44,32,98,117,116,32,110,111,116,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,110,97,109,101,46,10,0,0,0,78,111,78,97,109,101,0,0,84,104,101,32,118,97,108,117,101,115,32,111,102,32,116,104,101,32,102,105,114,115,116,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,97,114,101,32,110,111,116,32,115,116,114,105,99,116,108,121,32,105,110,99,114,101,97,115,105,110,103,32,98,101,99,97,117,115,101,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,32,62,61,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,46,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,112,112,114,111,112,114,105,97,116,101,32,100,105,109,101,110,115,105,111,110,115,32,102,111,114,32,49,68,45,105,110,116,101,114,112,111,108,97,116,105,111,110,46,10,0,0,0,0,0,0,152,43,0,0,168,43,0,0,184,43,0,0,208,43,0,0,240,43,0,0,0,44,0,0,24,44,0,0,40,44,0,0,64,44,0,0,96,44,0,0,136,44,0,0,160,44,0,0,192,44,0,0,216,44,0,0,0,45,0,0,32,45,0,0,80,45,0,0,128,45,0,0,152,45,0,0,208,45,0,0,232,45,0,0,24,46,0,0,56,46,0,0,112,46,0,0,152,46,0,0,208,46,0,0,0,47,0,0,16,47,0,0,48,47,0,0,88,47,0,0,120,47,0,0,160,47,0,0,200,47,0,0,224,47,0,0,248,47,0,0,8,48,0,0,32,48,0,0,80,48,0,0,160,48,0,0,224,48,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,16,63,0,0,160,61,0,0,40,60,0,0,176,58,0,0,176,58,0,0,56,57,0,0,40,60,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,216,73,0,0,96,70,0,0,240,68,0,0,128,67,0,0,128,67,0,0,16,66,0,0,240,68,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,32,72,0,0,48,72,0,0,64,72,0,0,16,57,0,0,72,72,0,0,88,72,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,184,75,0,0,192,75,0,0,200,75,0,0,208,75,0,0,72,75,0,0,216,75,0,0,232,75,0,0,240,75,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,101,108,116,115,91,105,93,45,62,110,100,105,109,115,32,61,61,32,110,100,105,109,115,32,38,38,32,34,78,111,116,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,34,0,0,0,0,0,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,104,101,99,107,95,98,97,115,101,95,97,114,114,97,121,95,100,105,109,95,115,105,122,101,115,0,0,0,0,0,0,100,105,109,115,105,122,101,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,99,117,114,100,105,109,93,32,38,38,32,34,68,105,109,101,110,115,105,111,110,115,32,115,105,122,101,32,110,111,116,32,115,97,109,101,34,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,48,78,0,0,64,78,0,0,72,78,0,0,80,78,0,0,96,78,0,0,112,78,0,0,120,78,0,0,136,78,0,0,152,78,0,0,168,78,0,0,184,78,0,0,200,78,0,0,216,78,0,0,232,78,0,0,248,78,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([8,79,0,0,24,79,0,0,32,79,0,0,48,79,0,0,64,79,0,0,80,79,0,0,96,79,0,0,112,79,0,0,128,79,0,0,144,79,0,0,160,79,0,0,176,79,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,56,80,0,0,64,80,0,0,64,80,0,0,96,80,0,0,144,80,0,0,176,80,0,0,232,80,0,0,24,81,0,0,72,81,0,0,104,81,0,0,152,81,0,0,176,81,0,0,208,81,0,0,248,81,0,0,24,82,0,0,72,82,0,0,104,82,0,0,144,82,0,0,176,82,0,0,216,82,0,0,8,83,0,0,64,83,0,0,104,83,0,0,152,83,0,0,200,83,0,0,240,83,0,0,32,84,0,0,40,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,56,80,0,0,40,87,0,0,48,87,0,0,56,87,0,0,72,78,0,0,64,87,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,152,88,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,176,88,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,200,88,0,0,208,88,0,0,216,88,0,0,232,88,0,0,248,88,0,0,0,89,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,97,114,114,97,121,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,48,32,38,38,32,34,68,105,109,101,110,115,105,111,110,32,115,105,122,101,32,62,32,52,32,110,111,116,32,105,109,112,108,46,32,121,101,116,34,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,56,100,0,0,0,0,0,0,176,99,0,0,0,0,0,0,40,99,0,0,0,0,0,0,160,98,0,0,0,0,0,0,152,97,0,0,0,0,0,0,144,96,0,0,0,0,0,0,136,95,0,0,0,0,0,0,128,94,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,192,100,0,0,208,100,0,0,216,100,0,0,224,100,0,0,240,100,0,0,248,100,0,0,0,101,0,0,8,101,0,0,16,101,0,0,24,101,0,0,32,101,0,0,48,101,0,0,56,101,0,0,72,101,0,0,88,101,0,0,104,101,0,0,112,101,0,0,128,101,0,0,136,101,0,0,152,101,0,0,160,101,0,0,184,101,0,0,192,101,0,0,200,101,0,0,216,101,0,0,224,101,0,0,240,101,0,0,0,102,0,0,8,102,0,0,16,102,0,0,24,102,0,0,32,102,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,176,102,0,0,184,102,0,0,0,103,0,0,48,103,0,0,96,103,0,0,168,103,0,0,232,103,0,0,48,104,0,0,96,104,0,0,168,104,0,0,192,104,0,0,224,104,0,0,24,105,0,0,64,105,0,0,104,105,0,0,160,105,0,0,240,105,0,0,80,106,0,0,128,106,0,0,184,106,0,0,232,106,0,0,48,107,0,0,88,107,0,0,136,107,0,0,184,107,0,0,16,108,0,0,88,108,0,0,200,108,0,0,248,108,0,0,64,109,0,0,96,109,0,0,32,102,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,176,102,0,0,32,110,0,0,200,110,0,0,48,103,0,0,96,103,0,0,48,111,0,0,232,103,0,0,48,104,0,0,184,111,0,0,248,111,0,0,192,104,0,0,224,104,0,0,152,112,0,0,216,112,0,0,24,113,0,0,160,105,0,0,240,105,0,0,88,113,0,0,144,113,0,0,24,114,0,0,64,114,0,0,48,107,0,0,88,107,0,0,136,107,0,0,168,114,0,0,48,115,0,0,48,116,0,0,200,108,0,0,248,108,0,0,64,109,0,0,96,109,0,0,32,102,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,122,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,122,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+25784);
/* memory initializer */ allocate([47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,139,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+36024);
/* memory initializer */ allocate([16,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,145,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,144,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,146,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,147,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,149,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,149,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,184,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,185,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,186,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,187,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,187,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,136,199,0,0,168,200,0,0,176,200,0,0,192,200,0,0,208,200,0,0,224,200,0,0,248,200,0,0,16,201,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,136,199,0,0,144,199,0,0,216,199,0,0,0,200,0,0,32,200,0,0,64,200,0,0,104,200,0,0,144,200,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,240,207,0,0,0,208,0,0,8,208,0,0,16,208,0,0,24,208,0,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,56,208,0,0,64,208,0,0,80,208,0,0,96,208,0,0,24,208,0,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+46404);
/* memory initializer */ allocate([0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,168,225,0,0,112,227,0,0,120,227,0,0,128,227,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,168,225,0,0,176,226,0,0,0,227,0,0,48,227,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,168,225,0,0,112,226,0,0,120,226,0,0,128,226,0,0,144,226,0,0,152,226,0,0,168,226,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,168,225,0,0,176,225,0,0,200,225,0,0,216,225,0,0,32,226,0,0,48,226,0,0,80,226,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,88,237,0,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,88,237,0,0,10,0,0,0,11,0,0,0,252,236,0,0,116,237,0,0,136,237,0,0,16,237,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,104,167,1,0,40,237,0,0,240,98,1,0,0,0,0,0,104,0,0,0,0,0,0,0,240,98,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,240,98,1,0,14,0,0,0,15,0,0,0,0,0,0,0,0,238,0,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,104,167,1,0,208,237,0,0,232,97,1,0,0,0,0,0,0,0,0,0,136,238,0,0,144,238,0,0,128,238,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,96,238,0,0,112,238,0,0,128,238,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,224,254,0,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,224,254,0,0,20,0,0,0,21,0,0,0,132,254,0,0,252,254,0,0,16,255,0,0,152,254,0,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,104,167,1,0,176,254,0,0,96,98,1,0,0,0,0,0,108,0,0,0,0,0,0,0,96,98,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,96,98,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,24,9,1,0,0,11,1,0,8,11,1,0,80,13,1,0,104,11,1,0,120,11,1,0,88,13,1,0,96,13,1,0,104,13,1,0,112,13,1,0,128,13,1,0,144,13,1,0,160,13,1,0,176,13,1,0,192,13,1,0,208,13,1,0,224,13,1,0,248,13,1,0,48,13,1,0,72,13,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,24,9,1,0,0,11,1,0,8,11,1,0,24,11,1,0,104,11,1,0,120,11,1,0,136,11,1,0,168,11,1,0,200,11,1,0,232,11,1,0,16,12,1,0,56,12,1,0,96,12,1,0,136,12,1,0,160,12,1,0,192,12,1,0,224,12,1,0,8,13,1,0,48,13,1,0,72,13,1,0,114,101,99,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+56644);
/* memory initializer */ allocate([103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,24,9,1,0,224,10,1,0,232,10,1,0,240,10,1,0,24,9,1,0,32,10,1,0,112,10,1,0,160,10,1,0,24,9,1,0,224,9,1,0,232,9,1,0,240,9,1,0,0,10,1,0,8,10,1,0,24,10,1,0,0,0,0,0,24,9,1,0,32,9,1,0,56,9,1,0,72,9,1,0,144,9,1,0,160,9,1,0,192,9,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,56,16,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,56,16,1,0,29,0,0,0,30,0,0,0,196,15,1,0,84,16,1,0,104,16,1,0,216,15,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,104,167,1,0,240,15,1,0,240,98,1,0,0,0,0,0,56,0,0,0,0,0,0,0,240,98,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,240,98,1,0,14,0,0,0,15,0,0,0,0,0,0,0,248,16,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,104,167,1,0,176,16,1,0,232,97,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,136,37,1,0,136,37,1,0,136,37,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,48,40,1,0,64,40,1,0,88,40,1,0,120,40,1,0,152,40,1,0,176,40,1,0,208,40,1,0,232,40,1,0,248,40,1,0,8,41,1,0,32,41,1,0,56,41,1,0,88,41,1,0,120,41,1,0,8,41,1,0,144,41,1,0,176,41,1,0,200,41,1,0,224,41,1,0,248,41,1,0,24,42,1,0,40,42,1,0,72,42,1,0,104,42,1,0,128,42,1,0,152,42,1,0,176,42,1,0,192,42,1,0,216,42,1,0,240,42,1,0,8,43,1,0,40,43,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+66884);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81624);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,48,84,1,0,56,84,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,72,84,1,0,80,84,1,0,88,84,1,0,96,84,1,0,144,1,0,0,0,0,0,0,208,84,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+86848);
/* memory initializer */ allocate([168,91,1,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,104,167,1,0,136,91,1,0,40,98,1,0,0,0,0,0,0,0,0,0,16,92,1,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,104,167,1,0,248,91,1,0,40,98,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,168,92,1,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,104,167,1,0,136,92,1,0,232,97,1,0,0,0,0,0,0,0,0,0,16,93,1,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,104,167,1,0,248,92,1,0,232,97,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,64,167,1,0,32,93,1,0,0,0,0,0,136,93,1,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,48,94,1,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,104,167,1,0,120,93,1,0,0,0,0,0,0,0,0,0,0,0,0,0,200,93,1,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,104,167,1,0,176,93,1,0,136,93,1,0,0,0,0,0,0,0,0,0,8,94,1,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,104,167,1,0,240,93,1,0,136,93,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,104,167,1,0,24,94,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,120,94,1,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,104,167,1,0,96,94,1,0,48,94,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,64,167,1,0,136,94,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,104,167,1,0,176,94,1,0,168,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,96,97,1,0,49,0,0,0,50,0,0,0,0,0,0,0,232,97,1,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,40,98,1,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,96,98,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,96,98,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,168,98,1,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,168,98,1,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,240,98,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,240,98,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,56,99,1,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,56,99,1,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,1,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,40,97,1,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,104,167,1,0,224,96,1,0,120,94,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,64,167,1,0,16,97,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,104,167,1,0,48,97,1,0,40,97,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,104,167,1,0,112,97,1,0,40,97,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,64,167,1,0,176,97,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,64,167,1,0,240,97,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,200,167,1,0,48,98,1,0,0,0,0,0,1,0,0,0,96,97,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,200,167,1,0,120,98,1,0,0,0,0,0,1,0,0,0,160,97,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,200,167,1,0,192,98,1,0,0,0,0,0,1,0,0,0,96,97,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,200,167,1,0,8,99,1,0,0,0,0,0,1,0,0,0,160,97,1,0,3,244,255,255,0,0,0,0,152,99,1,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,104,167,1,0,120,99,1,0,200,94,1,0,0,0,0,0,0,0,0,0,192,113,1,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,113,1,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,118,1,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,48,119,1,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,119,1,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,120,1,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,176,115,1,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,176,115,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,80,116,1,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,80,116,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,224,116,1,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,117,1,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,114,1,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,114,1,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,114,1,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,114,1,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,121,1,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,168,121,1,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,56,122,1,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,200,122,1,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,117,1,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,117,1,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,152,113,1,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,110,1,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,111,1,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,113,1,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,112,113,1,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,168,109,1,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,104,167,1,0,144,109,1,0,64,93,1,0,0,0,0,0,0,0,0,0,56,110,1,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,64,167,1,0,24,110,1,0,200,167,1,0,0,110,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,110,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,200,167,1,0,88,110,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,110,1,0,2,0,0,0,0,0,0,0,8,111,1,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,64,167,1,0,232,110,1,0,200,167,1,0,192,110,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,0,111,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,200,167,1,0,40,111,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,0,111,1,0,2,0,0,0,0,0,0,0,200,111,1,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,200,167,1,0,160,111,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,0,111,1,0,2,0,0,0,0,0,0,0,64,112,1,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,200,167,1,0,24,112,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,0,111,1,0,2,0,0,0,0,0,0,0,184,112,1,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,104,167,1,0,144,112,1,0,64,112,1,0,0,0,0,0,0,0,0,0,32,113,1,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,104,167,1,0,248,112,1,0,64,112,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,104,167,1,0,48,113,1,0,168,109,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,104,167,1,0,88,113,1,0,168,109,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,104,167,1,0,128,113,1,0,168,109,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,104,167,1,0,168,113,1,0,168,109,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,104,167,1,0,208,113,1,0,168,109,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,64,167,1,0,24,114,1,0,200,167,1,0,248,113,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,114,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,200,167,1,0,88,114,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,114,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,200,167,1,0,152,114,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,114,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,200,167,1,0,216,114,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,114,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,64,167,1,0,96,115,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,64,167,1,0,128,115,1,0,200,167,1,0,24,115,1,0,0,0,0,0,3,0,0,0,168,109,1,0,2,0,0,0,120,115,1,0,2,0,0,0,168,115,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,64,167,1,0,32,116,1,0,200,167,1,0,216,115,1,0,0,0,0,0,3,0,0,0,168,109,1,0,2,0,0,0,120,115,1,0,2,0,0,0,72,116,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,64,167,1,0,192,116,1,0,200,167,1,0,120,116,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,216,116,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,200,167,1,0,0,117,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,216,116,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,64,167,1,0,128,117,1,0,200,167,1,0,104,117,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,152,117,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,200,167,1,0,192,117,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,152,117,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,64,167,1,0,88,118,1,0,200,167,1,0,64,118,1,0,0,0,0,0,1,0,0,0,120,118,1,0,0,0,0,0,200,167,1,0,248,117,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,128,118,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,200,167,1,0,0,119,1,0,0,0,0,0,1,0,0,0,120,118,1,0,0,0,0,0,200,167,1,0,184,118,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,24,119,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,64,167,1,0,176,119,1,0,200,167,1,0,152,119,1,0,0,0,0,0,1,0,0,0,208,119,1,0,0,0,0,0,200,167,1,0,80,119,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,216,119,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,200,167,1,0,88,120,1,0,0,0,0,0,1,0,0,0,208,119,1,0,0,0,0,0,200,167,1,0,16,120,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,112,120,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,64,167,1,0,240,120,1,0,200,167,1,0,168,120,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,16,121,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,64,167,1,0,128,121,1,0,200,167,1,0,56,121,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,160,121,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,64,167,1,0,16,122,1,0,200,167,1,0,200,121,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,48,122,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,64,167,1,0,160,122,1,0,200,167,1,0,88,122,1,0,0,0,0,0,2,0,0,0,168,109,1,0,2,0,0,0,192,122,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+88900);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,176,164,1,0,110,0,0,0,184,164,1,0,114,0,0,0,192,164,1,0,102,0,0,0,200,164,1,0,97,0,0,0,208,164,1,0,101,0,0,0,216,164,1,0,119,0,0,0,224,164,1,0,87,0,0,0,240,164,1,0,115,0,0,0,0,165,1,0,83,0,0,0,16,165,1,0,100,0,0,0,32,165,1,0,68,0,0,0,48,165,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,184,166,1,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,64,167,1,0,144,166,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,104,167,1,0,168,166,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,104,167,1,0,200,166,1,0,160,166,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,104,167,1,0,0,167,1,0,240,166,1,0,0,0,0,0,0,0,0,0,40,167,1,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,176,167,1,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,104,167,1,0,136,167,1,0,40,167,1,0,0,0,0,0,0,0,0,0,16,168,1,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,104,167,1,0,232,167,1,0,40,167,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,170,1,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,104,167,1,0,64,170,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+99240);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  var _fseeko=_fseek;



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiiiiiiiiiiiiiiiiiiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_viiiiii;var Ba=env.invoke_iid;var Ca=env.invoke_viiiiiii;var Da=env.invoke_viiiiiid;var Ea=env.invoke_viiiiiiiii;var Fa=env.invoke_iii;var Ga=env.invoke_iiiiii;var Ha=env.invoke_iiiiidi;var Ia=env.invoke_iiiiiiiii;var Ja=env.invoke_i;var Ka=env.invoke_iiiiiiiiii;var La=env.invoke_viii;var Ma=env.invoke_v;var Na=env.invoke_viidii;var Oa=env.invoke_iiiii;var Pa=env.invoke_viiii;var Qa=env._fabs;var Ra=env._strrchr;var Sa=env._pthread_key_create;var Ta=env._vsscanf;var Ua=env.__ZSt9terminatev;var Va=env.___cxa_guard_acquire;var Wa=env.__reallyNegative;var Xa=env._fstat;var Ya=env._pclose;var Za=env._lis_solver_create;var _a=env.___assert_fail;var $a=env.__ZSt18uncaught_exceptionv;var ab=env._longjmp;var bb=env.__isLeapYear;var cb=env._clock_gettime;var db=env._fsync;var eb=env._signal;var fb=env._GC_collect_a_little;var gb=env._sbrk;var hb=env._strtoull;var ib=env._emscripten_memcpy_big;var jb=env.__parseInt64;var kb=env._close;var lb=env._rewind;var mb=env._cos;var nb=env._fileno;var ob=env._fread;var pb=env._puts;var qb=env._isatty;var rb=env._lis_matrix_set_value;var sb=env._write;var tb=env._isblank;var ub=env._ftell;var vb=env.__ZNSt9exceptionD2Ev;var wb=env._round;var xb=env.___cxa_does_inherit;var yb=env._strtoll_l;var zb=env._strstr;var Ab=env.___cxa_rethrow;var Bb=env._llvm_lifetime_end;var Cb=env._catclose;var Db=env._tmpnam;var Eb=env._lis_vector_destroy;var Fb=env._lis_solver_set_option;var Gb=env._tmpfile;var Hb=env._send;var Ib=env._pow;var Jb=env.___cxa_is_number_type;var Kb=env.___cxa_free_exception;var Lb=env.___cxa_find_matching_catch;var Mb=env._isxdigit_l;var Nb=env.___cxa_guard_release;var Ob=env._truncate;var Pb=env._strtol;var Qb=env._sin;var Rb=env._strtok;var Sb=env.___setErrNo;var Tb=env._newlocale;var Ub=env._isdigit_l;var Vb=env.___resumeException;var Wb=env._freelocale;var Xb=env._srand;var Yb=env._fscanf;var Zb=env._qsort;var _b=env._putchar;var $b=env._pthread_mutex_unlock;var ac=env._printf;var bc=env._sprintf;var cc=env._fopen;var dc=env._strtok_r;var ec=env._emscripten_get_now;var fc=env._stat;var gc=env._vsnprintf;var hc=env._strtoull_l;var ic=env._read;var jc=env.__addDays;var kc=env._fwrite;var lc=env._time;var mc=env._pthread_mutex_lock;var nc=env._catopen;var oc=env._exit;var pc=env._GC_strdup;var qc=env._freopen;var rc=env.___ctype_b_loc;var sc=env._fmod;var tc=env._vasprintf;var uc=env._lseek;var vc=env._access;var wc=env._vfprintf;var xc=env.___cxa_allocate_exception;var yc=env._atoi;var zc=env._strtoll;var Ac=env._pwrite;var Bc=env._localtime_r;var Cc=env._tzset;var Dc=env._open;var Ec=env._uselocale;var Fc=env._snprintf;var Gc=env.___errno_location;var Hc=env._GC_malloc;var Ic=env.___cxa_end_catch;var Jc=env._perror;var Kc=env.___cxa_begin_catch;var Lc=env._strftime;var Mc=env._ftruncate;var Nc=env._GC_init;var Oc=env._fseek;var Pc=env._isxdigit;var Qc=env._fclose;var Rc=env.__parseInt;var Sc=env._log;var Tc=env._pthread_cond_broadcast;var Uc=env._popen;var Vc=env._recv;var Wc=env._fgetc;var Xc=env._sysconf;var Yc=env.__getFloat;var Zc=env._abort;var _c=env._ceil;var $c=env._isspace;var ad=env._localtime;var bd=env._pthread_getspecific;var cd=env._pthread_cond_wait;var dd=env._llvm_lifetime_start;var ed=env._ungetc;var fd=env._system;var gd=env._fmax;var hd=env._fflush;var id=env._strftime_l;var jd=env._fprintf;var kd=env._sscanf;var ld=env._catgets;var md=env._strdup;var nd=env._asprintf;var od=env.__exit;var pd=env.___ctype_toupper_loc;var qd=env._bsearch;var rd=env.__arraySum;var sd=env.__formatString;var td=env._htonl;var ud=env.___ctype_tolower_loc;var vd=env._unlink;var wd=env._fputs;var xd=env._GC_malloc_atomic;var yd=env._pread;var zd=env._lis_vector_set_size;var Ad=env._mkport;var Bd=env.__scanString;var Cd=env._pthread_setspecific;var Dd=env._copysign;var Ed=env._fputc;var Fd=env.___cxa_throw;var Gd=env._lis_solver_destroy;var Hd=env._isdigit;var Id=env._strerror;var Jd=env._emscripten_longjmp;var Kd=env._lis_vector_create;var Ld=env._atexit;var Md=env._sqrt;var Nd=env._strerror_r;var Od=0.0;
// EMSCRIPTEN_START_FUNCS
function SG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{ZG(n,o,v-u|0);KG(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,72128);q=v+9|0;Sq(q);LG(a,2);kc(72136,15,1,a|0)|0;LG(a,4);c[m>>2]=c[e>>2];jd(a|0,72152,m|0)|0;LG(a,4);c[l>>2]=Kq(q)|0;jd(a|0,72176,l|0)|0;LG(a,4);w=+Pq(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];jd(a|0,72200,j|0)|0;LG(a,4);w=+Oq(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];jd(a|0,71368,g|0)|0;LG(a,2);kc(72224,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function TG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;LG(a,b);kc(72440,16,1,a|0)|0;MG(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?72544:72560;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;jd(a|0,72464,f|0)|0;i=e;return}function UG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){VG(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function VG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=cc(c[o>>2]|0,73776)|0;if((p|0)!=0){q=p;break}p=Id(c[(Gc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Cp(0,73784,g)}else{q=0}}while(0);g=rk(0)|0;if((g|0)==0){Cp(0,73816,f)}f=a+8|0;c[a+20>>2]=GT(c[f>>2]|0,32)|0;p=a+12|0;o=GT((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=73848;c[o+12>>2]=0;c[o+16>>2]=0;Ck(g,h);Dk(g,9,60);h=c[n>>2]|0;do{if((h|0)==0){o=j;kU(o|0,0,1024)|0;while(1){r=ob(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Ek(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Mk(Jk(g)|0)|0;s=Kk(g)|0;Qc(q|0)|0;yk(g);r=c[a>>2]|0;c[e>>2]=73952;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Cp(0,73888,e)}else if((t|0)==11){Qc(q|0)|0;break}}else{if((Ek(g,h,gU(h|0)|0,1)|0)!=0){break}s=Mk(Jk(g)|0)|0;o=Kk(g)|0;yk(g);r=c[n>>2]|0;c[d>>2]=73952;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Cp(0,73992,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){_a(74056,73952,295,74096)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{_a(74120,73952,297,74096)}}function WG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((cU(74528,b)|0)==0){if((cU(c[d>>2]|0,74536)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Bp(0,p,74544,l);l=c[18596]|0;p=c[18650]|0;do{if((l|0)==0|(p|0)==0){c[18650]=32;a=ET(1152)|0;c[18596]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[18650]=p<<1;a=HT(l,p*72|0)|0;c[18596]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(aH(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((cU(74608,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((cU(74616,u)|0)==0){c[18656]=md(c[t+4>>2]|0)|0}else{if((cU(74648,u)|0)==0){c[74628>>2]=Pb(c[t+4>>2]|0,0,10)|0;break}if((cU(74664,u)|0)==0){c[74636>>2]=Pb(c[t+4>>2]|0,0,10)|0;break}if((cU(74672,u)|0)==0){c[74632>>2]=Pb(c[t+4>>2]|0,0,10)|0;break}if((cU(74688,u)|0)==0){c[74640>>2]=Pb(c[t+4>>2]|0,0,10)|0;break}if((cU(74696,u)|0)!=0){v=23;break a}c[74644>>2]=(cU(c[t+4>>2]|0,74712)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Cp(0,74720,k)}else if((v|0)==45){i=e;return}}if((cU(74368,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=73952;c[j+4>>2]=k;c[j+8>>2]=v;Cp(0,74752,j)}if((cU(74816,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=73952;c[h+4>>2]=j;Cp(0,74824,h)}h=Pb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=73952;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Cp(0,74880,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=74944;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((cU(74312,b)|0)!=0){if((cU(74504,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=75048;m=md(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=75056;i=e;return}c[74332>>2]=0;c[74336>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((cU(m,74536)|0)==0){c[74332>>2]=md(c[b+4>>2]|0)|0}else{if((cU(m,75e3)|0)!=0){break}c[74336>>2]=md(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[74332>>2]|0)==0){w=0;break}w=(c[74336>>2]|0)!=0|0}}while(0);Bp(0,w,75008,f);c[18582]=-1;f=74340|0;w=74624;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function XG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((cU(74312,b)|0)==0){o=e+0|0;p=74328|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));$G(e);i=d;return}if((cU(74368,b)|0)==0){e=h+24|0;r=ET((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=ET(36)|0;t=s;o=s+0|0;p=(c[18596]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((cU(74392,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;nd(e+(k*20|0)+8|0,74400,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((cU(74440,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;nd(h+(k*20|0)+8|0,74456,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((cU(74504,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function YG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){VG(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function ZG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){VG(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Cp(0,74160,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=74240;p=o;Cp(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=74240;p=o;Cp(0,p,f)}}function _G(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){FT(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){FT(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}FT(k);c[d>>2]=0;i=b;return}function $G(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=ET(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=gU(f|0)|0;c[e+64>>2]=k;k=c[18630]|0;do{if((k|0)==0){c[18630]=e;c[e+44>>2]=0;l=ET(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){oc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=ET(384)|0;c[l>>2]=n;if((n|0)==0){oc(-1)}else{kU(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[18630]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[18630]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=gU(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(gU(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 1:{B=o;C=x;D=y;E=22;break};case 5:{F=o;G=y;E=18;break};case 4:{H=o;I=y;E=19;break};case 10:{J=o;E=13;break};case 6:{K=o;L=y;E=17;break};case 8:{M=o;E=15;break};case 3:{N=o;O=x;P=y;E=20;break};case 2:{Q=o;R=x;S=y;E=21;break};case 7:{T=o;U=y;E=16;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;J=z;E=13;break};case 9:{V=o;E=14;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+J|0;c[p>>2]=o;V=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+V|0;c[p>>2]=o;M=o;E=15}if((E|0)==15){T=M;U=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){K=T;L=((d[A+6|0]|0)<<16)+U|0;E=17}if((E|0)==17){F=K;G=((d[A+5|0]|0)<<8)+L|0;E=18}if((E|0)==18){H=F;I=(d[A+4|0]|0)+G|0;E=19}if((E|0)==19){N=H;O=((d[A+3|0]|0)<<24)+x|0;P=I;E=20}if((E|0)==20){Q=N;R=((d[A+2|0]|0)<<16)+O|0;S=P;E=21}if((E|0)==21){B=Q;C=((d[A+1|0]|0)<<8)+R|0;D=S;E=22}if((E|0)==22){W=B;X=(d[A]|0)+C|0;Y=D}D=X-Y-W^W>>>13;X=Y-W-D^D<<8;Y=W-D-X^X>>>13;W=D-X-Y^Y>>>12;D=X-Y-W^W<<16;X=Y-W-D^D>>>5;Y=W-D-X^X>>>3;W=D-X-Y^Y<<10;D=X-Y-W^W>>>15;c[p>>2]=D;p=(c[18630]|0)+40|0;W=c[p>>2]|0;Y=D&(c[W+4>>2]|0)+ -1;D=c[W>>2]|0;W=D+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[D+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[18630]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[18630]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=ET((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){oc(-1)}kU(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;D=c[j>>2]|0;c[Y+24>>2]=(((D<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((D|0)==0){_=e}else{D=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=D}else{W=D;X=j;while(1){j=X+16|0;C=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];B=Z+(A*12|0)+4|0;E=(c[B>>2]|0)+1|0;c[B>>2]=E;S=c[W+24>>2]|0;if(E>>>0>S>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[B>>2]|0)>>>0)/(S>>>0)|0}c[X+12>>2]=0;S=Z+(A*12|0)|0;c[j>>2]=c[S>>2];j=c[S>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[S>>2]=X;S=c[h>>2]|0;if((C|0)==0){$=S;break}else{W=S;X=C}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){D=$;Y=W;e=X}else{_=W;break}}}FT(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function aH(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[18630]|0)==0){f=24}else{g=gU(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(gU(a|0)|0)+s|0;switch(v|0){case 4:{x=h;y=u;f=12;break};case 7:{z=h;A=u;f=9;break};case 2:{B=h;C=t;D=u;f=14;break};case 1:{E=h;F=t;G=u;f=15;break};case 3:{H=h;I=t;J=u;f=13;break};case 10:{K=h;f=6;break};case 11:{K=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 5:{L=h;M=u;f=11;break};case 9:{N=h;f=7;break};case 6:{O=h;P=u;f=10;break};case 8:{Q=h;f=8;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+K|0;f=7}if((f|0)==7){Q=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){z=Q;A=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){O=z;P=((d[w+6|0]|0)<<16)+A|0;f=10}if((f|0)==10){L=O;M=((d[w+5|0]|0)<<8)+P|0;f=11}if((f|0)==11){x=L;y=(d[w+4|0]|0)+M|0;f=12}if((f|0)==12){H=x;I=((d[w+3|0]|0)<<24)+t|0;J=y;f=13}if((f|0)==13){B=H;C=((d[w+2|0]|0)<<16)+I|0;D=J;f=14}if((f|0)==14){E=B;F=((d[w+1|0]|0)<<8)+C|0;G=D;f=15}if((f|0)==15){R=E;S=(d[w]|0)+F|0;T=G}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[18630]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=gU(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((bU(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((zb(a|0,75080)|0)==0){V=0;break}else{W=75104}i=b;return W|0}}while(0);c[e>>2]=a;Bp(0,(V|0)!=0|0,75152,e);W=V+4|0;i=b;return W|0}function bH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((cH(75208,a,b)|0)!=0){d=1;i=c;return d|0}d=(cH(75216,a,b)|0)!=0|0;i=c;return d|0}function cH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((cU(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function dH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(cU(c[26284>>2]|0,75224)|0)==0|0;Bp(0,m,75240,l);l=(cU(c[28188>>2]|0,75224)|0)==0|0;Bp(0,l,75296,k);k=(cU(c[30180>>2]|0,75224)|0)==0|0;Bp(0,k,75352,j);j=75416|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=75544|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[30184+(k<<2)>>2]|0;if((l|0)==1){if((cH(c[26160+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[26160+(k<<2)>>2]|0;if(!((cH(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[26160+(k<<2)>>2]|0;if((fH(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=75416+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=75416+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[75544+(k<<2)>>2]=eH(r,p)|0;t=j}else if((q|0)==13){q=0;l=75416+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[75544+(k<<2)>>2]=gH(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];Ap(1,0,75672,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];Ap(1,0,75672,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];Ap(1,0,75672,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];Ap(1,0,75728,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function eH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((cU(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function fH(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(gH(a,b)|0)!=0|0;i=c;return d|0}function gH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=gU(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((dU(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function hH(){i=i;return}function iH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){oc(0)}e=c[r>>2]|0;kc(75760,5,1,e|0)|0;f=b;b=0;while(1){Ed(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}kc(75768,20,1,e|0)|0;oc(0);return 0}function jH(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;jd(d|0,75792,e|0)|0;if((b|0)==0){oc(1)}else{hd(d|0)|0;pH();hd(d|0)|0;eb(6,0)|0;Zc()}}function kH(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function lH(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function mH(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function nH(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}kU(p|0,32,b+(d-p)|0)|0;i=f;return}function oH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=76832+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[76876+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[76872+(e*48|0)>>2]|0)==1){qH(b)|0}k=76836+(e*48|0)|0;if((c[k>>2]|0)==0){break}Qc(c[f>>2]|0)|0;FT(c[k>>2]|0)}}while(0);do{if((h|0)==10){Qc(g|0)|0;b=76836+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}vd(k|0)|0;FT(c[b>>2]|0)}}while(0);c[f>>2]=0}c[76868+(e*48|0)>>2]=0;c[76836+(e*48|0)>>2]=0;i=d;return 0}function pH(){var a=0,b=0;a=i;if((c[18950]|0)!=0){i=a;return}c[18950]=1;c[75808>>2]=0;b=0;do{c[75804>>2]=b;oH(75800)|0;b=b+1|0;}while((b|0)<100);i=a;return}function qH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[76848+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=76832+(d*48|0)|0;g=c[f>>2]|0;h=ub(g|0)|0;Oc(g|0,0,2)|0;if((h|0)>=(ub(g|0)|0)){e=0;i=b;return e|0}if((c[76852+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[76860+(d*48|0)>>2]&2|0)!=0){hd(c[f>>2]|0)|0}d=Mc(nb(c[f>>2]|0)|0,h|0)|0;Oc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){sH(111,75816);e=111;i=b;return e|0}else{c[(Gc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function rH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((Xa(nb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(qb(nb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function sH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Jc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;jd(m|0,76728,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;jd(m|0,76760,j|0)|0;l=m;break}else{n=c[76600+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;jd(m|0,76784,h|0)|0;l=m;break}}}while(0);h=c[19198]|0;do{if((h|0)==0){kc(81664,29,1,l|0)|0}else{c[g>>2]=(h-76832|0)/48|0;jd(l|0,76800,g|0)|0;b=c[(c[19198]|0)+4>>2]|0;if((b|0)==0){kc(81648,10,1,l|0)|0;break}else{c[f>>2]=b;jd(l|0,81632,f|0)|0;break}}}while(0);f=c[20424]|0;if((f|0)!=0){c[d>>2]=f;jd(l|0,81704,d|0)|0}d=(c[20444]|0)!=0?81784:81800;f=(c[20452]|0)!=0?81816:81832;g=(c[20462]|0)!=0?81856:81872;c[e>>2]=(c[20438]|0)!=0?81760:81768;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;jd(l|0,81728,e|0)|0;jH(81888,1)}function tH(){var a=0,b=0;a=i;c[20474]=1;b=c[r>>2]|0;c[19208]=b;c[76852>>2]=rH(b)|0;c[76856>>2]=1;c[76872>>2]=1;b=c[s>>2]|0;c[77072>>2]=b;c[77092>>2]=rH(b)|0;c[77096>>2]=1;c[77112>>2]=0;b=c[t>>2]|0;c[77120>>2]=b;c[77140>>2]=rH(b)|0;c[77144>>2]=1;c[77160>>2]=1;i=a;return}function uH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=qc(g|0,c[87144+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[20476]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=ub(c[k>>2]|0)|0;l=qc(c[f>>2]|0,c[87144+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[20476]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Oc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Gc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Oc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function vH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){sH(b,d)}d=c[20478]|0;if((d|0)!=0){le[d&7]()|0}c[(Gc()|0)>>2]=b;i=e;return b|0}function wH(a){a=a|0;var b=0,d=0;b=i;c[20508]=0;c[20510]=0;c[20512]=0;d=((xH(a,0)|0)==0)<<31>>31;i=b;return d|0}function xH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[20512]|0;c[20512]=j+1;if((j|0)==1){c[20510]=d}if((CH(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=DH(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function yH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[20508]|0;l=82056+(k<<4)|0;m=c[l>>2]|0;switch(zH(m)|0){case 3:{n=c[21724]|0;o=86904+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[21724]=n+ -1;c[21740]=(c[21740]|0)+ -1;c[20508]=k+1;continue b}else{n=c[21740]|0;c[21740]=n+ -1;c[20508]=(c[86968+(n<<2)>>2]|0)+1;continue b}break};case 22:{c[20486]=1;c[20508]=k+1;continue b;break};case 8:{n=c[21724]|0;q=86904+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){t=10;break b}c[21724]=n+ -1;c[20508]=k+1;continue b;break};case 6:{n=c[82060+(k<<4)>>2]|0;p=(c[21724]|0)+1|0;c[21724]=p;c[86904+(p<<2)>>2]=n;c[20508]=k+1;continue b;break};case 19:case 17:{c[20484]=0;c[20508]=k+1;continue b;break};case 18:{c[20484]=1;c[20508]=k+1;continue b;break};case 21:{c[20486]=0;c[20508]=k+1;continue b;break};case 1:{n=c[82060+(k<<4)>>2]|0;p=(c[21740]|0)+1|0;c[21740]=p;c[86968+(p<<2)>>2]=n;c[20508]=k+1;continue b;break};case 2:{c[21724]=0;c[21740]=0;c[20508]=c[82060+(k<<4)>>2];if(b){t=24;break a}if((c[21736]|0)==0){j=0;t=37;break a}n=le[c[20494]&7]()|0;if((n|0)==0){continue b}else{j=n;t=37;break a}break};case 9:{n=(Wd[c[20492]&127](l)|0)==0;c[20508]=(c[20508]|0)+1;if(n){break b}else{continue b}break};case 20:{c[20504]=c[82060+(k<<4)>>2];c[20508]=k+1;continue b;break};case 33:{c[21752]=1;c[20508]=k+1;continue b;break};case 16:{if(b){t=28;break a}c[20508]=k+1;continue b;break};default:{t=4;break a}}}if((t|0)==10){t=0;if(b){t=11;break}c[q>>2]=s+ -1;c[21736]=1;k=$d[c[20490]&63](l,g,d)|0;if((k|0)>0){t=13;break}if((k|0)<0){t=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;t=37;break}}if((t|0)==4){h=c[r>>2]|0;d=c[20424]|0;c[f>>2]=m;c[f+4>>2]=d;jd(h|0,86856,f|0)|0;if((c[c[20480]>>2]|0)==0){sH(100,86888);j=100;i=e;return j|0}else{c[(Gc()|0)>>2]=100;j=100;i=e;return j|0}}else if((t|0)==11){j=le[c[20478]&7]()|0;i=e;return j|0}else if((t|0)==13){f=c[c[20480]>>2]|0;j=vH(f,c[(Gc()|0)>>2]|0,86952)|0;i=e;return j|0}else if((t|0)==15){if((c[(c[20480]|0)+8>>2]|0)==0){sH(-1,86952);j=-1;i=e;return j|0}else{c[(Gc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((t|0)==24){j=le[c[20478]&7]()|0;i=e;return j|0}else if((t|0)==28){j=le[c[20478]&7]()|0;i=e;return j|0}else if((t|0)==37){i=e;return j|0}return 0}function zH(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function AH(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=yH(b,0,0)|0;i=a;return d|0}function BH(){c[20500]=0;c[20508]=0;c[21740]=0;c[21724]=0;c[21736]=0;c[21742]=0;c[21726]=0;i=i;return}function CH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[20508]|0;if((g|0)>299){kc(87032,24,1,c[r>>2]|0)|0;jH(c[20424]|0,1)}else{c[82056+(g<<4)>>2]=a;c[82060+(g<<4)>>2]=b;c[82064+(g<<4)>>2]=d;c[82068+(g<<4)>>2]=e;c[20508]=g+1;i=f;return g|0}return 0}function DH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=EH(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[20512]|0)+ -1|0;c[20512]=h;if((h|0)==0){CH(2,c[20510]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{CH(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function EH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((FH(b,e)|0)!=0){g=c[e>>2]|0;break}if((GH(b,e)|0)!=0){g=c[e>>2]|0;break}h=HH(b,f,1)|0;j=CH(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=xH(h,j)|0}}while(0);i=d;return g|0}function FH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 120:case 88:{CH(4,1,0,0)|0;g=b;h=30;break};case 47:{CH(5,0,0,0)|0;g=b;h=30;break};case 36:{CH(33,0,0,0)|0;g=b;h=30;break};case 43:{j=0;h=13;break};case 39:case 34:case 2:{c[82064+((CH(11,0,0,0)|0)<<4)>>2]=b;k=IH(b)|0;c[d>>2]=k;l=(k|0)!=0|0;i=e;return l|0};case 115:case 83:{k=b+1|0;m=a[k]|0;if(m<<24>>24==83|m<<24>>24==115){n=k;o=19}else if(m<<24>>24==80|m<<24>>24==112){n=k;o=18}else{n=b;o=17}CH(o,0,0,0)|0;g=n;h=30;break};case 58:{CH(16,0,0,0)|0;g=b;h=30;break};case 98:case 66:{k=b+1|0;m=a[k]|0;if(m<<24>>24==90|m<<24>>24==122){CH(22,0,0,0)|0;g=k;h=30;break a}else{CH(21,0,0,0)|0;g=k;h=30;break a}break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;h=14;break};case 45:{j=1;h=13;break};case 116:case 84:{k=b+1|0;m=a[k]|0;if(m<<24>>24==82|m<<24>>24==114){r=k;s=14}else if(m<<24>>24==76|m<<24>>24==108){r=k;s=13}else{r=b;s=15}k=HH(r+1|0,f,0)|0;if((k|0)==0){h=15;break a}CH(s,c[f>>2]|0,0,0)|0;g=k+ -1|0;h=30;break};case 112:case 80:{CH(20,1,0,0)|0;g=b;h=30;break};default:{l=0;i=e;return l|0}}}while(0);if((h|0)==13){p=b+1|0;q=j;h=14}b:do{if((h|0)==14){j=HH(p,f,0)|0;if((j|0)==0){h=15;break}switch(a[j]|0){case 104:case 72:{b=c[f>>2]|0;c[82064+((CH(12,b,0,0)|0)<<4)>>2]=j+1;g=j+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}CH(20,t,0,0)|0;g=j;h=30;break b;break};case 120:case 88:{CH(4,c[f>>2]|0,0,0)|0;g=j;h=30;break b;break};default:{l=0;i=e;return l|0}}}}while(0);if((h|0)==15){c[d>>2]=0;l=1;i=e;return l|0}else if((h|0)==30){c[d>>2]=g+1;l=1;i=e;return l|0}return 0}function GH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=HH(b,f,1)|0;CH(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 97:case 65:{l=f;while(1){m=a[l]|0;if(m<<24>>24==32){l=l+1|0}else{break}}if(!((m+ -48<<24>>24&255)<10)){CH(30,0,0,0)|0;n=l;o=45;break a}p=HH(l,g,1)|0;q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}CH(31,q,0,0)|0;n=p;o=45;break};case 105:case 73:{r=7;s=10;o=38;break};case 101:case 69:{t=1;o=3;break};case 102:case 70:{p=HH(f,g,0)|0;if((p|0)==0){o=4;break a}q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}if((a[p]|0)==46){u=HH(p+1|0,h,0)|0;if((u|0)==0){o=4;break a}v=u;w=c[h>>2]|0}else{c[h>>2]=0;v=p;w=0}CH(23,q,w,0)|0;n=v;o=45;break};case 100:case 68:{q=HH(f,g,0)|0;if((q|0)==0){o=4;break a}p=c[g>>2]|0;if((p|0)==0){n=q;o=45;break a}if((a[q]|0)==46){u=HH(q+1|0,h,0)|0;if((u|0)==0){o=4;break a}x=u;y=c[h>>2]|0}else{c[h>>2]=0;x=q;y=0}CH(26,p,y,0)|0;n=x;o=45;break};case 111:case 79:{r=32;s=34;o=38;break};case 103:case 71:{t=0;o=3;break};case 108:case 76:{p=HH(f,g,0)|0;if((p|0)==0){o=4;break a}q=c[g>>2]|0;if((q|0)==0){n=p;o=45;break a}CH(29,q,0,0)|0;n=p;o=45;break};case 122:case 90:{r=35;s=36;o=38;break};default:{c[20508]=(c[20508]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((o|0)==3){b=HH(f,g,0)|0;if((b|0)==0){o=4;break}x=c[g>>2]|0;if((x|0)==0){n=b;o=45;break}y=a[b]|0;if(y<<24>>24==46){v=HH(b+1|0,h,0)|0;if((v|0)==0){o=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){CH((t|0)==1?24:27,x,c[h>>2]|0,0)|0;n=A;o=45;break}y=HH(A+1|0,j,0)|0;if((y|0)==0){o=4;break}CH((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;n=y;o=45}else if((o|0)==38){y=HH(f,g,0)|0;if((y|0)==0){o=4;break}x=c[g>>2]|0;if((x|0)==0){n=y;o=45;break}if((a[y]|0)!=46){CH(r,x,0,0)|0;n=y;o=45;break}b=HH(y+1|0,h,0)|0;if((b|0)==0){o=4;break}CH(s,x,c[h>>2]|0,0)|0;n=b;o=45}}while(0);if((o|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((o|0)==45){c[d>>2]=n;z=1;i=e;return z|0}return 0}function HH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function IH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[20480]>>2]|0)==0){sH(100,87016);n=0;i=d;return n|0}else{c[(Gc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function JH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[87086|0]=48;k=87086|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=87064+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function KH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[20502]|0;f=c[20498]|0;if((e|0)>(f|0)){c[20498]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[21790]|0)){h=g}else{LH(f,g);h=c[20498]|0}g=c[21792]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;wd(g|0,c[20476]|0)|0;h=gU(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Ed(a[k]|0,c[20476]|0)|0;wd(h|0,c[20476]|0)|0;b=gU(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function LH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[21792]|0;if((f|0)==87248){c[21790]=1024;g=1024}else{g=c[21790]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[21790]=j;h=j}j=ET(h)|0;if((j|0)==0){sH(113,87648);k=c[21792]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[21792]|0}else{l=k}if((l|0)==87248){m=87168;c[21792]=j;i=e;return}FT(l);m=87168;c[21792]=j;i=e;return}function MH(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[20498]|0;f=c[21790]|0;if((e|0)<(f|0)){g=e}else{LH(e,f);g=c[20498]|0}c[20498]=g+1;a[(c[21792]|0)+g|0]=b;i=d;return}function NH(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[20462]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){sH(101,87176);l=101;i=d;return l|0}else{c[(Gc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[20474]|0)==0){tH();m=c[f>>2]|0}else{m=k}k=76832+(m*48|0)|0;c[19198]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){SH(k,c[b+12>>2]|0,j);o=TH(j,h)|0;if((o|0)==(c[76840+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[76844+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=oH(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[76864+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=76848+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[76864+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=76856+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[76856+(m*48|0)>>2]=1;r=1;break}else{c[76856+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];bc(j|0,87184,e|0)|0}else{SH(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){OH(107,87176,b);l=107;i=d;return l|0}else{c[(Gc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=76876+(m*48|0)|0;c[q>>2]=0;c[76868+(m*48|0)>>2]=0;e=76872+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=76860+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((vc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){OH(128,87176,b);l=128;i=d;return l|0}else{c[(Gc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((vc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Gc()|0;s=c[k>>2]|0;if(o){OH(s,87176,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;s=Gb()|0;c[n>>2]=s;if((s|0)!=0){c[76836+(m*48|0)>>2]=0;c[76844+(m*48|0)>>2]=-1;c[76840+(m*48|0)>>2]=-1;c[76852+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Gc()|0;o=c[k>>2]|0;if(s){OH(o,87176,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=cc(j|0,c[21786]|0)|0;if((o|0)==0){break}Qc(o|0)|0}}while(0);q=ET((gU(j|0)|0)+1|0)|0;c[76836+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){OH(113,87200,b);l=113;i=d;return l|0}else{c[(Gc()|0)>>2]=113;l=113;i=d;return l|0}}mU(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=cc(j|0,c[87144+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=cc(j|0,c[87104+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=cc(j|0,c[87144+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Gc()|0;o=c[g>>2]|0;if(h){sH(o,87176);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=76852+(m*48|0)|0;c[r>>2]=rH(u)|0;u=TH(j,76844+(m*48|0)|0)|0;c[76840+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){OH(108,87176,b);l=108;i=d;return l|0}else{c[(Gc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){lb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Oc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){OH(129,87176,b);l=129;i=d;return l|0}else{c[(Gc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function OH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){sH(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[21790]|0)){j=d;k=g}else{LH(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[21792]|0;c[(c[19198]|0)+4>>2]=f;SH(k,j,f);sH(a,b);i=e;return}function PH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;bc(j|0,87184,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=gU(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?87216:87224;c[h+24>>2]=(b|0)==5?87232:87240;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=NH(h)|0;i=e;return a|0}function QH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=76832+(d*48|0)|0;c[19198]=e;if(d>>>0>99){if((c[a>>2]|0)==0){sH(101,87664);f=101;i=b;return f|0}else{c[(Gc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((PH(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){sH(114,87672);f=114;i=b;return f|0}else{c[(Gc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[76856+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){sH(102,87672);f=102;i=b;return f|0}else{c[(Gc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function RH(){var a=0,b=0;a=i;b=AH()|0;c[20424]=0;i=a;return b|0}function SH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function TH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((fc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function UH(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[20504]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[20484]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];bc(p|0,87680,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(gU(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;Td[c[20488]&255](32);}while((A|0)>0)}if((D|0)!=0){Td[c[20488]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{Td[c[20488]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(yc(A|0)|0)+1|0;c[m>>2]=t-(c[20504]|0);bc(A|0,87688,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;Td[c[20488]&255](32);}while((z|0)>0)}if((x|0)!=0){Td[c[20488]&255]((w|0)!=0?45:43)}z=c[20504]|0;do{if((z|0)<1){Td[c[20488]&255](46);y=c[20488]|0;if((z|0)<0){G=y;J=z;while(1){Td[G&255](48);I=J+1|0;K=c[20488]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}Td[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}Td[c[20488]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[20488]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){Td[P&255](a[J]|0);R=Q+ -1|0;S=c[20488]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}Td[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;Td[c[20488]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){Td[c[20488]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;Td[c[20488]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){Td[c[20488]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;Td[c[20488]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;Td[c[20488]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;Td[c[20488]&255](42);}while((_|0)>0);i=l;return 0}function VH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[20504]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(bc(n|0,87696,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[20484]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;Td[c[20488]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;Td[c[20488]&255](32);}while((b|0)>0)}do{if(q){if((c[20484]|0)==0){break}Td[c[20488]&255](43)}else{Td[c[20488]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;Td[c[20488]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;Td[c[20488]&255](48);}while((z|0)>0);i=j;return 0}function WH(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{Td[c[20488]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[20488]|0;if((h|0)==0){Td[d&255](70);i=g;return 0}else{Td[d&255](84);i=g;return 0}return 0}function XH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[20500]|0)!=0){g=YH()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 29:{WH(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 23:{h=VH(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 31:{aI(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 32:{ZH(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 30:{$H(b,d);h=0;i=e;return h|0};case 10:{_H(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 7:{ZH(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 35:{cI(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 36:{cI(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 28:case 27:{h=bI(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 34:{_H(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 25:case 24:case 26:{h=UH(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;jd(h|0,87704,f|0)|0;jH(c[20424]|0,1)}}return 0}function YH(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[20500]|0;c[20500]=0;if((c[20462]|0)!=0){if((b|0)>0){d=c[20502]|0;e=c[20498]|0;if((d|0)<=(e|0)){f=b;while(1){Td[c[20488]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[20498]=f;h=0;i=a;return h|0}f=b-d+e|0;c[20498]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){Td[c[20488]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[20498]|0;f=j+b|0;if((f|0)>=0){if((c[20502]|0)<(j|0)){c[20502]=j}c[20498]=f;h=0;i=a;return h|0}if((c[c[20480]>>2]|0)==0){sH(110,87792);h=110;i=a;return h|0}else{c[(Gc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[20498]|0;if((c[20502]|0)<(f|0)){c[20502]=f}j=f+b|0;c[20498]=j;c[20506]=(c[20506]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[20480]>>2]|0)==0){sH(110,87792);h=110;i=a;return h|0}else{c[(Gc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[20498]|0;f=j+b|0;if((f|0)>=(c[(c[20482]|0)+16>>2]|0)){if((c[c[20480]>>2]|0)==0){sH(110,87808);h=110;i=a;return h|0}else{c[(Gc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[20502]|0;if((d|0)<=(j|0)){e=b;while(1){Td[c[20488]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[20506]=(c[20506]|0)+b;c[20498]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[20506]=(c[20506]|0)+f;c[20498]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){Td[c[20488]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function ZH(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=JH(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[20484]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{Td[c[20488]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{Td[c[20488]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[20484]|0)==0){break}Td[c[20488]&255](43)}else{Td[c[20488]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){Td[c[20488]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function _H(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=JH(m,k,l,h)|0;h=c[l>>2]|0;g=(c[20484]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{Td[c[20488]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{Td[c[20488]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[20484]|0)==0){break}Td[c[20488]&255](43)}else{Td[c[20488]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){Td[c[20488]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){Td[c[20488]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{Td[c[20488]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function $H(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;Td[c[20488]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function aI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;Td[c[20488]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;Td[c[20488]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function bI(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=UH(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=UH(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[20504]|0;c[20504]=0;p=(e|0)==0?4:e+2|0;e=VH(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{Td[c[20488]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[20504]=o;n=e;i=j;return n|0}function cI(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{Td[c[20488]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;Td[c[20488]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;Td[c[20488]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){Td[c[20488]&255](a[87768+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){Td[c[20488]&255](a[87768+((d[p]|0)>>>4)|0]|0);Td[c[20488]&255](a[87768+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function dI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 5:{f=le[c[20496]&7]()|0;i=b;return f|0};case 12:{f=fI(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 15:{c[20500]=(c[a+4>>2]|0)+ -1-(c[20498]|0);f=1;i=b;return f|0};case 13:{g=(c[20500]|0)-(c[a+4>>2]|0)|0;h=0-(c[20498]|0)|0;c[20500]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 11:{f=eI(c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[20500]=(c[20500]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;jd(f|0,87736,d|0)|0;jH(c[20424]|0,1)}}return 0}function eI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[20500]|0)!=0){e=YH()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}Td[c[20488]&255](e<<24>>24);n=b}else{Td[c[20488]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function fI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[20500]|0)!=0){f=YH()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;Td[c[20488]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function gI(){var a=0,b=0;a=i;b=KH(10)|0;c[20500]=0;c[20498]=0;c[20502]=0;i=a;return(b|0)==0|0}function hI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[20474]|0)==0){tH()}c[20438]=0;c[20444]=1;c[20452]=1;c[20462]=1;d=QH(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[20480]=a;c[20498]=0;c[20500]=0;c[20502]=0;c[21752]=0;c[20504]=0;d=c[a+12>>2]|0;c[20424]=d;c[20476]=c[c[19198]>>2];if((wH(d)|0)<0){if((c[a>>2]|0)==0){sH(100,87816);e=100;i=b;return e|0}else{c[(Gc()|0)>>2]=100;e=100;i=b;return e|0}}c[20488]=208;c[20490]=43;c[20492]=111;c[20478]=4;c[20494]=5;c[20496]=6;BH();c[20484]=0;d=c[19198]|0;c[20486]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((uH(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Gc()|0;f=c[a>>2]|0;if(d){sH(f,87824);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function iI(){var a=0,b=0;a=i;if((c[21752]|0)==0){b=KH(10)|0}else{KH(0)|0;hd(c[20476]|0)|0;b=0}c[20500]=0;c[20498]=0;c[20502]=0;i=a;return b|0}function jI(){var a=0,b=0,d=0;a=i;if((c[21736]|0)==0){b=0}else{d=KH(10)|0;c[21736]=0;b=d}c[20500]=0;c[20498]=0;c[20502]=0;i=a;return b|0}function kI(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;GI(88552,h,88608);c[21960]=90060;c[87848>>2]=90080;c[87844>>2]=0;xK(87848|0,88552);c[87920>>2]=0;c[87924>>2]=-1;j=c[t>>2]|0;c[22164]=89928;fQ(88660|0);k=88664|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[22164]=89168;c[88688>>2]=j;gQ(g,88660|0);k=jQ(g,92720)|0;l=k;hQ(g);c[88692>>2]=l;c[88696>>2]=88616;a[88700|0]=(Wd[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[21982]=90140;c[87932>>2]=90160;xK(87932|0,88656);c[88004>>2]=0;c[88008>>2]=-1;l=c[r>>2]|0;c[22176]=89928;fQ(88708|0);k=88712|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[22176]=89168;c[88736>>2]=l;gQ(f,88708|0);k=jQ(f,92720)|0;g=k;hQ(f);c[88740>>2]=g;c[88744>>2]=88624;a[88748|0]=(Wd[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[22004]=90140;c[88020>>2]=90160;xK(88020|0,88704);c[88092>>2]=0;c[88096>>2]=-1;g=c[(c[(c[22004]|0)+ -12>>2]|0)+88040>>2]|0;c[22026]=90140;c[88108>>2]=90160;xK(88108|0,g);c[88180>>2]=0;c[88184>>2]=-1;c[(c[(c[21960]|0)+ -12>>2]|0)+87912>>2]=87928;g=(c[(c[22004]|0)+ -12>>2]|0)+88020|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[22004]|0)+ -12>>2]|0)+88088>>2]=87928;sI(88752,h,88632|0);c[22048]=90100;c[88200>>2]=90120;c[88196>>2]=0;xK(88200|0,88752);c[88272>>2]=0;c[88276>>2]=-1;c[22202]=89992;fQ(88812|0);h=88816|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[22202]=88912;c[88840>>2]=j;gQ(e,88812|0);j=jQ(e,92728)|0;h=j;hQ(e);c[88844>>2]=h;c[88848>>2]=88640;a[88852|0]=(Wd[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[22070]=90180;c[88284>>2]=90200;xK(88284|0,88808);c[88356>>2]=0;c[88360>>2]=-1;c[22214]=89992;fQ(88860|0);h=88864|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[22214]=88912;c[88888>>2]=l;gQ(d,88860|0);l=jQ(d,92728)|0;h=l;hQ(d);c[88892>>2]=h;c[88896>>2]=88648;a[88900|0]=(Wd[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[22092]=90180;c[88372>>2]=90200;xK(88372|0,88856);c[88444>>2]=0;c[88448>>2]=-1;h=c[(c[(c[22092]|0)+ -12>>2]|0)+88392>>2]|0;c[22114]=90180;c[88460>>2]=90200;xK(88460|0,h);c[88532>>2]=0;c[88536>>2]=-1;c[(c[(c[22048]|0)+ -12>>2]|0)+88264>>2]=88280;h=(c[(c[22092]|0)+ -12>>2]|0)+88372|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[22092]|0)+ -12>>2]|0)+88440>>2]=88280;i=b;return}function lI(a){a=a|0;a=i;vL(87928)|0;vL(88104)|0;CL(88280)|0;CL(88456)|0;i=a;return}function mI(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);i=b;return}function nI(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);MT(a);i=b;return}function oI(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Wd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=jQ(d,92728)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(Wd[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function pI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ie[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((kc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((hd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function qI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=kc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((he[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function rI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((kc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=ke[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((kc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((kc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function sI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=89992;j=b+4|0;fQ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=89024;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;gQ(g,j);j=jQ(g,92728)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=Wd[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(Wd[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){rP(89120)}else{hQ(g);i=f;return}}function tI(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);i=b;return}function uI(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);MT(a);i=b;return}function vI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=jQ(d,92728)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=Wd[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(Wd[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){rP(89120)}else{i=e;return}}function wI(a){a=a|0;var b=0,c=0;b=i;c=zI(a,0)|0;i=b;return c|0}function xI(a){a=a|0;var b=0,c=0;b=i;c=zI(a,1)|0;i=b;return c|0}function yI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=ke[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((ed(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function zI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Wc(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=ke[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Wc(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((ed(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function AI(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);i=b;return}function BI(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);MT(a);i=b;return}function CI(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;Wd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=jQ(d,92720)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(Wd[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function DI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ie[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((kc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((hd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function EI(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=kc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((he[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function FI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((kc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=ke[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((kc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((kc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function GI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=89928;j=b+4|0;fQ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=89280;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;gQ(g,j);j=jQ(g,92720)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=Wd[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(Wd[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){rP(89120)}else{hQ(g);i=f;return}}function HI(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);i=b;return}function II(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);MT(a);i=b;return}function JI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=jQ(d,92720)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=Wd[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(Wd[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){rP(89120)}else{i=e;return}}function KI(a){a=a|0;var b=0,c=0;b=i;c=NI(a,0)|0;i=b;return c|0}function LI(a){a=a|0;var b=0,c=0;b=i;c=NI(a,1)|0;i=b;return c|0}function MI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=ke[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((ed(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function NI(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Wc(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=ke[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Wc(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((ed(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function OI(){var a=0;a=i;kI(0);Ld(209,88544,q|0)|0;i=a;return}function PI(a){a=a|0;i=i;return}function QI(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function RI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}Td[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function SI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=89424;e=gU(b|0)|0;f=LT(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;iU(g|0,b|0,e+1|0)|0;i=d;return}function TI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=89424;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}function UI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=89424;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);i=b;return}function VI(a){a=a|0;i=i;return c[a+4>>2]|0}function WI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=89448;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=gU(f|0)|0;g=LT(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;iU(h|0,f|0,d+1|0)|0;i=e;return}function XI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=89448;e=gU(b|0)|0;f=LT(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;iU(g|0,b|0,e+1|0)|0;i=d;return}function YI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=89448;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}function ZI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=89448;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);i=b;return}function _I(a){a=a|0;i=i;return c[a+4>>2]|0}function $I(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=89424;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}function aJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=89424;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}NT((c[d>>2]|0)+ -12|0);g=a;h=g;vb(h|0);j=a;MT(j);i=b;return}function bJ(a){a=a|0;i=i;return}function cJ(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function dJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ne[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function eJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function fJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Id(e|0)|0;e=gU(f|0)|0;if(e>>>0>4294967279){lJ(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;iU(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=KT(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;iU(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function gJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{SJ(e,89664,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ne[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}SJ(e,o,p)|0;if((a[g]&1)==0){break}MT(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function hJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=gU(e|0)|0;if(j>>>0>4294967279){lJ(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=KT(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}iU(k|0,e|0,j|0)|0;a[k+j|0]=0;gJ(g,d,h);WI(b,g);if(!((a[g]&1)==0)){MT(c[g+8>>2]|0)}if(!((a[h]&1)==0)){MT(c[h+8>>2]|0)}c[b>>2]=89680;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function iJ(a){a=a|0;var b=0;b=i;ZI(a);MT(a);i=b;return}function jJ(a){a=a|0;var b=0;b=i;ZI(a);i=b;return}function kJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;mc(89816)|0;if((c[a>>2]|0)==1){do{cd(89840,89816)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;$b(89816)|0;Td[d&255](b);mc(89816)|0;c[a>>2]=-1;$b(89816)|0;Tc(89840)|0;i=e;return}else{$b(89816)|0;i=e;return}}function lJ(a){a=a|0;a=xc(8)|0;SI(a,89888);c[a>>2]=89504;Fd(a|0,89544,41)}function mJ(a){a=a|0;a=xc(8)|0;SI(a,89888);c[a>>2]=89568;Fd(a|0,89608,41)}function nJ(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function oJ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function pJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){lJ(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=KT(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}iU(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function qJ(b){b=b|0;i=i;return(a[b]&1)!=0|0}function rJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){lJ(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=KT(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}iU(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function sJ(a){a=a|0;i=i;return a|0}function tJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=gU(d|0)|0;if(f>>>0>4294967279){lJ(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;iU(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=KT(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;iU(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function uJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){lJ(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=KT(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}kU(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function vJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){lJ(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;kU(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=KT(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;kU(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function wJ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){mJ(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){lJ(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;iU(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=KT(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;iU(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function xJ(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function yJ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function zJ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}MT(c[b+8>>2]|0);i=d;return}function AJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}TJ(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}jU(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function BJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=CJ(a,b)|0;i=c;return d|0}function CJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=gU(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}TJ(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}jU(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function DJ(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function EJ(a){a=a|0;i=i;return a+1|0}function FJ(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function GJ(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function HJ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function IJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){JJ(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function JJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){UJ(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}kU(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function KJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){JJ(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function LJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){lJ(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=KT(f)|0}else{p=KT(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}iU(l|0,n|0,q+1|0)|0;if(o){MT(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function MJ(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function NJ(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function OJ(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function PJ(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function QJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=SJ(b,g,h)|0;i=e;return d|0}function RJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){UJ(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function SJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){TJ(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}iU(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function TJ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){lJ(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=KT(q)|0;if((g|0)!=0){iU(e|0,m|0,g|0)|0}if((j|0)!=0){iU(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){iU(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){MT(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function UJ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){lJ(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=KT(p)|0;if((g|0)!=0){iU(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){iU(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}MT(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function VJ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;wJ(a,b,c,d,0);i=e;return}function WJ(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function XJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=gU(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function YJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=bU(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function ZJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=gU(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){mJ(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=bU(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function _J(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){lJ(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;iU(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=KT(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;iU(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function $J(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){lJ(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=KT(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}fT(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function aK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){lJ(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=KT(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}hT(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function bK(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}MT(c[b+8>>2]|0);i=d;return}function cK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=dK(a,b,eT(b)|0)|0;i=c;return d|0}function dK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}gK(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}gT(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function eK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){lJ(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=KT(f)|0}else{p=KT(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}fT(l,n,q+1|0)|0;if(o){MT(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function fK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){hK(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function gK(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){lJ(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=KT(q<<2)|0;p=e;if((g|0)!=0){fT(p,m,g)|0}if((j|0)!=0){fT(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){fT(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){MT(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function hK(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){lJ(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=KT(p<<2)|0;o=e;if((g|0)!=0){fT(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){fT(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}MT(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function iK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=gU(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){lJ(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=KT(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}iU(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=SJ(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=SJ(b,m,j)|0;i=f;return}}function jK(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function kK(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function lK(a,b){a=a|0;b=b|0;var c=0;c=i;mK(a,b);i=c;return}function mK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=xc(16)|0;do{if((a[90272]|0)==0){if((Va(90272)|0)==0){break}c[22566]=90968;Ld(67,90264,q|0)|0;Nb(90272)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=90264;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];hJ(b,f,90320);c[e>>2]=90288;Fd(e|0,90368,63)}function nK(a,b){a=a|0;b=b|0;var d=0;d=i;mK(a,c[a+16>>2]|b);i=d;return}function oK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=90312;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ne[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}hQ(a+28|0);FT(c[e>>2]|0);FT(c[f>>2]|0);FT(c[a+48>>2]|0);FT(c[a+60>>2]|0);i=b;return}function pK(a){a=a|0;var b=0;b=i;oK(a);MT(a);i=b;return}function qK(a){a=a|0;var b=0;b=i;oK(a);i=b;return}function rK(a){a=a|0;var b=0;b=i;oK(a);i=b;return}function sK(a){a=a|0;i=i;return c[a+24>>2]|0}function tK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}gQ(d,a+28|0);a=jQ(d,92656)|0;f=he[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;hQ(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function uK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;gQ(e,a+28|0);a=jQ(e,92656)|0;f=he[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;hQ(e);i=d;return f|0}function vK(a,b){a=a|0;b=b|0;var c=0;c=i;gQ(a,b+28|0);i=c;return}function wK(a){a=a|0;c[a>>2]=89912;i=i;return}function xK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));fQ(b);i=d;return}function yK(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);MT(a);i=b;return}function zK(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);i=b;return}function AK(a){a=a|0;var b=0;b=i;c[a>>2]=89928;hQ(a+4|0);i=b;return}function BK(a,b){a=a|0;b=b|0;var c=0;c=i;gQ(a,b+4|0);i=c;return}function CK(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=Wd[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function DK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=he[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function EK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=$d[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function FK(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=89928;fQ(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function GK(a){a=a|0;i=i;return c[a+8>>2]|0}function HK(a){a=a|0;i=i;return c[a+12>>2]|0}function IK(a){a=a|0;i=i;return c[a+16>>2]|0}function JK(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function KK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function LK(a){a=a|0;i=i;return c[a+20>>2]|0}function MK(a){a=a|0;i=i;return c[a+24>>2]|0}function NK(a){a=a|0;i=i;return c[a+28>>2]|0}function OK(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function PK(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function QK(a,b){a=a|0;b=b|0;i=i;return}function RK(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function SK(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function TK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function UK(a){a=a|0;i=i;return 0}function VK(a){a=a|0;i=i;return 0}function WK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=Wd[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function XK(a){a=a|0;i=i;return-1}function YK(a){a=a|0;var b=0,e=0,f=0;b=i;if((Wd[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function ZK(a,b){a=a|0;b=b|0;i=i;return-1}function _K(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((he[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function $K(a,b){a=a|0;b=b|0;i=i;return-1}function aL(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);MT(a);i=b;return}function bL(a){a=a|0;var b=0;b=i;c[a>>2]=89992;hQ(a+4|0);i=b;return}function cL(a,b){a=a|0;b=b|0;i=i;return}function dL(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function eL(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function fL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function gL(a){a=a|0;i=i;return 0}function hL(a){a=a|0;i=i;return 0}function iL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=Wd[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function jL(a){a=a|0;i=i;return-1}function kL(a){a=a|0;var b=0,d=0,e=0;b=i;if((Wd[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function lL(a,b){a=a|0;b=b|0;i=i;return-1}function mL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((he[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function nL(a,b){a=a|0;b=b|0;i=i;return-1}function oL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));fQ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function pL(a){a=a|0;var b=0;b=i;oK(a+8|0);MT(a);i=b;return}function qL(a){a=a|0;var b=0;b=i;oK(a+8|0);i=b;return}function rL(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;oK(a+(d+8)|0);MT(a+d|0);i=b;return}function sL(a){a=a|0;var b=0;b=i;oK(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function tL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;uL(a,b,c);i=d;return}function uL(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){mK(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){vL(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}gQ(h,e+(k+28)|0);k=jQ(h,92656)|0;hQ(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(Wd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(Wd[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){Wd[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((Wd[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;mK(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function vL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{vL(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((Wd[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;mK(b+h|0,c[b+(h+16)>>2]|1)}}while(0);KL(e);i=d;return b|0}function wL(b){b=b|0;i=i;return(a[b]|0)!=0|0}function xL(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Ab()}}function yL(a){a=a|0;var b=0;b=i;oK(a+8|0);MT(a);i=b;return}function zL(a){a=a|0;var b=0;b=i;oK(a+8|0);i=b;return}function AL(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;oK(a+(d+8)|0);MT(a+d|0);i=b;return}function BL(a){a=a|0;var b=0;b=i;oK(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function CL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{CL(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((Wd[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;mK(b+h|0,c[b+(h+16)>>2]|1)}}while(0);WL(e);i=d;return b|0}function DL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));fQ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function EL(a){a=a|0;var b=0;b=i;oK(a+4|0);MT(a);i=b;return}function FL(a){a=a|0;var b=0;b=i;oK(a+4|0);i=b;return}function GL(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;oK(a+(d+4)|0);MT(a+d|0);i=b;return}function HL(a){a=a|0;var b=0;b=i;oK(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function IL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){vL(g)|0}a[f]=1;i=e;return}function JL(a){a=a|0;var b=0;b=i;KL(a);i=b;return}function KL(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if($a()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((Wd[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;mK(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function LL(b){b=b|0;i=i;return(a[b]|0)!=0|0}function ML(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Wd[b&127](a)|0;i=c;return d|0}function NL(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){KL(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{vL(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;gQ(k,b+(p+28)|0);p=jQ(k,91376)|0;m=p;hQ(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){gQ(h,b+(k+28)|0);r=jQ(h,92656)|0;s=he[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;hQ(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ae[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){KL(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;mK(b+l|0,c[b+(l+16)>>2]|5);KL(j);i=e;return b|0}



function OL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){KL(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{vL(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;KL(f);i=e;return b|0}if((he[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{KL(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;mK(b+d|0,c[b+(d+16)>>2]|1);KL(f);i=e;return b|0}function PL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){KL(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){vL(k)|0}a[h]=1;if((e|0)==0){KL(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(($d[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){KL(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;mK(b+e|0,c[b+(e+16)>>2]|1);KL(g);i=f;return b|0}function QL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;ce[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function RL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){KL(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{vL(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];re[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){KL(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;mK(b+f|0,c[b+(f+16)>>2]|4);KL(h);i=e;return b|0}function SL(a){a=a|0;var b=0;b=i;oK(a+4|0);MT(a);i=b;return}function TL(a){a=a|0;var b=0;b=i;oK(a+4|0);i=b;return}function UL(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;oK(a+(d+4)|0);MT(a+d|0);i=b;return}function VL(a){a=a|0;var b=0;b=i;oK(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function WL(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if($a()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((Wd[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;mK(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function XL(a){a=a|0;i=i;return 90208}function YL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){rJ(a,90224,35);i=d;return}else{fJ(a,b,c);i=d;return}}function ZL(a){a=a|0;i=i;return}function _L(a){a=a|0;var b=0;b=i;jJ(a);MT(a);i=b;return}function $L(a){a=a|0;var b=0;b=i;jJ(a);i=b;return}function aM(a){a=a|0;var b=0;b=i;oK(a);MT(a);i=b;return}function bM(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function cM(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function dM(a){a=a|0;i=i;return}function eM(a){a=a|0;i=i;return}function fM(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function gM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){lJ(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=KT(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function hM(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function iM(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function jM(a){a=a|0;i=i;return}function kM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function lM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){lJ(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=KT(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function mM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function nM(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function oM(a){a=a|0;i=i;return}function pM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ee[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}vK(u,g);m=u;u=c[m>>2]|0;if(!((c[23164]|0)==-1)){c[p>>2]=92656;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92656,p,211)}p=(c[92660>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}F=u;RI(c[m>>2]|0)|0;vK(v,g);g=v;v=c[g>>2]|0;if(!((c[23200]|0)==-1)){c[o>>2]=92800;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92800,o,211)}o=(c[92804>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}J=v;RI(c[g>>2]|0)|0;g=w;Ud[c[(c[v>>2]|0)+24>>2]&63](g,J);Ud[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=qM(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];zJ(w+12|0);zJ(w);i=k;return}function qM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=ET(l)|0;if((n|0)!=0){o=n;p=n;break}RT()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((Wd[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((Wd[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=he[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(he[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){Wd[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((Wd[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}FT(o);i=k;return _|0}function rM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sM(a,0,k,j,f,g,h);i=b;return}function sM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;iN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}IJ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}IJ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((KM(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=eS(F,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}function tM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uM(a,0,k,j,f,g,h);i=b;return}function uM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;iN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}IJ(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}IJ(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((KM(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=dS(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}function vM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wM(a,0,k,j,f,g,h);i=b;return}function wM(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;iN(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}IJ(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}IJ(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((KM(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){Wd[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=cS(G,c[p>>2]|0,j,u)|0;vP(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;zJ(o);zJ(n);i=e;return}if((Wd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;zJ(o);zJ(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;zJ(o);zJ(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;zJ(o);zJ(n);i=e;return}function xM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];yM(a,0,k,j,f,g,h);i=b;return}function yM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;iN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}IJ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}IJ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((KM(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=bS(F,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}function zM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];AM(a,0,k,j,f,g,h);i=b;return}function AM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;iN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}IJ(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}IJ(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((KM(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=aS(F,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;zJ(n);zJ(m);i=d;return}function BM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CM(a,0,k,j,f,g,h);i=b;return}function CM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;iN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}IJ(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}IJ(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((KM(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=$R(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;zJ(n);zJ(m);i=d;return}function DM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EM(a,0,k,j,f,g,h);i=b;return}function EM(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;jN(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}IJ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}IJ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((kN(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+_R(I,c[p>>2]|0,j);vP(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}if((Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}function FM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GM(a,0,k,j,f,g,h);i=b;return}function GM(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;jN(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}IJ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}IJ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((kN(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+ZR(I,c[p>>2]|0,j);vP(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}if((Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}function HM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];IM(a,0,k,j,f,g,h);i=b;return}function IM(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;jN(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}IJ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}IJ(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((kN(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+YR(I,c[p>>2]|0,j);vP(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}if((Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;zJ(o);zJ(n);i=d;return}function JM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;vK(o,g);g=o;o=c[g>>2]|0;if(!((c[23164]|0)==-1)){c[l>>2]=92656;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92656,l,211)}l=(c[92660>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}y=m;qe[c[(c[o>>2]|0)+32>>2]&63](o,91200,91226|0,y)|0;RI(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((Wd[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}IJ(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}IJ(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((KM(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){Wd[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);K=c[23136]|0;c[k>>2]=j;if((LM(E,K,91240,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((Wd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;zJ(p);zJ(n);i=d;return}if((Wd[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;zJ(p);zJ(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;zJ(p);zJ(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;zJ(p);zJ(n);i=d;return}function KM(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[91200+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[91200+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function LM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Ec(b|0)|0;b=Ta(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Ec(e|0)|0;i=f;return b|0}function MM(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function NM(a){a=a|0;i=i;return}function OM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ee[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}vK(u,g);m=u;u=c[m>>2]|0;if(!((c[23162]|0)==-1)){c[p>>2]=92648;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92648,p,211)}p=(c[92652>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}F=u;RI(c[m>>2]|0)|0;vK(v,g);g=v;v=c[g>>2]|0;if(!((c[23202]|0)==-1)){c[o>>2]=92808;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92808,o,211)}o=(c[92812>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}J=v;RI(c[g>>2]|0)|0;g=w;Ud[c[(c[v>>2]|0)+24>>2]&63](g,J);Ud[c[(c[v>>2]|0)+28>>2]&63](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=PM(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];bK(w+12|0);bK(w);i=k;return}function PM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=ET(l)|0;if((n|0)!=0){o=n;p=n;break}RT()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=Wd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=Wd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=he[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(he[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){Wd[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}FT(o);i=k;return ba|0}function QM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];RM(a,0,k,j,f,g,h);i=b;return}function RM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;lN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Wd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}IJ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}IJ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((hN(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=eS(I,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}function SM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];TM(a,0,k,j,f,g,h);i=b;return}function TM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;lN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Wd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}IJ(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}IJ(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((hN(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=dS(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}function UM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];VM(a,0,k,j,f,g,h);i=b;return}function VM(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;lN(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=Wd[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}IJ(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}IJ(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((hN(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){Wd[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=cS(J,c[p>>2]|0,j,u)|0;vP(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=Wd[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;zJ(o);zJ(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;zJ(o);zJ(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;zJ(o);zJ(n);i=e;return}function WM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XM(a,0,k,j,f,g,h);i=b;return}function XM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;lN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Wd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}IJ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}IJ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((hN(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=bS(I,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}function YM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZM(a,0,k,j,f,g,h);i=b;return}function ZM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;lN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Wd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}IJ(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}IJ(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((hN(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=aS(I,c[o>>2]|0,h,t)|0;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;zJ(n);zJ(m);i=d;return}function _M(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$M(a,0,k,j,f,g,h);i=b;return}function $M(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;lN(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=Wd[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}IJ(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}IJ(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((hN(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){Wd[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=$R(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;vP(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=Wd[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;zJ(n);zJ(m);i=d;return}function aN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];bN(a,0,k,j,f,g,h);i=b;return}function bN(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;mN(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Wd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}IJ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}IJ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((nN(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+_R(L,c[p>>2]|0,j);vP(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Wd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}function cN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dN(a,0,k,j,f,g,h);i=b;return}function dN(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;mN(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Wd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}IJ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}IJ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((nN(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+ZR(L,c[p>>2]|0,j);vP(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Wd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}function eN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];fN(a,0,k,j,f,g,h);i=b;return}function fN(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;mN(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=Wd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}IJ(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}IJ(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((nN(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+YR(L,c[p>>2]|0,j);vP(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=Wd[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;zJ(o);zJ(n);i=d;return}function gN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;vK(o,g);g=o;o=c[g>>2]|0;if(!((c[23162]|0)==-1)){c[l>>2]=92648;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92648,l,211)}l=(c[92652>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}y=m;qe[c[(c[o>>2]|0)+48>>2]&63](o,91200,91226|0,y)|0;RI(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;IJ(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=Wd[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}IJ(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}IJ(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((hN(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){Wd[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);N=c[23136]|0;c[k>>2]=j;if((LM(H,N,91240,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=Wd[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=Wd[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;zJ(p);zJ(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;zJ(p);zJ(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;zJ(p);zJ(n);i=d;return}function hN(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[91200+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[91200+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function iN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;vK(k,d);d=k;k=c[d>>2]|0;if(!((c[23164]|0)==-1)){c[j>>2]=92656;c[j+4>>2]=210;c[j+8>>2]=0;kJ(92656,j,211)}j=(c[92660>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=xc(4)|0;n=m;jT(n);o=108216;p=128;Fd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=xc(4)|0;n=m;jT(n);o=108216;p=128;Fd(m|0,o|0,p|0)}qe[c[(c[k>>2]|0)+32>>2]&63](k,91200,91226|0,e)|0;e=c[d>>2]|0;if(!((c[23200]|0)==-1)){c[h>>2]=92800;c[h+4>>2]=210;c[h+8>>2]=0;kJ(92800,h,211)}h=(c[92804>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}else{t=e;a[f]=Wd[c[(c[e>>2]|0)+16>>2]&127](t)|0;Ud[c[(c[e>>2]|0)+20>>2]&63](b,t);RI(c[d>>2]|0)|0;i=g;return}}function jN(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;vK(l,d);d=l;l=c[d>>2]|0;if(!((c[23164]|0)==-1)){c[k>>2]=92656;c[k+4>>2]=210;c[k+8>>2]=0;kJ(92656,k,211)}k=(c[92660>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=xc(4)|0;o=n;jT(o);p=108216;q=128;Fd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=xc(4)|0;o=n;jT(o);p=108216;q=128;Fd(n|0,p|0,q|0)}qe[c[(c[l>>2]|0)+32>>2]&63](l,91200,91232|0,e)|0;e=c[d>>2]|0;if(!((c[23200]|0)==-1)){c[j>>2]=92800;c[j+4>>2]=210;c[j+8>>2]=0;kJ(92800,j,211)}j=(c[92804>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=xc(4)|0;s=r;jT(s);t=108216;u=128;Fd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=xc(4)|0;s=r;jT(s);t=108216;u=128;Fd(r|0,t|0,u|0)}else{u=e;a[f]=Wd[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=Wd[c[(c[e>>2]|0)+16>>2]&127](u)|0;Ud[c[(c[e>>2]|0)+20>>2]&63](b,u);RI(c[d>>2]|0)|0;i=h;return}}function kN(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[91200+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function lN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;vK(j,b);b=j;j=c[b>>2]|0;if(!((c[23162]|0)==-1)){c[h>>2]=92648;c[h+4>>2]=210;c[h+8>>2]=0;kJ(92648,h,211)}h=(c[92652>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=xc(4)|0;m=l;jT(m);n=108216;o=128;Fd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=xc(4)|0;m=l;jT(m);n=108216;o=128;Fd(l|0,n|0,o|0)}qe[c[(c[j>>2]|0)+48>>2]&63](j,91200,91226|0,d)|0;d=c[b>>2]|0;if(!((c[23202]|0)==-1)){c[g>>2]=92808;c[g+4>>2]=210;c[g+8>>2]=0;kJ(92808,g,211)}g=(c[92812>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}else{s=d;c[e>>2]=Wd[c[(c[d>>2]|0)+16>>2]&127](s)|0;Ud[c[(c[d>>2]|0)+20>>2]&63](a,s);RI(c[b>>2]|0)|0;i=f;return}}function mN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;vK(k,b);b=k;k=c[b>>2]|0;if(!((c[23162]|0)==-1)){c[j>>2]=92648;c[j+4>>2]=210;c[j+8>>2]=0;kJ(92648,j,211)}j=(c[92652>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=xc(4)|0;n=m;jT(n);o=108216;p=128;Fd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=xc(4)|0;n=m;jT(n);o=108216;p=128;Fd(m|0,o|0,p|0)}qe[c[(c[k>>2]|0)+48>>2]&63](k,91200,91232|0,d)|0;d=c[b>>2]|0;if(!((c[23202]|0)==-1)){c[h>>2]=92808;c[h+4>>2]=210;c[h+8>>2]=0;kJ(92808,h,211)}h=(c[92812>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}else{t=d;c[e>>2]=Wd[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=Wd[c[(c[d>>2]|0)+16>>2]&127](t)|0;Ud[c[(c[d>>2]|0)+20>>2]&63](a,t);RI(c[b>>2]|0)|0;i=g;return}}function nN(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[91200+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function oN(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function pN(a){a=a|0;i=i;return}function qN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ce[p&31](b,d,k,f,g,q);i=j;return}vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23200]|0)==-1)){c[l>>2]=92800;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92800,l,211)}l=(c[92804>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}w=n;RI(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Ud[c[f+24>>2]&63](o,w)}else{Ud[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((he[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];zJ(o);i=j;return}function rN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=91448;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);v=c[23136]|0;c[k>>2]=h;h=sN(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;vK(q,f);tN(w,y,k,z,o,p,q);RI(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];ZF(b,j,z,e,o,f,g);i=d;return}function sN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Ec(d|0)|0;d=gc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Ec(f|0)|0;i=g;return d|0}function tN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23164]|0)==-1)){c[m>>2]=92656;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92656,m,211)}m=(c[92660>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23200]|0)==-1)){c[l>>2]=92800;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92800,l,211)}l=(c[92804>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}x=s;Ud[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){qe[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=he[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=he[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=he[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=Wd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=he[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;zJ(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;zJ(n);i=k;return}}function uN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);y=c[23136]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=sN(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;vK(r,f);tN(x,z,l,A,p,q,r);RI(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];ZF(b,k,A,e,p,f,g);i=d;return}function vN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=91448;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);x=c[23136]|0;c[k>>2]=h;h=sN(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;vK(q,f);tN(w,y,k,z,o,p,q);RI(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];ZF(b,j,z,e,o,f,g);i=d;return}function wN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);w=c[23136]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=sN(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;vK(r,f);tN(x,z,l,A,p,q,r);RI(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];ZF(b,k,A,e,p,f,g);i=d;return}function xN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=sN(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=sN(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[92552]|0)==0;if(F){do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=yN(s,r,z,n)|0}else{do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=yN(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}RT()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=ET(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}RT()}}while(0);vK(w,f);zN(N,L,G,P,u,v,w);RI(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];ZF(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){FT(O)}if((J|0)==0){i=d;return}FT(J);i=d;return}function yN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Ec(b|0)|0;b=tc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Ec(e|0)|0;i=f;return b|0}function zN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23164]|0)==-1)){c[m>>2]=92656;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92656,m,211)}m=(c[92660>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23200]|0)==-1)){c[l>>2]=92800;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92800,l,211)}l=(c[92804>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}x=s;Ud[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=he[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=he[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=he[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);w=A+1|0;if((Pc(l<<24>>24|0,c[23136]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);l=D+1|0;if((Hd(A<<24>>24|0,c[23136]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){qe[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=Wd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=he[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=he[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=Wd[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);qe[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;zJ(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;zJ(n);i=k;return}



function tm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=wm(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function um(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function vm(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function wm(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 219:case 218:case 217:case 216:{e=7;break};case 223:case 222:case 221:case 220:{e=8;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function xm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 19:{k=zm(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wm(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function ym(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wm(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function zm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Am(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wm(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Am(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wm(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wm(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Bm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Em(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=Fm(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wm(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=Cm(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Dm(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=wm(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 27:case 26:case 25:case 24:case 22:{break};case 17:{break b;break};case 11:{o=90;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=wm(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{o=65;break b;break};case 5:{o=59;break b;break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=wm(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 17:{break c;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 7:{o=84;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Gm(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Cm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wm(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Dm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[15016+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Em(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=wm(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=wm(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Hm(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=wm(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Hm(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Fm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wm(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wm(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Gm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=wm(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=wm(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 29:{if((c[13072+((d[14352+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=wm(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 29:{if((c[13072+((d[12816+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 24:case 22:{break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=wm(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=wm(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 2:{l=79;break a;break};case 3:{t=xm(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=wm(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=wm(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[13072+((d[12816+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Hm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Im(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=wm(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=wm(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Jm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=wm(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wm(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=Cm(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Km(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=wm(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Lm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 12:{k=mn(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=mn(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 29:{g=b;if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[13072+((d[14352+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 30:{k=bn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=wm(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 16:{k=nn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=hn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 19:{k=on(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;n=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=wm(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=wm(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=wm(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{n=116;break b;break};case 33:{n=119;break b;break};case 5:{n=85;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=wm(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 15:{n=122;break b;break};case 7:{n=91;break b;break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=88;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function Mm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 2:{k=en(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=an(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wm(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=wm(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Nm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wm(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=wm(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Om(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=wm(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Pm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wm(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};case 9:{n=19;break a;break};case 21:{n=29;break a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=an(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=wm(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Qm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wm(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=18;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=an(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=bn(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=wm(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Rm(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=wm(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=wm(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Sm(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Tm(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=wm(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Um(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=wm(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Vm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=wm(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=wm(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Wm(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Kl(c)|0;k=j;i=b;return k|0}function Xm(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function Ym(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wm(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=wm(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Zm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=wm(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function _m(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function $m(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function an(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=cn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wm(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function bn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wm(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function cn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=dn(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wm(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function dn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wm(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wm(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function en(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 17:{k=jn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=wm(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=gn(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=fn(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=hn(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=wm(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 27:case 26:case 25:case 24:case 22:{break};case 11:{o=90;break b;break};case 17:{break b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=wm(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 24:case 22:{break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 10:case 9:case 21:{o=69;break b;break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=wm(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 7:{o=84;break d;break};case 24:case 22:{break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=kn(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function fn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=wm(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function gn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[15392+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function hn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=wm(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=wm(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=31;break b;break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((ln(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=wm(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((ln(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function jn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wm(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wm(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function kn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=wm(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=wm(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 6:{l=33;break a;break};case 24:case 22:{break};case 5:{l=30;break a;break};case 29:{if((c[13072+((d[12816+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=wm(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};case 29:{if((c[13072+((d[14352+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 14:{break};case 5:{l=10;break a;break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=wm(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=wm(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=an(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=wm(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=wm(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 10:case 9:case 21:{break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[13072+((d[12816+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function ln(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function mn(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=wm(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=wm(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function nn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=fn(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=wm(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=wm(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function on(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=wm(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[13072+((d[12816+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=wm(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[13072+((d[14352+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function pn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:case 21:{m=15;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((he[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((he[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((he[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((he[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((he[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((he[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=Zn(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=Pn(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=$n(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=Vn(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=_n(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 12:{k=Zn(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=69;break b;break};case 5:{if((e-b|0)<2){m=72;break b}p=b;if((he[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){m=77;break b}q=b;if((he[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=q+3|0;continue b;break};case 33:{m=113;break b;break};case 15:{m=116;break b;break};case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=91;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=94;break b}r=b;if((he[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=r+2|0;continue b;break};case 7:{if((e-b|0)<4){m=104;break b}s=b;if((he[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=s+4|0;continue b;break};case 6:{if((e-b|0)<3){m=99;break b}t=b;if((he[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=t+3|0;continue b;break};default:{n=19;continue b}}break};case 7:{if((e-b|0)<4){m=82;break b}u=b;if((he[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=u+4|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 34:{m=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==110){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){s=b;if((n|0)==19){c[f>>2]=s;k=0;l=k;i=h;return l|0}else{c[f>>2]=s+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function qn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=On(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=Sn(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=49;break b}if((he[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 6:{if((e-b|0)<3){n=45;break b}if((he[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((he[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function rn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((he[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((he[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((he[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function sn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((he[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((he[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 4:{n=b+1|0;b=n;if((n|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 2:{n=b+1|0;b=n;if((n|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}n=b+1|0;b=n;if((n|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}o=b;if((he[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=o+2|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function tn(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 2:{m=12;break a;break};case 3:{m=9;break a;break};case 21:{m=23;break a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=16;break a;break};case 10:{m=13;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=On(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function un(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 9:{m=18;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 3:{m=9;break a;break};case 10:{m=15;break a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=On(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Pn(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}



function AN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=sN(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=sN(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[92552]|0)==0;if(F){do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=yN(s,r,z,n)|0}else{do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=yN(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}RT()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=ET(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}RT()}}while(0);vK(w,f);zN(N,L,G,P,u,v,w);RI(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];ZF(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){FT(O)}if((J|0)==0){i=d;return}FT(J);i=d;return}function BN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=91456;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);s=c[23136]|0;c[k>>2]=h;h=sN(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;vK(p,f);r=p;p=c[r>>2]|0;if(!((c[23164]|0)==-1)){c[l>>2]=92656;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92656,l,211)}l=(c[92660>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}RI(c[r>>2]|0)|0;qe[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];ZF(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];ZF(b,j,u,z,m,f,g);I=j;i=d;return}function CN(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function DN(a){a=a|0;i=i;return}function EN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ce[p&31](b,d,k,f,g,q);i=j;return}vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23202]|0)==-1)){c[l>>2]=92808;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92808,l,211)}l=(c[92812>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}w=n;RI(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){Ud[c[f+24>>2]&63](o,w)}else{Ud[c[f+28>>2]&63](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=he[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];bK(o);i=j;return}function FN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=91448;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);x=c[23136]|0;c[k>>2]=h;h=sN(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;vK(q,f);GN(w,y,k,z,o,p,q);RI(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];HN(b,j,z,e,o,f,g);i=d;return}function GN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23162]|0)==-1)){c[m>>2]=92648;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92648,m,211)}m=(c[92652>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23202]|0)==-1)){c[l>>2]=92808;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92808,l,211)}l=(c[92812>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}x=s;Ud[c[(c[s>>2]|0)+20>>2]&63](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){qe[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=he[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=he[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=he[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=Wd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=he[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;zJ(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;zJ(n);i=k;return}function HN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if(($d[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){aK(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if(($d[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){bK(l);break}c[m>>2]=0;c[b>>2]=0;bK(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if(($d[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function IN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);y=c[23136]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=sN(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;vK(r,f);GN(x,z,l,A,p,q,r);RI(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];HN(b,k,A,e,p,f,g);i=d;return}function JN(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=91448;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);x=c[23136]|0;c[k>>2]=h;h=sN(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;vK(q,f);GN(w,y,k,z,o,p,q);RI(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];HN(b,j,z,e,o,f,g);i=d;return}function KN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);y=c[23136]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=sN(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;vK(r,f);GN(x,z,l,A,p,q,r);RI(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];HN(b,k,A,e,p,f,g);i=d;return}function LN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=sN(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=sN(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[92552]|0)==0;if(F){do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=yN(s,r,z,n)|0}else{do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=yN(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}RT()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=ET(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}RT()}}while(0);vK(w,f);MN(N,L,G,P,u,v,w);RI(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];HN(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){FT(O)}if((J|0)==0){i=d;return}FT(J);i=d;return}function MN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[23162]|0)==-1)){c[m>>2]=92648;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92648,m,211)}m=(c[92652>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=xc(4)|0;r=q;jT(r);s=108216;t=128;Fd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[23202]|0)==-1)){c[l>>2]=92808;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92808,l,211)}l=(c[92812>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=xc(4)|0;v=u;jT(v);w=108216;x=128;Fd(u|0,w|0,x|0)}x=s;Ud[c[(c[s>>2]|0)+20>>2]&63](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=he[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=he[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=he[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);w=A+1|0;if((Pc(l<<24>>24|0,c[23136]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);l=D+1|0;if((Hd(A<<24>>24|0,c[23136]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){qe[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=Wd[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=he[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=he[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=Wd[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);qe[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;zJ(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;zJ(n);i=k;return}function NN(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=sN(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=sN(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[92552]|0)==0;if(F){do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);r=c[23136]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=yN(s,r,z,n)|0}else{do{if(o){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=yN(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}RT()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=ET(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}RT()}}while(0);vK(w,f);MN(N,L,G,P,u,v,w);RI(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];HN(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){FT(O)}if((J|0)==0){i=d;return}FT(J);i=d;return}function ON(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=91456;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);s=c[23136]|0;c[k>>2]=h;h=sN(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}vK(p,f);u=p;p=c[u>>2]|0;if(!((c[23162]|0)==-1)){c[l>>2]=92648;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92648,l,211)}l=(c[92652>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}RI(c[u>>2]|0)|0;u=o;qe[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];HN(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];HN(b,j,u,z,m,f,g);I=j;i=d;return}function PN(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;vK(r,h);v=r;r=c[v>>2]|0;if(!((c[23164]|0)==-1)){c[q>>2]=92656;c[q+4>>2]=210;c[q+8>>2]=0;kJ(92656,q,211)}q=(c[92660>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=xc(4)|0;y=x;jT(y);z=108216;A=128;Fd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=xc(4)|0;y=x;jT(y);z=108216;A=128;Fd(x|0,z|0,A|0)}A=r;RI(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((Wd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((Wd[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if(($d[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(Wd[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=he[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(he[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=$d[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=$d[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];ge[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((Wd[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((Wd[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(Wd[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){Wd[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){Wd[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((Wd[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function QN(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function RN(a){a=a|0;i=i;return}function SN(a){a=a|0;i=i;return 2}function TN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];PN(a,b,l,k,f,g,h,91560,91568|0);i=j;return}function UN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=Wd[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];PN(b,d,m,l,g,h,j,s,q);i=k;return}function VN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23164]|0)==-1)){c[m>>2]=92656;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92656,m,211)}m=(c[92660>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}s=n;RI(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Wd[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=qM(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function WN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23164]|0)==-1)){c[m>>2]=92656;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92656,m,211)}m=(c[92660>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}s=n;RI(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Wd[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=qM(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function XN(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;vK(m,f);f=m;m=c[f>>2]|0;if(!((c[23164]|0)==-1)){c[l>>2]=92656;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92656,l,211)}l=(c[92660>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=xc(4)|0;p=o;jT(p);q=108216;r=128;Fd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=xc(4)|0;p=o;jT(p);q=108216;r=128;Fd(o|0,q|0,r|0)}r=m;RI(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=aO(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function YN(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;vK(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[23164]|0)==-1)){c[ba>>2]=92656;c[ba+4>>2]=210;c[ba+8>>2]=0;kJ(92656,ba,211)}ba=(c[92660>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=xc(4)|0;Ga=Fa;jT(Ga);Ha=108216;Ia=128;Fd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=xc(4)|0;Ga=Fa;jT(Ga);Ha=108216;Ia=128;Fd(Fa|0,Ha|0,Ia|0)}Ia=ca;RI(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];PN(oa,d,A,z,g,h,j,91584,91595|0);c[Da>>2]=c[oa>>2];break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];PN(ra,d,y,x,g,h,j,91600,91605|0);c[Da>>2]=c[ra>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];ZN(0,e,C,h,Ia);break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=Wd[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(qM(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];PN(ga,d,L,K,g,h,j,91568,91576|0);c[Da>>2]=c[ga>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=aO(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 99:{Ha=d+8|0;Da=Wd[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ja=ca;Ka=ca;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];PN(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Ha>>2]=c[da>>2];break};case 70:{Ha=e;c[ka>>2]=c[Ha>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];PN(ja,d,J,I,g,h,j,91576,91584|0);c[Ha>>2]=c[ja>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=aO(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=Wd[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(qM(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];_N(d,j+8|0,e,B,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=aO(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=aO(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=aO(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];$N(0,e,m,h,Ia);break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];PN(ua,d,v,u,g,h,j,91608,91616|0);c[Da>>2]=c[ua>>2];break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ee[Da&63](b,d,s,r,g,h,j);i=l;return};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=aO(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ma=Da+2e3|0}else{Ma=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ma+ -1900;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=aO(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Da=Wd[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Na=Da+1|0;Oa=Da+1|0;Pa=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];PN(za,d,q,p,g,h,j,Oa,Na+Pa|0);c[ca>>2]=c[za>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=aO(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=aO(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=aO(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function ZN(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((Wd[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){Wd[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((Wd[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((Wd[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function _N(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=Wd[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=qM(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function $N(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!(($d[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){Wd[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((Wd[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function aO(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=($d[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){Wd[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((Wd[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((Wd[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=(($d[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){Wd[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((Wd[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((Wd[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function bO(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;vK(p,f);t=p;p=c[t>>2]|0;if(!((c[23162]|0)==-1)){c[o>>2]=92648;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92648,o,211)}o=(c[92652>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=xc(4)|0;w=v;jT(w);x=108216;y=128;Fd(v|0,x|0,y|0)}y=p;RI(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if(($d[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=Wd[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=he[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(he[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=$d[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=$d[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];ge[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=Wd[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=Wd[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!($d[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){Wd[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){Wd[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=Wd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function cO(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function dO(a){a=a|0;i=i;return}function eO(a){a=a|0;i=i;return 2}function fO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];bO(a,b,l,k,f,g,h,91712,91744|0);i=j;return}function gO(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=Wd[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];bO(b,d,m,l,g,h,j,s,q);i=k;return}function hO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23162]|0)==-1)){c[m>>2]=92648;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92648,m,211)}m=(c[92652>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}s=n;RI(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Wd[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=PM(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function iO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;vK(n,f);f=n;n=c[f>>2]|0;if(!((c[23162]|0)==-1)){c[m>>2]=92648;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92648,m,211)}m=(c[92652>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=xc(4)|0;q=p;jT(q);r=108216;s=128;Fd(p|0,r|0,s|0)}s=n;RI(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=Wd[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=PM(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function jO(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;vK(m,f);f=m;m=c[f>>2]|0;if(!((c[23162]|0)==-1)){c[l>>2]=92648;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92648,l,211)}l=(c[92652>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=xc(4)|0;p=o;jT(p);q=108216;r=128;Fd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=xc(4)|0;p=o;jT(p);q=108216;r=128;Fd(o|0,q|0,r|0)}r=m;RI(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=oO(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function kO(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;vK(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[23162]|0)==-1)){c[ba>>2]=92648;c[ba+4>>2]=210;c[ba+8>>2]=0;kJ(92648,ba,211)}ba=(c[92652>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=xc(4)|0;Ga=Fa;jT(Ga);Ha=108216;Ia=128;Fd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=xc(4)|0;Ga=Fa;jT(Ga);Ha=108216;Ia=128;Fd(Fa|0,Ha|0,Ia|0)}Ia=ca;RI(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];bO(ra,d,y,x,g,h,j,91856,91876|0);c[Da>>2]=c[ra>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];bO(ga,d,L,K,g,h,j,91744,91776|0);c[Da>>2]=c[ga>>2];break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];bO(ja,d,J,I,g,h,j,91776,91808|0);c[Da>>2]=c[ja>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=oO(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=Wd[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(PM(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];lO(0,e,C,h,Ia);break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];mO(d,j+8|0,e,B,h,Ia);break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=Wd[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(PM(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=oO(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=oO(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 99:{Da=d+8|0;ca=Wd[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ka=ca+4|0;La=ca+4|0;Ma=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ka=Fa;La=Fa;Ma=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];bO(da,d,O,N,g,h,j,La,Ka+(Ma<<2)|0);c[Da>>2]=c[da>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];nO(0,e,m,h,Ia);break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];bO(ua,d,v,u,g,h,j,91880,91912|0);c[Da>>2]=c[ua>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=oO(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=oO(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=oO(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=oO(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;ca=Wd[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Na=ca+4|0;Oa=ca+4|0;Pa=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];bO(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[za>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=oO(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=oO(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ee[ca&63](b,d,s,r,g,h,j);i=l;return};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=oO(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];bO(oa,d,A,z,g,h,j,91808,91852|0);c[Da>>2]=c[oa>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function lO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!($d[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){Wd[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=Wd[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=Wd[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function mO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=Wd[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=PM(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function nO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=Wd[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=Wd[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!(($d[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){Wd[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=Wd[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=Wd[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function oO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=Wd[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=Wd[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=Wd[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!($d[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=($d[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){Wd[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=Wd[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=Wd[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!($d[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=(($d[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){Wd[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=Wd[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=Wd[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function pO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);if((f|0)==(c[23136]|0)){g=b;MT(g);i=d;return}Wb(c[e>>2]|0);g=b;MT(g);i=d;return}function qO(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);if((b|0)==(c[23136]|0)){i=d;return}Wb(c[e>>2]|0);i=d;return}function rO(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Lc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(he[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function sO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);if((f|0)==(c[23136]|0)){g=b;MT(g);i=d;return}Wb(c[e>>2]|0);g=b;MT(g);i=d;return}function tO(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);if((b|0)==(c[23136]|0)){i=d;return}Wb(c[e>>2]|0);i=d;return}function uO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;vO(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=he[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function vO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Lc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Ec(c[g>>2]|0)|0;g=HS(d,m,n,l)|0;if((f|0)!=0){Ec(f|0)|0}if((g|0)==-1){rP(93536)}else{c[e>>2]=d+(g<<2);i=j;return}}function wO(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function xO(a){a=a|0;i=i;return}function yO(a){a=a|0;i=i;return 127}function zO(a){a=a|0;i=i;return 127}function AO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function BO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function CO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function DO(a,b){a=a|0;b=b|0;b=i;vJ(a,1,45);i=b;return}function EO(a){a=a|0;i=i;return 0}function FO(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function GO(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function HO(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function IO(a){a=a|0;i=i;return}function JO(a){a=a|0;i=i;return 127}function KO(a){a=a|0;i=i;return 127}function LO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function MO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function NO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function OO(a,b){a=a|0;b=b|0;b=i;vJ(a,1,45);i=b;return}function PO(a){a=a|0;i=i;return 0}function QO(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function RO(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function SO(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function TO(a){a=a|0;i=i;return}function UO(a){a=a|0;i=i;return 2147483647}function VO(a){a=a|0;i=i;return 2147483647}function WO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function XO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function YO(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function ZO(a,b){a=a|0;b=b|0;b=i;aK(a,1,45);i=b;return}function _O(a){a=a|0;i=i;return 0}function $O(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function aP(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function bP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function cP(a){a=a|0;i=i;return}function dP(a){a=a|0;i=i;return 2147483647}function eP(a){a=a|0;i=i;return 2147483647}function fP(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function gP(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function hP(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function iP(a,b){a=a|0;b=b|0;b=i;aK(a,1,45);i=b;return}function jP(a){a=a|0;i=i;return 0}function kP(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function lP(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function mP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function nP(a){a=a|0;i=i;return}function oP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=212;y=o+100|0;vK(r,h);o=r;z=c[o>>2]|0;if(!((c[23164]|0)==-1)){c[n>>2]=92656;c[n+4>>2]=210;c[n+8>>2]=0;kJ(92656,n,211)}n=(c[92660>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=qP(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;qe[c[(c[z>>2]|0)+32>>2]&63](E,92272,92282|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=ET(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}RT()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[92272+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((kd(p|0,92288,m|0)|0)!=1){t=xc(8)|0;XI(t,92296);Fd(t|0,89648,43)}if((F|0)==0){break}FT(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;RI(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Td[c[x>>2]&255](o);i=d;return}function pP(a){a=a|0;i=i;return}function qP(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;uP(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=212;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((Wd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((Wd[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(Wd[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(Wd[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}RJ(A,ea);X=26;break};case 0:{X=26;break};case 4:{da=D;W=R;ba=r;fa=Q;ga=0;ha=T;c:while(1){ia=c[h>>2]|0;do{if((ia|0)==0){ja=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){ja=ia;break}if((Wd[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;ja=0;break}else{ja=c[h>>2]|0;break}}}while(0);ia=(ja|0)==0;ka=c[e>>2]|0;do{if((ka|0)==0){X=173}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){if(ia){break}else{break c}}if((Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[e>>2]=0;X=173;break}else{if(ia){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(ia){break}}ka=c[h>>2]|0;la=c[ka+12>>2]|0;if((la|0)==(c[ka+16>>2]|0)){ma=(Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)&255}else{ma=a[la]|0}do{if(ma<<24>>24>-1){if((b[(c[f>>2]|0)+(ma<<24>>24<<1)>>1]&2048)==0){X=189;break}la=c[o>>2]|0;if((la|0)==(da|0)){ka=(c[P>>2]|0)!=212;na=c[t>>2]|0;oa=da-na|0;pa=oa>>>0<2147483647?oa<<1:-1;qa=HT(ka?na:0,pa)|0;if((qa|0)==0){X=182;break a}do{if(ka){c[t>>2]=qa;ra=qa}else{na=c[t>>2]|0;c[t>>2]=qa;if((na|0)==0){ra=qa;break}Td[c[P>>2]&255](na);ra=c[t>>2]|0}}while(0);c[P>>2]=187;qa=ra+oa|0;c[o>>2]=qa;sa=qa;ta=(c[t>>2]|0)+pa|0}else{sa=la;ta=da}c[o>>2]=sa+1;a[sa]=ma;ua=ta;va=W;wa=ba;xa=fa;ya=ga+1|0;za=ha}else{X=189}}while(0);if((X|0)==189){X=0;ia=a[w]|0;if((ia&1)==0){Aa=(ia&255)>>>1}else{Aa=c[n>>2]|0}if((Aa|0)==0|(ga|0)==0){break}if(!(ma<<24>>24==(a[v]|0))){break}if((ba|0)==(fa|0)){ia=ba-W|0;qa=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==212){Ba=0}else{Ba=W}ka=HT(Ba,qa)|0;if((ka|0)==0){X=198;break a}Ca=ka;Da=ka+(ia>>2<<2)|0;Ea=ka+(qa>>>2<<2)|0;Fa=187}else{Ca=W;Da=ba;Ea=fa;Fa=ha}c[Da>>2]=ga;ua=da;va=Ca;wa=Da+4|0;xa=Ea;ya=0;za=Fa}qa=c[h>>2]|0;ka=qa+12|0;ia=c[ka>>2]|0;if((ia|0)==(c[qa+16>>2]|0)){Wd[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}else{c[ka>>2]=ia+1;da=ua;W=va;ba=wa;fa=xa;ga=ya;ha=za;continue}}if((W|0)==(ba|0)|(ga|0)==0){Ga=W;Ha=ba;Ia=fa;Ja=ha}else{if((ba|0)==(fa|0)){ia=ba-W|0;ka=ia>>>0<2147483647?ia<<1:-1;if((ha|0)==212){Ka=0}else{Ka=W}qa=HT(Ka,ka)|0;if((qa|0)==0){X=209;break a}La=qa;Ma=qa+(ia>>2<<2)|0;Na=qa+(ka>>>2<<2)|0;Oa=187}else{La=W;Ma=ba;Na=fa;Oa=ha}c[Ma>>2]=ga;Ga=La;Ha=Ma+4|0;Ia=Na;Ja=Oa}if((c[B>>2]|0)>0){ka=c[h>>2]|0;do{if((ka|0)==0){Pa=0}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){Pa=ka;break}if((Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[h>>2]=0;Pa=0;break}else{Pa=c[h>>2]|0;break}}}while(0);ka=(Pa|0)==0;ga=c[e>>2]|0;do{if((ga|0)==0){X=223}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){if(ka){Qa=ga;break}else{X=229;break a}}if((Wd[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[e>>2]=0;X=223;break}else{if(ka){Qa=ga;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ka){X=229;break a}else{Qa=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Ra=(Wd[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Ra=a[ha]|0}if(!(Ra<<24>>24==(a[u]|0))){X=229;break a}ha=c[h>>2]|0;ga=ha+12|0;fa=c[ga>>2]|0;if((fa|0)==(c[ha+16>>2]|0)){Wd[c[(c[ha>>2]|0)+40>>2]&127](ha)|0;Sa=Qa;Ta=Qa;Ua=da}else{c[ga>>2]=fa+1;Sa=Qa;Ta=Qa;Ua=da}while(1){fa=c[h>>2]|0;do{if((fa|0)==0){Va=0}else{if((c[fa+12>>2]|0)!=(c[fa+16>>2]|0)){Va=fa;break}if((Wd[c[(c[fa>>2]|0)+36>>2]&127](fa)|0)==-1){c[h>>2]=0;Va=0;break}else{Va=c[h>>2]|0;break}}}while(0);fa=(Va|0)==0;do{if((Ta|0)==0){Wa=Sa;X=243}else{if((c[Ta+12>>2]|0)!=(c[Ta+16>>2]|0)){if(fa){Xa=Sa;Ya=Ta;break}else{X=250;break a}}if((Wd[c[(c[Ta>>2]|0)+36>>2]&127](Ta)|0)==-1){c[e>>2]=0;Wa=0;X=243;break}else{if(fa^(Sa|0)==0){Xa=Sa;Ya=Sa;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(fa){X=250;break a}else{Xa=Wa;Ya=0}}ga=c[h>>2]|0;ha=c[ga+12>>2]|0;if((ha|0)==(c[ga+16>>2]|0)){Za=(Wd[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{Za=a[ha]|0}if(!(Za<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Za<<24>>24<<1)>>1]&2048)==0){X=250;break a}ha=c[o>>2]|0;if((ha|0)==(Ua|0)){ga=(c[P>>2]|0)!=212;ba=c[t>>2]|0;W=Ua-ba|0;qa=W>>>0<2147483647?W<<1:-1;ia=HT(ga?ba:0,qa)|0;if((ia|0)==0){X=253;break a}do{if(ga){c[t>>2]=ia;_a=ia}else{ba=c[t>>2]|0;c[t>>2]=ia;if((ba|0)==0){_a=ia;break}Td[c[P>>2]&255](ba);_a=c[t>>2]|0}}while(0);c[P>>2]=187;ia=_a+W|0;c[o>>2]=ia;$a=ia;ab=(c[t>>2]|0)+qa|0}else{$a=ha;ab=Ua}ia=c[h>>2]|0;ga=c[ia+12>>2]|0;if((ga|0)==(c[ia+16>>2]|0)){fa=(Wd[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;bb=fa;cb=c[o>>2]|0}else{bb=a[ga]|0;cb=$a}c[o>>2]=cb+1;a[cb]=bb;ga=(c[B>>2]|0)+ -1|0;c[B>>2]=ga;fa=c[h>>2]|0;ia=fa+12|0;ba=c[ia>>2]|0;if((ba|0)==(c[fa+16>>2]|0)){Wd[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[ia>>2]=ba+1}if((ga|0)>0){Sa=Xa;Ta=Ya;Ua=ab}else{db=ab;break}}}else{db=da}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{eb=db;fb=Ga;gb=Ha;hb=Ia;ib=S;jb=Ja}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){kb=(a[O]|0)!=0}else{kb=0}if(!(I|kb)){eb=D;fb=R;gb=r;hb=Q;ib=0;jb=T;break b}}ka=a[x]|0;ga=(ka&1)==0;ba=ga?j:c[J>>2]|0;d:do{if((p|0)==0){lb=Y;mb=Y;nb=ka;ob=ba}else{if((d[s+(p+ -1)|0]|0)>=2){lb=Y;mb=Y;nb=ka;ob=ba;break}ia=ba+(ga?(ka&255)>>>1:c[K>>2]|0)|0;fa=ba;while(1){if((fa|0)==(ia|0)){pb=ia;break}na=a[fa]|0;if(!(na<<24>>24>-1)){pb=fa;break}if((b[(c[f>>2]|0)+(na<<24>>24<<1)>>1]&8192)==0){pb=fa;break}else{fa=fa+1|0}}fa=pb-ba|0;ia=a[A]|0;ha=(ia&1)==0;if(ha){qb=(ia&255)>>>1}else{qb=c[N>>2]|0}if(fa>>>0>qb>>>0){lb=Y;mb=Y;nb=ka;ob=ba;break}if(ha){ha=(ia&255)>>>1;rb=A+1+(ha-fa)|0;sb=L;tb=ha}else{ha=c[M>>2]|0;ia=c[N>>2]|0;rb=ha+(ia-fa)|0;sb=ha;tb=ia}ia=sb+tb|0;if((rb|0)==(ia|0)){lb=Y;mb=Y;nb=ka;ob=pb;break}else{ub=ba;vb=rb}while(1){if((a[vb]|0)!=(a[ub]|0)){lb=Y;mb=Y;nb=ka;ob=ba;break d}ha=vb+1|0;if((ha|0)==(ia|0)){lb=Y;mb=Y;nb=ka;ob=pb;break}else{ub=ub+1|0;vb=ha}}}}while(0);e:while(1){if((nb&1)==0){wb=j;xb=(nb&255)>>>1}else{wb=c[J>>2]|0;xb=c[K>>2]|0}if((ob|0)==(wb+xb|0)){break}ka=c[h>>2]|0;do{if((ka|0)==0){yb=0}else{if((c[ka+12>>2]|0)!=(c[ka+16>>2]|0)){yb=ka;break}if((Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)==-1){c[h>>2]=0;yb=0;break}else{yb=c[h>>2]|0;break}}}while(0);ka=(yb|0)==0;do{if((mb|0)==0){zb=lb;X=147}else{if((c[mb+12>>2]|0)!=(c[mb+16>>2]|0)){if(ka){Ab=lb;Bb=mb;break}else{break e}}if((Wd[c[(c[mb>>2]|0)+36>>2]&127](mb)|0)==-1){c[e>>2]=0;zb=0;X=147;break}else{if(ka^(lb|0)==0){Ab=lb;Bb=lb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ka){break}else{Ab=zb;Bb=0}}ba=c[h>>2]|0;ga=c[ba+12>>2]|0;if((ga|0)==(c[ba+16>>2]|0)){Cb=(Wd[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{Cb=a[ga]|0}if(!(Cb<<24>>24==(a[ob]|0))){break}ga=c[h>>2]|0;ba=ga+12|0;da=c[ba>>2]|0;if((da|0)==(c[ga+16>>2]|0)){Wd[c[(c[ga>>2]|0)+40>>2]&127](ga)|0}else{c[ba>>2]=da+1}lb=Ab;mb=Bb;nb=a[x]|0;ob=ob+1|0}if(!I){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}da=a[x]|0;if((da&1)==0){Db=j;Eb=(da&255)>>>1}else{Db=c[J>>2]|0;Eb=c[K>>2]|0}if((ob|0)==(Db+Eb|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}else{X=162;break a}break};case 3:{da=a[y]|0;ba=(da&1)==0;if(ba){Fb=(da&255)>>>1}else{Fb=c[G>>2]|0}ga=a[z]|0;ia=(ga&1)==0;if(ia){Gb=(ga&255)>>>1}else{Gb=c[g>>2]|0}if((Fb|0)==(0-Gb|0)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}if(ba){Hb=(da&255)>>>1}else{Hb=c[G>>2]|0}do{if((Hb|0)!=0){if(ia){Ib=(ga&255)>>>1}else{Ib=c[g>>2]|0}if((Ib|0)==0){break}ha=c[h>>2]|0;fa=c[ha+12>>2]|0;qa=c[ha+16>>2]|0;if((fa|0)==(qa|0)){W=(Wd[c[(c[ha>>2]|0)+36>>2]&127](ha)|0)&255;na=c[h>>2]|0;Jb=W;Kb=c[na+16>>2]|0;Lb=c[na+12>>2]|0;Mb=na;Nb=a[y]|0}else{Jb=a[fa]|0;Kb=qa;Lb=fa;Mb=ha;Nb=da}ha=Mb+12|0;fa=(Lb|0)==(Kb|0);if(Jb<<24>>24==(a[(Nb&1)==0?F:c[H>>2]|0]|0)){if(fa){Wd[c[(c[Mb>>2]|0)+40>>2]&127](Mb)|0}else{c[ha>>2]=Lb+1}ha=a[y]|0;if((ha&1)==0){Ob=(ha&255)>>>1}else{Ob=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Ob>>>0>1?y:S;jb=T;break b}if(fa){Pb=(Wd[c[(c[Mb>>2]|0)+36>>2]&127](Mb)|0)&255}else{Pb=a[Lb]|0}if(!(Pb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}fa=c[h>>2]|0;ha=fa+12|0;qa=c[ha>>2]|0;if((qa|0)==(c[fa+16>>2]|0)){Wd[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[ha>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Qb=(qa&255)>>>1}else{Qb=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Qb>>>0>1?z:S;jb=T;break b}}while(0);if(ba){Rb=(da&255)>>>1}else{Rb=c[G>>2]|0}ia=c[h>>2]|0;qa=c[ia+12>>2]|0;ha=(qa|0)==(c[ia+16>>2]|0);if((Rb|0)==0){if(ha){fa=(Wd[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Sb=fa;Tb=a[z]|0}else{Sb=a[qa]|0;Tb=ga}if(!(Sb<<24>>24==(a[(Tb&1)==0?m:c[E>>2]|0]|0))){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}fa=c[h>>2]|0;na=fa+12|0;W=c[na>>2]|0;if((W|0)==(c[fa+16>>2]|0)){Wd[c[(c[fa>>2]|0)+40>>2]&127](fa)|0}else{c[na>>2]=W+1}a[l]=1;W=a[z]|0;if((W&1)==0){Ub=(W&255)>>>1}else{Ub=c[g>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Ub>>>0>1?z:S;jb=T;break b}if(ha){ha=(Wd[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Vb=ha;Wb=a[y]|0}else{Vb=a[qa]|0;Wb=da}if(!(Vb<<24>>24==(a[(Wb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break b}qa=c[h>>2]|0;ha=qa+12|0;ia=c[ha>>2]|0;if((ia|0)==(c[qa+16>>2]|0)){Wd[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ha>>2]=ia+1}ia=a[y]|0;if((ia&1)==0){Xb=(ia&255)>>>1}else{Xb=c[G>>2]|0}eb=D;fb=R;gb=r;hb=Q;ib=Xb>>>0>1?y:S;jb=T;break};default:{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((Wd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}if((Wd[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}else{ac=$b;bc=0}}ka=c[h>>2]|0;ia=c[ka+12>>2]|0;if((ia|0)==(c[ka+16>>2]|0)){cc=(Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0)&255}else{cc=a[ia]|0}if(!(cc<<24>>24>-1)){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){eb=D;fb=R;gb=r;hb=Q;ib=S;jb=T;break f}ia=c[h>>2]|0;ka=ia+12|0;ha=c[ka>>2]|0;if((ha|0)==(c[ia+16>>2]|0)){dc=(Wd[c[(c[ia>>2]|0)+40>>2]&127](ia)|0)&255}else{c[ka>>2]=ha+1;dc=a[ha]|0}RJ(A,dc);Yb=ac;Zb=bc}}}while(0);da=p+1|0;if(da>>>0<4){Q=hb;r=gb;R=fb;D=eb;p=da;S=ib;T=jb}else{Z=fb;_=gb;$=ib;aa=jb;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){RT()}else if((X|0)==198){RT()}else if((X|0)==209){RT()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==253){RT()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=Ga;gc=Ja}else if((X|0)==269){h:do{if(($|0)!=0){jb=$+1|0;ib=$+8|0;gb=$+4|0;fb=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[gb>>2]|0}if(!(fb>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((Wd[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((Wd[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(Wd[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=jb}else{kc=c[ib>>2]|0}if(!(jc<<24>>24==(a[kc+fb|0]|0))){break}p=fb+1|0;U=c[h>>2]|0;eb=U+12|0;D=c[eb>>2]|0;if((D|0)==(c[U+16>>2]|0)){Wd[c[(c[U>>2]|0)+40>>2]&127](U)|0;fb=p;continue}else{c[eb>>2]=D+1;fb=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;vP(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);zJ(A);zJ(z);zJ(y);zJ(x);zJ(w);if((fc|0)==0){i=q;return ec|0}Td[gc&255](fc);i=q;return ec|0}function rP(a){a=a|0;var b=0;b=xc(8)|0;XI(b,a);Fd(b|0,89648,43)}function sP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=212;v=n+100|0;vK(q,h);n=q;w=c[n>>2]|0;if(!((c[23164]|0)==-1)){c[m>>2]=92656;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92656,m,211)}m=(c[92660>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=xc(4)|0;z=y;jT(z);A=108216;B=128;Fd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=xc(4)|0;z=y;jT(z);A=108216;B=128;Fd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=qP(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){RJ(k,he[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=he[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);tP(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((Wd[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;RI(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Td[c[u>>2]&255](n);i=d;return}function tP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){UJ(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function uP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[23024]|0)==-1)){c[p>>2]=92096;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92096,p,211)}p=(c[92100>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}E=b;Ud[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Ud[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zJ(r);Ud[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}LJ(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zJ(s);a[f]=Wd[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=Wd[c[(c[b>>2]|0)+16>>2]&127](E)|0;Ud[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}LJ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zJ(t);Ud[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zJ(u);F=Wd[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[23008]|0)==-1)){c[o>>2]=92032;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92032,o,211)}o=(c[92036>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}J=E;Ud[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Ud[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zJ(w);Ud[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}LJ(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zJ(x);a[f]=Wd[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=Wd[c[(c[E>>2]|0)+16>>2]&127](J)|0;Ud[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}LJ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;zJ(y);Ud[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;zJ(z);F=Wd[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function vP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function wP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function xP(a){a=a|0;i=i;return}function yP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=212;y=o+400|0;vK(r,h);o=r;z=c[o>>2]|0;if(!((c[23162]|0)==-1)){c[n>>2]=92648;c[n+4>>2]=210;c[n+8>>2]=0;kJ(92648,n,211)}n=(c[92652>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=zP(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;qe[c[(c[z>>2]|0)+48>>2]&63](E,92352,92362|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=ET((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}RT()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[92352+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((kd(p|0,92288,m|0)|0)!=1){t=xc(8)|0;XI(t,92296);Fd(t|0,89648,43)}if((F|0)==0){break}FT(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=Wd[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];RI(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}Td[c[x>>2]&255](o);i=d;return}



function zP(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;CP(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=212;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=Wd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=Wd[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 3:{P=a[y]|0;R=(P&1)==0;if(R){_=(P&255)>>>1}else{_=c[D>>2]|0}$=a[z]|0;aa=($&1)==0;if(aa){ba=($&255)>>>1}else{ba=c[e>>2]|0}if((_|0)==(0-ba|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}if(R){ha=(P&255)>>>1}else{ha=c[D>>2]|0}do{if((ha|0)!=0){if(aa){ia=($&255)>>>1}else{ia=c[e>>2]|0}if((ia|0)==0){break}ja=c[g>>2]|0;ka=c[ja+12>>2]|0;if((ka|0)==(c[ja+16>>2]|0)){la=Wd[c[(c[ja>>2]|0)+36>>2]&127](ja)|0;ma=la;na=a[y]|0}else{ma=c[ka>>2]|0;na=P}ka=c[g>>2]|0;la=ka+12|0;ja=c[la>>2]|0;oa=(ja|0)==(c[ka+16>>2]|0);if((ma|0)==(c[((na&1)==0?D:c[E>>2]|0)>>2]|0)){if(oa){Wd[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=ja+4}la=a[y]|0;if((la&1)==0){pa=(la&255)>>>1}else{pa=c[D>>2]|0}ca=M;da=r;ea=L;fa=pa>>>0>1?y:N;ga=O;break b}if(oa){qa=Wd[c[(c[ka>>2]|0)+36>>2]&127](ka)|0}else{qa=c[ja>>2]|0}if((qa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ja=c[g>>2]|0;ka=ja+12|0;oa=c[ka>>2]|0;if((oa|0)==(c[ja+16>>2]|0)){Wd[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[ka>>2]=oa+4}a[k]=1;oa=a[z]|0;if((oa&1)==0){ra=(oa&255)>>>1}else{ra=c[e>>2]|0}ca=M;da=r;ea=L;fa=ra>>>0>1?z:N;ga=O;break b}}while(0);if(R){sa=(P&255)>>>1}else{sa=c[D>>2]|0}aa=c[g>>2]|0;oa=c[aa+12>>2]|0;ka=(oa|0)==(c[aa+16>>2]|0);if((sa|0)==0){if(ka){ja=Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;ta=ja;ua=a[z]|0}else{ta=c[oa>>2]|0;ua=$}if((ta|0)!=(c[((ua&1)==0?e:c[f>>2]|0)>>2]|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}ja=c[g>>2]|0;la=ja+12|0;va=c[la>>2]|0;if((va|0)==(c[ja+16>>2]|0)){Wd[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[la>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){wa=(va&255)>>>1}else{wa=c[e>>2]|0}ca=M;da=r;ea=L;fa=wa>>>0>1?z:N;ga=O;break b}if(ka){ka=Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;xa=ka;ya=a[y]|0}else{xa=c[oa>>2]|0;ya=P}if((xa|0)!=(c[((ya&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=c[g>>2]|0;ka=oa+12|0;aa=c[ka>>2]|0;if((aa|0)==(c[oa+16>>2]|0)){Wd[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[ka>>2]=aa+4}aa=a[y]|0;if((aa&1)==0){za=(aa&255)>>>1}else{za=c[D>>2]|0}ca=M;da=r;ea=L;fa=za>>>0>1?y:N;ga=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){Aa=Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Aa=c[ka>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,Aa)|0)){T=27;break a}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){Ba=Wd[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4;Ba=c[oa>>2]|0}fK(A,Ba);T=28;break};case 0:{T=28;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){Ca=(a[J]|0)!=0}else{Ca=0}if(!(F|Ca)){ca=M;da=r;ea=L;fa=0;ga=O;break b}}oa=a[x]|0;aa=(oa&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){Da=V;Ea=V;Fa=oa;Ga=aa}else{if((d[s+(o+ -1)|0]|0)<2){Ha=oa;Ia=aa}else{Da=V;Ea=V;Fa=oa;Ga=aa;break}while(1){if((Ha&1)==0){Ja=h;Ka=(Ha&255)>>>1}else{Ja=c[G>>2]|0;Ka=c[h>>2]|0}if((Ia|0)==(Ja+(Ka<<2)|0)){La=Ha;break}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[Ia>>2]|0)|0)){T=129;break}Ha=a[x]|0;Ia=Ia+4|0}if((T|0)==129){T=0;La=a[x]|0}ka=(La&1)==0;va=Ia-(ka?h:c[G>>2]|0)>>2;la=a[A]|0;ja=(la&1)==0;if(ja){Ma=(la&255)>>>1}else{Ma=c[H>>2]|0}d:do{if(!(va>>>0>Ma>>>0)){if(ja){Na=H+(((la&255)>>>1)-va<<2)|0;Oa=H;Pa=(la&255)>>>1}else{Qa=c[I>>2]|0;Ra=c[H>>2]|0;Na=Qa+(Ra-va<<2)|0;Oa=Qa;Pa=Ra}Ra=Oa+(Pa<<2)|0;if((Na|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}else{Sa=ka?h:c[G>>2]|0;Ta=Na}while(1){if((c[Ta>>2]|0)!=(c[Sa>>2]|0)){break d}Qa=Ta+4|0;if((Qa|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}Sa=Sa+4|0;Ta=Qa}}}while(0);Da=V;Ea=V;Fa=La;Ga=ka?h:c[G>>2]|0}}while(0);e:while(1){if((Fa&1)==0){Ua=h;Va=(Fa&255)>>>1}else{Ua=c[G>>2]|0;Va=c[h>>2]|0}if((Ga|0)==(Ua+(Va<<2)|0)){break}aa=c[g>>2]|0;do{if((aa|0)==0){Wa=1}else{oa=c[aa+12>>2]|0;if((oa|0)==(c[aa+16>>2]|0)){Xa=Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Xa=c[oa>>2]|0}if((Xa|0)==-1){c[g>>2]=0;Wa=1;break}else{Wa=(c[g>>2]|0)==0;break}}}while(0);do{if((Ea|0)==0){Ya=Da;T=159}else{aa=c[Ea+12>>2]|0;if((aa|0)==(c[Ea+16>>2]|0)){Za=Wd[c[(c[Ea>>2]|0)+36>>2]&127](Ea)|0}else{Za=c[aa>>2]|0}if((Za|0)==-1){c[b>>2]=0;Ya=0;T=159;break}else{if(Wa^(Da|0)==0){_a=Da;$a=Da;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Wa){break}else{_a=Ya;$a=0}}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){ab=Wd[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{ab=c[ka>>2]|0}if((ab|0)!=(c[Ga>>2]|0)){break}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){Wd[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4}Da=_a;Ea=$a;Fa=a[x]|0;Ga=Ga+4|0}if(!F){ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=a[x]|0;if((oa&1)==0){bb=h;cb=(oa&255)>>>1}else{bb=c[G>>2]|0;cb=c[h>>2]|0}if((Ga|0)==(bb+(cb<<2)|0)){ca=M;da=r;ea=L;fa=N;ga=O}else{T=174;break a}break};case 4:{oa=M;aa=r;ka=L;P=0;$=O;f:while(1){R=c[g>>2]|0;do{if((R|0)==0){db=1}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){eb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{eb=c[va>>2]|0}if((eb|0)==-1){c[g>>2]=0;db=1;break}else{db=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=188}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){fb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{fb=c[va>>2]|0}if((fb|0)==-1){c[b>>2]=0;T=188;break}else{if(db){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(db){break}}R=c[g>>2]|0;va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){gb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{gb=c[va>>2]|0}if($d[c[(c[l>>2]|0)+12>>2]&63](l,2048,gb)|0){va=c[n>>2]|0;if((va|0)==(c[q>>2]|0)){DP(m,n,q);hb=c[n>>2]|0}else{hb=va}c[n>>2]=hb+4;c[hb>>2]=gb;ib=oa;jb=aa;kb=ka;lb=P+1|0;mb=$}else{va=a[w]|0;if((va&1)==0){nb=(va&255)>>>1}else{nb=c[K>>2]|0}if((nb|0)==0|(P|0)==0){break}if((gb|0)!=(c[v>>2]|0)){break}if((aa|0)==(ka|0)){va=aa-oa|0;R=va>>>0<2147483647?va<<1:-1;if(($|0)!=212){ob=oa}else{ob=0}la=HT(ob,R)|0;if((la|0)==0){T=206;break a}pb=la;qb=la+(va>>2<<2)|0;rb=la+(R>>>2<<2)|0;sb=187}else{pb=oa;qb=aa;rb=ka;sb=$}c[qb>>2]=P;ib=pb;jb=qb+4|0;kb=rb;lb=0;mb=sb}R=c[g>>2]|0;la=R+12|0;va=c[la>>2]|0;if((va|0)==(c[R+16>>2]|0)){Wd[c[(c[R>>2]|0)+40>>2]&127](R)|0;oa=ib;aa=jb;ka=kb;P=lb;$=mb;continue}else{c[la>>2]=va+4;oa=ib;aa=jb;ka=kb;P=lb;$=mb;continue}}if((oa|0)==(aa|0)|(P|0)==0){tb=oa;ub=aa;vb=ka;wb=$}else{if((aa|0)==(ka|0)){va=aa-oa|0;la=va>>>0<2147483647?va<<1:-1;if(($|0)!=212){xb=oa}else{xb=0}R=HT(xb,la)|0;if((R|0)==0){T=217;break a}yb=R;zb=R+(va>>2<<2)|0;Ab=R+(la>>>2<<2)|0;Bb=187}else{yb=oa;zb=aa;Ab=ka;Bb=$}c[zb>>2]=P;tb=yb;ub=zb+4|0;vb=Ab;wb=Bb}la=c[B>>2]|0;if((la|0)>0){R=c[g>>2]|0;do{if((R|0)==0){Cb=1}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){Db=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Db=c[va>>2]|0}if((Db|0)==-1){c[g>>2]=0;Cb=1;break}else{Cb=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Eb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[P>>2]|0}if((Eb|0)==-1){c[b>>2]=0;T=234;break}else{if(Cb){Fb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Cb){T=240;break a}else{Fb=0}}R=c[g>>2]|0;P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Gb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[P>>2]|0}if((Gb|0)!=(c[u>>2]|0)){T=240;break a}P=c[g>>2]|0;R=P+12|0;$=c[R>>2]|0;if(($|0)==(c[P+16>>2]|0)){Wd[c[(c[P>>2]|0)+40>>2]&127](P)|0;Hb=Fb;Ib=la;Jb=Fb}else{c[R>>2]=$+4;Hb=Fb;Ib=la;Jb=Fb}while(1){$=c[g>>2]|0;do{if(($|0)==0){Kb=1}else{R=c[$+12>>2]|0;if((R|0)==(c[$+16>>2]|0)){Lb=Wd[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Lb=c[R>>2]|0}if((Lb|0)==-1){c[g>>2]=0;Kb=1;break}else{Kb=(c[g>>2]|0)==0;break}}}while(0);do{if((Jb|0)==0){Mb=Hb;T=257}else{$=c[Jb+12>>2]|0;if(($|0)==(c[Jb+16>>2]|0)){Nb=Wd[c[(c[Jb>>2]|0)+36>>2]&127](Jb)|0}else{Nb=c[$>>2]|0}if((Nb|0)==-1){c[b>>2]=0;Mb=0;T=257;break}else{if(Kb^(Hb|0)==0){Ob=Hb;Pb=Hb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Kb){T=263;break a}else{Ob=Mb;Pb=0}}$=c[g>>2]|0;R=c[$+12>>2]|0;if((R|0)==(c[$+16>>2]|0)){Qb=Wd[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Qb=c[R>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,2048,Qb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){DP(m,n,q)}R=c[g>>2]|0;$=c[R+12>>2]|0;if(($|0)==(c[R+16>>2]|0)){Rb=Wd[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Rb=c[$>>2]|0}$=c[n>>2]|0;c[n>>2]=$+4;c[$>>2]=Rb;$=Ib+ -1|0;c[B>>2]=$;R=c[g>>2]|0;P=R+12|0;ka=c[P>>2]|0;if((ka|0)==(c[R+16>>2]|0)){Wd[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=ka+4}if(($|0)>0){Hb=Ob;Ib=$;Jb=Pb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ca=tb;da=ub;ea=vb;fa=N;ga=wb}break};default:{ca=M;da=r;ea=L;fa=N;ga=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){la=c[g>>2]|0;do{if((la|0)==0){Ub=1}else{$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){Vb=Wd[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Vb=c[$>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{la=c[Tb+12>>2]|0;if((la|0)==(c[Tb+16>>2]|0)){Xb=Wd[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[la>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ca=M;da=r;ea=L;fa=N;ga=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ca=M;da=r;ea=L;fa=N;ga=O;break g}else{Yb=Wb;Zb=0}}la=c[g>>2]|0;$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){_b=Wd[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{_b=c[$>>2]|0}if(!($d[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ca=M;da=r;ea=L;fa=N;ga=O;break g}$=c[g>>2]|0;la=$+12|0;ka=c[la>>2]|0;if((ka|0)==(c[$+16>>2]|0)){$b=Wd[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[la>>2]=ka+4;$b=c[ka>>2]|0}fK(A,$b);Sb=Yb;Tb=Zb}}}while(0);ka=o+1|0;if(ka>>>0<4){L=ea;r=da;M=ca;o=ka;N=fa;O=ga}else{W=ca;X=da;Y=fa;Z=ga;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){RT()}else if((T|0)==217){RT()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==276){i:do{if((Y|0)!=0){ga=Y+4|0;fa=Y+8|0;da=1;j:while(1){ca=a[Y]|0;if((ca&1)==0){dc=(ca&255)>>>1}else{dc=c[ga>>2]|0}if(!(da>>>0<dc>>>0)){break i}ca=c[g>>2]|0;do{if((ca|0)==0){ec=1}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){fc=Wd[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ca=c[b>>2]|0;do{if((ca|0)==0){T=295}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){gc=Wd[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ca=c[g>>2]|0;N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){hc=Wd[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ga}else{ic=c[fa>>2]|0}if((hc|0)!=(c[ic+(da<<2)>>2]|0)){break}N=da+1|0;ca=c[g>>2]|0;o=ca+12|0;r=c[o>>2]|0;if((r|0)==(c[ca+16>>2]|0)){Wd[c[(c[ca>>2]|0)+40>>2]&127](ca)|0;da=N;continue}else{c[o>>2]=r+4;da=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;vP(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);bK(A);bK(z);bK(y);bK(x);zJ(w);if((bc|0)==0){i=p;return ac|0}Td[cc&255](bc);i=p;return ac|0}function AP(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=212;v=n+400|0;vK(q,h);n=q;w=c[n>>2]|0;if(!((c[23162]|0)==-1)){c[m>>2]=92648;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92648,m,211)}m=(c[92652>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=xc(4)|0;z=y;jT(z);A=108216;B=128;Fd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=xc(4)|0;z=y;jT(z);A=108216;B=128;Fd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=zP(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){fK(k,he[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=he[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);BP(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=Wd[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=Wd[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];RI(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}Td[c[u>>2]&255](n);i=d;return}function BP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){hK(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function CP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[23056]|0)==-1)){c[p>>2]=92224;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92224,p,211)}p=(c[92228>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=xc(4)|0;C=B;jT(C);D=108216;E=128;Fd(B|0,D|0,E|0)}E=b;Ud[c[(c[b>>2]|0)+44>>2]&63](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;Ud[c[(c[b>>2]|0)+32>>2]&63](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;bK(r);Ud[c[(c[b>>2]|0)+28>>2]&63](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}eK(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;bK(s);c[f>>2]=Wd[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=Wd[c[(c[b>>2]|0)+16>>2]&127](E)|0;Ud[c[(c[b>>2]|0)+20>>2]&63](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}LJ(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;zJ(t);Ud[c[(c[b>>2]|0)+24>>2]&63](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}eK(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;bK(u);F=Wd[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[23040]|0)==-1)){c[o>>2]=92160;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92160,o,211)}o=(c[92164>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=xc(4)|0;H=G;jT(H);I=108216;J=128;Fd(G|0,I|0,J|0)}J=E;Ud[c[(c[E>>2]|0)+44>>2]&63](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;Ud[c[(c[E>>2]|0)+32>>2]&63](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;bK(w);Ud[c[(c[E>>2]|0)+28>>2]&63](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}eK(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;bK(x);c[f>>2]=Wd[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=Wd[c[(c[E>>2]|0)+16>>2]&127](J)|0;Ud[c[(c[E>>2]|0)+20>>2]&63](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}LJ(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;zJ(y);Ud[c[(c[E>>2]|0)+24>>2]&63](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}eK(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;bK(z);F=Wd[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function DP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=212;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=HT(m,l)|0;m=a;if((a|0)==0){RT()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}Td[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=187;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function EP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function FP(a){a=a|0;i=i;return}function GP(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Fc(G|0,100,92408,o|0)|0;do{if(s>>>0>99){do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=yN(r,o,92408,n)|0;o=c[r>>2]|0;if((o|0)==0){RT()}H=ET(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}RT()}else{I=0;J=0;K=q;L=s}}while(0);vK(t,g);s=t;q=c[s>>2]|0;if(!((c[23164]|0)==-1)){c[p>>2]=92656;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92656,p,211)}p=(c[92660>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;qe[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;HP(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=ET(V)|0;if((T|0)!=0){W=T;X=T;break}RT()}else{W=0;X=t}}while(0);IP(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];ZF(b,m,X,e,D,g,j);if((W|0)!=0){FT(W)}zJ(A);zJ(z);zJ(y);RI(c[s>>2]|0)|0;if((J|0)!=0){FT(J)}if((I|0)==0){i=d;return}FT(I);i=d;return}function HP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[23024]|0)==-1)){c[p>>2]=92096;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92096,p,211)}p=(c[92100>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=xc(4)|0;I=H;jT(I);J=108216;K=128;Fd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=xc(4)|0;I=H;jT(I);J=108216;K=128;Fd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Ud[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Ud[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;zJ(s)}else{Ud[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Ud[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zJ(v)}a[g]=Wd[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=Wd[c[(c[e>>2]|0)+16>>2]&127](K)|0;Ud[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zJ(w);Ud[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}LJ(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zJ(x);L=Wd[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[23008]|0)==-1)){c[o>>2]=92032;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92032,o,211)}o=(c[92036>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Ud[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Ud[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;zJ(A)}else{Ud[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Ud[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}LJ(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;zJ(D)}a[g]=Wd[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=Wd[c[(c[G>>2]|0)+16>>2]&127](P)|0;Ud[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;zJ(E);Ud[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}LJ(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;zJ(F);L=Wd[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function IP(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 2:{I=a[q]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[A>>2]|0}if((K|0)==0|x){L=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;L=H;break};case 4:{P=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){I=J;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){S=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){S=I;break b}if(Q>>>0<j>>>0){I=Q}else{S=Q;break}}}else{S=J}}while(0);I=S;if(B){if(S>>>0>J>>>0){Q=J+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=P;T=S;U=s;while(1){V=T+ -1|0;W=a[V]|0;c[f>>2]=R+1;a[R]=W;W=U+ -1|0;X=(W|0)>0;if(!(V>>>0>J>>>0&X)){break}R=c[f>>2]|0;U=W;T=V}T=S+I|0;if(X){Y=T;Z=Q;_=32}else{$=0;aa=T;ba=Q}}else{Y=S;Z=s;_=32}if((_|0)==32){_=0;$=he[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;aa=Y;ba=Z}T=c[f>>2]|0;c[f>>2]=T+1;if((ba|0)>0){U=T;R=ba;while(1){a[U]=$;V=R+ -1|0;W=c[f>>2]|0;c[f>>2]=W+1;if((V|0)>0){R=V;U=W}else{ca=W;break}}}else{ca=T}a[ca]=n;da=aa}else{da=S}if((da|0)==(J|0)){U=he[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=U}else{U=a[p]|0;R=(U&1)==0;if(R){ea=(U&255)>>>1}else{ea=c[E>>2]|0}if((ea|0)==0){fa=da;ga=-1;ha=0;ia=0}else{if(R){ja=C}else{ja=c[D>>2]|0}fa=da;ga=a[ja]|0;ha=0;ia=0}while(1){do{if((ia|0)==(ga|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ha+1|0;U=a[p]|0;Q=(U&1)==0;if(Q){ka=(U&255)>>>1}else{ka=c[E>>2]|0}if(!(R>>>0<ka>>>0)){la=ga;ma=R;na=0;break}if(Q){oa=C}else{oa=c[D>>2]|0}if((a[oa+R|0]|0)==127){la=-1;ma=R;na=0;break}if(Q){pa=C}else{pa=c[D>>2]|0}la=a[pa+R|0]|0;ma=R;na=0}else{la=ga;ma=ha;na=ia}}while(0);R=fa+ -1|0;Q=a[R]|0;U=c[f>>2]|0;c[f>>2]=U+1;a[U]=Q;if((R|0)==(J|0)){break}else{fa=R;ga=la;ha=ma;ia=na+1|0}}}T=c[f>>2]|0;if((P|0)==(T|0)){L=J;break a}R=T+ -1|0;if(R>>>0>P>>>0){qa=P;ra=R}else{L=J;break a}while(1){R=a[qa]|0;a[qa]=a[ra]|0;a[ra]=R;R=qa+1|0;T=ra+ -1|0;if(R>>>0<T>>>0){ra=T;qa=R}else{L=J;break}}break};case 3:{J=a[r]|0;P=(J&1)==0;if(P){sa=(J&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){L=H;break a}if(P){ta=u}else{ta=c[v>>2]|0}P=a[ta]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;L=H;break};case 1:{c[e>>2]=c[f>>2];P=he[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};default:{L=H}}}while(0);P=h+1|0;if(P>>>0<4){H=L;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function JP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;vK(m,g);z=m;A=c[z>>2]|0;if(!((c[23164]|0)==-1)){c[l>>2]=92656;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92656,l,211)}l=(c[92660>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(he[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;HP(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=ET(P)|0;if((N|0)!=0){Q=N;R=N;break}RT()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}IP(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];ZF(b,k,R,e,w,g,h);if((Q|0)==0){zJ(t);zJ(s);zJ(r);U=c[z>>2]|0;V=U;W=V;X=RI(W)|0;i=d;return}FT(Q);zJ(t);zJ(s);zJ(r);U=c[z>>2]|0;V=U;W=V;X=RI(W)|0;i=d;return}function KP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function LP(a){a=a|0;i=i;return}function MP(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Fc(G|0,100,92408,o|0)|0;do{if(s>>>0>99){do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);o=c[23136]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=yN(r,o,92408,n)|0;o=c[r>>2]|0;if((o|0)==0){RT()}H=ET(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}RT()}else{J=0;K=0;L=q;M=s}}while(0);vK(t,g);s=t;q=c[s>>2]|0;if(!((c[23162]|0)==-1)){c[p>>2]=92648;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92648,p,211)}p=(c[92652>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=xc(4)|0;O=N;jT(O);P=108216;Q=128;Fd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=xc(4)|0;O=N;jT(O);P=108216;Q=128;Fd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;qe[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;NP(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=ET(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}RT()}else{X=0;Y=t}}while(0);OP(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];HN(b,m,Y,e,D,g,j);if((X|0)!=0){FT(X)}bK(A);bK(z);zJ(y);RI(c[s>>2]|0)|0;if((K|0)!=0){FT(K)}if((J|0)==0){i=d;return}FT(J);i=d;return}function NP(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[23056]|0)==-1)){c[p>>2]=92224;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92224,p,211)}p=(c[92228>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=xc(4)|0;I=H;jT(I);J=108216;K=128;Fd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=xc(4)|0;I=H;jT(I);J=108216;K=128;Fd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){Ud[c[J+44>>2]&63](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;Ud[c[(c[e>>2]|0)+32>>2]&63](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;bK(s)}else{Ud[c[J+40>>2]&63](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;Ud[c[(c[e>>2]|0)+28>>2]&63](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;bK(v)}c[g>>2]=Wd[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=Wd[c[(c[e>>2]|0)+16>>2]&127](K)|0;Ud[c[(c[e>>2]|0)+20>>2]&63](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;zJ(w);Ud[c[(c[e>>2]|0)+24>>2]&63](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}eK(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;bK(x);L=Wd[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[23040]|0)==-1)){c[o>>2]=92160;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92160,o,211)}o=(c[92164>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=xc(4)|0;N=M;jT(N);O=108216;P=128;Fd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){Ud[c[O+44>>2]&63](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;Ud[c[(c[G>>2]|0)+32>>2]&63](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;bK(A)}else{Ud[c[O+40>>2]&63](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;Ud[c[(c[G>>2]|0)+28>>2]&63](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}eK(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;bK(D)}c[g>>2]=Wd[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=Wd[c[(c[G>>2]|0)+16>>2]&127](P)|0;Ud[c[(c[G>>2]|0)+20>>2]&63](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}LJ(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;zJ(E);Ud[c[(c[G>>2]|0)+24>>2]&63](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}eK(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;bK(F);L=Wd[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function OP(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){G=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 1:{c[d>>2]=c[e>>2];L=he[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){D=M;while(1){N=D+4|0;if(!($d[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){Q=D;break b}if(N>>>0<h>>>0){D=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;E=Q;D=r;while(1){R=E+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=D+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){D=T;E=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=he[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((W|0)>0){_=D;$=E;aa=W}else{Y=E;Z=V;break}while(1){c[$>>2]=K;D=aa+ -1|0;if((D|0)>0){aa=D;$=_;_=_+4|0}else{break}}c[e>>2]=E+(W+1<<2);Y=E+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=he[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(D>>>0<la>>>0)){ma=N;na=fa;oa=D;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+D|0]|0)==127){ma=N;na=-1;oa=D;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+D|0]|0;oa=D;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;E=c[K>>2]|0;D=ma+4|0;c[e>>2]=D;c[ma>>2]=E;if((K|0)==(M|0)){ca=D;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){G=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{G=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;D=ta+ -4|0;if(K>>>0<D>>>0){ta=D;sa=K}else{G=M;break}}break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function PP(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;vK(m,g);z=m;A=c[z>>2]|0;if(!((c[23162]|0)==-1)){c[l>>2]=92648;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92648,l,211)}l=(c[92652>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=xc(4)|0;D=C;jT(D);E=108216;F=128;Fd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(he[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;NP(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=ET(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}RT()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}OP(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];HN(b,k,R,e,w,g,h);if((Q|0)==0){bK(t);bK(s);zJ(r);U=c[z>>2]|0;V=U;W=V;X=RI(W)|0;i=d;return}FT(Q);bK(t);bK(s);zJ(r);U=c[z>>2]|0;V=U;W=V;X=RI(W)|0;i=d;return}function QP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function RP(a){a=a|0;i=i;return}function SP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=nc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function TP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{RJ(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=ld(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=gU(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{zJ(j);i=d;return}do{RJ(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);zJ(j);i=d;return}function UP(a,b){a=a|0;b=b|0;a=i;Cb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function VP(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function WP(a){a=a|0;i=i;return}function XP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=nc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function YP(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=94312;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=94312|0;while(1){c[m>>2]=y;A=(ke[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{RJ(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}rP(93536)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=ld(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=94416;D=gU(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){zJ(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=94416|0;while(1){c[q>>2]=o;h=(ke[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{fK(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){rP(93536)}else if((E|0)==25){zJ(r);i=d;return}}function ZP(a,b){a=a|0;b=b|0;a=i;Cb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function _P(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=92744;e=b+8|0;b=c[e>>2]|0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);if((b|0)==(c[23136]|0)){i=d;return}Wb(c[e>>2]|0);i=d;return}function $P(a){a=a|0;a=xc(8)|0;SI(a,92536);c[a>>2]=89504;Fd(a|0,89544,41)}function aQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=92576;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);rJ(b+144|0,92560,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[97468>>2]=0;c[24366]=91056;if(!((c[22770]|0)==-1)){c[G>>2]=91080;c[G+4>>2]=210;c[G+8>>2]=0;kJ(91080,G,211)}bQ(b,97464,(c[91084>>2]|0)+ -1|0);c[97460>>2]=0;c[24364]=91096;if(!((c[22780]|0)==-1)){c[F>>2]=91120;c[F+4>>2]=210;c[F+8>>2]=0;kJ(91120,F,211)}bQ(b,97456,(c[91124>>2]|0)+ -1|0);c[97444>>2]=0;c[24360]=92672;c[97448>>2]=0;a[97452|0]=0;F=c[(rc()|0)>>2]|0;c[97448>>2]=F;if(!((c[23164]|0)==-1)){c[E>>2]=92656;c[E+4>>2]=210;c[E+8>>2]=0;kJ(92656,E,211)}bQ(b,97440,(c[92660>>2]|0)+ -1|0);c[97436>>2]=0;c[24358]=93632;if(!((c[23162]|0)==-1)){c[D>>2]=92648;c[D+4>>2]=210;c[D+8>>2]=0;kJ(92648,D,211)}bQ(b,97432,(c[92652>>2]|0)+ -1|0);c[97428>>2]=0;c[24356]=93848;if(!((c[23180]|0)==-1)){c[C>>2]=92720;c[C+4>>2]=210;c[C+8>>2]=0;kJ(92720,C,211)}bQ(b,97424,(c[92724>>2]|0)+ -1|0);c[97412>>2]=0;c[24352]=92744;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);c[97416>>2]=c[23136];if(!((c[23182]|0)==-1)){c[B>>2]=92728;c[B+4>>2]=210;c[B+8>>2]=0;kJ(92728,B,211)}bQ(b,97408,(c[92732>>2]|0)+ -1|0);c[97404>>2]=0;c[24350]=94072;if(!((c[23196]|0)==-1)){c[A>>2]=92784;c[A+4>>2]=210;c[A+8>>2]=0;kJ(92784,A,211)}bQ(b,97400,(c[92788>>2]|0)+ -1|0);c[97396>>2]=0;c[24348]=94192;if(!((c[23198]|0)==-1)){c[z>>2]=92792;c[z+4>>2]=210;c[z+8>>2]=0;kJ(92792,z,211)}bQ(b,97392,(c[92796>>2]|0)+ -1|0);c[97372>>2]=0;c[24342]=92824;a[97376|0]=46;a[97377|0]=44;z=97380|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[23200]|0)==-1)){c[y>>2]=92800;c[y+4>>2]=210;c[y+8>>2]=0;kJ(92800,y,211)}bQ(b,97368,(c[92804>>2]|0)+ -1|0);c[97340>>2]=0;c[24334]=92864;c[97344>>2]=46;c[97348>>2]=44;y=97352|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[23202]|0)==-1)){c[x>>2]=92808;c[x+4>>2]=210;c[x+8>>2]=0;kJ(92808,x,211)}bQ(b,97336,(c[92812>>2]|0)+ -1|0);c[97332>>2]=0;c[24332]=91136;if(!((c[22798]|0)==-1)){c[w>>2]=91192;c[w+4>>2]=210;c[w+8>>2]=0;kJ(91192,w,211)}bQ(b,97328,(c[91196>>2]|0)+ -1|0);c[97324>>2]=0;c[24330]=91256;if(!((c[22828]|0)==-1)){c[v>>2]=91312;c[v+4>>2]=210;c[v+8>>2]=0;kJ(91312,v,211)}bQ(b,97320,(c[91316>>2]|0)+ -1|0);c[97316>>2]=0;c[24328]=91328;if(!((c[22844]|0)==-1)){c[u>>2]=91376;c[u+4>>2]=210;c[u+8>>2]=0;kJ(91376,u,211)}bQ(b,97312,(c[91380>>2]|0)+ -1|0);c[97308>>2]=0;c[24326]=91392;if(!((c[22860]|0)==-1)){c[t>>2]=91440;c[t+4>>2]=210;c[t+8>>2]=0;kJ(91440,t,211)}bQ(b,97304,(c[91444>>2]|0)+ -1|0);c[97300>>2]=0;c[24324]=91984;if(!((c[23008]|0)==-1)){c[s>>2]=92032;c[s+4>>2]=210;c[s+8>>2]=0;kJ(92032,s,211)}bQ(b,97296,(c[92036>>2]|0)+ -1|0);c[97292>>2]=0;c[24322]=92048;if(!((c[23024]|0)==-1)){c[r>>2]=92096;c[r+4>>2]=210;c[r+8>>2]=0;kJ(92096,r,211)}bQ(b,97288,(c[92100>>2]|0)+ -1|0);c[97284>>2]=0;c[24320]=92112;if(!((c[23040]|0)==-1)){c[q>>2]=92160;c[q+4>>2]=210;c[q+8>>2]=0;kJ(92160,q,211)}bQ(b,97280,(c[92164>>2]|0)+ -1|0);c[97276>>2]=0;c[24318]=92176;if(!((c[23056]|0)==-1)){c[p>>2]=92224;c[p+4>>2]=210;c[p+8>>2]=0;kJ(92224,p,211)}bQ(b,97272,(c[92228>>2]|0)+ -1|0);c[97268>>2]=0;c[24316]=92240;if(!((c[23066]|0)==-1)){c[o>>2]=92264;c[o+4>>2]=210;c[o+8>>2]=0;kJ(92264,o,211)}bQ(b,97264,(c[92268>>2]|0)+ -1|0);c[97260>>2]=0;c[24314]=92320;if(!((c[23086]|0)==-1)){c[n>>2]=92344;c[n+4>>2]=210;c[n+8>>2]=0;kJ(92344,n,211)}bQ(b,97256,(c[92348>>2]|0)+ -1|0);c[97252>>2]=0;c[24312]=92376;if(!((c[23100]|0)==-1)){c[m>>2]=92400;c[m+4>>2]=210;c[m+8>>2]=0;kJ(92400,m,211)}bQ(b,97248,(c[92404>>2]|0)+ -1|0);c[97244>>2]=0;c[24310]=92424;if(!((c[23112]|0)==-1)){c[l>>2]=92448;c[l+4>>2]=210;c[l+8>>2]=0;kJ(92448,l,211)}bQ(b,97240,(c[92452>>2]|0)+ -1|0);c[97228>>2]=0;c[24306]=91472;c[97232>>2]=91520;if(!((c[22888]|0)==-1)){c[k>>2]=91552;c[k+4>>2]=210;c[k+8>>2]=0;kJ(91552,k,211)}bQ(b,97224,(c[91556>>2]|0)+ -1|0);c[97212>>2]=0;c[24302]=91624;c[97216>>2]=91672;if(!((c[22926]|0)==-1)){c[j>>2]=91704;c[j+4>>2]=210;c[j+8>>2]=0;kJ(91704,j,211)}bQ(b,97208,(c[91708>>2]|0)+ -1|0);c[97196>>2]=0;c[24298]=93568;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);c[97200>>2]=c[23136];c[24298]=91920;if(!((c[22984]|0)==-1)){c[h>>2]=91936;c[h+4>>2]=210;c[h+8>>2]=0;kJ(91936,h,211)}bQ(b,97192,(c[91940>>2]|0)+ -1|0);c[97180>>2]=0;c[24294]=93568;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);c[97184>>2]=c[23136];c[24294]=91952;if(!((c[22992]|0)==-1)){c[g>>2]=91968;c[g+4>>2]=210;c[g+8>>2]=0;kJ(91968,g,211)}bQ(b,97176,(c[91972>>2]|0)+ -1|0);c[97172>>2]=0;c[24292]=92464;if(!((c[23122]|0)==-1)){c[f>>2]=92488;c[f+4>>2]=210;c[f+8>>2]=0;kJ(92488,f,211)}bQ(b,97168,(c[92492>>2]|0)+ -1|0);c[97164>>2]=0;c[24290]=92504;if((c[23132]|0)==-1){N=92528;O=92528;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=97160;bQ(b,T,S);i=e;return}c[H>>2]=92528;c[H+4>>2]=210;c[H+8>>2]=0;kJ(92528,H,211);N=92528;O=92528;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=97160;bQ(b,T,S);i=e;return}function bQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;QI(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){gS(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}RI(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function cQ(a){a=a|0;var b=0;b=i;dQ(a);MT(a);i=b;return}function dQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=92576;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{RI(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}zJ(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{MT(h);i=d;return}}function eQ(){var b=0,d=0,e=0,f=0;b=i;if((a[92632]|0)!=0){d=92624;e=c[23156]|0;i=b;return e|0}if((Va(92632)|0)==0){d=92624;e=c[23156]|0;i=b;return e|0}do{if((a[92608]|0)==0){if((Va(92608)|0)==0){break}aQ(97e3,1);c[23148]=97e3;c[23150]=92592;Nb(92608)}}while(0);f=c[c[23150]>>2]|0;c[23154]=f;QI(f);c[23156]=92616;Nb(92632);d=92624;e=c[23156]|0;i=b;return e|0}function fQ(a){a=a|0;var b=0,d=0;b=i;d=c[(eQ()|0)>>2]|0;c[a>>2]=d;QI(d);i=b;return}function gQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;QI(e);i=d;return}function hQ(a){a=a|0;var b=0;b=i;RI(c[a>>2]|0)|0;i=b;return}function iQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=210;c[e+8>>2]=0;kJ(a,e,211)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function jQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=210;c[e+8>>2]=0;kJ(a,e,211)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=xc(4)|0;h=g;jT(h);j=108216;k=128;Fd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=xc(4)|0;h=g;jT(h);j=108216;k=128;Fd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function kQ(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function lQ(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}Td[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function mQ(a){a=a|0;var b=0;b=c[23160]|0;c[23160]=1+b;c[a+4>>2]=b+1;i=i;return}function nQ(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function oQ(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(rc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function pQ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(rc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function qQ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(rc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function rQ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(rc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function sQ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(pd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function tQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(pd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function uQ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function vQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(ud()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function wQ(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function xQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function yQ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function zQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function AQ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=92672;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}NT(e)}}while(0);MT(b);i=d;return}function BQ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=92672;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}NT(e);i=d;return}function CQ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(pd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function DQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(pd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function EQ(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(ud()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function FQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(ud()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function GQ(a,b){a=a|0;b=b|0;i=i;return b|0}function HQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function IQ(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function JQ(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function KQ(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function LQ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function MQ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function NQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function OQ(a){a=a|0;i=i;return 1}function PQ(a){a=a|0;i=i;return 1}function QQ(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function RQ(a){a=a|0;i=i;return 1}function SQ(a){a=a|0;var b=0;b=i;_P(a);MT(a);i=b;return}function TQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Ec(c[s>>2]|0)|0;A=KS(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Ec(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Ec(c[s>>2]|0)|0;A=JS(u,0,d)|0;if((z|0)!=0){Ec(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Ec(c[s>>2]|0)|0;G=JS(u,r,n)|0;if((z|0)!=0){Ec(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function UQ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Ec(c[r>>2]|0)|0;y=GS(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Ec(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Ec(c[r>>2]|0)|0;F=FS(x,y,1,d)|0;if((w|0)!=0){Ec(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Ec(c[r>>2]|0)|0;y=FS(q,v,z-v|0,n)|0;if((w|0)!=0){Ec(w|0)|0}if((y|0)==-2){B=16;break}else if((y|0)==0){I=v+1|0}else if((y|0)==-1){B=15;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function VQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Ec(c[b+8>>2]|0)|0;b=JS(e,0,d)|0;if((j|0)!=0){Ec(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function WQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Ec(c[d>>2]|0)|0;e=IS(0,0,4)|0;if((a|0)!=0){Ec(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Ec(a|0)|0;if((g|0)==0){f=0;break}Ec(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function XQ(a){a=a|0;i=i;return 0}function YQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Ec(c[k>>2]|0)|0;n=ES(a,j-a|0,b)|0;if((m|0)!=0){Ec(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function ZQ(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Ec(d|0)|0;if((a|0)==0){e=4;break}Ec(a|0)|0;e=4}}while(0);i=b;return e|0}function _Q(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function $Q(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=aR(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function aR(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function bR(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=cR(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function cR(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function dR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function eR(a){a=a|0;i=i;return 0}function fR(a){a=a|0;i=i;return 0}function gR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=hR(c,d,e,1114111,0)|0;i=b;return a|0}function hR(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function iR(a){a=a|0;i=i;return 4}function jR(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function kR(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=lR(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function lR(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function mR(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=nR(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function nR(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function oR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function pR(a){a=a|0;i=i;return 0}function qR(a){a=a|0;i=i;return 0}function rR(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=sR(c,d,e,1114111,0)|0;i=b;return a|0}function sR(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function tR(a){a=a|0;i=i;return 4}function uR(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function vR(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function wR(a){a=a|0;var b=0;b=i;c[a>>2]=92824;zJ(a+12|0);MT(a);i=b;return}function xR(a){a=a|0;var b=0;b=i;c[a>>2]=92824;zJ(a+12|0);i=b;return}function yR(a){a=a|0;var b=0;b=i;c[a>>2]=92864;zJ(a+16|0);MT(a);i=b;return}function zR(a){a=a|0;var b=0;b=i;c[a>>2]=92864;zJ(a+16|0);i=b;return}function AR(b){b=b|0;i=i;return a[b+8|0]|0}function BR(a){a=a|0;i=i;return c[a+8>>2]|0}function CR(b){b=b|0;i=i;return a[b+9|0]|0}function DR(a){a=a|0;i=i;return c[a+12>>2]|0}function ER(a,b){a=a|0;b=b|0;var c=0;c=i;pJ(a,b+12|0);i=c;return}function FR(a,b){a=a|0;b=b|0;var c=0;c=i;pJ(a,b+16|0);i=c;return}function GR(a,b){a=a|0;b=b|0;b=i;rJ(a,92896,4);i=b;return}function HR(a,b){a=a|0;b=b|0;b=i;$J(a,92904,eT(92904)|0);i=b;return}function IR(a,b){a=a|0;b=b|0;b=i;rJ(a,92928,5);i=b;return}function JR(a,b){a=a|0;b=b|0;b=i;$J(a,92936,eT(92936)|0);i=b;return}function KR(b){b=b|0;var d=0,e=0;b=i;if((a[92968]|0)!=0){d=92960;e=c[23240]|0;i=b;return e|0}if((Va(92968)|0)==0){d=92960;e=c[23240]|0;i=b;return e|0}do{if((a[100168]|0)==0){if((Va(100168)|0)==0){break}kU(1e5,0,168)|0;Ld(213,0,q|0)|0;Nb(100168)}}while(0);CJ(1e5,100176)|0;CJ(100012|0,100184)|0;CJ(100024|0,100192)|0;CJ(100036|0,100200)|0;CJ(100048|0,100216)|0;CJ(100060|0,100232)|0;CJ(100072|0,100240)|0;CJ(100084|0,100256)|0;CJ(100096|0,100264)|0;CJ(100108|0,100272)|0;CJ(100120|0,100280)|0;CJ(100132|0,100288)|0;CJ(100144|0,100296)|0;CJ(100156|0,100304)|0;c[23240]=1e5;Nb(92968);d=92960;e=c[23240]|0;i=b;return e|0}function LR(b){b=b|0;var d=0,e=0;b=i;if((a[92984]|0)!=0){d=92976;e=c[23244]|0;i=b;return e|0}if((Va(92984)|0)==0){d=92976;e=c[23244]|0;i=b;return e|0}do{if((a[99632]|0)==0){if((Va(99632)|0)==0){break}kU(99464,0,168)|0;Ld(214,0,q|0)|0;Nb(99632)}}while(0);cK(99464,99640)|0;cK(99476|0,99672)|0;cK(99488|0,99704)|0;cK(99500|0,99736)|0;cK(99512|0,99776)|0;cK(99524|0,99816)|0;cK(99536|0,99848)|0;cK(99548|0,99888)|0;cK(99560|0,99904)|0;cK(99572|0,99920)|0;cK(99584|0,99936)|0;cK(99596|0,99952)|0;cK(99608|0,99968)|0;cK(99620|0,99984)|0;c[23244]=99464;Nb(92984);d=92976;e=c[23244]|0;i=b;return e|0}function MR(b){b=b|0;var d=0,e=0;b=i;if((a[93e3]|0)!=0){d=92992;e=c[23248]|0;i=b;return e|0}if((Va(93e3)|0)==0){d=92992;e=c[23248]|0;i=b;return e|0}do{if((a[99240]|0)==0){if((Va(99240)|0)==0){break}kU(98952,0,288)|0;Ld(215,0,q|0)|0;Nb(99240)}}while(0);CJ(98952,99248)|0;CJ(98964|0,99256)|0;CJ(98976|0,99272)|0;CJ(98988|0,99280)|0;CJ(99e3|0,99288)|0;CJ(99012|0,99296)|0;CJ(99024|0,99304)|0;CJ(99036|0,99312)|0;CJ(99048|0,99320)|0;CJ(99060|0,99336)|0;CJ(99072|0,99344)|0;CJ(99084|0,99360)|0;CJ(99096|0,99376)|0;CJ(99108|0,99384)|0;CJ(99120|0,99392)|0;CJ(99132|0,99400)|0;CJ(99144|0,99288)|0;CJ(99156|0,99408)|0;CJ(99168|0,99416)|0;CJ(99180|0,99424)|0;CJ(99192|0,99432)|0;CJ(99204|0,99440)|0;CJ(99216|0,99448)|0;CJ(99228|0,99456)|0;c[23248]=98952;Nb(93e3);d=92992;e=c[23248]|0;i=b;return e|0}function NR(b){b=b|0;var d=0,e=0;b=i;if((a[93016]|0)!=0){d=93008;e=c[23252]|0;i=b;return e|0}if((Va(93016)|0)==0){d=93008;e=c[23252]|0;i=b;return e|0}do{if((a[98400]|0)==0){if((Va(98400)|0)==0){break}kU(98112,0,288)|0;Ld(216,0,q|0)|0;Nb(98400)}}while(0);cK(98112,98408)|0;cK(98124|0,98440)|0;cK(98136|0,98480)|0;cK(98148|0,98504)|0;cK(98160|0,98824)|0;cK(98172|0,98528)|0;cK(98184|0,98552)|0;cK(98196|0,98576)|0;cK(98208|0,98608)|0;cK(98220|0,98648)|0;cK(98232|0,98680)|0;cK(98244|0,98720)|0;cK(98256|0,98760)|0;cK(98268|0,98776)|0;cK(98280|0,98792)|0;cK(98292|0,98808)|0;cK(98304|0,98824)|0;cK(98316|0,98840)|0;cK(98328|0,98856)|0;cK(98340|0,98872)|0;cK(98352|0,98888)|0;cK(98364|0,98904)|0;cK(98376|0,98920)|0;cK(98388|0,98936)|0;c[23252]=98112;Nb(93016);d=93008;e=c[23252]|0;i=b;return e|0}function OR(b){b=b|0;var d=0,e=0;b=i;if((a[93032]|0)!=0){d=93024;e=c[23256]|0;i=b;return e|0}if((Va(93032)|0)==0){d=93024;e=c[23256]|0;i=b;return e|0}do{if((a[98088]|0)==0){if((Va(98088)|0)==0){break}kU(97800,0,288)|0;Ld(217,0,q|0)|0;Nb(98088)}}while(0);CJ(97800,98096)|0;CJ(97812|0,98104)|0;c[23256]=97800;Nb(93032);d=93024;e=c[23256]|0;i=b;return e|0}function PR(b){b=b|0;var d=0,e=0;b=i;if((a[93048]|0)!=0){d=93040;e=c[23260]|0;i=b;return e|0}if((Va(93048)|0)==0){d=93040;e=c[23260]|0;i=b;return e|0}do{if((a[97760]|0)==0){if((Va(97760)|0)==0){break}kU(97472,0,288)|0;Ld(218,0,q|0)|0;Nb(97760)}}while(0);cK(97472,97768)|0;cK(97484|0,97784)|0;c[23260]=97472;Nb(93048);d=93040;e=c[23260]|0;i=b;return e|0}function QR(b){b=b|0;var c=0;b=i;if((a[93072]|0)!=0){c=93056;i=b;return c|0}if((Va(93072)|0)==0){c=93056;i=b;return c|0}rJ(93056,93080,8);Ld(219,93056,q|0)|0;Nb(93072);c=93056;i=b;return c|0}function RR(b){b=b|0;var c=0;b=i;if((a[93112]|0)!=0){c=93096;i=b;return c|0}if((Va(93112)|0)==0){c=93096;i=b;return c|0}$J(93096,93120,eT(93120)|0);Ld(220,93096,q|0)|0;Nb(93112);c=93096;i=b;return c|0}function SR(b){b=b|0;var c=0;b=i;if((a[93176]|0)!=0){c=93160;i=b;return c|0}if((Va(93176)|0)==0){c=93160;i=b;return c|0}rJ(93160,93184,8);Ld(219,93160,q|0)|0;Nb(93176);c=93160;i=b;return c|0}function TR(b){b=b|0;var c=0;b=i;if((a[93216]|0)!=0){c=93200;i=b;return c|0}if((Va(93216)|0)==0){c=93200;i=b;return c|0}$J(93200,93224,eT(93224)|0);Ld(220,93200,q|0)|0;Nb(93216);c=93200;i=b;return c|0}function UR(b){b=b|0;var c=0;b=i;if((a[93280]|0)!=0){c=93264;i=b;return c|0}if((Va(93280)|0)==0){c=93264;i=b;return c|0}rJ(93264,93288,20);Ld(219,93264,q|0)|0;Nb(93280);c=93264;i=b;return c|0}function VR(b){b=b|0;var c=0;b=i;if((a[93328]|0)!=0){c=93312;i=b;return c|0}if((Va(93328)|0)==0){c=93312;i=b;return c|0}$J(93312,93336,eT(93336)|0);Ld(220,93312,q|0)|0;Nb(93328);c=93312;i=b;return c|0}function WR(b){b=b|0;var c=0;b=i;if((a[93440]|0)!=0){c=93424;i=b;return c|0}if((Va(93440)|0)==0){c=93424;i=b;return c|0}rJ(93424,93448,11);Ld(219,93424,q|0)|0;Nb(93440);c=93424;i=b;return c|0}function XR(b){b=b|0;var c=0;b=i;if((a[93480]|0)!=0){c=93464;i=b;return c|0}if((Va(93480)|0)==0){c=93464;i=b;return c|0}$J(93464,93488,eT(93488)|0);Ld(220,93464,q|0)|0;Nb(93480);c=93464;i=b;return c|0}function YR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Gc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);l=+aU(b,g,c[23136]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function ZR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Gc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);l=+aU(b,g,c[23136]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function _R(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Gc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);l=+aU(b,g,c[23136]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function $R(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;do{if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0}else{if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;break}l=Gc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);n=hb(b|0,h|0,f|0,c[23136]|0)|0;o=c[l>>2]|0;if((o|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;break}if((o|0)!=34){j=n;k=J;break}c[e>>2]=4;j=-1;k=-1}}while(0);J=k;i=g;return j|0}function aS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Gc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);m=hb(b|0,h|0,f|0,c[23136]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function bS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Gc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);m=hb(b|0,h|0,f|0,c[23136]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function cS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Gc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);m=hb(b|0,h|0,f|0,c[23136]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function dS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Gc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);n=zc(b|0,h|0,f|0,c[23136]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function eS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Gc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[92552]|0)==0){if((Va(92552)|0)==0){break}c[23136]=Tb(2147483647,92560,0)|0;Nb(92552)}}while(0);m=zc(b|0,h|0,f|0,c[23136]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function fS(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;Td[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;Td[h&255](a);i=b;return}}function gS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){$P(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=KT(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;iU(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{MT(h);i=e;return}}function hS(a){a=a|0;a=i;bK(97748|0);bK(97736|0);bK(97724|0);bK(97712|0);bK(97700|0);bK(97688|0);bK(97676|0);bK(97664|0);bK(97652|0);bK(97640|0);bK(97628|0);bK(97616|0);bK(97604|0);bK(97592|0);bK(97580|0);bK(97568|0);bK(97556|0);bK(97544|0);bK(97532|0);bK(97520|0);bK(97508|0);bK(97496|0);bK(97484|0);bK(97472);i=a;return}function iS(a){a=a|0;a=i;zJ(98076|0);zJ(98064|0);zJ(98052|0);zJ(98040|0);zJ(98028|0);zJ(98016|0);zJ(98004|0);zJ(97992|0);zJ(97980|0);zJ(97968|0);zJ(97956|0);zJ(97944|0);zJ(97932|0);zJ(97920|0);zJ(97908|0);zJ(97896|0);zJ(97884|0);zJ(97872|0);zJ(97860|0);zJ(97848|0);zJ(97836|0);zJ(97824|0);zJ(97812|0);zJ(97800);i=a;return}



function vn(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 5:{break};case 6:{j=5;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function wn(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function xn(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{break a}}}i=c;return a-b|0}function yn(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function zn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function An(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Kl(c)|0;g=f;i=b;return g|0}function Bn(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function Cn(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;break};case 5:{a=a+2|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Dn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function En(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Fn(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Gn(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13072+(((d[14352+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Hn(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13072+(((d[14352+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function In(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Jn(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13072+(((d[12816+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Kn(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[13072+(((d[12816+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Ln(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Mn(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Nn(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function On(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Qn(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((he[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((he[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((he[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Pn(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((he[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((he[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((he[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Qn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Rn(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Rn(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Sn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=Tn(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=Un(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Wn(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Vn(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 11:{m=97;break b;break};case 29:{m=33;break b;break};case 17:{break b;break};case 10:case 9:case 21:{m=73;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}n=b;if((he[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=n+3|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((he[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}p=b;if((he[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=p+4|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}q=b;if((he[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}r=b;if((he[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=r+2|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}s=b;if((he[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=s+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{break};case 11:{m=97;break c;break};case 17:{break c;break};case 7:{m=88;break d;break};case 29:{m=76;break d;break};case 5:{m=78;break d;break};case 24:case 22:{m=77;break d;break};case 6:{m=83;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((he[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Xn(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Tn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 6:{if((e-b|0)<3){m=13;break b}n=b;if((he[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}o=b;if((he[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=o+4|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((he[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Un(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[15768+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Vn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((he[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((he[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((he[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{o=24;break b;break};case 15:{o=68;break b;break};case 5:{if((e-b|0)<2){o=27;break b}p=b;if((he[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((he[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((he[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Yn(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 7:{if((e-b|0)<4){o=57;break c}s=b;if((he[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}t=b;if((he[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=t+2|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((he[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Yn(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Wn(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 23:{a=a+1|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((he[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((he[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((he[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Xn(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(he[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 14:{break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(he[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=n+2;continue a;break};case 29:{l=26;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(he[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=o+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(he[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=p+3;continue a;break};default:{l=43;break a}}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}q=b;if(!((q|0)==9|(q|0)==10|(q|0)==21)){l=48;break a}}break};case 29:{l=4;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}q=(he[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!q){l=19;break a}c[j>>2]=r+4;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}q=(he[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!q){l=9;break a}c[j>>2]=s+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}q=t;if(!((q|0)==9|(q|0)==10|(q|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}q=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((q|0)==(t|0)){break}switch(q|0){case 3:{u=On(k,(c[j>>2]|0)+1|0,e,j)|0;if((u|0)<=0){l=77;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}q=(he[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(q){l=73;break a}c[j>>2]=v+4;continue c;break};case 2:{l=80;break a;break};case 8:case 1:case 0:{l=75;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}q=(he[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(q){l=68;break a}c[j>>2]=w+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}q=(he[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(q){l=63;break a}c[j>>2]=x+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{l=101;break d;break};case 6:{l=96;break d;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 29:{l=89;break a;break};case 17:{l=107;break a;break};case 5:{l=91;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}q=(he[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!q){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}q=(he[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!q){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}q=(he[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!q){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((u|0)==0){c[f>>2]=c[j>>2]}B=u;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Yn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Zn(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((he[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((he[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((he[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function _n(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Tn(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function $n(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((he[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((he[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 29:{l=24;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((he[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((he[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function ao(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function bo(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function co(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function eo(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=qe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){q=a[b+73|0]|0;if((q|0)==0|(q|0)==4|(q|0)==5|(q|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=qe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=qe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=qe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function fo(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((ho(go(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((ho(go(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=go(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((ho(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=go(k,a,b)|0;n=h;}while((ho(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=go(k,a,b)|0;while(1){if((ho(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=go(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=go(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function go(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Qd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function ho(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function io(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function jo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((qe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,19512)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 12:{c[h>>2]=14;j=1;break};case 13:{c[h>>2]=14;j=56;break};case 15:{c[h>>2]=14;j=0;break};default:{k=10}}}while(0);if((k|0)==10){j=no(h,a)|0}i=g;return j|0}function ko(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 15:{k=0;break};default:{k=mo(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=no(h,a)|0}i=g;return k|0}function lo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((qe[c[e+28>>2]&63](e,b,d,19496)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((qe[c[e+28>>2]&63](e,b,d,19504)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=no(h,a)|0;l=k;i=g;return l|0}function mo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 16:{if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19272)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19280)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19288)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,19296)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};default:{}}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function no(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function oo(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function po(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=no(e,a)|0}i=f;return g|0}function qo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=no(e,a)|0}i=f;return g|0}function ro(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=no(e,a)|0}i=f;return g|0}function so(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=no(e,a)|0}i=f;return g|0}function to(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=no(e,a)|0}i=f;return g|0}function uo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==11){g=55}else{g=no(e,a)|0}i=f;return g|0}function vo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((qe[c[e+28>>2]&63](e,b,d,19312)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b,d,19320)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function wo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=no(e,a)|0}i=f;return g|0}function xo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=no(e,a)|0}i=f;return g|0}function yo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=no(e,a)|0}i=f;return g|0}function zo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=no(e,a)|0;h=g;i=f;return h|0}return 0}function Ao(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((qe[c[e+28>>2]&63](e,b,d,19328)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b,d,19336)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function Bo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 30:{c[h>>2]=40;j=53;break};case 32:{c[h>>2]=40;j=54;break};case 15:{j=39;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 20:{if((qe[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,19344)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 31:{c[h>>2]=40;j=52;break};case 41:case 18:{c[h>>2]=40;j=51;break};default:{k=10}}}while(0);if((k|0)==10){j=no(h,a)|0}i=g;return j|0}function Co(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else{g=no(e,a)|0}i=f;return g|0}function Do(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 32:{c[e>>2]=40;g=54;break};case 30:{c[e>>2]=40;g=53;break};case 15:{g=39;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 31:{c[e>>2]=40;g=52;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};default:{g=no(e,a)|0}}i=f;return g|0}function Eo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=no(e,a)|0;h=g;i=f;return h|0}}return 0}function Fo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=no(e,a)|0}i=f;return g|0}function Go(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else{g=no(e,a)|0}i=f;return g|0}function Ho(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=no(e,a)|0}i=f;return g|0}function Io(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((qe[k&63](l,m,n,c[19352+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((qe[k&63](l,m,n,19296)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}}while(0);p=no(h,a)|0;q=p;i=g;return q|0}function Jo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19456)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19464)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,19480)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function Ko(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=no(e,a)|0}i=f;return g|0}function Lo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=no(e,a)|0}i=f;return g|0}function Mo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==15){g=33}else{g=no(e,a)|0}i=f;return g|0}function No(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=no(e,a)|0}i=f;return g|0}function Oo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=no(e,a)|0}i=f;return g|0}function Po(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=no(e,a)|0}i=f;return g|0}function Qo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=no(e,a)|0}i=f;return g|0}function Ro(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((qe[c[e+28>>2]&63](e,b,d,19312)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b,d,19320)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function So(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=no(e,a)|0}i=f;return g|0}function To(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=no(e,a)|0}i=f;return g|0}function Uo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((qe[c[b+28>>2]&63](b,d,e,19488)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function Vo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=no(e,a)|0}i=f;return g|0}function Wo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((qe[c[e+28>>2]&63](e,b,d,19312)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b,d,19320)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function Xo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=no(e,a)|0}i=f;return g|0}function Yo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=no(e,a)|0}i=f;return g|0}function Zo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=no(e,a)|0;h=g;i=f;return h|0}return 0}function _o(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=no(e,a)|0;h=g;i=f;return h|0}return 0}function $o(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=no(e,a)|0}i=f;return g|0}function ap(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 15:{j=0;break};case 11:{j=55;break};case 13:{j=56;break};case 16:{if((qe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,19512)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=no(h,a)|0}i=g;return j|0}function bp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=no(e,a)|0}i=f;return g|0}function cp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((qe[c[e+28>>2]&63](e,b,d,19312)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((qe[c[e+28>>2]&63](e,b,d,19320)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=no(h,a)|0;k=j;i=g;return k|0}function dp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=no(e,a)|0}i=f;return g|0}function ep(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=no(e,a)|0}i=f;return g|0}function fp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else{g=no(e,a)|0}i=f;return g|0}function gp(){i=i;return}function hp(){i=i;return}function ip(){var a=0;a=i;Sa(19520,0)|0;i=a;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;kc(19528,29,1,e|0)|0;hd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;kc(19560,54,1,g|0)|0;hd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;kc(19616,47,1,a|0)|0;hd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;jd(k|0,19664,d|0)|0;hd(k|0)|0;f=0;i=b;return f|0}function kp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a>>2]|0;f=c[e>>2]|0;g=(b|0)>1;a:do{if(g){h=1;while(1){j=h+1|0;if((c[c[a+(h<<2)>>2]>>2]|0)!=(f|0)){break}if((j|0)<(b|0)){h=j}else{break a}}_a(19728,19792,103,19816)}}while(0);if((f|0)<=0){i=d;return}h=c[e+4>>2]|0;e=0;b:while(1){j=c[h+(e<<2)>>2]|0;if(g){k=1;while(1){l=k+1|0;if((j|0)!=(c[(c[(c[a+(k<<2)>>2]|0)+4>>2]|0)+(e<<2)>>2]|0)){m=10;break b}if((l|0)<(b|0)){k=l}else{break}}}k=e+1|0;if((k|0)<(f|0)){e=k}else{m=12;break}}if((m|0)==10){_a(19848,19792,109,19816)}else if((m|0)==12){i=d;return}}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function mp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Zp(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function np(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Zp(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function op(a,b){a=a|0;b=b|0;var d=0;d=i;if((jp(a)|0)==0){_a(19920,19792,347,19944)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);_a(19976,19792,348,19944);return 0}function pp(){var a=0,b=0,d=0;a=i;b=21720|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=21832|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=21944|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[21724>>2]=1;c[21728>>2]=1;i=a;return}function qp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?22080:22096;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;jd(a|0,22056,e|0)|0;i=d;return}function rp(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=21944+(d<<2)|0;o=21832+(d<<2)|0;p=22144+(b<<2)|0;q=20424+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=22128;ac(22112,l|0)|0;s=22128}else{if((c[5426]|0)==(d|0)){if((c[o>>2]|0)>0){t=22128}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;ac(22112,m|0)|0;do{if((c[5426]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=22128;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;ac(22136,k|0)|0;c[n>>2]=b;c[5426]=d;if((c[o>>2]|0)>0){g=0;while(1){ac(22168,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;pb(e|0)|0;r=0;e=e+(w+1)|0;f=1}pb(e|0)|0;hd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function sp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[22144+(a<<2)>>2]|0;c[j>>2]=c[20424+(b<<2)>>2];c[j+4>>2]=k;ac(22176,j|0)|0;tp(e);if((g|0)==0){wd(((d|0)!=0?22216:22264)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=hd(m|0)|0;i=f;return}pb(22344)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];ac(22224,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=hd(m|0)|0;i=f;return}kc(22248,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=hd(m|0)|0;i=f;return}function tp(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==0){break}else if(b<<24>>24==38){kc(22288,5,1,e|0)|0}else if(b<<24>>24==62){kc(22304,4,1,e|0)|0}else if(b<<24>>24==60){kc(22296,4,1,e|0)|0}else{Ed(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function up(a){a=a|0;var b=0;b=21832+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function vp(a){a=a|0;var b=0;b=(a|0)==0;c[5570]=b?1:19;c[5568]=b?7:188;i=i;return}function wp(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;kc(22248,11,1,b|0)|0;hd(b|0)|0;i=a;return}function xp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[21720+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;gc(j|0,2048,e|0,h|0)|0;ce[c[5570]&31](1,a,b,j,0,d);i=g;return}function yp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[21720+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;gc(h|0,2048,d|0,g|0)|0;ce[c[5570]&31](1,a,b,h,0,0);i=f;return}function zp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[5428]|0)==0){if((c[21720+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;gc(k|0,2048,e|0,j|0)|0;ce[c[5570]&31](2,a,b,k,0,d);i=g;return}function Ap(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[5428]|0)==0){if((c[21720+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;gc(j|0,2048,d|0,h|0)|0;ce[c[5570]&31](2,a,b,j,0,0);i=f;return}function Bp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;gc(b|0,2048,d|0,g|0)|0;ce[c[5570]&31](4,2,0,b,0,0);if((a|0)==0){h=bd(c[4880]|0)|0}else{h=a}ab(c[h+76>>2]|0,1)}function Cp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;gc(g|0,2048,b|0,f|0)|0;ce[c[5570]&31](5,2,0,g,0,0);if((a|0)==0){h=bd(c[4880]|0)|0}else{h=a}ab(c[h+76>>2]|0,1)}function Dp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;gc(h|0,2048,d|0,g|0)|0;ce[c[5570]&31](5,2,0,h,0,b);if((a|0)==0){j=bd(c[4880]|0)|0}else{j=a}ab(c[j+76>>2]|0,1)}function Ep(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;Dp(a,e,22416,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;zp(26,0,e,22352,m);i=j;return+b}return 0.0}function Fp(a,b){a=a|0;b=b|0;var c=0;c=i;mp(a,b,Yp(b)|0);i=c;return}function Gp(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function Hp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;Gp(c[d+8>>2]|0,b,a);i=e;return}function Ip(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;Fp(a,b);h=g;c[g>>2]=e;Hp(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;Hp(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function Jp(a){a=a|0;i=i;return}function Kp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=ET(16)|0;Bp(0,(d|0)!=0|0,22464,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;FT(c[f>>2]|0);FT(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Mp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Bp(0,(a|0)!=0|0,22480,f);f=ET(8)|0;g=f;Bp(0,(f|0)!=0|0,22464,e);e=a+8|0;h=ET(c[e>>2]|0)|0;c[f>>2]=h;Bp(0,(h|0)!=0|0,22464,d);iU(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Np(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Bp(0,(a|0)!=0|0,22480,f);f=ET(8)|0;g=f;Bp(0,(f|0)!=0|0,22464,e);e=a+8|0;h=ET(c[e>>2]|0)|0;c[f>>2]=h;Bp(0,(h|0)!=0|0,22464,d);iU(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Op(a){a=a|0;var b=0;b=i;i=i+8|0;Bp(0,(a|0)!=0|0,22480,b);i=b;return c[a+12>>2]|0}function Pp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Bp(0,(a|0)!=0|0,22480,d);d=a;Bp(0,(c[d>>2]|0)!=0|0,22504,b);i=b;return c[c[d>>2]>>2]|0}function Qp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;FT(c[e>>2]|0);FT(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function Rp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Bp(0,(a|0)!=0|0,22480,d);d=a;Bp(0,(c[d>>2]|0)!=0|0,22520,b);i=b;return c[d>>2]|0}function Sp(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Bp(0,d&1,22552,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Tp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Bp(0,(a|0)!=0|0,22552,d);d=a;Bp(0,(c[d>>2]|0)!=0|0,22576,b);i=b;return c[d>>2]|0}function Up(){var a=0,b=0,d=0;a=i;b=ET(16)|0;c[5662]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=ET(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Vp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=_p(a)|0;mc(22656)|0;$p(d);a=c[5662]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;$b(22656)|0;kU(g|0,0,d|0)|0;i=b;return g|0}function Wp(){var a=0,b=0,d=0,e=0;a=i;b=c[5662]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;FT(c[b>>2]|0);FT(b);if((d|0)==0){break}else{b=d}}e=c[5662]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Xp(a){a=a|0;var b=0,d=0;b=i;d=Wd[c[22608>>2]&127](a<<3)|0;i=b;return d|0}function Yp(a){a=a|0;var b=0,d=0;b=i;d=Wd[c[22608>>2]&127](a<<2)|0;i=b;return d|0}function Zp(a){a=a|0;var b=0,d=0;b=i;d=Wd[c[22608>>2]&127](a<<2)|0;i=b;return d|0}function _p(a){a=a|0;i=i;return a+7&-8|0}function $p(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[5662]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=ET(16)|0;c[f+12>>2]=d;c[5662]=f;c[f+4>>2]=0;d=aq((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=ET(d)|0;c[f>>2]=a;i=b;return}function aq(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function bq(a){a=a|0;var b=0,c=0;b=i;c=gU(a|0)|0;i=b;return c|0}function cq(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;mU(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];bc(m|0,l|0,f|0)|0;f=dq(m)|0;i=e;return f|0}function dq(a){a=a|0;var b=0,c=0,d=0;b=i;c=gU(a|0)|0;d=fq(c)|0;iU(d|0,a|0,c|0)|0;i=b;return d|0}function eq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;mU(g+1|0,d|0)|0;c[f>>2]=b;bc(k|0,j|0,f|0)|0;f=dq(k)|0;i=e;return f|0}function fq(b){b=b|0;var d=0,e=0;d=i;e=Wd[c[22612>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function gq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=bq(a)|0;e=bq(b)|0;f=fq(e+d|0)|0;iU(f|0,a|0,d|0)|0;iU(f+d|0,b|0,e|0)|0;i=c;return f|0}function hq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=cU(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function iq(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 0:{f=8;break a;break};case 5:{f=1;break a;break};case 1:{f=4;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 3:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Qc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){FT(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{FT(c[(c[f>>2]|0)+(g<<4)>>2]|0);FT(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;FT(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){FT(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{FT(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}FT(d);c[g>>2]=0;i=b;return}function kq(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(gU(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function lq(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=cc(b|0,22840)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Id(c[(Gc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=md(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=ob(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=22848;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[22816+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=22872;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=22896;E=131;break}G=iq(D)|0;if((G|0)==-1){n=22928;E=131;break}D=c[q>>2]|0;H=ET(D)|0;if((ob(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=22976;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=23e3;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((cU(H,c[22792+(C<<2)>>2]|0)|0)!=0){n=23024;E=131;break}FT(H);H=23600;b:do{switch(C|0){case 4:{if(d<<24>>24==1){if((D|0)==0){n=23288;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=23344;E=131;break a}c[w>>2]=D;F=fa(I,D)|0;if((a[l]|0)==1){G=ET(F<<3)|0;c[x>>2]=G;if((ob(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=23384;E=131;break a}}else{G=ET(F<<2)|0;c[x>>2]=ET(fa(D<<3,I)|0)|0;if((ob(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=23384;E=131;break a}if((F|0)!=0){K=c[x>>2]|0;L=0;do{h[K+(L<<3)>>3]=+g[G+(L<<2)>>2];L=L+1|0;}while(L>>>0<F>>>0)}FT(G)}F=c[w>>2]|0;if(!(F>>>0>1)){M=1;E=130;break b}L=(I|0)==2;K=1;while(1){if(L){N=c[x>>2]|0;if(+h[N+(K<<3)>>3]!=+h[N+(F+K<<3)>>3]){n=23416;E=131;break a}}N=K+1|0;if(N>>>0<F>>>0){K=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}if((I|0)==0){n=23288;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=23496;E=131;break a}c[w>>2]=I;K=fa(I,D)|0;if((a[l]|0)==1){F=ET(K<<3)|0;c[x>>2]=ET(fa(D<<3,I)|0)|0;if((ob(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=23384;E=131;break a}if((D|0)!=0){L=0;do{G=c[x>>2]|0;N=0;do{h[G+((fa(I,L)|0)+N<<3)>>3]=+h[F+((fa(D,N)|0)+L<<3)>>3];N=N+1|0;}while(N>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}FT(F)}else{L=ET(K<<2)|0;c[x>>2]=ET(fa(D<<3,I)|0)|0;if((ob(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=23384;E=131;break a}if((D|0)!=0){N=0;do{G=c[x>>2]|0;P=0;do{h[G+((fa(I,N)|0)+P<<3)>>3]=+g[L+((fa(D,P)|0)+N<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}FT(L)}N=c[w>>2]|0;if(!(N>>>0>1)){M=d;E=130;break b}K=(D|0)==2;F=1;while(1){if(K){P=c[x>>2]|0;if(+h[P+(F<<3)>>3]!=+h[P+(N+F<<3)>>3]){n=23416;E=131;break a}}P=F+1|0;if(P>>>0<N>>>0){F=P}else{M=d;E=130;break}}break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;N=ET((F?D:I)<<4)|0;c[v>>2]=N;c:do{if(d<<24>>24==1){if((I|0)==0){Q=0;break}K=D+1|0;L=N;P=0;while(1){c[L+(P<<4)>>2]=ET(K)|0;if((ob(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=23224;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;G=c[v>>2]|0;c[G+(P<<4)+8>>2]=-1;c[G+(P<<4)+12>>2]=-1;kq(c[G+(P<<4)>>2]|0);G=P+1|0;if(!(G>>>0<I>>>0)){Q=I;break c}L=c[v>>2]|0;P=G}}else{Q=I}}while(0);if(!F){M=d;E=130;break b}N=fa(D,Q)|0;R=ET(N+1|0)|0;if((ob(R|0,N|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){N=Q+1|0;P=(Q|0)==0;L=0;do{K=ET(N)|0;c[(c[v>>2]|0)+(L<<4)>>2]=K;if(!P){K=0;do{G=a[R+((fa(D,K)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+K|0]=G;K=K+1|0;}while(K>>>0<Q>>>0)}a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+Q|0]=0;K=c[v>>2]|0;c[K+(L<<4)+8>>2]=-1;c[K+(L<<4)+12>>2]=-1;kq(c[K+(L<<4)>>2]|0);L=L+1|0;}while(L>>>0<D>>>0)}FT(R);M=0;E=130;break};case 3:{L=fa(I<<2,D)|0;S=ET(L)|0;if((ob(S|0,L|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}L=c[v>>2]|0;P=0;do{N=fa(D,P)|0;c[L+(P<<4)+8>>2]=(c[S+(N<<2)>>2]|0)==1;c[L+(P<<4)+12>>2]=c[S+(N+1<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}P=c[v>>2]|0;L=0;do{c[P+(L<<4)+8>>2]=(c[S+(L<<2)>>2]|0)==1;c[P+(L<<4)+12>>2]=c[S+(D+L<<2)>>2];L=L+1|0;}while(L>>>0<D>>>0)}}while(0);FT(S);Zb(c[v>>2]|0,c[u>>2]|0,16,52);M=d;E=130;break};case 2:{if(d<<24>>24==1){if((I|0)==0){O=1;E=129;break b}L=D+1|0;P=0;while(1){N=ET(L)|0;c[(c[v>>2]|0)+(P<<4)+4>>2]=N;if((ob(c[(c[v>>2]|0)+(P<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=23224;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)+4>>2]|0)+D|0]=0;N=P+1|0;if(N>>>0<I>>>0){P=N}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){O=d;E=129;break b}P=fa(D,I)|0;T=ET(P+1|0)|0;if((ob(T|0,P|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){P=I+1|0;L=(I|0)==0;N=0;do{F=ET(P)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=F;if(!L){F=0;do{K=a[T+((fa(D,F)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+F|0]=K;F=F+1|0;}while(F>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+I|0]=0;N=N+1|0;}while(N>>>0<D>>>0)}FT(T);M=0;E=130;break};case 0:{if((D|0)!=4){n=23048;E=131;break a}if((I|0)!=11){n=23088;E=131;break a}if((ob(f|0,44,1,c[m>>2]|0)|0)==1){U=0}else{n=23128;E=131;break a}while(1){N=0;do{a[k+N|0]=a[j+((N<<2)+U)|0]|0;N=N+1|0;}while(N>>>0<11);a[k+11|0]=0;if((U|0)==3){break}N=U+1|0;if(N>>>0<4){U=N}else{M=d;E=130;break b}}if((dU(t,c[5674]|0,8)|0)==0){M=1;E=130;break b}if((dU(t,c[5680]|0,9)|0)==0){M=0;E=130}else{n=23160;E=131;break a}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=23536;E=131;break a}c[z>>2]=D;c[A>>2]=ub(c[m>>2]|0)|0;c[B>>2]=GT(c[z>>2]<<1,4)|0;if((Oc(c[m>>2]|0,J|0,1)|0)==-1){n=23568;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=23536;E=131;break a}c[z>>2]=I;c[A>>2]=ub(c[m>>2]|0)|0;c[B>>2]=GT(c[z>>2]<<1,4)|0;N=fa(I,D)|0;if((a[l]|0)==1){L=ET(N<<3)|0;if((ob(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=23568;E=131;break a}if((I|0)!=0){P=D<<3;F=(D|0)==0;K=D<<3;G=0;do{V=ET(P)|0;c[(c[B>>2]|0)+(G<<2)>>2]=V;if(!F){V=L+(fa(K,G)|0)|0;iU(c[(c[B>>2]|0)+(G<<2)>>2]|0,V|0,K|0)|0}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;K=G<<1;if(G>>>0<K>>>0){F=D<<3;P=(D|0)==0;V=G;do{W=ET(F)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!P){W=c[B>>2]|0;X=c[W+(V-G<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<K>>>0)}FT(L)}else{K=ET(N<<2)|0;if((ob(K|0,J|0,1,c[m>>2]|0)|0)!=1){n=23568;E=131;break a}if((I|0)!=0){V=D<<3;G=(D|0)==0;P=0;do{F=ET(V)|0;c[(c[B>>2]|0)+(P<<2)>>2]=F;if(!G){F=c[(c[B>>2]|0)+(P<<2)>>2]|0;W=0;do{h[F+(W<<3)>>3]=+g[K+((fa(D,P)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;G=P<<1;if(P>>>0<G>>>0){V=D<<3;N=(D|0)==0;L=P;do{W=ET(V)|0;c[(c[B>>2]|0)+(L<<2)>>2]=W;if(!N){W=c[B>>2]|0;F=c[W+(L-P<<2)>>2]|0;X=c[W+(L<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[F+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}L=L+1|0;}while(L>>>0<G>>>0)}FT(K)}if((Oc(c[m>>2]|0,J|0,1)|0)==-1){n=23568;E=131;break a}else{M=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=O;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){FT(R);n=23224;i=e;return n|0}else if((E|0)==46){FT(T);n=23224;i=e;return n|0}else if((E|0)==52){FT(S);n=23256;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function mq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=qd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,52)|0;i=d;return b|0}function nq(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=23640;o=n;p=23688;q=p;r=23712;s=r;_a(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=23640;o=n;p=23688;q=p;r=23712;s=r;_a(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=ET(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Oc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((ob(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}FT(r);t=0;i=e;return t|0}else{k=ET(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Oc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((ob(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}FT(k);FT(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);FT(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function oq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=23640;r=q;s=23688;t=s;u=23736;v=u;_a(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=23640;r=q;s=23688;t=s;u=23736;v=u;_a(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Oc(o|0,t+(r<<3)|0,0)|0;f=(ob(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Oc(o|0,t+(r<<2)|0,0)|0;if((ob(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function pq(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function qq(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function rq(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function sq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+rq(b)<e){q=1;i=f;return q|0}if(+qq(b)>e){q=1;i=f;return q|0}if((nq(b,1)|0)==0){q=1;i=f;return q|0}pq(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+oq(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+oq(a,b,d,o);i=f;return q|0}if(+oq(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+oq(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function tq(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function uq(a,b){a=a|0;b=b|0;var c=0;c=i;mp(a,b,Xp(b)|0);i=c;return}function vq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Xp(np(a,b,f)|0)|0;i=e;return}function wq(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function xq(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;wq(c[d+8>>2]|0,b,a);i=e;return}function yq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0;f=i;i=i+24|0;g=f;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=ET(b<<2)|0;n=m;if((m|0)==0){_a(23792,23768,617,23800)}o=l;c[l>>2]=e;c[m>>2]=d;if((b|0)>1){e=1;do{l=c[o>>2]|0;p=c[l>>2]|0;c[o>>2]=l+4;c[m+(e<<2)>>2]=p;e=e+1|0;}while((e|0)<(b|0))}kp(n,b);n=c[d>>2]|0;if((n|0)==4){e=c[d+4>>2]|0;o=c[e>>2]|0;p=c[e+4>>2]|0;l=c[e+8>>2]|0;q=c[e+12>>2]|0;c[g>>2]=b;c[g+4>>2]=o;c[g+8>>2]=p;c[g+12>>2]=l;c[g+16>>2]=q;vq(a,5,g)}else if((n|0)==1){g=c[c[d+4>>2]>>2]|0;c[k>>2]=b;c[k+4>>2]=g;vq(a,2,k)}else if((n|0)==2){k=c[d+4>>2]|0;g=c[k>>2]|0;q=c[k+4>>2]|0;c[j>>2]=b;c[j+4>>2]=g;c[j+8>>2]=q;vq(a,3,j)}else if((n|0)==3){n=c[d+4>>2]|0;d=c[n>>2]|0;j=c[n+4>>2]|0;q=c[n+8>>2]|0;c[h>>2]=b;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=q;vq(a,4,h)}else{_a(23824,23768,639,23800)}if((b|0)<=0){FT(m);i=f;return}h=a+8|0;a=0;q=0;while(1){j=m+(q<<2)|0;d=lp(c[j>>2]|0)|0;if((d|0)>0){n=a;g=0;while(1){r=+tq(c[j>>2]|0,g);wq(c[h>>2]|0,n,r);k=g+1|0;if((k|0)<(d|0)){g=k;n=n+1|0}else{break}}s=d+a|0}else{s=a}n=q+1|0;if((n|0)<(b|0)){a=s;q=n}else{break}}FT(m);i=f;return}function zq(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;uq(a,b);j=g;c[g>>2]=e;xq(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;xq(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function Aq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=ET(20)|0;Bp(0,(f|0)!=0|0,23864,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=GT(e,b)|0;c[f>>2]=a;Bp(0,(a|0)!=0|0,23864,d);i=d;return f|0}function Bq(a){a=a|0;var b=0;b=i;FT(c[a>>2]|0);FT(a);i=b;return}function Cq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Bp(0,(c[h>>2]|0)>0|0,23880,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Bp(0,(g|0)>(b|0)|0,23904,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Bp(0,(0-f|0)<(b|0)|0,23904,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=GT(c[d>>2]<<1,c[e>>2]|0)|0;Bp(0,(f|0)!=0|0,23864,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Cq(a,j)|0;h=c[e>>2]|0;iU(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;FT(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Eq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Dq(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;iU((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Fq(a){a=a|0;i=i;return c[a+12>>2]|0}function Gq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Bp(0,(c[j>>2]|0)>0|0,23880,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Bp(0,(h|0)>(b|0)|0,23904,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Bp(0,b>>>31^1,23904,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Cq(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Hq(a){a=a|0;i=i;return c[(c[5984]|0)+(a<<2)>>2]|0}function Iq(a){a=a|0;i=i;return c[(c[5986]|0)+(a<<2)>>2]|0}function Jq(a){a=a|0;i=i;return c[(c[5988]|0)+(a<<2)>>2]|0}function Kq(a){a=a|0;i=i;return c[(c[5990]|0)+(a<<2)>>2]|0}function Lq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[5986]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[5988]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[5984]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Mq(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5992]|0;e=+Nq(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Nq(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Oq(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5994]|0;e=+Nq(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Pq(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[5996]|0;e=+Nq(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Qq(a){a=a|0;i=i;return 0}function Rq(a){a=a|0;var b=0,d=0;b=i;cb(4,(c[5998]|0)+(a<<3)|0)|0;d=(c[5984]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[5992]|0;f=e+(a<<3)|0;g=c[5996]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[5990]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[5984]|0)+(a<<2)>>2]|0);e=c[5994]|0;g=e+(a<<3)|0;Tq(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Lq(a);d=c[5992]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[5984]|0)+(a<<2)>>2]=0;i=b;return}function Tq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(Wq(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;cb(4,d|0)|0;e=c[5998]|0;f=c[5992]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Vq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=GT(a,8)|0;c[5992]=d;e=GT(a,8)|0;c[5994]=e;f=GT(a,8)|0;c[5996]=f;g=GT(a,8)|0;c[5998]=g;h=GT(a,4)|0;c[5984]=h;j=GT(a,4)|0;c[5990]=j;k=a<<2;l=ET(k)|0;c[5986]=l;m=GT(a,4)|0;c[5988]=m;kU(l|0,-1,k|0)|0;if((d|0)==0){_a(24e3,24016,393,24032)}if((e|0)==0){_a(24040,24016,394,24032)}if((f|0)==0){_a(24056,24016,395,24032)}if((g|0)==0){_a(24072,24016,396,24032)}if((h|0)==0){_a(24088,24016,397,24032)}if((l|0)==0){_a(24112,24016,398,24032)}if((m|0)==0){_a(24136,24016,399,24032)}if((j|0)==0){_a(24160,24016,400,24032)}else{i=b;return}}function Wq(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function Xq(a){a=a|0;var b=0;b=i;FT(c[a+12>>2]|0);FT(c[a+4>>2]|0);FT(c[a+8>>2]|0);i=b;return}function Yq(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;wd(a|0,d|0)|0;hd(d|0)|0;Td[c[16936]&255](0);i=b;return}function Zq(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[r>>2]|0;wc(e|0,a|0,b|0)|0;hd(e|0)|0;Td[c[16936]&255](0);i=d;return}function _q(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;Zq(a,e);i=d;return}



function Bt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;$r(b,+h[b+240>>3]);os(b);ts(b);nt(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=GT(c[y>>2]|0,8)|0;A=b+124|0;B=GT(c[A>>2]|0,4)|0;C=b+128|0;D=GT(c[C>>2]|0,1)|0;E=b+132|0;F=GT(c[E>>2]|0,4)|0;G=b+536|0;Bp(c[G>>2]|0,(z|0)!=0|0,57128,t);Bp(c[G>>2]|0,(B|0)!=0|0,57128,s);Bp(c[G>>2]|0,(D|0)!=0|0,57128,r);Bp(c[G>>2]|0,(F|0)!=0|0,57128,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[21756>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];bc(x|0,57144,p|0)|0;p=cc(x|0,57160)|0;c[o>>2]=57176;jd(p|0,57168,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];jd(p|0,57168,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Ed(10,p|0)|0;H=p}yp(9,1,57184,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;Wd[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];yp(9,0,57208,l);if((c[21756>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];jd(H|0,57232,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];jd(H|0,57232,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Ed(10,H|0)|0}if((Ys(b,0)|0)!=0){break a}if((Rs(b,0)|0)!=0){break a}if((Is(b,0)|0)!=0){break a}ws(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);Td[c[5568]&255](9);if((c[21756>>2]|0)!=0){Qc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}FT(z);FT(B);FT(D);FT(F)}else{h[b+304>>3]=1.0;Wd[c[w+80>>2]&127](b)|0}ls(b);if((nt(b,1,1)|0)!=1){i=e;return}Wd[c[(c[v>>2]|0)+80>>2]&127](b)|0;ls(b);if((nt(b,1,1)|0)!=1){i=e;return}Ap(1,0,57240,f);i=e;return}function Ct(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=Ft(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){yp(9,0,57344,u);if((c[b+184>>2]|0)==0){he[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}FT(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){yp(9,0,57376,t);he[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;FT(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){yp(9,1,57448,s);t=ET(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+vt(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+vt(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}yp(9,1,57472,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];yp(9,0,57496,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];yp(9,0,57496,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];yp(9,0,57496,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[21756>>2]|0)!=0){Td[c[5568]&255](9);Td[c[5568]&255](9)}FT(t);Gt(v);H=Ft(b)|0;if((c[H>>2]|0)!=0){$=H;break}yp(9,0,57520,n);FT(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}yp(9,0,57552,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){yp(9,0,57568,l);Dt($,d,1,e);wt(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+vt($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){FT(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){FT(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){FT(v);c[l>>2]=0}Dt($,d,0,e);wt(b,$);+vt($,1.0)}else{yp(9,0,57592,j)}yp(9,1,57616,g);wt(b,$);b=ut($)|0;if((c[21756>>2]|0)!=0){Td[c[5568]&255](9)}Gt($);y=b;i=f;return y|0}function Dt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=ET(c[p>>2]<<3)|0;r=q;s=+vt(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;It(a,r);FT(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=57744;F=E;yp(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;yp(9,0,57656,m);if(!t){Ht(a)}switch(b|0){case 1:{G=Pt(a)|0;break};case 6:{H=14;break a;break};case 5:{H=13;break a;break};case 3:{G=Rt(a,n,e)|0;break};case 2:{G=Nt(a)|0;break};case 4:{H=12;break a;break};default:{H=15;break a}}ts(o);js(o);ps(o);ts(o);s=+vt(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}yp(9,0,57704,k);wt(o,a);K=s}else{yp(9,0,57720,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){Mt(a)|0}else if((H|0)==13){Mt(a)|0}else if((H|0)==14){Lt(o,a,0)|0}else if((H|0)==15){Cp(c[o+536>>2]|0,57680,l)}else if((H|0)==23){It(a,r);FT(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=57744;F=E;yp(9,0,F,g);i=f;return}}function Et(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=gU(b|0)|0;do{if((d|0)==0){e=ET(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=ET(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((bU(e,58760,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;iU(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((bU(e,58760,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function Ft(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=ET(64)|0;z=y;Bp(0,(y|0)!=0|0,58768,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=GT(Z,8)|0;c[E>>2]=y;Bp(0,(y|0)!=0|0,58768,w);w=GT(Z,8)|0;c[F>>2]=w;Bp(0,(w|0)!=0|0,58768,v);v=GT(Z,8)|0;c[G>>2]=v;Bp(0,(v|0)!=0|0,58768,u);u=GT(Z,8)|0;c[H>>2]=u;Bp(0,(u|0)!=0|0,58768,t);t=GT(Z,8)|0;c[I>>2]=t;Bp(0,(t|0)!=0|0,58768,s);s=GT(Z,4)|0;t=s;c[J>>2]=t;Bp(0,(s|0)!=0|0,58768,r);yp(9,0,58784,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;yp(9,0,58808,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];yp(9,0,58896,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];yp(9,0,58944,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];yp(9,0,59e3,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;yp(9,0,59056,l);c[j>>2]=ya;yp(9,0,59128,j);j=GT(sa,8)|0;c[K>>2]=j;Bp(0,(j|0)!=0|0,58768,g);g=ET(sa<<3)|0;c[L>>2]=g;Bp(0,(g|0)!=0|0,58768,f);f=ET(ya<<3)|0;c[M>>2]=f;Bp(0,(f|0)!=0|0,58768,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function Gt(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){FT(d)}d=c[a+28>>2]|0;if((d|0)!=0){FT(d)}d=c[a+32>>2]|0;if((d|0)!=0){FT(d)}d=c[a+36>>2]|0;if((d|0)!=0){FT(d)}d=c[a+40>>2]|0;if((d|0)!=0){FT(d)}d=c[a+44>>2]|0;if((d|0)!=0){FT(d)}d=c[a+48>>2]|0;if((d|0)!=0){FT(d)}d=c[a+52>>2]|0;if((d|0)!=0){FT(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;FT(e);i=b;return}FT(d);e=a;FT(e);i=b;return}function Ht(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=GT(o,8)|0;q=GT(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=GT(s,8)|0;u=GT(s,8)|0;v=GT(o,8)|0;w=GT(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+vt(b,1.0);s=c[n>>2]|0;if((s|0)>0){iU(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+vt(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){iU(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;yp(9,0,59168,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}FT(p);FT(q);FT(t);FT(u);FT(v);FT(w);i=d;return}function It(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Jt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function Kt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function Lt(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Cp(c[a+536>>2]|0,59240,d);return 0}function Mt(a){a=a|0;a=i;i=i+8|0;Cp(0,59272,a);return 0}function Nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[21756>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=GT((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Bp(0,(n|0)!=0|0,59312,b);c[14832]=c[a+60>>2];c[14834]=c[a+48>>2];Fr(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;FT(n);c[14832]=0;c[14834]=0;n=ut(a)|0;i=b;return n|0}function Ot(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[14834];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[14832];h[d>>3]=+vt(f,1.0);i=e;return}function Pt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=ET(x)|0;z=y;A=ET(x)|0;x=A;Bp(0,(y|0)!=0|0,59344,n);Bp(0,(A|0)!=0|0,59344,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[21756>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+vt(a,1.0);h[o>>3]=D;if(D!=0.0){c[14840]=c[a+60>>2];c[14842]=c[a+48>>2];Cr(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[14840]=0;c[14842]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];yp(9,0,59376,l)}D=+vt(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];yp(9,0,59480,j);j=c[u>>2]|0;do{if((j|0)==2){Ap(9,0,59576,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Ap(9,0,59496,g);F=-1;i=b;return F|0}else if((j|0)==4){Ap(9,0,59712,d);F=-4;i=b;return F|0}else if((j|0)==3){Ap(9,0,59640,e);F=-3;i=b;return F|0}}while(0);F=ut(a)|0;i=b;return F|0}function Qt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[14842];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[14840];h[d>>3]=+vt(f,1.0);i=e;return}function Rt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;yp(9,1,59768,g);if((c[21756>>2]|0)==0){l=0}else{l=(k|0)/10|0}St(a,d,k,l,b,j);c[f>>2]=c[j>>2];yp(9,0,59792,f);Td[c[5568]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=ut(a)|0;if((b|0)==0){m=0;i=e;return m|0}Ap(9,0,59808,e);m=b;i=e;return m|0}function St(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=ET(fa(N,M)|0)|0;P=ET(M<<3)|0;Q=ET(N)|0;R=Q;S=ET(N)|0;T=S;V=ET(N)|0;W=V;X=ET(N)|0;Y=+h[f>>3];if((c[21756>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];bc(N|0,59856,I|0)|0;I=cc(N|0,59872)|0;c[H>>2]=59888;jd(I|0,59880,H|0)|0;c[G>>2]=59904;jd(I|0,59880,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];jd(I|0,59880,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Ed(10,I|0)|0;c[E>>2]=0;jd(I|0,59912,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];jd(I|0,59920,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];jd(I|0,59920,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Ed(10,I|0)|0;Z=I}else{Z=0}Bp(0,(O|0)!=0|0,59928,B);Bp(0,(P|0)!=0|0,59928,A);Bp(0,(Q|0)!=0|0,59928,z);Bp(0,(S|0)!=0|0,59928,y);Bp(0,(V|0)!=0|0,59928,x);Bp(0,(X|0)!=0|0,59928,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Jt(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+vt(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Jt(a,la);+vt(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];yp(9,0,59944,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){kU(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Jt(a,R);za=+vt(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}iU(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Jt(a,T);if(+vt(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}iU(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}iU(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Jt(a,W);Ba=+vt(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Jt(a,W);Ba=+vt(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}iU(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];yp(9,0,59984,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;jd(Z|0,59912,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];jd(Z|0,59920,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];jd(Z|0,59920,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Ed(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Ap(9,0,60032,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Ap(9,0,60048,p);Cp(0,60064,o)}Jt(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){FT(S);FT(Q);FT(V);FT(X);FT(P);FT(O);i=j;return}c[n>>2]=ia;jd(Z|0,59912,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];jd(Z|0,59920,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];jd(Z|0,59920,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Ed(10,Z|0)|0;Qc(Z|0)|0;FT(S);FT(Q);FT(V);FT(X);FT(P);FT(O);i=j;return}function Tt(a,b){a=a|0;b=b|0;i=i;return}function Ut(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Rq(3);Uq(0);w=+Mq(0);Rq(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];jd(v|0,60144,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];jd(v|0,60144,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];jd(v|0,60144,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];jd(v|0,60152,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;jd(v|0,60152,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];jd(v|0,60160,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];jd(v|0,60144,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];jd(v|0,60144,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;jd(v|0,60152,l|0)|0;break}else{c[m>>2]=0-E;jd(v|0,60152,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;jd(v|0,60152,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;jd(v|0,60152,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Ed(10,v|0)|0;Uq(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];jd(v|0,60160,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Ed(10,v|0)|0;Uq(3);i=e;return}function Vt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=cc(c[r>>2]|0,60168)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Id(c[(Gc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Bp(t,(s|0)!=0|0,60176,q);c[p>>2]=60232;jd(s|0,60160,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=60240;jd(s|0,60160,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];jd(s|0,60160,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];jd(s|0,60160,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];jd(s|0,60160,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];jd(s|0,60160,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];jd(s|0,60160,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];jd(s|0,60160,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];jd(s|0,60160,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Ed(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];jd(s|0,60160,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Ed(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function Wt(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Rq(3);Qc(d|0)|0;Uq(3);i=b;return}function Xt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;QL(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];RL(p,f)|0;Yt(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;Zt(a,b,60256,c[j>>2]|0,c[g>>2]|0,o,8);FT(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];RL(p,e)|0;i=d;return}function Yt(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=GT(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Bp(c[b+536>>2]|0,(p|0)!=0|0,60536,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function Zt(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;iu(a,b,d,e,f,h);PL(l,g,fa(fa(f,e)|0,h)|0)|0;if(kK(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Cp(l,60488,k)}else{i=j;return}}function _t(a){a=a|0;var b=0;b=i;if((av(a+4|0)|0)!=0){i=b;return}nK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function $t(a){a=a|0;Kc(a|0)|0;Ua()}function au(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=KT(320)|0;kU(q|0,0,320)|0;bu(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Rq(3);t=a+8|0;u=cu(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=du(a,b,u+s|0)|0;u=q+184|0;eu(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;eu(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;fu(q,c[x>>2]|0,36);if(kK(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Cp(y,60312,e)}else{Zt(a,b,60344,4,11,60264,1);gu((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;Zt(a,b,60352,c[g>>2]|0,c[j>>2]|0,e,1);FT(e);c[f>>2]=0;gu((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;Zt(a,b,60360,c[g>>2]|0,c[j>>2]|0,e,1);FT(e);c[f>>2]=0;hu(a,b,k,g,j,c[r>>2]|0,s);Zt(a,b,60376,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;QL(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];Yt(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;Zt(a,b,60256,c[j>>2]|0,c[g>>2]|0,n,8);QL(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=ju(q+240|0)|0;w=ju(q+264|0)|0;p=ju(q+288|0)|0;iu(a,b,60392,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);FT(n);FT(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;vL(s)|0;FT(v);Uq(3);i=d;return}}function bu(a){a=a|0;var b=0;b=i;kx(a);i=b;return}function cu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(ow(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(ow(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(ow(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function du(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=ET(e<<2)|0;e=l;c[l>>2]=60944;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=60984;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(ow(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(ow(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(ow(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function eu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;$u(a,b,c);i=d;return}function fu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_u(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){nK(d,4);i=e;return}else{lK(d,0);i=e;return}}function gu(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=gU(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=GT((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Bp(0,(o|0)!=0|0,60464,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;rU(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;nu(q,gU(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=GT(1,1)|0;c[d>>2]=q;Bp(0,(q|0)!=0|0,60464,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function hu(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=GT(c[f>>2]<<2,4)|0;c[e>>2]=g;Bp(c[d+536>>2]|0,(g|0)!=0|0,60512,k);g=s+240|0;f=ju(g)|0;h=s+264|0;t=ju(h)|0;u=s+288|0;v=ju(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=ju(g)|0;D=ju(h)|0;E=ju(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){ou(l,g,A+(v*52|0)+4|0);qu(m,g);if(!(pu(l,m)|0)){F=w;break}G=(c[(ru(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==1){ou(l,b,A+(v*52|0)+4|0);qu(n,b);if(!(pu(l,n)|0)){F=w;break}G=(c[(ru(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){ou(l,h,G+(t*52|0)+4|0);qu(o,h);H=pu(l,o)|0;J=H?2:0}else if(f<<24>>24==1){ou(l,v,G+(t*52|0)+4|0);qu(p,v);J=(pu(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(ru(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){ou(l,u,y+(t*52|0)+4|0);qu(q,u);F=pu(l,q)|0;M=F?2:0}else if(x<<24>>24==1){ou(l,d,y+(t*52|0)+4|0);qu(r,d);M=(pu(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(ru(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function iu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(gU(d|0)|0)+1;e=m;PL(e,l,20)|0;if(kK(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Cp(l,60488,k)}PL(e,d,c[f>>2]|0)|0;if(kK(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Cp(m,60488,j)}else{i=h;return}}function ju(a){a=a|0;var b=0,d=0;b=i;d=c[(Xu(a)|0)>>2]|0;i=b;return d|0}function ku(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Rq(3);do{if(jK(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];RL(k,e)|0;k=ju(h+240|0)|0;m=ju(h+264|0)|0;l=ju(h+288|0)|0;iu(a,b,60392,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);_t(h)}else{if((h|0)!=0){break}c[g>>2]=0;Uq(3);i=d;return}}while(0);lu(j);MT(h);c[g>>2]=0;Uq(3);i=d;return}function lu(a){a=a|0;var b=0;b=i;tv(a);i=b;return}function mu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Rq(3);Uq(0);h[j>>3]=+Mq(0);Rq(0);l=k;m=d+4|0;PL(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){PL(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){PL(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);PL(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);PL(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);PL(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(kK(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Cp(t,60432,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Uq(3);i=e;return}}function nu(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((dU(b,60648,4)|0)!=0){i=d;return}c=b;while(1){e=Ra(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((dU(b,60648,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function ou(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Ju(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];zu(a,f);i=e;return}function pu(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=xu(a,b)|0;i=c;return d|0}function qu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Au(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];zu(a,e);i=d;return}function ru(a){a=a|0;var b=0,c=0;b=i;c=su(tu(a)|0)|0;i=b;return c|0}function su(a){a=a|0;var b=0,c=0;b=i;c=wu(a)|0;i=b;return c|0}function tu(a){a=a|0;var b=0,d=0;b=i;d=uu((c[a>>2]|0)+16|0)|0;i=b;return d|0}function uu(a){a=a|0;var b=0,c=0;b=i;c=vu(a)|0;i=b;return c|0}function vu(a){a=a|0;i=i;return a|0}function wu(a){a=a|0;i=i;return a|0}function xu(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(yu(a,b)|0)^1;i=c;return d|0}function yu(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function zu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Iu(a,e);i=d;return}function Au(a,b){a=a|0;b=b|0;var c=0;c=i;Bu(a,Cu(b)|0);i=c;return}function Bu(a,b){a=a|0;b=b|0;var c=0;c=i;Hu(a,b);i=c;return}function Cu(a){a=a|0;var b=0,c=0;b=i;c=Du(Eu(a+4|0)|0)|0;i=b;return c|0}function Du(a){a=a|0;var b=0,c=0;b=i;c=Gu(a)|0;i=b;return c|0}function Eu(a){a=a|0;var b=0,c=0;b=i;c=Fu(a)|0;i=b;return c|0}function Fu(a){a=a|0;i=i;return a|0}function Gu(a){a=a|0;i=i;return a|0}function Hu(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Iu(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Ju(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Lu(b)|0;Ku(f,b,d,h,Cu(b)|0);Au(g,b);do{if(xu(f,g)|0){h=Mu(b)|0;if(Nu(h,d,Ou(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Au(a,b);i=e;return}function Ku(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Su(h);a:do{if((e|0)==0){j=f}else{k=Mu(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Tu(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Su(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Su(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Bu(a,j);i=g;return}function Lu(a){a=a|0;var b=0,d=0;b=i;d=c[(Cu(a)|0)>>2]|0;i=b;return d|0}function Mu(a){a=a|0;var b=0,c=0;b=i;c=Qu(a+8|0)|0;i=b;return c|0}function Nu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Pu(0,b,c)|0;i=a;return d|0}function Ou(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function Pu(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function Qu(a){a=a|0;var b=0,c=0;b=i;c=Ru(a)|0;i=b;return c|0}function Ru(a){a=a|0;i=i;return a|0}function Su(a){a=a|0;var b=0;b=i;Uu(a,-1);i=b;return}function Tu(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Pu(0,b,c)|0;i=a;return d|0}function Uu(a,b){a=a|0;b=b|0;b=i;Vu(a,0);i=b;return}function Vu(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function Wu(a){a=a|0;i=i;return c[a+4>>2]|0}function Xu(a){a=a|0;var b=0,c=0;b=i;c=Yu(a+8|0)|0;i=b;return c|0}function Yu(a){a=a|0;var b=0,c=0;b=i;c=Zu(a)|0;i=b;return c|0}function Zu(a){a=a|0;i=i;return a|0}function _u(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 5:case 21:{h=60608;break};case 24:{h=60576;break};case 52:case 20:{h=60600;break};case 1:case 17:{h=60560;break};case 60:{h=60632;break};case 12:{h=60616;break};case 13:case 29:{h=60640;break};case 9:case 25:{h=60592;break};case 8:{h=60568;break};case 56:{h=60584;break};case 48:case 16:{h=60552;break};case 28:{h=60624;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=cc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Oc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Qc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function $u(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}bv(d,f,102);f=Wd[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Qc(cv(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}dv(d);g=h;i=b;return g|0}function bv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;kv(a,b,c);i=d;return}function cv(a){a=a|0;var b=0,d=0;b=i;d=gv(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function dv(a){a=a|0;var b=0;b=i;ev(a);i=b;return}function ev(a){a=a|0;var b=0;b=i;fv(a,0);i=b;return}function fv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=gv(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Wd[c[(hv(e)|0)>>2]&127](f)|0;i=d;return}function gv(a){a=a|0;var b=0,c=0;b=i;c=jv(a)|0;i=b;return c|0}function hv(a){a=a|0;var b=0,c=0;b=i;c=iv(a)|0;i=b;return c|0}function iv(a){a=a|0;i=i;return a+4|0}function jv(a){a=a|0;i=i;return a|0}function kv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(mv(f)|0)>>2]|0;lv(a,d,c[(nv(g)|0)>>2]|0);i=e;return}function lv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;ov(a,b,c);i=d;return}function mv(a){a=a|0;i=i;return a|0}function nv(a){a=a|0;i=i;return a|0}function ov(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(qv(f)|0)>>2]|0;pv(a,d,c[(rv(g)|0)>>2]|0);i=e;return}function pv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(qv(f)|0)>>2];c[a+4>>2]=c[(rv(g)|0)>>2];i=e;return}function qv(a){a=a|0;i=i;return a|0}function rv(a){a=a|0;i=i;return a|0}function sv(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function tv(a){a=a|0;var b=0;b=i;uv(a+300|0);uv(a+288|0);uv(a+276|0);uv(a+264|0);uv(a+252|0);uv(a+240|0);vv(a);i=b;return}function uv(a){a=a|0;var b=0;b=i;fw(a);i=b;return}function vv(a){a=a|0;var b=0;b=i;wv(a,60696);rK(a+104|0);i=b;return}function wv(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Av(a+4|0);i=d;return}function xv(a){a=a|0;var b=0;b=i;vv(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function yv(a){a=a|0;var b=0;b=i;vv(a);MT(a);i=b;return}function zv(a){a=a|0;var b=0;b=i;yv(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Av(a){a=a|0;var b=0;b=i;Bv(a);i=b;return}function Bv(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=60824;av(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}NT(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}NT(e)}}while(0);AK(b);i=d;return}function Cv(a){a=a|0;var b=0;b=i;Av(a);MT(a);i=b;return}function Dv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;Wd[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=dw(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=ew(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;KK(h,0,0,0);PK(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}NT(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=LT(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=LT(h)|0;a[b+97|0]=1;i=e;return}function Ev(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;KK(e,0,0,0);PK(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}NT(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}NT(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=LT(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(aw(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=LT(o)|0;a[k]=1;i=f;return e|0}return 0}function Fv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=xc(4)|0;jT(n);Fd(n|0,108216,128)}n=Yv(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((Wd[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){eu(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=zU(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Oc(p|0,q|0,f|0)|0)==0){p=ub(c[m>>2]|0)|0;eu(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];$v(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{eu(a,-1,-1);i=g;return}}}while(0);eu(a,-1,-1);i=g;return}function Gv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((Wd[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=sv(d)|0;if((Oc(j|0,k|0,0)|0)==0){_v(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{eu(a,-1,-1);i=e;return}}}while(0);eu(a,-1,-1);i=e;return}function Hv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=xc(4)|0;jT(m);Fd(m|0,108216,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=Yv(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=IK(s)|0;u=(fa(t-(HK(s)|0)|0,p)|0)+r|0;v=0;break}p=HK(s)|0;if((p|0)==(IK(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=Zv(t,g,x,o,p-(GK(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=IK(w)|0;u=q-(HK(w)|0)|0;v=0}}while(0);if((Oc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;KK(b,0,0,0);c[m>>2]=0}else{q=b;y=MK(q)|0;do{if((y|0)!=(LK(q)|0)){if((he[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=Xv(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((kc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((hd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function Iv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=Sv(b)|0;o=b;if((HK(o)|0)==0){p=e+1|0;KK(o,e,p,p)}if(n){q=0}else{n=IK(o)|0;c[f>>2]=(n-(GK(o)|0)|0)/2|0;c[g>>2]=4;q=c[(Tv(f,g)|0)>>2]|0}g=HK(o)|0;do{if((g|0)==(IK(o)|0)){jU(GK(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=IK(o)|0;n=GK(o)|0;p=ob(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=GK(o)|0;KK(o,n,n+q|0,n+(p+q)|0);r=Qv(a[HK(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;jU(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(Tv(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=ob(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=xc(4)|0;jT(t);Fd(t|0,108216,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=GK(o)|0;if((Uv(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;KK(o,f,f,c[s>>2]|0);r=Qv(a[HK(o)|0]|0)|0;break}s=c[k>>2]|0;f=GK(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}KK(o,f,p,s);r=Qv(a[HK(o)|0]|0)|0}else{r=Qv(a[g]|0)|0}}while(0);if((GK(o)|0)!=(e|0)){m=r;i=d;return m|0}KK(o,0,0,0);m=r;i=d;return m|0}function Jv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=GK(g)|0;j=HK(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(Mv(d,-1)|0){JK(g,-1);f=Pv(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=Nv(d)|0;do{if(h){if(Rv(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);JK(g,-1);a[HK(g)|0]=b;f=d;i=e;return f|0}function Kv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}Lv(b);l=b;m=LK(l)|0;n=NK(l)|0;if(!(Mv(d,-1)|0)){if((MK(l)|0)==0){PK(l,f,f+1|0)}f=Nv(d)|0;a[MK(l)|0]=f;OK(l,1)}f=MK(l)|0;o=LK(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=LK(l)|0;A=MK(l)|0;B=Ov(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=LK(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((kc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;PK(l,B,MK(l)|0);B=NK(l)|0;OK(l,B-(LK(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=xc(4)|0;u=t;jT(u);v=108216;w=128;Fd(t|0,v|0,w|0)}else if((D|0)==14){q=(MK(l)|0)-C|0;if((kc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((kc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);PK(l,m,n)}k=Pv(d)|0;i=e;return k|0}function Lv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;KK(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;PK(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;PK(f,h,h+(g+ -1)|0);break}}else{PK(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function Mv(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function Nv(a){a=a|0;i=i;return a&255|0}function Ov(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=ke[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function Pv(a){a=a|0;var b=0,c=0;b=i;c=Mv(a,-1)|0;i=b;return(c?0:a)|0}function Qv(a){a=a|0;i=i;return a&255|0}function Rv(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function Sv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;PK(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;KK(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;KK(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function Tv(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Vv(b,c,e)|0;i=d;return g|0}function Uv(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=ke[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function Vv(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Wv(0,b,a)|0;i=c;return(d?b:a)|0}function Wv(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function Xv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ie[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function Yv(a){a=a|0;var b=0,d=0;b=i;d=Wd[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function Zv(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ie[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function _v(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function $v(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function aw(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=bw(b,c,e)|0;i=d;return g|0}function bw(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=cw(0,a,b)|0;i=c;return(d?b:a)|0}function cw(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function dw(a){a=a|0;var b=0,c=0;b=i;c=jQ(a,92720)|0;i=b;return c|0}function ew(a){a=a|0;var b=0,d=0;b=i;d=Wd[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function fw(a){a=a|0;var b=0;b=i;gw(a);i=b;return}function gw(a){a=a|0;var b=0;b=i;hw(a);i=b;return}function hw(a){a=a|0;var b=0;b=i;iw(a,Lu(a)|0);i=b;return}function iw(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;Su(d);if((b|0)==0){i=d;return}iw(a,c[b>>2]|0);iw(a,c[b+4>>2]|0);kw(jw(a)|0,b,1);i=d;return}function jw(a){a=a|0;var b=0,c=0;b=i;c=mw(a+4|0)|0;i=b;return c|0}function kw(a,b,c){a=a|0;b=b|0;c=c|0;c=i;lw(0,b,0);i=c;return}function lw(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MT(b);i=c;return}function mw(a){a=a|0;var b=0,c=0;b=i;c=nw(a)|0;i=b;return c|0}function nw(a){a=a|0;i=i;return a|0}function ow(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=pw(a,f,b)|0;l=c[k>>2]|0;Su(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}rw(j,a,b);sw(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];qw(g,e);tw(j);j=c[f>>2]|0;uw(a,j,k,vw(g)|0);k=ww(g)|0;tw(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function pw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Lu(h)|0;Su(e);if((a|0)==0){j=Cu(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Pu(0,d,a)|0){m=l;j=c[m>>2]|0;Su(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Pu(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Su(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function qw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];ix(a,e);i=d;return}function rw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=jw(d)|0;d=Tw(n,1)|0;Uw(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Sw(j,d,h);Vw(0,Ow((Ww(j)|0)+16|0)|0,e);e=Xw(j)|0;a[e+4|0]=1;Yw(0,Nw((Ww(j)|0)+20|0)|0);a[e+5|0]=1;Zw(m,j);sw(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];qw(b,g);tw(m);tw(j);i=f;return}function sw(a,b){a=a|0;b=b|0;var c=0;c=i;Qw(a,b);i=c;return}function tw(a){a=a|0;var b=0;b=i;Jw(a);i=b;return}function uw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Su(f);c[e>>2]=0;Su(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Bw(a)|0;b=c[c[e>>2]>>2]|0;Su(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Cu(a)|0)>>2]|0;Cw(e,c[d>>2]|0);d=Dw(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function vw(a){a=a|0;var b=0,d=0;b=i;d=c[(zw(a)|0)>>2]|0;i=b;return d|0}function ww(a){a=a|0;var b=0,d=0;b=i;d=xw(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function xw(a){a=a|0;var b=0,c=0;b=i;c=yw(a)|0;i=b;return c|0}function yw(a){a=a|0;i=i;return a|0}function zw(a){a=a|0;var b=0,c=0;b=i;c=Aw(a)|0;i=b;return c|0}function Aw(a){a=a|0;i=i;return a|0}function Bw(a){a=a|0;i=i;return a|0}function Cw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=Gw(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;Su(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;Su(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(Gw(j)|0){p=j}else{o=c[k>>2]|0;Hw(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;Iw(p);i=e;return}else if((l|0)==14){if(Gw(j)|0){p=c[k>>2]|0;Iw(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;Hw(q);i=e;return}else if((l|0)==17){i=e;return}}function Dw(a){a=a|0;var b=0,c=0;b=i;c=Ew(a+8|0)|0;i=b;return c|0}function Ew(a){a=a|0;var b=0,c=0;b=i;c=Fw(a)|0;i=b;return c|0}function Fw(a){a=a|0;i=i;return a|0}function Gw(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function Hw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;Su(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=Gw(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Iw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;Su(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=Gw(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Jw(a){a=a|0;var b=0;b=i;Kw(a,0);i=b;return}function Kw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=xw(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Mw(Lw(e)|0,f);i=d;return}function Lw(a){a=a|0;var b=0,c=0;b=i;c=Pw(a)|0;i=b;return c|0}function Mw(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}kw(c[a>>2]|0,b,1);i=d;return}function Nw(a){a=a|0;i=i;return a|0}function Ow(a){a=a|0;i=i;return a|0}function Pw(a){a=a|0;i=i;return a+4|0}function Qw(a,b){a=a|0;b=b|0;var c=0;c=i;Rw(a,b);i=c;return}function Rw(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Sw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ax(a,b,f);i=e;return}function Tw(a,b){a=a|0;b=b|0;var c=0;a=i;c=$w(0,b,0)|0;i=a;return c|0}function Uw(a,b){a=a|0;b=b|0;var c=0;c=i;_w(a,b);i=c;return}function Vw(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function Ww(a){a=a|0;var b=0,d=0;b=i;d=c[(zw(a)|0)>>2]|0;i=b;return d|0}function Xw(a){a=a|0;var b=0,c=0;b=i;c=Lw(a)|0;i=b;return c|0}function Yw(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function Zw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Qw(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];qw(h,f);sw(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];qw(a,e);tw(h);i=d;return}function _w(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function $w(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=KT(b*24|0)|0;i=c;return a|0}function ax(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(cx(g)|0)>>2]|0;g=dx(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];bx(b,a,f);i=e;return}function bx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ex(a,b,f);i=e;return}function cx(a){a=a|0;i=i;return a|0}function dx(a){a=a|0;i=i;return a|0}function ex(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(gx(g)|0)>>2]|0;g=hx(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];fx(b,a,f);i=e;return}function fx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(gx(f)|0)>>2];f=hx(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function gx(a){a=a|0;i=i;return a|0}function hx(a){a=a|0;i=i;return a|0}function ix(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=ww(jx(b)|0)|0;h=hx(Xw(jx(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];bx(g,a,e);i=d;return}function jx(a){a=a|0;i=i;return c[a>>2]|0}function kx(a){a=a|0;var b=0;b=i;i=i+48|0;lx(a);eu(a+184|0,0,0);eu(a+200|0,0,0);mx(a+240|0,b);mx(a+252|0,b+8|0);mx(a+264|0,b+16|0);mx(a+276|0,b+24|0);mx(a+288|0,b+32|0);mx(a+300|0,b+40|0);i=b;return}function lx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;wK(d);e=a;c[e>>2]=60668;f=d;c[f>>2]=60688;d=a+4|0;DL(a,60700|0,d);c[e>>2]=60668;c[f>>2]=60688;zx(d);i=b;return}function mx(a,b){a=a|0;b=b|0;b=i;nx(a,0);i=b;return}function nx(a,b){a=a|0;b=b|0;b=i;i=i+8|0;ox(a,b);i=b;return}function ox(a,b){a=a|0;b=b|0;b=i;px(a,0);i=b;return}function px(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;qx(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;rx(f,0,e);e=Cu(b)|0;c[(Bw(b)|0)>>2]=e;i=d;return}function qx(a){a=a|0;var b=0;b=i;vx(a);i=b;return}function rx(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;sx(b,c,f);i=e;return}function sx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(ux(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;tx(d,b,f);i=e;return}function tx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(ux(e)|0)>>2];i=d;return}function ux(a){a=a|0;i=i;return a|0}function vx(a){a=a|0;var b=0;b=i;wx(a);i=b;return}function wx(a){a=a|0;var b=0;b=i;xx(a);i=b;return}function xx(a){a=a|0;var b=0;b=i;yx(a);i=b;return}function yx(a){a=a|0;c[a>>2]=0;i=i;return}function zx(a){a=a|0;var b=0;b=i;Ax(a);i=b;return}function Ax(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;FK(j);c[d>>2]=60824;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;Su(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;BK(g,j);l=Bx(g)|0;hQ(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=$d[r&63](d,0,4096)|0;i=e;return}BK(h,j);c[k>>2]=dw(h)|0;hQ(h);a[f]=(ew(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=$d[r&63](d,0,4096)|0;i=e;return}function Bx(a){a=a|0;var b=0,c=0;b=i;c=iQ(a,92720)|0;i=b;return c|0}function Cx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Rq(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){Dx(a,b,c[f>>2]|0,h);Uq(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=HT(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Cp(k,61096,e)}Dx(a,b,l,h);Uq(3);i=d;return}function Dx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Uq(0);k=+Mq(0);Rq(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function Ex(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=ET(24)|0;Rq(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Bp(c[m>>2]|0,l>>>31^1,61152,f);f=b+8|0;b=c[a+8>>2]|0;l=Fx(b,f)|0;c[g+20>>2]=l;l=Fx(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=ET(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Cp(k,61232,e)}else{c[h>>2]=0;c[a+12>>2]=g;Uq(3);i=d;return}}function Fx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}



function se(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function te(){return i|0}function ue(a){a=a|0;i=a}function ve(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function we(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function xe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function ye(a){a=a|0;J=a}function ze(a){a=a|0;K=a}function Ae(a){a=a|0;L=a}function Be(a){a=a|0;M=a}function Ce(a){a=a|0;N=a}function De(a){a=a|0;O=a}function Ee(a){a=a|0;P=a}function Fe(a){a=a|0;Q=a}function Ge(a){a=a|0;R=a}function He(a){a=a|0;S=a}function Ie(a){a=a|0;var b=0,d=0;b=i;tt(a)|0;d=a+540|0;Wd[c[(c[d>>2]|0)+40>>2]&127](a)|0;Wd[c[(c[d>>2]|0)+28>>2]&127](a)|0;Wd[c[(c[d>>2]|0)+32>>2]&127](a)|0;Wd[c[(c[d>>2]|0)+48>>2]&127](a)|0;Wd[c[(c[d>>2]|0)+52>>2]&127](a)|0;os(a);i=b;return}function Je(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=gU(B|0)|0;D=ET(C+11|0)|0;rU(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=cc(D|0,32)|0;if((C|0)==0){B=Id(c[(Gc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Ap(23,0,40,u);Qc(0)|0;F=0}else{F=C}FT(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}le[c[22620>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Sq(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Sq(2);Rq(2)}Gq(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];bs(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(23,1,144,r);Z=bt(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ie(b);ps(b);if((c[21812>>2]|0)!=0){Td[c[5568]&255](23)}if((c[2]|0)!=0){Rq(4)}A=ds(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(7,1,200,q);if((c[75508>>2]|0)==0){Ud[c[60132>>2]&63](60112,b)}fs(b,c[J>>2]|0,z,d);if((c[21748>>2]|0)!=0){Td[c[5568]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;ts(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Uq(4)}if((nt(b,1,1)|0)!=0){c[B>>2]=1;ts(b)}Wd[c[(c[K>>2]|0)+88>>2]&127](b)|0;os(b);xs(b);ps(b);do{if((T|0)==0){_=0}else{Rq(7);Uq(2);A=(kc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(kc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Mq(2);if(!$){aa=0;break}aa=(kc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Mq(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Hq(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(kc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Mq(ba+9|0);if((ca|0)==0){ka=0}else{ka=(kc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Uq(7);if((la|0)!=0){_=T;break}c[p>>2]=Id(c[(Gc()|0)>>2]|0)|0;Ap(23,0,240,p);Qc(T|0)|0;_=0}}while(0);if((c[75508>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;Ud[c[60132>>2]&63](60112,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[16428]|0)!=0){ca=f;ba=65720;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];qp(M,f);Ed(10,M|0)|0;ba=c[16436]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;yp(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((Ys(b,0)|0)!=0){ma=58;break}if((Rs(b,0)|0)!=0){ma=58;break}if((Is(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];yp(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((Ys(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];yp(1,0,448,m);U=_;V=-2;break}if((Rs(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];yp(1,0,536,l);U=_;V=-3;break}T=(Is(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];yp(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];yp(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Qc(U|0)|0;i=e;return V|0}function Ke(a){a=a|0;i=i;return 0}function Le(a){a=a|0;i=i;return 0}function Me(a){a=a|0;i=i;return 0}function Ne(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Oe(b){b=b|0;var d=0;d=i;if((a[b+312|0]|0)==0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[b+400>>2]|0)+40>>3];i=d;return}else{h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+40>>3]=1.0;i=d;return}}function Pe(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=0.0;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[j+1048>>3]+ +h[j+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;y=g;break}else{g=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[g+1048>>3]+ +h[g+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;y=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[k+1048>>3]+ +h[k+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[f+1048>>3]+ +h[f+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}}}while(0);if(y<<24>>24==0){l=0.0;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}y=c[b+416>>2]|0;z=+h[y+1032>>3];A=+h[y+1024>>3];if(z!=0.0){l=A/z;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}if(A==0.0){l=A;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}l=A/+Ep(c[b+536>>2]|0,z,880,872,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}function Qe(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,904,896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=1296;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,928,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+168>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,1032,896,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}function Re(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[j+1048>>3]+ +h[j+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[g+1048>>3]+ +h[g+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[k+1048>>3]+ +h[k+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[f+1048>>3]+ +h[f+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+1024>>3];n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+1048>>3];I=+h[e+1032>>3];J=+h[e+1024>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+Ep(c[b+536>>2]|0,I,880,1088,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}function Se(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[(c[a+416>>2]|0)+912>>3]- +h[b+280>>3];i=i;return}function Te(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;l=Bs(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+4|0;k=Bs(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;j=Cs(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+4|0;k=Cs(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function Ue(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+232|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=-(+h[(c[b+416>>2]|0)+848>>3]*+h[m+168>>3]);j=f;k=j+232|0;l=k;h[l>>3]=g;i=d;return}}function Ve(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){g=0.0;j=f;k=j+240|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+216>>3]- +h[e+856>>3]));g=-(+h[e+840>>3]*m*m);j=f;k=j+240|0;l=k;h[l>>3]=g;i=d;return}function We(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+1|0]|0)==0){g=f;j=0.0}else{k=(Cs(+h[f+232>>3],+h[f+240>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+240>>3];break}k=(Es(+h[l+232>>3],-+h[l+240>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+232>>3];break}else{g=l;j=-+h[l+240>>3];break}}}while(0);h[g+224>>3]=j;i=d;return}function Xe(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=-(+h[b+224>>3]*+h[b+168>>3]);i=i;return}function Ye(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+240>>3]+ +h[b+224>>3];i=i;return}function Ze(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+280>>3]+ +h[(c[a+416>>2]|0)+816>>3]*-.5;i=i;return}function _e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+264>>3]+ +h[(c[a+416>>2]|0)+816>>3]*-.5;i=i;return}function $e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+112>>3]- +h[(c[a+416>>2]|0)+920>>3];i=i;return}function af(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+2|0]|0;q=b+4|0;r=Bs(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=r;e=q;f=p;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{p=b+4|0;q=Bs(+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=q;e=p;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+2|0]|0;q=b+4|0;p=Cs(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3])|0;a[(c[b+352>>2]|0)+2|0]=p;e=q;f=o;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{o=b+4|0;q=Cs(+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3])|0;a[(c[b+352>>2]|0)+2|0]=q;e=o;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}}function bf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+184|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+888>>3]*+h[m+168>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=d;return}}function cf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){g=0.0;j=f;k=j+192|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+160>>3]- +h[e+896>>3]));g=-(+h[e+880>>3]*m*m);j=f;k=j+192|0;l=k;h[l>>3]=g;i=d;return}function df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[c[b+16>>2]|0]|0)==0){g=f;j=0.0}else{k=(Cs(+h[f+184>>3],+h[f+192>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+192>>3];break}k=(Es(+h[l+184>>3],-+h[l+192>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+184>>3];break}else{g=l;j=-+h[l+192>>3];break}}}while(0);h[g+176>>3]=j;i=d;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+176>>3]*+h[b+168>>3];i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+192>>3]+ +h[b+176>>3];i=i;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+424>>3]- +h[b+208>>3];i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=-+h[b+256>>3]- +h[b+272>>3];i=i;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[(c[a+416>>2]|0)+576>>3]*.5+ +h[b+280>>3];i=i;return}function kf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,904,1096,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=1296;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,928,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+104>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,1032,1096,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,1112,1104,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}function mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+480>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,1144,1136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+472>>3]-(-+h[b+152>>3]- +h[b+496>>3]);i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[(c[a+416>>2]|0)+704>>3]*+h[b+312>>3];i=i;return}function pf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+416|0;do{if((Es(+U(+-+h[(c[e>>2]|0)+1016>>3]),1.0e-13)|0)<<24>>24==0){f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=+h[f+304>>3]*1.0e13;j=f}else{k=+h[(c[e>>2]|0)+1016>>3];f=b+4|0;l=c[c[f>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+304>>3];o=-n;if(k!=0.0){g=o/k;j=m;break}if(n==-0.0){g=o;j=m;break}n=o/+Ep(c[b+536>>2]|0,k,1176,1168,+h[l>>3],(a[b+319|0]|0)!=0|0);g=n;j=c[(c[c[f>>2]>>2]|0)+8>>2]|0}}while(0);h[j+296>>3]=+U(+g);i=d;return}function qf(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+704>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+344>>3]=b*b*(+h[d+136>>3]+(+h[d+592>>3]+ +h[d+552>>3]));i=i;return}function rf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];k=j*j;j=+h[g+368>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}j=l/+Ep(c[b+536>>2]|0,k,1200,1192,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+152>>3]*+h[g+360>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,1144,1224,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=-(+h[(c[a+416>>2]|0)+704>>3]*+h[b+352>>3]);i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+464>>3]+ +h[b+320>>3];i=i;return}function vf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+120>>3]=(+h[b+936>>3]+ +h[b+944>>3])*+h[d+104>>3]*3.141592653589793;i=i;return}function wf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];k=+h[g+152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,1240,1232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function xf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[d>>3];i=b;return}function yf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,2,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[d>>3];i=b;return}function zf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,3,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[d>>3];i=b;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[(c[a+416>>2]|0)+576>>3]*.5- +h[b+280>>3];i=i;return}function Bf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+960>>3];m=+h[j+968>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,1272,1264,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=1296;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,1320,f);}l=+h[(c[g>>2]|0)+952>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+56>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,1424,1264,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}function Cf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,1488,1480,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3];k=+h[(c[b+416>>2]|0)+752>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,1520,1512,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+152>>3]+ +h[b+96>>3];i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+312>>3]+ +h[b+96>>3]- +h[b+496>>3]- +h[b+288>>3]- +h[b+472>>3];i=i;return}function Gf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+64>>3]=(+h[b+960>>3]+ +h[b+968>>3])*+h[d+56>>3]*3.141592653589793;i=i;return}function Hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+96>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,1552,1544,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}function If(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Fs(+h[f+728>>3]*(+h[f+736>>3]- +h[f+720>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[16932]|0;g=d;j=1656;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];re[a&31](f,d,1680,e);i=b;return}function Jf(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ne(b);Oe(b);Pe(b);Qe(b);Re(b);Se(b);Te(b);Ue(b);Ve(b);We(b);Xe(b);Ye(b);Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);i=c;return 0}function Kf(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Lf(b);i=c;return 0}function Lf(a){a=a|0;var b=0;b=i;Ne(a);i=b;return}function Mf(a,b){a=a|0;b=+b;i=i;return 0}function Nf(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;Bp(c[a+536>>2]|0,(a|0)!=0|0,1928,b);c[a+540>>2]=1736;c[a+84>>2]=1960;c[a+88>>2]=1960;c[a+92>>2]=2040;c[a+96>>2]=2104;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=1;c[a+116>>2]=78;c[a+120>>2]=1;c[a+124>>2]=0;c[a+128>>2]=2;c[a+132>>2]=0;c[a+136>>2]=134;c[a+140>>2]=10;c[a+144>>2]=9;c[a+148>>2]=2;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=89;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=4;c[a+104>>2]=0;c[a+164>>2]=4;c[a+168>>2]=0;c[a+176>>2]=0;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=1;c[a+56>>2]=2144;c[a+64>>2]=5;c[a+72>>2]=0;c[a+68>>2]=243;c[a+172>>2]=0;d=a+192|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Of(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Ma(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=tU(c[k>>2]|0,e)|0;if((l|0)==0){ab(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=22600;F=22624;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Ma(c[5650]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=tU(c[F>>2]|0,e)|0;if((G|0)==0){ab(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[4880]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=tU(c[H>>2]|0,e)|0;if((I|0)==0){ab(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Fa(46,c[4880]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=tU(c[H>>2]|0,e)|0;if((K|0)==0){ab(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;fU(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=tU(c[L>>2]|0,e)|0;if((M|0)==0){ab(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;fU(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=tU(c[I>>2]|0,e)|0;if((N|0)==0){ab(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Fa(46,c[4880]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=tU(c[M>>2]|0,e)|0;if((R|0)==0){ab(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=tU(c[M>>2]|0,e)|0;if((V|0)==0){ab(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Ma(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=tU(c[M>>2]|0,e)|0;if((W|0)==0){ab(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Oa(34,2232,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=tU(c[M>>2]|0,e)|0;if((ba|0)==0){ab(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=tU(c[M>>2]|0,e)|0;if((ca|0)==0){ab(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=tU(c[M>>2]|0,e)|0;if((da|0)==0){ab(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=tU(c[M>>2]|0,e)|0;if((ea|0)==0){ab(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=xa(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=tU(c[h>>2]|0,e)|0;if((fa|0)==0){ab(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=tU(c[h>>2]|0,e)|0;if((ga|0)==0){ab(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Fa(46,c[4880]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=tU(c[h>>2]|0,e)|0;if((ha|0)==0){ab(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=tU(c[h>>2]|0,e)|0;if((ia|0)==0){ab(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=tU(c[h>>2]|0,e)|0;if((ja|0)==0){ab(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=tU(c[M>>2]|0,e)|0;if((ka|0)==0){ab(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Pf(){var a=0;a=i;hd(0)|0;kc(2392,18,1,c[r>>2]|0)|0;hd(0)|0;i=a;return}function Qf(a,b){a=a|0;b=b|0;a=i;ok(b);i=a;return}function Rf(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;b=i;j=Sf(c[f+8>>2]|0)|0;k=Tf(f,1)|0;l=Tf(f,2)|0;f=Uf(c[g+8>>2]|0)|0;c[a>>2]=mk(d,e,j,k,l,f,Vf(g)|0,h)|0;i=b;return}function Sf(a){a=a|0;i=i;return a|0}function Tf(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=op(a,b)|0;i=c;return d|0}function Uf(a){a=a|0;i=i;return a|0}function Vf(a){a=a|0;var b=0,c=0;b=i;c=op(a,1)|0;i=b;return c|0}function Wf(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;b=i;h[a>>3]=+pk(c,d,e);i=b;return}function Xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+64|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=i;i=i+24|0;v=i;i=i+24|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=i;i=i+24|0;A=i;i=i+24|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+8|0;yp(4,0,2416,C);C=B;h[k>>3]=-8.8729;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=-9.07503;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+16|0;h[k>>3]=.00332;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];zq(E,4,-.004,B);B=A;h[k>>3]=-9.05239;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=-9.25042;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+16|0;h[k>>3]=.00352;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];zq(F,4,-.0035,A);A=z;h[k>>3]=-9.1915;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=-9.38558;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+16|0;h[k>>3]=.00371;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];zq(G,4,-.003,z);z=y;h[k>>3]=-9.28247;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=-9.47266;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+16|0;h[k>>3]=.0039;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];zq(H,4,-.0025,y);y=x;h[k>>3]=-9.3587;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x+8|0;h[k>>3]=-9.54503;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x+16|0;h[k>>3]=.00409;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];zq(I,4,-.002,x);x=w;h[k>>3]=-9.41568;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w+8|0;h[k>>3]=-9.59782;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w+16|0;h[k>>3]=.00429;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];zq(J,4,-.0015,w);w=v;h[k>>3]=-9.45496;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=v+8|0;h[k>>3]=-9.6331;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=v+16|0;h[k>>3]=.00448;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];zq(K,4,-.001,v);v=u;h[k>>3]=-9.47427;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+8|0;h[k>>3]=-9.64839;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=u+16|0;h[k>>3]=.00467;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];zq(L,4,-5.0e-4,u);u=t;h[k>>3]=-9.48639;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=-9.65616;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+16|0;h[k>>3]=.00486;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];zq(M,4,0.0,t);t=s;h[k>>3]=-9.48623;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s+8|0;h[k>>3]=-9.65174;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s+16|0;h[k>>3]=.00505;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];zq(N,4,5.0e-4,s);s=r;h[k>>3]=-9.4732;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r+8|0;h[k>>3]=-9.63435;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r+16|0;h[k>>3]=.00524;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];zq(O,4,.001,r);r=q;h[k>>3]=-9.44143;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=q+8|0;h[k>>3]=-9.59825;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=q+16|0;h[k>>3]=.00543;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];zq(P,4,.0015,q);q=p;h[k>>3]=-9.39915;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=p+8|0;h[k>>3]=-9.55226;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=p+16|0;h[k>>3]=.00562;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];zq(Q,4,.002,p);p=o;h[k>>3]=-9.33166;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+8|0;h[k>>3]=-9.47988;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+16|0;h[k>>3]=.00581;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];zq(R,4,.0025,o);o=n;h[k>>3]=-9.23707;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=-9.38112;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=.006;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];zq(S,4,.003,n);n=m;h[k>>3]=-9.09497;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=-9.23417;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.00619;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];zq(T,4,.0035,m);m=l;h[k>>3]=-8.91839;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=-9.05337;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+16|0;h[k>>3]=.00638;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];zq(U,4,.004,l);c[j>>2]=F;c[j+4>>2]=G;c[j+8>>2]=H;c[j+12>>2]=I;c[j+16>>2]=J;c[j+20>>2]=K;c[j+24>>2]=L;c[j+28>>2]=M;c[j+32>>2]=N;c[j+36>>2]=O;c[j+40>>2]=P;c[j+44>>2]=Q;c[j+48>>2]=R;c[j+52>>2]=S;c[j+56>>2]=T;c[j+60>>2]=U;yq(D,17,E,j);c[g>>2]=3;c[g+4>>2]=4;Ip(V,3,2,g);g=c[a+536>>2]|0;j=e;E=D;c[j+0>>2]=c[E+0>>2];c[j+4>>2]=c[E+4>>2];c[j+8>>2]=c[E+8>>2];E=d;j=V;c[E+0>>2]=c[j+0>>2];c[E+4>>2]=c[j+4>>2];c[E+8>>2]=c[j+8>>2];j=2456;Rf(W,g,j,j,e,d,1);c[c[a+320>>2]>>2]=c[W>>2];yp(4,0,2464,f);i=b;return}function Yf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+320|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}Qf(c[a+536>>2]|0,c[e>>2]|0);FT(c[d>>2]|0);c[d>>2]=0;i=b;return}function Zf(a){a=a|0;i=i;return}function _f(a){a=a|0;i=i;return}function $f(a,b){a=a|0;b=b|0;i=i;return}function ag(a){a=a|0;i=i;return}function bg(a,b){a=a|0;b=b|0;c[b>>2]=c[2776+(a<<2)>>2];i=i;return c[2792+(a<<2)>>2]|0}function cg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;b=(Bs(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+1048>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=c[g>>2]|0;k=(Bs(+h[c[c[f>>2]>>2]>>3],+h[b+1048>>3]+ +h[b+1032>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=k?1.0:-1.0;k=(Bs(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[g>>2]|0)+896>>3],a[(c[j>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=k?1.0:-1.0;k=(Bs(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[g>>2]|0)+856>>3],a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=k?1.0:-1.0;i=e;return 0}function dg(a){a=a|0;i=i;return c[2792+(a<<2)>>2]|0}function eg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+1048>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;l=c[j>>2]|0;a[(c[d>>2]|0)+1|0]=+h[c[c[f>>2]>>2]>>3]<+h[l+1048>>3]+ +h[l+1032>>3]|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3]<+h[(c[j>>2]|0)+896>>3]|0;a[(c[d>>2]|0)+3|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3]<+h[(c[j>>2]|0)+856>>3]|0;i=e;return 0}else{d=b+360|0;l=Bs(g,k,a[c[d>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=l;l=c[j>>2]|0;b=Bs(+h[c[c[f>>2]>>2]>>3],+h[l+1048>>3]+ +h[l+1032>>3],a[(c[d>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=b;b=Bs(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[j>>2]|0)+896>>3],a[(c[d>>2]|0)+2|0]|0)|0;a[(c[m>>2]|0)+2|0]=b;b=Bs(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[j>>2]|0)+856>>3],a[(c[d>>2]|0)+3|0]|0)|0;a[(c[m>>2]|0)+3|0]=b;i=e;return 0}return 0}function fg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;yp(8,1,2808,j);j=b+4|0;l=c[c[j>>2]>>2]|0;m=c[l+16>>2]|0;n=a[m+1|0]|0;o=b+408|0;p=c[o>>2]|0;q=a[p+1|0]|0;if(n<<24>>24==q<<24>>24){r=p;s=m;t=l;u=0}else{c[g>>2]=q<<24>>24;c[g+4>>2]=n<<24>>24;yp(8,0,2840,g);g=c[c[j>>2]>>2]|0;r=c[o>>2]|0;s=c[g+16>>2]|0;t=g;u=1}g=a[s]|0;s=a[r]|0;if(g<<24>>24==s<<24>>24){v=t;w=u}else{c[f>>2]=s<<24>>24;c[f+4>>2]=g<<24>>24;yp(8,0,2920,f);v=c[c[j>>2]>>2]|0;w=1}x=+h[(c[v+8>>2]|0)+40>>3];y=+h[(c[b+400>>2]|0)+40>>3];if(x!=y){b=e;h[k>>3]=y;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=e+8|0;h[k>>3]=x;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];yp(8,0,3e3,e);z=1}else{z=w}if((c[21752>>2]|0)==0){i=d;return z|0}Td[c[5568]&255](8);i=d;return z|0}function gg(a){a=a|0;i=i;return 3072}function hg(a,b){a=a|0;b=b|0;b=i;i=i+8|0;yp(21,1,3080,b);if((c[21804>>2]|0)==0){i=b;return 0}Td[c[5568]&255](21);i=b;return 0}function ig(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1064>>3]=+h[b+1056>>3]*6.283185307179586;i=i;return}function jg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+560>>3]+(+h[b+584>>3]+(+h[b+568>>3]+ +h[b+592>>3]));i=i;return}function kg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+984>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function lg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+560>>3];i=i;return}function mg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function ng(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+560>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function pg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+560>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+760>>3];i=i;return}function rg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+688>>3];i=i;return}function sg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+808>>3];i=i;return}function tg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+696>>3];i=i;return}function ug(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+800>>3];i=i;return}function vg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+680>>3];i=i;return}function wg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+784>>3];i=i;return}function xg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+784>>3];i=i;return}function yg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+672>>3];i=i;return}function zg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+776>>3];i=i;return}function Ag(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+776>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+752>>3]=+h[b+568>>3]*4.0e5;i=i;return}function Cg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+744>>3]=(+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3])*.5)*6.283185307179586;i=i;return}function Dg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+720>>3];i=i;return}function Eg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+552>>3];i=i;return}function Fg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+544>>3];i=i;return}function Gg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=(Ds(.003999999999999997,+h[(c[f>>2]|0)+976>>3])|0)<<24>>24==0;j=+h[(c[f>>2]|0)+976>>3];if(!g){l=(j+.003250000000000001)*201651662697442.0e-20;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+592|0;x=w;h[x>>3]=l;i=b;return}y=j/.006500000000000002*2.0+1.0;if(y>0.0){z=j}else{g=c[16932]|0;A=c[a+536>>2]|0;B=e;h[k>>3]=y;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=g;g=d;C=4016;c[g+0>>2]=c[C+0>>2];c[g+4>>2]=c[C+4>>2];c[g+8>>2]=c[C+8>>2];c[g+12>>2]=c[C+12>>2];c[g+16>>2]=c[C+16>>2];c[g+20>>2]=c[C+20>>2];re[B&31](A,d,3120,e);z=+h[(c[f>>2]|0)+976>>3]}l=(z+.003250000000000001)*+da(+y)*2513274122871835.0e-21;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+592|0;x=w;h[x>>3]=l;i=b;return}function Hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+960>>3];m=+h[j+968>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,3240,3232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4016;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,3264,f);}l=+h[(c[g>>2]|0)+952>>3];m=+da(+n);g=c[(c[b+420>>2]|0)+28>>2]|0;n=+(g|0);do{if(m!=0.0){r=n/m}else{if((g|0)==0){r=n;break}r=n/+Ep(c[b+536>>2]|0,m,3368,3232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+576>>3]=l*r*7895683520871486.0e-21;i=d;return}function Ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,3432,3424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4016;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,3456,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=c[(c[b+420>>2]|0)+24>>2]|0;n=+(g|0);do{if(m!=0.0){r=n/m}else{if((g|0)==0){r=n;break}r=n/+Ep(c[b+536>>2]|0,m,3560,3424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3]=l*r*7895683520871486.0e-21;i=d;return}function Jg(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+552>>3]=+h[(c[a+416>>2]|0)+744>>3]*3.267256359733385e-7;i=i;return}function Kg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+536>>3]=-(+h[b+1016>>3]*+h[b+704>>3]);i=i;return}function Lg(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+528>>3]=+h[b+712>>3]*(+h[b+728>>3]*(+h[b+736>>3]- +h[b+720>>3])+1.0);i=i;return}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,3624,3616,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}function Ng(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,3656,3648,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}function Og(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+512>>3];k=+h[g+536>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,3688,3680,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}function Pg(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+752>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+488>>3]=b*b*+h[d+576>>3]*.5;i=i;return}function Qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=-+h[(c[a+416>>2]|0)+752>>3]- +h[b+536>>3];i=i;return}function Rg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+h[g+536>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,3720,3712,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}function Sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=-(+h[b+528>>3]*+h[(c[a+416>>2]|0)+1016>>3]);i=i;return}function Tg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+480>>3];h[b+432>>3]=d*d*+h[b+560>>3]*.5;i=i;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[b+488>>3]+ +h[b+432>>3];i=i;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-(+h[b+464>>3]*+h[(c[a+416>>2]|0)+1016>>3]);i=i;return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=b+416|0;m=0.0;n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}do{if((a[e]|0)==0){F=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[j+1048>>3]+ +h[j+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=g;break}else{g=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[g+1048>>3]+ +h[g+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;F=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[k+1048>>3]+ +h[k+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=f;break}else{f=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[f+1048>>3]+ +h[f+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;F=g;break}}}}while(0);if(F<<24>>24==0){F=b+416|0;l=F;m=+h[(c[F>>2]|0)+1024>>3];n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}G=+h[c[c[b+4>>2]>>2]>>3];F=b+416|0;e=c[F>>2]|0;H=G- +h[e+1048>>3];I=+h[e+1032>>3];J=+h[e+1024>>3];do{if(I!=0.0){K=J/I}else{if(J==0.0){K=J;break}K=J/+Ep(c[b+536>>2]|0,I,3752,3744,G,(a[b+319|0]|0)!=0|0)}}while(0);l=F;m=H*K;n=c[l>>2]|0;o=n;p=o+1040|0;q=p;r=+h[q>>3];s=m+r;t=b;u=t+4|0;v=u;w=c[v>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+280|0;E=D;h[E>>3]=s;i=d;return}function Xg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1048>>3])|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);if(!(f<<24>>24==0)){l=0.0;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}do{if((a[e]|0)==0){y=a[(c[b+356>>2]|0)+1|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){g=a[(c[b+356>>2]|0)+1|0]|0;j=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[j+1048>>3]+ +h[j+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;y=g;break}else{g=c[b+416>>2]|0;k=Bs(+h[c[c[b+4>>2]>>2]>>3],+h[g+1048>>3]+ +h[g+1032>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;y=k;break}}else{if(f){f=a[(c[b+356>>2]|0)+1|0]|0;k=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[k+1048>>3]+ +h[k+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;y=f;break}else{f=c[b+416>>2]|0;g=Cs(+h[c[c[b+4>>2]>>2]>>3],+h[f+1048>>3]+ +h[f+1032>>3])|0;a[(c[b+352>>2]|0)+1|0]=g;y=g;break}}}}while(0);if(y<<24>>24==0){l=0.0;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}y=c[b+416>>2]|0;z=+h[y+1032>>3];A=+h[y+1024>>3];if(z!=0.0){l=A/z;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}if(A==0.0){l=A;m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}l=A/+Ep(c[b+536>>2]|0,z,3752,3768,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);m=b;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+168|0;x=w;h[x>>3]=l;i=d;return}function Yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[(c[a+416>>2]|0)+912>>3]- +h[b+280>>3];i=i;return}function Zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+280>>3]+ +h[(c[a+416>>2]|0)+816>>3]*-.5;i=i;return}function _g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+264>>3]+ +h[(c[a+416>>2]|0)+816>>3]*-.5;i=i;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+112>>3]- +h[(c[a+416>>2]|0)+920>>3];i=i;return}function ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[(c[a+416>>2]|0)+576>>3]*.5+ +h[b+280>>3];i=i;return}function bh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,3432,3776,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4016;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,3456,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+104>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,3560,3776,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+136|0;x=w;h[x>>3]=u;i=d;return}function ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,3792,3784,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+144|0;p=o;h[p>>3]=m;i=d;return}function dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+480>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,3824,3816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+152|0;p=o;h[p>>3]=m;i=d;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[b+472>>3]-(-+h[b+152>>3]- +h[b+496>>3]);i=i;return}function fh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=1.0;i=i;return}function gh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[d>>3];i=b;return}function hh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,2,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[d>>3];i=b;return}function ih(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Wf(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,3,+h[f+280>>3],+h[f+40>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[d>>3];i=b;return}function jh(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+704>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+344>>3]=b*b*(+h[d+136>>3]+(+h[d+592>>3]+ +h[d+552>>3]));i=i;return}function kh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+120>>3]=(+h[b+936>>3]+ +h[b+944>>3])*+h[d+104>>3]*3.141592653589793;i=i;return}function lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+120>>3];k=+h[g+152>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,3856,3848,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+2|0]|0;q=b+4|0;r=Bs(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=r;e=q;f=p;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{p=b+4|0;q=Bs(+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=q;e=p;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+2|0]|0;q=b+4|0;p=Cs(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3])|0;a[(c[b+352>>2]|0)+2|0]=p;e=q;f=o;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{o=b+4|0;q=Cs(+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+160>>3],+h[(c[b+416>>2]|0)+896>>3])|0;a[(c[b+352>>2]|0)+2|0]=q;e=o;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}}function nh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){g=0.0;j=f;k=j+192|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+160>>3]- +h[e+896>>3]));g=-(+h[e+880>>3]*m*m);j=f;k=j+192|0;l=k;h[l>>3]=g;i=d;return}function oh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+184|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+888>>3]*+h[m+168>>3];j=f;k=j+184|0;l=k;h[l>>3]=g;i=d;return}}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[c[b+16>>2]|0]|0)==0){g=f;j=0.0}else{k=(Cs(+h[f+184>>3],+h[f+192>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+192>>3];break}k=(Es(+h[l+184>>3],-+h[l+192>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+184>>3];break}else{g=l;j=-+h[l+192>>3];break}}}while(0);h[g+176>>3]=j;i=d;return}function qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+192>>3]+ +h[b+176>>3];i=i;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+424>>3]- +h[b+208>>3];i=i;return}function sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+176>>3]*+h[b+168>>3];i=i;return}function th(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;l=Bs(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+4|0;k=Bs(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;j=Cs(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+4|0;k=Cs(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],+h[(c[b+416>>2]|0)+856>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function uh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){g=0.0;j=f;k=j+240|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+216>>3]- +h[e+856>>3]));g=-(+h[e+840>>3]*m*m);j=f;k=j+240|0;l=k;h[l>>3]=g;i=d;return}function vh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+232|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=-(+h[(c[b+416>>2]|0)+848>>3]*+h[m+168>>3]);j=f;k=j+232|0;l=k;h[l>>3]=g;i=d;return}}function wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+1|0]|0)==0){g=f;j=0.0}else{k=(Cs(+h[f+232>>3],+h[f+240>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+240>>3];break}k=(Es(+h[l+232>>3],-+h[l+240>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+232>>3];break}else{g=l;j=-+h[l+240>>3];break}}}while(0);h[g+224>>3]=j;i=d;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+240>>3]+ +h[b+224>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=-(+h[b+224>>3]*+h[b+168>>3]);i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=-+h[b+256>>3]- +h[b+272>>3];i=i;return}function Ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=+h[(c[a+416>>2]|0)+704>>3]*+h[b+312>>3];i=i;return}function Bh(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0;d=i;e=b+416|0;do{if((Es(+U(+-+h[(c[e>>2]|0)+1016>>3]),1.0e-13)|0)<<24>>24==0){f=c[(c[c[b+4>>2]>>2]|0)+8>>2]|0;g=+h[f+304>>3]*1.0e13;j=f}else{k=+h[(c[e>>2]|0)+1016>>3];f=b+4|0;l=c[c[f>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+304>>3];o=-n;if(k!=0.0){g=o/k;j=m;break}if(n==-0.0){g=o;j=m;break}n=o/+Ep(c[b+536>>2]|0,k,3888,3880,+h[l>>3],(a[b+319|0]|0)!=0|0);g=n;j=c[(c[c[f>>2]>>2]|0)+8>>2]|0}}while(0);h[j+296>>3]=+U(+g);i=d;return}function Ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[(c[a+416>>2]|0)+576>>3]*.5- +h[b+280>>3];i=i;return}function Dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+960>>3];m=+h[j+968>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,3240,3904,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4016;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,3264,f);}l=+h[(c[g>>2]|0)+952>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+56>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,3368,3904,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+80|0;x=w;h[x>>3]=u;i=d;return}function Eh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,3920,3912,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+88|0;p=o;h[p>>3]=m;i=d;return}function Fh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3];k=+h[(c[b+416>>2]|0)+752>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,3952,3944,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}function Gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+152>>3]+ +h[b+96>>3];i=i;return}function Hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+312>>3]+ +h[b+96>>3]- +h[b+496>>3]- +h[b+288>>3]- +h[b+472>>3];i=i;return}function Ih(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+64>>3]=(+h[b+960>>3]+ +h[b+968>>3])*+h[d+56>>3]*3.141592653589793;i=i;return}function Jh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3];k=+h[g+96>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}q=k/+Ep(c[b+536>>2]|0,j,3984,3976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+72|0;p=o;h[p>>3]=m;i=d;return}function Kh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,3432,4008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4016;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,3456,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=b+4|0;f=c[c[g>>2]>>2]|0;e=c[f+8>>2]|0;n=+h[e+168>>3];if(m!=0.0){r=e;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=e;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}y=n/+Ep(c[b+536>>2]|0,m,3560,4008,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+368|0;x=w;h[x>>3]=u;i=d;return}function Lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];k=j*j;j=+h[g+368>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}j=l/+Ep(c[b+536>>2]|0,k,4048,4040,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function Mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+144>>3];k=+h[g+152>>3]*+h[g+360>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,3824,4072,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=-(+h[(c[a+416>>2]|0)+704>>3]*+h[b+352>>3]);i=i;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+464>>3]+ +h[b+320>>3];i=i;return}function Ph(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+664>>3];i=i;return}function Qh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+768>>3];i=i;return}function Rh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=0.0;i=i;return}function Sh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+608>>3]=0.0;i=i;return}function Th(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+600>>3]=0.0;i=i;return}function Uh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+584>>3]=0.0;i=i;return}function Vh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+568>>3]=0.0;i=i;return}function Wh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3]=1.0e-13;i=i;return}function Xh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+504>>3]=0.0;i=i;return}function Yh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+456>>3]=0.0;i=i;return}function Zh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+448>>3]=0.0;i=i;return}function _h(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3]=0.0;i=i;return}function $h(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+416>>3]=0.0;i=i;return}function ai(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+408>>3]=0.0;i=i;return}function bi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+400>>3]=0.0;i=i;return}function ci(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3]=0.0;i=i;return}function di(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+384>>3]=0.0;i=i;return}function ei(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);a[d]=0;i=c;return 0}function fi(a){a=a|0;i=i;return}function gi(a){a=a|0;i=i;return 0}function hi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+872>>3];i=i;return}function ii(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+216>>3]=+h[(c[a+416>>2]|0)+832>>3];i=i;return}function ji(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0;b=i;i=i+8|0;d=i;i=i+16|0;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;yp(9,1,4080,j);if((c[21756>>2]|0)!=0){Td[c[5568]&255](9)}yp(9,1,4104,g);if((c[21756>>2]|0)!=0){Td[c[5568]&255](9)}hi(a);ii(a);yp(9,1,4128,f);f=a+4|0;l=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3];g=a+8|0;a=c[g>>2]|0;h[a+2320>>3]=l;c[e>>2]=c[a+2244>>2];a=e+4|0;h[k>>3]=l;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];yp(9,0,4152,e);l=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+216>>3];f=c[g>>2]|0;h[f+3104>>3]=l;c[d>>2]=c[f+3028>>2];f=d+4|0;h[k>>3]=l;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];yp(9,0,4152,d);if((c[21756>>2]|0)!=0){Td[c[5568]&255](9)}yp(9,1,4168,b);if((c[21756>>2]|0)==0){i=b;return 0}Td[c[5568]&255](9);i=b;return 0}function ki(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+384>>3]=0.0;i=i;return}function li(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3]=0.0;i=i;return}function mi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+400>>3]=0.0;i=i;return}function ni(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+408>>3]=0.0;i=i;return}function oi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+416>>3]=0.0;i=i;return}function pi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3]=0.0;i=i;return}function qi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+448>>3]=0.0;i=i;return}function ri(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+456>>3]=0.0;i=i;return}function si(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+504>>3]=0.0;i=i;return}function ti(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3]=1.0e-13;i=i;return}function ui(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+568>>3]=0.0;i=i;return}function vi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+584>>3]=0.0;i=i;return}function wi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+600>>3]=0.0;i=i;return}function xi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+608>>3]=0.0;i=i;return}function yi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+616>>3]=0.0;i=i;return}function zi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+704>>3]=+h[b+544>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+536>>3]=-(+h[b+1016>>3]*+h[b+704>>3]);i=i;return}function Bi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+552>>3];i=i;return}function Ci(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+720>>3];i=i;return}function Di(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+528>>3]=+h[b+712>>3]*(+h[b+728>>3]*(+h[b+736>>3]- +h[b+720>>3])+1.0);i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=-(+h[b+528>>3]*+h[(c[a+416>>2]|0)+1016>>3]);i=i;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=-(+h[b+464>>3]*+h[(c[a+416>>2]|0)+1016>>3]);i=i;return}function Gi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+744>>3]=(+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3])*.5)*6.283185307179586;i=i;return}function Hi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+552>>3]=+h[(c[a+416>>2]|0)+744>>3]*3.267256359733385e-7;i=i;return}function Ii(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+552>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,4200,4192,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+520|0;p=o;h[p>>3]=m;i=d;return}function Ji(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+520>>3];k=+h[g+536>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,4232,4224,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+472|0;q=p;h[q>>3]=n;i=d;return}function Ki(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+752>>3]=+h[b+568>>3]*4.0e5;i=i;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=-+h[(c[a+416>>2]|0)+752>>3]- +h[b+536>>3];i=i;return}function Mi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+h[b+664>>3];i=i;return}function Ni(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+672>>3];i=i;return}function Oi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+680>>3];i=i;return}function Pi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+696>>3];i=i;return}function Qi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+688>>3];i=i;return}function Ri(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+760>>3];i=i;return}function Si(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+768>>3];i=i;return}function Ti(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+776>>3];i=i;return}function Ui(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+784>>3];i=i;return}function Vi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+776>>3];i=i;return}function Wi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+784>>3];i=i;return}function Xi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+800>>3];i=i;return}function Yi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+920>>3]=+h[b+808>>3];i=i;return}function Zi(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+560>>3];i=i;return}function _i(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function $i(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+936>>3];m=+h[j+944>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,4264,4256,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4648;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,4296,f);}l=+h[(c[g>>2]|0)+928>>3];m=+da(+n);g=c[(c[b+420>>2]|0)+24>>2]|0;n=+(g|0);do{if(m!=0.0){r=n/m}else{if((g|0)==0){r=n;break}r=n/+Ep(c[b+536>>2]|0,m,4400,4256,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+560>>3]=l*r*7895683520871486.0e-21;i=d;return}function aj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+480>>3];h[b+432>>3]=d*d*+h[b+560>>3]*.5;i=i;return}function bj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+560>>3];i=i;return}function cj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+968>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+960>>3];m=+h[j+968>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+Ep(c[b+536>>2]|0,l,4464,4456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[16932]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4648;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];re[p&31](o,e,4488,f);}l=+h[(c[g>>2]|0)+952>>3];m=+da(+n);g=c[(c[b+420>>2]|0)+28>>2]|0;n=+(g|0);do{if(m!=0.0){r=n/m}else{if((g|0)==0){r=n;break}r=n/+Ep(c[b+536>>2]|0,m,4592,4456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+576>>3]=l*r*7895683520871486.0e-21;i=d;return}function ej(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+752>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+488>>3]=b*b*+h[d+576>>3]*.5;i=i;return}function fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[b+488>>3]+ +h[b+432>>3];i=i;return}function gj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+976>>3]=+h[b+560>>3];i=i;return}function hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=(Ds(.003999999999999997,+h[(c[f>>2]|0)+976>>3])|0)<<24>>24==0;j=+h[(c[f>>2]|0)+976>>3];if(!g){l=(j+.003250000000000001)*201651662697442.0e-20;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+592|0;x=w;h[x>>3]=l;i=b;return}y=j/.006500000000000002*2.0+1.0;if(y>0.0){z=j}else{g=c[16932]|0;A=c[a+536>>2]|0;B=e;h[k>>3]=y;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=g;g=d;C=4648;c[g+0>>2]=c[C+0>>2];c[g+4>>2]=c[C+4>>2];c[g+8>>2]=c[C+8>>2];c[g+12>>2]=c[C+12>>2];c[g+16>>2]=c[C+16>>2];c[g+20>>2]=c[C+20>>2];re[B&31](A,d,4672,e);z=+h[(c[f>>2]|0)+976>>3]}l=(z+.003250000000000001)*+da(+y)*2513274122871835.0e-21;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+592|0;x=w;h[x>>3]=l;i=b;return}function ij(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+592>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}q=+Ep(c[b+536>>2]|0,j,4792,4784,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+512|0;p=o;h[p>>3]=m;i=d;return}function jj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+512>>3];k=+h[g+536>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}k=l/+Ep(c[b+536>>2]|0,j,4824,4816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+496|0;q=p;h[q>>3]=n;i=d;return}function kj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+984>>3]=+h[b+560>>3]+(+h[b+584>>3]+ +h[b+568>>3]);i=i;return}function lj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+992>>3]=+h[b+560>>3]+(+h[b+584>>3]+(+h[b+568>>3]+ +h[b+592>>3]));i=i;return}function mj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1064>>3]=+h[b+1056>>3]*6.283185307179586;i=i;return}function nj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[4848]&1){i=d;return}g=b+420|0;b=Fs(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Ds(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gq(4864,eq(c[(c[g>>2]|0)+32>>2]|0,4856)|0)|0;g=c[16934]|0;h=e;j=5184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ne[g&15](e,b,f);a[4848]=1;i=d;return}



function $q(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[3822]=.5;h[3808]=1.0;h[3845]=.25;h[3820]=2.0;h[3847]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[7652]=A;B=c[d>>2]|0;c[7582]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[7582]=D;if((C|0)<(B|0)){C=D}else{break}}}c[7580]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[3823]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[3823]=F;G=F}else{G=E}D=c[d>>2]|0;c[7582]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[7582]=I;if((H|0)>=(D|0)){break a}E=+h[3823];H=I}}}while(0);D=C+1|0;c[7580]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[3827]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[3792]=0.0;h[3794]=0.0;h[3798]=0.0;h[3855]=0.0;c[7578]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[3792]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[3794]+ +h[B>>3]*F;h[3794]=E;F=+h[I>>3];M=+h[3798]+F*F;h[3798]=M;F=+h[H>>3];h[3855]=+h[3855]+F*F;H=A+1|0;c[7578]=H;F=+h[3792];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[7648]=A;E=G/J;h[3844]=E;C=c[d>>2]|0;c[7582]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[3852]=0.0;h[3854]=0.0;I=c[b>>2]|0;c[7578]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[3821]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[3852]=ba;ca=E+aa*aa;h[3854]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[7578]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[7648]=A;h[3844]=E;h[3794]=Z;h[3798]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[7582]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[7578]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[7578]=A+1;da=+h[3794];ea=+h[3798];ga=+h[3792]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[3843]=K;c[7676]=0;h[3851]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[7676]=C;K=+h[3808]/+V(+ga);h[3823]=K;h[3846]=0.0;h[3848]=0.0;B=c[b>>2]|0;c[7578]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[3846]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[3846]=oa;pa=+h[3848]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[3848]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[3794];L=+h[3792];N=+h[3823];D=D+1|0;la=ma}c[7578]=B+1;ia=+h[3792];ja=pa;ka=oa}N=+h[3822];L=ka*N*ka;h[3839]=L;J=ja*N*ja;h[3840]=J;h[3799]=J+(L+ia*(+h[3855]+ia*N));N=+h[3820];h[30400>>3]=N*ka*ia;h[30408>>3]=N*ja*ia;h[30416>>3]=L-J;h[30424>>3]=ka*ja;la=30432|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[7578]=10;la=c[d>>2]|0;c[7582]=1;if((la|0)>=1){D=1;while(1){h[3839]=0.0;h[3840]=0.0;h[3841]=0.0;A=c[b>>2]|0;c[7578]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[3839]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[3840]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[3841]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[7578]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[3845]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[3839]*+h[3841];h[t+(U+D<<3)>>3]=+h[3840]*+h[3841];J=+h[3839];L=+h[3840];h[t+(P+D<<3)>>3]=+h[3845]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[3822]*+h[3839]*+h[3840];na=D+1|0;c[7582]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[7578]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[7590]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[7578]=B;if((la|0)<(D|0)){la=B}else{break}}}c[7586]=1;la=1;do{D=c[d>>2]|0;c[7594]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[7594]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[7582]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[7582]=D+1}na=c[7652]|0;c[7580]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[3819]=0.0;ma=c[d>>2]|0;c[7582]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[3819]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[7582]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[3819]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[7582]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[3819];Ca=Ca+1|0}c[7582]=ta+1}Ca=B+1|0;c[7580]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[7582]=1;if((A|0)<1){break}else{Ea=1}while(1){h[3819]=0.0;B=c[b>>2]|0;c[7580]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[3819]=N;Ca=na+1|0;c[7580]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[7582]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[7580]=1;if((A|0)>=1){ta=1;while(1){h[3819]=0.0;c[7578]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[3819]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[7578]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[7580]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[7586]=la;}while((la|0)<6);la=c[l>>2]|0;c[7582]=1;h[3819]=0.0;c[7578]=1;L=+h[3822];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[30472+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[30472+(A+ -1<<3)>>3]+L;h[3819]=L;A=A+1|0;}while((A|0)<6);h[3799]=+h[3799]- +h[3809]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[3839]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[3840]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[3841]=O;h[30400>>3]=+h[30400>>3]-J-N*(O+K);h[30432>>3]=+h[30432>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[3839]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[3840]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[3841]=J;h[30408>>3]=+h[30408>>3]-O-N*(K-J);h[30440>>3]=+h[30440>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[3839]=J;h[30416>>3]=+h[30488>>3]+(+h[30416>>3]-J- +h[30480>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[3839]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[3840]=K;Oa=+h[3822];h[30424>>3]=+h[30424>>3]-J-K*Oa;h[30448>>3]=+h[30448>>3]- +h[30496>>3]+ +h[30504>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[3839]=K;h[30456>>3]=+h[30456>>3]-Oa*K;h[3819]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[7582]=la+1;c[7578]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[30472+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[30472+(ta+ -1<<3)>>3]+N;h[3819]=N;ta=ta+1|0;c[7578]=ta;}while((ta|0)<6);K=+h[3827];h[3829]=K*+h[3799]+ +h[3809]+N;J=+h[3820];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[3839]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[3840]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[3841]=R;T=R+(K*+h[30400>>3]+O+S);h[30640>>3]=T;O=K*+h[30432>>3]+S-R;h[30672>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[3839]=R;S=+h[I>>3]*+h[ma>>3];h[3840]=S;Z=+h[Ma>>3]*+h[Na>>3];h[3841]=Z;h[30648>>3]=K*+h[30408>>3]+R+S-Z;h[30680>>3]=K*+h[30440>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[3839]=Z;R=+h[30480>>3]+(Z+K*+h[30416>>3])- +h[30488>>3];h[30656>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[3839]=Z;h[30664>>3]=Z+K*+h[30424>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[30448>>3]+ +h[30496>>3]- +h[30504>>3];h[30688>>3]=J;h[30696>>3]=+h[3827]*+h[30456>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[3829]+T+R+O+J;h[3819]=K;h[3849]=K;h[3850]=K;c[7684]=0;J=+h[3847]/50.0;h[3823]=J;h[3809]=+h[3808];c[7578]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[30480>>3]=Z;W=+Y(+Pa);h[30488>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[30472+(Ma+ -1<<3)>>3]=Z;Q=+h[30480>>3]*G+ +h[30488>>3]*W;h[30472+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[30488>>3];ca=+h[30480>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[30632+(Ma<<3)>>3]*+h[30472+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[3850]=Ra;c[7684]=Na;h[3839]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[3840]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[7580]=10;h[3819]=Ra;h[3828]=Pa;h[3853]=O;c[7578]=50;if((Xa|0)==49){h[3840]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[3839]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[3825]=0.0;if(Ya!=Za){S=Ya-Ua;h[3839]=S;T=Za-Ua;h[3840]=T;R=+h[3822]*(S-T)/(S+T);h[3825]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[3828]=R;T=+X(+R);h[30480>>3]=T;S=+Y(+R);h[30488>>3]=S;c[7580]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[30472+(Na+ -1<<3)>>3]=T;W=+h[30480>>3]*G+ +h[30488>>3]*S;h[30472+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[30488>>3];N=+h[30480>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[3850]=0.0;c[7580]=1;Na=1;do{ma=Na+ -1|0;Ma=30472+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[30392+(ma<<3)>>3]*+h[Ma>>3];h[3850]=+h[3850]+ +h[30632+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[7580]=10;Na=c[l>>2]|0;c[7582]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[30472+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[7580]=6;c[7582]=Na+1}h[3818]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[3792]=0.0;h[3839]=0.0;h[3840]=0.0;Ma=c[b>>2]|0;c[7578]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[30480>>3]*+h[la>>3]+ +h[30488>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[3792]=+h[3792]+G*G;bb=+h[3839]+ +h[la>>3]*+h[ta>>3];h[3839]=bb;G=+h[ta>>3];cb=+h[3840]+G*G;h[3840]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[7578]=Ma+1;$a=cb;ab=bb}ma=c[7676]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[3851];S=+h[3849];h[3851]=G>=S?G:S}S=+h[3850];if(!(S>=0.0)){db=-S}else{db=S}G=+h[3851];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[3851]=S;c[7578]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[3823]=N;R=+h[3818]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[3827];la=ta+1|0;c[7578]=la;if((ta|0)>=(Na|0)){break b}S=+h[3840];G=+h[3839];ta=la}}}while(0);Na=c[d>>2]|0;c[7582]=1;if((Na|0)>=1){Ma=1;while(1){h[3819]=0.0;ta=c[b>>2]|0;c[7580]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[3819]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[7580]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[3818]*+h[p+(la+ -1+Ma<<3)>>3]- +h[3827]*+h[q+(Ma+ -1<<3)>>3]);h[3823]=G;c[7578]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[3823];I=I+1|0}c[7578]=la+1}I=Ma+1|0;c[7582]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[3798]=0.0;h[3794]=0.0;Ma=c[b>>2]|0;c[7578]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[3798]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[3794]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[7578]=Ma+1;hb=kb;ib=jb}S=+h[3792];G=S*ib-hb*hb;h[3843]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[30368]=1;C=c[l>>2]|0;c[7582]=1;if((C|0)<1){lb=30464;mb=+h[3808];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[30472+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[7580]=6;c[7582]=C+1;lb=30464;mb=+h[3808];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function ar(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[3875]=.5;h[3871]=1.0;h[3887]=6.283185307179586;z=+h[n>>3];h[3884]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[7756]=A;c[7764]=0;B=c[d>>2]|0;c[7716]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[7716]=B+1}c[7714]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[3876]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[3876]=F;G=F}else{G=z}H=c[d>>2]|0;c[7716]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[3876];I=I+1|0}c[7716]=H+1}I=B+1|0;c[7714]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[3859]=0.0;D=c[b>>2]|0;c[7712]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[3859]=+h[3859]+G*G;A=p+1|0;c[7712]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[7716]=1;if((p|0)>=1){D=1;while(1){h[3876]=0.0;h[3874]=0.0;y=c[b>>2]|0;c[7714]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[3876]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[3874]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[7714]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[3876]=G;h[3874]=+h[g>>3]*L;g=c[b>>2]|0;c[7712]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[3874]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[3876];H=H+1|0}c[7712]=g+1}H=D+1|0;c[7716]=H;if((D|0)<(p|0)){D=H}else{break}}}h[3860]=0.0;h[3862]=0.0;h[3869]=0.0;D=c[b>>2]|0;c[7712]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[3860]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[3862]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[3869]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[7712]=D+1;O=R;P=T;Q=S}S=+h[3859];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[3880]=U;h[3876]=0.0;if(Q*Q>S*.99*O){h[3876]=+h[3871]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[3875]*U*Z);h[3872]=P;if(O*+h[3884]<P*P*.01){h[3876]=+h[3871]}n=c[b>>2]|0;c[7712]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[3880]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[3876]*U;if((D|0)>=(n|0)){break}e=D;P=+h[3880];D=D+1|0;p=e}c[7712]=n+1;_=0}while(1){n=_+1|0;c[7764]=n;h[3859]=0.0;h[3862]=0.0;h[3863]=0.0;p=c[b>>2]|0;c[7712]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[3859]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[3862]=da;Z=+h[H>>3];ea=P+Z*Z;h[3863]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[7712]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[3876]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[3881]=U;D=c[b>>2]|0;c[7712]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[3881];U=+h[3862];O=+h[3859];g=g+1|0;H=e}c[7712]=D+1}H=c[d>>2]|0;c[7716]=1;if((H|0)>=1){g=1;while(1){h[3874]=0.0;p=c[b>>2]|0;c[7714]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[3874]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[7714]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[3874]=O;e=c[b>>2]|0;c[7712]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[3874];l=l+1|0}c[7712]=e+1}l=g+1|0;c[7716]=l;if((g|0)<(H|0)){g=l}else{break}}}h[3864]=0.0;h[3865]=0.0;h[3866]=0.0;h[3867]=0.0;h[3868]=0.0;g=c[b>>2]|0;c[7712]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[3864]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[3865]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[3866]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[3867]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[3868]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[7712]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[3875];O=U*na;h[3864]=O;P=U*ma-O;h[3867]=P;Z=O+la+P;h[3888]=Z;h[3890]=Z;h[3889]=Z;c[7766]=0;a[30888]=1;W=+h[3887]/50.0;h[3876]=W;c[7712]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[3890]=wa;c[7766]=p;h[3885]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[3886]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[3879]=ta;h[3870]=ua;h[3873]=va;h[3872]=wa;c[7712]=50;h[3889]=wa;if((za|0)==0){h[3885]=wa;ga=74}else if((za|0)==49){h[3886]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[3886]}h[3877]=0.0;S=+h[3885];if(S!=Ba){Q=S-Aa;h[3885]=Q;S=Ba-Aa;h[3886]=S;T=U*(Q-S)/(Q+S);h[3877]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[3879]=T;S=+X(+T);h[3870]=S;Q=+Y(+T);h[3873]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[3872]=T;p=c[b>>2]|0;c[7712]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[3870]*+h[y>>3]+ +h[3873]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[3873];Q=+h[3870];H=H+1|0;g=e}c[7712]=p+1;Da=+h[3872]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[3888];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function br(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[31344]=1;a[31336]=1;c[31356>>2]=6;hI(31352)|0;e=c[d>>2]|0;c[7832]=1;if((e|0)>=1){d=1;do{yH(31472,b+(d+ -1)|0,1)|0;o=c[7832]|0;d=o+1|0;c[7832]=d;}while((o|0)<(e|0))}RH()|0;e=c[g>>2]|0;if((e|0)==1){c[31380>>2]=a[31336]&1?6:0;hI(31376)|0;yH(31472,h,4)|0;RH()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[31404>>2]=a[31336]&1?6:0;hI(31400)|0;yH(31472,h,4)|0;yH(31472,j,4)|0;RH()|0}j=c[k>>2]|0;if((j|0)==1){c[31428>>2]=a[31336]&1?6:0;hI(31424)|0;yH(31472,l,8)|0;RH()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[31452>>2]=a[31336]&1?6:0;hI(31448)|0;yH(31472,l,8)|0;yH(31472,m,8)|0;RH()|0}if((c[f>>2]|0)==2){iH(31480,0)|0}else{i=n;return 0}return 0}function cr(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==0){c[7874]=2;C=2;while(1){D=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[7874]=D;if((D|0)<12){C=D}else{break}}if((c[d>>2]|0)<1){nH(31552,33248,80,25);C=31856;D=31864;br(31552,33280,32032,C,31936,d,C,C,D,D,80)|0;break}c[7938]=5;D=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[D>>2]|0;c[7938]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}nH(31552,33288,80,34);C=31856;F=31864;br(31552,33328,32024,C,31936,31752,C,C,F,F,80)|0;break a}}while(0);c[D>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[7924]=C;c[7936]=C+50+(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){nH(31552,34112,80,52);I=31856;J=31864;br(31552,34096,34168,I,31936,G,I,I,J,J,80)|0;break a}c[7924]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[D>>2]|0)+4|0,H)|0;c[7936]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[7924]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[7936]=F+(c[7924]|0);break b}}}while(0);nH(31552,34040,80,52);C=31856;F=31864;br(31552,34096,34104,C,31936,q,C,C,F,F,80)|0;break a}}while(0);c[7928]=(c[d>>2]|0)+20;c[q+64>>2]=c[7924];if((c[p>>2]|0)<(c[7936]|0)){nH(31552,33336,80,60);D=31856;F=31864;br(31552,33400,33408,D,32032,31744,p,D,F,F,80)|0;break}if((c[r>>2]|0)<(c[7928]|0)){nH(31552,33416,80,60);F=31856;D=31864;br(31552,33400,33480,F,32032,31712,r,F,D,D,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){nH(31552,34224,80,24);D=31936;F=31856;C=31864;br(31552,34256,34264,D,D,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[3959]=K;if(!(K<=0.0)){break}nH(31552,33720,80,28);C=31856;br(31552,32432,33752,C,C,C,C,31936,31672,31864,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;B=27}else if((A|0)==-1){nH(31552,31784,80,49);C=31856;F=31864;br(31552,31840,31848,C,C,C,C,C,F,F,80)|0;nH(31552,31872,80,47);F=31856;C=31864;br(31552,31920,31928,F,31936,n,F,F,C,C,80)|0;nH(31552,31944,80,41);C=31856;F=31864;br(31552,31992,32e3,31936,C,C,C,C,F,F,80)|0;i=y;return 0}else{B=210}}while(0);c:do{if((B|0)==27){a[31728]=0;K=+h[l>>3];h[3970]=K;L=+h[m>>3];h[3963]=L;A=c[d>>2]|0;c[7874]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[3970]=O;P=+h[m+(F<<3)>>3];h[3963]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[31728]=1;S=1}else{S=p}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}F=E+1|0;c[7874]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[7884]=p;r=p+(c[w>>2]|0)|0;c[7886]=r;p=r+(c[w>>2]|0)|0;c[7908]=p;F=p+(c[w>>2]|0)|0;c[7878]=F;C=F+(c[d>>2]|0)|0;c[7914]=C;D=C+(c[d>>2]|0)|0;c[7920]=D;c[7910]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+D;c[7934]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){C=o+64|0;h[3972]=+h[C>>3];a[31664]=0;h[3941]=+h[o+24>>3];J=o+16|0;h[3936]=+h[J>>3];do{if((c[w>>2]|0)!=0){dr(32032,v,w,d,31528,j,f,o+(F+ -1<<3)|0,o+(D+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,31648,C,0,o,q,s,t)|0;if((c[8004]|0)>0){i=y;return 0}if((c[7912]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=31936;Ar(d,o+((c[7878]|0)+ -1<<3)|0,G,g,G)|0;a[31664]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[3936];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[3936]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[3936];if((M-N)*P>0.0){B=220;break}C=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[3971]=O;U=+h[3941];V=U-O;G=V*P>0.0;do{if(C){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[7920]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){ir(31528,j,f,g,d,H,I,X)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31664]=1;B=197;break d}}else{Y=31528;ir(Y,Y,f,g,d,H,I,X)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[3941];c[n>>2]=1;a[31664]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31664]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[3972]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[3936]=W;h[J>>3]=W;break}ir(31528,31768,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[3971];a[31664]=1;B=197;break d}}else{W=+h[3941];if(!C){if(P*(W-N)<0.0){break}ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31664]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[7920]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){ir(31528,j,f,g,d,G,X,I)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[31664]=1;B=197;break d}}else{H=31528;ir(H,H,f,g,d,G,X,I)|0;if((c[8004]|0)>0){i=y;return 0}else{h[e>>3]=+h[3941];c[n>>2]=1;a[31664]=1;B=197;break d}}}}while(0);if(a[31664]&1){B=197}else{B=128}}else{h[3941]=+h[e>>3];c[n>>2]=1;fr(d,k+4|0,l,m,f,o+((c[7914]|0)+ -1<<3)|0,s,t)|0;C=c[d>>2]|0;c[7874]=1;e:do{if((C|0)>=1){J=c[7914]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[7874]=X;if((I|0)<(C|0)){I=X}else{break e}}nH(31552,33856,80,39);I=31856;J=31864;br(31552,33528,33896,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+mr(32008,1);h[3972]=U;C=o+64|0;h[C>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[3972]*4.0*(aa>=ba?aa:ba);h[3961]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){nH(31552,33904,80,60);J=31856;br(31552,33400,33968,J,J,J,J,32032,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[3940]=ca*.001;U=+gr(d,g,o+((c[7914]|0)+ -1<<3)|0,s,t);if(U>.5/+h[3940]){h[3940]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+mH(31520,z);h[3940]=U;da=U}else{U=+h[o+16>>3];h[3940]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}nH(31552,33808,80,29);J=31856;I=31864;br(31552,33840,33848,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[3940]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[3971]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[3940]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{hr(31528,f,g,d,b,u,31520,o+((c[7914]|0)+ -1<<3)|0,n,s,t,o+((c[7920]|0)+ -1<<3)|0,o+400|0,o+((c[7878]|0)+ -1<<3)|0,o+((c[7910]|0)+ -1<<3)|0,q,31688,C,k+36|0,31736)|0;if((c[8004]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[3940]}h[3936]=ja;h[o+16>>3]=ja;J=c[7920]|0;X=(c[d>>2]|0)+J|0;c[7930]=X;G=c[d>>2]|0;c[7874]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[3936]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[7874]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[3936];h[o+232>>3]=+h[3936]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}dr(31936,v,w,d,e,j,f,o+((c[7878]|0)+ -1<<3)|0,o+((c[7920]|0)+ -1<<3)|0,J,Y,o+((c[7884]|0)+ -1<<3)|0,o+((c[7886]|0)+ -1<<3)|0,o+((c[7908]|0)+ -1<<3)|0,x,31648,C,0,o,q,s,t)|0;if((c[8004]|0)>0){i=y;return 0}if((c[7912]|0)!=0){nH(31552,34272,80,47);la=31856;ma=31864;br(31552,31920,34320,31936,la,la,la,la,ma,ma,80)|0;nH(31552,34328,80,38);ma=31856;la=31864;br(31552,32080,34320,31936,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}dr(32024,v,w,d,31528,j,f,o+((c[7878]|0)+ -1<<3)|0,o+((c[7920]|0)+ -1<<3)|0,J,Y,o+((c[7884]|0)+ -1<<3)|0,o+((c[7886]|0)+ -1<<3)|0,o+((c[7908]|0)+ -1<<3)|0,x,31648,C,0,o,q,s,t)|0;if((c[8004]|0)>0){i=y;return 0}if((c[7912]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=31936;Ar(d,o+((c[7878]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){nH(31552,33648,80,54);p=31856;br(31552,33704,33712,p,p,p,p,32032,31768,j,80)|0;break c}else if((B|0)==220){nH(31552,33760,80,34);p=31856;br(31552,33328,33800,p,p,p,p,32032,j,e,80)|0;break c}else if((B|0)==224){nH(31552,33976,80,49);p=31856;br(31552,31840,34032,p,p,p,p,32032,31768,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;fr(d,oa,l,m,o+((c[7920]|0)+ -1<<3)|0,o+((c[7914]|0)+ -1<<3)|0,s,t)|0;if((c[8004]|0)>0){B=233;break}p=c[d>>2]|0;c[7874]=1;r=c[7914]|0;if((p|0)>=1){E=1;while(1){D=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){B=136;break f}c[7874]=D;if((E|0)<(p|0)){E=D}else{break}}}O=+gr(d,o+((c[7920]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[3972];pa=O*V;h[3938]=pa;if(!(pa<=1.0)){B=138;break}O=+h[3941];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[3961]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[3936];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[3936]=V/O}}while(0);jr(31528,f,g,d,b,u,31488,o+((c[7914]|0)+ -1<<3)|0,k,n,s,t,o+((c[7920]|0)+ -1<<3)|0,o+400|0,o+((c[7878]|0)+ -1<<3)|0,o+((c[7910]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,31688,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,31736)|0;if((c[8004]|0)>0){B=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){dr(32024,v,w,d,31528,j,f,o+((c[7878]|0)+ -1<<3)|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[7884]|0)+ -1<<3)|0,o+((c[7886]|0)+ -1<<3)|0,o+((c[7908]|0)+ -1<<3)|0,x,31648,o+64|0,0,o,q,s,t)|0;if((c[8004]|0)>0){B=233;break f}if((c[7912]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=31936;Ar(d,o+((c[7878]|0)+ -1<<3)|0,r,g,r)|0;B=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[3941];V=+h[3936];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){B=128;continue}ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(r){if(U>=0.0){ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[3971];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[3972]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}ir(31528,31768,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[3971];B=197;continue}if(!(U<0.0)){ir(31528,j,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[3971];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[3972]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[3936]=U-O;B=128;continue}else{ir(31528,31768,f,g,d,q+28|0,o+((c[7920]|0)+ -1<<3)|0,o+224|0)|0;if((c[8004]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[3971];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[3941];h[o+16>>3]=+h[3936];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[3938]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[7874]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){C=l+(p<<3)|0;h[C>>3]=O*+h[C>>3];C=m+(E+ -1<<3)|0;h[C>>3]=+h[3938]*+h[C>>3];if((E|0)>=(r|0)){break}C=E;O=+h[3938];E=E+1|0;p=C}c[7874]=r+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);p=0-na|0;c[7930]=p;switch(p|0){case 8:{nH(31552,32448,80,44);p=31856;br(31552,32496,32704,p,p,p,p,32032,31528,31488,80)|0;nH(31552,32712,80,37);p=31856;E=31864;br(31552,32752,32760,p,p,p,p,p,E,E,80)|0;break};case 9:{nH(31552,32448,80,44);E=31856;br(31552,32496,32768,E,E,E,E,32032,31528,31488,80)|0;nH(31552,32776,80,49);E=31856;p=31864;br(31552,31840,32832,E,E,E,E,E,p,p,80)|0;nH(31552,32840,80,38);p=31856;E=31864;br(31552,32080,32880,p,p,p,p,p,E,E,80)|0;break};case 10:{nH(31552,32448,80,44);E=31856;br(31552,32496,32888,E,E,E,E,32032,31528,31488,80)|0;nH(31552,32896,80,45);E=31856;p=31864;br(31552,32336,32944,E,E,E,E,E,p,p,80)|0;nH(31552,32952,80,36);p=31856;E=31864;br(31552,32992,33e3,p,p,p,p,p,E,E,80)|0;break};case 11:{nH(31552,33008,80,40);E=31856;br(31552,33056,33064,E,E,E,E,32032,31528,31488,80)|0;nH(31552,33072,80,36);E=31856;p=31864;br(31552,32992,33112,E,E,E,E,E,p,p,80)|0;break};case 12:{nH(31552,32448,80,44);p=31856;br(31552,32496,33120,p,p,p,p,32032,31528,31520,80)|0;nH(31552,33128,80,45);p=31856;E=31864;br(31552,32336,33176,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};case 2:{nH(31552,32168,80,47);E=31856;br(31552,31920,32216,E,E,E,E,31936,31528,31864,80)|0;nH(31552,32224,80,48);E=31856;p=31864;br(31552,32152,32280,E,E,E,E,E,p,p,80)|0;nH(31552,32288,80,45);p=31856;E=31864;br(31552,32336,32344,p,p,p,p,p,E,E,80)|0;break};case 3:{nH(31552,32352,80,38);E=31856;br(31552,32080,32392,E,E,E,E,31936,31528,31864,80)|0;nH(31552,32400,80,28);E=31856;p=31864;br(31552,32432,32440,E,E,E,E,E,p,p,80)|0;break};case 6:{nH(31552,32448,80,44);p=31856;br(31552,32496,32504,p,p,p,p,32032,31528,31488,80)|0;nH(31552,32512,80,57);p=31856;E=31864;br(31552,32576,32584,p,p,p,p,p,E,E,80)|0;break};case 7:{nH(31552,32448,80,44);E=31856;br(31552,32496,32592,E,E,E,E,32032,31528,31488,80)|0;nH(31552,32600,80,48);E=31856;p=31864;br(31552,32152,32656,E,E,E,E,E,p,p,80)|0;nH(31552,32664,80,28);p=31856;E=31864;br(31552,32432,32696,p,p,p,p,p,E,E,80)|0;break};default:{nH(31552,32040,80,38);E=31856;br(31552,32080,32088,E,E,E,E,31936,31528,31864,80)|0;nH(31552,32096,80,48);E=31856;p=31864;br(31552,32152,32160,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[3941];h[o+24>>3]=+h[3941];h[o+16>>3]=+h[3936];i=y;return 0}else if((B|0)==215){nH(31552,33488,80,39);p=31856;E=31864;br(31552,33528,33536,p,p,p,p,p,E,E,80)|0;break c}else if((B|0)==216){nH(31552,33544,80,39);E=31856;p=31864;br(31552,33528,33584,E,E,E,E,E,p,p,80)|0;break c}}}while(0);nH(31552,33592,80,47);A=31856;p=31864;br(31552,31920,33640,A,A,A,A,A,p,p,80)|0}else if((B|0)==210){nH(31552,33184,80,55);p=31856;A=31864;br(31552,33240,31936,p,p,p,p,p,A,A,80)|0}}while(0);if((B|0)==227){nH(31552,34176,80,39);B=31856;br(31552,33528,34216,B,B,B,B,32032,j,e,80)|0}if((c[k>>2]|0)==-1){nH(31552,34368,80,46);e=31856;j=31864;br(31552,34416,34424,e,e,e,e,e,j,j,80)|0;nH(31552,34432,80,47);j=31856;e=31864;br(31552,31920,34480,31936,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function dr(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[4311]=C;c[t>>2]=0;D=c[e>>2]|0;c[8624]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[8624]|0;E=F+1|0;c[8624]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[4318]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;ir(g,b,k,l,f,o,m,n)|0;if((c[8004]|0)>0){i=v;return 0}D=d;Pd[D&7](f,b,k,e,p,y,z)|0;if((c[8004]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[34552]=0;F=c[e>>2]|0;c[8624]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[34552]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[8624]=F+1;if(!M){break}I=+mH(34544,34488);h[4315]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[4311];do{if((H- +h[g>>3])*I<0.0){ir(g,b,k,l,f,o,m,n)|0;if((c[8004]|0)<=0){break}i=v;return 0}else{G=+h[4315]/I;h[4316]=G;N=c[f>>2]|0;c[8624]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[4316];Q=Q+1|0}c[8624]=N+1}}while(0);Pd[D&7](f,b,k,e,p,y,z)|0;if((c[8004]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[34552]=0;F=c[e>>2]|0;c[8624]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[34552]=1;V=1;W=c[8624]|0}Q=W+1|0;c[8624]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[4311];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;ir(g,F,k,l,f,o,m,n)|0;if((c[8004]|0)>0){i=v;return 0}E=d;Pd[E&7](f,F,k,e,p,y,z)|0;if((c[8004]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[34552]=0;D=c[e>>2]|0;c[8624]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[34552]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[8624]=D+1;if(!aa){i=v;return 0}I=+mH(34544,34488);h[4315]=I;h[F>>3]=I+ +h[F>>3];I=+h[4315]/+h[4311];h[4316]=I;Q=c[f>>2]|0;c[8624]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[4316];R=R+1|0}c[8624]=Q+1}Pd[E&7](f,F,k,e,p,y,z)|0;if((c[8004]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[34552]=0;R=c[e>>2]|0;c[8624]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[34552]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[8624]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[4314]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}ir(g,34512,k,l,f,o,m,n)|0;if((c[8004]|0)<=0){break}i=v;return 0}else{h[4314]=Y;j=c[f>>2]|0;c[8624]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[8624]=j+1}}while(0);ga=d;Pd[ga&7](f,34512,k,e,q,y,z)|0;if((c[8004]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[8634]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){er(e,34544,34536,R,34512,p,q,r,34504,s,fa,da,x,ca)|0;if((c[8004]|0)>0){ha=76;break}if((c[8634]|0)>1){ha=73;break}ir(g,34504,k,l,f,o,m,n)|0;if((c[8004]|0)>0){ha=76;break}Pd[ga&7](f,34504,k,e,r,y,z)|0;if((c[8004]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[4313];R=31936;Ar(e,r,R,p,R)|0;if((c[8634]|0)==4){i=v;return 0}ir(g,34504,k,l,f,o,m,n)|0;if((c[8004]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function er(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[8650]=c[o>>2];c[o>>2]=0;h[4321]=0.0;a[34584]=0;t=c[b>>2]|0;c[8640]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+mH(34616,j+(v<<3)|0);if(w==+mH(34616,l+((c[8640]|0)+ -1<<3)|0)){break}y=c[8640]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[4321]){break}h[4321]=B;c[o>>2]=y}else{a[34584]=1}}while(0);v=c[8640]|0;u=v+1|0;c[8640]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[34592]=1;c[8652]=c[p>>2];h[g>>3]=+h[r>>3];t=31936;Ar(b,l,t,k,t)|0;c[p>>2]=1;a[34576]=0;C=0}else{a[34592]=0;c[o>>2]=c[8650];c[8652]=c[p>>2];if(a[34584]&1){h[g>>3]=+h[r>>3];t=31936;Ar(b,l,t,k,t)|0;a[34576]=1;C=1;break}else{t=31936;Ar(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[34576]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[34576]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=31936;Ar(b,k,t,l,t)|0;t=c[b>>2]|0;c[8640]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[8640]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+mH(34616,j+(u<<3)|0);if(!(A!=+mH(34616,k+((c[8640]|0)+ -1<<3)|0))){break}c[n+((c[8640]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[8640]|0;F=u+1|0;c[8640]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[4321]=0.0;a[34584]=0;t=c[b>>2]|0;c[8640]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+mH(34616,j+(v<<3)|0);if(A==+mH(34616,k+((c[8640]|0)+ -1<<3)|0)){break}y=c[8640]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[4321]){break}h[4321]=I;c[o>>2]=y}else{a[34584]=1}}while(0);v=c[8640]|0;u=v+1|0;c[8640]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[34592]=t&1;if(t){a[34576]=0;c[8652]=0;c[p>>2]=1;break}if(!(a[34584]&1)){t=31936;Ar(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=31936;Ar(b,k,t,l,t)|0;t=c[b>>2]|0;c[8640]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[8640]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[8640]|0}u=K+1|0;c[8640]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[8652]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function fr(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[4330]=+h[d>>3];h[4329]=+h[e>>3];j=c[a>>2]|0;c[8656]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[4330]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[4330]=o;h[4329]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[4329];a=l+1|0;c[8656]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function gr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[4333]=0.0;e=c[a>>2]|0;c[8662]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[4333]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[8662]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[4332]=0.0;e=c[a>>2]|0;c[8662]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[4332]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[8662]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function hr(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[8680]=0;c[8678]=0;c[8684]=0;h[4345]=+h[b>>3];h[4347]=+gr(f,d,l,0,0);C=c[f>>2]|0;c[8668]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[8668]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[4338]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[8668]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[8668]=G+1}a[34768]=1;c[8670]=0;a[34784]=1;c[C>>2]=(c[C>>2]|0)+1;c[8688]=0;Pd[B&7](b,d,e,q,34752,n,o)|0;b:do{if((c[8688]|0)<0){K=35}else{while(1){if(a[34768]&1){c[E>>2]=(c[E>>2]|0)+1;a[34768]=0;kr(f,b,d,e,q,34704,k,34728,l,r,s,t,g,34752,v,j,n,o,x)|0;h[4337]=1.0e6;if((c[8688]|0)<0|(c[8682]|0)!=0){K=35;break b}c[8684]=0}H=c[f>>2]|0;c[8668]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[8668]=H+1}lr(f,q,s,t)|0;I=c[f>>2]|0;c[8668]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[4338]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[8668]=I+1}N=+gr(f,q,l,0,0);h[4349]=N;if(N<=+h[v>>3]*100.0*+h[4347]){break}J=c[8670]|0;if((J|0)>0){h[z>>3]=N/+h[4350];h[A>>3]=1.0/+(J|0);O=+kH(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[4337]=P;Q=+h[4349];R=P}else{h[4350]=N;Q=N;R=+h[4337]}if(R*Q<=.33){break}J=c[8670]|0;H=J+1|0;c[8670]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[34768]=1}c[C>>2]=(c[C>>2]|0)+1;c[8688]=0;Pd[B&7](b,d,e,q,34752,n,o)|0;if((c[8688]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[8668]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[8668]=H+1}N=+gr(f,q,l,0,0);h[4349]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[8668]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[4338]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[8668]=J+1}}while(0);if(!(a[34784]&1)){break}H=c[f>>2]|0;c[8668]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[8668]=H+1}N=+gr(f,r,l,0,0);h[4343]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[34784]=0}h[b>>3]=+h[4345];G=c[f>>2]|0;c[8668]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[8668]=G+1}if(a[34784]&1){I=(c[8680]|0)+1|0;c[8680]=I;N=.9/(+h[4343]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[4336]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[8682]|0)!=0){I=(c[8684]|0)+1|0;c[8684]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[8688]|0)>-2)){K=53;break}I=(c[8678]|0)+1|0;c[8678]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function ir(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[8714]=o;p=+h[b>>3]- +h[a>>3];h[4355]=p;a=c[f>>2]|0;c[8706]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[8706]=a+1;q=+h[4355]}h[4351]=1.0;h[4352]=0.0;p=q/+h[k>>3];h[4356]=p;c[8708]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[4352]=u*t+s/+h[a>>3];p=t*s;h[4351]=p;h[4356]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[8706]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[4352]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[4351];g=g+1|0}c[8706]=a+1}g=v+1|0;c[8708]=g;if((v|0)>=(o|0)){break}r=+h[4355];s=+h[4351];t=+h[4356];u=+h[4352];v=g}i=l;return 0}function jr(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[4378]=+h[b>>3];c[8734]=0;c[8742]=0;c[8736]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[4390]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[8730]=(c[I>>2]|0)+1;c[8732]=(c[I>>2]|0)+2;c[8728]=(c[I>>2]|0)+ -1;h[4378]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[8746]=$+1;$=c[8730]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[4381]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[8716]=2;if(($|0)>=2){Y=2;while(1){h[4382]=+h[y+(Y+ -2<<3)>>3];U=+h[4381];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[4382];U=+h[4382]+ +h[k>>3];h[4381]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[8716]=$+1}h[y+($+ -1<<3)>>3]=+h[4381]}h[4388]=0.0;h[4386]=0.0;Y=c[I>>2]|0;c[8716]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[4388]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[4386]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[8716]=Y+1;da=ea}h[4389]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[4388]- +h[4386];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[4363]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[4363]=ha>=ca?ha:ca;h[4381]=.6;h[4382]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[4389]){h[D>>3]=100.0}aa=c[8730]|0;ba=c[8746]|0;if((aa|0)>=(ba|0)){c[8718]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[8716]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[8716]=ba+1}ja=ia+1|0;c[8718]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[8716]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[8716]=ia+1}aa=c[8730]|0;c[8718]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[8716]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[8716]=$+1}la=ba+1|0;c[8718]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[4385]=+gr(f,d,l,0,0);a[35128]=1;c[8720]=0;c[T>>2]=(c[T>>2]|0)+1;c[8750]=0;Pd[m&7](b,d,e,r,35e3,o,p)|0;if((c[8750]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;kr(f,b,d,e,r,A,k,34952,l,s,t,u,g,35e3,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[8750]|0)<0|(c[8738]|0)!=0){X=70;break}c[8742]=0}ba=c[f>>2]|0;c[8716]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8716]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[4381]=ca;aa=c[f>>2]|0;c[8716]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[4381];ia=ia+1|0;la=ka}c[8716]=aa+1}lr(f,r,t,u)|0;la=c[f>>2]|0;c[8716]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[8716]=la+1}U=+gr(f,r,l,0,0);h[4390]=U;if(U<=+h[F>>3]*100.0*+h[4385]){X=63;break a}ia=c[8720]|0;if((ia|0)>0){h[O>>3]=U/+h[4392];h[P>>3]=1.0/+(ia|0);ca=+kH(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[4390];oa=ga}else{h[4392]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[8720]|0;c[8720]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[8750]=0;Pd[m&7](b,d,e,r,35e3,o,p)|0;if((c[8750]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[8716]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[8716]=ba+1}U=+gr(f,r,l,0,0);h[4390]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[8716]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[8716]=ia+1}}while(0);if((X|0)==70){X=0;a[35128]=0}c[H>>2]=1;if(a[35128]&1){U=+gr(f,s,l,0,0);h[4384]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[4370]=ga;h[4377]=ga*+(ba+1|0);h[4372]=ga;c[8752]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[8716]=1;if((ba|0)>=1){aa=fa(c[8730]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[8716]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+gr(f,r,l,0,0);h[4379]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[4387]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[8716]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[8716]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+gr(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[4387];if((sa>=ca?sa:ca)>+h[4377]){break}ta=+h[4379];ua=Y}else{if(!(ga<=+h[4377]*.5)){break}else{ta=U;ua=ka}}c[8752]=ua+ -1;h[4372]=ta}}while(0);if(!(+h[4363]*+h[4384]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[4378];Y=c[8730]|0;ia=c[8746]|0;if((Y|0)>=(ia|0)){c[8718]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[4381]=ca;ia=c[f>>2]|0;c[8716]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[4381];ja=ja+1|0}c[8716]=ia+1}ja=aa+1|0;c[8718]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[8716]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[8716]=Y+1}if(!(a[35128]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[8738]|0)!=0){aa=(c[8742]|0)+1|0;c[8742]=aa;h[4361]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[8750]|0)>-2)){X=146;break}aa=(c[8734]|0)+1|0;c[8734]=aa;h[4361]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[8736]=(c[8736]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[8736]|0;if((aa|0)<=1){ja=c[8752]|0;c[I>>2]=ja;sa=+(ja+1|0);h[4382]=sa;h[O>>3]=+h[4372]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+kH(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[4361]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[8752];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[8766]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[8752]|0;E=c[8728]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[8730];za=+h[k>>3]*2.0;h[4374]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[8728]|0;Ba=c[8752]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[8730]|0)>=(c[K>>2]|0)|(c[8766]|0)==1){Fa=G;break}G=c[f>>2]|0;c[8716]=1;if((G|0)>=1){E=fa(c[8732]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[8716]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+gr(f,r,l,0,0);h[4380]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[4377];E=xa<=za;if(+h[4387]<=(E?xa:za)){Ea=c[8728]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[4377]*.5){Fa=S;break}}S=c[8730]|0;c[I>>2]=S;h[4372]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[4372]=+h[4379];Fa=Ea}h[4374]=+h[k>>3];ya=+(Fa+1|0);h[4382]=ya;h[O>>3]=+h[4372]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+kH(O,P);h[4361]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[4374];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[4361]=xa;za=+h[k>>3]*xa;h[4374]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[4374]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[8716]=1;if((k|0)<1){break}u=fa(c[8732]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[8716]=k+1}}while(0);Ca=c[f>>2]|0;c[8716]=1;if((Ca|0)>=1){J=fa(c[8730]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[8716]=Ca+1}Ca=c[8730]|0;c[8724]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[8718]=P;s=c[f>>2]|0;c[8716]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[8716]=s+1}P=Ha+1|0;c[8724]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[8750]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[8736]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}ir(b,b,d,e,f,I,q,y)|0;i=N;return 0}function kr(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0,xa=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[8808]=0;h[4405]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[8786]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[4402]=+h[4405]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+mH(35216,N);h[4402]=T;W=(c[8786]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[4402]=_;h[4409]=+h[S>>3];$=f+(W<<3)|0;h[4413]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[4402]+ +h[$>>3];Pd[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[4402];h[4411]=_;$=c[b>>2]|0;c[8792]=1;S=c[8808]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[4411];W=W+1|0;aa=ba}c[8792]=$+1}c[8808]=S+(c[b>>2]|0);aa=c[8786]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[4409];h[f+(W<<3)>>3]=+h[4413];R=aa+1|0;c[8786]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[8808]=0;P=c[b>>2]|0;if((c[21776>>2]|0)==0){ca=42;break}R=ET(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];yp(14,1,35312,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];yp(14,0,35336,E);yp(14,1,35344,D);c[8790]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];yp(14,0,35352,C);Q=(c[8790]|0)+1|0;c[8790]=Q;}while((Q|0)<(c[b>>2]|0))}Td[c[5568]&255](14);yp(14,1,35408,B);c[8786]=1;if((P|0)>=1){Q=R+1|0;aa=c[8808]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[8792]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];bc(R|0,35392,A|0)|0;ea=c[8792]|0;c[8792]=ea+1;if((ea|0)>=(P|0)){break}ba=c[8808]|0;da=ea}c[z>>2]=R;yp(14,0,35400,z);da=c[8808]|0;ba=c[8786]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[8808]=aa;W=ba+1|0;c[8786]=W;}while((ba|0)<(P|0))}Td[c[5568]&255](14);Td[c[5568]&255](14);FT(R);ca=42}else if((O|0)==3){i=y;return 0}else if((O|0)==4){P=c[q>>2]|0;W=q+4|0;aa=c[W>>2]|0;Q=c[b>>2]|0;ba=fa(aa+1+(P<<1)|0,Q)|0;c[8786]=1;if((ba|0)>=1){da=fa(Q,aa+(P<<1)+1|0)|0;P=(da|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8786]=P?2:da+1|0}Vd[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[8820]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else if((O|0)==5){aa=q+4|0;ba=(c[aa>>2]|0)+(c[q>>2]|0)|0;R=ba+1|0;c[8812]=R;Q=c[b>>2]|0;c[8802]=(ba|0)<(Q|0)?R:Q;Q=c[q>>2]|0;c[8820]=R+Q;c[8806]=Q+ba;ba=(c[b>>2]|0)/(R|0)|0;c[8816]=ba+1;R=c[x>>2]|0;c[8814]=R+ -1;c[8824]=R+ba;c[s>>2]=0;h[4405]=+V(+(+h[t>>3]));ba=c[8802]|0;c[8788]=1;if((ba|0)<1){ca=75;break}R=r;Q=1;while(1){ea=c[b>>2]|0;ga=c[8812]|0;c[8794]=Q;ha=(ga|0)<0;c:do{if(ha?(Q|0)>=(ea|0):(Q|0)<=(ea|0)){ia=ga;ja=Q;ka=Q;while(1){la=(ka-ja|0)/(ia|0)|0;c[8790]=la+1;ma=ka+ -1|0;na=e+(ma<<3)|0;h[p+((c[8814]|0)+la<<3)>>3]=+h[na>>3];oa=f+(ma<<3)|0;h[p+((c[8824]|0)+la<<3)>>3]=+h[oa>>3];Y=+h[na>>3];h[N>>3]=Y;if(!(Y>=0.0)){pa=-Y}else{pa=Y}Y=+h[l>>3]*+h[oa>>3];if(!(Y>=0.0)){qa=-Y}else{qa=Y}Y=pa>=qa?pa:qa;_=+h[n+(ma<<3)>>3];if(!(_>=0.0)){ra=-_}else{ra=_}h[4402]=+h[4405]*(Y>=ra?Y:ra);h[N>>3]=+h[l>>3]*+h[oa>>3];Y=+mH(35216,N);h[4402]=Y;oa=c[8794]|0;ma=oa+ -1|0;na=e+(ma<<3)|0;_=+h[na>>3];T=Y+_-_;h[4402]=T;h[na>>3]=+h[na>>3]+T;na=f+(ma<<3)|0;h[na>>3]=+h[j>>3]*+h[4402]+ +h[na>>3];na=oa+ga|0;c[8794]=na;if(!(ha?(na|0)>=(ea|0):(na|0)<=(ea|0))){break c}ia=c[8812]|0;ja=c[8788]|0;ka=na}}}while(0);Pd[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ea=c[b>>2]|0;ha=c[8812]|0;ga=c[8788]|0;c[8794]=ga;ka=(ha|0)<0;d:do{if(ka?(ga|0)>=(ea|0):(ga|0)<=(ea|0)){ja=ha;ia=ga;S=ga;while(1){$=(S-ia|0)/(ja|0)|0;c[8790]=$+1;na=S+ -1|0;oa=e+(na<<3)|0;h[oa>>3]=+h[p+((c[8814]|0)+$<<3)>>3];T=+h[p+((c[8824]|0)+$<<3)>>3];$=f+(na<<3)|0;h[$>>3]=T;_=+h[oa>>3];h[N>>3]=_;if(!(_>=0.0)){sa=-_}else{sa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ta=-_}else{ta=_}_=sa>=ta?sa:ta;T=+h[n+(na<<3)>>3];if(!(T>=0.0)){ua=-T}else{ua=T}h[4402]=+h[4405]*(_>=ua?_:ua);h[N>>3]=+h[l>>3]*+h[$>>3];_=+mH(35216,N);h[4402]=_;$=c[8794]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[4402]=Y;T=1.0/Y;h[4411]=T;na=$-(c[aa>>2]|0)|0;oa=(na|0)>1?na:1;c[8796]=oa;na=c[b>>2]|0;ma=(c[q>>2]|0)+$|0;la=(na|0)<=(ma|0)?na:ma;c[8798]=la;va=fa(c[8806]|0,$)|0;wa=va-(c[q>>2]|0)|0;c[8800]=wa;c[8786]=oa;if((oa|0)<=(la|0)){va=~na;na=~ma;ma=~((va|0)>(na|0)?va:na);na=(oa|0)>(ma|0)?oa:ma;Y=T;ma=oa;while(1){oa=ma+ -1|0;h[p+(oa+wa<<3)>>3]=(+h[o+(oa<<3)>>3]- +h[g+(oa<<3)>>3])*Y;if((ma|0)>=(la|0)){break}Y=+h[4411];ma=ma+1|0}c[8786]=na+1}ma=$+ha|0;c[8794]=ma;la=c[8788]|0;if(!(ka?(ma|0)>=(ea|0):(ma|0)<=(ea|0))){xa=la;break d}ja=c[8812]|0;ia=la;S=ma}}else{xa=ga}}while(0);ga=xa+1|0;c[8788]=ga;if((xa|0)<(ba|0)){Q=ga}else{ca=75;break a}}i=y;return 0}else{Q=c[b>>2]|0;ba=fa(Q,Q)|0;c[8786]=1;if((ba|0)!=0){Q=(ba|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[8786]=Q?2:ba+1|0}Vd[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[8808]=0;aa=c[b>>2]|0;if((c[21776>>2]|0)==0){ca=42;break}R=ET(aa*20|0)|0;W=M;h[k>>3]=+h[d>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];yp(14,1,35312,M);W=L;h[k>>3]=+h[j>>3];c[W>>2]=c[k>>2];c[W+4>>2]=c[k+4>>2];yp(14,0,35336,L);yp(14,1,35344,K);c[8790]=0;if((c[b>>2]|0)>0){W=0;do{Y=+h[e+(W<<3)>>3];c[J>>2]=W+1;da=J+4|0;h[k>>3]=Y;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];yp(14,0,35352,J);W=(c[8790]|0)+1|0;c[8790]=W;}while((W|0)<(c[b>>2]|0))}Td[c[5568]&255](14);yp(14,1,35368,I);c[8786]=1;if((aa|0)>=1){W=R+1|0;ba=c[8808]|0;Q=1;do{da=p+(Q+ -1+ba<<3)|0;h[da>>3]=+h[j>>3]+ +h[da>>3];a[R]=0;a[W]=0;c[8792]=1;da=ba;P=0;while(1){Y=+h[p+(P+da<<3)>>3];c[H>>2]=R;ga=H+4|0;h[k>>3]=Y;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];bc(R|0,35392,H|0)|0;ga=c[8792]|0;c[8792]=ga+1;if((ga|0)>=(aa|0)){break}da=c[8808]|0;P=ga}c[G>>2]=R;yp(14,0,35400,G);P=c[8808]|0;da=c[8786]|0;ga=p+(P+ -1+da<<3)|0;h[ga>>3]=+h[ga>>3]- +h[j>>3];ba=P+(c[b>>2]|0)|0;c[8808]=ba;Q=da+1|0;c[8786]=Q;}while((da|0)<(aa|0))}Td[c[5568]&255](14);Td[c[5568]&255](14);FT(R);ca=42}}while(0);if((ca|0)==42){sr(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){yr(p,35280,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function lr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[8858]=(c[g>>2]|0)+1+(c[e>>2]<<1);zr(d,35432,a,e,g,e+80|0,b,35440)|0;i=f;return 0}else{wr(d,a,a,e+80|0,b,35440)|0;i=f;return 0}return 0}function mr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[35448]&1)){a[35448]=1;nr(35496,35464,35544,35480,35528,35552,35536,35560)|0;h[4436]=+(c[8874]|0);f=c[8866]|0;h[4432]=+(f|0);if((c[8886]|0)==0){h[4434]=0.0;c[e>>2]=1-f;g=+lH(35488,e)}else{h[4434]=1.0;c[e>>2]=1-f;g=+lH(35488,e)*.5}h[4435]=g;h[4439]=g*+h[4436];h[4438]=+(c[8882]|0);h[4440]=+(c[8884]|0);j=+h[4444];h[4447]=j;k=1.0/+h[4445];if(!(k>=j)){break}h[4447]=k*(g+1.0)}}while(0);if((Br(b,35584,1,1)|0)!=0){g=+h[4435];h[4446]=g;l=g;i=d;return+l}if((Br(b,35592,1,1)|0)!=0){g=+h[4447];h[4446]=g;l=g;i=d;return+l}if((Br(b,35600,1,1)|0)!=0){g=+h[4436];h[4446]=g;l=g;i=d;return+l}if((Br(b,35608,1,1)|0)!=0){g=+h[4439];h[4446]=g;l=g;i=d;return+l}if((Br(b,35616,1,1)|0)!=0){g=+h[4432];h[4446]=g;l=g;i=d;return+l}if((Br(b,35624,1,1)|0)!=0){g=+h[4434];h[4446]=g;l=g;i=d;return+l}if((Br(b,35632,1,1)|0)!=0){g=+h[4438];h[4446]=g;l=g;i=d;return+l}if((Br(b,35640,1,1)|0)!=0){g=+h[4444];h[4446]=g;l=g;i=d;return+l}if((Br(b,35648,1,1)|0)!=0){g=+h[4440];h[4446]=g;l=g;i=d;return+l}if((Br(b,35656,1,1)|0)==0){l=+h[4446];i=d;return+l}else{g=+h[4445];h[4446]=g;l=g;i=d;return+l}return 0.0}function nr(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[35768]&1){q=36136;r=c[9034]|0;c[b>>2]=r;s=36072;t=c[9018]|0;c[d>>2]=t;u=36112;v=c[9028]|0;c[e>>2]=v;w=36120;x=+h[4515];h[f>>3]=x;y=36152;z=c[9038]|0;c[g>>2]=z;A=36200;B=+h[4525];h[j>>3]=B;C=36160;D=c[9040]|0;c[k>>2]=D;E=36208;F=+h[4526];h[l>>3]=F;i=m;return 0}a[35768]=1;h[4516]=0.0;h[4510]=1.0;h[4511]=2.0;or(36136,36072,36112,36224)|0;h[4506]=+(c[9034]|0);c[n>>2]=0-(c[9018]|0);G=+lH(36048,n);h[4505]=G;h[4515]=G;H=+h[4511];h[4506]=H/3.0;I=+h[4510];J=I*.5;h[4513]=J;K=-J;h[o>>3]=K;h[4527]=+pr(36048,o);L=36216;h[4524]=+pr(L,L);h[o>>3]=K;h[4506]=+pr(36192,o);K=+pr(36048,36216);h[4506]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[4506]=K;h[4515]=1.0;M=+h[4516];if(K<1.0&K>M){N=K;while(1){h[4515]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+pr(o,p);h[4507]=K;h[o>>3]=-K;h[4507]=+pr(36104,o);K=+pr(36104,36056);h[4506]=K;h[o>>3]=-K;h[4507]=+pr(36104,o);K=+pr(36104,36056);h[4506]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[4515]=G}G=I/+(c[9034]|0);h[4518]=G;h[4522]=I;c[9016]=1;p=1;O=I;do{h[o>>3]=O*G;O=+pr(o,36128);h[4522]=O;p=p+1|0;c[9016]=p;}while((p|0)<4);h[4505]=+pr(36080,36176);qr(36240,36080,36136)|0;h[o>>3]=-+h[4510];qr(36232,o,36136)|0;qr(36184,36040,36136)|0;h[o>>3]=-+h[4505];qr(36168,o,36136)|0;c[9024]=0;p=c[9060]|0;L=c[9058]|0;P=c[9046]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[9042]|0)){if(Q){c[9038]=p;R=0;S=25;break}if((P-p|0)==3){c[9038]=p+ -1+(c[9018]|0);c[9024]=1;R=1;S=25;break}else{c[9038]=(p|0)<=(P|0)?p:P;a[35776]=1;S=26;break}}else{T=Q&(L|0)==(c[9042]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[9038]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[9038]=(p|0)<=(L|0)?p:L;a[35776]=1;S=26;break}}T=c[9042]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[9038]=(V|0)<=(T|0)?V:T;a[35776]=1;S=26;break}if((P-U|0)==3){c[9038]=((p|0)>=(L|0)?p:L)+ -1+(c[9018]|0);R=0;S=25;break}else{c[9038]=U;a[35776]=1;S=26;break}}}while(0);if((S|0)==25){if(a[35776]&1){S=26}else{W=R}}if((S|0)==26){a[35768]=0;hI(36248)|0;yH(36272,36152,4)|0;RH()|0;W=c[9024]|0}if((W|0)==0){X=(c[9056]|0)!=0|0}else{X=1}c[9024]=X;h[4525]=1.0;X=c[9038]|0;W=1-X|0;c[n>>2]=W;c[9016]=1;if((X|0)<=0){O=+h[4518];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+pr(o,36128);h[4525]=I;n=X+1|0;c[9016]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}rr(36136,36072,36152,36096,36160,36208)|0;q=36136;r=c[9034]|0;c[b>>2]=r;s=36072;t=c[9018]|0;c[d>>2]=t;u=36112;v=c[9028]|0;c[e>>2]=v;w=36120;x=+h[4515];h[f>>3]=x;y=36152;z=c[9038]|0;c[g>>2]=z;A=36200;B=+h[4525];h[j>>3]=B;C=36160;D=c[9040]|0;c[k>>2]=D;E=36208;F=+h[4526];h[l>>3]=F;i=m;return 0}function or(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[35664]&1){l=a[35736]&1;m=c[8936]|0;c[b>>2]=m;n=35712;o=c[8928]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=35760;r=c[8940]|0;c[f>>2]=r;i=g;return 0}a[35664]=1;h[4465]=1.0;h[4459]=1.0;h[4461]=1.0;s=1.0;do{s=s*2.0;h[4459]=s;h[4461]=+pr(35672,35720);h[j>>3]=-s;t=+pr(35688,j);h[4461]=t;}while(t==1.0);h[4460]=1.0;t=+pr(35672,35680);h[4461]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[4460]=v;w=+pr(35672,35680);h[4461]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[4466]=.25;h[4469]=x;h[j>>3]=-s;t=+pr(35688,j);h[4461]=t;y=~~(t+.25);c[8936]=y;t=+(y|0);h[4460]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[4462]=+pr(j,k);w=+pr(35696,35672);h[4461]=w;z=w==s;a[35736]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[4462]=+pr(j,k);w=+pr(35696,35672);h[4461]=w;if(z&w==s){a[35736]=0;A=0}else{A=z}h[j>>3]=u;w=+pr(j,35672);h[4463]=w;h[j>>3]=u;z=w==s&+pr(j,35752)>x;c[8940]=z?A&1:0;c[8928]=0;h[4459]=1.0;h[4461]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[8928]=k;s=x*t;h[4459]=s;h[4461]=+pr(35672,35720);h[j>>3]=-s;w=+pr(35688,j);h[4461]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=35712;o=c[8928]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=35760;r=c[8940]|0;c[f>>2]=r;i=g;return 0}function pr(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function qr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[4535]=g;j=1.0/+(c[d>>2]|0);h[4544]=j;h[4543]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+pr(f,36344);h[4537]=k;h[4539]=g;h[4540]=g;h[4541]=g;h[4542]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[4535]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+pr(f,36344);h[4537]=g;h[f>>3]=g*k;k=+pr(f,36344);h[4539]=k;h[4541]=0.0;c[9072]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[4541]=q;c[9072]=b+1;n=q}h[f>>3]=m*j;p=+pr(f,36344);h[4538]=p;h[f>>3]=p/j;r=+pr(f,36344);h[4540]=r;h[4542]=0.0;o=c[d>>2]|0;c[9072]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[4542]=v;c[9072]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function rr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[9096]=1;c[9104]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[9096]=q;r=l+1|0;c[9104]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[9100]=n;u=n}else{c[9100]=m;c[9104]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[9106]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[9104]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[4551]=x;y=w+-1.0;h[4547]=y;h[4546]=0.0;v=c[b>>2]|0;c[9090]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[4547]=B;if(w<1.0){h[4549]=w}C=+pr(36368,36376);h[4546]=C;e=b+1|0;c[9090]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[4549];h[4546]=A;z=A}}while(0);v=c[f>>2]|0;c[9090]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+pr(k,36432);h[4546]=z;f=E+1|0;c[9090]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function sr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[9112]=1;m=1;do{c[9118]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=tr(j,a+(m+b+(fa(m,l)|0)<<3)|0,36480)|0;q=c[9112]|0;r=p+ -1+q|0;c[9114]=r;c[e+(q+ -1<<2)>>2]=r;r=c[9114]|0;q=c[9112]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[4558]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[4558];t=q}u=fa(t,l)|0;h[4558]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;ur(j,36464,a+(t-l+u<<3)|0,36480)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[9118]|0;c[9110]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[9114]|0;x=fa(w,l)|0;h[4558]=+h[a+(x+b+v<<3)>>3];y=c[9112]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[4558];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=36480;vr(k,36464,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[9110]|0;w=A+1|0;c[9110]=w;}while((A|0)<(u|0))}}while(0);q=c[9112]|0;m=q+1|0;c[9112]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function tr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[9210]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[4606]=k;l=(c[d>>2]|0)+1|0;c[9210]=l;m=c[a>>2]|0;c[9208]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[4606]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[9210]=l;a=n+1|0;c[9208]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[4606]=v;c[9208]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[4606]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[9208]=f+1;g=C;i=e;return g|0}function ur(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[9194]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[9194]=l;i=f;return 0}l=(g|0)%5|0;c[9196]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[9194]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[9194]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[9194]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[9194]=o;i=f;return 0}function vr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[9180]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[9178]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[9178]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[9178]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[9178]=s;i=j;return 0}}while(0);c[9182]=1;c[9184]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[9182]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[9184]=s;u=s}else{u=1}s=c[a>>2]|0;c[9178]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[9182]=t;u=x+(c[g>>2]|0)|0;c[9184]=u;a=w+1|0;c[9178]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}



function wr(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[9130]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[9122]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[9124]=o;p=f+(o+ -1<<3)|0;h[4563]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[4563]}c[k>>2]=(c[d>>2]|0)-m;o=36480;vr(k,36504,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[9122]|0;m=o+1|0;c[9122]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[9128]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[9122]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[4563]=-s;c[k>>2]=g;g=36480;vr(k,36504,a+(p-l<<3)|0,g,f,g)|0;g=c[9128]|0;q=g+1|0;c[9128]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[9122]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=36480;s=+xr(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[4563]=s;q=c[9122]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[9122]=n;}while((q|0)<(m|0));t=c[9130]|0}if((t|0)<1){i=j;return 0}c[9128]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[9122]=n;c[k>>2]=(c[d>>2]|0)-n;b=36480;s=+xr(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[9122]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[9124]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[4563]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[4563]}q=c[9128]|0;m=q+1|0;c[9128]=m;}while((q|0)<(t|0));i=j;return 0}function xr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[4603]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[9200]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[9198]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[4603]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[9198]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[9198]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[4603]=t;u=u+5|0;}while((u|0)<=(m|0));c[9198]=u;k=t;i=g;return+k}}while(0);c[9202]=1;c[9204]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[9202]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[9204]=u;y=u}else{y=1}u=c[a>>2]|0;c[9198]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[4603]=t;x=C+(c[d>>2]|0)|0;c[9202]=x;y=B+(c[f>>2]|0)|0;c[9204]=y;a=z+1|0;c[9198]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function yr(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[9140]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[9146]=n;o=c[d>>2]|0;p=c[9140]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[9148]=o;do{if((q|0)>(n|0)){c[9156]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[9144]=s;t=c[e>>2]|0;c[9132]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[9132]=t+1}u=r+1|0;c[9156]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[9156]=o;c[9154]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[9136]=1;t=o;o=1;while(1){c[9158]=o+1;p=t+1|0;c[9156]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[9132]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[9132]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[9150]=s;c[l>>2]=s+1;s=tr(l,a+((c[9140]|0)+b+(fa(o,m)|0)<<3)|0,36480)|0;p=s+ -1|0;c[9138]=p+(c[9140]|0);s=c[9136]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[9138]|0;p=c[9136]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[9140]|0;if((s|0)==(u|0)){y=s}else{h[4571]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[4571];y=u}h[4571]=-1.0/+h[a+(y+b+n<<3)>>3];ur(36600,36568,a+(y-m+n<<3)|0,36480)|0;u=c[9154]|0;z=(c[g+((c[9136]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[9154]=u;A=c[9140]|0;c[9152]=A;z=c[9158]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[9134]=z;B=z;z=A;while(1){A=(c[9138]|0)+ -1|0;c[9138]=A;C=z+ -1|0;c[9152]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[4571]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[4571];F=C}C=36480;vr(36600,36568,a+((c[9140]|0)-m+(fa(c[9136]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[9134]|0;D=C+1|0;c[9134]=D;if((C|0)>=(u|0)){break a}B=D;z=c[9152]|0}}}while(0);n=c[9136]|0;s=n+1|0;c[9136]=s;if((n|0)>=(r|0)){break}t=c[9156]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[9140]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function zr(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[9164]=n;f=c[d>>2]|0;o=f+ -1|0;c[9176]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[9160]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[9174]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[9162]=k;q=j+(k+ -1<<3)|0;h[4583]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[4583]}k=36480;vr(36696,36664,a+((c[9164]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[9160]|0;f=k+1|0;c[9160]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[9168]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[9160]=k;q=c[9164]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[9174]=s;u=q-s|0;c[9170]=u;q=k-s|0;c[9172]=q;h[4583]=-t;s=36480;vr(36696,36664,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[9168]|0;r=s+1|0;c[9168]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[9160]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[9174]=r;s=o-r|0;c[9170]=s;q=n-r|0;c[9172]=q;r=36480;t=+xr(36696,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[4583]=t;r=c[9160]|0;q=j+(r+ -1<<3)|0;o=c[9164]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[9160]=n;}while((r|0)<(f|0));v=o;w=c[9176]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[9168]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[9160]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[9174]=(n|0)<=(b|0)?n:b;b=36480;t=+xr(36696,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[9160]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[9162]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[4583]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[4583]}n=c[9168]|0;b=n+1|0;c[9168]=b;if((n|0)>=(w|0)){break}o=c[9164]|0;v=b}i=l;return 0}function Ar(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[9188]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[9186]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[9186]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[9186]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[9186]=o;i=g;return 0}}while(0);c[9190]=1;c[9192]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[9190]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[9192]=o;q=o}else{q=1}o=c[a>>2]|0;c[9186]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[9190]=p;q=s+(c[f>>2]|0)|0;c[9192]=q;a=r+1|0;c[9186]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Br(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[36872]=1;f=d[b]|0;c[9214]=f;b=d[e]|0;c[9216]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[9214]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[9216]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function Cr(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[46404>>2]=6;hI(46400)|0;yH(47144,j,4)|0;RH()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[10902]=0;c[11508]=0;c[11496]=0;a[46008]=0;t=c[e>>2]|0;c[10456]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[10902]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[10456]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[10456]=1;if((v|0)>=1){x=1;while(1){h[38296+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[10456]=v+1}c[11500]=2;x=c[e>>2]|0;c[10456]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[10458]=1;if((E|0)<1){F=C}else{G=1;while(1){h[38296+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[10458]=E+1;F=+h[B>>3]}h[38296+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[11500]=G;D=G}G=z+1|0;c[10456]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[10902]|0;y=z+1|0;c[10898]=y;c[10456]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[10458]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[38296+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[10458]=x+1}$d[u&63](e,b,41656+(z+ -1<<3)|0)|0;c[11508]=(c[11508]|0)+1;if((c[j>>2]|0)>=1){c[46428>>2]=6;hI(46424)|0;yH(47144,46032,4)|0;yH(47144,41656+((c[10456]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[10458]=1;if((v|0)>=1){A=1;do{yH(47144,b+(A+ -1<<3)|0,8)|0;B=c[10458]|0;A=B+1|0;c[10458]=A;}while((B|0)<(v|0))}RH()|0}v=c[10456]|0;z=v+1|0;c[10456]=z;}while((v|0)<(y|0))}y=c[11496]|0;b:while(1){c[11496]=y+1;c[11408]=1;c[11404]=1;C=+h[5207];h[5703]=C;h[5705]=C;z=c[10898]|0;c[10456]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[41656+(A+ -1<<3)>>3];do{if(!(C<=K)){c[11408]=A;L=+h[41656+(A+ -1<<3)>>3];h[5703]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[11404]=A;L=+h[41656+(A+ -1<<3)>>3];h[5705]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[10456]=z+1;H=O}A=c[e>>2]|0;c[10456]=1;if((A|0)>=1){v=1;while(1){h[43776+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[10456]=A+1}c[10456]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[10458]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=43776+(Q+ -1<<3)|0;h[B>>3]=+h[38296+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[10458]=x+1;P=v}}while(0);v=P+1|0;c[10456]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[10458]=1;if((z|0)>=1){K=+(c[10902]|0);v=1;while(1){A=43776+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[10458]=z+1}v=c[e>>2]|0;c[10456]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[43776+(B<<3)>>3];h[46056+(B<<3)>>3]=K+(K- +h[38296+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[10456]=v+1}$d[u&63](e,46056,46048)|0;A=(c[11508]|0)+1|0;c[11508]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[46452>>2]=6;hI(46448)|0;yH(47144,46032,4)|0;yH(47144,46048,8)|0;B=c[e>>2]|0;c[10458]=1;if((B|0)>=1){E=1;do{yH(47144,46056+(E+ -1<<3)|0,8)|0;G=c[10458]|0;E=G+1|0;c[10458]=E;}while((G|0)<(B|0))}RH()|0}}while(0);K=+h[5756];c:do{if(!(K>=+h[5705])){z=c[e>>2]|0;c[10456]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[43776+(v<<3)>>3];h[46224+(v<<3)>>3]=I+(+h[46056+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[10456]=z+1}$d[u&63](e,46224,46216)|0;A=(c[11508]|0)+1|0;c[11508]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[46476>>2]=6;hI(46472)|0;yH(47144,46032,4)|0;yH(47144,46216,8)|0;B=c[e>>2]|0;c[10458]=1;if((B|0)>=1){E=1;do{yH(47144,46224+(E+ -1<<3)|0,8)|0;G=c[10458]|0;E=G+1|0;c[10458]=E;}while((G|0)<(B|0))}RH()|0}}while(0);I=+h[5777];if(I>=+h[5705]){R=118;break}v=c[e>>2]|0;c[10456]=1;A=c[11408]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[38296+((z*21|0)+ -22+A<<3)>>3]=+h[46224+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[10456]=v+1}h[41656+(A+ -1<<3)>>3]=I}else{z=c[10898]|0;c[10456]=1;if((z|0)>=1){B=c[11408]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[41656+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[10456]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[5703])){E=c[e>>2]|0;c[10456]=1;z=c[11408]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[38296+((B*21|0)+ -22+z<<3)>>3]=+h[46056+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[10456]=E+1}h[5703]=K;h[41656+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[10456]=1;if((B|0)>=1){A=c[11408]|0;v=1;while(1){x=v+ -1|0;h[46224+(x<<3)>>3]=+h[38296+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[43776+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[10456]=B+1}$d[u&63](e,46224,46216)|0;v=(c[11508]|0)+1|0;c[11508]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[46500>>2]=6;hI(46496)|0;yH(47144,46032,4)|0;yH(47144,46216,8)|0;z=c[e>>2]|0;c[10458]=1;if((z|0)>=1){E=1;do{yH(47144,46224+(E+ -1<<3)|0,8)|0;x=c[10458]|0;E=x+1|0;c[10458]=E;}while((x|0)<(z|0))}RH()|0}}while(0);I=+h[5777];if(!(I>+h[5703])){A=c[e>>2]|0;c[10456]=1;v=c[11408]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[38296+((B*21|0)+ -22+v<<3)>>3]=+h[46224+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[10456]=A+1}h[41656+(v+ -1<<3)>>3]=I;break}B=c[10898]|0;c[10456]=1;if((B|0)<1){break}else{S=1}do{z=c[11404]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[10458]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=38296+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[38296+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[38296+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[10458]=E+1}$d[u&63](e,b,41656+(S+ -1<<3)|0)|0;G=(c[11508]|0)+1|0;c[11508]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[46524>>2]=6;hI(46520)|0;yH(47144,46032,4)|0;yH(47144,41656+((c[10456]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[10458]=1;if((x|0)>=1){G=1;do{yH(47144,b+(G+ -1<<3)|0,8)|0;T=c[10458]|0;G=T+1|0;c[10458]=G;}while((T|0)<(x|0))}RH()|0}}while(0);z=c[10456]|0;S=z+1|0;c[10456]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[10456]=1;v=c[11408]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[38296+((A*21|0)+ -22+v<<3)>>3]=+h[46056+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[10456]=B+1}h[41656+(v+ -1<<3)>>3]=+h[5756]}A=c[11496]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[5706]=0.0;h[5752]=0.0;A=c[10898]|0;c[10456]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[5752]=0.0/K;c[10456]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[41656+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[5752]=I;c[10456]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[41656+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[5706]=$;c[10456]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[5706]=I;do{if(!(I<=+h[k>>3])){if((c[11508]|0)>(c[g>>2]|0)){break}a[46008]=0;c[11496]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[10456]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[10458]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[38296+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[10458]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[10456]=v+1}$d[u&63](e,b,f)|0;B=(c[11508]|0)+1|0;c[11508]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[46548>>2]=6;hI(46544)|0;yH(47144,46032,4)|0;yH(47144,s,8)|0;z=c[e>>2]|0;c[10458]=1;if((z|0)>=1){E=1;do{yH(47144,b+(E+ -1<<3)|0,8)|0;x=c[10458]|0;E=x+1|0;c[10458]=E;}while((x|0)<(z|0))}RH()|0;ba=c[11508]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[46668>>2]=6;hI(46664)|0;RH()|0;c[46692>>2]=6;hI(46688)|0;B=c[e>>2]|0;c[10456]=1;if((B|0)>=1){A=1;do{yH(47144,b+(A+ -1<<3)|0,8)|0;v=c[10456]|0;A=v+1|0;c[10456]=A;}while((v|0)<(B|0))}RH()|0;c[46716>>2]=6;hI(46712)|0;yH(47144,s,8)|0;RH()|0}if(a[46008]&1){I=+h[5752];K=+h[5798]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[46008]=1;da=+h[5752]}h[5798]=da;c[11496]=0;y=0}if((c[j>>2]|0)>=0){c[46740>>2]=6;hI(46736)|0;yH(47144,46032,4)|0;RH()|0;c[46764>>2]=6;hI(46760)|0;y=c[e>>2]|0;c[10456]=1;if((y|0)>=1){B=1;do{yH(47144,b+(B+ -1<<3)|0,8)|0;A=c[10456]|0;B=A+1|0;c[10456]=B;}while((A|0)<(y|0))}RH()|0;c[46788>>2]=6;hI(46784)|0;yH(47144,s,8)|0;RH()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[46812>>2]=6;hI(46808)|0;RH()|0}h[5705]=+h[f>>3];c[11510]=0;y=c[10898]|0;c[10456]=1;if((y|0)>=1){B=1;while(1){A=41656+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[10456]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[10458]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=38296+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[46224+(E+ -1<<3)>>3]=+h[38296+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[10458]=v+1}$d[u&63](e,46224,A)|0;c[11510]=(c[11510]|0)+1;c[11508]=(c[11508]|0)+1;E=c[10456]|0;I=+h[41656+(E+ -1<<3)>>3];if(I>=+h[5705]){B=E;continue}h[5705]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[46836>>2]=6;hI(46832)|0;yH(47144,46032,4)|0;yH(47144,45640,8)|0;E=c[e>>2]|0;c[10458]=1;if((E|0)>=1){z=1;do{yH(47144,46224+(z+ -1<<3)|0,8)|0;G=c[10458]|0;z=G+1|0;c[10458]=z;}while((G|0)<(E|0))}RH()|0;B=c[10456]|0}}B=c[10902]|0;c[10456]=1;do{if((B|0)<1){h[5232]=+h[5207];c[10456]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[10466]=E;z=c[e>>2]|0;c[10458]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[46056+(A+ -1<<3)>>3]=(+h[38296+(v+ -21<<3)>>3]+ +h[38296+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[10458]=z+1}$d[u&63](e,46056,43616+(y+ -1<<3)|0)|0;c[11510]=(c[11510]|0)+1;c[11508]=(c[11508]|0)+1;A=c[10456]|0;y=A+1|0;c[10456]=y;}while((A|0)<(B|0));y=c[10902]|0;I=+h[5207];h[5232]=I;c[10456]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[10466]=A;c[10468]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[10458]=1;E=1;while(1){v=E+1|0;c[10470]=v;G=c[e>>2]|0;c[10460]=1;if((G|0)>=1){x=c[10468]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[46224+(T+ -1<<3)>>3]=(+h[38296+(U+x<<3)>>3]+ +h[38296+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[10460]=G+1}$d[u&63](e,46224,46216)|0;c[11510]=(c[11510]|0)+1;c[11508]=(c[11508]|0)+1;T=c[10456]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[10458]|0;la=U+x|0;c[10462]=la;I=+h[5232];h[43936+(la+ -1<<3)>>3]=(+h[5777]+I- +h[43616+(v<<3)>>3]- +h[43616+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[10458]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[10456]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[10902]|0;c[10462]=0;c[10456]=1;E=(y|0)<1;if(E){c[10456]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=zU(A|0,0,y+ -2|0,0)|0;A=sU(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[43936+(U+ -1<<3)>>3]=(+h[41656+(v<<3)>>3]+ka- +h[43616+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[10466]=v+1;c[10462]=(z|1)+A;c[10456]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=43616+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[41656+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[10466]=T+1;c[10456]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[10462]=0;c[10456]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[10456]=1;if((B|0)>=1){A=1;while(1){h[45656+(A+ -1<<3)>>3]=+h[38296+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[10456]=B+1}c[10456]=1;do{if(ma){c[10456]=1}else{A=1;while(1){z=A+1|0;c[10466]=z;v=c[e>>2]|0;c[10458]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=38296+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[38296+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[10458]=v+1}c[10456]=z;if((A|0)<(na|0)){A=z}else{break}}c[10456]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[10466]=A;y=c[e>>2]|0;c[10458]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[38296+(T+oa<<3)>>3]=+h[38296+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[10458]=y+1}c[10456]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=43936;Dr(B,43608,B,45816,46392,q,45976)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[46860>>2]=6;hI(46856)|0;RH()|0}c[q>>2]=2;if((c[11508]|0)>(c[g>>2]|0)){R=312;break}c[46884>>2]=6;hI(46880)|0;RH()|0;B=c[e>>2]|0;c[10456]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[10456]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[46572>>2]=6;hI(46568)|0;yH(47144,g,4)|0;RH()|0;c[46596>>2]=6;hI(46592)|0;yH(47144,45648,8)|0;RH()|0;c[46620>>2]=6;hI(46616)|0;u=c[e>>2]|0;c[10456]=1;if((u|0)>=1){E=1;do{yH(47144,b+(E+ -1<<3)|0,8)|0;z=c[10456]|0;E=z+1|0;c[10456]=E;}while((z|0)<(u|0))}RH()|0;c[46644>>2]=6;hI(46640)|0;yH(47144,s,8)|0;RH()|0;i=r;return 0}else if((R|0)==226){u=c[10902]|0;c[11506]=u-(c[11598]|0);c[10456]=1;E=(u|0)<1;do{if(E){h[5749]=0.0;c[10456]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[41656+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=41656+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[43936+(sa+ -1<<3)>>3]*+h[43616+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[10462]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[10458]=z;h[5749]=0.0;c[10456]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[41656+(v<<3)>>3]*+h[43616+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[5749]=wa;c[10456]=u+1;qa=wa}}while(0);h[5749]=+h[5232]-qa;s=c[e>>2]|0;c[10456]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[46224+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=46224+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[41656+(T+ -1<<3)>>3]*+h[38296+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[10456]=s+1;c[10458]=xa}v=c[e>>2]|0;c[10456]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=45656+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[46224+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[10456]=v+1}if((c[j>>2]|0)>=0){c[46908>>2]=6;hI(46904)|0;yH(47144,45992,8)|0;z=c[e>>2]|0;c[10456]=1;if((z|0)>=1){s=1;do{yH(47144,45656+(s+ -1<<3)|0,8)|0;u=c[10456]|0;s=u+1|0;c[10456]=s;}while((u|0)<(z|0))}RH()|0;c[46932>>2]=6;hI(46928)|0;RH()|0}z=c[e>>2]|0;c[10456]=1;if((z|0)>=1){s=c[10902]|0;v=1;while(1){c[10458]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[41656+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=41656+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[43936+(Aa+ -1<<3)>>3]*+h[38296+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[10462]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[10460]=E;c[10458]=s+1}T=c[e>>2]|0;c[10458]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=41912+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[41656+(Ea+ -1<<3)>>3]*+h[38296+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[10458]=T+1;c[10462]=Ca;c[10460]=Da}za=v+1|0;c[10456]=za;if((v|0)<(z|0)){v=za}else{break}}}c[10458]=0;v=c[e>>2]|0;c[10456]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[41912+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[10458]=Ga;c[10456]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[46956>>2]=6;hI(46952)|0;yH(47144,46024,4)|0;RH()|0;c[10900]=1;z=1;d:while(1){c[10462]=z;do{if((z|0)>(c[e>>2]|0)){s=c[10900]|0;if((s|0)==1){c[46980>>2]=6;hI(46976)|0;RH()|0;Dr(41912,43608,43936,45816,46392,q,45976)|0;c[47004>>2]=6;hI(47e3)|0;RH()|0;c[10900]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[10900]=2;c[10472]=0;c[10474]=0;s=c[e>>2]|0;c[10456]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=zU(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=sU(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=41912+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=41912+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[41912+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[10476]=Na;c[10474]=Ta;c[10472]=Ia;c[10458]=Ma;c[10456]=s+1}c[47028>>2]=6;hI(47024)|0;RH()|0;c[10472]=0;u=c[e>>2]|0;c[10456]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=41912+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[10472]=Wa;c[10456]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[10472]=T;s=c[e>>2]|0;c[10456]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[10466]=B;Qa=za+la|0;c[10472]=Qa;Pa=B+5|0;c[10468]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[10900]|0)==3){c[47100>>2]=6;hI(47096)|0;Pa=c[10468]|0;Qa=c[10466]|0;c[10458]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{yH(47144,43936+(B+ -1<<3)|0,8)|0;Qa=c[10458]|0;B=Qa+1|0;c[10458]=B;}while((Qa|0)<(Pa|0))}RH()|0}else{c[47076>>2]=6;hI(47072)|0;Pa=c[10468]|0;B=c[10466]|0;c[10458]=B;if((B|0)<=(Pa|0)){x=B;do{yH(47144,41912+(x+ -1<<3)|0,8)|0;B=c[10458]|0;x=B+1|0;c[10458]=x;}while((B|0)<(Pa|0))}RH()|0}Pa=c[10456]|0;x=Pa+1|0;c[10456]=x;if((Pa|0)>=(s|0)){break e}E=c[10462]|0;la=c[10472]|0;za=x}}}while(0);c[47124>>2]=6;hI(47120)|0;RH()|0;z=(c[10462]|0)+6|0}c[47052>>2]=6;hI(47048)|0;yH(47144,46040,4)|0;RH()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);$d[p&63](e,b,f)|0;i=r;return 0}function Dr(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[11806]=c[b>>2];c[g>>2]=1;if((c[11806]|0)<1){i=k;return 0}c[g>>2]=0;Er(a,47224,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[11806]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[11798]=f;c[11804]=g;c[11810]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=zU(a|0,0,g+ -2|0,0)|0;m=sU(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[11790]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=zU(p|0,0,a-n|0,0)|0;p=sU(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[11790]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[11788]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[11788]=j}c[11800]=g;c[11802]=f;c[11808]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[5898]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[5898]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[5898]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[11808]=D;E=v+ -1|0;c[11800]=E;F=w+ -1|0;c[11802]=F;q=D;v=E;w=F}c[11792]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[11794]=t;c[11804]=0;c[11810]=l-g;i=k;return 0}function Er(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[5912]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[5912]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[5912];c[11814]=1;c[11816]=0;n=c[b>>2]|0;c[11828]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[11818]=0;c[11830]=1;do{if((o|0)>=1){p=1;q=c[11816]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[5911]=m;u=(p|0)==(o|0);if(u){l=m*+h[5912];h[5913]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[5911]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[5913]=+h[5913]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[11818]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[11818]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[5911];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[11830]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[11812]=y;c[11820]=x;c[11816]=s;break}else if((D|0)==26){D=0;c[11812]=y;c[11820]=x;c[11816]=s;break}}}while(0);m=+V(+(+h[5913]));h[5913]=m;H=+h[5911];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[11816]|0)+ -1<<3)>>3]=G;G=+h[5913]/+h[5911];h[j+((c[11812]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[11816]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[11814]|0;O=c[11828]|0}}while(0);b=N+O|0;c[11814]=b;o=O+1|0;c[11828]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[11812]=y;c[11820]=x;c[11816]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Fr(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[11854]=n;o=(c[d>>2]|0)-n|0;c[11876]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[11874]=s;a[47440]=1;t=c[b>>2]|0;u=t+1|0;c[11870]=u;v=c[b>>2]|0;w=u+v|0;c[11868]=w;u=w+(c[b>>2]|0)|0;c[11872]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[11862]=w;x=w+(c[d>>2]|0)|0;c[11856]=x;y=x+(c[b>>2]|0)|0;c[11858]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[11864]=z;A=z+(c[d>>2]|0)|0;c[11878]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[11880]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[11852]=C;D=C+(c[b>>2]|0)|0;c[11866]=D;Gr(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,47496,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);hI(47528)|0;RH()|0;i=m;return 0}function Gr(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[6026]=.5;h[6017]=1.0;h[6057]=.1;F=(c[a>>2]|0)+1|0;c[12030]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[12022]=H;I=(c[b>>2]|0)-F|0;c[12076]=I;F=c[j>>2]|0;c[12130]=(F|0)<1?1:F;F=c[a>>2]|0;c[12014]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[12016]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[12016]=J+1}L=c[u>>2]|0;c[12012]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[12012]=L+1}K=j+1|0;c[12014]=K;if((j|0)<(F|0)){j=K}else{break}}}c[12018]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[12018]=H+1}H=c[b>>2]|0;c[12016]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[12014]=M;c[12016]=H+1}N=+h[e>>3];O=N*N;h[6062]=O;h[6048]=+h[6017]/O;h[6049]=+V(+(+h[6026]))/O;c[12020]=0;H=y;y=A;M=0;a:while(1){c[12032]=M;F=M-(c[a>>2]|0)|0;c[12056]=F;j=M+1|0;c[12020]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[12106]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[12044]=L;K=L+G|0;c[12042]=K;if((K|0)>(c[a>>2]|0)){c[12106]=L;G=K-(c[a>>2]|0)|0;c[12044]=G;c[12042]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[6039]=O;L=c[12030]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[6039]=N;R=N}else{R=O}O=+h[e>>3];h[6040]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[6040]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[6040];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[12014]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[12014]=S+1}if((M|0)>=(c[12130]|0)){T=j;U=159;break}while(1){$d[H&63](a,d,48040)|0;if((c[g>>2]|0)==3){hI(48568)|0;yH(48736,48080,4)|0;yH(48736,48040,8)|0;I=c[a>>2]|0;c[12012]=1;if((I|0)>=1){F=1;do{yH(48736,d+(F+ -1<<3)|0,8)|0;L=c[12012]|0;F=L+1|0;c[12012]=F;}while((L|0)<(I|0))}RH()|0}I=c[12020]|0;do{if((I|0)>(c[b>>2]|0)){F=c[12060]|0;if((F|0)==-1){break a}h[6058]=0.0;c[12018]=0;L=c[a>>2]|0;c[12014]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[6058]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[6031]=N;if((X|0)==(G|0)){ea=N*+h[6026];h[6031]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[6058]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[12018]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[12012]=Y;c[12014]=L+1;W=Z}J=c[b>>2]|0;c[12016]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[6058]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[12016]=J+1;ia=ja}O=+h[6005];ba=+h[6034];N=O-ba-ia;h[6025]=N;h[6044]=+h[6043];h[6043]=+h[6042];if(!(N>=0.0)){ka=-N}else{ka=N}h[6042]=ka;if(+h[6054]>+h[6020]){c[12104]=I}h[6050]=ba;do{if(O<ba){h[6034]=O;h[6067]=0.0;G=c[a>>2]|0;c[12012]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[6067]=+h[6067]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[12012]=G+1;h[A>>3]=ma}}while(0);c[12102]=F;if((F|0)<=0){O=+h[6058];if(O>=0.0){U=190;break a}ba=+h[6005];N=+h[6050];ea=(ba-N)/O;h[6055]=ea;O=+h[6057];do{if(!(ea<=O)){na=+h[6026]*+h[6047];h[A>>3]=na;oa=+h[6054];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[6047]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[6047]=qa;ra=qa;break}}else{qa=+h[6026]*+h[6054];h[6047]=qa;ra=qa}}while(0);ea=+h[6020];if(!(ra<=ea*1.5)){sa=ra}else{h[6047]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[6062]=ea;c[12118]=0;h[6063]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[12074]|0;c[12118]=J;oa=+h[6017];h[6063]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[12016]=1;if((J|0)<1){va=F}else{L=c[12076]|0;oa=ua;K=1;ca=F;while(1){h[6045]=0.0;c[12014]=1;if((L|0)<1){wa=0.0}else{X=c[12036]|0;aa=K+C|0;qa=+h[6017];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[6031]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[6045]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[12014]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[6027]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[6031]=za;h[6066]=0.0;$=c[a>>2]|0;c[12014]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[6066]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[12014]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[6031]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[6063]=Fa;c[12060]=K;Ga=Fa;Ha=K}aa=K+1|0;c[12016]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Ir(a,b,s,t,48144,u,w,48216,48240,x)|0;ca=c[12060]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[6005];c[12018]=0;J=c[a>>2]|0;c[12012]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[6031]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[6031];G=G+1|0;da=da+1|0}da=X+aa|0;c[12018]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[12014]=La;c[12012]=J+1}h[L>>3]=0.0;X=c[12076]|0;c[12014]=1;aa=(X|0)<1;if(!aa){F=c[12036]|0;K=1;while(1){da=fa(K,B)|0;O=+h[6025]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[6031]=Oa;G=c[b>>2]|0;c[12016]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[6031];$=$+1|0}c[12016]=G+1}$=K+1|0;c[12014]=$;if((K|0)<(X|0)){K=$}else{break}}}h[6036]=0.0;K=c[a>>2]|0;c[12012]=1;if((K|0)>=1){F=1;while(1){O=+h[6025]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[6036]=+h[6036]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[12012]=K+1;h[A>>3]=Pa}F=c[12102]|0;do{if((F|0)==0){if(!(+h[6047]==+h[6020])){break}O=+h[6055];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[12122]=0;break}L=c[b>>2]|0;c[12016]=1;if((L|0)>=1){J=o+((c[12074]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[12016]=L+1}h[6029]=0.0;$=c[a>>2]|0;c[12012]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[6023]=0.0;G=c[b>>2]|0;c[12016]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[6023]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[12016]=G+1;Sa=Ta}h[6029]=+h[6029]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[12012]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[6029]*100.0}J=c[12122]|0;c[12122]=J+1;if(+h[6036]<Ra){c[12122]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[12012]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[12012]=J+1}$=c[12022]|0;c[12018]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[12018]=$+1}c[12014]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[12016]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[12016]=Na+1;Ua=Wa}if((L|0)<(c[12036]|0)){h[J>>3]=-Ua}Va=L+1|0;c[12014]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[12016]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[12014]=Xa;c[12016]=L+1}c[12122]=0}}while(0);O=+h[6005];ea=+h[6050];if(O<ea){c[12074]=ca}oa=+h[6057];if(O<=ea+oa*+h[6058]|(F|0)>0){U=54;break}c[12060]=0;Ia=0;Ja=+h[6047];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[6005];oa=+h[6005];do{if((I|0)==1){h[6024]=oa;h[6034]=oa;c[12074]=1;Ya=1}else{if(!(oa<+h[6034])){Ya=I;break}h[6034]=oa;c[12074]=I;Ya=I}}while(0);F=c[12032]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[12042]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[12044]|0;Va=K+aa|0;c[12018]=Va;if(+h[6039]<0.0){aa=X+(c[a>>2]|0)|0;c[12042]=aa;Za=aa}else{Za=X}if(+h[6040]<0.0){X=K+(c[a>>2]|0)|0;c[12044]=X;_a=X}else{_a=K}K=fa(c[12056]|0,B)|0;h[t+(K-B<<3)>>3]=+h[6048];h[t+(Ya+C+K<<3)>>3]=+h[6048];h[t+(Za-B+K<<3)>>3]=-+h[6048];h[t+(_a-B+K<<3)>>3]=-+h[6048];h[q+(Va+ -1<<3)>>3]=(+h[6024]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[6005])/(+h[6039]*+h[6040])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[12056]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[6026]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[6026]/+h[e>>3];ea=+h[6049];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[6049];h[t+(X+K<<3)>>3]=+h[6049];K=(fa(Va+1|0,Va)|0)/2|0;c[12018]=K;ea=(+h[6024]- +h[6005])/+h[e>>3];h[6031]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[6026]*(+h[X>>3]+ +h[6031]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[6024])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[6017]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[6017]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[6026]*+h[6062]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[6020]=oa;h[6047]=oa;c[12036]=1;h[6042]=0.0;h[6043]=0.0;c[12122]=0;h[6067]=0.0;F=c[a>>2]|0;c[12012]=1;if((F|0)<1){U=53;break}ca=c[12074]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[6067]=+h[6067]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[12012]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[12104]=c[12020];U=54;continue}else if((U|0)==54){U=0;c[12060]=0;I=(c[12030]|0)+ -1|0;K=c[a>>2]|0;Hr(a,b,l,n,p,q,r,48376,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,48512)|0;h[6019]=0.0;K=c[a>>2]|0;c[12012]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[6019]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[12012]=K+1;ab=cb}oa=+h[6047];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[6054]=O;ea=+h[6020];if(!(O<+h[6026]*ea)){db=ab;U=62;break}c[12060]=-1;O=+h[6057];N=O*oa;h[6047]=N;h[6055]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[6047]=ea;eb=ea}if((c[12020]|0)<=((c[12104]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[6064]*.125*ea;h[6031]=N;oa=+h[6042];ba=+h[6043];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[6044];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[6066]=O;I=c[b>>2]|0;c[12016]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[6023]=0.0;X=c[a>>2]|0;c[12014]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[6023]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[12014]=X+1;jb=lb}if(jb>ea){c[12060]=F;h[6066]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[12016]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[6055]>0.0){U=54;continue}ea=+h[6054];O=+h[6020];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[6026];h[6047]=O;ea=hb/+h[f>>3];h[6055]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[6020]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[6020]=na;ob=na;break}}else{na=+h[f>>3];h[6020]=na;ob=na}}while(0);h[6047]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){hI(48616)|0;RH()|0}hI(48640)|0;yH(48736,48160,8)|0;yH(48736,48080,4)|0;RH()|0;hI(48664)|0;yH(48736,48272,8)|0;ca=c[a>>2]|0;c[12012]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];yH(48736,y,8)|0;I=c[12012]|0;F=I+1|0;c[12012]=F;}while((I|0)<(ca|0))}RH()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[6026]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[6020];O=na>=ea?na:ea;h[6056]=O;ea=O*O;h[6019]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[6067];if(db<=ea*.001){h[6060]=ea*.25;ca=c[b>>2]|0;c[12016]=1;if((ca|0)>=1){F=1;while(1){h[6023]=0.0;I=c[a>>2]|0;c[12012]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[6023]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[12012]=I+1;pb=qb}h[6031]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[6026]*+h[6067];h[6023]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[12012]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[6031]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[6026]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[6023]*+h[n+(F+C+Va<<3)>>3]+ +h[6060]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[12024]=aa;c[12014]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[12014]=Va;rb=Va}c[12012]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[12016]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[12076]|0;c[12016]=1;if((F|0)>=1){ca=1;while(1){h[6041]=0.0;X=c[b>>2]|0;c[12012]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[6041]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[12012]=I;if((K|0)>=(X|0)){break b}O=+h[6041];K=I}}}while(0);X=c[a>>2]|0;c[12014]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[6060]*+h[6041]*+h[l+(I<<3)>>3];h[6023]=O;Va=c[b>>2]|0;c[12012]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[6023]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[12012]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[12036]|0)){h[6023]=-+h[6023]}L=c[b>>2]|0;c[12012]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[6023]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[12012]=L+1}J=K+1|0;c[12014]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[12012]=1;if((K|0)>=1){X=c[12036]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[12024]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[6031]=ub;c[12014]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[6031];aa=aa+1|0}aa=J+1|0;c[12014]=aa;vb=aa}c[12012]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[12016]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[12018]=0;ca=c[a>>2]|0;c[12014]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[12016]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[6026]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[12016]=aa+1}c[12012]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[12018]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[12012]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[12014]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[12014]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[12014]=J+1}h[6067]=0.0}if((c[12060]|0)>0){F=(c[12030]|0)+ -1|0;ar(a,b,l,n,s,t,48144,u,48240,48448,v,48368,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[12016]=1;if((F|0)>=1){L=1;while(1){h[6032]=0.0;h[6033]=0.0;h[6023]=0.0;ca=c[a>>2]|0;c[12014]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[6032]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[6033]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[6023]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[12014]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[6026]+Ab);h[w+(K<<3)>>3]=+h[6023];K=L+1|0;c[12016]=K;if((L|0)<(F|0)){L=K}else{break}}}h[6027]=0.0;L=c[12076]|0;c[12016]=1;if((L|0)>=1){F=1;while(1){h[6023]=0.0;J=c[b>>2]|0;c[12012]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[6023]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[12012]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[6027];if((F|0)<(c[12036]|0)){h[6027]=O+ea;na=-Eb;h[6023]=na;Gb=na}else{h[6027]=O-ea;Gb=Eb}K=c[b>>2]|0;c[12012]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[6023];X=X+1|0}c[12012]=K+1}X=F+1|0;c[12016]=X;if((F|0)<(L|0)){F=X}else{break}}}h[6035]=0.0;h[6014]=0.0;F=c[a>>2]|0;c[12014]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[6023]=0.0;X=c[b>>2]|0;c[12012]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[6023]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[12012]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[6035]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[12026]=K;Va=c[a>>2]|0;c[12016]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[6023]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[12016]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[6035]+ +h[6023]*+h[ca>>3];h[6035]=O;na=+h[6014]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[6014]=na;aa=L+1|0;c[12014]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[6019];h[6027]=+h[6027]+(Ib*Ib+ea*(Ib+(Ib+ +h[6067])+ea*+h[6026]))-Hb;L=w+((c[12074]|0)+ -1<<3)|0;h[L>>3]=+h[6017]+ +h[L>>3];L=c[12060]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[6017]+ +h[6046]*+h[6027]/(ea*ea);h[6031]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;$q(a,b,l,n,s,t,48144,u,48296,48240,v,x,w,48216,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[12012]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[12012]=L+1}F=c[12020]|0;aa=F+1|0;c[12020]=aa;if((F|0)>=(c[12130]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[12020]=T+ -1;if((c[g>>2]|0)<=0){break}hI(48544)|0;RH()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}hI(48592)|0;RH()|0}}while(0);Nb=+h[6034];if(Nb<=+h[6005]){U=c[a>>2]|0;c[12012]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[12012]=U+1;Ob=+h[6034]}h[6005]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}hI(48688)|0;yH(48736,48080,4)|0;RH()|0;hI(48712)|0;yH(48736,48040,8)|0;g=c[a>>2]|0;c[12012]=1;if((g|0)>=1){a=1;do{yH(48736,d+(a+ -1<<3)|0,8)|0;U=c[12012]|0;a=U+1|0;c[12012]=a;}while((U|0)<(g|0))}RH()|0;i=z;return 0}function Hr(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[6112]=.5;h[6130]=6.283185307179586;v=+h[l>>3];h[6125]=v*v;c[12246]=0;l=c[b>>2]|0;c[12264]=l;c[12262]=l;w=c[b>>2]|0;c[12186]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[12186]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[12186]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[12186]=w+1}z=c[d>>2]|0;c[12190]=1;if((z|0)>=1){e=1;while(1){h[6116]=0.0;A=c[b>>2]|0;c[12188]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[6116]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[12188]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[6116]=v;C=c[b>>2]|0;c[12186]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[6116];F=F+1|0}c[12186]=C+1}F=e+1|0;c[12190]=F;if((e|0)<(z|0)){e=F}else{break}}}c[12200]=0;e=c[b>>2]|0;c[12188]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[12200]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[12186]=H;c[12188]=e+1}do{if((y|0)==0){h[6114]=0.0;h[6096]=0.0;w=c[b>>2]|0;c[12186]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[6096]=+h[6096]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[12186]=w+1}h[r>>3]=0.0;D=+h[6096];if(D==0.0){O=55;break a}h[6101]=0.0;h[6104]=0.0;h[6099]=D;h[6119]=D;P=D;Q=0.0;R=0.0;S=+h[6125];T=0}else{if((y|0)>(x|0)){h[6098]=0.0;h[6105]=0.0;h[6106]=0.0;z=c[b>>2]|0;c[12186]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[6098]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[6105]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[6106]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[12186]=z+1;U=ba;W=$;Z=aa}D=+h[6112];v=D*(+h[6109]-Z);h[6097]=v;_=+h[6102];ca=_+v;h[6113]=ca;h[6117]=ca;h[6115]=ca;c[12256]=0;a[48824]=1;da=+h[6130]/50.0;h[6116]=da;c[12186]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[6115]=ka;c[12256]=w;h[6126]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[6127]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[6121]=ha;h[6107]=ia;h[6110]=ja;h[6118]=ka;c[12186]=50;h[6117]=ka;if((la|0)==49){h[6127]=ca;na=ca}else if((la|0)==0){h[6126]=ka;O=46}else{O=46}if((O|0)==46){O=0;na=+h[6127]}h[6121]=0.0;ga=+h[6126];if(ga!=na){ea=ga-ma;h[6126]=ea;ga=na-ma;h[6127]=ga;oa=D*(ea-ga)/(ea+ga);h[6121]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[6121]=oa;ga=+X(+oa);h[6107]=ga;ea=+Y(+oa);h[6110]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[6122]=oa;h[6099]=0.0;w=c[b>>2]|0;c[12186]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[6107]*+h[J>>3]+ +h[6110]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[6099]+sa*sa;h[6099]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[6110];ea=+h[6107];F=F+1|0;z=K}c[12186]=w+1;qa=ta;ra=+h[6122]}ea=ra+ +h[6114];h[6114]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[6105]=0.0;z=c[b>>2]|0;c[12188]=1;do{if((z|0)<1){ea=+h[6129];h[6120]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[6105]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[12188]=z+1;ea=+h[6129];h[6120]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[6096];h[6116]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[6116]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[6120];oa=+h[6099];v=+h[6105];_=oa/v;ca=ea<=_?ea:_;h[6120]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[6099];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[6112]*Ca);h[6111]=ca;h[6114]=+h[6114]+ca;h[6124]=Ba;h[6099]=0.0;z=c[b>>2]|0;c[12186]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[6120]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[6099]+oa*oa;h[6099]=Ga;Ha=+h[6120];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[12186]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[6129]){if(+h[6111]<=+h[6114]*.01){O=55;break a}if(Fa<=+h[6119]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[6124];h[6116]=ca;h[6096]=0.0;h[6101]=0.0;h[6104]=0.0;w=c[b>>2]|0;c[12186]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[6096]+ca*ca;h[6096]=La;J=m+(F<<3)|0;Ma=+h[6101]+ +h[K>>3]*+h[J>>3];h[6101]=Ma;ca=+h[J>>3];Na=+h[6104]+ca*ca;h[6104]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[6116];Ja=Ja+1|0;Ka=J}c[12186]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[6125];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[12262]=y;ua=+h[6099];va=y}if(ua<=+h[6119]*1.0e-4){O=55;break a}h[6102]=0.0;h[6109]=0.0;z=c[b>>2]|0;c[12186]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[6102]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[6109]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[12186]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[6108]=ca;oa=+h[6125];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[12246]=J;_=+V(+(v-ca*ca));h[6116]=_;v=oa/_;h[6126]=v;oa=ca/_;h[6127]=oa;w=c[b>>2]|0;c[12186]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[6127];Ta=+h[6126];Ua=Ua+1|0;Va=K}c[12186]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[12246]=e;v=S-R;h[6116]=v;h[6129]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Ir(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[6139]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[12284]=t;c[12274]=1;c[12268]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[12274]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[6141]=D;C=+h[x>>3]/D;h[6148]=C;z=+h[f+(B+y<<3)>>3]/D;h[6149]=z;B=c[d>>2]|0;c[12266]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[6141]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[6141];if((x|0)>=(B|0)){break}D=+h[6149];z=+h[6148];x=x+1|0}c[12266]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[12268]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[6148]=z;if((c[g>>2]|0)>1){D=-z;h[6148]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[6149]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[12266]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[6149]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[6148];t=t+1|0;x=A}c[12266]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[6146]=z;x=k+(w<<3)|0;H=+h[x>>3];h[6140]=H;D=H*H;h[6150]=D;h[6147]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[6139];a[49144]=0;do{if((u|0)==1){z=+h[6147];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[6141]=z;D=+h[6148]/z;h[6149]=D;H=+h[6140]/z;h[6148]=H;x=c[d>>2]|0;c[12266]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[6149];D=+h[6148];w=w+1|0;t=s}c[12266]=x+1;J=+h[6141]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[12270]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[12270]=u;M=u}t=u+1-M|0;c[12272]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[6147];z=+h[f+(t+w<<3)>>3]/D;h[6141]=z;h[6148]=z*+h[l>>3];H=+h[6140];h[6149]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[6141]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[6139]/+V(+(+h[6150]+z*N*z));h[6144]=C;if(!(D>=0.0)){O=-D}else{O=D}h[6145]=C*+V(+O);t=c[d>>2]|0;c[12266]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[6145]*(+h[A>>3]- +h[6148]*+h[n+(G<<3)>>3]- +h[6149]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[6141];z=+h[6140];H=+h[6144];v=v+1|0}c[12266]=t+1;P=+h[6147]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[49144]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[12266]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[6141]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[6141];K=Q+1|0;c[12266]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[12268]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[12276]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[6140];N=+h[6147];J=(+h[6146]*+h[f>>3]-O*P)/N;h[6148]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[6149]=P;c[12266]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[12266]=q;if((f|0)>=(b|0)){break a}N=+h[6149];O=+h[6148];f=q}}}while(0);b=R+1|0;c[12268]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Jr(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Kr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Jr(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){_a(49208,49224,116,49248)}else if((s|0)==14){i=g;return o|0}return 0}function Lr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((cU(w,c[49256+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[49360+(x<<2)>>2]|0;c[q>>2]=c[49256+(x<<2)>>2];c[q+4>>2]=y;yp(23,0,49432,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=GT(D,8)|0;c[e+40>>2]=B;D=b+536|0;Bp(c[D>>2]|0,(B|0)!=0|0,49472,p);B=GT(c[A>>2]|0,4)|0;c[e+36>>2]=B;Bp(c[D>>2]|0,(B|0)!=0|0,49472,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=GT(c[C>>2]|0,4)|0;c[e+24>>2]=ET(8)|0;C=ET(4)|0;c[e+20>>2]=C;c[C>>2]=c[21776>>2];Bp(c[D>>2]|0,(C|0)!=0|0,49472,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=ET(C)|0;A=e+44|0;c[A>>2]=ET(C)|0;C=GT(15,4)|0;E=e+12|0;c[E>>2]=C;Bp(c[D>>2]|0,(C|0)!=0|0,49472,m);C=GT(5,4)|0;c[e+4>>2]=C;Bp(c[D>>2]|0,(C|0)!=0|0,49472,l);C=GT(5,4)|0;c[e+8>>2]=C;Bp(c[D>>2]|0,(C|0)!=0|0,49472,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=ET(C)|0;c[e+76>>2]=ET(C)|0;c[e+80>>2]=ET(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((Wd[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){yp(23,0,49488,j)}else{yp(1,0,49560,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[21812>>2]|c[5428]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=49392;W=V;Cp(Q,W,r)}c[t>>2]=w;Ap(23,1,49288,t);t=1;do{w=c[49360+(t<<2)>>2]|0;c[s>>2]=c[49256+(t<<2)>>2];c[s+4>>2]=w;Ap(23,0,49344,s);t=t+1|0;}while((t|0)<8);Td[c[5568]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=49392;W=V;Cp(Q,W,r);return 0}function Mr(a){a=a|0;var b=0;b=i;FT(c[a+40>>2]|0);FT(c[a+36>>2]|0);FT(c[a+20>>2]|0);FT(c[a+12>>2]|0);FT(c[a+4>>2]|0);FT(c[a+8>>2]|0);FT(a);i=b;return 0}function Nr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Bp(c[N>>2]|0,(c[M>>2]|0)!=0|0,49656,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){yp(3,0,49688,B);yp(3,0,49728,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];Wd[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(3,0,49752,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];yp(23,0,49792,y);if((c[z>>2]|0)==1){Gq(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){tt(a)|0;Wd[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{cr(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{cr(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{cr(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 5:{cr(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{cr(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){cr(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{cr(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){hd(_|0)|0;hd($|0)|0;Ap(3,0,49824,x);yp(3,0,49912,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){hd(_|0)|0;hd($|0)|0;$=Wr(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){tt(a)|0;Wd[c[(c[ba>>2]|0)+40>>2]&127](a)|0}Wd[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Ap(1,0,49936,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[21732>>2]|0)!=0){yp(3,1,49968,u);c[s>>2]=c[z>>2];yp(3,0,49992,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];yp(3,0,50016,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];yp(3,0,50048,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];yp(3,0,50088,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];yp(3,0,50136,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];yp(3,0,50184,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];yp(3,0,50224,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];yp(3,0,50264,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];yp(3,0,50304,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];yp(3,0,50352,f);Td[c[5568]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){_a(50392,50424,410,50456)}yp(3,0,50472,e);S=0;i=d;return S|0}function Or(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;tt(g)|0;a=f+540|0;Wd[c[(c[a>>2]|0)+40>>2]&127](g)|0;Wd[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Pr(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;tt(l)|0;b=k+540|0;Wd[c[(c[b>>2]|0)+40>>2]&127](l)|0;Wd[c[(c[b>>2]|0)+28>>2]&127](l)|0;Yr(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Qr(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];tt(g)|0;l=e+540|0;Wd[c[(c[l>>2]|0)+40>>2]&127](g)|0;Wd[c[(c[l>>2]|0)+28>>2]&127](g)|0;Wd[c[(c[l>>2]|0)+32>>2]&127](g)|0;$d[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function Rr(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;Zr(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Sr(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;tt(l)|0;b=k+540|0;Wd[c[(c[b>>2]|0)+40>>2]&127](l)|0;Wd[c[(c[b>>2]|0)+28>>2]&127](l)|0;Xr(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function Tr(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function Ur(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;_r(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function Vr(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function Wr(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-11:{Ap(1,0,50880,d);m=-11;i=b;return m|0};case-12:{Ap(1,0,50968,c);m=-12;i=b;return m|0};case-10:{Ap(1,0,50784,e);m=-10;i=b;return m|0};case-7:{Ap(1,0,50608,h);m=-7;i=b;return m|0};case-8:{Ap(1,0,50648,g);m=-8;i=b;return m|0};case-6:{Ap(1,0,50536,j);m=-6;i=b;return m|0};case-2:{Ap(1,0,50496,k);m=-2;i=b;return m|0};case-1:{Ap(3,0,49824,l);m=1;i=b;return m|0};case-33:{Ap(1,0,51016,b);m=-33;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-9:{Ap(1,0,50696,f);m=-9;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function Xr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}Wd[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function Yr(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;Wd[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}



function Zr(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+gd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+gd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Or(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function _r(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+gd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+gd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Or(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function $r(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function as(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;Td[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function bs(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function cs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Op(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{he[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Mp(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Op(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function ds(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((cs(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}es(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Op(d)|0)>0;h=b?2:0;i=e;return h|0}function es(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=ET(q)|0;s=r;t=ET(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[12944]=Kp(4)|0;if((r|0)==0){_a(51784,51800,308,51832)}if((t|0)==0){_a(51848,51800,309,51832)}v=Rp(b)|0;if((v|0)!=0){w=v;do{v=Tp(w)|0;c[l>>2]=c[v>>2];yp(27,0,51864,l);w=Sp(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;iU(t|0,c[a+384>>2]|0,v|0)|0;iU(r|0,l|0,v|0)|0}h[d>>3]=+hs(a,n,o,q,s,c[12944]|0,b);do{if((Op(c[12944]|0)|0)==0){s=Pp(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Rp(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Tp(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Sp(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];yp(27,0,51912,j);v=Rp(b)|0;if((v|0)==0){break}else{B=v}do{v=Tp(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[12944]|0;Np(v,Tp(B)|0);v=Tp(B)|0;c[g>>2]=c[v>>2];yp(27,0,51936,g)}B=Sp(B)|0;}while((B|0)!=0)}}while(0);Lp(b);if((c[21748>>2]|0)!=0){Op(c[12944]|0)|0}if((Op(c[12944]|0)|0)>0){B=m;do{g=Pp(c[12944]|0)|0;c[m>>2]=c[g>>2];Qp(c[12944]|0);c[f>>2]=c[m>>2];yp(7,0,51960,f);Mp(b,B);}while((Op(c[12944]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){iU(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ie(a);ks(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){FT(t);FT(r);i=e;return}iU(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;FT(t);FT(r);i=e;return}function fs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){os(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(7,0,51504,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Op(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[21748>>2]|0)!=0){e=Rp(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Tp(s)|0;x=c[e>>2]|0;e=he[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;xp(7,0,w,51528,l);s=Sp(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Tp(Rp(d)|0)|0;x=he[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;xp(1,0,e,51544,j);c[s>>2]=1}}while(0);Lp(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;js(b);gs(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function gs(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;yp(27,0,52152,b);d=a+344|0;$d[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function hs(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=ET(p<<3)|0;if((q|0)==0){_a(51968,51800,409,51984)}if((p|0)>0){iU(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];yp(27,0,52e3,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];yp(27,0,52048,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){FT(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}tt(a)|0;Wd[c[(c[p>>2]|0)+40>>2]&127](a)|0;Wd[c[(c[p>>2]|0)+28>>2]&127](a)|0;Wd[c[(c[p>>2]|0)+32>>2]&127](a)|0;$d[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(is(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}iU(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}FT(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function is(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Lp(b);yp(27,0,52072,g);g=Rp(d)|0;if((g|0)==0){j=Op(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Tp(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Tp(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Tp(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Tp(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Tp(a)|0;o=c[g>>2]|0;g=Tp(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?51488:51496;g=Tp(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?51488:51496;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;yp(27,0,52112,f);Mp(b,Tp(a)|0)}a=Sp(a)|0;}while((a|0)!=0);j=Op(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function js(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;he[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;ks(b);ls(b);Wd[c[(c[g>>2]|0)+36>>2]&127](b)|0;ms(b,8);h=ns(b)|0;j=Wd[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{ls(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}os(b);ks(b);ms(b,8);Wd[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=ns(b)|0;j=Wd[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Cp(c[b+536>>2]|0,52192,e)}else if((o|0)==7){ls(b);i=d;return}}function ks(a){a=a|0;var b=0;b=i;iU(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function ls(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function ms(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[21720+(d<<2)>>2]|0)==0){i=e;return}yp(d,1,52616,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=Wd[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=Wd[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;yp(d,0,52640,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}Td[c[5568]&255](d);i=e;return}function ns(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function os(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;iU(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;iU(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;iU(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;iU(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}$d[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function qs(a){a=a|0;var b=0;b=i;rs(a);ss(a);os(a);ts(a);i=b;return}function rs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Fq(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];iU(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;iU(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;iU(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;iU(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Fq(c[d>>2]|0)|0));i=b;return}function us(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[21720+(d<<2)>>2]|0)==0){i=e;return}yp(d,1,52288,q);q=b+136|0;if((c[q>>2]|0)>0){yp(d,1,52312,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?52272:52280;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];yp(d,0,52328,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}Td[c[5568]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){yp(d,1,52384,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?52272:52280;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;yp(d,0,52408,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}Td[c[5568]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){yp(d,1,52464,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?52272:52280;v=(a[n+(m*48|0)+40|0]|0)!=0?52272:52280;n=(a[(c[s>>2]|0)+m|0]|0)!=0?52272:52280;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;yp(d,0,52488,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}Td[c[5568]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){yp(d,1,52544,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;yp(d,0,52568,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}Td[c[5568]&255](d)}Td[c[5568]&255](d);i=e;return}function vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Fq(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];iU(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;iU(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;iU(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;iU(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Fq(c[d>>2]|0)|0));i=b;return}function ws(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function xs(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];iU(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;iU(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;iU(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;iU(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Aq(3,32)|0;c[o>>2]=p;if((p|0)==0){Cp(c[b+536>>2]|0,52672,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=GT(c[p>>2]|0,8)|0;c[q>>2]=z;Bp(c[r>>2]|0,(z|0)!=0|0,52728,l);z=GT(c[s>>2]|0,4)|0;c[t>>2]=z;Bp(c[r>>2]|0,(z|0)!=0|0,52728,k);z=GT(c[u>>2]|0,1)|0;c[v>>2]=z;Bp(c[r>>2]|0,(z|0)!=0|0,52728,j);z=GT(c[w>>2]|0,4)|0;c[x>>2]=z;Bp(c[r>>2]|0,(z|0)!=0|0,52728,g);Eq(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=GT(3,4)|0;c[b+4>>2]=n;Gq(c[o>>2]|0,0,n);c[b+8>>2]=GT(c[p>>2]|0,112)|0;c[b+12>>2]=GT(c[s>>2]|0,60)|0;c[b+16>>2]=GT(c[u>>2]|0,48)|0;c[b+20>>2]=GT(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=GT(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=GT(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=GT(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=GT(g,52)|0;c[b+40>>2]=GT(c[b+216>>2]|0,52)|0;c[b+44>>2]=GT(c[b+220>>2]|0,52)|0;c[b+48>>2]=GT(c[b+224>>2]|0,52)|0;c[b+52>>2]=GT(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=GT(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=GT(x,8)|0;c[b+340>>2]=GT(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=GT(x,8)|0;c[b+348>>2]=GT(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=GT(j,1)|0;c[b+356>>2]=GT(j,1)|0;c[b+360>>2]=GT(j,1)|0;j=ET(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=ET(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=GT(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=GT(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=GT(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=GT(u,4)|0;c[b+400>>2]=GT(x,8)|0;c[b+404>>2]=GT(p,4)|0;c[b+408>>2]=GT(s,1)|0;c[b+412>>2]=GT(u,4)|0;c[b+416>>2]=GT(c[n>>2]|0,8)|0;c[b+420>>2]=GT(o,4)|0;c[b+424>>2]=GT(y,1)|0;c[b+428>>2]=GT(g,4)|0;c[b+432>>2]=GT(c[b+152>>2]|0,8)|0;c[b+436>>2]=GT(c[b+156>>2]|0,8)|0;g=ET((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;Td[c[(c[y>>2]|0)+20>>2]&255](g);g=ET((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;Td[c[(c[y>>2]|0)+16>>2]&255](g);g=ET((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;Td[c[(c[y>>2]|0)+12>>2]&255](g);g=ET((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;Ud[c[(c[y>>2]|0)+24>>2]&63](g,b);c[b+464>>2]=ET((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=GT(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Bp(c[r>>2]|0,(g|0)!=0|0,52744,f);c[b+512>>2]=100;c[b+516>>2]=GT(100,4)|0;c[b+520>>2]=GT(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=ET(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Bp(c[r>>2]|0,(g|0)!=0|0,52728,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Aq(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function zs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;FT(c[g+8>>2]|0);FT(c[g+12>>2]|0);FT(c[g+16>>2]|0);FT(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);FT(e);Bq(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){Xq(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}FT(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){Xq(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}FT(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){Xq(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}FT(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){Xq(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}FT(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){Xq(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}FT(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){Xq(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}FT(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){Xq(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}FT(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){Xq(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}FT(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){Xq(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}FT(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){Xq(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}FT(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){Xq(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}FT(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){Xq(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}FT(v);FT(c[a+108>>2]|0);FT(c[a+336>>2]|0);FT(c[a+340>>2]|0);FT(c[a+344>>2]|0);FT(c[a+348>>2]|0);FT(c[a+352>>2]|0);FT(c[a+356>>2]|0);FT(c[a+360>>2]|0);FT(c[a+368>>2]|0);FT(c[a+384>>2]|0);FT(c[a+388>>2]|0);FT(c[a+392>>2]|0);FT(c[a+396>>2]|0);FT(c[a+400>>2]|0);FT(c[a+404>>2]|0);FT(c[a+408>>2]|0);FT(c[a+412>>2]|0);FT(c[a+416>>2]|0);FT(c[a+420>>2]|0);FT(c[a+424>>2]|0);FT(c[a+428>>2]|0);FT(c[a+488>>2]|0);FT(c[a+484>>2]|0);FT(c[a+476>>2]|0);FT(c[a+468>>2]|0);FT(c[a+464>>2]|0);FT(c[a+432>>2]|0);FT(c[a+436>>2]|0);FT(c[a+320>>2]|0);FT(c[a+516>>2]|0);FT(c[a+520>>2]|0);_G(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;FT(x);i=b;return}else{y=a;z=0}while(1){Bq(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;FT(x);i=b;return}function As(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[6598]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];yp(8,0,52792,d);i=b;return}function Bs(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[6598];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function Cs(a,b){a=+a;b=+b;i=i;return a<b|0}function Ds(a,b){a=+a;b=+b;i=i;return a<=b|0}function Es(a,b){a=+a;b=+b;i=i;return a>b|0}function Fs(a,b){a=+a;b=+b;i=i;return a>=b|0}function Gs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=ET(k)|0;c[e+(h*40|0)+24>>2]=ET(k)|0;if((c[g>>2]|0)!=1){l=5;break}Js(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Cp(c[a+536>>2]|0,52848,d)}else if((l|0)==6){i=b;return 0}return 0}function Hs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){FT(c[e+(h*40|0)+20>>2]|0);FT(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Ks(k)|0;FT(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Cp(c[a+536>>2]|0,52848,d)}else if((j|0)==6){i=b;return 0}return 0}function Is(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[21788>>2]|c[5428]|0)==0){z=w;A=1;break}YG(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ap(17,1,52880,g);YG(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;YG(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Ap(17,0,52912,f);YG(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Td[c[5568]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Js(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=ET(20)|0;c[b>>2]=f;Bp(0,(f|0)!=0|0,52920,e);e=ET(a)|0;c[f>>2]=e;e=ET(a)|0;c[f+4>>2]=e;e=ET(a)|0;c[f+8>>2]=e;e=ET(a)|0;c[f+16>>2]=e;Bp(0,(c[b>>2]|0)!=0|0,52952,d);i=d;return 0}function Ks(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;FT(c[d>>2]|0);FT(c[d+4>>2]|0);FT(c[d+8>>2]|0);FT(c[d+16>>2]|0);i=b;return 0}function Ls(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Cp(c[a+536>>2]|0,53e3,b);return 0}function Ms(a){a=a|0;a=i;i=i+8|0;Cp(0,53e3,a);return 0}function Ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=ET(l)|0;c[e+(h<<6)+36>>2]=ET(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=ET(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;Ss(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;Us(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){Cp(c[a+536>>2]|0,53040,d)}else if((n|0)==8){i=b;return 0}return 0}function Os(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Ps(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;rb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){FT(c[e+(h<<6)+28>>2]|0);FT(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){Vs(e+(h<<6)+24|0)|0}else if((j|0)==1){Ts(e+(h<<6)+24|0)|0;FT(c[e+(h<<6)+32>>2]|0)}else{k=6;break}FT(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Cp(c[a+536>>2]|0,53040,d)}else if((k|0)==8){i=b;return 0}return 0}function Rs(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[21780>>2]|c[5428]|0)==0){z=w;A=1;break}YG(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Ap(15,1,53072,g);YG(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;YG(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Ap(15,0,53104,f);YG(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}Td[c[5568]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Ss(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=ET(12)|0;f=ET(a<<2)|0;c[e>>2]=f;Bp(0,(f|0)!=0|0,53112,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function Ts(a){a=a|0;var b=0;b=i;FT(c[c[a>>2]>>2]|0);i=b;return 0}function Us(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=ET(32)|0;Bp(0,(g|0)!=0|0,53168,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Kd(0,d|0)|0;zd(c[d>>2]|0,c[b>>2]|0,0)|0;Kd(0,g+4|0)|0;zd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;Za(b|0)|0;Fb(53216,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function Vs(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Gd(c[d+12>>2]|0)|0;Eb(c[d+8>>2]|0)|0;Eb(c[d+4>>2]|0)|0;i=b;return 0}function Ws(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Bp(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,53384,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Bp(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,53424,e);if((Wd[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=ET(p)|0;c[g+(m*80|0)+52>>2]=ET(p)|0;c[g+(m*80|0)+48>>2]=ET(p)|0;c[g+(m*80|0)+16>>2]=ET(p)|0;c[g+(m*80|0)+8>>2]=ET(p)|0;c[g+(m*80|0)+12>>2]=ET(p)|0;Ud[c[g+(m*80|0)+36>>2]&63](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){$s(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){Zs(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Ls(a,n)|0;break}else if((p|0)==3){$s(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Cp(c[j>>2]|0,53464,d)}else if((q|0)==14){i=b;return 0}return 0}function Xs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;FT(c[e+(h*80|0)+44>>2]|0);FT(c[e+(h*80|0)+52>>2]|0);FT(c[e+(h*80|0)+48>>2]|0);FT(c[e+(h*80|0)+16>>2]|0);FT(c[e+(h*80|0)+8>>2]|0);FT(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;at(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==3){n=e+(h*80|0)+40|0;at(n)|0;l=n;break}else if((k|0)==1){k=e+(h*80|0)+40|0;_s(k)|0;l=k;break}else{m=9;break a}}}while(0);FT(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){Ms(j)|0}else if((m|0)==9){Cp(c[a+536>>2]|0,53464,d)}else if((m|0)==11){i=b;return 0}return 0}function Ys(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;YG(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];zp(17,1,u,53496,m);do{if((a[b+312|0]|0)==0){YG(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;YG(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Ap(17,0,53696,f);YG(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Ap(17,1,53536,l);YG(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;YG(q,d,c[v>>2]|0);if((cU(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Ap(17,0,53616,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;YG(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Ap(17,0,53656,g);G=E}YG(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[21788>>2]|c[5428]|0)==0){break}Td[c[5568]&255](17)}}while(0);if((c[21788>>2]|c[5428]|0)==0){x=1;i=e;return x|0}Td[c[5568]&255](17);x=1;i=e;return x|0}function Zs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=ET(144)|0;c[b>>2]=f;Bp(0,(f|0)!=0|0,53712,e);c[f>>2]=0;e=a<<3;g=ET(e)|0;c[f+4>>2]=g;g=ET(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=ET(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=ET(e)|0;c[f+24>>2]=g;g=GT(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=ET(e)|0;c[f+64>>2]=g;g=ET(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=GT(g,8)|0;c[f+104>>2]=j;j=GT(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=ET(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=ET(e)|0;c[f+124>>2]=j;j=ET(e)|0;c[f+128>>2]=j;j=ET(e)|0;c[f+132>>2]=j;j=ET(e)|0;c[f+136>>2]=j;j=ET(e)|0;c[f+140>>2]=j;Bp(0,(c[b>>2]|0)!=0|0,53744,d);i=d;return 0}function _s(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;FT(c[d+4>>2]|0);FT(c[d+16>>2]|0);FT(c[d+12>>2]|0);FT(c[d+24>>2]|0);FT(c[d+28>>2]|0);FT(c[d+64>>2]|0);FT(c[d+68>>2]|0);FT(c[d+104>>2]|0);FT(c[d+108>>2]|0);FT(c[d+116>>2]|0);FT(c[d+124>>2]|0);FT(c[d+128>>2]|0);FT(c[d+132>>2]|0);FT(c[d+136>>2]|0);FT(c[d+140>>2]|0);i=b;return 0}function $s(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=ET(80)|0;c[b>>2]=f;Bp(0,(f|0)!=0|0,53784,e);c[f>>2]=0;e=a<<3;g=ET(e)|0;c[f+4>>2]=g;g=ET(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=ET(e)|0;c[f+16>>2]=g;g=GT(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=ET(fa(e,a)|0)|0;c[f+64>>2]=g;g=ET(e)|0;c[f+68>>2]=g;g=ET(a<<2)|0;c[f+72>>2]=g;Bp(0,(c[b>>2]|0)!=0|0,53816,d);i=d;return 0}function at(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;FT(c[d+4>>2]|0);FT(c[d+8>>2]|0);FT(c[d+16>>2]|0);FT(c[d+20>>2]|0);FT(c[d+64>>2]|0);FT(c[d+68>>2]|0);FT(c[d+72>>2]|0);i=b;return 0}function bt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==1){f=c[a+4>>2]|0;g=c[f+4>>2]|0;dt(c[f>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);j=0;i=d;return j|0}else if((e|0)==4){de[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];j=0;i=d;return j|0}else if((e|0)==2){ct(a,b);j=0;i=d;return j|0}else if((e|0)==3){j=Nr(a,b)|0;i=d;return j|0}else{j=1;i=d;return j|0}return 0}function ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[53856+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[53856+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];Wd[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function dt(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function et(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Kp(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=ET(8)|0;c[j+4>>2]=4;k=ET(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=GT(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==3){k=ET(88)|0;yp(23,0,53888,f);m=Lr(b,d,k)|0;c[d+48>>2]=k;n=m}else if((g|0)==4){m=c[432]|0;k=ET(m<<2)|0;c[13478]=k;if((m|0)<=0){n=0;break}l=c[b+116>>2]|0;o=k;k=0;while(1){c[o+(k<<2)>>2]=GT(l,8)|0;p=k+1|0;if((p|0)>=(m|0)){n=0;break a}o=c[13478]|0;k=p}}else{n=0}}while(0);rt(b)|0;if((c[2]|0)==0){i=e;return n|0}Uq(6);Rq(1);i=e;return n|0}function ft(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){Mr(c[b+48>>2]|0)|0}else if((e|0)==4){f=c[432]|0;g=c[13478]|0;if((f|0)>0){h=g;j=0;while(1){FT(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[13478]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}FT(m)}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){FT(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}FT(n);FT(c[e>>2]|0)}st(a)|0;mt(a);i=d;return 0}function gt(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(194,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=tU(c[s>>2]|0,o)|0;if((t|0)==0){ab(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=tU(c[s>>2]|0,o)|0;if((B|0)==0){ab(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=tU(c[C>>2]|0,o)|0;if((D|0)==0){ab(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=tU(c[C>>2]|0,o)|0;if((E|0)==0){ab(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=tU(c[s>>2]|0,o)|0;if((F|0)==0){ab(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(195,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=tU(c[s>>2]|0,o)|0;if((G|0)==0){ab(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=tU(c[s>>2]|0,o)|0;if((H|0)==0){ab(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;fU(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=tU(c[L>>2]|0,o)|0;if((M|0)==0){ab(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ha(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=tU(c[p>>2]|0,o)|0;if((N|0)==0){ab(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Pa(14,1,0,53920,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=tU(c[M>>2]|0,o)|0;if((U|0)==0){ab(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=tU(c[M>>2]|0,o)|0;if((V|0)==0){ab(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Pa(15,2,0,54016,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=tU(c[M>>2]|0,o)|0;if((X|0)==0){ab(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[60136>>2]|0,60112,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=tU(c[M>>2]|0,o)|0;if((Y|0)==0){ab(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Pa(15,23,0,54072,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=tU(c[M>>2]|0,o)|0;if((Z|0)==0){ab(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(196,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=tU(c[M>>2]|0,o)|0;if(($|0)==0){ab(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function ht(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];yp(8,0,54168,G);I=b+313|0;a[I]=1;js(b);if((c[75508>>2]|0)==0){Ud[c[60132>>2]&63](60112,b)}a[I]=0}}while(0);if((e|0)!=0){it(md(e|0)|0,b)}if((c[21820>>2]|0)==0){i=f;return 0}Uq(0);yp(25,0,54216,F);yp(25,1,54240,E);H=+Mq(6);J=+Mq(6);K=J/+Mq(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];yp(25,0,54248,D);K=+Mq(1);H=+Mq(1);J=H/+Mq(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];yp(25,0,54288,C);J=+Mq(2);K=+Mq(2);H=K/+Mq(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];yp(25,0,54320,B);H=+Mq(3);J=+Mq(3);K=J/+Mq(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];yp(25,0,54344,A);K=+Mq(4);H=+Mq(4);J=H/+Mq(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];yp(25,0,54384,z);J=+Mq(7);K=+Mq(7);H=K/+Mq(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(25,0,54416,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Mq(0);J=H- +Mq(7);H=J- +Mq(4);J=H- +Mq(3);H=J- +Mq(2);J=H- +Mq(1);H=J- +Mq(6);J=+Mq(0);K=J- +Mq(7);J=K- +Mq(4);K=J- +Mq(3);J=K- +Mq(2);K=J- +Mq(1);J=K- +Mq(6);K=J/+Mq(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(25,0,54480,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];yp(25,0,54448,x)}K=+Mq(0);H=+Mq(0);J=H/+Mq(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];yp(25,0,54512,v);Td[c[5568]&255](25);yp(25,1,54536,u);c[t>>2]=c[d+40>>2];yp(25,0,54544,t);c[s>>2]=c[d+44>>2];yp(25,0,54568,s);Td[c[5568]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);yp(25,1,54592,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];yp(25,0,54608,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];yp(25,0,54624,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];yp(25,0,54656,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];yp(25,0,54688,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];yp(25,0,54712,m);Td[c[5568]&255](25)}else if((s|0)!=5){yp(25,1,54744,l);yp(25,0,54752,j);Td[c[5568]&255](25)}yp(25,0,54816,g);Rq(0);i=f;return 0}function it(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Rb(b|0,55288)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];jd(b|0,55296,y|0)|0;if((z|0)==0){C=Ed(10,b|0)|0;D=hd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];jd(b|0,55312,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;jd(b|0,55328,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;jd(b|0,55336,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;jd(b|0,55344,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((cU(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];jd(b|0,55312,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];jd(b|0,55312,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((cU(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;jd(b|0,55328,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;jd(b|0,55328,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((cU(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;jd(b|0,55336,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;jd(b|0,55336,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((cU(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;jd(b|0,55344,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];jd(b|0,55312,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;jd(b|0,55328,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;jd(b|0,55336,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((cU(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;jd(b|0,55344,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Rb(0,55288)|0;}while((d|0)!=0);C=Ed(10,b|0)|0;D=hd(b|0)|0;i=e;return}function jt(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[430]|0;if((v|0)!=0){if((cU(v,54952)|0)==0){break a}}yp(23,0,54968,p);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 5:{Ap(1,0,54912,q);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{Ap(1,0,54840,r);w=1;i=m;return w|0};case 18:{v=c[430]|0;do{if((v|0)!=0){if((cU(v,55096)|0)!=0){break}c[u>>2]=4;break a}}while(0);yp(23,0,55120,o);w=1;i=m;return w|0};default:{}}}while(0);o=et(a,s)|0;le[c[22620>>2]&7]()|0;do{if((o|0)==0){r=gt(a,b,d,e,f,g)|0;le[c[22620>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){Ud[c[60132>>2]&63](60112,a);ts(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(23,0,55248,n);r=he[c[c[a+540>>2]>>2]&63](a,t)|0;le[c[22620>>2]&7]()|0;ht(a,s,l)|0;le[c[22620>>2]&7]()|0;x=r}else{le[c[22620>>2]&7]()|0;x=o}}while(0);ft(a,s)|0;w=x;i=m;return w|0}function kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){lt(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((Wd[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Cp(c[a+536>>2]|0,55360,d)}else if((k|0)==6){lt(a);i=b;return}}function lt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;kU(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function mt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;FT(c[f+(a*48|0)+28>>2]|0);FT(c[f+(a*48|0)+32>>2]|0);FT(c[f+(a*48|0)+16>>2]|0);FT(c[f+(a*48|0)+20>>2]|0);FT(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function nt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=ET(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=ET(c[y>>2]<<2)|0;ot(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;iU(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;iU(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Kr(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=pt(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){iU(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;iU(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;FT(x);FT(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Ap(5,1,55416,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];bc(q|0,55448,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Ap(5,0,55456,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=22272;K=c[5568]|0;Td[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=55464;aa=$;Cp(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Ap(5,0,55456,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=22272;K=c[5568]|0;Td[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=55464;aa=$;Cp(O,aa,g);return 0}function ot(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;kU(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}Wd[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function pt(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=GT(d,4)|0;r=GT(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;FT(q);FT(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;FT(q);FT(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){FT(q);FT(r);i=o;return v|0}if((n|0)==0){v=-1;FT(q);FT(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];yp(5,1,55568,p);qt(s,d,f,c[g>>2]|0,j,l,m);if((c[21740>>2]|0)==0){v=-1;FT(q);FT(r);i=o;return v|0}Td[c[5568]&255](5);v=-1;FT(q);FT(r);i=o;return v|0}function qt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;kU(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];yp(5,0,55600,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function rt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=cc(55616,55640)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Wc(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;lb(n|0);do{}while((Wc(n|0)|0)!=10);q=c[b+152>>2]|0;r=GT(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=GT(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=GT(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Yb(n|0,55648,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Yb(n|0,55648,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=GT(s,8)|0;x=v}}while(0);ac(55656,j|0)|0;ac(55712,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ac(55672,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ac(55696,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}pb(55712)|0;Qc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function st(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}FT(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){FT(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}FT(l);i=d;return 0}function tt(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function ut(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+vt(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[21756>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];yp(9,1,55776,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];yp(9,0,55888,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}Td[c[5568]&255](9);g=1;i=b;return g|0}function vt(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;Kt(b);g=f+540|0;Wd[c[(c[g>>2]|0)+84>>2]&127](f)|0;Wd[c[(c[g>>2]|0)+36>>2]&127](f)|0;Wd[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;he[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function wt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+vt(b,1.0);if((c[21756>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}yp(9,1,55912,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(9,0,55976,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(9,0,55936,s)}yp(9,1,56e3,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;yp(9,0,56072,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];yp(9,0,56024,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;yp(9,0,56160,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(9,0,56096,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;yp(9,0,56248,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];yp(9,0,56192,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}Td[c[5568]&255](9);yp(9,1,56280,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=Wd[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;yp(9,0,56072,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];yp(9,0,56024,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}Td[c[5568]&255](9);Td[c[5568]&255](9);i=d;return}function xt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[21756>>2]|0)!=0){us(b,9)}if((c[21816>>2]|0)==0){i=d;return}yp(24,1,56304,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){yp(24,1,56344,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];yp(24,0,56368,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}Td[c[5568]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}yp(24,1,56424,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];yp(24,0,56448,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}Td[c[5568]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){yp(24,1,56480,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(24,0,56368,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}Td[c[5568]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){yp(24,1,56504,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;yp(24,0,56528,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}Td[c[5568]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){yp(24,1,56576,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?56648:56656;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?56648:56656;t=(a[(c[l>>2]|0)+n|0]|0)!=0?56648:56656;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;yp(24,0,56600,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}Td[c[5568]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){yp(24,1,56664,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;yp(24,0,56688,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}Td[c[5568]&255](24)}Td[c[5568]&255](24);i=d;return}function yt(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;yp(9,0,56736,z);if((f|0)==0){rs(b);ss(b);C=6}else{if((a[f]|0)!=0){zt(b,f,g)}rs(b);ss(b);if((a[f]|0)==0){C=6}}if((C|0)==6){Wd[c[(c[A>>2]|0)+84>>2]&127](b)|0;Wd[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(cU(d,58224)|0)==0|0;f=(cU(d,58232)|0)==0;z=(cU(d,58240)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Ap(1,0,56784,y);Ap(1,0,56816,x);c[w>>2]=58224;c[w+4>>2]=58032;Ap(1,0,56840,w);c[v>>2]=58232;c[v+4>>2]=58112;Ap(1,0,56840,v);c[u>>2]=58240;c[u+4>>2]=58160;Ap(1,0,56840,u);Cp(c[b+536>>2]|0,56872,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(cU(e,c[56896+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Ap(1,0,56928,s);Ap(1,0,56816,r);t=1;do{u=c[56960+(t<<2)>>2]|0;c[q>>2]=c[56896+(t<<2)>>2];c[q+4>>2]=u;Ap(1,0,56840,q);t=t+1|0;}while((t|0)<7);Cp(c[b+536>>2]|0,56872,p)}}while(0);p=c[56856+(D<<2)>>2]|0;c[o>>2]=c[56768+(D<<2)>>2];c[o+4>>2]=p;yp(9,0,56992,o);o=(D|0)==2;if(o){p=c[56960+(F<<2)>>2]|0;c[n>>2]=c[56896+(F<<2)>>2];c[n+4>>2]=p;yp(9,0,57032,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=At(b,F,j)|0;break}if((D|0)==3){Bt(b,j);I=0;break}else{Cp(c[b+536>>2]|0,57072,m)}}}while(0);if((Ys(b,1)|0)!=0){J=-2;xt(b);K=15;L=K;M=57096;N=M;yp(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];as(b,R,V);W=191;os(b);X=197;ts(b);Y=192;js(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Wd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=he[ha&63](b,1)|0;ja=200;ps(b);i=k;return J|0}if((Rs(b,1)|0)!=0){J=-3;xt(b);K=15;L=K;M=57096;N=M;yp(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];as(b,R,V);W=191;os(b);X=197;ts(b);Y=192;js(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Wd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=he[ha&63](b,1)|0;ja=200;ps(b);i=k;return J|0}m=(Is(b,1)|0)==0;J=m?I:-4;xt(b);K=15;L=K;M=57096;N=M;yp(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];as(b,R,V);W=191;os(b);X=197;ts(b);Y=192;js(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=Wd[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=he[ha&63](b,1)|0;ja=200;ps(b);i=k;return J|0}function zt(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];yp(9,0,58256,z);z=lq(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Cp(C,58296,y)}yp(9,0,58336,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=mq(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=Et(c[d+(C*112|0)+4>>2]|0)|0;E=mq(A,D)|0;FT(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((dU(E,58376,6)|0)==0){if((c[21756>>2]|0)==0){break}}else{D=dU(E,58384,6)|0;if((c[21756>>2]|D|0)==0){break}}c[v>>2]=E;Ap(9,0,58392,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;sq(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(9,0,58360,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}yp(9,0,58448,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=mq(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=Et(c[G+(w*112|0)+4>>2]|0)|0;v=mq(A,F)|0;FT(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Ap(9,0,58472,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;sq(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];yp(9,0,58360,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}yp(9,0,58528,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=mq(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=Et(c[t+(x*112|0)+4>>2]|0)|0;K=mq(A,C)|0;FT(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Ap(9,0,58472,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;sq(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];yp(9,0,58360,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}yp(9,0,58552,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=mq(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=Et(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=mq(A,u)|0;FT(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Ap(9,0,58600,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;sq(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;yp(9,0,58584,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}yp(9,0,58656,l);l=b+144|0;if((c[l>>2]|0)<=0){jq(A);i=f;return}o=b+32|0;b=0;do{x=mq(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=Et(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=mq(A,n)|0;FT(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Ap(9,0,58704,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;sq(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?56648:56656;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;yp(9,0,58688,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));jq(A);i=f;return}function At(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;$r(a,+h[a+240>>3]);os(a);ts(a);js(a);vs(a);lt(a);ks(a);os(a);e=Ct(a,b,c)|0;ts(a);js(a);ps(a);ts(a);i=d;return e|0}



function _k(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function $k(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=ql(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((yl(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function al(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Zk(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Qk(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((zl(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function bl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Nk(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Zk(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Qk(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Qk(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Nk(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Nk(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Qk(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function cl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Nk(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function dl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Nk(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Qd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Nk(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function el(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=Wd[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=he[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function fl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Al(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Nk(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function gl(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Nk(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(qe[c[b+20>>2]&63](b,e,f,j)|0){case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 0:{r=49;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=Zk(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=Qk(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=gl(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ie[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case-4:{r=24;break a;break};case 7:{r=28;break};case 10:{s=he[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=Hl(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Nk(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 6:case 9:{if((dl(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-1:{r=46;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Nk(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function hl(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=qe[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Lk(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function il(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=hl(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=39;k=Wk(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=Wd[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=he[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=Wd[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function kl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=Wd[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=qe[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Xk(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=ql(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=40;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function ll(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=Wd[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;pl(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function ml(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Lk(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(he[c[a+32>>2]&63](a,b)|0)|0;k=Zk(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=he[c[a+36>>2]&63](a,e)|0;e=Zk(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){ol(e);ne[c[g+64>>2]&15](c[g+4>>2]|0,k,e);uk(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function nl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Lk(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Zk(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){ol(k);Ud[c[g+68>>2]&63](c[g+4>>2]|0,k);uk(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function ol(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function pl(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}pl(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function ql(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=qe[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 9:{a[p]=$d[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){B=y;if((c[y+60>>2]|0)!=0){ne[c[B+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[B+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break b}B=Zk(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((B|0)==0){C=37;break a}D=Qk(y,k,B,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){C=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){ne[c[E+120>>2]&15](c[y+4>>2]|0,B,0);break b}if((c[E+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{C=40}}while(0);if((C|0)==40){C=0;if((D|0)==0){C=41;break a}if((a[D+34|0]|0)==0){C=43;break a}}if((a[D+32|0]|0)!=0){C=50;break a}if((c[D+28>>2]|0)!=0){C=52;break a}B=y;if((c[D+4>>2]|0)!=0){E=y;if((a[B+308|0]|0)!=0){F=kl(E,D,0)|0;if((F|0)!=0){C=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){ne[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[B+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;B=sl(y)|0;a[D+32|0]=0;if((B|0)==0){C=63;break a}if((ie[c[y+112>>2]&63](c[y+116>>2]|0,B,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){C=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{C=24;break a;break};case-1:{C=25;break a;break};case-2:{C=28;break a;break};case-3:{C=6;break a;break};case 1:case 2:{B=y;if((c[y+368>>2]|0)!=0){H=c[B+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{H=Wd[c[B+12>>2]&127](48)|0;if((H|0)==0){C=72;break a}c[H+36>>2]=Wd[c[y+12>>2]&127](32)|0;if((c[H+36>>2]|0)==0){C=74;break a}c[H+40>>2]=(c[H+36>>2]|0)+32}c[H+44>>2]=0;c[H>>2]=c[y+364>>2];c[y+364>>2]=H;c[H+16>>2]=0;c[H+20>>2]=0;c[H+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[H+8>>2]=he[c[e+32>>2]&63](e,c[H+4>>2]|0)|0;B=y+312|0;c[B>>2]=(c[B>>2]|0)+1;B=(c[H+4>>2]|0)+(c[H+8>>2]|0)|0;c[r>>2]=c[H+4>>2];c[q>>2]=c[H+36>>2];while(1){Qd[c[e+60>>2]&31](e,r,B,q,(c[H+40>>2]|0)+ -1|0);I=(c[q>>2]|0)-(c[H+36>>2]|0)|0;if((c[r>>2]|0)==(B|0)){break}G=(c[H+40>>2]|0)-(c[H+36>>2]|0)<<1;E=he[c[y+16>>2]&63](c[H+36>>2]|0,G)|0;if((E|0)==0){C=80;break a}c[H+36>>2]=E;c[H+40>>2]=E+G;c[q>>2]=E+I}c[H+24>>2]=I;c[H+12>>2]=c[H+36>>2];a[c[q>>2]|0]=0;J=tl(y,e,c[m>>2]|0,H+12|0,H+44|0)|0;if((J|0)!=0){C=82;break a}B=y;do{if((c[y+52>>2]|0)!=0){ne[c[B+52>>2]&15](c[y+4>>2]|0,c[H+12>>2]|0,c[y+392>>2]|0)}else{if((c[B+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);uk(y+416|0);break};case 3:case 4:{B=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=Zk(y+416|0,e,B,B+(he[c[e+32>>2]&63](e,B)|0)|0)|0;if((c[t>>2]|0)==0){C=89;break a}c[y+432>>2]=c[y+428>>2];K=tl(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){C=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ne[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}Ud[c[y+56>>2]&63](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);uk(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){Ud[c[y+104>>2]&63](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){C=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){C=109;break a}D=c[y+364>>2]|0;c[y+364>>2]=c[D>>2];c[D>>2]=c[y+368>>2];c[y+368>>2]=D;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;B=he[c[e+32>>2]&63](e,L)|0;if((B|0)!=(c[D+8>>2]|0)){C=112;break a}if((bU(c[D+4>>2]|0,L,B)|0)!=0){C=112;break a}B=y+312|0;c[B>>2]=(c[B>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){B=c[D+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((B|0)==0){break}E=(c[D+12>>2]|0)+(c[D+28>>2]|0)|0;while(1){if((a[B]|0)==0){break}G=B;B=G+1|0;M=E;E=M+1|0;a[M]=a[G]|0}G=c[D+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}M=E;E=M+1|0;a[M]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}M=G;G=M+1|0;N=E;E=N+1|0;a[N]=a[M]|0}}}while(0);a[E]=0}}while(0);Ud[c[y+56>>2]&63](c[y+4>>2]|0,c[D+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[D+44>>2]|0)==0){break}B=c[D+44>>2]|0;if((c[y+104>>2]|0)!=0){Ud[c[y+104>>2]&63](c[y+4>>2]|0,c[c[B>>2]>>2]|0)}c[D+44>>2]=c[(c[D+44>>2]|0)+4>>2];c[B+4>>2]=c[y+376>>2];c[y+376>>2]=B;c[(c[B>>2]|0)+4>>2]=c[B+8>>2]}if((c[y+312>>2]|0)==0){C=133;break a}break};case 12:{C=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ne[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{D=he[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((D|0)<0){C=135;break a}B=y;if((c[y+60>>2]|0)!=0){G=c[B+60>>2]|0;M=c[y+4>>2]|0;N=Hl(D,u)|0;ne[G&15](M,u,N);break b}if((c[B+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{B=y;do{if((c[y+72>>2]|0)!=0){Td[c[B+72>>2]&255](c[y+4>>2]|0)}else{if((c[B+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=vl(y,e,n,g,h,j)|0;if((O|0)!=0){C=150;break a}if((c[n>>2]|0)==0){C=152;break a}break};case-5:{C=153;break a;break};case 6:{B=c[y+60>>2]|0;if((B|0)==0){if((c[y+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ne[B&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Qd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ne[B&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((ml(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){C=174;break a}break};case 13:{if((nl(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){C=176;break a}break};case-4:{C=17;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Lk(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){C=181;break}else if((f|0)==3){C=180;break}}if((C|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ne[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((C|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((C|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((C|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((C|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((C|0)==37){P=1;Q=P;i=l;return Q|0}else if((C|0)==41){P=11;Q=P;i=l;return Q|0}else if((C|0)==43){P=24;Q=P;i=l;return Q|0}else if((C|0)==50){P=12;Q=P;i=l;return Q|0}else if((C|0)==52){P=15;Q=P;i=l;return Q|0}else if((C|0)==60){P=F;Q=P;i=l;return Q|0}else if((C|0)==63){P=1;Q=P;i=l;return Q|0}else if((C|0)==65){P=21;Q=P;i=l;return Q|0}else if((C|0)==72){P=1;Q=P;i=l;return Q|0}else if((C|0)==74){Td[c[y+20>>2]&255](H);P=1;Q=P;i=l;return Q|0}else if((C|0)==80){P=1;Q=P;i=l;return Q|0}else if((C|0)==82){P=J;Q=P;i=l;return Q|0}else if((C|0)==89){P=1;Q=P;i=l;return Q|0}else if((C|0)==91){P=K;Q=P;i=l;return Q|0}else if((C|0)==107){P=ul(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((C|0)==109){P=13;Q=P;i=l;return Q|0}else if((C|0)==112){c[z>>2]=L;P=7;Q=P;i=l;return Q|0}else if((C|0)==133){P=ul(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((C|0)==135){P=14;Q=P;i=l;return Q|0}else if((C|0)==140){P=17;Q=P;i=l;return Q|0}else if((C|0)==150){P=O;Q=P;i=l;return Q|0}else if((C|0)==152){c[y+280>>2]=41;P=O;Q=P;i=l;return Q|0}else if((C|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ne[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Qd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ne[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Lk(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((C|0)==174){P=1;Q=P;i=l;return Q|0}else if((C|0)==176){P=1;Q=P;i=l;return Q|0}else if((C|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((C|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function rl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=qe[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Xk(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=ql(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=39;m=qe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Xk(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=37;k=ql(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function sl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Nk(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Ok(e,b+60|0);a:while(1){k=Pk(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Ok(e,b);b:while(1){b=Pk(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Nk(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function tl(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Qk(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=wk(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Qk(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((zl(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=qe[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=he[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}qe[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=bl(k,b,v,w+(he[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Zk(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=fl(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Uk(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Uk(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=he[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Qk(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Nk(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Nk(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Nk(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=Wd[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;iU(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}Td[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;iU(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;iU(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function ul(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=42;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=qe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 13:{if((nl(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-2:{k=18;break a;break};case-4:{k=7;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Lk(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 11:{if((ml(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 0:{k=14;break a;break};case-1:{k=15;break a;break};case-15:{k=3;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Lk(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function vl(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=qe[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 40:{r=6;break a;break};case-4:case-1:{r=28;break a;break};case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Lk(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ne[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Qd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ne[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ne[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Lk(o,b,c[k>>2]|0,c[l>>2]|0);break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){Td[c[m+76>>2]&255](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Lk(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function wl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=vl(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=43;k=xl(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=37;k=$k(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function xl(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=ql(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((yl(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=he[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}iU(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function zl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Nk(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Nk(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Qk(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Al(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(qe[c[b+16>>2]&63](b,f,g,l)|0){case 7:case 39:{o=31;break};case-1:{o=7;break a;break};case 9:{p=($d[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(p<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Nk(h)|0)<<24>>24!=0)){o=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;break b}p=Zk(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((p|0)==0){o=44;break a}r=Qk(n,j,p,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}p=(r|0)!=0;if(u<<24>>24!=0){if(!p){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!p){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}p=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=Al(n,c[n+228>>2]|0,e,c[r+4>>2]|0,p,h)|0;a[r+32|0]=0;if((w|0)!=0){o=74;break a}break};case-4:{o=3;break a;break};case 0:{o=4;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 10:{r=he[c[b+44>>2]&63](b,f)|0;if((r|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=Hl(r,m)|0;if((r|0)==0){o=19;break a}p=0;while(1){if((p|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Nk(h)|0)<<24>>24!=0)){o=27;break a}}q=a[m+p|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;p=p+1|0}break};case 6:{if((dl(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Nk(h)|0)<<24>>24!=0)){o=37;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=w;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Bl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if(($d[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Il()|0;c[g+240>>2]=Wd[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=qe[((a[g+236|0]&255|0)!=0?44:45)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){Td[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}Td[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Cl(){var a=0,b=0;a=i;i=i+8|0;Xb(((lc(0)|0)>>>0)%4294967295|0|0);b=oU()|0;i=a;return b|0}function Dl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Vk(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=39;h=Wk(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function El(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=Wd[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Fl(f+80|0,e);Fl(b+104|0,e);Gl(b,e);Gl(b+20|0,e);Gl(b+40|0,e);Gl(b+60|0,e);a[b+131|0]=0;Gl(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Fl(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Gl(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Hl(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Il(){i=i;return 1912}function Jl(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[18904+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[18980+l|0]|0|0)!=28){if((d[18980+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[18980+q|0]|0|0)!=28){if((d[18980+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[18980+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Kl(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[13072+(((d[12816+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[13072+(((d[14352+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Hl(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=48;c[h+336>>2]=48;c[h+340>>2]=48;c[h+344>>2]=49;c[h+348>>2]=49;c[h+352>>2]=49;c[h+356>>2]=50;c[h+360>>2]=50;c[h+364>>2]=50}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function Kl(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};case 0:{if((d[18980+c|0]|0|0)!=0){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Ll(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=he[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[13072+(((d[14352+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Ml(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=he[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[13072+(((d[12816+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Nl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=he[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Kl(a)|0)<0;g=f&1;i=d;return g|0}function Ol(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Hl(he[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Pl(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(he[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Ql(){i=i;return 18536}function Rl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Sl(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=46;c[g+4>>2]=47;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((em(d,c[18440+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Tl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=eo(16880,a,0,b,c,d)|0;i=e;return f|0}function Ul(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=eo(16880,a,1,b,c,d)|0;i=e;return f|0}function Vl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Cn(17648,b,c,d);i=a;return}function Wl(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Xl(34,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Xl(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(fo(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((qe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18384)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((fo(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((qe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18392)|0)!=0){h=go(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=$d[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((fo(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((qe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,18408)|0)!=0){if((a|0)!=0){break}do{if((qe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,18424)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((qe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,18432)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((ho(go(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Yl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Qd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((em(h,14608)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Sl(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[16880+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Zl(){i=i;return 16512}function _l(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Sl(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=20;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function $l(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=eo(14616,a,0,b,c,d)|0;i=e;return f|0}function am(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=eo(14616,a,1,b,c,d)|0;i=e;return f|0}function bm(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Xl(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function cm(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Qd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((em(h,14608)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Sl(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[14616+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function dm(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Jl(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function em(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function fm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{g=b;if((c[13072+((d[12816+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[13072+((d[14352+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 13:{k=Im(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=Im(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=wm(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 16:{k=Jm(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Em(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 19:{k=Km(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=wm(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 30:{k=ym(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=wm(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=wm(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 34:{o=116;break b;break};case 7:{o=91;break b;break};case 5:{o=85;break b;break};case 6:{o=88;break b;break};case 33:{o=119;break b;break};case 15:{o=122;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=wm(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{o=111;break b;break};case 6:{o=108;break b;break};case 29:{if((c[13072+((d[14352+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function gm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=xm(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wm(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 2:{k=Bm(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=wm(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function hm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=wm(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=wm(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=wm(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function im(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=wm(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function jm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wm(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xm(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=wm(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function km(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=wm(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=xm(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=ym(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=wm(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function lm(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=wm(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 6:{j=8;break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=15;break a}e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=17;break a}else{continue a}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[j]|0)|0]|0}else{n=wm(a[j+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function mm(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function nm(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=wm(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function om(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=wm(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function pm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=wm(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=wm(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function qm(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Kl(c)|0;k=j;i=b;return k|0}function rm(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function sm(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=wm(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=wm(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}



function lB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Su(f);c[e>>2]=0;Su(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=sB(a)|0;b=c[c[e>>2]>>2]|0;Su(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(tB(a)|0)>>2]|0;Cw(e,c[d>>2]|0);d=uB(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function mB(a){a=a|0;var b=0,d=0;b=i;d=c[(qB(a)|0)>>2]|0;i=b;return d|0}function nB(a){a=a|0;var b=0,d=0;b=i;d=oB(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function oB(a){a=a|0;var b=0,c=0;b=i;c=pB(a)|0;i=b;return c|0}function pB(a){a=a|0;i=i;return a|0}function qB(a){a=a|0;var b=0,c=0;b=i;c=rB(a)|0;i=b;return c|0}function rB(a){a=a|0;i=i;return a|0}function sB(a){a=a|0;i=i;return a|0}function tB(a){a=a|0;var b=0,c=0;b=i;c=Du(xB(a+4|0)|0)|0;i=b;return c|0}function uB(a){a=a|0;var b=0,c=0;b=i;c=vB(a+8|0)|0;i=b;return c|0}function vB(a){a=a|0;var b=0,c=0;b=i;c=wB(a)|0;i=b;return c|0}function wB(a){a=a|0;i=i;return a|0}function xB(a){a=a|0;var b=0,c=0;b=i;c=yB(a)|0;i=b;return c|0}function yB(a){a=a|0;i=i;return a|0}function zB(a){a=a|0;var b=0;b=i;AB(a,0);i=b;return}function AB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=oB(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}CB(BB(e)|0,f);i=d;return}function BB(a){a=a|0;var b=0,c=0;b=i;c=IB(a)|0;i=b;return c|0}function CB(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;DB(f,EB(d+20|0)|0)}if((d|0)==0){i=e;return}FB(c[b>>2]|0,d,1);i=e;return}function DB(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;HB(d,0,c);i=b;return}function EB(a){a=a|0;i=i;return a|0}function FB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;GB(0,b,0);i=c;return}function GB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MT(b);i=c;return}function HB(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Qy(c);i=b;return}function IB(a){a=a|0;i=i;return a+4|0}function JB(a,b){a=a|0;b=b|0;var c=0;c=i;KB(a,b);i=c;return}function KB(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function LB(a){a=a|0;var b=0,c=0;b=i;c=cC(a+4|0)|0;i=b;return c|0}function MB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];WB(a,b,f);i=e;return}function NB(a,b){a=a|0;b=b|0;var c=0;a=i;c=VB(0,b,0)|0;i=a;return c|0}function OB(a,b){a=a|0;b=b|0;var c=0;c=i;UB(a,b);i=c;return}function PB(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function QB(a){a=a|0;var b=0,d=0;b=i;d=c[(qB(a)|0)>>2]|0;i=b;return d|0}function RB(a){a=a|0;var b=0,c=0;b=i;c=BB(a)|0;i=b;return c|0}function SB(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}Iy(b,a);i=a;return}function TB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;JB(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hB(h,f);jB(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hB(a,e);kB(h);i=d;return}function UB(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function VB(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=KT(b<<5)|0;i=c;return a|0}function WB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(YB(g)|0)>>2]|0;g=ZB(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];XB(b,a,f);i=e;return}function XB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];_B(a,b,f);i=e;return}function YB(a){a=a|0;i=i;return a|0}function ZB(a){a=a|0;i=i;return a|0}function _B(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(aC(g)|0)>>2]|0;g=bC(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];$B(b,a,f);i=e;return}function $B(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(aC(f)|0)>>2];f=bC(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function aC(a){a=a|0;i=i;return a|0}function bC(a){a=a|0;i=i;return a|0}function cC(a){a=a|0;var b=0,c=0;b=i;c=dC(a)|0;i=b;return c|0}function dC(a){a=a|0;i=i;return a|0}function eC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=nB(fC(b)|0)|0;h=bC(RB(fC(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];XB(g,a,e);i=d;return}function fC(a){a=a|0;i=i;return c[a>>2]|0}function gC(a){a=a|0;var b=0,d=0;b=i;d=c[(tB(a)|0)>>2]|0;i=b;return d|0}function hC(a,b){a=a|0;b=b|0;b=i;i=i+8|0;iC(a,b);i=b;return}function iC(a,b){a=a|0;b=b|0;b=i;jC(a,0);i=b;return}function jC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;kC(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;lC(f,0,e);e=MA(b)|0;c[(mC(b)|0)>>2]=e;i=d;return}function kC(a){a=a|0;var b=0;b=i;pC(a);i=b;return}function lC(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;nC(b,c,f);i=e;return}function mC(a){a=a|0;i=i;return a|0}function nC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(ux(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;oC(d,b,f);i=e;return}function oC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(ux(e)|0)>>2];i=d;return}function pC(a){a=a|0;var b=0;b=i;qC(a);i=b;return}function qC(a){a=a|0;var b=0;b=i;xx(a);i=b;return}function rC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=TA(h)|0;Su(e);if((a|0)==0){j=MA(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Xy(0,d,a)|0){m=l;j=c[m>>2]|0;Su(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Xy(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Su(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function sC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];nD(a,e);i=d;return}function tC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=UC(d)|0;d=WC(n,1)|0;XC(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];VC(j,d,h);YC(0,eA((ZC(j)|0)+16|0)|0,e);e=_C(j)|0;a[e+4|0]=1;$C(0,LC((ZC(j)|0)+28|0)|0);a[e+5|0]=1;aD(m,j);uC(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];sC(b,g);vC(m);vC(j);i=f;return}function uC(a,b){a=a|0;b=b|0;var c=0;c=i;SC(a,b);i=c;return}function vC(a){a=a|0;var b=0;b=i;GC(a);i=b;return}function wC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Su(f);c[e>>2]=0;Su(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=mC(a)|0;b=c[c[e>>2]>>2]|0;Su(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(MA(a)|0)>>2]|0;Cw(e,c[d>>2]|0);d=DC(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function xC(a){a=a|0;var b=0,d=0;b=i;d=c[(BC(a)|0)>>2]|0;i=b;return d|0}function yC(a){a=a|0;var b=0,d=0;b=i;d=zC(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function zC(a){a=a|0;var b=0,c=0;b=i;c=AC(a)|0;i=b;return c|0}function AC(a){a=a|0;i=i;return a|0}function BC(a){a=a|0;var b=0,c=0;b=i;c=CC(a)|0;i=b;return c|0}function CC(a){a=a|0;i=i;return a|0}function DC(a){a=a|0;var b=0,c=0;b=i;c=EC(a+8|0)|0;i=b;return c|0}function EC(a){a=a|0;var b=0,c=0;b=i;c=FC(a)|0;i=b;return c|0}function FC(a){a=a|0;i=i;return a|0}function GC(a){a=a|0;var b=0;b=i;HC(a,0);i=b;return}function HC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=zC(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}JC(IC(e)|0,f);i=d;return}function IC(a){a=a|0;var b=0,c=0;b=i;c=RC(a)|0;i=b;return c|0}function JC(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;KC(f,LC(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;MC(f,eA(d+16|0)|0)}if((d|0)==0){i=e;return}NC(c[b>>2]|0,d,1);i=e;return}function KC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;QC(d,0,c);i=b;return}function LC(a){a=a|0;i=i;return a|0}function MC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;PC(d,0,c);i=b;return}function NC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;OC(0,b,0);i=c;return}function OC(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MT(b);i=c;return}function PC(a,b,c){a=a|0;b=b|0;c=c|0;b=i;zJ(c);i=b;return}function QC(a,b,c){a=a|0;b=b|0;c=c|0;b=i;zJ(c);i=b;return}function RC(a){a=a|0;i=i;return a+4|0}function SC(a,b){a=a|0;b=b|0;var c=0;c=i;TC(a,b);i=c;return}function TC(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function UC(a){a=a|0;var b=0,c=0;b=i;c=lD(a+4|0)|0;i=b;return c|0}function VC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];dD(a,b,f);i=e;return}function WC(a,b){a=a|0;b=b|0;var c=0;a=i;c=cD(0,b,0)|0;i=a;return c|0}function XC(a,b){a=a|0;b=b|0;var c=0;c=i;bD(a,b);i=c;return}function YC(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}pJ(b,c);i=a;return}function ZC(a){a=a|0;var b=0,d=0;b=i;d=c[(BC(a)|0)>>2]|0;i=b;return d|0}function _C(a){a=a|0;var b=0,c=0;b=i;c=IC(a)|0;i=b;return c|0}function $C(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}nJ(b);i=a;return}function aD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;SC(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];sC(h,f);uC(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];sC(a,e);vC(h);i=d;return}function bD(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function cD(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=KT(b*40|0)|0;i=c;return a|0}function dD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(fD(g)|0)>>2]|0;g=gD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];eD(b,a,f);i=e;return}function eD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];hD(a,b,f);i=e;return}function fD(a){a=a|0;i=i;return a|0}function gD(a){a=a|0;i=i;return a|0}function hD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(jD(g)|0)>>2]|0;g=kD(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];iD(b,a,f);i=e;return}function iD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(jD(f)|0)>>2];f=kD(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function jD(a){a=a|0;i=i;return a|0}function kD(a){a=a|0;i=i;return a|0}function lD(a){a=a|0;var b=0,c=0;b=i;c=mD(a)|0;i=b;return c|0}function mD(a){a=a|0;i=i;return a|0}function nD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=yC(oD(b)|0)|0;h=kD(_C(oD(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];eD(g,a,e);i=d;return}function oD(a){a=a|0;i=i;return c[a>>2]|0}function pD(a){a=a|0;var b=0;b=i;qD(a);i=b;return}function qD(a){a=a|0;var b=0;b=i;rD(a);i=b;return}function rD(a){a=a|0;var b=0;b=i;sD(a,TA(a)|0);i=b;return}function sD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Su(d);if((b|0)==0){i=d;return}sD(a,c[b>>2]|0);sD(a,c[b+4>>2]|0);e=UC(a)|0;tD(e,uD(b+16|0)|0);NC(e,b,1);i=d;return}function tD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;vD(d,0,c);i=b;return}function uD(a){a=a|0;i=i;return a|0}function vD(a,b,c){a=a|0;b=b|0;c=c|0;b=i;wD(c);i=b;return}function wD(a){a=a|0;var b=0;b=i;xD(a);i=b;return}function xD(a){a=a|0;var b=0;b=i;yD(a);i=b;return}function yD(a){a=a|0;var b=0;b=i;zD(a);i=b;return}function zD(a){a=a|0;var b=0;b=i;zJ(a+12|0);zJ(a);i=b;return}function AD(a){a=a|0;var b=0;b=i;BD(a+180|0);BD(a+168|0);BD(a+156|0);BD(a+144|0);BD(a+132|0);BD(a+120|0);BD(a+108|0);BD(a+96|0);BD(a+84|0);BD(a+72|0);BD(a+60|0);BD(a+48|0);BD(a+36|0);BD(a+24|0);Qy(a+12|0);Qy(a);i=b;return}function BD(a){a=a|0;var b=0;b=i;CD(a);i=b;return}function CD(a){a=a|0;var b=0;b=i;DD(a);i=b;return}function DD(a){a=a|0;var b=0;b=i;ED(a);i=b;return}function ED(a){a=a|0;var b=0;b=i;FD(a,gC(a)|0);i=b;return}function FD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Su(d);if((b|0)==0){i=d;return}FD(a,c[b>>2]|0);FD(a,c[b+4>>2]|0);e=LB(a)|0;GD(e,HD(b+16|0)|0);FB(e,b,1);i=d;return}function GD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;ID(d,0,c);i=b;return}function HD(a){a=a|0;i=i;return a|0}function ID(a,b,c){a=a|0;b=b|0;c=c|0;b=i;JD(c);i=b;return}function JD(a){a=a|0;var b=0;b=i;KD(a);i=b;return}function KD(a){a=a|0;var b=0;b=i;LD(a);i=b;return}function LD(a){a=a|0;var b=0;b=i;MD(a);i=b;return}function MD(a){a=a|0;var b=0;b=i;Qy(a+4|0);i=b;return}function ND(a){a=a|0;var b=0;b=i;OD(a);i=b;return}function OD(a){a=a|0;var b=0;b=i;PD(a);i=b;return}function PD(a){a=a|0;var b=0;b=i;QD(a,Dz(a)|0);i=b;return}function QD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;Su(d);if((b|0)==0){i=d;return}QD(a,c[b>>2]|0);QD(a,c[b+4>>2]|0);e=lA(a)|0;RD(e,qz(b+16|0)|0);fA(e,b,1);i=d;return}function RD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;SD(d,0,c);i=b;return}function SD(a,b,c){a=a|0;b=b|0;c=c|0;b=i;TD(c);i=b;return}function TD(a){a=a|0;var b=0;b=i;UD(a);i=b;return}function UD(a){a=a|0;var b=0;b=i;VD(a);i=b;return}function VD(a){a=a|0;var b=0;b=i;WD(a);i=b;return}function WD(a){a=a|0;var b=0;b=i;zJ(a);i=b;return}function XD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;YD(a);_D(g,b);$D(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];ZD(a,f,e);i=d;return a|0}function YD(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;sD(a,TA(a)|0);c[(DC(a)|0)>>2]=0;d=MA(a)|0;c[(mC(a)|0)>>2]=d;Su(b);c[d>>2]=0;i=b;return}function ZD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;hE(h,a);if(!(iE(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];aE(j,g);o=kE(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];jE(l,a,f,o);lE(b)|0;}while(iE(b,d)|0);i=e;return}function _D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;fE(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];aE(a,e);i=d;return}function $D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;bE(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];aE(a,e);i=d;return}function aE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];eE(a,e);i=d;return}function bE(a,b){a=a|0;b=b|0;var c=0;c=i;cE(a,Sy(b)|0);i=c;return}function cE(a,b){a=a|0;b=b|0;var c=0;c=i;dE(a,b);i=c;return}function dE(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function eE(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function fE(a,b){a=a|0;b=b|0;var d=0;d=i;cE(a,c[(gE(b)|0)>>2]|0);i=d;return}function gE(a){a=a|0;i=i;return a|0}function hE(a,b){a=a|0;b=b|0;var c=0;c=i;$D(a,b);i=c;return}function iE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rF(a,b)|0;i=c;return d|0}function jE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];tE(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];sE(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];JA(a,g);wD(l);i=f;return}function kE(a){a=a|0;var b=0,c=0;b=i;c=pE(a)|0;i=b;return c|0}function lE(a){a=a|0;var b=0;b=i;mE(a)|0;i=b;return a|0}function mE(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=nE(c[d>>2]|0)|0;i=b;return a|0}function nE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;Su(b);if((e|0)==0){e=a;while(1){a=Gw(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=oE(c[d>>2]|0)|0;i=b;return g|0}return 0}function oE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;Su(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;Su(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function pE(a){a=a|0;var b=0,d=0;b=i;d=qE((c[a>>2]|0)+16|0)|0;i=b;return d|0}function qE(a){a=a|0;var b=0,c=0;b=i;c=rE(a)|0;i=b;return c|0}function rE(a){a=a|0;i=i;return a|0}function sE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=xE(b,h,j,e)|0;h=c[p>>2]|0;Su(l);if((h|0)!=0){q=h;LA(a,q);i=f;return}zE(o,b,e);AE(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];yE(m,g);BE(o);o=c[j>>2]|0;wC(b,o,p,CE(m)|0);p=DE(m)|0;BE(m);q=p;LA(a,q);i=f;return}function tE(a,b){a=a|0;b=b|0;var c=0;c=i;uE(a,b);i=c;return}function uE(a,b){a=a|0;b=b|0;var c=0;c=i;vE(a,b);i=c;return}function vE(a,b){a=a|0;b=b|0;var c=0;c=i;wE(a,b);i=c;return}function wE(a,b){a=a|0;b=b|0;var c=0;c=i;pJ(a,b);pJ(a+12|0,b+12|0);i=c;return}function xE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;KA(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];fF(l,k);do{if(!(eF(b,l)|0)){k=VA(a)|0;x=hF(b)|0;if(gF(k,e,x)|0){break}w=gF(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];lF(r,h,1,0);KA(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];fF(t,g);do{if(!(eF(r,t)|0)){if(gF(k,e,hF(r)|0)|0){break}y=kF(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;Su(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;iF(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];fF(o,j);do{if(!(eF(n,o)|0)){j=VA(a)|0;if(gF(j,hF(jF(n)|0)|0,e)|0){break}y=kF(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;Su(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function yE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];cF(a,e);i=d;return}function zE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=UC(d)|0;d=WC(n,1)|0;QE(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];PE(j,d,h);RE(0,uD((SE(j)|0)+16|0)|0,e);a[(TE(j)|0)+4|0]=1;UE(m,j);AE(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];yE(b,g);BE(m);BE(j);i=f;return}function AE(a,b){a=a|0;b=b|0;var c=0;c=i;NE(a,b);i=c;return}function BE(a){a=a|0;var b=0;b=i;IE(a);i=b;return}function CE(a){a=a|0;var b=0,d=0;b=i;d=c[(GE(a)|0)>>2]|0;i=b;return d|0}function DE(a){a=a|0;var b=0,d=0;b=i;d=EE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function EE(a){a=a|0;var b=0,c=0;b=i;c=FE(a)|0;i=b;return c|0}function FE(a){a=a|0;i=i;return a|0}function GE(a){a=a|0;var b=0,c=0;b=i;c=HE(a)|0;i=b;return c|0}function HE(a){a=a|0;i=i;return a|0}function IE(a){a=a|0;var b=0;b=i;JE(a,0);i=b;return}function JE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=EE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}LE(KE(e)|0,f);i=d;return}function KE(a){a=a|0;var b=0,c=0;b=i;c=ME(a)|0;i=b;return c|0}function LE(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;tD(f,uD(d+16|0)|0)}if((d|0)==0){i=e;return}NC(c[b>>2]|0,d,1);i=e;return}function ME(a){a=a|0;i=i;return a+4|0}function NE(a,b){a=a|0;b=b|0;var c=0;c=i;OE(a,b);i=c;return}function OE(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];YE(a,b,f);i=e;return}function QE(a,b){a=a|0;b=b|0;var c=0;c=i;XE(a,b);i=c;return}function RE(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}VE(b,c);i=a;return}function SE(a){a=a|0;var b=0,d=0;b=i;d=c[(GE(a)|0)>>2]|0;i=b;return d|0}function TE(a){a=a|0;var b=0,c=0;b=i;c=KE(a)|0;i=b;return c|0}function UE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;NE(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];yE(h,f);AE(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];yE(a,e);BE(h);i=d;return}function VE(a,b){a=a|0;b=b|0;var c=0;c=i;WE(a,b);i=c;return}function WE(a,b){a=a|0;b=b|0;var c=0;c=i;vE(a,b);i=c;return}function XE(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function YE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(fD(g)|0)>>2]|0;g=_E(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];ZE(b,a,f);i=e;return}function ZE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];$E(a,b,f);i=e;return}function _E(a){a=a|0;i=i;return a|0}function $E(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(jD(g)|0)>>2]|0;g=bF(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];aF(b,a,f);i=e;return}function aF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(jD(f)|0)>>2];f=bF(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function bF(a){a=a|0;i=i;return a|0}function cF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=DE(dF(b)|0)|0;h=bF(TE(dF(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];ZE(g,a,e);i=d;return}function dF(a){a=a|0;i=i;return c[a>>2]|0}function eF(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function fF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];qF(a,e);i=d;return}function gF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xy(0,b,c)|0;i=a;return d|0}function hF(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function iF(a,b){a=a|0;b=b|0;var d=0;d=i;LA(a,c[(mC(b)|0)>>2]|0);i=d;return}function jF(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=oF(c[d>>2]|0)|0;i=b;return a|0}function kF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=TA(a)|0;Su(e);if((h|0)==0){j=MA(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=VA(a)|0;a=h;while(1){h=a+16|0;if(gF(j,d,h)|0){l=a;m=c[l>>2]|0;Su(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(gF(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;Su(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function lF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;mF(b,d);c[a>>2]=c[b>>2];i=e;return}function mF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;nF(b,c,e);i=d;return}function nF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{jF(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{mE(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function oF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;Su(b);if((e|0)==0){e=a;while(1){a=Gw(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=pF(c[d>>2]|0)|0;i=b;return g|0}return 0}function pF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;Su(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;Su(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function qF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function rF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(eF(a,b)|0)^1;i=c;return d|0}function sF(a){a=a|0;var b=0;b=i;i=i+128|0;Iy(a,b);Iy(a+12|0,b+8|0);tF(a+24|0,b+16|0);tF(a+36|0,b+24|0);tF(a+48|0,b+32|0);tF(a+60|0,b+40|0);tF(a+72|0,b+48|0);tF(a+84|0,b+56|0);tF(a+96|0,b+64|0);tF(a+108|0,b+72|0);tF(a+120|0,b+80|0);tF(a+132|0,b+88|0);tF(a+144|0,b+96|0);tF(a+156|0,b+104|0);tF(a+168|0,b+112|0);tF(a+180|0,b+120|0);i=b;return}function tF(a,b){a=a|0;b=b|0;b=i;uF(a,0);i=b;return}function uF(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vF(a,b);i=b;return}function vF(a,b){a=a|0;b=b|0;b=i;wF(a,0);i=b;return}function wF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;xF(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;yF(f,0,e);e=tB(b)|0;c[(sB(b)|0)>>2]=e;i=d;return}function xF(a){a=a|0;var b=0;b=i;BF(a);i=b;return}function yF(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;zF(b,c,f);i=e;return}function zF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(ux(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;AF(d,b,f);i=e;return}function AF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(ux(e)|0)>>2];i=d;return}function BF(a){a=a|0;var b=0;b=i;CF(a);i=b;return}function CF(a){a=a|0;var b=0;b=i;xx(a);i=b;return}function DF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[75620>>2]|0;if((m|0)==0){n=0}else{o=KT(12)|0;tJ(o,m);n=o}if((c[75536>>2]|0)!=0){c[5428]=1}if((n|0)==0){c[21724>>2]=1;c[21728>>2]=1;i=b;return}do{if((XJ(n,65760,0)|0)==-1){pJ(g,n);nJ(h);o=c[5002]|0;m=(o|0)<28;while(1){p=XJ(g,65768,0)|0;q=(p|0)!=-1;if(q){VJ(j,g,0,p);AJ(h,j)|0;zJ(j);VJ(k,g,p+1|0,-1);AJ(g,k)|0;zJ(k)}else{AJ(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){tJ(l,c[20424+(s<<2)>>2]|0);p=EF(h,l)|0;zJ(l);if(p){c[21720+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Ap(1,1,65776,f);if(m){v=o}else{w=22272;x=c[5568]|0;Td[x&255](1);y=WJ(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=65816;E=D;Cp(0,E,a)}do{p=c[21592+(v<<2)>>2]|0;c[e>>2]=c[20424+(v<<2)>>2];c[e+4>>2]=p;Ap(1,0,65800,e);v=v+1|0;}while((v|0)<28);w=22272;x=c[5568]|0;Td[x&255](1);y=WJ(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=65816;E=D;Cp(0,E,a)}else if((t|0)==20){Ap(1,1,65776,d);w=22272;x=c[5568]|0;Td[x&255](1);y=WJ(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=65816;E=D;Cp(0,E,a)}else if((t|0)==23){zJ(h);zJ(g);break}}else{o=1;do{c[21720+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[21724>>2]=1;c[21728>>2]=1;if((c[21756>>2]|0)!=0){c[21816>>2]=1}if((c[21812>>2]|0)==1){c[21820>>2]=1}if((c[21792>>2]|0)!=0){c[21788>>2]=1}if((c[21800>>2]|0)!=0){c[21788>>2]=1}if((c[21752>>2]|0)!=0){c[21748>>2]=1}if((c[21796>>2]|0)!=0){c[21788>>2]=1}if((c[21744>>2]|0)!=0){c[21740>>2]=1}zJ(n);MT(n);i=b;return}function EF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=xJ(b)|0;if((e|0)!=(xJ(c)|0)){f=0;i=d;return f|0}g=yJ(b)|0;h=yJ(c)|0;if(qJ(b)|0){f=(Zy(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function FF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[75628>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=KT(12)|0;l=k;tJ(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(GF(l,c[53280+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=WJ(l)|0;Ap(1,1,65848,g);g=c[53364>>2]|0;c[f>>2]=c[53284>>2];c[f+4>>2]=g;Ap(1,0,65800,f);f=c[53368>>2]|0;c[e>>2]=c[53288>>2];c[e+4>>2]=f;Ap(1,0,65800,e);e=c[53372>>2]|0;c[d>>2]=c[53292>>2];c[d+4>>2]=e;Ap(1,0,65800,d);Td[c[5568]&255](1);Cp(0,65904,a)}else if((n|0)==6){i=b;return j|0}return 0}function GF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(ZJ(a,b)|0)==0;i=c;return d|0}function HF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[75612>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=KT(12)|0;l=k;tJ(l,h);if((k|0)==0){j=1;i=b;return j|0}tJ(f,65928);k=EF(l,f)|0;zJ(f);if(k){j=1;i=b;return j|0}tJ(g,65936);k=EF(l,g)|0;zJ(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=WJ(l)|0;Ap(1,1,65944,e);c[d>>2]=65928;c[d+4>>2]=66e3;Ap(1,0,65800,d);c[a>>2]=65936;c[a+4>>2]=66016;Ap(1,0,65800,a);Td[c[5568]&255](1);Cp(0,65904,b)}return 0}function IF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;IL(f,a);if(!(LL(f)|0)){JL(f);i=d;return a|0}j=fz(b)|0;WF(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((Wu(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=tK(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];ZF(h,e,b,m,k,l,n);if(!(XF(h)|0)){JL(f);i=d;return a|0}nK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);JL(f);i=d;return a|0}function JF(a){a=a|0;var b=0;b=i;OL(a,uK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;vL(a)|0;i=b;return a|0}function KF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;tJ(h,d);iK(k,66024,h);sy(j,k,66032);zJ(k);k=WJ(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((cU(c[n+4>>2]|0,66040)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((cU(k,66048)|0)==0){zJ(j);zJ(h);i=f;return}d=MS(g,k,1)|0;if((d|0)!=0){m=l;kU(m|0,0,2048)|0;ZS(d,g,m,2048)|0;ML(IF(IF(IF(IF(IF(88016,66056)|0,k)|0,66096)|0,m)|0,66112)|0,103)|0;zJ(j);zJ(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(_S(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(_S(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(_S(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(_S(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(_S(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(_S(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(_S(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==1){n=(_S(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(_S(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){k=b+12|0;t=p;p=0;while(1){l=c[k>>2]|0;if((a[l+(p*52|0)+48|0]|0)==0){o=(_S(g,c[l+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[k>>2]|0)+(p*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=p+1|0;if((o|0)<(u|0)){t=u;p=o}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{k=c[u>>2]|0;do{if((a[k+(b*52|0)+48|0]|0)==0){o=a[k+(b*52|0)+8|0]|0;if(o<<24>>24==0){l=(_S(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=l;l=c[u>>2]|0;if((a[l+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[l+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(_S(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}QS(g);zJ(j);zJ(h);i=f;return}function LF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[75476>>2]|0;H=c[75604>>2]|0;I=c[2]|0;if((c[21820>>2]|0)==0){if(!((c[75424>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+wb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;yp(23,0,66160,l);l=c[75548>>2]|0;do{if((l|0)==0){M=0}else{if((cU(l,66184)|0)==0){M=1;break}if((cU(l,66192)|0)==0){M=0;break}if((cU(l,66200)|0)==0){M=2;break}c[j>>2]=l;Ap(1,0,66208,j);M=0}}while(0);if((Qq(M)|0)!=0){c[g>>2]=l;Ap(1,0,66280,g)}if((c[2]|0)!=0){VG(d+56|0);Vq((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Rq(0);Rq(6);Sq(3);Sq(4);Sq(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+_T(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];yp(1,0,66368,f)}do{if((c[75532>>2]|0)!=0){f=KT(12)|0;J=f;tJ(J,c[75660>>2]|0);if((f|0)==0){break}f=WJ(J)|0;c[d+280>>2]=f;c[e>>2]=f;yp(23,0,66424,e)}}while(0);e=c[75656>>2]|0;nJ(m);if((e|0)==0){tJ(p,c[d+88>>2]|0);tJ(q,66472);MF(o,p,q);sy(n,o,c[d+284>>2]|0);AJ(m,n)|0;zJ(n);zJ(o);zJ(q);zJ(p)}else{BJ(m,e)|0}tJ(r,66480);tJ(s,66480);tJ(t,66480);tJ(u,66480);tJ(v,66480);tJ(w,66480);e=c[75424>>2]|0;if((c[75444>>2]|0)!=0){BJ(r,c[75572>>2]|0)|0}if((c[75460>>2]|0)!=0){BJ(s,c[75588>>2]|0)|0}if((c[75440>>2]|0)!=0){BJ(t,c[75568>>2]|0)|0}if((c[75448>>2]|0)==0){O=0.0}else{BJ(u,c[75576>>2]|0)|0;O=+_T(WJ(u)|0)}if((c[75452>>2]|0)==0){P=1}else{BJ(v,c[75580>>2]|0)|0;P=yc(WJ(v)|0)|0}if((c[75512>>2]|0)!=0){BJ(w,c[75640>>2]|0)|0}pJ(x,m);pJ(y,r);pJ(z,s);pJ(A,t);pJ(B,w);p=NF(d,x,y,z,A,O,P,B,e)|0;zJ(B);zJ(A);zJ(z);zJ(y);zJ(x);if((p|0)!=0|g^1){Q=p}else{Rq(5);p=kG(d)|0;Uq(5);yp(1,0,66488,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;zJ(w);zJ(v);zJ(u);zJ(t);zJ(s);zJ(r);zJ(m);i=b;return R|0}Q=d+88|0;tJ(D,c[Q>>2]|0);sy(C,D,66520);zJ(D);tJ(F,c[Q>>2]|0);sy(E,F,66536);zJ(F);Uq(0);F=c[75624>>2]|0;Q=WJ(C)|0;D=WJ(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;JG(d,Q,D,(F|0)!=0?F:66552,I,p,WJ(m)|0)|0;zJ(E);zJ(C);R=0;zJ(w);zJ(v);zJ(u);zJ(t);zJ(s);zJ(r);zJ(m);i=b;return R|0}function MF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;oJ(a,d);e=xJ(b)|0;f=xJ(c)|0;_J(a,yJ(b)|0,e,f+e|0);SJ(a,yJ(c)|0,f)|0;i=d;return}function NF(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((xJ(j)|0)==0){u=0}else{u=WJ(j)|0}pJ(r,b);b=(OF(a,r,k)|0)==0;zJ(r);if(!b){v=-1;i=l;return v|0}tJ(s,66480);b=a+280|0;r=GF(s,c[b>>2]|0)|0;zJ(s);do{if(r){w=3}else{s=1;k=0;do{tJ(t,c[66696+(s<<2)>>2]|0);j=GF(t,c[b>>2]|0)|0;zJ(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Ap(1,0,66776,q);Ap(1,0,65776,p);s=1;do{j=c[66808+(s<<2)>>2]|0;c[o>>2]=c[66696+(s<<2)>>2];c[o+4>>2]=j;Ap(1,0,65800,o);s=s+1|0;}while((s|0)<20);Cp(c[a+536>>2]|0,65904,n)}}while(0);c[m>>2]=c[66696+(w<<2)>>2];yp(23,0,66888,m);m=WJ(d)|0;d=WJ(e)|0;e=jt(a,m,d,WJ(f)|0,g,h,w,u)|0;Ud[c[60140>>2]&63](60112,a);v=e;i=l;return v|0}function OF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[15028]=md(WJ(b)|0)|0;c[60116>>2]=g;c[60120>>2]=d;d=a+284|0;do{if((c[16438]|0)==0){g=c[d>>2]|0;if((cU(66560,g)|0)==0){h=0;break}if((cU(66568,g)|0)==0){c[60128>>2]=46;c[60132>>2]=47;c[60140>>2]=48;h=0;break}if((cU(66576,g)|0)==0){c[60128>>2]=49;c[60132>>2]=50;c[60136>>2]=51;c[60140>>2]=52;h=1;break}if((cU(66584,g)|0)==0){c[60128>>2]=53;c[60132>>2]=54;c[60136>>2]=55;c[60140>>2]=56;h=1;break}if((cU(66592,g)|0)==0){c[60128>>2]=57;c[60132>>2]=58;c[60140>>2]=59;h=0;break}g=IF(88016,66600)|0;ML(IF(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);KF(a+8|0,c[a+288>>2]|0,h);Ud[c[60128>>2]&63](60112,a);a=c[15028]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;yp(23,0,66624,f);j=0;i=e;return j|0}function PF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;pp();do{if((bH(a,b)|0)==0){if((dH(a,b)|0)!=0){break}do{if((c[75480>>2]|0)!=0){w=c[75608>>2]|0;if((cU(w,67008)|0)==0){vp(1);break}if((cU(w,67016)|0)==0){vp(0);break}else{c[p>>2]=w;Ap(1,0,67024,p);hd(0)|0;od(0)}}}while(0);if((c[75436>>2]|0)==0){DF(0,0);ys(d);if((d|0)==0){ML(IF(88016,67392)|0,103)|0}c[d+300>>2]=FF(0,0)|0;c[d+292>>2]=HF(0,0)|0;py(d+8|0,d+240|0);Gs(d)|0;Ns(d)|0;Ws(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}ML(IF(88016,67456)|0,103)|0;x=1;i=e;return x|0}}while(0);c[16438]=c[75504>>2];x=0;i=e;return x|0}tJ(u,c[75564>>2]|0);w=1;while(1){y=26160+(w<<2)|0;tJ(v,c[y>>2]|0);z=EF(u,v)|0;zJ(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=WJ(u)|0;Ap(1,0,67296,g);c[f>>2]=c[b>>2];Ap(1,0,67336,f);hd(0)|0;od(0)}A=c[30184+(w<<2)>>2]|0;do{if((A|0)==1){z=c[30056+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;yp(1,1,67096,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[30056+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;yp(1,1,67136,n);break}else{c[m>>2]=z;Ap(1,1,66976,m);break}}}while(0);if((w|0)==19){A=c[5002]|0;if((A|0)<28){D=A}else{E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}do{A=c[21592+(D<<2)>>2]|0;c[l>>2]=c[20424+(D<<2)>>2];c[l+4>>2]=A;yp(1,0,65800,l);D=D+1|0;}while((D|0)<28);E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}else if((w|0)==7){A=1;do{z=c[67216+(A<<2)>>2]|0;c[k>>2]=c[67200+(A<<2)>>2];c[k+4>>2]=z;yp(1,0,65800,k);A=A+1|0;}while((A|0)<4);E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}else if((w|0)==11){A=1;do{z=c[67264+(A<<2)>>2]|0;c[j>>2]=c[67232+(A<<2)>>2];c[j+4>>2]=z;yp(1,0,65800,j);A=A+1|0;}while((A|0)<7);E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}else if((w|0)==29){A=1;do{z=c[66808+(A<<2)>>2]|0;c[h>>2]=c[66696+(A<<2)>>2];c[h+4>>2]=z;yp(1,0,65800,h);A=A+1|0;}while((A|0)<20);E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}else{E=22272;F=c[5568]|0;Td[F&255](1);G=hd(0)|0;od(0)}}}while(0);c[t>>2]=c[b>>2];yp(1,1,66912,t);t=1;do{b=c[30184+(t<<2)>>2]|0;do{if((b|0)==1){G=c[28064+(t<<2)>>2]|0;c[s>>2]=c[26160+(t<<2)>>2];c[s+4>>2]=G;yp(1,0,66928,s)}else{G=c[26160+(t<<2)>>2]|0;if((b|0)==2){F=c[28064+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;yp(1,0,66944,r);break}else{c[q>>2]=G;Ap(1,0,66976,q);break}}}while(0);t=t+1|0;}while((t|0)<31);Td[c[5568]&255](1);hd(0)|0;od(0);return 0}function QF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[16872]|0;pb(69136)|0;c[l>>2]=c[m+88>>2];ac(67496,l|0)|0;pb(69152)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];ac(67520,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ac(67560,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ac(67592,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ac(67624,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];ac(67656,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];ac(67688,b|0)|0;pb(69176)|0;i=a;return}function RF(a,b){a=a|0;b=+b;i=i;return}function SF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;fU(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=tU(c[g>>2]|0,f)|0;if((k|0)==0){ab(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=xa(40,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=tU(c[g>>2]|0,f)|0;if((m|0)==0){ab(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[16872]=d;u=0;Fa(54,10,206)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=tU(c[k>>2]|0,f)|0;if((p|0)==0){ab(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=xa(41,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=tU(c[g>>2]|0,f)|0;if((q|0)==0){ab(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=tU(c[g>>2]|0,f)|0;if((r|0)==0){ab(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=tU(c[g>>2]|0,f)|0;if((s|0)==0){ab(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=tU(c[g>>2]|0,f)|0;if((t|0)==0){ab(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=tU(c[g>>2]|0,f)|0;if((w|0)==0){ab(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(207,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=tU(c[g>>2]|0,f)|0;if((x|0)==0){ab(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=tU(c[g>>2]|0,f)|0;if((y|0)==0){ab(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=tU(c[k>>2]|0,f)|0;if((A|0)==0){ab(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function TF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=bd(c[4880]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[21732>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;ab(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;kc(67824,7,1,a|0)|0;wc(a|0,d|0,f|0)|0;Ed(10,a|0)|0;hd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;ab(n|0,1);break};case 5:case 4:{i=b;return};case 1:{c[f>>2]=e;n=c[r>>2]|0;kc(67824,7,1,n|0)|0;wc(n|0,d|0,f|0)|0;Ed(10,n|0)|0;hd(0)|0;ab(c[g+80>>2]|0,1);break};case 3:{if((c[21788>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;kc(67824,7,1,e|0)|0;wc(e|0,d|0,f|0)|0;Ed(10,e|0)|0;hd(0)|0;i=b;return};default:{Cp(g,67832,b)}}}function UF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;kc(67808,9,1,d|0)|0;wc(d|0,b|0,e|0)|0;Ed(10,d|0)|0;hd(0)|0;i=a;return}function VF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;aG(67752,b);c[16430]=66480;b=65724|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[65740>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;ab(k|0,1)}d=bd(c[4880]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;ab(k|0,1)}function WF(a,b){a=a|0;b=b|0;var c=0;c=i;YF(a,b);i=c;return}function XF(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function YF(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=sK(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function ZF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;Su(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=_F(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((EK(b,d,r)|0)==(r|0)){break}Su(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){uJ(l,s,h);if((EK(b,yJ(l)|0,s)|0)==(s|0)){zJ(l);break}Su(m);c[o>>2]=0;c[a>>2]=0;zJ(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((EK(b,e,l)|0)==(l|0)){break}Su(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);$F(g,0)|0;c[a>>2]=b;i=j;return}function _F(a){a=a|0;i=i;return c[a+12>>2]|0}function $F(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function aG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[16436]|0;if((g|0)==0){c[e>>2]=(gU(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(gz(e,f)|0)>>2]|0;c[16950]=h;f=ET(h)|0;c[16436]=f;j=h;k=f}else{j=c[16950]|0;k=g}g=gc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[16950]|0)>>>0){i=d;return}FT(c[16436]|0);j=g<<1|1;c[16950]=j;g=ET(j)|0;c[16436]=g;gc(g|0,j|0,a|0,b|0)|0;i=d;return}function bG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;cG(g,16);dG(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){eG(a,g);fG(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){IF(NL(m,+h[b+(p<<3)>>3])|0,69192)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){NL(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){IF(m,69200)|0}}while((e|0)<(d|0));eG(a,g);fG(g);i=f;return}function cG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;wK(e);f=a;c[f>>2]=69572;g=e;c[g>>2]=69592;e=a+4|0;DL(a,69604|0,e);c[f>>2]=69572;c[g>>2]=69592;rG(e,b|16);i=d;return}function dG(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function eG(a,b){a=a|0;b=b|0;var c=0;c=i;lG(a,b+4|0);i=c;return}function fG(a){a=a|0;var b=0;b=i;vG(a,69600);rK(a+56|0);i=b;return}function gG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21776>>2]|0)!=0){pb(69896)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(14,0,69208,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Wd[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(14,0,69280,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21776>>2]|0)==0){i=d;return 0}yp(14,0,69328,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ac(69344,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}_b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function hG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21776>>2]|0)!=0){pb(69896)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(14,0,69208,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Wd[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(14,0,69280,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21776>>2]|0)==0){i=d;return 0}yp(14,0,69328,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ac(69344,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}_b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function iG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21776>>2]|0)!=0){pb(69896)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(14,0,69208,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Wd[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(14,0,69280,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21776>>2]|0)==0){i=d;return 0}yp(14,0,69328,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ac(69344,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}_b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function jG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[21776>>2]|0)!=0){pb(69896)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];yp(14,0,69208,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);Wd[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];yp(14,0,69280,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[21776>>2]|0)==0){i=d;return 0}yp(14,0,69328,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ac(69344,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}_b(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function kG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=GT(fa(F,F)|0,8)|0;J=I;K=GT(fa(G,F)|0,8)|0;L=K;M=GT(fa(H,F)|0,8)|0;N=M;O=GT(fa(H,G)|0,8)|0;P=O;nJ(p);nJ(q);nJ(r);nJ(s);nJ(t);nJ(u);nJ(v);Q=a+536|0;Bp(c[Q>>2]|0,(I|0)!=0|0,69352,o);Bp(c[Q>>2]|0,(K|0)!=0|0,69352,n);Bp(c[Q>>2]|0,(M|0)!=0|0,69352,m);Bp(c[Q>>2]|0,(O|0)!=0|0,69352,l);l=a+540|0;m=a;if((Wd[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;gG(a,J)|0;Bp(n,1,69368,k)}bG(w,J,F,F);AJ(p,w)|0;zJ(w);if((Wd[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;hG(a,L)|0;Bp(w,1,69400,j)}bG(x,L,F,G);AJ(q,x)|0;zJ(x);if((Wd[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;iG(a,N)|0;Bp(x,1,69432,h)}bG(y,N,H,F);AJ(r,y)|0;zJ(y);if((Wd[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;jG(a,P)|0;Bp(m,1,69464,g)}bG(z,P,H,G);AJ(s,z)|0;zJ(z);if((F|0)==0){BJ(t,69496)|0}else{bG(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);AJ(t,A)|0;zJ(A)}if((G|0)==0){BJ(u,69496)|0}else{bG(B,c[a+432>>2]|0,1,G);AJ(u,B)|0;zJ(B)}FT(I);FT(K);FT(M);FT(O);tJ(E,c[a+84>>2]|0);iK(D,69512,E);sy(C,D,69520);AJ(v,C)|0;zJ(C);zJ(D);zJ(E);E=cc(WJ(v)|0,69528)|0;D=c[Q>>2]|0;c[f>>2]=WJ(v)|0;Bp(D,(E|0)!=0|0,69536,f);f=le[c[(c[l>>2]|0)+176>>2]&7]()|0;D=WJ(t)|0;Q=WJ(u)|0;C=WJ(p)|0;a=WJ(q)|0;O=WJ(r)|0;M=WJ(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;jd(E|0,f|0,e|0)|0;if((c[21820>>2]|0)==0){R=hd(E|0)|0;S=Qc(E|0)|0;zJ(v);zJ(u);zJ(t);zJ(s);zJ(r);zJ(q);zJ(p);i=b;return 0}e=le[c[(c[l>>2]|0)+176>>2]&7]()|0;l=WJ(t)|0;f=WJ(u)|0;M=WJ(p)|0;O=WJ(q)|0;a=WJ(r)|0;C=WJ(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;yp(25,0,e,d);R=hd(E|0)|0;S=Qc(E|0)|0;zJ(v);zJ(u);zJ(t);zJ(s);zJ(r);zJ(q);zJ(p);i=b;return 0}function lG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=MK(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}mG(a,LK(l)|0,n,e);i=d;return}if((h&8|0)==0){oJ(a,g);i=d;return}else{g=b;b=GK(g)|0;mG(a,b,IK(g)|0,f);i=d;return}}function mG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;nG(a,b,c,0);i=d;return}function nG(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;oG(a,b,c);i=d;return}function oG(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=pG(c,d)|0;if(g>>>0>4294967279){lJ(0)}if(g>>>0<11){FJ(b,g);h=EJ(b)|0}else{j=MJ(g)|0;k=j+1|0;j=cz(sJ(b)|0,k)|0;OJ(b,j);NJ(b,k);DJ(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;dz(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){dz(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;dz(l,f);i=e;return}function pG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=qG(b,c,e)|0;i=d;return g|0}function qG(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function rG(a,b){a=a|0;b=b|0;var c=0;c=i;HG(a,b);i=c;return}function sG(a){a=a|0;var b=0;b=i;fG(a);MT(a);i=b;return}function tG(a){a=a|0;var b=0;b=i;fG(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function uG(a){a=a|0;var b=0;b=i;sG(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function vG(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];wG(a+4|0);i=d;return}function wG(a){a=a|0;var b=0;b=i;xG(a);i=b;return}function xG(a){a=a|0;var b=0;b=i;c[a>>2]=69752;zJ(a+32|0);AK(a);i=b;return}function yG(a){a=a|0;var b=0;b=i;wG(a);MT(a);i=b;return}function zG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=MK(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}eu(a,-1,-1);i=h;return}else if((k|0)==0){eu(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=MK(l)|0;j=m-(LK(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=HK(l)|0;m=j-(GK(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(yJ(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){eu(a,-1,-1);i=h;return}q=qU(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(yJ(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((HK(l)|0)!=0){break}eu(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((MK(l)|0)!=0){break}eu(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=GK(l)|0;KK(l,p,p+q|0,n)}if((g&16|0)!=0){p=LK(l)|0;PK(l,p,NK(l)|0);OK(l,q)}eu(a,q,e);i=h;return}}while(0);eu(a,-1,-1);i=h;return}function AG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=sv(d)|0;ce[g&31](a,b,h,J,0,e);i=f;return}function BG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=MK(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((IK(g)|0)>>>0<j>>>0){b=GK(g)|0;KK(g,b,HK(g)|0,j)}j=HK(g)|0;if(!(j>>>0<(IK(g)|0)>>>0)){k=-1;i=d;return k|0}k=Qv(a[j]|0)|0;i=d;return k|0}function CG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=MK(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=GK(h)|0;j=HK(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(Mv(d,-1)|0){KK(h,g,j+ -1|0,k);l=Pv(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=Nv(d)|0;do{if(g){if(Rv(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=GK(h)|0;KK(h,j,(HK(h)|0)+ -1|0,k);a[HK(h)|0]=b;l=d;i=e;return l|0}function DG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(Mv(b,-1)|0){f=Pv(b)|0;i=d;return f|0}g=a;h=HK(g)|0;j=h-(GK(g)|0)|0;h=MK(g)|0;do{if((h|0)==(NK(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=LK(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;RJ(o,0);KJ(o,HJ(o)|0);p=yJ(o)|0;PK(g,p,p+(xJ(o)|0)|0);OK(g,h-l|0);c[m>>2]=(LK(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(MK(g)|0)+1;h=c[(EG(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=yJ(a+32|0)|0;KK(g,q,q+j|0,h)}f=DK(g,b&255)|0;i=d;return f|0}function EG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=FG(b,c,e)|0;i=d;return g|0}function FG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=GG(0,a,b)|0;i=c;return(d?b:a)|0}function GG(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function HG(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;FK(a);c[a>>2]=69752;nJ(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;nJ(e);IG(a,e);zJ(e);i=d;return}function IG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;AJ(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=yJ(e)|0;j=g+(xJ(e)|0)|0;c[b>>2]=j;g=yJ(e)|0;KK(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=xJ(e)|0;c[b>>2]=(yJ(e)|0)+h;KJ(e,HJ(e)|0);b=a;a=yJ(e)|0;PK(b,a,a+(xJ(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}OK(b,h);i=d;return}function JG(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=cc(d|0,70176)|0;J=Uc(70184,70176)|0;K=(J|0)!=0;L=Gc()|0;if(K){M=c[b+536>>2]|0;N=Id(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Bp(M,(I|0)!=0|0,70240,E);kc(70264,17,1,J|0)|0;kc(70288,10,1,J|0)|0;kc(70304,18,1,J|0)|0;KG(J,f,70328,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,70360)}else{c[G>>2]=Id(c[L>>2]|0)|0;Ap(26,0,70192,G);G=c[b+536>>2]|0;E=Id(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Bp(G,(I|0)!=0|0,70240,F)}kc(70368,348,1,I|0)|0;if((lc(H|0)|0)<0){c[D>>2]=Id(c[L>>2]|0)|0;Ap(26,0,70720,D);Qc(I|0)|0;Ya(J|0)|0;O=1;i=j;return O|0}if((Lc(69920,250,70744,ad(H|0)|0)|0)==0){Ap(26,0,70768,C);Qc(I|0)|0;O=1;i=j;return O|0}kc(70792,13,1,I|0)|0;kc(70808,12,1,I|0)|0;LG(I,2);kc(70824,6,1,I|0)|0;MG(I,c[b+84>>2]|0);kc(70832,8,1,I|0)|0;LG(I,2);kc(70848,8,1,I|0)|0;C=b+88|0;MG(I,c[C>>2]|0);kc(70864,10,1,I|0)|0;LG(I,2);kc(70880,6,1,I|0)|0;MG(I,69920);kc(70888,8,1,I|0)|0;LG(I,2);kc(70904,8,1,I|0)|0;MG(I,c[b+280>>2]|0);kc(70920,10,1,I|0)|0;LG(I,2);kc(70936,14,1,I|0)|0;MG(I,c[b+284>>2]|0);kc(70952,16,1,I|0)|0;LG(I,2);kc(70976,16,1,I|0)|0;MG(I,l);kc(71e3,18,1,I|0)|0;LG(I,2);c[B>>2]=NG(l)|0;jd(I|0,71024,B|0)|0;LG(I,2);P=+Mq(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];jd(I|0,71064,A|0)|0;LG(I,2);P=+Mq(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];jd(I|0,71104,z|0)|0;LG(I,2);P=+Mq(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];jd(I|0,71136,y|0)|0;LG(I,2);P=+Mq(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];jd(I|0,71168,x|0)|0;LG(I,2);P=+Mq(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];jd(I|0,71200,w|0)|0;LG(I,2);P=+Mq(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];jd(I|0,71232,v|0)|0;LG(I,2);P=+Mq(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];jd(I|0,71272,u|0)|0;LG(I,2);P=+Pq(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];jd(I|0,71304,t|0)|0;LG(I,2);c[s>>2]=Kq(2)|0;jd(I|0,71344,s|0)|0;LG(I,2);P=+Oq(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];jd(I|0,71368,r|0)|0;kc(71400,13,1,I|0)|0;kc(71416,16,1,I|0)|0;LG(I,2);P=+Mq(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];jd(I|0,71440,q|0)|0;LG(I,2);c[p>>2]=Hq(8)|0;jd(I|0,71464,p|0)|0;kc(71504,17,1,I|0)|0;kc(71528,22,1,I|0)|0;OG(I,b);kc(71552,23,1,I|0)|0;kc(71576,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{PG(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{PG(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{PG(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{PG(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{PG(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{PG(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{PG(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{PG(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}kc(71592,13,1,I|0)|0;kc(71608,12,1,I|0)|0;QG(I,J,f,c[C>>2]|0,b);kc(71624,13,1,I|0)|0;kc(71640,12,1,I|0)|0;RG(I,c[b+68>>2]|0,b+56|0);kc(71656,13,1,I|0)|0;kc(71672,16,1,I|0)|0;SG(I,J,f,b);kc(71696,17,1,I|0)|0;kc(71720,14,1,I|0)|0;Qc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((gU(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(gU(K|0)|0)<<1}else{Q=0}I=ET(b+Q|0)|0;if((I|0)==0){_a(71736,71744,404,71768)}if((Ya(J|0)|0)!=0){Ap(26,0,71784,o)}if(e){e=c[C>>2]|0;c[n>>2]=71816;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;bc(I|0,71832,n|0)|0;if((fd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=71912|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Ap(1,0,71944,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;yp(1,0,72008,g);FT(I);O=0;i=j;return O|0}function KG(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Iq(F)|0;H=Jq(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Oq(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}kc(70264,17,1,a|0)|0;kc(73176,12,1,a|0)|0;kc(73192,12,1,a|0)|0;kc(73208,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;jd(a|0,73224,D|0)|0;kc(73264,10,1,a|0)|0;kc(73280,11,1,a|0)|0;kc(73296,11,1,a|0)|0;kc(73312,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];jd(a|0,73328,C|0)|0}else{kc(73352,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;jd(a|0,72952,B|0)|0;kc(73376,13,1,a|0)|0;if(E){kc(73192,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];jd(a|0,73392,A|0)|0}else{kc(73352,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;jd(a|0,73416,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;jd(a|0,73072,y|0)|0;kc(73464,10,1,a|0)|0;kc(73480,10,1,a|0)|0;kc(73464,10,1,a|0)|0;kc(73496,11,1,a|0)|0;c[x>>2]=b;jd(a|0,73512,x|0)|0;c[w>>2]=d;jd(a|0,73536,w|0)|0;kc(73552,33,1,a|0)|0;kc(73592,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;jd(a|0,73632,v|0)|0;kc(73312,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];jd(a|0,73328,u|0)|0}else{kc(73480,10,1,a|0)|0;kc(73464,10,1,a|0)|0;kc(73496,11,1,a|0)|0;c[t>>2]=b;jd(a|0,73512,t|0)|0;c[s>>2]=d;jd(a|0,73536,s|0)|0;kc(73552,33,1,a|0)|0;kc(73592,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;jd(a|0,73632,r|0)|0;kc(73312,10,1,a|0)|0;kc(73352,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;jd(a|0,72952,q|0)|0;kc(73376,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];jd(a|0,73392,p|0)|0}else{kc(73352,17,1,a|0)|0}kc(73664,32,1,a|0)|0;kc(73704,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;jd(a|0,73736,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;jd(a|0,73072,n|0)|0;i=m;return}function LG(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Ed(32,a|0)|0;}while((d|0)!=0);i=c;return}function MG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==60){kc(72920,4,1,b|0)|0}else if((e|0)==39){kc(72936,6,1,b|0)|0}else if((e|0)==62){kc(72928,4,1,b|0)|0}else if((e|0)==34){kc(72944,6,1,b|0)|0}else{Ed(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function NG(a){a=a|0;var b=0,c=0,d=0;b=i;c=cc(a|0,72912)|0;if((c|0)==0){d=-1;i=b;return d|0}Oc(c|0,0,2)|0;a=ub(c|0)|0;Qc(c|0)|0;d=a;i=b;return d|0}function OG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=ET((gU(l|0)|0)+15|0)|0;c[f>>2]=l;bc(m|0,72640,f|0)|0;LG(a,2);kc(72656,10,1,a|0)|0;MG(a,m);kc(72672,12,1,a|0)|0;LG(a,2);c[e>>2]=NG(m)|0;jd(a|0,72688,e|0)|0;FT(m);LG(a,2);kc(72720,9,1,a|0)|0;LG(a,4);kc(72736,22,1,a|0)|0;LG(a,4);kc(72760,22,1,a|0)|0;LG(a,4);kc(72784,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){UG(g,m,n);o=c[l>>2]|0;LG(a,4);kc(72816,8,1,a|0)|0;MG(a,o);kc(72832,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{ZG(h,m,l);g=c[n>>2]|0;LG(a,4);kc(72816,8,1,a|0)|0;MG(a,g);kc(72832,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{UG(j,m,q);b=c[t>>2]|0;LG(a,4);kc(72856,8,1,a|0)|0;MG(a,b);kc(72872,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){LG(a,2);v=72896;w=v;x=kc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{ZG(k,m,s);e=c[u>>2]|0;LG(a,4);kc(72856,8,1,a|0)|0;MG(a,e);kc(72872,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));LG(a,2);v=72896;w=v;x=kc(w|0,10,1,a|0)|0;i=d;return}function PG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;LG(a,2);c[f>>2]=c[b>>2];jd(a|0,72576,f|0)|0;MG(a,c[b+4>>2]|0);kc(72608,11,1,a|0)|0;MG(a,c[b+8>>2]|0);kc(72280,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];TG(a,4,e);LG(a,2);kc(72624,12,1,a|0)|0;i=d;return}function QG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{UG(p,r,v);KG(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,72392);w=v+9|0;Sq(w);LG(a,2);c[o>>2]=c[f>>2];jd(a|0,72400,o|0)|0;LG(a,4);kc(70824,6,1,a|0)|0;MG(a,c[s>>2]|0);kc(70832,8,1,a|0)|0;LG(a,4);c[n>>2]=Kq(w)|0;jd(a|0,72176,n|0)|0;LG(a,4);x=+Pq(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];jd(a|0,72200,m|0)|0;LG(a,4);x=+Oq(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];jd(a|0,71368,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];TG(a,6,j);LG(a,2);kc(72424,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function RG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{LG(a,2);YG(l,d,x);c[j>>2]=c[q>>2];jd(a|0,72248,j|0)|0;YG(m,d,x);MG(a,c[r>>2]|0);kc(72280,3,1,a|0)|0;LG(a,4);kc(72288,7,1,a|0)|0;YG(n,d,x);if((c[s>>2]|0)>0){y=0;do{LG(a,6);c[g>>2]=0;jd(a|0,72296,g|0)|0;y=y+1|0;YG(n,d,x);}while((y|0)<(c[s>>2]|0))}LG(a,4);kc(72320,8,1,a|0)|0;LG(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;YG(o,d,x);z=+Mq(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;YG(p,d,x);A=Hq(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;jd(a|0,72336,f|0)|0;LG(a,2);kc(72376,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}



function jS(a){a=a|0;a=i;bK(98388|0);bK(98376|0);bK(98364|0);bK(98352|0);bK(98340|0);bK(98328|0);bK(98316|0);bK(98304|0);bK(98292|0);bK(98280|0);bK(98268|0);bK(98256|0);bK(98244|0);bK(98232|0);bK(98220|0);bK(98208|0);bK(98196|0);bK(98184|0);bK(98172|0);bK(98160|0);bK(98148|0);bK(98136|0);bK(98124|0);bK(98112);i=a;return}function kS(a){a=a|0;a=i;zJ(99228|0);zJ(99216|0);zJ(99204|0);zJ(99192|0);zJ(99180|0);zJ(99168|0);zJ(99156|0);zJ(99144|0);zJ(99132|0);zJ(99120|0);zJ(99108|0);zJ(99096|0);zJ(99084|0);zJ(99072|0);zJ(99060|0);zJ(99048|0);zJ(99036|0);zJ(99024|0);zJ(99012|0);zJ(99e3|0);zJ(98988|0);zJ(98976|0);zJ(98964|0);zJ(98952);i=a;return}function lS(a){a=a|0;a=i;bK(99620|0);bK(99608|0);bK(99596|0);bK(99584|0);bK(99572|0);bK(99560|0);bK(99548|0);bK(99536|0);bK(99524|0);bK(99512|0);bK(99500|0);bK(99488|0);bK(99476|0);bK(99464);i=a;return}function mS(a){a=a|0;a=i;zJ(100156|0);zJ(100144|0);zJ(100132|0);zJ(100120|0);zJ(100108|0);zJ(100096|0);zJ(100084|0);zJ(100072|0);zJ(100060|0);zJ(100048|0);zJ(100036|0);zJ(100024|0);zJ(100012|0);zJ(1e5);i=a;return}function nS(a){a=a|0;var b=0,c=0;b=i;if((tS(a)|0)==0){c=(oS(a)|0)!=0|0}else{c=1}i=b;return c|0}function oS(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[100312+((d[100312+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function pS(a){a=a|0;var b=0,c=0;b=i;c=tb(a|0)|0;i=b;return c|0}function qS(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function rS(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 4:{d=qS(a)|0;break};case 2:{d=oS(a)|0;break};case 8:{d=wS(a)|0;break};case 6:{d=uS(a)|0;break};case 12:{d=AS(a)|0;break};case 5:{d=tS(a)|0;break};case 7:{d=vS(a)|0;break};case 1:{d=nS(a)|0;break};case 10:{d=yS(a)|0;break};case 11:{d=zS(a)|0;break};case 9:{d=xS(a)|0;break};case 3:{d=pS(a)|0;break};default:{d=0}}i=c;return d|0}function sS(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=103288;while(1){if(d<<24>>24==e<<24>>24){if((cU(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function tS(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function uS(a){a=a|0;var b=0,c=0;b=i;if((yS(a)|0)==0){c=(wS(a)|0)!=0|0}else{c=0}i=b;return c|0}function vS(a){a=a|0;var b=0,c=0;b=i;if((BS(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function wS(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function xS(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[103368+((d[103368+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function yS(a){a=a|0;var b=0,c=0;b=i;c=(dT(106536,a)|0)!=0|0;i=b;return c|0}function zS(a){a=a|0;var b=0,c=0;b=i;c=(DS(a)|0)!=(a|0)|0;i=b;return c|0}function AS(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function BS(a){a=a|0;var b=0,c=0;b=i;c=CS(a,0)|0;i=b;return c|0}function CS(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((oS(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[106626+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[106624+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[106627+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[106872+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[106872+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[106872+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function DS(a){a=a|0;var b=0,c=0;b=i;c=CS(a,1)|0;i=b;return c|0}function ES(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=FS(0,a,b,(c|0)!=0?c:107576)|0;i=d;return e|0}function FS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?107584:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[107368+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Gc()|0)>>2]=84;k=-1;i=g;return k|0}function GS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=HS(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=FS(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function HS(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[107368+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[107368+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Gc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function IS(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[107368+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Gc()|0)>>2]=84;j=-1;i=g;return j|0}function JS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Gc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function KS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=LS(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=JS(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function LS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=JS(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=JS(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=JS(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}JS(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function MS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=ET(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=ET(2048)|0;c[p+16>>2]=s;if((s|0)==0){FT(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=aT(0,0)|0;if((s|0)==0){FT(c[p+16>>2]|0);FT(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=NS(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=GT(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=OS(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=ET(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;kU(y|0,-1,v|0)|0;I=H}else{I=0}H=GT(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=GT(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=OS(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=US(q,x)|0;b:do{if((v|0)==0){y=US(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=VS(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=cT(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=cT(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=VS(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=cT(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=cT(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=VS(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=cT(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=cT(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=cT(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=cT(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=cT(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=cT(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=cT(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=cT(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==3){U=c[S+4>>2]|0;W=US(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=US(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=US(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=US(q,0)|0}else if((T|0)==0){W=c[S+4>>2]|0;U=c[W>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=W+8|0;W=(c[U>>2]|0)+L|0;c[U>>2]=W;if((W|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=W;ra=L;sa=M;ta=N;break}else if((T|0)==1){W=c[S+4>>2]|0;U=US(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=US(q,0)|0}else if((T|0)==2){T=c[S+4>>2]|0;U=US(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,c[T>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=US(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=cT(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=cT(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=cT(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=cT(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=US(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=US(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==0){R=c[ya>>2]|0;if((R|0)==0){Q=c[ya+4>>2]|0;T=c[Q>>2]|0;if((T|0)==-4){c[ya+8>>2]=0;U=Q+8|0;W=c[U>>2]|0;ea=cT(s,0,0,1,64)|0;if((ea|0)==0){F=104;break g}fa=ea;c[ea>>2]=W;c[ea+4>>2]=0;c[ea+8>>2]=1114111;c[ea+20>>2]=0;c[ea+24>>2]=0;W=ea+28|0;ea=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[ea>>2]=fa;fa=c[U>>2]|0;U=c[Q+4>>2]|0;ea=cT(s,0,0,1,64)|0;if((ea|0)==0){F=106;break g}c[ea>>2]=fa;c[ea+4>>2]=0;c[ea+8>>2]=1114111;c[ea+20>>2]=0;c[ea+24>>2]=0;c[ea+28>>2]=U;c[ea+32>>2]=-1;c[ea+36>>2]=-1;c[ea+40>>2]=-1;c[ya+28>>2]=ea;break}ea=ya+8|0;if((T|0)<0){c[ea>>2]=1;U=cT(s,0,0,1,32)|0;if((U|0)==0){F=110;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+24>>2]=U;U=cT(s,0,0,1,32)|0;if((U|0)==0){F=112;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+28>>2]=U;break}else{c[ea>>2]=0;ea=Q+8|0;U=c[ea>>2]|0;fa=Q+4|0;W=c[fa>>2]|0;da=cT(s,0,0,1,64)|0;if((da|0)==0){F=115;break g}Z=da;c[da>>2]=U;c[da+4>>2]=T;c[da+8>>2]=W;c[da+20>>2]=0;c[da+24>>2]=0;W=da+28|0;da=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[da>>2]=Z;Z=c[ea>>2]|0;ea=c[Q>>2]|0;da=c[fa>>2]|0;fa=c[Q+12>>2]|0;W=c[Q+16>>2]|0;Q=cT(s,0,0,1,64)|0;if((Q|0)==0){F=117;break g}T=Q;c[Q>>2]=Z;c[Q+4>>2]=ea;c[Q+8>>2]=da;c[Q+20>>2]=fa;c[Q+24>>2]=W;W=Q+28|0;Q=ya+28|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[Q>>2]=T;break}}else if((R|0)==1){T=US(q,ya)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=US(q,2)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=ya+4|0;Q=US(q,c[(c[T>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=US(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=US(q,c[c[T>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=US(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((R|0)==3){Q=US(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=US(q,1)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=ya+4|0;T=US(q,c[(c[Q>>2]|0)+4>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=US(q,0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=US(q,c[c[Q>>2]>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=US(q,0)|0;if((T|0)==0){break}else{z=0;A=T;B=0;C=D;break a}}else if((R|0)==2){R=US(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=US(q,3)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=US(q,c[c[ya+4>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=US(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else{break}}else if((S|0)==1){R=c[ya+4>>2]|0;T=c[R>>2]|0;Q=R+4|0;W=c[Q>>2]|0;if((c[T+8>>2]|0)==0){za=(c[W+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;fa=SS(s,c[T+24>>2]|0,c[W+24>>2]|0,0,0)|0;c[ya+24>>2]=fa;if((fa|0)==0){z=0;A=12;B=0;C=D;break a}fa=SS(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[Q>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=fa;if((fa|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==2){fa=c[ya+4>>2]|0;Q=c[fa>>2]|0;R=Q+8|0;if((c[R>>2]|0)==0){Aa=0}else{Aa=(c[(c[fa+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[R>>2]|0)==0){c[ya+24>>2]=c[Q+24>>2];Ba=fa+4|0}else{R=TS(q,Q,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ca=ET((c[g>>2]<<2)+4|0)|0;R=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=TS(q,c[fa>>2]|0,R,h,0)|0;if((Da|0)!=0){F=150;break g}Q=fa+4|0;W=SS(s,c[(c[Q>>2]|0)+24>>2]|0,c[(c[fa>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=W;FT(Ca);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=Q}}Q=c[Ba>>2]|0;if((c[Q+8>>2]|0)==0){c[ya+28>>2]=c[Q+28>>2];break}R=TS(q,Q,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ea=ET((c[g>>2]<<2)+4|0)|0;R=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=TS(q,c[Ba>>2]|0,R,h,0)|0;if((Fa|0)!=0){F=157;break g}Q=SS(s,c[(c[fa>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=Q;FT(Ea);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){FT(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){FT(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=ET(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=ET(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){kU(O|0,0,((E|0)>1?E<<2:4)|0)|0}PS(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;Q=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=Q}else{Ga=Q;break}}}else{Ga=0}K=GT(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;Q=PS(y,S,x,u)|0;if((Q|0)!=0){z=x;A=Q;B=u;C=D;break}c[w+20>>2]=0;Q=v+24|0;S=c[Q>>2]|0;if((c[S>>2]|0)>-1){R=1;fa=S;while(1){S=fa+32|0;W=R+1|0;if((c[S>>2]|0)>-1){fa=S;R=W}else{Ha=W;break}}}else{Ha=1}R=GT(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;fa=c[Q>>2]|0;y=c[fa>>2]|0;if((y|0)>-1){W=y;y=fa;fa=0;while(1){c[R+(fa<<5)+8>>2]=K+(c[N+(W<<2)>>2]<<5);c[R+(fa<<5)+12>>2]=W;S=R+(fa<<5)+16|0;c[S>>2]=0;T=y+12|0;da=c[T>>2]|0;if((da|0)!=0){ea=0;while(1){Ia=ea+1|0;if((c[da+(ea<<2)>>2]|0)>-1){ea=Ia}else{break}}ea=Ia<<2;da=ET(ea)|0;c[S>>2]=da;if((da|0)==0){z=x;A=12;B=u;C=D;break a}iU(da|0,c[T>>2]|0,ea|0)|0}c[R+(fa<<5)+20>>2]=c[y+16>>2];ea=fa+1|0;da=y+32|0;Z=c[da>>2]|0;if((Z|0)>-1){W=Z;y=da;fa=ea}else{Ja=ea;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;bT(s);FT(c[p+16>>2]|0);FT(p);FT(O);FT(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);bT(s);FT(c[p+16>>2]|0);FT(p);if((z|0)!=0){FT(z)}if((B|0)!=0){FT(B)}c[b+4>>2]=C;QS(b);r=A;i=f;return r|0}function NS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;US(m,c[p>>2]|0)|0;US(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=US(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 2:{Q=L+ -2|0;c[n>>2]=Q;R=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;S=cT(Q,0,0,1,32)|0;if((S|0)==0){T=12;U=294;break b}V=cT(Q,0,0,1,20)|0;c[S+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[V>>2]=-1;c[V+4>>2]=-1;c[V+8>>2]=-1;V=c[w>>2]|0;Q=cT(V,0,0,1,32)|0;if((Q|0)==0){T=12;U=294;break b}W=cT(V,0,0,1,8)|0;V=Q+4|0;c[V>>2]=W;if((W|0)==0){T=12;U=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[W>>2]=S;c[(c[V>>2]|0)+4>>2]=N;V=N+16|0;W=Q+16|0;c[W>>2]=(c[V>>2]|0)+(c[S+16>>2]|0);c[W>>2]=c[V>>2];X=Q}else{X=N}c[X+12>>2]=R;R=X+16|0;c[R>>2]=(c[R>>2]|0)+1;Y=M;Z=X;_=0;break};case 10:{R=L+ -2|0;c[n>>2]=R;c[v>>2]=c[P+(R<<2)>>2];Y=M;Z=N;_=0;break};case 5:{R=c[q>>2]|0;Q=a[R]|0;if(Q<<24>>24==0){Y=M;Z=N;_=0;break c}V=c[v>>2]&1;W=(V|0)!=0;if(W&Q<<24>>24==124){Y=M;Z=N;_=0;break c}do{if(!(W&Q<<24>>24==41&(M|0)>0)){if((V|0)==0&Q<<24>>24==92){if((a[R+1|0]|0)==41){break}}S=US(m,5)|0;if((S|0)!=0){$=M;aa=S;U=6;break b}S=US(m,N)|0;if((S|0)!=0){$=M;aa=S;U=6;break b}S=US(m,6)|0;if((S|0)!=0){$=M;aa=S;U=6;break b}Y=M;Z=N;_=US(m,4)|0;break c}}while(0);Q=(V|M|0)==0?8:0;W=M+ -1|0;if((V|0)!=0){Y=W;Z=N;_=Q;break c}c[q>>2]=R+2;Y=W;Z=N;_=Q;break};case 0:{if((c[v>>2]&1|0)!=0){Q=US(m,7)|0;if((Q|0)!=0){$=M;aa=Q;U=6;break b}}Y=M;Z=N;_=US(m,3)|0;break};case 7:{Q=c[q>>2]|0;W=a[Q]|0;if((W|0)==41){c[q>>2]=Q+1;Y=M;Z=N;_=0;break c}else if((W|0)!=124){Y=M;Z=N;_=0;break c}W=US(m,7)|0;if((W|0)!=0){$=M;aa=W;U=6;break b}W=US(m,N)|0;if((W|0)!=0){$=M;aa=W;U=6;break b}W=US(m,8)|0;if((W|0)!=0){$=M;aa=W;U=6;break b}W=US(m,3)|0;if((W|0)!=0){$=M;aa=W;U=6;break b}c[q>>2]=(c[q>>2]|0)+1;Y=M;Z=N;_=0;break};case 9:{W=c[q>>2]|0;Q=a[W]|0;switch(Q<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){Y=M;Z=N;_=0;break c}else{U=41}break};case 42:{U=41;break};case 92:{S=c[v>>2]|0;if((S&1|0)!=0){Y=M;Z=N;_=0;break c}ba=W+1|0;if((a[ba]|0)!=123){Y=M;Z=N;_=0;break c}c[q>>2]=ba;ca=S;da=ba;break};case 123:{ba=c[v>>2]|0;if((ba&1|0)==0){Y=M;Z=N;_=0;break c}else{ca=ba;da=W}break};default:{Y=M;Z=N;_=0;break c}}if((U|0)==41){U=0;c[q>>2]=W+1;W=c[w>>2]|0;ba=cT(W,0,0,1,32)|0;if((ba|0)==0){T=12;U=294;break b}S=cT(W,0,0,1,16)|0;c[ba+4>>2]=S;if((S|0)==0){T=12;U=294;break b}c[ba>>2]=2;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[S>>2]=N;c[S+4>>2]=Q<<24>>24==43;c[S+8>>2]=Q<<24>>24==63?1:-1;Q=S+12|0;a[Q]=a[Q]&-2;c[ba+16>>2]=c[N+16>>2];Y=M;Z=ba;_=US(m,9)|0;break c}ba=da+1|0;c[q>>2]=ba;Q=a[ba]|0;if((Q+ -48<<24>>24&255)<10){S=Q<<24>>24;if((S+ -48|0)>>>0<10){ea=S;fa=-1;ga=ba}else{T=10;U=294;break b}while(1){S=((fa|0)<0?-48:(fa*10|0)+ -48|0)+ea|0;W=ga+1|0;ha=a[W]|0;ia=ha<<24>>24;if((ia+ -48|0)>>>0<10){ga=W;fa=S;ea=ia}else{ja=ha;ka=S;la=W;break}}}else{ja=Q;ka=-1;la=ba}do{if(ja<<24>>24==44){R=la+1|0;V=a[R]|0;W=V<<24>>24;if((W+ -48|0)>>>0<10){ma=W;na=-1;oa=R}else{pa=V;qa=-1;ra=R;break}while(1){R=((na|0)<0?-48:(na*10|0)+ -48|0)+ma|0;V=oa+1|0;W=a[V]|0;S=W<<24>>24;if((S+ -48|0)>>>0<10){oa=V;na=R;ma=S}else{sa=W;ta=R;ua=V;U=54;break}}}else{sa=ja;ta=ka;ua=la;U=54}}while(0);do{if((U|0)==54){U=0;if(!((ta|0)>-1)){pa=sa;qa=ta;ra=ua;break}if((ka|0)>(ta|0)|(ta|0)>255){T=10;U=294;break b}else{pa=sa;qa=ta;ra=ua}}}while(0);if(pa<<24>>24==0){T=9;U=294;break b}if((ra|0)==(ba|0)){T=10;U=294;break b}if((ca&1|0)==0){if(!(pa<<24>>24==92)){T=10;U=294;break b}if((a[ra+1|0]|0)!=125){T=10;U=294;break b}va=ra+2|0}else{if(!(pa<<24>>24==125)){T=10;U=294;break b}va=ra+1|0}if((qa|ka|0)==0){Q=c[w>>2]|0;V=cT(Q,0,0,1,32)|0;if((V|0)==0){T=12;U=294;break b}R=cT(Q,0,0,1,20)|0;c[V+4>>2]=R;if((R|0)==0){T=12;U=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;wa=V}else{V=(qa&ka|0)<0;R=c[w>>2]|0;Q=cT(R,0,0,1,32)|0;if((Q|0)==0){T=12;U=294;break b}W=cT(R,0,0,1,16)|0;c[Q+4>>2]=W;if((W|0)==0){T=12;U=294;break b}c[Q>>2]=2;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[W>>2]=N;c[W+4>>2]=V?1:ka;c[W+8>>2]=V?1:qa;V=W+12|0;a[V]=a[V]&-2;c[Q+16>>2]=c[N+16>>2];wa=Q}c[q>>2]=va;Y=M;Z=wa;_=US(m,9)|0;break};case 3:{Q=US(m,5)|0;if((Q|0)!=0){$=M;aa=Q;U=6;break b}Y=M;Z=N;_=US(m,4)|0;break};case 6:{Q=L+ -2|0;c[n>>2]=Q;V=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;W=cT(Q,0,0,1,32)|0;if((W|0)==0){T=12;U=294;break b}R=cT(Q,0,0,1,8)|0;Q=W+4|0;c[Q>>2]=R;if((R|0)==0){T=12;U=294;break b}c[W>>2]=1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[R>>2]=V;c[(c[Q>>2]|0)+4>>2]=N;c[W+16>>2]=(c[N+16>>2]|0)+(c[V+16>>2]|0);Y=M;Z=W;_=0;break};case 4:{W=US(m,9)|0;if((W|0)!=0){$=M;aa=W;U=6;break b}Y=M;Z=N;_=US(m,1)|0;break};case 8:{W=L+ -2|0;c[n>>2]=W;V=c[P+(W<<2)>>2]|0;W=c[w>>2]|0;Q=cT(W,0,0,1,32)|0;if((Q|0)==0){T=12;U=294;break b}R=cT(W,0,0,1,8)|0;W=Q+4|0;c[W>>2]=R;if((R|0)==0){T=12;U=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[R>>2]=V;c[(c[W>>2]|0)+4>>2]=N;c[Q+16>>2]=(c[N+16>>2]|0)+(c[V+16>>2]|0);Y=M;Z=Q;_=0;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 91:{V=Q+1|0;c[q>>2]=V;W=ET(128)|0;if((W|0)==0){T=12;U=294;break b}if((a[V]|0)==94){R=Q+2|0;c[q>>2]=R;xa=R;ya=1}else{xa=V;ya=0}V=(ya|0)==0;R=W;W=0;S=0;ha=32;ia=xa;e:while(1){za=a[ia]|0;if(za<<24>>24==0){Aa=R;Ba=ia;Ca=7;U=140;break}else if(za<<24>>24==93){if(ia>>>0>(c[q>>2]|0)>>>0){U=85;break}}za=IS(e,ia,-1)|0;if((za|0)<0){c[e>>2]=-1;Da=1}else{Da=za}za=ia+Da|0;do{if((a[za]|0)==45){Ea=Da+1|0;Fa=ia+Ea|0;if((a[Fa]|0)==93){U=94;break}Ga=c[e>>2]|0;Ha=IS(e,Fa,-1)|0;if((Ha|0)<0){c[e>>2]=-1;Ia=-1;Ja=1}else{Ia=c[e>>2]|0;Ja=Ha}Ka=0;La=Ia;Ma=Ga;Na=ia+(Ja+Ea)|0;Oa=Ga>>>0>Ia>>>0?11:0}else{U=94}}while(0);f:do{if((U|0)==94){U=0;Ga=a[ia]|0;do{if(Ga<<24>>24==45){if((a[ia+1|0]|0)==93){Pa=0;break}Pa=(c[q>>2]|0)==(ia|0)?0:11}else if(Ga<<24>>24==91){Ea=a[ia+1|0]|0;if(Ea<<24>>24==61|Ea<<24>>24==46){Aa=R;Ba=ia;Ca=3;U=140;break e}else if(!(Ea<<24>>24==58)){Pa=0;break}Ea=ia+2|0;Ha=Ea;while(1){Fa=a[Ha]|0;Qa=Fa<<24>>24==0;if(Fa<<24>>24!=58&(Qa^1)){Ha=Ha+1|0}else{break}}if(Qa){Aa=R;Ba=ia;Ca=4;U=140;break e}Fa=Ha-ia+ -2|0;Ra=(Fa|0)>63?63:Fa;rU(A|0,Ea|0,Ra|0)|0;a[f+Ra|0]=0;Ra=sS(A)|0;Ka=Ra;La=1114111;Ma=0;Na=Ha+2|0;Oa=(Ra|0)==0?4:0;break f}else{Pa=0}}while(0);Ga=c[e>>2]|0;Ka=0;La=Ga;Ma=Ga;Na=za;Oa=Pa}}while(0);if((Oa|0)!=0){Aa=R;Ba=Na;Ca=Oa;U=140;break}za=(Ka|0)!=0;do{if(V|za^1){Ga=c[w>>2]|0;if((S|0)<(ha|0)){Sa=R;Ta=ha}else{if((ha|0)>1024){Aa=R;Ba=Na;Ca=12;U=140;break e}Ra=HT(R,ha<<3)|0;if((Ra|0)==0){Aa=R;Ba=Na;Ca=12;U=140;break e}else{Sa=Ra;Ta=ha<<1}}Ra=cT(Ga,0,0,1,32)|0;if((Ra|0)==0){U=112;break e}Fa=cT(Ga,0,0,1,20)|0;Ga=Ra+4|0;c[Ga>>2]=Fa;if((Fa|0)==0){U=112;break e}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[Fa>>2]=Ma;c[Fa+4>>2]=La;c[Fa+8>>2]=-1;c[Sa+(S<<2)>>2]=Ra;c[(c[Ga>>2]|0)+12>>2]=Ka;Ua=Sa;Va=W;Wa=S+1|0;Xa=Ta;Ya=0}else{if((W|0)>63){Ua=R;Va=W;Wa=S;Xa=ha;Ya=12;break}c[g+(W<<2)>>2]=Ka;Ua=R;Va=W+1|0;Wa=S;Xa=ha;Ya=0}}while(0);Ga=(Ya|0)==0;if(Ga&(((c[v>>2]&2|0)==0|za)^1)){Za=Ua;_a=Wa;$a=Xa;ab=Ma}else{if(Ga){R=Ua;W=Va;S=Wa;ha=Xa;ia=Na;continue}else{Aa=Ua;Ba=Na;Ca=Ya;U=140;break}}while(1){Ga=ab;while(1){if(Ga>>>0>La>>>0){R=Za;W=Va;S=_a;ha=$a;ia=Na;continue e}if((vS(Ga)|0)!=0){U=118;break}bb=Ga+1|0;if((zS(Ga)|0)==0){Ga=bb}else{U=129;break}}if((U|0)==118){U=0;Ra=BS(Ga)|0;Fa=Ga+1|0;g:do{if((vS(Fa)|0)==0){cb=Ra;db=Fa}else{eb=Ra;fb=Fa;while(1){if((BS(fb)|0)!=(eb+1|0)|fb>>>0>La>>>0){cb=eb;db=fb;break g}gb=BS(fb)|0;hb=fb+1|0;if((vS(hb)|0)==0){cb=gb;db=hb;break}else{eb=gb;fb=hb}}}}while(0);Fa=c[w>>2]|0;if((_a|0)<($a|0)){ib=Za;jb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;U=140;break e}fb=HT(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;U=140;break e}else{ib=fb;jb=$a<<1}}fb=cT(Fa,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){kb=0}else{Ha=cT(Fa,0,0,1,20)|0;c[fb+4>>2]=Ha;if((Ha|0)==0){kb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Ha>>2]=Ra;c[Ha+4>>2]=cb;c[Ha+8>>2]=-1;kb=eb}}while(0);c[ib+(_a<<2)>>2]=kb;lb=kb;mb=ib;nb=jb;ob=db}else if((U|0)==129){U=0;eb=DS(Ga)|0;h:do{if((zS(bb)|0)==0){pb=eb;qb=bb}else{Ra=eb;fb=bb;while(1){if((DS(fb)|0)!=(Ra+1|0)|fb>>>0>La>>>0){pb=Ra;qb=fb;break h}Fa=fb+1|0;Ha=DS(fb)|0;if((zS(Fa)|0)==0){pb=Ha;qb=Fa;break}else{Ra=Ha;fb=Fa}}}}while(0);Ga=c[w>>2]|0;if((_a|0)<($a|0)){rb=Za;sb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;U=140;break e}fb=HT(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;U=140;break e}else{rb=fb;sb=$a<<1}}fb=cT(Ga,0,0,1,32)|0;Ra=fb;do{if((fb|0)==0){tb=0}else{Fa=cT(Ga,0,0,1,20)|0;c[fb+4>>2]=Fa;if((Fa|0)==0){tb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=pb;c[Fa+8>>2]=-1;tb=Ra}}while(0);c[rb+(_a<<2)>>2]=tb;lb=tb;mb=rb;nb=sb;ob=qb}if((lb|0)==0){U=141;break e}else{Za=mb;_a=_a+1|0;$a=nb;ab=ob}}}i:do{if((U|0)==85){U=0;c[q>>2]=ia+1;ha=(ya|0)!=0;if(ha){Zb(R|0,S|0,4,55)}j:do{if((S|0)>0){V=(W|0)>0;za=W<<2;Ra=za+4|0;if(ha){ub=0;vb=0;wb=0;xb=0}else{eb=0;fb=0;while(1){Ga=R+(eb<<2)|0;Fa=c[(c[Ga>>2]|0)+4>>2]|0;do{if((Fa|0)==0){yb=fb;zb=0}else{c[Fa+8>>2]=c[x>>2];if(V){Ha=cT(c[w>>2]|0,0,0,0,Ra)|0;Ea=Fa+16|0;c[Ea>>2]=Ha;if((Ha|0)==0){Ab=R;Bb=fb;Cb=12;break i}iU(Ha|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(W<<2)>>2]=0}else{c[Fa+16>>2]=0}if((fb|0)==0){yb=c[Ga>>2]|0;zb=0;break}Ea=c[w>>2]|0;Ha=c[Ga>>2]|0;hb=cT(Ea,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){Db=0}else{Eb=cT(Ea,0,0,1,8)|0;Fb=hb+4|0;c[Fb>>2]=Eb;if((Eb|0)==0){Db=0;break}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Eb>>2]=fb;c[(c[Fb>>2]|0)+4>>2]=Ha;c[hb+16>>2]=(c[Ha+16>>2]|0)+(c[fb+16>>2]|0);Db=gb}}while(0);yb=Db;zb=(Db|0)==0?12:0}}while(0);Ga=eb+1|0;if((Ga|0)<(S|0)&(zb|0)==0){eb=Ga;fb=yb}else{Gb=0;Hb=yb;Ib=zb;break j}}}while(1){fb=R+(wb<<2)|0;eb=c[(c[fb>>2]|0)+4>>2]|0;Ga=c[eb>>2]|0;Fa=eb+4|0;gb=c[Fa>>2]|0;do{if((Ga|0)<(ub|0)){Ha=gb+1|0;Jb=(Ha|0)<(ub|0)?ub:Ha;Kb=vb;Lb=xb;Mb=0}else{if((Ga|0)<=(vb|0)){Ha=gb+1|0;Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb>>2]=vb;c[Fa>>2]=Ga+ -1;Ha=gb+1|0;if((eb|0)==0){Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb+8>>2]=c[x>>2];if(V){hb=cT(c[w>>2]|0,0,0,0,Ra)|0;Ea=eb+16|0;c[Ea>>2]=hb;if((hb|0)==0){Ab=R;Bb=xb;Cb=12;break i}iU(hb|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(W<<2)>>2]=0}else{c[eb+16>>2]=0}if((xb|0)==0){Jb=Ha;Kb=Ha;Lb=c[fb>>2]|0;Mb=0;break}Ea=c[w>>2]|0;hb=c[fb>>2]|0;Fb=cT(Ea,0,0,1,32)|0;Eb=Fb;do{if((Fb|0)==0){Nb=0}else{Ob=cT(Ea,0,0,1,8)|0;Qb=Fb+4|0;c[Qb>>2]=Ob;if((Ob|0)==0){Nb=0;break}c[Fb>>2]=3;c[Fb+8>>2]=-1;c[Fb+12>>2]=-1;c[Ob>>2]=xb;c[(c[Qb>>2]|0)+4>>2]=hb;c[Fb+16>>2]=(c[hb+16>>2]|0)+(c[xb+16>>2]|0);Nb=Eb}}while(0);Jb=Ha;Kb=Ha;Lb=Nb;Mb=(Nb|0)==0?12:0}}while(0);fb=wb+1|0;if((fb|0)<(S|0)&(Mb|0)==0){ub=Jb;vb=Kb;wb=fb;xb=Lb}else{Gb=Kb;Hb=Lb;Ib=Mb;break}}}else{Gb=0;Hb=0;Ib=0}}while(0);if((Ib|0)!=0|ha^1){Ab=R;Bb=Hb;Cb=Ib;break}za=c[w>>2]|0;Ra=c[x>>2]|0;V=cT(za,0,0,1,32)|0;fb=V;if((V|0)==0){Ab=R;Bb=Hb;Cb=12;break}eb=cT(za,0,0,1,20)|0;c[V+4>>2]=eb;if((eb|0)==0){Ab=R;Bb=Hb;Cb=12;break}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[eb>>2]=Gb;c[eb+4>>2]=1114111;c[eb+8>>2]=Ra;if((W|0)>0){Ra=W<<2;za=cT(c[w>>2]|0,0,0,0,Ra+4|0)|0;gb=eb+16|0;c[gb>>2]=za;if((za|0)==0){Ab=R;Bb=Hb;Cb=12;break}iU(za|0,z|0,Ra|0)|0;c[(c[gb>>2]|0)+(W<<2)>>2]=0}else{c[eb+16>>2]=0}if((Hb|0)==0){Ab=R;Bb=fb;Cb=0;break}eb=c[w>>2]|0;gb=cT(eb,0,0,1,32)|0;Ra=gb;do{if((gb|0)==0){Rb=0}else{za=cT(eb,0,0,1,8)|0;Ga=gb+4|0;c[Ga>>2]=za;if((za|0)==0){Rb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[za>>2]=Hb;c[(c[Ga>>2]|0)+4>>2]=fb;c[gb+16>>2]=(c[V+16>>2]|0)+(c[Hb+16>>2]|0);Rb=Ra}}while(0);Ab=R;Bb=Rb;Cb=(Rb|0)==0?12:0}else if((U|0)==112){U=0;c[Sa+(S<<2)>>2]=0;Aa=Sa;Ba=Na;Ca=12;U=140}else if((U|0)==141){U=0;c[q>>2]=Na;Ab=mb;Bb=0;Cb=12}}while(0);if((U|0)==140){U=0;c[q>>2]=Ba;Ab=Aa;Bb=0;Cb=Ca}FT(Ab);c[x>>2]=(c[x>>2]|0)+1;if((Cb|0)==0){Y=M;Z=Bb;_=0;break c}else{T=Cb;U=294;break b}break};case 46:{S=(c[v>>2]&4|0)==0;R=c[w>>2]|0;W=c[x>>2]|0;ia=cT(R,0,0,1,32)|0;Ra=ia;V=(ia|0)==0;if(S){if(V){T=12;U=294;break b}S=cT(R,0,0,1,20)|0;c[ia+4>>2]=S;if((S|0)==0){T=12;U=294;break b}c[ia>>2]=0;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[S>>2]=0;c[S+4>>2]=1114111;c[S+8>>2]=W;Sb=Ra;Tb=(c[x>>2]|0)+1|0}else{if(V){T=12;U=294;break b}V=cT(R,0,0,1,20)|0;c[ia+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[ia>>2]=0;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[V>>2]=0;c[V+4>>2]=9;c[V+8>>2]=W;W=c[w>>2]|0;V=(c[x>>2]|0)+1|0;R=cT(W,0,0,1,32)|0;if((R|0)==0){T=12;U=294;break b}S=cT(W,0,0,1,20)|0;c[R+4>>2]=S;if((S|0)==0){T=12;U=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[S>>2]=11;c[S+4>>2]=1114111;c[S+8>>2]=V;V=c[w>>2]|0;S=cT(V,0,0,1,32)|0;if((S|0)==0){T=12;U=294;break b}W=cT(V,0,0,1,8)|0;V=S+4|0;c[V>>2]=W;if((W|0)==0){T=12;U=294;break b}c[S>>2]=3;c[S+8>>2]=-1;c[S+12>>2]=-1;c[W>>2]=Ra;c[(c[V>>2]|0)+4>>2]=R;c[S+16>>2]=(c[R+16>>2]|0)+(c[ia+16>>2]|0);Sb=S;Tb=(c[x>>2]|0)+2|0}c[x>>2]=Tb;c[q>>2]=(c[q>>2]|0)+1;Y=M;Z=Sb;_=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}S=US(m,5)|0;if((S|0)!=0){$=M;aa=S;U=6;break b}}S=c[w>>2]|0;ia=cT(S,0,0,1,32)|0;if((ia|0)==0){T=12;U=294;break b}R=cT(S,0,0,1,20)|0;c[ia+4>>2]=R;if((R|0)==0){T=12;U=294;break b}c[ia>>2]=0;c[ia+8>>2]=-1;c[ia+12>>2]=-1;c[R>>2]=-2;c[R+4>>2]=1;c[R+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;Y=M;Z=ia;_=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){Ub=Q;U=74}break};case 92:{ia=Q+1|0;R=a[ia]|0;do{if((c[v>>2]&1|0)==0){if(R<<24>>24==40){c[q>>2]=ia;Ub=ia;U=74;break d}else{S=a[Q+1|0]|0;if(S<<24>>24==41){U=265;break d}else{Vb=S;break}}}else{Vb=R}}while(0);R=Q+1|0;ia=Vb<<24>>24==0;if(ia){T=5;U=294;break b}else{Wb=107596|0;Xb=0}while(1){S=Xb+1|0;if((a[107592+(Xb<<3)|0]|0)==Vb<<24>>24){Yb=Wb;break}V=107596+(S<<3)|0;if((S|0)==12){Yb=V;break}else{Wb=V;Xb=S}}S=c[Yb>>2]|0;if((S|0)!=0){V=F+0|0;Ra=G+0|0;W=V+40|0;do{c[V>>2]=c[Ra>>2];V=V+4|0;Ra=Ra+4|0}while((V|0)<(W|0));c[H>>2]=S;c[I>>2]=1;Ra=NS(j)|0;if((Ra|0)!=0){T=Ra;U=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];Y=M;Z=c[K>>2]|0;_=0;break c}if(ia){T=5;U=294;break b}c[q>>2]=R;Ra=a[R]|0;k:do{switch(Ra|0){case 120:{V=Q+2|0;c[q>>2]=V;W=a[V]|0;if(W<<24>>24==123){V=Q+3|0;c[q>>2]=V;gb=V;V=0;while(1){fb=a[gb]|0;if(fb<<24>>24==0|fb<<24>>24==125){_b=V;$b=gb;break}if((AS(fb<<24>>24)|0)==0){T=9;U=294;break b}fb=c[q>>2]|0;a[l+V|0]=a[fb]|0;eb=V+1|0;ha=fb+1|0;c[q>>2]=ha;if(eb>>>0>31){_b=eb;$b=ha;break}else{gb=ha;V=eb}}c[q>>2]=$b+1;a[l+_b|0]=0;V=Pb(C|0,0,16)|0;gb=c[w>>2]|0;eb=c[x>>2]|0;ha=cT(gb,0,0,1,32)|0;fb=ha;do{if((ha|0)==0){ac=0}else{Ga=cT(gb,0,0,1,20)|0;c[ha+4>>2]=Ga;if((Ga|0)==0){ac=0;break}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Ga>>2]=V;c[Ga+4>>2]=V;c[Ga+8>>2]=eb;ac=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;bc=ac;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;fb=(AS(W<<24>>24)|0)==0;eb=c[q>>2]|0;if(fb){cc=eb}else{a[D]=a[eb]|0;fb=eb+1|0;c[q>>2]=fb;cc=fb}if((AS(a[cc]|0)|0)!=0){fb=c[q>>2]|0;a[E]=a[fb]|0;c[q>>2]=fb+1}fb=Pb(D|0,0,16)|0;eb=c[w>>2]|0;V=c[x>>2]|0;ha=cT(eb,0,0,1,32)|0;gb=ha;do{if((ha|0)==0){dc=0}else{Ga=cT(eb,0,0,1,20)|0;c[ha+4>>2]=Ga;if((Ga|0)==0){dc=0;break}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Ga>>2]=fb;c[Ga+4>>2]=fb;c[Ga+8>>2]=V;dc=gb}}while(0);c[x>>2]=(c[x>>2]|0)+1;bc=dc;break k}break};case 98:{gb=c[w>>2]|0;V=cT(gb,0,0,1,32)|0;fb=V;do{if((V|0)==0){ec=0}else{ha=cT(gb,0,0,1,20)|0;c[V+4>>2]=ha;if((ha|0)==0){ec=0;break}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ha>>2]=-2;c[ha+4>>2]=64;c[ha+8>>2]=-1;ec=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;bc=ec;break};case 66:{fb=c[w>>2]|0;V=cT(fb,0,0,1,32)|0;gb=V;do{if((V|0)==0){fc=0}else{ha=cT(fb,0,0,1,20)|0;c[V+4>>2]=ha;if((ha|0)==0){fc=0;break}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ha>>2]=-2;c[ha+4>>2]=128;c[ha+8>>2]=-1;fc=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;bc=fc;break};case 60:{gb=c[w>>2]|0;V=cT(gb,0,0,1,32)|0;fb=V;do{if((V|0)==0){gc=0}else{ha=cT(gb,0,0,1,20)|0;c[V+4>>2]=ha;if((ha|0)==0){gc=0;break}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ha>>2]=-2;c[ha+4>>2]=16;c[ha+8>>2]=-1;gc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;bc=gc;break};case 62:{fb=c[w>>2]|0;V=cT(fb,0,0,1,32)|0;gb=V;do{if((V|0)==0){hc=0}else{ha=cT(fb,0,0,1,20)|0;c[V+4>>2]=ha;if((ha|0)==0){hc=0;break}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ha>>2]=-2;c[ha+4>>2]=32;c[ha+8>>2]=-1;hc=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;bc=hc;break};default:{if((tS(Ra)|0)!=0){gb=(a[c[q>>2]|0]|0)+ -48|0;V=c[w>>2]|0;fb=c[x>>2]|0;ha=cT(V,0,0,1,32)|0;if((ha|0)==0){T=12;U=294;break b}eb=cT(V,0,0,1,20)|0;c[ha+4>>2]=eb;if((eb|0)==0){T=12;U=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[eb>>2]=-4;c[eb+4>>2]=gb;c[eb+8>>2]=fb;c[x>>2]=(c[x>>2]|0)+1;fb=c[B>>2]|0;c[B>>2]=(gb|0)<(fb|0)?fb:gb;c[q>>2]=(c[q>>2]|0)+1;Y=M;Z=ha;_=0;break c}ha=c[w>>2]|0;gb=a[c[q>>2]|0]|0;fb=c[x>>2]|0;eb=cT(ha,0,0,1,32)|0;V=eb;do{if((eb|0)==0){ic=0}else{W=cT(ha,0,0,1,20)|0;c[eb+4>>2]=W;if((W|0)==0){ic=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[W>>2]=gb;c[W+4>>2]=gb;c[W+8>>2]=fb;ic=V}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;bc=ic}}}while(0);if((bc|0)==0){T=12;U=294;break b}else{Y=M;Z=bc;_=0;break c}break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}Ra=c[w>>2]|0;R=cT(Ra,0,0,1,32)|0;if((R|0)==0){T=12;U=294;break b}ia=cT(Ra,0,0,1,20)|0;c[R+4>>2]=ia;if((ia|0)==0){T=12;U=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ia>>2]=-2;c[ia+4>>2]=2;c[ia+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;Y=M;Z=R;_=0;break c;break};case 63:case 43:case 123:case 124:case 42:{U=264;break};case 0:{U=265;break};case 41:{if((M|0)!=0){U=264}break};default:{}}}while(0);if((U|0)==74){U=0;ba=M+1|0;c[q>>2]=Ub+1;R=US(m,c[y>>2]|0)|0;if((R|0)!=0){$=ba;aa=R;U=6;break b}R=US(m,2)|0;if((R|0)!=0){$=ba;aa=R;U=6;break b}R=US(m,0)|0;if((R|0)!=0){$=ba;aa=R;U=6;break b}c[y>>2]=(c[y>>2]|0)+1;Y=ba;Z=N;_=0;break c}else if((U|0)==264){U=0;if((c[v>>2]&1|0)!=0){U=265}}if((U|0)==265){U=0;ba=c[w>>2]|0;R=cT(ba,0,0,1,32)|0;if((R|0)==0){T=12;U=294;break b}ia=cT(ba,0,0,1,20)|0;c[R+4>>2]=ia;if((ia|0)==0){T=12;U=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ia>>2]=-1;c[ia+4>>2]=-1;c[ia+8>>2]=-1;Y=M;Z=R;_=0;break c}R=IS(h,Q,-1)|0;if((R|0)<0){c[h>>2]=-1;jc=1}else{jc=R}do{if((c[v>>2]&2|0)==0){U=280}else{if((zS(c[h>>2]|0)|0)==0){if((vS(c[h>>2]|0)|0)==0){U=280;break}}R=c[w>>2]|0;ia=BS(c[h>>2]|0)|0;ba=BS(c[h>>2]|0)|0;Ra=c[x>>2]|0;S=cT(R,0,0,1,32)|0;if((S|0)==0){T=12;U=294;break b}V=cT(R,0,0,1,20)|0;c[S+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[V>>2]=ia;c[V+4>>2]=ba;c[V+8>>2]=Ra;Ra=c[w>>2]|0;V=DS(c[h>>2]|0)|0;ba=DS(c[h>>2]|0)|0;ia=c[x>>2]|0;R=cT(Ra,0,0,1,32)|0;if((R|0)==0){T=12;U=294;break b}fb=cT(Ra,0,0,1,20)|0;c[R+4>>2]=fb;if((fb|0)==0){T=12;U=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[fb>>2]=V;c[fb+4>>2]=ba;c[fb+8>>2]=ia;ia=c[w>>2]|0;fb=cT(ia,0,0,1,32)|0;if((fb|0)==0){T=12;U=294;break b}ba=cT(ia,0,0,1,8)|0;ia=fb+4|0;c[ia>>2]=ba;if((ba|0)==0){T=12;U=294;break b}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ba>>2]=S;c[(c[ia>>2]|0)+4>>2]=R;c[fb+16>>2]=(c[R+16>>2]|0)+(c[S+16>>2]|0);kc=fb}}while(0);if((U|0)==280){U=0;Q=c[w>>2]|0;fb=c[h>>2]|0;S=c[x>>2]|0;R=cT(Q,0,0,1,32)|0;if((R|0)==0){T=12;U=294;break b}ia=cT(Q,0,0,1,20)|0;c[R+4>>2]=ia;if((ia|0)==0){T=12;U=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ia>>2]=fb;c[ia+4>>2]=fb;c[ia+8>>2]=S;kc=R}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;Y=M;Z=kc;_=0;break};default:{Y=M;Z=N;_=0}}}while(0);P=c[n>>2]|0;O=(_|0)==0;if((P|0)>(o|0)&O){L=P;M=Y;N=Z}else{lc=O;mc=Y;nc=Z;oc=_;break a}}if((U|0)==6){lc=(aa|0)==0;mc=$;nc=N;oc=aa;break}else if((U|0)==294){i=d;return T|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){T=p?8:oc;i=d;return T|0}c[b+8>>2]=nc;T=0;i=d;return T|0}function OS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=ET((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=ET((l<<2)+4|0)|0;if((p|0)==0){FT(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}US(d,e)|0;e=US(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 5:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(!k){G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break b}E=c[F+4>>2]|0;c[F+20>>2]=(c[(c[E+4>>2]|0)+20>>2]|0)+(c[(c[E>>2]|0)+20>>2]|0);G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 4:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;G=v;H=w;I=c[D+(E<<2)>>2]|0;J=y;K=z;L=A;M=0;N=(F|0)>-1?F:B;break};case 3:{F=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;O=c[D+(u+ -4<<2)>>2]|0;P=u+ -5|0;c[h>>2]=P;if(k){Q=c[O+4>>2]|0;R=O+16|0;c[O+20>>2]=(c[(c[Q>>2]|0)+20>>2]|0)+(c[D+(P<<2)>>2]|0)+(c[(c[Q+4>>2]|0)+20>>2]|0)+((c[R>>2]|0)>0?2:0);S=R;T=c[h>>2]|0}else{S=O+16|0;T=P}P=c[D+(T+ -1<<2)>>2]|0;O=T+ -2|0;c[h>>2]=O;R=c[D+(O<<2)>>2]|0;O=T+ -3|0;c[h>>2]=O;Q=c[D+(O<<2)>>2]|0;if((c[S>>2]|0)<=0){G=1;H=w;I=x;J=y;K=z;L=P;M=0;N=B;break b}if(k){U=0}else{XS(b,F,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;R=XS(b,E,Q)|0;c[(c[r>>2]|0)+(Q<<2)>>2]=1;U=R}G=1;H=w;I=x;J=y;K=z+2|0;L=P;M=U;N=B;break};case 2:{P=A;while(1){if((c[P>>2]|0)>-1){P=P+4|0}else{G=v;H=w;I=x;J=y;K=z;L=P;M=0;N=B;break}}break};case 1:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;if(k){P=c[(c[c[R+4>>2]>>2]|0)+20>>2]|0;Q=u+ -3|0;c[h>>2]=Q;c[R+20>>2]=(c[D+(Q<<2)>>2]|0)+P;G=v;H=-1;I=x;J=y;K=z;L=A;M=0;N=B;break b}else{P=u+ -3|0;c[h>>2]=P;Q=c[D+(P<<2)>>2]|0;P=u+ -4|0;c[h>>2]=P;R=(Q|0)==0;G=R&1;H=R?w:c[D+(P<<2)>>2]|0;I=x;J=y;K=z;L=A;M=0;N=B;break b}break};case 0:{P=u+ -2|0;c[h>>2]=P;R=c[D+(P<<2)>>2]|0;P=R;Q=R+12|0;E=c[Q>>2]|0;if((E|0)>-1){F=0;do{V=A+(F<<2)|0;F=F+1|0}while((c[V>>2]|0)>-1);c[V>>2]=E<<1;c[A+(F<<2)>>2]=-1;do{if(!k){O=0;while(1){if((c[p+(O<<2)>>2]|0)>-1){O=O+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((O|0)<=0){break}W=ET((O<<2)+4|0)|0;X=W;if((W|0)==0){Y=w;Z=y;_=z;$=A;aa=12;ba=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=X;ca=c[p>>2]|0;if((ca|0)>-1){da=X;ea=ca;ca=0;while(1){c[da>>2]=ea;fa=ca+1|0;ga=c[p+(fa<<2)>>2]|0;ha=W+(fa<<2)|0;if((ga|0)>-1){ca=fa;ea=ga;da=ha}else{ia=ha;break}}}else{ia=X}c[ia>>2]=-1}}while(0);E=US(d,c[Q>>2]|0)|0;if((E|0)!=0){Y=w;Z=y;_=z;$=A;aa=E;ba=B;break a}E=US(d,6)|0;if((E|0)!=0){Y=w;Z=y;_=z;$=A;aa=E;ba=B;break a}}E=c[R>>2]|0;do{if((E|0)==3){F=c[R+4>>2]|0;da=c[F>>2]|0;ea=c[F+4>>2]|0;F=(c[A>>2]|0)>-1;ca=x+1|0;W=US(d,F?ca:x)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=US(d,F?x:B)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=US(d,A)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=US(d,(c[A>>2]|0)>>>31^1)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=US(d,R)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=ea;ea=US(d,W)|0;if((ea|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ea;pa=B;break}ea=da;da=US(d,ea)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,3)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,W)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,0)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,2)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,ea)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=US(d,0)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}if((c[A>>2]|0)>-1){if(k){qa=w;ra=y;sa=0}else{da=WS(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;W=0;while(1){ta=ea+(W<<2)|0;ua=W+1|0;if((c[ta>>2]|0)>-1){W=ua}else{break}}c[ta>>2]=B;c[ea+(ua<<2)>>2]=w;c[ea+(W+2<<2)>>2]=-1;va=-1;wa=y+1|0}else{va=w;wa=y}X=c[A>>2]|0;if((X|0)>-1){F=c[s>>2]|0;O=X;X=0;do{ha=(O|0)/2|0;if((O&1|0)==0){c[F+(ha*12|0)>>2]=B}else{c[F+(ha*12|0)+4>>2]=B}X=X+1|0;O=c[A+(X<<2)>>2]|0;}while((O|0)>-1)}c[A>>2]=-1;qa=va;ra=wa;sa=da}c[A>>2]=-1;xa=qa;ya=ca;za=ra;Aa=z+1|0;Ba=sa;Ca=x}else{xa=w;ya=x;za=y;Aa=z;Ba=0;Ca=B}if((c[R+16>>2]|0)<=0){ja=v;ka=xa;la=ya;ma=za;na=Aa;oa=Ba;pa=Ca;break}ja=v;ka=xa;la=ya+2|0;ma=za;na=Aa;oa=Ba;pa=ya+1|0}else if((E|0)==1){O=c[R+4>>2]|0;X=c[O>>2]|0;F=c[O+4>>2]|0;O=US(d,R)|0;if((O|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=O;pa=B;break}O=US(d,5)|0;if((O|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=O;pa=B;break}O=US(d,F)|0;if((O|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=O;pa=B;break}O=US(d,0)|0;if((O|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=O;pa=B;break}O=X+20|0;W=US(d,(c[O>>2]|0)+x|0)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}if((c[O>>2]|0)>0){O=(c[F+20>>2]|0)>0;Da=(O&1)+x|0;Ea=O?x:-1}else{Da=x;Ea=-1}O=US(d,Ea)|0;if((O|0)!=0){ja=v;ka=w;la=Da;ma=y;na=z;oa=O;pa=B;break}O=US(d,4)|0;if((O|0)!=0){ja=v;ka=w;la=Da;ma=y;na=z;oa=O;pa=B;break}O=US(d,X)|0;if((O|0)!=0){ja=v;ka=w;la=Da;ma=y;na=z;oa=O;pa=B;break}ja=v;ka=w;la=Da;ma=y;na=z;oa=US(d,0)|0;pa=B}else if((E|0)==2){O=c[R+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Fa=1}else{Fa=a[O+12|0]&1}X=US(d,Fa)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}}else{X=US(d,B)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}X=US(d,a[O+12|0]&1)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}}X=US(d,R)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}X=US(d,1)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}X=US(d,c[O>>2]|0)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}X=US(d,0)|0;if((X|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=X;pa=B;break}if(!((c[A>>2]|0)>-1)){if((a[O+12|0]&1)==0){ja=0;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}}if(k){Ga=w;Ha=y;Ia=0}else{X=WS(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[O+12|0]&1)==0?v:1;if((w|0)>-1){O=c[t>>2]|0;F=0;while(1){Ja=O+(F<<2)|0;Ka=F+1|0;if((c[Ja>>2]|0)>-1){F=Ka}else{break}}c[Ja>>2]=B;c[O+(Ka<<2)>>2]=w;c[O+(F+2<<2)>>2]=-1;La=-1;Ma=y+1|0}else{La=w;Ma=y}ca=c[A>>2]|0;if((ca|0)>-1){da=c[s>>2]|0;W=ca;ca=0;do{ea=(W|0)/2|0;if((W&1|0)==0){c[da+(ea*12|0)>>2]=B}else{c[da+(ea*12|0)+4>>2]=B}ca=ca+1|0;W=c[A+(ca<<2)>>2]|0;}while((W|0)>-1)}c[A>>2]=-1;Ga=La;Ha=Ma;Ia=X}c[A>>2]=-1;ja=0;ka=Ga;la=x+1|0;ma=Ha;na=z+1|0;oa=Ia;pa=x}else if((E|0)==0){W=c[c[R+4>>2]>>2]|0;if(!((W|0)>-1|(W|0)==-4)){ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}if(!((c[A>>2]|0)>-1)){ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}if(k){c[R+20>>2]=1;Na=w;Oa=y;Pa=0}else{W=WS(b,P,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ca=c[t>>2]|0;da=0;while(1){Qa=ca+(da<<2)|0;Ra=da+1|0;if((c[Qa>>2]|0)>-1){da=Ra}else{break}}c[Qa>>2]=B;c[ca+(Ra<<2)>>2]=w;c[ca+(da+2<<2)>>2]=-1;Sa=-1;Ta=y+1|0}else{Sa=w;Ta=y}X=c[A>>2]|0;if((X|0)>-1){F=c[s>>2]|0;O=X;X=0;do{ea=(O|0)/2|0;if((O&1|0)==0){c[F+(ea*12|0)>>2]=B}else{c[F+(ea*12|0)+4>>2]=B}X=X+1|0;O=c[A+(X<<2)>>2]|0;}while((O|0)>-1)}c[A>>2]=-1;Na=Sa;Oa=Ta;Pa=W}c[A>>2]=-1;ja=v;ka=Na;la=x+1|0;ma=Oa;na=z+1|0;oa=Pa;pa=x}else{ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B}}while(0);P=c[Q>>2]|0;if((P|0)>-1){Ua=0}else{G=ja;H=ka;I=la;J=ma;K=na;L=A;M=oa;N=pa;break b}do{Va=p+(Ua<<2)|0;Ua=Ua+1|0}while((c[Va>>2]|0)>-1);c[Va>>2]=P;c[p+(Ua<<2)>>2]=-1;G=ja;H=ka;I=la;J=ma;K=na;L=A;M=oa;N=pa;break};case 6:{Q=u+ -2|0;c[h>>2]=Q;R=c[D+(Q<<2)>>2]|0;Q=0;do{Wa=A+(Q<<2)|0;Q=Q+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=R<<1|1;c[A+(Q<<2)>>2]=-1;P=0;while(1){if((c[p+(P<<2)>>2]|0)>-1){P=P+1|0}else{break}}c[p+(P+ -1<<2)>>2]=-1;G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};default:{G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(M|0)==0){u=D;v=G;w=H;x=I;y=J;z=K;A=L;B=N}else{Y=H;Z=J;_=K;$=L;aa=M;ba=N;break a}}}else{Y=-1;Z=0;_=0;$=n;aa=e;ba=0}}while(0);do{if(k){Xa=Z}else{e=c[$>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;N=e;e=0;do{M=(N|0)/2|0;if((N&1|0)==0){c[n+(M*12|0)>>2]=ba}else{c[n+(M*12|0)+4>>2]=ba}e=e+1|0;N=c[$+(e<<2)>>2]|0;}while((N|0)>-1)}c[$>>2]=-1;if(!((Y|0)>-1)){Xa=Z;break}N=c[f+36>>2]|0;e=0;while(1){Ya=N+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ba;c[N+(Za<<2)>>2]=Y;c[N+(e+2<<2)>>2]=-1;Xa=Z+1|0}}while(0);c[f+48>>2]=_;c[f+40>>2]=_;c[f+44>>2]=Xa;FT(m);FT(p);o=aa;i=g;return o|0}function PS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=PS(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=RS(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=PS(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else if((a|0)==2){n=c[g+4>>2]|0;j=n;if(!((c[n+8>>2]|0)==-1)){m=j;break}h=c[n>>2]|0;n=RS(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function QS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{FT(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}FT(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){FT(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){FT(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}FT(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{FT(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}FT(m)}m=c[d+32>>2]|0;if((m|0)!=0){FT(m)}m=c[d+20>>2]|0;if((m|0)!=0){FT(m)}m=c[d+36>>2]|0;if((m|0)!=0){FT(m)}FT(d);i=b;return}function RS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=ET(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){FT(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=ET((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function SS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=cT(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=cT(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=cT(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function TS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=US(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}s=US(a,r)|0}else if((q|0)==0){r=c[o+4>>2]|0;t=c[r>>2]|0;if((t|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((t|0)==-3)){continue a}t=c[r+4>>2]|0;if(!((t|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){u=r;v=d;w=0;while(1){x=w+1|0;if((u|0)==(t|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((t|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=t;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){t=c[o+4>>2]|0;r=US(a,c[t>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}s=US(a,c[t+4>>2]|0)|0}else if((q|0)==3){t=c[o+4>>2]|0;r=c[t>>2]|0;if((c[r+8>>2]|0)!=0){s=US(a,r)|0;break}r=c[t+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}s=US(a,r)|0}else{continue a}}while(0);if((s|0)!=0){m=s;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function US(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=HT(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;US(a,b)|0;i=d;return 0}return 0}function VS(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;US(d,e)|0;e=US(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==0){y=c[u+4>>2]|0;x=c[y+8>>2]|0;D=c[y>>2]|0;E=c[y+4>>2]|0;do{if((D|0)>-1|(D|0)==-4){F=r;G=E;H=D;I=s+1|0;J=(c[g>>2]|0)+x|0}else{if(!((D|0)==-3)){F=r;G=E;H=D;I=s;J=x;break}if(!p){F=r;G=-1;H=-1;I=s;J=-1;break}if(q|(r|0)==0){F=r;G=E;H=-3;I=s;J=x;break}c[h+(E<<2)>>2]=1;F=0;G=E;H=-3;I=s;J=x}}while(0);x=cT(b,0,0,1,32)|0;E=x;do{if((x|0)==0){K=0}else{D=cT(b,0,0,1,20)|0;c[x+4>>2]=D;if((D|0)==0){K=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=H;c[D+4>>2]=G;c[D+8>>2]=J;K=E}}while(0);c[t>>2]=K;E=(K|0)==0?12:0;if((J|0)<=(c[k>>2]|0)){L=F;M=I;N=t;O=E;break}c[k>>2]=J;L=F;M=I;N=t;O=E}else if((z|0)==2){E=c[u+4>>2]|0;x=US(d,c[E>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=US(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[E>>2]|0;D=c[E+4>>2]|0;y=c[E+8>>2]|0;P=a[E+12|0]|0;E=cT(b,0,0,1,32)|0;if((E|0)==0){Q=40;break b}R=cT(b,0,0,1,16)|0;S=E+4|0;c[S>>2]=R;if((R|0)==0){Q=40;break b}c[E>>2]=2;c[E+8>>2]=-1;c[E+12>>2]=-1;c[R>>2]=x;c[R+4>>2]=D;c[R+8>>2]=y;y=R+12|0;a[y]=a[y]&-2|P&1;c[E+16>>2]=c[x+16>>2];c[t>>2]=E;A=s;B=r;t=c[S>>2]|0;s=A;r=B;continue b}else if((z|0)==3){S=c[u+4>>2]|0;E=c[S>>2]|0;x=S+4|0;P=c[x>>2]|0;y=cT(b,0,0,1,32)|0;if((y|0)==0){Q=20;break b}R=cT(b,0,0,1,8)|0;D=y+4|0;c[D>>2]=R;if((R|0)==0){Q=20;break b}c[y>>2]=3;c[y+8>>2]=-1;c[y+12>>2]=-1;c[R>>2]=E;c[(c[D>>2]|0)+4>>2]=P;c[y+16>>2]=(c[P+16>>2]|0)+(c[E+16>>2]|0);c[t>>2]=y;y=c[D>>2]|0;D=US(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,y+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=y;O=US(d,0)|0}else if((z|0)==1){y=c[u+4>>2]|0;D=c[y>>2]|0;S=y+4|0;x=c[S>>2]|0;E=cT(b,0,0,1,32)|0;if((E|0)==0){Q=29;break b}P=cT(b,0,0,1,8)|0;R=E+4|0;c[R>>2]=P;if((P|0)==0){Q=29;break b}c[E>>2]=1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[P>>2]=D;c[(c[R>>2]|0)+4>>2]=x;c[E+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=E;E=c[R>>2]|0;c[E>>2]=0;R=E+4|0;c[R>>2]=0;D=US(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,R)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=US(d,c[y>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=E;O=US(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((O|0)==0){r=L;s=M;t=N}else{v=M;w=O;break a}}if((Q|0)==20){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==29){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function WS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=cT(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=cT(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=cT(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=cT(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function XS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=cT(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=cT(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=cT(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=cT(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function YS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function ZS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=107840}else{j=b;k=107840;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((gU(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Fc(e|0,f|0,108128,g|0)|0)+1|0;i=d;return h|0}



function Gx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Rq(3);u=b;v=cc(c[u>>2]|0,61296)|0;if((v|0)==0){Hx(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Id(c[(Gc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Cp(w,61304,q)}kc(61360,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];jd(v|0,61408,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];jd(v|0,61432,o|0)|0;kc(61456,40,1,v|0)|0;kc(61504,11,1,v|0)|0;kc(61520,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];Ix(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Ed(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{kc(61536,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;Ix(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Ed(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];jd(v|0,61560,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;Ix(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Ed(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];jd(v|0,61560,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;Ix(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Ed(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];jd(v|0,61560,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;Ix(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Ed(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];jd(v|0,61560,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;Ix(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Ed(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];jd(v|0,61560,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;Ix(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Ed(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];jd(v|0,61560,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;Ix(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Ed(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}Hx(t);if((Qc(v|0)|0)==0){FT(c[r>>2]|0);c[r>>2]=0;Uq(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Cp(e,61576,f)}}function Hx(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}FT(a);c[d>>2]=0;i=b;return}function Ix(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];jd(a|0,61624,f|0)|0;i=e;return}function Jx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=KT(192)|0;kU(m|0,0,192)|0;Kx(m);c[a+12>>2]=m;n=m;o=a;fu(n,c[o>>2]|0,36);if(kK(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Cp(a,61664,g)}else{g=m;PL(g,61640,14)|0;QL(h,g);a=sv(h)|0;h=m+184|0;c[h>>2]=a;PL(g,61656,4)|0;Lx(n,b+8|0);QL(j,g);b=sv(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;eu(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];RL(g,f)|0;Mx(n,-4-m+b|0);b=c[j>>2]|0;eu(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];RL(g,e)|0;Uq(3);i=d;return}}function Kx(a){a=a|0;var b=0;b=i;dy(a);i=b;return}function Lx(a,b){a=a|0;b=b|0;var c=0;c=i;Ox(a,3);Px(a,61840);Ox(a,0);Px(a,61848);Ox(a,2);_x(a,b);$x(a,b);Px(a,61856);Ox(a,0);i=c;return}function Mx(a,b){a=a|0;b=b|0;var d=0;d=i;c[15458]=td(b|0)|0;PL(a,61832,4)|0;i=d;return}function Nx(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;QL(l,q);r=sv(l)|0;Mx(b,0);QL(m,q);l=sv(m)|0;Ox(b,1);Px(b,61728);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;Qx(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);Rx(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{Rx(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{Sx(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{Tx(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{Px(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}QL(n,q);u=sv(n)|0;n=hU(0,r|0,32)|0;eu(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];RL(q,k)|0;Mx(b,u-l|0);eu(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];RL(q,j)|0;i=g;return}function Ox(b,d){b=b|0;d=d|0;var e=0;e=i;a[61816]=-33;c[15456]=td(d|0)|0;d=b;PL(d,61816,1)|0;PL(d,61824,4)|0;i=e;return}function Px(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=td(gU(d|0)|0)|0;a[61808]=-37;g=b;PL(g,61808,1)|0;PL(g,f,4)|0;PL(g,d,gU(d|0)|0)|0;i=e;return}function Qx(b,d){b=b|0;d=d|0;var e=0;e=i;a[61792]=-35;c[15450]=td(d|0)|0;d=b;PL(d,61792,1)|0;PL(d,61800,4)|0;i=e;return}function Rx(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[61776]=-53;Zx(c);e=b;PL(e,61776,1)|0;PL(e,61784,8)|0;i=d;return}function Sx(b,d){b=b|0;d=d|0;var e=0;e=i;a[61760]=-46;c[15442]=td(d|0)|0;d=b;PL(d,61760,1)|0;PL(d,61768,4)|0;i=e;return}function Tx(b,c){b=b|0;c=c|0;var d=0;d=i;a[61752]=c?-61:-62;PL(b,61752,1)|0;i=d;return}function Ux(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;Nx(e,+h[f>>3],a,f);Nx(e,+h[b+248>>3],a,f);i=d;return}function Vx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;QL(j,p);o=sv(j)|0;Mx(b,0);QL(k,p);j=sv(k)|0;Ox(b,1);Px(b,61736);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;Qx(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;Rx(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{Rx(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{Sx(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{Tx(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{Px(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}QL(l,p);s=sv(l)|0;l=hU(0,o|0,32)|0;eu(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];RL(p,g)|0;Mx(b,s-j|0);eu(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];RL(p,f)|0;i=e;return}function Wx(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;_t(a);Rq(3);if((a|0)!=0){Xx(a);MT(a)}c[d>>2]=0;Uq(3);i=b;return}function Xx(a){a=a|0;var b=0;b=i;Yx(a);i=b;return}function Yx(a){a=a|0;var b=0;b=i;vv(a);i=b;return}function Zx(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((td(1)|0)==1){f=e;g=c[f+4>>2]|0;j=61784;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[61784+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function _x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;Px(a,61728);Ox(a,4);Px(a,61864);Ox(a,0);Px(a,61872);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;Qx(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);Px(a,61880);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{Px(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{Px(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{Px(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{Px(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=61968;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];ay(a,b,e);Px(a,61904);Ox(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);by(a,61880,61912);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;by(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;by(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;by(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;by(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function $x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;Px(a,61736);Ox(a,4);Px(a,61864);Ox(a,0);Px(a,61872);o=g+1+j+l+n|0;Qx(a,o);Px(a,61880);if((c[f>>2]|0)>0){n=b;l=0;do{Px(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{Px(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{Px(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{Px(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=61888;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];ay(a,b,e);Px(a,61904);Ox(a,o);by(a,61880,61912);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;by(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;by(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;by(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;by(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function ay(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;Px(b,61936);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}Ox(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?61880:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}cy(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?61880:w;if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}cy(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?61880:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}cy(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?61880:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}cy(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function by(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Px(a,b);Ox(a,1);Px(a,61920);Px(a,c);i=d;return}function cy(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Px(a,b);Ox(a,d?2:1);Px(a,61944);Px(a,c);if(!d){i=e;return}Px(a,61952);Px(a,61960);i=e;return}function dy(a){a=a|0;var b=0;b=i;lx(a);i=b;return}function ey(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;tJ(e,61984);pJ(d,gy(a,e)|0);fy(d,b+4|0);zJ(d);zJ(e);tJ(g,61992);pJ(f,gy(a,g)|0);hy(f,b);zJ(f);zJ(g);tJ(j,62008);pJ(h,gy(a,j)|0);fy(h,b+8|0);zJ(h);zJ(j);tJ(l,62024);pJ(k,gy(a,l)|0);fy(k,b+12|0);zJ(k);zJ(l);tJ(n,62040);pJ(m,gy(a,n)|0);iy(m,b+16|0,0);zJ(m);zJ(n);tJ(p,62056);pJ(o,gy(a,p)|0);iy(o,b+20|0,0);zJ(o);zJ(p);tJ(r,62072);pJ(q,gy(a,r)|0);iy(q,b+24|0,0);zJ(q);zJ(r);tJ(t,62080);pJ(s,gy(a,t)|0);iy(s,b+28|0,0);zJ(s);zJ(t);tJ(v,62096);pJ(u,gy(a,v)|0);iy(u,b+32|0,0);zJ(u);zJ(v);i=c;return}function fy(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Ap(22,0,65304,d);i=d;return}else{c[b>>2]=md(WJ(a)|0)|0;i=d;return}}function gy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=rC(a,f,b)|0;l=c[k>>2]|0;Su(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}tC(j,a,b);uC(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];sC(g,e);vC(j);j=c[f>>2]|0;wC(a,j,k,xC(g)|0);k=yC(g)|0;vC(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function hy(a,b){a=a|0;b=b|0;var d=0;d=i;if((ZJ(a,62272)|0)==0){c[b>>2]=1;i=d;return}if((ZJ(a,62280)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=yc(WJ(a)|0)|0;i=d;return}}function iy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((ZJ(a,62248)|0)==0){c[b>>2]=d}if((ZJ(a,62272)|0)==0){c[b>>2]=1;i=e;return}if((ZJ(a,62280)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=yc(WJ(a)|0)|0;i=e;return}}function jy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;tJ(j,62112);pJ(g,gy(b,j)|0);y=d+48|0;ky(g,y);zJ(g);zJ(j);tJ(m,62128);pJ(l,gy(b,m)|0);j=d+56|0;ly(l,j,0.0);zJ(l);zJ(m);tJ(o,62136);pJ(n,gy(b,o)|0);m=d+32|0;ky(n,m);zJ(n);zJ(o);tJ(q,62144);pJ(p,gy(b,q)|0);o=d+33|0;ky(p,o);zJ(p);zJ(q);tJ(s,62160);pJ(r,gy(b,s)|0);q=d+40|0;ly(r,q,1.0);zJ(r);zJ(s);tJ(u,62168);pJ(t,gy(b,u)|0);s=d+16|0;ly(t,s,-1.7976931348623157e+308);zJ(t);zJ(u);tJ(w,62176);pJ(v,gy(b,w)|0);u=d+24|0;ly(v,u,1.7976931348623157e+308);zJ(v);zJ(w);tJ(x,61984);w=WJ(gy(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?62272:62280;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?62248:62256;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?62248:62264;c[f+20>>2]=j;c[f+24>>2]=m?62248:62256;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?62248:62264;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];yp(4,0,62184,f);zJ(x);i=e;return}function ky(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(ZJ(b,62272)|0)==0|0;i=d;return}function ly(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((ZJ(a,62248)|0)==0){h[b>>3]=c;i=d;return}if((ZJ(a,62272)|0)==0){h[b>>3]=1.0;i=d;return}if((ZJ(a,62280)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+_T(WJ(a)|0);i=d;return}}function my(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;tJ(h,62112);pJ(g,gy(b,h)|0);s=d+13|0;ky(g,s);zJ(g);zJ(h);tJ(k,62128);pJ(j,gy(b,k)|0);h=d+16|0;iy(j,h,0);zJ(j);zJ(k);tJ(m,62136);pJ(l,gy(b,m)|0);k=d+12|0;ky(l,k);zJ(l);zJ(m);tJ(o,62168);pJ(n,gy(b,o)|0);m=d+4|0;iy(n,m,-2147483648);zJ(n);zJ(o);tJ(q,62176);pJ(p,gy(b,q)|0);o=d+8|0;iy(p,o,2147483647);zJ(p);zJ(q);tJ(r,61984);q=WJ(gy(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?62272:62280;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?62248:62256;c[f+8>>2]=s;c[f+12>>2]=b?62248:62264;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;yp(4,0,62288,f);zJ(r);i=e;return}function ny(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;tJ(h,62112);pJ(g,gy(b,h)|0);o=d+5|0;ky(g,o);zJ(g);zJ(h);tJ(k,62128);pJ(j,gy(b,k)|0);h=d+6|0;ky(j,h);zJ(j);zJ(k);tJ(m,62136);pJ(l,gy(b,m)|0);k=d+4|0;ky(l,k);zJ(l);zJ(m);tJ(n,61984);m=WJ(gy(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?62272:62280;h=(a[k]|0)!=0?62272:62280;c[f>>2]=m;c[f+4>>2]=b?62248:62256;c[f+8>>2]=o;c[f+12>>2]=b?62248:62264;c[f+16>>2]=h;yp(4,0,62344,f);zJ(n);i=e;return}function oy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;tJ(h,62112);pJ(g,gy(b,h)|0);m=d+4|0;ky(g,m);zJ(g);zJ(h);tJ(k,62128);pJ(j,gy(b,k)|0);h=d+8|0;fy(j,h);zJ(j);zJ(k);tJ(l,61984);k=WJ(gy(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?62248:62256;c[f+8>>2]=m;c[f+12>>2]=b?62248:62264;yp(4,0,62384,f);zJ(l);i=e;return}function py(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+8|0;gc=i;i=i+16|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Rc=i;i=i+16|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=qa;qy(qa);nJ(ra);ry(sa,ta);ry(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[75432>>2]|0)==0){tJ(za,c[b+80>>2]|0);sy(ya,za,62408);AJ(ra,ya)|0;zJ(ya);zJ(za)}else{BJ(ra,c[75560>>2]|0)|0}ta=cc(WJ(ra)|0,62424)|0;if((ta|0)!=0){Xc=ta;break}c[pa>>2]=WJ(ra)|0;Cp(0,62432,pa)}else{Xc=0}}while(0);pa=rk(0)|0;if((pa|0)==0){Qc(Xc|0)|0;Cp(0,62536,oa)}Ck(pa,Wc);Dk(pa,8,45);Wc=c[va>>2]|0;do{if((Wc|0)==0){oa=Aa;kU(oa|0,0,1024)|0;while(1){za=ob(oa|0,1,1024,Xc|0)|0;ya=za>>>0<1024;if((Ek(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Qc(Xc|0)|0;oa=WJ(ra)|0;ya=Mk(Jk(pa)|0)|0;za=Kk(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Ap(1,0,62616,na);yk(pa);Cp(0,62704,ma)}else if((Yc|0)==14){Qc(Xc|0)|0;break}}else{if((Ek(pa,Wc,gU(Wc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Mk(Jk(pa)|0)|0;ta=Kk(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;jd(za|0,62728,la|0)|0;za=c[va>>2]|0;ta=Mk(Jk(pa)|0)|0;oa=Kk(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Ap(1,0,62744,ka);yk(pa);Cp(0,62704,ja)}}while(0);ja=qa;tJ(Ca,62832);wy(Ba,ja,Ca);xy(Da,ja);ka=vy(Ba,Da)|0;zJ(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=WJ(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Ap(1,0,62840,ia)}else{tJ(Ea,62832);Ba=cU(Da,WJ(gy(ja,Ea)|0)|0)|0;zJ(Ea);if((Ba|0)==0){break}yk(pa);tJ(Fa,62832);Ba=WJ(gy(ja,Fa)|0)|0;va=WJ(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Ap(1,0,62888,ha);zJ(Fa);Cp(0,62704,ga)}}while(0);yy(qa,b,c[75644>>2]|0,c[75648>>2]|0);yp(23,1,62984,fa);fa=qa+12|0;tJ(Ha,63024);pJ(Ga,gy(fa,Ha)|0);ga=d;ly(Ga,ga,0.0);zJ(Ga);zJ(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];yp(23,0,63040,ea);tJ(Ja,63056);pJ(Ia,gy(fa,Ja)|0);ea=d+8|0;ly(Ia,ea,1.0);zJ(Ia);zJ(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];yp(23,0,63072,da);tJ(La,63088);pJ(Ka,gy(fa,La)|0);da=d+24|0;ly(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);zJ(Ka);zJ(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];yp(23,0,63104,ca);tJ(Na,63120);pJ(Ma,gy(fa,Na)|0);ca=d+32|0;ly(Ma,ca,1.0e-5);zJ(Ma);zJ(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];yp(23,0,63136,ba);tJ(Pa,63152);pJ(Oa,gy(fa,Pa)|0);ba=d+40|0;fy(Oa,ba);zJ(Oa);zJ(Pa);c[aa>>2]=c[ba>>2];yp(23,0,63160,aa);tJ(Ra,63184);pJ(Qa,gy(fa,Ra)|0);aa=d+44|0;fy(Qa,aa);zJ(Qa);zJ(Ra);c[$>>2]=c[aa>>2];yp(23,0,63200,$);tJ(Ta,63224);pJ(Sa,gy(fa,Ta)|0);fa=d+48|0;fy(Sa,fa);zJ(Sa);zJ(Ta);c[_>>2]=c[fa>>2];yp(23,0,63240,_);tJ(Va,63264);pJ(Ua,gy(ja,Va)|0);_=d+268|0;fy(Ua,_);zJ(Ua);zJ(Va);c[Z>>2]=c[_>>2];yp(23,0,63288,Z);if((c[21812>>2]|0)!=0){Td[c[5568]&255](23)}tJ(eb,63312);pJ(db,gy(ja,eb)|0);iy(db,Wa,0);zJ(db);zJ(eb);tJ(gb,63344);pJ(fb,gy(ja,gb)|0);iy(fb,Xa,0);zJ(fb);zJ(gb);tJ(ib,63376);pJ(hb,gy(ja,ib)|0);iy(hb,Ya,0);zJ(hb);zJ(ib);tJ(kb,63400);pJ(jb,gy(ja,kb)|0);iy(jb,_a,0);zJ(jb);zJ(kb);tJ(mb,63432);pJ(lb,gy(ja,mb)|0);iy(lb,Za,0);zJ(lb);zJ(mb);tJ(pb,63472);pJ(nb,gy(ja,pb)|0);iy(nb,ab,0);zJ(nb);zJ(pb);tJ(rb,63504);pJ(qb,gy(ja,rb)|0);iy(qb,$a,0);zJ(qb);zJ(rb);tJ(tb,63544);pJ(sb,gy(ja,tb)|0);iy(sb,cb,0);zJ(sb);zJ(tb);tJ(vb,63576);pJ(ub,gy(ja,vb)|0);iy(ub,bb,0);zJ(ub);zJ(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}sb=b+116|0;if((c[Za>>2]|0)!=(c[sb>>2]|0)){break}rb=b+136|0;if((c[ab>>2]|0)!=(c[rb>>2]|0)){break}qb=b+120|0;if((c[$a>>2]|0)!=(c[qb>>2]|0)){break}pb=b+140|0;if((c[cb>>2]|0)!=(c[pb>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=64120;yp(4,1,64096,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=zy(lb,wb)|0;ey(ib,jb+(kb*112|0)|0);jy(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(xb,64136);jb=(ZJ(gy(ib,xb)|0,62272)|0)==0;zJ(xb);if(!jb){break}c[N>>2]=c[hb>>2];yp(4,0,64152,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);tJ(yb,c[hb>>2]|0);c[(Ay(sa,yb)|0)>>2]=kb;zJ(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[M>>2]=64184;yp(4,1,64096,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=zy(lb,zb)|0;ey(fb,gb+(jb*112|0)|0);jy(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Ab,64136);gb=(ZJ(gy(fb,Ab)|0,62272)|0)==0;zJ(Ab);if(!gb){break}c[L>>2]=c[eb>>2];yp(4,0,64152,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);tJ(Bb,c[eb>>2]|0);c[(Ay(sa,Bb)|0)>>2]=jb;zJ(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[K>>2]=64208;yp(4,1,64096,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=zy(mb,Cb)|0;ey(gb,hb+(fb*112|0)|0);jy(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Db,64136);hb=(ZJ(gy(gb,Db)|0,62272)|0)==0;zJ(Db);if(!hb){break}c[J>>2]=c[db>>2];yp(4,0,64152,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);tJ(Eb,c[db>>2]|0);c[(Ay(sa,Eb)|0)>>2]=fb;zJ(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[I>>2]=64224;yp(4,1,64096,I);if((c[sb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=zy(ub,Fb)|0;ey(mb,kb+(ib*60|0)|0);my(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Gb,64136);kb=(ZJ(gy(mb,Gb)|0,62272)|0)==0;zJ(Gb);if(!kb){break}c[H>>2]=c[gb>>2];yp(4,0,64152,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);tJ(Hb,c[gb>>2]|0);c[(Ay(sa,Hb)|0)>>2]=ib;zJ(Hb);ib=ib+1|0;}while((ib|0)<(c[sb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[G>>2]=64248;yp(4,1,64096,G);if((c[qb>>2]|0)>0){sb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[sb>>2]|0;c[Ib>>2]=lb;mb=zy(ib,Ib)|0;ey(mb,ub+(lb*48|0)|0);ny(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Jb,64136);ub=(ZJ(gy(mb,Jb)|0,62272)|0)==0;zJ(Jb);if(!ub){break}c[F>>2]=c[fb>>2];yp(4,0,64152,F);a[(c[sb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);tJ(Kb,c[fb>>2]|0);c[(Ay(sa,Kb)|0)>>2]=lb;zJ(Kb);lb=lb+1|0;}while((lb|0)<(c[qb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[E>>2]=64272;yp(4,1,64096,E);if((c[nb>>2]|0)>0){qb=b+12|0;lb=qa+156|0;sb=0;do{ib=c[qb>>2]|0;c[Lb>>2]=sb;mb=zy(lb,Lb)|0;ey(mb,ib+(sb*52|0)|0);oy(mb,ib+(sb*52|0)+36|0);gb=ib+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Mb,64136);ib=(ZJ(gy(mb,Mb)|0,62272)|0)==0;zJ(Mb);if(!ib){break}c[D>>2]=c[gb>>2];yp(4,0,64152,D);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);tJ(Nb,c[gb>>2]|0);c[(Ay(sa,Nb)|0)>>2]=sb;zJ(Nb);sb=sb+1|0;}while((sb|0)<(c[nb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[C>>2]=64296;yp(4,1,64096,C);if((c[ja>>2]|0)>0){nb=b+16|0;sb=qa+60|0;qb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=qb;mb=zy(sb,Ob)|0;ey(mb,lb+(qb*112|0)|0);jy(mb,lb+(qb*112|0)+40|0);fb=lb+(qb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Pb,64136);lb=(ZJ(gy(mb,Pb)|0,62272)|0)==0;zJ(Pb);if(!lb){break}c[B>>2]=c[fb>>2];yp(4,0,64152,B);a[(c[nb>>2]|0)+(qb*112|0)+104|0]=1}}while(0);tJ(Qb,c[fb>>2]|0);c[(Ay(ua,Qb)|0)>>2]=qb;zJ(Qb);qb=qb+1|0;}while((qb|0)<(c[ja>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[A>>2]=64312;yp(4,1,64096,A);if((c[tb>>2]|0)>0){ja=b+20|0;qb=qa+96|0;nb=0;do{sb=c[ja>>2]|0;c[Rb>>2]=nb;mb=zy(qb,Rb)|0;ey(mb,sb+(nb*60|0)|0);my(mb,sb+(nb*60|0)+36|0);gb=sb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Sb,64136);sb=(ZJ(gy(mb,Sb)|0,62272)|0)==0;zJ(Sb);if(!sb){break}c[z>>2]=c[gb>>2];yp(4,0,64152,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);tJ(Tb,c[gb>>2]|0);c[(Ay(ua,Tb)|0)>>2]=nb;zJ(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[y>>2]=64336;yp(4,1,64096,y);if((c[rb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{qb=c[tb>>2]|0;c[Ub>>2]=ja;mb=zy(nb,Ub)|0;ey(mb,qb+(ja*48|0)|0);ny(mb,qb+(ja*48|0)+36|0);fb=qb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Vb,64136);qb=(ZJ(gy(mb,Vb)|0,62272)|0)==0;zJ(Vb);if(!qb){break}c[x>>2]=c[fb>>2];yp(4,0,64152,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);tJ(Wb,c[fb>>2]|0);c[(Ay(ua,Wb)|0)>>2]=ja;zJ(Wb);ja=ja+1|0;}while((ja|0)<(c[rb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}c[w>>2]=64360;yp(4,1,64096,w);if((c[pb>>2]|0)>0){rb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[rb>>2]|0;c[Xb>>2]=tb;mb=zy(ja,Xb)|0;ey(mb,nb+(tb*52|0)|0);oy(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[75428>>2]|0)!=0){break}tJ(Yb,64136);nb=(ZJ(gy(mb,Yb)|0,62272)|0)==0;zJ(Yb);if(!nb){break}c[v>>2]=c[gb>>2];yp(4,0,64152,v);a[(c[rb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);tJ(Zb,c[gb>>2]|0);c[(Ay(ua,Zb)|0)>>2]=tb;zJ(Zb);tb=tb+1|0;}while((tb|0)<(c[pb>>2]|0))}if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}yp(4,1,64384,u);pb=b+208|0;a:do{if((c[pb>>2]|0)>0){tb=qa+72|0;rb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=zy(tb,_b)|0;ey(mb,(c[rb>>2]|0)+(ja*52|0)+12|0);nJ($b);c[bc>>2]=ja;mb=zy(tb,bc)|0;tJ(dc,64424);pJ(ac,gy(mb,dc)|0);By(ac,$b);zJ(ac);zJ(dc);mb=(ZJ($b,64432)|0)==0;fb=c[rb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;yp(4,0,64448,t);nb=c[rb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[fc>>2]=ja;nb=zy(tb,fc)|0;tJ(gc,64488);pJ(ec,gy(nb,gc)|0);By(ec,$b);zJ(ec);zJ(gc);Cy(wa,sa,$b);Cy(xa,ua,$b);Ey(hc,sa);do{if(Dy(wa,hc)|0){nb=c[(Fy(wa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{Ey(ic,ua);if(Dy(xa,ic)|0){fb=c[(Fy(xa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((ZJ($b,64504)|0)!=0){break b}a[(c[rb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);zJ($b);ja=ja+1|0;if((ja|0)>=(c[pb>>2]|0)){break a}}iK(kc,64512,$b);sy(jc,kc,64536);zJ(kc);c[s>>2]=WJ(jc)|0;Cp(0,64552,s)}}while(0);if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}yp(4,1,64560,q);pb=b+212|0;c:do{if((c[pb>>2]|0)>0){ja=qa+108|0;rb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=zy(ja,lc)|0;ey(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);nJ(mc);c[oc>>2]=tb;gb=zy(ja,oc)|0;tJ(pc,64424);pJ(nc,gy(gb,pc)|0);By(nc,mc);zJ(nc);zJ(pc);gb=(ZJ(mc,64432)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;yp(4,0,64448,p);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=zy(ja,rc)|0;tJ(sc,64488);pJ(qc,gy(fb,sc)|0);By(qc,mc);zJ(qc);zJ(sc);Cy(wa,sa,mc);Cy(xa,ua,mc);Ey(tc,sa);if(Dy(wa,tc)|0){fb=c[(Fy(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{Ey(uc,ua);if(!(Dy(xa,uc)|0)){break}nb=c[(Fy(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}zJ(mc);tb=tb+1|0;if((tb|0)>=(c[pb>>2]|0)){break c}}iK(wc,64600,mc);sy(vc,wc,64536);zJ(wc);c[o>>2]=WJ(vc)|0;Cp(0,64552,o)}}while(0);if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}yp(4,1,64624,n);pb=b+216|0;d:do{if((c[pb>>2]|0)>0){tb=qa+144|0;rb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=zy(tb,xc)|0;ey(fb,(c[rb>>2]|0)+(ja*52|0)+12|0);nJ(yc);c[Ac>>2]=ja;fb=zy(tb,Ac)|0;tJ(Bc,64424);pJ(zc,gy(fb,Bc)|0);By(zc,yc);zJ(zc);zJ(Bc);fb=(ZJ(yc,64432)|0)==0;nb=c[rb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;yp(4,0,64448,m);gb=c[rb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=zy(tb,Dc)|0;tJ(Ec,64488);pJ(Cc,gy(gb,Ec)|0);By(Cc,yc);zJ(Cc);zJ(Ec);Cy(wa,sa,yc);Cy(xa,ua,yc);Ey(Fc,sa);if(Dy(wa,Fc)|0){gb=c[(Fy(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{Ey(Gc,ua);if(!(Dy(xa,Gc)|0)){break}nb=c[(Fy(xa)|0)+12>>2]|0;gb=c[rb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}zJ(yc);ja=ja+1|0;if((ja|0)>=(c[pb>>2]|0)){break d}}iK(Ic,64664,yc);sy(Hc,Ic,64536);zJ(Ic);c[l>>2]=WJ(Hc)|0;Cp(0,64552,l)}}while(0);if((c[21736>>2]|0)!=0){Td[c[5568]&255](4)}yp(4,1,64688,j);pb=b+220|0;e:do{if((c[pb>>2]|0)>0){ja=qa+180|0;rb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=zy(ja,Jc)|0;ey(gb,(c[rb>>2]|0)+(tb*52|0)+12|0);nJ(Kc);c[Mc>>2]=tb;gb=zy(ja,Mc)|0;tJ(Nc,64424);pJ(Lc,gy(gb,Nc)|0);By(Lc,Kc);zJ(Lc);zJ(Nc);gb=(ZJ(Kc,64432)|0)==0;nb=c[rb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;yp(4,0,64448,g);fb=c[rb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=zy(ja,Pc)|0;tJ(Rc,64488);pJ(Oc,gy(fb,Rc)|0);By(Oc,Kc);zJ(Oc);zJ(Rc);Cy(wa,sa,Kc);Cy(xa,ua,Kc);Ey(Sc,sa);if(Dy(wa,Sc)|0){fb=c[(Fy(wa)|0)+12>>2]|0;nb=c[rb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{Ey(Tc,ua);if(!(Dy(xa,Tc)|0)){break}nb=c[(Fy(xa)|0)+12>>2]|0;fb=c[rb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}zJ(Kc);tb=tb+1|0;if((tb|0)>=(c[pb>>2]|0)){break e}}iK(Vc,64728,Kc);sy(Uc,Vc,64536);zJ(Vc);c[f>>2]=WJ(Uc)|0;Cp(0,64552,f)}}while(0);if((c[21736>>2]|0)==0){yk(pa);Gy(ua);Gy(sa);zJ(ra);Hy(qa);i=e;return}Td[c[5568]&255](4);yk(pa);Gy(ua);Gy(sa);zJ(ra);Hy(qa);i=e;return}}while(0);if((c[21808>>2]|c[5428]|0)==0){yk(pa);Zc=hd(0)|0;od(-1)}Ap(22,1,63616,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Ap(22,0,63664,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Ap(22,0,63712,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Ap(22,0,63760,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Ap(22,0,63808,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Ap(22,0,63856,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Ap(22,0,63904,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Ap(22,0,63952,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Ap(22,0,64e3,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Ap(22,0,64048,P);Td[c[5568]&255](22);yk(pa);Zc=hd(0)|0;od(-1)}function qy(a){a=a|0;var b=0;b=i;sF(a);i=b;return}function ry(a,b){a=a|0;b=b|0;b=i;ZA(a,0);i=b;return}function sy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;oJ(a,d);e=xJ(b)|0;f=fz(c)|0;_J(a,yJ(b)|0,e,f+e|0);SJ(a,c,f)|0;i=d;return}function ty(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((cU(b,65360)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{tJ(g,v);w=gy(u,g)|0;BJ(w,c[d+((t|1)<<2)>>2]|0)|0;zJ(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((cU(b,65384)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{tJ(h,g);u=gy(t,h)|0;BJ(u,c[d+((v|1)<<2)>>2]|0)|0;zJ(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((cU(b,65408)|0)!=0){do{if((cU(b,65664)|0)!=0){if((cU(b,65672)|0)==0){break}if((cU(b,65680)|0)==0){break}if((cU(b,65688)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=zy(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){tJ(r,c[t>>2]|0);w=gy(g,r)|0;BJ(w,c[d+((u|1)<<2)>>2]|0)|0;zJ(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=zy(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}tJ(s,65696);BJ(gy(x,s)|0,b)|0;zJ(s);i=e;return}Iy(j,k);nJ(l);nJ(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{tJ(n,g);t=gy(j,n)|0;BJ(t,c[d+((x|1)<<2)>>2]|0)|0;zJ(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}tJ(o,65424);AJ(l,gy(j,o)|0)|0;zJ(o);tJ(p,65440);AJ(m,gy(j,p)|0)|0;zJ(p);c[k>>2]=yc(WJ(l)|0)|0;if((ZJ(m,65456)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((ZJ(m,65464)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((ZJ(m,65472)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((ZJ(m,65480)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((ZJ(m,65488)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((ZJ(m,65496)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((ZJ(m,65504)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((ZJ(m,65512)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((ZJ(m,65520)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((ZJ(m,65528)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((ZJ(m,65536)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((ZJ(m,65544)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((ZJ(m,65552)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((ZJ(m,65560)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=WJ(m)|0;tJ(q,61984);N=WJ(gy(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Bp(0,(O|0)!=0|0,65568,f);zJ(q);XD(zy(c[b>>2]|0,s)|0,j)|0;zJ(m);zJ(l);Qy(j);i=e;return}function uy(a,b){a=a|0;b=b|0;i=i;return}function vy(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=IA(a,b)|0;i=c;return d|0}function wy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;RA(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];JA(a,f);i=e;return}function xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;KA(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];JA(a,e);i=d;return}function yy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,nd=0,od=0,pd=0,qd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+8|0;Ub=i;i=i+16|0;Vb=i;i=i+8|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;Iy(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Cp(0,64752,n)}if(p){ec=md(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;yp(23,0,64896,m);Jy(q);Ky(q,e,8);if(!(Ly(q)|0)){c[l>>2]=e;Cp(0,64936,l)}nJ(r);l=q;My(l,r)|0;pJ(s,r);while(1){e=My(l,r)|0;if(!(jK(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}iK(t,65016,r);QJ(s,t)|0;zJ(t)}t=md(WJ(s)|0)|0;Ny(q);zJ(s);zJ(r);Oy(q);fc=t}if((fc|0)==0){yp(23,0,65104,g);Qy(o);i=f;return}nJ(u);nJ(v);c[k>>2]=fc;yp(23,0,65024,k);k=Rb(fc|0,65016)|0;if((k|0)!=0){g=k;do{k=KT(12)|0;tJ(k,g);t=XJ(k,65056,0)|0;VJ(w,k,0,t);AJ(u,w)|0;zJ(w);VJ(x,k,t+1|0,(GJ(k)|0)+~t|0);AJ(v,x)|0;zJ(x);AJ(gy(o,u)|0,v)|0;t=WJ(u)|0;k=WJ(v)|0;c[j>>2]=t;c[j+4>>2]=k;yp(23,0,65064,j);g=Rb(0,65016)|0;}while((g|0)!=0)}FT(fc);fc=a+12|0;tJ(y,63152);g=gy(fc,y)|0;tJ(z,63152);if((Py(o,z)|0)==0){tJ(B,63152);gc=1;hc=0;ic=gy(fc,B)|0}else{tJ(A,63152);gc=0;hc=1;ic=gy(o,A)|0}AJ(g,ic)|0;if(gc){zJ(B)}if(hc){zJ(A)}zJ(z);zJ(y);tJ(C,63024);y=gy(fc,C)|0;tJ(D,63024);if((Py(o,D)|0)==0){tJ(F,63024);jc=1;kc=0;lc=gy(fc,F)|0}else{tJ(E,63024);jc=0;kc=1;lc=gy(o,E)|0}AJ(y,lc)|0;if(jc){zJ(F)}if(kc){zJ(E)}zJ(D);zJ(C);tJ(G,63056);C=gy(fc,G)|0;tJ(H,63056);if((Py(o,H)|0)==0){tJ(J,63056);mc=1;nc=0;oc=gy(fc,J)|0}else{tJ(I,63056);mc=0;nc=1;oc=gy(o,I)|0}AJ(C,oc)|0;if(mc){zJ(J)}if(nc){zJ(I)}zJ(H);zJ(G);tJ(K,63088);G=gy(fc,K)|0;tJ(L,63088);if((Py(o,L)|0)==0){tJ(N,63088);pc=0;qc=1;rc=gy(fc,N)|0}else{tJ(M,63088);pc=1;qc=0;rc=gy(o,M)|0}AJ(G,rc)|0;if(qc){zJ(N)}if(pc){zJ(M)}zJ(L);zJ(K);tJ(O,63120);K=gy(fc,O)|0;tJ(P,63120);if((Py(o,P)|0)==0){tJ(R,63120);sc=1;tc=0;uc=gy(fc,R)|0}else{tJ(Q,63120);sc=0;tc=1;uc=gy(o,Q)|0}AJ(K,uc)|0;if(sc){zJ(R)}if(tc){zJ(Q)}zJ(P);zJ(O);tJ(S,63184);O=gy(fc,S)|0;tJ(T,63184);if((Py(o,T)|0)==0){tJ(V,63184);vc=1;wc=0;xc=gy(fc,V)|0}else{tJ(U,63184);vc=0;wc=1;xc=gy(o,U)|0}AJ(O,xc)|0;if(vc){zJ(V)}if(wc){zJ(U)}zJ(T);zJ(S);tJ(W,63224);S=gy(fc,W)|0;tJ(X,63224);if((Py(o,X)|0)==0){tJ(Z,63224);yc=1;zc=0;Ac=gy(fc,Z)|0}else{tJ(Y,63224);yc=0;zc=1;Ac=gy(o,Y)|0}AJ(S,Ac)|0;if(yc){zJ(Z)}if(zc){zJ(Y)}zJ(X);zJ(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=zy(Y,_)|0;tJ($,62128);Ac=gy(yc,$)|0;c[aa>>2]=Z;yc=zy(Y,aa)|0;tJ(ba,61984);if((Py(o,gy(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=zy(Y,ea)|0;tJ(fa,62128);Bc=1;Cc=0;Dc=gy(yc,fa)|0}else{c[ca>>2]=Z;yc=zy(Y,ca)|0;tJ(da,61984);Bc=0;Cc=1;Dc=gy(o,gy(yc,da)|0)|0}AJ(Ac,Dc)|0;if(Bc){zJ(fa)}if(Cc){zJ(da)}zJ(ba);zJ($);c[ga>>2]=Z;Ac=zy(zc,ga)|0;tJ(ha,62128);yc=gy(Ac,ha)|0;c[ia>>2]=Z;Ac=zy(zc,ia)|0;tJ(ja,61984);if((Py(o,gy(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=zy(zc,ma)|0;tJ(na,62128);Ec=1;Fc=0;Gc=gy(Ac,na)|0}else{c[ka>>2]=Z;Ac=zy(zc,ka)|0;tJ(la,61984);Ec=0;Fc=1;Gc=gy(o,gy(Ac,la)|0)|0}AJ(yc,Gc)|0;if(Ec){zJ(na)}if(Fc){zJ(la)}zJ(ja);zJ(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=zy(Hc,oa)|0;tJ(pa,62128);ja=gy(ha,pa)|0;c[qa>>2]=Z;ha=zy(Hc,qa)|0;tJ(ra,61984);if((Py(o,gy(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=zy(Hc,ua)|0;tJ(va,62128);Ic=1;Jc=0;Kc=gy(ha,va)|0}else{c[sa>>2]=Z;ha=zy(Hc,sa)|0;tJ(ta,61984);Ic=0;Jc=1;Kc=gy(o,gy(ha,ta)|0)|0}AJ(ja,Kc)|0;if(Ic){zJ(va)}if(Jc){zJ(ta)}zJ(ra);zJ(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=zy(X,wa)|0;tJ(xa,62128);ra=gy(pa,xa)|0;c[ya>>2]=Z;pa=zy(X,ya)|0;tJ(za,61984);if((Py(o,gy(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=zy(X,Ca)|0;tJ(Da,62128);Lc=1;Mc=0;Nc=gy(pa,Da)|0}else{c[Aa>>2]=Z;pa=zy(X,Aa)|0;tJ(Ba,61984);Lc=0;Mc=1;Nc=gy(o,gy(pa,Ba)|0)|0}AJ(ra,Nc)|0;if(Lc){zJ(Da)}if(Mc){zJ(Ba)}zJ(za);zJ(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=zy(Z,Ea)|0;tJ(Fa,62128);Ba=gy(za,Fa)|0;c[Ga>>2]=xa;za=zy(Z,Ga)|0;tJ(Ha,61984);if((Py(o,gy(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=zy(Z,Ka)|0;tJ(La,62128);Oc=1;Pc=0;Qc=gy(za,La)|0}else{c[Ia>>2]=xa;za=zy(Z,Ia)|0;tJ(Ja,61984);Oc=0;Pc=1;Qc=gy(o,gy(za,Ja)|0)|0}AJ(Ba,Qc)|0;if(Oc){zJ(La)}if(Pc){zJ(Ja)}zJ(Ha);zJ(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=zy(xa,Ma)|0;tJ(Na,62128);Ja=gy(Ha,Na)|0;c[Oa>>2]=Fa;Ha=zy(xa,Oa)|0;tJ(Pa,61984);if((Py(o,gy(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=zy(xa,Sa)|0;tJ(Ta,62128);Rc=1;Sc=0;Tc=gy(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=zy(xa,Qa)|0;tJ(Ra,61984);Rc=0;Sc=1;Tc=gy(o,gy(Ha,Ra)|0)|0}AJ(Ja,Tc)|0;if(Rc){zJ(Ta)}if(Sc){zJ(Ra)}zJ(Pa);zJ(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=zy(Fa,Ua)|0;tJ(Va,62128);Ra=gy(Pa,Va)|0;c[Wa>>2]=Na;Pa=zy(Fa,Wa)|0;tJ(Xa,61984);if((Py(o,gy(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=zy(Fa,_a)|0;tJ($a,62128);Uc=1;Vc=0;Wc=gy(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=zy(Fa,Ya)|0;tJ(Za,61984);Uc=0;Vc=1;Wc=gy(o,gy(Pa,Za)|0)|0}AJ(Ra,Wc)|0;if(Uc){zJ($a)}if(Vc){zJ(Za)}zJ(Xa);zJ(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=zy(Na,ab)|0;tJ(bb,62128);Za=gy(Xa,bb)|0;c[cb>>2]=Va;Xa=zy(Na,cb)|0;tJ(db,61984);if((Py(o,gy(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=zy(Na,gb)|0;tJ(hb,62128);Xc=1;Yc=0;Zc=gy(Xa,hb)|0}else{c[eb>>2]=Va;Xa=zy(Na,eb)|0;tJ(fb,61984);Xc=0;Yc=1;Zc=gy(o,gy(Xa,fb)|0)|0}AJ(Za,Zc)|0;if(Xc){zJ(hb)}if(Yc){zJ(fb)}zJ(db);zJ(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=zy(Va,ib)|0;tJ(jb,62128);fb=gy(db,jb)|0;c[kb>>2]=bb;db=zy(Va,kb)|0;tJ(lb,61984);if((Py(o,gy(db,lb)|0)|0)==0){c[ob>>2]=bb;db=zy(Va,ob)|0;tJ(pb,62128);_c=1;$c=0;ad=gy(db,pb)|0}else{c[mb>>2]=bb;db=zy(Va,mb)|0;tJ(nb,61984);_c=0;$c=1;ad=gy(o,gy(db,nb)|0)|0}AJ(fb,ad)|0;if(_c){zJ(pb)}if($c){zJ(nb)}zJ(lb);zJ(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=zy(bb,qb)|0;tJ(rb,62128);nb=gy(lb,rb)|0;c[sb>>2]=jb;lb=zy(bb,sb)|0;tJ(tb,61984);if((Py(o,gy(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=zy(bb,wb)|0;tJ(xb,62128);bd=1;cd=0;dd=gy(lb,xb)|0}else{c[ub>>2]=jb;lb=zy(bb,ub)|0;tJ(vb,61984);bd=0;cd=1;dd=gy(o,gy(lb,vb)|0)|0}AJ(nb,dd)|0;if(bd){zJ(xb)}if(cd){zJ(vb)}zJ(tb);zJ(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=zy(jb,yb)|0;tJ(zb,62128);vb=gy(tb,zb)|0;c[Ab>>2]=rb;tb=zy(jb,Ab)|0;tJ(Bb,61984);if((Py(o,gy(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=zy(jb,Eb)|0;tJ(Fb,62128);ed=1;fd=0;gd=gy(tb,Fb)|0}else{c[Cb>>2]=rb;tb=zy(jb,Cb)|0;tJ(Db,61984);ed=0;fd=1;gd=gy(o,gy(tb,Db)|0)|0}AJ(vb,gd)|0;if(ed){zJ(Fb)}if(fd){zJ(Db)}zJ(Bb);zJ(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=zy(rb,Gb)|0;tJ(Hb,62128);Db=gy(Bb,Hb)|0;c[Ib>>2]=zb;Bb=zy(rb,Ib)|0;tJ(Jb,61984);if((Py(o,gy(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=zy(rb,Mb)|0;tJ(Nb,62128);hd=0;id=1;jd=gy(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=zy(rb,Kb)|0;tJ(Lb,61984);hd=1;id=0;jd=gy(o,gy(Bb,Lb)|0)|0}AJ(Db,jd)|0;if(id){zJ(Nb)}if(hd){zJ(Lb)}zJ(Jb);zJ(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=zy(zb,Ob)|0;tJ(Pb,62128);Lb=gy(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=zy(zb,Qb)|0;tJ(Sb,61984);if((Py(o,gy(Jb,Sb)|0)|0)==0){c[Vb>>2]=Hb;Jb=zy(zb,Vb)|0;tJ(Wb,62128);kd=1;ld=0;nd=gy(Jb,Wb)|0}else{c[Tb>>2]=Hb;Jb=zy(zb,Tb)|0;tJ(Ub,61984);kd=0;ld=1;nd=gy(o,gy(Jb,Ub)|0)|0}AJ(Lb,nd)|0;if(kd){zJ(Wb)}if(ld){zJ(Ub)}zJ(Sb);zJ(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Xb>>2]=a;Hb=zy(b,Xb)|0;tJ(Yb,62128);Pb=gy(Hb,Yb)|0;c[Zb>>2]=a;Hb=zy(b,Zb)|0;tJ(_b,61984);if((Py(o,gy(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=zy(b,bc)|0;tJ(cc,62128);od=1;pd=0;qd=gy(Hb,cc)|0}else{c[$b>>2]=a;Hb=zy(b,$b)|0;tJ(ac,61984);od=0;pd=1;qd=gy(o,gy(Hb,ac)|0)|0}AJ(Pb,qd)|0;if(od){zJ(cc)}if(pd){zJ(ac)}zJ(_b);zJ(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}yp(23,0,65088,h);zJ(v);zJ(u);Qy(o);i=f;return}function zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=gB(a,f,b)|0;l=c[k>>2]|0;Su(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}iB(j,a,b);jB(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];hB(g,e);kB(j);j=c[f>>2]|0;lB(a,j,k,mB(g)|0);k=nB(g)|0;kB(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Kz(a,f,b)|0;l=c[k>>2]|0;Su(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}Mz(j,a,b);Nz(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Lz(g,e);Oz(j);j=c[f>>2]|0;Pz(a,j,k,Qz(g)|0);k=Rz(g)|0;Oz(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function By(a,b){a=a|0;b=b|0;var c=0;c=i;AJ(b,a)|0;i=c;return}function Cy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Bz(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];tz(a,f);i=e;return}function Dy(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rz(a,b)|0;i=c;return d|0}function Ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;uz(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];tz(a,e);i=d;return}function Fy(a){a=a|0;var b=0,c=0;b=i;c=oz(a)|0;i=b;return c|0}function Gy(a){a=a|0;var b=0;b=i;ND(a);i=b;return}function Hy(a){a=a|0;var b=0;b=i;AD(a);i=b;return}function Iy(a,b){a=a|0;b=b|0;b=i;hC(a,0);i=b;return}function Jy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;wK(d);e=a;c[e>>2]=65156;f=d;c[f>>2]=65176;d=a+8|0;oL(a,65188|0,d);c[e>>2]=65156;c[f>>2]=65176;zx(d);i=b;return}function Ky(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(_u(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){nK(d,4);i=e;return}else{lK(d,0);i=e;return}}function Ly(a){a=a|0;var b=0,c=0;b=i;c=jz(a+8|0)|0;i=b;return c|0}function My(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=iz(a,b,uK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function Ny(a){a=a|0;var b=0;b=i;if((av(a+8|0)|0)!=0){i=b;return}nK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function Oy(a){a=a|0;var b=0;b=i;nz(a,65184);rK(a+108|0);i=b;return}function Py(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Ry(a,b)|0;i=c;return d|0}function Qy(a){a=a|0;var b=0;b=i;pD(a);i=b;return}function Ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=Ty(a)|0;Su(e);if((f|0)==0){g=0;i=d;return g|0}h=Uy(a)|0;a=f;while(1){f=a+16|0;if(Vy(h,b,f)|0){j=a}else{if(!(Wy(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;Su(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function Sy(a){a=a|0;var b=0,c=0;b=i;c=Du(az(a+4|0)|0)|0;i=b;return c|0}function Ty(a){a=a|0;var b=0,d=0;b=i;d=c[(Sy(a)|0)>>2]|0;i=b;return d|0}function Uy(a){a=a|0;var b=0,c=0;b=i;c=_y(a+8|0)|0;i=b;return c|0}function Vy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xy(0,b,c)|0;i=a;return d|0}function Wy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xy(0,b,c)|0;i=a;return d|0}function Xy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Yy(b,c)|0;i=a;return d|0}function Yy(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(YJ(a,b)|0)<0;i=c;return d|0}function Zy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=bU(a,b,c)|0;i=d;return e|0}function _y(a){a=a|0;var b=0,c=0;b=i;c=$y(a)|0;i=b;return c|0}function $y(a){a=a|0;i=i;return a|0}function az(a){a=a|0;var b=0,c=0;b=i;c=bz(a)|0;i=b;return c|0}function bz(a){a=a|0;i=i;return a|0}function cz(a,b){a=a|0;b=b|0;var c=0;a=i;c=ez(0,b,0)|0;i=a;return c|0}function dz(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function ez(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=KT(b)|0;i=c;return a|0}function fz(a){a=a|0;var b=0,c=0;b=i;c=gU(a|0)|0;i=b;return c|0}function gz(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=hz(b,c,e)|0;i=d;return g|0}function hz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Wv(0,a,b)|0;i=c;return(d?b:a)|0}function iz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;tL(f,a,1);if(!(wL(f)|0)){i=e;return a|0}PJ(b);f=0;while(1){g=CK(sK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(Mv(g,-1)|0){h=2;j=f;break}k=f+1|0;l=Nv(g)|0;if(Rv(l,d)|0){h=0;j=k;break}RJ(b,l);if((xJ(b)|0)==-17){h=4;j=k;break}else{f=k}}nK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function jz(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function kz(a){a=a|0;var b=0;b=i;Oy(a);MT(a);i=b;return}function lz(a){a=a|0;var b=0;b=i;Oy(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function mz(a){a=a|0;var b=0;b=i;kz(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function nz(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Av(a+8|0);i=d;return}function oz(a){a=a|0;var b=0,d=0;b=i;d=pz((c[a>>2]|0)+16|0)|0;i=b;return d|0}function pz(a){a=a|0;var b=0,c=0;b=i;c=qz(a)|0;i=b;return c|0}function qz(a){a=a|0;i=i;return a|0}function rz(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(sz(a,b)|0)^1;i=c;return d|0}function sz(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function tz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Az(a,e);i=d;return}function uz(a,b){a=a|0;b=b|0;var c=0;c=i;vz(a,wz(b)|0);i=c;return}function vz(a,b){a=a|0;b=b|0;var c=0;c=i;zz(a,b);i=c;return}function wz(a){a=a|0;var b=0,c=0;b=i;c=Du(xz(a+4|0)|0)|0;i=b;return c|0}function xz(a){a=a|0;var b=0,c=0;b=i;c=yz(a)|0;i=b;return c|0}function yz(a){a=a|0;i=i;return a|0}function zz(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Az(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Bz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=Dz(b)|0;Cz(f,b,d,h,wz(b)|0);uz(g,b);do{if(rz(f,g)|0){h=Ez(b)|0;if(Fz(h,d,Gz(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);uz(a,b);i=e;return}function Cz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Su(h);a:do{if((e|0)==0){j=f}else{k=Ez(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Jz(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Su(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Su(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);vz(a,j);i=g;return}function Dz(a){a=a|0;var b=0,d=0;b=i;d=c[(wz(a)|0)>>2]|0;i=b;return d|0}function Ez(a){a=a|0;var b=0,c=0;b=i;c=Hz(a+8|0)|0;i=b;return c|0}function Fz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xy(0,b,c)|0;i=a;return d|0}function Gz(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function Hz(a){a=a|0;var b=0,c=0;b=i;c=Iz(a)|0;i=b;return c|0}function Iz(a){a=a|0;i=i;return a|0}function Jz(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=Xy(0,b,c)|0;i=a;return d|0}function Kz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Dz(h)|0;Su(e);if((a|0)==0){j=wz(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Xy(0,d,a)|0){m=l;j=c[m>>2]|0;Su(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Xy(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Su(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Lz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];GA(a,e);i=d;return}function Mz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=lA(d)|0;d=nA(n,1)|0;oA(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];mA(j,d,h);pA(0,eA((qA(j)|0)+16|0)|0,e);e=rA(j)|0;a[e+4|0]=1;sA(0,cA((qA(j)|0)+28|0)|0);a[e+5|0]=1;tA(m,j);Nz(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Lz(b,g);Oz(m);Oz(j);i=f;return}function Nz(a,b){a=a|0;b=b|0;var c=0;c=i;jA(a,b);i=c;return}function Oz(a){a=a|0;var b=0;b=i;_z(a);i=b;return}function Pz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;Su(f);c[e>>2]=0;Su(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Wz(a)|0;b=c[c[e>>2]>>2]|0;Su(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(wz(a)|0)>>2]|0;Cw(e,c[d>>2]|0);d=Xz(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Qz(a){a=a|0;var b=0,d=0;b=i;d=c[(Uz(a)|0)>>2]|0;i=b;return d|0}function Rz(a){a=a|0;var b=0,d=0;b=i;d=Sz(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Sz(a){a=a|0;var b=0,c=0;b=i;c=Tz(a)|0;i=b;return c|0}function Tz(a){a=a|0;i=i;return a|0}function Uz(a){a=a|0;var b=0,c=0;b=i;c=Vz(a)|0;i=b;return c|0}function Vz(a){a=a|0;i=i;return a|0}function Wz(a){a=a|0;i=i;return a|0}function Xz(a){a=a|0;var b=0,c=0;b=i;c=Yz(a+8|0)|0;i=b;return c|0}function Yz(a){a=a|0;var b=0,c=0;b=i;c=Zz(a)|0;i=b;return c|0}function Zz(a){a=a|0;i=i;return a|0}function _z(a){a=a|0;var b=0;b=i;$z(a,0);i=b;return}function $z(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Sz(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}bA(aA(e)|0,f);i=d;return}function aA(a){a=a|0;var b=0,c=0;b=i;c=iA(a)|0;i=b;return c|0}function bA(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;dA(f,eA(d+16|0)|0)}if((d|0)==0){i=e;return}fA(c[b>>2]|0,d,1);i=e;return}function cA(a){a=a|0;i=i;return a|0}function dA(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;hA(d,0,c);i=b;return}function eA(a){a=a|0;i=i;return a|0}function fA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;gA(0,b,0);i=c;return}function gA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;MT(b);i=c;return}function hA(a,b,c){a=a|0;b=b|0;c=c|0;b=i;zJ(c);i=b;return}function iA(a){a=a|0;i=i;return a+4|0}function jA(a,b){a=a|0;b=b|0;var c=0;c=i;kA(a,b);i=c;return}function kA(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function lA(a){a=a|0;var b=0,c=0;b=i;c=EA(a+4|0)|0;i=b;return c|0}function mA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wA(a,b,f);i=e;return}function nA(a,b){a=a|0;b=b|0;var c=0;a=i;c=vA(0,b,0)|0;i=a;return c|0}function oA(a,b){a=a|0;b=b|0;var c=0;c=i;uA(a,b);i=c;return}function pA(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}pJ(b,c);i=a;return}function qA(a){a=a|0;var b=0,d=0;b=i;d=c[(Uz(a)|0)>>2]|0;i=b;return d|0}function rA(a){a=a|0;var b=0,c=0;b=i;c=aA(a)|0;i=b;return c|0}function sA(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function tA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;jA(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Lz(h,f);Nz(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Lz(a,e);Oz(h);i=d;return}function uA(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function vA(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=KT(b<<5)|0;i=c;return a|0}function wA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(yA(g)|0)>>2]|0;g=zA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xA(b,a,f);i=e;return}function xA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];AA(a,b,f);i=e;return}function yA(a){a=a|0;i=i;return a|0}function zA(a){a=a|0;i=i;return a|0}function AA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(CA(g)|0)>>2]|0;g=DA(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];BA(b,a,f);i=e;return}function BA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(CA(f)|0)>>2];f=DA(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function CA(a){a=a|0;i=i;return a|0}function DA(a){a=a|0;i=i;return a|0}function EA(a){a=a|0;var b=0,c=0;b=i;c=FA(a)|0;i=b;return c|0}function FA(a){a=a|0;i=i;return a|0}function GA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Rz(HA(b)|0)|0;h=DA(rA(HA(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];xA(g,a,e);i=d;return}function HA(a){a=a|0;i=i;return c[a>>2]|0}function IA(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function JA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];QA(a,e);i=d;return}function KA(a,b){a=a|0;b=b|0;var c=0;c=i;LA(a,MA(b)|0);i=c;return}function LA(a,b){a=a|0;b=b|0;var c=0;c=i;PA(a,b);i=c;return}function MA(a){a=a|0;var b=0,c=0;b=i;c=Du(NA(a+4|0)|0)|0;i=b;return c|0}function NA(a){a=a|0;var b=0,c=0;b=i;c=OA(a)|0;i=b;return c|0}function OA(a){a=a|0;i=i;return a|0}function PA(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function QA(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function RA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=TA(b)|0;SA(f,b,d,h,MA(b)|0);KA(g,b);do{if(UA(f,g)|0){h=VA(b)|0;if(Vy(h,d,WA(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);KA(a,b);i=e;return}function SA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;Su(h);a:do{if((e|0)==0){j=f}else{k=VA(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Wy(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;Su(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;Su(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);LA(a,j);i=g;return}function TA(a){a=a|0;var b=0,d=0;b=i;d=c[(MA(a)|0)>>2]|0;i=b;return d|0}function UA(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(IA(a,b)|0)^1;i=c;return d|0}function VA(a){a=a|0;var b=0,c=0;b=i;c=XA(a+8|0)|0;i=b;return c|0}function WA(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function XA(a){a=a|0;var b=0,c=0;b=i;c=YA(a)|0;i=b;return c|0}function YA(a){a=a|0;i=i;return a|0}function ZA(a,b){a=a|0;b=b|0;b=i;i=i+8|0;_A(a,b);i=b;return}function _A(a,b){a=a|0;b=b|0;b=i;$A(a,0);i=b;return}function $A(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;aB(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;bB(f,0,e);e=wz(b)|0;c[(Wz(b)|0)>>2]=e;i=d;return}function aB(a){a=a|0;var b=0;b=i;eB(a);i=b;return}function bB(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;cB(b,c,f);i=e;return}function cB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(ux(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;dB(d,b,f);i=e;return}function dB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(ux(e)|0)>>2];i=d;return}function eB(a){a=a|0;var b=0;b=i;fB(a);i=b;return}function fB(a){a=a|0;var b=0;b=i;xx(a);i=b;return}function gB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=gC(h)|0;Su(e);if((a|0)==0){j=tB(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(Pu(0,d,a)|0){m=l;j=c[m>>2]|0;Su(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(Pu(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;Su(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function hB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];eC(a,e);i=d;return}function iB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=LB(d)|0;d=NB(n,1)|0;OB(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];MB(j,d,h);PB(0,Ow((QB(j)|0)+16|0)|0,e);e=RB(j)|0;a[e+4|0]=1;SB(0,EB((QB(j)|0)+20|0)|0);a[e+5|0]=1;TB(m,j);jB(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hB(b,g);kB(m);kB(j);i=f;return}function jB(a,b){a=a|0;b=b|0;var c=0;c=i;JB(a,b);i=c;return}function kB(a){a=a|0;var b=0;b=i;zB(a);i=b;return}



function _S(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=ET(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=ET(y)|0;if((z|0)==0){A=12;break}kU(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=IS(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((nS(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((nS(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((nS(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((nS(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(nS(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(nS(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(nS(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(nS(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){kU(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=IS(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((nS(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((nS(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((nS(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((nS(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(nS(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(nS(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(nS(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(nS(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((rS(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=DS(X)|0;qb=_a+24|0;if((rS(fb,c[qb>>2]|0)|0)!=0){break}fb=BS(X)|0;if((rS(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((rS(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=BS(X)|0;if((rS(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=DS(X)|0;if((rS(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}FT(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=aT(0,0)|0;if((S|0)==0){A=12;break}R=cT(S,0,0,0,32)|0;Q=R;if((R|0)==0){bT(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=ET(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=ET(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=ET(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){kU(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){kU(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=IS(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((nS(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((nS(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((nS(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((nS(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(nS(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(nS(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(nS(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(nS(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=cT(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=cT(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;$S(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((dU(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=IS(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=IS(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((nS(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((nS(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((nS(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((nS(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(nS(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(nS(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(nS(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(nS(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((rS(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=DS(tc)|0;aa=Ca+24|0;if((rS(qa,c[aa>>2]|0)|0)!=0){break}qa=BS(tc)|0;if((rS(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((rS(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=BS(tc)|0;if((rS(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=DS(tc)|0;if((rS(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=cT(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=cT(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){bT(S);if((Eb|0)!=0){FT(O)}if((Kb|0)!=0){FT(Kb)}if((Lb|0)==0){A=12;break a}FT(N);A=12;break a}else if((sa|0)==67){bT(S);if((Eb|0)!=0){FT(O)}if((Kb|0)!=0){FT(Kb)}if((Lb|0)==0){A=12;break a}FT(N);A=12;break a}else if((sa|0)==169){bT(S);if((Eb|0)!=0){FT(O)}if((Kb|0)!=0){FT(Kb)}if((Lb|0)==0){A=12;break a}FT(N);A=12;break a}else if((sa|0)==176){bT(S);if((Eb|0)!=0){FT(O)}if((Kb|0)!=0){FT(Kb)}if((Lb|0)==0){A=12;break a}FT(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);bT(S);if((Jb|0)!=0){FT(Jb)}if((Gb|0)!=0){FT(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}FT(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}$S(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}FT(m);p=A;i=g;return p|0}function $S(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function aT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=GT(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function bT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;FT(e);i=b;return}else{f=d}while(1){FT(c[f>>2]|0);d=c[f+4>>2]|0;FT(f);if((d|0)==0){break}else{f=d}}e=a;FT(e);i=b;return}function cT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=ET(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=ET(p)|0;c[o>>2]=r;if((r|0)==0){FT(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}kU(m|0,0,h|0)|0;j=m;i=g;return j|0}function dT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((eT(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function eT(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function fT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function gT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function hT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function iT(a){a=a|0;i=i;return}function jT(a){a=a|0;c[a>>2]=108144;i=i;return}function kT(a){a=a|0;var b=0;b=i;vb(a|0);MT(a);i=b;return}function lT(a){a=a|0;var b=0;b=i;vb(a|0);i=b;return}function mT(a){a=a|0;i=i;return 108160}function nT(a){a=a|0;i=i;return}function oT(a){a=a|0;i=i;return}function pT(a){a=a|0;i=i;return}function qT(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function rT(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function sT(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function tT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=xT(b,108272,108328,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;re[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function uT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function vT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;re[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function wT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;re[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;re[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function xT(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;ce[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Qd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function yT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;ce[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Qd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Qd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Qd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Qd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function zT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Qd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;ce[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function AT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function BT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;ce[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;ce[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function CT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;ce[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function DT(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function ET(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[27144]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=108616+(j<<2)|0;l=108616+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[27144]=f&~(1<<h)}else{if(n>>>0<(c[108592>>2]|0)>>>0){Zc()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{Zc()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[108584>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=108616+(r<<2)|0;o=108616+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[27144]=f&~(1<<t)}else{if(n>>>0<(c[108592>>2]|0)>>>0){Zc()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{Zc()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[108584>>2]|0;if((n|0)!=0){f=c[108596>>2]|0;e=n>>>3;n=e<<1;g=108616+(n<<2)|0;m=c[27144]|0;j=1<<e;do{if((m&j|0)==0){c[27144]=m|j;u=108616+(n+2<<2)|0;v=g}else{e=108616+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[108592>>2]|0)>>>0)){u=e;v=h;break}Zc()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[108584>>2]=o;c[108596>>2]=s;p=k;i=b;return p|0}n=c[108580>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[108880+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[108592>>2]|0;if(h>>>0<k>>>0){Zc()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){Zc()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){Zc()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){Zc()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){Zc()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{Zc()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=108880+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<h);break a}else{if(s>>>0<(c[108592>>2]|0)>>>0){Zc()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[108592>>2]|0)>>>0){Zc()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[108584>>2]|0;if((h|0)!=0){s=c[108596>>2]|0;k=h>>>3;h=k<<1;f=108616+(h<<2)|0;m=c[27144]|0;g=1<<k;do{if((m&g|0)==0){c[27144]=m|g;A=108616+(h+2<<2)|0;B=f}else{k=108616+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[108592>>2]|0)>>>0)){A=k;B=e;break}Zc()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[108584>>2]=t;c[108596>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[108580>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[108880+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[108880+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[108584>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[108592>>2]|0;if(t>>>0<f>>>0){Zc()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){Zc()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){Zc()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){Zc()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){Zc()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{Zc()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=108880+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<e);break c}else{if(t>>>0<(c[108592>>2]|0)>>>0){Zc()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[108592>>2]|0)>>>0){Zc()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=108616+(t<<2)|0;s=c[27144]|0;r=1<<e;do{if((s&r|0)==0){c[27144]=s|r;S=108616+(t+2<<2)|0;T=f}else{e=108616+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[108592>>2]|0)>>>0)){S=e;T=k;break}Zc()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=108880+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[108580>>2]|0;l=1<<U;if((f&l|0)==0){c[108580>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[108592>>2]|0;if(W>>>0<k>>>0){Zc()}if(r>>>0<k>>>0){Zc()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[108584>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[108596>>2]|0;if(W>>>0>15){c[108596>>2]=X+q;c[108584>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[108584>>2]=0;c[108596>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[108588>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[108588>>2]=W;X=c[108600>>2]|0;c[108600>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[27262]|0)==0){X=Xc(30)|0;if((X+ -1&X|0)==0){c[109056>>2]=X;c[109052>>2]=X;c[109060>>2]=-1;c[109064>>2]=-1;c[109068>>2]=0;c[109020>>2]=0;c[27262]=(lc(0)|0)&-16^1431655768;break}else{Zc()}}}while(0);X=q+48|0;W=c[109056>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[109016>>2]|0;do{if((U|0)!=0){T=c[109008>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[109020>>2]&4|0)==0){U=c[108600>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=109024|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[108588>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=gb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=gb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[109052>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[109008>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[109016>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=gb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[109056>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((gb(t|0)|0)==(-1|0)){gb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[109020>>2]=c[109020>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=gb(W|0)|0;ha=gb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[109008>>2]|0)+ga|0;c[109008>>2]=ia;if(ia>>>0>(c[109012>>2]|0)>>>0){c[109012>>2]=ia}ia=c[108600>>2]|0;W=109024|0;i:do{if((ia|0)==0){aa=c[108592>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[108592>>2]=fa}c[109024>>2]=fa;c[109028>>2]=ga;c[109036>>2]=0;c[108612>>2]=c[27262];c[108608>>2]=-1;aa=0;do{ha=aa<<1;$=108616+(ha<<2)|0;c[108616+(ha+3<<2)>>2]=$;c[108616+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[108600>>2]=fa+ja;c[108588>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[108604>>2]=c[109064>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[108588>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[108600>>2]=ia+na;c[108588>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[108604>>2]=c[109064>>2];break i}}while(0);if(fa>>>0<(c[108592>>2]|0)>>>0){c[108592>>2]=fa}aa=fa+ga|0;$=109024|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[108600>>2]|0)){ca=(c[108588>>2]|0)+X|0;c[108588>>2]=ca;c[108600>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[108596>>2]|0)){ca=(c[108584>>2]|0)+X|0;c[108584>>2]=ca;c[108596>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=108616+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[108592>>2]|0)>>>0){Zc()}if((c[V+12>>2]|0)==(ha|0)){break}Zc()}}while(0);if((L|0)==(V|0)){c[27144]=c[27144]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[108592>>2]|0)>>>0){Zc()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}Zc()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[108592>>2]|0)>>>0){Zc()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){Zc()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{Zc()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=108880+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<t);break k}else{if(T>>>0<(c[108592>>2]|0)>>>0){Zc()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[108592>>2]|0)>>>0){Zc()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=108616+(Z<<2)|0;t=c[27144]|0;T=1<<ca;do{if((t&T|0)==0){c[27144]=t|T;xa=108616+(Z+2<<2)|0;ya=ea}else{ca=108616+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[108592>>2]|0)>>>0)){xa=ca;ya=V;break}Zc()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=108880+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[108580>>2]|0;L=1<<za;if((ea&L|0)==0){c[108580>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[108592>>2]|0;if(Ba>>>0<S>>>0){Zc()}if(T>>>0<S>>>0){Zc()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=109024|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[108600>>2]=fa+Ha;c[108588>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[108604>>2]=c[109064>>2];c[ba+4>>2]=27;X=109024|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[109024>>2]=fa;c[109028>>2]=ga;c[109036>>2]=0;c[109032>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=108616+(da<<2)|0;aa=c[27144]|0;f=1<<M;do{if((aa&f|0)==0){c[27144]=aa|f;Ia=108616+(da+2<<2)|0;Ja=ha}else{M=108616+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[108592>>2]|0)>>>0)){Ia=M;Ja=T;break}Zc()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=108880+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[108580>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[108580>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[108592>>2]|0;if(Ma>>>0<f>>>0){Zc()}if(M>>>0<f>>>0){Zc()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[108588>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[108588>>2]=W;ia=c[108600>>2]|0;c[108600>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Gc()|0)>>2]=12;p=0;i=b;return p|0}function FT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[108592>>2]|0;if(d>>>0<f>>>0){Zc()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){Zc()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){Zc()}if((p|0)==(c[108596>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[108584>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=108616+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){Zc()}if((c[m+12>>2]|0)==(p|0)){break}Zc()}}while(0);if((u|0)==(m|0)){c[27144]=c[27144]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){Zc()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}Zc()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){Zc()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){Zc()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){Zc()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{Zc()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=108880+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[108592>>2]|0)>>>0){Zc()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[108592>>2]|0)>>>0){Zc()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){Zc()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){Zc()}do{if((C&2|0)==0){if((l|0)==(c[108600>>2]|0)){f=(c[108588>>2]|0)+t|0;c[108588>>2]=f;c[108600>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[108596>>2]|0)){i=b;return}c[108596>>2]=0;c[108584>>2]=0;i=b;return}if((l|0)==(c[108596>>2]|0)){f=(c[108584>>2]|0)+t|0;c[108584>>2]=f;c[108596>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=108616+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[108592>>2]|0)>>>0){Zc()}if((c[E+12>>2]|0)==(l|0)){break}Zc()}}while(0);if((w|0)==(E|0)){c[27144]=c[27144]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[108592>>2]|0)>>>0){Zc()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}Zc()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[108592>>2]|0)>>>0){Zc()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){Zc()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{Zc()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=108880+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<g);break b}else{if(d>>>0<(c[108592>>2]|0)>>>0){Zc()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[108592>>2]|0)>>>0){Zc()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[108596>>2]|0)){J=f;break}c[108584>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=108616+(C<<2)|0;G=c[27144]|0;j=1<<t;do{if((G&j|0)==0){c[27144]=G|j;K=108616+(C+2<<2)|0;L=e}else{t=108616+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[108592>>2]|0)>>>0)){K=t;L=a;break}Zc()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=108880+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[108580>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[108580>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[108592>>2]|0;if(O>>>0<K>>>0){Zc()}if(f>>>0<K>>>0){Zc()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[108608>>2]|0)+ -1|0;c[108608>>2]=s;if((s|0)==0){Q=109032|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[108608>>2]=-1;i=b;return}function GT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=ET(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}kU(b|0,0,e|0)|0;i=d;return b|0}function HT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=ET(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Gc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=IT(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=ET(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;iU(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;FT(a);e=g;i=d;return e|0}function IT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[108592>>2]|0;if(h>>>0<l>>>0){Zc()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){Zc()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){Zc()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[109056>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;JT(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[108600>>2]|0)){m=(c[108588>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[108600>>2]=a+b;c[108588>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[108596>>2]|0)){h=(c[108584>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[108584>>2]=r;c[108596>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=108616+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){Zc()}if((c[h+12>>2]|0)==(k|0)){break}Zc()}}while(0);if((m|0)==(h|0)){c[27144]=c[27144]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){Zc()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}Zc()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){Zc()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){Zc()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){Zc()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{Zc()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=108880+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<u);break a}else{if(t>>>0<(c[108592>>2]|0)>>>0){Zc()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[108592>>2]|0)>>>0){Zc()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;JT(a+b|0,r);o=a;i=d;return o|0}return 0}function JT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[108592>>2]|0;if(j>>>0<m>>>0){Zc()}if((k|0)==(c[108596>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[108584>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=108616+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){Zc()}if((c[q+12>>2]|0)==(k|0)){break}Zc()}}while(0);if((r|0)==(q|0)){c[27144]=c[27144]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){Zc()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}Zc()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){Zc()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){Zc()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){Zc()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{Zc()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=108880+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[108592>>2]|0)>>>0){Zc()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[108592>>2]|0)>>>0){Zc()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[108592>>2]|0;if(e>>>0<z>>>0){Zc()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[108600>>2]|0)){t=(c[108588>>2]|0)+p|0;c[108588>>2]=t;c[108600>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[108596>>2]|0)){i=d;return}c[108596>>2]=0;c[108584>>2]=0;i=d;return}if((f|0)==(c[108596>>2]|0)){t=(c[108584>>2]|0)+p|0;c[108584>>2]=t;c[108596>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=108616+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){Zc()}if((c[u+12>>2]|0)==(f|0)){break}Zc()}}while(0);if((h|0)==(u|0)){c[27144]=c[27144]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){Zc()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}Zc()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){Zc()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){Zc()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){Zc()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{Zc()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=108880+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[108580>>2]=c[108580>>2]&~(1<<j);break b}else{if(m>>>0<(c[108592>>2]|0)>>>0){Zc()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[108592>>2]|0)>>>0){Zc()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[108592>>2]|0)>>>0){Zc()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[108596>>2]|0)){G=t;break}c[108584>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=108616+(B<<2)|0;D=c[27144]|0;b=1<<p;do{if((D&b|0)==0){c[27144]=D|b;H=108616+(B+2<<2)|0;I=A}else{p=108616+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[108592>>2]|0)>>>0)){H=p;I=a;break}Zc()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=108880+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[108580>>2]|0;B=1<<J;if((a&B|0)==0){c[108580>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[108592>>2]|0)>>>0){Zc()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[108592>>2]|0;if(L>>>0<B>>>0){Zc()}if(G>>>0<B>>>0){Zc()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function KT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=ET(d)|0;if((e|0)!=0){f=6;break}a=c[27268]|0;c[27268]=0+a;if((a|0)==0){f=5;break}oe[a&7]()}if((f|0)==5){d=xc(4)|0;c[d>>2]=109088;Fd(d|0,109136,136)}else if((f|0)==6){i=b;return e|0}return 0}function LT(a){a=a|0;var b=0,c=0;b=i;c=KT(a)|0;i=b;return c|0}function MT(a){a=a|0;var b=0;b=i;if((a|0)!=0){FT(a)}i=b;return}function NT(a){a=a|0;var b=0;b=i;MT(a);i=b;return}function OT(a){a=a|0;var b=0;b=i;vb(a|0);MT(a);i=b;return}function PT(a){a=a|0;var b=0;b=i;vb(a|0);i=b;return}function QT(a){a=a|0;i=i;return 109104}function RT(){var a=0;a=xc(4)|0;c[a>>2]=109088;Fd(a|0,109136,136)}



function oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5208]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+1032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(5224,cq(+h[(c[g>>2]|0)+1032>>3],5216)|0)|0;g=c[16934]|0;j=e;k=5384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[5208]=1;i=d;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5408]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+1e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(5416,cq(+h[(c[g>>2]|0)+1e3>>3],5216)|0)|0;g=c[16934]|0;j=e;k=5600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[5408]=1;i=d;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5624]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(5632,cq(+h[(c[g>>2]|0)+992>>3],5216)|0)|0;g=c[16934]|0;j=e;k=5736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[5624]=1;i=d;return}function rj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5760]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(5768,cq(+h[(c[g>>2]|0)+984>>3],5216)|0)|0;g=c[16934]|0;j=e;k=5872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[5760]=1;i=d;return}function sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5896]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(5904,cq(+h[(c[g>>2]|0)+976>>3],5216)|0)|0;g=c[16934]|0;j=e;k=6008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[5896]=1;i=d;return}function tj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6032]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6040,cq(+h[(c[g>>2]|0)+968>>3],5216)|0)|0;g=c[16934]|0;j=e;k=6344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6032]=1;i=d;return}function uj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6136]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6144,cq(+h[(c[g>>2]|0)+960>>3],5216)|0)|0;g=c[16934]|0;j=e;k=6472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6136]=1;i=d;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6240]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6248,cq(+h[(c[g>>2]|0)+944>>3],5216)|0)|0;g=c[16934]|0;j=e;k=6344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6240]=1;i=d;return}function wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6368]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6376,cq(+h[(c[g>>2]|0)+936>>3],5216)|0)|0;g=c[16934]|0;j=e;k=6472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6368]=1;i=d;return}function xj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6496]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+904>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gq(6504,cq(+h[(c[g>>2]|0)+904>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6496]=1;i=d;return}function yj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6712]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6720,cq(+h[(c[g>>2]|0)+888>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6712]=1;i=d;return}function zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6848]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6856,cq(+h[(c[g>>2]|0)+880>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6848]=1;i=d;return}function Aj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6984]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(6992,cq(+h[(c[g>>2]|0)+872>>3],5216)|0)|0;g=c[16934]|0;j=e;k=8008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[6984]=1;i=d;return}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7136]&1){i=d;return}g=b+420|0;b=Fs(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Ds(+(c[(c[g>>2]|0)+20>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gq(7144,eq(c[(c[g>>2]|0)+20>>2]|0,4856)|0)|0;g=c[16934]|0;h=e;j=8272;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ne[g&15](e,b,f);a[7136]=1;i=d;return}function Cj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7376]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+864>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gq(7384,cq(+h[(c[g>>2]|0)+864>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[7376]=1;i=d;return}function Dj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7536]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(7544,cq(+h[(c[g>>2]|0)+848>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[7536]=1;i=d;return}function Ej(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7696]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(7704,cq(+h[(c[g>>2]|0)+840>>3],5216)|0)|0;g=c[16934]|0;j=e;k=7832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[7696]=1;i=d;return}function Fj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7856]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(7864,cq(+h[(c[g>>2]|0)+832>>3],5216)|0)|0;g=c[16934]|0;j=e;k=8008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[7856]=1;i=d;return}function Gj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8032]&1){i=d;return}g=b+420|0;b=Fs(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Ds(+(c[(c[g>>2]|0)+16>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gq(8040,eq(c[(c[g>>2]|0)+16>>2]|0,4856)|0)|0;g=c[16934]|0;h=e;j=8272;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ne[g&15](e,b,f);a[8032]=1;i=d;return}function Hj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8296]&1){i=d;return}g=b+420|0;b=Fs(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Ds(+(c[(c[g>>2]|0)+12>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gq(8304,eq(c[(c[g>>2]|0)+12>>2]|0,4856)|0)|0;g=c[16934]|0;h=e;j=8512;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ne[g&15](e,b,f);a[8296]=1;i=d;return}function Ij(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8536]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(8544,cq(+h[(c[g>>2]|0)+824>>3],5216)|0)|0;g=c[16934]|0;j=e;k=8656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[8536]=1;i=d;return}function Jj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8680]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+792>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gq(8688,cq(+h[(c[g>>2]|0)+792>>3],5216)|0)|0;g=c[16934]|0;j=e;k=8784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[8680]=1;i=d;return}function Kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8808]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(8816,cq(+h[(c[g>>2]|0)+768>>3],5216)|0)|0;g=c[16934]|0;j=e;k=8912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[8808]=1;i=d;return}function Lj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8936]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(8944,cq(+h[(c[g>>2]|0)+736>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[8936]=1;i=d;return}function Mj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9144]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(9152,cq(+h[(c[g>>2]|0)+720>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[9144]=1;i=d;return}function Nj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9352]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(9360,cq(+h[(c[g>>2]|0)+664>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[9352]=1;i=d;return}function Oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9472]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(9480,cq(+h[(c[g>>2]|0)+632>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[9472]=1;i=d;return}function Pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9608]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(9616,cq(+h[(c[g>>2]|0)+616>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[9608]=1;i=d;return}function Qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9744]&1){i=d;return}g=b+416|0;if(!((Fs(+h[(c[g>>2]|0)+560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gq(9752,cq(+h[(c[g>>2]|0)+560>>3],5216)|0)|0;g=c[16934]|0;j=e;k=9840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ne[g&15](e,b,f);a[9744]=1;i=d;return}function Rj(a){a=a|0;var b=0;b=i;ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);Qj(a);i=b;return 0}function Sj(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Tj(b);i=c;return 0}function Tj(a){a=a|0;var b=0;b=i;Pe(a);Qe(a);Re(a);Se(a);Te(a);Ue(a);Ve(a);We(a);Xe(a);Ye(a);Ze(a);_e(a);$e(a);af(a);bf(a);cf(a);df(a);ef(a);ff(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);i=b;return}function Uj(a){a=a|0;i=i;return 0}function Vj(a){a=a|0;i=i;return 1}function Wj(a){a=a|0;i=i;return 1}function Xj(a){a=a|0;i=i;return 1}function Yj(a){a=a|0;i=i;return 1}function Zj(a){a=a|0;i=i;return 1}function _j(a){a=a|0;i=i;return 0}function $j(a){a=a|0;i=i;return 0}function ak(a){a=a|0;i=i;return 0}function bk(a){a=a|0;i=i;return 0}function ck(a){a=a|0;i=i;return 0}function dk(a,b){a=a|0;b=b|0;i=i;return-1}function ek(a,b){a=a|0;b=b|0;i=i;return-1}function fk(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function gk(){i=i;return 9864}function hk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=d;f=b;b=qk(a)|0;a=qk(f)|0;if((b|0)!=0){g=(a|0)==0?2:1;h=g;i=d;return h|0}if((a|0)!=0){c[e>>2]=f;_q(10672,e)}g=0;h=g;i=d;return h|0}function ik(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0;g=i;i=i+120|0;j=a;a=b;b=d;d=e;e=f;f=0;do{if((j|0)!=0){if((d|0)==0){break}if(!(a>>>0>2)){break}f=ET((fa(a-1|0,e)|0)*24|0)|0;if((f|0)==0){Yq(10544);k=0;l=k;i=g;return l|0}m=ET(a+3<<3)|0;if((m|0)==0){FT(f);Yq(10544);k=0;l=k;i=g;return l|0}n=0;while(1){if(!(n>>>0<e>>>0)){break}o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}p=fa(o+1|0,b)|0;q=fa(o,b)|0;r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];h[m+(o+2<<3)>>3]=(+h[j+(p+((c[d+(n<<2)>>2]|0)-1)<<3)>>3]- +h[j+(q+((c[d+(n<<2)>>2]|0)-1)<<3)>>3])/(r- +h[j+((fa(o,b)|0)<<3)>>3]);o=o+1|0}h[m>>3]=+h[m+16>>3]*3.0- +h[m+24>>3]*2.0;h[m+8>>3]=+h[m+16>>3]*2.0- +h[m+24>>3];h[m+(a+1<<3)>>3]=+h[m+(a<<3)>>3]*2.0- +h[m+(a-1<<3)>>3];h[m+(a+2<<3)>>3]=+h[m+(a<<3)>>3]*3.0- +h[m+(a-1<<3)>>3]*2.0;o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];s=r- +h[j+((fa(o,b)|0)<<3)>>3];q=f+(((fa(o,e)|0)+n|0)*24|0)|0;r=+U(+(+h[m+(o+3<<3)>>3]- +h[m+(o+2<<3)>>3]));t=r+ +U(+(+h[m+(o+1<<3)>>3]- +h[m+(o<<3)>>3]));r=+h[m+(o+1<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o<<3)>>3]))/t;h[q+16>>3]=(1.0-u)*+h[m+(o+1<<3)>>3]+u*+h[m+(o+2<<3)>>3]}else{h[q+16>>3]=.5*r+ +h[m+(o+2<<3)>>3]*.5}r=+U(+(+h[m+(o+4<<3)>>3]- +h[m+(o+3<<3)>>3]));t=r+ +U(+(+h[m+(o+2<<3)>>3]- +h[m+(o+1<<3)>>3]));r=+h[m+(o+2<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o+1<<3)>>3]))/t;t=(1.0-u)*+h[m+(o+2<<3)>>3]+u*+h[m+(o+3<<3)>>3]}else{t=.5*r+ +h[m+(o+3<<3)>>3]*.5}h[q+8>>3]=(+h[m+(o+2<<3)>>3]*3.0- +h[q+16>>3]*2.0-t)/s;h[q>>3]=(+h[q+16>>3]+t- +h[m+(o+2<<3)>>3]*2.0)/(s*s);o=o+1|0}n=n+1|0}FT(m)}}while(0);k=f;l=k;i=g;return l|0}function jk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;Yq(10632);i=e;return 1}function kk(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=a;if((c|0)!=0){FT(c);c=0}i=b;return}function lk(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,j=0.0,k=0,l=0,m=0,n=0;f=i;i=i+72|0;g=a;a=c;c=d;j=e;d=0;k=b-1|0;do{if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=c}else{b=c;if(j>=+h[g+((fa(c+1|0,a)|0)<<3)>>3]){d=b;break}l=b;m=l;i=f;return m|0}}while(0);while(1){n=d;if(!(k>>>0>(d+1|0)>>>0)){break}c=((n+k|0)>>>0)/2|0;b=c;if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=b;continue}else{d=b;continue}}l=n;m=l;i=f;return m|0}function mk(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+136|0;m=l+80|0;n=l+88|0;o=l+104|0;p=a;a=b;b=d;d=e;e=f;f=g;g=j;j=GT(1,44)|0;do{if((j|0)!=0){c[j+24>>2]=k;c[j+36>>2]=g;do{if(g>>>0>0){c[j+32>>2]=ET(c[j+36>>2]<<2)|0;q=j;if((c[j+32>>2]|0)!=0){iU(c[q+32>>2]|0,f|0,c[j+36>>2]<<2|0)|0;break}FT(q);Yq(10544);r=0;s=r;i=l;return s|0}}while(0);c[j+28>>2]=hk(p,a)|0;q=c[j+28>>2]|0;if((q|0)==1){c[j+4>>2]=ET((gU(p|0)|0)+1|0)|0;if((c[j+4>>2]|0)==0){if(g>>>0>0){FT(c[j+32>>2]|0)}FT(j);j=0;Yq(10544);break}mU(c[j+4>>2]|0,p|0)|0;c[j>>2]=ET((gU(a|0)|0)+1|0)|0;t=j;if((c[j>>2]|0)!=0){mU(c[t>>2]|0,a|0)|0;break}FT(c[t+4>>2]|0);if(g>>>0>0){FT(c[j+32>>2]|0)}FT(j);j=0;Yq(10544);break}else if((q|0)==0){c[j+12>>2]=d;c[j+16>>2]=e;c[j+8>>2]=b;do{if((c[j+24>>2]|0)==2){if((c[j+12>>2]|0)!=2){break}c[j+24>>2]=1}}while(0);t=j;if((nk(j)|0)==0){c[t+8>>2]=0;break}if((c[t+24>>2]|0)==2){c[j+40>>2]=ik(b,c[j+12>>2]|0,c[j+16>>2]|0,f,c[j+36>>2]|0)|0}c[j+8>>2]=ET((fa(c[j+12>>2]|0,c[j+16>>2]|0)|0)<<3)|0;if((c[j+8>>2]|0)!=0){iU(c[j+8>>2]|0,b|0,(fa(c[j+12>>2]|0,c[j+16>>2]|0)|0)<<3|0)|0;break}if(g>>>0>0){FT(c[j+32>>2]|0)}FT(j);j=0;Yq(10544);break}else if((q|0)==3){break}else if((q|0)==2){if((jk(p,1,n,m,j+8|0)|0)!=0){break}c[j+12>>2]=c[n>>2];c[j+16>>2]=c[n+4>>2];if((c[m>>2]|0)!=0){c[o>>2]=c[j+12>>2];c[o+4>>2]=c[j+16>>2];t=ET((fa(c[o>>2]|0,c[o+4>>2]|0)|0)<<3)|0;if((t|0)==0){if(g>>>0>0){FT(c[j+32>>2]|0)}FT(j);j=0;Yq(10544);break}u=0;while(1){if(!(u>>>0<(c[o+4>>2]|0)>>>0)){break}v=0;while(1){if(!(v>>>0<(c[o>>2]|0)>>>0)){break}w=(fa(v,c[o+4>>2]|0)|0)+u|0;h[t+((fa(u,c[o>>2]|0)|0)+v<<3)>>3]=+h[(c[j+8>>2]|0)+(w<<3)>>3];v=v+1|0}u=u+1|0}c[j+8>>2]=t;c[j+12>>2]=c[o+4>>2];c[j+16>>2]=c[o>>2];c[j+28>>2]=3}do{if((c[j+24>>2]|0)==2){if((c[j+12>>2]|0)!=2){break}c[j+24>>2]=1}}while(0);if((nk(j)|0)==0){break}if((c[j+24>>2]|0)!=2){break}c[j+40>>2]=ik(c[j+8>>2]|0,c[j+12>>2]|0,c[j+16>>2]|0,f,c[j+36>>2]|0)|0;break}else{Yq(10576);break}}else{Yq(10544)}}while(0);r=j;s=r;i=l;return s|0}function nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0;b=i;i=i+48|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a;a=1;a:do{if((g|0)!=0){j=c[g+12>>2]|0;l=c[g+16>>2]|0;mU(f|0,10760)|0;if((c[g+28>>2]|0)==0){m=f}else{m=c[g+4>>2]|0}do{if(!(j>>>0<1)){if(l>>>0<2){break}if((c[g+8>>2]|0)==0){break a}n=c[g+8>>2]|0;o=0;while(1){if(!(o>>>0<(j-1|0)>>>0)){break a}p=+h[n+((fa(o,l)|0)<<3)>>3];q=+h[n+((fa(o+1|0,l)|0)<<3)>>3];if(p>=q){break}o=o+1|0}c[d>>2]=m;c[d+4>>2]=j;c[d+8>>2]=l;c[d+12>>2]=m;c[d+16>>2]=o+1;n=d+20|0;h[k>>3]=p;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[d+28>>2]=m;c[d+32>>2]=o+2;n=d+36|0;h[k>>3]=q;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];_q(10768,d);a=0;r=a;s=r;i=b;return s|0}}while(0);c[e>>2]=m;c[e+4>>2]=j;c[e+8>>2]=l;_q(10904,e);a=0;r=a;s=r;i=b;return s|0}}while(0);r=a;s=r;i=b;return s|0}function ok(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;if((d|0)==0){i=b;return}do{if((c[d+8>>2]|0)!=0){if((c[d+28>>2]|0)!=1){e=5;break}FT(c[d+8>>2]|0);c[d+8>>2]=0}else{e=5}}while(0);do{if((e|0)==5){if((c[d+8>>2]|0)==0){break}if((c[d+28>>2]|0)!=0){if((c[d+28>>2]|0)!=3){break}}FT(c[d+8>>2]|0);c[d+8>>2]=0}}while(0);do{if((c[d+36>>2]|0)>>>0>0){if((c[d+32>>2]|0)==0){break}FT(c[d+32>>2]|0);c[d+32>>2]=0}}while(0);if((c[d+4>>2]|0)!=0){FT(c[d+4>>2]|0);c[d+4>>2]=0}if((c[d>>2]|0)!=0){FT(c[d>>2]|0);c[d>>2]=0}kk(c[d+40>>2]|0);FT(d);d=0;i=b;return}function pk(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;e=i;i=i+192|0;f=b;g=d;d=0.0;b=a;if((b|0)==0){j=d;i=e;return+j}if((c[b+8>>2]|0)==0){j=d;i=e;return+j}if((c[b+32>>2]|0)==0){j=d;i=e;return+j}a=c[b+8>>2]|0;k=c[b+12>>2]|0;l=c[b+16>>2]|0;m=(c[(c[b+32>>2]|0)+(f-1<<2)>>2]|0)-1|0;if((k|0)==1){d=+h[a+(m<<3)>>3];j=d;i=e;return+j}n=0;do{if(g<+h[a>>3]){n=-1}else{if(!(g>+h[a+((fa(k-1|0,l)|0)<<3)>>3])){break}n=1}}while(0);if((n|0)!=0){if((n|0)==1){o=k-2|0}else{o=0}p=o;q=+h[a+((fa(p,l)|0)<<3)>>3];r=+h[a+((fa(p,l)|0)+m<<3)>>3];if((c[b+24>>2]|0)!=2){s=+h[a+((fa(p+1|0,l)|0)<<3)>>3];d=r+(+h[a+((fa(p+1|0,l)|0)+m<<3)>>3]-r)*(g-q)/(s-q);j=d;i=e;return+j}if((c[b+40>>2]|0)==0){j=d;i=e;return+j}o=(fa(p,c[b+36>>2]|0)|0)+(f-1)|0;t=(c[b+40>>2]|0)+(o*24|0)|0;if((n|0)==1){s=+h[a+((fa(p+1|0,l)|0)<<3)>>3];u=+h[a+((fa(p+1|0,l)|0)+m<<3)>>3];d=s-q;d=(+h[t>>3]*3.0*d+ +h[t+8>>3]*2.0)*d+ +h[t+16>>3];d=u+d*(g-s);j=d;i=e;return+j}else{d=r+ +h[t+16>>3]*(g-q);j=d;i=e;return+j}}t=lk(a,k,l,c[b+20>>2]|0,g)|0;c[b+20>>2]=t;k=c[b+24>>2]|0;if((k|0)==3){if(g>=+h[a+((fa(t+1|0,l)|0)<<3)>>3]){t=t+1|0}d=+h[a+((fa(t,l)|0)+m<<3)>>3];j=d;i=e;return+j}else if((k|0)==2){if((c[b+40>>2]|0)==0){j=d;i=e;return+j}p=(fa(t,c[b+36>>2]|0)|0)+(f-1)|0;f=(c[b+40>>2]|0)+(p*24|0)|0;g=g- +h[a+((fa(t,l)|0)<<3)>>3];d=+h[a+((fa(t,l)|0)+m<<3)>>3];d=d+((+h[f>>3]*g+ +h[f+8>>3])*g+ +h[f+16>>3])*g;j=d;i=e;return+j}else if((k|0)==1){q=+h[a+((fa(t,l)|0)<<3)>>3];r=+h[a+((fa(t+1|0,l)|0)<<3)>>3];s=+h[a+((fa(t,l)|0)+m<<3)>>3];d=s+(+h[a+((fa(t+1|0,l)|0)+m<<3)>>3]-s)*(g-q)/(r-q);j=d;i=e;return+j}else{Yq(10600);j=d;i=e;return+j}return 0.0}function qk(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+32|0;d=b;b=0;a:do{if((d|0)!=0){if((cU(d,10760)|0)==0){break}e=gU(d|0)|0;f=0;while(1){if(!(f>>>0<e>>>0)){break a}if((a[d+f|0]|0)!=32){break}f=f+1|0}b=1}}while(0);i=c;return b|0}function rk(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=sk(a,0,0)|0;i=b;return c|0}function sk(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=tk(a,b,c,0)|0;i=d;return e|0}function tk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=Wd[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=ET(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=47;c[f+8>>2]=187}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=Wd[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){Td[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=Wd[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){Td[c[b+20>>2]&255](c[j+392>>2]|0);Td[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=El(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}Td[c[j+20>>2]&255](c[j+44>>2]|0);Td[c[j+20>>2]&255](c[j+392>>2]|0);Td[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Fl(j+416|0,j+12|0);Fl(j+440|0,j+12|0);vk(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}yk(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Zl()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Ql()|0}k=j;l=k;i=g;return l|0}function uk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function vk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=35;io(f+256|0);if((b|0)!=0){g=wk(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Rl(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function wk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Nk(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function xk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Qk(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=wk(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Nk(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Nk(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Uk(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Nk(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Qk(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function yk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;Td[c[e+20>>2]&255](c[g+36>>2]|0);zk(c[g+44>>2]|0,e);Td[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;Td[c[e+20>>2]&255](f)}zk(c[h+376>>2]|0,e);zk(c[e+372>>2]|0,e);Ak(e+416|0);Ak(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Bk(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);Td[c[e+20>>2]&255](c[e+392>>2]|0);Td[c[e+20>>2]&255](c[e+464>>2]|0);Td[c[e+20>>2]&255](c[e+8>>2]|0);Td[c[e+20>>2]&255](c[e+44>>2]|0);Td[c[e+20>>2]&255](c[e+396>>2]|0);Td[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){Td[c[e+252>>2]&255](c[e+244>>2]|0)}Td[c[e+20>>2]&255](e);i=d;return}function zk(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;Td[c[a+20>>2]&255](c[b+16>>2]|0);Td[c[a+20>>2]&255](b)}i=d;return}function Ak(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Td[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;Td[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function Bk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Ok(f,g+20|0);while(1){d=Pk(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}Td[c[b+8>>2]&255](c[d+20>>2]|0)}Tk(g);Tk(g+132|0);Tk(g+20|0);Tk(g+40|0);Tk(g+60|0);Ak(g+80|0);Ak(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Td[m&255](o);i=e;return}Td[c[b+8>>2]&255](c[g+184>>2]|0);Td[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;Td[m&255](o);i=e;return}function Ck(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Dk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Ek(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Fk(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Hk(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{iU(f|0,b|0,d|0)|0;j=Ik(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=qe[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=36;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){re[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function Fk(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Cl()|0}if((a[e+236|0]|0)!=0){f=xk(e,12768)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Gk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Hk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;jU(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=Wd[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;iU(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;Td[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Ik(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Fk(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=qe[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=36;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);re[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Jk(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Kk(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}re[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Lk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ne[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Qd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ne[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Mk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[10992+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;iU((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=he[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=Wd[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){iU(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Ok(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Qk(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=Wd[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){kU(c[m>>2]|0,0,g|0)|0;g=Rk(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Rk(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Sk(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=Wd[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}kU(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Rk(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}Td[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=Wd[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){kU(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Rk(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Sk(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Tk(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}Td[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}Td[e&255](c[d>>2]|0);i=b;return}function Uk(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[12576+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[12616+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=he[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=Wd[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=Wd[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}Td[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;iU(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ne[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Vk(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if(($d[((a[e+236|0]&255|0)!=0?32:33)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Bl(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Wk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=qe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Xk(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Xk(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ie[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=Yk(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Qk(o,l+132|0,12648,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((qe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=Zk(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}_k(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Zk(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}Qd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;uk(o+416|0);h=0;break};case 57:{v=Yk(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=bl(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Qd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);uk(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Qk(o,l+132|0,12648,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ie[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Wd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}Td[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=al(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=12752}else{x=(s|0)==32?12736:12760}if((cl(o+416|0,x)|0)==0){r=111;break a}if((dl(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=12656;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=12664;r=102;break};case 25:{c[o+332>>2]=12672;r=102;break};case 26:{c[o+332>>2]=12680;r=102;break};case 27:{c[o+332>>2]=12688;r=102;break};case 28:{c[o+332>>2]=12696;r=102;break};case 29:{c[o+332>>2]=12712;r=102;break};case 30:{c[o+332>>2]=12720;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((el(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Nk(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Nk(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ce[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);uk(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Zk(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=12648}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Wd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Qk(o,l+132|0,12648,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=fl(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((el(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Nk(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Nk(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ce[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);uk(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=gl(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;ge[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ge[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=Zk(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;ce[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ge[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if(($d[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Zk(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Qk(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Zk(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Qk(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Zk(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Lk(o,b,e,c[n>>2]|0)}h=0;D=hl(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((qe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=Zk(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}_k(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=Zk(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Qd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);uk(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Qd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);uk(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=Wd[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=he[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=he[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=jl(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=Zk(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Qk(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ne[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=kl(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ie[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((Wd[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=al(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=Wd[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ne[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((nl(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((ml(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((qe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Zk(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=jl(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=al(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=ll(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ne[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Zk(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}_k(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Lk(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=qe[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ie[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=Qk(o,l+132|0,12648,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ie[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((Wd[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=37;I=$k(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=38;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Yk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((Vd[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Zk(n+440|0,p,b,s+(he[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Zk(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);re[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Lk(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Zk(n+440|0,e,d,m+(he[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Bl(n,f)|0;uk(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){uk(n+440|0)}q=0;r=q;i=g;return r|0}function Zk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((dl(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Nk(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}



function ST(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,tc=0,uc=0,vc=0,wc=0,xc=0.0,yc=0,zc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Hc=0,Ic=0,Jc=0.0,Kc=0,Lc=0.0,Mc=0;g=i;i=i+512|0;h=g;if((e|0)==0){j=24;k=-149}else if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=VT(b)|0}}while(($c(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=VT(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[109152+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=VT(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[109168+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=VT(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=VT(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=VT(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Gc()|0)>>2]=22;UT(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=VT(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=VT(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=VT(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=VT(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=VT(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=qU(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=qU(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=VT(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){UT(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=qU(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=TT(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){UT(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=lU(q|0,n|0,2)|0;o=qU(p|0,J|0,-32,-1)|0;p=qU(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Gc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Gc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=qU(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=pU(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=qU(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+Dd(+(+WT(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Gc()|0)>>2]=34}l=+XT(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=VT(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=VT(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=VT(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=qU(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=qU(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=VT(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=TT(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){UT(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=qU(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Gc()|0)>>2]=22;UT(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Gc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Gc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[109184+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[109184+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[109184+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=lU(c[Wa>>2]|0,0,29)|0;Va=qU(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=AU(Va|0,Ya|0,1e9,0)|0;Ta=BU(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=lU(c[Za>>2]|0,0,29)|0;Wa=qU(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=AU(Wa|0,Xa|0,1e9,0)|0;Ua=BU(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[109176+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;tc=0;Ua=nc;uc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+tc|0;c[Wa>>2]=Xa;tc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;uc=Va?uc+ -9|0:uc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((tc|0)==0){sa=rc;u=qc;$a=uc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=uc}c[h+(hc<<2)>>2]=tc;ec=rc;fc=qc;gc=uc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;vc=mc}else{vc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(vc|0)){u=vc+1&127;c[h+(u+ -1<<2)>>2]=0;wc=u}else{wc=vc}pa=+(r|0);xc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){yc=(u|0)<0?0:u;zc=1}else{yc=j;zc=0}if((yc|0)<53){za=+Dd(+(+WT(1.0,105-yc|0)),+xc);Ac=+sc(+xc,+(+WT(1.0,53-yc|0)));Bc=za;Cc=Ac;Dc=za+(xc-Ac)}else{Bc=0.0;Cc=0.0;Dc=xc}sa=nc+2&127;do{if((sa|0)==(wc|0)){Ec=Cc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(wc|0)){Fc=Cc;break}}Fc=pa*.25+Cc}else{if(ra>>>0>5e8){Fc=pa*.75+Cc;break}if((nc+3&127|0)==(wc|0)){Fc=pa*.5+Cc;break}else{Fc=pa*.75+Cc;break}}}while(0);if((53-yc|0)<=1){Ec=Fc;break}if(+sc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Bc;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Hc=zc;Ic=oc;Jc=pa}else{Hc=(zc|0)!=0&(yc|0)==(u|0)?0:zc;Ic=oc+1|0;Jc=pa*.5}if((Ic+50|0)<=(p|0)){if(!((Hc|0)!=0&Ec!=0.0)){Kc=Ic;Lc=Jc;break}}c[(Gc()|0)>>2]=34;Kc=Ic;Lc=Jc}else{Kc=oc;Lc=pa}}while(0);l=+XT(Lc,Kc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Gc()|0)>>2]=22;UT(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Mc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Mc=Mc+ -1|0;}while(Mc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function TT(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=VT(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=VT(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=VT(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=zU(q|0,m|0,10,0)|0;b=J;g=qU(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=qU(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=VT(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=VT(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=pU(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function UT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function VT(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=ZT(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function WT(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=lU(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function XT(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+WT(a,b);i=c;return+d}function YT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){$d[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function ZT(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((YT(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if(($d[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function _T(a){a=a|0;var b=0,c=0.0;b=i;c=+$T(a,0);i=b;return+c}function $T(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;UT(e,0);h=+ST(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function aU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;UT(e,0);h=+ST(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function bU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function cU(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function dU(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function eU(){c[22372]=p;c[22414]=p;c[27056]=p;c[27286]=p}function fU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}_b(116);_b(111);_b(111);_b(32);_b(109);_b(97);_b(110);_b(121);_b(32);_b(115);_b(101);_b(116);_b(106);_b(109);_b(112);_b(115);_b(32);_b(105);_b(110);_b(32);_b(97);_b(32);_b(102);_b(117);_b(110);_b(99);_b(116);_b(105);_b(111);_b(110);_b(32);_b(99);_b(97);_b(108);_b(108);_b(44);_b(32);_b(98);_b(117);_b(105);_b(108);_b(100);_b(32);_b(119);_b(105);_b(116);_b(104);_b(32);_b(97);_b(32);_b(104);_b(105);_b(103);_b(104);_b(101);_b(114);_b(32);_b(118);_b(97);_b(108);_b(117);_b(101);_b(32);_b(102);_b(111);_b(114);_b(32);_b(77);_b(65);_b(88);_b(95);_b(83);_b(69);_b(84);_b(74);_b(77);_b(80);_b(83);_b(10);ga(0);return 0}function gU(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function hU(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function iU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return ib(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function jU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{iU(b,c,d)|0}return b|0}function kU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function lU(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function mU(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function nU(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function oU(){return nU(o)|0}function pU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function qU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function rU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function sU(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function tU(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function uU(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function vU(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function wU(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function xU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=pU(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=pU((CU(i,b,pU(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function yU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=pU(h^a,j^b,h,j)|0;b=J;CU(m,b,pU(k^d,l^e,k,l)|0,J,g)|0;l=pU(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function zU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=wU(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function AU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=CU(a,b,c,d,0)|0;return(J=J,e)|0}function BU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;CU(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function CU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((vU(l|0)|0)>>>0);return(J=n,o)|0}p=(uU(l|0)|0)-(uU(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(uU(l|0)|0)-(uU(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(uU(j|0)|0)+33-(uU(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=vU(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=qU(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;pU(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=pU(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function DU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Pd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function EU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Qd[a&31](b|0,c|0,d|0,e|0,f|0)}function FU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return Rd[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function GU(a,b){a=a|0;b=+b;Sd[a&1](+b)}function HU(a,b){a=a|0;b=b|0;Td[a&255](b|0)}function IU(a,b,c){a=a|0;b=b|0;c=c|0;Ud[a&63](b|0,c|0)}function JU(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return Vd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function KU(a,b){a=a|0;b=b|0;return Wd[a&127](b|0)|0}function LU(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Xd[a&1](b|0,c|0,+d,e|0)}function MU(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return Yd[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function NU(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return Zd[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function OU(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return _d[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function PU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return $d[a&63](b|0,c|0,d|0)|0}function QU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ae[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function RU(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;be[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function SU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ce[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function TU(a,b,c){a=a|0;b=b|0;c=+c;return de[a&1](b|0,+c)|0}function UU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ee[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function VU(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;fe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function WU(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ge[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function XU(a,b,c){a=a|0;b=b|0;c=c|0;return he[a&63](b|0,c|0)|0}function YU(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ie[a&63](b|0,c|0,d|0,e|0,f|0)|0}function ZU(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return je[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function _U(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return ke[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function $U(a){a=a|0;return le[a&7]()|0}function aV(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function bV(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ne[a&15](b|0,c|0,d|0)}function cV(a){a=a|0;oe[a&7]()}function dV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;pe[a&3](b|0,c|0,+d,e|0,f|0)}function eV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return qe[a&63](b|0,c|0,d|0,e|0)|0}function fV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;re[a&31](b|0,c|0,d|0,e|0)}function gV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function hV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function iV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function jV(a){a=+a;ga(3)}function kV(a){a=a|0;ga(4)}function lV(a){a=a|0;od(a|0)}function mV(a,b){a=a|0;b=b|0;ga(5)}function nV(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function oV(a){a=a|0;ga(7);return 0}function pV(a){a=a|0;return Hc(a|0)|0}function qV(a){a=a|0;return xd(a|0)|0}function rV(a){a=a|0;return pc(a|0)|0}function sV(a){a=a|0;return md(a|0)|0}function tV(a){a=a|0;return bd(a|0)|0}function uV(a){a=a|0;return hd(a|0)|0}function vV(a){a=a|0;return Qc(a|0)|0}function wV(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function xV(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function yV(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(10);return 0}function zV(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function AV(a,b,c){a=a|0;b=b|0;c=c|0;ga(12);return 0}function BV(a,b,c){a=a|0;b=b|0;c=c|0;return jd(a|0,b|0,c|0)|0}function CV(a,b,c){a=a|0;b=b|0;c=c|0;return bc(a|0,b|0,c|0)|0}function DV(a,b,c){a=a|0;b=b|0;c=c|0;return Yb(a|0,b|0,c|0)|0}function EV(a,b,c){a=a|0;b=b|0;c=c|0;return nd(a|0,b|0,c|0)|0}function FV(a,b,c){a=a|0;b=b|0;c=c|0;return kd(a|0,b|0,c|0)|0}function GV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function HV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function IV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(15)}function JV(a,b){a=a|0;b=+b;ga(16);return 0}function KV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(17)}function LV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(18)}function MV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(19)}function NV(a,b){a=a|0;b=b|0;ga(20);return 0}function OV(a,b){a=a|0;b=b|0;return Cd(a|0,b|0)|0}function PV(a,b){a=a|0;b=b|0;return ac(a|0,b|0)|0}function QV(a,b){a=a|0;b=b|0;return eb(a|0,b|0)|0}function RV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(21);return 0}function SV(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(22);return 0}function TV(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(23);return 0}function UV(){ga(24);return 0}function VV(){return fb()|0}function WV(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(25);return 0}function XV(a,b,c){a=a|0;b=b|0;c=c|0;ga(26)}function YV(){ga(27)}function ZV(){Nc()}function _V(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(28)}function $V(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(29);return 0}function aW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return kc(a|0,b|0,c|0,d|0)|0}function bW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Fc(a|0,b|0,c|0,d|0)|0}function cW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(30)}




// EMSCRIPTEN_END_FUNCS
var Pd=[gV,Or,Qr,Vr,JG,gV,gV,gV];var Qd=[hV,um,vm,_m,$m,En,Fn,ao,bo,co,AT,zT,yT,Ol,Pl,zp,xp,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV,hV];var Rd=[iV,jt];var Sd=[jV,As];var Td=[kV,Xf,Yf,Zf,_f,fi,ag,up,vv,yv,xv,zv,FL,EL,HL,GL,Av,Cv,Oy,kz,lz,mz,qL,pL,sL,rL,VF,fG,sG,tG,uG,wG,yG,mI,nI,tI,uI,AI,BI,HI,II,UI,TI,ZI,YI,$I,aJ,jJ,iJ,qK,pK,zK,yK,bL,aL,zL,yL,BL,AL,TL,SL,VL,UL,$L,_L,oK,aM,ZL,bM,dM,cM,lQ,jM,iM,oM,nM,NM,MM,pN,oN,DN,CN,RN,QN,dO,cO,qO,pO,tO,sO,xO,wO,IO,HO,TO,SO,cP,bP,nP,mP,xP,wP,FP,EP,LP,KP,RP,QP,WP,VP,dQ,cQ,BQ,AQ,_P,SQ,xR,wR,zR,yR,eM,kQ,nQ,KQ,_Q,jR,uR,vR,lT,kT,nT,qT,oT,pT,rT,sT,PT,OT,Nf,lV,Pe,Qe,Re,Se,Te,Ue,Ve,We,Xe,Ye,Ze,_e,$e,af,bf,cf,df,ef,ff,gf,hf,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,FT,wp,Ie,ks,os,js,mt,qs,kt,Uq,ts,rs,ss,ps,vs,lt,ws,ls,ys,QF,zs,MH,lI,mQ,fS,pP,mS,lS,kS,jS,iS,hS,zJ,bK,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV,kV];var Ud=[mV,$f,Tt,Dv,QK,oI,vI,CI,JI,cL,AO,BO,CO,DO,FO,GO,LO,MO,NO,OO,QO,RO,WO,XO,YO,ZO,$O,aP,fP,gP,hP,iP,kP,lP,UP,ZP,ER,GR,IR,FR,HR,JR,bs,_q,us,uy,Vt,Ut,Wt,au,mu,Xt,ku,Jx,Vx,Ux,Wx,Ex,Cx,Gx,XG,mV,mV,mV];var Vd=[nV,bm,Wl,Pr,Rr,Sr,Tr,Ur];var Wd=[oV,Kf,Sj,Jf,Ke,Le,Me,gi,ji,gg,ei,Rj,Uj,fg,dg,Vj,Wj,Xj,Yj,Zj,_j,$j,ak,bk,ck,pV,qV,rV,Vp,ET,sV,Hv,VK,Iv,YK,UK,BG,pI,hL,jL,kL,gL,wI,xI,DI,XK,KI,LI,VI,_I,XL,SN,KR,MR,OR,UR,WR,QR,SR,eO,LR,NR,PR,VR,XR,RR,TR,yO,zO,EO,JO,KO,PO,UO,VO,_O,dP,eP,jP,WQ,XQ,ZQ,AR,CR,BR,DR,OQ,PQ,RQ,eR,fR,iR,pR,qR,tR,mT,QT,tt,tV,uV,rt,st,vV,JF,kG,Gs,Ns,Ws,Hs,Qs,Xs,dI,ZT,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV,oV];var Xd=[wV,zq];var Yd=[xV,Cr];var Zd=[yV,cr];var _d=[zV,Gr];var $d=[AV,cg,lm,rm,Rm,Xm,vn,Bn,Ev,WK,_K,RK,dL,iL,qI,mL,EI,dJ,eJ,hM,mM,SP,XP,DQ,FQ,IQ,oQ,tQ,vQ,yQ,tT,SF,_l,Rl,Yl,cm,BV,CV,DV,nt,PF,LF,EV,XH,FV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV,AV];var ae=[GV,xN,AN,LN,NN,GV,GV,GV];var be=[HV,rO,uO,oP,sP,yP,AP,HV];var ce=[IV,rp,Fv,zG,eL,SK,qN,rN,vN,BN,EN,FN,JN,ON,TP,YP,DT,CT,BT,sp,IV,IV,IV,IV,IV,IV,IV,IV,IV,IV,IV,IV];var de=[JV,Mf];var ee=[KV,pM,rM,tM,vM,xM,zM,BM,DM,FM,HM,JM,OM,QM,SM,UM,WM,YM,_M,aN,cN,eN,gN,uN,wN,IN,KN,TN,UN,VN,WN,XN,fO,gO,hO,iO,jO,JP,PP,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV,KV];var fe=[LV,GP,MP,LV];var ge=[MV,YN,kO,MV];var he=[NV,Je,hg,eg,bg,dk,ek,nm,om,qm,Tm,Um,Wm,xn,yn,An,Gn,Hn,In,Jn,Kn,Ln,Mn,Nn,Jv,Kv,CG,DG,lL,rI,yI,nL,ZK,FI,MI,$K,CQ,EQ,GQ,sQ,uQ,wQ,bt,Ys,Rs,Is,OV,HT,Ll,Ml,Nl,PV,hq,Ls,QV,YS,NV,NV,NV,NV,NV,NV,NV,NV];var ie=[RV,fM,kM,JQ,VQ,YQ,zQ,NQ,QQ,dR,gR,oR,rR,jo,ap,bp,oo,lo,_o,$o,po,qo,ro,so,to,Qo,Ro,Ho,Ao,vo,uo,wo,xo,zo,yo,mo,ko,Bo,Co,Do,Eo,Fo,Go,Io,Jo,Ko,Lo,Po,No,Mo,Oo,Wo,So,To,Uo,Vo,Xo,Yo,Zo,cp,dp,ep,fp,sN];var je=[SV,yt];var ke=[TV,fk,TQ,UQ,LQ,MQ,$Q,bR,kR,mR,TV,TV,TV,TV,TV,TV];var le=[UV,gk,VV,Wp,iI,jI,gI,UV];var me=[WV,Fr];var ne=[XV,UF,cJ,YL,vq,Cp,Ot,Qt,ty,WG,XV,XV,XV,XV,XV,XV];var oe=[YV,ZV,Up,ip,Pf,YV,YV,YV];var pe=[_V,Os,Ps,_V];var qe=[$V,fm,gm,hm,im,jm,km,mm,pm,tm,Lm,Mm,Nm,Om,Pm,Qm,Sm,Vm,Zm,pn,qn,rn,sn,tn,un,wn,zn,Dn,HQ,pQ,qQ,rQ,xQ,ds,aW,Dl,Gk,$k,il,Wk,rl,wl,ul,xl,dm,Jl,Tl,Ul,$l,am,LM,yN,bW,$V,$V,$V,$V,$V,$V,$V,$V,$V,$V,$V];var re=[cW,sm,Ym,Cn,Gv,TF,AG,fL,TK,gM,lM,uT,vT,wT,Ap,yp,fs,Bp,yq,Ip,Vl,Dp,nH,cW,cW,cW,cW,cW,cW,cW,cW,cW];return{_testSetjmp:tU,_saveSetjmp:fU,_free:FT,_main:Of,_rand_r:nU,_realloc:HT,_i64Add:qU,_memmove:jU,_bitshift64Ashr:hU,_memset:kU,_malloc:ET,_strncpy:rU,_memcpy:iU,_strlen:gU,_bitshift64Lshr:sU,_bitshift64Shl:lU,_i64Subtract:pU,_strcpy:mU,_calloc:GT,_rand:oU,__GLOBAL__I_a:OI,runPostSets:eU,stackAlloc:se,stackSave:te,stackRestore:ue,setThrew:ve,setTempRet0:ye,setTempRet1:ze,setTempRet2:Ae,setTempRet3:Be,setTempRet4:Ce,setTempRet5:De,setTempRet6:Ee,setTempRet7:Fe,setTempRet8:Ge,setTempRet9:He,dynCall_iiiiiiii:DU,dynCall_viiiii:EU,dynCall_iiiiidiii:FU,dynCall_vd:GU,dynCall_vi:HU,dynCall_vii:IU,dynCall_iiiiiiiiiii:JU,dynCall_ii:KU,dynCall_viidi:LU,dynCall_iiiiiiiiiiiiii:MU,dynCall_iiiiiiiiiiiiiiiiiiiii:NU,dynCall_iiiiiiiiiiiiiiiiiiiiiii:OU,dynCall_iiii:PU,dynCall_viiiiid:QU,dynCall_viiiiiiii:RU,dynCall_viiiiii:SU,dynCall_iid:TU,dynCall_viiiiiii:UU,dynCall_viiiiiid:VU,dynCall_viiiiiiiii:WU,dynCall_iii:XU,dynCall_iiiiii:YU,dynCall_iiiiidi:ZU,dynCall_iiiiiiiii:_U,dynCall_i:$U,dynCall_iiiiiiiiii:aV,dynCall_viii:bV,dynCall_v:cV,dynCall_viidii:dV,dynCall_iiiii:eV,dynCall_viiii:fV}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_viidii": invoke_viidii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_strtok_r": _strtok_r, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_vasprintf": _vasprintf, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






