var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 153288;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 153328;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(154155);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,228,1,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,0,0,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,32,42,32,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,41,41,0,0,0,1,0,0,0,230,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,1,0,0,0,231,1,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,0,0,1,0,0,0,234,1,0,0,1,0,0,0,235,1,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,0,0,0,1,0,0,0,14,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,65,0,0,0,0,0,0,0,1,0,0,0,16,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,0,0,1,0,0,0,17,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,0,0,0,0,0,1,0,0,0,18,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,21,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,65,0,0,0,0,0,1,0,0,0,22,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,65,0,0,0,0,0,0,1,0,0,0,23,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,25,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,1,0,0,0,26,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,0,1,0,0,0,27,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,0,1,0,0,0,28,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,1,0,0,0,30,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,78,0,0,0,1,0,0,0,31,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,105,0,0,0,1,0,0,0,34,2,0,0,1,0,0,0,35,2,0,0,1,0,0,0,36,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,37,2,0,0,1,0,0,0,38,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,46,2,0,0,1,0,0,0,47,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,0,1,0,0,0,48,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,0,0,1,0,0,0,49,2,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,52,2,0,0,1,0,0,0,77,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,0,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,32,42,32,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,41,41,0,0,0,0,0,1,0,0,0,80,2,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,1,0,0,0,81,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,0,0,0,0,0,0,0,0,1,0,0,0,84,2,0,0,1,0,0,0,85,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,0,1,0,0,0,89,2,0,0,1,0,0,0,90,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,1,0,0,0,91,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,92,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,1,0,0,0,138,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,65,0,0,0,0,1,0,0,0,139,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,140,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,141,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,142,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,143,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,144,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,1,0,0,0,145,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,65,0,0,0,1,0,0,0,146,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,1,0,0,0,148,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,49,46,105,0,0,0,0,0,0,0,0,1,0,0,0,150,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,65,0,0,0,0,0,1,0,0,0,152,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,1,0,0,0,153,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,0,0,0,1,0,0,0,154,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,1,0,0,0,159,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,65,0,0,0,1,0,0,0,163,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,78,0,0,0,0,0,0,0,0,1,0,0,0,165,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,49,46,67,0,0,0,0,0,0,0,1,0,0,0,169,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,49,46,78,0,0,0,0,0,0,0,0,1,0,0,0,170,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,65,0,0,0,0,0,0,0,1,0,0,0,171,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,172,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,108,0,0,0,0,0,0,0,1,0,0,0,173,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,175,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,65,0,1,0,0,0,176,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,1,0,0,0,177,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,178,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,71,95,109,32,94,32,50,46,48,0,1,0,0,0,180,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,65,0,0,0,0,1,0,0,0,181,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,182,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,108,0,0,0,0,1,0,0,0,183,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,71,95,109,32,94,32,50,46,48,0,0,0,0,1,0,0,0,185,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,50,46,67,0,0,0,0,0,0,0,1,0,0,0,191,2,0,0,1,0,0,0,192,2,0,0,1,0,0,0,193,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,1,0,0,0,194,2,0,0,1,0,0,0,195,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,202,2,0,0,1,0,0,0,204,2,0,0,1,0,0,0,206,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,105,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,84,101,109,112,101,114,97,116,117,114,101,32,111,117,116,115,105,100,101,32,115,99,111,112,101,32,111,102,32,109,111,100,101,108,33,0,0,0,0,0,48,24,0,0,74,0,0,0,3,0,0,0,74,0,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,97,103,110,101,116,105,99,46,70,108,117,120,84,117,98,101,115,46,69,120,97,109,112,108,101,115,46,83,111,108,101,110,111,105,100,65,99,116,117,97,116,111,114,46,67,111,109,112,97,114,105,115,111,110,80,117,108,108,73,110,83,116,114,111,107,101,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,103,110,101,116,105,99,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,97,103,110,101,116,105,99,46,70,108,117,120,84,117,98,101,115,46,69,120,97,109,112,108,101,115,46,83,111,108,101,110,111,105,100,65,99,116,117,97,116,111,114,46,67,111,109,112,97,114,105,115,111,110,80,117,108,108,73,110,83,116,114,111,107,101,95,105,110,102,111,46,120,109,108,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,78,111,78,97,109,101,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,95,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,65,0,0,0,0,0,0,1,0,0,0,97,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,108,0,0,0,0,0,0,1,0,0,0,98,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,71,95,109,0,0,0,0,1,0,0,0,100,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,65,0,0,0,1,0,0,0,102,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,0,1,0,0,0,103,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,71,95,109,0,1,0,0,0,105,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,65,0,0,0,1,0,0,0,107,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,0,1,0,0,0,108,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,71,95,109,0,1,0,0,0,110,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,65,0,0,1,0,0,0,112,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,108,0,0,1,0,0,0,113,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,71,95,109,0,0,0,0,0,0,0,0,1,0,0,0,119,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,0,0,1,0,0,0,120,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,0,0,0,0,0,1,0,0,0,74,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,65,0,0,0,0,1,0,0,0,76,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,108,0,0,0,0,1,0,0,0,77,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,71,95,109,0,0,1,0,0,0,79,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,65,0,1,0,0,0,81,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,82,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,84,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,65,0,0,0,0,0,0,0,1,0,0,0,86,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,108,0,0,0,0,0,0,0,1,0,0,0,87,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,71,95,109,0,0,0,0,0,1,0,0,0,89,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,65,0,0,0,0,0,0,0,1,0,0,0,91,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,108,0,0,0,0,0,0,0,1,0,0,0,92,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,71,95,109,0,0,0,0,0,1,0,0,0,97,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,65,0,1,0,0,0,99,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,100,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,103,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,1,0,0,0,104,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,0,0,0,1,0,0,0,238,1,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,82,95,109,0,0,0,0,1,0,0,0,239,1,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,82,95,109,0,0,0,0,0,1,0,0,0,240,1,0,0,1,0,0,0,242,1,0,0,1,0,0,0,243,1,0,0,1,0,0,0,245,1,0,0,1,0,0,0,247,1,0,0,1,0,0,0,248,1,0,0,1,0,0,0,252,1,0,0,1,0,0,0,254,1,0,0,1,0,0,0,255,1,0,0,1,0,0,0,2,2,0,0,1,0,0,0,4,2,0,0,1,0,0,0,5,2,0,0,1,0,0,0,95,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,82,95,109,0,0,0,1,0,0,0,96,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,82,95,109,0,0,0,1,0,0,0,97,2,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,82,95,109,0,0,1,0,0,0,98,2,0,0,1,0,0,0,100,2,0,0,1,0,0,0,101,2,0,0,1,0,0,0,103,2,0,0,1,0,0,0,105,2,0,0,1,0,0,0,106,2,0,0,1,0,0,0,110,2,0,0,1,0,0,0,112,2,0,0,1,0,0,0,113,2,0,0,1,0,0,0,115,2,0,0,1,0,0,0,117,2,0,0,216,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,118,2,0,0,1,0,0,0,120,2,0,0,1,0,0,0,122,2,0,0,1,0,0,0,123,2,0,0,1,0,0,0,175,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,71,95,109,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,108,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,65,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,65,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,71,95,109,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,65,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,71,95,109,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,65,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,108,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,71,95,109,0,0,0,0,0,0,0,0,1,0,0,0,184,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,71,95,109,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,108,0,0,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,65,0,0,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,65,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,41,41,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,71,95,109,0,0,0,0,0,0,0,1,0,0,0,50,2,0,0,1,0,0,0,197,2,0,0,88,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,32,60,32,115,105,109,112,108,101,83,111,117,114,99,101,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,32,60,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,48,0,0,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,32,60,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,48,0,0,0,0,0,0,0,0,116,105,109,101,32,60,32,97,100,118,97,110,99,101,100,83,111,117,114,99,101,46,115,105,103,110,97,108,83,111,117,114,99,101,46,115,116,97,114,116,84,105,109,101,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,32,60,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,114,101,108,48,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,32,60,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,114,101,108,48,0,0,0,0,116,105,109,101,32,62,61,32,112,114,101,40,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,110,101,120,116,84,105,109,101,69,118,101,110,116,41,0,0,0,0,1,0,0,0,229,1,0,0,1,0,0,0,56,2,0,0,1,0,0,0,64,2,0,0,1,0,0,0,48,2,0,0,1,0,0,0,68,2,0,0,1,0,0,0,27,2,0,0,1,0,0,0,55,2,0,0,88,53,0,0,96,53,0,0,104,53,0,0,112,53,0,0,120,53,0,0,128,53,0,0,136,53,0,0,0,0,0,0,72,51,0,0,120,51,0,0,216,51,0,0,56,52,0,0,104,52,0,0,200,52,0,0,40,53,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,95,110,101,120,116,84,105,109,101,69,118,101,110,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,97,120,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,105,110,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,97,120,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,95,97,114,109,97,116,117,114,101,46,95,115,116,111,112,112,101,114,95,120,77,105,110,46,95,99,111,110,116,97,99,116,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,105,32,45,32,36,95,115,116,97,114,116,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,105,41,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,105,32,45,32,36,95,115,116,97,114,116,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,105,41,0,0,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,116,97,98,108,101,79,110,70,105,108,101,82,101,97,100,32,45,32,36,84,77,80,95,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,36,80,116,97,98,108,101,79,110,70,105,108,101,82,101,97,100,95,52,55,55,0,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,116,95,109,105,110,32,45,32,36,84,77,80,95,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,36,80,116,95,109,105,110,95,52,55,55,0,0,0,0,0,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,116,95,109,97,120,32,45,32,36,84,77,80,95,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,36,80,116,95,109,97,120,95,52,55,55,0,0,0,0,0,208,55,0,0,16,56,0,0,72,56,0,0,152,56,0,0,216,56,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,114,97,116,105,111,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,1,0,0,0,76,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,0,0,1,0,0,0,77,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,0,0,1,0,0,0,78,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,0,0,0,0,0,0,0,1,0,0,0,79,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,71,95,109,0,0,0,0,1,0,0,0,84,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,78,0,0,0,1,0,0,0,85,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,65,0,0,0,0,0,0,0,1,0,0,0,90,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,0,0,0,0,0,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,32,42,32,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,41,41,0,0,0,1,0,0,0,91,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,1,0,0,0,92,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,0,0,1,0,0,0,93,0,0,0,1,0,0,0,94,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,0,0,0,1,0,0,0,137,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,65,0,0,0,0,0,0,1,0,0,0,138,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,139,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,1,0,0,0,140,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,0,1,0,0,0,141,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,0,1,0,0,0,142,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,0,1,0,0,0,143,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,0,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,144,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,0,0,1,0,0,0,145,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,146,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,149,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,99,111,105,108,46,105,0,0,0,1,0,0,0,151,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,65,0,0,0,0,0,1,0,0,0,171,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,0,0,1,0,0,0,172,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,173,0,0,0,1,0,0,0,174,0,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,0,1,0,0,0,177,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,114,97,116,105,111,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,32,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,1,0,0,0,33,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,1,0,0,0,34,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,41,41,0,1,0,0,0,35,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,51,46,71,95,109,0,0,0,1,0,0,0,36,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,0,0,0,1,0,0,0,37,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,71,95,109,0,0,1,0,0,0,38,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,71,95,109,0,1,0,0,0,54,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,50,46,67,0,0,0,0,0,0,0,1,0,0,0,57,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,49,46,67,0,0,0,0,0,0,0,1,0,0,0,60,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,49,46,78,0,0,0,0,0,0,0,0,1,0,0,0,61,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,65,0,0,0,0,1,0,0,0,62,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,65,0,1,0,0,0,63,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,65,0,0,0,0,0,0,0,1,0,0,0,65,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,78,0,0,0,0,0,0,0,0,1,0,0,0,66,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,65,0,0,0,0,0,1,0,0,0,69,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,0,0,0,0,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,32,42,32,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,41,41,0,0,0,0,0,1,0,0,0,70,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,1,0,0,0,71,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,0,0,0,0,0,0,0,0,1,0,0,0,72,1,0,0,1,0,0,0,73,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,0,1,0,0,0,129,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,65,0,0,0,1,0,0,0,131,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,50,46,105,0,0,0,0,0,0,0,0,1,0,0,0,132,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,1,0,0,0,133,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,108,0,0,0,0,0,1,0,0,0,134,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,1,0,0,0,135,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,137,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,138,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,108,0,0,0,0,0,0,0,1,0,0,0,139,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,71,95,109,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,140,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,144,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,111,105,108,49,46,105,0,0,0,0,0,0,0,0,1,0,0,0,146,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,0,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,0,0,1,0,0,0,147,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,108,0,0,0,0,1,0,0,0,148,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,1,0,0,0,149,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,71,95,109,32,94,32,50,46,48,0,0,0,0,1,0,0,0,151,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,0,0,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,99,95,98,32,42,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,43,32,97,98,115,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,66,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,66,95,109,121,77,97,120,41,41,32,94,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,97,116,101,114,105,97,108,46,110,41,32,94,32,50,46,48,0,0,0,1,0,0,0,152,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,0,0,0,0,0,0,0,96,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,41,41,0,0,0,0,0,1,0,0,0,153,1], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,154,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,71,95,109,32,94,32,50,46,48,0,1,0,0,0,156,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,0,0,1,0,0,0,157,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,109,117,95,114,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,158,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,65,0,0,0,1,0,0,0,159,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,1,0,0,0,160,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,65,0,0,0,0,1,0,0,0,161,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,109,117,95,114,67,111,110,115,116,32,42,32,49,46,50,53,54,54,51,55,48,54,49,52,51,53,57,49,55,101,45,48,54,0,0,0,0,1,0,0,0,180,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,120,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,181,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,0,1,0,0,0,182,1,0,0,1,0,0,0,183,1,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,71,95,109,32,94,32,50,46,48,0,0,1,0,0,0,186,1,0,0,1,0,0,0,191,1,0,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,37,115,40,110,111,109,105,110,97,108,61,37,103,41,0,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,69,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,114,97,116,105,111,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,1,0,0,0,72,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,1,0,0,0,77,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,41,41,0,1,0,0,0,78,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,71,95,109,0,1,0,0,0,81,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,51,46,71,95,109,0,0,0,1,0,0,0,110,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,108,111,103,40,68,73,86,73,83,73,79,78,40,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,0,0,0,1,0,0,0,111,3,0,0,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,71,95,109,0,0,1,0,0,0,157,3,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,49,46,71,95,109,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,49,46,48,32,43,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,114,97,116,105,111,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,1,0,0,0,160,3,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,50,46,71,95,109,0,0,0,0,0,1,0,0,0,189,3,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,0,0,0,0,48,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,108,111,103,40,68,73,86,73,83,73,79,78,40,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,44,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,41,41,0,0,0,0,0,0,0,1,0,0,0,190,3,0,0,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,71,95,109,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,110,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,110,111,117,116,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,120,88,0,0,33,1,0,0,5,0,0,0,33,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,69,120,116,114,97,112,111,108,97,116,105,111,110,46,72,111,108,100,76,97,115,116,80,111,105,110,116,32,97,110,100,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,69,120,116,114,97,112,111,108,97,116,105,111,110,46,78,111,69,120,116,114,97,112,111,108,97,116,105,111,110,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,240,89,0,0,218,8,0,0,5,0,0,0,220,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,76,105,110,101,97,114,83,101,103,109,101,110,116,115,32,97,110,100,32,99,111,109,112,97,114,105,115,111,110,87,105,116,104,70,69,65,46,115,109,111,111,116,104,110,101,115,115,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,67,111,110,115,116,97,110,116,83,101,103,109,101,110,116,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,240,89,0,0,215,8,0,0,5,0,0,0,217,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,115,105,109,112,108,101,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,76,111,97,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,76,111,97,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,103,110,101,116,105,99,47,70,108,117,120,84,117,98,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,69,108,101,99,116,114,105,99,97,108,47,65,110,97,108,111,103,47,66,97,115,105,99,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,104,111,95,115,116,101,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,104,111,95,115,116,101,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,93,0,0,21,6,0,0,11,0,0,0,22,6,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,97,114,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,97,114,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,93,0,0,0,6,0,0,11,0,0,0,1,6,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,73,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,237,5,0,0,11,0,0,0,237,5,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,109,112,108,101,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,79,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,93,0,0,234,5,0,0,11,0,0,0,236,5,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,100,118,97,110,99,101,100,76,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,76,111,97,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,76,111,97,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,80,97,114,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,76,101,97,107,87,111,114,107,46,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,93,0,0,17,12,0,0,9,0,0,0,17,12,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,146,11,0,0,9,0,0,0,146,11,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,65,105,114,87,111,114,107,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,145,11,0,0,9,0,0,0,145,11,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,105,110,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,92,0,0,240,6,0,0,7,0,0,0,241,6,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,92,0,0,237,6,0,0,7,0,0,0,238,6,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,92,0,0,235,6,0,0,7,0,0,0,236,6,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,92,0,0,170,17,0,0,7,0,0,0,171,17,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,115,116,111,112,112,101,114,95,120,77,97,120,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,92,0,0,167,17,0,0,7,0,0,0,169,17,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,92,0,0,95,5,0,0,7,0,0,0,96,5,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,97,115,115,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,92,0,0,94,5,0,0,7,0,0,0,94,5,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,110,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,229,8,0,0,9,0,0,0,231,8,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,97,114,109,97,116,117,114,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,223,8,0,0,9,0,0,0,223,8,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,65,114,109,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,71,95,109,76,101,97,107,82,97,100,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,80,111,108,101,66,111,116,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,93,0,0,72,11,0,0,9,0,0,0,73,11,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,66,111,116,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,93,0,0,70,11,0,0,9,0,0,0,71,11,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,50,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,114,95,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,114,95,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,43,11,0,0,9,0,0,0,44,11,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,114,95,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,103,95,109,70,101,89,111,107,101,83,105,100,101,49,46,114,95,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,93,0,0,40,11,0,0,9,0,0,0,42,11,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,50,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,50,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,49,46,67,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,99,95,112,97,114,49,46,67,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,110,0,0,27,1,0,0,5,0,0,0,27,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,112,97,114,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,50,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,50,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,50,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,50,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,110,0,0,50,1,0,0,5,0,0,0,51,1,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,49,46,84,95,114,101,102,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,49,46,84,95,114,101,102,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,110,0,0,64,0,0,0,3,0,0,0,64,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,104,111,95,115,116,101,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,104,111,95,115,116,101,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,93,0,0,96,7,0,0,11,0,0,0,97,7,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,97,114,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,97,114,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,93,0,0,71,7,0,0,11,0,0,0,72,7,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,73,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,73,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,93,0,0,52,7,0,0,11,0,0,0,52,7,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,79,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,114,95,121,111,107,101,79,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,93,0,0,51,7,0,0,11,0,0,0,51,7,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,67,95,112,97,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,46,67,95,112,97,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,93,0,0,47,7,0,0,11,0,0,0,48,7,0,0,67,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,97,103,110,101,116,105,99,95,70,108,117,120,84,117,98,101,115,95,69,120,97,109,112,108,101,115,95,83,111,108,101,110,111,105,100,65,99,116,117,97,116,111,114,95,67,111,109,112,97,114,105,115,111,110,80,117,108,108,73,110,83,116,114,111,107,101,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,57,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,57,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,57,44,57,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,57,44,48,93,32,61,32,122,101,114,111,115,40,57,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,57,93,32,61,32,122,101,114,111,115,40,48,44,57,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,57,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,115,105,109,112,108,101,83,111,108,101,110,111,105,100,80,103,95,109,76,101,97,107,87,111,114,107,80,80,104,105,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,115,105,109,112,108,101,83,111,108,101,110,111,105,100,80,97,114,109,97,116,117,114,101,80,115,116,111,112,112,101,114,95,120,77,105,110,80,118,95,114,101,108,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,115,105,109,112,108,101,83,111,108,101,110,111,105,100,80,120,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,103,95,109,76,101,97,107,87,111,114,107,80,80,104,105,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,97,114,109,97,116,117,114,101,80,115,116,111,112,112,101,114,95,120,77,105,110,80,118,95,114,101,108,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,120,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,99,95,112,97,114,50,80,118,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,99,95,112,97,114,49,80,118,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,97,100,118,97,110,99,101,100,83,111,108,101,110,111,105,100,80,99,111,105,108,49,80,105,32,61,32,120,91,57,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,97,103,110,101,116,105,99,95,70,108,117,120,84,117,98,101,115,95,69,120,97,109,112,108,101,115,95,83,111,108,101,110,111,105,100,65,99,116,117,97,116,111,114,95,67,111,109,112,97,114,105,115,111,110,80,117,108,108,73,110,83,116,114,111,107,101,59,10,0,0,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,115,111,117,114,99,101,32,101,114,114,111,114,10,0,0,0,0,0,85,110,107,110,111,119,110,32,115,109,111,111,116,104,110,101,115,115,32,107,105,110,100,10,0,0,0,0,0,0,0,0,69,120,116,114,97,112,111,108,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,85,110,107,110,111,119,110,32,101,120,116,114,97,112,111,108,97,116,105,111,110,32,107,105,110,100,10,0,0,0,0,0,78,111,32,116,97,98,108,101,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,100,101,116,101,99,116,105,111,110,32,111,102,32,116,105,109,101,32,101,118,101,110,116,115,10,0,0,0,70,117,110,99,116,105,111,110,32,34,117,115,101,114,116,97,98,34,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,10,0,0,46,109,97,116,0,0,0,0,46,77,65,84,0,0,0,0,46,46,46,32,108,111,97,100,105,110,103,32,34,37,115,34,32,102,114,111,109,32,34,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,78,111,116,32,112,111,115,115,105,98,108,101,32,116,111,32,111,112,101,110,32,102,105,108,101,32,34,37,115,34,58,32,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,105,114,115,116,32,108,105,110,101,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,58,32,69,110,100,45,79,102,45,70,105,108,101,32,114,101,97,99,104,101,100,46,10,0,0,35,49,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,46,10,0,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,44,32,98,117,116,32,34,37,99,34,32,102,111,117,110,100,46,10,0,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,44,32,98,117,116,32,34,37,99,37,99,34,32,102,111,117,110,100,46,10,0,0,0,0,0,0,32,9,40,44,41,13,0,0,100,111,117,98,108,101,0,0,102,108,111,97,116,0,0,0,32,9,44,59,13,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,110,111,116,32,102,111,117,110,100,32,111,110,32,102,105,108,101,32,34,37,115,34,46,10,0,0,0,0,0,0,69,110,100,45,111,102,45,102,105,108,101,32,114,101,97,99,104,101,100,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,0,0,69,114,114,111,114,32,105,110,32,108,105,110,101,32,37,108,117,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,0,0,0,0,84,97,98,108,101,32,97,114,114,97,121,32,34,37,115,34,32,104,97,115,32,110,111,116,32,116,104,101,32,114,101,113,117,105,114,101,100,32,114,97,110,107,32,50,46,10,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,104,97,115,32,110,111,116,32,116,104,101,32,114,101,113,117,105,114,101,100,32,100,111,117,98,108,101,32,112,114,101,99,105,115,105,111,110,32,99,108,97,115,115,46,10,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,109,117,115,116,32,110,111,116,32,98,101,32,99,111,109,112,108,101,120,46,10,0,69,114,114,111,114,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,84,104,101,32,102,105,108,101,32,110,97,109,101,32,102,111,114,32,97,32,116,97,98,108,101,32,40,61,32,34,37,115,34,41,32,105,115,32,100,101,102,105,110,101,100,44,32,98,117,116,32,110,111,116,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,110,97,109,101,46,10,0,0,0,78,111,78,97,109,101,0,0,84,104,101,32,118,97,108,117,101,115,32,111,102,32,116,104,101,32,102,105,114,115,116,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,97,114,101,32,110,111,116,32,115,116,114,105,99,116,108,121,32,105,110,99,114,101,97,115,105,110,103,32,98,101,99,97,117,115,101,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,32,62,61,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,46,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,112,112,114,111,112,114,105,97,116,101,32,100,105,109,101,110,115,105,111,110,115,32,102,111,114,32,116,105,109,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,46,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,32,112,111,115,105,116,105,118,101,32,112,101,114,105,111,100,47,99,121,108,99,101,32,116,105,109,101,32,102,111,114,32,116,105,109,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,119,105,116,104,32,112,101,114,105,111,100,105,99,32,101,120,116,114,97,112,111,108,97,116,105,111,110,46,10,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,115,32,111,102,32,116,104,101,32,102,105,114,115,116,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,97,114,101,32,110,111,116,32,109,111,110,111,116,111,110,105,99,97,108,108,121,32,105,110,99,114,101,97,115,105,110,103,32,98,101,99,97,117,115,101,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,32,62,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,46,10,0,0,0,0,73,110,102,108,97,116,101,83,107,105,112,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,73,110,102,108,97,116,101,86,97,114,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,73,110,102,108,97,116,101,65,114,114,97,121,70,108,97,103,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,68,105,109,101,110,115,105,111,110,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,68,105,109,101,110,115,105,111,110,115,58,32,82,101,97,100,105,110,103,32,100,105,109,101,110,115,105,111,110,115,32,101,120,112,101,99,116,101,100,32,116,121,112,101,32,77,65,84,95,84,95,73,78,84,51,50,0,73,110,102,108,97,116,101,86,97,114,78,97,109,101,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,86,97,114,78,97,109,101,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,73,110,102,108,97,116,101,68,97,116,97,84,121,112,101,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,73,110,102,108,97,116,101,68,97,116,97,58,32,110,66,121,116,101,115,32,109,117,115,116,32,98,101,32,62,32,48,0,73,110,102,108,97,116,101,68,97,116,97,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,76,101,110,103,116,104,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,115,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,37,115,10,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,77,65,84,32,102,105,108,101,0,0,0,0,0,0,37,115,32,100,111,101,115,32,110,111,116,32,115,101,101,109,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,77,65,84,32,102,105,108,101,0,37,115,0,0,0,0,0,0,78,111,32,72,68,70,53,32,115,117,112,112,111,114,116,32,119,104,105,99,104,32,105,115,32,114,101,113,117,105,114,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,118,55,46,51,32,77,65,84,32,102,105,108,101,32,34,37,115,34,0,0,0,0,0,0,0,0,65,110,32,101,114,114,111,114,32,111,99,99,117,114,114,101,100,32,105,110,32,114,101,97,100,105,110,103,32,116,104,101,32,77,65,84,32,102,105,108,101,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,77,65,84,76,65,66,32,53,46,48,32,77,65,84,45,102,105,108,101,44,32,80,108,97,116,102,111,114,109,58,32,37,115,44,32,67,114,101,97,116,101,100,32,98,121,58,32,108,105,98,109,97,116,105,111,32,118,37,100,46,37,100,46,37,100,32,111,110,32,37,115,0,85,78,75,78,79,87,78,0,32,32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,49,46,50,46,53,0,0,0,105,110,102,108,97,116,101,73,110,105,116,50,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,0,0,0,0,78,111,116,32,112,111,115,115,105,98,108,101,32,116,111,32,114,101,97,100,32,99,111,109,112,114,101,115,115,101,100,32,118,55,32,77,65,84,32,102,105,108,101,32,34,37,115,34,0,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,37,115,45,62,100,97,116,97,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,99,101,108,108,32,37,100,0,0,0,99,101,108,108,115,91,37,100,93,44,32,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,0,69,120,112,101,99,116,101,100,32,77,65,84,95,84,95,85,73,78,84,51,50,32,102,111,114,32,65,114,114,97,121,32,84,97,103,115,44,32,103,111,116,32,37,100,0,0,0,0,105,110,102,108,97,116,101,67,111,112,121,32,114,101,116,117,114,110,101,100,32,101,114,114,111,114,32,37,100,0,0,0,99,101,108,108,115,91,37,100,93,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,44,32,102,112,111,115,32,61,32,37,108,100,0,0,69,114,114,111,114,32,103,101,116,116,105,110,103,32,102,105,101,108,100,110,97,109,101,32,115,105,122,101,0,0,0,0,102,105,101,108,100,115,91,37,100,93,44,32,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,102,105,101,108,100,115,91,37,100,93,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,44,32,102,112,111,115,32,61,32,37,108,100,0,40,78,85,76,76,41,0,0,60,78,85,76,76,62,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,0,0,0,0,0,0,0,49,46,50,46,56,0,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,0,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,0,0,0,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,0,0,0,0,0,0,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,0,0,0,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,0,0,0,0,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,0,0,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,0,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,0,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,0,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,0,0,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,0,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,72,0,78,0,0,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43,150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,207,0,0,16,207,0,0,32,207,0,0,56,207,0,0,88,207,0,0,104,207,0,0,128,207,0,0,144,207,0,0,168,207,0,0,200,207,0,0,240,207,0,0,8,208,0,0,40,208,0,0,64,208,0,0,104,208,0,0,136,208,0,0,184,208,0,0,232,208,0,0,0,209,0,0,56,209,0,0,80,209,0,0,128,209,0,0,160,209,0,0,216,209,0,0,0,210,0,0,56,210,0,0,104,210,0,0,120,210,0,0,152,210,0,0,192,210,0,0,224,210,0,0,8,211,0,0,48,211,0,0,72,211,0,0,96,211,0,0,112,211,0,0,136,211,0,0,184,211,0,0,8,212,0,0,72,212,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,120,226,0,0,8,225,0,0,144,223,0,0,24,222,0,0,24,222,0,0,160,220,0,0,144,223,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,64,237,0,0,200,233,0,0,88,232,0,0,232,230,0,0,232,230,0,0,120,229,0,0,88,232,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,136,235,0,0,152,235,0,0,168,235,0,0,120,220,0,0,176,235,0,0,192,235,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,32,239,0,0,40,239,0,0,48,239,0,0,56,239,0,0,176,238,0,0,64,239,0,0,80,239,0,0,88,239,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,101,108,116,115,91,105,93,45,62,110,100,105,109,115,32,61,61,32,110,100,105,109,115,32,38,38,32,34,78,111,116,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,34,0,0,0,0,0,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,104,101,99,107,95,98,97,115,101,95,97,114,114,97,121,95,100,105,109,95,115,105,122,101,115,0,0,0,0,0,0,100,105,109,115,105,122,101,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,99,117,114,100,105,109,93,32,38,38,32,34,68,105,109,101,110,115,105,111,110,115,32,115,105,122,101,32,110,111,116,32,115,97,109,101,34,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,152,241,0,0,168,241,0,0,176,241,0,0,184,241,0,0,200,241,0,0,216,241,0,0,224,241,0,0,240,241,0,0,0,242,0,0,16,242,0,0,32,242,0,0,48,242,0,0,64,242,0,0,80,242,0,0,96,242,0,0,104,242,0,0,112,242,0,0,128,242,0,0,136,242,0,0,152,242,0,0,168,242,0,0,184,242,0,0,200,242,0,0,216,242,0,0,232,242,0,0,248,242,0,0,8,243,0,0,24,243,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,160,243,0,0,168,243,0,0,168,243,0,0,200,243,0,0,248,243,0,0,24,244,0,0,80,244,0,0,128,244,0,0,176,244,0,0,208,244,0,0,0,245,0,0,24,245,0,0,56,245,0,0,96,245,0,0,128,245,0,0,176,245,0,0,208,245,0,0,248,245,0,0,24,246,0,0,64,246,0,0,112,246,0,0,168,246,0,0,208,246,0,0,0,247,0,0,48,247,0,0,88,247,0,0,136,247,0,0,144,247,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,160,243,0,0,144,250,0,0,152,250,0,0,160,250,0,0,176,241,0,0,168,250,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,24,252,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,48,252,0,0,56,252,0,0,64,252,0,0,80,252,0,0,96,252,0,0,104,252,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,97,114,114,97,121,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,48,32,38,38,32,34,68,105,109,101,110,115,105,111,110,32,115,105,122,101,32,62,32,52,32,110,111,116,32,105,109,112,108,46,32,121,101,116,34,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,160,7,1,0,0,0,0,0,24,7,1,0,0,0,0,0,144,6,1,0,0,0,0,0,8,6,1,0,0,0,0,0,0,5,1,0,0,0,0,0,248,3,1,0,0,0,0,0,240,2,1,0,0,0,0,0,232,1,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,9,1,0,152,9,1,0,160,9,1,0,168,9,1,0,184,9,1,0,192,9,1,0,200,9,1,0,208,9,1,0,216,9,1,0,224,9,1,0,232,9,1,0,248,9,1,0,0,10,1,0,16,10,1,0,32,10,1,0,48,10,1,0,56,10,1,0,72,10,1,0,80,10,1,0,96,10,1,0,104,10,1,0,128,10,1,0,136,10,1,0,144,10,1,0,160,10,1,0,168,10,1,0,184,10,1,0,200,10,1,0,208,10,1,0,216,10,1,0,224,10,1,0,232,10,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,11,1,0,128,11,1,0,200,11,1,0,248,11,1,0,40,12,1,0,112,12,1,0,176,12,1,0,248,12,1,0,40,13,1,0,112,13,1,0,136,13,1,0,168,13,1,0,224,13,1,0,8,14,1,0,48,14,1,0,104,14,1,0,184,14,1,0,24,15,1,0,72,15,1,0,128,15,1,0,176,15,1,0,248,15,1,0,32,16,1,0,80,16,1,0,128,16,1,0,216,16,1,0,32,17,1,0,144,17,1,0,192,17,1,0,8,18,1,0,40,18,1,0,232,10,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,11,1,0,232,18,1,0,144,19,1,0,248,11,1,0,40,12,1,0,248,19,1,0,176,12,1,0,248,12,1,0,128,20,1,0,192,20,1,0,136,13,1,0,168,13,1,0,96,21,1,0,160,21,1,0,224,21,1,0,104,14,1,0,184,14,1,0,32,22,1,0,88,22,1,0,224,22,1,0,8,23,1,0,248,15,1,0,32,16,1,0,80,16,1,0,112,23,1,0,248,23,1,0,248,24,1,0,144,17,1,0,192,17,1,0,8,18,1,0,40,18,1,0,232,10,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,30,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,30,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,30,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,30,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,30,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+67616);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,48,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+77960);
/* memory initializer */ allocate([16,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,54,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,53,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,55,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,56,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,56,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,58,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,58,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,58,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,58,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,58,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,58,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,93,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,94,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,95,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,96,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,96,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,96,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,108,1,0,184,109,1,0,192,109,1,0,208,109,1,0,224,109,1,0,240,109,1,0,8,110,1,0,32,110,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,108,1,0,160,108,1,0,232,108,1,0,16,109,1,0,48,109,1,0,80,109,1,0,120,109,1,0,160,109,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,8,118,1,0,24,118,1,0,32,118,1,0,40,118,1,0,48,118,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,80,118,1,0,88,118,1,0,104,118,1,0,120,118,1,0,48,118,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+88644);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,56,145,1,0,0,147,1,0,8,147,1,0,16,147,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,56,145,1,0,64,146,1,0,144,146,1,0,192,146,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,56,145,1,0,0,146,1,0,8,146,1,0,16,146,1,0,32,146,1,0,40,146,1,0,56,146,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,56,145,1,0,64,145,1,0,88,145,1,0,104,145,1,0,176,145,1,0,192,145,1,0,224,145,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,232,156,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,232,156,1,0,10,0,0,0,11,0,0,0,140,156,1,0,4,157,1,0,24,157,1,0,160,156,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,86,2,0,184,156,1,0,128,18,2,0,0,0,0,0,104,0,0,0,0,0,0,0,128,18,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,128,18,2,0,14,0,0,0,15,0,0,0,0,0,0,0,144,157,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,248,86,2,0,96,157,1,0,120,17,2,0,0,0,0,0,0,0,0,0,24,158,1,0,32,158,1,0,16,158,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,240,157,1,0,0,158,1,0,16,158,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+98884);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,112,174,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,112,174,1,0,20,0,0,0,21,0,0,0,20,174,1,0,140,174,1,0,160,174,1,0,40,174,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,248,86,2,0,64,174,1,0,240,17,2,0,0,0,0,0,108,0,0,0,0,0,0,0,240,17,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,240,17,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,168,184,1,0,144,186,1,0,152,186,1,0,224,188,1,0,248,186,1,0,8,187,1,0,232,188,1,0,240,188,1,0,248,188,1,0,0,189,1,0,16,189,1,0,32,189,1,0,48,189,1,0,64,189,1,0,80,189,1,0,96,189,1,0,112,189,1,0,136,189,1,0,192,188,1,0,216,188,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,168,184,1,0,144,186,1,0,152,186,1,0,168,186,1,0,248,186,1,0,8,187,1,0,24,187,1,0,56,187,1,0,88,187,1,0,120,187,1,0,160,187,1,0,200,187,1,0,240,187,1,0,24,188,1,0,48,188,1,0,80,188,1,0,112,188,1,0,152,188,1,0,192,188,1,0,216,188,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,168,184,1,0,112,186,1,0,120,186,1,0,128,186,1,0,168,184,1,0,176,185,1,0,0,186,1,0,48,186,1,0,168,184,1,0,112,185,1,0,120,185,1,0,128,185,1,0,144,185,1,0,152,185,1,0,168,185,1,0,0,0,0,0,168,184,1,0,176,184,1,0,200,184,1,0,216,184,1,0,32,185,1,0,48,185,1,0,80,185,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,200,191,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,200,191,1,0,29,0,0,0,30,0,0,0,84,191,1,0,228,191,1,0,248,191,1,0,104,191,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,248,86,2,0,128,191,1,0,128,18,2,0,0,0,0,0,56,0,0,0,0,0,0,0,128,18,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,128,18,2,0,14,0,0,0,15,0,0,0,0,0,0,0,136,192,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,248,86,2,0,64,192,1,0,120,17,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+109124);
/* memory initializer */ allocate([115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,24,213,1,0,24,213,1,0,24,213,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,192,215,1,0,208,215,1,0,232,215,1,0,8,216,1,0,40,216,1,0,64,216,1,0,96,216,1,0,120,216,1,0,136,216,1,0,152,216,1,0,176,216,1,0,200,216,1,0,232,216,1,0,8,217,1,0,152,216,1,0,32,217,1,0,64,217,1,0,88,217,1,0,112,217,1,0,136,217,1,0,168,217,1,0,184,217,1,0,216,217,1,0,248,217,1,0,16,218,1,0,40,218,1,0,64,218,1,0,80,218,1,0,104,218,1,0,128,218,1,0,152,218,1,0,184,218,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+119364);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+126568);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,192,3,2,0,200,3,2,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,216,3,2,0,224,3,2,0,232,3,2,0,240,3,2,0,144,1,0,0,0,0,0,0,96,4,2,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+131792);
/* memory initializer */ allocate([56,11,2,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,248,86,2,0,24,11,2,0,184,17,2,0,0,0,0,0,0,0,0,0,160,11,2,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,248,86,2,0,136,11,2,0,184,17,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,56,12,2,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,248,86,2,0,24,12,2,0,120,17,2,0,0,0,0,0,0,0,0,0,160,12,2,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,248,86,2,0,136,12,2,0,120,17,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,208,86,2,0,176,12,2,0,0,0,0,0,24,13,2,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,192,13,2,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,248,86,2,0,8,13,2,0,0,0,0,0,0,0,0,0,0,0,0,0,88,13,2,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,248,86,2,0,64,13,2,0,24,13,2,0,0,0,0,0,0,0,0,0,152,13,2,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,248,86,2,0,128,13,2,0,24,13,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,248,86,2,0,168,13,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,8,14,2,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,248,86,2,0,240,13,2,0,192,13,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,208,86,2,0,24,14,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,248,86,2,0,64,14,2,0,56,14,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,240,16,2,0,49,0,0,0,50,0,0,0,0,0,0,0,120,17,2,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,184,17,2,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,240,17,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,240,17,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,56,18,2,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,56,18,2,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,128,18,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,128,18,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,200,18,2,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,200,18,2,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,16,2,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,184,16,2,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,248,86,2,0,112,16,2,0,8,14,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,208,86,2,0,160,16,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,248,86,2,0,192,16,2,0,184,16,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,248,86,2,0,0,17,2,0,184,16,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,208,86,2,0,64,17,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,208,86,2,0,128,17,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,87,2,0,192,17,2,0,0,0,0,0,1,0,0,0,240,16,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,87,2,0,8,18,2,0,0,0,0,0,1,0,0,0,48,17,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,88,87,2,0,80,18,2,0,0,0,0,0,1,0,0,0,240,16,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,88,87,2,0,152,18,2,0,0,0,0,0,1,0,0,0,48,17,2,0,3,244,255,255,0,0,0,0,40,19,2,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,248,86,2,0,8,19,2,0,88,14,2,0,0,0,0,0,0,0,0,0,80,33,2,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,33,2,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,38,2,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,192,38,2,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,39,2,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,40,2,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,64,35,2,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,64,35,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,224,35,2,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,224,35,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,112,36,2,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,36,2,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,33,2,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,34,2,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,34,2,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,34,2,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,40,2,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,56,41,2,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,200,41,2,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,88,42,2,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,37,2,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,37,2,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,40,33,2,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,30,2,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,30,2,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,32,2,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,0,33,2,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,56,29,2,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,248,86,2,0,32,29,2,0,208,12,2,0,0,0,0,0,0,0,0,0,200,29,2,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,208,86,2,0,168,29,2,0,88,87,2,0,144,29,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,29,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,88,87,2,0,232,29,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,29,2,0,2,0,0,0,0,0,0,0,152,30,2,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,208,86,2,0,120,30,2,0,88,87,2,0,80,30,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,144,30,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,88,87,2,0,184,30,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,144,30,2,0,2,0,0,0,0,0,0,0,88,31,2,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,87,2,0,48,31,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,144,30,2,0,2,0,0,0,0,0,0,0,208,31,2,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,88,87,2,0,168,31,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,144,30,2,0,2,0,0,0,0,0,0,0,72,32,2,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,248,86,2,0,32,32,2,0,208,31,2,0,0,0,0,0,0,0,0,0,176,32,2,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,248,86,2,0,136,32,2,0,208,31,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,248,86,2,0,192,32,2,0,56,29,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,248,86,2,0,232,32,2,0,56,29,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,248,86,2,0,16,33,2,0,56,29,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,248,86,2,0,56,33,2,0,56,29,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,248,86,2,0,96,33,2,0,56,29,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,208,86,2,0,168,33,2,0,88,87,2,0,136,33,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,33,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,88,87,2,0,232,33,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,33,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,88,87,2,0,40,34,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,33,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,88,87,2,0,104,34,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,33,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,208,86,2,0,240,34,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,208,86,2,0,16,35,2,0,88,87,2,0,168,34,2,0,0,0,0,0,3,0,0,0,56,29,2,0,2,0,0,0,8,35,2,0,2,0,0,0,56,35,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,208,86,2,0,176,35,2,0,88,87,2,0,104,35,2,0,0,0,0,0,3,0,0,0,56,29,2,0,2,0,0,0,8,35,2,0,2,0,0,0,216,35,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,208,86,2,0,80,36,2,0,88,87,2,0,8,36,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,104,36,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,88,87,2,0,144,36,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,104,36,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,208,86,2,0,16,37,2,0,88,87,2,0,248,36,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,40,37,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,88,87,2,0,80,37,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,40,37,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,86,2,0,232,37,2,0,88,87,2,0,208,37,2,0,0,0,0,0,1,0,0,0,8,38,2,0,0,0,0,0,88,87,2,0,136,37,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,16,38,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,88,87,2,0,144,38,2,0,0,0,0,0,1,0,0,0,8,38,2,0,0,0,0,0,88,87,2,0,72,38,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,168,38,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,208,86,2,0,64,39,2,0,88,87,2,0,40,39,2,0,0,0,0,0,1,0,0,0,96,39,2,0,0,0,0,0,88,87,2,0,224,38,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,104,39,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,88,87,2,0,232,39,2,0,0,0,0,0,1,0,0,0,96,39,2,0,0,0,0,0,88,87,2,0,160,39,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,0,40,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,208,86,2,0,128,40,2,0,88,87,2,0,56,40,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,160,40,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,208,86,2,0,16,41,2,0,88,87,2,0,200,40,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,48,41,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,208,86,2,0,160,41,2,0,88,87,2,0,88,41,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,192,41,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,208,86,2,0,48,42,2,0,88,87,2,0,232,41,2,0,0,0,0,0,2,0,0,0,56,29,2,0,2,0,0,0,80,42,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133844);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,64,84,2,0,110,0,0,0,72,84,2,0,114,0,0,0,80,84,2,0,102,0,0,0,88,84,2,0,97,0,0,0,96,84,2,0,101,0,0,0,104,84,2,0,119,0,0,0,112,84,2,0,87,0,0,0,128,84,2,0,115,0,0,0,144,84,2,0,83,0,0,0,160,84,2,0,100,0,0,0,176,84,2,0,68,0,0,0,192,84,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,72,86,2,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,208,86,2,0,32,86,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,248,86,2,0,56,86,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,248,86,2,0,88,86,2,0,48,86,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,248,86,2,0,144,86,2,0,128,86,2,0,0,0,0,0,0,0,0,0,184,86,2,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,64,87,2,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,248,86,2,0,24,87,2,0,184,86,2,0,0,0,0,0,0,0,0,0,160,87,2,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,248,86,2,0,120,87,2,0,184,86,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,89,2,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,248,86,2,0,208,89,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+144184);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  var _DtoILow=true;

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

  
  
  var ___tm_formatted=allocate(44, "i8", ALLOC_STATIC);
  
  
  function _mktime(tmPtr) {
      _tzset();
      var year = HEAP32[(((tmPtr)+(20))>>2)];
      var timestamp = new Date(year >= 1900 ? year : year + 1900,
                               HEAP32[(((tmPtr)+(16))>>2)],
                               HEAP32[(((tmPtr)+(12))>>2)],
                               HEAP32[(((tmPtr)+(8))>>2)],
                               HEAP32[(((tmPtr)+(4))>>2)],
                               HEAP32[((tmPtr)>>2)],
                               0).getTime() / 1000;
      HEAP32[(((tmPtr)+(24))>>2)]=new Date(timestamp).getDay();
      var yday = Math.round((timestamp - (new Date(year, 0, 1)).getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      return timestamp;
    }function _asctime_r(tmPtr, buf) {
      var date = new Date(_mktime(tmPtr)*1000);
      var formatted = date.toString();
      var datePart = formatted.replace(/\d{4}.*/, '').replace(/ 0/, '  ');
      var timePart = formatted.match(/\d{2}:\d{2}:\d{2}/)[0];
      formatted = datePart + timePart + ' ' + date.getFullYear() + '\n';
      formatted.split('').forEach(function(chr, index) {
        HEAP8[(((buf)+(index))|0)]=chr.charCodeAt(0);
      });
      HEAP8[(((buf)+(25))|0)]=0;
      return buf;
    }function _asctime(tmPtr) {
      return _asctime_r(tmPtr, ___tm_formatted);
    }function _ctime(timer) {
      return _asctime(_localtime(timer));
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _fgets(s, n, stream) {
      // char *fgets(char *restrict s, int n, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgets.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return 0;
      if (streamObj.error || streamObj.eof) return 0;
      var byte_;
      for (var i = 0; i < n - 1 && byte_ != 10; i++) {
        byte_ = _fgetc(stream);
        if (byte_ == -1) {
          if (streamObj.error || (streamObj.eof && i == 0)) return 0;
          else if (streamObj.eof) break;
        }
        HEAP8[(((s)+(i))|0)]=byte_;
      }
      HEAP8[(((s)+(i))|0)]=0;
      return s;
    }

  function _strchr(ptr, chr) {
      ptr--;
      do {
        ptr++;
        var val = HEAP8[(ptr)];
        if (val == chr) return ptr;
      } while (val);
      return 0;
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }

  var _FtoIHigh=true;

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }


  function _localeconv() {
      // %struct.timeval = type { char* decimal point, other stuff... }
      // var indexes = Runtime.calculateStructAlignment({ fields: ['i32', 'i32'] });
      var me = _localeconv;
      if (!me.ret) {
      // These are defaults from the "C" locale
        me.ret = allocate([
          allocate(intArrayFromString('.'), 'i8', ALLOC_NORMAL),0,0,0, // decimal_point
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // thousands_sep
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // grouping
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // int_curr_symbol
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // currency_symbol
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_decimal_point
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_thousands_sep
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_grouping
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // positive_sign
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0 // negative_sign
        ], 'i8*', ALLOC_NORMAL); // Allocate strings in lconv, still don't allocate chars
      }
      return me.ret;
    }


  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  var _DtoIHigh=true;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }




  function _feof(stream) {
      // int feof(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/feof.html
      stream = FS.getStreamFromPtr(stream);
      return Number(stream && stream.eof);
    }

  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;


  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _FtoILow=true;

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env._isblank;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env._sysconf;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env.__isLeapYear;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_get_values;var Kb=env._lis_vector_destroy;var Lb=env._lis_solver_set_option;var Mb=env._tmpfile;var Nb=env._send;var Ob=env._pow;var Pb=env._ctime;var Qb=env._lis_matrix_set_size;var Rb=env.___cxa_free_exception;var Sb=env.___cxa_find_matching_catch;var Tb=env._isxdigit_l;var Ub=env.___cxa_guard_release;var Vb=env._truncate;var Wb=env._strtol;var Xb=env._sin;var Yb=env._strtok;var Zb=env.___setErrNo;var _b=env._newlocale;var $b=env._isdigit_l;var ac=env.___resumeException;var bc=env._freelocale;var cc=env._srand;var dc=env._strchr;var ec=env._mktime;var fc=env._qsort;var gc=env._putchar;var hc=env._floor;var ic=env._pthread_mutex_unlock;var jc=env._localeconv;var kc=env._printf;var lc=env._sprintf;var mc=env._fopen;var nc=env._vasprintf;var oc=env._emscripten_get_now;var pc=env._stat;var qc=env._lis_solve;var rc=env._strtoull_l;var sc=env._mkport;var tc=env._asctime;var uc=env._read;var vc=env.__addDays;var wc=env._fwrite;var xc=env._time;var yc=env._pthread_mutex_lock;var zc=env._catopen;var Ac=env._exit;var Bc=env._GC_strdup;var Cc=env._freopen;var Dc=env.___ctype_b_loc;var Ec=env._fmod;var Fc=env._strtok_r;var Gc=env._lseek;var Hc=env._access;var Ic=env._vfprintf;var Jc=env.___cxa_allocate_exception;var Kc=env._atoi;var Lc=env._strtoll;var Mc=env._pwrite;var Nc=env._localtime_r;var Oc=env._tzset;var Pc=env._open;var Qc=env._uselocale;var Rc=env._snprintf;var Sc=env.___errno_location;var Tc=env._GC_malloc;var Uc=env.___cxa_end_catch;var Vc=env._perror;var Wc=env.___cxa_begin_catch;var Xc=env._strftime;var Yc=env._ftruncate;var Zc=env._GC_init;var _c=env._lis_matrix_set_type;var $c=env._fseek;var ad=env._asctime_r;var bd=env._isxdigit;var cd=env._fclose;var dd=env._vsnprintf;var ed=env.__parseInt;var fd=env._log;var gd=env._pthread_cond_broadcast;var hd=env._popen;var id=env._recv;var jd=env._copysign;var kd=env.__parseInt64;var ld=env.__getFloat;var md=env._lis_vector_set_value;var nd=env._abort;var od=env._ceil;var pd=env._isspace;var qd=env._localtime;var rd=env._lis_matrix_destroy;var sd=env._pthread_getspecific;var td=env._pthread_cond_wait;var ud=env._llvm_lifetime_start;var vd=env.___cxa_is_number_type;var wd=env._ungetc;var xd=env._system;var yd=env._fmax;var zd=env._fflush;var Ad=env._strftime_l;var Bd=env._fprintf;var Cd=env._sscanf;var Dd=env._catgets;var Ed=env._lis_solver_destroy;var Fd=env._strdup;var Gd=env._asprintf;var Hd=env.__formatString;var Id=env.__exit;var Jd=env.___ctype_toupper_loc;var Kd=env._bsearch;var Ld=env.__arraySum;var Md=env._lis_vector_create;var Nd=env._htonl;var Od=env.___ctype_tolower_loc;var Pd=env._unlink;var Qd=env._fputs;var Rd=env._GC_malloc_atomic;var Sd=env._pread;var Td=env._lis_vector_set_size;var Ud=env._fscanf;var Vd=env._feof;var Wd=env.__scanString;var Xd=env._pthread_setspecific;var Yd=env._fgetc;var Zd=env._fputc;var _d=env.___cxa_throw;var $d=env._lis_matrix_create;var ae=env._isdigit;var be=env._strerror;var ce=env._emscripten_longjmp;var de=env._fgets;var ee=env._atexit;var fe=env._sqrt;var ge=env._strerror_r;var he=0.0;
// EMSCRIPTEN_START_FUNCS
function gj(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0,Dl=0,El=0,Fl=0,Gl=0,Hl=0,Il=0,Jl=0,Kl=0,Ll=0,Ml=0,Nl=0,Ol=0,Pl=0,Ql=0,Rl=0,Sl=0,Tl=0,Ul=0,Vl=0,Wl=0,Xl=0,Yl=0,Zl=0,_l=0,$l=0,am=0,bm=0,cm=0,dm=0,em=0,fm=0,gm=0,hm=0,im=0,jm=0,km=0,lm=0,mm=0,nm=0,om=0,pm=0,qm=0,rm=0,sm=0,tm=0,um=0,vm=0,wm=0,xm=0,ym=0,zm=0,Am=0,Bm=0,Cm=0,Dm=0,Em=0,Fm=0,Gm=0,Hm=0,Im=0,Jm=0,Km=0,Lm=0,Mm=0,Nm=0,Om=0,Pm=0,Qm=0,Rm=0,Sm=0,Tm=0,Um=0,Vm=0,Wm=0,Xm=0,Ym=0,Zm=0,_m=0,$m=0,an=0,bn=0,cn=0,dn=0,en=0,fn=0,gn=0,hn=0,jn=0,kn=0,ln=0,mn=0,nn=0,on=0,pn=0,qn=0,rn=0,sn=0,tn=0,un=0,vn=0,wn=0,xn=0,yn=0,zn=0,An=0,Bn=0,Cn=0,Dn=0,En=0,Fn=0,Gn=0,Hn=0,In=0,Jn=0,Kn=0,Ln=0,Mn=0,Nn=0,On=0,Pn=0,Qn=0,Rn=0,Sn=0,Tn=0,Un=0,Vn=0,Wn=0,Xn=0,Yn=0,Zn=0,_n=0,$n=0,ao=0,bo=0,co=0,eo=0,fo=0,go=0,ho=0,io=0,jo=0,ko=0,lo=0,mo=0,no=0,oo=0,po=0,qo=0,ro=0,so=0,to=0,uo=0,vo=0,wo=0,xo=0,yo=0,zo=0,Ao=0,Bo=0,Co=0,Do=0,Eo=0,Fo=0,Go=0,Ho=0,Io=0,Jo=0,Ko=0,Lo=0,Mo=0,No=0,Oo=0,Po=0,Qo=0,Ro=0,So=0,To=0,Uo=0,Vo=0,Wo=0,Xo=0,Yo=0,Zo=0,_o=0,$o=0,ap=0,bp=0,cp=0,dp=0,ep=0,fp=0,gp=0,hp=0,ip=0,jp=0,kp=0,lp=0,mp=0,np=0,op=0,pp=0,qp=0,rp=0,sp=0,tp=0,up=0,vp=0,wp=0,xp=0,yp=0,zp=0,Ap=0,Bp=0,Cp=0,Dp=0,Ep=0,Fp=0,Gp=0,Hp=0,Ip=0,Jp=0,Kp=0,Lp=0,Mp=0,Np=0,Op=0,Pp=0,Qp=0,Rp=0,Sp=0,Tp=0,Up=0,Vp=0,Wp=0,Xp=0,Yp=0,Zp=0,_p=0,$p=0,aq=0,bq=0,cq=0,dq=0,eq=0,fq=0,gq=0,hq=0,iq=0,jq=0,kq=0,lq=0,mq=0,nq=0,oq=0,pq=0,qq=0,rq=0,sq=0,tq=0,uq=0,vq=0,wq=0,xq=0,yq=0,zq=0,Aq=0,Bq=0,Cq=0,Dq=0,Eq=0,Fq=0,Gq=0,Hq=0,Iq=0,Jq=0,Kq=0,Lq=0,Mq=0,Nq=0,Oq=0,Pq=0,Qq=0,Rq=0,Sq=0,Tq=0,Uq=0,Vq=0,Wq=0,Xq=0,Yq=0,Zq=0,_q=0,$q=0,ar=0,br=0,cr=0,dr=0,er=0,fr=0,gr=0,hr=0,ir=0,jr=0,kr=0,lr=0,mr=0,nr=0,or=0,pr=0,qr=0;b=i;i=i+8856|0;d=i;i=i+8|0;e=i;i=i+2120|0;f=i;i=i+24|0;h=i;i=i+24|0;j=i;i=i+24|0;k=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=i;i=i+24|0;v=i;i=i+24|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=i;i=i+24|0;B=i;i=i+24|0;C=i;i=i+24|0;D=i;i=i+24|0;E=i;i=i+24|0;F=i;i=i+24|0;G=i;i=i+24|0;J=i;i=i+24|0;K=i;i=i+24|0;L=i;i=i+24|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+24|0;P=i;i=i+24|0;Q=i;i=i+24|0;R=i;i=i+24|0;S=i;i=i+24|0;T=i;i=i+24|0;U=i;i=i+24|0;V=i;i=i+24|0;W=i;i=i+24|0;X=i;i=i+24|0;Y=i;i=i+24|0;Z=i;i=i+24|0;_=i;i=i+24|0;$=i;i=i+24|0;aa=i;i=i+24|0;ba=i;i=i+24|0;ca=i;i=i+24|0;da=i;i=i+24|0;ea=i;i=i+24|0;fa=i;i=i+24|0;ga=i;i=i+24|0;ha=i;i=i+24|0;ia=i;i=i+24|0;ja=i;i=i+24|0;ka=i;i=i+24|0;la=i;i=i+24|0;ma=i;i=i+24|0;na=i;i=i+24|0;oa=i;i=i+24|0;pa=i;i=i+24|0;qa=i;i=i+24|0;ra=i;i=i+24|0;sa=i;i=i+24|0;ta=i;i=i+24|0;ua=i;i=i+24|0;va=i;i=i+24|0;wa=i;i=i+24|0;xa=i;i=i+24|0;ya=i;i=i+24|0;za=i;i=i+24|0;Aa=i;i=i+24|0;Ba=i;i=i+24|0;Ca=i;i=i+24|0;Da=i;i=i+24|0;Ea=i;i=i+24|0;Fa=i;i=i+24|0;Ga=i;i=i+24|0;Ha=i;i=i+24|0;Ia=i;i=i+24|0;Ja=i;i=i+24|0;Ka=i;i=i+24|0;La=i;i=i+24|0;Ma=i;i=i+24|0;Na=i;i=i+24|0;Oa=i;i=i+24|0;Pa=i;i=i+24|0;Qa=i;i=i+24|0;Ra=i;i=i+24|0;Sa=i;i=i+24|0;Ta=i;i=i+24|0;Ua=i;i=i+24|0;Va=i;i=i+24|0;Wa=i;i=i+24|0;Xa=i;i=i+24|0;Ya=i;i=i+24|0;Za=i;i=i+24|0;_a=i;i=i+24|0;$a=i;i=i+24|0;ab=i;i=i+24|0;bb=i;i=i+24|0;cb=i;i=i+24|0;db=i;i=i+24|0;eb=i;i=i+24|0;fb=i;i=i+24|0;gb=i;i=i+24|0;hb=i;i=i+24|0;ib=i;i=i+24|0;jb=i;i=i+24|0;kb=i;i=i+24|0;lb=i;i=i+24|0;mb=i;i=i+24|0;nb=i;i=i+24|0;ob=i;i=i+24|0;pb=i;i=i+24|0;qb=i;i=i+24|0;rb=i;i=i+24|0;sb=i;i=i+24|0;tb=i;i=i+24|0;ub=i;i=i+24|0;vb=i;i=i+24|0;wb=i;i=i+24|0;xb=i;i=i+24|0;yb=i;i=i+24|0;zb=i;i=i+24|0;Ab=i;i=i+24|0;Bb=i;i=i+24|0;Cb=i;i=i+24|0;Db=i;i=i+24|0;Eb=i;i=i+24|0;Fb=i;i=i+24|0;Gb=i;i=i+24|0;Hb=i;i=i+24|0;Ib=i;i=i+24|0;Jb=i;i=i+24|0;Kb=i;i=i+24|0;Lb=i;i=i+24|0;Mb=i;i=i+24|0;Nb=i;i=i+24|0;Ob=i;i=i+24|0;Pb=i;i=i+24|0;Qb=i;i=i+24|0;Rb=i;i=i+24|0;Sb=i;i=i+24|0;Tb=i;i=i+24|0;Ub=i;i=i+24|0;Vb=i;i=i+24|0;Wb=i;i=i+24|0;Xb=i;i=i+24|0;Yb=i;i=i+24|0;Zb=i;i=i+24|0;_b=i;i=i+24|0;$b=i;i=i+24|0;ac=i;i=i+24|0;bc=i;i=i+24|0;cc=i;i=i+24|0;dc=i;i=i+24|0;ec=i;i=i+24|0;fc=i;i=i+24|0;gc=i;i=i+24|0;hc=i;i=i+24|0;ic=i;i=i+24|0;jc=i;i=i+24|0;kc=i;i=i+24|0;lc=i;i=i+24|0;mc=i;i=i+24|0;nc=i;i=i+24|0;oc=i;i=i+24|0;pc=i;i=i+24|0;qc=i;i=i+24|0;rc=i;i=i+24|0;sc=i;i=i+24|0;tc=i;i=i+24|0;uc=i;i=i+24|0;vc=i;i=i+24|0;wc=i;i=i+24|0;xc=i;i=i+24|0;yc=i;i=i+24|0;zc=i;i=i+24|0;Ac=i;i=i+24|0;Bc=i;i=i+24|0;Cc=i;i=i+24|0;Dc=i;i=i+24|0;Ec=i;i=i+24|0;Fc=i;i=i+24|0;Gc=i;i=i+24|0;Hc=i;i=i+24|0;Ic=i;i=i+24|0;Jc=i;i=i+24|0;Kc=i;i=i+24|0;Lc=i;i=i+24|0;Mc=i;i=i+24|0;Nc=i;i=i+24|0;Oc=i;i=i+24|0;Pc=i;i=i+24|0;Qc=i;i=i+24|0;Rc=i;i=i+24|0;Sc=i;i=i+24|0;Tc=i;i=i+24|0;Uc=i;i=i+24|0;Vc=i;i=i+24|0;Wc=i;i=i+24|0;Xc=i;i=i+24|0;Yc=i;i=i+24|0;Zc=i;i=i+24|0;_c=i;i=i+24|0;$c=i;i=i+24|0;ad=i;i=i+24|0;bd=i;i=i+24|0;cd=i;i=i+24|0;dd=i;i=i+24|0;ed=i;i=i+24|0;fd=i;i=i+24|0;gd=i;i=i+24|0;hd=i;i=i+24|0;id=i;i=i+24|0;jd=i;i=i+24|0;kd=i;i=i+24|0;ld=i;i=i+24|0;md=i;i=i+24|0;nd=i;i=i+24|0;od=i;i=i+24|0;pd=i;i=i+24|0;qd=i;i=i+24|0;rd=i;i=i+24|0;sd=i;i=i+24|0;td=i;i=i+24|0;ud=i;i=i+24|0;vd=i;i=i+24|0;wd=i;i=i+24|0;xd=i;i=i+24|0;yd=i;i=i+24|0;zd=i;i=i+24|0;Ad=i;i=i+24|0;Bd=i;i=i+24|0;Cd=i;i=i+24|0;Dd=i;i=i+24|0;Ed=i;i=i+24|0;Fd=i;i=i+24|0;Gd=i;i=i+24|0;Hd=i;i=i+24|0;Id=i;i=i+24|0;Jd=i;i=i+24|0;Kd=i;i=i+24|0;Ld=i;i=i+24|0;Md=i;i=i+24|0;Nd=i;i=i+24|0;Od=i;i=i+24|0;Pd=i;i=i+24|0;Qd=i;i=i+24|0;Rd=i;i=i+24|0;Sd=i;i=i+24|0;Td=i;i=i+24|0;Ud=i;i=i+24|0;Vd=i;i=i+24|0;Wd=i;i=i+24|0;Xd=i;i=i+24|0;Yd=i;i=i+24|0;Zd=i;i=i+24|0;_d=i;i=i+24|0;$d=i;i=i+24|0;ae=i;i=i+24|0;be=i;i=i+24|0;ce=i;i=i+24|0;de=i;i=i+24|0;ee=i;i=i+24|0;fe=i;i=i+24|0;ge=i;i=i+24|0;he=i;i=i+24|0;ie=i;i=i+24|0;je=i;i=i+24|0;ke=i;i=i+24|0;le=i;i=i+24|0;me=i;i=i+24|0;ne=i;i=i+24|0;oe=i;i=i+24|0;pe=i;i=i+24|0;qe=i;i=i+24|0;re=i;i=i+24|0;se=i;i=i+24|0;te=i;i=i+24|0;ue=i;i=i+24|0;ve=i;i=i+24|0;we=i;i=i+24|0;xe=i;i=i+24|0;ye=i;i=i+24|0;ze=i;i=i+24|0;Ae=i;i=i+24|0;Be=i;i=i+24|0;Ce=i;i=i+24|0;De=i;i=i+24|0;Ee=i;i=i+24|0;Fe=i;i=i+24|0;Ge=i;i=i+24|0;He=i;i=i+24|0;Ie=i;i=i+24|0;Je=i;i=i+24|0;Ke=i;i=i+24|0;Le=i;i=i+24|0;Me=i;i=i+24|0;Ne=i;i=i+24|0;Oe=i;i=i+24|0;Pe=i;i=i+24|0;Qe=i;i=i+24|0;Re=i;i=i+24|0;Se=i;i=i+24|0;Te=i;i=i+24|0;Ue=i;i=i+24|0;Ve=i;i=i+24|0;We=i;i=i+24|0;Xe=i;i=i+24|0;Ye=i;i=i+24|0;Ze=i;i=i+24|0;_e=i;i=i+24|0;$e=i;i=i+24|0;af=i;i=i+24|0;bf=i;i=i+24|0;cf=i;i=i+24|0;df=i;i=i+24|0;ef=i;i=i+24|0;ff=i;i=i+24|0;gf=i;i=i+24|0;hf=i;i=i+24|0;jf=i;i=i+24|0;kf=i;i=i+24|0;lf=i;i=i+24|0;mf=i;i=i+24|0;nf=i;i=i+24|0;of=i;i=i+24|0;pf=i;i=i+24|0;qf=i;i=i+24|0;rf=i;i=i+24|0;sf=i;i=i+24|0;tf=i;i=i+24|0;uf=i;i=i+24|0;vf=i;i=i+24|0;wf=i;i=i+24|0;xf=i;i=i+24|0;yf=i;i=i+24|0;zf=i;i=i+24|0;Af=i;i=i+24|0;Bf=i;i=i+24|0;Cf=i;i=i+24|0;Df=i;i=i+24|0;Ef=i;i=i+24|0;Ff=i;i=i+24|0;Gf=i;i=i+24|0;Hf=i;i=i+24|0;If=i;i=i+24|0;Jf=i;i=i+24|0;Kf=i;i=i+24|0;Lf=i;i=i+24|0;Mf=i;i=i+24|0;Nf=i;i=i+24|0;Of=i;i=i+24|0;Pf=i;i=i+24|0;Qf=i;i=i+24|0;Rf=i;i=i+24|0;Sf=i;i=i+24|0;Tf=i;i=i+24|0;Uf=i;i=i+24|0;Vf=i;i=i+24|0;Wf=i;i=i+24|0;Xf=i;i=i+24|0;Yf=i;i=i+24|0;Zf=i;i=i+24|0;_f=i;i=i+24|0;$f=i;i=i+24|0;ag=i;i=i+24|0;bg=i;i=i+24|0;cg=i;i=i+24|0;dg=i;i=i+24|0;eg=i;i=i+24|0;fg=i;i=i+24|0;gg=i;i=i+24|0;hg=i;i=i+24|0;ig=i;i=i+24|0;jg=i;i=i+24|0;kg=i;i=i+24|0;lg=i;i=i+24|0;mg=i;i=i+24|0;ng=i;i=i+24|0;og=i;i=i+24|0;pg=i;i=i+24|0;qg=i;i=i+24|0;rg=i;i=i+24|0;sg=i;i=i+24|0;tg=i;i=i+24|0;ug=i;i=i+24|0;vg=i;i=i+24|0;wg=i;i=i+24|0;xg=i;i=i+24|0;yg=i;i=i+24|0;zg=i;c[b+56>>2]=Ag;c[b+72>>2]=Bg;c[b+80>>2]=Cg;c[b+88>>2]=Dg;c[b+96>>2]=Eg;c[b+104>>2]=Fg;c[b+112>>2]=Gg;c[b+120>>2]=Hg;c[b+128>>2]=Ig;c[b+136>>2]=Jg;c[b+144>>2]=Kg;c[b+152>>2]=Lg;c[b+160>>2]=Mg;c[b+168>>2]=Ng;c[b+176>>2]=Og;c[b+184>>2]=Pg;c[b+192>>2]=Qg;c[b+200>>2]=Rg;c[b+208>>2]=Sg;c[b+216>>2]=Tg;c[b+224>>2]=Ug;c[b+232>>2]=Vg;c[b+240>>2]=Wg;c[b+248>>2]=Xg;c[b+256>>2]=Yg;c[b+264>>2]=Zg;c[b+272>>2]=_g;c[b+280>>2]=$g;c[b+288>>2]=ah;c[b+296>>2]=bh;c[b+304>>2]=ch;c[b+312>>2]=dh;c[b+320>>2]=eh;c[b+328>>2]=fh;c[b+336>>2]=gh;c[b+344>>2]=hh;c[b+352>>2]=ih;c[b+360>>2]=jh;c[b+368>>2]=kh;c[b+376>>2]=lh;c[b+384>>2]=mh;c[b+392>>2]=nh;c[b+400>>2]=oh;c[b+408>>2]=ph;c[b+416>>2]=qh;c[b+424>>2]=rh;c[b+432>>2]=sh;c[b+440>>2]=th;c[b+448>>2]=uh;c[b+456>>2]=vh;c[b+464>>2]=wh;c[b+472>>2]=xh;c[b+480>>2]=yh;c[b+488>>2]=zh;c[b+496>>2]=Ah;c[b+504>>2]=Bh;c[b+512>>2]=Ch;c[b+520>>2]=Dh;c[b+528>>2]=Eh;c[b+536>>2]=Fh;c[b+544>>2]=Gh;c[b+552>>2]=Hh;c[b+560>>2]=Ih;c[b+568>>2]=Jh;c[b+576>>2]=Kh;c[b+584>>2]=Lh;c[b+592>>2]=Mh;c[b+600>>2]=Nh;c[b+608>>2]=Oh;c[b+616>>2]=Ph;c[b+624>>2]=Qh;c[b+632>>2]=Rh;c[b+640>>2]=Sh;c[b+648>>2]=Th;c[b+656>>2]=Uh;c[b+664>>2]=Vh;c[b+672>>2]=Wh;c[b+680>>2]=Xh;c[b+688>>2]=Yh;c[b+696>>2]=Zh;c[b+704>>2]=_h;c[b+712>>2]=$h;c[b+720>>2]=ai;c[b+728>>2]=bi;c[b+736>>2]=ci;c[b+744>>2]=di;c[b+752>>2]=ei;c[b+760>>2]=fi;c[b+768>>2]=gi;c[b+776>>2]=hi;c[b+784>>2]=ii;c[b+792>>2]=ji;c[b+800>>2]=ki;c[b+808>>2]=li;c[b+816>>2]=mi;c[b+824>>2]=ni;c[b+832>>2]=oi;c[b+840>>2]=pi;c[b+848>>2]=qi;c[b+856>>2]=ri;c[b+864>>2]=si;c[b+872>>2]=ti;c[b+880>>2]=ui;c[b+888>>2]=vi;c[b+896>>2]=wi;c[b+904>>2]=xi;c[b+912>>2]=yi;c[b+920>>2]=zi;c[b+928>>2]=Ai;c[b+936>>2]=Bi;c[b+944>>2]=Ci;c[b+952>>2]=Di;c[b+960>>2]=Ei;c[b+968>>2]=Fi;c[b+976>>2]=Gi;c[b+984>>2]=Hi;c[b+992>>2]=Ii;c[b+1e3>>2]=Ji;c[b+1008>>2]=Ki;c[b+1016>>2]=Li;c[b+1024>>2]=Mi;c[b+1032>>2]=Ni;c[b+1040>>2]=Oi;c[b+1048>>2]=Pi;c[b+1056>>2]=Qi;c[b+1064>>2]=Ri;c[b+1072>>2]=Si;c[b+1080>>2]=Ti;c[b+1088>>2]=Ui;c[b+1096>>2]=Vi;c[b+1104>>2]=Wi;c[b+1112>>2]=Xi;c[b+1120>>2]=Yi;c[b+1128>>2]=Zi;c[b+1136>>2]=_i;c[b+1144>>2]=$i;c[b+1152>>2]=aj;c[b+1160>>2]=bj;c[b+1168>>2]=cj;c[b+1176>>2]=dj;c[b+1184>>2]=ej;c[b+1192>>2]=fj;c[b+1200>>2]=gj;c[b+1208>>2]=hj;c[b+1216>>2]=ij;c[b+1224>>2]=jj;c[b+1232>>2]=kj;c[b+1240>>2]=lj;c[b+1248>>2]=mj;c[b+1256>>2]=nj;c[b+1264>>2]=oj;c[b+1272>>2]=pj;c[b+1280>>2]=qj;c[b+1288>>2]=rj;c[b+1296>>2]=sj;c[b+1304>>2]=tj;c[b+1312>>2]=uj;c[b+1320>>2]=vj;c[b+1328>>2]=wj;c[b+1336>>2]=xj;c[b+1344>>2]=yj;c[b+1352>>2]=zj;c[b+1360>>2]=Aj;c[b+1368>>2]=Bj;c[b+1376>>2]=Cj;c[b+1384>>2]=Dj;c[b+1392>>2]=Ej;c[b+1400>>2]=Fj;c[b+1408>>2]=Gj;c[b+1416>>2]=Hj;c[b+1424>>2]=Ij;c[b+1432>>2]=Jj;c[b+1440>>2]=Kj;c[b+1448>>2]=Lj;c[b+1456>>2]=Mj;c[b+1464>>2]=Nj;c[b+1472>>2]=Oj;c[b+1480>>2]=Pj;c[b+1488>>2]=Qj;c[b+1496>>2]=Rj;c[b+1504>>2]=Sj;c[b+1512>>2]=Tj;c[b+1520>>2]=Uj;c[b+1528>>2]=Vj;c[b+1536>>2]=Wj;c[b+1544>>2]=Xj;c[b+1552>>2]=Yj;c[b+1560>>2]=Zj;c[b+1568>>2]=_j;c[b+1576>>2]=$j;c[b+1584>>2]=ak;c[b+1592>>2]=bk;c[b+1600>>2]=ck;c[b+1608>>2]=dk;c[b+1616>>2]=ek;c[b+1624>>2]=fk;c[b+1632>>2]=gk;c[b+1640>>2]=hk;c[b+1648>>2]=ik;c[b+1656>>2]=jk;c[b+1664>>2]=kk;c[b+1672>>2]=lk;c[b+1680>>2]=mk;c[b+1688>>2]=nk;c[b+1696>>2]=ok;c[b+1704>>2]=pk;c[b+1712>>2]=qk;c[b+1720>>2]=rk;c[b+1728>>2]=sk;c[b+1736>>2]=tk;c[b+1744>>2]=uk;c[b+1752>>2]=vk;c[b+1760>>2]=wk;c[b+1768>>2]=xk;c[b+1776>>2]=yk;c[b+1784>>2]=zk;c[b+1792>>2]=Ak;c[b+1800>>2]=Bk;c[b+1808>>2]=Ck;c[b+1816>>2]=Dk;c[b+1824>>2]=Ek;c[b+1832>>2]=Fk;c[b+1840>>2]=Gk;c[b+1848>>2]=Hk;c[b+1856>>2]=Ik;c[b+1864>>2]=Jk;c[b+1872>>2]=Kk;c[b+1880>>2]=Lk;c[b+1888>>2]=Mk;c[b+1896>>2]=Nk;c[b+1904>>2]=Ok;c[b+1912>>2]=Pk;c[b+1920>>2]=Qk;c[b+1928>>2]=Rk;c[b+1936>>2]=Sk;c[b+1944>>2]=Tk;c[b+1952>>2]=Uk;c[b+1960>>2]=Vk;c[b+1968>>2]=Wk;c[b+1976>>2]=Xk;c[b+1984>>2]=Yk;c[b+1992>>2]=Zk;c[b+2e3>>2]=_k;c[b+2008>>2]=$k;c[b+2016>>2]=al;c[b+2024>>2]=bl;c[b+2032>>2]=cl;c[b+2040>>2]=dl;c[b+2048>>2]=el;c[b+2056>>2]=fl;c[b+2064>>2]=gl;c[b+2072>>2]=hl;c[b+2080>>2]=il;c[b+2088>>2]=jl;c[b+2096>>2]=kl;c[b+2104>>2]=ll;c[b+2112>>2]=ml;c[b+2120>>2]=nl;c[b+2128>>2]=ol;c[b+2136>>2]=pl;c[b+2144>>2]=ql;c[b+2152>>2]=rl;c[b+2160>>2]=sl;c[b+2168>>2]=tl;c[b+2176>>2]=ul;c[b+2184>>2]=vl;c[b+2192>>2]=wl;c[b+2200>>2]=xl;c[b+2208>>2]=yl;c[b+2216>>2]=zl;c[b+2224>>2]=Al;c[b+2232>>2]=Bl;c[b+2240>>2]=Cl;c[b+2248>>2]=Dl;c[b+2256>>2]=El;c[b+2264>>2]=Fl;c[b+2272>>2]=Gl;c[b+2280>>2]=Hl;c[b+2288>>2]=Il;c[b+2296>>2]=Jl;c[b+2304>>2]=Kl;c[b+2312>>2]=Ll;c[b+2320>>2]=Ml;c[b+2328>>2]=Nl;c[b+2336>>2]=Ol;c[b+2344>>2]=Pl;c[b+2352>>2]=Ql;c[b+2360>>2]=Rl;c[b+2368>>2]=Sl;c[b+2376>>2]=Tl;c[b+2384>>2]=Ul;c[b+2392>>2]=Vl;c[b+2400>>2]=Wl;c[b+2408>>2]=Xl;c[b+2416>>2]=Yl;c[b+2424>>2]=Zl;c[b+2432>>2]=_l;c[b+2440>>2]=$l;c[b+2448>>2]=am;c[b+2456>>2]=bm;c[b+2464>>2]=cm;c[b+2472>>2]=dm;c[b+2480>>2]=em;c[b+2488>>2]=fm;c[b+2496>>2]=gm;c[b+2504>>2]=hm;c[b+2512>>2]=im;c[b+2520>>2]=jm;c[b+2528>>2]=km;c[b+2536>>2]=lm;c[b+2544>>2]=mm;c[b+2552>>2]=nm;c[b+2560>>2]=om;c[b+2568>>2]=pm;c[b+2576>>2]=qm;c[b+2584>>2]=rm;c[b+2592>>2]=sm;c[b+2600>>2]=tm;c[b+2608>>2]=um;c[b+2616>>2]=vm;c[b+2624>>2]=wm;c[b+2632>>2]=xm;c[b+2640>>2]=ym;c[b+2648>>2]=zm;c[b+2656>>2]=Am;c[b+2664>>2]=Bm;c[b+2672>>2]=Cm;c[b+2680>>2]=Dm;c[b+2688>>2]=Em;c[b+2696>>2]=Fm;c[b+2704>>2]=Gm;c[b+2712>>2]=Hm;c[b+2720>>2]=Im;c[b+2728>>2]=Jm;c[b+2736>>2]=Km;c[b+2744>>2]=Lm;c[b+2752>>2]=Mm;c[b+2760>>2]=Nm;c[b+2768>>2]=Om;c[b+2776>>2]=Pm;c[b+2784>>2]=Qm;c[b+2792>>2]=Rm;c[b+2800>>2]=Sm;c[b+2808>>2]=Tm;c[b+2816>>2]=Um;c[b+2824>>2]=Vm;c[b+2832>>2]=Wm;c[b+2840>>2]=Xm;c[b+2848>>2]=Ym;c[b+2856>>2]=Zm;c[b+2864>>2]=_m;c[b+2872>>2]=$m;c[b+2880>>2]=an;c[b+2888>>2]=bn;c[b+2896>>2]=cn;c[b+2904>>2]=dn;c[b+2912>>2]=en;c[b+2920>>2]=fn;c[b+2928>>2]=gn;c[b+2936>>2]=hn;c[b+2944>>2]=jn;c[b+2952>>2]=kn;c[b+2960>>2]=ln;c[b+2968>>2]=mn;c[b+2976>>2]=nn;c[b+2984>>2]=on;c[b+2992>>2]=pn;c[b+3e3>>2]=qn;c[b+3008>>2]=rn;c[b+3016>>2]=sn;c[b+3024>>2]=tn;c[b+3032>>2]=un;c[b+3040>>2]=vn;c[b+3048>>2]=wn;c[b+3056>>2]=xn;c[b+3064>>2]=yn;c[b+3072>>2]=zn;c[b+3080>>2]=An;c[b+3088>>2]=Bn;c[b+3096>>2]=Cn;c[b+3104>>2]=Dn;c[b+3112>>2]=En;c[b+3120>>2]=Fn;c[b+3128>>2]=Gn;c[b+3136>>2]=Hn;c[b+3144>>2]=In;c[b+3152>>2]=Jn;c[b+3160>>2]=Kn;c[b+3168>>2]=Ln;c[b+3176>>2]=Mn;c[b+3184>>2]=Nn;c[b+3192>>2]=On;c[b+3200>>2]=Pn;c[b+3208>>2]=Qn;c[b+3216>>2]=Rn;c[b+3224>>2]=Sn;c[b+3232>>2]=Tn;c[b+3240>>2]=Un;c[b+3248>>2]=Vn;c[b+3256>>2]=Wn;c[b+3264>>2]=Xn;c[b+3272>>2]=Yn;c[b+3280>>2]=Zn;c[b+3288>>2]=_n;c[b+3296>>2]=$n;c[b+3304>>2]=ao;c[b+3312>>2]=bo;c[b+3320>>2]=co;c[b+3328>>2]=eo;c[b+3336>>2]=fo;c[b+3344>>2]=go;c[b+3352>>2]=ho;c[b+3360>>2]=io;c[b+3368>>2]=jo;c[b+3376>>2]=ko;c[b+3384>>2]=lo;c[b+3392>>2]=mo;c[b+3400>>2]=no;c[b+3408>>2]=oo;c[b+3416>>2]=po;c[b+3424>>2]=qo;c[b+3432>>2]=ro;c[b+3440>>2]=so;c[b+3448>>2]=to;c[b+3456>>2]=uo;c[b+3464>>2]=vo;c[b+3472>>2]=wo;c[b+3480>>2]=xo;c[b+3488>>2]=yo;c[b+3496>>2]=zo;c[b+3504>>2]=Ao;c[b+3512>>2]=Bo;c[b+3520>>2]=Co;c[b+3528>>2]=Do;c[b+3536>>2]=Eo;c[b+3544>>2]=Fo;c[b+3552>>2]=Go;c[b+3560>>2]=Ho;c[b+3568>>2]=Io;c[b+3576>>2]=Jo;c[b+3584>>2]=Ko;c[b+3592>>2]=Lo;c[b+3600>>2]=Mo;c[b+3608>>2]=No;c[b+3616>>2]=Oo;c[b+3624>>2]=Po;c[b+3632>>2]=Qo;c[b+3640>>2]=Ro;c[b+3648>>2]=So;c[b+3656>>2]=To;c[b+3664>>2]=Uo;c[b+3672>>2]=Vo;c[b+3680>>2]=Wo;c[b+3688>>2]=Xo;c[b+3696>>2]=Yo;c[b+3704>>2]=Zo;c[b+3712>>2]=_o;c[b+3720>>2]=$o;c[b+3728>>2]=ap;c[b+3736>>2]=bp;c[b+3744>>2]=cp;c[b+3752>>2]=dp;c[b+3760>>2]=ep;c[b+3768>>2]=fp;c[b+3776>>2]=gp;c[b+3784>>2]=hp;c[b+3792>>2]=ip;c[b+3800>>2]=jp;c[b+3808>>2]=kp;c[b+3816>>2]=lp;c[b+3824>>2]=mp;c[b+3832>>2]=np;c[b+3840>>2]=op;c[b+3848>>2]=pp;c[b+3856>>2]=qp;c[b+3864>>2]=rp;c[b+3872>>2]=sp;c[b+3880>>2]=tp;c[b+3888>>2]=up;c[b+3896>>2]=vp;c[b+3904>>2]=wp;c[b+3912>>2]=xp;c[b+3920>>2]=yp;c[b+3928>>2]=zp;c[b+3936>>2]=Ap;c[b+3944>>2]=Bp;c[b+3952>>2]=Cp;c[b+3960>>2]=Dp;c[b+3968>>2]=Ep;c[b+3976>>2]=Fp;c[b+3984>>2]=Gp;c[b+3992>>2]=Hp;c[b+4e3>>2]=Ip;c[b+4008>>2]=Jp;c[b+4016>>2]=Kp;c[b+4024>>2]=Lp;c[b+4032>>2]=Mp;c[b+4040>>2]=Np;c[b+4048>>2]=Op;c[b+4056>>2]=Pp;c[b+4064>>2]=Qp;c[b+4072>>2]=Rp;c[b+4080>>2]=Sp;c[b+4088>>2]=Tp;c[b+4096>>2]=Up;c[b+4104>>2]=Vp;c[b+4112>>2]=Wp;c[b+4120>>2]=Xp;c[b+4128>>2]=Yp;c[b+4136>>2]=Zp;c[b+4144>>2]=_p;c[b+4152>>2]=$p;c[b+4160>>2]=aq;c[b+4168>>2]=bq;c[b+4176>>2]=cq;c[b+4184>>2]=dq;c[b+4192>>2]=eq;c[b+4200>>2]=fq;c[b+4208>>2]=gq;c[b+4216>>2]=hq;c[b+4224>>2]=iq;c[b+4232>>2]=jq;c[b+4240>>2]=kq;c[b+4248>>2]=lq;c[b+4256>>2]=mq;c[b+4264>>2]=nq;c[b+4272>>2]=oq;c[b+4280>>2]=pq;c[b+4288>>2]=qq;c[b+4296>>2]=rq;c[b+4304>>2]=sq;c[b+4312>>2]=tq;c[b+4320>>2]=uq;c[b+7880>>2]=vq;c[b+7888>>2]=wq;c[b+7896>>2]=xq;c[b+7912>>2]=yq;c[b+7920>>2]=zq;c[b+7928>>2]=Aq;c[b+7936>>2]=Bq;c[b+7944>>2]=Cq;c[b+7952>>2]=Dq;c[b+7960>>2]=Eq;c[b+7968>>2]=Fq;c[b+7976>>2]=Gq;c[b+7984>>2]=Hq;c[b+8008>>2]=Iq;c[b+8016>>2]=Jq;c[b+8024>>2]=Kq;c[b+8032>>2]=Lq;c[b+8040>>2]=Mq;c[b+8048>>2]=Nq;c[b+8056>>2]=Oq;c[b+8064>>2]=Pq;c[b+8072>>2]=Qq;c[b+8080>>2]=Rq;c[b+8096>>2]=Sq;c[b+8104>>2]=Tq;c[b+8112>>2]=Uq;c[b+8120>>2]=Vq;c[b+8128>>2]=Wq;c[b+8136>>2]=Xq;c[b+8144>>2]=Yq;c[b+8152>>2]=Zq;c[b+8160>>2]=_q;c[b+8168>>2]=$q;c[b+8184>>2]=ar;c[b+8192>>2]=br;c[b+8200>>2]=cr;c[b+8208>>2]=dr;c[b+8216>>2]=er;c[b+8224>>2]=fr;c[b+8232>>2]=gr;c[b+8240>>2]=hr;c[b+8248>>2]=ir;c[b+8256>>2]=jr;c[b+8272>>2]=kr;c[b+8280>>2]=lr;c[b+8288>>2]=mr;c[b+8296>>2]=nr;c[b+8304>>2]=or;c[b+8312>>2]=pr;c[b+8320>>2]=qr;c[b+8632>>2]=0;c[b+8636>>2]=0;_Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$4(b);Ag=c[b+56>>2]|0;Bg=c[b+72>>2]|0;Cg=c[b+80>>2]|0;Dg=c[b+88>>2]|0;Eg=c[b+96>>2]|0;Fg=c[b+104>>2]|0;Gg=c[b+112>>2]|0;Hg=c[b+120>>2]|0;Ig=c[b+128>>2]|0;Jg=c[b+136>>2]|0;Kg=c[b+144>>2]|0;Lg=c[b+152>>2]|0;Mg=c[b+160>>2]|0;Ng=c[b+168>>2]|0;Og=c[b+176>>2]|0;Pg=c[b+184>>2]|0;Qg=c[b+192>>2]|0;Rg=c[b+200>>2]|0;Sg=c[b+208>>2]|0;Tg=c[b+216>>2]|0;Ug=c[b+224>>2]|0;Vg=c[b+232>>2]|0;Wg=c[b+240>>2]|0;Xg=c[b+248>>2]|0;Yg=c[b+256>>2]|0;Zg=c[b+264>>2]|0;_g=c[b+272>>2]|0;$g=c[b+280>>2]|0;ah=c[b+288>>2]|0;bh=c[b+296>>2]|0;ch=c[b+304>>2]|0;dh=c[b+312>>2]|0;eh=c[b+320>>2]|0;fh=c[b+328>>2]|0;gh=c[b+336>>2]|0;hh=c[b+344>>2]|0;ih=c[b+352>>2]|0;jh=c[b+360>>2]|0;kh=c[b+368>>2]|0;lh=c[b+376>>2]|0;mh=c[b+384>>2]|0;nh=c[b+392>>2]|0;oh=c[b+400>>2]|0;ph=c[b+408>>2]|0;qh=c[b+416>>2]|0;rh=c[b+424>>2]|0;sh=c[b+432>>2]|0;th=c[b+440>>2]|0;uh=c[b+448>>2]|0;vh=c[b+456>>2]|0;wh=c[b+464>>2]|0;xh=c[b+472>>2]|0;yh=c[b+480>>2]|0;zh=c[b+488>>2]|0;Ah=c[b+496>>2]|0;Bh=c[b+504>>2]|0;Ch=c[b+512>>2]|0;Dh=c[b+520>>2]|0;Eh=c[b+528>>2]|0;Fh=c[b+536>>2]|0;Gh=c[b+544>>2]|0;Hh=c[b+552>>2]|0;Ih=c[b+560>>2]|0;Jh=c[b+568>>2]|0;Kh=c[b+576>>2]|0;Lh=c[b+584>>2]|0;Mh=c[b+592>>2]|0;Nh=c[b+600>>2]|0;Oh=c[b+608>>2]|0;Ph=c[b+616>>2]|0;Qh=c[b+624>>2]|0;Rh=c[b+632>>2]|0;Sh=c[b+640>>2]|0;Th=c[b+648>>2]|0;Uh=c[b+656>>2]|0;Vh=c[b+664>>2]|0;Wh=c[b+672>>2]|0;Xh=c[b+680>>2]|0;Yh=c[b+688>>2]|0;Zh=c[b+696>>2]|0;_h=c[b+704>>2]|0;$h=c[b+712>>2]|0;ai=c[b+720>>2]|0;bi=c[b+728>>2]|0;ci=c[b+736>>2]|0;di=c[b+744>>2]|0;ei=c[b+752>>2]|0;fi=c[b+760>>2]|0;gi=c[b+768>>2]|0;hi=c[b+776>>2]|0;ii=c[b+784>>2]|0;ji=c[b+792>>2]|0;ki=c[b+800>>2]|0;li=c[b+808>>2]|0;mi=c[b+816>>2]|0;ni=c[b+824>>2]|0;oi=c[b+832>>2]|0;pi=c[b+840>>2]|0;qi=c[b+848>>2]|0;ri=c[b+856>>2]|0;si=c[b+864>>2]|0;ti=c[b+872>>2]|0;ui=c[b+880>>2]|0;vi=c[b+888>>2]|0;wi=c[b+896>>2]|0;xi=c[b+904>>2]|0;yi=c[b+912>>2]|0;zi=c[b+920>>2]|0;Ai=c[b+928>>2]|0;Bi=c[b+936>>2]|0;Ci=c[b+944>>2]|0;Di=c[b+952>>2]|0;Ei=c[b+960>>2]|0;Fi=c[b+968>>2]|0;Gi=c[b+976>>2]|0;Hi=c[b+984>>2]|0;Ii=c[b+992>>2]|0;Ji=c[b+1e3>>2]|0;Ki=c[b+1008>>2]|0;Li=c[b+1016>>2]|0;Mi=c[b+1024>>2]|0;Ni=c[b+1032>>2]|0;Oi=c[b+1040>>2]|0;Pi=c[b+1048>>2]|0;Qi=c[b+1056>>2]|0;Ri=c[b+1064>>2]|0;Si=c[b+1072>>2]|0;Ti=c[b+1080>>2]|0;Ui=c[b+1088>>2]|0;Vi=c[b+1096>>2]|0;Wi=c[b+1104>>2]|0;Xi=c[b+1112>>2]|0;Yi=c[b+1120>>2]|0;Zi=c[b+1128>>2]|0;_i=c[b+1136>>2]|0;$i=c[b+1144>>2]|0;aj=c[b+1152>>2]|0;bj=c[b+1160>>2]|0;cj=c[b+1168>>2]|0;dj=c[b+1176>>2]|0;ej=c[b+1184>>2]|0;fj=c[b+1192>>2]|0;gj=c[b+1200>>2]|0;hj=c[b+1208>>2]|0;ij=c[b+1216>>2]|0;jj=c[b+1224>>2]|0;kj=c[b+1232>>2]|0;lj=c[b+1240>>2]|0;mj=c[b+1248>>2]|0;nj=c[b+1256>>2]|0;oj=c[b+1264>>2]|0;pj=c[b+1272>>2]|0;qj=c[b+1280>>2]|0;rj=c[b+1288>>2]|0;sj=c[b+1296>>2]|0;tj=c[b+1304>>2]|0;uj=c[b+1312>>2]|0;vj=c[b+1320>>2]|0;wj=c[b+1328>>2]|0;xj=c[b+1336>>2]|0;yj=c[b+1344>>2]|0;zj=c[b+1352>>2]|0;Aj=c[b+1360>>2]|0;Bj=c[b+1368>>2]|0;Cj=c[b+1376>>2]|0;Dj=c[b+1384>>2]|0;Ej=c[b+1392>>2]|0;Fj=c[b+1400>>2]|0;Gj=c[b+1408>>2]|0;Hj=c[b+1416>>2]|0;Ij=c[b+1424>>2]|0;Jj=c[b+1432>>2]|0;Kj=c[b+1440>>2]|0;Lj=c[b+1448>>2]|0;Mj=c[b+1456>>2]|0;Nj=c[b+1464>>2]|0;Oj=c[b+1472>>2]|0;Pj=c[b+1480>>2]|0;Qj=c[b+1488>>2]|0;Rj=c[b+1496>>2]|0;Sj=c[b+1504>>2]|0;Tj=c[b+1512>>2]|0;Uj=c[b+1520>>2]|0;Vj=c[b+1528>>2]|0;Wj=c[b+1536>>2]|0;Xj=c[b+1544>>2]|0;Yj=c[b+1552>>2]|0;Zj=c[b+1560>>2]|0;_j=c[b+1568>>2]|0;$j=c[b+1576>>2]|0;ak=c[b+1584>>2]|0;bk=c[b+1592>>2]|0;ck=c[b+1600>>2]|0;dk=c[b+1608>>2]|0;ek=c[b+1616>>2]|0;fk=c[b+1624>>2]|0;gk=c[b+1632>>2]|0;hk=c[b+1640>>2]|0;ik=c[b+1648>>2]|0;jk=c[b+1656>>2]|0;kk=c[b+1664>>2]|0;lk=c[b+1672>>2]|0;mk=c[b+1680>>2]|0;nk=c[b+1688>>2]|0;ok=c[b+1696>>2]|0;pk=c[b+1704>>2]|0;qk=c[b+1712>>2]|0;rk=c[b+1720>>2]|0;sk=c[b+1728>>2]|0;tk=c[b+1736>>2]|0;uk=c[b+1744>>2]|0;vk=c[b+1752>>2]|0;wk=c[b+1760>>2]|0;xk=c[b+1768>>2]|0;yk=c[b+1776>>2]|0;zk=c[b+1784>>2]|0;Ak=c[b+1792>>2]|0;Bk=c[b+1800>>2]|0;Ck=c[b+1808>>2]|0;Dk=c[b+1816>>2]|0;Ek=c[b+1824>>2]|0;Fk=c[b+1832>>2]|0;Gk=c[b+1840>>2]|0;Hk=c[b+1848>>2]|0;Ik=c[b+1856>>2]|0;Jk=c[b+1864>>2]|0;Kk=c[b+1872>>2]|0;Lk=c[b+1880>>2]|0;Mk=c[b+1888>>2]|0;Nk=c[b+1896>>2]|0;Ok=c[b+1904>>2]|0;Pk=c[b+1912>>2]|0;Qk=c[b+1920>>2]|0;Rk=c[b+1928>>2]|0;Sk=c[b+1936>>2]|0;Tk=c[b+1944>>2]|0;Uk=c[b+1952>>2]|0;Vk=c[b+1960>>2]|0;Wk=c[b+1968>>2]|0;Xk=c[b+1976>>2]|0;Yk=c[b+1984>>2]|0;Zk=c[b+1992>>2]|0;_k=c[b+2e3>>2]|0;$k=c[b+2008>>2]|0;al=c[b+2016>>2]|0;bl=c[b+2024>>2]|0;cl=c[b+2032>>2]|0;dl=c[b+2040>>2]|0;el=c[b+2048>>2]|0;fl=c[b+2056>>2]|0;gl=c[b+2064>>2]|0;hl=c[b+2072>>2]|0;il=c[b+2080>>2]|0;jl=c[b+2088>>2]|0;kl=c[b+2096>>2]|0;ll=c[b+2104>>2]|0;ml=c[b+2112>>2]|0;nl=c[b+2120>>2]|0;ol=c[b+2128>>2]|0;pl=c[b+2136>>2]|0;ql=c[b+2144>>2]|0;rl=c[b+2152>>2]|0;sl=c[b+2160>>2]|0;tl=c[b+2168>>2]|0;ul=c[b+2176>>2]|0;vl=c[b+2184>>2]|0;wl=c[b+2192>>2]|0;xl=c[b+2200>>2]|0;yl=c[b+2208>>2]|0;zl=c[b+2216>>2]|0;Al=c[b+2224>>2]|0;Bl=c[b+2232>>2]|0;Cl=c[b+2240>>2]|0;Dl=c[b+2248>>2]|0;El=c[b+2256>>2]|0;Fl=c[b+2264>>2]|0;Gl=c[b+2272>>2]|0;Hl=c[b+2280>>2]|0;Il=c[b+2288>>2]|0;Jl=c[b+2296>>2]|0;Kl=c[b+2304>>2]|0;Ll=c[b+2312>>2]|0;Ml=c[b+2320>>2]|0;Nl=c[b+2328>>2]|0;Ol=c[b+2336>>2]|0;Pl=c[b+2344>>2]|0;Ql=c[b+2352>>2]|0;Rl=c[b+2360>>2]|0;Sl=c[b+2368>>2]|0;Tl=c[b+2376>>2]|0;Ul=c[b+2384>>2]|0;Vl=c[b+2392>>2]|0;Wl=c[b+2400>>2]|0;Xl=c[b+2408>>2]|0;Yl=c[b+2416>>2]|0;Zl=c[b+2424>>2]|0;_l=c[b+2432>>2]|0;$l=c[b+2440>>2]|0;am=c[b+2448>>2]|0;bm=c[b+2456>>2]|0;cm=c[b+2464>>2]|0;dm=c[b+2472>>2]|0;em=c[b+2480>>2]|0;fm=c[b+2488>>2]|0;gm=c[b+2496>>2]|0;hm=c[b+2504>>2]|0;im=c[b+2512>>2]|0;jm=c[b+2520>>2]|0;km=c[b+2528>>2]|0;lm=c[b+2536>>2]|0;mm=c[b+2544>>2]|0;nm=c[b+2552>>2]|0;om=c[b+2560>>2]|0;pm=c[b+2568>>2]|0;qm=c[b+2576>>2]|0;rm=c[b+2584>>2]|0;sm=c[b+2592>>2]|0;tm=c[b+2600>>2]|0;um=c[b+2608>>2]|0;vm=c[b+2616>>2]|0;wm=c[b+2624>>2]|0;xm=c[b+2632>>2]|0;ym=c[b+2640>>2]|0;zm=c[b+2648>>2]|0;Am=c[b+2656>>2]|0;Bm=c[b+2664>>2]|0;Cm=c[b+2672>>2]|0;Dm=c[b+2680>>2]|0;Em=c[b+2688>>2]|0;Fm=c[b+2696>>2]|0;Gm=c[b+2704>>2]|0;Hm=c[b+2712>>2]|0;Im=c[b+2720>>2]|0;Jm=c[b+2728>>2]|0;Km=c[b+2736>>2]|0;Lm=c[b+2744>>2]|0;Mm=c[b+2752>>2]|0;Nm=c[b+2760>>2]|0;Om=c[b+2768>>2]|0;Pm=c[b+2776>>2]|0;Qm=c[b+2784>>2]|0;Rm=c[b+2792>>2]|0;Sm=c[b+2800>>2]|0;Tm=c[b+2808>>2]|0;Um=c[b+2816>>2]|0;Vm=c[b+2824>>2]|0;Wm=c[b+2832>>2]|0;Xm=c[b+2840>>2]|0;Ym=c[b+2848>>2]|0;Zm=c[b+2856>>2]|0;_m=c[b+2864>>2]|0;$m=c[b+2872>>2]|0;an=c[b+2880>>2]|0;bn=c[b+2888>>2]|0;cn=c[b+2896>>2]|0;dn=c[b+2904>>2]|0;en=c[b+2912>>2]|0;fn=c[b+2920>>2]|0;gn=c[b+2928>>2]|0;hn=c[b+2936>>2]|0;jn=c[b+2944>>2]|0;kn=c[b+2952>>2]|0;ln=c[b+2960>>2]|0;mn=c[b+2968>>2]|0;nn=c[b+2976>>2]|0;on=c[b+2984>>2]|0;pn=c[b+2992>>2]|0;qn=c[b+3e3>>2]|0;rn=c[b+3008>>2]|0;sn=c[b+3016>>2]|0;tn=c[b+3024>>2]|0;un=c[b+3032>>2]|0;vn=c[b+3040>>2]|0;wn=c[b+3048>>2]|0;xn=c[b+3056>>2]|0;yn=c[b+3064>>2]|0;zn=c[b+3072>>2]|0;An=c[b+3080>>2]|0;Bn=c[b+3088>>2]|0;Cn=c[b+3096>>2]|0;Dn=c[b+3104>>2]|0;En=c[b+3112>>2]|0;Fn=c[b+3120>>2]|0;Gn=c[b+3128>>2]|0;Hn=c[b+3136>>2]|0;In=c[b+3144>>2]|0;Jn=c[b+3152>>2]|0;Kn=c[b+3160>>2]|0;Ln=c[b+3168>>2]|0;Mn=c[b+3176>>2]|0;Nn=c[b+3184>>2]|0;On=c[b+3192>>2]|0;Pn=c[b+3200>>2]|0;Qn=c[b+3208>>2]|0;Rn=c[b+3216>>2]|0;Sn=c[b+3224>>2]|0;Tn=c[b+3232>>2]|0;Un=c[b+3240>>2]|0;Vn=c[b+3248>>2]|0;Wn=c[b+3256>>2]|0;Xn=c[b+3264>>2]|0;Yn=c[b+3272>>2]|0;Zn=c[b+3280>>2]|0;_n=c[b+3288>>2]|0;$n=c[b+3296>>2]|0;ao=c[b+3304>>2]|0;bo=c[b+3312>>2]|0;co=c[b+3320>>2]|0;eo=c[b+3328>>2]|0;fo=c[b+3336>>2]|0;go=c[b+3344>>2]|0;ho=c[b+3352>>2]|0;io=c[b+3360>>2]|0;jo=c[b+3368>>2]|0;ko=c[b+3376>>2]|0;lo=c[b+3384>>2]|0;mo=c[b+3392>>2]|0;no=c[b+3400>>2]|0;oo=c[b+3408>>2]|0;po=c[b+3416>>2]|0;qo=c[b+3424>>2]|0;ro=c[b+3432>>2]|0;so=c[b+3440>>2]|0;to=c[b+3448>>2]|0;uo=c[b+3456>>2]|0;vo=c[b+3464>>2]|0;wo=c[b+3472>>2]|0;xo=c[b+3480>>2]|0;yo=c[b+3488>>2]|0;zo=c[b+3496>>2]|0;Ao=c[b+3504>>2]|0;Bo=c[b+3512>>2]|0;Co=c[b+3520>>2]|0;Do=c[b+3528>>2]|0;Eo=c[b+3536>>2]|0;Fo=c[b+3544>>2]|0;Go=c[b+3552>>2]|0;Ho=c[b+3560>>2]|0;Io=c[b+3568>>2]|0;Jo=c[b+3576>>2]|0;Ko=c[b+3584>>2]|0;Lo=c[b+3592>>2]|0;Mo=c[b+3600>>2]|0;No=c[b+3608>>2]|0;Oo=c[b+3616>>2]|0;Po=c[b+3624>>2]|0;Qo=c[b+3632>>2]|0;Ro=c[b+3640>>2]|0;So=c[b+3648>>2]|0;To=c[b+3656>>2]|0;Uo=c[b+3664>>2]|0;Vo=c[b+3672>>2]|0;Wo=c[b+3680>>2]|0;Xo=c[b+3688>>2]|0;Yo=c[b+3696>>2]|0;Zo=c[b+3704>>2]|0;_o=c[b+3712>>2]|0;$o=c[b+3720>>2]|0;ap=c[b+3728>>2]|0;bp=c[b+3736>>2]|0;cp=c[b+3744>>2]|0;dp=c[b+3752>>2]|0;ep=c[b+3760>>2]|0;fp=c[b+3768>>2]|0;gp=c[b+3776>>2]|0;hp=c[b+3784>>2]|0;ip=c[b+3792>>2]|0;jp=c[b+3800>>2]|0;kp=c[b+3808>>2]|0;lp=c[b+3816>>2]|0;mp=c[b+3824>>2]|0;np=c[b+3832>>2]|0;op=c[b+3840>>2]|0;pp=c[b+3848>>2]|0;qp=c[b+3856>>2]|0;rp=c[b+3864>>2]|0;sp=c[b+3872>>2]|0;tp=c[b+3880>>2]|0;up=c[b+3888>>2]|0;vp=c[b+3896>>2]|0;wp=c[b+3904>>2]|0;xp=c[b+3912>>2]|0;yp=c[b+3920>>2]|0;zp=c[b+3928>>2]|0;Ap=c[b+3936>>2]|0;Bp=c[b+3944>>2]|0;Cp=c[b+3952>>2]|0;Dp=c[b+3960>>2]|0;Ep=c[b+3968>>2]|0;Fp=c[b+3976>>2]|0;Gp=c[b+3984>>2]|0;Hp=c[b+3992>>2]|0;Ip=c[b+4e3>>2]|0;Jp=c[b+4008>>2]|0;Kp=c[b+4016>>2]|0;Lp=c[b+4024>>2]|0;Mp=c[b+4032>>2]|0;Np=c[b+4040>>2]|0;Op=c[b+4048>>2]|0;Pp=c[b+4056>>2]|0;Qp=c[b+4064>>2]|0;Rp=c[b+4072>>2]|0;Sp=c[b+4080>>2]|0;Tp=c[b+4088>>2]|0;Up=c[b+4096>>2]|0;Vp=c[b+4104>>2]|0;Wp=c[b+4112>>2]|0;Xp=c[b+4120>>2]|0;Yp=c[b+4128>>2]|0;Zp=c[b+4136>>2]|0;_p=c[b+4144>>2]|0;$p=c[b+4152>>2]|0;aq=c[b+4160>>2]|0;bq=c[b+4168>>2]|0;cq=c[b+4176>>2]|0;dq=c[b+4184>>2]|0;eq=c[b+4192>>2]|0;fq=c[b+4200>>2]|0;gq=c[b+4208>>2]|0;hq=c[b+4216>>2]|0;iq=c[b+4224>>2]|0;jq=c[b+4232>>2]|0;kq=c[b+4240>>2]|0;lq=c[b+4248>>2]|0;mq=c[b+4256>>2]|0;nq=c[b+4264>>2]|0;oq=c[b+4272>>2]|0;pq=c[b+4280>>2]|0;qq=c[b+4288>>2]|0;rq=c[b+4296>>2]|0;sq=c[b+4304>>2]|0;tq=c[b+4312>>2]|0;uq=c[b+4320>>2]|0;vq=c[b+7880>>2]|0;wq=c[b+7888>>2]|0;xq=c[b+7896>>2]|0;yq=c[b+7912>>2]|0;zq=c[b+7920>>2]|0;Aq=c[b+7928>>2]|0;Bq=c[b+7936>>2]|0;Cq=c[b+7944>>2]|0;Dq=c[b+7952>>2]|0;Eq=c[b+7960>>2]|0;Fq=c[b+7968>>2]|0;Gq=c[b+7976>>2]|0;Hq=c[b+7984>>2]|0;Iq=c[b+8008>>2]|0;Jq=c[b+8016>>2]|0;Kq=c[b+8024>>2]|0;Lq=c[b+8032>>2]|0;Mq=c[b+8040>>2]|0;Nq=c[b+8048>>2]|0;Oq=c[b+8056>>2]|0;Pq=c[b+8064>>2]|0;Qq=c[b+8072>>2]|0;Rq=c[b+8080>>2]|0;Sq=c[b+8096>>2]|0;Tq=c[b+8104>>2]|0;Uq=c[b+8112>>2]|0;Vq=c[b+8120>>2]|0;Wq=c[b+8128>>2]|0;Xq=c[b+8136>>2]|0;Yq=c[b+8144>>2]|0;Zq=c[b+8152>>2]|0;_q=c[b+8160>>2]|0;$q=c[b+8168>>2]|0;ar=c[b+8184>>2]|0;br=c[b+8192>>2]|0;cr=c[b+8200>>2]|0;dr=c[b+8208>>2]|0;er=c[b+8216>>2]|0;fr=c[b+8224>>2]|0;gr=c[b+8232>>2]|0;hr=c[b+8240>>2]|0;ir=c[b+8248>>2]|0;jr=c[b+8256>>2]|0;kr=c[b+8272>>2]|0;lr=c[b+8280>>2]|0;mr=c[b+8288>>2]|0;nr=c[b+8296>>2]|0;or=c[b+8304>>2]|0;pr=c[b+8312>>2]|0;qr=c[b+8320>>2]|0;c[b+776>>2]=hi;c[b+784>>2]=ii;c[b+792>>2]=ji;c[b+800>>2]=ki;c[b+808>>2]=li;c[b+816>>2]=mi;c[b+824>>2]=ni;c[b+832>>2]=oi;c[b+840>>2]=pi;c[b+848>>2]=qi;c[b+856>>2]=ri;c[b+864>>2]=si;c[b+872>>2]=ti;c[b+880>>2]=ui;c[b+888>>2]=vi;c[b+896>>2]=wi;c[b+904>>2]=xi;c[b+912>>2]=yi;c[b+920>>2]=zi;c[b+928>>2]=Ai;c[b+936>>2]=Bi;c[b+944>>2]=Ci;c[b+952>>2]=Di;c[b+960>>2]=Ei;c[b+968>>2]=Fi;c[b+976>>2]=Gi;c[b+984>>2]=Hi;c[b+992>>2]=Ii;c[b+1e3>>2]=Ji;c[b+1008>>2]=Ki;c[b+1016>>2]=Li;c[b+1024>>2]=Mi;c[b+1032>>2]=Ni;c[b+1040>>2]=Oi;c[b+1048>>2]=Pi;c[b+1056>>2]=Qi;c[b+1064>>2]=Ri;c[b+1072>>2]=Si;c[b+1080>>2]=Ti;c[b+1088>>2]=Ui;c[b+1096>>2]=Vi;c[b+1104>>2]=Wi;c[b+1112>>2]=Xi;c[b+1120>>2]=Yi;c[b+1128>>2]=Zi;c[b+1136>>2]=_i;c[b+1144>>2]=$i;c[b+1152>>2]=aj;c[b+1160>>2]=bj;c[b+1168>>2]=cj;c[b+1176>>2]=dj;c[b+1184>>2]=ej;c[b+1192>>2]=fj;c[b+1200>>2]=gj;c[b+1208>>2]=hj;c[b+1216>>2]=ij;c[b+1224>>2]=jj;c[b+1232>>2]=kj;c[b+1240>>2]=lj;c[b+1248>>2]=mj;c[b+1256>>2]=nj;c[b+1264>>2]=oj;c[b+1272>>2]=pj;c[b+1280>>2]=qj;c[b+1288>>2]=rj;c[b+1296>>2]=sj;c[b+1304>>2]=tj;c[b+1312>>2]=uj;c[b+1320>>2]=vj;c[b+1328>>2]=wj;c[b+1336>>2]=xj;c[b+1344>>2]=yj;c[b+1352>>2]=zj;c[b+1360>>2]=Aj;c[b+1368>>2]=Bj;c[b+1376>>2]=Cj;c[b+1384>>2]=Dj;c[b+1392>>2]=Ej;c[b+1400>>2]=Fj;c[b+1408>>2]=Gj;c[b+1416>>2]=Hj;c[b+1424>>2]=Ij;c[b+1432>>2]=Jj;c[b+1440>>2]=Kj;c[b+1448>>2]=Lj;c[b+1456>>2]=Mj;c[b+1464>>2]=Nj;c[b+1472>>2]=Oj;c[b+1480>>2]=Pj;c[b+1488>>2]=Qj;c[b+1496>>2]=Rj;c[b+1504>>2]=Sj;c[b+1512>>2]=Tj;c[b+1520>>2]=Uj;c[b+1528>>2]=Vj;c[b+1536>>2]=Wj;c[b+1544>>2]=Xj;c[b+1552>>2]=Yj;c[b+1560>>2]=Zj;c[b+1568>>2]=_j;c[b+1576>>2]=$j;c[b+1584>>2]=ak;c[b+1592>>2]=bk;c[b+1600>>2]=ck;c[b+1608>>2]=dk;c[b+1616>>2]=ek;c[b+1624>>2]=fk;c[b+1632>>2]=gk;c[b+1640>>2]=hk;c[b+1648>>2]=ik;c[b+1656>>2]=jk;c[b+1664>>2]=kk;c[b+1672>>2]=lk;c[b+1680>>2]=mk;c[b+1688>>2]=nk;c[b+1696>>2]=ok;c[b+1704>>2]=pk;c[b+1712>>2]=qk;c[b+1720>>2]=rk;c[b+1728>>2]=sk;c[b+1736>>2]=tk;c[b+1744>>2]=uk;c[b+1752>>2]=vk;c[b+1760>>2]=wk;c[b+1768>>2]=xk;c[b+1776>>2]=yk;c[b+1784>>2]=zk;c[b+1792>>2]=Ak;c[b+1800>>2]=Bk;c[b+1808>>2]=Ck;c[b+1816>>2]=Dk;c[b+1824>>2]=Ek;c[b+1832>>2]=Fk;c[b+4344>>2]=Xf;c[b+4352>>2]=Wf;c[b+4360>>2]=Vf;c[b+4376>>2]=Uf;c[b+4384>>2]=Tf;c[b+4392>>2]=Sf;c[b+4400>>2]=Rf;c[b+4408>>2]=Qf;c[b+4416>>2]=Pf;c[b+4424>>2]=Of;c[b+4432>>2]=Nf;c[b+4440>>2]=Mf;c[b+4448>>2]=Lf;c[b+4464>>2]=Kf;c[b+4472>>2]=Jf;c[b+4480>>2]=If;c[b+4488>>2]=Hf;c[b+4496>>2]=Gf;c[b+4504>>2]=Ff;c[b+4512>>2]=Ef;c[b+4520>>2]=Df;c[b+4528>>2]=Cf;c[b+4536>>2]=Bf;c[b+4552>>2]=Af;c[b+4560>>2]=zf;c[b+4568>>2]=yf;c[b+4576>>2]=xf;c[b+4584>>2]=wf;c[b+4592>>2]=vf;c[b+4600>>2]=uf;c[b+4608>>2]=tf;c[b+4616>>2]=sf;c[b+4624>>2]=rf;c[b+4648>>2]=qf;c[b+4656>>2]=pf;c[b+4664>>2]=of;c[b+4672>>2]=nf;c[b+4680>>2]=mf;c[b+4688>>2]=lf;c[b+4696>>2]=kf;c[b+4704>>2]=jf;c[b+4712>>2]=hf;c[b+4720>>2]=gf;c[b+4736>>2]=ff;c[b+4744>>2]=ef;c[b+4752>>2]=df;c[b+4760>>2]=cf;c[b+4768>>2]=bf;c[b+4776>>2]=af;c[b+4784>>2]=$e;c[b+4792>>2]=_e;c[b+4800>>2]=Ze;c[b+4808>>2]=Ye;c[b+4824>>2]=Xe;c[b+7880>>2]=vq;c[b+7888>>2]=wq;c[b+7896>>2]=xq;c[b+7912>>2]=yq;c[b+7920>>2]=zq;c[b+7928>>2]=Aq;c[b+7936>>2]=Bq;c[b+7944>>2]=Cq;c[b+7952>>2]=Dq;c[b+7960>>2]=Eq;c[b+7968>>2]=Fq;c[b+7976>>2]=Gq;c[b+7984>>2]=Hq;c[b+8008>>2]=Iq;c[b+8016>>2]=Jq;c[b+8024>>2]=Kq;c[b+8032>>2]=Lq;c[b+8040>>2]=Mq;c[b+8048>>2]=Nq;c[b+8056>>2]=Oq;c[b+8064>>2]=Pq;c[b+8072>>2]=Qq;c[b+8080>>2]=Rq;c[b+8096>>2]=Sq;c[b+8104>>2]=Tq;c[b+8112>>2]=Uq;c[b+8120>>2]=Vq;c[b+8128>>2]=Wq;c[b+8136>>2]=Xq;c[b+8144>>2]=Yq;c[b+8152>>2]=Zq;c[b+8160>>2]=_q;c[b+8168>>2]=$q;c[b+8184>>2]=ar;c[b+8192>>2]=br;c[b+8200>>2]=cr;c[b+8208>>2]=dr;c[b+8216>>2]=er;c[b+8224>>2]=fr;c[b+8232>>2]=gr;c[b+8240>>2]=hr;c[b+8248>>2]=ir;c[b+8256>>2]=jr;c[b+8272>>2]=kr;c[b+8280>>2]=lr;c[b+8288>>2]=mr;c[b+8296>>2]=nr;c[b+8304>>2]=or;c[b+8312>>2]=pr;c[b+8320>>2]=qr;c[b+8328>>2]=zg;c[b+8336>>2]=yg;c[b+8344>>2]=xg;c[b+8360>>2]=wg;c[b+8368>>2]=vg;c[b+8376>>2]=ug;c[b+8384>>2]=tg;c[b+8392>>2]=sg;c[b+8400>>2]=rg;c[b+8408>>2]=qg;c[b+8416>>2]=pg;c[b+8424>>2]=og;c[b+8432>>2]=ng;c[b+8448>>2]=mg;c[b+8456>>2]=lg;c[b+8464>>2]=kg;c[b+8472>>2]=jg;c[b+8480>>2]=ig;c[b+8488>>2]=hg;c[b+8496>>2]=gg;c[b+8504>>2]=fg;c[b+8512>>2]=eg;c[b+8520>>2]=dg;c[b+8536>>2]=cg;c[b+8544>>2]=bg;c[b+8552>>2]=ag;c[b+8560>>2]=$f;c[b+8568>>2]=_f;c[b+8576>>2]=Zf;c[b+8584>>2]=Yf;c[b+8624>>2]=0;c[b+8628>>2]=0;_Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$3(b);c[b+1840>>2]=Gk;c[b+1848>>2]=Hk;c[b+1856>>2]=Ik;c[b+1864>>2]=Jk;c[b+1872>>2]=Kk;c[b+1880>>2]=Lk;c[b+1888>>2]=Mk;c[b+1896>>2]=Nk;c[b+1904>>2]=Ok;c[b+1912>>2]=Pk;c[b+1920>>2]=Qk;c[b+1928>>2]=Rk;c[b+1936>>2]=Sk;c[b+1944>>2]=Tk;c[b+1952>>2]=Uk;c[b+1960>>2]=Vk;c[b+1968>>2]=Wk;c[b+1976>>2]=Xk;c[b+1984>>2]=Yk;c[b+1992>>2]=Zk;c[b+2e3>>2]=_k;c[b+2008>>2]=$k;c[b+2016>>2]=al;c[b+2024>>2]=bl;c[b+2032>>2]=cl;c[b+2040>>2]=dl;c[b+2048>>2]=el;c[b+2056>>2]=fl;c[b+2064>>2]=gl;c[b+2072>>2]=hl;c[b+2080>>2]=il;c[b+2088>>2]=jl;c[b+2096>>2]=kl;c[b+2104>>2]=ll;c[b+2112>>2]=ml;c[b+2120>>2]=nl;c[b+2128>>2]=ol;c[b+2136>>2]=pl;c[b+2144>>2]=ql;c[b+2152>>2]=rl;c[b+2160>>2]=sl;c[b+2168>>2]=tl;c[b+2176>>2]=ul;c[b+2184>>2]=vl;c[b+2192>>2]=wl;c[b+2200>>2]=xl;c[b+2208>>2]=yl;c[b+2216>>2]=zl;c[b+2224>>2]=Al;c[b+2232>>2]=Bl;c[b+2240>>2]=Cl;c[b+2248>>2]=Dl;c[b+2256>>2]=El;c[b+2264>>2]=Fl;c[b+2272>>2]=Gl;c[b+2280>>2]=Hl;c[b+2288>>2]=Il;c[b+2296>>2]=Jl;c[b+2304>>2]=Kl;c[b+2312>>2]=Ll;c[b+2320>>2]=Ml;c[b+2328>>2]=Nl;c[b+2336>>2]=Ol;c[b+2344>>2]=Pl;c[b+2352>>2]=Ql;c[b+2360>>2]=Rl;c[b+2368>>2]=Sl;c[b+2376>>2]=Tl;c[b+2384>>2]=Ul;c[b+2392>>2]=Vl;c[b+2400>>2]=Wl;c[b+2408>>2]=Xl;c[b+2416>>2]=Yl;c[b+2424>>2]=Zl;c[b+2432>>2]=_l;c[b+2440>>2]=$l;c[b+2448>>2]=am;c[b+2456>>2]=bm;c[b+2464>>2]=cm;c[b+2472>>2]=dm;c[b+2480>>2]=em;c[b+2488>>2]=fm;c[b+2496>>2]=gm;c[b+2504>>2]=hm;c[b+2512>>2]=im;c[b+2520>>2]=jm;c[b+2528>>2]=km;c[b+2536>>2]=lm;c[b+2544>>2]=mm;c[b+2552>>2]=nm;c[b+2560>>2]=om;c[b+2568>>2]=pm;c[b+2576>>2]=qm;c[b+2584>>2]=rm;c[b+2592>>2]=sm;c[b+2600>>2]=tm;c[b+2608>>2]=um;c[b+2616>>2]=vm;c[b+2624>>2]=wm;c[b+2632>>2]=xm;c[b+2640>>2]=ym;c[b+2648>>2]=zm;c[b+2656>>2]=Am;c[b+2664>>2]=Bm;c[b+2672>>2]=Cm;c[b+2680>>2]=Dm;c[b+2688>>2]=Em;c[b+2696>>2]=Fm;c[b+2704>>2]=Gm;c[b+2712>>2]=Hm;c[b+2720>>2]=Im;c[b+2728>>2]=Jm;c[b+2736>>2]=Km;c[b+2744>>2]=Lm;c[b+2752>>2]=Mm;c[b+2760>>2]=Nm;c[b+2768>>2]=Om;c[b+2776>>2]=Pm;c[b+2784>>2]=Qm;c[b+2792>>2]=Rm;c[b+2800>>2]=Sm;c[b+2808>>2]=Tm;c[b+2816>>2]=Um;c[b+2824>>2]=Vm;c[b+2832>>2]=Wm;c[b+2840>>2]=Xm;c[b+2848>>2]=Ym;c[b+4824>>2]=Xe;c[b+4832>>2]=We;c[b+4840>>2]=Ve;c[b+4848>>2]=Ue;c[b+4856>>2]=Te;c[b+4864>>2]=Se;c[b+4872>>2]=Re;c[b+4880>>2]=Qe;c[b+4888>>2]=Pe;c[b+4896>>2]=Oe;c[b+4912>>2]=Ne;c[b+4920>>2]=Me;c[b+4928>>2]=Le;c[b+4936>>2]=Ke;c[b+4944>>2]=Je;c[b+4952>>2]=Ie;c[b+4960>>2]=He;c[b+4968>>2]=Ge;c[b+4976>>2]=Fe;c[b+4984>>2]=Ee;c[b+5e3>>2]=De;c[b+5008>>2]=Ce;c[b+5016>>2]=Be;c[b+5024>>2]=Ae;c[b+5032>>2]=ze;c[b+5040>>2]=ye;c[b+5048>>2]=xe;c[b+5056>>2]=we;c[b+5064>>2]=ve;c[b+5072>>2]=ue;c[b+5088>>2]=te;c[b+5096>>2]=se;c[b+5104>>2]=re;c[b+5112>>2]=qe;c[b+5120>>2]=pe;c[b+5128>>2]=oe;c[b+5136>>2]=ne;c[b+5144>>2]=me;c[b+5152>>2]=le;c[b+5160>>2]=ke;c[b+5176>>2]=je;c[b+5184>>2]=ie;c[b+5192>>2]=he;c[b+5200>>2]=ge;c[b+5208>>2]=fe;c[b+5216>>2]=ee;c[b+5224>>2]=de;c[b+5232>>2]=ce;c[b+5240>>2]=be;c[b+5248>>2]=ae;c[b+5264>>2]=$d;c[b+5272>>2]=_d;c[b+5280>>2]=Zd;c[b+5288>>2]=Yd;c[b+5296>>2]=Xd;c[b+5304>>2]=Wd;c[b+5312>>2]=Vd;c[b+5320>>2]=Ud;c[b+5328>>2]=Td;c[b+5336>>2]=Sd;c[b+5352>>2]=Rd;c[b+5360>>2]=Qd;c[b+5368>>2]=Pd;c[b+5376>>2]=Od;c[b+5384>>2]=Nd;c[b+5392>>2]=Md;c[b+5400>>2]=Ld;c[b+5408>>2]=Kd;c[b+5416>>2]=Jd;c[b+5424>>2]=Id;c[b+5440>>2]=Hd;c[b+5448>>2]=Gd;c[b+5456>>2]=Fd;c[b+5464>>2]=Ed;c[b+5472>>2]=Dd;c[b+5480>>2]=Cd;c[b+5488>>2]=Bd;c[b+5496>>2]=Ad;c[b+5504>>2]=zd;c[b+5512>>2]=yd;c[b+5536>>2]=xd;c[b+5544>>2]=wd;c[b+5552>>2]=vd;c[b+5560>>2]=ud;c[b+5568>>2]=td;c[b+5576>>2]=sd;c[b+5584>>2]=rd;c[b+5592>>2]=qd;c[b+5600>>2]=pd;c[b+5608>>2]=od;c[b+5624>>2]=nd;c[b+5632>>2]=md;c[b+5640>>2]=ld;c[b+5648>>2]=kd;c[b+5656>>2]=jd;c[b+5664>>2]=id;c[b+5672>>2]=hd;c[b+5680>>2]=gd;c[b+5688>>2]=fd;c[b+5696>>2]=ed;c[b+5712>>2]=dd;c[b+5720>>2]=cd;c[b+5728>>2]=bd;c[b+5736>>2]=ad;c[b+5744>>2]=$c;c[b+5752>>2]=_c;c[b+5760>>2]=Zc;c[b+5768>>2]=Yc;c[b+5776>>2]=Xc;c[b+5784>>2]=Wc;c[b+5800>>2]=Vc;c[b+5808>>2]=Uc;c[b+5816>>2]=Tc;c[b+5824>>2]=Sc;c[b+5832>>2]=Rc;c[b+5840>>2]=Qc;c[b+5848>>2]=Pc;c[b+5856>>2]=Oc;c[b+5864>>2]=Nc;c[b+5872>>2]=Mc;c[b+5888>>2]=Lc;c[b+5896>>2]=Kc;c[b+5904>>2]=Jc;c[b+5912>>2]=Ic;c[b+5920>>2]=Hc;c[b+5928>>2]=Gc;c[b+5936>>2]=Fc;c[b+5944>>2]=Ec;c[b+8616>>2]=0;c[b+8620>>2]=0;_Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$2(b);c[b+2856>>2]=Zm;c[b+2864>>2]=_m;c[b+2872>>2]=$m;c[b+2880>>2]=an;c[b+2888>>2]=bn;c[b+2896>>2]=cn;c[b+2904>>2]=dn;c[b+2912>>2]=en;c[b+2920>>2]=fn;c[b+2928>>2]=gn;c[b+2936>>2]=hn;c[b+2944>>2]=jn;c[b+2952>>2]=kn;c[b+2960>>2]=ln;c[b+2968>>2]=mn;c[b+2976>>2]=nn;c[b+2984>>2]=on;c[b+2992>>2]=pn;c[b+3e3>>2]=qn;c[b+3008>>2]=rn;c[b+3016>>2]=sn;c[b+3024>>2]=tn;c[b+3032>>2]=un;c[b+3040>>2]=vn;c[b+3048>>2]=wn;c[b+3056>>2]=xn;c[b+3064>>2]=yn;c[b+3072>>2]=zn;c[b+3080>>2]=An;c[b+3088>>2]=Bn;c[b+3096>>2]=Cn;c[b+3104>>2]=Dn;c[b+3112>>2]=En;c[b+3120>>2]=Fn;c[b+3128>>2]=Gn;c[b+3136>>2]=Hn;c[b+3144>>2]=In;c[b+3152>>2]=Jn;c[b+3160>>2]=Kn;c[b+3168>>2]=Ln;c[b+3176>>2]=Mn;c[b+3184>>2]=Nn;c[b+3192>>2]=On;c[b+3200>>2]=Pn;c[b+3208>>2]=Qn;c[b+3216>>2]=Rn;c[b+3224>>2]=Sn;c[b+3232>>2]=Tn;c[b+3240>>2]=Un;c[b+3248>>2]=Vn;c[b+3256>>2]=Wn;c[b+3264>>2]=Xn;c[b+3272>>2]=Yn;c[b+3280>>2]=Zn;c[b+3288>>2]=_n;c[b+3296>>2]=$n;c[b+3304>>2]=ao;c[b+3312>>2]=bo;c[b+3320>>2]=co;c[b+3328>>2]=eo;c[b+3336>>2]=fo;c[b+3344>>2]=go;c[b+3352>>2]=ho;c[b+3360>>2]=io;c[b+3368>>2]=jo;c[b+3376>>2]=ko;c[b+3384>>2]=lo;c[b+3392>>2]=mo;c[b+3400>>2]=no;c[b+3408>>2]=oo;c[b+3416>>2]=po;c[b+3424>>2]=qo;c[b+3432>>2]=ro;c[b+3440>>2]=so;c[b+3448>>2]=to;c[b+3456>>2]=uo;c[b+3464>>2]=vo;c[b+3472>>2]=wo;c[b+3480>>2]=xo;c[b+3488>>2]=yo;c[b+3496>>2]=zo;c[b+3504>>2]=Ao;c[b+3512>>2]=Bo;c[b+3520>>2]=Co;c[b+3528>>2]=Do;c[b+3536>>2]=Eo;c[b+3544>>2]=Fo;c[b+3552>>2]=Go;c[b+3560>>2]=Ho;c[b+3568>>2]=Io;c[b+3576>>2]=Jo;c[b+3584>>2]=Ko;c[b+3592>>2]=Lo;c[b+3600>>2]=Mo;c[b+3608>>2]=No;c[b+3616>>2]=Oo;c[b+3624>>2]=Po;c[b+3632>>2]=Qo;c[b+3640>>2]=Ro;c[b+3648>>2]=So;c[b+3656>>2]=To;c[b+3664>>2]=Uo;c[b+3672>>2]=Vo;c[b+3680>>2]=Wo;c[b+3688>>2]=Xo;c[b+3696>>2]=Yo;c[b+3704>>2]=Zo;c[b+3712>>2]=_o;c[b+3720>>2]=$o;c[b+3728>>2]=ap;c[b+3736>>2]=bp;c[b+3744>>2]=cp;c[b+3752>>2]=dp;c[b+3760>>2]=ep;c[b+3768>>2]=fp;c[b+3776>>2]=gp;c[b+3784>>2]=hp;c[b+3792>>2]=ip;c[b+3800>>2]=jp;c[b+3808>>2]=kp;c[b+3816>>2]=lp;c[b+3824>>2]=mp;c[b+3832>>2]=np;c[b+5944>>2]=Ec;c[b+5952>>2]=Dc;c[b+5960>>2]=Cc;c[b+5976>>2]=Bc;c[b+5984>>2]=Ac;c[b+5992>>2]=zc;c[b+6e3>>2]=yc;c[b+6008>>2]=xc;c[b+6016>>2]=wc;c[b+6024>>2]=vc;c[b+6032>>2]=uc;c[b+6040>>2]=tc;c[b+6048>>2]=sc;c[b+6064>>2]=rc;c[b+6072>>2]=qc;c[b+6080>>2]=pc;c[b+6088>>2]=oc;c[b+6096>>2]=nc;c[b+6104>>2]=mc;c[b+6112>>2]=lc;c[b+6120>>2]=kc;c[b+6128>>2]=jc;c[b+6136>>2]=ic;c[b+6152>>2]=hc;c[b+6160>>2]=gc;c[b+6168>>2]=fc;c[b+6176>>2]=ec;c[b+6184>>2]=dc;c[b+6192>>2]=cc;c[b+6200>>2]=bc;c[b+6208>>2]=ac;c[b+6216>>2]=$b;c[b+6224>>2]=_b;c[b+6240>>2]=Zb;c[b+6248>>2]=Yb;c[b+6256>>2]=Xb;c[b+6264>>2]=Wb;c[b+6272>>2]=Vb;c[b+6280>>2]=Ub;c[b+6288>>2]=Tb;c[b+6296>>2]=Sb;c[b+6304>>2]=Rb;c[b+6312>>2]=Qb;c[b+6328>>2]=Pb;c[b+6336>>2]=Ob;c[b+6344>>2]=Nb;c[b+6352>>2]=Mb;c[b+6360>>2]=Lb;c[b+6368>>2]=Kb;c[b+6376>>2]=Jb;c[b+6384>>2]=Ib;c[b+6392>>2]=Hb;c[b+6400>>2]=Gb;c[b+6424>>2]=Fb;c[b+6432>>2]=Eb;c[b+6440>>2]=Db;c[b+6448>>2]=Cb;c[b+6456>>2]=Bb;c[b+6464>>2]=Ab;c[b+6472>>2]=zb;c[b+6480>>2]=yb;c[b+6488>>2]=xb;c[b+6496>>2]=wb;c[b+6512>>2]=vb;c[b+6520>>2]=ub;c[b+6528>>2]=tb;c[b+6536>>2]=sb;c[b+6544>>2]=rb;c[b+6552>>2]=qb;c[b+6560>>2]=pb;c[b+6568>>2]=ob;c[b+6576>>2]=nb;c[b+6584>>2]=mb;c[b+6600>>2]=lb;c[b+6608>>2]=kb;c[b+6616>>2]=jb;c[b+6624>>2]=ib;c[b+6632>>2]=hb;c[b+6640>>2]=gb;c[b+6648>>2]=fb;c[b+6656>>2]=eb;c[b+6664>>2]=db;c[b+6672>>2]=cb;c[b+6688>>2]=bb;c[b+6696>>2]=ab;c[b+6704>>2]=$a;c[b+6712>>2]=_a;c[b+6720>>2]=Za;c[b+6728>>2]=Ya;c[b+6736>>2]=Xa;c[b+6744>>2]=Wa;c[b+6752>>2]=Va;c[b+6760>>2]=Ua;c[b+6776>>2]=Ta;c[b+6784>>2]=Sa;c[b+6792>>2]=Ra;c[b+6800>>2]=Qa;c[b+6808>>2]=Pa;c[b+6816>>2]=Oa;c[b+6824>>2]=Na;c[b+6832>>2]=Ma;c[b+6840>>2]=La;c[b+6848>>2]=Ka;c[b+6864>>2]=Ja;c[b+6872>>2]=Ia;c[b+6880>>2]=Ha;c[b+6888>>2]=Ga;c[b+6896>>2]=Fa;c[b+6904>>2]=Ea;c[b+6912>>2]=Da;c[b+6920>>2]=Ca;c[b+6928>>2]=Ba;c[b+6936>>2]=Aa;c[b+6952>>2]=za;c[b+6960>>2]=ya;c[b+6968>>2]=xa;c[b+6976>>2]=wa;c[b+6984>>2]=va;c[b+6992>>2]=ua;c[b+7e3>>2]=ta;c[b+7008>>2]=sa;c[b+7016>>2]=ra;c[b+7024>>2]=qa;c[b+7040>>2]=pa;c[b+8608>>2]=0;c[b+8612>>2]=0;_Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$1(b);c[b+48>>2]=a;c[b+56>>2]=Ag;c[b+72>>2]=Bg;c[b+80>>2]=Cg;c[b+88>>2]=Dg;c[b+96>>2]=Eg;c[b+104>>2]=Fg;c[b+112>>2]=Gg;c[b+120>>2]=Hg;c[b+128>>2]=Ig;c[b+136>>2]=Jg;c[b+144>>2]=Kg;c[b+152>>2]=Lg;c[b+160>>2]=Mg;c[b+168>>2]=Ng;c[b+176>>2]=Og;c[b+184>>2]=Pg;c[b+192>>2]=Qg;c[b+200>>2]=Rg;c[b+208>>2]=Sg;c[b+216>>2]=Tg;c[b+224>>2]=Ug;c[b+232>>2]=Vg;c[b+240>>2]=Wg;c[b+248>>2]=Xg;c[b+256>>2]=Yg;c[b+264>>2]=Zg;c[b+272>>2]=_g;c[b+280>>2]=$g;c[b+288>>2]=ah;c[b+296>>2]=bh;c[b+304>>2]=ch;c[b+312>>2]=dh;c[b+320>>2]=eh;c[b+328>>2]=fh;c[b+336>>2]=gh;c[b+344>>2]=hh;c[b+352>>2]=ih;c[b+360>>2]=jh;c[b+368>>2]=kh;c[b+376>>2]=lh;c[b+384>>2]=mh;c[b+392>>2]=nh;c[b+400>>2]=oh;c[b+408>>2]=ph;c[b+416>>2]=qh;c[b+424>>2]=rh;c[b+432>>2]=sh;c[b+440>>2]=th;c[b+448>>2]=uh;c[b+456>>2]=vh;c[b+464>>2]=wh;c[b+472>>2]=xh;c[b+480>>2]=yh;c[b+488>>2]=zh;c[b+496>>2]=Ah;c[b+504>>2]=Bh;c[b+512>>2]=Ch;c[b+520>>2]=Dh;c[b+528>>2]=Eh;c[b+536>>2]=Fh;c[b+544>>2]=Gh;c[b+552>>2]=Hh;c[b+560>>2]=Ih;c[b+568>>2]=Jh;c[b+576>>2]=Kh;c[b+584>>2]=Lh;c[b+592>>2]=Mh;c[b+600>>2]=Nh;c[b+608>>2]=Oh;c[b+616>>2]=Ph;c[b+624>>2]=Qh;c[b+632>>2]=Rh;c[b+640>>2]=Sh;c[b+648>>2]=Th;c[b+656>>2]=Uh;c[b+664>>2]=Vh;c[b+672>>2]=Wh;c[b+680>>2]=Xh;c[b+688>>2]=Yh;c[b+696>>2]=Zh;c[b+704>>2]=_h;c[b+712>>2]=$h;c[b+720>>2]=ai;c[b+728>>2]=bi;c[b+736>>2]=ci;c[b+744>>2]=di;c[b+752>>2]=ei;c[b+760>>2]=fi;c[b+768>>2]=gi;c[b+776>>2]=hi;c[b+784>>2]=ii;c[b+792>>2]=ji;c[b+800>>2]=ki;c[b+808>>2]=li;c[b+816>>2]=mi;c[b+824>>2]=ni;c[b+832>>2]=oi;c[b+840>>2]=pi;c[b+848>>2]=qi;c[b+856>>2]=ri;c[b+864>>2]=si;c[b+872>>2]=ti;c[b+880>>2]=ui;c[b+888>>2]=vi;c[b+896>>2]=wi;c[b+904>>2]=xi;c[b+912>>2]=yi;c[b+920>>2]=zi;c[b+928>>2]=Ai;c[b+936>>2]=Bi;c[b+944>>2]=Ci;c[b+952>>2]=Di;c[b+960>>2]=Ei;c[b+968>>2]=Fi;c[b+976>>2]=Gi;c[b+984>>2]=Hi;c[b+992>>2]=Ii;c[b+1e3>>2]=Ji;c[b+1008>>2]=Ki;c[b+1016>>2]=Li;c[b+1024>>2]=Mi;c[b+1032>>2]=Ni;c[b+1040>>2]=Oi;c[b+1048>>2]=Pi;c[b+1056>>2]=Qi;c[b+1064>>2]=Ri;c[b+1072>>2]=Si;c[b+1080>>2]=Ti;c[b+1088>>2]=Ui;c[b+1096>>2]=Vi;c[b+1104>>2]=Wi;c[b+1112>>2]=Xi;c[b+1120>>2]=Yi;c[b+1128>>2]=Zi;c[b+1136>>2]=_i;c[b+1144>>2]=$i;c[b+1152>>2]=aj;c[b+1160>>2]=bj;c[b+1168>>2]=cj;c[b+1176>>2]=dj;c[b+1184>>2]=ej;c[b+1192>>2]=fj;c[b+1200>>2]=gj;c[b+1208>>2]=hj;c[b+1216>>2]=ij;c[b+1224>>2]=jj;c[b+1232>>2]=kj;c[b+1240>>2]=lj;c[b+1248>>2]=mj;c[b+1256>>2]=nj;c[b+1264>>2]=oj;c[b+1272>>2]=pj;c[b+1280>>2]=qj;c[b+1288>>2]=rj;c[b+1296>>2]=sj;c[b+1304>>2]=tj;c[b+1312>>2]=uj;c[b+1320>>2]=vj;c[b+1328>>2]=wj;c[b+1336>>2]=xj;c[b+1344>>2]=yj;c[b+1352>>2]=zj;c[b+1360>>2]=Aj;c[b+1368>>2]=Bj;c[b+1376>>2]=Cj;c[b+1384>>2]=Dj;c[b+1392>>2]=Ej;c[b+1400>>2]=Fj;c[b+1408>>2]=Gj;c[b+1416>>2]=Hj;c[b+1424>>2]=Ij;c[b+1432>>2]=Jj;c[b+1440>>2]=Kj;c[b+1448>>2]=Lj;c[b+1456>>2]=Mj;c[b+1464>>2]=Nj;c[b+1472>>2]=Oj;c[b+1480>>2]=Pj;c[b+1488>>2]=Qj;c[b+1496>>2]=Rj;c[b+1504>>2]=Sj;c[b+1512>>2]=Tj;c[b+1520>>2]=Uj;c[b+1528>>2]=Vj;c[b+1536>>2]=Wj;c[b+1544>>2]=Xj;c[b+1552>>2]=Yj;c[b+1560>>2]=Zj;c[b+1568>>2]=_j;c[b+1576>>2]=$j;c[b+1584>>2]=ak;c[b+1592>>2]=bk;c[b+1600>>2]=ck;c[b+1608>>2]=dk;c[b+1616>>2]=ek;c[b+1624>>2]=fk;c[b+1632>>2]=gk;c[b+1640>>2]=hk;c[b+1648>>2]=ik;c[b+1656>>2]=jk;c[b+1664>>2]=kk;c[b+1672>>2]=lk;c[b+1680>>2]=mk;c[b+1688>>2]=nk;c[b+1696>>2]=ok;c[b+1704>>2]=pk;c[b+1712>>2]=qk;c[b+1720>>2]=rk;c[b+1728>>2]=sk;c[b+1736>>2]=tk;c[b+1744>>2]=uk;c[b+1752>>2]=vk;c[b+1760>>2]=wk;c[b+1768>>2]=xk;c[b+1776>>2]=yk;c[b+1784>>2]=zk;c[b+1792>>2]=Ak;c[b+1800>>2]=Bk;c[b+1808>>2]=Ck;c[b+1816>>2]=Dk;c[b+1824>>2]=Ek;c[b+1832>>2]=Fk;c[b+1840>>2]=Gk;c[b+1848>>2]=Hk;c[b+1856>>2]=Ik;c[b+1864>>2]=Jk;c[b+1872>>2]=Kk;c[b+1880>>2]=Lk;c[b+1888>>2]=Mk;c[b+1896>>2]=Nk;c[b+1904>>2]=Ok;c[b+1912>>2]=Pk;c[b+1920>>2]=Qk;c[b+1928>>2]=Rk;c[b+1936>>2]=Sk;c[b+1944>>2]=Tk;c[b+1952>>2]=Uk;c[b+1960>>2]=Vk;c[b+1968>>2]=Wk;c[b+1976>>2]=Xk;c[b+1984>>2]=Yk;c[b+1992>>2]=Zk;c[b+2e3>>2]=_k;c[b+2008>>2]=$k;c[b+2016>>2]=al;c[b+2024>>2]=bl;c[b+2032>>2]=cl;c[b+2040>>2]=dl;c[b+2048>>2]=el;c[b+2056>>2]=fl;c[b+2064>>2]=gl;c[b+2072>>2]=hl;c[b+2080>>2]=il;c[b+2088>>2]=jl;c[b+2096>>2]=kl;c[b+2104>>2]=ll;c[b+2112>>2]=ml;c[b+2120>>2]=nl;c[b+2128>>2]=ol;c[b+2136>>2]=pl;c[b+2144>>2]=ql;c[b+2152>>2]=rl;c[b+2160>>2]=sl;c[b+2168>>2]=tl;c[b+2176>>2]=ul;c[b+2184>>2]=vl;c[b+2192>>2]=wl;c[b+2200>>2]=xl;c[b+2208>>2]=yl;c[b+2216>>2]=zl;c[b+2224>>2]=Al;c[b+2232>>2]=Bl;c[b+2240>>2]=Cl;c[b+2248>>2]=Dl;c[b+2256>>2]=El;c[b+2264>>2]=Fl;c[b+2272>>2]=Gl;c[b+2280>>2]=Hl;c[b+2288>>2]=Il;c[b+2296>>2]=Jl;c[b+2304>>2]=Kl;c[b+2312>>2]=Ll;c[b+2320>>2]=Ml;c[b+2328>>2]=Nl;c[b+2336>>2]=Ol;c[b+2344>>2]=Pl;c[b+2352>>2]=Ql;c[b+2360>>2]=Rl;c[b+2368>>2]=Sl;c[b+2376>>2]=Tl;c[b+2384>>2]=Ul;c[b+2392>>2]=Vl;c[b+2400>>2]=Wl;c[b+2408>>2]=Xl;c[b+2416>>2]=Yl;c[b+2424>>2]=Zl;c[b+2432>>2]=_l;c[b+2440>>2]=$l;c[b+2448>>2]=am;c[b+2456>>2]=bm;c[b+2464>>2]=cm;c[b+2472>>2]=dm;c[b+2480>>2]=em;c[b+2488>>2]=fm;c[b+2496>>2]=gm;c[b+2504>>2]=hm;c[b+2512>>2]=im;c[b+2520>>2]=jm;c[b+2528>>2]=km;c[b+2536>>2]=lm;c[b+2544>>2]=mm;c[b+2552>>2]=nm;c[b+2560>>2]=om;c[b+2568>>2]=pm;c[b+2576>>2]=qm;c[b+2584>>2]=rm;c[b+2592>>2]=sm;c[b+2600>>2]=tm;c[b+2608>>2]=um;c[b+2616>>2]=vm;c[b+2624>>2]=wm;c[b+2632>>2]=xm;c[b+2640>>2]=ym;c[b+2648>>2]=zm;c[b+2656>>2]=Am;c[b+2664>>2]=Bm;c[b+2672>>2]=Cm;c[b+2680>>2]=Dm;c[b+2688>>2]=Em;c[b+2696>>2]=Fm;c[b+2704>>2]=Gm;c[b+2712>>2]=Hm;c[b+2720>>2]=Im;c[b+2728>>2]=Jm;c[b+2736>>2]=Km;c[b+2744>>2]=Lm;c[b+2752>>2]=Mm;c[b+2760>>2]=Nm;c[b+2768>>2]=Om;c[b+2776>>2]=Pm;c[b+2784>>2]=Qm;c[b+2792>>2]=Rm;c[b+2800>>2]=Sm;c[b+2808>>2]=Tm;c[b+2816>>2]=Um;c[b+2824>>2]=Vm;c[b+2832>>2]=Wm;c[b+2840>>2]=Xm;c[b+2848>>2]=Ym;c[b+2856>>2]=Zm;c[b+2864>>2]=_m;c[b+2872>>2]=$m;c[b+2880>>2]=an;c[b+2888>>2]=bn;c[b+2896>>2]=cn;c[b+2904>>2]=dn;c[b+2912>>2]=en;c[b+2920>>2]=fn;c[b+2928>>2]=gn;c[b+2936>>2]=hn;c[b+2944>>2]=jn;c[b+2952>>2]=kn;c[b+2960>>2]=ln;c[b+2968>>2]=mn;c[b+2976>>2]=nn;c[b+2984>>2]=on;c[b+2992>>2]=pn;c[b+3e3>>2]=qn;c[b+3008>>2]=rn;c[b+3016>>2]=sn;c[b+3024>>2]=tn;c[b+3032>>2]=un;c[b+3040>>2]=vn;c[b+3048>>2]=wn;c[b+3056>>2]=xn;c[b+3064>>2]=yn;c[b+3072>>2]=zn;c[b+3080>>2]=An;c[b+3088>>2]=Bn;c[b+3096>>2]=Cn;c[b+3104>>2]=Dn;c[b+3112>>2]=En;c[b+3120>>2]=Fn;c[b+3128>>2]=Gn;c[b+3136>>2]=Hn;c[b+3144>>2]=In;c[b+3152>>2]=Jn;c[b+3160>>2]=Kn;c[b+3168>>2]=Ln;c[b+3176>>2]=Mn;c[b+3184>>2]=Nn;c[b+3192>>2]=On;c[b+3200>>2]=Pn;c[b+3208>>2]=Qn;c[b+3216>>2]=Rn;c[b+3224>>2]=Sn;c[b+3232>>2]=Tn;c[b+3240>>2]=Un;c[b+3248>>2]=Vn;c[b+3256>>2]=Wn;c[b+3264>>2]=Xn;c[b+3272>>2]=Yn;c[b+3280>>2]=Zn;c[b+3288>>2]=_n;c[b+3296>>2]=$n;c[b+3304>>2]=ao;c[b+3312>>2]=bo;c[b+3320>>2]=co;c[b+3328>>2]=eo;c[b+3336>>2]=fo;c[b+3344>>2]=go;c[b+3352>>2]=ho;c[b+3360>>2]=io;c[b+3368>>2]=jo;c[b+3376>>2]=ko;c[b+3384>>2]=lo;c[b+3392>>2]=mo;c[b+3400>>2]=no;c[b+3408>>2]=oo;c[b+3416>>2]=po;c[b+3424>>2]=qo;c[b+3432>>2]=ro;c[b+3440>>2]=so;c[b+3448>>2]=to;c[b+3456>>2]=uo;c[b+3464>>2]=vo;c[b+3472>>2]=wo;c[b+3480>>2]=xo;c[b+3488>>2]=yo;c[b+3496>>2]=zo;c[b+3504>>2]=Ao;c[b+3512>>2]=Bo;c[b+3520>>2]=Co;c[b+3528>>2]=Do;c[b+3536>>2]=Eo;c[b+3544>>2]=Fo;c[b+3552>>2]=Go;c[b+3560>>2]=Ho;c[b+3568>>2]=Io;c[b+3576>>2]=Jo;c[b+3584>>2]=Ko;c[b+3592>>2]=Lo;c[b+3600>>2]=Mo;c[b+3608>>2]=No;c[b+3616>>2]=Oo;c[b+3624>>2]=Po;c[b+3632>>2]=Qo;c[b+3640>>2]=Ro;c[b+3648>>2]=So;c[b+3656>>2]=To;c[b+3664>>2]=Uo;c[b+3672>>2]=Vo;c[b+3680>>2]=Wo;c[b+3688>>2]=Xo;c[b+3696>>2]=Yo;c[b+3704>>2]=Zo;c[b+3712>>2]=_o;c[b+3720>>2]=$o;c[b+3728>>2]=ap;c[b+3736>>2]=bp;c[b+3744>>2]=cp;c[b+3752>>2]=dp;c[b+3760>>2]=ep;c[b+3768>>2]=fp;c[b+3776>>2]=gp;c[b+3784>>2]=hp;c[b+3792>>2]=ip;c[b+3800>>2]=jp;c[b+3808>>2]=kp;c[b+3816>>2]=lp;c[b+3824>>2]=mp;c[b+3832>>2]=np;c[b+3840>>2]=op;c[b+3848>>2]=pp;c[b+3856>>2]=qp;c[b+3864>>2]=rp;c[b+3872>>2]=sp;c[b+3880>>2]=tp;c[b+3888>>2]=up;c[b+3896>>2]=vp;c[b+3904>>2]=wp;c[b+3912>>2]=xp;c[b+3920>>2]=yp;c[b+3928>>2]=zp;c[b+3936>>2]=Ap;c[b+3944>>2]=Bp;c[b+3952>>2]=Cp;c[b+3960>>2]=Dp;c[b+3968>>2]=Ep;c[b+3976>>2]=Fp;c[b+3984>>2]=Gp;c[b+3992>>2]=Hp;c[b+4e3>>2]=Ip;c[b+4008>>2]=Jp;c[b+4016>>2]=Kp;c[b+4024>>2]=Lp;c[b+4032>>2]=Mp;c[b+4040>>2]=Np;c[b+4048>>2]=Op;c[b+4056>>2]=Pp;c[b+4064>>2]=Qp;c[b+4072>>2]=Rp;c[b+4080>>2]=Sp;c[b+4088>>2]=Tp;c[b+4096>>2]=Up;c[b+4104>>2]=Vp;c[b+4112>>2]=Wp;c[b+4120>>2]=Xp;c[b+4128>>2]=Yp;c[b+4136>>2]=Zp;c[b+4144>>2]=_p;c[b+4152>>2]=$p;c[b+4160>>2]=aq;c[b+4168>>2]=bq;c[b+4176>>2]=cq;c[b+4184>>2]=dq;c[b+4192>>2]=eq;c[b+4200>>2]=fq;c[b+4208>>2]=gq;c[b+4216>>2]=hq;c[b+4224>>2]=iq;c[b+4232>>2]=jq;c[b+4240>>2]=kq;c[b+4248>>2]=lq;c[b+4256>>2]=mq;c[b+4264>>2]=nq;c[b+4272>>2]=oq;c[b+4280>>2]=pq;c[b+4288>>2]=qq;c[b+4296>>2]=rq;c[b+4304>>2]=sq;c[b+4312>>2]=tq;c[b+4320>>2]=uq;c[b+7040>>2]=pa;c[b+7048>>2]=oa;c[b+7056>>2]=na;c[b+7064>>2]=ma;c[b+7072>>2]=la;c[b+7080>>2]=ka;c[b+7088>>2]=ja;c[b+7096>>2]=ia;c[b+7104>>2]=ha;c[b+7112>>2]=ga;c[b+7128>>2]=fa;c[b+7136>>2]=ea;c[b+7144>>2]=da;c[b+7152>>2]=ca;c[b+7160>>2]=ba;c[b+7168>>2]=aa;c[b+7176>>2]=$;c[b+7184>>2]=_;c[b+7192>>2]=Z;c[b+7200>>2]=Y;c[b+7216>>2]=X;c[b+7224>>2]=W;c[b+7232>>2]=V;c[b+7240>>2]=U;c[b+7248>>2]=T;c[b+7256>>2]=S;c[b+7264>>2]=R;c[b+7272>>2]=Q;c[b+7280>>2]=P;c[b+7288>>2]=O;c[b+7312>>2]=N;c[b+7320>>2]=M;c[b+7328>>2]=L;c[b+7336>>2]=K;c[b+7344>>2]=J;c[b+7352>>2]=G;c[b+7360>>2]=F;c[b+7368>>2]=E;c[b+7376>>2]=D;c[b+7384>>2]=C;c[b+7400>>2]=B;c[b+7408>>2]=z;c[b+7416>>2]=y;c[b+7424>>2]=x;c[b+7432>>2]=w;c[b+7440>>2]=v;c[b+7448>>2]=u;c[b+7456>>2]=t;c[b+7464>>2]=s;c[b+7472>>2]=r;c[b+7488>>2]=q;c[b+7496>>2]=p;c[b+7504>>2]=o;c[b+7512>>2]=n;c[b+7520>>2]=m;c[b+7528>>2]=l;c[b+7536>>2]=k;c[b+7544>>2]=j;c[b+7552>>2]=h;c[b+7560>>2]=f;c[b+7576>>2]=e;c[b+7656>>2]=d;c[b+8600>>2]=0;c[b+8604>>2]=0;_Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$0(b);H=c[b+8600>>2]|0;A=c[b+8604>>2]|0;I=+g[b+8604>>2];c[b+8600>>2]=0;c[b+8604>>2]=0;if((H|0)==5){return}}function _Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0;b=c[a+48>>2]|0;d=c[a+56>>2]|0;e=c[a+72>>2]|0;f=c[a+80>>2]|0;g=c[a+88>>2]|0;j=c[a+96>>2]|0;l=c[a+104>>2]|0;m=c[a+112>>2]|0;n=c[a+120>>2]|0;o=c[a+128>>2]|0;p=c[a+136>>2]|0;q=c[a+144>>2]|0;r=c[a+152>>2]|0;s=c[a+160>>2]|0;t=c[a+168>>2]|0;u=c[a+176>>2]|0;v=c[a+184>>2]|0;w=c[a+192>>2]|0;x=c[a+200>>2]|0;y=c[a+208>>2]|0;z=c[a+216>>2]|0;A=c[a+224>>2]|0;B=c[a+232>>2]|0;C=c[a+240>>2]|0;D=c[a+248>>2]|0;E=c[a+256>>2]|0;F=c[a+264>>2]|0;G=c[a+272>>2]|0;H=c[a+280>>2]|0;I=c[a+288>>2]|0;J=c[a+296>>2]|0;K=c[a+304>>2]|0;L=c[a+312>>2]|0;M=c[a+320>>2]|0;N=c[a+328>>2]|0;O=c[a+336>>2]|0;P=c[a+344>>2]|0;Q=c[a+352>>2]|0;R=c[a+360>>2]|0;S=c[a+368>>2]|0;T=c[a+376>>2]|0;U=c[a+384>>2]|0;V=c[a+392>>2]|0;W=c[a+400>>2]|0;X=c[a+408>>2]|0;Y=c[a+416>>2]|0;Z=c[a+424>>2]|0;_=c[a+432>>2]|0;$=c[a+440>>2]|0;aa=c[a+448>>2]|0;ba=c[a+456>>2]|0;ca=c[a+464>>2]|0;da=c[a+472>>2]|0;ea=c[a+480>>2]|0;fa=c[a+488>>2]|0;ga=c[a+496>>2]|0;ha=c[a+504>>2]|0;ia=c[a+512>>2]|0;ja=c[a+520>>2]|0;ka=c[a+528>>2]|0;la=c[a+536>>2]|0;ma=c[a+544>>2]|0;na=c[a+552>>2]|0;oa=c[a+560>>2]|0;pa=c[a+568>>2]|0;qa=c[a+576>>2]|0;ra=c[a+584>>2]|0;sa=c[a+592>>2]|0;ta=c[a+600>>2]|0;ua=c[a+608>>2]|0;va=c[a+616>>2]|0;wa=c[a+624>>2]|0;xa=c[a+632>>2]|0;ya=c[a+640>>2]|0;za=c[a+648>>2]|0;Aa=c[a+656>>2]|0;Ba=c[a+664>>2]|0;Ca=c[a+672>>2]|0;Da=c[a+680>>2]|0;Ea=c[a+688>>2]|0;Fa=c[a+696>>2]|0;Ga=c[a+704>>2]|0;Ha=c[a+712>>2]|0;Ia=c[a+720>>2]|0;Ja=c[a+728>>2]|0;Ka=c[a+736>>2]|0;La=c[a+744>>2]|0;Ma=c[a+752>>2]|0;Na=c[a+760>>2]|0;Oa=c[a+768>>2]|0;Pa=c[a+776>>2]|0;Qa=c[a+784>>2]|0;Ra=c[a+792>>2]|0;Sa=c[a+800>>2]|0;Ta=c[a+808>>2]|0;Ua=c[a+816>>2]|0;Va=c[a+824>>2]|0;Wa=c[a+832>>2]|0;Xa=c[a+840>>2]|0;Ya=c[a+848>>2]|0;Za=c[a+856>>2]|0;_a=c[a+864>>2]|0;$a=c[a+872>>2]|0;ab=c[a+880>>2]|0;bb=c[a+888>>2]|0;cb=c[a+896>>2]|0;db=c[a+904>>2]|0;eb=c[a+912>>2]|0;fb=c[a+920>>2]|0;gb=c[a+928>>2]|0;hb=c[a+936>>2]|0;ib=c[a+944>>2]|0;jb=c[a+952>>2]|0;kb=c[a+960>>2]|0;lb=c[a+968>>2]|0;mb=c[a+976>>2]|0;nb=c[a+984>>2]|0;ob=c[a+992>>2]|0;pb=c[a+1e3>>2]|0;qb=c[a+1008>>2]|0;rb=c[a+1016>>2]|0;sb=c[a+1024>>2]|0;tb=c[a+1032>>2]|0;ub=c[a+1040>>2]|0;vb=c[a+1048>>2]|0;wb=c[a+1056>>2]|0;xb=c[a+1064>>2]|0;yb=c[a+1072>>2]|0;zb=c[a+1080>>2]|0;Ab=c[a+1088>>2]|0;Bb=c[a+1096>>2]|0;Cb=c[a+1104>>2]|0;Db=c[a+1112>>2]|0;Eb=c[a+1120>>2]|0;Fb=c[a+1128>>2]|0;Gb=c[a+1136>>2]|0;Hb=c[a+1144>>2]|0;Ib=c[a+1152>>2]|0;Jb=c[a+1160>>2]|0;Kb=c[a+1168>>2]|0;Lb=c[a+1176>>2]|0;Mb=c[a+1184>>2]|0;Nb=c[a+1192>>2]|0;Ob=c[a+1200>>2]|0;Pb=c[a+1208>>2]|0;Qb=c[a+1216>>2]|0;Rb=c[a+1224>>2]|0;Sb=c[a+1232>>2]|0;Tb=c[a+1240>>2]|0;Ub=c[a+1248>>2]|0;Vb=c[a+1256>>2]|0;Wb=c[a+1264>>2]|0;Xb=c[a+1272>>2]|0;Yb=c[a+1280>>2]|0;Zb=c[a+1288>>2]|0;_b=c[a+1296>>2]|0;$b=c[a+1304>>2]|0;ac=c[a+1312>>2]|0;bc=c[a+1320>>2]|0;cc=c[a+1328>>2]|0;dc=c[a+1336>>2]|0;ec=c[a+1344>>2]|0;fc=c[a+1352>>2]|0;gc=c[a+1360>>2]|0;hc=c[a+1368>>2]|0;ic=c[a+1376>>2]|0;jc=c[a+1384>>2]|0;kc=c[a+1392>>2]|0;lc=c[a+1400>>2]|0;mc=c[a+1408>>2]|0;nc=c[a+1416>>2]|0;oc=c[a+1424>>2]|0;pc=c[a+1432>>2]|0;qc=c[a+1440>>2]|0;rc=c[a+1448>>2]|0;sc=c[a+1456>>2]|0;tc=c[a+1464>>2]|0;uc=c[a+1472>>2]|0;vc=c[a+1480>>2]|0;wc=c[a+1488>>2]|0;xc=c[a+1496>>2]|0;yc=c[a+1504>>2]|0;zc=c[a+1512>>2]|0;Ac=c[a+1520>>2]|0;Bc=c[a+1528>>2]|0;Cc=c[a+1536>>2]|0;Dc=c[a+1544>>2]|0;Ec=c[a+1552>>2]|0;Fc=c[a+1560>>2]|0;Gc=c[a+1568>>2]|0;Hc=c[a+1576>>2]|0;Ic=c[a+1584>>2]|0;Jc=c[a+1592>>2]|0;Kc=c[a+1600>>2]|0;Lc=c[a+1608>>2]|0;Mc=c[a+1616>>2]|0;Nc=c[a+1624>>2]|0;Oc=c[a+1632>>2]|0;Pc=c[a+1640>>2]|0;Qc=c[a+1648>>2]|0;Rc=c[a+1656>>2]|0;Sc=c[a+1664>>2]|0;Tc=c[a+1672>>2]|0;Uc=c[a+1680>>2]|0;Vc=c[a+1688>>2]|0;Wc=c[a+1696>>2]|0;Xc=c[a+1704>>2]|0;Yc=c[a+1712>>2]|0;Zc=c[a+1720>>2]|0;_c=c[a+1728>>2]|0;$c=c[a+1736>>2]|0;ad=c[a+1744>>2]|0;bd=c[a+1752>>2]|0;cd=c[a+1760>>2]|0;dd=c[a+1768>>2]|0;ed=c[a+1776>>2]|0;fd=c[a+1784>>2]|0;gd=c[a+1792>>2]|0;hd=c[a+1800>>2]|0;id=c[a+1808>>2]|0;jd=c[a+1816>>2]|0;kd=c[a+1824>>2]|0;ld=c[a+1832>>2]|0;md=c[a+1840>>2]|0;nd=c[a+1848>>2]|0;od=c[a+1856>>2]|0;pd=c[a+1864>>2]|0;qd=c[a+1872>>2]|0;rd=c[a+1880>>2]|0;sd=c[a+1888>>2]|0;td=c[a+1896>>2]|0;ud=c[a+1904>>2]|0;vd=c[a+1912>>2]|0;wd=c[a+1920>>2]|0;xd=c[a+1928>>2]|0;yd=c[a+1936>>2]|0;zd=c[a+1944>>2]|0;Ad=c[a+1952>>2]|0;Bd=c[a+1960>>2]|0;Cd=c[a+1968>>2]|0;Dd=c[a+1976>>2]|0;Ed=c[a+1984>>2]|0;Fd=c[a+1992>>2]|0;Gd=c[a+2e3>>2]|0;Hd=c[a+2008>>2]|0;Id=c[a+2016>>2]|0;Jd=c[a+2024>>2]|0;Kd=c[a+2032>>2]|0;Ld=c[a+2040>>2]|0;Md=c[a+2048>>2]|0;Nd=c[a+2056>>2]|0;Od=c[a+2064>>2]|0;Pd=c[a+2072>>2]|0;Qd=c[a+2080>>2]|0;Rd=c[a+2088>>2]|0;Sd=c[a+2096>>2]|0;Td=c[a+2104>>2]|0;Ud=c[a+2112>>2]|0;Vd=c[a+2120>>2]|0;Wd=c[a+2128>>2]|0;Xd=c[a+2136>>2]|0;Yd=c[a+2144>>2]|0;Zd=c[a+2152>>2]|0;_d=c[a+2160>>2]|0;$d=c[a+2168>>2]|0;ae=c[a+2176>>2]|0;be=c[a+2184>>2]|0;ce=c[a+2192>>2]|0;de=c[a+2200>>2]|0;ee=c[a+2208>>2]|0;fe=c[a+2216>>2]|0;ge=c[a+2224>>2]|0;he=c[a+2232>>2]|0;ie=c[a+2240>>2]|0;je=c[a+2248>>2]|0;ke=c[a+2256>>2]|0;le=c[a+2264>>2]|0;me=c[a+2272>>2]|0;ne=c[a+2280>>2]|0;oe=c[a+2288>>2]|0;pe=c[a+2296>>2]|0;qe=c[a+2304>>2]|0;re=c[a+2312>>2]|0;se=c[a+2320>>2]|0;te=c[a+2328>>2]|0;ue=c[a+2336>>2]|0;ve=c[a+2344>>2]|0;we=c[a+2352>>2]|0;xe=c[a+2360>>2]|0;ye=c[a+2368>>2]|0;ze=c[a+2376>>2]|0;Ae=c[a+2384>>2]|0;Be=c[a+2392>>2]|0;Ce=c[a+2400>>2]|0;De=c[a+2408>>2]|0;Ee=c[a+2416>>2]|0;Fe=c[a+2424>>2]|0;Ge=c[a+2432>>2]|0;He=c[a+2440>>2]|0;Ie=c[a+2448>>2]|0;Je=c[a+2456>>2]|0;Ke=c[a+2464>>2]|0;Le=c[a+2472>>2]|0;Me=c[a+2480>>2]|0;Ne=c[a+2488>>2]|0;Oe=c[a+2496>>2]|0;Pe=c[a+2504>>2]|0;Qe=c[a+2512>>2]|0;Re=c[a+2520>>2]|0;Se=c[a+2528>>2]|0;Te=c[a+2536>>2]|0;Ue=c[a+2544>>2]|0;Ve=c[a+2552>>2]|0;We=c[a+2560>>2]|0;Xe=c[a+2568>>2]|0;Ye=c[a+2576>>2]|0;Ze=c[a+2584>>2]|0;_e=c[a+2592>>2]|0;$e=c[a+2600>>2]|0;af=c[a+2608>>2]|0;bf=c[a+2616>>2]|0;cf=c[a+2624>>2]|0;df=c[a+2632>>2]|0;ef=c[a+2640>>2]|0;ff=c[a+2648>>2]|0;gf=c[a+2656>>2]|0;hf=c[a+2664>>2]|0;jf=c[a+2672>>2]|0;kf=c[a+2680>>2]|0;lf=c[a+2688>>2]|0;mf=c[a+2696>>2]|0;nf=c[a+2704>>2]|0;of=c[a+2712>>2]|0;pf=c[a+2720>>2]|0;qf=c[a+2728>>2]|0;rf=c[a+2736>>2]|0;sf=c[a+2744>>2]|0;tf=c[a+2752>>2]|0;uf=c[a+2760>>2]|0;vf=c[a+2768>>2]|0;wf=c[a+2776>>2]|0;xf=c[a+2784>>2]|0;yf=c[a+2792>>2]|0;zf=c[a+2800>>2]|0;Af=c[a+2808>>2]|0;Bf=c[a+2816>>2]|0;Cf=c[a+2824>>2]|0;Df=c[a+2832>>2]|0;Ef=c[a+2840>>2]|0;Ff=c[a+2848>>2]|0;Gf=c[a+2856>>2]|0;Hf=c[a+2864>>2]|0;If=c[a+2872>>2]|0;Jf=c[a+2880>>2]|0;Kf=c[a+2888>>2]|0;Lf=c[a+2896>>2]|0;Mf=c[a+2904>>2]|0;Nf=c[a+2912>>2]|0;Of=c[a+2920>>2]|0;Pf=c[a+2928>>2]|0;Qf=c[a+2936>>2]|0;Rf=c[a+2944>>2]|0;Sf=c[a+2952>>2]|0;Tf=c[a+2960>>2]|0;Uf=c[a+2968>>2]|0;Vf=c[a+2976>>2]|0;Wf=c[a+2984>>2]|0;Xf=c[a+2992>>2]|0;Yf=c[a+3e3>>2]|0;Zf=c[a+3008>>2]|0;_f=c[a+3016>>2]|0;$f=c[a+3024>>2]|0;ag=c[a+3032>>2]|0;bg=c[a+3040>>2]|0;cg=c[a+3048>>2]|0;dg=c[a+3056>>2]|0;eg=c[a+3064>>2]|0;fg=c[a+3072>>2]|0;gg=c[a+3080>>2]|0;hg=c[a+3088>>2]|0;ig=c[a+3096>>2]|0;jg=c[a+3104>>2]|0;kg=c[a+3112>>2]|0;lg=c[a+3120>>2]|0;mg=c[a+3128>>2]|0;ng=c[a+3136>>2]|0;og=c[a+3144>>2]|0;pg=c[a+3152>>2]|0;qg=c[a+3160>>2]|0;rg=c[a+3168>>2]|0;sg=c[a+3176>>2]|0;tg=c[a+3184>>2]|0;ug=c[a+3192>>2]|0;vg=c[a+3200>>2]|0;wg=c[a+3208>>2]|0;xg=c[a+3216>>2]|0;yg=c[a+3224>>2]|0;zg=c[a+3232>>2]|0;Ag=c[a+3240>>2]|0;Bg=c[a+3248>>2]|0;Cg=c[a+3256>>2]|0;Dg=c[a+3264>>2]|0;Eg=c[a+3272>>2]|0;Fg=c[a+3280>>2]|0;Gg=c[a+3288>>2]|0;Hg=c[a+3296>>2]|0;Ig=c[a+3304>>2]|0;Jg=c[a+3312>>2]|0;Kg=c[a+3320>>2]|0;Lg=c[a+3328>>2]|0;Mg=c[a+3336>>2]|0;Ng=c[a+3344>>2]|0;Og=c[a+3352>>2]|0;Pg=c[a+3360>>2]|0;Qg=c[a+3368>>2]|0;Rg=c[a+3376>>2]|0;Sg=c[a+3384>>2]|0;Tg=c[a+3392>>2]|0;Ug=c[a+3400>>2]|0;Vg=c[a+3408>>2]|0;Wg=c[a+3416>>2]|0;Xg=c[a+3424>>2]|0;Yg=c[a+3432>>2]|0;Zg=c[a+3440>>2]|0;_g=c[a+3448>>2]|0;$g=c[a+3456>>2]|0;ah=c[a+3464>>2]|0;bh=c[a+3472>>2]|0;ch=c[a+3480>>2]|0;dh=c[a+3488>>2]|0;eh=c[a+3496>>2]|0;fh=c[a+3504>>2]|0;gh=c[a+3512>>2]|0;hh=c[a+3520>>2]|0;ih=c[a+3528>>2]|0;jh=c[a+3536>>2]|0;kh=c[a+3544>>2]|0;lh=c[a+3552>>2]|0;mh=c[a+3560>>2]|0;nh=c[a+3568>>2]|0;oh=c[a+3576>>2]|0;ph=c[a+3584>>2]|0;qh=c[a+3592>>2]|0;rh=c[a+3600>>2]|0;sh=c[a+3608>>2]|0;th=c[a+3616>>2]|0;uh=c[a+3624>>2]|0;vh=c[a+3632>>2]|0;wh=c[a+3640>>2]|0;xh=c[a+3648>>2]|0;yh=c[a+3656>>2]|0;zh=c[a+3664>>2]|0;Ah=c[a+3672>>2]|0;Bh=c[a+3680>>2]|0;Ch=c[a+3688>>2]|0;Dh=c[a+3696>>2]|0;Eh=c[a+3704>>2]|0;Fh=c[a+3712>>2]|0;Gh=c[a+3720>>2]|0;Hh=c[a+3728>>2]|0;Ih=c[a+3736>>2]|0;Jh=c[a+3744>>2]|0;Kh=c[a+3752>>2]|0;Lh=c[a+3760>>2]|0;Mh=c[a+3768>>2]|0;Nh=c[a+3776>>2]|0;Oh=c[a+3784>>2]|0;Ph=c[a+3792>>2]|0;Qh=c[a+3800>>2]|0;Rh=c[a+3808>>2]|0;Sh=c[a+3816>>2]|0;Th=c[a+3824>>2]|0;Uh=c[a+3832>>2]|0;Vh=c[a+3840>>2]|0;Wh=c[a+3848>>2]|0;Xh=c[a+3856>>2]|0;Yh=c[a+3864>>2]|0;Zh=c[a+3872>>2]|0;_h=c[a+3880>>2]|0;$h=c[a+3888>>2]|0;ai=c[a+3896>>2]|0;bi=c[a+3904>>2]|0;ci=c[a+3912>>2]|0;di=c[a+3920>>2]|0;ei=c[a+3928>>2]|0;fi=c[a+3936>>2]|0;gi=c[a+3944>>2]|0;hi=c[a+3952>>2]|0;ii=c[a+3960>>2]|0;ji=c[a+3968>>2]|0;ki=c[a+3976>>2]|0;li=c[a+3984>>2]|0;mi=c[a+3992>>2]|0;ni=c[a+4e3>>2]|0;oi=c[a+4008>>2]|0;pi=c[a+4016>>2]|0;qi=c[a+4024>>2]|0;ri=c[a+4032>>2]|0;si=c[a+4040>>2]|0;ti=c[a+4048>>2]|0;ui=c[a+4056>>2]|0;vi=c[a+4064>>2]|0;wi=c[a+4072>>2]|0;xi=c[a+4080>>2]|0;yi=c[a+4088>>2]|0;zi=c[a+4096>>2]|0;Ai=c[a+4104>>2]|0;Bi=c[a+4112>>2]|0;Ci=c[a+4120>>2]|0;Di=c[a+4128>>2]|0;Ei=c[a+4136>>2]|0;Fi=c[a+4144>>2]|0;Gi=c[a+4152>>2]|0;Hi=c[a+4160>>2]|0;Ii=c[a+4168>>2]|0;Ji=c[a+4176>>2]|0;Ki=c[a+4184>>2]|0;Li=c[a+4192>>2]|0;Mi=c[a+4200>>2]|0;Ni=c[a+4208>>2]|0;Oi=c[a+4216>>2]|0;Pi=c[a+4224>>2]|0;Qi=c[a+4232>>2]|0;Ri=c[a+4240>>2]|0;Si=c[a+4248>>2]|0;Ti=c[a+4256>>2]|0;Ui=c[a+4264>>2]|0;Vi=c[a+4272>>2]|0;Xi=c[a+4280>>2]|0;Yi=c[a+4288>>2]|0;Zi=c[a+4296>>2]|0;_i=c[a+4304>>2]|0;$i=c[a+4312>>2]|0;aj=c[a+4320>>2]|0;bj=c[a+7040>>2]|0;cj=c[a+7048>>2]|0;dj=c[a+7056>>2]|0;ej=c[a+7064>>2]|0;fj=c[a+7072>>2]|0;gj=c[a+7080>>2]|0;hj=c[a+7088>>2]|0;ij=c[a+7096>>2]|0;jj=c[a+7104>>2]|0;kj=c[a+7112>>2]|0;lj=c[a+7128>>2]|0;mj=c[a+7136>>2]|0;nj=c[a+7144>>2]|0;oj=c[a+7152>>2]|0;pj=c[a+7160>>2]|0;qj=c[a+7168>>2]|0;rj=c[a+7176>>2]|0;sj=c[a+7184>>2]|0;tj=c[a+7192>>2]|0;uj=c[a+7200>>2]|0;vj=c[a+7216>>2]|0;wj=c[a+7224>>2]|0;xj=c[a+7232>>2]|0;yj=c[a+7240>>2]|0;zj=c[a+7248>>2]|0;Aj=c[a+7256>>2]|0;Bj=c[a+7264>>2]|0;Cj=c[a+7272>>2]|0;Dj=c[a+7280>>2]|0;Ej=c[a+7288>>2]|0;Fj=c[a+7312>>2]|0;Gj=c[a+7320>>2]|0;Hj=c[a+7328>>2]|0;Ij=c[a+7336>>2]|0;Jj=c[a+7344>>2]|0;Kj=c[a+7352>>2]|0;Lj=c[a+7360>>2]|0;Mj=c[a+7368>>2]|0;Nj=c[a+7376>>2]|0;Oj=c[a+7384>>2]|0;Pj=c[a+7400>>2]|0;Qj=c[a+7408>>2]|0;Rj=c[a+7416>>2]|0;Sj=c[a+7424>>2]|0;Tj=c[a+7432>>2]|0;Uj=c[a+7440>>2]|0;Vj=c[a+7448>>2]|0;Wj=c[a+7456>>2]|0;Xj=c[a+7464>>2]|0;Yj=c[a+7472>>2]|0;Zj=c[a+7488>>2]|0;_j=c[a+7496>>2]|0;$j=c[a+7504>>2]|0;ak=c[a+7512>>2]|0;bk=c[a+7520>>2]|0;ck=c[a+7528>>2]|0;dk=c[a+7536>>2]|0;ek=c[a+7544>>2]|0;fk=c[a+7552>>2]|0;gk=c[a+7560>>2]|0;hk=c[a+7576>>2]|0;ik=c[a+7656>>2]|0;a:do{h[k>>3]=220193.0e-9;c[(bj+16|0)>>2]=c[k>>2];c[(bj+16|0)+4>>2]=c[k+4>>2];sI(Vh,4,.0442,bj);h[k>>3]=1.19766;c[cj>>2]=c[k>>2];c[cj+4>>2]=c[k+4>>2];h[k>>3]=-88.852;c[(cj+8|0)>>2]=c[k>>2];c[(cj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220192.0e-9;c[(cj+16|0)>>2]=c[k>>2];c[(cj+16|0)+4>>2]=c[k+4>>2];sI(Wh,4,.0443,cj);h[k>>3]=1.19773;c[dj>>2]=c[k>>2];c[dj+4>>2]=c[k+4>>2];h[k>>3]=-88.855;c[(dj+8|0)>>2]=c[k>>2];c[(dj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220192.0e-9;c[(dj+16|0)>>2]=c[k>>2];c[(dj+16|0)+4>>2]=c[k+4>>2];sI(Xh,4,.0444,dj);h[k>>3]=1.1978;c[ej>>2]=c[k>>2];c[ej+4>>2]=c[k+4>>2];h[k>>3]=-88.8578;c[(ej+8|0)>>2]=c[k>>2];c[(ej+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220191.0e-9;c[(ej+16|0)>>2]=c[k>>2];c[(ej+16|0)+4>>2]=c[k+4>>2];sI(Yh,4,.0445,ej);h[k>>3]=1.19786;c[fj>>2]=c[k>>2];c[fj+4>>2]=c[k+4>>2];h[k>>3]=-88.8606;c[(fj+8|0)>>2]=c[k>>2];c[(fj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220191.0e-9;c[(fj+16|0)>>2]=c[k>>2];c[(fj+16|0)+4>>2]=c[k+4>>2];sI(Zh,4,.0446,fj);h[k>>3]=1.19793;c[gj>>2]=c[k>>2];c[gj+4>>2]=c[k+4>>2];h[k>>3]=-88.8633;c[(gj+8|0)>>2]=c[k>>2];c[(gj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220191.0e-9;c[(gj+16|0)>>2]=c[k>>2];c[(gj+16|0)+4>>2]=c[k+4>>2];sI(_h,4,.0447,gj);h[k>>3]=1.19799;c[hj>>2]=c[k>>2];c[hj+4>>2]=c[k+4>>2];h[k>>3]=-88.8659;c[(hj+8|0)>>2]=c[k>>2];c[(hj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22019.0e-8;c[(hj+16|0)>>2]=c[k>>2];c[(hj+16|0)+4>>2]=c[k+4>>2];sI($h,4,.0448,hj);h[k>>3]=1.19805;c[ij>>2]=c[k>>2];c[ij+4>>2]=c[k+4>>2];h[k>>3]=-88.8685;c[(ij+8|0)>>2]=c[k>>2];c[(ij+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22019.0e-8;c[(ij+16|0)>>2]=c[k>>2];c[(ij+16|0)+4>>2]=c[k+4>>2];sI(ai,4,.0449,ij);h[k>>3]=1.19811;c[jj>>2]=c[k>>2];c[jj+4>>2]=c[k+4>>2];h[k>>3]=-88.871;c[(jj+8|0)>>2]=c[k>>2];c[(jj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220189.0e-9;c[(jj+16|0)>>2]=c[k>>2];c[(jj+16|0)+4>>2]=c[k+4>>2];sI(bi,4,.045,jj);h[k>>3]=1.19816;c[kj>>2]=c[k>>2];c[kj+4>>2]=c[k+4>>2];h[k>>3]=-88.8734;c[(kj+8|0)>>2]=c[k>>2];c[(kj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220189.0e-9;c[(kj+16|0)>>2]=c[k>>2];c[(kj+16|0)+4>>2]=c[k+4>>2];sI(ci,4,.0451,kj);h[k>>3]=1.19822;c[lj>>2]=c[k>>2];c[lj+4>>2]=c[k+4>>2];h[k>>3]=-88.8757;c[(lj+8|0)>>2]=c[k>>2];c[(lj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220188.0e-9;c[(lj+16|0)>>2]=c[k>>2];c[(lj+16|0)+4>>2]=c[k+4>>2];sI(di,4,.0452,lj);h[k>>3]=1.19827;c[mj>>2]=c[k>>2];c[mj+4>>2]=c[k+4>>2];h[k>>3]=-88.8779;c[(mj+8|0)>>2]=c[k>>2];c[(mj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220188.0e-9;c[(mj+16|0)>>2]=c[k>>2];c[(mj+16|0)+4>>2]=c[k+4>>2];sI(ei,4,.0453,mj);h[k>>3]=1.19832;c[nj>>2]=c[k>>2];c[nj+4>>2]=c[k+4>>2];h[k>>3]=-88.8801;c[(nj+8|0)>>2]=c[k>>2];c[(nj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220188.0e-9;c[(nj+16|0)>>2]=c[k>>2];c[(nj+16|0)+4>>2]=c[k+4>>2];sI(fi,4,.0454,nj);h[k>>3]=1.19837;c[oj>>2]=c[k>>2];c[oj+4>>2]=c[k+4>>2];h[k>>3]=-88.8822;c[(oj+8|0)>>2]=c[k>>2];c[(oj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220187.0e-9;c[(oj+16|0)>>2]=c[k>>2];c[(oj+16|0)+4>>2]=c[k+4>>2];sI(gi,4,.0455,oj);h[k>>3]=1.19842;c[pj>>2]=c[k>>2];c[pj+4>>2]=c[k+4>>2];h[k>>3]=-88.8843;c[(pj+8|0)>>2]=c[k>>2];c[(pj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220187.0e-9;c[(pj+16|0)>>2]=c[k>>2];c[(pj+16|0)+4>>2]=c[k+4>>2];sI(hi,4,.0456,pj);h[k>>3]=1.19847;c[qj>>2]=c[k>>2];c[qj+4>>2]=c[k+4>>2];h[k>>3]=-88.8863;c[(qj+8|0)>>2]=c[k>>2];c[(qj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220187.0e-9;c[(qj+16|0)>>2]=c[k>>2];c[(qj+16|0)+4>>2]=c[k+4>>2];sI(ii,4,.0457,qj);h[k>>3]=1.19851;c[rj>>2]=c[k>>2];c[rj+4>>2]=c[k+4>>2];h[k>>3]=-88.8882;c[(rj+8|0)>>2]=c[k>>2];c[(rj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220186.0e-9;c[(rj+16|0)>>2]=c[k>>2];c[(rj+16|0)+4>>2]=c[k+4>>2];sI(ji,4,.0458,rj);h[k>>3]=1.19856;c[sj>>2]=c[k>>2];c[sj+4>>2]=c[k+4>>2];h[k>>3]=-88.8901;c[(sj+8|0)>>2]=c[k>>2];c[(sj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220186.0e-9;c[(sj+16|0)>>2]=c[k>>2];c[(sj+16|0)+4>>2]=c[k+4>>2];sI(ki,4,.0459,sj);h[k>>3]=1.1986;c[tj>>2]=c[k>>2];c[tj+4>>2]=c[k+4>>2];h[k>>3]=-88.8919;c[(tj+8|0)>>2]=c[k>>2];c[(tj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220186.0e-9;c[(tj+16|0)>>2]=c[k>>2];c[(tj+16|0)+4>>2]=c[k+4>>2];sI(li,4,.046,tj);h[k>>3]=1.19864;c[uj>>2]=c[k>>2];c[uj+4>>2]=c[k+4>>2];h[k>>3]=-88.8937;c[(uj+8|0)>>2]=c[k>>2];c[(uj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220185.0e-9;c[(uj+16|0)>>2]=c[k>>2];c[(uj+16|0)+4>>2]=c[k+4>>2];sI(mi,4,.0461,uj);h[k>>3]=1.19868;c[vj>>2]=c[k>>2];c[vj+4>>2]=c[k+4>>2];h[k>>3]=-88.8954;c[(vj+8|0)>>2]=c[k>>2];c[(vj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220185.0e-9;c[(vj+16|0)>>2]=c[k>>2];c[(vj+16|0)+4>>2]=c[k+4>>2];sI(ni,4,.0462,vj);h[k>>3]=1.19872;c[wj>>2]=c[k>>2];c[wj+4>>2]=c[k+4>>2];h[k>>3]=-88.897;c[(wj+8|0)>>2]=c[k>>2];c[(wj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220185.0e-9;c[(wj+16|0)>>2]=c[k>>2];c[(wj+16|0)+4>>2]=c[k+4>>2];sI(oi,4,.0463,wj);h[k>>3]=1.19876;c[xj>>2]=c[k>>2];c[xj+4>>2]=c[k+4>>2];h[k>>3]=-88.8987;c[(xj+8|0)>>2]=c[k>>2];c[(xj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220184.0e-9;c[(xj+16|0)>>2]=c[k>>2];c[(xj+16|0)+4>>2]=c[k+4>>2];sI(pi,4,.0464,xj);h[k>>3]=1.1988;c[yj>>2]=c[k>>2];c[yj+4>>2]=c[k+4>>2];h[k>>3]=-88.9002;c[(yj+8|0)>>2]=c[k>>2];c[(yj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220184.0e-9;c[(yj+16|0)>>2]=c[k>>2];c[(yj+16|0)+4>>2]=c[k+4>>2];sI(qi,4,.0465,yj);h[k>>3]=1.19883;c[zj>>2]=c[k>>2];c[zj+4>>2]=c[k+4>>2];h[k>>3]=-88.9017;c[(zj+8|0)>>2]=c[k>>2];c[(zj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220184.0e-9;c[(zj+16|0)>>2]=c[k>>2];c[(zj+16|0)+4>>2]=c[k+4>>2];sI(ri,4,.0466,zj);h[k>>3]=1.19887;c[Aj>>2]=c[k>>2];c[Aj+4>>2]=c[k+4>>2];h[k>>3]=-88.9032;c[(Aj+8|0)>>2]=c[k>>2];c[(Aj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220184.0e-9;c[(Aj+16|0)>>2]=c[k>>2];c[(Aj+16|0)+4>>2]=c[k+4>>2];sI(si,4,.0467,Aj);h[k>>3]=1.1989;c[Bj>>2]=c[k>>2];c[Bj+4>>2]=c[k+4>>2];h[k>>3]=-88.9046;c[(Bj+8|0)>>2]=c[k>>2];c[(Bj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220183.0e-9;c[(Bj+16|0)>>2]=c[k>>2];c[(Bj+16|0)+4>>2]=c[k+4>>2];sI(ti,4,.0468,Bj);h[k>>3]=1.19893;c[Cj>>2]=c[k>>2];c[Cj+4>>2]=c[k+4>>2];h[k>>3]=-88.906;c[(Cj+8|0)>>2]=c[k>>2];c[(Cj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220183.0e-9;c[(Cj+16|0)>>2]=c[k>>2];c[(Cj+16|0)+4>>2]=c[k+4>>2];sI(ui,4,.0469,Cj);h[k>>3]=1.19897;c[Dj>>2]=c[k>>2];c[Dj+4>>2]=c[k+4>>2];h[k>>3]=-88.9074;c[(Dj+8|0)>>2]=c[k>>2];c[(Dj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220183.0e-9;c[(Dj+16|0)>>2]=c[k>>2];c[(Dj+16|0)+4>>2]=c[k+4>>2];sI(vi,4,.047,Dj);h[k>>3]=1.199;c[Ej>>2]=c[k>>2];c[Ej+4>>2]=c[k+4>>2];h[k>>3]=-88.9087;c[(Ej+8|0)>>2]=c[k>>2];c[(Ej+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220183.0e-9;c[(Ej+16|0)>>2]=c[k>>2];c[(Ej+16|0)+4>>2]=c[k+4>>2];sI(wi,4,.0471,Ej);h[k>>3]=1.19903;c[Fj>>2]=c[k>>2];c[Fj+4>>2]=c[k+4>>2];h[k>>3]=-88.91;c[(Fj+8|0)>>2]=c[k>>2];c[(Fj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220182.0e-9;c[(Fj+16|0)>>2]=c[k>>2];c[(Fj+16|0)+4>>2]=c[k+4>>2];sI(xi,4,.0472,Fj);h[k>>3]=1.19906;c[Gj>>2]=c[k>>2];c[Gj+4>>2]=c[k+4>>2];h[k>>3]=-88.9112;c[(Gj+8|0)>>2]=c[k>>2];c[(Gj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220182.0e-9;c[(Gj+16|0)>>2]=c[k>>2];c[(Gj+16|0)+4>>2]=c[k+4>>2];sI(yi,4,.0473,Gj);h[k>>3]=1.19908;c[Hj>>2]=c[k>>2];c[Hj+4>>2]=c[k+4>>2];h[k>>3]=-88.9124;c[(Hj+8|0)>>2]=c[k>>2];c[(Hj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220182.0e-9;c[(Hj+16|0)>>2]=c[k>>2];c[(Hj+16|0)+4>>2]=c[k+4>>2];sI(zi,4,.0474,Hj);h[k>>3]=1.19911;c[Ij>>2]=c[k>>2];c[Ij+4>>2]=c[k+4>>2];h[k>>3]=-88.9135;c[(Ij+8|0)>>2]=c[k>>2];c[(Ij+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220182.0e-9;c[(Ij+16|0)>>2]=c[k>>2];c[(Ij+16|0)+4>>2]=c[k+4>>2];sI(Ai,4,.0475,Ij);h[k>>3]=1.19914;c[Jj>>2]=c[k>>2];c[Jj+4>>2]=c[k+4>>2];h[k>>3]=-88.9146;c[(Jj+8|0)>>2]=c[k>>2];c[(Jj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220182.0e-9;c[(Jj+16|0)>>2]=c[k>>2];c[(Jj+16|0)+4>>2]=c[k+4>>2];sI(Bi,4,.0476,Jj);h[k>>3]=1.19916;c[Kj>>2]=c[k>>2];c[Kj+4>>2]=c[k+4>>2];h[k>>3]=-88.9157;c[(Kj+8|0)>>2]=c[k>>2];c[(Kj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Kj+16|0)>>2]=c[k>>2];c[(Kj+16|0)+4>>2]=c[k+4>>2];sI(Ci,4,.0477,Kj);h[k>>3]=1.19919;c[Lj>>2]=c[k>>2];c[Lj+4>>2]=c[k+4>>2];h[k>>3]=-88.9168;c[(Lj+8|0)>>2]=c[k>>2];c[(Lj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Lj+16|0)>>2]=c[k>>2];c[(Lj+16|0)+4>>2]=c[k+4>>2];sI(Di,4,.0478,Lj);h[k>>3]=1.19921;c[Mj>>2]=c[k>>2];c[Mj+4>>2]=c[k+4>>2];h[k>>3]=-88.9178;c[(Mj+8|0)>>2]=c[k>>2];c[(Mj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Mj+16|0)>>2]=c[k>>2];c[(Mj+16|0)+4>>2]=c[k+4>>2];sI(Ei,4,.0479,Mj);h[k>>3]=1.19924;c[Nj>>2]=c[k>>2];c[Nj+4>>2]=c[k+4>>2];h[k>>3]=-88.9188;c[(Nj+8|0)>>2]=c[k>>2];c[(Nj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Nj+16|0)>>2]=c[k>>2];c[(Nj+16|0)+4>>2]=c[k+4>>2];sI(Fi,4,.048,Nj);h[k>>3]=1.19926;c[Oj>>2]=c[k>>2];c[Oj+4>>2]=c[k+4>>2];h[k>>3]=-88.9198;c[(Oj+8|0)>>2]=c[k>>2];c[(Oj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Oj+16|0)>>2]=c[k>>2];c[(Oj+16|0)+4>>2]=c[k+4>>2];sI(Gi,4,.0481,Oj);h[k>>3]=1.19928;c[Pj>>2]=c[k>>2];c[Pj+4>>2]=c[k+4>>2];h[k>>3]=-88.9207;c[(Pj+8|0)>>2]=c[k>>2];c[(Pj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220181.0e-9;c[(Pj+16|0)>>2]=c[k>>2];c[(Pj+16|0)+4>>2]=c[k+4>>2];sI(Hi,4,.0482,Pj);h[k>>3]=1.1993;c[Qj>>2]=c[k>>2];c[Qj+4>>2]=c[k+4>>2];h[k>>3]=-88.9216;c[(Qj+8|0)>>2]=c[k>>2];c[(Qj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Qj+16|0)>>2]=c[k>>2];c[(Qj+16|0)+4>>2]=c[k+4>>2];sI(Ii,4,.0483,Qj);h[k>>3]=1.19932;c[Rj>>2]=c[k>>2];c[Rj+4>>2]=c[k+4>>2];h[k>>3]=-88.9225;c[(Rj+8|0)>>2]=c[k>>2];c[(Rj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Rj+16|0)>>2]=c[k>>2];c[(Rj+16|0)+4>>2]=c[k+4>>2];sI(Ji,4,.0484,Rj);h[k>>3]=1.19934;c[Sj>>2]=c[k>>2];c[Sj+4>>2]=c[k+4>>2];h[k>>3]=-88.9233;c[(Sj+8|0)>>2]=c[k>>2];c[(Sj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Sj+16|0)>>2]=c[k>>2];c[(Sj+16|0)+4>>2]=c[k+4>>2];sI(Ki,4,.0485,Sj);h[k>>3]=1.19936;c[Tj>>2]=c[k>>2];c[Tj+4>>2]=c[k+4>>2];h[k>>3]=-88.9242;c[(Tj+8|0)>>2]=c[k>>2];c[(Tj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Tj+16|0)>>2]=c[k>>2];c[(Tj+16|0)+4>>2]=c[k+4>>2];sI(Li,4,.0486,Tj);h[k>>3]=1.19938;c[Uj>>2]=c[k>>2];c[Uj+4>>2]=c[k+4>>2];h[k>>3]=-88.925;c[(Uj+8|0)>>2]=c[k>>2];c[(Uj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Uj+16|0)>>2]=c[k>>2];c[(Uj+16|0)+4>>2]=c[k+4>>2];sI(Mi,4,.0487,Uj);h[k>>3]=1.1994;c[Vj>>2]=c[k>>2];c[Vj+4>>2]=c[k+4>>2];h[k>>3]=-88.9258;c[(Vj+8|0)>>2]=c[k>>2];c[(Vj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Vj+16|0)>>2]=c[k>>2];c[(Vj+16|0)+4>>2]=c[k+4>>2];sI(Ni,4,.0488,Vj);h[k>>3]=1.19942;c[Wj>>2]=c[k>>2];c[Wj+4>>2]=c[k+4>>2];h[k>>3]=-88.9265;c[(Wj+8|0)>>2]=c[k>>2];c[(Wj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22018.0e-8;c[(Wj+16|0)>>2]=c[k>>2];c[(Wj+16|0)+4>>2]=c[k+4>>2];sI(Oi,4,.0489,Wj);h[k>>3]=1.19944;c[Xj>>2]=c[k>>2];c[Xj+4>>2]=c[k+4>>2];h[k>>3]=-88.9273;c[(Xj+8|0)>>2]=c[k>>2];c[(Xj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(Xj+16|0)>>2]=c[k>>2];c[(Xj+16|0)+4>>2]=c[k+4>>2];sI(Pi,4,.049,Xj);h[k>>3]=1.19945;c[Yj>>2]=c[k>>2];c[Yj+4>>2]=c[k+4>>2];h[k>>3]=-88.928;c[(Yj+8|0)>>2]=c[k>>2];c[(Yj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(Yj+16|0)>>2]=c[k>>2];c[(Yj+16|0)+4>>2]=c[k+4>>2];sI(Qi,4,.0491,Yj);h[k>>3]=1.19947;c[Zj>>2]=c[k>>2];c[Zj+4>>2]=c[k+4>>2];h[k>>3]=-88.9287;c[(Zj+8|0)>>2]=c[k>>2];c[(Zj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(Zj+16|0)>>2]=c[k>>2];c[(Zj+16|0)+4>>2]=c[k+4>>2];sI(Ri,4,.0492,Zj);h[k>>3]=1.19948;c[_j>>2]=c[k>>2];c[_j+4>>2]=c[k+4>>2];h[k>>3]=-88.9293;c[(_j+8|0)>>2]=c[k>>2];c[(_j+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(_j+16|0)>>2]=c[k>>2];c[(_j+16|0)+4>>2]=c[k+4>>2];sI(Si,4,.0493,_j);h[k>>3]=1.1995;c[$j>>2]=c[k>>2];c[$j+4>>2]=c[k+4>>2];h[k>>3]=-88.93;c[($j+8|0)>>2]=c[k>>2];c[($j+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[($j+16|0)>>2]=c[k>>2];c[($j+16|0)+4>>2]=c[k+4>>2];sI(Ti,4,.0494,$j);h[k>>3]=1.19951;c[ak>>2]=c[k>>2];c[ak+4>>2]=c[k+4>>2];h[k>>3]=-88.9306;c[(ak+8|0)>>2]=c[k>>2];c[(ak+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(ak+16|0)>>2]=c[k>>2];c[(ak+16|0)+4>>2]=c[k+4>>2];sI(Ui,4,.0495,ak);h[k>>3]=1.19953;c[bk>>2]=c[k>>2];c[bk+4>>2]=c[k+4>>2];h[k>>3]=-88.9312;c[(bk+8|0)>>2]=c[k>>2];c[(bk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(bk+16|0)>>2]=c[k>>2];c[(bk+16|0)+4>>2]=c[k+4>>2];sI(Vi,4,.0496,bk);h[k>>3]=1.19954;c[ck>>2]=c[k>>2];c[ck+4>>2]=c[k+4>>2];h[k>>3]=-88.9318;c[(ck+8|0)>>2]=c[k>>2];c[(ck+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(ck+16|0)>>2]=c[k>>2];c[(ck+16|0)+4>>2]=c[k+4>>2];sI(Xi,4,.0497,ck);h[k>>3]=1.19956;c[dk>>2]=c[k>>2];c[dk+4>>2]=c[k+4>>2];h[k>>3]=-88.9324;c[(dk+8|0)>>2]=c[k>>2];c[(dk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220179.0e-9;c[(dk+16|0)>>2]=c[k>>2];c[(dk+16|0)+4>>2]=c[k+4>>2];sI(Yi,4,.0498,dk);h[k>>3]=1.19957;c[ek>>2]=c[k>>2];c[ek+4>>2]=c[k+4>>2];h[k>>3]=-88.933;c[(ek+8|0)>>2]=c[k>>2];c[(ek+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220178.0e-9;c[(ek+16|0)>>2]=c[k>>2];c[(ek+16|0)+4>>2]=c[k+4>>2];sI(Zi,4,.0499,ek);h[k>>3]=1.19958;c[fk>>2]=c[k>>2];c[fk+4>>2]=c[k+4>>2];h[k>>3]=-88.9335;c[(fk+8|0)>>2]=c[k>>2];c[(fk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220178.0e-9;c[(fk+16|0)>>2]=c[k>>2];c[(fk+16|0)+4>>2]=c[k+4>>2];sI(_i,4,.05,fk);h[k>>3]=1.19958;c[gk>>2]=c[k>>2];c[gk+4>>2]=c[k+4>>2];h[k>>3]=-88.9335;c[(gk+8|0)>>2]=c[k>>2];c[(gk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220178.0e-9;c[(gk+16|0)>>2]=c[k>>2];c[(gk+16|0)+4>>2]=c[k+4>>2];sI($i,4,.05,gk);c[hk>>2]=g;c[hk+4>>2]=j;c[hk+8>>2]=l;c[hk+12>>2]=m;c[hk+16>>2]=n;c[hk+20>>2]=o;c[hk+24>>2]=p;c[hk+28>>2]=q;c[hk+32>>2]=r;c[hk+36>>2]=s;c[hk+40>>2]=t;c[hk+44>>2]=u;c[hk+48>>2]=v;c[hk+52>>2]=w;c[hk+56>>2]=x;c[hk+60>>2]=y;c[hk+64>>2]=z;c[hk+68>>2]=A;c[hk+72>>2]=B;c[hk+76>>2]=C;c[hk+80>>2]=D;c[hk+84>>2]=E;c[hk+88>>2]=F;c[hk+92>>2]=G;c[hk+96>>2]=H;c[hk+100>>2]=I;c[hk+104>>2]=J;c[hk+108>>2]=K;c[hk+112>>2]=L;c[hk+116>>2]=M;c[hk+120>>2]=N;c[hk+124>>2]=O;c[hk+128>>2]=P;c[hk+132>>2]=Q;c[hk+136>>2]=R;c[hk+140>>2]=S;c[hk+144>>2]=T;c[hk+148>>2]=U;c[hk+152>>2]=V;c[hk+156>>2]=W;c[hk+160>>2]=X;c[hk+164>>2]=Y;c[hk+168>>2]=Z;c[hk+172>>2]=_;c[hk+176>>2]=$;c[hk+180>>2]=aa;c[hk+184>>2]=ba;c[hk+188>>2]=ca;c[hk+192>>2]=da;c[hk+196>>2]=ea;c[hk+200>>2]=fa;c[hk+204>>2]=ga;c[hk+208>>2]=ha;c[hk+212>>2]=ia;c[hk+216>>2]=ja;c[hk+220>>2]=ka;c[hk+224>>2]=la;c[hk+228>>2]=ma;c[hk+232>>2]=na;c[hk+236>>2]=oa;c[hk+240>>2]=pa;c[hk+244>>2]=qa;c[hk+248>>2]=ra;c[hk+252>>2]=sa;c[hk+256>>2]=ta;c[hk+260>>2]=ua;c[hk+264>>2]=va;c[hk+268>>2]=wa;c[hk+272>>2]=xa;c[hk+276>>2]=ya;c[hk+280>>2]=za;c[hk+284>>2]=Aa;c[hk+288>>2]=Ba;c[hk+292>>2]=Ca;c[hk+296>>2]=Da;c[hk+300>>2]=Ea;c[hk+304>>2]=Fa;c[hk+308>>2]=Ga;c[hk+312>>2]=Ha;c[hk+316>>2]=Ia;c[hk+320>>2]=Ja;c[hk+324>>2]=Ka;c[hk+328>>2]=La;c[hk+332>>2]=Ma;c[hk+336>>2]=Na;c[hk+340>>2]=Oa;c[hk+344>>2]=Pa;c[hk+348>>2]=Qa;c[hk+352>>2]=Ra;c[hk+356>>2]=Sa;c[hk+360>>2]=Ta;c[hk+364>>2]=Ua;c[hk+368>>2]=Va;c[hk+372>>2]=Wa;c[hk+376>>2]=Xa;c[hk+380>>2]=Ya;c[hk+384>>2]=Za;c[hk+388>>2]=_a;c[hk+392>>2]=$a;c[hk+396>>2]=ab;c[hk+400>>2]=bb;c[hk+404>>2]=cb;c[hk+408>>2]=db;c[hk+412>>2]=eb;c[hk+416>>2]=fb;c[hk+420>>2]=gb;c[hk+424>>2]=hb;c[hk+428>>2]=ib;c[hk+432>>2]=jb;c[hk+436>>2]=kb;c[hk+440>>2]=lb;c[hk+444>>2]=mb;c[hk+448>>2]=nb;c[hk+452>>2]=ob;c[hk+456>>2]=pb;c[hk+460>>2]=qb;c[hk+464>>2]=rb;c[hk+468>>2]=sb;c[hk+472>>2]=tb;c[hk+476>>2]=ub;c[hk+480>>2]=vb;c[hk+484>>2]=wb;c[hk+488>>2]=xb;c[hk+492>>2]=yb;c[hk+496>>2]=zb;c[hk+500>>2]=Ab;c[hk+504>>2]=Bb;c[hk+508>>2]=Cb;c[hk+512>>2]=Db;c[hk+516>>2]=Eb;c[hk+520>>2]=Fb;c[hk+524>>2]=Gb;c[hk+528>>2]=Hb;c[hk+532>>2]=Ib;c[hk+536>>2]=Jb;c[hk+540>>2]=Kb;c[hk+544>>2]=Lb;c[hk+548>>2]=Mb;c[hk+552>>2]=Nb;c[hk+556>>2]=Ob;c[hk+560>>2]=Pb;c[hk+564>>2]=Qb;c[hk+568>>2]=Rb;c[hk+572>>2]=Sb;c[hk+576>>2]=Tb;c[hk+580>>2]=Ub;c[hk+584>>2]=Vb;c[hk+588>>2]=Wb;c[hk+592>>2]=Xb;c[hk+596>>2]=Yb;c[hk+600>>2]=Zb;c[hk+604>>2]=_b;c[hk+608>>2]=$b;c[hk+612>>2]=ac;c[hk+616>>2]=bc;c[hk+620>>2]=cc;c[hk+624>>2]=dc;c[hk+628>>2]=ec;c[hk+632>>2]=fc;c[hk+636>>2]=gc;c[hk+640>>2]=hc;c[hk+644>>2]=ic;c[hk+648>>2]=jc;c[hk+652>>2]=kc;c[hk+656>>2]=lc;c[hk+660>>2]=mc;c[hk+664>>2]=nc;c[hk+668>>2]=oc;c[hk+672>>2]=pc;c[hk+676>>2]=qc;c[hk+680>>2]=rc;c[hk+684>>2]=sc;c[hk+688>>2]=tc;c[hk+692>>2]=uc;c[hk+696>>2]=vc;c[hk+700>>2]=wc;c[hk+704>>2]=xc;c[hk+708>>2]=yc;c[hk+712>>2]=zc;c[hk+716>>2]=Ac;c[hk+720>>2]=Bc;c[hk+724>>2]=Cc;c[hk+728>>2]=Dc;c[hk+732>>2]=Ec;c[hk+736>>2]=Fc;c[hk+740>>2]=Gc;c[hk+744>>2]=Hc;c[hk+748>>2]=Ic;c[hk+752>>2]=Jc;c[hk+756>>2]=Kc;c[hk+760>>2]=Lc;c[hk+764>>2]=Mc;c[hk+768>>2]=Nc;c[hk+772>>2]=Oc;c[hk+776>>2]=Pc;c[hk+780>>2]=Qc;c[hk+784>>2]=Rc;c[hk+788>>2]=Sc;c[hk+792>>2]=Tc;c[hk+796>>2]=Uc;c[hk+800>>2]=Vc;c[hk+804>>2]=Wc;c[hk+808>>2]=Xc;c[hk+812>>2]=Yc;c[hk+816>>2]=Zc;c[hk+820>>2]=_c;c[hk+824>>2]=$c;c[hk+828>>2]=ad;c[hk+832>>2]=bd;c[hk+836>>2]=cd;c[hk+840>>2]=dd;c[hk+844>>2]=ed;c[hk+848>>2]=fd;c[hk+852>>2]=gd;c[hk+856>>2]=hd;c[hk+860>>2]=id;c[hk+864>>2]=jd;c[hk+868>>2]=kd;c[hk+872>>2]=ld;c[hk+876>>2]=md;c[hk+880>>2]=nd;c[hk+884>>2]=od;c[hk+888>>2]=pd;c[hk+892>>2]=qd;c[hk+896>>2]=rd;c[hk+900>>2]=sd;c[hk+904>>2]=td;c[hk+908>>2]=ud;c[hk+912>>2]=vd;c[hk+916>>2]=wd;c[hk+920>>2]=xd;c[hk+924>>2]=yd;c[hk+928>>2]=zd;c[hk+932>>2]=Ad;c[hk+936>>2]=Bd;c[hk+940>>2]=Cd;c[hk+944>>2]=Dd;c[hk+948>>2]=Ed;c[hk+952>>2]=Fd;c[hk+956>>2]=Gd;c[hk+960>>2]=Hd;c[hk+964>>2]=Id;c[hk+968>>2]=Jd;c[hk+972>>2]=Kd;c[hk+976>>2]=Ld;c[hk+980>>2]=Md;c[hk+984>>2]=Nd;c[hk+988>>2]=Od;c[hk+992>>2]=Pd;c[hk+996>>2]=Qd;c[hk+1e3>>2]=Rd;c[hk+1004>>2]=Sd;c[hk+1008>>2]=Td;c[hk+1012>>2]=Ud;c[hk+1016>>2]=Vd;c[hk+1020>>2]=Wd;c[hk+1024>>2]=Xd;c[hk+1028>>2]=Yd;c[hk+1032>>2]=Zd;c[hk+1036>>2]=_d;c[hk+1040>>2]=$d;c[hk+1044>>2]=ae;c[hk+1048>>2]=be;c[hk+1052>>2]=ce;c[hk+1056>>2]=de;c[hk+1060>>2]=ee;c[hk+1064>>2]=fe;c[hk+1068>>2]=ge;c[hk+1072>>2]=he;c[hk+1076>>2]=ie;c[hk+1080>>2]=je;c[hk+1084>>2]=ke;c[hk+1088>>2]=le;c[hk+1092>>2]=me;c[hk+1096>>2]=ne;c[hk+1100>>2]=oe;c[hk+1104>>2]=pe;c[hk+1108>>2]=qe;c[hk+1112>>2]=re;c[hk+1116>>2]=se;c[hk+1120>>2]=te;c[hk+1124>>2]=ue;c[hk+1128>>2]=ve;c[hk+1132>>2]=we;c[hk+1136>>2]=xe;c[hk+1140>>2]=ye;c[hk+1144>>2]=ze;c[hk+1148>>2]=Ae;c[hk+1152>>2]=Be;c[hk+1156>>2]=Ce;c[hk+1160>>2]=De;c[hk+1164>>2]=Ee;c[hk+1168>>2]=Fe;c[hk+1172>>2]=Ge;c[hk+1176>>2]=He;c[hk+1180>>2]=Ie;c[hk+1184>>2]=Je;c[hk+1188>>2]=Ke;c[hk+1192>>2]=Le;c[hk+1196>>2]=Me;c[hk+1200>>2]=Ne;c[hk+1204>>2]=Oe;c[hk+1208>>2]=Pe;c[hk+1212>>2]=Qe;c[hk+1216>>2]=Re;c[hk+1220>>2]=Se;c[hk+1224>>2]=Te;c[hk+1228>>2]=Ue;c[hk+1232>>2]=Ve;c[hk+1236>>2]=We;c[hk+1240>>2]=Xe;c[hk+1244>>2]=Ye;c[hk+1248>>2]=Ze;c[hk+1252>>2]=_e;c[hk+1256>>2]=$e;c[hk+1260>>2]=af;c[hk+1264>>2]=bf;c[hk+1268>>2]=cf;c[hk+1272>>2]=df;c[hk+1276>>2]=ef;c[hk+1280>>2]=ff;c[hk+1284>>2]=gf;c[hk+1288>>2]=hf;c[hk+1292>>2]=jf;c[hk+1296>>2]=kf;c[hk+1300>>2]=lf;c[hk+1304>>2]=mf;c[hk+1308>>2]=nf;c[hk+1312>>2]=of;c[hk+1316>>2]=pf;c[hk+1320>>2]=qf;c[hk+1324>>2]=rf;c[hk+1328>>2]=sf;c[hk+1332>>2]=tf;c[hk+1336>>2]=uf;c[hk+1340>>2]=vf;c[hk+1344>>2]=wf;c[hk+1348>>2]=xf;c[hk+1352>>2]=yf;c[hk+1356>>2]=zf;c[hk+1360>>2]=Af;c[hk+1364>>2]=Bf;c[hk+1368>>2]=Cf;c[hk+1372>>2]=Df;c[hk+1376>>2]=Ef;c[hk+1380>>2]=Ff;c[hk+1384>>2]=Gf;c[hk+1388>>2]=Hf;c[hk+1392>>2]=If;c[hk+1396>>2]=Jf;c[hk+1400>>2]=Kf;c[hk+1404>>2]=Lf;c[hk+1408>>2]=Mf;c[hk+1412>>2]=Nf;c[hk+1416>>2]=Of;c[hk+1420>>2]=Pf;c[hk+1424>>2]=Qf;c[hk+1428>>2]=Rf;c[hk+1432>>2]=Sf;c[hk+1436>>2]=Tf;c[hk+1440>>2]=Uf;c[hk+1444>>2]=Vf;c[hk+1448>>2]=Wf;c[hk+1452>>2]=Xf;c[hk+1456>>2]=Yf;c[hk+1460>>2]=Zf;c[hk+1464>>2]=_f;c[hk+1468>>2]=$f;c[hk+1472>>2]=ag;c[hk+1476>>2]=bg;c[hk+1480>>2]=cg;c[hk+1484>>2]=dg;c[hk+1488>>2]=eg;c[hk+1492>>2]=fg;c[hk+1496>>2]=gg;c[hk+1500>>2]=hg;c[hk+1504>>2]=ig;c[hk+1508>>2]=jg;c[hk+1512>>2]=kg;c[hk+1516>>2]=lg;c[hk+1520>>2]=mg;c[hk+1524>>2]=ng;c[hk+1528>>2]=og;c[hk+1532>>2]=pg;c[hk+1536>>2]=qg;c[hk+1540>>2]=rg;c[hk+1544>>2]=sg;c[hk+1548>>2]=tg;c[hk+1552>>2]=ug;c[hk+1556>>2]=vg;c[hk+1560>>2]=wg;c[hk+1564>>2]=xg;c[hk+1568>>2]=yg;c[hk+1572>>2]=zg;c[hk+1576>>2]=Ag;c[hk+1580>>2]=Bg;c[hk+1584>>2]=Cg;c[hk+1588>>2]=Dg;c[hk+1592>>2]=Eg;c[hk+1596>>2]=Fg;c[hk+1600>>2]=Gg;c[hk+1604>>2]=Hg;c[hk+1608>>2]=Ig;c[hk+1612>>2]=Jg;c[hk+1616>>2]=Kg;c[hk+1620>>2]=Lg;c[hk+1624>>2]=Mg;c[hk+1628>>2]=Ng;c[hk+1632>>2]=Og;c[hk+1636>>2]=Pg;c[hk+1640>>2]=Qg;c[hk+1644>>2]=Rg;c[hk+1648>>2]=Sg;c[hk+1652>>2]=Tg;c[hk+1656>>2]=Ug;c[hk+1660>>2]=Vg;c[hk+1664>>2]=Wg;c[hk+1668>>2]=Xg;c[hk+1672>>2]=Yg;c[hk+1676>>2]=Zg;c[hk+1680>>2]=_g;c[hk+1684>>2]=$g;c[hk+1688>>2]=ah;c[hk+1692>>2]=bh;c[hk+1696>>2]=ch;c[hk+1700>>2]=dh;c[hk+1704>>2]=eh;c[hk+1708>>2]=fh;c[hk+1712>>2]=gh;c[hk+1716>>2]=hh;c[hk+1720>>2]=ih;c[hk+1724>>2]=jh;c[hk+1728>>2]=kh;c[hk+1732>>2]=lh;c[hk+1736>>2]=mh;c[hk+1740>>2]=nh;c[hk+1744>>2]=oh;c[hk+1748>>2]=ph;c[hk+1752>>2]=qh;c[hk+1756>>2]=rh;c[hk+1760>>2]=sh;c[hk+1764>>2]=th;c[hk+1768>>2]=uh;c[hk+1772>>2]=vh;c[hk+1776>>2]=wh;c[hk+1780>>2]=xh;c[hk+1784>>2]=yh;c[hk+1788>>2]=zh;c[hk+1792>>2]=Ah;c[hk+1796>>2]=Bh;c[hk+1800>>2]=Ch;c[hk+1804>>2]=Dh;c[hk+1808>>2]=Eh;c[hk+1812>>2]=Fh;c[hk+1816>>2]=Gh;c[hk+1820>>2]=Hh;c[hk+1824>>2]=Ih;c[hk+1828>>2]=Jh;c[hk+1832>>2]=Kh;c[hk+1836>>2]=Lh;c[hk+1840>>2]=Mh;c[hk+1844>>2]=Nh;c[hk+1848>>2]=Oh;c[hk+1852>>2]=Ph;c[hk+1856>>2]=Qh;c[hk+1860>>2]=Rh;c[hk+1864>>2]=Sh;c[hk+1868>>2]=Th;c[hk+1872>>2]=Uh;c[hk+1876>>2]=Vh;c[hk+1880>>2]=Wh;c[hk+1884>>2]=Xh;c[hk+1888>>2]=Yh;c[hk+1892>>2]=Zh;c[hk+1896>>2]=_h;c[hk+1900>>2]=$h;c[hk+1904>>2]=ai;c[hk+1908>>2]=bi;c[hk+1912>>2]=ci;c[hk+1916>>2]=di;c[hk+1920>>2]=ei;c[hk+1924>>2]=fi;c[hk+1928>>2]=gi;c[hk+1932>>2]=hi;c[hk+1936>>2]=ii;c[hk+1940>>2]=ji;c[hk+1944>>2]=ki;c[hk+1948>>2]=li;c[hk+1952>>2]=mi;c[hk+1956>>2]=ni;c[hk+1960>>2]=oi;c[hk+1964>>2]=pi;c[hk+1968>>2]=qi;c[hk+1972>>2]=ri;c[hk+1976>>2]=si;c[hk+1980>>2]=ti;c[hk+1984>>2]=ui;c[hk+1988>>2]=vi;c[hk+1992>>2]=wi;c[hk+1996>>2]=xi;c[hk+2e3>>2]=yi;c[hk+2004>>2]=zi;c[hk+2008>>2]=Ai;c[hk+2012>>2]=Bi;c[hk+2016>>2]=Ci;c[hk+2020>>2]=Di;c[hk+2024>>2]=Ei;c[hk+2028>>2]=Fi;c[hk+2032>>2]=Gi;c[hk+2036>>2]=Hi;c[hk+2040>>2]=Ii;c[hk+2044>>2]=Ji;c[hk+2048>>2]=Ki;c[hk+2052>>2]=Li;c[hk+2056>>2]=Mi;c[hk+2060>>2]=Ni;c[hk+2064>>2]=Oi;c[hk+2068>>2]=Pi;c[hk+2072>>2]=Qi;c[hk+2076>>2]=Ri;c[hk+2080>>2]=Si;c[hk+2084>>2]=Ti;c[hk+2088>>2]=Ui;c[hk+2092>>2]=Vi;c[hk+2096>>2]=Xi;c[hk+2100>>2]=Yi;c[hk+2104>>2]=Zi;c[hk+2108>>2]=_i;c[hk+2112>>2]=$i;rI(e,530,f,hk);c[ik>>2]=3;c[ik+4>>2]=4;BH(aj,3,2,ik);jk=c[b+536>>2]|0;c[(a+16|0)+0>>2]=c[e+0>>2];c[(a+16|0)+4>>2]=c[e+4>>2];c[(a+16|0)+8>>2]=c[e+8>>2];c[a+0>>2]=c[aj+0>>2];c[a+4>>2]=c[aj+4>>2];c[a+8>>2]=c[aj+8>>2];Wi(d,jk,7072,7072,a+16|0,0.0,a,1,1);c[c[b+320>>2]>>2]=c[d>>2];rH(4,0,7080,a+32|0);i=a;c[a+8600>>2]=5;break a}while(0)}function _Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0;b=c[a+2856>>2]|0;d=c[a+2864>>2]|0;e=c[a+2872>>2]|0;f=c[a+2880>>2]|0;g=c[a+2888>>2]|0;i=c[a+2896>>2]|0;j=c[a+2904>>2]|0;l=c[a+2912>>2]|0;m=c[a+2920>>2]|0;n=c[a+2928>>2]|0;o=c[a+2936>>2]|0;p=c[a+2944>>2]|0;q=c[a+2952>>2]|0;r=c[a+2960>>2]|0;s=c[a+2968>>2]|0;t=c[a+2976>>2]|0;u=c[a+2984>>2]|0;v=c[a+2992>>2]|0;w=c[a+3e3>>2]|0;x=c[a+3008>>2]|0;y=c[a+3016>>2]|0;z=c[a+3024>>2]|0;A=c[a+3032>>2]|0;B=c[a+3040>>2]|0;C=c[a+3048>>2]|0;D=c[a+3056>>2]|0;E=c[a+3064>>2]|0;F=c[a+3072>>2]|0;G=c[a+3080>>2]|0;H=c[a+3088>>2]|0;I=c[a+3096>>2]|0;J=c[a+3104>>2]|0;K=c[a+3112>>2]|0;L=c[a+3120>>2]|0;M=c[a+3128>>2]|0;N=c[a+3136>>2]|0;O=c[a+3144>>2]|0;P=c[a+3152>>2]|0;Q=c[a+3160>>2]|0;R=c[a+3168>>2]|0;S=c[a+3176>>2]|0;T=c[a+3184>>2]|0;U=c[a+3192>>2]|0;V=c[a+3200>>2]|0;W=c[a+3208>>2]|0;X=c[a+3216>>2]|0;Y=c[a+3224>>2]|0;Z=c[a+3232>>2]|0;_=c[a+3240>>2]|0;$=c[a+3248>>2]|0;aa=c[a+3256>>2]|0;ba=c[a+3264>>2]|0;ca=c[a+3272>>2]|0;da=c[a+3280>>2]|0;ea=c[a+3288>>2]|0;fa=c[a+3296>>2]|0;ga=c[a+3304>>2]|0;ha=c[a+3312>>2]|0;ia=c[a+3320>>2]|0;ja=c[a+3328>>2]|0;ka=c[a+3336>>2]|0;la=c[a+3344>>2]|0;ma=c[a+3352>>2]|0;na=c[a+3360>>2]|0;oa=c[a+3368>>2]|0;pa=c[a+3376>>2]|0;qa=c[a+3384>>2]|0;ra=c[a+3392>>2]|0;sa=c[a+3400>>2]|0;ta=c[a+3408>>2]|0;ua=c[a+3416>>2]|0;va=c[a+3424>>2]|0;wa=c[a+3432>>2]|0;xa=c[a+3440>>2]|0;ya=c[a+3448>>2]|0;za=c[a+3456>>2]|0;Aa=c[a+3464>>2]|0;Ba=c[a+3472>>2]|0;Ca=c[a+3480>>2]|0;Da=c[a+3488>>2]|0;Ea=c[a+3496>>2]|0;Fa=c[a+3504>>2]|0;Ga=c[a+3512>>2]|0;Ha=c[a+3520>>2]|0;Ia=c[a+3528>>2]|0;Ja=c[a+3536>>2]|0;Ka=c[a+3544>>2]|0;La=c[a+3552>>2]|0;Ma=c[a+3560>>2]|0;Na=c[a+3568>>2]|0;Oa=c[a+3576>>2]|0;Pa=c[a+3584>>2]|0;Qa=c[a+3592>>2]|0;Ra=c[a+3600>>2]|0;Sa=c[a+3608>>2]|0;Ta=c[a+3616>>2]|0;Ua=c[a+3624>>2]|0;Va=c[a+3632>>2]|0;Wa=c[a+3640>>2]|0;Xa=c[a+3648>>2]|0;Ya=c[a+3656>>2]|0;Za=c[a+3664>>2]|0;_a=c[a+3672>>2]|0;$a=c[a+3680>>2]|0;ab=c[a+3688>>2]|0;bb=c[a+3696>>2]|0;cb=c[a+3704>>2]|0;db=c[a+3712>>2]|0;eb=c[a+3720>>2]|0;fb=c[a+3728>>2]|0;gb=c[a+3736>>2]|0;hb=c[a+3744>>2]|0;ib=c[a+3752>>2]|0;jb=c[a+3760>>2]|0;kb=c[a+3768>>2]|0;lb=c[a+3776>>2]|0;mb=c[a+3784>>2]|0;nb=c[a+3792>>2]|0;ob=c[a+3800>>2]|0;pb=c[a+3808>>2]|0;qb=c[a+3816>>2]|0;rb=c[a+3824>>2]|0;sb=c[a+3832>>2]|0;tb=c[a+5944>>2]|0;ub=c[a+5952>>2]|0;vb=c[a+5960>>2]|0;wb=c[a+5976>>2]|0;xb=c[a+5984>>2]|0;yb=c[a+5992>>2]|0;zb=c[a+6e3>>2]|0;Ab=c[a+6008>>2]|0;Bb=c[a+6016>>2]|0;Cb=c[a+6024>>2]|0;Db=c[a+6032>>2]|0;Eb=c[a+6040>>2]|0;Fb=c[a+6048>>2]|0;Gb=c[a+6064>>2]|0;Hb=c[a+6072>>2]|0;Ib=c[a+6080>>2]|0;Jb=c[a+6088>>2]|0;Kb=c[a+6096>>2]|0;Lb=c[a+6104>>2]|0;Mb=c[a+6112>>2]|0;Nb=c[a+6120>>2]|0;Ob=c[a+6128>>2]|0;Pb=c[a+6136>>2]|0;Qb=c[a+6152>>2]|0;Rb=c[a+6160>>2]|0;Sb=c[a+6168>>2]|0;Tb=c[a+6176>>2]|0;Ub=c[a+6184>>2]|0;Vb=c[a+6192>>2]|0;Wb=c[a+6200>>2]|0;Xb=c[a+6208>>2]|0;Yb=c[a+6216>>2]|0;Zb=c[a+6224>>2]|0;_b=c[a+6240>>2]|0;$b=c[a+6248>>2]|0;ac=c[a+6256>>2]|0;bc=c[a+6264>>2]|0;cc=c[a+6272>>2]|0;dc=c[a+6280>>2]|0;ec=c[a+6288>>2]|0;fc=c[a+6296>>2]|0;gc=c[a+6304>>2]|0;hc=c[a+6312>>2]|0;ic=c[a+6328>>2]|0;jc=c[a+6336>>2]|0;kc=c[a+6344>>2]|0;lc=c[a+6352>>2]|0;mc=c[a+6360>>2]|0;nc=c[a+6368>>2]|0;oc=c[a+6376>>2]|0;pc=c[a+6384>>2]|0;qc=c[a+6392>>2]|0;rc=c[a+6400>>2]|0;sc=c[a+6424>>2]|0;tc=c[a+6432>>2]|0;uc=c[a+6440>>2]|0;vc=c[a+6448>>2]|0;wc=c[a+6456>>2]|0;xc=c[a+6464>>2]|0;yc=c[a+6472>>2]|0;zc=c[a+6480>>2]|0;Ac=c[a+6488>>2]|0;Bc=c[a+6496>>2]|0;Cc=c[a+6512>>2]|0;Dc=c[a+6520>>2]|0;Ec=c[a+6528>>2]|0;Fc=c[a+6536>>2]|0;Gc=c[a+6544>>2]|0;Hc=c[a+6552>>2]|0;Ic=c[a+6560>>2]|0;Jc=c[a+6568>>2]|0;Kc=c[a+6576>>2]|0;Lc=c[a+6584>>2]|0;Mc=c[a+6600>>2]|0;Nc=c[a+6608>>2]|0;Oc=c[a+6616>>2]|0;Pc=c[a+6624>>2]|0;Qc=c[a+6632>>2]|0;Rc=c[a+6640>>2]|0;Sc=c[a+6648>>2]|0;Tc=c[a+6656>>2]|0;Uc=c[a+6664>>2]|0;Vc=c[a+6672>>2]|0;Wc=c[a+6688>>2]|0;Xc=c[a+6696>>2]|0;Yc=c[a+6704>>2]|0;Zc=c[a+6712>>2]|0;_c=c[a+6720>>2]|0;$c=c[a+6728>>2]|0;ad=c[a+6736>>2]|0;bd=c[a+6744>>2]|0;cd=c[a+6752>>2]|0;dd=c[a+6760>>2]|0;ed=c[a+6776>>2]|0;fd=c[a+6784>>2]|0;gd=c[a+6792>>2]|0;hd=c[a+6800>>2]|0;id=c[a+6808>>2]|0;jd=c[a+6816>>2]|0;kd=c[a+6824>>2]|0;ld=c[a+6832>>2]|0;md=c[a+6840>>2]|0;nd=c[a+6848>>2]|0;od=c[a+6864>>2]|0;pd=c[a+6872>>2]|0;qd=c[a+6880>>2]|0;rd=c[a+6888>>2]|0;sd=c[a+6896>>2]|0;td=c[a+6904>>2]|0;ud=c[a+6912>>2]|0;vd=c[a+6920>>2]|0;wd=c[a+6928>>2]|0;xd=c[a+6936>>2]|0;yd=c[a+6952>>2]|0;zd=c[a+6960>>2]|0;Ad=c[a+6968>>2]|0;Bd=c[a+6976>>2]|0;Cd=c[a+6984>>2]|0;Dd=c[a+6992>>2]|0;Ed=c[a+7e3>>2]|0;Fd=c[a+7008>>2]|0;Gd=c[a+7016>>2]|0;Hd=c[a+7024>>2]|0;Id=c[a+7040>>2]|0;c[(tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220725.0e-9;c[(tb+16|0)>>2]=c[k>>2];c[(tb+16|0)+4>>2]=c[k+4>>2];sI(b,4,.0319,tb);h[k>>3]=1.12699;c[ub>>2]=c[k>>2];c[ub+4>>2]=c[k+4>>2];h[k>>3]=-85.857;c[(ub+8|0)>>2]=c[k>>2];c[(ub+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220712.0e-9;c[(ub+16|0)>>2]=c[k>>2];c[(ub+16|0)+4>>2]=c[k+4>>2];sI(d,4,.032,ub);h[k>>3]=1.12875;c[vb>>2]=c[k>>2];c[vb+4>>2]=c[k+4>>2];h[k>>3]=-85.9319;c[(vb+8|0)>>2]=c[k>>2];c[(vb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220699.0e-9;c[(vb+16|0)>>2]=c[k>>2];c[(vb+16|0)+4>>2]=c[k+4>>2];sI(e,4,.0321,vb);h[k>>3]=1.13048;c[wb>>2]=c[k>>2];c[wb+4>>2]=c[k+4>>2];h[k>>3]=-86.005;c[(wb+8|0)>>2]=c[k>>2];c[(wb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220686.0e-9;c[(wb+16|0)>>2]=c[k>>2];c[(wb+16|0)+4>>2]=c[k+4>>2];sI(f,4,.0322,wb);h[k>>3]=1.13216;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];h[k>>3]=-86.0763;c[(xb+8|0)>>2]=c[k>>2];c[(xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220673.0e-9;c[(xb+16|0)>>2]=c[k>>2];c[(xb+16|0)+4>>2]=c[k+4>>2];sI(g,4,.0323,xb);h[k>>3]=1.1338;c[yb>>2]=c[k>>2];c[yb+4>>2]=c[k+4>>2];h[k>>3]=-86.1459;c[(yb+8|0)>>2]=c[k>>2];c[(yb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220661.0e-9;c[(yb+16|0)>>2]=c[k>>2];c[(yb+16|0)+4>>2]=c[k+4>>2];sI(i,4,.0324,yb);h[k>>3]=1.1354;c[zb>>2]=c[k>>2];c[zb+4>>2]=c[k+4>>2];h[k>>3]=-86.2138;c[(zb+8|0)>>2]=c[k>>2];c[(zb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220649.0e-9;c[(zb+16|0)>>2]=c[k>>2];c[(zb+16|0)+4>>2]=c[k+4>>2];sI(j,4,.0325,zb);h[k>>3]=1.13696;c[Ab>>2]=c[k>>2];c[Ab+4>>2]=c[k+4>>2];h[k>>3]=-86.28;c[(Ab+8|0)>>2]=c[k>>2];c[(Ab+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220638.0e-9;c[(Ab+16|0)>>2]=c[k>>2];c[(Ab+16|0)+4>>2]=c[k+4>>2];sI(l,4,.0326,Ab);h[k>>3]=1.13849;c[Bb>>2]=c[k>>2];c[Bb+4>>2]=c[k+4>>2];h[k>>3]=-86.3447;c[(Bb+8|0)>>2]=c[k>>2];c[(Bb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220627.0e-9;c[(Bb+16|0)>>2]=c[k>>2];c[(Bb+16|0)+4>>2]=c[k+4>>2];sI(m,4,.0327,Bb);h[k>>3]=1.13997;c[Cb>>2]=c[k>>2];c[Cb+4>>2]=c[k+4>>2];h[k>>3]=-86.4078;c[(Cb+8|0)>>2]=c[k>>2];c[(Cb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220616.0e-9;c[(Cb+16|0)>>2]=c[k>>2];c[(Cb+16|0)+4>>2]=c[k+4>>2];sI(n,4,.0328,Cb);h[k>>3]=1.14143;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];h[k>>3]=-86.4693;c[(Db+8|0)>>2]=c[k>>2];c[(Db+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220605.0e-9;c[(Db+16|0)>>2]=c[k>>2];c[(Db+16|0)+4>>2]=c[k+4>>2];sI(o,4,.0329,Db);h[k>>3]=1.14284;c[Eb>>2]=c[k>>2];c[Eb+4>>2]=c[k+4>>2];h[k>>3]=-86.5294;c[(Eb+8|0)>>2]=c[k>>2];c[(Eb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220594.0e-9;c[(Eb+16|0)>>2]=c[k>>2];c[(Eb+16|0)+4>>2]=c[k+4>>2];sI(p,4,.033,Eb);h[k>>3]=1.14423;c[Fb>>2]=c[k>>2];c[Fb+4>>2]=c[k+4>>2];h[k>>3]=-86.588;c[(Fb+8|0)>>2]=c[k>>2];c[(Fb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220584.0e-9;c[(Fb+16|0)>>2]=c[k>>2];c[(Fb+16|0)+4>>2]=c[k+4>>2];sI(q,4,.0331,Fb);h[k>>3]=1.14558;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];h[k>>3]=-86.6452;c[(Gb+8|0)>>2]=c[k>>2];c[(Gb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220574.0e-9;c[(Gb+16|0)>>2]=c[k>>2];c[(Gb+16|0)+4>>2]=c[k+4>>2];sI(r,4,.0332,Gb);h[k>>3]=1.14689;c[Hb>>2]=c[k>>2];c[Hb+4>>2]=c[k+4>>2];h[k>>3]=-86.701;c[(Hb+8|0)>>2]=c[k>>2];c[(Hb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220564.0e-9;c[(Hb+16|0)>>2]=c[k>>2];c[(Hb+16|0)+4>>2]=c[k+4>>2];sI(s,4,.0333,Hb);h[k>>3]=1.14818;c[Ib>>2]=c[k>>2];c[Ib+4>>2]=c[k+4>>2];h[k>>3]=-86.7555;c[(Ib+8|0)>>2]=c[k>>2];c[(Ib+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220555.0e-9;c[(Ib+16|0)>>2]=c[k>>2];c[(Ib+16|0)+4>>2]=c[k+4>>2];sI(t,4,.0334,Ib);h[k>>3]=1.14943;c[Jb>>2]=c[k>>2];c[Jb+4>>2]=c[k+4>>2];h[k>>3]=-86.8086;c[(Jb+8|0)>>2]=c[k>>2];c[(Jb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220546.0e-9;c[(Jb+16|0)>>2]=c[k>>2];c[(Jb+16|0)+4>>2]=c[k+4>>2];sI(u,4,.0335,Jb);h[k>>3]=1.15065;c[Kb>>2]=c[k>>2];c[Kb+4>>2]=c[k+4>>2];h[k>>3]=-86.8605;c[(Kb+8|0)>>2]=c[k>>2];c[(Kb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220537.0e-9;c[(Kb+16|0)>>2]=c[k>>2];c[(Kb+16|0)+4>>2]=c[k+4>>2];sI(v,4,.0336,Kb);h[k>>3]=1.15185;c[Lb>>2]=c[k>>2];c[Lb+4>>2]=c[k+4>>2];h[k>>3]=-86.9111;c[(Lb+8|0)>>2]=c[k>>2];c[(Lb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220528.0e-9;c[(Lb+16|0)>>2]=c[k>>2];c[(Lb+16|0)+4>>2]=c[k+4>>2];sI(w,4,.0337,Lb);h[k>>3]=1.15301;c[Mb>>2]=c[k>>2];c[Mb+4>>2]=c[k+4>>2];h[k>>3]=-86.9605;c[(Mb+8|0)>>2]=c[k>>2];c[(Mb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220519.0e-9;c[(Mb+16|0)>>2]=c[k>>2];c[(Mb+16|0)+4>>2]=c[k+4>>2];sI(x,4,.0338,Mb);h[k>>3]=1.15415;c[Nb>>2]=c[k>>2];c[Nb+4>>2]=c[k+4>>2];h[k>>3]=-87.0086;c[(Nb+8|0)>>2]=c[k>>2];c[(Nb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220511.0e-9;c[(Nb+16|0)>>2]=c[k>>2];c[(Nb+16|0)+4>>2]=c[k+4>>2];sI(y,4,.0339,Nb);h[k>>3]=1.15526;c[Ob>>2]=c[k>>2];c[Ob+4>>2]=c[k+4>>2];h[k>>3]=-87.0556;c[(Ob+8|0)>>2]=c[k>>2];c[(Ob+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220503.0e-9;c[(Ob+16|0)>>2]=c[k>>2];c[(Ob+16|0)+4>>2]=c[k+4>>2];sI(z,4,.034,Ob);h[k>>3]=1.15634;c[Pb>>2]=c[k>>2];c[Pb+4>>2]=c[k+4>>2];h[k>>3]=-87.1015;c[(Pb+8|0)>>2]=c[k>>2];c[(Pb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220495.0e-9;c[(Pb+16|0)>>2]=c[k>>2];c[(Pb+16|0)+4>>2]=c[k+4>>2];sI(A,4,.0341,Pb);h[k>>3]=1.1574;c[Qb>>2]=c[k>>2];c[Qb+4>>2]=c[k+4>>2];h[k>>3]=-87.1463;c[(Qb+8|0)>>2]=c[k>>2];c[(Qb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220487.0e-9;c[(Qb+16|0)>>2]=c[k>>2];c[(Qb+16|0)+4>>2]=c[k+4>>2];sI(B,4,.0342,Qb);h[k>>3]=1.15843;c[Rb>>2]=c[k>>2];c[Rb+4>>2]=c[k+4>>2];h[k>>3]=-87.19;c[(Rb+8|0)>>2]=c[k>>2];c[(Rb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220479.0e-9;c[(Rb+16|0)>>2]=c[k>>2];c[(Rb+16|0)+4>>2]=c[k+4>>2];sI(C,4,.0343,Rb);h[k>>3]=1.15943;c[Sb>>2]=c[k>>2];c[Sb+4>>2]=c[k+4>>2];h[k>>3]=-87.2326;c[(Sb+8|0)>>2]=c[k>>2];c[(Sb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220472.0e-9;c[(Sb+16|0)>>2]=c[k>>2];c[(Sb+16|0)+4>>2]=c[k+4>>2];sI(D,4,.0344,Sb);h[k>>3]=1.16041;c[Tb>>2]=c[k>>2];c[Tb+4>>2]=c[k+4>>2];h[k>>3]=-87.2742;c[(Tb+8|0)>>2]=c[k>>2];c[(Tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220465.0e-9;c[(Tb+16|0)>>2]=c[k>>2];c[(Tb+16|0)+4>>2]=c[k+4>>2];sI(E,4,.0345,Tb);h[k>>3]=1.16137;c[Ub>>2]=c[k>>2];c[Ub+4>>2]=c[k+4>>2];h[k>>3]=-87.3148;c[(Ub+8|0)>>2]=c[k>>2];c[(Ub+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220458.0e-9;c[(Ub+16|0)>>2]=c[k>>2];c[(Ub+16|0)+4>>2]=c[k+4>>2];sI(F,4,.0346,Ub);h[k>>3]=1.16231;c[Vb>>2]=c[k>>2];c[Vb+4>>2]=c[k+4>>2];h[k>>3]=-87.3544;c[(Vb+8|0)>>2]=c[k>>2];c[(Vb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220451.0e-9;c[(Vb+16|0)>>2]=c[k>>2];c[(Vb+16|0)+4>>2]=c[k+4>>2];sI(G,4,.0347,Vb);h[k>>3]=1.16322;c[Wb>>2]=c[k>>2];c[Wb+4>>2]=c[k+4>>2];h[k>>3]=-87.3931;c[(Wb+8|0)>>2]=c[k>>2];c[(Wb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220444.0e-9;c[(Wb+16|0)>>2]=c[k>>2];c[(Wb+16|0)+4>>2]=c[k+4>>2];sI(H,4,.0348,Wb);h[k>>3]=1.16411;c[Xb>>2]=c[k>>2];c[Xb+4>>2]=c[k+4>>2];h[k>>3]=-87.4308;c[(Xb+8|0)>>2]=c[k>>2];c[(Xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220438.0e-9;c[(Xb+16|0)>>2]=c[k>>2];c[(Xb+16|0)+4>>2]=c[k+4>>2];sI(I,4,.0349,Xb);h[k>>3]=1.16498;c[Yb>>2]=c[k>>2];c[Yb+4>>2]=c[k+4>>2];h[k>>3]=-87.4676;c[(Yb+8|0)>>2]=c[k>>2];c[(Yb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220431.0e-9;c[(Yb+16|0)>>2]=c[k>>2];c[(Yb+16|0)+4>>2]=c[k+4>>2];sI(J,4,.035,Yb);h[k>>3]=1.16582;c[Zb>>2]=c[k>>2];c[Zb+4>>2]=c[k+4>>2];h[k>>3]=-87.5035;c[(Zb+8|0)>>2]=c[k>>2];c[(Zb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220425.0e-9;c[(Zb+16|0)>>2]=c[k>>2];c[(Zb+16|0)+4>>2]=c[k+4>>2];sI(K,4,.0351,Zb);h[k>>3]=1.16665;c[_b>>2]=c[k>>2];c[_b+4>>2]=c[k+4>>2];h[k>>3]=-87.5385;c[(_b+8|0)>>2]=c[k>>2];c[(_b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220419.0e-9;c[(_b+16|0)>>2]=c[k>>2];c[(_b+16|0)+4>>2]=c[k+4>>2];sI(L,4,.0352,_b);h[k>>3]=1.16746;c[$b>>2]=c[k>>2];c[$b+4>>2]=c[k+4>>2];h[k>>3]=-87.5727;c[($b+8|0)>>2]=c[k>>2];c[($b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220413.0e-9;c[($b+16|0)>>2]=c[k>>2];c[($b+16|0)+4>>2]=c[k+4>>2];sI(M,4,.0353,$b);h[k>>3]=1.16824;c[ac>>2]=c[k>>2];c[ac+4>>2]=c[k+4>>2];h[k>>3]=-87.6061;c[(ac+8|0)>>2]=c[k>>2];c[(ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220407.0e-9;c[(ac+16|0)>>2]=c[k>>2];c[(ac+16|0)+4>>2]=c[k+4>>2];sI(N,4,.0354,ac);h[k>>3]=1.16901;c[bc>>2]=c[k>>2];c[bc+4>>2]=c[k+4>>2];h[k>>3]=-87.6386;c[(bc+8|0)>>2]=c[k>>2];c[(bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220402.0e-9;c[(bc+16|0)>>2]=c[k>>2];c[(bc+16|0)+4>>2]=c[k+4>>2];sI(O,4,.0355,bc);h[k>>3]=1.16976;c[cc>>2]=c[k>>2];c[cc+4>>2]=c[k+4>>2];h[k>>3]=-87.6704;c[(cc+8|0)>>2]=c[k>>2];c[(cc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220396.0e-9;c[(cc+16|0)>>2]=c[k>>2];c[(cc+16|0)+4>>2]=c[k+4>>2];sI(P,4,.0356,cc);h[k>>3]=1.17049;c[dc>>2]=c[k>>2];c[dc+4>>2]=c[k+4>>2];h[k>>3]=-87.7014;c[(dc+8|0)>>2]=c[k>>2];c[(dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220391.0e-9;c[(dc+16|0)>>2]=c[k>>2];c[(dc+16|0)+4>>2]=c[k+4>>2];sI(Q,4,.0357,dc);h[k>>3]=1.17121;c[ec>>2]=c[k>>2];c[ec+4>>2]=c[k+4>>2];h[k>>3]=-87.7316;c[(ec+8|0)>>2]=c[k>>2];c[(ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220386.0e-9;c[(ec+16|0)>>2]=c[k>>2];c[(ec+16|0)+4>>2]=c[k+4>>2];sI(R,4,.0358,ec);h[k>>3]=1.1719;c[fc>>2]=c[k>>2];c[fc+4>>2]=c[k+4>>2];h[k>>3]=-87.7612;c[(fc+8|0)>>2]=c[k>>2];c[(fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22038.0e-8;c[(fc+16|0)>>2]=c[k>>2];c[(fc+16|0)+4>>2]=c[k+4>>2];sI(S,4,.0359,fc);h[k>>3]=1.17258;c[gc>>2]=c[k>>2];c[gc+4>>2]=c[k+4>>2];h[k>>3]=-87.79;c[(gc+8|0)>>2]=c[k>>2];c[(gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220375.0e-9;c[(gc+16|0)>>2]=c[k>>2];c[(gc+16|0)+4>>2]=c[k+4>>2];sI(T,4,.036,gc);h[k>>3]=1.17325;c[hc>>2]=c[k>>2];c[hc+4>>2]=c[k+4>>2];h[k>>3]=-87.8181;c[(hc+8|0)>>2]=c[k>>2];c[(hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220371.0e-9;c[(hc+16|0)>>2]=c[k>>2];c[(hc+16|0)+4>>2]=c[k+4>>2];sI(U,4,.0361,hc);h[k>>3]=1.1739;c[ic>>2]=c[k>>2];c[ic+4>>2]=c[k+4>>2];h[k>>3]=-87.8455;c[(ic+8|0)>>2]=c[k>>2];c[(ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220366.0e-9;c[(ic+16|0)>>2]=c[k>>2];c[(ic+16|0)+4>>2]=c[k+4>>2];sI(V,4,.0362,ic);h[k>>3]=1.17453;c[jc>>2]=c[k>>2];c[jc+4>>2]=c[k+4>>2];h[k>>3]=-87.8722;c[(jc+8|0)>>2]=c[k>>2];c[(jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220361.0e-9;c[(jc+16|0)>>2]=c[k>>2];c[(jc+16|0)+4>>2]=c[k+4>>2];sI(W,4,.0363,jc);h[k>>3]=1.17514;c[kc>>2]=c[k>>2];c[kc+4>>2]=c[k+4>>2];h[k>>3]=-87.8984;c[(kc+8|0)>>2]=c[k>>2];c[(kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220357.0e-9;c[(kc+16|0)>>2]=c[k>>2];c[(kc+16|0)+4>>2]=c[k+4>>2];sI(X,4,.0364,kc);h[k>>3]=1.17574;c[lc>>2]=c[k>>2];c[lc+4>>2]=c[k+4>>2];h[k>>3]=-87.9238;c[(lc+8|0)>>2]=c[k>>2];c[(lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220352.0e-9;c[(lc+16|0)>>2]=c[k>>2];c[(lc+16|0)+4>>2]=c[k+4>>2];sI(Y,4,.0365,lc);h[k>>3]=1.17633;c[mc>>2]=c[k>>2];c[mc+4>>2]=c[k+4>>2];h[k>>3]=-87.9487;c[(mc+8|0)>>2]=c[k>>2];c[(mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220348.0e-9;c[(mc+16|0)>>2]=c[k>>2];c[(mc+16|0)+4>>2]=c[k+4>>2];sI(Z,4,.0366,mc);h[k>>3]=1.1769;c[nc>>2]=c[k>>2];c[nc+4>>2]=c[k+4>>2];h[k>>3]=-87.9729;c[(nc+8|0)>>2]=c[k>>2];c[(nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220344.0e-9;c[(nc+16|0)>>2]=c[k>>2];c[(nc+16|0)+4>>2]=c[k+4>>2];sI(_,4,.0367,nc);h[k>>3]=1.17746;c[oc>>2]=c[k>>2];c[oc+4>>2]=c[k+4>>2];h[k>>3]=-87.9966;c[(oc+8|0)>>2]=c[k>>2];c[(oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22034.0e-8;c[(oc+16|0)>>2]=c[k>>2];c[(oc+16|0)+4>>2]=c[k+4>>2];sI($,4,.0368,oc);h[k>>3]=1.17801;c[pc>>2]=c[k>>2];c[pc+4>>2]=c[k+4>>2];h[k>>3]=-88.0197;c[(pc+8|0)>>2]=c[k>>2];c[(pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220336.0e-9;c[(pc+16|0)>>2]=c[k>>2];c[(pc+16|0)+4>>2]=c[k+4>>2];sI(aa,4,.0369,pc);h[k>>3]=1.17858;c[qc>>2]=c[k>>2];c[qc+4>>2]=c[k+4>>2];h[k>>3]=-88.0441;c[(qc+8|0)>>2]=c[k>>2];c[(qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220332.0e-9;c[(qc+16|0)>>2]=c[k>>2];c[(qc+16|0)+4>>2]=c[k+4>>2];sI(ba,4,.037,qc);h[k>>3]=1.17922;c[rc>>2]=c[k>>2];c[rc+4>>2]=c[k+4>>2];h[k>>3]=-88.0712;c[(rc+8|0)>>2]=c[k>>2];c[(rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220328.0e-9;c[(rc+16|0)>>2]=c[k>>2];c[(rc+16|0)+4>>2]=c[k+4>>2];sI(ca,4,.0371,rc);h[k>>3]=1.17985;c[sc>>2]=c[k>>2];c[sc+4>>2]=c[k+4>>2];h[k>>3]=-88.0975;c[(sc+8|0)>>2]=c[k>>2];c[(sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220323.0e-9;c[(sc+16|0)>>2]=c[k>>2];c[(sc+16|0)+4>>2]=c[k+4>>2];sI(da,4,.0372,sc);h[k>>3]=1.18045;c[tc>>2]=c[k>>2];c[tc+4>>2]=c[k+4>>2];h[k>>3]=-88.123;c[(tc+8|0)>>2]=c[k>>2];c[(tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220319.0e-9;c[(tc+16|0)>>2]=c[k>>2];c[(tc+16|0)+4>>2]=c[k+4>>2];sI(ea,4,.0373,tc);h[k>>3]=1.18103;c[uc>>2]=c[k>>2];c[uc+4>>2]=c[k+4>>2];h[k>>3]=-88.1477;c[(uc+8|0)>>2]=c[k>>2];c[(uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220314.0e-9;c[(uc+16|0)>>2]=c[k>>2];c[(uc+16|0)+4>>2]=c[k+4>>2];sI(fa,4,.0374,uc);h[k>>3]=1.1816;c[vc>>2]=c[k>>2];c[vc+4>>2]=c[k+4>>2];h[k>>3]=-88.1717;c[(vc+8|0)>>2]=c[k>>2];c[(vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22031.0e-8;c[(vc+16|0)>>2]=c[k>>2];c[(vc+16|0)+4>>2]=c[k+4>>2];sI(ga,4,.0375,vc);h[k>>3]=1.18215;c[wc>>2]=c[k>>2];c[wc+4>>2]=c[k+4>>2];h[k>>3]=-88.195;c[(wc+8|0)>>2]=c[k>>2];c[(wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220306.0e-9;c[(wc+16|0)>>2]=c[k>>2];c[(wc+16|0)+4>>2]=c[k+4>>2];sI(ha,4,.0376,wc);h[k>>3]=1.18268;c[xc>>2]=c[k>>2];c[xc+4>>2]=c[k+4>>2];h[k>>3]=-88.2176;c[(xc+8|0)>>2]=c[k>>2];c[(xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220302.0e-9;c[(xc+16|0)>>2]=c[k>>2];c[(xc+16|0)+4>>2]=c[k+4>>2];sI(ia,4,.0377,xc);h[k>>3]=1.1832;c[yc>>2]=c[k>>2];c[yc+4>>2]=c[k+4>>2];h[k>>3]=-88.2395;c[(yc+8|0)>>2]=c[k>>2];c[(yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220299.0e-9;c[(yc+16|0)>>2]=c[k>>2];c[(yc+16|0)+4>>2]=c[k+4>>2];sI(ja,4,.0378,yc);h[k>>3]=1.1837;c[zc>>2]=c[k>>2];c[zc+4>>2]=c[k+4>>2];h[k>>3]=-88.2607;c[(zc+8|0)>>2]=c[k>>2];c[(zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220295.0e-9;c[(zc+16|0)>>2]=c[k>>2];c[(zc+16|0)+4>>2]=c[k+4>>2];sI(ka,4,.0379,zc);h[k>>3]=1.18419;c[Ac>>2]=c[k>>2];c[Ac+4>>2]=c[k+4>>2];h[k>>3]=-88.2814;c[(Ac+8|0)>>2]=c[k>>2];c[(Ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220291.0e-9;c[(Ac+16|0)>>2]=c[k>>2];c[(Ac+16|0)+4>>2]=c[k+4>>2];sI(la,4,.038,Ac);h[k>>3]=1.18466;c[Bc>>2]=c[k>>2];c[Bc+4>>2]=c[k+4>>2];h[k>>3]=-88.3014;c[(Bc+8|0)>>2]=c[k>>2];c[(Bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220288.0e-9;c[(Bc+16|0)>>2]=c[k>>2];c[(Bc+16|0)+4>>2]=c[k+4>>2];sI(ma,4,.0381,Bc);h[k>>3]=1.18512;c[Cc>>2]=c[k>>2];c[Cc+4>>2]=c[k+4>>2];h[k>>3]=-88.3208;c[(Cc+8|0)>>2]=c[k>>2];c[(Cc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220284.0e-9;c[(Cc+16|0)>>2]=c[k>>2];c[(Cc+16|0)+4>>2]=c[k+4>>2];sI(na,4,.0382,Cc);h[k>>3]=1.18556;c[Dc>>2]=c[k>>2];c[Dc+4>>2]=c[k+4>>2];h[k>>3]=-88.3396;c[(Dc+8|0)>>2]=c[k>>2];c[(Dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220281.0e-9;c[(Dc+16|0)>>2]=c[k>>2];c[(Dc+16|0)+4>>2]=c[k+4>>2];sI(oa,4,.0383,Dc);h[k>>3]=1.18599;c[Ec>>2]=c[k>>2];c[Ec+4>>2]=c[k+4>>2];h[k>>3]=-88.3578;c[(Ec+8|0)>>2]=c[k>>2];c[(Ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220278.0e-9;c[(Ec+16|0)>>2]=c[k>>2];c[(Ec+16|0)+4>>2]=c[k+4>>2];sI(pa,4,.0384,Ec);h[k>>3]=1.18641;c[Fc>>2]=c[k>>2];c[Fc+4>>2]=c[k+4>>2];h[k>>3]=-88.3756;c[(Fc+8|0)>>2]=c[k>>2];c[(Fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220275.0e-9;c[(Fc+16|0)>>2]=c[k>>2];c[(Fc+16|0)+4>>2]=c[k+4>>2];sI(qa,4,.0385,Fc);h[k>>3]=1.18682;c[Gc>>2]=c[k>>2];c[Gc+4>>2]=c[k+4>>2];h[k>>3]=-88.3928;c[(Gc+8|0)>>2]=c[k>>2];c[(Gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220272.0e-9;c[(Gc+16|0)>>2]=c[k>>2];c[(Gc+16|0)+4>>2]=c[k+4>>2];sI(ra,4,.0386,Gc);h[k>>3]=1.18721;c[Hc>>2]=c[k>>2];c[Hc+4>>2]=c[k+4>>2];h[k>>3]=-88.4094;c[(Hc+8|0)>>2]=c[k>>2];c[(Hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220269.0e-9;c[(Hc+16|0)>>2]=c[k>>2];c[(Hc+16|0)+4>>2]=c[k+4>>2];sI(sa,4,.0387,Hc);h[k>>3]=1.18759;c[Ic>>2]=c[k>>2];c[Ic+4>>2]=c[k+4>>2];h[k>>3]=-88.4256;c[(Ic+8|0)>>2]=c[k>>2];c[(Ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220266.0e-9;c[(Ic+16|0)>>2]=c[k>>2];c[(Ic+16|0)+4>>2]=c[k+4>>2];sI(ta,4,.0388,Ic);h[k>>3]=1.18796;c[Jc>>2]=c[k>>2];c[Jc+4>>2]=c[k+4>>2];h[k>>3]=-88.4413;c[(Jc+8|0)>>2]=c[k>>2];c[(Jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220264.0e-9;c[(Jc+16|0)>>2]=c[k>>2];c[(Jc+16|0)+4>>2]=c[k+4>>2];sI(ua,4,.0389,Jc);h[k>>3]=1.18832;c[Kc>>2]=c[k>>2];c[Kc+4>>2]=c[k+4>>2];h[k>>3]=-88.4565;c[(Kc+8|0)>>2]=c[k>>2];c[(Kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220261.0e-9;c[(Kc+16|0)>>2]=c[k>>2];c[(Kc+16|0)+4>>2]=c[k+4>>2];sI(va,4,.039,Kc);h[k>>3]=1.18867;c[Lc>>2]=c[k>>2];c[Lc+4>>2]=c[k+4>>2];h[k>>3]=-88.4713;c[(Lc+8|0)>>2]=c[k>>2];c[(Lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220258.0e-9;c[(Lc+16|0)>>2]=c[k>>2];c[(Lc+16|0)+4>>2]=c[k+4>>2];sI(wa,4,.0391,Lc);h[k>>3]=1.18901;c[Mc>>2]=c[k>>2];c[Mc+4>>2]=c[k+4>>2];h[k>>3]=-88.4856;c[(Mc+8|0)>>2]=c[k>>2];c[(Mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220256.0e-9;c[(Mc+16|0)>>2]=c[k>>2];c[(Mc+16|0)+4>>2]=c[k+4>>2];sI(xa,4,.0392,Mc);h[k>>3]=1.18934;c[Nc>>2]=c[k>>2];c[Nc+4>>2]=c[k+4>>2];h[k>>3]=-88.4995;c[(Nc+8|0)>>2]=c[k>>2];c[(Nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220253.0e-9;c[(Nc+16|0)>>2]=c[k>>2];c[(Nc+16|0)+4>>2]=c[k+4>>2];sI(ya,4,.0393,Nc);h[k>>3]=1.18965;c[Oc>>2]=c[k>>2];c[Oc+4>>2]=c[k+4>>2];h[k>>3]=-88.513;c[(Oc+8|0)>>2]=c[k>>2];c[(Oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220251.0e-9;c[(Oc+16|0)>>2]=c[k>>2];c[(Oc+16|0)+4>>2]=c[k+4>>2];sI(za,4,.0394,Oc);h[k>>3]=1.18996;c[Pc>>2]=c[k>>2];c[Pc+4>>2]=c[k+4>>2];h[k>>3]=-88.5261;c[(Pc+8|0)>>2]=c[k>>2];c[(Pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220249.0e-9;c[(Pc+16|0)>>2]=c[k>>2];c[(Pc+16|0)+4>>2]=c[k+4>>2];sI(Aa,4,.0395,Pc);h[k>>3]=1.19026;c[Qc>>2]=c[k>>2];c[Qc+4>>2]=c[k+4>>2];h[k>>3]=-88.5388;c[(Qc+8|0)>>2]=c[k>>2];c[(Qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220247.0e-9;c[(Qc+16|0)>>2]=c[k>>2];c[(Qc+16|0)+4>>2]=c[k+4>>2];sI(Ba,4,.0396,Qc);h[k>>3]=1.19055;c[Rc>>2]=c[k>>2];c[Rc+4>>2]=c[k+4>>2];h[k>>3]=-88.5511;c[(Rc+8|0)>>2]=c[k>>2];c[(Rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220245.0e-9;c[(Rc+16|0)>>2]=c[k>>2];c[(Rc+16|0)+4>>2]=c[k+4>>2];sI(Ca,4,.0397,Rc);h[k>>3]=1.19084;c[Sc>>2]=c[k>>2];c[Sc+4>>2]=c[k+4>>2];h[k>>3]=-88.563;c[(Sc+8|0)>>2]=c[k>>2];c[(Sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220242.0e-9;c[(Sc+16|0)>>2]=c[k>>2];c[(Sc+16|0)+4>>2]=c[k+4>>2];sI(Da,4,.0398,Sc);h[k>>3]=1.19111;c[Tc>>2]=c[k>>2];c[Tc+4>>2]=c[k+4>>2];h[k>>3]=-88.5746;c[(Tc+8|0)>>2]=c[k>>2];c[(Tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22024.0e-8;c[(Tc+16|0)>>2]=c[k>>2];c[(Tc+16|0)+4>>2]=c[k+4>>2];sI(Ea,4,.0399,Tc);h[k>>3]=1.19137;c[Uc>>2]=c[k>>2];c[Uc+4>>2]=c[k+4>>2];h[k>>3]=-88.5859;c[(Uc+8|0)>>2]=c[k>>2];c[(Uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220239.0e-9;c[(Uc+16|0)>>2]=c[k>>2];c[(Uc+16|0)+4>>2]=c[k+4>>2];sI(Fa,4,.04,Uc);h[k>>3]=1.19163;c[Vc>>2]=c[k>>2];c[Vc+4>>2]=c[k+4>>2];h[k>>3]=-88.5968;c[(Vc+8|0)>>2]=c[k>>2];c[(Vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220237.0e-9;c[(Vc+16|0)>>2]=c[k>>2];c[(Vc+16|0)+4>>2]=c[k+4>>2];sI(Ga,4,.0401,Vc);h[k>>3]=1.19188;c[Wc>>2]=c[k>>2];c[Wc+4>>2]=c[k+4>>2];h[k>>3]=-88.6074;c[(Wc+8|0)>>2]=c[k>>2];c[(Wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220235.0e-9;c[(Wc+16|0)>>2]=c[k>>2];c[(Wc+16|0)+4>>2]=c[k+4>>2];sI(Ha,4,.0402,Wc);h[k>>3]=1.19212;c[Xc>>2]=c[k>>2];c[Xc+4>>2]=c[k+4>>2];h[k>>3]=-88.6176;c[(Xc+8|0)>>2]=c[k>>2];c[(Xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220233.0e-9;c[(Xc+16|0)>>2]=c[k>>2];c[(Xc+16|0)+4>>2]=c[k+4>>2];sI(Ia,4,.0403,Xc);h[k>>3]=1.19236;c[Yc>>2]=c[k>>2];c[Yc+4>>2]=c[k+4>>2];h[k>>3]=-88.6276;c[(Yc+8|0)>>2]=c[k>>2];c[(Yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220231.0e-9;c[(Yc+16|0)>>2]=c[k>>2];c[(Yc+16|0)+4>>2]=c[k+4>>2];sI(Ja,4,.0404,Yc);h[k>>3]=1.19259;c[Zc>>2]=c[k>>2];c[Zc+4>>2]=c[k+4>>2];h[k>>3]=-88.6373;c[(Zc+8|0)>>2]=c[k>>2];c[(Zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22023.0e-8;c[(Zc+16|0)>>2]=c[k>>2];c[(Zc+16|0)+4>>2]=c[k+4>>2];sI(Ka,4,.0405,Zc);h[k>>3]=1.19281;c[_c>>2]=c[k>>2];c[_c+4>>2]=c[k+4>>2];h[k>>3]=-88.6466;c[(_c+8|0)>>2]=c[k>>2];c[(_c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220228.0e-9;c[(_c+16|0)>>2]=c[k>>2];c[(_c+16|0)+4>>2]=c[k+4>>2];sI(La,4,.0406,_c);h[k>>3]=1.19302;c[$c>>2]=c[k>>2];c[$c+4>>2]=c[k+4>>2];h[k>>3]=-88.6557;c[($c+8|0)>>2]=c[k>>2];c[($c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220226.0e-9;c[($c+16|0)>>2]=c[k>>2];c[($c+16|0)+4>>2]=c[k+4>>2];sI(Ma,4,.0407,$c);h[k>>3]=1.19323;c[ad>>2]=c[k>>2];c[ad+4>>2]=c[k+4>>2];h[k>>3]=-88.6646;c[(ad+8|0)>>2]=c[k>>2];c[(ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220225.0e-9;c[(ad+16|0)>>2]=c[k>>2];c[(ad+16|0)+4>>2]=c[k+4>>2];sI(Na,4,.0408,ad);h[k>>3]=1.19343;c[bd>>2]=c[k>>2];c[bd+4>>2]=c[k+4>>2];h[k>>3]=-88.6731;c[(bd+8|0)>>2]=c[k>>2];c[(bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220223.0e-9;c[(bd+16|0)>>2]=c[k>>2];c[(bd+16|0)+4>>2]=c[k+4>>2];sI(Oa,4,.0409,bd);h[k>>3]=1.19363;c[cd>>2]=c[k>>2];c[cd+4>>2]=c[k+4>>2];h[k>>3]=-88.6814;c[(cd+8|0)>>2]=c[k>>2];c[(cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220222.0e-9;c[(cd+16|0)>>2]=c[k>>2];c[(cd+16|0)+4>>2]=c[k+4>>2];sI(Pa,4,.041,cd);h[k>>3]=1.19382;c[dd>>2]=c[k>>2];c[dd+4>>2]=c[k+4>>2];h[k>>3]=-88.6895;c[(dd+8|0)>>2]=c[k>>2];c[(dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220221.0e-9;c[(dd+16|0)>>2]=c[k>>2];c[(dd+16|0)+4>>2]=c[k+4>>2];sI(Qa,4,.0411,dd);h[k>>3]=1.19401;c[ed>>2]=c[k>>2];c[ed+4>>2]=c[k+4>>2];h[k>>3]=-88.6973;c[(ed+8|0)>>2]=c[k>>2];c[(ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220219.0e-9;c[(ed+16|0)>>2]=c[k>>2];c[(ed+16|0)+4>>2]=c[k+4>>2];sI(Ra,4,.0412,ed);h[k>>3]=1.19418;c[fd>>2]=c[k>>2];c[fd+4>>2]=c[k+4>>2];h[k>>3]=-88.7049;c[(fd+8|0)>>2]=c[k>>2];c[(fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220218.0e-9;c[(fd+16|0)>>2]=c[k>>2];c[(fd+16|0)+4>>2]=c[k+4>>2];sI(Sa,4,.0413,fd);h[k>>3]=1.19436;c[gd>>2]=c[k>>2];c[gd+4>>2]=c[k+4>>2];h[k>>3]=-88.7122;c[(gd+8|0)>>2]=c[k>>2];c[(gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220217.0e-9;c[(gd+16|0)>>2]=c[k>>2];c[(gd+16|0)+4>>2]=c[k+4>>2];sI(Ta,4,.0414,gd);h[k>>3]=1.19453;c[hd>>2]=c[k>>2];c[hd+4>>2]=c[k+4>>2];h[k>>3]=-88.7194;c[(hd+8|0)>>2]=c[k>>2];c[(hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220215.0e-9;c[(hd+16|0)>>2]=c[k>>2];c[(hd+16|0)+4>>2]=c[k+4>>2];sI(Ua,4,.0415,hd);h[k>>3]=1.19469;c[id>>2]=c[k>>2];c[id+4>>2]=c[k+4>>2];h[k>>3]=-88.7263;c[(id+8|0)>>2]=c[k>>2];c[(id+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220214.0e-9;c[(id+16|0)>>2]=c[k>>2];c[(id+16|0)+4>>2]=c[k+4>>2];sI(Va,4,.0416,id);h[k>>3]=1.19485;c[jd>>2]=c[k>>2];c[jd+4>>2]=c[k+4>>2];h[k>>3]=-88.733;c[(jd+8|0)>>2]=c[k>>2];c[(jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220213.0e-9;c[(jd+16|0)>>2]=c[k>>2];c[(jd+16|0)+4>>2]=c[k+4>>2];sI(Wa,4,.0417,jd);h[k>>3]=1.195;c[kd>>2]=c[k>>2];c[kd+4>>2]=c[k+4>>2];h[k>>3]=-88.7395;c[(kd+8|0)>>2]=c[k>>2];c[(kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220212.0e-9;c[(kd+16|0)>>2]=c[k>>2];c[(kd+16|0)+4>>2]=c[k+4>>2];sI(Xa,4,.0418,kd);h[k>>3]=1.19515;c[ld>>2]=c[k>>2];c[ld+4>>2]=c[k+4>>2];h[k>>3]=-88.7459;c[(ld+8|0)>>2]=c[k>>2];c[(ld+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220211.0e-9;c[(ld+16|0)>>2]=c[k>>2];c[(ld+16|0)+4>>2]=c[k+4>>2];sI(Ya,4,.0419,ld);h[k>>3]=1.1953;c[md>>2]=c[k>>2];c[md+4>>2]=c[k+4>>2];h[k>>3]=-88.752;c[(md+8|0)>>2]=c[k>>2];c[(md+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22021.0e-8;c[(md+16|0)>>2]=c[k>>2];c[(md+16|0)+4>>2]=c[k+4>>2];sI(Za,4,.042,md);h[k>>3]=1.19544;c[nd>>2]=c[k>>2];c[nd+4>>2]=c[k+4>>2];h[k>>3]=-88.7579;c[(nd+8|0)>>2]=c[k>>2];c[(nd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220209.0e-9;c[(nd+16|0)>>2]=c[k>>2];c[(nd+16|0)+4>>2]=c[k+4>>2];sI(_a,4,.0421,nd);h[k>>3]=1.19557;c[od>>2]=c[k>>2];c[od+4>>2]=c[k+4>>2];h[k>>3]=-88.7637;c[(od+8|0)>>2]=c[k>>2];c[(od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220208.0e-9;c[(od+16|0)>>2]=c[k>>2];c[(od+16|0)+4>>2]=c[k+4>>2];sI($a,4,.0422,od);h[k>>3]=1.19571;c[pd>>2]=c[k>>2];c[pd+4>>2]=c[k+4>>2];h[k>>3]=-88.7693;c[(pd+8|0)>>2]=c[k>>2];c[(pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220207.0e-9;c[(pd+16|0)>>2]=c[k>>2];c[(pd+16|0)+4>>2]=c[k+4>>2];sI(ab,4,.0423,pd);h[k>>3]=1.19583;c[qd>>2]=c[k>>2];c[qd+4>>2]=c[k+4>>2];h[k>>3]=-88.7747;c[(qd+8|0)>>2]=c[k>>2];c[(qd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220206.0e-9;c[(qd+16|0)>>2]=c[k>>2];c[(qd+16|0)+4>>2]=c[k+4>>2];sI(bb,4,.0424,qd);h[k>>3]=1.19596;c[rd>>2]=c[k>>2];c[rd+4>>2]=c[k+4>>2];h[k>>3]=-88.78;c[(rd+8|0)>>2]=c[k>>2];c[(rd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220205.0e-9;c[(rd+16|0)>>2]=c[k>>2];c[(rd+16|0)+4>>2]=c[k+4>>2];sI(cb,4,.0425,rd);h[k>>3]=1.19608;c[sd>>2]=c[k>>2];c[sd+4>>2]=c[k+4>>2];h[k>>3]=-88.7851;c[(sd+8|0)>>2]=c[k>>2];c[(sd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220204.0e-9;c[(sd+16|0)>>2]=c[k>>2];c[(sd+16|0)+4>>2]=c[k+4>>2];sI(db,4,.0426,sd);h[k>>3]=1.1962;c[td>>2]=c[k>>2];c[td+4>>2]=c[k+4>>2];h[k>>3]=-88.7901;c[(td+8|0)>>2]=c[k>>2];c[(td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220203.0e-9;c[(td+16|0)>>2]=c[k>>2];c[(td+16|0)+4>>2]=c[k+4>>2];sI(eb,4,.0427,td);h[k>>3]=1.19631;c[ud>>2]=c[k>>2];c[ud+4>>2]=c[k+4>>2];h[k>>3]=-88.7949;c[(ud+8|0)>>2]=c[k>>2];c[(ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220202.0e-9;c[(ud+16|0)>>2]=c[k>>2];c[(ud+16|0)+4>>2]=c[k+4>>2];sI(fb,4,.0428,ud);h[k>>3]=1.19642;c[vd>>2]=c[k>>2];c[vd+4>>2]=c[k+4>>2];h[k>>3]=-88.7996;c[(vd+8|0)>>2]=c[k>>2];c[(vd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220202.0e-9;c[(vd+16|0)>>2]=c[k>>2];c[(vd+16|0)+4>>2]=c[k+4>>2];sI(gb,4,.0429,vd);h[k>>3]=1.19653;c[wd>>2]=c[k>>2];c[wd+4>>2]=c[k+4>>2];h[k>>3]=-88.8041;c[(wd+8|0)>>2]=c[k>>2];c[(wd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220201.0e-9;c[(wd+16|0)>>2]=c[k>>2];c[(wd+16|0)+4>>2]=c[k+4>>2];sI(hb,4,.043,wd);h[k>>3]=1.19663;c[xd>>2]=c[k>>2];c[xd+4>>2]=c[k+4>>2];h[k>>3]=-88.8085;c[(xd+8|0)>>2]=c[k>>2];c[(xd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=2202.0e-7;c[(xd+16|0)>>2]=c[k>>2];c[(xd+16|0)+4>>2]=c[k+4>>2];sI(ib,4,.0431,xd);h[k>>3]=1.19673;c[yd>>2]=c[k>>2];c[yd+4>>2]=c[k+4>>2];h[k>>3]=-88.8127;c[(yd+8|0)>>2]=c[k>>2];c[(yd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220199.0e-9;c[(yd+16|0)>>2]=c[k>>2];c[(yd+16|0)+4>>2]=c[k+4>>2];sI(jb,4,.0432,yd);h[k>>3]=1.19683;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=-88.8169;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220199.0e-9;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];sI(kb,4,.0433,zd);h[k>>3]=1.19692;c[Ad>>2]=c[k>>2];c[Ad+4>>2]=c[k+4>>2];h[k>>3]=-88.8209;c[(Ad+8|0)>>2]=c[k>>2];c[(Ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220198.0e-9;c[(Ad+16|0)>>2]=c[k>>2];c[(Ad+16|0)+4>>2]=c[k+4>>2];sI(lb,4,.0434,Ad);h[k>>3]=1.19702;c[Bd>>2]=c[k>>2];c[Bd+4>>2]=c[k+4>>2];h[k>>3]=-88.8248;c[(Bd+8|0)>>2]=c[k>>2];c[(Bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220197.0e-9;c[(Bd+16|0)>>2]=c[k>>2];c[(Bd+16|0)+4>>2]=c[k+4>>2];sI(mb,4,.0435,Bd);h[k>>3]=1.1971;c[Cd>>2]=c[k>>2];c[Cd+4>>2]=c[k+4>>2];h[k>>3]=-88.8286;c[(Cd+8|0)>>2]=c[k>>2];c[(Cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220197.0e-9;c[(Cd+16|0)>>2]=c[k>>2];c[(Cd+16|0)+4>>2]=c[k+4>>2];sI(nb,4,.0436,Cd);h[k>>3]=1.19719;c[Dd>>2]=c[k>>2];c[Dd+4>>2]=c[k+4>>2];h[k>>3]=-88.8322;c[(Dd+8|0)>>2]=c[k>>2];c[(Dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220196.0e-9;c[(Dd+16|0)>>2]=c[k>>2];c[(Dd+16|0)+4>>2]=c[k+4>>2];sI(ob,4,.0437,Dd);h[k>>3]=1.19728;c[Ed>>2]=c[k>>2];c[Ed+4>>2]=c[k+4>>2];h[k>>3]=-88.8358;c[(Ed+8|0)>>2]=c[k>>2];c[(Ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220195.0e-9;c[(Ed+16|0)>>2]=c[k>>2];c[(Ed+16|0)+4>>2]=c[k+4>>2];sI(pb,4,.0438,Ed);h[k>>3]=1.19736;c[Fd>>2]=c[k>>2];c[Fd+4>>2]=c[k+4>>2];h[k>>3]=-88.8392;c[(Fd+8|0)>>2]=c[k>>2];c[(Fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220195.0e-9;c[(Fd+16|0)>>2]=c[k>>2];c[(Fd+16|0)+4>>2]=c[k+4>>2];sI(qb,4,.0439,Fd);h[k>>3]=1.19744;c[Gd>>2]=c[k>>2];c[Gd+4>>2]=c[k+4>>2];h[k>>3]=-88.8426;c[(Gd+8|0)>>2]=c[k>>2];c[(Gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220194.0e-9;c[(Gd+16|0)>>2]=c[k>>2];c[(Gd+16|0)+4>>2]=c[k+4>>2];sI(rb,4,.044,Gd);h[k>>3]=1.19751;c[Hd>>2]=c[k>>2];c[Hd+4>>2]=c[k+4>>2];h[k>>3]=-88.8458;c[(Hd+8|0)>>2]=c[k>>2];c[(Hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220194.0e-9;c[(Hd+16|0)>>2]=c[k>>2];c[(Hd+16|0)+4>>2]=c[k+4>>2];sI(sb,4,.0441,Hd);h[k>>3]=1.19759;c[Id>>2]=c[k>>2];c[Id+4>>2]=c[k+4>>2];h[k>>3]=-88.8489;c[(Id+8|0)>>2]=c[k>>2];c[(Id+8|0)+4>>2]=c[k+4>>2]}function _Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0;b=c[a+1840>>2]|0;d=c[a+1848>>2]|0;e=c[a+1856>>2]|0;f=c[a+1864>>2]|0;g=c[a+1872>>2]|0;i=c[a+1880>>2]|0;j=c[a+1888>>2]|0;l=c[a+1896>>2]|0;m=c[a+1904>>2]|0;n=c[a+1912>>2]|0;o=c[a+1920>>2]|0;p=c[a+1928>>2]|0;q=c[a+1936>>2]|0;r=c[a+1944>>2]|0;s=c[a+1952>>2]|0;t=c[a+1960>>2]|0;u=c[a+1968>>2]|0;v=c[a+1976>>2]|0;w=c[a+1984>>2]|0;x=c[a+1992>>2]|0;y=c[a+2e3>>2]|0;z=c[a+2008>>2]|0;A=c[a+2016>>2]|0;B=c[a+2024>>2]|0;C=c[a+2032>>2]|0;D=c[a+2040>>2]|0;E=c[a+2048>>2]|0;F=c[a+2056>>2]|0;G=c[a+2064>>2]|0;H=c[a+2072>>2]|0;I=c[a+2080>>2]|0;J=c[a+2088>>2]|0;K=c[a+2096>>2]|0;L=c[a+2104>>2]|0;M=c[a+2112>>2]|0;N=c[a+2120>>2]|0;O=c[a+2128>>2]|0;P=c[a+2136>>2]|0;Q=c[a+2144>>2]|0;R=c[a+2152>>2]|0;S=c[a+2160>>2]|0;T=c[a+2168>>2]|0;U=c[a+2176>>2]|0;V=c[a+2184>>2]|0;W=c[a+2192>>2]|0;X=c[a+2200>>2]|0;Y=c[a+2208>>2]|0;Z=c[a+2216>>2]|0;_=c[a+2224>>2]|0;$=c[a+2232>>2]|0;aa=c[a+2240>>2]|0;ba=c[a+2248>>2]|0;ca=c[a+2256>>2]|0;da=c[a+2264>>2]|0;ea=c[a+2272>>2]|0;fa=c[a+2280>>2]|0;ga=c[a+2288>>2]|0;ha=c[a+2296>>2]|0;ia=c[a+2304>>2]|0;ja=c[a+2312>>2]|0;ka=c[a+2320>>2]|0;la=c[a+2328>>2]|0;ma=c[a+2336>>2]|0;na=c[a+2344>>2]|0;oa=c[a+2352>>2]|0;pa=c[a+2360>>2]|0;qa=c[a+2368>>2]|0;ra=c[a+2376>>2]|0;sa=c[a+2384>>2]|0;ta=c[a+2392>>2]|0;ua=c[a+2400>>2]|0;va=c[a+2408>>2]|0;wa=c[a+2416>>2]|0;xa=c[a+2424>>2]|0;ya=c[a+2432>>2]|0;za=c[a+2440>>2]|0;Aa=c[a+2448>>2]|0;Ba=c[a+2456>>2]|0;Ca=c[a+2464>>2]|0;Da=c[a+2472>>2]|0;Ea=c[a+2480>>2]|0;Fa=c[a+2488>>2]|0;Ga=c[a+2496>>2]|0;Ha=c[a+2504>>2]|0;Ia=c[a+2512>>2]|0;Ja=c[a+2520>>2]|0;Ka=c[a+2528>>2]|0;La=c[a+2536>>2]|0;Ma=c[a+2544>>2]|0;Na=c[a+2552>>2]|0;Oa=c[a+2560>>2]|0;Pa=c[a+2568>>2]|0;Qa=c[a+2576>>2]|0;Ra=c[a+2584>>2]|0;Sa=c[a+2592>>2]|0;Ta=c[a+2600>>2]|0;Ua=c[a+2608>>2]|0;Va=c[a+2616>>2]|0;Wa=c[a+2624>>2]|0;Xa=c[a+2632>>2]|0;Ya=c[a+2640>>2]|0;Za=c[a+2648>>2]|0;_a=c[a+2656>>2]|0;$a=c[a+2664>>2]|0;ab=c[a+2672>>2]|0;bb=c[a+2680>>2]|0;cb=c[a+2688>>2]|0;db=c[a+2696>>2]|0;eb=c[a+2704>>2]|0;fb=c[a+2712>>2]|0;gb=c[a+2720>>2]|0;hb=c[a+2728>>2]|0;ib=c[a+2736>>2]|0;jb=c[a+2744>>2]|0;kb=c[a+2752>>2]|0;lb=c[a+2760>>2]|0;mb=c[a+2768>>2]|0;nb=c[a+2776>>2]|0;ob=c[a+2784>>2]|0;pb=c[a+2792>>2]|0;qb=c[a+2800>>2]|0;rb=c[a+2808>>2]|0;sb=c[a+2816>>2]|0;tb=c[a+2824>>2]|0;ub=c[a+2832>>2]|0;vb=c[a+2840>>2]|0;wb=c[a+2848>>2]|0;xb=c[a+4824>>2]|0;yb=c[a+4832>>2]|0;zb=c[a+4840>>2]|0;Ab=c[a+4848>>2]|0;Bb=c[a+4856>>2]|0;Cb=c[a+4864>>2]|0;Db=c[a+4872>>2]|0;Eb=c[a+4880>>2]|0;Fb=c[a+4888>>2]|0;Gb=c[a+4896>>2]|0;Hb=c[a+4912>>2]|0;Ib=c[a+4920>>2]|0;Jb=c[a+4928>>2]|0;Kb=c[a+4936>>2]|0;Lb=c[a+4944>>2]|0;Mb=c[a+4952>>2]|0;Nb=c[a+4960>>2]|0;Ob=c[a+4968>>2]|0;Pb=c[a+4976>>2]|0;Qb=c[a+4984>>2]|0;Rb=c[a+5e3>>2]|0;Sb=c[a+5008>>2]|0;Tb=c[a+5016>>2]|0;Ub=c[a+5024>>2]|0;Vb=c[a+5032>>2]|0;Wb=c[a+5040>>2]|0;Xb=c[a+5048>>2]|0;Yb=c[a+5056>>2]|0;Zb=c[a+5064>>2]|0;_b=c[a+5072>>2]|0;$b=c[a+5088>>2]|0;ac=c[a+5096>>2]|0;bc=c[a+5104>>2]|0;cc=c[a+5112>>2]|0;dc=c[a+5120>>2]|0;ec=c[a+5128>>2]|0;fc=c[a+5136>>2]|0;gc=c[a+5144>>2]|0;hc=c[a+5152>>2]|0;ic=c[a+5160>>2]|0;jc=c[a+5176>>2]|0;kc=c[a+5184>>2]|0;lc=c[a+5192>>2]|0;mc=c[a+5200>>2]|0;nc=c[a+5208>>2]|0;oc=c[a+5216>>2]|0;pc=c[a+5224>>2]|0;qc=c[a+5232>>2]|0;rc=c[a+5240>>2]|0;sc=c[a+5248>>2]|0;tc=c[a+5264>>2]|0;uc=c[a+5272>>2]|0;vc=c[a+5280>>2]|0;wc=c[a+5288>>2]|0;xc=c[a+5296>>2]|0;yc=c[a+5304>>2]|0;zc=c[a+5312>>2]|0;Ac=c[a+5320>>2]|0;Bc=c[a+5328>>2]|0;Cc=c[a+5336>>2]|0;Dc=c[a+5352>>2]|0;Ec=c[a+5360>>2]|0;Fc=c[a+5368>>2]|0;Gc=c[a+5376>>2]|0;Hc=c[a+5384>>2]|0;Ic=c[a+5392>>2]|0;Jc=c[a+5400>>2]|0;Kc=c[a+5408>>2]|0;Lc=c[a+5416>>2]|0;Mc=c[a+5424>>2]|0;Nc=c[a+5440>>2]|0;Oc=c[a+5448>>2]|0;Pc=c[a+5456>>2]|0;Qc=c[a+5464>>2]|0;Rc=c[a+5472>>2]|0;Sc=c[a+5480>>2]|0;Tc=c[a+5488>>2]|0;Uc=c[a+5496>>2]|0;Vc=c[a+5504>>2]|0;Wc=c[a+5512>>2]|0;Xc=c[a+5536>>2]|0;Yc=c[a+5544>>2]|0;Zc=c[a+5552>>2]|0;_c=c[a+5560>>2]|0;$c=c[a+5568>>2]|0;ad=c[a+5576>>2]|0;bd=c[a+5584>>2]|0;cd=c[a+5592>>2]|0;dd=c[a+5600>>2]|0;ed=c[a+5608>>2]|0;fd=c[a+5624>>2]|0;gd=c[a+5632>>2]|0;hd=c[a+5640>>2]|0;id=c[a+5648>>2]|0;jd=c[a+5656>>2]|0;kd=c[a+5664>>2]|0;ld=c[a+5672>>2]|0;md=c[a+5680>>2]|0;nd=c[a+5688>>2]|0;od=c[a+5696>>2]|0;pd=c[a+5712>>2]|0;qd=c[a+5720>>2]|0;rd=c[a+5728>>2]|0;sd=c[a+5736>>2]|0;td=c[a+5744>>2]|0;ud=c[a+5752>>2]|0;vd=c[a+5760>>2]|0;wd=c[a+5768>>2]|0;xd=c[a+5776>>2]|0;yd=c[a+5784>>2]|0;zd=c[a+5800>>2]|0;Ad=c[a+5808>>2]|0;Bd=c[a+5816>>2]|0;Cd=c[a+5824>>2]|0;Dd=c[a+5832>>2]|0;Ed=c[a+5840>>2]|0;Fd=c[a+5848>>2]|0;Gd=c[a+5856>>2]|0;Hd=c[a+5864>>2]|0;Id=c[a+5872>>2]|0;Jd=c[a+5888>>2]|0;Kd=c[a+5896>>2]|0;Ld=c[a+5904>>2]|0;Md=c[a+5912>>2]|0;Nd=c[a+5920>>2]|0;Od=c[a+5928>>2]|0;Pd=c[a+5936>>2]|0;Qd=c[a+5944>>2]|0;c[(xb+8|0)>>2]=c[k>>2];c[(xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228341.0e-9;c[(xb+16|0)>>2]=c[k>>2];c[(xb+16|0)+4>>2]=c[k+4>>2];sI(b,4,.0192,xb);h[k>>3]=.660077;c[yb>>2]=c[k>>2];c[yb+4>>2]=c[k+4>>2];h[k>>3]=-47.8633;c[(yb+8|0)>>2]=c[k>>2];c[(yb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228231.0e-9;c[(yb+16|0)>>2]=c[k>>2];c[(yb+16|0)+4>>2]=c[k+4>>2];sI(d,4,.0193,yb);h[k>>3]=.663999;c[zb>>2]=c[k>>2];c[zb+4>>2]=c[k+4>>2];h[k>>3]=-48.3362;c[(zb+8|0)>>2]=c[k>>2];c[(zb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228122.0e-9;c[(zb+16|0)>>2]=c[k>>2];c[(zb+16|0)+4>>2]=c[k+4>>2];sI(e,4,.0194,zb);h[k>>3]=.667892;c[Ab>>2]=c[k>>2];c[Ab+4>>2]=c[k+4>>2];h[k>>3]=-48.8057;c[(Ab+8|0)>>2]=c[k>>2];c[(Ab+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228014.0e-9;c[(Ab+16|0)>>2]=c[k>>2];c[(Ab+16|0)+4>>2]=c[k+4>>2];sI(f,4,.0195,Ab);h[k>>3]=.671756;c[Bb>>2]=c[k>>2];c[Bb+4>>2]=c[k+4>>2];h[k>>3]=-49.2718;c[(Bb+8|0)>>2]=c[k>>2];c[(Bb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227908.0e-9;c[(Bb+16|0)>>2]=c[k>>2];c[(Bb+16|0)+4>>2]=c[k+4>>2];sI(g,4,.0196,Bb);h[k>>3]=.675592;c[Cb>>2]=c[k>>2];c[Cb+4>>2]=c[k+4>>2];h[k>>3]=-49.7347;c[(Cb+8|0)>>2]=c[k>>2];c[(Cb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227802.0e-9;c[(Cb+16|0)>>2]=c[k>>2];c[(Cb+16|0)+4>>2]=c[k+4>>2];sI(i,4,.0197,Cb);h[k>>3]=.67979;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];h[k>>3]=-50.2404;c[(Db+8|0)>>2]=c[k>>2];c[(Db+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227697.0e-9;c[(Db+16|0)>>2]=c[k>>2];c[(Db+16|0)+4>>2]=c[k+4>>2];sI(j,4,.0198,Db);h[k>>3]=.684118;c[Eb>>2]=c[k>>2];c[Eb+4>>2]=c[k+4>>2];h[k>>3]=-50.7623;c[(Eb+8|0)>>2]=c[k>>2];c[(Eb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227586.0e-9;c[(Eb+16|0)>>2]=c[k>>2];c[(Eb+16|0)+4>>2]=c[k+4>>2];sI(l,4,.0199,Eb);h[k>>3]=.688404;c[Fb>>2]=c[k>>2];c[Fb+4>>2]=c[k+4>>2];h[k>>3]=-51.2799;c[(Fb+8|0)>>2]=c[k>>2];c[(Fb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227471.0e-9;c[(Fb+16|0)>>2]=c[k>>2];c[(Fb+16|0)+4>>2]=c[k+4>>2];sI(m,4,.02,Fb);h[k>>3]=.692654;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];h[k>>3]=-51.7933;c[(Gb+8|0)>>2]=c[k>>2];c[(Gb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227355.0e-9;c[(Gb+16|0)>>2]=c[k>>2];c[(Gb+16|0)+4>>2]=c[k+4>>2];sI(n,4,.0201,Gb);h[k>>3]=.696868;c[Hb>>2]=c[k>>2];c[Hb+4>>2]=c[k+4>>2];h[k>>3]=-52.3025;c[(Hb+8|0)>>2]=c[k>>2];c[(Hb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227241.0e-9;c[(Hb+16|0)>>2]=c[k>>2];c[(Hb+16|0)+4>>2]=c[k+4>>2];sI(o,4,.0202,Hb);h[k>>3]=.701047;c[Ib>>2]=c[k>>2];c[Ib+4>>2]=c[k+4>>2];h[k>>3]=-52.8002;c[(Ib+8|0)>>2]=c[k>>2];c[(Ib+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22713.0e-8;c[(Ib+16|0)>>2]=c[k>>2];c[(Ib+16|0)+4>>2]=c[k+4>>2];sI(p,4,.0203,Ib);h[k>>3]=.705193;c[Jb>>2]=c[k>>2];c[Jb+4>>2]=c[k+4>>2];h[k>>3]=-53.2717;c[(Jb+8|0)>>2]=c[k>>2];c[(Jb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227022.0e-9;c[(Jb+16|0)>>2]=c[k>>2];c[(Jb+16|0)+4>>2]=c[k+4>>2];sI(q,4,.0204,Jb);h[k>>3]=.709307;c[Kb>>2]=c[k>>2];c[Kb+4>>2]=c[k+4>>2];h[k>>3]=-53.7394;c[(Kb+8|0)>>2]=c[k>>2];c[(Kb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226918.0e-9;c[(Kb+16|0)>>2]=c[k>>2];c[(Kb+16|0)+4>>2]=c[k+4>>2];sI(r,4,.0205,Kb);h[k>>3]=.713479;c[Lb>>2]=c[k>>2];c[Lb+4>>2]=c[k+4>>2];h[k>>3]=-54.2135;c[(Lb+8|0)>>2]=c[k>>2];c[(Lb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226817.0e-9;c[(Lb+16|0)>>2]=c[k>>2];c[(Lb+16|0)+4>>2]=c[k+4>>2];sI(s,4,.0206,Lb);h[k>>3]=.717635;c[Mb>>2]=c[k>>2];c[Mb+4>>2]=c[k+4>>2];h[k>>3]=-54.686;c[(Mb+8|0)>>2]=c[k>>2];c[(Mb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226716.0e-9;c[(Mb+16|0)>>2]=c[k>>2];c[(Mb+16|0)+4>>2]=c[k+4>>2];sI(t,4,.0207,Mb);h[k>>3]=.721755;c[Nb>>2]=c[k>>2];c[Nb+4>>2]=c[k+4>>2];h[k>>3]=-55.1544;c[(Nb+8|0)>>2]=c[k>>2];c[(Nb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226615.0e-9;c[(Nb+16|0)>>2]=c[k>>2];c[(Nb+16|0)+4>>2]=c[k+4>>2];sI(u,4,.0208,Nb);h[k>>3]=.725839;c[Ob>>2]=c[k>>2];c[Ob+4>>2]=c[k+4>>2];h[k>>3]=-55.619;c[(Ob+8|0)>>2]=c[k>>2];c[(Ob+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226515.0e-9;c[(Ob+16|0)>>2]=c[k>>2];c[(Ob+16|0)+4>>2]=c[k+4>>2];sI(v,4,.0209,Ob);h[k>>3]=.729888;c[Pb>>2]=c[k>>2];c[Pb+4>>2]=c[k+4>>2];h[k>>3]=-56.0796;c[(Pb+8|0)>>2]=c[k>>2];c[(Pb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226416.0e-9;c[(Pb+16|0)>>2]=c[k>>2];c[(Pb+16|0)+4>>2]=c[k+4>>2];sI(w,4,.021,Pb);h[k>>3]=.733903;c[Qb>>2]=c[k>>2];c[Qb+4>>2]=c[k+4>>2];h[k>>3]=-56.5364;c[(Qb+8|0)>>2]=c[k>>2];c[(Qb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226319.0e-9;c[(Qb+16|0)>>2]=c[k>>2];c[(Qb+16|0)+4>>2]=c[k+4>>2];sI(x,4,.0211,Qb);h[k>>3]=.737883;c[Rb>>2]=c[k>>2];c[Rb+4>>2]=c[k+4>>2];h[k>>3]=-56.9893;c[(Rb+8|0)>>2]=c[k>>2];c[(Rb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226222.0e-9;c[(Rb+16|0)>>2]=c[k>>2];c[(Rb+16|0)+4>>2]=c[k+4>>2];sI(y,4,.0212,Rb);h[k>>3]=.741829;c[Sb>>2]=c[k>>2];c[Sb+4>>2]=c[k+4>>2];h[k>>3]=-57.4383;c[(Sb+8|0)>>2]=c[k>>2];c[(Sb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226127.0e-9;c[(Sb+16|0)>>2]=c[k>>2];c[(Sb+16|0)+4>>2]=c[k+4>>2];sI(z,4,.0213,Sb);h[k>>3]=.745732;c[Tb>>2]=c[k>>2];c[Tb+4>>2]=c[k+4>>2];h[k>>3]=-57.8827;c[(Tb+8|0)>>2]=c[k>>2];c[(Tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=226033.0e-9;c[(Tb+16|0)>>2]=c[k>>2];c[(Tb+16|0)+4>>2]=c[k+4>>2];sI(A,4,.0214,Tb);h[k>>3]=.749587;c[Ub>>2]=c[k>>2];c[Ub+4>>2]=c[k+4>>2];h[k>>3]=-58.3217;c[(Ub+8|0)>>2]=c[k>>2];c[(Ub+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225941.0e-9;c[(Ub+16|0)>>2]=c[k>>2];c[(Ub+16|0)+4>>2]=c[k+4>>2];sI(B,4,.0215,Ub);h[k>>3]=.75341;c[Vb>>2]=c[k>>2];c[Vb+4>>2]=c[k+4>>2];h[k>>3]=-58.7569;c[(Vb+8|0)>>2]=c[k>>2];c[(Vb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22585.0e-8;c[(Vb+16|0)>>2]=c[k>>2];c[(Vb+16|0)+4>>2]=c[k+4>>2];sI(C,4,.0216,Vb);h[k>>3]=.757199;c[Wb>>2]=c[k>>2];c[Wb+4>>2]=c[k+4>>2];h[k>>3]=-59.1885;c[(Wb+8|0)>>2]=c[k>>2];c[(Wb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22576.0e-8;c[(Wb+16|0)>>2]=c[k>>2];c[(Wb+16|0)+4>>2]=c[k+4>>2];sI(D,4,.0217,Wb);h[k>>3]=.760956;c[Xb>>2]=c[k>>2];c[Xb+4>>2]=c[k+4>>2];h[k>>3]=-59.6164;c[(Xb+8|0)>>2]=c[k>>2];c[(Xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225671.0e-9;c[(Xb+16|0)>>2]=c[k>>2];c[(Xb+16|0)+4>>2]=c[k+4>>2];sI(E,4,.0218,Xb);h[k>>3]=.764681;c[Yb>>2]=c[k>>2];c[Yb+4>>2]=c[k+4>>2];h[k>>3]=-60.0407;c[(Yb+8|0)>>2]=c[k>>2];c[(Yb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225583.0e-9;c[(Yb+16|0)>>2]=c[k>>2];c[(Yb+16|0)+4>>2]=c[k+4>>2];sI(F,4,.0219,Yb);h[k>>3]=.768373;c[Zb>>2]=c[k>>2];c[Zb+4>>2]=c[k+4>>2];h[k>>3]=-60.4614;c[(Zb+8|0)>>2]=c[k>>2];c[(Zb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225497.0e-9;c[(Zb+16|0)>>2]=c[k>>2];c[(Zb+16|0)+4>>2]=c[k+4>>2];sI(G,4,.022,Zb);h[k>>3]=.772034;c[_b>>2]=c[k>>2];c[_b+4>>2]=c[k+4>>2];h[k>>3]=-60.8786;c[(_b+8|0)>>2]=c[k>>2];c[(_b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225411.0e-9;c[(_b+16|0)>>2]=c[k>>2];c[(_b+16|0)+4>>2]=c[k+4>>2];sI(H,4,.0221,_b);h[k>>3]=.775663;c[$b>>2]=c[k>>2];c[$b+4>>2]=c[k+4>>2];h[k>>3]=-61.2922;c[($b+8|0)>>2]=c[k>>2];c[($b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225326.0e-9;c[($b+16|0)>>2]=c[k>>2];c[($b+16|0)+4>>2]=c[k+4>>2];sI(I,4,.0222,$b);h[k>>3]=.779579;c[ac>>2]=c[k>>2];c[ac+4>>2]=c[k+4>>2];h[k>>3]=-61.7378;c[(ac+8|0)>>2]=c[k>>2];c[(ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225242.0e-9;c[(ac+16|0)>>2]=c[k>>2];c[(ac+16|0)+4>>2]=c[k+4>>2];sI(J,4,.0223,ac);h[k>>3]=.784355;c[bc>>2]=c[k>>2];c[bc+4>>2]=c[k+4>>2];h[k>>3]=-62.2802;c[(bc+8|0)>>2]=c[k>>2];c[(bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225151.0e-9;c[(bc+16|0)>>2]=c[k>>2];c[(bc+16|0)+4>>2]=c[k+4>>2];sI(K,4,.0224,bc);h[k>>3]=.789065;c[cc>>2]=c[k>>2];c[cc+4>>2]=c[k+4>>2];h[k>>3]=-62.8168;c[(cc+8|0)>>2]=c[k>>2];c[(cc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=225046.0e-9;c[(cc+16|0)>>2]=c[k>>2];c[(cc+16|0)+4>>2]=c[k+4>>2];sI(L,4,.0225,cc);h[k>>3]=.793716;c[dc>>2]=c[k>>2];c[dc+4>>2]=c[k+4>>2];h[k>>3]=-63.3474;c[(dc+8|0)>>2]=c[k>>2];c[(dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224938.0e-9;c[(dc+16|0)>>2]=c[k>>2];c[(dc+16|0)+4>>2]=c[k+4>>2];sI(M,4,.0226,dc);h[k>>3]=.798315;c[ec>>2]=c[k>>2];c[ec+4>>2]=c[k+4>>2];h[k>>3]=-63.8721;c[(ec+8|0)>>2]=c[k>>2];c[(ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224831.0e-9;c[(ec+16|0)>>2]=c[k>>2];c[(ec+16|0)+4>>2]=c[k+4>>2];sI(N,4,.0227,ec);h[k>>3]=.802863;c[fc>>2]=c[k>>2];c[fc+4>>2]=c[k+4>>2];h[k>>3]=-64.3256;c[(fc+8|0)>>2]=c[k>>2];c[(fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224728.0e-9;c[(fc+16|0)>>2]=c[k>>2];c[(fc+16|0)+4>>2]=c[k+4>>2];sI(O,4,.0228,fc);h[k>>3]=.80737;c[gc>>2]=c[k>>2];c[gc+4>>2]=c[k+4>>2];h[k>>3]=-64.7356;c[(gc+8|0)>>2]=c[k>>2];c[(gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224637.0e-9;c[(gc+16|0)>>2]=c[k>>2];c[(gc+16|0)+4>>2]=c[k+4>>2];sI(P,4,.0229,gc);h[k>>3]=.811833;c[hc>>2]=c[k>>2];c[hc+4>>2]=c[k+4>>2];h[k>>3]=-65.1406;c[(hc+8|0)>>2]=c[k>>2];c[(hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224555.0e-9;c[(hc+16|0)>>2]=c[k>>2];c[(hc+16|0)+4>>2]=c[k+4>>2];sI(Q,4,.023,hc);h[k>>3]=.816247;c[ic>>2]=c[k>>2];c[ic+4>>2]=c[k+4>>2];h[k>>3]=-65.541;c[(ic+8|0)>>2]=c[k>>2];c[(ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224477.0e-9;c[(ic+16|0)>>2]=c[k>>2];c[(ic+16|0)+4>>2]=c[k+4>>2];sI(R,4,.0231,ic);h[k>>3]=.820611;c[jc>>2]=c[k>>2];c[jc+4>>2]=c[k+4>>2];h[k>>3]=-65.9369;c[(jc+8|0)>>2]=c[k>>2];c[(jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224399.0e-9;c[(jc+16|0)>>2]=c[k>>2];c[(jc+16|0)+4>>2]=c[k+4>>2];sI(S,4,.0232,jc);h[k>>3]=.824909;c[kc>>2]=c[k>>2];c[kc+4>>2]=c[k+4>>2];h[k>>3]=-66.3269;c[(kc+8|0)>>2]=c[k>>2];c[(kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224322.0e-9;c[(kc+16|0)>>2]=c[k>>2];c[(kc+16|0)+4>>2]=c[k+4>>2];sI(T,4,.0233,kc);h[k>>3]=.829106;c[lc>>2]=c[k>>2];c[lc+4>>2]=c[k+4>>2];h[k>>3]=-66.7079;c[(lc+8|0)>>2]=c[k>>2];c[(lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224246.0e-9;c[(lc+16|0)>>2]=c[k>>2];c[(lc+16|0)+4>>2]=c[k+4>>2];sI(U,4,.0234,lc);h[k>>3]=.833258;c[mc>>2]=c[k>>2];c[mc+4>>2]=c[k+4>>2];h[k>>3]=-67.0845;c[(mc+8|0)>>2]=c[k>>2];c[(mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224172.0e-9;c[(mc+16|0)>>2]=c[k>>2];c[(mc+16|0)+4>>2]=c[k+4>>2];sI(V,4,.0235,mc);h[k>>3]=.837362;c[nc>>2]=c[k>>2];c[nc+4>>2]=c[k+4>>2];h[k>>3]=-67.457;c[(nc+8|0)>>2]=c[k>>2];c[(nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224099.0e-9;c[(nc+16|0)>>2]=c[k>>2];c[(nc+16|0)+4>>2]=c[k+4>>2];sI(W,4,.0236,nc);h[k>>3]=.84142;c[oc>>2]=c[k>>2];c[oc+4>>2]=c[k+4>>2];h[k>>3]=-67.8252;c[(oc+8|0)>>2]=c[k>>2];c[(oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=224027.0e-9;c[(oc+16|0)>>2]=c[k>>2];c[(oc+16|0)+4>>2]=c[k+4>>2];sI(X,4,.0237,oc);h[k>>3]=.845433;c[pc>>2]=c[k>>2];c[pc+4>>2]=c[k+4>>2];h[k>>3]=-68.1893;c[(pc+8|0)>>2]=c[k>>2];c[(pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223957.0e-9;c[(pc+16|0)>>2]=c[k>>2];c[(pc+16|0)+4>>2]=c[k+4>>2];sI(Y,4,.0238,pc);h[k>>3]=.8494;c[qc>>2]=c[k>>2];c[qc+4>>2]=c[k+4>>2];h[k>>3]=-68.5494;c[(qc+8|0)>>2]=c[k>>2];c[(qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223887.0e-9;c[(qc+16|0)>>2]=c[k>>2];c[(qc+16|0)+4>>2]=c[k+4>>2];sI(Z,4,.0239,qc);h[k>>3]=.853323;c[rc>>2]=c[k>>2];c[rc+4>>2]=c[k+4>>2];h[k>>3]=-68.9053;c[(rc+8|0)>>2]=c[k>>2];c[(rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223818.0e-9;c[(rc+16|0)>>2]=c[k>>2];c[(rc+16|0)+4>>2]=c[k+4>>2];sI(_,4,.024,rc);h[k>>3]=.857201;c[sc>>2]=c[k>>2];c[sc+4>>2]=c[k+4>>2];h[k>>3]=-69.2573;c[(sc+8|0)>>2]=c[k>>2];c[(sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22375.0e-8;c[(sc+16|0)>>2]=c[k>>2];c[(sc+16|0)+4>>2]=c[k+4>>2];sI($,4,.0241,sc);h[k>>3]=.861036;c[tc>>2]=c[k>>2];c[tc+4>>2]=c[k+4>>2];h[k>>3]=-69.6053;c[(tc+8|0)>>2]=c[k>>2];c[(tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223683.0e-9;c[(tc+16|0)>>2]=c[k>>2];c[(tc+16|0)+4>>2]=c[k+4>>2];sI(aa,4,.0242,tc);h[k>>3]=.864828;c[uc>>2]=c[k>>2];c[uc+4>>2]=c[k+4>>2];h[k>>3]=-69.9494;c[(uc+8|0)>>2]=c[k>>2];c[(uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223617.0e-9;c[(uc+16|0)>>2]=c[k>>2];c[(uc+16|0)+4>>2]=c[k+4>>2];sI(ba,4,.0243,uc);h[k>>3]=.868577;c[vc>>2]=c[k>>2];c[vc+4>>2]=c[k+4>>2];h[k>>3]=-70.2896;c[(vc+8|0)>>2]=c[k>>2];c[(vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223552.0e-9;c[(vc+16|0)>>2]=c[k>>2];c[(vc+16|0)+4>>2]=c[k+4>>2];sI(ca,4,.0244,vc);h[k>>3]=.873541;c[wc>>2]=c[k>>2];c[wc+4>>2]=c[k+4>>2];h[k>>3]=-70.7381;c[(wc+8|0)>>2]=c[k>>2];c[(wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223484.0e-9;c[(wc+16|0)>>2]=c[k>>2];c[(wc+16|0)+4>>2]=c[k+4>>2];sI(da,4,.0245,wc);h[k>>3]=.878506;c[xc>>2]=c[k>>2];c[xc+4>>2]=c[k+4>>2];h[k>>3]=-71.1879;c[(xc+8|0)>>2]=c[k>>2];c[(xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223404.0e-9;c[(xc+16|0)>>2]=c[k>>2];c[(xc+16|0)+4>>2]=c[k+4>>2];sI(ea,4,.0246,xc);h[k>>3]=.883389;c[yc>>2]=c[k>>2];c[yc+4>>2]=c[k+4>>2];h[k>>3]=-71.6312;c[(yc+8|0)>>2]=c[k>>2];c[(yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22332.0e-8;c[(yc+16|0)>>2]=c[k>>2];c[(yc+16|0)+4>>2]=c[k+4>>2];sI(fa,4,.0247,yc);h[k>>3]=.888198;c[zc>>2]=c[k>>2];c[zc+4>>2]=c[k+4>>2];h[k>>3]=-72.0678;c[(zc+8|0)>>2]=c[k>>2];c[(zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223236.0e-9;c[(zc+16|0)>>2]=c[k>>2];c[(zc+16|0)+4>>2]=c[k+4>>2];sI(ga,4,.0248,zc);h[k>>3]=.892935;c[Ac>>2]=c[k>>2];c[Ac+4>>2]=c[k+4>>2];h[k>>3]=-72.4978;c[(Ac+8|0)>>2]=c[k>>2];c[(Ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223154.0e-9;c[(Ac+16|0)>>2]=c[k>>2];c[(Ac+16|0)+4>>2]=c[k+4>>2];sI(ha,4,.0249,Ac);h[k>>3]=.8976;c[Bc>>2]=c[k>>2];c[Bc+4>>2]=c[k+4>>2];h[k>>3]=-72.9212;c[(Bc+8|0)>>2]=c[k>>2];c[(Bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223074.0e-9;c[(Bc+16|0)>>2]=c[k>>2];c[(Bc+16|0)+4>>2]=c[k+4>>2];sI(ia,4,.025,Bc);h[k>>3]=.902194;c[Cc>>2]=c[k>>2];c[Cc+4>>2]=c[k+4>>2];h[k>>3]=-73.2832;c[(Cc+8|0)>>2]=c[k>>2];c[(Cc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222997.0e-9;c[(Cc+16|0)>>2]=c[k>>2];c[(Cc+16|0)+4>>2]=c[k+4>>2];sI(ja,4,.0251,Cc);h[k>>3]=.906729;c[Dc>>2]=c[k>>2];c[Dc+4>>2]=c[k+4>>2];h[k>>3]=-73.5797;c[(Dc+8|0)>>2]=c[k>>2];c[(Dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22293.0e-8;c[(Dc+16|0)>>2]=c[k>>2];c[(Dc+16|0)+4>>2]=c[k+4>>2];sI(ka,4,.0252,Dc);h[k>>3]=.911203;c[Ec>>2]=c[k>>2];c[Ec+4>>2]=c[k+4>>2];h[k>>3]=-73.8711;c[(Ec+8|0)>>2]=c[k>>2];c[(Ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222873.0e-9;c[(Ec+16|0)>>2]=c[k>>2];c[(Ec+16|0)+4>>2]=c[k+4>>2];sI(la,4,.0253,Ec);h[k>>3]=.915611;c[Fc>>2]=c[k>>2];c[Fc+4>>2]=c[k+4>>2];h[k>>3]=-74.1579;c[(Fc+8|0)>>2]=c[k>>2];c[(Fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22282.0e-8;c[(Fc+16|0)>>2]=c[k>>2];c[(Fc+16|0)+4>>2]=c[k+4>>2];sI(ma,4,.0254,Fc);h[k>>3]=.919953;c[Gc>>2]=c[k>>2];c[Gc+4>>2]=c[k+4>>2];h[k>>3]=-74.4404;c[(Gc+8|0)>>2]=c[k>>2];c[(Gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222768.0e-9;c[(Gc+16|0)>>2]=c[k>>2];c[(Gc+16|0)+4>>2]=c[k+4>>2];sI(na,4,.0255,Gc);h[k>>3]=.924227;c[Hc>>2]=c[k>>2];c[Hc+4>>2]=c[k+4>>2];h[k>>3]=-74.7185;c[(Hc+8|0)>>2]=c[k>>2];c[(Hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222716.0e-9;c[(Hc+16|0)>>2]=c[k>>2];c[(Hc+16|0)+4>>2]=c[k+4>>2];sI(oa,4,.0256,Hc);h[k>>3]=.928436;c[Ic>>2]=c[k>>2];c[Ic+4>>2]=c[k+4>>2];h[k>>3]=-74.9923;c[(Ic+8|0)>>2]=c[k>>2];c[(Ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222665.0e-9;c[(Ic+16|0)>>2]=c[k>>2];c[(Ic+16|0)+4>>2]=c[k+4>>2];sI(pa,4,.0257,Ic);h[k>>3]=.932872;c[Jc>>2]=c[k>>2];c[Jc+4>>2]=c[k+4>>2];h[k>>3]=-75.2805;c[(Jc+8|0)>>2]=c[k>>2];c[(Jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222615.0e-9;c[(Jc+16|0)>>2]=c[k>>2];c[(Jc+16|0)+4>>2]=c[k+4>>2];sI(qa,4,.0258,Jc);h[k>>3]=.937419;c[Kc>>2]=c[k>>2];c[Kc+4>>2]=c[k+4>>2];h[k>>3]=-75.5759;c[(Kc+8|0)>>2]=c[k>>2];c[(Kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222563.0e-9;c[(Kc+16|0)>>2]=c[k>>2];c[(Kc+16|0)+4>>2]=c[k+4>>2];sI(ra,4,.0259,Kc);h[k>>3]=.941886;c[Lc>>2]=c[k>>2];c[Lc+4>>2]=c[k+4>>2];h[k>>3]=-75.8664;c[(Lc+8|0)>>2]=c[k>>2];c[(Lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222509.0e-9;c[(Lc+16|0)>>2]=c[k>>2];c[(Lc+16|0)+4>>2]=c[k+4>>2];sI(sa,4,.026,Lc);h[k>>3]=.946276;c[Mc>>2]=c[k>>2];c[Mc+4>>2]=c[k+4>>2];h[k>>3]=-76.1519;c[(Mc+8|0)>>2]=c[k>>2];c[(Mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222456.0e-9;c[(Mc+16|0)>>2]=c[k>>2];c[(Mc+16|0)+4>>2]=c[k+4>>2];sI(ta,4,.0261,Mc);h[k>>3]=.950592;c[Nc>>2]=c[k>>2];c[Nc+4>>2]=c[k+4>>2];h[k>>3]=-76.4326;c[(Nc+8|0)>>2]=c[k>>2];c[(Nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222404.0e-9;c[(Nc+16|0)>>2]=c[k>>2];c[(Nc+16|0)+4>>2]=c[k+4>>2];sI(ua,4,.0262,Nc);h[k>>3]=.954834;c[Oc>>2]=c[k>>2];c[Oc+4>>2]=c[k+4>>2];h[k>>3]=-76.7084;c[(Oc+8|0)>>2]=c[k>>2];c[(Oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222354.0e-9;c[(Oc+16|0)>>2]=c[k>>2];c[(Oc+16|0)+4>>2]=c[k+4>>2];sI(va,4,.0263,Oc);h[k>>3]=.959005;c[Pc>>2]=c[k>>2];c[Pc+4>>2]=c[k+4>>2];h[k>>3]=-76.9795;c[(Pc+8|0)>>2]=c[k>>2];c[(Pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222304.0e-9;c[(Pc+16|0)>>2]=c[k>>2];c[(Pc+16|0)+4>>2]=c[k+4>>2];sI(wa,4,.0264,Pc);h[k>>3]=.963104;c[Qc>>2]=c[k>>2];c[Qc+4>>2]=c[k+4>>2];h[k>>3]=-77.246;c[(Qc+8|0)>>2]=c[k>>2];c[(Qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222255.0e-9;c[(Qc+16|0)>>2]=c[k>>2];c[(Qc+16|0)+4>>2]=c[k+4>>2];sI(xa,4,.0265,Qc);h[k>>3]=.967134;c[Rc>>2]=c[k>>2];c[Rc+4>>2]=c[k+4>>2];h[k>>3]=-77.5079;c[(Rc+8|0)>>2]=c[k>>2];c[(Rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222207.0e-9;c[(Rc+16|0)>>2]=c[k>>2];c[(Rc+16|0)+4>>2]=c[k+4>>2];sI(ya,4,.0266,Rc);h[k>>3]=.971094;c[Sc>>2]=c[k>>2];c[Sc+4>>2]=c[k+4>>2];h[k>>3]=-77.7654;c[(Sc+8|0)>>2]=c[k>>2];c[(Sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22216.0e-8;c[(Sc+16|0)>>2]=c[k>>2];c[(Sc+16|0)+4>>2]=c[k+4>>2];sI(za,4,.0267,Sc);h[k>>3]=.974988;c[Tc>>2]=c[k>>2];c[Tc+4>>2]=c[k+4>>2];h[k>>3]=-78.0184;c[(Tc+8|0)>>2]=c[k>>2];c[(Tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222114.0e-9;c[(Tc+16|0)>>2]=c[k>>2];c[(Tc+16|0)+4>>2]=c[k+4>>2];sI(Aa,4,.0268,Tc);h[k>>3]=.978815;c[Uc>>2]=c[k>>2];c[Uc+4>>2]=c[k+4>>2];h[k>>3]=-78.2671;c[(Uc+8|0)>>2]=c[k>>2];c[(Uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222068.0e-9;c[(Uc+16|0)>>2]=c[k>>2];c[(Uc+16|0)+4>>2]=c[k+4>>2];sI(Ba,4,.0269,Uc);h[k>>3]=.982577;c[Vc>>2]=c[k>>2];c[Vc+4>>2]=c[k+4>>2];h[k>>3]=-78.5115;c[(Vc+8|0)>>2]=c[k>>2];c[(Vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=222024.0e-9;c[(Vc+16|0)>>2]=c[k>>2];c[(Vc+16|0)+4>>2]=c[k+4>>2];sI(Ca,4,.027,Vc);h[k>>3]=.986275;c[Wc>>2]=c[k>>2];c[Wc+4>>2]=c[k+4>>2];h[k>>3]=-78.7518;c[(Wc+8|0)>>2]=c[k>>2];c[(Wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22198.0e-8;c[(Wc+16|0)>>2]=c[k>>2];c[(Wc+16|0)+4>>2]=c[k+4>>2];sI(Da,4,.0271,Wc);h[k>>3]=.98991;c[Xc>>2]=c[k>>2];c[Xc+4>>2]=c[k+4>>2];h[k>>3]=-78.9879;c[(Xc+8|0)>>2]=c[k>>2];c[(Xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221937.0e-9;c[(Xc+16|0)>>2]=c[k>>2];c[(Xc+16|0)+4>>2]=c[k+4>>2];sI(Ea,4,.0272,Xc);h[k>>3]=.993484;c[Yc>>2]=c[k>>2];c[Yc+4>>2]=c[k+4>>2];h[k>>3]=-79.2201;c[(Yc+8|0)>>2]=c[k>>2];c[(Yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221895.0e-9;c[(Yc+16|0)>>2]=c[k>>2];c[(Yc+16|0)+4>>2]=c[k+4>>2];sI(Fa,4,.0273,Yc);h[k>>3]=.996996;c[Zc>>2]=c[k>>2];c[Zc+4>>2]=c[k+4>>2];h[k>>3]=-79.4482;c[(Zc+8|0)>>2]=c[k>>2];c[(Zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221854.0e-9;c[(Zc+16|0)>>2]=c[k>>2];c[(Zc+16|0)+4>>2]=c[k+4>>2];sI(Ga,4,.0274,Zc);h[k>>3]=1.00082;c[_c>>2]=c[k>>2];c[_c+4>>2]=c[k+4>>2];h[k>>3]=-79.6845;c[(_c+8|0)>>2]=c[k>>2];c[(_c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221813.0e-9;c[(_c+16|0)>>2]=c[k>>2];c[(_c+16|0)+4>>2]=c[k+4>>2];sI(Ha,4,.0275,_c);h[k>>3]=1.00486;c[$c>>2]=c[k>>2];c[$c+4>>2]=c[k+4>>2];h[k>>3]=-79.8903;c[($c+8|0)>>2]=c[k>>2];c[($c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221773.0e-9;c[($c+16|0)>>2]=c[k>>2];c[($c+16|0)+4>>2]=c[k+4>>2];sI(Ia,4,.0276,$c);h[k>>3]=1.00883;c[ad>>2]=c[k>>2];c[ad+4>>2]=c[k+4>>2];h[k>>3]=-80.0919;c[(ad+8|0)>>2]=c[k>>2];c[(ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221735.0e-9;c[(ad+16|0)>>2]=c[k>>2];c[(ad+16|0)+4>>2]=c[k+4>>2];sI(Ja,4,.0277,ad);h[k>>3]=1.01272;c[bd>>2]=c[k>>2];c[bd+4>>2]=c[k+4>>2];h[k>>3]=-80.2892;c[(bd+8|0)>>2]=c[k>>2];c[(bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221699.0e-9;c[(bd+16|0)>>2]=c[k>>2];c[(bd+16|0)+4>>2]=c[k+4>>2];sI(Ka,4,.0278,bd);h[k>>3]=1.01653;c[cd>>2]=c[k>>2];c[cd+4>>2]=c[k+4>>2];h[k>>3]=-80.4824;c[(cd+8|0)>>2]=c[k>>2];c[(cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221665.0e-9;c[(cd+16|0)>>2]=c[k>>2];c[(cd+16|0)+4>>2]=c[k+4>>2];sI(La,4,.0279,cd);h[k>>3]=1.02026;c[dd>>2]=c[k>>2];c[dd+4>>2]=c[k+4>>2];h[k>>3]=-80.6717;c[(dd+8|0)>>2]=c[k>>2];c[(dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221631.0e-9;c[(dd+16|0)>>2]=c[k>>2];c[(dd+16|0)+4>>2]=c[k+4>>2];sI(Ma,4,.028,dd);h[k>>3]=1.02392;c[ed>>2]=c[k>>2];c[ed+4>>2]=c[k+4>>2];h[k>>3]=-80.8572;c[(ed+8|0)>>2]=c[k>>2];c[(ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221597.0e-9;c[(ed+16|0)>>2]=c[k>>2];c[(ed+16|0)+4>>2]=c[k+4>>2];sI(Na,4,.0281,ed);h[k>>3]=1.0275;c[fd>>2]=c[k>>2];c[fd+4>>2]=c[k+4>>2];h[k>>3]=-81.0389;c[(fd+8|0)>>2]=c[k>>2];c[(fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221565.0e-9;c[(fd+16|0)>>2]=c[k>>2];c[(fd+16|0)+4>>2]=c[k+4>>2];sI(Oa,4,.0282,fd);h[k>>3]=1.03101;c[gd>>2]=c[k>>2];c[gd+4>>2]=c[k+4>>2];h[k>>3]=-81.2168;c[(gd+8|0)>>2]=c[k>>2];c[(gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221533.0e-9;c[(gd+16|0)>>2]=c[k>>2];c[(gd+16|0)+4>>2]=c[k+4>>2];sI(Pa,4,.0283,gd);h[k>>3]=1.03445;c[hd>>2]=c[k>>2];c[hd+4>>2]=c[k+4>>2];h[k>>3]=-81.3911;c[(hd+8|0)>>2]=c[k>>2];c[(hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221501.0e-9;c[(hd+16|0)>>2]=c[k>>2];c[(hd+16|0)+4>>2]=c[k+4>>2];sI(Qa,4,.0284,hd);h[k>>3]=1.03781;c[id>>2]=c[k>>2];c[id+4>>2]=c[k+4>>2];h[k>>3]=-81.5619;c[(id+8|0)>>2]=c[k>>2];c[(id+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221471.0e-9;c[(id+16|0)>>2]=c[k>>2];c[(id+16|0)+4>>2]=c[k+4>>2];sI(Ra,4,.0285,id);h[k>>3]=1.04111;c[jd>>2]=c[k>>2];c[jd+4>>2]=c[k+4>>2];h[k>>3]=-81.7292;c[(jd+8|0)>>2]=c[k>>2];c[(jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221441.0e-9;c[(jd+16|0)>>2]=c[k>>2];c[(jd+16|0)+4>>2]=c[k+4>>2];sI(Sa,4,.0286,jd);h[k>>3]=1.04434;c[kd>>2]=c[k>>2];c[kd+4>>2]=c[k+4>>2];h[k>>3]=-81.893;c[(kd+8|0)>>2]=c[k>>2];c[(kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221412.0e-9;c[(kd+16|0)>>2]=c[k>>2];c[(kd+16|0)+4>>2]=c[k+4>>2];sI(Ta,4,.0287,kd);h[k>>3]=1.04751;c[ld>>2]=c[k>>2];c[ld+4>>2]=c[k+4>>2];h[k>>3]=-82.0535;c[(ld+8|0)>>2]=c[k>>2];c[(ld+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221383.0e-9;c[(ld+16|0)>>2]=c[k>>2];c[(ld+16|0)+4>>2]=c[k+4>>2];sI(Ua,4,.0288,ld);h[k>>3]=1.05061;c[md>>2]=c[k>>2];c[md+4>>2]=c[k+4>>2];h[k>>3]=-82.2107;c[(md+8|0)>>2]=c[k>>2];c[(md+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221355.0e-9;c[(md+16|0)>>2]=c[k>>2];c[(md+16|0)+4>>2]=c[k+4>>2];sI(Va,4,.0289,md);h[k>>3]=1.05365;c[nd>>2]=c[k>>2];c[nd+4>>2]=c[k+4>>2];h[k>>3]=-82.3647;c[(nd+8|0)>>2]=c[k>>2];c[(nd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221328.0e-9;c[(nd+16|0)>>2]=c[k>>2];c[(nd+16|0)+4>>2]=c[k+4>>2];sI(Wa,4,.029,nd);h[k>>3]=1.05663;c[od>>2]=c[k>>2];c[od+4>>2]=c[k+4>>2];h[k>>3]=-82.5155;c[(od+8|0)>>2]=c[k>>2];c[(od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221301.0e-9;c[(od+16|0)>>2]=c[k>>2];c[(od+16|0)+4>>2]=c[k+4>>2];sI(Xa,4,.0291,od);h[k>>3]=1.05954;c[pd>>2]=c[k>>2];c[pd+4>>2]=c[k+4>>2];h[k>>3]=-82.6633;c[(pd+8|0)>>2]=c[k>>2];c[(pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221275.0e-9;c[(pd+16|0)>>2]=c[k>>2];c[(pd+16|0)+4>>2]=c[k+4>>2];sI(Ya,4,.0292,pd);h[k>>3]=1.0624;c[qd>>2]=c[k>>2];c[qd+4>>2]=c[k+4>>2];h[k>>3]=-82.808;c[(qd+8|0)>>2]=c[k>>2];c[(qd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221249.0e-9;c[(qd+16|0)>>2]=c[k>>2];c[(qd+16|0)+4>>2]=c[k+4>>2];sI(Za,4,.0293,qd);h[k>>3]=1.0652;c[rd>>2]=c[k>>2];c[rd+4>>2]=c[k+4>>2];h[k>>3]=-82.9498;c[(rd+8|0)>>2]=c[k>>2];c[(rd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221224.0e-9;c[(rd+16|0)>>2]=c[k>>2];c[(rd+16|0)+4>>2]=c[k+4>>2];sI(_a,4,.0294,rd);h[k>>3]=1.06794;c[sd>>2]=c[k>>2];c[sd+4>>2]=c[k+4>>2];h[k>>3]=-83.0887;c[(sd+8|0)>>2]=c[k>>2];c[(sd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221199.0e-9;c[(sd+16|0)>>2]=c[k>>2];c[(sd+16|0)+4>>2]=c[k+4>>2];sI($a,4,.0295,sd);h[k>>3]=1.07063;c[td>>2]=c[k>>2];c[td+4>>2]=c[k+4>>2];h[k>>3]=-83.2248;c[(td+8|0)>>2]=c[k>>2];c[(td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221175.0e-9;c[(td+16|0)>>2]=c[k>>2];c[(td+16|0)+4>>2]=c[k+4>>2];sI(ab,4,.0296,td);h[k>>3]=1.07326;c[ud>>2]=c[k>>2];c[ud+4>>2]=c[k+4>>2];h[k>>3]=-83.3581;c[(ud+8|0)>>2]=c[k>>2];c[(ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221151.0e-9;c[(ud+16|0)>>2]=c[k>>2];c[(ud+16|0)+4>>2]=c[k+4>>2];sI(bb,4,.0297,ud);h[k>>3]=1.07584;c[vd>>2]=c[k>>2];c[vd+4>>2]=c[k+4>>2];h[k>>3]=-83.4886;c[(vd+8|0)>>2]=c[k>>2];c[(vd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221128.0e-9;c[(vd+16|0)>>2]=c[k>>2];c[(vd+16|0)+4>>2]=c[k+4>>2];sI(cb,4,.0298,vd);h[k>>3]=1.07836;c[wd>>2]=c[k>>2];c[wd+4>>2]=c[k+4>>2];h[k>>3]=-83.6165;c[(wd+8|0)>>2]=c[k>>2];c[(wd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221106.0e-9;c[(wd+16|0)>>2]=c[k>>2];c[(wd+16|0)+4>>2]=c[k+4>>2];sI(db,4,.0299,wd);h[k>>3]=1.08088;c[xd>>2]=c[k>>2];c[xd+4>>2]=c[k+4>>2];h[k>>3]=-83.7439;c[(xd+8|0)>>2]=c[k>>2];c[(xd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221083.0e-9;c[(xd+16|0)>>2]=c[k>>2];c[(xd+16|0)+4>>2]=c[k+4>>2];sI(eb,4,.03,xd);h[k>>3]=1.08376;c[yd>>2]=c[k>>2];c[yd+4>>2]=c[k+4>>2];h[k>>3]=-83.8895;c[(yd+8|0)>>2]=c[k>>2];c[(yd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221061.0e-9;c[(yd+16|0)>>2]=c[k>>2];c[(yd+16|0)+4>>2]=c[k+4>>2];sI(fb,4,.0301,yd);h[k>>3]=1.08657;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=-84.0316;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221037.0e-9;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];sI(gb,4,.0302,zd);h[k>>3]=1.08931;c[Ad>>2]=c[k>>2];c[Ad+4>>2]=c[k+4>>2];h[k>>3]=-84.1703;c[(Ad+8|0)>>2]=c[k>>2];c[(Ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=221012.0e-9;c[(Ad+16|0)>>2]=c[k>>2];c[(Ad+16|0)+4>>2]=c[k+4>>2];sI(hb,4,.0303,Ad);h[k>>3]=1.09198;c[Bd>>2]=c[k>>2];c[Bd+4>>2]=c[k+4>>2];h[k>>3]=-84.3057;c[(Bd+8|0)>>2]=c[k>>2];c[(Bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220988.0e-9;c[(Bd+16|0)>>2]=c[k>>2];c[(Bd+16|0)+4>>2]=c[k+4>>2];sI(ib,4,.0304,Bd);h[k>>3]=1.09459;c[Cd>>2]=c[k>>2];c[Cd+4>>2]=c[k+4>>2];h[k>>3]=-84.4378;c[(Cd+8|0)>>2]=c[k>>2];c[(Cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220965.0e-9;c[(Cd+16|0)>>2]=c[k>>2];c[(Cd+16|0)+4>>2]=c[k+4>>2];sI(jb,4,.0305,Cd);h[k>>3]=1.09714;c[Dd>>2]=c[k>>2];c[Dd+4>>2]=c[k+4>>2];h[k>>3]=-84.5667;c[(Dd+8|0)>>2]=c[k>>2];c[(Dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220942.0e-9;c[(Dd+16|0)>>2]=c[k>>2];c[(Dd+16|0)+4>>2]=c[k+4>>2];sI(kb,4,.0306,Dd);h[k>>3]=1.09962;c[Ed>>2]=c[k>>2];c[Ed+4>>2]=c[k+4>>2];h[k>>3]=-84.6924;c[(Ed+8|0)>>2]=c[k>>2];c[(Ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22092.0e-8;c[(Ed+16|0)>>2]=c[k>>2];c[(Ed+16|0)+4>>2]=c[k+4>>2];sI(lb,4,.0307,Ed);h[k>>3]=1.10205;c[Fd>>2]=c[k>>2];c[Fd+4>>2]=c[k+4>>2];h[k>>3]=-84.7987;c[(Fd+8|0)>>2]=c[k>>2];c[(Fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220899.0e-9;c[(Fd+16|0)>>2]=c[k>>2];c[(Fd+16|0)+4>>2]=c[k+4>>2];sI(mb,4,.0308,Fd);h[k>>3]=1.10442;c[Gd>>2]=c[k>>2];c[Gd+4>>2]=c[k+4>>2];h[k>>3]=-84.8994;c[(Gd+8|0)>>2]=c[k>>2];c[(Gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=22088.0e-8;c[(Gd+16|0)>>2]=c[k>>2];c[(Gd+16|0)+4>>2]=c[k+4>>2];sI(nb,4,.0309,Gd);h[k>>3]=1.10673;c[Hd>>2]=c[k>>2];c[Hd+4>>2]=c[k+4>>2];h[k>>3]=-84.9975;c[(Hd+8|0)>>2]=c[k>>2];c[(Hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220862.0e-9;c[(Hd+16|0)>>2]=c[k>>2];c[(Hd+16|0)+4>>2]=c[k+4>>2];sI(ob,4,.031,Hd);h[k>>3]=1.10898;c[Id>>2]=c[k>>2];c[Id+4>>2]=c[k+4>>2];h[k>>3]=-85.0932;c[(Id+8|0)>>2]=c[k>>2];c[(Id+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220846.0e-9;c[(Id+16|0)>>2]=c[k>>2];c[(Id+16|0)+4>>2]=c[k+4>>2];sI(pb,4,.0311,Id);h[k>>3]=1.11119;c[Jd>>2]=c[k>>2];c[Jd+4>>2]=c[k+4>>2];h[k>>3]=-85.1866;c[(Jd+8|0)>>2]=c[k>>2];c[(Jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220829.0e-9;c[(Jd+16|0)>>2]=c[k>>2];c[(Jd+16|0)+4>>2]=c[k+4>>2];sI(qb,4,.0312,Jd);h[k>>3]=1.11333;c[Kd>>2]=c[k>>2];c[Kd+4>>2]=c[k+4>>2];h[k>>3]=-85.2778;c[(Kd+8|0)>>2]=c[k>>2];c[(Kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220813.0e-9;c[(Kd+16|0)>>2]=c[k>>2];c[(Kd+16|0)+4>>2]=c[k+4>>2];sI(rb,4,.0313,Kd);h[k>>3]=1.11543;c[Ld>>2]=c[k>>2];c[Ld+4>>2]=c[k+4>>2];h[k>>3]=-85.3668;c[(Ld+8|0)>>2]=c[k>>2];c[(Ld+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220798.0e-9;c[(Ld+16|0)>>2]=c[k>>2];c[(Ld+16|0)+4>>2]=c[k+4>>2];sI(sb,4,.0314,Ld);h[k>>3]=1.11748;c[Md>>2]=c[k>>2];c[Md+4>>2]=c[k+4>>2];h[k>>3]=-85.4536;c[(Md+8|0)>>2]=c[k>>2];c[(Md+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220782.0e-9;c[(Md+16|0)>>2]=c[k>>2];c[(Md+16|0)+4>>2]=c[k+4>>2];sI(tb,4,.0315,Md);h[k>>3]=1.11947;c[Nd>>2]=c[k>>2];c[Nd+4>>2]=c[k+4>>2];h[k>>3]=-85.5382;c[(Nd+8|0)>>2]=c[k>>2];c[(Nd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220768.0e-9;c[(Nd+16|0)>>2]=c[k>>2];c[(Nd+16|0)+4>>2]=c[k+4>>2];sI(ub,4,.0316,Nd);h[k>>3]=1.12142;c[Od>>2]=c[k>>2];c[Od+4>>2]=c[k+4>>2];h[k>>3]=-85.6209;c[(Od+8|0)>>2]=c[k>>2];c[(Od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220753.0e-9;c[(Od+16|0)>>2]=c[k>>2];c[(Od+16|0)+4>>2]=c[k+4>>2];sI(vb,4,.0317,Od);h[k>>3]=1.12332;c[Pd>>2]=c[k>>2];c[Pd+4>>2]=c[k+4>>2];h[k>>3]=-85.7015;c[(Pd+8|0)>>2]=c[k>>2];c[(Pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220739.0e-9;c[(Pd+16|0)>>2]=c[k>>2];c[(Pd+16|0)+4>>2]=c[k+4>>2];sI(wb,4,.0318,Pd);h[k>>3]=1.12518;c[Qd>>2]=c[k>>2];c[Qd+4>>2]=c[k+4>>2];h[k>>3]=-85.7802;c[(Qd+8|0)>>2]=c[k>>2]}function _Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0;b=c[a+776>>2]|0;d=c[a+784>>2]|0;e=c[a+792>>2]|0;f=c[a+800>>2]|0;g=c[a+808>>2]|0;i=c[a+816>>2]|0;j=c[a+824>>2]|0;l=c[a+832>>2]|0;m=c[a+840>>2]|0;n=c[a+848>>2]|0;o=c[a+856>>2]|0;p=c[a+864>>2]|0;q=c[a+872>>2]|0;r=c[a+880>>2]|0;s=c[a+888>>2]|0;t=c[a+896>>2]|0;u=c[a+904>>2]|0;v=c[a+912>>2]|0;w=c[a+920>>2]|0;x=c[a+928>>2]|0;y=c[a+936>>2]|0;z=c[a+944>>2]|0;A=c[a+952>>2]|0;B=c[a+960>>2]|0;C=c[a+968>>2]|0;D=c[a+976>>2]|0;E=c[a+984>>2]|0;F=c[a+992>>2]|0;G=c[a+1e3>>2]|0;H=c[a+1008>>2]|0;I=c[a+1016>>2]|0;J=c[a+1024>>2]|0;K=c[a+1032>>2]|0;L=c[a+1040>>2]|0;M=c[a+1048>>2]|0;N=c[a+1056>>2]|0;O=c[a+1064>>2]|0;P=c[a+1072>>2]|0;Q=c[a+1080>>2]|0;R=c[a+1088>>2]|0;S=c[a+1096>>2]|0;T=c[a+1104>>2]|0;U=c[a+1112>>2]|0;V=c[a+1120>>2]|0;W=c[a+1128>>2]|0;X=c[a+1136>>2]|0;Y=c[a+1144>>2]|0;Z=c[a+1152>>2]|0;_=c[a+1160>>2]|0;$=c[a+1168>>2]|0;aa=c[a+1176>>2]|0;ba=c[a+1184>>2]|0;ca=c[a+1192>>2]|0;da=c[a+1200>>2]|0;ea=c[a+1208>>2]|0;fa=c[a+1216>>2]|0;ga=c[a+1224>>2]|0;ha=c[a+1232>>2]|0;ia=c[a+1240>>2]|0;ja=c[a+1248>>2]|0;ka=c[a+1256>>2]|0;la=c[a+1264>>2]|0;ma=c[a+1272>>2]|0;na=c[a+1280>>2]|0;oa=c[a+1288>>2]|0;pa=c[a+1296>>2]|0;qa=c[a+1304>>2]|0;ra=c[a+1312>>2]|0;sa=c[a+1320>>2]|0;ta=c[a+1328>>2]|0;ua=c[a+1336>>2]|0;va=c[a+1344>>2]|0;wa=c[a+1352>>2]|0;xa=c[a+1360>>2]|0;ya=c[a+1368>>2]|0;za=c[a+1376>>2]|0;Aa=c[a+1384>>2]|0;Ba=c[a+1392>>2]|0;Ca=c[a+1400>>2]|0;Da=c[a+1408>>2]|0;Ea=c[a+1416>>2]|0;Fa=c[a+1424>>2]|0;Ga=c[a+1432>>2]|0;Ha=c[a+1440>>2]|0;Ia=c[a+1448>>2]|0;Ja=c[a+1456>>2]|0;Ka=c[a+1464>>2]|0;La=c[a+1472>>2]|0;Ma=c[a+1480>>2]|0;Na=c[a+1488>>2]|0;Oa=c[a+1496>>2]|0;Pa=c[a+1504>>2]|0;Qa=c[a+1512>>2]|0;Ra=c[a+1520>>2]|0;Sa=c[a+1528>>2]|0;Ta=c[a+1536>>2]|0;Ua=c[a+1544>>2]|0;Va=c[a+1552>>2]|0;Wa=c[a+1560>>2]|0;Xa=c[a+1568>>2]|0;Ya=c[a+1576>>2]|0;Za=c[a+1584>>2]|0;_a=c[a+1592>>2]|0;$a=c[a+1600>>2]|0;ab=c[a+1608>>2]|0;bb=c[a+1616>>2]|0;cb=c[a+1624>>2]|0;db=c[a+1632>>2]|0;eb=c[a+1640>>2]|0;fb=c[a+1648>>2]|0;gb=c[a+1656>>2]|0;hb=c[a+1664>>2]|0;ib=c[a+1672>>2]|0;jb=c[a+1680>>2]|0;kb=c[a+1688>>2]|0;lb=c[a+1696>>2]|0;mb=c[a+1704>>2]|0;nb=c[a+1712>>2]|0;ob=c[a+1720>>2]|0;pb=c[a+1728>>2]|0;qb=c[a+1736>>2]|0;rb=c[a+1744>>2]|0;sb=c[a+1752>>2]|0;tb=c[a+1760>>2]|0;ub=c[a+1768>>2]|0;vb=c[a+1776>>2]|0;wb=c[a+1784>>2]|0;xb=c[a+1792>>2]|0;yb=c[a+1800>>2]|0;zb=c[a+1808>>2]|0;Ab=c[a+1816>>2]|0;Bb=c[a+1824>>2]|0;Cb=c[a+1832>>2]|0;Db=c[a+4344>>2]|0;Eb=c[a+4352>>2]|0;Fb=c[a+4360>>2]|0;Gb=c[a+4376>>2]|0;Hb=c[a+4384>>2]|0;Ib=c[a+4392>>2]|0;Jb=c[a+4400>>2]|0;Kb=c[a+4408>>2]|0;Lb=c[a+4416>>2]|0;Mb=c[a+4424>>2]|0;Nb=c[a+4432>>2]|0;Ob=c[a+4440>>2]|0;Pb=c[a+4448>>2]|0;Qb=c[a+4464>>2]|0;Rb=c[a+4472>>2]|0;Sb=c[a+4480>>2]|0;Tb=c[a+4488>>2]|0;Ub=c[a+4496>>2]|0;Vb=c[a+4504>>2]|0;Wb=c[a+4512>>2]|0;Xb=c[a+4520>>2]|0;Yb=c[a+4528>>2]|0;Zb=c[a+4536>>2]|0;_b=c[a+4552>>2]|0;$b=c[a+4560>>2]|0;ac=c[a+4568>>2]|0;bc=c[a+4576>>2]|0;cc=c[a+4584>>2]|0;dc=c[a+4592>>2]|0;ec=c[a+4600>>2]|0;fc=c[a+4608>>2]|0;gc=c[a+4616>>2]|0;hc=c[a+4624>>2]|0;ic=c[a+4648>>2]|0;jc=c[a+4656>>2]|0;kc=c[a+4664>>2]|0;lc=c[a+4672>>2]|0;mc=c[a+4680>>2]|0;nc=c[a+4688>>2]|0;oc=c[a+4696>>2]|0;pc=c[a+4704>>2]|0;qc=c[a+4712>>2]|0;rc=c[a+4720>>2]|0;sc=c[a+4736>>2]|0;tc=c[a+4744>>2]|0;uc=c[a+4752>>2]|0;vc=c[a+4760>>2]|0;wc=c[a+4768>>2]|0;xc=c[a+4776>>2]|0;yc=c[a+4784>>2]|0;zc=c[a+4792>>2]|0;Ac=c[a+4800>>2]|0;Bc=c[a+4808>>2]|0;Cc=c[a+4824>>2]|0;Dc=c[a+7880>>2]|0;Ec=c[a+7888>>2]|0;Fc=c[a+7896>>2]|0;Gc=c[a+7912>>2]|0;Hc=c[a+7920>>2]|0;Ic=c[a+7928>>2]|0;Jc=c[a+7936>>2]|0;Kc=c[a+7944>>2]|0;Lc=c[a+7952>>2]|0;Mc=c[a+7960>>2]|0;Nc=c[a+7968>>2]|0;Oc=c[a+7976>>2]|0;Pc=c[a+7984>>2]|0;Qc=c[a+8008>>2]|0;Rc=c[a+8016>>2]|0;Sc=c[a+8024>>2]|0;Tc=c[a+8032>>2]|0;Uc=c[a+8040>>2]|0;Vc=c[a+8048>>2]|0;Wc=c[a+8056>>2]|0;Xc=c[a+8064>>2]|0;Yc=c[a+8072>>2]|0;Zc=c[a+8080>>2]|0;_c=c[a+8096>>2]|0;$c=c[a+8104>>2]|0;ad=c[a+8112>>2]|0;bd=c[a+8120>>2]|0;cd=c[a+8128>>2]|0;dd=c[a+8136>>2]|0;ed=c[a+8144>>2]|0;fd=c[a+8152>>2]|0;gd=c[a+8160>>2]|0;hd=c[a+8168>>2]|0;id=c[a+8184>>2]|0;jd=c[a+8192>>2]|0;kd=c[a+8200>>2]|0;ld=c[a+8208>>2]|0;md=c[a+8216>>2]|0;nd=c[a+8224>>2]|0;od=c[a+8232>>2]|0;pd=c[a+8240>>2]|0;qd=c[a+8248>>2]|0;rd=c[a+8256>>2]|0;sd=c[a+8272>>2]|0;td=c[a+8280>>2]|0;ud=c[a+8288>>2]|0;vd=c[a+8296>>2]|0;wd=c[a+8304>>2]|0;xd=c[a+8312>>2]|0;yd=c[a+8320>>2]|0;zd=c[a+8328>>2]|0;Ad=c[a+8336>>2]|0;Bd=c[a+8344>>2]|0;Cd=c[a+8360>>2]|0;Dd=c[a+8368>>2]|0;Ed=c[a+8376>>2]|0;Fd=c[a+8384>>2]|0;Gd=c[a+8392>>2]|0;Hd=c[a+8400>>2]|0;Id=c[a+8408>>2]|0;Jd=c[a+8416>>2]|0;Kd=c[a+8424>>2]|0;Ld=c[a+8432>>2]|0;Md=c[a+8448>>2]|0;Nd=c[a+8456>>2]|0;Od=c[a+8464>>2]|0;Pd=c[a+8472>>2]|0;Qd=c[a+8480>>2]|0;Rd=c[a+8488>>2]|0;Sd=c[a+8496>>2]|0;Td=c[a+8504>>2]|0;Ud=c[a+8512>>2]|0;Vd=c[a+8520>>2]|0;Wd=c[a+8536>>2]|0;Xd=c[a+8544>>2]|0;Yd=c[a+8552>>2]|0;Zd=c[a+8560>>2]|0;_d=c[a+8568>>2]|0;$d=c[a+8576>>2]|0;ae=c[a+8584>>2]|0;c[(Dc+16|0)>>2]=c[k>>2];c[(Dc+16|0)+4>>2]=c[k+4>>2];sI(b,4,.0085,Dc);h[k>>3]=.93269;c[Ec>>2]=c[k>>2];c[Ec+4>>2]=c[k+4>>2];h[k>>3]=-3.20708;c[(Ec+8|0)>>2]=c[k>>2];c[(Ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00361952;c[(Ec+16|0)>>2]=c[k>>2];c[(Ec+16|0)+4>>2]=c[k+4>>2];sI(d,4,.0086,Ec);h[k>>3]=.931553;c[Fc>>2]=c[k>>2];c[Fc+4>>2]=c[k+4>>2];h[k>>3]=-3.25592;c[(Fc+8|0)>>2]=c[k>>2];c[(Fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00356812;c[(Fc+16|0)>>2]=c[k>>2];c[(Fc+16|0)+4>>2]=c[k+4>>2];sI(e,4,.0087,Fc);h[k>>3]=.930194;c[Gc>>2]=c[k>>2];c[Gc+4>>2]=c[k+4>>2];h[k>>3]=-3.30427;c[(Gc+8|0)>>2]=c[k>>2];c[(Gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00351548;c[(Gc+16|0)>>2]=c[k>>2];c[(Gc+16|0)+4>>2]=c[k+4>>2];sI(f,4,.0088,Gc);h[k>>3]=.928473;c[Hc>>2]=c[k>>2];c[Hc+4>>2]=c[k+4>>2];h[k>>3]=-3.35247;c[(Hc+8|0)>>2]=c[k>>2];c[(Hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00346157;c[(Hc+16|0)>>2]=c[k>>2];c[(Hc+16|0)+4>>2]=c[k+4>>2];sI(g,4,.0089,Hc);h[k>>3]=.926467;c[Ic>>2]=c[k>>2];c[Ic+4>>2]=c[k+4>>2];h[k>>3]=-3.40014;c[(Ic+8|0)>>2]=c[k>>2];c[(Ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00340636;c[(Ic+16|0)>>2]=c[k>>2];c[(Ic+16|0)+4>>2]=c[k+4>>2];sI(i,4,.009,Ic);h[k>>3]=.924232;c[Jc>>2]=c[k>>2];c[Jc+4>>2]=c[k+4>>2];h[k>>3]=-3.44698;c[(Jc+8|0)>>2]=c[k>>2];c[(Jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00334985;c[(Jc+16|0)>>2]=c[k>>2];c[(Jc+16|0)+4>>2]=c[k+4>>2];sI(j,4,.0091,Jc);h[k>>3]=.921766;c[Kc>>2]=c[k>>2];c[Kc+4>>2]=c[k+4>>2];h[k>>3]=-3.49289;c[(Kc+8|0)>>2]=c[k>>2];c[(Kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00329202;c[(Kc+16|0)>>2]=c[k>>2];c[(Kc+16|0)+4>>2]=c[k+4>>2];sI(l,4,.0092,Kc);h[k>>3]=.918579;c[Lc>>2]=c[k>>2];c[Lc+4>>2]=c[k+4>>2];h[k>>3]=-3.53879;c[(Lc+8|0)>>2]=c[k>>2];c[(Lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00323283;c[(Lc+16|0)>>2]=c[k>>2];c[(Lc+16|0)+4>>2]=c[k+4>>2];sI(m,4,.0093,Lc);h[k>>3]=.913925;c[Mc>>2]=c[k>>2];c[Mc+4>>2]=c[k+4>>2];h[k>>3]=-3.5856;c[(Mc+8|0)>>2]=c[k>>2];c[(Mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00317229;c[(Mc+16|0)>>2]=c[k>>2];c[(Mc+16|0)+4>>2]=c[k+4>>2];sI(n,4,.0094,Mc);h[k>>3]=.909004;c[Nc>>2]=c[k>>2];c[Nc+4>>2]=c[k+4>>2];h[k>>3]=-3.63034;c[(Nc+8|0)>>2]=c[k>>2];c[(Nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00311037;c[(Nc+16|0)>>2]=c[k>>2];c[(Nc+16|0)+4>>2]=c[k+4>>2];sI(o,4,.0095,Nc);h[k>>3]=.903809;c[Oc>>2]=c[k>>2];c[Oc+4>>2]=c[k+4>>2];h[k>>3]=-3.67275;c[(Oc+8|0)>>2]=c[k>>2];c[(Oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00304706;c[(Oc+16|0)>>2]=c[k>>2];c[(Oc+16|0)+4>>2]=c[k+4>>2];sI(p,4,.0096,Oc);h[k>>3]=.89859;c[Pc>>2]=c[k>>2];c[Pc+4>>2]=c[k+4>>2];h[k>>3]=-3.72881;c[(Pc+8|0)>>2]=c[k>>2];c[(Pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00298233;c[(Pc+16|0)>>2]=c[k>>2];c[(Pc+16|0)+4>>2]=c[k+4>>2];sI(q,4,.0097,Pc);h[k>>3]=.893783;c[Qc>>2]=c[k>>2];c[Qc+4>>2]=c[k+4>>2];h[k>>3]=-3.82589;c[(Qc+8|0)>>2]=c[k>>2];c[(Qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00291616;c[(Qc+16|0)>>2]=c[k>>2];c[(Qc+16|0)+4>>2]=c[k+4>>2];sI(r,4,.0098,Qc);h[k>>3]=.888707;c[Rc>>2]=c[k>>2];c[Rc+4>>2]=c[k+4>>2];h[k>>3]=-3.92096;c[(Rc+8|0)>>2]=c[k>>2];c[(Rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00284852;c[(Rc+16|0)>>2]=c[k>>2];c[(Rc+16|0)+4>>2]=c[k+4>>2];sI(s,4,.0099,Rc);h[k>>3]=.883343;c[Sc>>2]=c[k>>2];c[Sc+4>>2]=c[k+4>>2];h[k>>3]=-4.01357;c[(Sc+8|0)>>2]=c[k>>2];c[(Sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00277938;c[(Sc+16|0)>>2]=c[k>>2];c[(Sc+16|0)+4>>2]=c[k+4>>2];sI(t,4,.01,Sc);h[k>>3]=.876979;c[Tc>>2]=c[k>>2];c[Tc+4>>2]=c[k+4>>2];h[k>>3]=-4.10734;c[(Tc+8|0)>>2]=c[k>>2];c[(Tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00270869;c[(Tc+16|0)>>2]=c[k>>2];c[(Tc+16|0)+4>>2]=c[k+4>>2];sI(u,4,.0101,Tc);h[k>>3]=.869783;c[Uc>>2]=c[k>>2];c[Uc+4>>2]=c[k+4>>2];h[k>>3]=-4.19987;c[(Uc+8|0)>>2]=c[k>>2];c[(Uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00263642;c[(Uc+16|0)>>2]=c[k>>2];c[(Uc+16|0)+4>>2]=c[k+4>>2];sI(v,4,.0102,Uc);h[k>>3]=.862246;c[Vc>>2]=c[k>>2];c[Vc+4>>2]=c[k+4>>2];h[k>>3]=-4.28752;c[(Vc+8|0)>>2]=c[k>>2];c[(Vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00256254;c[(Vc+16|0)>>2]=c[k>>2];c[(Vc+16|0)+4>>2]=c[k+4>>2];sI(w,4,.0103,Vc);h[k>>3]=.854574;c[Wc>>2]=c[k>>2];c[Wc+4>>2]=c[k+4>>2];h[k>>3]=-4.37627;c[(Wc+8|0)>>2]=c[k>>2];c[(Wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00248701;c[(Wc+16|0)>>2]=c[k>>2];c[(Wc+16|0)+4>>2]=c[k+4>>2];sI(x,4,.0104,Wc);h[k>>3]=.847614;c[Xc>>2]=c[k>>2];c[Xc+4>>2]=c[k+4>>2];h[k>>3]=-4.49154;c[(Xc+8|0)>>2]=c[k>>2];c[(Xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00240979;c[(Xc+16|0)>>2]=c[k>>2];c[(Xc+16|0)+4>>2]=c[k+4>>2];sI(y,4,.0105,Xc);h[k>>3]=.840302;c[Yc>>2]=c[k>>2];c[Yc+4>>2]=c[k+4>>2];h[k>>3]=-4.60102;c[(Yc+8|0)>>2]=c[k>>2];c[(Yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00233085;c[(Yc+16|0)>>2]=c[k>>2];c[(Yc+16|0)+4>>2]=c[k+4>>2];sI(z,4,.0106,Yc);h[k>>3]=.832625;c[Zc>>2]=c[k>>2];c[Zc+4>>2]=c[k+4>>2];h[k>>3]=-4.70399;c[(Zc+8|0)>>2]=c[k>>2];c[(Zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00225014;c[(Zc+16|0)>>2]=c[k>>2];c[(Zc+16|0)+4>>2]=c[k+4>>2];sI(A,4,.0107,Zc);h[k>>3]=.822938;c[_c>>2]=c[k>>2];c[_c+4>>2]=c[k+4>>2];h[k>>3]=-4.82647;c[(_c+8|0)>>2]=c[k>>2];c[(_c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00216761;c[(_c+16|0)>>2]=c[k>>2];c[(_c+16|0)+4>>2]=c[k+4>>2];sI(B,4,.0108,_c);h[k>>3]=.812813;c[$c>>2]=c[k>>2];c[$c+4>>2]=c[k+4>>2];h[k>>3]=-4.93752;c[($c+8|0)>>2]=c[k>>2];c[($c+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00208323;c[($c+16|0)>>2]=c[k>>2];c[($c+16|0)+4>>2]=c[k+4>>2];sI(C,4,.0109,$c);h[k>>3]=.802204;c[ad>>2]=c[k>>2];c[ad+4>>2]=c[k+4>>2];h[k>>3]=-5.04175;c[(ad+8|0)>>2]=c[k>>2];c[(ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00199695;c[(ad+16|0)>>2]=c[k>>2];c[(ad+16|0)+4>>2]=c[k+4>>2];sI(D,4,.011,ad);h[k>>3]=.78997;c[bd>>2]=c[k>>2];c[bd+4>>2]=c[k+4>>2];h[k>>3]=-5.30274;c[(bd+8|0)>>2]=c[k>>2];c[(bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00190873;c[(bd+16|0)>>2]=c[k>>2];c[(bd+16|0)+4>>2]=c[k+4>>2];sI(E,4,.0111,bd);h[k>>3]=.777197;c[cd>>2]=c[k>>2];c[cd+4>>2]=c[k+4>>2];h[k>>3]=-5.54515;c[(cd+8|0)>>2]=c[k>>2];c[(cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00181846;c[(cd+16|0)>>2]=c[k>>2];c[(cd+16|0)+4>>2]=c[k+4>>2];sI(F,4,.0112,cd);h[k>>3]=.763521;c[dd>>2]=c[k>>2];c[dd+4>>2]=c[k+4>>2];h[k>>3]=-5.78149;c[(dd+8|0)>>2]=c[k>>2];c[(dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00172606;c[(dd+16|0)>>2]=c[k>>2];c[(dd+16|0)+4>>2]=c[k+4>>2];sI(G,4,.0113,dd);h[k>>3]=.748272;c[ed>>2]=c[k>>2];c[ed+4>>2]=c[k+4>>2];h[k>>3]=-6.039;c[(ed+8|0)>>2]=c[k>>2];c[(ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00163144;c[(ed+16|0)>>2]=c[k>>2];c[(ed+16|0)+4>>2]=c[k+4>>2];sI(H,4,.0114,ed);h[k>>3]=.73235;c[fd>>2]=c[k>>2];c[fd+4>>2]=c[k+4>>2];h[k>>3]=-6.25778;c[(fd+8|0)>>2]=c[k>>2];c[(fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0015345;c[(fd+16|0)>>2]=c[k>>2];c[(fd+16|0)+4>>2]=c[k+4>>2];sI(I,4,.0115,fd);h[k>>3]=.715211;c[gd>>2]=c[k>>2];c[gd+4>>2]=c[k+4>>2];h[k>>3]=-6.57852;c[(gd+8|0)>>2]=c[k>>2];c[(gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00143514;c[(gd+16|0)>>2]=c[k>>2];c[(gd+16|0)+4>>2]=c[k+4>>2];sI(J,4,.0116,gd);h[k>>3]=.696998;c[hd>>2]=c[k>>2];c[hd+4>>2]=c[k+4>>2];h[k>>3]=-6.91971;c[(hd+8|0)>>2]=c[k>>2];c[(hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00133326;c[(hd+16|0)>>2]=c[k>>2];c[(hd+16|0)+4>>2]=c[k+4>>2];sI(K,4,.0117,hd);h[k>>3]=.677065;c[id>>2]=c[k>>2];c[id+4>>2]=c[k+4>>2];h[k>>3]=-7.30735;c[(id+8|0)>>2]=c[k>>2];c[(id+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00122872;c[(id+16|0)>>2]=c[k>>2];c[(id+16|0)+4>>2]=c[k+4>>2];sI(L,4,.0118,id);h[k>>3]=.652791;c[jd>>2]=c[k>>2];c[jd+4>>2]=c[k+4>>2];h[k>>3]=-7.88085;c[(jd+8|0)>>2]=c[k>>2];c[(jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00112136;c[(jd+16|0)>>2]=c[k>>2];c[(jd+16|0)+4>>2]=c[k+4>>2];sI(M,4,.0119,jd);h[k>>3]=.62734;c[kd>>2]=c[k>>2];c[kd+4>>2]=c[k+4>>2];h[k>>3]=-8.29718;c[(kd+8|0)>>2]=c[k>>2];c[(kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00101097;c[(kd+16|0)>>2]=c[k>>2];c[(kd+16|0)+4>>2]=c[k+4>>2];sI(N,4,.012,kd);h[k>>3]=.597125;c[ld>>2]=c[k>>2];c[ld+4>>2]=c[k+4>>2];h[k>>3]=-9.13179;c[(ld+8|0)>>2]=c[k>>2];c[(ld+8|0)+4>>2]=c[k+4>>2];h[k>>3]=897364.0e-9;c[(ld+16|0)>>2]=c[k>>2];c[(ld+16|0)+4>>2]=c[k+4>>2];sI(O,4,.0121,ld);h[k>>3]=.564919;c[md>>2]=c[k>>2];c[md+4>>2]=c[k+4>>2];h[k>>3]=-9.82427;c[(md+8|0)>>2]=c[k>>2];c[(md+8|0)+4>>2]=c[k+4>>2];h[k>>3]=780251.0e-9;c[(md+16|0)>>2]=c[k>>2];c[(md+16|0)+4>>2]=c[k+4>>2];sI(P,4,.0122,md);h[k>>3]=.527838;c[nd>>2]=c[k>>2];c[nd+4>>2]=c[k+4>>2];h[k>>3]=-11.1684;c[(nd+8|0)>>2]=c[k>>2];c[(nd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=659331.0e-9;c[(nd+16|0)>>2]=c[k>>2];c[(nd+16|0)+4>>2]=c[k+4>>2];sI(Q,4,.0123,nd);h[k>>3]=.487477;c[od>>2]=c[k>>2];c[od+4>>2]=c[k+4>>2];h[k>>3]=-12.1609;c[(od+8|0)>>2]=c[k>>2];c[(od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=534142.0e-9;c[(od+16|0)>>2]=c[k>>2];c[(od+16|0)+4>>2]=c[k+4>>2];sI(R,4,.0124,od);h[k>>3]=.436631;c[pd>>2]=c[k>>2];c[pd+4>>2]=c[k+4>>2];h[k>>3]=-14.9103;c[(pd+8|0)>>2]=c[k>>2];c[(pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=404205.0e-9;c[(pd+16|0)>>2]=c[k>>2];c[(pd+16|0)+4>>2]=c[k+4>>2];sI(S,4,.0125,pd);h[k>>3]=.379243;c[qd>>2]=c[k>>2];c[qd+4>>2]=c[k+4>>2];h[k>>3]=-16.2449;c[(qd+8|0)>>2]=c[k>>2];c[(qd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=268616.0e-9;c[(qd+16|0)>>2]=c[k>>2];c[(qd+16|0)+4>>2]=c[k+4>>2];sI(T,4,.0126,qd);h[k>>3]=.371242;c[rd>>2]=c[k>>2];c[rd+4>>2]=c[k+4>>2];h[k>>3]=-16.2777;c[(rd+8|0)>>2]=c[k>>2];c[(rd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(rd+16|0)>>2]=c[k>>2];c[(rd+16|0)+4>>2]=c[k+4>>2];sI(U,4,.0126134,rd);h[k>>3]=.371242;c[sd>>2]=c[k>>2];c[sd+4>>2]=c[k+4>>2];h[k>>3]=-16.2777;c[(sd+8|0)>>2]=c[k>>2];c[(sd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(sd+16|0)>>2]=c[k>>2];c[(sd+16|0)+4>>2]=c[k+4>>2];sI(V,4,.0126134,sd);h[k>>3]=.350822;c[td>>2]=c[k>>2];c[td+4>>2]=c[k+4>>2];h[k>>3]=-16.2554;c[(td+8|0)>>2]=c[k>>2];c[(td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=198624.0e-9;c[(td+16|0)>>2]=c[k>>2];c[(td+16|0)+4>>2]=c[k+4>>2];sI(W,4,.0126868,td);h[k>>3]=.350822;c[ud>>2]=c[k>>2];c[ud+4>>2]=c[k+4>>2];h[k>>3]=-16.2554;c[(ud+8|0)>>2]=c[k>>2];c[(ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=198624.0e-9;c[(ud+16|0)>>2]=c[k>>2];c[(ud+16|0)+4>>2]=c[k+4>>2];sI(X,4,.0126868,ud);h[k>>3]=.351869;c[vd>>2]=c[k>>2];c[vd+4>>2]=c[k+4>>2];h[k>>3]=-16.3218;c[(vd+8|0)>>2]=c[k>>2];c[(vd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=199455.0e-9;c[(vd+16|0)>>2]=c[k>>2];c[(vd+16|0)+4>>2]=c[k+4>>2];sI(Y,4,.0127,vd);h[k>>3]=.37695;c[wd>>2]=c[k>>2];c[wd+4>>2]=c[k+4>>2];h[k>>3]=-17.0338;c[(wd+8|0)>>2]=c[k>>2];c[(wd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=241587.0e-9;c[(wd+16|0)>>2]=c[k>>2];c[(wd+16|0)+4>>2]=c[k+4>>2];sI(Z,4,.0128,wd);h[k>>3]=.381787;c[xd>>2]=c[k>>2];c[xd+4>>2]=c[k+4>>2];h[k>>3]=-17.1198;c[(xd+8|0)>>2]=c[k>>2];c[(xd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(xd+16|0)>>2]=c[k>>2];c[(xd+16|0)+4>>2]=c[k+4>>2];sI(_,4,.0128157,xd);h[k>>3]=.381787;c[yd>>2]=c[k>>2];c[yd+4>>2]=c[k+4>>2];h[k>>3]=-17.1198;c[(yd+8|0)>>2]=c[k>>2];c[(yd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(yd+16|0)>>2]=c[k>>2];c[(yd+16|0)+4>>2]=c[k+4>>2];sI($,4,.0128157,yd);h[k>>3]=.406591;c[zd>>2]=c[k>>2];c[zd+4>>2]=c[k+4>>2];h[k>>3]=-17.48;c[(zd+8|0)>>2]=c[k>>2];c[(zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=292352.0e-9;c[(zd+16|0)>>2]=c[k>>2];c[(zd+16|0)+4>>2]=c[k+4>>2];sI(aa,4,.0129,zd);h[k>>3]=.433421;c[Ad>>2]=c[k>>2];c[Ad+4>>2]=c[k+4>>2];h[k>>3]=-17.8191;c[(Ad+8|0)>>2]=c[k>>2];c[(Ad+8|0)+4>>2]=c[k+4>>2];h[k>>3]=336402.0e-9;c[(Ad+16|0)>>2]=c[k>>2];c[(Ad+16|0)+4>>2]=c[k+4>>2];sI(ba,4,.013,Ad);h[k>>3]=.457261;c[Bd>>2]=c[k>>2];c[Bd+4>>2]=c[k+4>>2];h[k>>3]=-17.8337;c[(Bd+8|0)>>2]=c[k>>2];c[(Bd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=373609.0e-9;c[(Bd+16|0)>>2]=c[k>>2];c[(Bd+16|0)+4>>2]=c[k+4>>2];sI(ca,4,.0131,Bd);h[k>>3]=.477911;c[Cd>>2]=c[k>>2];c[Cd+4>>2]=c[k+4>>2];h[k>>3]=-17.6706;c[(Cd+8|0)>>2]=c[k>>2];c[(Cd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=403962.0e-9;c[(Cd+16|0)>>2]=c[k>>2];c[(Cd+16|0)+4>>2]=c[k+4>>2];sI(da,4,.0132,Cd);h[k>>3]=.495294;c[Dd>>2]=c[k>>2];c[Dd+4>>2]=c[k+4>>2];h[k>>3]=-17.4605;c[(Dd+8|0)>>2]=c[k>>2];c[(Dd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=42752.0e-8;c[(Dd+16|0)>>2]=c[k>>2];c[(Dd+16|0)+4>>2]=c[k+4>>2];sI(ea,4,.0133,Dd);h[k>>3]=.509353;c[Ed>>2]=c[k>>2];c[Ed+4>>2]=c[k+4>>2];h[k>>3]=-17.3988;c[(Ed+8|0)>>2]=c[k>>2];c[(Ed+8|0)+4>>2]=c[k+4>>2];h[k>>3]=444358.0e-9;c[(Ed+16|0)>>2]=c[k>>2];c[(Ed+16|0)+4>>2]=c[k+4>>2];sI(fa,4,.0134,Ed);h[k>>3]=.520015;c[Fd>>2]=c[k>>2];c[Fd+4>>2]=c[k+4>>2];h[k>>3]=-17.4878;c[(Fd+8|0)>>2]=c[k>>2];c[(Fd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=4545.0e-7;c[(Fd+16|0)>>2]=c[k>>2];c[(Fd+16|0)+4>>2]=c[k+4>>2];sI(ga,4,.0135,Fd);h[k>>3]=.527192;c[Gd>>2]=c[k>>2];c[Gd+4>>2]=c[k+4>>2];h[k>>3]=-17.7433;c[(Gd+8|0)>>2]=c[k>>2];c[(Gd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=457911.0e-9;c[(Gd+16|0)>>2]=c[k>>2];c[(Gd+16|0)+4>>2]=c[k+4>>2];sI(ha,4,.0136,Gd);h[k>>3]=.527207;c[Hd>>2]=c[k>>2];c[Hd+4>>2]=c[k+4>>2];h[k>>3]=-17.7443;c[(Hd+8|0)>>2]=c[k>>2];c[(Hd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=457911.0e-9;c[(Hd+16|0)>>2]=c[k>>2];c[(Hd+16|0)+4>>2]=c[k+4>>2];sI(ia,4,.0136003,Hd);h[k>>3]=.527207;c[Id>>2]=c[k>>2];c[Id+4>>2]=c[k+4>>2];h[k>>3]=-17.7443;c[(Id+8|0)>>2]=c[k>>2];c[(Id+8|0)+4>>2]=c[k+4>>2];h[k>>3]=457911.0e-9;c[(Id+16|0)>>2]=c[k>>2];c[(Id+16|0)+4>>2]=c[k+4>>2];sI(ja,4,.0136003,Id);h[k>>3]=.530748;c[Jd>>2]=c[k>>2];c[Jd+4>>2]=c[k+4>>2];h[k>>3]=-18.1997;c[(Jd+8|0)>>2]=c[k>>2];c[(Jd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=454491.0e-9;c[(Jd+16|0)>>2]=c[k>>2];c[(Jd+16|0)+4>>2]=c[k+4>>2];sI(ka,4,.0137,Jd);h[k>>3]=.530517;c[Kd>>2]=c[k>>2];c[Kd+4>>2]=c[k+4>>2];h[k>>3]=-18.8646;c[(Kd+8|0)>>2]=c[k>>2];c[(Kd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=444064.0e-9;c[(Kd+16|0)>>2]=c[k>>2];c[(Kd+16|0)+4>>2]=c[k+4>>2];sI(la,4,.0138,Kd);h[k>>3]=.526294;c[Ld>>2]=c[k>>2];c[Ld+4>>2]=c[k+4>>2];h[k>>3]=-19.7142;c[(Ld+8|0)>>2]=c[k>>2];c[(Ld+8|0)+4>>2]=c[k+4>>2];h[k>>3]=426376.0e-9;c[(Ld+16|0)>>2]=c[k>>2];c[(Ld+16|0)+4>>2]=c[k+4>>2];sI(ma,4,.0139,Ld);h[k>>3]=.517828;c[Md>>2]=c[k>>2];c[Md+4>>2]=c[k+4>>2];h[k>>3]=-20.6871;c[(Md+8|0)>>2]=c[k>>2];c[(Md+8|0)+4>>2]=c[k+4>>2];h[k>>3]=401101.0e-9;c[(Md+16|0)>>2]=c[k>>2];c[(Md+16|0)+4>>2]=c[k+4>>2];sI(na,4,.014,Md);h[k>>3]=.504836;c[Nd>>2]=c[k>>2];c[Nd+4>>2]=c[k+4>>2];h[k>>3]=-21.6765;c[(Nd+8|0)>>2]=c[k>>2];c[(Nd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=367869.0e-9;c[(Nd+16|0)>>2]=c[k>>2];c[(Nd+16|0)+4>>2]=c[k+4>>2];sI(oa,4,.0141,Nd);h[k>>3]=.487037;c[Od>>2]=c[k>>2];c[Od+4>>2]=c[k+4>>2];h[k>>3]=-22.6627;c[(Od+8|0)>>2]=c[k>>2];c[(Od+8|0)+4>>2]=c[k+4>>2];h[k>>3]=326301.0e-9;c[(Od+16|0)>>2]=c[k>>2];c[(Od+16|0)+4>>2]=c[k+4>>2];sI(pa,4,.0142,Od);h[k>>3]=.464073;c[Pd>>2]=c[k>>2];c[Pd+4>>2]=c[k+4>>2];h[k>>3]=-23.4017;c[(Pd+8|0)>>2]=c[k>>2];c[(Pd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=276025.0e-9;c[(Pd+16|0)>>2]=c[k>>2];c[(Pd+16|0)+4>>2]=c[k+4>>2];sI(qa,4,.0143,Pd);h[k>>3]=.451744;c[Qd>>2]=c[k>>2];c[Qd+4>>2]=c[k+4>>2];h[k>>3]=-23.5657;c[(Qd+8|0)>>2]=c[k>>2];c[(Qd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Qd+16|0)>>2]=c[k>>2];c[(Qd+16|0)+4>>2]=c[k+4>>2];sI(ra,4,.0143458,Qd);h[k>>3]=.451744;c[Rd>>2]=c[k>>2];c[Rd+4>>2]=c[k+4>>2];h[k>>3]=-23.5657;c[(Rd+8|0)>>2]=c[k>>2];c[(Rd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Rd+16|0)>>2]=c[k>>2];c[(Rd+16|0)+4>>2]=c[k+4>>2];sI(sa,4,.0143458,Rd);h[k>>3]=.439383;c[Sd>>2]=c[k>>2];c[Sd+4>>2]=c[k+4>>2];h[k>>3]=-23.6302;c[(Sd+8|0)>>2]=c[k>>2];c[(Sd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=223375.0e-9;c[(Sd+16|0)>>2]=c[k>>2];c[(Sd+16|0)+4>>2]=c[k+4>>2];sI(ta,4,.0144,Sd);h[k>>3]=.438001;c[Td>>2]=c[k>>2];c[Td+4>>2]=c[k+4>>2];h[k>>3]=-23.8106;c[(Td+8|0)>>2]=c[k>>2];c[(Td+8|0)+4>>2]=c[k+4>>2];h[k>>3]=21654.0e-8;c[(Td+16|0)>>2]=c[k>>2];c[(Td+16|0)+4>>2]=c[k+4>>2];sI(ua,4,.0144518,Td);h[k>>3]=.438001;c[Ud>>2]=c[k>>2];c[Ud+4>>2]=c[k+4>>2];h[k>>3]=-23.8106;c[(Ud+8|0)>>2]=c[k>>2];c[(Ud+8|0)+4>>2]=c[k+4>>2];h[k>>3]=21654.0e-8;c[(Ud+16|0)>>2]=c[k>>2];c[(Ud+16|0)+4>>2]=c[k+4>>2];sI(va,4,.0144518,Ud);h[k>>3]=.442437;c[Vd>>2]=c[k>>2];c[Vd+4>>2]=c[k+4>>2];h[k>>3]=-24.0882;c[(Vd+8|0)>>2]=c[k>>2];c[(Vd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=220288.0e-9;c[(Vd+16|0)>>2]=c[k>>2];c[(Vd+16|0)+4>>2]=c[k+4>>2];sI(wa,4,.0145,Vd);h[k>>3]=.459291;c[Wd>>2]=c[k>>2];c[Wd+4>>2]=c[k+4>>2];h[k>>3]=-24.7355;c[(Wd+8|0)>>2]=c[k>>2];c[(Wd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=241352.0e-9;c[(Wd+16|0)>>2]=c[k>>2];c[(Wd+16|0)+4>>2]=c[k+4>>2];sI(xa,4,.0146,Wd);h[k>>3]=.466338;c[Xd>>2]=c[k>>2];c[Xd+4>>2]=c[k+4>>2];h[k>>3]=-24.9736;c[(Xd+8|0)>>2]=c[k>>2];c[(Xd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Xd+16|0)>>2]=c[k>>2];c[(Xd+16|0)+4>>2]=c[k+4>>2];sI(ya,4,.014643,Xd);h[k>>3]=.466338;c[Yd>>2]=c[k>>2];c[Yd+4>>2]=c[k+4>>2];h[k>>3]=-24.9736;c[(Yd+8|0)>>2]=c[k>>2];c[(Yd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Yd+16|0)>>2]=c[k>>2];c[(Yd+16|0)+4>>2]=c[k+4>>2];sI(za,4,.014643,Yd);h[k>>3]=.47417;c[Zd>>2]=c[k>>2];c[Zd+4>>2]=c[k+4>>2];h[k>>3]=-25.2545;c[(Zd+8|0)>>2]=c[k>>2];c[(Zd+8|0)+4>>2]=c[k+4>>2];h[k>>3]=258795.0e-9;c[(Zd+16|0)>>2]=c[k>>2];c[(Zd+16|0)+4>>2]=c[k+4>>2];sI(Aa,4,.0147,Zd);h[k>>3]=.483493;c[_d>>2]=c[k>>2];c[_d+4>>2]=c[k+4>>2];h[k>>3]=-25.7045;c[(_d+8|0)>>2]=c[k>>2];c[(_d+8|0)+4>>2]=c[k+4>>2];h[k>>3]=266567.0e-9;c[(_d+16|0)>>2]=c[k>>2];c[(_d+16|0)+4>>2]=c[k+4>>2];sI(Ba,4,.0148,_d);h[k>>3]=.485111;c[$d>>2]=c[k>>2];c[$d+4>>2]=c[k+4>>2];h[k>>3]=-25.8323;c[($d+8|0)>>2]=c[k>>2];c[($d+8|0)+4>>2]=c[k+4>>2];h[k>>3]=26698.0e-8;c[($d+16|0)>>2]=c[k>>2];c[($d+16|0)+4>>2]=c[k+4>>2];sI(Ca,4,.0148288,$d);h[k>>3]=.485111;c[ae>>2]=c[k>>2];c[ae+4>>2]=c[k+4>>2];h[k>>3]=-25.8323;c[(ae+8|0)>>2]=c[k>>2];c[(ae+8|0)+4>>2]=c[k+4>>2];h[k>>3]=26698.0e-8;c[(ae+16|0)>>2]=c[k>>2];c[(ae+16|0)+4>>2]=c[k+4>>2];sI(Da,4,.0148288,ae);h[k>>3]=.486998;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];h[k>>3]=-26.1506;c[(Db+8|0)>>2]=c[k>>2];c[(Db+8|0)+4>>2]=c[k+4>>2];h[k>>3]=264454.0e-9;c[(Db+16|0)>>2]=c[k>>2];c[(Db+16|0)+4>>2]=c[k+4>>2];sI(Ea,4,.0149,Db);h[k>>3]=.484444;c[Eb>>2]=c[k>>2];c[Eb+4>>2]=c[k+4>>2];h[k>>3]=-26.5924;c[(Eb+8|0)>>2]=c[k>>2];c[(Eb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=252282.0e-9;c[(Eb+16|0)>>2]=c[k>>2];c[(Eb+16|0)+4>>2]=c[k+4>>2];sI(Fa,4,.015,Eb);h[k>>3]=.483671;c[Fb>>2]=c[k>>2];c[Fb+4>>2]=c[k+4>>2];h[k>>3]=-26.6456;c[(Fb+8|0)>>2]=c[k>>2];c[(Fb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Fb+16|0)>>2]=c[k>>2];c[(Fb+16|0)+4>>2]=c[k+4>>2];sI(Ga,4,.0150127,Fb);h[k>>3]=.483671;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];h[k>>3]=-26.6456;c[(Gb+8|0)>>2]=c[k>>2];c[(Gb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=25.0e-5;c[(Gb+16|0)>>2]=c[k>>2];c[(Gb+16|0)+4>>2]=c[k+4>>2];sI(Ha,4,.0150127,Gb);h[k>>3]=.477935;c[Hb>>2]=c[k>>2];c[Hb+4>>2]=c[k+4>>2];h[k>>3]=-26.9803;c[(Hb+8|0)>>2]=c[k>>2];c[(Hb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=233764.0e-9;c[(Hb+16|0)>>2]=c[k>>2];c[(Hb+16|0)+4>>2]=c[k+4>>2];sI(Ia,4,.0151,Hb);h[k>>3]=.478678;c[Ib>>2]=c[k>>2];c[Ib+4>>2]=c[k+4>>2];h[k>>3]=-27.3825;c[(Ib+8|0)>>2]=c[k>>2];c[(Ib+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227777.0e-9;c[(Ib+16|0)>>2]=c[k>>2];c[(Ib+16|0)+4>>2]=c[k+4>>2];sI(Ja,4,.0151954,Ib);h[k>>3]=.478678;c[Jb>>2]=c[k>>2];c[Jb+4>>2]=c[k+4>>2];h[k>>3]=-27.3825;c[(Jb+8|0)>>2]=c[k>>2];c[(Jb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227777.0e-9;c[(Jb+16|0)>>2]=c[k>>2];c[(Jb+16|0)+4>>2]=c[k+4>>2];sI(Ka,4,.0151954,Jb);h[k>>3]=.478896;c[Kb>>2]=c[k>>2];c[Kb+4>>2]=c[k+4>>2];h[k>>3]=-27.404;c[(Kb+8|0)>>2]=c[k>>2];c[(Kb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=227786.0e-9;c[(Kb+16|0)>>2]=c[k>>2];c[(Kb+16|0)+4>>2]=c[k+4>>2];sI(La,4,.0152,Kb);h[k>>3]=.486112;c[Lb>>2]=c[k>>2];c[Lb+4>>2]=c[k+4>>2];h[k>>3]=-27.9096;c[(Lb+8|0)>>2]=c[k>>2];c[(Lb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231723.0e-9;c[(Lb+16|0)>>2]=c[k>>2];c[(Lb+16|0)+4>>2]=c[k+4>>2];sI(Ma,4,.0153,Lb);h[k>>3]=.494618;c[Mb>>2]=c[k>>2];c[Mb+4>>2]=c[k+4>>2];h[k>>3]=-28.4114;c[(Mb+8|0)>>2]=c[k>>2];c[(Mb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=237745.0e-9;c[(Mb+16|0)>>2]=c[k>>2];c[(Mb+16|0)+4>>2]=c[k+4>>2];sI(Na,4,.0154,Mb);h[k>>3]=.499054;c[Nb>>2]=c[k>>2];c[Nb+4>>2]=c[k+4>>2];h[k>>3]=-28.7526;c[(Nb+8|0)>>2]=c[k>>2];c[(Nb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=239402.0e-9;c[(Nb+16|0)>>2]=c[k>>2];c[(Nb+16|0)+4>>2]=c[k+4>>2];sI(Oa,4,.0154716,Nb);h[k>>3]=.499054;c[Ob>>2]=c[k>>2];c[Ob+4>>2]=c[k+4>>2];h[k>>3]=-28.7526;c[(Ob+8|0)>>2]=c[k>>2];c[(Ob+8|0)+4>>2]=c[k+4>>2];h[k>>3]=239402.0e-9;c[(Ob+16|0)>>2]=c[k>>2];c[(Ob+16|0)+4>>2]=c[k+4>>2];sI(Pa,4,.0154716,Ob);h[k>>3]=.500242;c[Pb>>2]=c[k>>2];c[Pb+4>>2]=c[k+4>>2];h[k>>3]=-28.8872;c[(Pb+8|0)>>2]=c[k>>2];c[(Pb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=239151.0e-9;c[(Pb+16|0)>>2]=c[k>>2];c[(Pb+16|0)+4>>2]=c[k+4>>2];sI(Qa,4,.0155,Pb);h[k>>3]=.502893;c[Qb>>2]=c[k>>2];c[Qb+4>>2]=c[k+4>>2];h[k>>3]=-29.3755;c[(Qb+8|0)>>2]=c[k>>2];c[(Qb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=235871.0e-9;c[(Qb+16|0)>>2]=c[k>>2];c[(Qb+16|0)+4>>2]=c[k+4>>2];sI(Ra,4,.0156,Qb);h[k>>3]=.505639;c[Rb>>2]=c[k>>2];c[Rb+4>>2]=c[k+4>>2];h[k>>3]=-29.8643;c[(Rb+8|0)>>2]=c[k>>2];c[(Rb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232816.0e-9;c[(Rb+16|0)>>2]=c[k>>2];c[(Rb+16|0)+4>>2]=c[k+4>>2];sI(Sa,4,.0157,Rb);h[k>>3]=.509736;c[Sb>>2]=c[k>>2];c[Sb+4>>2]=c[k+4>>2];h[k>>3]=-30.3772;c[(Sb+8|0)>>2]=c[k>>2];c[(Sb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231912.0e-9;c[(Sb+16|0)>>2]=c[k>>2];c[(Sb+16|0)+4>>2]=c[k+4>>2];sI(Ta,4,.0158,Sb);h[k>>3]=.51029;c[Tb>>2]=c[k>>2];c[Tb+4>>2]=c[k+4>>2];h[k>>3]=-30.4396;c[(Tb+8|0)>>2]=c[k>>2];c[(Tb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231905.0e-9;c[(Tb+16|0)>>2]=c[k>>2];c[(Tb+16|0)+4>>2]=c[k+4>>2];sI(Ua,4,.0158118,Tb);h[k>>3]=.51029;c[Ub>>2]=c[k>>2];c[Ub+4>>2]=c[k+4>>2];h[k>>3]=-30.4396;c[(Ub+8|0)>>2]=c[k>>2];c[(Ub+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231905.0e-9;c[(Ub+16|0)>>2]=c[k>>2];c[(Ub+16|0)+4>>2]=c[k+4>>2];sI(Va,4,.0158118,Ub);h[k>>3]=.514622;c[Vb>>2]=c[k>>2];c[Vb+4>>2]=c[k+4>>2];h[k>>3]=-30.9065;c[(Vb+8|0)>>2]=c[k>>2];c[(Vb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232198.0e-9;c[(Vb+16|0)>>2]=c[k>>2];c[(Vb+16|0)+4>>2]=c[k+4>>2];sI(Wa,4,.0159,Vb);h[k>>3]=.519654;c[Wb>>2]=c[k>>2];c[Wb+4>>2]=c[k+4>>2];h[k>>3]=-31.4343;c[(Wb+8|0)>>2]=c[k>>2];c[(Wb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232755.0e-9;c[(Wb+16|0)>>2]=c[k>>2];c[(Wb+16|0)+4>>2]=c[k+4>>2];sI(Xa,4,.016,Wb);h[k>>3]=.521947;c[Xb>>2]=c[k>>2];c[Xb+4>>2]=c[k+4>>2];h[k>>3]=-31.6846;c[(Xb+8|0)>>2]=c[k>>2];c[(Xb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232849.0e-9;c[(Xb+16|0)>>2]=c[k>>2];c[(Xb+16|0)+4>>2]=c[k+4>>2];sI(Ya,4,.016048,Xb);h[k>>3]=.521947;c[Yb>>2]=c[k>>2];c[Yb+4>>2]=c[k+4>>2];h[k>>3]=-31.6846;c[(Yb+8|0)>>2]=c[k>>2];c[(Yb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232849.0e-9;c[(Yb+16|0)>>2]=c[k>>2];c[(Yb+16|0)+4>>2]=c[k+4>>2];sI(Za,4,.016048,Yb);h[k>>3]=.524291;c[Zb>>2]=c[k>>2];c[Zb+4>>2]=c[k+4>>2];h[k>>3]=-31.9527;c[(Zb+8|0)>>2]=c[k>>2];c[(Zb+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232753.0e-9;c[(Zb+16|0)>>2]=c[k>>2];c[(Zb+16|0)+4>>2]=c[k+4>>2];sI(_a,4,.0161,Zb);h[k>>3]=.528618;c[_b>>2]=c[k>>2];c[_b+4>>2]=c[k+4>>2];h[k>>3]=-32.4638;c[(_b+8|0)>>2]=c[k>>2];c[(_b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=232328.0e-9;c[(_b+16|0)>>2]=c[k>>2];c[(_b+16|0)+4>>2]=c[k+4>>2];sI($a,4,.0162,_b);h[k>>3]=.53296;c[$b>>2]=c[k>>2];c[$b+4>>2]=c[k+4>>2];h[k>>3]=-32.9726;c[($b+8|0)>>2]=c[k>>2];c[($b+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231976.0e-9;c[($b+16|0)>>2]=c[k>>2];c[($b+16|0)+4>>2]=c[k+4>>2];sI(ab,4,.0163,$b);h[k>>3]=.537374;c[ac>>2]=c[k>>2];c[ac+4>>2]=c[k+4>>2];h[k>>3]=-33.4793;c[(ac+8|0)>>2]=c[k>>2];c[(ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231787.0e-9;c[(ac+16|0)>>2]=c[k>>2];c[(ac+16|0)+4>>2]=c[k+4>>2];sI(bb,4,.0164,ac);h[k>>3]=.541801;c[bc>>2]=c[k>>2];c[bc+4>>2]=c[k+4>>2];h[k>>3]=-33.9827;c[(bc+8|0)>>2]=c[k>>2];c[(bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231672.0e-9;c[(bc+16|0)>>2]=c[k>>2];c[(bc+16|0)+4>>2]=c[k+4>>2];sI(cb,4,.0165,bc);h[k>>3]=.546199;c[cc>>2]=c[k>>2];c[cc+4>>2]=c[k+4>>2];h[k>>3]=-34.4828;c[(cc+8|0)>>2]=c[k>>2];c[(cc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231561.0e-9;c[(cc+16|0)>>2]=c[k>>2];c[(cc+16|0)+4>>2]=c[k+4>>2];sI(db,4,.0166,cc);h[k>>3]=.550555;c[dc>>2]=c[k>>2];c[dc+4>>2]=c[k+4>>2];h[k>>3]=-34.9795;c[(dc+8|0)>>2]=c[k>>2];c[(dc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231435.0e-9;c[(dc+16|0)>>2]=c[k>>2];c[(dc+16|0)+4>>2]=c[k+4>>2];sI(eb,4,.0167,dc);h[k>>3]=.554875;c[ec>>2]=c[k>>2];c[ec+4>>2]=c[k+4>>2];h[k>>3]=-35.4729;c[(ec+8|0)>>2]=c[k>>2];c[(ec+8|0)+4>>2]=c[k+4>>2];h[k>>3]=2313.0e-7;c[(ec+16|0)>>2]=c[k>>2];c[(ec+16|0)+4>>2]=c[k+4>>2];sI(fb,4,.0168,ec);h[k>>3]=.559164;c[fc>>2]=c[k>>2];c[fc+4>>2]=c[k+4>>2];h[k>>3]=-35.9631;c[(fc+8|0)>>2]=c[k>>2];c[(fc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231166.0e-9;c[(fc+16|0)>>2]=c[k>>2];c[(fc+16|0)+4>>2]=c[k+4>>2];sI(gb,4,.0169,fc);h[k>>3]=.56344;c[gc>>2]=c[k>>2];c[gc+4>>2]=c[k+4>>2];h[k>>3]=-36.4518;c[(gc+8|0)>>2]=c[k>>2];c[(gc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=231035.0e-9;c[(gc+16|0)>>2]=c[k>>2];c[(gc+16|0)+4>>2]=c[k+4>>2];sI(hb,4,.017,gc);h[k>>3]=.567726;c[hc>>2]=c[k>>2];c[hc+4>>2]=c[k+4>>2];h[k>>3]=-36.9417;c[(hc+8|0)>>2]=c[k>>2];c[(hc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230906.0e-9;c[(hc+16|0)>>2]=c[k>>2];c[(hc+16|0)+4>>2]=c[k+4>>2];sI(ib,4,.0171,hc);h[k>>3]=.571982;c[ic>>2]=c[k>>2];c[ic+4>>2]=c[k+4>>2];h[k>>3]=-37.4284;c[(ic+8|0)>>2]=c[k>>2];c[(ic+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230779.0e-9;c[(ic+16|0)>>2]=c[k>>2];c[(ic+16|0)+4>>2]=c[k+4>>2];sI(jb,4,.0172,ic);h[k>>3]=.576209;c[jc>>2]=c[k>>2];c[jc+4>>2]=c[k+4>>2];h[k>>3]=-37.9119;c[(jc+8|0)>>2]=c[k>>2];c[(jc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230653.0e-9;c[(jc+16|0)>>2]=c[k>>2];c[(jc+16|0)+4>>2]=c[k+4>>2];sI(kb,4,.0173,jc);h[k>>3]=.580407;c[kc>>2]=c[k>>2];c[kc+4>>2]=c[k+4>>2];h[k>>3]=-38.3923;c[(kc+8|0)>>2]=c[k>>2];c[(kc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230528.0e-9;c[(kc+16|0)>>2]=c[k>>2];c[(kc+16|0)+4>>2]=c[k+4>>2];sI(lb,4,.0174,kc);h[k>>3]=.584575;c[lc>>2]=c[k>>2];c[lc+4>>2]=c[k+4>>2];h[k>>3]=-38.8695;c[(lc+8|0)>>2]=c[k>>2];c[(lc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230405.0e-9;c[(lc+16|0)>>2]=c[k>>2];c[(lc+16|0)+4>>2]=c[k+4>>2];sI(mb,4,.0175,lc);h[k>>3]=.588716;c[mc>>2]=c[k>>2];c[mc+4>>2]=c[k+4>>2];h[k>>3]=-39.3436;c[(mc+8|0)>>2]=c[k>>2];c[(mc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230284.0e-9;c[(mc+16|0)>>2]=c[k>>2];c[(mc+16|0)+4>>2]=c[k+4>>2];sI(nb,4,.0176,mc);h[k>>3]=.593137;c[nc>>2]=c[k>>2];c[nc+4>>2]=c[k+4>>2];h[k>>3]=-39.8493;c[(nc+8|0)>>2]=c[k>>2];c[(nc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230163.0e-9;c[(nc+16|0)>>2]=c[k>>2];c[(nc+16|0)+4>>2]=c[k+4>>2];sI(ob,4,.0177,nc);h[k>>3]=.59757;c[oc>>2]=c[k>>2];c[oc+4>>2]=c[k+4>>2];h[k>>3]=-40.357;c[(oc+8|0)>>2]=c[k>>2];c[(oc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=230038.0e-9;c[(oc+16|0)>>2]=c[k>>2];c[(oc+16|0)+4>>2]=c[k+4>>2];sI(pb,4,.0178,oc);h[k>>3]=.601967;c[pc>>2]=c[k>>2];c[pc+4>>2]=c[k+4>>2];h[k>>3]=-40.8716;c[(pc+8|0)>>2]=c[k>>2];c[(pc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229911.0e-9;c[(pc+16|0)>>2]=c[k>>2];c[(pc+16|0)+4>>2]=c[k+4>>2];sI(qb,4,.0179,pc);h[k>>3]=.60633;c[qc>>2]=c[k>>2];c[qc+4>>2]=c[k+4>>2];h[k>>3]=-41.3953;c[(qc+8|0)>>2]=c[k>>2];c[(qc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229783.0e-9;c[(qc+16|0)>>2]=c[k>>2];c[(qc+16|0)+4>>2]=c[k+4>>2];sI(rb,4,.018,qc);h[k>>3]=.610659;c[rc>>2]=c[k>>2];c[rc+4>>2]=c[k+4>>2];h[k>>3]=-41.9153;c[(rc+8|0)>>2]=c[k>>2];c[(rc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229654.0e-9;c[(rc+16|0)>>2]=c[k>>2];c[(rc+16|0)+4>>2]=c[k+4>>2];sI(sb,4,.0181,rc);h[k>>3]=.614955;c[sc>>2]=c[k>>2];c[sc+4>>2]=c[k+4>>2];h[k>>3]=-42.4317;c[(sc+8|0)>>2]=c[k>>2];c[(sc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229526.0e-9;c[(sc+16|0)>>2]=c[k>>2];c[(sc+16|0)+4>>2]=c[k+4>>2];sI(tb,4,.0182,sc);h[k>>3]=.619218;c[tc>>2]=c[k>>2];c[tc+4>>2]=c[k+4>>2];h[k>>3]=-42.9441;c[(tc+8|0)>>2]=c[k>>2];c[(tc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=2294.0e-7;c[(tc+16|0)>>2]=c[k>>2];c[(tc+16|0)+4>>2]=c[k+4>>2];sI(ub,4,.0183,tc);h[k>>3]=.623441;c[uc>>2]=c[k>>2];c[uc+4>>2]=c[k+4>>2];h[k>>3]=-43.452;c[(uc+8|0)>>2]=c[k>>2];c[(uc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229276.0e-9;c[(uc+16|0)>>2]=c[k>>2];c[(uc+16|0)+4>>2]=c[k+4>>2];sI(vb,4,.0184,uc);h[k>>3]=.627634;c[vc>>2]=c[k>>2];c[vc+4>>2]=c[k+4>>2];h[k>>3]=-43.9562;c[(vc+8|0)>>2]=c[k>>2];c[(vc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229154.0e-9;c[(vc+16|0)>>2]=c[k>>2];c[(vc+16|0)+4>>2]=c[k+4>>2];sI(wb,4,.0185,vc);h[k>>3]=.631795;c[wc>>2]=c[k>>2];c[wc+4>>2]=c[k+4>>2];h[k>>3]=-44.4569;c[(wc+8|0)>>2]=c[k>>2];c[(wc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=229034.0e-9;c[(wc+16|0)>>2]=c[k>>2];c[(wc+16|0)+4>>2]=c[k+4>>2];sI(xb,4,.0186,wc);h[k>>3]=.635926;c[xc>>2]=c[k>>2];c[xc+4>>2]=c[k+4>>2];h[k>>3]=-44.954;c[(xc+8|0)>>2]=c[k>>2];c[(xc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228915.0e-9;c[(xc+16|0)>>2]=c[k>>2];c[(xc+16|0)+4>>2]=c[k+4>>2];sI(yb,4,.0187,xc);h[k>>3]=.640026;c[yc>>2]=c[k>>2];c[yc+4>>2]=c[k+4>>2];h[k>>3]=-45.4476;c[(yc+8|0)>>2]=c[k>>2];c[(yc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228797.0e-9;c[(yc+16|0)>>2]=c[k>>2];c[(yc+16|0)+4>>2]=c[k+4>>2];sI(zb,4,.0188,yc);h[k>>3]=.644096;c[zc>>2]=c[k>>2];c[zc+4>>2]=c[k+4>>2];h[k>>3]=-45.9377;c[(zc+8|0)>>2]=c[k>>2];c[(zc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228681.0e-9;c[(zc+16|0)>>2]=c[k>>2];c[(zc+16|0)+4>>2]=c[k+4>>2];sI(Ab,4,.0189,zc);h[k>>3]=.648136;c[Ac>>2]=c[k>>2];c[Ac+4>>2]=c[k+4>>2];h[k>>3]=-46.4242;c[(Ac+8|0)>>2]=c[k>>2];c[(Ac+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228566.0e-9;c[(Ac+16|0)>>2]=c[k>>2];c[(Ac+16|0)+4>>2]=c[k+4>>2];sI(Bb,4,.019,Ac);h[k>>3]=.652146;c[Bc>>2]=c[k>>2];c[Bc+4>>2]=c[k+4>>2];h[k>>3]=-46.9074;c[(Bc+8|0)>>2]=c[k>>2];c[(Bc+8|0)+4>>2]=c[k+4>>2];h[k>>3]=228453.0e-9;c[(Bc+16|0)>>2]=c[k>>2];c[(Bc+16|0)+4>>2]=c[k+4>>2];sI(Cb,4,.0191,Bc);h[k>>3]=.656126;c[Cc>>2]=c[k>>2];c[Cc+4>>2]=c[k+4>>2];h[k>>3]=-47.387}function _Modelica_Magnetic_FluxTubes_Examples_SolenoidActuator_ComparisonPullInStroke_callExternalObjectConstructors$4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0,eg=0,fg=0,gg=0,hg=0,ig=0,jg=0,kg=0,lg=0,mg=0,ng=0,og=0,pg=0,qg=0,rg=0,sg=0,tg=0,ug=0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0,hh=0,ih=0,jh=0,kh=0,lh=0,mh=0,nh=0,oh=0,ph=0,qh=0,rh=0,sh=0,th=0,uh=0,vh=0,wh=0,xh=0,yh=0,zh=0,Ah=0,Bh=0,Ch=0,Dh=0,Eh=0,Fh=0,Gh=0,Hh=0,Ih=0,Jh=0,Kh=0,Lh=0,Mh=0,Nh=0,Oh=0,Ph=0,Qh=0,Rh=0,Sh=0,Th=0,Uh=0,Vh=0,Wh=0,Xh=0,Yh=0,Zh=0,_h=0,$h=0,ai=0,bi=0,ci=0,di=0,ei=0,fi=0,gi=0,hi=0,ii=0,ji=0,ki=0,li=0,mi=0,ni=0,oi=0,pi=0,qi=0,ri=0,si=0,ti=0,ui=0,vi=0,wi=0,xi=0,yi=0,zi=0,Ai=0,Bi=0,Ci=0,Di=0,Ei=0,Fi=0,Gi=0,Hi=0,Ii=0,Ji=0,Ki=0,Li=0,Mi=0,Ni=0,Oi=0,Pi=0,Qi=0,Ri=0,Si=0,Ti=0,Ui=0,Vi=0,Wi=0,Xi=0,Yi=0,Zi=0,_i=0,$i=0,aj=0,bj=0,cj=0,dj=0,ej=0,fj=0,gj=0,hj=0,ij=0,jj=0,kj=0,lj=0,mj=0,nj=0,oj=0,pj=0,qj=0,rj=0,sj=0,tj=0,uj=0,vj=0,wj=0,xj=0,yj=0,zj=0,Aj=0,Bj=0,Cj=0,Dj=0,Ej=0,Fj=0,Gj=0,Hj=0,Ij=0,Jj=0,Kj=0,Lj=0,Mj=0,Nj=0,Oj=0,Pj=0,Qj=0,Rj=0,Sj=0,Tj=0,Uj=0,Vj=0,Wj=0,Xj=0,Yj=0,Zj=0,_j=0,$j=0,ak=0,bk=0,ck=0,dk=0,ek=0,fk=0,gk=0,hk=0,ik=0,jk=0,kk=0,lk=0,mk=0,nk=0,ok=0,pk=0,qk=0,rk=0,sk=0,tk=0,uk=0,vk=0,wk=0,xk=0,yk=0,zk=0,Ak=0,Bk=0,Ck=0,Dk=0,Ek=0,Fk=0,Gk=0,Hk=0,Ik=0,Jk=0,Kk=0,Lk=0,Mk=0,Nk=0,Ok=0,Pk=0,Qk=0,Rk=0,Sk=0,Tk=0,Uk=0,Vk=0,Wk=0,Xk=0,Yk=0,Zk=0,_k=0,$k=0,al=0,bl=0,cl=0,dl=0,el=0,fl=0,gl=0,hl=0,il=0,jl=0,kl=0,ll=0,ml=0,nl=0,ol=0,pl=0,ql=0,rl=0,sl=0,tl=0,ul=0,vl=0,wl=0,xl=0,yl=0,zl=0,Al=0,Bl=0,Cl=0;b=c[a+56>>2]|0;d=c[a+72>>2]|0;e=c[a+80>>2]|0;f=c[a+88>>2]|0;g=c[a+96>>2]|0;j=c[a+104>>2]|0;l=c[a+112>>2]|0;m=c[a+120>>2]|0;n=c[a+128>>2]|0;o=c[a+136>>2]|0;p=c[a+144>>2]|0;q=c[a+152>>2]|0;r=c[a+160>>2]|0;s=c[a+168>>2]|0;t=c[a+176>>2]|0;u=c[a+184>>2]|0;v=c[a+192>>2]|0;w=c[a+200>>2]|0;x=c[a+208>>2]|0;y=c[a+216>>2]|0;z=c[a+224>>2]|0;A=c[a+232>>2]|0;B=c[a+240>>2]|0;C=c[a+248>>2]|0;D=c[a+256>>2]|0;E=c[a+264>>2]|0;F=c[a+272>>2]|0;G=c[a+280>>2]|0;H=c[a+288>>2]|0;I=c[a+296>>2]|0;J=c[a+304>>2]|0;K=c[a+312>>2]|0;L=c[a+320>>2]|0;M=c[a+328>>2]|0;N=c[a+336>>2]|0;O=c[a+344>>2]|0;P=c[a+352>>2]|0;Q=c[a+360>>2]|0;R=c[a+368>>2]|0;S=c[a+376>>2]|0;T=c[a+384>>2]|0;U=c[a+392>>2]|0;V=c[a+400>>2]|0;W=c[a+408>>2]|0;X=c[a+416>>2]|0;Y=c[a+424>>2]|0;Z=c[a+432>>2]|0;_=c[a+440>>2]|0;$=c[a+448>>2]|0;aa=c[a+456>>2]|0;ba=c[a+464>>2]|0;ca=c[a+472>>2]|0;da=c[a+480>>2]|0;ea=c[a+488>>2]|0;fa=c[a+496>>2]|0;ga=c[a+504>>2]|0;ha=c[a+512>>2]|0;ia=c[a+520>>2]|0;ja=c[a+528>>2]|0;ka=c[a+536>>2]|0;la=c[a+544>>2]|0;ma=c[a+552>>2]|0;na=c[a+560>>2]|0;oa=c[a+568>>2]|0;pa=c[a+576>>2]|0;qa=c[a+584>>2]|0;ra=c[a+592>>2]|0;sa=c[a+600>>2]|0;ta=c[a+608>>2]|0;ua=c[a+616>>2]|0;va=c[a+624>>2]|0;wa=c[a+632>>2]|0;xa=c[a+640>>2]|0;ya=c[a+648>>2]|0;za=c[a+656>>2]|0;Aa=c[a+664>>2]|0;Ba=c[a+672>>2]|0;Ca=c[a+680>>2]|0;Da=c[a+688>>2]|0;Ea=c[a+696>>2]|0;Fa=c[a+704>>2]|0;Ga=c[a+712>>2]|0;Ha=c[a+720>>2]|0;Ia=c[a+728>>2]|0;Ja=c[a+736>>2]|0;Ka=c[a+744>>2]|0;La=c[a+752>>2]|0;Ma=c[a+760>>2]|0;Na=c[a+768>>2]|0;Oa=c[a+776>>2]|0;Pa=c[a+784>>2]|0;Qa=c[a+792>>2]|0;Ra=c[a+800>>2]|0;Sa=c[a+808>>2]|0;Ta=c[a+816>>2]|0;Ua=c[a+824>>2]|0;Va=c[a+832>>2]|0;Wa=c[a+840>>2]|0;Xa=c[a+848>>2]|0;Ya=c[a+856>>2]|0;Za=c[a+864>>2]|0;_a=c[a+872>>2]|0;$a=c[a+880>>2]|0;ab=c[a+888>>2]|0;bb=c[a+896>>2]|0;cb=c[a+904>>2]|0;db=c[a+912>>2]|0;eb=c[a+920>>2]|0;fb=c[a+928>>2]|0;gb=c[a+936>>2]|0;hb=c[a+944>>2]|0;ib=c[a+952>>2]|0;jb=c[a+960>>2]|0;kb=c[a+968>>2]|0;lb=c[a+976>>2]|0;mb=c[a+984>>2]|0;nb=c[a+992>>2]|0;ob=c[a+1e3>>2]|0;pb=c[a+1008>>2]|0;qb=c[a+1016>>2]|0;rb=c[a+1024>>2]|0;sb=c[a+1032>>2]|0;tb=c[a+1040>>2]|0;ub=c[a+1048>>2]|0;vb=c[a+1056>>2]|0;wb=c[a+1064>>2]|0;xb=c[a+1072>>2]|0;yb=c[a+1080>>2]|0;zb=c[a+1088>>2]|0;Ab=c[a+1096>>2]|0;Bb=c[a+1104>>2]|0;Cb=c[a+1112>>2]|0;Db=c[a+1120>>2]|0;Eb=c[a+1128>>2]|0;Fb=c[a+1136>>2]|0;Gb=c[a+1144>>2]|0;Hb=c[a+1152>>2]|0;Ib=c[a+1160>>2]|0;Jb=c[a+1168>>2]|0;Kb=c[a+1176>>2]|0;Lb=c[a+1184>>2]|0;Mb=c[a+1192>>2]|0;Nb=c[a+1200>>2]|0;Ob=c[a+1208>>2]|0;Pb=c[a+1216>>2]|0;Qb=c[a+1224>>2]|0;Rb=c[a+1232>>2]|0;Sb=c[a+1240>>2]|0;Tb=c[a+1248>>2]|0;Ub=c[a+1256>>2]|0;Vb=c[a+1264>>2]|0;Wb=c[a+1272>>2]|0;Xb=c[a+1280>>2]|0;Yb=c[a+1288>>2]|0;Zb=c[a+1296>>2]|0;_b=c[a+1304>>2]|0;$b=c[a+1312>>2]|0;ac=c[a+1320>>2]|0;bc=c[a+1328>>2]|0;cc=c[a+1336>>2]|0;dc=c[a+1344>>2]|0;ec=c[a+1352>>2]|0;fc=c[a+1360>>2]|0;gc=c[a+1368>>2]|0;hc=c[a+1376>>2]|0;ic=c[a+1384>>2]|0;jc=c[a+1392>>2]|0;kc=c[a+1400>>2]|0;lc=c[a+1408>>2]|0;mc=c[a+1416>>2]|0;nc=c[a+1424>>2]|0;oc=c[a+1432>>2]|0;pc=c[a+1440>>2]|0;qc=c[a+1448>>2]|0;rc=c[a+1456>>2]|0;sc=c[a+1464>>2]|0;tc=c[a+1472>>2]|0;uc=c[a+1480>>2]|0;vc=c[a+1488>>2]|0;wc=c[a+1496>>2]|0;xc=c[a+1504>>2]|0;yc=c[a+1512>>2]|0;zc=c[a+1520>>2]|0;Ac=c[a+1528>>2]|0;Bc=c[a+1536>>2]|0;Cc=c[a+1544>>2]|0;Dc=c[a+1552>>2]|0;Ec=c[a+1560>>2]|0;Fc=c[a+1568>>2]|0;Gc=c[a+1576>>2]|0;Hc=c[a+1584>>2]|0;Ic=c[a+1592>>2]|0;Jc=c[a+1600>>2]|0;Kc=c[a+1608>>2]|0;Lc=c[a+1616>>2]|0;Mc=c[a+1624>>2]|0;Nc=c[a+1632>>2]|0;Oc=c[a+1640>>2]|0;Pc=c[a+1648>>2]|0;Qc=c[a+1656>>2]|0;Rc=c[a+1664>>2]|0;Sc=c[a+1672>>2]|0;Tc=c[a+1680>>2]|0;Uc=c[a+1688>>2]|0;Vc=c[a+1696>>2]|0;Wc=c[a+1704>>2]|0;Xc=c[a+1712>>2]|0;Yc=c[a+1720>>2]|0;Zc=c[a+1728>>2]|0;_c=c[a+1736>>2]|0;$c=c[a+1744>>2]|0;ad=c[a+1752>>2]|0;bd=c[a+1760>>2]|0;cd=c[a+1768>>2]|0;dd=c[a+1776>>2]|0;ed=c[a+1784>>2]|0;fd=c[a+1792>>2]|0;gd=c[a+1800>>2]|0;hd=c[a+1808>>2]|0;id=c[a+1816>>2]|0;jd=c[a+1824>>2]|0;kd=c[a+1832>>2]|0;ld=c[a+1840>>2]|0;md=c[a+1848>>2]|0;nd=c[a+1856>>2]|0;od=c[a+1864>>2]|0;pd=c[a+1872>>2]|0;qd=c[a+1880>>2]|0;rd=c[a+1888>>2]|0;sd=c[a+1896>>2]|0;td=c[a+1904>>2]|0;ud=c[a+1912>>2]|0;vd=c[a+1920>>2]|0;wd=c[a+1928>>2]|0;xd=c[a+1936>>2]|0;yd=c[a+1944>>2]|0;zd=c[a+1952>>2]|0;Ad=c[a+1960>>2]|0;Bd=c[a+1968>>2]|0;Cd=c[a+1976>>2]|0;Dd=c[a+1984>>2]|0;Ed=c[a+1992>>2]|0;Fd=c[a+2e3>>2]|0;Gd=c[a+2008>>2]|0;Hd=c[a+2016>>2]|0;Id=c[a+2024>>2]|0;Jd=c[a+2032>>2]|0;Kd=c[a+2040>>2]|0;Ld=c[a+2048>>2]|0;Md=c[a+2056>>2]|0;Nd=c[a+2064>>2]|0;Od=c[a+2072>>2]|0;Pd=c[a+2080>>2]|0;Qd=c[a+2088>>2]|0;Rd=c[a+2096>>2]|0;Sd=c[a+2104>>2]|0;Td=c[a+2112>>2]|0;Ud=c[a+2120>>2]|0;Vd=c[a+2128>>2]|0;Wd=c[a+2136>>2]|0;Xd=c[a+2144>>2]|0;Yd=c[a+2152>>2]|0;Zd=c[a+2160>>2]|0;_d=c[a+2168>>2]|0;$d=c[a+2176>>2]|0;ae=c[a+2184>>2]|0;be=c[a+2192>>2]|0;ce=c[a+2200>>2]|0;de=c[a+2208>>2]|0;ee=c[a+2216>>2]|0;fe=c[a+2224>>2]|0;ge=c[a+2232>>2]|0;he=c[a+2240>>2]|0;ie=c[a+2248>>2]|0;je=c[a+2256>>2]|0;ke=c[a+2264>>2]|0;le=c[a+2272>>2]|0;me=c[a+2280>>2]|0;ne=c[a+2288>>2]|0;oe=c[a+2296>>2]|0;pe=c[a+2304>>2]|0;qe=c[a+2312>>2]|0;re=c[a+2320>>2]|0;se=c[a+2328>>2]|0;te=c[a+2336>>2]|0;ue=c[a+2344>>2]|0;ve=c[a+2352>>2]|0;we=c[a+2360>>2]|0;xe=c[a+2368>>2]|0;ye=c[a+2376>>2]|0;ze=c[a+2384>>2]|0;Ae=c[a+2392>>2]|0;Be=c[a+2400>>2]|0;Ce=c[a+2408>>2]|0;De=c[a+2416>>2]|0;Ee=c[a+2424>>2]|0;Fe=c[a+2432>>2]|0;Ge=c[a+2440>>2]|0;He=c[a+2448>>2]|0;Ie=c[a+2456>>2]|0;Je=c[a+2464>>2]|0;Ke=c[a+2472>>2]|0;Le=c[a+2480>>2]|0;Me=c[a+2488>>2]|0;Ne=c[a+2496>>2]|0;Oe=c[a+2504>>2]|0;Pe=c[a+2512>>2]|0;Qe=c[a+2520>>2]|0;Re=c[a+2528>>2]|0;Se=c[a+2536>>2]|0;Te=c[a+2544>>2]|0;Ue=c[a+2552>>2]|0;Ve=c[a+2560>>2]|0;We=c[a+2568>>2]|0;Xe=c[a+2576>>2]|0;Ye=c[a+2584>>2]|0;Ze=c[a+2592>>2]|0;_e=c[a+2600>>2]|0;$e=c[a+2608>>2]|0;af=c[a+2616>>2]|0;bf=c[a+2624>>2]|0;cf=c[a+2632>>2]|0;df=c[a+2640>>2]|0;ef=c[a+2648>>2]|0;ff=c[a+2656>>2]|0;gf=c[a+2664>>2]|0;hf=c[a+2672>>2]|0;jf=c[a+2680>>2]|0;kf=c[a+2688>>2]|0;lf=c[a+2696>>2]|0;mf=c[a+2704>>2]|0;nf=c[a+2712>>2]|0;of=c[a+2720>>2]|0;pf=c[a+2728>>2]|0;qf=c[a+2736>>2]|0;rf=c[a+2744>>2]|0;sf=c[a+2752>>2]|0;tf=c[a+2760>>2]|0;uf=c[a+2768>>2]|0;vf=c[a+2776>>2]|0;wf=c[a+2784>>2]|0;xf=c[a+2792>>2]|0;yf=c[a+2800>>2]|0;zf=c[a+2808>>2]|0;Af=c[a+2816>>2]|0;Bf=c[a+2824>>2]|0;Cf=c[a+2832>>2]|0;Df=c[a+2840>>2]|0;Ef=c[a+2848>>2]|0;Ff=c[a+2856>>2]|0;Gf=c[a+2864>>2]|0;Hf=c[a+2872>>2]|0;If=c[a+2880>>2]|0;Jf=c[a+2888>>2]|0;Kf=c[a+2896>>2]|0;Lf=c[a+2904>>2]|0;Mf=c[a+2912>>2]|0;Nf=c[a+2920>>2]|0;Of=c[a+2928>>2]|0;Pf=c[a+2936>>2]|0;Qf=c[a+2944>>2]|0;Rf=c[a+2952>>2]|0;Sf=c[a+2960>>2]|0;Tf=c[a+2968>>2]|0;Uf=c[a+2976>>2]|0;Vf=c[a+2984>>2]|0;Wf=c[a+2992>>2]|0;Xf=c[a+3e3>>2]|0;Yf=c[a+3008>>2]|0;Zf=c[a+3016>>2]|0;_f=c[a+3024>>2]|0;$f=c[a+3032>>2]|0;ag=c[a+3040>>2]|0;bg=c[a+3048>>2]|0;cg=c[a+3056>>2]|0;dg=c[a+3064>>2]|0;eg=c[a+3072>>2]|0;fg=c[a+3080>>2]|0;gg=c[a+3088>>2]|0;hg=c[a+3096>>2]|0;ig=c[a+3104>>2]|0;jg=c[a+3112>>2]|0;kg=c[a+3120>>2]|0;lg=c[a+3128>>2]|0;mg=c[a+3136>>2]|0;ng=c[a+3144>>2]|0;og=c[a+3152>>2]|0;pg=c[a+3160>>2]|0;qg=c[a+3168>>2]|0;rg=c[a+3176>>2]|0;sg=c[a+3184>>2]|0;tg=c[a+3192>>2]|0;ug=c[a+3200>>2]|0;vg=c[a+3208>>2]|0;wg=c[a+3216>>2]|0;xg=c[a+3224>>2]|0;yg=c[a+3232>>2]|0;zg=c[a+3240>>2]|0;Ag=c[a+3248>>2]|0;Bg=c[a+3256>>2]|0;Cg=c[a+3264>>2]|0;Dg=c[a+3272>>2]|0;Eg=c[a+3280>>2]|0;Fg=c[a+3288>>2]|0;Gg=c[a+3296>>2]|0;Hg=c[a+3304>>2]|0;Ig=c[a+3312>>2]|0;Jg=c[a+3320>>2]|0;Kg=c[a+3328>>2]|0;Lg=c[a+3336>>2]|0;Mg=c[a+3344>>2]|0;Ng=c[a+3352>>2]|0;Og=c[a+3360>>2]|0;Pg=c[a+3368>>2]|0;Qg=c[a+3376>>2]|0;Rg=c[a+3384>>2]|0;Sg=c[a+3392>>2]|0;Tg=c[a+3400>>2]|0;Ug=c[a+3408>>2]|0;Vg=c[a+3416>>2]|0;Wg=c[a+3424>>2]|0;Xg=c[a+3432>>2]|0;Yg=c[a+3440>>2]|0;Zg=c[a+3448>>2]|0;_g=c[a+3456>>2]|0;$g=c[a+3464>>2]|0;ah=c[a+3472>>2]|0;bh=c[a+3480>>2]|0;ch=c[a+3488>>2]|0;dh=c[a+3496>>2]|0;eh=c[a+3504>>2]|0;fh=c[a+3512>>2]|0;gh=c[a+3520>>2]|0;hh=c[a+3528>>2]|0;ih=c[a+3536>>2]|0;jh=c[a+3544>>2]|0;kh=c[a+3552>>2]|0;lh=c[a+3560>>2]|0;mh=c[a+3568>>2]|0;nh=c[a+3576>>2]|0;oh=c[a+3584>>2]|0;ph=c[a+3592>>2]|0;qh=c[a+3600>>2]|0;rh=c[a+3608>>2]|0;sh=c[a+3616>>2]|0;th=c[a+3624>>2]|0;uh=c[a+3632>>2]|0;vh=c[a+3640>>2]|0;wh=c[a+3648>>2]|0;xh=c[a+3656>>2]|0;yh=c[a+3664>>2]|0;zh=c[a+3672>>2]|0;Ah=c[a+3680>>2]|0;Bh=c[a+3688>>2]|0;Ch=c[a+3696>>2]|0;Dh=c[a+3704>>2]|0;Eh=c[a+3712>>2]|0;Fh=c[a+3720>>2]|0;Gh=c[a+3728>>2]|0;Hh=c[a+3736>>2]|0;Ih=c[a+3744>>2]|0;Jh=c[a+3752>>2]|0;Kh=c[a+3760>>2]|0;Lh=c[a+3768>>2]|0;Mh=c[a+3776>>2]|0;Nh=c[a+3784>>2]|0;Oh=c[a+3792>>2]|0;Ph=c[a+3800>>2]|0;Qh=c[a+3808>>2]|0;Rh=c[a+3816>>2]|0;Sh=c[a+3824>>2]|0;Th=c[a+3832>>2]|0;Uh=c[a+3840>>2]|0;Vh=c[a+3848>>2]|0;Wh=c[a+3856>>2]|0;Xh=c[a+3864>>2]|0;Yh=c[a+3872>>2]|0;Zh=c[a+3880>>2]|0;_h=c[a+3888>>2]|0;$h=c[a+3896>>2]|0;ai=c[a+3904>>2]|0;bi=c[a+3912>>2]|0;ci=c[a+3920>>2]|0;di=c[a+3928>>2]|0;ei=c[a+3936>>2]|0;fi=c[a+3944>>2]|0;gi=c[a+3952>>2]|0;hi=c[a+3960>>2]|0;ii=c[a+3968>>2]|0;ji=c[a+3976>>2]|0;ki=c[a+3984>>2]|0;li=c[a+3992>>2]|0;mi=c[a+4e3>>2]|0;ni=c[a+4008>>2]|0;oi=c[a+4016>>2]|0;pi=c[a+4024>>2]|0;qi=c[a+4032>>2]|0;ri=c[a+4040>>2]|0;si=c[a+4048>>2]|0;ti=c[a+4056>>2]|0;ui=c[a+4064>>2]|0;vi=c[a+4072>>2]|0;wi=c[a+4080>>2]|0;xi=c[a+4088>>2]|0;yi=c[a+4096>>2]|0;zi=c[a+4104>>2]|0;Ai=c[a+4112>>2]|0;Bi=c[a+4120>>2]|0;Ci=c[a+4128>>2]|0;Di=c[a+4136>>2]|0;Ei=c[a+4144>>2]|0;Fi=c[a+4152>>2]|0;Gi=c[a+4160>>2]|0;Hi=c[a+4168>>2]|0;Ii=c[a+4176>>2]|0;Ji=c[a+4184>>2]|0;Ki=c[a+4192>>2]|0;Li=c[a+4200>>2]|0;Mi=c[a+4208>>2]|0;Ni=c[a+4216>>2]|0;Oi=c[a+4224>>2]|0;Pi=c[a+4232>>2]|0;Qi=c[a+4240>>2]|0;Ri=c[a+4248>>2]|0;Si=c[a+4256>>2]|0;Ti=c[a+4264>>2]|0;Ui=c[a+4272>>2]|0;Vi=c[a+4280>>2]|0;Wi=c[a+4288>>2]|0;Xi=c[a+4296>>2]|0;Yi=c[a+4304>>2]|0;Zi=c[a+4312>>2]|0;_i=c[a+4320>>2]|0;$i=c[a+7880>>2]|0;aj=c[a+7888>>2]|0;bj=c[a+7896>>2]|0;cj=c[a+7912>>2]|0;dj=c[a+7920>>2]|0;ej=c[a+7928>>2]|0;fj=c[a+7936>>2]|0;gj=c[a+7944>>2]|0;hj=c[a+7952>>2]|0;ij=c[a+7960>>2]|0;jj=c[a+7968>>2]|0;kj=c[a+7976>>2]|0;lj=c[a+7984>>2]|0;mj=c[a+8008>>2]|0;nj=c[a+8016>>2]|0;oj=c[a+8024>>2]|0;pj=c[a+8032>>2]|0;qj=c[a+8040>>2]|0;rj=c[a+8048>>2]|0;sj=c[a+8056>>2]|0;tj=c[a+8064>>2]|0;uj=c[a+8072>>2]|0;vj=c[a+8080>>2]|0;wj=c[a+8096>>2]|0;xj=c[a+8104>>2]|0;yj=c[a+8112>>2]|0;zj=c[a+8120>>2]|0;Aj=c[a+8128>>2]|0;Bj=c[a+8136>>2]|0;Cj=c[a+8144>>2]|0;Dj=c[a+8152>>2]|0;Ej=c[a+8160>>2]|0;Fj=c[a+8168>>2]|0;Gj=c[a+8184>>2]|0;Hj=c[a+8192>>2]|0;Ij=c[a+8200>>2]|0;Jj=c[a+8208>>2]|0;Kj=c[a+8216>>2]|0;Lj=c[a+8224>>2]|0;Mj=c[a+8232>>2]|0;Nj=c[a+8240>>2]|0;Oj=c[a+8248>>2]|0;Pj=c[a+8256>>2]|0;Qj=c[a+8272>>2]|0;Rj=c[a+8280>>2]|0;Sj=c[a+8288>>2]|0;Tj=c[a+8296>>2]|0;Uj=c[a+8304>>2]|0;Vj=c[a+8312>>2]|0;Wj=c[a+8320>>2]|0;i=i+24|0;Wj=i;i=i+24|0;Vj=i;i=i+24|0;Uj=i;i=i+24|0;Tj=i;i=i+24|0;Sj=i;i=i+24|0;Rj=i;i=i+24|0;Qj=i;i=i+24|0;Pj=i;i=i+24|0;Oj=i;i=i+24|0;Nj=i;i=i+24|0;Mj=i;i=i+24|0;Lj=i;i=i+24|0;Kj=i;i=i+24|0;Jj=i;i=i+24|0;Ij=i;i=i+24|0;Hj=i;i=i+24|0;Gj=i;i=i+24|0;Fj=i;i=i+24|0;Ej=i;i=i+24|0;Dj=i;i=i+24|0;Cj=i;i=i+24|0;Bj=i;i=i+24|0;Aj=i;i=i+24|0;zj=i;i=i+24|0;yj=i;i=i+24|0;xj=i;i=i+24|0;wj=i;i=i+24|0;vj=i;i=i+24|0;uj=i;i=i+24|0;tj=i;i=i+24|0;sj=i;i=i+24|0;rj=i;i=i+24|0;qj=i;i=i+24|0;pj=i;i=i+24|0;oj=i;i=i+24|0;nj=i;i=i+24|0;mj=i;i=i+24|0;lj=i;i=i+24|0;kj=i;i=i+24|0;jj=i;i=i+24|0;ij=i;i=i+24|0;hj=i;i=i+24|0;gj=i;i=i+24|0;fj=i;i=i+24|0;ej=i;i=i+24|0;dj=i;i=i+24|0;cj=i;i=i+24|0;bj=i;i=i+24|0;aj=i;i=i+24|0;$i=i;i=i+24|0;Xj=i;i=i+24|0;Yj=i;i=i+24|0;Zj=i;i=i+24|0;_j=i;i=i+24|0;$j=i;i=i+24|0;ak=i;i=i+24|0;bk=i;i=i+24|0;ck=i;i=i+24|0;dk=i;i=i+24|0;ek=i;i=i+24|0;fk=i;i=i+24|0;gk=i;i=i+24|0;hk=i;i=i+24|0;ik=i;i=i+24|0;jk=i;i=i+24|0;kk=i;i=i+24|0;lk=i;i=i+24|0;mk=i;i=i+24|0;nk=i;i=i+24|0;ok=i;i=i+24|0;pk=i;i=i+24|0;qk=i;i=i+24|0;rk=i;i=i+24|0;sk=i;i=i+24|0;tk=i;i=i+24|0;uk=i;i=i+24|0;vk=i;i=i+24|0;wk=i;i=i+24|0;xk=i;i=i+24|0;yk=i;i=i+24|0;zk=i;i=i+24|0;Ak=i;i=i+24|0;Bk=i;i=i+24|0;Ck=i;i=i+24|0;Dk=i;i=i+24|0;Ek=i;i=i+24|0;Fk=i;i=i+24|0;Gk=i;i=i+24|0;Hk=i;i=i+24|0;Ik=i;i=i+24|0;Jk=i;i=i+24|0;Kk=i;i=i+24|0;Lk=i;i=i+24|0;Mk=i;i=i+24|0;Nk=i;i=i+24|0;Ok=i;i=i+24|0;Pk=i;i=i+24|0;Qk=i;i=i+24|0;Rk=i;i=i+24|0;Sk=i;i=i+24|0;Tk=i;i=i+24|0;Uk=i;i=i+24|0;Vk=i;i=i+24|0;Wk=i;i=i+24|0;Xk=i;i=i+24|0;Yk=i;i=i+24|0;Zk=i;i=i+24|0;_k=i;i=i+24|0;$k=i;i=i+24|0;al=i;i=i+24|0;bl=i;i=i+24|0;cl=i;i=i+24|0;dl=i;i=i+24|0;el=i;i=i+24|0;fl=i;i=i+24|0;gl=i;i=i+24|0;hl=i;i=i+24|0;il=i;i=i+24|0;jl=i;i=i+24|0;kl=i;i=i+24|0;ll=i;i=i+24|0;ml=i;i=i+24|0;nl=i;i=i+24|0;ol=i;i=i+24|0;pl=i;i=i+24|0;ql=i;i=i+24|0;rl=i;i=i+24|0;sl=i;i=i+24|0;tl=i;i=i+24|0;ul=i;i=i+24|0;vl=i;i=i+24|0;wl=i;i=i+24|0;xl=i;i=i+24|0;yl=i;i=i+24|0;zl=i;i=i+24|0;Al=i;i=i+24|0;Bl=i;i=i+24|0;Cl=i;i=i+8|0;d=i;i=i+16|0;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+16|0;$=i;i=i+16|0;aa=i;i=i+16|0;ba=i;i=i+16|0;ca=i;i=i+16|0;da=i;i=i+16|0;ea=i;i=i+16|0;fa=i;i=i+16|0;ga=i;i=i+16|0;ha=i;i=i+16|0;ia=i;i=i+16|0;ja=i;i=i+16|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+16|0;na=i;i=i+16|0;oa=i;i=i+16|0;pa=i;i=i+16|0;qa=i;i=i+16|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+16|0;Xa=i;i=i+16|0;Ya=i;i=i+16|0;Za=i;i=i+16|0;_a=i;i=i+16|0;$a=i;i=i+16|0;ab=i;i=i+16|0;bb=i;i=i+16|0;cb=i;i=i+16|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+16|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+16|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+16|0;fc=i;i=i+16|0;gc=i;i=i+16|0;hc=i;i=i+16|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+16|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+16|0;sc=i;i=i+16|0;tc=i;i=i+16|0;uc=i;i=i+16|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+16|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+16|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+16|0;Ec=i;i=i+16|0;Fc=i;i=i+16|0;Gc=i;i=i+16|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+16|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+16|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+16|0;Qc=i;i=i+16|0;Rc=i;i=i+16|0;Sc=i;i=i+16|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=i;i=i+16|0;Wc=i;i=i+16|0;Xc=i;i=i+16|0;Yc=i;i=i+16|0;Zc=i;i=i+16|0;_c=i;i=i+16|0;$c=i;i=i+16|0;ad=i;i=i+16|0;bd=i;i=i+16|0;cd=i;i=i+16|0;dd=i;i=i+16|0;ed=i;i=i+16|0;fd=i;i=i+16|0;gd=i;i=i+16|0;hd=i;i=i+16|0;id=i;i=i+16|0;jd=i;i=i+16|0;kd=i;i=i+16|0;ld=i;i=i+16|0;md=i;i=i+16|0;nd=i;i=i+16|0;od=i;i=i+16|0;pd=i;i=i+16|0;qd=i;i=i+16|0;rd=i;i=i+16|0;sd=i;i=i+16|0;td=i;i=i+16|0;ud=i;i=i+16|0;vd=i;i=i+16|0;wd=i;i=i+16|0;xd=i;i=i+16|0;yd=i;i=i+16|0;zd=i;i=i+16|0;Ad=i;i=i+16|0;Bd=i;i=i+16|0;Cd=i;i=i+16|0;Dd=i;i=i+16|0;Ed=i;i=i+16|0;Fd=i;i=i+16|0;Gd=i;i=i+16|0;Hd=i;i=i+16|0;Id=i;i=i+16|0;Jd=i;i=i+16|0;Kd=i;i=i+16|0;Ld=i;i=i+16|0;Md=i;i=i+16|0;Nd=i;i=i+16|0;Od=i;i=i+16|0;Pd=i;i=i+16|0;Qd=i;i=i+16|0;Rd=i;i=i+16|0;Sd=i;i=i+16|0;Td=i;i=i+16|0;Ud=i;i=i+16|0;Vd=i;i=i+16|0;Wd=i;i=i+16|0;Xd=i;i=i+16|0;Yd=i;i=i+16|0;Zd=i;i=i+16|0;_d=i;i=i+16|0;$d=i;i=i+16|0;ae=i;i=i+16|0;be=i;i=i+16|0;ce=i;i=i+16|0;de=i;i=i+16|0;ee=i;i=i+16|0;fe=i;i=i+16|0;ge=i;i=i+16|0;he=i;i=i+16|0;ie=i;i=i+16|0;je=i;i=i+16|0;ke=i;i=i+16|0;le=i;i=i+16|0;me=i;i=i+16|0;ne=i;i=i+16|0;oe=i;i=i+16|0;pe=i;i=i+16|0;qe=i;i=i+16|0;re=i;i=i+16|0;se=i;i=i+16|0;te=i;i=i+16|0;ue=i;i=i+16|0;ve=i;i=i+16|0;we=i;i=i+16|0;xe=i;i=i+16|0;ye=i;i=i+16|0;ze=i;i=i+16|0;Ae=i;i=i+16|0;Be=i;i=i+16|0;Ce=i;i=i+16|0;De=i;i=i+16|0;Ee=i;i=i+16|0;Fe=i;i=i+16|0;Ge=i;i=i+16|0;He=i;i=i+16|0;Ie=i;i=i+16|0;Je=i;i=i+16|0;Ke=i;i=i+16|0;Le=i;i=i+16|0;Me=i;i=i+16|0;Ne=i;i=i+16|0;Oe=i;i=i+16|0;Pe=i;i=i+16|0;Qe=i;i=i+16|0;Re=i;i=i+16|0;Se=i;i=i+16|0;Te=i;i=i+16|0;Ue=i;i=i+16|0;Ve=i;i=i+16|0;We=i;i=i+16|0;Xe=i;i=i+16|0;Ye=i;i=i+16|0;Ze=i;i=i+16|0;_e=i;i=i+16|0;$e=i;i=i+16|0;af=i;i=i+16|0;bf=i;i=i+16|0;cf=i;i=i+16|0;df=i;i=i+16|0;ef=i;i=i+16|0;ff=i;i=i+16|0;gf=i;i=i+16|0;hf=i;i=i+16|0;jf=i;i=i+16|0;kf=i;i=i+16|0;lf=i;i=i+16|0;mf=i;i=i+16|0;nf=i;i=i+16|0;of=i;i=i+16|0;pf=i;i=i+16|0;qf=i;i=i+16|0;rf=i;i=i+16|0;sf=i;i=i+16|0;tf=i;i=i+16|0;uf=i;i=i+16|0;vf=i;i=i+16|0;wf=i;i=i+16|0;xf=i;i=i+16|0;yf=i;i=i+16|0;zf=i;i=i+16|0;Af=i;i=i+16|0;Bf=i;i=i+16|0;Cf=i;i=i+16|0;Df=i;i=i+16|0;Ef=i;i=i+16|0;Ff=i;i=i+16|0;Gf=i;i=i+16|0;Hf=i;i=i+16|0;If=i;i=i+16|0;Jf=i;i=i+16|0;Kf=i;i=i+16|0;Lf=i;i=i+16|0;Mf=i;i=i+16|0;Nf=i;i=i+16|0;Of=i;i=i+16|0;Pf=i;i=i+16|0;Qf=i;i=i+16|0;Rf=i;i=i+16|0;Sf=i;i=i+16|0;Tf=i;i=i+16|0;Uf=i;i=i+16|0;Vf=i;i=i+16|0;Wf=i;i=i+16|0;Xf=i;i=i+16|0;Yf=i;i=i+16|0;Zf=i;i=i+16|0;_f=i;i=i+16|0;$f=i;i=i+16|0;ag=i;i=i+16|0;bg=i;i=i+16|0;cg=i;i=i+16|0;dg=i;i=i+16|0;eg=i;i=i+16|0;fg=i;i=i+16|0;gg=i;i=i+16|0;hg=i;i=i+16|0;ig=i;i=i+16|0;jg=i;i=i+16|0;kg=i;i=i+16|0;lg=i;i=i+16|0;mg=i;i=i+16|0;ng=i;i=i+16|0;og=i;i=i+16|0;pg=i;i=i+16|0;qg=i;i=i+16|0;rg=i;i=i+16|0;sg=i;i=i+16|0;tg=i;i=i+16|0;ug=i;i=i+16|0;vg=i;i=i+16|0;wg=i;i=i+16|0;xg=i;i=i+16|0;yg=i;i=i+16|0;zg=i;i=i+16|0;Ag=i;i=i+16|0;Bg=i;i=i+16|0;Cg=i;i=i+16|0;Dg=i;i=i+16|0;Eg=i;i=i+16|0;Fg=i;i=i+16|0;Gg=i;i=i+16|0;Hg=i;i=i+16|0;Ig=i;i=i+16|0;Jg=i;i=i+16|0;Kg=i;i=i+16|0;Lg=i;i=i+16|0;Mg=i;i=i+16|0;Ng=i;i=i+16|0;Og=i;i=i+16|0;Pg=i;i=i+16|0;Qg=i;i=i+16|0;Rg=i;i=i+16|0;Sg=i;i=i+16|0;Tg=i;i=i+16|0;Ug=i;i=i+16|0;Vg=i;i=i+16|0;Wg=i;i=i+16|0;Xg=i;i=i+16|0;Yg=i;i=i+16|0;Zg=i;i=i+16|0;_g=i;i=i+16|0;$g=i;i=i+16|0;ah=i;i=i+16|0;bh=i;i=i+16|0;ch=i;i=i+16|0;dh=i;i=i+16|0;eh=i;i=i+16|0;fh=i;i=i+16|0;gh=i;i=i+16|0;hh=i;i=i+16|0;ih=i;i=i+16|0;jh=i;i=i+16|0;kh=i;i=i+16|0;lh=i;i=i+16|0;mh=i;i=i+16|0;nh=i;i=i+16|0;oh=i;i=i+16|0;ph=i;i=i+16|0;qh=i;i=i+16|0;rh=i;i=i+16|0;sh=i;i=i+16|0;th=i;i=i+16|0;uh=i;i=i+16|0;vh=i;i=i+16|0;wh=i;i=i+16|0;xh=i;i=i+16|0;yh=i;i=i+16|0;zh=i;i=i+16|0;Ah=i;i=i+16|0;Bh=i;i=i+16|0;Ch=i;i=i+16|0;Dh=i;i=i+16|0;Eh=i;i=i+16|0;Fh=i;i=i+16|0;Gh=i;i=i+16|0;Hh=i;i=i+16|0;Ih=i;i=i+16|0;Jh=i;i=i+16|0;Kh=i;i=i+16|0;Lh=i;i=i+16|0;Mh=i;i=i+16|0;Nh=i;i=i+16|0;Oh=i;i=i+16|0;Ph=i;i=i+16|0;Qh=i;i=i+16|0;Rh=i;i=i+16|0;Sh=i;i=i+16|0;Th=i;i=i+16|0;Uh=i;i=i+16|0;Vh=i;i=i+16|0;Wh=i;i=i+16|0;Xh=i;i=i+16|0;Yh=i;i=i+16|0;Zh=i;i=i+16|0;_h=i;i=i+16|0;$h=i;i=i+16|0;ai=i;i=i+16|0;bi=i;i=i+16|0;ci=i;i=i+16|0;di=i;i=i+16|0;ei=i;i=i+16|0;fi=i;i=i+16|0;gi=i;i=i+16|0;hi=i;i=i+16|0;ii=i;i=i+16|0;ji=i;i=i+16|0;ki=i;i=i+16|0;li=i;i=i+16|0;mi=i;i=i+16|0;ni=i;i=i+16|0;oi=i;i=i+16|0;pi=i;i=i+16|0;qi=i;i=i+16|0;ri=i;i=i+16|0;si=i;i=i+16|0;ti=i;i=i+16|0;ui=i;i=i+16|0;vi=i;i=i+16|0;wi=i;i=i+16|0;xi=i;i=i+16|0;yi=i;i=i+16|0;zi=i;i=i+16|0;Ai=i;i=i+16|0;Bi=i;i=i+16|0;Ci=i;i=i+16|0;Di=i;i=i+16|0;Ei=i;i=i+16|0;Fi=i;i=i+16|0;Gi=i;i=i+16|0;Hi=i;i=i+16|0;Ii=i;i=i+16|0;Ji=i;i=i+16|0;Ki=i;i=i+16|0;Li=i;i=i+16|0;Mi=i;i=i+16|0;Ni=i;i=i+16|0;Oi=i;i=i+16|0;Pi=i;i=i+16|0;Qi=i;i=i+16|0;Ri=i;i=i+16|0;Si=i;i=i+16|0;Ti=i;i=i+16|0;Ui=i;i=i+16|0;Vi=i;i=i+16|0;Wi=i;i=i+16|0;Xi=i;i=i+16|0;Yi=i;i=i+16|0;Zi=i;i=i+16|0;_i=i;i=i+16|0;b=i;i=i+8|0;rH(4,0,7032,Cl);h[k>>3]=0.0;c[Bl>>2]=c[k>>2];c[Bl+4>>2]=c[k+4>>2];h[k>>3]=0.0;c[(Bl+8|0)>>2]=c[k>>2];c[(Bl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.005;c[(Bl+16|0)>>2]=c[k>>2];c[(Bl+16|0)+4>>2]=c[k+4>>2];sI(e,4,0.0,Bl);h[k>>3]=793537.0e-10;c[Al>>2]=c[k>>2];c[Al+4>>2]=c[k+4>>2];h[k>>3]=-197914.0e-10;c[(Al+8|0)>>2]=c[k>>2];c[(Al+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.005;c[(Al+16|0)>>2]=c[k>>2];c[(Al+16|0)+4>>2]=c[k+4>>2];sI(f,4,2.61165e-7,Al);h[k>>3]=793537.0e-10;c[zl>>2]=c[k>>2];c[zl+4>>2]=c[k+4>>2];h[k>>3]=-197914.0e-10;c[(zl+8|0)>>2]=c[k>>2];c[(zl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.005;c[(zl+16|0)>>2]=c[k>>2];c[(zl+16|0)+4>>2]=c[k+4>>2];sI(g,4,2.61165e-7,zl);h[k>>3]=.0300045;c[yl>>2]=c[k>>2];c[yl+4>>2]=c[k+4>>2];h[k>>3]=-.00748335;c[(yl+8|0)>>2]=c[k>>2];c[(yl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.005;c[(yl+16|0)>>2]=c[k>>2];c[(yl+16|0)+4>>2]=c[k+4>>2];sI(j,4,1.0e-4,yl);h[k>>3]=.05926;c[xl>>2]=c[k>>2];c[xl+4>>2]=c[k+4>>2];h[k>>3]=-.0147799;c[(xl+8|0)>>2]=c[k>>2];c[(xl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.005;c[(xl+16|0)>>2]=c[k>>2];c[(xl+16|0)+4>>2]=c[k+4>>2];sI(l,4,2.0e-4,xl);h[k>>3]=.0877841;c[wl>>2]=c[k>>2];c[wl+4>>2]=c[k+4>>2];h[k>>3]=-.021894;c[(wl+8|0)>>2]=c[k>>2];c[(wl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499999;c[(wl+16|0)>>2]=c[k>>2];c[(wl+16|0)+4>>2]=c[k+4>>2];sI(m,4,3.0e-4,wl);h[k>>3]=.115593;c[vl>>2]=c[k>>2];c[vl+4>>2]=c[k+4>>2];h[k>>3]=-.036608;c[(vl+8|0)>>2]=c[k>>2];c[(vl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499997;c[(vl+16|0)>>2]=c[k>>2];c[(vl+16|0)+4>>2]=c[k+4>>2];sI(n,4,4.0e-4,vl);h[k>>3]=.142707;c[ul>>2]=c[k>>2];c[ul+4>>2]=c[k+4>>2];h[k>>3]=-.0568957;c[(ul+8|0)>>2]=c[k>>2];c[(ul+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499994;c[(ul+16|0)>>2]=c[k>>2];c[(ul+16|0)+4>>2]=c[k+4>>2];sI(o,4,5.0e-4,ul);h[k>>3]=.169143;c[tl>>2]=c[k>>2];c[tl+4>>2]=c[k+4>>2];h[k>>3]=-.076676;c[(tl+8|0)>>2]=c[k>>2];c[(tl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499988;c[(tl+16|0)>>2]=c[k>>2];c[(tl+16|0)+4>>2]=c[k+4>>2];sI(p,4,6.0e-4,tl);h[k>>3]=.194915;c[sl>>2]=c[k>>2];c[sl+4>>2]=c[k+4>>2];h[k>>3]=-.0959614;c[(sl+8|0)>>2]=c[k>>2];c[(sl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0049998;c[(sl+16|0)>>2]=c[k>>2];c[(sl+16|0)+4>>2]=c[k+4>>2];sI(q,4,7.0e-4,sl);h[k>>3]=.220042;c[rl>>2]=c[k>>2];c[rl+4>>2]=c[k+4>>2];h[k>>3]=-.124763;c[(rl+8|0)>>2]=c[k>>2];c[(rl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499968;c[(rl+16|0)>>2]=c[k>>2];c[(rl+16|0)+4>>2]=c[k+4>>2];sI(r,4,8.0e-4,rl);h[k>>3]=.244539;c[ql>>2]=c[k>>2];c[ql+4>>2]=c[k+4>>2];h[k>>3]=-.155317;c[(ql+8|0)>>2]=c[k>>2];c[(ql+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499951;c[(ql+16|0)>>2]=c[k>>2];c[(ql+16|0)+4>>2]=c[k+4>>2];sI(s,4,9.0e-4,ql);h[k>>3]=.26842;c[pl>>2]=c[k>>2];c[pl+4>>2]=c[k+4>>2];h[k>>3]=-.185107;c[(pl+8|0)>>2]=c[k>>2];c[(pl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499928;c[(pl+16|0)>>2]=c[k>>2];c[(pl+16|0)+4>>2]=c[k+4>>2];sI(t,4,.001,pl);h[k>>3]=.291701;c[ol>>2]=c[k>>2];c[ol+4>>2]=c[k+4>>2];h[k>>3]=-.214153;c[(ol+8|0)>>2]=c[k>>2];c[(ol+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499898;c[(ol+16|0)>>2]=c[k>>2];c[(ol+16|0)+4>>2]=c[k+4>>2];sI(u,4,.0011,ol);h[k>>3]=.314394;c[nl>>2]=c[k>>2];c[nl+4>>2]=c[k+4>>2];h[k>>3]=-.249655;c[(nl+8|0)>>2]=c[k>>2];c[(nl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0049986;c[(nl+16|0)>>2]=c[k>>2];c[(nl+16|0)+4>>2]=c[k+4>>2];sI(v,4,.0012,nl);h[k>>3]=.336514;c[ml>>2]=c[k>>2];c[ml+4>>2]=c[k+4>>2];h[k>>3]=-.288306;c[(ml+8|0)>>2]=c[k>>2];c[(ml+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499812;c[(ml+16|0)>>2]=c[k>>2];c[(ml+16|0)+4>>2]=c[k+4>>2];sI(w,4,.0013,ml);h[k>>3]=.358074;c[ll>>2]=c[k>>2];c[ll+4>>2]=c[k+4>>2];h[k>>3]=-.325991;c[(ll+8|0)>>2]=c[k>>2];c[(ll+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499754;c[(ll+16|0)>>2]=c[k>>2];c[(ll+16|0)+4>>2]=c[k+4>>2];sI(x,4,.0014,ll);h[k>>3]=.379086;c[kl>>2]=c[k>>2];c[kl+4>>2]=c[k+4>>2];h[k>>3]=-.362735;c[(kl+8|0)>>2]=c[k>>2];c[(kl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499682;c[(kl+16|0)>>2]=c[k>>2];c[(kl+16|0)+4>>2]=c[k+4>>2];sI(y,4,.0015,kl);h[k>>3]=.399562;c[jl>>2]=c[k>>2];c[jl+4>>2]=c[k+4>>2];h[k>>3]=-.398563;c[(jl+8|0)>>2]=c[k>>2];c[(jl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499597;c[(jl+16|0)>>2]=c[k>>2];c[(jl+16|0)+4>>2]=c[k+4>>2];sI(z,4,.0016,jl);h[k>>3]=.419514;c[il>>2]=c[k>>2];c[il+4>>2]=c[k+4>>2];h[k>>3]=-.44324;c[(il+8|0)>>2]=c[k>>2];c[(il+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499496;c[(il+16|0)>>2]=c[k>>2];c[(il+16|0)+4>>2]=c[k+4>>2];sI(A,4,.0017,il);h[k>>3]=.438955;c[hl>>2]=c[k>>2];c[hl+4>>2]=c[k+4>>2];h[k>>3]=-.487015;c[(hl+8|0)>>2]=c[k>>2];c[(hl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499378;c[(hl+16|0)>>2]=c[k>>2];c[(hl+16|0)+4>>2]=c[k+4>>2];sI(B,4,.0018,hl);h[k>>3]=.457893;c[gl>>2]=c[k>>2];c[gl+4>>2]=c[k+4>>2];h[k>>3]=-.529698;c[(gl+8|0)>>2]=c[k>>2];c[(gl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499242;c[(gl+16|0)>>2]=c[k>>2];c[(gl+16|0)+4>>2]=c[k+4>>2];sI(C,4,.0019,gl);h[k>>3]=.47634;c[fl>>2]=c[k>>2];c[fl+4>>2]=c[k+4>>2];h[k>>3]=-.571317;c[(fl+8|0)>>2]=c[k>>2];c[(fl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00499085;c[(fl+16|0)>>2]=c[k>>2];c[(fl+16|0)+4>>2]=c[k+4>>2];sI(D,4,.002,fl);h[k>>3]=.494305;c[el>>2]=c[k>>2];c[el+4>>2]=c[k+4>>2];h[k>>3]=-.611901;c[(el+8|0)>>2]=c[k>>2];c[(el+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00498906;c[(el+16|0)>>2]=c[k>>2];c[(el+16|0)+4>>2]=c[k+4>>2];sI(E,4,.0021,el);h[k>>3]=.511799;c[dl>>2]=c[k>>2];c[dl+4>>2]=c[k+4>>2];h[k>>3]=-.657374;c[(dl+8|0)>>2]=c[k>>2];c[(dl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00498704;c[(dl+16|0)>>2]=c[k>>2];c[(dl+16|0)+4>>2]=c[k+4>>2];sI(F,4,.0022,dl);h[k>>3]=.528832;c[cl>>2]=c[k>>2];c[cl+4>>2]=c[k+4>>2];h[k>>3]=-.704491;c[(cl+8|0)>>2]=c[k>>2];c[(cl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00498476;c[(cl+16|0)>>2]=c[k>>2];c[(cl+16|0)+4>>2]=c[k+4>>2];sI(G,4,.0023,cl);h[k>>3]=.545412;c[bl>>2]=c[k>>2];c[bl+4>>2]=c[k+4>>2];h[k>>3]=-.750434;c[(bl+8|0)>>2]=c[k>>2];c[(bl+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00498221;c[(bl+16|0)>>2]=c[k>>2];c[(bl+16|0)+4>>2]=c[k+4>>2];sI(H,4,.0024,bl);h[k>>3]=.561548;c[al>>2]=c[k>>2];c[al+4>>2]=c[k+4>>2];h[k>>3]=-.795237;c[(al+8|0)>>2]=c[k>>2];c[(al+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00497937;c[(al+16|0)>>2]=c[k>>2];c[(al+16|0)+4>>2]=c[k+4>>2];sI(I,4,.0025,al);h[k>>3]=.577248;c[$k>>2]=c[k>>2];c[$k+4>>2]=c[k+4>>2];h[k>>3]=-.83893;c[($k+8|0)>>2]=c[k>>2];c[($k+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00497623;c[($k+16|0)>>2]=c[k>>2];c[($k+16|0)+4>>2]=c[k+4>>2];sI(J,4,.0026,$k);h[k>>3]=.592521;c[_k>>2]=c[k>>2];c[_k+4>>2]=c[k+4>>2];h[k>>3]=-.881543;c[(_k+8|0)>>2]=c[k>>2];c[(_k+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00497277;c[(_k+16|0)>>2]=c[k>>2];c[(_k+16|0)+4>>2]=c[k+4>>2];sI(K,4,.0027,_k);h[k>>3]=.607375;c[Zk>>2]=c[k>>2];c[Zk+4>>2]=c[k+4>>2];h[k>>3]=-.926803;c[(Zk+8|0)>>2]=c[k>>2];c[(Zk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00496896;c[(Zk+16|0)>>2]=c[k>>2];c[(Zk+16|0)+4>>2]=c[k+4>>2];sI(L,4,.0028,Zk);h[k>>3]=.62182;c[Yk>>2]=c[k>>2];c[Yk+4>>2]=c[k+4>>2];h[k>>3]=-.974598;c[(Yk+8|0)>>2]=c[k>>2];c[(Yk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0049648;c[(Yk+16|0)>>2]=c[k>>2];c[(Yk+16|0)+4>>2]=c[k+4>>2];sI(M,4,.0029,Yk);h[k>>3]=.63586;c[Xk>>2]=c[k>>2];c[Xk+4>>2]=c[k+4>>2];h[k>>3]=-1.02121;c[(Xk+8|0)>>2]=c[k>>2];c[(Xk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00496027;c[(Xk+16|0)>>2]=c[k>>2];c[(Xk+16|0)+4>>2]=c[k+4>>2];sI(N,4,.003,Xk);h[k>>3]=.649503;c[Wk>>2]=c[k>>2];c[Wk+4>>2]=c[k+4>>2];h[k>>3]=-1.06667;c[(Wk+8|0)>>2]=c[k>>2];c[(Wk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00495534;c[(Wk+16|0)>>2]=c[k>>2];c[(Wk+16|0)+4>>2]=c[k+4>>2];sI(O,4,.0031,Wk);h[k>>3]=.662756;c[Vk>>2]=c[k>>2];c[Vk+4>>2]=c[k+4>>2];h[k>>3]=-1.11102;c[(Vk+8|0)>>2]=c[k>>2];c[(Vk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00495;c[(Vk+16|0)>>2]=c[k>>2];c[(Vk+16|0)+4>>2]=c[k+4>>2];sI(P,4,.0032,Vk);h[k>>3]=.675625;c[Uk>>2]=c[k>>2];c[Uk+4>>2]=c[k+4>>2];h[k>>3]=-1.15428;c[(Uk+8|0)>>2]=c[k>>2];c[(Uk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00494424;c[(Uk+16|0)>>2]=c[k>>2];c[(Uk+16|0)+4>>2]=c[k+4>>2];sI(Q,4,.0033,Uk);h[k>>3]=.688119;c[Tk>>2]=c[k>>2];c[Tk+4>>2]=c[k+4>>2];h[k>>3]=-1.19648;c[(Tk+8|0)>>2]=c[k>>2];c[(Tk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00493803;c[(Tk+16|0)>>2]=c[k>>2];c[(Tk+16|0)+4>>2]=c[k+4>>2];sI(R,4,.0034,Tk);h[k>>3]=.700242;c[Sk>>2]=c[k>>2];c[Sk+4>>2]=c[k+4>>2];h[k>>3]=-1.23778;c[(Sk+8|0)>>2]=c[k>>2];c[(Sk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00493136;c[(Sk+16|0)>>2]=c[k>>2];c[(Sk+16|0)+4>>2]=c[k+4>>2];sI(S,4,.0035,Sk);h[k>>3]=.712005;c[Rk>>2]=c[k>>2];c[Rk+4>>2]=c[k+4>>2];h[k>>3]=-1.28391;c[(Rk+8|0)>>2]=c[k>>2];c[(Rk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00492421;c[(Rk+16|0)>>2]=c[k>>2];c[(Rk+16|0)+4>>2]=c[k+4>>2];sI(T,4,.0036,Rk);h[k>>3]=.72341;c[Qk>>2]=c[k>>2];c[Qk+4>>2]=c[k+4>>2];h[k>>3]=-1.32891;c[(Qk+8|0)>>2]=c[k>>2];c[(Qk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00491657;c[(Qk+16|0)>>2]=c[k>>2];c[(Qk+16|0)+4>>2]=c[k+4>>2];sI(U,4,.0037,Qk);h[k>>3]=.734463;c[Pk>>2]=c[k>>2];c[Pk+4>>2]=c[k+4>>2];h[k>>3]=-1.3728;c[(Pk+8|0)>>2]=c[k>>2];c[(Pk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00490842;c[(Pk+16|0)>>2]=c[k>>2];c[(Pk+16|0)+4>>2]=c[k+4>>2];sI(V,4,.0038,Pk);h[k>>3]=.74517;c[Ok>>2]=c[k>>2];c[Ok+4>>2]=c[k+4>>2];h[k>>3]=-1.41563;c[(Ok+8|0)>>2]=c[k>>2];c[(Ok+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00489974;c[(Ok+16|0)>>2]=c[k>>2];c[(Ok+16|0)+4>>2]=c[k+4>>2];sI(W,4,.0039,Ok);h[k>>3]=.755536;c[Nk>>2]=c[k>>2];c[Nk+4>>2]=c[k+4>>2];h[k>>3]=-1.45743;c[(Nk+8|0)>>2]=c[k>>2];c[(Nk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00489052;c[(Nk+16|0)>>2]=c[k>>2];c[(Nk+16|0)+4>>2]=c[k+4>>2];sI(X,4,.004,Nk);h[k>>3]=.765568;c[Mk>>2]=c[k>>2];c[Mk+4>>2]=c[k+4>>2];h[k>>3]=-1.49822;c[(Mk+8|0)>>2]=c[k>>2];c[(Mk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00488074;c[(Mk+16|0)>>2]=c[k>>2];c[(Mk+16|0)+4>>2]=c[k+4>>2];sI(Y,4,.0041,Mk);h[k>>3]=.775269;c[Lk>>2]=c[k>>2];c[Lk+4>>2]=c[k+4>>2];h[k>>3]=-1.53803;c[(Lk+8|0)>>2]=c[k>>2];c[(Lk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00487038;c[(Lk+16|0)>>2]=c[k>>2];c[(Lk+16|0)+4>>2]=c[k+4>>2];sI(Z,4,.0042,Lk);h[k>>3]=.784646;c[Kk>>2]=c[k>>2];c[Kk+4>>2]=c[k+4>>2];h[k>>3]=-1.57689;c[(Kk+8|0)>>2]=c[k>>2];c[(Kk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00485943;c[(Kk+16|0)>>2]=c[k>>2];c[(Kk+16|0)+4>>2]=c[k+4>>2];sI(_,4,.0043,Kk);h[k>>3]=.793704;c[Jk>>2]=c[k>>2];c[Jk+4>>2]=c[k+4>>2];h[k>>3]=-1.61483;c[(Jk+8|0)>>2]=c[k>>2];c[(Jk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00484787;c[(Jk+16|0)>>2]=c[k>>2];c[(Jk+16|0)+4>>2]=c[k+4>>2];sI($,4,.0044,Jk);h[k>>3]=.80245;c[Ik>>2]=c[k>>2];c[Ik+4>>2]=c[k+4>>2];h[k>>3]=-1.65314;c[(Ik+8|0)>>2]=c[k>>2];c[(Ik+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00483569;c[(Ik+16|0)>>2]=c[k>>2];c[(Ik+16|0)+4>>2]=c[k+4>>2];sI(aa,4,.0045,Ik);h[k>>3]=.810888;c[Hk>>2]=c[k>>2];c[Hk+4>>2]=c[k+4>>2];h[k>>3]=-1.69366;c[(Hk+8|0)>>2]=c[k>>2];c[(Hk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00482288;c[(Hk+16|0)>>2]=c[k>>2];c[(Hk+16|0)+4>>2]=c[k+4>>2];sI(ba,4,.0046,Hk);h[k>>3]=.81902;c[Gk>>2]=c[k>>2];c[Gk+4>>2]=c[k+4>>2];h[k>>3]=-1.7332;c[(Gk+8|0)>>2]=c[k>>2];c[(Gk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00480941;c[(Gk+16|0)>>2]=c[k>>2];c[(Gk+16|0)+4>>2]=c[k+4>>2];sI(ca,4,.0047,Gk);h[k>>3]=.826851;c[Fk>>2]=c[k>>2];c[Fk+4>>2]=c[k+4>>2];h[k>>3]=-1.77179;c[(Fk+8|0)>>2]=c[k>>2];c[(Fk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00479528;c[(Fk+16|0)>>2]=c[k>>2];c[(Fk+16|0)+4>>2]=c[k+4>>2];sI(da,4,.0048,Fk);h[k>>3]=.834387;c[Ek>>2]=c[k>>2];c[Ek+4>>2]=c[k+4>>2];h[k>>3]=-1.80945;c[(Ek+8|0)>>2]=c[k>>2];c[(Ek+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00478046;c[(Ek+16|0)>>2]=c[k>>2];c[(Ek+16|0)+4>>2]=c[k+4>>2];sI(ea,4,.0049,Ek);h[k>>3]=.841631;c[Dk>>2]=c[k>>2];c[Dk+4>>2]=c[k+4>>2];h[k>>3]=-1.84622;c[(Dk+8|0)>>2]=c[k>>2];c[(Dk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00476495;c[(Dk+16|0)>>2]=c[k>>2];c[(Dk+16|0)+4>>2]=c[k+4>>2];sI(fa,4,.005,Dk);h[k>>3]=.84859;c[Ck>>2]=c[k>>2];c[Ck+4>>2]=c[k+4>>2];h[k>>3]=-1.88259;c[(Ck+8|0)>>2]=c[k>>2];c[(Ck+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00474873;c[(Ck+16|0)>>2]=c[k>>2];c[(Ck+16|0)+4>>2]=c[k+4>>2];sI(ga,4,.0051,Ck);h[k>>3]=.855304;c[Bk>>2]=c[k>>2];c[Bk+4>>2]=c[k+4>>2];h[k>>3]=-1.92429;c[(Bk+8|0)>>2]=c[k>>2];c[(Bk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00473179;c[(Bk+16|0)>>2]=c[k>>2];c[(Bk+16|0)+4>>2]=c[k+4>>2];sI(ha,4,.0052,Bk);h[k>>3]=.861739;c[Ak>>2]=c[k>>2];c[Ak+4>>2]=c[k+4>>2];h[k>>3]=-1.96564;c[(Ak+8|0)>>2]=c[k>>2];c[(Ak+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0047141;c[(Ak+16|0)>>2]=c[k>>2];c[(Ak+16|0)+4>>2]=c[k+4>>2];sI(ia,4,.0053,Ak);h[k>>3]=.8679;c[zk>>2]=c[k>>2];c[zk+4>>2]=c[k+4>>2];h[k>>3]=-2.00668;c[(zk+8|0)>>2]=c[k>>2];c[(zk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00469566;c[(zk+16|0)>>2]=c[k>>2];c[(zk+16|0)+4>>2]=c[k+4>>2];sI(ja,4,.0054,zk);h[k>>3]=.873791;c[yk>>2]=c[k>>2];c[yk+4>>2]=c[k+4>>2];h[k>>3]=-2.04743;c[(yk+8|0)>>2]=c[k>>2];c[(yk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00467645;c[(yk+16|0)>>2]=c[k>>2];c[(yk+16|0)+4>>2]=c[k+4>>2];sI(ka,4,.0055,yk);h[k>>3]=.879419;c[xk>>2]=c[k>>2];c[xk+4>>2]=c[k+4>>2];h[k>>3]=-2.08794;c[(xk+8|0)>>2]=c[k>>2];c[(xk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00465645;c[(xk+16|0)>>2]=c[k>>2];c[(xk+16|0)+4>>2]=c[k+4>>2];sI(la,4,.0056,xk);h[k>>3]=.884782;c[wk>>2]=c[k>>2];c[wk+4>>2]=c[k+4>>2];h[k>>3]=-2.1282;c[(wk+8|0)>>2]=c[k>>2];c[(wk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00463565;c[(wk+16|0)>>2]=c[k>>2];c[(wk+16|0)+4>>2]=c[k+4>>2];sI(ma,4,.0057,wk);h[k>>3]=.889885;c[vk>>2]=c[k>>2];c[vk+4>>2]=c[k+4>>2];h[k>>3]=-2.16824;c[(vk+8|0)>>2]=c[k>>2];c[(vk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00461403;c[(vk+16|0)>>2]=c[k>>2];c[(vk+16|0)+4>>2]=c[k+4>>2];sI(na,4,.0058,vk);h[k>>3]=.894731;c[uk>>2]=c[k>>2];c[uk+4>>2]=c[k+4>>2];h[k>>3]=-2.20808;c[(uk+8|0)>>2]=c[k>>2];c[(uk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00459157;c[(uk+16|0)>>2]=c[k>>2];c[(uk+16|0)+4>>2]=c[k+4>>2];sI(oa,4,.0059,uk);h[k>>3]=.899322;c[tk>>2]=c[k>>2];c[tk+4>>2]=c[k+4>>2];h[k>>3]=-2.24774;c[(tk+8|0)>>2]=c[k>>2];c[(tk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00456827;c[(tk+16|0)>>2]=c[k>>2];c[(tk+16|0)+4>>2]=c[k+4>>2];sI(pa,4,.006,tk);h[k>>3]=.903661;c[sk>>2]=c[k>>2];c[sk+4>>2]=c[k+4>>2];h[k>>3]=-2.28927;c[(sk+8|0)>>2]=c[k>>2];c[(sk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0045441;c[(sk+16|0)>>2]=c[k>>2];c[(sk+16|0)+4>>2]=c[k+4>>2];sI(qa,4,.0061,sk);h[k>>3]=.907752;c[rk>>2]=c[k>>2];c[rk+4>>2]=c[k+4>>2];h[k>>3]=-2.33091;c[(rk+8|0)>>2]=c[k>>2];c[(rk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00451905;c[(rk+16|0)>>2]=c[k>>2];c[(rk+16|0)+4>>2]=c[k+4>>2];sI(ra,4,.0062,rk);h[k>>3]=.911603;c[qk>>2]=c[k>>2];c[qk+4>>2]=c[k+4>>2];h[k>>3]=-2.37014;c[(qk+8|0)>>2]=c[k>>2];c[(qk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0044931;c[(qk+16|0)>>2]=c[k>>2];c[(qk+16|0)+4>>2]=c[k+4>>2];sI(sa,4,.0063,qk);h[k>>3]=.915232;c[pk>>2]=c[k>>2];c[pk+4>>2]=c[k+4>>2];h[k>>3]=-2.40274;c[(pk+8|0)>>2]=c[k>>2];c[(pk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00446624;c[(pk+16|0)>>2]=c[k>>2];c[(pk+16|0)+4>>2]=c[k+4>>2];sI(ta,4,.0064,pk);h[k>>3]=.91862;c[ok>>2]=c[k>>2];c[ok+4>>2]=c[k+4>>2];h[k>>3]=-2.43469;c[(ok+8|0)>>2]=c[k>>2];c[(ok+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00443846;c[(ok+16|0)>>2]=c[k>>2];c[(ok+16|0)+4>>2]=c[k+4>>2];sI(ua,4,.0065,ok);h[k>>3]=.92177;c[nk>>2]=c[k>>2];c[nk+4>>2]=c[k+4>>2];h[k>>3]=-2.466;c[(nk+8|0)>>2]=c[k>>2];c[(nk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00440974;c[(nk+16|0)>>2]=c[k>>2];c[(nk+16|0)+4>>2]=c[k+4>>2];sI(va,4,.0066,nk);h[k>>3]=.924686;c[mk>>2]=c[k>>2];c[mk+4>>2]=c[k+4>>2];h[k>>3]=-2.49668;c[(mk+8|0)>>2]=c[k>>2];c[(mk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00438007;c[(mk+16|0)>>2]=c[k>>2];c[(mk+16|0)+4>>2]=c[k+4>>2];sI(wa,4,.0067,mk);h[k>>3]=.927368;c[lk>>2]=c[k>>2];c[lk+4>>2]=c[k+4>>2];h[k>>3]=-2.52672;c[(lk+8|0)>>2]=c[k>>2];c[(lk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00434945;c[(lk+16|0)>>2]=c[k>>2];c[(lk+16|0)+4>>2]=c[k+4>>2];sI(xa,4,.0068,lk);h[k>>3]=.929822;c[kk>>2]=c[k>>2];c[kk+4>>2]=c[k+4>>2];h[k>>3]=-2.55615;c[(kk+8|0)>>2]=c[k>>2];c[(kk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00431785;c[(kk+16|0)>>2]=c[k>>2];c[(kk+16|0)+4>>2]=c[k+4>>2];sI(ya,4,.0069,kk);h[k>>3]=.93205;c[jk>>2]=c[k>>2];c[jk+4>>2]=c[k+4>>2];h[k>>3]=-2.58498;c[(jk+8|0)>>2]=c[k>>2];c[(jk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00428527;c[(jk+16|0)>>2]=c[k>>2];c[(jk+16|0)+4>>2]=c[k+4>>2];sI(za,4,.007,jk);h[k>>3]=.934052;c[ik>>2]=c[k>>2];c[ik+4>>2]=c[k+4>>2];h[k>>3]=-2.61318;c[(ik+8|0)>>2]=c[k>>2];c[(ik+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00425169;c[(ik+16|0)>>2]=c[k>>2];c[(ik+16|0)+4>>2]=c[k+4>>2];sI(Aa,4,.0071,ik);h[k>>3]=.935241;c[hk>>2]=c[k>>2];c[hk+4>>2]=c[k+4>>2];h[k>>3]=-2.64973;c[(hk+8|0)>>2]=c[k>>2];c[(hk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00421711;c[(hk+16|0)>>2]=c[k>>2];c[(hk+16|0)+4>>2]=c[k+4>>2];sI(Ba,4,.0072,hk);h[k>>3]=.936164;c[gk>>2]=c[k>>2];c[gk+4>>2]=c[k+4>>2];h[k>>3]=-2.68643;c[(gk+8|0)>>2]=c[k>>2];c[(gk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00418151;c[(gk+16|0)>>2]=c[k>>2];c[(gk+16|0)+4>>2]=c[k+4>>2];sI(Ca,4,.0073,gk);h[k>>3]=.936854;c[fk>>2]=c[k>>2];c[fk+4>>2]=c[k+4>>2];h[k>>3]=-2.7228;c[(fk+8|0)>>2]=c[k>>2];c[(fk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00414488;c[(fk+16|0)>>2]=c[k>>2];c[(fk+16|0)+4>>2]=c[k+4>>2];sI(Da,4,.0074,fk);h[k>>3]=.937309;c[ek>>2]=c[k>>2];c[ek+4>>2]=c[k+4>>2];h[k>>3]=-2.7588;c[(ek+8|0)>>2]=c[k>>2];c[(ek+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0041072;c[(ek+16|0)>>2]=c[k>>2];c[(ek+16|0)+4>>2]=c[k+4>>2];sI(Ea,4,.0075,ek);h[k>>3]=.937532;c[dk>>2]=c[k>>2];c[dk+4>>2]=c[k+4>>2];h[k>>3]=-2.7944;c[(dk+8|0)>>2]=c[k>>2];c[(dk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00406845;c[(dk+16|0)>>2]=c[k>>2];c[(dk+16|0)+4>>2]=c[k+4>>2];sI(Fa,4,.0076,dk);h[k>>3]=.937522;c[ck>>2]=c[k>>2];c[ck+4>>2]=c[k+4>>2];h[k>>3]=-2.82958;c[(ck+8|0)>>2]=c[k>>2];c[(ck+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00402864;c[(ck+16|0)>>2]=c[k>>2];c[(ck+16|0)+4>>2]=c[k+4>>2];sI(Ga,4,.0077,ck);h[k>>3]=.937411;c[bk>>2]=c[k>>2];c[bk+4>>2]=c[k+4>>2];h[k>>3]=-2.866;c[(bk+8|0)>>2]=c[k>>2];c[(bk+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00398773;c[(bk+16|0)>>2]=c[k>>2];c[(bk+16|0)+4>>2]=c[k+4>>2];sI(Ha,4,.0078,bk);h[k>>3]=.937385;c[ak>>2]=c[k>>2];c[ak+4>>2]=c[k+4>>2];h[k>>3]=-2.90613;c[(ak+8|0)>>2]=c[k>>2];c[(ak+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00394572;c[(ak+16|0)>>2]=c[k>>2];c[(ak+16|0)+4>>2]=c[k+4>>2];sI(Ia,4,.0079,ak);h[k>>3]=.937133;c[$j>>2]=c[k>>2];c[$j+4>>2]=c[k+4>>2];h[k>>3]=-2.94589;c[($j+8|0)>>2]=c[k>>2];c[($j+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.0039026;c[($j+16|0)>>2]=c[k>>2];c[($j+16|0)+4>>2]=c[k+4>>2];sI(Ja,4,.008,$j);h[k>>3]=.936656;c[_j>>2]=c[k>>2];c[_j+4>>2]=c[k+4>>2];h[k>>3]=-2.98525;c[(_j+8|0)>>2]=c[k>>2];c[(_j+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00385834;c[(_j+16|0)>>2]=c[k>>2];c[(_j+16|0)+4>>2]=c[k+4>>2];sI(Ka,4,.0081,_j);h[k>>3]=.935953;c[Zj>>2]=c[k>>2];c[Zj+4>>2]=c[k+4>>2];h[k>>3]=-3.02414;c[(Zj+8|0)>>2]=c[k>>2];c[(Zj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00381293;c[(Zj+16|0)>>2]=c[k>>2];c[(Zj+16|0)+4>>2]=c[k+4>>2];sI(La,4,.0082,Zj);h[k>>3]=.935024;c[Yj>>2]=c[k>>2];c[Yj+4>>2]=c[k+4>>2];h[k>>3]=-3.06251;c[(Yj+8|0)>>2]=c[k>>2];c[(Yj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00376636;c[(Yj+16|0)>>2]=c[k>>2];c[(Yj+16|0)+4>>2]=c[k+4>>2];sI(Ma,4,.0083,Yj);h[k>>3]=.934308;c[Xj>>2]=c[k>>2];c[Xj+4>>2]=c[k+4>>2];h[k>>3]=-3.10824;c[(Xj+8|0)>>2]=c[k>>2];c[(Xj+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00371862;c[(Xj+16|0)>>2]=c[k>>2];c[(Xj+16|0)+4>>2]=c[k+4>>2];sI(Na,4,.0084,Xj);h[k>>3]=.933608;c[$i>>2]=c[k>>2];c[$i+4>>2]=c[k+4>>2];h[k>>3]=-3.15783;c[($i+8|0)>>2]=c[k>>2];c[($i+8|0)+4>>2]=c[k+4>>2];h[k>>3]=.00366967;c[a+56>>2]=b;c[a+72>>2]=d;c[a+80>>2]=e;c[a+88>>2]=f;c[a+96>>2]=g;c[a+104>>2]=j;c[a+112>>2]=l;c[a+120>>2]=m;c[a+128>>2]=n;c[a+136>>2]=o;c[a+144>>2]=p;c[a+152>>2]=q;c[a+160>>2]=r;c[a+168>>2]=s;c[a+176>>2]=t;c[a+184>>2]=u;c[a+192>>2]=v;c[a+200>>2]=w;c[a+208>>2]=x;c[a+216>>2]=y;c[a+224>>2]=z;c[a+232>>2]=A;c[a+240>>2]=B;c[a+248>>2]=C;c[a+256>>2]=D;c[a+264>>2]=E;c[a+272>>2]=F;c[a+280>>2]=G;c[a+288>>2]=H;c[a+296>>2]=I;c[a+304>>2]=J;c[a+312>>2]=K;c[a+320>>2]=L;c[a+328>>2]=M;c[a+336>>2]=N;c[a+344>>2]=O;c[a+352>>2]=P;c[a+360>>2]=Q;c[a+368>>2]=R;c[a+376>>2]=S;c[a+384>>2]=T;c[a+392>>2]=U;c[a+400>>2]=V;c[a+408>>2]=W;c[a+416>>2]=X;c[a+424>>2]=Y;c[a+432>>2]=Z;c[a+440>>2]=_;c[a+448>>2]=$;c[a+456>>2]=aa;c[a+464>>2]=ba;c[a+472>>2]=ca;c[a+480>>2]=da;c[a+488>>2]=ea;c[a+496>>2]=fa;c[a+504>>2]=ga;c[a+512>>2]=ha;c[a+520>>2]=ia;c[a+528>>2]=ja;c[a+536>>2]=ka;c[a+544>>2]=la;c[a+552>>2]=ma;c[a+560>>2]=na;c[a+568>>2]=oa;c[a+576>>2]=pa;c[a+584>>2]=qa;c[a+592>>2]=ra;c[a+600>>2]=sa;c[a+608>>2]=ta;c[a+616>>2]=ua;c[a+624>>2]=va;c[a+632>>2]=wa;c[a+640>>2]=xa;c[a+648>>2]=ya;c[a+656>>2]=za;c[a+664>>2]=Aa;c[a+672>>2]=Ba;c[a+680>>2]=Ca;c[a+688>>2]=Da;c[a+696>>2]=Ea;c[a+704>>2]=Fa;c[a+712>>2]=Ga;c[a+720>>2]=Ha;c[a+728>>2]=Ia;c[a+736>>2]=Ja;c[a+744>>2]=Ka;c[a+752>>2]=La;c[a+760>>2]=Ma;c[a+768>>2]=Na;c[a+776>>2]=Oa;c[a+784>>2]=Pa;c[a+792>>2]=Qa;c[a+800>>2]=Ra;c[a+808>>2]=Sa;c[a+816>>2]=Ta;c[a+824>>2]=Ua;c[a+832>>2]=Va;c[a+840>>2]=Wa;c[a+848>>2]=Xa;c[a+856>>2]=Ya;c[a+864>>2]=Za;c[a+872>>2]=_a;c[a+880>>2]=$a;c[a+888>>2]=ab;c[a+896>>2]=bb;c[a+904>>2]=cb;c[a+912>>2]=db;c[a+920>>2]=eb;c[a+928>>2]=fb;c[a+936>>2]=gb;c[a+944>>2]=hb;c[a+952>>2]=ib;c[a+960>>2]=jb;c[a+968>>2]=kb;c[a+976>>2]=lb;c[a+984>>2]=mb;c[a+992>>2]=nb;c[a+1e3>>2]=ob;c[a+1008>>2]=pb;c[a+1016>>2]=qb;c[a+1024>>2]=rb;c[a+1032>>2]=sb;c[a+1040>>2]=tb;c[a+1048>>2]=ub;c[a+1056>>2]=vb;c[a+1064>>2]=wb;c[a+1072>>2]=xb;c[a+1080>>2]=yb;c[a+1088>>2]=zb;c[a+1096>>2]=Ab;c[a+1104>>2]=Bb;c[a+1112>>2]=Cb;c[a+1120>>2]=Db;c[a+1128>>2]=Eb;c[a+1136>>2]=Fb;c[a+1144>>2]=Gb;c[a+1152>>2]=Hb;c[a+1160>>2]=Ib;c[a+1168>>2]=Jb;c[a+1176>>2]=Kb;c[a+1184>>2]=Lb;c[a+1192>>2]=Mb;c[a+1200>>2]=Nb;c[a+1208>>2]=Ob;c[a+1216>>2]=Pb;c[a+1224>>2]=Qb;c[a+1232>>2]=Rb;c[a+1240>>2]=Sb;c[a+1248>>2]=Tb;c[a+1256>>2]=Ub;c[a+1264>>2]=Vb;c[a+1272>>2]=Wb;c[a+1280>>2]=Xb;c[a+1288>>2]=Yb;c[a+1296>>2]=Zb;c[a+1304>>2]=_b;c[a+1312>>2]=$b;c[a+1320>>2]=ac;c[a+1328>>2]=bc;c[a+1336>>2]=cc;c[a+1344>>2]=dc;c[a+1352>>2]=ec;c[a+1360>>2]=fc;c[a+1368>>2]=gc;c[a+1376>>2]=hc;c[a+1384>>2]=ic;c[a+1392>>2]=jc;c[a+1400>>2]=kc;c[a+1408>>2]=lc;c[a+1416>>2]=mc;c[a+1424>>2]=nc;c[a+1432>>2]=oc;c[a+1440>>2]=pc;c[a+1448>>2]=qc;c[a+1456>>2]=rc;c[a+1464>>2]=sc;c[a+1472>>2]=tc;c[a+1480>>2]=uc;c[a+1488>>2]=vc;c[a+1496>>2]=wc;c[a+1504>>2]=xc;c[a+1512>>2]=yc;c[a+1520>>2]=zc;c[a+1528>>2]=Ac;c[a+1536>>2]=Bc;c[a+1544>>2]=Cc;c[a+1552>>2]=Dc;c[a+1560>>2]=Ec;c[a+1568>>2]=Fc;c[a+1576>>2]=Gc;c[a+1584>>2]=Hc;c[a+1592>>2]=Ic;c[a+1600>>2]=Jc;c[a+1608>>2]=Kc;c[a+1616>>2]=Lc;c[a+1624>>2]=Mc;c[a+1632>>2]=Nc;c[a+1640>>2]=Oc;c[a+1648>>2]=Pc;c[a+1656>>2]=Qc;c[a+1664>>2]=Rc;c[a+1672>>2]=Sc;c[a+1680>>2]=Tc;c[a+1688>>2]=Uc;c[a+1696>>2]=Vc;c[a+1704>>2]=Wc;c[a+1712>>2]=Xc;c[a+1720>>2]=Yc;c[a+1728>>2]=Zc;c[a+1736>>2]=_c;c[a+1744>>2]=$c;c[a+1752>>2]=ad;c[a+1760>>2]=bd;c[a+1768>>2]=cd;c[a+1776>>2]=dd;c[a+1784>>2]=ed;c[a+1792>>2]=fd;c[a+1800>>2]=gd;c[a+1808>>2]=hd;c[a+1816>>2]=id;c[a+1824>>2]=jd;c[a+1832>>2]=kd;c[a+1840>>2]=ld;c[a+1848>>2]=md;c[a+1856>>2]=nd;c[a+1864>>2]=od;c[a+1872>>2]=pd;c[a+1880>>2]=qd;c[a+1888>>2]=rd;c[a+1896>>2]=sd;c[a+1904>>2]=td;c[a+1912>>2]=ud;c[a+1920>>2]=vd;c[a+1928>>2]=wd;c[a+1936>>2]=xd;c[a+1944>>2]=yd;c[a+1952>>2]=zd;c[a+1960>>2]=Ad;c[a+1968>>2]=Bd;c[a+1976>>2]=Cd;c[a+1984>>2]=Dd;c[a+1992>>2]=Ed;c[a+2e3>>2]=Fd;c[a+2008>>2]=Gd;c[a+2016>>2]=Hd;c[a+2024>>2]=Id;c[a+2032>>2]=Jd;c[a+2040>>2]=Kd;c[a+2048>>2]=Ld;c[a+2056>>2]=Md;c[a+2064>>2]=Nd;c[a+2072>>2]=Od;c[a+2080>>2]=Pd;c[a+2088>>2]=Qd;c[a+2096>>2]=Rd;c[a+2104>>2]=Sd;c[a+2112>>2]=Td;c[a+2120>>2]=Ud;c[a+2128>>2]=Vd;c[a+2136>>2]=Wd;c[a+2144>>2]=Xd;c[a+2152>>2]=Yd;c[a+2160>>2]=Zd;c[a+2168>>2]=_d;c[a+2176>>2]=$d;c[a+2184>>2]=ae;c[a+2192>>2]=be;c[a+2200>>2]=ce;c[a+2208>>2]=de;c[a+2216>>2]=ee;c[a+2224>>2]=fe;c[a+2232>>2]=ge;c[a+2240>>2]=he;c[a+2248>>2]=ie;c[a+2256>>2]=je;c[a+2264>>2]=ke;c[a+2272>>2]=le;c[a+2280>>2]=me;c[a+2288>>2]=ne;c[a+2296>>2]=oe;c[a+2304>>2]=pe;c[a+2312>>2]=qe;c[a+2320>>2]=re;c[a+2328>>2]=se;c[a+2336>>2]=te;c[a+2344>>2]=ue;c[a+2352>>2]=ve;c[a+2360>>2]=we;c[a+2368>>2]=xe;c[a+2376>>2]=ye;c[a+2384>>2]=ze;c[a+2392>>2]=Ae;c[a+2400>>2]=Be;c[a+2408>>2]=Ce;c[a+2416>>2]=De;c[a+2424>>2]=Ee;c[a+2432>>2]=Fe;c[a+2440>>2]=Ge;c[a+2448>>2]=He;c[a+2456>>2]=Ie;c[a+2464>>2]=Je;c[a+2472>>2]=Ke;c[a+2480>>2]=Le;c[a+2488>>2]=Me;c[a+2496>>2]=Ne;c[a+2504>>2]=Oe;c[a+2512>>2]=Pe;c[a+2520>>2]=Qe;c[a+2528>>2]=Re;c[a+2536>>2]=Se;c[a+2544>>2]=Te;c[a+2552>>2]=Ue;c[a+2560>>2]=Ve;c[a+2568>>2]=We;c[a+2576>>2]=Xe;c[a+2584>>2]=Ye;c[a+2592>>2]=Ze;c[a+2600>>2]=_e;c[a+2608>>2]=$e;c[a+2616>>2]=af;c[a+2624>>2]=bf;c[a+2632>>2]=cf;c[a+2640>>2]=df;c[a+2648>>2]=ef;c[a+2656>>2]=ff;c[a+2664>>2]=gf;c[a+2672>>2]=hf;c[a+2680>>2]=jf;c[a+2688>>2]=kf;c[a+2696>>2]=lf;c[a+2704>>2]=mf;c[a+2712>>2]=nf;c[a+2720>>2]=of;c[a+2728>>2]=pf;c[a+2736>>2]=qf;c[a+2744>>2]=rf;c[a+2752>>2]=sf;c[a+2760>>2]=tf;c[a+2768>>2]=uf;c[a+2776>>2]=vf;c[a+2784>>2]=wf;c[a+2792>>2]=xf;c[a+2800>>2]=yf;c[a+2808>>2]=zf;c[a+2816>>2]=Af;c[a+2824>>2]=Bf;c[a+2832>>2]=Cf;c[a+2840>>2]=Df;c[a+2848>>2]=Ef;c[a+2856>>2]=Ff;c[a+2864>>2]=Gf;c[a+2872>>2]=Hf;c[a+2880>>2]=If;c[a+2888>>2]=Jf;c[a+2896>>2]=Kf;c[a+2904>>2]=Lf;c[a+2912>>2]=Mf;c[a+2920>>2]=Nf;c[a+2928>>2]=Of;c[a+2936>>2]=Pf;c[a+2944>>2]=Qf;c[a+2952>>2]=Rf;c[a+2960>>2]=Sf;c[a+2968>>2]=Tf;c[a+2976>>2]=Uf;c[a+2984>>2]=Vf;c[a+2992>>2]=Wf;c[a+3e3>>2]=Xf;c[a+3008>>2]=Yf;c[a+3016>>2]=Zf;c[a+3024>>2]=_f;c[a+3032>>2]=$f;c[a+3040>>2]=ag;c[a+3048>>2]=bg;c[a+3056>>2]=cg;c[a+3064>>2]=dg;c[a+3072>>2]=eg;c[a+3080>>2]=fg;c[a+3088>>2]=gg;c[a+3096>>2]=hg;c[a+3104>>2]=ig;c[a+3112>>2]=jg;c[a+3120>>2]=kg;c[a+3128>>2]=lg;c[a+3136>>2]=mg;c[a+3144>>2]=ng;c[a+3152>>2]=og;c[a+3160>>2]=pg;c[a+3168>>2]=qg;c[a+3176>>2]=rg;c[a+3184>>2]=sg;c[a+3192>>2]=tg;c[a+3200>>2]=ug;c[a+3208>>2]=vg;c[a+3216>>2]=wg;c[a+3224>>2]=xg;c[a+3232>>2]=yg;c[a+3240>>2]=zg;c[a+3248>>2]=Ag;c[a+3256>>2]=Bg;c[a+3264>>2]=Cg;c[a+3272>>2]=Dg;c[a+3280>>2]=Eg;c[a+3288>>2]=Fg;c[a+3296>>2]=Gg;c[a+3304>>2]=Hg;c[a+3312>>2]=Ig;c[a+3320>>2]=Jg;c[a+3328>>2]=Kg;c[a+3336>>2]=Lg;c[a+3344>>2]=Mg;c[a+3352>>2]=Ng;c[a+3360>>2]=Og;c[a+3368>>2]=Pg;c[a+3376>>2]=Qg;c[a+3384>>2]=Rg;c[a+3392>>2]=Sg;c[a+3400>>2]=Tg;c[a+3408>>2]=Ug;c[a+3416>>2]=Vg;c[a+3424>>2]=Wg;c[a+3432>>2]=Xg;c[a+3440>>2]=Yg;c[a+3448>>2]=Zg;c[a+3456>>2]=_g;c[a+3464>>2]=$g;c[a+3472>>2]=ah;c[a+3480>>2]=bh;c[a+3488>>2]=ch;c[a+3496>>2]=dh;c[a+3504>>2]=eh;c[a+3512>>2]=fh;c[a+3520>>2]=gh;c[a+3528>>2]=hh;c[a+3536>>2]=ih;c[a+3544>>2]=jh;c[a+3552>>2]=kh;c[a+3560>>2]=lh;c[a+3568>>2]=mh;c[a+3576>>2]=nh;c[a+3584>>2]=oh;c[a+3592>>2]=ph;c[a+3600>>2]=qh;c[a+3608>>2]=rh;c[a+3616>>2]=sh;c[a+3624>>2]=th;c[a+3632>>2]=uh;c[a+3640>>2]=vh;c[a+3648>>2]=wh;c[a+3656>>2]=xh;c[a+3664>>2]=yh;c[a+3672>>2]=zh;c[a+3680>>2]=Ah;c[a+3688>>2]=Bh;c[a+3696>>2]=Ch;c[a+3704>>2]=Dh;c[a+3712>>2]=Eh;c[a+3720>>2]=Fh;c[a+3728>>2]=Gh;c[a+3736>>2]=Hh;c[a+3744>>2]=Ih;c[a+3752>>2]=Jh;c[a+3760>>2]=Kh;c[a+3768>>2]=Lh;c[a+3776>>2]=Mh;c[a+3784>>2]=Nh;c[a+3792>>2]=Oh;c[a+3800>>2]=Ph;c[a+3808>>2]=Qh;c[a+3816>>2]=Rh;c[a+3824>>2]=Sh;c[a+3832>>2]=Th;c[a+3840>>2]=Uh;c[a+3848>>2]=Vh;c[a+3856>>2]=Wh;c[a+3864>>2]=Xh;c[a+3872>>2]=Yh;c[a+3880>>2]=Zh;c[a+3888>>2]=_h;c[a+3896>>2]=$h;c[a+3904>>2]=ai;c[a+3912>>2]=bi;c[a+3920>>2]=ci;c[a+3928>>2]=di;c[a+3936>>2]=ei;c[a+3944>>2]=fi;c[a+3952>>2]=gi;c[a+3960>>2]=hi;c[a+3968>>2]=ii;c[a+3976>>2]=ji;c[a+3984>>2]=ki;c[a+3992>>2]=li;c[a+4e3>>2]=mi;c[a+4008>>2]=ni;c[a+4016>>2]=oi;c[a+4024>>2]=pi;c[a+4032>>2]=qi;c[a+4040>>2]=ri;c[a+4048>>2]=si;c[a+4056>>2]=ti;c[a+4064>>2]=ui;c[a+4072>>2]=vi;c[a+4080>>2]=wi;c[a+4088>>2]=xi;c[a+4096>>2]=yi;c[a+4104>>2]=zi;c[a+4112>>2]=Ai;c[a+4120>>2]=Bi;c[a+4128>>2]=Ci;c[a+4136>>2]=Di;c[a+4144>>2]=Ei;c[a+4152>>2]=Fi;c[a+4160>>2]=Gi;c[a+4168>>2]=Hi;c[a+4176>>2]=Ii;c[a+4184>>2]=Ji;c[a+4192>>2]=Ki;c[a+4200>>2]=Li;c[a+4208>>2]=Mi;c[a+4216>>2]=Ni;c[a+4224>>2]=Oi;c[a+4232>>2]=Pi;c[a+4240>>2]=Qi;c[a+4248>>2]=Ri;c[a+4256>>2]=Si;c[a+4264>>2]=Ti;c[a+4272>>2]=Ui;c[a+4280>>2]=Vi;c[a+4288>>2]=Wi;c[a+4296>>2]=Xi;c[a+4304>>2]=Yi;c[a+4312>>2]=Zi;c[a+4320>>2]=_i;c[a+7880>>2]=$i;c[a+7888>>2]=aj;c[a+7896>>2]=bj;c[a+7912>>2]=cj;c[a+7920>>2]=dj;c[a+7928>>2]=ej;c[a+7936>>2]=fj;c[a+7944>>2]=gj;c[a+7952>>2]=hj;c[a+7960>>2]=ij;c[a+7968>>2]=jj;c[a+7976>>2]=kj;c[a+7984>>2]=lj;c[a+8008>>2]=mj;c[a+8016>>2]=nj;c[a+8024>>2]=oj;c[a+8032>>2]=pj;c[a+8040>>2]=qj;c[a+8048>>2]=rj;c[a+8056>>2]=sj;c[a+8064>>2]=tj;c[a+8072>>2]=uj;c[a+8080>>2]=vj;c[a+8096>>2]=wj;c[a+8104>>2]=xj;c[a+8112>>2]=yj;c[a+8120>>2]=zj;c[a+8128>>2]=Aj;c[a+8136>>2]=Bj;c[a+8144>>2]=Cj;c[a+8152>>2]=Dj;c[a+8160>>2]=Ej;c[a+8168>>2]=Fj;c[a+8184>>2]=Gj;c[a+8192>>2]=Hj;c[a+8200>>2]=Ij;c[a+8208>>2]=Jj;c[a+8216>>2]=Kj;c[a+8224>>2]=Lj;c[a+8232>>2]=Mj;c[a+8240>>2]=Nj;c[a+8248>>2]=Oj;c[a+8256>>2]=Pj;c[a+8272>>2]=Qj;c[a+8280>>2]=Rj;c[a+8288>>2]=Sj;c[a+8296>>2]=Tj;c[a+8304>>2]=Uj;c[a+8312>>2]=Vj;c[a+8320>>2]=Wj}



function $E(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 15:{k=cF(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=rE(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=bF(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=aF(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=dF(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=rE(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=rE(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 24:case 22:{break};case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=rE(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{o=78;break d;break};case 17:{break c;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=eF(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function aF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=rE(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function bF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[57224+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function cF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=rE(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=rE(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=31;break b;break};case 7:{p=34;break b;break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((fF(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=rE(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((fF(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function dF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=rE(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=rE(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function eF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=rE(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 5:{l=10;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=rE(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 5:{l=30;break a;break};case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[54904+((d[54648+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 7:{l=16;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=rE(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 14:{break};case 29:{if((c[54904+((d[56184+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=rE(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=rE(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 3:{t=XE(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=rE(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=rE(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 7:{l=103;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[54904+((d[54648+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function fF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function gF(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=rE(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=rE(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function hF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=rE(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=rE(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=aF(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function iF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=rE(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function jF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((Ee[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=UF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=PF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 30:{k=JF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=VF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((Ee[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 13:{k=TF(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 12:{k=TF(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((Ee[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=72;break b}p=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=p+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 29:{n=69;break b;break};case 7:{if((e-b|0)<4){n=82;break b}q=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=q+4|0;continue b;break};case 6:{if((e-b|0)<3){n=77;break b}r=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=r+3|0;continue b;break};case 34:{n=110;break b;break};case 33:{n=113;break b;break};case 15:{n=116;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}s=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=s+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}t=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=t+2|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}u=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=u+4|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==110){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function kF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=IF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 2:{k=MF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 6:{if((e-b|0)<3){n=45;break b}if((Ee[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((Ee[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((Ee[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function lF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=39;break b}if((Ee[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((Ee[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((Ee[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function mF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{k=19;break a;break};case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((Ee[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((Ee[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}o=b;if((Ee[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=o+2|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function nF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 21:{m=23;break a;break};case 7:{a=a+4|0;continue a;break};case 2:{m=12;break a;break};case 9:{m=16;break a;break};case 10:{m=13;break a;break};case 5:{a=a+2|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=IF(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function oF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 3:{m=9;break a;break};case 10:{m=15;break a;break};case 30:{m=12;break a;break};case 7:{a=a+4|0;continue a;break};case 9:{m=18;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=IF(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=JF(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function pF(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function qF(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function rF(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};default:{break a}}}i=c;return a-b|0}function sF(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function tF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function uF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=FD(c)|0;g=f;i=b;return g|0}function vF(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function wF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 7:{a=a+4|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 5:{a=a+2|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function xF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function yF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function zF(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function AF(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[54904+(((d[56184+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function BF(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[54904+(((d[56184+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function CF(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function DF(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[54904+(((d[54648+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function EF(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[54904+(((d[54648+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function FF(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function GF(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function HF(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function IF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=KF(h,a+1|0,b,e)|0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function JF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function KF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=LF(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function LF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function MF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=NF(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=OF(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=QF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=PF(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=58;break b}n=b;if((Ee[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=n+2|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}o=b;if((Ee[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=o+4|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}p=b;if((Ee[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=p+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 6:{if((e-b|0)<3){m=41;break b}q=b;if((Ee[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=q+3|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}r=b;if((Ee[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=r+4|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}s=b;if((Ee[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=s+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 17:{break b;break};case 29:{m=33;break b;break};case 11:{m=97;break b;break};case 10:case 9:case 21:{m=73;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 17:{break c;break};case 24:case 22:{m=77;break d;break};case 11:{m=97;break c;break};case 29:{m=76;break d;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ee[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=RF(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function NF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 7:{if((e-b|0)<4){m=18;break b}n=b;if((Ee[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((Ee[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((Ee[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function OF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[57600+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function PF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((Ee[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=32;break b}p=b;if((Ee[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 29:{o=24;break b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((Ee[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}r=b;if((Ee[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=r+4|0;continue b;break};case 15:{o=68;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((SF(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=47;break c}s=b;if((Ee[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((Ee[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((Ee[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((SF(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function QF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 29:{l=24;break b;break};case 23:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}o=d[h+76+(d[a]|0)|0]|0;if((o|0)==11){l=44;break}else if(!((o|0)==10|(o|0)==9|(o|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function RF(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}m=b;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=48;break a}}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}m=(Ee[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!m){l=14;break a}c[j>>2]=n+3;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}m=(Ee[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!m){l=36;break a}c[j>>2]=o+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}m=(Ee[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!m){l=41;break a}c[j>>2]=p+4;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}m=(Ee[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!m){l=31;break a}c[j>>2]=q+2;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}m=(Ee[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!m){l=9;break a}c[j>>2]=r+2;continue a;break};case 29:{l=4;break a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 14:{break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}m=(Ee[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!m){l=19;break a}c[j>>2]=s+4;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}m=t;if(!((m|0)==9|(m|0)==10|(m|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}m=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((m|0)==(t|0)){break}switch(m|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}m=(Ee[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(m){l=63;break a}c[j>>2]=u+2;continue c;break};case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}m=(Ee[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(m){l=68;break a}c[j>>2]=v+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}m=(Ee[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(m){l=73;break a}c[j>>2]=w+4;continue c;break};case 3:{x=IF(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};case 8:case 1:case 0:{l=75;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 5:{l=91;break d;break};case 17:{l=107;break a;break};case 24:case 22:{l=90;break d;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 29:{l=89;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}m=(Ee[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!m){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}m=(Ee[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!m){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}m=(Ee[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!m){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function SF(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function TF(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((Ee[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((Ee[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((Ee[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function UF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=NF(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function VF(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ee[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((Ee[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((Ee[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((Ee[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function WF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function XF(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function YF(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function ZF(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){q=a[b+73|0]|0;if((q|0)==0|(q|0)==4|(q|0)==5|(q|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Oe[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function _F(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((aG($F(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((aG($F(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=$F(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((aG(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=$F(k,a,b)|0;n=h;}while((aG(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=$F(k,a,b)|0;while(1){if((aG(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=$F(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=$F(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function $F(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;je[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function aG(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function bG(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function cG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 13:{c[h>>2]=14;j=56;break};case 29:{c[h>>2]=16;j=2;break};case 11:{c[h>>2]=14;j=55;break};case 15:{c[h>>2]=14;j=0;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,61344)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};default:{k=10}}}while(0);if((k|0)==10){j=gG(h,a)|0}i=g;return j|0}function dG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 15:{j=0;break};case 26:{k=9;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};case 33:{c[h>>2]=17;j=0;break};default:{j=fG(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=gG(h,a)|0}i=g;return j|0}function eG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Oe[c[e+28>>2]&63](e,b,d,61328)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61336)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function fG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case-4:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 16:{if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61104)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61112)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61120)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,61128)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function gG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function hG(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function iG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=gG(e,a)|0}i=f;return g|0}function jG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function kG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=gG(e,a)|0}i=f;return g|0}function lG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=gG(e,a)|0}i=f;return g|0}function mG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=gG(e,a)|0}i=f;return g|0}function nG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else{g=gG(e,a)|0}i=f;return g|0}function oG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Oe[c[e+28>>2]&63](e,b,d,61144)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61152)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function pG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=gG(e,a)|0}i=f;return g|0}function qG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=gG(e,a)|0}i=f;return g|0}function rG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else{g=gG(e,a)|0}i=f;return g|0}function sG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=gG(e,a)|0;h=g;i=f;return h|0}return 0}function tG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,61160)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61168)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function uG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=39;break};case 31:{c[h>>2]=40;j=52;break};case 32:{c[h>>2]=40;j=54;break};case 30:{c[h>>2]=40;j=53;break};case 20:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,61176)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};default:{k=10}}}while(0);if((k|0)==10){j=gG(h,a)|0}i=g;return j|0}function vG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else{g=gG(e,a)|0}i=f;return g|0}function wG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 31:{c[e>>2]=40;g=52;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 30:{c[e>>2]=40;g=53;break};case 32:{c[e>>2]=40;g=54;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 15:{g=39;break};default:{g=gG(e,a)|0}}i=f;return g|0}function xG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};default:{g=gG(e,a)|0;h=g;i=f;return h|0}}return 0}function yG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=gG(e,a)|0}i=f;return g|0}function zG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=gG(e,a)|0}i=f;return g|0}function AG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=gG(e,a)|0}i=f;return g|0}function BG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((Oe[k&63](l,m,n,c[61184+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((Oe[k&63](l,m,n,61128)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}}while(0);p=gG(h,a)|0;q=p;i=g;return q|0}function CG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,61288)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,61296)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,61312)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function DG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function EG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function FG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function GG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function HG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=gG(e,a)|0}i=f;return g|0}function IG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=gG(e,a)|0}i=f;return g|0}function JG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=gG(e,a)|0}i=f;return g|0}function KG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,61144)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61152)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function LG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=gG(e,a)|0}i=f;return g|0}function MG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=gG(e,a)|0}i=f;return g|0}function NG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,61320)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function OG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=gG(e,a)|0}i=f;return g|0}function PG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,61144)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61152)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function QG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=gG(e,a)|0}i=f;return g|0}function RG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=gG(e,a)|0}i=f;return g|0}function SG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=gG(e,a)|0;h=g;i=f;return h|0}return 0}function TG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=gG(e,a)|0;h=g;i=f;return h|0}return 0}function UG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=gG(e,a)|0}i=f;return g|0}function VG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=0;break};case 16:{if((Oe[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,61344)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 13:{j=56;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 11:{j=55;break};default:{k=9}}}while(0);if((k|0)==9){j=gG(h,a)|0}i=g;return j|0}function WG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=gG(e,a)|0}i=f;return g|0}function XG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((Oe[c[e+28>>2]&63](e,b,d,61144)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Oe[c[e+28>>2]&63](e,b,d,61152)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=gG(h,a)|0;k=j;i=g;return k|0}function YG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=gG(e,a)|0}i=f;return g|0}function ZG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=gG(e,a)|0}i=f;return g|0}function _G(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else{g=gG(e,a)|0}i=f;return g|0}function $G(){i=i;return}function aH(){i=i;return}function bH(){var a=0;a=i;Wa(61352,0)|0;i=a;return}function cH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;wc(61360,29,1,e|0)|0;zd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;wc(61392,54,1,g|0)|0;zd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;wc(61448,47,1,a|0)|0;zd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;Bd(k|0,61496,d|0)|0;zd(k|0)|0;f=0;i=b;return f|0}function dH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a>>2]|0;f=c[e>>2]|0;g=(b|0)>1;a:do{if(g){h=1;while(1){j=h+1|0;if((c[c[a+(h<<2)>>2]>>2]|0)!=(f|0)){break}if((j|0)<(b|0)){h=j}else{break a}}cb(61560,61624,103,61648)}}while(0);if((f|0)<=0){i=d;return}h=c[e+4>>2]|0;e=0;b:while(1){j=c[h+(e<<2)>>2]|0;if(g){k=1;while(1){l=k+1|0;if((j|0)!=(c[(c[(c[a+(k<<2)>>2]|0)+4>>2]|0)+(e<<2)>>2]|0)){m=10;break b}if((l|0)<(b|0)){k=l}else{break}}}k=e+1|0;if((k|0)<(f|0)){e=k}else{m=12;break}}if((m|0)==10){cb(61680,61624,109,61648)}else if((m|0)==12){i=d;return}}function eH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function fH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=SH(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function gH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=SH(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function hH(a,b){a=a|0;b=b|0;var d=0;d=i;if((cH(a)|0)==0){cb(61752,61624,347,61776)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(61808,61624,348,61776);return 0}function iH(){var a=0,b=0,d=0;a=i;b=63552|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=63664|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=63776|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[63556>>2]=1;c[63560>>2]=1;i=a;return}function jH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?63912:63928;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;Bd(a|0,63888,e|0)|0;i=d;return}function kH(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=63776+(d<<2)|0;o=63664+(d<<2)|0;p=63976+(b<<2)|0;q=62256+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=63960;kc(63944,l|0)|0;s=63960}else{if((c[15884]|0)==(d|0)){if((c[o>>2]|0)>0){t=63960}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;kc(63944,m|0)|0;do{if((c[15884]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=63960;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;kc(63968,k|0)|0;c[n>>2]=b;c[15884]=d;if((c[o>>2]|0)>0){g=0;while(1){kc(64e3,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;zd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function lH(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[63976+(a<<2)>>2]|0;c[j>>2]=c[62256+(b<<2)>>2];c[j+4>>2]=k;kc(64008,j|0)|0;mH(e);if((g|0)==0){Qd(((d|0)!=0?64048:64096)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}tb(64176)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];kc(64056,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}wc(64080,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}function mH(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){wc(64136,4,1,e|0)|0}else if(b<<24>>24==60){wc(64128,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){wc(64120,5,1,e|0)|0}else{Zd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function nH(a){a=a|0;var b=0;b=63664+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function oH(a){a=a|0;var b=0;b=(a|0)==0;c[16028]=b?1:19;c[16026]=b?7:211;i=i;return}function pH(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;wc(64080,11,1,b|0)|0;zd(b|0)|0;i=a;return}function qH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[63552+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;dd(j|0,2048,e|0,h|0)|0;ye[c[16028]&31](1,a,b,j,0,d);i=g;return}function rH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[63552+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;dd(h|0,2048,d|0,g|0)|0;ye[c[16028]&31](1,a,b,h,0,0);i=f;return}function sH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[15886]|0)==0){if((c[63552+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;dd(k|0,2048,e|0,j|0)|0;ye[c[16028]&31](2,a,b,k,0,d);i=g;return}function tH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[15886]|0)==0){if((c[63552+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;dd(j|0,2048,d|0,h|0)|0;ye[c[16028]&31](2,a,b,j,0,0);i=f;return}function uH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;dd(b|0,2048,d|0,g|0)|0;ye[c[16028]&31](4,2,0,b,0,0);if((a|0)==0){h=sd(c[15338]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function vH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;dd(g|0,2048,b|0,f|0)|0;ye[c[16028]&31](5,2,0,g,0,0);if((a|0)==0){h=sd(c[15338]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function wH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;dd(h|0,2048,d|0,g|0)|0;ye[c[16028]&31](5,2,0,h,0,b);if((a|0)==0){j=sd(c[15338]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function xH(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;wH(a,e,64248,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;sH(26,0,e,64184,m);i=j;return+b}return 0.0}function yH(a,b){a=a|0;b=b|0;var c=0;c=i;fH(a,b,RH(b)|0);i=c;return}function zH(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function AH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;zH(c[d+8>>2]|0,b,a);i=e;return}function BH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;yH(a,b);h=g;c[g>>2]=e;AH(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;AH(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function CH(a){a=a|0;i=i;return}function DH(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=baa(16)|0;uH(0,(d|0)!=0|0,64296,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function EH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;caa(c[f>>2]|0);caa(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function FH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;uH(0,(a|0)!=0|0,64312,f);f=baa(8)|0;g=f;uH(0,(f|0)!=0|0,64296,e);e=a+8|0;h=baa(c[e>>2]|0)|0;c[f>>2]=h;uH(0,(h|0)!=0|0,64296,d);Haa(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function GH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;uH(0,(a|0)!=0|0,64312,f);f=baa(8)|0;g=f;uH(0,(f|0)!=0|0,64296,e);e=a+8|0;h=baa(c[e>>2]|0)|0;c[f>>2]=h;uH(0,(h|0)!=0|0,64296,d);Haa(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function HH(a){a=a|0;var b=0;b=i;i=i+8|0;uH(0,(a|0)!=0|0,64312,b);i=b;return c[a+12>>2]|0}function IH(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uH(0,(a|0)!=0|0,64312,d);d=a;uH(0,(c[d>>2]|0)!=0|0,64336,b);i=b;return c[c[d>>2]>>2]|0}function JH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;caa(c[e>>2]|0);caa(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function KH(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uH(0,(a|0)!=0|0,64312,d);d=a;uH(0,(c[d>>2]|0)!=0|0,64352,b);i=b;return c[d>>2]|0}function LH(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;uH(0,d&1,64384,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function MH(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uH(0,(a|0)!=0|0,64384,d);d=a;uH(0,(c[d>>2]|0)!=0|0,64408,b);i=b;return c[d>>2]|0}function NH(){var a=0,b=0,d=0;a=i;b=baa(16)|0;c[16120]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=baa(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function OH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=TH(a)|0;yc(64488)|0;UH(d);a=c[16120]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;ic(64488)|0;Jaa(g|0,0,d|0)|0;i=b;return g|0}



function fZ(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=BI(F)|0;H=CI(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+HI(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}wc(115208,17,1,a|0)|0;wc(118120,12,1,a|0)|0;wc(118136,12,1,a|0)|0;wc(118152,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;Bd(a|0,118168,D|0)|0;wc(118208,10,1,a|0)|0;wc(118224,11,1,a|0)|0;wc(118240,11,1,a|0)|0;wc(118256,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Bd(a|0,118272,C|0)|0}else{wc(118296,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;Bd(a|0,117896,B|0)|0;wc(118320,13,1,a|0)|0;if(E){wc(118136,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(a|0,118336,A|0)|0}else{wc(118296,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;Bd(a|0,118360,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;Bd(a|0,118016,y|0)|0;wc(118408,10,1,a|0)|0;wc(118424,10,1,a|0)|0;wc(118408,10,1,a|0)|0;wc(118440,11,1,a|0)|0;c[x>>2]=b;Bd(a|0,118456,x|0)|0;c[w>>2]=d;Bd(a|0,118480,w|0)|0;wc(118496,33,1,a|0)|0;wc(118536,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;Bd(a|0,118576,v|0)|0;wc(118256,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Bd(a|0,118272,u|0)|0}else{wc(118424,10,1,a|0)|0;wc(118408,10,1,a|0)|0;wc(118440,11,1,a|0)|0;c[t>>2]=b;Bd(a|0,118456,t|0)|0;c[s>>2]=d;Bd(a|0,118480,s|0)|0;wc(118496,33,1,a|0)|0;wc(118536,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;Bd(a|0,118576,r|0)|0;wc(118256,10,1,a|0)|0;wc(118296,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;Bd(a|0,117896,q|0)|0;wc(118320,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Bd(a|0,118336,p|0)|0}else{wc(118296,17,1,a|0)|0}wc(118608,32,1,a|0)|0;wc(118648,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;Bd(a|0,118680,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;Bd(a|0,118016,n|0)|0;i=m;return}function gZ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Zd(32,a|0)|0;}while((d|0)!=0);i=c;return}function hZ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){wc(117872,4,1,b|0)|0}else if((e|0)==39){wc(117880,6,1,b|0)|0}else if((e|0)==60){wc(117864,4,1,b|0)|0}else if((e|0)==34){wc(117888,6,1,b|0)|0}else{Zd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function iZ(a){a=a|0;var b=0,c=0,d=0;b=i;c=mc(a|0,117856)|0;if((c|0)==0){d=-1;i=b;return d|0}$c(c|0,0,2)|0;a=yb(c|0)|0;cd(c|0)|0;d=a;i=b;return d|0}function jZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=baa((Faa(l|0)|0)+15|0)|0;c[f>>2]=l;lc(m|0,117584,f|0)|0;gZ(a,2);wc(117600,10,1,a|0)|0;hZ(a,m);wc(117616,12,1,a|0)|0;gZ(a,2);c[e>>2]=iZ(m)|0;Bd(a|0,117632,e|0)|0;caa(m);gZ(a,2);wc(117664,9,1,a|0)|0;gZ(a,4);wc(117680,22,1,a|0)|0;gZ(a,4);wc(117704,22,1,a|0)|0;gZ(a,4);wc(117728,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){pZ(g,m,n);o=c[l>>2]|0;gZ(a,4);wc(117760,8,1,a|0)|0;hZ(a,o);wc(117776,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{uZ(h,m,l);g=c[n>>2]|0;gZ(a,4);wc(117760,8,1,a|0)|0;hZ(a,g);wc(117776,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{pZ(j,m,q);b=c[t>>2]|0;gZ(a,4);wc(117800,8,1,a|0)|0;hZ(a,b);wc(117816,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){gZ(a,2);v=117840;w=v;x=wc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{uZ(k,m,s);e=c[u>>2]|0;gZ(a,4);wc(117800,8,1,a|0)|0;hZ(a,e);wc(117816,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));gZ(a,2);v=117840;w=v;x=wc(w|0,10,1,a|0)|0;i=d;return}function kZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;gZ(a,2);c[f>>2]=c[b>>2];Bd(a|0,117520,f|0)|0;hZ(a,c[b+4>>2]|0);wc(117552,11,1,a|0)|0;hZ(a,c[b+8>>2]|0);wc(117224,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];oZ(a,4,e);gZ(a,2);wc(117568,12,1,a|0)|0;i=d;return}function lZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{pZ(p,r,v);fZ(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,117336);w=v+9|0;LI(w);gZ(a,2);c[o>>2]=c[f>>2];Bd(a|0,117344,o|0)|0;gZ(a,4);wc(115768,6,1,a|0)|0;hZ(a,c[s>>2]|0);wc(115776,8,1,a|0)|0;gZ(a,4);c[n>>2]=DI(w)|0;Bd(a|0,117120,n|0)|0;gZ(a,4);x=+II(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(a|0,117144,m|0)|0;gZ(a,4);x=+HI(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Bd(a|0,116312,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];oZ(a,6,j);gZ(a,2);wc(117368,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function mZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{gZ(a,2);tZ(l,d,x);c[j>>2]=c[q>>2];Bd(a|0,117192,j|0)|0;tZ(m,d,x);hZ(a,c[r>>2]|0);wc(117224,3,1,a|0)|0;gZ(a,4);wc(117232,7,1,a|0)|0;tZ(n,d,x);if((c[s>>2]|0)>0){y=0;do{gZ(a,6);c[g>>2]=0;Bd(a|0,117240,g|0)|0;y=y+1|0;tZ(n,d,x);}while((y|0)<(c[s>>2]|0))}gZ(a,4);wc(117264,8,1,a|0)|0;gZ(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;tZ(o,d,x);z=+FI(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;tZ(p,d,x);A=AI(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;Bd(a|0,117280,f|0)|0;gZ(a,2);wc(117320,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function nZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{uZ(n,o,v-u|0);fZ(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,117072);q=v+9|0;LI(q);gZ(a,2);wc(117080,15,1,a|0)|0;gZ(a,4);c[m>>2]=c[e>>2];Bd(a|0,117096,m|0)|0;gZ(a,4);c[l>>2]=DI(q)|0;Bd(a|0,117120,l|0)|0;gZ(a,4);w=+II(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Bd(a|0,117144,j|0)|0;gZ(a,4);w=+HI(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Bd(a|0,116312,g|0)|0;gZ(a,2);wc(117168,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function oZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;gZ(a,b);wc(117384,16,1,a|0)|0;hZ(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?117488:117504;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;Bd(a|0,117408,f|0)|0;i=e;return}function pZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){qZ(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function qZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=mc(c[o>>2]|0,118720)|0;if((p|0)!=0){q=p;break}p=be(c[(Sc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;vH(0,118728,g)}else{q=0}}while(0);g=mC(0)|0;if((g|0)==0){vH(0,118760,f)}f=a+8|0;c[a+20>>2]=daa(c[f>>2]|0,32)|0;p=a+12|0;o=daa((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=118792;c[o+12>>2]=0;c[o+16>>2]=0;xC(g,h);yC(g,9,88);h=c[n>>2]|0;do{if((h|0)==0){o=j;Jaa(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((zC(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=HC(EC(g)|0)|0;s=FC(g)|0;cd(q|0)|0;tC(g);r=c[a>>2]|0;c[e>>2]=118896;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;vH(0,118832,e)}else if((t|0)==11){cd(q|0)|0;break}}else{if((zC(g,h,Faa(h|0)|0,1)|0)!=0){break}s=HC(EC(g)|0)|0;o=FC(g)|0;tC(g);r=c[n>>2]|0;c[d>>2]=118896;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;vH(0,118936,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(119e3,118896,295,119040)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(119064,118896,297,119040)}}function rZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((Baa(119472,b)|0)==0){if((Baa(c[d>>2]|0,119480)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}uH(0,p,119488,l);l=c[29832]|0;p=c[29886]|0;do{if((l|0)==0|(p|0)==0){c[29886]=32;a=baa(1152)|0;c[29832]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[29886]=p<<1;a=eaa(l,p*72|0)|0;c[29832]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(xZ(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((Baa(119552,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((Baa(119560,u)|0)==0){c[29892]=Fd(c[t+4>>2]|0)|0}else{if((Baa(119592,u)|0)==0){c[119572>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if((Baa(119608,u)|0)==0){c[119580>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if((Baa(119616,u)|0)==0){c[119576>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if((Baa(119632,u)|0)==0){c[119584>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if((Baa(119640,u)|0)!=0){v=23;break a}c[119588>>2]=(Baa(c[t+4>>2]|0,119656)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];vH(0,119664,k)}else if((v|0)==45){i=e;return}}if((Baa(119312,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=118896;c[j+4>>2]=k;c[j+8>>2]=v;vH(0,119696,j)}if((Baa(119760,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=118896;c[h+4>>2]=j;vH(0,119768,h)}h=Wb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=118896;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;vH(0,119824,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=119888;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((Baa(119256,b)|0)!=0){if((Baa(119448,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=119992;m=Fd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=12e4;i=e;return}c[119276>>2]=0;c[119280>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((Baa(m,119480)|0)==0){c[119276>>2]=Fd(c[b+4>>2]|0)|0}else{if((Baa(m,119944)|0)!=0){break}c[119280>>2]=Fd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[119276>>2]|0)==0){w=0;break}w=(c[119280>>2]|0)!=0|0}}while(0);uH(0,w,119952,f);c[29818]=-1;f=119284|0;w=119568;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function sZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((Baa(119256,b)|0)==0){o=e+0|0;p=119272|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));wZ(e);i=d;return}if((Baa(119312,b)|0)==0){e=h+24|0;r=baa((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=baa(36)|0;t=s;o=s+0|0;p=(c[29832]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((Baa(119336,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Gd(e+(k*20|0)+8|0,119344,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Baa(119384,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Gd(h+(k*20|0)+8|0,119400,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((Baa(119448,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function tZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){qZ(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function uZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){qZ(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;vH(0,119104,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=119184;p=o;vH(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=119184;p=o;vH(0,p,f)}}function vZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){caa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){caa(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}caa(k);c[d>>2]=0;i=b;return}function wZ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=baa(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=Faa(f|0)|0;c[e+64>>2]=k;k=c[29866]|0;do{if((k|0)==0){c[29866]=e;c[e+44>>2]=0;l=baa(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){Ac(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=baa(384)|0;c[l>>2]=n;if((n|0)==0){Ac(-1)}else{Jaa(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[29866]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[29866]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=Faa(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(Faa(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 6:{B=o;C=y;D=17;break};case 10:{E=o;D=13;break};case 4:{F=o;G=y;D=19;break};case 3:{H=o;I=x;J=y;D=20;break};case 8:{K=o;D=15;break};case 2:{L=o;M=x;N=y;D=21;break};case 1:{O=o;P=x;Q=y;D=22;break};case 5:{R=o;S=y;D=18;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;E=z;D=13;break};case 7:{T=o;U=y;D=16;break};case 9:{V=o;D=14;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+E|0;c[p>>2]=o;V=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+V|0;c[p>>2]=o;K=o;D=15}if((D|0)==15){T=K;U=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){B=T;C=((d[A+6|0]|0)<<16)+U|0;D=17}if((D|0)==17){R=B;S=((d[A+5|0]|0)<<8)+C|0;D=18}if((D|0)==18){F=R;G=(d[A+4|0]|0)+S|0;D=19}if((D|0)==19){H=F;I=((d[A+3|0]|0)<<24)+x|0;J=G;D=20}if((D|0)==20){L=H;M=((d[A+2|0]|0)<<16)+I|0;N=J;D=21}if((D|0)==21){O=L;P=((d[A+1|0]|0)<<8)+M|0;Q=N;D=22}if((D|0)==22){W=O;X=(d[A]|0)+P|0;Y=Q}Q=X-Y-W^W>>>13;X=Y-W-Q^Q<<8;Y=W-Q-X^X>>>13;W=Q-X-Y^Y>>>12;Q=X-Y-W^W<<16;X=Y-W-Q^Q>>>5;Y=W-Q-X^X>>>3;W=Q-X-Y^Y<<10;Q=X-Y-W^W>>>15;c[p>>2]=Q;p=(c[29866]|0)+40|0;W=c[p>>2]|0;Y=Q&(c[W+4>>2]|0)+ -1;Q=c[W>>2]|0;W=Q+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[Q+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[29866]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[29866]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=baa((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){Ac(-1)}Jaa(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;Q=c[j>>2]|0;c[Y+24>>2]=(((Q<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((Q|0)==0){_=e}else{Q=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=Q}else{W=Q;X=j;while(1){j=X+16|0;P=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];O=Z+(A*12|0)+4|0;D=(c[O>>2]|0)+1|0;c[O>>2]=D;N=c[W+24>>2]|0;if(D>>>0>N>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[O>>2]|0)>>>0)/(N>>>0)|0}c[X+12>>2]=0;N=Z+(A*12|0)|0;c[j>>2]=c[N>>2];j=c[N>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[N>>2]=X;N=c[h>>2]|0;if((P|0)==0){$=N;break}else{W=N;X=P}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){Q=$;Y=W;e=X}else{_=W;break}}}caa(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function xZ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[29866]|0)==0){f=24}else{g=Faa(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(Faa(a|0)|0)+s|0;switch(v|0){case 4:{x=h;y=u;f=12;break};case 1:{z=h;A=t;B=u;f=15;break};case 5:{C=h;D=u;f=11;break};case 6:{E=h;F=u;f=10;break};case 7:{G=h;H=u;f=9;break};case 8:{I=h;f=8;break};case 10:{J=h;f=6;break};case 9:{K=h;f=7;break};case 2:{L=h;M=t;N=u;f=14;break};case 11:{J=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 3:{O=h;P=t;Q=u;f=13;break};default:{R=h;S=t;T=u}}if((f|0)==6){K=((d[w+9|0]|0)<<16)+J|0;f=7}if((f|0)==7){I=((d[w+8|0]|0)<<8)+K|0;f=8}if((f|0)==8){G=I;H=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){E=G;F=((d[w+6|0]|0)<<16)+H|0;f=10}if((f|0)==10){C=E;D=((d[w+5|0]|0)<<8)+F|0;f=11}if((f|0)==11){x=C;y=(d[w+4|0]|0)+D|0;f=12}if((f|0)==12){O=x;P=((d[w+3|0]|0)<<24)+t|0;Q=y;f=13}if((f|0)==13){L=O;M=((d[w+2|0]|0)<<16)+P|0;N=Q;f=14}if((f|0)==14){z=L;A=((d[w+1|0]|0)<<8)+M|0;B=N;f=15}if((f|0)==15){R=z;S=(d[w]|0)+A|0;T=B}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[29866]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=Faa(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((Aaa(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,120024)|0)==0){V=0;break}else{W=120048}i=b;return W|0}}while(0);c[e>>2]=a;uH(0,(V|0)!=0|0,120096,e);W=V+4|0;i=b;return W|0}function yZ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((zZ(120152,a,b)|0)!=0){d=1;i=c;return d|0}d=(zZ(120160,a,b)|0)!=0|0;i=c;return d|0}function zZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((Baa(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function AZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(Baa(c[68468>>2]|0,120168)|0)==0|0;uH(0,m,120184,l);l=(Baa(c[70372>>2]|0,120168)|0)==0|0;uH(0,l,120240,k);k=(Baa(c[72364>>2]|0,120168)|0)==0|0;uH(0,k,120296,j);j=120360|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=120488|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[72368+(k<<2)>>2]|0;if((l|0)==2){q=c[68344+(k<<2)>>2]|0;if(!((zZ(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[68344+(k<<2)>>2]|0;if((CZ(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((zZ(c[68344+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=120360+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=120360+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[120488+(k<<2)>>2]=BZ(q,p)|0;t=j}else if((r|0)==13){r=0;l=120360+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[120488+(k<<2)>>2]=DZ(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];tH(1,0,120616,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];tH(1,0,120616,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];tH(1,0,120616,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];tH(1,0,120672,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function BZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((Baa(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function CZ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(DZ(a,b)|0)!=0|0;i=c;return d|0}function DZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=Faa(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((Caa(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function EZ(){i=i;return}function FZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){Ac(0)}e=c[r>>2]|0;wc(120704,5,1,e|0)|0;f=b;b=0;while(1){Zd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}wc(120712,20,1,e|0)|0;Ac(0);return 0}function GZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;Bd(d|0,120736,e|0)|0;if((b|0)==0){Ac(1)}else{zd(d|0)|0;OZ();zd(d|0)|0;ib(6,0)|0;nd()}}function HZ(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function IZ(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function JZ(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function KZ(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function LZ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function MZ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}Jaa(p|0,32,b+(d-p)|0)|0;i=f;return}function NZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=121776+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[121820+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[121816+(e*48|0)>>2]|0)==1){PZ(b)|0}k=121780+(e*48|0)|0;if((c[k>>2]|0)==0){break}cd(c[f>>2]|0)|0;caa(c[k>>2]|0)}}while(0);do{if((h|0)==10){cd(g|0)|0;b=121780+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Pd(k|0)|0;caa(c[b>>2]|0)}}while(0);c[f>>2]=0}c[121812+(e*48|0)>>2]=0;c[121780+(e*48|0)>>2]=0;i=d;return 0}function OZ(){var a=0,b=0;a=i;if((c[30186]|0)!=0){i=a;return}c[30186]=1;c[120752>>2]=0;b=0;do{c[120748>>2]=b;NZ(120744)|0;b=b+1|0;}while((b|0)<100);i=a;return}function PZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[121792+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=121776+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;$c(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[121796+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[121804+(d*48|0)>>2]&2|0)!=0){zd(c[f>>2]|0)|0}d=Yc(rb(c[f>>2]|0)|0,h|0)|0;$c(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){RZ(111,120760);e=111;i=b;return e|0}else{c[(Sc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function QZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function RZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Vc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;Bd(m|0,121672,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;Bd(m|0,121704,j|0)|0;l=m;break}else{n=c[121544+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;Bd(m|0,121728,h|0)|0;l=m;break}}}while(0);h=c[30434]|0;do{if((h|0)==0){wc(126608,29,1,l|0)|0}else{c[g>>2]=(h-121776|0)/48|0;Bd(l|0,121744,g|0)|0;b=c[(c[30434]|0)+4>>2]|0;if((b|0)==0){wc(126592,10,1,l|0)|0;break}else{c[f>>2]=b;Bd(l|0,126576,f|0)|0;break}}}while(0);f=c[31660]|0;if((f|0)!=0){c[d>>2]=f;Bd(l|0,126648,d|0)|0}d=(c[31680]|0)!=0?126728:126744;f=(c[31688]|0)!=0?126760:126776;g=(c[31698]|0)!=0?126800:126816;c[e>>2]=(c[31674]|0)!=0?126704:126712;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;Bd(l|0,126672,e|0)|0;GZ(126832,1)}function SZ(){var a=0,b=0;a=i;c[31710]=1;b=c[r>>2]|0;c[30444]=b;c[121796>>2]=QZ(b)|0;c[121800>>2]=1;c[121816>>2]=1;b=c[s>>2]|0;c[122016>>2]=b;c[122036>>2]=QZ(b)|0;c[122040>>2]=1;c[122056>>2]=0;b=c[t>>2]|0;c[122064>>2]=b;c[122084>>2]=QZ(b)|0;c[122088>>2]=1;c[122104>>2]=1;i=a;return}function TZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=Cc(g|0,c[132088+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[31712]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=Cc(c[f>>2]|0,c[132088+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[31712]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;$c(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Sc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}$c(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function UZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){RZ(b,d)}d=c[31714]|0;if((d|0)!=0){Je[d&7]()|0}c[(Sc()|0)>>2]=b;i=e;return b|0}function VZ(a){a=a|0;var b=0,d=0;b=i;c[31744]=0;c[31746]=0;c[31748]=0;d=((WZ(a,0)|0)==0)<<31>>31;i=b;return d|0}function WZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[31748]|0;c[31748]=j+1;if((j|0)==1){c[31746]=d}if(($Z(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=a_(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function XZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[31744]|0;l=127e3+(k<<4)|0;m=c[l>>2]|0;switch(YZ(m)|0){case 6:{n=c[127004+(k<<4)>>2]|0;o=(c[32960]|0)+1|0;c[32960]=o;c[131848+(o<<2)>>2]=n;c[31744]=k+1;continue b;break};case 19:case 17:{c[31720]=0;c[31744]=k+1;continue b;break};case 18:{c[31720]=1;c[31744]=k+1;continue b;break};case 8:{n=c[32960]|0;p=131848+(n<<2)|0;q=c[p>>2]|0;if((q|0)>=1){s=10;break b}c[32960]=n+ -1;c[31744]=k+1;continue b;break};case 21:{c[31722]=0;c[31744]=k+1;continue b;break};case 3:{n=c[32960]|0;o=131848+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[32960]=n+ -1;c[32976]=(c[32976]|0)+ -1;c[31744]=k+1;continue b}else{n=c[32976]|0;c[32976]=n+ -1;c[31744]=(c[131912+(n<<2)>>2]|0)+1;continue b}break};case 1:{n=c[127004+(k<<4)>>2]|0;t=(c[32976]|0)+1|0;c[32976]=t;c[131912+(t<<2)>>2]=n;c[31744]=k+1;continue b;break};case 20:{c[31740]=c[127004+(k<<4)>>2];c[31744]=k+1;continue b;break};case 33:{c[32988]=1;c[31744]=k+1;continue b;break};case 16:{if(b){s=28;break a}c[31744]=k+1;continue b;break};case 9:{n=(pe[c[31728]&127](l)|0)==0;c[31744]=(c[31744]|0)+1;if(n){break b}else{continue b}break};case 22:{c[31722]=1;c[31744]=k+1;continue b;break};case 2:{c[32960]=0;c[32976]=0;c[31744]=c[127004+(k<<4)>>2];if(b){s=24;break a}if((c[32972]|0)==0){j=0;s=37;break a}k=Je[c[31730]&7]()|0;if((k|0)==0){continue b}else{j=k;s=37;break a}break};default:{s=4;break a}}}if((s|0)==10){s=0;if(b){s=11;break}c[p>>2]=q+ -1;c[32972]=1;k=se[c[31726]&63](l,g,d)|0;if((k|0)>0){s=13;break}if((k|0)<0){s=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;s=37;break}}if((s|0)==4){h=c[r>>2]|0;d=c[31660]|0;c[f>>2]=m;c[f+4>>2]=d;Bd(h|0,131800,f|0)|0;if((c[c[31716]>>2]|0)==0){RZ(100,131832);j=100;i=e;return j|0}else{c[(Sc()|0)>>2]=100;j=100;i=e;return j|0}}else if((s|0)==11){j=Je[c[31714]&7]()|0;i=e;return j|0}else if((s|0)==13){f=c[c[31716]>>2]|0;j=UZ(f,c[(Sc()|0)>>2]|0,131896)|0;i=e;return j|0}else if((s|0)==15){if((c[(c[31716]|0)+8>>2]|0)==0){RZ(-1,131896);j=-1;i=e;return j|0}else{c[(Sc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((s|0)==24){j=Je[c[31714]&7]()|0;i=e;return j|0}else if((s|0)==28){j=Je[c[31714]&7]()|0;i=e;return j|0}else if((s|0)==37){i=e;return j|0}return 0}function YZ(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function ZZ(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=XZ(b,0,0)|0;i=a;return d|0}function _Z(){c[31736]=0;c[31744]=0;c[32976]=0;c[32960]=0;c[32972]=0;c[32978]=0;c[32962]=0;i=i;return}function $Z(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[31744]|0;if((g|0)>299){wc(131976,24,1,c[r>>2]|0)|0;GZ(c[31660]|0,1)}else{c[127e3+(g<<4)>>2]=a;c[127004+(g<<4)>>2]=b;c[127008+(g<<4)>>2]=d;c[127012+(g<<4)>>2]=e;c[31744]=g+1;i=f;return g|0}return 0}function a_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=b_(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[31748]|0)+ -1|0;c[31748]=h;if((h|0)==0){$Z(2,c[31746]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{$Z(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function b_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((c_(b,e)|0)!=0){g=c[e>>2]|0;break}if((d_(b,e)|0)!=0){g=c[e>>2]|0;break}h=e_(b,f,1)|0;j=$Z(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=WZ(h,j)|0}}while(0);i=d;return g|0}function c_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){$Z(22,0,0,0)|0;j=g;k=30;break a}else{$Z(21,0,0,0)|0;j=g;k=30;break a}break};case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==80|h<<24>>24==112){l=g;m=18}else if(h<<24>>24==83|h<<24>>24==115){l=g;m=19}else{l=b;m=17}$Z(m,0,0,0)|0;j=l;k=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{n=b;o=0;k=14;break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==76|h<<24>>24==108){p=g;q=13}else if(h<<24>>24==82|h<<24>>24==114){p=g;q=14}else{p=b;q=15}g=e_(p+1|0,f,0)|0;if((g|0)==0){k=15;break a}$Z(q,c[f>>2]|0,0,0)|0;j=g+ -1|0;k=30;break};case 43:{r=0;k=13;break};case 45:{r=1;k=13;break};case 120:case 88:{$Z(4,1,0,0)|0;j=b;k=30;break};case 36:{$Z(33,0,0,0)|0;j=b;k=30;break};case 112:case 80:{$Z(20,1,0,0)|0;j=b;k=30;break};case 39:case 34:case 2:{c[127008+(($Z(11,0,0,0)|0)<<4)>>2]=b;g=f_(b)|0;c[d>>2]=g;s=(g|0)!=0|0;i=e;return s|0};case 47:{$Z(5,0,0,0)|0;j=b;k=30;break};case 58:{$Z(16,0,0,0)|0;j=b;k=30;break};default:{s=0;i=e;return s|0}}}while(0);if((k|0)==13){n=b+1|0;o=r;k=14}b:do{if((k|0)==14){r=e_(n,f,0)|0;if((r|0)==0){k=15;break}switch(a[r]|0){case 120:case 88:{$Z(4,c[f>>2]|0,0,0)|0;j=r;k=30;break b;break};case 104:case 72:{b=c[f>>2]|0;c[127008+(($Z(12,b,0,0)|0)<<4)>>2]=r+1;j=r+b|0;k=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((o|0)==0){t=b}else{q=0-b|0;c[f>>2]=q;t=q}$Z(20,t,0,0)|0;j=r;k=30;break b;break};default:{s=0;i=e;return s|0}}}}while(0);if((k|0)==15){c[d>>2]=0;s=1;i=e;return s|0}else if((k|0)==30){c[d>>2]=j+1;s=1;i=e;return s|0}return 0}function d_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e_(b,f,1)|0;$Z(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=e_(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=e_(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}$Z(23,n,r,0)|0;o=q;m=45;break};case 103:case 71:{s=0;m=3;break};case 97:case 65:{n=f;while(1){t=a[n]|0;if(t<<24>>24==32){n=n+1|0}else{break}}if(!((t+ -48<<24>>24&255)<10)){$Z(30,0,0,0)|0;o=n;m=45;break a}l=e_(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}$Z(31,p,0,0)|0;o=l;m=45;break};case 111:case 79:{u=32;v=34;m=38;break};case 100:case 68:{l=e_(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=e_(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}$Z(26,p,y,0)|0;o=x;m=45;break};case 108:case 76:{p=e_(f,g,0)|0;if((p|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=p;m=45;break a}$Z(29,l,0,0)|0;o=p;m=45;break};case 122:case 90:{u=35;v=36;m=38;break};case 101:case 69:{s=1;m=3;break};case 105:case 73:{u=7;v=10;m=38;break};default:{c[31744]=(c[31744]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=e_(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){t=e_(b+1|0,h,0)|0;if((t|0)==0){m=4;break}A=t;B=a[t]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){$Z((s|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=e_(A+1|0,j,0)|0;if((y|0)==0){m=4;break}$Z((s|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=e_(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){$Z(u,x,0,0)|0;o=y;m=45;break}b=e_(y+1|0,h,0)|0;if((b|0)==0){m=4;break}$Z(v,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function e_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function f_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[31716]>>2]|0)==0){RZ(100,131960);n=0;i=d;return n|0}else{c[(Sc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function g_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[132030|0]=48;k=132030|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=132008+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function h_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[31738]|0;f=c[31734]|0;if((e|0)>(f|0)){c[31734]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[33026]|0)){h=g}else{i_(f,g);h=c[31734]|0}g=c[33028]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Qd(g|0,c[31712]|0)|0;h=Faa(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Zd(a[k]|0,c[31712]|0)|0;Qd(h|0,c[31712]|0)|0;b=Faa(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function i_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[33028]|0;if((f|0)==132192){c[33026]=1024;g=1024}else{g=c[33026]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[33026]=j;h=j}j=baa(h)|0;if((j|0)==0){RZ(113,132592);k=c[33028]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[33028]|0}else{l=k}if((l|0)==132192){m=132112;c[33028]=j;i=e;return}caa(l);m=132112;c[33028]=j;i=e;return}function j_(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[31734]|0;f=c[33026]|0;if((e|0)<(f|0)){g=e}else{i_(e,f);g=c[31734]|0}c[31734]=g+1;a[(c[33028]|0)+g|0]=b;i=d;return}function k_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[31698]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){RZ(101,132120);l=101;i=d;return l|0}else{c[(Sc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[31710]|0)==0){SZ();m=c[f>>2]|0}else{m=k}k=121776+(m*48|0)|0;c[30434]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){p_(k,c[b+12>>2]|0,j);o=q_(j,h)|0;if((o|0)==(c[121784+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[121788+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=NZ(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[121808+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=121792+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[121808+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=121800+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[121800+(m*48|0)>>2]=1;r=1;break}else{c[121800+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];lc(j|0,132128,e|0)|0}else{p_(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){l_(107,132120,b);l=107;i=d;return l|0}else{c[(Sc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=121820+(m*48|0)|0;c[q>>2]=0;c[121812+(m*48|0)>>2]=0;e=121816+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=121804+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((Hc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Sc()|0;s=c[k>>2]|0;if(o){l_(s,132120,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Mb()|0;c[n>>2]=s;if((s|0)!=0){c[121780+(m*48|0)>>2]=0;c[121788+(m*48|0)>>2]=-1;c[121784+(m*48|0)>>2]=-1;c[121796+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Sc()|0;o=c[k>>2]|0;if(s){l_(o,132120,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 78:case 110:{if((Hc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){l_(128,132120,b);l=128;i=d;return l|0}else{c[(Sc()|0)>>2]=128;l=128;i=d;return l|0}break};case 82:case 114:{break};default:{break b}}}while(0);o=mc(j|0,c[33022]|0)|0;if((o|0)==0){break}cd(o|0)|0}}while(0);q=baa((Faa(j|0)|0)+1|0)|0;c[121780+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){l_(113,132144,b);l=113;i=d;return l|0}else{c[(Sc()|0)>>2]=113;l=113;i=d;return l|0}}Laa(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=mc(j|0,c[132088+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=mc(j|0,c[132048+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=mc(j|0,c[132088+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Sc()|0;o=c[g>>2]|0;if(h){RZ(o,132120);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=121796+(m*48|0)|0;c[r>>2]=QZ(u)|0;u=q_(j,121788+(m*48|0)|0)|0;c[121784+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){l_(108,132120,b);l=108;i=d;return l|0}else{c[(Sc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if(($c(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){l_(129,132120,b);l=129;i=d;return l|0}else{c[(Sc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function l_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){RZ(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[33026]|0)){j=d;k=g}else{i_(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[33028]|0;c[(c[30434]|0)+4>>2]=f;p_(k,j,f);RZ(a,b);i=e;return}function m_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;lc(j|0,132128,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=Faa(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?132160:132168;c[h+24>>2]=(b|0)==5?132176:132184;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=k_(h)|0;i=e;return a|0}function n_(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=121776+(d*48|0)|0;c[30434]=e;if(d>>>0>99){if((c[a>>2]|0)==0){RZ(101,132608);f=101;i=b;return f|0}else{c[(Sc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((m_(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){RZ(114,132616);f=114;i=b;return f|0}else{c[(Sc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[121800+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){RZ(102,132616);f=102;i=b;return f|0}else{c[(Sc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function o_(){var a=0,b=0;a=i;b=ZZ()|0;c[31660]=0;i=a;return b|0}function p_(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function q_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((pc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function r_(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[31740]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[31720]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];lc(p|0,132624,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(Faa(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;me[c[31724]&255](32);}while((A|0)>0)}if((D|0)!=0){me[c[31724]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{me[c[31724]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Kc(A|0)|0)+1|0;c[m>>2]=t-(c[31740]|0);lc(A|0,132632,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;me[c[31724]&255](32);}while((z|0)>0)}if((x|0)!=0){me[c[31724]&255]((w|0)!=0?45:43)}z=c[31740]|0;do{if((z|0)<1){me[c[31724]&255](46);y=c[31724]|0;if((z|0)<0){G=y;J=z;while(1){me[G&255](48);I=J+1|0;K=c[31724]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}me[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}me[c[31724]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[31724]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){me[P&255](a[J]|0);R=Q+ -1|0;S=c[31724]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}me[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;me[c[31724]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){me[c[31724]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;me[c[31724]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){me[c[31724]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;me[c[31724]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;me[c[31724]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;me[c[31724]&255](42);}while((_|0)>0);i=l;return 0}function s_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[31740]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(lc(n|0,132640,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[31720]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;me[c[31724]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;me[c[31724]&255](32);}while((b|0)>0)}do{if(q){if((c[31720]|0)==0){break}me[c[31724]&255](43)}else{me[c[31724]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;me[c[31724]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;me[c[31724]&255](48);}while((z|0)>0);i=j;return 0}function t_(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{me[c[31724]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[31724]|0;if((h|0)==0){me[d&255](70);i=g;return 0}else{me[d&255](84);i=g;return 0}return 0}function u_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[31736]|0)!=0){g=v_()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 23:{h=s_(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 29:{t_(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 28:case 27:{h=A_(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 31:{z_(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 32:{w_(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 36:{B_(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 10:{x_(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 7:{w_(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 30:{y_(b,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=r_(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 35:{B_(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 34:{x_(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;Bd(h|0,132648,f|0)|0;GZ(c[31660]|0,1)}}return 0}function v_(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[31736]|0;c[31736]=0;if((c[31698]|0)!=0){if((b|0)>0){d=c[31738]|0;e=c[31734]|0;if((d|0)<=(e|0)){f=b;while(1){me[c[31724]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[31734]=f;h=0;i=a;return h|0}f=b-d+e|0;c[31734]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){me[c[31724]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[31734]|0;f=j+b|0;if((f|0)>=0){if((c[31738]|0)<(j|0)){c[31738]=j}c[31734]=f;h=0;i=a;return h|0}if((c[c[31716]>>2]|0)==0){RZ(110,132736);h=110;i=a;return h|0}else{c[(Sc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[31734]|0;if((c[31738]|0)<(f|0)){c[31738]=f}j=f+b|0;c[31734]=j;c[31742]=(c[31742]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[31716]>>2]|0)==0){RZ(110,132736);h=110;i=a;return h|0}else{c[(Sc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[31734]|0;f=j+b|0;if((f|0)>=(c[(c[31718]|0)+16>>2]|0)){if((c[c[31716]>>2]|0)==0){RZ(110,132752);h=110;i=a;return h|0}else{c[(Sc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[31738]|0;if((d|0)<=(j|0)){e=b;while(1){me[c[31724]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[31742]=(c[31742]|0)+b;c[31734]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[31742]=(c[31742]|0)+f;c[31734]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){me[c[31724]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function w_(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=g_(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[31720]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{me[c[31724]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{me[c[31724]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[31720]|0)==0){break}me[c[31724]&255](43)}else{me[c[31724]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){me[c[31724]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function x_(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=g_(m,k,l,h)|0;h=c[l>>2]|0;g=(c[31720]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{me[c[31724]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{me[c[31724]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[31720]|0)==0){break}me[c[31724]&255](43)}else{me[c[31724]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){me[c[31724]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){me[c[31724]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{me[c[31724]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function y_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;me[c[31724]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function z_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;me[c[31724]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;me[c[31724]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function A_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=r_(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=r_(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[31740]|0;c[31740]=0;p=(e|0)==0?4:e+2|0;e=s_(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{me[c[31724]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[31740]=o;n=e;i=j;return n|0}function B_(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{me[c[31724]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;me[c[31724]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;me[c[31724]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){me[c[31724]&255](a[132712+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){me[c[31724]&255](a[132712+((d[p]|0)>>>4)|0]|0);me[c[31724]&255](a[132712+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function C_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 13:{f=(c[31736]|0)-(c[a+4>>2]|0)|0;g=0-(c[31734]|0)|0;c[31736]=(f|0)<(g|0)?g:f;h=1;i=b;return h|0};case 5:{h=Je[c[31732]&7]()|0;i=b;return h|0};case 11:{h=D_(c[a+8>>2]|0)|0;i=b;return h|0};case 4:case 14:{c[31736]=(c[31736]|0)+(c[a+4>>2]|0);h=1;i=b;return h|0};case 12:{h=E_(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return h|0};case 15:{c[31736]=(c[a+4>>2]|0)+ -1-(c[31734]|0);h=1;i=b;return h|0};default:{h=c[r>>2]|0;c[d>>2]=e;Bd(h|0,132680,d|0)|0;GZ(c[31660]|0,1)}}return 0}function D_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[31736]|0)!=0){e=v_()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}me[c[31724]&255](e<<24>>24);n=b}else{me[c[31724]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function E_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[31736]|0)!=0){f=v_()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;me[c[31724]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function F_(){var a=0,b=0;a=i;b=h_(10)|0;c[31736]=0;c[31734]=0;c[31738]=0;i=a;return(b|0)==0|0}function G_(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[31710]|0)==0){SZ()}c[31674]=0;c[31680]=1;c[31688]=1;c[31698]=1;d=n_(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[31716]=a;c[31734]=0;c[31736]=0;c[31738]=0;c[32988]=0;c[31740]=0;d=c[a+12>>2]|0;c[31660]=d;c[31712]=c[c[30434]>>2];if((VZ(d)|0)<0){if((c[a>>2]|0)==0){RZ(100,132760);e=100;i=b;return e|0}else{c[(Sc()|0)>>2]=100;e=100;i=b;return e|0}}c[31724]=231;c[31726]=44;c[31728]=111;c[31714]=4;c[31730]=5;c[31732]=6;_Z();c[31720]=0;d=c[30434]|0;c[31722]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((TZ(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Sc()|0;f=c[a>>2]|0;if(d){RZ(f,132768);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function H_(){var a=0,b=0;a=i;if((c[32988]|0)==0){b=h_(10)|0}else{h_(0)|0;zd(c[31712]|0)|0;b=0}c[31736]=0;c[31734]=0;c[31738]=0;i=a;return b|0}function I_(){var a=0,b=0,d=0;a=i;if((c[32972]|0)==0){b=0}else{d=h_(10)|0;c[32972]=0;b=d}c[31736]=0;c[31734]=0;c[31738]=0;i=a;return b|0}function J_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;d$(133496,h,133552);c[33196]=135004;c[132792>>2]=135024;c[132788>>2]=0;W0(132792|0,133496);c[132864>>2]=0;c[132868>>2]=-1;j=c[t>>2]|0;c[33400]=134872;E6(133604|0);k=133608|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[33400]=134112;c[133632>>2]=j;F6(g,133604|0);k=I6(g,137664)|0;l=k;G6(g);c[133636>>2]=l;c[133640>>2]=133560;a[133644|0]=(pe[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[33218]=135084;c[132876>>2]=135104;W0(132876|0,133600);c[132948>>2]=0;c[132952>>2]=-1;l=c[r>>2]|0;c[33412]=134872;E6(133652|0);k=133656|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[33412]=134112;c[133680>>2]=l;F6(f,133652|0);k=I6(f,137664)|0;g=k;G6(f);c[133684>>2]=g;c[133688>>2]=133568;a[133692|0]=(pe[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[33240]=135084;c[132964>>2]=135104;W0(132964|0,133648);c[133036>>2]=0;c[133040>>2]=-1;g=c[(c[(c[33240]|0)+ -12>>2]|0)+132984>>2]|0;c[33262]=135084;c[133052>>2]=135104;W0(133052|0,g);c[133124>>2]=0;c[133128>>2]=-1;c[(c[(c[33196]|0)+ -12>>2]|0)+132856>>2]=132872;g=(c[(c[33240]|0)+ -12>>2]|0)+132964|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[33240]|0)+ -12>>2]|0)+133032>>2]=132872;R_(133696,h,133576|0);c[33284]=135044;c[133144>>2]=135064;c[133140>>2]=0;W0(133144|0,133696);c[133216>>2]=0;c[133220>>2]=-1;c[33438]=134936;E6(133756|0);h=133760|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[33438]=133856;c[133784>>2]=j;F6(e,133756|0);j=I6(e,137672)|0;h=j;G6(e);c[133788>>2]=h;c[133792>>2]=133584;a[133796|0]=(pe[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[33306]=135124;c[133228>>2]=135144;W0(133228|0,133752);c[133300>>2]=0;c[133304>>2]=-1;c[33450]=134936;E6(133804|0);h=133808|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[33450]=133856;c[133832>>2]=l;F6(d,133804|0);l=I6(d,137672)|0;h=l;G6(d);c[133836>>2]=h;c[133840>>2]=133592;a[133844|0]=(pe[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[33328]=135124;c[133316>>2]=135144;W0(133316|0,133800);c[133388>>2]=0;c[133392>>2]=-1;h=c[(c[(c[33328]|0)+ -12>>2]|0)+133336>>2]|0;c[33350]=135124;c[133404>>2]=135144;W0(133404|0,h);c[133476>>2]=0;c[133480>>2]=-1;c[(c[(c[33284]|0)+ -12>>2]|0)+133208>>2]=133224;h=(c[(c[33328]|0)+ -12>>2]|0)+133316|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[33328]|0)+ -12>>2]|0)+133384>>2]=133224;i=b;return}function K_(a){a=a|0;a=i;U1(132872)|0;U1(133048)|0;$1(133224)|0;$1(133400)|0;i=a;return}function L_(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);i=b;return}function M_(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);jaa(a);i=b;return}function N_(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=I6(d,137672)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(pe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function O_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Fe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((wc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((zd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function P_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=wc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function Q_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((wc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ne[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((wc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((wc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function R_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=134936;j=b+4|0;E6(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=133968;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;F6(g,j);j=I6(g,137672)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=pe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(pe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Q5(134064)}else{G6(g);i=f;return}}function S_(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);i=b;return}function T_(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);jaa(a);i=b;return}function U_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=I6(d,137672)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=pe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(pe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Q5(134064)}else{i=e;return}}function V_(a){a=a|0;var b=0,c=0;b=i;c=Y_(a,0)|0;i=b;return c|0}function W_(a){a=a|0;var b=0,c=0;b=i;c=Y_(a,1)|0;i=b;return c|0}function X_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ne[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((wd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Y_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Yd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ne[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Yd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((wd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Z_(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);i=b;return}function __(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);jaa(a);i=b;return}function $_(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=I6(d,137664)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(pe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function a$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Fe[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((wc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((zd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function b$(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=wc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function c$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((wc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ne[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((wc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((wc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function d$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=134872;j=b+4|0;E6(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=134224;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;F6(g,j);j=I6(g,137664)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=pe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(pe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Q5(134064)}else{G6(g);i=f;return}}function e$(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);i=b;return}function f$(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);jaa(a);i=b;return}function g$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=I6(d,137664)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=pe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(pe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Q5(134064)}else{i=e;return}}function h$(a){a=a|0;var b=0,c=0;b=i;c=k$(a,0)|0;i=b;return c|0}function i$(a){a=a|0;var b=0,c=0;b=i;c=k$(a,1)|0;i=b;return c|0}function j$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ne[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((wd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function k$(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Yd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ne[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Yd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((wd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function l$(){var a=0;a=i;J_(0);ee(232,133488,q|0)|0;i=a;return}function m$(a){a=a|0;i=i;return}function n$(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function o$(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}me[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function p$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=134368;e=Faa(b|0)|0;f=iaa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Haa(g|0,b|0,e+1|0)|0;i=d;return}function q$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=134368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}function r$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=134368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function s$(a){a=a|0;i=i;return c[a+4>>2]|0}function t$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=134392;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=Faa(f|0)|0;g=iaa(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;Haa(h|0,f|0,d+1|0)|0;i=e;return}function u$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=134392;e=Faa(b|0)|0;f=iaa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;Haa(g|0,b|0,e+1|0)|0;i=d;return}function v$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=134392;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}function w$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=134392;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function x$(a){a=a|0;i=i;return c[a+4>>2]|0}function y$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=134368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}function z$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=134368;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}kaa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;jaa(j);i=b;return}function A$(a){a=a|0;i=i;return}function B$(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function C$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Le[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function D$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function E$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=be(e|0)|0;e=Faa(f|0)|0;if(e>>>0>4294967279){K$(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;Haa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=haa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;Haa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function F$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{p0(e,134608,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Le[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}p0(e,o,p)|0;if((a[g]&1)==0){break}jaa(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function G$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=Faa(e|0)|0;if(j>>>0>4294967279){K$(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=haa(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}Haa(k|0,e|0,j|0)|0;a[k+j|0]=0;F$(g,d,h);t$(b,g);if(!((a[g]&1)==0)){jaa(c[g+8>>2]|0)}if(!((a[h]&1)==0)){jaa(c[h+8>>2]|0)}c[b>>2]=134624;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function H$(a){a=a|0;var b=0;b=i;w$(a);jaa(a);i=b;return}function I$(a){a=a|0;var b=0;b=i;w$(a);i=b;return}function J$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;yc(134760)|0;if((c[a>>2]|0)==1){do{td(134784,134760)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;ic(134760)|0;me[d&255](b);yc(134760)|0;c[a>>2]=-1;ic(134760)|0;gd(134784)|0;i=e;return}else{ic(134760)|0;i=e;return}}function K$(a){a=a|0;a=Jc(8)|0;p$(a,134832);c[a>>2]=134448;_d(a|0,134488,41)}function L$(a){a=a|0;a=Jc(8)|0;p$(a,134832);c[a>>2]=134512;_d(a|0,134552,41)}function M$(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function N$(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function O$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){K$(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=haa(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}Haa(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function P$(b){b=b|0;i=i;return(a[b]&1)!=0|0}function Q$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){K$(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=haa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}Haa(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function R$(a){a=a|0;i=i;return a|0}function S$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=Faa(d|0)|0;if(f>>>0>4294967279){K$(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;Haa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=haa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;Haa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function T$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){K$(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=haa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}Jaa(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function U$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){K$(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;Jaa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=haa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;Jaa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function V$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){L$(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){K$(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;Haa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=haa(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;Haa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function W$(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function X$(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Y$(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}jaa(c[b+8>>2]|0);i=d;return}function Z$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}q0(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}Iaa(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function _$(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=$$(a,b)|0;i=c;return d|0}function $$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=Faa(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}q0(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}Iaa(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function a0(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function b0(a){a=a|0;i=i;return a+1|0}function c0(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function d0(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function e0(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function f0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){g0(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function g0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){r0(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}Jaa(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function h0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){g0(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function i0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){K$(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=haa(f)|0}else{p=haa(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}Haa(l|0,n|0,q+1|0)|0;if(o){jaa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function j0(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function k0(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function l0(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function m0(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function n0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=p0(b,g,h)|0;i=e;return d|0}function o0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){r0(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function p0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){q0(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}Haa(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function q0(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){K$(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=haa(q)|0;if((g|0)!=0){Haa(e|0,m|0,g|0)|0}if((j|0)!=0){Haa(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){Haa(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){jaa(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function r0(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){K$(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=haa(p)|0;if((g|0)!=0){Haa(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){Haa(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}jaa(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function s0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;V$(a,b,c,d,0);i=e;return}function t0(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function u0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=Faa(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function v0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=Aaa(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function w0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=Faa(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){L$(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=Aaa(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function x0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){K$(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;Haa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=haa(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;Haa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function y0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){K$(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=haa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}E9(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function z0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){K$(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=haa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}G9(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function A0(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}jaa(c[b+8>>2]|0);i=d;return}function B0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=C0(a,b,D9(b)|0)|0;i=c;return d|0}function C0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}F0(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}F9(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function D0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){K$(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=haa(f)|0}else{p=haa(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}E9(l,n,q+1|0)|0;if(o){jaa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function E0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){G0(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function F0(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){K$(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=haa(q<<2)|0;p=e;if((g|0)!=0){E9(p,m,g)|0}if((j|0)!=0){E9(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){E9(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){jaa(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function G0(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){K$(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=haa(p<<2)|0;o=e;if((g|0)!=0){E9(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){E9(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}jaa(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function H0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=Faa(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){K$(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=haa(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}Haa(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=p0(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=p0(b,m,j)|0;i=f;return}}function I0(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function J0(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function K0(a,b){a=a|0;b=b|0;var c=0;c=i;L0(a,b);i=c;return}function L0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Jc(16)|0;do{if((a[135216]|0)==0){if((Za(135216)|0)==0){break}c[33802]=135912;ee(67,135208,q|0)|0;Ub(135216)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=135208;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];G$(b,f,135264);c[e>>2]=135232;_d(e|0,135312,63)}function M0(a,b){a=a|0;b=b|0;var d=0;d=i;L0(a,c[a+16>>2]|b);i=d;return}function N0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=135256;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Le[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}G6(a+28|0);caa(c[e>>2]|0);caa(c[f>>2]|0);caa(c[a+48>>2]|0);caa(c[a+60>>2]|0);i=b;return}function O0(a){a=a|0;var b=0;b=i;N0(a);jaa(a);i=b;return}function P0(a){a=a|0;var b=0;b=i;N0(a);i=b;return}function Q0(a){a=a|0;var b=0;b=i;N0(a);i=b;return}function R0(a){a=a|0;i=i;return c[a+24>>2]|0}function S0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}F6(d,a+28|0);a=I6(d,137600)|0;f=Ee[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;G6(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function T0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;F6(e,a+28|0);a=I6(e,137600)|0;f=Ee[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;G6(e);i=d;return f|0}function U0(a,b){a=a|0;b=b|0;var c=0;c=i;F6(a,b+28|0);i=c;return}function V0(a){a=a|0;c[a>>2]=134856;i=i;return}function W0(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));E6(b);i=d;return}function X0(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);jaa(a);i=b;return}function Y0(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);i=b;return}function Z0(a){a=a|0;var b=0;b=i;c[a>>2]=134872;G6(a+4|0);i=b;return}function _0(a,b){a=a|0;b=b|0;var c=0;c=i;F6(a,b+4|0);i=c;return}function $0(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=pe[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function a1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=Ee[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function b1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=se[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function c1(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=134872;E6(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function d1(a){a=a|0;i=i;return c[a+8>>2]|0}function e1(a){a=a|0;i=i;return c[a+12>>2]|0}function f1(a){a=a|0;i=i;return c[a+16>>2]|0}function g1(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function h1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function i1(a){a=a|0;i=i;return c[a+20>>2]|0}function j1(a){a=a|0;i=i;return c[a+24>>2]|0}function k1(a){a=a|0;i=i;return c[a+28>>2]|0}function l1(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function m1(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function n1(a,b){a=a|0;b=b|0;i=i;return}function o1(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function p1(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function q1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function r1(a){a=a|0;i=i;return 0}function s1(a){a=a|0;i=i;return 0}function t1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=pe[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function u1(a){a=a|0;i=i;return-1}function v1(a){a=a|0;var b=0,e=0,f=0;b=i;if((pe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function w1(a,b){a=a|0;b=b|0;i=i;return-1}



function U3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=136392;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);v=c[34372]|0;c[k>>2]=h;h=R3(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;U0(q,f);S3(w,y,k,z,o,p,q);o$(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];uY(b,j,z,e,o,f,g);i=d;return}function V3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);y=c[34372]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=R3(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;U0(r,f);S3(x,z,l,A,p,q,r);o$(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];uY(b,k,A,e,p,f,g);i=d;return}function W3(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=R3(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=R3(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[137496]|0)==0;if(F){do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=X3(s,r,z,n)|0}else{do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=X3(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}oaa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=baa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}oaa()}}while(0);U0(w,f);Y3(N,L,G,P,u,v,w);o$(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];uY(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){caa(O)}if((J|0)==0){i=d;return}caa(J);i=d;return}function X3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Qc(b|0)|0;b=nc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Qc(e|0)|0;i=f;return b|0}function Y3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[34400]|0)==-1)){c[m>>2]=137600;c[m+4>>2]=233;c[m+8>>2]=0;J$(137600,m,234)}m=(c[137604>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34436]|0)==-1)){c[l>>2]=137744;c[l+4>>2]=233;c[l+8>>2]=0;J$(137744,l,234)}l=(c[137748>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ee[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);w=A+1|0;if((bd(l<<24>>24|0,c[34372]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);l=D+1|0;if((ae(A<<24>>24|0,c[34372]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Oe[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=Ee[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=pe[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Oe[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Y$(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Y$(n);i=k;return}function Z3(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=R3(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=R3(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[137496]|0)==0;if(F){do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=X3(s,r,z,n)|0}else{do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=X3(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}oaa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=baa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}oaa()}}while(0);U0(w,f);Y3(N,L,G,P,u,v,w);o$(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];uY(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){caa(O)}if((J|0)==0){i=d;return}caa(J);i=d;return}function _3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=136400;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);s=c[34372]|0;c[k>>2]=h;h=R3(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;U0(p,f);r=p;p=c[r>>2]|0;if(!((c[34400]|0)==-1)){c[l>>2]=137600;c[l+4>>2]=233;c[l+8>>2]=0;J$(137600,l,234)}l=(c[137604>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}o$(c[r>>2]|0)|0;Oe[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];uY(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];uY(b,j,u,z,m,f,g);I=j;i=d;return}function $3(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function a4(a){a=a|0;i=i;return}function b4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ye[p&31](b,d,k,f,g,q);i=j;return}U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34438]|0)==-1)){c[l>>2]=137752;c[l+4>>2]=233;c[l+8>>2]=0;J$(137752,l,234)}l=(c[137756>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}w=n;o$(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ne[c[f+24>>2]&127](o,w)}else{ne[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=Ee[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];A0(o);i=j;return}function c4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=136392;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);v=c[34372]|0;c[k>>2]=h;h=R3(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;U0(q,f);d4(w,y,k,z,o,p,q);o$(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];e4(b,j,z,e,o,f,g);i=d;return}function d4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[34398]|0)==-1)){c[m>>2]=137592;c[m+4>>2]=233;c[m+8>>2]=0;J$(137592,m,234)}m=(c[137596>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34438]|0)==-1)){c[l>>2]=137752;c[l+4>>2]=233;c[l+8>>2]=0;J$(137752,l,234)}l=(c[137756>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Oe[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=Ee[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Y$(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Y$(n);i=k;return}function e4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((se[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){z0(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((se[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){A0(l);break}c[m>>2]=0;c[b>>2]=0;A0(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((se[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function f4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);y=c[34372]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=R3(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;U0(r,f);d4(x,z,l,A,p,q,r);o$(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];e4(b,k,A,e,p,f,g);i=d;return}function g4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=136392;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);x=c[34372]|0;c[k>>2]=h;h=R3(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;U0(q,f);d4(w,y,k,z,o,p,q);o$(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];e4(b,j,z,e,o,f,g);i=d;return}function h4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);y=c[34372]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=R3(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;U0(r,f);d4(x,z,l,A,p,q,r);o$(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];e4(b,k,A,e,p,f,g);i=d;return}function i4(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=R3(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=R3(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[137496]|0)==0;if(F){do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=X3(s,r,z,n)|0}else{do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=X3(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}oaa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=baa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}oaa()}}while(0);U0(w,f);j4(N,L,G,P,u,v,w);o$(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];e4(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){caa(O)}if((J|0)==0){i=d;return}caa(J);i=d;return}function j4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[34398]|0)==-1)){c[m>>2]=137592;c[m+4>>2]=233;c[m+8>>2]=0;J$(137592,m,234)}m=(c[137596>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34438]|0)==-1)){c[l>>2]=137752;c[l+4>>2]=233;c[l+8>>2]=0;J$(137752,l,234)}l=(c[137756>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ee[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);w=A+1|0;if((bd(l<<24>>24|0,c[34372]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);l=D+1|0;if((ae(A<<24>>24|0,c[34372]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Oe[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=Ee[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=Ee[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=pe[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Oe[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Y$(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Y$(n);i=k;return}function k4(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=R3(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=R3(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[137496]|0)==0;if(F){do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);r=c[34372]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=X3(s,r,z,n)|0}else{do{if(o){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=X3(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}oaa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=baa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}oaa()}}while(0);U0(w,f);j4(N,L,G,P,u,v,w);o$(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];e4(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){caa(O)}if((J|0)==0){i=d;return}caa(J);i=d;return}function l4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=136400;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);s=c[34372]|0;c[k>>2]=h;h=R3(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}U0(p,f);u=p;p=c[u>>2]|0;if(!((c[34398]|0)==-1)){c[l>>2]=137592;c[l+4>>2]=233;c[l+8>>2]=0;J$(137592,l,234)}l=(c[137596>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}o$(c[u>>2]|0)|0;u=o;Oe[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];e4(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];e4(b,j,u,z,m,f,g);I=j;i=d;return}function m4(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;U0(r,h);v=r;r=c[v>>2]|0;if(!((c[34400]|0)==-1)){c[q>>2]=137600;c[q+4>>2]=233;c[q+8>>2]=0;J$(137600,q,234)}q=(c[137604>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Jc(4)|0;y=x;I9(y);z=153160;A=128;_d(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Jc(4)|0;y=x;I9(y);z=153160;A=128;_d(x|0,z|0,A|0)}A=r;o$(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((se[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(pe[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=Ee[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(Ee[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=se[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=se[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];De[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){pe[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){pe[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((pe[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((pe[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function n4(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function o4(a){a=a|0;i=i;return}function p4(a){a=a|0;i=i;return 2}function q4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];m4(a,b,l,k,f,g,h,136504,136512|0);i=j;return}function r4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=pe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];m4(b,d,m,l,g,h,j,s,q);i=k;return}function s4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34400]|0)==-1)){c[m>>2]=137600;c[m+4>>2]=233;c[m+8>>2]=0;J$(137600,m,234)}m=(c[137604>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}s=n;o$(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=P2(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function t4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34400]|0)==-1)){c[m>>2]=137600;c[m+4>>2]=233;c[m+8>>2]=0;J$(137600,m,234)}m=(c[137604>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}s=n;o$(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=P2(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function u4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;U0(m,f);f=m;m=c[f>>2]|0;if(!((c[34400]|0)==-1)){c[l>>2]=137600;c[l+4>>2]=233;c[l+8>>2]=0;J$(137600,l,234)}l=(c[137604>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Jc(4)|0;p=o;I9(p);q=153160;r=128;_d(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Jc(4)|0;p=o;I9(p);q=153160;r=128;_d(o|0,q|0,r|0)}r=m;o$(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=z4(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function v4(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;U0(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[34400]|0)==-1)){c[ba>>2]=137600;c[ba+4>>2]=233;c[ba+8>>2]=0;J$(137600,ba,234)}ba=(c[137604>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Jc(4)|0;Ga=Fa;I9(Ga);Ha=153160;Ia=128;_d(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Jc(4)|0;Ga=Fa;I9(Ga);Ha=153160;Ia=128;_d(Fa|0,Ha|0,Ia|0)}Ia=ca;o$(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=z4(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Be[ca&63](b,d,s,r,g,h,j);i=l;return};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];m4(ua,d,v,u,g,h,j,136552,136560|0);c[ca>>2]=c[ua>>2];break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=pe[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(P2(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 99:{ca=d+8|0;Ha=pe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Ja=Ha+1|0;Ka=Ha+1|0;La=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Ja=Da;Ka=Da;La=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];m4(da,d,O,N,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[da>>2];break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];m4(ja,d,J,I,g,h,j,136520,136528|0);c[ca>>2]=c[ja>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];x4(d,j+8|0,e,B,h,Ia);break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];m4(oa,d,A,z,g,h,j,136528,136539|0);c[ca>>2]=c[oa>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];m4(ga,d,L,K,g,h,j,136512,136520|0);c[ca>>2]=c[ga>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];y4(0,e,m,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=z4(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=z4(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=z4(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 104:case 66:case 98:{ca=c[f>>2]|0;Ha=d+8|0;Da=pe[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(P2(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];m4(ra,d,y,x,g,h,j,136544,136549|0);c[ca>>2]=c[ra>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];w4(0,e,C,h,Ia);break};case 88:{ca=d+8|0;Da=pe[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];m4(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[ca>>2]=c[za>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=z4(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=z4(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=z4(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=z4(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=z4(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=z4(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function w4(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((pe[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){pe[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((pe[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function x4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=pe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=P2(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function y4(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((se[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){pe[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function z4(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(pe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(se[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((pe[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((pe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((se[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((pe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function A4(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;U0(p,f);t=p;p=c[t>>2]|0;if(!((c[34398]|0)==-1)){c[o>>2]=137592;c[o+4>>2]=233;c[o+8>>2]=0;J$(137592,o,234)}o=(c[137596>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}y=p;o$(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((se[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=Ee[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(Ee[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=se[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=se[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];De[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=pe[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=pe[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(se[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){pe[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=pe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function B4(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function C4(a){a=a|0;i=i;return}function D4(a){a=a|0;i=i;return 2}function E4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];A4(a,b,l,k,f,g,h,136656,136688|0);i=j;return}function F4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=pe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];A4(b,d,m,l,g,h,j,s,q);i=k;return}function G4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34398]|0)==-1)){c[m>>2]=137592;c[m+4>>2]=233;c[m+8>>2]=0;J$(137592,m,234)}m=(c[137596>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}s=n;o$(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=m3(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function H4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34398]|0)==-1)){c[m>>2]=137592;c[m+4>>2]=233;c[m+8>>2]=0;J$(137592,m,234)}m=(c[137596>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}s=n;o$(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=pe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=m3(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function I4(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;U0(m,f);f=m;m=c[f>>2]|0;if(!((c[34398]|0)==-1)){c[l>>2]=137592;c[l+4>>2]=233;c[l+8>>2]=0;J$(137592,l,234)}l=(c[137596>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Jc(4)|0;p=o;I9(p);q=153160;r=128;_d(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Jc(4)|0;p=o;I9(p);q=153160;r=128;_d(o|0,q|0,r|0)}r=m;o$(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=N4(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function J4(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;U0(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[34398]|0)==-1)){c[ba>>2]=137592;c[ba+4>>2]=233;c[ba+8>>2]=0;J$(137592,ba,234)}ba=(c[137596>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Jc(4)|0;Ga=Fa;I9(Ga);Ha=153160;Ia=128;_d(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Jc(4)|0;Ga=Fa;I9(Ga);Ha=153160;Ia=128;_d(Fa|0,Ha|0,Ia|0)}Ia=ca;o$(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=N4(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];A4(ja,d,J,I,g,h,j,136720,136752|0);c[ca>>2]=c[ja>>2];break};case 84:{ca=e;c[va>>2]=c[ca>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];A4(ua,d,v,u,g,h,j,136824,136856|0);c[ca>>2]=c[ua>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];A4(oa,d,A,z,g,h,j,136752,136796|0);c[ca>>2]=c[oa>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];A4(ga,d,L,K,g,h,j,136688,136720|0);c[ca>>2]=c[ga>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];M4(0,e,m,h,Ia);break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=N4(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=N4(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=pe[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ja=Da+4|0;Ka=Da+4|0;La=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ja=Ha;Ka=Ha;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];A4(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[ca>>2]=c[da>>2];break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];A4(ra,d,y,x,g,h,j,136800,136820|0);c[ca>>2]=c[ra>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];K4(0,e,C,h,Ia);break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=pe[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(m3(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=pe[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(m3(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 88:{ca=d+8|0;Da=pe[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ma=Da+4|0;Na=Da+4|0;Oa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];A4(za,d,q,p,g,h,j,Na,Ma+(Oa<<2)|0);c[ca>>2]=c[za>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=N4(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Ha|4;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=N4(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Be[ca&63](b,d,s,r,g,h,j);i=l;return};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=N4(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Pa=ca+2e3|0}else{Pa=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Pa+ -1900;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=N4(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=N4(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];L4(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=N4(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=N4(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function K4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(se[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){pe[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=pe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=pe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function L4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=pe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=m3(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function M4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=pe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=pe[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((se[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){pe[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=pe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=pe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function N4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=pe[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=pe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=pe[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(se[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(se[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){pe[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=pe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=pe[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(se[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((se[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){pe[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function O4(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);if((f|0)==(c[34372]|0)){g=b;jaa(g);i=d;return}bc(c[e>>2]|0);g=b;jaa(g);i=d;return}function P4(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);if((b|0)==(c[34372]|0)){i=d;return}bc(c[e>>2]|0);i=d;return}function Q4(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Xc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(Ee[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function R4(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);if((f|0)==(c[34372]|0)){g=b;jaa(g);i=d;return}bc(c[e>>2]|0);g=b;jaa(g);i=d;return}function S4(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);if((b|0)==(c[34372]|0)){i=d;return}bc(c[e>>2]|0);i=d;return}function T4(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;U4(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=Ee[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function U4(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Xc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Qc(c[g>>2]|0)|0;g=e9(d,m,n,l)|0;if((f|0)!=0){Qc(f|0)|0}if((g|0)==-1){Q5(138480)}else{c[e>>2]=d+(g<<2);i=j;return}}function V4(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function W4(a){a=a|0;i=i;return}function X4(a){a=a|0;i=i;return 127}function Y4(a){a=a|0;i=i;return 127}function Z4(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _4(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $4(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function a5(a,b){a=a|0;b=b|0;b=i;U$(a,1,45);i=b;return}function b5(a){a=a|0;i=i;return 0}function c5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function d5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function e5(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function f5(a){a=a|0;i=i;return}function g5(a){a=a|0;i=i;return 127}function h5(a){a=a|0;i=i;return 127}function i5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function j5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function k5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function l5(a,b){a=a|0;b=b|0;b=i;U$(a,1,45);i=b;return}function m5(a){a=a|0;i=i;return 0}function n5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function o5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function p5(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function q5(a){a=a|0;i=i;return}function r5(a){a=a|0;i=i;return 2147483647}function s5(a){a=a|0;i=i;return 2147483647}function t5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function u5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function v5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function w5(a,b){a=a|0;b=b|0;b=i;z0(a,1,45);i=b;return}function x5(a){a=a|0;i=i;return 0}function y5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function z5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function A5(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function B5(a){a=a|0;i=i;return}function C5(a){a=a|0;i=i;return 2147483647}function D5(a){a=a|0;i=i;return 2147483647}function E5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function F5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function G5(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function H5(a,b){a=a|0;b=b|0;b=i;z0(a,1,45);i=b;return}function I5(a){a=a|0;i=i;return 0}function J5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function K5(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function L5(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function M5(a){a=a|0;i=i;return}function N5(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=235;y=o+100|0;U0(r,h);o=r;z=c[o>>2]|0;if(!((c[34400]|0)==-1)){c[n>>2]=137600;c[n+4>>2]=233;c[n+8>>2]=0;J$(137600,n,234)}n=(c[137604>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=P5(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Oe[c[(c[z>>2]|0)+32>>2]&63](E,137216,137226|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=baa(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}oaa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[137216+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Cd(p|0,137232,m|0)|0)!=1){t=Jc(8)|0;u$(t,137240);_d(t|0,134592,43)}if((F|0)==0){break}caa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;o$(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}me[c[x>>2]&255](o);i=d;return}function O5(a){a=a|0;i=i;return}function P5(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;T5(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=235;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 0:{X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){ba=(a[O]|0)!=0}else{ba=0}if(!(I|ba)){ca=D;da=R;ea=r;fa=Q;ga=0;ha=T;break b}}W=a[x]|0;ia=(W&1)==0;ja=ia?j:c[J>>2]|0;c:do{if((p|0)==0){ka=Y;la=Y;ma=W;na=ja}else{if((d[s+(p+ -1)|0]|0)>=2){ka=Y;la=Y;ma=W;na=ja;break}oa=ja+(ia?(W&255)>>>1:c[K>>2]|0)|0;pa=ja;while(1){if((pa|0)==(oa|0)){qa=oa;break}ra=a[pa]|0;if(!(ra<<24>>24>-1)){qa=pa;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){qa=pa;break}else{pa=pa+1|0}}pa=qa-ja|0;oa=a[A]|0;ra=(oa&1)==0;if(ra){sa=(oa&255)>>>1}else{sa=c[N>>2]|0}if(pa>>>0>sa>>>0){ka=Y;la=Y;ma=W;na=ja;break}if(ra){ra=(oa&255)>>>1;ta=A+1+(ra-pa)|0;ua=L;va=ra}else{ra=c[M>>2]|0;oa=c[N>>2]|0;ta=ra+(oa-pa)|0;ua=ra;va=oa}oa=ua+va|0;if((ta|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=ja;xa=ta}while(1){if((a[xa]|0)!=(a[wa]|0)){ka=Y;la=Y;ma=W;na=ja;break c}ra=xa+1|0;if((ra|0)==(oa|0)){ka=Y;la=Y;ma=W;na=qa;break}else{wa=wa+1|0;xa=ra}}}}while(0);d:while(1){if((ma&1)==0){ya=j;za=(ma&255)>>>1}else{ya=c[J>>2]|0;za=c[K>>2]|0}if((na|0)==(ya+za|0)){break}W=c[h>>2]|0;do{if((W|0)==0){Aa=0}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){Aa=W;break}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[h>>2]=0;Aa=0;break}else{Aa=c[h>>2]|0;break}}}while(0);W=(Aa|0)==0;do{if((la|0)==0){Ba=ka;X=147}else{if((c[la+12>>2]|0)!=(c[la+16>>2]|0)){if(W){Ca=ka;Da=la;break}else{break d}}if((pe[c[(c[la>>2]|0)+36>>2]&127](la)|0)==-1){c[e>>2]=0;Ba=0;X=147;break}else{if(W^(ka|0)==0){Ca=ka;Da=ka;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(W){break}else{Ca=Ba;Da=0}}ja=c[h>>2]|0;ia=c[ja+12>>2]|0;if((ia|0)==(c[ja+16>>2]|0)){Ea=(pe[c[(c[ja>>2]|0)+36>>2]&127](ja)|0)&255}else{Ea=a[ia]|0}if(!(Ea<<24>>24==(a[na]|0))){break}ia=c[h>>2]|0;ja=ia+12|0;oa=c[ja>>2]|0;if((oa|0)==(c[ia+16>>2]|0)){pe[c[(c[ia>>2]|0)+40>>2]&127](ia)|0}else{c[ja>>2]=oa+1}ka=Ca;la=Da;ma=a[x]|0;na=na+1|0}if(!I){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}oa=a[x]|0;if((oa&1)==0){Fa=j;Ga=(oa&255)>>>1}else{Fa=c[J>>2]|0;Ga=c[K>>2]|0}if((na|0)==(Fa+Ga|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}else{X=162;break a}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}oa=c[h>>2]|0;ja=c[oa+12>>2]|0;if((ja|0)==(c[oa+16>>2]|0)){Ha=(pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255}else{Ha=a[ja]|0}if(!(Ha<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Ha<<24>>24<<1)>>1]&8192)==0){X=25;break a}ja=c[h>>2]|0;oa=ja+12|0;ia=c[oa>>2]|0;if((ia|0)==(c[ja+16>>2]|0)){Ia=(pe[c[(c[ja>>2]|0)+40>>2]&127](ja)|0)&255}else{c[oa>>2]=ia+1;Ia=a[ia]|0}o0(A,Ia);X=26;break};case 3:{ia=a[y]|0;oa=(ia&1)==0;if(oa){Ja=(ia&255)>>>1}else{Ja=c[G>>2]|0}ja=a[z]|0;ra=(ja&1)==0;if(ra){Ka=(ja&255)>>>1}else{Ka=c[g>>2]|0}if((Ja|0)==(0-Ka|0)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}if(oa){La=(ia&255)>>>1}else{La=c[G>>2]|0}do{if((La|0)!=0){if(ra){Ma=(ja&255)>>>1}else{Ma=c[g>>2]|0}if((Ma|0)==0){break}pa=c[h>>2]|0;Na=c[pa+12>>2]|0;Oa=c[pa+16>>2]|0;if((Na|0)==(Oa|0)){Pa=(pe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0)&255;Qa=c[h>>2]|0;Ra=Pa;Sa=c[Qa+16>>2]|0;Ta=c[Qa+12>>2]|0;Ua=Qa;Va=a[y]|0}else{Ra=a[Na]|0;Sa=Oa;Ta=Na;Ua=pa;Va=ia}pa=Ua+12|0;Na=(Ta|0)==(Sa|0);if(Ra<<24>>24==(a[(Va&1)==0?F:c[H>>2]|0]|0)){if(Na){pe[c[(c[Ua>>2]|0)+40>>2]&127](Ua)|0}else{c[pa>>2]=Ta+1}pa=a[y]|0;if((pa&1)==0){Wa=(pa&255)>>>1}else{Wa=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Wa>>>0>1?y:S;ha=T;break b}if(Na){Xa=(pe[c[(c[Ua>>2]|0)+36>>2]&127](Ua)|0)&255}else{Xa=a[Ta]|0}if(!(Xa<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}Na=c[h>>2]|0;pa=Na+12|0;Oa=c[pa>>2]|0;if((Oa|0)==(c[Na+16>>2]|0)){pe[c[(c[Na>>2]|0)+40>>2]&127](Na)|0}else{c[pa>>2]=Oa+1}a[l]=1;Oa=a[z]|0;if((Oa&1)==0){Ya=(Oa&255)>>>1}else{Ya=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=Ya>>>0>1?z:S;ha=T;break b}}while(0);if(oa){Za=(ia&255)>>>1}else{Za=c[G>>2]|0}ra=c[h>>2]|0;Oa=c[ra+12>>2]|0;pa=(Oa|0)==(c[ra+16>>2]|0);if((Za|0)==0){if(pa){Na=(pe[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;_a=Na;$a=a[z]|0}else{_a=a[Oa]|0;$a=ja}if(!(_a<<24>>24==(a[($a&1)==0?m:c[E>>2]|0]|0))){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}Na=c[h>>2]|0;Qa=Na+12|0;Pa=c[Qa>>2]|0;if((Pa|0)==(c[Na+16>>2]|0)){pe[c[(c[Na>>2]|0)+40>>2]&127](Na)|0}else{c[Qa>>2]=Pa+1}a[l]=1;Pa=a[z]|0;if((Pa&1)==0){ab=(Pa&255)>>>1}else{ab=c[g>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=ab>>>0>1?z:S;ha=T;break b}if(pa){pa=(pe[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;bb=pa;cb=a[y]|0}else{bb=a[Oa]|0;cb=ia}if(!(bb<<24>>24==(a[(cb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break b}Oa=c[h>>2]|0;pa=Oa+12|0;ra=c[pa>>2]|0;if((ra|0)==(c[Oa+16>>2]|0)){pe[c[(c[Oa>>2]|0)+40>>2]&127](Oa)|0}else{c[pa>>2]=ra+1}ra=a[y]|0;if((ra&1)==0){db=(ra&255)>>>1}else{db=c[G>>2]|0}ca=D;da=R;ea=r;fa=Q;ga=db>>>0>1?y:S;ha=T;break};case 4:{ra=D;pa=R;Oa=r;Pa=Q;Qa=0;Na=T;e:while(1){eb=c[h>>2]|0;do{if((eb|0)==0){fb=0}else{if((c[eb+12>>2]|0)!=(c[eb+16>>2]|0)){fb=eb;break}if((pe[c[(c[eb>>2]|0)+36>>2]&127](eb)|0)==-1){c[h>>2]=0;fb=0;break}else{fb=c[h>>2]|0;break}}}while(0);eb=(fb|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=173}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(eb){break}else{break e}}if((pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=173;break}else{if(eb){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(eb){break}}W=c[h>>2]|0;gb=c[W+12>>2]|0;if((gb|0)==(c[W+16>>2]|0)){hb=(pe[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{hb=a[gb]|0}do{if(hb<<24>>24>-1){if((b[(c[f>>2]|0)+(hb<<24>>24<<1)>>1]&2048)==0){X=189;break}gb=c[o>>2]|0;if((gb|0)==(ra|0)){W=(c[P>>2]|0)!=235;ib=c[t>>2]|0;jb=ra-ib|0;kb=jb>>>0<2147483647?jb<<1:-1;lb=eaa(W?ib:0,kb)|0;if((lb|0)==0){X=182;break a}do{if(W){c[t>>2]=lb;mb=lb}else{ib=c[t>>2]|0;c[t>>2]=lb;if((ib|0)==0){mb=lb;break}me[c[P>>2]&255](ib);mb=c[t>>2]|0}}while(0);c[P>>2]=210;lb=mb+jb|0;c[o>>2]=lb;nb=lb;ob=(c[t>>2]|0)+kb|0}else{nb=gb;ob=ra}c[o>>2]=nb+1;a[nb]=hb;pb=ob;qb=pa;rb=Oa;sb=Pa;tb=Qa+1|0;ub=Na}else{X=189}}while(0);if((X|0)==189){X=0;eb=a[w]|0;if((eb&1)==0){vb=(eb&255)>>>1}else{vb=c[n>>2]|0}if((vb|0)==0|(Qa|0)==0){break}if(!(hb<<24>>24==(a[v]|0))){break}if((Oa|0)==(Pa|0)){eb=Oa-pa|0;lb=eb>>>0<2147483647?eb<<1:-1;if((Na|0)==235){wb=0}else{wb=pa}W=eaa(wb,lb)|0;if((W|0)==0){X=198;break a}xb=W;yb=W+(eb>>2<<2)|0;zb=W+(lb>>>2<<2)|0;Ab=210}else{xb=pa;yb=Oa;zb=Pa;Ab=Na}c[yb>>2]=Qa;pb=ra;qb=xb;rb=yb+4|0;sb=zb;tb=0;ub=Ab}lb=c[h>>2]|0;W=lb+12|0;eb=c[W>>2]|0;if((eb|0)==(c[lb+16>>2]|0)){pe[c[(c[lb>>2]|0)+40>>2]&127](lb)|0;ra=pb;pa=qb;Oa=rb;Pa=sb;Qa=tb;Na=ub;continue}else{c[W>>2]=eb+1;ra=pb;pa=qb;Oa=rb;Pa=sb;Qa=tb;Na=ub;continue}}if((pa|0)==(Oa|0)|(Qa|0)==0){Bb=pa;Cb=Oa;Db=Pa;Eb=Na}else{if((Oa|0)==(Pa|0)){ia=Oa-pa|0;ja=ia>>>0<2147483647?ia<<1:-1;if((Na|0)==235){Fb=0}else{Fb=pa}oa=eaa(Fb,ja)|0;if((oa|0)==0){X=209;break a}Gb=oa;Hb=oa+(ia>>2<<2)|0;Ib=oa+(ja>>>2<<2)|0;Jb=210}else{Gb=pa;Hb=Oa;Ib=Pa;Jb=Na}c[Hb>>2]=Qa;Bb=Gb;Cb=Hb+4|0;Db=Ib;Eb=Jb}if((c[B>>2]|0)>0){ja=c[h>>2]|0;do{if((ja|0)==0){Kb=0}else{if((c[ja+12>>2]|0)!=(c[ja+16>>2]|0)){Kb=ja;break}if((pe[c[(c[ja>>2]|0)+36>>2]&127](ja)|0)==-1){c[h>>2]=0;Kb=0;break}else{Kb=c[h>>2]|0;break}}}while(0);ja=(Kb|0)==0;Qa=c[e>>2]|0;do{if((Qa|0)==0){X=223}else{if((c[Qa+12>>2]|0)!=(c[Qa+16>>2]|0)){if(ja){Lb=Qa;break}else{X=229;break a}}if((pe[c[(c[Qa>>2]|0)+36>>2]&127](Qa)|0)==-1){c[e>>2]=0;X=223;break}else{if(ja){Lb=Qa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ja){X=229;break a}else{Lb=0}}Qa=c[h>>2]|0;Na=c[Qa+12>>2]|0;if((Na|0)==(c[Qa+16>>2]|0)){Mb=(pe[c[(c[Qa>>2]|0)+36>>2]&127](Qa)|0)&255}else{Mb=a[Na]|0}if(!(Mb<<24>>24==(a[u]|0))){X=229;break a}Na=c[h>>2]|0;Qa=Na+12|0;Pa=c[Qa>>2]|0;if((Pa|0)==(c[Na+16>>2]|0)){pe[c[(c[Na>>2]|0)+40>>2]&127](Na)|0;Nb=Lb;Ob=Lb;Pb=ra}else{c[Qa>>2]=Pa+1;Nb=Lb;Ob=Lb;Pb=ra}while(1){Pa=c[h>>2]|0;do{if((Pa|0)==0){Qb=0}else{if((c[Pa+12>>2]|0)!=(c[Pa+16>>2]|0)){Qb=Pa;break}if((pe[c[(c[Pa>>2]|0)+36>>2]&127](Pa)|0)==-1){c[h>>2]=0;Qb=0;break}else{Qb=c[h>>2]|0;break}}}while(0);Pa=(Qb|0)==0;do{if((Ob|0)==0){Rb=Nb;X=243}else{if((c[Ob+12>>2]|0)!=(c[Ob+16>>2]|0)){if(Pa){Sb=Nb;Tb=Ob;break}else{X=250;break a}}if((pe[c[(c[Ob>>2]|0)+36>>2]&127](Ob)|0)==-1){c[e>>2]=0;Rb=0;X=243;break}else{if(Pa^(Nb|0)==0){Sb=Nb;Tb=Nb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(Pa){X=250;break a}else{Sb=Rb;Tb=0}}Qa=c[h>>2]|0;Na=c[Qa+12>>2]|0;if((Na|0)==(c[Qa+16>>2]|0)){Ub=(pe[c[(c[Qa>>2]|0)+36>>2]&127](Qa)|0)&255}else{Ub=a[Na]|0}if(!(Ub<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Ub<<24>>24<<1)>>1]&2048)==0){X=250;break a}Na=c[o>>2]|0;if((Na|0)==(Pb|0)){Qa=(c[P>>2]|0)!=235;Oa=c[t>>2]|0;pa=Pb-Oa|0;oa=pa>>>0<2147483647?pa<<1:-1;ia=eaa(Qa?Oa:0,oa)|0;if((ia|0)==0){X=253;break a}do{if(Qa){c[t>>2]=ia;Vb=ia}else{Oa=c[t>>2]|0;c[t>>2]=ia;if((Oa|0)==0){Vb=ia;break}me[c[P>>2]&255](Oa);Vb=c[t>>2]|0}}while(0);c[P>>2]=210;ia=Vb+pa|0;c[o>>2]=ia;Wb=ia;Xb=(c[t>>2]|0)+oa|0}else{Wb=Na;Xb=Pb}ia=c[h>>2]|0;Qa=c[ia+12>>2]|0;if((Qa|0)==(c[ia+16>>2]|0)){Pa=(pe[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255;Yb=Pa;Zb=c[o>>2]|0}else{Yb=a[Qa]|0;Zb=Wb}c[o>>2]=Zb+1;a[Zb]=Yb;Qa=(c[B>>2]|0)+ -1|0;c[B>>2]=Qa;Pa=c[h>>2]|0;ia=Pa+12|0;Oa=c[ia>>2]|0;if((Oa|0)==(c[Pa+16>>2]|0)){pe[c[(c[Pa>>2]|0)+40>>2]&127](Pa)|0}else{c[ia>>2]=Oa+1}if((Qa|0)>0){Nb=Sb;Ob=Tb;Pb=Xb}else{_b=Xb;break}}}else{_b=ra}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ca=_b;da=Bb;ea=Cb;fa=Db;ga=S;ha=Eb}break};default:{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}if((pe[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}else{dc=cc;ec=0}}Na=c[h>>2]|0;oa=c[Na+12>>2]|0;if((oa|0)==(c[Na+16>>2]|0)){fc=(pe[c[(c[Na>>2]|0)+36>>2]&127](Na)|0)&255}else{fc=a[oa]|0}if(!(fc<<24>>24>-1)){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ca=D;da=R;ea=r;fa=Q;ga=S;ha=T;break f}oa=c[h>>2]|0;Na=oa+12|0;pa=c[Na>>2]|0;if((pa|0)==(c[oa+16>>2]|0)){gc=(pe[c[(c[oa>>2]|0)+40>>2]&127](oa)|0)&255}else{c[Na>>2]=pa+1;gc=a[pa]|0}o0(A,gc);$b=dc;ac=ec}}}while(0);ra=p+1|0;if(ra>>>0<4){Q=fa;r=ea;R=da;D=ca;p=ra;S=ga;T=ha}else{Z=da;_=ea;$=ga;aa=ha;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){oaa()}else if((X|0)==198){oaa()}else if((X|0)==209){oaa()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==253){oaa()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=Bb;jc=Eb}else if((X|0)==269){h:do{if(($|0)!=0){ha=$+1|0;ga=$+8|0;ea=$+4|0;da=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ea>>2]|0}if(!(da>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((pe[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(pe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=ha}else{nc=c[ga>>2]|0}if(!(mc<<24>>24==(a[nc+da|0]|0))){break}p=da+1|0;U=c[h>>2]|0;ca=U+12|0;D=c[ca>>2]|0;if((D|0)==(c[U+16>>2]|0)){pe[c[(c[U>>2]|0)+40>>2]&127](U)|0;da=p;continue}else{c[ca>>2]=D+1;da=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;U5(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);Y$(A);Y$(z);Y$(y);Y$(x);Y$(w);if((ic|0)==0){i=q;return hc|0}me[jc&255](ic);i=q;return hc|0}function Q5(a){a=a|0;var b=0;b=Jc(8)|0;u$(b,a);_d(b|0,134592,43)}function R5(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=235;v=n+100|0;U0(q,h);n=q;w=c[n>>2]|0;if(!((c[34400]|0)==-1)){c[m>>2]=137600;c[m+4>>2]=233;c[m+8>>2]=0;J$(137600,m,234)}m=(c[137604>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Jc(4)|0;z=y;I9(z);A=153160;B=128;_d(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Jc(4)|0;z=y;I9(z);A=153160;B=128;_d(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=P5(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){o0(k,Ee[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=Ee[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);S5(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((pe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((pe[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;o$(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}me[c[u>>2]&255](n);i=d;return}function S5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){r0(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}



function x1(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function y1(a,b){a=a|0;b=b|0;i=i;return-1}function z1(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);jaa(a);i=b;return}function A1(a){a=a|0;var b=0;b=i;c[a>>2]=134936;G6(a+4|0);i=b;return}function B1(a,b){a=a|0;b=b|0;i=i;return}function C1(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function D1(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function E1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function F1(a){a=a|0;i=i;return 0}function G1(a){a=a|0;i=i;return 0}function H1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=pe[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function I1(a){a=a|0;i=i;return-1}function J1(a){a=a|0;var b=0,d=0,e=0;b=i;if((pe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function K1(a,b){a=a|0;b=b|0;i=i;return-1}function L1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((Ee[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function M1(a,b){a=a|0;b=b|0;i=i;return-1}function N1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));E6(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function O1(a){a=a|0;var b=0;b=i;N0(a+8|0);jaa(a);i=b;return}function P1(a){a=a|0;var b=0;b=i;N0(a+8|0);i=b;return}function Q1(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;N0(a+(d+8)|0);jaa(a+d|0);i=b;return}function R1(a){a=a|0;var b=0;b=i;N0(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function S1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;T1(a,b,c);i=d;return}function T1(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){L0(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){U1(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}F6(h,e+(k+28)|0);k=I6(h,137600)|0;G6(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){pe[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((pe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;L0(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function U1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{U1(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((pe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;L0(b+h|0,c[b+(h+16)>>2]|1)}}while(0);h2(e);i=d;return b|0}function V1(b){b=b|0;i=i;return(a[b]|0)!=0|0}function W1(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function X1(a){a=a|0;var b=0;b=i;N0(a+8|0);jaa(a);i=b;return}function Y1(a){a=a|0;var b=0;b=i;N0(a+8|0);i=b;return}function Z1(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;N0(a+(d+8)|0);jaa(a+d|0);i=b;return}function _1(a){a=a|0;var b=0;b=i;N0(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function $1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{$1(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((pe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;L0(b+h|0,c[b+(h+16)>>2]|1)}}while(0);t2(e);i=d;return b|0}function a2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));E6(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function b2(a){a=a|0;var b=0;b=i;N0(a+4|0);jaa(a);i=b;return}function c2(a){a=a|0;var b=0;b=i;N0(a+4|0);i=b;return}function d2(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;N0(a+(d+4)|0);jaa(a+d|0);i=b;return}function e2(a){a=a|0;var b=0;b=i;N0(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function f2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){U1(g)|0}a[f]=1;i=e;return}function g2(a){a=a|0;var b=0;b=i;h2(a);i=b;return}function h2(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((pe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;L0(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function i2(b){b=b|0;i=i;return(a[b]|0)!=0|0}function j2(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=pe[b&127](a)|0;i=c;return d|0}function k2(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){h2(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{U1(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;F6(k,b+(p+28)|0);p=I6(k,136320)|0;m=p;G6(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){F6(h,b+(k+28)|0);r=I6(h,137600)|0;s=Ee[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;G6(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ve[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){h2(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;L0(b+l|0,c[b+(l+16)>>2]|5);h2(j);i=e;return b|0}function l2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){h2(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{U1(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;h2(f);i=e;return b|0}if((Ee[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{h2(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;L0(b+d|0,c[b+(d+16)>>2]|1);h2(f);i=e;return b|0}function m2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){h2(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){U1(k)|0}a[h]=1;if((e|0)==0){h2(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((se[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){h2(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;L0(b+e|0,c[b+(e+16)>>2]|1);h2(g);i=f;return b|0}function n2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;ye[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function o2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){h2(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{U1(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Pe[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){h2(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;L0(b+f|0,c[b+(f+16)>>2]|4);h2(h);i=e;return b|0}function p2(a){a=a|0;var b=0;b=i;N0(a+4|0);jaa(a);i=b;return}function q2(a){a=a|0;var b=0;b=i;N0(a+4|0);i=b;return}function r2(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;N0(a+(d+4)|0);jaa(a+d|0);i=b;return}function s2(a){a=a|0;var b=0;b=i;N0(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function t2(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((pe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;L0(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function u2(a){a=a|0;i=i;return 135152}function v2(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){Q$(a,135168,35);i=d;return}else{E$(a,b,c);i=d;return}}function w2(a){a=a|0;i=i;return}function x2(a){a=a|0;var b=0;b=i;I$(a);jaa(a);i=b;return}function y2(a){a=a|0;var b=0;b=i;I$(a);i=b;return}function z2(a){a=a|0;var b=0;b=i;N0(a);jaa(a);i=b;return}function A2(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function B2(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function C2(a){a=a|0;i=i;return}function D2(a){a=a|0;i=i;return}function E2(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function F2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){K$(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=haa(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function G2(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function H2(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function I2(a){a=a|0;i=i;return}function J2(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function K2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){K$(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=haa(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function L2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function M2(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function N2(a){a=a|0;i=i;return}function O2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Be[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}U0(u,g);m=u;u=c[m>>2]|0;if(!((c[34400]|0)==-1)){c[p>>2]=137600;c[p+4>>2]=233;c[p+8>>2]=0;J$(137600,p,234)}p=(c[137604>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}F=u;o$(c[m>>2]|0)|0;U0(v,g);g=v;v=c[g>>2]|0;if(!((c[34436]|0)==-1)){c[o>>2]=137744;c[o+4>>2]=233;c[o+8>>2]=0;J$(137744,o,234)}o=(c[137748>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}J=v;o$(c[g>>2]|0)|0;g=w;ne[c[(c[v>>2]|0)+24>>2]&127](g,J);ne[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=P2(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Y$(w+12|0);Y$(w);i=k;return}function P2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=baa(l)|0;if((n|0)!=0){o=n;p=n;break}oaa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((pe[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((pe[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=Ee[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(Ee[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){pe[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((pe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}caa(o);i=k;return _|0}function Q2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];R2(a,0,k,j,f,g,h);i=b;return}function R2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;H3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}f0(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}f0(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((h3(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=D8(F,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}function S2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];T2(a,0,k,j,f,g,h);i=b;return}function T2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;H3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}f0(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}f0(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((h3(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=C8(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}function U2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];V2(a,0,k,j,f,g,h);i=b;return}function V2(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;H3(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((pe[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}f0(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}f0(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((h3(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){pe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=B8(G,c[p>>2]|0,j,u)|0;U5(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Y$(o);Y$(n);i=e;return}if((pe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Y$(o);Y$(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Y$(o);Y$(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Y$(o);Y$(n);i=e;return}function W2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];X2(a,0,k,j,f,g,h);i=b;return}function X2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;H3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}f0(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}f0(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((h3(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=A8(F,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}function Y2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Z2(a,0,k,j,f,g,h);i=b;return}function Z2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;H3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}f0(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}f0(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((h3(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=z8(F,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Y$(n);Y$(m);i=d;return}function _2(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$2(a,0,k,j,f,g,h);i=b;return}function $2(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;H3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((pe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((pe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}f0(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}f0(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((h3(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=y8(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((pe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Y$(n);Y$(m);i=d;return}function a3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];b3(a,0,k,j,f,g,h);i=b;return}function b3(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;I3(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}f0(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}f0(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((J3(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+x8(I,c[p>>2]|0,j);U5(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}function c3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];d3(a,0,k,j,f,g,h);i=b;return}function d3(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;I3(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}f0(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}f0(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((J3(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+w8(I,c[p>>2]|0,j);U5(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}function e3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];f3(a,0,k,j,f,g,h);i=b;return}function f3(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;I3(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((pe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}f0(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}f0(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((J3(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+v8(I,c[p>>2]|0,j);U5(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((pe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}if((pe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Y$(o);Y$(n);i=d;return}function g3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;U0(o,g);g=o;o=c[g>>2]|0;if(!((c[34400]|0)==-1)){c[l>>2]=137600;c[l+4>>2]=233;c[l+8>>2]=0;J$(137600,l,234)}l=(c[137604>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}y=m;Oe[c[(c[o>>2]|0)+32>>2]&63](o,136144,136170|0,y)|0;o$(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((pe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((pe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}f0(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}f0(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(pe[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((h3(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){pe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);K=c[34372]|0;c[k>>2]=j;if((i3(E,K,136184,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Y$(p);Y$(n);i=d;return}if((pe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Y$(p);Y$(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Y$(p);Y$(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Y$(p);Y$(n);i=d;return}function h3(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[136144+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[136144+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function i3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Qc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Qc(e|0)|0;i=f;return b|0}function j3(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function k3(a){a=a|0;i=i;return}function l3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Be[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}U0(u,g);m=u;u=c[m>>2]|0;if(!((c[34398]|0)==-1)){c[p>>2]=137592;c[p+4>>2]=233;c[p+8>>2]=0;J$(137592,p,234)}p=(c[137596>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}F=u;o$(c[m>>2]|0)|0;U0(v,g);g=v;v=c[g>>2]|0;if(!((c[34438]|0)==-1)){c[o>>2]=137752;c[o+4>>2]=233;c[o+8>>2]=0;J$(137752,o,234)}o=(c[137756>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}J=v;o$(c[g>>2]|0)|0;g=w;ne[c[(c[v>>2]|0)+24>>2]&127](g,J);ne[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=m3(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];A0(w+12|0);A0(w);i=k;return}function m3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=baa(l)|0;if((n|0)!=0){o=n;p=n;break}oaa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=Ee[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(Ee[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){pe[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}caa(o);i=k;return ba|0}function n3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];o3(a,0,k,j,f,g,h);i=b;return}function o3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;K3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}f0(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}f0(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((G3(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=D8(I,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}function p3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];q3(a,0,k,j,f,g,h);i=b;return}function q3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;K3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}f0(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}f0(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((G3(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=C8(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}function r3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];s3(a,0,k,j,f,g,h);i=b;return}function s3(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;K3(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=pe[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}f0(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}f0(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((G3(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){pe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=B8(J,c[p>>2]|0,j,u)|0;U5(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=pe[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Y$(o);Y$(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Y$(o);Y$(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Y$(o);Y$(n);i=e;return}function t3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];u3(a,0,k,j,f,g,h);i=b;return}function u3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;K3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}f0(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}f0(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((G3(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=A8(I,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}function v3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];w3(a,0,k,j,f,g,h);i=b;return}function w3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;K3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}f0(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}f0(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((G3(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=z8(I,c[o>>2]|0,h,t)|0;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Y$(n);Y$(m);i=d;return}function x3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];y3(a,0,k,j,f,g,h);i=b;return}function y3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;K3(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=pe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=pe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}f0(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}f0(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((G3(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){pe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=y8(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;U5(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=pe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=pe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Y$(n);Y$(m);i=d;return}function z3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];A3(a,0,k,j,f,g,h);i=b;return}function A3(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;L3(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}f0(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}f0(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((M3(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+x8(L,c[p>>2]|0,j);U5(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}function B3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];C3(a,0,k,j,f,g,h);i=b;return}function C3(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;L3(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}f0(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}f0(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((M3(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+w8(L,c[p>>2]|0,j);U5(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}function D3(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];E3(a,0,k,j,f,g,h);i=b;return}function E3(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;L3(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=pe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}f0(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}f0(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((M3(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){pe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+v8(L,c[p>>2]|0,j);U5(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=pe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=pe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Y$(o);Y$(n);i=d;return}function F3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;U0(o,g);g=o;o=c[g>>2]|0;if(!((c[34398]|0)==-1)){c[l>>2]=137592;c[l+4>>2]=233;c[l+8>>2]=0;J$(137592,l,234)}l=(c[137596>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Jc(4)|0;w=v;I9(w);x=153160;y=128;_d(v|0,x|0,y|0)}y=m;Oe[c[(c[o>>2]|0)+48>>2]&63](o,136144,136170|0,y)|0;o$(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f0(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=pe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=pe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}f0(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}f0(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=pe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((G3(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){pe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);N=c[34372]|0;c[k>>2]=j;if((i3(H,N,136184,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=pe[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=pe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Y$(p);Y$(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Y$(p);Y$(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Y$(p);Y$(n);i=d;return}function G3(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[136144+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[136144+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function H3(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;U0(k,d);d=k;k=c[d>>2]|0;if(!((c[34400]|0)==-1)){c[j>>2]=137600;c[j+4>>2]=233;c[j+8>>2]=0;J$(137600,j,234)}j=(c[137604>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Jc(4)|0;n=m;I9(n);o=153160;p=128;_d(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Jc(4)|0;n=m;I9(n);o=153160;p=128;_d(m|0,o|0,p|0)}Oe[c[(c[k>>2]|0)+32>>2]&63](k,136144,136170|0,e)|0;e=c[d>>2]|0;if(!((c[34436]|0)==-1)){c[h>>2]=137744;c[h+4>>2]=233;c[h+8>>2]=0;J$(137744,h,234)}h=(c[137748>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}else{t=e;a[f]=pe[c[(c[e>>2]|0)+16>>2]&127](t)|0;ne[c[(c[e>>2]|0)+20>>2]&127](b,t);o$(c[d>>2]|0)|0;i=g;return}}function I3(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;U0(l,d);d=l;l=c[d>>2]|0;if(!((c[34400]|0)==-1)){c[k>>2]=137600;c[k+4>>2]=233;c[k+8>>2]=0;J$(137600,k,234)}k=(c[137604>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Jc(4)|0;o=n;I9(o);p=153160;q=128;_d(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Jc(4)|0;o=n;I9(o);p=153160;q=128;_d(n|0,p|0,q|0)}Oe[c[(c[l>>2]|0)+32>>2]&63](l,136144,136176|0,e)|0;e=c[d>>2]|0;if(!((c[34436]|0)==-1)){c[j>>2]=137744;c[j+4>>2]=233;c[j+8>>2]=0;J$(137744,j,234)}j=(c[137748>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Jc(4)|0;s=r;I9(s);t=153160;u=128;_d(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Jc(4)|0;s=r;I9(s);t=153160;u=128;_d(r|0,t|0,u|0)}else{u=e;a[f]=pe[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=pe[c[(c[e>>2]|0)+16>>2]&127](u)|0;ne[c[(c[e>>2]|0)+20>>2]&127](b,u);o$(c[d>>2]|0)|0;i=h;return}}function J3(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[136144+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function K3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;U0(j,b);b=j;j=c[b>>2]|0;if(!((c[34398]|0)==-1)){c[h>>2]=137592;c[h+4>>2]=233;c[h+8>>2]=0;J$(137592,h,234)}h=(c[137596>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Jc(4)|0;m=l;I9(m);n=153160;o=128;_d(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Jc(4)|0;m=l;I9(m);n=153160;o=128;_d(l|0,n|0,o|0)}Oe[c[(c[j>>2]|0)+48>>2]&63](j,136144,136170|0,d)|0;d=c[b>>2]|0;if(!((c[34438]|0)==-1)){c[g>>2]=137752;c[g+4>>2]=233;c[g+8>>2]=0;J$(137752,g,234)}g=(c[137756>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Jc(4)|0;q=p;I9(q);r=153160;s=128;_d(p|0,r|0,s|0)}else{s=d;c[e>>2]=pe[c[(c[d>>2]|0)+16>>2]&127](s)|0;ne[c[(c[d>>2]|0)+20>>2]&127](a,s);o$(c[b>>2]|0)|0;i=f;return}}function L3(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;U0(k,b);b=k;k=c[b>>2]|0;if(!((c[34398]|0)==-1)){c[j>>2]=137592;c[j+4>>2]=233;c[j+8>>2]=0;J$(137592,j,234)}j=(c[137596>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Jc(4)|0;n=m;I9(n);o=153160;p=128;_d(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Jc(4)|0;n=m;I9(n);o=153160;p=128;_d(m|0,o|0,p|0)}Oe[c[(c[k>>2]|0)+48>>2]&63](k,136144,136176|0,d)|0;d=c[b>>2]|0;if(!((c[34438]|0)==-1)){c[h>>2]=137752;c[h+4>>2]=233;c[h+8>>2]=0;J$(137752,h,234)}h=(c[137756>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}else{t=d;c[e>>2]=pe[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=pe[c[(c[d>>2]|0)+16>>2]&127](t)|0;ne[c[(c[d>>2]|0)+20>>2]&127](a,t);o$(c[b>>2]|0)|0;i=g;return}}function M3(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[136144+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function N3(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function O3(a){a=a|0;i=i;return}function P3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ye[p&31](b,d,k,f,g,q);i=j;return}U0(n,f);f=n;n=c[f>>2]|0;if(!((c[34436]|0)==-1)){c[l>>2]=137744;c[l+4>>2]=233;c[l+8>>2]=0;J$(137744,l,234)}l=(c[137748>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}w=n;o$(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ne[c[f+24>>2]&127](o,w)}else{ne[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((Ee[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Y$(o);i=j;return}function Q3(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=136392;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);x=c[34372]|0;c[k>>2]=h;h=R3(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;U0(q,f);S3(w,y,k,z,o,p,q);o$(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];uY(b,j,z,e,o,f,g);i=d;return}function R3(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Qc(d|0)|0;d=dd(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Qc(f|0)|0;i=g;return d|0}function S3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[34400]|0)==-1)){c[m>>2]=137600;c[m+4>>2]=233;c[m+8>>2]=0;J$(137600,m,234)}m=(c[137604>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Jc(4)|0;r=q;I9(r);s=153160;t=128;_d(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34436]|0)==-1)){c[l>>2]=137744;c[l+4>>2]=233;c[l+8>>2]=0;J$(137744,l,234)}l=(c[137748>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Jc(4)|0;v=u;I9(v);w=153160;x=128;_d(u|0,w|0,x|0)}x=s;ne[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Oe[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ee[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=Ee[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=pe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=Ee[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Y$(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Y$(n);i=k;return}}function T3(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);w=c[34372]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=R3(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;U0(r,f);S3(x,z,l,A,p,q,r);o$(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];uY(b,k,A,e,p,f,g);i=d;return}



function T5(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[34260]|0)==-1)){c[p>>2]=137040;c[p+4>>2]=233;c[p+8>>2]=0;J$(137040,p,234)}p=(c[137044>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}E=b;ne[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ne[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Y$(r);ne[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}i0(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Y$(s);a[f]=pe[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=pe[c[(c[b>>2]|0)+16>>2]&127](E)|0;ne[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}i0(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Y$(t);ne[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Y$(u);F=pe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[34244]|0)==-1)){c[o>>2]=136976;c[o+4>>2]=233;c[o+8>>2]=0;J$(136976,o,234)}o=(c[136980>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}J=E;ne[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ne[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Y$(w);ne[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}i0(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Y$(x);a[f]=pe[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=pe[c[(c[E>>2]|0)+16>>2]&127](J)|0;ne[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}i0(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Y$(y);ne[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Y$(z);F=pe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function U5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function V5(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function W5(a){a=a|0;i=i;return}function X5(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=235;y=o+400|0;U0(r,h);o=r;z=c[o>>2]|0;if(!((c[34398]|0)==-1)){c[n>>2]=137592;c[n+4>>2]=233;c[n+8>>2]=0;J$(137592,n,234)}n=(c[137596>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Y5(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Oe[c[(c[z>>2]|0)+48>>2]&63](E,137296,137306|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=baa((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}oaa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[137296+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Cd(p|0,137232,m|0)|0)!=1){t=Jc(8)|0;u$(t,137240);_d(t|0,134592,43)}if((F|0)==0){break}caa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=pe[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];o$(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}me[c[x>>2]&255](o);i=d;return}function Y5(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;$5(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=235;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=pe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=pe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=pe[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=pe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){pe[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 4:{P=M;R=r;na=L;oa=0;pa=O;f:while(1){qa=c[g>>2]|0;do{if((qa|0)==0){Ka=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){La=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{La=c[wa>>2]|0}if((La|0)==-1){c[g>>2]=0;Ka=1;break}else{Ka=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=188}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Ma=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ma=c[wa>>2]|0}if((Ma|0)==-1){c[b>>2]=0;T=188;break}else{if(Ka){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(Ka){break}}qa=c[g>>2]|0;wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Na=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Na=c[wa>>2]|0}if(se[c[(c[l>>2]|0)+12>>2]&63](l,2048,Na)|0){wa=c[n>>2]|0;if((wa|0)==(c[q>>2]|0)){a6(m,n,q);Oa=c[n>>2]|0}else{Oa=wa}c[n>>2]=Oa+4;c[Oa>>2]=Na;Pa=P;Qa=R;Ra=na;Sa=oa+1|0;Ta=pa}else{wa=a[w]|0;if((wa&1)==0){Ua=(wa&255)>>>1}else{Ua=c[K>>2]|0}if((Ua|0)==0|(oa|0)==0){break}if((Na|0)!=(c[v>>2]|0)){break}if((R|0)==(na|0)){wa=R-P|0;qa=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=235){Va=P}else{Va=0}va=eaa(Va,qa)|0;if((va|0)==0){T=206;break a}Wa=va;Xa=va+(wa>>2<<2)|0;Ya=va+(qa>>>2<<2)|0;Za=210}else{Wa=P;Xa=R;Ya=na;Za=pa}c[Xa>>2]=oa;Pa=Wa;Qa=Xa+4|0;Ra=Ya;Sa=0;Ta=Za}qa=c[g>>2]|0;va=qa+12|0;wa=c[va>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){pe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}else{c[va>>2]=wa+4;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}}if((P|0)==(R|0)|(oa|0)==0){_a=P;$a=R;ab=na;bb=pa}else{if((R|0)==(na|0)){wa=R-P|0;va=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=235){cb=P}else{cb=0}qa=eaa(cb,va)|0;if((qa|0)==0){T=217;break a}db=qa;eb=qa+(wa>>2<<2)|0;fb=qa+(va>>>2<<2)|0;gb=210}else{db=P;eb=R;fb=na;gb=pa}c[eb>>2]=oa;_a=db;$a=eb+4|0;ab=fb;bb=gb}va=c[B>>2]|0;if((va|0)>0){qa=c[g>>2]|0;do{if((qa|0)==0){hb=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){ib=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{ib=c[wa>>2]|0}if((ib|0)==-1){c[g>>2]=0;hb=1;break}else{hb=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=234}else{oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){jb=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{jb=c[oa>>2]|0}if((jb|0)==-1){c[b>>2]=0;T=234;break}else{if(hb){kb=qa;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(hb){T=240;break a}else{kb=0}}qa=c[g>>2]|0;oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){lb=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{lb=c[oa>>2]|0}if((lb|0)!=(c[u>>2]|0)){T=240;break a}oa=c[g>>2]|0;qa=oa+12|0;pa=c[qa>>2]|0;if((pa|0)==(c[oa+16>>2]|0)){pe[c[(c[oa>>2]|0)+40>>2]&127](oa)|0;mb=kb;nb=va;ob=kb}else{c[qa>>2]=pa+4;mb=kb;nb=va;ob=kb}while(1){pa=c[g>>2]|0;do{if((pa|0)==0){pb=1}else{qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){qb=pe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{qb=c[qa>>2]|0}if((qb|0)==-1){c[g>>2]=0;pb=1;break}else{pb=(c[g>>2]|0)==0;break}}}while(0);do{if((ob|0)==0){rb=mb;T=257}else{pa=c[ob+12>>2]|0;if((pa|0)==(c[ob+16>>2]|0)){sb=pe[c[(c[ob>>2]|0)+36>>2]&127](ob)|0}else{sb=c[pa>>2]|0}if((sb|0)==-1){c[b>>2]=0;rb=0;T=257;break}else{if(pb^(mb|0)==0){tb=mb;ub=mb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(pb){T=263;break a}else{tb=rb;ub=0}}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){vb=pe[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{vb=c[qa>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,2048,vb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){a6(m,n,q)}qa=c[g>>2]|0;pa=c[qa+12>>2]|0;if((pa|0)==(c[qa+16>>2]|0)){wb=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{wb=c[pa>>2]|0}pa=c[n>>2]|0;c[n>>2]=pa+4;c[pa>>2]=wb;pa=nb+ -1|0;c[B>>2]=pa;qa=c[g>>2]|0;oa=qa+12|0;na=c[oa>>2]|0;if((na|0)==(c[qa+16>>2]|0)){pe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=na+4}if((pa|0)>0){mb=tb;nb=pa;ob=ub}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=_a;aa=$a;ba=ab;ca=N;da=bb}break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}va=c[g>>2]|0;pa=c[va+12>>2]|0;if((pa|0)==(c[va+16>>2]|0)){xb=pe[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{xb=c[pa>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,xb)|0)){T=27;break a}pa=c[g>>2]|0;va=pa+12|0;na=c[va>>2]|0;if((na|0)==(c[pa+16>>2]|0)){yb=pe[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[va>>2]=na+4;yb=c[na>>2]|0}E0(A,yb);T=28;break};case 0:{T=28;break};case 3:{na=a[y]|0;va=(na&1)==0;if(va){zb=(na&255)>>>1}else{zb=c[D>>2]|0}pa=a[z]|0;oa=(pa&1)==0;if(oa){Ab=(pa&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(va){Bb=(na&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(oa){Cb=(pa&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}qa=c[g>>2]|0;R=c[qa+12>>2]|0;if((R|0)==(c[qa+16>>2]|0)){P=pe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0;Db=P;Eb=a[y]|0}else{Db=c[R>>2]|0;Eb=na}R=c[g>>2]|0;P=R+12|0;qa=c[P>>2]|0;wa=(qa|0)==(c[R+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if(wa){pe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=qa+4}P=a[y]|0;if((P&1)==0){Fb=(P&255)>>>1}else{Fb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Fb>>>0>1?y:N;da=O;break b}if(wa){Gb=pe[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[qa>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}qa=c[g>>2]|0;R=qa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){pe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[R>>2]=wa+4}a[k]=1;wa=a[z]|0;if((wa&1)==0){Hb=(wa&255)>>>1}else{Hb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Hb>>>0>1?z:N;da=O;break b}}while(0);if(va){Ib=(na&255)>>>1}else{Ib=c[D>>2]|0}oa=c[g>>2]|0;wa=c[oa+12>>2]|0;R=(wa|0)==(c[oa+16>>2]|0);if((Ib|0)==0){if(R){qa=pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Jb=qa;Kb=a[z]|0}else{Jb=c[wa>>2]|0;Kb=pa}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}qa=c[g>>2]|0;P=qa+12|0;Lb=c[P>>2]|0;if((Lb|0)==(c[qa+16>>2]|0)){pe[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[P>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Mb>>>0>1?z:N;da=O;break b}if(R){R=pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Nb=R;Ob=a[y]|0}else{Nb=c[wa>>2]|0;Ob=na}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}wa=c[g>>2]|0;R=wa+12|0;oa=c[R>>2]|0;if((oa|0)==(c[wa+16>>2]|0)){pe[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[R>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){Pb=(oa&255)>>>1}else{Pb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Pb>>>0>1?y:N;da=O;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){oa=c[g>>2]|0;do{if((oa|0)==0){Sb=1}else{R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Tb=pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Tb=c[R>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{oa=c[Rb+12>>2]|0;if((oa|0)==(c[Rb+16>>2]|0)){Vb=pe[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[oa>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Wb=Ub;Xb=0}}oa=c[g>>2]|0;R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Yb=pe[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Yb=c[R>>2]|0}if(!(se[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}R=c[g>>2]|0;oa=R+12|0;wa=c[oa>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Zb=pe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[oa>>2]=wa+4;Zb=c[wa>>2]|0}E0(A,Zb);Qb=Wb;Rb=Xb}}}while(0);na=o+1|0;if(na>>>0<4){L=ba;r=aa;M=$;o=na;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){oaa()}else if((T|0)==217){oaa()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){bc=($&255)>>>1}else{bc=c[da>>2]|0}if(!(aa>>>0<bc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){cc=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){dc=pe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){ec=pe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=pe[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=da}else{gc=c[ca>>2]|0}if((fc|0)!=(c[gc+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){pe[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;U5(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);A0(A);A0(z);A0(y);A0(x);Y$(w);if(($b|0)==0){i=p;return _b|0}me[ac&255]($b);i=p;return _b|0}function Z5(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=235;v=n+400|0;U0(q,h);n=q;w=c[n>>2]|0;if(!((c[34398]|0)==-1)){c[m>>2]=137592;c[m+4>>2]=233;c[m+8>>2]=0;J$(137592,m,234)}m=(c[137596>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Jc(4)|0;z=y;I9(z);A=153160;B=128;_d(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Jc(4)|0;z=y;I9(z);A=153160;B=128;_d(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Y5(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){E0(k,Ee[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=Ee[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);_5(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=pe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=pe[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];o$(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}me[c[u>>2]&255](n);i=d;return}function _5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){G0(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function $5(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[34292]|0)==-1)){c[p>>2]=137168;c[p+4>>2]=233;c[p+8>>2]=0;J$(137168,p,234)}p=(c[137172>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Jc(4)|0;C=B;I9(C);D=153160;E=128;_d(B|0,D|0,E|0)}E=b;ne[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ne[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;A0(r);ne[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}D0(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;A0(s);c[f>>2]=pe[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=pe[c[(c[b>>2]|0)+16>>2]&127](E)|0;ne[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}i0(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Y$(t);ne[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}D0(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;A0(u);F=pe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[34276]|0)==-1)){c[o>>2]=137104;c[o+4>>2]=233;c[o+8>>2]=0;J$(137104,o,234)}o=(c[137108>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Jc(4)|0;H=G;I9(H);I=153160;J=128;_d(G|0,I|0,J|0)}J=E;ne[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ne[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;A0(w);ne[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}D0(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;A0(x);c[f>>2]=pe[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=pe[c[(c[E>>2]|0)+16>>2]&127](J)|0;ne[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}i0(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Y$(y);ne[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}D0(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;A0(z);F=pe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function a6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=235;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=eaa(m,l)|0;m=a;if((a|0)==0){oaa()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}me[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=210;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function b6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function c6(a){a=a|0;i=i;return}function d6(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Rc(G|0,100,137352,o|0)|0;do{if(s>>>0>99){do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=X3(r,o,137352,n)|0;o=c[r>>2]|0;if((o|0)==0){oaa()}H=baa(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}oaa()}else{I=0;J=0;K=q;L=s}}while(0);U0(t,g);s=t;q=c[s>>2]|0;if(!((c[34400]|0)==-1)){c[p>>2]=137600;c[p+4>>2]=233;c[p+8>>2]=0;J$(137600,p,234)}p=(c[137604>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Oe[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;e6(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=baa(V)|0;if((T|0)!=0){W=T;X=T;break}oaa()}else{W=0;X=t}}while(0);f6(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];uY(b,m,X,e,D,g,j);if((W|0)!=0){caa(W)}Y$(A);Y$(z);Y$(y);o$(c[s>>2]|0)|0;if((J|0)!=0){caa(J)}if((I|0)==0){i=d;return}caa(I);i=d;return}function e6(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[34260]|0)==-1)){c[p>>2]=137040;c[p+4>>2]=233;c[p+8>>2]=0;J$(137040,p,234)}p=(c[137044>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Jc(4)|0;I=H;I9(I);J=153160;K=128;_d(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Jc(4)|0;I=H;I9(I);J=153160;K=128;_d(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ne[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ne[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Y$(s)}else{ne[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ne[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Y$(v)}a[g]=pe[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=pe[c[(c[e>>2]|0)+16>>2]&127](K)|0;ne[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Y$(w);ne[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}i0(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Y$(x);L=pe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[34244]|0)==-1)){c[o>>2]=136976;c[o+4>>2]=233;c[o+8>>2]=0;J$(136976,o,234)}o=(c[136980>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ne[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ne[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Y$(A)}else{ne[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ne[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}i0(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Y$(D)}a[g]=pe[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=pe[c[(c[G>>2]|0)+16>>2]&127](P)|0;ne[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Y$(E);ne[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}i0(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Y$(F);L=pe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function f6(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 0:{c[e>>2]=c[f>>2];I=H;break};case 4:{J=c[f>>2]|0;K=l?H+1|0:H;b:do{if(K>>>0<j>>>0){L=K;while(1){M=a[L]|0;if(!(M<<24>>24>-1)){N=L;break b}O=L+1|0;if((b[(c[F>>2]|0)+(M<<24>>24<<1)>>1]&2048)==0){N=L;break b}if(O>>>0<j>>>0){L=O}else{N=O;break}}}else{N=K}}while(0);L=N;if(B){if(N>>>0>K>>>0){O=K+(0-L)|0;L=O>>>0<G>>>0?G:O;O=L+s|0;M=J;P=N;Q=s;while(1){R=P+ -1|0;S=a[R]|0;c[f>>2]=M+1;a[M]=S;S=Q+ -1|0;T=(S|0)>0;if(!(R>>>0>K>>>0&T)){break}M=c[f>>2]|0;Q=S;P=R}P=N+L|0;if(T){U=P;V=O;W=32}else{X=0;Y=P;Z=O}}else{U=N;V=s;W=32}if((W|0)==32){W=0;X=Ee[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;Y=U;Z=V}P=c[f>>2]|0;c[f>>2]=P+1;if((Z|0)>0){Q=P;M=Z;while(1){a[Q]=X;R=M+ -1|0;S=c[f>>2]|0;c[f>>2]=S+1;if((R|0)>0){M=R;Q=S}else{_=S;break}}}else{_=P}a[_]=n;$=Y}else{$=N}if(($|0)==(K|0)){Q=Ee[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;M=c[f>>2]|0;c[f>>2]=M+1;a[M]=Q}else{Q=a[p]|0;M=(Q&1)==0;if(M){aa=(Q&255)>>>1}else{aa=c[E>>2]|0}if((aa|0)==0){ba=$;ca=-1;da=0;ea=0}else{if(M){fa=C}else{fa=c[D>>2]|0}ba=$;ca=a[fa]|0;da=0;ea=0}while(1){do{if((ea|0)==(ca|0)){M=c[f>>2]|0;c[f>>2]=M+1;a[M]=o;M=da+1|0;Q=a[p]|0;O=(Q&1)==0;if(O){ga=(Q&255)>>>1}else{ga=c[E>>2]|0}if(!(M>>>0<ga>>>0)){ha=ca;ia=M;ja=0;break}if(O){ka=C}else{ka=c[D>>2]|0}if((a[ka+M|0]|0)==127){ha=-1;ia=M;ja=0;break}if(O){la=C}else{la=c[D>>2]|0}ha=a[la+M|0]|0;ia=M;ja=0}else{ha=ca;ia=da;ja=ea}}while(0);M=ba+ -1|0;O=a[M]|0;Q=c[f>>2]|0;c[f>>2]=Q+1;a[Q]=O;if((M|0)==(K|0)){break}else{ba=M;ca=ha;da=ia;ea=ja+1|0}}}P=c[f>>2]|0;if((J|0)==(P|0)){I=K;break a}M=P+ -1|0;if(M>>>0>J>>>0){ma=J;na=M}else{I=K;break a}while(1){M=a[ma]|0;a[ma]=a[na]|0;a[na]=M;M=ma+1|0;P=na+ -1|0;if(M>>>0<P>>>0){na=P;ma=M}else{I=K;break}}break};case 3:{K=a[r]|0;J=(K&1)==0;if(J){oa=(K&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0){I=H;break a}if(J){pa=u}else{pa=c[v>>2]|0}J=a[pa]|0;K=c[f>>2]|0;c[f>>2]=K+1;a[K]=J;I=H;break};case 1:{c[e>>2]=c[f>>2];J=Ee[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;K=c[f>>2]|0;c[f>>2]=K+1;a[K]=J;I=H;break};case 2:{J=a[q]|0;K=(J&1)==0;if(K){qa=(J&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){I=H;break a}if(K){ra=y;sa=(J&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}J=ra+sa|0;K=c[f>>2]|0;if((ra|0)==(J|0)){ta=K}else{M=K;K=ra;while(1){a[M]=a[K]|0;P=K+1|0;O=M+1|0;if((P|0)==(J|0)){ta=O;break}else{K=P;M=O}}}c[f>>2]=ta;I=H;break};default:{I=H}}}while(0);M=h+1|0;if(M>>>0<4){H=I;h=M}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function g6(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;U0(m,g);z=m;A=c[z>>2]|0;if(!((c[34400]|0)==-1)){c[l>>2]=137600;c[l+4>>2]=233;c[l+8>>2]=0;J$(137600,l,234)}l=(c[137604>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(Ee[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;e6(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=baa(P)|0;if((N|0)!=0){Q=N;R=N;break}oaa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}f6(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];uY(b,k,R,e,w,g,h);if((Q|0)==0){Y$(t);Y$(s);Y$(r);U=c[z>>2]|0;V=U;W=V;X=o$(W)|0;i=d;return}caa(Q);Y$(t);Y$(s);Y$(r);U=c[z>>2]|0;V=U;W=V;X=o$(W)|0;i=d;return}function h6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function i6(a){a=a|0;i=i;return}function j6(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Rc(G|0,100,137352,o|0)|0;do{if(s>>>0>99){do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);o=c[34372]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=X3(r,o,137352,n)|0;o=c[r>>2]|0;if((o|0)==0){oaa()}H=baa(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}oaa()}else{J=0;K=0;L=q;M=s}}while(0);U0(t,g);s=t;q=c[s>>2]|0;if(!((c[34398]|0)==-1)){c[p>>2]=137592;c[p+4>>2]=233;c[p+8>>2]=0;J$(137592,p,234)}p=(c[137596>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Jc(4)|0;O=N;I9(O);P=153160;Q=128;_d(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Jc(4)|0;O=N;I9(O);P=153160;Q=128;_d(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Oe[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;k6(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=baa(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}oaa()}else{X=0;Y=t}}while(0);l6(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];e4(b,m,Y,e,D,g,j);if((X|0)!=0){caa(X)}A0(A);A0(z);Y$(y);o$(c[s>>2]|0)|0;if((K|0)!=0){caa(K)}if((J|0)==0){i=d;return}caa(J);i=d;return}function k6(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[34292]|0)==-1)){c[p>>2]=137168;c[p+4>>2]=233;c[p+8>>2]=0;J$(137168,p,234)}p=(c[137172>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Jc(4)|0;I=H;I9(I);J=153160;K=128;_d(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Jc(4)|0;I=H;I9(I);J=153160;K=128;_d(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ne[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ne[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;A0(s)}else{ne[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ne[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;A0(v)}c[g>>2]=pe[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=pe[c[(c[e>>2]|0)+16>>2]&127](K)|0;ne[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Y$(w);ne[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}D0(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;A0(x);L=pe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[34276]|0)==-1)){c[o>>2]=137104;c[o+4>>2]=233;c[o+8>>2]=0;J$(137104,o,234)}o=(c[137108>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Jc(4)|0;N=M;I9(N);O=153160;P=128;_d(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ne[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ne[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;A0(A)}else{ne[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ne[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}D0(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;A0(D)}c[g>>2]=pe[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=pe[c[(c[G>>2]|0)+16>>2]&127](P)|0;ne[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}i0(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Y$(E);ne[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}D0(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;A0(F);L=pe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function l6(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 1:{c[d>>2]=c[e>>2];D=Ee[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 0:{c[d>>2]=c[e>>2];F=C;break};case 3:{D=a[q]|0;E=(D&1)==0;if(E){G=(D&255)>>>1}else{G=c[t>>2]|0}if((G|0)==0){F=C;break a}if(E){H=t}else{H=c[u>>2]|0}E=c[H>>2]|0;D=c[e>>2]|0;c[e>>2]=D+4;c[D>>2]=E;F=C;break};case 2:{E=a[p]|0;D=(E&1)==0;if(D){I=(E&255)>>>1}else{I=c[w>>2]|0}if((I|0)==0|v){F=C;break a}if(D){J=w;K=(E&255)>>>1}else{J=c[x>>2]|0;K=c[w>>2]|0}E=J+(K<<2)|0;D=c[e>>2]|0;if((J|0)==(E|0)){L=D}else{M=(J+(K+ -1<<2)+(0-J)|0)>>>2;N=D;O=J;while(1){c[N>>2]=c[O>>2];P=O+4|0;if((P|0)==(E|0)){break}N=N+4|0;O=P}L=D+(M+1<<2)|0}c[e>>2]=L;F=C;break};case 4:{O=c[e>>2]|0;N=k?C+4|0:C;b:do{if(N>>>0<h>>>0){E=N;while(1){P=E+4|0;if(!(se[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[E>>2]|0)|0)){Q=E;break b}if(P>>>0<h>>>0){E=P}else{Q=P;break}}}else{Q=N}}while(0);if(y){do{if(Q>>>0>N>>>0){M=c[e>>2]|0;D=Q;E=r;while(1){R=D+ -4|0;S=M+4|0;c[M>>2]=c[R>>2];T=E+ -1|0;U=(T|0)>0;if(R>>>0>N>>>0&U){E=T;D=R;M=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}M=c[e>>2]|0;c[e>>2]=M+4;Y=M;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;M=Ee[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;E=D+4|0;c[e>>2]=E;if((W|0)>0){_=E;$=D;aa=W}else{Y=D;Z=V;break}while(1){c[$>>2]=M;E=aa+ -1|0;if((E|0)>0){aa=E;$=_;_=_+4|0}else{break}}c[e>>2]=D+(W+1<<2);Y=D+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(N|0)){M=Ee[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;P=E+4|0;c[e>>2]=P;c[E>>2]=M;ca=P}else{P=a[o]|0;M=(P&1)==0;if(M){da=(P&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(M){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){M=c[e>>2]|0;do{if((ha|0)==(fa|0)){P=M+4|0;c[e>>2]=P;c[M>>2]=n;E=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(E>>>0<la>>>0)){ma=P;na=fa;oa=E;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+E|0]|0)==127){ma=P;na=-1;oa=E;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=P;na=a[ra+E|0]|0;oa=E;pa=0}else{ma=M;na=fa;oa=ga;pa=ha}}while(0);M=ea+ -4|0;D=c[M>>2]|0;E=ma+4|0;c[e>>2]=E;c[ma>>2]=D;if((M|0)==(N|0)){ca=E;break}else{ea=M;fa=na;ga=oa;ha=pa+1|0}}}if((O|0)==(ca|0)){F=N;break a}M=ca+ -4|0;if(M>>>0>O>>>0){sa=O;ta=M}else{F=N;break a}while(1){M=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=M;M=sa+4|0;E=ta+ -4|0;if(M>>>0<E>>>0){ta=E;sa=M}else{F=N;break}}break};default:{F=C}}}while(0);N=g+1|0;if(N>>>0<4){C=F;g=N}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function m6(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;U0(m,g);z=m;A=c[z>>2]|0;if(!((c[34398]|0)==-1)){c[l>>2]=137592;c[l+4>>2]=233;c[l+8>>2]=0;J$(137592,l,234)}l=(c[137596>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Jc(4)|0;D=C;I9(D);E=153160;F=128;_d(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(Ee[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;k6(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=baa(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}oaa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}l6(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];e4(b,k,R,e,w,g,h);if((Q|0)==0){A0(t);A0(s);Y$(r);U=c[z>>2]|0;V=U;W=V;X=o$(W)|0;i=d;return}caa(Q);A0(t);A0(s);Y$(r);U=c[z>>2]|0;V=U;W=V;X=o$(W)|0;i=d;return}function n6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function o6(a){a=a|0;i=i;return}function p6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=zc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function q6(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{o0(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Dd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=Faa(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Y$(j);i=d;return}do{o0(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Y$(j);i=d;return}function r6(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function s6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function t6(a){a=a|0;i=i;return}function u6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=zc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function v6(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=139256;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=139256|0;while(1){c[m>>2]=y;A=(Ne[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{o0(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}Q5(138480)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Dd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=139360;D=Faa(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Y$(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=139360|0;while(1){c[q>>2]=o;h=(Ne[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{E0(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){Q5(138480)}else if((E|0)==25){Y$(r);i=d;return}}function w6(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function x6(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=137688;e=b+8|0;b=c[e>>2]|0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);if((b|0)==(c[34372]|0)){i=d;return}bc(c[e>>2]|0);i=d;return}function y6(a){a=a|0;a=Jc(8)|0;p$(a,137480);c[a>>2]=134448;_d(a|0,134488,41)}function z6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=137520;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);Q$(b+144|0,137504,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[142412>>2]=0;c[35602]=136e3;if(!((c[34006]|0)==-1)){c[G>>2]=136024;c[G+4>>2]=233;c[G+8>>2]=0;J$(136024,G,234)}A6(b,142408,(c[136028>>2]|0)+ -1|0);c[142404>>2]=0;c[35600]=136040;if(!((c[34016]|0)==-1)){c[F>>2]=136064;c[F+4>>2]=233;c[F+8>>2]=0;J$(136064,F,234)}A6(b,142400,(c[136068>>2]|0)+ -1|0);c[142388>>2]=0;c[35596]=137616;c[142392>>2]=0;a[142396|0]=0;F=c[(Dc()|0)>>2]|0;c[142392>>2]=F;if(!((c[34400]|0)==-1)){c[E>>2]=137600;c[E+4>>2]=233;c[E+8>>2]=0;J$(137600,E,234)}A6(b,142384,(c[137604>>2]|0)+ -1|0);c[142380>>2]=0;c[35594]=138576;if(!((c[34398]|0)==-1)){c[D>>2]=137592;c[D+4>>2]=233;c[D+8>>2]=0;J$(137592,D,234)}A6(b,142376,(c[137596>>2]|0)+ -1|0);c[142372>>2]=0;c[35592]=138792;if(!((c[34416]|0)==-1)){c[C>>2]=137664;c[C+4>>2]=233;c[C+8>>2]=0;J$(137664,C,234)}A6(b,142368,(c[137668>>2]|0)+ -1|0);c[142356>>2]=0;c[35588]=137688;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);c[142360>>2]=c[34372];if(!((c[34418]|0)==-1)){c[B>>2]=137672;c[B+4>>2]=233;c[B+8>>2]=0;J$(137672,B,234)}A6(b,142352,(c[137676>>2]|0)+ -1|0);c[142348>>2]=0;c[35586]=139016;if(!((c[34432]|0)==-1)){c[A>>2]=137728;c[A+4>>2]=233;c[A+8>>2]=0;J$(137728,A,234)}A6(b,142344,(c[137732>>2]|0)+ -1|0);c[142340>>2]=0;c[35584]=139136;if(!((c[34434]|0)==-1)){c[z>>2]=137736;c[z+4>>2]=233;c[z+8>>2]=0;J$(137736,z,234)}A6(b,142336,(c[137740>>2]|0)+ -1|0);c[142316>>2]=0;c[35578]=137768;a[142320|0]=46;a[142321|0]=44;z=142324|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[34436]|0)==-1)){c[y>>2]=137744;c[y+4>>2]=233;c[y+8>>2]=0;J$(137744,y,234)}A6(b,142312,(c[137748>>2]|0)+ -1|0);c[142284>>2]=0;c[35570]=137808;c[142288>>2]=46;c[142292>>2]=44;y=142296|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[34438]|0)==-1)){c[x>>2]=137752;c[x+4>>2]=233;c[x+8>>2]=0;J$(137752,x,234)}A6(b,142280,(c[137756>>2]|0)+ -1|0);c[142276>>2]=0;c[35568]=136080;if(!((c[34034]|0)==-1)){c[w>>2]=136136;c[w+4>>2]=233;c[w+8>>2]=0;J$(136136,w,234)}A6(b,142272,(c[136140>>2]|0)+ -1|0);c[142268>>2]=0;c[35566]=136200;if(!((c[34064]|0)==-1)){c[v>>2]=136256;c[v+4>>2]=233;c[v+8>>2]=0;J$(136256,v,234)}A6(b,142264,(c[136260>>2]|0)+ -1|0);c[142260>>2]=0;c[35564]=136272;if(!((c[34080]|0)==-1)){c[u>>2]=136320;c[u+4>>2]=233;c[u+8>>2]=0;J$(136320,u,234)}A6(b,142256,(c[136324>>2]|0)+ -1|0);c[142252>>2]=0;c[35562]=136336;if(!((c[34096]|0)==-1)){c[t>>2]=136384;c[t+4>>2]=233;c[t+8>>2]=0;J$(136384,t,234)}A6(b,142248,(c[136388>>2]|0)+ -1|0);c[142244>>2]=0;c[35560]=136928;if(!((c[34244]|0)==-1)){c[s>>2]=136976;c[s+4>>2]=233;c[s+8>>2]=0;J$(136976,s,234)}A6(b,142240,(c[136980>>2]|0)+ -1|0);c[142236>>2]=0;c[35558]=136992;if(!((c[34260]|0)==-1)){c[r>>2]=137040;c[r+4>>2]=233;c[r+8>>2]=0;J$(137040,r,234)}A6(b,142232,(c[137044>>2]|0)+ -1|0);c[142228>>2]=0;c[35556]=137056;if(!((c[34276]|0)==-1)){c[q>>2]=137104;c[q+4>>2]=233;c[q+8>>2]=0;J$(137104,q,234)}A6(b,142224,(c[137108>>2]|0)+ -1|0);c[142220>>2]=0;c[35554]=137120;if(!((c[34292]|0)==-1)){c[p>>2]=137168;c[p+4>>2]=233;c[p+8>>2]=0;J$(137168,p,234)}A6(b,142216,(c[137172>>2]|0)+ -1|0);c[142212>>2]=0;c[35552]=137184;if(!((c[34302]|0)==-1)){c[o>>2]=137208;c[o+4>>2]=233;c[o+8>>2]=0;J$(137208,o,234)}A6(b,142208,(c[137212>>2]|0)+ -1|0);c[142204>>2]=0;c[35550]=137264;if(!((c[34322]|0)==-1)){c[n>>2]=137288;c[n+4>>2]=233;c[n+8>>2]=0;J$(137288,n,234)}A6(b,142200,(c[137292>>2]|0)+ -1|0);c[142196>>2]=0;c[35548]=137320;if(!((c[34336]|0)==-1)){c[m>>2]=137344;c[m+4>>2]=233;c[m+8>>2]=0;J$(137344,m,234)}A6(b,142192,(c[137348>>2]|0)+ -1|0);c[142188>>2]=0;c[35546]=137368;if(!((c[34348]|0)==-1)){c[l>>2]=137392;c[l+4>>2]=233;c[l+8>>2]=0;J$(137392,l,234)}A6(b,142184,(c[137396>>2]|0)+ -1|0);c[142172>>2]=0;c[35542]=136416;c[142176>>2]=136464;if(!((c[34124]|0)==-1)){c[k>>2]=136496;c[k+4>>2]=233;c[k+8>>2]=0;J$(136496,k,234)}A6(b,142168,(c[136500>>2]|0)+ -1|0);c[142156>>2]=0;c[35538]=136568;c[142160>>2]=136616;if(!((c[34162]|0)==-1)){c[j>>2]=136648;c[j+4>>2]=233;c[j+8>>2]=0;J$(136648,j,234)}A6(b,142152,(c[136652>>2]|0)+ -1|0);c[142140>>2]=0;c[35534]=138512;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);c[142144>>2]=c[34372];c[35534]=136864;if(!((c[34220]|0)==-1)){c[h>>2]=136880;c[h+4>>2]=233;c[h+8>>2]=0;J$(136880,h,234)}A6(b,142136,(c[136884>>2]|0)+ -1|0);c[142124>>2]=0;c[35530]=138512;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);c[142128>>2]=c[34372];c[35530]=136896;if(!((c[34228]|0)==-1)){c[g>>2]=136912;c[g+4>>2]=233;c[g+8>>2]=0;J$(136912,g,234)}A6(b,142120,(c[136916>>2]|0)+ -1|0);c[142116>>2]=0;c[35528]=137408;if(!((c[34358]|0)==-1)){c[f>>2]=137432;c[f+4>>2]=233;c[f+8>>2]=0;J$(137432,f,234)}A6(b,142112,(c[137436>>2]|0)+ -1|0);c[142108>>2]=0;c[35526]=137448;if((c[34368]|0)==-1){N=137472;O=137472;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=142104;A6(b,T,S);i=e;return}c[H>>2]=137472;c[H+4>>2]=233;c[H+8>>2]=0;J$(137472,H,234);N=137472;O=137472;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=142104;A6(b,T,S);i=e;return}function A6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;n$(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){F8(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}o$(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function B6(a){a=a|0;var b=0;b=i;C6(a);jaa(a);i=b;return}function C6(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=137520;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{o$(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Y$(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{jaa(h);i=d;return}}function D6(){var b=0,d=0,e=0,f=0;b=i;if((a[137576]|0)!=0){d=137568;e=c[34392]|0;i=b;return e|0}if((Za(137576)|0)==0){d=137568;e=c[34392]|0;i=b;return e|0}do{if((a[137552]|0)==0){if((Za(137552)|0)==0){break}z6(141944,1);c[34384]=141944;c[34386]=137536;Ub(137552)}}while(0);f=c[c[34386]>>2]|0;c[34390]=f;n$(f);c[34392]=137560;Ub(137576);d=137568;e=c[34392]|0;i=b;return e|0}function E6(a){a=a|0;var b=0,d=0;b=i;d=c[(D6()|0)>>2]|0;c[a>>2]=d;n$(d);i=b;return}function F6(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;n$(e);i=d;return}function G6(a){a=a|0;var b=0;b=i;o$(c[a>>2]|0)|0;i=b;return}function H6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=233;c[e+8>>2]=0;J$(a,e,234)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function I6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=233;c[e+8>>2]=0;J$(a,e,234)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Jc(4)|0;h=g;I9(h);j=153160;k=128;_d(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Jc(4)|0;h=g;I9(h);j=153160;k=128;_d(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function J6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function K6(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}me[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function L6(a){a=a|0;var b=0;b=c[34396]|0;c[34396]=1+b;c[a+4>>2]=b+1;i=i;return}function M6(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function N6(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Dc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function O6(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Dc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function P6(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Dc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function Q6(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Dc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function R6(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Jd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function S6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Jd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function T6(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Od()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function U6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Od()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function V6(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function W6(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function X6(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Y6(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Z6(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=137616;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}kaa(e)}}while(0);jaa(b);i=d;return}function _6(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=137616;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}kaa(e);i=d;return}function $6(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Jd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function a7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Jd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function b7(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Od()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function c7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Od()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function d7(a,b){a=a|0;b=b|0;i=i;return b|0}function e7(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function f7(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function g7(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function h7(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function i7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function j7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function k7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function l7(a){a=a|0;i=i;return 1}function m7(a){a=a|0;i=i;return 1}function n7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function o7(a){a=a|0;i=i;return 1}function p7(a){a=a|0;var b=0;b=i;x6(a);jaa(a);i=b;return}function q7(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Qc(c[s>>2]|0)|0;A=h9(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Qc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Qc(c[s>>2]|0)|0;A=g9(u,0,d)|0;if((z|0)!=0){Qc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Qc(c[s>>2]|0)|0;G=g9(u,r,n)|0;if((z|0)!=0){Qc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function r7(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Qc(c[r>>2]|0)|0;y=d9(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Qc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Qc(c[r>>2]|0)|0;F=c9(x,y,1,d)|0;if((w|0)!=0){Qc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Qc(c[r>>2]|0)|0;y=c9(q,v,z-v|0,n)|0;if((w|0)!=0){Qc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function s7(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Qc(c[b+8>>2]|0)|0;b=g9(e,0,d)|0;if((j|0)!=0){Qc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function t7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Qc(c[d>>2]|0)|0;e=f9(0,0,4)|0;if((a|0)!=0){Qc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Qc(a|0)|0;if((g|0)==0){f=0;break}Qc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function u7(a){a=a|0;i=i;return 0}function v7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Qc(c[k>>2]|0)|0;n=b9(a,j-a|0,b)|0;if((m|0)!=0){Qc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function w7(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Qc(d|0)|0;if((a|0)==0){e=4;break}Qc(a|0)|0;e=4}}while(0);i=b;return e|0}function x7(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function y7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=z7(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function z7(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function A7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=B7(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function B7(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function C7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function D7(a){a=a|0;i=i;return 0}function E7(a){a=a|0;i=i;return 0}function F7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=G7(c,d,e,1114111,0)|0;i=b;return a|0}function G7(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function H7(a){a=a|0;i=i;return 4}function I7(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function J7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=K7(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function K7(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function L7(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=M7(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function M7(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function N7(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function O7(a){a=a|0;i=i;return 0}function P7(a){a=a|0;i=i;return 0}function Q7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=R7(c,d,e,1114111,0)|0;i=b;return a|0}function R7(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function S7(a){a=a|0;i=i;return 4}function T7(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function U7(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function V7(a){a=a|0;var b=0;b=i;c[a>>2]=137768;Y$(a+12|0);jaa(a);i=b;return}function W7(a){a=a|0;var b=0;b=i;c[a>>2]=137768;Y$(a+12|0);i=b;return}function X7(a){a=a|0;var b=0;b=i;c[a>>2]=137808;Y$(a+16|0);jaa(a);i=b;return}function Y7(a){a=a|0;var b=0;b=i;c[a>>2]=137808;Y$(a+16|0);i=b;return}function Z7(b){b=b|0;i=i;return a[b+8|0]|0}function _7(a){a=a|0;i=i;return c[a+8>>2]|0}function $7(b){b=b|0;i=i;return a[b+9|0]|0}function a8(a){a=a|0;i=i;return c[a+12>>2]|0}function b8(a,b){a=a|0;b=b|0;var c=0;c=i;O$(a,b+12|0);i=c;return}function c8(a,b){a=a|0;b=b|0;var c=0;c=i;O$(a,b+16|0);i=c;return}function d8(a,b){a=a|0;b=b|0;b=i;Q$(a,137840,4);i=b;return}function e8(a,b){a=a|0;b=b|0;b=i;y0(a,137848,D9(137848)|0);i=b;return}function f8(a,b){a=a|0;b=b|0;b=i;Q$(a,137872,5);i=b;return}function g8(a,b){a=a|0;b=b|0;b=i;y0(a,137880,D9(137880)|0);i=b;return}function h8(b){b=b|0;var d=0,e=0;b=i;if((a[137912]|0)!=0){d=137904;e=c[34476]|0;i=b;return e|0}if((Za(137912)|0)==0){d=137904;e=c[34476]|0;i=b;return e|0}do{if((a[145112]|0)==0){if((Za(145112)|0)==0){break}Jaa(144944,0,168)|0;ee(236,0,q|0)|0;Ub(145112)}}while(0);$$(144944,145120)|0;$$(144956|0,145128)|0;$$(144968|0,145136)|0;$$(144980|0,145144)|0;$$(144992|0,145160)|0;$$(145004|0,145176)|0;$$(145016|0,145184)|0;$$(145028|0,145200)|0;$$(145040|0,145208)|0;$$(145052|0,145216)|0;$$(145064|0,145224)|0;$$(145076|0,145232)|0;$$(145088|0,145240)|0;$$(145100|0,145248)|0;c[34476]=144944;Ub(137912);d=137904;e=c[34476]|0;i=b;return e|0}function i8(b){b=b|0;var d=0,e=0;b=i;if((a[137928]|0)!=0){d=137920;e=c[34480]|0;i=b;return e|0}if((Za(137928)|0)==0){d=137920;e=c[34480]|0;i=b;return e|0}do{if((a[144576]|0)==0){if((Za(144576)|0)==0){break}Jaa(144408,0,168)|0;ee(237,0,q|0)|0;Ub(144576)}}while(0);B0(144408,144584)|0;B0(144420|0,144616)|0;B0(144432|0,144648)|0;B0(144444|0,144680)|0;B0(144456|0,144720)|0;B0(144468|0,144760)|0;B0(144480|0,144792)|0;B0(144492|0,144832)|0;B0(144504|0,144848)|0;B0(144516|0,144864)|0;B0(144528|0,144880)|0;B0(144540|0,144896)|0;B0(144552|0,144912)|0;B0(144564|0,144928)|0;c[34480]=144408;Ub(137928);d=137920;e=c[34480]|0;i=b;return e|0}function j8(b){b=b|0;var d=0,e=0;b=i;if((a[137944]|0)!=0){d=137936;e=c[34484]|0;i=b;return e|0}if((Za(137944)|0)==0){d=137936;e=c[34484]|0;i=b;return e|0}do{if((a[144184]|0)==0){if((Za(144184)|0)==0){break}Jaa(143896,0,288)|0;ee(238,0,q|0)|0;Ub(144184)}}while(0);$$(143896,144192)|0;$$(143908|0,144200)|0;$$(143920|0,144216)|0;$$(143932|0,144224)|0;$$(143944|0,144232)|0;$$(143956|0,144240)|0;$$(143968|0,144248)|0;$$(143980|0,144256)|0;$$(143992|0,144264)|0;$$(144004|0,144280)|0;$$(144016|0,144288)|0;$$(144028|0,144304)|0;$$(144040|0,144320)|0;$$(144052|0,144328)|0;$$(144064|0,144336)|0;$$(144076|0,144344)|0;$$(144088|0,144232)|0;$$(144100|0,144352)|0;$$(144112|0,144360)|0;$$(144124|0,144368)|0;$$(144136|0,144376)|0;$$(144148|0,144384)|0;$$(144160|0,144392)|0;$$(144172|0,144400)|0;c[34484]=143896;Ub(137944);d=137936;e=c[34484]|0;i=b;return e|0}function k8(b){b=b|0;var d=0,e=0;b=i;if((a[137960]|0)!=0){d=137952;e=c[34488]|0;i=b;return e|0}if((Za(137960)|0)==0){d=137952;e=c[34488]|0;i=b;return e|0}do{if((a[143344]|0)==0){if((Za(143344)|0)==0){break}Jaa(143056,0,288)|0;ee(239,0,q|0)|0;Ub(143344)}}while(0);B0(143056,143352)|0;B0(143068|0,143384)|0;B0(143080|0,143424)|0;B0(143092|0,143448)|0;B0(143104|0,143768)|0;B0(143116|0,143472)|0;B0(143128|0,143496)|0;B0(143140|0,143520)|0;B0(143152|0,143552)|0;B0(143164|0,143592)|0;B0(143176|0,143624)|0;B0(143188|0,143664)|0;B0(143200|0,143704)|0;B0(143212|0,143720)|0;B0(143224|0,143736)|0;B0(143236|0,143752)|0;B0(143248|0,143768)|0;B0(143260|0,143784)|0;B0(143272|0,143800)|0;B0(143284|0,143816)|0;B0(143296|0,143832)|0;B0(143308|0,143848)|0;B0(143320|0,143864)|0;B0(143332|0,143880)|0;c[34488]=143056;Ub(137960);d=137952;e=c[34488]|0;i=b;return e|0}function l8(b){b=b|0;var d=0,e=0;b=i;if((a[137976]|0)!=0){d=137968;e=c[34492]|0;i=b;return e|0}if((Za(137976)|0)==0){d=137968;e=c[34492]|0;i=b;return e|0}do{if((a[143032]|0)==0){if((Za(143032)|0)==0){break}Jaa(142744,0,288)|0;ee(240,0,q|0)|0;Ub(143032)}}while(0);$$(142744,143040)|0;$$(142756|0,143048)|0;c[34492]=142744;Ub(137976);d=137968;e=c[34492]|0;i=b;return e|0}function m8(b){b=b|0;var d=0,e=0;b=i;if((a[137992]|0)!=0){d=137984;e=c[34496]|0;i=b;return e|0}if((Za(137992)|0)==0){d=137984;e=c[34496]|0;i=b;return e|0}do{if((a[142704]|0)==0){if((Za(142704)|0)==0){break}Jaa(142416,0,288)|0;ee(241,0,q|0)|0;Ub(142704)}}while(0);B0(142416,142712)|0;B0(142428|0,142728)|0;c[34496]=142416;Ub(137992);d=137984;e=c[34496]|0;i=b;return e|0}function n8(b){b=b|0;var c=0;b=i;if((a[138016]|0)!=0){c=138e3;i=b;return c|0}if((Za(138016)|0)==0){c=138e3;i=b;return c|0}Q$(138e3,138024,8);ee(242,138e3,q|0)|0;Ub(138016);c=138e3;i=b;return c|0}function o8(b){b=b|0;var c=0;b=i;if((a[138056]|0)!=0){c=138040;i=b;return c|0}if((Za(138056)|0)==0){c=138040;i=b;return c|0}y0(138040,138064,D9(138064)|0);ee(243,138040,q|0)|0;Ub(138056);c=138040;i=b;return c|0}function p8(b){b=b|0;var c=0;b=i;if((a[138120]|0)!=0){c=138104;i=b;return c|0}if((Za(138120)|0)==0){c=138104;i=b;return c|0}Q$(138104,138128,8);ee(242,138104,q|0)|0;Ub(138120);c=138104;i=b;return c|0}function q8(b){b=b|0;var c=0;b=i;if((a[138160]|0)!=0){c=138144;i=b;return c|0}if((Za(138160)|0)==0){c=138144;i=b;return c|0}y0(138144,138168,D9(138168)|0);ee(243,138144,q|0)|0;Ub(138160);c=138144;i=b;return c|0}function r8(b){b=b|0;var c=0;b=i;if((a[138224]|0)!=0){c=138208;i=b;return c|0}if((Za(138224)|0)==0){c=138208;i=b;return c|0}Q$(138208,138232,20);ee(242,138208,q|0)|0;Ub(138224);c=138208;i=b;return c|0}function s8(b){b=b|0;var c=0;b=i;if((a[138272]|0)!=0){c=138256;i=b;return c|0}if((Za(138272)|0)==0){c=138256;i=b;return c|0}y0(138256,138280,D9(138280)|0);ee(243,138256,q|0)|0;Ub(138272);c=138256;i=b;return c|0}function t8(b){b=b|0;var c=0;b=i;if((a[138384]|0)!=0){c=138368;i=b;return c|0}if((Za(138384)|0)==0){c=138368;i=b;return c|0}Q$(138368,138392,11);ee(242,138368,q|0)|0;Ub(138384);c=138368;i=b;return c|0}function u8(b){b=b|0;var c=0;b=i;if((a[138424]|0)!=0){c=138408;i=b;return c|0}if((Za(138424)|0)==0){c=138408;i=b;return c|0}y0(138408,138432,D9(138432)|0);ee(243,138408,q|0)|0;Ub(138424);c=138408;i=b;return c|0}



function ED(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[60736+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[60812+l|0]|0|0)!=28){if((d[60812+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[60812+q|0]|0|0)!=28){if((d[60812+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[60812+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((FD(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[54904+(((d[54648+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[54904+(((d[56184+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=CD(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=51;c[h+336>>2]=51;c[h+340>>2]=51;c[h+344>>2]=52;c[h+348>>2]=52;c[h+352>>2]=52;c[h+356>>2]=53;c[h+360>>2]=53;c[h+364>>2]=53}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function FD(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[60812+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function GD(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ee[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[54904+(((d[56184+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function HD(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ee[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[54904+(((d[54648+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function ID(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=Ee[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(FD(a)|0)<0;g=f&1;i=d;return g|0}function JD(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=CD(Ee[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function KD(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(Ee[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function LD(){i=i;return 60368}function MD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=ND(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=25;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function ND(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if(($D(d,c[60272+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function OD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=ZF(58712,a,0,b,c,d)|0;i=e;return f|0}function PD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=ZF(58712,a,1,b,c,d)|0;i=e;return f|0}function QD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;wF(59480,b,c,d);i=a;return}function RD(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=SD(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function SD(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(_F(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,60216)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((_F(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,60224)|0)!=0){h=$F(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=se[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((_F(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Oe[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,60240)|0)!=0){if((a|0)!=0){break}do{if((Oe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,60256)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Oe[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,60264)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((aG($F(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function TD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;je[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if(($D(h,56440)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=ND(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[58712+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function UD(){i=i;return 58344}function VD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=ND(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=25;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function WD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=ZF(56448,a,0,b,c,d)|0;i=e;return f|0}function XD(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=ZF(56448,a,1,b,c,d)|0;i=e;return f|0}function YD(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=SD(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function ZD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;je[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if(($D(h,56440)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=ND(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[56448+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function _D(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=ED(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function $D(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function aE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 30:{k=tE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 13:{k=DE(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[54904+((d[56184+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=rE(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 16:{k=EE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=zE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 12:{k=DE(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=rE(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 19:{k=FE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=rE(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=rE(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 15:{o=122;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=rE(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 7:{o=111;break b;break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 5:{o=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{o=108;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 33:{o=119;break b;break};case 5:{o=85;break b;break};case 6:{o=88;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=91;break b;break};case 34:{o=116;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function bE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=wE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=rE(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=sE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=rE(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function cE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=rE(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=rE(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function dE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=rE(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function eE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=rE(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 2:{n=15;break a;break};case 3:{n=12;break a;break};case 21:{n=29;break a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=sE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=rE(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function fE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=rE(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=18;break a;break};case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=sE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=tE(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=rE(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function gE(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=rE(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=rE(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function hE(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function iE(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=rE(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function jE(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=rE(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function kE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=rE(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=rE(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function lE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=FD(c)|0;k=j;i=b;return k|0}function mE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function nE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=rE(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=rE(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function oE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=rE(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function pE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function qE(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function rE(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function sE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=uE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=rE(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function tE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=rE(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function uE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=vE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=rE(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function vE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=rE(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=rE(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function wE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=rE(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=xE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=yE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=AE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=zE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=rE(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=rE(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 11:{o=90;break b;break};case 7:{o=45;break b;break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 17:{break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=rE(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{o=78;break d;break};case 7:{o=84;break d;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 29:{o=75;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 17:{break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=BE(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function xE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=rE(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function yE(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[56848+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function zE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=rE(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=rE(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((CE(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=rE(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((CE(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function AE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=rE(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=rE(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function BE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=rE(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 6:{l=13;break a;break};case 14:{break};case 29:{if((c[54904+((d[56184+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=rE(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=rE(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 29:{if((c[54904+((d[54648+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=rE(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=rE(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 3:{t=sE(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=rE(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=rE(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 6:{l=100;break a;break};case 17:{l=107;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[54904+((d[54648+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function CE(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function DE(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=rE(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=rE(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function EE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=rE(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 24:case 22:{break};case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=rE(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=xE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function FE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=rE(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[54904+((d[54648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=rE(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 29:{if((c[54904+((d[56184+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function GE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 30:{k=YE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 13:{k=gF(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{n=25;break};case 29:{g=b;if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;n=77;break a}if((c[54904+((d[56184+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;o=19;n=77;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=rE(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=rE(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{k=cF(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=hF(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;n=77;break};case 12:{k=gF(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=iF(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;n=77;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=rE(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=rE(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{n=116;break b;break};case 7:{n=91;break b;break};case 33:{n=119;break b;break};case 15:{n=122;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=rE(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 7:{n=111;break b;break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 6:{n=108;break b;break};case 5:{n=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 5:{n=85;break b;break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 6:{n=88;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function HE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=XE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=rE(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=$E(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=rE(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function IE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=rE(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=rE(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function JE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=rE(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function KE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=rE(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=XE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=rE(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function LE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=rE(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 10:{n=18;break a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=XE(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=YE(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=rE(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ME(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=rE(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};case 5:{break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=rE(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function NE(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function OE(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=rE(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function PE(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=rE(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function QE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=rE(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=rE(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function RE(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=FD(c)|0;k=j;i=b;return k|0}function SE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function TE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=rE(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=rE(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function UE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=rE(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function VE(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function WE(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function XE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=ZE(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=rE(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function YE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[54904+((d[54648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=rE(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[54904+((d[56184+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function ZE(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=_E(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=rE(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=rE(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function _E(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=rE(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=rE(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}



function WL(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rH(9,0,103200,z);z=eI(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;vH(C,103240,y)}rH(9,0,103280,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=fI(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=$L(c[d+(C*112|0)+4>>2]|0)|0;E=fI(A,D)|0;caa(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((Caa(E,103320,6)|0)==0){if((c[63588>>2]|0)==0){break}}else{D=Caa(E,103328,6)|0;if((c[63588>>2]|D|0)==0){break}}c[v>>2]=E;tH(9,0,103336,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;lI(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(9,0,103304,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}rH(9,0,103392,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=fI(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=$L(c[G+(w*112|0)+4>>2]|0)|0;v=fI(A,F)|0;caa(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];tH(9,0,103416,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;lI(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];rH(9,0,103304,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}rH(9,0,103472,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=fI(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=$L(c[t+(x*112|0)+4>>2]|0)|0;K=fI(A,C)|0;caa(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];tH(9,0,103416,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;lI(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rH(9,0,103304,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}rH(9,0,103496,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=fI(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=$L(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=fI(A,u)|0;caa(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];tH(9,0,103544,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;lI(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;rH(9,0,103528,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}rH(9,0,103600,l);l=b+144|0;if((c[l>>2]|0)<=0){cI(A);i=f;return}o=b+32|0;b=0;do{x=fI(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=$L(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=fI(A,n)|0;caa(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];tH(9,0,103648,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;lI(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?101592:101600;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;rH(9,0,103632,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));cI(A);i=f;return}function XL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;eK(a,+h[a+240>>3]);tK(a);yK(a);oK(a);AK(a);IL(a);pK(a);tK(a);e=ZL(a,b,c)|0;yK(a);oK(a);uK(a);yK(a);i=d;return e|0}function YL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;eK(b,+h[b+240>>3]);tK(b);yK(b);KL(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=daa(c[y>>2]|0,8)|0;A=b+124|0;B=daa(c[A>>2]|0,4)|0;C=b+128|0;D=daa(c[C>>2]|0,1)|0;E=b+132|0;F=daa(c[E>>2]|0,4)|0;G=b+536|0;uH(c[G>>2]|0,(z|0)!=0|0,102072,t);uH(c[G>>2]|0,(B|0)!=0|0,102072,s);uH(c[G>>2]|0,(D|0)!=0|0,102072,r);uH(c[G>>2]|0,(F|0)!=0|0,102072,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[63588>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];lc(x|0,102088,p|0)|0;p=mc(x|0,102104)|0;c[o>>2]=102120;Bd(p|0,102112,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];Bd(p|0,102112,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Zd(10,p|0)|0;H=p}rH(9,1,102128,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;pe[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(9,0,102152,l);if((c[63588>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(H|0,102176,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Bd(H|0,102176,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Zd(10,H|0)|0}if((hL(b,0)|0)!=0){break a}if((ZK(b,0)|0)!=0){break a}if((OK(b,0)|0)!=0){break a}BK(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);me[c[16026]&255](9);if((c[63588>>2]|0)!=0){cd(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}caa(z);caa(B);caa(D);caa(F)}else{h[b+304>>3]=1.0;pe[c[w+80>>2]&127](b)|0}qK(b);if((KL(b,1,1)|0)!=1){i=e;return}pe[c[(c[v>>2]|0)+80>>2]&127](b)|0;qK(b);if((KL(b,1,1)|0)!=1){i=e;return}tH(1,0,102184,f);i=e;return}function ZL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=aM(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){rH(9,0,102288,u);if((c[b+184>>2]|0)==0){Ee[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}caa(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){rH(9,0,102320,t);Ee[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;caa(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){rH(9,1,102392,s);t=baa(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+SL(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+SL(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}rH(9,1,102416,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];rH(9,0,102440,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];rH(9,0,102440,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];rH(9,0,102440,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[63588>>2]|0)!=0){me[c[16026]&255](9);me[c[16026]&255](9)}caa(t);bM(v);H=aM(b)|0;if((c[H>>2]|0)!=0){$=H;break}rH(9,0,102464,n);caa(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}rH(9,0,102496,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){rH(9,0,102512,l);_L($,d,1,e);TL(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+SL($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){caa(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){caa(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){caa(v);c[l>>2]=0}_L($,d,0,e);TL(b,$);+SL($,1.0)}else{rH(9,0,102536,j)}rH(9,1,102560,g);TL(b,$);b=RL($)|0;if((c[63588>>2]|0)!=0){me[c[16026]&255](9)}bM($);y=b;i=f;return y|0}function _L(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=baa(c[p>>2]<<3)|0;r=q;s=+SL(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;dM(a,r);caa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=102688;F=E;rH(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;rH(9,0,102600,m);if(!t){cM(a)}switch(b|0){case 1:{G=kM(a)|0;break};case 4:{H=12;break a;break};case 6:{H=14;break a;break};case 5:{H=13;break a;break};case 2:{G=iM(a)|0;break};case 3:{G=mM(a,n,e)|0;break};default:{H=15;break a}}yK(o);oK(o);uK(o);yK(o);s=+SL(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}rH(9,0,102648,k);TL(o,a);K=s}else{rH(9,0,102664,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){hM(a)|0}else if((H|0)==13){hM(a)|0}else if((H|0)==14){gM(o,a,0)|0}else if((H|0)==15){vH(c[o+536>>2]|0,102624,l)}else if((H|0)==23){dM(a,r);caa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=102688;F=E;rH(9,0,F,g);i=f;return}}function $L(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=Faa(b|0)|0;do{if((d|0)==0){e=baa(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=baa(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((Aaa(e,103704,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;Haa(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((Aaa(e,103704,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function aM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=baa(64)|0;z=y;uH(0,(y|0)!=0|0,103712,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=daa(Z,8)|0;c[E>>2]=y;uH(0,(y|0)!=0|0,103712,w);w=daa(Z,8)|0;c[F>>2]=w;uH(0,(w|0)!=0|0,103712,v);v=daa(Z,8)|0;c[G>>2]=v;uH(0,(v|0)!=0|0,103712,u);u=daa(Z,8)|0;c[H>>2]=u;uH(0,(u|0)!=0|0,103712,t);t=daa(Z,8)|0;c[I>>2]=t;uH(0,(t|0)!=0|0,103712,s);s=daa(Z,4)|0;t=s;c[J>>2]=t;uH(0,(s|0)!=0|0,103712,r);rH(9,0,103728,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;rH(9,0,103752,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rH(9,0,103840,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];rH(9,0,103888,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];rH(9,0,103944,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;rH(9,0,104e3,l);c[j>>2]=ya;rH(9,0,104072,j);j=daa(sa,8)|0;c[K>>2]=j;uH(0,(j|0)!=0|0,103712,g);g=baa(sa<<3)|0;c[L>>2]=g;uH(0,(g|0)!=0|0,103712,f);f=baa(ya<<3)|0;c[M>>2]=f;uH(0,(f|0)!=0|0,103712,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function bM(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){caa(d)}d=c[a+28>>2]|0;if((d|0)!=0){caa(d)}d=c[a+32>>2]|0;if((d|0)!=0){caa(d)}d=c[a+36>>2]|0;if((d|0)!=0){caa(d)}d=c[a+40>>2]|0;if((d|0)!=0){caa(d)}d=c[a+44>>2]|0;if((d|0)!=0){caa(d)}d=c[a+48>>2]|0;if((d|0)!=0){caa(d)}d=c[a+52>>2]|0;if((d|0)!=0){caa(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;caa(e);i=b;return}caa(d);e=a;caa(e);i=b;return}function cM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=daa(o,8)|0;q=daa(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=daa(s,8)|0;u=daa(s,8)|0;v=daa(o,8)|0;w=daa(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+SL(b,1.0);s=c[n>>2]|0;if((s|0)>0){Haa(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+SL(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){Haa(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;rH(9,0,104112,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}caa(p);caa(q);caa(t);caa(u);caa(v);caa(w);i=d;return}function dM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function eM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function fM(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function gM(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;vH(c[a+536>>2]|0,104184,d);return 0}function hM(a){a=a|0;a=i;i=i+8|0;vH(0,104216,a);return 0}function iM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[63588>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=daa((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;uH(0,(n|0)!=0|0,104256,b);c[26068]=c[a+60>>2];c[26070]=c[a+48>>2];GJ(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;caa(n);c[26068]=0;c[26070]=0;n=RL(a)|0;i=b;return n|0}function jM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[26070];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[26068];h[d>>3]=+SL(f,1.0);i=e;return}function kM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=baa(x)|0;z=y;A=baa(x)|0;x=A;uH(0,(y|0)!=0|0,104288,n);uH(0,(A|0)!=0|0,104288,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[63588>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+SL(a,1.0);h[o>>3]=D;if(D!=0.0){c[26076]=c[a+60>>2];c[26078]=c[a+48>>2];DJ(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[26076]=0;c[26078]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rH(9,0,104320,l)}D=+SL(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rH(9,0,104424,j);j=c[u>>2]|0;do{if((j|0)==2){tH(9,0,104520,f);F=-2;i=b;return F|0}else if((j|0)==3){tH(9,0,104584,e);F=-3;i=b;return F|0}else if((j|0)==4){tH(9,0,104656,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];tH(9,0,104440,g);F=-1;i=b;return F|0}}while(0);F=RL(a)|0;i=b;return F|0}function lM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[26078];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[26076];h[d>>3]=+SL(f,1.0);i=e;return}function mM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;rH(9,1,104712,g);if((c[63588>>2]|0)==0){l=0}else{l=(k|0)/10|0}nM(a,d,k,l,b,j);c[f>>2]=c[j>>2];rH(9,0,104736,f);me[c[16026]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=RL(a)|0;if((b|0)==0){m=0;i=e;return m|0}tH(9,0,104752,e);m=b;i=e;return m|0}function nM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=baa(fa(N,M)|0)|0;P=baa(M<<3)|0;Q=baa(N)|0;R=Q;S=baa(N)|0;T=S;V=baa(N)|0;W=V;X=baa(N)|0;Y=+h[f>>3];if((c[63588>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];lc(N|0,104800,I|0)|0;I=mc(N|0,104816)|0;c[H>>2]=104832;Bd(I|0,104824,H|0)|0;c[G>>2]=104848;Bd(I|0,104824,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];Bd(I|0,104824,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Zd(10,I|0)|0;c[E>>2]=0;Bd(I|0,104856,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Bd(I|0,104864,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Bd(I|0,104864,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Zd(10,I|0)|0;Z=I}else{Z=0}uH(0,(O|0)!=0|0,104872,B);uH(0,(P|0)!=0|0,104872,A);uH(0,(Q|0)!=0|0,104872,z);uH(0,(S|0)!=0|0,104872,y);uH(0,(V|0)!=0|0,104872,x);uH(0,(X|0)!=0|0,104872,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{eM(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+SL(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;eM(a,la);+SL(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];rH(9,0,104888,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){Jaa(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);eM(a,R);za=+SL(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}Haa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}eM(a,T);if(+SL(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}Haa(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}Haa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}eM(a,W);Ba=+SL(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}eM(a,W);Ba=+SL(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}Haa(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rH(9,0,104928,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;Bd(Z|0,104856,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Bd(Z|0,104864,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Bd(Z|0,104864,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Zd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];tH(9,0,104976,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];tH(9,0,104992,p);vH(0,105008,o)}eM(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){caa(S);caa(Q);caa(V);caa(X);caa(P);caa(O);i=j;return}c[n>>2]=ia;Bd(Z|0,104856,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(Z|0,104864,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(Z|0,104864,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Zd(10,Z|0)|0;cd(Z|0)|0;caa(S);caa(Q);caa(V);caa(X);caa(P);caa(O);i=j;return}function oM(a,b){a=a|0;b=b|0;i=i;return}function pM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;KI(3);NI(0);w=+FI(0);KI(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(v|0,105088,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Bd(v|0,105088,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Bd(v|0,105088,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];Bd(v|0,105096,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;Bd(v|0,105096,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];Bd(v|0,105104,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Bd(v|0,105088,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Bd(v|0,105088,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;Bd(v|0,105096,l|0)|0;break}else{c[m>>2]=0-E;Bd(v|0,105096,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;Bd(v|0,105096,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;Bd(v|0,105096,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Zd(10,v|0)|0;NI(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];Bd(v|0,105104,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Zd(10,v|0)|0;NI(3);i=e;return}function qM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=mc(c[r>>2]|0,105112)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=be(c[(Sc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;uH(t,(s|0)!=0|0,105120,q);c[p>>2]=105176;Bd(s|0,105104,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=105184;Bd(s|0,105104,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];Bd(s|0,105104,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];Bd(s|0,105104,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];Bd(s|0,105104,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];Bd(s|0,105104,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];Bd(s|0,105104,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];Bd(s|0,105104,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];Bd(s|0,105104,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Zd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];Bd(s|0,105104,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Zd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function rM(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;KI(3);cd(d|0)|0;NI(3);i=b;return}function sM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;n2(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];o2(p,f)|0;tM(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;uM(a,b,105200,c[j>>2]|0,c[g>>2]|0,o,8);caa(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];o2(p,e)|0;i=d;return}function tM(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=daa(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;uH(c[b+536>>2]|0,(p|0)!=0|0,105480,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function uM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;FM(a,b,d,e,f,h);m2(l,g,fa(fa(f,e)|0,h)|0)|0;if(J0(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];vH(l,105432,k)}else{i=j;return}}function vM(a){a=a|0;var b=0;b=i;if((xN(a+4|0)|0)!=0){i=b;return}M0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function wM(a){a=a|0;Wc(a|0)|0;Ya()}function xM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=haa(320)|0;Jaa(q|0,0,320)|0;yM(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;KI(3);t=a+8|0;u=zM(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=AM(a,b,u+s|0)|0;u=q+184|0;BM(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;BM(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;CM(q,c[x>>2]|0,36);if(J0(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];vH(y,105256,e)}else{uM(a,b,105288,4,11,105208,1);DM((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;uM(a,b,105296,c[g>>2]|0,c[j>>2]|0,e,1);caa(e);c[f>>2]=0;DM((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;uM(a,b,105304,c[g>>2]|0,c[j>>2]|0,e,1);caa(e);c[f>>2]=0;EM(a,b,k,g,j,c[r>>2]|0,s);uM(a,b,105320,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;n2(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];tM(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;uM(a,b,105200,c[j>>2]|0,c[g>>2]|0,n,8);n2(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=GM(q+240|0)|0;w=GM(q+264|0)|0;p=GM(q+288|0)|0;FM(a,b,105336,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);caa(n);caa(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;U1(s)|0;caa(v);NI(3);i=d;return}}function yM(a){a=a|0;var b=0;b=i;HP(a);i=b;return}function zM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(LO(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(LO(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(LO(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function AM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=baa(e<<2)|0;e=l;c[l>>2]=105888;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=105928;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(LO(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(LO(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(LO(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function BM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;wN(a,b,c);i=d;return}function CM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(vN(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){M0(d,4);i=e;return}else{K0(d,0);i=e;return}}function DM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=Faa(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=daa((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;uH(0,(o|0)!=0|0,105408,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;Qaa(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;KM(q,Faa(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=daa(1,1)|0;c[d>>2]=q;uH(0,(q|0)!=0|0,105408,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function EM(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=daa(c[f>>2]<<2,4)|0;c[e>>2]=g;uH(c[d+536>>2]|0,(g|0)!=0|0,105456,k);g=s+240|0;f=GM(g)|0;h=s+264|0;t=GM(h)|0;u=s+288|0;v=GM(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=GM(g)|0;D=GM(h)|0;E=GM(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){LM(l,b,A+(v*52|0)+4|0);NM(n,b);if(!(MM(l,n)|0)){F=w;break}G=(c[(OM(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else if(z<<24>>24==0){LM(l,g,A+(v*52|0)+4|0);NM(m,g);if(!(MM(l,m)|0)){F=w;break}G=(c[(OM(l)|0)+4>>2]|0)+1|0;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){LM(l,v,G+(t*52|0)+4|0);NM(p,v);J=(MM(l,p)|0)&1}else if(f<<24>>24==0){LM(l,h,G+(t*52|0)+4|0);NM(o,h);f=MM(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(OM(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){LM(l,d,y+(t*52|0)+4|0);NM(r,d);M=(MM(l,r)|0)&1}else if(x<<24>>24==0){LM(l,u,y+(t*52|0)+4|0);NM(q,u);x=MM(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(OM(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function FM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(Faa(d|0)|0)+1;e=m;m2(e,l,20)|0;if(J0(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];vH(l,105432,k)}m2(e,d,c[f>>2]|0)|0;if(J0(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];vH(m,105432,j)}else{i=h;return}}function GM(a){a=a|0;var b=0,d=0;b=i;d=c[(sN(a)|0)>>2]|0;i=b;return d|0}function HM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;KI(3);do{if(I0(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];o2(k,e)|0;k=GM(h+240|0)|0;m=GM(h+264|0)|0;l=GM(h+288|0)|0;FM(a,b,105336,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);vM(h)}else{if((h|0)!=0){break}c[g>>2]=0;NI(3);i=d;return}}while(0);IM(j);jaa(h);c[g>>2]=0;NI(3);i=d;return}function IM(a){a=a|0;var b=0;b=i;QN(a);i=b;return}function JM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;KI(3);NI(0);h[j>>3]=+FI(0);KI(0);l=k;m=d+4|0;m2(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){m2(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){m2(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);m2(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);m2(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);m2(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(J0(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];vH(t,105376,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;NI(3);i=e;return}}function KM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((Caa(b,105592,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((Caa(b,105592,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function LM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;eN(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];WM(a,f);i=e;return}function MM(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=UM(a,b)|0;i=c;return d|0}function NM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;XM(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];WM(a,e);i=d;return}function OM(a){a=a|0;var b=0,c=0;b=i;c=PM(QM(a)|0)|0;i=b;return c|0}function PM(a){a=a|0;var b=0,c=0;b=i;c=TM(a)|0;i=b;return c|0}function QM(a){a=a|0;var b=0,d=0;b=i;d=RM((c[a>>2]|0)+16|0)|0;i=b;return d|0}function RM(a){a=a|0;var b=0,c=0;b=i;c=SM(a)|0;i=b;return c|0}function SM(a){a=a|0;i=i;return a|0}function TM(a){a=a|0;i=i;return a|0}function UM(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(VM(a,b)|0)^1;i=c;return d|0}function VM(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function WM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];dN(a,e);i=d;return}function XM(a,b){a=a|0;b=b|0;var c=0;c=i;YM(a,ZM(b)|0);i=c;return}function YM(a,b){a=a|0;b=b|0;var c=0;c=i;cN(a,b);i=c;return}function ZM(a){a=a|0;var b=0,c=0;b=i;c=_M($M(a+4|0)|0)|0;i=b;return c|0}function _M(a){a=a|0;var b=0,c=0;b=i;c=bN(a)|0;i=b;return c|0}function $M(a){a=a|0;var b=0,c=0;b=i;c=aN(a)|0;i=b;return c|0}function aN(a){a=a|0;i=i;return a|0}function bN(a){a=a|0;i=i;return a|0}function cN(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dN(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function eN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=gN(b)|0;fN(f,b,d,h,ZM(b)|0);XM(g,b);do{if(UM(f,g)|0){h=hN(b)|0;if(iN(h,d,jN(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);XM(a,b);i=e;return}function fN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;nN(h);a:do{if((e|0)==0){j=f}else{k=hN(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(oN(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;nN(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;nN(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);YM(a,j);i=g;return}function gN(a){a=a|0;var b=0,d=0;b=i;d=c[(ZM(a)|0)>>2]|0;i=b;return d|0}function hN(a){a=a|0;var b=0,c=0;b=i;c=lN(a+8|0)|0;i=b;return c|0}function iN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kN(0,b,c)|0;i=a;return d|0}function jN(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function kN(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function lN(a){a=a|0;var b=0,c=0;b=i;c=mN(a)|0;i=b;return c|0}function mN(a){a=a|0;i=i;return a|0}function nN(a){a=a|0;var b=0;b=i;pN(a,-1);i=b;return}function oN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=kN(0,b,c)|0;i=a;return d|0}function pN(a,b){a=a|0;b=b|0;b=i;qN(a,0);i=b;return}function qN(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function rN(a){a=a|0;i=i;return c[a+4>>2]|0}function sN(a){a=a|0;var b=0,c=0;b=i;c=tN(a+8|0)|0;i=b;return c|0}function tN(a){a=a|0;var b=0,c=0;b=i;c=uN(a)|0;i=b;return c|0}function uN(a){a=a|0;i=i;return a|0}function vN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 28:{h=105568;break};case 13:case 29:{h=105584;break};case 56:{h=105528;break};case 12:{h=105560;break};case 48:case 16:{h=105496;break};case 1:case 17:{h=105504;break};case 9:case 25:{h=105536;break};case 52:case 20:{h=105544;break};case 8:{h=105512;break};case 24:{h=105520;break};case 60:{h=105576;break};case 5:case 21:{h=105552;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=mc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if(($c(j|0,0,2)|0)==0){g=a;i=e;return g|0}cd(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function wN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function xN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}yN(d,f,102);f=pe[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((cd(zN(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}AN(d);g=h;i=b;return g|0}function yN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;HN(a,b,c);i=d;return}function zN(a){a=a|0;var b=0,d=0;b=i;d=DN(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function AN(a){a=a|0;var b=0;b=i;BN(a);i=b;return}function BN(a){a=a|0;var b=0;b=i;CN(a,0);i=b;return}function CN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=DN(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}pe[c[(EN(e)|0)>>2]&127](f)|0;i=d;return}function DN(a){a=a|0;var b=0,c=0;b=i;c=GN(a)|0;i=b;return c|0}function EN(a){a=a|0;var b=0,c=0;b=i;c=FN(a)|0;i=b;return c|0}function FN(a){a=a|0;i=i;return a+4|0}function GN(a){a=a|0;i=i;return a|0}function HN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(JN(f)|0)>>2]|0;IN(a,d,c[(KN(g)|0)>>2]|0);i=e;return}function IN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;LN(a,b,c);i=d;return}function JN(a){a=a|0;i=i;return a|0}function KN(a){a=a|0;i=i;return a|0}function LN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(NN(f)|0)>>2]|0;MN(a,d,c[(ON(g)|0)>>2]|0);i=e;return}function MN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(NN(f)|0)>>2];c[a+4>>2]=c[(ON(g)|0)>>2];i=e;return}function NN(a){a=a|0;i=i;return a|0}function ON(a){a=a|0;i=i;return a|0}function PN(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function QN(a){a=a|0;var b=0;b=i;RN(a+300|0);RN(a+288|0);RN(a+276|0);RN(a+264|0);RN(a+252|0);RN(a+240|0);SN(a);i=b;return}function RN(a){a=a|0;var b=0;b=i;CO(a);i=b;return}function SN(a){a=a|0;var b=0;b=i;TN(a,105640);Q0(a+104|0);i=b;return}function TN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];XN(a+4|0);i=d;return}function UN(a){a=a|0;var b=0;b=i;SN(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function VN(a){a=a|0;var b=0;b=i;SN(a);jaa(a);i=b;return}function WN(a){a=a|0;var b=0;b=i;VN(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function XN(a){a=a|0;var b=0;b=i;YN(a);i=b;return}function YN(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=105768;xN(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}kaa(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}kaa(e)}}while(0);Z0(b);i=d;return}function ZN(a){a=a|0;var b=0;b=i;XN(a);jaa(a);i=b;return}function _N(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;pe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=AO(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=BO(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;h1(h,0,0,0);m1(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}kaa(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=iaa(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=iaa(h)|0;a[b+97|0]=1;i=e;return}function $N(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;h1(e,0,0,0);m1(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}kaa(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}kaa(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=iaa(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(xO(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=iaa(o)|0;a[k]=1;i=f;return e|0}return 0}function aO(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Jc(4)|0;I9(n);_d(n|0,153160,128)}n=tO(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((pe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){BM(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Yaa(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if(($c(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;BM(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];wO(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{BM(a,-1,-1);i=g;return}}}while(0);BM(a,-1,-1);i=g;return}function bO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((pe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=PN(d)|0;if(($c(j|0,k|0,0)|0)==0){vO(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{BM(a,-1,-1);i=e;return}}}while(0);BM(a,-1,-1);i=e;return}function cO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Jc(4)|0;I9(m);_d(m|0,153160,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=tO(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=f1(s)|0;u=(fa(t-(e1(s)|0)|0,p)|0)+r|0;v=0;break}p=e1(s)|0;if((p|0)==(f1(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=uO(t,g,x,o,p-(d1(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=f1(w)|0;u=q-(e1(w)|0)|0;v=0}}while(0);if(($c(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;h1(b,0,0,0);c[m>>2]=0}else{q=b;y=j1(q)|0;do{if((y|0)!=(i1(q)|0)){if((Ee[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=sO(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((wc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((zd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function dO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=nO(b)|0;o=b;if((e1(o)|0)==0){p=e+1|0;h1(o,e,p,p)}if(n){q=0}else{n=f1(o)|0;c[f>>2]=(n-(d1(o)|0)|0)/2|0;c[g>>2]=4;q=c[(oO(f,g)|0)>>2]|0}g=e1(o)|0;do{if((g|0)==(f1(o)|0)){Iaa(d1(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=f1(o)|0;n=d1(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=d1(o)|0;h1(o,n,n+q|0,n+(p+q)|0);r=lO(a[e1(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;Iaa(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(oO(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Jc(4)|0;I9(t);_d(t|0,153160,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=d1(o)|0;if((pO(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;h1(o,f,f,c[s>>2]|0);r=lO(a[e1(o)|0]|0)|0;break}s=c[k>>2]|0;f=d1(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}h1(o,f,p,s);r=lO(a[e1(o)|0]|0)|0}else{r=lO(a[g]|0)|0}}while(0);if((d1(o)|0)!=(e|0)){m=r;i=d;return m|0}h1(o,0,0,0);m=r;i=d;return m|0}function eO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=d1(g)|0;j=e1(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(hO(d,-1)|0){g1(g,-1);f=kO(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=iO(d)|0;do{if(h){if(mO(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);g1(g,-1);a[e1(g)|0]=b;f=d;i=e;return f|0}function fO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}gO(b);l=b;m=i1(l)|0;n=k1(l)|0;if(!(hO(d,-1)|0)){if((j1(l)|0)==0){m1(l,f,f+1|0)}f=iO(d)|0;a[j1(l)|0]=f;l1(l,1)}f=j1(l)|0;o=i1(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=i1(l)|0;A=j1(l)|0;B=jO(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=i1(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((wc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;m1(l,B,j1(l)|0);B=k1(l)|0;l1(l,B-(i1(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Jc(4)|0;u=t;I9(u);v=153160;w=128;_d(t|0,v|0,w|0)}else if((D|0)==14){q=(j1(l)|0)-C|0;if((wc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((wc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);m1(l,m,n)}k=kO(d)|0;i=e;return k|0}function gO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;h1(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;m1(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;m1(f,h,h+(g+ -1)|0);break}}else{m1(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function hO(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function iO(a){a=a|0;i=i;return a&255|0}function jO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ne[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function kO(a){a=a|0;var b=0,c=0;b=i;c=hO(a,-1)|0;i=b;return(c?0:a)|0}function lO(a){a=a|0;i=i;return a&255|0}function mO(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function nO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;m1(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;h1(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;h1(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function oO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=qO(b,c,e)|0;i=d;return g|0}function pO(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ne[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function qO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=rO(0,b,a)|0;i=c;return(d?b:a)|0}function rO(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function sO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Fe[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function tO(a){a=a|0;var b=0,d=0;b=i;d=pe[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function uO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Fe[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function vO(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function wO(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function xO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=yO(b,c,e)|0;i=d;return g|0}function yO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=zO(0,a,b)|0;i=c;return(d?b:a)|0}function zO(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function AO(a){a=a|0;var b=0,c=0;b=i;c=I6(a,137664)|0;i=b;return c|0}function BO(a){a=a|0;var b=0,d=0;b=i;d=pe[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function CO(a){a=a|0;var b=0;b=i;DO(a);i=b;return}function DO(a){a=a|0;var b=0;b=i;EO(a);i=b;return}function EO(a){a=a|0;var b=0;b=i;FO(a,gN(a)|0);i=b;return}function FO(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;nN(d);if((b|0)==0){i=d;return}FO(a,c[b>>2]|0);FO(a,c[b+4>>2]|0);HO(GO(a)|0,b,1);i=d;return}function GO(a){a=a|0;var b=0,c=0;b=i;c=JO(a+4|0)|0;i=b;return c|0}function HO(a,b,c){a=a|0;b=b|0;c=c|0;c=i;IO(0,b,0);i=c;return}function IO(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jaa(b);i=c;return}function JO(a){a=a|0;var b=0,c=0;b=i;c=KO(a)|0;i=b;return c|0}function KO(a){a=a|0;i=i;return a|0}function LO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=MO(a,f,b)|0;l=c[k>>2]|0;nN(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}OO(j,a,b);PO(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];NO(g,e);QO(j);j=c[f>>2]|0;RO(a,j,k,SO(g)|0);k=TO(g)|0;QO(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function MO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=gN(h)|0;nN(e);if((a|0)==0){j=ZM(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kN(0,d,a)|0){m=l;j=c[m>>2]|0;nN(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kN(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;nN(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function NO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];FP(a,e);i=d;return}function OO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=GO(d)|0;d=oP(n,1)|0;pP(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];nP(j,d,h);qP(0,jP((rP(j)|0)+16|0)|0,e);e=sP(j)|0;a[e+4|0]=1;tP(0,iP((rP(j)|0)+20|0)|0);a[e+5|0]=1;uP(m,j);PO(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];NO(b,g);QO(m);QO(j);i=f;return}function PO(a,b){a=a|0;b=b|0;var c=0;c=i;lP(a,b);i=c;return}function QO(a){a=a|0;var b=0;b=i;eP(a);i=b;return}function RO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;nN(f);c[e>>2]=0;nN(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=YO(a)|0;b=c[c[e>>2]>>2]|0;nN(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(ZM(a)|0)>>2]|0;ZO(e,c[d>>2]|0);d=_O(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function SO(a){a=a|0;var b=0,d=0;b=i;d=c[(WO(a)|0)>>2]|0;i=b;return d|0}function TO(a){a=a|0;var b=0,d=0;b=i;d=UO(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function UO(a){a=a|0;var b=0,c=0;b=i;c=VO(a)|0;i=b;return c|0}function VO(a){a=a|0;i=i;return a|0}function WO(a){a=a|0;var b=0,c=0;b=i;c=XO(a)|0;i=b;return c|0}function XO(a){a=a|0;i=i;return a|0}function YO(a){a=a|0;i=i;return a|0}function ZO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=bP(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;nN(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;nN(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(bP(j)|0){p=j}else{o=c[k>>2]|0;cP(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;dP(p);i=e;return}else if((l|0)==14){if(bP(j)|0){p=c[k>>2]|0;dP(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;cP(q);i=e;return}else if((l|0)==17){i=e;return}}function _O(a){a=a|0;var b=0,c=0;b=i;c=$O(a+8|0)|0;i=b;return c|0}function $O(a){a=a|0;var b=0,c=0;b=i;c=aP(a)|0;i=b;return c|0}function aP(a){a=a|0;i=i;return a|0}function bP(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function cP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;nN(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=bP(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function dP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;nN(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=bP(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function eP(a){a=a|0;var b=0;b=i;fP(a,0);i=b;return}function fP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=UO(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}hP(gP(e)|0,f);i=d;return}function gP(a){a=a|0;var b=0,c=0;b=i;c=kP(a)|0;i=b;return c|0}function hP(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}HO(c[a>>2]|0,b,1);i=d;return}function iP(a){a=a|0;i=i;return a|0}function jP(a){a=a|0;i=i;return a|0}function kP(a){a=a|0;i=i;return a+4|0}function lP(a,b){a=a|0;b=b|0;var c=0;c=i;mP(a,b);i=c;return}function mP(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function nP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];xP(a,b,f);i=e;return}function oP(a,b){a=a|0;b=b|0;var c=0;a=i;c=wP(0,b,0)|0;i=a;return c|0}function pP(a,b){a=a|0;b=b|0;var c=0;c=i;vP(a,b);i=c;return}function qP(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function rP(a){a=a|0;var b=0,d=0;b=i;d=c[(WO(a)|0)>>2]|0;i=b;return d|0}function sP(a){a=a|0;var b=0,c=0;b=i;c=gP(a)|0;i=b;return c|0}function tP(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function uP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;lP(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];NO(h,f);PO(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];NO(a,e);QO(h);i=d;return}function vP(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function wP(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=haa(b*24|0)|0;i=c;return a|0}function xP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(zP(g)|0)>>2]|0;g=AP(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];yP(b,a,f);i=e;return}function yP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BP(a,b,f);i=e;return}function zP(a){a=a|0;i=i;return a|0}function AP(a){a=a|0;i=i;return a|0}function BP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(DP(g)|0)>>2]|0;g=EP(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CP(b,a,f);i=e;return}function CP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(DP(f)|0)>>2];f=EP(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function DP(a){a=a|0;i=i;return a|0}function EP(a){a=a|0;i=i;return a|0}function FP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=TO(GP(b)|0)|0;h=EP(sP(GP(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];yP(g,a,e);i=d;return}function GP(a){a=a|0;i=i;return c[a>>2]|0}function HP(a){a=a|0;var b=0;b=i;i=i+48|0;IP(a);BM(a+184|0,0,0);BM(a+200|0,0,0);JP(a+240|0,b);JP(a+252|0,b+8|0);JP(a+264|0,b+16|0);JP(a+276|0,b+24|0);JP(a+288|0,b+32|0);JP(a+300|0,b+40|0);i=b;return}function IP(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;V0(d);e=a;c[e>>2]=105612;f=d;c[f>>2]=105632;d=a+4|0;a2(a,105644|0,d);c[e>>2]=105612;c[f>>2]=105632;WP(d);i=b;return}function JP(a,b){a=a|0;b=b|0;b=i;KP(a,0);i=b;return}function KP(a,b){a=a|0;b=b|0;b=i;i=i+8|0;LP(a,b);i=b;return}function LP(a,b){a=a|0;b=b|0;b=i;MP(a,0);i=b;return}function MP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;NP(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;OP(f,0,e);e=ZM(b)|0;c[(YO(b)|0)>>2]=e;i=d;return}function NP(a){a=a|0;var b=0;b=i;SP(a);i=b;return}function OP(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;PP(b,c,f);i=e;return}function PP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(RP(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;QP(d,b,f);i=e;return}function QP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(RP(e)|0)>>2];i=d;return}function RP(a){a=a|0;i=i;return a|0}function SP(a){a=a|0;var b=0;b=i;TP(a);i=b;return}function TP(a){a=a|0;var b=0;b=i;UP(a);i=b;return}function UP(a){a=a|0;var b=0;b=i;VP(a);i=b;return}function VP(a){a=a|0;c[a>>2]=0;i=i;return}function WP(a){a=a|0;var b=0;b=i;XP(a);i=b;return}function XP(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;c1(j);c[d>>2]=105768;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;nN(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;_0(g,j);l=YP(g)|0;G6(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=se[r&63](d,0,4096)|0;i=e;return}_0(h,j);c[k>>2]=AO(h)|0;G6(h);a[f]=(BO(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=se[r&63](d,0,4096)|0;i=e;return}function YP(a){a=a|0;var b=0,c=0;b=i;c=H6(a,137664)|0;i=b;return c|0}function ZP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;KI(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){_P(a,b,c[f>>2]|0,h);NI(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=eaa(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;vH(k,106040,e)}_P(a,b,l,h);NI(3);i=d;return}



function HJ(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[11306]=.5;h[11297]=1.0;h[11337]=.1;F=(c[a>>2]|0)+1|0;c[22590]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[22582]=H;I=(c[b>>2]|0)-F|0;c[22636]=I;F=c[j>>2]|0;c[22690]=(F|0)<1?1:F;F=c[a>>2]|0;c[22574]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[22576]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[22576]=J+1}L=c[u>>2]|0;c[22572]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[22572]=L+1}K=j+1|0;c[22574]=K;if((j|0)<(F|0)){j=K}else{break}}}c[22578]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[22578]=H+1}H=c[b>>2]|0;c[22576]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[22574]=M;c[22576]=H+1}N=+h[e>>3];O=N*N;h[11342]=O;h[11328]=+h[11297]/O;h[11329]=+V(+(+h[11306]))/O;c[22580]=0;H=y;y=A;M=0;a:while(1){c[22592]=M;F=M-(c[a>>2]|0)|0;c[22616]=F;j=M+1|0;c[22580]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[22666]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[22604]=L;K=L+G|0;c[22602]=K;if((K|0)>(c[a>>2]|0)){c[22666]=L;G=K-(c[a>>2]|0)|0;c[22604]=G;c[22602]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[11319]=O;L=c[22590]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[11319]=N;R=N}else{R=O}O=+h[e>>3];h[11320]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[11320]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[11320];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[22574]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[22574]=S+1}if((M|0)>=(c[22690]|0)){T=j;U=159;break}while(1){se[H&63](a,d,90280)|0;if((c[g>>2]|0)==3){G_(90808)|0;XZ(90976,90320,4)|0;XZ(90976,90280,8)|0;I=c[a>>2]|0;c[22572]=1;if((I|0)>=1){F=1;do{XZ(90976,d+(F+ -1<<3)|0,8)|0;L=c[22572]|0;F=L+1|0;c[22572]=F;}while((L|0)<(I|0))}o_()|0}I=c[22580]|0;do{if((I|0)>(c[b>>2]|0)){F=c[22620]|0;if((F|0)==-1){break a}h[11338]=0.0;c[22578]=0;L=c[a>>2]|0;c[22574]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[11338]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[11311]=N;if((X|0)==(G|0)){ea=N*+h[11306];h[11311]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[11338]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[22578]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[22572]=Y;c[22574]=L+1;W=Z}J=c[b>>2]|0;c[22576]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[11338]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[22576]=J+1;ia=ja}O=+h[11285];ba=+h[11314];N=O-ba-ia;h[11305]=N;h[11324]=+h[11323];h[11323]=+h[11322];if(!(N>=0.0)){ka=-N}else{ka=N}h[11322]=ka;if(+h[11334]>+h[11300]){c[22664]=I}h[11330]=ba;do{if(O<ba){h[11314]=O;h[11347]=0.0;G=c[a>>2]|0;c[22572]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[11347]=+h[11347]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[22572]=G+1;h[A>>3]=ma}}while(0);c[22662]=F;if((F|0)<=0){O=+h[11338];if(O>=0.0){U=190;break a}ba=+h[11285];N=+h[11330];ea=(ba-N)/O;h[11335]=ea;O=+h[11337];do{if(!(ea<=O)){na=+h[11306]*+h[11327];h[A>>3]=na;oa=+h[11334];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[11327]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[11327]=qa;ra=qa;break}}else{qa=+h[11306]*+h[11334];h[11327]=qa;ra=qa}}while(0);ea=+h[11300];if(!(ra<=ea*1.5)){sa=ra}else{h[11327]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[11342]=ea;c[22678]=0;h[11343]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[22634]|0;c[22678]=J;oa=+h[11297];h[11343]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[22576]=1;if((J|0)<1){va=F}else{L=c[22636]|0;oa=ua;K=1;ca=F;while(1){h[11325]=0.0;c[22574]=1;if((L|0)<1){wa=0.0}else{X=c[22596]|0;aa=K+C|0;qa=+h[11297];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[11311]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[11325]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[22574]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[11307]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[11311]=za;h[11346]=0.0;$=c[a>>2]|0;c[22574]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[11346]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[22574]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[11311]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[11343]=Fa;c[22620]=K;Ga=Fa;Ha=K}aa=K+1|0;c[22576]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}NJ(a,b,s,t,90384,u,w,90456,90480,x)|0;ca=c[22620]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[11285];c[22578]=0;J=c[a>>2]|0;c[22572]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[11311]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[11311];G=G+1|0;da=da+1|0}da=X+aa|0;c[22578]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[22574]=La;c[22572]=J+1}h[L>>3]=0.0;X=c[22636]|0;c[22574]=1;aa=(X|0)<1;if(!aa){F=c[22596]|0;K=1;while(1){da=fa(K,B)|0;O=+h[11305]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[11311]=Oa;G=c[b>>2]|0;c[22576]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[11311];$=$+1|0}c[22576]=G+1}$=K+1|0;c[22574]=$;if((K|0)<(X|0)){K=$}else{break}}}h[11316]=0.0;K=c[a>>2]|0;c[22572]=1;if((K|0)>=1){F=1;while(1){O=+h[11305]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[11316]=+h[11316]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[22572]=K+1;h[A>>3]=Pa}F=c[22662]|0;do{if((F|0)==0){if(!(+h[11327]==+h[11300])){break}O=+h[11335];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[22682]=0;break}L=c[b>>2]|0;c[22576]=1;if((L|0)>=1){J=o+((c[22634]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[22576]=L+1}h[11309]=0.0;$=c[a>>2]|0;c[22572]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[11303]=0.0;G=c[b>>2]|0;c[22576]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[11303]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[22576]=G+1;Sa=Ta}h[11309]=+h[11309]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[22572]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[11309]*100.0}J=c[22682]|0;c[22682]=J+1;if(+h[11316]<Ra){c[22682]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[22572]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[22572]=J+1}$=c[22582]|0;c[22578]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[22578]=$+1}c[22574]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[22576]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[22576]=Na+1;Ua=Wa}if((L|0)<(c[22596]|0)){h[J>>3]=-Ua}Va=L+1|0;c[22574]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[22576]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[22574]=Xa;c[22576]=L+1}c[22682]=0}}while(0);O=+h[11285];ea=+h[11330];if(O<ea){c[22634]=ca}oa=+h[11337];if(O<=ea+oa*+h[11338]|(F|0)>0){U=54;break}c[22620]=0;Ia=0;Ja=+h[11327];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[11285];oa=+h[11285];do{if((I|0)==1){h[11304]=oa;h[11314]=oa;c[22634]=1;Ya=1}else{if(!(oa<+h[11314])){Ya=I;break}h[11314]=oa;c[22634]=I;Ya=I}}while(0);F=c[22592]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[22602]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[22604]|0;Va=K+aa|0;c[22578]=Va;if(+h[11319]<0.0){aa=X+(c[a>>2]|0)|0;c[22602]=aa;Za=aa}else{Za=X}if(+h[11320]<0.0){X=K+(c[a>>2]|0)|0;c[22604]=X;_a=X}else{_a=K}K=fa(c[22616]|0,B)|0;h[t+(K-B<<3)>>3]=+h[11328];h[t+(Ya+C+K<<3)>>3]=+h[11328];h[t+(Za-B+K<<3)>>3]=-+h[11328];h[t+(_a-B+K<<3)>>3]=-+h[11328];h[q+(Va+ -1<<3)>>3]=(+h[11304]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[11285])/(+h[11319]*+h[11320])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[22616]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[11306]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[11306]/+h[e>>3];ea=+h[11329];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[11329];h[t+(X+K<<3)>>3]=+h[11329];K=(fa(Va+1|0,Va)|0)/2|0;c[22578]=K;ea=(+h[11304]- +h[11285])/+h[e>>3];h[11311]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[11306]*(+h[X>>3]+ +h[11311]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[11304])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[11297]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[11297]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[11306]*+h[11342]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[11300]=oa;h[11327]=oa;c[22596]=1;h[11322]=0.0;h[11323]=0.0;c[22682]=0;h[11347]=0.0;F=c[a>>2]|0;c[22572]=1;if((F|0)<1){U=53;break}ca=c[22634]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[11347]=+h[11347]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[22572]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[22664]=c[22580];U=54;continue}else if((U|0)==54){U=0;c[22620]=0;I=(c[22590]|0)+ -1|0;K=c[a>>2]|0;MJ(a,b,l,n,p,q,r,90616,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,90752)|0;h[11299]=0.0;K=c[a>>2]|0;c[22572]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[11299]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[22572]=K+1;ab=cb}oa=+h[11327];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[11334]=O;ea=+h[11300];if(!(O<+h[11306]*ea)){db=ab;U=62;break}c[22620]=-1;O=+h[11337];N=O*oa;h[11327]=N;h[11335]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[11327]=ea;eb=ea}if((c[22580]|0)<=((c[22664]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[11344]*.125*ea;h[11311]=N;oa=+h[11322];ba=+h[11323];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[11324];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[11346]=O;I=c[b>>2]|0;c[22576]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[11303]=0.0;X=c[a>>2]|0;c[22574]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[11303]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[22574]=X+1;jb=lb}if(jb>ea){c[22620]=F;h[11346]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[22576]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[11335]>0.0){U=54;continue}ea=+h[11334];O=+h[11300];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[11306];h[11327]=O;ea=hb/+h[f>>3];h[11335]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[11300]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[11300]=na;ob=na;break}}else{na=+h[f>>3];h[11300]=na;ob=na}}while(0);h[11327]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){G_(90856)|0;o_()|0}G_(90880)|0;XZ(90976,90400,8)|0;XZ(90976,90320,4)|0;o_()|0;G_(90904)|0;XZ(90976,90512,8)|0;ca=c[a>>2]|0;c[22572]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];XZ(90976,y,8)|0;I=c[22572]|0;F=I+1|0;c[22572]=F;}while((I|0)<(ca|0))}o_()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[11306]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[11300];O=na>=ea?na:ea;h[11336]=O;ea=O*O;h[11299]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[11347];if(db<=ea*.001){h[11340]=ea*.25;ca=c[b>>2]|0;c[22576]=1;if((ca|0)>=1){F=1;while(1){h[11303]=0.0;I=c[a>>2]|0;c[22572]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[11303]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[22572]=I+1;pb=qb}h[11311]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[11306]*+h[11347];h[11303]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[22572]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[11311]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[11306]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[11303]*+h[n+(F+C+Va<<3)>>3]+ +h[11340]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[22584]=aa;c[22574]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[22574]=Va;rb=Va}c[22572]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[22576]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[22636]|0;c[22576]=1;if((F|0)>=1){ca=1;while(1){h[11321]=0.0;X=c[b>>2]|0;c[22572]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[11321]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[22572]=I;if((K|0)>=(X|0)){break b}O=+h[11321];K=I}}}while(0);X=c[a>>2]|0;c[22574]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[11340]*+h[11321]*+h[l+(I<<3)>>3];h[11303]=O;Va=c[b>>2]|0;c[22572]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[11303]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[22572]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[22596]|0)){h[11303]=-+h[11303]}L=c[b>>2]|0;c[22572]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[11303]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[22572]=L+1}J=K+1|0;c[22574]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[22572]=1;if((K|0)>=1){X=c[22596]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[22584]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[11311]=ub;c[22574]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[11311];aa=aa+1|0}aa=J+1|0;c[22574]=aa;vb=aa}c[22572]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[22576]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[22578]=0;ca=c[a>>2]|0;c[22574]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[22576]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[11306]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[22576]=aa+1}c[22572]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[22578]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[22572]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[22574]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[22574]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[22574]=J+1}h[11347]=0.0}if((c[22620]|0)>0){F=(c[22590]|0)+ -1|0;ZI(a,b,l,n,s,t,90384,u,90480,90688,v,90608,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[22576]=1;if((F|0)>=1){L=1;while(1){h[11312]=0.0;h[11313]=0.0;h[11303]=0.0;ca=c[a>>2]|0;c[22574]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[11312]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[11313]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[11303]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[22574]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[11306]+Ab);h[w+(K<<3)>>3]=+h[11303];K=L+1|0;c[22576]=K;if((L|0)<(F|0)){L=K}else{break}}}h[11307]=0.0;L=c[22636]|0;c[22576]=1;if((L|0)>=1){F=1;while(1){h[11303]=0.0;J=c[b>>2]|0;c[22572]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[11303]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[22572]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[11307];if((F|0)<(c[22596]|0)){h[11307]=O+ea;na=-Eb;h[11303]=na;Gb=na}else{h[11307]=O-ea;Gb=Eb}K=c[b>>2]|0;c[22572]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[11303];X=X+1|0}c[22572]=K+1}X=F+1|0;c[22576]=X;if((F|0)<(L|0)){F=X}else{break}}}h[11315]=0.0;h[11294]=0.0;F=c[a>>2]|0;c[22574]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[11303]=0.0;X=c[b>>2]|0;c[22572]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[11303]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[22572]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[11315]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[22586]=K;Va=c[a>>2]|0;c[22576]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[11303]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[22576]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[11315]+ +h[11303]*+h[ca>>3];h[11315]=O;na=+h[11294]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[11294]=na;aa=L+1|0;c[22574]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[11299];h[11307]=+h[11307]+(Ib*Ib+ea*(Ib+(Ib+ +h[11347])+ea*+h[11306]))-Hb;L=w+((c[22634]|0)+ -1<<3)|0;h[L>>3]=+h[11297]+ +h[L>>3];L=c[22620]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[11297]+ +h[11326]*+h[11307]/(ea*ea);h[11311]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;YI(a,b,l,n,s,t,90384,u,90536,90480,v,x,w,90456,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[22572]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[22572]=L+1}F=c[22580]|0;aa=F+1|0;c[22580]=aa;if((F|0)>=(c[22690]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[22580]=T+ -1;if((c[g>>2]|0)<=0){break}G_(90784)|0;o_()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}G_(90832)|0;o_()|0}}while(0);Nb=+h[11314];if(Nb<=+h[11285]){U=c[a>>2]|0;c[22572]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[22572]=U+1;Ob=+h[11314]}h[11285]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}G_(90928)|0;XZ(90976,90320,4)|0;o_()|0;G_(90952)|0;XZ(90976,90280,8)|0;g=c[a>>2]|0;c[22572]=1;if((g|0)>=1){a=1;do{XZ(90976,d+(a+ -1<<3)|0,8)|0;U=c[22572]|0;a=U+1|0;c[22572]=a;}while((U|0)<(g|0))}o_()|0;i=z;return 0}function IJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){Jaa(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){Jaa(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function JJ(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+zJ(90984);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+AJ(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+AJ(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+AJ(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function KJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function LJ(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+zJ(90992);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Yaa(u|0,0,t+ -2|0,0)|0;t=Raa(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function MJ(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[11394]=.5;h[11412]=6.283185307179586;v=+h[l>>3];h[11407]=v*v;c[22810]=0;l=c[b>>2]|0;c[22828]=l;c[22826]=l;w=c[b>>2]|0;c[22750]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[22750]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[22750]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22750]=w+1}z=c[d>>2]|0;c[22754]=1;if((z|0)>=1){e=1;while(1){h[11398]=0.0;A=c[b>>2]|0;c[22752]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[11398]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[22752]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[11398]=v;C=c[b>>2]|0;c[22750]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[11398];F=F+1|0}c[22750]=C+1}F=e+1|0;c[22754]=F;if((e|0)<(z|0)){e=F}else{break}}}c[22764]=0;e=c[b>>2]|0;c[22752]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[22764]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[22750]=H;c[22752]=e+1}do{if((y|0)==0){h[11396]=0.0;h[11378]=0.0;w=c[b>>2]|0;c[22750]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[11378]=+h[11378]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22750]=w+1}h[r>>3]=0.0;D=+h[11378];if(D==0.0){O=55;break a}h[11383]=0.0;h[11386]=0.0;h[11381]=D;h[11401]=D;P=D;Q=0.0;R=0.0;S=+h[11407];T=0}else{if((y|0)>(x|0)){h[11380]=0.0;h[11387]=0.0;h[11388]=0.0;z=c[b>>2]|0;c[22750]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11380]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[11387]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[11388]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[22750]=z+1;U=ba;W=$;Z=aa}D=+h[11394];v=D*(+h[11391]-Z);h[11379]=v;_=+h[11384];ca=_+v;h[11395]=ca;h[11399]=ca;h[11397]=ca;c[22820]=0;a[91080]=1;da=+h[11412]/50.0;h[11398]=da;c[22750]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[11397]=ka;c[22820]=w;h[11408]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[11409]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[11403]=ha;h[11389]=ia;h[11392]=ja;h[11400]=ka;c[22750]=50;h[11399]=ka;if((la|0)==0){h[11408]=ka;O=46}else if((la|0)==49){h[11409]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[11409]}h[11403]=0.0;ga=+h[11408];if(ga!=na){ea=ga-ma;h[11408]=ea;ga=na-ma;h[11409]=ga;oa=D*(ea-ga)/(ea+ga);h[11403]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[11403]=oa;ga=+X(+oa);h[11389]=ga;ea=+Y(+oa);h[11392]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[11404]=oa;h[11381]=0.0;w=c[b>>2]|0;c[22750]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[11389]*+h[J>>3]+ +h[11392]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[11381]+sa*sa;h[11381]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[11392];ea=+h[11389];F=F+1|0;z=K}c[22750]=w+1;qa=ta;ra=+h[11404]}ea=ra+ +h[11396];h[11396]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[11387]=0.0;z=c[b>>2]|0;c[22752]=1;do{if((z|0)<1){ea=+h[11411];h[11402]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[11387]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[22752]=z+1;ea=+h[11411];h[11402]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[11378];h[11398]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[11398]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[11402];oa=+h[11381];v=+h[11387];_=oa/v;ca=ea<=_?ea:_;h[11402]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[11381];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[11394]*Ca);h[11393]=ca;h[11396]=+h[11396]+ca;h[11406]=Ba;h[11381]=0.0;z=c[b>>2]|0;c[22750]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[11402]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[11381]+oa*oa;h[11381]=Ga;Ha=+h[11402];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[22750]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[11411]){if(+h[11393]<=+h[11396]*.01){O=55;break a}if(Fa<=+h[11401]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[11406];h[11398]=ca;h[11378]=0.0;h[11383]=0.0;h[11386]=0.0;w=c[b>>2]|0;c[22750]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[11378]+ca*ca;h[11378]=La;J=m+(F<<3)|0;Ma=+h[11383]+ +h[K>>3]*+h[J>>3];h[11383]=Ma;ca=+h[J>>3];Na=+h[11386]+ca*ca;h[11386]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[11398];Ja=Ja+1|0;Ka=J}c[22750]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[11407];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[22826]=y;ua=+h[11381];va=y}if(ua<=+h[11401]*1.0e-4){O=55;break a}h[11384]=0.0;h[11391]=0.0;z=c[b>>2]|0;c[22750]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11384]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[11391]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[22750]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[11390]=ca;oa=+h[11407];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[22810]=J;_=+V(+(v-ca*ca));h[11398]=_;v=oa/_;h[11408]=v;oa=ca/_;h[11409]=oa;w=c[b>>2]|0;c[22750]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[11409];Ta=+h[11408];Ua=Ua+1|0;Va=K}c[22750]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[22810]=e;v=S-R;h[11398]=v;h[11411]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function NJ(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[11421]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[22848]=t;c[22838]=1;c[22832]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[22838]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[11423]=D;C=+h[x>>3]/D;h[11430]=C;z=+h[f+(B+y<<3)>>3]/D;h[11431]=z;B=c[d>>2]|0;c[22830]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[11423]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[11423];if((x|0)>=(B|0)){break}D=+h[11431];z=+h[11430];x=x+1|0}c[22830]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[22832]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[11430]=z;if((c[g>>2]|0)>1){D=-z;h[11430]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[11431]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[22830]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[11431]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[11430];t=t+1|0;x=A}c[22830]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[11428]=z;x=k+(w<<3)|0;H=+h[x>>3];h[11422]=H;D=H*H;h[11432]=D;h[11429]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[11421];a[91400]=0;do{if((u|0)==1){z=+h[11429];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[11423]=z;D=+h[11430]/z;h[11431]=D;H=+h[11422]/z;h[11430]=H;x=c[d>>2]|0;c[22830]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[11431];D=+h[11430];w=w+1|0;t=s}c[22830]=x+1;J=+h[11423]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[22834]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[22834]=u;M=u}t=u+1-M|0;c[22836]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[11429];z=+h[f+(t+w<<3)>>3]/D;h[11423]=z;h[11430]=z*+h[l>>3];H=+h[11422];h[11431]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[11423]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[11421]/+V(+(+h[11432]+z*N*z));h[11426]=C;if(!(D>=0.0)){O=-D}else{O=D}h[11427]=C*+V(+O);t=c[d>>2]|0;c[22830]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[11427]*(+h[A>>3]- +h[11430]*+h[n+(G<<3)>>3]- +h[11431]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[11423];z=+h[11422];H=+h[11426];v=v+1|0}c[22830]=t+1;P=+h[11429]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[91400]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[22830]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[11423]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[11423];K=Q+1|0;c[22830]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[22832]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[22840]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[11422];N=+h[11429];J=(+h[11428]*+h[f>>3]-O*P)/N;h[11430]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[11431]=P;c[22830]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[22830]=q;if((f|0)>=(b|0)){break a}N=+h[11431];O=+h[11430];f=q}}}while(0);b=R+1|0;c[22832]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function OJ(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function PJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((OJ(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(91464,91480,116,91504)}else if((s|0)==14){i=g;return o|0}return 0}function QJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((Baa(w,c[91512+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[91616+(x<<2)>>2]|0;c[q>>2]=c[91512+(x<<2)>>2];c[q+4>>2]=y;rH(23,0,91688,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=daa(D,8)|0;c[e+40>>2]=B;D=b+536|0;uH(c[D>>2]|0,(B|0)!=0|0,91728,p);B=daa(c[A>>2]|0,4)|0;c[e+36>>2]=B;uH(c[D>>2]|0,(B|0)!=0|0,91728,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=daa(c[C>>2]|0,4)|0;c[e+24>>2]=baa(8)|0;C=baa(4)|0;c[e+20>>2]=C;c[C>>2]=c[63608>>2];uH(c[D>>2]|0,(C|0)!=0|0,91728,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=baa(C)|0;A=e+44|0;c[A>>2]=baa(C)|0;C=daa(15,4)|0;E=e+12|0;c[E>>2]=C;uH(c[D>>2]|0,(C|0)!=0|0,91728,m);C=daa(5,4)|0;c[e+4>>2]=C;uH(c[D>>2]|0,(C|0)!=0|0,91728,l);C=daa(5,4)|0;c[e+8>>2]=C;uH(c[D>>2]|0,(C|0)!=0|0,91728,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=baa(C)|0;c[e+76>>2]=baa(C)|0;c[e+80>>2]=baa(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((pe[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){rH(23,0,91744,j)}else{rH(1,0,91816,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[63644>>2]|c[15886]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=91648;W=V;vH(Q,W,r)}c[t>>2]=w;tH(23,1,91544,t);t=1;do{w=c[91616+(t<<2)>>2]|0;c[s>>2]=c[91512+(t<<2)>>2];c[s+4>>2]=w;tH(23,0,91600,s);t=t+1|0;}while((t|0)<8);me[c[16026]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=91648;W=V;vH(Q,W,r);return 0}function RJ(a){a=a|0;var b=0;b=i;caa(c[a+40>>2]|0);caa(c[a+36>>2]|0);caa(c[a+20>>2]|0);caa(c[a+12>>2]|0);caa(c[a+4>>2]|0);caa(c[a+8>>2]|0);caa(a);i=b;return 0}function SJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;uH(c[N>>2]|0,(c[M>>2]|0)!=0|0,91912,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){rH(3,0,91944,B);rH(3,0,91984,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];pe[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(3,0,92008,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];rH(23,0,92048,y);if((c[z>>2]|0)==1){zI(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){QL(a)|0;pe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 6:{$I(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 3:{$I(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 4:{$I(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 7:{$I(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{$I(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){$I(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{$I(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){zd(_|0)|0;zd($|0)|0;tH(3,0,92080,x);rH(3,0,92168,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){zd(_|0)|0;zd($|0)|0;$=$J(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){QL(a)|0;pe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}pe[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tH(1,0,92192,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[63564>>2]|0)!=0){rH(3,1,92224,u);c[s>>2]=c[z>>2];rH(3,0,92248,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];rH(3,0,92272,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];rH(3,0,92304,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rH(3,0,92344,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rH(3,0,92392,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];rH(3,0,92440,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];rH(3,0,92480,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];rH(3,0,92520,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];rH(3,0,92560,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];rH(3,0,92608,f);me[c[16026]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(92648,92680,410,92712)}rH(3,0,92728,e);S=0;i=d;return S|0}function TJ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;QL(g)|0;a=f+540|0;pe[c[(c[a>>2]|0)+40>>2]&127](g)|0;pe[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function UJ(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;QL(l)|0;b=k+540|0;pe[c[(c[b>>2]|0)+40>>2]&127](l)|0;pe[c[(c[b>>2]|0)+28>>2]&127](l)|0;bK(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function VJ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];QL(g)|0;l=e+540|0;pe[c[(c[l>>2]|0)+40>>2]&127](g)|0;pe[c[(c[l>>2]|0)+28>>2]&127](g)|0;pe[c[(c[l>>2]|0)+32>>2]&127](g)|0;se[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function WJ(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;cK(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function XJ(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;QL(l)|0;b=k+540|0;pe[c[(c[b>>2]|0)+40>>2]&127](l)|0;pe[c[(c[b>>2]|0)+28>>2]&127](l)|0;aK(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function YJ(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function ZJ(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;dK(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function _J(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function $J(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-6:{tH(1,0,92792,j);m=-6;i=b;return m|0};case-9:{tH(1,0,92952,f);m=-9;i=b;return m|0};case-33:{tH(1,0,93272,b);m=-33;i=b;return m|0};case-10:{tH(1,0,93040,e);m=-10;i=b;return m|0};case-8:{tH(1,0,92904,g);m=-8;i=b;return m|0};case-1:{tH(3,0,92080,l);m=1;i=b;return m|0};case-2:{tH(1,0,92752,k);m=-2;i=b;return m|0};case-12:{tH(1,0,93224,c);m=-12;i=b;return m|0};case-7:{tH(1,0,92864,h);m=-7;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-11:{tH(1,0,93136,d);m=-11;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function aK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}pe[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function bK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;pe[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function cK(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+yd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+yd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;TJ(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function dK(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+yd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+yd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}TJ(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function eK(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function fK(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;me[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function gK(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function hK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=HH(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{Ee[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;FH(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=HH(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function iK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((hK(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}jK(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(HH(d)|0)>0;h=b?2:0;i=e;return h|0}function jK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=baa(q)|0;s=r;t=baa(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[23508]=DH(4)|0;if((r|0)==0){cb(94040,94056,308,94088)}if((t|0)==0){cb(94104,94056,309,94088)}v=KH(b)|0;if((v|0)!=0){w=v;do{v=MH(w)|0;c[l>>2]=c[v>>2];rH(27,0,94120,l);w=LH(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;Haa(t|0,c[a+384>>2]|0,v|0)|0;Haa(r|0,l|0,v|0)|0}h[d>>3]=+mK(a,n,o,q,s,c[23508]|0,b);do{if((HH(c[23508]|0)|0)==0){s=IH(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=KH(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=MH(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=LH(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];rH(27,0,94168,j);v=KH(b)|0;if((v|0)==0){break}else{B=v}do{v=MH(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[23508]|0;GH(v,MH(B)|0);v=MH(B)|0;c[g>>2]=c[v>>2];rH(27,0,94192,g)}B=LH(B)|0;}while((B|0)!=0)}}while(0);EH(b);if((c[63580>>2]|0)!=0){HH(c[23508]|0)|0}if((HH(c[23508]|0)|0)>0){B=m;do{g=IH(c[23508]|0)|0;c[m>>2]=c[g>>2];JH(c[23508]|0);c[f>>2]=c[m>>2];rH(7,0,94216,f);FH(b,B);}while((HH(c[23508]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){Haa(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}ef(a);pK(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){caa(t);caa(r);i=e;return}Haa(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;caa(t);caa(r);i=e;return}function kK(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){tK(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(7,0,93760,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((HH(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[63580>>2]|0)!=0){e=KH(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=MH(s)|0;x=c[e>>2]|0;e=Ee[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;qH(7,0,w,93784,l);s=LH(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=MH(KH(d)|0)|0;x=Ee[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;qH(1,0,e,93800,j);c[s>>2]=1}}while(0);EH(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;oK(b);lK(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function lK(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;rH(27,0,94408,b);d=a+344|0;se[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function mK(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=baa(p<<3)|0;if((q|0)==0){cb(94224,94056,409,94240)}if((p|0)>0){Haa(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rH(27,0,94256,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(27,0,94304,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){caa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}QL(a)|0;pe[c[(c[p>>2]|0)+40>>2]&127](a)|0;pe[c[(c[p>>2]|0)+28>>2]&127](a)|0;pe[c[(c[p>>2]|0)+32>>2]&127](a)|0;se[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(nK(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}Haa(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}caa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function nK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;EH(b);rH(27,0,94328,g);g=KH(d)|0;if((g|0)==0){j=HH(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=MH(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=MH(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=MH(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=MH(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=MH(a)|0;o=c[g>>2]|0;g=MH(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?93744:93752;g=MH(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?93744:93752;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;rH(27,0,94368,f);FH(b,MH(a)|0)}a=LH(a)|0;}while((a|0)!=0);j=HH(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function oK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;Ee[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;pK(b);qK(b);pe[c[(c[g>>2]|0)+36>>2]&127](b)|0;rK(b,8);h=sK(b)|0;j=pe[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{qK(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}tK(b);pK(b);rK(b,8);pe[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=sK(b)|0;j=pe[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){vH(c[b+536>>2]|0,94448,e)}else if((o|0)==7){qK(b);i=d;return}}function pK(a){a=a|0;var b=0;b=i;Haa(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function qK(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function rK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[63552+(d<<2)>>2]|0)==0){i=e;return}rH(d,1,94872,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=pe[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=pe[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;rH(d,0,94896,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}me[c[16026]&255](d);i=e;return}function sK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function tK(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;Haa(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Haa(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Haa(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Haa(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function uK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}se[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function vK(a){a=a|0;var b=0;b=i;wK(a);xK(a);tK(a);yK(a);i=b;return}function wK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function xK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function yK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((yI(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];Haa(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;Haa(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;Haa(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;Haa(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(yI(c[d>>2]|0)|0));i=b;return}function zK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[63552+(d<<2)>>2]|0)==0){i=e;return}rH(d,1,94544,q);q=b+136|0;if((c[q>>2]|0)>0){rH(d,1,94568,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?94528:94536;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rH(d,0,94584,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}me[c[16026]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){rH(d,1,94640,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?94528:94536;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;rH(d,0,94664,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}me[c[16026]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){rH(d,1,94720,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?94528:94536;v=(a[n+(m*48|0)+40|0]|0)!=0?94528:94536;n=(a[(c[s>>2]|0)+m|0]|0)!=0?94528:94536;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;rH(d,0,94744,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}me[c[16026]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){rH(d,1,94800,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;rH(d,0,94824,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}me[c[16026]&255](d)}me[c[16026]&255](d);i=e;return}function AK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((yI(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];Haa(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;Haa(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;Haa(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;Haa(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(yI(c[d>>2]|0)|0));i=b;return}function BK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function CK(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];Haa(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;Haa(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;Haa(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;Haa(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function DK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=tI(3,32)|0;c[o>>2]=p;if((p|0)==0){vH(c[b+536>>2]|0,94928,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=daa(c[p>>2]|0,8)|0;c[q>>2]=z;uH(c[r>>2]|0,(z|0)!=0|0,94984,l);z=daa(c[s>>2]|0,4)|0;c[t>>2]=z;uH(c[r>>2]|0,(z|0)!=0|0,94984,k);z=daa(c[u>>2]|0,1)|0;c[v>>2]=z;uH(c[r>>2]|0,(z|0)!=0|0,94984,j);z=daa(c[w>>2]|0,4)|0;c[x>>2]=z;uH(c[r>>2]|0,(z|0)!=0|0,94984,g);xI(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=daa(3,4)|0;c[b+4>>2]=n;zI(c[o>>2]|0,0,n);c[b+8>>2]=daa(c[p>>2]|0,112)|0;c[b+12>>2]=daa(c[s>>2]|0,60)|0;c[b+16>>2]=daa(c[u>>2]|0,48)|0;c[b+20>>2]=daa(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=daa(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=daa(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=daa(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=daa(g,52)|0;c[b+40>>2]=daa(c[b+216>>2]|0,52)|0;c[b+44>>2]=daa(c[b+220>>2]|0,52)|0;c[b+48>>2]=daa(c[b+224>>2]|0,52)|0;c[b+52>>2]=daa(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=daa(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=daa(x,8)|0;c[b+340>>2]=daa(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=daa(x,8)|0;c[b+348>>2]=daa(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=daa(j,1)|0;c[b+356>>2]=daa(j,1)|0;c[b+360>>2]=daa(j,1)|0;j=baa(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=baa(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=daa(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=daa(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=daa(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=daa(u,4)|0;c[b+400>>2]=daa(x,8)|0;c[b+404>>2]=daa(p,4)|0;c[b+408>>2]=daa(s,1)|0;c[b+412>>2]=daa(u,4)|0;c[b+416>>2]=daa(c[n>>2]|0,8)|0;c[b+420>>2]=daa(o,4)|0;c[b+424>>2]=daa(y,1)|0;c[b+428>>2]=daa(g,4)|0;c[b+432>>2]=daa(c[b+152>>2]|0,8)|0;c[b+436>>2]=daa(c[b+156>>2]|0,8)|0;g=baa((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;me[c[(c[y>>2]|0)+20>>2]&255](g);g=baa((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;me[c[(c[y>>2]|0)+16>>2]&255](g);g=baa((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;me[c[(c[y>>2]|0)+12>>2]&255](g);g=baa((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ne[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=baa((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=daa(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;uH(c[r>>2]|0,(g|0)!=0|0,95e3,f);c[b+512>>2]=100;c[b+516>>2]=daa(100,4)|0;c[b+520>>2]=daa(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=baa(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;uH(c[r>>2]|0,(g|0)!=0|0,94984,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=tI(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function EK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;caa(c[g+8>>2]|0);caa(c[g+12>>2]|0);caa(c[g+16>>2]|0);caa(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);caa(e);uI(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){SI(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}caa(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){SI(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}caa(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){SI(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}caa(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){SI(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}caa(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){SI(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}caa(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){SI(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}caa(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){SI(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}caa(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){SI(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}caa(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){SI(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}caa(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){SI(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}caa(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){SI(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}caa(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){SI(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}caa(v);caa(c[a+108>>2]|0);caa(c[a+336>>2]|0);caa(c[a+340>>2]|0);caa(c[a+344>>2]|0);caa(c[a+348>>2]|0);caa(c[a+352>>2]|0);caa(c[a+356>>2]|0);caa(c[a+360>>2]|0);caa(c[a+368>>2]|0);caa(c[a+384>>2]|0);caa(c[a+388>>2]|0);caa(c[a+392>>2]|0);caa(c[a+396>>2]|0);caa(c[a+400>>2]|0);caa(c[a+404>>2]|0);caa(c[a+408>>2]|0);caa(c[a+412>>2]|0);caa(c[a+416>>2]|0);caa(c[a+420>>2]|0);caa(c[a+424>>2]|0);caa(c[a+428>>2]|0);caa(c[a+488>>2]|0);caa(c[a+484>>2]|0);caa(c[a+476>>2]|0);caa(c[a+468>>2]|0);caa(c[a+464>>2]|0);caa(c[a+432>>2]|0);caa(c[a+436>>2]|0);caa(c[a+320>>2]|0);caa(c[a+516>>2]|0);caa(c[a+520>>2]|0);vZ(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;caa(x);i=b;return}else{y=a;z=0}while(1){uI(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;caa(x);i=b;return}function FK(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[11880]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];rH(8,0,95048,d);i=b;return}function GK(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[11880];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function HK(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(GK(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function IK(a,b){a=+a;b=+b;i=i;return a<b|0}function JK(a,b){a=+a;b=+b;i=i;return a<=b|0}function KK(a,b){a=+a;b=+b;i=i;return a>b|0}function LK(a,b){a=+a;b=+b;i=i;return a>=b|0}function MK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=baa(k)|0;c[e+(h*40|0)+24>>2]=baa(k)|0;if((c[g>>2]|0)!=1){l=5;break}PK(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){vH(c[a+536>>2]|0,95104,d)}else if((l|0)==6){i=b;return 0}return 0}



function NK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){caa(c[e+(h*40|0)+20>>2]|0);caa(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;QK(k)|0;caa(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){vH(c[a+536>>2]|0,95104,d)}else if((j|0)==6){i=b;return 0}return 0}function OK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[63620>>2]|c[15886]|0)==0){z=w;A=1;break}tZ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tH(17,1,95136,g);tZ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;tZ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;tH(17,0,95168,f);tZ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}me[c[16026]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function PK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=baa(20)|0;c[b>>2]=f;uH(0,(f|0)!=0|0,95176,e);e=baa(a)|0;c[f>>2]=e;e=baa(a)|0;c[f+4>>2]=e;e=baa(a)|0;c[f+8>>2]=e;e=baa(a)|0;c[f+16>>2]=e;uH(0,(c[b>>2]|0)!=0|0,95208,d);i=d;return 0}function QK(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;caa(c[d>>2]|0);caa(c[d+4>>2]|0);caa(c[d+8>>2]|0);caa(c[d+16>>2]|0);i=b;return 0}function RK(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vH(c[a+536>>2]|0,95256,b);return 0}function SK(a){a=a|0;a=i;i=i+8|0;vH(0,95256,a);return 0}function TK(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vH(c[a+536>>2]|0,95256,b);return 0}function UK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=baa(l)|0;c[e+(h<<6)+36>>2]=baa(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=baa(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;_K(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;bL(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){vH(c[a+536>>2]|0,95296,d)}else if((n|0)==8){i=b;return 0}return 0}function VK(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function WK(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function XK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){caa(c[e+(h<<6)+28>>2]|0);caa(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){cL(e+(h<<6)+24|0)|0}else if((j|0)==1){$K(e+(h<<6)+24|0)|0;caa(c[e+(h<<6)+32>>2]|0)}else{k=6;break}caa(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){vH(c[a+536>>2]|0,95296,d)}else if((k|0)==8){i=b;return 0}return 0}function YK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=dL(b,d)|0}else if((h|0)==1){j=aL(b,d)|0}else{vH(c[b+536>>2]|0,95296,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function ZK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[63612>>2]|c[15886]|0)==0){z=w;A=1;break}tZ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tH(15,1,95328,g);tZ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;tZ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;tH(15,0,95360,f);tZ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}me[c[16026]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function _K(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=baa(12)|0;f=baa(a<<2)|0;c[e>>2]=f;uH(0,(f|0)!=0|0,95368,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function $K(a){a=a|0;var b=0;b=i;caa(c[c[a>>2]>>2]|0);i=b;return 0}function aL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;Jaa(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ne[c[x>>2]&127](C,D);ne[c[w+(d<<6)+4>>2]&127](C,D);if((c[63616>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;rH(16,1,95424,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,95448,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;rH(16,0,95464,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;rH(16,1,95472,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];lc(D|0,95448,o|0)|0;c[n>>2]=D;rH(16,0,95464,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;rH(16,1,95472,s)}}while(0);me[c[16026]&255](16)}s=w+(d<<6)+36|0;A=y+8|0;eC(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;tH(1,0,95488,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Haa(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Haa(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;tH(1,0,95576,l);if((c[63612>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Haa(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];lc(l|0,95680,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];lc(l|0,95680,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Haa(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];lc(l|0,95680,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;Haa(M|0,O|0,Q|0)|0;i=e;return F|0}function bL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=baa(32)|0;uH(0,(g|0)!=0|0,95688,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Md(0,d|0)|0;Td(c[d>>2]|0,c[b>>2]|0,0)|0;Md(0,g+4|0)|0;Td(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Lb(95736,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function cL(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ed(c[d+12>>2]|0)|0;Kb(c[d+8>>2]|0)|0;Kb(c[d+4>>2]|0)|0;i=b;return 0}function dL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;rd(c[g>>2]|0)|0;$d(0,g|0)|0;j=g+24|0;Qb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ne[c[f>>2]&127](k,a);_c(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;ne[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){md(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(qc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Jb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;rd(c[g>>2]|0)|0;i=d;return l|0}function eL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;uH(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,95904,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){uH(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,95944,e);if((pe[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=baa(p)|0;c[g+(m*80|0)+52>>2]=baa(p)|0;c[g+(m*80|0)+48>>2]=baa(p)|0;c[g+(m*80|0)+16>>2]=baa(p)|0;c[g+(m*80|0)+8>>2]=baa(p)|0;c[g+(m*80|0)+12>>2]=baa(p)|0;ne[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){rL(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){rL(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){RK(a,n)|0;break}else if((p|0)==1){jL(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){vH(c[j>>2]|0,95984,d)}else if((q|0)==14){i=b;return 0}return 0}function fL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;caa(c[e+(h*80|0)+44>>2]|0);caa(c[e+(h*80|0)+52>>2]|0);caa(c[e+(h*80|0)+48>>2]|0);caa(c[e+(h*80|0)+16>>2]|0);caa(c[e+(h*80|0)+8>>2]|0);caa(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;sL(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;sL(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==1){k=e+(h*80|0)+40|0;kL(k)|0;l=k;break}else{n=9;break a}}}while(0);caa(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){SK(j)|0}else if((n|0)==9){vH(c[a+536>>2]|0,95984,d)}else if((n|0)==11){i=b;return 0}return 0}function gL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(uL(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=lL(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(uL(b,d)|0)&255;break}else if((k|0)==2){j=(TK(b,d)|0)&255;break}else{vH(c[b+536>>2]|0,95984,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function hL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;tZ(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sH(17,1,u,96016,m);do{if((a[b+312|0]|0)==0){tZ(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;tZ(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;tH(17,0,96216,f);tZ(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{tH(17,1,96056,l);tZ(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;tZ(q,d,c[v>>2]|0);if((Baa(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];tH(17,0,96136,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;tZ(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;tH(17,0,96176,g);G=E}tZ(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[63620>>2]|c[15886]|0)==0){break}me[c[16026]&255](17)}}while(0);if((c[63620>>2]|c[15886]|0)==0){x=1;i=e;return x|0}me[c[16026]&255](17);x=1;i=e;return x|0}function iL(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function jL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=baa(144)|0;c[b>>2]=f;uH(0,(f|0)!=0|0,96232,e);c[f>>2]=0;e=a<<3;g=baa(e)|0;c[f+4>>2]=g;g=baa(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=baa(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=baa(e)|0;c[f+24>>2]=g;g=daa(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=baa(e)|0;c[f+64>>2]=g;g=baa(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=daa(g,8)|0;c[f+104>>2]=j;j=daa(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=baa(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=baa(e)|0;c[f+124>>2]=j;j=baa(e)|0;c[f+128>>2]=j;j=baa(e)|0;c[f+132>>2]=j;j=baa(e)|0;c[f+136>>2]=j;j=baa(e)|0;c[f+140>>2]=j;uH(0,(c[b>>2]|0)!=0|0,96264,d);i=d;return 0}function kL(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;caa(c[d+4>>2]|0);caa(c[d+16>>2]|0);caa(c[d+12>>2]|0);caa(c[d+24>>2]|0);caa(c[d+28>>2]|0);caa(c[d+64>>2]|0);caa(c[d+68>>2]|0);caa(c[d+104>>2]|0);caa(c[d+108>>2]|0);caa(c[d+116>>2]|0);caa(c[d+124>>2]|0);caa(c[d+128>>2]|0);caa(c[d+132>>2]|0);caa(c[d+136>>2]|0);caa(c[d+140>>2]|0);i=b;return 0}function lL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=baa(c[Y>>2]|0)|0;if((c[63620>>2]|0)!=0){tZ(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];rH(17,1,96304,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rH(17,1,96360,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rH(17,0,96376,F);me[c[16026]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}me[c[16026]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){Haa(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{Haa(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+yd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;mL($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+yd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[63624>>2]|0)!=0){nL(c[Q>>2]|0,$,18,96416);nL(c[ca>>2]|0,$,18,96448)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[63624>>2]|0)!=0){nL(c[ca>>2]|0,$,18,96480)}a[da]=R;BJ(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){tZ(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];RI(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;mL($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;mL($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}pK(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[63624>>2]|0)!=0){rH(18,1,96520,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rH(18,1,96560,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rH(18,0,96592,C);me[c[16026]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}me[c[16026]&255](18)}if((c[63628>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;rH(19,1,96624,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];lc(Ja|0,96648,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;rH(19,0,96656,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}me[c[16026]&255](19)}h[K>>3]=+AJ($,c[Ia>>2]|0);h[J>>3]=+AJ($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}Haa(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rH(17,0,96704,w);oL(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rH(17,0,96776,v);oL(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+yd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rH(17,0,96840,u);oL(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+yd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rH(17,0,96912,t);oL(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}Haa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;Haa(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}rH(17,0,96976,s);oL(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){Haa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}rH(17,0,97048,r);oL(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rH(17,0,97120,q);oL(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rH(17,0,97192,p);oL(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){Haa(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rH(17,0,97256,o);oL(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rH(17,0,97328,n);oL(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];rH(17,0,97464,l);oL(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){Haa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{Haa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}rH(17,0,97392,m);oL(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[63620>>2]|0)!=0){rH(17,1,96664,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;rH(17,0,96680,x);me[c[16026]&255](17);oL(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}Haa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;mL($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;caa(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;caa(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;caa(Z);i=e;return kb|0}if((a[Ha]|0)==0){tZ(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];RI(0,f,hb);}if((c[63620>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;rH(17,0,97536,j);oL(S,L,J,K,17)}Haa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;caa(Z);i=e;return kb|0}return 0}function mL(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[63632>>2]|0)!=0){c[u>>2]=c[y+96>>2];rH(20,0,97784,u);nL(d,b,20,97816)}Pe[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[63632>>2]|0)!=0){nL(e,b,20,97832);c[t>>2]=c[y+96>>2];rH(20,0,97848,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[63632>>2]|0)!=0){rH(20,0,97888,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){qL(w,f,d,e,m)}else{pL(w,f,m)}do{if((c[63632>>2]|0)!=0){rH(20,0,97928,r);if((c[63628>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;rH(19,1,96624,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];lc(m|0,97960,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;rH(19,0,96656,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}me[c[16026]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;vH(g,97976,n)}return 0}function nL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[63552+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;rH(d,1,96656,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];rH(d,0,97768,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}me[c[16026]&255](d);i=f;return}function oL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[63552+(f<<2)>>2]|0)==0){i=g;return}rH(f,1,97576,q);rH(f,1,97592,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];rH(f,0,97608,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}me[c[16026]&255](f);rH(f,1,97648,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rH(f,0,97664,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}me[c[16026]&255](f);rH(f,1,97704,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];rH(f,0,97720,j);me[c[16026]&255](f);me[c[16026]&255](f);i=g;return}function pL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;Jaa(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;Jaa(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}pe[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function qL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+yd(+(n*+yd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;mL(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function rL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=baa(80)|0;c[b>>2]=f;uH(0,(f|0)!=0|0,98056,e);c[f>>2]=0;e=a<<3;g=baa(e)|0;c[f+4>>2]=g;g=baa(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=baa(e)|0;c[f+16>>2]=g;g=daa(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=baa(fa(e,a)|0)|0;c[f+64>>2]=g;g=baa(e)|0;c[f+68>>2]=g;g=baa(a<<2)|0;c[f+72>>2]=g;uH(0,(c[b>>2]|0)!=0|0,98088,d);i=d;return 0}function sL(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;caa(c[d+4>>2]|0);caa(c[d+8>>2]|0);caa(c[d+16>>2]|0);caa(c[d+20>>2]|0);caa(c[d+64>>2]|0);caa(c[d+68>>2]|0);caa(c[d+72>>2]|0);i=b;return 0}function tL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;Jaa(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}pe[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function uL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;Haa(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[63620>>2]|0)==0){J=b+4|0}else{tZ(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rH(17,1,98128,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];rH(17,1,98200,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];rH(17,0,98216,t);me[c[16026]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}me[c[16026]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];vL(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){tZ(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];RI(3,g,P);}$=+AJ(H,c[b>>2]|0);aa=+AJ(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){Haa(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;rH(17,0,98392,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;rH(17,0,98448,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;rH(17,0,98512,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[63620>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;rH(17,0,98264,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];rH(17,0,98304,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];rH(17,0,98360,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){tZ(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];RI(0,f,L);if((c[63620>>2]|0)==0){da=0;break}c[m>>2]=V;rH(17,0,98592,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(17,0,98304,l);if((c[63620>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(17,0,98360,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[63620>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;Haa(ma|0,oa|0,qa|0)|0;i=e;return da|0}me[c[16026]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;Haa(ma|0,oa|0,qa|0)|0;i=e;return da|0}function vL(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[63624>>2]|0)!=0){c[z>>2]=j;rH(18,0,98632,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];rH(18,0,98680,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){wL(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){xL(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{tL(E,m,r)|0}if((c[63628>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;rH(19,1,98696,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];lc(F|0,98720,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;rH(19,0,98728,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}me[c[16026]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+AJ(b,_);if(!(!(J<=H)&!(+AJ(b,e)<=H))){$=31;break}eC(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;tH(17,0,98736,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;tH(17,0,98768,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+AJ(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function wL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Pe[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function xL(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+yd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;wL(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function yL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){zL(a,b);f=0;i=d;return f|0}else if((e|0)==3){f=SJ(a,b)|0;i=d;return f|0}else if((e|0)==4){Ae[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){e=c[a+4>>2]|0;g=c[e+4>>2]|0;AL(c[e>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function zL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[98800+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[98800+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];pe[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function AL(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function BL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=DH(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=baa(88)|0;rH(23,0,98832,e);j=QJ(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[1586]|0;g=baa(j<<2)|0;c[24714]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=daa(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[24714]|0;g=n}}else if((f|0)==2){g=baa(8)|0;c[g+4>>2]=4;m=baa(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=daa(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);OL(b)|0;if((c[2]|0)==0){i=e;return k|0}NI(6);KI(1);i=e;return k|0}function CL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){RJ(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){caa(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}caa(l);caa(c[f>>2]|0)}else if((e|0)==4){e=c[1586]|0;f=c[24714]|0;if((e|0)>0){l=f;g=0;while(1){caa(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[24714]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}caa(m)}PL(a)|0;JL(a);i=d;return 0}function DL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(217,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Saa(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Saa(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Saa(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Saa(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Saa(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(218,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Saa(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Saa(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;Eaa(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Saa(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Saa(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,98864,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Saa(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Saa(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,98960,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Saa(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[105080>>2]|0,105056,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Saa(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,99016,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Saa(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(219,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Saa(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function EL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];rH(8,0,99112,G);I=b+313|0;a[I]=1;oK(b);if((c[120452>>2]|0)==0){ne[c[105076>>2]&127](105056,b)}a[I]=0}}while(0);if((e|0)!=0){FL(Fd(e|0)|0,b)}if((c[63652>>2]|0)==0){i=f;return 0}NI(0);rH(25,0,99160,F);rH(25,1,99184,E);H=+FI(6);J=+FI(6);K=J/+FI(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];rH(25,0,99192,D);K=+FI(1);H=+FI(1);J=H/+FI(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];rH(25,0,99232,C);J=+FI(2);K=+FI(2);H=K/+FI(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rH(25,0,99264,B);H=+FI(3);J=+FI(3);K=J/+FI(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];rH(25,0,99288,A);K=+FI(4);H=+FI(4);J=H/+FI(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(25,0,99328,z);J=+FI(7);K=+FI(7);H=K/+FI(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(25,0,99360,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+FI(0);J=H- +FI(7);H=J- +FI(4);J=H- +FI(3);H=J- +FI(2);J=H- +FI(1);H=J- +FI(6);J=+FI(0);K=J- +FI(7);J=K- +FI(4);K=J- +FI(3);J=K- +FI(2);K=J- +FI(1);J=K- +FI(6);K=J/+FI(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(25,0,99424,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rH(25,0,99392,x)}K=+FI(0);H=+FI(0);J=H/+FI(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rH(25,0,99456,v);me[c[16026]&255](25);rH(25,1,99480,u);c[t>>2]=c[d+40>>2];rH(25,0,99488,t);c[s>>2]=c[d+44>>2];rH(25,0,99512,s);me[c[16026]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);rH(25,1,99536,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];rH(25,0,99552,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];rH(25,0,99568,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];rH(25,0,99600,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];rH(25,0,99632,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];rH(25,0,99656,m);me[c[16026]&255](25)}else if((s|0)!=5){rH(25,1,99688,l);rH(25,0,99696,j);me[c[16026]&255](25)}rH(25,0,99760,g);KI(0);i=f;return 0}function FL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Yb(b|0,100232)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(b|0,100240,y|0)|0;if((z|0)==0){C=Zd(10,b|0)|0;D=zd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,100256,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;Bd(b|0,100272,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;Bd(b|0,100280,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;Bd(b|0,100288,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((Baa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,100256,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,100256,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((Baa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;Bd(b|0,100272,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;Bd(b|0,100272,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((Baa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;Bd(b|0,100280,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;Bd(b|0,100280,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((Baa(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;Bd(b|0,100288,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Bd(b|0,100256,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;Bd(b|0,100272,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;Bd(b|0,100280,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((Baa(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;Bd(b|0,100288,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Yb(0,100232)|0;}while((d|0)!=0);C=Zd(10,b|0)|0;D=zd(b|0)|0;i=e;return}function GL(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 18:{v=c[1584]|0;do{if((v|0)!=0){if((Baa(v,100040)|0)!=0){break}c[u>>2]=4;break a}}while(0);rH(23,0,100064,o);w=1;i=m;return w|0};case 5:{tH(1,0,99856,q);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{tH(1,0,99784,r);w=1;i=m;return w|0};case 4:{v=c[1584]|0;if((v|0)!=0){if((Baa(v,99896)|0)==0){break a}}rH(23,0,99912,p);w=1;i=m;return w|0};default:{}}}while(0);p=BL(a,s)|0;Je[c[64452>>2]&7]()|0;do{if((p|0)==0){r=DL(a,b,d,e,f,g)|0;Je[c[64452>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){ne[c[105076>>2]&127](105056,a);yK(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(23,0,100192,n);r=Ee[c[c[a+540>>2]>>2]&63](a,t)|0;Je[c[64452>>2]&7]()|0;EL(a,s,l)|0;Je[c[64452>>2]&7]()|0;x=r}else{Je[c[64452>>2]&7]()|0;x=p}}while(0);CL(a,s)|0;w=x;i=m;return w|0}function HL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){IL(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((pe[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){vH(c[a+536>>2]|0,100304,d)}else if((k|0)==6){IL(a);i=b;return}}function IL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;Jaa(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function JL(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;caa(c[f+(a*48|0)+28>>2]|0);caa(c[f+(a*48|0)+32>>2]|0);caa(c[f+(a*48|0)+16>>2]|0);caa(c[f+(a*48|0)+20>>2]|0);caa(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function KL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=baa(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=baa(c[y>>2]<<2)|0;LL(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;Haa(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;Haa(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((PJ(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=ML(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){Haa(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;Haa(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;caa(x);caa(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;tH(5,1,100360,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(q|0,100392,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;tH(5,0,100400,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=64104;K=c[16026]|0;me[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=100408;aa=$;vH(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];tH(5,0,100400,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=64104;K=c[16026]|0;me[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=100408;aa=$;vH(O,aa,g);return 0}function LL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;Jaa(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}pe[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function ML(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=daa(d,4)|0;r=daa(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;caa(q);caa(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;caa(q);caa(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){caa(q);caa(r);i=o;return v|0}if((n|0)==0){v=-1;caa(q);caa(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(5,1,100512,p);NL(s,d,f,c[g>>2]|0,j,l,m);if((c[63572>>2]|0)==0){v=-1;caa(q);caa(r);i=o;return v|0}me[c[16026]&255](5);v=-1;caa(q);caa(r);i=o;return v|0}function NL(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;Jaa(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];rH(5,0,100544,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function OL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=mc(100560,100584)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Yd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((Yd(n|0)|0)!=10);q=c[b+152>>2]|0;r=daa(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=daa(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=daa(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Ud(n|0,100592,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Ud(n|0,100592,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=daa(s,8)|0;x=v}}while(0);kc(100600,j|0)|0;kc(100656,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];kc(100616,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];kc(100640,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(100656)|0;cd(n|0)|0;c[b+460>>2]=0;i=d;return 0}function PL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}caa(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){caa(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}caa(l);i=d;return 0}function QL(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function RL(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+SL(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[63588>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rH(9,1,100720,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(9,0,100832,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}me[c[16026]&255](9);g=1;i=b;return g|0}function SL(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;fM(b);g=f+540|0;pe[c[(c[g>>2]|0)+84>>2]&127](f)|0;pe[c[(c[g>>2]|0)+36>>2]&127](f)|0;pe[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;Ee[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function TL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+SL(b,1.0);if((c[63588>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}rH(9,1,100856,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(9,0,100920,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(9,0,100880,s)}rH(9,1,100944,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;rH(9,0,101016,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];rH(9,0,100968,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;rH(9,0,101104,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(9,0,101040,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;rH(9,0,101192,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rH(9,0,101136,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}me[c[16026]&255](9);rH(9,1,101224,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=pe[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;rH(9,0,101016,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rH(9,0,100968,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}me[c[16026]&255](9);me[c[16026]&255](9);i=d;return}function UL(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[63588>>2]|0)!=0){zK(b,9)}if((c[63648>>2]|0)==0){i=d;return}rH(24,1,101248,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){rH(24,1,101288,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rH(24,0,101312,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}me[c[16026]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}rH(24,1,101368,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rH(24,0,101392,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}me[c[16026]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){rH(24,1,101424,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(24,0,101312,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}me[c[16026]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){rH(24,1,101448,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;rH(24,0,101472,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}me[c[16026]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){rH(24,1,101520,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?101592:101600;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?101592:101600;t=(a[(c[l>>2]|0)+n|0]|0)!=0?101592:101600;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;rH(24,0,101544,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}me[c[16026]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){rH(24,1,101608,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;rH(24,0,101632,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}me[c[16026]&255](24)}me[c[16026]&255](24);i=d;return}function VL(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;rH(9,0,101680,z);if((f|0)==0){wK(b);xK(b);C=6}else{if((a[f]|0)!=0){WL(b,f,g)}wK(b);xK(b);if((a[f]|0)==0){C=6}}if((C|0)==6){pe[c[(c[A>>2]|0)+84>>2]&127](b)|0;pe[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(Baa(d,103168)|0)==0|0;f=(Baa(d,103176)|0)==0;z=(Baa(d,103184)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;tH(1,0,101728,y);tH(1,0,101760,x);c[w>>2]=103168;c[w+4>>2]=102976;tH(1,0,101784,w);c[v>>2]=103176;c[v+4>>2]=103056;tH(1,0,101784,v);c[u>>2]=103184;c[u+4>>2]=103104;tH(1,0,101784,u);vH(c[b+536>>2]|0,101816,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(Baa(e,c[101840+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;tH(1,0,101872,s);tH(1,0,101760,r);t=1;do{u=c[101904+(t<<2)>>2]|0;c[q>>2]=c[101840+(t<<2)>>2];c[q+4>>2]=u;tH(1,0,101784,q);t=t+1|0;}while((t|0)<7);vH(c[b+536>>2]|0,101816,p)}}while(0);p=c[101800+(D<<2)>>2]|0;c[o>>2]=c[101712+(D<<2)>>2];c[o+4>>2]=p;rH(9,0,101936,o);o=(D|0)==2;if(o){p=c[101904+(F<<2)>>2]|0;c[n>>2]=c[101840+(F<<2)>>2];c[n+4>>2]=p;rH(9,0,101976,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=XL(b,F,j)|0;break}if((D|0)==3){YL(b,j);I=0;break}else{vH(c[b+536>>2]|0,102016,m)}}}while(0);if((hL(b,1)|0)!=0){J=-2;UL(b);K=15;L=K;M=102040;N=M;rH(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];fK(b,R,V);W=214;tK(b);X=220;yK(b);Y=215;oK(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=223;uK(b);i=k;return J|0}if((ZK(b,1)|0)!=0){J=-3;UL(b);K=15;L=K;M=102040;N=M;rH(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];fK(b,R,V);W=214;tK(b);X=220;yK(b);Y=215;oK(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=223;uK(b);i=k;return J|0}m=(OK(b,1)|0)==0;J=m?I:-4;UL(b);K=15;L=K;M=102040;N=M;rH(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];fK(b,R,V);W=214;tK(b);X=220;yK(b);Y=215;oK(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=pe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ee[ha&63](b,1)|0;ja=223;uK(b);i=k;return J|0}



function v8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Sc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);l=+zaa(b,g,c[34372]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function w8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Sc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);l=+zaa(b,g,c[34372]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function x8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Sc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);l=+zaa(b,g,c[34372]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function y8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Sc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);n=lb(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function z8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Sc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);m=lb(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function A8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Sc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);m=lb(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function B8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Sc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);m=lb(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function C8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Sc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);n=Lc(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function D8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Sc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[137496]|0)==0){if((Za(137496)|0)==0){break}c[34372]=_b(2147483647,137504,0)|0;Ub(137496)}}while(0);m=Lc(b|0,h|0,f|0,c[34372]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function E8(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;me[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;me[h&255](a);i=b;return}}function F8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){y6(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=haa(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;Haa(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{jaa(h);i=e;return}}function G8(a){a=a|0;a=i;A0(142692|0);A0(142680|0);A0(142668|0);A0(142656|0);A0(142644|0);A0(142632|0);A0(142620|0);A0(142608|0);A0(142596|0);A0(142584|0);A0(142572|0);A0(142560|0);A0(142548|0);A0(142536|0);A0(142524|0);A0(142512|0);A0(142500|0);A0(142488|0);A0(142476|0);A0(142464|0);A0(142452|0);A0(142440|0);A0(142428|0);A0(142416);i=a;return}function H8(a){a=a|0;a=i;Y$(143020|0);Y$(143008|0);Y$(142996|0);Y$(142984|0);Y$(142972|0);Y$(142960|0);Y$(142948|0);Y$(142936|0);Y$(142924|0);Y$(142912|0);Y$(142900|0);Y$(142888|0);Y$(142876|0);Y$(142864|0);Y$(142852|0);Y$(142840|0);Y$(142828|0);Y$(142816|0);Y$(142804|0);Y$(142792|0);Y$(142780|0);Y$(142768|0);Y$(142756|0);Y$(142744);i=a;return}function I8(a){a=a|0;a=i;A0(143332|0);A0(143320|0);A0(143308|0);A0(143296|0);A0(143284|0);A0(143272|0);A0(143260|0);A0(143248|0);A0(143236|0);A0(143224|0);A0(143212|0);A0(143200|0);A0(143188|0);A0(143176|0);A0(143164|0);A0(143152|0);A0(143140|0);A0(143128|0);A0(143116|0);A0(143104|0);A0(143092|0);A0(143080|0);A0(143068|0);A0(143056);i=a;return}function J8(a){a=a|0;a=i;Y$(144172|0);Y$(144160|0);Y$(144148|0);Y$(144136|0);Y$(144124|0);Y$(144112|0);Y$(144100|0);Y$(144088|0);Y$(144076|0);Y$(144064|0);Y$(144052|0);Y$(144040|0);Y$(144028|0);Y$(144016|0);Y$(144004|0);Y$(143992|0);Y$(143980|0);Y$(143968|0);Y$(143956|0);Y$(143944|0);Y$(143932|0);Y$(143920|0);Y$(143908|0);Y$(143896);i=a;return}function K8(a){a=a|0;a=i;A0(144564|0);A0(144552|0);A0(144540|0);A0(144528|0);A0(144516|0);A0(144504|0);A0(144492|0);A0(144480|0);A0(144468|0);A0(144456|0);A0(144444|0);A0(144432|0);A0(144420|0);A0(144408);i=a;return}function L8(a){a=a|0;a=i;Y$(145100|0);Y$(145088|0);Y$(145076|0);Y$(145064|0);Y$(145052|0);Y$(145040|0);Y$(145028|0);Y$(145016|0);Y$(145004|0);Y$(144992|0);Y$(144980|0);Y$(144968|0);Y$(144956|0);Y$(144944);i=a;return}function M8(a){a=a|0;var b=0,c=0;b=i;if((S8(a)|0)==0){c=(N8(a)|0)!=0|0}else{c=1}i=b;return c|0}function N8(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[145256+((d[145256+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function O8(a){a=a|0;var b=0,c=0;b=i;c=fb(a|0)|0;i=b;return c|0}function P8(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function Q8(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 1:{d=M8(a)|0;break};case 3:{d=O8(a)|0;break};case 4:{d=P8(a)|0;break};case 5:{d=S8(a)|0;break};case 10:{d=X8(a)|0;break};case 12:{d=Z8(a)|0;break};case 2:{d=N8(a)|0;break};case 7:{d=U8(a)|0;break};case 8:{d=V8(a)|0;break};case 9:{d=W8(a)|0;break};case 6:{d=T8(a)|0;break};case 11:{d=Y8(a)|0;break};default:{d=0}}i=c;return d|0}function R8(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=148232;while(1){if(d<<24>>24==e<<24>>24){if((Baa(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function S8(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function T8(a){a=a|0;var b=0,c=0;b=i;if((X8(a)|0)==0){c=(V8(a)|0)!=0|0}else{c=0}i=b;return c|0}function U8(a){a=a|0;var b=0,c=0;b=i;if((_8(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function V8(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function W8(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[148312+((d[148312+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function X8(a){a=a|0;var b=0,c=0;b=i;c=(C9(151480,a)|0)!=0|0;i=b;return c|0}function Y8(a){a=a|0;var b=0,c=0;b=i;c=(a9(a)|0)!=(a|0)|0;i=b;return c|0}function Z8(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function _8(a){a=a|0;var b=0,c=0;b=i;c=$8(a,0)|0;i=b;return c|0}function $8(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((N8(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[151570+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[151568+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[151571+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[151816+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[151816+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[151816+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function a9(a){a=a|0;var b=0,c=0;b=i;c=$8(a,1)|0;i=b;return c|0}function b9(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=c9(0,a,b,(c|0)!=0?c:152520)|0;i=d;return e|0}function c9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?152528:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[152312+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Sc()|0)>>2]=84;k=-1;i=g;return k|0}function d9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=e9(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=c9(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function e9(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[152312+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[152312+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Sc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function f9(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[152312+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Sc()|0)>>2]=84;j=-1;i=g;return j|0}function g9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Sc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function h9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=i9(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=g9(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function i9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=g9(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=g9(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=g9(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}g9(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function j9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=baa(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=baa(2048)|0;c[p+16>>2]=s;if((s|0)==0){caa(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=z9(0,0)|0;if((s|0)==0){caa(c[p+16>>2]|0);caa(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=k9(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=daa(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=l9(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=baa(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;Jaa(y|0,-1,v|0)|0;I=H}else{I=0}H=daa(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=daa(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=l9(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=r9(q,x)|0;b:do{if((v|0)==0){y=r9(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==2){T=c[S+4>>2]|0;U=r9(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{X=L}}if((F|0)==45){F=0;c[j>>2]=0;X=0}Y=X;Z=M+1|0;_=N;break}else if((P|0)==1){T=c[S+4>>2]|0;U=r9(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=r9(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=r9(q,0)|0}else if((P|0)==3){U=c[S+4>>2]|0;T=r9(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=r9(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=r9(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}$=r9(q,0)|0}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=P;Y=L;Z=M;_=N;break}else{Y=L;Z=M;_=N;break}if(($|0)==0){Y=L;Z=M;_=N}else{V=N;W=$;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=s9(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=B9(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=B9(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=s9(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=B9(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=B9(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=s9(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=B9(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=B9(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=B9(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=B9(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=B9(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=B9(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=B9(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=B9(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Y=da;Z=U;_=T;break}c[j>>2]=T;Y=T;Z=0;_=T}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=B9(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=B9(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=B9(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=B9(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=r9(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=r9(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==1){M=c[ya+4>>2]|0;L=c[M>>2]|0;Q=M+4|0;R=c[Q>>2]|0;if((c[L+8>>2]|0)==0){za=(c[R+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;T=p9(s,c[L+24>>2]|0,c[R+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=p9(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Q>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){T=c[ya+4>>2]|0;Q=c[T>>2]|0;do{if((c[T+4>>2]|0)==0){F=141}else{if((c[Q+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[Q+24>>2];c[ya+28>>2]=c[(c[T>>2]|0)+28>>2]}else if((S|0)==2){M=c[ya+4>>2]|0;R=c[M>>2]|0;L=R+8|0;if((c[L>>2]|0)==0){Aa=0}else{Aa=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[L>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Ba=M+4|0}else{L=q9(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Ca=baa((c[g>>2]<<2)+4|0)|0;L=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=q9(q,c[M>>2]|0,L,h,0)|0;if((Da|0)!=0){F=150;break g}R=M+4|0;U=p9(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,L,c[h>>2]|0)|0;L=ya+24|0;c[L>>2]=U;caa(Ca);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=R}}R=c[Ba>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}L=q9(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Ea=baa((c[g>>2]<<2)+4|0)|0;L=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=q9(q,c[Ba>>2]|0,L,h,0)|0;if((Fa|0)!=0){F=157;break g}R=p9(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,L,c[h>>2]|0)|0;L=ya+28|0;c[L>>2]=R;caa(Ea);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){L=c[ya>>2]|0;if((L|0)==1){R=r9(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,2)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;M=r9(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=r9(q,0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=r9(q,c[c[R>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=r9(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((L|0)==3){M=r9(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=r9(q,1)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;R=r9(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,c[c[M>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((L|0)==2){R=r9(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,3)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,c[c[ya+4>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=r9(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((L|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;M=L+8|0;U=c[M>>2]|0;ba=B9(s,0,0,1,64)|0;if((ba|0)==0){F=104;break g}la=ba;c[ba>>2]=U;c[ba+4>>2]=0;c[ba+8>>2]=1114111;c[ba+20>>2]=0;c[ba+24>>2]=0;U=ba+28|0;ba=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=la;la=c[M>>2]|0;M=c[L+4>>2]|0;ba=B9(s,0,0,1,64)|0;if((ba|0)==0){F=106;break g}c[ba>>2]=la;c[ba+4>>2]=0;c[ba+8>>2]=1114111;c[ba+20>>2]=0;c[ba+24>>2]=0;c[ba+28>>2]=M;c[ba+32>>2]=-1;c[ba+36>>2]=-1;c[ba+40>>2]=-1;c[ya+28>>2]=ba;break}ba=ya+8|0;if((R|0)<0){c[ba>>2]=1;M=B9(s,0,0,1,32)|0;if((M|0)==0){F=110;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+24>>2]=M;M=B9(s,0,0,1,32)|0;if((M|0)==0){F=112;break g}c[M>>2]=-1;c[M+4>>2]=-1;c[M+8>>2]=-1;c[ya+28>>2]=M;break}else{c[ba>>2]=0;ba=L+8|0;M=c[ba>>2]|0;la=L+4|0;U=c[la>>2]|0;ma=B9(s,0,0,1,64)|0;if((ma|0)==0){F=115;break g}ka=ma;c[ma>>2]=M;c[ma+4>>2]=R;c[ma+8>>2]=U;c[ma+20>>2]=0;c[ma+24>>2]=0;U=ma+28|0;ma=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ma>>2]=ka;ka=c[ba>>2]|0;ba=c[L>>2]|0;ma=c[la>>2]|0;la=c[L+12>>2]|0;U=c[L+16>>2]|0;L=B9(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=ka;c[L+4>>2]=ba;c[L+8>>2]=ma;c[L+20>>2]=la;c[L+24>>2]=U;U=L+28|0;L=ya+28|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[L>>2]=R;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){caa(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){caa(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=baa(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=baa(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){Jaa(O|0,0,((E|0)>1?E<<2:4)|0)|0}m9(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;L=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=L}else{Ga=L;break}}}else{Ga=0}K=daa(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=m9(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){R=1;U=S;while(1){S=U+32|0;la=R+1|0;if((c[S>>2]|0)>-1){U=S;R=la}else{Ha=la;break}}}else{Ha=1}R=daa(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;U=c[L>>2]|0;y=c[U>>2]|0;if((y|0)>-1){la=y;y=U;U=0;while(1){c[R+(U<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[R+(U<<5)+12>>2]=la;S=R+(U<<5)+16|0;c[S>>2]=0;ma=y+12|0;ba=c[ma>>2]|0;if((ba|0)!=0){ka=0;while(1){Ia=ka+1|0;if((c[ba+(ka<<2)>>2]|0)>-1){ka=Ia}else{break}}ka=Ia<<2;ba=baa(ka)|0;c[S>>2]=ba;if((ba|0)==0){z=x;A=12;B=u;C=D;break a}Haa(ba|0,c[ma>>2]|0,ka|0)|0}c[R+(U<<5)+20>>2]=c[y+16>>2];ka=U+1|0;ba=y+32|0;M=c[ba>>2]|0;if((M|0)>-1){la=M;y=ba;U=ka}else{Ja=ka;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;A9(s);caa(c[p+16>>2]|0);caa(p);caa(O);caa(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);A9(s);caa(c[p+16>>2]|0);caa(p);if((z|0)!=0){caa(z)}if((B|0)!=0){caa(B)}c[b+4>>2]=C;n9(b);r=A;i=f;return r|0}function k9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;r9(m,c[p>>2]|0)|0;r9(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=r9(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 5:{Q=c[q>>2]|0;R=a[Q]|0;if(R<<24>>24==0){S=M;T=N;U=0;break c}V=c[v>>2]&1;W=(V|0)!=0;if(W&R<<24>>24==124){S=M;T=N;U=0;break c}do{if(!(W&R<<24>>24==41&(M|0)>0)){if((V|0)==0&R<<24>>24==92){if((a[Q+1|0]|0)==41){break}}X=r9(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=r9(m,N)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=r9(m,6)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}S=M;T=N;U=r9(m,4)|0;break c}}while(0);R=(V|M|0)==0?8:0;W=M+ -1|0;if((V|0)!=0){S=W;T=N;U=R;break c}c[q>>2]=Q+2;S=W;T=N;U=R;break};case 7:{R=c[q>>2]|0;W=a[R]|0;if((W|0)==41){c[q>>2]=R+1;S=M;T=N;U=0;break c}else if((W|0)!=124){S=M;T=N;U=0;break c}W=r9(m,7)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}W=r9(m,N)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}W=r9(m,8)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}W=r9(m,3)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}c[q>>2]=(c[q>>2]|0)+1;S=M;T=N;U=0;break};case 9:{W=c[q>>2]|0;R=a[W]|0;switch(R<<24>>24|0){case 92:{X=c[v>>2]|0;if((X&1|0)!=0){S=M;T=N;U=0;break c}$=W+1|0;if((a[$]|0)!=123){S=M;T=N;U=0;break c}c[q>>2]=$;aa=X;ba=$;break};case 42:{_=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){S=M;T=N;U=0;break c}else{_=41}break};case 123:{$=c[v>>2]|0;if(($&1|0)==0){S=M;T=N;U=0;break c}else{aa=$;ba=W}break};default:{S=M;T=N;U=0;break c}}if((_|0)==41){_=0;c[q>>2]=W+1;W=c[w>>2]|0;$=B9(W,0,0,1,32)|0;if(($|0)==0){ca=12;_=294;break b}X=B9(W,0,0,1,16)|0;c[$+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[$>>2]=2;c[$+8>>2]=-1;c[$+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=R<<24>>24==43;c[X+8>>2]=R<<24>>24==63?1:-1;R=X+12|0;a[R]=a[R]&-2;c[$+16>>2]=c[N+16>>2];S=M;T=$;U=r9(m,9)|0;break c}$=ba+1|0;c[q>>2]=$;R=a[$]|0;if((R+ -48<<24>>24&255)<10){X=R<<24>>24;if((X+ -48|0)>>>0<10){da=X;ea=-1;fa=$}else{ca=10;_=294;break b}while(1){X=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;W=fa+1|0;ga=a[W]|0;ha=ga<<24>>24;if((ha+ -48|0)>>>0<10){fa=W;ea=X;da=ha}else{ia=ga;ja=X;ka=W;break}}}else{ia=R;ja=-1;ka=$}do{if(ia<<24>>24==44){Q=ka+1|0;V=a[Q]|0;W=V<<24>>24;if((W+ -48|0)>>>0<10){la=W;ma=-1;na=Q}else{oa=V;pa=-1;qa=Q;break}while(1){Q=((ma|0)<0?-48:(ma*10|0)+ -48|0)+la|0;V=na+1|0;W=a[V]|0;X=W<<24>>24;if((X+ -48|0)>>>0<10){na=V;ma=Q;la=X}else{ra=W;sa=Q;ta=V;_=54;break}}}else{ra=ia;sa=ja;ta=ka;_=54}}while(0);do{if((_|0)==54){_=0;if(!((sa|0)>-1)){oa=ra;pa=sa;qa=ta;break}if((ja|0)>(sa|0)|(sa|0)>255){ca=10;_=294;break b}else{oa=ra;pa=sa;qa=ta}}}while(0);if(oa<<24>>24==0){ca=9;_=294;break b}if((qa|0)==($|0)){ca=10;_=294;break b}if((aa&1|0)==0){if(!(oa<<24>>24==92)){ca=10;_=294;break b}if((a[qa+1|0]|0)!=125){ca=10;_=294;break b}ua=qa+2|0}else{if(!(oa<<24>>24==125)){ca=10;_=294;break b}ua=qa+1|0}if((pa|ja|0)==0){R=c[w>>2]|0;V=B9(R,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=B9(R,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;va=V}else{V=(pa&ja|0)<0;Q=c[w>>2]|0;R=B9(Q,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}W=B9(Q,0,0,1,16)|0;c[R+4>>2]=W;if((W|0)==0){ca=12;_=294;break b}c[R>>2]=2;c[R+8>>2]=-1;c[R+12>>2]=-1;c[W>>2]=N;c[W+4>>2]=V?1:ja;c[W+8>>2]=V?1:pa;V=W+12|0;a[V]=a[V]&-2;c[R+16>>2]=c[N+16>>2];va=R}c[q>>2]=ua;S=M;T=va;U=r9(m,9)|0;break};case 8:{R=L+ -2|0;c[n>>2]=R;V=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;W=B9(R,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}Q=B9(R,0,0,1,8)|0;R=W+4|0;c[R>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[W>>2]=3;c[W+8>>2]=-1;c[W+12>>2]=-1;c[Q>>2]=V;c[(c[R>>2]|0)+4>>2]=N;c[W+16>>2]=(c[N+16>>2]|0)+(c[V+16>>2]|0);S=M;T=W;U=0;break};case 6:{W=L+ -2|0;c[n>>2]=W;V=c[P+(W<<2)>>2]|0;W=c[w>>2]|0;R=B9(W,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}Q=B9(W,0,0,1,8)|0;W=R+4|0;c[W>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[R>>2]=1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=V;c[(c[W>>2]|0)+4>>2]=N;c[R+16>>2]=(c[N+16>>2]|0)+(c[V+16>>2]|0);S=M;T=R;U=0;break};case 10:{R=L+ -2|0;c[n>>2]=R;c[v>>2]=c[P+(R<<2)>>2];S=M;T=N;U=0;break};case 1:{R=c[q>>2]|0;d:do{switch(a[R]|0){case 40:{if((c[v>>2]&1|0)!=0){wa=R;_=74}break};case 41:{if((M|0)!=0){_=264}break};case 63:case 43:case 123:case 124:case 42:{_=264;break};case 94:{if((c[v>>2]&1|0)==0){if((R|0)!=(c[r>>2]|0)){break d}V=r9(m,5)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}}V=c[w>>2]|0;W=B9(V,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}Q=B9(V,0,0,1,20)|0;c[W+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=W;U=0;break c;break};case 0:{_=265;break};case 91:{W=R+1|0;c[q>>2]=W;Q=baa(128)|0;if((Q|0)==0){ca=12;_=294;break b}if((a[W]|0)==94){V=R+2|0;c[q>>2]=V;xa=V;ya=1}else{xa=W;ya=0}W=(ya|0)==0;V=Q;Q=0;X=0;ga=32;ha=xa;e:while(1){za=a[ha]|0;if(za<<24>>24==93){if(ha>>>0>(c[q>>2]|0)>>>0){_=85;break}}else if(za<<24>>24==0){Aa=V;Ba=ha;Ca=7;_=140;break}za=f9(e,ha,-1)|0;if((za|0)<0){c[e>>2]=-1;Da=1}else{Da=za}za=ha+Da|0;do{if((a[za]|0)==45){Ea=Da+1|0;Fa=ha+Ea|0;if((a[Fa]|0)==93){_=94;break}Ga=c[e>>2]|0;Ha=f9(e,Fa,-1)|0;if((Ha|0)<0){c[e>>2]=-1;Ia=-1;Ja=1}else{Ia=c[e>>2]|0;Ja=Ha}Ka=0;La=Ia;Ma=Ga;Na=ha+(Ja+Ea)|0;Oa=Ga>>>0>Ia>>>0?11:0}else{_=94}}while(0);f:do{if((_|0)==94){_=0;Ga=a[ha]|0;do{if(Ga<<24>>24==91){Ea=a[ha+1|0]|0;if(Ea<<24>>24==61|Ea<<24>>24==46){Aa=V;Ba=ha;Ca=3;_=140;break e}else if(!(Ea<<24>>24==58)){Pa=0;break}Ea=ha+2|0;Ha=Ea;while(1){Fa=a[Ha]|0;Qa=Fa<<24>>24==0;if(Fa<<24>>24!=58&(Qa^1)){Ha=Ha+1|0}else{break}}if(Qa){Aa=V;Ba=ha;Ca=4;_=140;break e}Fa=Ha-ha+ -2|0;Ra=(Fa|0)>63?63:Fa;Qaa(A|0,Ea|0,Ra|0)|0;a[f+Ra|0]=0;Ra=R8(A)|0;Ka=Ra;La=1114111;Ma=0;Na=Ha+2|0;Oa=(Ra|0)==0?4:0;break f}else if(Ga<<24>>24==45){if((a[ha+1|0]|0)==93){Pa=0;break}Pa=(c[q>>2]|0)==(ha|0)?0:11}else{Pa=0}}while(0);Ga=c[e>>2]|0;Ka=0;La=Ga;Ma=Ga;Na=za;Oa=Pa}}while(0);if((Oa|0)!=0){Aa=V;Ba=Na;Ca=Oa;_=140;break}za=(Ka|0)!=0;do{if(W|za^1){Ga=c[w>>2]|0;if((X|0)<(ga|0)){Sa=V;Ta=ga}else{if((ga|0)>1024){Aa=V;Ba=Na;Ca=12;_=140;break e}Ra=eaa(V,ga<<3)|0;if((Ra|0)==0){Aa=V;Ba=Na;Ca=12;_=140;break e}else{Sa=Ra;Ta=ga<<1}}Ra=B9(Ga,0,0,1,32)|0;if((Ra|0)==0){_=112;break e}Fa=B9(Ga,0,0,1,20)|0;Ga=Ra+4|0;c[Ga>>2]=Fa;if((Fa|0)==0){_=112;break e}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[Fa>>2]=Ma;c[Fa+4>>2]=La;c[Fa+8>>2]=-1;c[Sa+(X<<2)>>2]=Ra;c[(c[Ga>>2]|0)+12>>2]=Ka;Ua=Sa;Va=Q;Wa=X+1|0;Xa=Ta;Ya=0}else{if((Q|0)>63){Ua=V;Va=Q;Wa=X;Xa=ga;Ya=12;break}c[g+(Q<<2)>>2]=Ka;Ua=V;Va=Q+1|0;Wa=X;Xa=ga;Ya=0}}while(0);Ga=(Ya|0)==0;if(Ga&(((c[v>>2]&2|0)==0|za)^1)){Za=Ua;_a=Wa;$a=Xa;ab=Ma}else{if(Ga){V=Ua;Q=Va;X=Wa;ga=Xa;ha=Na;continue}else{Aa=Ua;Ba=Na;Ca=Ya;_=140;break}}while(1){Ga=ab;while(1){if(Ga>>>0>La>>>0){V=Za;Q=Va;X=_a;ga=$a;ha=Na;continue e}if((U8(Ga)|0)!=0){_=118;break}bb=Ga+1|0;if((Y8(Ga)|0)==0){Ga=bb}else{_=129;break}}if((_|0)==118){_=0;Ra=_8(Ga)|0;Fa=Ga+1|0;g:do{if((U8(Fa)|0)==0){cb=Ra;db=Fa}else{eb=Ra;fb=Fa;while(1){if((_8(fb)|0)!=(eb+1|0)|fb>>>0>La>>>0){cb=eb;db=fb;break g}gb=_8(fb)|0;hb=fb+1|0;if((U8(hb)|0)==0){cb=gb;db=hb;break}else{eb=gb;fb=hb}}}}while(0);Fa=c[w>>2]|0;if((_a|0)<($a|0)){ib=Za;jb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;_=140;break e}fb=eaa(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;_=140;break e}else{ib=fb;jb=$a<<1}}fb=B9(Fa,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){kb=0}else{Ha=B9(Fa,0,0,1,20)|0;c[fb+4>>2]=Ha;if((Ha|0)==0){kb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Ha>>2]=Ra;c[Ha+4>>2]=cb;c[Ha+8>>2]=-1;kb=eb}}while(0);c[ib+(_a<<2)>>2]=kb;lb=kb;mb=ib;nb=jb;ob=db}else if((_|0)==129){_=0;eb=a9(Ga)|0;h:do{if((Y8(bb)|0)==0){pb=eb;qb=bb}else{Ra=eb;fb=bb;while(1){if((a9(fb)|0)!=(Ra+1|0)|fb>>>0>La>>>0){pb=Ra;qb=fb;break h}Fa=fb+1|0;Ha=a9(fb)|0;if((Y8(Fa)|0)==0){pb=Ha;qb=Fa;break}else{Ra=Ha;fb=Fa}}}}while(0);Ga=c[w>>2]|0;if((_a|0)<($a|0)){rb=Za;sb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;_=140;break e}fb=eaa(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;_=140;break e}else{rb=fb;sb=$a<<1}}fb=B9(Ga,0,0,1,32)|0;Ra=fb;do{if((fb|0)==0){tb=0}else{Fa=B9(Ga,0,0,1,20)|0;c[fb+4>>2]=Fa;if((Fa|0)==0){tb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=pb;c[Fa+8>>2]=-1;tb=Ra}}while(0);c[rb+(_a<<2)>>2]=tb;lb=tb;mb=rb;nb=sb;ob=qb}if((lb|0)==0){_=141;break e}else{Za=mb;_a=_a+1|0;$a=nb;ab=ob}}}i:do{if((_|0)==85){_=0;c[q>>2]=ha+1;ga=(ya|0)!=0;if(ga){fc(V|0,X|0,4,63)}j:do{if((X|0)>0){W=(Q|0)>0;za=Q<<2;Ra=za+4|0;if(ga){ub=0;vb=0;wb=0;xb=0}else{eb=0;fb=0;while(1){Ga=V+(eb<<2)|0;Fa=c[(c[Ga>>2]|0)+4>>2]|0;do{if((Fa|0)==0){yb=fb;zb=0}else{c[Fa+8>>2]=c[x>>2];if(W){Ha=B9(c[w>>2]|0,0,0,0,Ra)|0;Ea=Fa+16|0;c[Ea>>2]=Ha;if((Ha|0)==0){Ab=V;Bb=fb;Cb=12;break i}Haa(Ha|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(Q<<2)>>2]=0}else{c[Fa+16>>2]=0}if((fb|0)==0){yb=c[Ga>>2]|0;zb=0;break}Ea=c[w>>2]|0;Ha=c[Ga>>2]|0;hb=B9(Ea,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){Db=0}else{Eb=B9(Ea,0,0,1,8)|0;Fb=hb+4|0;c[Fb>>2]=Eb;if((Eb|0)==0){Db=0;break}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Eb>>2]=fb;c[(c[Fb>>2]|0)+4>>2]=Ha;c[hb+16>>2]=(c[Ha+16>>2]|0)+(c[fb+16>>2]|0);Db=gb}}while(0);yb=Db;zb=(Db|0)==0?12:0}}while(0);Ga=eb+1|0;if((Ga|0)<(X|0)&(zb|0)==0){eb=Ga;fb=yb}else{Gb=0;Hb=yb;Ib=zb;break j}}}while(1){fb=V+(wb<<2)|0;eb=c[(c[fb>>2]|0)+4>>2]|0;Ga=c[eb>>2]|0;Fa=eb+4|0;gb=c[Fa>>2]|0;do{if((Ga|0)<(ub|0)){Ha=gb+1|0;Jb=(Ha|0)<(ub|0)?ub:Ha;Kb=vb;Lb=xb;Mb=0}else{if((Ga|0)<=(vb|0)){Ha=gb+1|0;Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb>>2]=vb;c[Fa>>2]=Ga+ -1;Ha=gb+1|0;if((eb|0)==0){Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb+8>>2]=c[x>>2];if(W){hb=B9(c[w>>2]|0,0,0,0,Ra)|0;Ea=eb+16|0;c[Ea>>2]=hb;if((hb|0)==0){Ab=V;Bb=xb;Cb=12;break i}Haa(hb|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(Q<<2)>>2]=0}else{c[eb+16>>2]=0}if((xb|0)==0){Jb=Ha;Kb=Ha;Lb=c[fb>>2]|0;Mb=0;break}Ea=c[w>>2]|0;hb=c[fb>>2]|0;Fb=B9(Ea,0,0,1,32)|0;Eb=Fb;do{if((Fb|0)==0){Nb=0}else{Ob=B9(Ea,0,0,1,8)|0;Pb=Fb+4|0;c[Pb>>2]=Ob;if((Ob|0)==0){Nb=0;break}c[Fb>>2]=3;c[Fb+8>>2]=-1;c[Fb+12>>2]=-1;c[Ob>>2]=xb;c[(c[Pb>>2]|0)+4>>2]=hb;c[Fb+16>>2]=(c[hb+16>>2]|0)+(c[xb+16>>2]|0);Nb=Eb}}while(0);Jb=Ha;Kb=Ha;Lb=Nb;Mb=(Nb|0)==0?12:0}}while(0);fb=wb+1|0;if((fb|0)<(X|0)&(Mb|0)==0){ub=Jb;vb=Kb;wb=fb;xb=Lb}else{Gb=Kb;Hb=Lb;Ib=Mb;break}}}else{Gb=0;Hb=0;Ib=0}}while(0);if((Ib|0)!=0|ga^1){Ab=V;Bb=Hb;Cb=Ib;break}za=c[w>>2]|0;Ra=c[x>>2]|0;W=B9(za,0,0,1,32)|0;fb=W;if((W|0)==0){Ab=V;Bb=Hb;Cb=12;break}eb=B9(za,0,0,1,20)|0;c[W+4>>2]=eb;if((eb|0)==0){Ab=V;Bb=Hb;Cb=12;break}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[eb>>2]=Gb;c[eb+4>>2]=1114111;c[eb+8>>2]=Ra;if((Q|0)>0){Ra=Q<<2;za=B9(c[w>>2]|0,0,0,0,Ra+4|0)|0;gb=eb+16|0;c[gb>>2]=za;if((za|0)==0){Ab=V;Bb=Hb;Cb=12;break}Haa(za|0,z|0,Ra|0)|0;c[(c[gb>>2]|0)+(Q<<2)>>2]=0}else{c[eb+16>>2]=0}if((Hb|0)==0){Ab=V;Bb=fb;Cb=0;break}eb=c[w>>2]|0;gb=B9(eb,0,0,1,32)|0;Ra=gb;do{if((gb|0)==0){Qb=0}else{za=B9(eb,0,0,1,8)|0;Ga=gb+4|0;c[Ga>>2]=za;if((za|0)==0){Qb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[za>>2]=Hb;c[(c[Ga>>2]|0)+4>>2]=fb;c[gb+16>>2]=(c[W+16>>2]|0)+(c[Hb+16>>2]|0);Qb=Ra}}while(0);Ab=V;Bb=Qb;Cb=(Qb|0)==0?12:0}else if((_|0)==112){_=0;c[Sa+(X<<2)>>2]=0;Aa=Sa;Ba=Na;Ca=12;_=140}else if((_|0)==141){_=0;c[q>>2]=Na;Ab=mb;Bb=0;Cb=12}}while(0);if((_|0)==140){_=0;c[q>>2]=Ba;Ab=Aa;Bb=0;Cb=Ca}caa(Ab);c[x>>2]=(c[x>>2]|0)+1;if((Cb|0)==0){S=M;T=Bb;U=0;break c}else{ca=Cb;_=294;break b}break};case 92:{X=R+1|0;V=a[X]|0;do{if((c[v>>2]&1|0)==0){if(V<<24>>24==40){c[q>>2]=X;wa=X;_=74;break d}else{Q=a[R+1|0]|0;if(Q<<24>>24==41){_=265;break d}else{Rb=Q;break}}}else{Rb=V}}while(0);V=R+1|0;X=Rb<<24>>24==0;if(X){ca=5;_=294;break b}else{Sb=152540|0;Tb=0}while(1){Q=Tb+1|0;if((a[152536+(Tb<<3)|0]|0)==Rb<<24>>24){Ub=Sb;break}ha=152540+(Q<<3)|0;if((Q|0)==12){Ub=ha;break}else{Sb=ha;Tb=Q}}Q=c[Ub>>2]|0;if((Q|0)!=0){ha=F+0|0;Ra=G+0|0;W=ha+40|0;do{c[ha>>2]=c[Ra>>2];ha=ha+4|0;Ra=Ra+4|0}while((ha|0)<(W|0));c[H>>2]=Q;c[I>>2]=1;Ra=k9(j)|0;if((Ra|0)!=0){ca=Ra;_=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];S=M;T=c[K>>2]|0;U=0;break c}if(X){ca=5;_=294;break b}c[q>>2]=V;Ra=a[V]|0;k:do{switch(Ra|0){case 62:{ha=c[w>>2]|0;W=B9(ha,0,0,1,32)|0;gb=W;do{if((W|0)==0){Vb=0}else{fb=B9(ha,0,0,1,20)|0;c[W+4>>2]=fb;if((fb|0)==0){Vb=0;break}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=32;c[fb+8>>2]=-1;Vb=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=Vb;break};case 120:{gb=R+2|0;c[q>>2]=gb;W=a[gb]|0;if(W<<24>>24==123){gb=R+3|0;c[q>>2]=gb;ha=gb;gb=0;while(1){fb=a[ha]|0;if(fb<<24>>24==0|fb<<24>>24==125){Yb=gb;Zb=ha;break}if((Z8(fb<<24>>24)|0)==0){ca=9;_=294;break b}fb=c[q>>2]|0;a[l+gb|0]=a[fb]|0;eb=gb+1|0;ga=fb+1|0;c[q>>2]=ga;if(eb>>>0>31){Yb=eb;Zb=ga;break}else{ha=ga;gb=eb}}c[q>>2]=Zb+1;a[l+Yb|0]=0;gb=Wb(C|0,0,16)|0;ha=c[w>>2]|0;eb=c[x>>2]|0;ga=B9(ha,0,0,1,32)|0;fb=ga;do{if((ga|0)==0){_b=0}else{Ga=B9(ha,0,0,1,20)|0;c[ga+4>>2]=Ga;if((Ga|0)==0){_b=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Ga>>2]=gb;c[Ga+4>>2]=gb;c[Ga+8>>2]=eb;_b=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Xb=_b;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;fb=(Z8(W<<24>>24)|0)==0;eb=c[q>>2]|0;if(fb){$b=eb}else{a[D]=a[eb]|0;fb=eb+1|0;c[q>>2]=fb;$b=fb}if((Z8(a[$b]|0)|0)!=0){fb=c[q>>2]|0;a[E]=a[fb]|0;c[q>>2]=fb+1}fb=Wb(D|0,0,16)|0;eb=c[w>>2]|0;gb=c[x>>2]|0;ga=B9(eb,0,0,1,32)|0;ha=ga;do{if((ga|0)==0){ac=0}else{Ga=B9(eb,0,0,1,20)|0;c[ga+4>>2]=Ga;if((Ga|0)==0){ac=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Ga>>2]=fb;c[Ga+4>>2]=fb;c[Ga+8>>2]=gb;ac=ha}}while(0);c[x>>2]=(c[x>>2]|0)+1;Xb=ac;break k}break};case 66:{ha=c[w>>2]|0;gb=B9(ha,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){bc=0}else{ga=B9(ha,0,0,1,20)|0;c[gb+4>>2]=ga;if((ga|0)==0){bc=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=128;c[ga+8>>2]=-1;bc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=bc;break};case 60:{fb=c[w>>2]|0;gb=B9(fb,0,0,1,32)|0;ha=gb;do{if((gb|0)==0){cc=0}else{ga=B9(fb,0,0,1,20)|0;c[gb+4>>2]=ga;if((ga|0)==0){cc=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=16;c[ga+8>>2]=-1;cc=ha}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=cc;break};case 98:{ha=c[w>>2]|0;gb=B9(ha,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){dc=0}else{ga=B9(ha,0,0,1,20)|0;c[gb+4>>2]=ga;if((ga|0)==0){dc=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=64;c[ga+8>>2]=-1;dc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Xb=dc;break};default:{if((S8(Ra)|0)!=0){fb=(a[c[q>>2]|0]|0)+ -48|0;gb=c[w>>2]|0;ha=c[x>>2]|0;ga=B9(gb,0,0,1,32)|0;if((ga|0)==0){ca=12;_=294;break b}eb=B9(gb,0,0,1,20)|0;c[ga+4>>2]=eb;if((eb|0)==0){ca=12;_=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[eb>>2]=-4;c[eb+4>>2]=fb;c[eb+8>>2]=ha;c[x>>2]=(c[x>>2]|0)+1;ha=c[B>>2]|0;c[B>>2]=(fb|0)<(ha|0)?ha:fb;c[q>>2]=(c[q>>2]|0)+1;S=M;T=ga;U=0;break c}ga=c[w>>2]|0;fb=a[c[q>>2]|0]|0;ha=c[x>>2]|0;eb=B9(ga,0,0,1,32)|0;gb=eb;do{if((eb|0)==0){ec=0}else{W=B9(ga,0,0,1,20)|0;c[eb+4>>2]=W;if((W|0)==0){ec=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[W>>2]=fb;c[W+4>>2]=fb;c[W+8>>2]=ha;ec=gb}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Xb=ec}}}while(0);if((Xb|0)==0){ca=12;_=294;break b}else{S=M;T=Xb;U=0;break c}break};case 36:{if((c[v>>2]&1|0)==0){if((a[R+1|0]|0)!=0){break d}}Ra=c[w>>2]|0;V=B9(Ra,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}X=B9(Ra,0,0,1,20)|0;c[V+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=2;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=V;U=0;break c;break};case 46:{V=(c[v>>2]&4|0)==0;X=c[w>>2]|0;Ra=c[x>>2]|0;Q=B9(X,0,0,1,32)|0;gb=Q;ha=(Q|0)==0;if(V){if(ha){ca=12;_=294;break b}V=B9(X,0,0,1,20)|0;c[Q+4>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[V>>2]=0;c[V+4>>2]=1114111;c[V+8>>2]=Ra;gc=gb;hc=(c[x>>2]|0)+1|0}else{if(ha){ca=12;_=294;break b}ha=B9(X,0,0,1,20)|0;c[Q+4>>2]=ha;if((ha|0)==0){ca=12;_=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[ha>>2]=0;c[ha+4>>2]=9;c[ha+8>>2]=Ra;Ra=c[w>>2]|0;ha=(c[x>>2]|0)+1|0;X=B9(Ra,0,0,1,32)|0;if((X|0)==0){ca=12;_=294;break b}V=B9(Ra,0,0,1,20)|0;c[X+4>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[V>>2]=11;c[V+4>>2]=1114111;c[V+8>>2]=ha;ha=c[w>>2]|0;V=B9(ha,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Ra=B9(ha,0,0,1,8)|0;ha=V+4|0;c[ha>>2]=Ra;if((Ra|0)==0){ca=12;_=294;break b}c[V>>2]=3;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Ra>>2]=gb;c[(c[ha>>2]|0)+4>>2]=X;c[V+16>>2]=(c[X+16>>2]|0)+(c[Q+16>>2]|0);gc=V;hc=(c[x>>2]|0)+2|0}c[x>>2]=hc;c[q>>2]=(c[q>>2]|0)+1;S=M;T=gc;U=0;break c;break};default:{}}}while(0);if((_|0)==74){_=0;$=M+1|0;c[q>>2]=wa+1;V=r9(m,c[y>>2]|0)|0;if((V|0)!=0){Y=$;Z=V;_=6;break b}V=r9(m,2)|0;if((V|0)!=0){Y=$;Z=V;_=6;break b}V=r9(m,0)|0;if((V|0)!=0){Y=$;Z=V;_=6;break b}c[y>>2]=(c[y>>2]|0)+1;S=$;T=N;U=0;break c}else if((_|0)==264){_=0;if((c[v>>2]&1|0)!=0){_=265}}if((_|0)==265){_=0;$=c[w>>2]|0;V=B9($,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=B9($,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;S=M;T=V;U=0;break c}V=f9(h,R,-1)|0;if((V|0)<0){c[h>>2]=-1;ic=1}else{ic=V}do{if((c[v>>2]&2|0)==0){_=280}else{if((Y8(c[h>>2]|0)|0)==0){if((U8(c[h>>2]|0)|0)==0){_=280;break}}V=c[w>>2]|0;Q=_8(c[h>>2]|0)|0;$=_8(c[h>>2]|0)|0;X=c[x>>2]|0;ha=B9(V,0,0,1,32)|0;if((ha|0)==0){ca=12;_=294;break b}gb=B9(V,0,0,1,20)|0;c[ha+4>>2]=gb;if((gb|0)==0){ca=12;_=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[gb>>2]=Q;c[gb+4>>2]=$;c[gb+8>>2]=X;X=c[w>>2]|0;gb=a9(c[h>>2]|0)|0;$=a9(c[h>>2]|0)|0;Q=c[x>>2]|0;V=B9(X,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Ra=B9(X,0,0,1,20)|0;c[V+4>>2]=Ra;if((Ra|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Ra>>2]=gb;c[Ra+4>>2]=$;c[Ra+8>>2]=Q;Q=c[w>>2]|0;Ra=B9(Q,0,0,1,32)|0;if((Ra|0)==0){ca=12;_=294;break b}$=B9(Q,0,0,1,8)|0;Q=Ra+4|0;c[Q>>2]=$;if(($|0)==0){ca=12;_=294;break b}c[Ra>>2]=3;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[$>>2]=ha;c[(c[Q>>2]|0)+4>>2]=V;c[Ra+16>>2]=(c[V+16>>2]|0)+(c[ha+16>>2]|0);jc=Ra}}while(0);if((_|0)==280){_=0;R=c[w>>2]|0;Ra=c[h>>2]|0;ha=c[x>>2]|0;V=B9(R,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=B9(R,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=Ra;c[Q+4>>2]=Ra;c[Q+8>>2]=ha;jc=V}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+ic;S=M;T=jc;U=0;break};case 2:{V=L+ -2|0;c[n>>2]=V;ha=c[P+(V<<2)>>2]|0;if((c[N+12>>2]|0)>-1){V=c[w>>2]|0;Q=B9(V,0,0,1,32)|0;if((Q|0)==0){ca=12;_=294;break b}Ra=B9(V,0,0,1,20)|0;c[Q+4>>2]=Ra;if((Ra|0)==0){ca=12;_=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Ra>>2]=-1;c[Ra+4>>2]=-1;c[Ra+8>>2]=-1;Ra=c[w>>2]|0;V=B9(Ra,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}R=B9(Ra,0,0,1,8)|0;Ra=V+4|0;c[Ra>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[V>>2]=1;c[V+8>>2]=-1;c[V+12>>2]=-1;c[R>>2]=Q;c[(c[Ra>>2]|0)+4>>2]=N;Ra=N+16|0;R=V+16|0;c[R>>2]=(c[Ra>>2]|0)+(c[Q+16>>2]|0);c[R>>2]=c[Ra>>2];kc=V}else{kc=N}c[kc+12>>2]=ha;ha=kc+16|0;c[ha>>2]=(c[ha>>2]|0)+1;S=M;T=kc;U=0;break};case 0:{if((c[v>>2]&1|0)!=0){ha=r9(m,7)|0;if((ha|0)!=0){Y=M;Z=ha;_=6;break b}}S=M;T=N;U=r9(m,3)|0;break};case 3:{ha=r9(m,5)|0;if((ha|0)!=0){Y=M;Z=ha;_=6;break b}S=M;T=N;U=r9(m,4)|0;break};case 4:{ha=r9(m,9)|0;if((ha|0)!=0){Y=M;Z=ha;_=6;break b}S=M;T=N;U=r9(m,1)|0;break};default:{S=M;T=N;U=0}}}while(0);P=c[n>>2]|0;O=(U|0)==0;if((P|0)>(o|0)&O){L=P;M=S;N=T}else{lc=O;mc=S;nc=T;oc=U;break a}}if((_|0)==6){lc=(Z|0)==0;mc=Y;nc=N;oc=Z;break}else if((_|0)==294){i=d;return ca|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){ca=p?8:oc;i=d;return ca|0}c[b+8>>2]=nc;ca=0;i=d;return ca|0}function l9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=baa((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=baa((l<<2)+4|0)|0;if((p|0)==0){caa(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}r9(d,e)|0;e=r9(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{G=A+(E<<2)|0;E=E+1|0}while((c[G>>2]|0)>-1);c[G>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{I=v;J=w;K=x;L=y;M=z;N=E;O=0;P=B;break}}break};case 3:{E=c[D+(u+ -2<<2)>>2]|0;H=c[D+(u+ -3<<2)>>2]|0;F=c[D+(u+ -4<<2)>>2]|0;Q=u+ -5|0;c[h>>2]=Q;if(k){R=c[F+4>>2]|0;S=F+16|0;c[F+20>>2]=(c[(c[R>>2]|0)+20>>2]|0)+(c[D+(Q<<2)>>2]|0)+(c[(c[R+4>>2]|0)+20>>2]|0)+((c[S>>2]|0)>0?2:0);T=S;U=c[h>>2]|0}else{T=F+16|0;U=Q}Q=c[D+(U+ -1<<2)>>2]|0;F=U+ -2|0;c[h>>2]=F;S=c[D+(F<<2)>>2]|0;F=U+ -3|0;c[h>>2]=F;R=c[D+(F<<2)>>2]|0;if((c[T>>2]|0)<=0){I=1;J=w;K=x;L=y;M=z;N=Q;O=0;P=B;break b}if(k){V=0}else{u9(b,E,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;S=u9(b,H,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;V=S}I=1;J=w;K=x;L=y;M=z+2|0;N=Q;O=V;P=B;break};case 0:{Q=u+ -2|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;Q=S;R=S+12|0;H=c[R>>2]|0;if((H|0)>-1){E=0;do{W=A+(E<<2)|0;E=E+1|0}while((c[W>>2]|0)>-1);c[W>>2]=H<<1;c[A+(E<<2)>>2]=-1;do{if(!k){F=0;while(1){if((c[p+(F<<2)>>2]|0)>-1){F=F+1|0}else{break}}c[(c[s>>2]|0)+(H*12|0)+8>>2]=0;if((F|0)<=0){break}X=baa((F<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(H*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);H=r9(d,c[R>>2]|0)|0;if((H|0)!=0){Z=w;_=y;$=z;aa=A;ba=H;ca=B;break a}H=r9(d,6)|0;if((H|0)!=0){Z=w;_=y;$=z;aa=A;ba=H;ca=B;break a}}H=c[S>>2]|0;do{if((H|0)==0){E=c[c[S+4>>2]>>2]|0;if(!((E|0)>-1|(E|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[S+20>>2]=1;ra=w;sa=y;ta=0}else{E=t9(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;fa=0;while(1){ua=ea+(fa<<2)|0;va=fa+1|0;if((c[ua>>2]|0)>-1){fa=va}else{break}}c[ua>>2]=B;c[ea+(va<<2)>>2]=w;c[ea+(fa+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;X=Y;Y=0;do{F=(X|0)/2|0;if((X&1|0)==0){c[da+(F*12|0)>>2]=B}else{c[da+(F*12|0)+4>>2]=B}Y=Y+1|0;X=c[A+(Y<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=E}c[A>>2]=-1;ka=v;la=ra;ma=x+1|0;na=sa;oa=z+1|0;pa=ta;qa=x}else if((H|0)==2){X=c[S+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ya=1}else{ya=a[X+12|0]&1}Y=r9(d,ya)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=r9(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=r9(d,a[X+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=r9(d,S)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=r9(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=r9(d,c[X>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=r9(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[X+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){za=w;Aa=y;Ba=0}else{Y=t9(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[X+12|0]&1)==0?v:1;if((w|0)>-1){X=c[t>>2]|0;da=0;while(1){Ca=X+(da<<2)|0;Da=da+1|0;if((c[Ca>>2]|0)>-1){da=Da}else{break}}c[Ca>>2]=B;c[X+(Da<<2)>>2]=w;c[X+(da+2<<2)>>2]=-1;Ea=-1;Fa=y+1|0}else{Ea=w;Fa=y}E=c[A>>2]|0;if((E|0)>-1){fa=c[s>>2]|0;ea=E;E=0;do{F=(ea|0)/2|0;if((ea&1|0)==0){c[fa+(F*12|0)>>2]=B}else{c[fa+(F*12|0)+4>>2]=B}E=E+1|0;ea=c[A+(E<<2)>>2]|0;}while((ea|0)>-1)}c[A>>2]=-1;za=Ea;Aa=Fa;Ba=Y}c[A>>2]=-1;ka=0;la=za;ma=x+1|0;na=Aa;oa=z+1|0;pa=Ba;qa=x}else if((H|0)==1){ea=c[S+4>>2]|0;E=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=r9(d,S)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=r9(d,5)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=r9(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=r9(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=E+20|0;da=r9(d,(c[ea>>2]|0)+x|0)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}if((c[ea>>2]|0)>0){ea=(c[fa+20>>2]|0)>0;Ga=(ea&1)+x|0;Ha=ea?x:-1}else{Ga=x;Ha=-1}ea=r9(d,Ha)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=r9(d,4)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ea=r9(d,E)|0;if((ea|0)!=0){ka=v;la=w;ma=Ga;na=y;oa=z;pa=ea;qa=B;break}ka=v;la=w;ma=Ga;na=y;oa=z;pa=r9(d,0)|0;qa=B}else if((H|0)==3){ea=c[S+4>>2]|0;E=c[ea>>2]|0;fa=c[ea+4>>2]|0;ea=(c[A>>2]|0)>-1;da=x+1|0;X=r9(d,ea?da:x)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=r9(d,ea?x:B)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=r9(d,A)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=r9(d,(c[A>>2]|0)>>>31^1)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=r9(d,S)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=fa;fa=r9(d,X)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=E;E=r9(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,3)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,X)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,2)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,fa)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}E=r9(d,0)|0;if((E|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=E;qa=B;break}if((c[A>>2]|0)>-1){if(k){Ia=w;Ja=y;Ka=0}else{E=t9(b,Q,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;X=0;while(1){La=fa+(X<<2)|0;Ma=X+1|0;if((c[La>>2]|0)>-1){X=Ma}else{break}}c[La>>2]=B;c[fa+(Ma<<2)>>2]=w;c[fa+(X+2<<2)>>2]=-1;Na=-1;Oa=y+1|0}else{Na=w;Oa=y}Y=c[A>>2]|0;if((Y|0)>-1){ea=c[s>>2]|0;F=Y;Y=0;do{ia=(F|0)/2|0;if((F&1|0)==0){c[ea+(ia*12|0)>>2]=B}else{c[ea+(ia*12|0)+4>>2]=B}Y=Y+1|0;F=c[A+(Y<<2)>>2]|0;}while((F|0)>-1)}c[A>>2]=-1;Ia=Na;Ja=Oa;Ka=E}c[A>>2]=-1;Pa=Ia;Qa=da;Ra=Ja;Sa=z+1|0;Ta=Ka;Ua=x}else{Pa=w;Qa=x;Ra=y;Sa=z;Ta=0;Ua=B}if((c[S+16>>2]|0)<=0){ka=v;la=Pa;ma=Qa;na=Ra;oa=Sa;pa=Ta;qa=Ua;break}ka=v;la=Pa;ma=Qa+2|0;na=Ra;oa=Sa;pa=Ta;qa=Qa+1|0}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);S=c[R>>2]|0;if((S|0)>-1){Va=0}else{I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=S;c[p+(Va<<2)>>2]=-1;I=ka;J=la;K=ma;L=na;M=oa;N=A;O=pa;P=qa;break};case 4:{R=u+ -2|0;c[h>>2]=R;Q=c[D+(R<<2)>>2]|0;R=u+ -3|0;c[h>>2]=R;I=v;J=w;K=c[D+(R<<2)>>2]|0;L=y;M=z;N=A;O=0;P=(Q|0)>-1?Q:B;break};case 5:{Q=u+ -2|0;c[h>>2]=Q;R=c[D+(Q<<2)>>2]|0;if(!k){I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break b}Q=c[R+4>>2]|0;c[R+20>>2]=(c[(c[Q+4>>2]|0)+20>>2]|0)+(c[(c[Q>>2]|0)+20>>2]|0);I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B;break};case 1:{Q=u+ -2|0;c[h>>2]=Q;R=c[D+(Q<<2)>>2]|0;if(k){Q=c[(c[c[R+4>>2]>>2]|0)+20>>2]|0;H=u+ -3|0;c[h>>2]=H;c[R+20>>2]=(c[D+(H<<2)>>2]|0)+Q;I=v;J=-1;K=x;L=y;M=z;N=A;O=0;P=B;break b}else{Q=u+ -3|0;c[h>>2]=Q;H=c[D+(Q<<2)>>2]|0;Q=u+ -4|0;c[h>>2]=Q;R=(H|0)==0;I=R&1;J=R?w:c[D+(Q<<2)>>2]|0;K=x;L=y;M=z;N=A;O=0;P=B;break b}break};default:{I=v;J=w;K=x;L=y;M=z;N=A;O=0;P=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(O|0)==0){u=D;v=I;w=J;x=K;y=L;z=M;A=N;B=P}else{Z=J;_=L;$=M;aa=N;ba=O;ca=P;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;P=e;e=0;do{O=(P|0)/2|0;if((P&1|0)==0){c[n+(O*12|0)>>2]=ca}else{c[n+(O*12|0)+4>>2]=ca}e=e+1|0;P=c[aa+(e<<2)>>2]|0;}while((P|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}P=c[f+36>>2]|0;e=0;while(1){Ya=P+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[P+(Za<<2)>>2]=Z;c[P+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;caa(m);caa(p);o=ba;i=g;return o|0}function m9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=m9(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){m=j;break}n=c[h>>2]|0;h=o9(c[n+28>>2]|0,c[n+24>>2]|0,b,d,e)|0;if((h|0)==0){m=j}else{k=h;l=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=o9(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=m9(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function n9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{caa(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}caa(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){caa(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){caa(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}caa(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{caa(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}caa(m)}m=c[d+32>>2]|0;if((m|0)!=0){caa(m)}m=c[d+20>>2]|0;if((m|0)!=0){caa(m)}m=c[d+36>>2]|0;if((m|0)!=0){caa(m)}caa(d);i=b;return}function o9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=baa(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){caa(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=baa((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function p9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=B9(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=B9(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=B9(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function q9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=r9(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=r9(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=r9(a,c[r+4>>2]|0)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=r9(a,r)|0}else if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){u=r;v=d;w=0;while(1){x=w+1|0;if((u|0)==(s|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((s|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=s;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){t=r9(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=r9(a,r)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function r9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=eaa(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;r9(a,b)|0;i=d;return 0}return 0}function s9(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;r9(d,e)|0;e=r9(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==1){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=B9(b,0,0,1,32)|0;if((F|0)==0){G=29;break b}H=B9(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=29;break b}c[F>>2]=1;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;c[F>>2]=0;I=F+4|0;c[I>>2]=0;x=r9(d,c[D>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=r9(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=r9(d,I)|0;if((x|0)!=0){v=s;w=x;break a}x=r9(d,1)|0;if((x|0)!=0){v=s;w=x;break a}x=r9(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}J=r;K=s;L=F;M=r9(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;x=c[F+8>>2]|0;y=c[F>>2]|0;I=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=I;P=y;Q=s+1|0;R=(c[g>>2]|0)+x|0}else{if(!((y|0)==-3)){N=r;O=I;P=y;Q=s;R=x;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=I;P=-3;Q=s;R=x;break}c[h+(I<<2)>>2]=1;N=0;O=I;P=-3;Q=s;R=x}}while(0);x=B9(b,0,0,1,32)|0;I=x;do{if((x|0)==0){S=0}else{y=B9(b,0,0,1,20)|0;c[x+4>>2]=y;if((y|0)==0){S=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=I}}while(0);c[t>>2]=S;I=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=I;break}c[k>>2]=R;J=N;K=Q;L=t;M=I}else if((z|0)==3){I=c[u+4>>2]|0;x=c[I>>2]|0;y=I+4|0;F=c[y>>2]|0;D=B9(b,0,0,1,32)|0;if((D|0)==0){G=20;break b}E=B9(b,0,0,1,8)|0;H=D+4|0;c[H>>2]=E;if((E|0)==0){G=20;break b}c[D>>2]=3;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=x;c[(c[H>>2]|0)+4>>2]=F;c[D+16>>2]=(c[F+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=D;D=c[H>>2]|0;H=r9(d,c[y>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=r9(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=r9(d,D+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=r9(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=r9(d,c[I>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}J=r;K=s;L=D;M=r9(d,0)|0}else if((z|0)==2){D=c[u+4>>2]|0;H=r9(d,c[D>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=r9(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=c[D>>2]|0;I=c[D+4>>2]|0;y=c[D+8>>2]|0;x=a[D+12|0]|0;D=B9(b,0,0,1,32)|0;if((D|0)==0){G=40;break b}F=B9(b,0,0,1,16)|0;E=D+4|0;c[E>>2]=F;if((F|0)==0){G=40;break b}c[D>>2]=2;c[D+8>>2]=-1;c[D+12>>2]=-1;c[F>>2]=H;c[F+4>>2]=I;c[F+8>>2]=y;y=F+12|0;a[y]=a[y]&-2|x&1;c[D+16>>2]=c[H+16>>2];c[t>>2]=D;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function t9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=B9(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=B9(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=B9(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=B9(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function u9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=B9(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=B9(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=B9(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=B9(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function v9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function w9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=152784}else{j=b;k=152784;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((Faa(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Rc(e|0,f|0,153072,g|0)|0)+1|0;i=d;return h|0}



function mm(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0.0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0.0,La=0.0,Ma=0,Na=0.0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0,eb=0.0,fb=0.0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0.0,mb=0,nb=0.0,ob=0.0,pb=0,qb=0.0,rb=0.0,sb=0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0,Ib=0.0,Jb=0,Kb=0.0,Lb=0,Mb=0.0,Nb=0.0,Ob=0,Pb=0.0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0.0,Vb=0,Wb=0,Xb=0.0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0.0,ic=0.0,jc=0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0,qc=0.0,rc=0.0,sc=0.0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0,Bc=0.0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0.0,Jc=0.0,Kc=0,Lc=0.0,Mc=0,Nc=0.0,Oc=0,Pc=0.0,Qc=0,Rc=0.0,Sc=0.0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0.0,Xc=0,Yc=0.0,Zc=0,_c=0.0,$c=0,ad=0.0,bd=0.0,cd=0;e=i;i=i+14176|0;f=i;i=i+8|0;ze[c[(d+8|0)>>2]&3](0,2,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+296>>3],0,d);ze[c[(d+8|0)>>2]&3](0,33,1.0,1,d);ze[c[(d+8|0)>>2]&3](1,31,1.0,2,d);ze[c[(d+8|0)>>2]&3](1,32,-1.0,3,d);ze[c[(d+8|0)>>2]&3](1,33,1.0,4,d);ze[c[(d+8|0)>>2]&3](2,0,1.0,5,d);ze[c[(d+8|0)>>2]&3](2,31,1.0,6,d);ze[c[(d+8|0)>>2]&3](2,32,-1.0,7,d);ze[c[(d+8|0)>>2]&3](3,3,1.0,8,d);ze[c[(d+8|0)>>2]&3](3,30,1.0,9,d);ze[c[(d+8|0)>>2]&3](3,31,-1.0,10,d);ze[c[(d+8|0)>>2]&3](4,16,1.0,11,d);ze[c[(d+8|0)>>2]&3](4,29,1.0,12,d);ze[c[(d+8|0)>>2]&3](4,30,-1.0,13,d);ze[c[(d+8|0)>>2]&3](5,21,1.0,14,d);ze[c[(d+8|0)>>2]&3](5,28,1.0,15,d);ze[c[(d+8|0)>>2]&3](5,29,-1.0,16,d);ze[c[(d+8|0)>>2]&3](6,23,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+752>>3],17,d);ze[c[(d+8|0)>>2]&3](6,27,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],18,d);ze[c[(d+8|0)>>2]&3](6,28,1.0,19,d);j=c[c[(b+4|0)>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+744>>3];if(k!=0.0){l=k}else{l=+xH(c[b+536>>2]|0,k,11872,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}k=1.0/l;ze[c[(d+8|0)>>2]&3](7,26,k*k,20,d);ze[c[(d+8|0)>>2]&3](7,27,1.0,21,d);j=c[(d+8|0)>>2]|0;k=+h[(c[(b+416|0)>>2]|0)+18544>>3];m=c[c[(b+4|0)>>2]>>2]|0;l=+h[(c[m+8>>2]|0)+2944>>3];do{if(k!=0.0){n=l/k}else{if(l==0.0){n=l;break}n=l/+xH(c[b+536>>2]|0,k,11840,13088,+h[m>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](8,25,n*-1256637061435917.0e-21,22,d);ze[c[(d+8|0)>>2]&3](8,26,1.0,23,d);n=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+736>>3];do{if(n!=0.0){o=k/n}else{if(k==0.0){o=k;break}o=k/+xH(c[b+536>>2]|0,n,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+736>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+736>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+736>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}t=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;r=+h[(c[j+8>>2]|0)+736>>3];do{if(t!=0.0){u=r/t}else{if(r==0.0){u=r;break}u=r/+xH(c[b+536>>2]|0,t,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(u>0.0){v=1.0}else{u=+h[(c[(b+416|0)>>2]|0)+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[j+8>>2]|0)+736>>3];do{if(u!=0.0){w=t/u}else{if(t==0.0){w=t;break}w=t/+xH(c[b+536>>2]|0,u,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=+(w<0.0|0)}j=c[(b+416|0)>>2]|0;w=+h[j+18528>>3];u=+h[j+18512>>3];m=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[m+8>>2]|0)+736>>3];do{if(u!=0.0){x=t;y=m;z=u;B=j;C=t/u}else{if(t==0.0){x=t;y=m;z=u;B=j;C=t;break}r=t/+xH(c[b+536>>2]|0,u,11504,13088,+h[m>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;x=+h[(c[E+8>>2]|0)+736>>3];y=E;z=+h[D+18512>>3];B=D;C=r}}while(0);u=w*+U(+C);do{if(z!=0.0){F=x;G=y;J=z;K=B;L=x/z}else{if(x==0.0){F=x;G=y;J=z;K=B;L=x;break}C=x/+xH(c[b+536>>2]|0,z,11504,13088,+h[y>>3],(a[b+319|0]|0)!=0|0);m=c[(b+416|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;F=+h[(c[j+8>>2]|0)+736>>3];G=j;J=+h[m+18512>>3];K=m;L=C}}while(0);z=+U(+L);L=u+ +W(+z,+(+h[K+18536>>3]))+1.0;y=c[(d+8|0)>>2]|0;z=+h[K+18504>>3];u=+h[K+18520>>3];B=J!=0.0;do{m=1;if(m){m=0;if(L*L!=0.0){do{if(B){M=J;N=K;O=F/J}else{if(F==0.0){M=J;N=K;O=F;break}x=F/+xH(c[b+536>>2]|0,J,11504,13088,+h[G>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;M=+h[j+18512>>3];N=j;O=x}}while(0);x=z+u*+U(+O)+-1.0;C=+h[N+18528>>3];do{if(M!=0.0){P=M;Q=N;R=p/M}else{if(p==0.0){P=M;Q=N;R=p;break}w=p/+xH(c[b+536>>2]|0,M,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;P=+h[j+18512>>3];Q=j;R=w}}while(0);w=C*R;j=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[j+8>>2]|0)+736>>3];do{if(P!=0.0){S=P;T=Q;V=t/P}else{if(t==0.0){S=P;T=Q;V=t;break}r=t/+xH(c[b+536>>2]|0,P,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;S=+h[D+18512>>3];T=D;V=r}}while(0);t=+U(+V);C=+h[T+18536>>3];r=+W(+t,+(C+-1.0));do{if(S!=0.0){X=S;Y=T;Z=s/S}else{if(s==0.0){X=S;Y=T;Z=s;break}t=s/+xH(c[b+536>>2]|0,S,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;X=+h[j+18512>>3];Y=j;Z=t}}while(0);t=x*(w+r*C*Z);q=+h[Y+18520>>3];o=+h[Y+18528>>3];j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+736>>3];do{if(X!=0.0){k=+U(+(n/X));_=(o*k+ +W(+k,+(+h[Y+18536>>3]))+1.0)/X}else{if(n==0.0){$=n;aa=j;ba=X;ca=Y;da=n}else{k=n/+xH(c[b+536>>2]|0,X,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;$=+h[(c[E+8>>2]|0)+736>>3];aa=E;ba=+h[D+18512>>3];ca=D;da=k}k=o*+U(+da);do{if(ba!=0.0){ea=$;fa=aa;ga=ba;ha=ca;ia=$/ba}else{if($==0.0){ea=$;fa=aa;ga=ba;ha=ca;ia=$;break}l=$/+xH(c[b+536>>2]|0,ba,11504,13088,+h[aa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;ea=+h[(c[E+8>>2]|0)+736>>3];fa=E;ga=+h[D+18512>>3];ha=D;ia=l}}while(0);l=+U(+ia);D=k+ +W(+l,+(+h[ha+18536>>3]))+1.0==0.0;l=+h[ha+18528>>3];E=ga!=0.0;if(D){do{if(E){ja=ea;ka=fa;la=ga;ma=ha;na=ea/ga}else{if(ea==0.0){ja=ea;ka=fa;la=ga;ma=ha;na=ea;break}oa=ea/+xH(c[b+536>>2]|0,ga,11504,13088,+h[fa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;ja=+h[(c[pa+8>>2]|0)+736>>3];ka=pa;la=+h[D+18512>>3];ma=D;na=oa}}while(0);k=l*+U(+na);do{if(la!=0.0){qa=ma;ra=ja/la}else{if(ja==0.0){qa=ma;ra=ja;break}oa=ja/+xH(c[b+536>>2]|0,la,11504,13088,+h[ka>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;ra=oa}}while(0);oa=+U(+ra);_=k+ +W(+oa,+(+h[qa+18536>>3]))+1.0;break}else{do{if(E){sa=ea;ta=fa;ua=ga;va=ha;wa=ea/ga}else{if(ea==0.0){sa=ea;ta=fa;ua=ga;va=ha;wa=ea;break}oa=ea/+xH(c[b+536>>2]|0,ga,11504,13088,+h[fa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;sa=+h[(c[pa+8>>2]|0)+736>>3];ta=pa;ua=+h[D+18512>>3];va=D;wa=oa}}while(0);k=l*+U(+wa);do{if(ua!=0.0){xa=ta;ya=ua;za=va;Aa=sa/ua}else{if(sa==0.0){xa=ta;ya=ua;za=va;Aa=sa;break}oa=sa/+xH(c[b+536>>2]|0,ua,11504,13088,+h[ta>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;xa=c[c[(b+4|0)>>2]>>2]|0;ya=+h[E+18512>>3];za=E;Aa=oa}}while(0);l=+U(+Aa);oa=k+ +W(+l,+(+h[za+18536>>3]))+1.0;_=oa/+xH(c[b+536>>2]|0,ya,11504,13088,+h[xa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=(t-q*v*_)/(L*L)}else{m=1}}if(m){m=0;if(1){do{if(B){Ca=J;Da=K;Ea=F/J}else{if(F==0.0){Ca=J;Da=K;Ea=F;break}o=F/+xH(c[b+536>>2]|0,J,11504,13088,+h[G>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;Ca=+h[j+18512>>3];Da=j;Ea=o}}while(0);q=z+u*+U(+Ea)+-1.0;t=+h[Da+18528>>3];do{if(Ca!=0.0){Fa=Ca;Ga=Da;Ha=p/Ca}else{if(p==0.0){Fa=Ca;Ga=Da;Ha=p;break}o=p/+xH(c[b+536>>2]|0,Ca,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;Fa=+h[j+18512>>3];Ga=j;Ha=o}}while(0);o=t*Ha;j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+736>>3];do{if(Fa!=0.0){Ia=Fa;Ja=Ga;Ka=n/Fa}else{if(n==0.0){Ia=Fa;Ja=Ga;Ka=n;break}C=n/+xH(c[b+536>>2]|0,Fa,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Ia=+h[E+18512>>3];Ja=E;Ka=C}}while(0);n=+U(+Ka);t=+h[Ja+18536>>3];C=+W(+n,+(t+-1.0));do{if(Ia!=0.0){La=Ia;Ma=Ja;Na=s/Ia}else{if(s==0.0){La=Ia;Ma=Ja;Na=s;break}n=s/+xH(c[b+536>>2]|0,Ia,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;La=+h[j+18512>>3];Ma=j;Na=n}}while(0);n=q*(o+C*t*Na);r=+h[Ma+18520>>3];w=+h[Ma+18528>>3];j=c[c[(b+4|0)>>2]>>2]|0;x=+h[(c[j+8>>2]|0)+736>>3];do{if(La!=0.0){oa=+U(+(x/La));Oa=Ma;Pa=(w*oa+ +W(+oa,+(+h[Ma+18536>>3]))+1.0)/La}else{if(x==0.0){Qa=x;Ra=j;Sa=La;Ta=Ma;Ua=x}else{oa=x/+xH(c[b+536>>2]|0,La,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;Qa=+h[(c[D+8>>2]|0)+736>>3];Ra=D;Sa=+h[E+18512>>3];Ta=E;Ua=oa}oa=w*+U(+Ua);do{if(Sa!=0.0){Va=Qa;Wa=Ra;Xa=Sa;Ya=Ta;Za=Qa/Sa}else{if(Qa==0.0){Va=Qa;Wa=Ra;Xa=Sa;Ya=Ta;Za=Qa;break}l=Qa/+xH(c[b+536>>2]|0,Sa,11504,13088,+h[Ra>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;Va=+h[(c[D+8>>2]|0)+736>>3];Wa=D;Xa=+h[E+18512>>3];Ya=E;Za=l}}while(0);k=+U(+Za);E=oa+ +W(+k,+(+h[Ya+18536>>3]))+1.0==0.0;k=+h[Ya+18528>>3];D=Xa!=0.0;if(E){do{if(D){_a=Va;$a=Wa;ab=Xa;bb=Ya;cb=Va/Xa}else{if(Va==0.0){_a=Va;$a=Wa;ab=Xa;bb=Ya;cb=Va;break}l=Va/+xH(c[b+536>>2]|0,Xa,11504,13088,+h[Wa>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;_a=+h[(c[pa+8>>2]|0)+736>>3];$a=pa;ab=+h[E+18512>>3];bb=E;cb=l}}while(0);oa=k*+U(+cb);do{if(ab!=0.0){db=bb;eb=_a/ab}else{if(_a==0.0){db=bb;eb=_a;break}l=_a/+xH(c[b+536>>2]|0,ab,11504,13088,+h[$a>>3],(a[b+319|0]|0)!=0|0);db=c[(b+416|0)>>2]|0;eb=l}}while(0);l=+U(+eb);Oa=db;Pa=oa+ +W(+l,+(+h[db+18536>>3]))+1.0;break}else{do{if(D){fb=Va;gb=Wa;hb=Xa;ib=Ya;jb=Va/Xa}else{if(Va==0.0){fb=Va;gb=Wa;hb=Xa;ib=Ya;jb=Va;break}l=Va/+xH(c[b+536>>2]|0,Xa,11504,13088,+h[Wa>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;fb=+h[(c[pa+8>>2]|0)+736>>3];gb=pa;hb=+h[E+18512>>3];ib=E;jb=l}}while(0);oa=k*+U(+jb);do{if(hb!=0.0){kb=gb;lb=hb;mb=ib;nb=fb/hb}else{if(fb==0.0){kb=gb;lb=hb;mb=ib;nb=fb;break}l=fb/+xH(c[b+536>>2]|0,hb,11504,13088,+h[gb>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;kb=c[c[(b+4|0)>>2]>>2]|0;lb=+h[D+18512>>3];mb=D;nb=l}}while(0);k=+U(+nb);l=oa+ +W(+k,+(+h[mb+18536>>3]))+1.0;k=l/+xH(c[b+536>>2]|0,lb,11504,13088,+h[kb>>3],(a[b+319|0]|0)!=0|0);Oa=c[(b+416|0)>>2]|0;Pa=k;break}}}while(0);w=+h[Oa+18504>>3];x=+h[Oa+18520>>3];t=+h[Oa+18512>>3];j=c[c[(b+4|0)>>2]>>2]|0;C=+h[(c[j+8>>2]|0)+736>>3];D=1;if(D){D=0;if(n-r*v*Pa==0.0){do{if(t!=0.0){ob=t;pb=Oa;qb=C/t}else{if(C==0.0){ob=t;pb=Oa;qb=C;break}o=C/+xH(c[b+536>>2]|0,t,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;ob=+h[E+18512>>3];pb=E;qb=o}}while(0);r=w+x*+U(+qb)+-1.0;n=+h[pb+18528>>3];do{if(ob!=0.0){rb=ob;sb=pb;tb=p/ob}else{if(p==0.0){rb=ob;sb=pb;tb=p;break}o=p/+xH(c[b+536>>2]|0,ob,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;rb=+h[E+18512>>3];sb=E;tb=o}}while(0);o=n*tb;E=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[E+8>>2]|0)+736>>3];do{if(rb!=0.0){ub=rb;vb=sb;wb=q/rb}else{if(q==0.0){ub=rb;vb=sb;wb=q;break}k=q/+xH(c[b+536>>2]|0,rb,11504,13088,+h[E>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;ub=+h[pa+18512>>3];vb=pa;wb=k}}while(0);q=+U(+wb);n=+h[vb+18536>>3];k=+W(+q,+(n+-1.0));do{if(ub!=0.0){xb=ub;yb=vb;zb=s/ub}else{if(s==0.0){xb=ub;yb=vb;zb=s;break}q=s/+xH(c[b+536>>2]|0,ub,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;xb=+h[E+18512>>3];yb=E;zb=q}}while(0);q=r*(o+k*n*zb);l=+h[yb+18520>>3];Ab=+h[yb+18528>>3];E=c[c[(b+4|0)>>2]>>2]|0;Bb=+h[(c[E+8>>2]|0)+736>>3];do{if(xb!=0.0){Cb=+U(+(Bb/xb));Db=(Ab*Cb+ +W(+Cb,+(+h[yb+18536>>3]))+1.0)/xb}else{if(Bb==0.0){Eb=Bb;Fb=E;Gb=xb;Hb=yb;Ib=Bb}else{Cb=Bb/+xH(c[b+536>>2]|0,xb,11504,13088,+h[E>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Eb=+h[(c[Jb+8>>2]|0)+736>>3];Fb=Jb;Gb=+h[pa+18512>>3];Hb=pa;Ib=Cb}Cb=Ab*+U(+Ib);do{if(Gb!=0.0){Kb=Gb;Lb=Hb;Mb=Eb/Gb;Nb=Eb;Ob=Fb}else{if(Eb==0.0){Kb=Gb;Lb=Hb;Mb=Eb;Nb=Eb;Ob=Fb;break}Pb=Eb/+xH(c[b+536>>2]|0,Gb,11504,13088,+h[Fb>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Kb=+h[pa+18512>>3];Lb=pa;Mb=Pb;Nb=+h[(c[Jb+8>>2]|0)+736>>3];Ob=Jb}}while(0);oa=+U(+Mb);Jb=Cb+ +W(+oa,+(+h[Lb+18536>>3]))+1.0==0.0;oa=+h[Lb+18528>>3];pa=Kb!=0.0;if(Jb){do{if(pa){Qb=Nb;Rb=Ob;Sb=Kb;Tb=Lb;Ub=Nb/Kb}else{if(Nb==0.0){Qb=Nb;Rb=Ob;Sb=Kb;Tb=Lb;Ub=Nb;break}Pb=Nb/+xH(c[b+536>>2]|0,Kb,11504,13088,+h[Ob>>3],(a[b+319|0]|0)!=0|0);Jb=c[(b+416|0)>>2]|0;Vb=c[c[(b+4|0)>>2]>>2]|0;Qb=+h[(c[Vb+8>>2]|0)+736>>3];Rb=Vb;Sb=+h[Jb+18512>>3];Tb=Jb;Ub=Pb}}while(0);Cb=oa*+U(+Ub);do{if(Sb!=0.0){Wb=Tb;Xb=Qb/Sb}else{if(Qb==0.0){Wb=Tb;Xb=Qb;break}Pb=Qb/+xH(c[b+536>>2]|0,Sb,11504,13088,+h[Rb>>3],(a[b+319|0]|0)!=0|0);Wb=c[(b+416|0)>>2]|0;Xb=Pb}}while(0);Pb=+U(+Xb);Db=Cb+ +W(+Pb,+(+h[Wb+18536>>3]))+1.0;break}else{do{if(pa){Yb=Nb;Zb=Ob;_b=Kb;$b=Lb;ac=Nb/Kb}else{if(Nb==0.0){Yb=Nb;Zb=Ob;_b=Kb;$b=Lb;ac=Nb;break}Pb=Nb/+xH(c[b+536>>2]|0,Kb,11504,13088,+h[Ob>>3],(a[b+319|0]|0)!=0|0);Jb=c[(b+416|0)>>2]|0;Vb=c[c[(b+4|0)>>2]>>2]|0;Yb=+h[(c[Vb+8>>2]|0)+736>>3];Zb=Vb;_b=+h[Jb+18512>>3];$b=Jb;ac=Pb}}while(0);Cb=oa*+U(+ac);do{if(_b!=0.0){bc=Zb;cc=_b;dc=$b;ec=Yb/_b}else{if(Yb==0.0){bc=Zb;cc=_b;dc=$b;ec=Yb;break}Pb=Yb/+xH(c[b+536>>2]|0,_b,11504,13088,+h[Zb>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;bc=c[c[(b+4|0)>>2]>>2]|0;cc=+h[pa+18512>>3];dc=pa;ec=Pb}}while(0);oa=+U(+ec);Pb=Cb+ +W(+oa,+(+h[dc+18536>>3]))+1.0;Db=Pb/+xH(c[b+536>>2]|0,cc,11504,13088,+h[bc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=q-l*v*Db;break}else{D=1}}if(D){D=0;if(1){do{if(t!=0.0){fc=t;gc=Oa;hc=C/t}else{if(C==0.0){fc=t;gc=Oa;hc=C;break}Ab=C/+xH(c[b+536>>2]|0,t,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;fc=+h[E+18512>>3];gc=E;hc=Ab}}while(0);t=w+x*+U(+hc)+-1.0;C=+h[gc+18528>>3];do{if(fc!=0.0){ic=fc;jc=gc;kc=p/fc}else{if(p==0.0){ic=fc;jc=gc;kc=p;break}l=p/+xH(c[b+536>>2]|0,fc,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;ic=+h[j+18512>>3];jc=j;kc=l}}while(0);x=C*kc;j=c[c[(b+4|0)>>2]>>2]|0;w=+h[(c[j+8>>2]|0)+736>>3];do{if(ic!=0.0){lc=ic;mc=jc;nc=w/ic}else{if(w==0.0){lc=ic;mc=jc;nc=w;break}l=w/+xH(c[b+536>>2]|0,ic,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;lc=+h[E+18512>>3];mc=E;nc=l}}while(0);w=+U(+nc);C=+h[mc+18536>>3];l=+W(+w,+(C+-1.0));do{if(lc!=0.0){oc=lc;pc=mc;qc=s/lc}else{if(s==0.0){oc=lc;pc=mc;qc=s;break}w=s/+xH(c[b+536>>2]|0,lc,11504,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;oc=+h[j+18512>>3];pc=j;qc=w}}while(0);w=t*(x+l*C*qc);q=+h[pc+18520>>3];Ab=+h[pc+18528>>3];j=c[c[(b+4|0)>>2]>>2]|0;Bb=+h[(c[j+8>>2]|0)+736>>3];do{if(oc!=0.0){n=+U(+(Bb/oc));rc=(Ab*n+ +W(+n,+(+h[pc+18536>>3]))+1.0)/oc}else{if(Bb==0.0){sc=Bb;tc=j;uc=oc;vc=pc;wc=Bb}else{n=Bb/+xH(c[b+536>>2]|0,oc,11504,13088,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;sc=+h[(c[pa+8>>2]|0)+736>>3];tc=pa;uc=+h[E+18512>>3];vc=E;wc=n}n=Ab*+U(+wc);do{if(uc!=0.0){xc=sc;yc=tc;zc=uc;Ac=vc;Bc=sc/uc}else{if(sc==0.0){xc=sc;yc=tc;zc=uc;Ac=vc;Bc=sc;break}k=sc/+xH(c[b+536>>2]|0,uc,11504,13088,+h[tc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;xc=+h[(c[pa+8>>2]|0)+736>>3];yc=pa;zc=+h[E+18512>>3];Ac=E;Bc=k}}while(0);Cb=+U(+Bc);E=n+ +W(+Cb,+(+h[Ac+18536>>3]))+1.0==0.0;Cb=+h[Ac+18528>>3];pa=zc!=0.0;if(E){do{if(pa){Cc=xc;Dc=yc;Ec=zc;Fc=Ac;Gc=xc/zc}else{if(xc==0.0){Cc=xc;Dc=yc;Ec=zc;Fc=Ac;Gc=xc;break}k=xc/+xH(c[b+536>>2]|0,zc,11504,13088,+h[yc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Cc=+h[(c[Jb+8>>2]|0)+736>>3];Dc=Jb;Ec=+h[E+18512>>3];Fc=E;Gc=k}}while(0);n=Cb*+U(+Gc);do{if(Ec!=0.0){Hc=Fc;Ic=Cc/Ec}else{if(Cc==0.0){Hc=Fc;Ic=Cc;break}k=Cc/+xH(c[b+536>>2]|0,Ec,11504,13088,+h[Dc>>3],(a[b+319|0]|0)!=0|0);Hc=c[(b+416|0)>>2]|0;Ic=k}}while(0);k=+U(+Ic);rc=n+ +W(+k,+(+h[Hc+18536>>3]))+1.0;break}else{do{if(pa){Jc=xc;Kc=yc;Lc=zc;Mc=Ac;Nc=xc/zc}else{if(xc==0.0){Jc=xc;Kc=yc;Lc=zc;Mc=Ac;Nc=xc;break}k=xc/+xH(c[b+536>>2]|0,zc,11504,13088,+h[yc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Jc=+h[(c[Jb+8>>2]|0)+736>>3];Kc=Jb;Lc=+h[E+18512>>3];Mc=E;Nc=k}}while(0);n=Cb*+U(+Nc);do{if(Lc!=0.0){Oc=Kc;Pc=Lc;Qc=Mc;Rc=Jc/Lc}else{if(Jc==0.0){Oc=Kc;Pc=Lc;Qc=Mc;Rc=Jc;break}k=Jc/+xH(c[b+536>>2]|0,Lc,11504,13088,+h[Kc>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Oc=c[c[(b+4|0)>>2]>>2]|0;Pc=+h[pa+18512>>3];Qc=pa;Rc=k}}while(0);Cb=+U(+Rc);k=n+ +W(+Cb,+(+h[Qc+18536>>3]))+1.0;rc=k/+xH(c[b+536>>2]|0,Pc,11504,13088,+h[Oc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=(w-q*v*rc)/+xH(c[b+536>>2]|0,L*L,11552,13088,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);break}else{D=1}}}else{m=1}}}while(0);ze[y&3](9,24,Ba,24,d);ze[c[(d+8|0)>>2]&3](9,25,1.0,25,d);y=c[(d+8|0)>>2]|0;Oc=c[c[(b+4|0)>>2]>>2]|0;Ba=+h[(c[Oc+8>>2]|0)+2944>>3];if(Ba!=0.0){Sc=Ba}else{Sc=+xH(c[b+536>>2]|0,Ba,11472,13088,+h[Oc>>3],(a[b+319|0]|0)!=0|0)}ze[y&3](10,23,1.0/Sc,26,d);ze[c[(d+8|0)>>2]&3](10,24,1.0,27,d);ze[c[(d+8|0)>>2]&3](11,17,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],28,d);ze[c[(d+8|0)>>2]&3](11,22,1.0,29,d);c[e+64>>2]=b;c[e+72>>2]=d;g[e+6144>>2]=Tc;g[e+6256>>2]=Uc;g[e+6344>>2]=Vc;g[e+6472>>2]=Wc;c[e+6480>>2]=Xc;g[e+6488>>2]=Yc;c[e+6496>>2]=Zc;g[e+6520>>2]=_c;c[e+6528>>2]=$c;g[e+6536>>2]=ad;g[e+6544>>2]=bd;c[e+6552>>2]=cd;c[e+13952>>2]=f;c[e+14040>>2]=0;c[e+14044>>2]=0;_setLinearMatrixA562$1(e);Tc=+g[e+6144>>2];Uc=+g[e+6256>>2];Vc=+g[e+6344>>2];Wc=+g[e+6472>>2];Xc=c[e+6480>>2]|0;Yc=+g[e+6488>>2];Zc=c[e+6496>>2]|0;_c=+g[e+6520>>2];$c=c[e+6528>>2]|0;ad=+g[e+6536>>2];bd=+g[e+6544>>2];cd=c[e+6552>>2]|0;c[e+64>>2]=b;c[e+72>>2]=d;g[e+6144>>2]=Tc;g[e+6256>>2]=Uc;g[e+6344>>2]=Vc;g[e+6472>>2]=Wc;c[e+6480>>2]=Xc;g[e+6488>>2]=Yc;c[e+6496>>2]=Zc;g[e+6520>>2]=_c;c[e+6528>>2]=$c;g[e+6536>>2]=ad;g[e+6544>>2]=bd;c[e+6552>>2]=cd;c[e+14032>>2]=0;c[e+14036>>2]=0;_setLinearMatrixA562$0(e);H=c[e+14032>>2]|0;A=c[e+14036>>2]|0;I=+g[e+14036>>2];c[e+14032>>2]=0;c[e+14036>>2]=0;if((H|0)==5){return}}function _setLinearMatrixA562$0(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0,Na=0.0,Oa=0.0,Pa=0,Qa=0.0,Ra=0,Sa=0.0,Ta=0.0,Ua=0,Va=0.0,Wa=0,Xa=0.0,Ya=0.0,Za=0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0,Gb=0.0,Hb=0,Ib=0.0,Jb=0,Kb=0.0,Lb=0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0,Vb=0.0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0.0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0.0,jc=0.0,kc=0,lc=0.0,mc=0.0,nc=0,oc=0.0,pc=0.0,qc=0.0,rc=0,sc=0.0,tc=0,uc=0.0,vc=0.0,wc=0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0.0,Ic=0,Jc=0.0,Kc=0,Lc=0.0,Mc=0,Nc=0.0,Oc=0,Pc=0.0,Qc=0.0,Rc=0.0,Sc=0.0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0.0,Xc=0.0,Yc=0.0,Zc=0.0,_c=0.0,$c=0.0,ad=0.0,bd=0.0,cd=0,dd=0.0,ed=0,fd=0.0,gd=0.0,hd=0,id=0.0,jd=0,kd=0.0,ld=0.0,md=0,nd=0.0,od=0.0,pd=0,qd=0.0,rd=0.0,sd=0,td=0.0,ud=0.0,vd=0,wd=0.0,xd=0.0,yd=0.0,zd=0,Ad=0.0,Bd=0,Cd=0.0,Dd=0.0,Ed=0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0,Kd=0.0,Ld=0,Md=0.0,Nd=0,Od=0.0,Pd=0.0,Qd=0,Rd=0.0,Sd=0,Td=0.0,Ud=0,Vd=0.0,Wd=0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0,$d=0.0,ae=0.0,be=0,ce=0.0,de=0.0,ee=0,fe=0.0,ge=0.0,he=0,ie=0.0,je=0,ke=0.0,le=0.0,me=0,ne=0.0,oe=0,pe=0.0,qe=0.0,re=0,se=0.0,te=0,ue=0.0,ve=0.0,we=0,xe=0.0,ye=0,Ae=0.0,Be=0,Ce=0.0,De=0.0,Ee=0,Fe=0.0,Ge=0,He=0.0,Ie=0,Je=0.0,Ke=0,Le=0.0,Me=0.0,Ne=0,Oe=0.0,Qe=0.0,Re=0,Se=0.0,Te=0.0,Ue=0,Ve=0.0,We=0.0,Xe=0,Ye=0.0,Ze=0.0,_e=0.0,$e=0.0,af=0.0,bf=0.0,cf=0,df=0.0,ef=0,ff=0.0,gf=0,hf=0.0,jf=0,kf=0.0,lf=0,mf=0.0,nf=0.0,of=0.0,pf=0,qf=0.0,rf=0,sf=0.0,tf=0,uf=0,vf=0.0,wf=0.0,xf=0,yf=0.0,zf=0,Af=0.0,Bf=0,Cf=0.0,Df=0,Ef=0.0,Ff=0.0,Gf=0,Hf=0.0,If=0.0,Jf=0,Kf=0.0,Lf=0.0,Mf=0,Nf=0.0,Of=0.0,Pf=0,Qf=0.0,Rf=0.0,Sf=0.0,Tf=0,Uf=0.0,Vf=0,Wf=0.0,Xf=0.0,Yf=0,Zf=0.0,_f=0,$f=0.0,ag=0.0,bg=0,cg=0.0,dg=0,eg=0.0,fg=0,gg=0.0,hg=0.0,ig=0,jg=0.0,kg=0,lg=0.0,mg=0,ng=0.0,og=0,pg=0.0,qg=0.0,rg=0.0,sg=0.0,tg=0,ug=0.0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0.0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0.0,Sg=0,Tg=0,Ug=0,Vg=0,Wg=0,Xg=0,Yg=0,Zg=0,_g=0,$g=0,ah=0,bh=0,ch=0,dh=0,eh=0,fh=0,gh=0.0,hh=0.0;d=c[b+64>>2]|0;e=c[b+72>>2]|0;f=+g[b+6144>>2];j=+g[b+6256>>2];l=+g[b+6344>>2];m=+g[b+6472>>2];n=c[b+6480>>2]|0;o=+g[b+6488>>2];p=c[b+6496>>2]|0;q=+g[b+6520>>2];r=c[b+6528>>2]|0;s=+g[b+6536>>2];t=+g[b+6544>>2];u=c[b+6552>>2]|0;a:do{do{v=1;if(v){v=0;if(q*q!=0.0){do{if(u){w=o;x=p;y=m/o}else{if(m==0.0){w=o;x=p;y=m;break}z=m/+xH(c[d+536>>2]|0,o,10216,13088,+h[n>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;w=+h[A+18656>>3];x=A;y=z}}while(0);z=s+t*+U(+y)+-1.0;B=+h[x+18672>>3];do{if(w!=0.0){C=w;D=x;E=f/w}else{if(f==0.0){C=w;D=x;E=f;break}F=f/+xH(c[d+536>>2]|0,w,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;C=+h[A+18656>>3];D=A;E=F}}while(0);F=B*E;A=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[A+8>>2]|0)+616>>3];do{if(C!=0.0){H=C;I=D;J=G/C}else{if(G==0.0){H=C;I=D;J=G;break}K=G/+xH(c[d+536>>2]|0,C,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;H=+h[L+18656>>3];I=L;J=K}}while(0);G=+U(+J);B=+h[I+18680>>3];K=+W(+G,+(B+-1.0));do{if(H!=0.0){M=H;N=I;O=j/H}else{if(j==0.0){M=H;N=I;O=j;break}G=j/+xH(c[d+536>>2]|0,H,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;M=+h[A+18656>>3];N=A;O=G}}while(0);G=z*(F+K*B*O);P=+h[N+18664>>3];Q=+h[N+18672>>3];A=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[A+8>>2]|0)+616>>3];do{if(M!=0.0){S=+U(+(R/M));T=(Q*S+ +W(+S,+(+h[N+18680>>3]))+1.0)/M}else{if(R==0.0){V=R;X=A;Y=M;Z=N;_=R}else{S=R/+xH(c[d+536>>2]|0,M,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;V=+h[(c[$+8>>2]|0)+616>>3];X=$;Y=+h[L+18656>>3];Z=L;_=S}S=Q*+U(+_);do{if(Y!=0.0){aa=V;ba=X;ca=Y;ea=Z;fa=V/Y}else{if(V==0.0){aa=V;ba=X;ca=Y;ea=Z;fa=V;break}ga=V/+xH(c[d+536>>2]|0,Y,10216,13088,+h[X>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;aa=+h[(c[$+8>>2]|0)+616>>3];ba=$;ca=+h[L+18656>>3];ea=L;fa=ga}}while(0);ga=+U(+fa);L=S+ +W(+ga,+(+h[ea+18680>>3]))+1.0==0.0;ga=+h[ea+18672>>3];$=ca!=0.0;if(L){do{if($){ha=aa;ia=ba;ja=ca;ka=ea;la=aa/ca}else{if(aa==0.0){ha=aa;ia=ba;ja=ca;ka=ea;la=aa;break}ma=aa/+xH(c[d+536>>2]|0,ca,10216,13088,+h[ba>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;ha=+h[(c[na+8>>2]|0)+616>>3];ia=na;ja=+h[L+18656>>3];ka=L;la=ma}}while(0);S=ga*+U(+la);do{if(ja!=0.0){oa=ka;pa=ha/ja}else{if(ha==0.0){oa=ka;pa=ha;break}ma=ha/+xH(c[d+536>>2]|0,ja,10216,13088,+h[ia>>3],(a[d+319|0]|0)!=0|0);oa=c[(d+416|0)>>2]|0;pa=ma}}while(0);ma=+U(+pa);T=S+ +W(+ma,+(+h[oa+18680>>3]))+1.0;break}else{do{if($){qa=aa;ra=ba;sa=ca;ta=ea;ua=aa/ca}else{if(aa==0.0){qa=aa;ra=ba;sa=ca;ta=ea;ua=aa;break}ma=aa/+xH(c[d+536>>2]|0,ca,10216,13088,+h[ba>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;qa=+h[(c[na+8>>2]|0)+616>>3];ra=na;sa=+h[L+18656>>3];ta=L;ua=ma}}while(0);S=ga*+U(+ua);do{if(sa!=0.0){va=ra;wa=sa;xa=ta;ya=qa/sa}else{if(qa==0.0){va=ra;wa=sa;xa=ta;ya=qa;break}ma=qa/+xH(c[d+536>>2]|0,sa,10216,13088,+h[ra>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;va=c[c[(d+4|0)>>2]>>2]|0;wa=+h[$+18656>>3];xa=$;ya=ma}}while(0);ga=+U(+ya);ma=S+ +W(+ga,+(+h[xa+18680>>3]))+1.0;T=ma/+xH(c[d+536>>2]|0,wa,10216,13088,+h[va>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=(G-P*l*T)/(q*q)}else{v=1}}if(v){v=0;if(1){do{if(u){Aa=o;Ba=p;Ca=m/o}else{if(m==0.0){Aa=o;Ba=p;Ca=m;break}Q=m/+xH(c[d+536>>2]|0,o,10216,13088,+h[n>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Aa=+h[A+18656>>3];Ba=A;Ca=Q}}while(0);P=s+t*+U(+Ca)+-1.0;G=+h[Ba+18672>>3];do{if(Aa!=0.0){Da=Aa;Ea=Ba;Fa=f/Aa}else{if(f==0.0){Da=Aa;Ea=Ba;Fa=f;break}Q=f/+xH(c[d+536>>2]|0,Aa,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Da=+h[A+18656>>3];Ea=A;Fa=Q}}while(0);Q=G*Fa;A=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[A+8>>2]|0)+616>>3];do{if(Da!=0.0){Ga=Da;Ha=Ea;Ia=R/Da}else{if(R==0.0){Ga=Da;Ha=Ea;Ia=R;break}B=R/+xH(c[d+536>>2]|0,Da,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Ga=+h[$+18656>>3];Ha=$;Ia=B}}while(0);R=+U(+Ia);G=+h[Ha+18680>>3];B=+W(+R,+(G+-1.0));do{if(Ga!=0.0){Ja=Ga;Ka=Ha;La=j/Ga}else{if(j==0.0){Ja=Ga;Ka=Ha;La=j;break}R=j/+xH(c[d+536>>2]|0,Ga,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Ja=+h[A+18656>>3];Ka=A;La=R}}while(0);R=P*(Q+B*G*La);K=+h[Ka+18664>>3];F=+h[Ka+18672>>3];A=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[A+8>>2]|0)+616>>3];do{if(Ja!=0.0){ma=+U(+(z/Ja));Ma=Ka;Na=(F*ma+ +W(+ma,+(+h[Ka+18680>>3]))+1.0)/Ja}else{if(z==0.0){Oa=z;Pa=A;Qa=Ja;Ra=Ka;Sa=z}else{ma=z/+xH(c[d+536>>2]|0,Ja,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;Oa=+h[(c[L+8>>2]|0)+616>>3];Pa=L;Qa=+h[$+18656>>3];Ra=$;Sa=ma}ma=F*+U(+Sa);do{if(Qa!=0.0){Ta=Oa;Ua=Pa;Va=Qa;Wa=Ra;Xa=Oa/Qa}else{if(Oa==0.0){Ta=Oa;Ua=Pa;Va=Qa;Wa=Ra;Xa=Oa;break}ga=Oa/+xH(c[d+536>>2]|0,Qa,10216,13088,+h[Pa>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;Ta=+h[(c[L+8>>2]|0)+616>>3];Ua=L;Va=+h[$+18656>>3];Wa=$;Xa=ga}}while(0);S=+U(+Xa);$=ma+ +W(+S,+(+h[Wa+18680>>3]))+1.0==0.0;S=+h[Wa+18672>>3];L=Va!=0.0;if($){do{if(L){Ya=Ta;Za=Ua;_a=Va;$a=Wa;ab=Ta/Va}else{if(Ta==0.0){Ya=Ta;Za=Ua;_a=Va;$a=Wa;ab=Ta;break}ga=Ta/+xH(c[d+536>>2]|0,Va,10216,13088,+h[Ua>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Ya=+h[(c[na+8>>2]|0)+616>>3];Za=na;_a=+h[$+18656>>3];$a=$;ab=ga}}while(0);ma=S*+U(+ab);do{if(_a!=0.0){bb=$a;cb=Ya/_a}else{if(Ya==0.0){bb=$a;cb=Ya;break}ga=Ya/+xH(c[d+536>>2]|0,_a,10216,13088,+h[Za>>3],(a[d+319|0]|0)!=0|0);bb=c[(d+416|0)>>2]|0;cb=ga}}while(0);ga=+U(+cb);Ma=bb;Na=ma+ +W(+ga,+(+h[bb+18680>>3]))+1.0;break}else{do{if(L){db=Ta;eb=Ua;fb=Va;gb=Wa;hb=Ta/Va}else{if(Ta==0.0){db=Ta;eb=Ua;fb=Va;gb=Wa;hb=Ta;break}ga=Ta/+xH(c[d+536>>2]|0,Va,10216,13088,+h[Ua>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;db=+h[(c[na+8>>2]|0)+616>>3];eb=na;fb=+h[$+18656>>3];gb=$;hb=ga}}while(0);ma=S*+U(+hb);do{if(fb!=0.0){ib=eb;jb=fb;kb=gb;lb=db/fb}else{if(db==0.0){ib=eb;jb=fb;kb=gb;lb=db;break}ga=db/+xH(c[d+536>>2]|0,fb,10216,13088,+h[eb>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;ib=c[c[(d+4|0)>>2]>>2]|0;jb=+h[L+18656>>3];kb=L;lb=ga}}while(0);S=+U(+lb);ga=ma+ +W(+S,+(+h[kb+18680>>3]))+1.0;S=ga/+xH(c[d+536>>2]|0,jb,10216,13088,+h[ib>>3],(a[d+319|0]|0)!=0|0);Ma=c[(d+416|0)>>2]|0;Na=S;break}}}while(0);F=+h[Ma+18648>>3];z=+h[Ma+18664>>3];G=+h[Ma+18656>>3];A=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[A+8>>2]|0)+616>>3];L=1;if(L){L=0;if(R-K*l*Na==0.0){do{if(G!=0.0){mb=G;nb=Ma;ob=B/G}else{if(B==0.0){mb=G;nb=Ma;ob=B;break}Q=B/+xH(c[d+536>>2]|0,G,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;mb=+h[$+18656>>3];nb=$;ob=Q}}while(0);K=F+z*+U(+ob)+-1.0;R=+h[nb+18672>>3];do{if(mb!=0.0){pb=mb;qb=nb;rb=f/mb}else{if(f==0.0){pb=mb;qb=nb;rb=f;break}Q=f/+xH(c[d+536>>2]|0,mb,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;pb=+h[$+18656>>3];qb=$;rb=Q}}while(0);Q=R*rb;$=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[$+8>>2]|0)+616>>3];do{if(pb!=0.0){sb=pb;tb=qb;ub=P/pb}else{if(P==0.0){sb=pb;tb=qb;ub=P;break}S=P/+xH(c[d+536>>2]|0,pb,10216,13088,+h[$>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;sb=+h[na+18656>>3];tb=na;ub=S}}while(0);P=+U(+ub);R=+h[tb+18680>>3];S=+W(+P,+(R+-1.0));do{if(sb!=0.0){vb=sb;wb=tb;xb=j/sb}else{if(j==0.0){vb=sb;wb=tb;xb=j;break}P=j/+xH(c[d+536>>2]|0,sb,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;vb=+h[$+18656>>3];wb=$;xb=P}}while(0);P=K*(Q+S*R*xb);ga=+h[wb+18664>>3];yb=+h[wb+18672>>3];$=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[$+8>>2]|0)+616>>3];do{if(vb!=0.0){Ab=+U(+(zb/vb));Bb=(yb*Ab+ +W(+Ab,+(+h[wb+18680>>3]))+1.0)/vb}else{if(zb==0.0){Cb=zb;Db=$;Eb=vb;Fb=wb;Gb=zb}else{Ab=zb/+xH(c[d+536>>2]|0,vb,10216,13088,+h[$>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;Cb=+h[(c[Hb+8>>2]|0)+616>>3];Db=Hb;Eb=+h[na+18656>>3];Fb=na;Gb=Ab}Ab=yb*+U(+Gb);do{if(Eb!=0.0){Ib=Cb;Jb=Db;Kb=Eb;Lb=Fb;Mb=Cb/Eb}else{if(Cb==0.0){Ib=Cb;Jb=Db;Kb=Eb;Lb=Fb;Mb=Cb;break}Nb=Cb/+xH(c[d+536>>2]|0,Eb,10216,13088,+h[Db>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;Ib=+h[(c[Hb+8>>2]|0)+616>>3];Jb=Hb;Kb=+h[na+18656>>3];Lb=na;Mb=Nb}}while(0);ma=+U(+Mb);na=Ab+ +W(+ma,+(+h[Lb+18680>>3]))+1.0==0.0;ma=+h[Lb+18672>>3];Hb=Kb!=0.0;if(na){do{if(Hb){Ob=Ib;Pb=Jb;Qb=Kb;Rb=Lb;Sb=Ib/Kb}else{if(Ib==0.0){Ob=Ib;Pb=Jb;Qb=Kb;Rb=Lb;Sb=Ib;break}Nb=Ib/+xH(c[d+536>>2]|0,Kb,10216,13088,+h[Jb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ob=+h[(c[Tb+8>>2]|0)+616>>3];Pb=Tb;Qb=+h[na+18656>>3];Rb=na;Sb=Nb}}while(0);Ab=ma*+U(+Sb);do{if(Qb!=0.0){Ub=Rb;Vb=Ob/Qb}else{if(Ob==0.0){Ub=Rb;Vb=Ob;break}Nb=Ob/+xH(c[d+536>>2]|0,Qb,10216,13088,+h[Pb>>3],(a[d+319|0]|0)!=0|0);Ub=c[(d+416|0)>>2]|0;Vb=Nb}}while(0);Nb=+U(+Vb);Bb=Ab+ +W(+Nb,+(+h[Ub+18680>>3]))+1.0;break}else{do{if(Hb){Wb=Ib;Xb=Jb;Yb=Kb;Zb=Lb;_b=Ib/Kb}else{if(Ib==0.0){Wb=Ib;Xb=Jb;Yb=Kb;Zb=Lb;_b=Ib;break}Nb=Ib/+xH(c[d+536>>2]|0,Kb,10216,13088,+h[Jb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Wb=+h[(c[Tb+8>>2]|0)+616>>3];Xb=Tb;Yb=+h[na+18656>>3];Zb=na;_b=Nb}}while(0);Ab=ma*+U(+_b);do{if(Yb!=0.0){$b=Xb;ac=Yb;bc=Zb;cc=Wb/Yb}else{if(Wb==0.0){$b=Xb;ac=Yb;bc=Zb;cc=Wb;break}Nb=Wb/+xH(c[d+536>>2]|0,Yb,10216,13088,+h[Xb>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;$b=c[c[(d+4|0)>>2]>>2]|0;ac=+h[Hb+18656>>3];bc=Hb;cc=Nb}}while(0);ma=+U(+cc);Nb=Ab+ +W(+ma,+(+h[bc+18680>>3]))+1.0;Bb=Nb/+xH(c[d+536>>2]|0,ac,10216,13088,+h[$b>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=P-ga*l*Bb;break}else{L=1}}if(L){L=0;if(1){do{if(G!=0.0){dc=G;ec=Ma;fc=B/G}else{if(B==0.0){dc=G;ec=Ma;fc=B;break}yb=B/+xH(c[d+536>>2]|0,G,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;dc=+h[$+18656>>3];ec=$;fc=yb}}while(0);G=F+z*+U(+fc)+-1.0;B=+h[ec+18672>>3];do{if(dc!=0.0){gc=dc;hc=ec;ic=f/dc}else{if(f==0.0){gc=dc;hc=ec;ic=f;break}ga=f/+xH(c[d+536>>2]|0,dc,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;gc=+h[A+18656>>3];hc=A;ic=ga}}while(0);z=B*ic;A=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[A+8>>2]|0)+616>>3];do{if(gc!=0.0){jc=gc;kc=hc;lc=F/gc}else{if(F==0.0){jc=gc;kc=hc;lc=F;break}ga=F/+xH(c[d+536>>2]|0,gc,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;jc=+h[$+18656>>3];kc=$;lc=ga}}while(0);F=+U(+lc);B=+h[kc+18680>>3];ga=+W(+F,+(B+-1.0));do{if(jc!=0.0){mc=jc;nc=kc;oc=j/jc}else{if(j==0.0){mc=jc;nc=kc;oc=j;break}F=j/+xH(c[d+536>>2]|0,jc,10216,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;mc=+h[A+18656>>3];nc=A;oc=F}}while(0);F=G*(z+ga*B*oc);P=+h[nc+18664>>3];yb=+h[nc+18672>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+616>>3];do{if(mc!=0.0){R=+U(+(zb/mc));pc=(yb*R+ +W(+R,+(+h[nc+18680>>3]))+1.0)/mc}else{if(zb==0.0){qc=zb;rc=A;sc=mc;tc=nc;uc=zb}else{R=zb/+xH(c[d+536>>2]|0,mc,10216,13088,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;qc=+h[(c[Hb+8>>2]|0)+616>>3];rc=Hb;sc=+h[$+18656>>3];tc=$;uc=R}R=yb*+U(+uc);do{if(sc!=0.0){vc=qc;wc=rc;xc=sc;yc=tc;zc=qc/sc}else{if(qc==0.0){vc=qc;wc=rc;xc=sc;yc=tc;zc=qc;break}S=qc/+xH(c[d+536>>2]|0,sc,10216,13088,+h[rc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;vc=+h[(c[Hb+8>>2]|0)+616>>3];wc=Hb;xc=+h[$+18656>>3];yc=$;zc=S}}while(0);Ab=+U(+zc);$=R+ +W(+Ab,+(+h[yc+18680>>3]))+1.0==0.0;Ab=+h[yc+18672>>3];Hb=xc!=0.0;if($){do{if(Hb){Ac=vc;Bc=wc;Cc=xc;Dc=yc;Ec=vc/xc}else{if(vc==0.0){Ac=vc;Bc=wc;Cc=xc;Dc=yc;Ec=vc;break}S=vc/+xH(c[d+536>>2]|0,xc,10216,13088,+h[wc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Ac=+h[(c[na+8>>2]|0)+616>>3];Bc=na;Cc=+h[$+18656>>3];Dc=$;Ec=S}}while(0);R=Ab*+U(+Ec);do{if(Cc!=0.0){Fc=Dc;Gc=Ac/Cc}else{if(Ac==0.0){Fc=Dc;Gc=Ac;break}S=Ac/+xH(c[d+536>>2]|0,Cc,10216,13088,+h[Bc>>3],(a[d+319|0]|0)!=0|0);Fc=c[(d+416|0)>>2]|0;Gc=S}}while(0);S=+U(+Gc);pc=R+ +W(+S,+(+h[Fc+18680>>3]))+1.0;break}else{do{if(Hb){Hc=vc;Ic=wc;Jc=xc;Kc=yc;Lc=vc/xc}else{if(vc==0.0){Hc=vc;Ic=wc;Jc=xc;Kc=yc;Lc=vc;break}S=vc/+xH(c[d+536>>2]|0,xc,10216,13088,+h[wc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Hc=+h[(c[na+8>>2]|0)+616>>3];Ic=na;Jc=+h[$+18656>>3];Kc=$;Lc=S}}while(0);R=Ab*+U(+Lc);do{if(Jc!=0.0){Mc=Ic;Nc=Jc;Oc=Kc;Pc=Hc/Jc}else{if(Hc==0.0){Mc=Ic;Nc=Jc;Oc=Kc;Pc=Hc;break}S=Hc/+xH(c[d+536>>2]|0,Jc,10216,13088,+h[Ic>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;Mc=c[c[(d+4|0)>>2]>>2]|0;Nc=+h[Hb+18656>>3];Oc=Hb;Pc=S}}while(0);Ab=+U(+Pc);S=R+ +W(+Ab,+(+h[Oc+18680>>3]))+1.0;pc=S/+xH(c[d+536>>2]|0,Nc,10216,13088,+h[Mc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=(F-P*l*pc)/+xH(c[d+536>>2]|0,q*q,10264,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{L=1}}}else{v=1}}}while(0);ze[r&3](19,15,za,48,e);ze[c[(e+8|0)>>2]&3](20,13,1.0,49,e);A=c[(d+416|0)>>2]|0;yb=+h[A+18696>>3];zb=+h[A+18704>>3];do{if(yb!=0.0){Qc=zb/yb}else{if(zb==0.0){Qc=zb;break}Qc=zb/+xH(c[d+536>>2]|0,yb,10552,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(!(Qc>0.0)){A=c[28168]|0;Hb=c[d+536>>2]|0;h[k>>3]=Qc;c[(b+48|0)>>2]=c[k>>2];c[(b+48|0)+4>>2]=c[k+4>>2];c[b+0>>2]=c[13104+0>>2];c[b+4>>2]=c[13104+4>>2];c[b+8>>2]=c[13104+8>>2];c[b+12>>2]=c[13104+12>>2];c[b+16>>2]=c[13104+16>>2];c[b+20>>2]=c[13104+20>>2];Pe[A&31](Hb,b,10592,b+48|0);}Hb=c[(e+8|0)>>2]|0;yb=+da(+Qc);zb=+h[(c[(d+416|0)>>2]|0)+18688>>3];do{if(yb!=0.0){Rc=zb/yb}else{if(zb==0.0){Rc=zb;break}Rc=zb/+xH(c[d+536>>2]|0,yb,10720,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[Hb&3](20,14,Rc*-7895683520871486.0e-21,50,e);ze[c[(e+8|0)>>2]&3](21,12,1.0,51,e);A=c[c[(d+4|0)>>2]>>2]|0;yb=+h[(c[A+8>>2]|0)+624>>3];if(yb!=0.0){Sc=yb}else{Sc=+xH(c[d+536>>2]|0,yb,10800,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}yb=1.0/Sc;ze[c[(e+8|0)>>2]&3](21,13,yb*yb,52,e);ze[c[(e+8|0)>>2]&3](22,8,-1.0,53,e);ze[c[(e+8|0)>>2]&3](22,9,-1.0,54,e);ze[c[(e+8|0)>>2]&3](22,11,-1.0,55,e);ze[c[(e+8|0)>>2]&3](22,23,1.0,56,e);ze[c[(e+8|0)>>2]&3](23,10,1.0,57,e);ze[c[(e+8|0)>>2]&3](23,11,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2912>>3],58,e);ze[c[(e+8|0)>>2]&3](24,9,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2888>>3],59,e);ze[c[(e+8|0)>>2]&3](24,10,1.0,60,e);ze[c[(e+8|0)>>2]&3](25,8,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2920>>3],61,e);ze[c[(e+8|0)>>2]&3](25,10,1.0,62,e);ze[c[(e+8|0)>>2]&3](26,7,1.0,63,e);A=c[(e+8|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;yb=+h[(c[$+8>>2]|0)+2968>>3];if(yb!=0.0){Tc=yb}else{Tc=+xH(c[d+536>>2]|0,yb,10152,13088,+h[$>>3],(a[d+319|0]|0)!=0|0)}ze[A&3](26,23,1.0/Tc,64,e);ze[c[(e+8|0)>>2]&3](27,6,1.0,65,e);yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){Uc=zb/yb}else{if(zb==0.0){Uc=zb;break}Uc=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(Uc>0.0){Vc=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){Wc=zb/yb}else{if(zb==0.0){Wc=zb;break}Wc=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);Vc=+(Wc<0.0|0)}yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){Xc=zb/yb}else{if(zb==0.0){Xc=zb;break}Xc=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(Xc>0.0){Yc=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){Zc=zb/yb}else{if(zb==0.0){Zc=zb;break}Zc=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);Yc=+(Zc<0.0|0)}yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){_c=zb/yb}else{if(zb==0.0){_c=zb;break}_c=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(_c>0.0){$c=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18728>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+560>>3];do{if(yb!=0.0){ad=zb/yb}else{if(zb==0.0){ad=zb;break}ad=zb/+xH(c[d+536>>2]|0,yb,9840,13088,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);$c=+(ad<0.0|0)}A=c[(d+416|0)>>2]|0;yb=+h[A+18744>>3];zb=+h[A+18728>>3];Hb=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[Hb+8>>2]|0)+560>>3];do{if(zb!=0.0){bd=B;cd=Hb;dd=zb;ed=A;fd=B/zb}else{if(B==0.0){bd=B;cd=Hb;dd=zb;ed=A;fd=B;break}ga=B/+xH(c[d+536>>2]|0,zb,9840,13088,+h[Hb>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[na+8>>2]|0)+560>>3];cd=na;dd=+h[$+18728>>3];ed=$;fd=ga}}while(0);zb=yb*+U(+fd);do{if(dd!=0.0){gd=bd;hd=cd;id=dd;jd=ed;kd=bd/dd}else{if(bd==0.0){gd=bd;hd=cd;id=dd;jd=ed;kd=bd;break}B=bd/+xH(c[d+536>>2]|0,dd,9840,13088,+h[cd>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;A=c[c[(d+4|0)>>2]>>2]|0;gd=+h[(c[A+8>>2]|0)+560>>3];hd=A;id=+h[Hb+18728>>3];jd=Hb;kd=B}}while(0);yb=+U(+kd);B=zb+ +W(+yb,+(+h[jd+18752>>3]))+1.0;Hb=c[(e+8|0)>>2]|0;yb=+h[jd+18720>>3];ga=+h[jd+18736>>3];A=id!=0.0;do{$=1;if($){$=0;if(B*B!=0.0){do{if(A){ld=id;md=jd;nd=gd/id}else{if(gd==0.0){ld=id;md=jd;nd=gd;break}z=gd/+xH(c[d+536>>2]|0,id,9840,13088,+h[hd>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;ld=+h[na+18728>>3];md=na;nd=z}}while(0);P=yb+ga*+U(+nd)+-1.0;F=+h[md+18744>>3];do{if(ld!=0.0){od=ld;pd=md;qd=Vc/ld}else{if(Vc==0.0){od=ld;pd=md;qd=Vc;break}z=Vc/+xH(c[d+536>>2]|0,ld,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;od=+h[v+18728>>3];pd=v;qd=z}}while(0);z=F*qd;v=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[v+8>>2]|0)+560>>3];do{if(od!=0.0){rd=od;sd=pd;td=G/od}else{if(G==0.0){rd=od;sd=pd;td=G;break}S=G/+xH(c[d+536>>2]|0,od,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;rd=+h[L+18728>>3];sd=L;td=S}}while(0);G=+U(+td);F=+h[sd+18752>>3];S=+W(+G,+(F+-1.0));do{if(rd!=0.0){ud=rd;vd=sd;wd=Yc/rd}else{if(Yc==0.0){ud=rd;vd=sd;wd=Yc;break}G=Yc/+xH(c[d+536>>2]|0,rd,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ud=+h[v+18728>>3];vd=v;wd=G}}while(0);G=P*(z+S*F*wd);Ab=+h[vd+18736>>3];Q=+h[vd+18744>>3];v=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[v+8>>2]|0)+560>>3];do{if(ud!=0.0){Nb=+U(+(K/ud));xd=(Q*Nb+ +W(+Nb,+(+h[vd+18752>>3]))+1.0)/ud}else{if(K==0.0){yd=K;zd=v;Ad=ud;Bd=vd;Cd=K}else{Nb=K/+xH(c[d+536>>2]|0,ud,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;yd=+h[(c[na+8>>2]|0)+560>>3];zd=na;Ad=+h[L+18728>>3];Bd=L;Cd=Nb}Nb=Q*+U(+Cd);do{if(Ad!=0.0){Dd=yd;Ed=zd;Fd=Ad;Gd=Bd;Hd=yd/Ad}else{if(yd==0.0){Dd=yd;Ed=zd;Fd=Ad;Gd=Bd;Hd=yd;break}ma=yd/+xH(c[d+536>>2]|0,Ad,9840,13088,+h[zd>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Dd=+h[(c[na+8>>2]|0)+560>>3];Ed=na;Fd=+h[L+18728>>3];Gd=L;Hd=ma}}while(0);R=+U(+Hd);L=Nb+ +W(+R,+(+h[Gd+18752>>3]))+1.0==0.0;R=+h[Gd+18744>>3];na=Fd!=0.0;if(L){do{if(na){Id=Dd;Jd=Ed;Kd=Fd;Ld=Gd;Md=Dd/Fd}else{if(Dd==0.0){Id=Dd;Jd=Ed;Kd=Fd;Ld=Gd;Md=Dd;break}ma=Dd/+xH(c[d+536>>2]|0,Fd,9840,13088,+h[Ed>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Id=+h[(c[Tb+8>>2]|0)+560>>3];Jd=Tb;Kd=+h[L+18728>>3];Ld=L;Md=ma}}while(0);Nb=R*+U(+Md);do{if(Kd!=0.0){Nd=Ld;Od=Id/Kd}else{if(Id==0.0){Nd=Ld;Od=Id;break}ma=Id/+xH(c[d+536>>2]|0,Kd,9840,13088,+h[Jd>>3],(a[d+319|0]|0)!=0|0);Nd=c[(d+416|0)>>2]|0;Od=ma}}while(0);ma=+U(+Od);xd=Nb+ +W(+ma,+(+h[Nd+18752>>3]))+1.0;break}else{do{if(na){Pd=Dd;Qd=Ed;Rd=Fd;Sd=Gd;Td=Dd/Fd}else{if(Dd==0.0){Pd=Dd;Qd=Ed;Rd=Fd;Sd=Gd;Td=Dd;break}ma=Dd/+xH(c[d+536>>2]|0,Fd,9840,13088,+h[Ed>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Pd=+h[(c[Tb+8>>2]|0)+560>>3];Qd=Tb;Rd=+h[L+18728>>3];Sd=L;Td=ma}}while(0);Nb=R*+U(+Td);do{if(Rd!=0.0){Ud=Qd;Vd=Rd;Wd=Sd;Xd=Pd/Rd}else{if(Pd==0.0){Ud=Qd;Vd=Rd;Wd=Sd;Xd=Pd;break}ma=Pd/+xH(c[d+536>>2]|0,Rd,9840,13088,+h[Qd>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ud=c[c[(d+4|0)>>2]>>2]|0;Vd=+h[na+18728>>3];Wd=na;Xd=ma}}while(0);R=+U(+Xd);ma=Nb+ +W(+R,+(+h[Wd+18752>>3]))+1.0;xd=ma/+xH(c[d+536>>2]|0,Vd,9840,13088,+h[Ud>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=(G-Ab*$c*xd)/(B*B)}else{$=1}}if($){$=0;if(1){do{if(A){Zd=id;_d=jd;$d=gd/id}else{if(gd==0.0){Zd=id;_d=jd;$d=gd;break}Q=gd/+xH(c[d+536>>2]|0,id,9840,13088,+h[hd>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Zd=+h[v+18728>>3];_d=v;$d=Q}}while(0);Ab=yb+ga*+U(+$d)+-1.0;G=+h[_d+18744>>3];do{if(Zd!=0.0){ae=Zd;be=_d;ce=Vc/Zd}else{if(Vc==0.0){ae=Zd;be=_d;ce=Vc;break}Q=Vc/+xH(c[d+536>>2]|0,Zd,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ae=+h[v+18728>>3];be=v;ce=Q}}while(0);Q=G*ce;v=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[v+8>>2]|0)+560>>3];do{if(ae!=0.0){de=ae;ee=be;fe=K/ae}else{if(K==0.0){de=ae;ee=be;fe=K;break}F=K/+xH(c[d+536>>2]|0,ae,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;de=+h[na+18728>>3];ee=na;fe=F}}while(0);K=+U(+fe);G=+h[ee+18752>>3];F=+W(+K,+(G+-1.0));do{if(de!=0.0){ge=de;he=ee;ie=Yc/de}else{if(Yc==0.0){ge=de;he=ee;ie=Yc;break}K=Yc/+xH(c[d+536>>2]|0,de,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ge=+h[v+18728>>3];he=v;ie=K}}while(0);K=Ab*(Q+F*G*ie);S=+h[he+18736>>3];z=+h[he+18744>>3];v=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[v+8>>2]|0)+560>>3];do{if(ge!=0.0){ma=+U(+(P/ge));je=he;ke=(z*ma+ +W(+ma,+(+h[he+18752>>3]))+1.0)/ge}else{if(P==0.0){le=P;me=v;ne=ge;oe=he;pe=P}else{ma=P/+xH(c[d+536>>2]|0,ge,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;le=+h[(c[L+8>>2]|0)+560>>3];me=L;ne=+h[na+18728>>3];oe=na;pe=ma}ma=z*+U(+pe);do{if(ne!=0.0){qe=le;re=me;se=ne;te=oe;ue=le/ne}else{if(le==0.0){qe=le;re=me;se=ne;te=oe;ue=le;break}R=le/+xH(c[d+536>>2]|0,ne,9840,13088,+h[me>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;qe=+h[(c[L+8>>2]|0)+560>>3];re=L;se=+h[na+18728>>3];te=na;ue=R}}while(0);Nb=+U(+ue);na=ma+ +W(+Nb,+(+h[te+18752>>3]))+1.0==0.0;Nb=+h[te+18744>>3];L=se!=0.0;if(na){do{if(L){ve=qe;we=re;xe=se;ye=te;Ae=qe/se}else{if(qe==0.0){ve=qe;we=re;xe=se;ye=te;Ae=qe;break}R=qe/+xH(c[d+536>>2]|0,se,9840,13088,+h[re>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;ve=+h[(c[Tb+8>>2]|0)+560>>3];we=Tb;xe=+h[na+18728>>3];ye=na;Ae=R}}while(0);ma=Nb*+U(+Ae);do{if(xe!=0.0){Be=ye;Ce=ve/xe}else{if(ve==0.0){Be=ye;Ce=ve;break}R=ve/+xH(c[d+536>>2]|0,xe,9840,13088,+h[we>>3],(a[d+319|0]|0)!=0|0);Be=c[(d+416|0)>>2]|0;Ce=R}}while(0);R=+U(+Ce);je=Be;ke=ma+ +W(+R,+(+h[Be+18752>>3]))+1.0;break}else{do{if(L){De=qe;Ee=re;Fe=se;Ge=te;He=qe/se}else{if(qe==0.0){De=qe;Ee=re;Fe=se;Ge=te;He=qe;break}R=qe/+xH(c[d+536>>2]|0,se,9840,13088,+h[re>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;De=+h[(c[Tb+8>>2]|0)+560>>3];Ee=Tb;Fe=+h[na+18728>>3];Ge=na;He=R}}while(0);ma=Nb*+U(+He);do{if(Fe!=0.0){Ie=Ee;Je=Fe;Ke=Ge;Le=De/Fe}else{if(De==0.0){Ie=Ee;Je=Fe;Ke=Ge;Le=De;break}R=De/+xH(c[d+536>>2]|0,Fe,9840,13088,+h[Ee>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Ie=c[c[(d+4|0)>>2]>>2]|0;Je=+h[L+18728>>3];Ke=L;Le=R}}while(0);Nb=+U(+Le);R=ma+ +W(+Nb,+(+h[Ke+18752>>3]))+1.0;Nb=R/+xH(c[d+536>>2]|0,Je,9840,13088,+h[Ie>>3],(a[d+319|0]|0)!=0|0);je=c[(d+416|0)>>2]|0;ke=Nb;break}}}while(0);z=+h[je+18720>>3];P=+h[je+18736>>3];G=+h[je+18728>>3];v=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[v+8>>2]|0)+560>>3];L=1;if(L){L=0;if(K-S*$c*ke==0.0){do{if(G!=0.0){Me=G;Ne=je;Oe=F/G}else{if(F==0.0){Me=G;Ne=je;Oe=F;break}Q=F/+xH(c[d+536>>2]|0,G,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Me=+h[na+18728>>3];Ne=na;Oe=Q}}while(0);S=z+P*+U(+Oe)+-1.0;K=+h[Ne+18744>>3];do{if(Me!=0.0){Qe=Me;Re=Ne;Se=Vc/Me}else{if(Vc==0.0){Qe=Me;Re=Ne;Se=Vc;break}Q=Vc/+xH(c[d+536>>2]|0,Me,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Qe=+h[na+18728>>3];Re=na;Se=Q}}while(0);Q=K*Se;na=c[c[(d+4|0)>>2]>>2]|0;Ab=+h[(c[na+8>>2]|0)+560>>3];do{if(Qe!=0.0){Te=Qe;Ue=Re;Ve=Ab/Qe}else{if(Ab==0.0){Te=Qe;Ue=Re;Ve=Ab;break}Nb=Ab/+xH(c[d+536>>2]|0,Qe,9840,13088,+h[na>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;Te=+h[Tb+18728>>3];Ue=Tb;Ve=Nb}}while(0);Ab=+U(+Ve);K=+h[Ue+18752>>3];Nb=+W(+Ab,+(K+-1.0));do{if(Te!=0.0){We=Te;Xe=Ue;Ye=Yc/Te}else{if(Yc==0.0){We=Te;Xe=Ue;Ye=Yc;break}Ab=Yc/+xH(c[d+536>>2]|0,Te,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;We=+h[na+18728>>3];Xe=na;Ye=Ab}}while(0);Ab=S*(Q+Nb*K*Ye);R=+h[Xe+18736>>3];Ze=+h[Xe+18744>>3];na=c[c[(d+4|0)>>2]>>2]|0;_e=+h[(c[na+8>>2]|0)+560>>3];do{if(We!=0.0){$e=+U(+(_e/We));af=(Ze*$e+ +W(+$e,+(+h[Xe+18752>>3]))+1.0)/We}else{if(_e==0.0){bf=_e;cf=na;df=We;ef=Xe;ff=_e}else{$e=_e/+xH(c[d+536>>2]|0,We,9840,13088,+h[na>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;bf=+h[(c[gf+8>>2]|0)+560>>3];cf=gf;df=+h[Tb+18728>>3];ef=Tb;ff=$e}$e=Ze*+U(+ff);do{if(df!=0.0){hf=bf;jf=cf;kf=df;lf=ef;mf=bf/df}else{if(bf==0.0){hf=bf;jf=cf;kf=df;lf=ef;mf=bf;break}nf=bf/+xH(c[d+536>>2]|0,df,9840,13088,+h[cf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;hf=+h[(c[gf+8>>2]|0)+560>>3];jf=gf;kf=+h[Tb+18728>>3];lf=Tb;mf=nf}}while(0);ma=+U(+mf);Tb=$e+ +W(+ma,+(+h[lf+18752>>3]))+1.0==0.0;ma=+h[lf+18744>>3];gf=kf!=0.0;if(Tb){do{if(gf){of=hf;pf=jf;qf=kf;rf=lf;sf=hf/kf}else{if(hf==0.0){of=hf;pf=jf;qf=kf;rf=lf;sf=hf;break}nf=hf/+xH(c[d+536>>2]|0,kf,9840,13088,+h[jf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;tf=c[c[(d+4|0)>>2]>>2]|0;of=+h[(c[tf+8>>2]|0)+560>>3];pf=tf;qf=+h[Tb+18728>>3];rf=Tb;sf=nf}}while(0);$e=ma*+U(+sf);do{if(qf!=0.0){uf=rf;vf=of/qf}else{if(of==0.0){uf=rf;vf=of;break}nf=of/+xH(c[d+536>>2]|0,qf,9840,13088,+h[pf>>3],(a[d+319|0]|0)!=0|0);uf=c[(d+416|0)>>2]|0;vf=nf}}while(0);nf=+U(+vf);af=$e+ +W(+nf,+(+h[uf+18752>>3]))+1.0;break}else{do{if(gf){wf=hf;xf=jf;yf=kf;zf=lf;Af=hf/kf}else{if(hf==0.0){wf=hf;xf=jf;yf=kf;zf=lf;Af=hf;break}nf=hf/+xH(c[d+536>>2]|0,kf,9840,13088,+h[jf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;tf=c[c[(d+4|0)>>2]>>2]|0;wf=+h[(c[tf+8>>2]|0)+560>>3];xf=tf;yf=+h[Tb+18728>>3];zf=Tb;Af=nf}}while(0);$e=ma*+U(+Af);do{if(yf!=0.0){Bf=xf;Cf=yf;Df=zf;Ef=wf/yf}else{if(wf==0.0){Bf=xf;Cf=yf;Df=zf;Ef=wf;break}nf=wf/+xH(c[d+536>>2]|0,yf,9840,13088,+h[xf>>3],(a[d+319|0]|0)!=0|0);gf=c[(d+416|0)>>2]|0;Bf=c[c[(d+4|0)>>2]>>2]|0;Cf=+h[gf+18728>>3];Df=gf;Ef=nf}}while(0);ma=+U(+Ef);nf=$e+ +W(+ma,+(+h[Df+18752>>3]))+1.0;af=nf/+xH(c[d+536>>2]|0,Cf,9840,13088,+h[Bf>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=Ab-R*$c*af;break}else{L=1}}if(L){L=0;if(1){do{if(G!=0.0){Ff=G;Gf=je;Hf=F/G}else{if(F==0.0){Ff=G;Gf=je;Hf=F;break}Ze=F/+xH(c[d+536>>2]|0,G,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ff=+h[na+18728>>3];Gf=na;Hf=Ze}}while(0);G=z+P*+U(+Hf)+-1.0;F=+h[Gf+18744>>3];do{if(Ff!=0.0){If=Ff;Jf=Gf;Kf=Vc/Ff}else{if(Vc==0.0){If=Ff;Jf=Gf;Kf=Vc;break}R=Vc/+xH(c[d+536>>2]|0,Ff,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;If=+h[v+18728>>3];Jf=v;Kf=R}}while(0);P=F*Kf;v=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[v+8>>2]|0)+560>>3];do{if(If!=0.0){Lf=If;Mf=Jf;Nf=z/If}else{if(z==0.0){Lf=If;Mf=Jf;Nf=z;break}R=z/+xH(c[d+536>>2]|0,If,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Lf=+h[na+18728>>3];Mf=na;Nf=R}}while(0);z=+U(+Nf);F=+h[Mf+18752>>3];R=+W(+z,+(F+-1.0));do{if(Lf!=0.0){Of=Lf;Pf=Mf;Qf=Yc/Lf}else{if(Yc==0.0){Of=Lf;Pf=Mf;Qf=Yc;break}z=Yc/+xH(c[d+536>>2]|0,Lf,9840,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Of=+h[v+18728>>3];Pf=v;Qf=z}}while(0);z=G*(P+R*F*Qf);Ab=+h[Pf+18736>>3];Ze=+h[Pf+18744>>3];v=c[c[(d+4|0)>>2]>>2]|0;_e=+h[(c[v+8>>2]|0)+560>>3];do{if(Of!=0.0){K=+U(+(_e/Of));Rf=(Ze*K+ +W(+K,+(+h[Pf+18752>>3]))+1.0)/Of}else{if(_e==0.0){Sf=_e;Tf=v;Uf=Of;Vf=Pf;Wf=_e}else{K=_e/+xH(c[d+536>>2]|0,Of,9840,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;Sf=+h[(c[gf+8>>2]|0)+560>>3];Tf=gf;Uf=+h[na+18728>>3];Vf=na;Wf=K}K=Ze*+U(+Wf);do{if(Uf!=0.0){Xf=Sf;Yf=Tf;Zf=Uf;_f=Vf;$f=Sf/Uf}else{if(Sf==0.0){Xf=Sf;Yf=Tf;Zf=Uf;_f=Vf;$f=Sf;break}Nb=Sf/+xH(c[d+536>>2]|0,Uf,9840,13088,+h[Tf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;Xf=+h[(c[gf+8>>2]|0)+560>>3];Yf=gf;Zf=+h[na+18728>>3];_f=na;$f=Nb}}while(0);$e=+U(+$f);na=K+ +W(+$e,+(+h[_f+18752>>3]))+1.0==0.0;$e=+h[_f+18744>>3];gf=Zf!=0.0;if(na){do{if(gf){ag=Xf;bg=Yf;cg=Zf;dg=_f;eg=Xf/Zf}else{if(Xf==0.0){ag=Xf;bg=Yf;cg=Zf;dg=_f;eg=Xf;break}Nb=Xf/+xH(c[d+536>>2]|0,Zf,9840,13088,+h[Yf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;ag=+h[(c[Tb+8>>2]|0)+560>>3];bg=Tb;cg=+h[na+18728>>3];dg=na;eg=Nb}}while(0);K=$e*+U(+eg);do{if(cg!=0.0){fg=dg;gg=ag/cg}else{if(ag==0.0){fg=dg;gg=ag;break}Nb=ag/+xH(c[d+536>>2]|0,cg,9840,13088,+h[bg>>3],(a[d+319|0]|0)!=0|0);fg=c[(d+416|0)>>2]|0;gg=Nb}}while(0);Nb=+U(+gg);Rf=K+ +W(+Nb,+(+h[fg+18752>>3]))+1.0;break}else{do{if(gf){hg=Xf;ig=Yf;jg=Zf;kg=_f;lg=Xf/Zf}else{if(Xf==0.0){hg=Xf;ig=Yf;jg=Zf;kg=_f;lg=Xf;break}Nb=Xf/+xH(c[d+536>>2]|0,Zf,9840,13088,+h[Yf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;hg=+h[(c[Tb+8>>2]|0)+560>>3];ig=Tb;jg=+h[na+18728>>3];kg=na;lg=Nb}}while(0);K=$e*+U(+lg);do{if(jg!=0.0){mg=ig;ng=jg;og=kg;pg=hg/jg}else{if(hg==0.0){mg=ig;ng=jg;og=kg;pg=hg;break}Nb=hg/+xH(c[d+536>>2]|0,jg,9840,13088,+h[ig>>3],(a[d+319|0]|0)!=0|0);gf=c[(d+416|0)>>2]|0;mg=c[c[(d+4|0)>>2]>>2]|0;ng=+h[gf+18728>>3];og=gf;pg=Nb}}while(0);$e=+U(+pg);Nb=K+ +W(+$e,+(+h[og+18752>>3]))+1.0;Rf=Nb/+xH(c[d+536>>2]|0,ng,9840,13088,+h[mg>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=(z-Ab*$c*Rf)/+xH(c[d+536>>2]|0,B*B,9888,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{L=1}}}else{$=1}}}while(0);ze[Hb&3](27,7,Yd,66,e);ze[c[(e+8|0)>>2]&3](28,5,1.0,67,e);A=c[(e+8|0)>>2]|0;B=+h[(c[(d+416|0)>>2]|0)+18760>>3];v=c[c[(d+4|0)>>2]>>2]|0;ga=+h[(c[v+8>>2]|0)+2968>>3];do{if(B!=0.0){qg=ga/B}else{if(ga==0.0){qg=ga;break}qg=ga/+xH(c[d+536>>2]|0,B,9808,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[A&3](28,6,qg*-1256637061435917.0e-21,68,e);ze[c[(e+8|0)>>2]&3](29,4,1.0,69,e);v=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[v+8>>2]|0)+568>>3];if(B!=0.0){rg=B;sg=1.0/rg;tg=c[(e+8|0)>>2]|0;ug=sg*sg;ze[tg&3](29,5,ug,70,e);vg=c[(e+8|0)>>2]|0;ze[vg&3](30,3,1.0,71,e);wg=c[(e+8|0)>>2]|0;xg=c[(d+4|0)>>2]|0;yg=c[xg>>2]|0;zg=yg;Ag=zg+8|0;Bg=Ag;Cg=c[Bg>>2]|0;Dg=Cg;Eg=Dg+696|0;Fg=Eg;Gg=+h[Fg>>3];ze[wg&3](30,4,Gg,72,e);Hg=c[(e+8|0)>>2]|0;Ig=c[(d+4|0)>>2]|0;Jg=c[Ig>>2]|0;Kg=Jg;Lg=Kg+8|0;Mg=Lg;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+576|0;Qg=Pg;Rg=+h[Qg>>3];ze[Hg&3](30,23,Rg,73,e);Sg=c[(e+8|0)>>2]|0;ze[Sg&3](31,1,-1.0,74,e);Tg=c[(e+8|0)>>2]|0;ze[Tg&3](31,2,-1.0,75,e);Ug=c[(e+8|0)>>2]|0;ze[Ug&3](31,23,-1.0,76,e);Vg=c[(e+8|0)>>2]|0;ze[Vg&3](32,1,1.0,77,e);Wg=c[(e+8|0)>>2]|0;ze[Wg&3](32,2,1.0,78,e);Xg=c[(e+8|0)>>2]|0;ze[Xg&3](33,0,1.0,79,e);Yg=c[(e+8|0)>>2]|0;Zg=c[(d+4|0)>>2]|0;_g=c[Zg>>2]|0;$g=_g;ah=$g+8|0;bh=ah;ch=c[bh>>2]|0;dh=ch;eh=dh+240|0;fh=eh;gh=+h[fh>>3];hh=-gh;ze[Yg&3](33,1,hh,80,e);i=b;c[b+14032>>2]=5;break a}rg=+xH(c[d+536>>2]|0,B,9776,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);sg=1.0/rg;tg=c[(e+8|0)>>2]|0;ug=sg*sg;ze[tg&3](29,5,ug,70,e);vg=c[(e+8|0)>>2]|0;ze[vg&3](30,3,1.0,71,e);wg=c[(e+8|0)>>2]|0;xg=c[(d+4|0)>>2]|0;yg=c[xg>>2]|0;zg=yg;Ag=zg+8|0;Bg=Ag;Cg=c[Bg>>2]|0;Dg=Cg;Eg=Dg+696|0;Fg=Eg;Gg=+h[Fg>>3];ze[wg&3](30,4,Gg,72,e);Hg=c[(e+8|0)>>2]|0;Ig=c[(d+4|0)>>2]|0;Jg=c[Ig>>2]|0;Kg=Jg;Lg=Kg+8|0;Mg=Lg;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+576|0;Qg=Pg;Rg=+h[Qg>>3];ze[Hg&3](30,23,Rg,73,e);Sg=c[(e+8|0)>>2]|0;ze[Sg&3](31,1,-1.0,74,e);Tg=c[(e+8|0)>>2]|0;ze[Tg&3](31,2,-1.0,75,e);Ug=c[(e+8|0)>>2]|0;ze[Ug&3](31,23,-1.0,76,e);Vg=c[(e+8|0)>>2]|0;ze[Vg&3](32,1,1.0,77,e);Wg=c[(e+8|0)>>2]|0;ze[Wg&3](32,2,1.0,78,e);Xg=c[(e+8|0)>>2]|0;ze[Xg&3](33,0,1.0,79,e);Yg=c[(e+8|0)>>2]|0;Zg=c[(d+4|0)>>2]|0;_g=c[Zg>>2]|0;$g=_g;ah=$g+8|0;bh=ah;ch=c[bh>>2]|0;dh=ch;eh=dh+240|0;fh=eh;gh=+h[fh>>3];hh=-gh;ze[Yg&3](33,1,hh,80,e);i=b;c[b+14032>>2]=5;break a}while(0)}function _setLinearMatrixA562$1(b){b=b|0;var d=0,e=0,f=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0.0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0,T=0.0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0,hb=0.0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0.0,ub=0,vb=0.0,wb=0,xb=0.0,yb=0.0,zb=0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0.0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0.0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0.0,pc=0.0,qc=0,rc=0.0,sc=0.0,tc=0,uc=0.0,vc=0.0,wc=0,xc=0.0,yc=0.0,zc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0.0,Ic=0,Jc=0.0,Kc=0,Lc=0.0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0,Sc=0.0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0.0,ad=0.0,bd=0.0,cd=0.0,dd=0.0,ed=0.0,fd=0.0,gd=0.0,hd=0.0,id=0.0,jd=0.0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0,pd=0.0;d=c[b+64>>2]|0;e=c[b+72>>2]|0;f=+g[b+6144>>2];i=+g[b+6256>>2];j=+g[b+6344>>2];l=+g[b+6472>>2];m=c[b+6480>>2]|0;n=+g[b+6488>>2];o=c[b+6496>>2]|0;p=+g[b+6520>>2];q=c[b+6528>>2]|0;r=+g[b+6536>>2];s=+g[b+6544>>2];t=c[b+6552>>2]|0;u=c[b+13952>>2]|0;ze[c[(e+8|0)>>2]&3](11,23,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],30,e);ze[c[(e+8|0)>>2]&3](12,10,1.0,31,e);ze[c[(e+8|0)>>2]&3](12,21,1.0,32,e);ze[c[(e+8|0)>>2]&3](12,22,1.0,33,e);ze[c[(e+8|0)>>2]&3](13,20,1.0,34,e);v=c[(e+8|0)>>2]|0;w=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[w+8>>2]|0)+2952>>3];if(x!=0.0){y=x}else{y=+xH(c[d+536>>2]|0,x,10832,13088,+h[w>>3],(a[d+319|0]|0)!=0|0)}ze[v&3](13,23,-1.0/y,35,e);ze[c[(e+8|0)>>2]&3](14,19,1.0,36,e);y=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[v+8>>2]|0)+672>>3];do{if(y!=0.0){z=x/y}else{if(x==0.0){z=x;break}z=x/+xH(c[d+536>>2]|0,y,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(z>0.0){A=1.0}else{z=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+672>>3];do{if(z!=0.0){B=y/z}else{if(y==0.0){B=y;break}B=y/+xH(c[d+536>>2]|0,z,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);A=+(B<0.0|0)}B=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[v+8>>2]|0)+672>>3];do{if(B!=0.0){C=z/B}else{if(z==0.0){C=z;break}C=z/+xH(c[d+536>>2]|0,B,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(C>0.0){D=1.0}else{C=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[v+8>>2]|0)+672>>3];do{if(C!=0.0){E=B/C}else{if(B==0.0){E=B;break}E=B/+xH(c[d+536>>2]|0,C,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);D=+(E<0.0|0)}E=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;C=+h[(c[v+8>>2]|0)+672>>3];do{if(E!=0.0){F=C/E}else{if(C==0.0){F=C;break}F=C/+xH(c[d+536>>2]|0,E,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(F>0.0){G=1.0}else{F=+h[(c[(d+416|0)>>2]|0)+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[v+8>>2]|0)+672>>3];do{if(F!=0.0){H=E/F}else{if(E==0.0){H=E;break}H=E/+xH(c[d+536>>2]|0,F,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);G=+(H<0.0|0)}v=c[(d+416|0)>>2]|0;H=+h[v+18600>>3];F=+h[v+18584>>3];w=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[w+8>>2]|0)+672>>3];do{if(F!=0.0){I=E;J=w;K=F;L=v;M=E/F}else{if(E==0.0){I=E;J=w;K=F;L=v;M=E;break}C=E/+xH(c[d+536>>2]|0,F,10864,13088,+h[w>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;I=+h[(c[O+8>>2]|0)+672>>3];J=O;K=+h[N+18584>>3];L=N;M=C}}while(0);F=H*+U(+M);do{if(K!=0.0){P=I;Q=J;R=K;S=L;T=I/K}else{if(I==0.0){P=I;Q=J;R=K;S=L;T=I;break}M=I/+xH(c[d+536>>2]|0,K,10864,13088,+h[J>>3],(a[d+319|0]|0)!=0|0);w=c[(d+416|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[v+8>>2]|0)+672>>3];Q=v;R=+h[w+18584>>3];S=w;T=M}}while(0);K=+U(+T);T=F+ +W(+K,+(+h[S+18608>>3]))+1.0;J=c[(e+8|0)>>2]|0;K=+h[S+18576>>3];F=+h[S+18592>>3];L=R!=0.0;do{w=1;if(w){w=0;if(T*T!=0.0){do{if(L){V=R;X=S;Y=P/R}else{if(P==0.0){V=R;X=S;Y=P;break}I=P/+xH(c[d+536>>2]|0,R,10864,13088,+h[Q>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;V=+h[v+18584>>3];X=v;Y=I}}while(0);I=K+F*+U(+Y)+-1.0;M=+h[X+18600>>3];do{if(V!=0.0){Z=V;_=X;$=A/V}else{if(A==0.0){Z=V;_=X;$=A;break}H=A/+xH(c[d+536>>2]|0,V,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Z=+h[v+18584>>3];_=v;$=H}}while(0);H=M*$;v=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[v+8>>2]|0)+672>>3];do{if(Z!=0.0){aa=Z;ba=_;ca=E/Z}else{if(E==0.0){aa=Z;ba=_;ca=E;break}C=E/+xH(c[d+536>>2]|0,Z,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;aa=+h[N+18584>>3];ba=N;ca=C}}while(0);E=+U(+ca);M=+h[ba+18608>>3];C=+W(+E,+(M+-1.0));do{if(aa!=0.0){ea=aa;fa=ba;ga=D/aa}else{if(D==0.0){ea=aa;fa=ba;ga=D;break}E=D/+xH(c[d+536>>2]|0,aa,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ea=+h[v+18584>>3];fa=v;ga=E}}while(0);E=I*(H+C*M*ga);B=+h[fa+18592>>3];z=+h[fa+18600>>3];v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+672>>3];do{if(ea!=0.0){x=+U(+(y/ea));ha=(z*x+ +W(+x,+(+h[fa+18608>>3]))+1.0)/ea}else{if(y==0.0){ia=y;ja=v;ka=ea;la=fa;ma=y}else{x=y/+xH(c[d+536>>2]|0,ea,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;ia=+h[(c[O+8>>2]|0)+672>>3];ja=O;ka=+h[N+18584>>3];la=N;ma=x}x=z*+U(+ma);do{if(ka!=0.0){na=ia;oa=ja;pa=ka;qa=la;ra=ia/ka}else{if(ia==0.0){na=ia;oa=ja;pa=ka;qa=la;ra=ia;break}sa=ia/+xH(c[d+536>>2]|0,ka,10864,13088,+h[ja>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;na=+h[(c[O+8>>2]|0)+672>>3];oa=O;pa=+h[N+18584>>3];qa=N;ra=sa}}while(0);sa=+U(+ra);N=x+ +W(+sa,+(+h[qa+18608>>3]))+1.0==0.0;sa=+h[qa+18600>>3];O=pa!=0.0;if(N){do{if(O){ta=na;ua=oa;va=pa;wa=qa;xa=na/pa}else{if(na==0.0){ta=na;ua=oa;va=pa;wa=qa;xa=na;break}ya=na/+xH(c[d+536>>2]|0,pa,10864,13088,+h[oa>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;ta=+h[(c[za+8>>2]|0)+672>>3];ua=za;va=+h[N+18584>>3];wa=N;xa=ya}}while(0);x=sa*+U(+xa);do{if(va!=0.0){Aa=wa;Ba=ta/va}else{if(ta==0.0){Aa=wa;Ba=ta;break}ya=ta/+xH(c[d+536>>2]|0,va,10864,13088,+h[ua>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;Ba=ya}}while(0);ya=+U(+Ba);ha=x+ +W(+ya,+(+h[Aa+18608>>3]))+1.0;break}else{do{if(O){Ca=na;Da=oa;Ea=pa;Fa=qa;Ga=na/pa}else{if(na==0.0){Ca=na;Da=oa;Ea=pa;Fa=qa;Ga=na;break}ya=na/+xH(c[d+536>>2]|0,pa,10864,13088,+h[oa>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Ca=+h[(c[za+8>>2]|0)+672>>3];Da=za;Ea=+h[N+18584>>3];Fa=N;Ga=ya}}while(0);x=sa*+U(+Ga);do{if(Ea!=0.0){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ca/Ea}else{if(Ca==0.0){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ca;break}ya=Ca/+xH(c[d+536>>2]|0,Ea,10864,13088,+h[Da>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Ha=c[c[(d+4|0)>>2]>>2]|0;Ia=+h[O+18584>>3];Ja=O;Ka=ya}}while(0);sa=+U(+Ka);ya=x+ +W(+sa,+(+h[Ja+18608>>3]))+1.0;ha=ya/+xH(c[d+536>>2]|0,Ia,10864,13088,+h[Ha>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=(E-B*G*ha)/(T*T)}else{w=1}}if(w){w=0;if(1){do{if(L){Ma=R;Na=S;Oa=P/R}else{if(P==0.0){Ma=R;Na=S;Oa=P;break}z=P/+xH(c[d+536>>2]|0,R,10864,13088,+h[Q>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Ma=+h[v+18584>>3];Na=v;Oa=z}}while(0);B=K+F*+U(+Oa)+-1.0;E=+h[Na+18600>>3];do{if(Ma!=0.0){Pa=Ma;Qa=Na;Ra=A/Ma}else{if(A==0.0){Pa=Ma;Qa=Na;Ra=A;break}z=A/+xH(c[d+536>>2]|0,Ma,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Pa=+h[v+18584>>3];Qa=v;Ra=z}}while(0);z=E*Ra;v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+672>>3];do{if(Pa!=0.0){Sa=Pa;Ta=Qa;Ua=y/Pa}else{if(y==0.0){Sa=Pa;Ta=Qa;Ua=y;break}M=y/+xH(c[d+536>>2]|0,Pa,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Sa=+h[O+18584>>3];Ta=O;Ua=M}}while(0);y=+U(+Ua);E=+h[Ta+18608>>3];M=+W(+y,+(E+-1.0));do{if(Sa!=0.0){Va=Sa;Wa=Ta;Xa=D/Sa}else{if(D==0.0){Va=Sa;Wa=Ta;Xa=D;break}y=D/+xH(c[d+536>>2]|0,Sa,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Va=+h[v+18584>>3];Wa=v;Xa=y}}while(0);y=B*(z+M*E*Xa);C=+h[Wa+18592>>3];H=+h[Wa+18600>>3];v=c[c[(d+4|0)>>2]>>2]|0;I=+h[(c[v+8>>2]|0)+672>>3];do{if(Va!=0.0){ya=+U(+(I/Va));Ya=Wa;Za=(H*ya+ +W(+ya,+(+h[Wa+18608>>3]))+1.0)/Va}else{if(I==0.0){_a=I;$a=v;ab=Va;bb=Wa;cb=I}else{ya=I/+xH(c[d+536>>2]|0,Va,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;N=c[c[(d+4|0)>>2]>>2]|0;_a=+h[(c[N+8>>2]|0)+672>>3];$a=N;ab=+h[O+18584>>3];bb=O;cb=ya}ya=H*+U(+cb);do{if(ab!=0.0){db=_a;eb=$a;fb=ab;gb=bb;hb=_a/ab}else{if(_a==0.0){db=_a;eb=$a;fb=ab;gb=bb;hb=_a;break}sa=_a/+xH(c[d+536>>2]|0,ab,10864,13088,+h[$a>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;N=c[c[(d+4|0)>>2]>>2]|0;db=+h[(c[N+8>>2]|0)+672>>3];eb=N;fb=+h[O+18584>>3];gb=O;hb=sa}}while(0);x=+U(+hb);O=ya+ +W(+x,+(+h[gb+18608>>3]))+1.0==0.0;x=+h[gb+18600>>3];N=fb!=0.0;if(O){do{if(N){ib=db;jb=eb;kb=fb;lb=gb;mb=db/fb}else{if(db==0.0){ib=db;jb=eb;kb=fb;lb=gb;mb=db;break}sa=db/+xH(c[d+536>>2]|0,fb,10864,13088,+h[eb>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;ib=+h[(c[za+8>>2]|0)+672>>3];jb=za;kb=+h[O+18584>>3];lb=O;mb=sa}}while(0);ya=x*+U(+mb);do{if(kb!=0.0){nb=lb;ob=ib/kb}else{if(ib==0.0){nb=lb;ob=ib;break}sa=ib/+xH(c[d+536>>2]|0,kb,10864,13088,+h[jb>>3],(a[d+319|0]|0)!=0|0);nb=c[(d+416|0)>>2]|0;ob=sa}}while(0);sa=+U(+ob);Ya=nb;Za=ya+ +W(+sa,+(+h[nb+18608>>3]))+1.0;break}else{do{if(N){pb=db;qb=eb;rb=fb;sb=gb;tb=db/fb}else{if(db==0.0){pb=db;qb=eb;rb=fb;sb=gb;tb=db;break}sa=db/+xH(c[d+536>>2]|0,fb,10864,13088,+h[eb>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;pb=+h[(c[za+8>>2]|0)+672>>3];qb=za;rb=+h[O+18584>>3];sb=O;tb=sa}}while(0);ya=x*+U(+tb);do{if(rb!=0.0){ub=qb;vb=rb;wb=sb;xb=pb/rb}else{if(pb==0.0){ub=qb;vb=rb;wb=sb;xb=pb;break}sa=pb/+xH(c[d+536>>2]|0,rb,10864,13088,+h[qb>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;ub=c[c[(d+4|0)>>2]>>2]|0;vb=+h[N+18584>>3];wb=N;xb=sa}}while(0);x=+U(+xb);sa=ya+ +W(+x,+(+h[wb+18608>>3]))+1.0;x=sa/+xH(c[d+536>>2]|0,vb,10864,13088,+h[ub>>3],(a[d+319|0]|0)!=0|0);Ya=c[(d+416|0)>>2]|0;Za=x;break}}}while(0);H=+h[Ya+18576>>3];I=+h[Ya+18592>>3];E=+h[Ya+18584>>3];v=c[c[(d+4|0)>>2]>>2]|0;M=+h[(c[v+8>>2]|0)+672>>3];N=1;if(N){N=0;if(y-C*G*Za==0.0){do{if(E!=0.0){yb=E;zb=Ya;Ab=M/E}else{if(M==0.0){yb=E;zb=Ya;Ab=M;break}z=M/+xH(c[d+536>>2]|0,E,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;yb=+h[O+18584>>3];zb=O;Ab=z}}while(0);C=H+I*+U(+Ab)+-1.0;y=+h[zb+18600>>3];do{if(yb!=0.0){Bb=yb;Cb=zb;Db=A/yb}else{if(A==0.0){Bb=yb;Cb=zb;Db=A;break}z=A/+xH(c[d+536>>2]|0,yb,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Bb=+h[O+18584>>3];Cb=O;Db=z}}while(0);z=y*Db;O=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[O+8>>2]|0)+672>>3];do{if(Bb!=0.0){Eb=Bb;Fb=Cb;Gb=B/Bb}else{if(B==0.0){Eb=Bb;Fb=Cb;Gb=B;break}x=B/+xH(c[d+536>>2]|0,Bb,10864,13088,+h[O>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Eb=+h[za+18584>>3];Fb=za;Gb=x}}while(0);B=+U(+Gb);y=+h[Fb+18608>>3];x=+W(+B,+(y+-1.0));do{if(Eb!=0.0){Hb=Eb;Ib=Fb;Jb=D/Eb}else{if(D==0.0){Hb=Eb;Ib=Fb;Jb=D;break}B=D/+xH(c[d+536>>2]|0,Eb,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Hb=+h[O+18584>>3];Ib=O;Jb=B}}while(0);B=C*(z+x*y*Jb);sa=+h[Ib+18592>>3];Kb=+h[Ib+18600>>3];O=c[c[(d+4|0)>>2]>>2]|0;Lb=+h[(c[O+8>>2]|0)+672>>3];do{if(Hb!=0.0){Mb=+U(+(Lb/Hb));Nb=(Kb*Mb+ +W(+Mb,+(+h[Ib+18608>>3]))+1.0)/Hb}else{if(Lb==0.0){Ob=Lb;Pb=O;Qb=Hb;Rb=Ib;Sb=Lb}else{Mb=Lb/+xH(c[d+536>>2]|0,Hb,10864,13088,+h[O>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ob=+h[(c[Tb+8>>2]|0)+672>>3];Pb=Tb;Qb=+h[za+18584>>3];Rb=za;Sb=Mb}Mb=Kb*+U(+Sb);do{if(Qb!=0.0){Ub=Ob;Vb=Pb;Wb=Qb;Xb=Rb;Yb=Ob/Qb}else{if(Ob==0.0){Ub=Ob;Vb=Pb;Wb=Qb;Xb=Rb;Yb=Ob;break}Zb=Ob/+xH(c[d+536>>2]|0,Qb,10864,13088,+h[Pb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ub=+h[(c[Tb+8>>2]|0)+672>>3];Vb=Tb;Wb=+h[za+18584>>3];Xb=za;Yb=Zb}}while(0);ya=+U(+Yb);za=Mb+ +W(+ya,+(+h[Xb+18608>>3]))+1.0==0.0;ya=+h[Xb+18600>>3];Tb=Wb!=0.0;if(za){do{if(Tb){_b=Ub;$b=Vb;ac=Wb;bc=Xb;cc=Ub/Wb}else{if(Ub==0.0){_b=Ub;$b=Vb;ac=Wb;bc=Xb;cc=Ub;break}Zb=Ub/+xH(c[d+536>>2]|0,Wb,10864,13088,+h[Vb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;dc=c[c[(d+4|0)>>2]>>2]|0;_b=+h[(c[dc+8>>2]|0)+672>>3];$b=dc;ac=+h[za+18584>>3];bc=za;cc=Zb}}while(0);Mb=ya*+U(+cc);do{if(ac!=0.0){ec=bc;fc=_b/ac}else{if(_b==0.0){ec=bc;fc=_b;break}Zb=_b/+xH(c[d+536>>2]|0,ac,10864,13088,+h[$b>>3],(a[d+319|0]|0)!=0|0);ec=c[(d+416|0)>>2]|0;fc=Zb}}while(0);Zb=+U(+fc);Nb=Mb+ +W(+Zb,+(+h[ec+18608>>3]))+1.0;break}else{do{if(Tb){gc=Ub;hc=Vb;ic=Wb;jc=Xb;kc=Ub/Wb}else{if(Ub==0.0){gc=Ub;hc=Vb;ic=Wb;jc=Xb;kc=Ub;break}Zb=Ub/+xH(c[d+536>>2]|0,Wb,10864,13088,+h[Vb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;dc=c[c[(d+4|0)>>2]>>2]|0;gc=+h[(c[dc+8>>2]|0)+672>>3];hc=dc;ic=+h[za+18584>>3];jc=za;kc=Zb}}while(0);Mb=ya*+U(+kc);do{if(ic!=0.0){lc=hc;mc=ic;nc=jc;oc=gc/ic}else{if(gc==0.0){lc=hc;mc=ic;nc=jc;oc=gc;break}Zb=gc/+xH(c[d+536>>2]|0,ic,10864,13088,+h[hc>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;lc=c[c[(d+4|0)>>2]>>2]|0;mc=+h[Tb+18584>>3];nc=Tb;oc=Zb}}while(0);ya=+U(+oc);Zb=Mb+ +W(+ya,+(+h[nc+18608>>3]))+1.0;Nb=Zb/+xH(c[d+536>>2]|0,mc,10864,13088,+h[lc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=B-sa*G*Nb;break}else{N=1}}if(N){N=0;if(1){do{if(E!=0.0){pc=E;qc=Ya;rc=M/E}else{if(M==0.0){pc=E;qc=Ya;rc=M;break}Kb=M/+xH(c[d+536>>2]|0,E,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;pc=+h[O+18584>>3];qc=O;rc=Kb}}while(0);E=H+I*+U(+rc)+-1.0;M=+h[qc+18600>>3];do{if(pc!=0.0){sc=pc;tc=qc;uc=A/pc}else{if(A==0.0){sc=pc;tc=qc;uc=A;break}sa=A/+xH(c[d+536>>2]|0,pc,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;sc=+h[v+18584>>3];tc=v;uc=sa}}while(0);I=M*uc;v=c[c[(d+4|0)>>2]>>2]|0;H=+h[(c[v+8>>2]|0)+672>>3];do{if(sc!=0.0){vc=sc;wc=tc;xc=H/sc}else{if(H==0.0){vc=sc;wc=tc;xc=H;break}sa=H/+xH(c[d+536>>2]|0,sc,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;vc=+h[O+18584>>3];wc=O;xc=sa}}while(0);H=+U(+xc);M=+h[wc+18608>>3];sa=+W(+H,+(M+-1.0));do{if(vc!=0.0){yc=vc;zc=wc;Ac=D/vc}else{if(D==0.0){yc=vc;zc=wc;Ac=D;break}H=D/+xH(c[d+536>>2]|0,vc,10864,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;yc=+h[v+18584>>3];zc=v;Ac=H}}while(0);H=E*(I+sa*M*Ac);B=+h[zc+18592>>3];Kb=+h[zc+18600>>3];v=c[c[(d+4|0)>>2]>>2]|0;Lb=+h[(c[v+8>>2]|0)+672>>3];do{if(yc!=0.0){y=+U(+(Lb/yc));Bc=(Kb*y+ +W(+y,+(+h[zc+18608>>3]))+1.0)/yc}else{if(Lb==0.0){Cc=Lb;Dc=v;Ec=yc;Fc=zc;Gc=Lb}else{y=Lb/+xH(c[d+536>>2]|0,yc,10864,13088,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Cc=+h[(c[Tb+8>>2]|0)+672>>3];Dc=Tb;Ec=+h[O+18584>>3];Fc=O;Gc=y}y=Kb*+U(+Gc);do{if(Ec!=0.0){Hc=Cc;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Cc/Ec}else{if(Cc==0.0){Hc=Cc;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Cc;break}x=Cc/+xH(c[d+536>>2]|0,Ec,10864,13088,+h[Dc>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Hc=+h[(c[Tb+8>>2]|0)+672>>3];Ic=Tb;Jc=+h[O+18584>>3];Kc=O;Lc=x}}while(0);Mb=+U(+Lc);O=y+ +W(+Mb,+(+h[Kc+18608>>3]))+1.0==0.0;Mb=+h[Kc+18600>>3];Tb=Jc!=0.0;if(O){do{if(Tb){Mc=Hc;Nc=Ic;Oc=Jc;Pc=Kc;Qc=Hc/Jc}else{if(Hc==0.0){Mc=Hc;Nc=Ic;Oc=Jc;Pc=Kc;Qc=Hc;break}x=Hc/+xH(c[d+536>>2]|0,Jc,10864,13088,+h[Ic>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Mc=+h[(c[za+8>>2]|0)+672>>3];Nc=za;Oc=+h[O+18584>>3];Pc=O;Qc=x}}while(0);y=Mb*+U(+Qc);do{if(Oc!=0.0){Rc=Pc;Sc=Mc/Oc}else{if(Mc==0.0){Rc=Pc;Sc=Mc;break}x=Mc/+xH(c[d+536>>2]|0,Oc,10864,13088,+h[Nc>>3],(a[d+319|0]|0)!=0|0);Rc=c[(d+416|0)>>2]|0;Sc=x}}while(0);x=+U(+Sc);Bc=y+ +W(+x,+(+h[Rc+18608>>3]))+1.0;break}else{do{if(Tb){Tc=Hc;Uc=Ic;Vc=Jc;Wc=Kc;Xc=Hc/Jc}else{if(Hc==0.0){Tc=Hc;Uc=Ic;Vc=Jc;Wc=Kc;Xc=Hc;break}x=Hc/+xH(c[d+536>>2]|0,Jc,10864,13088,+h[Ic>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Tc=+h[(c[za+8>>2]|0)+672>>3];Uc=za;Vc=+h[O+18584>>3];Wc=O;Xc=x}}while(0);y=Mb*+U(+Xc);do{if(Vc!=0.0){Yc=Uc;Zc=Vc;_c=Wc;$c=Tc/Vc}else{if(Tc==0.0){Yc=Uc;Zc=Vc;_c=Wc;$c=Tc;break}x=Tc/+xH(c[d+536>>2]|0,Vc,10864,13088,+h[Uc>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;Yc=c[c[(d+4|0)>>2]>>2]|0;Zc=+h[Tb+18584>>3];_c=Tb;$c=x}}while(0);Mb=+U(+$c);x=y+ +W(+Mb,+(+h[_c+18608>>3]))+1.0;Bc=x/+xH(c[d+536>>2]|0,Zc,10864,13088,+h[Yc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=(H-B*G*Bc)/+xH(c[d+536>>2]|0,T*T,10912,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{N=1}}}else{w=1}}}while(0);ze[J&3](14,20,La,37,e);ze[c[(e+8|0)>>2]&3](15,18,1.0,38,e);J=c[(d+416|0)>>2]|0;La=+h[J+18624>>3];T=+h[J+18632>>3];do{if(La!=0.0){ad=T/La}else{if(T==0.0){ad=T;break}ad=T/+xH(c[d+536>>2]|0,La,11200,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(!(ad>0.0)){J=c[28168]|0;Yc=c[d+536>>2]|0;h[k>>3]=ad;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];_c=b+24|0;c[_c+0>>2]=c[13104+0>>2];c[_c+4>>2]=c[13104+4>>2];c[_c+8>>2]=c[13104+8>>2];c[_c+12>>2]=c[13104+12>>2];c[_c+16>>2]=c[13104+16>>2];c[_c+20>>2]=c[13104+20>>2];Pe[J&31](Yc,b+24|0,11232,u);}u=c[(e+8|0)>>2]|0;La=+da(+ad);ad=+h[(c[(d+416|0)>>2]|0)+18616>>3];do{if(La!=0.0){bd=ad/La}else{if(ad==0.0){bd=ad;break}bd=ad/+xH(c[d+536>>2]|0,La,11360,13088,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[u&3](15,19,bd*-7895683520871486.0e-21,39,e);ze[c[(e+8|0)>>2]&3](16,17,1.0,40,e);u=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[u+8>>2]|0)+680>>3];if(bd!=0.0){cd=bd}else{cd=+xH(c[d+536>>2]|0,bd,11440,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}bd=1.0/cd;ze[c[(e+8|0)>>2]&3](16,18,bd*bd,41,e);ze[c[(e+8|0)>>2]&3](17,12,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],42,e);ze[c[(e+8|0)>>2]&3](17,16,1.0,43,e);ze[c[(e+8|0)>>2]&3](17,23,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+632>>3],44,e);ze[c[(e+8|0)>>2]&3](18,15,1.0,45,e);u=c[(e+8|0)>>2]|0;Yc=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[Yc+8>>2]|0)+2960>>3];if(bd!=0.0){dd=bd}else{dd=+xH(c[d+536>>2]|0,bd,10184,13088,+h[Yc>>3],(a[d+319|0]|0)!=0|0)}ze[u&3](18,23,1.0/dd,46,e);ze[c[(e+8|0)>>2]&3](19,14,1.0,47,e);dd=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[u+8>>2]|0)+616>>3];do{if(dd!=0.0){ed=bd/dd}else{if(bd==0.0){ed=bd;break}ed=bd/+xH(c[d+536>>2]|0,dd,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(ed>0.0){f=1.0}else{ed=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;dd=+h[(c[u+8>>2]|0)+616>>3];do{if(ed!=0.0){fd=dd/ed}else{if(dd==0.0){fd=dd;break}fd=dd/+xH(c[d+536>>2]|0,ed,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);f=+(fd<0.0|0)}fd=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;ed=+h[(c[u+8>>2]|0)+616>>3];do{if(fd!=0.0){gd=ed/fd}else{if(ed==0.0){gd=ed;break}gd=ed/+xH(c[d+536>>2]|0,fd,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(gd>0.0){i=1.0}else{gd=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;fd=+h[(c[u+8>>2]|0)+616>>3];do{if(gd!=0.0){hd=fd/gd}else{if(fd==0.0){hd=fd;break}hd=fd/+xH(c[d+536>>2]|0,gd,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);i=+(hd<0.0|0)}hd=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;gd=+h[(c[u+8>>2]|0)+616>>3];do{if(hd!=0.0){id=gd/hd}else{if(gd==0.0){id=gd;break}id=gd/+xH(c[d+536>>2]|0,hd,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(id>0.0){j=1.0}else{id=+h[(c[(d+416|0)>>2]|0)+18656>>3];u=c[c[(d+4|0)>>2]>>2]|0;hd=+h[(c[u+8>>2]|0)+616>>3];do{if(id!=0.0){jd=hd/id}else{if(hd==0.0){jd=hd;break}jd=hd/+xH(c[d+536>>2]|0,id,10216,13088,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);j=+(jd<0.0|0)}u=c[(d+416|0)>>2]|0;jd=+h[u+18672>>3];id=+h[u+18656>>3];Yc=c[c[(d+4|0)>>2]>>2]|0;hd=+h[(c[Yc+8>>2]|0)+616>>3];do{if(id!=0.0){kd=hd;ld=Yc;md=id;nd=u;od=hd/id}else{if(hd==0.0){kd=hd;ld=Yc;md=id;nd=u;od=hd;break}gd=hd/+xH(c[d+536>>2]|0,id,10216,13088,+h[Yc>>3],(a[d+319|0]|0)!=0|0);J=c[(d+416|0)>>2]|0;_c=c[c[(d+4|0)>>2]>>2]|0;kd=+h[(c[_c+8>>2]|0)+616>>3];ld=_c;md=+h[J+18656>>3];nd=J;od=gd}}while(0);id=jd*+U(+od);do{if(md!=0.0){l=kd;m=ld;n=md;o=nd;pd=kd/md}else{if(kd==0.0){l=kd;m=ld;n=md;o=nd;pd=kd;break}od=kd/+xH(c[d+536>>2]|0,md,10216,13088,+h[ld>>3],(a[d+319|0]|0)!=0|0);Yc=c[(d+416|0)>>2]|0;u=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[u+8>>2]|0)+616>>3];m=u;n=+h[Yc+18656>>3];o=Yc;pd=od}}while(0);md=+U(+pd);p=id+ +W(+md,+(+h[o+18680>>3]))+1.0;q=c[(e+8|0)>>2]|0;r=+h[o+18648>>3];s=+h[o+18664>>3];t=n!=0.0;g[b+6144>>2]=f;g[b+6256>>2]=i;g[b+6344>>2]=j;g[b+6472>>2]=l;c[b+6480>>2]=m;g[b+6488>>2]=n;c[b+6496>>2]=o;g[b+6520>>2]=p;c[b+6528>>2]=q;g[b+6536>>2]=r;g[b+6544>>2]=s;c[b+6552>>2]=t}



function hs(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17872>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1536>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1536>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1536>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1536>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1536>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1536>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,18280,18272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17888>>3];r=+h[j+17872>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1536>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,18280,18272,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1536>>3];x=E;y=D;z=+h[C+17872>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,18280,18272,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1536>>3];G=+h[u+17872>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17896>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17880>>3];r=+h[H+2328>>3];H=G!=0.0;B=+h[J+17888>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,18280,18272,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1536>>3];O=A;P=+h[y+17872>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,18280,18272,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1536>>3];T=A;V=+h[y+17872>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17896>>3]))+1.0==0.0;q=+h[X+17888>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,18280,18272,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1536>>3];_=x;$=+h[y+17872>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,18280,18272,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17896>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,18280,18272,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1536>>3];fa=x;ga=+h[y+17872>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,18280,18272,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17872>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17896>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,18280,18272,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17864>>3];ma=+h[L+17880>>3];ga=+h[L+17872>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1536>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,18280,18272,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17872>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17888>>3];ma=+h[na+2328>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,18280,18272,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17872>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1536>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,18280,18272,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17872>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17896>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2328>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,18280,18272,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,18280,18272,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1536>>3];Qa=xa;Ra=+h[ya+17872>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,18280,18272,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1536>>3];Va=xa;Wa=+h[ya+17872>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17896>>3]))+1.0==0.0;t=+h[Xa+17888>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,18280,18272,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1536>>3];_a=Aa;$a=+h[ya+17872>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,18280,18272,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17896>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,18280,18272,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1536>>3];fb=Aa;gb=+h[ya+17872>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,18280,18272,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17872>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17896>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,18280,18272,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17864>>3];r=+h[Na+17880>>3];w=+h[Na+17872>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1536>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,18280,18272,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17872>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17888>>3];r=+h[nb+2328>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,18280,18272,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17872>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1536>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,18280,18272,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17872>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17896>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2328>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,18280,18272,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17872>>3];Db=+h[sb+2328>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17880>>3];yb=Cb!=0.0;ub=+h[Gb+17888>>3];rb=+h[Eb+1536>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17896>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,18280,18272,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1536>>3];Lb=Ab;Mb=+h[Eb+17872>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,18280,18272,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1536>>3];Qb=Ab;Rb=+h[Eb+17872>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17896>>3]))+1.0==0.0;Ca=+h[Sb+17888>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,18280,18272,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1536>>3];Vb=xb;Wb=+h[Eb+17872>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,18280,18272,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17896>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,18280,18272,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1536>>3];ac=xb;bc=+h[Eb+17872>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,18280,18272,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17872>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17896>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,18280,18272,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17864>>3];hc=+h[Ib+17880>>3];bc=+h[Ib+17872>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1536>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,18280,18272,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17872>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17888>>3];hc=+h[ic+2328>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,18280,18272,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17872>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1536>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,18280,18272,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17872>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17896>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2328>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,18280,18272,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17896>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,18280,18272,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1536>>3];Bc=sc;Cc=+h[tc+17872>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,18280,18272,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1536>>3];Gc=sc;Hc=+h[tc+17872>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17896>>3]))+1.0==0.0;Hb=+h[Ic+17888>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,18280,18272,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1536>>3];Lc=vc;Mc=+h[tc+17872>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,18280,18272,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17896>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,18280,18272,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1536>>3];Sc=vc;Tc=+h[tc+17872>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,18280,18272,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17872>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17896>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,18280,18272,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17864>>3];Db=+h[yc+17880>>3];m=+h[yc+17872>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1536>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,18280,18272,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17872>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17888>>3];Db=+h[_c+2328>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,18280,18272,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17872>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1536>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,18280,18272,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17872>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17896>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2328>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,18280,18272,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,18328,18272,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function is(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2512>>3];k=+h[(c[b+416>>2]|0)+17904>>3];l=+h[g+2832>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,18608,18600,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2320>>3]=j*n*1256637061435917.0e-21;i=d;return}function js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1520>>3]*1256637061435917.0e-21;k=+h[g+1536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,18648,18640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}function ks(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1544>>3];k=j*j;j=+h[g+2320>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,18712,18704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=-(+h[b+2552>>3]*+h[b+1552>>3])- +h[b+2032>>3]*+h[b+2312>>3];i=i;return}function ms(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17408>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1888>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1888>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1888>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1888>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1888>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1888>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,18760,18752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17424>>3];r=+h[j+17408>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1888>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,18760,18752,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1888>>3];x=E;y=D;z=+h[C+17408>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,18760,18752,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1888>>3];G=+h[u+17408>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17432>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17416>>3];r=+h[H+2208>>3];H=G!=0.0;B=+h[J+17424>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,18760,18752,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1888>>3];O=A;P=+h[y+17408>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,18760,18752,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1888>>3];T=A;V=+h[y+17408>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17432>>3]))+1.0==0.0;q=+h[X+17424>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,18760,18752,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1888>>3];_=x;$=+h[y+17408>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,18760,18752,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17432>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,18760,18752,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1888>>3];fa=x;ga=+h[y+17408>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,18760,18752,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17408>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17432>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,18760,18752,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17400>>3];ma=+h[L+17416>>3];ga=+h[L+17408>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1888>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,18760,18752,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17408>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17424>>3];ma=+h[na+2208>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,18760,18752,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17408>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1888>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,18760,18752,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17408>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17432>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2208>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,18760,18752,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,18760,18752,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1888>>3];Qa=xa;Ra=+h[ya+17408>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,18760,18752,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1888>>3];Va=xa;Wa=+h[ya+17408>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17432>>3]))+1.0==0.0;t=+h[Xa+17424>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,18760,18752,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1888>>3];_a=Aa;$a=+h[ya+17408>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,18760,18752,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17432>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,18760,18752,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1888>>3];fb=Aa;gb=+h[ya+17408>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,18760,18752,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17408>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17432>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,18760,18752,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17400>>3];r=+h[Na+17416>>3];w=+h[Na+17408>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1888>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,18760,18752,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17408>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17424>>3];r=+h[nb+2208>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,18760,18752,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17408>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1888>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,18760,18752,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17408>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17432>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2208>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,18760,18752,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17408>>3];Db=+h[sb+2208>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17416>>3];yb=Cb!=0.0;ub=+h[Gb+17424>>3];rb=+h[Eb+1888>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17432>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,18760,18752,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1888>>3];Lb=Ab;Mb=+h[Eb+17408>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,18760,18752,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1888>>3];Qb=Ab;Rb=+h[Eb+17408>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17432>>3]))+1.0==0.0;Ca=+h[Sb+17424>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,18760,18752,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1888>>3];Vb=xb;Wb=+h[Eb+17408>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,18760,18752,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17432>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,18760,18752,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1888>>3];ac=xb;bc=+h[Eb+17408>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,18760,18752,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17408>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17432>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,18760,18752,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17400>>3];hc=+h[Ib+17416>>3];bc=+h[Ib+17408>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1888>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,18760,18752,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17408>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17424>>3];hc=+h[ic+2208>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,18760,18752,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17408>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1888>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,18760,18752,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17408>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17432>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2208>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,18760,18752,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17432>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,18760,18752,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1888>>3];Bc=sc;Cc=+h[tc+17408>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,18760,18752,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1888>>3];Gc=sc;Hc=+h[tc+17408>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17432>>3]))+1.0==0.0;Hb=+h[Ic+17424>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,18760,18752,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1888>>3];Lc=vc;Mc=+h[tc+17408>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,18760,18752,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17432>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,18760,18752,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1888>>3];Sc=vc;Tc=+h[tc+17408>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,18760,18752,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17408>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17432>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,18760,18752,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17400>>3];Db=+h[yc+17416>>3];m=+h[yc+17408>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1888>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,18760,18752,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17408>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17424>>3];Db=+h[_c+2208>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,18760,18752,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17408>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1888>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,18760,18752,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17408>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17432>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2208>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,18760,18752,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,18816,18752,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function ns(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2424>>3];k=+h[(c[b+416>>2]|0)+17440>>3];l=+h[g+2760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,19136,19128,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2200>>3]=j*n*1256637061435917.0e-21;i=d;return}function os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=j*j;j=+h[g+2200>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,19184,19176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}function ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1872>>3]*1256637061435917.0e-21;k=+h[g+1888>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,19240,19232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}function qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=-(+h[b+2632>>3]*+h[b+1904>>3])- +h[b+2080>>3]*+h[b+2192>>3];i=i;return}function rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[(c[a+416>>2]|0)+17232>>3]*+h[b+2080>>3];i=i;return}function ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2072>>3]+ +h[b+2024>>3];i=i;return}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+64>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+2072>>3]*1.0e13;l=j}else{m=+h[j+64>>3];n=+h[j+2072>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,19312,19304,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+2064>>3]=+U(+k);i=d;return}function us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2064>>3]+ +h[b+2016>>3];i=i;return}function vs(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17696>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1664>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1664>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1664>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1664>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1664>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1664>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,19352,19344,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17712>>3];r=+h[j+17696>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1664>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,19352,19344,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1664>>3];x=E;y=D;z=+h[C+17696>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,19352,19344,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1664>>3];G=+h[u+17696>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17720>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17704>>3];r=+h[H+2304>>3];H=G!=0.0;B=+h[J+17712>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,19352,19344,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1664>>3];O=A;P=+h[y+17696>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,19352,19344,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1664>>3];T=A;V=+h[y+17696>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17720>>3]))+1.0==0.0;q=+h[X+17712>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,19352,19344,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1664>>3];_=x;$=+h[y+17696>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,19352,19344,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17720>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,19352,19344,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1664>>3];fa=x;ga=+h[y+17696>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,19352,19344,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17696>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17720>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,19352,19344,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17688>>3];ma=+h[L+17704>>3];ga=+h[L+17696>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1664>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,19352,19344,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17696>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17712>>3];ma=+h[na+2304>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,19352,19344,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17696>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1664>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,19352,19344,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17696>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17720>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2304>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,19352,19344,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,19352,19344,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1664>>3];Qa=xa;Ra=+h[ya+17696>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,19352,19344,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1664>>3];Va=xa;Wa=+h[ya+17696>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17720>>3]))+1.0==0.0;t=+h[Xa+17712>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,19352,19344,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1664>>3];_a=Aa;$a=+h[ya+17696>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,19352,19344,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17720>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,19352,19344,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1664>>3];fb=Aa;gb=+h[ya+17696>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,19352,19344,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17696>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17720>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,19352,19344,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17688>>3];r=+h[Na+17704>>3];w=+h[Na+17696>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1664>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,19352,19344,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17696>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17712>>3];r=+h[nb+2304>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,19352,19344,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17696>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1664>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,19352,19344,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17696>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17720>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2304>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,19352,19344,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17696>>3];Db=+h[sb+2304>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17704>>3];yb=Cb!=0.0;ub=+h[Gb+17712>>3];rb=+h[Eb+1664>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17720>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,19352,19344,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1664>>3];Lb=Ab;Mb=+h[Eb+17696>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,19352,19344,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1664>>3];Qb=Ab;Rb=+h[Eb+17696>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17720>>3]))+1.0==0.0;Ca=+h[Sb+17712>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,19352,19344,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1664>>3];Vb=xb;Wb=+h[Eb+17696>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,19352,19344,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17720>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,19352,19344,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1664>>3];ac=xb;bc=+h[Eb+17696>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,19352,19344,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17696>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17720>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,19352,19344,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17688>>3];hc=+h[Ib+17704>>3];bc=+h[Ib+17696>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1664>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,19352,19344,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17696>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17712>>3];hc=+h[ic+2304>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,19352,19344,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17696>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1664>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,19352,19344,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17696>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17720>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2304>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,19352,19344,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17720>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,19352,19344,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1664>>3];Bc=sc;Cc=+h[tc+17696>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,19352,19344,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1664>>3];Gc=sc;Hc=+h[tc+17696>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17720>>3]))+1.0==0.0;Hb=+h[Ic+17712>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,19352,19344,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1664>>3];Lc=vc;Mc=+h[tc+17696>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,19352,19344,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17720>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,19352,19344,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1664>>3];Sc=vc;Tc=+h[tc+17696>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,19352,19344,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17696>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17720>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,19352,19344,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17688>>3];Db=+h[yc+17704>>3];m=+h[yc+17696>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1664>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,19352,19344,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17696>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17712>>3];Db=+h[_c+2304>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,19352,19344,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17696>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1664>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,19352,19344,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17696>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17720>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2304>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,19352,19344,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,19400,19344,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function ws(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2488>>3];k=+h[(c[b+416>>2]|0)+17728>>3];l=+h[g+2792>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,19688,19680,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2296>>3]=j*n*1256637061435917.0e-21;i=d;return}function xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1648>>3]*1256637061435917.0e-21;k=+h[g+1664>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,19728,19720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=j*j;j=+h[g+2296>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,19792,19784,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}function zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=-(+h[b+2632>>3]*+h[b+1680>>3])- +h[b+2080>>3]*+h[b+2288>>3];i=i;return}function As(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17624>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1720>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1720>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1720>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1720>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1720>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1720>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,19840,19832,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17640>>3];r=+h[j+17624>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1720>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,19840,19832,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1720>>3];x=E;y=D;z=+h[C+17624>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,19840,19832,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1720>>3];G=+h[u+17624>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17648>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17632>>3];r=+h[H+2280>>3];H=G!=0.0;B=+h[J+17640>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,19840,19832,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1720>>3];O=A;P=+h[y+17624>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,19840,19832,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1720>>3];T=A;V=+h[y+17624>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17648>>3]))+1.0==0.0;q=+h[X+17640>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,19840,19832,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1720>>3];_=x;$=+h[y+17624>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,19840,19832,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17648>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,19840,19832,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1720>>3];fa=x;ga=+h[y+17624>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,19840,19832,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17624>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17648>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,19840,19832,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17616>>3];ma=+h[L+17632>>3];ga=+h[L+17624>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1720>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,19840,19832,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17624>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17640>>3];ma=+h[na+2280>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,19840,19832,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17624>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1720>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,19840,19832,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17624>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17648>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2280>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,19840,19832,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,19840,19832,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1720>>3];Qa=xa;Ra=+h[ya+17624>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,19840,19832,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1720>>3];Va=xa;Wa=+h[ya+17624>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17648>>3]))+1.0==0.0;t=+h[Xa+17640>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,19840,19832,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1720>>3];_a=Aa;$a=+h[ya+17624>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,19840,19832,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17648>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,19840,19832,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1720>>3];fb=Aa;gb=+h[ya+17624>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,19840,19832,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17624>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17648>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,19840,19832,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17616>>3];r=+h[Na+17632>>3];w=+h[Na+17624>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1720>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,19840,19832,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17624>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17640>>3];r=+h[nb+2280>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,19840,19832,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17624>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1720>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,19840,19832,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17624>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17648>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2280>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,19840,19832,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17624>>3];Db=+h[sb+2280>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17632>>3];yb=Cb!=0.0;ub=+h[Gb+17640>>3];rb=+h[Eb+1720>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17648>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,19840,19832,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1720>>3];Lb=Ab;Mb=+h[Eb+17624>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,19840,19832,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1720>>3];Qb=Ab;Rb=+h[Eb+17624>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17648>>3]))+1.0==0.0;Ca=+h[Sb+17640>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,19840,19832,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1720>>3];Vb=xb;Wb=+h[Eb+17624>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,19840,19832,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17648>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,19840,19832,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1720>>3];ac=xb;bc=+h[Eb+17624>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,19840,19832,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17624>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17648>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,19840,19832,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17616>>3];hc=+h[Ib+17632>>3];bc=+h[Ib+17624>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1720>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,19840,19832,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17624>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17640>>3];hc=+h[ic+2280>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,19840,19832,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17624>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1720>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,19840,19832,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17624>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17648>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2280>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,19840,19832,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17648>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,19840,19832,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1720>>3];Bc=sc;Cc=+h[tc+17624>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,19840,19832,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1720>>3];Gc=sc;Hc=+h[tc+17624>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17648>>3]))+1.0==0.0;Hb=+h[Ic+17640>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,19840,19832,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1720>>3];Lc=vc;Mc=+h[tc+17624>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,19840,19832,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17648>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,19840,19832,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1720>>3];Sc=vc;Tc=+h[tc+17624>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,19840,19832,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17624>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17648>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,19840,19832,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17616>>3];Db=+h[yc+17632>>3];m=+h[yc+17624>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1720>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,19840,19832,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17624>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17640>>3];Db=+h[_c+2280>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,19840,19832,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17624>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1720>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,19840,19832,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17624>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17648>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2280>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,19840,19832,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,19888,19832,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Bs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17664>>3];m=+h[j+17672>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,20192,20184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=20232;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,20256,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+2472>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17656>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,20392,20184,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}function Cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3]*1256637061435917.0e-21;k=+h[g+1720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,20488,20480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}function Ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1728>>3];k=j*j;j=+h[g+2272>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,20560,20552,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-(+h[b+2632>>3]*+h[b+1736>>3])- +h[b+2080>>3]*+h[b+2264>>3];i=i;return}



function Bh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17408>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1888>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1888>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1888>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1888>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1888>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17408>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1888>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,4024,4016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17424>>3];r=+h[j+17408>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1888>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,4024,4016,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1888>>3];x=E;y=D;z=+h[C+17408>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,4024,4016,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1888>>3];G=+h[u+17408>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17432>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17416>>3];r=+h[H+2208>>3];H=G!=0.0;B=+h[J+17424>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,4024,4016,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1888>>3];O=A;P=+h[y+17408>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,4024,4016,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1888>>3];T=A;V=+h[y+17408>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17432>>3]))+1.0==0.0;q=+h[X+17424>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,4024,4016,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1888>>3];_=x;$=+h[y+17408>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,4024,4016,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17432>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,4024,4016,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1888>>3];fa=x;ga=+h[y+17408>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,4024,4016,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17408>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17432>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,4024,4016,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17400>>3];ma=+h[L+17416>>3];ga=+h[L+17408>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1888>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,4024,4016,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17408>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17424>>3];ma=+h[na+2208>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,4024,4016,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17408>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1888>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,4024,4016,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17408>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17432>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2208>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,4024,4016,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,4024,4016,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1888>>3];Qa=xa;Ra=+h[ya+17408>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,4024,4016,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1888>>3];Va=xa;Wa=+h[ya+17408>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17432>>3]))+1.0==0.0;t=+h[Xa+17424>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,4024,4016,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1888>>3];_a=Aa;$a=+h[ya+17408>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,4024,4016,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17432>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,4024,4016,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1888>>3];fb=Aa;gb=+h[ya+17408>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,4024,4016,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17408>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17432>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,4024,4016,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17400>>3];r=+h[Na+17416>>3];w=+h[Na+17408>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1888>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,4024,4016,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17408>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17424>>3];r=+h[nb+2208>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,4024,4016,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17408>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1888>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,4024,4016,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17408>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17432>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2208>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,4024,4016,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17408>>3];Db=+h[sb+2208>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17416>>3];yb=Cb!=0.0;ub=+h[Gb+17424>>3];rb=+h[Eb+1888>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17432>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,4024,4016,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1888>>3];Lb=Ab;Mb=+h[Eb+17408>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,4024,4016,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1888>>3];Qb=Ab;Rb=+h[Eb+17408>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17432>>3]))+1.0==0.0;Ca=+h[Sb+17424>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,4024,4016,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1888>>3];Vb=xb;Wb=+h[Eb+17408>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,4024,4016,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17432>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,4024,4016,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1888>>3];ac=xb;bc=+h[Eb+17408>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,4024,4016,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17408>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17432>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,4024,4016,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17400>>3];hc=+h[Ib+17416>>3];bc=+h[Ib+17408>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1888>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,4024,4016,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17408>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17424>>3];hc=+h[ic+2208>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,4024,4016,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17408>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1888>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,4024,4016,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17408>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17432>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2208>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,4024,4016,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17432>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,4024,4016,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1888>>3];Bc=sc;Cc=+h[tc+17408>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,4024,4016,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1888>>3];Gc=sc;Hc=+h[tc+17408>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17432>>3]))+1.0==0.0;Hb=+h[Ic+17424>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,4024,4016,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1888>>3];Lc=vc;Mc=+h[tc+17408>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,4024,4016,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17432>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,4024,4016,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1888>>3];Sc=vc;Tc=+h[tc+17408>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,4024,4016,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17408>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17432>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,4024,4016,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17400>>3];Db=+h[yc+17416>>3];m=+h[yc+17408>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1888>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,4024,4016,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17408>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17424>>3];Db=+h[_c+2208>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,4024,4016,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17408>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1888>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,4024,4016,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17408>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17432>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2208>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,4024,4016,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,4080,4016,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2424|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2424>>3];k=+h[(c[b+416>>2]|0)+17440>>3];l=+h[g+2760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,4400,4392,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2200>>3]=j*n*1256637061435917.0e-21;i=d;return}function Dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];k=j*j;j=+h[g+2200>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,4448,4440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2192|0;q=p;h[q>>3]=n;i=d;return}function Eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=-(+h[b+2632>>3]*+h[b+1904>>3])- +h[b+2080>>3]*+h[b+2192>>3];i=i;return}function Fh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,4504,4496,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}function Gh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17624>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1720>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1720>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1720>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1720>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1720>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17624>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1720>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,4544,4536,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17640>>3];r=+h[j+17624>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1720>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,4544,4536,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1720>>3];x=E;y=D;z=+h[C+17624>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,4544,4536,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1720>>3];G=+h[u+17624>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17648>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17632>>3];r=+h[H+2280>>3];H=G!=0.0;B=+h[J+17640>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,4544,4536,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1720>>3];O=A;P=+h[y+17624>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,4544,4536,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1720>>3];T=A;V=+h[y+17624>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17648>>3]))+1.0==0.0;q=+h[X+17640>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,4544,4536,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1720>>3];_=x;$=+h[y+17624>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,4544,4536,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17648>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,4544,4536,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1720>>3];fa=x;ga=+h[y+17624>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,4544,4536,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17624>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17648>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,4544,4536,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17616>>3];ma=+h[L+17632>>3];ga=+h[L+17624>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1720>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,4544,4536,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17624>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17640>>3];ma=+h[na+2280>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,4544,4536,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17624>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1720>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,4544,4536,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17624>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17648>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2280>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,4544,4536,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,4544,4536,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1720>>3];Qa=xa;Ra=+h[ya+17624>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,4544,4536,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1720>>3];Va=xa;Wa=+h[ya+17624>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17648>>3]))+1.0==0.0;t=+h[Xa+17640>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,4544,4536,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1720>>3];_a=Aa;$a=+h[ya+17624>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,4544,4536,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17648>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,4544,4536,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1720>>3];fb=Aa;gb=+h[ya+17624>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,4544,4536,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17624>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17648>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,4544,4536,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17616>>3];r=+h[Na+17632>>3];w=+h[Na+17624>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1720>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,4544,4536,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17624>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17640>>3];r=+h[nb+2280>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,4544,4536,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17624>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1720>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,4544,4536,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17624>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17648>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2280>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,4544,4536,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17624>>3];Db=+h[sb+2280>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17632>>3];yb=Cb!=0.0;ub=+h[Gb+17640>>3];rb=+h[Eb+1720>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17648>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,4544,4536,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1720>>3];Lb=Ab;Mb=+h[Eb+17624>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,4544,4536,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1720>>3];Qb=Ab;Rb=+h[Eb+17624>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17648>>3]))+1.0==0.0;Ca=+h[Sb+17640>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,4544,4536,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1720>>3];Vb=xb;Wb=+h[Eb+17624>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,4544,4536,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17648>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,4544,4536,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1720>>3];ac=xb;bc=+h[Eb+17624>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,4544,4536,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17624>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17648>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,4544,4536,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17616>>3];hc=+h[Ib+17632>>3];bc=+h[Ib+17624>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1720>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,4544,4536,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17624>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17640>>3];hc=+h[ic+2280>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,4544,4536,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17624>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1720>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,4544,4536,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17624>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17648>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2280>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,4544,4536,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17648>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,4544,4536,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1720>>3];Bc=sc;Cc=+h[tc+17624>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,4544,4536,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1720>>3];Gc=sc;Hc=+h[tc+17624>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17648>>3]))+1.0==0.0;Hb=+h[Ic+17640>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,4544,4536,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1720>>3];Lc=vc;Mc=+h[tc+17624>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,4544,4536,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17648>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,4544,4536,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1720>>3];Sc=vc;Tc=+h[tc+17624>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,4544,4536,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17624>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17648>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,4544,4536,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17616>>3];Db=+h[yc+17632>>3];m=+h[yc+17624>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1720>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,4544,4536,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17624>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17640>>3];Db=+h[_c+2280>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,4544,4536,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17624>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1720>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,4544,4536,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17624>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17648>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2280>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,4544,4536,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,4592,4536,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2472|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Hh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17664>>3];m=+h[j+17672>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,4896,4888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=4936;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,4960,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+2472>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17656>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,5096,4888,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+2272|0;x=w;h[x>>3]=u;i=d;return}function Ih(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1728>>3];k=j*j;j=+h[g+2272>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,5192,5184,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2264|0;q=p;h[q>>3]=n;i=d;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-(+h[b+2632>>3]*+h[b+1736>>3])- +h[b+2080>>3]*+h[b+2264>>3];i=i;return}function Kh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2792>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,5240,5232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}function Lh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17696>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1664>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1664>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1664>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1664>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1664>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17696>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1664>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,5280,5272,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17712>>3];r=+h[j+17696>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1664>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,5280,5272,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1664>>3];x=E;y=D;z=+h[C+17696>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,5280,5272,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1664>>3];G=+h[u+17696>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17720>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17704>>3];r=+h[H+2304>>3];H=G!=0.0;B=+h[J+17712>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,5280,5272,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1664>>3];O=A;P=+h[y+17696>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,5280,5272,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1664>>3];T=A;V=+h[y+17696>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17720>>3]))+1.0==0.0;q=+h[X+17712>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,5280,5272,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1664>>3];_=x;$=+h[y+17696>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,5280,5272,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17720>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,5280,5272,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1664>>3];fa=x;ga=+h[y+17696>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,5280,5272,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17696>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17720>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,5280,5272,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17688>>3];ma=+h[L+17704>>3];ga=+h[L+17696>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1664>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,5280,5272,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17696>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17712>>3];ma=+h[na+2304>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,5280,5272,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17696>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1664>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,5280,5272,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17696>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17720>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2304>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,5280,5272,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,5280,5272,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1664>>3];Qa=xa;Ra=+h[ya+17696>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,5280,5272,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1664>>3];Va=xa;Wa=+h[ya+17696>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17720>>3]))+1.0==0.0;t=+h[Xa+17712>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,5280,5272,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1664>>3];_a=Aa;$a=+h[ya+17696>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,5280,5272,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17720>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,5280,5272,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1664>>3];fb=Aa;gb=+h[ya+17696>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,5280,5272,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17696>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17720>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,5280,5272,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17688>>3];r=+h[Na+17704>>3];w=+h[Na+17696>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1664>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,5280,5272,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17696>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17712>>3];r=+h[nb+2304>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,5280,5272,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17696>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1664>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,5280,5272,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17696>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17720>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2304>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,5280,5272,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17696>>3];Db=+h[sb+2304>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17704>>3];yb=Cb!=0.0;ub=+h[Gb+17712>>3];rb=+h[Eb+1664>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17720>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,5280,5272,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1664>>3];Lb=Ab;Mb=+h[Eb+17696>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,5280,5272,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1664>>3];Qb=Ab;Rb=+h[Eb+17696>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17720>>3]))+1.0==0.0;Ca=+h[Sb+17712>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,5280,5272,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1664>>3];Vb=xb;Wb=+h[Eb+17696>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,5280,5272,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17720>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,5280,5272,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1664>>3];ac=xb;bc=+h[Eb+17696>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,5280,5272,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17696>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17720>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,5280,5272,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17688>>3];hc=+h[Ib+17704>>3];bc=+h[Ib+17696>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1664>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,5280,5272,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17696>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17712>>3];hc=+h[ic+2304>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,5280,5272,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17696>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1664>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,5280,5272,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17696>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17720>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2304>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,5280,5272,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17720>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,5280,5272,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1664>>3];Bc=sc;Cc=+h[tc+17696>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,5280,5272,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1664>>3];Gc=sc;Hc=+h[tc+17696>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17720>>3]))+1.0==0.0;Hb=+h[Ic+17712>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,5280,5272,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1664>>3];Lc=vc;Mc=+h[tc+17696>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,5280,5272,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17720>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,5280,5272,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1664>>3];Sc=vc;Tc=+h[tc+17696>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,5280,5272,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17696>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17720>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,5280,5272,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17688>>3];Db=+h[yc+17704>>3];m=+h[yc+17696>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1664>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,5280,5272,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17696>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17712>>3];Db=+h[_c+2304>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,5280,5272,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17696>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1664>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,5280,5272,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17696>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17720>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2304>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,5280,5272,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,5328,5272,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2488|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2488>>3];k=+h[(c[b+416>>2]|0)+17728>>3];l=+h[g+2792>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,5616,5608,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2296>>3]=j*n*1256637061435917.0e-21;i=d;return}function Nh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];k=j*j;j=+h[g+2296>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,5656,5648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2288|0;q=p;h[q>>3]=n;i=d;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2480>>3]=-(+h[b+2632>>3]*+h[b+1680>>3])- +h[b+2080>>3]*+h[b+2288>>3];i=i;return}function Ph(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17384>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,5704,5696,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}function Qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+1952>>3]*+h[b+1944>>3];i=i;return}function Rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+1944>>3]- +h[b+2048>>3];i=i;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+2168>>3]- +h[b+2136>>3];i=i;return}function Th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[b+2728>>3]*+h[b+2048>>3];i=i;return}function Uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+1920>>3]- +h[b+1992>>3];i=i;return}function Vh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+17240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2056>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,3856,5736,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}function Wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2552>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,3632,5744,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}function Xh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+17872>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+1536>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+1536>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+1536>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+1536>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+1536>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+17872>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+1536>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,5760,5752,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+17888>>3];r=+h[j+17872>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+1536>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,5760,5752,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+1536>>3];x=E;y=D;z=+h[C+17872>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,5760,5752,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+1536>>3];G=+h[u+17872>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+17896>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+17880>>3];r=+h[H+2328>>3];H=G!=0.0;B=+h[J+17888>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,5760,5752,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+1536>>3];O=A;P=+h[y+17872>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,5760,5752,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+1536>>3];T=A;V=+h[y+17872>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+17896>>3]))+1.0==0.0;q=+h[X+17888>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,5760,5752,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+1536>>3];_=x;$=+h[y+17872>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,5760,5752,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+17896>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,5760,5752,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+1536>>3];fa=x;ga=+h[y+17872>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,5760,5752,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+17872>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+17896>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,5760,5752,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+17864>>3];ma=+h[L+17880>>3];ga=+h[L+17872>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+1536>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,5760,5752,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+17872>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+17888>>3];ma=+h[na+2328>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,5760,5752,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+17872>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+1536>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,5760,5752,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+17872>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+17896>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+2328>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,5760,5752,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,5760,5752,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+1536>>3];Qa=xa;Ra=+h[ya+17872>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,5760,5752,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+1536>>3];Va=xa;Wa=+h[ya+17872>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+17896>>3]))+1.0==0.0;t=+h[Xa+17888>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,5760,5752,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+1536>>3];_a=Aa;$a=+h[ya+17872>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,5760,5752,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+17896>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,5760,5752,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+1536>>3];fb=Aa;gb=+h[ya+17872>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,5760,5752,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+17872>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+17896>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,5760,5752,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+17864>>3];r=+h[Na+17880>>3];w=+h[Na+17872>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+1536>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,5760,5752,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+17872>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+17888>>3];r=+h[nb+2328>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,5760,5752,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+17872>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+1536>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,5760,5752,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+17872>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+17896>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+2328>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,5760,5752,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+17872>>3];Db=+h[sb+2328>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+17880>>3];yb=Cb!=0.0;ub=+h[Gb+17888>>3];rb=+h[Eb+1536>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+17896>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,5760,5752,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+1536>>3];Lb=Ab;Mb=+h[Eb+17872>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,5760,5752,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+1536>>3];Qb=Ab;Rb=+h[Eb+17872>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+17896>>3]))+1.0==0.0;Ca=+h[Sb+17888>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,5760,5752,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+1536>>3];Vb=xb;Wb=+h[Eb+17872>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,5760,5752,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+17896>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,5760,5752,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+1536>>3];ac=xb;bc=+h[Eb+17872>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,5760,5752,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+17872>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+17896>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,5760,5752,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+17864>>3];hc=+h[Ib+17880>>3];bc=+h[Ib+17872>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+1536>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,5760,5752,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+17872>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+17888>>3];hc=+h[ic+2328>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,5760,5752,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+17872>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+1536>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,5760,5752,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+17872>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+17896>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+2328>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,5760,5752,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+17896>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,5760,5752,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+1536>>3];Bc=sc;Cc=+h[tc+17872>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,5760,5752,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+1536>>3];Gc=sc;Hc=+h[tc+17872>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+17896>>3]))+1.0==0.0;Hb=+h[Ic+17888>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,5760,5752,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+1536>>3];Lc=vc;Mc=+h[tc+17872>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,5760,5752,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+17896>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,5760,5752,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+1536>>3];Sc=vc;Tc=+h[tc+17872>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,5760,5752,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+17872>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+17896>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,5760,5752,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+17864>>3];Db=+h[yc+17880>>3];m=+h[yc+17872>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+1536>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,5760,5752,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+17872>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+17888>>3];Db=+h[_c+2328>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,5760,5752,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+17872>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+1536>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,5760,5752,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+17872>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+17896>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+2328>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,5760,5752,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,5808,5752,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+2512|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Yh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2512>>3];k=+h[(c[b+416>>2]|0)+17904>>3];l=+h[g+2832>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,3672,6080,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+2320>>3]=j*n*1256637061435917.0e-21;i=d;return}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1544>>3];k=j*j;j=+h[g+2320>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,6096,6088,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2312|0;q=p;h[q>>3]=n;i=d;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2504>>3]=-(+h[b+2552>>3]*+h[b+1552>>3])- +h[b+2032>>3]*+h[b+2312>>3];i=i;return}



function cm(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,J=0.0,K=0,L=0.0,M=0.0,N=0,O=0.0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0.0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0,la=0.0,ma=0,na=0.0,oa=0.0,pa=0,qa=0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0.0,Ga=0,Ha=0.0,Ia=0.0,Ja=0,Ka=0.0,La=0.0,Ma=0,Na=0.0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0,eb=0.0,fb=0.0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0.0,mb=0,nb=0.0,ob=0.0,pb=0,qb=0.0,rb=0.0,sb=0,tb=0.0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0,Ib=0.0,Jb=0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0.0,Vb=0,Wb=0,Xb=0.0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0.0,ic=0.0,jc=0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0,qc=0.0,rc=0.0,sc=0.0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0,Bc=0.0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0.0,Jc=0.0,Kc=0,Lc=0.0,Mc=0,Nc=0.0,Oc=0,Pc=0.0,Qc=0,Rc=0.0,Sc=0.0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0.0,Xc=0,Yc=0.0,Zc=0,_c=0.0,$c=0,ad=0.0,bd=0.0,cd=0;e=i;i=i+14032|0;f=i;i=i+8|0;ze[c[(d+8|0)>>2]&3](0,24,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+240>>3],0,d);ze[c[(d+8|0)>>2]&3](0,33,1.0,1,d);ze[c[(d+8|0)>>2]&3](1,31,1.0,2,d);ze[c[(d+8|0)>>2]&3](1,32,-1.0,3,d);ze[c[(d+8|0)>>2]&3](1,33,1.0,4,d);ze[c[(d+8|0)>>2]&3](2,22,1.0,5,d);ze[c[(d+8|0)>>2]&3](2,31,1.0,6,d);ze[c[(d+8|0)>>2]&3](2,32,-1.0,7,d);ze[c[(d+8|0)>>2]&3](3,15,1.0,8,d);ze[c[(d+8|0)>>2]&3](3,30,1.0,9,d);ze[c[(d+8|0)>>2]&3](3,31,-1.0,10,d);ze[c[(d+8|0)>>2]&3](4,25,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+576>>3],11,d);ze[c[(d+8|0)>>2]&3](4,29,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],12,d);ze[c[(d+8|0)>>2]&3](4,30,1.0,13,d);j=c[c[(b+4|0)>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+568>>3];if(k!=0.0){l=k}else{l=+xH(c[b+536>>2]|0,k,9776,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}k=1.0/l;ze[c[(d+8|0)>>2]&3](5,28,k*k,14,d);ze[c[(d+8|0)>>2]&3](5,29,1.0,15,d);j=c[(d+8|0)>>2]|0;k=+h[(c[(b+416|0)>>2]|0)+18760>>3];m=c[c[(b+4|0)>>2]>>2]|0;l=+h[(c[m+8>>2]|0)+2968>>3];do{if(k!=0.0){n=l/k}else{if(l==0.0){n=l;break}n=l/+xH(c[b+536>>2]|0,k,9808,9768,+h[m>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[j&3](6,27,n*-1256637061435917.0e-21,16,d);ze[c[(d+8|0)>>2]&3](6,28,1.0,17,d);n=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+560>>3];do{if(n!=0.0){o=k/n}else{if(k==0.0){o=k;break}o=k/+xH(c[b+536>>2]|0,n,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+560>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+560>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+560>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}t=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;r=+h[(c[j+8>>2]|0)+560>>3];do{if(t!=0.0){u=r/t}else{if(r==0.0){u=r;break}u=r/+xH(c[b+536>>2]|0,t,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(u>0.0){v=1.0}else{u=+h[(c[(b+416|0)>>2]|0)+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[j+8>>2]|0)+560>>3];do{if(u!=0.0){w=t/u}else{if(t==0.0){w=t;break}w=t/+xH(c[b+536>>2]|0,u,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=+(w<0.0|0)}j=c[(b+416|0)>>2]|0;w=+h[j+18744>>3];u=+h[j+18728>>3];m=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[m+8>>2]|0)+560>>3];do{if(u!=0.0){x=t;y=m;z=u;B=j;C=t/u}else{if(t==0.0){x=t;y=m;z=u;B=j;C=t;break}r=t/+xH(c[b+536>>2]|0,u,9840,9768,+h[m>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;x=+h[(c[E+8>>2]|0)+560>>3];y=E;z=+h[D+18728>>3];B=D;C=r}}while(0);u=w*+U(+C);do{if(z!=0.0){F=x;G=y;J=z;K=B;L=x/z}else{if(x==0.0){F=x;G=y;J=z;K=B;L=x;break}C=x/+xH(c[b+536>>2]|0,z,9840,9768,+h[y>>3],(a[b+319|0]|0)!=0|0);m=c[(b+416|0)>>2]|0;j=c[c[(b+4|0)>>2]>>2]|0;F=+h[(c[j+8>>2]|0)+560>>3];G=j;J=+h[m+18728>>3];K=m;L=C}}while(0);z=+U(+L);L=u+ +W(+z,+(+h[K+18752>>3]))+1.0;y=c[(d+8|0)>>2]|0;z=+h[K+18720>>3];u=+h[K+18736>>3];B=J!=0.0;do{m=1;if(m){m=0;if(L*L!=0.0){do{if(B){M=J;N=K;O=F/J}else{if(F==0.0){M=J;N=K;O=F;break}x=F/+xH(c[b+536>>2]|0,J,9840,9768,+h[G>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;M=+h[j+18728>>3];N=j;O=x}}while(0);x=z+u*+U(+O)+-1.0;C=+h[N+18744>>3];do{if(M!=0.0){P=M;Q=N;R=p/M}else{if(p==0.0){P=M;Q=N;R=p;break}w=p/+xH(c[b+536>>2]|0,M,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;P=+h[j+18728>>3];Q=j;R=w}}while(0);w=C*R;j=c[c[(b+4|0)>>2]>>2]|0;t=+h[(c[j+8>>2]|0)+560>>3];do{if(P!=0.0){S=P;T=Q;V=t/P}else{if(t==0.0){S=P;T=Q;V=t;break}r=t/+xH(c[b+536>>2]|0,P,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;S=+h[D+18728>>3];T=D;V=r}}while(0);t=+U(+V);C=+h[T+18752>>3];r=+W(+t,+(C+-1.0));do{if(S!=0.0){X=S;Y=T;Z=s/S}else{if(s==0.0){X=S;Y=T;Z=s;break}t=s/+xH(c[b+536>>2]|0,S,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;X=+h[j+18728>>3];Y=j;Z=t}}while(0);t=x*(w+r*C*Z);q=+h[Y+18736>>3];o=+h[Y+18744>>3];j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+560>>3];do{if(X!=0.0){k=+U(+(n/X));_=(o*k+ +W(+k,+(+h[Y+18752>>3]))+1.0)/X}else{if(n==0.0){$=n;aa=j;ba=X;ca=Y;da=n}else{k=n/+xH(c[b+536>>2]|0,X,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;$=+h[(c[E+8>>2]|0)+560>>3];aa=E;ba=+h[D+18728>>3];ca=D;da=k}k=o*+U(+da);do{if(ba!=0.0){ea=$;fa=aa;ga=ba;ha=ca;ia=$/ba}else{if($==0.0){ea=$;fa=aa;ga=ba;ha=ca;ia=$;break}l=$/+xH(c[b+536>>2]|0,ba,9840,9768,+h[aa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;ea=+h[(c[E+8>>2]|0)+560>>3];fa=E;ga=+h[D+18728>>3];ha=D;ia=l}}while(0);l=+U(+ia);D=k+ +W(+l,+(+h[ha+18752>>3]))+1.0==0.0;l=+h[ha+18744>>3];E=ga!=0.0;if(D){do{if(E){ja=ea;ka=fa;la=ga;ma=ha;na=ea/ga}else{if(ea==0.0){ja=ea;ka=fa;la=ga;ma=ha;na=ea;break}oa=ea/+xH(c[b+536>>2]|0,ga,9840,9768,+h[fa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;ja=+h[(c[pa+8>>2]|0)+560>>3];ka=pa;la=+h[D+18728>>3];ma=D;na=oa}}while(0);k=l*+U(+na);do{if(la!=0.0){qa=ma;ra=ja/la}else{if(ja==0.0){qa=ma;ra=ja;break}oa=ja/+xH(c[b+536>>2]|0,la,9840,9768,+h[ka>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;ra=oa}}while(0);oa=+U(+ra);_=k+ +W(+oa,+(+h[qa+18752>>3]))+1.0;break}else{do{if(E){sa=ea;ta=fa;ua=ga;va=ha;wa=ea/ga}else{if(ea==0.0){sa=ea;ta=fa;ua=ga;va=ha;wa=ea;break}oa=ea/+xH(c[b+536>>2]|0,ga,9840,9768,+h[fa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;sa=+h[(c[pa+8>>2]|0)+560>>3];ta=pa;ua=+h[D+18728>>3];va=D;wa=oa}}while(0);k=l*+U(+wa);do{if(ua!=0.0){xa=ta;ya=ua;za=va;Aa=sa/ua}else{if(sa==0.0){xa=ta;ya=ua;za=va;Aa=sa;break}oa=sa/+xH(c[b+536>>2]|0,ua,9840,9768,+h[ta>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;xa=c[c[(b+4|0)>>2]>>2]|0;ya=+h[E+18728>>3];za=E;Aa=oa}}while(0);l=+U(+Aa);oa=k+ +W(+l,+(+h[za+18752>>3]))+1.0;_=oa/+xH(c[b+536>>2]|0,ya,9840,9768,+h[xa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=(t-q*v*_)/(L*L)}else{m=1}}if(m){m=0;if(1){do{if(B){Ca=J;Da=K;Ea=F/J}else{if(F==0.0){Ca=J;Da=K;Ea=F;break}o=F/+xH(c[b+536>>2]|0,J,9840,9768,+h[G>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;Ca=+h[j+18728>>3];Da=j;Ea=o}}while(0);q=z+u*+U(+Ea)+-1.0;t=+h[Da+18744>>3];do{if(Ca!=0.0){Fa=Ca;Ga=Da;Ha=p/Ca}else{if(p==0.0){Fa=Ca;Ga=Da;Ha=p;break}o=p/+xH(c[b+536>>2]|0,Ca,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;Fa=+h[j+18728>>3];Ga=j;Ha=o}}while(0);o=t*Ha;j=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+560>>3];do{if(Fa!=0.0){Ia=Fa;Ja=Ga;Ka=n/Fa}else{if(n==0.0){Ia=Fa;Ja=Ga;Ka=n;break}C=n/+xH(c[b+536>>2]|0,Fa,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Ia=+h[E+18728>>3];Ja=E;Ka=C}}while(0);n=+U(+Ka);t=+h[Ja+18752>>3];C=+W(+n,+(t+-1.0));do{if(Ia!=0.0){La=Ia;Ma=Ja;Na=s/Ia}else{if(s==0.0){La=Ia;Ma=Ja;Na=s;break}n=s/+xH(c[b+536>>2]|0,Ia,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;La=+h[j+18728>>3];Ma=j;Na=n}}while(0);n=q*(o+C*t*Na);r=+h[Ma+18736>>3];w=+h[Ma+18744>>3];j=c[c[(b+4|0)>>2]>>2]|0;x=+h[(c[j+8>>2]|0)+560>>3];do{if(La!=0.0){oa=+U(+(x/La));Oa=Ma;Pa=(w*oa+ +W(+oa,+(+h[Ma+18752>>3]))+1.0)/La}else{if(x==0.0){Qa=x;Ra=j;Sa=La;Ta=Ma;Ua=x}else{oa=x/+xH(c[b+536>>2]|0,La,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;Qa=+h[(c[D+8>>2]|0)+560>>3];Ra=D;Sa=+h[E+18728>>3];Ta=E;Ua=oa}oa=w*+U(+Ua);do{if(Sa!=0.0){Va=Qa;Wa=Ra;Xa=Sa;Ya=Ta;Za=Qa/Sa}else{if(Qa==0.0){Va=Qa;Wa=Ra;Xa=Sa;Ya=Ta;Za=Qa;break}l=Qa/+xH(c[b+536>>2]|0,Sa,9840,9768,+h[Ra>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;Va=+h[(c[D+8>>2]|0)+560>>3];Wa=D;Xa=+h[E+18728>>3];Ya=E;Za=l}}while(0);k=+U(+Za);E=oa+ +W(+k,+(+h[Ya+18752>>3]))+1.0==0.0;k=+h[Ya+18744>>3];D=Xa!=0.0;if(E){do{if(D){_a=Va;$a=Wa;ab=Xa;bb=Ya;cb=Va/Xa}else{if(Va==0.0){_a=Va;$a=Wa;ab=Xa;bb=Ya;cb=Va;break}l=Va/+xH(c[b+536>>2]|0,Xa,9840,9768,+h[Wa>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;_a=+h[(c[pa+8>>2]|0)+560>>3];$a=pa;ab=+h[E+18728>>3];bb=E;cb=l}}while(0);oa=k*+U(+cb);do{if(ab!=0.0){db=bb;eb=_a/ab}else{if(_a==0.0){db=bb;eb=_a;break}l=_a/+xH(c[b+536>>2]|0,ab,9840,9768,+h[$a>>3],(a[b+319|0]|0)!=0|0);db=c[(b+416|0)>>2]|0;eb=l}}while(0);l=+U(+eb);Oa=db;Pa=oa+ +W(+l,+(+h[db+18752>>3]))+1.0;break}else{do{if(D){fb=Va;gb=Wa;hb=Xa;ib=Ya;jb=Va/Xa}else{if(Va==0.0){fb=Va;gb=Wa;hb=Xa;ib=Ya;jb=Va;break}l=Va/+xH(c[b+536>>2]|0,Xa,9840,9768,+h[Wa>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;fb=+h[(c[pa+8>>2]|0)+560>>3];gb=pa;hb=+h[E+18728>>3];ib=E;jb=l}}while(0);oa=k*+U(+jb);do{if(hb!=0.0){kb=gb;lb=hb;mb=ib;nb=fb/hb}else{if(fb==0.0){kb=gb;lb=hb;mb=ib;nb=fb;break}l=fb/+xH(c[b+536>>2]|0,hb,9840,9768,+h[gb>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;kb=c[c[(b+4|0)>>2]>>2]|0;lb=+h[D+18728>>3];mb=D;nb=l}}while(0);k=+U(+nb);l=oa+ +W(+k,+(+h[mb+18752>>3]))+1.0;k=l/+xH(c[b+536>>2]|0,lb,9840,9768,+h[kb>>3],(a[b+319|0]|0)!=0|0);Oa=c[(b+416|0)>>2]|0;Pa=k;break}}}while(0);w=+h[Oa+18720>>3];x=+h[Oa+18736>>3];t=+h[Oa+18728>>3];j=c[c[(b+4|0)>>2]>>2]|0;C=+h[(c[j+8>>2]|0)+560>>3];D=1;if(D){D=0;if(n-r*v*Pa==0.0){do{if(t!=0.0){ob=t;pb=Oa;qb=C/t}else{if(C==0.0){ob=t;pb=Oa;qb=C;break}o=C/+xH(c[b+536>>2]|0,t,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;ob=+h[E+18728>>3];pb=E;qb=o}}while(0);r=w+x*+U(+qb)+-1.0;n=+h[pb+18744>>3];do{if(ob!=0.0){rb=ob;sb=pb;tb=p/ob}else{if(p==0.0){rb=ob;sb=pb;tb=p;break}o=p/+xH(c[b+536>>2]|0,ob,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;rb=+h[E+18728>>3];sb=E;tb=o}}while(0);o=n*tb;E=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[E+8>>2]|0)+560>>3];do{if(rb!=0.0){ub=rb;vb=sb;wb=q/rb}else{if(q==0.0){ub=rb;vb=sb;wb=q;break}k=q/+xH(c[b+536>>2]|0,rb,9840,9768,+h[E>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;ub=+h[pa+18728>>3];vb=pa;wb=k}}while(0);q=+U(+wb);n=+h[vb+18752>>3];k=+W(+q,+(n+-1.0));do{if(ub!=0.0){xb=ub;yb=vb;zb=s/ub}else{if(s==0.0){xb=ub;yb=vb;zb=s;break}q=s/+xH(c[b+536>>2]|0,ub,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;xb=+h[E+18728>>3];yb=E;zb=q}}while(0);q=r*(o+k*n*zb);l=+h[yb+18736>>3];Ab=+h[yb+18744>>3];E=c[c[(b+4|0)>>2]>>2]|0;Bb=+h[(c[E+8>>2]|0)+560>>3];do{if(xb!=0.0){Cb=+U(+(Bb/xb));Db=(Ab*Cb+ +W(+Cb,+(+h[yb+18752>>3]))+1.0)/xb}else{if(Bb==0.0){Eb=Bb;Fb=E;Gb=xb;Hb=yb;Ib=Bb}else{Cb=Bb/+xH(c[b+536>>2]|0,xb,9840,9768,+h[E>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Eb=+h[(c[Jb+8>>2]|0)+560>>3];Fb=Jb;Gb=+h[pa+18728>>3];Hb=pa;Ib=Cb}Cb=Ab*+U(+Ib);do{if(Gb!=0.0){Kb=Eb;Lb=Fb;Mb=Gb;Nb=Hb;Ob=Eb/Gb}else{if(Eb==0.0){Kb=Eb;Lb=Fb;Mb=Gb;Nb=Hb;Ob=Eb;break}Pb=Eb/+xH(c[b+536>>2]|0,Gb,9840,9768,+h[Fb>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;Kb=+h[(c[Jb+8>>2]|0)+560>>3];Lb=Jb;Mb=+h[pa+18728>>3];Nb=pa;Ob=Pb}}while(0);oa=+U(+Ob);pa=Cb+ +W(+oa,+(+h[Nb+18752>>3]))+1.0==0.0;oa=+h[Nb+18744>>3];Jb=Mb!=0.0;if(pa){do{if(Jb){Qb=Kb;Rb=Lb;Sb=Mb;Tb=Nb;Ub=Kb/Mb}else{if(Kb==0.0){Qb=Kb;Rb=Lb;Sb=Mb;Tb=Nb;Ub=Kb;break}Pb=Kb/+xH(c[b+536>>2]|0,Mb,9840,9768,+h[Lb>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Vb=c[c[(b+4|0)>>2]>>2]|0;Qb=+h[(c[Vb+8>>2]|0)+560>>3];Rb=Vb;Sb=+h[pa+18728>>3];Tb=pa;Ub=Pb}}while(0);Cb=oa*+U(+Ub);do{if(Sb!=0.0){Wb=Tb;Xb=Qb/Sb}else{if(Qb==0.0){Wb=Tb;Xb=Qb;break}Pb=Qb/+xH(c[b+536>>2]|0,Sb,9840,9768,+h[Rb>>3],(a[b+319|0]|0)!=0|0);Wb=c[(b+416|0)>>2]|0;Xb=Pb}}while(0);Pb=+U(+Xb);Db=Cb+ +W(+Pb,+(+h[Wb+18752>>3]))+1.0;break}else{do{if(Jb){Yb=Kb;Zb=Lb;_b=Mb;$b=Nb;ac=Kb/Mb}else{if(Kb==0.0){Yb=Kb;Zb=Lb;_b=Mb;$b=Nb;ac=Kb;break}Pb=Kb/+xH(c[b+536>>2]|0,Mb,9840,9768,+h[Lb>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;Vb=c[c[(b+4|0)>>2]>>2]|0;Yb=+h[(c[Vb+8>>2]|0)+560>>3];Zb=Vb;_b=+h[pa+18728>>3];$b=pa;ac=Pb}}while(0);Cb=oa*+U(+ac);do{if(_b!=0.0){bc=Zb;cc=_b;dc=$b;ec=Yb/_b}else{if(Yb==0.0){bc=Zb;cc=_b;dc=$b;ec=Yb;break}Pb=Yb/+xH(c[b+536>>2]|0,_b,9840,9768,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Jb=c[(b+416|0)>>2]|0;bc=c[c[(b+4|0)>>2]>>2]|0;cc=+h[Jb+18728>>3];dc=Jb;ec=Pb}}while(0);oa=+U(+ec);Pb=Cb+ +W(+oa,+(+h[dc+18752>>3]))+1.0;Db=Pb/+xH(c[b+536>>2]|0,cc,9840,9768,+h[bc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=q-l*v*Db;break}else{D=1}}if(D){D=0;if(1){do{if(t!=0.0){fc=t;gc=Oa;hc=C/t}else{if(C==0.0){fc=t;gc=Oa;hc=C;break}Ab=C/+xH(c[b+536>>2]|0,t,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;fc=+h[E+18728>>3];gc=E;hc=Ab}}while(0);t=w+x*+U(+hc)+-1.0;C=+h[gc+18744>>3];do{if(fc!=0.0){ic=fc;jc=gc;kc=p/fc}else{if(p==0.0){ic=fc;jc=gc;kc=p;break}l=p/+xH(c[b+536>>2]|0,fc,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;ic=+h[j+18728>>3];jc=j;kc=l}}while(0);x=C*kc;j=c[c[(b+4|0)>>2]>>2]|0;w=+h[(c[j+8>>2]|0)+560>>3];do{if(ic!=0.0){lc=ic;mc=jc;nc=w/ic}else{if(w==0.0){lc=ic;mc=jc;nc=w;break}l=w/+xH(c[b+536>>2]|0,ic,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;lc=+h[E+18728>>3];mc=E;nc=l}}while(0);w=+U(+nc);C=+h[mc+18752>>3];l=+W(+w,+(C+-1.0));do{if(lc!=0.0){oc=lc;pc=mc;qc=s/lc}else{if(s==0.0){oc=lc;pc=mc;qc=s;break}w=s/+xH(c[b+536>>2]|0,lc,9840,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=c[(b+416|0)>>2]|0;oc=+h[j+18728>>3];pc=j;qc=w}}while(0);w=t*(x+l*C*qc);q=+h[pc+18736>>3];Ab=+h[pc+18744>>3];j=c[c[(b+4|0)>>2]>>2]|0;Bb=+h[(c[j+8>>2]|0)+560>>3];do{if(oc!=0.0){n=+U(+(Bb/oc));rc=(Ab*n+ +W(+n,+(+h[pc+18752>>3]))+1.0)/oc}else{if(Bb==0.0){sc=Bb;tc=j;uc=oc;vc=pc;wc=Bb}else{n=Bb/+xH(c[b+536>>2]|0,oc,9840,9768,+h[j>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;sc=+h[(c[Jb+8>>2]|0)+560>>3];tc=Jb;uc=+h[E+18728>>3];vc=E;wc=n}n=Ab*+U(+wc);do{if(uc!=0.0){xc=sc;yc=tc;zc=uc;Ac=vc;Bc=sc/uc}else{if(sc==0.0){xc=sc;yc=tc;zc=uc;Ac=vc;Bc=sc;break}k=sc/+xH(c[b+536>>2]|0,uc,9840,9768,+h[tc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;Jb=c[c[(b+4|0)>>2]>>2]|0;xc=+h[(c[Jb+8>>2]|0)+560>>3];yc=Jb;zc=+h[E+18728>>3];Ac=E;Bc=k}}while(0);Cb=+U(+Bc);E=n+ +W(+Cb,+(+h[Ac+18752>>3]))+1.0==0.0;Cb=+h[Ac+18744>>3];Jb=zc!=0.0;if(E){do{if(Jb){Cc=xc;Dc=yc;Ec=zc;Fc=Ac;Gc=xc/zc}else{if(xc==0.0){Cc=xc;Dc=yc;Ec=zc;Fc=Ac;Gc=xc;break}k=xc/+xH(c[b+536>>2]|0,zc,9840,9768,+h[yc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;Cc=+h[(c[pa+8>>2]|0)+560>>3];Dc=pa;Ec=+h[E+18728>>3];Fc=E;Gc=k}}while(0);n=Cb*+U(+Gc);do{if(Ec!=0.0){Hc=Fc;Ic=Cc/Ec}else{if(Cc==0.0){Hc=Fc;Ic=Cc;break}k=Cc/+xH(c[b+536>>2]|0,Ec,9840,9768,+h[Dc>>3],(a[b+319|0]|0)!=0|0);Hc=c[(b+416|0)>>2]|0;Ic=k}}while(0);k=+U(+Ic);rc=n+ +W(+k,+(+h[Hc+18752>>3]))+1.0;break}else{do{if(Jb){Jc=xc;Kc=yc;Lc=zc;Mc=Ac;Nc=xc/zc}else{if(xc==0.0){Jc=xc;Kc=yc;Lc=zc;Mc=Ac;Nc=xc;break}k=xc/+xH(c[b+536>>2]|0,zc,9840,9768,+h[yc>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;pa=c[c[(b+4|0)>>2]>>2]|0;Jc=+h[(c[pa+8>>2]|0)+560>>3];Kc=pa;Lc=+h[E+18728>>3];Mc=E;Nc=k}}while(0);n=Cb*+U(+Nc);do{if(Lc!=0.0){Oc=Kc;Pc=Lc;Qc=Mc;Rc=Jc/Lc}else{if(Jc==0.0){Oc=Kc;Pc=Lc;Qc=Mc;Rc=Jc;break}k=Jc/+xH(c[b+536>>2]|0,Lc,9840,9768,+h[Kc>>3],(a[b+319|0]|0)!=0|0);Jb=c[(b+416|0)>>2]|0;Oc=c[c[(b+4|0)>>2]>>2]|0;Pc=+h[Jb+18728>>3];Qc=Jb;Rc=k}}while(0);Cb=+U(+Rc);k=n+ +W(+Cb,+(+h[Qc+18752>>3]))+1.0;rc=k/+xH(c[b+536>>2]|0,Pc,9840,9768,+h[Oc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ba=(w-q*v*rc)/+xH(c[b+536>>2]|0,L*L,9888,9768,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);break}else{D=1}}}else{m=1}}}while(0);ze[y&3](7,26,Ba,18,d);ze[c[(d+8|0)>>2]&3](7,27,1.0,19,d);y=c[(d+8|0)>>2]|0;Oc=c[c[(b+4|0)>>2]>>2]|0;Ba=+h[(c[Oc+8>>2]|0)+2968>>3];if(Ba!=0.0){Sc=Ba}else{Sc=+xH(c[b+536>>2]|0,Ba,10152,9768,+h[Oc>>3],(a[b+319|0]|0)!=0|0)}ze[y&3](8,25,1.0/Sc,20,d);ze[c[(d+8|0)>>2]&3](8,26,1.0,21,d);ze[c[(d+8|0)>>2]&3](9,23,-1.0,22,d);ze[c[(d+8|0)>>2]&3](9,24,-1.0,23,d);ze[c[(d+8|0)>>2]&3](9,25,-1.0,24,d);ze[c[(d+8|0)>>2]&3](10,23,1.0,25,d);ze[c[(d+8|0)>>2]&3](10,24,1.0,26,d);ze[c[(d+8|0)>>2]&3](11,22,1.0,27,d);ze[c[(d+8|0)>>2]&3](11,23,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+296>>3],28,d);ze[c[(d+8|0)>>2]&3](12,18,-1.0,29,d);ze[c[(d+8|0)>>2]&3](12,19,-1.0,30,d);ze[c[(d+8|0)>>2]&3](12,21,-1.0,31,d);ze[c[(d+8|0)>>2]&3](12,25,1.0,32,d);ze[c[(d+8|0)>>2]&3](13,20,1.0,33,d);ze[c[(d+8|0)>>2]&3](13,21,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2888>>3],34,d);ze[c[(d+8|0)>>2]&3](14,19,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2920>>3],35,d);ze[c[(d+8|0)>>2]&3](14,20,1.0,36,d);c[e+64>>2]=b;c[e+72>>2]=d;g[e+6160>>2]=Tc;g[e+6248>>2]=Uc;g[e+6336>>2]=Vc;g[e+6456>>2]=Wc;c[e+6464>>2]=Xc;g[e+6472>>2]=Yc;c[e+6480>>2]=Zc;g[e+6504>>2]=_c;c[e+6512>>2]=$c;g[e+6520>>2]=ad;g[e+6528>>2]=bd;c[e+6536>>2]=cd;c[e+13808>>2]=f;c[e+13896>>2]=0;c[e+13900>>2]=0;_setLinearMatrixA175$1(e);Tc=+g[e+6160>>2];Uc=+g[e+6248>>2];Vc=+g[e+6336>>2];Wc=+g[e+6456>>2];Xc=c[e+6464>>2]|0;Yc=+g[e+6472>>2];Zc=c[e+6480>>2]|0;_c=+g[e+6504>>2];$c=c[e+6512>>2]|0;ad=+g[e+6520>>2];bd=+g[e+6528>>2];cd=c[e+6536>>2]|0;c[e+64>>2]=b;c[e+72>>2]=d;g[e+6160>>2]=Tc;g[e+6248>>2]=Uc;g[e+6336>>2]=Vc;g[e+6456>>2]=Wc;c[e+6464>>2]=Xc;g[e+6472>>2]=Yc;c[e+6480>>2]=Zc;g[e+6504>>2]=_c;c[e+6512>>2]=$c;g[e+6520>>2]=ad;g[e+6528>>2]=bd;c[e+6536>>2]=cd;c[e+13888>>2]=0;c[e+13892>>2]=0;_setLinearMatrixA175$0(e);H=c[e+13888>>2]|0;A=c[e+13892>>2]|0;I=+g[e+13892>>2];c[e+13888>>2]=0;c[e+13892>>2]=0;if((H|0)==5){return}}function _setLinearMatrixA175$0(b){b=b|0;var d=0,e=0,f=0.0,j=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,X=0,Y=0.0,Z=0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0,ea=0,fa=0.0,ga=0.0,ha=0.0,ia=0,ja=0.0,ka=0,la=0.0,ma=0.0,na=0,oa=0,pa=0.0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0,Na=0.0,Oa=0.0,Pa=0,Qa=0.0,Ra=0,Sa=0.0,Ta=0.0,Ua=0,Va=0.0,Wa=0,Xa=0.0,Ya=0.0,Za=0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0,Gb=0.0,Hb=0,Ib=0.0,Jb=0,Kb=0.0,Lb=0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0,Vb=0.0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0.0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0.0,jc=0.0,kc=0,lc=0.0,mc=0.0,nc=0,oc=0.0,pc=0.0,qc=0.0,rc=0,sc=0.0,tc=0,uc=0.0,vc=0.0,wc=0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0.0,Ic=0,Jc=0.0,Kc=0,Lc=0.0,Mc=0,Nc=0.0,Oc=0,Pc=0.0,Qc=0.0,Rc=0.0,Sc=0.0,Tc=0.0,Uc=0.0,Vc=0.0,Wc=0.0,Xc=0.0,Yc=0.0,Zc=0.0,_c=0.0,$c=0.0,ad=0.0,bd=0.0,cd=0,dd=0.0,ed=0,fd=0.0,gd=0.0,hd=0,id=0.0,jd=0,kd=0.0,ld=0.0,md=0,nd=0.0,od=0.0,pd=0,qd=0.0,rd=0.0,sd=0,td=0.0,ud=0.0,vd=0,wd=0.0,xd=0.0,yd=0.0,zd=0,Ad=0.0,Bd=0,Cd=0.0,Dd=0.0,Ed=0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0,Kd=0.0,Ld=0,Md=0.0,Nd=0,Od=0.0,Pd=0.0,Qd=0,Rd=0.0,Sd=0,Td=0.0,Ud=0,Vd=0.0,Wd=0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0,$d=0.0,ae=0.0,be=0,ce=0.0,de=0.0,ee=0,fe=0.0,ge=0.0,he=0,ie=0.0,je=0,ke=0.0,le=0.0,me=0,ne=0.0,oe=0,pe=0.0,qe=0.0,re=0,se=0.0,te=0,ue=0.0,ve=0.0,we=0,xe=0.0,ye=0,Ae=0.0,Be=0,Ce=0.0,De=0.0,Ee=0,Fe=0.0,Ge=0,He=0.0,Ie=0,Je=0.0,Ke=0,Le=0.0,Me=0.0,Ne=0,Oe=0.0,Qe=0.0,Re=0,Se=0.0,Te=0.0,Ue=0,Ve=0.0,We=0.0,Xe=0,Ye=0.0,Ze=0.0,_e=0.0,$e=0.0,af=0.0,bf=0.0,cf=0,df=0.0,ef=0,ff=0.0,gf=0,hf=0.0,jf=0,kf=0.0,lf=0,mf=0.0,nf=0.0,of=0.0,pf=0,qf=0.0,rf=0,sf=0.0,tf=0,uf=0,vf=0.0,wf=0.0,xf=0,yf=0.0,zf=0,Af=0.0,Bf=0,Cf=0.0,Df=0,Ef=0.0,Ff=0.0,Gf=0,Hf=0.0,If=0.0,Jf=0,Kf=0.0,Lf=0.0,Mf=0,Nf=0.0,Of=0.0,Pf=0,Qf=0.0,Rf=0.0,Sf=0.0,Tf=0,Uf=0.0,Vf=0,Wf=0.0,Xf=0.0,Yf=0,Zf=0.0,_f=0,$f=0.0,ag=0.0,bg=0,cg=0.0,dg=0,eg=0.0,fg=0,gg=0.0,hg=0.0,ig=0,jg=0.0,kg=0,lg=0.0,mg=0,ng=0.0,og=0,pg=0.0,qg=0.0,rg=0.0,sg=0.0,tg=0,ug=0.0,vg=0,wg=0,xg=0,yg=0,zg=0,Ag=0,Bg=0,Cg=0,Dg=0,Eg=0,Fg=0,Gg=0.0,Hg=0,Ig=0,Jg=0,Kg=0,Lg=0,Mg=0,Ng=0,Og=0,Pg=0,Qg=0,Rg=0.0;d=c[b+64>>2]|0;e=c[b+72>>2]|0;f=+g[b+6160>>2];j=+g[b+6248>>2];l=+g[b+6336>>2];m=+g[b+6456>>2];n=c[b+6464>>2]|0;o=+g[b+6472>>2];p=c[b+6480>>2]|0;q=+g[b+6504>>2];r=c[b+6512>>2]|0;s=+g[b+6520>>2];t=+g[b+6528>>2];u=c[b+6536>>2]|0;a:do{do{v=1;if(v){v=0;if(q*q!=0.0){do{if(u){w=o;x=p;y=m/o}else{if(m==0.0){w=o;x=p;y=m;break}z=m/+xH(c[d+536>>2]|0,o,10864,9768,+h[n>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;w=+h[A+18584>>3];x=A;y=z}}while(0);z=s+t*+U(+y)+-1.0;B=+h[x+18600>>3];do{if(w!=0.0){C=w;D=x;E=f/w}else{if(f==0.0){C=w;D=x;E=f;break}F=f/+xH(c[d+536>>2]|0,w,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;C=+h[A+18584>>3];D=A;E=F}}while(0);F=B*E;A=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[A+8>>2]|0)+672>>3];do{if(C!=0.0){H=C;I=D;J=G/C}else{if(G==0.0){H=C;I=D;J=G;break}K=G/+xH(c[d+536>>2]|0,C,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;H=+h[L+18584>>3];I=L;J=K}}while(0);G=+U(+J);B=+h[I+18608>>3];K=+W(+G,+(B+-1.0));do{if(H!=0.0){M=H;N=I;O=j/H}else{if(j==0.0){M=H;N=I;O=j;break}G=j/+xH(c[d+536>>2]|0,H,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;M=+h[A+18584>>3];N=A;O=G}}while(0);G=z*(F+K*B*O);P=+h[N+18592>>3];Q=+h[N+18600>>3];A=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[A+8>>2]|0)+672>>3];do{if(M!=0.0){S=+U(+(R/M));T=(Q*S+ +W(+S,+(+h[N+18608>>3]))+1.0)/M}else{if(R==0.0){V=R;X=A;Y=M;Z=N;_=R}else{S=R/+xH(c[d+536>>2]|0,M,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;V=+h[(c[$+8>>2]|0)+672>>3];X=$;Y=+h[L+18584>>3];Z=L;_=S}S=Q*+U(+_);do{if(Y!=0.0){aa=V;ba=X;ca=Y;ea=Z;fa=V/Y}else{if(V==0.0){aa=V;ba=X;ca=Y;ea=Z;fa=V;break}ga=V/+xH(c[d+536>>2]|0,Y,10864,9768,+h[X>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;aa=+h[(c[$+8>>2]|0)+672>>3];ba=$;ca=+h[L+18584>>3];ea=L;fa=ga}}while(0);ga=+U(+fa);L=S+ +W(+ga,+(+h[ea+18608>>3]))+1.0==0.0;ga=+h[ea+18600>>3];$=ca!=0.0;if(L){do{if($){ha=aa;ia=ba;ja=ca;ka=ea;la=aa/ca}else{if(aa==0.0){ha=aa;ia=ba;ja=ca;ka=ea;la=aa;break}ma=aa/+xH(c[d+536>>2]|0,ca,10864,9768,+h[ba>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;ha=+h[(c[na+8>>2]|0)+672>>3];ia=na;ja=+h[L+18584>>3];ka=L;la=ma}}while(0);S=ga*+U(+la);do{if(ja!=0.0){oa=ka;pa=ha/ja}else{if(ha==0.0){oa=ka;pa=ha;break}ma=ha/+xH(c[d+536>>2]|0,ja,10864,9768,+h[ia>>3],(a[d+319|0]|0)!=0|0);oa=c[(d+416|0)>>2]|0;pa=ma}}while(0);ma=+U(+pa);T=S+ +W(+ma,+(+h[oa+18608>>3]))+1.0;break}else{do{if($){qa=aa;ra=ba;sa=ca;ta=ea;ua=aa/ca}else{if(aa==0.0){qa=aa;ra=ba;sa=ca;ta=ea;ua=aa;break}ma=aa/+xH(c[d+536>>2]|0,ca,10864,9768,+h[ba>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;qa=+h[(c[na+8>>2]|0)+672>>3];ra=na;sa=+h[L+18584>>3];ta=L;ua=ma}}while(0);S=ga*+U(+ua);do{if(sa!=0.0){va=ra;wa=sa;xa=ta;ya=qa/sa}else{if(qa==0.0){va=ra;wa=sa;xa=ta;ya=qa;break}ma=qa/+xH(c[d+536>>2]|0,sa,10864,9768,+h[ra>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;va=c[c[(d+4|0)>>2]>>2]|0;wa=+h[$+18584>>3];xa=$;ya=ma}}while(0);ga=+U(+ya);ma=S+ +W(+ga,+(+h[xa+18608>>3]))+1.0;T=ma/+xH(c[d+536>>2]|0,wa,10864,9768,+h[va>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=(G-P*l*T)/(q*q)}else{v=1}}if(v){v=0;if(1){do{if(u){Aa=o;Ba=p;Ca=m/o}else{if(m==0.0){Aa=o;Ba=p;Ca=m;break}Q=m/+xH(c[d+536>>2]|0,o,10864,9768,+h[n>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Aa=+h[A+18584>>3];Ba=A;Ca=Q}}while(0);P=s+t*+U(+Ca)+-1.0;G=+h[Ba+18600>>3];do{if(Aa!=0.0){Da=Aa;Ea=Ba;Fa=f/Aa}else{if(f==0.0){Da=Aa;Ea=Ba;Fa=f;break}Q=f/+xH(c[d+536>>2]|0,Aa,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Da=+h[A+18584>>3];Ea=A;Fa=Q}}while(0);Q=G*Fa;A=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[A+8>>2]|0)+672>>3];do{if(Da!=0.0){Ga=Da;Ha=Ea;Ia=R/Da}else{if(R==0.0){Ga=Da;Ha=Ea;Ia=R;break}B=R/+xH(c[d+536>>2]|0,Da,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Ga=+h[$+18584>>3];Ha=$;Ia=B}}while(0);R=+U(+Ia);G=+h[Ha+18608>>3];B=+W(+R,+(G+-1.0));do{if(Ga!=0.0){Ja=Ga;Ka=Ha;La=j/Ga}else{if(j==0.0){Ja=Ga;Ka=Ha;La=j;break}R=j/+xH(c[d+536>>2]|0,Ga,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;Ja=+h[A+18584>>3];Ka=A;La=R}}while(0);R=P*(Q+B*G*La);K=+h[Ka+18592>>3];F=+h[Ka+18600>>3];A=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[A+8>>2]|0)+672>>3];do{if(Ja!=0.0){ma=+U(+(z/Ja));Ma=Ka;Na=(F*ma+ +W(+ma,+(+h[Ka+18608>>3]))+1.0)/Ja}else{if(z==0.0){Oa=z;Pa=A;Qa=Ja;Ra=Ka;Sa=z}else{ma=z/+xH(c[d+536>>2]|0,Ja,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;Oa=+h[(c[L+8>>2]|0)+672>>3];Pa=L;Qa=+h[$+18584>>3];Ra=$;Sa=ma}ma=F*+U(+Sa);do{if(Qa!=0.0){Ta=Oa;Ua=Pa;Va=Qa;Wa=Ra;Xa=Oa/Qa}else{if(Oa==0.0){Ta=Oa;Ua=Pa;Va=Qa;Wa=Ra;Xa=Oa;break}ga=Oa/+xH(c[d+536>>2]|0,Qa,10864,9768,+h[Pa>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;Ta=+h[(c[L+8>>2]|0)+672>>3];Ua=L;Va=+h[$+18584>>3];Wa=$;Xa=ga}}while(0);S=+U(+Xa);$=ma+ +W(+S,+(+h[Wa+18608>>3]))+1.0==0.0;S=+h[Wa+18600>>3];L=Va!=0.0;if($){do{if(L){Ya=Ta;Za=Ua;_a=Va;$a=Wa;ab=Ta/Va}else{if(Ta==0.0){Ya=Ta;Za=Ua;_a=Va;$a=Wa;ab=Ta;break}ga=Ta/+xH(c[d+536>>2]|0,Va,10864,9768,+h[Ua>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Ya=+h[(c[na+8>>2]|0)+672>>3];Za=na;_a=+h[$+18584>>3];$a=$;ab=ga}}while(0);ma=S*+U(+ab);do{if(_a!=0.0){bb=$a;cb=Ya/_a}else{if(Ya==0.0){bb=$a;cb=Ya;break}ga=Ya/+xH(c[d+536>>2]|0,_a,10864,9768,+h[Za>>3],(a[d+319|0]|0)!=0|0);bb=c[(d+416|0)>>2]|0;cb=ga}}while(0);ga=+U(+cb);Ma=bb;Na=ma+ +W(+ga,+(+h[bb+18608>>3]))+1.0;break}else{do{if(L){db=Ta;eb=Ua;fb=Va;gb=Wa;hb=Ta/Va}else{if(Ta==0.0){db=Ta;eb=Ua;fb=Va;gb=Wa;hb=Ta;break}ga=Ta/+xH(c[d+536>>2]|0,Va,10864,9768,+h[Ua>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;db=+h[(c[na+8>>2]|0)+672>>3];eb=na;fb=+h[$+18584>>3];gb=$;hb=ga}}while(0);ma=S*+U(+hb);do{if(fb!=0.0){ib=eb;jb=fb;kb=gb;lb=db/fb}else{if(db==0.0){ib=eb;jb=fb;kb=gb;lb=db;break}ga=db/+xH(c[d+536>>2]|0,fb,10864,9768,+h[eb>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;ib=c[c[(d+4|0)>>2]>>2]|0;jb=+h[L+18584>>3];kb=L;lb=ga}}while(0);S=+U(+lb);ga=ma+ +W(+S,+(+h[kb+18608>>3]))+1.0;S=ga/+xH(c[d+536>>2]|0,jb,10864,9768,+h[ib>>3],(a[d+319|0]|0)!=0|0);Ma=c[(d+416|0)>>2]|0;Na=S;break}}}while(0);F=+h[Ma+18576>>3];z=+h[Ma+18592>>3];G=+h[Ma+18584>>3];A=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[A+8>>2]|0)+672>>3];L=1;if(L){L=0;if(R-K*l*Na==0.0){do{if(G!=0.0){mb=G;nb=Ma;ob=B/G}else{if(B==0.0){mb=G;nb=Ma;ob=B;break}Q=B/+xH(c[d+536>>2]|0,G,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;mb=+h[$+18584>>3];nb=$;ob=Q}}while(0);K=F+z*+U(+ob)+-1.0;R=+h[nb+18600>>3];do{if(mb!=0.0){pb=mb;qb=nb;rb=f/mb}else{if(f==0.0){pb=mb;qb=nb;rb=f;break}Q=f/+xH(c[d+536>>2]|0,mb,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;pb=+h[$+18584>>3];qb=$;rb=Q}}while(0);Q=R*rb;$=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[$+8>>2]|0)+672>>3];do{if(pb!=0.0){sb=pb;tb=qb;ub=P/pb}else{if(P==0.0){sb=pb;tb=qb;ub=P;break}S=P/+xH(c[d+536>>2]|0,pb,10864,9768,+h[$>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;sb=+h[na+18584>>3];tb=na;ub=S}}while(0);P=+U(+ub);R=+h[tb+18608>>3];S=+W(+P,+(R+-1.0));do{if(sb!=0.0){vb=sb;wb=tb;xb=j/sb}else{if(j==0.0){vb=sb;wb=tb;xb=j;break}P=j/+xH(c[d+536>>2]|0,sb,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;vb=+h[$+18584>>3];wb=$;xb=P}}while(0);P=K*(Q+S*R*xb);ga=+h[wb+18592>>3];yb=+h[wb+18600>>3];$=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[$+8>>2]|0)+672>>3];do{if(vb!=0.0){Ab=+U(+(zb/vb));Bb=(yb*Ab+ +W(+Ab,+(+h[wb+18608>>3]))+1.0)/vb}else{if(zb==0.0){Cb=zb;Db=$;Eb=vb;Fb=wb;Gb=zb}else{Ab=zb/+xH(c[d+536>>2]|0,vb,10864,9768,+h[$>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;Cb=+h[(c[Hb+8>>2]|0)+672>>3];Db=Hb;Eb=+h[na+18584>>3];Fb=na;Gb=Ab}Ab=yb*+U(+Gb);do{if(Eb!=0.0){Ib=Cb;Jb=Db;Kb=Eb;Lb=Fb;Mb=Cb/Eb}else{if(Cb==0.0){Ib=Cb;Jb=Db;Kb=Eb;Lb=Fb;Mb=Cb;break}Nb=Cb/+xH(c[d+536>>2]|0,Eb,10864,9768,+h[Db>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;Ib=+h[(c[Hb+8>>2]|0)+672>>3];Jb=Hb;Kb=+h[na+18584>>3];Lb=na;Mb=Nb}}while(0);ma=+U(+Mb);na=Ab+ +W(+ma,+(+h[Lb+18608>>3]))+1.0==0.0;ma=+h[Lb+18600>>3];Hb=Kb!=0.0;if(na){do{if(Hb){Ob=Ib;Pb=Jb;Qb=Kb;Rb=Lb;Sb=Ib/Kb}else{if(Ib==0.0){Ob=Ib;Pb=Jb;Qb=Kb;Rb=Lb;Sb=Ib;break}Nb=Ib/+xH(c[d+536>>2]|0,Kb,10864,9768,+h[Jb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ob=+h[(c[Tb+8>>2]|0)+672>>3];Pb=Tb;Qb=+h[na+18584>>3];Rb=na;Sb=Nb}}while(0);Ab=ma*+U(+Sb);do{if(Qb!=0.0){Ub=Rb;Vb=Ob/Qb}else{if(Ob==0.0){Ub=Rb;Vb=Ob;break}Nb=Ob/+xH(c[d+536>>2]|0,Qb,10864,9768,+h[Pb>>3],(a[d+319|0]|0)!=0|0);Ub=c[(d+416|0)>>2]|0;Vb=Nb}}while(0);Nb=+U(+Vb);Bb=Ab+ +W(+Nb,+(+h[Ub+18608>>3]))+1.0;break}else{do{if(Hb){Wb=Ib;Xb=Jb;Yb=Kb;Zb=Lb;_b=Ib/Kb}else{if(Ib==0.0){Wb=Ib;Xb=Jb;Yb=Kb;Zb=Lb;_b=Ib;break}Nb=Ib/+xH(c[d+536>>2]|0,Kb,10864,9768,+h[Jb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Wb=+h[(c[Tb+8>>2]|0)+672>>3];Xb=Tb;Yb=+h[na+18584>>3];Zb=na;_b=Nb}}while(0);Ab=ma*+U(+_b);do{if(Yb!=0.0){$b=Xb;ac=Yb;bc=Zb;cc=Wb/Yb}else{if(Wb==0.0){$b=Xb;ac=Yb;bc=Zb;cc=Wb;break}Nb=Wb/+xH(c[d+536>>2]|0,Yb,10864,9768,+h[Xb>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;$b=c[c[(d+4|0)>>2]>>2]|0;ac=+h[Hb+18584>>3];bc=Hb;cc=Nb}}while(0);ma=+U(+cc);Nb=Ab+ +W(+ma,+(+h[bc+18608>>3]))+1.0;Bb=Nb/+xH(c[d+536>>2]|0,ac,10864,9768,+h[$b>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=P-ga*l*Bb;break}else{L=1}}if(L){L=0;if(1){do{if(G!=0.0){dc=G;ec=Ma;fc=B/G}else{if(B==0.0){dc=G;ec=Ma;fc=B;break}yb=B/+xH(c[d+536>>2]|0,G,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;dc=+h[$+18584>>3];ec=$;fc=yb}}while(0);G=F+z*+U(+fc)+-1.0;B=+h[ec+18600>>3];do{if(dc!=0.0){gc=dc;hc=ec;ic=f/dc}else{if(f==0.0){gc=dc;hc=ec;ic=f;break}ga=f/+xH(c[d+536>>2]|0,dc,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;gc=+h[A+18584>>3];hc=A;ic=ga}}while(0);z=B*ic;A=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[A+8>>2]|0)+672>>3];do{if(gc!=0.0){jc=gc;kc=hc;lc=F/gc}else{if(F==0.0){jc=gc;kc=hc;lc=F;break}ga=F/+xH(c[d+536>>2]|0,gc,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;jc=+h[$+18584>>3];kc=$;lc=ga}}while(0);F=+U(+lc);B=+h[kc+18608>>3];ga=+W(+F,+(B+-1.0));do{if(jc!=0.0){mc=jc;nc=kc;oc=j/jc}else{if(j==0.0){mc=jc;nc=kc;oc=j;break}F=j/+xH(c[d+536>>2]|0,jc,10864,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);A=c[(d+416|0)>>2]|0;mc=+h[A+18584>>3];nc=A;oc=F}}while(0);F=G*(z+ga*B*oc);P=+h[nc+18592>>3];yb=+h[nc+18600>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+672>>3];do{if(mc!=0.0){R=+U(+(zb/mc));pc=(yb*R+ +W(+R,+(+h[nc+18608>>3]))+1.0)/mc}else{if(zb==0.0){qc=zb;rc=A;sc=mc;tc=nc;uc=zb}else{R=zb/+xH(c[d+536>>2]|0,mc,10864,9768,+h[A>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;qc=+h[(c[Hb+8>>2]|0)+672>>3];rc=Hb;sc=+h[$+18584>>3];tc=$;uc=R}R=yb*+U(+uc);do{if(sc!=0.0){vc=qc;wc=rc;xc=sc;yc=tc;zc=qc/sc}else{if(qc==0.0){vc=qc;wc=rc;xc=sc;yc=tc;zc=qc;break}S=qc/+xH(c[d+536>>2]|0,sc,10864,9768,+h[rc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;Hb=c[c[(d+4|0)>>2]>>2]|0;vc=+h[(c[Hb+8>>2]|0)+672>>3];wc=Hb;xc=+h[$+18584>>3];yc=$;zc=S}}while(0);Ab=+U(+zc);$=R+ +W(+Ab,+(+h[yc+18608>>3]))+1.0==0.0;Ab=+h[yc+18600>>3];Hb=xc!=0.0;if($){do{if(Hb){Ac=vc;Bc=wc;Cc=xc;Dc=yc;Ec=vc/xc}else{if(vc==0.0){Ac=vc;Bc=wc;Cc=xc;Dc=yc;Ec=vc;break}S=vc/+xH(c[d+536>>2]|0,xc,10864,9768,+h[wc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Ac=+h[(c[na+8>>2]|0)+672>>3];Bc=na;Cc=+h[$+18584>>3];Dc=$;Ec=S}}while(0);R=Ab*+U(+Ec);do{if(Cc!=0.0){Fc=Dc;Gc=Ac/Cc}else{if(Ac==0.0){Fc=Dc;Gc=Ac;break}S=Ac/+xH(c[d+536>>2]|0,Cc,10864,9768,+h[Bc>>3],(a[d+319|0]|0)!=0|0);Fc=c[(d+416|0)>>2]|0;Gc=S}}while(0);S=+U(+Gc);pc=R+ +W(+S,+(+h[Fc+18608>>3]))+1.0;break}else{do{if(Hb){Hc=vc;Ic=wc;Jc=xc;Kc=yc;Lc=vc/xc}else{if(vc==0.0){Hc=vc;Ic=wc;Jc=xc;Kc=yc;Lc=vc;break}S=vc/+xH(c[d+536>>2]|0,xc,10864,9768,+h[wc>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Hc=+h[(c[na+8>>2]|0)+672>>3];Ic=na;Jc=+h[$+18584>>3];Kc=$;Lc=S}}while(0);R=Ab*+U(+Lc);do{if(Jc!=0.0){Mc=Ic;Nc=Jc;Oc=Kc;Pc=Hc/Jc}else{if(Hc==0.0){Mc=Ic;Nc=Jc;Oc=Kc;Pc=Hc;break}S=Hc/+xH(c[d+536>>2]|0,Jc,10864,9768,+h[Ic>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;Mc=c[c[(d+4|0)>>2]>>2]|0;Nc=+h[Hb+18584>>3];Oc=Hb;Pc=S}}while(0);Ab=+U(+Pc);S=R+ +W(+Ab,+(+h[Oc+18608>>3]))+1.0;pc=S/+xH(c[d+536>>2]|0,Nc,10864,9768,+h[Mc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);za=(F-P*l*pc)/+xH(c[d+536>>2]|0,q*q,10912,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{L=1}}}else{v=1}}}while(0);ze[r&3](25,9,za,62,e);ze[c[(e+8|0)>>2]&3](26,7,1.0,63,e);A=c[(d+416|0)>>2]|0;yb=+h[A+18624>>3];zb=+h[A+18632>>3];do{if(yb!=0.0){Qc=zb/yb}else{if(zb==0.0){Qc=zb;break}Qc=zb/+xH(c[d+536>>2]|0,yb,11200,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(!(Qc>0.0)){A=c[28168]|0;Hb=c[d+536>>2]|0;h[k>>3]=Qc;c[(b+48|0)>>2]=c[k>>2];c[(b+48|0)+4>>2]=c[k+4>>2];c[b+0>>2]=c[13104+0>>2];c[b+4>>2]=c[13104+4>>2];c[b+8>>2]=c[13104+8>>2];c[b+12>>2]=c[13104+12>>2];c[b+16>>2]=c[13104+16>>2];c[b+20>>2]=c[13104+20>>2];Pe[A&31](Hb,b,11232,b+48|0);}Hb=c[(e+8|0)>>2]|0;yb=+da(+Qc);zb=+h[(c[(d+416|0)>>2]|0)+18616>>3];do{if(yb!=0.0){Rc=zb/yb}else{if(zb==0.0){Rc=zb;break}Rc=zb/+xH(c[d+536>>2]|0,yb,11360,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[Hb&3](26,8,Rc*-7895683520871486.0e-21,64,e);ze[c[(e+8|0)>>2]&3](27,6,1.0,65,e);A=c[c[(d+4|0)>>2]>>2]|0;yb=+h[(c[A+8>>2]|0)+680>>3];if(yb!=0.0){Sc=yb}else{Sc=+xH(c[d+536>>2]|0,yb,11440,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}yb=1.0/Sc;ze[c[(e+8|0)>>2]&3](27,7,yb*yb,66,e);ze[c[(e+8|0)>>2]&3](28,5,1.0,67,e);ze[c[(e+8|0)>>2]&3](28,6,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],68,e);ze[c[(e+8|0)>>2]&3](28,25,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+688>>3],69,e);ze[c[(e+8|0)>>2]&3](29,4,1.0,70,e);A=c[(e+8|0)>>2]|0;$=c[c[(d+4|0)>>2]>>2]|0;yb=+h[(c[$+8>>2]|0)+2944>>3];if(yb!=0.0){Tc=yb}else{Tc=+xH(c[d+536>>2]|0,yb,11472,9768,+h[$>>3],(a[d+319|0]|0)!=0|0)}ze[A&3](29,25,1.0/Tc,71,e);ze[c[(e+8|0)>>2]&3](30,3,1.0,72,e);yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){Uc=zb/yb}else{if(zb==0.0){Uc=zb;break}Uc=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(Uc>0.0){Vc=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){Wc=zb/yb}else{if(zb==0.0){Wc=zb;break}Wc=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);Vc=+(Wc<0.0|0)}yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){Xc=zb/yb}else{if(zb==0.0){Xc=zb;break}Xc=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(Xc>0.0){Yc=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){Zc=zb/yb}else{if(zb==0.0){Zc=zb;break}Zc=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);Yc=+(Zc<0.0|0)}yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){_c=zb/yb}else{if(zb==0.0){_c=zb;break}_c=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(_c>0.0){$c=1.0}else{yb=+h[(c[(d+416|0)>>2]|0)+18512>>3];A=c[c[(d+4|0)>>2]>>2]|0;zb=+h[(c[A+8>>2]|0)+736>>3];do{if(yb!=0.0){ad=zb/yb}else{if(zb==0.0){ad=zb;break}ad=zb/+xH(c[d+536>>2]|0,yb,11504,9768,+h[A>>3],(a[d+319|0]|0)!=0|0)}}while(0);$c=+(ad<0.0|0)}A=c[(d+416|0)>>2]|0;yb=+h[A+18528>>3];zb=+h[A+18512>>3];Hb=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[Hb+8>>2]|0)+736>>3];do{if(zb!=0.0){bd=B;cd=Hb;dd=zb;ed=A;fd=B/zb}else{if(B==0.0){bd=B;cd=Hb;dd=zb;ed=A;fd=B;break}ga=B/+xH(c[d+536>>2]|0,zb,11504,9768,+h[Hb>>3],(a[d+319|0]|0)!=0|0);$=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[na+8>>2]|0)+736>>3];cd=na;dd=+h[$+18512>>3];ed=$;fd=ga}}while(0);zb=yb*+U(+fd);do{if(dd!=0.0){gd=bd;hd=cd;id=dd;jd=ed;kd=bd/dd}else{if(bd==0.0){gd=bd;hd=cd;id=dd;jd=ed;kd=bd;break}B=bd/+xH(c[d+536>>2]|0,dd,11504,9768,+h[cd>>3],(a[d+319|0]|0)!=0|0);Hb=c[(d+416|0)>>2]|0;A=c[c[(d+4|0)>>2]>>2]|0;gd=+h[(c[A+8>>2]|0)+736>>3];hd=A;id=+h[Hb+18512>>3];jd=Hb;kd=B}}while(0);yb=+U(+kd);B=zb+ +W(+yb,+(+h[jd+18536>>3]))+1.0;Hb=c[(e+8|0)>>2]|0;yb=+h[jd+18504>>3];ga=+h[jd+18520>>3];A=id!=0.0;do{$=1;if($){$=0;if(B*B!=0.0){do{if(A){ld=id;md=jd;nd=gd/id}else{if(gd==0.0){ld=id;md=jd;nd=gd;break}z=gd/+xH(c[d+536>>2]|0,id,11504,9768,+h[hd>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;ld=+h[na+18512>>3];md=na;nd=z}}while(0);P=yb+ga*+U(+nd)+-1.0;F=+h[md+18528>>3];do{if(ld!=0.0){od=ld;pd=md;qd=Vc/ld}else{if(Vc==0.0){od=ld;pd=md;qd=Vc;break}z=Vc/+xH(c[d+536>>2]|0,ld,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;od=+h[v+18512>>3];pd=v;qd=z}}while(0);z=F*qd;v=c[c[(d+4|0)>>2]>>2]|0;G=+h[(c[v+8>>2]|0)+736>>3];do{if(od!=0.0){rd=od;sd=pd;td=G/od}else{if(G==0.0){rd=od;sd=pd;td=G;break}S=G/+xH(c[d+536>>2]|0,od,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;rd=+h[L+18512>>3];sd=L;td=S}}while(0);G=+U(+td);F=+h[sd+18536>>3];S=+W(+G,+(F+-1.0));do{if(rd!=0.0){ud=rd;vd=sd;wd=Yc/rd}else{if(Yc==0.0){ud=rd;vd=sd;wd=Yc;break}G=Yc/+xH(c[d+536>>2]|0,rd,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ud=+h[v+18512>>3];vd=v;wd=G}}while(0);G=P*(z+S*F*wd);Ab=+h[vd+18520>>3];Q=+h[vd+18528>>3];v=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[v+8>>2]|0)+736>>3];do{if(ud!=0.0){Nb=+U(+(K/ud));xd=(Q*Nb+ +W(+Nb,+(+h[vd+18536>>3]))+1.0)/ud}else{if(K==0.0){yd=K;zd=v;Ad=ud;Bd=vd;Cd=K}else{Nb=K/+xH(c[d+536>>2]|0,ud,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;yd=+h[(c[na+8>>2]|0)+736>>3];zd=na;Ad=+h[L+18512>>3];Bd=L;Cd=Nb}Nb=Q*+U(+Cd);do{if(Ad!=0.0){Dd=yd;Ed=zd;Fd=Ad;Gd=Bd;Hd=yd/Ad}else{if(yd==0.0){Dd=yd;Ed=zd;Fd=Ad;Gd=Bd;Hd=yd;break}ma=yd/+xH(c[d+536>>2]|0,Ad,11504,9768,+h[zd>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;Dd=+h[(c[na+8>>2]|0)+736>>3];Ed=na;Fd=+h[L+18512>>3];Gd=L;Hd=ma}}while(0);R=+U(+Hd);L=Nb+ +W(+R,+(+h[Gd+18536>>3]))+1.0==0.0;R=+h[Gd+18528>>3];na=Fd!=0.0;if(L){do{if(na){Id=Dd;Jd=Ed;Kd=Fd;Ld=Gd;Md=Dd/Fd}else{if(Dd==0.0){Id=Dd;Jd=Ed;Kd=Fd;Ld=Gd;Md=Dd;break}ma=Dd/+xH(c[d+536>>2]|0,Fd,11504,9768,+h[Ed>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Id=+h[(c[Tb+8>>2]|0)+736>>3];Jd=Tb;Kd=+h[L+18512>>3];Ld=L;Md=ma}}while(0);Nb=R*+U(+Md);do{if(Kd!=0.0){Nd=Ld;Od=Id/Kd}else{if(Id==0.0){Nd=Ld;Od=Id;break}ma=Id/+xH(c[d+536>>2]|0,Kd,11504,9768,+h[Jd>>3],(a[d+319|0]|0)!=0|0);Nd=c[(d+416|0)>>2]|0;Od=ma}}while(0);ma=+U(+Od);xd=Nb+ +W(+ma,+(+h[Nd+18536>>3]))+1.0;break}else{do{if(na){Pd=Dd;Qd=Ed;Rd=Fd;Sd=Gd;Td=Dd/Fd}else{if(Dd==0.0){Pd=Dd;Qd=Ed;Rd=Fd;Sd=Gd;Td=Dd;break}ma=Dd/+xH(c[d+536>>2]|0,Fd,11504,9768,+h[Ed>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Pd=+h[(c[Tb+8>>2]|0)+736>>3];Qd=Tb;Rd=+h[L+18512>>3];Sd=L;Td=ma}}while(0);Nb=R*+U(+Td);do{if(Rd!=0.0){Ud=Qd;Vd=Rd;Wd=Sd;Xd=Pd/Rd}else{if(Pd==0.0){Ud=Qd;Vd=Rd;Wd=Sd;Xd=Pd;break}ma=Pd/+xH(c[d+536>>2]|0,Rd,11504,9768,+h[Qd>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ud=c[c[(d+4|0)>>2]>>2]|0;Vd=+h[na+18512>>3];Wd=na;Xd=ma}}while(0);R=+U(+Xd);ma=Nb+ +W(+R,+(+h[Wd+18536>>3]))+1.0;xd=ma/+xH(c[d+536>>2]|0,Vd,11504,9768,+h[Ud>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=(G-Ab*$c*xd)/(B*B)}else{$=1}}if($){$=0;if(1){do{if(A){Zd=id;_d=jd;$d=gd/id}else{if(gd==0.0){Zd=id;_d=jd;$d=gd;break}Q=gd/+xH(c[d+536>>2]|0,id,11504,9768,+h[hd>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Zd=+h[v+18512>>3];_d=v;$d=Q}}while(0);Ab=yb+ga*+U(+$d)+-1.0;G=+h[_d+18528>>3];do{if(Zd!=0.0){ae=Zd;be=_d;ce=Vc/Zd}else{if(Vc==0.0){ae=Zd;be=_d;ce=Vc;break}Q=Vc/+xH(c[d+536>>2]|0,Zd,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ae=+h[v+18512>>3];be=v;ce=Q}}while(0);Q=G*ce;v=c[c[(d+4|0)>>2]>>2]|0;K=+h[(c[v+8>>2]|0)+736>>3];do{if(ae!=0.0){de=ae;ee=be;fe=K/ae}else{if(K==0.0){de=ae;ee=be;fe=K;break}F=K/+xH(c[d+536>>2]|0,ae,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;de=+h[na+18512>>3];ee=na;fe=F}}while(0);K=+U(+fe);G=+h[ee+18536>>3];F=+W(+K,+(G+-1.0));do{if(de!=0.0){ge=de;he=ee;ie=Yc/de}else{if(Yc==0.0){ge=de;he=ee;ie=Yc;break}K=Yc/+xH(c[d+536>>2]|0,de,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ge=+h[v+18512>>3];he=v;ie=K}}while(0);K=Ab*(Q+F*G*ie);S=+h[he+18520>>3];z=+h[he+18528>>3];v=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[v+8>>2]|0)+736>>3];do{if(ge!=0.0){ma=+U(+(P/ge));je=he;ke=(z*ma+ +W(+ma,+(+h[he+18536>>3]))+1.0)/ge}else{if(P==0.0){le=P;me=v;ne=ge;oe=he;pe=P}else{ma=P/+xH(c[d+536>>2]|0,ge,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;le=+h[(c[L+8>>2]|0)+736>>3];me=L;ne=+h[na+18512>>3];oe=na;pe=ma}ma=z*+U(+pe);do{if(ne!=0.0){qe=le;re=me;se=ne;te=oe;ue=le/ne}else{if(le==0.0){qe=le;re=me;se=ne;te=oe;ue=le;break}R=le/+xH(c[d+536>>2]|0,ne,11504,9768,+h[me>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;L=c[c[(d+4|0)>>2]>>2]|0;qe=+h[(c[L+8>>2]|0)+736>>3];re=L;se=+h[na+18512>>3];te=na;ue=R}}while(0);Nb=+U(+ue);na=ma+ +W(+Nb,+(+h[te+18536>>3]))+1.0==0.0;Nb=+h[te+18528>>3];L=se!=0.0;if(na){do{if(L){ve=qe;we=re;xe=se;ye=te;Ae=qe/se}else{if(qe==0.0){ve=qe;we=re;xe=se;ye=te;Ae=qe;break}R=qe/+xH(c[d+536>>2]|0,se,11504,9768,+h[re>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;ve=+h[(c[Tb+8>>2]|0)+736>>3];we=Tb;xe=+h[na+18512>>3];ye=na;Ae=R}}while(0);ma=Nb*+U(+Ae);do{if(xe!=0.0){Be=ye;Ce=ve/xe}else{if(ve==0.0){Be=ye;Ce=ve;break}R=ve/+xH(c[d+536>>2]|0,xe,11504,9768,+h[we>>3],(a[d+319|0]|0)!=0|0);Be=c[(d+416|0)>>2]|0;Ce=R}}while(0);R=+U(+Ce);je=Be;ke=ma+ +W(+R,+(+h[Be+18536>>3]))+1.0;break}else{do{if(L){De=qe;Ee=re;Fe=se;Ge=te;He=qe/se}else{if(qe==0.0){De=qe;Ee=re;Fe=se;Ge=te;He=qe;break}R=qe/+xH(c[d+536>>2]|0,se,11504,9768,+h[re>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;De=+h[(c[Tb+8>>2]|0)+736>>3];Ee=Tb;Fe=+h[na+18512>>3];Ge=na;He=R}}while(0);ma=Nb*+U(+He);do{if(Fe!=0.0){Ie=Ee;Je=Fe;Ke=Ge;Le=De/Fe}else{if(De==0.0){Ie=Ee;Je=Fe;Ke=Ge;Le=De;break}R=De/+xH(c[d+536>>2]|0,Fe,11504,9768,+h[Ee>>3],(a[d+319|0]|0)!=0|0);L=c[(d+416|0)>>2]|0;Ie=c[c[(d+4|0)>>2]>>2]|0;Je=+h[L+18512>>3];Ke=L;Le=R}}while(0);Nb=+U(+Le);R=ma+ +W(+Nb,+(+h[Ke+18536>>3]))+1.0;Nb=R/+xH(c[d+536>>2]|0,Je,11504,9768,+h[Ie>>3],(a[d+319|0]|0)!=0|0);je=c[(d+416|0)>>2]|0;ke=Nb;break}}}while(0);z=+h[je+18504>>3];P=+h[je+18520>>3];G=+h[je+18512>>3];v=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[v+8>>2]|0)+736>>3];L=1;if(L){L=0;if(K-S*$c*ke==0.0){do{if(G!=0.0){Me=G;Ne=je;Oe=F/G}else{if(F==0.0){Me=G;Ne=je;Oe=F;break}Q=F/+xH(c[d+536>>2]|0,G,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Me=+h[na+18512>>3];Ne=na;Oe=Q}}while(0);S=z+P*+U(+Oe)+-1.0;K=+h[Ne+18528>>3];do{if(Me!=0.0){Qe=Me;Re=Ne;Se=Vc/Me}else{if(Vc==0.0){Qe=Me;Re=Ne;Se=Vc;break}Q=Vc/+xH(c[d+536>>2]|0,Me,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Qe=+h[na+18512>>3];Re=na;Se=Q}}while(0);Q=K*Se;na=c[c[(d+4|0)>>2]>>2]|0;Ab=+h[(c[na+8>>2]|0)+736>>3];do{if(Qe!=0.0){Te=Qe;Ue=Re;Ve=Ab/Qe}else{if(Ab==0.0){Te=Qe;Ue=Re;Ve=Ab;break}Nb=Ab/+xH(c[d+536>>2]|0,Qe,11504,9768,+h[na>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;Te=+h[Tb+18512>>3];Ue=Tb;Ve=Nb}}while(0);Ab=+U(+Ve);K=+h[Ue+18536>>3];Nb=+W(+Ab,+(K+-1.0));do{if(Te!=0.0){We=Te;Xe=Ue;Ye=Yc/Te}else{if(Yc==0.0){We=Te;Xe=Ue;Ye=Yc;break}Ab=Yc/+xH(c[d+536>>2]|0,Te,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;We=+h[na+18512>>3];Xe=na;Ye=Ab}}while(0);Ab=S*(Q+Nb*K*Ye);R=+h[Xe+18520>>3];Ze=+h[Xe+18528>>3];na=c[c[(d+4|0)>>2]>>2]|0;_e=+h[(c[na+8>>2]|0)+736>>3];do{if(We!=0.0){$e=+U(+(_e/We));af=(Ze*$e+ +W(+$e,+(+h[Xe+18536>>3]))+1.0)/We}else{if(_e==0.0){bf=_e;cf=na;df=We;ef=Xe;ff=_e}else{$e=_e/+xH(c[d+536>>2]|0,We,11504,9768,+h[na>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;bf=+h[(c[gf+8>>2]|0)+736>>3];cf=gf;df=+h[Tb+18512>>3];ef=Tb;ff=$e}$e=Ze*+U(+ff);do{if(df!=0.0){hf=bf;jf=cf;kf=df;lf=ef;mf=bf/df}else{if(bf==0.0){hf=bf;jf=cf;kf=df;lf=ef;mf=bf;break}nf=bf/+xH(c[d+536>>2]|0,df,11504,9768,+h[cf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;hf=+h[(c[gf+8>>2]|0)+736>>3];jf=gf;kf=+h[Tb+18512>>3];lf=Tb;mf=nf}}while(0);ma=+U(+mf);Tb=$e+ +W(+ma,+(+h[lf+18536>>3]))+1.0==0.0;ma=+h[lf+18528>>3];gf=kf!=0.0;if(Tb){do{if(gf){of=hf;pf=jf;qf=kf;rf=lf;sf=hf/kf}else{if(hf==0.0){of=hf;pf=jf;qf=kf;rf=lf;sf=hf;break}nf=hf/+xH(c[d+536>>2]|0,kf,11504,9768,+h[jf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;tf=c[c[(d+4|0)>>2]>>2]|0;of=+h[(c[tf+8>>2]|0)+736>>3];pf=tf;qf=+h[Tb+18512>>3];rf=Tb;sf=nf}}while(0);$e=ma*+U(+sf);do{if(qf!=0.0){uf=rf;vf=of/qf}else{if(of==0.0){uf=rf;vf=of;break}nf=of/+xH(c[d+536>>2]|0,qf,11504,9768,+h[pf>>3],(a[d+319|0]|0)!=0|0);uf=c[(d+416|0)>>2]|0;vf=nf}}while(0);nf=+U(+vf);af=$e+ +W(+nf,+(+h[uf+18536>>3]))+1.0;break}else{do{if(gf){wf=hf;xf=jf;yf=kf;zf=lf;Af=hf/kf}else{if(hf==0.0){wf=hf;xf=jf;yf=kf;zf=lf;Af=hf;break}nf=hf/+xH(c[d+536>>2]|0,kf,11504,9768,+h[jf>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;tf=c[c[(d+4|0)>>2]>>2]|0;wf=+h[(c[tf+8>>2]|0)+736>>3];xf=tf;yf=+h[Tb+18512>>3];zf=Tb;Af=nf}}while(0);$e=ma*+U(+Af);do{if(yf!=0.0){Bf=xf;Cf=yf;Df=zf;Ef=wf/yf}else{if(wf==0.0){Bf=xf;Cf=yf;Df=zf;Ef=wf;break}nf=wf/+xH(c[d+536>>2]|0,yf,11504,9768,+h[xf>>3],(a[d+319|0]|0)!=0|0);gf=c[(d+416|0)>>2]|0;Bf=c[c[(d+4|0)>>2]>>2]|0;Cf=+h[gf+18512>>3];Df=gf;Ef=nf}}while(0);ma=+U(+Ef);nf=$e+ +W(+ma,+(+h[Df+18536>>3]))+1.0;af=nf/+xH(c[d+536>>2]|0,Cf,11504,9768,+h[Bf>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=Ab-R*$c*af;break}else{L=1}}if(L){L=0;if(1){do{if(G!=0.0){Ff=G;Gf=je;Hf=F/G}else{if(F==0.0){Ff=G;Gf=je;Hf=F;break}Ze=F/+xH(c[d+536>>2]|0,G,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ff=+h[na+18512>>3];Gf=na;Hf=Ze}}while(0);G=z+P*+U(+Hf)+-1.0;F=+h[Gf+18528>>3];do{if(Ff!=0.0){If=Ff;Jf=Gf;Kf=Vc/Ff}else{if(Vc==0.0){If=Ff;Jf=Gf;Kf=Vc;break}R=Vc/+xH(c[d+536>>2]|0,Ff,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;If=+h[v+18512>>3];Jf=v;Kf=R}}while(0);P=F*Kf;v=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[v+8>>2]|0)+736>>3];do{if(If!=0.0){Lf=If;Mf=Jf;Nf=z/If}else{if(z==0.0){Lf=If;Mf=Jf;Nf=z;break}R=z/+xH(c[d+536>>2]|0,If,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Lf=+h[na+18512>>3];Mf=na;Nf=R}}while(0);z=+U(+Nf);F=+h[Mf+18536>>3];R=+W(+z,+(F+-1.0));do{if(Lf!=0.0){Of=Lf;Pf=Mf;Qf=Yc/Lf}else{if(Yc==0.0){Of=Lf;Pf=Mf;Qf=Yc;break}z=Yc/+xH(c[d+536>>2]|0,Lf,11504,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Of=+h[v+18512>>3];Pf=v;Qf=z}}while(0);z=G*(P+R*F*Qf);Ab=+h[Pf+18520>>3];Ze=+h[Pf+18528>>3];v=c[c[(d+4|0)>>2]>>2]|0;_e=+h[(c[v+8>>2]|0)+736>>3];do{if(Of!=0.0){K=+U(+(_e/Of));Rf=(Ze*K+ +W(+K,+(+h[Pf+18536>>3]))+1.0)/Of}else{if(_e==0.0){Sf=_e;Tf=v;Uf=Of;Vf=Pf;Wf=_e}else{K=_e/+xH(c[d+536>>2]|0,Of,11504,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;Sf=+h[(c[gf+8>>2]|0)+736>>3];Tf=gf;Uf=+h[na+18512>>3];Vf=na;Wf=K}K=Ze*+U(+Wf);do{if(Uf!=0.0){Xf=Sf;Yf=Tf;Zf=Uf;_f=Vf;$f=Sf/Uf}else{if(Sf==0.0){Xf=Sf;Yf=Tf;Zf=Uf;_f=Vf;$f=Sf;break}Nb=Sf/+xH(c[d+536>>2]|0,Uf,11504,9768,+h[Tf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;gf=c[c[(d+4|0)>>2]>>2]|0;Xf=+h[(c[gf+8>>2]|0)+736>>3];Yf=gf;Zf=+h[na+18512>>3];_f=na;$f=Nb}}while(0);$e=+U(+$f);na=K+ +W(+$e,+(+h[_f+18536>>3]))+1.0==0.0;$e=+h[_f+18528>>3];gf=Zf!=0.0;if(na){do{if(gf){ag=Xf;bg=Yf;cg=Zf;dg=_f;eg=Xf/Zf}else{if(Xf==0.0){ag=Xf;bg=Yf;cg=Zf;dg=_f;eg=Xf;break}Nb=Xf/+xH(c[d+536>>2]|0,Zf,11504,9768,+h[Yf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;ag=+h[(c[Tb+8>>2]|0)+736>>3];bg=Tb;cg=+h[na+18512>>3];dg=na;eg=Nb}}while(0);K=$e*+U(+eg);do{if(cg!=0.0){fg=dg;gg=ag/cg}else{if(ag==0.0){fg=dg;gg=ag;break}Nb=ag/+xH(c[d+536>>2]|0,cg,11504,9768,+h[bg>>3],(a[d+319|0]|0)!=0|0);fg=c[(d+416|0)>>2]|0;gg=Nb}}while(0);Nb=+U(+gg);Rf=K+ +W(+Nb,+(+h[fg+18536>>3]))+1.0;break}else{do{if(gf){hg=Xf;ig=Yf;jg=Zf;kg=_f;lg=Xf/Zf}else{if(Xf==0.0){hg=Xf;ig=Yf;jg=Zf;kg=_f;lg=Xf;break}Nb=Xf/+xH(c[d+536>>2]|0,Zf,11504,9768,+h[Yf>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;hg=+h[(c[Tb+8>>2]|0)+736>>3];ig=Tb;jg=+h[na+18512>>3];kg=na;lg=Nb}}while(0);K=$e*+U(+lg);do{if(jg!=0.0){mg=ig;ng=jg;og=kg;pg=hg/jg}else{if(hg==0.0){mg=ig;ng=jg;og=kg;pg=hg;break}Nb=hg/+xH(c[d+536>>2]|0,jg,11504,9768,+h[ig>>3],(a[d+319|0]|0)!=0|0);gf=c[(d+416|0)>>2]|0;mg=c[c[(d+4|0)>>2]>>2]|0;ng=+h[gf+18512>>3];og=gf;pg=Nb}}while(0);$e=+U(+pg);Nb=K+ +W(+$e,+(+h[og+18536>>3]))+1.0;Rf=Nb/+xH(c[d+536>>2]|0,ng,11504,9768,+h[mg>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Yd=(z-Ab*$c*Rf)/+xH(c[d+536>>2]|0,B*B,11552,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{L=1}}}else{$=1}}}while(0);ze[Hb&3](30,4,Yd,73,e);ze[c[(e+8|0)>>2]&3](31,2,1.0,74,e);A=c[(e+8|0)>>2]|0;B=+h[(c[(d+416|0)>>2]|0)+18544>>3];v=c[c[(d+4|0)>>2]>>2]|0;ga=+h[(c[v+8>>2]|0)+2944>>3];do{if(B!=0.0){qg=ga/B}else{if(ga==0.0){qg=ga;break}qg=ga/+xH(c[d+536>>2]|0,B,11840,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[A&3](31,3,qg*-1256637061435917.0e-21,75,e);ze[c[(e+8|0)>>2]&3](32,1,1.0,76,e);v=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[v+8>>2]|0)+744>>3];if(B!=0.0){rg=B;sg=1.0/rg;tg=c[(e+8|0)>>2]|0;ug=sg*sg;ze[tg&3](32,2,ug,77,e);vg=c[(e+8|0)>>2]|0;ze[vg&3](33,0,1.0,78,e);wg=c[(e+8|0)>>2]|0;xg=c[(d+4|0)>>2]|0;yg=c[xg>>2]|0;zg=yg;Ag=zg+8|0;Bg=Ag;Cg=c[Bg>>2]|0;Dg=Cg;Eg=Dg+696|0;Fg=Eg;Gg=+h[Fg>>3];ze[wg&3](33,1,Gg,79,e);Hg=c[(e+8|0)>>2]|0;Ig=c[(d+4|0)>>2]|0;Jg=c[Ig>>2]|0;Kg=Jg;Lg=Kg+8|0;Mg=Lg;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+752|0;Qg=Pg;Rg=+h[Qg>>3];ze[Hg&3](33,25,Rg,80,e);i=b;c[b+13888>>2]=5;break a}rg=+xH(c[d+536>>2]|0,B,11872,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);sg=1.0/rg;tg=c[(e+8|0)>>2]|0;ug=sg*sg;ze[tg&3](32,2,ug,77,e);vg=c[(e+8|0)>>2]|0;ze[vg&3](33,0,1.0,78,e);wg=c[(e+8|0)>>2]|0;xg=c[(d+4|0)>>2]|0;yg=c[xg>>2]|0;zg=yg;Ag=zg+8|0;Bg=Ag;Cg=c[Bg>>2]|0;Dg=Cg;Eg=Dg+696|0;Fg=Eg;Gg=+h[Fg>>3];ze[wg&3](33,1,Gg,79,e);Hg=c[(e+8|0)>>2]|0;Ig=c[(d+4|0)>>2]|0;Jg=c[Ig>>2]|0;Kg=Jg;Lg=Kg+8|0;Mg=Lg;Ng=c[Mg>>2]|0;Og=Ng;Pg=Og+752|0;Qg=Pg;Rg=+h[Qg>>3];ze[Hg&3](33,25,Rg,80,e);i=b;c[b+13888>>2]=5;break a}while(0)}function _setLinearMatrixA175$1(b){b=b|0;var d=0,e=0,f=0.0,i=0.0,j=0.0,l=0.0,m=0,n=0.0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0,T=0.0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0,ca=0.0,ea=0.0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0,Ua=0.0,Va=0.0,Wa=0,Xa=0.0,Ya=0,Za=0.0,_a=0.0,$a=0,ab=0.0,bb=0,cb=0.0,db=0.0,eb=0,fb=0.0,gb=0,hb=0.0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0.0,ub=0,vb=0.0,wb=0,xb=0.0,yb=0.0,zb=0,Ab=0.0,Bb=0.0,Cb=0,Db=0.0,Eb=0.0,Fb=0,Gb=0.0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0,Qb=0.0,Rb=0,Sb=0.0,Tb=0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0.0,_b=0.0,$b=0,ac=0.0,bc=0,cc=0.0,dc=0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0.0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0.0,pc=0.0,qc=0,rc=0.0,sc=0.0,tc=0,uc=0.0,vc=0.0,wc=0,xc=0.0,yc=0.0,zc=0,Ac=0.0,Bc=0.0,Cc=0.0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0.0,Ic=0,Jc=0.0,Kc=0,Lc=0.0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0,Sc=0.0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0.0,ad=0.0,bd=0.0,cd=0.0,dd=0.0,ed=0.0,fd=0.0,gd=0.0,hd=0.0,id=0.0,jd=0.0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0,pd=0.0;d=c[b+64>>2]|0;e=c[b+72>>2]|0;f=+g[b+6160>>2];i=+g[b+6248>>2];j=+g[b+6336>>2];l=+g[b+6456>>2];m=c[b+6464>>2]|0;n=+g[b+6472>>2];o=c[b+6480>>2]|0;p=+g[b+6504>>2];q=c[b+6512>>2]|0;r=+g[b+6520>>2];s=+g[b+6528>>2];t=c[b+6536>>2]|0;u=c[b+13808>>2]|0;ze[c[(e+8|0)>>2]&3](15,18,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+2912>>3],37,e);ze[c[(e+8|0)>>2]&3](15,20,1.0,38,e);ze[c[(e+8|0)>>2]&3](16,5,1.0,39,e);ze[c[(e+8|0)>>2]&3](16,17,1.0,40,e);ze[c[(e+8|0)>>2]&3](16,20,1.0,41,e);ze[c[(e+8|0)>>2]&3](17,0,1.0,42,e);ze[c[(e+8|0)>>2]&3](17,16,-1.0,43,e);ze[c[(e+8|0)>>2]&3](17,17,1.0,44,e);ze[c[(e+8|0)>>2]&3](18,10,1.0,45,e);ze[c[(e+8|0)>>2]&3](18,15,-1.0,46,e);ze[c[(e+8|0)>>2]&3](18,16,1.0,47,e);ze[c[(e+8|0)>>2]&3](19,14,1.0,48,e);v=c[(e+8|0)>>2]|0;w=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[w+8>>2]|0)+2960>>3];if(x!=0.0){y=x}else{y=+xH(c[d+536>>2]|0,x,10184,9768,+h[w>>3],(a[d+319|0]|0)!=0|0)}ze[v&3](19,25,1.0/y,49,e);ze[c[(e+8|0)>>2]&3](20,13,1.0,50,e);y=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[v+8>>2]|0)+616>>3];do{if(y!=0.0){z=x/y}else{if(x==0.0){z=x;break}z=x/+xH(c[d+536>>2]|0,y,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(z>0.0){A=1.0}else{z=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+616>>3];do{if(z!=0.0){B=y/z}else{if(y==0.0){B=y;break}B=y/+xH(c[d+536>>2]|0,z,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);A=+(B<0.0|0)}B=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;z=+h[(c[v+8>>2]|0)+616>>3];do{if(B!=0.0){C=z/B}else{if(z==0.0){C=z;break}C=z/+xH(c[d+536>>2]|0,B,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(C>0.0){D=1.0}else{C=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[v+8>>2]|0)+616>>3];do{if(C!=0.0){E=B/C}else{if(B==0.0){E=B;break}E=B/+xH(c[d+536>>2]|0,C,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);D=+(E<0.0|0)}E=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;C=+h[(c[v+8>>2]|0)+616>>3];do{if(E!=0.0){F=C/E}else{if(C==0.0){F=C;break}F=C/+xH(c[d+536>>2]|0,E,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(F>0.0){G=1.0}else{F=+h[(c[(d+416|0)>>2]|0)+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[v+8>>2]|0)+616>>3];do{if(F!=0.0){H=E/F}else{if(E==0.0){H=E;break}H=E/+xH(c[d+536>>2]|0,F,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0)}}while(0);G=+(H<0.0|0)}v=c[(d+416|0)>>2]|0;H=+h[v+18672>>3];F=+h[v+18656>>3];w=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[w+8>>2]|0)+616>>3];do{if(F!=0.0){I=E;J=w;K=F;L=v;M=E/F}else{if(E==0.0){I=E;J=w;K=F;L=v;M=E;break}C=E/+xH(c[d+536>>2]|0,F,10216,9768,+h[w>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;I=+h[(c[O+8>>2]|0)+616>>3];J=O;K=+h[N+18656>>3];L=N;M=C}}while(0);F=H*+U(+M);do{if(K!=0.0){P=I;Q=J;R=K;S=L;T=I/K}else{if(I==0.0){P=I;Q=J;R=K;S=L;T=I;break}M=I/+xH(c[d+536>>2]|0,K,10216,9768,+h[J>>3],(a[d+319|0]|0)!=0|0);w=c[(d+416|0)>>2]|0;v=c[c[(d+4|0)>>2]>>2]|0;P=+h[(c[v+8>>2]|0)+616>>3];Q=v;R=+h[w+18656>>3];S=w;T=M}}while(0);K=+U(+T);T=F+ +W(+K,+(+h[S+18680>>3]))+1.0;J=c[(e+8|0)>>2]|0;K=+h[S+18648>>3];F=+h[S+18664>>3];L=R!=0.0;do{w=1;if(w){w=0;if(T*T!=0.0){do{if(L){V=R;X=S;Y=P/R}else{if(P==0.0){V=R;X=S;Y=P;break}I=P/+xH(c[d+536>>2]|0,R,10216,9768,+h[Q>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;V=+h[v+18656>>3];X=v;Y=I}}while(0);I=K+F*+U(+Y)+-1.0;M=+h[X+18672>>3];do{if(V!=0.0){Z=V;_=X;$=A/V}else{if(A==0.0){Z=V;_=X;$=A;break}H=A/+xH(c[d+536>>2]|0,V,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Z=+h[v+18656>>3];_=v;$=H}}while(0);H=M*$;v=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[v+8>>2]|0)+616>>3];do{if(Z!=0.0){aa=Z;ba=_;ca=E/Z}else{if(E==0.0){aa=Z;ba=_;ca=E;break}C=E/+xH(c[d+536>>2]|0,Z,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;aa=+h[N+18656>>3];ba=N;ca=C}}while(0);E=+U(+ca);M=+h[ba+18680>>3];C=+W(+E,+(M+-1.0));do{if(aa!=0.0){ea=aa;fa=ba;ga=D/aa}else{if(D==0.0){ea=aa;fa=ba;ga=D;break}E=D/+xH(c[d+536>>2]|0,aa,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;ea=+h[v+18656>>3];fa=v;ga=E}}while(0);E=I*(H+C*M*ga);B=+h[fa+18664>>3];z=+h[fa+18672>>3];v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+616>>3];do{if(ea!=0.0){x=+U(+(y/ea));ha=(z*x+ +W(+x,+(+h[fa+18680>>3]))+1.0)/ea}else{if(y==0.0){ia=y;ja=v;ka=ea;la=fa;ma=y}else{x=y/+xH(c[d+536>>2]|0,ea,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;ia=+h[(c[O+8>>2]|0)+616>>3];ja=O;ka=+h[N+18656>>3];la=N;ma=x}x=z*+U(+ma);do{if(ka!=0.0){na=ia;oa=ja;pa=ka;qa=la;ra=ia/ka}else{if(ia==0.0){na=ia;oa=ja;pa=ka;qa=la;ra=ia;break}sa=ia/+xH(c[d+536>>2]|0,ka,10216,9768,+h[ja>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;O=c[c[(d+4|0)>>2]>>2]|0;na=+h[(c[O+8>>2]|0)+616>>3];oa=O;pa=+h[N+18656>>3];qa=N;ra=sa}}while(0);sa=+U(+ra);N=x+ +W(+sa,+(+h[qa+18680>>3]))+1.0==0.0;sa=+h[qa+18672>>3];O=pa!=0.0;if(N){do{if(O){ta=na;ua=oa;va=pa;wa=qa;xa=na/pa}else{if(na==0.0){ta=na;ua=oa;va=pa;wa=qa;xa=na;break}ya=na/+xH(c[d+536>>2]|0,pa,10216,9768,+h[oa>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;ta=+h[(c[za+8>>2]|0)+616>>3];ua=za;va=+h[N+18656>>3];wa=N;xa=ya}}while(0);x=sa*+U(+xa);do{if(va!=0.0){Aa=wa;Ba=ta/va}else{if(ta==0.0){Aa=wa;Ba=ta;break}ya=ta/+xH(c[d+536>>2]|0,va,10216,9768,+h[ua>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;Ba=ya}}while(0);ya=+U(+Ba);ha=x+ +W(+ya,+(+h[Aa+18680>>3]))+1.0;break}else{do{if(O){Ca=na;Da=oa;Ea=pa;Fa=qa;Ga=na/pa}else{if(na==0.0){Ca=na;Da=oa;Ea=pa;Fa=qa;Ga=na;break}ya=na/+xH(c[d+536>>2]|0,pa,10216,9768,+h[oa>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Ca=+h[(c[za+8>>2]|0)+616>>3];Da=za;Ea=+h[N+18656>>3];Fa=N;Ga=ya}}while(0);x=sa*+U(+Ga);do{if(Ea!=0.0){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ca/Ea}else{if(Ca==0.0){Ha=Da;Ia=Ea;Ja=Fa;Ka=Ca;break}ya=Ca/+xH(c[d+536>>2]|0,Ea,10216,9768,+h[Da>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Ha=c[c[(d+4|0)>>2]>>2]|0;Ia=+h[O+18656>>3];Ja=O;Ka=ya}}while(0);sa=+U(+Ka);ya=x+ +W(+sa,+(+h[Ja+18680>>3]))+1.0;ha=ya/+xH(c[d+536>>2]|0,Ia,10216,9768,+h[Ha>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=(E-B*G*ha)/(T*T)}else{w=1}}if(w){w=0;if(1){do{if(L){Ma=R;Na=S;Oa=P/R}else{if(P==0.0){Ma=R;Na=S;Oa=P;break}z=P/+xH(c[d+536>>2]|0,R,10216,9768,+h[Q>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Ma=+h[v+18656>>3];Na=v;Oa=z}}while(0);B=K+F*+U(+Oa)+-1.0;E=+h[Na+18672>>3];do{if(Ma!=0.0){Pa=Ma;Qa=Na;Ra=A/Ma}else{if(A==0.0){Pa=Ma;Qa=Na;Ra=A;break}z=A/+xH(c[d+536>>2]|0,Ma,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Pa=+h[v+18656>>3];Qa=v;Ra=z}}while(0);z=E*Ra;v=c[c[(d+4|0)>>2]>>2]|0;y=+h[(c[v+8>>2]|0)+616>>3];do{if(Pa!=0.0){Sa=Pa;Ta=Qa;Ua=y/Pa}else{if(y==0.0){Sa=Pa;Ta=Qa;Ua=y;break}M=y/+xH(c[d+536>>2]|0,Pa,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Sa=+h[O+18656>>3];Ta=O;Ua=M}}while(0);y=+U(+Ua);E=+h[Ta+18680>>3];M=+W(+y,+(E+-1.0));do{if(Sa!=0.0){Va=Sa;Wa=Ta;Xa=D/Sa}else{if(D==0.0){Va=Sa;Wa=Ta;Xa=D;break}y=D/+xH(c[d+536>>2]|0,Sa,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;Va=+h[v+18656>>3];Wa=v;Xa=y}}while(0);y=B*(z+M*E*Xa);C=+h[Wa+18664>>3];H=+h[Wa+18672>>3];v=c[c[(d+4|0)>>2]>>2]|0;I=+h[(c[v+8>>2]|0)+616>>3];do{if(Va!=0.0){ya=+U(+(I/Va));Ya=Wa;Za=(H*ya+ +W(+ya,+(+h[Wa+18680>>3]))+1.0)/Va}else{if(I==0.0){_a=I;$a=v;ab=Va;bb=Wa;cb=I}else{ya=I/+xH(c[d+536>>2]|0,Va,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;N=c[c[(d+4|0)>>2]>>2]|0;_a=+h[(c[N+8>>2]|0)+616>>3];$a=N;ab=+h[O+18656>>3];bb=O;cb=ya}ya=H*+U(+cb);do{if(ab!=0.0){db=_a;eb=$a;fb=ab;gb=bb;hb=_a/ab}else{if(_a==0.0){db=_a;eb=$a;fb=ab;gb=bb;hb=_a;break}sa=_a/+xH(c[d+536>>2]|0,ab,10216,9768,+h[$a>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;N=c[c[(d+4|0)>>2]>>2]|0;db=+h[(c[N+8>>2]|0)+616>>3];eb=N;fb=+h[O+18656>>3];gb=O;hb=sa}}while(0);x=+U(+hb);O=ya+ +W(+x,+(+h[gb+18680>>3]))+1.0==0.0;x=+h[gb+18672>>3];N=fb!=0.0;if(O){do{if(N){ib=db;jb=eb;kb=fb;lb=gb;mb=db/fb}else{if(db==0.0){ib=db;jb=eb;kb=fb;lb=gb;mb=db;break}sa=db/+xH(c[d+536>>2]|0,fb,10216,9768,+h[eb>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;ib=+h[(c[za+8>>2]|0)+616>>3];jb=za;kb=+h[O+18656>>3];lb=O;mb=sa}}while(0);ya=x*+U(+mb);do{if(kb!=0.0){nb=lb;ob=ib/kb}else{if(ib==0.0){nb=lb;ob=ib;break}sa=ib/+xH(c[d+536>>2]|0,kb,10216,9768,+h[jb>>3],(a[d+319|0]|0)!=0|0);nb=c[(d+416|0)>>2]|0;ob=sa}}while(0);sa=+U(+ob);Ya=nb;Za=ya+ +W(+sa,+(+h[nb+18680>>3]))+1.0;break}else{do{if(N){pb=db;qb=eb;rb=fb;sb=gb;tb=db/fb}else{if(db==0.0){pb=db;qb=eb;rb=fb;sb=gb;tb=db;break}sa=db/+xH(c[d+536>>2]|0,fb,10216,9768,+h[eb>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;pb=+h[(c[za+8>>2]|0)+616>>3];qb=za;rb=+h[O+18656>>3];sb=O;tb=sa}}while(0);ya=x*+U(+tb);do{if(rb!=0.0){ub=qb;vb=rb;wb=sb;xb=pb/rb}else{if(pb==0.0){ub=qb;vb=rb;wb=sb;xb=pb;break}sa=pb/+xH(c[d+536>>2]|0,rb,10216,9768,+h[qb>>3],(a[d+319|0]|0)!=0|0);N=c[(d+416|0)>>2]|0;ub=c[c[(d+4|0)>>2]>>2]|0;vb=+h[N+18656>>3];wb=N;xb=sa}}while(0);x=+U(+xb);sa=ya+ +W(+x,+(+h[wb+18680>>3]))+1.0;x=sa/+xH(c[d+536>>2]|0,vb,10216,9768,+h[ub>>3],(a[d+319|0]|0)!=0|0);Ya=c[(d+416|0)>>2]|0;Za=x;break}}}while(0);H=+h[Ya+18648>>3];I=+h[Ya+18664>>3];E=+h[Ya+18656>>3];v=c[c[(d+4|0)>>2]>>2]|0;M=+h[(c[v+8>>2]|0)+616>>3];N=1;if(N){N=0;if(y-C*G*Za==0.0){do{if(E!=0.0){yb=E;zb=Ya;Ab=M/E}else{if(M==0.0){yb=E;zb=Ya;Ab=M;break}z=M/+xH(c[d+536>>2]|0,E,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;yb=+h[O+18656>>3];zb=O;Ab=z}}while(0);C=H+I*+U(+Ab)+-1.0;y=+h[zb+18672>>3];do{if(yb!=0.0){Bb=yb;Cb=zb;Db=A/yb}else{if(A==0.0){Bb=yb;Cb=zb;Db=A;break}z=A/+xH(c[d+536>>2]|0,yb,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Bb=+h[O+18656>>3];Cb=O;Db=z}}while(0);z=y*Db;O=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[O+8>>2]|0)+616>>3];do{if(Bb!=0.0){Eb=Bb;Fb=Cb;Gb=B/Bb}else{if(B==0.0){Eb=Bb;Fb=Cb;Gb=B;break}x=B/+xH(c[d+536>>2]|0,Bb,10216,9768,+h[O>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Eb=+h[za+18656>>3];Fb=za;Gb=x}}while(0);B=+U(+Gb);y=+h[Fb+18680>>3];x=+W(+B,+(y+-1.0));do{if(Eb!=0.0){Hb=Eb;Ib=Fb;Jb=D/Eb}else{if(D==0.0){Hb=Eb;Ib=Fb;Jb=D;break}B=D/+xH(c[d+536>>2]|0,Eb,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Hb=+h[O+18656>>3];Ib=O;Jb=B}}while(0);B=C*(z+x*y*Jb);sa=+h[Ib+18664>>3];Kb=+h[Ib+18672>>3];O=c[c[(d+4|0)>>2]>>2]|0;Lb=+h[(c[O+8>>2]|0)+616>>3];do{if(Hb!=0.0){Mb=+U(+(Lb/Hb));Nb=(Kb*Mb+ +W(+Mb,+(+h[Ib+18680>>3]))+1.0)/Hb}else{if(Lb==0.0){Ob=Lb;Pb=O;Qb=Hb;Rb=Ib;Sb=Lb}else{Mb=Lb/+xH(c[d+536>>2]|0,Hb,10216,9768,+h[O>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ob=+h[(c[Tb+8>>2]|0)+616>>3];Pb=Tb;Qb=+h[za+18656>>3];Rb=za;Sb=Mb}Mb=Kb*+U(+Sb);do{if(Qb!=0.0){Ub=Ob;Vb=Pb;Wb=Qb;Xb=Rb;Yb=Ob/Qb}else{if(Ob==0.0){Ub=Ob;Vb=Pb;Wb=Qb;Xb=Rb;Yb=Ob;break}Zb=Ob/+xH(c[d+536>>2]|0,Qb,10216,9768,+h[Pb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Ub=+h[(c[Tb+8>>2]|0)+616>>3];Vb=Tb;Wb=+h[za+18656>>3];Xb=za;Yb=Zb}}while(0);ya=+U(+Yb);za=Mb+ +W(+ya,+(+h[Xb+18680>>3]))+1.0==0.0;ya=+h[Xb+18672>>3];Tb=Wb!=0.0;if(za){do{if(Tb){_b=Ub;$b=Vb;ac=Wb;bc=Xb;cc=Ub/Wb}else{if(Ub==0.0){_b=Ub;$b=Vb;ac=Wb;bc=Xb;cc=Ub;break}Zb=Ub/+xH(c[d+536>>2]|0,Wb,10216,9768,+h[Vb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;dc=c[c[(d+4|0)>>2]>>2]|0;_b=+h[(c[dc+8>>2]|0)+616>>3];$b=dc;ac=+h[za+18656>>3];bc=za;cc=Zb}}while(0);Mb=ya*+U(+cc);do{if(ac!=0.0){ec=bc;fc=_b/ac}else{if(_b==0.0){ec=bc;fc=_b;break}Zb=_b/+xH(c[d+536>>2]|0,ac,10216,9768,+h[$b>>3],(a[d+319|0]|0)!=0|0);ec=c[(d+416|0)>>2]|0;fc=Zb}}while(0);Zb=+U(+fc);Nb=Mb+ +W(+Zb,+(+h[ec+18680>>3]))+1.0;break}else{do{if(Tb){gc=Ub;hc=Vb;ic=Wb;jc=Xb;kc=Ub/Wb}else{if(Ub==0.0){gc=Ub;hc=Vb;ic=Wb;jc=Xb;kc=Ub;break}Zb=Ub/+xH(c[d+536>>2]|0,Wb,10216,9768,+h[Vb>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;dc=c[c[(d+4|0)>>2]>>2]|0;gc=+h[(c[dc+8>>2]|0)+616>>3];hc=dc;ic=+h[za+18656>>3];jc=za;kc=Zb}}while(0);Mb=ya*+U(+kc);do{if(ic!=0.0){lc=hc;mc=ic;nc=jc;oc=gc/ic}else{if(gc==0.0){lc=hc;mc=ic;nc=jc;oc=gc;break}Zb=gc/+xH(c[d+536>>2]|0,ic,10216,9768,+h[hc>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;lc=c[c[(d+4|0)>>2]>>2]|0;mc=+h[Tb+18656>>3];nc=Tb;oc=Zb}}while(0);ya=+U(+oc);Zb=Mb+ +W(+ya,+(+h[nc+18680>>3]))+1.0;Nb=Zb/+xH(c[d+536>>2]|0,mc,10216,9768,+h[lc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=B-sa*G*Nb;break}else{N=1}}if(N){N=0;if(1){do{if(E!=0.0){pc=E;qc=Ya;rc=M/E}else{if(M==0.0){pc=E;qc=Ya;rc=M;break}Kb=M/+xH(c[d+536>>2]|0,E,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;pc=+h[O+18656>>3];qc=O;rc=Kb}}while(0);E=H+I*+U(+rc)+-1.0;M=+h[qc+18672>>3];do{if(pc!=0.0){sc=pc;tc=qc;uc=A/pc}else{if(A==0.0){sc=pc;tc=qc;uc=A;break}sa=A/+xH(c[d+536>>2]|0,pc,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;sc=+h[v+18656>>3];tc=v;uc=sa}}while(0);I=M*uc;v=c[c[(d+4|0)>>2]>>2]|0;H=+h[(c[v+8>>2]|0)+616>>3];do{if(sc!=0.0){vc=sc;wc=tc;xc=H/sc}else{if(H==0.0){vc=sc;wc=tc;xc=H;break}sa=H/+xH(c[d+536>>2]|0,sc,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;vc=+h[O+18656>>3];wc=O;xc=sa}}while(0);H=+U(+xc);M=+h[wc+18680>>3];sa=+W(+H,+(M+-1.0));do{if(vc!=0.0){yc=vc;zc=wc;Ac=D/vc}else{if(D==0.0){yc=vc;zc=wc;Ac=D;break}H=D/+xH(c[d+536>>2]|0,vc,10216,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);v=c[(d+416|0)>>2]|0;yc=+h[v+18656>>3];zc=v;Ac=H}}while(0);H=E*(I+sa*M*Ac);B=+h[zc+18664>>3];Kb=+h[zc+18672>>3];v=c[c[(d+4|0)>>2]>>2]|0;Lb=+h[(c[v+8>>2]|0)+616>>3];do{if(yc!=0.0){y=+U(+(Lb/yc));Bc=(Kb*y+ +W(+y,+(+h[zc+18680>>3]))+1.0)/yc}else{if(Lb==0.0){Cc=Lb;Dc=v;Ec=yc;Fc=zc;Gc=Lb}else{y=Lb/+xH(c[d+536>>2]|0,yc,10216,9768,+h[v>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Cc=+h[(c[Tb+8>>2]|0)+616>>3];Dc=Tb;Ec=+h[O+18656>>3];Fc=O;Gc=y}y=Kb*+U(+Gc);do{if(Ec!=0.0){Hc=Cc;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Cc/Ec}else{if(Cc==0.0){Hc=Cc;Ic=Dc;Jc=Ec;Kc=Fc;Lc=Cc;break}x=Cc/+xH(c[d+536>>2]|0,Ec,10216,9768,+h[Dc>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;Tb=c[c[(d+4|0)>>2]>>2]|0;Hc=+h[(c[Tb+8>>2]|0)+616>>3];Ic=Tb;Jc=+h[O+18656>>3];Kc=O;Lc=x}}while(0);Mb=+U(+Lc);O=y+ +W(+Mb,+(+h[Kc+18680>>3]))+1.0==0.0;Mb=+h[Kc+18672>>3];Tb=Jc!=0.0;if(O){do{if(Tb){Mc=Hc;Nc=Ic;Oc=Jc;Pc=Kc;Qc=Hc/Jc}else{if(Hc==0.0){Mc=Hc;Nc=Ic;Oc=Jc;Pc=Kc;Qc=Hc;break}x=Hc/+xH(c[d+536>>2]|0,Jc,10216,9768,+h[Ic>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Mc=+h[(c[za+8>>2]|0)+616>>3];Nc=za;Oc=+h[O+18656>>3];Pc=O;Qc=x}}while(0);y=Mb*+U(+Qc);do{if(Oc!=0.0){Rc=Pc;Sc=Mc/Oc}else{if(Mc==0.0){Rc=Pc;Sc=Mc;break}x=Mc/+xH(c[d+536>>2]|0,Oc,10216,9768,+h[Nc>>3],(a[d+319|0]|0)!=0|0);Rc=c[(d+416|0)>>2]|0;Sc=x}}while(0);x=+U(+Sc);Bc=y+ +W(+x,+(+h[Rc+18680>>3]))+1.0;break}else{do{if(Tb){Tc=Hc;Uc=Ic;Vc=Jc;Wc=Kc;Xc=Hc/Jc}else{if(Hc==0.0){Tc=Hc;Uc=Ic;Vc=Jc;Wc=Kc;Xc=Hc;break}x=Hc/+xH(c[d+536>>2]|0,Jc,10216,9768,+h[Ic>>3],(a[d+319|0]|0)!=0|0);O=c[(d+416|0)>>2]|0;za=c[c[(d+4|0)>>2]>>2]|0;Tc=+h[(c[za+8>>2]|0)+616>>3];Uc=za;Vc=+h[O+18656>>3];Wc=O;Xc=x}}while(0);y=Mb*+U(+Xc);do{if(Vc!=0.0){Yc=Uc;Zc=Vc;_c=Wc;$c=Tc/Vc}else{if(Tc==0.0){Yc=Uc;Zc=Vc;_c=Wc;$c=Tc;break}x=Tc/+xH(c[d+536>>2]|0,Vc,10216,9768,+h[Uc>>3],(a[d+319|0]|0)!=0|0);Tb=c[(d+416|0)>>2]|0;Yc=c[c[(d+4|0)>>2]>>2]|0;Zc=+h[Tb+18656>>3];_c=Tb;$c=x}}while(0);Mb=+U(+$c);x=y+ +W(+Mb,+(+h[_c+18680>>3]))+1.0;Bc=x/+xH(c[d+536>>2]|0,Zc,10216,9768,+h[Yc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);La=(H-B*G*Bc)/+xH(c[d+536>>2]|0,T*T,10264,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{N=1}}}else{w=1}}}while(0);ze[J&3](20,14,La,51,e);ze[c[(e+8|0)>>2]&3](21,12,1.0,52,e);J=c[(d+416|0)>>2]|0;La=+h[J+18696>>3];T=+h[J+18704>>3];do{if(La!=0.0){ad=T/La}else{if(T==0.0){ad=T;break}ad=T/+xH(c[d+536>>2]|0,La,10552,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(!(ad>0.0)){J=c[28168]|0;Yc=c[d+536>>2]|0;h[k>>3]=ad;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];_c=b+24|0;c[_c+0>>2]=c[13104+0>>2];c[_c+4>>2]=c[13104+4>>2];c[_c+8>>2]=c[13104+8>>2];c[_c+12>>2]=c[13104+12>>2];c[_c+16>>2]=c[13104+16>>2];c[_c+20>>2]=c[13104+20>>2];Pe[J&31](Yc,b+24|0,10592,u);}u=c[(e+8|0)>>2]|0;La=+da(+ad);ad=+h[(c[(d+416|0)>>2]|0)+18688>>3];do{if(La!=0.0){bd=ad/La}else{if(ad==0.0){bd=ad;break}bd=ad/+xH(c[d+536>>2]|0,La,10720,9768,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[u&3](21,13,bd*-7895683520871486.0e-21,53,e);ze[c[(e+8|0)>>2]&3](22,11,1.0,54,e);u=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[u+8>>2]|0)+624>>3];if(bd!=0.0){cd=bd}else{cd=+xH(c[d+536>>2]|0,bd,10800,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}bd=1.0/cd;ze[c[(e+8|0)>>2]&3](22,12,bd*bd,55,e);ze[c[(e+8|0)>>2]&3](23,10,1.0,56,e);ze[c[(e+8|0)>>2]&3](23,11,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+696>>3],57,e);ze[c[(e+8|0)>>2]&3](23,25,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+632>>3],58,e);ze[c[(e+8|0)>>2]&3](24,9,1.0,59,e);u=c[(e+8|0)>>2]|0;Yc=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[Yc+8>>2]|0)+2952>>3];if(bd!=0.0){dd=bd}else{dd=+xH(c[d+536>>2]|0,bd,10832,9768,+h[Yc>>3],(a[d+319|0]|0)!=0|0)}ze[u&3](24,25,-1.0/dd,60,e);ze[c[(e+8|0)>>2]&3](25,8,1.0,61,e);dd=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;bd=+h[(c[u+8>>2]|0)+672>>3];do{if(dd!=0.0){ed=bd/dd}else{if(bd==0.0){ed=bd;break}ed=bd/+xH(c[d+536>>2]|0,dd,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(ed>0.0){f=1.0}else{ed=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;dd=+h[(c[u+8>>2]|0)+672>>3];do{if(ed!=0.0){fd=dd/ed}else{if(dd==0.0){fd=dd;break}fd=dd/+xH(c[d+536>>2]|0,ed,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);f=+(fd<0.0|0)}fd=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;ed=+h[(c[u+8>>2]|0)+672>>3];do{if(fd!=0.0){gd=ed/fd}else{if(ed==0.0){gd=ed;break}gd=ed/+xH(c[d+536>>2]|0,fd,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(gd>0.0){i=1.0}else{gd=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;fd=+h[(c[u+8>>2]|0)+672>>3];do{if(gd!=0.0){hd=fd/gd}else{if(fd==0.0){hd=fd;break}hd=fd/+xH(c[d+536>>2]|0,gd,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);i=+(hd<0.0|0)}hd=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;gd=+h[(c[u+8>>2]|0)+672>>3];do{if(hd!=0.0){id=gd/hd}else{if(gd==0.0){id=gd;break}id=gd/+xH(c[d+536>>2]|0,hd,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(id>0.0){j=1.0}else{id=+h[(c[(d+416|0)>>2]|0)+18584>>3];u=c[c[(d+4|0)>>2]>>2]|0;hd=+h[(c[u+8>>2]|0)+672>>3];do{if(id!=0.0){jd=hd/id}else{if(hd==0.0){jd=hd;break}jd=hd/+xH(c[d+536>>2]|0,id,10864,9768,+h[u>>3],(a[d+319|0]|0)!=0|0)}}while(0);j=+(jd<0.0|0)}u=c[(d+416|0)>>2]|0;jd=+h[u+18600>>3];id=+h[u+18584>>3];Yc=c[c[(d+4|0)>>2]>>2]|0;hd=+h[(c[Yc+8>>2]|0)+672>>3];do{if(id!=0.0){kd=hd;ld=Yc;md=id;nd=u;od=hd/id}else{if(hd==0.0){kd=hd;ld=Yc;md=id;nd=u;od=hd;break}gd=hd/+xH(c[d+536>>2]|0,id,10864,9768,+h[Yc>>3],(a[d+319|0]|0)!=0|0);J=c[(d+416|0)>>2]|0;_c=c[c[(d+4|0)>>2]>>2]|0;kd=+h[(c[_c+8>>2]|0)+672>>3];ld=_c;md=+h[J+18584>>3];nd=J;od=gd}}while(0);id=jd*+U(+od);do{if(md!=0.0){l=kd;m=ld;n=md;o=nd;pd=kd/md}else{if(kd==0.0){l=kd;m=ld;n=md;o=nd;pd=kd;break}od=kd/+xH(c[d+536>>2]|0,md,10864,9768,+h[ld>>3],(a[d+319|0]|0)!=0|0);Yc=c[(d+416|0)>>2]|0;u=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[u+8>>2]|0)+672>>3];m=u;n=+h[Yc+18584>>3];o=Yc;pd=od}}while(0);md=+U(+pd);p=id+ +W(+md,+(+h[o+18608>>3]))+1.0;q=c[(e+8|0)>>2]|0;r=+h[o+18576>>3];s=+h[o+18592>>3];t=n!=0.0;g[b+6160>>2]=f;g[b+6248>>2]=i;g[b+6336>>2]=j;g[b+6456>>2]=l;c[b+6464>>2]=m;g[b+6472>>2]=n;c[b+6480>>2]=o;g[b+6504>>2]=p;c[b+6512>>2]=q;g[b+6520>>2]=r;g[b+6528>>2]=s;c[b+6536>>2]=t}



function PH(){var a=0,b=0,d=0,e=0;a=i;b=c[16120]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;caa(c[b>>2]|0);caa(b);if((d|0)==0){break}else{b=d}}e=c[16120]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function QH(a){a=a|0;var b=0,d=0;b=i;d=pe[c[64440>>2]&127](a<<3)|0;i=b;return d|0}function RH(a){a=a|0;var b=0,d=0;b=i;d=pe[c[64440>>2]&127](a<<2)|0;i=b;return d|0}function SH(a){a=a|0;var b=0,d=0;b=i;d=pe[c[64440>>2]&127](a<<2)|0;i=b;return d|0}function TH(a){a=a|0;i=i;return a+7&-8|0}function UH(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[16120]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=baa(16)|0;c[f+12>>2]=d;c[16120]=f;c[f+4>>2]=0;d=VH((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=baa(d)|0;c[f>>2]=a;i=b;return}function VH(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function WH(a){a=a|0;var b=0,c=0;b=i;c=Faa(a|0)|0;i=b;return c|0}function XH(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;Laa(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];lc(m|0,l|0,f|0)|0;f=YH(m)|0;i=e;return f|0}function YH(a){a=a|0;var b=0,c=0,d=0;b=i;c=Faa(a|0)|0;d=_H(c)|0;Haa(d|0,a|0,c|0)|0;i=b;return d|0}function ZH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;Laa(g+1|0,d|0)|0;c[f>>2]=b;lc(k|0,j|0,f|0)|0;f=YH(k)|0;i=e;return f|0}function _H(b){b=b|0;var d=0,e=0;d=i;e=pe[c[64444>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function $H(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=WH(a)|0;e=WH(b)|0;f=_H(e+d|0)|0;Haa(f|0,a|0,d|0)|0;Haa(f+d|0,b|0,e|0)|0;i=c;return f|0}function aI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Baa(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function bI(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 4:{f=2;break a;break};case 0:{f=8;break a;break};case 3:{f=2;break a;break};case 2:{f=4;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function cI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){cd(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){caa(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{caa(c[(c[f>>2]|0)+(g<<4)>>2]|0);caa(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;caa(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){caa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{caa(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}caa(d);c[g>>2]=0;i=b;return}function dI(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(Faa(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function eI(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=mc(b|0,64672)|0;m=d;c[m>>2]=l;if((l|0)==0){n=be(c[(Sc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Fd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=64680;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[64648+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=64704;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=64728;E=131;break}G=bI(D)|0;if((G|0)==-1){n=64760;E=131;break}D=c[q>>2]|0;H=baa(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=64808;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=64832;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((Baa(H,c[64624+(C<<2)>>2]|0)|0)!=0){n=64856;E=131;break}caa(H);H=65432;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=baa(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((sb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=65056;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=baa(G+1|0)|0;if((sb(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=baa(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}caa(N);M=0;E=130;break};case 0:{if((D|0)!=4){n=64880;E=131;break a}if((I|0)!=11){n=64920;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){Q=0}else{n=64960;E=131;break a}while(1){L=0;do{a[k+L|0]=a[j+((L<<2)+Q)|0]|0;L=L+1|0;}while(L>>>0<11);a[k+11|0]=0;if((Q|0)==3){break}L=Q+1|0;if(L>>>0<4){Q=L}else{M=d;E=130;break b}}if((Caa(t,c[16132]|0,8)|0)==0){M=1;E=130;break b}if((Caa(t,c[16138]|0,9)|0)==0){M=0;E=130}else{n=64992;E=131;break a}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=65120;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=65176;E=131;break a}c[w>>2]=D;L=fa(I,D)|0;if((a[l]|0)==1){F=baa(L<<3)|0;c[x>>2]=F;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=65216;E=131;break a}}else{F=baa(L<<2)|0;c[x>>2]=baa(fa(D<<3,I)|0)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=65216;E=131;break a}if((L|0)!=0){G=c[x>>2]|0;O=0;do{h[G+(O<<3)>>3]=+g[F+(O<<2)>>2];O=O+1|0;}while(O>>>0<L>>>0)}caa(F)}L=c[w>>2]|0;if(!(L>>>0>1)){M=1;E=130;break b}O=(I|0)==2;G=1;while(1){if(O){P=c[x>>2]|0;if(+h[P+(G<<3)>>3]!=+h[P+(L+G<<3)>>3]){n=65248;E=131;break a}}P=G+1|0;if(P>>>0<L>>>0){G=P}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=65120;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=65328;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){L=baa(G<<3)|0;c[x>>2]=baa(fa(D<<3,I)|0)|0;if((sb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=65216;E=131;break a}if((D|0)!=0){O=0;do{F=c[x>>2]|0;P=0;do{h[F+((fa(I,O)|0)+P<<3)>>3]=+h[L+((fa(D,P)|0)+O<<3)>>3];P=P+1|0;}while(P>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}caa(L)}else{O=baa(G<<2)|0;c[x>>2]=baa(fa(D<<3,I)|0)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=65216;E=131;break a}if((D|0)!=0){P=0;do{F=c[x>>2]|0;R=0;do{h[F+((fa(I,P)|0)+R<<3)>>3]=+g[O+((fa(D,R)|0)+P<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);P=P+1|0;}while(P>>>0<D>>>0)}caa(O)}P=c[w>>2]|0;if(!(P>>>0>1)){M=d;E=130;break b}G=(D|0)==2;L=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(L<<3)>>3]!=+h[R+(P+L<<3)>>3]){n=65248;E=131;break a}}R=L+1|0;if(R>>>0<P>>>0){L=R}else{M=d;E=130;break}}break};case 3:{L=fa(I<<2,D)|0;S=baa(L)|0;if((sb(S|0,L|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}L=c[v>>2]|0;P=0;do{c[L+(P<<4)+8>>2]=(c[S+(P<<2)>>2]|0)==1;c[L+(P<<4)+12>>2]=c[S+(D+P<<2)>>2];P=P+1|0;}while(P>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}P=c[v>>2]|0;L=0;do{G=fa(D,L)|0;c[P+(L<<4)+8>>2]=(c[S+(G<<2)>>2]|0)==1;c[P+(L<<4)+12>>2]=c[S+(G+1<<2)>>2];L=L+1|0;}while(L>>>0<I>>>0)}}while(0);caa(S);fc(c[v>>2]|0,c[u>>2]|0,16,55);M=d;E=130;break};case 1:{L=d<<24>>24==0;c[u>>2]=L?D:I;P=baa((L?D:I)<<4)|0;c[v>>2]=P;c:do{if(d<<24>>24==1){if((I|0)==0){T=0;break}G=D+1|0;O=P;R=0;while(1){c[O+(R<<4)>>2]=baa(G)|0;if((sb(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=65056;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;F=c[v>>2]|0;c[F+(R<<4)+8>>2]=-1;c[F+(R<<4)+12>>2]=-1;dI(c[F+(R<<4)>>2]|0);F=R+1|0;if(!(F>>>0<I>>>0)){T=I;break c}O=c[v>>2]|0;R=F}}else{T=I}}while(0);if(!L){M=d;E=130;break b}P=fa(D,T)|0;U=baa(P+1|0)|0;if((sb(U|0,P|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){P=T+1|0;R=(T|0)==0;O=0;do{G=baa(P)|0;c[(c[v>>2]|0)+(O<<4)>>2]=G;if(!R){G=0;do{F=a[U+((fa(D,G)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<T>>>0)}a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+T|0]=0;G=c[v>>2]|0;c[G+(O<<4)+8>>2]=-1;c[G+(O<<4)+12>>2]=-1;dI(c[G+(O<<4)>>2]|0);O=O+1|0;}while(O>>>0<D>>>0)}caa(U);M=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=65368;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=daa(c[z>>2]<<1,4)|0;if(($c(c[m>>2]|0,J|0,1)|0)==-1){n=65400;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=65368;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=daa(c[z>>2]<<1,4)|0;O=fa(I,D)|0;if((a[l]|0)==1){R=baa(O<<3)|0;if((sb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=65400;E=131;break a}if((I|0)!=0){P=D<<3;L=(D|0)==0;G=D<<3;F=0;do{V=baa(P)|0;c[(c[B>>2]|0)+(F<<2)>>2]=V;if(!L){V=R+(fa(G,F)|0)|0;Haa(c[(c[B>>2]|0)+(F<<2)>>2]|0,V|0,G|0)|0}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;G=F<<1;if(F>>>0<G>>>0){L=D<<3;P=(D|0)==0;V=F;do{W=baa(L)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!P){W=c[B>>2]|0;X=c[W+(V-F<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<G>>>0)}caa(R)}else{G=baa(O<<2)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=65400;E=131;break a}if((I|0)!=0){V=D<<3;F=(D|0)==0;P=0;do{L=baa(V)|0;c[(c[B>>2]|0)+(P<<2)>>2]=L;if(!F){L=c[(c[B>>2]|0)+(P<<2)>>2]|0;W=0;do{h[L+(W<<3)>>3]=+g[G+((fa(D,P)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;F=P<<1;if(P>>>0<F>>>0){V=D<<3;O=(D|0)==0;R=P;do{W=baa(V)|0;c[(c[B>>2]|0)+(R<<2)>>2]=W;if(!O){W=c[B>>2]|0;L=c[W+(R-P<<2)>>2]|0;X=c[W+(R<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[L+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}R=R+1|0;}while(R>>>0<F>>>0)}caa(G)}if(($c(c[m>>2]|0,J|0,1)|0)==-1){n=65400;E=131;break a}else{M=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){caa(U);n=65056;i=e;return n|0}else if((E|0)==46){caa(N);n=65056;i=e;return n|0}else if((E|0)==52){caa(S);n=65088;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function fI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Kd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,55)|0;i=d;return b|0}function gI(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=65472;o=n;p=65520;q=p;r=65544;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=65472;o=n;p=65520;q=p;r=65544;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=baa(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){$c(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}caa(r);t=0;i=e;return t|0}else{k=baa(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){$c(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}caa(k);caa(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);caa(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function hI(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=65472;r=q;s=65520;t=s;u=65568;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=65472;r=q;s=65520;t=s;u=65568;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){$c(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{$c(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function iI(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function jI(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function kI(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function lI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+kI(b)<e){q=1;i=f;return q|0}if(+jI(b)>e){q=1;i=f;return q|0}if((gI(b,1)|0)==0){q=1;i=f;return q|0}iI(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+hI(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+hI(a,b,d,o);i=f;return q|0}if(+hI(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+hI(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function mI(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function nI(a,b){a=a|0;b=b|0;var c=0;c=i;fH(a,b,QH(b)|0);i=c;return}function oI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=QH(gH(a,b,f)|0)|0;i=e;return}function pI(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function qI(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;pI(c[d+8>>2]|0,b,a);i=e;return}function rI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0;f=i;i=i+24|0;g=f;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=baa(b<<2)|0;n=m;if((m|0)==0){cb(65624,65600,617,65632)}o=l;c[l>>2]=e;c[m>>2]=d;if((b|0)>1){e=1;do{l=c[o>>2]|0;p=c[l>>2]|0;c[o>>2]=l+4;c[m+(e<<2)>>2]=p;e=e+1|0;}while((e|0)<(b|0))}dH(n,b);n=c[d>>2]|0;if((n|0)==4){e=c[d+4>>2]|0;o=c[e>>2]|0;p=c[e+4>>2]|0;l=c[e+8>>2]|0;q=c[e+12>>2]|0;c[g>>2]=b;c[g+4>>2]=o;c[g+8>>2]=p;c[g+12>>2]=l;c[g+16>>2]=q;oI(a,5,g)}else if((n|0)==3){g=c[d+4>>2]|0;q=c[g>>2]|0;l=c[g+4>>2]|0;p=c[g+8>>2]|0;c[h>>2]=b;c[h+4>>2]=q;c[h+8>>2]=l;c[h+12>>2]=p;oI(a,4,h)}else if((n|0)==1){h=c[c[d+4>>2]>>2]|0;c[k>>2]=b;c[k+4>>2]=h;oI(a,2,k)}else if((n|0)==2){n=c[d+4>>2]|0;d=c[n>>2]|0;k=c[n+4>>2]|0;c[j>>2]=b;c[j+4>>2]=d;c[j+8>>2]=k;oI(a,3,j)}else{cb(65656,65600,639,65632)}if((b|0)<=0){caa(m);i=f;return}j=a+8|0;a=0;k=0;while(1){d=m+(k<<2)|0;n=eH(c[d>>2]|0)|0;if((n|0)>0){h=a;p=0;while(1){r=+mI(c[d>>2]|0,p);pI(c[j>>2]|0,h,r);l=p+1|0;if((l|0)<(n|0)){p=l;h=h+1|0}else{break}}s=n+a|0}else{s=a}h=k+1|0;if((h|0)<(b|0)){a=s;k=h}else{break}}caa(m);i=f;return}function sI(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;nI(a,b);j=g;c[g>>2]=e;qI(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;qI(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function tI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=baa(20)|0;uH(0,(f|0)!=0|0,65696,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=daa(e,b)|0;c[f>>2]=a;uH(0,(a|0)!=0|0,65696,d);i=d;return f|0}function uI(a){a=a|0;var b=0;b=i;caa(c[a>>2]|0);caa(a);i=b;return}function vI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;uH(0,(c[h>>2]|0)>0|0,65712,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;uH(0,(g|0)>(b|0)|0,65736,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;uH(0,(0-f|0)<(b|0)|0,65736,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function wI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=daa(c[d>>2]<<1,c[e>>2]|0)|0;uH(0,(f|0)!=0|0,65696,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=vI(a,j)|0;h=c[e>>2]|0;Haa(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;caa(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function xI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){wI(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;Haa((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function yI(a){a=a|0;i=i;return c[a+12>>2]|0}function zI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;uH(0,(c[j>>2]|0)>0|0,65712,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;uH(0,(h|0)>(b|0)|0,65736,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;uH(0,b>>>31^1,65736,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=vI(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function AI(a){a=a|0;i=i;return c[(c[16442]|0)+(a<<2)>>2]|0}function BI(a){a=a|0;i=i;return c[(c[16444]|0)+(a<<2)>>2]|0}function CI(a){a=a|0;i=i;return c[(c[16446]|0)+(a<<2)>>2]|0}function DI(a){a=a|0;i=i;return c[(c[16448]|0)+(a<<2)>>2]|0}function EI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[16444]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[16446]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[16442]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function FI(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16450]|0;e=+GI(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function GI(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function HI(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16452]|0;e=+GI(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function II(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16454]|0;e=+GI(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function JI(a){a=a|0;i=i;return 0}function KI(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[16456]|0)+(a<<3)|0)|0;d=(c[16442]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function LI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[16450]|0;f=e+(a<<3)|0;g=c[16454]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[16448]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[16442]|0)+(a<<2)>>2]|0);e=c[16452]|0;g=e+(a<<3)|0;MI(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;EI(a);d=c[16450]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[16442]|0)+(a<<2)>>2]=0;i=b;return}function MI(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(PI(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function NI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[16456]|0;f=c[16450]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function OI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=daa(a,8)|0;c[16450]=d;e=daa(a,8)|0;c[16452]=e;f=daa(a,8)|0;c[16454]=f;g=daa(a,8)|0;c[16456]=g;h=daa(a,4)|0;c[16442]=h;j=daa(a,4)|0;c[16448]=j;k=a<<2;l=baa(k)|0;c[16444]=l;m=daa(a,4)|0;c[16446]=m;Jaa(l|0,-1,k|0)|0;if((d|0)==0){cb(65832,65848,393,65864)}if((e|0)==0){cb(65872,65848,394,65864)}if((f|0)==0){cb(65888,65848,395,65864)}if((g|0)==0){cb(65904,65848,396,65864)}if((h|0)==0){cb(65920,65848,397,65864)}if((l|0)==0){cb(65944,65848,398,65864)}if((m|0)==0){cb(65968,65848,399,65864)}if((j|0)==0){cb(65992,65848,400,65864)}else{i=b;return}}function PI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function QI(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function RI(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sH(17,0,o,67776,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];sH(17,0,o,67624,m);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];m=l+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];sH(17,0,o,67672,l);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];l=g+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];sH(17,0,o,67872,g);i=e;return}else{g=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=g;g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sH(17,0,o,67936,f);i=e;return}}function SI(a){a=a|0;var b=0;b=i;caa(c[a+12>>2]|0);caa(c[a+4>>2]|0);caa(c[a+8>>2]|0);i=b;return}function TI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;UI(a,e);i=d;return}function UI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[t>>2]|0;Ic(e|0,a|0,b|0)|0;zd(e|0)|0;i=d;return}function VI(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Qd(a|0,d|0)|0;zd(d|0)|0;me[c[28172]&255](0);i=b;return}function WI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[r>>2]|0;Ic(e|0,a|0,b|0)|0;zd(e|0)|0;me[c[28172]&255](0);i=d;return}function XI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;WI(a,e);i=d;return}function YI(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[9095]=.5;h[9081]=1.0;h[9118]=.25;h[9093]=2.0;h[9120]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[18198]=A;B=c[d>>2]|0;c[18128]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[18128]=D;if((C|0)<(B|0)){C=D}else{break}}}c[18126]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[9096]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[9096]=F;G=F}else{G=E}D=c[d>>2]|0;c[18128]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[18128]=I;if((H|0)>=(D|0)){break a}E=+h[9096];H=I}}}while(0);D=C+1|0;c[18126]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[9100]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[9065]=0.0;h[9067]=0.0;h[9071]=0.0;h[9128]=0.0;c[18124]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[9065]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[9067]+ +h[B>>3]*F;h[9067]=E;F=+h[I>>3];M=+h[9071]+F*F;h[9071]=M;F=+h[H>>3];h[9128]=+h[9128]+F*F;H=A+1|0;c[18124]=H;F=+h[9065];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[18194]=A;E=G/J;h[9117]=E;C=c[d>>2]|0;c[18128]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[9125]=0.0;h[9127]=0.0;I=c[b>>2]|0;c[18124]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[9094]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[9125]=ba;ca=E+aa*aa;h[9127]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[18124]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[18194]=A;h[9117]=E;h[9067]=Z;h[9071]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[18128]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[18124]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[18124]=A+1;da=+h[9067];ea=+h[9071];ga=+h[9065]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[9116]=K;c[18222]=0;h[9124]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[18222]=C;K=+h[9081]/+V(+ga);h[9096]=K;h[9119]=0.0;h[9121]=0.0;B=c[b>>2]|0;c[18124]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[9119]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[9119]=oa;pa=+h[9121]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[9121]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[9067];L=+h[9065];N=+h[9096];D=D+1|0;la=ma}c[18124]=B+1;ia=+h[9065];ja=pa;ka=oa}N=+h[9095];L=ka*N*ka;h[9112]=L;J=ja*N*ja;h[9113]=J;h[9072]=J+(L+ia*(+h[9128]+ia*N));N=+h[9093];h[72584>>3]=N*ka*ia;h[72592>>3]=N*ja*ia;h[72600>>3]=L-J;h[72608>>3]=ka*ja;la=72616|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[18124]=10;la=c[d>>2]|0;c[18128]=1;if((la|0)>=1){D=1;while(1){h[9112]=0.0;h[9113]=0.0;h[9114]=0.0;A=c[b>>2]|0;c[18124]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[9112]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[9113]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[9114]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[18124]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[9118]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[9112]*+h[9114];h[t+(U+D<<3)>>3]=+h[9113]*+h[9114];J=+h[9112];L=+h[9113];h[t+(P+D<<3)>>3]=+h[9118]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[9095]*+h[9112]*+h[9113];na=D+1|0;c[18128]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[18124]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[18136]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[18124]=B;if((la|0)<(D|0)){la=B}else{break}}}c[18132]=1;la=1;do{D=c[d>>2]|0;c[18140]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[18140]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[18128]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[18128]=D+1}na=c[18198]|0;c[18126]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[9092]=0.0;ma=c[d>>2]|0;c[18128]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[9092]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[18128]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[9092]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[18128]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[9092];Ca=Ca+1|0}c[18128]=ta+1}Ca=B+1|0;c[18126]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[18128]=1;if((A|0)<1){break}else{Ea=1}while(1){h[9092]=0.0;B=c[b>>2]|0;c[18126]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[9092]=N;Ca=na+1|0;c[18126]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[18128]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[18126]=1;if((A|0)>=1){ta=1;while(1){h[9092]=0.0;c[18124]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[9092]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[18124]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[18126]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[18132]=la;}while((la|0)<6);la=c[l>>2]|0;c[18128]=1;h[9092]=0.0;c[18124]=1;L=+h[9095];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[72656+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[72656+(A+ -1<<3)>>3]+L;h[9092]=L;A=A+1|0;}while((A|0)<6);h[9072]=+h[9072]- +h[9082]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[9112]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[9113]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[9114]=O;h[72584>>3]=+h[72584>>3]-J-N*(O+K);h[72616>>3]=+h[72616>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[9112]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[9113]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[9114]=J;h[72592>>3]=+h[72592>>3]-O-N*(K-J);h[72624>>3]=+h[72624>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[9112]=J;h[72600>>3]=+h[72672>>3]+(+h[72600>>3]-J- +h[72664>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[9112]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[9113]=K;Oa=+h[9095];h[72608>>3]=+h[72608>>3]-J-K*Oa;h[72632>>3]=+h[72632>>3]- +h[72680>>3]+ +h[72688>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[9112]=K;h[72640>>3]=+h[72640>>3]-Oa*K;h[9092]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[18128]=la+1;c[18124]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[72656+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[72656+(ta+ -1<<3)>>3]+N;h[9092]=N;ta=ta+1|0;c[18124]=ta;}while((ta|0)<6);K=+h[9100];h[9102]=K*+h[9072]+ +h[9082]+N;J=+h[9093];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[9112]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[9113]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[9114]=R;T=R+(K*+h[72584>>3]+O+S);h[72824>>3]=T;O=K*+h[72616>>3]+S-R;h[72856>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[9112]=R;S=+h[I>>3]*+h[ma>>3];h[9113]=S;Z=+h[Ma>>3]*+h[Na>>3];h[9114]=Z;h[72832>>3]=K*+h[72592>>3]+R+S-Z;h[72864>>3]=K*+h[72624>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[9112]=Z;R=+h[72664>>3]+(Z+K*+h[72600>>3])- +h[72672>>3];h[72840>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[9112]=Z;h[72848>>3]=Z+K*+h[72608>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[72632>>3]+ +h[72680>>3]- +h[72688>>3];h[72872>>3]=J;h[72880>>3]=+h[9100]*+h[72640>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[9102]+T+R+O+J;h[9092]=K;h[9122]=K;h[9123]=K;c[18230]=0;J=+h[9120]/50.0;h[9096]=J;h[9082]=+h[9081];c[18124]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[72664>>3]=Z;W=+Y(+Pa);h[72672>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[72656+(Ma+ -1<<3)>>3]=Z;Q=+h[72664>>3]*G+ +h[72672>>3]*W;h[72656+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[72672>>3];ca=+h[72664>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[72816+(Ma<<3)>>3]*+h[72656+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[9123]=Ra;c[18230]=Na;h[9112]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[9113]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[18126]=10;h[9092]=Ra;h[9101]=Pa;h[9126]=O;c[18124]=50;if((Xa|0)==0){h[9112]=Ra;Ya=Ra;Za=Va}else if((Xa|0)==49){h[9113]=K;Ya=Wa;Za=K}else{Ya=Wa;Za=Va}h[9098]=0.0;if(Ya!=Za){S=Ya-Ua;h[9112]=S;T=Za-Ua;h[9113]=T;R=+h[9095]*(S-T)/(S+T);h[9098]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[9101]=R;T=+X(+R);h[72664>>3]=T;S=+Y(+R);h[72672>>3]=S;c[18126]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[72656+(Na+ -1<<3)>>3]=T;W=+h[72664>>3]*G+ +h[72672>>3]*S;h[72656+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[72672>>3];N=+h[72664>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[9123]=0.0;c[18126]=1;Na=1;do{ma=Na+ -1|0;Ma=72656+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[72576+(ma<<3)>>3]*+h[Ma>>3];h[9123]=+h[9123]+ +h[72816+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[18126]=10;Na=c[l>>2]|0;c[18128]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[72656+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[18126]=6;c[18128]=Na+1}h[9091]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[9065]=0.0;h[9112]=0.0;h[9113]=0.0;Ma=c[b>>2]|0;c[18124]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[72664>>3]*+h[la>>3]+ +h[72672>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[9065]=+h[9065]+G*G;bb=+h[9112]+ +h[la>>3]*+h[ta>>3];h[9112]=bb;G=+h[ta>>3];cb=+h[9113]+G*G;h[9113]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[18124]=Ma+1;$a=cb;ab=bb}ma=c[18222]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[9124];S=+h[9122];h[9124]=G>=S?G:S}S=+h[9123];if(!(S>=0.0)){db=-S}else{db=S}G=+h[9124];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[9124]=S;c[18124]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[9096]=N;R=+h[9091]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[9100];la=ta+1|0;c[18124]=la;if((ta|0)>=(Na|0)){break b}S=+h[9113];G=+h[9112];ta=la}}}while(0);Na=c[d>>2]|0;c[18128]=1;if((Na|0)>=1){Ma=1;while(1){h[9092]=0.0;ta=c[b>>2]|0;c[18126]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[9092]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[18126]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[9091]*+h[p+(la+ -1+Ma<<3)>>3]- +h[9100]*+h[q+(Ma+ -1<<3)>>3]);h[9096]=G;c[18124]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[9096];I=I+1|0}c[18124]=la+1}I=Ma+1|0;c[18128]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[9071]=0.0;h[9067]=0.0;Ma=c[b>>2]|0;c[18124]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[9071]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[9067]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[18124]=Ma+1;hb=kb;ib=jb}S=+h[9065];G=S*ib-hb*hb;h[9116]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[72552]=1;C=c[l>>2]|0;c[18128]=1;if((C|0)<1){lb=72648;mb=+h[9081];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[72656+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[18126]=6;c[18128]=C+1;lb=72648;mb=+h[9081];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function ZI(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[9148]=.5;h[9144]=1.0;h[9160]=6.283185307179586;z=+h[n>>3];h[9157]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[18302]=A;c[18310]=0;B=c[d>>2]|0;c[18262]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[18262]=B+1}c[18260]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[9149]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[9149]=F;G=F}else{G=z}H=c[d>>2]|0;c[18262]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[9149];I=I+1|0}c[18262]=H+1}I=B+1|0;c[18260]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[9132]=0.0;D=c[b>>2]|0;c[18258]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[9132]=+h[9132]+G*G;A=p+1|0;c[18258]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[18262]=1;if((p|0)>=1){D=1;while(1){h[9149]=0.0;h[9147]=0.0;y=c[b>>2]|0;c[18260]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[9149]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[9147]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[18260]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[9149]=G;h[9147]=+h[g>>3]*L;g=c[b>>2]|0;c[18258]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[9147]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[9149];H=H+1|0}c[18258]=g+1}H=D+1|0;c[18262]=H;if((D|0)<(p|0)){D=H}else{break}}}h[9133]=0.0;h[9135]=0.0;h[9142]=0.0;D=c[b>>2]|0;c[18258]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[9133]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[9135]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[9142]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[18258]=D+1;O=R;P=T;Q=S}S=+h[9132];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[9153]=U;h[9149]=0.0;if(Q*Q>S*.99*O){h[9149]=+h[9144]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[9148]*U*Z);h[9145]=P;if(O*+h[9157]<P*P*.01){h[9149]=+h[9144]}n=c[b>>2]|0;c[18258]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[9153]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[9149]*U;if((D|0)>=(n|0)){break}e=D;P=+h[9153];D=D+1|0;p=e}c[18258]=n+1;_=0}while(1){n=_+1|0;c[18310]=n;h[9132]=0.0;h[9135]=0.0;h[9136]=0.0;p=c[b>>2]|0;c[18258]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[9132]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[9135]=da;Z=+h[H>>3];ea=P+Z*Z;h[9136]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[18258]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[9149]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[9154]=U;D=c[b>>2]|0;c[18258]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[9154];U=+h[9135];O=+h[9132];g=g+1|0;H=e}c[18258]=D+1}H=c[d>>2]|0;c[18262]=1;if((H|0)>=1){g=1;while(1){h[9147]=0.0;p=c[b>>2]|0;c[18260]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[9147]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[18260]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[9147]=O;e=c[b>>2]|0;c[18258]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[9147];l=l+1|0}c[18258]=e+1}l=g+1|0;c[18262]=l;if((g|0)<(H|0)){g=l}else{break}}}h[9137]=0.0;h[9138]=0.0;h[9139]=0.0;h[9140]=0.0;h[9141]=0.0;g=c[b>>2]|0;c[18258]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[9137]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[9138]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[9139]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[9140]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[9141]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[18258]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[9148];O=U*na;h[9137]=O;P=U*ma-O;h[9140]=P;Z=O+la+P;h[9161]=Z;h[9163]=Z;h[9162]=Z;c[18312]=0;a[73072]=1;W=+h[9160]/50.0;h[9149]=W;c[18258]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[9163]=wa;c[18312]=p;h[9158]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[9159]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[9152]=ta;h[9143]=ua;h[9146]=va;h[9145]=wa;c[18258]=50;h[9162]=wa;if((za|0)==49){h[9159]=Z;Ba=Z}else if((za|0)==0){h[9158]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[9159]}h[9150]=0.0;S=+h[9158];if(S!=Ba){Q=S-Aa;h[9158]=Q;S=Ba-Aa;h[9159]=S;T=U*(Q-S)/(Q+S);h[9150]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[9152]=T;S=+X(+T);h[9143]=S;Q=+Y(+T);h[9146]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[9145]=T;p=c[b>>2]|0;c[18258]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[9143]*+h[y>>3]+ +h[9146]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[9146];Q=+h[9143];H=H+1|0;g=e}c[18258]=p+1;Da=+h[9145]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[9161];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function _I(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[73528]=1;a[73520]=1;c[73540>>2]=6;G_(73536)|0;e=c[d>>2]|0;c[18378]=1;if((e|0)>=1){d=1;do{XZ(73656,b+(d+ -1)|0,1)|0;o=c[18378]|0;d=o+1|0;c[18378]=d;}while((o|0)<(e|0))}o_()|0;e=c[g>>2]|0;if((e|0)==1){c[73564>>2]=a[73520]&1?6:0;G_(73560)|0;XZ(73656,h,4)|0;o_()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[73588>>2]=a[73520]&1?6:0;G_(73584)|0;XZ(73656,h,4)|0;XZ(73656,j,4)|0;o_()|0}j=c[k>>2]|0;if((j|0)==1){c[73612>>2]=a[73520]&1?6:0;G_(73608)|0;XZ(73656,l,8)|0;o_()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[73636>>2]=a[73520]&1?6:0;G_(73632)|0;XZ(73656,l,8)|0;XZ(73656,m,8)|0;o_()|0}if((c[f>>2]|0)==2){FZ(73664,0)|0}else{i=n;return 0}return 0}function $I(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[18420]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[18420]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){MZ(73736,75432,80,25);B=74040;C=74048;_I(73736,75464,74216,B,74120,d,B,B,C,C,80)|0;break}c[18484]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[18484]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}MZ(73736,75472,80,34);B=74040;F=74048;_I(73736,75512,74208,B,74120,73936,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[18470]=B;c[18482]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){MZ(73736,76296,80,52);I=74040;J=74048;_I(73736,76280,76352,I,74120,G,I,I,J,J,80)|0;break a}c[18470]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[18482]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[18470]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[18482]=F+(c[18470]|0);break b}}}while(0);MZ(73736,76224,80,52);B=74040;F=74048;_I(73736,76280,76288,B,74120,q,B,B,F,F,80)|0;break a}}while(0);c[18474]=(c[d>>2]|0)+20;c[q+64>>2]=c[18470];if((c[p>>2]|0)<(c[18482]|0)){MZ(73736,75520,80,60);C=74040;F=74048;_I(73736,75584,75592,C,74216,73928,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[18474]|0)){MZ(73736,75600,80,60);F=74040;C=74048;_I(73736,75584,75664,F,74216,73896,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){MZ(73736,76408,80,24);C=74120;F=74040;B=74048;_I(73736,76440,76448,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[9232]=K;if(!(K<=0.0)){break}MZ(73736,75904,80,28);B=74040;_I(73736,74616,75936,B,B,B,B,74120,73856,74048,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){MZ(73736,73968,80,49);B=74040;F=74048;_I(73736,74024,74032,B,B,B,B,B,F,F,80)|0;MZ(73736,74056,80,47);F=74040;B=74048;_I(73736,74104,74112,F,74120,n,F,F,B,B,80)|0;MZ(73736,74128,80,41);B=74040;F=74048;_I(73736,74176,74184,74120,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[73912]=0;K=+h[l>>3];h[9243]=K;L=+h[m>>3];h[9236]=L;A=c[d>>2]|0;c[18420]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[9243]=O;P=+h[m+(F<<3)>>3];h[9236]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[73912]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[18420]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[18430]=p;r=p+(c[w>>2]|0)|0;c[18432]=r;p=r+(c[w>>2]|0)|0;c[18454]=p;F=p+(c[w>>2]|0)|0;c[18424]=F;B=F+(c[d>>2]|0)|0;c[18460]=B;C=B+(c[d>>2]|0)|0;c[18466]=C;c[18456]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[18480]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[9245]=+h[B>>3];a[73848]=0;h[9214]=+h[o+24>>3];J=o+16|0;h[9209]=+h[J>>3];do{if((c[w>>2]|0)!=0){aJ(74216,v,w,d,73712,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,73832,B,0,o,q,s,t)|0;if((c[18550]|0)>0){i=y;return 0}if((c[18458]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=74120;xJ(d,o+((c[18424]|0)+ -1<<3)|0,G,g,G)|0;a[73848]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[9209];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[9209]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[9209];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[9244]=O;U=+h[9214];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[18466]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){fJ(73712,j,f,g,d,H,I,X)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73848]=1;D=197;break d}}else{Y=73712;fJ(Y,Y,f,g,d,H,I,X)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[9214];c[n>>2]=1;a[73848]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73848]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[9245]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[9209]=W;h[J>>3]=W;break}fJ(73712,73952,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[9244];a[73848]=1;D=197;break d}}else{W=+h[9214];if(!B){if(P*(W-N)<0.0){break}fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73848]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[18466]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){fJ(73712,j,f,g,d,G,X,I)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[73848]=1;D=197;break d}}else{H=73712;fJ(H,H,f,g,d,G,X,I)|0;if((c[18550]|0)>0){i=y;return 0}else{h[e>>3]=+h[9214];c[n>>2]=1;a[73848]=1;D=197;break d}}}}while(0);if(a[73848]&1){D=197}else{D=128}}else{h[9214]=+h[e>>3];c[n>>2]=1;cJ(d,k+4|0,l,m,f,o+((c[18460]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[18420]=1;e:do{if((B|0)>=1){J=c[18460]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[18420]=X;if((I|0)<(B|0)){I=X}else{break e}}MZ(73736,76040,80,39);I=74040;J=74048;_I(73736,75712,76080,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+jJ(74192,1);h[9245]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[9245]*4.0*(aa>=ba?aa:ba);h[9234]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){MZ(73736,76088,80,60);J=74040;_I(73736,75584,76152,J,J,J,J,74216,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[9213]=ca*.001;U=+dJ(d,g,o+((c[18460]|0)+ -1<<3)|0,s,t);if(U>.5/+h[9213]){h[9213]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+JZ(73704,z);h[9213]=U;da=U}else{U=+h[o+16>>3];h[9213]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}MZ(73736,75992,80,29);J=74040;I=74048;_I(73736,76024,76032,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[9213]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[9244]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[9213]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{eJ(73712,f,g,d,b,u,73704,o+((c[18460]|0)+ -1<<3)|0,n,s,t,o+((c[18466]|0)+ -1<<3)|0,o+400|0,o+((c[18424]|0)+ -1<<3)|0,o+((c[18456]|0)+ -1<<3)|0,q,73872,B,k+36|0,73920)|0;if((c[18550]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[9213]}h[9209]=ja;h[o+16>>3]=ja;J=c[18466]|0;X=(c[d>>2]|0)+J|0;c[18476]=X;G=c[d>>2]|0;c[18420]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[9209]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[18420]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[9209];h[o+232>>3]=+h[9209]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}aJ(74120,v,w,d,e,j,f,o+((c[18424]|0)+ -1<<3)|0,o+((c[18466]|0)+ -1<<3)|0,J,Y,o+((c[18430]|0)+ -1<<3)|0,o+((c[18432]|0)+ -1<<3)|0,o+((c[18454]|0)+ -1<<3)|0,x,73832,B,0,o,q,s,t)|0;if((c[18550]|0)>0){i=y;return 0}if((c[18458]|0)!=0){MZ(73736,76456,80,47);la=74040;ma=74048;_I(73736,74104,76504,74120,la,la,la,la,ma,ma,80)|0;MZ(73736,76512,80,38);ma=74040;la=74048;_I(73736,74264,76504,74120,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}aJ(74208,v,w,d,73712,j,f,o+((c[18424]|0)+ -1<<3)|0,o+((c[18466]|0)+ -1<<3)|0,J,Y,o+((c[18430]|0)+ -1<<3)|0,o+((c[18432]|0)+ -1<<3)|0,o+((c[18454]|0)+ -1<<3)|0,x,73832,B,0,o,q,s,t)|0;if((c[18550]|0)>0){i=y;return 0}if((c[18458]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=74120;xJ(d,o+((c[18424]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){MZ(73736,75832,80,54);p=74040;_I(73736,75888,75896,p,p,p,p,74216,73952,j,80)|0;break c}else if((D|0)==220){MZ(73736,75944,80,34);p=74040;_I(73736,75512,75984,p,p,p,p,74216,j,e,80)|0;break c}else if((D|0)==224){MZ(73736,76160,80,49);p=74040;_I(73736,74024,76216,p,p,p,p,74216,73952,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;cJ(d,oa,l,m,o+((c[18466]|0)+ -1<<3)|0,o+((c[18460]|0)+ -1<<3)|0,s,t)|0;if((c[18550]|0)>0){D=233;break}p=c[d>>2]|0;c[18420]=1;r=c[18460]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[18420]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+dJ(d,o+((c[18466]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[9245];pa=O*V;h[9211]=pa;if(!(pa<=1.0)){D=138;break}O=+h[9214];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[9234]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[9209];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[9209]=V/O}}while(0);gJ(73712,f,g,d,b,u,73672,o+((c[18460]|0)+ -1<<3)|0,k,n,s,t,o+((c[18466]|0)+ -1<<3)|0,o+400|0,o+((c[18424]|0)+ -1<<3)|0,o+((c[18456]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,73872,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,73920)|0;if((c[18550]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){aJ(74208,v,w,d,73712,j,f,o+((c[18424]|0)+ -1<<3)|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[18430]|0)+ -1<<3)|0,o+((c[18432]|0)+ -1<<3)|0,o+((c[18454]|0)+ -1<<3)|0,x,73832,o+64|0,0,o,q,s,t)|0;if((c[18550]|0)>0){D=233;break f}if((c[18458]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=74120;xJ(d,o+((c[18424]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[9214];V=+h[9209];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[9244];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[9245]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}fJ(73712,73952,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[9244];D=197;continue}if(!(U<0.0)){fJ(73712,j,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[9244];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[9245]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[9209]=U-O;D=128;continue}else{fJ(73712,73952,f,g,d,q+28|0,o+((c[18466]|0)+ -1<<3)|0,o+224|0)|0;if((c[18550]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[9244];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[9214];h[o+16>>3]=+h[9209];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[9211]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[18420]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[9211]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[9211];E=E+1|0;p=B}c[18420]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[18476]=p;switch(p|0){case 3:{MZ(73736,74536,80,38);p=74040;_I(73736,74264,74576,p,p,p,p,74120,73712,74048,80)|0;MZ(73736,74584,80,28);p=74040;E=74048;_I(73736,74616,74624,p,p,p,p,p,E,E,80)|0;break};case 6:{MZ(73736,74632,80,44);E=74040;_I(73736,74680,74688,E,E,E,E,74216,73712,73672,80)|0;MZ(73736,74696,80,57);E=74040;p=74048;_I(73736,74760,74768,E,E,E,E,E,p,p,80)|0;break};case 8:{MZ(73736,74632,80,44);p=74040;_I(73736,74680,74888,p,p,p,p,74216,73712,73672,80)|0;MZ(73736,74896,80,37);p=74040;E=74048;_I(73736,74936,74944,p,p,p,p,p,E,E,80)|0;break};case 9:{MZ(73736,74632,80,44);E=74040;_I(73736,74680,74952,E,E,E,E,74216,73712,73672,80)|0;MZ(73736,74960,80,49);E=74040;p=74048;_I(73736,74024,75016,E,E,E,E,E,p,p,80)|0;MZ(73736,75024,80,38);p=74040;E=74048;_I(73736,74264,75064,p,p,p,p,p,E,E,80)|0;break};case 10:{MZ(73736,74632,80,44);E=74040;_I(73736,74680,75072,E,E,E,E,74216,73712,73672,80)|0;MZ(73736,75080,80,45);E=74040;p=74048;_I(73736,74520,75128,E,E,E,E,E,p,p,80)|0;MZ(73736,75136,80,36);p=74040;E=74048;_I(73736,75176,75184,p,p,p,p,p,E,E,80)|0;break};case 11:{MZ(73736,75192,80,40);E=74040;_I(73736,75240,75248,E,E,E,E,74216,73712,73672,80)|0;MZ(73736,75256,80,36);E=74040;p=74048;_I(73736,75176,75296,E,E,E,E,E,p,p,80)|0;break};case 2:{MZ(73736,74352,80,47);p=74040;_I(73736,74104,74400,p,p,p,p,74120,73712,74048,80)|0;MZ(73736,74408,80,48);p=74040;E=74048;_I(73736,74336,74464,p,p,p,p,p,E,E,80)|0;MZ(73736,74472,80,45);E=74040;p=74048;_I(73736,74520,74528,E,E,E,E,E,p,p,80)|0;break};case 7:{MZ(73736,74632,80,44);p=74040;_I(73736,74680,74776,p,p,p,p,74216,73712,73672,80)|0;MZ(73736,74784,80,48);p=74040;E=74048;_I(73736,74336,74840,p,p,p,p,p,E,E,80)|0;MZ(73736,74848,80,28);E=74040;p=74048;_I(73736,74616,74880,E,E,E,E,E,p,p,80)|0;break};case 12:{MZ(73736,74632,80,44);p=74040;_I(73736,74680,75304,p,p,p,p,74216,73712,73704,80)|0;MZ(73736,75312,80,45);p=74040;E=74048;_I(73736,74520,75360,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{MZ(73736,74224,80,38);E=74040;_I(73736,74264,74272,E,E,E,E,74120,73712,74048,80)|0;MZ(73736,74280,80,48);E=74040;p=74048;_I(73736,74336,74344,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[9214];h[o+24>>3]=+h[9214];h[o+16>>3]=+h[9209];i=y;return 0}else if((D|0)==215){MZ(73736,75672,80,39);p=74040;E=74048;_I(73736,75712,75720,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){MZ(73736,75728,80,39);E=74040;p=74048;_I(73736,75712,75768,E,E,E,E,E,p,p,80)|0;break c}}}while(0);MZ(73736,75776,80,47);A=74040;p=74048;_I(73736,74104,75824,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){MZ(73736,75368,80,55);p=74040;A=74048;_I(73736,75424,74120,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){MZ(73736,76360,80,39);D=74040;_I(73736,75712,76400,D,D,D,D,74216,j,e,80)|0}if((c[k>>2]|0)==-1){MZ(73736,76552,80,46);e=74040;j=74048;_I(73736,76600,76608,e,e,e,e,e,j,j,80)|0;MZ(73736,76616,80,47);j=74040;e=74048;_I(73736,74104,76664,74120,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function aJ(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[9584]=C;c[t>>2]=0;D=c[e>>2]|0;c[19170]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[19170]|0;E=F+1|0;c[19170]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[9591]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;fJ(g,b,k,l,f,o,m,n)|0;if((c[18550]|0)>0){i=v;return 0}D=d;ie[D&7](f,b,k,e,p,y,z)|0;if((c[18550]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[76736]=0;F=c[e>>2]|0;c[19170]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[76736]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[19170]=F+1;if(!M){break}I=+JZ(76728,76672);h[9588]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[9584];do{if((H- +h[g>>3])*I<0.0){fJ(g,b,k,l,f,o,m,n)|0;if((c[18550]|0)<=0){break}i=v;return 0}else{G=+h[9588]/I;h[9589]=G;N=c[f>>2]|0;c[19170]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[9589];Q=Q+1|0}c[19170]=N+1}}while(0);ie[D&7](f,b,k,e,p,y,z)|0;if((c[18550]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[76736]=0;F=c[e>>2]|0;c[19170]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[76736]=1;V=1;W=c[19170]|0}Q=W+1|0;c[19170]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[9584];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;fJ(g,F,k,l,f,o,m,n)|0;if((c[18550]|0)>0){i=v;return 0}E=d;ie[E&7](f,F,k,e,p,y,z)|0;if((c[18550]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[76736]=0;D=c[e>>2]|0;c[19170]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[76736]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[19170]=D+1;if(!aa){i=v;return 0}I=+JZ(76728,76672);h[9588]=I;h[F>>3]=I+ +h[F>>3];I=+h[9588]/+h[9584];h[9589]=I;Q=c[f>>2]|0;c[19170]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[9589];R=R+1|0}c[19170]=Q+1}ie[E&7](f,F,k,e,p,y,z)|0;if((c[18550]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[76736]=0;R=c[e>>2]|0;c[19170]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[76736]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[19170]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[9587]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}fJ(g,76696,k,l,f,o,m,n)|0;if((c[18550]|0)<=0){break}i=v;return 0}else{h[9587]=Y;j=c[f>>2]|0;c[19170]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[19170]=j+1}}while(0);ga=d;ie[ga&7](f,76696,k,e,q,y,z)|0;if((c[18550]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[19180]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){bJ(e,76728,76720,R,76696,p,q,r,76688,s,fa,da,x,ca)|0;if((c[18550]|0)>0){ha=76;break}if((c[19180]|0)>1){ha=73;break}fJ(g,76688,k,l,f,o,m,n)|0;if((c[18550]|0)>0){ha=76;break}ie[ga&7](f,76688,k,e,r,y,z)|0;if((c[18550]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[9586];R=74120;xJ(e,r,R,p,R)|0;if((c[19180]|0)==4){i=v;return 0}fJ(g,76688,k,l,f,o,m,n)|0;if((c[18550]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function bJ(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[19196]=c[o>>2];c[o>>2]=0;h[9594]=0.0;a[76768]=0;t=c[b>>2]|0;c[19186]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+JZ(76800,j+(v<<3)|0);if(w==+JZ(76800,l+((c[19186]|0)+ -1<<3)|0)){break}y=c[19186]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[9594]){break}h[9594]=B;c[o>>2]=y}else{a[76768]=1}}while(0);v=c[19186]|0;u=v+1|0;c[19186]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[76776]=1;c[19198]=c[p>>2];h[g>>3]=+h[r>>3];t=74120;xJ(b,l,t,k,t)|0;c[p>>2]=1;a[76760]=0;C=0}else{a[76776]=0;c[o>>2]=c[19196];c[19198]=c[p>>2];if(a[76768]&1){h[g>>3]=+h[r>>3];t=74120;xJ(b,l,t,k,t)|0;a[76760]=1;C=1;break}else{t=74120;xJ(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[76760]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[76760]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=74120;xJ(b,k,t,l,t)|0;t=c[b>>2]|0;c[19186]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[19186]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+JZ(76800,j+(u<<3)|0);if(!(A!=+JZ(76800,k+((c[19186]|0)+ -1<<3)|0))){break}c[n+((c[19186]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[19186]|0;F=u+1|0;c[19186]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[9594]=0.0;a[76768]=0;t=c[b>>2]|0;c[19186]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+JZ(76800,j+(v<<3)|0);if(A==+JZ(76800,k+((c[19186]|0)+ -1<<3)|0)){break}y=c[19186]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[9594]){break}h[9594]=I;c[o>>2]=y}else{a[76768]=1}}while(0);v=c[19186]|0;u=v+1|0;c[19186]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[76776]=t&1;if(t){a[76760]=0;c[19198]=0;c[p>>2]=1;break}if(!(a[76768]&1)){t=74120;xJ(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=74120;xJ(b,k,t,l,t)|0;t=c[b>>2]|0;c[19186]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[19186]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[19186]|0}u=K+1|0;c[19186]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[19198]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function cJ(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[9603]=+h[d>>3];h[9602]=+h[e>>3];j=c[a>>2]|0;c[19202]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[9603]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[9603]=o;h[9602]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[9602];a=l+1|0;c[19202]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function dJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[9606]=0.0;e=c[a>>2]|0;c[19208]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[9606]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[19208]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[9605]=0.0;e=c[a>>2]|0;c[19208]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[9605]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[19208]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function eJ(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[19226]=0;c[19224]=0;c[19230]=0;h[9618]=+h[b>>3];h[9620]=+dJ(f,d,l,0,0);C=c[f>>2]|0;c[19214]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[19214]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[9611]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[19214]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[19214]=G+1}a[76952]=1;c[19216]=0;a[76968]=1;c[C>>2]=(c[C>>2]|0)+1;c[19234]=0;ie[B&7](b,d,e,q,76936,n,o)|0;b:do{if((c[19234]|0)<0){K=35}else{while(1){if(a[76952]&1){c[E>>2]=(c[E>>2]|0)+1;a[76952]=0;hJ(f,b,d,e,q,76888,k,76912,l,r,s,t,g,76936,v,j,n,o,x)|0;h[9610]=1.0e6;if((c[19234]|0)<0|(c[19228]|0)!=0){K=35;break b}c[19230]=0}H=c[f>>2]|0;c[19214]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[19214]=H+1}iJ(f,q,s,t)|0;I=c[f>>2]|0;c[19214]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[9611]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[19214]=I+1}N=+dJ(f,q,l,0,0);h[9622]=N;if(N<=+h[v>>3]*100.0*+h[9620]){break}J=c[19216]|0;if((J|0)>0){h[z>>3]=N/+h[9623];h[A>>3]=1.0/+(J|0);O=+HZ(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[9610]=P;Q=+h[9622];R=P}else{h[9623]=N;Q=N;R=+h[9610]}if(R*Q<=.33){break}J=c[19216]|0;H=J+1|0;c[19216]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[76952]=1}c[C>>2]=(c[C>>2]|0)+1;c[19234]=0;ie[B&7](b,d,e,q,76936,n,o)|0;if((c[19234]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[19214]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[19214]=H+1}N=+dJ(f,q,l,0,0);h[9622]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[19214]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[9611]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[19214]=J+1}}while(0);if(!(a[76968]&1)){break}H=c[f>>2]|0;c[19214]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[19214]=H+1}N=+dJ(f,r,l,0,0);h[9616]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[76968]=0}h[b>>3]=+h[9618];G=c[f>>2]|0;c[19214]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[19214]=G+1}if(a[76968]&1){I=(c[19226]|0)+1|0;c[19226]=I;N=.9/(+h[9616]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[9609]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[19228]|0)!=0){I=(c[19230]|0)+1|0;c[19230]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[19234]|0)>-2)){K=53;break}I=(c[19224]|0)+1|0;c[19224]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function fJ(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[19260]=o;p=+h[b>>3]- +h[a>>3];h[9628]=p;a=c[f>>2]|0;c[19252]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[19252]=a+1;q=+h[9628]}h[9624]=1.0;h[9625]=0.0;p=q/+h[k>>3];h[9629]=p;c[19254]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[9625]=u*t+s/+h[a>>3];p=t*s;h[9624]=p;h[9629]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[19252]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[9625]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[9624];g=g+1|0}c[19252]=a+1}g=v+1|0;c[19254]=g;if((v|0)>=(o|0)){break}r=+h[9628];s=+h[9624];t=+h[9629];u=+h[9625];v=g}i=l;return 0}



function Fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1760>>3]*1256637061435917.0e-21;k=+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,20608,20600,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}function Gs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3]*1256637061435917.0e-21;k=+h[g+1832>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,20680,20672,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}function Hs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2816>>3];k=+h[g+1592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,20752,20744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}function Is(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17776>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1584>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,20792,20784,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}function Js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2856>>3];k=+h[g+1272>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,20864,20856,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}function Ks(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18152>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1264>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,20904,20896,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}function Ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+2032>>3]- +h[b+1272>>3]- +h[b+1568>>3]- +h[b+1624>>3]- +h[b+1632>>3];i=i;return}function Ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1488>>3]=+h[b+40>>3]+ +h[(c[a+416>>2]|0)+17984>>3]*-.5;i=i;return}function Ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+1488>>3]+ +h[(c[a+416>>2]|0)+17984>>3]*-.5;i=i;return}function Os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1384>>3]=+h[b+1320>>3]- +h[(c[a+416>>2]|0)+18088>>3];i=i;return}function Ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3])|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+2|0]=f;i=d;return}function Qs(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){g=0.0;j=f;k=j+1408|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+1384>>3]- +h[e+18064>>3]));g=-(+h[e+18048>>3]*m*m);j=f;k=j+1408|0;l=k;h[l>>3]=g;i=d;return}function Rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[(c[a+416>>2]|0)+18080>>3]- +h[b+40>>3];i=i;return}function Ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3])|0;a[(c[b+352>>2]|0)+5|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function Ts(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+3|0]|0)==0){g=0.0;j=f;k=j+1464|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+1432>>3]- +h[e+18024>>3]));g=-(+h[e+18008>>3]*m*m);j=f;k=j+1464|0;l=k;h[l>>3]=g;i=d;return}function Us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+40>>3]+ +h[(c[a+416>>2]|0)+18224>>3]*.5;i=i;return}function Vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1232>>3]+ +h[(c[a+416>>2]|0)+18224>>3]*.5;i=i;return}function Ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=0.0;i=i;return}function Xs(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+1400|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18056>>3]*+h[m+32>>3];j=f;k=j+1400|0;l=k;h[l>>3]=g;i=d;return}}function Ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+2|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+1400>>3],+h[f+1408>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+1408>>3];break}k=(KK(+h[l+1400>>3],-+h[l+1408>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+1400>>3];break}else{g=l;j=-+h[l+1408>>3];break}}}while(0);h[g+1392>>3]=j;i=d;return}function Zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+1392>>3]*+h[b+32>>3];i=i;return}function _s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+1408>>3]+ +h[b+1392>>3];i=i;return}function $s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=+h[b+1512>>3]- +h[b+1424>>3];i=i;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+32>>3];i=i;return}function bt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=c[b+416>>2]|0;l=+h[k+18096>>3];m=+h[k+18120>>3];n=j*j;j=+h[g+112>>3];do{if(n!=0.0){o=g;p=j/n}else{if(j==0.0){o=g;p=j;break}q=j/+xH(c[b+536>>2]|0,n,20976,20968,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+2344>>3]=l*m*p*-1256637061435917.0e-21;i=d;return}function ct(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1344>>3];k=j*j;j=+h[g+2344>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,21016,21008,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}function dt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+18136>>3];n=+h[l+18144>>3];o=j*j;do{if(j!=0.0){p=g;q=f;r=n/j}else{if(n==0.0){p=g;q=f;r=n;break}s=n/+xH(c[b+536>>2]|0,j,17800,21056,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[c[e>>2]>>2]|0;p=c[l+8>>2]|0;q=l;r=s}}while(0);j=+h[p+112>>3];if(o*(r*3.141592653589793+1.0)!=0.0){r=+h[p+40>>3];s=+h[(c[k>>2]|0)+18144>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+xH(c[b+536>>2]|0,r,17800,21056,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=j/(o*(t*3.141592653589793+1.0));v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}if(j==0.0){u=j;v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}f=c[b+536>>2]|0;t=+h[p+40>>3];r=+h[(c[k>>2]|0)+18144>>3];do{if(t!=0.0){H=q;I=r/t}else{if(r==0.0){H=q;I=r;break}s=r/+xH(f,t,17800,21056,+h[q>>3],(a[b+319|0]|0)!=0|0);H=c[c[e>>2]>>2]|0;I=s}}while(0);u=j/+xH(f,o*(I*3.141592653589793+1.0),17824,21056,+h[H>>3],(a[b+319|0]|0)!=0|0);v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}function et(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1288>>3];k=j*j;j=+h[g+2360>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,21072,21064,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}function ft(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;YK(a,3)|0;d=a+476|0;e=c[(c[d>>2]|0)+220>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2576>>3]=+h[e>>3];h[a+2592>>3]=+h[e+8>>3];h[a+2560>>3]=+h[e+16>>3];h[a+2624>>3]=+h[e+24>>3];h[a+2568>>3]=+h[e+32>>3];h[a+2240>>3]=+h[e+40>>3];h[a+2248>>3]=+h[e+48>>3];h[a+2456>>3]=+h[e+56>>3];h[a+2256>>3]=+h[e+64>>3];h[a+2376>>3]=+h[e+72>>3];h[a+2448>>3]=+h[e+80>>3];h[a+2496>>3]=+h[e+88>>3];h[a+2520>>3]=+h[e+96>>3];h[a+96>>3]=+h[e+104>>3];h[a+2584>>3]=+h[e+112>>3];h[a+2608>>3]=+h[e+120>>3];h[a+2616>>3]=+h[e+128>>3];h[a+2232>>3]=+h[e+136>>3];h[a+2440>>3]=+h[e+144>>3];h[a+2224>>3]=+h[e+152>>3];h[a+2216>>3]=+h[e+160>>3];h[a+2432>>3]=+h[e+168>>3];h[a+2544>>3]=+h[e+176>>3];h[a+2600>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+220>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+2536>>3]=+h[e+192>>3];h[d+2528>>3]=+h[e+200>>3];i=b;return}function gt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2408>>3]=+h[b+2504>>3]+ +h[b+2600>>3];i=i;return}function ht(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2408>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,17720,21112,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}function it(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+2416>>3]+ +h[b+2544>>3];i=i;return}function jt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+2464>>3]+ +h[b+2384>>3];i=i;return}function kt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+2480>>3]+ +h[b+2392>>3];i=i;return}function lt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=+h[b+2368>>3]- +h[b+2536>>3];i=i;return}function mt(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2400>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,17552,21120,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}function nt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=+h[b+112>>3];i=i;return}function ot(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=-+h[b+112>>3];i=i;return}function pt(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+3|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+1456|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18016>>3]*+h[m+1440>>3];j=f;k=j+1456|0;l=k;h[l>>3]=g;i=d;return}}function qt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+3|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+1456>>3],+h[f+1464>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+1464>>3];break}k=(KK(+h[l+1456>>3],-+h[l+1464>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+1456>>3];break}else{g=l;j=-+h[l+1464>>3];break}}}while(0);h[g+1448>>3]=j;i=d;return}function rt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=+h[b+1448>>3]*+h[b+1440>>3];i=i;return}function st(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1480>>3]=+h[b+1464>>3]+ +h[b+1448>>3];i=i;return}function tt(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+2128>>3]=+h[d>>3];h[e+1240>>3]=+h[d+8>>3];h[e+1496>>3]=+h[d+16>>3];i=b;return}function ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+1240>>3];i=i;return}function vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=0.0;i=i;return}function wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function zt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function At(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=1.0e-13;i=i;return}function Bt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function Ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function Dt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function Et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function Ft(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function Gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function Ht(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=1.0e-13;i=i;return}function It(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=1.0e-13;i=i;return}function Jt(a){a=a|0;h[(c[a+400>>2]|0)+2648>>3]=0.0;i=i;return}function Kt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;l=HK(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=l;e=k;f=j;break}else{j=b+4|0;k=HK(+h[c[c[j>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;j=LK(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;e=k;f=g;break}else{g=b+4|0;k=LK(+h[c[c[g>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3])|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+4|0]=f;i=d;return}function Lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=c[b+424>>2]|0;if((a[j+27|0]|0)==0){h[(c[b+416>>2]|0)+19216>>3]=1.0;k=b+320|0;l=b+536|0;m=1.0}else{n=b+536|0;o=b+320|0;dj(e,c[n>>2]|0,c[c[o>>2]>>2]|0,0,a[j+28|0]|0);p=+h[e>>3];h[(c[b+416>>2]|0)+19216>>3]=p;k=o;l=n;m=p}n=b+416|0;cj(f,c[l>>2]|0,c[c[k>>2]>>2]|0,m);b=c[n>>2]|0;h[b+19200>>3]=+h[f>>3];aj(g,c[l>>2]|0,c[c[k>>2]>>2]|0,+h[b+19216>>3]);h[(c[n>>2]|0)+19208>>3]=+h[g>>3];i=d;return}function Mt(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;bj(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,+h[c[c[e>>2]>>2]>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2648>>3]=+h[d>>3];i=b;return}function Nt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,3,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[d>>3];i=b;return}function Ot(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,2,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[d>>3];i=b;return}function Pt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function Qt(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);a[d]=0;i=c;return 0}function Rt(a){a=a|0;i=i;return}function St(a){a=a|0;i=i;return 0}function Tt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[a+416>>2]|0)+17216>>3];i=i;return}function Ut(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+18440>>3];i=i;return}function Vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1384>>3]=+h[(c[a+416>>2]|0)+18040>>3];i=i;return}function Wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1432>>3]=+h[(c[a+416>>2]|0)+18e3>>3];i=i;return}function Xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+336>>3]=+h[(c[a+416>>2]|0)+18992>>3];i=i;return}function Yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+384>>3]=+h[(c[a+416>>2]|0)+18952>>3];i=i;return}function Zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;rH(9,1,21128,p);if((c[63588>>2]|0)!=0){me[c[16026]&255](9)}rH(9,1,21152,o);if((c[63588>>2]|0)!=0){me[c[16026]&255](9)}Vt(a);Wt(a);Xt(a);Yt(a);rH(9,1,21176,n);n=a+4|0;q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+1384>>3];o=a+8|0;p=c[o>>2]|0;h[p+19456>>3]=q;c[m>>2]=c[p+19380>>2];p=m+4|0;h[k>>3]=q;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rH(9,0,21200,m);q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+1432>>3];m=c[o>>2]|0;h[m+20128>>3]=q;c[l>>2]=c[m+20052>>2];m=l+4|0;h[k>>3]=q;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];rH(9,0,21200,l);q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+336>>3];l=c[o>>2]|0;h[l+4784>>3]=q;c[j>>2]=c[l+4708>>2];l=j+4|0;h[k>>3]=q;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rH(9,0,21200,j);q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+384>>3];j=c[o>>2]|0;h[j+5456>>3]=q;c[g>>2]=c[j+5380>>2];j=g+4|0;h[k>>3]=q;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rH(9,0,21200,g);if((c[63588>>2]|0)!=0){me[c[16026]&255](9)}Tt(a);Ut(a);rH(9,1,21216,f);q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+40>>3];f=c[o>>2]|0;h[f+656>>3]=q;c[e>>2]=c[f+564>>2];f=e+4|0;h[k>>3]=q;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];rH(9,0,21240,e);q=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+16>>3];n=c[o>>2]|0;h[n+320>>3]=q;c[d>>2]=c[n+228>>2];n=d+4|0;h[k>>3]=q;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(9,0,21240,d);if((c[63588>>2]|0)==0){i=b;return 0}me[c[16026]&255](9);i=b;return 0}function _t(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=1.0e-13;i=i;return}function $t(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=1.0e-13;i=i;return}function au(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function bu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function cu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function du(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function eu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function fu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function gu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=1.0e-13;i=i;return}function hu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function iu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function ju(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function ku(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function lu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=0.0;i=i;return}function mu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17016>>3]=+h[b+16992>>3];i=i;return}function nu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17024>>3]=+h[b+17e3>>3];i=i;return}function ou(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17032>>3]=+h[b+17008>>3];i=i;return}function pu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17040>>3]=+h[b+17016>>3];i=i;return}function qu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17232>>3]=+h[b+17048>>3]*.5;i=i;return}function ru(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17240>>3]=+h[b+17048>>3]*.5;i=i;return}function su(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17248>>3]=+h[b+17056>>3];i=i;return}function tu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17272>>3]=+h[b+17256>>3];i=i;return}function uu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=+h[b+17248>>3]*(+h[b+17264>>3]*(+h[b+17272>>3]- +h[b+17256>>3])+1.0);i=i;return}function vu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17280>>3]=+h[b+17056>>3];i=i;return}function wu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17304>>3]=+h[b+17288>>3];i=i;return}function xu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=+h[b+17280>>3]*(+h[b+17296>>3]*(+h[b+17304>>3]- +h[b+17288>>3])+1.0);i=i;return}function yu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17312>>3]=+h[b+17064>>3];i=i;return}function zu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17336>>3]=+h[b+17320>>3];i=i;return}function Au(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=+h[b+17312>>3]*(+h[b+17328>>3]*(+h[b+17336>>3]- +h[b+17320>>3])+1.0);i=i;return}function Bu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17344>>3]=+h[b+17064>>3];i=i;return}function Cu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17368>>3]=+h[b+17352>>3];i=i;return}function Du(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=+h[b+17344>>3]*(+h[b+17360>>3]*(+h[b+17368>>3]- +h[b+17352>>3])+1.0);i=i;return}function Eu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17376>>3]=+h[b+17072>>3];i=i;return}function Fu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17384>>3]=+h[b+17072>>3];i=i;return}function Gu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17400>>3]=+h[b+17136>>3];i=i;return}function Hu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17408>>3]=+h[b+17144>>3];i=i;return}function Iu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17416>>3]=+h[b+17152>>3];i=i;return}function Ju(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17424>>3]=+h[b+17160>>3];i=i;return}function Ku(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17432>>3]=+h[b+17168>>3];i=i;return}function Lu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17440>>3]=(+h[b+17096>>3]- +h[b+17120>>3])*.5;i=i;return}function Mu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17448>>3]=+h[b+17088>>3];i=i;return}function Nu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17456>>3]=+h[b+17080>>3];i=i;return}function Ou(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17456>>3];e=+h[b+17448>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Pu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17472>>3]=+h[b+17136>>3];i=i;return}function Qu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17480>>3]=+h[b+17144>>3];i=i;return}function Ru(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17488>>3]=+h[b+17152>>3];i=i;return}function Su(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17496>>3]=+h[b+17160>>3];i=i;return}function Tu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17504>>3]=+h[b+17168>>3];i=i;return}function Uu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17512>>3]=(+h[b+17096>>3]- +h[b+17104>>3])*.5;i=i;return}function Vu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17520>>3]=+h[b+17088>>3];i=i;return}function Wu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17528>>3]=+h[b+17080>>3];i=i;return}function Xu(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17528>>3];e=+h[b+17520>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Yu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17544>>3]=+h[b+17136>>3];i=i;return}function Zu(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17552>>3]=+h[b+17144>>3];i=i;return}function _u(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17560>>3]=+h[b+17152>>3];i=i;return}function $u(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17568>>3]=+h[b+17160>>3];i=i;return}function av(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17576>>3]=+h[b+17168>>3];i=i;return}function bv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17584>>3]=+h[b+17104>>3];i=i;return}function cv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17592>>3]=+h[b+17176>>3]+ +h[b+17128>>3];i=i;return}function dv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17600>>3]=+h[b+17088>>3];i=i;return}function ev(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=+h[b+17584>>3]*(+h[b+17600>>3]+ +h[b+17592>>3])*3.141592653589793;i=i;return}function fv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17616>>3]=+h[b+17136>>3];i=i;return}function gv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17624>>3]=+h[b+17144>>3];i=i;return}function hv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17632>>3]=+h[b+17152>>3];i=i;return}function iv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17640>>3]=+h[b+17160>>3];i=i;return}function jv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17648>>3]=+h[b+17168>>3];i=i;return}function kv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17656>>3]=+h[b+17120>>3];i=i;return}function lv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17664>>3]=+h[b+17176>>3];i=i;return}function mv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17672>>3]=+h[b+17088>>3];i=i;return}function nv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=+h[b+17656>>3]*(+h[b+17672>>3]+ +h[b+17664>>3])*3.141592653589793;i=i;return}function ov(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17688>>3]=+h[b+17136>>3];i=i;return}function pv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17696>>3]=+h[b+17144>>3];i=i;return}function qv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17704>>3]=+h[b+17152>>3];i=i;return}function rv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17712>>3]=+h[b+17160>>3];i=i;return}function sv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17720>>3]=+h[b+17168>>3];i=i;return}function tv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17112>>3];i=i;return}function uv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17176>>3];i=i;return}function vv(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17744>>3];e=+h[b+17736>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function wv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17752>>3]=(+h[b+17176>>3]+ +h[b+17128>>3]*.5)*6.283185307179586;i=i;return}function xv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=+h[(c[a+416>>2]|0)+17752>>3]*6.53451271946677e-7;i=i;return}function yv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2800>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2704|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,21264,21256,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2704|0;p=o;h[p>>3]=m;i=d;return}function zv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17760>>3]=+h[b+17176>>3]*6.283185307179586;i=i;return}function Av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;j=+h[g+17768>>3]+1.0;if(j>0.0){l=g}else{g=c[28168]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=g;g=d;o=22264;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[g+16>>2]=c[o+16>>2];c[g+20>>2]=c[o+20>>2];Pe[n&31](m,d,21304,e);l=c[f>>2]|0}p=+h[l+17760>>3]*+da(+j)*8.000000000000001e-7;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=p;i=b;return}function Bv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2808>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2696|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,21408,21400,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2696|0;p=o;h[p>>3]=m;i=d;return}function Cv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17824>>3]=+h[b+17096>>3]*.25;i=i;return}function Dv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17832>>3]=+h[b+17176>>3];i=i;return}function Ev(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17840>>3]=+h[b+17088>>3];i=i;return}function Fv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=+h[b+17824>>3]*(+h[b+17840>>3]+ +h[b+17832>>3])*3.141592653589793;i=i;return}function Gv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17832>>3];m=+h[j+17840>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,21448,21440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=22264;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,21480,f);}f=c[g>>2]|0;l=+h[f+17776>>3];m=+da(+n);n=+h[f+17824>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,21608,21440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=l*r*7895683520871486.0e-21;i=d;return}function Hv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2688>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2656|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,21696,21688,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2656|0;p=o;h[p>>3]=m;i=d;return}function Iv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17848>>3]=(+h[b+17176>>3]+ +h[b+17128>>3]*.5)*6.283185307179586;i=i;return}function Jv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=+h[(c[a+416>>2]|0)+17848>>3]*6.53451271946677e-7;i=i;return}function Kv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2824>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2680|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,21736,21728,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2680|0;p=o;h[p>>3]=m;i=d;return}function Lv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17864>>3]=+h[b+17136>>3];i=i;return}function Mv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17872>>3]=+h[b+17144>>3];i=i;return}function Nv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17880>>3]=+h[b+17152>>3];i=i;return}function Ov(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17888>>3]=+h[b+17160>>3];i=i;return}function Pv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17896>>3]=+h[b+17168>>3];i=i;return}function Qv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17904>>3]=+h[b+17096>>3]+((+h[b+17104>>3]+ +h[b+17120>>3])*-.5+((+h[b+17216>>3]+ +h[b+17208>>3])*-.5- +h[b+17112>>3]));i=i;return}function Rv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17920>>3]=+h[b+17176>>3];i=i;return}function Sv(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17920>>3];e=+h[b+17912>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Tv(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+17176>>3];h[b+17936>>3]=+h[b+17224>>3]*d*d*+h[b+17184>>3]*3.141592653589793;i=i;return}function Uv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17944>>3]=+h[b+17192>>3];i=i;return}function Vv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17952>>3]=+h[b+17200>>3];i=i;return}function Wv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17968>>3]=+h[b+17216>>3];i=i;return}function Xv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17976>>3]=+h[b+17208>>3];i=i;return}function Yv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17984>>3]=+h[b+17928>>3];i=i;return}function Zv(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17992>>3]=+h[b+17936>>3];i=i;return}function _v(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18008>>3]=+h[b+17944>>3];i=i;return}function $v(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18016>>3]=+h[b+17952>>3];i=i;return}function aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18048>>3]=+h[b+17944>>3];i=i;return}function bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18056>>3]=+h[b+17952>>3];i=i;return}function cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18080>>3]=+h[b+17968>>3];i=i;return}function dw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18088>>3]=+h[b+17976>>3];i=i;return}function ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18112>>3]=+h[b+17176>>3];i=i;return}function fw(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18112>>3];e=+h[b+18104>>3];h[b+18120>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18136>>3]=(+h[b+17176>>3]+.0015)*6.283185307179586;i=i;return}function hw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18200>>3]=+h[b+17104>>3];i=i;return}function iw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18208>>3]=+h[b+17176>>3];i=i;return}function jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18216>>3]=+h[b+17176>>3]+ +h[b+17128>>3];i=i;return}function kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=+h[b+18200>>3]*(+h[b+18216>>3]+ +h[b+18208>>3])*3.141592653589793;i=i;return}function lw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18208>>3];m=+h[j+18216>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,21776,21768,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=22264;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,21808,f);}f=c[g>>2]|0;l=+h[f+18152>>3];m=+da(+n);n=+h[f+18200>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,21936,21768,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=l*r*7895683520871486.0e-21;i=d;return}function mw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2672>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2664|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,22024,22016,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2664|0;p=o;h[p>>3]=m;i=d;return}function nw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18256>>3]=+h[b+16992>>3];i=i;return}function ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18264>>3]=+h[b+18240>>3];i=i;return}function pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18272>>3]=+h[b+18248>>3];i=i;return}function qw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18280>>3]=+h[b+18256>>3];i=i;return}function rw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18456>>3]=+h[b+18288>>3];i=i;return}function sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18480>>3]=+h[b+18464>>3];i=i;return}function tw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=+h[b+18456>>3]*(+h[b+18472>>3]*(+h[b+18480>>3]- +h[b+18464>>3])+1.0);i=i;return}function uw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18488>>3]=+h[b+18296>>3];i=i;return}function vw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18504>>3]=+h[b+18360>>3];i=i;return}function ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18512>>3]=+h[b+18368>>3];i=i;return}function xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18520>>3]=+h[b+18376>>3];i=i;return}function yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18528>>3]=+h[b+18384>>3];i=i;return}function zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18536>>3]=+h[b+18392>>3];i=i;return}function Aw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18544>>3]=+h[b+18320>>3]+(+h[b+18344>>3]+ +h[b+18328>>3])*-.5;i=i;return}function Bw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18552>>3]=+h[b+18312>>3];i=i;return}function Cw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18560>>3]=+h[b+18304>>3];i=i;return}function Dw(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18560>>3];e=+h[b+18552>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Ew(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18576>>3]=+h[b+18360>>3];i=i;return}function Fw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18584>>3]=+h[b+18368>>3];i=i;return}function Gw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18592>>3]=+h[b+18376>>3];i=i;return}function Hw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18600>>3]=+h[b+18384>>3];i=i;return}function Iw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18608>>3]=+h[b+18392>>3];i=i;return}function Jw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18616>>3]=+h[b+18328>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18624>>3]=+h[b+18400>>3]+ +h[b+18352>>3];i=i;return}function Lw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18632>>3]=+h[b+18312>>3];i=i;return}function Mw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=+h[b+18616>>3]*(+h[b+18632>>3]+ +h[b+18624>>3])*3.141592653589793;i=i;return}function Nw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18648>>3]=+h[b+18360>>3];i=i;return}function Ow(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18656>>3]=+h[b+18368>>3];i=i;return}function Pw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18664>>3]=+h[b+18376>>3];i=i;return}function Qw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18672>>3]=+h[b+18384>>3];i=i;return}function Rw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18680>>3]=+h[b+18392>>3];i=i;return}function Sw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18688>>3]=+h[b+18344>>3];i=i;return}function Tw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18696>>3]=+h[b+18400>>3];i=i;return}function Uw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18704>>3]=+h[b+18312>>3];i=i;return}function Vw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=+h[b+18688>>3]*(+h[b+18704>>3]+ +h[b+18696>>3])*3.141592653589793;i=i;return}function Ww(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18720>>3]=+h[b+18360>>3];i=i;return}function Xw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18728>>3]=+h[b+18368>>3];i=i;return}function Yw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18736>>3]=+h[b+18376>>3];i=i;return}function Zw(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18744>>3]=+h[b+18384>>3];i=i;return}function _w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18752>>3]=+h[b+18392>>3];i=i;return}function $w(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18760>>3]=+h[b+18336>>3];i=i;return}function ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18776>>3]=+h[b+18400>>3];i=i;return}function bx(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18776>>3];e=+h[b+18768>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function cx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18784>>3]=(+h[b+18400>>3]+ +h[b+18352>>3]*.5)*6.283185307179586;i=i;return}function dx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[(c[a+416>>2]|0)+18784>>3]*6.53451271946677e-7;i=i;return}function ex(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2976>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2920|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,22064,22056,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2920|0;p=o;h[p>>3]=m;i=d;return}function fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18792>>3]=+h[b+18400>>3]*6.283185307179586;i=i;return}function gx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;j=+h[g+18800>>3]+1.0;if(j>0.0){l=g}else{g=c[28168]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=g;g=d;o=22264;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[g+16>>2]=c[o+16>>2];c[g+20>>2]=c[o+20>>2];Pe[n&31](m,d,22096,e);l=c[f>>2]|0}p=+h[l+18792>>3]*+da(+j)*8.000000000000001e-7;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=p;i=b;return}function hx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2984>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2912|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,22192,22184,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2912|0;p=o;h[p>>3]=m;i=d;return}function ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18816>>3]=+h[b+18360>>3];i=i;return}function jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18824>>3]=+h[b+18368>>3];i=i;return}function kx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18832>>3]=+h[b+18376>>3];i=i;return}function lx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18840>>3]=+h[b+18384>>3];i=i;return}function mx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18848>>3]=+h[b+18392>>3];i=i;return}function nx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18856>>3]=+h[b+18320>>3]+((+h[b+18328>>3]+ +h[b+18344>>3])*-.5+((+h[b+18440>>3]+ +h[b+18432>>3])*-.5- +h[b+18336>>3]));i=i;return}function ox(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18872>>3]=+h[b+18400>>3];i=i;return}function px(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18872>>3];e=+h[b+18864>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function qx(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+18400>>3];h[b+18888>>3]=+h[b+18448>>3]*d*d*+h[b+18408>>3]*3.141592653589793;i=i;return}function rx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18896>>3]=+h[b+18416>>3];i=i;return}function sx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18904>>3]=+h[b+18424>>3];i=i;return}function tx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18920>>3]=+h[b+18440>>3];i=i;return}function ux(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18928>>3]=+h[b+18432>>3];i=i;return}function vx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18936>>3]=+h[b+18880>>3];i=i;return}function wx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18944>>3]=+h[b+18888>>3];i=i;return}function xx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18960>>3]=+h[b+18896>>3];i=i;return}function yx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18968>>3]=+h[b+18904>>3];i=i;return}function zx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19e3>>3]=+h[b+18896>>3];i=i;return}function Ax(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19008>>3]=+h[b+18904>>3];i=i;return}function Bx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19032>>3]=+h[b+18920>>3];i=i;return}function Cx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19040>>3]=+h[b+18928>>3];i=i;return}function Dx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19064>>3]=+h[b+18400>>3];i=i;return}function Ex(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+19064>>3];e=+h[b+19056>>3];h[b+19072>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19088>>3]=(+h[b+18400>>3]+.0015)*6.283185307179586;i=i;return}function Gx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19152>>3]=+h[b+18328>>3];i=i;return}function Hx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19160>>3]=+h[b+18400>>3];i=i;return}function Ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19168>>3]=+h[b+18400>>3]+ +h[b+18352>>3];i=i;return}function Jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[b+19152>>3]*(+h[b+19168>>3]+ +h[b+19160>>3])*3.141592653589793;i=i;return}function Kx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+19160>>3];m=+h[j+19168>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,22232,22224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=22264;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,22288,f);}f=c[g>>2]|0;l=+h[f+19104>>3];m=+da(+n);n=+h[f+19152>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,22408,22224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=l*r*7895683520871486.0e-21;i=d;return}function Lx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2904>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2888|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,22496,22488,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2888|0;p=o;h[p>>3]=m;i=d;return}function Mx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22528]&1){i=d;return}g=b+420|0;if(!((LK(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=$H(22544,ZH(c[(c[g>>2]|0)+68>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=22728;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[22528]=1;i=d;return}function Nx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22752]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+64>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=$H(22760,ZH(c[(c[g>>2]|0)+64>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=23096;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[22752]=1;i=d;return}function Ox(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23120]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+60>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=$H(23128,ZH(c[(c[g>>2]|0)+60>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=23376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[23120]=1;i=d;return}function Px(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23400]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+56>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(23408,ZH(c[(c[g>>2]|0)+56>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=32128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[23400]=1;i=d;return}function Qx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23656]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(23672,XH(+h[(c[g>>2]|0)+19184>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[23656]=1;i=d;return}function Rx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23760]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(23768,XH(+h[(c[g>>2]|0)+19168>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[23760]=1;i=d;return}function Sx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23968]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(23976,XH(+h[(c[g>>2]|0)+19160>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[23968]=1;i=d;return}function Tx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24096]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24104,XH(+h[(c[g>>2]|0)+19096>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24096]=1;i=d;return}function Ux(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24224]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24232,XH(+h[(c[g>>2]|0)+19064>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24224]=1;i=d;return}function Vx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24352]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24360,XH(+h[(c[g>>2]|0)+19056>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24352]=1;i=d;return}function Wx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24480]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19024>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(24488,XH(+h[(c[g>>2]|0)+19024>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24480]=1;i=d;return}function Xx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24624]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24632,XH(+h[(c[g>>2]|0)+19008>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24624]=1;i=d;return}function Yx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24768]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+19e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24776,XH(+h[(c[g>>2]|0)+19e3>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24768]=1;i=d;return}function Zx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24912]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(24920,XH(+h[(c[g>>2]|0)+18992>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[24912]=1;i=d;return}function _x(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25072]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+44>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(25080,ZH(c[(c[g>>2]|0)+44>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=31864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[25072]=1;i=d;return}function $x(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25328]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18984>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(25336,XH(+h[(c[g>>2]|0)+18984>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[25328]=1;i=d;return}function ay(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25472]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(25480,XH(+h[(c[g>>2]|0)+18968>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[25472]=1;i=d;return}function by(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25616]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(25624,XH(+h[(c[g>>2]|0)+18960>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[25616]=1;i=d;return}function cy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25760]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(25768,XH(+h[(c[g>>2]|0)+18952>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[25760]=1;i=d;return}function dy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25920]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+40>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(25928,ZH(c[(c[g>>2]|0)+40>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=31864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[25920]=1;i=d;return}function ey(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26176]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+36>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(26184,ZH(c[(c[g>>2]|0)+36>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=32128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[26176]=1;i=d;return}function fy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26408]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(26416,XH(+h[(c[g>>2]|0)+18944>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[26408]=1;i=d;return}function gy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26536]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18912>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(26544,XH(+h[(c[g>>2]|0)+18912>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[26536]=1;i=d;return}function hy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26656]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(26664,XH(+h[(c[g>>2]|0)+18888>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[26656]=1;i=d;return}function iy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26776]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(26784,XH(+h[(c[g>>2]|0)+18872>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[26776]=1;i=d;return}function jy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26896]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(26904,XH(+h[(c[g>>2]|0)+18864>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[26896]=1;i=d;return}function ky(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27016]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27024,XH(+h[(c[g>>2]|0)+18776>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27016]=1;i=d;return}function ly(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27144]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27152,XH(+h[(c[g>>2]|0)+18768>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27144]=1;i=d;return}function my(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27272]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27280,XH(+h[(c[g>>2]|0)+18704>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27272]=1;i=d;return}function ny(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27400]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27408,XH(+h[(c[g>>2]|0)+18696>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27400]=1;i=d;return}function oy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27528]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27536,XH(+h[(c[g>>2]|0)+18632>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27528]=1;i=d;return}function py(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27656]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27664,XH(+h[(c[g>>2]|0)+18624>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27656]=1;i=d;return}function qy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27784]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27792,XH(+h[(c[g>>2]|0)+18560>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27784]=1;i=d;return}function ry(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27920]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(27928,XH(+h[(c[g>>2]|0)+18552>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[27920]=1;i=d;return}function sy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28056]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28064,XH(+h[(c[g>>2]|0)+18480>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28056]=1;i=d;return}function ty(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28248]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28256,XH(+h[(c[g>>2]|0)+18464>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28248]=1;i=d;return}function uy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28440]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28448,XH(+h[(c[g>>2]|0)+18448>>3],23664)|0)|0;g=c[28170]|0;j=e;k=28560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28440]=1;i=d;return}function vy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28584]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28592,XH(+h[(c[g>>2]|0)+18400>>3],23664)|0)|0;g=c[28170]|0;j=e;k=28696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28584]=1;i=d;return}function wy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28720]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28728,XH(+h[(c[g>>2]|0)+18312>>3],23664)|0)|0;g=c[28170]|0;j=e;k=28832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28720]=1;i=d;return}function xy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28856]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(28864,XH(+h[(c[g>>2]|0)+18304>>3],23664)|0)|0;g=c[28170]|0;j=e;k=28976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[28856]=1;i=d;return}function yy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29e3]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+32>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(29008,ZH(c[(c[g>>2]|0)+32>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=32128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[29e3]=1;i=d;return}function zy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29184]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29192,XH(+h[(c[g>>2]|0)+18232>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29184]=1;i=d;return}function Ay(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29280]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29288,XH(+h[(c[g>>2]|0)+18216>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29280]=1;i=d;return}function By(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29408]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29416,XH(+h[(c[g>>2]|0)+18208>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29408]=1;i=d;return}function Cy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29536]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29544,XH(+h[(c[g>>2]|0)+18144>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29536]=1;i=d;return}function Dy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29688]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29696,XH(+h[(c[g>>2]|0)+18112>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29688]=1;i=d;return}function Ey(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29840]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(29848,XH(+h[(c[g>>2]|0)+18104>>3],23664)|0)|0;g=c[28170]|0;j=e;k=29968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29840]=1;i=d;return}function Fy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29992]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18072>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(3e4,XH(+h[(c[g>>2]|0)+18072>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[29992]=1;i=d;return}function Gy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30144]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(30152,XH(+h[(c[g>>2]|0)+18056>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[30144]=1;i=d;return}function Hy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30296]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(30304,XH(+h[(c[g>>2]|0)+18048>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[30296]=1;i=d;return}function Iy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30448]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(30456,XH(+h[(c[g>>2]|0)+18040>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[30448]=1;i=d;return}function Jy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30616]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+20>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(30624,ZH(c[(c[g>>2]|0)+20>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=31864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[30616]=1;i=d;return}function Ky(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30880]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18032>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(30888,XH(+h[(c[g>>2]|0)+18032>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[30880]=1;i=d;return}function Ly(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31056]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(31064,XH(+h[(c[g>>2]|0)+18016>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[31056]=1;i=d;return}function My(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31232]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(31240,XH(+h[(c[g>>2]|0)+18008>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31384;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[31232]=1;i=d;return}function Ny(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31408]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+18e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(31416,XH(+h[(c[g>>2]|0)+18e3>>3],23664)|0)|0;g=c[28170]|0;j=e;k=31576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[31408]=1;i=d;return}



function gJ(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[9651]=+h[b>>3];c[19280]=0;c[19288]=0;c[19282]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[9663]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[19276]=(c[I>>2]|0)+1;c[19278]=(c[I>>2]|0)+2;c[19274]=(c[I>>2]|0)+ -1;h[9651]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[19292]=$+1;$=c[19276]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[9654]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[19262]=2;if(($|0)>=2){Y=2;while(1){h[9655]=+h[y+(Y+ -2<<3)>>3];U=+h[9654];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[9655];U=+h[9655]+ +h[k>>3];h[9654]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[19262]=$+1}h[y+($+ -1<<3)>>3]=+h[9654]}h[9661]=0.0;h[9659]=0.0;Y=c[I>>2]|0;c[19262]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[9661]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[9659]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[19262]=Y+1;da=ea}h[9662]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[9661]- +h[9659];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[9636]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[9636]=ha>=ca?ha:ca;h[9654]=.6;h[9655]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[9662]){h[D>>3]=100.0}aa=c[19276]|0;ba=c[19292]|0;if((aa|0)>=(ba|0)){c[19264]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[19262]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[19262]=ba+1}ja=ia+1|0;c[19264]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[19262]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[19262]=ia+1}aa=c[19276]|0;c[19264]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[19262]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[19262]=$+1}la=ba+1|0;c[19264]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[9658]=+dJ(f,d,l,0,0);a[77312]=1;c[19266]=0;c[T>>2]=(c[T>>2]|0)+1;c[19296]=0;ie[m&7](b,d,e,r,77184,o,p)|0;if((c[19296]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;hJ(f,b,d,e,r,A,k,77136,l,s,t,u,g,77184,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[19296]|0)<0|(c[19284]|0)!=0){X=70;break}c[19288]=0}ba=c[f>>2]|0;c[19262]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[19262]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[9654]=ca;aa=c[f>>2]|0;c[19262]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[9654];ia=ia+1|0;la=ka}c[19262]=aa+1}iJ(f,r,t,u)|0;la=c[f>>2]|0;c[19262]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[19262]=la+1}U=+dJ(f,r,l,0,0);h[9663]=U;if(U<=+h[F>>3]*100.0*+h[9658]){X=63;break a}ia=c[19266]|0;if((ia|0)>0){h[O>>3]=U/+h[9665];h[P>>3]=1.0/+(ia|0);ca=+HZ(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[9663];oa=ga}else{h[9665]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[19266]|0;c[19266]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[19296]=0;ie[m&7](b,d,e,r,77184,o,p)|0;if((c[19296]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[19262]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[19262]=ba+1}U=+dJ(f,r,l,0,0);h[9663]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[19262]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[19262]=ia+1}}while(0);if((X|0)==70){X=0;a[77312]=0}c[H>>2]=1;if(a[77312]&1){U=+dJ(f,s,l,0,0);h[9657]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[9643]=ga;h[9650]=ga*+(ba+1|0);h[9645]=ga;c[19298]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[19262]=1;if((ba|0)>=1){aa=fa(c[19276]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[19262]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+dJ(f,r,l,0,0);h[9652]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[9660]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[19262]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[19262]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+dJ(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[9660];if((sa>=ca?sa:ca)>+h[9650]){break}ta=+h[9652];ua=Y}else{if(!(ga<=+h[9650]*.5)){break}else{ta=U;ua=ka}}c[19298]=ua+ -1;h[9645]=ta}}while(0);if(!(+h[9636]*+h[9657]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[9651];Y=c[19276]|0;ia=c[19292]|0;if((Y|0)>=(ia|0)){c[19264]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[9654]=ca;ia=c[f>>2]|0;c[19262]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[9654];ja=ja+1|0}c[19262]=ia+1}ja=aa+1|0;c[19264]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[19262]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[19262]=Y+1}if(!(a[77312]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[19284]|0)!=0){aa=(c[19288]|0)+1|0;c[19288]=aa;h[9634]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[19296]|0)>-2)){X=146;break}aa=(c[19280]|0)+1|0;c[19280]=aa;h[9634]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[19282]=(c[19282]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[19282]|0;if((aa|0)<=1){ja=c[19298]|0;c[I>>2]=ja;sa=+(ja+1|0);h[9655]=sa;h[O>>3]=+h[9645]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+HZ(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[9634]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[19298];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[19312]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[19298]|0;E=c[19274]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[19276];za=+h[k>>3]*2.0;h[9647]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[19274]|0;Ba=c[19298]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[19276]|0)>=(c[K>>2]|0)|(c[19312]|0)==1){Fa=G;break}G=c[f>>2]|0;c[19262]=1;if((G|0)>=1){E=fa(c[19278]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[19262]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+dJ(f,r,l,0,0);h[9653]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[9650];E=xa<=za;if(+h[9660]<=(E?xa:za)){Ea=c[19274]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[9650]*.5){Fa=S;break}}S=c[19276]|0;c[I>>2]=S;h[9645]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[9645]=+h[9652];Fa=Ea}h[9647]=+h[k>>3];ya=+(Fa+1|0);h[9655]=ya;h[O>>3]=+h[9645]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+HZ(O,P);h[9634]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[9647];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[9634]=xa;za=+h[k>>3]*xa;h[9647]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[9647]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[19262]=1;if((k|0)<1){break}u=fa(c[19278]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[19262]=k+1}}while(0);Ca=c[f>>2]|0;c[19262]=1;if((Ca|0)>=1){J=fa(c[19276]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[19262]=Ca+1}Ca=c[19276]|0;c[19270]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[19264]=P;s=c[f>>2]|0;c[19262]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[19262]=s+1}P=Ha+1|0;c[19270]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[19296]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[19282]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}fJ(b,b,d,e,f,I,q,y)|0;i=N;return 0}function hJ(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[19354]=0;h[9678]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[19332]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[9675]=+h[9678]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+JZ(77400,N);h[9675]=T;W=(c[19332]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[9675]=_;h[9682]=+h[S>>3];$=f+(W<<3)|0;h[9686]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[9675]+ +h[$>>3];ie[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[9675];h[9684]=_;$=c[b>>2]|0;c[19338]=1;S=c[19354]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[9684];W=W+1|0;aa=ba}c[19338]=$+1}c[19354]=S+(c[b>>2]|0);aa=c[19332]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[9682];h[f+(W<<3)>>3]=+h[9686];R=aa+1|0;c[19332]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[19354]=0;P=c[b>>2]|0;if((c[63608>>2]|0)==0){ca=42;break}R=baa(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];rH(14,1,77496,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];rH(14,0,77520,E);rH(14,1,77528,D);c[19336]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];rH(14,0,77536,C);Q=(c[19336]|0)+1|0;c[19336]=Q;}while((Q|0)<(c[b>>2]|0))}me[c[16026]&255](14);rH(14,1,77592,B);c[19332]=1;if((P|0)>=1){Q=R+1|0;aa=c[19354]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[19338]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];lc(R|0,77576,A|0)|0;ea=c[19338]|0;c[19338]=ea+1;if((ea|0)>=(P|0)){break}ba=c[19354]|0;da=ea}c[z>>2]=R;rH(14,0,77584,z);da=c[19354]|0;ba=c[19332]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[19354]=aa;W=ba+1|0;c[19332]=W;}while((ba|0)<(P|0))}me[c[16026]&255](14);me[c[16026]&255](14);caa(R);ca=42}else if((O|0)==5){P=q+4|0;W=(c[P>>2]|0)+(c[q>>2]|0)|0;aa=W+1|0;c[19358]=aa;Q=c[b>>2]|0;c[19348]=(W|0)<(Q|0)?aa:Q;Q=c[q>>2]|0;c[19366]=aa+Q;c[19352]=Q+W;W=(c[b>>2]|0)/(aa|0)|0;c[19362]=W+1;aa=c[x>>2]|0;c[19360]=aa+ -1;c[19370]=aa+W;c[s>>2]=0;h[9678]=+V(+(+h[t>>3]));W=c[19348]|0;c[19334]=1;if((W|0)<1){ca=75;break}aa=r;Q=1;while(1){ba=c[b>>2]|0;da=c[19358]|0;c[19340]=Q;ea=(da|0)<0;c:do{if(ea?(Q|0)>=(ba|0):(Q|0)<=(ba|0)){ga=da;ha=Q;ia=Q;while(1){ja=(ia-ha|0)/(ga|0)|0;c[19336]=ja+1;ka=ia+ -1|0;la=e+(ka<<3)|0;h[p+((c[19360]|0)+ja<<3)>>3]=+h[la>>3];ma=f+(ka<<3)|0;h[p+((c[19370]|0)+ja<<3)>>3]=+h[ma>>3];Y=+h[la>>3];h[N>>3]=Y;if(!(Y>=0.0)){na=-Y}else{na=Y}Y=+h[l>>3]*+h[ma>>3];if(!(Y>=0.0)){oa=-Y}else{oa=Y}Y=na>=oa?na:oa;_=+h[n+(ka<<3)>>3];if(!(_>=0.0)){pa=-_}else{pa=_}h[9675]=+h[9678]*(Y>=pa?Y:pa);h[N>>3]=+h[l>>3]*+h[ma>>3];Y=+JZ(77400,N);h[9675]=Y;ma=c[19340]|0;ka=ma+ -1|0;la=e+(ka<<3)|0;_=+h[la>>3];T=Y+_-_;h[9675]=T;h[la>>3]=+h[la>>3]+T;la=f+(ka<<3)|0;h[la>>3]=+h[j>>3]*+h[9675]+ +h[la>>3];la=ma+da|0;c[19340]=la;if(!(ea?(la|0)>=(ba|0):(la|0)<=(ba|0))){break c}ga=c[19358]|0;ha=c[19334]|0;ia=la}}}while(0);ie[aa&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ba=c[b>>2]|0;ea=c[19358]|0;da=c[19334]|0;c[19340]=da;ia=(ea|0)<0;d:do{if(ia?(da|0)>=(ba|0):(da|0)<=(ba|0)){ha=ea;ga=da;S=da;while(1){$=(S-ga|0)/(ha|0)|0;c[19336]=$+1;la=S+ -1|0;ma=e+(la<<3)|0;h[ma>>3]=+h[p+((c[19360]|0)+$<<3)>>3];T=+h[p+((c[19370]|0)+$<<3)>>3];$=f+(la<<3)|0;h[$>>3]=T;_=+h[ma>>3];h[N>>3]=_;if(!(_>=0.0)){qa=-_}else{qa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ra=-_}else{ra=_}_=qa>=ra?qa:ra;T=+h[n+(la<<3)>>3];if(!(T>=0.0)){sa=-T}else{sa=T}h[9675]=+h[9678]*(_>=sa?_:sa);h[N>>3]=+h[l>>3]*+h[$>>3];_=+JZ(77400,N);h[9675]=_;$=c[19340]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[9675]=Y;T=1.0/Y;h[9684]=T;la=$-(c[P>>2]|0)|0;ma=(la|0)>1?la:1;c[19342]=ma;la=c[b>>2]|0;ka=(c[q>>2]|0)+$|0;ja=(la|0)<=(ka|0)?la:ka;c[19344]=ja;ta=fa(c[19352]|0,$)|0;ua=ta-(c[q>>2]|0)|0;c[19346]=ua;c[19332]=ma;if((ma|0)<=(ja|0)){ta=~la;la=~ka;ka=~((ta|0)>(la|0)?ta:la);la=(ma|0)>(ka|0)?ma:ka;Y=T;ka=ma;while(1){ma=ka+ -1|0;h[p+(ma+ua<<3)>>3]=(+h[o+(ma<<3)>>3]- +h[g+(ma<<3)>>3])*Y;if((ka|0)>=(ja|0)){break}Y=+h[9684];ka=ka+1|0}c[19332]=la+1}ka=$+ea|0;c[19340]=ka;ja=c[19334]|0;if(!(ia?(ka|0)>=(ba|0):(ka|0)<=(ba|0))){va=ja;break d}ha=c[19358]|0;ga=ja;S=ka}}else{va=da}}while(0);da=va+1|0;c[19334]=da;if((va|0)<(W|0)){Q=da}else{ca=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==4){Q=c[q>>2]|0;W=q+4|0;P=c[W>>2]|0;aa=c[b>>2]|0;R=fa(P+1+(Q<<1)|0,aa)|0;c[19332]=1;if((R|0)>=1){da=fa(aa,P+(Q<<1)+1|0)|0;Q=(da|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(R|0)){P=P+1|0}else{break}}c[19332]=Q?2:da+1|0}oe[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[19366]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else{P=c[b>>2]|0;R=fa(P,P)|0;c[19332]=1;if((R|0)!=0){P=(R|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(R|0)){aa=aa+1|0}else{break}}c[19332]=P?2:R+1|0}oe[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[19354]=0;aa=c[b>>2]|0;if((c[63608>>2]|0)==0){ca=42;break}W=baa(aa*20|0)|0;da=M;h[k>>3]=+h[d>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rH(14,1,77496,M);da=L;h[k>>3]=+h[j>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rH(14,0,77520,L);rH(14,1,77528,K);c[19336]=0;if((c[b>>2]|0)>0){da=0;do{Y=+h[e+(da<<3)>>3];c[J>>2]=da+1;Q=J+4|0;h[k>>3]=Y;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];rH(14,0,77536,J);da=(c[19336]|0)+1|0;c[19336]=da;}while((da|0)<(c[b>>2]|0))}me[c[16026]&255](14);rH(14,1,77552,I);c[19332]=1;if((aa|0)>=1){da=W+1|0;R=c[19354]|0;P=1;do{Q=p+(P+ -1+R<<3)|0;h[Q>>3]=+h[j>>3]+ +h[Q>>3];a[W]=0;a[da]=0;c[19338]=1;Q=R;ba=0;while(1){Y=+h[p+(ba+Q<<3)>>3];c[H>>2]=W;ia=H+4|0;h[k>>3]=Y;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];lc(W|0,77576,H|0)|0;ia=c[19338]|0;c[19338]=ia+1;if((ia|0)>=(aa|0)){break}Q=c[19354]|0;ba=ia}c[G>>2]=W;rH(14,0,77584,G);ba=c[19354]|0;Q=c[19332]|0;ia=p+(ba+ -1+Q<<3)|0;h[ia>>3]=+h[ia>>3]- +h[j>>3];R=ba+(c[b>>2]|0)|0;c[19354]=R;P=Q+1|0;c[19332]=P;}while((Q|0)<(aa|0))}me[c[16026]&255](14);me[c[16026]&255](14);caa(W);ca=42}}while(0);if((ca|0)==42){pJ(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){vJ(p,77464,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function iJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[19404]=(c[g>>2]|0)+1+(c[e>>2]<<1);wJ(d,77616,a,e,g,e+80|0,b,77624)|0;i=f;return 0}else{tJ(d,a,a,e+80|0,b,77624)|0;i=f;return 0}return 0}function jJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[77632]&1)){a[77632]=1;kJ(77680,77648,77728,77664,77712,77736,77720,77744)|0;h[9709]=+(c[19420]|0);f=c[19412]|0;h[9705]=+(f|0);if((c[19432]|0)==0){h[9707]=0.0;c[e>>2]=1-f;g=+IZ(77672,e)}else{h[9707]=1.0;c[e>>2]=1-f;g=+IZ(77672,e)*.5}h[9708]=g;h[9712]=g*+h[9709];h[9711]=+(c[19428]|0);h[9713]=+(c[19430]|0);j=+h[9717];h[9720]=j;k=1.0/+h[9718];if(!(k>=j)){break}h[9720]=k*(g+1.0)}}while(0);if((CJ(b,77768,1,1)|0)!=0){g=+h[9708];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77776,1,1)|0)!=0){g=+h[9720];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77784,1,1)|0)!=0){g=+h[9709];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77792,1,1)|0)!=0){g=+h[9712];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77800,1,1)|0)!=0){g=+h[9705];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77808,1,1)|0)!=0){g=+h[9707];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77816,1,1)|0)!=0){g=+h[9711];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77824,1,1)|0)!=0){g=+h[9717];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77832,1,1)|0)!=0){g=+h[9713];h[9719]=g;l=g;i=d;return+l}if((CJ(b,77840,1,1)|0)==0){l=+h[9719];i=d;return+l}else{g=+h[9718];h[9719]=g;l=g;i=d;return+l}return 0.0}function kJ(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[77952]&1){q=78320;r=c[19580]|0;c[b>>2]=r;s=78256;t=c[19564]|0;c[d>>2]=t;u=78296;v=c[19574]|0;c[e>>2]=v;w=78304;x=+h[9788];h[f>>3]=x;y=78336;z=c[19584]|0;c[g>>2]=z;A=78384;B=+h[9798];h[j>>3]=B;C=78344;D=c[19586]|0;c[k>>2]=D;E=78392;F=+h[9799];h[l>>3]=F;i=m;return 0}a[77952]=1;h[9789]=0.0;h[9783]=1.0;h[9784]=2.0;lJ(78320,78256,78296,78408)|0;h[9779]=+(c[19580]|0);c[n>>2]=0-(c[19564]|0);G=+IZ(78232,n);h[9778]=G;h[9788]=G;H=+h[9784];h[9779]=H/3.0;I=+h[9783];J=I*.5;h[9786]=J;K=-J;h[o>>3]=K;h[9800]=+mJ(78232,o);L=78400;h[9797]=+mJ(L,L);h[o>>3]=K;h[9779]=+mJ(78376,o);K=+mJ(78232,78400);h[9779]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[9779]=K;h[9788]=1.0;M=+h[9789];if(K<1.0&K>M){N=K;while(1){h[9788]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+mJ(o,p);h[9780]=K;h[o>>3]=-K;h[9780]=+mJ(78288,o);K=+mJ(78288,78240);h[9779]=K;h[o>>3]=-K;h[9780]=+mJ(78288,o);K=+mJ(78288,78240);h[9779]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[9788]=G}G=I/+(c[19580]|0);h[9791]=G;h[9795]=I;c[19562]=1;p=1;O=I;do{h[o>>3]=O*G;O=+mJ(o,78312);h[9795]=O;p=p+1|0;c[19562]=p;}while((p|0)<4);h[9778]=+mJ(78264,78360);nJ(78424,78264,78320)|0;h[o>>3]=-+h[9783];nJ(78416,o,78320)|0;nJ(78368,78224,78320)|0;h[o>>3]=-+h[9778];nJ(78352,o,78320)|0;c[19570]=0;p=c[19606]|0;L=c[19604]|0;P=c[19592]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[19588]|0)){if(Q){c[19584]=p;R=0;S=25;break}if((P-p|0)==3){c[19584]=p+ -1+(c[19564]|0);c[19570]=1;R=1;S=25;break}else{c[19584]=(p|0)<=(P|0)?p:P;a[77960]=1;S=26;break}}else{T=Q&(L|0)==(c[19588]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[19584]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[19584]=(p|0)<=(L|0)?p:L;a[77960]=1;S=26;break}}T=c[19588]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[19584]=(V|0)<=(T|0)?V:T;a[77960]=1;S=26;break}if((P-U|0)==3){c[19584]=((p|0)>=(L|0)?p:L)+ -1+(c[19564]|0);R=0;S=25;break}else{c[19584]=U;a[77960]=1;S=26;break}}}while(0);if((S|0)==25){if(a[77960]&1){S=26}else{W=R}}if((S|0)==26){a[77952]=0;G_(78432)|0;XZ(78456,78336,4)|0;o_()|0;W=c[19570]|0}if((W|0)==0){X=(c[19602]|0)!=0|0}else{X=1}c[19570]=X;h[9798]=1.0;X=c[19584]|0;W=1-X|0;c[n>>2]=W;c[19562]=1;if((X|0)<=0){O=+h[9791];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+mJ(o,78312);h[9798]=I;n=X+1|0;c[19562]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}oJ(78320,78256,78336,78280,78344,78392)|0;q=78320;r=c[19580]|0;c[b>>2]=r;s=78256;t=c[19564]|0;c[d>>2]=t;u=78296;v=c[19574]|0;c[e>>2]=v;w=78304;x=+h[9788];h[f>>3]=x;y=78336;z=c[19584]|0;c[g>>2]=z;A=78384;B=+h[9798];h[j>>3]=B;C=78344;D=c[19586]|0;c[k>>2]=D;E=78392;F=+h[9799];h[l>>3]=F;i=m;return 0}function lJ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[77848]&1){l=a[77920]&1;m=c[19482]|0;c[b>>2]=m;n=77896;o=c[19474]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=77944;r=c[19486]|0;c[f>>2]=r;i=g;return 0}a[77848]=1;h[9738]=1.0;h[9732]=1.0;h[9734]=1.0;s=1.0;do{s=s*2.0;h[9732]=s;h[9734]=+mJ(77856,77904);h[j>>3]=-s;t=+mJ(77872,j);h[9734]=t;}while(t==1.0);h[9733]=1.0;t=+mJ(77856,77864);h[9734]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[9733]=v;w=+mJ(77856,77864);h[9734]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[9739]=.25;h[9742]=x;h[j>>3]=-s;t=+mJ(77872,j);h[9734]=t;y=~~(t+.25);c[19482]=y;t=+(y|0);h[9733]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[9735]=+mJ(j,k);w=+mJ(77880,77856);h[9734]=w;z=w==s;a[77920]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[9735]=+mJ(j,k);w=+mJ(77880,77856);h[9734]=w;if(z&w==s){a[77920]=0;A=0}else{A=z}h[j>>3]=u;w=+mJ(j,77856);h[9736]=w;h[j>>3]=u;z=w==s&+mJ(j,77936)>x;c[19486]=z?A&1:0;c[19474]=0;h[9732]=1.0;h[9734]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[19474]=k;s=x*t;h[9732]=s;h[9734]=+mJ(77856,77904);h[j>>3]=-s;w=+mJ(77872,j);h[9734]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=77896;o=c[19474]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=77944;r=c[19486]|0;c[f>>2]=r;i=g;return 0}function mJ(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function nJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[9808]=g;j=1.0/+(c[d>>2]|0);h[9817]=j;h[9816]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+mJ(f,78528);h[9810]=k;h[9812]=g;h[9813]=g;h[9814]=g;h[9815]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[9808]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+mJ(f,78528);h[9810]=g;h[f>>3]=g*k;k=+mJ(f,78528);h[9812]=k;h[9814]=0.0;c[19618]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[9814]=q;c[19618]=b+1;n=q}h[f>>3]=m*j;p=+mJ(f,78528);h[9811]=p;h[f>>3]=p/j;r=+mJ(f,78528);h[9813]=r;h[9815]=0.0;o=c[d>>2]|0;c[19618]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[9815]=v;c[19618]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function oJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[19642]=1;c[19650]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[19642]=q;r=l+1|0;c[19650]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[19646]=n;u=n}else{c[19646]=m;c[19650]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[19652]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[19650]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[9824]=x;y=w+-1.0;h[9820]=y;h[9819]=0.0;v=c[b>>2]|0;c[19636]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[9820]=B;if(w<1.0){h[9822]=w}C=+mJ(78552,78560);h[9819]=C;e=b+1|0;c[19636]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[9822];h[9819]=A;z=A}}while(0);v=c[f>>2]|0;c[19636]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+mJ(k,78616);h[9819]=z;f=E+1|0;c[19636]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function pJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[19658]=1;m=1;do{c[19664]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=qJ(j,a+(m+b+(fa(m,l)|0)<<3)|0,78664)|0;q=c[19658]|0;r=p+ -1+q|0;c[19660]=r;c[e+(q+ -1<<2)>>2]=r;r=c[19660]|0;q=c[19658]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[9831]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[9831];t=q}u=fa(t,l)|0;h[9831]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;rJ(j,78648,a+(t-l+u<<3)|0,78664)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[19664]|0;c[19656]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[19660]|0;x=fa(w,l)|0;h[9831]=+h[a+(x+b+v<<3)>>3];y=c[19658]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[9831];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=78664;sJ(k,78648,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[19656]|0;w=A+1|0;c[19656]=w;}while((A|0)<(u|0))}}while(0);q=c[19658]|0;m=q+1|0;c[19658]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function qJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[19756]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[9879]=k;l=(c[d>>2]|0)+1|0;c[19756]=l;m=c[a>>2]|0;c[19754]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[9879]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[19756]=l;a=n+1|0;c[19754]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[9879]=v;c[19754]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[9879]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[19754]=f+1;g=C;i=e;return g|0}function rJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[19740]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[19740]=l;i=f;return 0}l=(g|0)%5|0;c[19742]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[19740]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[19740]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[19740]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[19740]=o;i=f;return 0}function sJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[19726]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[19724]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[19724]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[19724]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[19724]=s;i=j;return 0}}while(0);c[19728]=1;c[19730]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[19728]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[19730]=s;u=s}else{u=1}s=c[a>>2]|0;c[19724]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[19728]=t;u=x+(c[g>>2]|0)|0;c[19730]=u;a=w+1|0;c[19724]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function tJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[19676]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[19668]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[19670]=o;p=f+(o+ -1<<3)|0;h[9836]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[9836]}c[k>>2]=(c[d>>2]|0)-m;o=78664;sJ(k,78688,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[19668]|0;m=o+1|0;c[19668]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[19674]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[19668]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[9836]=-s;c[k>>2]=g;g=78664;sJ(k,78688,a+(p-l<<3)|0,g,f,g)|0;g=c[19674]|0;q=g+1|0;c[19674]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[19668]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=78664;s=+uJ(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[9836]=s;q=c[19668]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[19668]=n;}while((q|0)<(m|0));t=c[19676]|0}if((t|0)<1){i=j;return 0}c[19674]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[19668]=n;c[k>>2]=(c[d>>2]|0)-n;b=78664;s=+uJ(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[19668]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[19670]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[9836]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[9836]}q=c[19674]|0;m=q+1|0;c[19674]=m;}while((q|0)<(t|0));i=j;return 0}function uJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[9876]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[19746]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[19744]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[9876]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[19744]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[19744]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[9876]=t;u=u+5|0;}while((u|0)<=(m|0));c[19744]=u;k=t;i=g;return+k}}while(0);c[19748]=1;c[19750]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[19748]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[19750]=u;y=u}else{y=1}u=c[a>>2]|0;c[19744]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[9876]=t;x=C+(c[d>>2]|0)|0;c[19748]=x;y=B+(c[f>>2]|0)|0;c[19750]=y;a=z+1|0;c[19744]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function vJ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[19686]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[19692]=n;o=c[d>>2]|0;p=c[19686]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[19694]=o;do{if((q|0)>(n|0)){c[19702]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[19690]=s;t=c[e>>2]|0;c[19678]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[19678]=t+1}u=r+1|0;c[19702]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[19702]=o;c[19700]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[19682]=1;t=o;o=1;while(1){c[19704]=o+1;p=t+1|0;c[19702]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[19678]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[19678]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[19696]=s;c[l>>2]=s+1;s=qJ(l,a+((c[19686]|0)+b+(fa(o,m)|0)<<3)|0,78664)|0;p=s+ -1|0;c[19684]=p+(c[19686]|0);s=c[19682]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[19684]|0;p=c[19682]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[19686]|0;if((s|0)==(u|0)){y=s}else{h[9844]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[9844];y=u}h[9844]=-1.0/+h[a+(y+b+n<<3)>>3];rJ(78784,78752,a+(y-m+n<<3)|0,78664)|0;u=c[19700]|0;z=(c[g+((c[19682]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[19700]=u;A=c[19686]|0;c[19698]=A;z=c[19704]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[19680]=z;B=z;z=A;while(1){A=(c[19684]|0)+ -1|0;c[19684]=A;C=z+ -1|0;c[19698]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[9844]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[9844];F=C}C=78664;sJ(78784,78752,a+((c[19686]|0)-m+(fa(c[19682]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[19680]|0;D=C+1|0;c[19680]=D;if((C|0)>=(u|0)){break a}B=D;z=c[19698]|0}}}while(0);n=c[19682]|0;s=n+1|0;c[19682]=s;if((n|0)>=(r|0)){break}t=c[19702]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[19686]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function wJ(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[19710]=n;f=c[d>>2]|0;o=f+ -1|0;c[19722]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[19706]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[19720]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[19708]=k;q=j+(k+ -1<<3)|0;h[9856]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[9856]}k=78664;sJ(78880,78848,a+((c[19710]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[19706]|0;f=k+1|0;c[19706]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[19714]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[19706]=k;q=c[19710]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[19720]=s;u=q-s|0;c[19716]=u;q=k-s|0;c[19718]=q;h[9856]=-t;s=78664;sJ(78880,78848,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[19714]|0;r=s+1|0;c[19714]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[19706]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[19720]=r;s=o-r|0;c[19716]=s;q=n-r|0;c[19718]=q;r=78664;t=+uJ(78880,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[9856]=t;r=c[19706]|0;q=j+(r+ -1<<3)|0;o=c[19710]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[19706]=n;}while((r|0)<(f|0));v=o;w=c[19722]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[19714]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[19706]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[19720]=(n|0)<=(b|0)?n:b;b=78664;t=+uJ(78880,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[19706]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[19708]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[9856]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[9856]}n=c[19714]|0;b=n+1|0;c[19714]=b;if((n|0)>=(w|0)){break}o=c[19710]|0;v=b}i=l;return 0}function xJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[19734]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[19732]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[19732]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[19732]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[19732]=o;i=g;return 0}}while(0);c[19736]=1;c[19738]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[19736]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[19738]=o;q=o}else{q=1}o=c[a>>2]|0;c[19732]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[19736]=p;q=s+(c[f>>2]|0)|0;c[19738]=q;a=r+1|0;c[19732]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function yJ(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+zJ(79040);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+AJ(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+AJ(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+AJ(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+AJ(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function zJ(a){a=a|0;i=i;return+(+h[79048+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function AJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function BJ(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+zJ(79080);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+AJ(b,e);c[E>>2]=2;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){JJ(b,b,f,g,79088,N,79080,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+AJ(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Yaa(ga|0,0,Z+ -2|0,0)|0;Z=Raa(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}IJ(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ne[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);yJ(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+AJ(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ne[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+AJ(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+AJ(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+AJ(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}LJ(b,b,s,t,v,w,x,D)|0;KJ(b,b,f,g,w,x)|0;W=79080;KJ(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ne[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ne[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function CJ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[79112]=1;f=d[b]|0;c[19774]=f;b=d[e]|0;c[19776]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[19774]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[19776]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function DJ(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[88644>>2]=6;G_(88640)|0;XZ(89384,j,4)|0;o_()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[21462]=0;c[22068]=0;c[22056]=0;a[88248]=0;t=c[e>>2]|0;c[21016]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[21462]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[21016]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[21016]=1;if((v|0)>=1){x=1;while(1){h[80536+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[21016]=v+1}c[22060]=2;x=c[e>>2]|0;c[21016]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[21018]=1;if((E|0)<1){F=C}else{G=1;while(1){h[80536+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[21018]=E+1;F=+h[B>>3]}h[80536+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[22060]=G;D=G}G=z+1|0;c[21016]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[21462]|0;y=z+1|0;c[21458]=y;c[21016]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[21018]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[80536+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[21018]=x+1}se[u&63](e,b,83896+(z+ -1<<3)|0)|0;c[22068]=(c[22068]|0)+1;if((c[j>>2]|0)>=1){c[88668>>2]=6;G_(88664)|0;XZ(89384,88272,4)|0;XZ(89384,83896+((c[21016]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[21018]=1;if((v|0)>=1){A=1;do{XZ(89384,b+(A+ -1<<3)|0,8)|0;B=c[21018]|0;A=B+1|0;c[21018]=A;}while((B|0)<(v|0))}o_()|0}v=c[21016]|0;z=v+1|0;c[21016]=z;}while((v|0)<(y|0))}y=c[22056]|0;b:while(1){c[22056]=y+1;c[21968]=1;c[21964]=1;C=+h[10487];h[10983]=C;h[10985]=C;z=c[21458]|0;c[21016]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[83896+(A+ -1<<3)>>3];do{if(!(C<=K)){c[21968]=A;L=+h[83896+(A+ -1<<3)>>3];h[10983]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[21964]=A;L=+h[83896+(A+ -1<<3)>>3];h[10985]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[21016]=z+1;H=O}A=c[e>>2]|0;c[21016]=1;if((A|0)>=1){v=1;while(1){h[86016+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[21016]=A+1}c[21016]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[21018]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=86016+(Q+ -1<<3)|0;h[B>>3]=+h[80536+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[21018]=x+1;P=v}}while(0);v=P+1|0;c[21016]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[21018]=1;if((z|0)>=1){K=+(c[21462]|0);v=1;while(1){A=86016+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[21018]=z+1}v=c[e>>2]|0;c[21016]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[86016+(B<<3)>>3];h[88296+(B<<3)>>3]=K+(K- +h[80536+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[21016]=v+1}se[u&63](e,88296,88288)|0;A=(c[22068]|0)+1|0;c[22068]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[88692>>2]=6;G_(88688)|0;XZ(89384,88272,4)|0;XZ(89384,88288,8)|0;B=c[e>>2]|0;c[21018]=1;if((B|0)>=1){E=1;do{XZ(89384,88296+(E+ -1<<3)|0,8)|0;G=c[21018]|0;E=G+1|0;c[21018]=E;}while((G|0)<(B|0))}o_()|0}}while(0);K=+h[11036];c:do{if(!(K>=+h[10985])){z=c[e>>2]|0;c[21016]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[86016+(v<<3)>>3];h[88464+(v<<3)>>3]=I+(+h[88296+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[21016]=z+1}se[u&63](e,88464,88456)|0;A=(c[22068]|0)+1|0;c[22068]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[88716>>2]=6;G_(88712)|0;XZ(89384,88272,4)|0;XZ(89384,88456,8)|0;B=c[e>>2]|0;c[21018]=1;if((B|0)>=1){E=1;do{XZ(89384,88464+(E+ -1<<3)|0,8)|0;G=c[21018]|0;E=G+1|0;c[21018]=E;}while((G|0)<(B|0))}o_()|0}}while(0);I=+h[11057];if(I>=+h[10985]){R=118;break}v=c[e>>2]|0;c[21016]=1;A=c[21968]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[80536+((z*21|0)+ -22+A<<3)>>3]=+h[88464+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[21016]=v+1}h[83896+(A+ -1<<3)>>3]=I}else{z=c[21458]|0;c[21016]=1;if((z|0)>=1){B=c[21968]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[83896+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[21016]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[10983])){E=c[e>>2]|0;c[21016]=1;z=c[21968]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[80536+((B*21|0)+ -22+z<<3)>>3]=+h[88296+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[21016]=E+1}h[10983]=K;h[83896+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[21016]=1;if((B|0)>=1){A=c[21968]|0;v=1;while(1){x=v+ -1|0;h[88464+(x<<3)>>3]=+h[80536+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[86016+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[21016]=B+1}se[u&63](e,88464,88456)|0;v=(c[22068]|0)+1|0;c[22068]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[88740>>2]=6;G_(88736)|0;XZ(89384,88272,4)|0;XZ(89384,88456,8)|0;z=c[e>>2]|0;c[21018]=1;if((z|0)>=1){E=1;do{XZ(89384,88464+(E+ -1<<3)|0,8)|0;x=c[21018]|0;E=x+1|0;c[21018]=E;}while((x|0)<(z|0))}o_()|0}}while(0);I=+h[11057];if(!(I>+h[10983])){A=c[e>>2]|0;c[21016]=1;v=c[21968]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[80536+((B*21|0)+ -22+v<<3)>>3]=+h[88464+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[21016]=A+1}h[83896+(v+ -1<<3)>>3]=I;break}B=c[21458]|0;c[21016]=1;if((B|0)<1){break}else{S=1}do{z=c[21964]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[21018]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=80536+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[80536+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[80536+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[21018]=E+1}se[u&63](e,b,83896+(S+ -1<<3)|0)|0;G=(c[22068]|0)+1|0;c[22068]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[88764>>2]=6;G_(88760)|0;XZ(89384,88272,4)|0;XZ(89384,83896+((c[21016]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[21018]=1;if((x|0)>=1){G=1;do{XZ(89384,b+(G+ -1<<3)|0,8)|0;T=c[21018]|0;G=T+1|0;c[21018]=G;}while((T|0)<(x|0))}o_()|0}}while(0);z=c[21016]|0;S=z+1|0;c[21016]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[21016]=1;v=c[21968]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[80536+((A*21|0)+ -22+v<<3)>>3]=+h[88296+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[21016]=B+1}h[83896+(v+ -1<<3)>>3]=+h[11036]}A=c[22056]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[10986]=0.0;h[11032]=0.0;A=c[21458]|0;c[21016]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[11032]=0.0/K;c[21016]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[83896+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[11032]=I;c[21016]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[83896+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[10986]=$;c[21016]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[10986]=I;do{if(!(I<=+h[k>>3])){if((c[22068]|0)>(c[g>>2]|0)){break}a[88248]=0;c[22056]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[21016]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[21018]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[80536+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[21018]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[21016]=v+1}se[u&63](e,b,f)|0;B=(c[22068]|0)+1|0;c[22068]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[88788>>2]=6;G_(88784)|0;XZ(89384,88272,4)|0;XZ(89384,s,8)|0;z=c[e>>2]|0;c[21018]=1;if((z|0)>=1){E=1;do{XZ(89384,b+(E+ -1<<3)|0,8)|0;x=c[21018]|0;E=x+1|0;c[21018]=E;}while((x|0)<(z|0))}o_()|0;ba=c[22068]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[88908>>2]=6;G_(88904)|0;o_()|0;c[88932>>2]=6;G_(88928)|0;B=c[e>>2]|0;c[21016]=1;if((B|0)>=1){A=1;do{XZ(89384,b+(A+ -1<<3)|0,8)|0;v=c[21016]|0;A=v+1|0;c[21016]=A;}while((v|0)<(B|0))}o_()|0;c[88956>>2]=6;G_(88952)|0;XZ(89384,s,8)|0;o_()|0}if(a[88248]&1){I=+h[11032];K=+h[11078]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[88248]=1;da=+h[11032]}h[11078]=da;c[22056]=0;y=0}if((c[j>>2]|0)>=0){c[88980>>2]=6;G_(88976)|0;XZ(89384,88272,4)|0;o_()|0;c[89004>>2]=6;G_(89e3)|0;y=c[e>>2]|0;c[21016]=1;if((y|0)>=1){B=1;do{XZ(89384,b+(B+ -1<<3)|0,8)|0;A=c[21016]|0;B=A+1|0;c[21016]=B;}while((A|0)<(y|0))}o_()|0;c[89028>>2]=6;G_(89024)|0;XZ(89384,s,8)|0;o_()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[89052>>2]=6;G_(89048)|0;o_()|0}h[10985]=+h[f>>3];c[22070]=0;y=c[21458]|0;c[21016]=1;if((y|0)>=1){B=1;while(1){A=83896+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[21016]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[21018]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=80536+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[88464+(E+ -1<<3)>>3]=+h[80536+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[21018]=v+1}se[u&63](e,88464,A)|0;c[22070]=(c[22070]|0)+1;c[22068]=(c[22068]|0)+1;E=c[21016]|0;I=+h[83896+(E+ -1<<3)>>3];if(I>=+h[10985]){B=E;continue}h[10985]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[89076>>2]=6;G_(89072)|0;XZ(89384,88272,4)|0;XZ(89384,87880,8)|0;E=c[e>>2]|0;c[21018]=1;if((E|0)>=1){z=1;do{XZ(89384,88464+(z+ -1<<3)|0,8)|0;G=c[21018]|0;z=G+1|0;c[21018]=z;}while((G|0)<(E|0))}o_()|0;B=c[21016]|0}}B=c[21462]|0;c[21016]=1;do{if((B|0)<1){h[10512]=+h[10487];c[21016]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[21026]=E;z=c[e>>2]|0;c[21018]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[88296+(A+ -1<<3)>>3]=(+h[80536+(v+ -21<<3)>>3]+ +h[80536+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[21018]=z+1}se[u&63](e,88296,85856+(y+ -1<<3)|0)|0;c[22070]=(c[22070]|0)+1;c[22068]=(c[22068]|0)+1;A=c[21016]|0;y=A+1|0;c[21016]=y;}while((A|0)<(B|0));y=c[21462]|0;I=+h[10487];h[10512]=I;c[21016]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[21026]=A;c[21028]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[21018]=1;E=1;while(1){v=E+1|0;c[21030]=v;G=c[e>>2]|0;c[21020]=1;if((G|0)>=1){x=c[21028]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[88464+(T+ -1<<3)>>3]=(+h[80536+(U+x<<3)>>3]+ +h[80536+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[21020]=G+1}se[u&63](e,88464,88456)|0;c[22070]=(c[22070]|0)+1;c[22068]=(c[22068]|0)+1;T=c[21016]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[21018]|0;la=U+x|0;c[21022]=la;I=+h[10512];h[86176+(la+ -1<<3)>>3]=(+h[11057]+I- +h[85856+(v<<3)>>3]- +h[85856+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[21018]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[21016]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[21462]|0;c[21022]=0;c[21016]=1;E=(y|0)<1;if(E){c[21016]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Yaa(A|0,0,y+ -2|0,0)|0;A=Raa(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[86176+(U+ -1<<3)>>3]=(+h[83896+(v<<3)>>3]+ka- +h[85856+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[21026]=v+1;c[21022]=(z|1)+A;c[21016]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=85856+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[83896+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[21026]=T+1;c[21016]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[21022]=0;c[21016]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[21016]=1;if((B|0)>=1){A=1;while(1){h[87896+(A+ -1<<3)>>3]=+h[80536+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[21016]=B+1}c[21016]=1;do{if(ma){c[21016]=1}else{A=1;while(1){z=A+1|0;c[21026]=z;v=c[e>>2]|0;c[21018]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=80536+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[80536+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[21018]=v+1}c[21016]=z;if((A|0)<(na|0)){A=z}else{break}}c[21016]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[21026]=A;y=c[e>>2]|0;c[21018]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[80536+(T+oa<<3)>>3]=+h[80536+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[21018]=y+1}c[21016]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=86176;EJ(B,85848,B,88056,88632,q,88216)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[89100>>2]=6;G_(89096)|0;o_()|0}c[q>>2]=2;if((c[22068]|0)>(c[g>>2]|0)){R=312;break}c[89124>>2]=6;G_(89120)|0;o_()|0;B=c[e>>2]|0;c[21016]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[21016]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[88812>>2]=6;G_(88808)|0;XZ(89384,g,4)|0;o_()|0;c[88836>>2]=6;G_(88832)|0;XZ(89384,87888,8)|0;o_()|0;c[88860>>2]=6;G_(88856)|0;u=c[e>>2]|0;c[21016]=1;if((u|0)>=1){E=1;do{XZ(89384,b+(E+ -1<<3)|0,8)|0;z=c[21016]|0;E=z+1|0;c[21016]=E;}while((z|0)<(u|0))}o_()|0;c[88884>>2]=6;G_(88880)|0;XZ(89384,s,8)|0;o_()|0;i=r;return 0}else if((R|0)==226){u=c[21462]|0;c[22066]=u-(c[22158]|0);c[21016]=1;E=(u|0)<1;do{if(E){h[11029]=0.0;c[21016]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[83896+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=83896+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[86176+(sa+ -1<<3)>>3]*+h[85856+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[21022]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[21018]=z;h[11029]=0.0;c[21016]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[83896+(v<<3)>>3]*+h[85856+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[11029]=wa;c[21016]=u+1;qa=wa}}while(0);h[11029]=+h[10512]-qa;s=c[e>>2]|0;c[21016]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[88464+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=88464+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[83896+(T+ -1<<3)>>3]*+h[80536+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[21016]=s+1;c[21018]=xa}v=c[e>>2]|0;c[21016]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=87896+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[88464+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[21016]=v+1}if((c[j>>2]|0)>=0){c[89148>>2]=6;G_(89144)|0;XZ(89384,88232,8)|0;z=c[e>>2]|0;c[21016]=1;if((z|0)>=1){s=1;do{XZ(89384,87896+(s+ -1<<3)|0,8)|0;u=c[21016]|0;s=u+1|0;c[21016]=s;}while((u|0)<(z|0))}o_()|0;c[89172>>2]=6;G_(89168)|0;o_()|0}z=c[e>>2]|0;c[21016]=1;if((z|0)>=1){s=c[21462]|0;v=1;while(1){c[21018]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[83896+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=83896+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[86176+(Aa+ -1<<3)>>3]*+h[80536+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[21022]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[21020]=E;c[21018]=s+1}T=c[e>>2]|0;c[21018]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=84152+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[83896+(Ea+ -1<<3)>>3]*+h[80536+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[21018]=T+1;c[21022]=Ca;c[21020]=Da}za=v+1|0;c[21016]=za;if((v|0)<(z|0)){v=za}else{break}}}c[21018]=0;v=c[e>>2]|0;c[21016]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[84152+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[21018]=Ga;c[21016]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[89196>>2]=6;G_(89192)|0;XZ(89384,88264,4)|0;o_()|0;c[21460]=1;z=1;d:while(1){c[21022]=z;do{if((z|0)>(c[e>>2]|0)){s=c[21460]|0;if((s|0)==1){c[89220>>2]=6;G_(89216)|0;o_()|0;EJ(84152,85848,86176,88056,88632,q,88216)|0;c[89244>>2]=6;G_(89240)|0;o_()|0;c[21460]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[21460]=2;c[21032]=0;c[21034]=0;s=c[e>>2]|0;c[21016]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Yaa(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=Raa(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=84152+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=84152+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[84152+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[21036]=Na;c[21034]=Ta;c[21032]=Ia;c[21018]=Ma;c[21016]=s+1}c[89268>>2]=6;G_(89264)|0;o_()|0;c[21032]=0;u=c[e>>2]|0;c[21016]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=84152+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[21032]=Wa;c[21016]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[21032]=T;s=c[e>>2]|0;c[21016]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[21026]=B;Qa=za+la|0;c[21032]=Qa;Pa=B+5|0;c[21028]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[21460]|0)==3){c[89340>>2]=6;G_(89336)|0;Pa=c[21028]|0;Qa=c[21026]|0;c[21018]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{XZ(89384,86176+(B+ -1<<3)|0,8)|0;Qa=c[21018]|0;B=Qa+1|0;c[21018]=B;}while((Qa|0)<(Pa|0))}o_()|0}else{c[89316>>2]=6;G_(89312)|0;Pa=c[21028]|0;B=c[21026]|0;c[21018]=B;if((B|0)<=(Pa|0)){x=B;do{XZ(89384,84152+(x+ -1<<3)|0,8)|0;B=c[21018]|0;x=B+1|0;c[21018]=x;}while((B|0)<(Pa|0))}o_()|0}Pa=c[21016]|0;x=Pa+1|0;c[21016]=x;if((Pa|0)>=(s|0)){break e}E=c[21022]|0;la=c[21032]|0;za=x}}}while(0);c[89364>>2]=6;G_(89360)|0;o_()|0;z=(c[21022]|0)+6|0}c[89292>>2]=6;G_(89288)|0;XZ(89384,88280,4)|0;o_()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);se[p&63](e,b,f)|0;i=r;return 0}function EJ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[22366]=c[b>>2];c[g>>2]=1;if((c[22366]|0)<1){i=k;return 0}c[g>>2]=0;FJ(a,89464,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[22366]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[22358]=f;c[22364]=g;c[22370]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Yaa(a|0,0,g+ -2|0,0)|0;m=Raa(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[22350]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Yaa(p|0,0,a-n|0,0)|0;p=Raa(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[22350]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[22348]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[22348]=j}c[22360]=g;c[22362]=f;c[22368]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[11178]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[11178]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[11178]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[22368]=D;E=v+ -1|0;c[22360]=E;F=w+ -1|0;c[22362]=F;q=D;v=E;w=F}c[22352]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[22354]=t;c[22364]=0;c[22370]=l-g;i=k;return 0}function FJ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[11192]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[11192]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[11192];c[22374]=1;c[22376]=0;n=c[b>>2]|0;c[22388]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[22378]=0;c[22390]=1;do{if((o|0)>=1){p=1;q=c[22376]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[11191]=m;u=(p|0)==(o|0);if(u){l=m*+h[11192];h[11193]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[11191]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[11193]=+h[11193]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[22378]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[22378]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[11191];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[22390]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[22372]=y;c[22380]=x;c[22376]=s;break}else if((D|0)==26){D=0;c[22372]=y;c[22380]=x;c[22376]=s;break}}}while(0);m=+V(+(+h[11193]));h[11193]=m;H=+h[11191];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[22376]|0)+ -1<<3)>>3]=G;G=+h[11193]/+h[11191];h[j+((c[22372]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[22376]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[22374]|0;O=c[22388]|0}}while(0);b=N+O|0;c[22374]=b;o=O+1|0;c[22388]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[22372]=y;c[22380]=x;c[22376]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function GJ(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[22414]=n;o=(c[d>>2]|0)-n|0;c[22436]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[22434]=s;a[89680]=1;t=c[b>>2]|0;u=t+1|0;c[22430]=u;v=c[b>>2]|0;w=u+v|0;c[22428]=w;u=w+(c[b>>2]|0)|0;c[22432]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[22422]=w;x=w+(c[d>>2]|0)|0;c[22416]=x;y=x+(c[b>>2]|0)|0;c[22418]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[22424]=z;A=z+(c[d>>2]|0)|0;c[22438]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[22440]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[22412]=C;D=C+(c[b>>2]|0)|0;c[22426]=D;HJ(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,89736,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);G_(89768)|0;o_()|0;i=m;return 0}



function nm(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+312>>3]*+h[e+984>>3];Jaa(a+8|0,0,248)|0;h[a+256>>3]=-+h[e+1160>>3];h[a+264>>3]=+h[e>>3]*+h[e+1e3>>3];i=d;return}function om(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,1.0,0,b);ze[c[e>>2]&3](0,2,-1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,1,+h[(c[f>>2]|0)+19184>>3],2,b);ze[c[e>>2]&3](1,2,1.0,3,b);ze[c[e>>2]&3](2,0,-1.0,4,b);ze[c[e>>2]&3](2,1,+h[(c[f>>2]|0)+18944>>3],5,b);i=d;return}function pm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[d+432>>3];h[a+8>>3]=0.0;h[a+16>>3]=+h[d+456>>3];i=i;return}function qm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,-1.0,0,b);ze[c[e>>2]&3](0,5,1.0,1,b);ze[c[e>>2]&3](1,4,1.0,2,b);f=a+4|0;ze[c[e>>2]&3](1,5,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2712>>3],3,b);ze[c[e>>2]&3](2,3,-1.0,4,b);ze[c[e>>2]&3](2,4,1.0,5,b);ze[c[e>>2]&3](3,2,-1.0,6,b);ze[c[e>>2]&3](3,3,1.0,7,b);ze[c[e>>2]&3](4,1,1.0,8,b);ze[c[e>>2]&3](4,2,1.0,9,b);ze[c[e>>2]&3](5,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2720>>3],10,b);ze[c[e>>2]&3](5,1,1.0,11,b);i=d;return}function rm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[d+64>>3]- +h[d+2048>>3];h[a+8>>3]=0.0;h[a+16>>3]=-+h[d+48>>3];h[a+24>>3]=-+h[d+56>>3];h[a+32>>3]=+h[d+2176>>3];h[a+40>>3]=0.0;i=i;return}function sm(b,d){b=b|0;d=d|0;var e=0,f=0,j=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,B=0.0,C=0,D=0.0,E=0,F=0,G=0.0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,V=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0,ca=0.0,ea=0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0.0,oa=0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0,Ta=0.0,Ua=0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0,_a=0.0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0,fb=0.0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0,xb=0.0,yb=0.0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0,Lb=0.0,Mb=0,Nb=0.0,Ob=0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0,Tb=0.0,Ub=0,Vb=0.0,Wb=0,Xb=0,Yb=0.0,Zb=0.0,_b=0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0.0,hc=0,ic=0.0,jc=0.0,kc=0,lc=0.0,mc=0.0,nc=0,oc=0.0,pc=0.0,qc=0,rc=0.0,sc=0.0,tc=0.0,uc=0,vc=0.0,wc=0,xc=0.0,yc=0.0,zc=0,Ac=0.0,Bc=0,Cc=0.0,Dc=0.0,Ec=0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0,Sc=0.0,Tc=0.0;e=i;i=i+7648|0;ze[c[(d+8|0)>>2]&3](0,1,1.0,0,d);ze[c[(d+8|0)>>2]&3](0,3,1.0,1,d);ze[c[(d+8|0)>>2]&3](0,25,1.0,2,d);ze[c[(d+8|0)>>2]&3](1,24,1.0,3,d);ze[c[(d+8|0)>>2]&3](1,25,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1352>>3],4,d);ze[c[(d+8|0)>>2]&3](2,22,-1.0,5,d);ze[c[(d+8|0)>>2]&3](2,23,1.0,6,d);ze[c[(d+8|0)>>2]&3](2,24,1.0,7,d);ze[c[(d+8|0)>>2]&3](3,0,1.0,8,d);ze[c[(d+8|0)>>2]&3](3,22,-1.0,9,d);ze[c[(d+8|0)>>2]&3](3,23,1.0,10,d);ze[c[(d+8|0)>>2]&3](4,2,1.0,11,d);ze[c[(d+8|0)>>2]&3](4,21,1.0,12,d);ze[c[(d+8|0)>>2]&3](4,22,-1.0,13,d);ze[c[(d+8|0)>>2]&3](5,13,1.0,14,d);ze[c[(d+8|0)>>2]&3](5,20,1.0,15,d);ze[c[(d+8|0)>>2]&3](5,21,-1.0,16,d);ze[c[(d+8|0)>>2]&3](6,7,1.0,17,d);ze[c[(d+8|0)>>2]&3](6,19,1.0,18,d);ze[c[(d+8|0)>>2]&3](6,20,1.0,19,d);ze[c[(d+8|0)>>2]&3](7,14,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1792>>3],20,d);ze[c[(d+8|0)>>2]&3](7,18,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1856>>3],21,d);ze[c[(d+8|0)>>2]&3](7,19,1.0,22,d);f=c[c[(b+4|0)>>2]>>2]|0;j=+h[(c[f+8>>2]|0)+1784>>3];if(j!=0.0){l=j}else{l=+xH(c[b+536>>2]|0,j,13048,13096,+h[f>>3],(a[b+319|0]|0)!=0|0)}j=1.0/l;ze[c[(d+8|0)>>2]&3](8,17,j*j,23,d);ze[c[(d+8|0)>>2]&3](8,18,1.0,24,d);f=c[(b+416|0)>>2]|0;j=+h[f+17592>>3];l=+h[f+17600>>3];do{if(j!=0.0){m=l/j}else{if(l==0.0){m=l;break}m=l/+xH(c[b+536>>2]|0,j,12784,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(m>0.0)){f=c[28168]|0;n=c[b+536>>2]|0;h[k>>3]=m;c[(e+24|0)>>2]=c[k>>2];c[(e+24|0)+4>>2]=c[k+4>>2];c[e+0>>2]=c[13104+0>>2];c[e+4>>2]=c[13104+4>>2];c[e+8>>2]=c[13104+8>>2];c[e+12>>2]=c[13104+12>>2];c[e+16>>2]=c[13104+16>>2];c[e+20>>2]=c[13104+20>>2];Pe[f&31](n,e,12824,e+24|0);}n=c[(d+8|0)>>2]|0;j=+da(+m);m=+h[(c[(b+416|0)>>2]|0)+17584>>3];do{if(j!=0.0){o=m/j}else{if(m==0.0){o=m;break}o=m/+xH(c[b+536>>2]|0,j,12960,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[n&3](9,16,o*-7895683520871486.0e-21,25,d);ze[c[(d+8|0)>>2]&3](9,17,1.0,26,d);o=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;j=+h[(c[n+8>>2]|0)+1776>>3];do{if(o!=0.0){p=j/o}else{if(j==0.0){p=j;break}p=j/+xH(c[b+536>>2]|0,o,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(p>0.0){q=1.0}else{p=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;o=+h[(c[n+8>>2]|0)+1776>>3];do{if(p!=0.0){r=o/p}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,p,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);q=+(r<0.0|0)}r=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;p=+h[(c[n+8>>2]|0)+1776>>3];do{if(r!=0.0){s=p/r}else{if(p==0.0){s=p;break}s=p/+xH(c[b+536>>2]|0,r,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(s>0.0){t=1.0}else{s=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;r=+h[(c[n+8>>2]|0)+1776>>3];do{if(s!=0.0){u=r/s}else{if(r==0.0){u=r;break}u=r/+xH(c[b+536>>2]|0,s,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);t=+(u<0.0|0)}u=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;s=+h[(c[n+8>>2]|0)+1776>>3];do{if(u!=0.0){v=s/u}else{if(s==0.0){v=s;break}v=s/+xH(c[b+536>>2]|0,u,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(v>0.0){w=1.0}else{v=+h[(c[(b+416|0)>>2]|0)+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;u=+h[(c[n+8>>2]|0)+1776>>3];do{if(v!=0.0){x=u/v}else{if(u==0.0){x=u;break}x=u/+xH(c[b+536>>2]|0,v,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);w=+(x<0.0|0)}n=c[(b+416|0)>>2]|0;x=+h[n+17568>>3];v=+h[n+17552>>3];f=c[c[(b+4|0)>>2]>>2]|0;u=+h[(c[f+8>>2]|0)+1776>>3];do{if(v!=0.0){y=u;z=f;B=v;C=n;D=u/v}else{if(u==0.0){y=u;z=f;B=v;C=n;D=u;break}s=u/+xH(c[b+536>>2]|0,v,12440,13096,+h[f>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;F=c[c[(b+4|0)>>2]>>2]|0;y=+h[(c[F+8>>2]|0)+1776>>3];z=F;B=+h[E+17552>>3];C=E;D=s}}while(0);v=x*+U(+D);do{if(B!=0.0){G=y;J=z;K=B;L=C;M=y/B}else{if(y==0.0){G=y;J=z;K=B;L=C;M=y;break}D=y/+xH(c[b+536>>2]|0,B,12440,13096,+h[z>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;n=c[c[(b+4|0)>>2]>>2]|0;G=+h[(c[n+8>>2]|0)+1776>>3];J=n;K=+h[f+17552>>3];L=f;M=D}}while(0);B=+U(+M);M=v+ +W(+B,+(+h[L+17576>>3]))+1.0;z=c[(d+8|0)>>2]|0;B=+h[L+17544>>3];v=+h[L+17560>>3];C=K!=0.0;do{f=1;if(f){f=0;if(M*M!=0.0){do{if(C){N=K;O=L;P=G/K}else{if(G==0.0){N=K;O=L;P=G;break}y=G/+xH(c[b+536>>2]|0,K,12440,13096,+h[J>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;N=+h[n+17552>>3];O=n;P=y}}while(0);y=B+v*+U(+P)+-1.0;D=+h[O+17568>>3];do{if(N!=0.0){Q=N;R=O;S=q/N}else{if(q==0.0){Q=N;R=O;S=q;break}x=q/+xH(c[b+536>>2]|0,N,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;Q=+h[n+17552>>3];R=n;S=x}}while(0);x=D*S;n=c[c[(b+4|0)>>2]>>2]|0;u=+h[(c[n+8>>2]|0)+1776>>3];do{if(Q!=0.0){T=Q;V=R;X=u/Q}else{if(u==0.0){T=Q;V=R;X=u;break}s=u/+xH(c[b+536>>2]|0,Q,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;T=+h[E+17552>>3];V=E;X=s}}while(0);u=+U(+X);D=+h[V+17576>>3];s=+W(+u,+(D+-1.0));do{if(T!=0.0){Y=T;Z=V;_=t/T}else{if(t==0.0){Y=T;Z=V;_=t;break}u=t/+xH(c[b+536>>2]|0,T,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;Y=+h[n+17552>>3];Z=n;_=u}}while(0);u=y*(x+s*D*_);r=+h[Z+17560>>3];p=+h[Z+17568>>3];n=c[c[(b+4|0)>>2]>>2]|0;o=+h[(c[n+8>>2]|0)+1776>>3];do{if(Y!=0.0){j=+U(+(o/Y));$=(p*j+ +W(+j,+(+h[Z+17576>>3]))+1.0)/Y}else{if(o==0.0){aa=o;ba=n;ca=Y;ea=Z;fa=o}else{j=o/+xH(c[b+536>>2]|0,Y,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;F=c[c[(b+4|0)>>2]>>2]|0;aa=+h[(c[F+8>>2]|0)+1776>>3];ba=F;ca=+h[E+17552>>3];ea=E;fa=j}j=p*+U(+fa);do{if(ca!=0.0){ga=aa;ha=ba;ia=ca;ja=ea;ka=aa/ca}else{if(aa==0.0){ga=aa;ha=ba;ia=ca;ja=ea;ka=aa;break}m=aa/+xH(c[b+536>>2]|0,ca,12440,13096,+h[ba>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;F=c[c[(b+4|0)>>2]>>2]|0;ga=+h[(c[F+8>>2]|0)+1776>>3];ha=F;ia=+h[E+17552>>3];ja=E;ka=m}}while(0);m=+U(+ka);E=j+ +W(+m,+(+h[ja+17576>>3]))+1.0==0.0;m=+h[ja+17568>>3];F=ia!=0.0;if(E){do{if(F){la=ga;ma=ha;na=ia;oa=ja;pa=ga/ia}else{if(ga==0.0){la=ga;ma=ha;na=ia;oa=ja;pa=ga;break}l=ga/+xH(c[b+536>>2]|0,ia,12440,13096,+h[ha>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;la=+h[(c[qa+8>>2]|0)+1776>>3];ma=qa;na=+h[E+17552>>3];oa=E;pa=l}}while(0);j=m*+U(+pa);do{if(na!=0.0){ra=oa;sa=la/na}else{if(la==0.0){ra=oa;sa=la;break}l=la/+xH(c[b+536>>2]|0,na,12440,13096,+h[ma>>3],(a[b+319|0]|0)!=0|0);ra=c[(b+416|0)>>2]|0;sa=l}}while(0);l=+U(+sa);$=j+ +W(+l,+(+h[ra+17576>>3]))+1.0;break}else{do{if(F){ta=ga;ua=ha;va=ia;wa=ja;xa=ga/ia}else{if(ga==0.0){ta=ga;ua=ha;va=ia;wa=ja;xa=ga;break}l=ga/+xH(c[b+536>>2]|0,ia,12440,13096,+h[ha>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;ta=+h[(c[qa+8>>2]|0)+1776>>3];ua=qa;va=+h[E+17552>>3];wa=E;xa=l}}while(0);j=m*+U(+xa);do{if(va!=0.0){ya=ua;za=va;Aa=wa;Ba=ta/va}else{if(ta==0.0){ya=ua;za=va;Aa=wa;Ba=ta;break}l=ta/+xH(c[b+536>>2]|0,va,12440,13096,+h[ua>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;ya=c[c[(b+4|0)>>2]>>2]|0;za=+h[F+17552>>3];Aa=F;Ba=l}}while(0);m=+U(+Ba);l=j+ +W(+m,+(+h[Aa+17576>>3]))+1.0;$=l/+xH(c[b+536>>2]|0,za,12440,13096,+h[ya>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ca=(u-r*w*$)/(M*M)}else{f=1}}if(f){f=0;if(1){do{if(C){Da=K;Ea=L;Fa=G/K}else{if(G==0.0){Da=K;Ea=L;Fa=G;break}p=G/+xH(c[b+536>>2]|0,K,12440,13096,+h[J>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;Da=+h[n+17552>>3];Ea=n;Fa=p}}while(0);r=B+v*+U(+Fa)+-1.0;u=+h[Ea+17568>>3];do{if(Da!=0.0){Ga=Da;Ha=Ea;Ia=q/Da}else{if(q==0.0){Ga=Da;Ha=Ea;Ia=q;break}p=q/+xH(c[b+536>>2]|0,Da,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;Ga=+h[n+17552>>3];Ha=n;Ia=p}}while(0);p=u*Ia;n=c[c[(b+4|0)>>2]>>2]|0;o=+h[(c[n+8>>2]|0)+1776>>3];do{if(Ga!=0.0){Ja=Ga;Ka=Ha;La=o/Ga}else{if(o==0.0){Ja=Ga;Ka=Ha;La=o;break}D=o/+xH(c[b+536>>2]|0,Ga,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;Ja=+h[F+17552>>3];Ka=F;La=D}}while(0);o=+U(+La);u=+h[Ka+17576>>3];D=+W(+o,+(u+-1.0));do{if(Ja!=0.0){Ma=Ja;Na=Ka;Oa=t/Ja}else{if(t==0.0){Ma=Ja;Na=Ka;Oa=t;break}o=t/+xH(c[b+536>>2]|0,Ja,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;Ma=+h[n+17552>>3];Na=n;Oa=o}}while(0);o=r*(p+D*u*Oa);s=+h[Na+17560>>3];x=+h[Na+17568>>3];n=c[c[(b+4|0)>>2]>>2]|0;y=+h[(c[n+8>>2]|0)+1776>>3];do{if(Ma!=0.0){l=+U(+(y/Ma));Pa=Na;Qa=(x*l+ +W(+l,+(+h[Na+17576>>3]))+1.0)/Ma}else{if(y==0.0){Ra=y;Sa=n;Ta=Ma;Ua=Na;Va=y}else{l=y/+xH(c[b+536>>2]|0,Ma,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;Ra=+h[(c[E+8>>2]|0)+1776>>3];Sa=E;Ta=+h[F+17552>>3];Ua=F;Va=l}l=x*+U(+Va);do{if(Ta!=0.0){Wa=Ra;Xa=Sa;Ya=Ta;Za=Ua;_a=Ra/Ta}else{if(Ra==0.0){Wa=Ra;Xa=Sa;Ya=Ta;Za=Ua;_a=Ra;break}m=Ra/+xH(c[b+536>>2]|0,Ta,12440,13096,+h[Sa>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;E=c[c[(b+4|0)>>2]>>2]|0;Wa=+h[(c[E+8>>2]|0)+1776>>3];Xa=E;Ya=+h[F+17552>>3];Za=F;_a=m}}while(0);j=+U(+_a);F=l+ +W(+j,+(+h[Za+17576>>3]))+1.0==0.0;j=+h[Za+17568>>3];E=Ya!=0.0;if(F){do{if(E){$a=Wa;ab=Xa;bb=Ya;cb=Za;db=Wa/Ya}else{if(Wa==0.0){$a=Wa;ab=Xa;bb=Ya;cb=Za;db=Wa;break}m=Wa/+xH(c[b+536>>2]|0,Ya,12440,13096,+h[Xa>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;$a=+h[(c[qa+8>>2]|0)+1776>>3];ab=qa;bb=+h[F+17552>>3];cb=F;db=m}}while(0);l=j*+U(+db);do{if(bb!=0.0){eb=cb;fb=$a/bb}else{if($a==0.0){eb=cb;fb=$a;break}m=$a/+xH(c[b+536>>2]|0,bb,12440,13096,+h[ab>>3],(a[b+319|0]|0)!=0|0);eb=c[(b+416|0)>>2]|0;fb=m}}while(0);m=+U(+fb);Pa=eb;Qa=l+ +W(+m,+(+h[eb+17576>>3]))+1.0;break}else{do{if(E){gb=Wa;hb=Xa;ib=Ya;jb=Za;kb=Wa/Ya}else{if(Wa==0.0){gb=Wa;hb=Xa;ib=Ya;jb=Za;kb=Wa;break}m=Wa/+xH(c[b+536>>2]|0,Ya,12440,13096,+h[Xa>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;gb=+h[(c[qa+8>>2]|0)+1776>>3];hb=qa;ib=+h[F+17552>>3];jb=F;kb=m}}while(0);l=j*+U(+kb);do{if(ib!=0.0){lb=hb;mb=ib;nb=jb;ob=gb/ib}else{if(gb==0.0){lb=hb;mb=ib;nb=jb;ob=gb;break}m=gb/+xH(c[b+536>>2]|0,ib,12440,13096,+h[hb>>3],(a[b+319|0]|0)!=0|0);E=c[(b+416|0)>>2]|0;lb=c[c[(b+4|0)>>2]>>2]|0;mb=+h[E+17552>>3];nb=E;ob=m}}while(0);j=+U(+ob);m=l+ +W(+j,+(+h[nb+17576>>3]))+1.0;j=m/+xH(c[b+536>>2]|0,mb,12440,13096,+h[lb>>3],(a[b+319|0]|0)!=0|0);Pa=c[(b+416|0)>>2]|0;Qa=j;break}}}while(0);x=+h[Pa+17544>>3];y=+h[Pa+17560>>3];u=+h[Pa+17552>>3];n=c[c[(b+4|0)>>2]>>2]|0;D=+h[(c[n+8>>2]|0)+1776>>3];E=1;if(E){E=0;if(o-s*w*Qa==0.0){do{if(u!=0.0){pb=u;qb=Pa;rb=D/u}else{if(D==0.0){pb=u;qb=Pa;rb=D;break}p=D/+xH(c[b+536>>2]|0,u,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;pb=+h[F+17552>>3];qb=F;rb=p}}while(0);s=x+y*+U(+rb)+-1.0;o=+h[qb+17568>>3];do{if(pb!=0.0){sb=pb;tb=qb;ub=q/pb}else{if(q==0.0){sb=pb;tb=qb;ub=q;break}p=q/+xH(c[b+536>>2]|0,pb,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;sb=+h[F+17552>>3];tb=F;ub=p}}while(0);p=o*ub;F=c[c[(b+4|0)>>2]>>2]|0;r=+h[(c[F+8>>2]|0)+1776>>3];do{if(sb!=0.0){vb=sb;wb=tb;xb=r/sb}else{if(r==0.0){vb=sb;wb=tb;xb=r;break}j=r/+xH(c[b+536>>2]|0,sb,12440,13096,+h[F>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;vb=+h[qa+17552>>3];wb=qa;xb=j}}while(0);r=+U(+xb);o=+h[wb+17576>>3];j=+W(+r,+(o+-1.0));do{if(vb!=0.0){yb=vb;zb=wb;Ab=t/vb}else{if(t==0.0){yb=vb;zb=wb;Ab=t;break}r=t/+xH(c[b+536>>2]|0,vb,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;yb=+h[F+17552>>3];zb=F;Ab=r}}while(0);r=s*(p+j*o*Ab);m=+h[zb+17560>>3];Bb=+h[zb+17568>>3];F=c[c[(b+4|0)>>2]>>2]|0;Cb=+h[(c[F+8>>2]|0)+1776>>3];do{if(yb!=0.0){Db=+U(+(Cb/yb));Eb=(Bb*Db+ +W(+Db,+(+h[zb+17576>>3]))+1.0)/yb}else{if(Cb==0.0){Fb=Cb;Gb=F;Hb=yb;Ib=zb;Jb=Cb}else{Db=Cb/+xH(c[b+536>>2]|0,yb,12440,13096,+h[F>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;Kb=c[c[(b+4|0)>>2]>>2]|0;Fb=+h[(c[Kb+8>>2]|0)+1776>>3];Gb=Kb;Hb=+h[qa+17552>>3];Ib=qa;Jb=Db}Db=Bb*+U(+Jb);do{if(Hb!=0.0){Lb=Fb;Mb=Gb;Nb=Hb;Ob=Ib;Pb=Fb/Hb}else{if(Fb==0.0){Lb=Fb;Mb=Gb;Nb=Hb;Ob=Ib;Pb=Fb;break}Qb=Fb/+xH(c[b+536>>2]|0,Hb,12440,13096,+h[Gb>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;Kb=c[c[(b+4|0)>>2]>>2]|0;Lb=+h[(c[Kb+8>>2]|0)+1776>>3];Mb=Kb;Nb=+h[qa+17552>>3];Ob=qa;Pb=Qb}}while(0);l=+U(+Pb);qa=Db+ +W(+l,+(+h[Ob+17576>>3]))+1.0==0.0;l=+h[Ob+17568>>3];Kb=Nb!=0.0;if(qa){do{if(Kb){Rb=Lb;Sb=Mb;Tb=Nb;Ub=Ob;Vb=Lb/Nb}else{if(Lb==0.0){Rb=Lb;Sb=Mb;Tb=Nb;Ub=Ob;Vb=Lb;break}Qb=Lb/+xH(c[b+536>>2]|0,Nb,12440,13096,+h[Mb>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;Wb=c[c[(b+4|0)>>2]>>2]|0;Rb=+h[(c[Wb+8>>2]|0)+1776>>3];Sb=Wb;Tb=+h[qa+17552>>3];Ub=qa;Vb=Qb}}while(0);Db=l*+U(+Vb);do{if(Tb!=0.0){Xb=Ub;Yb=Rb/Tb}else{if(Rb==0.0){Xb=Ub;Yb=Rb;break}Qb=Rb/+xH(c[b+536>>2]|0,Tb,12440,13096,+h[Sb>>3],(a[b+319|0]|0)!=0|0);Xb=c[(b+416|0)>>2]|0;Yb=Qb}}while(0);Qb=+U(+Yb);Eb=Db+ +W(+Qb,+(+h[Xb+17576>>3]))+1.0;break}else{do{if(Kb){Zb=Lb;_b=Mb;$b=Nb;ac=Ob;bc=Lb/Nb}else{if(Lb==0.0){Zb=Lb;_b=Mb;$b=Nb;ac=Ob;bc=Lb;break}Qb=Lb/+xH(c[b+536>>2]|0,Nb,12440,13096,+h[Mb>>3],(a[b+319|0]|0)!=0|0);qa=c[(b+416|0)>>2]|0;Wb=c[c[(b+4|0)>>2]>>2]|0;Zb=+h[(c[Wb+8>>2]|0)+1776>>3];_b=Wb;$b=+h[qa+17552>>3];ac=qa;bc=Qb}}while(0);Db=l*+U(+bc);do{if($b!=0.0){cc=_b;dc=$b;ec=ac;fc=Zb/$b}else{if(Zb==0.0){cc=_b;dc=$b;ec=ac;fc=Zb;break}Qb=Zb/+xH(c[b+536>>2]|0,$b,12440,13096,+h[_b>>3],(a[b+319|0]|0)!=0|0);Kb=c[(b+416|0)>>2]|0;cc=c[c[(b+4|0)>>2]>>2]|0;dc=+h[Kb+17552>>3];ec=Kb;fc=Qb}}while(0);l=+U(+fc);Qb=Db+ +W(+l,+(+h[ec+17576>>3]))+1.0;Eb=Qb/+xH(c[b+536>>2]|0,dc,12440,13096,+h[cc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ca=r-m*w*Eb;break}else{E=1}}if(E){E=0;if(1){do{if(u!=0.0){gc=u;hc=Pa;ic=D/u}else{if(D==0.0){gc=u;hc=Pa;ic=D;break}Bb=D/+xH(c[b+536>>2]|0,u,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;gc=+h[F+17552>>3];hc=F;ic=Bb}}while(0);u=x+y*+U(+ic)+-1.0;D=+h[hc+17568>>3];do{if(gc!=0.0){jc=gc;kc=hc;lc=q/gc}else{if(q==0.0){jc=gc;kc=hc;lc=q;break}m=q/+xH(c[b+536>>2]|0,gc,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;jc=+h[n+17552>>3];kc=n;lc=m}}while(0);y=D*lc;n=c[c[(b+4|0)>>2]>>2]|0;x=+h[(c[n+8>>2]|0)+1776>>3];do{if(jc!=0.0){mc=jc;nc=kc;oc=x/jc}else{if(x==0.0){mc=jc;nc=kc;oc=x;break}m=x/+xH(c[b+536>>2]|0,jc,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;mc=+h[F+17552>>3];nc=F;oc=m}}while(0);x=+U(+oc);D=+h[nc+17576>>3];m=+W(+x,+(D+-1.0));do{if(mc!=0.0){pc=mc;qc=nc;rc=t/mc}else{if(t==0.0){pc=mc;qc=nc;rc=t;break}x=t/+xH(c[b+536>>2]|0,mc,12440,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);n=c[(b+416|0)>>2]|0;pc=+h[n+17552>>3];qc=n;rc=x}}while(0);x=u*(y+m*D*rc);r=+h[qc+17560>>3];Bb=+h[qc+17568>>3];n=c[c[(b+4|0)>>2]>>2]|0;Cb=+h[(c[n+8>>2]|0)+1776>>3];do{if(pc!=0.0){o=+U(+(Cb/pc));sc=(Bb*o+ +W(+o,+(+h[qc+17576>>3]))+1.0)/pc}else{if(Cb==0.0){tc=Cb;uc=n;vc=pc;wc=qc;xc=Cb}else{o=Cb/+xH(c[b+536>>2]|0,pc,12440,13096,+h[n>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;Kb=c[c[(b+4|0)>>2]>>2]|0;tc=+h[(c[Kb+8>>2]|0)+1776>>3];uc=Kb;vc=+h[F+17552>>3];wc=F;xc=o}o=Bb*+U(+xc);do{if(vc!=0.0){yc=tc;zc=uc;Ac=vc;Bc=wc;Cc=tc/vc}else{if(tc==0.0){yc=tc;zc=uc;Ac=vc;Bc=wc;Cc=tc;break}j=tc/+xH(c[b+536>>2]|0,vc,12440,13096,+h[uc>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;Kb=c[c[(b+4|0)>>2]>>2]|0;yc=+h[(c[Kb+8>>2]|0)+1776>>3];zc=Kb;Ac=+h[F+17552>>3];Bc=F;Cc=j}}while(0);Db=+U(+Cc);F=o+ +W(+Db,+(+h[Bc+17576>>3]))+1.0==0.0;Db=+h[Bc+17568>>3];Kb=Ac!=0.0;if(F){do{if(Kb){Dc=yc;Ec=zc;Fc=Ac;Gc=Bc;Hc=yc/Ac}else{if(yc==0.0){Dc=yc;Ec=zc;Fc=Ac;Gc=Bc;Hc=yc;break}j=yc/+xH(c[b+536>>2]|0,Ac,12440,13096,+h[zc>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;Dc=+h[(c[qa+8>>2]|0)+1776>>3];Ec=qa;Fc=+h[F+17552>>3];Gc=F;Hc=j}}while(0);o=Db*+U(+Hc);do{if(Fc!=0.0){Ic=Gc;Jc=Dc/Fc}else{if(Dc==0.0){Ic=Gc;Jc=Dc;break}j=Dc/+xH(c[b+536>>2]|0,Fc,12440,13096,+h[Ec>>3],(a[b+319|0]|0)!=0|0);Ic=c[(b+416|0)>>2]|0;Jc=j}}while(0);j=+U(+Jc);sc=o+ +W(+j,+(+h[Ic+17576>>3]))+1.0;break}else{do{if(Kb){Kc=yc;Lc=zc;Mc=Ac;Nc=Bc;Oc=yc/Ac}else{if(yc==0.0){Kc=yc;Lc=zc;Mc=Ac;Nc=Bc;Oc=yc;break}j=yc/+xH(c[b+536>>2]|0,Ac,12440,13096,+h[zc>>3],(a[b+319|0]|0)!=0|0);F=c[(b+416|0)>>2]|0;qa=c[c[(b+4|0)>>2]>>2]|0;Kc=+h[(c[qa+8>>2]|0)+1776>>3];Lc=qa;Mc=+h[F+17552>>3];Nc=F;Oc=j}}while(0);o=Db*+U(+Oc);do{if(Mc!=0.0){Pc=Lc;Qc=Mc;Rc=Nc;Sc=Kc/Mc}else{if(Kc==0.0){Pc=Lc;Qc=Mc;Rc=Nc;Sc=Kc;break}j=Kc/+xH(c[b+536>>2]|0,Mc,12440,13096,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Kb=c[(b+416|0)>>2]|0;Pc=c[c[(b+4|0)>>2]>>2]|0;Qc=+h[Kb+17552>>3];Rc=Kb;Sc=j}}while(0);Db=+U(+Sc);j=o+ +W(+Db,+(+h[Rc+17576>>3]))+1.0;sc=j/+xH(c[b+536>>2]|0,Qc,12440,13096,+h[Pc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Ca=(x-r*w*sc)/+xH(c[b+536>>2]|0,M*M,12488,13096,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);break}else{E=1}}}else{f=1}}}while(0);ze[z&3](10,15,Ca,27,d);ze[c[(d+8|0)>>2]&3](10,16,1.0,28,d);z=c[(d+8|0)>>2]|0;Pc=c[c[(b+4|0)>>2]>>2]|0;Ca=+h[(c[Pc+8>>2]|0)+2776>>3];if(Ca!=0.0){Tc=Ca}else{Tc=+xH(c[b+536>>2]|0,Ca,12408,13096,+h[Pc>>3],(a[b+319|0]|0)!=0|0)}ze[z&3](11,14,1.0/Tc,29,d);ze[c[(d+8|0)>>2]&3](11,15,1.0,30,d);ze[c[(d+8|0)>>2]&3](12,9,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1856>>3],31,d);ze[c[(d+8|0)>>2]&3](12,13,1.0,32,d);c[e+40>>2]=b;c[e+48>>2]=d;c[e+7568>>2]=0;c[e+7572>>2]=0;_setLinearMatrixA709$0(e);H=c[e+7568>>2]|0;A=c[e+7572>>2]|0;I=+g[e+7572>>2];c[e+7568>>2]=0;c[e+7572>>2]=0;if((H|0)==5){return}}function tm(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[e+2552>>3];h[a+8>>3]=+h[e+1368>>3]*+h[e+2336>>3];b=e+2632|0;Jaa(a+16|0,0,160)|0;h[a+176>>3]=-+h[b>>3];h[a+184>>3]=0.0;h[a+192>>3]=+h[b>>3];h[a+200>>3]=+h[e+24>>3]*+h[e+2352>>3];i=d;return}function um(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,1.0,0,b);ze[c[e>>2]&3](0,2,-1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,1,+h[(c[f>>2]|0)+18232>>3],2,b);ze[c[e>>2]&3](1,2,1.0,3,b);ze[c[e>>2]&3](2,0,-1.0,4,b);ze[c[e>>2]&3](2,1,+h[(c[f>>2]|0)+17992>>3],5,b);i=d;return}function vm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[d+1480>>3];h[a+8>>3]=0.0;h[a+16>>3]=+h[d+1504>>3];i=i;return}function wm(a){a=a|0;c[a+20>>2]=175;c[a+16>>2]=34;c[a+12>>2]=81;c[a>>2]=47;c[a+4>>2]=48;c[a+84>>2]=184;c[a+80>>2]=3;c[a+76>>2]=6;c[a+64>>2]=49;c[a+68>>2]=50;c[a+148>>2]=307;c[a+144>>2]=6;c[a+140>>2]=12;c[a+128>>2]=51;c[a+132>>2]=52;c[a+212>>2]=440;c[a+208>>2]=26;c[a+204>>2]=63;c[a+192>>2]=53;c[a+196>>2]=54;c[a+276>>2]=454;c[a+272>>2]=3;c[a+268>>2]=6;c[a+256>>2]=55;c[a+260>>2]=56;c[a+340>>2]=562;c[a+336>>2]=34;c[a+332>>2]=81;c[a+320>>2]=57;c[a+324>>2]=58;c[a+404>>2]=582;c[a+400>>2]=3;c[a+396>>2]=6;c[a+384>>2]=59;c[a+388>>2]=60;c[a+468>>2]=676;c[a+464>>2]=6;c[a+460>>2]=12;c[a+448>>2]=61;c[a+452>>2]=62;c[a+532>>2]=709;c[a+528>>2]=26;c[a+524>>2]=63;c[a+512>>2]=63;c[a+516>>2]=64;c[a+596>>2]=737;c[a+592>>2]=3;c[a+588>>2]=6;c[a+576>>2]=65;c[a+580>>2]=66;i=i;return}function xm(a,b){a=a|0;b=b|0;i=i;return}function ym(a){a=a|0;i=i;return}function zm(a,b){a=a|0;b=b|0;c[b>>2]=c[13712+(a<<2)>>2];i=i;return c[13744+(a<<2)>>2]|0}function Am(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;k=(GK(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+18272>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=k?1.0:-1.0;k=(GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[g>>2]|0)+19016>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=k?1.0:-1.0;k=(GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[g>>2]|0)+18976>>3],a[(c[j>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=k?1.0:-1.0;k=(GK(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+17032>>3],a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=k?1.0:-1.0;k=(GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[g>>2]|0)+18064>>3],a[(c[j>>2]|0)+4|0]|0)|0)<<24>>24!=0;h[d+32>>3]=k?1.0:-1.0;k=(GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[g>>2]|0)+18024>>3],a[(c[j>>2]|0)+5|0]|0)|0)<<24>>24!=0;h[d+40>>3]=k?1.0:-1.0;k=(HK(+h[c[c[f>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[j>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+48>>3]=k?1.0:-1.0;i=e;return 0}function Bm(a){a=a|0;i=i;return c[13744+(a<<2)>>2]|0}function Cm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+18272>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3]<+h[(c[j>>2]|0)+19016>>3]|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3]<+h[(c[j>>2]|0)+18976>>3]|0;a[(c[d>>2]|0)+3|0]=+h[c[c[f>>2]>>2]>>3]<+h[(c[j>>2]|0)+17032>>3]|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1384>>3]<+h[(c[j>>2]|0)+18064>>3]|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1432>>3]<+h[(c[j>>2]|0)+18024>>3]|0;a[(c[d>>2]|0)+6|0]=+h[c[c[f>>2]>>2]>>3]>=+h[(c[b+400>>2]|0)+2648>>3]|0;i=e;return 0}else{d=b+360|0;l=GK(g,k,a[c[d>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=l;l=GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[j>>2]|0)+19016>>3],a[(c[d>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=l;l=GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[j>>2]|0)+18976>>3],a[(c[d>>2]|0)+2|0]|0)|0;a[(c[m>>2]|0)+2|0]=l;l=GK(+h[c[c[f>>2]>>2]>>3],+h[(c[j>>2]|0)+17032>>3],a[(c[d>>2]|0)+3|0]|0)|0;a[(c[m>>2]|0)+3|0]=l;l=GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[j>>2]|0)+18064>>3],a[(c[d>>2]|0)+4|0]|0)|0;a[(c[m>>2]|0)+4|0]=l;l=GK(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[j>>2]|0)+18024>>3],a[(c[d>>2]|0)+5|0]|0)|0;a[(c[m>>2]|0)+5|0]=l;l=HK(+h[c[c[f>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[d>>2]|0)+6|0]|0)|0;a[(c[m>>2]|0)+6|0]=l;i=e;return 0}return 0}function Dm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;rH(8,1,13776,n);n=b+4|0;o=c[c[n>>2]>>2]|0;p=a[(c[o+16>>2]|0)+4|0]|0;q=b+408|0;r=a[(c[q>>2]|0)+4|0]|0;if(p<<24>>24==r<<24>>24){s=o;t=0}else{c[m>>2]=r<<24>>24;c[m+4>>2]=p<<24>>24;rH(8,0,13808,m);s=c[c[n>>2]>>2]|0;t=1}u=+h[(c[s+8>>2]|0)+2648>>3];v=+h[(c[b+400>>2]|0)+2648>>3];if(u!=v){b=l;h[k>>3]=v;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=l+8|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];rH(8,0,13864,l);w=c[c[n>>2]>>2]|0;x=1}else{w=s;x=t}t=c[w+16>>2]|0;w=a[t+3|0]|0;s=c[q>>2]|0;l=a[s+3|0]|0;if(w<<24>>24==l<<24>>24){y=s;z=t;A=x}else{c[j>>2]=l<<24>>24;c[j+4>>2]=w<<24>>24;rH(8,0,13936,j);y=c[q>>2]|0;z=c[(c[c[n>>2]>>2]|0)+16>>2]|0;A=1}j=a[z+2|0]|0;w=a[y+2|0]|0;if(j<<24>>24==w<<24>>24){B=y;C=z;D=A}else{c[g>>2]=w<<24>>24;c[g+4>>2]=j<<24>>24;rH(8,0,14024,g);B=c[q>>2]|0;C=c[(c[c[n>>2]>>2]|0)+16>>2]|0;D=1}g=a[C+1|0]|0;j=a[B+1|0]|0;if(g<<24>>24==j<<24>>24){E=B;F=C;G=D}else{c[f>>2]=j<<24>>24;c[f+4>>2]=g<<24>>24;rH(8,0,14112,f);E=c[q>>2]|0;F=c[(c[c[n>>2]>>2]|0)+16>>2]|0;G=1}n=a[F]|0;F=a[E]|0;if(n<<24>>24==F<<24>>24){H=G}else{c[e>>2]=F<<24>>24;c[e+4>>2]=n<<24>>24;rH(8,0,14200,e);H=1}if((c[63584>>2]|0)==0){i=d;return H|0}me[c[16026]&255](8);i=d;return H|0}function Em(a){a=a|0;i=i;return c[14616+(a<<2)>>2]|0}function Fm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=c[b+424>>2]|0;if((a[j+27|0]|0)==0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=1.0;k=b+320|0;l=b+536|0;m=1.0}else{n=b+536|0;o=b+320|0;dj(e,c[n>>2]|0,c[c[o>>2]>>2]|0,0,a[j+28|0]|0);p=+h[e>>3];h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=p;k=o;l=n;m=p}n=b+4|0;cj(f,c[l>>2]|0,c[c[k>>2]>>2]|0,m);b=c[(c[c[n>>2]>>2]|0)+8>>2]|0;h[b+3056>>3]=+h[f>>3];aj(g,c[l>>2]|0,c[c[k>>2]>>2]|0,+h[b+3064>>3]);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+3048>>3]=+h[g>>3];i=d;return}function Gm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;rH(21,1,14640,m);m=a+4|0;n=a+8|0;o=+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2048>>3]- +h[(c[n>>2]|0)+28768>>3];h[b>>3]=o;p=Em(0)|0;c[l>>2]=1;c[l+4>>2]=p;p=l+8|0;h[k>>3]=o;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rH(21,0,14672,l);o=+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+800>>3]- +h[(c[n>>2]|0)+11296>>3];h[b+8>>3]=o;n=Em(1)|0;c[j>>2]=2;c[j+4>>2]=n;n=j+8|0;h[k>>3]=o;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rH(21,0,14672,j);Fm(a);j=a+416|0;o=+h[(c[j>>2]|0)+19216>>3]- +h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3064>>3];h[b+16>>3]=o;a=Em(2)|0;c[g>>2]=3;c[g+4>>2]=a;a=g+8|0;h[k>>3]=o;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];rH(21,0,14672,g);o=+h[(c[j>>2]|0)+19200>>3]- +h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3056>>3];h[b+24>>3]=o;g=Em(3)|0;c[f>>2]=4;c[f+4>>2]=g;g=f+8|0;h[k>>3]=o;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];rH(21,0,14672,f);o=+h[(c[j>>2]|0)+19208>>3]- +h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+3048>>3];h[b+32>>3]=o;b=Em(4)|0;c[e>>2]=5;c[e+4>>2]=b;b=e+8|0;h[k>>3]=o;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];rH(21,0,14672,e);if((c[63636>>2]|0)==0){i=d;return 0}me[c[16026]&255](21);i=d;return 0}function Hm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19168>>3]=+h[b+18400>>3]+ +h[b+18352>>3];i=i;return}function Im(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19160>>3]=+h[b+18400>>3];i=i;return}function Jm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19152>>3]=+h[b+18328>>3];i=i;return}function Km(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19088>>3]=(+h[b+18400>>3]+.0015)*6.283185307179586;i=i;return}function Lm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19064>>3]=+h[b+18400>>3];i=i;return}function Mm(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+19064>>3];e=+h[b+19056>>3];h[b+19072>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Nm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18936>>3]=+h[b+18880>>3];i=i;return}function Om(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18928>>3]=+h[b+18432>>3];i=i;return}function Pm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19040>>3]=+h[b+18928>>3];i=i;return}function Qm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18920>>3]=+h[b+18440>>3];i=i;return}function Rm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19032>>3]=+h[b+18920>>3];i=i;return}function Sm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18904>>3]=+h[b+18424>>3];i=i;return}function Tm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18968>>3]=+h[b+18904>>3];i=i;return}function Um(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19008>>3]=+h[b+18904>>3];i=i;return}function Vm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18896>>3]=+h[b+18416>>3];i=i;return}function Wm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18960>>3]=+h[b+18896>>3];i=i;return}function Xm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19e3>>3]=+h[b+18896>>3];i=i;return}function Ym(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+18400>>3];h[b+18888>>3]=+h[b+18448>>3]*d*d*+h[b+18408>>3]*3.141592653589793;i=i;return}function Zm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18944>>3]=+h[b+18888>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18872>>3]=+h[b+18400>>3];i=i;return}function $m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18856>>3]=+h[b+18320>>3]+((+h[b+18328>>3]+ +h[b+18344>>3])*-.5+((+h[b+18440>>3]+ +h[b+18432>>3])*-.5- +h[b+18336>>3]));i=i;return}function an(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18848>>3]=+h[b+18392>>3];i=i;return}function bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18840>>3]=+h[b+18384>>3];i=i;return}function cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18832>>3]=+h[b+18376>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18824>>3]=+h[b+18368>>3];i=i;return}function en(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18816>>3]=+h[b+18360>>3];i=i;return}function fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18792>>3]=+h[b+18400>>3]*6.283185307179586;i=i;return}function gn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18784>>3]=(+h[b+18400>>3]+ +h[b+18352>>3]*.5)*6.283185307179586;i=i;return}function hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18776>>3]=+h[b+18400>>3];i=i;return}function jn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18760>>3]=+h[b+18336>>3];i=i;return}function kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18752>>3]=+h[b+18392>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18744>>3]=+h[b+18384>>3];i=i;return}function mn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18736>>3]=+h[b+18376>>3];i=i;return}function nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18728>>3]=+h[b+18368>>3];i=i;return}function on(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18720>>3]=+h[b+18360>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18704>>3]=+h[b+18312>>3];i=i;return}function qn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18696>>3]=+h[b+18400>>3];i=i;return}function rn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18688>>3]=+h[b+18344>>3];i=i;return}function sn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18680>>3]=+h[b+18392>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18672>>3]=+h[b+18384>>3];i=i;return}function un(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18664>>3]=+h[b+18376>>3];i=i;return}function vn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18656>>3]=+h[b+18368>>3];i=i;return}function wn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18648>>3]=+h[b+18360>>3];i=i;return}function xn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18632>>3]=+h[b+18312>>3];i=i;return}function yn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18624>>3]=+h[b+18400>>3]+ +h[b+18352>>3];i=i;return}function zn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18616>>3]=+h[b+18328>>3];i=i;return}function An(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18608>>3]=+h[b+18392>>3];i=i;return}function Bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18600>>3]=+h[b+18384>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18592>>3]=+h[b+18376>>3];i=i;return}function Dn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18584>>3]=+h[b+18368>>3];i=i;return}function En(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18576>>3]=+h[b+18360>>3];i=i;return}function Fn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18560>>3]=+h[b+18304>>3];i=i;return}function Gn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18552>>3]=+h[b+18312>>3];i=i;return}function Hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18544>>3]=+h[b+18320>>3]+(+h[b+18344>>3]+ +h[b+18328>>3])*-.5;i=i;return}function In(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18536>>3]=+h[b+18392>>3];i=i;return}function Jn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18528>>3]=+h[b+18384>>3];i=i;return}function Kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18520>>3]=+h[b+18376>>3];i=i;return}function Ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18512>>3]=+h[b+18368>>3];i=i;return}function Mn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18504>>3]=+h[b+18360>>3];i=i;return}function Nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18488>>3]=+h[b+18296>>3];i=i;return}function On(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18480>>3]=+h[b+18464>>3];i=i;return}function Pn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18456>>3]=+h[b+18288>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18272>>3]=+h[b+18248>>3];i=i;return}function Rn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18264>>3]=+h[b+18240>>3];i=i;return}function Sn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18256>>3]=+h[b+16992>>3];i=i;return}function Tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18280>>3]=+h[b+18256>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[b+19152>>3]*(+h[b+19168>>3]+ +h[b+19160>>3])*3.141592653589793;i=i;return}function Vn(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18872>>3];e=+h[b+18864>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Wn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;j=+h[g+18800>>3]+1.0;if(j>0.0){l=g}else{g=c[28168]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=g;g=d;o=20232;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[g+16>>2]=c[o+16>>2];c[g+20>>2]=c[o+20>>2];Pe[n&31](m,d,14696,e);l=c[f>>2]|0}p=+h[l+18792>>3]*+da(+j)*8.000000000000001e-7;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=p;i=b;return}function Xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[(c[a+416>>2]|0)+18784>>3]*6.53451271946677e-7;i=i;return}function Yn(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18776>>3];e=+h[b+18768>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function Zn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=+h[b+18688>>3]*(+h[b+18704>>3]+ +h[b+18696>>3])*3.141592653589793;i=i;return}function _n(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=+h[b+18616>>3]*(+h[b+18632>>3]+ +h[b+18624>>3])*3.141592653589793;i=i;return}function $n(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18560>>3];e=+h[b+18552>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function ao(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=+h[b+18456>>3]*(+h[b+18472>>3]*(+h[b+18480>>3]- +h[b+18464>>3])+1.0);i=i;return}function bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2976>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2920|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,14792,14784,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2920|0;p=o;h[p>>3]=m;i=d;return}function co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2984>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2912|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,14832,14824,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2912|0;p=o;h[p>>3]=m;i=d;return}function eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+19160>>3];m=+h[j+19168>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,14872,14864,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=20232;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,14904,f);}f=c[g>>2]|0;l=+h[f+19104>>3];m=+da(+n);n=+h[f+19152>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,15024,14864,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=l*r*7895683520871486.0e-21;i=d;return}function fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2904>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2888|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,15112,15104,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2888|0;p=o;h[p>>3]=m;i=d;return}function go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+18272>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+18272>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+18272>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+18272>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+18264>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+856|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+18280>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+856|0;A=z;h[A>>3]=o;i=d;return}function ho(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+800>>3]=0.0;i=i;return}function io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+2928>>3]*+h[b+800>>3];i=i;return}function jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=+h[b+856>>3]- +h[b+832>>3];i=i;return}function ko(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+18488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+808>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,15152,15144,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}function lo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2992>>3];k=+h[g+1160>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,15184,15176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}function mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+832>>3]*+h[b+800>>3];i=i;return}function no(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+800>>3]*+h[(c[a+416>>2]|0)+18488>>3];i=i;return}function oo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+18440>>3];i=i;return}function po(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0;b=i;d=c[a+416>>2]|0;e=+h[d+19048>>3];f=+h[d+19072>>3];d=a+4|0;g=+QI(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+16>>3],-2);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+280>>3]=e*f*g*+(c[(c[a+420>>2]|0)+48>>2]|0)*-1256637061435917.0e-21;i=b;return}function qo(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+16>>3];j=b+416|0;k=c[j>>2]|0;l=+h[k+19088>>3];m=+h[k+19096>>3];n=g*g;do{if(g!=0.0){o=m/g}else{if(m==0.0){o=m;break}o=m/+xH(c[b+536>>2]|0,g,15224,15216,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);f=c[(c[b+420>>2]|0)+52>>2]|0;g=+(f|0);if(n*(o*3.141592653589793+1.0)!=0.0){k=c[c[e>>2]>>2]|0;o=+h[(c[k+8>>2]|0)+16>>3];p=+h[(c[j>>2]|0)+19096>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+xH(c[b+536>>2]|0,o,15224,15216,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=g/(n*(q*3.141592653589793+1.0));s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}if((f|0)==0){r=g;s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}f=c[b+536>>2]|0;k=c[c[e>>2]>>2]|0;q=+h[(c[k+8>>2]|0)+16>>3];o=+h[(c[j>>2]|0)+19096>>3];do{if(q!=0.0){E=k;F=o/q}else{if(o==0.0){E=k;F=o;break}p=o/+xH(f,q,15224,15216,+h[k>>3],(a[b+319|0]|0)!=0|0);E=c[c[e>>2]>>2]|0;F=p}}while(0);r=g/+xH(f,n*(F*3.141592653589793+1.0),15248,15216,+h[E>>3],(a[b+319|0]|0)!=0|0);s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+16>>3];m=b+416|0;n=+h[(c[m>>2]|0)+19096>>3];do{if(l!=0.0){o=n/l}else{if(n==0.0){o=n;break}o=n/+xH(c[b+536>>2]|0,l,15224,15360,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);l=o*3.141592653589793+1.0;if(l>0.0){p=c[m>>2]|0;q=p;r=q+19088|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+232|0;F=E;h[F>>3]=w;i=d;return}j=c[28168]|0;G=c[b+536>>2]|0;b=f;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;H=20232;c[j+0>>2]=c[H+0>>2];c[j+4>>2]=c[H+4>>2];c[j+8>>2]=c[H+8>>2];c[j+12>>2]=c[H+12>>2];c[j+16>>2]=c[H+16>>2];c[j+20>>2]=c[H+20>>2];Pe[b&31](G,e,15368,f);p=c[m>>2]|0;q=p;r=q+19088|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+232|0;F=E;h[F>>3]=w;i=d;return}function so(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,15512,15504,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}function to(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0.0,p=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+19048>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+16>>3];m=+h[e+19072>>3];do{if(l!=0.0){n=k;o=m/l}else{if(m==0.0){n=k;o=m;break}p=m/+xH(c[b+536>>2]|0,l,15224,15544,+h[j>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=p}}while(0);h[n+288>>3]=f*o*1256637061435917.0e-21;i=d;return}function uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,15560,15552,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}function vo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+216>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+216|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+216>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+312>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+312|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+iL(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+312>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+784>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+784|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+784>>3]);e=c[f>>2]|0;h[(c[e+52>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+488>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+488|0;h[(c[e+48>>2]|0)+32>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+488>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+696>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+696|0;h[(c[j+48>>2]|0)+40>>3]=+h[e>>3];k=+iL(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+696>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+40>>3]=k;gL(a,0)|0;g=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[g>>3];h[f+216>>3]=+h[g+8>>3];h[f+312>>3]=+h[g+16>>3];h[f+784>>3]=+h[g+24>>3];h[f+488>>3]=+h[g+32>>3];h[f+696>>3]=+h[g+40>>3];ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);i=b;return}function wo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+304>>3]=d*d*+h[b+280>>3]*.5;i=i;return}function xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3016>>3];k=+h[g+216>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,15600,15592,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}function yo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19104>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,15640,15632,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function zo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3]*1256637061435917.0e-21;k=+h[g+560>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,15712,15704,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}function Ao(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+600>>3]*1256637061435917.0e-21;k=+h[g+616>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,15776,15768,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+656>>3]*1256637061435917.0e-21;k=+h[g+672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,15848,15840,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}function Co(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3]*1256637061435917.0e-21;k=+h[g+736>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,15920,15912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}function _setLinearMatrixA709$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0.0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0,X=0.0,Y=0.0,Z=0,_=0.0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0.0,Oa=0.0,Pa=0,Qa=0.0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0.0,db=0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0.0,mb=0,nb=0.0,ob=0.0,pb=0,qb=0.0,rb=0,sb=0.0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0.0,yb=0,zb=0.0,Ab=0.0,Bb=0,Cb=0.0,Db=0.0,Eb=0,Fb=0.0,Gb=0.0,Hb=0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0,Vb=0.0,Wb=0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0.0,kc=0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0,qc=0.0,rc=0.0,sc=0,tc=0.0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0.0,Ec=0,Fc=0.0,Gc=0.0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Lc=0.0,Mc=0,Nc=0.0,Oc=0,Pc=0.0,Qc=0,Rc=0.0,Sc=0.0,Tc=0,Uc=0.0,Vc=0,Wc=0.0,Xc=0,Yc=0.0,Zc=0,_c=0.0,$c=0.0,ad=0.0,bd=0.0,cd=0,dd=0.0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0.0,vd=0.0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0.0,Hd=0.0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0.0,Ud=0.0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0.0,fe=0.0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0.0,ve=0.0,we=0,xe=0,ye=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0.0,Le=0.0;d=c[b+40>>2]|0;e=c[b+48>>2]|0;a:do{ze[c[(e+8|0)>>2]&3](12,14,-+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1848>>3],33,e);ze[c[(e+8|0)>>2]&3](13,12,1.0,34,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;j=+h[(c[g+8>>2]|0)+2768>>3];if(j!=0.0){k=j}else{k=+xH(c[d+536>>2]|0,j,12368,13096,+h[g>>3],(a[d+319|0]|0)!=0|0)}ze[f&3](13,14,-1.0/k,35,e);ze[c[(e+8|0)>>2]&3](14,11,1.0,36,e);j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){m=l/j}else{if(l==0.0){m=l;break}m=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(m>0.0){n=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){o=l/j}else{if(l==0.0){o=l;break}o=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);n=+(o<0.0|0)}j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){p=l/j}else{if(l==0.0){p=l;break}p=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(p>0.0){q=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){r=l/j}else{if(l==0.0){r=l;break}r=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);q=+(r<0.0|0)}j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){s=l/j}else{if(l==0.0){s=l;break}s=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(s>0.0){t=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17480>>3];f=c[c[(d+4|0)>>2]>>2]|0;l=+h[(c[f+8>>2]|0)+1832>>3];do{if(j!=0.0){u=l/j}else{if(l==0.0){u=l;break}u=l/+xH(c[d+536>>2]|0,j,12e3,13096,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);t=+(u<0.0|0)}f=c[(d+416|0)>>2]|0;j=+h[f+17496>>3];l=+h[f+17480>>3];g=c[c[(d+4|0)>>2]>>2]|0;v=+h[(c[g+8>>2]|0)+1832>>3];do{if(l!=0.0){w=v;x=g;y=l;z=f;A=v/l}else{if(v==0.0){w=v;x=g;y=l;z=f;A=v;break}B=v/+xH(c[d+536>>2]|0,l,12e3,13096,+h[g>>3],(a[d+319|0]|0)!=0|0);C=c[(d+416|0)>>2]|0;D=c[c[(d+4|0)>>2]>>2]|0;w=+h[(c[D+8>>2]|0)+1832>>3];x=D;y=+h[C+17480>>3];z=C;A=B}}while(0);l=j*+U(+A);do{if(y!=0.0){E=w;F=x;G=y;H=z;I=w/y}else{if(w==0.0){E=w;F=x;G=y;H=z;I=w;break}v=w/+xH(c[d+536>>2]|0,y,12e3,13096,+h[x>>3],(a[d+319|0]|0)!=0|0);g=c[(d+416|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;E=+h[(c[f+8>>2]|0)+1832>>3];F=f;G=+h[g+17480>>3];H=g;I=v}}while(0);j=+U(+I);v=l+ +W(+j,+(+h[H+17504>>3]))+1.0;g=c[(e+8|0)>>2]|0;j=+h[H+17472>>3];B=+h[H+17488>>3];f=G!=0.0;do{C=1;if(C){C=0;if(v*v!=0.0){do{if(f){J=G;K=H;L=E/G}else{if(E==0.0){J=G;K=H;L=E;break}M=E/+xH(c[d+536>>2]|0,G,12e3,13096,+h[F>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;J=+h[D+17480>>3];K=D;L=M}}while(0);M=j+B*+U(+L)+-1.0;N=+h[K+17496>>3];do{if(J!=0.0){O=J;P=K;Q=n/J}else{if(n==0.0){O=J;P=K;Q=n;break}R=n/+xH(c[d+536>>2]|0,J,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;O=+h[D+17480>>3];P=D;Q=R}}while(0);R=N*Q;D=c[c[(d+4|0)>>2]>>2]|0;S=+h[(c[D+8>>2]|0)+1832>>3];do{if(O!=0.0){T=O;V=P;X=S/O}else{if(S==0.0){T=O;V=P;X=S;break}Y=S/+xH(c[d+536>>2]|0,O,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;T=+h[Z+17480>>3];V=Z;X=Y}}while(0);S=+U(+X);N=+h[V+17504>>3];Y=+W(+S,+(N+-1.0));do{if(T!=0.0){_=T;$=V;aa=q/T}else{if(q==0.0){_=T;$=V;aa=q;break}S=q/+xH(c[d+536>>2]|0,T,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;_=+h[D+17480>>3];$=D;aa=S}}while(0);S=M*(R+Y*N*aa);ba=+h[$+17488>>3];ca=+h[$+17496>>3];D=c[c[(d+4|0)>>2]>>2]|0;da=+h[(c[D+8>>2]|0)+1832>>3];do{if(_!=0.0){ea=+U(+(da/_));fa=(ca*ea+ +W(+ea,+(+h[$+17504>>3]))+1.0)/_}else{if(da==0.0){ga=da;ha=D;ia=_;ja=$;ka=da}else{ea=da/+xH(c[d+536>>2]|0,_,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;la=c[c[(d+4|0)>>2]>>2]|0;ga=+h[(c[la+8>>2]|0)+1832>>3];ha=la;ia=+h[Z+17480>>3];ja=Z;ka=ea}ea=ca*+U(+ka);do{if(ia!=0.0){ma=ga;na=ha;oa=ia;pa=ja;qa=ga/ia}else{if(ga==0.0){ma=ga;na=ha;oa=ia;pa=ja;qa=ga;break}ra=ga/+xH(c[d+536>>2]|0,ia,12e3,13096,+h[ha>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;la=c[c[(d+4|0)>>2]>>2]|0;ma=+h[(c[la+8>>2]|0)+1832>>3];na=la;oa=+h[Z+17480>>3];pa=Z;qa=ra}}while(0);ra=+U(+qa);Z=ea+ +W(+ra,+(+h[pa+17504>>3]))+1.0==0.0;ra=+h[pa+17496>>3];la=oa!=0.0;if(Z){do{if(la){sa=ma;ta=na;ua=oa;va=pa;wa=ma/oa}else{if(ma==0.0){sa=ma;ta=na;ua=oa;va=pa;wa=ma;break}xa=ma/+xH(c[d+536>>2]|0,oa,12e3,13096,+h[na>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;sa=+h[(c[ya+8>>2]|0)+1832>>3];ta=ya;ua=+h[Z+17480>>3];va=Z;wa=xa}}while(0);ea=ra*+U(+wa);do{if(ua!=0.0){za=va;Aa=sa/ua}else{if(sa==0.0){za=va;Aa=sa;break}xa=sa/+xH(c[d+536>>2]|0,ua,12e3,13096,+h[ta>>3],(a[d+319|0]|0)!=0|0);za=c[(d+416|0)>>2]|0;Aa=xa}}while(0);xa=+U(+Aa);fa=ea+ +W(+xa,+(+h[za+17504>>3]))+1.0;break}else{do{if(la){Ba=ma;Ca=na;Da=oa;Ea=pa;Fa=ma/oa}else{if(ma==0.0){Ba=ma;Ca=na;Da=oa;Ea=pa;Fa=ma;break}xa=ma/+xH(c[d+536>>2]|0,oa,12e3,13096,+h[na>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;Ba=+h[(c[ya+8>>2]|0)+1832>>3];Ca=ya;Da=+h[Z+17480>>3];Ea=Z;Fa=xa}}while(0);ea=ra*+U(+Fa);do{if(Da!=0.0){Ga=Ca;Ha=Da;Ia=Ea;Ja=Ba/Da}else{if(Ba==0.0){Ga=Ca;Ha=Da;Ia=Ea;Ja=Ba;break}xa=Ba/+xH(c[d+536>>2]|0,Da,12e3,13096,+h[Ca>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Ga=c[c[(d+4|0)>>2]>>2]|0;Ha=+h[la+17480>>3];Ia=la;Ja=xa}}while(0);ra=+U(+Ja);xa=ea+ +W(+ra,+(+h[Ia+17504>>3]))+1.0;fa=xa/+xH(c[d+536>>2]|0,Ha,12e3,13096,+h[Ga>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ka=(S-ba*t*fa)/(v*v)}else{C=1}}if(C){C=0;if(1){do{if(f){La=G;Ma=H;Na=E/G}else{if(E==0.0){La=G;Ma=H;Na=E;break}ca=E/+xH(c[d+536>>2]|0,G,12e3,13096,+h[F>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;La=+h[D+17480>>3];Ma=D;Na=ca}}while(0);ba=j+B*+U(+Na)+-1.0;S=+h[Ma+17496>>3];do{if(La!=0.0){Oa=La;Pa=Ma;Qa=n/La}else{if(n==0.0){Oa=La;Pa=Ma;Qa=n;break}ca=n/+xH(c[d+536>>2]|0,La,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;Oa=+h[D+17480>>3];Pa=D;Qa=ca}}while(0);ca=S*Qa;D=c[c[(d+4|0)>>2]>>2]|0;da=+h[(c[D+8>>2]|0)+1832>>3];do{if(Oa!=0.0){Ra=Oa;Sa=Pa;Ta=da/Oa}else{if(da==0.0){Ra=Oa;Sa=Pa;Ta=da;break}N=da/+xH(c[d+536>>2]|0,Oa,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Ra=+h[la+17480>>3];Sa=la;Ta=N}}while(0);da=+U(+Ta);S=+h[Sa+17504>>3];N=+W(+da,+(S+-1.0));do{if(Ra!=0.0){Ua=Ra;Va=Sa;Wa=q/Ra}else{if(q==0.0){Ua=Ra;Va=Sa;Wa=q;break}da=q/+xH(c[d+536>>2]|0,Ra,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;Ua=+h[D+17480>>3];Va=D;Wa=da}}while(0);da=ba*(ca+N*S*Wa);Y=+h[Va+17488>>3];R=+h[Va+17496>>3];D=c[c[(d+4|0)>>2]>>2]|0;M=+h[(c[D+8>>2]|0)+1832>>3];do{if(Ua!=0.0){xa=+U(+(M/Ua));Xa=Va;Ya=(R*xa+ +W(+xa,+(+h[Va+17504>>3]))+1.0)/Ua}else{if(M==0.0){Za=M;_a=D;$a=Ua;ab=Va;bb=M}else{xa=M/+xH(c[d+536>>2]|0,Ua,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Z=c[c[(d+4|0)>>2]>>2]|0;Za=+h[(c[Z+8>>2]|0)+1832>>3];_a=Z;$a=+h[la+17480>>3];ab=la;bb=xa}xa=R*+U(+bb);do{if($a!=0.0){cb=Za;db=_a;eb=$a;fb=ab;gb=Za/$a}else{if(Za==0.0){cb=Za;db=_a;eb=$a;fb=ab;gb=Za;break}ra=Za/+xH(c[d+536>>2]|0,$a,12e3,13096,+h[_a>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Z=c[c[(d+4|0)>>2]>>2]|0;cb=+h[(c[Z+8>>2]|0)+1832>>3];db=Z;eb=+h[la+17480>>3];fb=la;gb=ra}}while(0);ea=+U(+gb);la=xa+ +W(+ea,+(+h[fb+17504>>3]))+1.0==0.0;ea=+h[fb+17496>>3];Z=eb!=0.0;if(la){do{if(Z){hb=cb;ib=db;jb=eb;kb=fb;lb=cb/eb}else{if(cb==0.0){hb=cb;ib=db;jb=eb;kb=fb;lb=cb;break}ra=cb/+xH(c[d+536>>2]|0,eb,12e3,13096,+h[db>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;hb=+h[(c[ya+8>>2]|0)+1832>>3];ib=ya;jb=+h[la+17480>>3];kb=la;lb=ra}}while(0);xa=ea*+U(+lb);do{if(jb!=0.0){mb=kb;nb=hb/jb}else{if(hb==0.0){mb=kb;nb=hb;break}ra=hb/+xH(c[d+536>>2]|0,jb,12e3,13096,+h[ib>>3],(a[d+319|0]|0)!=0|0);mb=c[(d+416|0)>>2]|0;nb=ra}}while(0);ra=+U(+nb);Xa=mb;Ya=xa+ +W(+ra,+(+h[mb+17504>>3]))+1.0;break}else{do{if(Z){ob=cb;pb=db;qb=eb;rb=fb;sb=cb/eb}else{if(cb==0.0){ob=cb;pb=db;qb=eb;rb=fb;sb=cb;break}ra=cb/+xH(c[d+536>>2]|0,eb,12e3,13096,+h[db>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;ob=+h[(c[ya+8>>2]|0)+1832>>3];pb=ya;qb=+h[la+17480>>3];rb=la;sb=ra}}while(0);xa=ea*+U(+sb);do{if(qb!=0.0){tb=pb;ub=qb;vb=rb;wb=ob/qb}else{if(ob==0.0){tb=pb;ub=qb;vb=rb;wb=ob;break}ra=ob/+xH(c[d+536>>2]|0,qb,12e3,13096,+h[pb>>3],(a[d+319|0]|0)!=0|0);Z=c[(d+416|0)>>2]|0;tb=c[c[(d+4|0)>>2]>>2]|0;ub=+h[Z+17480>>3];vb=Z;wb=ra}}while(0);ea=+U(+wb);ra=xa+ +W(+ea,+(+h[vb+17504>>3]))+1.0;ea=ra/+xH(c[d+536>>2]|0,ub,12e3,13096,+h[tb>>3],(a[d+319|0]|0)!=0|0);Xa=c[(d+416|0)>>2]|0;Ya=ea;break}}}while(0);R=+h[Xa+17472>>3];M=+h[Xa+17488>>3];S=+h[Xa+17480>>3];D=c[c[(d+4|0)>>2]>>2]|0;N=+h[(c[D+8>>2]|0)+1832>>3];Z=1;if(Z){Z=0;if(da-Y*t*Ya==0.0){do{if(S!=0.0){xb=S;yb=Xa;zb=N/S}else{if(N==0.0){xb=S;yb=Xa;zb=N;break}ca=N/+xH(c[d+536>>2]|0,S,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;xb=+h[la+17480>>3];yb=la;zb=ca}}while(0);Y=R+M*+U(+zb)+-1.0;da=+h[yb+17496>>3];do{if(xb!=0.0){Ab=xb;Bb=yb;Cb=n/xb}else{if(n==0.0){Ab=xb;Bb=yb;Cb=n;break}ca=n/+xH(c[d+536>>2]|0,xb,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Ab=+h[la+17480>>3];Bb=la;Cb=ca}}while(0);ca=da*Cb;la=c[c[(d+4|0)>>2]>>2]|0;ba=+h[(c[la+8>>2]|0)+1832>>3];do{if(Ab!=0.0){Db=Ab;Eb=Bb;Fb=ba/Ab}else{if(ba==0.0){Db=Ab;Eb=Bb;Fb=ba;break}ea=ba/+xH(c[d+536>>2]|0,Ab,12e3,13096,+h[la>>3],(a[d+319|0]|0)!=0|0);ya=c[(d+416|0)>>2]|0;Db=+h[ya+17480>>3];Eb=ya;Fb=ea}}while(0);ba=+U(+Fb);da=+h[Eb+17504>>3];ea=+W(+ba,+(da+-1.0));do{if(Db!=0.0){Gb=Db;Hb=Eb;Ib=q/Db}else{if(q==0.0){Gb=Db;Hb=Eb;Ib=q;break}ba=q/+xH(c[d+536>>2]|0,Db,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Gb=+h[la+17480>>3];Hb=la;Ib=ba}}while(0);ba=Y*(ca+ea*da*Ib);ra=+h[Hb+17488>>3];Jb=+h[Hb+17496>>3];la=c[c[(d+4|0)>>2]>>2]|0;Kb=+h[(c[la+8>>2]|0)+1832>>3];do{if(Gb!=0.0){Lb=+U(+(Kb/Gb));Mb=(Jb*Lb+ +W(+Lb,+(+h[Hb+17504>>3]))+1.0)/Gb}else{if(Kb==0.0){Nb=Kb;Ob=la;Pb=Gb;Qb=Hb;Rb=Kb}else{Lb=Kb/+xH(c[d+536>>2]|0,Gb,12e3,13096,+h[la>>3],(a[d+319|0]|0)!=0|0);ya=c[(d+416|0)>>2]|0;Sb=c[c[(d+4|0)>>2]>>2]|0;Nb=+h[(c[Sb+8>>2]|0)+1832>>3];Ob=Sb;Pb=+h[ya+17480>>3];Qb=ya;Rb=Lb}Lb=Jb*+U(+Rb);do{if(Pb!=0.0){Tb=Nb;Ub=Ob;Vb=Pb;Wb=Qb;Xb=Nb/Pb}else{if(Nb==0.0){Tb=Nb;Ub=Ob;Vb=Pb;Wb=Qb;Xb=Nb;break}Yb=Nb/+xH(c[d+536>>2]|0,Pb,12e3,13096,+h[Ob>>3],(a[d+319|0]|0)!=0|0);ya=c[(d+416|0)>>2]|0;Sb=c[c[(d+4|0)>>2]>>2]|0;Tb=+h[(c[Sb+8>>2]|0)+1832>>3];Ub=Sb;Vb=+h[ya+17480>>3];Wb=ya;Xb=Yb}}while(0);xa=+U(+Xb);ya=Lb+ +W(+xa,+(+h[Wb+17504>>3]))+1.0==0.0;xa=+h[Wb+17496>>3];Sb=Vb!=0.0;if(ya){do{if(Sb){Zb=Tb;_b=Ub;$b=Vb;ac=Wb;bc=Tb/Vb}else{if(Tb==0.0){Zb=Tb;_b=Ub;$b=Vb;ac=Wb;bc=Tb;break}Yb=Tb/+xH(c[d+536>>2]|0,Vb,12e3,13096,+h[Ub>>3],(a[d+319|0]|0)!=0|0);ya=c[(d+416|0)>>2]|0;cc=c[c[(d+4|0)>>2]>>2]|0;Zb=+h[(c[cc+8>>2]|0)+1832>>3];_b=cc;$b=+h[ya+17480>>3];ac=ya;bc=Yb}}while(0);Lb=xa*+U(+bc);do{if($b!=0.0){dc=ac;ec=Zb/$b}else{if(Zb==0.0){dc=ac;ec=Zb;break}Yb=Zb/+xH(c[d+536>>2]|0,$b,12e3,13096,+h[_b>>3],(a[d+319|0]|0)!=0|0);dc=c[(d+416|0)>>2]|0;ec=Yb}}while(0);Yb=+U(+ec);Mb=Lb+ +W(+Yb,+(+h[dc+17504>>3]))+1.0;break}else{do{if(Sb){fc=Tb;gc=Ub;hc=Vb;ic=Wb;jc=Tb/Vb}else{if(Tb==0.0){fc=Tb;gc=Ub;hc=Vb;ic=Wb;jc=Tb;break}Yb=Tb/+xH(c[d+536>>2]|0,Vb,12e3,13096,+h[Ub>>3],(a[d+319|0]|0)!=0|0);ya=c[(d+416|0)>>2]|0;cc=c[c[(d+4|0)>>2]>>2]|0;fc=+h[(c[cc+8>>2]|0)+1832>>3];gc=cc;hc=+h[ya+17480>>3];ic=ya;jc=Yb}}while(0);Lb=xa*+U(+jc);do{if(hc!=0.0){kc=gc;lc=hc;mc=ic;nc=fc/hc}else{if(fc==0.0){kc=gc;lc=hc;mc=ic;nc=fc;break}Yb=fc/+xH(c[d+536>>2]|0,hc,12e3,13096,+h[gc>>3],(a[d+319|0]|0)!=0|0);Sb=c[(d+416|0)>>2]|0;kc=c[c[(d+4|0)>>2]>>2]|0;lc=+h[Sb+17480>>3];mc=Sb;nc=Yb}}while(0);xa=+U(+nc);Yb=Lb+ +W(+xa,+(+h[mc+17504>>3]))+1.0;Mb=Yb/+xH(c[d+536>>2]|0,lc,12e3,13096,+h[kc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ka=ba-ra*t*Mb;break}else{Z=1}}if(Z){Z=0;if(1){do{if(S!=0.0){oc=S;pc=Xa;qc=N/S}else{if(N==0.0){oc=S;pc=Xa;qc=N;break}Jb=N/+xH(c[d+536>>2]|0,S,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;oc=+h[la+17480>>3];pc=la;qc=Jb}}while(0);S=R+M*+U(+qc)+-1.0;N=+h[pc+17496>>3];do{if(oc!=0.0){rc=oc;sc=pc;tc=n/oc}else{if(n==0.0){rc=oc;sc=pc;tc=n;break}ra=n/+xH(c[d+536>>2]|0,oc,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;rc=+h[D+17480>>3];sc=D;tc=ra}}while(0);M=N*tc;D=c[c[(d+4|0)>>2]>>2]|0;R=+h[(c[D+8>>2]|0)+1832>>3];do{if(rc!=0.0){uc=rc;vc=sc;wc=R/rc}else{if(R==0.0){uc=rc;vc=sc;wc=R;break}ra=R/+xH(c[d+536>>2]|0,rc,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;uc=+h[la+17480>>3];vc=la;wc=ra}}while(0);R=+U(+wc);N=+h[vc+17504>>3];ra=+W(+R,+(N+-1.0));do{if(uc!=0.0){xc=uc;yc=vc;zc=q/uc}else{if(q==0.0){xc=uc;yc=vc;zc=q;break}R=q/+xH(c[d+536>>2]|0,uc,12e3,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;xc=+h[D+17480>>3];yc=D;zc=R}}while(0);R=S*(M+ra*N*zc);ba=+h[yc+17488>>3];Jb=+h[yc+17496>>3];D=c[c[(d+4|0)>>2]>>2]|0;Kb=+h[(c[D+8>>2]|0)+1832>>3];do{if(xc!=0.0){da=+U(+(Kb/xc));Ac=(Jb*da+ +W(+da,+(+h[yc+17504>>3]))+1.0)/xc}else{if(Kb==0.0){Bc=Kb;Cc=D;Dc=xc;Ec=yc;Fc=Kb}else{da=Kb/+xH(c[d+536>>2]|0,xc,12e3,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Sb=c[c[(d+4|0)>>2]>>2]|0;Bc=+h[(c[Sb+8>>2]|0)+1832>>3];Cc=Sb;Dc=+h[la+17480>>3];Ec=la;Fc=da}da=Jb*+U(+Fc);do{if(Dc!=0.0){Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ec;Kc=Bc/Dc}else{if(Bc==0.0){Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ec;Kc=Bc;break}ea=Bc/+xH(c[d+536>>2]|0,Dc,12e3,13096,+h[Cc>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;Sb=c[c[(d+4|0)>>2]>>2]|0;Gc=+h[(c[Sb+8>>2]|0)+1832>>3];Hc=Sb;Ic=+h[la+17480>>3];Jc=la;Kc=ea}}while(0);Lb=+U(+Kc);la=da+ +W(+Lb,+(+h[Jc+17504>>3]))+1.0==0.0;Lb=+h[Jc+17496>>3];Sb=Ic!=0.0;if(la){do{if(Sb){Lc=Gc;Mc=Hc;Nc=Ic;Oc=Jc;Pc=Gc/Ic}else{if(Gc==0.0){Lc=Gc;Mc=Hc;Nc=Ic;Oc=Jc;Pc=Gc;break}ea=Gc/+xH(c[d+536>>2]|0,Ic,12e3,13096,+h[Hc>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;Lc=+h[(c[ya+8>>2]|0)+1832>>3];Mc=ya;Nc=+h[la+17480>>3];Oc=la;Pc=ea}}while(0);da=Lb*+U(+Pc);do{if(Nc!=0.0){Qc=Oc;Rc=Lc/Nc}else{if(Lc==0.0){Qc=Oc;Rc=Lc;break}ea=Lc/+xH(c[d+536>>2]|0,Nc,12e3,13096,+h[Mc>>3],(a[d+319|0]|0)!=0|0);Qc=c[(d+416|0)>>2]|0;Rc=ea}}while(0);ea=+U(+Rc);Ac=da+ +W(+ea,+(+h[Qc+17504>>3]))+1.0;break}else{do{if(Sb){Sc=Gc;Tc=Hc;Uc=Ic;Vc=Jc;Wc=Gc/Ic}else{if(Gc==0.0){Sc=Gc;Tc=Hc;Uc=Ic;Vc=Jc;Wc=Gc;break}ea=Gc/+xH(c[d+536>>2]|0,Ic,12e3,13096,+h[Hc>>3],(a[d+319|0]|0)!=0|0);la=c[(d+416|0)>>2]|0;ya=c[c[(d+4|0)>>2]>>2]|0;Sc=+h[(c[ya+8>>2]|0)+1832>>3];Tc=ya;Uc=+h[la+17480>>3];Vc=la;Wc=ea}}while(0);da=Lb*+U(+Wc);do{if(Uc!=0.0){Xc=Tc;Yc=Uc;Zc=Vc;_c=Sc/Uc}else{if(Sc==0.0){Xc=Tc;Yc=Uc;Zc=Vc;_c=Sc;break}ea=Sc/+xH(c[d+536>>2]|0,Uc,12e3,13096,+h[Tc>>3],(a[d+319|0]|0)!=0|0);Sb=c[(d+416|0)>>2]|0;Xc=c[c[(d+4|0)>>2]>>2]|0;Yc=+h[Sb+17480>>3];Zc=Sb;_c=ea}}while(0);Lb=+U(+_c);ea=da+ +W(+Lb,+(+h[Zc+17504>>3]))+1.0;Ac=ea/+xH(c[d+536>>2]|0,Yc,12e3,13096,+h[Xc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ka=(R-ba*t*Ac)/+xH(c[d+536>>2]|0,v*v,12056,13096,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{Z=1}}}else{C=1}}}while(0);ze[g&3](14,12,Ka,37,e);ze[c[(e+8|0)>>2]&3](15,10,1.0,38,e);f=c[(e+8|0)>>2]|0;v=+h[(c[(d+416|0)>>2]|0)+17512>>3];D=c[c[(d+4|0)>>2]>>2]|0;B=+h[(c[D+8>>2]|0)+2768>>3];do{if(v!=0.0){$c=B/v}else{if(B==0.0){$c=B;break}$c=B/+xH(c[d+536>>2]|0,v,11960,13096,+h[D>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[f&3](15,11,$c*-1256637061435917.0e-21,39,e);ze[c[(e+8|0)>>2]&3](16,9,1.0,40,e);D=c[c[(d+4|0)>>2]>>2]|0;v=+h[(c[D+8>>2]|0)+1840>>3];if(v!=0.0){ad=v;bd=1.0/ad;cd=c[(e+8|0)>>2]|0;dd=bd*bd;ze[cd&3](16,10,dd,41,e);ed=c[(e+8|0)>>2]|0;ze[ed&3](17,4,-1.0,42,e);fd=c[(e+8|0)>>2]|0;ze[fd&3](17,5,-1.0,43,e);gd=c[(e+8|0)>>2]|0;ze[gd&3](17,6,-1.0,44,e);hd=c[(e+8|0)>>2]|0;ze[hd&3](17,8,-1.0,45,e);id=c[(e+8|0)>>2]|0;ze[id&3](17,14,-1.0,46,e);jd=c[(e+8|0)>>2]|0;ze[jd&3](18,7,1.0,47,e);kd=c[(e+8|0)>>2]|0;ld=c[(d+4|0)>>2]|0;md=c[ld>>2]|0;nd=md;od=nd+8|0;pd=od;qd=c[pd>>2]|0;rd=qd;sd=rd+2664|0;td=sd;ud=+h[td>>3];vd=-ud;ze[kd&3](18,8,vd,48,e);wd=c[(e+8|0)>>2]|0;xd=c[(d+4|0)>>2]|0;yd=c[xd>>2]|0;zd=yd;Ad=zd+8|0;Bd=Ad;Cd=c[Bd>>2]|0;Dd=Cd;Ed=Dd+2696|0;Fd=Ed;Gd=+h[Fd>>3];Hd=-Gd;ze[wd&3](19,6,Hd,49,e);Id=c[(e+8|0)>>2]|0;ze[Id&3](19,7,1.0,50,e);Jd=c[(e+8|0)>>2]|0;Kd=c[(d+4|0)>>2]|0;Ld=c[Kd>>2]|0;Md=Ld;Nd=Md+8|0;Od=Nd;Pd=c[Od>>2]|0;Qd=Pd;Rd=Qd+2680|0;Sd=Rd;Td=+h[Sd>>3];Ud=-Td;ze[Jd&3](20,5,Ud,51,e);Vd=c[(e+8|0)>>2]|0;ze[Vd&3](20,7,1.0,52,e);Wd=c[(e+8|0)>>2]|0;Xd=c[(d+4|0)>>2]|0;Yd=c[Xd>>2]|0;Zd=Yd;_d=Zd+8|0;$d=_d;ae=c[$d>>2]|0;be=ae;ce=be+2704|0;de=ce;ee=+h[de>>3];fe=-ee;ze[Wd&3](21,4,fe,53,e);ge=c[(e+8|0)>>2]|0;ze[ge&3](21,7,1.0,54,e);he=c[(e+8|0)>>2]|0;ze[he&3](22,3,-1.0,55,e);ie=c[(e+8|0)>>2]|0;ze[ie&3](22,14,1.0,56,e);je=c[(e+8|0)>>2]|0;ze[je&3](23,2,1.0,57,e);ke=c[(e+8|0)>>2]|0;le=c[(d+4|0)>>2]|0;me=c[le>>2]|0;ne=me;oe=ne+8|0;pe=oe;qe=c[pe>>2]|0;re=qe;se=re+2656|0;te=se;ue=+h[te>>3];ve=-ue;ze[ke&3](23,3,ve,58,e);we=c[(e+8|0)>>2]|0;ze[we&3](24,1,-1.0,59,e);xe=c[(e+8|0)>>2]|0;ze[xe&3](24,25,-1.0,60,e);ye=c[(e+8|0)>>2]|0;ze[ye&3](25,0,1.0,61,e);Ae=c[(e+8|0)>>2]|0;Be=c[(d+4|0)>>2]|0;Ce=c[Be>>2]|0;De=Ce;Ee=De+8|0;Fe=Ee;Ge=c[Fe>>2]|0;He=Ge;Ie=He+1296|0;Je=Ie;Ke=+h[Je>>3];Le=-Ke;ze[Ae&3](25,1,Le,62,e);i=b;c[b+7568>>2]=5;break a}ad=+xH(c[d+536>>2]|0,v,11920,13096,+h[D>>3],(a[d+319|0]|0)!=0|0);bd=1.0/ad;cd=c[(e+8|0)>>2]|0;dd=bd*bd;ze[cd&3](16,10,dd,41,e);ed=c[(e+8|0)>>2]|0;ze[ed&3](17,4,-1.0,42,e);fd=c[(e+8|0)>>2]|0;ze[fd&3](17,5,-1.0,43,e);gd=c[(e+8|0)>>2]|0;ze[gd&3](17,6,-1.0,44,e);hd=c[(e+8|0)>>2]|0;ze[hd&3](17,8,-1.0,45,e);id=c[(e+8|0)>>2]|0;ze[id&3](17,14,-1.0,46,e);jd=c[(e+8|0)>>2]|0;ze[jd&3](18,7,1.0,47,e);kd=c[(e+8|0)>>2]|0;ld=c[(d+4|0)>>2]|0;md=c[ld>>2]|0;nd=md;od=nd+8|0;pd=od;qd=c[pd>>2]|0;rd=qd;sd=rd+2664|0;td=sd;ud=+h[td>>3];vd=-ud;ze[kd&3](18,8,vd,48,e);wd=c[(e+8|0)>>2]|0;xd=c[(d+4|0)>>2]|0;yd=c[xd>>2]|0;zd=yd;Ad=zd+8|0;Bd=Ad;Cd=c[Bd>>2]|0;Dd=Cd;Ed=Dd+2696|0;Fd=Ed;Gd=+h[Fd>>3];Hd=-Gd;ze[wd&3](19,6,Hd,49,e);Id=c[(e+8|0)>>2]|0;ze[Id&3](19,7,1.0,50,e);Jd=c[(e+8|0)>>2]|0;Kd=c[(d+4|0)>>2]|0;Ld=c[Kd>>2]|0;Md=Ld;Nd=Md+8|0;Od=Nd;Pd=c[Od>>2]|0;Qd=Pd;Rd=Qd+2680|0;Sd=Rd;Td=+h[Sd>>3];Ud=-Td;ze[Jd&3](20,5,Ud,51,e);Vd=c[(e+8|0)>>2]|0;ze[Vd&3](20,7,1.0,52,e);Wd=c[(e+8|0)>>2]|0;Xd=c[(d+4|0)>>2]|0;Yd=c[Xd>>2]|0;Zd=Yd;_d=Zd+8|0;$d=_d;ae=c[$d>>2]|0;be=ae;ce=be+2704|0;de=ce;ee=+h[de>>3];fe=-ee;ze[Wd&3](21,4,fe,53,e);ge=c[(e+8|0)>>2]|0;ze[ge&3](21,7,1.0,54,e);he=c[(e+8|0)>>2]|0;ze[he&3](22,3,-1.0,55,e);ie=c[(e+8|0)>>2]|0;ze[ie&3](22,14,1.0,56,e);je=c[(e+8|0)>>2]|0;ze[je&3](23,2,1.0,57,e);ke=c[(e+8|0)>>2]|0;le=c[(d+4|0)>>2]|0;me=c[le>>2]|0;ne=me;oe=ne+8|0;pe=oe;qe=c[pe>>2]|0;re=qe;se=re+2656|0;te=se;ue=+h[te>>3];ve=-ue;ze[ke&3](23,3,ve,58,e);we=c[(e+8|0)>>2]|0;ze[we&3](24,1,-1.0,59,e);xe=c[(e+8|0)>>2]|0;ze[xe&3](24,25,-1.0,60,e);ye=c[(e+8|0)>>2]|0;ze[ye&3](25,0,1.0,61,e);Ae=c[(e+8|0)>>2]|0;Be=c[(d+4|0)>>2]|0;Ce=c[Be>>2]|0;De=Ce;Ee=De+8|0;Fe=Ee;Ge=c[Fe>>2]|0;He=Ge;Ie=He+1296|0;Je=Ie;Ke=+h[Je>>3];Le=-Ke;ze[Ae&3](25,1,Le,62,e);i=b;c[b+7568>>2]=5;break a}while(0)}



function _P(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;NI(0);k=+FI(0);KI(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function $P(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=baa(24)|0;KI(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;uH(c[m>>2]|0,l>>>31^1,106096,f);f=b+8|0;b=c[a+8>>2]|0;l=aQ(b,f)|0;c[g+20>>2]=l;l=aQ(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=baa(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;vH(k,106176,e)}else{c[h>>2]=0;c[a+12>>2]=g;NI(3);i=d;return}}function aQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function bQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;KI(3);u=b;v=mc(c[u>>2]|0,106240)|0;if((v|0)==0){cQ(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=be(c[(Sc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;vH(w,106248,q)}wc(106304,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];Bd(v|0,106352,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];Bd(v|0,106376,o|0)|0;wc(106400,40,1,v|0)|0;wc(106448,11,1,v|0)|0;wc(106464,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];dQ(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Zd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{wc(106480,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;dQ(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Zd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];Bd(v|0,106504,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;dQ(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Zd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];Bd(v|0,106504,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;dQ(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Zd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];Bd(v|0,106504,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;dQ(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Zd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];Bd(v|0,106504,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;dQ(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Zd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];Bd(v|0,106504,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;dQ(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Zd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];Bd(v|0,106504,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;dQ(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Zd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}cQ(t);if((cd(v|0)|0)==0){caa(c[r>>2]|0);c[r>>2]=0;NI(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];vH(e,106520,f)}}function cQ(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}caa(a);c[d>>2]=0;i=b;return}function dQ(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Bd(a|0,106568,f|0)|0;i=e;return}function eQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=haa(192)|0;Jaa(m|0,0,192)|0;fQ(m);c[a+12>>2]=m;n=m;o=a;CM(n,c[o>>2]|0,36);if(J0(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];vH(a,106608,g)}else{g=m;m2(g,106584,14)|0;n2(h,g);a=PN(h)|0;h=m+184|0;c[h>>2]=a;m2(g,106600,4)|0;gQ(n,b+8|0);n2(j,g);b=PN(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;BM(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];o2(g,f)|0;hQ(n,-4-m+b|0);b=c[j>>2]|0;BM(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];o2(g,e)|0;NI(3);i=d;return}}function fQ(a){a=a|0;var b=0;b=i;AQ(a);i=b;return}function gQ(a,b){a=a|0;b=b|0;var c=0;c=i;jQ(a,3);kQ(a,106784);jQ(a,0);kQ(a,106792);jQ(a,2);vQ(a,b);wQ(a,b);kQ(a,106800);jQ(a,0);i=c;return}function hQ(a,b){a=a|0;b=b|0;var d=0;d=i;c[26694]=Nd(b|0)|0;m2(a,106776,4)|0;i=d;return}function iQ(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;n2(l,q);r=PN(l)|0;hQ(b,0);n2(m,q);l=PN(m)|0;jQ(b,1);kQ(b,106672);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;lQ(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);mQ(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{mQ(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{nQ(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{oQ(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{kQ(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}n2(n,q);u=PN(n)|0;n=Gaa(0,r|0,32)|0;BM(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];o2(q,k)|0;hQ(b,u-l|0);BM(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];o2(q,j)|0;i=g;return}function jQ(b,d){b=b|0;d=d|0;var e=0;e=i;a[106760]=-33;c[26692]=Nd(d|0)|0;d=b;m2(d,106760,1)|0;m2(d,106768,4)|0;i=e;return}function kQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Nd(Faa(d|0)|0)|0;a[106752]=-37;g=b;m2(g,106752,1)|0;m2(g,f,4)|0;m2(g,d,Faa(d|0)|0)|0;i=e;return}function lQ(b,d){b=b|0;d=d|0;var e=0;e=i;a[106736]=-35;c[26686]=Nd(d|0)|0;d=b;m2(d,106736,1)|0;m2(d,106744,4)|0;i=e;return}function mQ(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[106720]=-53;uQ(c);e=b;m2(e,106720,1)|0;m2(e,106728,8)|0;i=d;return}function nQ(b,d){b=b|0;d=d|0;var e=0;e=i;a[106704]=-46;c[26678]=Nd(d|0)|0;d=b;m2(d,106704,1)|0;m2(d,106712,4)|0;i=e;return}function oQ(b,c){b=b|0;c=c|0;var d=0;d=i;a[106696]=c?-61:-62;m2(b,106696,1)|0;i=d;return}function pQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;iQ(e,+h[f>>3],a,f);iQ(e,+h[b+248>>3],a,f);i=d;return}function qQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;n2(j,p);o=PN(j)|0;hQ(b,0);n2(k,p);j=PN(k)|0;jQ(b,1);kQ(b,106680);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;lQ(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;mQ(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{mQ(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{nQ(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{oQ(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{kQ(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}n2(l,p);s=PN(l)|0;l=Gaa(0,o|0,32)|0;BM(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];o2(p,g)|0;hQ(b,s-j|0);BM(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];o2(p,f)|0;i=e;return}function rQ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;vM(a);KI(3);if((a|0)!=0){sQ(a);jaa(a)}c[d>>2]=0;NI(3);i=b;return}function sQ(a){a=a|0;var b=0;b=i;tQ(a);i=b;return}function tQ(a){a=a|0;var b=0;b=i;SN(a);i=b;return}function uQ(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Nd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=106728;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[106728+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function vQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;kQ(a,106672);jQ(a,4);kQ(a,106808);jQ(a,0);kQ(a,106816);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;lQ(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);kQ(a,106824);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{kQ(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{kQ(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{kQ(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{kQ(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=106912;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];xQ(a,b,e);kQ(a,106848);jQ(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);yQ(a,106824,106856);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;yQ(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;yQ(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;yQ(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;yQ(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function wQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;kQ(a,106680);jQ(a,4);kQ(a,106808);jQ(a,0);kQ(a,106816);o=g+1+j+l+n|0;lQ(a,o);kQ(a,106824);if((c[f>>2]|0)>0){n=b;l=0;do{kQ(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{kQ(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{kQ(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{kQ(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=106832;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];xQ(a,b,e);kQ(a,106848);jQ(a,o);yQ(a,106824,106856);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;yQ(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;yQ(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;yQ(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;yQ(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function xQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;kQ(b,106880);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}jQ(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?106824:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}zQ(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?106824:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}zQ(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?106824:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}zQ(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?106824:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}zQ(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function yQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;kQ(a,b);jQ(a,1);kQ(a,106864);kQ(a,c);i=d;return}function zQ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;kQ(a,b);jQ(a,d?2:1);kQ(a,106888);kQ(a,c);if(!d){i=e;return}kQ(a,106896);kQ(a,106904);i=e;return}function AQ(a){a=a|0;var b=0;b=i;IP(a);i=b;return}function BQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;S$(e,106928);O$(d,DQ(a,e)|0);CQ(d,b+4|0);Y$(d);Y$(e);S$(g,106936);O$(f,DQ(a,g)|0);EQ(f,b);Y$(f);Y$(g);S$(j,106952);O$(h,DQ(a,j)|0);CQ(h,b+8|0);Y$(h);Y$(j);S$(l,106968);O$(k,DQ(a,l)|0);CQ(k,b+12|0);Y$(k);Y$(l);S$(n,106984);O$(m,DQ(a,n)|0);FQ(m,b+16|0,0);Y$(m);Y$(n);S$(p,107e3);O$(o,DQ(a,p)|0);FQ(o,b+20|0,0);Y$(o);Y$(p);S$(r,107016);O$(q,DQ(a,r)|0);FQ(q,b+24|0,0);Y$(q);Y$(r);S$(t,107024);O$(s,DQ(a,t)|0);FQ(s,b+28|0,0);Y$(s);Y$(t);S$(v,107040);O$(u,DQ(a,v)|0);FQ(u,b+32|0,0);Y$(u);Y$(v);i=c;return}function CQ(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){tH(22,0,110248,d);i=d;return}else{c[b>>2]=Fd(t0(a)|0)|0;i=d;return}}function DQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=OU(a,f,b)|0;l=c[k>>2]|0;nN(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}QU(j,a,b);RU(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];PU(g,e);SU(j);j=c[f>>2]|0;TU(a,j,k,UU(g)|0);k=VU(g)|0;SU(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function EQ(a,b){a=a|0;b=b|0;var d=0;d=i;if((w0(a,107216)|0)==0){c[b>>2]=1;i=d;return}if((w0(a,107224)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Kc(t0(a)|0)|0;i=d;return}}function FQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((w0(a,107192)|0)==0){c[b>>2]=d}if((w0(a,107216)|0)==0){c[b>>2]=1;i=e;return}if((w0(a,107224)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Kc(t0(a)|0)|0;i=e;return}}function GQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;S$(j,107056);O$(g,DQ(b,j)|0);y=d+48|0;HQ(g,y);Y$(g);Y$(j);S$(m,107072);O$(l,DQ(b,m)|0);j=d+56|0;IQ(l,j,0.0);Y$(l);Y$(m);S$(o,107080);O$(n,DQ(b,o)|0);m=d+32|0;HQ(n,m);Y$(n);Y$(o);S$(q,107088);O$(p,DQ(b,q)|0);o=d+33|0;HQ(p,o);Y$(p);Y$(q);S$(s,107104);O$(r,DQ(b,s)|0);q=d+40|0;IQ(r,q,1.0);Y$(r);Y$(s);S$(u,107112);O$(t,DQ(b,u)|0);s=d+16|0;IQ(t,s,-1.7976931348623157e+308);Y$(t);Y$(u);S$(w,107120);O$(v,DQ(b,w)|0);u=d+24|0;IQ(v,u,1.7976931348623157e+308);Y$(v);Y$(w);S$(x,106928);w=t0(DQ(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?107216:107224;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?107192:107200;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?107192:107208;c[f+20>>2]=j;c[f+24>>2]=m?107192:107200;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?107192:107208;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];rH(4,0,107128,f);Y$(x);i=e;return}function HQ(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(w0(b,107216)|0)==0|0;i=d;return}function IQ(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((w0(a,107192)|0)==0){h[b>>3]=c;i=d;return}if((w0(a,107216)|0)==0){h[b>>3]=1.0;i=d;return}if((w0(a,107224)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+xaa(t0(a)|0);i=d;return}}function JQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;S$(h,107056);O$(g,DQ(b,h)|0);s=d+13|0;HQ(g,s);Y$(g);Y$(h);S$(k,107072);O$(j,DQ(b,k)|0);h=d+16|0;FQ(j,h,0);Y$(j);Y$(k);S$(m,107080);O$(l,DQ(b,m)|0);k=d+12|0;HQ(l,k);Y$(l);Y$(m);S$(o,107112);O$(n,DQ(b,o)|0);m=d+4|0;FQ(n,m,-2147483648);Y$(n);Y$(o);S$(q,107120);O$(p,DQ(b,q)|0);o=d+8|0;FQ(p,o,2147483647);Y$(p);Y$(q);S$(r,106928);q=t0(DQ(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?107216:107224;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?107192:107200;c[f+8>>2]=s;c[f+12>>2]=b?107192:107208;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;rH(4,0,107232,f);Y$(r);i=e;return}function KQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;S$(h,107056);O$(g,DQ(b,h)|0);o=d+5|0;HQ(g,o);Y$(g);Y$(h);S$(k,107072);O$(j,DQ(b,k)|0);h=d+6|0;HQ(j,h);Y$(j);Y$(k);S$(m,107080);O$(l,DQ(b,m)|0);k=d+4|0;HQ(l,k);Y$(l);Y$(m);S$(n,106928);m=t0(DQ(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?107216:107224;h=(a[k]|0)!=0?107216:107224;c[f>>2]=m;c[f+4>>2]=b?107192:107200;c[f+8>>2]=o;c[f+12>>2]=b?107192:107208;c[f+16>>2]=h;rH(4,0,107288,f);Y$(n);i=e;return}function LQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;S$(h,107056);O$(g,DQ(b,h)|0);m=d+4|0;HQ(g,m);Y$(g);Y$(h);S$(k,107072);O$(j,DQ(b,k)|0);h=d+8|0;CQ(j,h);Y$(j);Y$(k);S$(l,106928);k=t0(DQ(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?107192:107200;c[f+8>>2]=m;c[f+12>>2]=b?107192:107208;rH(4,0,107328,f);Y$(l);i=e;return}function MQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+8|0;lc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;NQ(qa);M$(ra);OQ(sa,ta);OQ(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[120376>>2]|0)==0){S$(za,c[b+80>>2]|0);PQ(ya,za,107352);Z$(ra,ya)|0;Y$(ya);Y$(za)}else{_$(ra,c[120504>>2]|0)|0}ta=mc(t0(ra)|0,107368)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=t0(ra)|0;vH(0,107376,pa)}else{Wc=0}}while(0);pa=mC(0)|0;if((pa|0)==0){cd(Wc|0)|0;vH(0,107480,oa)}xC(pa,Vc);yC(pa,8,73);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;Jaa(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((zC(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){cd(Wc|0)|0;oa=t0(ra)|0;ya=HC(EC(pa)|0)|0;za=FC(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;tH(1,0,107560,na);tC(pa);vH(0,107648,ma)}else if((Xc|0)==14){cd(Wc|0)|0;break}}else{if((zC(pa,Vc,Faa(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=HC(EC(pa)|0)|0;ta=FC(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;Bd(za|0,107672,la|0)|0;za=c[va>>2]|0;ta=HC(EC(pa)|0)|0;oa=FC(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;tH(1,0,107688,ka);tC(pa);vH(0,107648,ja)}}while(0);ja=qa;S$(Ca,107776);TQ(Ba,ja,Ca);UQ(Da,ja);ka=SQ(Ba,Da)|0;Y$(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=t0(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;tH(1,0,107784,ia)}else{S$(Ea,107776);Ba=Baa(Da,t0(DQ(ja,Ea)|0)|0)|0;Y$(Ea);if((Ba|0)==0){break}tC(pa);S$(Fa,107776);Ba=t0(DQ(ja,Fa)|0)|0;va=t0(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;tH(1,0,107832,ha);Y$(Fa);vH(0,107648,ga)}}while(0);VQ(qa,b,c[120588>>2]|0,c[120592>>2]|0);rH(23,1,107928,fa);fa=qa+12|0;S$(Ha,107968);O$(Ga,DQ(fa,Ha)|0);ga=d;IQ(Ga,ga,0.0);Y$(Ga);Y$(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];rH(23,0,107984,ea);S$(Ja,108e3);O$(Ia,DQ(fa,Ja)|0);ea=d+8|0;IQ(Ia,ea,1.0);Y$(Ia);Y$(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];rH(23,0,108016,da);S$(La,108032);O$(Ka,DQ(fa,La)|0);da=d+24|0;IQ(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Y$(Ka);Y$(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];rH(23,0,108048,ca);S$(Na,108064);O$(Ma,DQ(fa,Na)|0);ca=d+32|0;IQ(Ma,ca,1.0e-5);Y$(Ma);Y$(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];rH(23,0,108080,ba);S$(Pa,108096);O$(Oa,DQ(fa,Pa)|0);ba=d+40|0;CQ(Oa,ba);Y$(Oa);Y$(Pa);c[aa>>2]=c[ba>>2];rH(23,0,108104,aa);S$(Ra,108128);O$(Qa,DQ(fa,Ra)|0);aa=d+44|0;CQ(Qa,aa);Y$(Qa);Y$(Ra);c[$>>2]=c[aa>>2];rH(23,0,108144,$);S$(Ta,108168);O$(Sa,DQ(fa,Ta)|0);fa=d+48|0;CQ(Sa,fa);Y$(Sa);Y$(Ta);c[_>>2]=c[fa>>2];rH(23,0,108184,_);S$(Va,108208);O$(Ua,DQ(ja,Va)|0);_=d+268|0;CQ(Ua,_);Y$(Ua);Y$(Va);c[Z>>2]=c[_>>2];rH(23,0,108232,Z);if((c[63644>>2]|0)!=0){me[c[16026]&255](23)}S$(eb,108256);O$(db,DQ(ja,eb)|0);FQ(db,Wa,0);Y$(db);Y$(eb);S$(gb,108288);O$(fb,DQ(ja,gb)|0);FQ(fb,Xa,0);Y$(fb);Y$(gb);S$(ib,108320);O$(hb,DQ(ja,ib)|0);FQ(hb,Ya,0);Y$(hb);Y$(ib);S$(kb,108344);O$(jb,DQ(ja,kb)|0);FQ(jb,_a,0);Y$(jb);Y$(kb);S$(mb,108376);O$(lb,DQ(ja,mb)|0);FQ(lb,Za,0);Y$(lb);Y$(mb);S$(ob,108416);O$(nb,DQ(ja,ob)|0);FQ(nb,ab,0);Y$(nb);Y$(ob);S$(qb,108448);O$(pb,DQ(ja,qb)|0);FQ(pb,$a,0);Y$(pb);Y$(qb);S$(tb,108488);O$(rb,DQ(ja,tb)|0);FQ(rb,cb,0);Y$(rb);Y$(tb);S$(vb,108520);O$(ub,DQ(ja,vb)|0);FQ(ub,bb,0);Y$(ub);Y$(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=109064;rH(4,1,109040,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=WQ(lb,wb)|0;BQ(ib,jb+(kb*112|0)|0);GQ(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(xb,109080);jb=(w0(DQ(ib,xb)|0,107216)|0)==0;Y$(xb);if(!jb){break}c[N>>2]=c[hb>>2];rH(4,0,109096,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);S$(yb,c[hb>>2]|0);c[(XQ(sa,yb)|0)>>2]=kb;Y$(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[M>>2]=109128;rH(4,1,109040,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=WQ(lb,zb)|0;BQ(fb,gb+(jb*112|0)|0);GQ(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Ab,109080);gb=(w0(DQ(fb,Ab)|0,107216)|0)==0;Y$(Ab);if(!gb){break}c[L>>2]=c[eb>>2];rH(4,0,109096,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);S$(Bb,c[eb>>2]|0);c[(XQ(sa,Bb)|0)>>2]=jb;Y$(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[K>>2]=109152;rH(4,1,109040,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=WQ(mb,Cb)|0;BQ(gb,hb+(fb*112|0)|0);GQ(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Db,109080);hb=(w0(DQ(gb,Db)|0,107216)|0)==0;Y$(Db);if(!hb){break}c[J>>2]=c[db>>2];rH(4,0,109096,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);S$(Eb,c[db>>2]|0);c[(XQ(sa,Eb)|0)>>2]=fb;Y$(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[I>>2]=109168;rH(4,1,109040,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=WQ(ub,Fb)|0;BQ(mb,kb+(ib*60|0)|0);JQ(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Gb,109080);kb=(w0(DQ(mb,Gb)|0,107216)|0)==0;Y$(Gb);if(!kb){break}c[H>>2]=c[gb>>2];rH(4,0,109096,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);S$(Hb,c[gb>>2]|0);c[(XQ(sa,Hb)|0)>>2]=ib;Y$(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[G>>2]=109192;rH(4,1,109040,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=WQ(ib,Ib)|0;BQ(mb,ub+(lb*48|0)|0);KQ(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Jb,109080);ub=(w0(DQ(mb,Jb)|0,107216)|0)==0;Y$(Jb);if(!ub){break}c[F>>2]=c[fb>>2];rH(4,0,109096,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);S$(Kb,c[fb>>2]|0);c[(XQ(sa,Kb)|0)>>2]=lb;Y$(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[E>>2]=109216;rH(4,1,109040,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=WQ(lb,Lb)|0;BQ(mb,ib+(rb*52|0)|0);LQ(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Mb,109080);ib=(w0(DQ(mb,Mb)|0,107216)|0)==0;Y$(Mb);if(!ib){break}c[D>>2]=c[gb>>2];rH(4,0,109096,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);S$(Nb,c[gb>>2]|0);c[(XQ(sa,Nb)|0)>>2]=rb;Y$(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[C>>2]=109240;rH(4,1,109040,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=WQ(rb,Ob)|0;BQ(mb,lb+(pb*112|0)|0);GQ(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Pb,109080);lb=(w0(DQ(mb,Pb)|0,107216)|0)==0;Y$(Pb);if(!lb){break}c[B>>2]=c[fb>>2];rH(4,0,109096,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);S$(Qb,c[fb>>2]|0);c[(XQ(ua,Qb)|0)>>2]=pb;Y$(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[A>>2]=109256;rH(4,1,109040,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=WQ(pb,Rb)|0;BQ(mb,rb+(nb*60|0)|0);JQ(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Sb,109080);rb=(w0(DQ(mb,Sb)|0,107216)|0)==0;Y$(Sb);if(!rb){break}c[z>>2]=c[gb>>2];rH(4,0,109096,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);S$(Tb,c[gb>>2]|0);c[(XQ(ua,Tb)|0)>>2]=nb;Y$(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[y>>2]=109280;rH(4,1,109040,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=WQ(nb,Ub)|0;BQ(mb,pb+(ja*48|0)|0);KQ(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Vb,109080);pb=(w0(DQ(mb,Vb)|0,107216)|0)==0;Y$(Vb);if(!pb){break}c[x>>2]=c[fb>>2];rH(4,0,109096,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);S$(Wb,c[fb>>2]|0);c[(XQ(ua,Wb)|0)>>2]=ja;Y$(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}c[w>>2]=109304;rH(4,1,109040,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=WQ(ja,Xb)|0;BQ(mb,nb+(tb*52|0)|0);LQ(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[120372>>2]|0)!=0){break}S$(Yb,109080);nb=(w0(DQ(mb,Yb)|0,107216)|0)==0;Y$(Yb);if(!nb){break}c[v>>2]=c[gb>>2];rH(4,0,109096,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);S$(Zb,c[gb>>2]|0);c[(XQ(ua,Zb)|0)>>2]=tb;Y$(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}rH(4,1,109328,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=WQ(tb,_b)|0;BQ(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);M$($b);c[bc>>2]=ja;mb=WQ(tb,bc)|0;S$(cc,109368);O$(ac,DQ(mb,cc)|0);YQ(ac,$b);Y$(ac);Y$(cc);mb=(w0($b,109376)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;rH(4,0,109392,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=WQ(tb,ec)|0;S$(fc,109432);O$(dc,DQ(nb,fc)|0);YQ(dc,$b);Y$(dc);Y$(fc);ZQ(wa,sa,$b);ZQ(xa,ua,$b);$Q(gc,sa);do{if(_Q(wa,gc)|0){nb=c[(aR(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{$Q(hc,ua);if(_Q(xa,hc)|0){fb=c[(aR(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((w0($b,109448)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Y$($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}H0(jc,109456,$b);PQ(ic,jc,109480);Y$(jc);c[s>>2]=t0(ic)|0;vH(0,109496,s)}}while(0);if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}rH(4,1,109504,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[kc>>2]=tb;gb=WQ(ja,kc)|0;BQ(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);M$(lc);c[oc>>2]=tb;gb=WQ(ja,oc)|0;S$(pc,109368);O$(nc,DQ(gb,pc)|0);YQ(nc,lc);Y$(nc);Y$(pc);gb=(w0(lc,109376)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;rH(4,0,109392,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=WQ(ja,rc)|0;S$(sc,109432);O$(qc,DQ(fb,sc)|0);YQ(qc,lc);Y$(qc);Y$(sc);ZQ(wa,sa,lc);ZQ(xa,ua,lc);$Q(tc,sa);if(_Q(wa,tc)|0){fb=c[(aR(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{$Q(uc,ua);if(!(_Q(xa,uc)|0)){break}nb=c[(aR(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Y$(lc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}H0(wc,109544,lc);PQ(vc,wc,109480);Y$(wc);c[o>>2]=t0(vc)|0;vH(0,109496,o)}}while(0);if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}rH(4,1,109568,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=WQ(tb,xc)|0;BQ(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);M$(yc);c[Ac>>2]=ja;fb=WQ(tb,Ac)|0;S$(Bc,109368);O$(zc,DQ(fb,Bc)|0);YQ(zc,yc);Y$(zc);Y$(Bc);fb=(w0(yc,109376)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;rH(4,0,109392,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=WQ(tb,Dc)|0;S$(Ec,109432);O$(Cc,DQ(gb,Ec)|0);YQ(Cc,yc);Y$(Cc);Y$(Ec);ZQ(wa,sa,yc);ZQ(xa,ua,yc);$Q(Fc,sa);if(_Q(wa,Fc)|0){gb=c[(aR(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{$Q(Gc,ua);if(!(_Q(xa,Gc)|0)){break}nb=c[(aR(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Y$(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}H0(Ic,109608,yc);PQ(Hc,Ic,109480);Y$(Ic);c[l>>2]=t0(Hc)|0;vH(0,109496,l)}}while(0);if((c[63568>>2]|0)!=0){me[c[16026]&255](4)}rH(4,1,109632,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=WQ(ja,Jc)|0;BQ(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);M$(Kc);c[Mc>>2]=tb;gb=WQ(ja,Mc)|0;S$(Nc,109368);O$(Lc,DQ(gb,Nc)|0);YQ(Lc,Kc);Y$(Lc);Y$(Nc);gb=(w0(Kc,109376)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;rH(4,0,109392,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=WQ(ja,Pc)|0;S$(Qc,109432);O$(Oc,DQ(fb,Qc)|0);YQ(Oc,Kc);Y$(Oc);Y$(Qc);ZQ(wa,sa,Kc);ZQ(xa,ua,Kc);$Q(Rc,sa);if(_Q(wa,Rc)|0){fb=c[(aR(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{$Q(Sc,ua);if(!(_Q(xa,Sc)|0)){break}nb=c[(aR(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Y$(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}H0(Uc,109672,Kc);PQ(Tc,Uc,109480);Y$(Uc);c[f>>2]=t0(Tc)|0;vH(0,109496,f)}}while(0);if((c[63568>>2]|0)==0){tC(pa);bR(ua);bR(sa);Y$(ra);cR(qa);i=e;return}me[c[16026]&255](4);tC(pa);bR(ua);bR(sa);Y$(ra);cR(qa);i=e;return}}while(0);if((c[63640>>2]|c[15886]|0)==0){tC(pa);Yc=zd(0)|0;Id(-1)}tH(22,1,108560,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;tH(22,0,108608,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;tH(22,0,108656,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;tH(22,0,108704,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;tH(22,0,108752,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;tH(22,0,108800,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;tH(22,0,108848,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;tH(22,0,108896,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;tH(22,0,108944,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;tH(22,0,108992,P);me[c[16026]&255](22);tC(pa);Yc=zd(0)|0;Id(-1)}function NQ(a){a=a|0;var b=0;b=i;PX(a);i=b;return}function OQ(a,b){a=a|0;b=b|0;b=i;uT(a,0);i=b;return}function PQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;N$(a,d);e=W$(b)|0;f=CR(c)|0;x0(a,X$(b)|0,e,f+e|0);p0(a,c,f)|0;i=d;return}function QQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((Baa(b,110304)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{S$(g,v);w=DQ(u,g)|0;_$(w,c[d+((t|1)<<2)>>2]|0)|0;Y$(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((Baa(b,110328)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{S$(h,g);u=DQ(t,h)|0;_$(u,c[d+((v|1)<<2)>>2]|0)|0;Y$(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((Baa(b,110352)|0)!=0){do{if((Baa(b,110608)|0)!=0){if((Baa(b,110616)|0)==0){break}if((Baa(b,110624)|0)==0){break}if((Baa(b,110632)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=WQ(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){S$(r,c[t>>2]|0);w=DQ(g,r)|0;_$(w,c[d+((u|1)<<2)>>2]|0)|0;Y$(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=WQ(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}S$(s,110640);_$(DQ(x,s)|0,b)|0;Y$(s);i=e;return}dR(j,k);M$(l);M$(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{S$(n,g);t=DQ(j,n)|0;_$(t,c[d+((x|1)<<2)>>2]|0)|0;Y$(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}S$(o,110368);Z$(l,DQ(j,o)|0)|0;Y$(o);S$(p,110384);Z$(m,DQ(j,p)|0)|0;Y$(p);c[k>>2]=Kc(t0(l)|0)|0;if((w0(m,110400)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((w0(m,110408)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((w0(m,110416)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((w0(m,110424)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((w0(m,110432)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((w0(m,110440)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((w0(m,110448)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((w0(m,110456)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((w0(m,110464)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((w0(m,110472)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((w0(m,110480)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((w0(m,110488)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((w0(m,110496)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((w0(m,110504)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=t0(m)|0;S$(q,106928);N=t0(DQ(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;uH(0,(O|0)!=0|0,110512,f);Y$(q);sW(WQ(c[b>>2]|0,s)|0,j)|0;Y$(m);Y$(l);lR(j);i=e;return}function RQ(a,b){a=a|0;b=b|0;i=i;return}function SQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=dT(a,b)|0;i=c;return d|0}function TQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;mT(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];eT(a,f);i=e;return}function UQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;fT(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];eT(a,e);i=d;return}function VQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dR(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){vH(0,109696,n)}if(p){ec=Fd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;rH(23,0,109840,m);eR(q);fR(q,e,8);if(!(gR(q)|0)){c[l>>2]=e;vH(0,109880,l)}M$(r);l=q;hR(l,r)|0;O$(s,r);while(1){e=hR(l,r)|0;if(!(I0(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}H0(t,109960,r);n0(s,t)|0;Y$(t)}t=Fd(t0(s)|0)|0;iR(q);Y$(s);Y$(r);jR(q);fc=t}if((fc|0)==0){rH(23,0,110048,g);lR(o);i=f;return}M$(u);M$(v);c[k>>2]=fc;rH(23,0,109968,k);k=Yb(fc|0,109960)|0;if((k|0)!=0){g=k;do{k=haa(12)|0;S$(k,g);t=u0(k,11e4,0)|0;s0(w,k,0,t);Z$(u,w)|0;Y$(w);s0(x,k,t+1|0,(d0(k)|0)+~t|0);Z$(v,x)|0;Y$(x);Z$(DQ(o,u)|0,v)|0;t=t0(u)|0;k=t0(v)|0;c[j>>2]=t;c[j+4>>2]=k;rH(23,0,110008,j);g=Yb(0,109960)|0;}while((g|0)!=0)}caa(fc);fc=a+12|0;S$(y,108096);g=DQ(fc,y)|0;S$(z,108096);if((kR(o,z)|0)==0){S$(B,108096);gc=1;hc=0;ic=DQ(fc,B)|0}else{S$(A,108096);gc=0;hc=1;ic=DQ(o,A)|0}Z$(g,ic)|0;if(gc){Y$(B)}if(hc){Y$(A)}Y$(z);Y$(y);S$(C,107968);y=DQ(fc,C)|0;S$(D,107968);if((kR(o,D)|0)==0){S$(F,107968);jc=1;kc=0;lc=DQ(fc,F)|0}else{S$(E,107968);jc=0;kc=1;lc=DQ(o,E)|0}Z$(y,lc)|0;if(jc){Y$(F)}if(kc){Y$(E)}Y$(D);Y$(C);S$(G,108e3);C=DQ(fc,G)|0;S$(H,108e3);if((kR(o,H)|0)==0){S$(J,108e3);mc=1;nc=0;oc=DQ(fc,J)|0}else{S$(I,108e3);mc=0;nc=1;oc=DQ(o,I)|0}Z$(C,oc)|0;if(mc){Y$(J)}if(nc){Y$(I)}Y$(H);Y$(G);S$(K,108032);G=DQ(fc,K)|0;S$(L,108032);if((kR(o,L)|0)==0){S$(N,108032);pc=0;qc=1;rc=DQ(fc,N)|0}else{S$(M,108032);pc=1;qc=0;rc=DQ(o,M)|0}Z$(G,rc)|0;if(qc){Y$(N)}if(pc){Y$(M)}Y$(L);Y$(K);S$(O,108064);K=DQ(fc,O)|0;S$(P,108064);if((kR(o,P)|0)==0){S$(R,108064);sc=1;tc=0;uc=DQ(fc,R)|0}else{S$(Q,108064);sc=0;tc=1;uc=DQ(o,Q)|0}Z$(K,uc)|0;if(sc){Y$(R)}if(tc){Y$(Q)}Y$(P);Y$(O);S$(S,108128);O=DQ(fc,S)|0;S$(T,108128);if((kR(o,T)|0)==0){S$(V,108128);vc=1;wc=0;xc=DQ(fc,V)|0}else{S$(U,108128);vc=0;wc=1;xc=DQ(o,U)|0}Z$(O,xc)|0;if(vc){Y$(V)}if(wc){Y$(U)}Y$(T);Y$(S);S$(W,108168);S=DQ(fc,W)|0;S$(X,108168);if((kR(o,X)|0)==0){S$(Z,108168);yc=1;zc=0;Ac=DQ(fc,Z)|0}else{S$(Y,108168);yc=0;zc=1;Ac=DQ(o,Y)|0}Z$(S,Ac)|0;if(yc){Y$(Z)}if(zc){Y$(Y)}Y$(X);Y$(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=WQ(Y,_)|0;S$($,107072);Ac=DQ(yc,$)|0;c[aa>>2]=Z;yc=WQ(Y,aa)|0;S$(ba,106928);if((kR(o,DQ(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=WQ(Y,ea)|0;S$(fa,107072);Bc=1;Cc=0;Dc=DQ(yc,fa)|0}else{c[ca>>2]=Z;yc=WQ(Y,ca)|0;S$(da,106928);Bc=0;Cc=1;Dc=DQ(o,DQ(yc,da)|0)|0}Z$(Ac,Dc)|0;if(Bc){Y$(fa)}if(Cc){Y$(da)}Y$(ba);Y$($);c[ga>>2]=Z;Ac=WQ(zc,ga)|0;S$(ha,107072);yc=DQ(Ac,ha)|0;c[ia>>2]=Z;Ac=WQ(zc,ia)|0;S$(ja,106928);if((kR(o,DQ(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=WQ(zc,ma)|0;S$(na,107072);Ec=1;Fc=0;Gc=DQ(Ac,na)|0}else{c[ka>>2]=Z;Ac=WQ(zc,ka)|0;S$(la,106928);Ec=0;Fc=1;Gc=DQ(o,DQ(Ac,la)|0)|0}Z$(yc,Gc)|0;if(Ec){Y$(na)}if(Fc){Y$(la)}Y$(ja);Y$(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=WQ(Hc,oa)|0;S$(pa,107072);ja=DQ(ha,pa)|0;c[qa>>2]=Z;ha=WQ(Hc,qa)|0;S$(ra,106928);if((kR(o,DQ(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=WQ(Hc,ua)|0;S$(va,107072);Ic=1;Jc=0;Kc=DQ(ha,va)|0}else{c[sa>>2]=Z;ha=WQ(Hc,sa)|0;S$(ta,106928);Ic=0;Jc=1;Kc=DQ(o,DQ(ha,ta)|0)|0}Z$(ja,Kc)|0;if(Ic){Y$(va)}if(Jc){Y$(ta)}Y$(ra);Y$(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=WQ(X,wa)|0;S$(xa,107072);ra=DQ(pa,xa)|0;c[ya>>2]=Z;pa=WQ(X,ya)|0;S$(za,106928);if((kR(o,DQ(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=WQ(X,Ca)|0;S$(Da,107072);Lc=1;Mc=0;Nc=DQ(pa,Da)|0}else{c[Aa>>2]=Z;pa=WQ(X,Aa)|0;S$(Ba,106928);Lc=0;Mc=1;Nc=DQ(o,DQ(pa,Ba)|0)|0}Z$(ra,Nc)|0;if(Lc){Y$(Da)}if(Mc){Y$(Ba)}Y$(za);Y$(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=WQ(Z,Ea)|0;S$(Fa,107072);Ba=DQ(za,Fa)|0;c[Ga>>2]=xa;za=WQ(Z,Ga)|0;S$(Ha,106928);if((kR(o,DQ(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=WQ(Z,Ka)|0;S$(La,107072);Oc=1;Pc=0;Qc=DQ(za,La)|0}else{c[Ia>>2]=xa;za=WQ(Z,Ia)|0;S$(Ja,106928);Oc=0;Pc=1;Qc=DQ(o,DQ(za,Ja)|0)|0}Z$(Ba,Qc)|0;if(Oc){Y$(La)}if(Pc){Y$(Ja)}Y$(Ha);Y$(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=WQ(xa,Ma)|0;S$(Na,107072);Ja=DQ(Ha,Na)|0;c[Oa>>2]=Fa;Ha=WQ(xa,Oa)|0;S$(Pa,106928);if((kR(o,DQ(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=WQ(xa,Sa)|0;S$(Ta,107072);Rc=1;Sc=0;Tc=DQ(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=WQ(xa,Qa)|0;S$(Ra,106928);Rc=0;Sc=1;Tc=DQ(o,DQ(Ha,Ra)|0)|0}Z$(Ja,Tc)|0;if(Rc){Y$(Ta)}if(Sc){Y$(Ra)}Y$(Pa);Y$(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=WQ(Fa,Ua)|0;S$(Va,107072);Ra=DQ(Pa,Va)|0;c[Wa>>2]=Na;Pa=WQ(Fa,Wa)|0;S$(Xa,106928);if((kR(o,DQ(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=WQ(Fa,_a)|0;S$($a,107072);Uc=1;Vc=0;Wc=DQ(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=WQ(Fa,Ya)|0;S$(Za,106928);Uc=0;Vc=1;Wc=DQ(o,DQ(Pa,Za)|0)|0}Z$(Ra,Wc)|0;if(Uc){Y$($a)}if(Vc){Y$(Za)}Y$(Xa);Y$(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=WQ(Na,ab)|0;S$(bb,107072);Za=DQ(Xa,bb)|0;c[cb>>2]=Va;Xa=WQ(Na,cb)|0;S$(db,106928);if((kR(o,DQ(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=WQ(Na,gb)|0;S$(hb,107072);Xc=1;Yc=0;Zc=DQ(Xa,hb)|0}else{c[eb>>2]=Va;Xa=WQ(Na,eb)|0;S$(fb,106928);Xc=0;Yc=1;Zc=DQ(o,DQ(Xa,fb)|0)|0}Z$(Za,Zc)|0;if(Xc){Y$(hb)}if(Yc){Y$(fb)}Y$(db);Y$(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=WQ(Va,ib)|0;S$(jb,107072);fb=DQ(db,jb)|0;c[kb>>2]=bb;db=WQ(Va,kb)|0;S$(lb,106928);if((kR(o,DQ(db,lb)|0)|0)==0){c[ob>>2]=bb;db=WQ(Va,ob)|0;S$(pb,107072);_c=1;$c=0;ad=DQ(db,pb)|0}else{c[mb>>2]=bb;db=WQ(Va,mb)|0;S$(nb,106928);_c=0;$c=1;ad=DQ(o,DQ(db,nb)|0)|0}Z$(fb,ad)|0;if(_c){Y$(pb)}if($c){Y$(nb)}Y$(lb);Y$(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=WQ(bb,qb)|0;S$(rb,107072);nb=DQ(lb,rb)|0;c[sb>>2]=jb;lb=WQ(bb,sb)|0;S$(tb,106928);if((kR(o,DQ(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=WQ(bb,wb)|0;S$(xb,107072);bd=1;cd=0;dd=DQ(lb,xb)|0}else{c[ub>>2]=jb;lb=WQ(bb,ub)|0;S$(vb,106928);bd=0;cd=1;dd=DQ(o,DQ(lb,vb)|0)|0}Z$(nb,dd)|0;if(bd){Y$(xb)}if(cd){Y$(vb)}Y$(tb);Y$(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=WQ(jb,yb)|0;S$(zb,107072);vb=DQ(tb,zb)|0;c[Ab>>2]=rb;tb=WQ(jb,Ab)|0;S$(Bb,106928);if((kR(o,DQ(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=WQ(jb,Eb)|0;S$(Fb,107072);ed=1;fd=0;gd=DQ(tb,Fb)|0}else{c[Cb>>2]=rb;tb=WQ(jb,Cb)|0;S$(Db,106928);ed=0;fd=1;gd=DQ(o,DQ(tb,Db)|0)|0}Z$(vb,gd)|0;if(ed){Y$(Fb)}if(fd){Y$(Db)}Y$(Bb);Y$(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=WQ(rb,Gb)|0;S$(Hb,107072);Db=DQ(Bb,Hb)|0;c[Ib>>2]=zb;Bb=WQ(rb,Ib)|0;S$(Jb,106928);if((kR(o,DQ(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=WQ(rb,Mb)|0;S$(Nb,107072);hd=0;id=1;jd=DQ(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=WQ(rb,Kb)|0;S$(Lb,106928);hd=1;id=0;jd=DQ(o,DQ(Bb,Lb)|0)|0}Z$(Db,jd)|0;if(id){Y$(Nb)}if(hd){Y$(Lb)}Y$(Jb);Y$(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=WQ(zb,Ob)|0;S$(Pb,107072);Lb=DQ(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=WQ(zb,Qb)|0;S$(Rb,106928);if((kR(o,DQ(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=WQ(zb,Ub)|0;S$(Vb,107072);kd=1;ld=0;md=DQ(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=WQ(zb,Sb)|0;S$(Tb,106928);kd=0;ld=1;md=DQ(o,DQ(Jb,Tb)|0)|0}Z$(Lb,md)|0;if(kd){Y$(Vb)}if(ld){Y$(Tb)}Y$(Rb);Y$(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=WQ(b,Wb)|0;S$(Xb,107072);Pb=DQ(Hb,Xb)|0;c[Zb>>2]=a;Hb=WQ(b,Zb)|0;S$(_b,106928);if((kR(o,DQ(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=WQ(b,bc)|0;S$(cc,107072);nd=1;od=0;pd=DQ(Hb,cc)|0}else{c[$b>>2]=a;Hb=WQ(b,$b)|0;S$(ac,106928);nd=0;od=1;pd=DQ(o,DQ(Hb,ac)|0)|0}Z$(Pb,pd)|0;if(nd){Y$(cc)}if(od){Y$(ac)}Y$(_b);Y$(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}rH(23,0,110032,h);Y$(v);Y$(u);lR(o);i=f;return}function WQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=DT(a,f,b)|0;l=c[k>>2]|0;nN(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}FT(j,a,b);GT(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];ET(g,e);HT(j);j=c[f>>2]|0;IT(a,j,k,JT(g)|0);k=KT(g)|0;HT(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function XQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=fS(a,f,b)|0;l=c[k>>2]|0;nN(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}hS(j,a,b);iS(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];gS(g,e);jS(j);j=c[f>>2]|0;kS(a,j,k,lS(g)|0);k=mS(g)|0;jS(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function YQ(a,b){a=a|0;b=b|0;var c=0;c=i;Z$(b,a)|0;i=c;return}function ZQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;YR(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];QR(a,f);i=e;return}function _Q(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=OR(a,b)|0;i=c;return d|0}function $Q(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;RR(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];QR(a,e);i=d;return}function aR(a){a=a|0;var b=0,c=0;b=i;c=LR(a)|0;i=b;return c|0}function bR(a){a=a|0;var b=0;b=i;iW(a);i=b;return}function cR(a){a=a|0;var b=0;b=i;XV(a);i=b;return}function dR(a,b){a=a|0;b=b|0;b=i;EU(a,0);i=b;return}function eR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;V0(d);e=a;c[e>>2]=110100;f=d;c[f>>2]=110120;d=a+8|0;N1(a,110132|0,d);c[e>>2]=110100;c[f>>2]=110120;WP(d);i=b;return}function fR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(vN(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){M0(d,4);i=e;return}else{K0(d,0);i=e;return}}function gR(a){a=a|0;var b=0,c=0;b=i;c=GR(a+8|0)|0;i=b;return c|0}function hR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=FR(a,b,T0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function iR(a){a=a|0;var b=0;b=i;if((xN(a+8|0)|0)!=0){i=b;return}M0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function jR(a){a=a|0;var b=0;b=i;KR(a,110128);Q0(a+108|0);i=b;return}function kR(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mR(a,b)|0;i=c;return d|0}function lR(a){a=a|0;var b=0;b=i;MV(a);i=b;return}function mR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=oR(a)|0;nN(e);if((f|0)==0){g=0;i=d;return g|0}h=pR(a)|0;a=f;while(1){f=a+16|0;if(qR(h,b,f)|0){j=a}else{if(!(rR(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;nN(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function nR(a){a=a|0;var b=0,c=0;b=i;c=_M(xR(a+4|0)|0)|0;i=b;return c|0}function oR(a){a=a|0;var b=0,d=0;b=i;d=c[(nR(a)|0)>>2]|0;i=b;return d|0}function pR(a){a=a|0;var b=0,c=0;b=i;c=vR(a+8|0)|0;i=b;return c|0}function qR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sR(0,b,c)|0;i=a;return d|0}function rR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sR(0,b,c)|0;i=a;return d|0}function sR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=tR(b,c)|0;i=a;return d|0}function tR(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(v0(a,b)|0)<0;i=c;return d|0}function uR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Aaa(a,b,c)|0;i=d;return e|0}function vR(a){a=a|0;var b=0,c=0;b=i;c=wR(a)|0;i=b;return c|0}function wR(a){a=a|0;i=i;return a|0}function xR(a){a=a|0;var b=0,c=0;b=i;c=yR(a)|0;i=b;return c|0}function yR(a){a=a|0;i=i;return a|0}function zR(a,b){a=a|0;b=b|0;var c=0;a=i;c=BR(0,b,0)|0;i=a;return c|0}function AR(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function BR(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=haa(b)|0;i=c;return a|0}function CR(a){a=a|0;var b=0,c=0;b=i;c=Faa(a|0)|0;i=b;return c|0}function DR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=ER(b,c,e)|0;i=d;return g|0}function ER(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=rO(0,a,b)|0;i=c;return(d?b:a)|0}function FR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;S1(f,a,1);if(!(V1(f)|0)){i=e;return a|0}m0(b);f=0;while(1){g=$0(R0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(hO(g,-1)|0){h=2;j=f;break}k=f+1|0;l=iO(g)|0;if(mO(l,d)|0){h=0;j=k;break}o0(b,l);if((W$(b)|0)==-17){h=4;j=k;break}else{f=k}}M0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function GR(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function HR(a){a=a|0;var b=0;b=i;jR(a);jaa(a);i=b;return}function IR(a){a=a|0;var b=0;b=i;jR(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function JR(a){a=a|0;var b=0;b=i;HR(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function KR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];XN(a+8|0);i=d;return}function LR(a){a=a|0;var b=0,d=0;b=i;d=MR((c[a>>2]|0)+16|0)|0;i=b;return d|0}function MR(a){a=a|0;var b=0,c=0;b=i;c=NR(a)|0;i=b;return c|0}function NR(a){a=a|0;i=i;return a|0}function OR(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(PR(a,b)|0)^1;i=c;return d|0}function PR(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function QR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];XR(a,e);i=d;return}function RR(a,b){a=a|0;b=b|0;var c=0;c=i;SR(a,TR(b)|0);i=c;return}function SR(a,b){a=a|0;b=b|0;var c=0;c=i;WR(a,b);i=c;return}function TR(a){a=a|0;var b=0,c=0;b=i;c=_M(UR(a+4|0)|0)|0;i=b;return c|0}function UR(a){a=a|0;var b=0,c=0;b=i;c=VR(a)|0;i=b;return c|0}function VR(a){a=a|0;i=i;return a|0}function WR(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function XR(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function YR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=_R(b)|0;ZR(f,b,d,h,TR(b)|0);RR(g,b);do{if(OR(f,g)|0){h=$R(b)|0;if(aS(h,d,bS(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);RR(a,b);i=e;return}function ZR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;nN(h);a:do{if((e|0)==0){j=f}else{k=$R(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(eS(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;nN(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;nN(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);SR(a,j);i=g;return}function _R(a){a=a|0;var b=0,d=0;b=i;d=c[(TR(a)|0)>>2]|0;i=b;return d|0}function $R(a){a=a|0;var b=0,c=0;b=i;c=cS(a+8|0)|0;i=b;return c|0}function aS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sR(0,b,c)|0;i=a;return d|0}function bS(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function cS(a){a=a|0;var b=0,c=0;b=i;c=dS(a)|0;i=b;return c|0}function dS(a){a=a|0;i=i;return a|0}function eS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sR(0,b,c)|0;i=a;return d|0}function fS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=_R(h)|0;nN(e);if((a|0)==0){j=TR(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(sR(0,d,a)|0){m=l;j=c[m>>2]|0;nN(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(sR(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;nN(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function gS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];bT(a,e);i=d;return}function hS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=IS(d)|0;d=KS(n,1)|0;LS(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];JS(j,d,h);MS(0,BS((NS(j)|0)+16|0)|0,e);e=OS(j)|0;a[e+4|0]=1;PS(0,zS((NS(j)|0)+28|0)|0);a[e+5|0]=1;QS(m,j);iS(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];gS(b,g);jS(m);jS(j);i=f;return}function iS(a,b){a=a|0;b=b|0;var c=0;c=i;GS(a,b);i=c;return}function jS(a){a=a|0;var b=0;b=i;vS(a);i=b;return}function kS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;nN(f);c[e>>2]=0;nN(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=rS(a)|0;b=c[c[e>>2]>>2]|0;nN(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(TR(a)|0)>>2]|0;ZO(e,c[d>>2]|0);d=sS(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function lS(a){a=a|0;var b=0,d=0;b=i;d=c[(pS(a)|0)>>2]|0;i=b;return d|0}function mS(a){a=a|0;var b=0,d=0;b=i;d=nS(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function nS(a){a=a|0;var b=0,c=0;b=i;c=oS(a)|0;i=b;return c|0}function oS(a){a=a|0;i=i;return a|0}function pS(a){a=a|0;var b=0,c=0;b=i;c=qS(a)|0;i=b;return c|0}function qS(a){a=a|0;i=i;return a|0}function rS(a){a=a|0;i=i;return a|0}function sS(a){a=a|0;var b=0,c=0;b=i;c=tS(a+8|0)|0;i=b;return c|0}function tS(a){a=a|0;var b=0,c=0;b=i;c=uS(a)|0;i=b;return c|0}function uS(a){a=a|0;i=i;return a|0}function vS(a){a=a|0;var b=0;b=i;wS(a,0);i=b;return}function wS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=nS(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}yS(xS(e)|0,f);i=d;return}function xS(a){a=a|0;var b=0,c=0;b=i;c=FS(a)|0;i=b;return c|0}function yS(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;AS(f,BS(d+16|0)|0)}if((d|0)==0){i=e;return}CS(c[b>>2]|0,d,1);i=e;return}function zS(a){a=a|0;i=i;return a|0}function AS(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;ES(d,0,c);i=b;return}function BS(a){a=a|0;i=i;return a|0}function CS(a,b,c){a=a|0;b=b|0;c=c|0;c=i;DS(0,b,0);i=c;return}function DS(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jaa(b);i=c;return}function ES(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Y$(c);i=b;return}function FS(a){a=a|0;i=i;return a+4|0}function GS(a,b){a=a|0;b=b|0;var c=0;c=i;HS(a,b);i=c;return}function HS(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function IS(a){a=a|0;var b=0,c=0;b=i;c=$S(a+4|0)|0;i=b;return c|0}function JS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];TS(a,b,f);i=e;return}function KS(a,b){a=a|0;b=b|0;var c=0;a=i;c=SS(0,b,0)|0;i=a;return c|0}function LS(a,b){a=a|0;b=b|0;var c=0;c=i;RS(a,b);i=c;return}function MS(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}O$(b,c);i=a;return}function NS(a){a=a|0;var b=0,d=0;b=i;d=c[(pS(a)|0)>>2]|0;i=b;return d|0}function OS(a){a=a|0;var b=0,c=0;b=i;c=xS(a)|0;i=b;return c|0}function PS(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function QS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;GS(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];gS(h,f);iS(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];gS(a,e);jS(h);i=d;return}function RS(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function SS(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=haa(b<<5)|0;i=c;return a|0}function TS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(VS(g)|0)>>2]|0;g=WS(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];US(b,a,f);i=e;return}function US(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];XS(a,b,f);i=e;return}function VS(a){a=a|0;i=i;return a|0}function WS(a){a=a|0;i=i;return a|0}function XS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(ZS(g)|0)>>2]|0;g=_S(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];YS(b,a,f);i=e;return}function YS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(ZS(f)|0)>>2];f=_S(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function ZS(a){a=a|0;i=i;return a|0}function _S(a){a=a|0;i=i;return a|0}function $S(a){a=a|0;var b=0,c=0;b=i;c=aT(a)|0;i=b;return c|0}function aT(a){a=a|0;i=i;return a|0}function bT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=mS(cT(b)|0)|0;h=_S(OS(cT(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];US(g,a,e);i=d;return}function cT(a){a=a|0;i=i;return c[a>>2]|0}function dT(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function eT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];lT(a,e);i=d;return}function fT(a,b){a=a|0;b=b|0;var c=0;c=i;gT(a,hT(b)|0);i=c;return}function gT(a,b){a=a|0;b=b|0;var c=0;c=i;kT(a,b);i=c;return}



function hT(a){a=a|0;var b=0,c=0;b=i;c=_M(iT(a+4|0)|0)|0;i=b;return c|0}function iT(a){a=a|0;var b=0,c=0;b=i;c=jT(a)|0;i=b;return c|0}function jT(a){a=a|0;i=i;return a|0}function kT(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function lT(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function mT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=oT(b)|0;nT(f,b,d,h,hT(b)|0);fT(g,b);do{if(pT(f,g)|0){h=qT(b)|0;if(qR(h,d,rT(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);fT(a,b);i=e;return}function nT(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;nN(h);a:do{if((e|0)==0){j=f}else{k=qT(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(rR(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;nN(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;nN(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);gT(a,j);i=g;return}function oT(a){a=a|0;var b=0,d=0;b=i;d=c[(hT(a)|0)>>2]|0;i=b;return d|0}function pT(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(dT(a,b)|0)^1;i=c;return d|0}function qT(a){a=a|0;var b=0,c=0;b=i;c=sT(a+8|0)|0;i=b;return c|0}function rT(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function sT(a){a=a|0;var b=0,c=0;b=i;c=tT(a)|0;i=b;return c|0}function tT(a){a=a|0;i=i;return a|0}function uT(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vT(a,b);i=b;return}function vT(a,b){a=a|0;b=b|0;b=i;wT(a,0);i=b;return}function wT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;xT(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;yT(f,0,e);e=TR(b)|0;c[(rS(b)|0)>>2]=e;i=d;return}function xT(a){a=a|0;var b=0;b=i;BT(a);i=b;return}function yT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;zT(b,c,f);i=e;return}function zT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(RP(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;AT(d,b,f);i=e;return}function AT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(RP(e)|0)>>2];i=d;return}function BT(a){a=a|0;var b=0;b=i;CT(a);i=b;return}function CT(a){a=a|0;var b=0;b=i;UP(a);i=b;return}function DT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=DU(h)|0;nN(e);if((a|0)==0){j=QT(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(kN(0,d,a)|0){m=l;j=c[m>>2]|0;nN(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(kN(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;nN(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function ET(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];BU(a,e);i=d;return}function FT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=gU(d)|0;d=iU(n,1)|0;jU(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];hU(j,d,h);kU(0,jP((lU(j)|0)+16|0)|0,e);e=mU(j)|0;a[e+4|0]=1;nU(0,$T((lU(j)|0)+20|0)|0);a[e+5|0]=1;oU(m,j);GT(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];ET(b,g);HT(m);HT(j);i=f;return}function GT(a,b){a=a|0;b=b|0;var c=0;c=i;eU(a,b);i=c;return}function HT(a){a=a|0;var b=0;b=i;WT(a);i=b;return}function IT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;nN(f);c[e>>2]=0;nN(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=PT(a)|0;b=c[c[e>>2]>>2]|0;nN(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(QT(a)|0)>>2]|0;ZO(e,c[d>>2]|0);d=RT(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function JT(a){a=a|0;var b=0,d=0;b=i;d=c[(NT(a)|0)>>2]|0;i=b;return d|0}function KT(a){a=a|0;var b=0,d=0;b=i;d=LT(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function LT(a){a=a|0;var b=0,c=0;b=i;c=MT(a)|0;i=b;return c|0}function MT(a){a=a|0;i=i;return a|0}function NT(a){a=a|0;var b=0,c=0;b=i;c=OT(a)|0;i=b;return c|0}function OT(a){a=a|0;i=i;return a|0}function PT(a){a=a|0;i=i;return a|0}function QT(a){a=a|0;var b=0,c=0;b=i;c=_M(UT(a+4|0)|0)|0;i=b;return c|0}function RT(a){a=a|0;var b=0,c=0;b=i;c=ST(a+8|0)|0;i=b;return c|0}function ST(a){a=a|0;var b=0,c=0;b=i;c=TT(a)|0;i=b;return c|0}function TT(a){a=a|0;i=i;return a|0}function UT(a){a=a|0;var b=0,c=0;b=i;c=VT(a)|0;i=b;return c|0}function VT(a){a=a|0;i=i;return a|0}function WT(a){a=a|0;var b=0;b=i;XT(a,0);i=b;return}function XT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=LT(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ZT(YT(e)|0,f);i=d;return}function YT(a){a=a|0;var b=0,c=0;b=i;c=dU(a)|0;i=b;return c|0}function ZT(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;_T(f,$T(d+20|0)|0)}if((d|0)==0){i=e;return}aU(c[b>>2]|0,d,1);i=e;return}function _T(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;cU(d,0,c);i=b;return}function $T(a){a=a|0;i=i;return a|0}function aU(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bU(0,b,0);i=c;return}function bU(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jaa(b);i=c;return}function cU(a,b,c){a=a|0;b=b|0;c=c|0;b=i;lR(c);i=b;return}function dU(a){a=a|0;i=i;return a+4|0}function eU(a,b){a=a|0;b=b|0;var c=0;c=i;fU(a,b);i=c;return}function fU(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gU(a){a=a|0;var b=0,c=0;b=i;c=zU(a+4|0)|0;i=b;return c|0}function hU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rU(a,b,f);i=e;return}function iU(a,b){a=a|0;b=b|0;var c=0;a=i;c=qU(0,b,0)|0;i=a;return c|0}function jU(a,b){a=a|0;b=b|0;var c=0;c=i;pU(a,b);i=c;return}function kU(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function lU(a){a=a|0;var b=0,d=0;b=i;d=c[(NT(a)|0)>>2]|0;i=b;return d|0}function mU(a){a=a|0;var b=0,c=0;b=i;c=YT(a)|0;i=b;return c|0}function nU(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}dR(b,a);i=a;return}function oU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;eU(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];ET(h,f);GT(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];ET(a,e);HT(h);i=d;return}function pU(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function qU(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=haa(b<<5)|0;i=c;return a|0}function rU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tU(g)|0)>>2]|0;g=uU(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sU(b,a,f);i=e;return}function sU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];vU(a,b,f);i=e;return}function tU(a){a=a|0;i=i;return a|0}function uU(a){a=a|0;i=i;return a|0}function vU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(xU(g)|0)>>2]|0;g=yU(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];wU(b,a,f);i=e;return}function wU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(xU(f)|0)>>2];f=yU(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function xU(a){a=a|0;i=i;return a|0}function yU(a){a=a|0;i=i;return a|0}function zU(a){a=a|0;var b=0,c=0;b=i;c=AU(a)|0;i=b;return c|0}function AU(a){a=a|0;i=i;return a|0}function BU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=KT(CU(b)|0)|0;h=yU(mU(CU(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];sU(g,a,e);i=d;return}function CU(a){a=a|0;i=i;return c[a>>2]|0}function DU(a){a=a|0;var b=0,d=0;b=i;d=c[(QT(a)|0)>>2]|0;i=b;return d|0}function EU(a,b){a=a|0;b=b|0;b=i;i=i+8|0;FU(a,b);i=b;return}function FU(a,b){a=a|0;b=b|0;b=i;GU(a,0);i=b;return}function GU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;HU(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;IU(f,0,e);e=hT(b)|0;c[(JU(b)|0)>>2]=e;i=d;return}function HU(a){a=a|0;var b=0;b=i;MU(a);i=b;return}function IU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;KU(b,c,f);i=e;return}function JU(a){a=a|0;i=i;return a|0}function KU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(RP(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;LU(d,b,f);i=e;return}function LU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(RP(e)|0)>>2];i=d;return}function MU(a){a=a|0;var b=0;b=i;NU(a);i=b;return}function NU(a){a=a|0;var b=0;b=i;UP(a);i=b;return}function OU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=oT(h)|0;nN(e);if((a|0)==0){j=hT(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(sR(0,d,a)|0){m=l;j=c[m>>2]|0;nN(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(sR(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;nN(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function PU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];KV(a,e);i=d;return}function QU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=pV(d)|0;d=rV(n,1)|0;sV(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];qV(j,d,h);tV(0,BS((uV(j)|0)+16|0)|0,e);e=vV(j)|0;a[e+4|0]=1;wV(0,gV((uV(j)|0)+28|0)|0);a[e+5|0]=1;xV(m,j);RU(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];PU(b,g);SU(m);SU(j);i=f;return}function RU(a,b){a=a|0;b=b|0;var c=0;c=i;nV(a,b);i=c;return}function SU(a){a=a|0;var b=0;b=i;bV(a);i=b;return}function TU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;nN(f);c[e>>2]=0;nN(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=JU(a)|0;b=c[c[e>>2]>>2]|0;nN(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(hT(a)|0)>>2]|0;ZO(e,c[d>>2]|0);d=_U(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function UU(a){a=a|0;var b=0,d=0;b=i;d=c[(YU(a)|0)>>2]|0;i=b;return d|0}function VU(a){a=a|0;var b=0,d=0;b=i;d=WU(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function WU(a){a=a|0;var b=0,c=0;b=i;c=XU(a)|0;i=b;return c|0}function XU(a){a=a|0;i=i;return a|0}function YU(a){a=a|0;var b=0,c=0;b=i;c=ZU(a)|0;i=b;return c|0}function ZU(a){a=a|0;i=i;return a|0}function _U(a){a=a|0;var b=0,c=0;b=i;c=$U(a+8|0)|0;i=b;return c|0}function $U(a){a=a|0;var b=0,c=0;b=i;c=aV(a)|0;i=b;return c|0}function aV(a){a=a|0;i=i;return a|0}function bV(a){a=a|0;var b=0;b=i;cV(a,0);i=b;return}function cV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=WU(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}eV(dV(e)|0,f);i=d;return}function dV(a){a=a|0;var b=0,c=0;b=i;c=mV(a)|0;i=b;return c|0}function eV(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;fV(f,gV(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;hV(f,BS(d+16|0)|0)}if((d|0)==0){i=e;return}iV(c[b>>2]|0,d,1);i=e;return}function fV(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lV(d,0,c);i=b;return}function gV(a){a=a|0;i=i;return a|0}function hV(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;kV(d,0,c);i=b;return}function iV(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jV(0,b,0);i=c;return}function jV(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jaa(b);i=c;return}function kV(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Y$(c);i=b;return}function lV(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Y$(c);i=b;return}function mV(a){a=a|0;i=i;return a+4|0}function nV(a,b){a=a|0;b=b|0;var c=0;c=i;oV(a,b);i=c;return}function oV(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function pV(a){a=a|0;var b=0,c=0;b=i;c=IV(a+4|0)|0;i=b;return c|0}function qV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];AV(a,b,f);i=e;return}function rV(a,b){a=a|0;b=b|0;var c=0;a=i;c=zV(0,b,0)|0;i=a;return c|0}function sV(a,b){a=a|0;b=b|0;var c=0;c=i;yV(a,b);i=c;return}function tV(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}O$(b,c);i=a;return}function uV(a){a=a|0;var b=0,d=0;b=i;d=c[(YU(a)|0)>>2]|0;i=b;return d|0}function vV(a){a=a|0;var b=0,c=0;b=i;c=dV(a)|0;i=b;return c|0}function wV(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}M$(b);i=a;return}function xV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;nV(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];PU(h,f);RU(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];PU(a,e);SU(h);i=d;return}function yV(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function zV(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=haa(b*40|0)|0;i=c;return a|0}function AV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(CV(g)|0)>>2]|0;g=DV(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];BV(b,a,f);i=e;return}function BV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];EV(a,b,f);i=e;return}function CV(a){a=a|0;i=i;return a|0}function DV(a){a=a|0;i=i;return a|0}function EV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(GV(g)|0)>>2]|0;g=HV(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];FV(b,a,f);i=e;return}function FV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(GV(f)|0)>>2];f=HV(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function GV(a){a=a|0;i=i;return a|0}function HV(a){a=a|0;i=i;return a|0}function IV(a){a=a|0;var b=0,c=0;b=i;c=JV(a)|0;i=b;return c|0}function JV(a){a=a|0;i=i;return a|0}function KV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=VU(LV(b)|0)|0;h=HV(vV(LV(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];BV(g,a,e);i=d;return}function LV(a){a=a|0;i=i;return c[a>>2]|0}function MV(a){a=a|0;var b=0;b=i;NV(a);i=b;return}function NV(a){a=a|0;var b=0;b=i;OV(a);i=b;return}function OV(a){a=a|0;var b=0;b=i;PV(a,oT(a)|0);i=b;return}function PV(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;nN(d);if((b|0)==0){i=d;return}PV(a,c[b>>2]|0);PV(a,c[b+4>>2]|0);e=pV(a)|0;QV(e,RV(b+16|0)|0);iV(e,b,1);i=d;return}function QV(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;SV(d,0,c);i=b;return}function RV(a){a=a|0;i=i;return a|0}function SV(a,b,c){a=a|0;b=b|0;c=c|0;b=i;TV(c);i=b;return}function TV(a){a=a|0;var b=0;b=i;UV(a);i=b;return}function UV(a){a=a|0;var b=0;b=i;VV(a);i=b;return}function VV(a){a=a|0;var b=0;b=i;WV(a);i=b;return}function WV(a){a=a|0;var b=0;b=i;Y$(a+12|0);Y$(a);i=b;return}function XV(a){a=a|0;var b=0;b=i;YV(a+180|0);YV(a+168|0);YV(a+156|0);YV(a+144|0);YV(a+132|0);YV(a+120|0);YV(a+108|0);YV(a+96|0);YV(a+84|0);YV(a+72|0);YV(a+60|0);YV(a+48|0);YV(a+36|0);YV(a+24|0);lR(a+12|0);lR(a);i=b;return}function YV(a){a=a|0;var b=0;b=i;ZV(a);i=b;return}function ZV(a){a=a|0;var b=0;b=i;_V(a);i=b;return}function _V(a){a=a|0;var b=0;b=i;$V(a);i=b;return}function $V(a){a=a|0;var b=0;b=i;aW(a,DU(a)|0);i=b;return}function aW(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;nN(d);if((b|0)==0){i=d;return}aW(a,c[b>>2]|0);aW(a,c[b+4>>2]|0);e=gU(a)|0;bW(e,cW(b+16|0)|0);aU(e,b,1);i=d;return}function bW(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;dW(d,0,c);i=b;return}function cW(a){a=a|0;i=i;return a|0}function dW(a,b,c){a=a|0;b=b|0;c=c|0;b=i;eW(c);i=b;return}function eW(a){a=a|0;var b=0;b=i;fW(a);i=b;return}function fW(a){a=a|0;var b=0;b=i;gW(a);i=b;return}function gW(a){a=a|0;var b=0;b=i;hW(a);i=b;return}function hW(a){a=a|0;var b=0;b=i;lR(a+4|0);i=b;return}function iW(a){a=a|0;var b=0;b=i;jW(a);i=b;return}function jW(a){a=a|0;var b=0;b=i;kW(a);i=b;return}function kW(a){a=a|0;var b=0;b=i;lW(a,_R(a)|0);i=b;return}function lW(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;nN(d);if((b|0)==0){i=d;return}lW(a,c[b>>2]|0);lW(a,c[b+4>>2]|0);e=IS(a)|0;mW(e,NR(b+16|0)|0);CS(e,b,1);i=d;return}function mW(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;nW(d,0,c);i=b;return}function nW(a,b,c){a=a|0;b=b|0;c=c|0;b=i;oW(c);i=b;return}function oW(a){a=a|0;var b=0;b=i;pW(a);i=b;return}function pW(a){a=a|0;var b=0;b=i;qW(a);i=b;return}function qW(a){a=a|0;var b=0;b=i;rW(a);i=b;return}function rW(a){a=a|0;var b=0;b=i;Y$(a);i=b;return}function sW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;tW(a);vW(g,b);wW(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];uW(a,f,e);i=d;return a|0}function tW(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;PV(a,oT(a)|0);c[(_U(a)|0)>>2]=0;d=hT(a)|0;c[(JU(a)|0)>>2]=d;nN(b);c[d>>2]=0;i=b;return}function uW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;EW(h,a);if(!(FW(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];xW(j,g);o=HW(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];GW(l,a,f,o);IW(b)|0;}while(FW(b,d)|0);i=e;return}function vW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;CW(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];xW(a,e);i=d;return}function wW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;yW(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];xW(a,e);i=d;return}function xW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];BW(a,e);i=d;return}function yW(a,b){a=a|0;b=b|0;var c=0;c=i;zW(a,nR(b)|0);i=c;return}function zW(a,b){a=a|0;b=b|0;var c=0;c=i;AW(a,b);i=c;return}function AW(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function BW(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function CW(a,b){a=a|0;b=b|0;var d=0;d=i;zW(a,c[(DW(b)|0)>>2]|0);i=d;return}function DW(a){a=a|0;i=i;return a|0}function EW(a,b){a=a|0;b=b|0;var c=0;c=i;wW(a,b);i=c;return}function FW(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=OX(a,b)|0;i=c;return d|0}function GW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];QW(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];PW(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];eT(a,g);TV(l);i=f;return}function HW(a){a=a|0;var b=0,c=0;b=i;c=MW(a)|0;i=b;return c|0}function IW(a){a=a|0;var b=0;b=i;JW(a)|0;i=b;return a|0}function JW(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=KW(c[d>>2]|0)|0;i=b;return a|0}function KW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;nN(b);if((e|0)==0){e=a;while(1){a=bP(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=LW(c[d>>2]|0)|0;i=b;return g|0}return 0}function LW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;nN(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;nN(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function MW(a){a=a|0;var b=0,d=0;b=i;d=NW((c[a>>2]|0)+16|0)|0;i=b;return d|0}function NW(a){a=a|0;var b=0,c=0;b=i;c=OW(a)|0;i=b;return c|0}function OW(a){a=a|0;i=i;return a|0}function PW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=UW(b,h,j,e)|0;h=c[p>>2]|0;nN(l);if((h|0)!=0){q=h;gT(a,q);i=f;return}WW(o,b,e);XW(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];VW(m,g);YW(o);o=c[j>>2]|0;TU(b,o,p,ZW(m)|0);p=_W(m)|0;YW(m);q=p;gT(a,q);i=f;return}function QW(a,b){a=a|0;b=b|0;var c=0;c=i;RW(a,b);i=c;return}function RW(a,b){a=a|0;b=b|0;var c=0;c=i;SW(a,b);i=c;return}function SW(a,b){a=a|0;b=b|0;var c=0;c=i;TW(a,b);i=c;return}function TW(a,b){a=a|0;b=b|0;var c=0;c=i;O$(a,b);O$(a+12|0,b+12|0);i=c;return}function UW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;fT(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];CX(l,k);do{if(!(BX(b,l)|0)){k=qT(a)|0;x=EX(b)|0;if(DX(k,e,x)|0){break}w=DX(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];IX(r,h,1,0);fT(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];CX(t,g);do{if(!(BX(r,t)|0)){if(DX(k,e,EX(r)|0)|0){break}y=HX(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;nN(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;FX(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];CX(o,j);do{if(!(BX(n,o)|0)){j=qT(a)|0;if(DX(j,EX(GX(n)|0)|0,e)|0){break}y=HX(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;nN(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function VW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];zX(a,e);i=d;return}function WW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=pV(d)|0;d=rV(n,1)|0;lX(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kX(j,d,h);mX(0,RV((nX(j)|0)+16|0)|0,e);a[(oX(j)|0)+4|0]=1;pX(m,j);XW(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];VW(b,g);YW(m);YW(j);i=f;return}function XW(a,b){a=a|0;b=b|0;var c=0;c=i;iX(a,b);i=c;return}function YW(a){a=a|0;var b=0;b=i;dX(a);i=b;return}function ZW(a){a=a|0;var b=0,d=0;b=i;d=c[(bX(a)|0)>>2]|0;i=b;return d|0}function _W(a){a=a|0;var b=0,d=0;b=i;d=$W(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function $W(a){a=a|0;var b=0,c=0;b=i;c=aX(a)|0;i=b;return c|0}function aX(a){a=a|0;i=i;return a|0}function bX(a){a=a|0;var b=0,c=0;b=i;c=cX(a)|0;i=b;return c|0}function cX(a){a=a|0;i=i;return a|0}function dX(a){a=a|0;var b=0;b=i;eX(a,0);i=b;return}function eX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=$W(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}gX(fX(e)|0,f);i=d;return}function fX(a){a=a|0;var b=0,c=0;b=i;c=hX(a)|0;i=b;return c|0}function gX(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;QV(f,RV(d+16|0)|0)}if((d|0)==0){i=e;return}iV(c[b>>2]|0,d,1);i=e;return}function hX(a){a=a|0;i=i;return a+4|0}function iX(a,b){a=a|0;b=b|0;var c=0;c=i;jX(a,b);i=c;return}function jX(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];tX(a,b,f);i=e;return}function lX(a,b){a=a|0;b=b|0;var c=0;c=i;sX(a,b);i=c;return}function mX(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}qX(b,c);i=a;return}function nX(a){a=a|0;var b=0,d=0;b=i;d=c[(bX(a)|0)>>2]|0;i=b;return d|0}function oX(a){a=a|0;var b=0,c=0;b=i;c=fX(a)|0;i=b;return c|0}function pX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;iX(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];VW(h,f);XW(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];VW(a,e);YW(h);i=d;return}function qX(a,b){a=a|0;b=b|0;var c=0;c=i;rX(a,b);i=c;return}function rX(a,b){a=a|0;b=b|0;var c=0;c=i;SW(a,b);i=c;return}function sX(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function tX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(CV(g)|0)>>2]|0;g=vX(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];uX(b,a,f);i=e;return}function uX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wX(a,b,f);i=e;return}function vX(a){a=a|0;i=i;return a|0}function wX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(GV(g)|0)>>2]|0;g=yX(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xX(b,a,f);i=e;return}function xX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(GV(f)|0)>>2];f=yX(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function yX(a){a=a|0;i=i;return a|0}function zX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=_W(AX(b)|0)|0;h=yX(oX(AX(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];uX(g,a,e);i=d;return}function AX(a){a=a|0;i=i;return c[a>>2]|0}function BX(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function CX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];NX(a,e);i=d;return}function DX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=sR(0,b,c)|0;i=a;return d|0}function EX(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function FX(a,b){a=a|0;b=b|0;var d=0;d=i;gT(a,c[(JU(b)|0)>>2]|0);i=d;return}function GX(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=LX(c[d>>2]|0)|0;i=b;return a|0}function HX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=oT(a)|0;nN(e);if((h|0)==0){j=hT(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=qT(a)|0;a=h;while(1){h=a+16|0;if(DX(j,d,h)|0){l=a;m=c[l>>2]|0;nN(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(DX(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;nN(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function IX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;JX(b,d);c[a>>2]=c[b>>2];i=e;return}function JX(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;KX(b,c,e);i=d;return}function KX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{GX(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{JW(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function LX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;nN(b);if((e|0)==0){e=a;while(1){a=bP(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=MX(c[d>>2]|0)|0;i=b;return g|0}return 0}function MX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;nN(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;nN(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function NX(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function OX(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(BX(a,b)|0)^1;i=c;return d|0}function PX(a){a=a|0;var b=0;b=i;i=i+128|0;dR(a,b);dR(a+12|0,b+8|0);QX(a+24|0,b+16|0);QX(a+36|0,b+24|0);QX(a+48|0,b+32|0);QX(a+60|0,b+40|0);QX(a+72|0,b+48|0);QX(a+84|0,b+56|0);QX(a+96|0,b+64|0);QX(a+108|0,b+72|0);QX(a+120|0,b+80|0);QX(a+132|0,b+88|0);QX(a+144|0,b+96|0);QX(a+156|0,b+104|0);QX(a+168|0,b+112|0);QX(a+180|0,b+120|0);i=b;return}function QX(a,b){a=a|0;b=b|0;b=i;RX(a,0);i=b;return}function RX(a,b){a=a|0;b=b|0;b=i;i=i+8|0;SX(a,b);i=b;return}function SX(a,b){a=a|0;b=b|0;b=i;TX(a,0);i=b;return}function TX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;UX(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;VX(f,0,e);e=QT(b)|0;c[(PT(b)|0)>>2]=e;i=d;return}function UX(a){a=a|0;var b=0;b=i;YX(a);i=b;return}function VX(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;WX(b,c,f);i=e;return}function WX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(RP(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;XX(d,b,f);i=e;return}function XX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(RP(e)|0)>>2];i=d;return}function YX(a){a=a|0;var b=0;b=i;ZX(a);i=b;return}function ZX(a){a=a|0;var b=0;b=i;UP(a);i=b;return}function _X(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[120564>>2]|0;if((m|0)==0){n=0}else{o=haa(12)|0;S$(o,m);n=o}if((c[120480>>2]|0)!=0){c[15886]=1}if((n|0)==0){c[63556>>2]=1;c[63560>>2]=1;i=b;return}do{if((u0(n,110704,0)|0)==-1){O$(g,n);M$(h);o=c[15460]|0;m=(o|0)<28;while(1){p=u0(g,110712,0)|0;q=(p|0)!=-1;if(q){s0(j,g,0,p);Z$(h,j)|0;Y$(j);s0(k,g,p+1|0,-1);Z$(g,k)|0;Y$(k)}else{Z$(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){S$(l,c[62256+(s<<2)>>2]|0);p=$X(h,l)|0;Y$(l);if(p){c[63552+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){tH(1,1,110720,f);if(m){v=o}else{w=64104;x=c[16026]|0;me[x&255](1);y=t0(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=110760;E=D;vH(0,E,a)}do{p=c[63424+(v<<2)>>2]|0;c[e>>2]=c[62256+(v<<2)>>2];c[e+4>>2]=p;tH(1,0,110744,e);v=v+1|0;}while((v|0)<28);w=64104;x=c[16026]|0;me[x&255](1);y=t0(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=110760;E=D;vH(0,E,a)}else if((t|0)==20){tH(1,1,110720,d);w=64104;x=c[16026]|0;me[x&255](1);y=t0(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=110760;E=D;vH(0,E,a)}else if((t|0)==23){Y$(h);Y$(g);break}}else{o=1;do{c[63552+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[63556>>2]=1;c[63560>>2]=1;if((c[63588>>2]|0)!=0){c[63648>>2]=1}if((c[63644>>2]|0)==1){c[63652>>2]=1}if((c[63624>>2]|0)!=0){c[63620>>2]=1}if((c[63632>>2]|0)!=0){c[63620>>2]=1}if((c[63584>>2]|0)!=0){c[63580>>2]=1}if((c[63628>>2]|0)!=0){c[63620>>2]=1}if((c[63576>>2]|0)!=0){c[63572>>2]=1}Y$(n);jaa(n);i=b;return}function $X(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=W$(b)|0;if((e|0)!=(W$(c)|0)){f=0;i=d;return f|0}g=X$(b)|0;h=X$(c)|0;if(P$(b)|0){f=(uR(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function aY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[120572>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=haa(12)|0;l=k;S$(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(bY(l,c[95800+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=t0(l)|0;tH(1,1,110792,g);g=c[95884>>2]|0;c[f>>2]=c[95804>>2];c[f+4>>2]=g;tH(1,0,110744,f);f=c[95888>>2]|0;c[e>>2]=c[95808>>2];c[e+4>>2]=f;tH(1,0,110744,e);e=c[95892>>2]|0;c[d>>2]=c[95812>>2];c[d+4>>2]=e;tH(1,0,110744,d);me[c[16026]&255](1);vH(0,110848,a)}else if((n|0)==6){i=b;return j|0}return 0}function bY(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(w0(a,b)|0)==0;i=c;return d|0}function cY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[120556>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=haa(12)|0;l=k;S$(l,h);if((k|0)==0){j=1;i=b;return j|0}S$(f,110872);k=$X(l,f)|0;Y$(f);if(k){j=1;i=b;return j|0}S$(g,110880);k=$X(l,g)|0;Y$(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=t0(l)|0;tH(1,1,110888,e);c[d>>2]=110872;c[d+4>>2]=110944;tH(1,0,110744,d);c[a>>2]=110880;c[a+4>>2]=110960;tH(1,0,110744,a);me[c[16026]&255](1);vH(0,110848,b)}return 0}function dY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;f2(f,a);if(!(i2(f)|0)){g2(f);i=d;return a|0}j=CR(b)|0;rY(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((rN(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=S0(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];uY(h,e,b,m,k,l,n);if(!(sY(h)|0)){g2(f);i=d;return a|0}M0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);g2(f);i=d;return a|0}function eY(a){a=a|0;var b=0;b=i;l2(a,T0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;U1(a)|0;i=b;return a|0}function fY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;S$(h,d);H0(k,110968,h);PQ(j,k,110976);Y$(k);k=t0(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((Baa(c[n+4>>2]|0,110984)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((Baa(k,110992)|0)==0){Y$(j);Y$(h);i=f;return}d=j9(g,k,1)|0;if((d|0)!=0){m=l;Jaa(m|0,0,2048)|0;w9(d,g,m,2048)|0;j2(dY(dY(dY(dY(dY(132960,111e3)|0,k)|0,111040)|0,m)|0,111056)|0,103)|0;Y$(j);Y$(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(x9(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(x9(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(x9(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(x9(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==1){q=(x9(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(x9(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){m=b+8|0;s=l;l=0;while(1){d=c[m>>2]|0;if((a[d+(l*48|0)+44|0]|0)==0){k=(x9(g,c[d+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(l*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=l+1|0;if((k|0)<(t|0)){s=t;l=k}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;m=b+24|0;k=0;do{d=c[t>>2]|0;do{if((a[d+(k*52|0)+48|0]|0)==0){p=a[d+(k*52|0)+8|0]|0;if(p<<24>>24==1){n=(x9(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[m>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==0){p=(x9(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[p+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[l>>2]|0))}l=b+124|0;k=c[l>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){m=c[s>>2]|0;if((a[m+(k*52|0)+48|0]|0)==0){o=(x9(g,c[m+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[l>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==1){m=(x9(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=m;m=c[u>>2]|0;if((a[m+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[m+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(x9(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}n9(g);Y$(j);Y$(h);i=f;return}function gY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[120420>>2]|0;H=c[120548>>2]|0;I=c[2]|0;if((c[63652>>2]|0)==0){if(!((c[120368>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;rH(23,0,111104,l);l=c[120492>>2]|0;do{if((l|0)==0){M=0}else{if((Baa(l,111128)|0)==0){M=1;break}if((Baa(l,111136)|0)==0){M=0;break}if((Baa(l,111144)|0)==0){M=2;break}c[j>>2]=l;tH(1,0,111152,j);M=0}}while(0);if((JI(M)|0)!=0){c[g>>2]=l;tH(1,0,111224,g)}if((c[2]|0)!=0){qZ(d+56|0);OI((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);KI(0);KI(6);LI(3);LI(4);LI(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+xaa(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];rH(1,0,111312,f)}do{if((c[120476>>2]|0)!=0){f=haa(12)|0;J=f;S$(J,c[120604>>2]|0);if((f|0)==0){break}f=t0(J)|0;c[d+280>>2]=f;c[e>>2]=f;rH(23,0,111368,e)}}while(0);e=c[120600>>2]|0;M$(m);if((e|0)==0){S$(p,c[d+88>>2]|0);S$(q,111416);hY(o,p,q);PQ(n,o,c[d+284>>2]|0);Z$(m,n)|0;Y$(n);Y$(o);Y$(q);Y$(p)}else{_$(m,e)|0}S$(r,111424);S$(s,111424);S$(t,111424);S$(u,111424);S$(v,111424);S$(w,111424);e=c[120368>>2]|0;if((c[120388>>2]|0)!=0){_$(r,c[120516>>2]|0)|0}if((c[120404>>2]|0)!=0){_$(s,c[120532>>2]|0)|0}if((c[120384>>2]|0)!=0){_$(t,c[120512>>2]|0)|0}if((c[120392>>2]|0)==0){O=0.0}else{_$(u,c[120520>>2]|0)|0;O=+xaa(t0(u)|0)}if((c[120396>>2]|0)==0){P=1}else{_$(v,c[120524>>2]|0)|0;P=Kc(t0(v)|0)|0}if((c[120456>>2]|0)!=0){_$(w,c[120584>>2]|0)|0}O$(x,m);O$(y,r);O$(z,s);O$(A,t);O$(B,w);p=iY(d,x,y,z,A,O,P,B,e)|0;Y$(B);Y$(A);Y$(z);Y$(y);Y$(x);if((p|0)!=0|g^1){Q=p}else{KI(5);p=HY(d)|0;NI(5);rH(1,0,111432,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Y$(w);Y$(v);Y$(u);Y$(t);Y$(s);Y$(r);Y$(m);i=b;return R|0}Q=d+88|0;S$(D,c[Q>>2]|0);PQ(C,D,111464);Y$(D);S$(F,c[Q>>2]|0);PQ(E,F,111480);Y$(F);NI(0);F=c[120568>>2]|0;Q=t0(C)|0;D=t0(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;eZ(d,Q,D,(F|0)!=0?F:111496,I,p,t0(m)|0)|0;Y$(E);Y$(C);R=0;Y$(w);Y$(v);Y$(u);Y$(t);Y$(s);Y$(r);Y$(m);i=b;return R|0}function hY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;N$(a,d);e=W$(b)|0;f=W$(c)|0;x0(a,X$(b)|0,e,f+e|0);p0(a,X$(c)|0,f)|0;i=d;return}function iY(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((W$(j)|0)==0){u=0}else{u=t0(j)|0}O$(r,b);b=(jY(a,r,k)|0)==0;Y$(r);if(!b){v=-1;i=l;return v|0}S$(s,111424);b=a+280|0;r=bY(s,c[b>>2]|0)|0;Y$(s);do{if(r){w=3}else{s=1;k=0;do{S$(t,c[111640+(s<<2)>>2]|0);j=bY(t,c[b>>2]|0)|0;Y$(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];tH(1,0,111720,q);tH(1,0,110720,p);s=1;do{j=c[111752+(s<<2)>>2]|0;c[o>>2]=c[111640+(s<<2)>>2];c[o+4>>2]=j;tH(1,0,110744,o);s=s+1|0;}while((s|0)<20);vH(c[a+536>>2]|0,110848,n)}}while(0);c[m>>2]=c[111640+(w<<2)>>2];rH(23,0,111832,m);m=t0(d)|0;d=t0(e)|0;e=GL(a,m,d,t0(f)|0,g,h,w,u)|0;ne[c[105084>>2]&127](105056,a);v=e;i=l;return v|0}function jY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[26264]=Fd(t0(b)|0)|0;c[105060>>2]=g;c[105064>>2]=d;d=a+284|0;do{if((c[27674]|0)==0){g=c[d>>2]|0;if((Baa(111504,g)|0)==0){h=0;break}if((Baa(111512,g)|0)==0){c[105072>>2]=74;c[105076>>2]=75;c[105084>>2]=76;h=0;break}if((Baa(111520,g)|0)==0){c[105072>>2]=77;c[105076>>2]=78;c[105080>>2]=79;c[105084>>2]=80;h=1;break}if((Baa(111528,g)|0)==0){c[105072>>2]=81;c[105076>>2]=82;c[105080>>2]=83;c[105084>>2]=84;h=1;break}if((Baa(111536,g)|0)==0){c[105072>>2]=85;c[105076>>2]=86;c[105084>>2]=87;h=0;break}g=dY(132960,111544)|0;j2(dY(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);fY(a+8|0,c[a+288>>2]|0,h);ne[c[105072>>2]&127](105056,a);a=c[26264]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;rH(23,0,111568,f);j=0;i=e;return j|0}function kY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;iH();do{if((yZ(a,b)|0)==0){if((AZ(a,b)|0)!=0){break}do{if((c[120424>>2]|0)!=0){w=c[120552>>2]|0;if((Baa(w,111952)|0)==0){oH(1);break}if((Baa(w,111960)|0)==0){oH(0);break}else{c[p>>2]=w;tH(1,0,111968,p);zd(0)|0;Id(0)}}}while(0);if((c[120380>>2]|0)==0){_X(0,0);DK(d);if((d|0)==0){j2(dY(132960,112336)|0,103)|0}c[d+300>>2]=aY(0,0)|0;c[d+292>>2]=cY(0,0)|0;MQ(d+8|0,d+240|0);MK(d)|0;UK(d)|0;eL(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}j2(dY(132960,112400)|0,103)|0;x=1;i=e;return x|0}}while(0);c[27674]=c[120448>>2];x=0;i=e;return x|0}S$(u,c[120508>>2]|0);w=1;while(1){y=68344+(w<<2)|0;S$(v,c[y>>2]|0);z=$X(u,v)|0;Y$(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=t0(u)|0;tH(1,0,112240,g);c[f>>2]=c[b>>2];tH(1,0,112280,f);zd(0)|0;Id(0)}A=c[72368+(w<<2)>>2]|0;do{if((A|0)==1){z=c[72240+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;rH(1,1,112040,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[72240+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;rH(1,1,112080,n);break}else{c[m>>2]=z;tH(1,1,111920,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[111752+(A<<2)>>2]|0;c[h>>2]=c[111640+(A<<2)>>2];c[h+4>>2]=z;rH(1,0,110744,h);A=A+1|0;}while((A|0)<20);D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}else if((w|0)==7){A=1;do{z=c[112160+(A<<2)>>2]|0;c[k>>2]=c[112144+(A<<2)>>2];c[k+4>>2]=z;rH(1,0,110744,k);A=A+1|0;}while((A|0)<4);D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}else if((w|0)==11){A=1;do{z=c[112208+(A<<2)>>2]|0;c[j>>2]=c[112176+(A<<2)>>2];c[j+4>>2]=z;rH(1,0,110744,j);A=A+1|0;}while((A|0)<7);D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}else if((w|0)==19){A=c[15460]|0;if((A|0)<28){G=A}else{D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}do{A=c[63424+(G<<2)>>2]|0;c[l>>2]=c[62256+(G<<2)>>2];c[l+4>>2]=A;rH(1,0,110744,l);G=G+1|0;}while((G|0)<28);D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}else{D=64104;E=c[16026]|0;me[E&255](1);F=zd(0)|0;Id(0)}}}while(0);c[t>>2]=c[b>>2];rH(1,1,111856,t);t=1;do{b=c[72368+(t<<2)>>2]|0;do{if((b|0)==1){F=c[70248+(t<<2)>>2]|0;c[s>>2]=c[68344+(t<<2)>>2];c[s+4>>2]=F;rH(1,0,111872,s)}else{F=c[68344+(t<<2)>>2]|0;if((b|0)==2){E=c[70248+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;rH(1,0,111888,r);break}else{c[q>>2]=F;tH(1,0,111920,q);break}}}while(0);t=t+1|0;}while((t|0)<31);me[c[16026]&255](1);zd(0)|0;Id(0);return 0}function lY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[28108]|0;tb(114080)|0;c[l>>2]=c[m+88>>2];kc(112440,l|0)|0;tb(114096)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];kc(112464,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];kc(112504,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(112536,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];kc(112568,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];kc(112600,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];kc(112632,b|0)|0;tb(114120)|0;i=a;return}function mY(a,b){a=a|0;b=+b;i=i;return}function nY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;Eaa(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Saa(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Saa(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[28108]=d;u=0;Ha(62,10,229)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Saa(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Saa(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Saa(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Saa(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Saa(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Saa(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(230,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Saa(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Saa(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Saa(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function oY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=sd(c[15338]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;wc(112768,7,1,a|0)|0;Ic(a|0,d|0,f|0)|0;Zd(10,a|0)|0;zd(0)|0;eb(c[g+80>>2]|0,1);break};case 3:{if((c[63620>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;wc(112768,7,1,a|0)|0;Ic(a|0,d|0,f|0)|0;Zd(10,a|0)|0;zd(0)|0;i=b;return};case 2:{if((c[63564>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;e=c[r>>2]|0;wc(112768,7,1,e|0)|0;Ic(e|0,d|0,f|0)|0;Zd(10,e|0)|0;zd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 5:case 4:{i=b;return};default:{vH(g,112776,b)}}}function pY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;wc(112752,9,1,d|0)|0;Ic(d|0,b|0,e|0)|0;Zd(10,d|0)|0;zd(0)|0;i=a;return}function qY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;xY(112696,b);c[27666]=111424;b=110668|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[110684>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}d=sd(c[15338]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}function rY(a,b){a=a|0;b=b|0;var c=0;c=i;tY(a,b);i=c;return}function sY(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function tY(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=R0(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function uY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;nN(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=vY(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((b1(b,d,r)|0)==(r|0)){break}nN(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){T$(l,s,h);if((b1(b,X$(l)|0,s)|0)==(s|0)){Y$(l);break}nN(m);c[o>>2]=0;c[a>>2]=0;Y$(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((b1(b,e,l)|0)==(l|0)){break}nN(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);wY(g,0)|0;c[a>>2]=b;i=j;return}function vY(a){a=a|0;i=i;return c[a+12>>2]|0}function wY(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function xY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[27672]|0;if((g|0)==0){c[e>>2]=(Faa(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(DR(e,f)|0)>>2]|0;c[28186]=h;f=baa(h)|0;c[27672]=f;j=h;k=f}else{j=c[28186]|0;k=g}g=dd(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[28186]|0)>>>0){i=d;return}caa(c[27672]|0);j=g<<1|1;c[28186]=j;g=baa(j)|0;c[27672]=g;dd(g|0,j|0,a|0,b|0)|0;i=d;return}function yY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;zY(g,16);AY(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){BY(a,g);CY(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){dY(k2(m,+h[b+(p<<3)>>3])|0,114136)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){k2(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){dY(m,114144)|0}}while((e|0)<(d|0));BY(a,g);CY(g);i=f;return}function zY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;V0(e);f=a;c[f>>2]=114516;g=e;c[g>>2]=114536;e=a+4|0;a2(a,114548|0,e);c[f>>2]=114516;c[g>>2]=114536;OY(e,b|16);i=d;return}function AY(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function BY(a,b){a=a|0;b=b|0;var c=0;c=i;IY(a,b+4|0);i=c;return}function CY(a){a=a|0;var b=0;b=i;SY(a,114544);Q0(a+56|0);i=b;return}function DY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63608>>2]|0)!=0){tb(114840)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(14,0,114152,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(14,0,114224,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63608>>2]|0)==0){i=d;return 0}rH(14,0,114272,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(114288,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function EY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63608>>2]|0)!=0){tb(114840)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(14,0,114152,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(14,0,114224,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63608>>2]|0)==0){i=d;return 0}rH(14,0,114272,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(114288,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function FY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63608>>2]|0)!=0){tb(114840)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(14,0,114152,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(14,0,114224,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63608>>2]|0)==0){i=d;return 0}rH(14,0,114272,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(114288,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function GY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[63608>>2]|0)!=0){tb(114840)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rH(14,0,114152,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);pe[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rH(14,0,114224,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[63608>>2]|0)==0){i=d;return 0}rH(14,0,114272,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];kc(114288,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}gc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function HY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=daa(fa(F,F)|0,8)|0;J=I;K=daa(fa(G,F)|0,8)|0;L=K;M=daa(fa(H,F)|0,8)|0;N=M;O=daa(fa(H,G)|0,8)|0;P=O;M$(p);M$(q);M$(r);M$(s);M$(t);M$(u);M$(v);Q=a+536|0;uH(c[Q>>2]|0,(I|0)!=0|0,114296,o);uH(c[Q>>2]|0,(K|0)!=0|0,114296,n);uH(c[Q>>2]|0,(M|0)!=0|0,114296,m);uH(c[Q>>2]|0,(O|0)!=0|0,114296,l);l=a+540|0;m=a;if((pe[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;DY(a,J)|0;uH(n,1,114312,k)}yY(w,J,F,F);Z$(p,w)|0;Y$(w);if((pe[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;EY(a,L)|0;uH(w,1,114344,j)}yY(x,L,F,G);Z$(q,x)|0;Y$(x);if((pe[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;FY(a,N)|0;uH(x,1,114376,h)}yY(y,N,H,F);Z$(r,y)|0;Y$(y);if((pe[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;GY(a,P)|0;uH(m,1,114408,g)}yY(z,P,H,G);Z$(s,z)|0;Y$(z);if((F|0)==0){_$(t,114440)|0}else{yY(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Z$(t,A)|0;Y$(A)}if((G|0)==0){_$(u,114440)|0}else{yY(B,c[a+432>>2]|0,1,G);Z$(u,B)|0;Y$(B)}caa(I);caa(K);caa(M);caa(O);S$(E,c[a+84>>2]|0);H0(D,114456,E);PQ(C,D,114464);Z$(v,C)|0;Y$(C);Y$(D);Y$(E);E=mc(t0(v)|0,114472)|0;D=c[Q>>2]|0;c[f>>2]=t0(v)|0;uH(D,(E|0)!=0|0,114480,f);f=Je[c[(c[l>>2]|0)+176>>2]&7]()|0;D=t0(t)|0;Q=t0(u)|0;C=t0(p)|0;a=t0(q)|0;O=t0(r)|0;M=t0(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;Bd(E|0,f|0,e|0)|0;if((c[63652>>2]|0)==0){R=zd(E|0)|0;S=cd(E|0)|0;Y$(v);Y$(u);Y$(t);Y$(s);Y$(r);Y$(q);Y$(p);i=b;return 0}e=Je[c[(c[l>>2]|0)+176>>2]&7]()|0;l=t0(t)|0;f=t0(u)|0;M=t0(p)|0;O=t0(q)|0;a=t0(r)|0;C=t0(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;rH(25,0,e,d);R=zd(E|0)|0;S=cd(E|0)|0;Y$(v);Y$(u);Y$(t);Y$(s);Y$(r);Y$(q);Y$(p);i=b;return 0}function IY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=j1(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}JY(a,i1(l)|0,n,e);i=d;return}if((h&8|0)==0){N$(a,g);i=d;return}else{g=b;b=d1(g)|0;JY(a,b,f1(g)|0,f);i=d;return}}function JY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;KY(a,b,c,0);i=d;return}function KY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;LY(a,b,c);i=d;return}function LY(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=MY(c,d)|0;if(g>>>0>4294967279){K$(0)}if(g>>>0<11){c0(b,g);h=b0(b)|0}else{j=j0(g)|0;k=j+1|0;j=zR(R$(b)|0,k)|0;l0(b,j);k0(b,k);a0(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;AR(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){AR(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;AR(l,f);i=e;return}function MY(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=NY(b,c,e)|0;i=d;return g|0}function NY(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function OY(a,b){a=a|0;b=b|0;var c=0;c=i;cZ(a,b);i=c;return}function PY(a){a=a|0;var b=0;b=i;CY(a);jaa(a);i=b;return}function QY(a){a=a|0;var b=0;b=i;CY(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function RY(a){a=a|0;var b=0;b=i;PY(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function SY(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];TY(a+4|0);i=d;return}function TY(a){a=a|0;var b=0;b=i;UY(a);i=b;return}function UY(a){a=a|0;var b=0;b=i;c[a>>2]=114696;Y$(a+32|0);Z0(a);i=b;return}function VY(a){a=a|0;var b=0;b=i;TY(a);jaa(a);i=b;return}function WY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=j1(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}BM(a,-1,-1);i=h;return}else if((k|0)==0){BM(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=j1(l)|0;j=m-(i1(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=e1(l)|0;m=j-(d1(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(X$(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){BM(a,-1,-1);i=h;return}o=Paa(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(X$(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((e1(l)|0)!=0){break}BM(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((j1(l)|0)!=0){break}BM(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=d1(l)|0;h1(l,q,q+o|0,n)}if((g&16|0)!=0){q=i1(l)|0;m1(l,q,k1(l)|0);l1(l,o)}BM(a,o,e);i=h;return}}while(0);BM(a,-1,-1);i=h;return}function XY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=PN(d)|0;ye[g&31](a,b,h,J,0,e);i=f;return}function YY(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=j1(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((f1(g)|0)>>>0<j>>>0){b=d1(g)|0;h1(g,b,e1(g)|0,j)}j=e1(g)|0;if(!(j>>>0<(f1(g)|0)>>>0)){k=-1;i=d;return k|0}k=lO(a[j]|0)|0;i=d;return k|0}function ZY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=j1(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=d1(h)|0;j=e1(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(hO(d,-1)|0){h1(h,g,j+ -1|0,k);l=kO(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=iO(d)|0;do{if(g){if(mO(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=d1(h)|0;h1(h,j,(e1(h)|0)+ -1|0,k);a[e1(h)|0]=b;l=d;i=e;return l|0}function _Y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(hO(b,-1)|0){f=kO(b)|0;i=d;return f|0}g=a;h=e1(g)|0;j=h-(d1(g)|0)|0;h=j1(g)|0;do{if((h|0)==(k1(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=i1(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;o0(o,0);h0(o,e0(o)|0);p=X$(o)|0;m1(g,p,p+(W$(o)|0)|0);l1(g,h-l|0);c[m>>2]=(i1(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(j1(g)|0)+1;h=c[($Y(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=X$(a+32|0)|0;h1(g,q,q+j|0,h)}f=a1(g,b&255)|0;i=d;return f|0}function $Y(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=aZ(b,c,e)|0;i=d;return g|0}function aZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=bZ(0,a,b)|0;i=c;return(d?b:a)|0}function bZ(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function cZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c1(a);c[a>>2]=114696;M$(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;M$(e);dZ(a,e);Y$(e);i=d;return}function dZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Z$(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=X$(e)|0;j=g+(W$(e)|0)|0;c[b>>2]=j;g=X$(e)|0;h1(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=W$(e)|0;c[b>>2]=(X$(e)|0)+h;h0(e,e0(e)|0);b=a;a=X$(e)|0;m1(b,a,a+(W$(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}l1(b,h);i=d;return}function eZ(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=mc(d|0,115120)|0;J=hd(115128,115120)|0;K=(J|0)!=0;L=Sc()|0;if(K){M=c[b+536>>2]|0;N=be(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;uH(M,(I|0)!=0|0,115184,E);wc(115208,17,1,J|0)|0;wc(115232,10,1,J|0)|0;wc(115248,18,1,J|0)|0;fZ(J,f,115272,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,115304)}else{c[G>>2]=be(c[L>>2]|0)|0;tH(26,0,115136,G);G=c[b+536>>2]|0;E=be(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;uH(G,(I|0)!=0|0,115184,F)}wc(115312,348,1,I|0)|0;if((xc(H|0)|0)<0){c[D>>2]=be(c[L>>2]|0)|0;tH(26,0,115664,D);cd(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Xc(114864,250,115688,qd(H|0)|0)|0)==0){tH(26,0,115712,C);cd(I|0)|0;O=1;i=j;return O|0}wc(115736,13,1,I|0)|0;wc(115752,12,1,I|0)|0;gZ(I,2);wc(115768,6,1,I|0)|0;hZ(I,c[b+84>>2]|0);wc(115776,8,1,I|0)|0;gZ(I,2);wc(115792,8,1,I|0)|0;C=b+88|0;hZ(I,c[C>>2]|0);wc(115808,10,1,I|0)|0;gZ(I,2);wc(115824,6,1,I|0)|0;hZ(I,114864);wc(115832,8,1,I|0)|0;gZ(I,2);wc(115848,8,1,I|0)|0;hZ(I,c[b+280>>2]|0);wc(115864,10,1,I|0)|0;gZ(I,2);wc(115880,14,1,I|0)|0;hZ(I,c[b+284>>2]|0);wc(115896,16,1,I|0)|0;gZ(I,2);wc(115920,16,1,I|0)|0;hZ(I,l);wc(115944,18,1,I|0)|0;gZ(I,2);c[B>>2]=iZ(l)|0;Bd(I|0,115968,B|0)|0;gZ(I,2);P=+FI(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(I|0,116008,A|0)|0;gZ(I,2);P=+FI(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Bd(I|0,116048,z|0)|0;gZ(I,2);P=+FI(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Bd(I|0,116080,y|0)|0;gZ(I,2);P=+FI(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(I|0,116112,x|0)|0;gZ(I,2);P=+FI(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Bd(I|0,116144,w|0)|0;gZ(I,2);P=+FI(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Bd(I|0,116176,v|0)|0;gZ(I,2);P=+FI(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Bd(I|0,116216,u|0)|0;gZ(I,2);P=+II(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];Bd(I|0,116248,t|0)|0;gZ(I,2);c[s>>2]=DI(2)|0;Bd(I|0,116288,s|0)|0;gZ(I,2);P=+HI(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Bd(I|0,116312,r|0)|0;wc(116344,13,1,I|0)|0;wc(116360,16,1,I|0)|0;gZ(I,2);P=+FI(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Bd(I|0,116384,q|0)|0;gZ(I,2);c[p>>2]=AI(8)|0;Bd(I|0,116408,p|0)|0;wc(116448,17,1,I|0)|0;wc(116472,22,1,I|0)|0;jZ(I,b);wc(116496,23,1,I|0)|0;wc(116520,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{kZ(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{kZ(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{kZ(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{kZ(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{kZ(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{kZ(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{kZ(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{kZ(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}wc(116536,13,1,I|0)|0;wc(116552,12,1,I|0)|0;lZ(I,J,f,c[C>>2]|0,b);wc(116568,13,1,I|0)|0;wc(116584,12,1,I|0)|0;mZ(I,c[b+68>>2]|0,b+56|0);wc(116600,13,1,I|0)|0;wc(116616,16,1,I|0)|0;nZ(I,J,f,b);wc(116640,17,1,I|0)|0;wc(116664,14,1,I|0)|0;cd(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((Faa(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(Faa(K|0)|0)<<1}else{Q=0}I=baa(b+Q|0)|0;if((I|0)==0){cb(116680,116688,404,116712)}if((ab(J|0)|0)!=0){tH(26,0,116728,o)}if(e){e=c[C>>2]|0;c[n>>2]=116760;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;lc(I|0,116776,n|0)|0;if((xd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=116856|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;tH(1,0,116888,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;rH(1,0,116952,g);caa(I);O=0;i=j;return O|0}



function Qe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Re(){return i|0}function Se(a){a=a|0;i=a}function Te(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ue(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ve(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function We(a){a=a|0;J=a}function Xe(a){a=a|0;K=a}function Ye(a){a=a|0;L=a}function Ze(a){a=a|0;M=a}function _e(a){a=a|0;N=a}function $e(a){a=a|0;O=a}function af(a){a=a|0;P=a}function bf(a){a=a|0;Q=a}function cf(a){a=a|0;R=a}function df(a){a=a|0;S=a}function ef(a){a=a|0;var b=0,d=0;b=i;QL(a)|0;d=a+540|0;pe[c[(c[d>>2]|0)+40>>2]&127](a)|0;pe[c[(c[d>>2]|0)+28>>2]&127](a)|0;pe[c[(c[d>>2]|0)+32>>2]&127](a)|0;pe[c[(c[d>>2]|0)+48>>2]&127](a)|0;pe[c[(c[d>>2]|0)+52>>2]&127](a)|0;tK(a);i=b;return}function ff(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=Faa(B|0)|0;D=baa(C+11|0)|0;Qaa(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=mc(D|0,32)|0;if((C|0)==0){B=be(c[(Sc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;tH(23,0,40,u);cd(0)|0;F=0}else{F=C}caa(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Je[c[64452>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{LI(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}LI(2);KI(2)}zI(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];gK(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(23,1,144,r);Z=yL(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}ef(b);uK(b);if((c[63644>>2]|0)!=0){me[c[16026]&255](23)}if((c[2]|0)!=0){KI(4)}A=iK(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rH(7,1,200,q);if((c[120452>>2]|0)==0){ne[c[105076>>2]&127](105056,b)}kK(b,c[J>>2]|0,z,d);if((c[63580>>2]|0)!=0){me[c[16026]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;yK(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){NI(4)}if((KL(b,1,1)|0)!=0){c[B>>2]=1;yK(b)}pe[c[(c[K>>2]|0)+88>>2]&127](b)|0;tK(b);CK(b);uK(b);do{if((T|0)==0){_=0}else{KI(7);NI(2);A=(wc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(wc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+FI(2);if(!$){aa=0;break}aa=(wc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+FI(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=AI(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(wc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+FI(ba+9|0);if((ca|0)==0){ka=0}else{ka=(wc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}NI(7);if((la|0)!=0){_=T;break}c[p>>2]=be(c[(Sc()|0)>>2]|0)|0;tH(23,0,240,p);cd(T|0)|0;_=0}}while(0);if((c[120452>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ne[c[105076>>2]&127](105056,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[27664]|0)!=0){ca=f;ba=110664;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];jH(M,f);Zd(10,M|0)|0;ba=c[27672]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;rH(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((hL(b,0)|0)!=0){ma=58;break}if((ZK(b,0)|0)!=0){ma=58;break}if((OK(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rH(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((hL(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rH(1,0,448,m);U=_;V=-2;break}if((ZK(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rH(1,0,536,l);U=_;V=-3;break}T=(OK(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rH(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rH(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}cd(U|0)|0;i=e;return V|0}function gf(a){a=a|0;i=i;return 0}function hf(a){a=a|0;i=i;return 0}function jf(a){a=a|0;i=i;return 0}function kf(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0;b=i;d=c[a+416>>2]|0;e=+h[d+19048>>3];f=+h[d+19072>>3];d=a+4|0;g=+QI(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+16>>3],-2);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+280>>3]=e*f*g*+(c[(c[a+420>>2]|0)+48>>2]|0)*-1256637061435917.0e-21;i=b;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+16>>3];j=b+416|0;k=c[j>>2]|0;l=+h[k+19088>>3];m=+h[k+19096>>3];n=g*g;do{if(g!=0.0){o=m/g}else{if(m==0.0){o=m;break}o=m/+xH(c[b+536>>2]|0,g,880,872,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);f=c[(c[b+420>>2]|0)+52>>2]|0;g=+(f|0);if(n*(o*3.141592653589793+1.0)!=0.0){k=c[c[e>>2]>>2]|0;o=+h[(c[k+8>>2]|0)+16>>3];p=+h[(c[j>>2]|0)+19096>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+xH(c[b+536>>2]|0,o,880,872,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=g/(n*(q*3.141592653589793+1.0));s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}if((f|0)==0){r=g;s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}f=c[b+536>>2]|0;k=c[c[e>>2]>>2]|0;q=+h[(c[k+8>>2]|0)+16>>3];o=+h[(c[j>>2]|0)+19096>>3];do{if(q!=0.0){E=k;F=o/q}else{if(o==0.0){E=k;F=o;break}p=o/+xH(f,q,880,872,+h[k>>3],(a[b+319|0]|0)!=0|0);E=c[c[e>>2]>>2]|0;F=p}}while(0);r=g/+xH(f,n*(F*3.141592653589793+1.0),904,872,+h[E>>3],(a[b+319|0]|0)!=0|0);s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+224|0;D=C;h[D>>3]=u;i=d;return}function mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+18272>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+18272>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+18272>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+18272>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+18264>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+856|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+18280>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+856|0;A=z;h[A>>3]=o;i=d;return}function nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+16>>3];m=b+416|0;n=+h[(c[m>>2]|0)+19096>>3];do{if(l!=0.0){o=n/l}else{if(n==0.0){o=n;break}o=n/+xH(c[b+536>>2]|0,l,880,1016,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);l=o*3.141592653589793+1.0;if(l>0.0){p=c[m>>2]|0;q=p;r=q+19088|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+232|0;F=E;h[F>>3]=w;i=d;return}j=c[28168]|0;G=c[b+536>>2]|0;b=f;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;H=4936;c[j+0>>2]=c[H+0>>2];c[j+4>>2]=c[H+4>>2];c[j+8>>2]=c[H+8>>2];c[j+12>>2]=c[H+12>>2];c[j+16>>2]=c[H+16>>2];c[j+20>>2]=c[H+20>>2];Pe[b&31](G,e,1024,f);p=c[m>>2]|0;q=p;r=q+19088|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+232|0;F=E;h[F>>3]=w;i=d;return}function of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,1168,1160,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b>>3]*+h[b+240>>3];i=i;return}function qf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+256>>3];h[b+248>>3]=d*d*+h[b+224>>3]*.5;i=i;return}function rf(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0.0,p=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+19048>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+16>>3];m=+h[e+19072>>3];do{if(l!=0.0){n=k;o=m/l}else{if(m==0.0){n=k;o=m;break}p=m/+xH(c[b+536>>2]|0,l,880,1200,+h[j>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=p}}while(0);h[n+288>>3]=f*o*1256637061435917.0e-21;i=d;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,1216,1208,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+296|0;p=o;h[p>>3]=m;i=d;return}function tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+696>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+696|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+696>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+8>>3]=k;gL(a,2)|0;j=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[j>>3];h[f+696>>3]=+h[j+8>>3];Jk(a);Kk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);$k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);i=b;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=-+h[b+312>>3]- +h[b>>3];i=i;return}function vf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2992>>3];k=+h[g+784>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+488|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+488|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,1256,1248,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+488|0;q=p;h[q>>3]=n;i=d;return}function wf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3],+h[f+18816>>3],+h[f+18824>>3],+h[f+18832>>3],+h[f+18840>>3],+h[f+18848>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[d>>3];i=b;return}function xf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+472>>3];k=+h[(c[b+416>>2]|0)+18856>>3];l=+h[g+2992>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,1296,1288,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+496>>3]=j*n*1256637061435917.0e-21;i=d;return}function yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,1336,1328,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}function zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+472>>3]*1256637061435917.0e-21;k=+h[g+488>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1376,1368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=-(+h[b+784>>3]*+h[b+504>>3]);i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[(c[a+416>>2]|0)+18488>>3]*+h[b+784>>3];i=i;return}function Cf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19072>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+312>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,1440,1432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3016>>3];k=+h[g+216>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1480,1472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+208|0;p=o;h[p>>3]=m;i=d;return}function Ef(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19104>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,1520,1512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+784>>3]- +h[b+216>>3]- +h[b+520>>3]- +h[b+528>>3];i=i;return}function Gf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3]*1256637061435917.0e-21;k=+h[g+736>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1592,1584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+728|0;p=o;h[p>>3]=m;i=d;return}function Hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+656>>3]*1256637061435917.0e-21;k=+h[g+672>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1664,1656,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+664|0;p=o;h[p>>3]=m;i=d;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+600>>3]*1256637061435917.0e-21;k=+h[g+616>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1736,1728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+608|0;p=o;h[p>>3]=m;i=d;return}function Jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3]*1256637061435917.0e-21;k=+h[g+560>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,1808,1800,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+816>>3]+ +h[b+512>>3];i=i;return}function Lf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+792>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,1872,1864,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+800|0;p=o;h[p>>3]=m;i=d;return}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+800>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+776>>3]*1.0e13;l=j}else{m=+h[j+800>>3];n=+h[j+776>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,1904,1896,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+768>>3]=+U(+k);i=d;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+2928>>3]*+h[b+800>>3];i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=+h[b+856>>3]- +h[b+832>>3];i=i;return}function Pf(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+18488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+808>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,1872,1928,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1160|0;q=p;h[q>>3]=n;i=d;return}function Qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2992>>3];k=+h[g+1160>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,1256,1936,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+976|0;q=p;h[q>>3]=n;i=d;return}function Rf(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+18824>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+488>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+488>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+488>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+488>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+488>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+488>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,1952,1944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+18840>>3];r=+h[j+18824>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+488>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,1952,1944,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+488>>3];x=E;y=D;z=+h[C+18824>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,1952,1944,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+488>>3];G=+h[u+18824>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+18848>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+18832>>3];r=+h[H+976>>3];H=G!=0.0;B=+h[J+18840>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,1952,1944,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+488>>3];O=A;P=+h[y+18824>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,1952,1944,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+488>>3];T=A;V=+h[y+18824>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+18848>>3]))+1.0==0.0;q=+h[X+18840>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,1952,1944,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+488>>3];_=x;$=+h[y+18824>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,1952,1944,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+18848>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,1952,1944,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+488>>3];fa=x;ga=+h[y+18824>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,1952,1944,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+18824>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+18848>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,1952,1944,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+18816>>3];ma=+h[L+18832>>3];ga=+h[L+18824>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+488>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,1952,1944,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+18824>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+18840>>3];ma=+h[na+976>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,1952,1944,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+18824>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+488>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,1952,1944,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+18824>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+18848>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+976>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,1952,1944,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,1952,1944,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+488>>3];Qa=xa;Ra=+h[ya+18824>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,1952,1944,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+488>>3];Va=xa;Wa=+h[ya+18824>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+18848>>3]))+1.0==0.0;t=+h[Xa+18840>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,1952,1944,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+488>>3];_a=Aa;$a=+h[ya+18824>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,1952,1944,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+18848>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,1952,1944,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+488>>3];fb=Aa;gb=+h[ya+18824>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,1952,1944,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+18824>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+18848>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,1952,1944,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+18816>>3];r=+h[Na+18832>>3];w=+h[Na+18824>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+488>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,1952,1944,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+18824>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+18840>>3];r=+h[nb+976>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,1952,1944,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+18824>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+488>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,1952,1944,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+18824>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+18848>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+976>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,1952,1944,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+18824>>3];Db=+h[sb+976>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+18832>>3];yb=Cb!=0.0;ub=+h[Gb+18840>>3];rb=+h[Eb+488>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+18848>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,1952,1944,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+488>>3];Lb=Ab;Mb=+h[Eb+18824>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,1952,1944,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+488>>3];Qb=Ab;Rb=+h[Eb+18824>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+18848>>3]))+1.0==0.0;Ca=+h[Sb+18840>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,1952,1944,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+488>>3];Vb=xb;Wb=+h[Eb+18824>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,1952,1944,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+18848>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,1952,1944,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+488>>3];ac=xb;bc=+h[Eb+18824>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,1952,1944,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+18824>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+18848>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,1952,1944,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+18816>>3];hc=+h[Ib+18832>>3];bc=+h[Ib+18824>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+488>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,1952,1944,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+18824>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+18840>>3];hc=+h[ic+976>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,1952,1944,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+18824>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+488>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,1952,1944,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+18824>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+18848>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+976>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,1952,1944,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+18848>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,1952,1944,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+488>>3];Bc=sc;Cc=+h[tc+18824>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,1952,1944,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+488>>3];Gc=sc;Hc=+h[tc+18824>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+18848>>3]))+1.0==0.0;Hb=+h[Ic+18840>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,1952,1944,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+488>>3];Lc=vc;Mc=+h[tc+18824>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,1952,1944,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+18848>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,1952,1944,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+488>>3];Sc=vc;Tc=+h[tc+18824>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,1952,1944,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+18824>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+18848>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,1952,1944,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+18816>>3];Db=+h[yc+18832>>3];m=+h[yc+18824>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+488>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,1952,1944,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+18824>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+18840>>3];Db=+h[_c+976>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,1952,1944,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+18824>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+488>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,1952,1944,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+18824>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+18848>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+976>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,1952,1944,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,2e3,1944,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1120>>3];k=+h[(c[b+416>>2]|0)+18856>>3];l=+h[g+2992>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,1296,2264,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+968>>3]=j*n*1256637061435917.0e-21;i=d;return}function Tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];k=j*j;j=+h[g+968>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,2280,2272,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=-(+h[b+1160>>3]*+h[b+504>>3])- +h[b+784>>3]*+h[b+960>>3];i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+832>>3]*+h[b+800>>3];i=i;return}function Wf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+320>>3];h[b+304>>3]=d*d*+h[b+280>>3]*.5;i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+248>>3]+ +h[b+304>>3];i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+8>>3];i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-+h[b+88>>3];i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+88>>3];i=i;return}function $f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+19088>>3];n=+h[l+19096>>3];o=j*j;do{if(j!=0.0){p=g;q=f;r=n/j}else{if(n==0.0){p=g;q=f;r=n;break}s=n/+xH(c[b+536>>2]|0,j,880,2320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[c[e>>2]>>2]|0;p=c[l+8>>2]|0;q=l;r=s}}while(0);j=+h[p+88>>3];if(o*(r*3.141592653589793+1.0)!=0.0){r=+h[p+16>>3];s=+h[(c[k>>2]|0)+19096>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+xH(c[b+536>>2]|0,r,880,2320,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=j/(o*(t*3.141592653589793+1.0));v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}if(j==0.0){u=j;v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}f=c[b+536>>2]|0;t=+h[p+16>>3];r=+h[(c[k>>2]|0)+19096>>3];do{if(t!=0.0){H=q;I=r/t}else{if(r==0.0){H=q;I=r;break}s=r/+xH(f,t,880,2320,+h[q>>3],(a[b+319|0]|0)!=0|0);H=c[c[e>>2]>>2]|0;I=s}}while(0);u=j/+xH(f,o*(I*3.141592653589793+1.0),904,2320,+h[H>>3],(a[b+319|0]|0)!=0|0);v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}function ag(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=j*j;j=+h[g+1008>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,2336,2328,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}function bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=c[b+416>>2]|0;l=+h[k+19048>>3];m=+h[k+19072>>3];n=j*j;j=+h[g+88>>3];do{if(n!=0.0){o=g;p=j/n}else{if(j==0.0){o=g;p=j;break}q=j/+xH(c[b+536>>2]|0,n,2384,2376,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+992>>3]=l*m*p*-1256637061435917.0e-21;i=d;return}function cg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];k=j*j;j=+h[g+992>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,2416,2408,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}function dg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;YK(a,5)|0;d=a+476|0;e=c[(c[d>>2]|0)+348>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1136>>3]=+h[e>>3];h[a+72>>3]=+h[e+8>>3];h[a+1184>>3]=+h[e+16>>3];h[a+1096>>3]=+h[e+24>>3];h[a+936>>3]=+h[e+32>>3];h[a+944>>3]=+h[e+40>>3];h[a+1104>>3]=+h[e+48>>3];h[a+952>>3]=+h[e+56>>3];h[a+1168>>3]=+h[e+64>>3];h[a+1192>>3]=+h[e+72>>3];h[a+1200>>3]=+h[e+80>>3];h[a+1176>>3]=+h[e+88>>3];h[a+912>>3]=+h[e+96>>3];h[a+920>>3]=+h[e+104>>3];h[a+1088>>3]=+h[e+112>>3];h[a+928>>3]=+h[e+120>>3];h[a+1080>>3]=+h[e+128>>3];h[a+888>>3]=+h[e+136>>3];h[a+896>>3]=+h[e+144>>3];h[a+1072>>3]=+h[e+152>>3];h[a+904>>3]=+h[e+160>>3];h[a+1016>>3]=+h[e+168>>3];h[a+1064>>3]=+h[e+176>>3];h[a+1208>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+348>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+880>>3]=+h[e+192>>3];h[d+1056>>3]=+h[e+200>>3];h[d+872>>3]=+h[e+208>>3];h[d+864>>3]=+h[e+216>>3];h[d+1048>>3]=+h[e+224>>3];h[d+1024>>3]=+h[e+232>>3];h[d+1032>>3]=+h[e+240>>3];h[d+1152>>3]=+h[e+248>>3];h[d+1144>>3]=+h[e+256>>3];h[d+1128>>3]=+h[e+264>>3];i=b;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[b+1144>>3]+ +h[b+1112>>3];i=i;return}function fg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1040>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,1872,2456,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}function gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+16>>3]+ +h[(c[a+416>>2]|0)+18936>>3]*-.5;i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+440>>3]+ +h[(c[a+416>>2]|0)+18936>>3]*-.5;i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+19040>>3];i=i;return}function jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+1|0]|0;q=b+4|0;r=GK(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=r;e=q;f=p;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{p=b+4|0;q=GK(+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=q;e=p;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+1|0]|0;q=b+4|0;p=IK(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3])|0;a[(c[b+352>>2]|0)+1|0]=p;e=q;f=o;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{o=b+4|0;q=IK(+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3])|0;a[(c[b+352>>2]|0)+1|0]=q;e=o;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}}function kg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+352|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+19008>>3]*+h[m+8>>3];j=f;k=j+352|0;l=k;h[l>>3]=g;i=d;return}}function lg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){g=0.0;j=f;k=j+360|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+336>>3]- +h[e+19016>>3]));g=-(+h[e+19e3>>3]*m*m);j=f;k=j+360|0;l=k;h[l>>3]=g;i=d;return}function mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[c[b+16>>2]|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+352>>3],+h[f+360>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+360>>3];break}k=(KK(+h[l+352>>3],-+h[l+360>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+352>>3];break}else{g=l;j=-+h[l+360>>3];break}}}while(0);h[g+344>>3]=j;i=d;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+344>>3]*+h[b+8>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+360>>3]+ +h[b+344>>3];i=i;return}function pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+464>>3]- +h[b+376>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[(c[a+416>>2]|0)+19032>>3]- +h[b+16>>3];i=i;return}function rg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3])|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function sg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+408|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18968>>3]*+h[m+392>>3];j=f;k=j+408|0;l=k;h[l>>3]=g;i=d;return}}function tg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){g=0.0;j=f;k=j+416|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+384>>3]- +h[e+18976>>3]));g=-(+h[e+18960>>3]*m*m);j=f;k=j+416|0;l=k;h[l>>3]=g;i=d;return}function ug(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+1|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+408>>3],+h[f+416>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+416>>3];break}k=(KK(+h[l+408>>3],-+h[l+416>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+408>>3];break}else{g=l;j=-+h[l+416>>3];break}}}while(0);h[g+400>>3]=j;i=d;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[b+400>>3]*+h[b+392>>3];i=i;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+416>>3]+ +h[b+400>>3];i=i;return}function xg(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,6)|0;d=c[(c[a+476>>2]|0)+412>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+448>>3]=+h[d>>3];h[e+184>>3]=+h[d+8>>3];h[e+840>>3]=+h[d+16>>3];i=b;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+184>>3];i=i;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+16>>3]+ +h[(c[a+416>>2]|0)+19176>>3]*.5;i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+176>>3]+ +h[(c[a+416>>2]|0)+19176>>3]*.5;i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+2736>>3]*+h[b+64>>3];i=i;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+2008>>3]*+h[b+64>>3];i=i;return}function Dg(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0;b=i;d=c[a+416>>2]|0;e=+h[d+18096>>3];f=+h[d+18120>>3];d=a+4|0;g=+QI(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+40>>3],-2);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1336>>3]=e*f*g*+(c[(c[a+420>>2]|0)+24>>2]|0)*-1256637061435917.0e-21;i=b;return}function Eg(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+40>>3];j=b+416|0;k=c[j>>2]|0;l=+h[k+18136>>3];m=+h[k+18144>>3];n=g*g;do{if(g!=0.0){o=m/g}else{if(m==0.0){o=m;break}o=m/+xH(c[b+536>>2]|0,g,2472,2464,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);f=c[(c[b+420>>2]|0)+28>>2]|0;g=+(f|0);if(n*(o*3.141592653589793+1.0)!=0.0){k=c[c[e>>2]>>2]|0;o=+h[(c[k+8>>2]|0)+40>>3];p=+h[(c[j>>2]|0)+18144>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+xH(c[b+536>>2]|0,o,2472,2464,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=g/(n*(q*3.141592653589793+1.0));s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}if((f|0)==0){r=g;s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}f=c[b+536>>2]|0;k=c[c[e>>2]>>2]|0;q=+h[(c[k+8>>2]|0)+40>>3];o=+h[(c[j>>2]|0)+18144>>3];do{if(q!=0.0){E=k;F=o/q}else{if(o==0.0){E=k;F=o;break}p=o/+xH(f,q,2472,2464,+h[k>>3],(a[b+319|0]|0)!=0|0);E=c[c[e>>2]>>2]|0;F=p}}while(0);r=g/+xH(f,n*(F*3.141592653589793+1.0),2496,2464,+h[E>>3],(a[b+319|0]|0)!=0|0);s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}function Fg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+416|0;l=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+17032>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+416|0;k=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+17032>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+416|0;j=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+17032>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+416|0;k=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+17032>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+17024>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+2176|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+17040>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+2176|0;A=z;h[A>>3]=o;i=d;return}function Gg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+2176>>3]- +h[b+2008>>3];i=i;return}function Hg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+40>>3];m=b+416|0;n=+h[(c[m>>2]|0)+18144>>3];do{if(l!=0.0){o=n/l}else{if(n==0.0){o=n;break}o=n/+xH(c[b+536>>2]|0,l,2472,2616,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);l=o*3.141592653589793+1.0;if(l>0.0){p=c[m>>2]|0;q=p;r=q+18136|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+1288|0;F=E;h[F>>3]=w;i=d;return}j=c[28168]|0;G=c[b+536>>2]|0;b=f;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;H=4936;c[j+0>>2]=c[H+0>>2];c[j+4>>2]=c[H+4>>2];c[j+8>>2]=c[H+8>>2];c[j+12>>2]=c[H+12>>2];c[j+16>>2]=c[H+16>>2];c[j+20>>2]=c[H+20>>2];Pe[b&31](G,e,2624,f);p=c[m>>2]|0;q=p;r=q+18136|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+1288|0;F=E;h[F>>3]=w;i=d;return}function Ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1288>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,2776,2768,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}function Jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+24>>3]*+h[b+1296>>3];i=i;return}function Kg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];h[b+1304>>3]=d*d*+h[b+1280>>3]*.5;i=i;return}function Lg(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0.0,p=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+18096>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+40>>3];m=+h[e+18120>>3];do{if(l!=0.0){n=k;o=m/l}else{if(m==0.0){n=k;o=m;break}p=m/+xH(c[b+536>>2]|0,l,2472,2816,+h[j>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=p}}while(0);h[n+1344>>3]=f*o*1256637061435917.0e-21;i=d;return}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1344>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1352|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,2832,2824,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1352|0;p=o;h[p>>3]=m;i=d;return}function Ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+32>>3];i=i;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=-+h[b+112>>3];i=i;return}function Pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=+h[b+112>>3];i=i;return}function Qg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+18136>>3];n=+h[l+18144>>3];o=j*j;do{if(j!=0.0){p=g;q=f;r=n/j}else{if(n==0.0){p=g;q=f;r=n;break}s=n/+xH(c[b+536>>2]|0,j,2472,2864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[c[e>>2]>>2]|0;p=c[l+8>>2]|0;q=l;r=s}}while(0);j=+h[p+112>>3];if(o*(r*3.141592653589793+1.0)!=0.0){r=+h[p+40>>3];s=+h[(c[k>>2]|0)+18144>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+xH(c[b+536>>2]|0,r,2472,2864,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=j/(o*(t*3.141592653589793+1.0));v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}if(j==0.0){u=j;v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}f=c[b+536>>2]|0;t=+h[p+40>>3];r=+h[(c[k>>2]|0)+18144>>3];do{if(t!=0.0){H=q;I=r/t}else{if(r==0.0){H=q;I=r;break}s=r/+xH(f,t,2472,2864,+h[q>>3],(a[b+319|0]|0)!=0|0);H=c[c[e>>2]>>2]|0;I=s}}while(0);u=j/+xH(f,o*(I*3.141592653589793+1.0),2496,2864,+h[H>>3],(a[b+319|0]|0)!=0|0);v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+2360|0;G=F;h[G>>3]=x;i=d;return}function Rg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1288>>3];k=j*j;j=+h[g+2360>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,2880,2872,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2352|0;q=p;h[q>>3]=n;i=d;return}function Sg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=c[b+416>>2]|0;l=+h[k+18096>>3];m=+h[k+18120>>3];n=j*j;j=+h[g+112>>3];do{if(n!=0.0){o=g;p=j/n}else{if(j==0.0){o=g;p=j;break}q=j/+xH(c[b+536>>2]|0,n,2928,2920,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+2344>>3]=l*m*p*-1256637061435917.0e-21;i=d;return}function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1344>>3];k=j*j;j=+h[g+2344>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,2968,2960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+2336|0;q=p;h[q>>3]=n;i=d;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+64>>3]*+h[(c[a+416>>2]|0)+17232>>3];i=i;return}function Vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1568>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1568|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1568>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1856>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1856|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1856>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+2080>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+2080|0;h[(c[j+288>>2]|0)+16>>3]=+h[e>>3];k=+iL(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+2080>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+16>>3]=k;gL(a,3)|0;g=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1568>>3]=+h[g>>3];h[f+1856>>3]=+h[g+8>>3];h[f+2080>>3]=+h[g+16>>3];nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);tl(a);ul(a);vl(a);wl(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);Ll(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Rl(a);Sl(a);Tl(a);Ul(a);Vl(a);Wl(a);Xl(a);Yl(a);Zl(a);_l(a);i=b;return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2856>>3];k=+h[g+1272>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3016,3008,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}function Xg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18152>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1264>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3056,3048,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1256|0;p=o;h[p>>3]=m;i=d;return}function Yg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3]*1256637061435917.0e-21;k=+h[g+1832>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3128,3120,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1824|0;p=o;h[p>>3]=m;i=d;return}function Zg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1760>>3]*1256637061435917.0e-21;k=+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3200,3192,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1768|0;p=o;h[p>>3]=m;i=d;return}function _g(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1872>>3]*1256637061435917.0e-21;k=+h[g+1888>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3272,3264,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1880|0;p=o;h[p>>3]=m;i=d;return}function $g(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1704>>3]*1256637061435917.0e-21;k=+h[g+1720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3344,3336,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1712|0;p=o;h[p>>3]=m;i=d;return}function ah(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1648>>3]*1256637061435917.0e-21;k=+h[g+1664>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3416,3408,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1656|0;p=o;h[p>>3]=m;i=d;return}function bh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2816>>3];k=+h[g+1592>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3480,3472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1584|0;p=o;h[p>>3]=m;i=d;return}function ch(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17776>>3]*1256637061435917.0e-21;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1584>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3520,3512,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1576|0;p=o;h[p>>3]=m;i=d;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[(c[a+416>>2]|0)+17232>>3]*+h[b+2080>>3];i=i;return}function eh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+64>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+2072>>3]*1.0e13;l=j}else{m=+h[j+64>>3];n=+h[j+2072>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,3592,3584,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+2064>>3]=+U(+k);i=d;return}function fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2032>>3]=-+h[b+1368>>3]- +h[b+24>>3]- +h[b+1592>>3];i=i;return}function gh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2032>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1536|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1536|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,3632,3624,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1536|0;q=p;h[q>>3]=n;i=d;return}function hh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1536>>3],+h[f+17864>>3],+h[f+17872>>3],+h[f+17880>>3],+h[f+17888>>3],+h[f+17896>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1520>>3]=+h[d>>3];i=b;return}function ih(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1520>>3];k=+h[(c[b+416>>2]|0)+17904>>3];l=+h[g+2832>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,3672,3664,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1544>>3]=j*n*1256637061435917.0e-21;i=d;return}function jh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,3712,3704,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}function kh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1520>>3]*1256637061435917.0e-21;k=+h[g+1536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,3752,3744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1528|0;p=o;h[p>>3]=m;i=d;return}function lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=-(+h[b+2032>>3]*+h[b+1552>>3]);i=i;return}function mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[b+2032>>3]- +h[b+1272>>3]- +h[b+1568>>3]- +h[b+1624>>3]- +h[b+1632>>3];i=i;return}function nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[(c[a+416>>2]|0)+17240>>3]*+h[b+2032>>3];i=i;return}function oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2072>>3]+ +h[b+2024>>3];i=i;return}function ph(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18120>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1368>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3816,3808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}function qh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1376>>3];h[b+1360>>3]=d*d*+h[b+1336>>3]*.5;i=i;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+1304>>3]+ +h[b+1360>>3];i=i;return}function sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+1560>>3]+ +h[b+1616>>3];i=i;return}function th(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2040>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2048|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2048|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3856,3848,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2048|0;p=o;h[p>>3]=m;i=d;return}function uh(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,7)|0;d=c[(c[a+476>>2]|0)+476>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1968>>3]=+h[d>>3];h[e+1976>>3]=+h[d+8>>3];h[e+1928>>3]=+h[d+16>>3];h[e+1920>>3]=+h[d+24>>3];h[e+1952>>3]=+h[d+32>>3];h[e+1944>>3]=+h[d+40>>3];i=b;return}function vh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17376>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1968>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3896,3888,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=-+h[b+64>>3]- +h[b+1968>>3];i=i;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1976>>3]*+h[b+1968>>3];i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+2104>>3]- +h[b+1920>>3];i=i;return}function zh(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+17232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2096>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,3936,3928,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}function Ah(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,3976,3968,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}



function NA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+120|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=f;f=j;j=k;k=l;l=0;v=0;do{if((u|0)!=0){if((f|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(j|0){case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(a[s]|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(a[s]|0);w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(pA(o)|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(c[o>>2]|0);w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((rA(q)|0)<<16>>16);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(b[q>>1]|0);w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+tA(n);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+g[n>>2];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((qA(p)|0)>>>0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((c[p>>2]|0)>>>0);w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((sA(r)|0)&65535);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(e[r>>1]|0);w=w+1|0}}break};case 9:{v=8;x=(c[u+20>>2]|0)!=0;l=l+(sb(f|0,v|0,k|0,c[u>>2]|0)|0)|0;if(!x){break a}w=0;while(1){if((w|0)>=(k|0)){break a}+uA(f+(w<<3)|0);w=w+1|0}break};case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(d[t]|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(d[t]|0);w=w+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,v)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function OA(f,g,j,k,l){f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;i=i+1176|0;n=m+72|0;o=f;f=g;g=j;j=l;l=0;p=0;a:do{switch(k|0){case 5:{p=4;q=(j|0)<=256;if((c[o+20>>2]|0)!=0){if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(pA(n+(r<<2)|0)|0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<8)|0;s=0;while(1){if((s|0)>=256){break}h[g+(r+s<<3)>>3]=+(pA(n+(s<<2)|0)|0);s=s+1|0}r=r+256|0}j=j-(r-256)|0;EA(o,f,n,fa(j,p)|0)|0;s=0;while(1){if((s|0)>=(j|0)){break a}h[g+(r+s<<3)>>3]=+(pA(n+(s<<2)|0)|0);s=s+1|0}}else{if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(c[n+(r<<2)>>2]|0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<8)|0;t=0;while(1){if((t|0)>=256){break}h[g+(r+t<<3)>>3]=+(c[n+(t<<2)>>2]|0);t=t+1|0}r=r+256|0}j=j-(r-256)|0;EA(o,f,n,fa(j,p)|0)|0;t=0;while(1){if((t|0)>=(j|0)){break a}h[g+(r+t<<3)>>3]=+(c[n+(t<<2)>>2]|0);t=t+1|0}}break};case 4:{p=2;q=(j|0)<=512;if((c[o+20>>2]|0)!=0){if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((sA(n+(r<<1)|0)|0)&65535);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<9)|0;u=0;while(1){if((u|0)>=512){break}h[g+(r+u<<3)>>3]=+((sA(n+(u<<1)|0)|0)&65535);u=u+1|0}r=r+512|0}j=j-(r-512)|0;EA(o,f,n,fa(j,p)|0)|0;u=0;while(1){if((u|0)>=(j|0)){break a}h[g+(r+u<<3)>>3]=+((sA(n+(u<<1)|0)|0)&65535);u=u+1|0}}else{if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(e[n+(r<<1)>>1]|0);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<9)|0;v=0;while(1){if((v|0)>=512){break}h[g+(r+v<<3)>>3]=+(e[n+(v<<1)>>1]|0);v=v+1|0}r=r+512|0}j=j-(r-512)|0;EA(o,f,n,fa(j,p)|0)|0;v=0;while(1){if((v|0)>=(j|0)){break a}h[g+(r+v<<3)>>3]=+(e[n+(v<<1)>>1]|0);v=v+1|0}}break};case 6:{p=4;q=(j|0)<=256;if((c[o+20>>2]|0)!=0){if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((qA(n+(r<<2)|0)|0)>>>0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<8)|0;w=0;while(1){if((w|0)>=256){break}h[g+(r+w<<3)>>3]=+((qA(n+(w<<2)|0)|0)>>>0);w=w+1|0}r=r+256|0}j=j-(r-256)|0;EA(o,f,n,fa(j,p)|0)|0;w=0;while(1){if((w|0)>=(j|0)){break a}h[g+(r+w<<3)>>3]=+((qA(n+(w<<2)|0)|0)>>>0);w=w+1|0}}else{if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((c[n+(r<<2)>>2]|0)>>>0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<8)|0;x=0;while(1){if((x|0)>=256){break}h[g+(r+x<<3)>>3]=+((c[n+(x<<2)>>2]|0)>>>0);x=x+1|0}r=r+256|0}j=j-(r-256)|0;EA(o,f,n,fa(j,p)|0)|0;x=0;while(1){if((x|0)>=(j|0)){break a}h[g+(r+x<<3)>>3]=+((c[n+(x<<2)>>2]|0)>>>0);x=x+1|0}}break};case 3:{p=2;q=(j|0)<=512;if((c[o+20>>2]|0)!=0){if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((rA(n+(r<<1)|0)|0)<<16>>16);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<9)|0;y=0;while(1){if((y|0)>=512){break}h[g+(r+y<<3)>>3]=+((rA(n+(y<<1)|0)|0)<<16>>16);y=y+1|0}r=r+512|0}j=j-(r-512)|0;EA(o,f,n,fa(j,p)|0)|0;y=0;while(1){if((y|0)>=(j|0)){break a}h[g+(r+y<<3)>>3]=+((rA(n+(y<<1)|0)|0)<<16>>16);y=y+1|0}}else{if(q){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(b[n+(r<<1)>>1]|0);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<9)|0;z=0;while(1){if((z|0)>=512){break}h[g+(r+z<<3)>>3]=+(b[n+(z<<1)>>1]|0);z=z+1|0}r=r+512|0}j=j-(r-512)|0;EA(o,f,n,fa(j,p)|0)|0;z=0;while(1){if((z|0)>=(j|0)){break a}h[g+(r+z<<3)>>3]=+(b[n+(z<<1)>>1]|0);z=z+1|0}}break};case 1:{p=1;if((j|0)<=1024){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(a[n+r|0]|0);r=r+1|0}}j=j-1024|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<10)|0;A=0;while(1){if((A|0)>=1024){break}h[g+(r+A<<3)>>3]=+(a[n+A|0]|0);A=A+1|0}r=r+1024|0}j=j-(r-1024)|0;EA(o,f,n,fa(j,p)|0)|0;A=0;while(1){if((A|0)>=(j|0)){break a}h[g+(r+A<<3)>>3]=+(a[n+A|0]|0);A=A+1|0}break};case 2:{p=1;if((j|0)<=1024){EA(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(d[n+r|0]|0);r=r+1|0}}j=j-1024|0;r=0;while(1){if((r|0)>=(j|0)){break}EA(o,f,n,p<<10)|0;B=0;while(1){if((B|0)>=1024){break}h[g+(r+B<<3)>>3]=+(d[n+B|0]|0);B=B+1|0}r=r+1024|0}j=j-(r-1024)|0;EA(o,f,n,fa(j,p)|0)|0;B=0;while(1){if((B|0)>=(j|0)){break a}h[g+(r+B<<3)>>3]=+(d[n+B|0]|0);B=B+1|0}break};case 9:{p=8;q=(c[o+20>>2]|0)!=0;EA(o,f,g,fa(j,p)|0)|0;if(!q){break a}r=0;while(1){if((r|0)>=(j|0)){break a}+uA(g+(r<<3)|0);r=r+1|0}break};default:{C=0;D=C;i=m;return D|0}}}while(0);l=fa(j,p)|0;C=l;D=C;i=m;return D|0}function PA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((sA(s)|0)&65535);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(e[s>>1]|0);x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((qA(q)|0)>>>0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((c[q>>2]|0)>>>0);x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+uA(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+h[n>>3];x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((rA(r)|0)<<16>>16);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(b[r>>1]|0);x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+tA(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+g[o>>2];x=x+1|0}}break};case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(a[t]|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(a[t]|0);x=x+1|0}}break};case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(d[u]|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(d[u]|0);x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(pA(p)|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(c[p>>2]|0);x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function QA(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,v,x)|0;g[j+(y<<2)>>2]=+(a[v]|0);y=y+1|0}break};case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,u,x)|0;g[j+(y<<2)>>2]=+(d[u]|0);y=y+1|0}break};case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;g[j+(y<<2)>>2]=+((rA(s)|0)<<16>>16);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;g[j+(y<<2)>>2]=+(b[s>>1]|0);y=y+1|0}}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,p,x)|0;g[j+(y<<2)>>2]=+tA(p);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,j+(y<<2)|0,x)|0;y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;g[j+(y<<2)>>2]=+((sA(t)|0)&65535);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;g[j+(y<<2)>>2]=+(e[t>>1]|0);y=y+1|0}}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;g[j+(y<<2)>>2]=+(pA(q)|0);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;g[j+(y<<2)>>2]=+(c[q>>2]|0);y=y+1|0}}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;g[j+(y<<2)>>2]=+((qA(r)|0)>>>0);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;g[j+(y<<2)>>2]=+((c[r>>2]|0)>>>0);y=y+1|0}}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;g[j+(y<<2)>>2]=+uA(o);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;g[j+(y<<2)>>2]=+h[o>>3];y=y+1|0}}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function RA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0;m=i;i=i+144|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=m+128|0;w=m+136|0;x=f;f=j;j=k;k=l;l=0;y=0;do{if((x|0)!=0){if((f|0)==0){break}if((c[x>>2]|0)==0){break}a:do{switch(j|0){case 3:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(t|0,y|0,1,c[x>>2]|0)|0)|0;A=(rA(t)|0)<<16>>16;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(t|0,y|0,1,c[x>>2]|0)|0)|0;A=b[t>>1]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 5:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(r|0,y|0,1,c[x>>2]|0)|0)|0;A=pA(r)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(r|0,y|0,1,c[x>>2]|0)|0)|0;A=c[r>>2]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 13:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(q|0,y|0,1,c[x>>2]|0)|0)|0;A=oA(q)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(q|0,y|0,1,c[x>>2]|0)|0)|0;B=q;A=c[B+4>>2]|0;C=f+(z<<3)|0;c[C>>2]=c[B>>2];c[C+4>>2]=A;z=z+1|0}}break};case 4:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=(sA(u)|0)&65535;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=e[u>>1]|0;c[A+4>>2]=0;z=z+1|0}}break};case 2:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}break};case 6:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=qA(s)|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=c[s>>2];c[A+4>>2]=0;z=z+1|0}}break};case 7:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+tA(o);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;C=f+(z<<3)|0;c[C>>2]=~~D>>>0;c[C+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+g[o>>2];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;C=f+(z<<3)|0;c[C>>2]=~~D>>>0;c[C+4>>2]=A;z=z+1|0}}break};case 12:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(p|0,y|0,1,c[x>>2]|0)|0)|0;A=nA(p)|0;C=f+(z<<3)|0;c[C>>2]=A;c[C+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(p|0,y|0,1,c[x>>2]|0)|0)|0;C=p;A=c[C+4>>2]|0;B=f+(z<<3)|0;c[B>>2]=c[C>>2];c[B+4>>2]=A;z=z+1|0}}break};case 1:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 9:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+uA(n);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+h[n>>3];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};default:{E=0;F=E;i=m;return F|0}}}while(0);l=fa(l,y)|0;E=l;F=E;i=m;return F|0}}while(0);E=0;F=E;i=m;return F|0}function SA(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;n=i;i=i+152|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=n+136|0;x=n+144|0;y=f;f=j;j=k;k=l;l=m;m=0;z=0;do{if((y|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 2:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}EA(y,f,w,z)|0;B=j+(A<<3)|0;c[B>>2]=d[w]|0;c[B+4>>2]=0;A=A+1|0}break};case 3:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,u,z)|0;B=(rA(u)|0)<<16>>16;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,u,z)|0;B=b[u>>1]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 12:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,q,z)|0;B=nA(q)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,q,z)|0;C=q;B=c[C+4>>2]|0;D=j+(A<<3)|0;c[D>>2]=c[C>>2];c[D+4>>2]=B;A=A+1|0}}break};case 13:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,r,z)|0;B=oA(r)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,r,z)|0;D=r;B=c[D+4>>2]|0;C=j+(A<<3)|0;c[C>>2]=c[D>>2];c[C+4>>2]=B;A=A+1|0}}break};case 5:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,s,z)|0;B=pA(s)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,s,z)|0;B=c[s>>2]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 4:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=(sA(v)|0)&65535;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=e[v>>1]|0;c[B+4>>2]=0;A=A+1|0}}break};case 6:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=qA(t)|0;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=c[t>>2];c[B+4>>2]=0;A=A+1|0}}break};case 1:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}EA(y,f,x,z)|0;B=a[x]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}break};case 9:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,o,z)|0;E=+uA(o);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,o,z)|0;E=+h[o>>3];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};case 7:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,p,z)|0;E=+tA(p);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,p,z)|0;E=+g[p>>2];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};default:{F=0;G=F;i=n;return G|0}}}while(0);m=fa(l,z)|0;F=m;G=F;i=n;return G|0}}while(0);F=0;G=F;i=n;return G|0}function TA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0;m=i;i=i+144|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=m+128|0;w=m+136|0;x=f;f=j;j=k;k=l;l=0;y=0;do{if((x|0)!=0){if((f|0)==0){break}if((c[x>>2]|0)==0){break}a:do{switch(j|0){case 2:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}break};case 3:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(t|0,y|0,1,c[x>>2]|0)|0)|0;A=(rA(t)|0)<<16>>16;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(t|0,y|0,1,c[x>>2]|0)|0)|0;A=b[t>>1]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 13:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(q|0,y|0,1,c[x>>2]|0)|0)|0;A=oA(q)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(q|0,y|0,1,c[x>>2]|0)|0)|0;B=q;A=c[B+4>>2]|0;C=f+(z<<3)|0;c[C>>2]=c[B>>2];c[C+4>>2]=A;z=z+1|0}}break};case 6:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=qA(s)|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=c[s>>2];c[A+4>>2]=0;z=z+1|0}}break};case 12:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(p|0,y|0,1,c[x>>2]|0)|0)|0;A=nA(p)|0;C=f+(z<<3)|0;c[C>>2]=A;c[C+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(p|0,y|0,1,c[x>>2]|0)|0)|0;C=p;A=c[C+4>>2]|0;B=f+(z<<3)|0;c[B>>2]=c[C>>2];c[B+4>>2]=A;z=z+1|0}}break};case 1:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 4:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=(sA(u)|0)&65535;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=e[u>>1]|0;c[A+4>>2]=0;z=z+1|0}}break};case 9:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+uA(n);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+h[n>>3];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};case 5:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(r|0,y|0,1,c[x>>2]|0)|0)|0;A=pA(r)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(r|0,y|0,1,c[x>>2]|0)|0)|0;A=c[r>>2]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 7:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(sb(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+tA(o);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(sb(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+g[o>>2];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};default:{E=0;F=E;i=m;return F|0}}}while(0);l=fa(l,y)|0;E=l;F=E;i=m;return F|0}}while(0);E=0;F=E;i=m;return F|0}function UA(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;n=i;i=i+152|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=n+136|0;x=n+144|0;y=f;f=j;j=k;k=l;l=m;m=0;z=0;do{if((y|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 13:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,r,z)|0;B=oA(r)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,r,z)|0;C=r;B=c[C+4>>2]|0;D=j+(A<<3)|0;c[D>>2]=c[C>>2];c[D+4>>2]=B;A=A+1|0}}break};case 4:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=(sA(v)|0)&65535;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=e[v>>1]|0;c[B+4>>2]=0;A=A+1|0}}break};case 5:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,s,z)|0;B=pA(s)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,s,z)|0;B=c[s>>2]|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 2:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}EA(y,f,w,z)|0;B=j+(A<<3)|0;c[B>>2]=d[w]|0;c[B+4>>2]=0;A=A+1|0}break};case 1:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}EA(y,f,x,z)|0;B=a[x]|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}break};case 12:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,q,z)|0;B=nA(q)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,q,z)|0;D=q;B=c[D+4>>2]|0;C=j+(A<<3)|0;c[C>>2]=c[D>>2];c[C+4>>2]=B;A=A+1|0}}break};case 9:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,o,z)|0;E=+uA(o);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,o,z)|0;E=+h[o>>3];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};case 6:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=qA(t)|0;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=c[t>>2];c[B+4>>2]=0;A=A+1|0}}break};case 3:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,u,z)|0;B=(rA(u)|0)<<16>>16;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,u,z)|0;B=b[u>>1]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 7:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}EA(y,f,p,z)|0;E=+tA(p);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}EA(y,f,p,z)|0;E=+g[p>>2];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};default:{F=0;G=F;i=n;return G|0}}}while(0);m=fa(l,z)|0;F=m;G=F;i=n;return G|0}}while(0);F=0;G=F;i=n;return G|0}function VA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=pA(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[p>>2];x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(sA(s)|0)&65535;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=e[s>>1]|0;x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=qA(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[q>>2];x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(rA(r)|0)<<16>>16;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=b[r>>1]|0;x=x+1|0}}break};case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+uA(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+h[n>>3];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+tA(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+g[o>>2];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function WA(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,v,x)|0;c[j+(y<<2)>>2]=a[v]|0;y=y+1|0}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;c[j+(y<<2)>>2]=pA(q)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;c[j+(y<<2)>>2]=c[q>>2];y=y+1|0}}break};case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;c[j+(y<<2)>>2]=(rA(s)|0)<<16>>16;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;c[j+(y<<2)>>2]=b[s>>1]|0;y=y+1|0}}break};case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,u,x)|0;c[j+(y<<2)>>2]=d[u]|0;y=y+1|0}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;c[j+(y<<2)>>2]=qA(r)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;c[j+(y<<2)>>2]=c[r>>2];y=y+1|0}}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+uA(o);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+h[o>>3];y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;c[j+(y<<2)>>2]=(sA(t)|0)&65535;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;c[j+(y<<2)>>2]=e[t>>1]|0;y=y+1|0}}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+tA(p);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+g[p>>2];y=y+1|0}}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function XA(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(rA(r)|0)<<16>>16;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=b[r>>1]|0;x=x+1|0}}break};case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(sA(s)|0)&65535;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=e[s>>1]|0;x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=pA(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[p>>2];x=x+1|0}}break};case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=qA(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[q>>2];x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+uA(n)>>>0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+h[n>>3]>>>0;x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+tA(o)>>>0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(sb(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+g[o>>2]>>>0;x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function YA(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;c[j+(y<<2)>>2]=(rA(s)|0)<<16>>16;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,s,x)|0;c[j+(y<<2)>>2]=b[s>>1]|0;y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;c[j+(y<<2)>>2]=(sA(t)|0)&65535;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,t,x)|0;c[j+(y<<2)>>2]=e[t>>1]|0;y=y+1|0}}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;c[j+(y<<2)>>2]=pA(q)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,q,x)|0;c[j+(y<<2)>>2]=c[q>>2];y=y+1|0}}break};case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,u,x)|0;c[j+(y<<2)>>2]=d[u]|0;y=y+1|0}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;c[j+(y<<2)>>2]=qA(r)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,r,x)|0;c[j+(y<<2)>>2]=c[r>>2];y=y+1|0}}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+uA(o)>>>0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+h[o>>3]>>>0;y=y+1|0}}break};case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}EA(w,f,v,x)|0;c[j+(y<<2)>>2]=a[v]|0;y=y+1|0}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}EA(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+tA(p)>>>0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}EA(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+g[p>>2]>>>0;y=y+1|0}}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function ZA(e,f,j,k){e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+128|0;m=l+64|0;n=l+72|0;o=l+80|0;p=l+88|0;q=l+96|0;r=l+104|0;s=l+112|0;t=l+120|0;u=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(f|0){case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=sA(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[r>>1]|0;w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=rA(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[q>>1]|0;w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=pA(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[o>>2];w=w+1|0}}break};case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+uA(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+h[m>>3];w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+tA(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+g[n>>2];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=qA(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[p>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(k,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function _A(e,f,j,k,l){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+136|0;n=m+72|0;o=m+80|0;p=m+88|0;q=m+96|0;r=m+104|0;s=m+112|0;t=m+120|0;u=m+128|0;v=e;e=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((e|0)==0){break}a:do{switch(j|0){case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,r,w)|0;b[f+(x<<1)>>1]=rA(r)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,r,w)|0;b[f+(x<<1)>>1]=b[r>>1]|0;x=x+1|0}}break};case 1:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}EA(v,e,u,w)|0;b[f+(x<<1)>>1]=a[u]|0;x=x+1|0}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,q,w)|0;b[f+(x<<1)>>1]=qA(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,q,w)|0;b[f+(x<<1)>>1]=c[q>>2];x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,p,w)|0;b[f+(x<<1)>>1]=pA(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,p,w)|0;b[f+(x<<1)>>1]=c[p>>2];x=x+1|0}}break};case 2:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}EA(v,e,t,w)|0;b[f+(x<<1)>>1]=d[t]|0;x=x+1|0}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,s,w)|0;b[f+(x<<1)>>1]=sA(s)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,s,w)|0;b[f+(x<<1)>>1]=b[s>>1]|0;x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+uA(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+h[n>>3];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+tA(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+g[o>>2];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(k,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function $A(e,f,j,k){e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+128|0;m=l+64|0;n=l+72|0;o=l+80|0;p=l+88|0;q=l+96|0;r=l+104|0;s=l+112|0;t=l+120|0;u=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(f|0){case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=sA(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[r>>1]|0;w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=pA(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[o>>2];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=qA(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[p>>2];w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=rA(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[q>>1]|0;w=w+1|0}}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+uA(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+h[m>>3];w=w+1|0}}break};case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+tA(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(sb(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+g[n>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(k,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function aB(e,f,j,k,l){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+136|0;n=m+72|0;o=m+80|0;p=m+88|0;q=m+96|0;r=m+104|0;s=m+112|0;t=m+120|0;u=m+128|0;v=e;e=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((e|0)==0){break}a:do{switch(j|0){case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,r,w)|0;b[f+(x<<1)>>1]=rA(r)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,r,w)|0;b[f+(x<<1)>>1]=b[r>>1]|0;x=x+1|0}}break};case 2:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}EA(v,e,t,w)|0;b[f+(x<<1)>>1]=d[t]|0;x=x+1|0}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,p,w)|0;b[f+(x<<1)>>1]=pA(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,p,w)|0;b[f+(x<<1)>>1]=c[p>>2];x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,s,w)|0;b[f+(x<<1)>>1]=sA(s)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,s,w)|0;b[f+(x<<1)>>1]=b[s>>1]|0;x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,q,w)|0;b[f+(x<<1)>>1]=qA(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,q,w)|0;b[f+(x<<1)>>1]=c[q>>2];x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+uA(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+h[n>>3];x=x+1|0}}break};case 1:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}EA(v,e,u,w)|0;b[f+(x<<1)>>1]=a[u]|0;x=x+1|0}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}EA(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+tA(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}EA(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+g[o>>2];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(k,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function bB(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+128|0;l=k+64|0;m=k+72|0;n=k+80|0;o=k+88|0;p=k+96|0;q=k+104|0;r=k+112|0;s=k+120|0;t=d;d=e;e=f;f=j;j=0;u=0;do{if((t|0)!=0){if((d|0)==0){break}if((c[t>>2]|0)==0){break}a:do{switch(e|0){case 3:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=rA(p)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[p>>1];v=v+1|0}}break};case 2:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}break};case 5:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=pA(n)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[n>>2];v=v+1|0}}break};case 4:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=sA(q)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[q>>1];v=v+1|0}}break};case 6:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=qA(o)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[o>>2];v=v+1|0}}break};case 9:{u=8;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+uA(l);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+h[l>>3];v=v+1|0}}break};case 1:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}break};case 7:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+tA(m);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+g[m>>2];v=v+1|0}}break};default:{w=0;x=w;i=k;return x|0}}}while(0);j=fa(j,u)|0;w=j;x=w;i=k;return x|0}}while(0);w=0;x=w;i=k;return x|0}function cB(d,e,f,j,k){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+136|0;m=l+72|0;n=l+80|0;o=l+88|0;p=l+96|0;q=l+104|0;r=l+112|0;s=l+120|0;t=l+128|0;u=d;d=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((d|0)==0){break}a:do{switch(f|0){case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,r,v)|0;a[e+w|0]=sA(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,r,v)|0;a[e+w|0]=b[r>>1];w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,o,v)|0;a[e+w|0]=pA(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,o,v)|0;a[e+w|0]=c[o>>2];w=w+1|0}}break};case 2:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}EA(u,d,s,v)|0;a[e+w|0]=a[s]|0;w=w+1|0}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,p,v)|0;a[e+w|0]=qA(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,p,v)|0;a[e+w|0]=c[p>>2];w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,q,v)|0;a[e+w|0]=rA(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,q,v)|0;a[e+w|0]=b[q>>1];w=w+1|0}}break};case 1:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}EA(u,d,t,v)|0;a[e+w|0]=a[t]|0;w=w+1|0}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,m,v)|0;a[e+w|0]=~~+uA(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,m,v)|0;a[e+w|0]=~~+h[m>>3];w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,n,v)|0;a[e+w|0]=~~+tA(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,n,v)|0;a[e+w|0]=~~+g[n>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(j,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function dB(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+128|0;l=k+64|0;m=k+72|0;n=k+80|0;o=k+88|0;p=k+96|0;q=k+104|0;r=k+112|0;s=k+120|0;t=d;d=e;e=f;f=j;j=0;u=0;do{if((t|0)!=0){if((d|0)==0){break}if((c[t>>2]|0)==0){break}a:do{switch(e|0){case 3:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=rA(p)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[p>>1];v=v+1|0}}break};case 4:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=sA(q)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[q>>1];v=v+1|0}}break};case 2:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}break};case 5:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=pA(n)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[n>>2];v=v+1|0}}break};case 1:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}break};case 6:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=qA(o)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[o>>2];v=v+1|0}}break};case 9:{u=8;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+uA(l);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+h[l>>3];v=v+1|0}}break};case 7:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(sb(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+tA(m);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(sb(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+g[m>>2];v=v+1|0}}break};default:{w=0;x=w;i=k;return x|0}}}while(0);j=fa(j,u)|0;w=j;x=w;i=k;return x|0}}while(0);w=0;x=w;i=k;return x|0}function eB(d,e,f,j,k){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+136|0;m=l+72|0;n=l+80|0;o=l+88|0;p=l+96|0;q=l+104|0;r=l+112|0;s=l+120|0;t=l+128|0;u=d;d=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((d|0)==0){break}a:do{switch(f|0){case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,q,v)|0;a[e+w|0]=rA(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,q,v)|0;a[e+w|0]=b[q>>1];w=w+1|0}}break};case 2:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}EA(u,d,s,v)|0;a[e+w|0]=a[s]|0;w=w+1|0}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,o,v)|0;a[e+w|0]=pA(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,o,v)|0;a[e+w|0]=c[o>>2];w=w+1|0}}break};case 1:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}EA(u,d,t,v)|0;a[e+w|0]=a[t]|0;w=w+1|0}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,p,v)|0;a[e+w|0]=qA(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,p,v)|0;a[e+w|0]=c[p>>2];w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,r,v)|0;a[e+w|0]=sA(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,r,v)|0;a[e+w|0]=b[r>>1];w=w+1|0}}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,m,v)|0;a[e+w|0]=~~+uA(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,m,v)|0;a[e+w|0]=~~+h[m>>3];w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}EA(u,d,n,v)|0;a[e+w|0]=~~+tA(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}EA(u,d,n,v)|0;a[e+w|0]=~~+g[n>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(j,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function fB(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+88|0;k=a;a=b;b=e;e=g;g=h;h=0;l=MA(b)|0;$c(c[k>>2]|0,fa(f,l)|0,1)|0;e=fa(l,e-1|0)|0;a:do{switch(d|0){case 10:{if((e|0)==0){h=h+(ZA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(ZA(k,a+(m<<1)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 11:{if((e|0)==0){h=h+($A(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+($A(k,a+(m<<1)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 9:{if((e|0)==0){h=h+(dB(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(dB(k,a+m|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 12:{if((e|0)==0){h=h+(VA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(VA(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 7:{if((e|0)==0){h=h+(PA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(PA(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 13:{if((e|0)==0){h=h+(XA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(XA(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 14:{if((e|0)==0){h=h+(RA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(RA(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 15:{if((e|0)==0){h=h+(TA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(TA(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 8:{if((e|0)==0){h=h+(bB(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(bB(k,a+m|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 6:{if((e|0)==0){h=h+(NA(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(NA(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};default:{n=0;o=n;i=j;return o|0}}}while(0);n=h;o=n;i=j;return o|0}function gB(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+232|0;l=k+96|0;m=a;a=b;b=d;d=e;e=f;f=g;g=h;h=j;j=0;n=l+0|0;o=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));do{if((m|0)!=0){if((b|0)==0){break}if((c[m>>2]|0)==0){break}g=g+ -1|0;RB(l,a)|0;xA(m,l,e,f)|0;a:do{switch(d|0){case 14:{n=b;if((g|0)==0){j=j+(SA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(SA(m,l,n+(p<<3)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 12:{n=b;if((g|0)==0){j=j+(WA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(WA(m,l,n+(p<<2)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 10:{n=b;if((g|0)==0){j=j+(_A(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(_A(m,l,n+(p<<1)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 13:{n=b;if((g|0)==0){j=j+(YA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(YA(m,l,n+(p<<2)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 11:{n=b;if((g|0)==0){j=j+(aB(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(aB(m,l,n+(p<<1)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 6:{n=b;if((g|0)==0){j=j+(OA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(OA(m,l,n+(p<<3)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 9:{n=b;if((g|0)==0){j=j+(eB(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(eB(m,l,n+p|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 7:{n=b;if((g|0)==0){j=j+(QA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(QA(m,l,n+(p<<2)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 15:{n=b;if((g|0)==0){j=j+(UA(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(UA(m,l,n+(p<<3)|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};case 8:{n=b;if((g|0)==0){j=j+(cB(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(cB(m,l,n+p|0,e,1)|0)|0;xA(m,l,e,g)|0;p=p+1|0}break};default:{}}}while(0);QB(l)|0;q=j;r=q;i=k;return r|0}}while(0);q=0;r=q;i=k;return r|0}function hB(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0;j=i;i=i+160|0;k=j+104|0;l=j+112|0;m=d;d=e;e=f;c[l>>2]=c[g>>2];g=0;f=0;n=0;o=0;c[k>>2]=0;p=-1;q=e;e=q+1|0;r=a[q]|0;a:while(1){if((g|0)==7){break}if((r<<24>>24|0)==0){g=7}switch(g|0){case 6:{b:do{switch(r<<24>>24|0){case 71:{o=o|32;s=48;break};case 101:{s=46;break};case 110:{if((n|0)==1){q=l;t=c[q>>2]|0;u=c[t>>2]|0;c[q>>2]=t+4;b[u>>1]=c[k>>2];break b}if((n|0)==2){u=l;t=c[u>>2]|0;q=c[t>>2]|0;c[u>>2]=t+4;c[q>>2]=c[k>>2];break b}q=l;t=c[q>>2]|0;u=c[t>>2]|0;c[q>>2]=t+4;if((n|0)==4){c[u>>2]=c[k>>2];break b}else{c[u>>2]=c[k>>2];break b}break};case 112:{u=l;t=c[u>>2]|0;q=c[t>>2]|0;c[u>>2]=t+4;v=q;BB(m,k,d,v,16,f,p,o);break};case 115:{q=l;t=c[q>>2]|0;u=c[t>>2]|0;c[q>>2]=t+4;v=u;v=(v|0)!=0?u:40832;if((p|0)==-1){p=Faa(v|0)|0}do{if((f|0)>0){if((p|0)<0){break}if((f|0)<=(p|0)){break}p=f}}while(0);DB(m,k,d,v,o,f,p);break};case 120:{s=43;break};case 99:{u=l;t=c[u>>2]|0;q=c[t>>2]|0;c[u>>2]=t+4;AB(m,k,d,q&255);break};case 88:{o=o|32;s=43;break};case 105:case 100:{q=l;t=c[q>>2]|0;u=c[t>>2]|0;c[q>>2]=t+4;w=u;BB(m,k,d,w,10,f,p,o);break};case 37:{AB(m,k,d,r);break};case 119:{u=e;e=u+1|0;r=a[u]|0;break};case 103:{s=48;break};case 117:{o=o|64;u=l;t=c[u>>2]|0;q=c[t>>2]|0;c[u>>2]=t+4;w=q;BB(m,k,d,w,10,f,p,o);break};case 111:{o=o|64;q=l;t=c[q>>2]|0;u=c[t>>2]|0;c[q>>2]=t+4;w=u;BB(m,k,d,w,8,f,p,o);break};case 69:{o=o|32;s=46;break};case 102:{u=l;t=c[u>>2]|0;x=+h[t>>3];c[u>>2]=t+8;y=x;CB(m,k,d,y,f,p,o);break};default:{}}}while(0);if((s|0)==43){s=0;o=o|64;t=l;u=c[t>>2]|0;q=c[u>>2]|0;c[t>>2]=u+4;w=q;BB(m,k,d,w,16,f,p,o)}else if((s|0)==46){s=0;q=l;u=c[q>>2]|0;x=+h[u>>3];c[q>>2]=u+8;y=x;CB(m,k,d,y,f,p,o)}else if((s|0)==48){s=0;u=l;q=c[u>>2]|0;x=+h[q>>3];c[u>>2]=q+8;y=x;CB(m,k,d,y,f,p,o)}q=e;e=q+1|0;r=a[q]|0;g=0;f=0;n=0;o=0;p=-1;continue a;break};case 4:{if((ae(r&255|0)|0)!=0){if((p|0)<0){p=0}p=(p*10|0)+((r<<24>>24)-48)|0;q=e;e=q+1|0;r=a[q]|0;continue a}else{if((r<<24>>24|0)==42){q=l;u=c[q>>2]|0;t=c[u>>2]|0;c[q>>2]=u+4;p=t;t=e;e=t+1|0;r=a[t]|0;g=5;continue a}else{g=5;continue a}}break};case 3:{if((r<<24>>24|0)==46){g=4;t=e;e=t+1|0;r=a[t]|0;continue a}else{g=5;continue a}break};case 0:{if((r<<24>>24|0)==37){g=1}else{AB(m,k,d,r)}t=e;e=t+1|0;r=a[t]|0;continue a;break};case 5:{t=r<<24>>24;do{if((t|0)==104){n=1;u=e;e=u+1|0;r=a[u]|0}else if((t|0)==108){n=2;u=e;e=u+1|0;r=a[u]|0;if((r<<24>>24|0)!=108){break}n=4;u=e;e=u+1|0;r=a[u]|0}else if((t|0)==76){n=3;u=e;e=u+1|0;r=a[u]|0}}while(0);g=6;continue a;break};case 1:{switch(r<<24>>24|0){case 35:{o=o|8;t=e;e=t+1|0;r=a[t]|0;continue a;break};case 32:{o=o|4;t=e;e=t+1|0;r=a[t]|0;continue a;break};case 45:{o=o|1;t=e;e=t+1|0;r=a[t]|0;continue a;break};case 43:{o=o|2;t=e;e=t+1|0;r=a[t]|0;continue a;break};case 48:{o=o|16;t=e;e=t+1|0;r=a[t]|0;continue a;break};default:{g=2;continue a}}break};case 2:{if((ae(r&255|0)|0)!=0){f=(f*10|0)+((r<<24>>24)-48)|0;t=e;e=t+1|0;r=a[t]|0;continue a}if((r<<24>>24|0)==42){t=l;u=c[t>>2]|0;q=c[u>>2]|0;c[t>>2]=u+4;f=q;q=e;e=q+1|0;r=a[q]|0;g=3;continue a}else{g=3;continue a}break};default:{continue a}}}if((d|0)==0){z=c[k>>2]|0;i=j;return z|0}if((c[k>>2]|0)>>>0<(d-1|0)>>>0){a[m+(c[k>>2]|0)|0]=0;z=c[k>>2]|0;i=j;return z|0}if(!(d>>>0>0)){z=c[k>>2]|0;i=j;return z|0}a[m+(d-1)|0]=0;z=c[k>>2]|0;i=j;return z|0}function iB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+48|0;g=f+32|0;c[g>>2]=e;e=JA(a,b,d,g)|0;i=f;return e|0}function jB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=0;if((c|0)!=256){f=e;i=d;return f|0}e=kB(a,b)|0;f=e;i=d;return f|0}function kB(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=d;d=e;e=0;b[l>>1]=0;p=0;e=mc(o|0,40224)|0;if((e|0)==0){q=0;r=q;i=f;return r|0}p=baa(44)|0;if((p|0)==0){cd(e|0)|0;q=0;r=q;i=f;return r|0}c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=0;c[p+28>>2]=0;c[p+32>>2]=0;c[n>>2]=xc(0)|0;c[p>>2]=e;c[k>>2]=o;c[p+12>>2]=KA(40096,k)|0;c[p+24>>2]=1;c[p+20>>2]=0;c[p+4>>2]=daa(1,128)|0;c[p+8>>2]=daa(1,16)|0;k=(c[p+4>>2]|0)+0|0;o=k+128|0;do{a[k]=32;k=k+1|0}while((k|0)<(o|0));k=c[p+4>>2]|0;if((d|0)==0){o=Pb(n|0)|0;c[j>>2]=40304;c[j+4>>2]=1;c[j+8>>2]=5;c[j+12>>2]=2;c[j+16>>2]=o;s=iB(k,116,40232,j)|0;a[(c[p+4>>2]|0)+115|0]=0}else{c[h>>2]=d;s=iB(k,116,40096,h)|0}a[(c[p+4>>2]|0)+s|0]=32;iB(c[p+8>>2]|0,15,40312,g)|0;c[p+16>>2]=256;b[l>>1]=19785;b[m>>1]=256;s=wc(c[p+4>>2]|0,1,116,c[p>>2]|0)|0;s=wc(c[p+8>>2]|0,1,8,c[p>>2]|0)|0;s=wc(m|0,2,1,c[p>>2]|0)|0;s=wc(l|0,2,1,c[p>>2]|0)|0;q=p;r=q;i=f;return r|0}function lB(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=d;d=e;e=0;o=0;p=0;do{if((d&1|0)==0){e=mc(n|0,39992)|0;if((e|0)!=0){break}q=0;r=q;i=f;return r|0}else{s=n;if((d&1|0)!=1){o=jB(s,0,d&-2)|0;q=o;r=q;i=f;return r|0}e=mc(s|0,4e4)|0;if((e|0)!=0){break}o=jB(n,0,d&-2)|0;q=o;r=q;i=f;return r|0}}while(0);o=baa(44)|0;if(0==(o|0)){wA(40008,k);cd(e|0)|0;q=0;r=q;i=f;return r|0}c[o>>2]=e;c[o+4>>2]=daa(128,1)|0;c[o+8>>2]=daa(8,1)|0;c[o+12>>2]=0;c[o+20>>2]=0;c[o+16>>2]=0;p=p+(sb(c[o+4>>2]|0,1,116,e|0)|0)|0;a[(c[o+4>>2]|0)+116|0]=0;p=p+(sb(c[o+8>>2]|0,1,8,e|0)|0)|0;p=p+((sb(m|0,2,1,e|0)|0)<<1)|0;p=p+(sb(l|0,1,2,e|0)|0)|0;a:do{if(128==(p|0)){c[o+20>>2]=-1;do{if((b[l>>1]|0)==19785){c[o+20>>2]=0}else{if((b[l>>1]|0)!=18765){break}c[o+20>>2]=1;rA(m)|0}}while(0);c[o+16>>2]=b[m>>1]|0;if((c[o+16>>2]|0)==256){t=17}else{if((c[o+16>>2]|0)==512){t=17}}do{if((t|0)==17){if(!(-1!=(c[o+20>>2]|0))){break}c[o+28>>2]=yb(c[o>>2]|0)|0;c[o+32>>2]=0;break a}}while(0);c[o+16>>2]=0}}while(0);do{if(0==(c[o+16>>2]|0)){if(0!=(c[o+4>>2]|0)){caa(c[o+4>>2]|0)}if(0!=(c[o+8>>2]|0)){caa(c[o+8>>2]|0)}c[o+4>>2]=0;c[o+8>>2]=0;c[o>>2]=e;c[o+16>>2]=16;c[o+20>>2]=0;c[o+24>>2]=d;c[o+28>>2]=0;c[o+32>>2]=0;mB(o)|0;t=nB(o)|0;if(0==(t|0)){c[j>>2]=n;wA(40056,j);oB(o)|0;o=0;break}else{pB(t);mB(o)|0;break}}}while(0);if(0==(o|0)){q=o;r=q;i=f;return r|0}c[h>>2]=n;c[o+12>>2]=KA(40096,h)|0;c[o+24>>2]=d;if((c[o+16>>2]|0)==512){cd(c[o>>2]|0)|0;c[o>>2]=0;oB(o)|0;o=0;c[g>>2]=n;wA(40104,g)}q=o;r=q;i=f;return r|0}function mB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;a=c[d+16>>2]|0;if((a|0)==16){$c(c[d>>2]|0,0,0)|0}else if((a|0)==256){$c(c[d>>2]|0,128,0)|0}else if((a|0)==512){c[d+32>>2]=0}else{e=-1;f=e;i=b;return f|0}e=0;f=e;i=b;return f|0}function nB(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+88|0;e=b+16|0;f=b+80|0;g=a;a=0;do{if((g|0)!=0){if((c[g>>2]|0)==0){break}h=qB()|0;a=h;if(0==(h|0)){j=0;k=j;i=b;return k|0}c[(c[a+52>>2]|0)+20>>2]=g;h=yb(c[g>>2]|0)|0;c[(c[a+52>>2]|0)+12>>2]=h;h=sb(e|0,4,1,c[g>>2]|0)|0;if((h|0)==0){caa(a);j=0;k=j;i=b;return k|0}c[f>>2]=16909060;do{if((c[e>>2]|0)<0|(c[e>>2]|0)>4052){if((pA(e)|0)<=4052){break}pB(a);j=0;k=j;i=b;return k|0}}while(0);l=~~+T(+(+(c[e>>2]|0)/1.0e3));c[e>>2]=(c[e>>2]|0)-(l*1e3|0);m=~~+T(+(+(c[e>>2]|0)/100.0));c[e>>2]=(c[e>>2]|0)-(m*100|0);n=~~+T(+(+(c[e>>2]|0)/10.0));c[e>>2]=(c[e>>2]|0)-(n*10|0);o=~~+T(+(+(c[e>>2]|0)));p=l;if((p|0)==0){c[g+20>>2]=(d[f]|0|0)!=4}else if((p|0)==1){c[g+20>>2]=(d[f]|0|0)!=1}else{pB(a);j=0;k=j;i=b;return k|0}if(0!=(m|0)){pB(a);j=0;k=j;i=b;return k|0}switch(n|0){case 4:{c[a+8>>2]=4;break};case 2:{c[a+8>>2]=5;break};case 5:{c[a+8>>2]=2;break};case 1:{c[a+8>>2]=7;break};case 3:{c[a+8>>2]=3;break};case 0:{c[a+8>>2]=9;break};default:{pB(a);j=0;k=j;i=b;return k|0}}n=o;if((n|0)==2){c[a+16>>2]=5}else if((n|0)==1){c[a+16>>2]=4}else if((n|0)==0){c[a+16>>2]=6}else{pB(a);j=0;k=j;i=b;return k|0}c[a+4>>2]=2;c[a+32>>2]=baa(8)|0;if(0==(c[a+32>>2]|0)){pB(a);j=0;k=j;i=b;return k|0}h=sb(e|0,4,1,c[g>>2]|0)|0;if((c[g+20>>2]|0)!=0){pA(e)|0}c[c[a+32>>2]>>2]=c[e>>2];if((h|0)==0){pB(a);j=0;k=j;i=b;return k|0}h=sb(e|0,4,1,c[g>>2]|0)|0;if((c[g+20>>2]|0)!=0){pA(e)|0}c[(c[a+32>>2]|0)+4>>2]=c[e>>2];n=a;if((h|0)==0){pB(n);j=0;k=j;i=b;return k|0}h=sb(n+20|0,4,1,c[g>>2]|0)|0;if((h|0)==0){pB(a);j=0;k=j;i=b;return k|0}h=sb(e|0,4,1,c[g>>2]|0)|0;if((h|0)==0){pB(a);j=0;k=j;i=b;return k|0}if((c[g+20>>2]|0)!=0){pA(e)|0}if((c[e>>2]|0)<1){pB(a);j=0;k=j;i=b;return k|0}c[a+36>>2]=baa(c[e>>2]|0)|0;n=a;if(0==(c[a+36>>2]|0)){pB(n);j=0;k=j;i=b;return k|0}h=sb(c[n+36>>2]|0,1,c[e>>2]|0,c[g>>2]|0)|0;if((h|0)==0){pB(a);j=0;k=j;i=b;return k|0}n=yb(c[g>>2]|0)|0;c[(c[a+52>>2]|0)+16>>2]=n;n=fa(c[c[a+32>>2]>>2]|0,c[(c[a+32>>2]|0)+4>>2]|0)|0;o=fa(n,MA(c[a+8>>2]|0)|0)|0;if((c[a+20>>2]|0)!=0){o=o<<1}$c(c[g>>2]|0,o|0,1)|0;j=a;k=j;i=b;return k|0}}while(0);j=0;k=j;i=b;return k|0}function oB(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;if(0==(d|0)){i=b;return 0}if((c[d>>2]|0)!=0){cd(c[d>>2]|0)|0}if((c[d+4>>2]|0)!=0){caa(c[d+4>>2]|0)}if((c[d+8>>2]|0)!=0){caa(c[d+8>>2]|0)}if((c[d+12>>2]|0)!=0){caa(c[d+12>>2]|0)}caa(d);i=b;return 0}function pB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+80|0;d=a;a=0;if((d|0)==0){i=b;return}if((c[d+32>>2]|0)!=0){a=1;e=0;while(1){if(!(e>>>0<(c[d+4>>2]|0)>>>0)){break}a=fa(a,c[(c[d+32>>2]|0)+(e<<2)>>2]|0)|0;e=e+1|0}caa(c[d+32>>2]|0)}if((c[d+36>>2]|0)!=0){caa(c[d+36>>2]|0)}a:do{if((c[d+40>>2]|0)!=0){b:do{switch(c[d+16>>2]|0){case 5:{if((c[d+44>>2]|0)!=0){break a}f=c[d+40>>2]|0;if((c[f+4>>2]|0)!=0){caa(c[f+4>>2]|0)}if((c[f+12>>2]|0)!=0){caa(c[f+12>>2]|0)}do{if((c[d+20>>2]|0)!=0){if(0==(c[f+24>>2]|0)){g=31;break}h=c[f+24>>2]|0;caa(c[h>>2]|0);caa(c[h+4>>2]|0);caa(h)}else{g=31}}while(0);do{if((g|0)==31){if((c[f+24>>2]|0)==0){break}caa(c[f+24>>2]|0)}}while(0);caa(f);break a;break};case 1:{break};case 4:case 9:case 8:case 11:case 10:case 13:case 12:case 15:case 14:case 7:case 6:{if((c[d+44>>2]|0)!=0){break a}if(0==(c[d+40>>2]|0)){break a}h=c[d+40>>2]|0;if((c[d+20>>2]|0)!=0){j=h;caa(c[j>>2]|0);caa(c[j+4>>2]|0);caa(j);break a}else{caa(h);break a}break};case 2:{if((c[d+44>>2]|0)!=0){break b}if(0==(c[d+40>>2]|0)){break b}h=c[d+40>>2]|0;j=c[(c[d+52>>2]|0)+24>>2]|0;e=0;while(1){if(!(e>>>0<(fa(a,j)|0)>>>0)){break}pB(c[h+(e<<2)>>2]|0);e=e+1|0}caa(c[d+40>>2]|0);break a;break};default:{break a}}}while(0);if((c[d+44>>2]|0)!=0){break}if(0==(c[d+40>>2]|0)){break}h=c[d+40>>2]|0;e=0;while(1){if(!(e>>>0<a>>>0)){break}pB(c[h+(e<<2)>>2]|0);e=e+1|0}caa(c[d+40>>2]|0)}}while(0);if(0!=(c[d+52>>2]|0)){if((c[d+48>>2]|0)==1){QB(c[(c[d+52>>2]|0)+32>>2]|0)|0;caa(c[(c[d+52>>2]|0)+32>>2]|0)}do{if(0!=(c[(c[d+52>>2]|0)+28>>2]|0)){if(!((c[(c[d+52>>2]|0)+24>>2]|0)>>>0>0)){break}e=0;while(1){if(!(e>>>0<(c[(c[d+52>>2]|0)+24>>2]|0)>>>0)){break}if(0!=(c[(c[(c[d+52>>2]|0)+28>>2]|0)+(e<<2)>>2]|0)){caa(c[(c[(c[d+52>>2]|0)+28>>2]|0)+(e<<2)>>2]|0)}e=e+1|0}caa(c[(c[d+52>>2]|0)+28>>2]|0)}}while(0);caa(c[d+52>>2]|0);c[d+52>>2]=0}caa(d);i=b;return}



function x9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=baa(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=baa(y)|0;if((z|0)==0){A=12;break}Jaa(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=f9(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((M8(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((M8(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((M8(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((M8(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(M8(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(M8(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(M8(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(M8(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){Jaa(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=f9(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((M8(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((M8(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((M8(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((M8(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(M8(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(M8(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(M8(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(M8(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((Q8(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=a9(X)|0;qb=_a+24|0;if((Q8(fb,c[qb>>2]|0)|0)!=0){break}fb=_8(X)|0;if((Q8(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((Q8(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=_8(X)|0;if((Q8(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=a9(X)|0;if((Q8(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}caa(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=z9(0,0)|0;if((S|0)==0){A=12;break}R=B9(S,0,0,0,32)|0;Q=R;if((R|0)==0){A9(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=baa(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=baa(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=baa(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){Jaa(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){Jaa(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=f9(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((M8(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((M8(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((M8(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((M8(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(M8(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(M8(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(M8(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(M8(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=B9(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=B9(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;y9(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((Caa(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=f9(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=f9(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((M8(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((M8(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((M8(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((M8(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(M8(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(M8(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(M8(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(M8(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((Q8(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=a9(tc)|0;aa=Ca+24|0;if((Q8(qa,c[aa>>2]|0)|0)!=0){break}qa=_8(tc)|0;if((Q8(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((Q8(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=_8(tc)|0;if((Q8(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=a9(tc)|0;if((Q8(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=B9(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=B9(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){A9(S);if((Eb|0)!=0){caa(O)}if((Kb|0)!=0){caa(Kb)}if((Lb|0)==0){A=12;break a}caa(N);A=12;break a}else if((sa|0)==67){A9(S);if((Eb|0)!=0){caa(O)}if((Kb|0)!=0){caa(Kb)}if((Lb|0)==0){A=12;break a}caa(N);A=12;break a}else if((sa|0)==169){A9(S);if((Eb|0)!=0){caa(O)}if((Kb|0)!=0){caa(Kb)}if((Lb|0)==0){A=12;break a}caa(N);A=12;break a}else if((sa|0)==176){A9(S);if((Eb|0)!=0){caa(O)}if((Kb|0)!=0){caa(Kb)}if((Lb|0)==0){A=12;break a}caa(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);A9(S);if((Jb|0)!=0){caa(Jb)}if((Gb|0)!=0){caa(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}caa(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}y9(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}caa(m);p=A;i=g;return p|0}function y9(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function z9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=daa(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function A9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;caa(e);i=b;return}else{f=d}while(1){caa(c[f>>2]|0);d=c[f+4>>2]|0;caa(f);if((d|0)==0){break}else{f=d}}e=a;caa(e);i=b;return}function B9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=baa(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=baa(p)|0;c[o>>2]=r;if((r|0)==0){caa(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}Jaa(m|0,0,h|0)|0;j=m;i=g;return j|0}function C9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((D9(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function D9(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function E9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function F9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function G9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function H9(a){a=a|0;i=i;return}function I9(a){a=a|0;c[a>>2]=153088;i=i;return}function J9(a){a=a|0;var b=0;b=i;zb(a|0);jaa(a);i=b;return}function K9(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function L9(a){a=a|0;i=i;return 153104}function M9(a){a=a|0;i=i;return}function N9(a){a=a|0;i=i;return}function O9(a){a=a|0;i=i;return}function P9(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function Q9(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function R9(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function S9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=W9(b,153216,153272,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Pe[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function T9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function U9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Pe[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function V9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Pe[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Pe[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function W9(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;ye[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}je[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function X9(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;ye[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;je[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;je[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;je[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;je[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Y9(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;je[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;ye[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Z9(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function _9(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;ye[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;ye[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function $9(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;ye[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function aaa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function baa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[38380]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=153560+(j<<2)|0;l=153560+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[38380]=f&~(1<<h)}else{if(n>>>0<(c[153536>>2]|0)>>>0){nd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{nd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[153528>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=153560+(r<<2)|0;o=153560+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[38380]=f&~(1<<t)}else{if(n>>>0<(c[153536>>2]|0)>>>0){nd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{nd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[153528>>2]|0;if((n|0)!=0){f=c[153540>>2]|0;e=n>>>3;n=e<<1;g=153560+(n<<2)|0;m=c[38380]|0;j=1<<e;do{if((m&j|0)==0){c[38380]=m|j;u=153560+(n+2<<2)|0;v=g}else{e=153560+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[153536>>2]|0)>>>0)){u=e;v=h;break}nd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[153528>>2]=o;c[153540>>2]=s;p=k;i=b;return p|0}n=c[153524>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[153824+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[153536>>2]|0;if(h>>>0<k>>>0){nd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){nd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){nd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){nd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){nd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{nd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=153824+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<h);break a}else{if(s>>>0<(c[153536>>2]|0)>>>0){nd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[153536>>2]|0)>>>0){nd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[153528>>2]|0;if((h|0)!=0){s=c[153540>>2]|0;k=h>>>3;h=k<<1;f=153560+(h<<2)|0;m=c[38380]|0;g=1<<k;do{if((m&g|0)==0){c[38380]=m|g;A=153560+(h+2<<2)|0;B=f}else{k=153560+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[153536>>2]|0)>>>0)){A=k;B=e;break}nd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[153528>>2]=t;c[153540>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[153524>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[153824+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[153824+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[153528>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[153536>>2]|0;if(t>>>0<f>>>0){nd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){nd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){nd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){nd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){nd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{nd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=153824+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<e);break c}else{if(t>>>0<(c[153536>>2]|0)>>>0){nd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[153536>>2]|0)>>>0){nd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=153560+(t<<2)|0;s=c[38380]|0;r=1<<e;do{if((s&r|0)==0){c[38380]=s|r;S=153560+(t+2<<2)|0;T=f}else{e=153560+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[153536>>2]|0)>>>0)){S=e;T=k;break}nd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=153824+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[153524>>2]|0;l=1<<U;if((f&l|0)==0){c[153524>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[153536>>2]|0;if(W>>>0<k>>>0){nd()}if(r>>>0<k>>>0){nd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[153528>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[153540>>2]|0;if(W>>>0>15){c[153540>>2]=X+q;c[153528>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[153528>>2]=0;c[153540>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[153532>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[153532>>2]=W;X=c[153544>>2]|0;c[153544>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[38498]|0)==0){X=nb(30)|0;if((X+ -1&X|0)==0){c[154e3>>2]=X;c[153996>>2]=X;c[154004>>2]=-1;c[154008>>2]=-1;c[154012>>2]=0;c[153964>>2]=0;c[38498]=(xc(0)|0)&-16^1431655768;break}else{nd()}}}while(0);X=q+48|0;W=c[154e3>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[153960>>2]|0;do{if((U|0)!=0){T=c[153952>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[153964>>2]&4|0)==0){U=c[153544>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=153968|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[153532>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[153996>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[153952>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[153960>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[154e3>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[153964>>2]=c[153964>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[153952>>2]|0)+ga|0;c[153952>>2]=ia;if(ia>>>0>(c[153956>>2]|0)>>>0){c[153956>>2]=ia}ia=c[153544>>2]|0;W=153968|0;i:do{if((ia|0)==0){aa=c[153536>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[153536>>2]=fa}c[153968>>2]=fa;c[153972>>2]=ga;c[153980>>2]=0;c[153556>>2]=c[38498];c[153552>>2]=-1;aa=0;do{ha=aa<<1;$=153560+(ha<<2)|0;c[153560+(ha+3<<2)>>2]=$;c[153560+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[153544>>2]=fa+ja;c[153532>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[153548>>2]=c[154008>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[153532>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[153544>>2]=ia+na;c[153532>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[153548>>2]=c[154008>>2];break i}}while(0);if(fa>>>0<(c[153536>>2]|0)>>>0){c[153536>>2]=fa}aa=fa+ga|0;$=153968|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[153544>>2]|0)){ca=(c[153532>>2]|0)+X|0;c[153532>>2]=ca;c[153544>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[153540>>2]|0)){ca=(c[153528>>2]|0)+X|0;c[153528>>2]=ca;c[153540>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=153560+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[153536>>2]|0)>>>0){nd()}if((c[V+12>>2]|0)==(ha|0)){break}nd()}}while(0);if((L|0)==(V|0)){c[38380]=c[38380]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[153536>>2]|0)>>>0){nd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}nd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[153536>>2]|0)>>>0){nd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){nd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{nd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=153824+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<t);break k}else{if(T>>>0<(c[153536>>2]|0)>>>0){nd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[153536>>2]|0)>>>0){nd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=153560+(Z<<2)|0;t=c[38380]|0;T=1<<ca;do{if((t&T|0)==0){c[38380]=t|T;xa=153560+(Z+2<<2)|0;ya=ea}else{ca=153560+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[153536>>2]|0)>>>0)){xa=ca;ya=V;break}nd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=153824+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[153524>>2]|0;L=1<<za;if((ea&L|0)==0){c[153524>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[153536>>2]|0;if(Ba>>>0<S>>>0){nd()}if(T>>>0<S>>>0){nd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=153968|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[153544>>2]=fa+Ha;c[153532>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[153548>>2]=c[154008>>2];c[ba+4>>2]=27;X=153968|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[153968>>2]=fa;c[153972>>2]=ga;c[153980>>2]=0;c[153976>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=153560+(da<<2)|0;aa=c[38380]|0;f=1<<M;do{if((aa&f|0)==0){c[38380]=aa|f;Ia=153560+(da+2<<2)|0;Ja=ha}else{M=153560+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[153536>>2]|0)>>>0)){Ia=M;Ja=T;break}nd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=153824+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[153524>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[153524>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[153536>>2]|0;if(Ma>>>0<f>>>0){nd()}if(M>>>0<f>>>0){nd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[153532>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[153532>>2]=W;ia=c[153544>>2]|0;c[153544>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Sc()|0)>>2]=12;p=0;i=b;return p|0}function caa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[153536>>2]|0;if(d>>>0<f>>>0){nd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){nd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){nd()}if((p|0)==(c[153540>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[153528>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=153560+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){nd()}if((c[m+12>>2]|0)==(p|0)){break}nd()}}while(0);if((u|0)==(m|0)){c[38380]=c[38380]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){nd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}nd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){nd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){nd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){nd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{nd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=153824+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[153536>>2]|0)>>>0){nd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[153536>>2]|0)>>>0){nd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){nd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){nd()}do{if((C&2|0)==0){if((l|0)==(c[153544>>2]|0)){f=(c[153532>>2]|0)+t|0;c[153532>>2]=f;c[153544>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[153540>>2]|0)){i=b;return}c[153540>>2]=0;c[153528>>2]=0;i=b;return}if((l|0)==(c[153540>>2]|0)){f=(c[153528>>2]|0)+t|0;c[153528>>2]=f;c[153540>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=153560+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[153536>>2]|0)>>>0){nd()}if((c[E+12>>2]|0)==(l|0)){break}nd()}}while(0);if((w|0)==(E|0)){c[38380]=c[38380]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[153536>>2]|0)>>>0){nd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}nd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[153536>>2]|0)>>>0){nd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){nd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{nd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=153824+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<g);break b}else{if(d>>>0<(c[153536>>2]|0)>>>0){nd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[153536>>2]|0)>>>0){nd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[153540>>2]|0)){J=f;break}c[153528>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=153560+(C<<2)|0;G=c[38380]|0;j=1<<t;do{if((G&j|0)==0){c[38380]=G|j;K=153560+(C+2<<2)|0;L=e}else{t=153560+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[153536>>2]|0)>>>0)){K=t;L=a;break}nd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=153824+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[153524>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[153524>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[153536>>2]|0;if(O>>>0<K>>>0){nd()}if(f>>>0<K>>>0){nd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[153552>>2]|0)+ -1|0;c[153552>>2]=s;if((s|0)==0){Q=153976|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[153552>>2]=-1;i=b;return}function daa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=baa(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}Jaa(b|0,0,e|0)|0;i=d;return b|0}function eaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=baa(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Sc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=faa(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=baa(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;Haa(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;caa(a);e=g;i=d;return e|0}function faa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[153536>>2]|0;if(h>>>0<l>>>0){nd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){nd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){nd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[154e3>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;gaa(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[153544>>2]|0)){m=(c[153532>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[153544>>2]=a+b;c[153532>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[153540>>2]|0)){h=(c[153528>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[153528>>2]=r;c[153540>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=153560+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){nd()}if((c[h+12>>2]|0)==(k|0)){break}nd()}}while(0);if((m|0)==(h|0)){c[38380]=c[38380]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){nd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}nd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){nd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){nd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){nd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{nd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=153824+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<u);break a}else{if(t>>>0<(c[153536>>2]|0)>>>0){nd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[153536>>2]|0)>>>0){nd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;gaa(a+b|0,r);o=a;i=d;return o|0}return 0}function gaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[153536>>2]|0;if(j>>>0<m>>>0){nd()}if((k|0)==(c[153540>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[153528>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=153560+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){nd()}if((c[q+12>>2]|0)==(k|0)){break}nd()}}while(0);if((r|0)==(q|0)){c[38380]=c[38380]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){nd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}nd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){nd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){nd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){nd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{nd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=153824+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[153536>>2]|0)>>>0){nd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[153536>>2]|0)>>>0){nd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[153536>>2]|0;if(e>>>0<z>>>0){nd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[153544>>2]|0)){t=(c[153532>>2]|0)+p|0;c[153532>>2]=t;c[153544>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[153540>>2]|0)){i=d;return}c[153540>>2]=0;c[153528>>2]=0;i=d;return}if((f|0)==(c[153540>>2]|0)){t=(c[153528>>2]|0)+p|0;c[153528>>2]=t;c[153540>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=153560+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){nd()}if((c[u+12>>2]|0)==(f|0)){break}nd()}}while(0);if((h|0)==(u|0)){c[38380]=c[38380]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){nd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}nd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){nd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){nd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){nd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{nd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=153824+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[153524>>2]=c[153524>>2]&~(1<<j);break b}else{if(m>>>0<(c[153536>>2]|0)>>>0){nd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[153536>>2]|0)>>>0){nd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[153536>>2]|0)>>>0){nd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[153540>>2]|0)){G=t;break}c[153528>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=153560+(B<<2)|0;D=c[38380]|0;b=1<<p;do{if((D&b|0)==0){c[38380]=D|b;H=153560+(B+2<<2)|0;I=A}else{p=153560+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[153536>>2]|0)>>>0)){H=p;I=a;break}nd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=153824+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[153524>>2]|0;B=1<<J;if((a&B|0)==0){c[153524>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[153536>>2]|0)>>>0){nd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[153536>>2]|0;if(L>>>0<B>>>0){nd()}if(G>>>0<B>>>0){nd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function haa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=baa(d)|0;if((e|0)!=0){f=6;break}a=c[38504]|0;c[38504]=0+a;if((a|0)==0){f=5;break}Me[a&7]()}if((f|0)==5){d=Jc(4)|0;c[d>>2]=154032;_d(d|0,154080,136)}else if((f|0)==6){i=b;return e|0}return 0}function iaa(a){a=a|0;var b=0,c=0;b=i;c=haa(a)|0;i=b;return c|0}function jaa(a){a=a|0;var b=0;b=i;if((a|0)!=0){caa(a)}i=b;return}function kaa(a){a=a|0;var b=0;b=i;jaa(a);i=b;return}function laa(a){a=a|0;var b=0;b=i;zb(a|0);jaa(a);i=b;return}function maa(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function naa(a){a=a|0;i=i;return 154048}function oaa(){var a=0;a=Jc(4)|0;c[a>>2]=154032;_d(a|0,154080,136)}



function SC(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=Fe[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 6:{a[o+489|0]=0;c[o+316>>2]=LC(o,l+132|0,54480,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}t=UC(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=43;break a}VC(t);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=t;h=0;r=47;break};case 22:{c[o+348>>2]=YC(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 23:{a[o+352|0]=1;c[o+332>>2]=54488;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=54496;r=102;break};case 25:{c[o+332>>2]=54504;r=102;break};case 26:{c[o+332>>2]=54512;r=102;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}u=aD(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((u|0)!=0){r=132;break a}t=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if(($C(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,t,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((IC(o+416|0)|0)<<24>>24!=0)){r=145;break a}}v=o+428|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((IC(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;v=c[w>>2]|0;c[w>>2]=v+1;a[v]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ye[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,t,(s|0)==38|0);pC(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;v=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=UC(v+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[v+324>>2]=54480}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=LC(o,l+132|0,54480,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 13:{r=168;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if(($C(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((IC(o+416|0)|0)<<24>>24!=0)){r=128;break a}}t=o+428|0;v=c[t>>2]|0;c[t>>2]=v+1;a[v]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((IC(o+416|0)|0)<<24>>24!=0)){r=128;break a}}v=o+428|0;t=c[v>>2]|0;c[v>>2]=t+1;a[t]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ye[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);pC(o+416|0);h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 2:{r=75;break a;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}t=UC(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=t;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;ye[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 14:{r=45;break};case 7:{if((c[o+84>>2]|0)==0){break c}je[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;pC(o+416|0);h=0;break};case 57:{x=TC(o,1,e,c[n>>2]|0)|0;if((x|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 8:{if((c[o+320>>2]|0)!=0){je[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);pC(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;t=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}v=LC(o,l+132|0,54480,36)|0;if((v|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[v+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[v+20>>2]|0,c[v+16>>2]|0,c[v+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=t;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}me[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 34:{c[o+344>>2]=XC(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 27:{c[o+332>>2]=54520;r=102;break};case 28:{c[o+332>>2]=54528;r=102;break};case 29:{c[o+332>>2]=54544;r=102;break};case 30:{c[o+332>>2]=54552;r=102;break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){y=54584}else{y=(s|0)==32?54568:54592}if((ZC(o+416|0,y)|0)==0){r=111;break a}if((_C(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){t=pe[c[o+12>>2]&127](20)|0;if((t|0)==0){r=309;break a}c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t>>2]=(s|0)==41?2:1;c[q>>2]=e;Le[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,t);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{z=0;r=319;break};case 47:{z=1;r=334;break};case 46:{z=2;r=334;break};case 48:{z=3;r=334;break};case 45:{z=0;r=334;break};case 55:{if((hD(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 21:{if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}t=UC(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=220;break a}VC(t);c[o+340>>2]=t;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}t=UC(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=225;break a}c[q>>2]=e;je[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,t,c[o+340>>2]|0);h=0}}while(0);pC(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;je[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);pC(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){t=o+12|0;if((c[o+468>>2]|0)==0){v=c[t>>2]|0;c[o+468>>2]=32;c[o+464>>2]=pe[v&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}v=c[t+4>>2]|0;t=c[o+464>>2]|0;w=o+468|0;A=c[w>>2]<<1;c[w>>2]=A;w=Ee[v&63](t,A)|0;if((w|0)==0){r=245;break a}c[o+464>>2]=w;if((c[l+184>>2]|0)==0){break}w=Ee[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((w|0)==0){r=248;break a}c[l+184>>2]=w}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}w=eD(o)|0;if((w|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=w;A=l+180|0;c[A>>2]=(c[A>>2]|0)+1;c[(c[l+164>>2]|0)+(w*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 56:{if((iD(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 59:case 60:{a[l+129|0]=1;w=l;do{if((c[o+492>>2]|0)!=0){A=UC(w+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((A|0)==0){r=273;break a}t=LC(o,l+132|0,A,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((t|0)==0){r=279;break a}if((a[t+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((t|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Le[c[o+120>>2]&15](c[o+4>>2]|0,A,1);h=0;break c}}while(0);if((a[t+32|0]|0)!=0){r=287;break a}if((c[t+4>>2]|0)!=0){B=fD(o,t,((s|0)==60?1:0)&255)|0;if((B|0)!=0){r=290;break a}h=0;break c}A=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[A+130|0]|0;break c}a[A+131|0]=0;a[t+32|0]=1;A=(Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!A){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[w+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{z=1;r=319;break};case 52:{z=2;r=319;break};case 54:{z=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=XC(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}C=bD(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;De[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((C|0)!=0){r=153;break a}break};case 9:{if((se[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}A=UC(w,b,e,c[n>>2]|0)|0;if((A|0)==0){r=190;break a}c[o+316>>2]=LC(o,l,A,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(A|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){D=1}else{D=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(D^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}A=UC(w,b,e,c[n>>2]|0)|0;if((A|0)==0){r=202;break a}c[o+316>>2]=LC(o,l+132|0,A,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(A|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){E=1}else{E=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(E^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){GC(o,b,e,c[n>>2]|0)}h=0;F=cD(o,b,n,f,j,k)|0;if((F|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=UC(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 1:{G=TC(o,0,e,c[n>>2]|0)|0;if((G|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=UC(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Oe[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=UC(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((z|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=eD(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=z;w=XC(o,b,e,H)|0;if((w|0)==0){r=325;break a}A=c[w>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=A;s=0;do{w=s;s=w+1|0;}while((a[A+w|0]|0)!=0);A=l+168|0;c[A>>2]=(c[A>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}A=l+180|0;c[A>>2]=(c[A>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=z;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){A=gD(o)|0;if((A|0)==0){r=340;break a}c[q>>2]=e;Le[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,A)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}A=UC(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((A|0)==0){r=50;break a}VC(A);c[(c[o+316>>2]|0)+24>>2]=A;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}GC(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Oe[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((Fe[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=G;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=x;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){x=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}G=LC(o,l+132|0,54480,36)|0;if((G|0)==0){I=1;J=I;i=m;return J|0}c[G+20>>2]=c[o+360>>2];a[l+131|0]=0;if((Fe[c[o+112>>2]&63](c[o+116>>2]|0,0,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=x;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((pe[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=WC(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=u;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=C;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){C=g;if((C|0)==28){I=10;J=I;i=m;return J|0}else if((C|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=F;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=F;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=B;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function TC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((oe[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=UC(n+440|0,p,b,s+(Ee[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=UC(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Pe[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}GC(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=UC(n+440|0,e,d,m+(Ee[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=wD(n,f)|0;pC(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){pC(n+440|0)}q=0;r=q;i=g;return r|0}function UC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((_C(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((IC(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function VC(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function WC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=lD(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((tD(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function XC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=UC(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=LC(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((uD(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function YC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((IC(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=UC(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=LC(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=LC(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((IC(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((IC(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=LC(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function ZC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((IC(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function _C(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((IC(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){je[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((IC(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function $C(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=pe[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=Ee[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function aD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=vD(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((IC(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function bD(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((IC(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Oe[c[b+20>>2]&63](b,e,f,j)|0){case 6:case 9:{if((_C(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 7:{r=28;break};case-1:{r=46;break a;break};case 10:{s=Ee[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=CD(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((IC(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-4:{r=24;break a;break};case 0:{r=49;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=UC(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=LC(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=bD(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(Fe[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((IC(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function cD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Oe[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){GC(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function dD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=cD(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=RC(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function eD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=pe[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=Ee[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=pe[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function fD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=pe[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Oe[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=SC(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=lD(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function gD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=pe[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;kD(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function hD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){GC(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(Ee[c[a+32>>2]&63](a,b)|0)|0;k=UC(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=Ee[c[a+36>>2]&63](a,e)|0;e=UC(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){jD(e);Le[c[g+64>>2]&15](c[g+4>>2]|0,k,e);pC(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function iD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){GC(g,a,b,d)}h=1;j=h;i=f;return j|0}k=UC(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){jD(k);ne[c[g+68>>2]&127](c[g+4>>2]|0,k);pC(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function jD(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function kD(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}kD(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function lD(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Oe[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 1:case 2:{B=y;if((c[y+368>>2]|0)!=0){C=c[B+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{C=pe[c[B+12>>2]&127](48)|0;if((C|0)==0){D=72;break a}c[C+36>>2]=pe[c[y+12>>2]&127](32)|0;if((c[C+36>>2]|0)==0){D=74;break a}c[C+40>>2]=(c[C+36>>2]|0)+32}c[C+44>>2]=0;c[C>>2]=c[y+364>>2];c[y+364>>2]=C;c[C+16>>2]=0;c[C+20>>2]=0;c[C+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[C+8>>2]=Ee[c[e+32>>2]&63](e,c[C+4>>2]|0)|0;B=y+312|0;c[B>>2]=(c[B>>2]|0)+1;B=(c[C+4>>2]|0)+(c[C+8>>2]|0)|0;c[r>>2]=c[C+4>>2];c[q>>2]=c[C+36>>2];while(1){je[c[e+60>>2]&31](e,r,B,q,(c[C+40>>2]|0)+ -1|0);E=(c[q>>2]|0)-(c[C+36>>2]|0)|0;if((c[r>>2]|0)==(B|0)){break}F=(c[C+40>>2]|0)-(c[C+36>>2]|0)<<1;G=Ee[c[y+16>>2]&63](c[C+36>>2]|0,F)|0;if((G|0)==0){D=80;break a}c[C+36>>2]=G;c[C+40>>2]=G+F;c[q>>2]=G+E}c[C+24>>2]=E;c[C+12>>2]=c[C+36>>2];a[c[q>>2]|0]=0;H=oD(y,e,c[m>>2]|0,C+12|0,C+44|0)|0;if((H|0)!=0){D=82;break a}B=y;do{if((c[y+52>>2]|0)!=0){Le[c[B+52>>2]&15](c[y+4>>2]|0,c[C+12>>2]|0,c[y+392>>2]|0)}else{if((c[B+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);pC(y+416|0);break};case-2:{D=28;break a;break};case 10:{B=Ee[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((B|0)<0){D=135;break a}G=y;if((c[y+60>>2]|0)!=0){F=c[G+60>>2]|0;I=c[y+4>>2]|0;J=CD(B,u)|0;Le[F&15](I,u,J);break b}if((c[G+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break};case 0:{D=24;break a;break};case 3:case 4:{G=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;J=1;c[t>>2]=UC(y+416|0,e,G,G+(Ee[c[e+32>>2]&63](e,G)|0)|0)|0;if((c[t>>2]|0)==0){D=89;break a}c[y+432>>2]=c[y+428>>2];K=oD(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){D=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Le[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);J=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ne[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);J=0}do{if((J&255|0)!=0){if((c[y+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);pC(y+416|0);while(1){if((c[s>>2]|0)==0){break}J=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ne[c[y+104>>2]&127](c[y+4>>2]|0,c[c[J>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[J+4>>2]=c[y+376>>2];c[y+376>>2]=J;c[(c[J>>2]|0)+4>>2]=c[J+8>>2]}if((c[y+312>>2]|0)==0){D=107;break a}break};case 11:{if((hD(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=174;break a}break};case 13:{if((iD(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=176;break a}break};case-3:{D=6;break a;break};case 12:{D=140;break a;break};case-5:{D=153;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Le[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break};case 9:{a[p]=se[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){J=y;if((c[y+60>>2]|0)!=0){Le[c[J+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[J+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break b}J=UC(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((J|0)==0){D=37;break a}G=LC(y,k,J,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){D=40;break}if((G|0)!=0){break}I=y;if((c[y+120>>2]|0)!=0){Le[c[I+120>>2]&15](c[y+4>>2]|0,J,0);break b}if((c[I+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{D=40}}while(0);if((D|0)==40){D=0;if((G|0)==0){D=41;break a}if((a[G+34|0]|0)==0){D=43;break a}}if((a[G+32|0]|0)!=0){D=50;break a}if((c[G+28>>2]|0)!=0){D=52;break a}J=y;if((c[G+4>>2]|0)!=0){I=y;if((a[J+308|0]|0)!=0){L=fD(I,G,0)|0;if((L|0)!=0){D=60;break a}else{break b}}F=y;if((c[I+120>>2]|0)!=0){Le[c[F+120>>2]&15](c[y+4>>2]|0,c[G>>2]|0,0);break b}if((c[F+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[J+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[G+32|0]=1;J=nD(y)|0;a[G+32|0]=0;if((J|0)==0){D=63;break a}if((Fe[c[y+112>>2]&63](c[y+116>>2]|0,J,c[G+20>>2]|0,c[G+16>>2]|0,c[G+24>>2]|0)|0)==0){D=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case-1:{D=25;break a;break};case 6:{J=c[y+60>>2]|0;if((J|0)==0){if((c[y+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Le[J&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];je[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Le[J&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 8:{J=y;do{if((c[y+72>>2]|0)!=0){me[c[J+72>>2]&255](c[y+4>>2]|0)}else{if((c[J+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);M=qD(y,e,n,g,h,j)|0;if((M|0)!=0){D=150;break a}if((c[n>>2]|0)==0){D=152;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){D=109;break a}J=c[y+364>>2]|0;c[y+364>>2]=c[J>>2];c[J>>2]=c[y+368>>2];c[y+368>>2]=J;N=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;G=Ee[c[e+32>>2]&63](e,N)|0;if((G|0)!=(c[J+8>>2]|0)){D=112;break a}if((Aaa(c[J+4>>2]|0,N,G)|0)!=0){D=112;break a}G=y+312|0;c[G>>2]=(c[G>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){G=c[J+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((G|0)==0){break}F=(c[J+12>>2]|0)+(c[J+28>>2]|0)|0;while(1){if((a[G]|0)==0){break}I=G;G=I+1|0;B=F;F=B+1|0;a[B]=a[I]|0}I=c[J+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((I|0)==0){break}B=F;F=B+1|0;a[B]=a[y+472|0]|0;while(1){if((a[I]|0)==0){break c}B=I;I=B+1|0;O=F;F=O+1|0;a[O]=a[B]|0}}}while(0);a[F]=0}}while(0);ne[c[y+56>>2]&127](c[y+4>>2]|0,c[J+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[J+44>>2]|0)==0){break}G=c[J+44>>2]|0;if((c[y+104>>2]|0)!=0){ne[c[y+104>>2]&127](c[y+4>>2]|0,c[c[G>>2]>>2]|0)}c[J+44>>2]=c[(c[J+44>>2]|0)+4>>2];c[G+4>>2]=c[y+376>>2];c[y+376>>2]=G;c[(c[G>>2]|0)+4>>2]=c[G+8>>2]}if((c[y+312>>2]|0)==0){D=133;break a}break};case-4:{D=17;break a;break};default:{if((c[y+80>>2]|0)==0){break b}GC(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){D=180;break}else if((f|0)==2){D=181;break}}if((D|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Le[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((D|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((D|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((D|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((D|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((D|0)==37){P=1;Q=P;i=l;return Q|0}else if((D|0)==41){P=11;Q=P;i=l;return Q|0}else if((D|0)==43){P=24;Q=P;i=l;return Q|0}else if((D|0)==50){P=12;Q=P;i=l;return Q|0}else if((D|0)==52){P=15;Q=P;i=l;return Q|0}else if((D|0)==60){P=L;Q=P;i=l;return Q|0}else if((D|0)==63){P=1;Q=P;i=l;return Q|0}else if((D|0)==65){P=21;Q=P;i=l;return Q|0}else if((D|0)==72){P=1;Q=P;i=l;return Q|0}else if((D|0)==74){me[c[y+20>>2]&255](C);P=1;Q=P;i=l;return Q|0}else if((D|0)==80){P=1;Q=P;i=l;return Q|0}else if((D|0)==82){P=H;Q=P;i=l;return Q|0}else if((D|0)==89){P=1;Q=P;i=l;return Q|0}else if((D|0)==91){P=K;Q=P;i=l;return Q|0}else if((D|0)==107){P=pD(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==109){P=13;Q=P;i=l;return Q|0}else if((D|0)==112){c[z>>2]=N;P=7;Q=P;i=l;return Q|0}else if((D|0)==133){P=pD(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==135){P=14;Q=P;i=l;return Q|0}else if((D|0)==140){P=17;Q=P;i=l;return Q|0}else if((D|0)==150){P=M;Q=P;i=l;return Q|0}else if((D|0)==152){c[y+280>>2]=43;P=M;Q=P;i=l;return Q|0}else if((D|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Le[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];je[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Le[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}GC(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((D|0)==174){P=1;Q=P;i=l;return Q|0}else if((D|0)==176){P=1;Q=P;i=l;return Q|0}else if((D|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((D|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function mD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Oe[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=SC(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=lD(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=SC(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=lD(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function nD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((IC(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);JC(e,b+60|0);a:while(1){k=KC(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){JC(e,b);b:while(1){b=KC(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((IC(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function oD(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=LC(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=rC(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=LC(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((uD(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Oe[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=Ee[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Oe[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=YC(k,b,v,w+(Ee[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=UC(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=aD(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=PC(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=PC(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=Ee[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(LC(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((IC(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((IC(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((IC(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=pe[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;Haa(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}me[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;Haa(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;Haa(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function pD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-1:{k=15;break a;break};case-2:{k=18;break a;break};case-4:{k=7;break a;break};case 0:{k=14;break a;break};case 13:{if((iD(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-15:{k=3;break a;break};case 11:{if((hD(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}GC(j,c[j+144>>2]|0,b,c[h>>2]|0);break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){GC(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function qD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Oe[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-4:case-1:{r=28;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}GC(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Le[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];je[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Le[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-2:{r=25;break a;break};case 40:{r=6;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Le[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}GC(o,b,c[k>>2]|0,c[l>>2]|0);break};case 0:{r=24;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){me[c[m+76>>2]&255](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}GC(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function rD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=qD(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=sD(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=WC(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function sD(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=lD(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((tD(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function tD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=Ee[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}Haa(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function uD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((IC(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((IC(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=LC(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function vD(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Oe[c[b+16>>2]&63](b,f,g,l)|0){case 10:{o=Ee[c[b+44>>2]&63](b,f)|0;if((o|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((o|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);o=CD(o,m)|0;if((o|0)==0){p=19;break a}q=0;while(1){if((q|0)>=(o|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((IC(h)|0)<<24>>24!=0)){p=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 7:case 39:{p=31;break};case 0:{p=4;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 9:{q=(se[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((IC(h)|0)<<24>>24!=0)){p=42;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;break b}q=UC(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){p=44;break a}r=LC(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=vD(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){p=74;break a}break};case 6:{if((_C(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case-1:{p=7;break a;break};case-4:{p=3;break a;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((IC(h)|0)<<24>>24!=0)){p=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=y;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function wD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((se[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=DD()|0;c[g+240>>2]=pe[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Oe[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){me[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}me[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function xD(){var a=0,b=0;a=i;i=i+8|0;cc(((xc(0)|0)>>>0)%4294967295|0|0);b=Naa()|0;i=a;return b|0}function yD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=QC(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=RC(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function zD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=pe[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{AD(f+80|0,e);AD(b+104|0,e);BD(b,e);BD(b+20|0,e);BD(b+40|0,e);BD(b+60|0,e);a[b+131|0]=0;BD(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function AD(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function BD(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function CD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function DD(){i=i;return 1912}



function Do(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0,da=0.0,ea=0.0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0,pa=0.0,qa=0,ra=0.0,sa=0,ta=0,ua=0.0,va=0,wa=0.0,xa=0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0.0,qb=0,rb=0.0,sb=0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0,Gb=0,Hb=0.0,Ib=0,Jb=0.0,Kb=0.0,Lb=0,Mb=0.0,Nb=0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0.0,Vb=0,Wb=0.0,Xb=0,Yb=0.0,Zb=0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0.0,gc=0,hc=0.0,ic=0,jc=0,kc=0.0,lc=0,mc=0.0,nc=0,oc=0,pc=0.0,qc=0,rc=0.0,sc=0,tc=0,uc=0.0,vc=0,wc=0.0,xc=0.0,yc=0,zc=0.0,Ac=0.0,Bc=0,Cc=0.0,Dc=0,Ec=0.0,Fc=0.0,Gc=0,Hc=0.0,Ic=0,Jc=0.0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0,Sc=0,Tc=0.0,Uc=0,Vc=0.0,Wc=0,Xc=0.0,Yc=0,Zc=0.0,_c=0,$c=0,ad=0.0,bd=0,cd=0.0,dd=0,ed=0,fd=0.0,gd=0,hd=0.0,id=0,jd=0,kd=0.0,ld=0,md=0.0,nd=0,od=0.0;d=i;e=b+416|0;f=+h[(c[e>>2]|0)+18824>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=+h[(c[j+8>>2]|0)+488>>3];do{if(f!=0.0){l=k/f}else{if(k==0.0){l=k;break}l=k/+xH(c[b+536>>2]|0,f,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(l>0.0){m=1.0}else{l=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;f=+h[(c[j+8>>2]|0)+488>>3];do{if(l!=0.0){n=f/l}else{if(f==0.0){n=f;break}n=f/+xH(c[b+536>>2]|0,l,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);m=+(n<0.0|0)}n=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+488>>3];do{if(n!=0.0){o=l/n}else{if(l==0.0){o=l;break}o=l/+xH(c[b+536>>2]|0,n,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(o>0.0){p=1.0}else{o=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;n=+h[(c[j+8>>2]|0)+488>>3];do{if(o!=0.0){q=n/o}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,o,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=+(q<0.0|0)}q=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;o=+h[(c[j+8>>2]|0)+488>>3];do{if(q!=0.0){r=o/q}else{if(o==0.0){r=o;break}r=o/+xH(c[b+536>>2]|0,q,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(r>0.0){s=1.0}else{r=+h[(c[e>>2]|0)+18824>>3];j=c[c[g>>2]>>2]|0;q=+h[(c[j+8>>2]|0)+488>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,r,15992,15984,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);s=+(t<0.0|0)}j=c[e>>2]|0;t=+h[j+18840>>3];r=+h[j+18824>>3];u=c[c[g>>2]>>2]|0;v=c[u+8>>2]|0;q=+h[v+488>>3];do{if(r!=0.0){w=q;x=v;y=u;z=r;A=j;B=q/r}else{if(q==0.0){w=q;x=v;y=u;z=r;A=j;B=q;break}o=q/+xH(c[b+536>>2]|0,r,15992,15984,+h[u>>3],(a[b+319|0]|0)!=0|0);C=c[e>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;w=+h[E+488>>3];x=E;y=D;z=+h[C+18824>>3];A=C;B=o}}while(0);r=t*+U(+B);do{if(z!=0.0){F=w;G=z;H=x;I=y;J=A;K=w/z}else{if(w==0.0){F=w;G=z;H=x;I=y;J=A;K=w;break}B=w/+xH(c[b+536>>2]|0,z,15992,15984,+h[y>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;j=c[c[g>>2]>>2]|0;v=c[j+8>>2]|0;F=+h[v+488>>3];G=+h[u+18824>>3];H=v;I=j;J=u;K=B}}while(0);z=+U(+K);K=+h[J+18848>>3];w=r+ +W(+z,+K)+1.0;z=w*w;w=+h[J+18832>>3];r=+h[H+976>>3];H=G!=0.0;B=+h[J+18840>>3];if(z!=0.0){do{if(H){t=+U(+(F/G));L=J;M=(B*t+ +W(+t,+K)+1.0)/G}else{if(F==0.0){N=F;O=I;P=G;Q=J;R=F}else{t=F/+xH(c[b+536>>2]|0,G,15992,15984,+h[I>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;N=+h[(c[A+8>>2]|0)+488>>3];O=A;P=+h[y+18824>>3];Q=y;R=t}t=B*+U(+R);do{if(P!=0.0){S=N;T=O;V=P;X=Q;Y=N/P}else{if(N==0.0){S=N;T=O;V=P;X=Q;Y=N;break}q=N/+xH(c[b+536>>2]|0,P,15992,15984,+h[O>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;A=c[c[g>>2]>>2]|0;S=+h[(c[A+8>>2]|0)+488>>3];T=A;V=+h[y+18824>>3];X=y;Y=q}}while(0);q=+U(+Y);y=t+ +W(+q,+(+h[X+18848>>3]))+1.0==0.0;q=+h[X+18840>>3];A=V!=0.0;if(y){do{if(A){Z=S;_=T;$=V;aa=X;ba=S/V}else{if(S==0.0){Z=S;_=T;$=V;aa=X;ba=S;break}o=S/+xH(c[b+536>>2]|0,V,15992,15984,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;Z=+h[(c[x+8>>2]|0)+488>>3];_=x;$=+h[y+18824>>3];aa=y;ba=o}}while(0);t=q*+U(+ba);do{if($!=0.0){ca=aa;da=Z/$}else{if(Z==0.0){ca=aa;da=Z;break}o=Z/+xH(c[b+536>>2]|0,$,15992,15984,+h[_>>3],(a[b+319|0]|0)!=0|0);ca=c[e>>2]|0;da=o}}while(0);o=+U(+da);L=ca;M=t+ +W(+o,+(+h[ca+18848>>3]))+1.0;break}else{do{if(A){ea=S;fa=T;ga=V;ha=X;ia=S/V}else{if(S==0.0){ea=S;fa=T;ga=V;ha=X;ia=S;break}o=S/+xH(c[b+536>>2]|0,V,15992,15984,+h[T>>3],(a[b+319|0]|0)!=0|0);y=c[e>>2]|0;x=c[c[g>>2]>>2]|0;ea=+h[(c[x+8>>2]|0)+488>>3];fa=x;ga=+h[y+18824>>3];ha=y;ia=o}}while(0);t=q*+U(+ia);do{if(ga!=0.0){ja=fa;ka=ga;la=ha;ma=ea/ga}else{if(ea==0.0){ja=fa;ka=ga;la=ha;ma=ea;break}o=ea/+xH(c[b+536>>2]|0,ga,15992,15984,+h[fa>>3],(a[b+319|0]|0)!=0|0);A=c[e>>2]|0;ja=c[c[g>>2]>>2]|0;ka=+h[A+18824>>3];la=A;ma=o}}while(0);q=+U(+ma);o=t+ +W(+q,+(+h[la+18848>>3]))+1.0;q=o/+xH(c[b+536>>2]|0,ka,15992,15984,+h[ja>>3],(a[b+319|0]|0)!=0|0);L=c[e>>2]|0;M=q;break}}}while(0);ka=w*m*r*M;M=+h[L+18816>>3];ma=+h[L+18832>>3];ga=+h[L+18824>>3];ja=c[c[g>>2]>>2]|0;la=c[ja+8>>2]|0;ea=+h[la+488>>3];do{if(ga!=0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea/ga}else{if(ea==0.0){na=la;oa=ja;pa=ga;qa=L;ra=ea;break}ia=ea/+xH(c[b+536>>2]|0,ga,15992,15984,+h[ja>>3],(a[b+319|0]|0)!=0|0);fa=c[e>>2]|0;ha=c[c[g>>2]>>2]|0;na=c[ha+8>>2]|0;oa=ha;pa=+h[fa+18824>>3];qa=fa;ra=ia}}while(0);ga=M+ma*+U(+ra)+-1.0;ra=+h[qa+18840>>3];ma=+h[na+976>>3];do{if(pa!=0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma/pa}else{if(ma==0.0){sa=na;ta=oa;ua=pa;va=qa;wa=ma;break}M=ma/+xH(c[b+536>>2]|0,pa,15992,15984,+h[oa>>3],(a[b+319|0]|0)!=0|0);ja=c[e>>2]|0;L=c[c[g>>2]>>2]|0;sa=c[L+8>>2]|0;ta=L;ua=+h[ja+18824>>3];va=ja;wa=M}}while(0);pa=ra*p*wa;wa=+h[sa+488>>3];do{if(ua!=0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa/ua}else{if(wa==0.0){xa=sa;ya=ta;za=ua;Aa=va;Ba=wa;break}ra=wa/+xH(c[b+536>>2]|0,ua,15992,15984,+h[ta>>3],(a[b+319|0]|0)!=0|0);oa=c[e>>2]|0;qa=c[c[g>>2]>>2]|0;xa=c[qa+8>>2]|0;ya=qa;za=+h[oa+18824>>3];Aa=oa;Ba=ra}}while(0);ua=+U(+Ba);Ba=+h[Aa+18848>>3];wa=+W(+ua,+(Ba+-1.0));ua=+h[xa+976>>3];do{if(za!=0.0){Ca=ua/za}else{if(ua==0.0){Ca=ua;break}Ca=ua/+xH(c[b+536>>2]|0,za,15992,15984,+h[ya>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=(ka-ga*(pa+wa*Ba*s*Ca))/z;Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}do{if(H){Ca=+U(+(F/G));Na=J;Oa=(B*Ca+ +W(+Ca,+K)+1.0)/G}else{if(F==0.0){Pa=F;Qa=I;Ra=G;Sa=J;Ta=F}else{Ca=F/+xH(c[b+536>>2]|0,G,15992,15984,+h[I>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Pa=+h[(c[xa+8>>2]|0)+488>>3];Qa=xa;Ra=+h[ya+18824>>3];Sa=ya;Ta=Ca}Ca=B*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}Ba=Pa/+xH(c[b+536>>2]|0,Ra,15992,15984,+h[Qa>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;xa=c[c[g>>2]>>2]|0;Ua=+h[(c[xa+8>>2]|0)+488>>3];Va=xa;Wa=+h[ya+18824>>3];Xa=ya;Ya=Ba}}while(0);t=+U(+Ya);ya=Ca+ +W(+t,+(+h[Xa+18848>>3]))+1.0==0.0;t=+h[Xa+18840>>3];xa=Wa!=0.0;if(ya){do{if(xa){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,15992,15984,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;Za=+h[(c[Aa+8>>2]|0)+488>>3];_a=Aa;$a=+h[ya+18824>>3];ab=ya;bb=Ba}}while(0);Ca=t*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}Ba=Za/+xH(c[b+536>>2]|0,$a,15992,15984,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[e>>2]|0;db=Ba}}while(0);Ba=+U(+db);Na=cb;Oa=Ca+ +W(+Ba,+(+h[cb+18848>>3]))+1.0;break}else{do{if(xa){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}Ba=Ua/+xH(c[b+536>>2]|0,Wa,15992,15984,+h[Va>>3],(a[b+319|0]|0)!=0|0);ya=c[e>>2]|0;Aa=c[c[g>>2]>>2]|0;eb=+h[(c[Aa+8>>2]|0)+488>>3];fb=Aa;gb=+h[ya+18824>>3];hb=ya;ib=Ba}}while(0);Ca=t*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}Ba=eb/+xH(c[b+536>>2]|0,gb,15992,15984,+h[fb>>3],(a[b+319|0]|0)!=0|0);xa=c[e>>2]|0;jb=c[c[g>>2]>>2]|0;kb=+h[xa+18824>>3];lb=xa;mb=Ba}}while(0);t=+U(+mb);Ba=Ca+ +W(+t,+(+h[lb+18848>>3]))+1.0;t=Ba/+xH(c[b+536>>2]|0,kb,15992,15984,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[e>>2]|0;Oa=t;break}}}while(0);kb=w*m*r*Oa;Oa=+h[Na+18816>>3];r=+h[Na+18832>>3];w=+h[Na+18824>>3];jb=c[c[g>>2]>>2]|0;lb=c[jb+8>>2]|0;mb=+h[lb+488>>3];do{if(w!=0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb/w}else{if(mb==0.0){nb=lb;ob=jb;pb=w;qb=Na;rb=mb;break}gb=mb/+xH(c[b+536>>2]|0,w,15992,15984,+h[jb>>3],(a[b+319|0]|0)!=0|0);fb=c[e>>2]|0;hb=c[c[g>>2]>>2]|0;nb=c[hb+8>>2]|0;ob=hb;pb=+h[fb+18824>>3];qb=fb;rb=gb}}while(0);w=Oa+r*+U(+rb)+-1.0;rb=+h[qb+18840>>3];r=+h[nb+976>>3];do{if(pb!=0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r/pb}else{if(r==0.0){sb=nb;tb=ob;ub=pb;vb=qb;wb=r;break}Oa=r/+xH(c[b+536>>2]|0,pb,15992,15984,+h[ob>>3],(a[b+319|0]|0)!=0|0);jb=c[e>>2]|0;Na=c[c[g>>2]>>2]|0;sb=c[Na+8>>2]|0;tb=Na;ub=+h[jb+18824>>3];vb=jb;wb=Oa}}while(0);pb=rb*p*wb;wb=+h[sb+488>>3];do{if(ub!=0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb/ub}else{if(wb==0.0){xb=sb;yb=tb;zb=ub;Ab=vb;Bb=wb;break}rb=wb/+xH(c[b+536>>2]|0,ub,15992,15984,+h[tb>>3],(a[b+319|0]|0)!=0|0);ob=c[e>>2]|0;qb=c[c[g>>2]>>2]|0;xb=c[qb+8>>2]|0;yb=qb;zb=+h[ob+18824>>3];Ab=ob;Bb=rb}}while(0);ub=+U(+Bb);Bb=+h[Ab+18848>>3];wb=+W(+ub,+(Bb+-1.0));ub=+h[xb+976>>3];do{if(zb!=0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub/zb}else{if(ub==0.0){Cb=zb;Db=ub;Eb=xb;Fb=yb;Gb=Ab;Hb=ub;break}rb=ub/+xH(c[b+536>>2]|0,zb,15992,15984,+h[yb>>3],(a[b+319|0]|0)!=0|0);tb=c[e>>2]|0;vb=c[c[g>>2]>>2]|0;sb=c[vb+8>>2]|0;Cb=+h[tb+18824>>3];Db=+h[sb+976>>3];Eb=sb;Fb=vb;Gb=tb;Hb=rb}}while(0);zb=+h[Gb+18832>>3];yb=Cb!=0.0;ub=+h[Gb+18840>>3];rb=+h[Eb+488>>3];if(kb-w*(pb+wb*Bb*s*Hb)==0.0){do{if(yb){Hb=+U(+(rb/Cb));Ib=Gb;Jb=(ub*Hb+ +W(+Hb,+(+h[Gb+18848>>3]))+1.0)/Cb}else{if(rb==0.0){Kb=rb;Lb=Fb;Mb=Cb;Nb=Gb;Ob=rb}else{Hb=rb/+xH(c[b+536>>2]|0,Cb,15992,15984,+h[Fb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Kb=+h[(c[Ab+8>>2]|0)+488>>3];Lb=Ab;Mb=+h[Eb+18824>>3];Nb=Eb;Ob=Hb}Hb=ub*+U(+Ob);do{if(Mb!=0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb/Mb}else{if(Kb==0.0){Pb=Kb;Qb=Lb;Rb=Mb;Sb=Nb;Tb=Kb;break}Bb=Kb/+xH(c[b+536>>2]|0,Mb,15992,15984,+h[Lb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;Ab=c[c[g>>2]>>2]|0;Pb=+h[(c[Ab+8>>2]|0)+488>>3];Qb=Ab;Rb=+h[Eb+18824>>3];Sb=Eb;Tb=Bb}}while(0);Ca=+U(+Tb);Eb=Hb+ +W(+Ca,+(+h[Sb+18848>>3]))+1.0==0.0;Ca=+h[Sb+18840>>3];Ab=Rb!=0.0;if(Eb){do{if(Ab){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb/Rb}else{if(Pb==0.0){Ub=Pb;Vb=Qb;Wb=Rb;Xb=Sb;Yb=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,15992,15984,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;Ub=+h[(c[xb+8>>2]|0)+488>>3];Vb=xb;Wb=+h[Eb+18824>>3];Xb=Eb;Yb=Bb}}while(0);Hb=Ca*+U(+Yb);do{if(Wb!=0.0){Zb=Xb;_b=Ub/Wb}else{if(Ub==0.0){Zb=Xb;_b=Ub;break}Bb=Ub/+xH(c[b+536>>2]|0,Wb,15992,15984,+h[Vb>>3],(a[b+319|0]|0)!=0|0);Zb=c[e>>2]|0;_b=Bb}}while(0);Bb=+U(+_b);Ib=Zb;Jb=Hb+ +W(+Bb,+(+h[Zb+18848>>3]))+1.0;break}else{do{if(Ab){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb/Rb}else{if(Pb==0.0){$b=Pb;ac=Qb;bc=Rb;cc=Sb;dc=Pb;break}Bb=Pb/+xH(c[b+536>>2]|0,Rb,15992,15984,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Eb=c[e>>2]|0;xb=c[c[g>>2]>>2]|0;$b=+h[(c[xb+8>>2]|0)+488>>3];ac=xb;bc=+h[Eb+18824>>3];cc=Eb;dc=Bb}}while(0);Hb=Ca*+U(+dc);do{if(bc!=0.0){ec=ac;fc=bc;gc=cc;hc=$b/bc}else{if($b==0.0){ec=ac;fc=bc;gc=cc;hc=$b;break}Bb=$b/+xH(c[b+536>>2]|0,bc,15992,15984,+h[ac>>3],(a[b+319|0]|0)!=0|0);Ab=c[e>>2]|0;ec=c[c[g>>2]>>2]|0;fc=+h[Ab+18824>>3];gc=Ab;hc=Bb}}while(0);Ca=+U(+hc);Bb=Hb+ +W(+Ca,+(+h[gc+18848>>3]))+1.0;Ca=Bb/+xH(c[b+536>>2]|0,fc,15992,15984,+h[ec>>3],(a[b+319|0]|0)!=0|0);Ib=c[e>>2]|0;Jb=Ca;break}}}while(0);fc=zb*m*Db*Jb;Jb=+h[Ib+18816>>3];hc=+h[Ib+18832>>3];bc=+h[Ib+18824>>3];ec=c[c[g>>2]>>2]|0;gc=c[ec+8>>2]|0;$b=+h[gc+488>>3];do{if(bc!=0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b/bc}else{if($b==0.0){ic=gc;jc=ec;kc=bc;lc=Ib;mc=$b;break}dc=$b/+xH(c[b+536>>2]|0,bc,15992,15984,+h[ec>>3],(a[b+319|0]|0)!=0|0);ac=c[e>>2]|0;cc=c[c[g>>2]>>2]|0;ic=c[cc+8>>2]|0;jc=cc;kc=+h[ac+18824>>3];lc=ac;mc=dc}}while(0);bc=Jb+hc*+U(+mc)+-1.0;mc=+h[lc+18840>>3];hc=+h[ic+976>>3];do{if(kc!=0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc/kc}else{if(hc==0.0){nc=ic;oc=jc;pc=kc;qc=lc;rc=hc;break}Jb=hc/+xH(c[b+536>>2]|0,kc,15992,15984,+h[jc>>3],(a[b+319|0]|0)!=0|0);ec=c[e>>2]|0;Ib=c[c[g>>2]>>2]|0;nc=c[Ib+8>>2]|0;oc=Ib;pc=+h[ec+18824>>3];qc=ec;rc=Jb}}while(0);kc=mc*p*rc;rc=+h[nc+488>>3];do{if(pc!=0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc/pc}else{if(rc==0.0){sc=nc;tc=oc;uc=pc;vc=qc;wc=rc;break}mc=rc/+xH(c[b+536>>2]|0,pc,15992,15984,+h[oc>>3],(a[b+319|0]|0)!=0|0);jc=c[e>>2]|0;lc=c[c[g>>2]>>2]|0;sc=c[lc+8>>2]|0;tc=lc;uc=+h[jc+18824>>3];vc=jc;wc=mc}}while(0);pc=+U(+wc);wc=+h[vc+18848>>3];rc=+W(+pc,+(wc+-1.0));pc=+h[sc+976>>3];do{if(uc!=0.0){xc=pc/uc}else{if(pc==0.0){xc=pc;break}xc=pc/+xH(c[b+536>>2]|0,uc,15992,15984,+h[tc>>3],(a[b+319|0]|0)!=0|0)}}while(0);Da=fc-bc*(kc+rc*wc*s*xc);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}else{do{if(yb){xc=+U(+(rb/Cb));yc=Gb;zc=(ub*xc+ +W(+xc,+(+h[Gb+18848>>3]))+1.0)/Cb}else{if(rb==0.0){Ac=rb;Bc=Fb;Cc=Cb;Dc=Gb;Ec=rb}else{xc=rb/+xH(c[b+536>>2]|0,Cb,15992,15984,+h[Fb>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Ac=+h[(c[sc+8>>2]|0)+488>>3];Bc=sc;Cc=+h[tc+18824>>3];Dc=tc;Ec=xc}xc=ub*+U(+Ec);do{if(Cc!=0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac/Cc}else{if(Ac==0.0){Fc=Ac;Gc=Bc;Hc=Cc;Ic=Dc;Jc=Ac;break}wc=Ac/+xH(c[b+536>>2]|0,Cc,15992,15984,+h[Bc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;sc=c[c[g>>2]>>2]|0;Fc=+h[(c[sc+8>>2]|0)+488>>3];Gc=sc;Hc=+h[tc+18824>>3];Ic=tc;Jc=wc}}while(0);Hb=+U(+Jc);tc=xc+ +W(+Hb,+(+h[Ic+18848>>3]))+1.0==0.0;Hb=+h[Ic+18840>>3];sc=Hc!=0.0;if(tc){do{if(sc){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc/Hc}else{if(Fc==0.0){Kc=Fc;Lc=Gc;Mc=Hc;Nc=Ic;Oc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,15992,15984,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Kc=+h[(c[vc+8>>2]|0)+488>>3];Lc=vc;Mc=+h[tc+18824>>3];Nc=tc;Oc=wc}}while(0);xc=Hb*+U(+Oc);do{if(Mc!=0.0){Pc=Nc;Qc=Kc/Mc}else{if(Kc==0.0){Pc=Nc;Qc=Kc;break}wc=Kc/+xH(c[b+536>>2]|0,Mc,15992,15984,+h[Lc>>3],(a[b+319|0]|0)!=0|0);Pc=c[e>>2]|0;Qc=wc}}while(0);wc=+U(+Qc);yc=Pc;zc=xc+ +W(+wc,+(+h[Pc+18848>>3]))+1.0;break}else{do{if(sc){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc/Hc}else{if(Fc==0.0){Rc=Fc;Sc=Gc;Tc=Hc;Uc=Ic;Vc=Fc;break}wc=Fc/+xH(c[b+536>>2]|0,Hc,15992,15984,+h[Gc>>3],(a[b+319|0]|0)!=0|0);tc=c[e>>2]|0;vc=c[c[g>>2]>>2]|0;Rc=+h[(c[vc+8>>2]|0)+488>>3];Sc=vc;Tc=+h[tc+18824>>3];Uc=tc;Vc=wc}}while(0);xc=Hb*+U(+Vc);do{if(Tc!=0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc/Tc}else{if(Rc==0.0){Wc=Sc;Xc=Tc;Yc=Uc;Zc=Rc;break}wc=Rc/+xH(c[b+536>>2]|0,Tc,15992,15984,+h[Sc>>3],(a[b+319|0]|0)!=0|0);sc=c[e>>2]|0;Wc=c[c[g>>2]>>2]|0;Xc=+h[sc+18824>>3];Yc=sc;Zc=wc}}while(0);Hb=+U(+Zc);wc=xc+ +W(+Hb,+(+h[Yc+18848>>3]))+1.0;Hb=wc/+xH(c[b+536>>2]|0,Xc,15992,15984,+h[Wc>>3],(a[b+319|0]|0)!=0|0);yc=c[e>>2]|0;zc=Hb;break}}}while(0);Xc=zb*m*Db*zc;zc=+h[yc+18816>>3];Db=+h[yc+18832>>3];m=+h[yc+18824>>3];Wc=c[c[g>>2]>>2]|0;Yc=c[Wc+8>>2]|0;zb=+h[Yc+488>>3];do{if(m!=0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb/m}else{if(zb==0.0){_c=Yc;$c=Wc;ad=m;bd=yc;cd=zb;break}Zc=zb/+xH(c[b+536>>2]|0,m,15992,15984,+h[Wc>>3],(a[b+319|0]|0)!=0|0);Sc=c[e>>2]|0;Uc=c[c[g>>2]>>2]|0;_c=c[Uc+8>>2]|0;$c=Uc;ad=+h[Sc+18824>>3];bd=Sc;cd=Zc}}while(0);m=zc+Db*+U(+cd)+-1.0;cd=+h[bd+18840>>3];Db=+h[_c+976>>3];do{if(ad!=0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db/ad}else{if(Db==0.0){dd=_c;ed=$c;fd=ad;gd=bd;hd=Db;break}zc=Db/+xH(c[b+536>>2]|0,ad,15992,15984,+h[$c>>3],(a[b+319|0]|0)!=0|0);Wc=c[e>>2]|0;yc=c[c[g>>2]>>2]|0;dd=c[yc+8>>2]|0;ed=yc;fd=+h[Wc+18824>>3];gd=Wc;hd=zc}}while(0);ad=cd*p*hd;hd=+h[dd+488>>3];do{if(fd!=0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd/fd}else{if(hd==0.0){id=dd;jd=ed;kd=fd;ld=gd;md=hd;break}p=hd/+xH(c[b+536>>2]|0,fd,15992,15984,+h[ed>>3],(a[b+319|0]|0)!=0|0);$c=c[e>>2]|0;bd=c[c[g>>2]>>2]|0;id=c[bd+8>>2]|0;jd=bd;kd=+h[$c+18824>>3];ld=$c;md=p}}while(0);fd=+U(+md);md=+h[ld+18848>>3];hd=+W(+fd,+(md+-1.0));fd=+h[id+976>>3];do{if(kd!=0.0){nd=jd;od=fd/kd}else{if(fd==0.0){nd=jd;od=fd;break}p=fd/+xH(c[b+536>>2]|0,kd,15992,15984,+h[jd>>3],(a[b+319|0]|0)!=0|0);nd=c[c[g>>2]>>2]|0;od=p}}while(0);Da=(Xc-m*(ad+hd*md*s*od))/+xH(c[b+536>>2]|0,z,16040,15984,+h[nd>>3],(a[b+319|0]|0)!=0|0);Ea=c[g>>2]|0;Fa=c[Ea>>2]|0;Ga=Fa;Ha=Ga+8|0;Ia=Ha;Ja=c[Ia>>2]|0;Ka=Ja;La=Ka+1120|0;Ma=La;h[Ma>>3]=Da;i=d;return}}function Eo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1120>>3];k=+h[(c[b+416>>2]|0)+18856>>3];l=+h[g+2992>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,16312,16304,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+968>>3]=j*n*1256637061435917.0e-21;i=d;return}function Fo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];k=j*j;j=+h[g+968>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,16352,16344,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+960|0;q=p;h[q>>3]=n;i=d;return}function Go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+472>>3]*1256637061435917.0e-21;k=+h[g+488>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,16400,16392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+480|0;p=o;h[p>>3]=m;i=d;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=-(+h[b+1160>>3]*+h[b+504>>3])- +h[b+784>>3]*+h[b+960>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[(c[a+416>>2]|0)+18488>>3]*+h[b+784>>3];i=i;return}function Jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+800>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+776>>3]*1.0e13;l=j}else{m=+h[j+800>>3];n=+h[j+776>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,16464,16456,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+768>>3]=+U(+k);i=d;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+784>>3]- +h[b+216>>3]- +h[b+520>>3]- +h[b+528>>3];i=i;return}function Lo(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+19072>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+312>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,16496,16488,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}function Mo(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+256>>3];h[b+248>>3]=d*d*+h[b+224>>3]*.5;i=i;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+248>>3]+ +h[b+304>>3];i=i;return}function Oo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+16>>3]+ +h[(c[a+416>>2]|0)+18936>>3]*-.5;i=i;return}function Po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+440>>3]+ +h[(c[a+416>>2]|0)+18936>>3]*-.5;i=i;return}function Qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+264>>3]- +h[(c[a+416>>2]|0)+19040>>3];i=i;return}function Ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}o=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(o){p=a[(c[b+356>>2]|0)+1|0]|0;q=b+4|0;r=GK(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=r;e=q;f=p;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{p=b+4|0;q=GK(+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=q;e=p;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}else{if(o){o=a[(c[b+356>>2]|0)+1|0]|0;q=b+4|0;p=IK(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3])|0;a[(c[b+352>>2]|0)+1|0]=p;e=q;f=o;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}else{o=b+4|0;q=IK(+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+336>>3],+h[(c[b+416>>2]|0)+19016>>3])|0;a[(c[b+352>>2]|0)+1|0]=q;e=o;f=q;g=c[e>>2]|0;j=c[g>>2]|0;k=j;l=k+16|0;m=l;n=c[m>>2]|0;a[n]=f;i=d;return}}}function So(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[c[e+16>>2]|0]|0)==0){g=0.0;j=f;k=j+360|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+336>>3]- +h[e+19016>>3]));g=-(+h[e+19e3>>3]*m*m);j=f;k=j+360|0;l=k;h[l>>3]=g;i=d;return}function To(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[(c[a+416>>2]|0)+19032>>3]- +h[b+16>>3];i=i;return}function Uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],+h[(c[b+416>>2]|0)+18976>>3])|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+1|0]=f;i=d;return}function Vo(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){g=0.0;j=f;k=j+416|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+384>>3]- +h[e+18976>>3]));g=-(+h[e+18960>>3]*m*m);j=f;k=j+416|0;l=k;h[l>>3]=g;i=d;return}function Wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+16>>3]+ +h[(c[a+416>>2]|0)+19176>>3]*.5;i=i;return}function Xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+176>>3]+ +h[(c[a+416>>2]|0)+19176>>3]*.5;i=i;return}function Yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[c[e+16>>2]|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+352|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+19008>>3]*+h[m+8>>3];j=f;k=j+352|0;l=k;h[l>>3]=g;i=d;return}}function _o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[c[b+16>>2]|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+352>>3],+h[f+360>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+360>>3];break}k=(KK(+h[l+352>>3],-+h[l+360>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+352>>3];break}else{g=l;j=-+h[l+360>>3];break}}}while(0);h[g+344>>3]=j;i=d;return}function $o(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+344>>3]*+h[b+8>>3];i=i;return}function ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+360>>3]+ +h[b+344>>3];i=i;return}function bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+464>>3]- +h[b+376>>3];i=i;return}function cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+8>>3];i=i;return}function dp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=c[b+416>>2]|0;l=+h[k+19048>>3];m=+h[k+19072>>3];n=j*j;j=+h[g+88>>3];do{if(n!=0.0){o=g;p=j/n}else{if(j==0.0){o=g;p=j;break}q=j/+xH(c[b+536>>2]|0,n,16536,16528,+h[f>>3],(a[b+319|0]|0)!=0|0);o=c[(c[c[e>>2]>>2]|0)+8>>2]|0;p=q}}while(0);h[o+992>>3]=l*m*p*-1256637061435917.0e-21;i=d;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+288>>3];k=j*j;j=+h[g+992>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,16568,16560,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+984|0;q=p;h[q>>3]=n;i=d;return}function fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+19088>>3];n=+h[l+19096>>3];o=j*j;do{if(j!=0.0){p=g;q=f;r=n/j}else{if(n==0.0){p=g;q=f;r=n;break}s=n/+xH(c[b+536>>2]|0,j,15224,16608,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[c[e>>2]>>2]|0;p=c[l+8>>2]|0;q=l;r=s}}while(0);j=+h[p+88>>3];if(o*(r*3.141592653589793+1.0)!=0.0){r=+h[p+16>>3];s=+h[(c[k>>2]|0)+19096>>3];do{if(r!=0.0){t=s/r}else{if(s==0.0){t=s;break}t=s/+xH(c[b+536>>2]|0,r,15224,16608,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=j/(o*(t*3.141592653589793+1.0));v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}if(j==0.0){u=j;v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}f=c[b+536>>2]|0;t=+h[p+16>>3];r=+h[(c[k>>2]|0)+19096>>3];do{if(t!=0.0){H=q;I=r/t}else{if(r==0.0){H=q;I=r;break}s=r/+xH(f,t,15224,16608,+h[q>>3],(a[b+319|0]|0)!=0|0);H=c[c[e>>2]>>2]|0;I=s}}while(0);u=j/+xH(f,o*(I*3.141592653589793+1.0),15248,16608,+h[H>>3],(a[b+319|0]|0)!=0|0);v=n*u;w=m*v;x=w*-1256637061435917.0e-21;y=c[e>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+1008|0;G=F;h[G>>3]=x;i=d;return}function gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+232>>3];k=j*j;j=+h[g+1008>>3];l=-j;if(k!=0.0){m=g;n=l/k;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}if(j==-0.0){m=g;n=l;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}j=l/+xH(c[b+536>>2]|0,k,16624,16616,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1e3|0;q=p;h[q>>3]=n;i=d;return}function hp(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;YK(a,0)|0;d=a+476|0;e=c[(c[d>>2]|0)+28>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1048>>3]=+h[e>>3];h[a+864>>3]=+h[e+8>>3];h[a+872>>3]=+h[e+16>>3];h[a+1056>>3]=+h[e+24>>3];h[a+880>>3]=+h[e+32>>3];h[a+1064>>3]=+h[e+40>>3];h[a+888>>3]=+h[e+48>>3];h[a+896>>3]=+h[e+56>>3];h[a+1072>>3]=+h[e+64>>3];h[a+904>>3]=+h[e+72>>3];h[a+1080>>3]=+h[e+80>>3];h[a+912>>3]=+h[e+88>>3];h[a+920>>3]=+h[e+96>>3];h[a+1088>>3]=+h[e+104>>3];h[a+928>>3]=+h[e+112>>3];h[a+1032>>3]=+h[e+120>>3];h[a+1024>>3]=+h[e+128>>3];h[a+1016>>3]=+h[e+136>>3];h[a+1176>>3]=+h[e+144>>3];h[a+1168>>3]=+h[e+152>>3];h[a+1200>>3]=+h[e+160>>3];h[a+1192>>3]=+h[e+168>>3];h[a+1128>>3]=+h[e+176>>3];h[a+1184>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+28>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+72>>3]=+h[e+192>>3];h[d+1208>>3]=+h[e+200>>3];h[d+952>>3]=+h[e+208>>3];h[d+1104>>3]=+h[e+216>>3];h[d+944>>3]=+h[e+224>>3];h[d+936>>3]=+h[e+232>>3];h[d+1096>>3]=+h[e+240>>3];h[d+1152>>3]=+h[e+248>>3];h[d+1144>>3]=+h[e+256>>3];h[d+1136>>3]=+h[e+264>>3];i=b;return}function ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[b+1144>>3]+ +h[b+1112>>3];i=i;return}function jp(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18488>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1040>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,15152,16664,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1216|0;p=o;h[p>>3]=m;i=d;return}function kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+88>>3];i=i;return}function lp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-+h[b+88>>3];i=i;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+1|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+408|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18968>>3]*+h[m+392>>3];j=f;k=j+408|0;l=k;h[l>>3]=g;i=d;return}}function np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+1|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+408>>3],+h[f+416>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+416>>3];break}k=(KK(+h[l+408>>3],-+h[l+416>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+408>>3];break}else{g=l;j=-+h[l+416>>3];break}}}while(0);h[g+400>>3]=j;i=d;return}function op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=+h[b+400>>3]*+h[b+392>>3];i=i;return}function pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=+h[b+416>>3]+ +h[b+400>>3];i=i;return}function qp(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+448>>3]=+h[d>>3];h[e+184>>3]=+h[d+8>>3];h[e+840>>3]=+h[d+16>>3];i=b;return}function rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+184>>3];i=i;return}function sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18216>>3]=+h[b+17176>>3]+ +h[b+17128>>3];i=i;return}function tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18208>>3]=+h[b+17176>>3];i=i;return}function up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18200>>3]=+h[b+17104>>3];i=i;return}function vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18136>>3]=(+h[b+17176>>3]+.0015)*6.283185307179586;i=i;return}function wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18112>>3]=+h[b+17176>>3];i=i;return}function xp(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+18112>>3];e=+h[b+18104>>3];h[b+18120>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function yp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17984>>3]=+h[b+17928>>3];i=i;return}function zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17976>>3]=+h[b+17208>>3];i=i;return}function Ap(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18088>>3]=+h[b+17976>>3];i=i;return}function Bp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17968>>3]=+h[b+17216>>3];i=i;return}function Cp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18080>>3]=+h[b+17968>>3];i=i;return}function Dp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17952>>3]=+h[b+17200>>3];i=i;return}function Ep(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18016>>3]=+h[b+17952>>3];i=i;return}function Fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18056>>3]=+h[b+17952>>3];i=i;return}function Gp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17944>>3]=+h[b+17192>>3];i=i;return}function Hp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18008>>3]=+h[b+17944>>3];i=i;return}function Ip(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18048>>3]=+h[b+17944>>3];i=i;return}function Jp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+17176>>3];h[b+17936>>3]=+h[b+17224>>3]*d*d*+h[b+17184>>3]*3.141592653589793;i=i;return}function Kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17992>>3]=+h[b+17936>>3];i=i;return}function Lp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17920>>3]=+h[b+17176>>3];i=i;return}function Mp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17904>>3]=+h[b+17096>>3]+((+h[b+17104>>3]+ +h[b+17120>>3])*-.5+((+h[b+17216>>3]+ +h[b+17208>>3])*-.5- +h[b+17112>>3]));i=i;return}function Np(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17896>>3]=+h[b+17168>>3];i=i;return}function Op(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17888>>3]=+h[b+17160>>3];i=i;return}function Pp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17880>>3]=+h[b+17152>>3];i=i;return}function Qp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17872>>3]=+h[b+17144>>3];i=i;return}function Rp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17864>>3]=+h[b+17136>>3];i=i;return}function Sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17848>>3]=(+h[b+17176>>3]+ +h[b+17128>>3]*.5)*6.283185307179586;i=i;return}function Tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17840>>3]=+h[b+17088>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17832>>3]=+h[b+17176>>3];i=i;return}function Vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17824>>3]=+h[b+17096>>3]*.25;i=i;return}function Wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17760>>3]=+h[b+17176>>3]*6.283185307179586;i=i;return}function Xp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17752>>3]=(+h[b+17176>>3]+ +h[b+17128>>3]*.5)*6.283185307179586;i=i;return}function Yp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17176>>3];i=i;return}function Zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17112>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17720>>3]=+h[b+17168>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17712>>3]=+h[b+17160>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17704>>3]=+h[b+17152>>3];i=i;return}function bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17696>>3]=+h[b+17144>>3];i=i;return}function cq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17688>>3]=+h[b+17136>>3];i=i;return}function dq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17672>>3]=+h[b+17088>>3];i=i;return}function eq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17664>>3]=+h[b+17176>>3];i=i;return}function fq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17656>>3]=+h[b+17120>>3];i=i;return}function gq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17648>>3]=+h[b+17168>>3];i=i;return}function hq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17640>>3]=+h[b+17160>>3];i=i;return}function iq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17632>>3]=+h[b+17152>>3];i=i;return}function jq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17624>>3]=+h[b+17144>>3];i=i;return}function kq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17616>>3]=+h[b+17136>>3];i=i;return}function lq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17600>>3]=+h[b+17088>>3];i=i;return}function mq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17592>>3]=+h[b+17176>>3]+ +h[b+17128>>3];i=i;return}function nq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17584>>3]=+h[b+17104>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17576>>3]=+h[b+17168>>3];i=i;return}function pq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17568>>3]=+h[b+17160>>3];i=i;return}function qq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17560>>3]=+h[b+17152>>3];i=i;return}function rq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17552>>3]=+h[b+17144>>3];i=i;return}function sq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17544>>3]=+h[b+17136>>3];i=i;return}function tq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17528>>3]=+h[b+17080>>3];i=i;return}function uq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17520>>3]=+h[b+17088>>3];i=i;return}function vq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17512>>3]=(+h[b+17096>>3]- +h[b+17104>>3])*.5;i=i;return}function wq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17504>>3]=+h[b+17168>>3];i=i;return}function xq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17496>>3]=+h[b+17160>>3];i=i;return}function yq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17488>>3]=+h[b+17152>>3];i=i;return}function zq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17480>>3]=+h[b+17144>>3];i=i;return}function Aq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17472>>3]=+h[b+17136>>3];i=i;return}function Bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17456>>3]=+h[b+17080>>3];i=i;return}function Cq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17448>>3]=+h[b+17088>>3];i=i;return}function Dq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17440>>3]=(+h[b+17096>>3]- +h[b+17120>>3])*.5;i=i;return}function Eq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17432>>3]=+h[b+17168>>3];i=i;return}function Fq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17424>>3]=+h[b+17160>>3];i=i;return}function Gq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17416>>3]=+h[b+17152>>3];i=i;return}function Hq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17408>>3]=+h[b+17144>>3];i=i;return}function Iq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17400>>3]=+h[b+17136>>3];i=i;return}function Jq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17384>>3]=+h[b+17072>>3];i=i;return}function Kq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17376>>3]=+h[b+17072>>3];i=i;return}function Lq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17368>>3]=+h[b+17352>>3];i=i;return}function Mq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17344>>3]=+h[b+17064>>3];i=i;return}function Nq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17336>>3]=+h[b+17320>>3];i=i;return}function Oq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17312>>3]=+h[b+17064>>3];i=i;return}function Pq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17304>>3]=+h[b+17288>>3];i=i;return}function Qq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17280>>3]=+h[b+17056>>3];i=i;return}function Rq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17272>>3]=+h[b+17256>>3];i=i;return}function Sq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17248>>3]=+h[b+17056>>3];i=i;return}function Tq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17240>>3]=+h[b+17048>>3]*.5;i=i;return}function Uq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17232>>3]=+h[b+17048>>3]*.5;i=i;return}function Vq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17032>>3]=+h[b+17008>>3];i=i;return}function Wq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17024>>3]=+h[b+17e3>>3];i=i;return}function Xq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17016>>3]=+h[b+16992>>3];i=i;return}function Yq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17040>>3]=+h[b+17016>>3];i=i;return}function Zq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=+h[b+18200>>3]*(+h[b+18216>>3]+ +h[b+18208>>3])*3.141592653589793;i=i;return}function _q(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17920>>3];e=+h[b+17912>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function $q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=+h[(c[a+416>>2]|0)+17848>>3]*6.53451271946677e-7;i=i;return}function ar(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=+h[b+17824>>3]*(+h[b+17840>>3]+ +h[b+17832>>3])*3.141592653589793;i=i;return}function br(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;j=+h[g+17768>>3]+1.0;if(j>0.0){l=g}else{g=c[28168]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=g;g=d;o=20232;c[g+0>>2]=c[o+0>>2];c[g+4>>2]=c[o+4>>2];c[g+8>>2]=c[o+8>>2];c[g+12>>2]=c[o+12>>2];c[g+16>>2]=c[o+16>>2];c[g+20>>2]=c[o+20>>2];Pe[n&31](m,d,16672,e);l=c[f>>2]|0}p=+h[l+17760>>3]*+da(+j)*8.000000000000001e-7;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=p;i=b;return}function cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=+h[(c[a+416>>2]|0)+17752>>3]*6.53451271946677e-7;i=i;return}function dr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17744>>3];e=+h[b+17736>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function er(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=+h[b+17656>>3]*(+h[b+17672>>3]+ +h[b+17664>>3])*3.141592653589793;i=i;return}function fr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=+h[b+17584>>3]*(+h[b+17600>>3]+ +h[b+17592>>3])*3.141592653589793;i=i;return}function gr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17528>>3];e=+h[b+17520>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function hr(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[a+416>>2]|0;d=+h[b+17456>>3];e=+h[b+17448>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=(d*d-e*e)*3.141592653589793;i=i;return}function ir(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=+h[b+17248>>3]*(+h[b+17264>>3]*(+h[b+17272>>3]- +h[b+17256>>3])+1.0);i=i;return}function jr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=+h[b+17280>>3]*(+h[b+17296>>3]*(+h[b+17304>>3]- +h[b+17288>>3])+1.0);i=i;return}function kr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=+h[b+17312>>3]*(+h[b+17328>>3]*(+h[b+17336>>3]- +h[b+17320>>3])+1.0);i=i;return}function lr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=+h[b+17344>>3]*(+h[b+17360>>3]*(+h[b+17368>>3]- +h[b+17352>>3])+1.0);i=i;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2800>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2704|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,16776,16768,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2704|0;p=o;h[p>>3]=m;i=d;return}function nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2808>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2696|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,16816,16808,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2696|0;p=o;h[p>>3]=m;i=d;return}function or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17832>>3];m=+h[j+17840>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,16856,16848,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=20232;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,16888,f);}f=c[g>>2]|0;l=+h[f+17776>>3];m=+da(+n);n=+h[f+17824>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,17016,16848,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=l*r*7895683520871486.0e-21;i=d;return}function pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2824>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2680|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,17104,17096,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2680|0;p=o;h[p>>3]=m;i=d;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18208>>3];m=+h[j+18216>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,17144,17136,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=20232;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,17176,f);}f=c[g>>2]|0;l=+h[f+18152>>3];m=+da(+n);n=+h[f+18200>>3];do{if(m!=0.0){r=n/m}else{if(n==0.0){r=n;break}r=n/+xH(c[b+536>>2]|0,m,17304,17136,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=l*r*7895683520871486.0e-21;i=d;return}function rr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2672>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2664|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,17392,17384,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2664|0;p=o;h[p>>3]=m;i=d;return}function sr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2688>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+2656|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,17432,17424,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+2656|0;p=o;h[p>>3]=m;i=d;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+416|0;l=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+17032>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+416|0;k=GK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+17032>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+416|0;j=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+17032>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+416|0;k=IK(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+17032>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+17024>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+2176|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+17040>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+2176|0;A=z;h[A>>3]=o;i=d;return}function ur(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=0.0;i=i;return}function vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+2736>>3]*+h[b+64>>3];i=i;return}function wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+2176>>3]- +h[b+2008>>3];i=i;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+2008>>3]*+h[b+64>>3];i=i;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+64>>3]*+h[(c[a+416>>2]|0)+17232>>3];i=i;return}function zr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function Ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1992>>3]=+h[b+2728>>3]*+h[b+2048>>3];i=i;return}function Br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+1992>>3]*+h[b+2048>>3];i=i;return}function Cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+2048>>3]*+h[(c[a+416>>2]|0)+17240>>3];i=i;return}function Dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=0.0;i=i;return}function Er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=0.0;i=i;return}function Fr(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1920>>3]=+h[d>>3];h[e+1928>>3]=+h[d+8>>3];h[e+1976>>3]=+h[d+16>>3];h[e+1968>>3]=+h[d+24>>3];h[e+1944>>3]=+h[d+32>>3];h[e+1952>>3]=+h[d+40>>3];i=b;return}function Gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+1952>>3]*+h[b+1944>>3];i=i;return}function Hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+1944>>3]- +h[b+2048>>3];i=i;return}function Ir(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17384>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1944>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,17472,17464,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+120|0;p=o;h[p>>3]=m;i=d;return}function Jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=-+h[b+64>>3]- +h[b+1968>>3];i=i;return}function Kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+2168>>3]- +h[b+2136>>3];i=i;return}function Lr(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17376>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1968>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,17512,17504,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+128|0;p=o;h[p>>3]=m;i=d;return}function Mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1976>>3]*+h[b+1968>>3];i=i;return}function Nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+2104>>3]- +h[b+1920>>3];i=i;return}function Or(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+17232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2096>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,17552,17544,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2632|0;q=p;h[q>>3]=n;i=d;return}function Pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2792>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,17592,17584,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2304|0;q=p;h[q>>3]=n;i=d;return}function Qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,17632,17624,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2280|0;q=p;h[q>>3]=n;i=d;return}function Rr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+2632>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,17672,17664,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2208|0;q=p;h[q>>3]=n;i=d;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2056>>3]=+h[b+1920>>3]- +h[b+1992>>3];i=i;return}function Tr(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+17240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2056>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,e,17720,17712,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2552|0;q=p;h[q>>3]=n;i=d;return}function Ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2832>>3];k=+h[g+2552>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,17760,17752,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+2328|0;q=p;h[q>>3]=n;i=d;return}function Vr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[a+416>>2]|0)+17216>>3];i=i;return}function Wr(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0;b=i;d=c[a+416>>2]|0;e=+h[d+18096>>3];f=+h[d+18120>>3];d=a+4|0;g=+QI(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+40>>3],-2);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1336>>3]=e*f*g*+(c[(c[a+420>>2]|0)+24>>2]|0)*-1256637061435917.0e-21;i=b;return}function Xr(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=+h[(c[f+8>>2]|0)+40>>3];j=b+416|0;k=c[j>>2]|0;l=+h[k+18136>>3];m=+h[k+18144>>3];n=g*g;do{if(g!=0.0){o=m/g}else{if(m==0.0){o=m;break}o=m/+xH(c[b+536>>2]|0,g,17800,17792,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);f=c[(c[b+420>>2]|0)+28>>2]|0;g=+(f|0);if(n*(o*3.141592653589793+1.0)!=0.0){k=c[c[e>>2]>>2]|0;o=+h[(c[k+8>>2]|0)+40>>3];p=+h[(c[j>>2]|0)+18144>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+xH(c[b+536>>2]|0,o,17800,17792,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=g/(n*(q*3.141592653589793+1.0));s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}if((f|0)==0){r=g;s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}f=c[b+536>>2]|0;k=c[c[e>>2]>>2]|0;q=+h[(c[k+8>>2]|0)+40>>3];o=+h[(c[j>>2]|0)+18144>>3];do{if(q!=0.0){E=k;F=o/q}else{if(o==0.0){E=k;F=o;break}p=o/+xH(f,q,17800,17792,+h[k>>3],(a[b+319|0]|0)!=0|0);E=c[c[e>>2]>>2]|0;F=p}}while(0);r=g/+xH(f,n*(F*3.141592653589793+1.0),17824,17792,+h[E>>3],(a[b+319|0]|0)!=0|0);s=m*r;t=l*s;u=t*-1256637061435917.0e-21;v=c[e>>2]|0;w=c[v>>2]|0;x=w;y=x+8|0;z=y;A=c[z>>2]|0;B=A;C=B+1280|0;D=C;h[D>>3]=u;i=d;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=+h[(c[j+8>>2]|0)+40>>3];m=b+416|0;n=+h[(c[m>>2]|0)+18144>>3];do{if(l!=0.0){o=n/l}else{if(n==0.0){o=n;break}o=n/+xH(c[b+536>>2]|0,l,17800,17944,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);l=o*3.141592653589793+1.0;if(l>0.0){p=c[m>>2]|0;q=p;r=q+18136|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+1288|0;F=E;h[F>>3]=w;i=d;return}j=c[28168]|0;G=c[b+536>>2]|0;b=f;h[k>>3]=l;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j;j=e;H=20232;c[j+0>>2]=c[H+0>>2];c[j+4>>2]=c[H+4>>2];c[j+8>>2]=c[H+8>>2];c[j+12>>2]=c[H+12>>2];c[j+16>>2]=c[H+16>>2];c[j+20>>2]=c[H+20>>2];Pe[b&31](G,e,17952,f);p=c[m>>2]|0;q=p;r=q+18136|0;s=r;t=+h[s>>3];u=+da(+l);v=t*u;w=v*4.0e-7;x=c[g>>2]|0;y=c[x>>2]|0;z=y;A=z+8|0;B=A;C=c[B>>2]|0;D=C;E=D+1288|0;F=E;h[F>>3]=w;i=d;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1288>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,18104,18096,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}function _r(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0.0,n=0,o=0.0,p=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+18096>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+40>>3];m=+h[e+18120>>3];do{if(l!=0.0){n=k;o=m/l}else{if(m==0.0){n=k;o=m;break}p=m/+xH(c[b+536>>2]|0,l,17800,18144,+h[j>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;o=p}}while(0);h[n+1344>>3]=f*o*1256637061435917.0e-21;i=d;return}function $r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1344>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1352|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,18160,18152,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1352|0;p=o;h[p>>3]=m;i=d;return}function as(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1568>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1568|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1568>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1624>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1624|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1624>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1272>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1272|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+iL(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1272>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1368>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1368|0;h[(c[g+128>>2]|0)+24>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1368>>3]);e=c[f>>2]|0;h[(c[e+132>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2032>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2032|0;h[(c[e+128>>2]|0)+32>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2032>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+32>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+40>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1536>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1536|0;h[(c[j+128>>2]|0)+40>>3]=+h[e>>3];k=+iL(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1536>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+40>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+48>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1856>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1856|0;h[(c[g+128>>2]|0)+48>>3]=+h[j>>3];k=+iL(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1856>>3]);e=c[f>>2]|0;h[(c[e+132>>2]|0)+48>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+56>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+2080>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+2080|0;h[(c[e+128>>2]|0)+56>>3]=+h[g>>3];k=+iL(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+2080>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+56>>3]=k;gL(a,1)|0;j=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1568>>3]=+h[j>>3];h[f+1624>>3]=+h[j+8>>3];h[f+1272>>3]=+h[j+16>>3];h[f+1368>>3]=+h[j+24>>3];h[f+2032>>3]=+h[j+32>>3];h[f+1536>>3]=+h[j+40>>3];h[f+1856>>3]=+h[j+48>>3];h[f+2080>>3]=+h[j+56>>3];Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);gk(a);hk(a);ik(a);jk(a);kk(a);lk(a);mk(a);nk(a);ok(a);pk(a);qk(a);rk(a);sk(a);tk(a);uk(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);i=b;return}function bs(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1376>>3];h[b+1360>>3]=d*d*+h[b+1336>>3]*.5;i=i;return}function cs(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1312>>3];h[b+1304>>3]=d*d*+h[b+1280>>3]*.5;i=i;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=+h[b+1304>>3]+ +h[b+1360>>3];i=i;return}function es(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+18120>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1368>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,18200,18192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1328|0;p=o;h[p>>3]=m;i=d;return}function fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[(c[a+416>>2]|0)+17240>>3]*+h[b+2032>>3];i=i;return}function gs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2048>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+2024>>3]*1.0e13;l=j}else{m=+h[j+2048>>3];n=+h[j+2024>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,18240,18232,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+2016>>3]=+U(+k);i=d;return}



function Oy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31600]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+16>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(31608,ZH(c[(c[g>>2]|0)+16>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=31864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[31600]=1;i=d;return}function Py(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31888]&1){i=d;return}g=b+420|0;b=LK(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(JK(+(c[(c[g>>2]|0)+12>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=$H(31896,ZH(c[(c[g>>2]|0)+12>>2]|0,22536)|0)|0;g=c[28170]|0;h=e;j=32128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[g&15](e,b,f);a[31888]=1;i=d;return}function Qy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32152]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32160,XH(+h[(c[g>>2]|0)+17992>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32152]=1;i=d;return}function Ry(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32312]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17960>>3],1.0)|0)<<24>>24==0)){i=d;return}b=$H(32320,XH(+h[(c[g>>2]|0)+17960>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32312]=1;i=d;return}function Sy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32456]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32464,XH(+h[(c[g>>2]|0)+17936>>3],23664)|0)|0;g=c[28170]|0;j=e;k=32576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32456]=1;i=d;return}function Ty(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32600]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32608,XH(+h[(c[g>>2]|0)+17920>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32600]=1;i=d;return}function Uy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32728]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32736,XH(+h[(c[g>>2]|0)+17912>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32728]=1;i=d;return}function Vy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32856]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32864,XH(+h[(c[g>>2]|0)+17840>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32856]=1;i=d;return}function Wy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32984]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(32992,XH(+h[(c[g>>2]|0)+17832>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[32984]=1;i=d;return}function Xy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33112]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33120,XH(+h[(c[g>>2]|0)+17744>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33112]=1;i=d;return}function Yy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33240]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33248,XH(+h[(c[g>>2]|0)+17736>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33240]=1;i=d;return}function Zy(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33368]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33376,XH(+h[(c[g>>2]|0)+17672>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33368]=1;i=d;return}function _y(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33504]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33512,XH(+h[(c[g>>2]|0)+17664>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33504]=1;i=d;return}function $y(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33640]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33648,XH(+h[(c[g>>2]|0)+17600>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33640]=1;i=d;return}function az(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33800]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33808,XH(+h[(c[g>>2]|0)+17592>>3],23664)|0)|0;g=c[28170]|0;j=e;k=33936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33800]=1;i=d;return}function bz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33960]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(33968,XH(+h[(c[g>>2]|0)+17528>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[33960]=1;i=d;return}function cz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34096]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34104,XH(+h[(c[g>>2]|0)+17520>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34096]=1;i=d;return}function dz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34232]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34240,XH(+h[(c[g>>2]|0)+17456>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34232]=1;i=d;return}function ez(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34392]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34400,XH(+h[(c[g>>2]|0)+17448>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34392]=1;i=d;return}function fz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34552]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34560,XH(+h[(c[g>>2]|0)+17384>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34552]=1;i=d;return}function gz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34672]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34680,XH(+h[(c[g>>2]|0)+17376>>3],23664)|0)|0;g=c[28170]|0;j=e;k=34792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34672]=1;i=d;return}function hz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34816]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34824,XH(+h[(c[g>>2]|0)+17368>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34816]=1;i=d;return}function iz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34936]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(34944,XH(+h[(c[g>>2]|0)+17352>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[34936]=1;i=d;return}function jz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35064]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35072,XH(+h[(c[g>>2]|0)+17336>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35064]=1;i=d;return}function kz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35184]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35192,XH(+h[(c[g>>2]|0)+17320>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35184]=1;i=d;return}function lz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35312]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35320,XH(+h[(c[g>>2]|0)+17304>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35312]=1;i=d;return}function mz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35424]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35432,XH(+h[(c[g>>2]|0)+17288>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35424]=1;i=d;return}function nz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35544]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35552,XH(+h[(c[g>>2]|0)+17272>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35544]=1;i=d;return}function oz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35680]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35688,XH(+h[(c[g>>2]|0)+17256>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35680]=1;i=d;return}function pz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35824]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35832,XH(+h[(c[g>>2]|0)+17224>>3],23664)|0)|0;g=c[28170]|0;j=e;k=35944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35824]=1;i=d;return}function qz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35968]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(35976,XH(+h[(c[g>>2]|0)+17176>>3],23664)|0)|0;g=c[28170]|0;j=e;k=36080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[35968]=1;i=d;return}function rz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36104]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(36112,XH(+h[(c[g>>2]|0)+17088>>3],23664)|0)|0;g=c[28170]|0;j=e;k=36224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[36104]=1;i=d;return}function sz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36248]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(36256,XH(+h[(c[g>>2]|0)+17080>>3],23664)|0)|0;g=c[28170]|0;j=e;k=36368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[36248]=1;i=d;return}function tz(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36392]&1){i=d;return}g=b+416|0;if(!((LK(+h[(c[g>>2]|0)+17072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=$H(36400,XH(+h[(c[g>>2]|0)+17072>>3],23664)|0)|0;g=c[28170]|0;j=e;k=36504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[g&15](e,b,f);a[36392]=1;i=d;return}function uz(a){a=a|0;var b=0;b=i;_t(a);$t(a);au(a);bu(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);iu(a);ju(a);ku(a);lu(a);mu(a);nu(a);ou(a);pu(a);qu(a);ru(a);su(a);tu(a);uu(a);vu(a);wu(a);xu(a);yu(a);zu(a);Au(a);Bu(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Iu(a);Ju(a);Ku(a);Lu(a);Mu(a);Nu(a);Ou(a);Pu(a);Qu(a);Ru(a);Su(a);Tu(a);Uu(a);Vu(a);Wu(a);Xu(a);Yu(a);Zu(a);_u(a);$u(a);av(a);bv(a);cv(a);dv(a);ev(a);fv(a);gv(a);hv(a);iv(a);jv(a);kv(a);lv(a);mv(a);nv(a);ov(a);pv(a);qv(a);rv(a);sv(a);tv(a);uv(a);vv(a);wv(a);xv(a);yv(a);zv(a);Av(a);Bv(a);Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);Hv(a);Iv(a);Jv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);Pv(a);Qv(a);Rv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);Xv(a);Yv(a);Zv(a);_v(a);$v(a);aw(a);bw(a);cw(a);dw(a);ew(a);fw(a);gw(a);hw(a);iw(a);jw(a);kw(a);lw(a);mw(a);nw(a);ow(a);pw(a);qw(a);rw(a);sw(a);tw(a);uw(a);vw(a);ww(a);xw(a);yw(a);zw(a);Aw(a);Bw(a);Cw(a);Dw(a);Ew(a);Fw(a);Gw(a);Hw(a);Iw(a);Jw(a);Kw(a);Lw(a);Mw(a);Nw(a);Ow(a);Pw(a);Qw(a);Rw(a);Sw(a);Tw(a);Uw(a);Vw(a);Ww(a);Xw(a);Yw(a);Zw(a);_w(a);$w(a);ax(a);bx(a);cx(a);dx(a);ex(a);fx(a);gx(a);hx(a);ix(a);jx(a);kx(a);lx(a);mx(a);nx(a);ox(a);px(a);qx(a);rx(a);sx(a);tx(a);ux(a);vx(a);wx(a);xx(a);yx(a);zx(a);Ax(a);Bx(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);Hx(a);Ix(a);Jx(a);Kx(a);Lx(a);Mx(a);Nx(a);Ox(a);Px(a);Qx(a);Rx(a);Sx(a);Tx(a);Ux(a);Vx(a);Wx(a);Xx(a);Yx(a);Zx(a);_x(a);$x(a);ay(a);by(a);cy(a);dy(a);ey(a);fy(a);gy(a);hy(a);iy(a);jy(a);ky(a);ly(a);my(a);ny(a);oy(a);py(a);qy(a);ry(a);sy(a);ty(a);uy(a);vy(a);wy(a);xy(a);yy(a);zy(a);Ay(a);By(a);Cy(a);Dy(a);Ey(a);Fy(a);Gy(a);Hy(a);Iy(a);Jy(a);Ky(a);Ly(a);My(a);Ny(a);Oy(a);Py(a);Qy(a);Ry(a);Sy(a);Ty(a);Uy(a);Vy(a);Wy(a);Xy(a);Yy(a);Zy(a);_y(a);$y(a);az(a);bz(a);cz(a);dz(a);ez(a);fz(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);nz(a);oz(a);pz(a);qz(a);rz(a);sz(a);tz(a);i=b;return 0}function vz(b){b=b|0;var c=0;c=i;a[b+314|0]=0;wz(b);i=c;return 0}function wz(a){a=a|0;var b=0;b=i;Fi(a);Hi(a);Ii(a);Ji(a);Cg(a);Pg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);kh(a);mh(a);nh(a);oh(a);ph(a);wh(a);xh(a);Qh(a);Rh(a);Sh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);di(a);ei(a);hi(a);ii(a);ji(a);ri(a);zi(a);Di(a);Ei(a);zf(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Mf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);_f(a);eg(a);fg(a);ng(a);vg(a);zg(a);Ag(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);i=b;return}function xz(a){a=a|0;i=i;return 0}function yz(a){a=a|0;i=i;return 1}function zz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=9;c[a+48>>2]=9;c[a+72>>2]=daa(9,8)|0;a=daa(9,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=daa(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=baa(36)|0;c[(c[d>>2]|0)+52>>2]=a;a=baa(136)|0;c[(c[d>>2]|0)+56>>2]=a;a=baa(36)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=6;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+32>>2]=5;c[e+28>>2]=4;c[e+24>>2]=4;c[e+20>>2]=5;c[e+16>>2]=4;c[e+12>>2]=5;c[e+8>>2]=2;c[e+4>>2]=3;c[e>>2]=2;f=3;g=2;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=9){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}Az(e,c[a+56>>2]|0);a=c[d>>2]|0;Bz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Cz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Dz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ez(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Fz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Gz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Hz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Iz(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+32>>2]=1;c[a+8>>2]=1;c[a+28>>2]=2;c[a+4>>2]=2;c[a+24>>2]=3;c[a>>2]=3;c[a+20>>2]=4;c[a+16>>2]=5;c[a+12>>2]=6;i=b;return 0}function Az(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Bz(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Cz(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Dz(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Ez(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=5;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Fz(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=6;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function Gz(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=1;i=i;return}function Hz(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=1;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function Iz(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=0;c[b+((c[a>>2]|0)+ -1<<2)>>2]=1;i=i;return}function Jz(a){a=a|0;i=i;return 1}function Kz(a){a=a|0;i=i;return 1}function Lz(a){a=a|0;i=i;return 1}function Mz(a){a=a|0;i=i;return 0}function Nz(a){a=a|0;i=i;return 0}function Oz(a){a=a|0;i=i;return 0}function Pz(a){a=a|0;i=i;return 0}function Qz(a){a=a|0;i=i;return 0}function Rz(a,b){a=a|0;b=b|0;i=i;return-1}function Sz(a,b){a=a|0;b=b|0;i=i;return-1}function Tz(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Uz(){i=i;return 36528}function Vz(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;i=i+152|0;o=n+96|0;p=n+104|0;q=n+120|0;r=a;a=b;b=d;d=e;e=f;s=g;f=j;j=k;k=daa(1,104)|0;do{if((k|0)!=0){c[k+24>>2]=l;c[k+28>>2]=m;c[k+40>>2]=j;do{if(j>>>0>0){c[k+36>>2]=baa(c[k+40>>2]<<2)|0;t=k;if((c[k+36>>2]|0)!=0){Haa(c[t+36>>2]|0,f|0,c[k+40>>2]<<2|0)|0;break}caa(t);VI(37616);u=0;v=u;i=n;return v|0}}while(0);h[k+48>>3]=s;c[k+32>>2]=Wz(r,a)|0;t=c[k+32>>2]|0;if((t|0)==3){break}else if((t|0)==0){c[k+12>>2]=d;c[k+16>>2]=e;c[k+8>>2]=b;do{if((c[k+24>>2]|0)==2){if((c[k+12>>2]|0)!=2){break}c[k+24>>2]=1}}while(0);w=k;if((Xz(k)|0)==0){c[w+8>>2]=0;break}if((c[w+24>>2]|0)==2){c[k+56>>2]=Yz(b,c[k+12>>2]|0,c[k+16>>2]|0,f,c[k+40>>2]|0)|0}c[k+8>>2]=baa((fa(c[k+12>>2]|0,c[k+16>>2]|0)|0)<<3)|0;if((c[k+8>>2]|0)!=0){Haa(c[k+8>>2]|0,b|0,(fa(c[k+12>>2]|0,c[k+16>>2]|0)|0)<<3|0)|0;break}if(j>>>0>0){caa(c[k+36>>2]|0)}caa(k);k=0;VI(37616);break}else if((t|0)==1){c[k+4>>2]=baa((Faa(r|0)|0)+1|0)|0;if((c[k+4>>2]|0)==0){if(j>>>0>0){caa(c[k+36>>2]|0)}caa(k);k=0;VI(37616);break}Laa(c[k+4>>2]|0,r|0)|0;c[k>>2]=baa((Faa(a|0)|0)+1|0)|0;w=k;if((c[k>>2]|0)!=0){Laa(c[w>>2]|0,a|0)|0;break}caa(c[w+4>>2]|0);if(j>>>0>0){caa(c[k+36>>2]|0)}caa(k);k=0;VI(37616);break}else if((t|0)==2){if((Zz(r,0,p,o,k+8|0)|0)!=0){break}c[k+12>>2]=c[p>>2];c[k+16>>2]=c[p+4>>2];if((c[o>>2]|0)!=0){c[q>>2]=c[k+12>>2];c[q+4>>2]=c[k+16>>2];w=baa((fa(c[q>>2]|0,c[q+4>>2]|0)|0)<<3)|0;if((w|0)==0){if(j>>>0>0){caa(c[k+36>>2]|0)}caa(k);k=0;VI(37616);break}x=0;while(1){if(!(x>>>0<(c[q+4>>2]|0)>>>0)){break}y=0;while(1){if(!(y>>>0<(c[q>>2]|0)>>>0)){break}z=(fa(y,c[q+4>>2]|0)|0)+x|0;h[w+((fa(x,c[q>>2]|0)|0)+y<<3)>>3]=+h[(c[k+8>>2]|0)+(z<<3)>>3];y=y+1|0}x=x+1|0}c[k+8>>2]=w;c[k+12>>2]=c[q+4>>2];c[k+16>>2]=c[q>>2];c[k+32>>2]=3}do{if((c[k+24>>2]|0)==2){if((c[k+12>>2]|0)!=2){break}c[k+24>>2]=1}}while(0);if((Xz(k)|0)==0){break}if((c[k+24>>2]|0)!=2){break}c[k+56>>2]=Yz(c[k+8>>2]|0,c[k+12>>2]|0,c[k+16>>2]|0,f,c[k+40>>2]|0)|0;break}else{VI(37648);break}}else{VI(37616)}}while(0);u=k;v=u;i=n;return v|0}function Wz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=d;f=b;b=mA(a)|0;a=mA(f)|0;if((b|0)!=0){g=(a|0)==0?2:1;h=g;i=d;return h|0}if((a|0)!=0){c[e>>2]=f;XI(38848,e)}g=0;h=g;i=d;return h|0}function Xz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;b=i;i=i+48|0;d=b;e=i;i=i+48|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+8|0;l=a;a=1;a:do{if((l|0)!=0){m=c[l+12>>2]|0;n=c[l+16>>2]|0;Laa(j|0,38936)|0;if((c[l+32>>2]|0)==0){o=j}else{o=c[l+4>>2]|0}do{if(!(m>>>0<1)){if(n>>>0<2){break}if((c[l+8>>2]|0)==0){break a}if(!(m>>>0>1)){break a}p=c[l+8>>2]|0;do{if((c[l+28>>2]|0)==3){if(!(+h[p+((fa(m-1|0,n)|0)<<3)>>3]- +h[p>>3]<=0.0)){break}c[f>>2]=o;XI(39176,f);a=0;q=a;r=q;i=b;return r|0}}while(0);s=0;if((c[l+24>>2]|0)==2){while(1){if(!(s>>>0<(m-1|0)>>>0)){break a}t=+h[p+((fa(s,n)|0)<<3)>>3];u=+h[p+((fa(s+1|0,n)|0)<<3)>>3];if(t>=u){break}s=s+1|0}c[e>>2]=o;c[e+4>>2]=m;c[e+8>>2]=n;c[e+12>>2]=o;c[e+16>>2]=s+1;v=e+20|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[e+28>>2]=o;c[e+32>>2]=s+2;v=e+36|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];XI(38944,e);a=0;q=a;r=q;i=b;return r|0}else{while(1){if(!(s>>>0<(m-1|0)>>>0)){break a}w=+h[p+((fa(s,n)|0)<<3)>>3];x=+h[p+((fa(s+1|0,n)|0)<<3)>>3];if(w>x){break}s=s+1|0}c[d>>2]=o;c[d+4>>2]=m;c[d+8>>2]=n;c[d+12>>2]=o;c[d+16>>2]=s+1;p=d+20|0;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[d+28>>2]=o;c[d+32>>2]=s+2;p=d+36|0;h[k>>3]=x;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];XI(39296,d);a=0;q=a;r=q;i=b;return r|0}}}while(0);c[g>>2]=o;c[g+4>>2]=m;c[g+8>>2]=n;XI(39080,g);a=0;q=a;r=q;i=b;return r|0}}while(0);q=a;r=q;i=b;return r|0}function Yz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0;g=i;i=i+120|0;j=a;a=b;b=d;d=e;e=f;f=0;do{if((j|0)!=0){if((d|0)==0){break}if(!(a>>>0>2)){break}f=baa((fa(a-1|0,e)|0)*24|0)|0;if((f|0)==0){VI(37616);k=0;l=k;i=g;return l|0}m=baa(a+3<<3)|0;if((m|0)==0){caa(f);VI(37616);k=0;l=k;i=g;return l|0}n=0;while(1){if(!(n>>>0<e>>>0)){break}o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}p=fa(o+1|0,b)|0;q=fa(o,b)|0;r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];h[m+(o+2<<3)>>3]=(+h[j+(p+((c[d+(n<<2)>>2]|0)-1)<<3)>>3]- +h[j+(q+((c[d+(n<<2)>>2]|0)-1)<<3)>>3])/(r- +h[j+((fa(o,b)|0)<<3)>>3]);o=o+1|0}h[m>>3]=+h[m+16>>3]*3.0- +h[m+24>>3]*2.0;h[m+8>>3]=+h[m+16>>3]*2.0- +h[m+24>>3];h[m+(a+1<<3)>>3]=+h[m+(a<<3)>>3]*2.0- +h[m+(a-1<<3)>>3];h[m+(a+2<<3)>>3]=+h[m+(a<<3)>>3]*3.0- +h[m+(a-1<<3)>>3]*2.0;o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];s=r- +h[j+((fa(o,b)|0)<<3)>>3];q=f+(((fa(o,e)|0)+n|0)*24|0)|0;r=+U(+(+h[m+(o+3<<3)>>3]- +h[m+(o+2<<3)>>3]));t=r+ +U(+(+h[m+(o+1<<3)>>3]- +h[m+(o<<3)>>3]));r=+h[m+(o+1<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o<<3)>>3]))/t;h[q+16>>3]=(1.0-u)*+h[m+(o+1<<3)>>3]+u*+h[m+(o+2<<3)>>3]}else{h[q+16>>3]=.5*r+ +h[m+(o+2<<3)>>3]*.5}r=+U(+(+h[m+(o+4<<3)>>3]- +h[m+(o+3<<3)>>3]));t=r+ +U(+(+h[m+(o+2<<3)>>3]- +h[m+(o+1<<3)>>3]));r=+h[m+(o+2<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o+1<<3)>>3]))/t;t=(1.0-u)*+h[m+(o+2<<3)>>3]+u*+h[m+(o+3<<3)>>3]}else{t=.5*r+ +h[m+(o+3<<3)>>3]*.5}h[q+8>>3]=(+h[m+(o+2<<3)>>3]*3.0- +h[q+16>>3]*2.0-t)/s;h[q>>3]=(+h[q+16>>3]+t- +h[m+(o+2<<3)>>3]*2.0)/(s*s);o=o+1|0}n=n+1|0}caa(m)}}while(0);k=f;l=k;i=g;return l|0}function Zz(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;VI(37816);i=e;return 1}function _z(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;if((d|0)==0){i=b;return}do{if((c[d+8>>2]|0)!=0){if((c[d+32>>2]|0)!=1){e=5;break}caa(c[d+8>>2]|0);c[d+8>>2]=0}else{e=5}}while(0);do{if((e|0)==5){if((c[d+8>>2]|0)==0){break}if((c[d+32>>2]|0)!=0){if((c[d+32>>2]|0)!=3){break}}caa(c[d+8>>2]|0);c[d+8>>2]=0}}while(0);do{if((c[d+40>>2]|0)>>>0>0){if((c[d+36>>2]|0)==0){break}caa(c[d+36>>2]|0);c[d+36>>2]=0}}while(0);if((c[d+4>>2]|0)!=0){caa(c[d+4>>2]|0);c[d+4>>2]=0}if((c[d>>2]|0)!=0){caa(c[d>>2]|0);c[d>>2]=0}if((c[d+96>>2]|0)!=0){caa(c[d+96>>2]|0);c[d+96>>2]=0}$z(c[d+56>>2]|0);caa(d);d=0;i=b;return}function $z(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=a;if((c|0)!=0){caa(c);c=0}i=b;return}function aA(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0;g=i;i=i+288|0;j=b;k=d;d=e;e=f;f=0.0;b=a;do{if((b|0)!=0){if((c[b+8>>2]|0)==0){break}if((c[b+36>>2]|0)==0){break}l=k;k=k- +h[b+48>>3];do{if(k>=0.0){if(!(d<1.7976931348623157e+308)){break}if(!(d==e)){break}if(!(+h[b+48>>3]>=d)){break}m=0.0;n=m;i=g;return+n}}while(0);if(!(k>=0.0)){break}a=c[b+8>>2]|0;o=c[b+12>>2]|0;p=c[b+16>>2]|0;q=(c[(c[b+36>>2]|0)+(j-1<<2)>>2]|0)-1|0;if((o|0)==1){f=+h[a+(q<<3)>>3];break}r=0;do{if((c[b+28>>2]|0)==3){s=+h[a>>3];t=+h[a+((fa(o-1|0,p)|0)<<3)>>3];u=t-s;do{if(d==e){if(!(l>=d)){break}v=(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)|0;if((c[b+24>>2]|0)==3){w=c[v>>2]|0}else{w=c[v+4>>2]|0}f=+h[a+((fa(w,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);do{if(d>e){if(!(l>=e)){break}if(!(+h[b+48>>3]<e)){break}f=+h[a+((fa(c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)>>2]|0,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);v=c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)>>2]|0;x=c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)+4>>2]|0;k=k- +h[b+88>>3];do{if(k<s){k=k+u}else{if(!(k>t)){break}k=k-u}}while(0);c[b+20>>2]=bA(a,o,p,c[b+20>>2]|0,k)|0;if((c[b+20>>2]|0)>>>0<v>>>0){k=+h[a+((fa(v,p)|0)<<3)>>3]}if(!((c[b+20>>2]|0)>>>0>=x>>>0)){break}if((c[b+84>>2]|0)==1){k=+h[a+((fa(v,p)|0)<<3)>>3];break}else{k=+h[a+((fa(x,p)|0)<<3)>>3];break}}else{if(k<+h[a>>3]){r=-1;break}if(!(k>+h[a+((fa(o-1|0,p)|0)<<3)>>3])){break}r=1;if((c[b+28>>2]|0)==3){break}if(!(d==e&d<1.7976931348623157e+308)){break}if(!(l>=d)){break}r=0}}while(0);if((r|0)==0){y=bA(a,o,p,c[b+20>>2]|0,k)|0;c[b+20>>2]=y;do{if((c[b+28>>2]|0)!=3){if(!(d==e&d<1.7976931348623157e+308)){break}if(!(l>=d)){break}if(k>=+h[a+((fa(o-1|0,p)|0)<<3)>>3]){y=o-1|0}f=+h[a+((fa(cA(b,y)|0,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);z=c[b+24>>2]|0;if((z|0)==3){if(k>=+h[a+((fa(y+1|0,p)|0)<<3)>>3]){y=y+1|0}f=+h[a+((fa(y,p)|0)+q<<3)>>3];break}else if((z|0)==1){l=+h[a+((fa(y,p)|0)<<3)>>3];u=+h[a+((fa(y+1|0,p)|0)<<3)>>3];t=+h[a+((fa(y,p)|0)+q<<3)>>3];s=+h[a+((fa(y+1|0,p)|0)+q<<3)>>3];if((dA(l,u)|0)!=0){f=s;break}else{f=t+(s-t)*(k-l)/(u-l);break}}else if((z|0)==2){if((c[b+56>>2]|0)==0){break}z=(fa(y,c[b+40>>2]|0)|0)+(j-1)|0;A=(c[b+56>>2]|0)+(z*24|0)|0;k=k- +h[a+((fa(y,p)|0)<<3)>>3];f=+h[a+((fa(y,p)|0)+q<<3)>>3];f=f+((+h[A>>3]*k+ +h[A+8>>3])*k+ +h[A+16>>3])*k;break}else{VI(37672);break}}else{A=c[b+28>>2]|0;if((A|0)==3){break}else if((A|0)==4){VI(37704);break}else if((A|0)==1){if((r|0)==1){B=+h[a+((fa(o-1|0,p)|0)+q<<3)>>3]}else{B=+h[a+(q<<3)>>3]}f=B;break}else if((A|0)==2){if((r|0)==1){C=o-2|0}else{C=0}A=C;l=+h[a+((fa(A,p)|0)<<3)>>3];u=+h[a+((fa(A,p)|0)+q<<3)>>3];if((c[b+24>>2]|0)!=2){t=+h[a+((fa(A+1|0,p)|0)<<3)>>3];s=+h[a+((fa(A+1|0,p)|0)+q<<3)>>3];if((dA(l,t)|0)!=0){f=s;break}else{f=u+(s-u)*(k-l)/(t-l);break}}if((c[b+56>>2]|0)==0){break}z=(fa(A,c[b+40>>2]|0)|0)+(j-1)|0;D=(c[b+56>>2]|0)+(z*24|0)|0;if((r|0)==1){t=+h[a+((fa(A+1|0,p)|0)<<3)>>3];s=+h[a+((fa(A+1|0,p)|0)+q<<3)>>3];f=t-l;f=(+h[D>>3]*3.0*f+ +h[D+8>>3]*2.0)*f+ +h[D+16>>3];f=s+f*(k-t);break}else{f=u+ +h[D+16>>3]*(k-l);break}}else{VI(37728);break}}}}while(0);m=f;n=m;i=g;return+n}function bA(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,j=0.0,k=0,l=0,m=0,n=0;f=i;i=i+72|0;g=a;a=c;c=d;j=e;d=0;k=b-1|0;do{if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=c}else{b=c;if(j>=+h[g+((fa(c+1|0,a)|0)<<3)>>3]){d=b;break}l=b;m=l;i=f;return m|0}}while(0);while(1){n=d;if(!(k>>>0>(d+1|0)>>>0)){break}c=((n+k|0)>>>0)/2|0;b=c;if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=b;continue}else{d=b;continue}}l=n;m=l;i=f;return m|0}function cA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;d=i;i=i+64|0;e=a;a=b;b=a;if((e|0)==0){f=b;i=d;return f|0}if((c[e+8>>2]|0)==0){f=b;i=d;return f|0}g=c[e+8>>2]|0;j=c[e+16>>2]|0;k=a;while(1){if(!(k>>>0>0)){l=11;break}m=+h[g+((fa(k-1|0,j)|0)<<3)>>3];n=+h[g+((fa(k,j)|0)<<3)>>3];a=(c[e+24>>2]|0)==3;o=(dA(m,n)|0)!=0;if(a){if(!o){l=7;break}}else{if(!o){l=9;break}}k=k+ -1|0}if((l|0)==7){b=k-1|0;f=b;i=d;return f|0}else if((l|0)==9){b=k;f=b;i=d;return f|0}else if((l|0)==11){f=b;i=d;return f|0}return 0}function dA(a,b){a=+a;b=+b;var c=0,d=0.0,e=0.0,f=0.0,g=0;c=i;i=i+40|0;d=a;a=b;b=+U(+d);e=+U(+a);f=b>e?b:e;if(f<1.0e-10){f=1.0e-10}f=f*1.0e-10;g=+U(+(a-d))<f|0;i=c;return g|0}function eA(a){a=a|0;var b=0,d=0.0,e=0,f=0.0;b=i;i=i+32|0;d=0.0;e=a;if((e|0)==0){f=d;i=b;return+f}if((c[e+8>>2]|0)==0){f=d;i=b;return+f}d=+h[c[e+8>>2]>>3];f=d;i=b;return+f}function fA(a){a=a|0;var b=0,d=0.0,e=0,f=0.0;b=i;i=i+40|0;d=0.0;e=a;if((e|0)==0){f=d;i=b;return+f}if((c[e+8>>2]|0)==0){f=d;i=b;return+f}d=+h[(c[e+8>>2]|0)+((fa((c[e+12>>2]|0)-1|0,c[e+16>>2]|0)|0)<<3)>>3];f=d;i=b;return+f}function gA(a,b){a=a|0;b=+b;var d=0,e=0.0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;d=i;i=i+248|0;e=b;b=1.7976931348623157e+308;f=a;do{if((f|0)!=0){if((c[f+8>>2]|0)==0){g=91;break}a=c[f+8>>2]|0;j=c[f+12>>2]|0;k=c[f+16>>2]|0;do{if((c[f+60>>2]|0)>>>0>0){if(e>+h[f+72>>3]){h[f+72>>3]=e;break}l=+h[f+64>>3];m=l;i=d;return+m}}while(0);a:do{if((c[f+28>>2]|0)==3){if((c[f+60>>2]|0)!=0){break}n=+h[a>>3];o=+h[a+((fa(j-1|0,k)|0)<<3)>>3];c[f+80>>2]=1;p=0;while(1){if(!(p>>>0<(j-1|0)>>>0)){break}q=+h[a+((fa(p,k)|0)<<3)>>3];r=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(r>n){if((dA(r,o)|0)!=0){break}s=(c[f+24>>2]|0)==3;t=(dA(q,r)|0)!=0;if(s){if(t){break}n=r;s=f+80|0;c[s>>2]=(c[s>>2]|0)+1;break}else{if(!t){break}n=r;t=f+80|0;c[t>>2]=(c[t>>2]|0)+1;break}}}while(0);p=p+1|0}c[f+96>>2]=daa(c[f+80>>2]|0,8)|0;if((c[f+96>>2]|0)==0){VI(37616);l=b;m=l;i=d;return+m}n=+h[a>>3];t=0;p=0;if((c[f+24>>2]|0)==3){while(1){if(!(p>>>0<(j-1|0)>>>0)){break a}if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break a}o=+h[a+((fa(p,k)|0)<<3)>>3];r=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(r>n){if((dA(o,r)|0)!=0){c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1;break}else{n=r;c[(c[f+96>>2]|0)+(t<<3)>>2]=p;c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1;t=t+1|0;break}}else{c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1}}while(0);p=p+1|0}}while(1){if(!(p>>>0<(j-1|0)>>>0)){break a}if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break a}r=+h[a+((fa(p,k)|0)<<3)>>3];o=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(o>n){if((dA(r,o)|0)==0){c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1;break}n=o;c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p;t=t+1|0;if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break}c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1}else{c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1}}while(0);p=p+1|0}}}while(0);e=e- +h[f+48>>3];b:do{if(e<0.0){b=0.0}else{if(!(j>>>0>1)){break}n=+h[a>>3];o=+h[a+((fa(j-1|0,k)|0)<<3)>>3];r=o-n;if((c[f+28>>2]|0)!=3){if(e<n){b=n;break}if(!(e<o)){break}if((c[f+24>>2]|0)==2){b=o;break}u=bA(a,j,k,c[f+20>>2]|0,e+1.0e-10*r)|0;b=o;v=u+1|0;while(1){if(!(v>>>0<(j-1|0)>>>0)){break b}w=+h[a+((fa(v,k)|0)<<3)>>3];if(w>e){q=+h[a+((fa(v+1|0,k)|0)<<3)>>3];x=w;if((c[f+24>>2]|0)==3){g=83;break}if((dA(x,q)|0)!=0){g=85;break}}v=v+1|0}if((g|0)==83){b=x;break}else if((g|0)==85){b=w;break}}if((c[f+84>>2]|0)!=0){c[f+84>>2]=1+(((c[f+84>>2]|0)>>>0)%((c[f+80>>2]|0)>>>0)|0);if((c[f+84>>2]|0)==(c[f+80>>2]|0)){b=o+ +h[f+88>>3];p=f+88|0;h[p>>3]=+h[p>>3]+r;break}else{v=c[(c[f+96>>2]|0)+((c[f+84>>2]|0)-1<<3)+4>>2]|0;q=+h[a+((fa(v,k)|0)<<3)>>3];b=q+ +h[f+88>>3];break}}q=n;h[f+88>>3]=+T(+((e-n)/r))*r;e=e- +h[f+88>>3];do{if(e<n){e=e+r}else{if(!(e>o)){break}e=e-r}}while(0);u=bA(a,j,k,c[f+20>>2]|0,e+1.0e-10*r)|0;b=o;v=u+1|0;while(1){if(!(v>>>0<(j-1|0)>>>0)){break}y=+h[a+((fa(v,k)|0)<<3)>>3];n=+h[a+((fa(v+1|0,k)|0)<<3)>>3];if(y>e){z=y;if((c[f+24>>2]|0)==3){g=52;break}if((dA(z,n)|0)!=0){g=54;break}}v=v+1|0}if((g|0)==52){b=z}else if((g|0)==54){b=y}c[f+84>>2]=1;if(u>>>0<(j-1|0)>>>0){A=u}else{A=j-1|0}p=A;v=0;while(1){if(!(v>>>0<p>>>0)){break}n=+h[a+((fa(v,k)|0)<<3)>>3];B=+h[a+((fa(v+1|0,k)|0)<<3)>>3];do{if(B>q){if((dA(B,o)|0)!=0){break}t=(c[f+24>>2]|0)==3;s=(dA(n,B)|0)!=0;if(t){if(s){break}q=B;t=f+84|0;c[t>>2]=(c[t>>2]|0)+1;break}else{if(!s){break}q=B;s=f+84|0;c[s>>2]=(c[s>>2]|0)+1;break}}}while(0);v=v+1|0}b=b+ +h[f+88>>3];if((c[f+84>>2]|0)!=(c[f+80>>2]|0)){break}p=f+88|0;h[p>>3]=+h[p>>3]+r}}while(0);if(b<1.7976931348623157e+308){b=b+ +h[f+48>>3]}if(!(b>+h[f+64>>3])){break}h[f+64>>3]=b;k=f+60|0;c[k>>2]=(c[k>>2]|0)+1}else{g=91}}while(0);if((g|0)==91){VI(37760)}l=b;m=l;i=d;return+m}function hA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,h=0.0;e=i;i=i+40|0;f=b;b=d;d=a;do{if((d|0)!=0){if((c[d+32>>2]|0)!=1){break}if((f|0)==0){if((c[d+8>>2]|0)!=0){break}}if((c[d+8>>2]|0)!=0){caa(c[d+8>>2]|0)}c[d+8>>2]=iA(c[d+4>>2]|0,c[d>>2]|0,d+12|0,d+16|0,b,f)|0;if((c[d+8>>2]|0)==0){g=0.0;h=g;i=e;return+h}do{if((c[d+24>>2]|0)==2){if((c[d+12>>2]|0)!=2){break}c[d+24>>2]=1}}while(0);if((Xz(d)|0)!=0){if((c[d+24>>2]|0)!=2){break}$z(c[d+56>>2]|0);c[d+56>>2]=Yz(c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+36>>2]|0,c[d+40>>2]|0)|0;break}else{g=0.0;h=g;i=e;return+h}}}while(0);g=1.0;h=g;i=e;return+h}function iA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;j=a;a=b;b=d;d=e;e=f;f=0;if((j|0)==0){k=f;i=g;return k|0}if((a|0)==0){k=f;i=g;return k|0}if((b|0)==0){k=f;i=g;return k|0}if((d|0)==0){k=f;i=g;return k|0}l=0;m=Va(a|0,46)|0;do{if((m|0)!=0){if(0!=(Caa(m,37856,4)|0)){if(0!=(Caa(m,37864,4)|0)){break}}l=1}}while(0);if((e|0)==1){c[h>>2]=j;c[h+4>>2]=a;TI(37872,h)}h=j;j=a;a=b;b=d;if((l|0)!=0){f=jA(h,j,a,b)|0;k=f;i=g;return k|0}else{f=kA(h,j,a,b)|0;k=f;i=g;return k|0}return 0}function jA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=a;a=b;b=d;d=e;e=0;do{if((n|0)!=0){if((a|0)==0){break}if((b|0)==0){break}if((d|0)==0){break}o=0;p=lB(a,0)|0;if((p|0)==0){c[m>>2]=a;XI(37912,m);q=0;r=q;i=f;return r|0}s=wB(p,n)|0;if((s|0)==0){oB(p)|0;c[l>>2]=n;c[l+4>>2]=a;XI(38400,l);q=0;r=q;i=f;return r|0}t=s;if((c[s+4>>2]|0)!=2){pB(t);oB(p)|0;c[k>>2]=n;XI(38624,k);q=0;r=q;i=f;return r|0}u=s;if((c[t+16>>2]|0)!=6){pB(u);oB(p)|0;c[j>>2]=n;XI(38672,j);q=0;r=q;i=f;return r|0}t=s;if((c[u+20>>2]|0)!=0){pB(t);oB(p)|0;c[h>>2]=n;XI(38736,h);q=0;r=q;i=f;return r|0}e=baa((fa(c[c[t+32>>2]>>2]|0,c[(c[s+32>>2]|0)+4>>2]|0)|0)<<3)|0;t=s;if((e|0)==0){pB(t);oB(p)|0;VI(37616);q=0;r=q;i=f;return r|0}u=c[c[t+32>>2]>>2]|0;t=c[(c[s+32>>2]|0)+4>>2]|0;v=0;while(1){if((o|0)!=0){break}if(!(v>>>0<u>>>0)){break}o=rB(p,s,e+((fa(v,t)|0)<<3)|0,v,u,t)|0;v=v+1|0}pB(s);oB(p)|0;if((o|0)==0){c[b>>2]=u;c[d>>2]=t;break}caa(e);c[b>>2]=0;c[d>>2]=0;c[g>>2]=n;c[g+4>>2]=u;c[g+8>>2]=t;c[g+12>>2]=a;XI(38776,g);q=0;r=q;i=f;return r|0}}while(0);q=e;r=q;i=f;return r|0}function kA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=i;i=i+24|0;j=g;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b;b=d;d=e;e=f;f=0;do{if((u|0)!=0){if((b|0)==0){break}if((d|0)==0){break}if((e|0)==0){break}c[s>>2]=64;v=0;w=0;x=0;y=1;z=mc(b|0,37904)|0;if((z|0)==0){c[q>>2]=b;XI(37912,q);A=0;B=A;i=g;return B|0}c[r>>2]=baa(64)|0;C=z;if((c[r>>2]|0)==0){cd(C|0)|0;VI(37616);A=0;B=A;i=g;return B|0}D=lA(r,s,C)|0;C=D;E=c[r>>2]|0;if((D|0)!=0){caa(E);cd(z|0)|0;if((C|0)<0){c[p>>2]=b;XI(37976,p)}A=0;B=A;i=g;return B|0}if(0!=(Caa(E,38040,2)|0)){E=Faa(c[r>>2]|0)|0;do{if((E|0)==0){caa(c[r>>2]|0);cd(z|0)|0;c[o>>2]=b;XI(38048,o)}else{D=a[c[r>>2]|0]|0;if((E|0)==1){caa(c[r>>2]|0);cd(z|0)|0;c[n>>2]=b;c[n+4>>2]=D<<24>>24;XI(38144,n);break}else{F=a[(c[r>>2]|0)+1|0]|0;caa(c[r>>2]|0);cd(z|0)|0;c[m>>2]=b;c[m+4>>2]=D<<24>>24;c[m+8>>2]=F<<24>>24;XI(38256,m);break}}}while(0);A=0;B=A;i=g;return B|0}E=c[(jc()|0)>>2]|0;while(1){if((lA(r,s,z)|0)!=0){break}y=y+1|0;G=Yb(c[r>>2]|0,38368)|0;if((G|0)==0){continue}if(0!=(Baa(G,38376)|0)){if(0!=(Baa(G,38384)|0)){continue}}G=Yb(0,38368)|0;if((G|0)==0){continue}if(0!=(Baa(G,u)|0)){continue}v=1;G=Yb(0,38368)|0;if((G|0)==0){continue}w=Wb(G|0,t|0,10)|0;if((a[c[t>>2]|0]|0)!=0){continue}G=Yb(0,38368)|0;if((G|0)==0){continue}x=Wb(G|0,t|0,10)|0;if((a[c[t>>2]|0]|0)==0){H=31;break}}a:do{if((H|0)==31){F=0;D=0;f=baa((fa(w,x)|0)<<3)|0;if((f|0)==0){c[d>>2]=0;c[e>>2]=0;caa(c[r>>2]|0);cd(z|0)|0;VI(37616);A=f;B=A;i=g;return B|0}while(1){if((C|0)!=0){break a}if(!(F>>>0<w>>>0)){break a}I=0;y=y+1|0;J=lA(r,s,z)|0;C=J;if((J|0)!=0){break a}while(1){if((I|0)>=((c[s>>2]|0)-1|0)){break}if((a[(c[r>>2]|0)+I|0]|0)!=32){if((a[(c[r>>2]|0)+I|0]|0)!=9){break}}I=I+1|0}if((a[(c[r>>2]|0)+I|0]|0)==0){continue}if((a[(c[r>>2]|0)+I|0]|0)==35){continue}G=Yb((c[r>>2]|0)+I|0,38392)|0;b:while(1){if(!(F>>>0<w>>>0)){break}if(!(D>>>0<x>>>0)){break}if((G|0)==0){break}if((a[G]|0)==35){break}J=G;do{if((a[E]|0)==46){h[f+((fa(F,x)|0)+D<<3)>>3]=+yaa(J,t)}else{K=G;if(0==(dc(J|0,46)|0)){h[f+((fa(F,x)|0)+D<<3)>>3]=+yaa(K,t);break}L=baa((Faa(K|0)|0)+1|0)|0;if((L|0)==0){H=55;break b}Laa(L|0,G|0)|0;K=dc(L|0,46)|0;a[K]=a[E]|0;h[f+((fa(F,x)|0)+D<<3)>>3]=+yaa(L,t);if((a[c[t>>2]|0]|0)!=0){C=1}caa(L)}}while(0);J=D+1|0;D=J;if((J|0)==(x|0)){F=F+1|0;D=0}if((C|0)!=0){break}G=Yb(0,38392)|0}if((H|0)==55){H=0;c[d>>2]=0;c[e>>2]=0;caa(c[r>>2]|0);cd(z|0)|0;C=1;VI(37616)}if((G|0)==0){continue}if((a[G]|0)!=35){break}}C=1}}while(0);caa(c[r>>2]|0);cd(z|0)|0;if((v|0)==0){c[l>>2]=u;c[l+4>>2]=b;XI(38400,l);A=f;B=A;i=g;return B|0}if((C|0)==0){c[d>>2]=w;c[e>>2]=x;break}caa(f);f=0;c[d>>2]=0;c[e>>2]=0;if((C|0)==-1){c[k>>2]=u;c[k+4>>2]=w;c[k+8>>2]=x;c[k+12>>2]=b;XI(38448,k);break}else{c[j>>2]=y;c[j+4>>2]=u;c[j+8>>2]=w;c[j+12>>2]=x;c[j+16>>2]=b;XI(38536,j);break}}}while(0);A=f;B=A;i=g;return B|0}function lA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=b;b=d;d=e;if((de(c[g>>2]|0,c[b>>2]|0,d|0)|0)==0){h=-1;j=h;i=f;return j|0}e=dc(c[g>>2]|0,10)|0;k=e;if((e|0)!=0){a[k]=0;h=0;j=h;i=f;return j|0}while(1){e=dc(c[g>>2]|0,10)|0;k=e;if((e|0)!=0){l=6;break}e=c[b>>2]|0;m=b;c[m>>2]=c[m>>2]<<1;m=eaa(c[g>>2]|0,c[b>>2]|0)|0;if((m|0)==0){l=8;break}c[g>>2]=m;if((de((c[g>>2]|0)+(e-1)|0,e+1|0,d|0)|0)==0){l=10;break}}if((l|0)==6){a[k]=0;h=0;j=h;i=f;return j|0}else if((l|0)==8){VI(37616);h=1;j=h;i=f;return j|0}else if((l|0)==10){h=0;j=h;i=f;return j|0}return 0}function mA(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+32|0;d=b;b=0;a:do{if((d|0)!=0){if((Baa(d,38936)|0)==0){break}e=Faa(d|0)|0;f=0;while(1){if(!(f>>>0<e>>>0)){break a}if((a[d+f|0]|0)!=32){break}f=f+1|0}b=1}}while(0);i=c;return b|0}function nA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=b;b=f;g=c[b+4>>2]|0;h=e;c[h>>2]=c[b>>2];c[h+4>>2]=g;g=e;a[g]=a[g]^a[e+7|0];g=e+7|0;a[g]=a[g]^a[e];g=e;a[g]=a[g]^a[e+7|0];g=e+1|0;a[g]=a[g]^a[e+6|0];g=e+6|0;a[g]=a[g]^a[e+1|0];g=e+1|0;a[g]=a[g]^a[e+6|0];g=e+2|0;a[g]=a[g]^a[e+5|0];g=e+5|0;a[g]=a[g]^a[e+2|0];g=e+2|0;a[g]=a[g]^a[e+5|0];g=e+3|0;a[g]=a[g]^a[e+4|0];g=e+4|0;a[g]=a[g]^a[e+3|0];g=e+3|0;a[g]=a[g]^a[e+4|0];g=e;e=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=e;e=f;J=c[e+4>>2]|0;i=d;return c[e>>2]|0}function oA(b){b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=b;b=g;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=f;a[h]=(d[h]|0)^(d[f+7|0]|0);h=f+7|0;a[h]=(d[h]|0)^(d[f]|0);h=f;a[h]=(d[h]|0)^(d[f+7|0]|0);h=f+1|0;a[h]=(d[h]|0)^(d[f+6|0]|0);h=f+6|0;a[h]=(d[h]|0)^(d[f+1|0]|0);h=f+1|0;a[h]=(d[h]|0)^(d[f+6|0]|0);h=f+2|0;a[h]=(d[h]|0)^(d[f+5|0]|0);h=f+5|0;a[h]=(d[h]|0)^(d[f+2|0]|0);h=f+2|0;a[h]=(d[h]|0)^(d[f+5|0]|0);h=f+3|0;a[h]=(d[h]|0)^(d[f+4|0]|0);h=f+4|0;a[h]=(d[h]|0)^(d[f+3|0]|0);h=f+3|0;a[h]=(d[h]|0)^(d[f+4|0]|0);h=f;f=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=f;f=g;J=c[f+4>>2]|0;i=e;return c[f>>2]|0}function pA(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=b;c[e>>2]=c[f>>2];b=e;a[b]=a[b]^a[e+3|0];b=e+3|0;a[b]=a[b]^a[e];b=e;a[b]=a[b]^a[e+3|0];b=e+1|0;a[b]=a[b]^a[e+2|0];b=e+2|0;a[b]=a[b]^a[e+1|0];b=e+1|0;a[b]=a[b]^a[e+2|0];c[f>>2]=c[e>>2];i=d;return c[f>>2]|0}function qA(b){b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=b;c[f>>2]=c[g>>2];b=f;a[b]=(d[b]|0)^(d[f+3|0]|0);b=f+3|0;a[b]=(d[b]|0)^(d[f]|0);b=f;a[b]=(d[b]|0)^(d[f+3|0]|0);b=f+1|0;a[b]=(d[b]|0)^(d[f+2|0]|0);b=f+2|0;a[b]=(d[b]|0)^(d[f+1|0]|0);b=f+1|0;a[b]=(d[b]|0)^(d[f+2|0]|0);c[g>>2]=c[f>>2];i=e;return c[g>>2]|0}function rA(c){c=c|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=c;b[e>>1]=b[f>>1]|0;c=e;a[c]=a[c]^a[e+1|0];c=e+1|0;a[c]=a[c]^a[e];c=e;a[c]=a[c]^a[e+1|0];b[f>>1]=b[e>>1]|0;i=d;return b[f>>1]|0}function sA(c){c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=c;b[f>>1]=b[g>>1]|0;c=f;a[c]=(d[c]|0)^(d[f+1|0]|0);c=f+1|0;a[c]=(d[c]|0)^(d[f]|0);c=f;a[c]=(d[c]|0)^(d[f+1|0]|0);b[g>>1]=b[f>>1]|0;i=e;return b[g>>1]|0}function tA(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c+8|0;e=b;g[d>>2]=+g[e>>2];b=d;a[b]=a[b]^a[d+3|0];b=d+3|0;a[b]=a[b]^a[d];b=d;a[b]=a[b]^a[d+3|0];b=d+1|0;a[b]=a[b]^a[d+2|0];b=d+2|0;a[b]=a[b]^a[d+1|0];b=d+1|0;a[b]=a[b]^a[d+2|0];g[e>>2]=+g[d>>2];i=c;return+(+g[e>>2])}function uA(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c+8|0;e=b;h[d>>3]=+h[e>>3];b=d;a[b]=a[b]^a[d+7|0];b=d+7|0;a[b]=a[b]^a[d];b=d;a[b]=a[b]^a[d+7|0];b=d+1|0;a[b]=a[b]^a[d+6|0];b=d+6|0;a[b]=a[b]^a[d+1|0];b=d+1|0;a[b]=a[b]^a[d+6|0];b=d+2|0;a[b]=a[b]^a[d+5|0];b=d+5|0;a[b]=a[b]^a[d+2|0];b=d+2|0;a[b]=a[b]^a[d+5|0];b=d+3|0;a[b]=a[b]^a[d+4|0];b=d+4|0;a[b]=a[b]^a[d+3|0];b=d+3|0;a[b]=a[b]^a[d+4|0];h[e>>3]=+h[d>>3];i=c;return+(+h[e>>3])}function vA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+512|0;j=i;i=i+512|0;k=a;a=b;b=d;d=0;l=0;if((b|0)<1){m=0;n=m;i=e;return n|0}o=(b|0)<512?b:512;if((c[a+4>>2]|0)==0){c[a>>2]=h;p=sb(h|0,1,o|0,c[k>>2]|0)|0;q=a+4|0;c[q>>2]=(c[q>>2]|0)+p;d=d+(c[a+4>>2]|0)|0}c[a+16>>2]=o;c[a+12>>2]=j;p=NB(a,3)|0;if((p|0)==1){m=d;n=m;i=e;return n|0}if((p|0)!=0){c[g>>2]=p;wA(39432,g);m=d;n=m;i=e;return n|0}if((c[a+16>>2]|0)==0){l=l+o|0;if((b-l|0)<512){r=b-l|0}else{r=512}o=r;c[a+16>>2]=o;c[a+12>>2]=j}while(1){if((l|0)>=(b|0)){break}if((c[a+4>>2]|0)==0){c[a>>2]=h;r=sb(h|0,1,o|0,c[k>>2]|0)|0;g=a+4|0;c[g>>2]=(c[g>>2]|0)+r;d=d+(c[a+4>>2]|0)|0}p=NB(a,3)|0;if((p|0)==1){break}if((p|0)!=0){s=18;break}if((c[a+16>>2]|0)!=0){continue}l=l+o|0;if((b-l|0)<512){t=b-l|0}else{t=512}o=t;c[a+16>>2]=o;c[a+12>>2]=j}if((s|0)==18){c[f>>2]=p;wA(39432,f)}if((c[a+4>>2]|0)!=0){$c(c[k>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;d=d-(c[a+4>>2]|0)|0;c[a+4>>2]=0}m=d;n=m;i=e;return n|0}function wA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;f=i;i=i+16|0;c[f>>2]=b;b=IA(a,f)|0;c[e>>2]=b;XI(39984,e);caa(b);i=d;return}function xA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=a;a=b;b=c;c=d;d=0;a:do{if((f|0)==0){g=3}else{if((a|0)==0){g=3;break}if((c|0)<1){h=0;break}switch(b|0){case 7:{d=4;break};case 13:{d=8;break};case 2:{d=1;break};case 6:{d=4;break};case 1:{d=1;break};case 12:{d=8;break};case 5:{d=4;break};case 9:{d=8;break};case 3:{d=2;break};case 4:{d=2;break};default:{h=0;break a}}vA(f,a,fa(c,d)|0)|0;h=c}}while(0);if((g|0)==3){h=0}i=e;return h|0}function yA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39472,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39472,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function zA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=16;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39512,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39512,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function AA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+32|0;m=i;i=i+8|0;n=a;a=b;b=d;d=0;if((b|0)==0){o=0;p=o;i=e;return p|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[n>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;q=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){c[k>>2]=q;wA(39552,k);o=d;p=o;i=e;return p|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)==0){break}if(!((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1)){break}c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[n>>2]|0)|0)|0;q=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){r=10;break}}if((r|0)==10){c[j>>2]=q;wA(39552,j);o=d;p=o;i=e;return p|0}c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];if((c[n+20>>2]|0)!=0){pA(m)|0;pA(m+4|0)|0}if((c[m>>2]&65535|0)!=5){wA(39592,h);o=d;p=o;i=e;return p|0}h=c[m+4>>2]|0;if(((h|0)%8|0|0)!=0){s=8-((h|0)%8|0)|0}else{s=0}h=h+s|0;if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[n>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=h;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b+8;q=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){c[g>>2]=q;wA(39552,g);o=d;p=o;i=e;return p|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){t=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{t=0}u=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!t){break}c[u>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[n>>2]|0)|0)|0;q=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){r=26;break}}if((r|0)==26){c[f>>2]=q;wA(39552,f);o=d;p=o;i=e;return p|0}if((c[u>>2]|0)!=0){$c(c[n>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}o=d;p=o;i=e;return p|0}function BA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39656,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39656,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function CA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+32|0;k=a;a=b;b=d;d=0;if((b|0)==0){l=0;m=l;i=f;return m|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=j;d=d+(sb(j|0,1,1,c[k>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=e;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[h>>2]=b;wA(39696,h);l=d;m=l;i=f;return m|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){n=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{n=0}o=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!n){break}c[o>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=j;d=d+(sb(j|0,1,1,c[k>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){p=11;break}}if((p|0)==11){c[g>>2]=b;wA(39696,g);l=d;m=l;i=f;return m|0}if((c[o>>2]|0)!=0){$c(c[k>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}l=d;m=l;i=f;return m|0}function DA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[a+4>>2]|0)==0){c[a+4>>2]=1;c[a>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[a+16>>2]=4;c[a+12>>2]=b;b=NB(a,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39736,g);k=d;l=k;i=e;return l|0}while(1){if((c[a+16>>2]|0)!=0){m=(c[a+4>>2]|0)!=0^1}else{m=0}n=a+4|0;if(!m){break}c[n>>2]=1;c[a>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(a,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39736,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;d=d-(c[a+4>>2]|0)|0;c[a+4>>2]=0}k=d;l=k;i=e;return l|0}function EA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+1024|0;l=a;a=b;b=d;d=e;e=0;if((b|0)==0){m=0;n=m;i=f;return n|0}if((d|0)<1){wA(39776,j);m=e;n=m;i=f;return n|0}do{if((c[a+4>>2]|0)==0){j=k;if((d|0)>1024){c[a+4>>2]=sb(j|0,1,1024,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}else{c[a+4>>2]=sb(j|0,1,d|0,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}}}while(0);c[a+16>>2]=d;c[a+12>>2]=b;b=NB(a,3)|0;if((b|0)==1){m=e;n=m;i=f;return n|0}if((b|0)!=0){c[h>>2]=b;wA(39808,h);m=e;n=m;i=f;return n|0}while(1){if((c[a+16>>2]|0)==0){break}if(!((c[a+4>>2]|0)!=0^1)){break}do{if((d-e|0)>1024){c[a+4>>2]=sb(k|0,1,1024,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k}else{h=k;if((d-e|0)<1){c[a+4>>2]=sb(h|0,1,1,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}else{c[a+4>>2]=sb(h|0,1,d-e|0,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}}}while(0);b=NB(a,3)|0;if((b|0)==1){break}if((b|0)!=0&(b|0)!=-5){o=22;break}}if((o|0)==22){c[g>>2]=b;wA(39808,g)}if((c[a+4>>2]|0)!=0){$c(c[l>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;e=e-(c[a+4>>2]|0)|0;c[a+4>>2]=0}m=e;n=m;i=f;return n|0}function FA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39848,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39848,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function GA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;wA(39896,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(sb(h|0,1,1,c[j>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;wA(39896,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function HA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+32|0;m=a;a=b;b=d;d=0;if((b|0)==0){n=0;o=n;i=h;return o|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[m>>2]|0)|0)|0}p=(fa(e,f)|0)+g|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=p;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[k>>2]=b;wA(39944,k);n=d;o=n;i=h;return o|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){q=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{q=0}r=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!q){break}c[r>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(sb(l|0,1,1,c[m>>2]|0)|0)|0;b=NB(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){s=11;break}}if((s|0)==11){c[j>>2]=b;wA(39944,j);n=d;o=n;i=h;return o|0}if((c[r>>2]|0)!=0){$c(c[m>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}n=d;o=n;i=h;return o|0}function IA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+56|0;e=d+24|0;f=a;a=b;c[e>>2]=c[a>>2];b=(JA(0,0,f,e)|0)+1|0;e=baa(b+1|0)|0;if((e|0)!=0){JA(e,b,f,a)|0;g=e;h=g;i=d;return h|0}else{g=0;h=g;i=d;return h|0}return 0}function JA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=hB(a,b,c,d)|0;i=e;return f|0}function KA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d+16|0;c[e>>2]=b;b=IA(a,e)|0;i=d;return b|0}function LA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;f=i;i=i+16|0;c[f>>2]=b;b=IA(a,f)|0;c[e>>2]=b;TI(39984,e);caa(b);i=d;return}function MA(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;switch(a|0){case 2:{c=1;break};case 12:{c=8;break};case 7:{c=4;break};case 9:{c=8;break};case 6:{c=4;break};case 1:{c=1;break};case 3:{c=2;break};case 13:{c=8;break};case 5:{c=4;break};case 4:{c=2;break};default:{c=0}}i=b;return c|0}



function YB(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+40|0;g=a;a=b;b=e;e=(g>>>24&255)+(g>>>8&65280)+((g&65280)<<8)+((g&255)<<24)|0;e=~e;while(1){if((b|0)==0){break}if((a&3|0)==0){break}g=a;a=g+1|0;e=c[48e3+((e>>>24^(d[g]|0))<<2)>>2]^e<<8;b=b+ -1|0}g=a;g=g+ -4|0;while(1){if(!(b>>>0>=32)){break}h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];b=b-32|0}while(1){h=g+4|0;g=h;if(!(b>>>0>=4)){break}e=e^c[h>>2];e=c[48e3+((e&255)<<2)>>2]^c[49024+((e>>>8&255)<<2)>>2]^c[50048+((e>>>16&255)<<2)>>2]^c[51072+(e>>>24<<2)>>2];b=b-4|0}a=g;if((b|0)==0){j=e;k=~j;e=k;l=e;m=l>>>24;n=m&255;o=e;p=o>>>8;q=p&65280;r=n+q|0;s=e;t=s&65280;u=t<<8;v=r+u|0;w=e;x=w&255;y=x<<24;z=v+y|0;i=f;return z|0}do{g=a;a=g+1|0;e=c[48e3+((e>>>24^(d[g]|0))<<2)>>2]^e<<8;g=b+ -1|0;b=g;}while((g|0)!=0);j=e;k=~j;e=k;l=e;m=l>>>24;n=m&255;o=e;p=o>>>8;q=p&65280;r=n+q|0;s=e;t=s&65280;u=t<<8;v=r+u|0;w=e;x=w&255;y=x<<24;z=v+y|0;i=f;return z|0}function ZB(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=i;i=i+184|0;j=h+144|0;k=f;f=c[k+28>>2]|0;l=(c[k>>2]|0)+ -1|0;m=l+((c[k+4>>2]|0)-5)|0;n=(c[k+12>>2]|0)+ -1|0;o=n+(0-(g-(c[k+16>>2]|0)))|0;g=n+((c[k+16>>2]|0)-257)|0;p=c[f+40>>2]|0;q=c[f+44>>2]|0;r=c[f+48>>2]|0;s=c[f+52>>2]|0;t=c[f+56>>2]|0;u=c[f+60>>2]|0;v=c[f+76>>2]|0;w=c[f+80>>2]|0;x=(1<<c[f+84>>2])-1|0;y=(1<<c[f+88>>2])-1|0;a:do{if(u>>>0<15){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0;z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}z=j;A=v+((t&x)<<2)|0;b[z+0>>1]=b[A+0>>1]|0;b[z+2>>1]=b[A+2>>1]|0;while(1){B=d[j+1|0]|0;t=t>>>B;u=u-B|0;B=d[j]|0;if((B|0)==0){C=6;break}if((B&16|0)!=0){C=8;break}if((B&64|0)!=0){C=55;break a}A=j;z=v+((e[j+2>>1]|0)+(t&(1<<B)-1)<<2)|0;b[A+0>>1]=b[z+0>>1]|0;b[A+2>>1]=b[z+2>>1]|0}do{if((C|0)==6){C=0;z=n+1|0;n=z;a[z]=b[j+2>>1]}else if((C|0)==8){C=0;D=e[j+2>>1]|0;B=B&15;if((B|0)!=0){if(u>>>0<B>>>0){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}D=D+(t&(1<<B)-1)|0;t=t>>>B;u=u-B|0}if(u>>>0<15){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0;z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}z=j;A=w+((t&y)<<2)|0;b[z+0>>1]=b[A+0>>1]|0;b[z+2>>1]=b[A+2>>1]|0;while(1){B=d[j+1|0]|0;t=t>>>B;u=u-B|0;B=d[j]|0;if((B&16|0)!=0){break}if((B&64|0)!=0){C=52;break a}A=j;z=w+((e[j+2>>1]|0)+(t&(1<<B)-1)<<2)|0;b[A+0>>1]=b[z+0>>1]|0;b[A+2>>1]=b[z+2>>1]|0}z=e[j+2>>1]|0;B=B&15;do{if(u>>>0<B>>>0){A=l+1|0;l=A;t=t+((d[A]|0)<<u)|0;u=u+8|0;if(!(u>>>0<B>>>0)){break}A=l+1|0;l=A;t=t+((d[A]|0)<<u)|0;u=u+8|0}}while(0);z=z+(t&(1<<B)-1)|0;t=t>>>B;u=u-B|0;B=n-o|0;if(!(z>>>0>B>>>0)){E=n+(0-z)|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;D=D-3|0;}while(D>>>0>2);if((D|0)==0){break}A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;if(!(D>>>0>1)){break}A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;break}B=z-B|0;if(B>>>0>q>>>0){if((c[f+7104>>2]|0)!=0){C=22;break a}}E=s+ -1|0;do{if((r|0)==0){E=E+(p-B)|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0}else{if(!(r>>>0<B>>>0)){E=E+(r-B)|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0;break}E=E+(p+r-B)|0;B=B-r|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=s+ -1|0;if(!(r>>>0<D>>>0)){break}B=r;D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0}}while(0);while(1){if(!(D>>>0>2)){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;D=D-3|0}if((D|0)==0){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;if(!(D>>>0>1)){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0}}while(0);if(!(l>>>0<m>>>0)){break}}while(n>>>0<g>>>0);do{if((C|0)==22){c[k+24>>2]=52096;c[f>>2]=29}else if((C|0)==52){c[k+24>>2]=52128;c[f>>2]=29}else if((C|0)==55){if((B&32|0)!=0){c[f>>2]=11;break}else{c[k+24>>2]=52152;c[f>>2]=29;break}}}while(0);D=u>>>3;l=l+(0-D)|0;u=u-(D<<3)|0;t=t&(1<<u)-1;c[k>>2]=l+1;c[k+12>>2]=n+1;if(l>>>0<m>>>0){G=5+(m-l)|0}else{G=5-(l-m)|0}c[k+4>>2]=G;if(n>>>0<g>>>0){H=257+(g-n)|0;I=k;J=I;K=J+16|0;L=K;c[L>>2]=H;M=t;N=f;O=N;P=O+56|0;Q=P;c[Q>>2]=M;R=u;S=f;T=S;U=T+60|0;V=U;c[V>>2]=R;i=h;return}else{H=257-(n-g)|0;I=k;J=I;K=J+16|0;L=K;c[L>>2]=H;M=t;N=f;O=N;P=O+56|0;Q=P;c[Q>>2]=M;R=u;S=f;T=S;U=T+60|0;V=U;c[V>>2]=R;i=h;return}}function _B(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function $B(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function aC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function bC(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(52184,n|0)|0;i=m;return 0}function cC(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=CJ(a,52192)|0;z=CJ(b,52192)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((CJ(a,52200)|0)!=0){C=5;break}if((CJ(a,52208)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((CJ(b,52200)|0)!=0){break}if((CJ(b,52208)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){Jaa(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Jaa(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}Jaa(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(52216,r|0)|0;i=q;return 0}function dC(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(CJ(a,52224)|0)!=0;v=c[(u?f:g)>>2]|0;w=CJ(e,52232)|0;x=CJ(b,52240)|0;c[p>>2]=0;do{if(u){y=4}else{if((CJ(a,52248)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((CJ(b,52224)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((CJ(d,52232)|0)==0){if((CJ(d,52256)|0)!=0){break}if((CJ(d,52264)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((CJ(e,52240)|0)==0){if((CJ(e,52232)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){Jaa(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(CJ(d,52232)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(52272,p|0)|0;i=o;return 0}function eC(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}gC(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}hC(52288,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(52280,l|0)|0;i=k;return 0}function fC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+jJ(52312);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(_B(l,z,52320)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){aC(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;$B(l,n,d+(x-o+v<<3)|0,52320)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;bC(l,m,52328,d+(B+y<<3)|0,52320,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(52304,k|0)|0;i=j;return 0}function gC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=52360;u=jC(52344,52336,52352,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;fC(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;iC(k,d,e,m,l,f,52344)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;iC(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,52344)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;dC(52368,52376,52384,52400,n,k,52408,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=52384;cC(H,H,k,l,n,52416,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,52408,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);fC(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(52336,j|0)|0;i=h;return 0}function hC(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(CJ(a,52424)|0)!=0;do{if(n){o=5}else{if((CJ(a,52432)|0)!=0){o=5;break}if((CJ(a,52440)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=52456;iC(d,h,j,q,b,g,q)|0;dC(52464,52472,52480,52496,b,d,52504,e,f,h,j)|0;dC(52464,52512,52480,52520,b,d,52504,e,f,h,j)|0;i=l;return 0}else{dC(52464,52512,52536,52520,b,d,52504,e,f,h,j)|0;dC(52464,52472,52536,52496,b,d,52504,e,f,h,j)|0;iC(d,h,j,52456,b,g,52552)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(52448,m|0)|0;i=l;return 0}function iC(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function jC(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=Faa(d|0)|0;switch(c[b>>2]|0){case 11:{q=kC(52816,52800,52808)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=lC(b,d,e,f,g,h,j)|0;i=k;return q|0};case 3:case 2:case 1:{h=o;MZ(h,d,1,p);p=a[h]|0;do{if((p+ -97<<24>>24&255)<26){d=p+ -32<<24>>24;a[h]=d;e=o+1|0;r=a[e]|0;if((r+ -97<<24>>24&255)<26){a[e]=r+ -32<<24>>24}r=o+2|0;e=a[r]|0;if((e+ -97<<24>>24&255)<26){a[r]=e+ -32<<24>>24}e=o+3|0;r=a[e]|0;if((r+ -97<<24>>24&255)<26){a[e]=r+ -32<<24>>24}r=o+4|0;e=a[r]|0;if((e+ -97<<24>>24&255)<26){a[r]=e+ -32<<24>>24}e=o+5|0;r=a[e]|0;if(!((r+ -97<<24>>24&255)<26)){s=d;break}a[e]=r+ -32<<24>>24;s=d}else{s=p}}while(0);p=s<<24>>24==83;h=s<<24>>24==68;d=p|h;if(!(s<<24>>24==67|s<<24>>24==68|s<<24>>24==83|s<<24>>24==90)){q=1;i=k;return q|0}r=l;MZ(r,o+1|0,1,2);l=m;MZ(l,o+3|0,1,3);o=n;MZ(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((LZ(r,52560,1,2)|0)==0){if((LZ(l,52576,1,3)|0)==0){q=2;i=k;return q|0}if((LZ(l,52584,1,3)|0)==0){q=2;i=k;return q|0}if((LZ(l,52592,1,3)|0)==0){q=2;i=k;return q|0}if((LZ(l,52600,1,3)|0)==0){q=2;i=k;return q|0}if((LZ(l,52608,1,3)|0)==0){q=2;i=k;return q|0}if((LZ(l,52616,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((LZ(r,52640,1,2)|0)==0){b=(LZ(l,52568,1,3)|0)==0;if(b|(p|h)^1){q=b?8:2;i=k;return q|0}q=2;i=k;return q|0}if(s<<24>>24==67|s<<24>>24==90){t=91}else if(s<<24>>24==68|s<<24>>24==83){t=94}else{q=2;i=k;return q|0}do{if((t|0)==91){if((LZ(r,52664,1,2)|0)==0){q=2;i=k;return q|0}else{if(s<<24>>24==68|s<<24>>24==83){t=94;break}else if(s<<24>>24==67|s<<24>>24==90){break}else{q=2}i=k;return q|0}}}while(0);do{if((t|0)==94){if((LZ(r,52672,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){break}else{q=2}i=k;return q|0}b=a[l]|0;if(b<<24>>24==77){if((LZ(o,52680,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52688,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52696,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52704,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52712,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52720,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(b<<24>>24==71){if((LZ(o,52680,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52688,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52696,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52704,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52712,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52720,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((LZ(r,52736,1,2)|0)!=0){q=2;i=k;return q|0}b=a[l]|0;if(b<<24>>24==71){if((LZ(o,52680,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52688,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52696,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52704,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52712,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52720,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(b<<24>>24==77){if((LZ(o,52680,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52688,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52696,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52704,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52712,1,2)|0)==0){q=2;i=k;return q|0}if((LZ(o,52720,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else if((m|0)==3){if((LZ(r,52560,1,2)|0)==0){if((LZ(l,52576,1,3)|0)==0){q=128;i=k;return q|0}if((LZ(l,52584,1,3)|0)==0){q=128;i=k;return q|0}if((LZ(l,52592,1,3)|0)==0){q=128;i=k;return q|0}if((LZ(l,52600,1,3)|0)==0){q=128;i=k;return q|0}if((LZ(l,52608,1,3)|0)==0){q=128;i=k;return q|0}m=(LZ(l,52616,1,3)|0)==0;q=m?128:0;i=k;return q|0}if((LZ(r,52640,1,2)|0)==0){if(!(s<<24>>24==68|s<<24>>24==83)){q=0;i=k;return q|0}m=(LZ(l,52648,1,3)|0)==0;q=m?32:0;i=k;return q|0}if(s<<24>>24==67|s<<24>>24==90){t=138}else if(s<<24>>24==68|s<<24>>24==83){t=141}else{q=0;i=k;return q|0}do{if((t|0)==138){if((LZ(r,52664,1,2)|0)==0){m=(LZ(l,52648,1,3)|0)==0;q=m?32:0;i=k;return q|0}else{if(s<<24>>24==68|s<<24>>24==83){t=141;break}else if(s<<24>>24==67|s<<24>>24==90){break}else{q=0}i=k;return q|0}}}while(0);do{if((t|0)==141){if((LZ(r,52672,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((LZ(r,52736,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else{if((LZ(r,52560,1,2)|0)==0){if((LZ(l,52568,1,3)|0)==0){q=64;i=k;return q|0}if((LZ(l,52576,1,3)|0)==0){q=32;i=k;return q|0}if((LZ(l,52584,1,3)|0)==0){q=32;i=k;return q|0}if((LZ(l,52592,1,3)|0)==0){q=32;i=k;return q|0}if((LZ(l,52600,1,3)|0)==0){q=32;i=k;return q|0}if((LZ(l,52608,1,3)|0)==0){q=32;i=k;return q|0}if((LZ(l,52616,1,3)|0)==0){q=32;i=k;return q|0}m=(LZ(l,52624,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((LZ(r,52632,1,2)|0)==0){m=(LZ(l,52568,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((LZ(r,52640,1,2)|0)==0){m=(LZ(l,52568,1,3)|0)==0;if(m|d^1){q=m?64:1;i=k;return q|0}m=(LZ(l,52648,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(LZ(l,52656,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(s<<24>>24==68|s<<24>>24==83){t=29}else if(s<<24>>24==67|s<<24>>24==90){if((LZ(r,52664,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){t=48;break}else if(s<<24>>24==68|s<<24>>24==83){t=29;break}else{break}}if((LZ(l,52568,1,3)|0)==0){q=64;i=k;return q|0}if((LZ(l,52648,1,3)|0)==0){q=32;i=k;return q|0}m=(LZ(l,52656,1,3)|0)==0;q=m?64:1;i=k;return q|0}}while(0);do{if((t|0)==29){if((LZ(r,52672,1,2)|0)!=0){if(s<<24>>24==67|s<<24>>24==90){t=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((t|0)==48){if((LZ(r,52736,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((LZ(o,52680,1,2)|0)!=0){if((LZ(o,52688,1,2)|0)==0){break}if((LZ(o,52696,1,2)|0)==0){break}if((LZ(o,52704,1,2)|0)==0){break}if((LZ(o,52712,1,2)|0)==0){break}if((LZ(o,52720,1,2)|0)==0){break}if((LZ(o,52728,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((LZ(r,52744,1,2)|0)==0){if((LZ(l,52568,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((LZ(r,52752,1,2)|0)==0){if((LZ(l,52568,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((LZ(r,52720,1,2)|0)==0){j=(LZ(l,52624,1,3)|0)==0;q=j?64:1;i=k;return q|0}if((LZ(r,52760,1,2)|0)==0){j=(LZ(l,52768,1,3)|0)==0;q=j?64:1;i=k;return q|0}if(!(s<<24>>24==68|s<<24>>24==83)){q=1;i=k;return q|0}if((LZ(r,52776,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};case 6:{r=c[f>>2]|0;f=c[g>>2]|0;q=~~(+(((r|0)>(f|0)?f:r)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 10:{q=kC(52792,52800,52808)|0;i=k;return q|0};default:{q=-1;i=k;return q|0}}return 0}function kC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function lC(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(KZ(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 14:{p=14;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function mC(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=nC(a,0,0)|0;i=b;return c|0}function nC(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=oC(a,b,c,0)|0;i=d;return e|0}function oC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=pe[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=baa(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=50;c[f+8>>2]=210}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=pe[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){me[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=pe[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){me[c[b+20>>2]&255](c[j+392>>2]|0);me[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=zD(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}me[c[j+20>>2]&255](c[j+44>>2]|0);me[c[j+20>>2]&255](c[j+392>>2]|0);me[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;AD(j+416|0,j+12|0);AD(j+440|0,j+12|0);qC(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}tC(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=UD()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=LD()|0}k=j;l=k;i=g;return l|0}function pC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function qC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;bG(f+256|0);if((b|0)!=0){g=rC(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;MD(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function rC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((IC(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function sC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=LC(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=rC(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((IC(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((IC(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((PC(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((IC(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=LC(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function tC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;me[c[e+20>>2]&255](c[g+36>>2]|0);uC(c[g+44>>2]|0,e);me[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;me[c[e+20>>2]&255](f)}uC(c[h+376>>2]|0,e);uC(c[e+372>>2]|0,e);vC(e+416|0);vC(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}wC(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);me[c[e+20>>2]&255](c[e+392>>2]|0);me[c[e+20>>2]&255](c[e+464>>2]|0);me[c[e+20>>2]&255](c[e+8>>2]|0);me[c[e+20>>2]&255](c[e+44>>2]|0);me[c[e+20>>2]&255](c[e+396>>2]|0);me[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){me[c[e+252>>2]&255](c[e+244>>2]|0)}me[c[e+20>>2]&255](e);i=d;return}function uC(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;me[c[a+20>>2]&255](c[b+16>>2]|0);me[c[a+20>>2]&255](b)}i=d;return}function vC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;me[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;me[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function wC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;JC(f,g+20|0);while(1){d=KC(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}me[c[b+8>>2]&255](c[d+20>>2]|0)}OC(g);OC(g+132|0);OC(g+20|0);OC(g+40|0);OC(g+60|0);vC(g+80|0);vC(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;me[m&255](o);i=e;return}me[c[b+8>>2]&255](c[g+184>>2]|0);me[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;me[m&255](o);i=e;return}function xC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function yC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function zC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((AC(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=CC(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{Haa(f|0,b|0,d|0)|0;j=DC(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Oe[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Pe[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function AC(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=xD()|0}if((a[e+236|0]|0)!=0){f=sC(e,54600)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function BC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function CC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;Iaa(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=pe[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;Haa(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;me[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function DC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((AC(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Oe[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Pe[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function EC(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function FC(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Pe[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function GC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Le[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];je[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Le[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[52824+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function IC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;Haa((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=Ee[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=pe[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){Haa(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function JC(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function KC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function LC(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=pe[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){Jaa(c[m>>2]|0,0,g|0)|0;g=MC(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=MC(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((NC(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=pe[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}Jaa(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=MC(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}me[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=pe[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){Jaa(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function MC(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function NC(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function OC(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}me[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}me[e&255](c[d>>2]|0);i=b;return}function PC(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[54408+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[54448+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=Ee[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=pe[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=pe[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}me[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;Haa(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Le[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function QC(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((se[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=wD(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function RC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Oe[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=SC(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}



function qB(){var a=0,b=0,d=0,e=0;a=i;i=i+8|0;b=baa(56)|0;if(0==(b|0)){d=b;i=a;return d|0}c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=baa(36)|0;e=b;if(0==(c[b+52>>2]|0)){caa(e);b=0;d=b;i=a;return d|0}else{c[c[e+52>>2]>>2]=0;c[(c[b+52>>2]|0)+4>>2]=0;c[(c[b+52>>2]|0)+8>>2]=-1;c[(c[b+52>>2]|0)+20>>2]=0;c[(c[b+52>>2]|0)+12>>2]=0;c[(c[b+52>>2]|0)+16>>2]=0;c[(c[b+52>>2]|0)+28>>2]=0;c[(c[b+52>>2]|0)+24>>2]=0;c[(c[b+52>>2]|0)+32>>2]=0;d=b;i=a;return d|0}return 0}function rB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+64|0;j=a;a=b;b=d;d=e;e=f;f=g;g=0;if(!(((c[a+16>>2]|0)+ -6|0)>>>0<10)){k=-1;l=k;i=h;return l|0}m=c[j+16>>2]|0;if((m|0)==16){g=tB(j,a,b,d,e,f)|0}else if((m|0)==512){g=1}else if((m|0)==256){g=sB(j,a,b,d,e,f)|0}k=g;l=k;i=h;return l|0}function sB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+168|0;j=h+88|0;k=h+96|0;l=a;a=b;b=d;d=e;e=f;f=g;g=0;m=1;n=0;if((c[l+16>>2]|0)==16){o=-1;p=o;i=h;return p|0}$c(c[l>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;do{if((c[a+48>>2]|0)==0){sb(j|0,4,2,c[l>>2]|0)|0;if((c[l+20>>2]|0)!=0){pA(j)|0;pA(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){$c(c[l>>2]|0,-4,1)|0;n=4+(c[j>>2]>>16)|0;break}else{n=8+(c[j+4>>2]|0)|0;break}}else{if((c[a+48>>2]|0)!=1){break}c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0;g=RB(k,c[(c[a+52>>2]|0)+32>>2]|0)|0;DA(l,k,j)|0;if((c[l+20>>2]|0)!=0){pA(j)|0;pA(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){n=4+(c[j>>2]>>16)|0;break}DA(l,k,j+4|0)|0;if((c[l+20>>2]|0)!=0){pA(j+4|0)|0}n=8+(c[j+4>>2]|0)|0}}while(0);if(((n|0)%8|0|0)!=0){n=n+(8-((n|0)%8|0))|0}q=0;while(1){if((q|0)>=(c[a+4>>2]|0)){break}m=fa(m,c[(c[a+32>>2]|0)+(q<<2)>>2]|0)|0;q=q+1|0}do{if(((fa(e,f-1|0)|0)+d+1|0)>(m|0)){g=1}else{q=a;if((c[a+48>>2]|0)==0){if((c[q+20>>2]|0)==0){fB(l,b,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;break}r=b;fB(l,c[r>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;$c(c[l>>2]|0,(c[(c[a+52>>2]|0)+16>>2]|0)+n|0,0)|0;sb(j|0,4,2,c[l>>2]|0)|0;if((c[l+20>>2]|0)!=0){pA(j)|0;pA(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){$c(c[l>>2]|0,-4,1)|0}fB(l,c[r+4>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;break}if((c[q+48>>2]|0)!=1){break}if((c[a+20>>2]|0)==0){gB(l,k,b,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;QB(k)|0;break}q=b;gB(l,k,c[q>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;$c(c[l>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;QB(k)|0;g=RB(k,c[(c[a+52>>2]|0)+32>>2]|0)|0;vA(l,k,n)|0;c[k+4>>2]=0;DA(l,k,j)|0;if((c[l+20>>2]|0)!=0){pA(j)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)==0){vA(l,k,4)|0}gB(l,k,c[q+4>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;QB(k)|0}}while(0);switch(c[a+16>>2]|0){case 6:{c[a+8>>2]=9;c[a+12>>2]=8;break};case 7:{c[a+8>>2]=7;c[a+12>>2]=4;break};case 9:{c[a+8>>2]=2;c[a+12>>2]=1;break};case 12:{c[a+8>>2]=5;c[a+12>>2]=4;break};case 13:{c[a+8>>2]=6;c[a+12>>2]=4;break};case 10:{c[a+8>>2]=3;c[a+12>>2]=2;break};case 14:{c[a+8>>2]=12;c[a+12>>2]=8;break};case 15:{c[a+8>>2]=13;c[a+12>>2]=8;break};case 11:{c[a+8>>2]=4;c[a+12>>2]=2;break};case 8:{c[a+8>>2]=1;c[a+12>>2]=1;break};default:{}}o=g;p=o;i=h;return p|0}function tB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+104|0;j=a;a=b;b=d;d=e;e=f;f=g;g=1;k=0;l=0;$c(c[j>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;switch(c[a+8>>2]|0){case 2:{l=9;break};case 4:{l=11;break};case 9:{l=6;break};case 3:{l=10;break};case 7:{l=7;break};case 5:{l=12;break};default:{m=1;n=m;i=h;return n|0}}c[a+12>>2]=MA(c[a+8>>2]|0)|0;o=0;while(1){if(!(o>>>0<(c[a+4>>2]|0)>>>0)){break}g=fa(g,c[(c[a+32>>2]|0)+(o<<2)>>2]|0)|0;o=o+1|0}if(((fa(e,f-1|0)|0)+d+1|0)>>>0>g>>>0){m=1;n=m;i=h;return n|0}if((c[a+20>>2]|0)!=0){o=b;p=fa(g,c[a+12>>2]|0)|0;fB(j,c[o>>2]|0,l,c[a+8>>2]|0,d,e,f)|0;$c(c[j>>2]|0,(c[(c[a+52>>2]|0)+16>>2]|0)+p|0,0)|0;fB(j,c[o+4>>2]|0,l,c[a+8>>2]|0,d,e,f)|0}else{fB(j,b,l,c[a+8>>2]|0,d,e,f)|0}m=k;n=m;i=h;return n|0}function uB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+24|0;d=a;a=0;if((d|0)==0){e=0;f=e;i=b;return f|0}g=c[d+16>>2]|0;if((g|0)==16){a=nB(d)|0}else if((g|0)==256){a=vB(d)|0}e=a;f=e;i=b;return f|0}function vB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+64|0;l=i;i=i+128|0;m=b;b=0;if((m|0)==0){n=0;o=n;i=d;return o|0}p=yb(c[m>>2]|0)|0;q=sb(h|0,4,1,c[m>>2]|0)|0;if((q|0)==0){n=0;o=n;i=d;return o|0}q=sb(j|0,4,1,c[m>>2]|0)|0;if((c[m+20>>2]|0)!=0){pA(h)|0;pA(j)|0}r=c[h>>2]|0;do{if((r|0)==14){h=0;b=qB()|0;c[(c[b+52>>2]|0)+12>>2]=p;c[(c[b+52>>2]|0)+20>>2]=m;h=h+(sb(l|0,4,6,c[m>>2]|0)|0)|0;if((c[m+20>>2]|0)!=0){qA(l)|0;qA(l+4|0)|0;qA(l+8|0)|0;qA(l+12|0)|0;qA(l+16|0)|0;qA(l+20|0)|0}do{if((c[l>>2]|0)==6){s=c[l+8>>2]|0;c[b+16>>2]=s&255;c[b+20>>2]=s&2048;c[b+24>>2]=s&1024;c[b+28>>2]=s&512;if((c[b+16>>2]|0)!=5){break}c[b>>2]=c[l+12>>2]}}while(0);a:do{if((c[l+16>>2]|0)==5){c[b+4>>2]=(c[l+20>>2]|0)/4|0;c[b+32>>2]=baa(c[b+4>>2]<<2)|0;t=l;u=c[b+4>>2]|0;if(((c[b+4>>2]|0)%2|0|0)!=0){h=h+(sb(t|0,4,u+1|0,c[m>>2]|0)|0)|0}else{h=h+(sb(t|0,4,u|0,c[m>>2]|0)|0)|0}v=0;if((c[m+20>>2]|0)!=0){while(1){if((v|0)>=(c[b+4>>2]|0)){break a}u=qA(l+(v<<2)|0)|0;c[(c[b+32>>2]|0)+(v<<2)>>2]=u;v=v+1|0}}else{while(1){if((v|0)>=(c[b+4>>2]|0)){break a}c[(c[b+32>>2]|0)+(v<<2)>>2]=c[l+(v<<2)>>2];v=v+1|0}}}}while(0);h=h+(sb(l|0,4,2,c[m>>2]|0)|0)|0;if((c[m+20>>2]|0)!=0){qA(l)|0}do{if((c[l>>2]|0)==1){if((c[m+20>>2]|0)!=0){w=qA(l+4|0)|0}else{w=c[l+4>>2]|0}u=w;if(((w|0)%8|0|0)==0){v=u}else{v=u+(8-((w|0)%8|0))|0}h=h+(sb(l|0,1,v|0,c[m>>2]|0)|0)|0;c[b+36>>2]=baa(w+1|0)|0;Haa(c[b+36>>2]|0,l|0,w|0)|0;a[(c[b+36>>2]|0)+w|0]=0}else{if((c[l>>2]&65535|0)!=1){break}if((c[l>>2]&-65536|0)==0){break}u=(c[l>>2]&-65536)>>>16;c[b+36>>2]=baa(u+1|0)|0;Haa(c[b+36>>2]|0,l+4|0,u|0)|0;a[(c[b+36>>2]|0)+u|0]=0}}while(0);do{if((c[b+16>>2]|0)==2){xB(m,b)|0}else{if((c[b+16>>2]|0)==1){yB(m,b)|0;break}if((c[b+16>>2]|0)!=16){break}zB(m,b)|0}}while(0);h=yb(c[m>>2]|0)|0;c[(c[b+52>>2]|0)+16>>2]=h;$c(c[m>>2]|0,(c[j>>2]|0)+8+p|0,0)|0}else if((r|0)==15){h=k+0|0;u=h+64|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(u|0));h=0;b=qB()|0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+32>>2]=0;c[b>>2]=0;c[b+8>>2]=0;c[b+16>>2]=0;c[b+12>>2]=0;c[b+44>>2]=0;c[b+48>>2]=1;c[(c[b+52>>2]|0)+20>>2]=m;c[(c[b+52>>2]|0)+12>>2]=p;u=daa(1,56)|0;c[(c[b+52>>2]|0)+32>>2]=u;c[(c[(c[b+52>>2]|0)+32>>2]|0)+32>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+36>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+40>>2]=0;c[c[(c[b+52>>2]|0)+32>>2]>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+12>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+16>>2]=0;q=MB(c[(c[b+52>>2]|0)+32>>2]|0,40328,56)|0;if((q|0)!=0){c[g>>2]=q;wA(40336,g);pB(b);break}h=h+(yA(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){qA(k)|0;qA(k+4|0)|0}u=c[k+4>>2]|0;if((c[k>>2]|0)!=14){wA(40368,f);$c(c[m>>2]|0,(c[j>>2]|0)-h|0,1)|0;pB(b);b=0;break}h=h+(zA(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){qA(k)|0;qA(k+8|0)|0;qA(k+12|0)|0}do{if((c[k>>2]|0)==6){s=c[k+8>>2]|0;c[b+16>>2]=s&255;c[b+20>>2]=s&2048;c[b+24>>2]=s&1024;c[b+28>>2]=s&512;if((c[b+16>>2]|0)!=5){break}c[b>>2]=c[k+12>>2]}}while(0);h=h+(AA(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){qA(k)|0;qA(k+4|0)|0}b:do{if((c[k>>2]|0)==5){u=c[k+4>>2]|0;c[b+4>>2]=(u|0)/4|0;c[b+32>>2]=baa(c[b+4>>2]<<2)|0;v=0;if((c[m+20>>2]|0)!=0){while(1){if((v|0)>=(c[b+4>>2]|0)){break b}t=qA(k+(2+v<<2)|0)|0;c[(c[b+32>>2]|0)+(v<<2)>>2]=t;v=v+1|0}}else{while(1){if((v|0)>=(c[b+4>>2]|0)){break b}c[(c[b+32>>2]|0)+(v<<2)>>2]=c[k+(2+v<<2)>>2];v=v+1|0}}}}while(0);h=h+(BA(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){qA(k)|0}do{if((c[k>>2]|0)==1){if((c[m+20>>2]|0)!=0){x=qA(k+4|0)|0}else{x=c[k+4>>2]|0}u=x;if(((x|0)%8|0|0)==0){v=u}else{v=u+(8-((x|0)%8|0))|0}c[b+36>>2]=baa(v+1|0)|0;h=h+(CA(m,b,c[b+36>>2]|0,v)|0)|0;a[(c[b+36>>2]|0)+x|0]=0}else{if((c[k>>2]&65535|0)!=1){break}if((c[k>>2]&-65536|0)==0){break}u=(c[k>>2]&-65536)>>>16;c[b+36>>2]=baa(u+1|0)|0;Haa(c[b+36>>2]|0,k+4|0,u|0)|0;a[(c[b+36>>2]|0)+u|0]=0}}while(0);do{if((c[b+16>>2]|0)==2){xB(m,b)|0}else{if((c[b+16>>2]|0)!=1){break}yB(m,b)|0}}while(0);$c(c[m>>2]|0,0-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;h=yb(c[m>>2]|0)|0;c[(c[b+52>>2]|0)+16>>2]=h;$c(c[m>>2]|0,(c[j>>2]|0)+8+p|0,0)|0}else{c[e>>2]=c[m+12>>2];wA(40408,e);n=0;o=n;i=d;return o|0}}while(0);n=b;o=n;i=d;return o|0}function wB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=a;a=b;b=0;do{if((g|0)!=0){if((a|0)==0){break}a:do{if((c[g+16>>2]|0)==512){while(1){b=uB(g)|0;if((b|0)==0){break}h=b;do{if((c[b+36>>2]|0)!=0){if((Baa(c[h+36>>2]|0,a)|0)==0){break}pB(b);b=0}else{pB(h);b=0}}while(0);if(0!=(b|0)){break a}if((c[g+32>>2]|0)>=(c[g+36>>2]|0)){break a}}wA(40176,f)}else{h=yb(c[g>>2]|0)|0;$c(c[g>>2]|0,c[g+28>>2]|0,0)|0;do{b=uB(g)|0;if((b|0)==0){j=19;break}k=b;do{if((c[b+36>>2]|0)!=0){if((Baa(c[k+36>>2]|0,a)|0)==0){break}pB(b);b=0}else{pB(k);b=0}}while(0);if((b|0)!=0){break}}while((Vd(c[g>>2]|0)|0)!=0^1);if((j|0)==19){wA(40176,e)}$c(c[g>>2]|0,h|0,0)|0}}while(0);l=b;m=l;i=d;return m|0}}while(0);l=0;m=l;i=d;return m|0}function xB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+64|0;n=i;i=i+64|0;o=b;b=d;d=0;p=1;q=0;r=0;while(1){if((r|0)>=(c[b+4>>2]|0)){break}p=fa(p,c[(c[b+32>>2]|0)+(r<<2)>>2]|0)|0;r=r+1|0}a:do{if((c[b+48>>2]|0)!=0){s=m+0|0;t=s+64|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));d=d+(FA(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){qA(m)|0;qA(m+4|0)|0}if((c[m>>2]&65535|0)!=5){LA(40712,l);u=d;v=u;i=e;return v|0}w=c[m+4>>2]|0;d=d+(GA(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){qA(m)|0;qA(m+4|0)|0}x=c[m+4>>2]|0;x=(x|0)/(w|0)|0;c[b+12>>2]=4;if(((fa(x,w)|0)%8|0|0)!=0){r=8-((fa(x,w)|0)%8|0)|0}else{r=0}if((x|0)!=0){y=baa((fa(x,w)|0)+r|0)|0;d=d+(HA(o,b,y,x,w,r)|0)|0;c[(c[b+52>>2]|0)+24>>2]=x;z=daa(x,4)|0;c[(c[b+52>>2]|0)+28>>2]=z;r=0;while(1){if((r|0)>=(x|0)){break}z=baa(w)|0;c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]=z;Haa(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0,y+(fa(r,w)|0)|0,w|0)|0;a[(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0)+(w-1)|0]=0;r=r+1|0}caa(y)}else{c[(c[b+52>>2]|0)+24>>2]=0;c[(c[b+52>>2]|0)+28>>2]=0}z=fa(p,x)|0;c[b>>2]=fa(z,c[b+12>>2]|0)|0;if((c[b>>2]|0)==0){u=d;v=u;i=e;return v|0}c[b+40>>2]=baa(c[b>>2]|0)|0;if((c[b+40>>2]|0)==0){u=d;v=u;i=e;return v|0}q=c[b+40>>2]|0;r=0;while(1){if((r|0)>=(p|0)){break}z=0;while(1){if((z|0)>=(x|0)){break}c[q+((fa(r,x)|0)+z<<2)>>2]=qB()|0;A=Fd(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(z<<2)>>2]|0)|0;c[(c[q+((fa(r,x)|0)+z<<2)>>2]|0)+36>>2]=A;z=z+1|0}r=r+1|0}r=0;while(1){if((r|0)>=(fa(p,x)|0)){break a}y=yb(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+12>>2]=y-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);d=d+(yA(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){qA(m)|0;qA(m+4|0)|0}y=c[m+4>>2]|0;do{if((c[m>>2]|0)!=14){c[k>>2]=r;wA(40744,k);pB(c[q+(r<<2)>>2]|0);c[q+(r<<2)>>2]=0}else{z=c[q+(r<<2)>>2]|0;if((y|0)==0){c[z+4>>2]=0;break}c[z+48>>2]=1;d=d+(zA(o,b,m)|0)|0;y=y-16|0;if((c[o+20>>2]|0)!=0){qA(m)|0;qA(m+4|0)|0;qA(m+8|0)|0;qA(m+12|0)|0}do{if((c[m>>2]|0)==6){z=c[m+8>>2]|0;c[(c[q+(r<<2)>>2]|0)+16>>2]=z&255;c[(c[q+(r<<2)>>2]|0)+20>>2]=z&2048;c[(c[q+(r<<2)>>2]|0)+24>>2]=z&1024;c[(c[q+(r<<2)>>2]|0)+28>>2]=z&512;if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(r<<2)>>2]>>2]=c[m+12>>2]}else{c[j>>2]=c[m>>2];wA(40592,j);d=d+(vA(o,c[(c[b+52>>2]|0)+32>>2]|0,y)|0)|0}}while(0);d=d+(AA(o,b,m)|0)|0;y=y-8|0;if((c[o+20>>2]|0)!=0){qA(m)|0;qA(m+4|0)|0}do{if((c[m>>2]|0)==5){z=0;c[(c[q+(r<<2)>>2]|0)+4>>2]=c[m+4>>2];y=y-(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)|0;A=(c[q+(r<<2)>>2]|0)+4|0;c[A>>2]=(c[A>>2]|0)/4|0;A=baa(c[(c[q+(r<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(r<<2)>>2]|0)+32>>2]=A;z=0;b:do{if((c[o+20>>2]|0)!=0){while(1){if((z|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break b}A=qA(m+8+(z<<2)|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(z<<2)>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break b}c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(z<<2)>>2]=c[m+(2+z<<2)>>2];z=z+1|0}}}while(0);if(((c[(c[q+(r<<2)>>2]|0)+4>>2]|0)%2|0|0)==0){break}y=y-4|0}}while(0);d=d+(BA(o,b,m)|0)|0;y=y-8|0;z=daa(1,56)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]=z;z=RB(c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]|0,c[(c[b+52>>2]|0)+32>>2]|0)|0;if((z|0)!=0){c[h>>2]=z;wA(40640,h)}z=yb(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]=z-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);do{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)==2){d=d+(xB(o,c[q+(r<<2)>>2]|0)|0)|0}else{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(yB(o,c[q+(r<<2)>>2]|0)|0)|0}}while(0);$c(c[o>>2]|0,c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]|0,0)|0;d=d+(vA(o,c[(c[b+52>>2]|0)+32>>2]|0,y)|0)|0}}while(0);r=r+1|0}}else{s=n+0|0;t=s+64|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));d=d+(sb(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}if((c[n>>2]&65535|0)!=5){LA(40712,g);u=d;v=u;i=e;return v|0}w=c[n+4>>2]|0;d=d+(sb(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}x=c[n+4>>2]|0;x=(x|0)/(w|0)|0;c[b+12>>2]=4;c[(c[b+52>>2]|0)+24>>2]=x;y=daa(x,4)|0;c[(c[b+52>>2]|0)+28>>2]=y;r=0;while(1){if((r|0)>=(x|0)){break}y=baa(w)|0;c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]=y;d=d+(sb(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0,1,w|0,c[o>>2]|0)|0)|0;a[(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0)+(w-1)|0]=0;r=r+1|0}if(((fa(x,w)|0)%8|0|0)!=0){$c(c[o>>2]|0,8-((fa(x,w)|0)%8|0)|0,1)|0;d=d+(8-((fa(x,w)|0)%8|0))|0}y=fa(p,x)|0;c[b>>2]=fa(y,c[b+12>>2]|0)|0;if((c[b>>2]|0)==0){u=d;v=u;i=e;return v|0}c[b+40>>2]=baa(c[b>>2]|0)|0;if((c[b+40>>2]|0)==0){u=d;v=u;i=e;return v|0}q=c[b+40>>2]|0;r=0;while(1){if((r|0)>=(p|0)){break}y=0;while(1){if((y|0)>=(x|0)){break}c[q+((fa(r,x)|0)+y<<2)>>2]=qB()|0;z=Fd(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(y<<2)>>2]|0)|0;c[(c[q+((fa(r,x)|0)+y<<2)>>2]|0)+36>>2]=z;y=y+1|0}r=r+1|0}r=0;while(1){if((r|0)>=(fa(p,x)|0)){break a}y=yb(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+12>>2]=y;d=d+(sb(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}y=c[n+4>>2]|0;if((c[n>>2]|0)!=14){break}z=c[q+(r<<2)>>2]|0;if((y|0)==0){c[z+4>>2]=0}else{c[z+48>>2]=0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]=0;d=d+(sb(n|0,4,6,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0;qA(n+8|0)|0;qA(n+12|0)|0;qA(n+16|0)|0;qA(n+20|0)|0}y=y-24|0;do{if((c[n>>2]|0)==6){z=c[n+8>>2]|0;c[(c[q+(r<<2)>>2]|0)+16>>2]=z&255;c[(c[q+(r<<2)>>2]|0)+20>>2]=z&2048;c[(c[q+(r<<2)>>2]|0)+24>>2]=z&1024;c[(c[q+(r<<2)>>2]|0)+28>>2]=z&512;if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(r<<2)>>2]>>2]=c[n+12>>2]}}while(0);c:do{if((c[n+16>>2]|0)==5){z=c[n+20>>2]|0;y=y-z|0;c[(c[q+(r<<2)>>2]|0)+4>>2]=(z|0)/4|0;z=baa(c[(c[q+(r<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(r<<2)>>2]|0)+32>>2]=z;z=n;A=c[(c[q+(r<<2)>>2]|0)+4>>2]|0;if(((c[(c[q+(r<<2)>>2]|0)+4>>2]|0)%2|0|0)!=0){d=d+(sb(z|0,4,A+1|0,c[o>>2]|0)|0)|0;y=y-4|0}else{d=d+(sb(z|0,4,A|0,c[o>>2]|0)|0)|0}A=0;if((c[o+20>>2]|0)!=0){while(1){if((A|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break c}z=qA(n+(A<<2)|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(A<<2)>>2]=z;A=A+1|0}}else{while(1){if((A|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break c}c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0}}}}while(0);d=d+(sb(n|0,1,8,c[o>>2]|0)|0)|0;y=y-8|0;A=yb(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]=A;do{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)==2){d=d+(xB(o,c[q+(r<<2)>>2]|0)|0)|0}else{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(yB(o,c[q+(r<<2)>>2]|0)|0)|0}}while(0);$c(c[o>>2]|0,(c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]|0)+y|0,0)|0}r=r+1|0}A=yb(c[o>>2]|0)|0;c[f>>2]=r;c[f+4>>2]=A;wA(40792,f);pB(c[q+(r<<2)>>2]|0);c[q+(r<<2)>>2]=0;u=d;v=u;i=e;return v|0}}while(0);u=d;v=u;i=e;return v|0}function yB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+64|0;o=i;i=i+64|0;p=b;b=d;d=0;q=0;r=1;s=0;while(1){if((s|0)>=(c[b+4>>2]|0)){break}r=fa(r,c[(c[b+32>>2]|0)+(s<<2)>>2]|0)|0;s=s+1|0}c[b+12>>2]=4;c[b>>2]=fa(r,c[b+12>>2]|0)|0;c[b+40>>2]=baa(c[b>>2]|0)|0;t=b;if((c[b+40>>2]|0)==0){c[m>>2]=c[t+36>>2];wA(40464,m);u=d;v=u;i=e;return v|0}q=c[t+40>>2]|0;a:do{if((c[b+48>>2]|0)!=0){t=n+0|0;m=t+64|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(m|0));s=0;b:while(1){if((s|0)>=(r|0)){break a}c[q+(s<<2)>>2]=qB()|0;do{if(0==(c[q+(s<<2)>>2]|0)){c[l>>2]=s;wA(40504,l)}else{t=yb(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+12>>2]=t-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);c[n>>2]=0;c[n+4>>2]=0;d=d+(yA(p,b,n)|0)|0;if((c[p+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}t=c[n+4>>2]|0;if((t|0)==0){break}w=s;if((c[n>>2]|0)!=14){break b}c[(c[q+(w<<2)>>2]|0)+48>>2]=1;d=d+(zA(p,b,n)|0)|0;t=t-16|0;if((c[p+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0;qA(n+8|0)|0;qA(n+12|0)|0}do{if((c[n>>2]|0)==6){m=c[n+8>>2]|0;c[(c[q+(s<<2)>>2]|0)+16>>2]=m&255;c[(c[q+(s<<2)>>2]|0)+20>>2]=m&2048;c[(c[q+(s<<2)>>2]|0)+24>>2]=m&1024;c[(c[q+(s<<2)>>2]|0)+28>>2]=m&512;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(s<<2)>>2]>>2]=c[n+12>>2]}else{c[j>>2]=c[n>>2];wA(40592,j);d=d+(vA(p,c[(c[b+52>>2]|0)+32>>2]|0,t)|0)|0}}while(0);d=d+(AA(p,b,n)|0)|0;t=t-8|0;if((c[p+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}do{if((c[n>>2]|0)==5){m=0;c[(c[q+(s<<2)>>2]|0)+4>>2]=c[n+4>>2];t=t-(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)|0;x=(c[q+(s<<2)>>2]|0)+4|0;c[x>>2]=(c[x>>2]|0)/4|0;x=baa(c[(c[q+(s<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(s<<2)>>2]|0)+32>>2]=x;m=0;c:do{if((c[p+20>>2]|0)!=0){while(1){if((m|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break c}x=qA(n+8+(m<<2)|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(m<<2)>>2]=x;m=m+1|0}}else{while(1){if((m|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break c}c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(m<<2)>>2]=c[n+(2+m<<2)>>2];m=m+1|0}}}while(0);if(((c[(c[q+(s<<2)>>2]|0)+4>>2]|0)%2|0|0)==0){break}t=t-4|0}}while(0);d=d+(BA(p,b,n)|0)|0;t=t-8|0;if((c[p+20>>2]|0)!=0){qA(n)|0;qA(n+4|0)|0}do{if((c[n+4>>2]|0)>>>0>0){m=0;if((c[n>>2]|0)==1){m=c[n+4>>2]|0;if(((m|0)%8|0|0)>0){m=m+(8-((m|0)%8|0))|0}x=baa(m+1|0)|0;c[(c[q+(s<<2)>>2]|0)+36>>2]=x;d=d+(CA(p,b,c[(c[q+(s<<2)>>2]|0)+36>>2]|0,m)|0)|0;a[(c[(c[q+(s<<2)>>2]|0)+36>>2]|0)+m|0]=0;t=t-m|0;break}else{if((c[n>>2]&65535|0)!=1){break}if((c[n>>2]&-65536|0)==0){break}m=(c[n>>2]&-65536)>>>16;x=baa(m+1|0)|0;c[(c[q+(s<<2)>>2]|0)+36>>2]=x;Haa(c[(c[q+(s<<2)>>2]|0)+36>>2]|0,n+4|0,m|0)|0;a[(c[(c[q+(s<<2)>>2]|0)+36>>2]|0)+m|0]=0;break}}}while(0);m=daa(1,56)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]=m;m=RB(c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]|0,c[(c[b+52>>2]|0)+32>>2]|0)|0;if((m|0)!=0){c[h>>2]=m;wA(40640,h)}m=yb(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]=m-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);do{if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==2){d=d+(xB(p,c[q+(s<<2)>>2]|0)|0)|0}else{if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(yB(p,c[q+(s<<2)>>2]|0)|0)|0}}while(0);$c(c[p>>2]|0,c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]|0,0)|0;d=d+(vA(p,c[(c[b+52>>2]|0)+32>>2]|0,t)|0)|0}}while(0);s=s+1|0}c[k>>2]=w;wA(40544,k);pB(c[q+(s<<2)>>2]|0);c[q+(s<<2)>>2]=0}else{s=0;d:while(1){if((s|0)>=(r|0)){break a}c[q+(s<<2)>>2]=qB()|0;do{if((c[q+(s<<2)>>2]|0)!=0){m=yb(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+12>>2]=m;m=sb(o|0,4,2,c[p>>2]|0)|0;if((m|0)==0){break}d=d+m|0;if((c[p+20>>2]|0)!=0){qA(o)|0;qA(o+4|0)|0}m=c[o+4>>2]|0;if((m|0)==0){break}y=s;if((c[o>>2]|0)!=14){break d}c[(c[q+(y<<2)>>2]|0)+48>>2]=0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]=0;d=d+(sb(o|0,4,6,c[p>>2]|0)|0)|0;if((c[p+20>>2]|0)!=0){qA(o)|0;qA(o+4|0)|0;qA(o+8|0)|0;qA(o+12|0)|0;qA(o+16|0)|0;qA(o+20|0)|0}m=m-24|0;do{if((c[o>>2]|0)==6){x=c[o+8>>2]|0;c[(c[q+(s<<2)>>2]|0)+16>>2]=x&255;c[(c[q+(s<<2)>>2]|0)+20>>2]=x&2048;c[(c[q+(s<<2)>>2]|0)+24>>2]=x&1024;c[(c[q+(s<<2)>>2]|0)+28>>2]=x&512;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(s<<2)>>2]>>2]=c[o+12>>2]}}while(0);e:do{if((c[o+16>>2]|0)==5){t=c[o+20>>2]|0;m=m-t|0;c[(c[q+(s<<2)>>2]|0)+4>>2]=(t|0)/4|0;t=baa(c[(c[q+(s<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(s<<2)>>2]|0)+32>>2]=t;t=o;x=c[(c[q+(s<<2)>>2]|0)+4>>2]|0;if(((c[(c[q+(s<<2)>>2]|0)+4>>2]|0)%2|0|0)!=0){d=d+(sb(t|0,4,x+1|0,c[p>>2]|0)|0)|0;m=m-4|0}else{d=d+(sb(t|0,4,x|0,c[p>>2]|0)|0)|0}x=0;if((c[p+20>>2]|0)!=0){while(1){if((x|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break e}t=qA(o+(x<<2)|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(x<<2)>>2]=t;x=x+1|0}}else{while(1){if((x|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break e}c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(x<<2)>>2]=c[o+(x<<2)>>2];x=x+1|0}}}}while(0);d=d+(sb(o|0,1,8,c[p>>2]|0)|0)|0;m=m-8|0;if((c[p+20>>2]|0)!=0){qA(o)|0;qA(o+4|0)|0}x=0;do{if((c[o+4>>2]|0)>>>0>0){if((c[o>>2]|0)!=1){break}x=c[o+4>>2]|0;if(((x|0)%8|0|0)>0){x=x+(8-((x|0)%8|0))|0}m=m-x|0;$c(c[p>>2]|0,x|0,1)|0}}while(0);x=yb(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]=x;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==2){d=d+(xB(p,c[q+(s<<2)>>2]|0)|0)|0}if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==1){d=d+(yB(p,c[q+(s<<2)>>2]|0)|0)|0}$c(c[p>>2]|0,(c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]|0)+m|0,0)|0}else{c[g>>2]=s;wA(40504,g)}}while(0);s=s+1|0}x=yb(c[p>>2]|0)|0;c[f>>2]=y;c[f+4>>2]=x;wA(40672,f);pB(c[q+(s<<2)>>2]|0);c[q+(s<<2)>>2]=0}}while(0);u=d;v=u;i=e;return v|0}function zB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=a;a=b;b=1;f=0;g=0;h=0;while(1){if((h|0)>=(c[a+4>>2]|0)){break}b=fa(b,c[(c[a+32>>2]|0)+(h<<2)>>2]|0)|0;h=h+1|0}c[a+40>>2]=baa(b<<2)|0;if((c[a+40>>2]|0)==0){f=0;c[a+12>>2]=0;c[a>>2]=0;j=f;i=d;return j|0}c[a+12>>2]=4;c[a>>2]=fa(b,c[a+12>>2]|0)|0;g=c[a+40>>2]|0;h=0;while(1){if((h|0)>=(b|0)){break}c[g+(h<<2)>>2]=uB(e)|0;h=h+1|0}j=f;i=d;return j|0}function AB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=d;if((c[h>>2]|0)>>>0<e>>>0){a[b+(c[h>>2]|0)|0]=f}f=h;c[f>>2]=(c[f>>2]|0)+1;i=g;return}function BB(b,c,d,e,f,g,h,j){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+136|0;l=k+80|0;m=b;b=c;c=d;d=e;e=f;f=g;g=h;h=j;j=0;n=0;o=0;p=0;q=0;if((g|0)<0){g=0}r=d;do{if((h&64|0)==0){if((d|0)<0){j=45;r=0-d|0;break}if((h&2|0)!=0){j=43;break}if((h&4|0)==0){break}j=32}}while(0);if((h&32|0)!=0){q=1}do{d=n;n=d+1|0;a[l+d|0]=a[((q|0)!=0?40848:40872)+((r>>>0)%(e>>>0)|0)|0]|0;r=(r>>>0)/(e>>>0)|0;if((r|0)==0){break}}while((n|0)<20);if((n|0)==20){n=n+ -1|0}a[l+n|0]=0;p=g-n|0;o=f-((g|0)>=(n|0)?g:n)-((j|0)!=0?1:0)|0;if((p|0)<0){p=0}if((o|0)<0){o=0}if((h&16|0)!=0){p=(p|0)>=(o|0)?p:o;o=0}if((h&1|0)!=0){o=0-o|0}while(1){if((o|0)<=0){break}AB(m,b,c,32);o=o+ -1|0}if((j|0)!=0){AB(m,b,c,j&255)}if((p|0)>0&(p|0)>0){do{AB(m,b,c,48);p=p+ -1|0;}while((p|0)>0)}while(1){if((n|0)<=0){break}p=n+ -1|0;n=p;AB(m,b,c,a[l+p|0]|0)}while(1){if((o|0)>=0){break}AB(m,b,c,32);o=o+1|0}i=k;return}function CB(b,c,d,e,f,g,j){b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0;k=i;i=i+768|0;l=k+72|0;m=k+384|0;n=k+744|0;o=k+752|0;p=b;b=c;c=d;q=e;d=f;f=g;g=j;j=0;r=0;s=0;t=0;u=0;v=0;if((f|0)<0){f=6}e=+EB(q);do{if(q<0.0){j=45}else{if((g&2|0)!=0){j=43;break}if((g&4|0)==0){break}j=32}}while(0);if((f|0)>16){f=16}q=e;+FB(q,n);w=+HB(f);h[o>>3]=+(GB(w*(e- +h[n>>3]))|0);e=+h[o>>3];if(e>=+HB(f)){h[n>>3]=+h[n>>3]+1.0;e=+HB(f);h[o>>3]=+h[o>>3]-e}do{q=+h[n>>3]*.1;+FB(q,n);x=~~((q- +h[n>>3]+.05)*10.0);y=r;r=y+1|0;a[l+y|0]=a[((v|0)!=0?40848:40872)+x|0]|0;if(!(+h[n>>3]!=0.0)){break}}while((r|0)<311);if((r|0)==311){r=r+ -1|0}a[l+r|0]=0;do{if(+h[o>>3]!=0.0){do{q=+h[o>>3]*.1;+FB(q,o);x=~~((q- +h[o>>3]+.05)*10.0);n=s;s=n+1|0;a[m+n|0]=a[((v|0)!=0?40848:40872)+x|0]|0;if(!(+h[o>>3]!=0.0)){break}}while((s|0)<311);if((s|0)!=311){break}s=s+ -1|0}}while(0);a[m+s|0]=0;t=d-r-f-1-((j|0)!=0?1:0)|0;d=f-s|0;u=d;u=(u|0)<0?0:d;if((t|0)<0){t=0}if((g&1|0)!=0){t=0-t|0}a:do{if((g&16|0)!=0){if((t|0)<=0){break}if((j|0)!=0){AB(p,b,c,j&255);t=t+ -1|0;j=0}while(1){if((t|0)<=0){break a}AB(p,b,c,48);t=t+ -1|0}}}while(0);while(1){if((t|0)<=0){break}AB(p,b,c,32);t=t+ -1|0}if((j|0)!=0){AB(p,b,c,j&255)}while(1){if((r|0)<=0){break}j=r+ -1|0;r=j;AB(p,b,c,a[l+j|0]|0)}b:do{if((f|0)>0){AB(p,b,c,46);while(1){if((u|0)<=0){break}AB(p,b,c,48);u=u+ -1|0}while(1){if((s|0)<=0){break b}l=s+ -1|0;s=l;AB(p,b,c,a[m+l|0]|0)}}}while(0);while(1){if((t|0)>=0){break}AB(p,b,c,32);t=t+1|0}i=k;return}function DB(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+80|0;k=b;b=c;c=d;d=e;e=f;f=g;g=h;h=0;if((d|0)==0){d=40840}l=0;while(1){if((a[d+l|0]|0)==0){break}l=l+1|0}m=f-l|0;l=m;l=(l|0)<0?0:m;if((e&1|0)!=0){l=0-l|0}while(1){if((l|0)<=0){break}if((h|0)>=(g|0)){break}AB(k,b,c,32);l=l+ -1|0;h=h+1|0}while(1){if((a[d]|0)==0){break}if((h|0)>=(g|0)){break}e=d;d=e+1|0;AB(k,b,c,a[e]|0);h=h+1|0}while(1){if((l|0)>=0){n=17;break}if((h|0)>=(g|0)){n=17;break}AB(k,b,c,32);l=l+1|0;h=h+1|0}if((n|0)==17){i=j;return}}function EB(a){a=+a;var b=0,c=0.0;b=i;i=i+16|0;c=a;a=c;if(c<0.0){a=-c}i=b;return+a}function FB(a,b){a=+a;b=b|0;var c=0,d=0,e=0.0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0;c=i;i=i+72|0;d=c+56|0;e=a;f=b;a=e;g=1.0;b=0;while(1){if((b|0)>=100){break}j=~~a;if(+(j|0)<=a+1.0){if(+(j|0)>=a-1.0){break}}a=a*.1;g=g*10.0;b=b+1|0}if((b|0)==100){h[f>>3]=0.0;k=0.0;l=k;i=c;return+l}if((b|0)!=0){m=+FB(e- +(j|0)*g,d);h[f>>3]=+(j|0)*g+ +h[d>>3];k=m;l=k;i=c;return+l}else{h[f>>3]=+(j|0);k=a- +h[f>>3];l=k;i=c;return+l}return 0.0}function GB(a){a=+a;var b=0,c=0.0,d=0,e=0;b=i;i=i+16|0;c=a;d=~~c;c=c- +(d|0);if(!(c>=.5)){e=d;i=b;return e|0}d=d+1|0;e=d;i=b;return e|0}function HB(a){a=a|0;var b=0,c=0,d=0.0,e=0.0;b=i;i=i+16|0;c=a;d=1.0;while(1){e=d;if((c|0)==0){break}d=e*10.0;c=c+ -1|0}i=b;return+e}function IB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}a=c[d+28>>2]|0;c[a+28>>2]=0;c[d+20>>2]=0;c[d+8>>2]=0;c[d+24>>2]=0;if((c[a+8>>2]|0)!=0){c[d+48>>2]=c[a+8>>2]&1}c[a>>2]=0;c[a+4>>2]=0;c[a+12>>2]=0;c[a+20>>2]=32768;c[a+32>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;e=a+1328|0;c[a+108>>2]=e;c[a+80>>2]=e;c[a+76>>2]=e;c[a+7104>>2]=1;c[a+7108>>2]=-1;f=0;g=f;i=b;return g|0}}while(0);f=-2;g=f;i=b;return g|0}function JB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}a=c[d+28>>2]|0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;e=IB(d)|0;f=e;i=b;return f|0}}while(0);e=-2;f=e;i=b;return f|0}function KB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=a;a=b;do{if((e|0)!=0){if((c[e+28>>2]|0)==0){break}b=c[e+28>>2]|0;do{if((a|0)<0){f=0;a=0-a|0}else{f=(a>>4)+1|0;if((a|0)>=48){break}a=a&15}}while(0);do{if((a|0)!=0){if(!((a|0)<8|(a|0)>15)){break}g=-2;h=g;i=d;return h|0}}while(0);do{if((c[b+52>>2]|0)!=0){if((c[b+36>>2]|0)==(a|0)){break}ne[c[e+36>>2]&127](c[e+40>>2]|0,c[b+52>>2]|0);c[b+52>>2]=0}}while(0);c[b+8>>2]=f;c[b+36>>2]=a;g=JB(e)|0;h=g;i=d;return h|0}}while(0);g=-2;h=g;i=d;return h|0}function LB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+56|0;h=b;b=d;d=e;e=f;do{if((d|0)!=0){if((a[d]|0)!=(a[40896]|0)){break}if((e|0)!=56){break}if((h|0)==0){j=-2;k=j;i=g;return k|0}c[h+24>>2]=0;if((c[h+32>>2]|0)==0){c[h+32>>2]=32;c[h+40>>2]=0}if((c[h+36>>2]|0)==0){c[h+36>>2]=71}f=se[c[h+32>>2]&63](c[h+40>>2]|0,1,7116)|0;if((f|0)==0){j=-4;k=j;i=g;return k|0}c[h+28>>2]=f;c[f+52>>2]=0;l=KB(h,b)|0;if((l|0)!=0){ne[c[h+36>>2]&127](c[h+40>>2]|0,f);c[h+28>>2]=0}j=l;k=j;i=g;return k|0}}while(0);j=-6;k=j;i=g;return k|0}function MB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=LB(a,15,b,c)|0;i=d;return e|0}function NB(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=i;i=i+152|0;j=h+112|0;k=h+120|0;l=h+144|0;m=f;f=g;do{if((m|0)!=0){if((c[m+28>>2]|0)==0){break}if((c[m+12>>2]|0)==0){break}if((c[m>>2]|0)==0){if((c[m+4>>2]|0)!=0){break}}g=c[m+28>>2]|0;if((c[g>>2]|0)==11){c[g>>2]=12}n=c[m+12>>2]|0;o=c[m+16>>2]|0;p=c[m>>2]|0;q=c[m+4>>2]|0;r=c[g+56>>2]|0;s=c[g+60>>2]|0;t=q;u=o;v=0;a:while(1){b:do{switch(c[g>>2]|0){case 5:{w=71;break};case 11:{w=133;break};case 13:{r=r>>>(s&7);s=s-(s&7)|0;while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}if((r&65535|0)!=(r>>>16^65535|0)){c[m+24>>2]=41104;c[g>>2]=29;continue a}else{c[g+64>>2]=r&65535;r=0;s=0;c[g>>2]=14;if((f|0)==6){break a}else{w=153;break b}}break};case 12:{w=134;break};case 3:{w=51;break};case 7:{w=101;break};case 16:{while(1){if(!(s>>>0<14)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}c[g+96>>2]=(r&31)+257;r=r>>>5;s=s-5|0;c[g+100>>2]=(r&31)+1;r=r>>>5;s=s-5|0;c[g+92>>2]=(r&15)+4;r=r>>>4;s=s-4|0;do{if(!((c[g+96>>2]|0)>>>0>286)){if((c[g+100>>2]|0)>>>0>30){break}c[g+104>>2]=0;c[g>>2]=17;w=169;break b}}while(0);c[m+24>>2]=41136;c[g>>2]=29;continue a;break};case 18:{w=179;break};case 9:{while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}x=(r>>>24&255)+(r>>>8&65280)+((r&65280)<<8)+((r&255)<<24)|0;c[g+24>>2]=x;c[m+48>>2]=x;r=0;s=0;c[g>>2]=10;w=130;break};case 0:{if((c[g+8>>2]|0)==0){c[g>>2]=12;continue a}while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}do{if((c[g+8>>2]&2|0)!=0){if((r|0)!=35615){break}c[g+24>>2]=WB(0,0,0)|0;a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=WB(c[g+24>>2]|0,l,2)|0;r=0;s=0;c[g>>2]=1;continue a}}while(0);c[g+16>>2]=0;if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+48>>2]=-1}do{if((c[g+8>>2]&1|0)!=0){if((((((r&255)<<8)+(r>>>8)|0)>>>0)%31|0|0)!=0){break}if((r&15|0)!=8){c[m+24>>2]=40968;c[g>>2]=29;continue a}r=r>>>4;s=s-4|0;y=(r&15)+8|0;x=y;z=g+36|0;do{if((c[g+36>>2]|0)==0){c[z>>2]=x}else{if(!(x>>>0>(c[z>>2]|0)>>>0)){break}c[m+24>>2]=41e3;c[g>>2]=29;continue a}}while(0);c[g+20>>2]=1<<y;z=VB(0,0,0)|0;c[g+24>>2]=z;c[m+48>>2]=z;c[g>>2]=(r&512|0)!=0?9:11;r=0;s=0;continue a}}while(0);c[m+24>>2]=40944;c[g>>2]=29;continue a;break};case 1:{while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+16>>2]=r;if((c[g+16>>2]&255|0)!=8){c[m+24>>2]=40968;c[g>>2]=29;continue a}if((c[g+16>>2]&57344|0)!=0){c[m+24>>2]=41024;c[g>>2]=29;continue a}if((c[g+32>>2]|0)!=0){c[c[g+32>>2]>>2]=r>>>8&1}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=WB(c[g+24>>2]|0,l,2)|0}r=0;s=0;c[g>>2]=2;w=43;break};case 21:{w=236;break};case 22:{w=242;break};case 10:{w=130;break};case 20:{w=214;break};case 17:{w=169;break};case 4:{w=59;break};case 2:{w=43;break};case 6:{w=86;break};case 8:{w=116;break};case 23:{w=254;break};case 24:{break};case 25:{if((o|0)==0){break a}z=n;n=z+1|0;a[z]=c[g+64>>2];o=o+ -1|0;c[g>>2]=20;continue a;break};case 26:{do{if((c[g+8>>2]|0)!=0){while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}u=u-o|0;z=m+20|0;c[z>>2]=(c[z>>2]|0)+u;z=g+28|0;c[z>>2]=(c[z>>2]|0)+u;if((u|0)!=0){z=c[g+24>>2]|0;x=n+(0-u)|0;A=u;if((c[g+16>>2]|0)!=0){B=WB(z,x,A)|0}else{B=VB(z,x,A)|0}c[g+24>>2]=B;c[m+48>>2]=B}u=o;A=r;if((c[g+16>>2]|0)!=0){C=A}else{C=(A>>>24&255)+(r>>>8&65280)+((r&65280)<<8)+((r&255)<<24)|0}if((C|0)!=(c[g+24>>2]|0)){c[m+24>>2]=41424;c[g>>2]=29;continue a}else{r=0;s=0;break}}}while(0);c[g>>2]=27;w=294;break};case 14:{w=153;break};case 15:{w=154;break};case 19:{w=213;break};case 27:{w=294;break};case 28:{w=303;break a;break};case 29:{w=304;break a;break};case 30:{w=305;break a;break};default:{w=306;break a}}}while(0);do{if((w|0)==43){while(1){w=0;if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0;w=43}if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+4>>2]=r}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;a[l+2|0]=r>>>16;a[l+3|0]=r>>>24;c[g+24>>2]=WB(c[g+24>>2]|0,l,4)|0}r=0;s=0;c[g>>2]=3;w=51}else if((w|0)==130){w=0;if((c[g+12>>2]|0)==0){w=131;break a}A=VB(0,0,0)|0;c[g+24>>2]=A;c[m+48>>2]=A;c[g>>2]=11;w=133}else if((w|0)==153){w=0;c[g>>2]=15;w=154}else if((w|0)==169){while(1){w=0;if(!((c[g+104>>2]|0)>>>0<(c[g+92>>2]|0)>>>0)){break}while(1){if(!(s>>>0<3)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0}A=g+104|0;x=c[A>>2]|0;c[A>>2]=x+1;b[g+112+((e[40904+(x<<1)>>1]|0)<<1)>>1]=r&7;r=r>>>3;s=s-3|0;w=169}while(1){D=g;if(!((c[g+104>>2]|0)>>>0<19)){break}x=D+104|0;A=c[x>>2]|0;c[x>>2]=A+1;b[g+112+((e[40904+(A<<1)>>1]|0)<<1)>>1]=0}c[g+108>>2]=D+1328;c[g+76>>2]=c[g+108>>2];c[g+84>>2]=7;v=SB(0,g+112|0,19,g+108|0,g+84|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=41176;c[g>>2]=29;continue a}else{c[g+104>>2]=0;c[g>>2]=18;w=179;break}}else if((w|0)==294){w=0;if((c[g+8>>2]|0)==0){w=302;break a}if((c[g+16>>2]|0)==0){w=302;break a}while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0}if((r|0)==(c[g+28>>2]|0)){w=301;break a}c[m+24>>2]=41448;c[g>>2]=29;continue a}}while(0);do{if((w|0)==51){while(1){w=0;if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0;w=51}if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+8>>2]=r&255;c[(c[g+32>>2]|0)+12>>2]=r>>>8}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=WB(c[g+24>>2]|0,l,2)|0}r=0;s=0;c[g>>2]=4;w=59}else if((w|0)==133){w=0;if((f|0)==5|(f|0)==6){break a}else{w=134}}else if((w|0)==154){w=0;E=c[g+64>>2]|0;if((E|0)==0){c[g>>2]=11;continue a}if(E>>>0>q>>>0){E=q}if(E>>>0>o>>>0){E=o}if((E|0)==0){break a}Haa(n|0,p|0,E|0)|0;q=q-E|0;p=p+E|0;o=o-E|0;n=n+E|0;A=g+64|0;c[A>>2]=(c[A>>2]|0)-E;continue a}else if((w|0)==179){c:while(1){w=0;if(!((c[g+104>>2]|0)>>>0<((c[g+96>>2]|0)+(c[g+100>>2]|0)|0)>>>0)){break}while(1){A=j;x=(c[g+76>>2]|0)+((r&(1<<c[g+84>>2])-1)<<2)|0;b[A+0>>1]=b[x+0>>1]|0;b[A+2>>1]=b[x+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}if((e[j+2>>1]|0|0)<16){r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;x=b[j+2>>1]|0;A=g+104|0;z=c[A>>2]|0;c[A>>2]=z+1;b[g+112+(z<<1)>>1]=x;w=179;continue}do{if((e[j+2>>1]|0|0)==16){while(1){if(!(s>>>0<((d[j+1|0]|0)+2|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;if((c[g+104>>2]|0)==0){w=190;break c}y=e[g+112+((c[g+104>>2]|0)-1<<1)>>1]|0;E=3+(r&3)|0;r=r>>>2;s=s-2|0}else{if((e[j+2>>1]|0|0)==17){while(1){if(!(s>>>0<((d[j+1|0]|0)+3|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;y=0;E=3+(r&7)|0;r=r>>>3;s=s-3|0;break}else{while(1){if(!(s>>>0<((d[j+1|0]|0)+7|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;y=0;E=11+(r&127)|0;r=r>>>7;s=s-7|0;break}}}while(0);if(((c[g+104>>2]|0)+E|0)>>>0>((c[g+96>>2]|0)+(c[g+100>>2]|0)|0)>>>0){w=202;break}while(1){x=E;E=x+ -1|0;if((x|0)==0){w=179;continue c}x=g+104|0;z=c[x>>2]|0;c[x>>2]=z+1;b[g+112+(z<<1)>>1]=y}}if((w|0)==190){w=0;c[m+24>>2]=41208;c[g>>2]=29}else if((w|0)==202){w=0;c[m+24>>2]=41208;c[g>>2]=29}if((c[g>>2]|0)==29){continue a}if((e[g+624>>1]|0|0)==0){c[m+24>>2]=41240;c[g>>2]=29;continue a}c[g+108>>2]=g+1328;c[g+76>>2]=c[g+108>>2];c[g+84>>2]=9;v=SB(1,g+112|0,c[g+96>>2]|0,g+108|0,g+84|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=41280;c[g>>2]=29;continue a}c[g+80>>2]=c[g+108>>2];c[g+88>>2]=6;v=SB(2,g+112+(c[g+96>>2]<<1)|0,c[g+100>>2]|0,g+108|0,g+88|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=41312;c[g>>2]=29;continue a}else{c[g>>2]=19;if((f|0)==6){break a}else{w=213;break}}}}while(0);if((w|0)==59){w=0;do{if((c[g+16>>2]&1024|0)!=0){while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+64>>2]=r;if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+20>>2]=r}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=WB(c[g+24>>2]|0,l,2)|0}r=0;s=0}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+16>>2]=0}}while(0);c[g>>2]=5;w=71}else if((w|0)==134){w=0;if((c[g+4>>2]|0)!=0){r=r>>>(s&7);s=s-(s&7)|0;c[g>>2]=26;continue}while(1){if(!(s>>>0<3)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+4>>2]=r&1;r=r>>>1;s=s-1|0;z=r&3;if((z|0)==0){c[g>>2]=13}else if((z|0)==1){OB(g);c[g>>2]=19;if((f|0)==6){w=142;break}}else if((z|0)==2){c[g>>2]=16}else if((z|0)==3){c[m+24>>2]=41080;c[g>>2]=29}r=r>>>2;s=s-2|0;continue}else if((w|0)==213){w=0;c[g>>2]=20;w=214}do{if((w|0)==71){w=0;if((c[g+16>>2]&1024|0)!=0){E=c[g+64>>2]|0;if(E>>>0>q>>>0){E=q}if((E|0)!=0){do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+16>>2]|0)==0){break}y=(c[(c[g+32>>2]|0)+20>>2]|0)-(c[g+64>>2]|0)|0;if((y+E|0)>>>0>(c[(c[g+32>>2]|0)+24>>2]|0)>>>0){F=(c[(c[g+32>>2]|0)+24>>2]|0)-y|0}else{F=E}Haa((c[(c[g+32>>2]|0)+16>>2]|0)+y|0,p|0,F|0)|0}}while(0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=WB(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;z=g+64|0;c[z>>2]=(c[z>>2]|0)-E}if((c[g+64>>2]|0)!=0){break a}}c[g+64>>2]=0;c[g>>2]=6;w=86}else if((w|0)==214){w=0;do{if(q>>>0>=6){if(!(o>>>0>=258)){break}c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;ZB(m,u);n=c[m+12>>2]|0;o=c[m+16>>2]|0;p=c[m>>2]|0;q=c[m+4>>2]|0;r=c[g+56>>2]|0;s=c[g+60>>2]|0;if((c[g>>2]|0)!=11){continue a}c[g+7108>>2]=-1;continue a}}while(0);c[g+7108>>2]=0;while(1){z=j;x=(c[g+76>>2]|0)+((r&(1<<c[g+84>>2])-1)<<2)|0;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}do{if((d[j]|0|0)!=0){if((a[j]&240|0)!=0){break}x=k;z=j;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;while(1){z=j;x=(c[g+76>>2]|0)+((e[k+2>>1]|0)+((r&(1<<(d[k+1|0]|0)+(d[k]|0))-1)>>>(d[k+1|0]|0))<<2)|0;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;if(((d[k+1|0]|0)+(d[j+1|0]|0)|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[k+1|0]|0);s=s-(d[k+1|0]|0)|0;x=g+7108|0;c[x>>2]=(c[x>>2]|0)+(d[k+1|0]|0)}}while(0);r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;x=g+7108|0;c[x>>2]=(c[x>>2]|0)+(d[j+1|0]|0);c[g+64>>2]=e[j+2>>1]|0;if((d[j]|0|0)==0){c[g>>2]=25;continue a}if((a[j]&32|0)!=0){c[g+7108>>2]=-1;c[g>>2]=11;continue a}if((a[j]&64|0)!=0){c[m+24>>2]=41336;c[g>>2]=29;continue a}else{c[g+72>>2]=a[j]&15;c[g>>2]=21;w=236;break}}}while(0);if((w|0)==86){w=0;do{if((c[g+16>>2]&2048|0)!=0){if((q|0)==0){break a}E=0;do{x=E;E=x+1|0;y=d[p+x|0]|0;do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+28>>2]|0)==0){break}if(!((c[g+64>>2]|0)>>>0<(c[(c[g+32>>2]|0)+32>>2]|0)>>>0)){break}x=g+64|0;z=c[x>>2]|0;c[x>>2]=z+1;a[(c[(c[g+32>>2]|0)+28>>2]|0)+z|0]=y}}while(0);if((y|0)==0){break}}while(E>>>0<q>>>0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=WB(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;if((y|0)!=0){break a}}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+28>>2]=0}}while(0);c[g+64>>2]=0;c[g>>2]=7;w=101}else if((w|0)==236){w=0;if((c[g+72>>2]|0)!=0){while(1){if(!(s>>>0<(c[g+72>>2]|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}z=g+64|0;c[z>>2]=(c[z>>2]|0)+(r&(1<<c[g+72>>2])-1);r=r>>>(c[g+72>>2]|0);s=s-(c[g+72>>2]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(c[g+72>>2]|0)}c[g+7112>>2]=c[g+64>>2];c[g>>2]=22;w=242}do{if((w|0)==101){w=0;do{if((c[g+16>>2]&4096|0)!=0){if((q|0)==0){break a}E=0;do{z=E;E=z+1|0;y=d[p+z|0]|0;do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+36>>2]|0)==0){break}if(!((c[g+64>>2]|0)>>>0<(c[(c[g+32>>2]|0)+40>>2]|0)>>>0)){break}z=g+64|0;x=c[z>>2]|0;c[z>>2]=x+1;a[(c[(c[g+32>>2]|0)+36>>2]|0)+x|0]=y}}while(0);if((y|0)==0){break}}while(E>>>0<q>>>0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=WB(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;if((y|0)!=0){break a}}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+36>>2]=0}}while(0);c[g>>2]=8;w=116}else if((w|0)==242){while(1){w=0;x=j;z=(c[g+80>>2]|0)+((r&(1<<c[g+88>>2])-1)<<2)|0;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0;w=242}if((a[j]&240|0)==0){z=k;x=j;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;while(1){x=j;z=(c[g+80>>2]|0)+((e[k+2>>1]|0)+((r&(1<<(d[k+1|0]|0)+(d[k]|0))-1)>>>(d[k+1|0]|0))<<2)|0;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;if(((d[k+1|0]|0)+(d[j+1|0]|0)|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}r=r>>>(d[k+1|0]|0);s=s-(d[k+1|0]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(d[k+1|0]|0)}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(d[j+1|0]|0);if((a[j]&64|0)!=0){c[m+24>>2]=41368;c[g>>2]=29;continue a}else{c[g+68>>2]=e[j+2>>1]|0;c[g+72>>2]=a[j]&15;c[g>>2]=23;w=254;break}}}while(0);if((w|0)==116){w=0;do{if((c[g+16>>2]&512|0)!=0){while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}if((r|0)!=(c[g+24>>2]&65535|0)){c[m+24>>2]=41056;c[g>>2]=29;continue a}else{r=0;s=0;break}}}while(0);if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+44>>2]=c[g+16>>2]>>9&1;c[(c[g+32>>2]|0)+48>>2]=1}z=WB(0,0,0)|0;c[g+24>>2]=z;c[m+48>>2]=z;c[g>>2]=11;continue}else if((w|0)==254){w=0;if((c[g+72>>2]|0)!=0){while(1){if(!(s>>>0<(c[g+72>>2]|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}z=g+68|0;c[z>>2]=(c[z>>2]|0)+(r&(1<<c[g+72>>2])-1);r=r>>>(c[g+72>>2]|0);s=s-(c[g+72>>2]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(c[g+72>>2]|0)}c[g>>2]=24}if((o|0)==0){break}E=u-o|0;do{if((c[g+68>>2]|0)>>>0>E>>>0){E=(c[g+68>>2]|0)-E|0;do{if(E>>>0>(c[g+44>>2]|0)>>>0){if((c[g+7104>>2]|0)==0){break}c[m+24>>2]=41392;c[g>>2]=29;continue a}}while(0);z=g;if(E>>>0>(c[g+48>>2]|0)>>>0){E=E-(c[z+48>>2]|0)|0;G=(c[g+52>>2]|0)+((c[g+40>>2]|0)-E)|0}else{G=(c[z+52>>2]|0)+((c[g+48>>2]|0)-E)|0}if(!(E>>>0>(c[g+64>>2]|0)>>>0)){break}E=c[g+64>>2]|0}else{G=n+(0-(c[g+68>>2]|0))|0;E=c[g+64>>2]|0}}while(0);if(E>>>0>o>>>0){E=o}o=o-E|0;z=g+64|0;c[z>>2]=(c[z>>2]|0)-E;do{z=G;G=z+1|0;x=n;n=x+1|0;a[x]=a[z]|0;z=E+ -1|0;E=z;}while((z|0)!=0);if((c[g+64>>2]|0)!=0){continue}c[g>>2]=20}if((w|0)==131){c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;H=2;I=H;i=h;return I|0}else if((w|0)==142){r=r>>>2;s=s-2|0}else if((w|0)==301){r=0;s=0;w=302}else if((w|0)==304){v=-3}else if((w|0)==305){H=-4;I=H;i=h;return I|0}else if((w|0)==306){H=-2;I=H;i=h;return I|0}if((w|0)==302){c[g>>2]=28;w=303}if((w|0)==303){v=1}c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;do{if((c[g+40>>2]|0)!=0){w=312}else{if((u|0)==(c[m+16>>2]|0)){break}if(!((c[g>>2]|0)>>>0<29)){break}if((c[g>>2]|0)>>>0<26){w=312;break}if((f|0)!=4){w=312}}}while(0);do{if((w|0)==312){if((PB(m,c[m+12>>2]|0,u-(c[m+16>>2]|0)|0)|0)==0){break}c[g>>2]=30;H=-4;I=H;i=h;return I|0}}while(0);t=t-(c[m+4>>2]|0)|0;u=u-(c[m+16>>2]|0)|0;s=m+8|0;c[s>>2]=(c[s>>2]|0)+t;s=m+20|0;c[s>>2]=(c[s>>2]|0)+u;s=g+28|0;c[s>>2]=(c[s>>2]|0)+u;do{if((c[g+8>>2]|0)!=0){if((u|0)==0){break}s=c[g+24>>2]|0;r=(c[m+12>>2]|0)+(0-u)|0;q=u;if((c[g+16>>2]|0)!=0){J=WB(s,r,q)|0}else{J=VB(s,r,q)|0}c[g+24>>2]=J;c[m+48>>2]=J}}while(0);if((c[g>>2]|0)==19){K=1}else{K=(c[g>>2]|0)==14}c[m+44>>2]=(c[g+60>>2]|0)+((c[g+4>>2]|0)!=0?64:0)+((c[g>>2]|0)==11?128:0)+(K?256:0);if((t|0)==0){if((u|0)==0){w=325}else{w=324}}else{w=324}if((w|0)==324){if((f|0)==4){w=325}}do{if((w|0)==325){if((v|0)!=0){break}v=-5}}while(0);H=v;I=H;i=h;return I|0}}while(0);H=-2;I=H;i=h;return I|0}function OB(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d+76>>2]=41472;c[d+84>>2]=9;c[d+80>>2]=43520;c[d+88>>2]=5;i=b;return}function PB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=a;a=b;b=d;d=c[f+28>>2]|0;do{if((c[d+52>>2]|0)==0){c[d+52>>2]=se[c[f+32>>2]&63](c[f+40>>2]|0,1<<c[d+36>>2],1)|0;if((c[d+52>>2]|0)!=0){break}g=1;h=g;i=e;return h|0}}while(0);if((c[d+40>>2]|0)==0){c[d+40>>2]=1<<c[d+36>>2];c[d+48>>2]=0;c[d+44>>2]=0}f=d;do{if(b>>>0>=(c[d+40>>2]|0)>>>0){Haa(c[f+52>>2]|0,a+(0-(c[d+40>>2]|0))|0,c[d+40>>2]|0)|0;c[d+48>>2]=0;c[d+44>>2]=c[d+40>>2]}else{j=(c[f+40>>2]|0)-(c[d+48>>2]|0)|0;if(j>>>0>b>>>0){j=b}Haa((c[d+52>>2]|0)+(c[d+48>>2]|0)|0,a+(0-b)|0,j|0)|0;b=b-j|0;if((b|0)!=0){Haa(c[d+52>>2]|0,a+(0-b)|0,b|0)|0;c[d+48>>2]=b;c[d+44>>2]=c[d+40>>2];break}k=d+48|0;c[k>>2]=(c[k>>2]|0)+j;if((c[d+48>>2]|0)==(c[d+40>>2]|0)){c[d+48>>2]=0}if(!((c[d+44>>2]|0)>>>0<(c[d+40>>2]|0)>>>0)){break}k=d+44|0;c[k>>2]=(c[k>>2]|0)+j}}while(0);g=0;h=g;i=e;return h|0}function QB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}if((c[d+36>>2]|0)==0){break}a=c[d+28>>2]|0;if((c[a+52>>2]|0)!=0){ne[c[d+36>>2]&127](c[d+40>>2]|0,c[a+52>>2]|0)}ne[c[d+36>>2]&127](c[d+40>>2]|0,c[d+28>>2]|0);c[d+28>>2]=0;e=0;f=e;i=b;return f|0}}while(0);e=-2;f=e;i=b;return f|0}function RB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=b;b=d;do{if((f|0)!=0){if((b|0)==0){break}if((c[b+28>>2]|0)==0){break}if((c[b+32>>2]|0)==0){break}if((c[b+36>>2]|0)==0){break}d=c[b+28>>2]|0;g=se[c[b+32>>2]&63](c[b+40>>2]|0,1,7116)|0;if((g|0)==0){h=-4;j=h;i=e;return j|0}k=0;do{if((c[d+52>>2]|0)!=0){k=se[c[b+32>>2]&63](c[b+40>>2]|0,1<<c[d+36>>2],1)|0;if((k|0)!=0){break}ne[c[b+36>>2]&127](c[b+40>>2]|0,g);h=-4;j=h;i=e;return j|0}}while(0);l=f+0|0;m=b+0|0;n=l+56|0;do{a[l]=a[m]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));Haa(g|0,d|0,7116)|0;do{if((c[d+76>>2]|0)>>>0>=(d+1328|0)>>>0){if(!((c[d+76>>2]|0)>>>0<=(d+7104+ -4|0)>>>0)){break}c[g+76>>2]=g+1328+((((c[d+76>>2]|0)-(d+1328)|0)/4|0)<<2);c[g+80>>2]=g+1328+((((c[d+80>>2]|0)-(d+1328)|0)/4|0)<<2)}}while(0);c[g+108>>2]=g+1328+((((c[d+108>>2]|0)-(d+1328)|0)/4|0)<<2);if((k|0)!=0){Haa(k|0,c[d+52>>2]|0,1<<c[d+36>>2]|0)|0}c[g+52>>2]=k;c[f+28>>2]=g;h=0;j=h;i=e;return j|0}}while(0);h=-2;j=h;i=e;return j|0}function SB(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+272|0;m=l+168|0;n=l+208|0;o=l+240|0;p=d;d=f;f=g;g=h;h=j;j=k;k=0;while(1){if(!(k>>>0<=15)){break}b[n+(k<<1)>>1]=0;k=k+1|0}q=0;while(1){if(!(q>>>0<f>>>0)){break}r=n+((e[d+(q<<1)>>1]|0)<<1)|0;b[r>>1]=(b[r>>1]|0)+1<<16>>16;q=q+1|0}r=c[h>>2]|0;s=15;while(1){if(!(s>>>0>=1)){break}if((e[n+(s<<1)>>1]|0|0)!=0){break}s=s+ -1|0}if(r>>>0>s>>>0){r=s}if((s|0)==0){a[m]=64;a[m+1|0]=1;b[m+2>>1]=0;t=g;u=c[t>>2]|0;c[t>>2]=u+4;t=u;u=m;b[t+0>>1]=b[u+0>>1]|0;b[t+2>>1]=b[u+2>>1]|0;u=g;t=c[u>>2]|0;c[u>>2]=t+4;u=t;t=m;b[u+0>>1]=b[t+0>>1]|0;b[u+2>>1]=b[t+2>>1]|0;c[h>>2]=1;v=0;w=v;i=l;return w|0}t=1;while(1){if(!(t>>>0<s>>>0)){break}if((e[n+(t<<1)>>1]|0|0)!=0){break}t=t+1|0}if(r>>>0<t>>>0){r=t}u=1;k=1;while(1){x=u;if(!(k>>>0<=15)){break}u=x<<1;u=u-(e[n+(k<<1)>>1]|0)|0;if((u|0)<0){y=24;break}k=k+1|0}if((y|0)==24){v=-1;w=v;i=l;return w|0}do{if((x|0)>0){if((p|0)!=0){if((s|0)==1){break}}v=-1;w=v;i=l;return w|0}}while(0);b[o+2>>1]=0;k=1;while(1){if(!(k>>>0<15)){break}b[o+(k+1<<1)>>1]=(e[o+(k<<1)>>1]|0)+(e[n+(k<<1)>>1]|0);k=k+1|0}q=0;while(1){if(!(q>>>0<f>>>0)){break}if((e[d+(q<<1)>>1]|0|0)!=0){x=o+((e[d+(q<<1)>>1]|0)<<1)|0;z=b[x>>1]|0;b[x>>1]=z+1<<16>>16;b[j+((z&65535)<<1)>>1]=q}q=q+1|0}o=p;if((o|0)==0){f=j;A=f;B=f;C=19}else if((o|0)==1){B=43648;B=B+ -514|0;A=43712;A=A+ -514|0;C=256}else{B=43776;A=43840;C=-1}o=0;q=0;k=t;f=c[g>>2]|0;z=r;x=0;D=-1;E=1<<r;F=E-1|0;if((p|0)==1){if(!(E>>>0>852)){y=44}}else{y=44}do{if((y|0)==44){if((p|0)==2){if(E>>>0>592){break}}while(1){a[m+1|0]=k-x;do{if((e[j+(q<<1)>>1]|0|0)<(C|0)){a[m]=0;b[m+2>>1]=b[j+(q<<1)>>1]|0}else{if((e[j+(q<<1)>>1]|0|0)>(C|0)){a[m]=b[A+((e[j+(q<<1)>>1]|0)<<1)>>1];b[m+2>>1]=b[B+((e[j+(q<<1)>>1]|0)<<1)>>1]|0;break}else{a[m]=96;b[m+2>>1]=0;break}}}while(0);G=1<<k-x;H=1<<z;t=H;do{H=H-G|0;I=f+((o>>>x)+H<<2)|0;J=m;b[I+0>>1]=b[J+0>>1]|0;b[I+2>>1]=b[J+2>>1]|0;}while((H|0)!=0);G=1<<k-1;while(1){K=G;if((o&G|0)==0){break}G=K>>>1}if((K|0)!=0){o=o&G-1;o=o+G|0}else{o=0}q=q+1|0;H=n+(k<<1)|0;J=(b[H>>1]|0)+ -1<<16>>16;b[H>>1]=J;if((J&65535|0)==0){if((k|0)==(s|0)){break}k=e[d+((e[j+(q<<1)>>1]|0)<<1)>>1]|0}if(!(k>>>0>r>>>0)){continue}if((o&F|0)==(D|0)){continue}if((x|0)==0){x=r}f=f+(t<<2)|0;z=k-x|0;u=1<<z;while(1){if(!((z+x|0)>>>0<s>>>0)){break}u=u-(e[n+(z+x<<1)>>1]|0)|0;if((u|0)<=0){break}z=z+1|0;u=u<<1}E=E+(1<<z)|0;if((p|0)==1){if(E>>>0>852){y=75;break}}if((p|0)==2){if(E>>>0>592){y=75;break}}D=o&F;a[(c[g>>2]|0)+(D<<2)|0]=z;a[(c[g>>2]|0)+(D<<2)+1|0]=r;b[(c[g>>2]|0)+(D<<2)+2>>1]=(f-(c[g>>2]|0)|0)/4|0}if((y|0)==75){v=1;w=v;i=l;return w|0}if((o|0)!=0){a[m]=64;a[m+1|0]=k-x;b[m+2>>1]=0;G=f+(o<<2)|0;J=m;b[G+0>>1]=b[J+0>>1]|0;b[G+2>>1]=b[J+2>>1]|0}J=g;c[J>>2]=(c[J>>2]|0)+(E<<2);c[h>>2]=r;v=0;w=v;i=l;return w|0}}while(0);v=1;w=v;i=l;return w|0}function TB(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=b;b=c;if((a|0)!=0){e=e+(b-b)|0}a=baa(fa(e,b)|0)|0;i=d;return a|0}function UB(a,b){a=a|0;b=b|0;a=i;i=i+16|0;caa(b);i=a;return}function VB(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=a;a=b;b=c;c=f>>>16&65535;f=f&65535;g=a;if((b|0)==1){f=f+(d[g]|0)|0;if(f>>>0>=65521){f=f-65521|0}c=c+f|0;if(c>>>0>=65521){c=c-65521|0}h=f|c<<16;j=h;i=e;return j|0}if((g|0)==0){h=1;j=h;i=e;return j|0}if(b>>>0<16){while(1){g=b;b=g+ -1|0;if((g|0)==0){break}g=a;a=g+1|0;f=f+(d[g]|0)|0;c=c+f|0}if(f>>>0>=65521){f=f-65521|0}c=(c>>>0)%65521|0;h=f|c<<16;j=h;i=e;return j|0}while(1){k=b;if(!(b>>>0>=5552)){break}b=k-5552|0;g=347;do{f=f+(d[a]|0)|0;c=c+f|0;f=f+(d[a+1|0]|0)|0;c=c+f|0;f=f+(d[a+2|0]|0)|0;c=c+f|0;f=f+(d[a+3|0]|0)|0;c=c+f|0;f=f+(d[a+4|0]|0)|0;c=c+f|0;f=f+(d[a+5|0]|0)|0;c=c+f|0;f=f+(d[a+6|0]|0)|0;c=c+f|0;f=f+(d[a+7|0]|0)|0;c=c+f|0;f=f+(d[a+8|0]|0)|0;c=c+f|0;f=f+(d[a+9|0]|0)|0;c=c+f|0;f=f+(d[a+10|0]|0)|0;c=c+f|0;f=f+(d[a+11|0]|0)|0;c=c+f|0;f=f+(d[a+12|0]|0)|0;c=c+f|0;f=f+(d[a+13|0]|0)|0;c=c+f|0;f=f+(d[a+14|0]|0)|0;c=c+f|0;f=f+(d[a+15|0]|0)|0;c=c+f|0;a=a+16|0;l=g+ -1|0;g=l;}while((l|0)!=0);f=(f>>>0)%65521|0;c=(c>>>0)%65521|0}if((k|0)!=0){while(1){if(!(b>>>0>=16)){break}b=b-16|0;f=f+(d[a]|0)|0;c=c+f|0;f=f+(d[a+1|0]|0)|0;c=c+f|0;f=f+(d[a+2|0]|0)|0;c=c+f|0;f=f+(d[a+3|0]|0)|0;c=c+f|0;f=f+(d[a+4|0]|0)|0;c=c+f|0;f=f+(d[a+5|0]|0)|0;c=c+f|0;f=f+(d[a+6|0]|0)|0;c=c+f|0;f=f+(d[a+7|0]|0)|0;c=c+f|0;f=f+(d[a+8|0]|0)|0;c=c+f|0;f=f+(d[a+9|0]|0)|0;c=c+f|0;f=f+(d[a+10|0]|0)|0;c=c+f|0;f=f+(d[a+11|0]|0)|0;c=c+f|0;f=f+(d[a+12|0]|0)|0;c=c+f|0;f=f+(d[a+13|0]|0)|0;c=c+f|0;f=f+(d[a+14|0]|0)|0;c=c+f|0;f=f+(d[a+15|0]|0)|0;c=c+f|0;a=a+16|0}while(1){k=b;b=k+ -1|0;if((k|0)==0){break}k=a;a=k+1|0;f=f+(d[k]|0)|0;c=c+f|0}f=(f>>>0)%65521|0;c=(c>>>0)%65521|0}h=f|c<<16;j=h;i=e;return j|0}function WB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+40|0;g=f+32|0;h=d;do{if((h|0)==0){j=0}else{c[g>>2]=1;d=b;k=h;l=e;if((a[g]|0)!=0){j=XB(d,k,l)|0;break}else{j=YB(d,k,l)|0;break}}}while(0);i=f;return j|0}function XB(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=b;b=e;e=a;e=~e;while(1){if((b|0)==0){break}if((g&3|0)==0){break}a=g;g=a+1|0;e=c[43904+(((e^(d[a]|0))&255)<<2)>>2]^e>>>8;b=b+ -1|0}a=g;while(1){if(!(b>>>0>=32)){break}h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];b=b-32|0}while(1){j=a;if(!(b>>>0>=4)){break}a=j+4|0;e=e^c[j>>2];e=c[46976+((e&255)<<2)>>2]^c[45952+((e>>>8&255)<<2)>>2]^c[44928+((e>>>16&255)<<2)>>2]^c[43904+(e>>>24<<2)>>2];b=b-4|0}g=j;if((b|0)==0){k=e;l=~k;e=l;m=e;i=f;return m|0}do{j=g;g=j+1|0;e=c[43904+(((e^(d[j]|0))&255)<<2)>>2]^e>>>8;j=b+ -1|0;b=j;}while((j|0)!=0);k=e;l=~k;e=l;m=e;i=f;return m|0}



function hj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+320|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}ej(c[a+536>>2]|0,c[e>>2]|0);caa(c[d>>2]|0);c[d>>2]=0;i=b;return}function ij(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2968>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7144,7136,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}function jj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+560>>3],+h[f+18720>>3],+h[f+18728>>3],+h[f+18736>>3],+h[f+18744>>3],+h[f+18752>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[d>>3];i=b;return}function kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3];k=+h[(c[b+416>>2]|0)+18760>>3];l=+h[g+2968>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,7184,7176,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+568>>3]=j*n*1256637061435917.0e-21;i=d;return}function lj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+568>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+576|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7224,7216,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+576|0;p=o;h[p>>3]=m;i=d;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+696>>3]*+h[b+576>>3]);i=i;return}function nj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2960>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7264,7256,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}function oj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+616>>3],+h[f+18648>>3],+h[f+18656>>3],+h[f+18664>>3],+h[f+18672>>3],+h[f+18680>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[d>>3];i=b;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18696>>3];m=+h[j+18704>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,7304,7296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,7336,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+600>>3];m=+da(+n);n=+h[(c[g>>2]|0)+18688>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,7464,7296,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+624>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7552,7544,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=-(+h[b+696>>3]*+h[b+632>>3]);i=i;return}function sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2952>>3];k=+h[g+696>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,7592,7584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+672>>3],+h[f+18576>>3],+h[f+18584>>3],+h[f+18592>>3],+h[f+18600>>3],+h[f+18608>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+656>>3]=+h[d>>3];i=b;return}function uj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18624>>3];m=+h[j+18632>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,7632,7624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,7664,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+656>>3];m=+da(+n);n=+h[(c[g>>2]|0)+18616>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,7792,7624,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+680>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7880,7872,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}function wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+696>>3]*+h[b+688>>3];i=i;return}function xj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2944>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7920,7912,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}function yj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+736>>3],+h[f+18504>>3],+h[f+18512>>3],+h[f+18520>>3],+h[f+18528>>3],+h[f+18536>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+720>>3]=+h[d>>3];i=b;return}function zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3];k=+h[(c[b+416>>2]|0)+18544>>3];l=+h[g+2944>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,7960,7952,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+744>>3]=j*n*1256637061435917.0e-21;i=d;return}function Aj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+744>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+752|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8e3,7992,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+752|0;p=o;h[p>>3]=m;i=d;return}function Bj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+760>>3]=-(+h[b+696>>3]*+h[b+752>>3]);i=i;return}function Cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+696>>3]+(-+h[b+520>>3]- +h[b+216>>3]);i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b>>3]=-+h[b+312>>3]- +h[b+696>>3];i=i;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b>>3]*+h[b+240>>3];i=i;return}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+488>>3],+h[f+18816>>3],+h[f+18824>>3],+h[f+18832>>3],+h[f+18840>>3],+h[f+18848>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[d>>3];i=b;return}function Gj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+472>>3];k=+h[(c[b+416>>2]|0)+18856>>3];l=+h[g+2992>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8048,8040,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+496>>3]=j*n*1256637061435917.0e-21;i=d;return}function Hj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+496>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8088,8080,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+504|0;p=o;h[p>>3]=m;i=d;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=-(+h[b+784>>3]*+h[b+504>>3]);i=i;return}function Jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+792>>3]- +h[b+512>>3];i=i;return}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+312>>3]*+h[b+296>>3];i=i;return}function Lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+816>>3]- +h[b+320>>3];i=i;return}function Mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+328>>3]- +h[b+584>>3];i=i;return}function Nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+592>>3]- +h[b+640>>3];i=i;return}function Oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+648>>3]- +h[b+760>>3];i=i;return}function Pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+536>>3]=-+h[b+704>>3]- +h[b+712>>3];i=i;return}function Qj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+3104>>3];h[e+8>>3]=+h[d+3080>>3];h[f+8>>3]=+h[d+3088>>3];h[a+16>>3]=+h[d+4448>>3];h[e+16>>3]=+h[d+4424>>3];h[f+16>>3]=+h[d+4432>>3];h[a+24>>3]=+h[d+11056>>3];h[e+24>>3]=+h[d+11032>>3];h[f+24>>3]=+h[d+11040>>3];h[a+32>>3]=+h[d+6912>>3];h[e+32>>3]=+h[d+6888>>3];h[f+32>>3]=+h[d+6896>>3];h[a+40>>3]=+h[d+9824>>3];h[e+40>>3]=+h[d+9800>>3];h[f+40>>3]=+h[d+9808>>3];i=i;return}function Rj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+520>>3]=+h[b>>3];h[a+216>>3]=+h[b+8>>3];h[a+312>>3]=+h[b+16>>3];h[a+784>>3]=+h[b+24>>3];h[a+488>>3]=+h[b+32>>3];h[a+696>>3]=+h[b+40>>3];ij(f);jj(f);kj(f);lj(f);mj(f);nj(f);oj(f);pj(f);qj(f);rj(f);sj(f);tj(f);uj(f);vj(f);wj(f);xj(f);yj(f);zj(f);Aj(f);Bj(f);Cj(f);Dj(f);Ej(f);Fj(f);Gj(f);Hj(f);Ij(f);Jj(f);Kj(f);Lj(f);Mj(f);Nj(f);Oj(f);Pj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+256>>3]+(+h[f+328>>3]- +h[f+816>>3]);g=f+784|0;h[d+8>>3]=+h[f+488>>3]*+h[f+2992>>3]+ +h[g>>3];h[d+16>>3]=+h[g>>3]+(+h[f+312>>3]+ +h[f>>3]);g=f+536|0;h[d+24>>3]=+h[g>>3]- +h[f+528>>3]*+h[f+2920>>3];h[d+32>>3]=+h[g>>3]- +h[f+216>>3]*+h[f+2888>>3];h[d+40>>3]=+h[g>>3]- +h[f+520>>3]*+h[f+2912>>3];i=e;return}function Sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2792>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8128,8120,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}function Tj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1664>>3],+h[f+17688>>3],+h[f+17696>>3],+h[f+17704>>3],+h[f+17712>>3],+h[f+17720>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[d>>3];i=b;return}function Uj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1648>>3];k=+h[(c[b+416>>2]|0)+17728>>3];l=+h[g+2792>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8168,8160,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1672>>3]=j*n*1256637061435917.0e-21;i=d;return}function Vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1680|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8208,8200,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1680|0;p=o;h[p>>3]=m;i=d;return}function Wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=-(+h[b+2080>>3]*+h[b+1680>>3]);i=i;return}function Xj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8248,8240,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}function Yj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1720>>3],+h[f+17616>>3],+h[f+17624>>3],+h[f+17632>>3],+h[f+17640>>3],+h[f+17648>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1704>>3]=+h[d>>3];i=b;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17664>>3];m=+h[j+17672>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,8288,8280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,8328,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+1704>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17656>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,8464,8280,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}function _j(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1728>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1736|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8560,8552,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1736|0;p=o;h[p>>3]=m;i=d;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=-(+h[b+2080>>3]*+h[b+1736>>3]);i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8608,8600,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}function bk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1888>>3],+h[f+17400>>3],+h[f+17408>>3],+h[f+17416>>3],+h[f+17424>>3],+h[f+17432>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[d>>3];i=b;return}function ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1872>>3];k=+h[(c[b+416>>2]|0)+17440>>3];l=+h[g+2760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8656,8648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1896>>3]=j*n*1256637061435917.0e-21;i=d;return}function dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1904|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8704,8696,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1904|0;p=o;h[p>>3]=m;i=d;return}function ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=-(+h[b+2080>>3]*+h[b+1904>>3]);i=i;return}function fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2768>>3];k=+h[g+1856>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,8752,8744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}function gk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1832>>3],+h[f+17472>>3],+h[f+17480>>3],+h[f+17488>>3],+h[f+17496>>3],+h[f+17504>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1816>>3]=+h[d>>3];i=b;return}function hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=+h[(c[b+416>>2]|0)+17512>>3];l=+h[g+2768>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8800,8792,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1840>>3]=j*n*1256637061435917.0e-21;i=d;return}function ik(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1848|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8848,8840,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1848|0;p=o;h[p>>3]=m;i=d;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+1856>>3]*+h[b+1848>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+2080>>3]+ +h[b+1856>>3];i=i;return}function lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+1592>>3]*+h[b+2656>>3];i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=-+h[b+1272>>3]-(+h[b+1624>>3]+ +h[b+1856>>3]+ +h[b+1568>>3]);i=i;return}function nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2776>>3];k=+h[g+1856>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8896,8888,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}function ok(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3],+h[f+17544>>3],+h[f+17552>>3],+h[f+17560>>3],+h[f+17568>>3],+h[f+17576>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1760>>3]=+h[d>>3];i=b;return}function pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17592>>3];m=+h[j+17600>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,8936,8928,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,8976,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+1760>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17584>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,9112,8928,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}function qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,9208,9200,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}function rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=-(+h[b+1856>>3]*+h[b+1792>>3]);i=i;return}function sk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1536>>3],+h[f+17864>>3],+h[f+17872>>3],+h[f+17880>>3],+h[f+17888>>3],+h[f+17896>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1520>>3]=+h[d>>3];i=b;return}function tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1520>>3];k=+h[(c[b+416>>2]|0)+17904>>3];l=+h[g+2832>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,9256,9248,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1544>>3]=j*n*1256637061435917.0e-21;i=d;return}function uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,9296,9288,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1552|0;p=o;h[p>>3]=m;i=d;return}function vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=-(+h[b+2032>>3]*+h[b+1552>>3]);i=i;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+2040>>3]- +h[b+1560>>3];i=i;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+1616>>3]- +h[b+1600>>3];i=i;return}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+1608>>3]- +h[b+1864>>3];i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=-+h[b+1800>>3]- +h[b+1808>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=+h[b+1912>>3]+ +h[b+1608>>3];i=i;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+1744>>3]+ +h[b+1752>>3];i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+1688>>3]+ +h[b+1696>>3];i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+2120>>3]- +h[b+2088>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24>>3]=-+h[b+2032>>3]- +h[b+1368>>3]- +h[b+1592>>3];i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1616>>3]- +h[b+2112>>3];i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1376>>3]=+h[b+1616>>3]- +h[b+2112>>3];i=i;return}function Hk(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+22032>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+22008>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+22016>>3];h[a+8>>3]=+h[d+22816>>3];h[e+8>>3]=+h[d+22792>>3];h[f+8>>3]=+h[d+22800>>3];h[a+16>>3]=+h[d+17888>>3];h[e+16>>3]=+h[d+17864>>3];h[f+16>>3]=+h[d+17872>>3];h[a+24>>3]=+h[d+19232>>3];h[e+24>>3]=+h[d+19208>>3];h[f+24>>3]=+h[d+19216>>3];h[a+32>>3]=+h[d+28528>>3];h[e+32>>3]=+h[d+28504>>3];h[f+32>>3]=+h[d+28512>>3];h[a+40>>3]=+h[d+21584>>3];h[e+40>>3]=+h[d+21560>>3];h[f+40>>3]=+h[d+21568>>3];h[a+48>>3]=+h[d+26064>>3];h[e+48>>3]=+h[d+26040>>3];h[f+48>>3]=+h[d+26048>>3];h[a+56>>3]=+h[d+29200>>3];h[e+56>>3]=+h[d+29176>>3];h[f+56>>3]=+h[d+29184>>3];i=i;return}function Ik(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1568>>3]=+h[b>>3];h[a+1624>>3]=+h[b+8>>3];h[a+1272>>3]=+h[b+16>>3];h[a+1368>>3]=+h[b+24>>3];h[a+2032>>3]=+h[b+32>>3];h[a+1536>>3]=+h[b+40>>3];h[a+1856>>3]=+h[b+48>>3];h[a+2080>>3]=+h[b+56>>3];Sj(f);Tj(f);Uj(f);Vj(f);Wj(f);Xj(f);Yj(f);Zj(f);_j(f);$j(f);ak(f);bk(f);ck(f);dk(f);ek(f);fk(f);gk(f);hk(f);ik(f);jk(f);kk(f);lk(f);mk(f);nk(f);ok(f);pk(f);qk(f);rk(f);sk(f);tk(f);uk(f);vk(f);wk(f);xk(f);yk(f);zk(f);Ak(f);Bk(f);Ck(f);Dk(f);Ek(f);Fk(f);Gk(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1368|0;h[d>>3]=+h[f+1376>>3]- +h[g>>3]*+h[f+1352>>3];b=f+1640|0;h[d+8>>3]=+h[b>>3]- +h[f+1632>>3]*+h[f+2704>>3];a=f+24|0;h[d+16>>3]=+h[f+1312>>3]- +h[a>>3]*+h[f+1296>>3];h[d+24>>3]=+h[f+1536>>3]*+h[f+2832>>3]+ +h[f+2032>>3];h[d+32>>3]=-+h[f+2080>>3]- +h[g>>3]- +h[a>>3];h[d+40>>3]=+h[b>>3]- +h[f+1272>>3]*+h[f+2664>>3];h[d+48>>3]=+h[b>>3]- +h[f+1624>>3]*+h[f+2696>>3];h[d+56>>3]=+h[b>>3]- +h[f+1568>>3]*+h[f+2680>>3];i=e;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=-+h[b>>3]- +h[b+696>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+536>>3]=+h[b+520>>3]*+h[b+2912>>3];i=i;return}function Lk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2888>>3];k=+h[g+536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,9336,9328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+216|0;p=o;h[p>>3]=m;i=d;return}function Mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2920>>3];k=+h[g+536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+528|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+528|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,9376,9368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+528|0;p=o;h[p>>3]=m;i=d;return}function Nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2944>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7920,9408,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+736|0;q=p;h[q>>3]=n;i=d;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+736>>3],+h[f+18504>>3],+h[f+18512>>3],+h[f+18520>>3],+h[f+18528>>3],+h[f+18536>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+720>>3]=+h[d>>3];i=b;return}function Pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3];k=+h[(c[b+416>>2]|0)+18544>>3];l=+h[g+2944>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,7960,9416,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+744>>3]=j*n*1256637061435917.0e-21;i=d;return}function Qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+744>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+752|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8e3,9424,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+752|0;p=o;h[p>>3]=m;i=d;return}function Rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+760>>3]=-(+h[b+696>>3]*+h[b+752>>3]);i=i;return}function Sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2952>>3];k=+h[g+696>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,7592,9432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+672|0;p=o;h[p>>3]=m;i=d;return}function Tk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+672>>3],+h[f+18576>>3],+h[f+18584>>3],+h[f+18592>>3],+h[f+18600>>3],+h[f+18608>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+656>>3]=+h[d>>3];i=b;return}function Uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18624>>3];m=+h[j+18632>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,7632,9440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,7664,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+656>>3];m=+da(+n);n=+h[(c[g>>2]|0)+18616>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,7792,9440,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+680|0;x=w;h[x>>3]=u;i=d;return}function Vk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+680>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7880,9448,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}function Wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+696>>3]*+h[b+688>>3];i=i;return}function Xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=-+h[b+704>>3]- +h[b+536>>3];i=i;return}function Yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+760>>3]+ +h[b+712>>3];i=i;return}function Zk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2960>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7264,9456,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+616|0;q=p;h[q>>3]=n;i=d;return}function _k(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+616>>3],+h[f+18648>>3],+h[f+18656>>3],+h[f+18664>>3],+h[f+18672>>3],+h[f+18680>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+600>>3]=+h[d>>3];i=b;return}function $k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+18696>>3];m=+h[j+18704>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,7304,9464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,7336,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+600>>3];m=+da(+n);n=+h[(c[g>>2]|0)+18688>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,7464,9464,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+624|0;x=w;h[x>>3]=u;i=d;return}function al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+624>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7552,9472,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+632|0;p=o;h[p>>3]=m;i=d;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=-(+h[b+696>>3]*+h[b+632>>3]);i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+640>>3]+ +h[b+648>>3];i=i;return}function dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2968>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,7144,9480,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+560>>3],+h[f+18720>>3],+h[f+18728>>3],+h[f+18736>>3],+h[f+18744>>3],+h[f+18752>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[d>>3];i=b;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+544>>3];k=+h[(c[b+416>>2]|0)+18760>>3];l=+h[g+2968>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,7184,9488,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+568>>3]=j*n*1256637061435917.0e-21;i=d;return}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+568>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+576|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,7224,9496,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+576|0;p=o;h[p>>3]=m;i=d;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=-(+h[b+696>>3]*+h[b+576>>3]);i=i;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=+h[b+584>>3]+ +h[b+592>>3];i=i;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+256>>3]+ +h[b+328>>3];i=i;return}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=+h[b+312>>3]*+h[b+296>>3];i=i;return}function ll(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+9824>>3];h[e+8>>3]=+h[d+9800>>3];h[f+8>>3]=+h[d+9808>>3];i=i;return}function ml(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+520>>3]=+h[b>>3];h[a+696>>3]=+h[b+8>>3];Jk(f);Kk(f);Lk(f);Mk(f);Nk(f);Ok(f);Pk(f);Qk(f);Rk(f);Sk(f);Tk(f);Uk(f);Vk(f);Wk(f);Xk(f);Yk(f);Zk(f);_k(f);$k(f);al(f);bl(f);cl(f);dl(f);el(f);fl(f);gl(f);hl(f);il(f);jl(f);kl(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+320>>3]+(+h[f+328>>3]- +h[f+816>>3]);h[d+8>>3]=+h[f+696>>3]+(-+h[f+528>>3]- +h[f+520>>3]- +h[f+216>>3]);i=e;return}function nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+1568>>3]*+h[b+2680>>3];i=i;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2704>>3];k=+h[g+1640>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1632|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1632|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,9512,9504,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1632|0;p=o;h[p>>3]=m;i=d;return}function pl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2696>>3];k=+h[g+1640>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1624|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1624|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,9552,9544,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1624|0;p=o;h[p>>3]=m;i=d;return}function ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2664>>3];k=+h[g+1640>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,9592,9584,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1272|0;p=o;h[p>>3]=m;i=d;return}function rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2768>>3];k=+h[g+1856>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,j,8752,9624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1832|0;p=o;h[p>>3]=m;i=d;return}function sl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1832>>3],+h[f+17472>>3],+h[f+17480>>3],+h[f+17488>>3],+h[f+17496>>3],+h[f+17504>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1816>>3]=+h[d>>3];i=b;return}function tl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1816>>3];k=+h[(c[b+416>>2]|0)+17512>>3];l=+h[g+2768>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8800,9632,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1840>>3]=j*n*1256637061435917.0e-21;i=d;return}function ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1848|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8848,9640,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1848|0;p=o;h[p>>3]=m;i=d;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+1856>>3]*+h[b+1848>>3];i=i;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2776>>3];k=+h[g+1856>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8896,9648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1776|0;q=p;h[q>>3]=n;i=d;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1776>>3],+h[f+17544>>3],+h[f+17552>>3],+h[f+17560>>3],+h[f+17568>>3],+h[f+17576>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1760>>3]=+h[d>>3];i=b;return}function yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17592>>3];m=+h[j+17600>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,8936,9656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,8976,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+1760>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17584>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,9112,9656,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1784|0;x=w;h[x>>3]=u;i=d;return}function zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1784>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,9208,9664,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=-(+h[b+1856>>3]*+h[b+1792>>3]);i=i;return}function Bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=-+h[b+1800>>3]- +h[b+1640>>3];i=i;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1608>>3]=+h[b+1864>>3]+ +h[b+1808>>3];i=i;return}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2760>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8608,9672,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1888|0;q=p;h[q>>3]=n;i=d;return}function El(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1888>>3],+h[f+17400>>3],+h[f+17408>>3],+h[f+17416>>3],+h[f+17424>>3],+h[f+17432>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1872>>3]=+h[d>>3];i=b;return}function Fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1872>>3];k=+h[(c[b+416>>2]|0)+17440>>3];l=+h[g+2760>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8656,9680,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1896>>3]=j*n*1256637061435917.0e-21;i=d;return}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1896>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1904|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8704,9688,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1904|0;p=o;h[p>>3]=m;i=d;return}function Hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=-(+h[b+2080>>3]*+h[b+1904>>3]);i=i;return}function Il(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2784>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8248,9696,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1720|0;q=p;h[q>>3]=n;i=d;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1720>>3],+h[f+17616>>3],+h[f+17624>>3],+h[f+17632>>3],+h[f+17640>>3],+h[f+17648>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1704>>3]=+h[d>>3];i=b;return}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+416|0;j=c[g>>2]|0;l=+h[j+17664>>3];m=+h[j+17672>>3];do{if(l!=0.0){n=m/l}else{if(m==0.0){n=m;break}n=m/+xH(c[b+536>>2]|0,l,8288,9704,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(!(n>0.0)){j=c[28168]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=n;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=j;j=e;q=9712;c[j+0>>2]=c[q+0>>2];c[j+4>>2]=c[q+4>>2];c[j+8>>2]=c[q+8>>2];c[j+12>>2]=c[q+12>>2];c[j+16>>2]=c[q+16>>2];c[j+20>>2]=c[q+20>>2];Pe[p&31](o,e,8328,f);}f=b+4|0;e=c[c[f>>2]>>2]|0;o=c[e+8>>2]|0;l=+h[o+1704>>3];m=+da(+n);n=+h[(c[g>>2]|0)+17656>>3];if(m!=0.0){r=o;s=n/m;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}if(n==0.0){r=o;s=n;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}y=n/+xH(c[b+536>>2]|0,m,8464,9704,+h[e>>3],(a[b+319|0]|0)!=0|0);r=c[(c[c[f>>2]>>2]|0)+8>>2]|0;s=y;t=l*s;u=t*7895683520871486.0e-21;v=r;w=v+1728|0;x=w;h[x>>3]=u;i=d;return}function Ll(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1728>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1736|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8560,9736,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1736|0;p=o;h[p>>3]=m;i=d;return}function Ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=-(+h[b+2080>>3]*+h[b+1736>>3]);i=i;return}function Nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2792>>3];k=+h[g+2080>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}k=l/+xH(c[b+536>>2]|0,j,8128,9744,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1664|0;q=p;h[q>>3]=n;i=d;return}function Ol(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;fj(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1664>>3],+h[f+17688>>3],+h[f+17696>>3],+h[f+17704>>3],+h[f+17712>>3],+h[f+17720>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1648>>3]=+h[d>>3];i=b;return}function Pl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1648>>3];k=+h[(c[b+416>>2]|0)+17728>>3];l=+h[g+2792>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+xH(c[b+536>>2]|0,k,8168,9752,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1672>>3]=j*n*1256637061435917.0e-21;i=d;return}function Ql(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1672>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+1680|0;p=o;h[p>>3]=m;i=d;return}q=+xH(c[b+536>>2]|0,j,8208,9760,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+1680|0;p=o;h[p>>3]=m;i=d;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=-(+h[b+2080>>3]*+h[b+1680>>3]);i=i;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+2080>>3]+ +h[b+1856>>3];i=i;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1600>>3]=+h[b+1592>>3]*+h[b+2656>>3];i=i;return}function Ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1368>>3]=-+h[b+24>>3]- +h[b+2080>>3];i=i;return}function Vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1376>>3]=+h[b+1368>>3]*+h[b+1352>>3];i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=+h[b+1600>>3]+ +h[b+1608>>3];i=i;return}function Xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+1616>>3]- +h[b+1376>>3];i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=+h[b+1912>>3]+ +h[b+1608>>3];i=i;return}function Zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+1744>>3]+ +h[b+1752>>3];i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=+h[b+2088>>3]+ +h[b+2112>>3];i=i;return}function $l(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+22032>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+22008>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+22016>>3];h[a+8>>3]=+h[d+26064>>3];h[e+8>>3]=+h[d+26040>>3];h[f+8>>3]=+h[d+26048>>3];h[a+16>>3]=+h[d+29200>>3];h[e+16>>3]=+h[d+29176>>3];h[f+16>>3]=+h[d+29184>>3];i=i;return}function am(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1568>>3]=+h[b>>3];h[a+1856>>3]=+h[b+8>>3];h[a+2080>>3]=+h[b+16>>3];nl(f);ol(f);pl(f);ql(f);rl(f);sl(f);tl(f);ul(f);vl(f);wl(f);xl(f);yl(f);zl(f);Al(f);Bl(f);Cl(f);Dl(f);El(f);Fl(f);Gl(f);Hl(f);Il(f);Jl(f);Kl(f);Ll(f);Ml(f);Nl(f);Ol(f);Pl(f);Ql(f);Rl(f);Sl(f);Tl(f);Ul(f);Vl(f);Wl(f);Xl(f);Yl(f);Zl(f);_l(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+1688>>3]+(+h[f+1696>>3]- +h[f+2120>>3]);h[d+8>>3]=+h[f+1312>>3]+(+h[f+2112>>3]- +h[f+1616>>3]);h[d+16>>3]=-+h[f+1272>>3]- +h[f+1568>>3]- +h[f+1624>>3]- +h[f+1856>>3]- +h[f+1632>>3];i=e;return}function bm(a){a=a|0;c[a+4>>2]=135;c[a>>2]=6;c[a+56>>2]=0;c[a+32>>2]=20;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=381;c[a+80>>2]=8;c[a+136>>2]=0;c[a+112>>2]=21;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=524;c[a+160>>2]=2;c[a+216>>2]=0;c[a+192>>2]=22;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=649;c[a+240>>2]=3;c[a+296>>2]=0;c[a+272>>2]=23;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;i=i;return}



function dm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e>>3]*+h[e+1e3>>3];b=e+1160|0;f=a+8|0;g=f+72|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));h[a+80>>3]=-+h[b>>3];h[a+88>>3]=+h[e+312>>3]*+h[e+984>>3];Jaa(a+96|0,0,176)|0;i=d;return}function em(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,1.0,0,b);ze[c[e>>2]&3](0,2,-1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,1,+h[(c[f>>2]|0)+19184>>3],2,b);ze[c[e>>2]&3](1,2,1.0,3,b);ze[c[e>>2]&3](2,0,-1.0,4,b);ze[c[e>>2]&3](2,1,+h[(c[f>>2]|0)+18944>>3],5,b);i=d;return}function fm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[d+432>>3];h[a+8>>3]=0.0;h[a+16>>3]=+h[d+456>>3];i=i;return}function gm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,-1.0,0,b);ze[c[e>>2]&3](0,5,1.0,1,b);f=a+4|0;ze[c[e>>2]&3](1,4,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2712>>3],2,b);ze[c[e>>2]&3](1,5,1.0,3,b);ze[c[e>>2]&3](2,3,-1.0,4,b);ze[c[e>>2]&3](2,4,1.0,5,b);ze[c[e>>2]&3](3,2,1.0,6,b);ze[c[e>>2]&3](3,3,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2720>>3],7,b);ze[c[e>>2]&3](4,1,1.0,8,b);ze[c[e>>2]&3](4,2,1.0,9,b);ze[c[e>>2]&3](5,0,1.0,10,b);ze[c[e>>2]&3](5,1,-1.0,11,b);i=d;return}function hm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[d+48>>3];h[a+8>>3]=0.0;h[a+16>>3]=+h[d+64>>3]- +h[d+2048>>3];h[a+24>>3]=0.0;h[a+32>>3]=+h[d+2176>>3];h[a+40>>3]=-+h[d+56>>3];i=i;return}function im(b,d){b=b|0;d=d|0;var e=0,f=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,B=0.0,C=0,D=0,E=0.0,F=0,G=0.0,J=0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0,T=0.0,V=0.0,X=0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0,fa=0.0,ga=0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0.0,Ba=0.0,Ca=0,Da=0.0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0,kb=0.0,lb=0,mb=0.0,nb=0.0,ob=0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0,Fb=0.0,Gb=0,Hb=0.0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0,Vb=0,Wb=0.0,Xb=0.0,Yb=0,Zb=0.0,_b=0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0.0,fc=0,gc=0.0,hc=0.0,ic=0,jc=0.0,kc=0.0,lc=0,mc=0.0,nc=0.0,oc=0,pc=0.0,qc=0.0,rc=0.0,sc=0,tc=0.0,uc=0,vc=0.0,wc=0.0,xc=0,yc=0.0,zc=0,Ac=0.0,Bc=0.0,Cc=0,Dc=0.0,Ec=0,Fc=0.0,Gc=0,Hc=0.0,Ic=0.0,Jc=0,Kc=0.0,Lc=0,Mc=0.0,Nc=0,Oc=0.0,Pc=0,Qc=0.0,Rc=0.0;e=i;i=i+7408|0;ze[c[(d+8|0)>>2]&3](0,13,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1296>>3],0,d);ze[c[(d+8|0)>>2]&3](0,25,1.0,1,d);ze[c[(d+8|0)>>2]&3](1,23,-1.0,2,d);ze[c[(d+8|0)>>2]&3](1,24,1.0,3,d);ze[c[(d+8|0)>>2]&3](1,25,1.0,4,d);ze[c[(d+8|0)>>2]&3](2,12,1.0,5,d);ze[c[(d+8|0)>>2]&3](2,23,-1.0,6,d);ze[c[(d+8|0)>>2]&3](2,24,1.0,7,d);ze[c[(d+8|0)>>2]&3](3,11,1.0,8,d);ze[c[(d+8|0)>>2]&3](3,22,1.0,9,d);ze[c[(d+8|0)>>2]&3](3,23,-1.0,10,d);ze[c[(d+8|0)>>2]&3](4,9,1.0,11,d);ze[c[(d+8|0)>>2]&3](4,21,1.0,12,d);ze[c[(d+8|0)>>2]&3](4,22,-1.0,13,d);ze[c[(d+8|0)>>2]&3](5,16,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1848>>3],14,d);ze[c[(d+8|0)>>2]&3](5,20,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1856>>3],15,d);ze[c[(d+8|0)>>2]&3](5,21,1.0,16,d);f=c[c[(b+4|0)>>2]>>2]|0;j=+h[(c[f+8>>2]|0)+1840>>3];if(j!=0.0){k=j}else{k=+xH(c[b+536>>2]|0,j,11920,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}j=1.0/k;ze[c[(d+8|0)>>2]&3](6,19,j*j,17,d);ze[c[(d+8|0)>>2]&3](6,20,1.0,18,d);f=c[(d+8|0)>>2]|0;j=+h[(c[(b+416|0)>>2]|0)+17512>>3];l=c[c[(b+4|0)>>2]>>2]|0;k=+h[(c[l+8>>2]|0)+2768>>3];do{if(j!=0.0){m=k/j}else{if(k==0.0){m=k;break}m=k/+xH(c[b+536>>2]|0,j,11960,11912,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);ze[f&3](7,18,m*-1256637061435917.0e-21,19,d);ze[c[(d+8|0)>>2]&3](7,19,1.0,20,d);m=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;j=+h[(c[f+8>>2]|0)+1832>>3];do{if(m!=0.0){n=j/m}else{if(j==0.0){n=j;break}n=j/+xH(c[b+536>>2]|0,m,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(n>0.0){o=1.0}else{n=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1832>>3];do{if(n!=0.0){p=m/n}else{if(m==0.0){p=m;break}p=m/+xH(c[b+536>>2]|0,n,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);o=+(p<0.0|0)}p=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;n=+h[(c[f+8>>2]|0)+1832>>3];do{if(p!=0.0){q=n/p}else{if(n==0.0){q=n;break}q=n/+xH(c[b+536>>2]|0,p,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(q>0.0){r=1.0}else{q=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;p=+h[(c[f+8>>2]|0)+1832>>3];do{if(q!=0.0){s=p/q}else{if(p==0.0){s=p;break}s=p/+xH(c[b+536>>2]|0,q,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);r=+(s<0.0|0)}s=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;q=+h[(c[f+8>>2]|0)+1832>>3];do{if(s!=0.0){t=q/s}else{if(q==0.0){t=q;break}t=q/+xH(c[b+536>>2]|0,s,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if(t>0.0){u=1.0}else{t=+h[(c[(b+416|0)>>2]|0)+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+1832>>3];do{if(t!=0.0){v=s/t}else{if(s==0.0){v=s;break}v=s/+xH(c[b+536>>2]|0,t,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=+(v<0.0|0)}f=c[(b+416|0)>>2]|0;v=+h[f+17496>>3];t=+h[f+17480>>3];l=c[c[(b+4|0)>>2]>>2]|0;s=+h[(c[l+8>>2]|0)+1832>>3];do{if(t!=0.0){w=s;x=l;y=t;z=f;B=s/t}else{if(s==0.0){w=s;x=l;y=t;z=f;B=s;break}q=s/+xH(c[b+536>>2]|0,t,12e3,11912,+h[l>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;w=+h[(c[D+8>>2]|0)+1832>>3];x=D;y=+h[C+17480>>3];z=C;B=q}}while(0);t=v*+U(+B);do{if(y!=0.0){E=w;F=x;G=y;J=z;K=w/y}else{if(w==0.0){E=w;F=x;G=y;J=z;K=w;break}B=w/+xH(c[b+536>>2]|0,y,12e3,11912,+h[x>>3],(a[b+319|0]|0)!=0|0);l=c[(b+416|0)>>2]|0;f=c[c[(b+4|0)>>2]>>2]|0;E=+h[(c[f+8>>2]|0)+1832>>3];F=f;G=+h[l+17480>>3];J=l;K=B}}while(0);y=+U(+K);K=t+ +W(+y,+(+h[J+17504>>3]))+1.0;x=c[(d+8|0)>>2]|0;y=+h[J+17472>>3];t=+h[J+17488>>3];z=G!=0.0;do{l=1;if(l){l=0;if(K*K!=0.0){do{if(z){L=G;M=J;N=E/G}else{if(E==0.0){L=G;M=J;N=E;break}w=E/+xH(c[b+536>>2]|0,G,12e3,11912,+h[F>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;L=+h[f+17480>>3];M=f;N=w}}while(0);w=y+t*+U(+N)+-1.0;B=+h[M+17496>>3];do{if(L!=0.0){O=L;P=M;Q=o/L}else{if(o==0.0){O=L;P=M;Q=o;break}v=o/+xH(c[b+536>>2]|0,L,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;O=+h[f+17480>>3];P=f;Q=v}}while(0);v=B*Q;f=c[c[(b+4|0)>>2]>>2]|0;s=+h[(c[f+8>>2]|0)+1832>>3];do{if(O!=0.0){R=O;S=P;T=s/O}else{if(s==0.0){R=O;S=P;T=s;break}q=s/+xH(c[b+536>>2]|0,O,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;R=+h[C+17480>>3];S=C;T=q}}while(0);s=+U(+T);B=+h[S+17504>>3];q=+W(+s,+(B+-1.0));do{if(R!=0.0){V=R;X=S;Y=r/R}else{if(r==0.0){V=R;X=S;Y=r;break}s=r/+xH(c[b+536>>2]|0,R,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;V=+h[f+17480>>3];X=f;Y=s}}while(0);s=w*(v+q*B*Y);p=+h[X+17488>>3];n=+h[X+17496>>3];f=c[c[(b+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1832>>3];do{if(V!=0.0){j=+U(+(m/V));Z=(n*j+ +W(+j,+(+h[X+17504>>3]))+1.0)/V}else{if(m==0.0){_=m;$=f;aa=V;ba=X;ca=m}else{j=m/+xH(c[b+536>>2]|0,V,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;_=+h[(c[D+8>>2]|0)+1832>>3];$=D;aa=+h[C+17480>>3];ba=C;ca=j}j=n*+U(+ca);do{if(aa!=0.0){da=_;ea=$;fa=aa;ga=ba;ha=_/aa}else{if(_==0.0){da=_;ea=$;fa=aa;ga=ba;ha=_;break}k=_/+xH(c[b+536>>2]|0,aa,12e3,11912,+h[$>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;D=c[c[(b+4|0)>>2]>>2]|0;da=+h[(c[D+8>>2]|0)+1832>>3];ea=D;fa=+h[C+17480>>3];ga=C;ha=k}}while(0);k=+U(+ha);C=j+ +W(+k,+(+h[ga+17504>>3]))+1.0==0.0;k=+h[ga+17496>>3];D=fa!=0.0;if(C){do{if(D){ia=da;ja=ea;ka=fa;la=ga;ma=da/fa}else{if(da==0.0){ia=da;ja=ea;ka=fa;la=ga;ma=da;break}na=da/+xH(c[b+536>>2]|0,fa,12e3,11912,+h[ea>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;ia=+h[(c[oa+8>>2]|0)+1832>>3];ja=oa;ka=+h[C+17480>>3];la=C;ma=na}}while(0);j=k*+U(+ma);do{if(ka!=0.0){pa=la;qa=ia/ka}else{if(ia==0.0){pa=la;qa=ia;break}na=ia/+xH(c[b+536>>2]|0,ka,12e3,11912,+h[ja>>3],(a[b+319|0]|0)!=0|0);pa=c[(b+416|0)>>2]|0;qa=na}}while(0);na=+U(+qa);Z=j+ +W(+na,+(+h[pa+17504>>3]))+1.0;break}else{do{if(D){ra=da;sa=ea;ta=fa;ua=ga;va=da/fa}else{if(da==0.0){ra=da;sa=ea;ta=fa;ua=ga;va=da;break}na=da/+xH(c[b+536>>2]|0,fa,12e3,11912,+h[ea>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;ra=+h[(c[oa+8>>2]|0)+1832>>3];sa=oa;ta=+h[C+17480>>3];ua=C;va=na}}while(0);j=k*+U(+va);do{if(ta!=0.0){wa=sa;xa=ta;ya=ua;za=ra/ta}else{if(ra==0.0){wa=sa;xa=ta;ya=ua;za=ra;break}na=ra/+xH(c[b+536>>2]|0,ta,12e3,11912,+h[sa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;wa=c[c[(b+4|0)>>2]>>2]|0;xa=+h[D+17480>>3];ya=D;za=na}}while(0);k=+U(+za);na=j+ +W(+k,+(+h[ya+17504>>3]))+1.0;Z=na/+xH(c[b+536>>2]|0,xa,12e3,11912,+h[wa>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Aa=(s-p*u*Z)/(K*K)}else{l=1}}if(l){l=0;if(1){do{if(z){Ba=G;Ca=J;Da=E/G}else{if(E==0.0){Ba=G;Ca=J;Da=E;break}n=E/+xH(c[b+536>>2]|0,G,12e3,11912,+h[F>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;Ba=+h[f+17480>>3];Ca=f;Da=n}}while(0);p=y+t*+U(+Da)+-1.0;s=+h[Ca+17496>>3];do{if(Ba!=0.0){Ea=Ba;Fa=Ca;Ga=o/Ba}else{if(o==0.0){Ea=Ba;Fa=Ca;Ga=o;break}n=o/+xH(c[b+536>>2]|0,Ba,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;Ea=+h[f+17480>>3];Fa=f;Ga=n}}while(0);n=s*Ga;f=c[c[(b+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1832>>3];do{if(Ea!=0.0){Ha=Ea;Ia=Fa;Ja=m/Ea}else{if(m==0.0){Ha=Ea;Ia=Fa;Ja=m;break}B=m/+xH(c[b+536>>2]|0,Ea,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;Ha=+h[D+17480>>3];Ia=D;Ja=B}}while(0);m=+U(+Ja);s=+h[Ia+17504>>3];B=+W(+m,+(s+-1.0));do{if(Ha!=0.0){Ka=Ha;La=Ia;Ma=r/Ha}else{if(r==0.0){Ka=Ha;La=Ia;Ma=r;break}m=r/+xH(c[b+536>>2]|0,Ha,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;Ka=+h[f+17480>>3];La=f;Ma=m}}while(0);m=p*(n+B*s*Ma);q=+h[La+17488>>3];v=+h[La+17496>>3];f=c[c[(b+4|0)>>2]>>2]|0;w=+h[(c[f+8>>2]|0)+1832>>3];do{if(Ka!=0.0){na=+U(+(w/Ka));Na=La;Oa=(v*na+ +W(+na,+(+h[La+17504>>3]))+1.0)/Ka}else{if(w==0.0){Pa=w;Qa=f;Ra=Ka;Sa=La;Ta=w}else{na=w/+xH(c[b+536>>2]|0,Ka,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;C=c[c[(b+4|0)>>2]>>2]|0;Pa=+h[(c[C+8>>2]|0)+1832>>3];Qa=C;Ra=+h[D+17480>>3];Sa=D;Ta=na}na=v*+U(+Ta);do{if(Ra!=0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa/Ra}else{if(Pa==0.0){Ua=Pa;Va=Qa;Wa=Ra;Xa=Sa;Ya=Pa;break}k=Pa/+xH(c[b+536>>2]|0,Ra,12e3,11912,+h[Qa>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;C=c[c[(b+4|0)>>2]>>2]|0;Ua=+h[(c[C+8>>2]|0)+1832>>3];Va=C;Wa=+h[D+17480>>3];Xa=D;Ya=k}}while(0);j=+U(+Ya);D=na+ +W(+j,+(+h[Xa+17504>>3]))+1.0==0.0;j=+h[Xa+17496>>3];C=Wa!=0.0;if(D){do{if(C){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua/Wa}else{if(Ua==0.0){Za=Ua;_a=Va;$a=Wa;ab=Xa;bb=Ua;break}k=Ua/+xH(c[b+536>>2]|0,Wa,12e3,11912,+h[Va>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;Za=+h[(c[oa+8>>2]|0)+1832>>3];_a=oa;$a=+h[D+17480>>3];ab=D;bb=k}}while(0);na=j*+U(+bb);do{if($a!=0.0){cb=ab;db=Za/$a}else{if(Za==0.0){cb=ab;db=Za;break}k=Za/+xH(c[b+536>>2]|0,$a,12e3,11912,+h[_a>>3],(a[b+319|0]|0)!=0|0);cb=c[(b+416|0)>>2]|0;db=k}}while(0);k=+U(+db);Na=cb;Oa=na+ +W(+k,+(+h[cb+17504>>3]))+1.0;break}else{do{if(C){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua/Wa}else{if(Ua==0.0){eb=Ua;fb=Va;gb=Wa;hb=Xa;ib=Ua;break}k=Ua/+xH(c[b+536>>2]|0,Wa,12e3,11912,+h[Va>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;eb=+h[(c[oa+8>>2]|0)+1832>>3];fb=oa;gb=+h[D+17480>>3];hb=D;ib=k}}while(0);na=j*+U(+ib);do{if(gb!=0.0){jb=fb;kb=gb;lb=hb;mb=eb/gb}else{if(eb==0.0){jb=fb;kb=gb;lb=hb;mb=eb;break}k=eb/+xH(c[b+536>>2]|0,gb,12e3,11912,+h[fb>>3],(a[b+319|0]|0)!=0|0);C=c[(b+416|0)>>2]|0;jb=c[c[(b+4|0)>>2]>>2]|0;kb=+h[C+17480>>3];lb=C;mb=k}}while(0);j=+U(+mb);k=na+ +W(+j,+(+h[lb+17504>>3]))+1.0;j=k/+xH(c[b+536>>2]|0,kb,12e3,11912,+h[jb>>3],(a[b+319|0]|0)!=0|0);Na=c[(b+416|0)>>2]|0;Oa=j;break}}}while(0);v=+h[Na+17472>>3];w=+h[Na+17488>>3];s=+h[Na+17480>>3];f=c[c[(b+4|0)>>2]>>2]|0;B=+h[(c[f+8>>2]|0)+1832>>3];C=1;if(C){C=0;if(m-q*u*Oa==0.0){do{if(s!=0.0){nb=s;ob=Na;pb=B/s}else{if(B==0.0){nb=s;ob=Na;pb=B;break}n=B/+xH(c[b+536>>2]|0,s,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;nb=+h[D+17480>>3];ob=D;pb=n}}while(0);q=v+w*+U(+pb)+-1.0;m=+h[ob+17496>>3];do{if(nb!=0.0){qb=nb;rb=ob;sb=o/nb}else{if(o==0.0){qb=nb;rb=ob;sb=o;break}n=o/+xH(c[b+536>>2]|0,nb,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;qb=+h[D+17480>>3];rb=D;sb=n}}while(0);n=m*sb;D=c[c[(b+4|0)>>2]>>2]|0;p=+h[(c[D+8>>2]|0)+1832>>3];do{if(qb!=0.0){tb=qb;ub=rb;vb=p/qb}else{if(p==0.0){tb=qb;ub=rb;vb=p;break}j=p/+xH(c[b+536>>2]|0,qb,12e3,11912,+h[D>>3],(a[b+319|0]|0)!=0|0);oa=c[(b+416|0)>>2]|0;tb=+h[oa+17480>>3];ub=oa;vb=j}}while(0);p=+U(+vb);m=+h[ub+17504>>3];j=+W(+p,+(m+-1.0));do{if(tb!=0.0){wb=tb;xb=ub;yb=r/tb}else{if(r==0.0){wb=tb;xb=ub;yb=r;break}p=r/+xH(c[b+536>>2]|0,tb,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;wb=+h[D+17480>>3];xb=D;yb=p}}while(0);p=q*(n+j*m*yb);k=+h[xb+17488>>3];zb=+h[xb+17496>>3];D=c[c[(b+4|0)>>2]>>2]|0;Ab=+h[(c[D+8>>2]|0)+1832>>3];do{if(wb!=0.0){Bb=+U(+(Ab/wb));Cb=(zb*Bb+ +W(+Bb,+(+h[xb+17504>>3]))+1.0)/wb}else{if(Ab==0.0){Db=Ab;Eb=D;Fb=wb;Gb=xb;Hb=Ab}else{Bb=Ab/+xH(c[b+536>>2]|0,wb,12e3,11912,+h[D>>3],(a[b+319|0]|0)!=0|0);oa=c[(b+416|0)>>2]|0;Ib=c[c[(b+4|0)>>2]>>2]|0;Db=+h[(c[Ib+8>>2]|0)+1832>>3];Eb=Ib;Fb=+h[oa+17480>>3];Gb=oa;Hb=Bb}Bb=zb*+U(+Hb);do{if(Fb!=0.0){Jb=Gb;Kb=Db/Fb;Lb=Db;Mb=Eb;Nb=Fb}else{if(Db==0.0){Jb=Gb;Kb=Db;Lb=Db;Mb=Eb;Nb=Fb;break}Ob=Db/+xH(c[b+536>>2]|0,Fb,12e3,11912,+h[Eb>>3],(a[b+319|0]|0)!=0|0);oa=c[(b+416|0)>>2]|0;Ib=c[c[(b+4|0)>>2]>>2]|0;Jb=oa;Kb=Ob;Lb=+h[(c[Ib+8>>2]|0)+1832>>3];Mb=Ib;Nb=+h[oa+17480>>3]}}while(0);na=+U(+Kb);oa=Bb+ +W(+na,+(+h[Jb+17504>>3]))+1.0==0.0;na=+h[Jb+17496>>3];Ib=Nb!=0.0;if(oa){do{if(Ib){Pb=Lb;Qb=Mb;Rb=Nb;Sb=Jb;Tb=Lb/Nb}else{if(Lb==0.0){Pb=Lb;Qb=Mb;Rb=Nb;Sb=Jb;Tb=Lb;break}Ob=Lb/+xH(c[b+536>>2]|0,Nb,12e3,11912,+h[Mb>>3],(a[b+319|0]|0)!=0|0);oa=c[(b+416|0)>>2]|0;Ub=c[c[(b+4|0)>>2]>>2]|0;Pb=+h[(c[Ub+8>>2]|0)+1832>>3];Qb=Ub;Rb=+h[oa+17480>>3];Sb=oa;Tb=Ob}}while(0);Bb=na*+U(+Tb);do{if(Rb!=0.0){Vb=Sb;Wb=Pb/Rb}else{if(Pb==0.0){Vb=Sb;Wb=Pb;break}Ob=Pb/+xH(c[b+536>>2]|0,Rb,12e3,11912,+h[Qb>>3],(a[b+319|0]|0)!=0|0);Vb=c[(b+416|0)>>2]|0;Wb=Ob}}while(0);Ob=+U(+Wb);Cb=Bb+ +W(+Ob,+(+h[Vb+17504>>3]))+1.0;break}else{do{if(Ib){Xb=Lb;Yb=Mb;Zb=Nb;_b=Jb;$b=Lb/Nb}else{if(Lb==0.0){Xb=Lb;Yb=Mb;Zb=Nb;_b=Jb;$b=Lb;break}Ob=Lb/+xH(c[b+536>>2]|0,Nb,12e3,11912,+h[Mb>>3],(a[b+319|0]|0)!=0|0);oa=c[(b+416|0)>>2]|0;Ub=c[c[(b+4|0)>>2]>>2]|0;Xb=+h[(c[Ub+8>>2]|0)+1832>>3];Yb=Ub;Zb=+h[oa+17480>>3];_b=oa;$b=Ob}}while(0);Bb=na*+U(+$b);do{if(Zb!=0.0){ac=Yb;bc=Zb;cc=_b;dc=Xb/Zb}else{if(Xb==0.0){ac=Yb;bc=Zb;cc=_b;dc=Xb;break}Ob=Xb/+xH(c[b+536>>2]|0,Zb,12e3,11912,+h[Yb>>3],(a[b+319|0]|0)!=0|0);Ib=c[(b+416|0)>>2]|0;ac=c[c[(b+4|0)>>2]>>2]|0;bc=+h[Ib+17480>>3];cc=Ib;dc=Ob}}while(0);na=+U(+dc);Ob=Bb+ +W(+na,+(+h[cc+17504>>3]))+1.0;Cb=Ob/+xH(c[b+536>>2]|0,bc,12e3,11912,+h[ac>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Aa=p-k*u*Cb;break}else{C=1}}if(C){C=0;if(1){do{if(s!=0.0){ec=s;fc=Na;gc=B/s}else{if(B==0.0){ec=s;fc=Na;gc=B;break}zb=B/+xH(c[b+536>>2]|0,s,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;ec=+h[D+17480>>3];fc=D;gc=zb}}while(0);s=v+w*+U(+gc)+-1.0;B=+h[fc+17496>>3];do{if(ec!=0.0){hc=ec;ic=fc;jc=o/ec}else{if(o==0.0){hc=ec;ic=fc;jc=o;break}k=o/+xH(c[b+536>>2]|0,ec,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;hc=+h[f+17480>>3];ic=f;jc=k}}while(0);w=B*jc;f=c[c[(b+4|0)>>2]>>2]|0;v=+h[(c[f+8>>2]|0)+1832>>3];do{if(hc!=0.0){kc=hc;lc=ic;mc=v/hc}else{if(v==0.0){kc=hc;lc=ic;mc=v;break}k=v/+xH(c[b+536>>2]|0,hc,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;kc=+h[D+17480>>3];lc=D;mc=k}}while(0);v=+U(+mc);B=+h[lc+17504>>3];k=+W(+v,+(B+-1.0));do{if(kc!=0.0){nc=kc;oc=lc;pc=r/kc}else{if(r==0.0){nc=kc;oc=lc;pc=r;break}v=r/+xH(c[b+536>>2]|0,kc,12e3,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);f=c[(b+416|0)>>2]|0;nc=+h[f+17480>>3];oc=f;pc=v}}while(0);v=s*(w+k*B*pc);p=+h[oc+17488>>3];zb=+h[oc+17496>>3];f=c[c[(b+4|0)>>2]>>2]|0;Ab=+h[(c[f+8>>2]|0)+1832>>3];do{if(nc!=0.0){m=+U(+(Ab/nc));qc=(zb*m+ +W(+m,+(+h[oc+17504>>3]))+1.0)/nc}else{if(Ab==0.0){rc=Ab;sc=f;tc=nc;uc=oc;vc=Ab}else{m=Ab/+xH(c[b+536>>2]|0,nc,12e3,11912,+h[f>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;Ib=c[c[(b+4|0)>>2]>>2]|0;rc=+h[(c[Ib+8>>2]|0)+1832>>3];sc=Ib;tc=+h[D+17480>>3];uc=D;vc=m}m=zb*+U(+vc);do{if(tc!=0.0){wc=rc;xc=sc;yc=tc;zc=uc;Ac=rc/tc}else{if(rc==0.0){wc=rc;xc=sc;yc=tc;zc=uc;Ac=rc;break}j=rc/+xH(c[b+536>>2]|0,tc,12e3,11912,+h[sc>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;Ib=c[c[(b+4|0)>>2]>>2]|0;wc=+h[(c[Ib+8>>2]|0)+1832>>3];xc=Ib;yc=+h[D+17480>>3];zc=D;Ac=j}}while(0);Bb=+U(+Ac);D=m+ +W(+Bb,+(+h[zc+17504>>3]))+1.0==0.0;Bb=+h[zc+17496>>3];Ib=yc!=0.0;if(D){do{if(Ib){Bc=wc;Cc=xc;Dc=yc;Ec=zc;Fc=wc/yc}else{if(wc==0.0){Bc=wc;Cc=xc;Dc=yc;Ec=zc;Fc=wc;break}j=wc/+xH(c[b+536>>2]|0,yc,12e3,11912,+h[xc>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;Bc=+h[(c[oa+8>>2]|0)+1832>>3];Cc=oa;Dc=+h[D+17480>>3];Ec=D;Fc=j}}while(0);m=Bb*+U(+Fc);do{if(Dc!=0.0){Gc=Ec;Hc=Bc/Dc}else{if(Bc==0.0){Gc=Ec;Hc=Bc;break}j=Bc/+xH(c[b+536>>2]|0,Dc,12e3,11912,+h[Cc>>3],(a[b+319|0]|0)!=0|0);Gc=c[(b+416|0)>>2]|0;Hc=j}}while(0);j=+U(+Hc);qc=m+ +W(+j,+(+h[Gc+17504>>3]))+1.0;break}else{do{if(Ib){Ic=wc;Jc=xc;Kc=yc;Lc=zc;Mc=wc/yc}else{if(wc==0.0){Ic=wc;Jc=xc;Kc=yc;Lc=zc;Mc=wc;break}j=wc/+xH(c[b+536>>2]|0,yc,12e3,11912,+h[xc>>3],(a[b+319|0]|0)!=0|0);D=c[(b+416|0)>>2]|0;oa=c[c[(b+4|0)>>2]>>2]|0;Ic=+h[(c[oa+8>>2]|0)+1832>>3];Jc=oa;Kc=+h[D+17480>>3];Lc=D;Mc=j}}while(0);m=Bb*+U(+Mc);do{if(Kc!=0.0){Nc=Jc;Oc=Kc;Pc=Lc;Qc=Ic/Kc}else{if(Ic==0.0){Nc=Jc;Oc=Kc;Pc=Lc;Qc=Ic;break}j=Ic/+xH(c[b+536>>2]|0,Kc,12e3,11912,+h[Jc>>3],(a[b+319|0]|0)!=0|0);Ib=c[(b+416|0)>>2]|0;Nc=c[c[(b+4|0)>>2]>>2]|0;Oc=+h[Ib+17480>>3];Pc=Ib;Qc=j}}while(0);Bb=+U(+Qc);j=m+ +W(+Bb,+(+h[Pc+17504>>3]))+1.0;qc=j/+xH(c[b+536>>2]|0,Oc,12e3,11912,+h[Nc>>3],(a[b+319|0]|0)!=0|0);break}}}while(0);Aa=(v-p*u*qc)/+xH(c[b+536>>2]|0,K*K,12056,11912,+h[c[c[(b+4|0)>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);break}else{C=1}}}else{l=1}}}while(0);ze[x&3](8,17,Aa,21,d);ze[c[(d+8|0)>>2]&3](8,18,1.0,22,d);x=c[(d+8|0)>>2]|0;Nc=c[c[(b+4|0)>>2]>>2]|0;Aa=+h[(c[Nc+8>>2]|0)+2768>>3];if(Aa!=0.0){Rc=Aa}else{Rc=+xH(c[b+536>>2]|0,Aa,12368,11912,+h[Nc>>3],(a[b+319|0]|0)!=0|0)}ze[x&3](9,16,-1.0/Rc,23,d);ze[c[(d+8|0)>>2]&3](9,17,1.0,24,d);ze[c[(d+8|0)>>2]&3](10,15,-1.0,25,d);ze[c[(d+8|0)>>2]&3](10,16,1.0,26,d);ze[c[(d+8|0)>>2]&3](11,13,1.0,27,d);ze[c[(d+8|0)>>2]&3](11,14,1.0,28,d);ze[c[(d+8|0)>>2]&3](11,15,1.0,29,d);ze[c[(d+8|0)>>2]&3](12,13,-1.0,30,d);ze[c[(d+8|0)>>2]&3](12,14,-1.0,31,d);ze[c[(d+8|0)>>2]&3](13,12,1.0,32,d);ze[c[(d+8|0)>>2]&3](13,14,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+1352>>3],33,d);ze[c[(d+8|0)>>2]&3](14,11,1.0,34,d);ze[c[(d+8|0)>>2]&3](14,15,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+2656>>3],35,d);c[e+40>>2]=b;c[e+48>>2]=d;c[e+7328>>2]=0;c[e+7332>>2]=0;_setLinearMatrixA440$0(e);H=c[e+7328>>2]|0;A=c[e+7332>>2]|0;I=+g[e+7332>>2];c[e+7328>>2]=0;c[e+7332>>2]=0;if((H|0)==5){return}}function jm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+24>>3]*+h[e+2352>>3];b=e+2632|0;f=a+8|0;g=f+72|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));h[a+80>>3]=-+h[b>>3];h[a+88>>3]=-+h[e+2552>>3];h[a+96>>3]=+h[b>>3];h[a+104>>3]=+h[e+1368>>3]*+h[e+2336>>3];f=a+112|0;g=f+96|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));i=d;return}function km(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;ze[c[e>>2]&3](0,0,-1.0,0,b);ze[c[e>>2]&3](0,2,1.0,1,b);f=a+416|0;ze[c[e>>2]&3](1,1,+h[(c[f>>2]|0)+17992>>3],2,b);ze[c[e>>2]&3](1,2,-1.0,3,b);ze[c[e>>2]&3](2,0,1.0,4,b);ze[c[e>>2]&3](2,1,+h[(c[f>>2]|0)+18232>>3],5,b);i=d;return}function lm(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[d+1480>>3];h[a+8>>3]=+h[d+1504>>3];h[a+16>>3]=0.0;i=i;return}function _setLinearMatrixA440$0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0.0,I=0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,V=0.0,X=0,Y=0.0,Z=0.0,_=0,$=0.0,aa=0,ba=0.0,ca=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0,Pa=0.0,Qa=0.0,Ra=0,Sa=0.0,Ta=0.0,Ua=0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0,_a=0.0,$a=0.0,ab=0,bb=0.0,cb=0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0,ib=0.0,jb=0.0,kb=0,lb=0.0,mb=0,nb=0.0,ob=0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0,ub=0.0,vb=0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0,Hb=0.0,Ib=0.0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0,Tb=0.0,Ub=0,Vb=0.0,Wb=0,Xb=0.0,Yb=0,Zb=0.0,_b=0.0,$b=0.0,ac=0,bc=0.0,cc=0,dc=0.0,ec=0,fc=0,gc=0.0,hc=0.0,ic=0,jc=0.0,kc=0,lc=0.0,mc=0,nc=0.0,oc=0,pc=0.0,qc=0.0,rc=0,sc=0.0,tc=0.0,uc=0,vc=0.0,wc=0.0,xc=0,yc=0.0,zc=0.0,Ac=0,Bc=0.0,Cc=0.0,Dc=0.0,Ec=0,Fc=0.0,Gc=0,Hc=0.0,Ic=0.0,Jc=0,Kc=0.0,Lc=0,Mc=0.0,Nc=0.0,Oc=0,Pc=0.0,Qc=0,Rc=0.0,Sc=0,Tc=0.0,Uc=0.0,Vc=0,Wc=0.0,Xc=0,Yc=0.0,Zc=0,_c=0.0,$c=0,ad=0.0,bd=0.0,cd=0.0,dd=0.0,ed=0.0,fd=0,gd=0.0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0.0,yd=0.0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0.0,Kd=0.0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0.0,Xd=0.0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0.0,ie=0.0,je=0;d=c[b+40>>2]|0;e=c[b+48>>2]|0;a:do{ze[c[(e+8|0)>>2]&3](15,5,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1856>>3],36,e);ze[c[(e+8|0)>>2]&3](15,10,1.0,37,e);ze[c[(e+8|0)>>2]&3](15,16,+h[(c[(c[c[(d+4|0)>>2]>>2]|0)+8>>2]|0)+1792>>3],38,e);ze[c[(e+8|0)>>2]&3](16,3,1.0,39,e);ze[c[(e+8|0)>>2]&3](16,9,1.0,40,e);ze[c[(e+8|0)>>2]&3](16,10,1.0,41,e);ze[c[(e+8|0)>>2]&3](17,8,1.0,42,e);f=c[(e+8|0)>>2]|0;g=c[c[(d+4|0)>>2]>>2]|0;j=+h[(c[g+8>>2]|0)+2776>>3];if(j!=0.0){l=j}else{l=+xH(c[d+536>>2]|0,j,12408,11912,+h[g>>3],(a[d+319|0]|0)!=0|0)}ze[f&3](17,16,1.0/l,43,e);ze[c[(e+8|0)>>2]&3](18,7,1.0,44,e);j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){n=m/j}else{if(m==0.0){n=m;break}n=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(n>0.0){o=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){p=m/j}else{if(m==0.0){p=m;break}p=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);o=+(p<0.0|0)}j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){q=m/j}else{if(m==0.0){q=m;break}q=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(q>0.0){r=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){s=m/j}else{if(m==0.0){s=m;break}s=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);r=+(s<0.0|0)}j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){t=m/j}else{if(m==0.0){t=m;break}t=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(t>0.0){u=1.0}else{j=+h[(c[(d+416|0)>>2]|0)+17552>>3];f=c[c[(d+4|0)>>2]>>2]|0;m=+h[(c[f+8>>2]|0)+1776>>3];do{if(j!=0.0){v=m/j}else{if(m==0.0){v=m;break}v=m/+xH(c[d+536>>2]|0,j,12440,11912,+h[f>>3],(a[d+319|0]|0)!=0|0)}}while(0);u=+(v<0.0|0)}f=c[(d+416|0)>>2]|0;j=+h[f+17568>>3];m=+h[f+17552>>3];g=c[c[(d+4|0)>>2]>>2]|0;w=+h[(c[g+8>>2]|0)+1776>>3];do{if(m!=0.0){x=w;y=g;z=m;A=f;B=w/m}else{if(w==0.0){x=w;y=g;z=m;A=f;B=w;break}C=w/+xH(c[d+536>>2]|0,m,12440,11912,+h[g>>3],(a[d+319|0]|0)!=0|0);D=c[(d+416|0)>>2]|0;E=c[c[(d+4|0)>>2]>>2]|0;x=+h[(c[E+8>>2]|0)+1776>>3];y=E;z=+h[D+17552>>3];A=D;B=C}}while(0);m=j*+U(+B);do{if(z!=0.0){F=x;G=y;H=z;I=A;J=x/z}else{if(x==0.0){F=x;G=y;H=z;I=A;J=x;break}w=x/+xH(c[d+536>>2]|0,z,12440,11912,+h[y>>3],(a[d+319|0]|0)!=0|0);g=c[(d+416|0)>>2]|0;f=c[c[(d+4|0)>>2]>>2]|0;F=+h[(c[f+8>>2]|0)+1776>>3];G=f;H=+h[g+17552>>3];I=g;J=w}}while(0);j=+U(+J);w=m+ +W(+j,+(+h[I+17576>>3]))+1.0;g=c[(e+8|0)>>2]|0;j=+h[I+17544>>3];C=+h[I+17560>>3];f=H!=0.0;do{D=1;if(D){D=0;if(w*w!=0.0){do{if(f){K=H;L=I;M=F/H}else{if(F==0.0){K=H;L=I;M=F;break}N=F/+xH(c[d+536>>2]|0,H,12440,11912,+h[G>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;K=+h[E+17552>>3];L=E;M=N}}while(0);N=j+C*+U(+M)+-1.0;O=+h[L+17568>>3];do{if(K!=0.0){P=K;Q=L;R=o/K}else{if(o==0.0){P=K;Q=L;R=o;break}S=o/+xH(c[d+536>>2]|0,K,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;P=+h[E+17552>>3];Q=E;R=S}}while(0);S=O*R;E=c[c[(d+4|0)>>2]>>2]|0;T=+h[(c[E+8>>2]|0)+1776>>3];do{if(P!=0.0){V=P;X=Q;Y=T/P}else{if(T==0.0){V=P;X=Q;Y=T;break}Z=T/+xH(c[d+536>>2]|0,P,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;V=+h[_+17552>>3];X=_;Y=Z}}while(0);T=+U(+Y);O=+h[X+17576>>3];Z=+W(+T,+(O+-1.0));do{if(V!=0.0){$=V;aa=X;ba=r/V}else{if(r==0.0){$=V;aa=X;ba=r;break}T=r/+xH(c[d+536>>2]|0,V,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;$=+h[E+17552>>3];aa=E;ba=T}}while(0);T=N*(S+Z*O*ba);ca=+h[aa+17560>>3];ea=+h[aa+17568>>3];E=c[c[(d+4|0)>>2]>>2]|0;fa=+h[(c[E+8>>2]|0)+1776>>3];do{if($!=0.0){ga=+U(+(fa/$));ha=(ea*ga+ +W(+ga,+(+h[aa+17576>>3]))+1.0)/$}else{if(fa==0.0){ia=fa;ja=E;ka=$;la=aa;ma=fa}else{ga=fa/+xH(c[d+536>>2]|0,$,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;ia=+h[(c[na+8>>2]|0)+1776>>3];ja=na;ka=+h[_+17552>>3];la=_;ma=ga}ga=ea*+U(+ma);do{if(ka!=0.0){oa=ia;pa=ja;qa=ka;ra=la;sa=ia/ka}else{if(ia==0.0){oa=ia;pa=ja;qa=ka;ra=la;sa=ia;break}ta=ia/+xH(c[d+536>>2]|0,ka,12440,11912,+h[ja>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;na=c[c[(d+4|0)>>2]>>2]|0;oa=+h[(c[na+8>>2]|0)+1776>>3];pa=na;qa=+h[_+17552>>3];ra=_;sa=ta}}while(0);ta=+U(+sa);_=ga+ +W(+ta,+(+h[ra+17576>>3]))+1.0==0.0;ta=+h[ra+17568>>3];na=qa!=0.0;if(_){do{if(na){ua=oa;va=pa;wa=qa;xa=ra;ya=oa/qa}else{if(oa==0.0){ua=oa;va=pa;wa=qa;xa=ra;ya=oa;break}za=oa/+xH(c[d+536>>2]|0,qa,12440,11912,+h[pa>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;ua=+h[(c[Aa+8>>2]|0)+1776>>3];va=Aa;wa=+h[_+17552>>3];xa=_;ya=za}}while(0);ga=ta*+U(+ya);do{if(wa!=0.0){Ba=xa;Ca=ua/wa}else{if(ua==0.0){Ba=xa;Ca=ua;break}za=ua/+xH(c[d+536>>2]|0,wa,12440,11912,+h[va>>3],(a[d+319|0]|0)!=0|0);Ba=c[(d+416|0)>>2]|0;Ca=za}}while(0);za=+U(+Ca);ha=ga+ +W(+za,+(+h[Ba+17576>>3]))+1.0;break}else{do{if(na){Da=oa;Ea=pa;Fa=qa;Ga=ra;Ha=oa/qa}else{if(oa==0.0){Da=oa;Ea=pa;Fa=qa;Ga=ra;Ha=oa;break}za=oa/+xH(c[d+536>>2]|0,qa,12440,11912,+h[pa>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;Da=+h[(c[Aa+8>>2]|0)+1776>>3];Ea=Aa;Fa=+h[_+17552>>3];Ga=_;Ha=za}}while(0);ga=ta*+U(+Ha);do{if(Fa!=0.0){Ia=Ea;Ja=Fa;Ka=Ga;La=Da/Fa}else{if(Da==0.0){Ia=Ea;Ja=Fa;Ka=Ga;La=Da;break}za=Da/+xH(c[d+536>>2]|0,Fa,12440,11912,+h[Ea>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ia=c[c[(d+4|0)>>2]>>2]|0;Ja=+h[na+17552>>3];Ka=na;La=za}}while(0);ta=+U(+La);za=ga+ +W(+ta,+(+h[Ka+17576>>3]))+1.0;ha=za/+xH(c[d+536>>2]|0,Ja,12440,11912,+h[Ia>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ma=(T-ca*u*ha)/(w*w)}else{D=1}}if(D){D=0;if(1){do{if(f){Na=H;Oa=I;Pa=F/H}else{if(F==0.0){Na=H;Oa=I;Pa=F;break}ea=F/+xH(c[d+536>>2]|0,H,12440,11912,+h[G>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;Na=+h[E+17552>>3];Oa=E;Pa=ea}}while(0);ca=j+C*+U(+Pa)+-1.0;T=+h[Oa+17568>>3];do{if(Na!=0.0){Qa=Na;Ra=Oa;Sa=o/Na}else{if(o==0.0){Qa=Na;Ra=Oa;Sa=o;break}ea=o/+xH(c[d+536>>2]|0,Na,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;Qa=+h[E+17552>>3];Ra=E;Sa=ea}}while(0);ea=T*Sa;E=c[c[(d+4|0)>>2]>>2]|0;fa=+h[(c[E+8>>2]|0)+1776>>3];do{if(Qa!=0.0){Ta=Qa;Ua=Ra;Va=fa/Qa}else{if(fa==0.0){Ta=Qa;Ua=Ra;Va=fa;break}O=fa/+xH(c[d+536>>2]|0,Qa,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ta=+h[na+17552>>3];Ua=na;Va=O}}while(0);fa=+U(+Va);T=+h[Ua+17576>>3];O=+W(+fa,+(T+-1.0));do{if(Ta!=0.0){Wa=Ta;Xa=Ua;Ya=r/Ta}else{if(r==0.0){Wa=Ta;Xa=Ua;Ya=r;break}fa=r/+xH(c[d+536>>2]|0,Ta,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;Wa=+h[E+17552>>3];Xa=E;Ya=fa}}while(0);fa=ca*(ea+O*T*Ya);Z=+h[Xa+17560>>3];S=+h[Xa+17568>>3];E=c[c[(d+4|0)>>2]>>2]|0;N=+h[(c[E+8>>2]|0)+1776>>3];do{if(Wa!=0.0){za=+U(+(N/Wa));Za=Xa;_a=(S*za+ +W(+za,+(+h[Xa+17576>>3]))+1.0)/Wa}else{if(N==0.0){$a=N;ab=E;bb=Wa;cb=Xa;db=N}else{za=N/+xH(c[d+536>>2]|0,Wa,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;_=c[c[(d+4|0)>>2]>>2]|0;$a=+h[(c[_+8>>2]|0)+1776>>3];ab=_;bb=+h[na+17552>>3];cb=na;db=za}za=S*+U(+db);do{if(bb!=0.0){eb=$a;fb=ab;gb=bb;hb=cb;ib=$a/bb}else{if($a==0.0){eb=$a;fb=ab;gb=bb;hb=cb;ib=$a;break}ta=$a/+xH(c[d+536>>2]|0,bb,12440,11912,+h[ab>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;_=c[c[(d+4|0)>>2]>>2]|0;eb=+h[(c[_+8>>2]|0)+1776>>3];fb=_;gb=+h[na+17552>>3];hb=na;ib=ta}}while(0);ga=+U(+ib);na=za+ +W(+ga,+(+h[hb+17576>>3]))+1.0==0.0;ga=+h[hb+17568>>3];_=gb!=0.0;if(na){do{if(_){jb=eb;kb=fb;lb=gb;mb=hb;nb=eb/gb}else{if(eb==0.0){jb=eb;kb=fb;lb=gb;mb=hb;nb=eb;break}ta=eb/+xH(c[d+536>>2]|0,gb,12440,11912,+h[fb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;jb=+h[(c[Aa+8>>2]|0)+1776>>3];kb=Aa;lb=+h[na+17552>>3];mb=na;nb=ta}}while(0);za=ga*+U(+nb);do{if(lb!=0.0){ob=mb;pb=jb/lb}else{if(jb==0.0){ob=mb;pb=jb;break}ta=jb/+xH(c[d+536>>2]|0,lb,12440,11912,+h[kb>>3],(a[d+319|0]|0)!=0|0);ob=c[(d+416|0)>>2]|0;pb=ta}}while(0);ta=+U(+pb);Za=ob;_a=za+ +W(+ta,+(+h[ob+17576>>3]))+1.0;break}else{do{if(_){qb=eb;rb=fb;sb=gb;tb=hb;ub=eb/gb}else{if(eb==0.0){qb=eb;rb=fb;sb=gb;tb=hb;ub=eb;break}ta=eb/+xH(c[d+536>>2]|0,gb,12440,11912,+h[fb>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;qb=+h[(c[Aa+8>>2]|0)+1776>>3];rb=Aa;sb=+h[na+17552>>3];tb=na;ub=ta}}while(0);za=ga*+U(+ub);do{if(sb!=0.0){vb=rb;wb=sb;xb=tb;yb=qb/sb}else{if(qb==0.0){vb=rb;wb=sb;xb=tb;yb=qb;break}ta=qb/+xH(c[d+536>>2]|0,sb,12440,11912,+h[rb>>3],(a[d+319|0]|0)!=0|0);_=c[(d+416|0)>>2]|0;vb=c[c[(d+4|0)>>2]>>2]|0;wb=+h[_+17552>>3];xb=_;yb=ta}}while(0);ga=+U(+yb);ta=za+ +W(+ga,+(+h[xb+17576>>3]))+1.0;ga=ta/+xH(c[d+536>>2]|0,wb,12440,11912,+h[vb>>3],(a[d+319|0]|0)!=0|0);Za=c[(d+416|0)>>2]|0;_a=ga;break}}}while(0);S=+h[Za+17544>>3];N=+h[Za+17560>>3];T=+h[Za+17552>>3];E=c[c[(d+4|0)>>2]>>2]|0;O=+h[(c[E+8>>2]|0)+1776>>3];_=1;if(_){_=0;if(fa-Z*u*_a==0.0){do{if(T!=0.0){zb=T;Ab=Za;Bb=O/T}else{if(O==0.0){zb=T;Ab=Za;Bb=O;break}ea=O/+xH(c[d+536>>2]|0,T,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;zb=+h[na+17552>>3];Ab=na;Bb=ea}}while(0);Z=S+N*+U(+Bb)+-1.0;fa=+h[Ab+17568>>3];do{if(zb!=0.0){Cb=zb;Db=Ab;Eb=o/zb}else{if(o==0.0){Cb=zb;Db=Ab;Eb=o;break}ea=o/+xH(c[d+536>>2]|0,zb,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Cb=+h[na+17552>>3];Db=na;Eb=ea}}while(0);ea=fa*Eb;na=c[c[(d+4|0)>>2]>>2]|0;ca=+h[(c[na+8>>2]|0)+1776>>3];do{if(Cb!=0.0){Fb=Cb;Gb=Db;Hb=ca/Cb}else{if(ca==0.0){Fb=Cb;Gb=Db;Hb=ca;break}ga=ca/+xH(c[d+536>>2]|0,Cb,12440,11912,+h[na>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;Fb=+h[Aa+17552>>3];Gb=Aa;Hb=ga}}while(0);ca=+U(+Hb);fa=+h[Gb+17576>>3];ga=+W(+ca,+(fa+-1.0));do{if(Fb!=0.0){Ib=Fb;Jb=Gb;Kb=r/Fb}else{if(r==0.0){Ib=Fb;Jb=Gb;Kb=r;break}ca=r/+xH(c[d+536>>2]|0,Fb,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ib=+h[na+17552>>3];Jb=na;Kb=ca}}while(0);ca=Z*(ea+ga*fa*Kb);ta=+h[Jb+17560>>3];Lb=+h[Jb+17568>>3];na=c[c[(d+4|0)>>2]>>2]|0;Mb=+h[(c[na+8>>2]|0)+1776>>3];do{if(Ib!=0.0){Nb=+U(+(Mb/Ib));Ob=(Lb*Nb+ +W(+Nb,+(+h[Jb+17576>>3]))+1.0)/Ib}else{if(Mb==0.0){Pb=Mb;Qb=na;Rb=Ib;Sb=Jb;Tb=Mb}else{Nb=Mb/+xH(c[d+536>>2]|0,Ib,12440,11912,+h[na>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;Ub=c[c[(d+4|0)>>2]>>2]|0;Pb=+h[(c[Ub+8>>2]|0)+1776>>3];Qb=Ub;Rb=+h[Aa+17552>>3];Sb=Aa;Tb=Nb}Nb=Lb*+U(+Tb);do{if(Rb!=0.0){Vb=Pb;Wb=Qb;Xb=Rb;Yb=Sb;Zb=Pb/Rb}else{if(Pb==0.0){Vb=Pb;Wb=Qb;Xb=Rb;Yb=Sb;Zb=Pb;break}_b=Pb/+xH(c[d+536>>2]|0,Rb,12440,11912,+h[Qb>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;Ub=c[c[(d+4|0)>>2]>>2]|0;Vb=+h[(c[Ub+8>>2]|0)+1776>>3];Wb=Ub;Xb=+h[Aa+17552>>3];Yb=Aa;Zb=_b}}while(0);za=+U(+Zb);Aa=Nb+ +W(+za,+(+h[Yb+17576>>3]))+1.0==0.0;za=+h[Yb+17568>>3];Ub=Xb!=0.0;if(Aa){do{if(Ub){$b=Vb;ac=Wb;bc=Xb;cc=Yb;dc=Vb/Xb}else{if(Vb==0.0){$b=Vb;ac=Wb;bc=Xb;cc=Yb;dc=Vb;break}_b=Vb/+xH(c[d+536>>2]|0,Xb,12440,11912,+h[Wb>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;ec=c[c[(d+4|0)>>2]>>2]|0;$b=+h[(c[ec+8>>2]|0)+1776>>3];ac=ec;bc=+h[Aa+17552>>3];cc=Aa;dc=_b}}while(0);Nb=za*+U(+dc);do{if(bc!=0.0){fc=cc;gc=$b/bc}else{if($b==0.0){fc=cc;gc=$b;break}_b=$b/+xH(c[d+536>>2]|0,bc,12440,11912,+h[ac>>3],(a[d+319|0]|0)!=0|0);fc=c[(d+416|0)>>2]|0;gc=_b}}while(0);_b=+U(+gc);Ob=Nb+ +W(+_b,+(+h[fc+17576>>3]))+1.0;break}else{do{if(Ub){hc=Vb;ic=Wb;jc=Xb;kc=Yb;lc=Vb/Xb}else{if(Vb==0.0){hc=Vb;ic=Wb;jc=Xb;kc=Yb;lc=Vb;break}_b=Vb/+xH(c[d+536>>2]|0,Xb,12440,11912,+h[Wb>>3],(a[d+319|0]|0)!=0|0);Aa=c[(d+416|0)>>2]|0;ec=c[c[(d+4|0)>>2]>>2]|0;hc=+h[(c[ec+8>>2]|0)+1776>>3];ic=ec;jc=+h[Aa+17552>>3];kc=Aa;lc=_b}}while(0);Nb=za*+U(+lc);do{if(jc!=0.0){mc=ic;nc=jc;oc=kc;pc=hc/jc}else{if(hc==0.0){mc=ic;nc=jc;oc=kc;pc=hc;break}_b=hc/+xH(c[d+536>>2]|0,jc,12440,11912,+h[ic>>3],(a[d+319|0]|0)!=0|0);Ub=c[(d+416|0)>>2]|0;mc=c[c[(d+4|0)>>2]>>2]|0;nc=+h[Ub+17552>>3];oc=Ub;pc=_b}}while(0);za=+U(+pc);_b=Nb+ +W(+za,+(+h[oc+17576>>3]))+1.0;Ob=_b/+xH(c[d+536>>2]|0,nc,12440,11912,+h[mc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ma=ca-ta*u*Ob;break}else{_=1}}if(_){_=0;if(1){do{if(T!=0.0){qc=T;rc=Za;sc=O/T}else{if(O==0.0){qc=T;rc=Za;sc=O;break}Lb=O/+xH(c[d+536>>2]|0,T,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;qc=+h[na+17552>>3];rc=na;sc=Lb}}while(0);T=S+N*+U(+sc)+-1.0;O=+h[rc+17568>>3];do{if(qc!=0.0){tc=qc;uc=rc;vc=o/qc}else{if(o==0.0){tc=qc;uc=rc;vc=o;break}ta=o/+xH(c[d+536>>2]|0,qc,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;tc=+h[E+17552>>3];uc=E;vc=ta}}while(0);N=O*vc;E=c[c[(d+4|0)>>2]>>2]|0;S=+h[(c[E+8>>2]|0)+1776>>3];do{if(tc!=0.0){wc=tc;xc=uc;yc=S/tc}else{if(S==0.0){wc=tc;xc=uc;yc=S;break}ta=S/+xH(c[d+536>>2]|0,tc,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;wc=+h[na+17552>>3];xc=na;yc=ta}}while(0);S=+U(+yc);O=+h[xc+17576>>3];ta=+W(+S,+(O+-1.0));do{if(wc!=0.0){zc=wc;Ac=xc;Bc=r/wc}else{if(r==0.0){zc=wc;Ac=xc;Bc=r;break}S=r/+xH(c[d+536>>2]|0,wc,12440,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);E=c[(d+416|0)>>2]|0;zc=+h[E+17552>>3];Ac=E;Bc=S}}while(0);S=T*(N+ta*O*Bc);ca=+h[Ac+17560>>3];Lb=+h[Ac+17568>>3];E=c[c[(d+4|0)>>2]>>2]|0;Mb=+h[(c[E+8>>2]|0)+1776>>3];do{if(zc!=0.0){fa=+U(+(Mb/zc));Cc=(Lb*fa+ +W(+fa,+(+h[Ac+17576>>3]))+1.0)/zc}else{if(Mb==0.0){Dc=Mb;Ec=E;Fc=zc;Gc=Ac;Hc=Mb}else{fa=Mb/+xH(c[d+536>>2]|0,zc,12440,11912,+h[E>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ub=c[c[(d+4|0)>>2]>>2]|0;Dc=+h[(c[Ub+8>>2]|0)+1776>>3];Ec=Ub;Fc=+h[na+17552>>3];Gc=na;Hc=fa}fa=Lb*+U(+Hc);do{if(Fc!=0.0){Ic=Dc;Jc=Ec;Kc=Fc;Lc=Gc;Mc=Dc/Fc}else{if(Dc==0.0){Ic=Dc;Jc=Ec;Kc=Fc;Lc=Gc;Mc=Dc;break}ga=Dc/+xH(c[d+536>>2]|0,Fc,12440,11912,+h[Ec>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Ub=c[c[(d+4|0)>>2]>>2]|0;Ic=+h[(c[Ub+8>>2]|0)+1776>>3];Jc=Ub;Kc=+h[na+17552>>3];Lc=na;Mc=ga}}while(0);Nb=+U(+Mc);na=fa+ +W(+Nb,+(+h[Lc+17576>>3]))+1.0==0.0;Nb=+h[Lc+17568>>3];Ub=Kc!=0.0;if(na){do{if(Ub){Nc=Ic;Oc=Jc;Pc=Kc;Qc=Lc;Rc=Ic/Kc}else{if(Ic==0.0){Nc=Ic;Oc=Jc;Pc=Kc;Qc=Lc;Rc=Ic;break}ga=Ic/+xH(c[d+536>>2]|0,Kc,12440,11912,+h[Jc>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;Nc=+h[(c[Aa+8>>2]|0)+1776>>3];Oc=Aa;Pc=+h[na+17552>>3];Qc=na;Rc=ga}}while(0);fa=Nb*+U(+Rc);do{if(Pc!=0.0){Sc=Qc;Tc=Nc/Pc}else{if(Nc==0.0){Sc=Qc;Tc=Nc;break}ga=Nc/+xH(c[d+536>>2]|0,Pc,12440,11912,+h[Oc>>3],(a[d+319|0]|0)!=0|0);Sc=c[(d+416|0)>>2]|0;Tc=ga}}while(0);ga=+U(+Tc);Cc=fa+ +W(+ga,+(+h[Sc+17576>>3]))+1.0;break}else{do{if(Ub){Uc=Ic;Vc=Jc;Wc=Kc;Xc=Lc;Yc=Ic/Kc}else{if(Ic==0.0){Uc=Ic;Vc=Jc;Wc=Kc;Xc=Lc;Yc=Ic;break}ga=Ic/+xH(c[d+536>>2]|0,Kc,12440,11912,+h[Jc>>3],(a[d+319|0]|0)!=0|0);na=c[(d+416|0)>>2]|0;Aa=c[c[(d+4|0)>>2]>>2]|0;Uc=+h[(c[Aa+8>>2]|0)+1776>>3];Vc=Aa;Wc=+h[na+17552>>3];Xc=na;Yc=ga}}while(0);fa=Nb*+U(+Yc);do{if(Wc!=0.0){Zc=Vc;_c=Wc;$c=Xc;ad=Uc/Wc}else{if(Uc==0.0){Zc=Vc;_c=Wc;$c=Xc;ad=Uc;break}ga=Uc/+xH(c[d+536>>2]|0,Wc,12440,11912,+h[Vc>>3],(a[d+319|0]|0)!=0|0);Ub=c[(d+416|0)>>2]|0;Zc=c[c[(d+4|0)>>2]>>2]|0;_c=+h[Ub+17552>>3];$c=Ub;ad=ga}}while(0);Nb=+U(+ad);ga=fa+ +W(+Nb,+(+h[$c+17576>>3]))+1.0;Cc=ga/+xH(c[d+536>>2]|0,_c,12440,11912,+h[Zc>>3],(a[d+319|0]|0)!=0|0);break}}}while(0);Ma=(S-ca*u*Cc)/+xH(c[d+536>>2]|0,w*w,12488,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0);break}else{_=1}}}else{D=1}}}while(0);ze[g&3](18,8,Ma,45,e);ze[c[(e+8|0)>>2]&3](19,6,1.0,46,e);f=c[(d+416|0)>>2]|0;w=+h[f+17592>>3];C=+h[f+17600>>3];do{if(w!=0.0){bd=C/w}else{if(C==0.0){bd=C;break}bd=C/+xH(c[d+536>>2]|0,w,12784,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);if(!(bd>0.0)){g=c[28168]|0;f=c[d+536>>2]|0;h[k>>3]=bd;c[(b+24|0)>>2]=c[k>>2];c[(b+24|0)+4>>2]=c[k+4>>2];c[b+0>>2]=c[13104+0>>2];c[b+4>>2]=c[13104+4>>2];c[b+8>>2]=c[13104+8>>2];c[b+12>>2]=c[13104+12>>2];c[b+16>>2]=c[13104+16>>2];c[b+20>>2]=c[13104+20>>2];Pe[g&31](f,b,12824,b+24|0);}f=c[(e+8|0)>>2]|0;w=+da(+bd);C=+h[(c[(d+416|0)>>2]|0)+17584>>3];do{if(w!=0.0){cd=C/w}else{if(C==0.0){cd=C;break}cd=C/+xH(c[d+536>>2]|0,w,12960,11912,+h[c[c[(d+4|0)>>2]>>2]>>3],(a[d+319|0]|0)!=0|0)}}while(0);ze[f&3](19,7,cd*-7895683520871486.0e-21,47,e);ze[c[(e+8|0)>>2]&3](20,5,1.0,48,e);g=c[c[(d+4|0)>>2]>>2]|0;w=+h[(c[g+8>>2]|0)+1784>>3];if(w!=0.0){dd=w;ed=1.0/dd;fd=c[(e+8|0)>>2]|0;gd=ed*ed;ze[fd&3](20,6,gd,49,e);hd=c[(e+8|0)>>2]|0;ze[hd&3](21,0,-1.0,50,e);id=c[(e+8|0)>>2]|0;ze[id&3](21,1,-1.0,51,e);jd=c[(e+8|0)>>2]|0;ze[jd&3](21,2,-1.0,52,e);kd=c[(e+8|0)>>2]|0;ze[kd&3](21,4,-1.0,53,e);ld=c[(e+8|0)>>2]|0;ze[ld&3](21,16,-1.0,54,e);md=c[(e+8|0)>>2]|0;ze[md&3](22,3,1.0,55,e);nd=c[(e+8|0)>>2]|0;od=c[(d+4|0)>>2]|0;pd=c[od>>2]|0;qd=pd;rd=qd+8|0;sd=rd;td=c[sd>>2]|0;ud=td;vd=ud+2696|0;wd=vd;xd=+h[wd>>3];yd=-xd;ze[nd&3](22,4,yd,56,e);zd=c[(e+8|0)>>2]|0;Ad=c[(d+4|0)>>2]|0;Bd=c[Ad>>2]|0;Cd=Bd;Dd=Cd+8|0;Ed=Dd;Fd=c[Ed>>2]|0;Gd=Fd;Hd=Gd+2704|0;Id=Hd;Jd=+h[Id>>3];Kd=-Jd;ze[zd&3](23,2,Kd,57,e);Ld=c[(e+8|0)>>2]|0;ze[Ld&3](23,3,1.0,58,e);Md=c[(e+8|0)>>2]|0;Nd=c[(d+4|0)>>2]|0;Od=c[Nd>>2]|0;Pd=Od;Qd=Pd+8|0;Rd=Qd;Sd=c[Rd>>2]|0;Td=Sd;Ud=Td+2664|0;Vd=Ud;Wd=+h[Vd>>3];Xd=-Wd;ze[Md&3](24,1,Xd,59,e);Yd=c[(e+8|0)>>2]|0;ze[Yd&3](24,3,1.0,60,e);Zd=c[(e+8|0)>>2]|0;_d=c[(d+4|0)>>2]|0;$d=c[_d>>2]|0;ae=$d;be=ae+8|0;ce=be;de=c[ce>>2]|0;ee=de;fe=ee+2680|0;ge=fe;he=+h[ge>>3];ie=-he;ze[Zd&3](25,0,ie,61,e);je=c[(e+8|0)>>2]|0;ze[je&3](25,3,1.0,62,e);i=b;c[b+7328>>2]=5;break a}dd=+xH(c[d+536>>2]|0,w,13048,11912,+h[g>>3],(a[d+319|0]|0)!=0|0);ed=1.0/dd;fd=c[(e+8|0)>>2]|0;gd=ed*ed;ze[fd&3](20,6,gd,49,e);hd=c[(e+8|0)>>2]|0;ze[hd&3](21,0,-1.0,50,e);id=c[(e+8|0)>>2]|0;ze[id&3](21,1,-1.0,51,e);jd=c[(e+8|0)>>2]|0;ze[jd&3](21,2,-1.0,52,e);kd=c[(e+8|0)>>2]|0;ze[kd&3](21,4,-1.0,53,e);ld=c[(e+8|0)>>2]|0;ze[ld&3](21,16,-1.0,54,e);md=c[(e+8|0)>>2]|0;ze[md&3](22,3,1.0,55,e);nd=c[(e+8|0)>>2]|0;od=c[(d+4|0)>>2]|0;pd=c[od>>2]|0;qd=pd;rd=qd+8|0;sd=rd;td=c[sd>>2]|0;ud=td;vd=ud+2696|0;wd=vd;xd=+h[wd>>3];yd=-xd;ze[nd&3](22,4,yd,56,e);zd=c[(e+8|0)>>2]|0;Ad=c[(d+4|0)>>2]|0;Bd=c[Ad>>2]|0;Cd=Bd;Dd=Cd+8|0;Ed=Dd;Fd=c[Ed>>2]|0;Gd=Fd;Hd=Gd+2704|0;Id=Hd;Jd=+h[Id>>3];Kd=-Jd;ze[zd&3](23,2,Kd,57,e);Ld=c[(e+8|0)>>2]|0;ze[Ld&3](23,3,1.0,58,e);Md=c[(e+8|0)>>2]|0;Nd=c[(d+4|0)>>2]|0;Od=c[Nd>>2]|0;Pd=Od;Qd=Pd+8|0;Rd=Qd;Sd=c[Rd>>2]|0;Td=Sd;Ud=Td+2664|0;Vd=Ud;Wd=+h[Vd>>3];Xd=-Wd;ze[Md&3](24,1,Xd,59,e);Yd=c[(e+8|0)>>2]|0;ze[Yd&3](24,3,1.0,60,e);Zd=c[(e+8|0)>>2]|0;_d=c[(d+4|0)>>2]|0;$d=c[_d>>2]|0;ae=$d;be=ae+8|0;ce=be;de=c[ce>>2]|0;ee=de;fe=ee+2680|0;ge=fe;he=+h[ge>>3];ie=-he;ze[Zd&3](25,0,ie,61,e);je=c[(e+8|0)>>2]|0;ze[je&3](25,3,1.0,62,e);i=b;c[b+7328>>2]=5;break a}while(0)}



function paa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0,Cc=0,Dc=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=saa(b)|0}}while((pd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=saa(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[154096+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=saa(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[154112+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=saa(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=saa(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=saa(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=saa(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=saa(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=saa(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=Paa(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=Paa(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=saa(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){raa(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=Paa(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=qaa(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){raa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=Kaa(q|0,n|0,2)|0;o=Paa(p|0,J|0,-32,-1)|0;p=Paa(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Sc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Sc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=Paa(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=Oaa(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=Paa(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+jd(+(+taa(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Sc()|0)>>2]=34}l=+uaa(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=saa(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=saa(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=saa(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=Paa(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=Paa(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=saa(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=qaa(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){raa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=Paa(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Sc()|0)>>2]=22;raa(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Sc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Sc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[154128+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[154128+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[154128+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=Kaa(c[Ra>>2]|0,0,29)|0;Qa=Paa(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=Zaa(Qa|0,Ta|0,1e9,0)|0;pa=_aa(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=Kaa(c[Ua>>2]|0,0,29)|0;Ra=Paa(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=Zaa(Ra|0,Sa|0,1e9,0)|0;Pa=_aa(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[154120+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+jd(+(+taa(1.0,105-tc|0)),+sc);vc=+Ec(+sc,+(+taa(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){zc=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Ac=xc;break}}Ac=la*.25+xc}else{if(na>>>0>5e8){Ac=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Ac=la*.5+xc;break}else{Ac=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){zc=Ac;break}if(+Ec(+Ac,1.0)!=0.0){zc=Ac;break}zc=Ac+1.0}}while(0);la=yc+zc-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Bc=uc;Cc=kc;Dc=la}else{Bc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Cc=kc+1|0;Dc=la*.5}if((Cc+50|0)<=(p|0)){if(!((Bc|0)!=0&zc!=0.0)){Fc=Cc;Gc=Dc;break}}c[(Sc()|0)>>2]=34;Fc=Cc;Gc=Dc}else{Fc=kc;Gc=la}}while(0);l=+uaa(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=saa(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=saa(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Sc()|0)>>2]=22;raa(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Sc()|0)>>2]=22;raa(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function qaa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=saa(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=saa(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=saa(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Yaa(q|0,m|0,10,0)|0;b=J;g=Paa(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=Paa(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=saa(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=saa(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=Oaa(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function raa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function saa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=waa(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function taa(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=Kaa(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function uaa(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+taa(a,b);i=c;return+d}function vaa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){se[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function waa(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((vaa(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((se[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function xaa(a){a=a|0;var b=0,c=0.0;b=i;c=+yaa(a,0);i=b;return+c}function yaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;raa(e,0);h=+paa(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function zaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;raa(e,0);h=+paa(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function Aaa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function Baa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function Caa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function Daa(){c[33608]=p;c[33650]=p;c[38292]=p;c[38522]=p}function Eaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}gc(116);gc(111);gc(111);gc(32);gc(109);gc(97);gc(110);gc(121);gc(32);gc(115);gc(101);gc(116);gc(106);gc(109);gc(112);gc(115);gc(32);gc(105);gc(110);gc(32);gc(97);gc(32);gc(102);gc(117);gc(110);gc(99);gc(116);gc(105);gc(111);gc(110);gc(32);gc(99);gc(97);gc(108);gc(108);gc(44);gc(32);gc(98);gc(117);gc(105);gc(108);gc(100);gc(32);gc(119);gc(105);gc(116);gc(104);gc(32);gc(97);gc(32);gc(104);gc(105);gc(103);gc(104);gc(101);gc(114);gc(32);gc(118);gc(97);gc(108);gc(117);gc(101);gc(32);gc(102);gc(111);gc(114);gc(32);gc(77);gc(65);gc(88);gc(95);gc(83);gc(69);gc(84);gc(74);gc(77);gc(80);gc(83);gc(10);ga(0);return 0}function Faa(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function Gaa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function Haa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function Iaa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{Haa(b,c,d)|0}return b|0}function Jaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Kaa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function Laa(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Maa(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function Naa(){return Maa(o)|0}function Oaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function Paa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Qaa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function Raa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Saa(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Taa(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Uaa(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Vaa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Waa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Oaa(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=Oaa(($aa(i,b,Oaa(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Xaa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Oaa(h^a,j^b,h,j)|0;b=J;$aa(m,b,Oaa(k^d,l^e,k,l)|0,J,g)|0;l=Oaa(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Yaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Vaa(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Zaa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=$aa(a,b,c,d,0)|0;return(J=J,e)|0}function _aa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;$aa(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function $aa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Uaa(l|0)|0)>>>0);return(J=n,o)|0}p=(Taa(l|0)|0)-(Taa(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Taa(l|0)|0)-(Taa(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Taa(j|0)|0)+33-(Taa(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Uaa(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Paa(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Oaa(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=Oaa(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function aba(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ie[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function bba(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;je[a&31](b|0,c|0,d|0,e|0,f|0)}function cba(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return ke[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function dba(a,b){a=a|0;b=+b;le[a&1](+b)}function eba(a,b){a=a|0;b=b|0;me[a&255](b|0)}function fba(a,b,c){a=a|0;b=b|0;c=c|0;ne[a&127](b|0,c|0)}function gba(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return oe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function hba(a,b){a=a|0;b=b|0;return pe[a&127](b|0)|0}function iba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;qe[a&1](b|0,c|0,+d,e|0)}function jba(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return re[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function kba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return se[a&63](b|0,c|0,d|0)|0}function lba(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function mba(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ue[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function nba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ve[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function oba(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;we[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function pba(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return xe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function qba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ye[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function rba(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ze[a&3](b|0,c|0,+d,e|0,f|0)}function sba(a,b,c){a=a|0;b=b|0;c=+c;return Ae[a&1](b|0,+c)|0}function tba(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Be[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function uba(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Ce[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function vba(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;De[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function wba(a,b,c){a=a|0;b=b|0;c=c|0;return Ee[a&63](b|0,c|0)|0}function xba(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Fe[a&63](b|0,c|0,d|0,e|0,f|0)|0}function yba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Ge[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function zba(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+He[a&1](b|0,+c,+d)}function Aba(a,b,c){a=a|0;b=b|0;c=c|0;return+Ie[a&1](b|0,c|0)}function Bba(a){a=a|0;return Je[a&7]()|0}function Cba(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function Dba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Le[a&15](b|0,c|0,d|0)}function Eba(a){a=a|0;Me[a&7]()}function Fba(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ne[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Gba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Oe[a&63](b|0,c|0,d|0,e|0)|0}function Hba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Pe[a&31](b|0,c|0,d|0,e|0)}function Iba(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function Jba(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function Kba(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function Lba(a){a=+a;ga(3)}function Mba(a){a=a|0;ga(4)}function Nba(a){a=a|0;Id(a|0)}function Oba(a,b){a=a|0;b=b|0;ga(5)}function Pba(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function Qba(a){a=a|0;ga(7);return 0}function Rba(a){a=a|0;return Tc(a|0)|0}function Sba(a){a=a|0;return Rd(a|0)|0}function Tba(a){a=a|0;return Bc(a|0)|0}function Uba(a){a=a|0;return Fd(a|0)|0}function Vba(a){a=a|0;return sd(a|0)|0}function Wba(a){a=a|0;return zd(a|0)|0}function Xba(a){a=a|0;return cd(a|0)|0}function Yba(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function Zba(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function _ba(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function $ba(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function aca(a,b,c){a=a|0;b=b|0;c=c|0;return lc(a|0,b|0,c|0)|0}function bca(a,b,c){a=a|0;b=b|0;c=c|0;return Ud(a|0,b|0,c|0)|0}function cca(a,b,c){a=a|0;b=b|0;c=c|0;return Gd(a|0,b|0,c|0)|0}function dca(a,b,c){a=a|0;b=b|0;c=c|0;return Cd(a|0,b|0,c|0)|0}function eca(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function fca(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function gca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function hca(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function ica(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function jca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function kca(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function lca(a,b){a=a|0;b=+b;ga(18);return 0}function mca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function nca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function oca(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function pca(a,b){a=a|0;b=b|0;ga(22);return 0}function qca(a,b){a=a|0;b=b|0;return Xd(a|0,b|0)|0}function rca(a,b){a=a|0;b=b|0;return kc(a|0,b|0)|0}function sca(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function tca(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function uca(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function vca(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function wca(a,b){a=a|0;b=b|0;ga(26);return 0.0}function xca(){ga(27);return 0}function yca(){return jb()|0}function zca(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function Aca(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function Bca(){ga(30)}function Cca(){Zc()}function Dca(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function Eca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function Fca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return wc(a|0,b|0,c|0,d|0)|0}function Gca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Rc(a|0,b|0,c|0,d|0)|0}function Hca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function $h(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;YK(a,8)|0;d=a+476|0;e=c[(c[d>>2]|0)+540>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2528>>3]=+h[e>>3];h[a+96>>3]=+h[e+8>>3];h[a+2496>>3]=+h[e+16>>3];h[a+2608>>3]=+h[e+24>>3];h[a+2560>>3]=+h[e+32>>3];h[a+2576>>3]=+h[e+40>>3];h[a+2568>>3]=+h[e+48>>3];h[a+2624>>3]=+h[e+56>>3];h[a+2592>>3]=+h[e+64>>3];h[a+2216>>3]=+h[e+72>>3];h[a+2224>>3]=+h[e+80>>3];h[a+2440>>3]=+h[e+88>>3];h[a+2232>>3]=+h[e+96>>3];h[a+2432>>3]=+h[e+104>>3];h[a+2616>>3]=+h[e+112>>3];h[a+2256>>3]=+h[e+120>>3];h[a+2456>>3]=+h[e+128>>3];h[a+2248>>3]=+h[e+136>>3];h[a+2240>>3]=+h[e+144>>3];h[a+2448>>3]=+h[e+152>>3];h[a+2376>>3]=+h[e+160>>3];h[a+2544>>3]=+h[e+168>>3];h[a+2600>>3]=+h[e+176>>3];h[a+2536>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+540>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+2520>>3]=+h[e+192>>3];h[d+2584>>3]=+h[e+200>>3];i=b;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=+h[b+2416>>3]+ +h[b+2544>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2392>>3]=+h[b+2464>>3]+ +h[b+2384>>3];i=i;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=+h[b+2480>>3]+ +h[b+2392>>3];i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2408>>3]=+h[b+2504>>3]+ +h[b+2600>>3];i=i;return}function ei(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17240>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2408>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3856,6136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2640|0;p=o;h[p>>3]=m;i=d;return}function fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2400>>3]=+h[b+2368>>3]- +h[b+2536>>3];i=i;return}function gi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+17232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+2400>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}q=k/+xH(c[b+536>>2]|0,e,3936,6144,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+136|0;p=o;h[p>>3]=m;i=d;return}function hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=+h[b+1992>>3]*+h[b+2048>>3];i=i;return}function ii(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(KK(+U(+(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2048>>3])),1.0e-13)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=+h[j+2024>>3]*1.0e13;l=j}else{m=+h[j+2048>>3];n=+h[j+2024>>3];if(m!=0.0){k=n/m;l=j;break}if(n==0.0){k=n;l=j;break}o=n/+xH(c[b+536>>2]|0,m,6160,6152,+h[g>>3],(a[b+319|0]|0)!=0|0);k=o;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0}}while(0);h[l+2016>>3]=+U(+k);i=d;return}function ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2152>>3]=+h[b+2064>>3]+ +h[b+2016>>3];i=i;return}function ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1488>>3]=+h[b+40>>3]+ +h[(c[a+416>>2]|0)+17984>>3]*-.5;i=i;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+1488>>3]+ +h[(c[a+416>>2]|0)+17984>>3]*-.5;i=i;return}function mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1384>>3]=+h[b+1320>>3]- +h[(c[a+416>>2]|0)+18088>>3];i=i;return}function ni(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],+h[(c[b+416>>2]|0)+18064>>3])|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+2|0]=f;i=d;return}function oi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+1400|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18056>>3]*+h[m+32>>3];j=f;k=j+1400|0;l=k;h[l>>3]=g;i=d;return}}function pi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+2|0]|0)==0){g=0.0;j=f;k=j+1408|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+1384>>3]- +h[e+18064>>3]));g=-(+h[e+18048>>3]*m*m);j=f;k=j+1408|0;l=k;h[l>>3]=g;i=d;return}function qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+2|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+1400>>3],+h[f+1408>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+1408>>3];break}k=(KK(+h[l+1400>>3],-+h[l+1408>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+1400>>3];break}else{g=l;j=-+h[l+1408>>3];break}}}while(0);h[g+1392>>3]=j;i=d;return}function ri(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+1392>>3]*+h[b+32>>3];i=i;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+1408>>3]+ +h[b+1392>>3];i=i;return}function ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=+h[b+1512>>3]- +h[b+1424>>3];i=i;return}function ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1432>>3]=+h[(c[a+416>>2]|0)+18080>>3]- +h[b+40>>3];i=i;return}function vi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;l=GK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;e=k;f=j;break}else{j=b+4|0;k=GK(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;j=IK(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;e=k;f=g;break}else{g=b+4|0;k=IK(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1432>>3],+h[(c[b+416>>2]|0)+18024>>3])|0;a[(c[b+352>>2]|0)+5|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function wi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0;d=i;e=c[c[b+4>>2]>>2]|0;if((a[(c[e+16>>2]|0)+3|0]|0)==0){f=c[e+8>>2]|0;g=0.0;j=f;k=j+1456|0;l=k;h[l>>3]=g;i=d;return}else{m=c[e+8>>2]|0;f=m;g=+h[(c[b+416>>2]|0)+18016>>3]*+h[m+1440>>3];j=f;k=j+1456|0;l=k;h[l>>3]=g;i=d;return}}function xi(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+8>>2]|0;if((a[(c[e+16>>2]|0)+3|0]|0)==0){g=0.0;j=f;k=j+1464|0;l=k;h[l>>3]=g;i=d;return}e=c[b+416>>2]|0;m=+U(+(+h[f+1432>>3]- +h[e+18024>>3]));g=-(+h[e+18008>>3]*m*m);j=f;k=j+1464|0;l=k;h[l>>3]=g;i=d;return}function yi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0;d=i;e=b+4|0;b=c[c[e>>2]>>2]|0;f=c[b+8>>2]|0;do{if((a[(c[b+16>>2]|0)+3|0]|0)==0){g=f;j=0.0}else{k=(IK(+h[f+1456>>3],+h[f+1464>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(!k){g=l;j=+h[l+1464>>3];break}k=(KK(+h[l+1456>>3],-+h[l+1464>>3])|0)<<24>>24==0;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;if(k){g=l;j=+h[l+1456>>3];break}else{g=l;j=-+h[l+1464>>3];break}}}while(0);h[g+1448>>3]=j;i=d;return}function zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1472>>3]=+h[b+1448>>3]*+h[b+1440>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1480>>3]=+h[b+1464>>3]+ +h[b+1448>>3];i=i;return}function Bi(a){a=a|0;var b=0,d=0,e=0;b=i;YK(a,9)|0;d=c[(c[a+476>>2]|0)+604>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=+h[d>>3];h[e+1240>>3]=+h[d+8>>3];h[e+2128>>3]=+h[d+16>>3];i=b;return}function Ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+1240>>3];i=i;return}function Di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+40>>3]+ +h[(c[a+416>>2]|0)+18224>>3]*.5;i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1232>>3]+ +h[(c[a+416>>2]|0)+18224>>3]*.5;i=i;return}function Fi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;l=HK(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=l;e=k;f=j;break}else{j=b+4|0;k=HK(+h[c[c[j>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;j=LK(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;e=k;f=g;break}else{g=b+4|0;k=LK(+h[c[c[g>>2]>>2]>>3],+h[(c[b+400>>2]|0)+2648>>3])|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+4|0]=f;i=d;return}function Gi(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;if((a[b+312|0]|0)!=0){g=b+4|0;bj(e,c[b+536>>2]|0,c[c[b+320>>2]>>2]|0,+h[c[c[g>>2]>>2]>>3],+h[(c[b+416>>2]|0)+19216>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2648>>3]=+h[e>>3];i=d;return}e=b+4|0;g=c[c[e>>2]>>2]|0;do{if((a[(c[g+16>>2]|0)+4|0]|0)!=0){if((a[(c[b+408>>2]|0)+4|0]|0)!=0){break}bj(f,c[b+536>>2]|0,c[c[b+320>>2]>>2]|0,+h[g>>3],+h[(c[b+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+2648>>3]=+h[f>>3];i=d;return}}while(0);h[(c[g+8>>2]|0)+2648>>3]=+h[(c[b+400>>2]|0)+2648>>3];i=d;return}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,2,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[d>>3];i=b;return}function Ji(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;$i(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,3,+h[f>>3],+h[(c[f+8>>2]|0)+2648>>3],+h[(c[a+400>>2]|0)+2648>>3],+h[(c[a+416>>2]|0)+19216>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[d>>3];i=b;return}function Ki(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((LK(+h[f+17264>>3]*(+h[f+17272>>3]- +h[f+17256>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28168]|0;g=d;j=6312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&31](f,d,6272,e);i=b;return}function Li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((LK(+h[f+17296>>3]*(+h[f+17304>>3]- +h[f+17288>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28168]|0;g=d;j=6312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&31](f,d,6272,e);i=b;return}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((LK(+h[f+17328>>3]*(+h[f+17336>>3]- +h[f+17320>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28168]|0;g=d;j=6312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&31](f,d,6272,e);i=b;return}function Ni(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((LK(+h[f+17360>>3]*(+h[f+17368>>3]- +h[f+17352>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28168]|0;g=d;j=6312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&31](f,d,6272,e);i=b;return}function Oi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((LK(+h[f+18472>>3]*(+h[f+18480>>3]- +h[f+18464>>3])+1.0,1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28168]|0;g=d;j=6312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Pe[a&31](f,d,6272,e);i=b;return}function Pi(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);i=c;return 0}function Qi(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Ri(b);i=c;return 0}function Ri(a){a=a|0;var b=0;b=i;Bg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);fh(a);gh(a);hh(a);ih(a);jh(a);lh(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Th(a);Uh(a);Vh(a);$h(a);ai(a);bi(a);ci(a);fi(a);gi(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);si(a);ti(a);ui(a);vi(a);wi(a);xi(a);yi(a);Ai(a);Bi(a);Ci(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);Af(a);Kf(a);Lf(a);Nf(a);Of(a);Pf(a);Wf(a);Xf(a);Yf(a);Zf(a);$f(a);ag(a);bg(a);cg(a);dg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);wg(a);xg(a);yg(a);i=b;return}function Si(a,b){a=a|0;b=+b;i=i;return 0}function Ti(a){a=a|0;var b=0;b=i;i=i+8|0;uH(c[a+536>>2]|0,(a|0)!=0|0,6544,b);c[a+540>>2]=6352;c[a+84>>2]=6576;c[a+88>>2]=6576;c[a+92>>2]=6656;c[a+96>>2]=6720;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=9;c[a+116>>2]=384;c[a+120>>2]=1;c[a+124>>2]=0;c[a+128>>2]=5;c[a+132>>2]=0;c[a+136>>2]=2403;c[a+140>>2]=18;c[a+144>>2]=29;c[a+148>>2]=2;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=258;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=7;c[a+104>>2]=0;c[a+164>>2]=7;c[a+168>>2]=0;c[a+176>>2]=2;c[a+180>>2]=3;c[a+184>>2]=5;c[a+188>>2]=1;c[a+56>>2]=6760;c[a+64>>2]=10;c[a+72>>2]=0;c[a+68>>2]=1049;c[a+192>>2]=0;c[a+196>>2]=10;c[a+200>>2]=4;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Ui(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Saa(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=64432;F=64456;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[16108]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Saa(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[15338]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Saa(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(48,c[15338]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Saa(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;Eaa(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Saa(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;Eaa(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Saa(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(48,c[15338]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Saa(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Saa(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Saa(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,6848,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Saa(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Saa(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Saa(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Saa(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Saa(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Saa(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(48,c[15338]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Saa(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Saa(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Saa(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Saa(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Vi(){var a=0;a=i;zd(0)|0;wc(7008,18,1,c[r>>2]|0)|0;zd(0)|0;i=a;return}function Wi(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0;b=i;l=Xi(c[f+8>>2]|0)|0;m=Yi(f,1)|0;n=Yi(f,2)|0;f=Zi(c[h+8>>2]|0)|0;c[a>>2]=Vz(d,e,l,m,n,g,f,_i(h)|0,j,k)|0;i=b;return}function Xi(a){a=a|0;i=i;return a|0}function Yi(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=hH(a,b)|0;i=c;return d|0}function Zi(a){a=a|0;i=i;return a|0}function _i(a){a=a|0;var b=0,c=0;b=i;c=hH(a,1)|0;i=b;return c|0}function $i(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;j=+j;b=i;h[a>>3]=+aA(c,d,e,f,g);i=b;return}function aj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;b=i;h[a>>3]=+fA(c);i=b;return}function bj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;b=i;h[a>>3]=+gA(c,d);i=b;return}function cj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;b=i;h[a>>3]=+eA(c);i=b;return}function dj(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;h[a>>3]=+hA(c,d<<24>>24,e<<24>>24);i=b;return}function ej(a,b){a=a|0;b=b|0;a=i;_z(b);i=a;return}function fj(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;var k=0.0;k=+U(+(c/e));h[a>>3]=(k*f+d+-1.0)/(k*g+ +W(+k,+j)+1.0)+1.0;i=i;return}




// EMSCRIPTEN_END_FUNCS
var ie=[Iba,TJ,VJ,_J,eZ,Iba,Iba,Iba];var je=[Jba,pE,qE,VE,WE,yF,zF,WF,XF,YF,Z9,Y9,X9,JD,KD,sH,qH,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba,Jba];var ke=[Kba,GL];var le=[Lba,FK];var me=[Mba,gj,hj,bm,wm,Rt,ym,nH,SN,VN,UN,WN,c2,b2,e2,d2,XN,ZN,jR,HR,IR,JR,P1,O1,R1,Q1,qY,CY,PY,QY,RY,TY,VY,L_,M_,S_,T_,Z_,__,e$,f$,r$,q$,w$,v$,y$,z$,I$,H$,P0,O0,Y0,X0,A1,z1,Y1,X1,_1,Z1,q2,p2,s2,r2,y2,x2,N0,z2,w2,A2,C2,B2,K6,I2,H2,N2,M2,k3,j3,O3,N3,a4,$3,o4,n4,C4,B4,P4,O4,S4,R4,W4,V4,f5,e5,q5,p5,B5,A5,M5,L5,W5,V5,c6,b6,i6,h6,o6,n6,t6,s6,C6,B6,_6,Z6,x6,p7,W7,V7,Y7,X7,D2,J6,M6,h7,x7,I7,T7,U7,K9,J9,M9,P9,N9,O9,Q9,R9,maa,laa,Ti,Nba,Fi,Hi,Ii,Ji,Cg,Pg,Wg,Xg,Yg,Zg,_g,$g,ah,bh,ch,dh,eh,kh,mh,nh,oh,ph,wh,xh,Qh,Rh,Sh,Wh,Xh,Yh,Zh,_h,di,ei,hi,ii,ji,ri,zi,Di,Ei,zf,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Mf,Qf,Rf,Sf,Tf,Uf,Vf,_f,eg,fg,ng,vg,zg,Ag,Ki,Li,Mi,Ni,Oi,caa,pH,ef,pK,tK,oK,JL,vK,HL,NI,yK,wK,xK,uK,AK,IL,BK,qK,DK,lY,EK,j_,K_,L6,E8,O5,L8,K8,J8,I8,H8,G8,Y$,A0,Mba,Mba,Mba,Mba,Mba,Mba,Mba,Mba,Mba,Mba,Mba,Mba];var ne=[Oba,xm,oM,_N,n1,N_,U_,$_,g$,B1,Z4,_4,$4,a5,c5,d5,i5,j5,k5,l5,n5,o5,t5,u5,v5,w5,y5,z5,E5,F5,G5,H5,J5,K5,r6,w6,b8,d8,f8,c8,e8,g8,gK,Qj,Hk,ll,$l,cm,dm,em,fm,gm,hm,im,jm,km,lm,mm,nm,om,pm,qm,rm,sm,tm,um,vm,XI,TI,wA,LA,UB,zK,RQ,qM,pM,rM,xM,JM,sM,HM,eQ,qQ,pQ,rQ,$P,ZP,bQ,sZ,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba,Oba];var oe=[Pba,YD,RD,UJ,WJ,XJ,YJ,ZJ];var pe=[Qba,Qi,vz,Pi,gf,hf,jf,St,Zt,Em,Qt,uz,xz,Dm,Bm,yz,zz,Jz,Kz,Lz,Mz,Nz,Oz,Pz,Qz,Rba,Sba,Tba,OH,baa,Uba,cO,s1,dO,v1,r1,YY,O_,G1,I1,J1,F1,V_,W_,a$,u1,h$,i$,s$,x$,u2,p4,h8,j8,l8,r8,t8,n8,p8,D4,i8,k8,m8,s8,u8,o8,q8,X4,Y4,b5,g5,h5,m5,r5,s5,x5,C5,D5,I5,t7,u7,w7,Z7,$7,_7,a8,l7,m7,o7,D7,E7,H7,O7,P7,S7,L9,naa,QL,Vba,Wba,OL,PL,Xba,eY,HY,MK,UK,eL,NK,XK,fL,C_,waa,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba,Qba];var qe=[Yba,sI];var re=[Zba,DJ];var se=[_ba,Am,gE,mE,ME,SE,pF,vF,$N,t1,x1,o1,C1,H1,P_,L1,b$,C$,D$,G2,L2,p6,u6,a7,c7,f7,N6,S6,U6,X6,S9,nY,TB,VD,MD,TD,ZD,$ba,aca,bca,KL,kY,gY,cca,u_,dca,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba,_ba];var te=[eca,HJ];var ue=[fca,$I];var ve=[gca,W3,Z3,i4,k4,gca,gca,gca];var we=[hca,Q4,T4,N5,R5,X5,Z5,hca];var xe=[ica,BJ];var ye=[jca,kH,aO,WY,D1,p1,P3,Q3,U3,_3,b4,c4,g4,l4,q6,v6,aaa,$9,_9,lH,jca,jca,jca,jca,jca,jca,jca,jca,jca,jca,jca,jca];var ze=[kca,VK,WK,kca];var Ae=[lca,Si];var Be=[mca,O2,Q2,S2,U2,W2,Y2,_2,a3,c3,e3,g3,l3,n3,p3,r3,t3,v3,x3,z3,B3,D3,F3,T3,V3,f4,h4,q4,r4,s4,t4,u4,E4,F4,G4,H4,I4,g6,m6,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca,mca];var Ce=[nca,d6,j6,nca];var De=[oca,v4,J4,oca];var Ee=[pca,ff,Gm,Cm,zm,Rz,Sz,iE,jE,lE,OE,PE,RE,rF,sF,uF,AF,BF,CF,DF,EF,FF,GF,HF,eO,fO,ZY,_Y,K1,Q_,X_,M1,w1,c$,j$,y1,$6,b7,d7,R6,T6,V6,yL,hL,ZK,OK,gL,YK,qca,KA,eaa,GD,HD,ID,rca,aI,aL,dL,RK,uL,lL,TK,sca,v9];var Fe=[tca,E2,J2,g7,s7,v7,Y6,k7,n7,C7,F7,N7,Q7,cG,VG,WG,hG,eG,TG,UG,iG,jG,kG,lG,mG,JG,KG,AG,tG,oG,nG,pG,qG,sG,rG,fG,dG,uG,vG,wG,xG,yG,zG,BG,CG,DG,EG,IG,GG,FG,HG,PG,LG,MG,NG,OG,QG,RG,SG,XG,YG,ZG,_G,R3];var Ge=[uca,VL];var He=[vca,iL];var Ie=[wca,jJ];var Je=[xca,Uz,yca,PH,H_,I_,F_,xca];var Ke=[zca,GJ];var Le=[Aca,pY,B$,v2,oI,vH,jM,lM,QQ,rZ,Aca,Aca,Aca,Aca,Aca,Aca];var Me=[Bca,Cca,NH,bH,Vi,Bca,Bca,Bca];var Ne=[Dca,Tz,q7,r7,i7,j7,y7,A7,J7,L7,mL,Dca,Dca,Dca,Dca,Dca];var Oe=[Eca,aE,bE,cE,dE,eE,fE,hE,kE,oE,GE,HE,IE,JE,KE,LE,NE,QE,UE,jF,kF,lF,mF,nF,oF,qF,tF,xF,e7,O6,P6,Q6,W6,iK,Fca,iB,CJ,yD,BC,WC,dD,RC,mD,rD,pD,sD,_D,ED,OD,PD,WD,XD,i3,X3,Gca,Eca,Eca,Eca,Eca,Eca,Eca,Eca,Eca,Eca];var Pe=[Hca,nE,TE,wF,bO,oY,XY,E1,q1,F2,K2,T9,U9,V9,tH,rH,kK,uH,rI,BH,Rj,Ik,ml,am,MZ,QD,wH,Hca,Hca,Hca,Hca,Hca];return{_testSetjmp:Saa,_saveSetjmp:Eaa,_free:caa,_main:Ui,_rand_r:Maa,_realloc:eaa,_i64Add:Paa,_memmove:Iaa,_bitshift64Ashr:Gaa,_memset:Jaa,_malloc:baa,_strncpy:Qaa,_memcpy:Haa,_strlen:Faa,_bitshift64Lshr:Raa,_bitshift64Shl:Kaa,_i64Subtract:Oaa,_strcpy:Laa,_calloc:daa,_rand:Naa,__GLOBAL__I_a:l$,runPostSets:Daa,stackAlloc:Qe,stackSave:Re,stackRestore:Se,setThrew:Te,setTempRet0:We,setTempRet1:Xe,setTempRet2:Ye,setTempRet3:Ze,setTempRet4:_e,setTempRet5:$e,setTempRet6:af,setTempRet7:bf,setTempRet8:cf,setTempRet9:df,dynCall_iiiiiiii:aba,dynCall_viiiii:bba,dynCall_iiiiidiii:cba,dynCall_vd:dba,dynCall_vi:eba,dynCall_vii:fba,dynCall_iiiiiiiiiii:gba,dynCall_ii:hba,dynCall_viidi:iba,dynCall_iiiiiiiiiiiiii:jba,dynCall_iiii:kba,dynCall_iiiiiiiiiiiiiiiiiiiiiii:lba,dynCall_iiiiiiiiiiiiiiiiiiiii:mba,dynCall_viiiiid:nba,dynCall_viiiiiiii:oba,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:pba,dynCall_viiiiii:qba,dynCall_viidii:rba,dynCall_iid:sba,dynCall_viiiiiii:tba,dynCall_viiiiiid:uba,dynCall_viiiiiiiii:vba,dynCall_iii:wba,dynCall_iiiiii:xba,dynCall_iiiiidi:yba,dynCall_didd:zba,dynCall_dii:Aba,dynCall_i:Bba,dynCall_iiiiiiiiii:Cba,dynCall_viii:Dba,dynCall_v:Eba,dynCall_iiiiiiiii:Fba,dynCall_iiiii:Gba,dynCall_viiii:Hba}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "_isblank": _isblank, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_sysconf": _sysconf, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "__isLeapYear": __isLeapYear, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_ctime": _ctime, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_strchr": _strchr, "_mktime": _mktime, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_localeconv": _localeconv, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_asctime": _asctime, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_asctime_r": _asctime_r, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_copysign": _copysign, "__parseInt64": __parseInt64, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__formatString": __formatString, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "_lis_vector_create": _lis_vector_create, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "_feof": _feof, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_fgetc": _fgetc, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_fgets": _fgets, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






