var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 139712;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 139752;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(140579);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,43,5,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,100,97,109,112,101,114,50,46,115,95,114,101,108,44,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,115,95,115,109,97,108,108,41,0,0,0,0,0,1,0,0,0,48,5,0,0,1,0,0,0,53,5,0,0,1,0,0,0,59,5,0,0,115,113,114,116,40,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,41,0,0,0,0,0,1,0,0,0,60,5,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,100,97,109,112,101,114,50,46,115,95,114,101,108,44,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,115,95,115,109,97,108,108,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,63,5,0,0,1,0,0,0,68,5,0,0,1,0,0,0,129,5,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,0,0,0,0,0,1,0,0,0,130,5,0,0,1,0,0,0,133,5,0,0,1,0,0,0,134,5,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,1,0,0,0,137,5,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,1,0,0,0,140,5,0,0,1,0,0,0,150,5,0,0,1,0,0,0,154,5,0,0,1,0,0,0,157,5,0,0,115,113,114,116,40,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,49,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,50,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,48,91,51,93,32,94,32,50,46,48,41,0,1,0,0,0,160,5,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,163,5,0,0,1,0,0,0,164,5,0,0,1,0,0,0,166,5,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,113,114,116,40,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,167,5,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,170,5,0,0,1,0,0,0,181,5,0,0,40,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,49,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,50,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,48,91,51,93,32,94,32,50,46,48,41,32,42,32,52,46,48,0,0,0,0,0,0,0,1,0,0,0,192,5,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,112,97,114,97,109,101,116,101,114,32,105,110,110,101,114,87,105,100,116,104,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,112,97,114,97,109,101,116,101,114,32,119,105,100,116,104,0,0,0,0,112,97,114,97,109,101,116,101,114,32,105,110,110,101,114,72,101,105,103,104,116,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,112,97,114,97,109,101,116,101,114,32,104,101,105,103,104,116,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,112,8,0,0,215,15,0,0,7,0,0,0,218,15,0,0,61,0,0,0,0,0,0,0,10,68,105,115,116,97,110,99,101,32,98,101,116,119,101,101,110,32,102,114,97,109,101,95,97,32,97,110,100,32,102,114,97,109,101,95,98,32,111,102,32,97,32,74,111,105,110,116,85,80,83,32,106,111,105,110,116,10,98,101,99,97,109,101,32,122,101,114,111,46,32,84,104,105,115,32,105,115,32,110,111,116,32,97,108,108,111,119,101,100,46,32,73,102,32,116,104,105,115,32,111,99,99,117,114,115,32,100,117,114,105,110,103,10,105,110,105,116,105,97,108,105,122,97,116,105,111,110,44,32,116,104,101,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,32,97,114,101,32,112,114,111,98,97,98,108,121,32,119,114,111,110,103,46,0,0,0,0,112,8,0,0,223,15,0,0,7,0,0,0,230,15,0,0,3,0,0,0,0,0,0,0,10,65,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,65,115,115,101,109,98,108,105,101,115,46,74,111,105,110,116,85,80,83,32,106,111,105,110,116,32,40,99,111,110,115,105,115,116,105,110,103,32,111,102,10,97,32,117,110,105,118,101,114,115,97,108,44,32,112,114,105,115,109,97,116,105,99,32,97,110,100,32,115,112,104,101,114,105,99,97,108,32,106,111,105,110,116,41,32,105,115,32,105,110,32,116,104,101,32,115,105,110,103,117,108,97,114,10,99,111,110,102,105,103,117,114,97,116,105,111,110,32,111,102,32,116,104,101,32,117,110,105,118,101,114,115,97,108,32,106,111,105,110,116,46,32,84,104,105,115,32,109,101,97,110,115,32,116,104,97,116,32,97,120,105,115,32,49,32,111,102,10,116,104,101,32,117,110,105,118,101,114,115,97,108,32,106,111,105,110,116,32,100,101,102,105,110,101,100,32,118,105,97,32,112,97,114,97,109,101,116,101,114,32,34,110,49,95,97,34,32,105,115,32,112,97,114,97,108,108,101,108,32,116,111,32,118,101,99,116,111,114,10,34,101,65,120,105,115,95,105,97,34,32,116,104,97,116,32,105,115,32,100,105,114,101,99,116,101,100,32,102,114,111,109,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,97,32,116,111,32,116,104,101,10,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,98,46,32,89,111,117,32,109,97,121,32,116,114,121,32,116,111,32,117,115,101,32,97,110,111,116,104,101,114,32,34,110,49,95,97,34,32,118,101,99,116,111,114,46,10,0,0,0,0,0,0,0,168,7,0,0,233,5,0,0,5,0,0,0,234,5,0,0,62,0,0,0,0,0,0,0,168,7,0,0,235,5,0,0,5,0,0,0,236,5,0,0,64,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,70,111,114,99,101,115,46,109,111,0,0,0,0,0,0,112,11,0,0,205,6,0,0,5,0,0,0,222,6,0,0,3,0,0,0,0,0,0,0,10,84,104,101,32,100,105,115,116,97,110,99,101,32,98,101,116,119,101,101,110,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,97,32,97,110,100,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,98,10,111,102,32,97,32,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,32,99,111,109,112,111,110,101,110,116,32,98,101,99,97,109,101,32,115,109,97,108,108,101,114,32,97,115,32,112,97,114,97,109,101,116,101,114,32,115,95,115,109,97,108,108,10,40,61,32,97,32,115,109,97,108,108,32,110,117,109,98,101,114,44,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,34,65,100,118,97,110,99,101,100,34,32,109,101,110,117,41,46,32,84,104,101,32,100,105,115,116,97,110,99,101,32,105,115,10,115,101,116,32,116,111,32,115,95,115,109,97,108,108,44,32,97,108,116,104,111,117,103,104,32,105,116,32,105,115,32,115,109,97,108,108,101,114,44,32,116,111,32,97,118,111,105,100,32,97,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,10,119,104,101,110,32,99,111,109,112,117,116,105,110,103,32,116,104,101,32,100,105,114,101,99,116,105,111,110,32,111,102,32,116,104,101,32,108,105,110,101,32,102,111,114,99,101,46,32,80,111,115,115,105,98,108,101,32,114,101,97,115,111,110,115,10,102,111,114,32,116,104,105,115,32,115,105,116,117,97,116,105,111,110,58,10,45,32,65,116,32,105,110,105,116,105,97,108,32,116,105,109,101,32,116,104,101,32,100,105,115,116,97,110,99,101,32,109,97,121,32,97,108,114,101,97,100,121,32,98,101,32,122,101,114,111,58,32,67,104,97,110,103,101,32,116,104,101,32,105,110,105,116,105,97,108,10,32,32,112,111,115,105,116,105,111,110,115,32,111,102,32,116,104,101,32,98,111,100,105,101,115,32,99,111,110,110,101,99,116,101,100,32,98,121,32,116,104,105,115,32,101,108,101,109,101,110,116,46,10,45,32,72,97,114,100,119,97,114,101,32,115,116,111,112,115,32,97,114,101,32,110,111,116,32,109,111,100,101,108,101,100,32,111,114,32,97,114,101,32,109,111,100,101,108,101,100,32,110,111,116,32,115,116,105,102,102,32,101,110,111,117,103,104,46,10,32,32,73,110,99,108,117,100,101,32,115,116,111,112,115,44,32,101,46,103,46,44,32,115,116,105,102,102,32,115,112,114,105,110,103,115,44,32,111,114,32,105,110,99,114,101,97,115,101,32,116,104,101,32,115,116,105,102,102,110,101,115,115,10,32,32,105,102,32,97,108,114,101,97,100,121,32,112,114,101,115,101,110,116,46,10,45,32,65,110,111,116,104,101,114,32,101,114,114,111,114,32,105,110,32,121,111,117,114,32,109,111,100,101,108,32,109,97,121,32,108,101,97,100,32,116,111,32,117,110,114,101,97,108,105,115,116,105,99,97,108,108,121,32,108,97,114,103,101,32,102,111,114,99,101,115,10,32,32,97,110,100,32,116,111,114,113,117,101,115,32,116,104,97,116,32,119,111,117,108,100,32,105,110,32,114,101,97,108,105,116,121,32,100,101,115,116,114,111,121,32,116,104,101,32,115,116,111,112,115,46,10,45,32,84,104,101,32,102,108,97,110,103,101,95,98,32,99,111,110,110,101,99,116,111,114,32,109,105,103,104,116,32,98,101,32,100,101,102,105,110,101,100,32,98,121,32,97,32,112,114,101,45,100,101,102,105,110,101,100,32,109,111,116,105,111,110,44,10,32,32,101,46,103,46,44,32,119,105,116,104,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,84,114,97,110,115,108,97,116,105,111,110,97,108,46,80,111,115,105,116,105,111,110,32,97,110,100,32,116,104,101,10,32,32,112,114,101,100,101,102,105,110,101,100,32,102,108,97,110,103,101,95,98,46,115,32,105,115,32,122,101,114,111,32,111,114,32,110,101,103,97,116,105,118,101,46,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,69,108,101,109,101,110,116,97,114,121,46,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,69,108,101,109,101,110,116,97,114,121,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,69,108,101,109,101,110,116,97,114,121,46,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,95,105,110,102,111,46,120,109,108,0,0,0,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,96,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,51,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,1,0,0,0,160,19,0,0,168,19,0,0,0,0,0,0,1,0,0,0,128,19,0,0,136,19,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,152,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,100,97,109,112,101,114,50,46,115,95,114,101,108,44,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,115,95,115,109,97,108,108,41,32,94,32,52,46,48,0,0,0,0,0,0,0,1,0,0,0,155,0,0,0,100,97,109,112,101,114,50,46,115,95,114,101,108,0,0,0,1,0,0,0,160,0,0,0,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,76,95,98,0,0,0,0,0,0,1,0,0,0,162,0,0,0,1,0,0,0,164,0,0,0,1,0,0,0,168,0,0,0,1,0,0,0,177,0,0,0,115,113,114,116,40,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,41,0,0,0,0,0,1,0,0,0,77,5,0,0,1,0,0,0,80,5,0,0,1,0,0,0,81,5,0,0,1,0,0,0,83,5,0,0,1,0,0,0,84,5,0,0,1,0,0,0,87,5,0,0,1,0,0,0,96,5,0,0,1,0,0,0,88,0,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,32,94,32,50,46,48,0,0,0,0,0,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,32,42,32,106,111,105,110,116,85,80,83,46,101,51,95,97,91,51,93,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,0,0,0,0,0,1,0,0,0,88,0,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,179,5,0,0,106,111,105,110,116,85,80,83,46,101,51,95,97,91,51,93,32,42,32,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,0,0,1,0,0,0,179,5,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,101,109,112,116,121,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,1,0,0,0,29,0,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,0,0,0,0,0,1,0,0,0,32,0,0,0,1,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,1,0,0,0,36,0,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,0,0,0,0,1,0,0,0,41,0,0,0,1,0,0,0,57,0,0,0,1,0,0,0,59,0,0,0,115,113,114,116,40,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,49,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,50,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,48,91,51,93,32,94,32,50,46,48,41,0,1,0,0,0,60,0,0,0,106,111,105,110,116,85,80,83,46,97,120,105,115,76,101,110,103,116,104,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,61,0,0,0,1,0,0,0,63,0,0,0,115,113,114,116,40,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,50,95,110,50,95,97,41,32,42,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,64,0,0,0,106,111,105,110,116,85,80,83,46,108,101,110,103,116,104,95,110,50,95,97,32,94,32,50,46,48,0,0,0,0,0,0,1,0,0,0,67,0,0,0,1,0,0,0,72,0,0,0,1,0,0,0,81,0,0,0,1,0,0,0,82,0,0,0,1,0,0,0,90,0,0,0,40,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,49,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,97,91,50,93,32,94,32,50,46,48,32,43,32,106,111,105,110,116,85,80,83,46,114,65,120,105,115,95,48,91,51,93,32,94,32,50,46,48,41,32,42,32,52,46,48,0,0,0,0,0,0,0,1,0,0,0,96,0,0,0,1,0,0,0,126,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,100,97,109,112,101,114,50,46,115,95,114,101,108,44,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,115,95,115,109,97,108,108,41,0,0,0,0,0,1,0,0,0,131,0,0,0,1,0,0,0,136,0,0,0,1,0,0,0,150,0,0,0,115,113,114,116,40,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,49,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,50,93,32,43,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,32,42,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,114,95,114,101,108,95,48,91,51,93,41,0,0,0,0,0,1,0,0,0,211,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,100,97,109,112,101,114,50,46,115,95,114,101,108,44,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,115,95,115,109,97,108,108,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,214,0,0,0,1,0,0,0,217,0,0,0,2,0,0,0,112,29,0,0,120,29,0,0,0,0,0,0,1,0,0,0,72,29,0,0,80,29,0,0,0,0,0,0,1,0,0,0,253,0,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,60,1,0,0,1,0,0,0,71,1,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,76,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,42,32,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,43,32,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,1,0,0,0,40,29,0,0,48,29,0,0,0,0,0,0,1,0,0,0,8,29,0,0,16,29,0,0,0,0,0,0,1,0,0,0,232,28,0,0,240,28,0,0,0,0,0,0,112,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,200,28,0,0,208,28,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,37,115,40,110,111,109,105,110,97,108,61,37,103,41,0,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,208,146,0,0,216,146,0,0,0,0,0,0,1,0,0,0,176,146,0,0,184,146,0,0,0,0,0,0,1,0,0,0,144,146,0,0,152,146,0,0,0,0,0,0,1,0,0,0,112,146,0,0,120,146,0,0,0,0,0,0,1,0,0,0,136,9,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,42,32,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,43,32,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,176,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,187,9,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,198,9,0,0,2,0,0,0,32,146,0,0,40,146,0,0,0,0,0,0,1,0,0,0,248,145,0,0,0,146,0,0,0,0,0,0,1,0,0,0,15,10,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,95,98,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,95,98,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,70,111,114,99,101,115,46,109,111,0,0,0,0,0,0,32,32,0,0,94,6,0,0,5,0,0,0,95,6,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,95,97,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,95,97,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,32,0,0,92,6,0,0,5,0,0,0,93,6,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,50,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,50,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,50,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,50,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,100,97,109,112,101,114,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,51,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,51,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,51,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,51,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,114,101,118,111,108,117,116,101,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,33,0,0,58,6,0,0,7,0,0,0,59,6,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,115,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,33,0,0,170,17,0,0,7,0,0,0,171,17,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,100,97,109,112,101,114,49,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,120,33,0,0,167,17,0,0,7,0,0,0,169,17,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,53,0,0,72,15,0,0,7,0,0,0,75,15,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,53,0,0,86,15,0,0,7,0,0,0,90,15,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,72,53,0,0,82,15,0,0,7,0,0,0,85,15,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,72,53,0,0,66,15,0,0,7,0,0,0,68,15,0,0,92,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,225,2,0,0,5,0,0,0,229,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,35,0,0,214,2,0,0,5,0,0,0,218,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,35,0,0,248,2,0,0,5,0,0,0,251,2,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,56,35,0,0,190,2,0,0,5,0,0,0,192,2,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,35,0,0,165,2,0,0,5,0,0,0,167,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,35,0,0,162,2,0,0,5,0,0,0,164,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,56,35,0,0,159,2,0,0,5,0,0,0,161,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,156,2,0,0,5,0,0,0,158,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,153,2,0,0,5,0,0,0,155,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,150,2,0,0,5,0,0,0,152,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,149,2,0,0,5,0,0,0,149,2,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,179,5,0,0,5,0,0,0,179,5,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,35,0,0,195,0,0,0,5,0,0,0,198,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,190,0,0,0,5,0,0,0,194,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,175,5,0,0,5,0,0,0,176,5,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,106,5,0,0,5,0,0,0,106,5,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,177,5,0,0,5,0,0,0,178,5,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,56,35,0,0,104,5,0,0,5,0,0,0,105,5,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,35,0,0,109,5,0,0,5,0,0,0,110,5,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,35,0,0,170,5,0,0,5,0,0,0,173,5,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,66,111,120,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,140,5,0,0,5,0,0,0,142,5,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,35,0,0,111,5,0,0,5,0,0,0,112,5,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,107,5,0,0,5,0,0,0,108,5,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,72,53,0,0,247,0,0,0,5,0,0,0,249,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,53,0,0,244,0,0,0,5,0,0,0,246,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,114,101,118,111,108,117,116,101,49,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,53,0,0,1,1,0,0,5,0,0,0,2,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,32,95,0,0,189,4,0,0,3,0,0,0,193,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,95,0,0,167,4,0,0,3,0,0,0,169,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,95,0,0,164,4,0,0,3,0,0,0,166,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,95,0,0,243,4,0,0,3,0,0,0,245,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,95,0,0,240,4,0,0,3,0,0,0,242,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,95,0,0,237,4,0,0,3,0,0,0,239,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,95,0,0,198,4,0,0,3,0,0,0,202,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,109,117,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,109,117,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,95,0,0,156,4,0,0,3,0,0,0,160,4,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,78,111,71,114,97,118,105,116,121,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,80,111,105,110,116,71,114,97,118,105,116,121,32,104,97,115,32,118,97,108,117,101,58,32,0,32,95,0,0,148,4,0,0,3,0,0,0,149,4,0,0,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,69,108,101,109,101,110,116,97,114,121,47,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,111,0,0,136,100,0,0,5,0,0,0,3,0,0,0,5,0,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,109,97,115,115,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,32,0,0,120,6,0,0,5,0,0,0,122,6,0,0,151,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,51,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,50,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,49,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,98,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,32,0,0,115,6,0,0,5,0,0,0,116,6,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,51,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,50,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,49,93,32,62,61,32,48,32,97,110,100,32,108,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,46,99,111,108,111,114,95,97,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,32,0,0,105,6,0,0,5,0,0,0,106,6,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,111,100,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,111,100,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,111,100,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,111,100,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,111,100,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,111,100,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,111,100,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,111,100,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([32,105,110,116,101,114,118,97,108,58,32,114,111,100,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,111,100,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,72,53,0,0,91,15,0,0,6,0,0,0,94,15,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,72,53,0,0,69,15,0,0,7,0,0,0,71,15,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,106,111,105,110,116,85,80,83,46,97,120,105,115,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,72,53,0,0,76,15,0,0,7,0,0,0,78,15,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,111,100,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,111,100,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,111,100,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,111,100,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,111,100,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,56,35,0,0,205,0,0,0,5,0,0,0,210,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,56,35,0,0,219,2,0,0,5,0,0,0,224,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,66,111,120,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,56,35,0,0,113,5,0,0,5,0,0,0,114,5,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,114,101,118,111,108,117,116,101,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,53,0,0,250,0,0,0,5,0,0,0,252,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,95,0,0,194,4,0,0,3,0,0,0,197,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,32,95,0,0,172,4,0,0,3,0,0,0,174,4,0,0,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,95,0,0,203,4,0,0,3,0,0,0,206,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,85,116,105,108,105,116,105,101,115,47,73,110,116,101,114,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,24,139,0,0,39,0,0,0,5,0,0,0,41,0,0,0,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,86,105,115,117,97,108,105,122,101,114,115,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,0,0,76,10,0,0,7,0,0,0,78,10,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,78,111,109,105,110,97,108,32,100,97,109,112,101,114,50,46,115,95,114,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,50,46,115,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,120,33,0,0,173,17,0,0,7,0,0,0,174,17,0,0,56,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,50,46,115,95,114,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,50,46,115,95,114,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,88,147,0,0,173,17,0,0,7,0,0,0,174,17,0,0,56,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,69,108,101,109,101,110,116,97,114,121,95,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,52,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,52,44,48,93,32,61,32,122,101,114,111,115,40,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,52,93,32,61,32,122,101,114,111,115,40,48,44,52,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,114,101,118,111,108,117,116,101,50,80,119,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,114,101,118,111,108,117,116,101,50,80,112,104,105,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,114,101,118,111,108,117,116,101,49,80,119,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,114,101,118,111,108,117,116,101,49,80,112,104,105,32,61,32,120,91,52,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,69,108,101,109,101,110,116,97,114,121,95,76,105,110,101,70,111,114,99,101,87,105,116,104,84,119,111,77,97,115,115,101,115,59,10,0,0,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,153,0,0,0,154,0,0,16,154,0,0,40,154,0,0,72,154,0,0,88,154,0,0,112,154,0,0,128,154,0,0,152,154,0,0,184,154,0,0,224,154,0,0,248,154,0,0,24,155,0,0,48,155,0,0,88,155,0,0,120,155,0,0,168,155,0,0,216,155,0,0,240,155,0,0,40,156,0,0,64,156,0,0,112,156,0,0,144,156,0,0,200,156,0,0,240,156,0,0,40,157,0,0,88,157,0,0,104,157,0,0,136,157,0,0,176,157,0,0,208,157,0,0,248,157,0,0,32,158,0,0,56,158,0,0,80,158,0,0,96,158,0,0,120,158,0,0,168,158,0,0,248,158,0,0,56,159,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,104,173,0,0,248,171,0,0,128,170,0,0,8,169,0,0,8,169,0,0,144,167,0,0,128,170,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,48,184,0,0,184,180,0,0,72,179,0,0,216,177,0,0,216,177,0,0,104,176,0,0,72,179,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,120,182,0,0,136,182,0,0,152,182,0,0,104,167,0,0,160,182,0,0,176,182,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,16,186,0,0,24,186,0,0,32,186,0,0,40,186,0,0,160,185,0,0,48,186,0,0,64,186,0,0,72,186,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,184,187,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,24,188,0,0,40,188,0,0,48,188,0,0,56,188,0,0,72,188,0,0,88,188,0,0,96,188,0,0,112,188,0,0,128,188,0,0,144,188,0,0,160,188,0,0,176,188,0,0,192,188,0,0,208,188,0,0,224,188,0,0,232,188,0,0,240,188,0,0,0,189,0,0,8,189,0,0,24,189,0,0,40,189,0,0,56,189,0,0,72,189,0,0,88,189,0,0,104,189,0,0,120,189,0,0,136,189,0,0,152,189,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,32,190,0,0,40,190,0,0,40,190,0,0,72,190,0,0,120,190,0,0,152,190,0,0,208,190,0,0,0,191,0,0,48,191,0,0,80,191,0,0,128,191,0,0,152,191,0,0,184,191,0,0,224,191,0,0,0,192,0,0,48,192,0,0,80,192,0,0,120,192,0,0,152,192,0,0,192,192,0,0,240,192,0,0,40,193,0,0,80,193,0,0,128,193,0,0,176,193,0,0,216,193,0,0,8,194,0,0,16,194,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,32,190,0,0,16,197,0,0,24,197,0,0,32,197,0,0,48,188,0,0,40,197,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,128,198,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,152,198,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,176,198,0,0,184,198,0,0,192,198,0,0,208,198,0,0,224,198,0,0,232,198,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,216,210,0,0,0,0,0,0,80,210,0,0,0,0,0,0,200,209,0,0,0,0,0,0,64,209,0,0,0,0,0,0,56,208,0,0,0,0,0,0,48,207,0,0,0,0,0,0,40,206,0,0,0,0,0,0,32,205,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,192,212,0,0,208,212,0,0,216,212,0,0,224,212,0,0,240,212,0,0,248,212,0,0,0,213,0,0,8,213,0,0,16,213,0,0,24,213,0,0,32,213,0,0,48,213,0,0,56,213,0,0,72,213,0,0,88,213,0,0,104,213,0,0,112,213,0,0,128,213,0,0,136,213,0,0,152,213,0,0,160,213,0,0,184,213,0,0,192,213,0,0,200,213,0,0,216,213,0,0,224,213,0,0,240,213,0,0,0,214,0,0,8,214,0,0,16,214,0,0,24,214,0,0,32,214,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,176,214,0,0,184,214,0,0,0,215,0,0,48,215,0,0,96,215,0,0,168,215,0,0,232,215,0,0,48,216,0,0,96,216,0,0,168,216,0,0,192,216,0,0,224,216,0,0,24,217,0,0,64,217,0,0,104,217,0,0,160,217,0,0,240,217,0,0,80,218,0,0,128,218,0,0,184,218,0,0,232,218,0,0,48,219,0,0,88,219,0,0,136,219,0,0,184,219,0,0,16,220,0,0,88,220,0,0,200,220,0,0,248,220,0,0,64,221,0,0,96,221,0,0,32,214,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,176,214,0,0,32,222,0,0,200,222,0,0,48,215,0,0,96,215,0,0,48,223,0,0,232,215,0,0,48,216,0,0,184,223,0,0,248,223,0,0,192,216,0,0,224,216,0,0,152,224,0,0,216,224,0,0,24,225,0,0,160,217,0,0,240,217,0,0,88,225,0,0,144,225,0,0,24,226,0,0,64,226,0,0,48,219,0,0,88,219,0,0,136,219,0,0,168,226,0,0,48,227,0,0,48,228,0,0,200,220,0,0,248,220,0,0,64,221,0,0,96,221,0,0,32,214,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,233,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,234,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,234,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+54104);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,251,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+64448);
/* memory initializer */ allocate([72,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,5,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,41,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,41,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,160,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,248,42,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,43,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,43,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,43,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,43,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,208,55,1,0,240,56,1,0,248,56,1,0,8,57,1,0,24,57,1,0,40,57,1,0,64,57,1,0,88,57,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,208,55,1,0,216,55,1,0,32,56,1,0,72,56,1,0,104,56,1,0,136,56,1,0,176,56,1,0,216,56,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,64,65,1,0,80,65,1,0,88,65,1,0,96,65,1,0,104,65,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,136,65,1,0,144,65,1,0,160,65,1,0,176,65,1,0,104,65,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+75132);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,112,92,1,0,56,94,1,0,64,94,1,0,72,94,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,112,92,1,0,120,93,1,0,200,93,1,0,248,93,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,112,92,1,0,56,93,1,0,64,93,1,0,72,93,1,0,88,93,1,0,96,93,1,0,112,93,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,112,92,1,0,120,92,1,0,144,92,1,0,160,92,1,0,232,92,1,0,248,92,1,0,24,93,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,32,104,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,32,104,1,0,10,0,0,0,11,0,0,0,196,103,1,0,60,104,1,0,80,104,1,0,216,103,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,240,33,2,0,240,103,1,0,120,221,1,0,0,0,0,0,104,0,0,0,0,0,0,0,120,221,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,120,221,1,0,14,0,0,0,15,0,0,0,0,0,0,0,200,104,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,240,33,2,0,152,104,1,0,112,220,1,0,0,0,0,0,0,0,0,0,80,105,1,0,88,105,1,0,72,105,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,40,105,1,0,56,105,1,0,72,105,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+85372);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,168,121,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,168,121,1,0,20,0,0,0,21,0,0,0,76,121,1,0,196,121,1,0,216,121,1,0,96,121,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,240,33,2,0,120,121,1,0,232,220,1,0,0,0,0,0,108,0,0,0,0,0,0,0,232,220,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,232,220,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,160,131,1,0,136,133,1,0,144,133,1,0,216,135,1,0,240,133,1,0,0,134,1,0,224,135,1,0,232,135,1,0,240,135,1,0,248,135,1,0,8,136,1,0,24,136,1,0,40,136,1,0,56,136,1,0,72,136,1,0,88,136,1,0,104,136,1,0,128,136,1,0,184,135,1,0,208,135,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,160,131,1,0,136,133,1,0,144,133,1,0,160,133,1,0,240,133,1,0,0,134,1,0,16,134,1,0,48,134,1,0,80,134,1,0,112,134,1,0,152,134,1,0,192,134,1,0,232,134,1,0,16,135,1,0,40,135,1,0,72,135,1,0,104,135,1,0,144,135,1,0,184,135,1,0,208,135,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,160,131,1,0,104,133,1,0,112,133,1,0,120,133,1,0,160,131,1,0,168,132,1,0,248,132,1,0,40,133,1,0,160,131,1,0,104,132,1,0,112,132,1,0,120,132,1,0,136,132,1,0,144,132,1,0,160,132,1,0,0,0,0,0,160,131,1,0,168,131,1,0,192,131,1,0,208,131,1,0,24,132,1,0,40,132,1,0,72,132,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,192,138,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,192,138,1,0,28,0,0,0,29,0,0,0,76,138,1,0,220,138,1,0,240,138,1,0,96,138,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,240,33,2,0,120,138,1,0,120,221,1,0,0,0,0,0,56,0,0,0,0,0,0,0,120,221,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,120,221,1,0,14,0,0,0,15,0,0,0,0,0,0,0,128,139,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,240,33,2,0,56,139,1,0,112,220,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+95612);
/* memory initializer */ allocate([32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,16,160,1,0,16,160,1,0,16,160,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,184,162,1,0,200,162,1,0,224,162,1,0,0,163,1,0,32,163,1,0,56,163,1,0,88,163,1,0,112,163,1,0,128,163,1,0,144,163,1,0,168,163,1,0,192,163,1,0,224,163,1,0,0,164,1,0,144,163,1,0,24,164,1,0,56,164,1,0,80,164,1,0,104,164,1,0,128,164,1,0,160,164,1,0,176,164,1,0,208,164,1,0,240,164,1,0,8,165,1,0,32,165,1,0,56,165,1,0,72,165,1,0,96,165,1,0,120,165,1,0,144,165,1,0,176,165,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+105852);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112992);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,184,206,1,0,192,206,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,208,206,1,0,216,206,1,0,224,206,1,0,232,206,1,0,144,1,0,0,0,0,0,0,88,207,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+118216);
/* memory initializer */ allocate([48,214,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,240,33,2,0,16,214,1,0,176,220,1,0,0,0,0,0,0,0,0,0,152,214,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,240,33,2,0,128,214,1,0,176,220,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,48,215,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,240,33,2,0,16,215,1,0,112,220,1,0,0,0,0,0,0,0,0,0,152,215,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,240,33,2,0,128,215,1,0,112,220,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,200,33,2,0,168,215,1,0,0,0,0,0,16,216,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,184,216,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,240,33,2,0,0,216,1,0,0,0,0,0,0,0,0,0,0,0,0,0,80,216,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,240,33,2,0,56,216,1,0,16,216,1,0,0,0,0,0,0,0,0,0,144,216,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,240,33,2,0,120,216,1,0,16,216,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,240,33,2,0,160,216,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,0,217,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,240,33,2,0,232,216,1,0,184,216,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,200,33,2,0,16,217,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,240,33,2,0,56,217,1,0,48,217,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,232,219,1,0,48,0,0,0,49,0,0,0,0,0,0,0,112,220,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,176,220,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,232,220,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,232,220,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,48,221,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,48,221,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,120,221,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,120,221,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,192,221,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,192,221,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,219,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,176,219,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,240,33,2,0,104,219,1,0,0,217,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,200,33,2,0,152,219,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,240,33,2,0,184,219,1,0,176,219,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,240,33,2,0,248,219,1,0,176,219,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,200,33,2,0,56,220,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,200,33,2,0,120,220,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,80,34,2,0,184,220,1,0,0,0,0,0,1,0,0,0,232,219,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,80,34,2,0,0,221,1,0,0,0,0,0,1,0,0,0,40,220,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,80,34,2,0,72,221,1,0,0,0,0,0,1,0,0,0,232,219,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,80,34,2,0,144,221,1,0,0,0,0,0,1,0,0,0,40,220,1,0,3,244,255,255,0,0,0,0,32,222,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,240,33,2,0,0,222,1,0,80,217,1,0,0,0,0,0,0,0,0,0,72,236,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,236,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,241,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,184,241,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,242,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,243,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,56,238,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,56,238,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,216,238,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,216,238,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,104,239,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,239,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,236,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,237,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,237,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,237,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,243,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,48,244,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,192,244,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,80,245,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,240,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,240,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,32,236,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,232,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,233,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,235,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,248,235,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,48,232,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,240,33,2,0,24,232,1,0,200,215,1,0,0,0,0,0,0,0,0,0,192,232,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,200,33,2,0,160,232,1,0,80,34,2,0,136,232,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,232,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,80,34,2,0,224,232,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,232,1,0,2,0,0,0,0,0,0,0,144,233,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,200,33,2,0,112,233,1,0,80,34,2,0,72,233,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,136,233,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,80,34,2,0,176,233,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,136,233,1,0,2,0,0,0,0,0,0,0,80,234,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,80,34,2,0,40,234,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,136,233,1,0,2,0,0,0,0,0,0,0,200,234,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,80,34,2,0,160,234,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,136,233,1,0,2,0,0,0,0,0,0,0,64,235,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,240,33,2,0,24,235,1,0,200,234,1,0,0,0,0,0,0,0,0,0,168,235,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,240,33,2,0,128,235,1,0,200,234,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,240,33,2,0,184,235,1,0,48,232,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,240,33,2,0,224,235,1,0,48,232,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,240,33,2,0,8,236,1,0,48,232,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,240,33,2,0,48,236,1,0,48,232,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,240,33,2,0,88,236,1,0,48,232,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,200,33,2,0,160,236,1,0,80,34,2,0,128,236,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,236,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,80,34,2,0,224,236,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,236,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,80,34,2,0,32,237,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,236,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,80,34,2,0,96,237,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,236,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,200,33,2,0,232,237,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,200,33,2,0,8,238,1,0,80,34,2,0,160,237,1,0,0,0,0,0,3,0,0,0,48,232,1,0,2,0,0,0,0,238,1,0,2,0,0,0,48,238,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,200,33,2,0,168,238,1,0,80,34,2,0,96,238,1,0,0,0,0,0,3,0,0,0,48,232,1,0,2,0,0,0,0,238,1,0,2,0,0,0,208,238,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,200,33,2,0,72,239,1,0,80,34,2,0,0,239,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,96,239,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,80,34,2,0,136,239,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,96,239,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,200,33,2,0,8,240,1,0,80,34,2,0,240,239,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,32,240,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,80,34,2,0,72,240,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,32,240,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,200,33,2,0,224,240,1,0,80,34,2,0,200,240,1,0,0,0,0,0,1,0,0,0,0,241,1,0,0,0,0,0,80,34,2,0,128,240,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,8,241,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,80,34,2,0,136,241,1,0,0,0,0,0,1,0,0,0,0,241,1,0,0,0,0,0,80,34,2,0,64,241,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,160,241,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,200,33,2,0,56,242,1,0,80,34,2,0,32,242,1,0,0,0,0,0,1,0,0,0,88,242,1,0,0,0,0,0,80,34,2,0,216,241,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,96,242,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,80,34,2,0,224,242,1,0,0,0,0,0,1,0,0,0,88,242,1,0,0,0,0,0,80,34,2,0,152,242,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,248,242,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,200,33,2,0,120,243,1,0,80,34,2,0,48,243,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,152,243,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,200,33,2,0,8,244,1,0,80,34,2,0,192,243,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,40,244,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,200,33,2,0,152,244,1,0,80,34,2,0,80,244,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,184,244,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,200,33,2,0,40,245,1,0,80,34,2,0,224,244,1,0,0,0,0,0,2,0,0,0,48,232,1,0,2,0,0,0,72,245,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+120268);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,56,31,2,0,110,0,0,0,64,31,2,0,114,0,0,0,72,31,2,0,102,0,0,0,80,31,2,0,97,0,0,0,88,31,2,0,101,0,0,0,96,31,2,0,119,0,0,0,104,31,2,0,87,0,0,0,120,31,2,0,115,0,0,0,136,31,2,0,83,0,0,0,152,31,2,0,100,0,0,0,168,31,2,0,68,0,0,0,184,31,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,64,33,2,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,200,33,2,0,24,33,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,240,33,2,0,48,33,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,240,33,2,0,80,33,2,0,40,33,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,240,33,2,0,136,33,2,0,120,33,2,0,0,0,0,0,0,0,0,0,176,33,2,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,56,34,2,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,240,33,2,0,16,34,2,0,176,33,2,0,0,0,0,0,0,0,0,0,152,34,2,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,240,33,2,0,112,34,2,0,176,33,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,36,2,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,240,33,2,0,200,36,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+130608);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_get_values;var Kb=env._lis_vector_destroy;var Lb=env._lis_solver_set_option;var Mb=env._tmpfile;var Nb=env._send;var Ob=env._pow;var Pb=env._lis_matrix_set_size;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._qsort;var dc=env._putchar;var ec=env._floor;var fc=env._pthread_mutex_unlock;var gc=env._printf;var hc=env._sprintf;var ic=env._fopen;var jc=env._vasprintf;var kc=env._emscripten_get_now;var lc=env._stat;var mc=env._lis_solve;var nc=env._strtoull_l;var oc=env._mkport;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._lis_matrix_set_type;var Wc=env._fseek;var Xc=env._isxdigit;var Yc=env._fclose;var Zc=env._vsnprintf;var _c=env.__parseInt;var $c=env._log;var ad=env._pthread_cond_broadcast;var bd=env._popen;var cd=env._recv;var dd=env._fgetc;var ed=env._sysconf;var fd=env.__getFloat;var gd=env._lis_vector_set_value;var hd=env._abort;var id=env._ceil;var jd=env._isspace;var kd=env._localtime;var ld=env._lis_matrix_destroy;var md=env._pthread_getspecific;var nd=env._pthread_cond_wait;var od=env._llvm_lifetime_start;var pd=env.___cxa_is_number_type;var qd=env._ungetc;var rd=env._system;var sd=env._fmin;var td=env._fmax;var ud=env._fflush;var vd=env._strftime_l;var wd=env._fprintf;var xd=env._sscanf;var yd=env._catgets;var zd=env._lis_solver_destroy;var Ad=env._strdup;var Bd=env._asprintf;var Cd=env.__exit;var Dd=env.___ctype_toupper_loc;var Ed=env._bsearch;var Fd=env.__arraySum;var Gd=env.__formatString;var Hd=env._htonl;var Id=env.___ctype_tolower_loc;var Jd=env._unlink;var Kd=env._fputs;var Ld=env._GC_malloc_atomic;var Md=env._pread;var Nd=env._lis_vector_set_size;var Od=env._fscanf;var Pd=env.__scanString;var Qd=env._pthread_setspecific;var Rd=env._copysign;var Sd=env._fputc;var Td=env.___cxa_throw;var Ud=env._lis_matrix_create;var Vd=env._isdigit;var Wd=env._strerror;var Xd=env._emscripten_longjmp;var Yd=env._lis_vector_create;var Zd=env._atexit;var _d=env._sqrt;var $d=env._strerror_r;var ae=0.0;
// EMSCRIPTEN_START_FUNCS
function N7(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[41320+(((d[42600+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function O7(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function P7(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[41320+(((d[41064+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Q7(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[41320+(((d[41064+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function R7(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function S7(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function T7(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function U7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=W7(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function V7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 29:{l=25;break b;break};case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function W7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=X7(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function X7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Y7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=_7(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Z7(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=$7(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=a8(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=33;break b;break};case 11:{m=97;break b;break};case 10:case 9:case 21:{m=73;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}n=b;if((xe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=n+4|0;continue b;break};case 29:{m=55;break b;break};case 6:{if((e-b|0)<3){m=63;break b}o=b;if((xe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=o+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}p=b;if((xe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=p+2|0;continue b;break};default:{m=72;break b}}break};case 5:{if((e-b|0)<2){m=36;break b}q=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}r=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=r+3|0;continue b;break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}s=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=s+4|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 11:{m=97;break c;break};case 6:{m=83;break d;break};case 10:case 9:case 21:{break};case 29:{m=76;break d;break};case 24:case 22:{m=77;break d;break};case 7:{m=88;break d;break};case 17:{break c;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=b8(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Z7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}n=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function _7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[44016+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function $7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){o=27;break b}p=b;if((xe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((xe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((xe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};case 29:{o=24;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((c8(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=52;break c}s=b;if((xe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=s+3|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 5:{if((e-b|0)<2){o=47;break c}t=b;if((xe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=t+2|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 7:{if((e-b|0)<4){o=57;break c}u=b;if((xe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=u+4|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((c8(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function a8(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=27;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function b8(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(xe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=m+4;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(xe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=n+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(xe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=o+2;continue a;break};case 29:{l=4;break a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=p+2;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=q+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=r+4;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}s=b;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=48;break a}}break};case 14:{break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}s=t;if(!((s|0)==9|(s|0)==10|(s|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}s=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((s|0)==(t|0)){break}switch(s|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}s=(xe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(s){l=68;break a}c[j>>2]=u+3;continue c;break};case 3:{v=U7(k,(c[j>>2]|0)+1|0,e,j)|0;if((v|0)<=0){l=77;break a}else{continue c}break};case 2:{l=80;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}s=(xe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(s){l=73;break a}c[j>>2]=w+4;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}s=(xe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(s){l=63;break a}c[j>>2]=x+2;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{l=101;break d;break};case 11:{l=106;break a;break};case 5:{l=91;break d;break};case 10:case 9:case 21:{break};case 6:{l=96;break d;break};case 29:{l=89;break a;break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}s=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!s){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}s=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!s){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}s=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!s){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((v|0)==0){c[f>>2]=c[j>>2]}B=v;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function c8(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function d8(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((xe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((xe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((xe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function e8(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Z7(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function f8(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}m=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function g8(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function h8(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function i8(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function j8(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function k8(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((m8(l8(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((m8(l8(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=l8(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((m8(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=l8(k,a,b)|0;n=h;}while((m8(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=l8(k,a,b)|0;while(1){if((m8(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=l8(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=l8(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function l8(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function m8(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function n8(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function o8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 13:{c[h>>2]=14;j=56;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,47760)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 12:{c[h>>2]=14;j=1;break};case 29:{c[h>>2]=16;j=2;break};case 14:{j=0;break};case 15:{c[h>>2]=14;j=0;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=s8(h,a)|0}i=g;return j|0}function p8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 26:{j=9;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 15:{k=0;break};case 33:{c[h>>2]=17;k=0;break};default:{k=r8(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=s8(h,a)|0}i=g;return k|0}function q8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((He[c[e+28>>2]&63](e,b,d,47744)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47752)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function r8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 16:{if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,47520)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,47528)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,47536)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,47544)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};default:{}}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function s8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function t8(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function u8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else{g=s8(e,a)|0}i=f;return g|0}function v8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=s8(e,a)|0}i=f;return g|0}function w8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=s8(e,a)|0}i=f;return g|0}function x8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=s8(e,a)|0}i=f;return g|0}function y8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=s8(e,a)|0}i=f;return g|0}function z8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==13){g=56}else if((b|0)==11){g=55}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==15){g=0}else{g=s8(e,a)|0}i=f;return g|0}function A8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((He[c[e+28>>2]&63](e,b,d,47560)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47568)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function B8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=s8(e,a)|0}i=f;return g|0}function C8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=s8(e,a)|0}i=f;return g|0}function D8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=s8(e,a)|0}i=f;return g|0}function E8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=s8(e,a)|0;h=g;i=f;return h|0}return 0}function F8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,47576)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47584)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function G8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 41:case 18:{c[h>>2]=40;j=51;break};case 32:{c[h>>2]=40;j=54;break};case 31:{c[h>>2]=40;j=52;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 30:{c[h>>2]=40;j=53;break};case 15:{j=39;break};case 20:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,47592)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};default:{k=10}}}while(0);if((k|0)==10){j=s8(h,a)|0}i=g;return j|0}function H8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=s8(e,a)|0}i=f;return g|0}function I8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 32:{c[e>>2]=40;g=54;break};case 31:{c[e>>2]=40;g=52;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 15:{g=39;break};case 30:{c[e>>2]=40;g=53;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};default:{g=s8(e,a)|0}}i=f;return g|0}function J8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=s8(e,a)|0;h=g;i=f;return h|0}}return 0}function K8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=s8(e,a)|0}i=f;return g|0}function L8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=s8(e,a)|0}i=f;return g|0}function M8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else{g=s8(e,a)|0}i=f;return g|0}function N8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((He[m&63](n,o,p,c[47600+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((He[m&63](n,o,p,47544)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function O8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,47704)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,47712)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,47728)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function P8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=s8(e,a)|0}i=f;return g|0}function Q8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=s8(e,a)|0}i=f;return g|0}function R8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=s8(e,a)|0}i=f;return g|0}function S8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=s8(e,a)|0}i=f;return g|0}function T8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=s8(e,a)|0}i=f;return g|0}function U8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=s8(e,a)|0}i=f;return g|0}function V8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=51;g=10}else if((b|0)==15){g=11}else{g=s8(e,a)|0}i=f;return g|0}function W8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,47560)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47568)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function X8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=s8(e,a)|0}i=f;return g|0}function Y8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=s8(e,a)|0}i=f;return g|0}function Z8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,47736)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function _8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=s8(e,a)|0}i=f;return g|0}function $8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,47560)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47568)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function a9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=s8(e,a)|0}i=f;return g|0}function b9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=s8(e,a)|0}i=f;return g|0}function c9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=s8(e,a)|0;h=g;i=f;return h|0}return 0}function d9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=s8(e,a)|0;h=g;i=f;return h|0}return 0}function e9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=s8(e,a)|0}i=f;return g|0}function f9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 13:{j=56;break};case 29:{c[h>>2]=16;j=2;break};case 11:{j=55;break};case 14:{j=0;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,47760)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 15:{j=0;break};default:{k=9}}}while(0);if((k|0)==9){j=s8(h,a)|0}i=g;return j|0}function g9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=s8(e,a)|0}i=f;return g|0}function h9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,47560)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,47568)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}}while(0);j=s8(h,a)|0;k=j;i=g;return k|0}function i9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=s8(e,a)|0}i=f;return g|0}function j9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=s8(e,a)|0}i=f;return g|0}function k9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=s8(e,a)|0}i=f;return g|0}function l9(){i=i;return}function m9(){i=i;return}function n9(){var a=0;a=i;Wa(47768,0)|0;i=a;return}function o9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(47776,29,1,e|0)|0;ud(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(47808,54,1,g|0)|0;ud(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(47864,47,1,a|0)|0;ud(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;wd(k|0,47912,d|0)|0;ud(k|0)|0;f=0;i=b;return f|0}function p9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;wd(j|0,47976,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;wd(n|0,48008,e|0)|0;k=0;i=d;return k|0}function q9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function r9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Y9(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function s9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Y9(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function t9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[24790]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=48064;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&31](0,f,48088,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function u9(){var a=0,b=0,d=0;a=i;b=49856|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=49968|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=50080|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[49860>>2]=1;c[49864>>2]=1;i=a;return}function v9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?50216:50232;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;wd(a|0,50192,e|0)|0;i=d;return}function w9(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=50080+(d<<2)|0;o=49968+(d<<2)|0;p=50280+(b<<2)|0;q=48560+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=50264;gc(50248,l|0)|0;s=50264}else{if((c[12460]|0)==(d|0)){if((c[o>>2]|0)>0){t=50264}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;gc(50248,m|0)|0;do{if((c[12460]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=50264;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;gc(50272,k|0)|0;c[n>>2]=b;c[12460]=d;if((c[o>>2]|0)>0){g=0;while(1){gc(50304,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;ud(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function x9(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[50280+(a<<2)>>2]|0;c[j>>2]=c[48560+(b<<2)>>2];c[j+4>>2]=k;gc(50312,j|0)|0;y9(e);if((g|0)==0){Kd(((d|0)!=0?50352:50400)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}tb(50480)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];gc(50360,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}rc(50384,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}function y9(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){rc(50440,4,1,e|0)|0}else if(b<<24>>24==60){rc(50432,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==38){rc(50424,5,1,e|0)|0}else{Sd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function z9(a){a=a|0;var b=0;b=49968+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function A9(a){a=a|0;var b=0;b=(a|0)==0;c[12604]=b?1:19;c[12602]=b?7:269;i=i;return}function B9(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(50384,11,1,b|0)|0;ud(b|0)|0;i=a;return}function C9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[49856+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Zc(j|0,2048,e|0,h|0)|0;re[c[12604]&31](1,a,b,j,0,d);i=g;return}function D9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[49856+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[12604]&31](1,a,b,h,0,0);i=f;return}function E9(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[12462]|0)==0){if((c[49856+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Zc(k|0,2048,e|0,j|0)|0;re[c[12604]&31](2,a,b,k,0,d);i=g;return}function F9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[12462]|0)==0){if((c[49856+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Zc(j|0,2048,d|0,h|0)|0;re[c[12604]&31](2,a,b,j,0,0);i=f;return}function G9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Zc(b|0,2048,d|0,g|0)|0;re[c[12604]&31](4,2,0,b,0,0);if((a|0)==0){h=md(c[11942]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function H9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Zc(g|0,2048,b|0,f|0)|0;re[c[12604]&31](5,2,0,g,0,0);if((a|0)==0){h=md(c[11942]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function I9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[12604]&31](5,2,0,h,0,b);if((a|0)==0){j=md(c[11942]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function J9(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;I9(a,e,50552,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;E9(26,0,e,50488,m);i=j;return+b}return 0.0}function K9(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=$Da(16)|0;G9(0,(d|0)!=0|0,50600,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function L9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;aEa(c[f>>2]|0);aEa(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function M9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;G9(0,(a|0)!=0|0,50616,f);f=$Da(8)|0;g=f;G9(0,(f|0)!=0|0,50600,e);e=a+8|0;h=$Da(c[e>>2]|0)|0;c[f>>2]=h;G9(0,(h|0)!=0|0,50600,d);FEa(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function N9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;G9(0,(a|0)!=0|0,50616,f);f=$Da(8)|0;g=f;G9(0,(f|0)!=0|0,50600,e);e=a+8|0;h=$Da(c[e>>2]|0)|0;c[f>>2]=h;G9(0,(h|0)!=0|0,50600,d);FEa(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function O9(a){a=a|0;var b=0;b=i;i=i+8|0;G9(0,(a|0)!=0|0,50616,b);i=b;return c[a+12>>2]|0}function P9(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;G9(0,(a|0)!=0|0,50616,d);d=a;G9(0,(c[d>>2]|0)!=0|0,50640,b);i=b;return c[c[d>>2]>>2]|0}function Q9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;aEa(c[e>>2]|0);aEa(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function R9(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;G9(0,(a|0)!=0|0,50616,d);d=a;G9(0,(c[d>>2]|0)!=0|0,50656,b);i=b;return c[d>>2]|0}function S9(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;G9(0,d&1,50688,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function T9(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;G9(0,(a|0)!=0|0,50688,d);d=a;G9(0,(c[d>>2]|0)!=0|0,50712,b);i=b;return c[d>>2]|0}function U9(){var a=0,b=0,d=0;a=i;b=$Da(16)|0;c[12696]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=$Da(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function V9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Z9(a)|0;tc(50792)|0;_9(d);a=c[12696]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;fc(50792)|0;HEa(g|0,0,d|0)|0;i=b;return g|0}function W9(){var a=0,b=0,d=0,e=0;a=i;b=c[12696]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;aEa(c[b>>2]|0);aEa(b);if((d|0)==0){break}else{b=d}}e=c[12696]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function X9(a){a=a|0;var b=0,d=0;b=i;d=ie[c[50744>>2]&127](a<<3)|0;i=b;return d|0}function Y9(a){a=a|0;var b=0,d=0;b=i;d=ie[c[50744>>2]&127](a<<2)|0;i=b;return d|0}function Z9(a){a=a|0;i=i;return a+7&-8|0}function _9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[12696]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=$Da(16)|0;c[f+12>>2]=d;c[12696]=f;c[f+4>>2]=0;d=$9((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=$Da(d)|0;c[f>>2]=a;i=b;return}function $9(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function aaa(a){a=a|0;var b=0,c=0;b=i;c=DEa(a|0)|0;i=b;return c|0}function baa(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;JEa(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(m|0,l|0,f|0)|0;f=caa(m)|0;i=e;return f|0}function caa(a){a=a|0;var b=0,c=0,d=0;b=i;c=DEa(a|0)|0;d=eaa(c)|0;FEa(d|0,a|0,c|0)|0;i=b;return d|0}function daa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;JEa(g+1|0,d|0)|0;c[f>>2]=b;hc(k|0,j|0,f|0)|0;f=caa(k)|0;i=e;return f|0}function eaa(b){b=b|0;var d=0,e=0;d=i;e=ie[c[50748>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function faa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=aaa(a)|0;e=aaa(b)|0;f=eaa(e+d|0)|0;FEa(f|0,a|0,d|0)|0;FEa(f+d|0,b|0,e|0)|0;i=c;return f|0}function gaa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=zEa(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function haa(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 1:{f=4;break a;break};case 3:{f=2;break a;break};case 0:{f=8;break a;break};case 5:{f=1;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function iaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Yc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){aEa(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{aEa(c[(c[f>>2]|0)+(g<<4)>>2]|0);aEa(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;aEa(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){aEa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{aEa(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}aEa(d);c[g>>2]=0;i=b;return}function jaa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(DEa(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function kaa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ic(b|0,50976)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Wd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ad(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=50984;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[50952+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=51008;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=51032;E=131;break}G=haa(D)|0;if((G|0)==-1){n=51064;E=131;break}D=c[q>>2]|0;H=$Da(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=51112;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=51136;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((zEa(H,c[50928+(C<<2)>>2]|0)|0)!=0){n=51160;E=131;break}aEa(H);H=51736;b:do{switch(C|0){case 0:{if((D|0)!=4){n=51184;E=131;break a}if((I|0)!=11){n=51224;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=51264;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((AEa(t,c[12708]|0,8)|0)==0){L=1;E=130;break b}if((AEa(t,c[12714]|0,9)|0)==0){L=0;E=130}else{n=51296;E=131;break a}break};case 2:{if(d<<24>>24==1){if((I|0)==0){M=1;E=129;break b}F=D+1|0;G=0;while(1){N=$Da(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=N;if((sb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=51360;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;N=G+1|0;if(N>>>0<I>>>0){G=N}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){M=d;E=129;break b}G=fa(D,I)|0;O=$Da(G+1|0)|0;if((sb(O|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;N=0;do{P=$Da(G)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=P;if(!F){P=0;do{Q=a[O+((fa(D,P)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+P|0]=Q;P=P+1|0;}while(P>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+I|0]=0;N=N+1|0;}while(N>>>0<D>>>0)}aEa(O);L=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=51424;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=51480;E=131;break a}c[w>>2]=D;N=fa(I,D)|0;if((a[l]|0)==1){F=$Da(N<<3)|0;c[x>>2]=F;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=51520;E=131;break a}}else{F=$Da(N<<2)|0;c[x>>2]=$Da(fa(D<<3,I)|0)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=51520;E=131;break a}if((N|0)!=0){G=c[x>>2]|0;P=0;do{h[G+(P<<3)>>3]=+g[F+(P<<2)>>2];P=P+1|0;}while(P>>>0<N>>>0)}aEa(F)}N=c[w>>2]|0;if(!(N>>>0>1)){L=1;E=130;break b}P=(I|0)==2;G=1;while(1){if(P){Q=c[x>>2]|0;if(+h[Q+(G<<3)>>3]!=+h[Q+(N+G<<3)>>3]){n=51552;E=131;break a}}Q=G+1|0;if(Q>>>0<N>>>0){G=Q}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){M=d;E=129;break b}if((I|0)==0){n=51424;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=51632;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){N=$Da(G<<3)|0;c[x>>2]=$Da(fa(D<<3,I)|0)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=51520;E=131;break a}if((D|0)!=0){P=0;do{F=c[x>>2]|0;Q=0;do{h[F+((fa(I,P)|0)+Q<<3)>>3]=+h[N+((fa(D,Q)|0)+P<<3)>>3];Q=Q+1|0;}while(Q>>>0<I>>>0);P=P+1|0;}while(P>>>0<D>>>0)}aEa(N)}else{P=$Da(G<<2)|0;c[x>>2]=$Da(fa(D<<3,I)|0)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=51520;E=131;break a}if((D|0)!=0){Q=0;do{F=c[x>>2]|0;R=0;do{h[F+((fa(I,Q)|0)+R<<3)>>3]=+g[P+((fa(D,R)|0)+Q<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);Q=Q+1|0;}while(Q>>>0<D>>>0)}aEa(P)}Q=c[w>>2]|0;if(!(Q>>>0>1)){L=d;E=130;break b}G=(D|0)==2;N=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(N<<3)>>3]!=+h[R+(Q+N<<3)>>3]){n=51552;E=131;break a}}R=N+1|0;if(R>>>0<Q>>>0){N=R}else{L=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=51672;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=bEa(c[z>>2]<<1,4)|0;if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=51704;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=51672;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=bEa(c[z>>2]<<1,4)|0;N=fa(I,D)|0;if((a[l]|0)==1){Q=$Da(N<<3)|0;if((sb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=51704;E=131;break a}if((I|0)!=0){G=D<<3;P=(D|0)==0;R=D<<3;F=0;do{S=$Da(G)|0;c[(c[B>>2]|0)+(F<<2)>>2]=S;if(!P){S=Q+(fa(R,F)|0)|0;FEa(c[(c[B>>2]|0)+(F<<2)>>2]|0,S|0,R|0)|0}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;R=F<<1;if(F>>>0<R>>>0){P=D<<3;G=(D|0)==0;S=F;do{T=$Da(P)|0;c[(c[B>>2]|0)+(S<<2)>>2]=T;if(!G){T=c[B>>2]|0;U=c[T+(S-F<<2)>>2]|0;V=c[T+(S<<2)>>2]|0;T=0;do{h[V+(T<<3)>>3]=-+h[U+(T<<3)>>3];T=T+1|0;}while(T>>>0<D>>>0)}S=S+1|0;}while(S>>>0<R>>>0)}aEa(Q)}else{R=$Da(N<<2)|0;if((sb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=51704;E=131;break a}if((I|0)!=0){S=D<<3;F=(D|0)==0;G=0;do{P=$Da(S)|0;c[(c[B>>2]|0)+(G<<2)>>2]=P;if(!F){P=c[(c[B>>2]|0)+(G<<2)>>2]|0;T=0;do{h[P+(T<<3)>>3]=+g[R+((fa(D,G)|0)+T<<2)>>2];T=T+1|0;}while(T>>>0<D>>>0)}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;F=G<<1;if(G>>>0<F>>>0){S=D<<3;N=(D|0)==0;Q=G;do{T=$Da(S)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=T;if(!N){T=c[B>>2]|0;P=c[T+(Q-G<<2)>>2]|0;U=c[T+(Q<<2)>>2]|0;T=0;do{h[U+(T<<3)>>3]=-+h[P+(T<<3)>>3];T=T+1|0;}while(T>>>0<D>>>0)}Q=Q+1|0;}while(Q>>>0<F>>>0)}aEa(R)}if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=51704;E=131;break a}else{L=d;E=130}break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;Q=$Da((F?D:I)<<4)|0;c[v>>2]=Q;c:do{if(d<<24>>24==1){if((I|0)==0){W=0;break}G=D+1|0;N=Q;S=0;while(1){c[N+(S<<4)>>2]=$Da(G)|0;if((sb(c[(c[v>>2]|0)+(S<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=51360;E=131;break a}a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+D|0]=0;T=c[v>>2]|0;c[T+(S<<4)+8>>2]=-1;c[T+(S<<4)+12>>2]=-1;jaa(c[T+(S<<4)>>2]|0);T=S+1|0;if(!(T>>>0<I>>>0)){W=I;break c}N=c[v>>2]|0;S=T}}else{W=I}}while(0);if(!F){L=d;E=130;break b}Q=fa(D,W)|0;X=$Da(Q+1|0)|0;if((sb(X|0,Q|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){Q=W+1|0;R=(W|0)==0;S=0;do{N=$Da(Q)|0;c[(c[v>>2]|0)+(S<<4)>>2]=N;if(!R){N=0;do{G=a[X+((fa(D,N)|0)+S)|0]|0;a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+N|0]=G;N=N+1|0;}while(N>>>0<W>>>0)}a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+W|0]=0;N=c[v>>2]|0;c[N+(S<<4)+8>>2]=-1;c[N+(S<<4)+12>>2]=-1;jaa(c[N+(S<<4)>>2]|0);S=S+1|0;}while(S>>>0<D>>>0)}aEa(X);L=0;E=130;break};case 3:{S=fa(I<<2,D)|0;Y=$Da(S)|0;if((sb(Y|0,S|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}S=c[v>>2]|0;R=0;do{Q=fa(D,R)|0;c[S+(R<<4)+8>>2]=(c[Y+(Q<<2)>>2]|0)==1;c[S+(R<<4)+12>>2]=c[Y+(Q+1<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}R=c[v>>2]|0;S=0;do{c[R+(S<<4)+8>>2]=(c[Y+(S<<2)>>2]|0)==1;c[R+(S<<4)+12>>2]=c[Y+(D+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}}while(0);aEa(Y);cc(c[v>>2]|0,c[u>>2]|0,16,54);L=d;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=M;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){aEa(X);n=51360;i=e;return n|0}else if((E|0)==46){aEa(O);n=51360;i=e;return n|0}else if((E|0)==52){aEa(Y);n=51392;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function laa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ed(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function maa(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=51776;o=n;p=51824;q=p;r=51848;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=51776;o=n;p=51824;q=p;r=51848;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=$Da(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}aEa(r);t=0;i=e;return t|0}else{k=$Da(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}aEa(k);aEa(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);aEa(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function naa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=51776;r=q;s=51824;t=s;u=51872;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=51776;r=q;s=51824;t=s;u=51872;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Wc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Wc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function oaa(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function paa(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function qaa(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function raa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+qaa(b)<e){q=1;i=f;return q|0}if(+paa(b)>e){q=1;i=f;return q|0}if((maa(b,1)|0)==0){q=1;i=f;return q|0}oaa(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+naa(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+naa(a,b,d,o);i=f;return q|0}if(+naa(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+naa(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function saa(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function taa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0;e=i;f=+saa(a,(fa(c[(c[a+4>>2]|0)+4>>2]|0,b)|0)+d|0);i=e;return+f}function uaa(a,b){a=a|0;b=b|0;var c=0;c=i;r9(a,b,X9(b)|0);i=c;return}function vaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=X9(s9(a,b,f)|0)|0;i=e;return}function waa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((o9(a)|0)==0){cb(51904,51928,127,51952)}if((o9(b)|0)==0){cb(51976,51928,128,51952)}if((p9(a,b)|0)==0){cb(52e3,51928,129,51952)}e=q9(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+saa(a,b);xaa(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function xaa(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function yaa(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function zaa(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;xaa(c[d+8>>2]|0,b,a);i=e;return}function Aaa(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;uaa(a,b);j=g;c[g>>2]=e;zaa(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;zaa(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function Baa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=t9(a,b,f)|0;f=yaa(c[a+8>>2]|0,d)|0;i=e;return f|0}function Caa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=$Da(d<<2)|0;if((j|0)==0){cb(52040,51928,784,52072)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(52048,51928,795,52072)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(52096,51928,798,52072)}else if((s|0)==17){cb(52136,51928,800,52072)}else if((s|0)==22){cb(52136,51928,804,52072)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=X9(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=Y9(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){aEa(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+saa(a,k+s|0);xaa(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}aEa(j);i=g;return}function Daa(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=d+4|0;c[f>>2]=Y9(b)|0;g=X9(1)|0;c[d+8>>2]=g;c[d>>2]=b;xaa(g,0,a);if((b|0)<=0){i=e;return}g=c[f>>2]|0;f=0;do{c[g+(f<<2)>>2]=1;f=f+1|0;}while((f|0)<(b|0));i=e;return}function Eaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=$Da(20)|0;G9(0,(f|0)!=0|0,52184,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=bEa(e,b)|0;c[f>>2]=a;G9(0,(a|0)!=0|0,52184,d);i=d;return f|0}function Faa(a){a=a|0;var b=0;b=i;aEa(c[a>>2]|0);aEa(a);i=b;return}function Gaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;G9(0,(c[h>>2]|0)>0|0,52200,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;G9(0,(g|0)>(b|0)|0,52224,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;G9(0,(0-f|0)<(b|0)|0,52224,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Haa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=bEa(c[d>>2]<<1,c[e>>2]|0)|0;G9(0,(f|0)!=0|0,52184,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Gaa(a,j)|0;h=c[e>>2]|0;FEa(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;aEa(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Iaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Haa(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;FEa((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Jaa(a){a=a|0;i=i;return c[a+12>>2]|0}function Kaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;G9(0,(c[j>>2]|0)>0|0,52200,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;G9(0,(h|0)>(b|0)|0,52224,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;G9(0,b>>>31^1,52224,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Gaa(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Laa(a){a=a|0;i=i;return c[(c[13064]|0)+(a<<2)>>2]|0}function Maa(a){a=a|0;i=i;return c[(c[13066]|0)+(a<<2)>>2]|0}function Naa(a){a=a|0;i=i;return c[(c[13068]|0)+(a<<2)>>2]|0}function Oaa(a){a=a|0;i=i;return c[(c[13070]|0)+(a<<2)>>2]|0}function Paa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[13066]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[13068]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[13064]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Qaa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[13072]|0;e=+Raa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Raa(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Saa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[13074]|0;e=+Raa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Taa(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[13076]|0;e=+Raa(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Uaa(a){a=a|0;i=i;return 0}function Vaa(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[13078]|0)+(a<<3)|0)|0;d=(c[13064]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Waa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[13072]|0;f=e+(a<<3)|0;g=c[13076]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[13070]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[13064]|0)+(a<<2)>>2]|0);e=c[13074]|0;g=e+(a<<3)|0;Xaa(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Paa(a);d=c[13072]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[13064]|0)+(a<<2)>>2]=0;i=b;return}function Xaa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(_aa(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function Yaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[13078]|0;f=c[13072]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function Zaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=bEa(a,8)|0;c[13072]=d;e=bEa(a,8)|0;c[13074]=e;f=bEa(a,8)|0;c[13076]=f;g=bEa(a,8)|0;c[13078]=g;h=bEa(a,4)|0;c[13064]=h;j=bEa(a,4)|0;c[13070]=j;k=a<<2;l=$Da(k)|0;c[13066]=l;m=bEa(a,4)|0;c[13068]=m;HEa(l|0,-1,k|0)|0;if((d|0)==0){cb(52320,52336,393,52352)}if((e|0)==0){cb(52360,52336,394,52352)}if((f|0)==0){cb(52376,52336,395,52352)}if((g|0)==0){cb(52392,52336,396,52352)}if((h|0)==0){cb(52408,52336,397,52352)}if((l|0)==0){cb(52432,52336,398,52352)}if((m|0)==0){cb(52456,52336,399,52352)}if((j|0)==0){cb(52480,52336,400,52352)}else{i=b;return}}function _aa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function $aa(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==1){c[l>>2]=c[b+8>>2];n=l+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];E9(17,0,o,54160,l);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];l=j+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];E9(17,0,o,54264,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];E9(17,0,o,54360,g);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];g=m+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];E9(17,0,o,54112,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];E9(17,0,o,54424,f);i=e;return}}function aba(a){a=a|0;var b=0;b=i;aEa(c[a+12>>2]|0);aEa(c[a+4>>2]|0);aEa(c[a+8>>2]|0);i=b;return}function bba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[7406]=.5;h[7392]=1.0;h[7429]=.25;h[7404]=2.0;h[7431]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[14820]=A;B=c[d>>2]|0;c[14750]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[14750]=D;if((C|0)<(B|0)){C=D}else{break}}}c[14748]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[7407]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[7407]=F;G=F}else{G=E}D=c[d>>2]|0;c[14750]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[14750]=I;if((H|0)>=(D|0)){break a}E=+h[7407];H=I}}}while(0);D=C+1|0;c[14748]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[7411]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[7376]=0.0;h[7378]=0.0;h[7382]=0.0;h[7439]=0.0;c[14746]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[7376]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[7378]+ +h[B>>3]*F;h[7378]=E;F=+h[I>>3];M=+h[7382]+F*F;h[7382]=M;F=+h[H>>3];h[7439]=+h[7439]+F*F;H=A+1|0;c[14746]=H;F=+h[7376];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[14816]=A;E=G/J;h[7428]=E;C=c[d>>2]|0;c[14750]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[7436]=0.0;h[7438]=0.0;I=c[b>>2]|0;c[14746]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[7405]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[7436]=ba;ca=E+aa*aa;h[7438]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[14746]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[14816]=A;h[7428]=E;h[7378]=Z;h[7382]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[14750]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[14746]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[14746]=A+1;da=+h[7378];ea=+h[7382];ga=+h[7376]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[7427]=K;c[14844]=0;h[7435]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[14844]=C;K=+h[7392]/+V(+ga);h[7407]=K;h[7430]=0.0;h[7432]=0.0;B=c[b>>2]|0;c[14746]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[7430]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[7430]=oa;pa=+h[7432]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[7432]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[7378];L=+h[7376];N=+h[7407];D=D+1|0;la=ma}c[14746]=B+1;ia=+h[7376];ja=pa;ka=oa}N=+h[7406];L=ka*N*ka;h[7423]=L;J=ja*N*ja;h[7424]=J;h[7383]=J+(L+ia*(+h[7439]+ia*N));N=+h[7404];h[59072>>3]=N*ka*ia;h[59080>>3]=N*ja*ia;h[59088>>3]=L-J;h[59096>>3]=ka*ja;la=59104|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[14746]=10;la=c[d>>2]|0;c[14750]=1;if((la|0)>=1){D=1;while(1){h[7423]=0.0;h[7424]=0.0;h[7425]=0.0;A=c[b>>2]|0;c[14746]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[7423]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[7424]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[7425]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[14746]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[7429]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[7423]*+h[7425];h[t+(U+D<<3)>>3]=+h[7424]*+h[7425];J=+h[7423];L=+h[7424];h[t+(P+D<<3)>>3]=+h[7429]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[7406]*+h[7423]*+h[7424];na=D+1|0;c[14750]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[14746]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[14758]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[14746]=B;if((la|0)<(D|0)){la=B}else{break}}}c[14754]=1;la=1;do{D=c[d>>2]|0;c[14762]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[14762]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[14750]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[14750]=D+1}na=c[14820]|0;c[14748]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[7403]=0.0;ma=c[d>>2]|0;c[14750]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[7403]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[14750]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[7403]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[14750]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[7403];Ca=Ca+1|0}c[14750]=ta+1}Ca=B+1|0;c[14748]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[14750]=1;if((A|0)<1){break}else{Ea=1}while(1){h[7403]=0.0;B=c[b>>2]|0;c[14748]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[7403]=N;Ca=na+1|0;c[14748]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[14750]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[14748]=1;if((A|0)>=1){ta=1;while(1){h[7403]=0.0;c[14746]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[7403]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[14746]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[14748]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[14754]=la;}while((la|0)<6);la=c[l>>2]|0;c[14750]=1;h[7403]=0.0;c[14746]=1;L=+h[7406];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[59144+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[59144+(A+ -1<<3)>>3]+L;h[7403]=L;A=A+1|0;}while((A|0)<6);h[7383]=+h[7383]- +h[7393]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[7423]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[7424]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[7425]=O;h[59072>>3]=+h[59072>>3]-J-N*(O+K);h[59104>>3]=+h[59104>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[7423]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[7424]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[7425]=J;h[59080>>3]=+h[59080>>3]-O-N*(K-J);h[59112>>3]=+h[59112>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[7423]=J;h[59088>>3]=+h[59160>>3]+(+h[59088>>3]-J- +h[59152>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[7423]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[7424]=K;Oa=+h[7406];h[59096>>3]=+h[59096>>3]-J-K*Oa;h[59120>>3]=+h[59120>>3]- +h[59168>>3]+ +h[59176>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[7423]=K;h[59128>>3]=+h[59128>>3]-Oa*K;h[7403]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[14750]=la+1;c[14746]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[59144+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[59144+(ta+ -1<<3)>>3]+N;h[7403]=N;ta=ta+1|0;c[14746]=ta;}while((ta|0)<6);K=+h[7411];h[7413]=K*+h[7383]+ +h[7393]+N;J=+h[7404];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[7423]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[7424]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[7425]=R;T=R+(K*+h[59072>>3]+O+S);h[59312>>3]=T;O=K*+h[59104>>3]+S-R;h[59344>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[7423]=R;S=+h[I>>3]*+h[ma>>3];h[7424]=S;Z=+h[Ma>>3]*+h[Na>>3];h[7425]=Z;h[59320>>3]=K*+h[59080>>3]+R+S-Z;h[59352>>3]=K*+h[59112>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[7423]=Z;R=+h[59152>>3]+(Z+K*+h[59088>>3])- +h[59160>>3];h[59328>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[7423]=Z;h[59336>>3]=Z+K*+h[59096>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[59120>>3]+ +h[59168>>3]- +h[59176>>3];h[59360>>3]=J;h[59368>>3]=+h[7411]*+h[59128>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[7413]+T+R+O+J;h[7403]=K;h[7433]=K;h[7434]=K;c[14852]=0;J=+h[7431]/50.0;h[7407]=J;h[7393]=+h[7392];c[14746]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[59152>>3]=Z;W=+Y(+Pa);h[59160>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[59144+(Ma+ -1<<3)>>3]=Z;Q=+h[59152>>3]*G+ +h[59160>>3]*W;h[59144+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[59160>>3];ca=+h[59152>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[59304+(Ma<<3)>>3]*+h[59144+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[7434]=Ra;c[14852]=Na;h[7423]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[7424]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[14748]=10;h[7403]=Ra;h[7412]=Pa;h[7437]=O;c[14746]=50;if((Xa|0)==49){h[7424]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[7423]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[7409]=0.0;if(Ya!=Za){S=Ya-Ua;h[7423]=S;T=Za-Ua;h[7424]=T;R=+h[7406]*(S-T)/(S+T);h[7409]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[7412]=R;T=+X(+R);h[59152>>3]=T;S=+Y(+R);h[59160>>3]=S;c[14748]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[59144+(Na+ -1<<3)>>3]=T;W=+h[59152>>3]*G+ +h[59160>>3]*S;h[59144+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[59160>>3];N=+h[59152>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[7434]=0.0;c[14748]=1;Na=1;do{ma=Na+ -1|0;Ma=59144+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[59064+(ma<<3)>>3]*+h[Ma>>3];h[7434]=+h[7434]+ +h[59304+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[14748]=10;Na=c[l>>2]|0;c[14750]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[59144+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[14748]=6;c[14750]=Na+1}h[7402]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[7376]=0.0;h[7423]=0.0;h[7424]=0.0;Ma=c[b>>2]|0;c[14746]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[59152>>3]*+h[la>>3]+ +h[59160>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[7376]=+h[7376]+G*G;bb=+h[7423]+ +h[la>>3]*+h[ta>>3];h[7423]=bb;G=+h[ta>>3];cb=+h[7424]+G*G;h[7424]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[14746]=Ma+1;$a=cb;ab=bb}ma=c[14844]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[7435];S=+h[7433];h[7435]=G>=S?G:S}S=+h[7434];if(!(S>=0.0)){db=-S}else{db=S}G=+h[7435];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[7435]=S;c[14746]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[7407]=N;R=+h[7402]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[7411];la=ta+1|0;c[14746]=la;if((ta|0)>=(Na|0)){break b}S=+h[7424];G=+h[7423];ta=la}}}while(0);Na=c[d>>2]|0;c[14750]=1;if((Na|0)>=1){Ma=1;while(1){h[7403]=0.0;ta=c[b>>2]|0;c[14748]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[7403]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[14748]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[7402]*+h[p+(la+ -1+Ma<<3)>>3]- +h[7411]*+h[q+(Ma+ -1<<3)>>3]);h[7407]=G;c[14746]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[7407];I=I+1|0}c[14746]=la+1}I=Ma+1|0;c[14750]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[7382]=0.0;h[7378]=0.0;Ma=c[b>>2]|0;c[14746]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[7382]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[7378]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[14746]=Ma+1;hb=kb;ib=jb}S=+h[7376];G=S*ib-hb*hb;h[7427]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[59040]=1;C=c[l>>2]|0;c[14750]=1;if((C|0)<1){lb=59136;mb=+h[7392];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[59144+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[14748]=6;c[14750]=C+1;lb=59136;mb=+h[7392];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}



function qxa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;Ixa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ie[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}dua(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}dua(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((Exa(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=zCa(J,c[p>>2]|0,j,u)|0;Sza(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ie[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Wta(o);Wta(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Wta(o);Wta(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Wta(o);Wta(n);i=e;return}function rxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];sxa(a,0,k,j,f,g,h);i=b;return}function sxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;Ixa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}dua(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}dua(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((Exa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=yCa(I,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}function txa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uxa(a,0,k,j,f,g,h);i=b;return}function uxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Ixa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}dua(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}dua(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((Exa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=xCa(I,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}function vxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wxa(a,0,k,j,f,g,h);i=b;return}function wxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Ixa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}dua(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}dua(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((Exa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=wCa(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}function xxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];yxa(a,0,k,j,f,g,h);i=b;return}function yxa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Jxa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}dua(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}dua(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Kxa(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+vCa(L,c[p>>2]|0,j);Sza(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}function zxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Axa(a,0,k,j,f,g,h);i=b;return}function Axa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Jxa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}dua(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}dua(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Kxa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+uCa(L,c[p>>2]|0,j);Sza(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}function Bxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Cxa(a,0,k,j,f,g,h);i=b;return}function Cxa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Jxa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}dua(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}dua(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Kxa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+tCa(L,c[p>>2]|0,j);Sza(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Wta(o);Wta(n);i=d;return}function Dxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Sua(o,g);g=o;o=c[g>>2]|0;if(!((c[31004]|0)==-1)){c[l>>2]=124016;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124016,l,292)}l=(c[124020>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+48>>2]&63](o,122568,122594|0,y)|0;mta(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}dua(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}dua(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((Exa(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);N=c[30978]|0;c[k>>2]=j;if((gxa(H,N,122608,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ie[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Wta(p);Wta(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Wta(p);Wta(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Wta(p);Wta(n);i=d;return}function Exa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[122568+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[122568+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Fxa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Sua(k,d);d=k;k=c[d>>2]|0;if(!((c[31006]|0)==-1)){c[j>>2]=124024;c[j+4>>2]=291;c[j+8>>2]=0;Hta(124024,j,292)}j=(c[124028>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;GDa(n);o=139584;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;GDa(n);o=139584;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+32>>2]&63](k,122568,122594|0,e)|0;e=c[d>>2]|0;if(!((c[31042]|0)==-1)){c[h>>2]=124168;c[h+4>>2]=291;c[h+8>>2]=0;Hta(124168,h,292)}h=(c[124172>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}else{t=e;a[f]=ie[c[(c[e>>2]|0)+16>>2]&127](t)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,t);mta(c[d>>2]|0)|0;i=g;return}}function Gxa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;Sua(l,d);d=l;l=c[d>>2]|0;if(!((c[31006]|0)==-1)){c[k>>2]=124024;c[k+4>>2]=291;c[k+8>>2]=0;Hta(124024,k,292)}k=(c[124028>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;GDa(o);p=139584;q=127;Td(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;GDa(o);p=139584;q=127;Td(n|0,p|0,q|0)}He[c[(c[l>>2]|0)+32>>2]&63](l,122568,122600|0,e)|0;e=c[d>>2]|0;if(!((c[31042]|0)==-1)){c[j>>2]=124168;c[j+4>>2]=291;c[j+8>>2]=0;Hta(124168,j,292)}j=(c[124172>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;GDa(s);t=139584;u=127;Td(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;GDa(s);t=139584;u=127;Td(r|0,t|0,u|0)}else{u=e;a[f]=ie[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ie[c[(c[e>>2]|0)+16>>2]&127](u)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,u);mta(c[d>>2]|0)|0;i=h;return}}function Hxa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[122568+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function Ixa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;Sua(j,b);b=j;j=c[b>>2]|0;if(!((c[31004]|0)==-1)){c[h>>2]=124016;c[h+4>>2]=291;c[h+8>>2]=0;Hta(124016,h,292)}h=(c[124020>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;GDa(m);n=139584;o=127;Td(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;GDa(m);n=139584;o=127;Td(l|0,n|0,o|0)}He[c[(c[j>>2]|0)+48>>2]&63](j,122568,122594|0,d)|0;d=c[b>>2]|0;if(!((c[31044]|0)==-1)){c[g>>2]=124176;c[g+4>>2]=291;c[g+8>>2]=0;Hta(124176,g,292)}g=(c[124180>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}else{s=d;c[e>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](s)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,s);mta(c[b>>2]|0)|0;i=f;return}}function Jxa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Sua(k,b);b=k;k=c[b>>2]|0;if(!((c[31004]|0)==-1)){c[j>>2]=124016;c[j+4>>2]=291;c[j+8>>2]=0;Hta(124016,j,292)}j=(c[124020>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;GDa(n);o=139584;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;GDa(n);o=139584;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+48>>2]&63](k,122568,122600|0,d)|0;d=c[b>>2]|0;if(!((c[31044]|0)==-1)){c[h>>2]=124176;c[h+4>>2]=291;c[h+8>>2]=0;Hta(124176,h,292)}h=(c[124180>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}else{t=d;c[e>>2]=ie[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](t)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,t);mta(c[b>>2]|0)|0;i=g;return}}function Kxa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[122568+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function Lxa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Mxa(a){a=a|0;i=i;return}function Nxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31042]|0)==-1)){c[l>>2]=124168;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124168,l,292)}l=(c[124172>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}w=n;mta(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((xe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Wta(o);i=j;return}function Oxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=122816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);v=c[30978]|0;c[k>>2]=h;h=Pxa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Sua(q,f);Qxa(w,y,k,z,o,p,q);mta(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];tqa(b,j,z,e,o,f,g);i=d;return}function Pxa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=Zc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function Qxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[31006]|0)==-1)){c[m>>2]=124024;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124024,m,292)}m=(c[124028>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[31042]|0)==-1)){c[l>>2]=124168;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124168,l,292)}l=(c[124172>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Wta(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Wta(n);i=k;return}}function Rxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);y=c[30978]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Pxa(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Sua(r,f);Qxa(x,z,l,A,p,q,r);mta(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];tqa(b,k,A,e,p,f,g);i=d;return}function Sxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=122816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);v=c[30978]|0;c[k>>2]=h;h=Pxa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Sua(q,f);Qxa(w,y,k,z,o,p,q);mta(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];tqa(b,j,z,e,o,f,g);i=d;return}function Txa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);y=c[30978]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Pxa(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Sua(r,f);Qxa(x,z,l,A,p,q,r);mta(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];tqa(b,k,A,e,p,f,g);i=d;return}function Uxa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[123920]|0)==0;if(F){do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Vxa(s,r,z,n)|0}else{do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Vxa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}mEa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=$Da(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}mEa()}}while(0);Sua(w,f);Wxa(N,L,G,P,u,v,w);mta(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];tqa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){aEa(O)}if((J|0)==0){i=d;return}aEa(J);i=d;return}function Vxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=jc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function Wxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[31006]|0)==-1)){c[m>>2]=124024;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124024,m,292)}m=(c[124028>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[31042]|0)==-1)){c[l>>2]=124168;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124168,l,292)}l=(c[124172>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[30978]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[30978]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=xe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);He[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Wta(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Wta(n);i=k;return}function Xxa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[123920]|0)==0;if(F){do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Vxa(s,r,z,n)|0}else{do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Vxa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}mEa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=$Da(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}mEa()}}while(0);Sua(w,f);Wxa(N,L,G,P,u,v,w);mta(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];tqa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){aEa(O)}if((J|0)==0){i=d;return}aEa(J);i=d;return}function Yxa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=122824;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);s=c[30978]|0;c[k>>2]=h;h=Pxa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;Sua(p,f);r=p;p=c[r>>2]|0;if(!((c[31006]|0)==-1)){c[l>>2]=124024;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124024,l,292)}l=(c[124028>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}mta(c[r>>2]|0)|0;He[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];tqa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];tqa(b,j,u,z,m,f,g);I=j;i=d;return}function Zxa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function _xa(a){a=a|0;i=i;return}function $xa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31044]|0)==-1)){c[l>>2]=124176;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124176,l,292)}l=(c[124180>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}w=n;mta(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=xe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];yua(o);i=j;return}function aya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=122816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);v=c[30978]|0;c[k>>2]=h;h=Pxa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Sua(q,f);bya(w,y,k,z,o,p,q);mta(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];cya(b,j,z,e,o,f,g);i=d;return}function bya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[31004]|0)==-1)){c[m>>2]=124016;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124016,m,292)}m=(c[124020>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[31044]|0)==-1)){c[l>>2]=124176;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124176,l,292)}l=(c[124180>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Wta(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Wta(n);i=k;return}function cya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){xua(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((le[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){yua(l);break}c[m>>2]=0;c[b>>2]=0;yua(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function dya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);y=c[30978]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Pxa(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Sua(r,f);bya(x,z,l,A,p,q,r);mta(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];cya(b,k,A,e,p,f,g);i=d;return}function eya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=122816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);v=c[30978]|0;c[k>>2]=h;h=Pxa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Sua(q,f);bya(w,y,k,z,o,p,q);mta(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];cya(b,j,z,e,o,f,g);i=d;return}function fya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);y=c[30978]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Pxa(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Sua(r,f);bya(x,z,l,A,p,q,r);mta(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];cya(b,k,A,e,p,f,g);i=d;return}function gya(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[123920]|0)==0;if(F){do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Vxa(s,r,z,n)|0}else{do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Vxa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}mEa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=$Da(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}mEa()}}while(0);Sua(w,f);hya(N,L,G,P,u,v,w);mta(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];cya(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){aEa(O)}if((J|0)==0){i=d;return}aEa(J);i=d;return}function hya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[31004]|0)==-1)){c[m>>2]=124016;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124016,m,292)}m=(c[124020>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;GDa(r);s=139584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[31044]|0)==-1)){c[l>>2]=124176;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124176,l,292)}l=(c[124180>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;GDa(v);w=139584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[30978]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[30978]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=xe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);He[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Wta(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Wta(n);i=k;return}function iya(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Pxa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[123920]|0)==0;if(F){do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);r=c[30978]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Vxa(s,r,z,n)|0}else{do{if(o){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Vxa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}mEa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=$Da(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}mEa()}}while(0);Sua(w,f);hya(N,L,G,P,u,v,w);mta(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];cya(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){aEa(O)}if((J|0)==0){i=d;return}aEa(J);i=d;return}function jya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=122824;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);s=c[30978]|0;c[k>>2]=h;h=Pxa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}Sua(p,f);u=p;p=c[u>>2]|0;if(!((c[31004]|0)==-1)){c[l>>2]=124016;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124016,l,292)}l=(c[124020>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}mta(c[u>>2]|0)|0;u=o;He[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];cya(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];cya(b,j,u,z,m,f,g);I=j;i=d;return}function kya(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;Sua(r,h);v=r;r=c[v>>2]|0;if(!((c[31006]|0)==-1)){c[q>>2]=124024;c[q+4>>2]=291;c[q+8>>2]=0;Hta(124024,q,292)}q=(c[124028>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;GDa(y);z=139584;A=127;Td(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;GDa(y);z=139584;A=127;Td(x|0,z|0,A|0)}A=r;mta(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((le[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ie[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=xe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(xe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=le[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=le[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];we[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ie[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ie[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function lya(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function mya(a){a=a|0;i=i;return}function nya(a){a=a|0;i=i;return 2}function oya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];kya(a,b,l,k,f,g,h,122928,122936|0);i=j;return}function pya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];kya(b,d,m,l,g,h,j,s,q);i=k;return}function qya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31006]|0)==-1)){c[m>>2]=124024;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124024,m,292)}m=(c[124028>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}s=n;mta(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Nwa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function rya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31006]|0)==-1)){c[m>>2]=124024;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124024,m,292)}m=(c[124028>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}s=n;mta(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Nwa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function sya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Sua(m,f);f=m;m=c[f>>2]|0;if(!((c[31006]|0)==-1)){c[l>>2]=124024;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124024,l,292)}l=(c[124028>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;GDa(p);q=139584;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;GDa(p);q=139584;r=127;Td(o|0,q|0,r|0)}r=m;mta(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=xya(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function tya(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Sua(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[31006]|0)==-1)){c[ba>>2]=124024;c[ba+4>>2]=291;c[ba+8>>2]=0;Hta(124024,ba,292)}ba=(c[124028>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;GDa(Ga);Ha=139584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;GDa(Ga);Ha=139584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;mta(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];kya(ra,d,y,x,g,h,j,122968,122973|0);c[Da>>2]=c[ra>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=xya(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=xya(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=xya(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=ie[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];kya(da,d,O,N,g,h,j,Ka,Ja+La|0);c[ca>>2]=c[da>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Fa=ie[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(Nwa(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[ca&63](b,d,s,r,g,h,j);i=l;return};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=xya(e,E,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Fa|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Fa=xya(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Fa+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];wya(0,e,m,h,Ia);break};case 65:case 97:{Fa=c[f>>2]|0;ca=d+8|0;Da=ie[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Fa;c[Q+0>>2]=c[aa+0>>2];Fa=(Nwa(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((Fa|0)>=168){break a}c[j+24>>2]=((Fa|0)/12|0|0)%7|0;break};case 114:{Fa=e;c[pa>>2]=c[Fa>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];kya(oa,d,A,z,g,h,j,122952,122963|0);c[Fa>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];vya(d,j+8|0,e,B,h,Ia);break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Fa=xya(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<366){c[j+28>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Fa=xya(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Fa+ -1|0)>>>0<12)){break}c[Da>>2]=Fa;break a}}while(0);c[h>>2]=ca|4;break};case 68:{Fa=e;c[ha>>2]=c[Fa>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];kya(ga,d,L,K,g,h,j,122936,122944|0);c[Fa>>2]=c[ga>>2];break};case 70:{Fa=e;c[ka>>2]=c[Fa>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];kya(ja,d,J,I,g,h,j,122944,122952|0);c[Fa>>2]=c[ja>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];uya(0,e,C,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Fa=xya(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Fa|0)<7){c[j+24>>2]=Fa;break a}else{c[h>>2]=Da|4;break a}break};case 88:{Da=d+8|0;Fa=ie[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[Fa]|0;if((Ha&1)==0){Ma=Fa+1|0;Na=Fa+1|0;Oa=(Ha&255)>>>1}else{Ha=c[Fa+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[Fa+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];kya(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Da>>2]=c[za>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=xya(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=xya(e,H,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=Fa|4;break a}break};case 84:{Fa=e;c[va>>2]=c[Fa>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];kya(ua,d,v,u,g,h,j,122976,122984|0);c[Fa>>2]=c[ua>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function uya(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ie[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ie[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ie[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function vya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=Nwa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function wya(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((le[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ie[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function xya(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(le[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ie[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((le[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function yya(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;Sua(p,f);t=p;p=c[t>>2]|0;if(!((c[31004]|0)==-1)){c[o>>2]=124016;c[o+4>>2]=291;c[o+8>>2]=0;Hta(124016,o,292)}o=(c[124020>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}y=p;mta(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((le[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=xe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(xe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=le[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=le[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];we[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ie[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ie[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ie[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function zya(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Aya(a){a=a|0;i=i;return}function Bya(a){a=a|0;i=i;return 2}function Cya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];yya(a,b,l,k,f,g,h,123080,123112|0);i=j;return}function Dya(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];yya(b,d,m,l,g,h,j,s,q);i=k;return}function Eya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31004]|0)==-1)){c[m>>2]=124016;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124016,m,292)}m=(c[124020>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}s=n;mta(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=kxa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function Fya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Sua(n,f);f=n;n=c[f>>2]|0;if(!((c[31004]|0)==-1)){c[m>>2]=124016;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124016,m,292)}m=(c[124020>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;GDa(q);r=139584;s=127;Td(p|0,r|0,s|0)}s=n;mta(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=kxa(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function Gya(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Sua(m,f);f=m;m=c[f>>2]|0;if(!((c[31004]|0)==-1)){c[l>>2]=124016;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124016,l,292)}l=(c[124020>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;GDa(p);q=139584;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;GDa(p);q=139584;r=127;Td(o|0,q|0,r|0)}r=m;mta(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=Lya(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}



function Hsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;bta(119920,h,119976);c[29802]=121428;c[119216>>2]=121448;c[119212>>2]=0;Uua(119216|0,119920);c[119288>>2]=0;c[119292>>2]=-1;j=c[t>>2]|0;c[30006]=121296;CAa(120028|0);k=120032|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[30006]=120536;c[120056>>2]=j;DAa(g,120028|0);k=GAa(g,124088)|0;l=k;EAa(g);c[120060>>2]=l;c[120064>>2]=119984;a[120068|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[29824]=121508;c[119300>>2]=121528;Uua(119300|0,120024);c[119372>>2]=0;c[119376>>2]=-1;l=c[r>>2]|0;c[30018]=121296;CAa(120076|0);k=120080|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[30018]=120536;c[120104>>2]=l;DAa(f,120076|0);k=GAa(f,124088)|0;g=k;EAa(f);c[120108>>2]=g;c[120112>>2]=119992;a[120116|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[29846]=121508;c[119388>>2]=121528;Uua(119388|0,120072);c[119460>>2]=0;c[119464>>2]=-1;g=c[(c[(c[29846]|0)+ -12>>2]|0)+119408>>2]|0;c[29868]=121508;c[119476>>2]=121528;Uua(119476|0,g);c[119548>>2]=0;c[119552>>2]=-1;c[(c[(c[29802]|0)+ -12>>2]|0)+119280>>2]=119296;g=(c[(c[29846]|0)+ -12>>2]|0)+119388|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[29846]|0)+ -12>>2]|0)+119456>>2]=119296;Psa(120120,h,12e4|0);c[29890]=121468;c[119568>>2]=121488;c[119564>>2]=0;Uua(119568|0,120120);c[119640>>2]=0;c[119644>>2]=-1;c[30044]=121360;CAa(120180|0);h=120184|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[30044]=120280;c[120208>>2]=j;DAa(e,120180|0);j=GAa(e,124096)|0;h=j;EAa(e);c[120212>>2]=h;c[120216>>2]=120008;a[120220|0]=(ie[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[29912]=121548;c[119652>>2]=121568;Uua(119652|0,120176);c[119724>>2]=0;c[119728>>2]=-1;c[30056]=121360;CAa(120228|0);h=120232|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[30056]=120280;c[120256>>2]=l;DAa(d,120228|0);l=GAa(d,124096)|0;h=l;EAa(d);c[120260>>2]=h;c[120264>>2]=120016;a[120268|0]=(ie[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[29934]=121548;c[119740>>2]=121568;Uua(119740|0,120224);c[119812>>2]=0;c[119816>>2]=-1;h=c[(c[(c[29934]|0)+ -12>>2]|0)+119760>>2]|0;c[29956]=121548;c[119828>>2]=121568;Uua(119828|0,h);c[119900>>2]=0;c[119904>>2]=-1;c[(c[(c[29890]|0)+ -12>>2]|0)+119632>>2]=119648;h=(c[(c[29934]|0)+ -12>>2]|0)+119740|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[29934]|0)+ -12>>2]|0)+119808>>2]=119648;i=b;return}function Isa(a){a=a|0;a=i;Sva(119296)|0;Sva(119472)|0;Zva(119648)|0;Zva(119824)|0;i=a;return}function Jsa(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);i=b;return}function Ksa(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);hEa(a);i=b;return}function Lsa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=GAa(d,124096)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Msa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Nsa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function Osa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Psa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=121360;j=b+4|0;CAa(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=120392;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;DAa(g,j);j=GAa(g,124096)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Oza(120488)}else{EAa(g);i=f;return}}function Qsa(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);i=b;return}function Rsa(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);hEa(a);i=b;return}function Ssa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=GAa(d,124096)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Oza(120488)}else{i=e;return}}function Tsa(a){a=a|0;var b=0,c=0;b=i;c=Wsa(a,0)|0;i=b;return c|0}function Usa(a){a=a|0;var b=0,c=0;b=i;c=Wsa(a,1)|0;i=b;return c|0}function Vsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Wsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=dd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ge[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=dd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((qd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Xsa(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);i=b;return}function Ysa(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);hEa(a);i=b;return}function Zsa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=GAa(d,124088)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function _sa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function $sa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function ata(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function bta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=121296;j=b+4|0;CAa(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=120648;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;DAa(g,j);j=GAa(g,124088)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Oza(120488)}else{EAa(g);i=f;return}}function cta(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);i=b;return}function dta(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);hEa(a);i=b;return}function eta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=GAa(d,124088)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Oza(120488)}else{i=e;return}}function fta(a){a=a|0;var b=0,c=0;b=i;c=ita(a,0)|0;i=b;return c|0}function gta(a){a=a|0;var b=0,c=0;b=i;c=ita(a,1)|0;i=b;return c|0}function hta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function ita(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=dd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ge[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=dd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((qd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function jta(){var a=0;a=i;Hsa(0);Zd(290,119912,q|0)|0;i=a;return}function kta(a){a=a|0;i=i;return}function lta(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function mta(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}fe[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function nta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=120792;e=DEa(b|0)|0;f=gEa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;FEa(g|0,b|0,e+1|0)|0;i=d;return}function ota(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=120792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}function pta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=120792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function qta(a){a=a|0;i=i;return c[a+4>>2]|0}function rta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=120816;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=DEa(f|0)|0;g=gEa(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;FEa(h|0,f|0,d+1|0)|0;i=e;return}function sta(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=120816;e=DEa(b|0)|0;f=gEa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;FEa(g|0,b|0,e+1|0)|0;i=d;return}function tta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=120816;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}function uta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=120816;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function vta(a){a=a|0;i=i;return c[a+4>>2]|0}function wta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=120792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}function xta(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=120792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}iEa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;hEa(j);i=b;return}function yta(a){a=a|0;i=i;return}function zta(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function Ata(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ee[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function Bta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function Cta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Wd(e|0)|0;e=DEa(f|0)|0;if(e>>>0>4294967279){Ita(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;FEa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=fEa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;FEa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function Dta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{nua(e,121032,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ee[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}nua(e,o,p)|0;if((a[g]&1)==0){break}hEa(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function Eta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=DEa(e|0)|0;if(j>>>0>4294967279){Ita(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=fEa(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}FEa(k|0,e|0,j|0)|0;a[k+j|0]=0;Dta(g,d,h);rta(b,g);if(!((a[g]&1)==0)){hEa(c[g+8>>2]|0)}if(!((a[h]&1)==0)){hEa(c[h+8>>2]|0)}c[b>>2]=121048;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function Fta(a){a=a|0;var b=0;b=i;uta(a);hEa(a);i=b;return}function Gta(a){a=a|0;var b=0;b=i;uta(a);i=b;return}function Hta(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(121184)|0;if((c[a>>2]|0)==1){do{nd(121208,121184)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;fc(121184)|0;fe[d&511](b);tc(121184)|0;c[a>>2]=-1;fc(121184)|0;ad(121208)|0;i=e;return}else{fc(121184)|0;i=e;return}}function Ita(a){a=a|0;a=Ec(8)|0;nta(a,121256);c[a>>2]=120872;Td(a|0,120912,40)}function Jta(a){a=a|0;a=Ec(8)|0;nta(a,121256);c[a>>2]=120936;Td(a|0,120976,40)}function Kta(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Lta(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Mta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){Ita(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=fEa(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}FEa(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function Nta(b){b=b|0;i=i;return(a[b]&1)!=0|0}function Ota(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){Ita(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=fEa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}FEa(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function Pta(a){a=a|0;i=i;return a|0}function Qta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=DEa(d|0)|0;if(f>>>0>4294967279){Ita(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;FEa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=fEa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;FEa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function Rta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){Ita(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=fEa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}HEa(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function Sta(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){Ita(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;HEa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=fEa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;HEa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function Tta(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){Jta(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){Ita(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;FEa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=fEa(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;FEa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function Uta(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Vta(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Wta(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}hEa(c[b+8>>2]|0);i=d;return}function Xta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}oua(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}GEa(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Yta(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Zta(a,b)|0;i=c;return d|0}function Zta(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=DEa(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}oua(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}GEa(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function _ta(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function $ta(a){a=a|0;i=i;return a+1|0}function aua(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function bua(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function cua(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function dua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){eua(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function eua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){pua(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}HEa(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function fua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){eua(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function gua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){Ita(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=fEa(f)|0}else{p=fEa(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}FEa(l|0,n|0,q+1|0)|0;if(o){hEa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function hua(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function iua(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function jua(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function kua(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function lua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=nua(b,g,h)|0;i=e;return d|0}function mua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){pua(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function nua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){oua(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}FEa(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function oua(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){Ita(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=fEa(q)|0;if((g|0)!=0){FEa(e|0,m|0,g|0)|0}if((j|0)!=0){FEa(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){FEa(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){hEa(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function pua(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){Ita(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=fEa(p)|0;if((g|0)!=0){FEa(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){FEa(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}hEa(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function qua(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Tta(a,b,c,d,0);i=e;return}function rua(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function sua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=DEa(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function tua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=yEa(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function uua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=DEa(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){Jta(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=yEa(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function vua(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){Ita(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;FEa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=fEa(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;FEa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function wua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){Ita(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=fEa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}CDa(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function xua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){Ita(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=fEa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}EDa(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function yua(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}hEa(c[b+8>>2]|0);i=d;return}function zua(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Aua(a,b,BDa(b)|0)|0;i=c;return d|0}function Aua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}Dua(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}DDa(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function Bua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){Ita(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=fEa(f)|0}else{p=fEa(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}CDa(l,n,q+1|0)|0;if(o){hEa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function Cua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){Eua(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function Dua(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){Ita(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=fEa(q<<2)|0;p=e;if((g|0)!=0){CDa(p,m,g)|0}if((j|0)!=0){CDa(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){CDa(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){hEa(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function Eua(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){Ita(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=fEa(p<<2)|0;o=e;if((g|0)!=0){CDa(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){CDa(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}hEa(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function Fua(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=DEa(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){Ita(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=fEa(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}FEa(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=nua(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=nua(b,m,j)|0;i=f;return}}function Gua(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function Hua(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function Iua(a,b){a=a|0;b=b|0;var c=0;c=i;Jua(a,b);i=c;return}function Jua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[121640]|0)==0){if((Za(121640)|0)==0){break}c[30408]=122336;Zd(66,121632,q|0)|0;Tb(121640)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=121632;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];Eta(b,f,121688);c[e>>2]=121656;Td(e|0,121736,62)}function Kua(a,b){a=a|0;b=b|0;var d=0;d=i;Jua(a,c[a+16>>2]|b);i=d;return}function Lua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=121680;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ee[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}EAa(a+28|0);aEa(c[e>>2]|0);aEa(c[f>>2]|0);aEa(c[a+48>>2]|0);aEa(c[a+60>>2]|0);i=b;return}function Mua(a){a=a|0;var b=0;b=i;Lua(a);hEa(a);i=b;return}function Nua(a){a=a|0;var b=0;b=i;Lua(a);i=b;return}function Oua(a){a=a|0;var b=0;b=i;Lua(a);i=b;return}function Pua(a){a=a|0;i=i;return c[a+24>>2]|0}function Qua(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}DAa(d,a+28|0);a=GAa(d,124024)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;EAa(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function Rua(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;DAa(e,a+28|0);a=GAa(e,124024)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;EAa(e);i=d;return f|0}function Sua(a,b){a=a|0;b=b|0;var c=0;c=i;DAa(a,b+28|0);i=c;return}function Tua(a){a=a|0;c[a>>2]=121280;i=i;return}function Uua(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));CAa(b);i=d;return}function Vua(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);hEa(a);i=b;return}function Wua(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);i=b;return}function Xua(a){a=a|0;var b=0;b=i;c[a>>2]=121296;EAa(a+4|0);i=b;return}function Yua(a,b){a=a|0;b=b|0;var c=0;c=i;DAa(a,b+4|0);i=c;return}function Zua(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function _ua(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=xe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function $ua(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=le[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function ava(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=121296;CAa(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function bva(a){a=a|0;i=i;return c[a+8>>2]|0}function cva(a){a=a|0;i=i;return c[a+12>>2]|0}function dva(a){a=a|0;i=i;return c[a+16>>2]|0}function eva(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function fva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function gva(a){a=a|0;i=i;return c[a+20>>2]|0}function hva(a){a=a|0;i=i;return c[a+24>>2]|0}function iva(a){a=a|0;i=i;return c[a+28>>2]|0}function jva(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function kva(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function lva(a,b){a=a|0;b=b|0;i=i;return}function mva(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function nva(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function ova(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function pva(a){a=a|0;i=i;return 0}function qva(a){a=a|0;i=i;return 0}function rva(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ie[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function sva(a){a=a|0;i=i;return-1}function tva(a){a=a|0;var b=0,e=0,f=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function uva(a,b){a=a|0;b=b|0;i=i;return-1}function vva(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function wva(a,b){a=a|0;b=b|0;i=i;return-1}function xva(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);hEa(a);i=b;return}function yva(a){a=a|0;var b=0;b=i;c[a>>2]=121360;EAa(a+4|0);i=b;return}function zva(a,b){a=a|0;b=b|0;i=i;return}function Ava(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function Bva(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function Cva(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function Dva(a){a=a|0;i=i;return 0}function Eva(a){a=a|0;i=i;return 0}function Fva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function Gva(a){a=a|0;i=i;return-1}function Hva(a){a=a|0;var b=0,d=0,e=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function Iva(a,b){a=a|0;b=b|0;i=i;return-1}function Jva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((xe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function Kva(a,b){a=a|0;b=b|0;i=i;return-1}function Lva(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));CAa(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Mva(a){a=a|0;var b=0;b=i;Lua(a+8|0);hEa(a);i=b;return}function Nva(a){a=a|0;var b=0;b=i;Lua(a+8|0);i=b;return}function Ova(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Lua(a+(d+8)|0);hEa(a+d|0);i=b;return}function Pva(a){a=a|0;var b=0;b=i;Lua(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Qva(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Rva(a,b,c);i=d;return}function Rva(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){Jua(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){Sva(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}DAa(h,e+(k+28)|0);k=GAa(h,124024)|0;EAa(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ie[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;Jua(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function Sva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Sva(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Jua(b+h|0,c[b+(h+16)>>2]|1)}}while(0);fwa(e);i=d;return b|0}function Tva(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Uva(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function Vva(a){a=a|0;var b=0;b=i;Lua(a+8|0);hEa(a);i=b;return}function Wva(a){a=a|0;var b=0;b=i;Lua(a+8|0);i=b;return}function Xva(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Lua(a+(d+8)|0);hEa(a+d|0);i=b;return}function Yva(a){a=a|0;var b=0;b=i;Lua(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Zva(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Zva(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Jua(b+h|0,c[b+(h+16)>>2]|1)}}while(0);rwa(e);i=d;return b|0}function _va(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));CAa(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function $va(a){a=a|0;var b=0;b=i;Lua(a+4|0);hEa(a);i=b;return}function awa(a){a=a|0;var b=0;b=i;Lua(a+4|0);i=b;return}function bwa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Lua(a+(d+4)|0);hEa(a+d|0);i=b;return}function cwa(a){a=a|0;var b=0;b=i;Lua(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function dwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){Sva(g)|0}a[f]=1;i=e;return}function ewa(a){a=a|0;var b=0;b=i;fwa(a);i=b;return}function fwa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Jua(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function gwa(b){b=b|0;i=i;return(a[b]|0)!=0|0}function hwa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ie[b&127](a)|0;i=c;return d|0}function iwa(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){fwa(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{Sva(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;DAa(k,b+(p+28)|0);p=GAa(k,122744)|0;m=p;EAa(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){DAa(h,b+(k+28)|0);r=GAa(h,124024)|0;s=xe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;EAa(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];oe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){fwa(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;Jua(b+l|0,c[b+(l+16)>>2]|5);fwa(j);i=e;return b|0}function jwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){fwa(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{Sva(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;fwa(f);i=e;return b|0}if((xe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{fwa(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;Jua(b+d|0,c[b+(d+16)>>2]|1);fwa(f);i=e;return b|0}function kwa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){fwa(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){Sva(k)|0}a[h]=1;if((e|0)==0){fwa(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((le[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){fwa(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;Jua(b+e|0,c[b+(e+16)>>2]|1);fwa(g);i=f;return b|0}function lwa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;re[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function mwa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){fwa(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{Sva(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ie[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){fwa(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;Jua(b+f|0,c[b+(f+16)>>2]|4);fwa(h);i=e;return b|0}function nwa(a){a=a|0;var b=0;b=i;Lua(a+4|0);hEa(a);i=b;return}function owa(a){a=a|0;var b=0;b=i;Lua(a+4|0);i=b;return}function pwa(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Lua(a+(d+4)|0);hEa(a+d|0);i=b;return}function qwa(a){a=a|0;var b=0;b=i;Lua(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function rwa(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Jua(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function swa(a){a=a|0;i=i;return 121576}function twa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){Ota(a,121592,35);i=d;return}else{Cta(a,b,c);i=d;return}}function uwa(a){a=a|0;i=i;return}function vwa(a){a=a|0;var b=0;b=i;Gta(a);hEa(a);i=b;return}function wwa(a){a=a|0;var b=0;b=i;Gta(a);i=b;return}function xwa(a){a=a|0;var b=0;b=i;Lua(a);hEa(a);i=b;return}function ywa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function zwa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Awa(a){a=a|0;i=i;return}function Bwa(a){a=a|0;i=i;return}function Cwa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function Dwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){Ita(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=fEa(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function Ewa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function Fwa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Gwa(a){a=a|0;i=i;return}function Hwa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function Iwa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){Ita(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=fEa(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function Jwa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function Kwa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Lwa(a){a=a|0;i=i;return}function Mwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Sua(u,g);m=u;u=c[m>>2]|0;if(!((c[31006]|0)==-1)){c[p>>2]=124024;c[p+4>>2]=291;c[p+8>>2]=0;Hta(124024,p,292)}p=(c[124028>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}F=u;mta(c[m>>2]|0)|0;Sua(v,g);g=v;v=c[g>>2]|0;if(!((c[31042]|0)==-1)){c[o>>2]=124168;c[o+4>>2]=291;c[o+8>>2]=0;Hta(124168,o,292)}o=(c[124172>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}J=v;mta(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=Nwa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Wta(w+12|0);Wta(w);i=k;return}function Nwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=$Da(l)|0;if((n|0)!=0){o=n;p=n;break}mEa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ie[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ie[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=xe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(xe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ie[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}aEa(o);i=k;return _|0}function Owa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Pwa(a,0,k,j,f,g,h);i=b;return}function Pwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;Fxa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}dua(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}dua(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((fxa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=BCa(F,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}function Qwa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Rwa(a,0,k,j,f,g,h);i=b;return}function Rwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Fxa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}dua(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}dua(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((fxa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=ACa(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}function Swa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Twa(a,0,k,j,f,g,h);i=b;return}function Twa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;Fxa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}dua(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}dua(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((fxa(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=zCa(G,c[p>>2]|0,j,u)|0;Sza(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Wta(o);Wta(n);i=e;return}if((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Wta(o);Wta(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Wta(o);Wta(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Wta(o);Wta(n);i=e;return}function Uwa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Vwa(a,0,k,j,f,g,h);i=b;return}function Vwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Fxa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}dua(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}dua(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((fxa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=yCa(F,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}function Wwa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Xwa(a,0,k,j,f,g,h);i=b;return}function Xwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Fxa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}dua(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}dua(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((fxa(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=xCa(F,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Wta(n);Wta(m);i=d;return}function Ywa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Zwa(a,0,k,j,f,g,h);i=b;return}function Zwa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;Fxa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}dua(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}dua(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((fxa(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=wCa(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Wta(n);Wta(m);i=d;return}function _wa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$wa(a,0,k,j,f,g,h);i=b;return}function $wa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Gxa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}dua(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}dua(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Hxa(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+vCa(I,c[p>>2]|0,j);Sza(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}function axa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];bxa(a,0,k,j,f,g,h);i=b;return}function bxa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Gxa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}dua(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}dua(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Hxa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+uCa(I,c[p>>2]|0,j);Sza(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}function cxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dxa(a,0,k,j,f,g,h);i=b;return}function dxa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;Gxa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}dua(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}dua(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((Hxa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+tCa(I,c[p>>2]|0,j);Sza(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Wta(o);Wta(n);i=d;return}function exa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Sua(o,g);g=o;o=c[g>>2]|0;if(!((c[31006]|0)==-1)){c[l>>2]=124024;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124024,l,292)}l=(c[124028>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;GDa(w);x=139584;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+32>>2]&63](o,122568,122594|0,y)|0;mta(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}dua(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}dua(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((fxa(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);K=c[30978]|0;c[k>>2]=j;if((gxa(E,K,122608,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Wta(p);Wta(n);i=d;return}if((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Wta(p);Wta(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Wta(p);Wta(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Wta(p);Wta(n);i=d;return}function fxa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[122568+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[122568+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function gxa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function hxa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function ixa(a){a=a|0;i=i;return}function jxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Sua(u,g);m=u;u=c[m>>2]|0;if(!((c[31004]|0)==-1)){c[p>>2]=124016;c[p+4>>2]=291;c[p+8>>2]=0;Hta(124016,p,292)}p=(c[124020>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}F=u;mta(c[m>>2]|0)|0;Sua(v,g);g=v;v=c[g>>2]|0;if(!((c[31044]|0)==-1)){c[o>>2]=124176;c[o+4>>2]=291;c[o+8>>2]=0;Hta(124176,o,292)}o=(c[124180>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}J=v;mta(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=kxa(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];yua(w+12|0);yua(w);i=k;return}function kxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=$Da(l)|0;if((n|0)!=0){o=n;p=n;break}mEa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=xe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(xe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ie[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}aEa(o);i=k;return ba|0}function lxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];mxa(a,0,k,j,f,g,h);i=b;return}function mxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;Ixa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}dua(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}dua(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((Exa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=BCa(I,c[o>>2]|0,h,t)|0;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Wta(n);Wta(m);i=d;return}function nxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];oxa(a,0,k,j,f,g,h);i=b;return}function oxa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;Ixa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;dua(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}dua(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}dua(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((Exa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=ACa(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Sza(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Wta(n);Wta(m);i=d;return}function pxa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];qxa(a,0,k,j,f,g,h);i=b;return}



function I6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 17:{k=M6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=L6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=J6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=K6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=D6(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 11:{o=90;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=D6(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 6:{o=42;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=D6(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 5:{o=78;break d;break};case 6:{o=81;break d;break};case 11:{o=90;break c;break};case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 29:{o=75;break d;break};case 17:{break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=N6(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function J6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=D6(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function K6(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[43264+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function L6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=D6(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=D6(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((O6(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=D6(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((O6(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function M6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=D6(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=D6(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function N6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=D6(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 29:{if((c[41320+((d[42600+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=D6(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 29:{if((c[41320+((d[41064+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=D6(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=D6(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=D6(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 3:{t=E6(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 2:{l=79;break a;break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=D6(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=D6(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 7:{l=103;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[41320+((d[41064+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function O6(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function P6(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=D6(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=D6(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Q6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=D6(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=D6(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=J6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function R6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=D6(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function S6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=D6(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 15:{k=o7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=t7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{p=19;b=b+2|0;n=77;break};case 13:{k=s7(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=s7(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=D6(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 29:{g=b;if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;p=18;n=77;break a}if((c[41320+((d[42600+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;p=19;n=77;break};case 30:{k=i7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{p=18;b=b+2|0;n=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 19:{k=u7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=D6(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=D6(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{n=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};case 5:{n=85;break b;break};case 23:{b=b+2|0;r=p;if((r|0)==41){p=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}p=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=D6(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 5:{n=105;break b;break};case 6:{n=108;break b;break};case 7:{n=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{p=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 7:{n=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 6:{n=88;break b;break};case 33:{n=119;break b;break};case 15:{n=122;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=p;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-p|0;l=k;i=h;return l|0}}return 0}function T6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=D6(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=h7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=l7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=D6(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function U6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=D6(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=D6(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function V6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=D6(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function W6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=D6(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=h7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=D6(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function X6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=D6(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=h7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=i7(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=D6(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Y6(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=D6(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=D6(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Z6(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function _6(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=D6(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function $6(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=D6(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function a7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=D6(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=D6(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function b7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=R5(c)|0;k=j;i=b;return k|0}function c7(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function d7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=D6(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=D6(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function e7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=D6(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function f7(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function g7(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function h7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=j7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=D6(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function i7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=D6(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function j7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=k7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=D6(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function k7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=D6(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=D6(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function l7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=D6(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=m7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=n7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 17:{k=p7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=o7(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=D6(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 11:{o=90;break b;break};case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 17:{break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=D6(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 24:case 22:{break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=D6(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 11:{o=90;break c;break};case 5:{o=78;break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 17:{break c;break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=q7(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function m7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=D6(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function n7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[43640+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function o7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=D6(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=D6(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=28;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((r7(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=D6(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((r7(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function p7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=D6(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 11:{n=48;break b;break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=D6(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function q7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=D6(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 6:{l=13;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[41320+((d[42600+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=D6(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 5:{l=30;break a;break};case 24:case 22:{break};case 29:{if((c[41320+((d[41064+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 7:{l=16;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=D6(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 5:{l=10;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=D6(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=D6(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=h7(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 2:{l=79;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=D6(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=D6(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 7:{l=103;break a;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[41320+((d[41064+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function r7(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function s7(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=D6(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=D6(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function t7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=D6(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=D6(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=m7(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function u7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=D6(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[41320+((d[41064+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=D6(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[41320+((d[42600+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function v7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{if((b+1|0)!=(e|0)){m=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 10:case 21:{m=15;break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;n=18;break a}g=b;if((xe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 13:{k=d8(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;n=18;break a}g=b;if((xe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=d8(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+1|0;break};case 19:{k=f8(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;n=18;break a}g=b;if((xe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;n=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 30:{k=V7(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=e8(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=$7(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+1|0;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((m|0)==15){while(1){m=0;b=b+1|0;o=b;if((b|0)==(e|0)){m=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){m=15;continue}else if((g|0)!=9){m=18;break}if((b+1|0)!=(e|0)){m=15}else{m=18;break}}if((m|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((m|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){m=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=82;break b}p=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=84;break b}b=p+4|0;continue b;break};case 23:{b=b+1|0;o=n;if((o|0)==41){n=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){m=89;break b}n=41;switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=99;break b}q=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=101;break b}b=q+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=104;break b}r=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=106;break b}b=r+4|0;continue b;break};case 29:{m=91;break b;break};case 5:{if((e-b|0)<2){m=94;break b}s=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=96;break b}b=s+2|0;continue b;break};default:{n=19;continue b}}break};case 5:{if((e-b|0)<2){m=72;break b}t=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=74;break b}b=t+2|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{m=86;break b;break};case 6:{if((e-b|0)<3){m=77;break b}u=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=79;break b}b=u+3|0;continue b;break};case 15:{m=116;break b;break};case 29:{m=69;break b;break};case 34:{m=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 33:{m=113;break b;break};default:{m=119;break b}}}if((m|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==72){k=-2;l=k;i=h;return l|0}else if((m|0)==74){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((m|0)==77){k=-2;l=k;i=h;return l|0}else if((m|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((m|0)==82){k=-2;l=k;i=h;return l|0}else if((m|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==86){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((m|0)==89){k=-1;l=k;i=h;return l|0}else if((m|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==94){k=-2;l=k;i=h;return l|0}else if((m|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==99){k=-2;l=k;i=h;return l|0}else if((m|0)==101){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-2;l=k;i=h;return l|0}else if((m|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==110){r=b;if((n|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((m|0)==113){r=b;if((n|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((m|0)==116){r=b;if((n|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((m|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==120){k=0-n|0;l=k;i=h;return l|0}return 0}function w7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=U7(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=Y7(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function x7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 6:{if((e-b|0)<3){n=43;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function y7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}o=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=o+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function z7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=16;break a;break};case 10:{m=13;break a;break};case 21:{m=23;break a;break};case 6:{a=a+3|0;continue a;break};case 2:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=U7(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function A7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 9:{m=18;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 30:{m=12;break a;break};case 10:{m=15;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=U7(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=V7(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function B7(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};case 5:{break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function C7(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function D7(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function E7(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function F7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function G7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=R5(c)|0;g=f;i=b;return g|0}function H7(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function I7(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};case 5:{a=a+2|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function J7(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function K7(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function L7(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){o=j;j=o+2|0;b[o>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function M7(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[41320+(((d[42600+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}



function Hya(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Sua(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[31004]|0)==-1)){c[ba>>2]=124016;c[ba+4>>2]=291;c[ba+8>>2]=0;Hta(124016,ba,292)}ba=(c[124020>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;GDa(Ga);Ha=139584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;GDa(Ga);Ha=139584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;mta(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=Lya(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=Lya(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];Kya(0,e,m,h,Ia);break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Fa=ie[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(kxa(e,P,Fa,Fa+288|0,Ia,h,0)|0)-Fa|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];yya(ra,d,y,x,g,h,j,123224,123244|0);c[Da>>2]=c[ra>>2];break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[Da&63](b,d,s,r,g,h,j);i=l;return};case 65:case 97:{Da=c[f>>2]|0;Fa=d+8|0;ca=ie[c[c[Fa>>2]>>2]&127](Fa)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(kxa(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];Iya(0,e,C,h,Ia);break};case 88:{Da=d+8|0;ca=ie[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ja=Fa;Ka=Fa;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];yya(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[za>>2];break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];yya(ua,d,v,u,g,h,j,123248,123280|0);c[Da>>2]=c[ua>>2];break};case 99:{Da=d+8|0;ca=ie[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Ma=ca+4|0;Na=ca+4|0;Oa=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Ma=Fa;Na=Fa;Oa=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];yya(da,d,O,N,g,h,j,Na,Ma+(Oa<<2)|0);c[Da>>2]=c[da>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=Lya(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=Lya(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];yya(ga,d,L,K,g,h,j,123112,123144|0);c[Da>>2]=c[ga>>2];break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];yya(ja,d,J,I,g,h,j,123144,123176|0);c[Da>>2]=c[ja>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];yya(oa,d,A,z,g,h,j,123176,123220|0);c[Da>>2]=c[oa>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=Lya(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=Lya(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=Lya(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Pa=ca+2e3|0}else{Pa=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Pa+ -1900;break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=Lya(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=Lya(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];Jya(d,j+8|0,e,B,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=Lya(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function Iya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(le[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ie[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Jya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=kxa(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function Kya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ie[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((le[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ie[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Lya(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ie[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ie[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(le[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ie[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((le[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ie[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function Mya(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);if((f|0)==(c[30978]|0)){g=b;hEa(g);i=d;return}ac(c[e>>2]|0);g=b;hEa(g);i=d;return}function Nya(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);if((b|0)==(c[30978]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Oya(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(xe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function Pya(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);if((f|0)==(c[30978]|0)){g=b;hEa(g);i=d;return}ac(c[e>>2]|0);g=b;hEa(g);i=d;return}function Qya(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);if((b|0)==(c[30978]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Rya(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;Sya(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=xe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function Sya(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=cDa(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){Oza(124904)}else{c[e>>2]=d+(g<<2);i=j;return}}function Tya(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Uya(a){a=a|0;i=i;return}function Vya(a){a=a|0;i=i;return 127}function Wya(a){a=a|0;i=i;return 127}function Xya(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Yya(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Zya(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _ya(a,b){a=a|0;b=b|0;b=i;Sta(a,1,45);i=b;return}function $ya(a){a=a|0;i=i;return 0}function aza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function bza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function cza(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function dza(a){a=a|0;i=i;return}function eza(a){a=a|0;i=i;return 127}function fza(a){a=a|0;i=i;return 127}function gza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function hza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function iza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function jza(a,b){a=a|0;b=b|0;b=i;Sta(a,1,45);i=b;return}function kza(a){a=a|0;i=i;return 0}function lza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function mza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function nza(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function oza(a){a=a|0;i=i;return}function pza(a){a=a|0;i=i;return 2147483647}function qza(a){a=a|0;i=i;return 2147483647}function rza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function sza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function tza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uza(a,b){a=a|0;b=b|0;b=i;xua(a,1,45);i=b;return}function vza(a){a=a|0;i=i;return 0}function wza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function xza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function yza(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function zza(a){a=a|0;i=i;return}function Aza(a){a=a|0;i=i;return 2147483647}function Bza(a){a=a|0;i=i;return 2147483647}function Cza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Dza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Eza(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Fza(a,b){a=a|0;b=b|0;b=i;xua(a,1,45);i=b;return}function Gza(a){a=a|0;i=i;return 0}function Hza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Iza(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Jza(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Kza(a){a=a|0;i=i;return}function Lza(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=293;y=o+100|0;Sua(r,h);o=r;z=c[o>>2]|0;if(!((c[31006]|0)==-1)){c[n>>2]=124024;c[n+4>>2]=291;c[n+8>>2]=0;Hta(124024,n,292)}n=(c[124028>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Nza(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+32>>2]&63](E,123640,123650|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=$Da(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}mEa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[123640+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,123656,m|0)|0)!=1){t=Ec(8)|0;sta(t,123664);Td(t|0,121016,42)}if((F|0)==0){break}aEa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;mta(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&511](o);i=d;return}function Mza(a){a=a|0;i=i;return}function Nza(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Rza(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=293;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(ie[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}mua(A,ea);X=26;break};case 3:{da=a[y]|0;W=(da&1)==0;if(W){fa=(da&255)>>>1}else{fa=c[G>>2]|0}ba=a[z]|0;ga=(ba&1)==0;if(ga){ha=(ba&255)>>>1}else{ha=c[g>>2]|0}if((fa|0)==(0-ha|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}if(W){oa=(da&255)>>>1}else{oa=c[G>>2]|0}do{if((oa|0)!=0){if(ga){pa=(ba&255)>>>1}else{pa=c[g>>2]|0}if((pa|0)==0){break}qa=c[h>>2]|0;ra=c[qa+12>>2]|0;sa=c[qa+16>>2]|0;if((ra|0)==(sa|0)){ta=(ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255;ua=c[h>>2]|0;va=ta;wa=c[ua+16>>2]|0;xa=c[ua+12>>2]|0;ya=ua;za=a[y]|0}else{va=a[ra]|0;wa=sa;xa=ra;ya=qa;za=da}qa=ya+12|0;ra=(xa|0)==(wa|0);if(va<<24>>24==(a[(za&1)==0?F:c[H>>2]|0]|0)){if(ra){ie[c[(c[ya>>2]|0)+40>>2]&127](ya)|0}else{c[qa>>2]=xa+1}qa=a[y]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Aa>>>0>1?y:S;na=T;break b}if(ra){Ba=(ie[c[(c[ya>>2]|0)+36>>2]&127](ya)|0)&255}else{Ba=a[xa]|0}if(!(Ba<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}ra=c[h>>2]|0;qa=ra+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[qa>>2]=sa+1}a[l]=1;sa=a[z]|0;if((sa&1)==0){Ca=(sa&255)>>>1}else{Ca=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ca>>>0>1?z:S;na=T;break b}}while(0);if(W){Da=(da&255)>>>1}else{Da=c[G>>2]|0}ga=c[h>>2]|0;sa=c[ga+12>>2]|0;qa=(sa|0)==(c[ga+16>>2]|0);if((Da|0)==0){if(qa){ra=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ea=ra;Fa=a[z]|0}else{Ea=a[sa]|0;Fa=ba}if(!(Ea<<24>>24==(a[(Fa&1)==0?m:c[E>>2]|0]|0))){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[ua>>2]=ta+1}a[l]=1;ta=a[z]|0;if((ta&1)==0){Ga=(ta&255)>>>1}else{Ga=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ga>>>0>1?z:S;na=T;break b}if(qa){qa=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ha=qa;Ia=a[y]|0}else{Ha=a[sa]|0;Ia=da}if(!(Ha<<24>>24==(a[(Ia&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}sa=c[h>>2]|0;qa=sa+12|0;ga=c[qa>>2]|0;if((ga|0)==(c[sa+16>>2]|0)){ie[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Ja=(ga&255)>>>1}else{Ja=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ja>>>0>1?y:S;na=T;break};case 0:{X=26;break};case 4:{ga=D;qa=R;sa=r;ta=Q;ua=0;ra=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((ie[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((ie[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(ie[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(ga|0)){Ma=(c[P>>2]|0)!=293;Pa=c[t>>2]|0;Qa=ga-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=cEa(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}fe[c[P>>2]&511](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=268;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=ga}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=qa;Ya=sa;Za=ta;_a=ua+1|0;$a=ra}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(ua|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((sa|0)==(ta|0)){Ka=sa-qa|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((ra|0)==293){bb=0}else{bb=qa}Ma=cEa(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=268}else{cb=qa;db=sa;eb=ta;fb=ra}c[db>>2]=ua;Wa=ga;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){ie[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}else{c[Ma>>2]=Ka+1;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}}if((qa|0)==(sa|0)|(ua|0)==0){gb=qa;hb=sa;ib=ta;jb=ra}else{if((sa|0)==(ta|0)){da=sa-qa|0;ba=da>>>0<2147483647?da<<1:-1;if((ra|0)==293){kb=0}else{kb=qa}W=cEa(kb,ba)|0;if((W|0)==0){X=209;break a}lb=W;mb=W+(da>>2<<2)|0;nb=W+(ba>>>2<<2)|0;ob=268}else{lb=qa;mb=sa;nb=ta;ob=ra}c[mb>>2]=ua;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){ba=c[h>>2]|0;do{if((ba|0)==0){pb=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){pb=ba;break}if((ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);ba=(pb|0)==0;ua=c[e>>2]|0;do{if((ua|0)==0){X=223}else{if((c[ua+12>>2]|0)!=(c[ua+16>>2]|0)){if(ba){qb=ua;break}else{X=229;break a}}if((ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)==-1){c[e>>2]=0;X=223;break}else{if(ba){qb=ua;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ba){X=229;break a}else{qb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){rb=(ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{rb=a[ra]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0;sb=qb;tb=qb;ub=ga}else{c[ua>>2]=ta+1;sb=qb;tb=qb;ub=ga}while(1){ta=c[h>>2]|0;do{if((ta|0)==0){vb=0}else{if((c[ta+12>>2]|0)!=(c[ta+16>>2]|0)){vb=ta;break}if((ie[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ta=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ta){xb=sb;yb=tb;break}else{X=250;break a}}if((ie[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ta^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ta){X=250;break a}else{xb=wb;yb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){zb=(ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{zb=a[ra]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ra=c[o>>2]|0;if((ra|0)==(ub|0)){ua=(c[P>>2]|0)!=293;sa=c[t>>2]|0;qa=ub-sa|0;W=qa>>>0<2147483647?qa<<1:-1;da=cEa(ua?sa:0,W)|0;if((da|0)==0){X=253;break a}do{if(ua){c[t>>2]=da;Ab=da}else{sa=c[t>>2]|0;c[t>>2]=da;if((sa|0)==0){Ab=da;break}fe[c[P>>2]&511](sa);Ab=c[t>>2]|0}}while(0);c[P>>2]=268;da=Ab+qa|0;c[o>>2]=da;Bb=da;Cb=(c[t>>2]|0)+W|0}else{Bb=ra;Cb=ub}da=c[h>>2]|0;ua=c[da+12>>2]|0;if((ua|0)==(c[da+16>>2]|0)){ta=(ie[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255;Db=ta;Eb=c[o>>2]|0}else{Db=a[ua]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;ua=(c[B>>2]|0)+ -1|0;c[B>>2]=ua;ta=c[h>>2]|0;da=ta+12|0;sa=c[da>>2]|0;if((sa|0)==(c[ta+16>>2]|0)){ie[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[da>>2]=sa+1}if((ua|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=ga}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ia=Fb;ja=gb;ka=hb;la=ib;ma=S;na=jb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ia=D;ja=R;ka=r;la=Q;ma=0;na=T;break b}}ba=a[x]|0;ua=(ba&1)==0;sa=ua?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=ba;Kb=sa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}da=sa+(ua?(ba&255)>>>1:c[K>>2]|0)|0;ta=sa;while(1){if((ta|0)==(da|0)){Lb=da;break}Ka=a[ta]|0;if(!(Ka<<24>>24>-1)){Lb=ta;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ta;break}else{ta=ta+1|0}}ta=Lb-sa|0;da=a[A]|0;ra=(da&1)==0;if(ra){Mb=(da&255)>>>1}else{Mb=c[N>>2]|0}if(ta>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}if(ra){ra=(da&255)>>>1;Nb=A+1+(ra-ta)|0;Ob=L;Pb=ra}else{ra=c[M>>2]|0;da=c[N>>2]|0;Nb=ra+(da-ta)|0;Ob=ra;Pb=da}da=Ob+Pb|0;if((Nb|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=sa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break d}ra=Rb+1|0;if((ra|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=Qb+1|0;Rb=ra}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}ba=c[h>>2]|0;do{if((ba|0)==0){Ub=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){Ub=ba;break}if((ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);ba=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(ba){Wb=Hb;Xb=Ib;break}else{break e}}if((ie[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(ba^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ba){break}else{Wb=Vb;Xb=0}}sa=c[h>>2]|0;ua=c[sa+12>>2]|0;if((ua|0)==(c[sa+16>>2]|0)){Yb=(ie[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{Yb=a[ua]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}ua=c[h>>2]|0;sa=ua+12|0;ga=c[sa>>2]|0;if((ga|0)==(c[ua+16>>2]|0)){ie[c[(c[ua>>2]|0)+40>>2]&127](ua)|0}else{c[sa>>2]=ga+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ga=a[x]|0;if((ga&1)==0){Zb=j;_b=(ga&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T}else{X=162;break a}break};default:{ia=D;ja=R;ka=r;la=Q;ma=S;na=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}if((ie[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}else{dc=cc;ec=0}}ba=c[h>>2]|0;ga=c[ba+12>>2]|0;if((ga|0)==(c[ba+16>>2]|0)){fc=(ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{fc=a[ga]|0}if(!(fc<<24>>24>-1)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}ga=c[h>>2]|0;ba=ga+12|0;sa=c[ba>>2]|0;if((sa|0)==(c[ga+16>>2]|0)){gc=(ie[c[(c[ga>>2]|0)+40>>2]&127](ga)|0)&255}else{c[ba>>2]=sa+1;gc=a[sa]|0}mua(A,gc);$b=dc;ac=ec}}}while(0);sa=p+1|0;if(sa>>>0<4){Q=la;r=ka;R=ja;D=ia;p=sa;S=ma;T=na}else{Z=ja;_=ka;$=ma;aa=na;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){mEa()}else if((X|0)==198){mEa()}else if((X|0)==209){mEa()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){mEa()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){na=$+1|0;ma=$+8|0;ka=$+4|0;ja=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ka>>2]|0}if(!(ja>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((ie[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=na}else{nc=c[ma>>2]|0}if(!(mc<<24>>24==(a[nc+ja|0]|0))){break}p=ja+1|0;U=c[h>>2]|0;ia=U+12|0;D=c[ia>>2]|0;if((D|0)==(c[U+16>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;ja=p;continue}else{c[ia>>2]=D+1;ja=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;Sza(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);Wta(A);Wta(z);Wta(y);Wta(x);Wta(w);if((ic|0)==0){i=q;return hc|0}fe[jc&511](ic);i=q;return hc|0}function Oza(a){a=a|0;var b=0;b=Ec(8)|0;sta(b,a);Td(b|0,121016,42)}function Pza(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=293;v=n+100|0;Sua(q,h);n=q;w=c[n>>2]|0;if(!((c[31006]|0)==-1)){c[m>>2]=124024;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124024,m,292)}m=(c[124028>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;GDa(z);A=139584;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;GDa(z);A=139584;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Nza(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){mua(k,xe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Qza(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ie[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;mta(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&511](n);i=d;return}function Qza(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){pua(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function Rza(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[30866]|0)==-1)){c[p>>2]=123464;c[p+4>>2]=291;c[p+8>>2]=0;Hta(123464,p,292)}p=(c[123468>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Wta(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}gua(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Wta(s);a[f]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}gua(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Wta(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Wta(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[30850]|0)==-1)){c[o>>2]=123400;c[o+4>>2]=291;c[o+8>>2]=0;Hta(123400,o,292)}o=(c[123404>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Wta(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}gua(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Wta(x);a[f]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}gua(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wta(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Wta(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Sza(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function Tza(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function Uza(a){a=a|0;i=i;return}function Vza(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=293;y=o+400|0;Sua(r,h);o=r;z=c[o>>2]|0;if(!((c[31004]|0)==-1)){c[n>>2]=124016;c[n+4>>2]=291;c[n+8>>2]=0;Hta(124016,n,292)}n=(c[124020>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Wza(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+48>>2]&63](E,123720,123730|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=$Da((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}mEa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[123720+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,123656,m|0)|0)!=1){t=Ec(8)|0;sta(t,123664);Td(t|0,121016,42)}if((F|0)==0){break}aEa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ie[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];mta(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&511](o);i=d;return}function Wza(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Zza(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=293;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 3:{P=a[y]|0;R=(P&1)==0;if(R){_=(P&255)>>>1}else{_=c[D>>2]|0}$=a[z]|0;aa=($&1)==0;if(aa){ba=($&255)>>>1}else{ba=c[e>>2]|0}if((_|0)==(0-ba|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}if(R){ha=(P&255)>>>1}else{ha=c[D>>2]|0}do{if((ha|0)!=0){if(aa){ia=($&255)>>>1}else{ia=c[e>>2]|0}if((ia|0)==0){break}ja=c[g>>2]|0;ka=c[ja+12>>2]|0;if((ka|0)==(c[ja+16>>2]|0)){la=ie[c[(c[ja>>2]|0)+36>>2]&127](ja)|0;ma=la;na=a[y]|0}else{ma=c[ka>>2]|0;na=P}ka=c[g>>2]|0;la=ka+12|0;ja=c[la>>2]|0;oa=(ja|0)==(c[ka+16>>2]|0);if((ma|0)==(c[((na&1)==0?D:c[E>>2]|0)>>2]|0)){if(oa){ie[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=ja+4}la=a[y]|0;if((la&1)==0){pa=(la&255)>>>1}else{pa=c[D>>2]|0}ca=M;da=r;ea=L;fa=pa>>>0>1?y:N;ga=O;break b}if(oa){qa=ie[c[(c[ka>>2]|0)+36>>2]&127](ka)|0}else{qa=c[ja>>2]|0}if((qa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ja=c[g>>2]|0;ka=ja+12|0;oa=c[ka>>2]|0;if((oa|0)==(c[ja+16>>2]|0)){ie[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[ka>>2]=oa+4}a[k]=1;oa=a[z]|0;if((oa&1)==0){ra=(oa&255)>>>1}else{ra=c[e>>2]|0}ca=M;da=r;ea=L;fa=ra>>>0>1?z:N;ga=O;break b}}while(0);if(R){sa=(P&255)>>>1}else{sa=c[D>>2]|0}aa=c[g>>2]|0;oa=c[aa+12>>2]|0;ka=(oa|0)==(c[aa+16>>2]|0);if((sa|0)==0){if(ka){ja=ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;ta=ja;ua=a[z]|0}else{ta=c[oa>>2]|0;ua=$}if((ta|0)!=(c[((ua&1)==0?e:c[f>>2]|0)>>2]|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}ja=c[g>>2]|0;la=ja+12|0;va=c[la>>2]|0;if((va|0)==(c[ja+16>>2]|0)){ie[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[la>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){wa=(va&255)>>>1}else{wa=c[e>>2]|0}ca=M;da=r;ea=L;fa=wa>>>0>1?z:N;ga=O;break b}if(ka){ka=ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;xa=ka;ya=a[y]|0}else{xa=c[oa>>2]|0;ya=P}if((xa|0)!=(c[((ya&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=c[g>>2]|0;ka=oa+12|0;aa=c[ka>>2]|0;if((aa|0)==(c[oa+16>>2]|0)){ie[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[ka>>2]=aa+4}aa=a[y]|0;if((aa&1)==0){za=(aa&255)>>>1}else{za=c[D>>2]|0}ca=M;da=r;ea=L;fa=za>>>0>1?y:N;ga=O;break};case 4:{aa=M;ka=r;oa=L;va=0;la=O;c:while(1){ja=c[g>>2]|0;do{if((ja|0)==0){Aa=1}else{Ba=c[ja+12>>2]|0;if((Ba|0)==(c[ja+16>>2]|0)){Ca=ie[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ca=c[Ba>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Aa=1;break}else{Aa=(c[g>>2]|0)==0;break}}}while(0);ja=c[b>>2]|0;do{if((ja|0)==0){T=188}else{Ba=c[ja+12>>2]|0;if((Ba|0)==(c[ja+16>>2]|0)){Da=ie[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Da=c[Ba>>2]|0}if((Da|0)==-1){c[b>>2]=0;T=188;break}else{if(Aa){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Aa){break}}ja=c[g>>2]|0;Ba=c[ja+12>>2]|0;if((Ba|0)==(c[ja+16>>2]|0)){Ea=ie[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ea=c[Ba>>2]|0}if(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ea)|0){Ba=c[n>>2]|0;if((Ba|0)==(c[q>>2]|0)){_za(m,n,q);Fa=c[n>>2]|0}else{Fa=Ba}c[n>>2]=Fa+4;c[Fa>>2]=Ea;Ga=aa;Ha=ka;Ia=oa;Ja=va+1|0;Ka=la}else{Ba=a[w]|0;if((Ba&1)==0){La=(Ba&255)>>>1}else{La=c[K>>2]|0}if((La|0)==0|(va|0)==0){break}if((Ea|0)!=(c[v>>2]|0)){break}if((ka|0)==(oa|0)){Ba=ka-aa|0;ja=Ba>>>0<2147483647?Ba<<1:-1;if((la|0)!=293){Ma=aa}else{Ma=0}Na=cEa(Ma,ja)|0;if((Na|0)==0){T=206;break a}Oa=Na;Pa=Na+(Ba>>2<<2)|0;Qa=Na+(ja>>>2<<2)|0;Ra=268}else{Oa=aa;Pa=ka;Qa=oa;Ra=la}c[Pa>>2]=va;Ga=Oa;Ha=Pa+4|0;Ia=Qa;Ja=0;Ka=Ra}ja=c[g>>2]|0;Na=ja+12|0;Ba=c[Na>>2]|0;if((Ba|0)==(c[ja+16>>2]|0)){ie[c[(c[ja>>2]|0)+40>>2]&127](ja)|0;aa=Ga;ka=Ha;oa=Ia;va=Ja;la=Ka;continue}else{c[Na>>2]=Ba+4;aa=Ga;ka=Ha;oa=Ia;va=Ja;la=Ka;continue}}if((aa|0)==(ka|0)|(va|0)==0){Sa=aa;Ta=ka;Ua=oa;Va=la}else{if((ka|0)==(oa|0)){P=ka-aa|0;$=P>>>0<2147483647?P<<1:-1;if((la|0)!=293){Wa=aa}else{Wa=0}R=cEa(Wa,$)|0;if((R|0)==0){T=217;break a}Xa=R;Ya=R+(P>>2<<2)|0;Za=R+($>>>2<<2)|0;_a=268}else{Xa=aa;Ya=ka;Za=oa;_a=la}c[Ya>>2]=va;Sa=Xa;Ta=Ya+4|0;Ua=Za;Va=_a}$=c[B>>2]|0;if(($|0)>0){R=c[g>>2]|0;do{if((R|0)==0){$a=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){ab=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{ab=c[P>>2]|0}if((ab|0)==-1){c[g>>2]=0;$a=1;break}else{$a=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){bb=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{bb=c[va>>2]|0}if((bb|0)==-1){c[b>>2]=0;T=234;break}else{if($a){cb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if($a){T=240;break a}else{cb=0}}R=c[g>>2]|0;va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){db=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{db=c[va>>2]|0}if((db|0)!=(c[u>>2]|0)){T=240;break a}va=c[g>>2]|0;R=va+12|0;la=c[R>>2]|0;if((la|0)==(c[va+16>>2]|0)){ie[c[(c[va>>2]|0)+40>>2]&127](va)|0;eb=cb;fb=$;gb=cb}else{c[R>>2]=la+4;eb=cb;fb=$;gb=cb}while(1){la=c[g>>2]|0;do{if((la|0)==0){hb=1}else{R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){ib=ie[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{ib=c[R>>2]|0}if((ib|0)==-1){c[g>>2]=0;hb=1;break}else{hb=(c[g>>2]|0)==0;break}}}while(0);do{if((gb|0)==0){jb=eb;T=257}else{la=c[gb+12>>2]|0;if((la|0)==(c[gb+16>>2]|0)){kb=ie[c[(c[gb>>2]|0)+36>>2]&127](gb)|0}else{kb=c[la>>2]|0}if((kb|0)==-1){c[b>>2]=0;jb=0;T=257;break}else{if(hb^(eb|0)==0){lb=eb;mb=eb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(hb){T=263;break a}else{lb=jb;mb=0}}la=c[g>>2]|0;R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){nb=ie[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{nb=c[R>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,nb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){_za(m,n,q)}R=c[g>>2]|0;la=c[R+12>>2]|0;if((la|0)==(c[R+16>>2]|0)){ob=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{ob=c[la>>2]|0}la=c[n>>2]|0;c[n>>2]=la+4;c[la>>2]=ob;la=fb+ -1|0;c[B>>2]=la;R=c[g>>2]|0;va=R+12|0;oa=c[va>>2]|0;if((oa|0)==(c[R+16>>2]|0)){ie[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[va>>2]=oa+4}if((la|0)>0){eb=lb;fb=la;gb=mb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ca=Sa;da=Ta;ea=Ua;fa=N;ga=Va}break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}$=c[g>>2]|0;la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){pb=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{pb=c[la>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,pb)|0)){T=27;break a}la=c[g>>2]|0;$=la+12|0;oa=c[$>>2]|0;if((oa|0)==(c[la+16>>2]|0)){qb=ie[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[$>>2]=oa+4;qb=c[oa>>2]|0}Cua(A,qb);T=28;break};case 0:{T=28;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ca=M;da=r;ea=L;fa=0;ga=O;break b}}oa=a[x]|0;$=(oa&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=oa;vb=$}else{if((d[s+(o+ -1)|0]|0)<2){wb=oa;xb=$}else{sb=V;tb=V;ub=oa;vb=$;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}la=(Ab&1)==0;va=xb-(la?h:c[G>>2]|0)>>2;R=a[A]|0;ka=(R&1)==0;if(ka){Bb=(R&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(va>>>0>Bb>>>0)){if(ka){Cb=H+(((R&255)>>>1)-va<<2)|0;Db=H;Eb=(R&255)>>>1}else{aa=c[I>>2]|0;P=c[H>>2]|0;Cb=aa+(P-va<<2)|0;Db=aa;Eb=P}P=Db+(Eb<<2)|0;if((Cb|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=la?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}aa=Gb+4|0;if((aa|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=aa}}}while(0);sb=V;tb=V;ub=Ab;vb=la?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}$=c[g>>2]|0;do{if(($|0)==0){Jb=1}else{oa=c[$+12>>2]|0;if((oa|0)==(c[$+16>>2]|0)){Kb=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Kb=c[oa>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{$=c[tb+12>>2]|0;if(($|0)==(c[tb+16>>2]|0)){Mb=ie[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[$>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}$=c[g>>2]|0;la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){Pb=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Pb=c[la>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}la=c[g>>2]|0;$=la+12|0;oa=c[$>>2]|0;if((oa|0)==(c[la+16>>2]|0)){ie[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[$>>2]=oa+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=a[x]|0;if((oa&1)==0){Qb=h;Rb=(oa&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ca=M;da=r;ea=L;fa=N;ga=O}else{T=174;break a}break};default:{ca=M;da=r;ea=L;fa=N;ga=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){oa=c[g>>2]|0;do{if((oa|0)==0){Ub=1}else{$=c[oa+12>>2]|0;if(($|0)==(c[oa+16>>2]|0)){Vb=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Vb=c[$>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{oa=c[Tb+12>>2]|0;if((oa|0)==(c[Tb+16>>2]|0)){Xb=ie[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[oa>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ca=M;da=r;ea=L;fa=N;ga=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ca=M;da=r;ea=L;fa=N;ga=O;break g}else{Yb=Wb;Zb=0}}oa=c[g>>2]|0;$=c[oa+12>>2]|0;if(($|0)==(c[oa+16>>2]|0)){_b=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{_b=c[$>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ca=M;da=r;ea=L;fa=N;ga=O;break g}$=c[g>>2]|0;oa=$+12|0;la=c[oa>>2]|0;if((la|0)==(c[$+16>>2]|0)){$b=ie[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[oa>>2]=la+4;$b=c[la>>2]|0}Cua(A,$b);Sb=Yb;Tb=Zb}}}while(0);la=o+1|0;if(la>>>0<4){L=ea;r=da;M=ca;o=la;N=fa;O=ga}else{W=ca;X=da;Y=fa;Z=ga;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){mEa()}else if((T|0)==217){mEa()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Sa;cc=Va}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Sa;cc=Va}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Sa;cc=Va}else if((T|0)==276){i:do{if((Y|0)!=0){ga=Y+4|0;fa=Y+8|0;da=1;j:while(1){ca=a[Y]|0;if((ca&1)==0){dc=(ca&255)>>>1}else{dc=c[ga>>2]|0}if(!(da>>>0<dc>>>0)){break i}ca=c[g>>2]|0;do{if((ca|0)==0){ec=1}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){fc=ie[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ca=c[b>>2]|0;do{if((ca|0)==0){T=295}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){gc=ie[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ca=c[g>>2]|0;N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){hc=ie[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ga}else{ic=c[fa>>2]|0}if((hc|0)!=(c[ic+(da<<2)>>2]|0)){break}N=da+1|0;ca=c[g>>2]|0;o=ca+12|0;r=c[o>>2]|0;if((r|0)==(c[ca+16>>2]|0)){ie[c[(c[ca>>2]|0)+40>>2]&127](ca)|0;da=N;continue}else{c[o>>2]=r+4;da=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;Sza(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);yua(A);yua(z);yua(y);yua(x);Wta(w);if((bc|0)==0){i=p;return ac|0}fe[cc&511](bc);i=p;return ac|0}function Xza(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=293;v=n+400|0;Sua(q,h);n=q;w=c[n>>2]|0;if(!((c[31004]|0)==-1)){c[m>>2]=124016;c[m+4>>2]=291;c[m+8>>2]=0;Hta(124016,m,292)}m=(c[124020>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;GDa(z);A=139584;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;GDa(z);A=139584;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Wza(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){Cua(k,xe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Yza(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ie[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];mta(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&511](n);i=d;return}function Yza(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){Eua(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function Zza(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[30898]|0)==-1)){c[p>>2]=123592;c[p+4>>2]=291;c[p+8>>2]=0;Hta(123592,p,292)}p=(c[123596>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;GDa(C);D=139584;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;yua(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Bua(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;yua(s);c[f>>2]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}gua(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Wta(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}Bua(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;yua(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[30882]|0)==-1)){c[o>>2]=123528;c[o+4>>2]=291;c[o+8>>2]=0;Hta(123528,o,292)}o=(c[123532>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;GDa(H);I=139584;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;yua(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Bua(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;yua(x);c[f>>2]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}gua(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wta(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}Bua(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;yua(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function _za(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=293;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=cEa(m,l)|0;m=a;if((a|0)==0){mEa()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}fe[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=268;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function $za(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function aAa(a){a=a|0;i=i;return}function bAa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,123776,o|0)|0;do{if(s>>>0>99){do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Vxa(r,o,123776,n)|0;o=c[r>>2]|0;if((o|0)==0){mEa()}H=$Da(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}mEa()}else{I=0;J=0;K=q;L=s}}while(0);Sua(t,g);s=t;q=c[s>>2]|0;if(!((c[31006]|0)==-1)){c[p>>2]=124024;c[p+4>>2]=291;c[p+8>>2]=0;Hta(124024,p,292)}p=(c[124028>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;He[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cAa(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=$Da(V)|0;if((T|0)!=0){W=T;X=T;break}mEa()}else{W=0;X=t}}while(0);dAa(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];tqa(b,m,X,e,D,g,j);if((W|0)!=0){aEa(W)}Wta(A);Wta(z);Wta(y);mta(c[s>>2]|0)|0;if((J|0)!=0){aEa(J)}if((I|0)==0){i=d;return}aEa(I);i=d;return}function cAa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[30866]|0)==-1)){c[p>>2]=123464;c[p+4>>2]=291;c[p+8>>2]=0;Hta(123464,p,292)}p=(c[123468>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;GDa(I);J=139584;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;GDa(I);J=139584;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Wta(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Wta(v)}a[g]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Wta(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}gua(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Wta(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[30850]|0)==-1)){c[o>>2]=123400;c[o+4>>2]=291;c[o+8>>2]=0;Hta(123400,o,292)}o=(c[123404>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Wta(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}gua(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Wta(D)}a[g]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Wta(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}gua(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Wta(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function dAa(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){N=(J&255)>>>1}else{N=c[A>>2]|0}if((N|0)==0|x){L=H;break a}if(I){O=y;P=(J&255)>>>1}else{O=c[z>>2]|0;P=c[A>>2]|0}J=O+P|0;I=c[f>>2]|0;if((O|0)==(J|0)){Q=I}else{R=I;I=O;while(1){a[R]=a[I]|0;S=I+1|0;T=R+1|0;if((S|0)==(J|0)){Q=T;break}else{I=S;R=T}}}c[f>>2]=Q;L=H;break};case 1:{c[e>>2]=c[f>>2];R=xe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=R;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};case 4:{R=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){J=I;while(1){T=a[J]|0;if(!(T<<24>>24>-1)){U=J;break b}S=J+1|0;if((b[(c[F>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=J;break b}if(S>>>0<j>>>0){J=S}else{U=S;break}}}else{U=I}}while(0);J=U;if(B){if(U>>>0>I>>>0){S=I+(0-J)|0;J=S>>>0<G>>>0?G:S;S=J+s|0;T=R;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=T+1;a[T]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>I>>>0&Z)){break}T=c[f>>2]|0;W=Y;V=X}V=U+J|0;if(Z){_=V;$=S;aa=32}else{ba=0;ca=V;da=S}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;T=da;while(1){a[W]=ba;X=T+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){T=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(I|0)){W=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;T=c[f>>2]|0;c[f>>2]=T+1;a[T]=W}else{W=a[p]|0;T=(W&1)==0;if(T){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(T){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=o;T=ja+1|0;W=a[p]|0;S=(W&1)==0;if(S){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(T>>>0<ma>>>0)){na=ia;oa=T;pa=0;break}if(S){qa=C}else{qa=c[D>>2]|0}if((a[qa+T|0]|0)==127){na=-1;oa=T;pa=0;break}if(S){ra=C}else{ra=c[D>>2]|0}na=a[ra+T|0]|0;oa=T;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);T=ha+ -1|0;S=a[T]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=S;if((T|0)==(I|0)){break}else{ha=T;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((R|0)==(V|0)){L=I;break a}T=V+ -1|0;if(T>>>0>R>>>0){sa=R;ta=T}else{L=I;break a}while(1){T=a[sa]|0;a[sa]=a[ta]|0;a[ta]=T;T=sa+1|0;V=ta+ -1|0;if(T>>>0<V>>>0){ta=V;sa=T}else{L=I;break}}break};default:{L=H}}}while(0);I=h+1|0;if(I>>>0<4){H=L;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else if((xa|0)==16){i=t;return}else{c[e>>2]=d;i=t;return}}function eAa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Sua(m,g);z=m;A=c[z>>2]|0;if(!((c[31006]|0)==-1)){c[l>>2]=124024;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124024,l,292)}l=(c[124028>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(xe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;cAa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=$Da(P)|0;if((N|0)!=0){Q=N;R=N;break}mEa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}dAa(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];tqa(b,k,R,e,w,g,h);if((Q|0)==0){Wta(t);Wta(s);Wta(r);U=c[z>>2]|0;V=U;W=V;X=mta(W)|0;i=d;return}aEa(Q);Wta(t);Wta(s);Wta(r);U=c[z>>2]|0;V=U;W=V;X=mta(W)|0;i=d;return}function fAa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function gAa(a){a=a|0;i=i;return}function hAa(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,123776,o|0)|0;do{if(s>>>0>99){do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);o=c[30978]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Vxa(r,o,123776,n)|0;o=c[r>>2]|0;if((o|0)==0){mEa()}H=$Da(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}mEa()}else{J=0;K=0;L=q;M=s}}while(0);Sua(t,g);s=t;q=c[s>>2]|0;if(!((c[31004]|0)==-1)){c[p>>2]=124016;c[p+4>>2]=291;c[p+8>>2]=0;Hta(124016,p,292)}p=(c[124020>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;GDa(O);P=139584;Q=127;Td(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;GDa(O);P=139584;Q=127;Td(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;He[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;iAa(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=$Da(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}mEa()}else{X=0;Y=t}}while(0);jAa(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];cya(b,m,Y,e,D,g,j);if((X|0)!=0){aEa(X)}yua(A);yua(z);Wta(y);mta(c[s>>2]|0)|0;if((K|0)!=0){aEa(K)}if((J|0)==0){i=d;return}aEa(J);i=d;return}function iAa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[30898]|0)==-1)){c[p>>2]=123592;c[p+4>>2]=291;c[p+8>>2]=0;Hta(123592,p,292)}p=(c[123596>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;GDa(I);J=139584;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;GDa(I);J=139584;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;yua(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;yua(v)}c[g>>2]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Wta(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Bua(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;yua(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[30882]|0)==-1)){c[o>>2]=123528;c[o+4>>2]=291;c[o+8>>2]=0;Hta(123528,o,292)}o=(c[123532>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;GDa(N);O=139584;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;yua(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}Bua(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;yua(D)}c[g>>2]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}gua(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Wta(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}Bua(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;yua(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function jAa(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 1:{c[d>>2]=c[e>>2];E=xe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 3:{E=a[q]|0;F=(E&1)==0;if(F){G=(E&255)>>>1}else{G=c[t>>2]|0}if((G|0)==0){D=C;break a}if(F){H=t}else{H=c[u>>2]|0}F=c[H>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=F;D=C;break};case 4:{F=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){I=E;while(1){J=I+4|0;if(!(le[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[I>>2]|0)|0)){K=I;break b}if(J>>>0<h>>>0){I=J}else{K=J;break}}}else{K=E}}while(0);if(y){do{if(K>>>0>E>>>0){I=c[e>>2]|0;J=K;L=r;while(1){M=J+ -4|0;N=I+4|0;c[I>>2]=c[M>>2];O=L+ -1|0;P=(O|0)>0;if(M>>>0>E>>>0&P){L=O;J=M;I=N}else{break}}c[e>>2]=N;if(P){Q=M;R=O;S=34;break}I=c[e>>2]|0;c[e>>2]=I+4;T=I;U=M}else{Q=K;R=r;S=34}}while(0);do{if((S|0)==34){S=0;I=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;L=J+4|0;c[e>>2]=L;if((R|0)>0){V=L;W=J;X=R}else{T=J;U=Q;break}while(1){c[W>>2]=I;L=X+ -1|0;if((L|0)>0){X=L;W=V;V=V+4|0}else{break}}c[e>>2]=J+(R+1<<2);T=J+(R<<2)|0;U=Q}}while(0);c[T>>2]=m;Y=U}else{Y=K}if((Y|0)==(E|0)){I=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;L=c[e>>2]|0;Z=L+4|0;c[e>>2]=Z;c[L>>2]=I;_=Z}else{Z=a[o]|0;I=(Z&1)==0;if(I){$=(Z&255)>>>1}else{$=c[B>>2]|0}if(($|0)==0){aa=Y;ba=-1;ca=0;da=0}else{if(I){ea=z}else{ea=c[A>>2]|0}aa=Y;ba=a[ea]|0;ca=0;da=0}while(1){I=c[e>>2]|0;do{if((da|0)==(ba|0)){Z=I+4|0;c[e>>2]=Z;c[I>>2]=n;L=ca+1|0;fa=a[o]|0;ga=(fa&1)==0;if(ga){ha=(fa&255)>>>1}else{ha=c[B>>2]|0}if(!(L>>>0<ha>>>0)){ia=Z;ja=ba;ka=L;la=0;break}if(ga){ma=z}else{ma=c[A>>2]|0}if((a[ma+L|0]|0)==127){ia=Z;ja=-1;ka=L;la=0;break}if(ga){na=z}else{na=c[A>>2]|0}ia=Z;ja=a[na+L|0]|0;ka=L;la=0}else{ia=I;ja=ba;ka=ca;la=da}}while(0);I=aa+ -4|0;J=c[I>>2]|0;L=ia+4|0;c[e>>2]=L;c[ia>>2]=J;if((I|0)==(E|0)){_=L;break}else{aa=I;ba=ja;ca=ka;da=la+1|0}}}if((F|0)==(_|0)){D=E;break a}I=_+ -4|0;if(I>>>0>F>>>0){oa=F;pa=I}else{D=E;break a}while(1){I=c[oa>>2]|0;c[oa>>2]=c[pa>>2];c[pa>>2]=I;I=oa+4|0;L=pa+ -4|0;if(I>>>0<L>>>0){pa=L;oa=I}else{D=E;break}}break};case 2:{E=a[p]|0;F=(E&1)==0;if(F){qa=(E&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){D=C;break a}if(F){ra=w;sa=(E&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}E=ra+(sa<<2)|0;F=c[e>>2]|0;if((ra|0)==(E|0)){ta=F}else{I=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;L=F;J=ra;while(1){c[L>>2]=c[J>>2];Z=J+4|0;if((Z|0)==(E|0)){break}L=L+4|0;J=Z}ta=F+(I+1<<2)|0}c[e>>2]=ta;D=C;break};default:{D=C}}}while(0);J=g+1|0;if(J>>>0<4){C=D;g=J}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function kAa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Sua(m,g);z=m;A=c[z>>2]|0;if(!((c[31004]|0)==-1)){c[l>>2]=124016;c[l+4>>2]=291;c[l+8>>2]=0;Hta(124016,l,292)}l=(c[124020>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;GDa(D);E=139584;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(xe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;iAa(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=$Da(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}mEa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}jAa(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];cya(b,k,R,e,w,g,h);if((Q|0)==0){yua(t);yua(s);Wta(r);U=c[z>>2]|0;V=U;W=V;X=mta(W)|0;i=d;return}aEa(Q);yua(t);yua(s);Wta(r);U=c[z>>2]|0;V=U;W=V;X=mta(W)|0;i=d;return}function lAa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function mAa(a){a=a|0;i=i;return}function nAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function oAa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{mua(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=yd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=DEa(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Wta(j);i=d;return}do{mua(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Wta(j);i=d;return}function pAa(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function qAa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function rAa(a){a=a|0;i=i;return}function sAa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function tAa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=125680;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=125680|0;while(1){c[m>>2]=y;A=(Ge[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{mua(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}Oza(124904)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=yd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=125784;D=DEa(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Wta(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=125784|0;while(1){c[q>>2]=o;h=(Ge[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{Cua(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){Oza(124904)}else if((E|0)==25){Wta(r);i=d;return}}function uAa(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function vAa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=124112;e=b+8|0;b=c[e>>2]|0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);if((b|0)==(c[30978]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function wAa(a){a=a|0;a=Ec(8)|0;nta(a,123904);c[a>>2]=120872;Td(a|0,120912,40)}



function kqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;u9();do{if((wra(a,b)|0)==0){if((yra(a,b)|0)!=0){break}do{if((c[106848>>2]|0)!=0){w=c[106976>>2]|0;if((zEa(w,98440)|0)==0){A9(1);break}if((zEa(w,98448)|0)==0){A9(0);break}else{c[p>>2]=w;F9(1,0,98456,p);ud(0)|0;Cd(0)}}}while(0);if((c[106804>>2]|0)==0){_pa(0,0);Ica(d);if((d|0)==0){hwa(dqa(119384,98824)|0,103)|0}c[d+300>>2]=aqa(0,0)|0;c[d+292>>2]=cqa(0,0)|0;Oia(d+8|0,d+240|0);Oca(d)|0;Wca(d)|0;gda(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}hwa(dqa(119384,98888)|0,103)|0;x=1;i=e;return x|0}}while(0);c[24296]=c[106872>>2];x=0;i=e;return x|0}Qta(u,c[106932>>2]|0);w=1;while(1){y=54832+(w<<2)|0;Qta(v,c[y>>2]|0);z=$pa(u,v)|0;Wta(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=rua(u)|0;F9(1,0,98728,g);c[f>>2]=c[b>>2];F9(1,0,98768,f);ud(0)|0;Cd(0)}A=c[58856+(w<<2)>>2]|0;do{if((A|0)==1){z=c[58728+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;D9(1,1,98528,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[58728+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;D9(1,1,98568,n);break}else{c[m>>2]=z;F9(1,1,98408,m);break}}}while(0);if((w|0)==11){A=1;do{z=c[98696+(A<<2)>>2]|0;c[j>>2]=c[98664+(A<<2)>>2];c[j+4>>2]=z;D9(1,0,97232,j);A=A+1|0;}while((A|0)<7);D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==29){A=1;do{z=c[98240+(A<<2)>>2]|0;c[h>>2]=c[98128+(A<<2)>>2];c[h+4>>2]=z;D9(1,0,97232,h);A=A+1|0;}while((A|0)<20);D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==7){A=1;do{z=c[98648+(A<<2)>>2]|0;c[k>>2]=c[98632+(A<<2)>>2];c[k+4>>2]=z;D9(1,0,97232,k);A=A+1|0;}while((A|0)<4);D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else if((w|0)==19){A=c[12036]|0;if((A|0)<28){G=A}else{D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}do{A=c[49728+(G<<2)>>2]|0;c[l>>2]=c[48560+(G<<2)>>2];c[l+4>>2]=A;D9(1,0,97232,l);G=G+1|0;}while((G|0)<28);D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}else{D=50408;E=c[12602]|0;fe[E&511](1);F=ud(0)|0;Cd(0)}}}while(0);c[t>>2]=c[b>>2];D9(1,1,98344,t);t=1;do{b=c[58856+(t<<2)>>2]|0;do{if((b|0)==1){F=c[56736+(t<<2)>>2]|0;c[s>>2]=c[54832+(t<<2)>>2];c[s+4>>2]=F;D9(1,0,98360,s)}else{F=c[54832+(t<<2)>>2]|0;if((b|0)==2){E=c[56736+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;D9(1,0,98376,r);break}else{c[q>>2]=F;F9(1,0,98408,q);break}}}while(0);t=t+1|0;}while((t|0)<31);fe[c[12602]&511](1);ud(0)|0;Cd(0);return 0}function lqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[24730]|0;tb(100504)|0;c[l>>2]=c[m+88>>2];gc(98928,l|0)|0;tb(100520)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gc(98952,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(98992,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(99024,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(99056,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];gc(99088,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gc(99120,b|0)|0;tb(100544)|0;i=a;return}function mqa(a,b){a=a|0;b=+b;i=i;return}function nqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;CEa(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=QEa(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=QEa(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[24730]=d;u=0;Ha(61,10,287)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=QEa(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=QEa(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=QEa(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=QEa(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=QEa(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=QEa(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(288,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=QEa(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=QEa(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=QEa(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function oqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=md(c[11942]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[49868>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(99192,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Sd(10,a|0)|0;ud(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 3:{if((c[49924>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;rc(99192,7,1,n|0)|0;Dc(n|0,d|0,f|0)|0;Sd(10,n|0)|0;ud(0)|0;i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(99192,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Sd(10,e|0)|0;ud(0)|0;eb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};default:{H9(g,99200,b)}}}function pqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(99176,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Sd(10,d|0)|0;ud(0)|0;i=a;return}function qqa(a,b){a=a|0;b=b|0;var c=0;c=i;sqa(a,b);i=c;return}function rqa(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function sqa(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=Pua(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function tqa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;pfa(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=uqa(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if(($ua(b,d,r)|0)==(r|0)){break}pfa(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){Rta(l,s,h);if(($ua(b,Vta(l)|0,s)|0)==(s|0)){Wta(l);break}pfa(m);c[o>>2]=0;c[a>>2]=0;Wta(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if(($ua(b,e,l)|0)==(l|0)){break}pfa(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);vqa(g,0)|0;c[a>>2]=b;i=j;return}function uqa(a){a=a|0;i=i;return c[a+12>>2]|0}function vqa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function wqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;xqa(g,16);yqa(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){zqa(a,g);Aqa(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){dqa(iwa(m,+h[b+(p<<3)>>3])|0,100560)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){iwa(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){dqa(m,100568)|0}}while((e|0)<(d|0));zqa(a,g);Aqa(g);i=f;return}function xqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;Tua(e);f=a;c[f>>2]=100940;g=e;c[g>>2]=100960;e=a+4|0;_va(a,100972|0,e);c[f>>2]=100940;c[g>>2]=100960;Mqa(e,b|16);i=d;return}function yqa(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function zqa(a,b){a=a|0;b=b|0;var c=0;c=i;Gqa(a,b+4|0);i=c;return}function Aqa(a){a=a|0;var b=0;b=i;Qqa(a,100968);Oua(a+56|0);i=b;return}function Bqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[49912>>2]|0)!=0){tb(101264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(14,0,100576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(14,0,100648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[49912>>2]|0)==0){i=d;return 0}D9(14,0,100696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(100712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function Cqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[49912>>2]|0)!=0){tb(101264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(14,0,100576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(14,0,100648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[49912>>2]|0)==0){i=d;return 0}D9(14,0,100696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(100712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function Dqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[49912>>2]|0)!=0){tb(101264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(14,0,100576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(14,0,100648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[49912>>2]|0)==0){i=d;return 0}D9(14,0,100696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(100712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function Eqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[49912>>2]|0)!=0){tb(101264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(14,0,100576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(14,0,100648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[49912>>2]|0)==0){i=d;return 0}D9(14,0,100696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(100712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function Fqa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=bEa(fa(F,F)|0,8)|0;J=I;K=bEa(fa(G,F)|0,8)|0;L=K;M=bEa(fa(H,F)|0,8)|0;N=M;O=bEa(fa(H,G)|0,8)|0;P=O;Kta(p);Kta(q);Kta(r);Kta(s);Kta(t);Kta(u);Kta(v);Q=a+536|0;G9(c[Q>>2]|0,(I|0)!=0|0,100720,o);G9(c[Q>>2]|0,(K|0)!=0|0,100720,n);G9(c[Q>>2]|0,(M|0)!=0|0,100720,m);G9(c[Q>>2]|0,(O|0)!=0|0,100720,l);l=a+540|0;m=a;if((ie[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;Bqa(a,J)|0;G9(n,1,100736,k)}wqa(w,J,F,F);Xta(p,w)|0;Wta(w);if((ie[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;Cqa(a,L)|0;G9(w,1,100768,j)}wqa(x,L,F,G);Xta(q,x)|0;Wta(x);if((ie[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;Dqa(a,N)|0;G9(x,1,100800,h)}wqa(y,N,H,F);Xta(r,y)|0;Wta(y);if((ie[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;Eqa(a,P)|0;G9(m,1,100832,g)}wqa(z,P,H,G);Xta(s,z)|0;Wta(z);if((F|0)==0){Yta(t,100864)|0}else{wqa(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Xta(t,A)|0;Wta(A)}if((G|0)==0){Yta(u,100864)|0}else{wqa(B,c[a+432>>2]|0,1,G);Xta(u,B)|0;Wta(B)}aEa(I);aEa(K);aEa(M);aEa(O);Qta(E,c[a+84>>2]|0);Fua(D,100880,E);Ria(C,D,100888);Xta(v,C)|0;Wta(C);Wta(D);Wta(E);E=ic(rua(v)|0,100896)|0;D=c[Q>>2]|0;c[f>>2]=rua(v)|0;G9(D,(E|0)!=0|0,100904,f);f=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;D=rua(t)|0;Q=rua(u)|0;C=rua(p)|0;a=rua(q)|0;O=rua(r)|0;M=rua(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;wd(E|0,f|0,e|0)|0;if((c[49956>>2]|0)==0){R=ud(E|0)|0;S=Yc(E|0)|0;Wta(v);Wta(u);Wta(t);Wta(s);Wta(r);Wta(q);Wta(p);i=b;return 0}e=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;l=rua(t)|0;f=rua(u)|0;M=rua(p)|0;O=rua(q)|0;a=rua(r)|0;C=rua(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;D9(25,0,e,d);R=ud(E|0)|0;S=Yc(E|0)|0;Wta(v);Wta(u);Wta(t);Wta(s);Wta(r);Wta(q);Wta(p);i=b;return 0}function Gqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=hva(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}Hqa(a,gva(l)|0,n,e);i=d;return}if((h&8|0)==0){Lta(a,g);i=d;return}else{g=b;b=bva(g)|0;Hqa(a,b,dva(g)|0,f);i=d;return}}function Hqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Iqa(a,b,c,0);i=d;return}function Iqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Jqa(a,b,c);i=d;return}function Jqa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=Kqa(c,d)|0;if(g>>>0>4294967279){Ita(0)}if(g>>>0<11){aua(b,g);h=$ta(b)|0}else{j=hua(g)|0;k=j+1|0;j=Bja(Pta(b)|0,k)|0;jua(b,j);iua(b,k);_ta(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;Cja(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){Cja(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;Cja(l,f);i=e;return}function Kqa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Lqa(b,c,e)|0;i=d;return g|0}function Lqa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function Mqa(a,b){a=a|0;b=b|0;var c=0;c=i;ara(a,b);i=c;return}function Nqa(a){a=a|0;var b=0;b=i;Aqa(a);hEa(a);i=b;return}function Oqa(a){a=a|0;var b=0;b=i;Aqa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Pqa(a){a=a|0;var b=0;b=i;Nqa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Qqa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Rqa(a+4|0);i=d;return}function Rqa(a){a=a|0;var b=0;b=i;Sqa(a);i=b;return}function Sqa(a){a=a|0;var b=0;b=i;c[a>>2]=101120;Wta(a+32|0);Xua(a);i=b;return}function Tqa(a){a=a|0;var b=0;b=i;Rqa(a);hEa(a);i=b;return}function Uqa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=hva(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){Dea(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}Dea(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=hva(l)|0;j=m-(gva(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=cva(l)|0;m=j-(bva(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(Vta(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){Dea(a,-1,-1);i=h;return}q=NEa(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(Vta(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((cva(l)|0)!=0){break}Dea(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((hva(l)|0)!=0){break}Dea(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=bva(l)|0;fva(l,p,p+q|0,n)}if((g&16|0)!=0){p=gva(l)|0;kva(l,p,iva(l)|0);jva(l,q)}Dea(a,q,e);i=h;return}}while(0);Dea(a,-1,-1);i=h;return}function Vqa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=Rfa(d)|0;re[g&31](a,b,h,J,0,e);i=f;return}function Wqa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=hva(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((dva(g)|0)>>>0<j>>>0){b=bva(g)|0;fva(g,b,cva(g)|0,j)}j=cva(g)|0;if(!(j>>>0<(dva(g)|0)>>>0)){k=-1;i=d;return k|0}k=nga(a[j]|0)|0;i=d;return k|0}function Xqa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=hva(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=bva(h)|0;j=cva(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(jga(d,-1)|0){fva(h,g,j+ -1|0,k);l=mga(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=kga(d)|0;do{if(g){if(oga(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=bva(h)|0;fva(h,j,(cva(h)|0)+ -1|0,k);a[cva(h)|0]=b;l=d;i=e;return l|0}function Yqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(jga(b,-1)|0){f=mga(b)|0;i=d;return f|0}g=a;h=cva(g)|0;j=h-(bva(g)|0)|0;h=hva(g)|0;do{if((h|0)==(iva(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=gva(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;mua(o,0);fua(o,cua(o)|0);p=Vta(o)|0;kva(g,p,p+(Uta(o)|0)|0);jva(g,h-l|0);c[m>>2]=(gva(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(hva(g)|0)+1;h=c[(Zqa(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=Vta(a+32|0)|0;fva(g,q,q+j|0,h)}f=_ua(g,b&255)|0;i=d;return f|0}function Zqa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=_qa(b,c,e)|0;i=d;return g|0}function _qa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=$qa(0,a,b)|0;i=c;return(d?b:a)|0}function $qa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function ara(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;ava(a);c[a>>2]=101120;Kta(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;Kta(e);bra(a,e);Wta(e);i=d;return}function bra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Xta(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=Vta(e)|0;j=g+(Uta(e)|0)|0;c[b>>2]=j;g=Vta(e)|0;fva(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=Uta(e)|0;c[b>>2]=(Vta(e)|0)+h;fua(e,cua(e)|0);b=a;a=Vta(e)|0;kva(b,a,a+(Uta(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}jva(b,h);i=d;return}function cra(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ic(d|0,101544)|0;J=bd(101552,101544)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Wd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;G9(M,(I|0)!=0|0,101608,E);rc(101632,17,1,J|0)|0;rc(101656,10,1,J|0)|0;rc(101672,18,1,J|0)|0;dra(J,f,101696,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,101728)}else{c[G>>2]=Wd(c[L>>2]|0)|0;F9(26,0,101560,G);G=c[b+536>>2]|0;E=Wd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;G9(G,(I|0)!=0|0,101608,F)}rc(101736,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Wd(c[L>>2]|0)|0;F9(26,0,102088,D);Yc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(101288,250,102112,kd(H|0)|0)|0)==0){F9(26,0,102136,C);Yc(I|0)|0;O=1;i=j;return O|0}rc(102160,13,1,I|0)|0;rc(102176,12,1,I|0)|0;era(I,2);rc(102192,6,1,I|0)|0;fra(I,c[b+84>>2]|0);rc(102200,8,1,I|0)|0;era(I,2);rc(102216,8,1,I|0)|0;C=b+88|0;fra(I,c[C>>2]|0);rc(102232,10,1,I|0)|0;era(I,2);rc(102248,6,1,I|0)|0;fra(I,101288);rc(102256,8,1,I|0)|0;era(I,2);rc(102272,8,1,I|0)|0;fra(I,c[b+280>>2]|0);rc(102288,10,1,I|0)|0;era(I,2);rc(102304,14,1,I|0)|0;fra(I,c[b+284>>2]|0);rc(102320,16,1,I|0)|0;era(I,2);rc(102344,16,1,I|0)|0;fra(I,l);rc(102368,18,1,I|0)|0;era(I,2);c[B>>2]=gra(l)|0;wd(I|0,102392,B|0)|0;era(I,2);P=+Qaa(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(I|0,102432,A|0)|0;era(I,2);P=+Qaa(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];wd(I|0,102472,z|0)|0;era(I,2);P=+Qaa(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(I|0,102504,y|0)|0;era(I,2);P=+Qaa(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(I|0,102536,x|0)|0;era(I,2);P=+Qaa(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(I|0,102568,w|0)|0;era(I,2);P=+Qaa(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(I|0,102600,v|0)|0;era(I,2);P=+Qaa(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(I|0,102640,u|0)|0;era(I,2);P=+Taa(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];wd(I|0,102672,t|0)|0;era(I,2);c[s>>2]=Oaa(2)|0;wd(I|0,102712,s|0)|0;era(I,2);P=+Saa(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];wd(I|0,102736,r|0)|0;rc(102768,13,1,I|0)|0;rc(102784,16,1,I|0)|0;era(I,2);P=+Qaa(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];wd(I|0,102808,q|0)|0;era(I,2);c[p>>2]=Laa(8)|0;wd(I|0,102832,p|0)|0;rc(102872,17,1,I|0)|0;rc(102896,22,1,I|0)|0;hra(I,b);rc(102920,23,1,I|0)|0;rc(102944,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{ira(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{ira(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{ira(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{ira(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{ira(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{ira(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{ira(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{ira(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(102960,13,1,I|0)|0;rc(102976,12,1,I|0)|0;jra(I,J,f,c[C>>2]|0,b);rc(102992,13,1,I|0)|0;rc(103008,12,1,I|0)|0;kra(I,c[b+68>>2]|0,b+56|0);rc(103024,13,1,I|0)|0;rc(103040,16,1,I|0)|0;lra(I,J,f,b);rc(103064,17,1,I|0)|0;rc(103088,14,1,I|0)|0;Yc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((DEa(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(DEa(K|0)|0)<<1}else{Q=0}I=$Da(b+Q|0)|0;if((I|0)==0){cb(103104,103112,404,103136)}if((ab(J|0)|0)!=0){F9(26,0,103152,o)}if(e){e=c[C>>2]|0;c[n>>2]=103184;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;hc(I|0,103200,n|0)|0;if((rd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=103280|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;F9(1,0,103312,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;D9(1,0,103376,g);aEa(I);O=0;i=j;return O|0}function dra(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Maa(F)|0;H=Naa(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Saa(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(101632,17,1,a|0)|0;rc(104544,12,1,a|0)|0;rc(104560,12,1,a|0)|0;rc(104576,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;wd(a|0,104592,D|0)|0;rc(104632,10,1,a|0)|0;rc(104648,11,1,a|0)|0;rc(104664,11,1,a|0)|0;rc(104680,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];wd(a|0,104696,C|0)|0}else{rc(104720,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;wd(a|0,104320,B|0)|0;rc(104744,13,1,a|0)|0;if(E){rc(104560,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(a|0,104760,A|0)|0}else{rc(104720,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;wd(a|0,104784,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;wd(a|0,104440,y|0)|0;rc(104832,10,1,a|0)|0;rc(104848,10,1,a|0)|0;rc(104832,10,1,a|0)|0;rc(104864,11,1,a|0)|0;c[x>>2]=b;wd(a|0,104880,x|0)|0;c[w>>2]=d;wd(a|0,104904,w|0)|0;rc(104920,33,1,a|0)|0;rc(104960,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;wd(a|0,105e3,v|0)|0;rc(104680,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(a|0,104696,u|0)|0}else{rc(104848,10,1,a|0)|0;rc(104832,10,1,a|0)|0;rc(104864,11,1,a|0)|0;c[t>>2]=b;wd(a|0,104880,t|0)|0;c[s>>2]=d;wd(a|0,104904,s|0)|0;rc(104920,33,1,a|0)|0;rc(104960,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;wd(a|0,105e3,r|0)|0;rc(104680,10,1,a|0)|0;rc(104720,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;wd(a|0,104320,q|0)|0;rc(104744,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];wd(a|0,104760,p|0)|0}else{rc(104720,17,1,a|0)|0}rc(105032,32,1,a|0)|0;rc(105072,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;wd(a|0,105104,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;wd(a|0,104440,n|0)|0;i=m;return}function era(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Sd(32,a|0)|0;}while((d|0)!=0);i=c;return}function fra(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==34){rc(104312,6,1,b|0)|0}else if((e|0)==60){rc(104288,4,1,b|0)|0}else if((e|0)==62){rc(104296,4,1,b|0)|0}else if((e|0)==39){rc(104304,6,1,b|0)|0}else{Sd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function gra(a){a=a|0;var b=0,c=0,d=0;b=i;c=ic(a|0,104280)|0;if((c|0)==0){d=-1;i=b;return d|0}Wc(c|0,0,2)|0;a=yb(c|0)|0;Yc(c|0)|0;d=a;i=b;return d|0}function hra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=$Da((DEa(l|0)|0)+15|0)|0;c[f>>2]=l;hc(m|0,104008,f|0)|0;era(a,2);rc(104024,10,1,a|0)|0;fra(a,m);rc(104040,12,1,a|0)|0;era(a,2);c[e>>2]=gra(m)|0;wd(a|0,104056,e|0)|0;aEa(m);era(a,2);rc(104088,9,1,a|0)|0;era(a,4);rc(104104,22,1,a|0)|0;era(a,4);rc(104128,22,1,a|0)|0;era(a,4);rc(104152,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){nra(g,m,n);o=c[l>>2]|0;era(a,4);rc(104184,8,1,a|0)|0;fra(a,o);rc(104200,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{sra(h,m,l);g=c[n>>2]|0;era(a,4);rc(104184,8,1,a|0)|0;fra(a,g);rc(104200,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{nra(j,m,q);b=c[t>>2]|0;era(a,4);rc(104224,8,1,a|0)|0;fra(a,b);rc(104240,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){era(a,2);v=104264;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{sra(k,m,s);e=c[u>>2]|0;era(a,4);rc(104224,8,1,a|0)|0;fra(a,e);rc(104240,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));era(a,2);v=104264;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function ira(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;era(a,2);c[f>>2]=c[b>>2];wd(a|0,103944,f|0)|0;fra(a,c[b+4>>2]|0);rc(103976,11,1,a|0)|0;fra(a,c[b+8>>2]|0);rc(103648,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];mra(a,4,e);era(a,2);rc(103992,12,1,a|0)|0;i=d;return}function jra(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{nra(p,r,v);dra(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,103760);w=v+9|0;Waa(w);era(a,2);c[o>>2]=c[f>>2];wd(a|0,103768,o|0)|0;era(a,4);rc(102192,6,1,a|0)|0;fra(a,c[s>>2]|0);rc(102200,8,1,a|0)|0;era(a,4);c[n>>2]=Oaa(w)|0;wd(a|0,103544,n|0)|0;era(a,4);x=+Taa(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(a|0,103568,m|0)|0;era(a,4);x=+Saa(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(a|0,102736,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];mra(a,6,j);era(a,2);rc(103792,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function kra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{era(a,2);rra(l,d,x);c[j>>2]=c[q>>2];wd(a|0,103616,j|0)|0;rra(m,d,x);fra(a,c[r>>2]|0);rc(103648,3,1,a|0)|0;era(a,4);rc(103656,7,1,a|0)|0;rra(n,d,x);if((c[s>>2]|0)>0){y=0;do{era(a,6);c[g>>2]=0;wd(a|0,103664,g|0)|0;y=y+1|0;rra(n,d,x);}while((y|0)<(c[s>>2]|0))}era(a,4);rc(103688,8,1,a|0)|0;era(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;rra(o,d,x);z=+Qaa(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;rra(p,d,x);A=Laa(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;wd(a|0,103704,f|0)|0;era(a,2);rc(103744,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function lra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{sra(n,o,v-u|0);dra(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,103496);q=v+9|0;Waa(q);era(a,2);rc(103504,15,1,a|0)|0;era(a,4);c[m>>2]=c[e>>2];wd(a|0,103520,m|0)|0;era(a,4);c[l>>2]=Oaa(q)|0;wd(a|0,103544,l|0)|0;era(a,4);w=+Taa(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(a|0,103568,j|0)|0;era(a,4);w=+Saa(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];wd(a|0,102736,g|0)|0;era(a,2);rc(103592,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function mra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;era(a,b);rc(103808,16,1,a|0)|0;fra(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?103912:103928;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;wd(a|0,103832,f|0)|0;i=e;return}function nra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){ora(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function ora(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ic(c[o>>2]|0,105144)|0;if((p|0)!=0){q=p;break}p=Wd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;H9(0,105152,g)}else{q=0}}while(0);g=y4(0)|0;if((g|0)==0){H9(0,105184,f)}f=a+8|0;c[a+20>>2]=bEa(c[f>>2]|0,32)|0;p=a+12|0;o=bEa((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=105216;c[o+12>>2]=0;c[o+16>>2]=0;J4(g,h);K4(g,9,65);h=c[n>>2]|0;do{if((h|0)==0){o=j;HEa(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((L4(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=T4(Q4(g)|0)|0;s=R4(g)|0;Yc(q|0)|0;F4(g);r=c[a>>2]|0;c[e>>2]=105320;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;H9(0,105256,e)}else if((t|0)==11){Yc(q|0)|0;break}}else{if((L4(g,h,DEa(h|0)|0,1)|0)!=0){break}s=T4(Q4(g)|0)|0;o=R4(g)|0;F4(g);r=c[n>>2]|0;c[d>>2]=105320;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;H9(0,105360,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(105424,105320,295,105464)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(105488,105320,297,105464)}}function pra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((zEa(105896,b)|0)==0){if((zEa(c[d>>2]|0,105904)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}G9(0,p,105912,l);l=c[26438]|0;p=c[26492]|0;do{if((l|0)==0|(p|0)==0){c[26492]=32;a=$Da(1152)|0;c[26438]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[26492]=p<<1;a=cEa(l,p*72|0)|0;c[26438]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(vra(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((zEa(105976,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((zEa(105984,u)|0)==0){c[26498]=Ad(c[t+4>>2]|0)|0}else{if((zEa(106016,u)|0)==0){c[105996>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((zEa(106032,u)|0)==0){c[106004>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((zEa(106040,u)|0)==0){c[106e3>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((zEa(106056,u)|0)==0){c[106008>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((zEa(106064,u)|0)!=0){v=23;break a}c[106012>>2]=(zEa(c[t+4>>2]|0,106080)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];H9(0,106088,k)}else if((v|0)==45){i=e;return}}if((zEa(105736,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=105320;c[j+4>>2]=k;c[j+8>>2]=v;H9(0,106120,j)}if((zEa(106184,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=105320;c[h+4>>2]=j;H9(0,106192,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=105320;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;H9(0,106248,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=106312;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((zEa(105680,b)|0)!=0){if((zEa(105872,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=106416;m=Ad(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=106424;i=e;return}c[105700>>2]=0;c[105704>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((zEa(m,105904)|0)==0){c[105700>>2]=Ad(c[b+4>>2]|0)|0}else{if((zEa(m,106368)|0)!=0){break}c[105704>>2]=Ad(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[105700>>2]|0)==0){w=0;break}w=(c[105704>>2]|0)!=0|0}}while(0);G9(0,w,106376,f);c[26424]=-1;f=105708|0;w=105992;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function qra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((zEa(105680,b)|0)==0){o=e+0|0;p=105696|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));ura(e);i=d;return}if((zEa(105736,b)|0)==0){e=h+24|0;r=$Da((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=$Da(36)|0;t=s;o=s+0|0;p=(c[26438]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((zEa(105760,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Bd(e+(k*20|0)+8|0,105768,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((zEa(105808,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Bd(h+(k*20|0)+8|0,105824,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((zEa(105872,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function rra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){ora(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function sra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){ora(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;H9(0,105528,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=105608;p=o;H9(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=105608;p=o;H9(0,p,f)}}function tra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){aEa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){aEa(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}aEa(k);c[d>>2]=0;i=b;return}function ura(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=$Da(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=DEa(f|0)|0;c[e+64>>2]=k;k=c[26472]|0;do{if((k|0)==0){c[26472]=e;c[e+44>>2]=0;l=$Da(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=$Da(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{HEa(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[26472]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[26472]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=DEa(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(DEa(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 3:{B=o;C=x;D=y;E=20;break};case 10:{F=o;E=13;break};case 6:{G=o;H=y;E=17;break};case 9:{I=o;E=14;break};case 5:{J=o;K=y;E=18;break};case 4:{L=o;M=y;E=19;break};case 1:{N=o;O=x;P=y;E=22;break};case 7:{Q=o;R=y;E=16;break};case 8:{S=o;E=15;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;F=z;E=13;break};case 2:{T=o;U=x;V=y;E=21;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+F|0;c[p>>2]=o;I=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+I|0;c[p>>2]=o;S=o;E=15}if((E|0)==15){Q=S;R=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){G=Q;H=((d[A+6|0]|0)<<16)+R|0;E=17}if((E|0)==17){J=G;K=((d[A+5|0]|0)<<8)+H|0;E=18}if((E|0)==18){L=J;M=(d[A+4|0]|0)+K|0;E=19}if((E|0)==19){B=L;C=((d[A+3|0]|0)<<24)+x|0;D=M;E=20}if((E|0)==20){T=B;U=((d[A+2|0]|0)<<16)+C|0;V=D;E=21}if((E|0)==21){N=T;O=((d[A+1|0]|0)<<8)+U|0;P=V;E=22}if((E|0)==22){W=N;X=(d[A]|0)+O|0;Y=P}P=X-Y-W^W>>>13;X=Y-W-P^P<<8;Y=W-P-X^X>>>13;W=P-X-Y^Y>>>12;P=X-Y-W^W<<16;X=Y-W-P^P>>>5;Y=W-P-X^X>>>3;W=P-X-Y^Y<<10;P=X-Y-W^W>>>15;c[p>>2]=P;p=(c[26472]|0)+40|0;W=c[p>>2]|0;Y=P&(c[W+4>>2]|0)+ -1;P=c[W>>2]|0;W=P+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[P+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[26472]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[26472]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=$Da((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}HEa(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;P=c[j>>2]|0;c[Y+24>>2]=(((P<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((P|0)==0){_=e}else{P=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=P}else{W=P;X=j;while(1){j=X+16|0;O=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];N=Z+(A*12|0)+4|0;E=(c[N>>2]|0)+1|0;c[N>>2]=E;V=c[W+24>>2]|0;if(E>>>0>V>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[N>>2]|0)>>>0)/(V>>>0)|0}c[X+12>>2]=0;V=Z+(A*12|0)|0;c[j>>2]=c[V>>2];j=c[V>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[V>>2]=X;V=c[h>>2]|0;if((O|0)==0){$=V;break}else{W=V;X=O}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){P=$;Y=W;e=X}else{_=W;break}}}aEa(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function vra(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[26472]|0)==0){f=24}else{g=DEa(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(DEa(a|0)|0)+s|0;switch(v|0){case 3:{x=h;y=t;z=u;f=13;break};case 9:{A=h;f=7;break};case 10:{B=h;f=6;break};case 4:{C=h;D=u;f=12;break};case 2:{E=h;F=t;G=u;f=14;break};case 8:{H=h;f=8;break};case 1:{I=h;J=t;K=u;f=15;break};case 7:{L=h;M=u;f=9;break};case 5:{N=h;O=u;f=11;break};case 11:{B=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 6:{P=h;Q=u;f=10;break};default:{R=h;S=t;T=u}}if((f|0)==6){A=((d[w+9|0]|0)<<16)+B|0;f=7}if((f|0)==7){H=((d[w+8|0]|0)<<8)+A|0;f=8}if((f|0)==8){L=H;M=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){P=L;Q=((d[w+6|0]|0)<<16)+M|0;f=10}if((f|0)==10){N=P;O=((d[w+5|0]|0)<<8)+Q|0;f=11}if((f|0)==11){C=N;D=(d[w+4|0]|0)+O|0;f=12}if((f|0)==12){x=C;y=((d[w+3|0]|0)<<24)+t|0;z=D;f=13}if((f|0)==13){E=x;F=((d[w+2|0]|0)<<16)+y|0;G=z;f=14}if((f|0)==14){I=E;J=((d[w+1|0]|0)<<8)+F|0;K=G;f=15}if((f|0)==15){R=I;S=(d[w]|0)+J|0;T=K}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[26472]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=DEa(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((yEa(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,106448)|0)==0){V=0;break}else{W=106472}i=b;return W|0}}while(0);c[e>>2]=a;G9(0,(V|0)!=0|0,106520,e);W=V+4|0;i=b;return W|0}function wra(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((xra(106576,a,b)|0)!=0){d=1;i=c;return d|0}d=(xra(106584,a,b)|0)!=0|0;i=c;return d|0}function xra(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((zEa(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function yra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(zEa(c[54956>>2]|0,106592)|0)==0|0;G9(0,m,106608,l);l=(zEa(c[56860>>2]|0,106592)|0)==0|0;G9(0,l,106664,k);k=(zEa(c[58852>>2]|0,106592)|0)==0|0;G9(0,k,106720,j);j=106784|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=106912|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[58856+(k<<2)>>2]|0;if((l|0)==2){q=c[54832+(k<<2)>>2]|0;if(!((xra(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[54832+(k<<2)>>2]|0;if((Ara(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((xra(c[54832+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=106784+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=106784+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[106912+(k<<2)>>2]=zra(q,p)|0;t=j}else if((r|0)==13){r=0;l=106784+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[106912+(k<<2)>>2]=Bra(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];F9(1,0,107040,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];F9(1,0,107040,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];F9(1,0,107040,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];F9(1,0,107096,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function zra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((zEa(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function Ara(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Bra(a,b)|0)!=0|0;i=c;return d|0}function Bra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=DEa(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((AEa(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function Cra(){i=i;return}function Dra(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(107128,5,1,e|0)|0;f=b;b=0;while(1){Sd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(107136,20,1,e|0)|0;vc(0);return 0}function Era(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;wd(d|0,107160,e|0)|0;if((b|0)==0){vc(1)}else{ud(d|0)|0;Mra();ud(d|0)|0;ib(6,0)|0;hd()}}function Fra(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function Gra(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function Hra(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function Ira(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function Jra(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function Kra(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}HEa(p|0,32,b+(d-p)|0)|0;i=f;return}function Lra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=108200+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[108244+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[108240+(e*48|0)>>2]|0)==1){Nra(b)|0}k=108204+(e*48|0)|0;if((c[k>>2]|0)==0){break}Yc(c[f>>2]|0)|0;aEa(c[k>>2]|0)}}while(0);do{if((h|0)==10){Yc(g|0)|0;b=108204+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Jd(k|0)|0;aEa(c[b>>2]|0)}}while(0);c[f>>2]=0}c[108236+(e*48|0)>>2]=0;c[108204+(e*48|0)>>2]=0;i=d;return 0}function Mra(){var a=0,b=0;a=i;if((c[26792]|0)!=0){i=a;return}c[26792]=1;c[107176>>2]=0;b=0;do{c[107172>>2]=b;Lra(107168)|0;b=b+1|0;}while((b|0)<100);i=a;return}function Nra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[108216+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=108200+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Wc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[108220+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[108228+(d*48|0)>>2]&2|0)!=0){ud(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Wc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){Pra(111,107184);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function Ora(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function Pra(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;wd(m|0,108096,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;wd(m|0,108128,j|0)|0;l=m;break}else{n=c[107968+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;wd(m|0,108152,h|0)|0;l=m;break}}}while(0);h=c[27040]|0;do{if((h|0)==0){rc(113032,29,1,l|0)|0}else{c[g>>2]=(h-108200|0)/48|0;wd(l|0,108168,g|0)|0;b=c[(c[27040]|0)+4>>2]|0;if((b|0)==0){rc(113016,10,1,l|0)|0;break}else{c[f>>2]=b;wd(l|0,113e3,f|0)|0;break}}}while(0);f=c[28266]|0;if((f|0)!=0){c[d>>2]=f;wd(l|0,113072,d|0)|0}d=(c[28286]|0)!=0?113152:113168;f=(c[28294]|0)!=0?113184:113200;g=(c[28304]|0)!=0?113224:113240;c[e>>2]=(c[28280]|0)!=0?113128:113136;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;wd(l|0,113096,e|0)|0;Era(113256,1)}function Qra(){var a=0,b=0;a=i;c[28316]=1;b=c[r>>2]|0;c[27050]=b;c[108220>>2]=Ora(b)|0;c[108224>>2]=1;c[108240>>2]=1;b=c[s>>2]|0;c[108440>>2]=b;c[108460>>2]=Ora(b)|0;c[108464>>2]=1;c[108480>>2]=0;b=c[t>>2]|0;c[108488>>2]=b;c[108508>>2]=Ora(b)|0;c[108512>>2]=1;c[108528>>2]=1;i=a;return}function Rra(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[118512+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[28318]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[118512+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[28318]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Wc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Wc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function Sra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){Pra(b,d)}d=c[28320]|0;if((d|0)!=0){Ce[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function Tra(a){a=a|0;var b=0,d=0;b=i;c[28350]=0;c[28352]=0;c[28354]=0;d=((Ura(a,0)|0)==0)<<31>>31;i=b;return d|0}function Ura(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[28354]|0;c[28354]=j+1;if((j|0)==1){c[28352]=d}if((Zra(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=_ra(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function Vra(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[28350]|0;l=113424+(k<<4)|0;m=c[l>>2]|0;switch(Wra(m)|0){case 1:{n=c[113428+(k<<4)>>2]|0;o=(c[29582]|0)+1|0;c[29582]=o;c[118336+(o<<2)>>2]=n;c[28350]=k+1;continue b;break};case 8:{n=c[29566]|0;p=118272+(n<<2)|0;q=c[p>>2]|0;if((q|0)>=1){s=10;break b}c[29566]=n+ -1;c[28350]=k+1;continue b;break};case 3:{n=c[29566]|0;o=118272+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[29566]=n+ -1;c[29582]=(c[29582]|0)+ -1;c[28350]=k+1;continue b}else{n=c[29582]|0;c[29582]=n+ -1;c[28350]=(c[118336+(n<<2)>>2]|0)+1;continue b}break};case 19:case 17:{c[28326]=0;c[28350]=k+1;continue b;break};case 21:{c[28328]=0;c[28350]=k+1;continue b;break};case 18:{c[28326]=1;c[28350]=k+1;continue b;break};case 2:{c[29566]=0;c[29582]=0;c[28350]=c[113428+(k<<4)>>2];if(b){s=24;break a}if((c[29578]|0)==0){j=0;s=37;break a}n=Ce[c[28336]&7]()|0;if((n|0)==0){continue b}else{j=n;s=37;break a}break};case 16:{if(b){s=28;break a}c[28350]=k+1;continue b;break};case 22:{c[28328]=1;c[28350]=k+1;continue b;break};case 20:{c[28346]=c[113428+(k<<4)>>2];c[28350]=k+1;continue b;break};case 9:{n=(ie[c[28334]&127](l)|0)==0;c[28350]=(c[28350]|0)+1;if(n){break b}else{continue b}break};case 6:{n=c[113428+(k<<4)>>2]|0;t=(c[29566]|0)+1|0;c[29566]=t;c[118272+(t<<2)>>2]=n;c[28350]=k+1;continue b;break};case 33:{c[29594]=1;c[28350]=k+1;continue b;break};default:{s=4;break a}}}if((s|0)==10){s=0;if(b){s=11;break}c[p>>2]=q+ -1;c[29578]=1;k=le[c[28332]&63](l,g,d)|0;if((k|0)>0){s=13;break}if((k|0)<0){s=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;s=37;break}}if((s|0)==4){h=c[r>>2]|0;d=c[28266]|0;c[f>>2]=m;c[f+4>>2]=d;wd(h|0,118224,f|0)|0;if((c[c[28322]>>2]|0)==0){Pra(100,118256);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((s|0)==11){j=Ce[c[28320]&7]()|0;i=e;return j|0}else if((s|0)==13){f=c[c[28322]>>2]|0;j=Sra(f,c[(Nc()|0)>>2]|0,118320)|0;i=e;return j|0}else if((s|0)==15){if((c[(c[28322]|0)+8>>2]|0)==0){Pra(-1,118320);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((s|0)==24){j=Ce[c[28320]&7]()|0;i=e;return j|0}else if((s|0)==28){j=Ce[c[28320]&7]()|0;i=e;return j|0}else if((s|0)==37){i=e;return j|0}return 0}function Wra(a){a=a|0;var b=0;switch(a|0){case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};default:{b=a}}i=i;return b|0}function Xra(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=Vra(b,0,0)|0;i=a;return d|0}function Yra(){c[28342]=0;c[28350]=0;c[29582]=0;c[29566]=0;c[29578]=0;c[29584]=0;c[29568]=0;i=i;return}function Zra(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[28350]|0;if((g|0)>299){rc(118400,24,1,c[r>>2]|0)|0;Era(c[28266]|0,1)}else{c[113424+(g<<4)>>2]=a;c[113428+(g<<4)>>2]=b;c[113432+(g<<4)>>2]=d;c[113436+(g<<4)>>2]=e;c[28350]=g+1;i=f;return g|0}return 0}function _ra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=$ra(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[28354]|0)+ -1|0;c[28354]=h;if((h|0)==0){Zra(2,c[28352]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{Zra(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function $ra(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((asa(b,e)|0)!=0){g=c[e>>2]|0;break}if((bsa(b,e)|0)!=0){g=c[e>>2]|0;break}h=csa(b,f,1)|0;j=Zra(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=Ura(h,j)|0}}while(0);i=d;return g|0}function asa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{g=b;h=0;j=14;break};case 116:case 84:{k=b+1|0;l=a[k]|0;if(l<<24>>24==76|l<<24>>24==108){m=k;n=13}else if(l<<24>>24==82|l<<24>>24==114){m=k;n=14}else{m=b;n=15}k=csa(m+1|0,f,0)|0;if((k|0)==0){j=15;break a}Zra(n,c[f>>2]|0,0,0)|0;o=k+ -1|0;j=30;break};case 45:{p=1;j=13;break};case 112:case 80:{Zra(20,1,0,0)|0;o=b;j=30;break};case 47:{Zra(5,0,0,0)|0;o=b;j=30;break};case 115:case 83:{k=b+1|0;l=a[k]|0;if(l<<24>>24==83|l<<24>>24==115){q=k;r=19}else if(l<<24>>24==80|l<<24>>24==112){q=k;r=18}else{q=b;r=17}Zra(r,0,0,0)|0;o=q;j=30;break};case 120:case 88:{Zra(4,1,0,0)|0;o=b;j=30;break};case 98:case 66:{k=b+1|0;l=a[k]|0;if(l<<24>>24==90|l<<24>>24==122){Zra(22,0,0,0)|0;o=k;j=30;break a}else{Zra(21,0,0,0)|0;o=k;j=30;break a}break};case 36:{Zra(33,0,0,0)|0;o=b;j=30;break};case 58:{Zra(16,0,0,0)|0;o=b;j=30;break};case 43:{p=0;j=13;break};case 39:case 34:case 2:{c[113432+((Zra(11,0,0,0)|0)<<4)>>2]=b;k=dsa(b)|0;c[d>>2]=k;s=(k|0)!=0|0;i=e;return s|0};default:{s=0;i=e;return s|0}}}while(0);if((j|0)==13){g=b+1|0;h=p;j=14}b:do{if((j|0)==14){p=csa(g,f,0)|0;if((p|0)==0){j=15;break}switch(a[p]|0){case 120:case 88:{Zra(4,c[f>>2]|0,0,0)|0;o=p;j=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((h|0)==0){t=b}else{q=0-b|0;c[f>>2]=q;t=q}Zra(20,t,0,0)|0;o=p;j=30;break b;break};case 104:case 72:{q=c[f>>2]|0;c[113432+((Zra(12,q,0,0)|0)<<4)>>2]=p+1;o=p+q|0;j=30;break b;break};default:{s=0;i=e;return s|0}}}}while(0);if((j|0)==15){c[d>>2]=0;s=1;i=e;return s|0}else if((j|0)==30){c[d>>2]=o+1;s=1;i=e;return s|0}return 0}function bsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=csa(b,f,1)|0;Zra(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 100:case 68:{l=csa(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=csa(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}Zra(26,n,r,0)|0;o=q;m=45;break};case 97:case 65:{n=f;while(1){s=a[n]|0;if(s<<24>>24==32){n=n+1|0}else{break}}if(!((s+ -48<<24>>24&255)<10)){Zra(30,0,0,0)|0;o=n;m=45;break a}l=csa(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}Zra(31,p,0,0)|0;o=l;m=45;break};case 103:case 71:{t=0;m=3;break};case 101:case 69:{t=1;m=3;break};case 111:case 79:{u=32;v=34;m=38;break};case 105:case 73:{u=7;v=10;m=38;break};case 102:case 70:{l=csa(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=csa(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}Zra(23,p,y,0)|0;o=x;m=45;break};case 108:case 76:{p=csa(f,g,0)|0;if((p|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=p;m=45;break a}Zra(29,l,0,0)|0;o=p;m=45;break};case 122:case 90:{u=35;v=36;m=38;break};default:{c[28350]=(c[28350]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=csa(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){s=csa(b+1|0,h,0)|0;if((s|0)==0){m=4;break}A=s;B=a[s]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){Zra((t|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=csa(A+1|0,j,0)|0;if((y|0)==0){m=4;break}Zra((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=csa(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){Zra(u,x,0,0)|0;o=y;m=45;break}b=csa(y+1|0,h,0)|0;if((b|0)==0){m=4;break}Zra(v,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function csa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function dsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[28322]>>2]|0)==0){Pra(100,118384);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function esa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[118454|0]=48;k=118454|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=118432+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function fsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[28344]|0;f=c[28340]|0;if((e|0)>(f|0)){c[28340]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[29632]|0)){h=g}else{gsa(f,g);h=c[28340]|0}g=c[29634]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Kd(g|0,c[28318]|0)|0;h=DEa(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Sd(a[k]|0,c[28318]|0)|0;Kd(h|0,c[28318]|0)|0;b=DEa(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function gsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[29634]|0;if((f|0)==118616){c[29632]=1024;g=1024}else{g=c[29632]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[29632]=j;h=j}j=$Da(h)|0;if((j|0)==0){Pra(113,119016);k=c[29634]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[29634]|0}else{l=k}if((l|0)==118616){m=118536;c[29634]=j;i=e;return}aEa(l);m=118536;c[29634]=j;i=e;return}function hsa(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[28340]|0;f=c[29632]|0;if((e|0)<(f|0)){g=e}else{gsa(e,f);g=c[28340]|0}c[28340]=g+1;a[(c[29634]|0)+g|0]=b;i=d;return}function isa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[28304]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){Pra(101,118544);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[28316]|0)==0){Qra();m=c[f>>2]|0}else{m=k}k=108200+(m*48|0)|0;c[27040]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){nsa(k,c[b+12>>2]|0,j);o=osa(j,h)|0;if((o|0)==(c[108208+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[108212+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=Lra(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[108232+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=108216+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[108232+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=108224+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[108224+(m*48|0)>>2]=1;r=1;break}else{c[108224+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];hc(j|0,118552,e|0)|0}else{nsa(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){jsa(107,118544,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=108244+(m*48|0)|0;c[q>>2]=0;c[108236+(m*48|0)>>2]=0;e=108240+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=108228+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 83:case 115:{c[q>>2]=1;o=Mb()|0;c[n>>2]=o;if((o|0)!=0){c[108204+(m*48|0)>>2]=0;c[108212+(m*48|0)>>2]=-1;c[108208+(m*48|0)>>2]=-1;c[108220+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){jsa(s,118544,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){jsa(o,118544,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){jsa(128,118544,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=ic(j|0,c[29628]|0)|0;if((o|0)==0){break}Yc(o|0)|0}}while(0);q=$Da((DEa(j|0)|0)+1|0)|0;c[108204+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){jsa(113,118568,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}JEa(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ic(j|0,c[118512+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ic(j|0,c[118472+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ic(j|0,c[118512+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){Pra(o,118544);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=108220+(m*48|0)|0;c[r>>2]=Ora(u)|0;u=osa(j,108212+(m*48|0)|0)|0;c[108208+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){jsa(108,118544,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Wc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){jsa(129,118544,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function jsa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){Pra(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[29632]|0)){j=d;k=g}else{gsa(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[29634]|0;c[(c[27040]|0)+4>>2]=f;nsa(k,j,f);Pra(a,b);i=e;return}function ksa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;hc(j|0,118552,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=DEa(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?118584:118592;c[h+24>>2]=(b|0)==5?118600:118608;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=isa(h)|0;i=e;return a|0}function lsa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=108200+(d*48|0)|0;c[27040]=e;if(d>>>0>99){if((c[a>>2]|0)==0){Pra(101,119032);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((ksa(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){Pra(114,119040);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[108224+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){Pra(102,119040);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function msa(){var a=0,b=0;a=i;b=Xra()|0;c[28266]=0;i=a;return b|0}function nsa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function osa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((lc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function psa(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[28346]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[28326]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hc(p|0,119048,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(DEa(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;fe[c[28330]&511](32);}while((A|0)>0)}if((D|0)!=0){fe[c[28330]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{fe[c[28330]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[28346]|0);hc(A|0,119056,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;fe[c[28330]&511](32);}while((z|0)>0)}if((x|0)!=0){fe[c[28330]&511]((w|0)!=0?45:43)}z=c[28346]|0;do{if((z|0)<1){fe[c[28330]&511](46);y=c[28330]|0;if((z|0)<0){G=y;J=z;while(1){fe[G&511](48);I=J+1|0;K=c[28330]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}fe[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}fe[c[28330]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[28330]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){fe[P&511](a[J]|0);R=Q+ -1|0;S=c[28330]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}fe[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;fe[c[28330]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){fe[c[28330]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;fe[c[28330]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){fe[c[28330]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;fe[c[28330]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;fe[c[28330]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;fe[c[28330]&511](42);}while((_|0)>0);i=l;return 0}function qsa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[28346]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(hc(n|0,119064,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[28326]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;fe[c[28330]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;fe[c[28330]&511](32);}while((b|0)>0)}do{if(q){if((c[28326]|0)==0){break}fe[c[28330]&511](43)}else{fe[c[28330]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;fe[c[28330]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;fe[c[28330]&511](48);}while((z|0)>0);i=j;return 0}function rsa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{fe[c[28330]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[28330]|0;if((h|0)==0){fe[d&511](70);i=g;return 0}else{fe[d&511](84);i=g;return 0}return 0}function ssa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[28342]|0)!=0){g=tsa()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 29:{rsa(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 34:{vsa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 10:{vsa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 25:case 24:case 26:{h=psa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=ysa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 30:{wsa(b,d);h=0;i=e;return h|0};case 7:{usa(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 23:{h=qsa(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 31:{xsa(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 36:{zsa(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 32:{usa(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 35:{zsa(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;wd(h|0,119072,f|0)|0;Era(c[28266]|0,1)}}return 0}function tsa(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[28342]|0;c[28342]=0;if((c[28304]|0)!=0){if((b|0)>0){d=c[28344]|0;e=c[28340]|0;if((d|0)<=(e|0)){f=b;while(1){fe[c[28330]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[28340]=f;h=0;i=a;return h|0}f=b-d+e|0;c[28340]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){fe[c[28330]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[28340]|0;f=j+b|0;if((f|0)>=0){if((c[28344]|0)<(j|0)){c[28344]=j}c[28340]=f;h=0;i=a;return h|0}if((c[c[28322]>>2]|0)==0){Pra(110,119160);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[28340]|0;if((c[28344]|0)<(f|0)){c[28344]=f}j=f+b|0;c[28340]=j;c[28348]=(c[28348]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[28322]>>2]|0)==0){Pra(110,119160);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[28340]|0;f=j+b|0;if((f|0)>=(c[(c[28324]|0)+16>>2]|0)){if((c[c[28322]>>2]|0)==0){Pra(110,119176);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[28344]|0;if((d|0)<=(j|0)){e=b;while(1){fe[c[28330]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[28348]=(c[28348]|0)+b;c[28340]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[28348]=(c[28348]|0)+f;c[28340]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){fe[c[28330]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function usa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=esa(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[28326]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{fe[c[28330]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{fe[c[28330]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[28326]|0)==0){break}fe[c[28330]&511](43)}else{fe[c[28330]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){fe[c[28330]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function vsa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=esa(m,k,l,h)|0;h=c[l>>2]|0;g=(c[28326]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{fe[c[28330]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{fe[c[28330]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[28326]|0)==0){break}fe[c[28330]&511](43)}else{fe[c[28330]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){fe[c[28330]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){fe[c[28330]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{fe[c[28330]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function wsa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;fe[c[28330]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function xsa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;fe[c[28330]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;fe[c[28330]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function ysa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=psa(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=psa(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[28346]|0;c[28346]=0;p=(e|0)==0?4:e+2|0;e=qsa(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{fe[c[28330]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[28346]=o;n=e;i=j;return n|0}function zsa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{fe[c[28330]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;fe[c[28330]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;fe[c[28330]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){fe[c[28330]&511](a[119136+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){fe[c[28330]&511](a[119136+((d[p]|0)>>>4)|0]|0);fe[c[28330]&511](a[119136+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function Asa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 4:case 14:{c[28342]=(c[28342]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 11:{f=Bsa(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=Ce[c[28338]&7]()|0;i=b;return f|0};case 13:{g=(c[28342]|0)-(c[a+4>>2]|0)|0;h=0-(c[28340]|0)|0;c[28342]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 12:{f=Csa(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 15:{c[28342]=(c[a+4>>2]|0)+ -1-(c[28340]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;wd(f|0,119104,d|0)|0;Era(c[28266]|0,1)}}return 0}function Bsa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[28342]|0)!=0){e=tsa()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}fe[c[28330]&511](e<<24>>24);n=b}else{fe[c[28330]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function Csa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[28342]|0)!=0){f=tsa()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;fe[c[28330]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function Dsa(){var a=0,b=0;a=i;b=fsa(10)|0;c[28342]=0;c[28340]=0;c[28344]=0;i=a;return(b|0)==0|0}function Esa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[28316]|0)==0){Qra()}c[28280]=0;c[28286]=1;c[28294]=1;c[28304]=1;d=lsa(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[28322]=a;c[28340]=0;c[28342]=0;c[28344]=0;c[29594]=0;c[28346]=0;d=c[a+12>>2]|0;c[28266]=d;c[28318]=c[c[27040]>>2];if((Tra(d)|0)<0){if((c[a>>2]|0)==0){Pra(100,119184);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[28330]=289;c[28332]=44;c[28334]=111;c[28320]=4;c[28336]=5;c[28338]=6;Yra();c[28326]=0;d=c[27040]|0;c[28328]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((Rra(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){Pra(f,119192);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function Fsa(){var a=0,b=0;a=i;if((c[29594]|0)==0){b=fsa(10)|0}else{fsa(0)|0;ud(c[28318]|0)|0;b=0}c[28342]=0;c[28340]=0;c[28344]=0;i=a;return b|0}function Gsa(){var a=0,b=0,d=0;a=i;if((c[29578]|0)==0){b=0}else{d=fsa(10)|0;c[29578]=0;b=d}c[28342]=0;c[28340]=0;c[28344]=0;i=a;return b|0}



function cba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[7459]=.5;h[7455]=1.0;h[7471]=6.283185307179586;z=+h[n>>3];h[7468]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[14924]=A;c[14932]=0;B=c[d>>2]|0;c[14884]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[14884]=B+1}c[14882]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[7460]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[7460]=F;G=F}else{G=z}H=c[d>>2]|0;c[14884]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[7460];I=I+1|0}c[14884]=H+1}I=B+1|0;c[14882]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[7443]=0.0;D=c[b>>2]|0;c[14880]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[7443]=+h[7443]+G*G;A=p+1|0;c[14880]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[14884]=1;if((p|0)>=1){D=1;while(1){h[7460]=0.0;h[7458]=0.0;y=c[b>>2]|0;c[14882]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[7460]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[7458]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[14882]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[7460]=G;h[7458]=+h[g>>3]*L;g=c[b>>2]|0;c[14880]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[7458]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[7460];H=H+1|0}c[14880]=g+1}H=D+1|0;c[14884]=H;if((D|0)<(p|0)){D=H}else{break}}}h[7444]=0.0;h[7446]=0.0;h[7453]=0.0;D=c[b>>2]|0;c[14880]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[7444]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[7446]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[7453]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[14880]=D+1;O=R;P=T;Q=S}S=+h[7443];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[7464]=U;h[7460]=0.0;if(Q*Q>S*.99*O){h[7460]=+h[7455]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[7459]*U*Z);h[7456]=P;if(O*+h[7468]<P*P*.01){h[7460]=+h[7455]}n=c[b>>2]|0;c[14880]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[7464]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[7460]*U;if((D|0)>=(n|0)){break}e=D;P=+h[7464];D=D+1|0;p=e}c[14880]=n+1;_=0}while(1){n=_+1|0;c[14932]=n;h[7443]=0.0;h[7446]=0.0;h[7447]=0.0;p=c[b>>2]|0;c[14880]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[7443]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[7446]=da;Z=+h[H>>3];ea=P+Z*Z;h[7447]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[14880]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[7460]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[7465]=U;D=c[b>>2]|0;c[14880]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[7465];U=+h[7446];O=+h[7443];g=g+1|0;H=e}c[14880]=D+1}H=c[d>>2]|0;c[14884]=1;if((H|0)>=1){g=1;while(1){h[7458]=0.0;p=c[b>>2]|0;c[14882]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[7458]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[14882]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[7458]=O;e=c[b>>2]|0;c[14880]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[7458];l=l+1|0}c[14880]=e+1}l=g+1|0;c[14884]=l;if((g|0)<(H|0)){g=l}else{break}}}h[7448]=0.0;h[7449]=0.0;h[7450]=0.0;h[7451]=0.0;h[7452]=0.0;g=c[b>>2]|0;c[14880]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[7448]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[7449]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[7450]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[7451]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[7452]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[14880]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[7459];O=U*na;h[7448]=O;P=U*ma-O;h[7451]=P;Z=O+la+P;h[7472]=Z;h[7474]=Z;h[7473]=Z;c[14934]=0;a[59560]=1;W=+h[7471]/50.0;h[7460]=W;c[14880]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[7474]=wa;c[14934]=p;h[7469]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[7470]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[7463]=ta;h[7454]=ua;h[7457]=va;h[7456]=wa;c[14880]=50;h[7473]=wa;if((za|0)==49){h[7470]=Z;Ba=Z}else if((za|0)==0){h[7469]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[7470]}h[7461]=0.0;S=+h[7469];if(S!=Ba){Q=S-Aa;h[7469]=Q;S=Ba-Aa;h[7470]=S;T=U*(Q-S)/(Q+S);h[7461]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[7463]=T;S=+X(+T);h[7454]=S;Q=+Y(+T);h[7457]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[7456]=T;p=c[b>>2]|0;c[14880]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[7454]*+h[y>>3]+ +h[7457]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[7457];Q=+h[7454];H=H+1|0;g=e}c[14880]=p+1;Da=+h[7456]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[7472];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function dba(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[60016]=1;a[60008]=1;c[60028>>2]=6;Esa(60024)|0;e=c[d>>2]|0;c[15e3]=1;if((e|0)>=1){d=1;do{Vra(60144,b+(d+ -1)|0,1)|0;o=c[15e3]|0;d=o+1|0;c[15e3]=d;}while((o|0)<(e|0))}msa()|0;e=c[g>>2]|0;if((e|0)==1){c[60052>>2]=a[60008]&1?6:0;Esa(60048)|0;Vra(60144,h,4)|0;msa()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[60076>>2]=a[60008]&1?6:0;Esa(60072)|0;Vra(60144,h,4)|0;Vra(60144,j,4)|0;msa()|0}j=c[k>>2]|0;if((j|0)==1){c[60100>>2]=a[60008]&1?6:0;Esa(60096)|0;Vra(60144,l,8)|0;msa()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[60124>>2]=a[60008]&1?6:0;Esa(60120)|0;Vra(60144,l,8)|0;Vra(60144,m,8)|0;msa()|0}if((c[f>>2]|0)==2){Dra(60152,0)|0}else{i=n;return 0}return 0}function eba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[15042]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[15042]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){Kra(60224,61920,80,25);B=60528;C=60536;dba(60224,61952,60704,B,60608,d,B,B,C,C,80)|0;break}c[15106]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[15106]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}Kra(60224,61960,80,34);B=60528;F=60536;dba(60224,62e3,60696,B,60608,60424,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[15092]=B;c[15104]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){Kra(60224,62784,80,52);I=60528;J=60536;dba(60224,62768,62840,I,60608,G,I,I,J,J,80)|0;break a}c[15092]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[15104]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[15092]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[15104]=F+(c[15092]|0);break b}}}while(0);Kra(60224,62712,80,52);B=60528;F=60536;dba(60224,62768,62776,B,60608,q,B,B,F,F,80)|0;break a}}while(0);c[15096]=(c[d>>2]|0)+20;c[q+64>>2]=c[15092];if((c[p>>2]|0)<(c[15104]|0)){Kra(60224,62008,80,60);C=60528;F=60536;dba(60224,62072,62080,C,60704,60416,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[15096]|0)){Kra(60224,62088,80,60);F=60528;C=60536;dba(60224,62072,62152,F,60704,60384,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){Kra(60224,62896,80,24);C=60608;F=60528;B=60536;dba(60224,62928,62936,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[7543]=K;if(!(K<=0.0)){break}Kra(60224,62392,80,28);B=60528;dba(60224,61104,62424,B,B,B,B,60608,60344,60536,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){Kra(60224,60456,80,49);B=60528;F=60536;dba(60224,60512,60520,B,B,B,B,B,F,F,80)|0;Kra(60224,60544,80,47);F=60528;B=60536;dba(60224,60592,60600,F,60608,n,F,F,B,B,80)|0;Kra(60224,60616,80,41);B=60528;F=60536;dba(60224,60664,60672,60608,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[60400]=0;K=+h[l>>3];h[7554]=K;L=+h[m>>3];h[7547]=L;A=c[d>>2]|0;c[15042]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[7554]=O;P=+h[m+(F<<3)>>3];h[7547]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[60400]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[15042]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[15052]=p;r=p+(c[w>>2]|0)|0;c[15054]=r;p=r+(c[w>>2]|0)|0;c[15076]=p;F=p+(c[w>>2]|0)|0;c[15046]=F;B=F+(c[d>>2]|0)|0;c[15082]=B;C=B+(c[d>>2]|0)|0;c[15088]=C;c[15078]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[15102]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[7556]=+h[B>>3];a[60336]=0;h[7525]=+h[o+24>>3];J=o+16|0;h[7520]=+h[J>>3];do{if((c[w>>2]|0)!=0){fba(60704,v,w,d,60200,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,60320,B,0,o,q,s,t)|0;if((c[15172]|0)>0){i=y;return 0}if((c[15080]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=60608;Cba(d,o+((c[15046]|0)+ -1<<3)|0,G,g,G)|0;a[60336]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[7520];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[7520]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[7520];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[7555]=O;U=+h[7525];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[15088]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){kba(60200,j,f,g,d,H,I,X)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[60336]=1;D=197;break d}}else{Y=60200;kba(Y,Y,f,g,d,H,I,X)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[7525];c[n>>2]=1;a[60336]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[60336]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[7556]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[7520]=W;h[J>>3]=W;break}kba(60200,60440,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[7555];a[60336]=1;D=197;break d}}else{W=+h[7525];if(!B){if(P*(W-N)<0.0){break}kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[60336]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[15088]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){kba(60200,j,f,g,d,G,X,I)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[60336]=1;D=197;break d}}else{H=60200;kba(H,H,f,g,d,G,X,I)|0;if((c[15172]|0)>0){i=y;return 0}else{h[e>>3]=+h[7525];c[n>>2]=1;a[60336]=1;D=197;break d}}}}while(0);if(a[60336]&1){D=197}else{D=128}}else{h[7525]=+h[e>>3];c[n>>2]=1;hba(d,k+4|0,l,m,f,o+((c[15082]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[15042]=1;e:do{if((B|0)>=1){J=c[15082]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[15042]=X;if((I|0)<(B|0)){I=X}else{break e}}Kra(60224,62528,80,39);I=60528;J=60536;dba(60224,62200,62568,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+oba(60680,1);h[7556]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[7556]*4.0*(aa>=ba?aa:ba);h[7545]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){Kra(60224,62576,80,60);J=60528;dba(60224,62072,62640,J,J,J,J,60704,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[7524]=ca*.001;U=+iba(d,g,o+((c[15082]|0)+ -1<<3)|0,s,t);if(U>.5/+h[7524]){h[7524]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+Hra(60192,z);h[7524]=U;da=U}else{U=+h[o+16>>3];h[7524]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}Kra(60224,62480,80,29);J=60528;I=60536;dba(60224,62512,62520,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[7524]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[7555]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[7524]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{jba(60200,f,g,d,b,u,60192,o+((c[15082]|0)+ -1<<3)|0,n,s,t,o+((c[15088]|0)+ -1<<3)|0,o+400|0,o+((c[15046]|0)+ -1<<3)|0,o+((c[15078]|0)+ -1<<3)|0,q,60360,B,k+36|0,60408)|0;if((c[15172]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[7524]}h[7520]=ja;h[o+16>>3]=ja;J=c[15088]|0;X=(c[d>>2]|0)+J|0;c[15098]=X;G=c[d>>2]|0;c[15042]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[7520]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[15042]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[7520];h[o+232>>3]=+h[7520]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}fba(60608,v,w,d,e,j,f,o+((c[15046]|0)+ -1<<3)|0,o+((c[15088]|0)+ -1<<3)|0,J,Y,o+((c[15052]|0)+ -1<<3)|0,o+((c[15054]|0)+ -1<<3)|0,o+((c[15076]|0)+ -1<<3)|0,x,60320,B,0,o,q,s,t)|0;if((c[15172]|0)>0){i=y;return 0}if((c[15080]|0)!=0){Kra(60224,62944,80,47);la=60528;ma=60536;dba(60224,60592,62992,60608,la,la,la,la,ma,ma,80)|0;Kra(60224,63e3,80,38);ma=60528;la=60536;dba(60224,60752,62992,60608,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}fba(60696,v,w,d,60200,j,f,o+((c[15046]|0)+ -1<<3)|0,o+((c[15088]|0)+ -1<<3)|0,J,Y,o+((c[15052]|0)+ -1<<3)|0,o+((c[15054]|0)+ -1<<3)|0,o+((c[15076]|0)+ -1<<3)|0,x,60320,B,0,o,q,s,t)|0;if((c[15172]|0)>0){i=y;return 0}if((c[15080]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=60608;Cba(d,o+((c[15046]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){Kra(60224,62320,80,54);p=60528;dba(60224,62376,62384,p,p,p,p,60704,60440,j,80)|0;break c}else if((D|0)==220){Kra(60224,62432,80,34);p=60528;dba(60224,62e3,62472,p,p,p,p,60704,j,e,80)|0;break c}else if((D|0)==224){Kra(60224,62648,80,49);p=60528;dba(60224,60512,62704,p,p,p,p,60704,60440,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;hba(d,oa,l,m,o+((c[15088]|0)+ -1<<3)|0,o+((c[15082]|0)+ -1<<3)|0,s,t)|0;if((c[15172]|0)>0){D=233;break}p=c[d>>2]|0;c[15042]=1;r=c[15082]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[15042]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+iba(d,o+((c[15088]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[7556];pa=O*V;h[7522]=pa;if(!(pa<=1.0)){D=138;break}O=+h[7525];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[7545]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[7520];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[7520]=V/O}}while(0);lba(60200,f,g,d,b,u,60160,o+((c[15082]|0)+ -1<<3)|0,k,n,s,t,o+((c[15088]|0)+ -1<<3)|0,o+400|0,o+((c[15046]|0)+ -1<<3)|0,o+((c[15078]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,60360,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,60408)|0;if((c[15172]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){fba(60696,v,w,d,60200,j,f,o+((c[15046]|0)+ -1<<3)|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[15052]|0)+ -1<<3)|0,o+((c[15054]|0)+ -1<<3)|0,o+((c[15076]|0)+ -1<<3)|0,x,60320,o+64|0,0,o,q,s,t)|0;if((c[15172]|0)>0){D=233;break f}if((c[15080]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=60608;Cba(d,o+((c[15046]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[7525];V=+h[7520];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[7555];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[7556]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}kba(60200,60440,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[7555];D=197;continue}if(!(U<0.0)){kba(60200,j,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[7555];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[7556]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[7520]=U-O;D=128;continue}else{kba(60200,60440,f,g,d,q+28|0,o+((c[15088]|0)+ -1<<3)|0,o+224|0)|0;if((c[15172]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[7555];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[7525];h[o+16>>3]=+h[7520];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[7522]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[15042]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[7522]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[7522];E=E+1|0;p=B}c[15042]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[15098]=p;switch(p|0){case 2:{Kra(60224,60840,80,47);p=60528;dba(60224,60592,60888,p,p,p,p,60608,60200,60536,80)|0;Kra(60224,60896,80,48);p=60528;E=60536;dba(60224,60824,60952,p,p,p,p,p,E,E,80)|0;Kra(60224,60960,80,45);E=60528;p=60536;dba(60224,61008,61016,E,E,E,E,E,p,p,80)|0;break};case 3:{Kra(60224,61024,80,38);p=60528;dba(60224,60752,61064,p,p,p,p,60608,60200,60536,80)|0;Kra(60224,61072,80,28);p=60528;E=60536;dba(60224,61104,61112,p,p,p,p,p,E,E,80)|0;break};case 6:{Kra(60224,61120,80,44);E=60528;dba(60224,61168,61176,E,E,E,E,60704,60200,60160,80)|0;Kra(60224,61184,80,57);E=60528;p=60536;dba(60224,61248,61256,E,E,E,E,E,p,p,80)|0;break};case 7:{Kra(60224,61120,80,44);p=60528;dba(60224,61168,61264,p,p,p,p,60704,60200,60160,80)|0;Kra(60224,61272,80,48);p=60528;E=60536;dba(60224,60824,61328,p,p,p,p,p,E,E,80)|0;Kra(60224,61336,80,28);E=60528;p=60536;dba(60224,61104,61368,E,E,E,E,E,p,p,80)|0;break};case 8:{Kra(60224,61120,80,44);p=60528;dba(60224,61168,61376,p,p,p,p,60704,60200,60160,80)|0;Kra(60224,61384,80,37);p=60528;E=60536;dba(60224,61424,61432,p,p,p,p,p,E,E,80)|0;break};case 9:{Kra(60224,61120,80,44);E=60528;dba(60224,61168,61440,E,E,E,E,60704,60200,60160,80)|0;Kra(60224,61448,80,49);E=60528;p=60536;dba(60224,60512,61504,E,E,E,E,E,p,p,80)|0;Kra(60224,61512,80,38);p=60528;E=60536;dba(60224,60752,61552,p,p,p,p,p,E,E,80)|0;break};case 10:{Kra(60224,61120,80,44);E=60528;dba(60224,61168,61560,E,E,E,E,60704,60200,60160,80)|0;Kra(60224,61568,80,45);E=60528;p=60536;dba(60224,61008,61616,E,E,E,E,E,p,p,80)|0;Kra(60224,61624,80,36);p=60528;E=60536;dba(60224,61664,61672,p,p,p,p,p,E,E,80)|0;break};case 11:{Kra(60224,61680,80,40);E=60528;dba(60224,61728,61736,E,E,E,E,60704,60200,60160,80)|0;Kra(60224,61744,80,36);E=60528;p=60536;dba(60224,61664,61784,E,E,E,E,E,p,p,80)|0;break};case 12:{Kra(60224,61120,80,44);p=60528;dba(60224,61168,61792,p,p,p,p,60704,60200,60192,80)|0;Kra(60224,61800,80,45);p=60528;E=60536;dba(60224,61008,61848,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{Kra(60224,60712,80,38);E=60528;dba(60224,60752,60760,E,E,E,E,60608,60200,60536,80)|0;Kra(60224,60768,80,48);E=60528;p=60536;dba(60224,60824,60832,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[7525];h[o+24>>3]=+h[7525];h[o+16>>3]=+h[7520];i=y;return 0}else if((D|0)==215){Kra(60224,62160,80,39);p=60528;E=60536;dba(60224,62200,62208,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){Kra(60224,62216,80,39);E=60528;p=60536;dba(60224,62200,62256,E,E,E,E,E,p,p,80)|0;break c}}}while(0);Kra(60224,62264,80,47);A=60528;p=60536;dba(60224,60592,62312,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){Kra(60224,61856,80,55);p=60528;A=60536;dba(60224,61912,60608,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){Kra(60224,62848,80,39);D=60528;dba(60224,62200,62888,D,D,D,D,60704,j,e,80)|0}if((c[k>>2]|0)==-1){Kra(60224,63040,80,46);e=60528;j=60536;dba(60224,63088,63096,e,e,e,e,e,j,j,80)|0;Kra(60224,63104,80,47);j=60528;e=60536;dba(60224,60592,63152,60608,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function fba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[7895]=C;c[t>>2]=0;D=c[e>>2]|0;c[15792]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[15792]|0;E=F+1|0;c[15792]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[7902]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;kba(g,b,k,l,f,o,m,n)|0;if((c[15172]|0)>0){i=v;return 0}D=d;be[D&7](f,b,k,e,p,y,z)|0;if((c[15172]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[63224]=0;F=c[e>>2]|0;c[15792]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[63224]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[15792]=F+1;if(!M){break}I=+Hra(63216,63160);h[7899]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[7895];do{if((H- +h[g>>3])*I<0.0){kba(g,b,k,l,f,o,m,n)|0;if((c[15172]|0)<=0){break}i=v;return 0}else{G=+h[7899]/I;h[7900]=G;N=c[f>>2]|0;c[15792]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[7900];Q=Q+1|0}c[15792]=N+1}}while(0);be[D&7](f,b,k,e,p,y,z)|0;if((c[15172]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[63224]=0;F=c[e>>2]|0;c[15792]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[63224]=1;V=1;W=c[15792]|0}Q=W+1|0;c[15792]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[7895];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;kba(g,F,k,l,f,o,m,n)|0;if((c[15172]|0)>0){i=v;return 0}E=d;be[E&7](f,F,k,e,p,y,z)|0;if((c[15172]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[63224]=0;D=c[e>>2]|0;c[15792]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[63224]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[15792]=D+1;if(!aa){i=v;return 0}I=+Hra(63216,63160);h[7899]=I;h[F>>3]=I+ +h[F>>3];I=+h[7899]/+h[7895];h[7900]=I;Q=c[f>>2]|0;c[15792]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[7900];R=R+1|0}c[15792]=Q+1}be[E&7](f,F,k,e,p,y,z)|0;if((c[15172]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[63224]=0;R=c[e>>2]|0;c[15792]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[63224]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[15792]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[7898]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}kba(g,63184,k,l,f,o,m,n)|0;if((c[15172]|0)<=0){break}i=v;return 0}else{h[7898]=Y;j=c[f>>2]|0;c[15792]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[15792]=j+1}}while(0);ga=d;be[ga&7](f,63184,k,e,q,y,z)|0;if((c[15172]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[15802]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){gba(e,63216,63208,R,63184,p,q,r,63176,s,fa,da,x,ca)|0;if((c[15172]|0)>0){ha=76;break}if((c[15802]|0)>1){ha=73;break}kba(g,63176,k,l,f,o,m,n)|0;if((c[15172]|0)>0){ha=76;break}be[ga&7](f,63176,k,e,r,y,z)|0;if((c[15172]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[7897];R=60608;Cba(e,r,R,p,R)|0;if((c[15802]|0)==4){i=v;return 0}kba(g,63176,k,l,f,o,m,n)|0;if((c[15172]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function gba(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[15818]=c[o>>2];c[o>>2]=0;h[7905]=0.0;a[63256]=0;t=c[b>>2]|0;c[15808]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+Hra(63288,j+(v<<3)|0);if(w==+Hra(63288,l+((c[15808]|0)+ -1<<3)|0)){break}y=c[15808]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[7905]){break}h[7905]=B;c[o>>2]=y}else{a[63256]=1}}while(0);v=c[15808]|0;u=v+1|0;c[15808]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[63264]=1;c[15820]=c[p>>2];h[g>>3]=+h[r>>3];t=60608;Cba(b,l,t,k,t)|0;c[p>>2]=1;a[63248]=0;C=0}else{a[63264]=0;c[o>>2]=c[15818];c[15820]=c[p>>2];if(a[63256]&1){h[g>>3]=+h[r>>3];t=60608;Cba(b,l,t,k,t)|0;a[63248]=1;C=1;break}else{t=60608;Cba(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[63248]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[63248]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=60608;Cba(b,k,t,l,t)|0;t=c[b>>2]|0;c[15808]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[15808]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+Hra(63288,j+(u<<3)|0);if(!(A!=+Hra(63288,k+((c[15808]|0)+ -1<<3)|0))){break}c[n+((c[15808]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[15808]|0;F=u+1|0;c[15808]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[7905]=0.0;a[63256]=0;t=c[b>>2]|0;c[15808]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+Hra(63288,j+(v<<3)|0);if(A==+Hra(63288,k+((c[15808]|0)+ -1<<3)|0)){break}y=c[15808]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[7905]){break}h[7905]=I;c[o>>2]=y}else{a[63256]=1}}while(0);v=c[15808]|0;u=v+1|0;c[15808]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[63264]=t&1;if(t){a[63248]=0;c[15820]=0;c[p>>2]=1;break}if(!(a[63256]&1)){t=60608;Cba(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=60608;Cba(b,k,t,l,t)|0;t=c[b>>2]|0;c[15808]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[15808]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[15808]|0}u=K+1|0;c[15808]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[15820]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function hba(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[7914]=+h[d>>3];h[7913]=+h[e>>3];j=c[a>>2]|0;c[15824]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[7914]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[7914]=o;h[7913]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[7913];a=l+1|0;c[15824]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function iba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[7917]=0.0;e=c[a>>2]|0;c[15830]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[7917]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[15830]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[7916]=0.0;e=c[a>>2]|0;c[15830]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[7916]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[15830]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function jba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[15848]=0;c[15846]=0;c[15852]=0;h[7929]=+h[b>>3];h[7931]=+iba(f,d,l,0,0);C=c[f>>2]|0;c[15836]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[15836]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[7922]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[15836]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[15836]=G+1}a[63440]=1;c[15838]=0;a[63456]=1;c[C>>2]=(c[C>>2]|0)+1;c[15856]=0;be[B&7](b,d,e,q,63424,n,o)|0;b:do{if((c[15856]|0)<0){K=35}else{while(1){if(a[63440]&1){c[E>>2]=(c[E>>2]|0)+1;a[63440]=0;mba(f,b,d,e,q,63376,k,63400,l,r,s,t,g,63424,v,j,n,o,x)|0;h[7921]=1.0e6;if((c[15856]|0)<0|(c[15850]|0)!=0){K=35;break b}c[15852]=0}H=c[f>>2]|0;c[15836]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[15836]=H+1}nba(f,q,s,t)|0;I=c[f>>2]|0;c[15836]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[7922]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[15836]=I+1}N=+iba(f,q,l,0,0);h[7933]=N;if(N<=+h[v>>3]*100.0*+h[7931]){break}J=c[15838]|0;if((J|0)>0){h[z>>3]=N/+h[7934];h[A>>3]=1.0/+(J|0);O=+Fra(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[7921]=P;Q=+h[7933];R=P}else{h[7934]=N;Q=N;R=+h[7921]}if(R*Q<=.33){break}J=c[15838]|0;H=J+1|0;c[15838]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[63440]=1}c[C>>2]=(c[C>>2]|0)+1;c[15856]=0;be[B&7](b,d,e,q,63424,n,o)|0;if((c[15856]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[15836]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[15836]=H+1}N=+iba(f,q,l,0,0);h[7933]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[15836]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[7922]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[15836]=J+1}}while(0);if(!(a[63456]&1)){break}H=c[f>>2]|0;c[15836]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[15836]=H+1}N=+iba(f,r,l,0,0);h[7927]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[63456]=0}h[b>>3]=+h[7929];G=c[f>>2]|0;c[15836]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[15836]=G+1}if(a[63456]&1){I=(c[15848]|0)+1|0;c[15848]=I;N=.9/(+h[7927]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[7920]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[15850]|0)!=0){I=(c[15852]|0)+1|0;c[15852]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[15856]|0)>-2)){K=53;break}I=(c[15846]|0)+1|0;c[15846]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function kba(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[15882]=o;p=+h[b>>3]- +h[a>>3];h[7939]=p;a=c[f>>2]|0;c[15874]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[15874]=a+1;q=+h[7939]}h[7935]=1.0;h[7936]=0.0;p=q/+h[k>>3];h[7940]=p;c[15876]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[7936]=u*t+s/+h[a>>3];p=t*s;h[7935]=p;h[7940]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[15874]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[7936]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[7935];g=g+1|0}c[15874]=a+1}g=v+1|0;c[15876]=g;if((v|0)>=(o|0)){break}r=+h[7939];s=+h[7935];t=+h[7940];u=+h[7936];v=g}i=l;return 0}function lba(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[7962]=+h[b>>3];c[15902]=0;c[15910]=0;c[15904]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[7974]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[15898]=(c[I>>2]|0)+1;c[15900]=(c[I>>2]|0)+2;c[15896]=(c[I>>2]|0)+ -1;h[7962]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[15914]=$+1;$=c[15898]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[7965]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[15884]=2;if(($|0)>=2){Y=2;while(1){h[7966]=+h[y+(Y+ -2<<3)>>3];U=+h[7965];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[7966];U=+h[7966]+ +h[k>>3];h[7965]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[15884]=$+1}h[y+($+ -1<<3)>>3]=+h[7965]}h[7972]=0.0;h[7970]=0.0;Y=c[I>>2]|0;c[15884]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[7972]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[7970]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[15884]=Y+1;da=ea}h[7973]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[7972]- +h[7970];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[7947]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[7947]=ha>=ca?ha:ca;h[7965]=.6;h[7966]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[7973]){h[D>>3]=100.0}aa=c[15898]|0;ba=c[15914]|0;if((aa|0)>=(ba|0)){c[15886]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[15884]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[15884]=ba+1}ja=ia+1|0;c[15886]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[15884]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[15884]=ia+1}aa=c[15898]|0;c[15886]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[15884]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[15884]=$+1}la=ba+1|0;c[15886]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[7969]=+iba(f,d,l,0,0);a[63800]=1;c[15888]=0;c[T>>2]=(c[T>>2]|0)+1;c[15918]=0;be[m&7](b,d,e,r,63672,o,p)|0;if((c[15918]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;mba(f,b,d,e,r,A,k,63624,l,s,t,u,g,63672,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[15918]|0)<0|(c[15906]|0)!=0){X=70;break}c[15910]=0}ba=c[f>>2]|0;c[15884]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[15884]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[7965]=ca;aa=c[f>>2]|0;c[15884]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[7965];ia=ia+1|0;la=ka}c[15884]=aa+1}nba(f,r,t,u)|0;la=c[f>>2]|0;c[15884]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[15884]=la+1}U=+iba(f,r,l,0,0);h[7974]=U;if(U<=+h[F>>3]*100.0*+h[7969]){X=63;break a}ia=c[15888]|0;if((ia|0)>0){h[O>>3]=U/+h[7976];h[P>>3]=1.0/+(ia|0);ca=+Fra(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[7974];oa=ga}else{h[7976]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[15888]|0;c[15888]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[15918]=0;be[m&7](b,d,e,r,63672,o,p)|0;if((c[15918]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[15884]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[15884]=ba+1}U=+iba(f,r,l,0,0);h[7974]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[15884]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[15884]=ia+1}}while(0);if((X|0)==70){X=0;a[63800]=0}c[H>>2]=1;if(a[63800]&1){U=+iba(f,s,l,0,0);h[7968]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[7954]=ga;h[7961]=ga*+(ba+1|0);h[7956]=ga;c[15920]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[15884]=1;if((ba|0)>=1){aa=fa(c[15898]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[15884]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+iba(f,r,l,0,0);h[7963]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[7971]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[15884]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[15884]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+iba(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[7971];if((sa>=ca?sa:ca)>+h[7961]){break}ta=+h[7963];ua=Y}else{if(!(ga<=+h[7961]*.5)){break}else{ta=U;ua=ka}}c[15920]=ua+ -1;h[7956]=ta}}while(0);if(!(+h[7947]*+h[7968]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[7962];Y=c[15898]|0;ia=c[15914]|0;if((Y|0)>=(ia|0)){c[15886]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[7965]=ca;ia=c[f>>2]|0;c[15884]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[7965];ja=ja+1|0}c[15884]=ia+1}ja=aa+1|0;c[15886]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[15884]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[15884]=Y+1}if(!(a[63800]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[15906]|0)!=0){aa=(c[15910]|0)+1|0;c[15910]=aa;h[7945]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[15918]|0)>-2)){X=146;break}aa=(c[15902]|0)+1|0;c[15902]=aa;h[7945]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[15904]=(c[15904]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[15904]|0;if((aa|0)<=1){ja=c[15920]|0;c[I>>2]=ja;sa=+(ja+1|0);h[7966]=sa;h[O>>3]=+h[7956]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+Fra(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[7945]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[15920];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[15934]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[15920]|0;E=c[15896]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[15898];za=+h[k>>3]*2.0;h[7958]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[15896]|0;Ba=c[15920]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[15898]|0)>=(c[K>>2]|0)|(c[15934]|0)==1){Fa=G;break}G=c[f>>2]|0;c[15884]=1;if((G|0)>=1){E=fa(c[15900]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[15884]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+iba(f,r,l,0,0);h[7964]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[7961];E=xa<=za;if(+h[7971]<=(E?xa:za)){Ea=c[15896]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[7961]*.5){Fa=S;break}}S=c[15898]|0;c[I>>2]=S;h[7956]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[7956]=+h[7963];Fa=Ea}h[7958]=+h[k>>3];ya=+(Fa+1|0);h[7966]=ya;h[O>>3]=+h[7956]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+Fra(O,P);h[7945]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[7958];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[7945]=xa;za=+h[k>>3]*xa;h[7958]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[7958]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[15884]=1;if((k|0)<1){break}u=fa(c[15900]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[15884]=k+1}}while(0);Ca=c[f>>2]|0;c[15884]=1;if((Ca|0)>=1){J=fa(c[15898]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[15884]=Ca+1}Ca=c[15898]|0;c[15892]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[15886]=P;s=c[f>>2]|0;c[15884]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[15884]=s+1}P=Ha+1|0;c[15892]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[15918]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[15904]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}kba(b,b,d,e,f,I,q,y)|0;i=N;return 0}function mba(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==3){i=y;return 0}else if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[15954]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[15954]=P?2:U+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[15988]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==5){R=q+4|0;T=(c[R>>2]|0)+(c[q>>2]|0)|0;S=T+1|0;c[15980]=S;X=c[b>>2]|0;c[15970]=(T|0)<(X|0)?S:X;X=c[q>>2]|0;c[15988]=S+X;c[15974]=X+T;T=(c[b>>2]|0)/(S|0)|0;c[15984]=T+1;S=c[x>>2]|0;c[15982]=S+ -1;c[15992]=S+T;c[s>>2]=0;h[7989]=+V(+(+h[t>>3]));T=c[15970]|0;c[15956]=1;if((T|0)<1){W=75;break}S=r;X=1;while(1){Y=c[b>>2]|0;Z=c[15980]|0;c[15962]=X;_=(Z|0)<0;b:do{if(_?(X|0)>=(Y|0):(X|0)<=(Y|0)){$=Z;aa=X;ba=X;while(1){ca=(ba-aa|0)/($|0)|0;c[15958]=ca+1;da=ba+ -1|0;ea=e+(da<<3)|0;h[p+((c[15982]|0)+ca<<3)>>3]=+h[ea>>3];ga=f+(da<<3)|0;h[p+((c[15992]|0)+ca<<3)>>3]=+h[ga>>3];ha=+h[ea>>3];h[N>>3]=ha;if(!(ha>=0.0)){ia=-ha}else{ia=ha}ha=+h[l>>3]*+h[ga>>3];if(!(ha>=0.0)){ja=-ha}else{ja=ha}ha=ia>=ja?ia:ja;ka=+h[n+(da<<3)>>3];if(!(ka>=0.0)){la=-ka}else{la=ka}h[7986]=+h[7989]*(ha>=la?ha:la);h[N>>3]=+h[l>>3]*+h[ga>>3];ha=+Hra(63888,N);h[7986]=ha;ga=c[15962]|0;da=ga+ -1|0;ea=e+(da<<3)|0;ka=+h[ea>>3];ma=ha+ka-ka;h[7986]=ma;h[ea>>3]=+h[ea>>3]+ma;ea=f+(da<<3)|0;h[ea>>3]=+h[j>>3]*+h[7986]+ +h[ea>>3];ea=ga+Z|0;c[15962]=ea;if(!(_?(ea|0)>=(Y|0):(ea|0)<=(Y|0))){break b}$=c[15980]|0;aa=c[15956]|0;ba=ea}}}while(0);be[S&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}Y=c[b>>2]|0;_=c[15980]|0;Z=c[15956]|0;c[15962]=Z;ba=(_|0)<0;c:do{if(ba?(Z|0)>=(Y|0):(Z|0)<=(Y|0)){aa=_;$=Z;ea=Z;while(1){ga=(ea-$|0)/(aa|0)|0;c[15958]=ga+1;da=ea+ -1|0;ca=e+(da<<3)|0;h[ca>>3]=+h[p+((c[15982]|0)+ga<<3)>>3];ma=+h[p+((c[15992]|0)+ga<<3)>>3];ga=f+(da<<3)|0;h[ga>>3]=ma;ka=+h[ca>>3];h[N>>3]=ka;if(!(ka>=0.0)){na=-ka}else{na=ka}ka=+h[l>>3]*ma;if(!(ka>=0.0)){oa=-ka}else{oa=ka}ka=na>=oa?na:oa;ma=+h[n+(da<<3)>>3];if(!(ma>=0.0)){pa=-ma}else{pa=ma}h[7986]=+h[7989]*(ka>=pa?ka:pa);h[N>>3]=+h[l>>3]*+h[ga>>3];ka=+Hra(63888,N);h[7986]=ka;ga=c[15962]|0;ma=+h[e+(ga+ -1<<3)>>3];ha=ka+ma-ma;h[7986]=ha;ma=1.0/ha;h[7995]=ma;da=ga-(c[R>>2]|0)|0;ca=(da|0)>1?da:1;c[15964]=ca;da=c[b>>2]|0;qa=(c[q>>2]|0)+ga|0;ra=(da|0)<=(qa|0)?da:qa;c[15966]=ra;sa=fa(c[15974]|0,ga)|0;ta=sa-(c[q>>2]|0)|0;c[15968]=ta;c[15954]=ca;if((ca|0)<=(ra|0)){sa=~da;da=~qa;qa=~((sa|0)>(da|0)?sa:da);da=(ca|0)>(qa|0)?ca:qa;ha=ma;qa=ca;while(1){ca=qa+ -1|0;h[p+(ca+ta<<3)>>3]=(+h[o+(ca<<3)>>3]- +h[g+(ca<<3)>>3])*ha;if((qa|0)>=(ra|0)){break}ha=+h[7995];qa=qa+1|0}c[15954]=da+1}qa=ga+_|0;c[15962]=qa;ra=c[15956]|0;if(!(ba?(qa|0)>=(Y|0):(qa|0)<=(Y|0))){ua=ra;break c}aa=c[15980]|0;$=ra;ea=qa}}else{ua=Z}}while(0);Z=ua+1|0;c[15956]=Z;if((ua|0)<(T|0)){X=Z}else{W=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[15976]=0;h[7989]=+V(+(+h[t>>3]));X=c[b>>2]|0;c[15954]=1;d:do{if((X|0)>=1){T=r;R=1;while(1){S=R+ -1|0;ha=+h[e+(S<<3)>>3];h[N>>3]=ha;if(!(ha>=0.0)){va=-ha}else{va=ha}Q=f+(S<<3)|0;ha=+h[l>>3]*+h[Q>>3];if(!(ha>=0.0)){wa=-ha}else{wa=ha}ha=va>=wa?va:wa;ma=+h[n+(S<<3)>>3];if(!(ma>=0.0)){xa=-ma}else{xa=ma}h[7986]=+h[7989]*(ha>=xa?ha:xa);h[N>>3]=+h[l>>3]*+h[Q>>3];ha=+Hra(63888,N);h[7986]=ha;Q=(c[15954]|0)+ -1|0;S=e+(Q<<3)|0;ma=+h[S>>3];ka=ha+ma-ma;h[7986]=ka;h[7993]=+h[S>>3];U=f+(Q<<3)|0;h[7997]=+h[U>>3];h[S>>3]=ka+ +h[S>>3];h[U>>3]=+h[j>>3]*+h[7986]+ +h[U>>3];be[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ka=1.0/+h[7986];h[7995]=ka;U=c[b>>2]|0;c[15960]=1;S=c[15976]|0;if((U|0)>=1){ma=ka;Q=1;P=0;while(1){h[p+(P+S<<3)>>3]=(+h[o+(P<<3)>>3]- +h[g+(P<<3)>>3])*ma;if((Q|0)>=(U|0)){break}Z=Q;ma=+h[7995];Q=Q+1|0;P=Z}c[15960]=U+1}c[15976]=S+(c[b>>2]|0);P=c[15954]|0;Q=P+ -1|0;h[e+(Q<<3)>>3]=+h[7993];h[f+(Q<<3)>>3]=+h[7997];R=P+1|0;c[15954]=R;if((P|0)>=(X|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[15976]=0;X=c[b>>2]|0;if((c[49912>>2]|0)==0){W=42;break}R=$Da(X*20|0)|0;T=F;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(14,1,63984,F);T=E;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(14,0,64008,E);D9(14,1,64016,D);c[15958]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[C>>2]=T+1;P=C+4|0;h[k>>3]=ma;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];D9(14,0,64024,C);T=(c[15958]|0)+1|0;c[15958]=T;}while((T|0)<(c[b>>2]|0))}fe[c[12602]&511](14);D9(14,1,64080,B);c[15954]=1;if((X|0)>=1){T=R+1|0;P=c[15976]|0;Q=1;do{Z=p+(Q+ -1+P<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[15960]=1;Z=P;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[A>>2]=R;ba=A+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];hc(R|0,64064,A|0)|0;ba=c[15960]|0;c[15960]=ba+1;if((ba|0)>=(X|0)){break}Z=c[15976]|0;Y=ba}c[z>>2]=R;D9(14,0,64072,z);Y=c[15976]|0;Z=c[15954]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];P=Y+(c[b>>2]|0)|0;c[15976]=P;Q=Z+1|0;c[15954]=Q;}while((Z|0)<(X|0))}fe[c[12602]&511](14);fe[c[12602]&511](14);aEa(R);W=42}else{X=c[b>>2]|0;Q=fa(X,X)|0;c[15954]=1;if((Q|0)!=0){X=(Q|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(Q|0)){P=P+1|0}else{break}}c[15954]=X?2:Q+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[15976]=0;P=c[b>>2]|0;if((c[49912>>2]|0)==0){W=42;break}R=$Da(P*20|0)|0;T=M;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(14,1,63984,M);T=L;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(14,0,64008,L);D9(14,1,64016,K);c[15958]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[J>>2]=T+1;Z=J+4|0;h[k>>3]=ma;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];D9(14,0,64024,J);T=(c[15958]|0)+1|0;c[15958]=T;}while((T|0)<(c[b>>2]|0))}fe[c[12602]&511](14);D9(14,1,64040,I);c[15954]=1;if((P|0)>=1){T=R+1|0;Q=c[15976]|0;X=1;do{Z=p+(X+ -1+Q<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[15960]=1;Z=Q;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[H>>2]=R;ba=H+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];hc(R|0,64064,H|0)|0;ba=c[15960]|0;c[15960]=ba+1;if((ba|0)>=(P|0)){break}Z=c[15976]|0;Y=ba}c[G>>2]=R;D9(14,0,64072,G);Y=c[15976]|0;Z=c[15954]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];Q=Y+(c[b>>2]|0)|0;c[15976]=Q;X=Z+1|0;c[15954]=X;}while((Z|0)<(P|0))}fe[c[12602]&511](14);fe[c[12602]&511](14);aEa(R);W=42}}while(0);if((W|0)==42){uba(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){Aba(p,63952,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function nba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[16026]=(c[g>>2]|0)+1+(c[e>>2]<<1);Bba(d,64104,a,e,g,e+80|0,b,64112)|0;i=f;return 0}else{yba(d,a,a,e+80|0,b,64112)|0;i=f;return 0}return 0}function oba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[64120]&1)){a[64120]=1;pba(64168,64136,64216,64152,64200,64224,64208,64232)|0;h[8020]=+(c[16042]|0);f=c[16034]|0;h[8016]=+(f|0);if((c[16054]|0)==0){h[8018]=0.0;c[e>>2]=1-f;g=+Gra(64160,e)}else{h[8018]=1.0;c[e>>2]=1-f;g=+Gra(64160,e)*.5}h[8019]=g;h[8023]=g*+h[8020];h[8022]=+(c[16050]|0);h[8024]=+(c[16052]|0);j=+h[8028];h[8031]=j;k=1.0/+h[8029];if(!(k>=j)){break}h[8031]=k*(g+1.0)}}while(0);if((Hba(b,64256,1,1)|0)!=0){g=+h[8019];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64264,1,1)|0)!=0){g=+h[8031];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64272,1,1)|0)!=0){g=+h[8020];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64280,1,1)|0)!=0){g=+h[8023];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64288,1,1)|0)!=0){g=+h[8016];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64296,1,1)|0)!=0){g=+h[8018];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64304,1,1)|0)!=0){g=+h[8022];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64312,1,1)|0)!=0){g=+h[8028];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64320,1,1)|0)!=0){g=+h[8024];h[8030]=g;l=g;i=d;return+l}if((Hba(b,64328,1,1)|0)==0){l=+h[8030];i=d;return+l}else{g=+h[8029];h[8030]=g;l=g;i=d;return+l}return 0.0}function pba(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[64440]&1){q=64808;r=c[16202]|0;c[b>>2]=r;s=64744;t=c[16186]|0;c[d>>2]=t;u=64784;v=c[16196]|0;c[e>>2]=v;w=64792;x=+h[8099];h[f>>3]=x;y=64824;z=c[16206]|0;c[g>>2]=z;A=64872;B=+h[8109];h[j>>3]=B;C=64832;D=c[16208]|0;c[k>>2]=D;E=64880;F=+h[8110];h[l>>3]=F;i=m;return 0}a[64440]=1;h[8100]=0.0;h[8094]=1.0;h[8095]=2.0;qba(64808,64744,64784,64896)|0;h[8090]=+(c[16202]|0);c[n>>2]=0-(c[16186]|0);G=+Gra(64720,n);h[8089]=G;h[8099]=G;H=+h[8095];h[8090]=H/3.0;I=+h[8094];J=I*.5;h[8097]=J;K=-J;h[o>>3]=K;h[8111]=+rba(64720,o);L=64888;h[8108]=+rba(L,L);h[o>>3]=K;h[8090]=+rba(64864,o);K=+rba(64720,64888);h[8090]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[8090]=K;h[8099]=1.0;M=+h[8100];if(K<1.0&K>M){N=K;while(1){h[8099]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+rba(o,p);h[8091]=K;h[o>>3]=-K;h[8091]=+rba(64776,o);K=+rba(64776,64728);h[8090]=K;h[o>>3]=-K;h[8091]=+rba(64776,o);K=+rba(64776,64728);h[8090]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[8099]=G}G=I/+(c[16202]|0);h[8102]=G;h[8106]=I;c[16184]=1;p=1;O=I;do{h[o>>3]=O*G;O=+rba(o,64800);h[8106]=O;p=p+1|0;c[16184]=p;}while((p|0)<4);h[8089]=+rba(64752,64848);sba(64912,64752,64808)|0;h[o>>3]=-+h[8094];sba(64904,o,64808)|0;sba(64856,64712,64808)|0;h[o>>3]=-+h[8089];sba(64840,o,64808)|0;c[16192]=0;p=c[16228]|0;L=c[16226]|0;P=c[16214]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[16210]|0)){if(Q){c[16206]=p;R=0;S=25;break}if((P-p|0)==3){c[16206]=p+ -1+(c[16186]|0);c[16192]=1;R=1;S=25;break}else{c[16206]=(p|0)<=(P|0)?p:P;a[64448]=1;S=26;break}}else{T=Q&(L|0)==(c[16210]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[16206]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[16206]=(p|0)<=(L|0)?p:L;a[64448]=1;S=26;break}}T=c[16210]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[16206]=(V|0)<=(T|0)?V:T;a[64448]=1;S=26;break}if((P-U|0)==3){c[16206]=((p|0)>=(L|0)?p:L)+ -1+(c[16186]|0);R=0;S=25;break}else{c[16206]=U;a[64448]=1;S=26;break}}}while(0);if((S|0)==25){if(a[64448]&1){S=26}else{W=R}}if((S|0)==26){a[64440]=0;Esa(64920)|0;Vra(64944,64824,4)|0;msa()|0;W=c[16192]|0}if((W|0)==0){X=(c[16224]|0)!=0|0}else{X=1}c[16192]=X;h[8109]=1.0;X=c[16206]|0;W=1-X|0;c[n>>2]=W;c[16184]=1;if((X|0)<=0){O=+h[8102];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+rba(o,64800);h[8109]=I;n=X+1|0;c[16184]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}tba(64808,64744,64824,64768,64832,64880)|0;q=64808;r=c[16202]|0;c[b>>2]=r;s=64744;t=c[16186]|0;c[d>>2]=t;u=64784;v=c[16196]|0;c[e>>2]=v;w=64792;x=+h[8099];h[f>>3]=x;y=64824;z=c[16206]|0;c[g>>2]=z;A=64872;B=+h[8109];h[j>>3]=B;C=64832;D=c[16208]|0;c[k>>2]=D;E=64880;F=+h[8110];h[l>>3]=F;i=m;return 0}function qba(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[64336]&1){l=a[64408]&1;m=c[16104]|0;c[b>>2]=m;n=64384;o=c[16096]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=64432;r=c[16108]|0;c[f>>2]=r;i=g;return 0}a[64336]=1;h[8049]=1.0;h[8043]=1.0;h[8045]=1.0;s=1.0;do{s=s*2.0;h[8043]=s;h[8045]=+rba(64344,64392);h[j>>3]=-s;t=+rba(64360,j);h[8045]=t;}while(t==1.0);h[8044]=1.0;t=+rba(64344,64352);h[8045]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[8044]=v;w=+rba(64344,64352);h[8045]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[8050]=.25;h[8053]=x;h[j>>3]=-s;t=+rba(64360,j);h[8045]=t;y=~~(t+.25);c[16104]=y;t=+(y|0);h[8044]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[8046]=+rba(j,k);w=+rba(64368,64344);h[8045]=w;z=w==s;a[64408]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[8046]=+rba(j,k);w=+rba(64368,64344);h[8045]=w;if(z&w==s){a[64408]=0;A=0}else{A=z}h[j>>3]=u;w=+rba(j,64344);h[8047]=w;h[j>>3]=u;z=w==s&+rba(j,64424)>x;c[16108]=z?A&1:0;c[16096]=0;h[8043]=1.0;h[8045]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[16096]=k;s=x*t;h[8043]=s;h[8045]=+rba(64344,64392);h[j>>3]=-s;w=+rba(64360,j);h[8045]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=64384;o=c[16096]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=64432;r=c[16108]|0;c[f>>2]=r;i=g;return 0}function rba(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function sba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[8119]=g;j=1.0/+(c[d>>2]|0);h[8128]=j;h[8127]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+rba(f,65016);h[8121]=k;h[8123]=g;h[8124]=g;h[8125]=g;h[8126]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[8119]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+rba(f,65016);h[8121]=g;h[f>>3]=g*k;k=+rba(f,65016);h[8123]=k;h[8125]=0.0;c[16240]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[8125]=q;c[16240]=b+1;n=q}h[f>>3]=m*j;p=+rba(f,65016);h[8122]=p;h[f>>3]=p/j;r=+rba(f,65016);h[8124]=r;h[8126]=0.0;o=c[d>>2]|0;c[16240]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[8126]=v;c[16240]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function tba(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[16264]=1;c[16272]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[16264]=q;r=l+1|0;c[16272]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[16268]=n;u=n}else{c[16268]=m;c[16272]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[16274]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[16272]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[8135]=x;y=w+-1.0;h[8131]=y;h[8130]=0.0;v=c[b>>2]|0;c[16258]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[8131]=B;if(w<1.0){h[8133]=w}C=+rba(65040,65048);h[8130]=C;e=b+1|0;c[16258]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[8133];h[8130]=A;z=A}}while(0);v=c[f>>2]|0;c[16258]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+rba(k,65104);h[8130]=z;f=E+1|0;c[16258]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function uba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[16280]=1;m=1;do{c[16286]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=vba(j,a+(m+b+(fa(m,l)|0)<<3)|0,65152)|0;q=c[16280]|0;r=p+ -1+q|0;c[16282]=r;c[e+(q+ -1<<2)>>2]=r;r=c[16282]|0;q=c[16280]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[8142]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[8142];t=q}u=fa(t,l)|0;h[8142]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;wba(j,65136,a+(t-l+u<<3)|0,65152)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[16286]|0;c[16278]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[16282]|0;x=fa(w,l)|0;h[8142]=+h[a+(x+b+v<<3)>>3];y=c[16280]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[8142];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=65152;xba(k,65136,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[16278]|0;w=A+1|0;c[16278]=w;}while((A|0)<(u|0))}}while(0);q=c[16280]|0;m=q+1|0;c[16280]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function vba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[16378]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[8190]=k;l=(c[d>>2]|0)+1|0;c[16378]=l;m=c[a>>2]|0;c[16376]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[8190]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[16378]=l;a=n+1|0;c[16376]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[8190]=v;c[16376]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[8190]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[16376]=f+1;g=C;i=e;return g|0}function wba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[16362]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[16362]=l;i=f;return 0}l=(g|0)%5|0;c[16364]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[16362]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[16362]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[16362]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[16362]=o;i=f;return 0}function xba(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[16348]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[16346]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[16346]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[16346]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[16346]=s;i=j;return 0}}while(0);c[16350]=1;c[16352]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[16350]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[16352]=s;u=s}else{u=1}s=c[a>>2]|0;c[16346]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[16350]=t;u=x+(c[g>>2]|0)|0;c[16352]=u;a=w+1|0;c[16346]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function yba(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[16298]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[16290]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[16292]=o;p=f+(o+ -1<<3)|0;h[8147]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[8147]}c[k>>2]=(c[d>>2]|0)-m;o=65152;xba(k,65176,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[16290]|0;m=o+1|0;c[16290]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[16296]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[16290]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[8147]=-s;c[k>>2]=g;g=65152;xba(k,65176,a+(p-l<<3)|0,g,f,g)|0;g=c[16296]|0;q=g+1|0;c[16296]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[16290]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=65152;s=+zba(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[8147]=s;q=c[16290]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[16290]=n;}while((q|0)<(m|0));t=c[16298]|0}if((t|0)<1){i=j;return 0}c[16296]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[16290]=n;c[k>>2]=(c[d>>2]|0)-n;b=65152;s=+zba(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[16290]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[16292]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[8147]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[8147]}q=c[16296]|0;m=q+1|0;c[16296]=m;}while((q|0)<(t|0));i=j;return 0}function zba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[8187]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[16368]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[16366]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[8187]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[16366]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[16366]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[8187]=t;u=u+5|0;}while((u|0)<=(m|0));c[16366]=u;k=t;i=g;return+k}}while(0);c[16370]=1;c[16372]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[16370]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[16372]=u;y=u}else{y=1}u=c[a>>2]|0;c[16366]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[8187]=t;x=C+(c[d>>2]|0)|0;c[16370]=x;y=B+(c[f>>2]|0)|0;c[16372]=y;a=z+1|0;c[16366]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function Aba(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[16308]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[16314]=n;o=c[d>>2]|0;p=c[16308]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[16316]=o;do{if((q|0)>(n|0)){c[16324]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[16312]=s;t=c[e>>2]|0;c[16300]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[16300]=t+1}u=r+1|0;c[16324]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[16324]=o;c[16322]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[16304]=1;t=o;o=1;while(1){c[16326]=o+1;p=t+1|0;c[16324]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[16300]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[16300]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[16318]=s;c[l>>2]=s+1;s=vba(l,a+((c[16308]|0)+b+(fa(o,m)|0)<<3)|0,65152)|0;p=s+ -1|0;c[16306]=p+(c[16308]|0);s=c[16304]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[16306]|0;p=c[16304]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[16308]|0;if((s|0)==(u|0)){y=s}else{h[8155]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[8155];y=u}h[8155]=-1.0/+h[a+(y+b+n<<3)>>3];wba(65272,65240,a+(y-m+n<<3)|0,65152)|0;u=c[16322]|0;z=(c[g+((c[16304]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[16322]=u;A=c[16308]|0;c[16320]=A;z=c[16326]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[16302]=z;B=z;z=A;while(1){A=(c[16306]|0)+ -1|0;c[16306]=A;C=z+ -1|0;c[16320]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[8155]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[8155];F=C}C=65152;xba(65272,65240,a+((c[16308]|0)-m+(fa(c[16304]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[16302]|0;D=C+1|0;c[16302]=D;if((C|0)>=(u|0)){break a}B=D;z=c[16320]|0}}}while(0);n=c[16304]|0;s=n+1|0;c[16304]=s;if((n|0)>=(r|0)){break}t=c[16324]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[16308]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function Bba(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[16332]=n;f=c[d>>2]|0;o=f+ -1|0;c[16344]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[16328]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[16342]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[16330]=k;q=j+(k+ -1<<3)|0;h[8167]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[8167]}k=65152;xba(65368,65336,a+((c[16332]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[16328]|0;f=k+1|0;c[16328]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[16336]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[16328]=k;q=c[16332]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[16342]=s;u=q-s|0;c[16338]=u;q=k-s|0;c[16340]=q;h[8167]=-t;s=65152;xba(65368,65336,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[16336]|0;r=s+1|0;c[16336]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[16328]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[16342]=r;s=o-r|0;c[16338]=s;q=n-r|0;c[16340]=q;r=65152;t=+zba(65368,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[8167]=t;r=c[16328]|0;q=j+(r+ -1<<3)|0;o=c[16332]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[16328]=n;}while((r|0)<(f|0));v=o;w=c[16344]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[16336]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[16328]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[16342]=(n|0)<=(b|0)?n:b;b=65152;t=+zba(65368,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[16328]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[16330]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[8167]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[8167]}n=c[16336]|0;b=n+1|0;c[16336]=b;if((n|0)>=(w|0)){break}o=c[16332]|0;v=b}i=l;return 0}function Cba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[16356]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[16354]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[16354]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[16354]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[16354]=o;i=g;return 0}}while(0);c[16358]=1;c[16360]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[16358]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[16360]=o;q=o}else{q=1}o=c[a>>2]|0;c[16354]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[16358]=p;q=s+(c[f>>2]|0)|0;c[16360]=q;a=r+1|0;c[16354]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function Dba(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+Eba(65528);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+Fba(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+Fba(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+Fba(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+Fba(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function Eba(a){a=a|0;i=i;return+(+h[65536+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function Fba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function Gba(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+Eba(65568);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+Fba(b,e);c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){Oba(b,b,f,g,65576,N,65568,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+Fba(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=WEa(ga|0,0,Z+ -2|0,0)|0;Z=PEa(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}Nba(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ge[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);Dba(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+Fba(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ge[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+Fba(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+Fba(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+Fba(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}Qba(b,b,s,t,v,w,x,D)|0;Pba(b,b,f,g,w,x)|0;W=65568;Pba(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ge[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}



function Hba(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[65600]=1;f=d[b]|0;c[16396]=f;b=d[e]|0;c[16398]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[16396]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[16398]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function Iba(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[75132>>2]=6;Esa(75128)|0;Vra(75872,j,4)|0;msa()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[18084]=0;c[18690]=0;c[18678]=0;a[74736]=0;t=c[e>>2]|0;c[17638]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[18084]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[17638]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[17638]=1;if((v|0)>=1){x=1;while(1){h[67024+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[17638]=v+1}c[18682]=2;x=c[e>>2]|0;c[17638]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[17640]=1;if((E|0)<1){F=C}else{G=1;while(1){h[67024+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[17640]=E+1;F=+h[B>>3]}h[67024+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[18682]=G;D=G}G=z+1|0;c[17638]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[18084]|0;y=z+1|0;c[18080]=y;c[17638]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[17640]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[67024+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[17640]=x+1}le[u&63](e,b,70384+(z+ -1<<3)|0)|0;c[18690]=(c[18690]|0)+1;if((c[j>>2]|0)>=1){c[75156>>2]=6;Esa(75152)|0;Vra(75872,74760,4)|0;Vra(75872,70384+((c[17638]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[17640]=1;if((v|0)>=1){A=1;do{Vra(75872,b+(A+ -1<<3)|0,8)|0;B=c[17640]|0;A=B+1|0;c[17640]=A;}while((B|0)<(v|0))}msa()|0}v=c[17638]|0;z=v+1|0;c[17638]=z;}while((v|0)<(y|0))}y=c[18678]|0;b:while(1){c[18678]=y+1;c[18590]=1;c[18586]=1;C=+h[8798];h[9294]=C;h[9296]=C;z=c[18080]|0;c[17638]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[70384+(A+ -1<<3)>>3];do{if(!(C<=K)){c[18590]=A;L=+h[70384+(A+ -1<<3)>>3];h[9294]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[18586]=A;L=+h[70384+(A+ -1<<3)>>3];h[9296]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[17638]=z+1;H=O}A=c[e>>2]|0;c[17638]=1;if((A|0)>=1){v=1;while(1){h[72504+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[17638]=A+1}c[17638]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[17640]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=72504+(Q+ -1<<3)|0;h[B>>3]=+h[67024+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[17640]=x+1;P=v}}while(0);v=P+1|0;c[17638]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[17640]=1;if((z|0)>=1){K=+(c[18084]|0);v=1;while(1){A=72504+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[17640]=z+1}v=c[e>>2]|0;c[17638]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[72504+(B<<3)>>3];h[74784+(B<<3)>>3]=K+(K- +h[67024+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[17638]=v+1}le[u&63](e,74784,74776)|0;A=(c[18690]|0)+1|0;c[18690]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[75180>>2]=6;Esa(75176)|0;Vra(75872,74760,4)|0;Vra(75872,74776,8)|0;B=c[e>>2]|0;c[17640]=1;if((B|0)>=1){E=1;do{Vra(75872,74784+(E+ -1<<3)|0,8)|0;G=c[17640]|0;E=G+1|0;c[17640]=E;}while((G|0)<(B|0))}msa()|0}}while(0);K=+h[9347];c:do{if(!(K>=+h[9296])){z=c[e>>2]|0;c[17638]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[72504+(v<<3)>>3];h[74952+(v<<3)>>3]=I+(+h[74784+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[17638]=z+1}le[u&63](e,74952,74944)|0;A=(c[18690]|0)+1|0;c[18690]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[75204>>2]=6;Esa(75200)|0;Vra(75872,74760,4)|0;Vra(75872,74944,8)|0;B=c[e>>2]|0;c[17640]=1;if((B|0)>=1){E=1;do{Vra(75872,74952+(E+ -1<<3)|0,8)|0;G=c[17640]|0;E=G+1|0;c[17640]=E;}while((G|0)<(B|0))}msa()|0}}while(0);I=+h[9368];if(I>=+h[9296]){R=118;break}v=c[e>>2]|0;c[17638]=1;A=c[18590]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[67024+((z*21|0)+ -22+A<<3)>>3]=+h[74952+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[17638]=v+1}h[70384+(A+ -1<<3)>>3]=I}else{z=c[18080]|0;c[17638]=1;if((z|0)>=1){B=c[18590]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[70384+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[17638]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[9294])){E=c[e>>2]|0;c[17638]=1;z=c[18590]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[67024+((B*21|0)+ -22+z<<3)>>3]=+h[74784+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[17638]=E+1}h[9294]=K;h[70384+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[17638]=1;if((B|0)>=1){A=c[18590]|0;v=1;while(1){x=v+ -1|0;h[74952+(x<<3)>>3]=+h[67024+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[72504+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[17638]=B+1}le[u&63](e,74952,74944)|0;v=(c[18690]|0)+1|0;c[18690]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[75228>>2]=6;Esa(75224)|0;Vra(75872,74760,4)|0;Vra(75872,74944,8)|0;z=c[e>>2]|0;c[17640]=1;if((z|0)>=1){E=1;do{Vra(75872,74952+(E+ -1<<3)|0,8)|0;x=c[17640]|0;E=x+1|0;c[17640]=E;}while((x|0)<(z|0))}msa()|0}}while(0);I=+h[9368];if(!(I>+h[9294])){A=c[e>>2]|0;c[17638]=1;v=c[18590]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[67024+((B*21|0)+ -22+v<<3)>>3]=+h[74952+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[17638]=A+1}h[70384+(v+ -1<<3)>>3]=I;break}B=c[18080]|0;c[17638]=1;if((B|0)<1){break}else{S=1}do{z=c[18586]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[17640]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=67024+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[67024+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[67024+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[17640]=E+1}le[u&63](e,b,70384+(S+ -1<<3)|0)|0;G=(c[18690]|0)+1|0;c[18690]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[75252>>2]=6;Esa(75248)|0;Vra(75872,74760,4)|0;Vra(75872,70384+((c[17638]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[17640]=1;if((x|0)>=1){G=1;do{Vra(75872,b+(G+ -1<<3)|0,8)|0;T=c[17640]|0;G=T+1|0;c[17640]=G;}while((T|0)<(x|0))}msa()|0}}while(0);z=c[17638]|0;S=z+1|0;c[17638]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[17638]=1;v=c[18590]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[67024+((A*21|0)+ -22+v<<3)>>3]=+h[74784+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[17638]=B+1}h[70384+(v+ -1<<3)>>3]=+h[9347]}A=c[18678]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[9297]=0.0;h[9343]=0.0;A=c[18080]|0;c[17638]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[9343]=0.0/K;c[17638]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[70384+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[9343]=I;c[17638]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[70384+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[9297]=$;c[17638]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[9297]=I;do{if(!(I<=+h[k>>3])){if((c[18690]|0)>(c[g>>2]|0)){break}a[74736]=0;c[18678]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[17638]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[17640]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[67024+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[17640]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[17638]=v+1}le[u&63](e,b,f)|0;B=(c[18690]|0)+1|0;c[18690]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[75276>>2]=6;Esa(75272)|0;Vra(75872,74760,4)|0;Vra(75872,s,8)|0;z=c[e>>2]|0;c[17640]=1;if((z|0)>=1){E=1;do{Vra(75872,b+(E+ -1<<3)|0,8)|0;x=c[17640]|0;E=x+1|0;c[17640]=E;}while((x|0)<(z|0))}msa()|0;ba=c[18690]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[75396>>2]=6;Esa(75392)|0;msa()|0;c[75420>>2]=6;Esa(75416)|0;B=c[e>>2]|0;c[17638]=1;if((B|0)>=1){A=1;do{Vra(75872,b+(A+ -1<<3)|0,8)|0;v=c[17638]|0;A=v+1|0;c[17638]=A;}while((v|0)<(B|0))}msa()|0;c[75444>>2]=6;Esa(75440)|0;Vra(75872,s,8)|0;msa()|0}if(a[74736]&1){I=+h[9343];K=+h[9389]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[74736]=1;da=+h[9343]}h[9389]=da;c[18678]=0;y=0}if((c[j>>2]|0)>=0){c[75468>>2]=6;Esa(75464)|0;Vra(75872,74760,4)|0;msa()|0;c[75492>>2]=6;Esa(75488)|0;y=c[e>>2]|0;c[17638]=1;if((y|0)>=1){B=1;do{Vra(75872,b+(B+ -1<<3)|0,8)|0;A=c[17638]|0;B=A+1|0;c[17638]=B;}while((A|0)<(y|0))}msa()|0;c[75516>>2]=6;Esa(75512)|0;Vra(75872,s,8)|0;msa()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[75540>>2]=6;Esa(75536)|0;msa()|0}h[9296]=+h[f>>3];c[18692]=0;y=c[18080]|0;c[17638]=1;if((y|0)>=1){B=1;while(1){A=70384+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[17638]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[17640]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=67024+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[74952+(E+ -1<<3)>>3]=+h[67024+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[17640]=v+1}le[u&63](e,74952,A)|0;c[18692]=(c[18692]|0)+1;c[18690]=(c[18690]|0)+1;E=c[17638]|0;I=+h[70384+(E+ -1<<3)>>3];if(I>=+h[9296]){B=E;continue}h[9296]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[75564>>2]=6;Esa(75560)|0;Vra(75872,74760,4)|0;Vra(75872,74368,8)|0;E=c[e>>2]|0;c[17640]=1;if((E|0)>=1){z=1;do{Vra(75872,74952+(z+ -1<<3)|0,8)|0;G=c[17640]|0;z=G+1|0;c[17640]=z;}while((G|0)<(E|0))}msa()|0;B=c[17638]|0}}B=c[18084]|0;c[17638]=1;do{if((B|0)<1){h[8823]=+h[8798];c[17638]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[17648]=E;z=c[e>>2]|0;c[17640]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[74784+(A+ -1<<3)>>3]=(+h[67024+(v+ -21<<3)>>3]+ +h[67024+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[17640]=z+1}le[u&63](e,74784,72344+(y+ -1<<3)|0)|0;c[18692]=(c[18692]|0)+1;c[18690]=(c[18690]|0)+1;A=c[17638]|0;y=A+1|0;c[17638]=y;}while((A|0)<(B|0));y=c[18084]|0;I=+h[8798];h[8823]=I;c[17638]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[17648]=A;c[17650]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[17640]=1;E=1;while(1){v=E+1|0;c[17652]=v;G=c[e>>2]|0;c[17642]=1;if((G|0)>=1){x=c[17650]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[74952+(T+ -1<<3)>>3]=(+h[67024+(U+x<<3)>>3]+ +h[67024+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[17642]=G+1}le[u&63](e,74952,74944)|0;c[18692]=(c[18692]|0)+1;c[18690]=(c[18690]|0)+1;T=c[17638]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[17640]|0;la=U+x|0;c[17644]=la;I=+h[8823];h[72664+(la+ -1<<3)>>3]=(+h[9368]+I- +h[72344+(v<<3)>>3]- +h[72344+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[17640]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[17638]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[18084]|0;c[17644]=0;c[17638]=1;E=(y|0)<1;if(E){c[17638]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=WEa(A|0,0,y+ -2|0,0)|0;A=PEa(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[72664+(U+ -1<<3)>>3]=(+h[70384+(v<<3)>>3]+ka- +h[72344+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[17648]=v+1;c[17644]=(z|1)+A;c[17638]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=72344+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[70384+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[17648]=T+1;c[17638]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[17644]=0;c[17638]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[17638]=1;if((B|0)>=1){A=1;while(1){h[74384+(A+ -1<<3)>>3]=+h[67024+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[17638]=B+1}c[17638]=1;do{if(ma){c[17638]=1}else{A=1;while(1){z=A+1|0;c[17648]=z;v=c[e>>2]|0;c[17640]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=67024+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[67024+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[17640]=v+1}c[17638]=z;if((A|0)<(na|0)){A=z}else{break}}c[17638]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[17648]=A;y=c[e>>2]|0;c[17640]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[67024+(T+oa<<3)>>3]=+h[67024+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[17640]=y+1}c[17638]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=72664;Jba(B,72336,B,74544,75120,q,74704)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[75588>>2]=6;Esa(75584)|0;msa()|0}c[q>>2]=2;if((c[18690]|0)>(c[g>>2]|0)){R=312;break}c[75612>>2]=6;Esa(75608)|0;msa()|0;B=c[e>>2]|0;c[17638]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[17638]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[75300>>2]=6;Esa(75296)|0;Vra(75872,g,4)|0;msa()|0;c[75324>>2]=6;Esa(75320)|0;Vra(75872,74376,8)|0;msa()|0;c[75348>>2]=6;Esa(75344)|0;u=c[e>>2]|0;c[17638]=1;if((u|0)>=1){E=1;do{Vra(75872,b+(E+ -1<<3)|0,8)|0;z=c[17638]|0;E=z+1|0;c[17638]=E;}while((z|0)<(u|0))}msa()|0;c[75372>>2]=6;Esa(75368)|0;Vra(75872,s,8)|0;msa()|0;i=r;return 0}else if((R|0)==226){u=c[18084]|0;c[18688]=u-(c[18780]|0);c[17638]=1;E=(u|0)<1;do{if(E){h[9340]=0.0;c[17638]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[70384+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=70384+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[72664+(sa+ -1<<3)>>3]*+h[72344+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[17644]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[17640]=z;h[9340]=0.0;c[17638]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[70384+(v<<3)>>3]*+h[72344+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[9340]=wa;c[17638]=u+1;qa=wa}}while(0);h[9340]=+h[8823]-qa;s=c[e>>2]|0;c[17638]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[74952+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=74952+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[70384+(T+ -1<<3)>>3]*+h[67024+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[17638]=s+1;c[17640]=xa}v=c[e>>2]|0;c[17638]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=74384+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[74952+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[17638]=v+1}if((c[j>>2]|0)>=0){c[75636>>2]=6;Esa(75632)|0;Vra(75872,74720,8)|0;z=c[e>>2]|0;c[17638]=1;if((z|0)>=1){s=1;do{Vra(75872,74384+(s+ -1<<3)|0,8)|0;u=c[17638]|0;s=u+1|0;c[17638]=s;}while((u|0)<(z|0))}msa()|0;c[75660>>2]=6;Esa(75656)|0;msa()|0}z=c[e>>2]|0;c[17638]=1;if((z|0)>=1){s=c[18084]|0;v=1;while(1){c[17640]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[70384+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=70384+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[72664+(Aa+ -1<<3)>>3]*+h[67024+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[17644]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[17642]=E;c[17640]=s+1}T=c[e>>2]|0;c[17640]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=70640+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[70384+(Ea+ -1<<3)>>3]*+h[67024+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[17640]=T+1;c[17644]=Ca;c[17642]=Da}za=v+1|0;c[17638]=za;if((v|0)<(z|0)){v=za}else{break}}}c[17640]=0;v=c[e>>2]|0;c[17638]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[70640+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[17640]=Ga;c[17638]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[75684>>2]=6;Esa(75680)|0;Vra(75872,74752,4)|0;msa()|0;c[18082]=1;z=1;d:while(1){c[17644]=z;do{if((z|0)>(c[e>>2]|0)){s=c[18082]|0;if((s|0)==1){c[75708>>2]=6;Esa(75704)|0;msa()|0;Jba(70640,72336,72664,74544,75120,q,74704)|0;c[75732>>2]=6;Esa(75728)|0;msa()|0;c[18082]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[18082]=2;c[17654]=0;c[17656]=0;s=c[e>>2]|0;c[17638]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=WEa(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=PEa(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=70640+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=70640+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[70640+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[17658]=Na;c[17656]=Ta;c[17654]=Ia;c[17640]=Ma;c[17638]=s+1}c[75756>>2]=6;Esa(75752)|0;msa()|0;c[17654]=0;u=c[e>>2]|0;c[17638]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=70640+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[17654]=Wa;c[17638]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[17654]=T;s=c[e>>2]|0;c[17638]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[17648]=B;Qa=za+la|0;c[17654]=Qa;Pa=B+5|0;c[17650]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[18082]|0)==3){c[75828>>2]=6;Esa(75824)|0;Pa=c[17650]|0;Qa=c[17648]|0;c[17640]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{Vra(75872,72664+(B+ -1<<3)|0,8)|0;Qa=c[17640]|0;B=Qa+1|0;c[17640]=B;}while((Qa|0)<(Pa|0))}msa()|0}else{c[75804>>2]=6;Esa(75800)|0;Pa=c[17650]|0;B=c[17648]|0;c[17640]=B;if((B|0)<=(Pa|0)){x=B;do{Vra(75872,70640+(x+ -1<<3)|0,8)|0;B=c[17640]|0;x=B+1|0;c[17640]=x;}while((B|0)<(Pa|0))}msa()|0}Pa=c[17638]|0;x=Pa+1|0;c[17638]=x;if((Pa|0)>=(s|0)){break e}E=c[17644]|0;la=c[17654]|0;za=x}}}while(0);c[75852>>2]=6;Esa(75848)|0;msa()|0;z=(c[17644]|0)+6|0}c[75780>>2]=6;Esa(75776)|0;Vra(75872,74768,4)|0;msa()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);le[p&63](e,b,f)|0;i=r;return 0}function Jba(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[18988]=c[b>>2];c[g>>2]=1;if((c[18988]|0)<1){i=k;return 0}c[g>>2]=0;Kba(a,75952,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[18988]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[18980]=f;c[18986]=g;c[18992]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=WEa(a|0,0,g+ -2|0,0)|0;m=PEa(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[18972]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=WEa(p|0,0,a-n|0,0)|0;p=PEa(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[18972]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[18970]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[18970]=j}c[18982]=g;c[18984]=f;c[18990]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[9489]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[9489]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[9489]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[18990]=D;E=v+ -1|0;c[18982]=E;F=w+ -1|0;c[18984]=F;q=D;v=E;w=F}c[18974]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[18976]=t;c[18986]=0;c[18992]=l-g;i=k;return 0}function Kba(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[9503]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[9503]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[9503];c[18996]=1;c[18998]=0;n=c[b>>2]|0;c[19010]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[19e3]=0;c[19012]=1;do{if((o|0)>=1){p=1;q=c[18998]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[9502]=m;u=(p|0)==(o|0);if(u){l=m*+h[9503];h[9504]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[9502]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[9504]=+h[9504]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[19e3]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[19e3]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[9502];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[19012]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[18994]=y;c[19002]=x;c[18998]=s;break}else if((D|0)==26){D=0;c[18994]=y;c[19002]=x;c[18998]=s;break}}}while(0);m=+V(+(+h[9504]));h[9504]=m;H=+h[9502];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[18998]|0)+ -1<<3)>>3]=G;G=+h[9504]/+h[9502];h[j+((c[18994]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[18998]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[18996]|0;O=c[19010]|0}}while(0);b=N+O|0;c[18996]=b;o=O+1|0;c[19010]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[18994]=y;c[19002]=x;c[18998]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function Lba(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[19036]=n;o=(c[d>>2]|0)-n|0;c[19058]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[19056]=s;a[76168]=1;t=c[b>>2]|0;u=t+1|0;c[19052]=u;v=c[b>>2]|0;w=u+v|0;c[19050]=w;u=w+(c[b>>2]|0)|0;c[19054]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[19044]=w;x=w+(c[d>>2]|0)|0;c[19038]=x;y=x+(c[b>>2]|0)|0;c[19040]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[19046]=z;A=z+(c[d>>2]|0)|0;c[19060]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[19062]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[19034]=C;D=C+(c[b>>2]|0)|0;c[19048]=D;Mba(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,76224,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);Esa(76256)|0;msa()|0;i=m;return 0}function Mba(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[9617]=.5;h[9608]=1.0;h[9648]=.1;F=(c[a>>2]|0)+1|0;c[19212]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[19204]=H;I=(c[b>>2]|0)-F|0;c[19258]=I;F=c[j>>2]|0;c[19312]=(F|0)<1?1:F;F=c[a>>2]|0;c[19196]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[19198]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[19198]=J+1}L=c[u>>2]|0;c[19194]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[19194]=L+1}K=j+1|0;c[19196]=K;if((j|0)<(F|0)){j=K}else{break}}}c[19200]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[19200]=H+1}H=c[b>>2]|0;c[19198]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[19196]=M;c[19198]=H+1}N=+h[e>>3];O=N*N;h[9653]=O;h[9639]=+h[9608]/O;h[9640]=+V(+(+h[9617]))/O;c[19202]=0;H=y;y=A;M=0;a:while(1){c[19214]=M;F=M-(c[a>>2]|0)|0;c[19238]=F;j=M+1|0;c[19202]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[19288]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[19226]=L;K=L+G|0;c[19224]=K;if((K|0)>(c[a>>2]|0)){c[19288]=L;G=K-(c[a>>2]|0)|0;c[19226]=G;c[19224]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[9630]=O;L=c[19212]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[9630]=N;R=N}else{R=O}O=+h[e>>3];h[9631]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[9631]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[9631];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[19196]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[19196]=S+1}if((M|0)>=(c[19312]|0)){T=j;U=159;break}while(1){le[H&63](a,d,76768)|0;if((c[g>>2]|0)==3){Esa(77296)|0;Vra(77464,76808,4)|0;Vra(77464,76768,8)|0;I=c[a>>2]|0;c[19194]=1;if((I|0)>=1){F=1;do{Vra(77464,d+(F+ -1<<3)|0,8)|0;L=c[19194]|0;F=L+1|0;c[19194]=F;}while((L|0)<(I|0))}msa()|0}I=c[19202]|0;do{if((I|0)>(c[b>>2]|0)){F=c[19242]|0;if((F|0)==-1){break a}h[9649]=0.0;c[19200]=0;L=c[a>>2]|0;c[19196]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[9649]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[9622]=N;if((X|0)==(G|0)){ea=N*+h[9617];h[9622]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[9649]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[19200]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[19194]=Y;c[19196]=L+1;W=Z}J=c[b>>2]|0;c[19198]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[9649]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[19198]=J+1;ia=ja}O=+h[9596];ba=+h[9625];N=O-ba-ia;h[9616]=N;h[9635]=+h[9634];h[9634]=+h[9633];if(!(N>=0.0)){ka=-N}else{ka=N}h[9633]=ka;if(+h[9645]>+h[9611]){c[19286]=I}h[9641]=ba;do{if(O<ba){h[9625]=O;h[9658]=0.0;G=c[a>>2]|0;c[19194]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[9658]=+h[9658]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[19194]=G+1;h[A>>3]=ma}}while(0);c[19284]=F;if((F|0)<=0){O=+h[9649];if(O>=0.0){U=190;break a}ba=+h[9596];N=+h[9641];ea=(ba-N)/O;h[9646]=ea;O=+h[9648];do{if(!(ea<=O)){na=+h[9617]*+h[9638];h[A>>3]=na;oa=+h[9645];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[9638]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[9638]=qa;ra=qa;break}}else{qa=+h[9617]*+h[9645];h[9638]=qa;ra=qa}}while(0);ea=+h[9611];if(!(ra<=ea*1.5)){sa=ra}else{h[9638]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[9653]=ea;c[19300]=0;h[9654]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[19256]|0;c[19300]=J;oa=+h[9608];h[9654]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[19198]=1;if((J|0)<1){va=F}else{L=c[19258]|0;oa=ua;K=1;ca=F;while(1){h[9636]=0.0;c[19196]=1;if((L|0)<1){wa=0.0}else{X=c[19218]|0;aa=K+C|0;qa=+h[9608];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[9622]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[9636]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[19196]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[9618]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[9622]=za;h[9657]=0.0;$=c[a>>2]|0;c[19196]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[9657]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[19196]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[9622]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[9654]=Fa;c[19242]=K;Ga=Fa;Ha=K}aa=K+1|0;c[19198]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}Sba(a,b,s,t,76872,u,w,76944,76968,x)|0;ca=c[19242]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[9596];c[19200]=0;J=c[a>>2]|0;c[19194]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[9622]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[9622];G=G+1|0;da=da+1|0}da=X+aa|0;c[19200]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[19196]=La;c[19194]=J+1}h[L>>3]=0.0;X=c[19258]|0;c[19196]=1;aa=(X|0)<1;if(!aa){F=c[19218]|0;K=1;while(1){da=fa(K,B)|0;O=+h[9616]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[9622]=Oa;G=c[b>>2]|0;c[19198]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[9622];$=$+1|0}c[19198]=G+1}$=K+1|0;c[19196]=$;if((K|0)<(X|0)){K=$}else{break}}}h[9627]=0.0;K=c[a>>2]|0;c[19194]=1;if((K|0)>=1){F=1;while(1){O=+h[9616]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[9627]=+h[9627]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[19194]=K+1;h[A>>3]=Pa}F=c[19284]|0;do{if((F|0)==0){if(!(+h[9638]==+h[9611])){break}O=+h[9646];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[19304]=0;break}L=c[b>>2]|0;c[19198]=1;if((L|0)>=1){J=o+((c[19256]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[19198]=L+1}h[9620]=0.0;$=c[a>>2]|0;c[19194]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[9614]=0.0;G=c[b>>2]|0;c[19198]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[9614]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[19198]=G+1;Sa=Ta}h[9620]=+h[9620]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[19194]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[9620]*100.0}J=c[19304]|0;c[19304]=J+1;if(+h[9627]<Ra){c[19304]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[19194]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[19194]=J+1}$=c[19204]|0;c[19200]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[19200]=$+1}c[19196]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[19198]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[19198]=Na+1;Ua=Wa}if((L|0)<(c[19218]|0)){h[J>>3]=-Ua}Va=L+1|0;c[19196]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[19198]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[19196]=Xa;c[19198]=L+1}c[19304]=0}}while(0);O=+h[9596];ea=+h[9641];if(O<ea){c[19256]=ca}oa=+h[9648];if(O<=ea+oa*+h[9649]|(F|0)>0){U=54;break}c[19242]=0;Ia=0;Ja=+h[9638];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[9596];oa=+h[9596];do{if((I|0)==1){h[9615]=oa;h[9625]=oa;c[19256]=1;Ya=1}else{if(!(oa<+h[9625])){Ya=I;break}h[9625]=oa;c[19256]=I;Ya=I}}while(0);F=c[19214]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[19224]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[19226]|0;Va=K+aa|0;c[19200]=Va;if(+h[9630]<0.0){aa=X+(c[a>>2]|0)|0;c[19224]=aa;Za=aa}else{Za=X}if(+h[9631]<0.0){X=K+(c[a>>2]|0)|0;c[19226]=X;_a=X}else{_a=K}K=fa(c[19238]|0,B)|0;h[t+(K-B<<3)>>3]=+h[9639];h[t+(Ya+C+K<<3)>>3]=+h[9639];h[t+(Za-B+K<<3)>>3]=-+h[9639];h[t+(_a-B+K<<3)>>3]=-+h[9639];h[q+(Va+ -1<<3)>>3]=(+h[9615]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[9596])/(+h[9630]*+h[9631])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[19238]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[9617]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[9617]/+h[e>>3];ea=+h[9640];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[9640];h[t+(X+K<<3)>>3]=+h[9640];K=(fa(Va+1|0,Va)|0)/2|0;c[19200]=K;ea=(+h[9615]- +h[9596])/+h[e>>3];h[9622]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[9617]*(+h[X>>3]+ +h[9622]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[9615])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[9608]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[9608]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[9617]*+h[9653]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[9611]=oa;h[9638]=oa;c[19218]=1;h[9633]=0.0;h[9634]=0.0;c[19304]=0;h[9658]=0.0;F=c[a>>2]|0;c[19194]=1;if((F|0)<1){U=53;break}ca=c[19256]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[9658]=+h[9658]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[19194]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[19286]=c[19202];U=54;continue}else if((U|0)==54){U=0;c[19242]=0;I=(c[19212]|0)+ -1|0;K=c[a>>2]|0;Rba(a,b,l,n,p,q,r,77104,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,77240)|0;h[9610]=0.0;K=c[a>>2]|0;c[19194]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[9610]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[19194]=K+1;ab=cb}oa=+h[9638];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[9645]=O;ea=+h[9611];if(!(O<+h[9617]*ea)){db=ab;U=62;break}c[19242]=-1;O=+h[9648];N=O*oa;h[9638]=N;h[9646]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[9638]=ea;eb=ea}if((c[19202]|0)<=((c[19286]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[9655]*.125*ea;h[9622]=N;oa=+h[9633];ba=+h[9634];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[9635];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[9657]=O;I=c[b>>2]|0;c[19198]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[9614]=0.0;X=c[a>>2]|0;c[19196]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[9614]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[19196]=X+1;jb=lb}if(jb>ea){c[19242]=F;h[9657]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[19198]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[9646]>0.0){U=54;continue}ea=+h[9645];O=+h[9611];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[9617];h[9638]=O;ea=hb/+h[f>>3];h[9646]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[9611]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[9611]=na;ob=na;break}}else{na=+h[f>>3];h[9611]=na;ob=na}}while(0);h[9638]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){Esa(77344)|0;msa()|0}Esa(77368)|0;Vra(77464,76888,8)|0;Vra(77464,76808,4)|0;msa()|0;Esa(77392)|0;Vra(77464,77e3,8)|0;ca=c[a>>2]|0;c[19194]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];Vra(77464,y,8)|0;I=c[19194]|0;F=I+1|0;c[19194]=F;}while((I|0)<(ca|0))}msa()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[9617]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[9611];O=na>=ea?na:ea;h[9647]=O;ea=O*O;h[9610]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[9658];if(db<=ea*.001){h[9651]=ea*.25;ca=c[b>>2]|0;c[19198]=1;if((ca|0)>=1){F=1;while(1){h[9614]=0.0;I=c[a>>2]|0;c[19194]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[9614]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[19194]=I+1;pb=qb}h[9622]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[9617]*+h[9658];h[9614]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[19194]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[9622]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[9617]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[9614]*+h[n+(F+C+Va<<3)>>3]+ +h[9651]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[19206]=aa;c[19196]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[19196]=Va;rb=Va}c[19194]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[19198]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[19258]|0;c[19198]=1;if((F|0)>=1){ca=1;while(1){h[9632]=0.0;X=c[b>>2]|0;c[19194]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[9632]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[19194]=I;if((K|0)>=(X|0)){break b}O=+h[9632];K=I}}}while(0);X=c[a>>2]|0;c[19196]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[9651]*+h[9632]*+h[l+(I<<3)>>3];h[9614]=O;Va=c[b>>2]|0;c[19194]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[9614]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[19194]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[19218]|0)){h[9614]=-+h[9614]}L=c[b>>2]|0;c[19194]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[9614]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[19194]=L+1}J=K+1|0;c[19196]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[19194]=1;if((K|0)>=1){X=c[19218]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[19206]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[9622]=ub;c[19196]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[9622];aa=aa+1|0}aa=J+1|0;c[19196]=aa;vb=aa}c[19194]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[19198]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[19200]=0;ca=c[a>>2]|0;c[19196]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[19198]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[9617]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[19198]=aa+1}c[19194]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[19200]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[19194]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[19196]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[19196]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[19196]=J+1}h[9658]=0.0}if((c[19242]|0)>0){F=(c[19212]|0)+ -1|0;cba(a,b,l,n,s,t,76872,u,76968,77176,v,77096,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[19198]=1;if((F|0)>=1){L=1;while(1){h[9623]=0.0;h[9624]=0.0;h[9614]=0.0;ca=c[a>>2]|0;c[19196]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[9623]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[9624]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[9614]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[19196]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[9617]+Ab);h[w+(K<<3)>>3]=+h[9614];K=L+1|0;c[19198]=K;if((L|0)<(F|0)){L=K}else{break}}}h[9618]=0.0;L=c[19258]|0;c[19198]=1;if((L|0)>=1){F=1;while(1){h[9614]=0.0;J=c[b>>2]|0;c[19194]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[9614]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[19194]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[9618];if((F|0)<(c[19218]|0)){h[9618]=O+ea;na=-Eb;h[9614]=na;Gb=na}else{h[9618]=O-ea;Gb=Eb}K=c[b>>2]|0;c[19194]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[9614];X=X+1|0}c[19194]=K+1}X=F+1|0;c[19198]=X;if((F|0)<(L|0)){F=X}else{break}}}h[9626]=0.0;h[9605]=0.0;F=c[a>>2]|0;c[19196]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[9614]=0.0;X=c[b>>2]|0;c[19194]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[9614]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[19194]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[9626]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[19208]=K;Va=c[a>>2]|0;c[19198]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[9614]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[19198]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[9626]+ +h[9614]*+h[ca>>3];h[9626]=O;na=+h[9605]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[9605]=na;aa=L+1|0;c[19196]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[9610];h[9618]=+h[9618]+(Ib*Ib+ea*(Ib+(Ib+ +h[9658])+ea*+h[9617]))-Hb;L=w+((c[19256]|0)+ -1<<3)|0;h[L>>3]=+h[9608]+ +h[L>>3];L=c[19242]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[9608]+ +h[9637]*+h[9618]/(ea*ea);h[9622]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;bba(a,b,l,n,s,t,76872,u,77024,76968,v,x,w,76944,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[19194]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[19194]=L+1}F=c[19202]|0;aa=F+1|0;c[19202]=aa;if((F|0)>=(c[19312]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[19202]=T+ -1;if((c[g>>2]|0)<=0){break}Esa(77272)|0;msa()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}Esa(77320)|0;msa()|0}}while(0);Nb=+h[9625];if(Nb<=+h[9596]){U=c[a>>2]|0;c[19194]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[19194]=U+1;Ob=+h[9625]}h[9596]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}Esa(77416)|0;Vra(77464,76808,4)|0;msa()|0;Esa(77440)|0;Vra(77464,76768,8)|0;g=c[a>>2]|0;c[19194]=1;if((g|0)>=1){a=1;do{Vra(77464,d+(a+ -1<<3)|0,8)|0;U=c[19194]|0;a=U+1|0;c[19194]=a;}while((U|0)<(g|0))}msa()|0;i=z;return 0}function Nba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){HEa(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){HEa(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function Oba(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+Eba(77472);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+Fba(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+Fba(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+Fba(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function Pba(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function Qba(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+Eba(77480);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=WEa(u|0,0,t+ -2|0,0)|0;t=PEa(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function Rba(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[9705]=.5;h[9723]=6.283185307179586;v=+h[l>>3];h[9718]=v*v;c[19432]=0;l=c[b>>2]|0;c[19450]=l;c[19448]=l;w=c[b>>2]|0;c[19372]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[19372]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[19372]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[19372]=w+1}z=c[d>>2]|0;c[19376]=1;if((z|0)>=1){e=1;while(1){h[9709]=0.0;A=c[b>>2]|0;c[19374]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[9709]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[19374]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[9709]=v;C=c[b>>2]|0;c[19372]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[9709];F=F+1|0}c[19372]=C+1}F=e+1|0;c[19376]=F;if((e|0)<(z|0)){e=F}else{break}}}c[19386]=0;e=c[b>>2]|0;c[19374]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[19386]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[19372]=H;c[19374]=e+1}do{if((y|0)==0){h[9707]=0.0;h[9689]=0.0;w=c[b>>2]|0;c[19372]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[9689]=+h[9689]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[19372]=w+1}h[r>>3]=0.0;D=+h[9689];if(D==0.0){O=55;break a}h[9694]=0.0;h[9697]=0.0;h[9692]=D;h[9712]=D;P=D;Q=0.0;R=0.0;S=+h[9718];T=0}else{if((y|0)>(x|0)){h[9691]=0.0;h[9698]=0.0;h[9699]=0.0;z=c[b>>2]|0;c[19372]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[9691]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[9698]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[9699]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[19372]=z+1;U=ba;W=$;Z=aa}D=+h[9705];v=D*(+h[9702]-Z);h[9690]=v;_=+h[9695];ca=_+v;h[9706]=ca;h[9710]=ca;h[9708]=ca;c[19442]=0;a[77568]=1;da=+h[9723]/50.0;h[9709]=da;c[19372]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[9708]=ka;c[19442]=w;h[9719]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[9720]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[9714]=ha;h[9700]=ia;h[9703]=ja;h[9711]=ka;c[19372]=50;h[9710]=ka;if((la|0)==0){h[9719]=ka;O=46}else if((la|0)==49){h[9720]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[9720]}h[9714]=0.0;ga=+h[9719];if(ga!=na){ea=ga-ma;h[9719]=ea;ga=na-ma;h[9720]=ga;oa=D*(ea-ga)/(ea+ga);h[9714]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[9714]=oa;ga=+X(+oa);h[9700]=ga;ea=+Y(+oa);h[9703]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[9715]=oa;h[9692]=0.0;w=c[b>>2]|0;c[19372]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[9700]*+h[J>>3]+ +h[9703]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[9692]+sa*sa;h[9692]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[9703];ea=+h[9700];F=F+1|0;z=K}c[19372]=w+1;qa=ta;ra=+h[9715]}ea=ra+ +h[9707];h[9707]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[9698]=0.0;z=c[b>>2]|0;c[19374]=1;do{if((z|0)<1){ea=+h[9722];h[9713]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[9698]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[19374]=z+1;ea=+h[9722];h[9713]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[9689];h[9709]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[9709]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[9713];oa=+h[9692];v=+h[9698];_=oa/v;ca=ea<=_?ea:_;h[9713]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[9692];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[9705]*Ca);h[9704]=ca;h[9707]=+h[9707]+ca;h[9717]=Ba;h[9692]=0.0;z=c[b>>2]|0;c[19372]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[9713]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[9692]+oa*oa;h[9692]=Ga;Ha=+h[9713];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[19372]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[9722]){if(+h[9704]<=+h[9707]*.01){O=55;break a}if(Fa<=+h[9712]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[9717];h[9709]=ca;h[9689]=0.0;h[9694]=0.0;h[9697]=0.0;w=c[b>>2]|0;c[19372]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[9689]+ca*ca;h[9689]=La;J=m+(F<<3)|0;Ma=+h[9694]+ +h[K>>3]*+h[J>>3];h[9694]=Ma;ca=+h[J>>3];Na=+h[9697]+ca*ca;h[9697]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[9709];Ja=Ja+1|0;Ka=J}c[19372]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[9718];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[19448]=y;ua=+h[9692];va=y}if(ua<=+h[9712]*1.0e-4){O=55;break a}h[9695]=0.0;h[9702]=0.0;z=c[b>>2]|0;c[19372]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[9695]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[9702]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[19372]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[9701]=ca;oa=+h[9718];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[19432]=J;_=+V(+(v-ca*ca));h[9709]=_;v=oa/_;h[9719]=v;oa=ca/_;h[9720]=oa;w=c[b>>2]|0;c[19372]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[9720];Ta=+h[9719];Ua=Ua+1|0;Va=K}c[19372]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[19432]=e;v=S-R;h[9709]=v;h[9722]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function Sba(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[9732]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[19470]=t;c[19460]=1;c[19454]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[19460]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[9734]=D;C=+h[x>>3]/D;h[9741]=C;z=+h[f+(B+y<<3)>>3]/D;h[9742]=z;B=c[d>>2]|0;c[19452]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[9734]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[9734];if((x|0)>=(B|0)){break}D=+h[9742];z=+h[9741];x=x+1|0}c[19452]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[19454]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[9741]=z;if((c[g>>2]|0)>1){D=-z;h[9741]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[9742]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[19452]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[9742]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[9741];t=t+1|0;x=A}c[19452]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[9739]=z;x=k+(w<<3)|0;H=+h[x>>3];h[9733]=H;D=H*H;h[9743]=D;h[9740]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[9732];a[77888]=0;do{if((u|0)==1){z=+h[9740];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[9734]=z;D=+h[9741]/z;h[9742]=D;H=+h[9733]/z;h[9741]=H;x=c[d>>2]|0;c[19452]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[9742];D=+h[9741];w=w+1|0;t=s}c[19452]=x+1;J=+h[9734]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[19456]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[19456]=u;M=u}t=u+1-M|0;c[19458]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[9740];z=+h[f+(t+w<<3)>>3]/D;h[9734]=z;h[9741]=z*+h[l>>3];H=+h[9733];h[9742]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[9734]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[9732]/+V(+(+h[9743]+z*N*z));h[9737]=C;if(!(D>=0.0)){O=-D}else{O=D}h[9738]=C*+V(+O);t=c[d>>2]|0;c[19452]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[9738]*(+h[A>>3]- +h[9741]*+h[n+(G<<3)>>3]- +h[9742]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[9734];z=+h[9733];H=+h[9737];v=v+1|0}c[19452]=t+1;P=+h[9740]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[77888]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[19452]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[9734]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[9734];K=Q+1|0;c[19452]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[19454]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[19462]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[9733];N=+h[9740];J=(+h[9739]*+h[f>>3]-O*P)/N;h[9741]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[9742]=P;c[19452]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[19452]=q;if((f|0)>=(b|0)){break a}N=+h[9742];O=+h[9741];f=q}}}while(0);b=R+1|0;c[19454]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function Tba(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function Uba(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((Tba(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(77952,77968,116,77992)}else if((s|0)==14){i=g;return o|0}return 0}function Vba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((zEa(w,c[78e3+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[78104+(x<<2)>>2]|0;c[q>>2]=c[78e3+(x<<2)>>2];c[q+4>>2]=y;D9(23,0,78176,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=bEa(D,8)|0;c[e+40>>2]=B;D=b+536|0;G9(c[D>>2]|0,(B|0)!=0|0,78216,p);B=bEa(c[A>>2]|0,4)|0;c[e+36>>2]=B;G9(c[D>>2]|0,(B|0)!=0|0,78216,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=bEa(c[C>>2]|0,4)|0;c[e+24>>2]=$Da(8)|0;C=$Da(4)|0;c[e+20>>2]=C;c[C>>2]=c[49912>>2];G9(c[D>>2]|0,(C|0)!=0|0,78216,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=$Da(C)|0;A=e+44|0;c[A>>2]=$Da(C)|0;C=bEa(15,4)|0;E=e+12|0;c[E>>2]=C;G9(c[D>>2]|0,(C|0)!=0|0,78216,m);C=bEa(5,4)|0;c[e+4>>2]=C;G9(c[D>>2]|0,(C|0)!=0|0,78216,l);C=bEa(5,4)|0;c[e+8>>2]=C;G9(c[D>>2]|0,(C|0)!=0|0,78216,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=$Da(C)|0;c[e+76>>2]=$Da(C)|0;c[e+80>>2]=$Da(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ie[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){D9(23,0,78232,j)}else{D9(1,0,78304,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[49948>>2]|c[12462]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=78136;W=V;H9(Q,W,r)}c[t>>2]=w;F9(23,1,78032,t);t=1;do{w=c[78104+(t<<2)>>2]|0;c[s>>2]=c[78e3+(t<<2)>>2];c[s+4>>2]=w;F9(23,0,78088,s);t=t+1|0;}while((t|0)<8);fe[c[12602]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=78136;W=V;H9(Q,W,r);return 0}function Wba(a){a=a|0;var b=0;b=i;aEa(c[a+40>>2]|0);aEa(c[a+36>>2]|0);aEa(c[a+20>>2]|0);aEa(c[a+12>>2]|0);aEa(c[a+4>>2]|0);aEa(c[a+8>>2]|0);aEa(a);i=b;return 0}function Xba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;G9(c[N>>2]|0,(c[M>>2]|0)!=0|0,78400,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){D9(3,0,78432,B);D9(3,0,78472,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ie[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(3,0,78496,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];D9(23,0,78536,y);if((c[z>>2]|0)==1){Kaa(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){Sda(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 3:{eba(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 4:{eba(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 5:{eba(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 6:{eba(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{eba(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){eba(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{eba(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){ud(_|0)|0;ud($|0)|0;F9(3,0,78568,x);D9(3,0,78656,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){ud(_|0)|0;ud($|0)|0;$=eca(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){Sda(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ie[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];F9(1,0,78680,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[49868>>2]|0)!=0){D9(3,1,78712,u);c[s>>2]=c[z>>2];D9(3,0,78736,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];D9(3,0,78760,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];D9(3,0,78792,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];D9(3,0,78832,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];D9(3,0,78880,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];D9(3,0,78928,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];D9(3,0,78968,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];D9(3,0,79008,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];D9(3,0,79048,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];D9(3,0,79096,f);fe[c[12602]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(79136,79168,410,79200)}D9(3,0,79216,e);S=0;i=d;return S|0}function Yba(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;Sda(g)|0;a=f+540|0;ie[c[(c[a>>2]|0)+40>>2]&127](g)|0;ie[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function Zba(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Sda(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;gca(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function _ba(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];Sda(g)|0;l=e+540|0;ie[c[(c[l>>2]|0)+40>>2]&127](g)|0;ie[c[(c[l>>2]|0)+28>>2]&127](g)|0;ie[c[(c[l>>2]|0)+32>>2]&127](g)|0;le[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function $ba(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;hca(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function aca(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;Sda(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;fca(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function bca(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function cca(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;ica(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function dca(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function eca(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-3:{m=-3;i=b;return m|0};case-2:{F9(1,0,79240,k);m=-2;i=b;return m|0};case-7:{F9(1,0,79352,h);m=-7;i=b;return m|0};case-6:{F9(1,0,79280,j);m=-6;i=b;return m|0};case-12:{F9(1,0,79712,c);m=-12;i=b;return m|0};case-33:{F9(1,0,79760,b);m=-33;i=b;return m|0};case-9:{F9(1,0,79440,f);m=-9;i=b;return m|0};case-10:{F9(1,0,79528,e);m=-10;i=b;return m|0};case-11:{F9(1,0,79624,d);m=-11;i=b;return m|0};case-8:{F9(1,0,79392,g);m=-8;i=b;return m|0};case-1:{F9(3,0,78568,l);m=1;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function fca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function gca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ie[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function hca(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+td(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+td(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;Yba(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function Ri(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+184>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5336,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+160>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5336,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}function Si(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=-d;f=c[a+416>>2]|0;g=+h[f+2232>>3];j=+h[b+1840>>3];k=+h[f+2240>>3];h[b+1736>>3]=+h[b+8016>>3]*(d*g*e-j*k)+ +h[b+8040>>3]*(g*j+d*k*e);i=i;return}function Ti(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0;d=i;i=i+56|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=d+32|0;l=d+40|0;m=d+48|0;n=b+536|0;o=b+4|0;p=b+416|0;Di(e,c[n>>2]|0,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3]);q=+h[e>>3];e=Mca(+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3])|0;Di(f,c[n>>2]|0,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3]);r=+h[f>>3];Di(g,c[n>>2]|0,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3]);s=+h[g>>3];g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;Ci(j,c[n>>2]|0,+h[g+8648>>3],+h[(c[p>>2]|0)+3960>>3],+h[g+8656>>3],0.0);t=+h[j>>3];Di(k,c[n>>2]|0,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3]);u=+h[k>>3];k=c[(c[c[o>>2]>>2]|0)+8>>2]|0;Ci(l,c[n>>2]|0,+h[k+8648>>3],+h[(c[p>>2]|0)+3960>>3],+h[k+8656>>3],0.0);v=+h[l>>3];Di(m,c[n>>2]|0,+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[p>>2]|0)+3960>>3]);w=+h[m>>3];x=w*w;w=x*x;m=c[c[o>>2]>>2]|0;p=c[m+8>>2]|0;x=q*+h[p+1736>>3];q=+h[p+2232>>3];y=-q;l=e<<24>>24!=0;if(w!=0.0){if(l){z=+h[p+8760>>3]}else{z=0.0}A=p;B=(r*r*(x+z*y)+u*v*(s*+h[p+1984>>3]-t*q)*-2.0)/w;C=A;D=C+1168|0;E=D;h[E>>3]=B;i=d;return}if(l){F=+h[p+8760>>3]}else{F=0.0}z=r*r;r=u*v*(s*+h[p+1984>>3]-t*q)*-2.0;if(z*(x+F*y)+r==0.0){if(l){G=+h[p+8760>>3]}else{G=0.0}A=p;B=z*(x+G*y)+r;C=A;D=C+1168|0;E=D;h[E>>3]=B;i=d;return}else{if(l){H=+h[p+8760>>3]}else{H=0.0}G=(z*(x+H*y)+r)/+J9(c[n>>2]|0,w,5152,5344,+h[m>>3],(a[b+319|0]|0)!=0|0);A=c[(c[c[o>>2]>>2]|0)+8>>2]|0;B=G;C=A;D=C+1168|0;E=D;h[E>>3]=B;i=d;return}}function Ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=+h[b+1168>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function Vi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+1184>>3]+ +h[(c[a+416>>2]|0)+2944>>3];i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=+h[b+168>>3]- +h[(c[a+416>>2]|0)+2944>>3];i=i;return}function Xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5352,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+168>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5352,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}function Yi(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+136>>3];e=+h[b+304>>3];h[b+112>>3]=d-e*(d*e+(+h[b+144>>3]*+h[b+312>>3]+ +h[b+152>>3]*+h[b+320>>3]));i=i;return}function Zi(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+144>>3];e=+h[b+312>>3];h[b+120>>3]=d-e*(+h[b+136>>3]*+h[b+304>>3]+(d*e+ +h[b+152>>3]*+h[b+320>>3]));i=i;return}function _i(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[(c[a+416>>2]|0)+3944>>3];e=+h[b+8672>>3];h[b+408>>3]=-(+h[b+8040>>3]*(d*+h[b+168>>3]+(+h[b+120>>3]+e*+h[b+312>>3])))- +h[b+8032>>3]*(+h[b+160>>3]*d+(+h[b+112>>3]+ +h[b+304>>3]*e));i=i;return}function $i(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[(c[a+416>>2]|0)+3944>>3];e=+h[b+8672>>3];h[b+416>>3]=-(+h[b+8016>>3]*(d*+h[b+168>>3]+(+h[b+120>>3]+e*+h[b+312>>3])))- +h[b+8008>>3]*(+h[b+160>>3]*d+(+h[b+112>>3]+ +h[b+304>>3]*e));i=i;return}function aj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+25840>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+25816>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+25824>>3];h[a+8>>3]=+h[d+2320>>3];h[e+8>>3]=+h[d+2296>>3];h[f+8>>3]=+h[d+2304>>3];h[a+16>>3]=+h[d+2432>>3];h[e+16>>3]=+h[d+2408>>3];h[f+16>>3]=+h[d+2416>>3];h[a+24>>3]=+h[d+122720>>3];h[e+24>>3]=+h[d+122696>>3];h[f+24>>3]=+h[d+122704>>3];i=i;return}function bj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0;f=i;i=i+56|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;o=f+48|0;p=b;q=b+4|0;r=c[(c[c[q>>2]>>2]|0)+8>>2]|0;h[r+1840>>3]=+h[d>>3];h[r+160>>3]=+h[d+8>>3];h[r+168>>3]=+h[d+16>>3];h[r+8760>>3]=+h[d+24>>3];Hi(p);Ii(p);Ji(p);Ki(p);Li(p);Mi(p);Ni(p);Oi(p);Pi(p);Qi(p);Ri(p);Si(p);Ti(p);Ui(p);Vi(p);Wi(p);Xi(p);Yi(p);Zi(p);_i(p);$i(p);p=c[(c[c[q>>2]>>2]|0)+8>>2]|0;d=b+416|0;r=c[d>>2]|0;h[e>>3]=+h[p+1192>>3]+(+h[p+1168>>3]*+h[r+3968>>3]- +h[p+1736>>3]);h[e+8>>3]=+h[p+400>>3]+(+h[r+2232>>3]*+h[p+408>>3]- +h[r+2240>>3]*+h[p+416>>3]);s=b+536|0;Di(g,c[s>>2]|0,+h[p+8648>>3],+h[r+3960>>3]);t=+h[g>>3];u=t*t;Di(j,c[s>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[d>>2]|0)+3960>>3]);t=+h[j>>3];j=Mca(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[d>>2]|0)+3960>>3])|0;Di(k,c[s>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[d>>2]|0)+3960>>3]);v=+h[k>>3];Di(l,c[s>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[d>>2]|0)+3960>>3]);w=+h[l>>3];l=c[(c[c[q>>2]>>2]|0)+8>>2]|0;Ci(m,c[s>>2]|0,+h[l+8648>>3],+h[(c[d>>2]|0)+3960>>3],+h[l+8656>>3],0.0);x=+h[m>>3];Di(n,c[s>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[d>>2]|0)+3960>>3]);y=+h[n>>3];n=c[(c[c[q>>2]>>2]|0)+8>>2]|0;Ci(o,c[s>>2]|0,+h[n+8648>>3],+h[(c[d>>2]|0)+3960>>3],+h[n+8656>>3],0.0);n=c[c[q>>2]>>2]|0;q=c[n+8>>2]|0;d=q+1728|0;m=q+2224|0;z=+h[m>>3];l=q+8760|0;if(j<<24>>24==0){A=0.0}else{A=+h[l>>3]}j=q+1976|0;h[e+16>>3]=u*u*+h[q+1160>>3]+(v*v*(z*A-t*+h[d>>3])+y*+h[o>>3]*(w*+h[j>>3]-x*z)*2.0);z=+h[m>>3];x=+h[q+2232>>3];w=+h[q+2240>>3];y=+h[j>>3];t=+h[q+1984>>3];A=z*y+x*t;v=z*z;u=x*x;B=w*w;w=+h[l>>3]*(v+(u+B))*4.0;C=+V(+(v+u+B));B=C*(z*+h[d>>3]+(y*y+(t*t+x*+h[q+1736>>3])))*-4.0;x=A*A;if(C!=0.0){D=x/C;E=D*4.0;F=B+E;G=w+F;H=e;I=H+24|0;J=I;h[J>>3]=G;i=f;return}if(x==0.0){D=x;E=D*4.0;F=B+E;G=w+F;H=e;I=H+24|0;J=I;h[J>>3]=G;i=f;return}D=x/+J9(c[s>>2]|0,C,5368,5360,+h[n>>3],(a[b+319|0]|0)!=0|0);E=D*4.0;F=B+E;G=w+F;H=e;I=H+24|0;J=I;h[J>>3]=G;i=f;return}function cj(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=-d;f=c[a+416>>2]|0;g=+h[f+2232>>3];j=+h[b+1840>>3];k=+h[f+2240>>3];h[b+1728>>3]=+h[b+8008>>3]*(d*g*e-j*k)+ +h[b+8032>>3]*(g*j+d*k*e);i=i;return}function dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=(+h[b+8040>>3]*+h[(c[a+416>>2]|0)+2944>>3]+ +h[b+1840>>3]*.35)*6.602749999999998;i=i;return}function ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+1840>>3]*.2702863223958332+ +h[b+1792>>3]*.35;i=i;return}function fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+3656>>3]- +h[b+1776>>3];i=i;return}function gj(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=-d;f=c[a+416>>2]|0;g=+h[f+2232>>3];j=+h[b+1840>>3];k=+h[f+2240>>3];h[b+1736>>3]=+h[b+8016>>3]*(d*g*e-j*k)+ +h[b+8040>>3]*(g*j+d*k*e);i=i;return}function hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1192>>3]=+h[b+168>>3]- +h[(c[a+416>>2]|0)+2944>>3];i=i;return}function ij(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+3968>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1736>>3]- +h[j+1192>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1168|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1168|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,e,5304,5592,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1168|0;p=o;h[p>>3]=m;i=d;return}function jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1184>>3]=+h[b+1168>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+1184>>3]+ +h[(c[a+416>>2]|0)+2944>>3];i=i;return}function lj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+192>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5600,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+168>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5600,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+144|0;E=D;h[E>>3]=B;i=d;return}function mj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+3968>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1728>>3]- +h[j+160>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,e,5304,5608,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+1160>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+184>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5616,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+160>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5616,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+136|0;E=D;h[E>>3]=B;i=d;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=b+4|0;l=b+416|0;m=Mca(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3])|0;n=b+536|0;Di(e,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[n>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);p=+h[f>>3];Di(g,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);q=+h[g>>3];Di(j,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);r=+h[j>>3];s=r*r;r=s*s;j=c[c[k>>2]>>2]|0;l=c[j+8>>2]|0;s=+h[l+2240>>3];t=-s;g=m<<24>>24!=0;if(r!=0.0){if(g){u=+h[l+8760>>3]}else{u=0.0}v=l;w=(o*o*u*t+p*p*q*s*2.0)/r;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}if(g){A=+h[l+8760>>3]}else{A=0.0}u=o*o;o=p*p*q;if(u*A*t+o*t*-2.0==0.0){if(g){B=+h[l+8760>>3]}else{B=0.0}v=l;w=u*B*t+o*s*2.0;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}else{if(g){C=+h[l+8760>>3]}else{C=0.0}B=(u*C*t+o*s*2.0)/+J9(c[n>>2]|0,r,5152,5624,+h[j>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;w=B;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}}function qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=-(+h[b+1176>>3]*+h[(c[a+416>>2]|0)+3968>>3]);i=i;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+1176>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5632,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+176>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5632,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}function tj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+144>>3];e=+h[b+312>>3];h[b+120>>3]=d-e*(+h[b+136>>3]*+h[b+304>>3]+(d*e+ +h[b+152>>3]*+h[b+320>>3]));i=i;return}function uj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+136>>3];e=+h[b+304>>3];h[b+112>>3]=d-e*(d*e+(+h[b+144>>3]*+h[b+312>>3]+ +h[b+152>>3]*+h[b+320>>3]));i=i;return}function vj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[(c[a+416>>2]|0)+3944>>3];e=+h[b+8672>>3];h[b+408>>3]=-(+h[b+8040>>3]*(d*+h[b+168>>3]+(+h[b+120>>3]+e*+h[b+312>>3])))- +h[b+8032>>3]*(+h[b+160>>3]*d+(+h[b+112>>3]+ +h[b+304>>3]*e));i=i;return}function wj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[(c[a+416>>2]|0)+3944>>3];e=+h[b+8672>>3];h[b+416>>3]=-(+h[b+8016>>3]*(d*+h[b+168>>3]+(+h[b+120>>3]+e*+h[b+312>>3])))- +h[b+8008>>3]*(+h[b+160>>3]*d+(+h[b+112>>3]+ +h[b+304>>3]*e));i=i;return}function xj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+25840>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+25816>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+25824>>3];h[a+8>>3]=+h[d+2320>>3];h[e+8>>3]=+h[d+2296>>3];h[f+8>>3]=+h[d+2304>>3];h[a+16>>3]=+h[d+2432>>3];h[e+16>>3]=+h[d+2408>>3];h[f+16>>3]=+h[d+2416>>3];h[a+24>>3]=+h[d+122720>>3];h[e+24>>3]=+h[d+122696>>3];h[f+24>>3]=+h[d+122704>>3];i=i;return}function yj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0;f=i;i=i+112|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;o=f+48|0;p=f+56|0;q=f+64|0;r=f+72|0;s=f+80|0;t=f+88|0;u=f+96|0;v=f+104|0;w=b;x=b+4|0;y=c[(c[c[x>>2]>>2]|0)+8>>2]|0;h[y+1840>>3]=+h[d>>3];h[y+160>>3]=+h[d+8>>3];h[y+168>>3]=+h[d+16>>3];h[y+8760>>3]=+h[d+24>>3];cj(w);dj(w);ej(w);fj(w);gj(w);hj(w);ij(w);jj(w);kj(w);lj(w);mj(w);nj(w);oj(w);pj(w);qj(w);rj(w);sj(w);tj(w);uj(w);vj(w);wj(w);w=c[c[x>>2]>>2]|0;d=c[w+8>>2]|0;z=+h[d+2224>>3];A=+h[d+2232>>3];B=+h[d+2240>>3];C=+h[d+1976>>3];D=+h[d+1984>>3];E=z*C+A*D;F=z*z;G=A*A;H=B*B;B=+h[d+8760>>3]*(F+(G+H))*4.0;I=+V(+(F+G+H));H=I*(z*+h[d+1728>>3]+(C*C+(D*D+A*+h[d+1736>>3])))*-4.0;A=E*E;do{if(I!=0.0){J=d;K=A/I}else{if(A==0.0){J=d;K=A;break}E=A/+J9(c[b+536>>2]|0,I,5368,5640,+h[w>>3],(a[b+319|0]|0)!=0|0);J=c[(c[c[x>>2]>>2]|0)+8>>2]|0;K=E}}while(0);h[e>>3]=B+(H+K*4.0);w=b+416|0;d=c[w>>2]|0;h[e+8>>3]=+h[J+400>>3]+(+h[d+2232>>3]*+h[J+408>>3]- +h[d+2240>>3]*+h[J+416>>3]);y=b+536|0;Di(g,c[y>>2]|0,+h[J+8648>>3],+h[d+3960>>3]);K=+h[g>>3];H=K*K;Di(j,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);K=+h[j>>3];j=Mca(+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3])|0;Di(k,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);B=+h[k>>3];Di(l,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);I=+h[l>>3];l=c[(c[c[x>>2]>>2]|0)+8>>2]|0;Ci(m,c[y>>2]|0,+h[l+8648>>3],+h[(c[w>>2]|0)+3960>>3],+h[l+8656>>3],0.0);A=+h[m>>3];Di(n,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);E=+h[n>>3];n=c[(c[c[x>>2]>>2]|0)+8>>2]|0;Ci(o,c[y>>2]|0,+h[n+8648>>3],+h[(c[w>>2]|0)+3960>>3],+h[n+8656>>3],0.0);n=c[(c[c[x>>2]>>2]|0)+8>>2]|0;D=+h[n+2224>>3];if(j<<24>>24==0){L=0.0}else{L=+h[n+8760>>3]}h[e+16>>3]=H*H*+h[n+1160>>3]+(B*B*(D*L-K*+h[n+1728>>3])+E*+h[o>>3]*(I*+h[n+1976>>3]-A*D)*2.0);Di(p,c[y>>2]|0,+h[n+8648>>3],+h[(c[w>>2]|0)+3960>>3]);D=+h[p>>3];A=D*D;Di(q,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);D=+h[q>>3];q=Mca(+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3])|0;Di(r,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);I=+h[r>>3];Di(s,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);E=+h[s>>3];s=c[(c[c[x>>2]>>2]|0)+8>>2]|0;Ci(t,c[y>>2]|0,+h[s+8648>>3],+h[(c[w>>2]|0)+3960>>3],+h[s+8656>>3],0.0);K=+h[t>>3];Di(u,c[y>>2]|0,+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[w>>2]|0)+3960>>3]);L=+h[u>>3];u=c[(c[c[x>>2]>>2]|0)+8>>2]|0;Ci(v,c[y>>2]|0,+h[u+8648>>3],+h[(c[w>>2]|0)+3960>>3],+h[u+8656>>3],0.0);B=+h[v>>3];v=c[(c[c[x>>2]>>2]|0)+8>>2]|0;H=A*A*+h[v+1168>>3];A=D*+h[v+1736>>3];D=+h[v+2232>>3];if(q<<24>>24==0){M=0.0;N=D*M;O=N-A;P=I*I;Q=P*O;R=v;S=R+1984|0;T=S;U=+h[T>>3];W=E*U;X=K*D;Y=W-X;Z=L*B;_=Z*Y;$=_*2.0;aa=Q+$;ba=H+aa;ca=e;da=ca+24|0;ea=da;h[ea>>3]=ba;i=f;return}M=+h[v+8760>>3];N=D*M;O=N-A;P=I*I;Q=P*O;R=v;S=R+1984|0;T=S;U=+h[T>>3];W=E*U;X=K*D;Y=W-X;Z=L*B;_=Z*Y;$=_*2.0;aa=Q+$;ba=H+aa;ca=e;da=ca+24|0;ea=da;h[ea>>3]=ba;i=f;return}function zj(a){a=a|0;c[a+4>>2]=177;c[a>>2]=4;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=1376;c[a+80>>2]=4;c[a+136>>2]=0;c[a+112>>2]=19;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;i=i;return}function Aj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0;e=i;f=d+8|0;g=b+416|0;se[c[f>>2]&3](0,5,+h[(c[g>>2]|0)+3456>>3]*.1727557801796867,0,d);se[c[f>>2]&3](0,32,-1.0,1,d);se[c[f>>2]&3](1,4,.1007742051048172,2,d);se[c[f>>2]&3](1,31,-1.0,3,d);se[c[f>>2]&3](1,32,-.1727557801796867,4,d);j=b+4|0;se[c[f>>2]&3](2,0,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+568>>3],5,d);se[c[f>>2]&3](2,2,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+616>>3],6,d);se[c[f>>2]&3](2,7,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3],7,d);se[c[f>>2]&3](2,10,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+568>>3],8,d);se[c[f>>2]&3](2,18,1.0,9,d);se[c[f>>2]&3](2,30,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3],10,d);se[c[f>>2]&3](2,31,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+616>>3],11,d);se[c[f>>2]&3](3,29,-.1007742051048172,12,d);se[c[f>>2]&3](3,30,-1.0,13,d);se[c[f>>2]&3](4,12,+h[(c[g>>2]|0)+3456>>3]*-.1727557801796867,14,d);se[c[f>>2]&3](4,28,+h[(c[g>>2]|0)+3456>>3]*.1007742051048172,15,d);se[c[f>>2]&3](4,29,-1.0,16,d);se[c[f>>2]&3](5,13,-.5038710255240862,17,d);se[c[f>>2]&3](5,27,-.8637789008984333,18,d);se[c[f>>2]&3](5,28,1.0,19,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+8712>>3];o=+h[m+672>>3];p=-o;do{if(n!=0.0){q=p/n}else{if(o==-0.0){q=p;break}q=p/+J9(c[b+536>>2]|0,n,5656,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](6,14,q,20,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;q=+h[m+8712>>3];n=+h[m+664>>3];do{if(q!=0.0){r=n/q}else{if(n==0.0){r=n;break}r=n/+J9(c[b+536>>2]|0,q,5656,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](6,26,r,21,d);se[c[f>>2]&3](6,27,1.0,22,d);k=c[c[j>>2]>>2]|0;r=+h[(c[k+8>>2]|0)+8728>>3];l=c[f>>2]|0;q=r*r;n=-r;do{if(q!=0.0){s=n/q}else{if(r==-0.0){s=n;break}s=n/+J9(c[b+536>>2]|0,q,5680,5648,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[l&3](7,25,s,23,d);se[c[f>>2]&3](7,26,1.0,24,d);l=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=c[g>>2]|0;se[c[f>>2]&3](8,24,+h[l+8112>>3]*+h[k+392>>3]- +h[l+8136>>3]*+h[k+384>>3],25,d);se[c[f>>2]&3](8,25,1.0,26,d);se[c[f>>2]&3](9,23,1.0,27,d);se[c[f>>2]&3](9,24,-2.310962499999999,28,d);se[c[f>>2]&3](10,22,1.0,29,d);se[c[f>>2]&3](10,23,-.35,30,d);se[c[f>>2]&3](10,24,-.2702863223958332,31,d);se[c[f>>2]&3](11,21,1.0,32,d);se[c[f>>2]&3](11,22,1.0,33,d);se[c[f>>2]&3](12,16,-+h[(c[g>>2]|0)+384>>3],34,d);se[c[f>>2]&3](12,20,+h[(c[g>>2]|0)+392>>3],35,d);se[c[f>>2]&3](12,21,-1.0,36,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](13,1,-(+h[k+8112>>3]*+h[k+600>>3])- +h[k+8104>>3]*+h[k+592>>3],37,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](13,3,-(+h[k+8112>>3]*+h[k+576>>3])- +h[k+8104>>3]*+h[k+568>>3],38,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](13,11,-(+h[k+8112>>3]*+h[k+624>>3])- +h[k+8104>>3]*+h[k+616>>3],39,d);se[c[f>>2]&3](13,17,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8112>>3],40,d);se[c[f>>2]&3](13,19,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8104>>3],41,d);se[c[f>>2]&3](13,20,1.0,42,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;s=+h[m+8728>>3]*+h[m+680>>3];q=+h[m+8080>>3];do{if(s!=0.0){t=q/s}else{if(q==0.0){t=q;break}t=q/+J9(c[b+536>>2]|0,s,5712,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](14,8,t,43,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;t=+h[m+664>>3];s=+h[m+8728>>3];q=+h[m+8088>>3];do{if(s!=0.0){u=q/s}else{if(q==0.0){u=q;break}u=q/+J9(c[b+536>>2]|0,s,5752,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](14,9,-(t*u),44,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;u=+h[m+664>>3];t=+h[m+8728>>3];s=+h[m+8080>>3];do{if(t!=0.0){v=s/t}else{if(s==0.0){v=s;break}v=s/+J9(c[b+536>>2]|0,t,5752,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](14,18,-(u*v),45,d);se[c[f>>2]&3](14,19,1.0,46,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;v=+h[m+8728>>3]*+h[m+680>>3];u=+h[m+8088>>3];do{if(v!=0.0){w=u/v}else{if(u==0.0){w=u;break}w=u/+J9(c[b+536>>2]|0,v,5712,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](15,8,w,47,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;w=+h[m+672>>3];v=+h[m+8728>>3];u=+h[m+8088>>3];do{if(v!=0.0){x=u/v}else{if(u==0.0){x=u;break}x=u/+J9(c[b+536>>2]|0,v,5752,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](15,9,-(w*x),48,d);se[c[f>>2]&3](15,17,1.0,49,d);k=c[f>>2]|0;l=c[c[j>>2]>>2]|0;m=c[l+8>>2]|0;x=+h[m+672>>3];w=+h[m+8728>>3];v=+h[m+8080>>3];do{if(w!=0.0){y=v/w}else{if(v==0.0){y=v;break}y=v/+J9(c[b+536>>2]|0,w,5752,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](15,18,-(x*y),50,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](16,1,-(+h[k+8136>>3]*+h[k+600>>3])- +h[k+8128>>3]*+h[k+592>>3],51,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](16,3,-(+h[k+8136>>3]*+h[k+576>>3])- +h[k+8128>>3]*+h[k+568>>3],52,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](16,11,-(+h[k+8136>>3]*+h[k+624>>3])- +h[k+8128>>3]*+h[k+616>>3],53,d);se[c[f>>2]&3](16,16,1.0,54,d);se[c[f>>2]&3](16,17,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8136>>3],55,d);se[c[f>>2]&3](16,19,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8128>>3],56,d);se[c[f>>2]&3](17,15,1.0,57,d);k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=c[g>>2]|0;se[c[f>>2]&3](17,24,+h[k+8104>>3]*+h[l+392>>3]- +h[k+8128>>3]*+h[l+384>>3],58,d);se[c[f>>2]&3](18,14,1.0,59,d);l=c[c[j>>2]>>2]|0;y=+h[(c[l+8>>2]|0)+8728>>3];k=c[f>>2]|0;x=y*y;w=-y;do{if(x!=0.0){z=w/x}else{if(y==-0.0){z=w;break}z=w/+J9(c[b+536>>2]|0,x,5680,5648,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](18,15,z,60,d);se[c[f>>2]&3](19,13,1.0,61,d);se[c[f>>2]&3](19,14,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+664>>3],62,d);se[c[f>>2]&3](19,26,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+672>>3],63,d);se[c[f>>2]&3](20,12,1.0,64,d);se[c[f>>2]&3](20,13,.8637789008984335,65,d);se[c[f>>2]&3](20,27,-.5038710255240861,66,d);se[c[f>>2]&3](21,11,-1.0,67,d);se[c[f>>2]&3](21,12,+h[(c[g>>2]|0)+3528>>3]*.1727557801796867,68,d);se[c[f>>2]&3](21,15,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+616>>3]*+h[(c[g>>2]|0)+3528>>3]),69,d);se[c[f>>2]&3](21,25,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+624>>3]*+h[(c[g>>2]|0)+3528>>3]),70,d);se[c[f>>2]&3](21,28,+h[(c[g>>2]|0)+3528>>3]*-.1007742051048172,71,d);se[c[f>>2]&3](22,10,-1.0,72,d);se[c[f>>2]&3](22,11,-.1727557801796867,73,d);se[c[f>>2]&3](23,0,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+576>>3],74,d);se[c[f>>2]&3](23,2,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+624>>3],75,d);se[c[f>>2]&3](23,7,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+600>>3],76,d);se[c[f>>2]&3](23,9,1.0,77,d);se[c[f>>2]&3](23,10,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+576>>3],78,d);se[c[f>>2]&3](23,30,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+600>>3],79,d);se[c[f>>2]&3](23,31,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+624>>3],80,d);se[c[f>>2]&3](24,0,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+584>>3],81,d);se[c[f>>2]&3](24,2,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],82,d);se[c[f>>2]&3](24,7,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+608>>3],83,d);se[c[f>>2]&3](24,8,1.0,84,d);se[c[f>>2]&3](24,10,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+584>>3],85,d);se[c[f>>2]&3](24,30,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+608>>3],86,d);se[c[f>>2]&3](24,31,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+632>>3],87,d);se[c[f>>2]&3](25,7,-1.0,88,d);se[c[f>>2]&3](25,11,.1007742051048172,89,d);se[c[f>>2]&3](26,6,1.0,90,d);se[c[f>>2]&3](26,14,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8080>>3],91,d);se[c[f>>2]&3](26,26,-+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8088>>3],92,d);se[c[f>>2]&3](27,5,1.0,93,d);se[c[f>>2]&3](27,6,-.9999999999999999,94,d);se[c[f>>2]&3](28,4,-1.0,95,d);se[c[f>>2]&3](28,5,+h[(c[g>>2]|0)+3456>>3]*-.1007742051048172,96,d);se[c[f>>2]&3](29,3,-1.0,97,d);se[c[f>>2]&3](29,5,+h[(c[g>>2]|0)+3528>>3]*-.1727557801796867,98,d);se[c[f>>2]&3](29,15,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+568>>3]*+h[(c[g>>2]|0)+3528>>3]),99,d);se[c[f>>2]&3](29,25,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+576>>3]*+h[(c[g>>2]|0)+3528>>3]),100,d);se[c[f>>2]&3](30,1,-.1007742051048172,101,d);se[c[f>>2]&3](30,2,-1.0,102,d);se[c[f>>2]&3](30,3,.1727557801796867,103,d);se[c[f>>2]&3](31,1,-1.0,104,d);se[c[f>>2]&3](31,5,+h[(c[g>>2]|0)+3528>>3]*.1007742051048172,105,d);se[c[f>>2]&3](31,15,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3]*+h[(c[g>>2]|0)+3528>>3]),106,d);se[c[f>>2]&3](31,25,-(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+600>>3]*+h[(c[g>>2]|0)+3528>>3]),107,d);se[c[f>>2]&3](32,0,-1.0,108,d);se[c[f>>2]&3](32,29,.1727557801796867,109,d);i=e;return}function Bj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0;e=i;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=j+560|0;l=+h[k>>3];m=b+416|0;n=c[m>>2]|0;o=n+2944|0;p=j+552|0;q=+h[p>>3];r=j+544|0;s=n+3456|0;n=d+36|0;d=c[n>>2]|0;h[d>>3]=+h[s>>3]*(+h[j+576>>3]*+h[o>>3]+(l*l*-.1007742051048172+q*(q*-.1007742051048172+ +h[r>>3]*.1727557801796867)));t=j+624|0;u=d+8|0;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[u+12>>2]=0;c[u+16>>2]=0;c[u+20>>2]=0;q=+h[k>>3];h[d+32>>3]=+h[s>>3]*(+h[t>>3]*+h[o>>3]+(+h[r>>3]*q*.1007742051048172+q*+h[p>>3]*.1727557801796867));h[d+40>>3]=0.0;q=+h[j+8712>>3];l=q*q;v=+h[j+2080>>3];w=+h[j+2072>>3];x=q*(+h[j+1344>>3]*w- +h[j+1336>>3]*v)- +h[j+8744>>3]*(w*+h[j+672>>3]-v*+h[j+664>>3]);do{if(l!=0.0){y=j;z=g;A=d;B=x/l}else{if(x==0.0){y=j;z=g;A=d;B=x;break}v=x/+J9(c[b+536>>2]|0,l,5784,5776,+h[g>>3],(a[b+319|0]|0)!=0|0);p=c[c[f>>2]>>2]|0;y=c[p+8>>2]|0;z=p;A=c[n>>2]|0;B=v}}while(0);h[A+48>>3]=B;B=+h[y+8728>>3];l=+h[y+2112>>3];x=B*B;B=+h[y+8688>>3];do{if(x!=0.0){C=y;D=z;E=A;F=B/x}else{if(B==0.0){C=y;D=z;E=A;F=B;break}v=B/+J9(c[b+536>>2]|0,x,5680,5776,+h[z>>3],(a[b+319|0]|0)!=0|0);g=c[c[f>>2]>>2]|0;C=c[g+8>>2]|0;D=g;E=c[n>>2]|0;F=v}}while(0);h[E+56>>3]=-(l*F);z=C+16|0;F=+h[z>>3];l=-F;A=c[m>>2]|0;y=A+384|0;g=C+8136|0;d=A+392|0;h[E+64>>3]=+h[C+8112>>3]*F*+h[y>>3]*l+ +h[g>>3]*F*+h[d>>3]*l;h[E+72>>3]=+h[g>>3]*+h[A+2944>>3]*6.602749999999998;h[E+80>>3]=0.0;h[E+88>>3]=+h[A+3184>>3];g=C+688|0;j=E+96|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;j=C+8704|0;h[E+112>>3]=+h[g>>3]*+h[j>>3];h[E+120>>3]=+h[C+696>>3]*+h[j>>3];h[E+128>>3]=0.0;l=+h[z>>3];F=-l;h[E+136>>3]=+h[C+8104>>3]*l*+h[y>>3]*F+ +h[C+8128>>3]*l*+h[d>>3]*F;F=+h[C+8728>>3];l=+h[C+2104>>3];x=F*F;F=+h[C+8688>>3];do{if(x!=0.0){G=A;H=C;I=E;J=F/x}else{if(F==0.0){G=A;H=C;I=E;J=F;break}B=F/+J9(c[b+536>>2]|0,x,5680,5776,+h[D>>3],(a[b+319|0]|0)!=0|0);G=c[m>>2]|0;H=c[(c[c[f>>2]>>2]|0)+8>>2]|0;I=c[n>>2]|0;J=B}}while(0);h[I+144>>3]=-(l*J);b=H+2072|0;D=H+2080|0;h[I+152>>3]=-(+h[H+1344>>3]*+h[D>>3])- +h[H+1336>>3]*+h[b>>3];h[I+160>>3]=0.0;E=G+2944|0;C=H+544|0;A=H+560|0;J=+h[A>>3];d=H+552|0;y=G+3528|0;h[I+168>>3]=+h[y>>3]*(+h[H+624>>3]*+h[E>>3]+(+h[C>>3]*J*-.1007742051048172+J*+h[d>>3]*-.1727557801796867));z=H+1384|0;j=I+176|0;c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;c[j+24>>2]=0;c[j+28>>2]=0;h[I+208>>3]=+h[z>>3]*+h[b>>3]+ +h[H+1392>>3]*+h[D>>3];h[I+216>>3]=0.0;J=+h[C>>3];l=+h[A>>3];h[I+224>>3]=+h[G+3456>>3]*(+h[H+600>>3]*+h[E>>3]+(l*l*-.1727557801796867-J*(J*.1727557801796867+ +h[d>>3]*-.1007742051048172)));J=+h[A>>3];l=+h[d>>3];d=c[n>>2]|0;h[d+232>>3]=+h[y>>3]*(+h[H+576>>3]*+h[E>>3]+(J*J*.1007742051048172+l*(l*.1007742051048172+ +h[C>>3]*-.1727557801796867)));h[d+240>>3]=0.0;C=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[m>>2]|0;l=+h[C+544>>3];J=+h[C+560>>3];h[d+248>>3]=+h[f+3528>>3]*(+h[C+600>>3]*+h[f+2944>>3]+(J*J*.1727557801796867-l*(l*-.1727557801796867+ +h[C+552>>3]*.1007742051048172)));h[d+256>>3]=0.0;i=e;return}function Cj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](0,11,-(+h[j+8112>>3]*+h[j+576>>3])- +h[j+8104>>3]*+h[j+568>>3],0,d);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](0,13,-(+h[j+8112>>3]*+h[j+600>>3])- +h[j+8104>>3]*+h[j+592>>3],1,d);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](0,24,-(+h[j+8112>>3]*+h[j+624>>3])- +h[j+8104>>3]*+h[j+616>>3],2,d);se[c[f>>2]&3](0,26,1.0,3,d);se[c[f>>2]&3](0,28,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8104>>3],4,d);se[c[f>>2]&3](0,32,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8112>>3],5,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+672>>3];n=+h[l+8728>>3];o=+h[l+8080>>3];do{if(n!=0.0){p=o/n}else{if(o==0.0){p=o;break}p=o/+J9(c[b+536>>2]|0,n,5752,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](1,25,-(m*p),6,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;p=+h[l+672>>3];m=+h[l+8728>>3];n=+h[l+8088>>3];do{if(m!=0.0){q=n/m}else{if(n==0.0){q=n;break}q=n/+J9(c[b+536>>2]|0,m,5752,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](1,29,-(p*q),7,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;q=+h[l+680>>3]*+h[l+8728>>3];p=+h[l+8088>>3];do{if(q!=0.0){r=p/q}else{if(p==0.0){r=p;break}r=p/+J9(c[b+536>>2]|0,q,5824,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](1,31,r,8,d);se[c[f>>2]&3](1,32,1.0,9,d);se[c[f>>2]&3](2,0,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],10,d);se[c[f>>2]&3](2,9,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],11,d);se[c[f>>2]&3](2,12,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],12,d);se[c[f>>2]&3](2,20,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],13,d);se[c[f>>2]&3](2,21,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],14,d);se[c[f>>2]&3](2,30,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],15,d);se[c[f>>2]&3](2,31,1.0,16,d);se[c[f>>2]&3](3,0,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],17,d);se[c[f>>2]&3](3,9,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],18,d);se[c[f>>2]&3](3,12,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],19,d);se[c[f>>2]&3](3,20,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],20,d);se[c[f>>2]&3](3,21,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],21,d);se[c[f>>2]&3](3,29,1.0,22,d);se[c[f>>2]&3](3,30,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],23,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;r=+h[l+664>>3];q=+h[l+8728>>3];p=+h[l+8080>>3];do{if(q!=0.0){s=p/q}else{if(p==0.0){s=p;break}s=p/+J9(c[b+536>>2]|0,q,5752,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](4,25,-(r*s),24,d);se[c[f>>2]&3](4,28,1.0,25,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;s=+h[l+664>>3];r=+h[l+8728>>3];q=+h[l+8088>>3];do{if(r!=0.0){t=q/r}else{if(q==0.0){t=q;break}t=q/+J9(c[b+536>>2]|0,r,5752,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](4,29,-(s*t),26,d);j=c[f>>2]|0;k=c[c[g>>2]>>2]|0;l=c[k+8>>2]|0;t=+h[l+680>>3]*+h[l+8728>>3];s=+h[l+8080>>3];do{if(t!=0.0){u=s/t}else{if(s==0.0){u=s;break}u=s/+J9(c[b+536>>2]|0,t,5824,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[j&3](4,31,u,27,d);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](5,11,-(+h[j+8136>>3]*+h[j+576>>3])- +h[j+8128>>3]*+h[j+568>>3],28,d);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](5,13,-(+h[j+8136>>3]*+h[j+600>>3])- +h[j+8128>>3]*+h[j+592>>3],29,d);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;se[c[f>>2]&3](5,24,-(+h[j+8136>>3]*+h[j+624>>3])- +h[j+8128>>3]*+h[j+616>>3],30,d);se[c[f>>2]&3](5,27,1.0,31,d);se[c[f>>2]&3](5,28,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8128>>3],32,d);se[c[f>>2]&3](5,32,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8136>>3],33,d);se[c[f>>2]&3](6,2,-1.0,34,d);j=b+416|0;se[c[f>>2]&3](6,26,+h[(c[j>>2]|0)+392>>3],35,d);se[c[f>>2]&3](6,27,-+h[(c[j>>2]|0)+384>>3],36,d);se[c[f>>2]&3](7,0,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],37,d);se[c[f>>2]&3](7,9,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],38,d);se[c[f>>2]&3](7,12,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],39,d);se[c[f>>2]&3](7,20,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],40,d);se[c[f>>2]&3](7,21,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],41,d);se[c[f>>2]&3](7,25,1.0,42,d);se[c[f>>2]&3](7,30,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],43,d);se[c[f>>2]&3](8,24,-.1727557801796867,44,d);se[c[f>>2]&3](8,30,-1.0,45,d);se[c[f>>2]&3](9,5,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3]*+h[(c[j>>2]|0)+3528>>3]),46,d);se[c[f>>2]&3](9,7,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3]*+h[(c[j>>2]|0)+3528>>3]),47,d);se[c[f>>2]&3](9,18,+h[(c[j>>2]|0)+3528>>3]*-.1007742051048172,48,d);se[c[f>>2]&3](9,23,+h[(c[j>>2]|0)+3528>>3]*.1727557801796867,49,d);se[c[f>>2]&3](9,24,-1.0,50,d);se[c[f>>2]&3](10,18,+h[(c[j>>2]|0)+3456>>3]*.1007742051048172,51,d);se[c[f>>2]&3](10,22,-1.0,52,d);se[c[f>>2]&3](10,23,+h[(c[j>>2]|0)+3456>>3]*-.1727557801796867,53,d);se[c[f>>2]&3](11,21,-1.0,54,d);se[c[f>>2]&3](11,22,.1727557801796867,55,d);se[c[f>>2]&3](12,20,-1.0,56,d);se[c[f>>2]&3](12,22,-.1007742051048172,57,d);se[c[f>>2]&3](13,16,-.5038710255240861,58,d);se[c[f>>2]&3](13,19,.8637789008984335,59,d);se[c[f>>2]&3](13,23,1.0,60,d);se[c[f>>2]&3](14,16,-.8637789008984333,61,d);se[c[f>>2]&3](14,18,1.0,62,d);se[c[f>>2]&3](14,19,-.5038710255240862,63,d);se[c[f>>2]&3](15,4,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],64,d);se[c[f>>2]&3](15,17,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+672>>3],65,d);se[c[f>>2]&3](15,19,1.0,66,d);k=c[f>>2]|0;l=c[c[g>>2]>>2]|0;v=c[l+8>>2]|0;u=+h[v+8712>>3];t=+h[v+672>>3];s=-t;do{if(u!=0.0){w=s/u}else{if(t==-0.0){w=s;break}w=s/+J9(c[b+536>>2]|0,u,5656,5816,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](16,4,w,67,d);se[c[f>>2]&3](16,16,1.0,68,d);k=c[f>>2]|0;l=c[c[g>>2]>>2]|0;v=c[l+8>>2]|0;w=+h[v+8712>>3];u=+h[v+664>>3];do{if(w!=0.0){x=u/w}else{if(u==0.0){x=u;break}x=u/+J9(c[b+536>>2]|0,w,5656,5816,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[k&3](16,17,x,69,d);se[c[f>>2]&3](17,4,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8080>>3],70,d);se[c[f>>2]&3](17,15,1.0,71,d);se[c[f>>2]&3](17,17,-+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8088>>3],72,d);se[c[f>>2]&3](18,14,1.0,73,d);se[c[f>>2]&3](18,15,-.9999999999999999,74,d);se[c[f>>2]&3](19,5,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3]*+h[(c[j>>2]|0)+3528>>3]),75,d);se[c[f>>2]&3](19,7,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3]*+h[(c[j>>2]|0)+3528>>3]),76,d);se[c[f>>2]&3](19,13,-1.0,77,d);se[c[f>>2]&3](19,14,+h[(c[j>>2]|0)+3528>>3]*.1007742051048172,78,d);se[c[f>>2]&3](20,11,.1727557801796867,79,d);se[c[f>>2]&3](20,12,-1.0,80,d);se[c[f>>2]&3](20,13,-.1007742051048172,81,d);se[c[f>>2]&3](21,5,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3]*+h[(c[j>>2]|0)+3528>>3]),82,d);se[c[f>>2]&3](21,7,-(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3]*+h[(c[j>>2]|0)+3528>>3]),83,d);se[c[f>>2]&3](21,11,-1.0,84,d);se[c[f>>2]&3](21,14,+h[(c[j>>2]|0)+3528>>3]*-.1727557801796867,85,d);se[c[f>>2]&3](22,10,-1.0,86,d);se[c[f>>2]&3](22,14,+h[(c[j>>2]|0)+3456>>3]*-.1007742051048172,87,d);se[c[f>>2]&3](23,8,-.1727557801796867,88,d);se[c[f>>2]&3](23,9,-1.0,89,d);se[c[f>>2]&3](23,10,.1007742051048172,90,d);se[c[f>>2]&3](24,8,-1.0,91,d);se[c[f>>2]&3](24,14,+h[(c[j>>2]|0)+3456>>3]*.1727557801796867,92,d);k=c[c[g>>2]>>2]|0;x=+h[(c[k+8>>2]|0)+8728>>3];l=c[f>>2]|0;w=x*x;u=-x;do{if(w!=0.0){y=u/w}else{if(x==-0.0){y=u;break}y=u/+J9(c[b+536>>2]|0,w,5680,5816,+h[k>>3],(a[b+319|0]|0)!=0|0)}}while(0);se[l&3](25,7,y,93,d);se[c[f>>2]&3](25,17,1.0,94,d);l=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=c[j>>2]|0;se[c[f>>2]&3](26,6,+h[l+8112>>3]*+h[k+392>>3]- +h[l+8136>>3]*+h[k+384>>3],95,d);se[c[f>>2]&3](26,7,1.0,96,d);se[c[f>>2]&3](27,5,1.0,97,d);k=c[(c[c[g>>2]>>2]|0)+8>>2]|0;l=c[j>>2]|0;se[c[f>>2]&3](27,6,+h[k+8104>>3]*+h[l+392>>3]- +h[k+8128>>3]*+h[l+384>>3],98,d);se[c[f>>2]&3](28,4,1.0,99,d);l=c[c[g>>2]>>2]|0;y=+h[(c[l+8>>2]|0)+8728>>3];g=c[f>>2]|0;w=y*y;u=-y;if(w!=0.0){z=u/w;se[g&3](28,5,z,100,d);A=c[f>>2]|0;se[A&3](29,1,-.35,101,d);B=c[f>>2]|0;se[B&3](29,3,1.0,102,d);C=c[f>>2]|0;se[C&3](29,6,-.2702863223958332,103,d);D=c[f>>2]|0;se[D&3](30,2,1.0,104,d);E=c[f>>2]|0;se[E&3](30,3,1.0,105,d);F=c[f>>2]|0;se[F&3](31,1,1.0,106,d);G=c[f>>2]|0;se[G&3](31,6,-2.310962499999999,107,d);H=c[f>>2]|0;se[H&3](32,0,-1.0,108,d);I=c[f>>2]|0;se[I&3](32,24,.1007742051048172,109,d);i=e;return}if(y==-0.0){z=u;se[g&3](28,5,z,100,d);A=c[f>>2]|0;se[A&3](29,1,-.35,101,d);B=c[f>>2]|0;se[B&3](29,3,1.0,102,d);C=c[f>>2]|0;se[C&3](29,6,-.2702863223958332,103,d);D=c[f>>2]|0;se[D&3](30,2,1.0,104,d);E=c[f>>2]|0;se[E&3](30,3,1.0,105,d);F=c[f>>2]|0;se[F&3](31,1,1.0,106,d);G=c[f>>2]|0;se[G&3](31,6,-2.310962499999999,107,d);H=c[f>>2]|0;se[H&3](32,0,-1.0,108,d);I=c[f>>2]|0;se[I&3](32,24,.1007742051048172,109,d);i=e;return}z=u/+J9(c[b+536>>2]|0,w,5680,5816,+h[l>>3],(a[b+319|0]|0)!=0|0);se[g&3](28,5,z,100,d);A=c[f>>2]|0;se[A&3](29,1,-.35,101,d);B=c[f>>2]|0;se[B&3](29,3,1.0,102,d);C=c[f>>2]|0;se[C&3](29,6,-.2702863223958332,103,d);D=c[f>>2]|0;se[D&3](30,2,1.0,104,d);E=c[f>>2]|0;se[E&3](30,3,1.0,105,d);F=c[f>>2]|0;se[F&3](31,1,1.0,106,d);G=c[f>>2]|0;se[G&3](31,6,-2.310962499999999,107,d);H=c[f>>2]|0;se[H&3](32,0,-1.0,108,d);I=c[f>>2]|0;se[I&3](32,24,.1007742051048172,109,d);i=e;return}function Dj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;e=i;f=d+36|0;d=c[f>>2]|0;h[d>>3]=0.0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=k+8704|0;h[d+8>>3]=+h[k+696>>3]*+h[l>>3];m=k+688|0;n=d+16|0;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;c[n+12>>2]=0;h[d+32>>3]=+h[m>>3]*+h[l>>3];l=k+624|0;m=d+40|0;c[m+0>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;c[m+12>>2]=0;c[m+16>>2]=0;c[m+20>>2]=0;c[m+24>>2]=0;c[m+28>>2]=0;m=b+416|0;n=c[m>>2]|0;o=n+2944|0;p=k+544|0;q=k+560|0;r=+h[q>>3];s=k+552|0;h[d+72>>3]=+h[n+3528>>3]*(+h[l>>3]*+h[o>>3]+(+h[p>>3]*r*-.1007742051048172+r*+h[s>>3]*-.1727557801796867));r=+h[q>>3];h[d+80>>3]=+h[n+3456>>3]*(+h[l>>3]*+h[o>>3]+(+h[p>>3]*r*.1007742051048172+r*+h[s>>3]*.1727557801796867));s=k+1336|0;p=d+88|0;c[p+0>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=0;c[p+28>>2]=0;p=k+2072|0;o=k+1344|0;l=k+2080|0;h[d+120>>3]=-(+h[o>>3]*+h[l>>3])- +h[s>>3]*+h[p>>3];r=+h[k+8712>>3];t=r*r;u=+h[l>>3];v=+h[p>>3];w=r*(+h[o>>3]*v- +h[s>>3]*u)- +h[k+8744>>3]*(v*+h[k+672>>3]-u*+h[k+664>>3]);do{if(t!=0.0){x=n;y=w/t}else{if(w==0.0){x=n;y=w;break}u=w/+J9(c[b+536>>2]|0,t,5784,5864,+h[j>>3],(a[b+319|0]|0)!=0|0);x=c[m>>2]|0;y=u}}while(0);j=c[f>>2]|0;h[j+128>>3]=y;n=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[j+136>>3]=+h[n+1384>>3]*+h[n+2072>>3]+ +h[n+1392>>3]*+h[n+2080>>3];h[j+144>>3]=0.0;k=n+600|0;s=x+2944|0;o=n+544|0;y=+h[o>>3];p=n+552|0;l=n+560|0;t=+h[l>>3];d=x+3528|0;h[j+152>>3]=+h[d>>3]*(+h[k>>3]*+h[s>>3]+(t*t*.1727557801796867-y*(y*-.1727557801796867+ +h[p>>3]*.1007742051048172)));h[j+160>>3]=0.0;y=+h[l>>3];q=n+576|0;t=+h[p>>3];h[j+168>>3]=+h[d>>3]*(+h[q>>3]*+h[s>>3]+(y*y*.1007742051048172+t*(t*.1007742051048172+ +h[o>>3]*-.1727557801796867)));t=+h[o>>3];y=+h[l>>3];d=x+3456|0;h[j+176>>3]=+h[d>>3]*(+h[k>>3]*+h[s>>3]+(y*y*-.1727557801796867-t*(t*.1727557801796867+ +h[p>>3]*-.1007742051048172)));h[j+184>>3]=0.0;t=+h[l>>3];y=+h[p>>3];p=c[f>>2]|0;h[p+192>>3]=+h[d>>3]*(+h[q>>3]*+h[s>>3]+(t*t*-.1007742051048172+y*(y*-.1007742051048172+ +h[o>>3]*.1727557801796867)));o=c[c[g>>2]>>2]|0;s=c[o+8>>2]|0;y=+h[s+8728>>3];t=+h[s+2112>>3];w=y*y;y=+h[s+8688>>3];do{if(w!=0.0){z=s;A=o;B=p;C=y/w}else{if(y==0.0){z=s;A=o;B=p;C=y;break}u=y/+J9(c[b+536>>2]|0,w,5680,5864,+h[o>>3],(a[b+319|0]|0)!=0|0);q=c[c[g>>2]>>2]|0;z=c[q+8>>2]|0;A=q;B=c[f>>2]|0;C=u}}while(0);h[B+200>>3]=-(t*C);o=z+16|0;C=+h[o>>3];t=-C;p=c[m>>2]|0;s=p+384|0;q=p+392|0;h[B+208>>3]=+h[z+8112>>3]*C*+h[s>>3]*t+ +h[z+8136>>3]*C*+h[q>>3]*t;t=+h[o>>3];C=-t;h[B+216>>3]=+h[z+8104>>3]*t*+h[s>>3]*C+ +h[z+8128>>3]*t*+h[q>>3]*C;C=+h[z+8728>>3];t=+h[z+2104>>3];w=C*C;C=+h[z+8688>>3];if(w!=0.0){D=z;E=p;F=B;G=C/w;H=t*G;I=-H;J=F;K=J+224|0;L=K;h[L>>3]=I;M=F;N=M+232|0;O=N;h[O>>3]=0.0;P=E;Q=P+3184|0;R=Q;S=+h[R>>3];T=F;U=T+240|0;V=U;h[V>>3]=S;W=D;X=W+8136|0;Y=X;Z=+h[Y>>3];_=E;$=_+2944|0;aa=$;ba=+h[aa>>3];ca=Z*ba;da=ca*6.602749999999998;ea=F;fa=ea+248|0;ga=fa;h[ga>>3]=da;ha=F;ia=ha+256|0;ja=ia;h[ja>>3]=0.0;i=e;return}if(C==0.0){D=z;E=p;F=B;G=C;H=t*G;I=-H;J=F;K=J+224|0;L=K;h[L>>3]=I;M=F;N=M+232|0;O=N;h[O>>3]=0.0;P=E;Q=P+3184|0;R=Q;S=+h[R>>3];T=F;U=T+240|0;V=U;h[V>>3]=S;W=D;X=W+8136|0;Y=X;Z=+h[Y>>3];_=E;$=_+2944|0;aa=$;ba=+h[aa>>3];ca=Z*ba;da=ca*6.602749999999998;ea=F;fa=ea+248|0;ga=fa;h[ga>>3]=da;ha=F;ia=ha+256|0;ja=ia;h[ja>>3]=0.0;i=e;return}y=C/+J9(c[b+536>>2]|0,w,5680,5864,+h[A>>3],(a[b+319|0]|0)!=0|0);D=c[(c[c[g>>2]>>2]|0)+8>>2]|0;E=c[m>>2]|0;F=c[f>>2]|0;G=y;H=t*G;I=-H;J=F;K=J+224|0;L=K;h[L>>3]=I;M=F;N=M+232|0;O=N;h[O>>3]=0.0;P=E;Q=P+3184|0;R=Q;S=+h[R>>3];T=F;U=T+240|0;V=U;h[V>>3]=S;W=D;X=W+8136|0;Y=X;Z=+h[Y>>3];_=E;$=_+2944|0;aa=$;ba=+h[aa>>3];ca=Z*ba;da=ca*6.602749999999998;ea=F;fa=ea+248|0;ga=fa;h[ga>>3]=da;ha=F;ia=ha+256|0;ja=ia;h[ja>>3]=0.0;i=e;return}function Ej(a){a=a|0;c[a+20>>2]=88;c[a+16>>2]=33;c[a+12>>2]=110;c[a>>2]=45;c[a+4>>2]=46;c[a+84>>2]=1459;c[a+80>>2]=33;c[a+76>>2]=110;c[a+64>>2]=47;c[a+68>>2]=48;i=i;return}function Fj(a,b){a=a|0;b=b|0;i=i;return}function Gj(a){a=a|0;i=i;return}function Hj(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 5872}function Ij(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function Jj(a){a=a|0;i=i;return 5872}function Kj(a,b){a=a|0;b=b|0;i=i;return 0}function Lj(a){a=a|0;a=i;i=i+8|0;D9(8,1,5880,a);if((c[49888>>2]|0)==0){i=a;return 0}fe[c[12602]&511](8);i=a;return 0}function Mj(a){a=a|0;i=i;return 5912}function Nj(a,b){a=a|0;b=b|0;b=i;i=i+8|0;D9(21,1,5920,b);if((c[49940>>2]|0)==0){i=b;return 0}fe[c[12602]&511](21);i=b;return 0}function Oj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+2936>>3];i=i;return}function Pj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+2936>>3];i=i;return}function Qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+416|0;f=Mca(+h[(c[e>>2]|0)+3936>>3],0.0)|0;g=Mca(+h[(c[e>>2]|0)+3944>>3],0.0)|0;e=c[b+424>>2]|0;do{if((a[e]|0)==0){j=0}else{if((a[e+58|0]|0)==0){j=0;break}if((a[e+59|0]|0)==0|f<<24>>24==0){j=0;break}j=g<<24>>24!=0|0}}while(0);a[e+62|0]=j;i=d;return}function Rj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2248>>3]=+h[b+1960>>3];i=i;return}function Sj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2240>>3]=+h[b+1952>>3];i=i;return}function Tj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2232>>3]=+h[b+1944>>3];i=i;return}function Uj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3528>>3]=+h[b+2936>>3];i=i;return}function Vj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+2936>>3];i=i;return}function Wj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+112>>3];i=i;return}function Xj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+104>>3];i=i;return}function Yj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+96>>3];i=i;return}function Zj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2968>>3]*.05;i=i;return}function _j(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=+h[(c[a+416>>2]|0)+3056>>3]*.8;i=i;return}function $j(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=+h[(c[a+416>>2]|0)+3056>>3]*2.2;i=i;return}function ak(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2264>>3]=+h[b+2856>>3]+ +h[b+2248>>3];i=i;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+2264>>3]- +h[(c[a+416>>2]|0)+2760>>3];i=i;return}function ck(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2216>>3]=+h[b+1816>>3]+ +h[b+400>>3];i=i;return}function dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+2216>>3]- +h[(c[a+416>>2]|0)+912>>3];i=i;return}function ek(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=0.0;i=i;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+X(+(+h[b+24>>3]));i=i;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8128>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+Y(+(+h[b+24>>3]));i=i;return}function ik(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2208>>3]=+h[b+1808>>3]+(+h[d+8112>>3]*+h[b+384>>3]+ +h[d+8136>>3]*+h[b+392>>3]);i=i;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+2208>>3]- +h[(c[a+416>>2]|0)+904>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8104>>3]=+X(+(+h[b+24>>3]));i=i;return}function lk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2200>>3]=+h[b+1800>>3]+(+h[d+8104>>3]*+h[b+384>>3]+ +h[d+8128>>3]*+h[b+392>>3]);i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[b+2200>>3]- +h[(c[a+416>>2]|0)+896>>3];i=i;return}function nk(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+720>>3];e=+h[b+712>>3];f=+h[b+2192>>3];h[b+8728>>3]=+V(+(d*d+(e*e+f*f)));i=i;return}function ok(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2192>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,5960,5952,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}function pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+704>>3]*.8637789008984333;i=i;return}function qk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=+h[b+704>>3]*.5038710255240861;i=i;return}function rk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+712>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,5960,5984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}function sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,5960,5992,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}function tk(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+696>>3];e=+h[b+688>>3];h[b+8720>>3]=d*d+e*e;i=i;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+8720>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+8712|0;p=o;h[p>>3]=m;i=b;return}g=c[24790]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=7328;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ie[a&31](q,d,6008,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+8712|0;p=o;h[p>>3]=m;i=b;return}function vk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,6096,6088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+696>>3]*.8637789008984333+ +h[b+8088>>3]*.5038710255240862;i=i;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+696>>3]*.5038710255240861+ +h[b+8088>>3]*-.8637789008984335;i=i;return}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=-(+h[b+704>>3]*+h[b+8088>>3]);i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+664>>3]*.9999999999999999;i=i;return}function Ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}k=l/+J9(c[b+536>>2]|0,j,6096,6120,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+688>>3]*.8637789008984333+ +h[b+8080>>3]*.5038710255240862;i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+568>>3]=+h[b+688>>3]*.5038710255240861+ +h[b+8080>>3]*-.8637789008984335;i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+688>>3]*+h[b+8088>>3]- +h[b+696>>3]*+h[b+8080>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+680>>3]*.9999999999999999;i=i;return}function Fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+704>>3]*+h[b+8080>>3];i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[b+672>>3]*.9999999999999999;i=i;return}function Hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+8728>>3]- +h[(c[a+416>>2]|0)+3416>>3];i=i;return}function Ik(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=0.0;i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function Kk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+1200>>3]=-(d*+h[b+16>>3]);i=i;return}function Lk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+1208>>3]=d*+h[b+16>>3];i=i;return}function Mk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+1216>>3]=-(d*+h[b+16>>3]);i=i;return}function Nk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+1224>>3]=-(d*+h[b+16>>3]);i=i;return}function Ok(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];h[b+1536>>3]=(d*d*-.35+ +h[b+8112>>3]*+h[(c[a+416>>2]|0)+2944>>3])*6.602749999999998;i=i;return}function Pk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+2104>>3]=+h[b+8128>>3]*d*+h[e+384>>3]- +h[b+8104>>3]*d*+h[e+392>>3];i=i;return}function Qk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,5960,6128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}function Rk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+2112>>3]=+h[b+8136>>3]*d*+h[e+384>>3]- +h[b+8112>>3]*d*+h[e+392>>3];i=i;return}function Sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3];k=+h[g+712>>3];l=+h[g+2192>>3];m=+V(+(j*j+(k*k+l*l)));l=j*+h[g+2104>>3]+k*+h[g+2112>>3];if(m!=0.0){n=g;o=l/m;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){n=g;o=l;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}k=l/+J9(c[b+536>>2]|0,m,6144,6136,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}function Tk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=j*j;l=j*+h[g+2104>>3]- +h[g+720>>3]*+h[g+8688>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,6240,6232,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}function Uk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=j*j;l=j*+h[g+2112>>3]- +h[g+712>>3]*+h[g+8688>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,6240,6272,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}function Vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=(+h[b+696>>3]*+h[b+1368>>3]+ +h[b+688>>3]*+h[b+1360>>3])*2.0;i=i;return}function Wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+8720>>3];if(!(m>=0.0)){n=c[24790]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=7328;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&31](o,e,6008,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+8736>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}z=m/+J9(c[b+536>>2]|0,t,6288,6280,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}function Xk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=j*j;l=j*+h[g+1360>>3]- +h[g+688>>3]*+h[g+8744>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,6336,6328,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}function Yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+1368>>3]*.8637789008984333+ +h[b+1392>>3]*.5038710255240862;i=i;return}function Zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+1368>>3]*.5038710255240861+ +h[b+1392>>3]*-.8637789008984335;i=i;return}function _k(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=j*j;l=+h[g+696>>3]*+h[g+8744>>3]-j*+h[g+1368>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,6336,6368,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+1360>>3]*.8637789008984333+ +h[b+1384>>3]*.5038710255240862;i=i;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+1360>>3]*.5038710255240861+ +h[b+1384>>3]*-.8637789008984335;i=i;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+688>>3]*+h[b+1392>>3]+(+h[b+1360>>3]*+h[b+8088>>3]+(-(+h[b+696>>3]*+h[b+1384>>3])- +h[b+1368>>3]*+h[b+8080>>3]));i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[b+1352>>3]*.9999999999999999;i=i;return}function dl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2192>>3];l=j*j;j=+h[g+8688>>3];do{if(l!=0.0){m=g;n=j/l}else{if(j==0.0){m=g;n=j;break}o=j/+J9(c[b+536>>2]|0,l,6240,6376,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1376>>3]=-(k*n);i=d;return}function el(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=-(+h[b+1376>>3]*+h[b+8088>>3])- +h[b+704>>3]*+h[b+1392>>3];i=i;return}function fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=+h[b+1336>>3]*.9999999999999999;i=i;return}function gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1344>>3]=+h[b+704>>3]*+h[b+1384>>3]+ +h[b+1376>>3]*+h[b+8080>>3];i=i;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+1344>>3]*.9999999999999999;i=i;return}function il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+1376>>3]*.8637789008984333;i=i;return}function jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1376>>3]*.5038710255240861;i=i;return}function kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8704>>3]=+h[(c[a+416>>2]|0)+3640>>3]*+h[b+8688>>3];i=i;return}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8696>>3]=+h[b+8704>>3]*+h[b+8688>>3];i=i;return}function ml(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,5960,6384,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}function nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+672>>3]*+h[g+2072>>3]- +h[g+664>>3]*+h[g+2080>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,6096,6392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}function ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=-(+h[b+672>>3]*+h[b+2080>>3])- +h[b+664>>3]*+h[b+2072>>3];i=i;return}function pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+640>>3]*.8637789008984333+ +h[b+648>>3]*.5038710255240862;i=i;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+640>>3]*.5038710255240861+ +h[b+648>>3]*-.8637789008984335;i=i;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=+h[b+8080>>3]*+h[b+2072>>3]+ +h[b+8088>>3]*+h[b+2080>>3];i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+656>>3]*.9999999999999999;i=i;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;_ca(a,0)|0;d=a+476|0;e=c[(c[d>>2]|0)+28>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+848>>3]=+h[e>>3];h[a+832>>3]=+h[e+8>>3];h[a+816>>3]=+h[e+16>>3];h[a+824>>3]=+h[e+24>>3];h[a+880>>3]=+h[e+32>>3];h[a+536>>3]=+h[e+40>>3];h[a+1416>>3]=+h[e+48>>3];h[a+808>>3]=+h[e+56>>3];h[a+768>>3]=+h[e+64>>3];h[a+760>>3]=+h[e+72>>3];h[a+800>>3]=+h[e+80>>3];h[a+840>>3]=+h[e+88>>3];h[a+520>>3]=+h[e+96>>3];h[a+1408>>3]=+h[e+104>>3];h[a+1456>>3]=+h[e+112>>3];h[a+1488>>3]=+h[e+120>>3];h[a+976>>3]=+h[e+128>>3];h[a+736>>3]=+h[e+136>>3];h[a+752>>3]=+h[e+144>>3];h[a+728>>3]=+h[e+152>>3];h[a+984>>3]=+h[e+160>>3];h[a+968>>3]=+h[e+168>>3];h[a+1528>>3]=+h[e+176>>3];h[a+1544>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+28>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+1592>>3]=+h[e+192>>3];h[d+1496>>3]=+h[e+200>>3];h[d+1464>>3]=+h[e+208>>3];h[d+1400>>3]=+h[e+216>>3];h[d+528>>3]=+h[e+224>>3];h[d+888>>3]=+h[e+232>>3];h[d+856>>3]=+h[e+240>>3];h[d+864>>3]=+h[e+248>>3];h[d+872>>3]=+h[e+256>>3];i=b;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+1592>>3];i=i;return}function vl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2104>>3];k=+h[g+2112>>3];l=+h[g+720>>3];m=+h[g+712>>3];n=+h[g+2192>>3];o=j*l+k*m;p=l*l+(m*m+n*n);n=p*4.0;q=+h[g+1488>>3];r=j*j;j=+h[g+1496>>3];s=k*k;k=+V(+p);p=k*(l*q+(r+(s+m*j)))*4.0;g=k!=0.0;t=o*o;if(n!=0.0){do{if(g){u=t/k}else{if(t==0.0){u=t;break}u=t/+J9(c[b+536>>2]|0,k,6144,6400,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=(p+u*-4.0)/n;w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}do{if(g){F=j;G=m;H=q;I=l;J=f;K=t/k}else{if(t==0.0){F=j;G=m;H=q;I=l;J=f;K=t;break}u=t/+J9(c[b+536>>2]|0,k,6144,6400,+h[f>>3],(a[b+319|0]|0)!=0|0);L=c[c[e>>2]>>2]|0;M=c[L+8>>2]|0;F=+h[M+1496>>3];G=+h[M+712>>3];H=+h[M+1488>>3];I=+h[M+720>>3];J=L;K=u}}while(0);l=k*(I*H+(r+(s+G*F)))*4.0;if(p+K*-4.0==0.0){do{if(g){N=t/k}else{if(t==0.0){N=t;break}N=t/+J9(c[b+536>>2]|0,k,6144,6400,+h[J>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=l+N*-4.0;w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}else{do{if(g){O=J;P=t/k}else{if(t==0.0){O=J;P=t;break}N=t/+J9(c[b+536>>2]|0,k,6144,6400,+h[J>>3],(a[b+319|0]|0)!=0|0);O=c[c[e>>2]>>2]|0;P=N}}while(0);v=(l+P*-4.0)/+J9(c[b+536>>2]|0,n,6408,6400,+h[O>>3],(a[b+319|0]|0)!=0|0);w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}}function wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+584>>3]*+h[b+872>>3]+(+h[b+608>>3]*+h[b+880>>3]+ +h[b+632>>3]*+h[b+888>>3]);i=i;return}function xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=+h[b+576>>3]*+h[b+872>>3]+(+h[b+600>>3]*+h[b+880>>3]+ +h[b+624>>3]*+h[b+888>>3]);i=i;return}function yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[b+568>>3]*+h[b+872>>3]+(+h[b+592>>3]*+h[b+880>>3]+ +h[b+616>>3]*+h[b+888>>3]);i=i;return}function zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+984>>3]- +h[b+1536>>3];i=i;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=+h[b+728>>3]+ +h[b+776>>3];i=i;return}function Bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+704>>3]*+h[g+8704>>3];k=+h[g+680>>3];l=+h[g+8728>>3];m=+h[g+8080>>3]*+h[g+752>>3]+ +h[g+8088>>3]*+h[g+760>>3];if(l!=0.0){n=g;o=m/l;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}if(m==0.0){n=g;o=m;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}u=m/+J9(c[b+536>>2]|0,l,5960,6504,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+2192>>3]*+h[b+728>>3]+(+h[b+760>>3]- +h[b+720>>3]*+h[b+744>>3]);i=i;return}function Dl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+744>>3]+ +h[b+792>>3];i=i;return}function El(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+952>>3]=+h[b+896>>3]*+h[d+936>>3]+(-(+h[b+912>>3]*+h[d+920>>3])- +h[d+904>>3]);i=i;return}function Fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+744>>3]- +h[b+632>>3]*+h[b+840>>3]- +h[b+608>>3]*+h[b+832>>3]- +h[b+584>>3]*+h[b+824>>3];i=i;return}function Gl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+992>>3]=+h[b+400>>3]*+h[d+984>>3]+ +h[b+384>>3]*+h[d+1056>>3];i=i;return}function Hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+720>>3]*+h[b+736>>3]+(+h[b+768>>3]- +h[b+712>>3]*+h[b+728>>3]);i=i;return}function Il(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+712>>3]*+h[b+744>>3]+(+h[b+752>>3]- +h[b+2192>>3]*+h[b+736>>3]);i=i;return}function Jl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+736>>3]+ +h[b+784>>3];i=i;return}function Kl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+960>>3]=+h[b+904>>3]*+h[d+920>>3]+(-(+h[b+896>>3]*+h[d+928>>3])- +h[d+912>>3]);i=i;return}function Ll(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+944>>3]=+h[b+912>>3]*+h[d+928>>3]+(-(+h[b+904>>3]*+h[d+936>>3])- +h[d+896>>3]);i=i;return}function Ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+976>>3]- +h[b+1544>>3];i=i;return}function Nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=-(+h[b+8136>>3]*+h[b+1008>>3])- +h[b+8112>>3]*+h[b+1016>>3];i=i;return}function Ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=-(+h[b+8128>>3]*+h[b+1008>>3])- +h[b+8104>>3]*+h[b+1016>>3];i=i;return}function Pl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+512>>3]=+h[b+1800>>3]*+h[d+1048>>3]+(+h[b+3184>>3]- +h[b+1808>>3]*+h[d+1040>>3]);i=i;return}function Ql(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1e3>>3]=-(+h[b+400>>3]*+h[d+976>>3])- +h[b+392>>3]*+h[d+1056>>3];i=i;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=-(+h[b+8136>>3]*+h[b+992>>3])- +h[b+8112>>3]*+h[b+1e3>>3];i=i;return}function Sl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+504>>3]=+h[b+1816>>3]*+h[d+1040>>3]+(+h[d+1024>>3]- +h[b+1800>>3]*+h[d+1056>>3]);i=i;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=-(+h[b+8128>>3]*+h[b+992>>3])- +h[b+8104>>3]*+h[b+1e3>>3];i=i;return}function Ul(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+496>>3]=+h[b+1808>>3]*+h[d+1056>>3]+(+h[d+1032>>3]- +h[b+1816>>3]*+h[d+1048>>3]);i=i;return}function Vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=0.0;i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+X(+(+h[b+8>>3]));i=i;return}function Xl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8032>>3]=-+Y(+(+h[b+8>>3]));i=i;return}function Yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+Y(+(+h[b+8>>3]));i=i;return}function Zl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2256>>3]=+h[b+2848>>3]+(+h[d+8016>>3]*+h[b+2232>>3]+ +h[d+8040>>3]*+h[b+2240>>3]);i=i;return}function _l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2232>>3]=+h[b+2256>>3]- +h[(c[a+416>>2]|0)+2752>>3];i=i;return}function $l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8008>>3]=+X(+(+h[b+8>>3]));i=i;return}function am(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2248>>3]=+h[b+2840>>3]+(+h[d+8008>>3]*+h[b+2232>>3]+ +h[d+8032>>3]*+h[b+2240>>3]);i=i;return}function bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=+h[b+2248>>3]- +h[(c[a+416>>2]|0)+2744>>3];i=i;return}function cm(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2232>>3];f=+h[b+2240>>3];h[b+8648>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2232>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,6520,6512,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}function em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[b+312>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-(+h[b+312>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+2256>>3]- +h[b+312>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function hm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+288>>3]=+h[b+2752>>3]+ +h[d+312>>3]*+h[b+3952>>3];i=i;return}function im(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2240>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,6520,6632,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+320>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=-(+h[b+320>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+2264>>3]- +h[b+320>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function mm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+296>>3]=+h[b+2760>>3]+ +h[d+320>>3]*+h[b+3952>>3];i=i;return}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2224>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,6520,6640,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}function om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+304>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=-(+h[b+304>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+2248>>3]- +h[b+304>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function rm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+280>>3]=+h[b+2744>>3]+ +h[d+304>>3]*+h[b+3952>>3];i=i;return}function sm(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=0.0;i=i;return}function tm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b>>3];i=i;return}function um(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8>>3]));h[b+1304>>3]=-(d*+h[b>>3]);i=i;return}function vm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8>>3]));h[b+1312>>3]=d*+h[b>>3];i=i;return}function wm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8>>3]));h[b+1320>>3]=-(d*+h[b>>3]);i=i;return}function xm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8>>3]));h[b+1328>>3]=-(d*+h[b>>3]);i=i;return}function ym(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];h[b+1784>>3]=(d*d*-.35+ +h[b+8016>>3]*+h[(c[a+416>>2]|0)+2944>>3])*6.602749999999998;i=i;return}function zm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=c[a+416>>2]|0;h[b+1976>>3]=+h[b+8032>>3]*d*+h[e+2232>>3]- +h[b+8008>>3]*d*+h[e+2240>>3];i=i;return}function Am(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=c[a+416>>2]|0;h[b+1984>>3]=+h[b+8040>>3]*d*+h[e+2232>>3]- +h[b+8016>>3]*d*+h[e+2240>>3];i=i;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2224>>3];k=+h[g+2232>>3];l=j*+h[g+1976>>3]+k*+h[g+1984>>3];m=+h[g+2240>>3];n=+V(+(j*j+k*k+m*m));if(n!=0.0){o=n;p=g;q=.5/o;r=l*q;s=r*2.0;t=p;u=t+8656|0;v=u;h[v>>3]=s;i=d;return}m=+J9(c[b+536>>2]|0,n,6656,6648,+h[f>>3],(a[b+319|0]|0)!=0|0);o=m;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=.5/o;r=l*q;s=r*2.0;t=p;u=t+8656|0;v=u;h[v>>3]=s;i=d;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8672>>3]=+h[(c[a+416>>2]|0)+3928>>3]*+h[b+8656>>3];i=i;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1840>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1840|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+kda(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1840>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+160>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+160|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+kda(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+160>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+168>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+168|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+kda(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+168>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8760>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8760|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+kda(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8760>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+24>>3]=k;ida(a,0)|0;e=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1840>>3]=+h[e>>3];h[f+160>>3]=+h[e+8>>3];h[f+168>>3]=+h[e+16>>3];h[f+8760>>3]=+h[e+24>>3];Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);i=b;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+1840>>3];i=i;return}function Fm(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+152>>3];e=+h[b+320>>3];h[b+128>>3]=d-e*(+h[b+136>>3]*+h[b+304>>3]+(d*e+ +h[b+144>>3]*+h[b+312>>3]));i=i;return}



function Gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+176>>3]*+h[(c[a+416>>2]|0)+3944>>3]+(+h[b+128>>3]+ +h[b+320>>3]*+h[b+8672>>3]);i=i;return}function Hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+488>>3]- +h[b+1056>>3];i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+320>>3]*+h[b+8672>>3]+ +h[b+128>>3]- +h[b+200>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function Jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+936>>3]+ +h[b+368>>3]- +h[b+488>>3]- +h[b+1056>>3];i=i;return}function Km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1152>>3]=+h[b+936>>3]- +h[b+368>>3];i=i;return}function Lm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+312>>3]*+h[b+8672>>3]+ +h[b+120>>3]- +h[b+192>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function Mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=+h[b+928>>3]- +h[b+360>>3];i=i;return}function Nm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+376>>3]=+h[b+2760>>3]*+h[d+360>>3]- +h[b+2752>>3]*+h[d+368>>3];i=i;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+304>>3]*+h[b+8672>>3]+ +h[b+112>>3]- +h[b+184>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+920>>3]- +h[b+352>>3];i=i;return}function Qm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+384>>3]=+h[b+2744>>3]*+h[d+368>>3]- +h[b+2760>>3]*+h[d+352>>3];i=i;return}function Rm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+392>>3]=+h[b+2752>>3]*+h[d+352>>3]- +h[b+2744>>3]*+h[d+360>>3];i=i;return}function Sm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1120>>3]=+h[b+976>>3]- +h[b+408>>3];i=i;return}function Tm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+432>>3]=-(+h[b+2248>>3]*+h[d+408>>3])- +h[b+2240>>3]*+h[d+488>>3];i=i;return}function Um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+408>>3]- +h[b+1792>>3];i=i;return}function Vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+984>>3]- +h[b+416>>3];i=i;return}function Wm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+424>>3]=+h[b+2248>>3]*+h[d+416>>3]+ +h[b+2232>>3]*+h[d+488>>3];i=i;return}function Xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=-(+h[b+8040>>3]*+h[b+424>>3])- +h[b+8016>>3]*+h[b+432>>3];i=i;return}function Ym(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=-(+h[b+8032>>3]*+h[b+424>>3])- +h[b+8008>>3]*+h[b+432>>3];i=i;return}function Zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+416>>3]- +h[b+1784>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=-(+h[b+8040>>3]*+h[b+440>>3])- +h[b+8016>>3]*+h[b+448>>3];i=i;return}function $m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1096>>3]=+h[b+928>>3]+ +h[b+360>>3]- +h[b+480>>3]- +h[b+1048>>3];i=i;return}function an(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+328>>3]=+h[b+2848>>3]*+h[d+488>>3]+(+h[d+464>>3]- +h[b+2856>>3]*+h[d+480>>3]);i=i;return}function bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=-+h[b+376>>3]- +h[b+328>>3]- +h[b+496>>3]- +h[b+944>>3];i=i;return}function cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=-(+h[b+8032>>3]*+h[b+440>>3])- +h[b+8008>>3]*+h[b+448>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+920>>3]+ +h[b+352>>3]- +h[b+472>>3]- +h[b+1040>>3];i=i;return}function en(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+336>>3]=+h[b+2856>>3]*+h[d+472>>3]+(+h[d+456>>3]- +h[b+2840>>3]*+h[d+488>>3]);i=i;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=-+h[b+384>>3]- +h[b+336>>3]- +h[b+504>>3]- +h[b+952>>3];i=i;return}function gn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+344>>3]=+h[b+2840>>3]*+h[d+480>>3]+(+h[b+3656>>3]- +h[b+2848>>3]*+h[d+472>>3]);i=i;return}function hn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=-+h[b+392>>3]- +h[b+344>>3]- +h[b+512>>3]- +h[b+960>>3];i=i;return}function jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+8672>>3]*+h[b+8656>>3];i=i;return}function kn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+536|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=b+416|0;Ci(e,c[g>>2]|0,+h[k+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[k+8656>>3],0.0);m=+h[e>>3];Di(f,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);n=+h[f>>3];f=c[c[j>>2]>>2]|0;l=c[f+8>>2]|0;o=+h[l+2240>>3];p=n*n;if(p!=0.0){q=l;r=m/p;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}if(m==0.0){q=l;r=m;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}n=m/+J9(c[g>>2]|0,p,6888,6880,+h[f>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[j>>2]>>2]|0)+8>>2]|0;r=n;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}function ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=-(+h[b+1440>>3]*+h[(c[a+416>>2]|0)+3968>>3]);i=i;return}function mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+1440>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function nn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=b+4|0;l=b+416|0;Di(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);m=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[j>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);n=+h[f>>3];Di(g,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[g>>3];p=o*o;g=c[c[k>>2]>>2]|0;l=c[g+8>>2]|0;o=m*+h[l+1984>>3]-n*+h[l+2232>>3];if(p!=0.0){q=l;r=o/p;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}if(o==0.0){q=l;r=o;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}n=o/+J9(c[j>>2]|0,p,6888,7008,+h[g>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=n;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}function on(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+1984>>3]- +h[b+1432>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+1432>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function qn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=b+4|0;l=b+416|0;Di(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);m=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[j>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);n=+h[f>>3];Di(g,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[g>>3];p=o*o;g=c[c[k>>2]>>2]|0;l=c[g+8>>2]|0;o=m*+h[l+1976>>3]-n*+h[l+2224>>3];if(p!=0.0){q=l;r=o/p;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}if(o==0.0){q=l;r=o;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}n=o/+J9(c[j>>2]|0,p,6888,7016,+h[g>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=n;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}function rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+1976>>3]- +h[b+1424>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+1424>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3912>>3]=+h[b+3904>>3];i=i;return}function un(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2840>>3]- +h[b+2864>>3];e=+h[b+2848>>3]- +h[b+2872>>3];f=+h[b+2856>>3]- +h[b+2880>>3];h[b+3896>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3880>>3]=+h[b+3872>>3];i=i;return}function wn(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2744>>3]- +h[b+2768>>3];e=+h[b+2752>>3]- +h[b+2776>>3];f=+h[b+2760>>3]- +h[b+2784>>3];h[b+3864>>3]=+V(+(d*d+e*e+f*f));i=i;return}function xn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3064>>3]=+h[b+2968>>3]/9.0;i=i;return}function yn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3064>>3];i=i;return}function zn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3376>>3]=+h[b+3368>>3]/3.0;i=i;return}function An(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3512>>3]=+h[b+3064>>3];i=i;return}function Bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3584>>3]=+h[b+3064>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3840>>3]=+h[b+3064>>3];i=i;return}function Dn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3848>>3]=+h[b+3840>>3]/3.0;i=i;return}function En(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7544>>3]=+h[(c[a+416>>2]|0)+3584>>3]*-.5+-.1007742051048172;i=i;return}function Fn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=+h[(c[a+416>>2]|0)+3512>>3]*-.5+.1007742051048172;i=i;return}function Gn(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0.0;b=i;d=a+416|0;if((Mca(.2,+h[(c[d>>2]|0)+3584>>3]*.5)|0)<<24>>24==0){e=0.0}else{f=c[d>>2]|0;if((Mca(+h[f+3592>>3],+h[f+3584>>3]*1.1)|0)<<24>>24==0){g=0.0}else{g=+h[(c[d>>2]|0)+3584>>3]*.5}e=.2-g}h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=e;i=b;return}function Hn(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0.0;b=i;d=a+416|0;if((Mca(.2,+h[(c[d>>2]|0)+3512>>3]*.5)|0)<<24>>24==0){e=0.0}else{f=c[d>>2]|0;if((Mca(+h[f+3520>>3],+h[f+3512>>3]*1.1)|0)<<24>>24==0){g=0.0}else{g=+h[(c[d>>2]|0)+3512>>3]*.5}e=.2-g}h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8968>>3]=e;i=b;return}function In(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+2736>>3]=l;i=b;return}function Jn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+2728>>3]=l;i=b;return}function Kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+2720>>3]=l;i=b;return}function Ln(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+2712>>3]=l;i=b;return}function Mn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2440>>3]=+h[b+2032>>3];i=i;return}function Nn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2512>>3]=+h[b+2440>>3];i=i;return}function On(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2432>>3]=+h[b+2024>>3];i=i;return}function Pn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2504>>3]=+h[b+2432>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2424>>3]=+h[b+2016>>3];i=i;return}function Rn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2496>>3]=+h[b+2424>>3];i=i;return}function Sn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+2080>>3];i=i;return}function Tn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2480>>3]=+h[b+2072>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2472>>3]=+h[b+2064>>3];i=i;return}function Vn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2464>>3]=+h[b+2056>>3];i=i;return}function Wn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2456>>3]=+h[b+2048>>3];i=i;return}function Xn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2448>>3]=+h[b+2040>>3];i=i;return}function Yn(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+132>>2]=c[b+128>>2];i=i;return}function Zn(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1944>>3]- +h[b+1968>>3];e=+h[b+1952>>3]- +h[b+1976>>3];f=+h[b+1960>>3]- +h[b+1984>>3];h[b+3696>>3]=+V(+(d*d+e*e+f*f));i=i;return}function _n(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,7064,7056,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3712>>3]=l;i=d;return}function $n(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3728>>3]=+h[b+3712>>3];i=i;return}function ao(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3768>>3]=+h[b+3728>>3];i=i;return}function bo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3760>>3]=+h[b+3712>>3];i=i;return}function co(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3752>>3]=+h[b+3696>>3];i=i;return}function eo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2272>>3]=+h[b+1984>>3];i=i;return}function fo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2264>>3]=+h[b+1976>>3];i=i;return}function go(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2256>>3]=+h[b+1968>>3];i=i;return}function ho(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+48|0]=a[d+42|0]|0;i=i;return}function io(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3704>>3]=+h[b+3680>>3];i=i;return}function jo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3040>>3]=+h[b+2968>>3]*.05;i=i;return}function ko(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3200>>3]=+h[b+3040>>3];i=i;return}function lo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3040>>3];i=i;return}function mo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3672>>3]=+h[b+3040>>3];i=i;return}function no(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3032>>3]=+h[b+2968>>3]*.1;i=i;return}function oo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3032>>3];i=i;return}function po(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3032>>3];i=i;return}function qo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3424>>3]*.5;i=i;return}function ro(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3032>>3];i=i;return}function so(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3664>>3]=+h[b+3032>>3];i=i;return}function to(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=+h[(c[a+416>>2]|0)+3664>>3]*-.5;i=i;return}function uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6792>>3]=+h[(c[a+416>>2]|0)+3432>>3]*-.2519355127620431;i=i;return}function vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=+h[(c[a+416>>2]|0)+3432>>3]*.4318894504492167;i=i;return}function wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[(c[a+416>>2]|0)+3432>>3]*-.5;i=i;return}function xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6592>>3]=+h[(c[a+416>>2]|0)+3424>>3]*-.5;i=i;return}function yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6520>>3]=+h[(c[a+416>>2]|0)+3424>>3]*-.5;i=i;return}function zo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[(c[a+416>>2]|0)+3192>>3]*-.5;i=i;return}function Ao(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3624>>3]=+h[b+3616>>3];i=i;return}function Bo(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1800>>3]- +h[b+1824>>3];e=+h[b+1808>>3]- +h[b+1832>>3];f=+h[b+1816>>3]- +h[b+1840>>3];h[b+3608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Co(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+1792>>3]=l;i=b;return}function Do(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+1784>>3]=l;i=b;return}function Eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+1776>>3]=l;i=b;return}function Fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+1768>>3]=l;i=b;return}function Go(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+1496>>3];i=i;return}function Ho(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1560>>3]=+h[b+1488>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+1480>>3];i=i;return}function Jo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+1448>>3]=l;i=b;return}function Ko(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+1440>>3]=l;i=b;return}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+1432>>3]=l;i=b;return}function Mo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+1424>>3]=l;i=b;return}function No(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1224>>3]=+h[b+1152>>3];i=i;return}function Oo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1144>>3];i=i;return}function Po(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+1136>>3];i=i;return}function Qo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3400>>3];i=i;return}function Ro(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+896>>3]- +h[b+920>>3];e=+h[b+904>>3]- +h[b+928>>3];f=+h[b+912>>3]- +h[b+936>>3];h[b+3392>>3]=+V(+(d*d+e*e+f*f));i=i;return}function So(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+888>>3]=l;i=b;return}function To(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+880>>3]=l;i=b;return}function Uo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+872>>3]=l;i=b;return}function Vo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7040;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+864>>3]=l;i=b;return}function Wo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+184>>3];i=i;return}function Xo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+592>>3];i=i;return}function Yo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+176>>3];i=i;return}function Zo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+584>>3];i=i;return}function _o(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+168>>3];i=i;return}function $o(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+576>>3];i=i;return}function ap(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+232>>3];i=i;return}function bp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+224>>3];i=i;return}function cp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+216>>3];i=i;return}function dp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+208>>3];i=i;return}function ep(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+200>>3];i=i;return}function fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+192>>3];i=i;return}function gp(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function hp(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+96>>3]- +h[b+120>>3];e=+h[b+104>>3]- +h[b+128>>3];f=+h[b+112>>3]- +h[b+136>>3];h[b+3224>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ip(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3224>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,7064,7096,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3240>>3]=l;i=d;return}function jp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3256>>3]=+h[b+3240>>3];i=i;return}function kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3256>>3];i=i;return}function lp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3288>>3]=+h[b+3240>>3];i=i;return}function mp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3280>>3]=+h[b+3224>>3];i=i;return}function np(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+136>>3];i=i;return}function op(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+128>>3];i=i;return}function pp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+120>>3];i=i;return}function qp(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d+8|0]|0;i=i;return}function rp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3232>>3]=+h[b+3208>>3];i=i;return}function sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3016>>3]=+h[b+2968>>3]*.5;i=i;return}function tp(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2984>>3];j=+h[f+3016>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,7112,7104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3080>>3]=l;i=d;return}function up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3112>>3]=+h[b+3080>>3]*3.0;i=i;return}function vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+3080>>3];i=i;return}function wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3128>>3]=+h[b+3080>>3]*3.0;i=i;return}function xp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3088>>3]=+h[b+3016>>3]*.5;i=i;return}function yp(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3088>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,7064,7152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3136>>3]=l;i=d;return}function zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3160>>3]=+h[b+3136>>3]*3.0;i=i;return}function Ap(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3152>>3]=+sd(+(+h[d+3088>>3]),+(+h[d+3136>>3]*4.0));i=b;return}function Bp(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3168>>3]=+td(0.0,+(+h[d+3088>>3]- +h[d+3152>>3]));i=b;return}function Cp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3096>>3]=+h[b+3016>>3]*1.05;i=i;return}function Dp(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3104>>3]=+sd(+(+h[d+3016>>3]),+(+h[d+3080>>3]*5.0));i=b;return}function Ep(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3144>>3]=+td(0.0,+(+h[d+3016>>3]- +h[d+3104>>3]));i=b;return}function Fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[b+32>>3]- +h[b+3168>>3];i=i;return}function Gp(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=d;i=i;return}function Hp(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=d;i=i;return}function Ip(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7328;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7160,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=j;i=b;return}function Jp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=l;i=b;return}function Kp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=l;i=b;return}function Lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=l;i=b;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=l;i=b;return}function Np(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=l;i=b;return}function Op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=l;i=b;return}function Pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4760>>3]- +h[b+4784>>3]);i=i;return}function Qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4752>>3]- +h[b+4776>>3]);i=i;return}function Rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4744>>3]- +h[b+4768>>3]);i=i;return}function Sp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4712>>3]=+h[b+3096>>3]+ +h[d+4784>>3]*+h[b+3128>>3];i=i;return}function Tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4704>>3]=+h[b+4776>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+4768>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Vp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+4760>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Wp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+4752>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+4744>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Yp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4664>>3]=+h[b+3096>>3]+ +h[d+4784>>3]*+h[b+3128>>3];i=i;return}function Zp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+4776>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4648>>3]=+h[b+4768>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4640>>3]=+h[b+4760>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4632>>3]=+h[b+4752>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4624>>3]=+h[b+4744>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function cq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=+h[(c[a+416>>2]|0)+3128>>3]*.75;i=i;return}function dq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=+h[(c[a+416>>2]|0)+3128>>3]*.5;i=i;return}function eq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=+h[(c[a+416>>2]|0)+3128>>3]*1.5;i=i;return}function fq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=+h[(c[a+416>>2]|0)+3128>>3]*1.5;i=i;return}function gq(a){a=a|0;var b=0.0,d=0,e=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+4440>>3];h[d+4256>>3]=+V(+(b*b+e*e));i=i;return}function hq(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4464>>3];e=+h[b+4472>>3]- +h[b+4456>>3];h[b+4248>>3]=+V(+(d*d+e*e));i=i;return}function iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=l;i=b;return}function jq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=l;i=b;return}function kq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=l;i=b;return}function lq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=l;i=b;return}function mq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=l;i=b;return}function nq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=l;i=b;return}function oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4176>>3]*+h[b+4464>>3]+ +h[b+4200>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4168>>3]*+h[b+4464>>3]+ +h[b+4192>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+4160>>3]*+h[b+4464>>3]+ +h[b+4184>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function rq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+4200>>3]*+h[b+4456>>3];i=i;return}function sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[(c[a+416>>2]|0)+3096>>3]+ +h[b+4192>>3]*+h[b+4456>>3];i=i;return}function tq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+4184>>3]*+h[b+4456>>3];i=i;return}function uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+4176>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4200>>3]*+h[b+4440>>3];i=i;return}function vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4168>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4192>>3]*+h[b+4440>>3];i=i;return}function wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+4160>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4184>>3]*+h[b+4440>>3];i=i;return}function xq(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3792|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7328;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7160,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3792|0;w=v;h[w>>3]=j;i=b;return}function yq(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3784|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7328;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7160,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3784|0;w=v;h[w>>3]=j;i=b;return}function zq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=l;i=b;return}function Aq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=l;i=b;return}function Bq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=l;i=b;return}function Cq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=l;i=b;return}function Dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=l;i=b;return}function Eq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=l;i=b;return}function Fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3688>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3712>>3]- +h[b+3736>>3]);i=i;return}function Gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3680>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3704>>3]- +h[b+3728>>3]);i=i;return}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3672>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3696>>3]- +h[b+3720>>3]);i=i;return}function Iq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=+h[b+3736>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+3728>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function Kq(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3648>>3]=+h[b+3096>>3]+ +h[d+3720>>3]*+h[b+3128>>3];i=i;return}function Lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3712>>3]+ +h[b+3736>>3]);i=i;return}function Mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3632>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3704>>3]+ +h[b+3728>>3]);i=i;return}function Nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3696>>3]+ +h[b+3720>>3]);i=i;return}function Oq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3072>>3]=+h[b+2968>>3]*.025;i=i;return}function Pq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2968>>3]*.1;i=i;return}function Qq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3024>>3]=+h[b+2968>>3]*.2;i=i;return}function Rq(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+156>>2]=e;i=i;return}function Sq(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e]|0)==0){f=0}else{if((a[e+1|0]|0)==0){f=0;break}f=(a[e+4|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+152>>2]=f;i=d;return}function Tq(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+1|0]|0)!=0|0}c[(c[b+420>>2]|0)+148>>2]=e;i=i;return}function Uq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function Vq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function Wq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function Xq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function Yq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8616>>3]=1.0;i=i;return}function Zq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function _q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function $q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8608>>3]=0.0;i=i;return}function ar(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8584>>3]=1.0;i=i;return}function br(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8560>>3]=0.0;i=i;return}function cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8576>>3]=0.0;i=i;return}function er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8552>>3]=1.0;i=i;return}function fr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function gr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8536>>3]=0.0;i=i;return}function hr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8528>>3]=0.0;i=i;return}function ir(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function jr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8520>>3]=0.0;i=i;return}function kr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8512>>3]=0.0;i=i;return}function lr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function mr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8496>>3]=0.0;i=i;return}function nr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8488>>3]=0.0;i=i;return}function or(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8480>>3]=0.0;i=i;return}function pr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function qr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3]=0.0;i=i;return}function rr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8456>>3]=0.0;i=i;return}function sr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function tr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8440>>3]=0.0;i=i;return}function ur(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8432>>3]=0.0;i=i;return}function vr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function wr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8416>>3]=0.0;i=i;return}function xr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8408>>3]=0.0;i=i;return}function yr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8400>>3]=1.0;i=i;return}function zr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8392>>3]=0.0;i=i;return}function Ar(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function Br(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8376>>3]=0.0;i=i;return}function Cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8368>>3]=0.0;i=i;return}function Dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function Er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function Fr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9120>>3]=0.0;i=i;return}function Gr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8344>>3]=.9999999999999999;i=i;return}function Hr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8336>>3]=0.0;i=i;return}function Ir(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8328>>3]=0.0;i=i;return}function Jr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8320>>3]=0.0;i=i;return}function Kr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8312>>3]=.5038710255240862;i=i;return}function Lr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8304>>3]=.8637789008984333;i=i;return}function Mr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8296>>3]=0.0;i=i;return}function Nr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=-.8637789008984335;i=i;return}function Or(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8280>>3]=.5038710255240861;i=i;return}function Pr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8272>>3]=0.0;i=i;return}function Qr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function Rr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8256>>3]=0.0;i=i;return}function Sr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8248>>3]=0.0;i=i;return}function Tr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function Ur(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function Vr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8224>>3]=1.0;i=i;return}function Wr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8216>>3]=0.0;i=i;return}function Xr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function Yr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8200>>3]=0.0;i=i;return}function Zr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8192>>3]=0.0;i=i;return}function _r(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8184>>3]=0.0;i=i;return}function $r(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8176>>3]=0.0;i=i;return}function as(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9112>>3]=0.0;i=i;return}function bs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=2.2;i=i;return}function cs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9096>>3]=.8;i=i;return}function ds(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function es(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8144>>3]=0.0;i=i;return}function fs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8152>>3]=0.0;i=i;return}function gs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8160>>3]=0.0;i=i;return}function hs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=1.0;i=i;return}function is(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8096>>3]=0.0;i=i;return}function js(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8024>>3]=0.0;i=i;return}function ks(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8048>>3]=0.0;i=i;return}function ls(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function ms(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8064>>3]=0.0;i=i;return}function ns(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8072>>3]=1.0;i=i;return}function os(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function ps(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function qs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=255;i=i;return}function rs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=128;i=i;return}function ss(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=0;i=i;return}function ts(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7984>>3]=0.0;i=i;return}function us(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=128.0;i=i;return}function vs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=255.0;i=i;return}function ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7960>>3]=0.0;i=i;return}function xs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=128.0;i=i;return}function ys(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7976>>3]=255.0;i=i;return}function zs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7952>>3]=0.0;i=i;return}function As(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7944>>3]=1.0;i=i;return}function Bs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7936>>3]=0.0;i=i;return}function Cs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7928>>3]=0.0;i=i;return}function Ds(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7920>>3]=1.0;i=i;return}function Es(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7912>>3]=0.0;i=i;return}function Fs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=100;i=i;return}function Gs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=100;i=i;return}function Hs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=100;i=i;return}function Is(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7888>>3]=100.0;i=i;return}function Js(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=100.0;i=i;return}function Ks(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7904>>3]=100.0;i=i;return}function Ls(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7880>>3]=0.0;i=i;return}function Ms(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=1.0;i=i;return}function Ns(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function Os(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function Ps(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function Qs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7840>>3]=0.0;i=i;return}function Rs(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=155;i=i;return}function Ss(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=155;i=i;return}function Ts(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=155;i=i;return}function Us(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7816>>3]=155.0;i=i;return}function Vs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=155.0;i=i;return}function Ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7832>>3]=155.0;i=i;return}function Xs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7808>>3]=0.0;i=i;return}function Ys(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7800>>3]=1.0;i=i;return}function Zs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7792>>3]=0.0;i=i;return}function _s(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7784>>3]=0.0;i=i;return}function $s(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7776>>3]=0.0;i=i;return}function at(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function bt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7752>>3]=0.0;i=i;return}function dt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7744>>3]=0.0;i=i;return}function et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function ft(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7728>>3]=0.0;i=i;return}function gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7720>>3]=0.0;i=i;return}function ht(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7712>>3]=0.0;i=i;return}function it(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7704>>3]=0.0;i=i;return}function jt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7696>>3]=0.0;i=i;return}function kt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7688>>3]=1.0;i=i;return}function lt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7680>>3]=0.0;i=i;return}function mt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7672>>3]=0.0;i=i;return}function nt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7664>>3]=0.0;i=i;return}function ot(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=255;i=i;return}function pt(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=128;i=i;return}function qt(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function rt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7640>>3]=0.0;i=i;return}function st(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7648>>3]=128.0;i=i;return}function tt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7656>>3]=255.0;i=i;return}function ut(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=128.0;i=i;return}function wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=255.0;i=i;return}function xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=1.0;i=i;return}function zt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function At(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=0.0;i=i;return}function Bt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function Ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7568>>3]=1.0;i=i;return}function Dt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7560>>3]=0.0;i=i;return}function Et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=-.1727557801796867;i=i;return}function Ft(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7536>>3]=0.0;i=i;return}function Gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=1.0;i=i;return}function Ht(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=0.0;i=i;return}function It(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7512>>3]=0.0;i=i;return}function Jt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=-.1727557801796867;i=i;return}function Kt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=-.1007742051048172;i=i;return}function Lt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=0.0;i=i;return}function Mt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=0.0;i=i;return}function Nt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7472>>3]=0.0;i=i;return}function Ot(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=0.0;i=i;return}function Pt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=0.0;i=i;return}function Qt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=0.0;i=i;return}function Rt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function St(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function Tt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function Ut(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function Vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function Wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function Xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=1.0;i=i;return}function Yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=0.0;i=i;return}function Zt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7376>>3]=0.0;i=i;return}function _t(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function $t(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function au(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function bu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function cu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7344>>3]=0.0;i=i;return}function du(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7352>>3]=128.0;i=i;return}function eu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=255.0;i=i;return}function fu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7320>>3]=0.0;i=i;return}function gu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7328>>3]=128.0;i=i;return}function hu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7336>>3]=255.0;i=i;return}function iu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7312>>3]=0.0;i=i;return}function ju(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7304>>3]=1.0;i=i;return}function ku(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7296>>3]=0.0;i=i;return}function lu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7288>>3]=0.0;i=i;return}function mu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function nu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=1.0;i=i;return}function ou(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=0.0;i=i;return}function pu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=.1727557801796867;i=i;return}function qu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=0.0;i=i;return}function ru(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=1.0;i=i;return}function su(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=0.0;i=i;return}function tu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=0.0;i=i;return}function uu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=.1727557801796867;i=i;return}function vu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=.1007742051048172;i=i;return}function wu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=0.0;i=i;return}function xu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=0.0;i=i;return}function yu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7176>>3]=0.0;i=i;return}function zu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function Au(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function Bu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function Cu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=155;i=i;return}function Du(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=155;i=i;return}function Eu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=155;i=i;return}function Fu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=0.0;i=i;return}function Gu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=0.0;i=i;return}function Hu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7152>>3]=0.0;i=i;return}function Iu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7144>>3]=0.0;i=i;return}function Ju(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=0.0;i=i;return}function Ku(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function Lu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7120>>3]=0.0;i=i;return}function Mu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=0.0;i=i;return}function Nu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=0.0;i=i;return}function Ou(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=1.0;i=i;return}function Pu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function Qu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function Ru(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function Su(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function Tu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function Uu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function Vu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=255;i=i;return}function Wu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=128;i=i;return}function Xu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=0;i=i;return}function Yu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function Zu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=128.0;i=i;return}function _u(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=255.0;i=i;return}function $u(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function av(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=1.0;i=i;return}function bv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function cv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function dv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7008>>3]=0.0;i=i;return}function ev(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=.7;i=i;return}function fv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=0;i=i;return}function gv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function hv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=255;i=i;return}function iv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=255.0;i=i;return}function jv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function kv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function lv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function mv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=1.0;i=i;return}function nv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function ov(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=1.0;i=i;return}function pv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6936>>3]=0.0;i=i;return}function qv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function rv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6912>>3]=0.0;i=i;return}function sv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function tv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=155;i=i;return}function uv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=155;i=i;return}function vv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=155;i=i;return}function wv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function xv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=0;i=i;return}function yv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=0;i=i;return}function zv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=255;i=i;return}function Av(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=255.0;i=i;return}function Bv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function Cv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function Dv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=255.0;i=i;return}function Ev(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function Fv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function Gv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function Hv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=1.0;i=i;return}function Iv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function Jv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=0.0;i=i;return}function Kv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=.5038710255240862;i=i;return}function Lv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=-.8637789008984335;i=i;return}function Mv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6800>>3]=0.0;i=i;return}function Nv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function Ov(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=1.0;i=i;return}function Pv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function Qv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=1.0;i=i;return}function Rv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6744>>3]=0.0;i=i;return}function Sv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function Tv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6720>>3]=0.0;i=i;return}function Uv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function Vv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=0;i=i;return}function Wv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function Xv(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=255;i=i;return}function Yv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=255.0;i=i;return}function Zv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function _v(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function $v(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=255.0;i=i;return}function aw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function bw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function cw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function dw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=1.0;i=i;return}function ew(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function fw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6632>>3]=0.0;i=i;return}function gw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function hw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=1.0;i=i;return}function iw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6608>>3]=0.0;i=i;return}function jw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6600>>3]=0.0;i=i;return}function kw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function lw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=1.0;i=i;return}function mw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function nw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function ow(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function pw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=1.0;i=i;return}function qw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function rw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=0.0;i=i;return}function sw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=0;i=i;return}function tw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=255;i=i;return}function uw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=255;i=i;return}function vw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6496>>3]=255.0;i=i;return}function ww(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=255.0;i=i;return}function xw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=0.0;i=i;return}function yw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=0.0;i=i;return}function zw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=.5038710255240862;i=i;return}function Aw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=-.8637789008984335;i=i;return}function Bw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function Cw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=.8637789008984333;i=i;return}function Dw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6448>>3]=.5038710255240861;i=i;return}function Ew(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6440>>3]=0.0;i=i;return}function Fw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function Gw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function Hw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=155;i=i;return}function Iw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=155;i=i;return}function Jw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=155;i=i;return}function Kw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6416>>3]=0.0;i=i;return}function Lw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function Mw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function Nw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function Ow(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function Pw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function Qw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6368>>3]=0.0;i=i;return}function Rw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function Sw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}function Tw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=1.0;i=i;return}function Uw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function Vw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function Ww(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function Xw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=255;i=i;return}function Yw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=128;i=i;return}function Zw(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function _w(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=255;i=i;return}function $w(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=128;i=i;return}function ax(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function bx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function cx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=128.0;i=i;return}function dx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=255.0;i=i;return}function ex(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function fx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=1.0;i=i;return}function gx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function hx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function ix(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=0.0;i=i;return}function jx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=.7;i=i;return}function kx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function lx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function mx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function nx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=255.0;i=i;return}function ox(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function px(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function qx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function rx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6208>>3]=1.0;i=i;return}function sx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6200>>3]=0.0;i=i;return}function tx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=1.0;i=i;return}function ux(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function vx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function wx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function xx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function yx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function zx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=230;i=i;return}function Ax(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function Bx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function Cx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6136>>3]=230.0;i=i;return}function Dx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6144>>3]=0.0;i=i;return}function Ex(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function Fx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6112>>3]=230.0;i=i;return}function Gx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6120>>3]=0.0;i=i;return}function Hx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function Ix(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6088>>3]=1.0;i=i;return}function Jx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=0.0;i=i;return}function Kx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6072>>3]=0.0;i=i;return}function Lx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=-1.0;i=i;return}function Mx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function Nx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function Ox(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function Px(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function Qx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function Rx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=1.0;i=i;return}function Sx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function Tx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function Ux(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=-1.0;i=i;return}function Vx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function Wx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function Xx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function Yx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function Zx(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function _x(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=0;i=i;return}function $x(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function by(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function cy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function ey(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5920>>3]=0.0;i=i;return}function gy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function hy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=0.0;i=i;return}function iy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function jy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function ky(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function ly(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function my(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=0.0;i=i;return}function qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5824>>3]=0.0;i=i;return}function sy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function uy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5800>>3]=0.0;i=i;return}function vy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function wy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function xy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function yy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function zy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5744>>3]=0.0;i=i;return}function Ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function By(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=0.0;i=i;return}function Cy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function Dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function Ey(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function Fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function Gy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function Hy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function Iy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=0.0;i=i;return}function Jy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function Ky(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function Ly(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function My(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function Ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function Oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=1.0;i=i;return}function Py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function Qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=1.0;i=i;return}function Ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function Sy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function Ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function Uy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function Vy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function Wy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function Xy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function Yy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function Zy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=1.0;i=i;return}function _y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function $y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=1.0;i=i;return}function az(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function cz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=0.0;i=i;return}function dz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function ez(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function fz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=0.0;i=i;return}function gz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function hz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5440>>3]=0.0;i=i;return}function kz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=1.0;i=i;return}function lz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function mz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=1.0;i=i;return}function nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5392>>3]=0.0;i=i;return}function qz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function rz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=0.0;i=i;return}



function BZ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3792|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7984;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7864,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3792|0;w=v;h[w>>3]=j;i=b;return}function CZ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3784|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7984;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7864,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3784|0;w=v;h[w>>3]=j;i=b;return}function DZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3688>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3712>>3]- +h[b+3736>>3]);i=i;return}function EZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3680>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3704>>3]- +h[b+3728>>3]);i=i;return}function FZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3672>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3696>>3]- +h[b+3720>>3]);i=i;return}function GZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=+h[b+3736>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function HZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+3728>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function IZ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3648>>3]=+h[b+3096>>3]+ +h[d+3720>>3]*+h[b+3128>>3];i=i;return}function JZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3712>>3]+ +h[b+3736>>3]);i=i;return}function KZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3632>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3704>>3]+ +h[b+3728>>3]);i=i;return}function LZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+3696>>3]+ +h[b+3720>>3]);i=i;return}function MZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3088>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,8016,8008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3136>>3]=l;i=d;return}function NZ(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3144>>3]=+td(0.0,+(+h[d+3016>>3]- +h[d+3104>>3]));i=b;return}function OZ(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3152>>3]=+sd(+(+h[d+3088>>3]),+(+h[d+3136>>3]*4.0));i=b;return}function PZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3160>>3]=+h[b+3136>>3]*3.0;i=i;return}function QZ(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3168>>3]=+td(0.0,+(+h[d+3088>>3]- +h[d+3152>>3]));i=b;return}function RZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=+h[b+32>>3]- +h[b+3168>>3];i=i;return}function SZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+3032>>3];i=i;return}function TZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=+h[(c[a+416>>2]|0)+3192>>3]*-.5;i=i;return}function UZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3200>>3]=+h[b+3040>>3];i=i;return}function VZ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+96>>3]- +h[b+120>>3];e=+h[b+104>>3]- +h[b+128>>3];f=+h[b+112>>3]- +h[b+136>>3];h[b+3224>>3]=+V(+(d*d+e*e+f*f));i=i;return}function WZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3232>>3]=+h[b+3208>>3];i=i;return}function XZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3224>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,8016,8048,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3240>>3]=l;i=d;return}function YZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3256>>3]=+h[b+3240>>3];i=i;return}function ZZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d+8|0]|0;i=i;return}function _Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+96>>3];i=i;return}function $Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+104>>3];i=i;return}function a_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+112>>3];i=i;return}function b_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2216>>3]=+h[b+1816>>3]+ +h[b+400>>3];i=i;return}function c_(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[b+2216>>3]- +h[(c[a+416>>2]|0)+912>>3];i=i;return}function d_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+408>>3]=+h[b+120>>3];i=i;return}function e_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+128>>3];i=i;return}function f_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+424>>3]=+h[b+136>>3];i=i;return}function g_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3280>>3]=+h[b+3224>>3];i=i;return}function h_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3288>>3]=+h[b+3240>>3];i=i;return}function i_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3296>>3]=+h[b+3256>>3];i=i;return}function j_(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function k_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+168>>3];i=i;return}function l_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+176>>3];i=i;return}function m_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+592>>3]=+h[b+184>>3];i=i;return}function n_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+192>>3];i=i;return}function o_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+200>>3];i=i;return}function p_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+208>>3];i=i;return}function q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+624>>3]=+h[b+216>>3];i=i;return}function r_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+224>>3];i=i;return}function s_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+232>>3];i=i;return}function t_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+576>>3];i=i;return}function u_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+656>>3]=+h[b+584>>3];i=i;return}function v_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+592>>3];i=i;return}function w_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3368>>3]=+h[b+3064>>3];i=i;return}function x_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+864>>3]=l;i=b;return}function y_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+872>>3]=l;i=b;return}function z_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+880>>3]=l;i=b;return}function A_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+888>>3]=l;i=b;return}function B_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3376>>3]=+h[b+3368>>3]/3.0;i=i;return}function C_(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+896>>3]- +h[b+920>>3];e=+h[b+904>>3]- +h[b+928>>3];f=+h[b+912>>3]- +h[b+936>>3];h[b+3392>>3]=+V(+(d*d+e*e+f*f));i=i;return}function D_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3400>>3];i=i;return}function E_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3032>>3];i=i;return}function F_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6592>>3]=+h[(c[a+416>>2]|0)+3424>>3]*-.5;i=i;return}function G_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6520>>3]=+h[(c[a+416>>2]|0)+3424>>3]*-.5;i=i;return}function H_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3032>>3];i=i;return}function I_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6792>>3]=+h[(c[a+416>>2]|0)+3432>>3]*-.2519355127620431;i=i;return}function J_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=+h[(c[a+416>>2]|0)+3432>>3]*.4318894504492167;i=i;return}function K_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=+h[(c[a+416>>2]|0)+3432>>3]*-.5;i=i;return}function L_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3040>>3];i=i;return}function M_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3424>>3]*.5;i=i;return}function N_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+2936>>3];i=i;return}function O_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1208>>3]=+h[b+1136>>3];i=i;return}function P_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1144>>3];i=i;return}function Q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1224>>3]=+h[b+1152>>3];i=i;return}function R_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3512>>3]=+h[b+3064>>3];i=i;return}function S_(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7248>>3]=+h[(c[a+416>>2]|0)+3512>>3]*-.5+.1007742051048172;i=i;return}function T_(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0.0;b=i;d=a+416|0;if((Mca(.2,+h[(c[d>>2]|0)+3512>>3]*.5)|0)<<24>>24==0){e=0.0}else{f=c[d>>2]|0;if((Mca(+h[f+3520>>3],+h[f+3512>>3]*1.1)|0)<<24>>24==0){g=0.0}else{g=+h[(c[d>>2]|0)+3512>>3]*.5}e=.2-g}h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8968>>3]=e;i=b;return}function U_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+1424>>3]=l;i=b;return}function V_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+1432>>3]=l;i=b;return}function W_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+1440>>3]=l;i=b;return}function X_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+1448>>3]=l;i=b;return}function Y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3528>>3]=+h[b+2936>>3];i=i;return}function Z_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+1480>>3];i=i;return}function __(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1560>>3]=+h[b+1488>>3];i=i;return}function $_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1568>>3]=+h[b+1496>>3];i=i;return}function a$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3584>>3]=+h[b+3064>>3];i=i;return}function b$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7544>>3]=+h[(c[a+416>>2]|0)+3584>>3]*-.5+-.1007742051048172;i=i;return}function c$(a){a=a|0;var b=0,d=0,e=0.0,f=0,g=0.0;b=i;d=a+416|0;if((Mca(.2,+h[(c[d>>2]|0)+3584>>3]*.5)|0)<<24>>24==0){e=0.0}else{f=c[d>>2]|0;if((Mca(+h[f+3592>>3],+h[f+3584>>3]*1.1)|0)<<24>>24==0){g=0.0}else{g=+h[(c[d>>2]|0)+3584>>3]*.5}e=.2-g}h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=e;i=b;return}function d$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+1768>>3]=l;i=b;return}function e$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+1776>>3]=l;i=b;return}function f$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+1784>>3]=l;i=b;return}function g$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+1792>>3]=l;i=b;return}function h$(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1800>>3]- +h[b+1824>>3];e=+h[b+1808>>3]- +h[b+1832>>3];f=+h[b+1816>>3]- +h[b+1840>>3];h[b+3608>>3]=+V(+(d*d+e*e+f*f));i=i;return}function i$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3624>>3]=+h[b+3616>>3];i=i;return}function j$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3664>>3]=+h[b+3032>>3];i=i;return}function k$(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=+h[(c[a+416>>2]|0)+3664>>3]*-.5;i=i;return}function l$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3672>>3]=+h[b+3040>>3];i=i;return}function m$(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1944>>3]- +h[b+1968>>3];e=+h[b+1952>>3]- +h[b+1976>>3];f=+h[b+1960>>3]- +h[b+1984>>3];h[b+3696>>3]=+V(+(d*d+e*e+f*f));i=i;return}function n$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3704>>3]=+h[b+3680>>3];i=i;return}function o$(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2976>>3];j=+h[f+3696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,8016,8088,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3712>>3]=l;i=d;return}function p$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3728>>3]=+h[b+3712>>3];i=i;return}function q$(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+48|0]=a[d+42|0]|0;i=i;return}function r$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2232>>3]=+h[b+1944>>3];i=i;return}function s$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2240>>3]=+h[b+1952>>3];i=i;return}function t$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2248>>3]=+h[b+1960>>3];i=i;return}function u$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2264>>3]=+h[b+2856>>3]+ +h[b+2248>>3];i=i;return}function v$(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=+h[b+2264>>3]- +h[(c[a+416>>2]|0)+2760>>3];i=i;return}function w$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2256>>3]=+h[b+1968>>3];i=i;return}function x$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2264>>3]=+h[b+1976>>3];i=i;return}function y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2272>>3]=+h[b+1984>>3];i=i;return}function z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3752>>3]=+h[b+3696>>3];i=i;return}function A$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3760>>3]=+h[b+3712>>3];i=i;return}function B$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3768>>3]=+h[b+3728>>3];i=i;return}function C$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+132>>2]=c[b+128>>2];i=i;return}function D$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2424>>3]=+h[b+2016>>3];i=i;return}function E$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2432>>3]=+h[b+2024>>3];i=i;return}function F$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2440>>3]=+h[b+2032>>3];i=i;return}function G$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2448>>3]=+h[b+2040>>3];i=i;return}function H$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2456>>3]=+h[b+2048>>3];i=i;return}function I$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2464>>3]=+h[b+2056>>3];i=i;return}function J$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2472>>3]=+h[b+2064>>3];i=i;return}function K$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2480>>3]=+h[b+2072>>3];i=i;return}function L$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2488>>3]=+h[b+2080>>3];i=i;return}function M$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2496>>3]=+h[b+2424>>3];i=i;return}function N$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2504>>3]=+h[b+2432>>3];i=i;return}function O$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2512>>3]=+h[b+2440>>3];i=i;return}function P$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3840>>3]=+h[b+3064>>3];i=i;return}function Q$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,0);h[(c[a+416>>2]|0)+2712>>3]=l;i=b;return}function R$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,1);h[(c[a+416>>2]|0)+2720>>3]=l;i=b;return}function S$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,2);h[(c[a+416>>2]|0)+2728>>3]=l;i=b;return}function T$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=8056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=8072;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Bi(f,g,e,d);l=+saa(f,3);h[(c[a+416>>2]|0)+2736>>3]=l;i=b;return}function U$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3848>>3]=+h[b+3840>>3]/3.0;i=i;return}function V$(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2744>>3]- +h[b+2768>>3];e=+h[b+2752>>3]- +h[b+2776>>3];f=+h[b+2760>>3]- +h[b+2784>>3];h[b+3864>>3]=+V(+(d*d+e*e+f*f));i=i;return}function W$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3880>>3]=+h[b+3872>>3];i=i;return}function X$(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2840>>3]- +h[b+2864>>3];e=+h[b+2848>>3]- +h[b+2872>>3];f=+h[b+2856>>3]- +h[b+2880>>3];h[b+3896>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3912>>3]=+h[b+3904>>3];i=i;return}function Z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3936>>3]=+h[b+2936>>3];i=i;return}function _$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3944>>3]=+h[b+2936>>3];i=i;return}function $$(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+416|0;f=Mca(+h[(c[e>>2]|0)+3936>>3],0.0)|0;g=Mca(+h[(c[e>>2]|0)+3944>>3],0.0)|0;e=c[b+424>>2]|0;do{if((a[e]|0)==0){j=0}else{if((a[e+58|0]|0)==0){j=0;break}if((a[e+59|0]|0)==0|f<<24>>24==0){j=0;break}j=g<<24>>24!=0|0}}while(0);a[e+62|0]=j;i=d;return}function a0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8096]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(8112,baa(+h[(c[g>>2]|0)+3944>>3],8104)|0)|0;g=c[24792]|0;j=e;k=8312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8096]=1;i=d;return}function b0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8336]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(8344,baa(+h[(c[g>>2]|0)+3936>>3],8104)|0)|0;g=c[24792]|0;j=e;k=8456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8336]=1;i=d;return}function c0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8480]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(8488,baa(+h[(c[g>>2]|0)+3928>>3],8104)|0)|0;g=c[24792]|0;j=e;k=14112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8480]=1;i=d;return}function d0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8648]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(8656,baa(+h[(c[g>>2]|0)+3920>>3],8104)|0)|0;g=c[24792]|0;j=e;k=14240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8648]=1;i=d;return}function e0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8752]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+184>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=faa(8768,daa(c[(c[g>>2]|0)+184>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=14432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8752]=1;i=d;return}function f0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8928]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(8936,baa(+h[(c[g>>2]|0)+3912>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8928]=1;i=d;return}function g0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9104]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(9112,baa(+h[(c[g>>2]|0)+3904>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9104]=1;i=d;return}function h0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9192]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(9200,baa(+h[(c[g>>2]|0)+3880>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9192]=1;i=d;return}function i0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9280]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(9288,baa(+h[(c[g>>2]|0)+3872>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9280]=1;i=d;return}function j0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9368]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(9376,baa(+h[(c[g>>2]|0)+3848>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9368]=1;i=d;return}function k0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9496]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(9504,baa(+h[(c[g>>2]|0)+3840>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9496]=1;i=d;return}function l0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9624]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(9632,daa(c[(c[g>>2]|0)+140>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9624]=1;i=d;return}function m0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9816]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(9824,daa(c[(c[g>>2]|0)+136>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9816]=1;i=d;return}function n0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10008]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(10016,daa(c[(c[g>>2]|0)+132>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10008]=1;i=d;return}function o0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10200]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+128>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(10208,daa(c[(c[g>>2]|0)+128>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10200]=1;i=d;return}function p0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10368]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(10376,daa(c[(c[g>>2]|0)+124>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10368]=1;i=d;return}function q0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10536]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(10544,daa(c[(c[g>>2]|0)+120>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10536]=1;i=d;return}function r0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10704]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3832>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(10712,baa(+h[(c[g>>2]|0)+3832>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10704]=1;i=d;return}function s0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10832]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3824>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(10840,baa(+h[(c[g>>2]|0)+3824>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10832]=1;i=d;return}function t0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10960]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3816>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(10968,baa(+h[(c[g>>2]|0)+3816>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10960]=1;i=d;return}function u0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11088]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11096,baa(+h[(c[g>>2]|0)+3808>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11088]=1;i=d;return}function v0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11192]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11200,baa(+h[(c[g>>2]|0)+3800>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11192]=1;i=d;return}function w0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11296]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11304,baa(+h[(c[g>>2]|0)+3792>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11296]=1;i=d;return}function x0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11400]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11408,baa(+h[(c[g>>2]|0)+3784>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11400]=1;i=d;return}function y0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11496]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11504,baa(+h[(c[g>>2]|0)+3776>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11496]=1;i=d;return}function z0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11584]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11592,baa(+h[(c[g>>2]|0)+3768>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11584]=1;i=d;return}function A0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11720]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11728,baa(+h[(c[g>>2]|0)+3760>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11720]=1;i=d;return}function B0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11848]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11856,baa(+h[(c[g>>2]|0)+3736>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11848]=1;i=d;return}function C0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11936]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(11944,baa(+h[(c[g>>2]|0)+3728>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11936]=1;i=d;return}function D0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12032]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(12040,baa(+h[(c[g>>2]|0)+3720>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12032]=1;i=d;return}function E0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12120]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(12128,baa(+h[(c[g>>2]|0)+3712>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12120]=1;i=d;return}function F0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12216]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(12224,baa(+h[(c[g>>2]|0)+3704>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12216]=1;i=d;return}function G0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12328]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+116>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(12336,daa(c[(c[g>>2]|0)+116>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[12328]=1;i=d;return}function H0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12504]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(12512,daa(c[(c[g>>2]|0)+112>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[12504]=1;i=d;return}function I0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12680]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(12688,daa(c[(c[g>>2]|0)+108>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[12680]=1;i=d;return}function J0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12856]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+104>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(12864,daa(c[(c[g>>2]|0)+104>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[12856]=1;i=d;return}function K0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13008]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(13016,daa(c[(c[g>>2]|0)+100>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13008]=1;i=d;return}function L0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13160]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+96>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(13168,daa(c[(c[g>>2]|0)+96>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13160]=1;i=d;return}function M0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13312]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(13320,baa(+h[(c[g>>2]|0)+3688>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13312]=1;i=d;return}function N0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13416]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(13424,baa(+h[(c[g>>2]|0)+3680>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13416]=1;i=d;return}function O0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13520]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(13528,baa(+h[(c[g>>2]|0)+3672>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13520]=1;i=d;return}function P0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13728]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(13736,baa(+h[(c[g>>2]|0)+3664>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13728]=1;i=d;return}function Q0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13848]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+180>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=faa(13856,daa(c[(c[g>>2]|0)+180>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=24208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13848]=1;i=d;return}function R0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14024]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14032,baa(+h[(c[g>>2]|0)+3640>>3],8104)|0)|0;g=c[24792]|0;j=e;k=14112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14024]=1;i=d;return}function S0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14136]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14144,baa(+h[(c[g>>2]|0)+3632>>3],8104)|0)|0;g=c[24792]|0;j=e;k=14240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14136]=1;i=d;return}function T0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14264]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+176>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=faa(14272,daa(c[(c[g>>2]|0)+176>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=14432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14264]=1;i=d;return}function U0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14456]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14464,baa(+h[(c[g>>2]|0)+3624>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14456]=1;i=d;return}function V0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14544]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14552,baa(+h[(c[g>>2]|0)+3616>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14544]=1;i=d;return}function W0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14632]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14640,baa(+h[(c[g>>2]|0)+3592>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14632]=1;i=d;return}function X0(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14744]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(14752,baa(+h[(c[g>>2]|0)+3584>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14744]=1;i=d;return}function Y0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14856]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+92>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(14864,daa(c[(c[g>>2]|0)+92>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14856]=1;i=d;return}function Z0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15024]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(15032,daa(c[(c[g>>2]|0)+88>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15024]=1;i=d;return}function _0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15192]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+84>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(15200,daa(c[(c[g>>2]|0)+84>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15192]=1;i=d;return}function $0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15360]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+80>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(15368,daa(c[(c[g>>2]|0)+80>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15360]=1;i=d;return}function a1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15504]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(15512,daa(c[(c[g>>2]|0)+76>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15504]=1;i=d;return}function b1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15648]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+72>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(15656,daa(c[(c[g>>2]|0)+72>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15648]=1;i=d;return}function c1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15792]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3576>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(15800,baa(+h[(c[g>>2]|0)+3576>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15792]=1;i=d;return}function d1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15904]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3568>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(15912,baa(+h[(c[g>>2]|0)+3568>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15904]=1;i=d;return}function e1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16016]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3560>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(16024,baa(+h[(c[g>>2]|0)+3560>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16016]=1;i=d;return}function f1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16128]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16136,baa(+h[(c[g>>2]|0)+3552>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16128]=1;i=d;return}function g1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16216]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16224,baa(+h[(c[g>>2]|0)+3544>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16216]=1;i=d;return}function h1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16304]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16312,baa(+h[(c[g>>2]|0)+3536>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16304]=1;i=d;return}function i1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16392]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16400,baa(+h[(c[g>>2]|0)+3528>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16392]=1;i=d;return}function j1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16472]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16480,baa(+h[(c[g>>2]|0)+3520>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16472]=1;i=d;return}function k1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16584]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(16592,baa(+h[(c[g>>2]|0)+3512>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16584]=1;i=d;return}function l1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16696]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+68>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(16704,daa(c[(c[g>>2]|0)+68>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16696]=1;i=d;return}function m1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16864]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(16872,daa(c[(c[g>>2]|0)+64>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16864]=1;i=d;return}function n1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17032]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+60>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(17040,daa(c[(c[g>>2]|0)+60>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17032]=1;i=d;return}function o1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17200]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+56>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(17208,daa(c[(c[g>>2]|0)+56>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17200]=1;i=d;return}function p1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17344]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(17352,daa(c[(c[g>>2]|0)+52>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17344]=1;i=d;return}function q1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17488]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+48>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(17496,daa(c[(c[g>>2]|0)+48>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17488]=1;i=d;return}function r1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17632]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3504>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(17640,baa(+h[(c[g>>2]|0)+3504>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17632]=1;i=d;return}function s1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17744]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3496>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(17752,baa(+h[(c[g>>2]|0)+3496>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17744]=1;i=d;return}function t1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17856]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3488>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(17864,baa(+h[(c[g>>2]|0)+3488>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17856]=1;i=d;return}function u1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17968]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(17976,baa(+h[(c[g>>2]|0)+3480>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17968]=1;i=d;return}function v1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18056]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18064,baa(+h[(c[g>>2]|0)+3472>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18056]=1;i=d;return}function w1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18144]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18152,baa(+h[(c[g>>2]|0)+3464>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18144]=1;i=d;return}function x1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18232]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18240,baa(+h[(c[g>>2]|0)+3456>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18232]=1;i=d;return}function y1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18312]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18320,baa(+h[(c[g>>2]|0)+3448>>3],8104)|0)|0;g=c[24792]|0;j=e;k=18424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18312]=1;i=d;return}function z1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18448]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18456,baa(+h[(c[g>>2]|0)+3440>>3],8104)|0)|0;g=c[24792]|0;j=e;k=18568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18448]=1;i=d;return}function A1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18592]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18600,baa(+h[(c[g>>2]|0)+3432>>3],8104)|0)|0;g=c[24792]|0;j=e;k=18704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18592]=1;i=d;return}function B1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18728]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18736,baa(+h[(c[g>>2]|0)+3424>>3],8104)|0)|0;g=c[24792]|0;j=e;k=18840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18728]=1;i=d;return}function C1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18864]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18872,baa(+h[(c[g>>2]|0)+3408>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18864]=1;i=d;return}function D1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18952]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(18960,baa(+h[(c[g>>2]|0)+3400>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18952]=1;i=d;return}function E1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19040]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(19048,baa(+h[(c[g>>2]|0)+3376>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19040]=1;i=d;return}function F1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19192]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(19200,baa(+h[(c[g>>2]|0)+3368>>3],8104)|0)|0;g=c[24792]|0;j=e;k=19320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19192]=1;i=d;return}function G1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19344]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+44>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(19352,daa(c[(c[g>>2]|0)+44>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19344]=1;i=d;return}function H1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19536]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(19544,daa(c[(c[g>>2]|0)+40>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19536]=1;i=d;return}function I1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19728]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+36>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(19736,daa(c[(c[g>>2]|0)+36>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=19920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19728]=1;i=d;return}function J1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19944]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(19952,daa(c[(c[g>>2]|0)+32>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19944]=1;i=d;return}function K1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20112]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(20120,daa(c[(c[g>>2]|0)+28>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20112]=1;i=d;return}function L1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20280]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(20288,daa(c[(c[g>>2]|0)+24>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=20448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20280]=1;i=d;return}function M1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20472]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3360>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(20480,baa(+h[(c[g>>2]|0)+3360>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20600;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20472]=1;i=d;return}function N1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20624]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3352>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(20632,baa(+h[(c[g>>2]|0)+3352>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20624]=1;i=d;return}function O1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20776]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3344>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=faa(20784,baa(+h[(c[g>>2]|0)+3344>>3],8104)|0)|0;g=c[24792]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20776]=1;i=d;return}function P1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20928]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(20936,baa(+h[(c[g>>2]|0)+3336>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20928]=1;i=d;return}function Q1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21056]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21064,baa(+h[(c[g>>2]|0)+3328>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21056]=1;i=d;return}function R1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21184]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21192,baa(+h[(c[g>>2]|0)+3320>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21184]=1;i=d;return}function S1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21312]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21320,baa(+h[(c[g>>2]|0)+3312>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21312]=1;i=d;return}function T1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21432]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21440,baa(+h[(c[g>>2]|0)+3304>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21432]=1;i=d;return}function U1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21544]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21552,baa(+h[(c[g>>2]|0)+3296>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21544]=1;i=d;return}function V1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21704]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21712,baa(+h[(c[g>>2]|0)+3288>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21704]=1;i=d;return}function W1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21856]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21864,baa(+h[(c[g>>2]|0)+3264>>3],8104)|0)|0;g=c[24792]|0;j=e;k=21944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21856]=1;i=d;return}function X1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21968]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(21976,baa(+h[(c[g>>2]|0)+3256>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21968]=1;i=d;return}function Y1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22088]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(22096,baa(+h[(c[g>>2]|0)+3248>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22088]=1;i=d;return}function Z1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22200]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(22208,baa(+h[(c[g>>2]|0)+3240>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22200]=1;i=d;return}function _1(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22320]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(22328,baa(+h[(c[g>>2]|0)+3232>>3],8104)|0)|0;g=c[24792]|0;j=e;k=22432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22320]=1;i=d;return}function $1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22456]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+20>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(22464,daa(c[(c[g>>2]|0)+20>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22456]=1;i=d;return}function a2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22632]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(22640,daa(c[(c[g>>2]|0)+16>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22632]=1;i=d;return}function b2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22808]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+12>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(22816,daa(c[(c[g>>2]|0)+12>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=22984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22808]=1;i=d;return}function c2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23008]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(23016,daa(c[(c[g>>2]|0)+8>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[23008]=1;i=d;return}function d2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23160]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(23168,daa(c[(c[g>>2]|0)+4>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[23160]=1;i=d;return}function e2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23312]&1){i=d;return}g=b+420|0;b=Nca(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[c[g>>2]>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(23320,daa(c[c[g>>2]>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=23464;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[23312]=1;i=d;return}function f2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23488]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(23496,baa(+h[(c[g>>2]|0)+3216>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23488]=1;i=d;return}function g2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23616]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(23624,baa(+h[(c[g>>2]|0)+3208>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23616]=1;i=d;return}function h2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23744]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(23752,baa(+h[(c[g>>2]|0)+3200>>3],8104)|0)|0;g=c[24792]|0;j=e;k=23864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23744]=1;i=d;return}function i2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23888]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(23896,baa(+h[(c[g>>2]|0)+3192>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23888]=1;i=d;return}function j2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24032]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+172>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=faa(24040,daa(c[(c[g>>2]|0)+172>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=24208;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[24032]=1;i=d;return}function k2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24232]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24240,baa(+h[(c[g>>2]|0)+3136>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24232]=1;i=d;return}function l2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24464]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24472,baa(+h[(c[g>>2]|0)+3080>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24464]=1;i=d;return}function m2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24592]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24600,baa(+h[(c[g>>2]|0)+3016>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24592]=1;i=d;return}function n2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24720]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24728,baa(+h[(c[g>>2]|0)+3008>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24720]=1;i=d;return}function o2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24856]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24864,baa(+h[(c[g>>2]|0)+3e3>>3],8104)|0)|0;g=c[24792]|0;j=e;k=24960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24856]=1;i=d;return}function p2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24984]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+2992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(24992,baa(+h[(c[g>>2]|0)+2992>>3],8104)|0)|0;g=c[24792]|0;j=e;k=25120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24984]=1;i=d;return}function q2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25144]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+2960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(25152,baa(+h[(c[g>>2]|0)+2960>>3],8104)|0)|0;g=c[24792]|0;j=e;k=25264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25144]=1;i=d;return}function r2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25288]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+2952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(25296,baa(+h[(c[g>>2]|0)+2952>>3],8104)|0)|0;g=c[24792]|0;j=e;k=25376;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25288]=1;i=d;return}



function Gea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=bEa(c[f>>2]<<2,4)|0;c[e>>2]=g;G9(c[d+536>>2]|0,(g|0)!=0|0,91944,k);g=s+240|0;f=Iea(g)|0;h=s+264|0;t=Iea(h)|0;u=s+288|0;v=Iea(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=Iea(g)|0;D=Iea(h)|0;E=Iea(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){Nea(l,b,A+(v*52|0)+4|0);Pea(n,b);if(!(Oea(l,n)|0)){F=w;break}G=(c[(Qea(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){Nea(l,g,A+(v*52|0)+4|0);Pea(m,g);if(!(Oea(l,m)|0)){F=w;break}G=(c[(Qea(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){Nea(l,h,G+(t*52|0)+4|0);Pea(o,h);H=Oea(l,o)|0;J=H?2:0}else if(f<<24>>24==1){Nea(l,v,G+(t*52|0)+4|0);Pea(p,v);J=(Oea(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(Qea(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){Nea(l,u,y+(t*52|0)+4|0);Pea(q,u);F=Oea(l,q)|0;M=F?2:0}else if(x<<24>>24==1){Nea(l,d,y+(t*52|0)+4|0);Pea(r,d);M=(Oea(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(Qea(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function Hea(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(DEa(d|0)|0)+1;e=m;kwa(e,l,20)|0;if(Hua(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];H9(l,91920,k)}kwa(e,d,c[f>>2]|0)|0;if(Hua(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];H9(m,91920,j)}else{i=h;return}}function Iea(a){a=a|0;var b=0,d=0;b=i;d=c[(ufa(a)|0)>>2]|0;i=b;return d|0}function Jea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Vaa(3);do{if(Gua(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];mwa(k,e)|0;k=Iea(h+240|0)|0;m=Iea(h+264|0)|0;l=Iea(h+288|0)|0;Hea(a,b,91824,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);xea(h)}else{if((h|0)!=0){break}c[g>>2]=0;Yaa(3);i=d;return}}while(0);Kea(j);hEa(h);c[g>>2]=0;Yaa(3);i=d;return}function Kea(a){a=a|0;var b=0;b=i;Sfa(a);i=b;return}function Lea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Vaa(3);Yaa(0);h[j>>3]=+Qaa(0);Vaa(0);l=k;m=d+4|0;kwa(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){kwa(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){kwa(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);kwa(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);kwa(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);kwa(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(Hua(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];H9(t,91864,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;Yaa(3);i=e;return}}function Mea(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((AEa(b,92080,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((AEa(b,92080,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function Nea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;gfa(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Yea(a,f);i=e;return}function Oea(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Wea(a,b)|0;i=c;return d|0}function Pea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Zea(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Yea(a,e);i=d;return}function Qea(a){a=a|0;var b=0,c=0;b=i;c=Rea(Sea(a)|0)|0;i=b;return c|0}function Rea(a){a=a|0;var b=0,c=0;b=i;c=Vea(a)|0;i=b;return c|0}function Sea(a){a=a|0;var b=0,d=0;b=i;d=Tea((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Tea(a){a=a|0;var b=0,c=0;b=i;c=Uea(a)|0;i=b;return c|0}function Uea(a){a=a|0;i=i;return a|0}function Vea(a){a=a|0;i=i;return a|0}function Wea(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Xea(a,b)|0)^1;i=c;return d|0}function Xea(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Yea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];ffa(a,e);i=d;return}function Zea(a,b){a=a|0;b=b|0;var c=0;c=i;_ea(a,$ea(b)|0);i=c;return}function _ea(a,b){a=a|0;b=b|0;var c=0;c=i;efa(a,b);i=c;return}function $ea(a){a=a|0;var b=0,c=0;b=i;c=afa(bfa(a+4|0)|0)|0;i=b;return c|0}function afa(a){a=a|0;var b=0,c=0;b=i;c=dfa(a)|0;i=b;return c|0}function bfa(a){a=a|0;var b=0,c=0;b=i;c=cfa(a)|0;i=b;return c|0}function cfa(a){a=a|0;i=i;return a|0}function dfa(a){a=a|0;i=i;return a|0}function efa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function ffa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function gfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=ifa(b)|0;hfa(f,b,d,h,$ea(b)|0);Zea(g,b);do{if(Wea(f,g)|0){h=jfa(b)|0;if(kfa(h,d,lfa(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Zea(a,b);i=e;return}function hfa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;pfa(h);a:do{if((e|0)==0){j=f}else{k=jfa(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(qfa(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;pfa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;pfa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);_ea(a,j);i=g;return}function ifa(a){a=a|0;var b=0,d=0;b=i;d=c[($ea(a)|0)>>2]|0;i=b;return d|0}function jfa(a){a=a|0;var b=0,c=0;b=i;c=nfa(a+8|0)|0;i=b;return c|0}function kfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=mfa(0,b,c)|0;i=a;return d|0}function lfa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function mfa(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function nfa(a){a=a|0;var b=0,c=0;b=i;c=ofa(a)|0;i=b;return c|0}function ofa(a){a=a|0;i=i;return a|0}function pfa(a){a=a|0;var b=0;b=i;rfa(a,-1);i=b;return}function qfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=mfa(0,b,c)|0;i=a;return d|0}function rfa(a,b){a=a|0;b=b|0;b=i;sfa(a,0);i=b;return}function sfa(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function tfa(a){a=a|0;i=i;return c[a+4>>2]|0}function ufa(a){a=a|0;var b=0,c=0;b=i;c=vfa(a+8|0)|0;i=b;return c|0}function vfa(a){a=a|0;var b=0,c=0;b=i;c=wfa(a)|0;i=b;return c|0}function wfa(a){a=a|0;i=i;return a|0}function xfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 9:case 25:{h=92024;break};case 56:{h=92016;break};case 52:case 20:{h=92032;break};case 5:case 21:{h=92040;break};case 48:case 16:{h=91984;break};case 12:{h=92048;break};case 60:{h=92064;break};case 8:{h=92e3;break};case 13:case 29:{h=92072;break};case 1:case 17:{h=91992;break};case 28:{h=92056;break};case 24:{h=92008;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ic(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Wc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Yc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function yfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function zfa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}Afa(d,f,102);f=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Yc(Bfa(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}Cfa(d);g=h;i=b;return g|0}function Afa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Jfa(a,b,c);i=d;return}function Bfa(a){a=a|0;var b=0,d=0;b=i;d=Ffa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Cfa(a){a=a|0;var b=0;b=i;Dfa(a);i=b;return}function Dfa(a){a=a|0;var b=0;b=i;Efa(a,0);i=b;return}function Efa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Ffa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ie[c[(Gfa(e)|0)>>2]&127](f)|0;i=d;return}function Ffa(a){a=a|0;var b=0,c=0;b=i;c=Ifa(a)|0;i=b;return c|0}function Gfa(a){a=a|0;var b=0,c=0;b=i;c=Hfa(a)|0;i=b;return c|0}function Hfa(a){a=a|0;i=i;return a+4|0}function Ifa(a){a=a|0;i=i;return a|0}function Jfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Lfa(f)|0)>>2]|0;Kfa(a,d,c[(Mfa(g)|0)>>2]|0);i=e;return}function Kfa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Nfa(a,b,c);i=d;return}function Lfa(a){a=a|0;i=i;return a|0}function Mfa(a){a=a|0;i=i;return a|0}function Nfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(Pfa(f)|0)>>2]|0;Ofa(a,d,c[(Qfa(g)|0)>>2]|0);i=e;return}function Ofa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(Pfa(f)|0)>>2];c[a+4>>2]=c[(Qfa(g)|0)>>2];i=e;return}function Pfa(a){a=a|0;i=i;return a|0}function Qfa(a){a=a|0;i=i;return a|0}function Rfa(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function Sfa(a){a=a|0;var b=0;b=i;Tfa(a+300|0);Tfa(a+288|0);Tfa(a+276|0);Tfa(a+264|0);Tfa(a+252|0);Tfa(a+240|0);Ufa(a);i=b;return}function Tfa(a){a=a|0;var b=0;b=i;Ega(a);i=b;return}function Ufa(a){a=a|0;var b=0;b=i;Vfa(a,92128);Oua(a+104|0);i=b;return}function Vfa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Zfa(a+4|0);i=d;return}function Wfa(a){a=a|0;var b=0;b=i;Ufa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Xfa(a){a=a|0;var b=0;b=i;Ufa(a);hEa(a);i=b;return}function Yfa(a){a=a|0;var b=0;b=i;Xfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Zfa(a){a=a|0;var b=0;b=i;_fa(a);i=b;return}function _fa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=92256;zfa(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}iEa(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}iEa(e)}}while(0);Xua(b);i=d;return}function $fa(a){a=a|0;var b=0;b=i;Zfa(a);hEa(a);i=b;return}function aga(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=Cga(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=Dga(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;fva(h,0,0,0);kva(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}iEa(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=gEa(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=gEa(h)|0;a[b+97|0]=1;i=e;return}function bga(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;fva(e,0,0,0);kva(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}iEa(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}iEa(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=gEa(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(zga(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=gEa(o)|0;a[k]=1;i=f;return e|0}return 0}function cga(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;GDa(n);Td(n|0,139584,127)}n=vga(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){Dea(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=WEa(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Wc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;Dea(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];yga(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{Dea(a,-1,-1);i=g;return}}}while(0);Dea(a,-1,-1);i=g;return}function dga(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=Rfa(d)|0;if((Wc(j|0,k|0,0)|0)==0){xga(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{Dea(a,-1,-1);i=e;return}}}while(0);Dea(a,-1,-1);i=e;return}function ega(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;GDa(m);Td(m|0,139584,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=vga(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=dva(s)|0;u=(fa(t-(cva(s)|0)|0,p)|0)+r|0;v=0;break}p=cva(s)|0;if((p|0)==(dva(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=wga(t,g,x,o,p-(bva(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=dva(w)|0;u=q-(cva(w)|0)|0;v=0}}while(0);if((Wc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;fva(b,0,0,0);c[m>>2]=0}else{q=b;y=hva(q)|0;do{if((y|0)!=(gva(q)|0)){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=uga(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((ud(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function fga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=pga(b)|0;o=b;if((cva(o)|0)==0){p=e+1|0;fva(o,e,p,p)}if(n){q=0}else{n=dva(o)|0;c[f>>2]=(n-(bva(o)|0)|0)/2|0;c[g>>2]=4;q=c[(qga(f,g)|0)>>2]|0}g=cva(o)|0;do{if((g|0)==(dva(o)|0)){GEa(bva(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=dva(o)|0;n=bva(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=bva(o)|0;fva(o,n,n+q|0,n+(p+q)|0);r=nga(a[cva(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;GEa(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(qga(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;GDa(t);Td(t|0,139584,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=bva(o)|0;if((rga(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;fva(o,f,f,c[s>>2]|0);r=nga(a[cva(o)|0]|0)|0;break}s=c[k>>2]|0;f=bva(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}fva(o,f,p,s);r=nga(a[cva(o)|0]|0)|0}else{r=nga(a[g]|0)|0}}while(0);if((bva(o)|0)!=(e|0)){m=r;i=d;return m|0}fva(o,0,0,0);m=r;i=d;return m|0}function gga(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=bva(g)|0;j=cva(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(jga(d,-1)|0){eva(g,-1);f=mga(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=kga(d)|0;do{if(h){if(oga(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);eva(g,-1);a[cva(g)|0]=b;f=d;i=e;return f|0}function hga(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}iga(b);l=b;m=gva(l)|0;n=iva(l)|0;if(!(jga(d,-1)|0)){if((hva(l)|0)==0){kva(l,f,f+1|0)}f=kga(d)|0;a[hva(l)|0]=f;jva(l,1)}f=hva(l)|0;o=gva(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=gva(l)|0;A=hva(l)|0;B=lga(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=gva(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;kva(l,B,hva(l)|0);B=iva(l)|0;jva(l,B-(gva(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;GDa(u);v=139584;w=127;Td(t|0,v|0,w|0)}else if((D|0)==14){q=(hva(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);kva(l,m,n)}k=mga(d)|0;i=e;return k|0}function iga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;fva(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;kva(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;kva(f,h,h+(g+ -1)|0);break}}else{kva(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function jga(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function kga(a){a=a|0;i=i;return a&255|0}function lga(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function mga(a){a=a|0;var b=0,c=0;b=i;c=jga(a,-1)|0;i=b;return(c?0:a)|0}function nga(a){a=a|0;i=i;return a&255|0}function oga(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function pga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;kva(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;fva(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;fva(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function qga(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=sga(b,c,e)|0;i=d;return g|0}function rga(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function sga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=tga(0,b,a)|0;i=c;return(d?b:a)|0}function tga(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function uga(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function vga(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function wga(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function xga(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function yga(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function zga(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Aga(b,c,e)|0;i=d;return g|0}function Aga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Bga(0,a,b)|0;i=c;return(d?b:a)|0}function Bga(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function Cga(a){a=a|0;var b=0,c=0;b=i;c=GAa(a,124088)|0;i=b;return c|0}function Dga(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function Ega(a){a=a|0;var b=0;b=i;Fga(a);i=b;return}function Fga(a){a=a|0;var b=0;b=i;Gga(a);i=b;return}function Gga(a){a=a|0;var b=0;b=i;Hga(a,ifa(a)|0);i=b;return}function Hga(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;pfa(d);if((b|0)==0){i=d;return}Hga(a,c[b>>2]|0);Hga(a,c[b+4>>2]|0);Jga(Iga(a)|0,b,1);i=d;return}function Iga(a){a=a|0;var b=0,c=0;b=i;c=Lga(a+4|0)|0;i=b;return c|0}function Jga(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Kga(0,b,0);i=c;return}function Kga(a,b,c){a=a|0;b=b|0;c=c|0;c=i;hEa(b);i=c;return}function Lga(a){a=a|0;var b=0,c=0;b=i;c=Mga(a)|0;i=b;return c|0}function Mga(a){a=a|0;i=i;return a|0}function Nga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Oga(a,f,b)|0;l=c[k>>2]|0;pfa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Qga(j,a,b);Rga(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Pga(g,e);Sga(j);j=c[f>>2]|0;Tga(a,j,k,Uga(g)|0);k=Vga(g)|0;Sga(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Oga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=ifa(h)|0;pfa(e);if((a|0)==0){j=$ea(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(mfa(0,d,a)|0){m=l;j=c[m>>2]|0;pfa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(mfa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;pfa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Pga(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Hha(a,e);i=d;return}function Qga(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Iga(d)|0;d=qha(n,1)|0;rha(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];pha(j,d,h);sha(0,lha((tha(j)|0)+16|0)|0,e);e=uha(j)|0;a[e+4|0]=1;vha(0,kha((tha(j)|0)+20|0)|0);a[e+5|0]=1;wha(m,j);Rga(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Pga(b,g);Sga(m);Sga(j);i=f;return}function Rga(a,b){a=a|0;b=b|0;var c=0;c=i;nha(a,b);i=c;return}function Sga(a){a=a|0;var b=0;b=i;gha(a);i=b;return}function Tga(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;pfa(f);c[e>>2]=0;pfa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=_ga(a)|0;b=c[c[e>>2]>>2]|0;pfa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[($ea(a)|0)>>2]|0;$ga(e,c[d>>2]|0);d=aha(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Uga(a){a=a|0;var b=0,d=0;b=i;d=c[(Yga(a)|0)>>2]|0;i=b;return d|0}function Vga(a){a=a|0;var b=0,d=0;b=i;d=Wga(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Wga(a){a=a|0;var b=0,c=0;b=i;c=Xga(a)|0;i=b;return c|0}function Xga(a){a=a|0;i=i;return a|0}function Yga(a){a=a|0;var b=0,c=0;b=i;c=Zga(a)|0;i=b;return c|0}function Zga(a){a=a|0;i=i;return a|0}function _ga(a){a=a|0;i=i;return a|0}function $ga(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=dha(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;pfa(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;pfa(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(dha(j)|0){p=j}else{o=c[k>>2]|0;eha(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;fha(p);i=e;return}else if((l|0)==14){if(dha(j)|0){p=c[k>>2]|0;fha(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;eha(q);i=e;return}else if((l|0)==17){i=e;return}}function aha(a){a=a|0;var b=0,c=0;b=i;c=bha(a+8|0)|0;i=b;return c|0}function bha(a){a=a|0;var b=0,c=0;b=i;c=cha(a)|0;i=b;return c|0}function cha(a){a=a|0;i=i;return a|0}function dha(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function eha(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;pfa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=dha(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function fha(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;pfa(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=dha(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function gha(a){a=a|0;var b=0;b=i;hha(a,0);i=b;return}function hha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Wga(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}jha(iha(e)|0,f);i=d;return}function iha(a){a=a|0;var b=0,c=0;b=i;c=mha(a)|0;i=b;return c|0}function jha(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}Jga(c[a>>2]|0,b,1);i=d;return}function kha(a){a=a|0;i=i;return a|0}function lha(a){a=a|0;i=i;return a|0}function mha(a){a=a|0;i=i;return a+4|0}function nha(a,b){a=a|0;b=b|0;var c=0;c=i;oha(a,b);i=c;return}function oha(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function pha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];zha(a,b,f);i=e;return}function qha(a,b){a=a|0;b=b|0;var c=0;a=i;c=yha(0,b,0)|0;i=a;return c|0}function rha(a,b){a=a|0;b=b|0;var c=0;c=i;xha(a,b);i=c;return}function sha(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function tha(a){a=a|0;var b=0,d=0;b=i;d=c[(Yga(a)|0)>>2]|0;i=b;return d|0}function uha(a){a=a|0;var b=0,c=0;b=i;c=iha(a)|0;i=b;return c|0}function vha(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function wha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;nha(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Pga(h,f);Rga(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Pga(a,e);Sga(h);i=d;return}function xha(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function yha(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=fEa(b*24|0)|0;i=c;return a|0}function zha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Bha(g)|0)>>2]|0;g=Cha(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Aha(b,a,f);i=e;return}function Aha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Dha(a,b,f);i=e;return}function Bha(a){a=a|0;i=i;return a|0}function Cha(a){a=a|0;i=i;return a|0}function Dha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Fha(g)|0)>>2]|0;g=Gha(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Eha(b,a,f);i=e;return}function Eha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Fha(f)|0)>>2];f=Gha(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Fha(a){a=a|0;i=i;return a|0}function Gha(a){a=a|0;i=i;return a|0}function Hha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Vga(Iha(b)|0)|0;h=Gha(uha(Iha(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Aha(g,a,e);i=d;return}function Iha(a){a=a|0;i=i;return c[a>>2]|0}function Jha(a){a=a|0;var b=0;b=i;i=i+48|0;Kha(a);Dea(a+184|0,0,0);Dea(a+200|0,0,0);Lha(a+240|0,b);Lha(a+252|0,b+8|0);Lha(a+264|0,b+16|0);Lha(a+276|0,b+24|0);Lha(a+288|0,b+32|0);Lha(a+300|0,b+40|0);i=b;return}function Kha(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;Tua(d);e=a;c[e>>2]=92100;f=d;c[f>>2]=92120;d=a+4|0;_va(a,92132|0,d);c[e>>2]=92100;c[f>>2]=92120;Yha(d);i=b;return}function Lha(a,b){a=a|0;b=b|0;b=i;Mha(a,0);i=b;return}function Mha(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Nha(a,b);i=b;return}function Nha(a,b){a=a|0;b=b|0;b=i;Oha(a,0);i=b;return}function Oha(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Pha(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Qha(f,0,e);e=$ea(b)|0;c[(_ga(b)|0)>>2]=e;i=d;return}function Pha(a){a=a|0;var b=0;b=i;Uha(a);i=b;return}function Qha(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Rha(b,c,f);i=e;return}function Rha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Tha(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Sha(d,b,f);i=e;return}function Sha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Tha(e)|0)>>2];i=d;return}function Tha(a){a=a|0;i=i;return a|0}function Uha(a){a=a|0;var b=0;b=i;Vha(a);i=b;return}function Vha(a){a=a|0;var b=0;b=i;Wha(a);i=b;return}function Wha(a){a=a|0;var b=0;b=i;Xha(a);i=b;return}function Xha(a){a=a|0;c[a>>2]=0;i=i;return}function Yha(a){a=a|0;var b=0;b=i;Zha(a);i=b;return}function Zha(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;ava(j);c[d>>2]=92256;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;pfa(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Yua(g,j);l=_ha(g)|0;EAa(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}Yua(h,j);c[k>>2]=Cga(h)|0;EAa(h);a[f]=(Dga(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}function _ha(a){a=a|0;var b=0,c=0;b=i;c=FAa(a,124088)|0;i=b;return c|0}function $ha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Vaa(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){aia(a,b,c[f>>2]|0,h);Yaa(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=cEa(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;H9(k,92528,e)}aia(a,b,l,h);Yaa(3);i=d;return}function aia(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;Yaa(0);k=+Qaa(0);Vaa(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function bia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=$Da(24)|0;Vaa(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;G9(c[m>>2]|0,l>>>31^1,92584,f);f=b+8|0;b=c[a+8>>2]|0;l=cia(b,f)|0;c[g+20>>2]=l;l=cia(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=$Da(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;H9(k,92664,e)}else{c[h>>2]=0;c[a+12>>2]=g;Yaa(3);i=d;return}}function cia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function dia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Vaa(3);u=b;v=ic(c[u>>2]|0,92728)|0;if((v|0)==0){eia(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;H9(w,92736,q)}rc(92792,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];wd(v|0,92840,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];wd(v|0,92864,o|0)|0;rc(92888,40,1,v|0)|0;rc(92936,11,1,v|0)|0;rc(92952,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];fia(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(92968,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;fia(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Sd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];wd(v|0,92992,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;fia(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Sd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];wd(v|0,92992,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;fia(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Sd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];wd(v|0,92992,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;fia(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];wd(v|0,92992,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;fia(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Sd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];wd(v|0,92992,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;fia(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Sd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];wd(v|0,92992,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;fia(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Sd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}eia(t);if((Yc(v|0)|0)==0){aEa(c[r>>2]|0);c[r>>2]=0;Yaa(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];H9(e,93008,f)}}function eia(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}aEa(a);c[d>>2]=0;i=b;return}function fia(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];wd(a|0,93056,f|0)|0;i=e;return}function gia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=fEa(192)|0;HEa(m|0,0,192)|0;hia(m);c[a+12>>2]=m;n=m;o=a;Eea(n,c[o>>2]|0,36);if(Hua(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];H9(a,93096,g)}else{g=m;kwa(g,93072,14)|0;lwa(h,g);a=Rfa(h)|0;h=m+184|0;c[h>>2]=a;kwa(g,93088,4)|0;iia(n,b+8|0);lwa(j,g);b=Rfa(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;Dea(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];mwa(g,f)|0;jia(n,-4-m+b|0);b=c[j>>2]|0;Dea(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];mwa(g,e)|0;Yaa(3);i=d;return}}function hia(a){a=a|0;var b=0;b=i;Cia(a);i=b;return}function iia(a,b){a=a|0;b=b|0;var c=0;c=i;lia(a,3);mia(a,93272);lia(a,0);mia(a,93280);lia(a,2);xia(a,b);yia(a,b);mia(a,93288);lia(a,0);i=c;return}function jia(a,b){a=a|0;b=b|0;var d=0;d=i;c[23316]=Hd(b|0)|0;kwa(a,93264,4)|0;i=d;return}function kia(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;lwa(l,q);r=Rfa(l)|0;jia(b,0);lwa(m,q);l=Rfa(m)|0;lia(b,1);mia(b,93160);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;nia(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);oia(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{oia(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{pia(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{qia(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{mia(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}lwa(n,q);u=Rfa(n)|0;n=EEa(0,r|0,32)|0;Dea(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];mwa(q,k)|0;jia(b,u-l|0);Dea(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];mwa(q,j)|0;i=g;return}function lia(b,d){b=b|0;d=d|0;var e=0;e=i;a[93248]=-33;c[23314]=Hd(d|0)|0;d=b;kwa(d,93248,1)|0;kwa(d,93256,4)|0;i=e;return}function mia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Hd(DEa(d|0)|0)|0;a[93240]=-37;g=b;kwa(g,93240,1)|0;kwa(g,f,4)|0;kwa(g,d,DEa(d|0)|0)|0;i=e;return}function nia(b,d){b=b|0;d=d|0;var e=0;e=i;a[93224]=-35;c[23308]=Hd(d|0)|0;d=b;kwa(d,93224,1)|0;kwa(d,93232,4)|0;i=e;return}function oia(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[93208]=-53;wia(c);e=b;kwa(e,93208,1)|0;kwa(e,93216,8)|0;i=d;return}function pia(b,d){b=b|0;d=d|0;var e=0;e=i;a[93192]=-46;c[23300]=Hd(d|0)|0;d=b;kwa(d,93192,1)|0;kwa(d,93200,4)|0;i=e;return}function qia(b,c){b=b|0;c=c|0;var d=0;d=i;a[93184]=c?-61:-62;kwa(b,93184,1)|0;i=d;return}function ria(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;kia(e,+h[f>>3],a,f);kia(e,+h[b+248>>3],a,f);i=d;return}function sia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;lwa(j,p);o=Rfa(j)|0;jia(b,0);lwa(k,p);j=Rfa(k)|0;lia(b,1);mia(b,93168);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;nia(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;oia(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{oia(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{pia(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{qia(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{mia(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}lwa(l,p);s=Rfa(l)|0;l=EEa(0,o|0,32)|0;Dea(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];mwa(p,g)|0;jia(b,s-j|0);Dea(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];mwa(p,f)|0;i=e;return}function tia(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;xea(a);Vaa(3);if((a|0)!=0){uia(a);hEa(a)}c[d>>2]=0;Yaa(3);i=b;return}function uia(a){a=a|0;var b=0;b=i;via(a);i=b;return}function via(a){a=a|0;var b=0;b=i;Ufa(a);i=b;return}function wia(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Hd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=93216;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[93216+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function xia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;mia(a,93160);lia(a,4);mia(a,93296);lia(a,0);mia(a,93304);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;nia(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);mia(a,93312);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{mia(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{mia(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{mia(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{mia(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=93400;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];zia(a,b,e);mia(a,93336);lia(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);Aia(a,93312,93344);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;Aia(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;Aia(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;Aia(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;Aia(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function yia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;mia(a,93168);lia(a,4);mia(a,93296);lia(a,0);mia(a,93304);o=g+1+j+l+n|0;nia(a,o);mia(a,93312);if((c[f>>2]|0)>0){n=b;l=0;do{mia(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{mia(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{mia(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{mia(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=93320;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];zia(a,b,e);mia(a,93336);lia(a,o);Aia(a,93312,93344);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;Aia(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;Aia(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;Aia(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;Aia(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function zia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;mia(b,93368);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}lia(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?93312:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}Bia(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?93312:w;if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}Bia(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?93312:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}Bia(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?93312:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}Bia(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function Aia(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;mia(a,b);lia(a,1);mia(a,93352);mia(a,c);i=d;return}function Bia(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;mia(a,b);lia(a,d?2:1);mia(a,93376);mia(a,c);if(!d){i=e;return}mia(a,93384);mia(a,93392);i=e;return}function Cia(a){a=a|0;var b=0;b=i;Kha(a);i=b;return}function Dia(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;Qta(e,93416);Mta(d,Fia(a,e)|0);Eia(d,b+4|0);Wta(d);Wta(e);Qta(g,93424);Mta(f,Fia(a,g)|0);Gia(f,b);Wta(f);Wta(g);Qta(j,93440);Mta(h,Fia(a,j)|0);Eia(h,b+8|0);Wta(h);Wta(j);Qta(l,93456);Mta(k,Fia(a,l)|0);Eia(k,b+12|0);Wta(k);Wta(l);Qta(n,93472);Mta(m,Fia(a,n)|0);Hia(m,b+16|0,0);Wta(m);Wta(n);Qta(p,93488);Mta(o,Fia(a,p)|0);Hia(o,b+20|0,0);Wta(o);Wta(p);Qta(r,93504);Mta(q,Fia(a,r)|0);Hia(q,b+24|0,0);Wta(q);Wta(r);Qta(t,93512);Mta(s,Fia(a,t)|0);Hia(s,b+28|0,0);Wta(s);Wta(t);Qta(v,93528);Mta(u,Fia(a,v)|0);Hia(u,b+32|0,0);Wta(u);Wta(v);i=c;return}function Eia(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){F9(22,0,96736,d);i=d;return}else{c[b>>2]=Ad(rua(a)|0)|0;i=d;return}}function Fia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Oma(a,f,b)|0;l=c[k>>2]|0;pfa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}Qma(j,a,b);Rma(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Pma(g,e);Sma(j);j=c[f>>2]|0;Tma(a,j,k,Uma(g)|0);k=Vma(g)|0;Sma(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function Gia(a,b){a=a|0;b=b|0;var d=0;d=i;if((uua(a,93704)|0)==0){c[b>>2]=1;i=d;return}if((uua(a,93712)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(rua(a)|0)|0;i=d;return}}function Hia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((uua(a,93680)|0)==0){c[b>>2]=d}if((uua(a,93704)|0)==0){c[b>>2]=1;i=e;return}if((uua(a,93712)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(rua(a)|0)|0;i=e;return}}function Iia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;Qta(j,93544);Mta(g,Fia(b,j)|0);y=d+48|0;Jia(g,y);Wta(g);Wta(j);Qta(m,93560);Mta(l,Fia(b,m)|0);j=d+56|0;Kia(l,j,0.0);Wta(l);Wta(m);Qta(o,93568);Mta(n,Fia(b,o)|0);m=d+32|0;Jia(n,m);Wta(n);Wta(o);Qta(q,93576);Mta(p,Fia(b,q)|0);o=d+33|0;Jia(p,o);Wta(p);Wta(q);Qta(s,93592);Mta(r,Fia(b,s)|0);q=d+40|0;Kia(r,q,1.0);Wta(r);Wta(s);Qta(u,93600);Mta(t,Fia(b,u)|0);s=d+16|0;Kia(t,s,-1.7976931348623157e+308);Wta(t);Wta(u);Qta(w,93608);Mta(v,Fia(b,w)|0);u=d+24|0;Kia(v,u,1.7976931348623157e+308);Wta(v);Wta(w);Qta(x,93416);w=rua(Fia(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?93704:93712;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?93680:93688;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?93680:93696;c[f+20>>2]=j;c[f+24>>2]=m?93680:93688;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?93680:93696;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];D9(4,0,93616,f);Wta(x);i=e;return}function Jia(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(uua(b,93704)|0)==0|0;i=d;return}function Kia(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((uua(a,93680)|0)==0){h[b>>3]=c;i=d;return}if((uua(a,93704)|0)==0){h[b>>3]=1.0;i=d;return}if((uua(a,93712)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+vEa(rua(a)|0);i=d;return}}function Lia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;Qta(h,93544);Mta(g,Fia(b,h)|0);s=d+13|0;Jia(g,s);Wta(g);Wta(h);Qta(k,93560);Mta(j,Fia(b,k)|0);h=d+16|0;Hia(j,h,0);Wta(j);Wta(k);Qta(m,93568);Mta(l,Fia(b,m)|0);k=d+12|0;Jia(l,k);Wta(l);Wta(m);Qta(o,93600);Mta(n,Fia(b,o)|0);m=d+4|0;Hia(n,m,-2147483648);Wta(n);Wta(o);Qta(q,93608);Mta(p,Fia(b,q)|0);o=d+8|0;Hia(p,o,2147483647);Wta(p);Wta(q);Qta(r,93416);q=rua(Fia(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?93704:93712;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?93680:93688;c[f+8>>2]=s;c[f+12>>2]=b?93680:93696;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;D9(4,0,93720,f);Wta(r);i=e;return}function Mia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;Qta(h,93544);Mta(g,Fia(b,h)|0);o=d+5|0;Jia(g,o);Wta(g);Wta(h);Qta(k,93560);Mta(j,Fia(b,k)|0);h=d+6|0;Jia(j,h);Wta(j);Wta(k);Qta(m,93568);Mta(l,Fia(b,m)|0);k=d+4|0;Jia(l,k);Wta(l);Wta(m);Qta(n,93416);m=rua(Fia(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?93704:93712;h=(a[k]|0)!=0?93704:93712;c[f>>2]=m;c[f+4>>2]=b?93680:93688;c[f+8>>2]=o;c[f+12>>2]=b?93680:93696;c[f+16>>2]=h;D9(4,0,93776,f);Wta(n);i=e;return}function Nia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;Qta(h,93544);Mta(g,Fia(b,h)|0);m=d+4|0;Jia(g,m);Wta(g);Wta(h);Qta(k,93560);Mta(j,Fia(b,k)|0);h=d+8|0;Eia(j,h);Wta(j);Wta(k);Qta(l,93416);k=rua(Fia(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?93680:93688;c[f+8>>2]=m;c[f+12>>2]=b?93680:93696;D9(4,0,93816,f);Wta(l);i=e;return}function Oia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;Pia(qa);Kta(ra);Qia(sa,ta);Qia(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[106800>>2]|0)==0){Qta(za,c[b+80>>2]|0);Ria(ya,za,93840);Xta(ra,ya)|0;Wta(ya);Wta(za)}else{Yta(ra,c[106928>>2]|0)|0}ta=ic(rua(ra)|0,93856)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=rua(ra)|0;H9(0,93864,pa)}else{Wc=0}}while(0);pa=y4(0)|0;if((pa|0)==0){Yc(Wc|0)|0;H9(0,93968,oa)}J4(pa,Vc);K4(pa,8,50);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;HEa(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((L4(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){Yc(Wc|0)|0;oa=rua(ra)|0;ya=T4(Q4(pa)|0)|0;za=R4(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;F9(1,0,94048,na);F4(pa);H9(0,94136,ma)}else if((Xc|0)==14){Yc(Wc|0)|0;break}}else{if((L4(pa,Vc,DEa(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=T4(Q4(pa)|0)|0;ta=R4(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;wd(za|0,94160,la|0)|0;za=c[va>>2]|0;ta=T4(Q4(pa)|0)|0;oa=R4(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;F9(1,0,94176,ka);F4(pa);H9(0,94136,ja)}}while(0);ja=qa;Qta(Ca,94264);Via(Ba,ja,Ca);Wia(Da,ja);ka=Uia(Ba,Da)|0;Wta(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=rua(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;F9(1,0,94272,ia)}else{Qta(Ea,94264);Ba=zEa(Da,rua(Fia(ja,Ea)|0)|0)|0;Wta(Ea);if((Ba|0)==0){break}F4(pa);Qta(Fa,94264);Ba=rua(Fia(ja,Fa)|0)|0;va=rua(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;F9(1,0,94320,ha);Wta(Fa);H9(0,94136,ga)}}while(0);Xia(qa,b,c[107012>>2]|0,c[107016>>2]|0);D9(23,1,94416,fa);fa=qa+12|0;Qta(Ha,94456);Mta(Ga,Fia(fa,Ha)|0);ga=d;Kia(Ga,ga,0.0);Wta(Ga);Wta(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];D9(23,0,94472,ea);Qta(Ja,94488);Mta(Ia,Fia(fa,Ja)|0);ea=d+8|0;Kia(Ia,ea,1.0);Wta(Ia);Wta(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];D9(23,0,94504,da);Qta(La,94520);Mta(Ka,Fia(fa,La)|0);da=d+24|0;Kia(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Wta(Ka);Wta(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];D9(23,0,94536,ca);Qta(Na,94552);Mta(Ma,Fia(fa,Na)|0);ca=d+32|0;Kia(Ma,ca,1.0e-5);Wta(Ma);Wta(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];D9(23,0,94568,ba);Qta(Pa,94584);Mta(Oa,Fia(fa,Pa)|0);ba=d+40|0;Eia(Oa,ba);Wta(Oa);Wta(Pa);c[aa>>2]=c[ba>>2];D9(23,0,94592,aa);Qta(Ra,94616);Mta(Qa,Fia(fa,Ra)|0);aa=d+44|0;Eia(Qa,aa);Wta(Qa);Wta(Ra);c[$>>2]=c[aa>>2];D9(23,0,94632,$);Qta(Ta,94656);Mta(Sa,Fia(fa,Ta)|0);fa=d+48|0;Eia(Sa,fa);Wta(Sa);Wta(Ta);c[_>>2]=c[fa>>2];D9(23,0,94672,_);Qta(Va,94696);Mta(Ua,Fia(ja,Va)|0);_=d+268|0;Eia(Ua,_);Wta(Ua);Wta(Va);c[Z>>2]=c[_>>2];D9(23,0,94720,Z);if((c[49948>>2]|0)!=0){fe[c[12602]&511](23)}Qta(eb,94744);Mta(db,Fia(ja,eb)|0);Hia(db,Wa,0);Wta(db);Wta(eb);Qta(gb,94776);Mta(fb,Fia(ja,gb)|0);Hia(fb,Xa,0);Wta(fb);Wta(gb);Qta(ib,94808);Mta(hb,Fia(ja,ib)|0);Hia(hb,Ya,0);Wta(hb);Wta(ib);Qta(kb,94832);Mta(jb,Fia(ja,kb)|0);Hia(jb,_a,0);Wta(jb);Wta(kb);Qta(mb,94864);Mta(lb,Fia(ja,mb)|0);Hia(lb,Za,0);Wta(lb);Wta(mb);Qta(ob,94904);Mta(nb,Fia(ja,ob)|0);Hia(nb,ab,0);Wta(nb);Wta(ob);Qta(qb,94936);Mta(pb,Fia(ja,qb)|0);Hia(pb,$a,0);Wta(pb);Wta(qb);Qta(tb,94976);Mta(rb,Fia(ja,tb)|0);Hia(rb,cb,0);Wta(rb);Wta(tb);Qta(vb,95008);Mta(ub,Fia(ja,vb)|0);Hia(ub,bb,0);Wta(ub);Wta(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=95552;D9(4,1,95528,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=Yia(lb,wb)|0;Dia(ib,jb+(kb*112|0)|0);Iia(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(xb,95568);jb=(uua(Fia(ib,xb)|0,93704)|0)==0;Wta(xb);if(!jb){break}c[N>>2]=c[hb>>2];D9(4,0,95584,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);Qta(yb,c[hb>>2]|0);c[(Zia(sa,yb)|0)>>2]=kb;Wta(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[M>>2]=95616;D9(4,1,95528,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=Yia(lb,zb)|0;Dia(fb,gb+(jb*112|0)|0);Iia(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Ab,95568);gb=(uua(Fia(fb,Ab)|0,93704)|0)==0;Wta(Ab);if(!gb){break}c[L>>2]=c[eb>>2];D9(4,0,95584,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);Qta(Bb,c[eb>>2]|0);c[(Zia(sa,Bb)|0)>>2]=jb;Wta(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[K>>2]=95640;D9(4,1,95528,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=Yia(mb,Cb)|0;Dia(gb,hb+(fb*112|0)|0);Iia(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Db,95568);hb=(uua(Fia(gb,Db)|0,93704)|0)==0;Wta(Db);if(!hb){break}c[J>>2]=c[db>>2];D9(4,0,95584,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);Qta(Eb,c[db>>2]|0);c[(Zia(sa,Eb)|0)>>2]=fb;Wta(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[I>>2]=95656;D9(4,1,95528,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=Yia(ub,Fb)|0;Dia(mb,kb+(ib*60|0)|0);Lia(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Gb,95568);kb=(uua(Fia(mb,Gb)|0,93704)|0)==0;Wta(Gb);if(!kb){break}c[H>>2]=c[gb>>2];D9(4,0,95584,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);Qta(Hb,c[gb>>2]|0);c[(Zia(sa,Hb)|0)>>2]=ib;Wta(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[G>>2]=95680;D9(4,1,95528,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=Yia(ib,Ib)|0;Dia(mb,ub+(lb*48|0)|0);Mia(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Jb,95568);ub=(uua(Fia(mb,Jb)|0,93704)|0)==0;Wta(Jb);if(!ub){break}c[F>>2]=c[fb>>2];D9(4,0,95584,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);Qta(Kb,c[fb>>2]|0);c[(Zia(sa,Kb)|0)>>2]=lb;Wta(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[E>>2]=95704;D9(4,1,95528,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=Yia(lb,Lb)|0;Dia(mb,ib+(rb*52|0)|0);Nia(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Mb,95568);ib=(uua(Fia(mb,Mb)|0,93704)|0)==0;Wta(Mb);if(!ib){break}c[D>>2]=c[gb>>2];D9(4,0,95584,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);Qta(Nb,c[gb>>2]|0);c[(Zia(sa,Nb)|0)>>2]=rb;Wta(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[C>>2]=95728;D9(4,1,95528,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=Yia(rb,Ob)|0;Dia(mb,lb+(pb*112|0)|0);Iia(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Pb,95568);lb=(uua(Fia(mb,Pb)|0,93704)|0)==0;Wta(Pb);if(!lb){break}c[B>>2]=c[fb>>2];D9(4,0,95584,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);Qta(Qb,c[fb>>2]|0);c[(Zia(ua,Qb)|0)>>2]=pb;Wta(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[A>>2]=95744;D9(4,1,95528,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=Yia(pb,Rb)|0;Dia(mb,rb+(nb*60|0)|0);Lia(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Sb,95568);rb=(uua(Fia(mb,Sb)|0,93704)|0)==0;Wta(Sb);if(!rb){break}c[z>>2]=c[gb>>2];D9(4,0,95584,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);Qta(Tb,c[gb>>2]|0);c[(Zia(ua,Tb)|0)>>2]=nb;Wta(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[y>>2]=95768;D9(4,1,95528,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=Yia(nb,Ub)|0;Dia(mb,pb+(ja*48|0)|0);Mia(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Vb,95568);pb=(uua(Fia(mb,Vb)|0,93704)|0)==0;Wta(Vb);if(!pb){break}c[x>>2]=c[fb>>2];D9(4,0,95584,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);Qta(Wb,c[fb>>2]|0);c[(Zia(ua,Wb)|0)>>2]=ja;Wta(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}c[w>>2]=95792;D9(4,1,95528,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=Yia(ja,Xb)|0;Dia(mb,nb+(tb*52|0)|0);Nia(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[106796>>2]|0)!=0){break}Qta(Yb,95568);nb=(uua(Fia(mb,Yb)|0,93704)|0)==0;Wta(Yb);if(!nb){break}c[v>>2]=c[gb>>2];D9(4,0,95584,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);Qta(Zb,c[gb>>2]|0);c[(Zia(ua,Zb)|0)>>2]=tb;Wta(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}D9(4,1,95816,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=Yia(tb,_b)|0;Dia(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);Kta($b);c[bc>>2]=ja;mb=Yia(tb,bc)|0;Qta(cc,95856);Mta(ac,Fia(mb,cc)|0);_ia(ac,$b);Wta(ac);Wta(cc);mb=(uua($b,95864)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;D9(4,0,95880,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=Yia(tb,ec)|0;Qta(fc,95920);Mta(dc,Fia(nb,fc)|0);_ia(dc,$b);Wta(dc);Wta(fc);$ia(wa,sa,$b);$ia(xa,ua,$b);bja(gc,sa);do{if(aja(wa,gc)|0){nb=c[(cja(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{bja(hc,ua);if(aja(xa,hc)|0){fb=c[(cja(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((uua($b,95936)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Wta($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}Fua(kc,95944,$b);Ria(jc,kc,95968);Wta(kc);c[s>>2]=rua(jc)|0;H9(0,95984,s)}}while(0);if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}D9(4,1,95992,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=Yia(ja,lc)|0;Dia(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);Kta(mc);c[oc>>2]=tb;gb=Yia(ja,oc)|0;Qta(pc,95856);Mta(nc,Fia(gb,pc)|0);_ia(nc,mc);Wta(nc);Wta(pc);gb=(uua(mc,95864)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;D9(4,0,95880,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=Yia(ja,rc)|0;Qta(sc,95920);Mta(qc,Fia(fb,sc)|0);_ia(qc,mc);Wta(qc);Wta(sc);$ia(wa,sa,mc);$ia(xa,ua,mc);bja(tc,sa);if(aja(wa,tc)|0){fb=c[(cja(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{bja(uc,ua);if(!(aja(xa,uc)|0)){break}nb=c[(cja(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Wta(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}Fua(wc,96032,mc);Ria(vc,wc,95968);Wta(wc);c[o>>2]=rua(vc)|0;H9(0,95984,o)}}while(0);if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}D9(4,1,96056,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=Yia(tb,xc)|0;Dia(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);Kta(yc);c[Ac>>2]=ja;fb=Yia(tb,Ac)|0;Qta(Bc,95856);Mta(zc,Fia(fb,Bc)|0);_ia(zc,yc);Wta(zc);Wta(Bc);fb=(uua(yc,95864)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;D9(4,0,95880,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=Yia(tb,Dc)|0;Qta(Ec,95920);Mta(Cc,Fia(gb,Ec)|0);_ia(Cc,yc);Wta(Cc);Wta(Ec);$ia(wa,sa,yc);$ia(xa,ua,yc);bja(Fc,sa);if(aja(wa,Fc)|0){gb=c[(cja(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{bja(Gc,ua);if(!(aja(xa,Gc)|0)){break}nb=c[(cja(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Wta(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}Fua(Ic,96096,yc);Ria(Hc,Ic,95968);Wta(Ic);c[l>>2]=rua(Hc)|0;H9(0,95984,l)}}while(0);if((c[49872>>2]|0)!=0){fe[c[12602]&511](4)}D9(4,1,96120,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=Yia(ja,Jc)|0;Dia(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);Kta(Kc);c[Mc>>2]=tb;gb=Yia(ja,Mc)|0;Qta(Nc,95856);Mta(Lc,Fia(gb,Nc)|0);_ia(Lc,Kc);Wta(Lc);Wta(Nc);gb=(uua(Kc,95864)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;D9(4,0,95880,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=Yia(ja,Pc)|0;Qta(Qc,95920);Mta(Oc,Fia(fb,Qc)|0);_ia(Oc,Kc);Wta(Oc);Wta(Qc);$ia(wa,sa,Kc);$ia(xa,ua,Kc);bja(Rc,sa);if(aja(wa,Rc)|0){fb=c[(cja(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{bja(Sc,ua);if(!(aja(xa,Sc)|0)){break}nb=c[(cja(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Wta(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}Fua(Uc,96160,Kc);Ria(Tc,Uc,95968);Wta(Uc);c[f>>2]=rua(Tc)|0;H9(0,95984,f)}}while(0);if((c[49872>>2]|0)==0){F4(pa);dja(ua);dja(sa);Wta(ra);eja(qa);i=e;return}fe[c[12602]&511](4);F4(pa);dja(ua);dja(sa);Wta(ra);eja(qa);i=e;return}}while(0);if((c[49944>>2]|c[12462]|0)==0){F4(pa);Zc=ud(0)|0;Cd(-1)}F9(22,1,95048,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;F9(22,0,95096,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;F9(22,0,95144,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;F9(22,0,95192,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;F9(22,0,95240,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;F9(22,0,95288,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;F9(22,0,95336,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;F9(22,0,95384,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;F9(22,0,95432,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;F9(22,0,95480,P);fe[c[12602]&511](22);F4(pa);Zc=ud(0)|0;Cd(-1)}function Pia(a){a=a|0;var b=0;b=i;Ppa(a);i=b;return}function Qia(a,b){a=a|0;b=b|0;b=i;ula(a,0);i=b;return}function Ria(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Lta(a,d);e=Uta(b)|0;f=Eja(c)|0;vua(a,Vta(b)|0,e,f+e|0);nua(a,c,f)|0;i=d;return}



function ica(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+td(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+td(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}Yba(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function jca(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function kca(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;fe[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function lca(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function mca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=O9(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{xe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;M9(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=O9(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function nca(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((mca(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}oca(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(O9(d)|0)>0;h=b?2:0;i=e;return h|0}function oca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=$Da(q)|0;s=r;t=$Da(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[20130]=K9(4)|0;if((r|0)==0){cb(80528,80544,308,80576)}if((t|0)==0){cb(80592,80544,309,80576)}v=R9(b)|0;if((v|0)!=0){w=v;do{v=T9(w)|0;c[l>>2]=c[v>>2];D9(27,0,80608,l);w=S9(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;FEa(t|0,c[a+384>>2]|0,v|0)|0;FEa(r|0,l|0,v|0)|0}h[d>>3]=+rca(a,n,o,q,s,c[20130]|0,b);do{if((O9(c[20130]|0)|0)==0){s=P9(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=R9(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=T9(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=S9(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];D9(27,0,80656,j);v=R9(b)|0;if((v|0)==0){break}else{B=v}do{v=T9(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[20130]|0;N9(v,T9(B)|0);v=T9(B)|0;c[g>>2]=c[v>>2];D9(27,0,80680,g)}B=S9(B)|0;}while((B|0)!=0)}}while(0);L9(b);if((c[49884>>2]|0)!=0){O9(c[20130]|0)|0}if((O9(c[20130]|0)|0)>0){B=m;do{g=P9(c[20130]|0)|0;c[m>>2]=c[g>>2];Q9(c[20130]|0);c[f>>2]=c[m>>2];D9(7,0,80704,f);M9(b,B);}while((O9(c[20130]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){FEa(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ze(a);uca(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){aEa(t);aEa(r);i=e;return}FEa(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;aEa(t);aEa(r);i=e;return}function pca(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){yca(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(7,0,80248,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((O9(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[49884>>2]|0)!=0){e=R9(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=T9(s)|0;x=c[e>>2]|0;e=xe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;C9(7,0,w,80272,l);s=S9(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=T9(R9(d)|0)|0;x=xe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;C9(1,0,e,80288,j);c[s>>2]=1}}while(0);L9(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;tca(b);qca(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function qca(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;D9(27,0,80896,b);d=a+344|0;le[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function rca(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=$Da(p<<3)|0;if((q|0)==0){cb(80712,80544,409,80728)}if((p|0)>0){FEa(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];D9(27,0,80744,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(27,0,80792,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){aEa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}Sda(a)|0;ie[c[(c[p>>2]|0)+40>>2]&127](a)|0;ie[c[(c[p>>2]|0)+28>>2]&127](a)|0;ie[c[(c[p>>2]|0)+32>>2]&127](a)|0;le[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(sca(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}FEa(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}aEa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function sca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;L9(b);D9(27,0,80816,g);g=R9(d)|0;if((g|0)==0){j=O9(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=T9(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=T9(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=T9(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=T9(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=T9(a)|0;o=c[g>>2]|0;g=T9(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?80232:80240;g=T9(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?80232:80240;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;D9(27,0,80856,f);M9(b,T9(a)|0)}a=S9(a)|0;}while((a|0)!=0);j=O9(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function tca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;xe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;uca(b);vca(b);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;wca(b,8);h=xca(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{vca(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}yca(b);uca(b);wca(b,8);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=xca(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){H9(c[b+536>>2]|0,80936,e)}else if((o|0)==7){vca(b);i=d;return}}function uca(a){a=a|0;var b=0;b=i;FEa(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function vca(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function wca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[49856+(d<<2)>>2]|0)==0){i=e;return}D9(d,1,81360,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;D9(d,0,81384,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}fe[c[12602]&511](d);i=e;return}function xca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function yca(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;FEa(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;FEa(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;FEa(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;FEa(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function zca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}le[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function Aca(a){a=a|0;var b=0;b=i;Bca(a);Cca(a);yca(a);Dca(a);i=b;return}function Bca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function Cca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function Dca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Jaa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];FEa(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;FEa(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;FEa(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;FEa(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Jaa(c[d>>2]|0)|0));i=b;return}function Eca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[49856+(d<<2)>>2]|0)==0){i=e;return}D9(d,1,81032,q);q=b+136|0;if((c[q>>2]|0)>0){D9(d,1,81056,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?81016:81024;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];D9(d,0,81072,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}fe[c[12602]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){D9(d,1,81128,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?81016:81024;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;D9(d,0,81152,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}fe[c[12602]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){D9(d,1,81208,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?81016:81024;v=(a[n+(m*48|0)+40|0]|0)!=0?81016:81024;n=(a[(c[s>>2]|0)+m|0]|0)!=0?81016:81024;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;D9(d,0,81232,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}fe[c[12602]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){D9(d,1,81288,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;D9(d,0,81312,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}fe[c[12602]&511](d)}fe[c[12602]&511](d);i=e;return}function Fca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Jaa(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];FEa(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;FEa(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;FEa(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;FEa(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Jaa(c[d>>2]|0)|0));i=b;return}function Gca(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function Hca(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];FEa(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;FEa(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;FEa(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;FEa(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function Ica(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Eaa(3,32)|0;c[o>>2]=p;if((p|0)==0){H9(c[b+536>>2]|0,81416,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=bEa(c[p>>2]|0,8)|0;c[q>>2]=z;G9(c[r>>2]|0,(z|0)!=0|0,81472,l);z=bEa(c[s>>2]|0,4)|0;c[t>>2]=z;G9(c[r>>2]|0,(z|0)!=0|0,81472,k);z=bEa(c[u>>2]|0,1)|0;c[v>>2]=z;G9(c[r>>2]|0,(z|0)!=0|0,81472,j);z=bEa(c[w>>2]|0,4)|0;c[x>>2]=z;G9(c[r>>2]|0,(z|0)!=0|0,81472,g);Iaa(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=bEa(3,4)|0;c[b+4>>2]=n;Kaa(c[o>>2]|0,0,n);c[b+8>>2]=bEa(c[p>>2]|0,112)|0;c[b+12>>2]=bEa(c[s>>2]|0,60)|0;c[b+16>>2]=bEa(c[u>>2]|0,48)|0;c[b+20>>2]=bEa(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=bEa(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=bEa(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=bEa(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=bEa(g,52)|0;c[b+40>>2]=bEa(c[b+216>>2]|0,52)|0;c[b+44>>2]=bEa(c[b+220>>2]|0,52)|0;c[b+48>>2]=bEa(c[b+224>>2]|0,52)|0;c[b+52>>2]=bEa(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=bEa(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=bEa(x,8)|0;c[b+340>>2]=bEa(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=bEa(x,8)|0;c[b+348>>2]=bEa(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=bEa(j,1)|0;c[b+356>>2]=bEa(j,1)|0;c[b+360>>2]=bEa(j,1)|0;j=$Da(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=$Da(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=bEa(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=bEa(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=bEa(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=bEa(u,4)|0;c[b+400>>2]=bEa(x,8)|0;c[b+404>>2]=bEa(p,4)|0;c[b+408>>2]=bEa(s,1)|0;c[b+412>>2]=bEa(u,4)|0;c[b+416>>2]=bEa(c[n>>2]|0,8)|0;c[b+420>>2]=bEa(o,4)|0;c[b+424>>2]=bEa(y,1)|0;c[b+428>>2]=bEa(g,4)|0;c[b+432>>2]=bEa(c[b+152>>2]|0,8)|0;c[b+436>>2]=bEa(c[b+156>>2]|0,8)|0;g=$Da((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;fe[c[(c[y>>2]|0)+20>>2]&511](g);g=$Da((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;fe[c[(c[y>>2]|0)+16>>2]&511](g);g=$Da((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;fe[c[(c[y>>2]|0)+12>>2]&511](g);g=$Da((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ge[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=$Da((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=bEa(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;G9(c[r>>2]|0,(g|0)!=0|0,81488,f);c[b+512>>2]=100;c[b+516>>2]=bEa(100,4)|0;c[b+520>>2]=bEa(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=$Da(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;G9(c[r>>2]|0,(g|0)!=0|0,81472,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Eaa(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function Jca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;aEa(c[g+8>>2]|0);aEa(c[g+12>>2]|0);aEa(c[g+16>>2]|0);aEa(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);aEa(e);Faa(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){aba(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}aEa(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){aba(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}aEa(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){aba(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}aEa(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){aba(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}aEa(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){aba(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}aEa(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){aba(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}aEa(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){aba(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}aEa(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){aba(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}aEa(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){aba(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}aEa(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){aba(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}aEa(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){aba(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}aEa(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){aba(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}aEa(v);aEa(c[a+108>>2]|0);aEa(c[a+336>>2]|0);aEa(c[a+340>>2]|0);aEa(c[a+344>>2]|0);aEa(c[a+348>>2]|0);aEa(c[a+352>>2]|0);aEa(c[a+356>>2]|0);aEa(c[a+360>>2]|0);aEa(c[a+368>>2]|0);aEa(c[a+384>>2]|0);aEa(c[a+388>>2]|0);aEa(c[a+392>>2]|0);aEa(c[a+396>>2]|0);aEa(c[a+400>>2]|0);aEa(c[a+404>>2]|0);aEa(c[a+408>>2]|0);aEa(c[a+412>>2]|0);aEa(c[a+416>>2]|0);aEa(c[a+420>>2]|0);aEa(c[a+424>>2]|0);aEa(c[a+428>>2]|0);aEa(c[a+488>>2]|0);aEa(c[a+484>>2]|0);aEa(c[a+476>>2]|0);aEa(c[a+468>>2]|0);aEa(c[a+464>>2]|0);aEa(c[a+432>>2]|0);aEa(c[a+436>>2]|0);aEa(c[a+320>>2]|0);aEa(c[a+516>>2]|0);aEa(c[a+520>>2]|0);tra(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;aEa(x);i=b;return}else{y=a;z=0}while(1){Faa(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;aEa(x);i=b;return}function Kca(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[10191]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];D9(8,0,81536,d);i=b;return}function Lca(a,b){a=+a;b=+b;i=i;return a<=b|0}function Mca(a,b){a=+a;b=+b;i=i;return a>b|0}function Nca(a,b){a=+a;b=+b;i=i;return a>=b|0}function Oca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=$Da(k)|0;c[e+(h*40|0)+24>>2]=$Da(k)|0;if((c[g>>2]|0)!=1){l=5;break}Rca(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){H9(c[a+536>>2]|0,81592,d)}else if((l|0)==6){i=b;return 0}return 0}function Pca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){aEa(c[e+(h*40|0)+20>>2]|0);aEa(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;Sca(k)|0;aEa(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){H9(c[a+536>>2]|0,81592,d)}else if((j|0)==6){i=b;return 0}return 0}function Qca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[49924>>2]|c[12462]|0)==0){z=w;A=1;break}rra(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];F9(17,1,81624,g);rra(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;rra(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;F9(17,0,81656,f);rra(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[12602]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function Rca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=$Da(20)|0;c[b>>2]=f;G9(0,(f|0)!=0|0,81664,e);e=$Da(a)|0;c[f>>2]=e;e=$Da(a)|0;c[f+4>>2]=e;e=$Da(a)|0;c[f+8>>2]=e;e=$Da(a)|0;c[f+16>>2]=e;G9(0,(c[b>>2]|0)!=0|0,81696,d);i=d;return 0}function Sca(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;aEa(c[d>>2]|0);aEa(c[d+4>>2]|0);aEa(c[d+8>>2]|0);aEa(c[d+16>>2]|0);i=b;return 0}function Tca(a,b){a=a|0;b=b|0;b=i;i=i+8|0;H9(c[a+536>>2]|0,81744,b);return 0}function Uca(a){a=a|0;a=i;i=i+8|0;H9(0,81744,a);return 0}function Vca(a,b){a=a|0;b=b|0;b=i;i=i+8|0;H9(c[a+536>>2]|0,81744,b);return 0}function Wca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=$Da(l)|0;c[e+(h<<6)+36>>2]=$Da(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;dda(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=$Da(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;ada(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){H9(c[a+536>>2]|0,81784,d)}else if((n|0)==8){i=b;return 0}return 0}function Xca(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function Yca(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function Zca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){aEa(c[e+(h<<6)+28>>2]|0);aEa(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){bda(e+(h<<6)+24|0)|0;aEa(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){eda(e+(h<<6)+24|0)|0}else{k=6;break}aEa(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){H9(c[a+536>>2]|0,81784,d)}else if((k|0)==8){i=b;return 0}return 0}function _ca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=fda(b,d)|0}else if((h|0)==1){j=cda(b,d)|0}else{H9(c[b+536>>2]|0,81784,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function $ca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[49916>>2]|c[12462]|0)==0){z=w;A=1;break}rra(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];F9(15,1,81816,g);rra(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;rra(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;F9(15,0,81848,f);rra(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[12602]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function ada(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=$Da(12)|0;f=$Da(a<<2)|0;c[e>>2]=f;G9(0,(f|0)!=0|0,81856,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function bda(a){a=a|0;var b=0;b=i;aEa(c[c[a>>2]>>2]|0);i=b;return 0}function cda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;HEa(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ge[c[x>>2]&127](C,D);ge[c[w+(d<<6)+4>>2]&127](C,D);if((c[49920>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;D9(16,1,81912,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,81936,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;D9(16,0,81952,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;D9(16,1,81960,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,81936,o|0)|0;c[n>>2]=D;D9(16,0,81952,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;D9(16,1,81960,s)}}while(0);fe[c[12602]&511](16)}s=w+(d<<6)+36|0;A=y+8|0;q4(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;F9(1,0,81976,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;FEa(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;FEa(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;F9(1,0,82064,l);if((c[49916>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;FEa(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hc(l|0,82168,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hc(l|0,82168,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;FEa(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hc(l|0,82168,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;FEa(M|0,O|0,Q|0)|0;i=e;return F|0}function dda(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=$Da(32)|0;G9(0,(g|0)!=0|0,82176,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Yd(0,d|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;Yd(0,g+4|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Lb(82224,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function eda(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;zd(c[d+12>>2]|0)|0;Kb(c[d+8>>2]|0)|0;Kb(c[d+4>>2]|0)|0;i=b;return 0}function fda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;ld(c[g>>2]|0)|0;Ud(0,g|0)|0;j=g+24|0;Pb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ge[c[f>>2]&127](k,a);Vc(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;ge[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){gd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(mc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Jb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;ld(c[g>>2]|0)|0;i=d;return l|0}function gda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;G9(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,82392,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){G9(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,82432,e);if((ie[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=$Da(p)|0;c[g+(m*80|0)+52>>2]=$Da(p)|0;c[g+(m*80|0)+48>>2]=$Da(p)|0;c[g+(m*80|0)+16>>2]=$Da(p)|0;c[g+(m*80|0)+8>>2]=$Da(p)|0;c[g+(m*80|0)+12>>2]=$Da(p)|0;ge[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){tda(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==3){tda(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){lda(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){Tca(a,n)|0;break}else{q=12;break a}}}while(0);n=m+1|0;if((n|0)<(c[h>>2]|0)){m=n}else{q=14;break}}if((q|0)==12){H9(c[j>>2]|0,82472,d)}else if((q|0)==14){i=b;return 0}return 0}function hda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;aEa(c[e+(h*80|0)+44>>2]|0);aEa(c[e+(h*80|0)+52>>2]|0);aEa(c[e+(h*80|0)+48>>2]|0);aEa(c[e+(h*80|0)+16>>2]|0);aEa(c[e+(h*80|0)+8>>2]|0);aEa(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;uda(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;uda(m)|0;l=m;break}else if((k|0)==1){m=e+(h*80|0)+40|0;mda(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);aEa(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){Uca(j)|0}else if((n|0)==9){H9(c[a+536>>2]|0,82472,d)}else if((n|0)==11){i=b;return 0}return 0}function ida(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(wda(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==3){j=(wda(b,d)|0)&255;break}else if((k|0)==2){j=(Vca(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=nda(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{H9(c[b+536>>2]|0,82472,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function jda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;rra(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];E9(17,1,u,82504,m);do{if((a[b+312|0]|0)==0){rra(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;rra(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;F9(17,0,82704,f);rra(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{F9(17,1,82544,l);rra(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;rra(q,d,c[v>>2]|0);if((zEa(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];F9(17,0,82624,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;rra(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;F9(17,0,82664,g);G=E}rra(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[49924>>2]|c[12462]|0)==0){break}fe[c[12602]&511](17)}}while(0);if((c[49924>>2]|c[12462]|0)==0){x=1;i=e;return x|0}fe[c[12602]&511](17);x=1;i=e;return x|0}function kda(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function lda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=$Da(144)|0;c[b>>2]=f;G9(0,(f|0)!=0|0,82720,e);c[f>>2]=0;e=a<<3;g=$Da(e)|0;c[f+4>>2]=g;g=$Da(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=$Da(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=$Da(e)|0;c[f+24>>2]=g;g=bEa(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=$Da(e)|0;c[f+64>>2]=g;g=$Da(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=bEa(g,8)|0;c[f+104>>2]=j;j=bEa(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=$Da(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=$Da(e)|0;c[f+124>>2]=j;j=$Da(e)|0;c[f+128>>2]=j;j=$Da(e)|0;c[f+132>>2]=j;j=$Da(e)|0;c[f+136>>2]=j;j=$Da(e)|0;c[f+140>>2]=j;G9(0,(c[b>>2]|0)!=0|0,82752,d);i=d;return 0}function mda(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;aEa(c[d+4>>2]|0);aEa(c[d+16>>2]|0);aEa(c[d+12>>2]|0);aEa(c[d+24>>2]|0);aEa(c[d+28>>2]|0);aEa(c[d+64>>2]|0);aEa(c[d+68>>2]|0);aEa(c[d+104>>2]|0);aEa(c[d+108>>2]|0);aEa(c[d+116>>2]|0);aEa(c[d+124>>2]|0);aEa(c[d+128>>2]|0);aEa(c[d+132>>2]|0);aEa(c[d+136>>2]|0);aEa(c[d+140>>2]|0);i=b;return 0}function nda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=$Da(c[Y>>2]|0)|0;if((c[49924>>2]|0)!=0){rra(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];D9(17,1,82792,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];D9(17,1,82848,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];D9(17,0,82864,F);fe[c[12602]&511](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}fe[c[12602]&511](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){FEa(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{FEa(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+td(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;oda($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+td(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[49928>>2]|0)!=0){pda(c[Q>>2]|0,$,18,82904);pda(c[ca>>2]|0,$,18,82936)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[49928>>2]|0)!=0){pda(c[ca>>2]|0,$,18,82968)}a[da]=R;Gba(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){rra(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];$aa(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;oda($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;oda($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}uca(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[49928>>2]|0)!=0){D9(18,1,83008,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];D9(18,1,83048,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];D9(18,0,83080,C);fe[c[12602]&511](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[12602]&511](18)}if((c[49932>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;D9(19,1,83112,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hc(Ja|0,83136,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;D9(19,0,83144,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[12602]&511](19)}h[K>>3]=+Fba($,c[Ia>>2]|0);h[J>>3]=+Fba($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}FEa(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];D9(17,0,83192,w);qda(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}D9(17,0,83264,v);qda(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+td(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}D9(17,0,83328,u);qda(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+td(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}D9(17,0,83400,t);qda(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}FEa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;FEa(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}D9(17,0,83464,s);qda(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){FEa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}D9(17,0,83536,r);qda(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}D9(17,0,83608,q);qda(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}D9(17,0,83680,p);qda(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){FEa(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}D9(17,0,83744,o);qda(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}D9(17,0,83816,n);qda(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];D9(17,0,83952,l);qda(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){FEa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{FEa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}D9(17,0,83880,m);qda(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[49924>>2]|0)!=0){D9(17,1,83152,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;D9(17,0,83168,x);fe[c[12602]&511](17);qda(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}FEa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;oda($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;aEa(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;aEa(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;aEa(Z);i=e;return kb|0}if((a[Ha]|0)==0){rra(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];$aa(0,f,hb);}if((c[49924>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;D9(17,0,84024,j);qda(S,L,J,K,17)}FEa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;aEa(Z);i=e;return kb|0}return 0}function oda(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[49936>>2]|0)!=0){D9(20,0,84376,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){sda(w,f,d,e,m)}else{rda(w,f,m)}do{if((c[49936>>2]|0)!=0){D9(20,0,84416,r);if((c[49932>>2]|0)==0){break}w=v;s=c[b>>2]|0;c[q>>2]=s;c[q+4>>2]=s;D9(19,1,83112,q);s=c[b>>2]|0;if((s|0)>0){C=y+20|0;D=s;s=0;do{a[w]=0;if((D|0)>0){E=0;do{F=+h[f+((fa(c[C>>2]|0,s)|0)+E<<3)>>3];c[p>>2]=w;G=p+4|0;h[k>>3]=F;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];hc(w|0,84448,p|0)|0;E=E+1|0;}while((E|0)<(c[b>>2]|0))}c[o>>2]=w;D9(19,0,83144,o);s=s+1|0;D=c[b>>2]|0;}while((s|0)<(D|0))}fe[c[12602]&511](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else if((A|0)==1){z=y+8|0;do{if((c[z>>2]|0)!=0){B=c[b>>2]|0;if((B|0)<=0){break}o=c[y+12>>2]|0;p=0;do{f=d+(p<<3)|0;h[f>>3]=+h[f>>3]*+h[o+(p<<3)>>3];p=p+1|0;}while((p|0)<(B|0))}}while(0);if((c[49936>>2]|0)!=0){c[u>>2]=c[y+96>>2];D9(20,0,84272,u);pda(d,b,20,84304)}Ie[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[49936>>2]|0)!=0){pda(e,b,20,84320);c[t>>2]=c[y+96>>2];D9(20,0,84336,t)}if((c[z>>2]|0)==0){i=g;return 0}z=c[b>>2]|0;if((z|0)<=0){i=g;return 0}b=c[y+12>>2]|0;y=0;do{t=d+(y<<3)|0;h[t>>3]=1.0/+h[b+(y<<3)>>3]*+h[t>>3];y=y+1|0;}while((y|0)<(z|0));i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;H9(g,84464,n)}return 0}function pda(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[49856+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;D9(d,1,83144,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];D9(d,0,84256,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}fe[c[12602]&511](d);i=f;return}function qda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[49856+(f<<2)>>2]|0)==0){i=g;return}D9(f,1,84064,q);D9(f,1,84080,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];D9(f,0,84096,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}fe[c[12602]&511](f);D9(f,1,84136,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];D9(f,0,84152,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}fe[c[12602]&511](f);D9(f,1,84192,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];D9(f,0,84208,j);fe[c[12602]&511](f);fe[c[12602]&511](f);i=g;return}function rda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;HEa(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;HEa(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function sda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+td(+(n*+td(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;oda(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function tda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=$Da(80)|0;c[b>>2]=f;G9(0,(f|0)!=0|0,84544,e);c[f>>2]=0;e=a<<3;g=$Da(e)|0;c[f+4>>2]=g;g=$Da(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=$Da(e)|0;c[f+16>>2]=g;g=bEa(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=$Da(fa(e,a)|0)|0;c[f+64>>2]=g;g=$Da(e)|0;c[f+68>>2]=g;g=$Da(a<<2)|0;c[f+72>>2]=g;G9(0,(c[b>>2]|0)!=0|0,84576,d);i=d;return 0}function uda(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;aEa(c[d+4>>2]|0);aEa(c[d+8>>2]|0);aEa(c[d+16>>2]|0);aEa(c[d+20>>2]|0);aEa(c[d+64>>2]|0);aEa(c[d+68>>2]|0);aEa(c[d+72>>2]|0);i=b;return 0}function vda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;HEa(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function wda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;FEa(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[49924>>2]|0)==0){J=b+4|0}else{rra(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];D9(17,1,84616,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];D9(17,1,84688,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];D9(17,0,84704,t);fe[c[12602]&511](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}fe[c[12602]&511](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];xda(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){rra(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];$aa(3,g,P);}$=+Fba(H,c[b>>2]|0);aa=+Fba(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){FEa(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;D9(17,0,84880,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;D9(17,0,84936,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;D9(17,0,85e3,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[49924>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;D9(17,0,84752,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];D9(17,0,84792,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];D9(17,0,84848,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){rra(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];$aa(0,f,L);if((c[49924>>2]|0)==0){da=0;break}c[m>>2]=V;D9(17,0,85080,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(17,0,84792,l);if((c[49924>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(17,0,84848,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[49924>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;FEa(ma|0,oa|0,qa|0)|0;i=e;return da|0}fe[c[12602]&511](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;FEa(ma|0,oa|0,qa|0)|0;i=e;return da|0}function xda(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[49928>>2]|0)!=0){c[z>>2]=j;D9(18,0,85120,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];D9(18,0,85168,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){yda(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){zda(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{vda(E,m,r)|0}if((c[49932>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;D9(19,1,85184,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hc(F|0,85208,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;D9(19,0,85216,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}fe[c[12602]&511](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+Fba(b,_);if(!(!(J<=H)&!(+Fba(b,e)<=H))){$=31;break}q4(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;F9(17,0,85224,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;F9(17,0,85256,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+Fba(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function yda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ie[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function zda(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+td(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;yda(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function Ada(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){te[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;Cda(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==2){Bda(a,b);f=0;i=d;return f|0}else if((e|0)==3){f=Xba(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function Bda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[85288+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[85288+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ie[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function Cda(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function Dda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=K9(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=$Da(88)|0;D9(23,0,85320,e);j=Vba(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[998]|0;g=$Da(j<<2)|0;c[21336]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=bEa(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[21336]|0;g=n}}else if((f|0)==2){g=$Da(8)|0;c[g+4>>2]=4;m=$Da(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=bEa(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);Qda(b)|0;if((c[2]|0)==0){i=e;return k|0}Yaa(6);Vaa(1);i=e;return k|0}function Eda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){Wba(c[b+48>>2]|0)|0}else if((e|0)==4){f=c[998]|0;g=c[21336]|0;if((f|0)>0){h=g;j=0;while(1){aEa(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[21336]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}aEa(m)}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){aEa(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}aEa(n);aEa(c[e>>2]|0)}Rda(a)|0;Lda(a);i=d;return 0}function Fda(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(275,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=QEa(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=QEa(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=QEa(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=QEa(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=QEa(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(276,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=QEa(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=QEa(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;CEa(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=QEa(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=QEa(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,85352,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=QEa(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=QEa(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,85448,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=QEa(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[91568>>2]|0,91544,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=QEa(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,85504,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=QEa(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(277,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=QEa(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function Gda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];D9(8,0,85600,G);I=b+313|0;a[I]=1;tca(b);if((c[106876>>2]|0)==0){ge[c[91564>>2]&127](91544,b)}a[I]=0}}while(0);if((e|0)!=0){Hda(Ad(e|0)|0,b)}if((c[49956>>2]|0)==0){i=f;return 0}Yaa(0);D9(25,0,85648,F);D9(25,1,85672,E);H=+Qaa(6);J=+Qaa(6);K=J/+Qaa(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];D9(25,0,85680,D);K=+Qaa(1);H=+Qaa(1);J=H/+Qaa(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D9(25,0,85720,C);J=+Qaa(2);K=+Qaa(2);H=K/+Qaa(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];D9(25,0,85752,B);H=+Qaa(3);J=+Qaa(3);K=J/+Qaa(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];D9(25,0,85776,A);K=+Qaa(4);H=+Qaa(4);J=H/+Qaa(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(25,0,85816,z);J=+Qaa(7);K=+Qaa(7);H=K/+Qaa(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(25,0,85848,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Qaa(0);J=H- +Qaa(7);H=J- +Qaa(4);J=H- +Qaa(3);H=J- +Qaa(2);J=H- +Qaa(1);H=J- +Qaa(6);J=+Qaa(0);K=J- +Qaa(7);J=K- +Qaa(4);K=J- +Qaa(3);J=K- +Qaa(2);K=J- +Qaa(1);J=K- +Qaa(6);K=J/+Qaa(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(25,0,85912,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];D9(25,0,85880,x)}K=+Qaa(0);H=+Qaa(0);J=H/+Qaa(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];D9(25,0,85944,v);fe[c[12602]&511](25);D9(25,1,85968,u);c[t>>2]=c[d+40>>2];D9(25,0,85976,t);c[s>>2]=c[d+44>>2];D9(25,0,86e3,s);fe[c[12602]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);D9(25,1,86024,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];D9(25,0,86040,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];D9(25,0,86056,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];D9(25,0,86088,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];D9(25,0,86120,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];D9(25,0,86144,m);fe[c[12602]&511](25)}else if((s|0)!=5){D9(25,1,86176,l);D9(25,0,86184,j);fe[c[12602]&511](25)}D9(25,0,86248,g);Vaa(0);i=f;return 0}



function iDa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;pDa(m,c[p>>2]|0)|0;pDa(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=pDa(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 91:{R=Q+1|0;c[q>>2]=R;S=$Da(128)|0;if((S|0)==0){T=12;U=294;break b}if((a[R]|0)==94){V=Q+2|0;c[q>>2]=V;W=V;X=1}else{W=R;X=0}R=(X|0)==0;V=S;S=0;Y=0;Z=32;_=W;e:while(1){$=a[_]|0;if($<<24>>24==93){if(_>>>0>(c[q>>2]|0)>>>0){U=85;break}}else if($<<24>>24==0){aa=V;ba=_;ca=7;U=140;break}$=dDa(e,_,-1)|0;if(($|0)<0){c[e>>2]=-1;da=1}else{da=$}$=_+da|0;do{if((a[$]|0)==45){ea=da+1|0;fa=_+ea|0;if((a[fa]|0)==93){U=94;break}ga=c[e>>2]|0;ha=dDa(e,fa,-1)|0;if((ha|0)<0){c[e>>2]=-1;ia=-1;ja=1}else{ia=c[e>>2]|0;ja=ha}ka=0;la=ia;ma=ga;na=_+(ja+ea)|0;oa=ga>>>0>ia>>>0?11:0}else{U=94}}while(0);f:do{if((U|0)==94){U=0;ga=a[_]|0;do{if(ga<<24>>24==45){if((a[_+1|0]|0)==93){pa=0;break}pa=(c[q>>2]|0)==(_|0)?0:11}else if(ga<<24>>24==91){ea=a[_+1|0]|0;if(ea<<24>>24==61|ea<<24>>24==46){aa=V;ba=_;ca=3;U=140;break e}else if(!(ea<<24>>24==58)){pa=0;break}ea=_+2|0;ha=ea;while(1){fa=a[ha]|0;qa=fa<<24>>24==0;if(fa<<24>>24!=58&(qa^1)){ha=ha+1|0}else{break}}if(qa){aa=V;ba=_;ca=4;U=140;break e}fa=ha-_+ -2|0;ra=(fa|0)>63?63:fa;OEa(A|0,ea|0,ra|0)|0;a[f+ra|0]=0;ra=PCa(A)|0;ka=ra;la=1114111;ma=0;na=ha+2|0;oa=(ra|0)==0?4:0;break f}else{pa=0}}while(0);ga=c[e>>2]|0;ka=0;la=ga;ma=ga;na=$;oa=pa}}while(0);if((oa|0)!=0){aa=V;ba=na;ca=oa;U=140;break}$=(ka|0)!=0;do{if(R|$^1){ga=c[w>>2]|0;if((Y|0)<(Z|0)){sa=V;ta=Z}else{if((Z|0)>1024){aa=V;ba=na;ca=12;U=140;break e}ra=cEa(V,Z<<3)|0;if((ra|0)==0){aa=V;ba=na;ca=12;U=140;break e}else{sa=ra;ta=Z<<1}}ra=zDa(ga,0,0,1,32)|0;if((ra|0)==0){U=112;break e}fa=zDa(ga,0,0,1,20)|0;ga=ra+4|0;c[ga>>2]=fa;if((fa|0)==0){U=112;break e}c[ra>>2]=0;c[ra+8>>2]=-1;c[ra+12>>2]=-1;c[fa>>2]=ma;c[fa+4>>2]=la;c[fa+8>>2]=-1;c[sa+(Y<<2)>>2]=ra;c[(c[ga>>2]|0)+12>>2]=ka;ua=sa;va=S;wa=Y+1|0;xa=ta;ya=0}else{if((S|0)>63){ua=V;va=S;wa=Y;xa=Z;ya=12;break}c[g+(S<<2)>>2]=ka;ua=V;va=S+1|0;wa=Y;xa=Z;ya=0}}while(0);ga=(ya|0)==0;if(ga&(((c[v>>2]&2|0)==0|$)^1)){za=ua;Aa=wa;Ba=xa;Ca=ma}else{if(ga){V=ua;S=va;Y=wa;Z=xa;_=na;continue}else{aa=ua;ba=na;ca=ya;U=140;break}}while(1){ga=Ca;while(1){if(ga>>>0>la>>>0){V=za;S=va;Y=Aa;Z=Ba;_=na;continue e}if((SCa(ga)|0)!=0){U=118;break}Da=ga+1|0;if((WCa(ga)|0)==0){ga=Da}else{U=129;break}}if((U|0)==118){U=0;ra=YCa(ga)|0;fa=ga+1|0;g:do{if((SCa(fa)|0)==0){Ea=ra;Fa=fa}else{Ga=ra;Ha=fa;while(1){if((YCa(Ha)|0)!=(Ga+1|0)|Ha>>>0>la>>>0){Ea=Ga;Fa=Ha;break g}Ia=YCa(Ha)|0;Ja=Ha+1|0;if((SCa(Ja)|0)==0){Ea=Ia;Fa=Ja;break}else{Ga=Ia;Ha=Ja}}}}while(0);fa=c[w>>2]|0;if((Aa|0)<(Ba|0)){Ka=za;La=Ba}else{if((Ba|0)>1024){aa=za;ba=na;ca=12;U=140;break e}Ha=cEa(za,Ba<<3)|0;if((Ha|0)==0){aa=za;ba=na;ca=12;U=140;break e}else{Ka=Ha;La=Ba<<1}}Ha=zDa(fa,0,0,1,32)|0;Ga=Ha;do{if((Ha|0)==0){Ma=0}else{ha=zDa(fa,0,0,1,20)|0;c[Ha+4>>2]=ha;if((ha|0)==0){Ma=0;break}c[Ha>>2]=0;c[Ha+8>>2]=-1;c[Ha+12>>2]=-1;c[ha>>2]=ra;c[ha+4>>2]=Ea;c[ha+8>>2]=-1;Ma=Ga}}while(0);c[Ka+(Aa<<2)>>2]=Ma;Na=Ma;Oa=Ka;Pa=La;Qa=Fa}else if((U|0)==129){U=0;Ga=_Ca(ga)|0;h:do{if((WCa(Da)|0)==0){Ra=Ga;Sa=Da}else{ra=Ga;Ha=Da;while(1){if((_Ca(Ha)|0)!=(ra+1|0)|Ha>>>0>la>>>0){Ra=ra;Sa=Ha;break h}fa=Ha+1|0;ha=_Ca(Ha)|0;if((WCa(fa)|0)==0){Ra=ha;Sa=fa;break}else{ra=ha;Ha=fa}}}}while(0);ga=c[w>>2]|0;if((Aa|0)<(Ba|0)){Ta=za;Ua=Ba}else{if((Ba|0)>1024){aa=za;ba=na;ca=12;U=140;break e}Ha=cEa(za,Ba<<3)|0;if((Ha|0)==0){aa=za;ba=na;ca=12;U=140;break e}else{Ta=Ha;Ua=Ba<<1}}Ha=zDa(ga,0,0,1,32)|0;ra=Ha;do{if((Ha|0)==0){Va=0}else{fa=zDa(ga,0,0,1,20)|0;c[Ha+4>>2]=fa;if((fa|0)==0){Va=0;break}c[Ha>>2]=0;c[Ha+8>>2]=-1;c[Ha+12>>2]=-1;c[fa>>2]=Ga;c[fa+4>>2]=Ra;c[fa+8>>2]=-1;Va=ra}}while(0);c[Ta+(Aa<<2)>>2]=Va;Na=Va;Oa=Ta;Pa=Ua;Qa=Sa}if((Na|0)==0){U=141;break e}else{za=Oa;Aa=Aa+1|0;Ba=Pa;Ca=Qa}}}i:do{if((U|0)==85){U=0;c[q>>2]=_+1;Z=(X|0)!=0;if(Z){cc(V|0,Y|0,4,62)}j:do{if((Y|0)>0){R=(S|0)>0;$=S<<2;ra=$+4|0;if(Z){Wa=0;Xa=0;Ya=0;Za=0}else{Ga=0;Ha=0;while(1){ga=V+(Ga<<2)|0;fa=c[(c[ga>>2]|0)+4>>2]|0;do{if((fa|0)==0){_a=Ha;$a=0}else{c[fa+8>>2]=c[x>>2];if(R){ha=zDa(c[w>>2]|0,0,0,0,ra)|0;ea=fa+16|0;c[ea>>2]=ha;if((ha|0)==0){ab=V;bb=Ha;cb=12;break i}FEa(ha|0,z|0,$|0)|0;c[(c[ea>>2]|0)+(S<<2)>>2]=0}else{c[fa+16>>2]=0}if((Ha|0)==0){_a=c[ga>>2]|0;$a=0;break}ea=c[w>>2]|0;ha=c[ga>>2]|0;Ja=zDa(ea,0,0,1,32)|0;Ia=Ja;do{if((Ja|0)==0){db=0}else{eb=zDa(ea,0,0,1,8)|0;fb=Ja+4|0;c[fb>>2]=eb;if((eb|0)==0){db=0;break}c[Ja>>2]=3;c[Ja+8>>2]=-1;c[Ja+12>>2]=-1;c[eb>>2]=Ha;c[(c[fb>>2]|0)+4>>2]=ha;c[Ja+16>>2]=(c[ha+16>>2]|0)+(c[Ha+16>>2]|0);db=Ia}}while(0);_a=db;$a=(db|0)==0?12:0}}while(0);ga=Ga+1|0;if((ga|0)<(Y|0)&($a|0)==0){Ga=ga;Ha=_a}else{gb=0;hb=_a;ib=$a;break j}}}while(1){Ha=V+(Ya<<2)|0;Ga=c[(c[Ha>>2]|0)+4>>2]|0;ga=c[Ga>>2]|0;fa=Ga+4|0;Ia=c[fa>>2]|0;do{if((ga|0)<(Wa|0)){ha=Ia+1|0;jb=(ha|0)<(Wa|0)?Wa:ha;kb=Xa;lb=Za;mb=0}else{if((ga|0)<=(Xa|0)){ha=Ia+1|0;jb=ha;kb=ha;lb=Za;mb=0;break}c[Ga>>2]=Xa;c[fa>>2]=ga+ -1;ha=Ia+1|0;if((Ga|0)==0){jb=ha;kb=ha;lb=Za;mb=0;break}c[Ga+8>>2]=c[x>>2];if(R){Ja=zDa(c[w>>2]|0,0,0,0,ra)|0;ea=Ga+16|0;c[ea>>2]=Ja;if((Ja|0)==0){ab=V;bb=Za;cb=12;break i}FEa(Ja|0,z|0,$|0)|0;c[(c[ea>>2]|0)+(S<<2)>>2]=0}else{c[Ga+16>>2]=0}if((Za|0)==0){jb=ha;kb=ha;lb=c[Ha>>2]|0;mb=0;break}ea=c[w>>2]|0;Ja=c[Ha>>2]|0;fb=zDa(ea,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){nb=0}else{ob=zDa(ea,0,0,1,8)|0;pb=fb+4|0;c[pb>>2]=ob;if((ob|0)==0){nb=0;break}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[ob>>2]=Za;c[(c[pb>>2]|0)+4>>2]=Ja;c[fb+16>>2]=(c[Ja+16>>2]|0)+(c[Za+16>>2]|0);nb=eb}}while(0);jb=ha;kb=ha;lb=nb;mb=(nb|0)==0?12:0}}while(0);Ha=Ya+1|0;if((Ha|0)<(Y|0)&(mb|0)==0){Wa=jb;Xa=kb;Ya=Ha;Za=lb}else{gb=kb;hb=lb;ib=mb;break}}}else{gb=0;hb=0;ib=0}}while(0);if((ib|0)!=0|Z^1){ab=V;bb=hb;cb=ib;break}$=c[w>>2]|0;ra=c[x>>2]|0;R=zDa($,0,0,1,32)|0;Ha=R;if((R|0)==0){ab=V;bb=hb;cb=12;break}Ga=zDa($,0,0,1,20)|0;c[R+4>>2]=Ga;if((Ga|0)==0){ab=V;bb=hb;cb=12;break}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Ga>>2]=gb;c[Ga+4>>2]=1114111;c[Ga+8>>2]=ra;if((S|0)>0){ra=S<<2;$=zDa(c[w>>2]|0,0,0,0,ra+4|0)|0;Ia=Ga+16|0;c[Ia>>2]=$;if(($|0)==0){ab=V;bb=hb;cb=12;break}FEa($|0,z|0,ra|0)|0;c[(c[Ia>>2]|0)+(S<<2)>>2]=0}else{c[Ga+16>>2]=0}if((hb|0)==0){ab=V;bb=Ha;cb=0;break}Ga=c[w>>2]|0;Ia=zDa(Ga,0,0,1,32)|0;ra=Ia;do{if((Ia|0)==0){qb=0}else{$=zDa(Ga,0,0,1,8)|0;ga=Ia+4|0;c[ga>>2]=$;if(($|0)==0){qb=0;break}c[Ia>>2]=3;c[Ia+8>>2]=-1;c[Ia+12>>2]=-1;c[$>>2]=hb;c[(c[ga>>2]|0)+4>>2]=Ha;c[Ia+16>>2]=(c[R+16>>2]|0)+(c[hb+16>>2]|0);qb=ra}}while(0);ab=V;bb=qb;cb=(qb|0)==0?12:0}else if((U|0)==112){U=0;c[sa+(Y<<2)>>2]=0;aa=sa;ba=na;ca=12;U=140}else if((U|0)==141){U=0;c[q>>2]=na;ab=Oa;bb=0;cb=12}}while(0);if((U|0)==140){U=0;c[q>>2]=ba;ab=aa;bb=0;cb=ca}aEa(ab);c[x>>2]=(c[x>>2]|0)+1;if((cb|0)==0){rb=M;sb=bb;tb=0;break c}else{T=cb;U=294;break b}break};case 92:{Y=Q+1|0;V=a[Y]|0;do{if((c[v>>2]&1|0)==0){if(V<<24>>24==40){c[q>>2]=Y;ub=Y;U=74;break d}else{S=a[Q+1|0]|0;if(S<<24>>24==41){U=265;break d}else{vb=S;break}}}else{vb=V}}while(0);V=Q+1|0;Y=vb<<24>>24==0;if(Y){T=5;U=294;break b}else{wb=138964|0;xb=0}while(1){S=xb+1|0;if((a[138960+(xb<<3)|0]|0)==vb<<24>>24){yb=wb;break}_=138964+(S<<3)|0;if((S|0)==12){yb=_;break}else{wb=_;xb=S}}S=c[yb>>2]|0;if((S|0)!=0){_=F+0|0;ra=G+0|0;R=_+40|0;do{c[_>>2]=c[ra>>2];_=_+4|0;ra=ra+4|0}while((_|0)<(R|0));c[H>>2]=S;c[I>>2]=1;ra=iDa(j)|0;if((ra|0)!=0){T=ra;U=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];rb=M;sb=c[K>>2]|0;tb=0;break c}if(Y){T=5;U=294;break b}c[q>>2]=V;ra=a[V]|0;k:do{switch(ra|0){case 120:{_=Q+2|0;c[q>>2]=_;R=a[_]|0;if(R<<24>>24==123){_=Q+3|0;c[q>>2]=_;Ia=_;_=0;while(1){Ha=a[Ia]|0;if(Ha<<24>>24==0|Ha<<24>>24==125){zb=_;Ab=Ia;break}if((XCa(Ha<<24>>24)|0)==0){T=9;U=294;break b}Ha=c[q>>2]|0;a[l+_|0]=a[Ha]|0;Ga=_+1|0;Z=Ha+1|0;c[q>>2]=Z;if(Ga>>>0>31){zb=Ga;Ab=Z;break}else{Ia=Z;_=Ga}}c[q>>2]=Ab+1;a[l+zb|0]=0;_=Vb(C|0,0,16)|0;Ia=c[w>>2]|0;Ga=c[x>>2]|0;Z=zDa(Ia,0,0,1,32)|0;Ha=Z;do{if((Z|0)==0){Bb=0}else{ga=zDa(Ia,0,0,1,20)|0;c[Z+4>>2]=ga;if((ga|0)==0){Bb=0;break}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ga>>2]=_;c[ga+4>>2]=_;c[ga+8>>2]=Ga;Bb=Ha}}while(0);c[x>>2]=(c[x>>2]|0)+1;Cb=Bb;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ha=(XCa(R<<24>>24)|0)==0;Ga=c[q>>2]|0;if(Ha){Db=Ga}else{a[D]=a[Ga]|0;Ha=Ga+1|0;c[q>>2]=Ha;Db=Ha}if((XCa(a[Db]|0)|0)!=0){Ha=c[q>>2]|0;a[E]=a[Ha]|0;c[q>>2]=Ha+1}Ha=Vb(D|0,0,16)|0;Ga=c[w>>2]|0;_=c[x>>2]|0;Z=zDa(Ga,0,0,1,32)|0;Ia=Z;do{if((Z|0)==0){Eb=0}else{ga=zDa(Ga,0,0,1,20)|0;c[Z+4>>2]=ga;if((ga|0)==0){Eb=0;break}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ga>>2]=Ha;c[ga+4>>2]=Ha;c[ga+8>>2]=_;Eb=Ia}}while(0);c[x>>2]=(c[x>>2]|0)+1;Cb=Eb;break k}break};case 62:{Ia=c[w>>2]|0;_=zDa(Ia,0,0,1,32)|0;Ha=_;do{if((_|0)==0){Fb=0}else{Z=zDa(Ia,0,0,1,20)|0;c[_+4>>2]=Z;if((Z|0)==0){Fb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Z>>2]=-2;c[Z+4>>2]=32;c[Z+8>>2]=-1;Fb=Ha}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Fb;break};case 60:{Ha=c[w>>2]|0;_=zDa(Ha,0,0,1,32)|0;Ia=_;do{if((_|0)==0){Gb=0}else{Z=zDa(Ha,0,0,1,20)|0;c[_+4>>2]=Z;if((Z|0)==0){Gb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Z>>2]=-2;c[Z+4>>2]=16;c[Z+8>>2]=-1;Gb=Ia}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Gb;break};case 66:{Ia=c[w>>2]|0;_=zDa(Ia,0,0,1,32)|0;Ha=_;do{if((_|0)==0){Hb=0}else{Z=zDa(Ia,0,0,1,20)|0;c[_+4>>2]=Z;if((Z|0)==0){Hb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Z>>2]=-2;c[Z+4>>2]=128;c[Z+8>>2]=-1;Hb=Ha}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Hb;break};case 98:{Ha=c[w>>2]|0;_=zDa(Ha,0,0,1,32)|0;Ia=_;do{if((_|0)==0){Ib=0}else{Z=zDa(Ha,0,0,1,20)|0;c[_+4>>2]=Z;if((Z|0)==0){Ib=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Z>>2]=-2;c[Z+4>>2]=64;c[Z+8>>2]=-1;Ib=Ia}}while(0);c[q>>2]=(c[q>>2]|0)+1;Cb=Ib;break};default:{if((QCa(ra)|0)!=0){Ia=(a[c[q>>2]|0]|0)+ -48|0;_=c[w>>2]|0;Ha=c[x>>2]|0;Z=zDa(_,0,0,1,32)|0;if((Z|0)==0){T=12;U=294;break b}Ga=zDa(_,0,0,1,20)|0;c[Z+4>>2]=Ga;if((Ga|0)==0){T=12;U=294;break b}c[Z>>2]=0;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[Ga>>2]=-4;c[Ga+4>>2]=Ia;c[Ga+8>>2]=Ha;c[x>>2]=(c[x>>2]|0)+1;Ha=c[B>>2]|0;c[B>>2]=(Ia|0)<(Ha|0)?Ha:Ia;c[q>>2]=(c[q>>2]|0)+1;rb=M;sb=Z;tb=0;break c}Z=c[w>>2]|0;Ia=a[c[q>>2]|0]|0;Ha=c[x>>2]|0;Ga=zDa(Z,0,0,1,32)|0;_=Ga;do{if((Ga|0)==0){Jb=0}else{R=zDa(Z,0,0,1,20)|0;c[Ga+4>>2]=R;if((R|0)==0){Jb=0;break}c[Ga>>2]=0;c[Ga+8>>2]=-1;c[Ga+12>>2]=-1;c[R>>2]=Ia;c[R+4>>2]=Ia;c[R+8>>2]=Ha;Jb=_}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Cb=Jb}}}while(0);if((Cb|0)==0){T=12;U=294;break b}else{rb=M;sb=Cb;tb=0;break c}break};case 40:{if((c[v>>2]&1|0)!=0){ub=Q;U=74}break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}ra=c[w>>2]|0;V=zDa(ra,0,0,1,32)|0;if((V|0)==0){T=12;U=294;break b}Y=zDa(ra,0,0,1,20)|0;c[V+4>>2]=Y;if((Y|0)==0){T=12;U=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Y>>2]=-2;c[Y+4>>2]=2;c[Y+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;rb=M;sb=V;tb=0;break c;break};case 63:case 43:case 123:case 124:case 42:{U=264;break};case 0:{U=265;break};case 41:{if((M|0)!=0){U=264}break};case 46:{V=(c[v>>2]&4|0)==0;Y=c[w>>2]|0;ra=c[x>>2]|0;S=zDa(Y,0,0,1,32)|0;_=S;Ha=(S|0)==0;if(V){if(Ha){T=12;U=294;break b}V=zDa(Y,0,0,1,20)|0;c[S+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[V>>2]=0;c[V+4>>2]=1114111;c[V+8>>2]=ra;Kb=_;Lb=(c[x>>2]|0)+1|0}else{if(Ha){T=12;U=294;break b}Ha=zDa(Y,0,0,1,20)|0;c[S+4>>2]=Ha;if((Ha|0)==0){T=12;U=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[Ha>>2]=0;c[Ha+4>>2]=9;c[Ha+8>>2]=ra;ra=c[w>>2]|0;Ha=(c[x>>2]|0)+1|0;Y=zDa(ra,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}V=zDa(ra,0,0,1,20)|0;c[Y+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[V>>2]=11;c[V+4>>2]=1114111;c[V+8>>2]=Ha;Ha=c[w>>2]|0;V=zDa(Ha,0,0,1,32)|0;if((V|0)==0){T=12;U=294;break b}ra=zDa(Ha,0,0,1,8)|0;Ha=V+4|0;c[Ha>>2]=ra;if((ra|0)==0){T=12;U=294;break b}c[V>>2]=3;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ra>>2]=_;c[(c[Ha>>2]|0)+4>>2]=Y;c[V+16>>2]=(c[Y+16>>2]|0)+(c[S+16>>2]|0);Kb=V;Lb=(c[x>>2]|0)+2|0}c[x>>2]=Lb;c[q>>2]=(c[q>>2]|0)+1;rb=M;sb=Kb;tb=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}V=pDa(m,5)|0;if((V|0)!=0){Mb=M;Nb=V;U=6;break b}}V=c[w>>2]|0;S=zDa(V,0,0,1,32)|0;if((S|0)==0){T=12;U=294;break b}Y=zDa(V,0,0,1,20)|0;c[S+4>>2]=Y;if((Y|0)==0){T=12;U=294;break b}c[S>>2]=0;c[S+8>>2]=-1;c[S+12>>2]=-1;c[Y>>2]=-2;c[Y+4>>2]=1;c[Y+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;rb=M;sb=S;tb=0;break c;break};default:{}}}while(0);if((U|0)==74){U=0;S=M+1|0;c[q>>2]=ub+1;Y=pDa(m,c[y>>2]|0)|0;if((Y|0)!=0){Mb=S;Nb=Y;U=6;break b}Y=pDa(m,2)|0;if((Y|0)!=0){Mb=S;Nb=Y;U=6;break b}Y=pDa(m,0)|0;if((Y|0)!=0){Mb=S;Nb=Y;U=6;break b}c[y>>2]=(c[y>>2]|0)+1;rb=S;sb=N;tb=0;break c}else if((U|0)==264){U=0;if((c[v>>2]&1|0)!=0){U=265}}if((U|0)==265){U=0;S=c[w>>2]|0;Y=zDa(S,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}V=zDa(S,0,0,1,20)|0;c[Y+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[V>>2]=-1;c[V+4>>2]=-1;c[V+8>>2]=-1;rb=M;sb=Y;tb=0;break c}Y=dDa(h,Q,-1)|0;if((Y|0)<0){c[h>>2]=-1;Ob=1}else{Ob=Y}do{if((c[v>>2]&2|0)==0){U=280}else{if((WCa(c[h>>2]|0)|0)==0){if((SCa(c[h>>2]|0)|0)==0){U=280;break}}Y=c[w>>2]|0;V=YCa(c[h>>2]|0)|0;S=YCa(c[h>>2]|0)|0;Ha=c[x>>2]|0;_=zDa(Y,0,0,1,32)|0;if((_|0)==0){T=12;U=294;break b}ra=zDa(Y,0,0,1,20)|0;c[_+4>>2]=ra;if((ra|0)==0){T=12;U=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[ra>>2]=V;c[ra+4>>2]=S;c[ra+8>>2]=Ha;Ha=c[w>>2]|0;ra=_Ca(c[h>>2]|0)|0;S=_Ca(c[h>>2]|0)|0;V=c[x>>2]|0;Y=zDa(Ha,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}Ia=zDa(Ha,0,0,1,20)|0;c[Y+4>>2]=Ia;if((Ia|0)==0){T=12;U=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ia>>2]=ra;c[Ia+4>>2]=S;c[Ia+8>>2]=V;V=c[w>>2]|0;Ia=zDa(V,0,0,1,32)|0;if((Ia|0)==0){T=12;U=294;break b}S=zDa(V,0,0,1,8)|0;V=Ia+4|0;c[V>>2]=S;if((S|0)==0){T=12;U=294;break b}c[Ia>>2]=3;c[Ia+8>>2]=-1;c[Ia+12>>2]=-1;c[S>>2]=_;c[(c[V>>2]|0)+4>>2]=Y;c[Ia+16>>2]=(c[Y+16>>2]|0)+(c[_+16>>2]|0);Pb=Ia}}while(0);if((U|0)==280){U=0;Q=c[w>>2]|0;Ia=c[h>>2]|0;_=c[x>>2]|0;Y=zDa(Q,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}V=zDa(Q,0,0,1,20)|0;c[Y+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[V>>2]=Ia;c[V+4>>2]=Ia;c[V+8>>2]=_;Pb=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Ob;rb=M;sb=Pb;tb=0;break};case 0:{if((c[v>>2]&1|0)!=0){Y=pDa(m,7)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}}rb=M;sb=N;tb=pDa(m,3)|0;break};case 4:{Y=pDa(m,9)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}rb=M;sb=N;tb=pDa(m,1)|0;break};case 6:{Y=L+ -2|0;c[n>>2]=Y;_=c[P+(Y<<2)>>2]|0;Y=c[w>>2]|0;V=zDa(Y,0,0,1,32)|0;if((V|0)==0){T=12;U=294;break b}Ia=zDa(Y,0,0,1,8)|0;Y=V+4|0;c[Y>>2]=Ia;if((Ia|0)==0){T=12;U=294;break b}c[V>>2]=1;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Ia>>2]=_;c[(c[Y>>2]|0)+4>>2]=N;c[V+16>>2]=(c[N+16>>2]|0)+(c[_+16>>2]|0);rb=M;sb=V;tb=0;break};case 8:{V=L+ -2|0;c[n>>2]=V;_=c[P+(V<<2)>>2]|0;V=c[w>>2]|0;Y=zDa(V,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}Ia=zDa(V,0,0,1,8)|0;V=Y+4|0;c[V>>2]=Ia;if((Ia|0)==0){T=12;U=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ia>>2]=_;c[(c[V>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[_+16>>2]|0);rb=M;sb=Y;tb=0;break};case 3:{Y=pDa(m,5)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}rb=M;sb=N;tb=pDa(m,4)|0;break};case 10:{Y=L+ -2|0;c[n>>2]=Y;c[v>>2]=c[P+(Y<<2)>>2];rb=M;sb=N;tb=0;break};case 2:{Y=L+ -2|0;c[n>>2]=Y;_=c[P+(Y<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Y=c[w>>2]|0;V=zDa(Y,0,0,1,32)|0;if((V|0)==0){T=12;U=294;break b}Ia=zDa(Y,0,0,1,20)|0;c[V+4>>2]=Ia;if((Ia|0)==0){T=12;U=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Ia>>2]=-1;c[Ia+4>>2]=-1;c[Ia+8>>2]=-1;Ia=c[w>>2]|0;Y=zDa(Ia,0,0,1,32)|0;if((Y|0)==0){T=12;U=294;break b}Q=zDa(Ia,0,0,1,8)|0;Ia=Y+4|0;c[Ia>>2]=Q;if((Q|0)==0){T=12;U=294;break b}c[Y>>2]=1;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=V;c[(c[Ia>>2]|0)+4>>2]=N;Ia=N+16|0;Q=Y+16|0;c[Q>>2]=(c[Ia>>2]|0)+(c[V+16>>2]|0);c[Q>>2]=c[Ia>>2];Qb=Y}else{Qb=N}c[Qb+12>>2]=_;_=Qb+16|0;c[_>>2]=(c[_>>2]|0)+1;rb=M;sb=Qb;tb=0;break};case 7:{_=c[q>>2]|0;Y=a[_]|0;if((Y|0)==41){c[q>>2]=_+1;rb=M;sb=N;tb=0;break c}else if((Y|0)!=124){rb=M;sb=N;tb=0;break c}Y=pDa(m,7)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}Y=pDa(m,N)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}Y=pDa(m,8)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}Y=pDa(m,3)|0;if((Y|0)!=0){Mb=M;Nb=Y;U=6;break b}c[q>>2]=(c[q>>2]|0)+1;rb=M;sb=N;tb=0;break};case 9:{Y=c[q>>2]|0;_=a[Y]|0;switch(_<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){rb=M;sb=N;tb=0;break c}else{U=41}break};case 42:{U=41;break};case 92:{Ia=c[v>>2]|0;if((Ia&1|0)!=0){rb=M;sb=N;tb=0;break c}Q=Y+1|0;if((a[Q]|0)!=123){rb=M;sb=N;tb=0;break c}c[q>>2]=Q;Rb=Ia;Sb=Q;break};case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){rb=M;sb=N;tb=0;break c}else{Rb=Q;Sb=Y}break};default:{rb=M;sb=N;tb=0;break c}}if((U|0)==41){U=0;c[q>>2]=Y+1;Y=c[w>>2]|0;Q=zDa(Y,0,0,1,32)|0;if((Q|0)==0){T=12;U=294;break b}Ia=zDa(Y,0,0,1,16)|0;c[Q+4>>2]=Ia;if((Ia|0)==0){T=12;U=294;break b}c[Q>>2]=2;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Ia>>2]=N;c[Ia+4>>2]=_<<24>>24==43;c[Ia+8>>2]=_<<24>>24==63?1:-1;_=Ia+12|0;a[_]=a[_]&-2;c[Q+16>>2]=c[N+16>>2];rb=M;sb=Q;tb=pDa(m,9)|0;break c}Q=Sb+1|0;c[q>>2]=Q;_=a[Q]|0;if((_+ -48<<24>>24&255)<10){Ia=_<<24>>24;if((Ia+ -48|0)>>>0<10){Tb=Ia;Ub=-1;Wb=Q}else{T=10;U=294;break b}while(1){Ia=((Ub|0)<0?-48:(Ub*10|0)+ -48|0)+Tb|0;Y=Wb+1|0;V=a[Y]|0;S=V<<24>>24;if((S+ -48|0)>>>0<10){Wb=Y;Ub=Ia;Tb=S}else{Xb=V;Yb=Ia;Zb=Y;break}}}else{Xb=_;Yb=-1;Zb=Q}do{if(Xb<<24>>24==44){Y=Zb+1|0;Ia=a[Y]|0;V=Ia<<24>>24;if((V+ -48|0)>>>0<10){_b=V;$b=-1;ac=Y}else{bc=Ia;dc=-1;ec=Y;break}while(1){Y=(($b|0)<0?-48:($b*10|0)+ -48|0)+_b|0;Ia=ac+1|0;V=a[Ia]|0;S=V<<24>>24;if((S+ -48|0)>>>0<10){ac=Ia;$b=Y;_b=S}else{fc=V;gc=Y;hc=Ia;U=54;break}}}else{fc=Xb;gc=Yb;hc=Zb;U=54}}while(0);do{if((U|0)==54){U=0;if(!((gc|0)>-1)){bc=fc;dc=gc;ec=hc;break}if((Yb|0)>(gc|0)|(gc|0)>255){T=10;U=294;break b}else{bc=fc;dc=gc;ec=hc}}}while(0);if(bc<<24>>24==0){T=9;U=294;break b}if((ec|0)==(Q|0)){T=10;U=294;break b}if((Rb&1|0)==0){if(!(bc<<24>>24==92)){T=10;U=294;break b}if((a[ec+1|0]|0)!=125){T=10;U=294;break b}ic=ec+2|0}else{if(!(bc<<24>>24==125)){T=10;U=294;break b}ic=ec+1|0}if((dc|Yb|0)==0){_=c[w>>2]|0;Ia=zDa(_,0,0,1,32)|0;if((Ia|0)==0){T=12;U=294;break b}Y=zDa(_,0,0,1,20)|0;c[Ia+4>>2]=Y;if((Y|0)==0){T=12;U=294;break b}c[Ia>>2]=0;c[Ia+8>>2]=-1;c[Ia+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;jc=Ia}else{Ia=(dc&Yb|0)<0;Y=c[w>>2]|0;_=zDa(Y,0,0,1,32)|0;if((_|0)==0){T=12;U=294;break b}V=zDa(Y,0,0,1,16)|0;c[_+4>>2]=V;if((V|0)==0){T=12;U=294;break b}c[_>>2]=2;c[_+8>>2]=-1;c[_+12>>2]=-1;c[V>>2]=N;c[V+4>>2]=Ia?1:Yb;c[V+8>>2]=Ia?1:dc;Ia=V+12|0;a[Ia]=a[Ia]&-2;c[_+16>>2]=c[N+16>>2];jc=_}c[q>>2]=ic;rb=M;sb=jc;tb=pDa(m,9)|0;break};case 5:{_=c[q>>2]|0;Ia=a[_]|0;if(Ia<<24>>24==0){rb=M;sb=N;tb=0;break c}V=c[v>>2]&1;Y=(V|0)!=0;if(Y&Ia<<24>>24==124){rb=M;sb=N;tb=0;break c}do{if(!(Y&Ia<<24>>24==41&(M|0)>0)){if((V|0)==0&Ia<<24>>24==92){if((a[_+1|0]|0)==41){break}}S=pDa(m,5)|0;if((S|0)!=0){Mb=M;Nb=S;U=6;break b}S=pDa(m,N)|0;if((S|0)!=0){Mb=M;Nb=S;U=6;break b}S=pDa(m,6)|0;if((S|0)!=0){Mb=M;Nb=S;U=6;break b}rb=M;sb=N;tb=pDa(m,4)|0;break c}}while(0);Ia=(V|M|0)==0?8:0;Y=M+ -1|0;if((V|0)!=0){rb=Y;sb=N;tb=Ia;break c}c[q>>2]=_+2;rb=Y;sb=N;tb=Ia;break};default:{rb=M;sb=N;tb=0}}}while(0);P=c[n>>2]|0;O=(tb|0)==0;if((P|0)>(o|0)&O){L=P;M=rb;N=sb}else{kc=O;lc=rb;mc=sb;nc=tb;break a}}if((U|0)==6){kc=(Nb|0)==0;lc=Mb;mc=N;nc=Nb;break}else if((U|0)==294){i=d;return T|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){T=p?8:nc;i=d;return T|0}c[b+8>>2]=mc;T=0;i=d;return T|0}function jDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=$Da((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=$Da((l<<2)+4|0)|0;if((p|0)==0){aEa(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}pDa(d,e)|0;e=pDa(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 1:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(k){E=c[(c[c[F+4>>2]>>2]|0)+20>>2]|0;G=u+ -3|0;c[h>>2]=G;c[F+20>>2]=(c[D+(G<<2)>>2]|0)+E;H=v;I=-1;J=x;K=y;L=z;M=A;N=0;O=B;break b}else{E=u+ -3|0;c[h>>2]=E;G=c[D+(E<<2)>>2]|0;E=u+ -4|0;c[h>>2]=E;F=(G|0)==0;H=F&1;I=F?w:c[D+(E<<2)>>2]|0;J=x;K=y;L=z;M=A;N=0;O=B;break b}break};case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{P=A+(E<<2)|0;E=E+1|0}while((c[P>>2]|0)>-1);c[P>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;G=0;while(1){if((c[p+(G<<2)>>2]|0)>-1){G=G+1|0}else{break}}c[p+(G+ -1<<2)>>2]=-1;H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 2:{E=A;while(1){if((c[E>>2]|0)>-1){E=E+4|0}else{H=v;I=w;J=x;K=y;L=z;M=E;N=0;O=B;break}}break};case 0:{E=u+ -2|0;c[h>>2]=E;G=c[D+(E<<2)>>2]|0;E=G;F=G+12|0;Q=c[F>>2]|0;if((Q|0)>-1){R=0;do{S=A+(R<<2)|0;R=R+1|0}while((c[S>>2]|0)>-1);c[S>>2]=Q<<1;c[A+(R<<2)>>2]=-1;do{if(!k){T=0;while(1){if((c[p+(T<<2)>>2]|0)>-1){T=T+1|0}else{break}}c[(c[s>>2]|0)+(Q*12|0)+8>>2]=0;if((T|0)<=0){break}U=$Da((T<<2)+4|0)|0;V=U;if((U|0)==0){W=w;X=y;Y=z;Z=A;_=12;$=B;break a}c[(c[s>>2]|0)+(Q*12|0)+8>>2]=V;aa=c[p>>2]|0;if((aa|0)>-1){ba=V;ca=aa;aa=0;while(1){c[ba>>2]=ca;da=aa+1|0;ea=c[p+(da<<2)>>2]|0;fa=U+(da<<2)|0;if((ea|0)>-1){aa=da;ca=ea;ba=fa}else{ga=fa;break}}}else{ga=V}c[ga>>2]=-1}}while(0);Q=pDa(d,c[F>>2]|0)|0;if((Q|0)!=0){W=w;X=y;Y=z;Z=A;_=Q;$=B;break a}Q=pDa(d,6)|0;if((Q|0)!=0){W=w;X=y;Y=z;Z=A;_=Q;$=B;break a}}Q=c[G>>2]|0;do{if((Q|0)==3){R=c[G+4>>2]|0;ba=c[R>>2]|0;ca=c[R+4>>2]|0;R=(c[A>>2]|0)>-1;aa=x+1|0;U=pDa(d,R?aa:x)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=pDa(d,R?x:B)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=pDa(d,A)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=pDa(d,(c[A>>2]|0)>>>31^1)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=pDa(d,G)|0;if((U|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=U;na=B;break}U=ca;ca=pDa(d,U)|0;if((ca|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ca;na=B;break}ca=ba;ba=pDa(d,ca)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,3)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,U)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,0)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,2)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,ca)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}ba=pDa(d,0)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}if((c[A>>2]|0)>-1){if(k){oa=w;pa=y;qa=0}else{ba=rDa(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ca=c[t>>2]|0;U=0;while(1){ra=ca+(U<<2)|0;sa=U+1|0;if((c[ra>>2]|0)>-1){U=sa}else{break}}c[ra>>2]=B;c[ca+(sa<<2)>>2]=w;c[ca+(U+2<<2)>>2]=-1;ta=-1;ua=y+1|0}else{ta=w;ua=y}V=c[A>>2]|0;if((V|0)>-1){R=c[s>>2]|0;T=V;V=0;do{fa=(T|0)/2|0;if((T&1|0)==0){c[R+(fa*12|0)>>2]=B}else{c[R+(fa*12|0)+4>>2]=B}V=V+1|0;T=c[A+(V<<2)>>2]|0;}while((T|0)>-1)}c[A>>2]=-1;oa=ta;pa=ua;qa=ba}c[A>>2]=-1;va=oa;wa=aa;xa=pa;ya=z+1|0;za=qa;Aa=x}else{va=w;wa=x;xa=y;ya=z;za=0;Aa=B}if((c[G+16>>2]|0)<=0){ha=v;ia=va;ja=wa;ka=xa;la=ya;ma=za;na=Aa;break}ha=v;ia=va;ja=wa+2|0;ka=xa;la=ya;ma=za;na=wa+1|0}else if((Q|0)==0){T=c[c[G+4>>2]>>2]|0;if(!((T|0)>-1|(T|0)==-4)){ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}if(!((c[A>>2]|0)>-1)){ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}if(k){c[G+20>>2]=1;Ba=w;Ca=y;Da=0}else{T=rDa(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){V=c[t>>2]|0;R=0;while(1){Ea=V+(R<<2)|0;Fa=R+1|0;if((c[Ea>>2]|0)>-1){R=Fa}else{break}}c[Ea>>2]=B;c[V+(Fa<<2)>>2]=w;c[V+(R+2<<2)>>2]=-1;Ga=-1;Ha=y+1|0}else{Ga=w;Ha=y}aa=c[A>>2]|0;if((aa|0)>-1){ba=c[s>>2]|0;U=aa;aa=0;do{ca=(U|0)/2|0;if((U&1|0)==0){c[ba+(ca*12|0)>>2]=B}else{c[ba+(ca*12|0)+4>>2]=B}aa=aa+1|0;U=c[A+(aa<<2)>>2]|0;}while((U|0)>-1)}c[A>>2]=-1;Ba=Ga;Ca=Ha;Da=T}c[A>>2]=-1;ha=v;ia=Ba;ja=x+1|0;ka=Ca;la=z+1|0;ma=Da;na=x}else if((Q|0)==2){U=c[G+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ia=1}else{Ia=a[U+12|0]&1}aa=pDa(d,Ia)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}}else{aa=pDa(d,B)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}aa=pDa(d,a[U+12|0]&1)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}}aa=pDa(d,G)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}aa=pDa(d,1)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}aa=pDa(d,c[U>>2]|0)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}aa=pDa(d,0)|0;if((aa|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=aa;na=B;break}if(!((c[A>>2]|0)>-1)){if((a[U+12|0]&1)==0){ha=0;ia=w;ja=x;ka=y;la=z;ma=0;na=B;break}}if(k){Ja=w;Ka=y;La=0}else{aa=rDa(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[U+12|0]&1)==0?v:1;if((w|0)>-1){U=c[t>>2]|0;ba=0;while(1){Ma=U+(ba<<2)|0;Na=ba+1|0;if((c[Ma>>2]|0)>-1){ba=Na}else{break}}c[Ma>>2]=B;c[U+(Na<<2)>>2]=w;c[U+(ba+2<<2)>>2]=-1;Oa=-1;Pa=y+1|0}else{Oa=w;Pa=y}T=c[A>>2]|0;if((T|0)>-1){R=c[s>>2]|0;V=T;T=0;do{ca=(V|0)/2|0;if((V&1|0)==0){c[R+(ca*12|0)>>2]=B}else{c[R+(ca*12|0)+4>>2]=B}T=T+1|0;V=c[A+(T<<2)>>2]|0;}while((V|0)>-1)}c[A>>2]=-1;Ja=Oa;Ka=Pa;La=aa}c[A>>2]=-1;ha=0;ia=Ja;ja=x+1|0;ka=Ka;la=z+1|0;ma=La;na=x}else if((Q|0)==1){V=c[G+4>>2]|0;T=c[V>>2]|0;R=c[V+4>>2]|0;V=pDa(d,G)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=pDa(d,5)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=pDa(d,R)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=pDa(d,0)|0;if((V|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=V;na=B;break}V=T+20|0;ba=pDa(d,(c[V>>2]|0)+x|0)|0;if((ba|0)!=0){ha=v;ia=w;ja=x;ka=y;la=z;ma=ba;na=B;break}if((c[V>>2]|0)>0){V=(c[R+20>>2]|0)>0;Qa=(V&1)+x|0;Ra=V?x:-1}else{Qa=x;Ra=-1}V=pDa(d,Ra)|0;if((V|0)!=0){ha=v;ia=w;ja=Qa;ka=y;la=z;ma=V;na=B;break}V=pDa(d,4)|0;if((V|0)!=0){ha=v;ia=w;ja=Qa;ka=y;la=z;ma=V;na=B;break}V=pDa(d,T)|0;if((V|0)!=0){ha=v;ia=w;ja=Qa;ka=y;la=z;ma=V;na=B;break}ha=v;ia=w;ja=Qa;ka=y;la=z;ma=pDa(d,0)|0;na=B}else{ha=v;ia=w;ja=x;ka=y;la=z;ma=0;na=B}}while(0);G=c[F>>2]|0;if((G|0)>-1){Sa=0}else{H=ha;I=ia;J=ja;K=ka;L=la;M=A;N=ma;O=na;break b}do{Ta=p+(Sa<<2)|0;Sa=Sa+1|0}while((c[Ta>>2]|0)>-1);c[Ta>>2]=G;c[p+(Sa<<2)>>2]=-1;H=ha;I=ia;J=ja;K=ka;L=la;M=A;N=ma;O=na;break};case 4:{F=u+ -2|0;c[h>>2]=F;Q=c[D+(F<<2)>>2]|0;F=u+ -3|0;c[h>>2]=F;H=v;I=w;J=c[D+(F<<2)>>2]|0;K=y;L=z;M=A;N=0;O=(Q|0)>-1?Q:B;break};case 5:{Q=u+ -2|0;c[h>>2]=Q;F=c[D+(Q<<2)>>2]|0;if(!k){H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break b}Q=c[F+4>>2]|0;c[F+20>>2]=(c[(c[Q+4>>2]|0)+20>>2]|0)+(c[(c[Q>>2]|0)+20>>2]|0);H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B;break};case 3:{Q=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;E=c[D+(u+ -4<<2)>>2]|0;V=u+ -5|0;c[h>>2]=V;if(k){T=c[E+4>>2]|0;R=E+16|0;c[E+20>>2]=(c[(c[T>>2]|0)+20>>2]|0)+(c[D+(V<<2)>>2]|0)+(c[(c[T+4>>2]|0)+20>>2]|0)+((c[R>>2]|0)>0?2:0);Ua=R;Va=c[h>>2]|0}else{Ua=E+16|0;Va=V}V=c[D+(Va+ -1<<2)>>2]|0;E=Va+ -2|0;c[h>>2]=E;R=c[D+(E<<2)>>2]|0;E=Va+ -3|0;c[h>>2]=E;T=c[D+(E<<2)>>2]|0;if((c[Ua>>2]|0)<=0){H=1;I=w;J=x;K=y;L=z;M=V;N=0;O=B;break b}if(k){Wa=0}else{sDa(b,Q,R)|0;c[(c[r>>2]|0)+(R<<2)>>2]=1;R=sDa(b,F,T)|0;c[(c[r>>2]|0)+(T<<2)>>2]=1;Wa=R}H=1;I=w;J=x;K=y;L=z+2|0;M=V;N=Wa;O=B;break};default:{H=v;I=w;J=x;K=y;L=z;M=A;N=0;O=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(N|0)==0){u=D;v=H;w=I;x=J;y=K;z=L;A=M;B=O}else{W=I;X=K;Y=L;Z=M;_=N;$=O;break a}}}else{W=-1;X=0;Y=0;Z=n;_=e;$=0}}while(0);do{if(k){Xa=X}else{e=c[Z>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;O=e;e=0;do{N=(O|0)/2|0;if((O&1|0)==0){c[n+(N*12|0)>>2]=$}else{c[n+(N*12|0)+4>>2]=$}e=e+1|0;O=c[Z+(e<<2)>>2]|0;}while((O|0)>-1)}c[Z>>2]=-1;if(!((W|0)>-1)){Xa=X;break}O=c[f+36>>2]|0;e=0;while(1){Ya=O+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=$;c[O+(Za<<2)>>2]=W;c[O+(e+2<<2)>>2]=-1;Xa=X+1|0}}while(0);c[f+48>>2]=Y;c[f+40>>2]=Y;c[f+44>>2]=Xa;aEa(m);aEa(p);o=_;i=g;return o|0}function kDa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=mDa(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==3){h=c[g+4>>2]|0;j=kDa(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=mDa(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=kDa(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function lDa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{aEa(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}aEa(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){aEa(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){aEa(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}aEa(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{aEa(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}aEa(m)}m=c[d+32>>2]|0;if((m|0)!=0){aEa(m)}m=c[d+20>>2]|0;if((m|0)!=0){aEa(m)}m=c[d+36>>2]|0;if((m|0)!=0){aEa(m)}aEa(d);i=b;return}function mDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=$Da(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){aEa(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=$Da((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function nDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=zDa(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=zDa(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=zDa(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function oDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=pDa(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==3){r=c[o+4>>2]|0;s=c[r>>2]|0;if((c[s+8>>2]|0)!=0){t=pDa(a,s)|0;break}s=c[r+4>>2]|0;if((c[s+8>>2]|0)==0){continue a}t=pDa(a,s)|0}else if((q|0)==0){s=c[o+4>>2]|0;r=c[s>>2]|0;if((r|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[s+4>>2];continue a}else if(!((r|0)==-3)){continue a}r=c[s+4>>2]|0;if(!((r|0)>-1)){continue a}b:do{if(!b){s=c[d>>2]|0;c:do{if((s|0)>-1){u=s;v=d;w=0;while(1){x=w+1|0;if((u|0)==(r|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((r|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=r;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=pDa(a,r)|0}else if((q|0)==1){r=c[o+4>>2]|0;s=pDa(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=pDa(a,c[r+4>>2]|0)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function pDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=cEa(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;pDa(a,b)|0;i=d;return 0}return 0}function qDa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;pDa(d,e)|0;e=pDa(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==2){y=c[u+4>>2]|0;x=pDa(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=pDa(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[y>>2]|0;D=c[y+4>>2]|0;E=c[y+8>>2]|0;F=a[y+12|0]|0;y=zDa(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}H=zDa(b,0,0,1,16)|0;I=y+4|0;c[I>>2]=H;if((H|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[H>>2]=x;c[H+4>>2]=D;c[H+8>>2]=E;E=H+12|0;a[E]=a[E]&-2|F&1;c[y+16>>2]=c[x+16>>2];c[t>>2]=y;A=s;B=r;t=c[I>>2]|0;s=A;r=B;continue b}else if((z|0)==1){I=c[u+4>>2]|0;y=c[I>>2]|0;x=I+4|0;F=c[x>>2]|0;E=zDa(b,0,0,1,32)|0;if((E|0)==0){G=29;break b}H=zDa(b,0,0,1,8)|0;D=E+4|0;c[D>>2]=H;if((H|0)==0){G=29;break b}c[E>>2]=1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[H>>2]=y;c[(c[D>>2]|0)+4>>2]=F;c[E+16>>2]=(c[F+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=E;E=c[D>>2]|0;c[E>>2]=0;D=E+4|0;c[D>>2]=0;y=pDa(d,c[x>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}y=pDa(d,0)|0;if((y|0)!=0){v=s;w=y;break a}y=pDa(d,D)|0;if((y|0)!=0){v=s;w=y;break a}y=pDa(d,1)|0;if((y|0)!=0){v=s;w=y;break a}y=pDa(d,c[I>>2]|0)|0;if((y|0)!=0){v=s;w=y;break a}J=r;K=s;L=E;M=pDa(d,0)|0}else if((z|0)==0){E=c[u+4>>2]|0;y=c[E+8>>2]|0;I=c[E>>2]|0;D=c[E+4>>2]|0;do{if((I|0)>-1|(I|0)==-4){N=r;O=D;P=I;Q=s+1|0;R=(c[g>>2]|0)+y|0}else{if(!((I|0)==-3)){N=r;O=D;P=I;Q=s;R=y;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=D;P=-3;Q=s;R=y;break}c[h+(D<<2)>>2]=1;N=0;O=D;P=-3;Q=s;R=y}}while(0);y=zDa(b,0,0,1,32)|0;D=y;do{if((y|0)==0){S=0}else{I=zDa(b,0,0,1,20)|0;c[y+4>>2]=I;if((I|0)==0){S=0;break}c[y>>2]=0;c[y+8>>2]=-1;c[y+12>>2]=-1;c[I>>2]=P;c[I+4>>2]=O;c[I+8>>2]=R;S=D}}while(0);c[t>>2]=S;D=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=D;break}c[k>>2]=R;J=N;K=Q;L=t;M=D}else if((z|0)==3){D=c[u+4>>2]|0;y=c[D>>2]|0;I=D+4|0;E=c[I>>2]|0;x=zDa(b,0,0,1,32)|0;if((x|0)==0){G=20;break b}F=zDa(b,0,0,1,8)|0;H=x+4|0;c[H>>2]=F;if((F|0)==0){G=20;break b}c[x>>2]=3;c[x+8>>2]=-1;c[x+12>>2]=-1;c[F>>2]=y;c[(c[H>>2]|0)+4>>2]=E;c[x+16>>2]=(c[E+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=x;x=c[H>>2]|0;H=pDa(d,c[I>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}H=pDa(d,0)|0;if((H|0)!=0){v=s;w=H;break a}H=pDa(d,x+4|0)|0;if((H|0)!=0){v=s;w=H;break a}H=pDa(d,1)|0;if((H|0)!=0){v=s;w=H;break a}H=pDa(d,c[D>>2]|0)|0;if((H|0)!=0){v=s;w=H;break a}J=r;K=s;L=x;M=pDa(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function rDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=zDa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=zDa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=zDa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=zDa(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function sDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=zDa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=zDa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=zDa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=zDa(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function tDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function uDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=139208}else{j=b;k=139208;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((DEa(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,139496,g|0)|0)+1|0;i=d;return h|0}function vDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=$Da(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=$Da(y)|0;if((z|0)==0){A=12;break}HEa(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=dDa(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((KCa(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((KCa(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((KCa(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((KCa(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(KCa(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(KCa(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(KCa(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(KCa(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){HEa(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=dDa(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((KCa(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((KCa(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((KCa(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((KCa(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(KCa(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(KCa(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(KCa(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(KCa(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((OCa(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=_Ca(X)|0;qb=_a+24|0;if((OCa(fb,c[qb>>2]|0)|0)!=0){break}fb=YCa(X)|0;if((OCa(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((OCa(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=YCa(X)|0;if((OCa(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=_Ca(X)|0;if((OCa(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}aEa(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=xDa(0,0)|0;if((S|0)==0){A=12;break}R=zDa(S,0,0,0,32)|0;Q=R;if((R|0)==0){yDa(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=$Da(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=$Da(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=$Da(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){HEa(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){HEa(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=dDa(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((KCa(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((KCa(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((KCa(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((KCa(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(KCa(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(KCa(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(KCa(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(KCa(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=zDa(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=zDa(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;wDa(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((AEa(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=dDa(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=dDa(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((KCa(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((KCa(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((KCa(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((KCa(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(KCa(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(KCa(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(KCa(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(KCa(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((OCa(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=_Ca(tc)|0;aa=Ca+24|0;if((OCa(qa,c[aa>>2]|0)|0)!=0){break}qa=YCa(tc)|0;if((OCa(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((OCa(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=YCa(tc)|0;if((OCa(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=_Ca(tc)|0;if((OCa(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=zDa(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=zDa(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){yDa(S);if((Eb|0)!=0){aEa(O)}if((Kb|0)!=0){aEa(Kb)}if((Lb|0)==0){A=12;break a}aEa(N);A=12;break a}else if((sa|0)==67){yDa(S);if((Eb|0)!=0){aEa(O)}if((Kb|0)!=0){aEa(Kb)}if((Lb|0)==0){A=12;break a}aEa(N);A=12;break a}else if((sa|0)==169){yDa(S);if((Eb|0)!=0){aEa(O)}if((Kb|0)!=0){aEa(Kb)}if((Lb|0)==0){A=12;break a}aEa(N);A=12;break a}else if((sa|0)==176){yDa(S);if((Eb|0)!=0){aEa(O)}if((Kb|0)!=0){aEa(Kb)}if((Lb|0)==0){A=12;break a}aEa(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);yDa(S);if((Jb|0)!=0){aEa(Jb)}if((Gb|0)!=0){aEa(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}aEa(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}wDa(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}aEa(m);p=A;i=g;return p|0}function wDa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function xDa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=bEa(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function yDa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;aEa(e);i=b;return}else{f=d}while(1){aEa(c[f>>2]|0);d=c[f+4>>2]|0;aEa(f);if((d|0)==0){break}else{f=d}}e=a;aEa(e);i=b;return}function zDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=$Da(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=$Da(p)|0;c[o>>2]=r;if((r|0)==0){aEa(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}HEa(m|0,0,h|0)|0;j=m;i=g;return j|0}function ADa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((BDa(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function BDa(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function CDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function DDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function EDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function FDa(a){a=a|0;i=i;return}function GDa(a){a=a|0;c[a>>2]=139512;i=i;return}function HDa(a){a=a|0;var b=0;b=i;zb(a|0);hEa(a);i=b;return}function IDa(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function JDa(a){a=a|0;i=i;return 139528}function KDa(a){a=a|0;i=i;return}function LDa(a){a=a|0;i=i;return}function MDa(a){a=a|0;i=i;return}function NDa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function ODa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function PDa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function QDa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=UDa(b,139640,139696,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ie[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function RDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function SDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ie[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function TDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ie[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ie[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function UDa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;re[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ce[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function VDa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;re[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ce[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ce[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function WDa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ce[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;re[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function XDa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function YDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;re[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;re[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function ZDa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;re[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function _Da(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}



function Hda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,86720)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(b|0,86728,y|0)|0;if((z|0)==0){C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,86744,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;wd(b|0,86760,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;wd(b|0,86768,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;wd(b|0,86776,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((zEa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,86744,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,86744,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((zEa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;wd(b|0,86760,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;wd(b|0,86760,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((zEa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;wd(b|0,86768,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;wd(b|0,86768,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((zEa(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;wd(b|0,86776,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];wd(b|0,86744,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;wd(b|0,86760,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;wd(b|0,86768,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((zEa(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;wd(b|0,86776,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,86720)|0;}while((d|0)!=0);C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}function Ida(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 18:{v=c[996]|0;do{if((v|0)!=0){if((zEa(v,86528)|0)!=0){break}c[u>>2]=4;break a}}while(0);D9(23,0,86552,o);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{F9(1,0,86272,r);w=1;i=m;return w|0};case 5:{F9(1,0,86344,q);w=1;i=m;return w|0};case 4:{v=c[996]|0;if((v|0)!=0){if((zEa(v,86384)|0)==0){break a}}D9(23,0,86400,p);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};default:{}}}while(0);p=Dda(a,s)|0;Ce[c[50756>>2]&7]()|0;do{if((p|0)==0){q=Fda(a,b,d,e,f,g)|0;Ce[c[50756>>2]&7]()|0;if((q|0)!=0){x=q;break}if((c[u>>2]|0)!=5){ge[c[91564>>2]&127](91544,a);Dca(a)}y=+h[a+248>>3];q=n;h[k>>3]=+h[a+240>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=n+8|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];D9(23,0,86680,n);q=xe[c[c[a+540>>2]>>2]&63](a,t)|0;Ce[c[50756>>2]&7]()|0;Gda(a,s,l)|0;Ce[c[50756>>2]&7]()|0;x=q}else{Ce[c[50756>>2]&7]()|0;x=p}}while(0);Eda(a,s)|0;w=x;i=m;return w|0}function Jda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){Kda(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ie[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){H9(c[a+536>>2]|0,86792,d)}else if((k|0)==6){Kda(a);i=b;return}}function Kda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;HEa(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Lda(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;aEa(c[f+(a*48|0)+28>>2]|0);aEa(c[f+(a*48|0)+32>>2]|0);aEa(c[f+(a*48|0)+16>>2]|0);aEa(c[f+(a*48|0)+20>>2]|0);aEa(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function Mda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=$Da(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=$Da(c[y>>2]<<2)|0;Nda(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;FEa(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;FEa(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((Uba(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=Oda(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){FEa(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;FEa(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;aEa(x);aEa(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;F9(5,1,86848,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(q|0,86880,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;F9(5,0,86888,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=50408;K=c[12602]|0;fe[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=86896;aa=$;H9(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];F9(5,0,86888,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=50408;K=c[12602]|0;fe[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=86896;aa=$;H9(O,aa,g);return 0}function Nda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;HEa(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function Oda(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=bEa(d,4)|0;r=bEa(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;aEa(q);aEa(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;aEa(q);aEa(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){aEa(q);aEa(r);i=o;return v|0}if((n|0)==0){v=-1;aEa(q);aEa(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(5,1,87e3,p);Pda(s,d,f,c[g>>2]|0,j,l,m);if((c[49876>>2]|0)==0){v=-1;aEa(q);aEa(r);i=o;return v|0}fe[c[12602]&511](5);v=-1;aEa(q);aEa(r);i=o;return v|0}function Pda(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;HEa(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];D9(5,0,87032,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function Qda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ic(87048,87072)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=dd(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((dd(n|0)|0)!=10);q=c[b+152>>2]|0;r=bEa(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=bEa(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=bEa(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Od(n|0,87080,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Od(n|0,87080,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=bEa(s,8)|0;x=v}}while(0);gc(87088,j|0)|0;gc(87144,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(87104,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gc(87128,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(87144)|0;Yc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function Rda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}aEa(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){aEa(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}aEa(l);i=d;return 0}function Sda(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function Tda(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+Uda(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[49892>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];D9(9,1,87208,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(9,0,87320,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}fe[c[12602]&511](9);g=1;i=b;return g|0}function Uda(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;hea(b);g=f+540|0;ie[c[(c[g>>2]|0)+84>>2]&127](f)|0;ie[c[(c[g>>2]|0)+36>>2]&127](f)|0;ie[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;xe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function Vda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+Uda(b,1.0);if((c[49892>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}D9(9,1,87344,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(9,0,87408,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(9,0,87368,s)}D9(9,1,87432,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;D9(9,0,87504,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];D9(9,0,87456,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;D9(9,0,87592,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(9,0,87528,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;D9(9,0,87680,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];D9(9,0,87624,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}fe[c[12602]&511](9);D9(9,1,87712,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ie[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;D9(9,0,87504,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];D9(9,0,87456,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}fe[c[12602]&511](9);fe[c[12602]&511](9);i=d;return}function Wda(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[49892>>2]|0)!=0){Eca(b,9)}if((c[49952>>2]|0)==0){i=d;return}D9(24,1,87736,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){D9(24,1,87776,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];D9(24,0,87800,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}fe[c[12602]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}D9(24,1,87856,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];D9(24,0,87880,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}fe[c[12602]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){D9(24,1,87912,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(24,0,87800,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}fe[c[12602]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){D9(24,1,87936,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;D9(24,0,87960,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}fe[c[12602]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){D9(24,1,88008,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?88080:88088;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?88080:88088;t=(a[(c[l>>2]|0)+n|0]|0)!=0?88080:88088;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;D9(24,0,88032,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}fe[c[12602]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){D9(24,1,88096,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;D9(24,0,88120,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}fe[c[12602]&511](24)}fe[c[12602]&511](24);i=d;return}function Xda(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;D9(9,0,88168,z);if((f|0)==0){Bca(b);Cca(b);C=6}else{if((a[f]|0)!=0){Yda(b,f,g)}Bca(b);Cca(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ie[c[(c[A>>2]|0)+84>>2]&127](b)|0;ie[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(zEa(d,89656)|0)==0|0;f=(zEa(d,89664)|0)==0;z=(zEa(d,89672)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;F9(1,0,88216,y);F9(1,0,88248,x);c[w>>2]=89656;c[w+4>>2]=89464;F9(1,0,88272,w);c[v>>2]=89664;c[v+4>>2]=89544;F9(1,0,88272,v);c[u>>2]=89672;c[u+4>>2]=89592;F9(1,0,88272,u);H9(c[b+536>>2]|0,88304,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(zEa(e,c[88328+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;F9(1,0,88360,s);F9(1,0,88248,r);t=1;do{u=c[88392+(t<<2)>>2]|0;c[q>>2]=c[88328+(t<<2)>>2];c[q+4>>2]=u;F9(1,0,88272,q);t=t+1|0;}while((t|0)<7);H9(c[b+536>>2]|0,88304,p)}}while(0);p=c[88288+(D<<2)>>2]|0;c[o>>2]=c[88200+(D<<2)>>2];c[o+4>>2]=p;D9(9,0,88424,o);o=(D|0)==2;if(o){p=c[88392+(F<<2)>>2]|0;c[n>>2]=c[88328+(F<<2)>>2];c[n+4>>2]=p;D9(9,0,88464,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Zda(b,F,j)|0;break}if((D|0)==3){_da(b,j);I=0;break}else{H9(c[b+536>>2]|0,88504,m)}}}while(0);if((jda(b,1)|0)!=0){J=-2;Wda(b);K=15;L=K;M=88528;N=M;D9(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kca(b,R,V);W=272;yca(b);X=278;Dca(b);Y=273;tca(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=281;zca(b);i=k;return J|0}if(($ca(b,1)|0)!=0){J=-3;Wda(b);K=15;L=K;M=88528;N=M;D9(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kca(b,R,V);W=272;yca(b);X=278;Dca(b);Y=273;tca(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=281;zca(b);i=k;return J|0}m=(Qca(b,1)|0)==0;J=m?I:-4;Wda(b);K=15;L=K;M=88528;N=M;D9(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];kca(b,R,V);W=272;yca(b);X=278;Dca(b);Y=273;tca(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=281;zca(b);i=k;return J|0}function Yda(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];D9(9,0,89688,z);z=kaa(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;H9(C,89728,y)}D9(9,0,89768,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=laa(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=bea(c[d+(C*112|0)+4>>2]|0)|0;E=laa(A,D)|0;aEa(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((AEa(E,89808,6)|0)==0){if((c[49892>>2]|0)==0){break}}else{D=AEa(E,89816,6)|0;if((c[49892>>2]|D|0)==0){break}}c[v>>2]=E;F9(9,0,89824,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;raa(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];D9(9,0,89792,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}D9(9,0,89880,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=laa(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=bea(c[G+(w*112|0)+4>>2]|0)|0;v=laa(A,F)|0;aEa(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];F9(9,0,89904,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;raa(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];D9(9,0,89792,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}D9(9,0,89960,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=laa(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=bea(c[t+(x*112|0)+4>>2]|0)|0;K=laa(A,C)|0;aEa(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];F9(9,0,89904,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;raa(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];D9(9,0,89792,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}D9(9,0,89984,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=laa(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=bea(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=laa(A,u)|0;aEa(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];F9(9,0,90032,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;raa(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;D9(9,0,90016,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}D9(9,0,90088,l);l=b+144|0;if((c[l>>2]|0)<=0){iaa(A);i=f;return}o=b+32|0;b=0;do{x=laa(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=bea(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=laa(A,n)|0;aEa(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];F9(9,0,90136,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;raa(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?88080:88088;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;D9(9,0,90120,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));iaa(A);i=f;return}function Zda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;jca(a,+h[a+240>>3]);yca(a);Dca(a);tca(a);Fca(a);Kda(a);uca(a);yca(a);e=$da(a,b,c)|0;Dca(a);tca(a);zca(a);Dca(a);i=d;return e|0}function _da(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;jca(b,+h[b+240>>3]);yca(b);Dca(b);Mda(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=bEa(c[y>>2]|0,8)|0;A=b+124|0;B=bEa(c[A>>2]|0,4)|0;C=b+128|0;D=bEa(c[C>>2]|0,1)|0;E=b+132|0;F=bEa(c[E>>2]|0,4)|0;G=b+536|0;G9(c[G>>2]|0,(z|0)!=0|0,88560,t);G9(c[G>>2]|0,(B|0)!=0|0,88560,s);G9(c[G>>2]|0,(D|0)!=0|0,88560,r);G9(c[G>>2]|0,(F|0)!=0|0,88560,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[49892>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];hc(x|0,88576,p|0)|0;p=ic(x|0,88592)|0;c[o>>2]=88608;wd(p|0,88600,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];wd(p|0,88600,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Sd(10,p|0)|0;H=p}D9(9,1,88616,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];D9(9,0,88640,l);if((c[49892>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(H|0,88664,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];wd(H|0,88664,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Sd(10,H|0)|0}if((jda(b,0)|0)!=0){break a}if(($ca(b,0)|0)!=0){break a}if((Qca(b,0)|0)!=0){break a}Gca(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);fe[c[12602]&511](9);if((c[49892>>2]|0)!=0){Yc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}aEa(z);aEa(B);aEa(D);aEa(F)}else{h[b+304>>3]=1.0;ie[c[w+80>>2]&127](b)|0}vca(b);if((Mda(b,1,1)|0)!=1){i=e;return}ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;vca(b);if((Mda(b,1,1)|0)!=1){i=e;return}F9(1,0,88672,f);i=e;return}function $da(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=cea(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){D9(9,0,88776,u);if((c[b+184>>2]|0)==0){xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}aEa(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){D9(9,0,88808,t);xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;aEa(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){D9(9,1,88880,s);t=$Da(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+Uda(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+Uda(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}D9(9,1,88904,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];D9(9,0,88928,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];D9(9,0,88928,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];D9(9,0,88928,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[49892>>2]|0)!=0){fe[c[12602]&511](9);fe[c[12602]&511](9)}aEa(t);dea(v);H=cea(b)|0;if((c[H>>2]|0)!=0){$=H;break}D9(9,0,88952,n);aEa(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}D9(9,0,88984,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){D9(9,0,89e3,l);aea($,d,1,e);Vda(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+Uda($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){aEa(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){aEa(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){aEa(v);c[l>>2]=0}aea($,d,0,e);Vda(b,$);+Uda($,1.0)}else{D9(9,0,89024,j)}D9(9,1,89048,g);Vda(b,$);b=Tda($)|0;if((c[49892>>2]|0)!=0){fe[c[12602]&511](9)}dea($);y=b;i=f;return y|0}function aea(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=$Da(c[p>>2]<<3)|0;r=q;s=+Uda(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;fea(a,r);aEa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=89176;F=E;D9(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;D9(9,0,89088,m);if(!t){eea(a)}switch(b|0){case 6:{G=14;break a;break};case 1:{H=mea(a)|0;break};case 5:{G=13;break a;break};case 4:{G=12;break a;break};case 3:{H=oea(a,n,e)|0;break};case 2:{H=kea(a)|0;break};default:{G=15;break a}}Dca(o);tca(o);zca(o);Dca(o);s=+Uda(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}D9(9,0,89136,k);Vda(o,a);K=s}else{D9(9,0,89152,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){jea(a)|0}else if((G|0)==13){jea(a)|0}else if((G|0)==14){iea(o,a,0)|0}else if((G|0)==15){H9(c[o+536>>2]|0,89112,l)}else if((G|0)==23){fea(a,r);aEa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=89176;F=E;D9(9,0,F,g);i=f;return}}function bea(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=DEa(b|0)|0;do{if((d|0)==0){e=$Da(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=$Da(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((yEa(e,90192,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;FEa(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((yEa(e,90192,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function cea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=$Da(64)|0;z=y;G9(0,(y|0)!=0|0,90200,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=bEa(Z,8)|0;c[E>>2]=y;G9(0,(y|0)!=0|0,90200,w);w=bEa(Z,8)|0;c[F>>2]=w;G9(0,(w|0)!=0|0,90200,v);v=bEa(Z,8)|0;c[G>>2]=v;G9(0,(v|0)!=0|0,90200,u);u=bEa(Z,8)|0;c[H>>2]=u;G9(0,(u|0)!=0|0,90200,t);t=bEa(Z,8)|0;c[I>>2]=t;G9(0,(t|0)!=0|0,90200,s);s=bEa(Z,4)|0;t=s;c[J>>2]=t;G9(0,(s|0)!=0|0,90200,r);D9(9,0,90216,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;D9(9,0,90240,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];D9(9,0,90328,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];D9(9,0,90376,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];D9(9,0,90432,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;D9(9,0,90488,l);c[j>>2]=ya;D9(9,0,90560,j);j=bEa(sa,8)|0;c[K>>2]=j;G9(0,(j|0)!=0|0,90200,g);g=$Da(sa<<3)|0;c[L>>2]=g;G9(0,(g|0)!=0|0,90200,f);f=$Da(ya<<3)|0;c[M>>2]=f;G9(0,(f|0)!=0|0,90200,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function dea(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+28>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+32>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+36>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+40>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+44>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+48>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+52>>2]|0;if((d|0)!=0){aEa(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;aEa(e);i=b;return}aEa(d);e=a;aEa(e);i=b;return}function eea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=bEa(o,8)|0;q=bEa(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=bEa(s,8)|0;u=bEa(s,8)|0;v=bEa(o,8)|0;w=bEa(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+Uda(b,1.0);s=c[n>>2]|0;if((s|0)>0){FEa(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+Uda(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){FEa(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;D9(9,0,90600,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}aEa(p);aEa(q);aEa(t);aEa(u);aEa(v);aEa(w);i=d;return}function fea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function gea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function hea(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function iea(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;H9(c[a+536>>2]|0,90672,d);return 0}function jea(a){a=a|0;a=i;i=i+8|0;H9(0,90704,a);return 0}function kea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[49892>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=bEa((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;G9(0,(n|0)!=0|0,90744,b);c[22690]=c[a+60>>2];c[22692]=c[a+48>>2];Lba(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;aEa(n);c[22690]=0;c[22692]=0;n=Tda(a)|0;i=b;return n|0}function lea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[22692];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[22690];h[d>>3]=+Uda(f,1.0);i=e;return}function mea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=$Da(x)|0;z=y;A=$Da(x)|0;x=A;G9(0,(y|0)!=0|0,90776,n);G9(0,(A|0)!=0|0,90776,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[49892>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+Uda(a,1.0);h[o>>3]=D;if(D!=0.0){c[22698]=c[a+60>>2];c[22700]=c[a+48>>2];Iba(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[22698]=0;c[22700]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];D9(9,0,90808,l)}D=+Uda(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];D9(9,0,90912,j);j=c[u>>2]|0;do{if((j|0)==4){F9(9,0,91144,d);F=-4;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];F9(9,0,90928,g);F=-1;i=b;return F|0}else if((j|0)==2){F9(9,0,91008,f);F=-2;i=b;return F|0}else if((j|0)==3){F9(9,0,91072,e);F=-3;i=b;return F|0}}while(0);F=Tda(a)|0;i=b;return F|0}function nea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[22700];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[22698];h[d>>3]=+Uda(f,1.0);i=e;return}function oea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;D9(9,1,91200,g);if((c[49892>>2]|0)==0){l=0}else{l=(k|0)/10|0}pea(a,d,k,l,b,j);c[f>>2]=c[j>>2];D9(9,0,91224,f);fe[c[12602]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=Tda(a)|0;if((b|0)==0){m=0;i=e;return m|0}F9(9,0,91240,e);m=b;i=e;return m|0}function pea(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=$Da(fa(N,M)|0)|0;P=$Da(M<<3)|0;Q=$Da(N)|0;R=Q;S=$Da(N)|0;T=S;V=$Da(N)|0;W=V;X=$Da(N)|0;Y=+h[f>>3];if((c[49892>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];hc(N|0,91288,I|0)|0;I=ic(N|0,91304)|0;c[H>>2]=91320;wd(I|0,91312,H|0)|0;c[G>>2]=91336;wd(I|0,91312,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];wd(I|0,91312,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Sd(10,I|0)|0;c[E>>2]=0;wd(I|0,91344,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(I|0,91352,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];wd(I|0,91352,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Sd(10,I|0)|0;Z=I}else{Z=0}G9(0,(O|0)!=0|0,91360,B);G9(0,(P|0)!=0|0,91360,A);G9(0,(Q|0)!=0|0,91360,z);G9(0,(S|0)!=0|0,91360,y);G9(0,(V|0)!=0|0,91360,x);G9(0,(X|0)!=0|0,91360,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{gea(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+Uda(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;gea(a,la);+Uda(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];D9(9,0,91376,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){HEa(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);gea(a,R);za=+Uda(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}FEa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}gea(a,T);if(+Uda(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}FEa(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}FEa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}gea(a,W);Ba=+Uda(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}gea(a,W);Ba=+Uda(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}FEa(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];D9(9,0,91416,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;wd(Z|0,91344,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wd(Z|0,91352,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(Z|0,91352,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];F9(9,0,91464,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];F9(9,0,91480,p);H9(0,91496,o)}gea(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){aEa(S);aEa(Q);aEa(V);aEa(X);aEa(P);aEa(O);i=j;return}c[n>>2]=ia;wd(Z|0,91344,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,91352,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,91352,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;Yc(Z|0)|0;aEa(S);aEa(Q);aEa(V);aEa(X);aEa(P);aEa(O);i=j;return}function qea(a,b){a=a|0;b=b|0;i=i;return}function rea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Vaa(3);Yaa(0);w=+Qaa(0);Vaa(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(v|0,91576,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];wd(v|0,91576,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(v|0,91576,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];wd(v|0,91584,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;wd(v|0,91584,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];wd(v|0,91592,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else if(p<<24>>24==1){break}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,91576,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,91576,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;wd(v|0,91584,l|0)|0;break}else{c[m>>2]=0-E;wd(v|0,91584,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;wd(v|0,91584,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;wd(v|0,91584,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Sd(10,v|0)|0;Yaa(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];wd(v|0,91592,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Sd(10,v|0)|0;Yaa(3);i=e;return}function sea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ic(c[r>>2]|0,91600)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;G9(t,(s|0)!=0|0,91608,q);c[p>>2]=91664;wd(s|0,91592,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=91672;wd(s|0,91592,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];wd(s|0,91592,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];wd(s|0,91592,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];wd(s|0,91592,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];wd(s|0,91592,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];wd(s|0,91592,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];wd(s|0,91592,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];wd(s|0,91592,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];wd(s|0,91592,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function tea(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Vaa(3);Yc(d|0)|0;Yaa(3);i=b;return}function uea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;lwa(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];mwa(p,f)|0;vea(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;wea(a,b,91688,c[j>>2]|0,c[g>>2]|0,o,8);aEa(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];mwa(p,e)|0;i=d;return}function vea(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=bEa(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;G9(c[b+536>>2]|0,(p|0)!=0|0,91968,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function wea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;Hea(a,b,d,e,f,h);kwa(l,g,fa(fa(f,e)|0,h)|0)|0;if(Hua(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];H9(l,91920,k)}else{i=j;return}}function xea(a){a=a|0;var b=0;b=i;if((zfa(a+4|0)|0)!=0){i=b;return}Kua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function yea(a){a=a|0;Rc(a|0)|0;Ya()}function zea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=fEa(320)|0;HEa(q|0,0,320)|0;Aea(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Vaa(3);t=a+8|0;u=Bea(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=Cea(a,b,u+s|0)|0;u=q+184|0;Dea(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;Dea(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;Eea(q,c[x>>2]|0,36);if(Hua(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];H9(y,91744,e)}else{wea(a,b,91776,4,11,91696,1);Fea((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;wea(a,b,91784,c[g>>2]|0,c[j>>2]|0,e,1);aEa(e);c[f>>2]=0;Fea((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;wea(a,b,91792,c[g>>2]|0,c[j>>2]|0,e,1);aEa(e);c[f>>2]=0;Gea(a,b,k,g,j,c[r>>2]|0,s);wea(a,b,91808,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;lwa(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];vea(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;wea(a,b,91688,c[j>>2]|0,c[g>>2]|0,n,8);lwa(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=Iea(q+240|0)|0;w=Iea(q+264|0)|0;p=Iea(q+288|0)|0;Hea(a,b,91824,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);aEa(n);aEa(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;Sva(s)|0;aEa(v);Yaa(3);i=d;return}}function Aea(a){a=a|0;var b=0;b=i;Jha(a);i=b;return}function Bea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(Nga(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(Nga(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(Nga(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function Cea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=$Da(e<<2)|0;e=l;c[l>>2]=92376;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=92416;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(Nga(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(Nga(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(Nga(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function Dea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;yfa(a,b,c);i=d;return}function Eea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(xfa(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Kua(d,4);i=e;return}else{Iua(d,0);i=e;return}}function Fea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=DEa(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=bEa((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;G9(0,(o|0)!=0|0,91896,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;OEa(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;Mea(q,DEa(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=bEa(1,1)|0;c[d>>2]=q;G9(0,(q|0)!=0|0,91896,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}



function XK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function YK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function ZK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function _K(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=1.0;i=i;return}function $K(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=0.0;i=i;return}function aL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function bL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function cL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=1.0;i=i;return}function dL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function eL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function fL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function gL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function hL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function iL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=1.0;i=i;return}function jL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=0.0;i=i;return}function kL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=0.0;i=i;return}function lL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function mL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=1.0;i=i;return}function nL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function oL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function pL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=0.0;i=i;return}function qL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=1.0;i=i;return}function rL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=0.0;i=i;return}function sL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=0.0;i=i;return}function tL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function uL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function vL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function wL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function xL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function yL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function zL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function AL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8952>>3]=0.0;i=i;return}function BL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8960>>3]=0.0;i=i;return}function CL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8976>>3]=0.0;i=i;return}function DL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function EL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9e3>>3]=0.0;i=i;return}function FL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9008>>3]=0.0;i=i;return}function GL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9016>>3]=0.0;i=i;return}function HL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=1.0;i=i;return}function IL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=0.0;i=i;return}function JL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=0.0;i=i;return}function KL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function LL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=1.0;i=i;return}function ML(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function NL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function OL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=0.0;i=i;return}function PL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=1.0;i=i;return}function QL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function RL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function SL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=0.0;i=i;return}function TL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function UL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=1.0;i=i;return}function VL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=0.0;i=i;return}function WL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=0.0;i=i;return}function XL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=0.0;i=i;return}function YL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=1.0;i=i;return}function ZL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=0.0;i=i;return}function _L(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function $L(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function aM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=1.0;i=i;return}function bM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=0.0;i=i;return}function cM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=0.0;i=i;return}function dM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=0.0;i=i;return}function eM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function fM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=1.0;i=i;return}function gM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function hM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function iM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=0.0;i=i;return}function jM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=1.0;i=i;return}function kM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function lM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function mM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function nM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=1.0;i=i;return}function oM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function pM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function qM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function rM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function sM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=1.0;i=i;return}function tM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function uM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function vM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function wM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function xM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function yM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=0.0;i=i;return}function zM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=0.0;i=i;return}function AM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=1.0;i=i;return}function BM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=0.0;i=i;return}function CM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function DM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function EM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=0.0;i=i;return}function FM(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function GM(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function HM(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function IM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=0.0;i=i;return}function JM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function KM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function LM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=0.0;i=i;return}function MM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=1.0;i=i;return}function NM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function OM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function PM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=0.0;i=i;return}function QM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function RM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=l;i=b;return}function SM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=l;i=b;return}function TM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=l;i=b;return}function UM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=l;i=b;return}function VM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=l;i=b;return}function WM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=l;i=b;return}function XM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=l;i=b;return}function YM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=l;i=b;return}function ZM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=l;i=b;return}function _M(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=0.0;i=i;return}function $M(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function aN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=1.0;i=i;return}function bN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function cN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function dN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function eN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=1.0;i=i;return}function fN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function gN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=0.0;i=i;return}function hN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function iN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=1.0;i=i;return}function jN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function kN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=0.0;i=i;return}function lN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function mN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function nN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function oN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=1.0;i=i;return}function pN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=0.0;i=i;return}function qN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function rN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=0.0;i=i;return}function sN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=1.0;i=i;return}function tN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function uN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function vN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function wN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function xN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function yN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function zN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=1.0;i=i;return}function AN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function BN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function CN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=0.0;i=i;return}function DN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function EN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=0.0;i=i;return}function FN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=1.0;i=i;return}function GN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=0.0;i=i;return}function HN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function IN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=0.0;i=i;return}function JN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function KN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=l;i=b;return}function LN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=l;i=b;return}function MN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=l;i=b;return}function NN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=l;i=b;return}function ON(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=l;i=b;return}function PN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=l;i=b;return}function QN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=l;i=b;return}function RN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=l;i=b;return}function SN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=l;i=b;return}function TN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=0.0;i=i;return}function UN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function VN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=1.0;i=i;return}function WN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function XN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function YN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function ZN(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=1.0;i=i;return}function _N(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function $N(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function aO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function bO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=1.0;i=i;return}function cO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function dO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function eO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function fO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function gO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function hO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}function iO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=1.0;i=i;return}function jO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function kO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=-1.0;i=i;return}function lO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=0.0;i=i;return}function mO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function nO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function oO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function pO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function qO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function rO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=1.0;i=i;return}function sO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function tO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function uO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function vO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function wO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function xO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=1.0;i=i;return}function yO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function zO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=0.0;i=i;return}function AO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function BO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=0.0;i=i;return}function CO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function DO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=1.0;i=i;return}function EO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=0.0;i=i;return}function FO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=0.0;i=i;return}function GO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=0.0;i=i;return}function HO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function IO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=l;i=b;return}function JO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=l;i=b;return}function KO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=l;i=b;return}function LO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=l;i=b;return}function MO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=l;i=b;return}function NO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=l;i=b;return}function OO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=l;i=b;return}function PO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=l;i=b;return}function QO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7760;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=l;i=b;return}function RO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=0.0;i=i;return}function SO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=0.0;i=i;return}function TO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=1.0;i=i;return}function UO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function VO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function WO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function XO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=1.0;i=i;return}function YO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function ZO(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function _O(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function $O(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=1.0;i=i;return}function aP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function bP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=0.0;i=i;return}function cP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=0.0;i=i;return}function dP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function eP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=0.0;i=i;return}function fP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=0.0;i=i;return}function gP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function hP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=1.0;i=i;return}function iP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=0.0;i=i;return}function jP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=1.0;i=i;return}function kP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=0.0;i=i;return}function lP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function mP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function nP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function oP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function pP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function qP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function rP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=0.0;i=i;return}function sP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=1.0;i=i;return}function tP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=0.0;i=i;return}function uP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=0.0;i=i;return}function vP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function wP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=0.0;i=i;return}function xP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function yP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function zP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=0.0;i=i;return}function AP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=1.0;i=i;return}function BP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function CP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function DP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function EP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=1.0;i=i;return}function FP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function GP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function HP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function IP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function JP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=0.0;i=i;return}function KP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function LP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=1.0;i=i;return}function MP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function NP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function OP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function PP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=1.0;i=i;return}function QP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function RP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=0.0;i=i;return}function SP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function TP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function UP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=0.0;i=i;return}function VP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function WP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function XP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function YP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=1.0;i=i;return}function ZP(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function _P(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=1.0;i=i;return}function $P(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function aQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function bQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=0.0;i=i;return}function cQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=0.0;i=i;return}function dQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function eQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5392>>3]=0.0;i=i;return}function fQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function gQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function hQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=1.0;i=i;return}function iQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function jQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=1.0;i=i;return}function kQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5440>>3]=0.0;i=i;return}function lQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function mQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function nQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function oQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=0.0;i=i;return}function pQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function qQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function rQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=0.0;i=i;return}function sQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function tQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function uQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=1.0;i=i;return}function vQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function wQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=1.0;i=i;return}function xQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function yQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function zQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function AQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function BQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function CQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function DQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function EQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function FQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=1.0;i=i;return}function GQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function HQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=1.0;i=i;return}function IQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function JQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function KQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function LQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function MQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function NQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=0.0;i=i;return}function OQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function PQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function QQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function RQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function SQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function TQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function UQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=0.0;i=i;return}function VQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5752>>3]=0.0;i=i;return}function WQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5744>>3]=0.0;i=i;return}function XQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function YQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function ZQ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function _Q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function $Q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5800>>3]=0.0;i=i;return}function aR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function bR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function cR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5824>>3]=0.0;i=i;return}function dR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function eR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=0.0;i=i;return}function fR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function gR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=0.0;i=i;return}function hR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function iR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function jR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=0.0;i=i;return}function kR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function lR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function mR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=0.0;i=i;return}function nR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function oR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5920>>3]=0.0;i=i;return}function pR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function qR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function rR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function sR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function tR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function uR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function vR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=0;i=i;return}function wR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function xR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function yR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function zR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function AR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function BR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=-1.0;i=i;return}function CR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function DR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function ER(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=1.0;i=i;return}function FR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function GR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function HR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function IR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function JR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function KR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=-1.0;i=i;return}function LR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6072>>3]=0.0;i=i;return}function MR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=0.0;i=i;return}function NR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6088>>3]=1.0;i=i;return}function OR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function PR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6120>>3]=0.0;i=i;return}function QR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6112>>3]=230.0;i=i;return}function RR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function SR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6144>>3]=0.0;i=i;return}function TR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6136>>3]=230.0;i=i;return}function UR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function VR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function WR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=230;i=i;return}function XR(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function YR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function ZR(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function _R(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function $R(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function aS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=1.0;i=i;return}function bS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6200>>3]=0.0;i=i;return}function cS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6208>>3]=1.0;i=i;return}function dS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function eS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function fS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function gS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=255.0;i=i;return}function hS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function iS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function jS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function kS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6248>>3]=.7;i=i;return}function lS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6256>>3]=0.0;i=i;return}function mS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function nS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function oS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=1.0;i=i;return}function pS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function qS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=255.0;i=i;return}function rS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=128.0;i=i;return}function sS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function tS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function uS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=128;i=i;return}function vS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=255;i=i;return}function wS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function xS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=128;i=i;return}function yS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=255;i=i;return}function zS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function AS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function BS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function CS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=1.0;i=i;return}function DS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}function ES(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function FS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6368>>3]=0.0;i=i;return}function GS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function HS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function IS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function JS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function KS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function LS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6416>>3]=0.0;i=i;return}function MS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=155;i=i;return}function NS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=155;i=i;return}function OS(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=155;i=i;return}function PS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function QS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function RS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6440>>3]=0.0;i=i;return}function SS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6448>>3]=.5038710255240861;i=i;return}function TS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=.8637789008984333;i=i;return}function US(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function VS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=-.8637789008984335;i=i;return}function WS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=.5038710255240862;i=i;return}function XS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=0.0;i=i;return}function YS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=0.0;i=i;return}function ZS(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=255.0;i=i;return}function _S(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6496>>3]=255.0;i=i;return}function $S(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=255;i=i;return}function aT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=255;i=i;return}function bT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=0;i=i;return}function cT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=0.0;i=i;return}function dT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function eT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=1.0;i=i;return}function fT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function gT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function hT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function iT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=1.0;i=i;return}function jT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function kT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6600>>3]=0.0;i=i;return}function lT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6608>>3]=0.0;i=i;return}function mT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=1.0;i=i;return}function nT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function oT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6632>>3]=0.0;i=i;return}function pT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function qT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=1.0;i=i;return}function rT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function sT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function tT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function uT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=255.0;i=i;return}function vT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function wT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function xT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=255.0;i=i;return}function yT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=255;i=i;return}function zT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function AT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=0;i=i;return}function BT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function CT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6720>>3]=0.0;i=i;return}function DT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function ET(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6744>>3]=0.0;i=i;return}function FT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=1.0;i=i;return}function GT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function HT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=1.0;i=i;return}function IT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function JT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6800>>3]=0.0;i=i;return}function KT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=-.8637789008984335;i=i;return}function LT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6816>>3]=.5038710255240862;i=i;return}function MT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=0.0;i=i;return}function NT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function OT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6840>>3]=1.0;i=i;return}function PT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function QT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function RT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function ST(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=255.0;i=i;return}function TT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function UT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function VT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=255.0;i=i;return}function WT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=255;i=i;return}function XT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=0;i=i;return}function YT(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=0;i=i;return}function ZT(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9056>>3]=0.0;i=i;return}function _T(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=155;i=i;return}function $T(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=155;i=i;return}function aU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=155;i=i;return}function bU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function cU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6912>>3]=0.0;i=i;return}function dU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function eU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6936>>3]=0.0;i=i;return}function fU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=1.0;i=i;return}function gU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function hU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=1.0;i=i;return}function iU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function jU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function kU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function lU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=255.0;i=i;return}function mU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=255;i=i;return}function nU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=0;i=i;return}function oU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=0;i=i;return}function pU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=.7;i=i;return}function qU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7008>>3]=0.0;i=i;return}function rU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function sU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function tU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7032>>3]=1.0;i=i;return}function uU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function vU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=255.0;i=i;return}function wU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=128.0;i=i;return}function xU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function yU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=0;i=i;return}function zU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=128;i=i;return}function AU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=255;i=i;return}function BU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function CU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function DU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function EU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function FU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function GU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function HU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=1.0;i=i;return}function IU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=0.0;i=i;return}function JU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7112>>3]=0.0;i=i;return}function KU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7120>>3]=0.0;i=i;return}function LU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function MU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=0.0;i=i;return}function NU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7144>>3]=0.0;i=i;return}function OU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7152>>3]=0.0;i=i;return}function PU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=0.0;i=i;return}function QU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=0.0;i=i;return}function RU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=155;i=i;return}function SU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=155;i=i;return}function TU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=155;i=i;return}function UU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function VU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function WU(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function XU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7176>>3]=0.0;i=i;return}function YU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7184>>3]=0.0;i=i;return}function ZU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=0.0;i=i;return}function _U(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=.1007742051048172;i=i;return}function $U(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=.1727557801796867;i=i;return}function aV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7216>>3]=0.0;i=i;return}function bV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7224>>3]=0.0;i=i;return}function cV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=1.0;i=i;return}function dV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7240>>3]=0.0;i=i;return}function eV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=.1727557801796867;i=i;return}function fV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7264>>3]=0.0;i=i;return}function gV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7272>>3]=1.0;i=i;return}function hV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function iV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7288>>3]=0.0;i=i;return}function jV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7296>>3]=0.0;i=i;return}function kV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7304>>3]=1.0;i=i;return}function lV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7312>>3]=0.0;i=i;return}function mV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7336>>3]=255.0;i=i;return}function nV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7328>>3]=128.0;i=i;return}function oV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7320>>3]=0.0;i=i;return}function pV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=255.0;i=i;return}function qV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7352>>3]=128.0;i=i;return}function rV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7344>>3]=0.0;i=i;return}function sV(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function tV(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function uV(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function vV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function wV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7376>>3]=0.0;i=i;return}function xV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=0.0;i=i;return}function yV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=1.0;i=i;return}function zV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function AV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function BV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function CV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function DV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function EV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function FV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7448>>3]=0.0;i=i;return}function GV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7456>>3]=0.0;i=i;return}function HV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=0.0;i=i;return}function IV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7472>>3]=0.0;i=i;return}function JV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7480>>3]=0.0;i=i;return}function KV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=0.0;i=i;return}function LV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=-.1007742051048172;i=i;return}function MV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=-.1727557801796867;i=i;return}function NV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7512>>3]=0.0;i=i;return}function OV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=0.0;i=i;return}function PV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=1.0;i=i;return}function QV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7536>>3]=0.0;i=i;return}function RV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=-.1727557801796867;i=i;return}function SV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7560>>3]=0.0;i=i;return}function TV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7568>>3]=1.0;i=i;return}function UV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function VV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7584>>3]=0.0;i=i;return}function WV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7592>>3]=0.0;i=i;return}function XV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=1.0;i=i;return}function YV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7608>>3]=0.0;i=i;return}function ZV(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=255.0;i=i;return}function _V(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=128.0;i=i;return}function $V(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7616>>3]=0.0;i=i;return}function aW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7656>>3]=255.0;i=i;return}function bW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7648>>3]=128.0;i=i;return}function cW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7640>>3]=0.0;i=i;return}function dW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function eW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=128;i=i;return}function fW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=255;i=i;return}function gW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7664>>3]=0.0;i=i;return}function hW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7672>>3]=0.0;i=i;return}function iW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7680>>3]=0.0;i=i;return}function jW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7688>>3]=1.0;i=i;return}function kW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7696>>3]=0.0;i=i;return}function lW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7704>>3]=0.0;i=i;return}function mW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7712>>3]=0.0;i=i;return}function nW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7720>>3]=0.0;i=i;return}function oW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7728>>3]=0.0;i=i;return}function pW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function qW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7744>>3]=0.0;i=i;return}function rW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7752>>3]=0.0;i=i;return}function sW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function tW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function uW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7776>>3]=0.0;i=i;return}function vW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7784>>3]=0.0;i=i;return}function wW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7792>>3]=0.0;i=i;return}function xW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7800>>3]=1.0;i=i;return}function yW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7808>>3]=0.0;i=i;return}function zW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7832>>3]=155.0;i=i;return}function AW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=155.0;i=i;return}function BW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7816>>3]=155.0;i=i;return}function CW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=155;i=i;return}function DW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=155;i=i;return}function EW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=155;i=i;return}function FW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7840>>3]=0.0;i=i;return}function GW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function HW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function IW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function JW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=1.0;i=i;return}function KW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7880>>3]=0.0;i=i;return}function LW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7904>>3]=100.0;i=i;return}function MW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=100.0;i=i;return}function NW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7888>>3]=100.0;i=i;return}function OW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=100;i=i;return}function PW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=100;i=i;return}function QW(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=100;i=i;return}function RW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7912>>3]=0.0;i=i;return}function SW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7920>>3]=1.0;i=i;return}function TW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7928>>3]=0.0;i=i;return}function UW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7936>>3]=0.0;i=i;return}function VW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7944>>3]=1.0;i=i;return}function WW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7952>>3]=0.0;i=i;return}function XW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7976>>3]=255.0;i=i;return}function YW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=128.0;i=i;return}function ZW(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7960>>3]=0.0;i=i;return}function _W(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=255.0;i=i;return}function $W(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=128.0;i=i;return}function aX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7984>>3]=0.0;i=i;return}function bX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=0;i=i;return}function cX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=128;i=i;return}function dX(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=255;i=i;return}function eX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9064>>3]=0.0;i=i;return}function fX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9072>>3]=0.0;i=i;return}function gX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8072>>3]=1.0;i=i;return}function hX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8064>>3]=0.0;i=i;return}function iX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function jX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8048>>3]=0.0;i=i;return}function kX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8024>>3]=0.0;i=i;return}function lX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8096>>3]=0.0;i=i;return}function mX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=1.0;i=i;return}function nX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8160>>3]=0.0;i=i;return}function oX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8152>>3]=0.0;i=i;return}function pX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8144>>3]=0.0;i=i;return}function qX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function rX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9096>>3]=.8;i=i;return}function sX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9104>>3]=2.2;i=i;return}function tX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9112>>3]=0.0;i=i;return}function uX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8176>>3]=0.0;i=i;return}function vX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8184>>3]=0.0;i=i;return}function wX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8192>>3]=0.0;i=i;return}function xX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8200>>3]=0.0;i=i;return}function yX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function zX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8216>>3]=0.0;i=i;return}function AX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8224>>3]=1.0;i=i;return}function BX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function CX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function DX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8248>>3]=0.0;i=i;return}function EX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8256>>3]=0.0;i=i;return}function FX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function GX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8272>>3]=0.0;i=i;return}function HX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8280>>3]=.5038710255240861;i=i;return}function IX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=-.8637789008984335;i=i;return}function JX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8296>>3]=0.0;i=i;return}function KX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8304>>3]=.8637789008984333;i=i;return}function LX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8312>>3]=.5038710255240862;i=i;return}function MX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8320>>3]=0.0;i=i;return}function NX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8328>>3]=0.0;i=i;return}function OX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8336>>3]=0.0;i=i;return}function PX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8344>>3]=.9999999999999999;i=i;return}function QX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9120>>3]=0.0;i=i;return}function RX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function SX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function TX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8368>>3]=0.0;i=i;return}function UX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8376>>3]=0.0;i=i;return}function VX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function WX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8392>>3]=0.0;i=i;return}function XX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8400>>3]=1.0;i=i;return}function YX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8408>>3]=0.0;i=i;return}function ZX(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8416>>3]=0.0;i=i;return}function _X(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function $X(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8432>>3]=0.0;i=i;return}function aY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8440>>3]=0.0;i=i;return}function bY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function cY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8456>>3]=0.0;i=i;return}function dY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8464>>3]=0.0;i=i;return}function eY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function fY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8480>>3]=0.0;i=i;return}function gY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8488>>3]=0.0;i=i;return}function hY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8496>>3]=0.0;i=i;return}function iY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function jY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8512>>3]=0.0;i=i;return}function kY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8520>>3]=0.0;i=i;return}function lY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function mY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8528>>3]=0.0;i=i;return}function nY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8536>>3]=0.0;i=i;return}function oY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function pY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8552>>3]=1.0;i=i;return}function qY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8576>>3]=0.0;i=i;return}function rY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function sY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8560>>3]=0.0;i=i;return}function tY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8584>>3]=1.0;i=i;return}function uY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8608>>3]=0.0;i=i;return}function vY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function wY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function xY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8616>>3]=1.0;i=i;return}function yY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function zY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function AY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function BY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function CY(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+1|0]|0)!=0|0}c[(c[b+420>>2]|0)+148>>2]=e;i=i;return}function DY(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e]|0)==0){f=0}else{if((a[e+1|0]|0)==0){f=0;break}f=(a[e+4|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+152>>2]=f;i=d;return}function EY(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+156>>2]=e;i=i;return}function FY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3016>>3]=+h[b+2968>>3]*.5;i=i;return}function GY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3024>>3]=+h[b+2968>>3]*.2;i=i;return}function HY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3032>>3]=+h[b+2968>>3]*.1;i=i;return}function IY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3040>>3]=+h[b+2968>>3]*.05;i=i;return}function JY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3048>>3]=+h[b+2968>>3]*.1;i=i;return}function KY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3056>>3]=+h[b+2968>>3]*.05;i=i;return}function LY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=+h[(c[a+416>>2]|0)+3056>>3]*.8;i=i;return}function MY(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=+h[(c[a+416>>2]|0)+3056>>3]*2.2;i=i;return}function NY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3064>>3]=+h[b+2968>>3]/9.0;i=i;return}function OY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3072>>3]=+h[b+2968>>3]*.025;i=i;return}function PY(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+2984>>3];j=+h[f+3016>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+J9(c[b+536>>2]|0,g,7816,7808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+3080>>3]=l;i=d;return}function QY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3088>>3]=+h[b+3016>>3]*.5;i=i;return}function RY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3096>>3]=+h[b+3016>>3]*1.05;i=i;return}function SY(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+3104>>3]=+sd(+(+h[d+3016>>3]),+(+h[d+3080>>3]*5.0));i=b;return}function TY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3112>>3]=+h[b+3080>>3]*3.0;i=i;return}function UY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3120>>3]=+h[b+3080>>3];i=i;return}function VY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3128>>3]=+h[b+3080>>3]*3.0;i=i;return}function WY(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=d;i=i;return}function XY(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=d;i=i;return}function YY(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+3128>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=j;i=b;return}x=c[24790]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=7984;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,7864,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+4832|0;w=v;h[w>>3]=j;i=b;return}function ZY(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4736>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4760>>3]- +h[b+4784>>3]);i=i;return}function _Y(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4752>>3]- +h[b+4776>>3]);i=i;return}function $Y(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[(c[a+416>>2]|0)+3128>>3]*(+h[b+4744>>3]- +h[b+4768>>3]);i=i;return}function aZ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4712>>3]=+h[b+3096>>3]+ +h[d+4784>>3]*+h[b+3128>>3];i=i;return}function bZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4704>>3]=+h[b+4776>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function cZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4696>>3]=+h[b+4768>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function dZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4688>>3]=+h[b+4760>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function eZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4680>>3]=+h[b+4752>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function fZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4672>>3]=+h[b+4744>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function gZ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+4664>>3]=+h[b+3096>>3]+ +h[d+4784>>3]*+h[b+3128>>3];i=i;return}function hZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4656>>3]=+h[b+4776>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function iZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4648>>3]=+h[b+4768>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function jZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4640>>3]=+h[b+4760>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function kZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4632>>3]=+h[b+4752>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function lZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4624>>3]=+h[b+4744>>3]*+h[(c[a+416>>2]|0)+3128>>3];i=i;return}function mZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=+h[(c[a+416>>2]|0)+3128>>3]*.75;i=i;return}function nZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=+h[(c[a+416>>2]|0)+3128>>3]*.5;i=i;return}function oZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=+h[(c[a+416>>2]|0)+3128>>3]*1.5;i=i;return}function pZ(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+4464>>3];e=+h[b+4472>>3]- +h[b+4456>>3];h[b+4248>>3]=+V(+(d*d+e*e));i=i;return}function qZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4152>>3]=+h[b+4176>>3]*+h[b+4464>>3]+ +h[b+4200>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function rZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4144>>3]=+h[b+4168>>3]*+h[b+4464>>3]+ +h[b+4192>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function sZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4136>>3]=+h[b+4160>>3]*+h[b+4464>>3]+ +h[b+4184>>3]*(+h[b+4472>>3]- +h[b+4456>>3]);i=i;return}function tZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4128>>3]=+h[b+4200>>3]*+h[b+4456>>3];i=i;return}function uZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4120>>3]=+h[(c[a+416>>2]|0)+3096>>3]+ +h[b+4192>>3]*+h[b+4456>>3];i=i;return}function vZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4112>>3]=+h[b+4184>>3]*+h[b+4456>>3];i=i;return}function wZ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=+h[(c[a+416>>2]|0)+3128>>3]*1.5;i=i;return}function xZ(a){a=a|0;var b=0.0,d=0,e=0.0;b=+h[(c[a+416>>2]|0)+3128>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+4440>>3];h[d+4256>>3]=+V(+(b*b+e*e));i=i;return}function yZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4104>>3]=+h[b+4176>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4200>>3]*+h[b+4440>>3];i=i;return}function zZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4168>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4192>>3]*+h[b+4440>>3];i=i;return}function AZ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+4160>>3]*+h[(c[a+416>>2]|0)+3128>>3]+ +h[b+4184>>3]*+h[b+4440>>3];i=i;return}



function Je(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ke(){return i|0}function Le(a){a=a|0;i=a}function Me(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ne(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Oe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Pe(a){a=a|0;J=a}function Qe(a){a=a|0;K=a}function Re(a){a=a|0;L=a}function Se(a){a=a|0;M=a}function Te(a){a=a|0;N=a}function Ue(a){a=a|0;O=a}function Ve(a){a=a|0;P=a}function We(a){a=a|0;Q=a}function Xe(a){a=a|0;R=a}function Ye(a){a=a|0;S=a}function Ze(a){a=a|0;var b=0,d=0;b=i;Sda(a)|0;d=a+540|0;ie[c[(c[d>>2]|0)+40>>2]&127](a)|0;ie[c[(c[d>>2]|0)+28>>2]&127](a)|0;ie[c[(c[d>>2]|0)+32>>2]&127](a)|0;ie[c[(c[d>>2]|0)+48>>2]&127](a)|0;ie[c[(c[d>>2]|0)+52>>2]&127](a)|0;yca(a);i=b;return}function _e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=DEa(B|0)|0;D=$Da(C+11|0)|0;OEa(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ic(D|0,32)|0;if((C|0)==0){B=Wd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;F9(23,0,40,u);Yc(0)|0;F=0}else{F=C}aEa(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ce[c[50756>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Waa(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Waa(2);Vaa(2)}Kaa(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];lca(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(23,1,144,r);Z=Ada(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ze(b);zca(b);if((c[49948>>2]|0)!=0){fe[c[12602]&511](23)}if((c[2]|0)!=0){Vaa(4)}A=nca(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];D9(7,1,200,q);if((c[106876>>2]|0)==0){ge[c[91564>>2]&127](91544,b)}pca(b,c[J>>2]|0,z,d);if((c[49884>>2]|0)!=0){fe[c[12602]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;Dca(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){Yaa(4)}if((Mda(b,1,1)|0)!=0){c[B>>2]=1;Dca(b)}ie[c[(c[K>>2]|0)+88>>2]&127](b)|0;yca(b);Hca(b);zca(b);do{if((T|0)==0){_=0}else{Vaa(7);Yaa(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Qaa(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Qaa(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Laa(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Qaa(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}Yaa(7);if((la|0)!=0){_=T;break}c[p>>2]=Wd(c[(Nc()|0)>>2]|0)|0;F9(23,0,240,p);Yc(T|0)|0;_=0}}while(0);if((c[106876>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ge[c[91564>>2]&127](91544,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[24286]|0)!=0){ca=f;ba=97152;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];v9(M,f);Sd(10,M|0)|0;ba=c[24294]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;D9(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((jda(b,0)|0)!=0){ma=58;break}if(($ca(b,0)|0)!=0){ma=58;break}if((Qca(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((jda(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(1,0,448,m);U=_;V=-2;break}if(($ca(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(1,0,536,l);U=_;V=-3;break}T=(Qca(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];D9(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Yc(U|0)|0;i=e;return V|0}function $e(a){a=a|0;i=i;return 0}function af(a){a=a|0;i=i;return 0}function bf(a){a=a|0;i=i;return 0}function cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function df(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+1200>>3]=-(d*+h[b+16>>3]);i=i;return}function ef(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+1208>>3]=d*+h[b+16>>3];i=i;return}function ff(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+1216>>3]=-(d*+h[b+16>>3]);i=i;return}function gf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+1224>>3]=-(d*+h[b+16>>3]);i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=+h[b>>3];i=i;return}function jf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8>>3]));h[b+1304>>3]=-(d*+h[b>>3]);i=i;return}function kf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8>>3]));h[b+1312>>3]=d*+h[b>>3];i=i;return}function lf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+8>>3]));h[b+1320>>3]=-(d*+h[b>>3]);i=i;return}function mf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+8>>3]));h[b+1328>>3]=-(d*+h[b>>3]);i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8040>>3]=+X(+(+h[b+8>>3]));i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8032>>3]=-+Y(+(+h[b+8>>3]));i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=+Y(+(+h[b+8>>3]));i=i;return}function qf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2256>>3]=+h[b+2848>>3]+(+h[d+8016>>3]*+h[b+2232>>3]+ +h[d+8040>>3]*+h[b+2240>>3]);i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2232>>3]=+h[b+2256>>3]- +h[(c[a+416>>2]|0)+2752>>3];i=i;return}function sf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=c[a+416>>2]|0;h[b+1984>>3]=+h[b+8040>>3]*d*+h[e+2232>>3]- +h[b+8016>>3]*d*+h[e+2240>>3];i=i;return}function tf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];h[b+1784>>3]=(d*d*-.35+ +h[b+8016>>3]*+h[(c[a+416>>2]|0)+2944>>3])*6.602749999999998;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8008>>3]=+X(+(+h[b+8>>3]));i=i;return}function vf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2248>>3]=+h[b+2840>>3]+(+h[d+8008>>3]*+h[b+2232>>3]+ +h[d+8032>>3]*+h[b+2240>>3]);i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2224>>3]=+h[b+2248>>3]- +h[(c[a+416>>2]|0)+2744>>3];i=i;return}function xf(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2224>>3];e=+h[b+2232>>3];f=+h[b+2240>>3];h[b+8648>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2240>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,880,872,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}function zf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+296>>3]=+h[b+2760>>3]+ +h[d+320>>3]*+h[b+3952>>3];i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+2264>>3]- +h[b+320>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=-(+h[b+320>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=+h[b+320>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function Df(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2232>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,880,992,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+312|0;q=p;h[q>>3]=n;i=d;return}function Ef(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+288>>3]=+h[b+2752>>3]+ +h[d+312>>3]*+h[b+3952>>3];i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+2256>>3]- +h[b+312>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-(+h[b+312>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[b+312>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Di(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[b+416>>2]|0)+3960>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+2224>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}r=l/+J9(c[f>>2]|0,j,880,1e3,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+304|0;q=p;h[q>>3]=n;i=d;return}function Jf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+280>>3]=+h[b+2744>>3]+ +h[d+304>>3]*+h[b+3952>>3];i=i;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+64>>3]=-(+h[b+304>>3]*(+h[(c[a+416>>2]|0)+3968>>3]+ +h[b+9080>>3]*-.5));i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+88>>3]=+h[b+304>>3]*(+h[(c[a+416>>2]|0)+3952>>3]+ +h[b+9080>>3]*-.5);i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+2248>>3]- +h[b+304>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function Nf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=c[a+416>>2]|0;h[b+1976>>3]=+h[b+8032>>3]*d*+h[e+2232>>3]- +h[b+8008>>3]*d*+h[e+2240>>3];i=i;return}function Of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2224>>3];k=+h[g+2232>>3];l=j*+h[g+1976>>3]+k*+h[g+1984>>3];m=+h[g+2240>>3];n=+V(+(j*j+k*k+m*m));if(n!=0.0){o=n;p=g;q=.5/o;r=l*q;s=r*2.0;t=p;u=t+8656|0;v=u;h[v>>3]=s;i=d;return}m=+J9(c[b+536>>2]|0,n,1016,1008,+h[f>>3],(a[b+319|0]|0)!=0|0);o=m;p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=.5/o;r=l*q;s=r*2.0;t=p;u=t+8656|0;v=u;h[v>>3]=s;i=d;return}function Pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=b+4|0;l=b+416|0;Di(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);m=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[j>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);n=+h[f>>3];Di(g,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[g>>3];p=o*o;g=c[c[k>>2]>>2]|0;l=c[g+8>>2]|0;o=m*+h[l+1984>>3]-n*+h[l+2232>>3];if(p!=0.0){q=l;r=o/p;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}if(o==0.0){q=l;r=o;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}n=o/+J9(c[j>>2]|0,p,1248,1240,+h[g>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=n;s=q;t=s+1432|0;u=t;h[u>>3]=r;i=d;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+1432>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+1984>>3]- +h[b+1432>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+536|0;j=b+4|0;k=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=b+416|0;Ci(e,c[g>>2]|0,+h[k+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[k+8656>>3],0.0);m=+h[e>>3];Di(f,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);n=+h[f>>3];f=c[c[j>>2]>>2]|0;l=c[f+8>>2]|0;o=+h[l+2240>>3];p=n*n;if(p!=0.0){q=l;r=m/p;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}if(m==0.0){q=l;r=m;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}n=m/+J9(c[g>>2]|0,p,1248,1368,+h[f>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[j>>2]>>2]|0)+8>>2]|0;r=n;s=o*r;t=-s;u=q;v=u+1440|0;w=v;h[w>>3]=t;i=d;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+1440>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=-(+h[b+1440>>3]*+h[(c[a+416>>2]|0)+3968>>3]);i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8672>>3]=+h[(c[a+416>>2]|0)+3928>>3]*+h[b+8656>>3];i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8664>>3]=+h[b+8672>>3]*+h[b+8656>>3];i=i;return}function Xf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0,t=0,u=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=b+4|0;l=b+416|0;Di(e,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);m=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[j>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);n=+h[f>>3];Di(g,c[j>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[g>>3];p=o*o;g=c[c[k>>2]>>2]|0;l=c[g+8>>2]|0;o=m*+h[l+1976>>3]-n*+h[l+2224>>3];if(p!=0.0){q=l;r=o/p;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}if(o==0.0){q=l;r=o;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}n=o/+J9(c[j>>2]|0,p,1248,1376,+h[g>>3],(a[b+319|0]|0)!=0|0);q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=n;s=q;t=s+1424|0;u=t;h[u>>3]=r;i=d;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+1424>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[b+1976>>3]- +h[b+1424>>3]*+h[(c[a+416>>2]|0)+3968>>3];i=i;return}function _f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1840>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1840|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+kda(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1840>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+160>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+160|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+kda(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+160>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+168>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+168|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+kda(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+168>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+8760>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+8760|0;h[(c[g+128>>2]|0)+24>>3]=+h[j>>3];k=+kda(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+8760>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+24>>3]=k;ida(a,1)|0;e=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1840>>3]=+h[e>>3];h[f+160>>3]=+h[e+8>>3];h[f+168>>3]=+h[e+16>>3];h[f+8760>>3]=+h[e+24>>3];cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);i=b;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=+h[b+1840>>3];i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+360>>3]=+h[b+312>>3]*+h[b+8672>>3]+ +h[b+120>>3]- +h[b+192>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function bg(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+152>>3];e=+h[b+320>>3];h[b+128>>3]=d-e*(+h[b+136>>3]*+h[b+304>>3]+(d*e+ +h[b+144>>3]*+h[b+312>>3]));i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+320>>3]*+h[b+8672>>3]+ +h[b+128>>3]- +h[b+200>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function dg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+376>>3]=+h[b+2760>>3]*+h[d+360>>3]- +h[b+2752>>3]*+h[d+368>>3];i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+176>>3]*+h[(c[a+416>>2]|0)+3944>>3]+(+h[b+128>>3]+ +h[b+320>>3]*+h[b+8672>>3]);i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[b+416>>3]- +h[b+1784>>3];i=i;return}function gg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+424>>3]=+h[b+2248>>3]*+h[d+416>>3]+ +h[b+2232>>3]*+h[d+488>>3];i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[b+408>>3]- +h[b+1792>>3];i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=-(+h[b+8040>>3]*+h[b+440>>3])- +h[b+8016>>3]*+h[b+448>>3];i=i;return}function jg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+432>>3]=-(+h[b+2248>>3]*+h[d+408>>3])- +h[b+2240>>3]*+h[d+488>>3];i=i;return}function kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=-(+h[b+8040>>3]*+h[b+424>>3])- +h[b+8016>>3]*+h[b+432>>3];i=i;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+352>>3]=+h[b+304>>3]*+h[b+8672>>3]+ +h[b+112>>3]- +h[b+184>>3]*+h[(c[a+416>>2]|0)+3936>>3];i=i;return}function mg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+392>>3]=+h[b+2752>>3]*+h[d+352>>3]- +h[b+2744>>3]*+h[d+360>>3];i=i;return}function ng(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+384>>3]=+h[b+2744>>3]*+h[d+368>>3]- +h[b+2760>>3]*+h[d+352>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=-(+h[b+8032>>3]*+h[b+440>>3])- +h[b+8008>>3]*+h[b+448>>3];i=i;return}function pg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+344>>3]=+h[b+2840>>3]*+h[d+480>>3]+(+h[b+3656>>3]- +h[b+2848>>3]*+h[d+472>>3]);i=i;return}function qg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+336>>3]=+h[b+2856>>3]*+h[d+472>>3]+(+h[d+456>>3]- +h[b+2840>>3]*+h[d+488>>3]);i=i;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=-(+h[b+8032>>3]*+h[b+424>>3])- +h[b+8008>>3]*+h[b+432>>3];i=i;return}function sg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+328>>3]=+h[b+2848>>3]*+h[d+488>>3]+(+h[d+464>>3]- +h[b+2856>>3]*+h[d+480>>3]);i=i;return}function tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=+X(+(+h[b+24>>3]));i=i;return}function ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8128>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8112>>3]=+Y(+(+h[b+24>>3]));i=i;return}function wg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2208>>3]=+h[b+1808>>3]+(+h[d+8112>>3]*+h[b+384>>3]+ +h[d+8136>>3]*+h[b+392>>3]);i=i;return}function xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+2208>>3]- +h[(c[a+416>>2]|0)+904>>3];i=i;return}function yg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+2112>>3]=+h[b+8136>>3]*d*+h[e+384>>3]- +h[b+8112>>3]*d*+h[e+392>>3];i=i;return}function zg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];h[b+1536>>3]=(d*d*-.35+ +h[b+8112>>3]*+h[(c[a+416>>2]|0)+2944>>3])*6.602749999999998;i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8104>>3]=+X(+(+h[b+24>>3]));i=i;return}function Bg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2200>>3]=+h[b+1800>>3]+(+h[d+8104>>3]*+h[b+384>>3]+ +h[d+8128>>3]*+h[b+392>>3]);i=i;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[b+2200>>3]- +h[(c[a+416>>2]|0)+896>>3];i=i;return}function Dg(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+720>>3];e=+h[b+712>>3];f=+h[b+2192>>3];h[b+8728>>3]=+V(+(d*d+(e*e+f*f)));i=i;return}function Eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8680>>3]=+h[b+8728>>3]- +h[(c[a+416>>2]|0)+3416>>3];i=i;return}function Fg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+712>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1392,1384,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+696|0;p=o;h[p>>3]=m;i=d;return}function Gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2192>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1392,1416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+704|0;p=o;h[p>>3]=m;i=d;return}function Hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=+h[b+704>>3]*.5038710255240861;i=i;return}function Ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=+h[b+704>>3]*.8637789008984333;i=i;return}function Jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2112>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1392,1424,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2080|0;p=o;h[p>>3]=m;i=d;return}function Kg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1392,1432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+688|0;p=o;h[p>>3]=m;i=d;return}function Lg(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+696>>3];e=+h[b+688>>3];h[b+8720>>3]=d*d+e*e;i=i;return}function Mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[g+8720>>3];if(j>=0.0){l=g;m=+V(+j);n=l;o=n+8712|0;p=o;h[p>>3]=m;i=b;return}g=c[24790]|0;q=c[a+536>>2]|0;a=e;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=g;g=d;r=1736;c[g+0>>2]=c[r+0>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];Ie[a&31](q,d,1440,e);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=+V(+j);n=l;o=n+8712|0;p=o;h[p>>3]=m;i=b;return}function Ng(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+696>>3];l=-k;if(j!=0.0){m=g;n=l/j;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=g;n=l;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}k=l/+J9(c[b+536>>2]|0,j,1528,1520,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+8080|0;q=p;h[q>>3]=n;i=d;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+704>>3]*+h[b+8080>>3];i=i;return}function Pg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=+h[b+672>>3]*.9999999999999999;i=i;return}function Qg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+688>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1528,1552,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+8088|0;p=o;h[p>>3]=m;i=d;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=-(+h[b+704>>3]*+h[b+8088>>3]);i=i;return}function Sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[b+664>>3]*.9999999999999999;i=i;return}function Tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+696>>3]*.5038710255240861+ +h[b+8088>>3]*-.8637789008984335;i=i;return}function Ug(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+696>>3]*.8637789008984333+ +h[b+8088>>3]*.5038710255240862;i=i;return}function Vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+688>>3]*+h[b+8088>>3]- +h[b+696>>3]*+h[b+8080>>3];i=i;return}function Wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[b+680>>3]*.9999999999999999;i=i;return}function Xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+568>>3]=+h[b+688>>3]*.5038710255240861+ +h[b+8080>>3]*-.8637789008984335;i=i;return}function Yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=+h[b+688>>3]*.8637789008984333+ +h[b+8080>>3]*.5038710255240862;i=i;return}function Zg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+2104>>3]=+h[b+8128>>3]*d*+h[e+384>>3]- +h[b+8104>>3]*d*+h[e+392>>3];i=i;return}function _g(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1392,1560,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2072|0;p=o;h[p>>3]=m;i=d;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=+h[b+8080>>3]*+h[b+2072>>3]+ +h[b+8088>>3]*+h[b+2080>>3];i=i;return}function ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=+h[b+656>>3]*.9999999999999999;i=i;return}function bh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=-(+h[b+672>>3]*+h[b+2080>>3])- +h[b+664>>3]*+h[b+2072>>3];i=i;return}function ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=+h[g+672>>3]*+h[g+2072>>3]- +h[g+664>>3]*+h[g+2080>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,j,1528,1568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+640|0;p=o;h[p>>3]=m;i=d;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+640>>3]*.5038710255240861+ +h[b+648>>3]*-.8637789008984335;i=i;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+640>>3]*.8637789008984333+ +h[b+648>>3]*.5038710255240862;i=i;return}function fh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+720>>3];k=+h[g+712>>3];l=+h[g+2192>>3];m=+V(+(j*j+(k*k+l*l)));l=j*+h[g+2104>>3]+k*+h[g+2112>>3];if(m!=0.0){n=g;o=l/m;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){n=g;o=l;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}k=l/+J9(c[b+536>>2]|0,m,1584,1576,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=k;p=n;q=p+8688|0;r=q;h[r>>3]=o;i=d;return}function gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8704>>3]=+h[(c[a+416>>2]|0)+3640>>3]*+h[b+8688>>3];i=i;return}function hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8696>>3]=+h[b+8704>>3]*+h[b+8688>>3];i=i;return}function ih(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=+h[g+2192>>3];l=j*j;j=+h[g+8688>>3];do{if(l!=0.0){m=g;n=j/l}else{if(j==0.0){m=g;n=j;break}o=j/+J9(c[b+536>>2]|0,l,1680,1672,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1376>>3]=-(k*n);i=d;return}function jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=+h[b+1376>>3]*.5038710255240861;i=i;return}function kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+1376>>3]*.8637789008984333;i=i;return}function lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=j*j;l=j*+h[g+2112>>3]- +h[g+712>>3]*+h[g+8688>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,1680,1712,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1368|0;q=p;h[q>>3]=n;i=d;return}function mh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8728>>3];k=j*j;l=j*+h[g+2104>>3]- +h[g+720>>3]*+h[g+8688>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,1680,1720,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1360|0;q=p;h[q>>3]=n;i=d;return}function nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8736>>3]=(+h[b+696>>3]*+h[b+1368>>3]+ +h[b+688>>3]*+h[b+1360>>3])*2.0;i=i;return}function oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+32|0;e=d;f=d+24|0;g=b+4|0;j=c[c[g>>2]>>2]|0;l=c[j+8>>2]|0;m=+h[l+8720>>3];if(!(m>=0.0)){n=c[24790]|0;o=c[b+536>>2]|0;p=f;h[k>>3]=m;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n;n=e;q=1736;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&31](o,e,1440,f);f=c[c[g>>2]>>2]|0;r=c[f+8>>2]|0;s=f}else{r=l;s=j}t=+V(+m)*2.0;m=+h[r+8736>>3];if(t!=0.0){u=r;v=m/t;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}if(m==0.0){u=r;v=m;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}z=m/+J9(c[b+536>>2]|0,t,1760,1728,+h[s>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[g>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+8744|0;y=x;h[y>>3]=v;i=d;return}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=j*j;l=+h[g+696>>3]*+h[g+8744>>3]-j*+h[g+1368>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,1808,1800,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}function qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1344>>3]=+h[b+704>>3]*+h[b+1384>>3]+ +h[b+1376>>3]*+h[b+8080>>3];i=i;return}function rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+1344>>3]*.9999999999999999;i=i;return}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8712>>3];k=j*j;l=j*+h[g+1360>>3]- +h[g+688>>3]*+h[g+8744>>3];if(k!=0.0){m=g;n=l/k;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}j=l/+J9(c[b+536>>2]|0,k,1808,1840,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+1392|0;q=p;h[q>>3]=n;i=d;return}function th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=-(+h[b+1376>>3]*+h[b+8088>>3])- +h[b+704>>3]*+h[b+1392>>3];i=i;return}function uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1280>>3]=+h[b+1336>>3]*.9999999999999999;i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+1368>>3]*.5038710255240861+ +h[b+1392>>3]*-.8637789008984335;i=i;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+1368>>3]*.8637789008984333+ +h[b+1392>>3]*.5038710255240862;i=i;return}function xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+688>>3]*+h[b+1392>>3]+(+h[b+1360>>3]*+h[b+8088>>3]+(-(+h[b+696>>3]*+h[b+1384>>3])- +h[b+1368>>3]*+h[b+8080>>3]));i=i;return}function yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1296>>3]=+h[b+1352>>3]*.9999999999999999;i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1232>>3]=+h[b+1360>>3]*.5038710255240861+ +h[b+1384>>3]*-.8637789008984335;i=i;return}function Ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1256>>3]=+h[b+1360>>3]*.8637789008984333+ +h[b+1384>>3]*.5038710255240862;i=i;return}function Bh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;_ca(a,1)|0;d=a+476|0;e=c[(c[d>>2]|0)+92>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+808>>3]=+h[e>>3];h[a+1544>>3]=+h[e+8>>3];h[a+968>>3]=+h[e+16>>3];h[a+1528>>3]=+h[e+24>>3];h[a+1456>>3]=+h[e+32>>3];h[a+1488>>3]=+h[e+40>>3];h[a+1592>>3]=+h[e+48>>3];h[a+1496>>3]=+h[e+56>>3];h[a+872>>3]=+h[e+64>>3];h[a+864>>3]=+h[e+72>>3];h[a+880>>3]=+h[e+80>>3];h[a+824>>3]=+h[e+88>>3];h[a+816>>3]=+h[e+96>>3];h[a+832>>3]=+h[e+104>>3];h[a+536>>3]=+h[e+112>>3];h[a+1416>>3]=+h[e+120>>3];h[a+1400>>3]=+h[e+128>>3];h[a+1464>>3]=+h[e+136>>3];h[a+528>>3]=+h[e+144>>3];h[a+1408>>3]=+h[e+152>>3];h[a+856>>3]=+h[e+160>>3];h[a+848>>3]=+h[e+168>>3];h[a+888>>3]=+h[e+176>>3];h[a+520>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+92>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+840>>3]=+h[e+192>>3];h[d+752>>3]=+h[e+200>>3];h[d+984>>3]=+h[e+208>>3];h[d+976>>3]=+h[e+216>>3];h[d+728>>3]=+h[e+224>>3];h[d+760>>3]=+h[e+232>>3];h[d+800>>3]=+h[e+240>>3];h[d+768>>3]=+h[e+248>>3];h[d+736>>3]=+h[e+256>>3];i=b;return}function Ch(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+1592>>3];i=i;return}function Dh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+2104>>3];k=+h[g+2112>>3];l=+h[g+720>>3];m=+h[g+712>>3];n=+h[g+2192>>3];o=j*l+k*m;p=l*l+(m*m+n*n);n=p*4.0;q=+h[g+1488>>3];r=j*j;j=+h[g+1496>>3];s=k*k;k=+V(+p);p=k*(l*q+(r+(s+m*j)))*4.0;g=k!=0.0;t=o*o;if(n!=0.0){do{if(g){u=t/k}else{if(t==0.0){u=t;break}u=t/+J9(c[b+536>>2]|0,k,1584,1848,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=(p+u*-4.0)/n;w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}do{if(g){F=j;G=m;H=q;I=l;J=f;K=t/k}else{if(t==0.0){F=j;G=m;H=q;I=l;J=f;K=t;break}u=t/+J9(c[b+536>>2]|0,k,1584,1848,+h[f>>3],(a[b+319|0]|0)!=0|0);L=c[c[e>>2]>>2]|0;M=c[L+8>>2]|0;F=+h[M+1496>>3];G=+h[M+712>>3];H=+h[M+1488>>3];I=+h[M+720>>3];J=L;K=u}}while(0);l=k*(I*H+(r+(s+G*F)))*4.0;if(p+K*-4.0==0.0){do{if(g){N=t/k}else{if(t==0.0){N=t;break}N=t/+J9(c[b+536>>2]|0,k,1584,1848,+h[J>>3],(a[b+319|0]|0)!=0|0)}}while(0);v=l+N*-4.0;w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}else{do{if(g){O=J;P=t/k}else{if(t==0.0){O=J;P=t;break}N=t/+J9(c[b+536>>2]|0,k,1584,1848,+h[J>>3],(a[b+319|0]|0)!=0|0);O=c[c[e>>2]>>2]|0;P=N}}while(0);v=(l+P*-4.0)/+J9(c[b+536>>2]|0,n,1856,1848,+h[O>>3],(a[b+319|0]|0)!=0|0);w=c[e>>2]|0;x=c[w>>2]|0;y=x;z=y+8|0;A=z;B=c[A>>2]|0;C=B;D=C+8752|0;E=D;h[E>>3]=v;i=d;return}}function Eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+776>>3]=+h[b+568>>3]*+h[b+872>>3]+(+h[b+592>>3]*+h[b+880>>3]+ +h[b+616>>3]*+h[b+888>>3]);i=i;return}function Fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=+h[b+576>>3]*+h[b+872>>3]+(+h[b+600>>3]*+h[b+880>>3]+ +h[b+624>>3]*+h[b+888>>3]);i=i;return}function Gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+584>>3]*+h[b+872>>3]+(+h[b+608>>3]*+h[b+880>>3]+ +h[b+632>>3]*+h[b+888>>3]);i=i;return}function Hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+984>>3]- +h[b+416>>3];i=i;return}function Ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+984>>3]- +h[b+1536>>3];i=i;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1120>>3]=+h[b+976>>3]- +h[b+408>>3];i=i;return}function Kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+976>>3]- +h[b+1544>>3];i=i;return}function Lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=-(+h[b+8136>>3]*+h[b+1008>>3])- +h[b+8112>>3]*+h[b+1016>>3];i=i;return}function Mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+920>>3]=+h[b+728>>3]+ +h[b+776>>3];i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+920>>3]- +h[b+352>>3];i=i;return}function Oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+704>>3]*+h[g+8704>>3];k=+h[g+680>>3];l=+h[g+8728>>3];m=+h[g+8080>>3]*+h[g+752>>3]+ +h[g+8088>>3]*+h[g+760>>3];if(l!=0.0){n=g;o=m/l;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}if(m==0.0){n=g;o=m;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}u=m/+J9(c[b+536>>2]|0,l,1392,1952,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=k*o;q=j+p;r=n;s=r+744|0;t=s;h[t>>3]=q;i=d;return}function Ph(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+744>>3]- +h[b+632>>3]*+h[b+840>>3]- +h[b+608>>3]*+h[b+832>>3]- +h[b+584>>3]*+h[b+824>>3];i=i;return}function Qh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1e3>>3]=-(+h[b+400>>3]*+h[d+976>>3])- +h[b+392>>3]*+h[d+1056>>3];i=i;return}function Rh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+992>>3]=+h[b+400>>3]*+h[d+984>>3]+ +h[b+384>>3]*+h[d+1056>>3];i=i;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=-(+h[b+8136>>3]*+h[b+992>>3])- +h[b+8112>>3]*+h[b+1e3>>3];i=i;return}function Th(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+488>>3]- +h[b+1056>>3];i=i;return}function Uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+744>>3]+ +h[b+792>>3];i=i;return}function Vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1152>>3]=+h[b+936>>3]- +h[b+368>>3];i=i;return}function Wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+936>>3]+ +h[b+368>>3]- +h[b+488>>3]- +h[b+1056>>3];i=i;return}function Xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+2192>>3]*+h[b+728>>3]+(+h[b+760>>3]- +h[b+720>>3]*+h[b+744>>3]);i=i;return}function Yh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+952>>3]=+h[b+896>>3]*+h[d+936>>3]+(-(+h[b+912>>3]*+h[d+920>>3])- +h[d+904>>3]);i=i;return}function Zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+736>>3]+ +h[b+784>>3];i=i;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=+h[b+928>>3]- +h[b+360>>3];i=i;return}function $h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1096>>3]=+h[b+928>>3]+ +h[b+360>>3]- +h[b+480>>3]- +h[b+1048>>3];i=i;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+712>>3]*+h[b+744>>3]+(+h[b+752>>3]- +h[b+2192>>3]*+h[b+736>>3]);i=i;return}function bi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+944>>3]=+h[b+912>>3]*+h[d+928>>3]+(-(+h[b+904>>3]*+h[d+936>>3])- +h[d+896>>3]);i=i;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+720>>3]*+h[b+736>>3]+(+h[b+768>>3]- +h[b+712>>3]*+h[b+728>>3]);i=i;return}function di(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+960>>3]=+h[b+904>>3]*+h[d+920>>3]+(-(+h[b+896>>3]*+h[d+928>>3])- +h[d+912>>3]);i=i;return}function ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=-(+h[b+8128>>3]*+h[b+1008>>3])- +h[b+8104>>3]*+h[b+1016>>3];i=i;return}function fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+920>>3]+ +h[b+352>>3]- +h[b+472>>3]- +h[b+1040>>3];i=i;return}function gi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+512>>3]=+h[b+1800>>3]*+h[d+1048>>3]+(+h[b+3184>>3]- +h[b+1808>>3]*+h[d+1040>>3]);i=i;return}function hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=-+h[b+392>>3]- +h[b+344>>3]- +h[b+512>>3]- +h[b+960>>3];i=i;return}function ii(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+504>>3]=+h[b+1816>>3]*+h[d+1040>>3]+(+h[d+1024>>3]- +h[b+1800>>3]*+h[d+1056>>3]);i=i;return}function ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=-+h[b+384>>3]- +h[b+336>>3]- +h[b+504>>3]- +h[b+952>>3];i=i;return}function ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=-(+h[b+8128>>3]*+h[b+992>>3])- +h[b+8104>>3]*+h[b+1e3>>3];i=i;return}function li(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+496>>3]=+h[b+1808>>3]*+h[d+1056>>3]+(+h[d+1032>>3]- +h[b+1816>>3]*+h[d+1048>>3]);i=i;return}function mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=-+h[b+376>>3]- +h[b+328>>3]- +h[b+496>>3]- +h[b+944>>3];i=i;return}function ni(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Lca(+h[f+3208>>3],+h[f+3240>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2880;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2048,e);i=b;return}function oi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Lca(+h[f+3232>>3],+h[f+3256>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2904;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2104,e);i=b;return}function pi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((Mca(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8728>>3],1.0e-15)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2248;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2272,e);i=b;return}function qi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((Mca(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8720>>3],1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2448;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2472,e);i=b;return}function ri(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Lca(+h[f+3680>>3],+h[f+3712>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2880;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2048,e);i=b;return}function si(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((Lca(+h[f+3704>>3],+h[f+3728>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=2904;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,2104,e);i=b;return}function ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((Mca(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[a+416>>2]|0)+3960>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[24790]|0;g=d;j=3016;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,3040,e);i=b;return}function ui(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);i=c;return 0}function vi(b){b=b|0;var c=0;c=i;a[b+314|0]=0;wi(b);i=c;return 0}function wi(a){a=a|0;var b=0;b=i;cf(a);hf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);uf(a);vf(a);wf(a);xf(a);yf(a);Df(a);If(a);Nf(a);Of(a);Vf(a);_f(a);$f(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);Ag(a);Bg(a);Cg(a);Dg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);ih(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);sh(a);th(a);Bh(a);Ch(a);i=b;return}function xi(a,b){a=a|0;b=+b;i=i;return 0}function yi(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;G9(c[a+536>>2]|0,(a|0)!=0|0,4192,b);c[a+540>>2]=4e3;c[a+84>>2]=4224;c[a+88>>2]=4224;c[a+92>>2]=4296;c[a+96>>2]=4392;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=4;c[a+116>>2]=1143;c[a+120>>2]=0;c[a+124>>2]=63;c[a+128>>2]=0;c[a+132>>2]=0;c[a+136>>2]=499;c[a+140>>2]=47;c[a+144>>2]=63;c[a+148>>2]=40;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=1182;c[a+220>>2]=33;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;d=a+56|0;e=a+176|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[d>>2]=4432;c[a+64>>2]=6;c[a+72>>2]=0;c[a+68>>2]=2818;c[a+192>>2]=0;c[a+196>>2]=2;c[a+200>>2]=2;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function zi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=QEa(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=50736;F=50760;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[12684]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=QEa(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[11942]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=QEa(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[11942]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=QEa(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;CEa(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=QEa(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;CEa(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=QEa(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[11942]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=QEa(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=QEa(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=QEa(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,4520,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=QEa(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=QEa(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=QEa(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=QEa(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=QEa(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=QEa(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[11942]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=QEa(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=QEa(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=QEa(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=QEa(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Ai(){var a=0;a=i;ud(0)|0;rc(4680,18,1,c[r>>2]|0)|0;ud(0)|0;i=a;return}function Bi(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0;f=i;i=i+120|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+24|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=ta;c[sa>>2]=4;vaa(Aa,1,sa);c[ra>>2]=4;vaa(ua,1,ra);c[qa>>2]=1;c[qa+4>>2]=1;Ba=+h[(Baa(d,2,qa)|0)>>3];c[pa>>2]=2;c[pa+4>>2]=2;Ca=-+h[(Baa(d,2,pa)|0)>>3];c[oa>>2]=3;c[oa+4>>2]=3;Da=Ba+(Ca- +h[(Baa(d,2,oa)|0)>>3])+1.0;c[na>>2]=2;c[na+4>>2]=2;Ca=+h[(Baa(d,2,na)|0)>>3];c[ma>>2]=1;c[ma+4>>2]=1;Ba=-+h[(Baa(d,2,ma)|0)>>3];c[la>>2]=3;c[la+4>>2]=3;Ea=Ca+(Ba- +h[(Baa(d,2,la)|0)>>3])+1.0;c[ka>>2]=3;c[ka+4>>2]=3;Ba=+h[(Baa(d,2,ka)|0)>>3];c[ja>>2]=1;c[ja+4>>2]=1;Ca=-+h[(Baa(d,2,ja)|0)>>3];c[ia>>2]=2;c[ia+4>>2]=2;Fa=Ba+(Ca- +h[(Baa(d,2,ia)|0)>>3])+1.0;c[ha>>2]=1;c[ha+4>>2]=1;Ca=+h[(Baa(d,2,ha)|0)>>3];c[ga>>2]=2;c[ga+4>>2]=2;Ba=+h[(Baa(d,2,ga)|0)>>3];c[fa>>2]=3;c[fa+4>>2]=3;Ga=Ca+(Ba+ +h[(Baa(d,2,fa)|0)>>3])+1.0;do{if(Ga>.04000000000000001){Ha=3}else{if(Ga>Da&Ga>Ea&Ga>Fa){Ha=3;break}if(Da>Ea&Da>Fa&Da>Ga){if(!(Da>=0.0)){fa=c[24790]|0;ga=Y;h[k>>3]=Da;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa;fa=l;ha=4880;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];Ie[ga&31](b,l,4768,Y);}Ba=+V(+Da)*.5;Ca=Ba*4.0;c[X>>2]=1;c[X+4>>2]=2;Ia=+h[(Baa(d,2,X)|0)>>3];c[W>>2]=2;c[W+4>>2]=1;Ja=(Ia+ +h[(Baa(d,2,W)|0)>>3])/Ca;c[U>>2]=1;c[U+4>>2]=3;Ia=+h[(Baa(d,2,U)|0)>>3];c[T>>2]=3;c[T+4>>2]=1;Ka=(Ia+ +h[(Baa(d,2,T)|0)>>3])/Ca;c[S>>2]=2;c[S+4>>2]=3;Ia=+h[(Baa(d,2,S)|0)>>3];c[R>>2]=3;c[R+4>>2]=2;La=(Ia- +h[(Baa(d,2,R)|0)>>3])/Ca;ga=Q;h[k>>3]=Ja;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+8|0;h[k>>3]=Ka;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+16|0;h[k>>3]=La;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];Aaa(wa,4,Ba,Q);waa(wa,ua);break}if(Ea>Da&Ea>Fa&Ea>Ga){if(!(Ea>=0.0)){ga=c[24790]|0;ha=P;h[k>>3]=Ea;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=ga;ga=j;fa=4880;c[ga+0>>2]=c[fa+0>>2];c[ga+4>>2]=c[fa+4>>2];c[ga+8>>2]=c[fa+8>>2];c[ga+12>>2]=c[fa+12>>2];c[ga+16>>2]=c[fa+16>>2];c[ga+20>>2]=c[fa+20>>2];Ie[ha&31](b,j,4824,P);}Ba=+V(+Ea)*.5;La=Ba*4.0;c[O>>2]=1;c[O+4>>2]=2;Ka=+h[(Baa(d,2,O)|0)>>3];c[N>>2]=2;c[N+4>>2]=1;Ja=(Ka+ +h[(Baa(d,2,N)|0)>>3])/La;c[M>>2]=2;c[M+4>>2]=3;Ka=+h[(Baa(d,2,M)|0)>>3];c[L>>2]=3;c[L+4>>2]=2;Ca=(Ka+ +h[(Baa(d,2,L)|0)>>3])/La;c[K>>2]=3;c[K+4>>2]=1;Ka=+h[(Baa(d,2,K)|0)>>3];c[J>>2]=1;c[J+4>>2]=3;Ia=(Ka- +h[(Baa(d,2,J)|0)>>3])/La;ha=I;h[k>>3]=Ba;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+8|0;h[k>>3]=Ca;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+16|0;h[k>>3]=Ia;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];Aaa(xa,4,Ja,I);waa(xa,ua);break}else{if(!(Fa>=0.0)){ha=c[24790]|0;fa=H;h[k>>3]=Fa;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=ha;ha=g;ga=4880;c[ha+0>>2]=c[ga+0>>2];c[ha+4>>2]=c[ga+4>>2];c[ha+8>>2]=c[ga+8>>2];c[ha+12>>2]=c[ga+12>>2];c[ha+16>>2]=c[ga+16>>2];c[ha+20>>2]=c[ga+20>>2];Ie[fa&31](b,g,4904,H);}Ja=+V(+Fa)*.5;Ia=Ja*4.0;c[G>>2]=1;c[G+4>>2]=3;Ca=+h[(Baa(d,2,G)|0)>>3];c[F>>2]=3;c[F+4>>2]=1;Ba=(Ca+ +h[(Baa(d,2,F)|0)>>3])/Ia;c[E>>2]=2;c[E+4>>2]=3;Ca=+h[(Baa(d,2,E)|0)>>3];c[D>>2]=3;c[D+4>>2]=2;La=(Ca+ +h[(Baa(d,2,D)|0)>>3])/Ia;c[C>>2]=1;c[C+4>>2]=2;Ca=+h[(Baa(d,2,C)|0)>>3];c[B>>2]=2;c[B+4>>2]=1;Ka=(Ca- +h[(Baa(d,2,B)|0)>>3])/Ia;fa=A;h[k>>3]=La;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+8|0;h[k>>3]=Ja;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+16|0;h[k>>3]=Ka;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];Aaa(ya,4,Ba,A);waa(ya,ua);break}}}while(0);if((Ha|0)==3){if(!(Ga>=0.0)){Ha=c[24790]|0;ya=ea;h[k>>3]=Ga;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=Ha;Ha=m;A=4880;c[Ha+0>>2]=c[A+0>>2];c[Ha+4>>2]=c[A+4>>2];c[Ha+8>>2]=c[A+8>>2];c[Ha+12>>2]=c[A+12>>2];c[Ha+16>>2]=c[A+16>>2];c[Ha+20>>2]=c[A+20>>2];Ie[ya&31](b,m,4712,ea);}Fa=+V(+Ga)*.5;Ga=Fa*4.0;c[da>>2]=2;c[da+4>>2]=3;Ea=+h[(Baa(d,2,da)|0)>>3];c[ca>>2]=3;c[ca+4>>2]=2;Da=(Ea- +h[(Baa(d,2,ca)|0)>>3])/Ga;c[ba>>2]=3;c[ba+4>>2]=1;Ea=+h[(Baa(d,2,ba)|0)>>3];c[aa>>2]=1;c[aa+4>>2]=3;Ba=(Ea- +h[(Baa(d,2,aa)|0)>>3])/Ga;c[$>>2]=1;c[$+4>>2]=2;Ea=+h[(Baa(d,2,$)|0)>>3];c[_>>2]=2;c[_+4>>2]=1;Ka=(Ea- +h[(Baa(d,2,_)|0)>>3])/Ga;_=Z;h[k>>3]=Ba;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+8|0;h[k>>3]=Ka;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+16|0;h[k>>3]=Fa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];Aaa(va,4,Da,Z);waa(va,ua)}c[z>>2]=1;Da=+h[(Baa(ua,1,z)|0)>>3];c[y>>2]=1;Fa=Da*+h[(Baa(e,1,y)|0)>>3];c[x>>2]=2;Da=+h[(Baa(ua,1,x)|0)>>3];c[w>>2]=2;Ka=Da*+h[(Baa(e,1,w)|0)>>3];c[v>>2]=3;Da=+h[(Baa(ua,1,v)|0)>>3];c[u>>2]=3;Ba=Da*+h[(Baa(e,1,u)|0)>>3];c[t>>2]=4;Da=+h[(Baa(ua,1,t)|0)>>3];c[s>>2]=4;if(!(Fa+(Ka+(Ba+Da*+h[(Baa(e,1,s)|0)>>3]))<0.0)){waa(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}c[r>>2]=1;Da=-+h[(Baa(ua,1,r)|0)>>3];c[q>>2]=2;Ba=-+h[(Baa(ua,1,q)|0)>>3];c[p>>2]=3;Ka=-+h[(Baa(ua,1,p)|0)>>3];c[o>>2]=4;Fa=-+h[(Baa(ua,1,o)|0)>>3];o=n;h[k>>3]=Ba;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Ka;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=Fa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Aaa(za,4,Da,n);waa(za,ua);waa(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}function Ci(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;h[a>>3]=c>d?e:f;i=i;return}function Di(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c>d?c:d;i=i;return}function Ei(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+16|0;S=i;i=i+8|0;T=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+16|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+16|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=yb;c[xb>>2]=3;c[xb+4>>2]=3;vaa($b,2,xb);c[wb>>2]=3;c[wb+4>>2]=3;vaa(zb,2,wb);c[vb>>2]=1;ac=+h[(Baa(d,1,vb)|0)>>3];c[ub>>2]=2;bc=+h[(Baa(d,1,ub)|0)>>3];c[tb>>2]=3;cc=+h[(Baa(d,1,tb)|0)>>3];dc=+V(+(ac*ac+(bc*bc+cc*cc)));c[sb>>2]=3;vaa(Ab,1,sb);if(dc<1.0e-10){sb=Bb;tb=4960;c[sb+0>>2]=c[tb+0>>2];c[sb+4>>2]=c[tb+4>>2];c[sb+8>>2]=c[tb+8>>2]}else{c[rb>>2]=1;cc=+h[(Baa(d,1,rb)|0)>>3]/dc;c[qb>>2]=2;bc=+h[(Baa(d,1,qb)|0)>>3]/dc;c[pb>>2]=3;ac=+h[(Baa(d,1,pb)|0)>>3]/dc;pb=ob;h[k>>3]=bc;c[pb>>2]=c[k>>2];c[pb+4>>2]=c[k+4>>2];pb=ob+8|0;h[k>>3]=ac;c[pb>>2]=c[k>>2];c[pb+4>>2]=c[k+4>>2];Aaa(Bb,3,cc,ob)}ob=Ab;pb=Bb;c[ob+0>>2]=c[pb+0>>2];c[ob+4>>2]=c[pb+4>>2];c[ob+8>>2]=c[pb+8>>2];c[nb>>2]=3;vaa(Cb,1,nb);c[mb>>2]=2;cc=+h[(Baa(Ab,1,mb)|0)>>3];c[lb>>2]=3;ac=cc*+h[(Baa(e,1,lb)|0)>>3];c[kb>>2]=3;cc=+h[(Baa(Ab,1,kb)|0)>>3];c[jb>>2]=2;bc=ac-cc*+h[(Baa(e,1,jb)|0)>>3];c[ib>>2]=3;cc=+h[(Baa(Ab,1,ib)|0)>>3];c[hb>>2]=1;ac=cc*+h[(Baa(e,1,hb)|0)>>3];c[gb>>2]=1;cc=+h[(Baa(Ab,1,gb)|0)>>3];c[fb>>2]=3;dc=ac-cc*+h[(Baa(e,1,fb)|0)>>3];c[eb>>2]=1;cc=+h[(Baa(Ab,1,eb)|0)>>3];c[db>>2]=2;ac=cc*+h[(Baa(e,1,db)|0)>>3];c[cb>>2]=2;cc=+h[(Baa(Ab,1,cb)|0)>>3];c[bb>>2]=1;ec=ac-cc*+h[(Baa(e,1,bb)|0)>>3];bb=ab;h[k>>3]=dc;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];bb=ab+8|0;h[k>>3]=ec;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];Aaa(Db,3,bc,ab);waa(Db,Cb);c[$a>>2]=2;bc=+h[(Baa(Ab,1,$a)|0)>>3];c[_a>>2]=3;ec=bc*+h[(Baa(e,1,_a)|0)>>3];c[Za>>2]=3;bc=+h[(Baa(Ab,1,Za)|0)>>3];c[Ya>>2]=2;dc=ec-bc*+h[(Baa(e,1,Ya)|0)>>3];c[Xa>>2]=3;bc=+h[(Baa(Ab,1,Xa)|0)>>3];c[Wa>>2]=1;ec=bc*+h[(Baa(e,1,Wa)|0)>>3];c[Va>>2]=1;bc=+h[(Baa(Ab,1,Va)|0)>>3];c[Ua>>2]=3;cc=ec-bc*+h[(Baa(e,1,Ua)|0)>>3];c[Ta>>2]=1;bc=+h[(Baa(Ab,1,Ta)|0)>>3];c[Sa>>2]=2;ec=bc*+h[(Baa(e,1,Sa)|0)>>3];c[Ra>>2]=2;bc=+h[(Baa(Ab,1,Ra)|0)>>3];c[Qa>>2]=1;ac=ec-bc*+h[(Baa(e,1,Qa)|0)>>3];Qa=Pa;h[k>>3]=cc;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];Qa=Pa+8|0;h[k>>3]=ac;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];Aaa(Eb,3,dc,Pa);Pa=Cb;Qa=Eb;c[Pa+0>>2]=c[Qa+0>>2];c[Pa+4>>2]=c[Qa+4>>2];c[Pa+8>>2]=c[Qa+8>>2];c[Oa>>2]=3;vaa(Fb,1,Oa);c[Na>>2]=1;dc=+h[(Baa(Cb,1,Na)|0)>>3];c[Ma>>2]=2;ac=+h[(Baa(Cb,1,Ma)|0)>>3];c[La>>2]=3;cc=+h[(Baa(Cb,1,La)|0)>>3];if(dc*dc+(ac*ac+cc*cc)>1.0e-6){c[Ka>>2]=1;cc=+h[(Baa(e,1,Ka)|0)>>3];c[Ja>>2]=2;ac=+h[(Baa(e,1,Ja)|0)>>3];c[Ia>>2]=3;dc=+h[(Baa(e,1,Ia)|0)>>3];Ia=Ha;h[k>>3]=ac;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];Ia=Ha+8|0;h[k>>3]=dc;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];Aaa(Hb,3,cc,Ha)}else{c[Ga>>2]=1;Ha=Gb;if(+U(+(+h[(Baa(Ab,1,Ga)|0)>>3]))>1.0e-6){Ga=4976;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2]}else{Ga=4960;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2]}Ga=Hb;c[Ga+0>>2]=c[Ha+0>>2];c[Ga+4>>2]=c[Ha+4>>2];c[Ga+8>>2]=c[Ha+8>>2]}Ha=Fb;Ga=Hb;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2];c[Fa>>2]=3;vaa(Ib,1,Fa);c[Ea>>2]=2;cc=+h[(Baa(Ab,1,Ea)|0)>>3];c[Da>>2]=3;dc=cc*+h[(Baa(Fb,1,Da)|0)>>3];c[Ca>>2]=3;cc=+h[(Baa(Ab,1,Ca)|0)>>3];c[Ba>>2]=2;ac=dc-cc*+h[(Baa(Fb,1,Ba)|0)>>3];c[Aa>>2]=3;cc=+h[(Baa(Ab,1,Aa)|0)>>3];c[za>>2]=1;dc=cc*+h[(Baa(Fb,1,za)|0)>>3];c[ya>>2]=1;cc=+h[(Baa(Ab,1,ya)|0)>>3];c[xa>>2]=3;bc=dc-cc*+h[(Baa(Fb,1,xa)|0)>>3];c[wa>>2]=1;cc=+h[(Baa(Ab,1,wa)|0)>>3];c[va>>2]=2;dc=cc*+h[(Baa(Fb,1,va)|0)>>3];c[ua>>2]=2;cc=+h[(Baa(Ab,1,ua)|0)>>3];c[ta>>2]=1;ec=dc-cc*+h[(Baa(Fb,1,ta)|0)>>3];ta=sa;h[k>>3]=bc;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];ta=sa+8|0;h[k>>3]=ec;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];Aaa(Jb,3,ac,sa);waa(Jb,Ib);c[ra>>2]=2;ac=+h[(Baa(Ab,1,ra)|0)>>3];c[qa>>2]=3;ec=ac*+h[(Baa(Fb,1,qa)|0)>>3];c[pa>>2]=3;ac=+h[(Baa(Ab,1,pa)|0)>>3];c[oa>>2]=2;bc=ec-ac*+h[(Baa(Fb,1,oa)|0)>>3];c[na>>2]=3;ac=+h[(Baa(Ab,1,na)|0)>>3];c[ma>>2]=1;ec=ac*+h[(Baa(Fb,1,ma)|0)>>3];c[la>>2]=1;ac=+h[(Baa(Ab,1,la)|0)>>3];c[ka>>2]=3;cc=ec-ac*+h[(Baa(Fb,1,ka)|0)>>3];c[ja>>2]=1;ac=+h[(Baa(Ab,1,ja)|0)>>3];c[ia>>2]=2;ec=ac*+h[(Baa(Fb,1,ia)|0)>>3];c[ha>>2]=2;ac=+h[(Baa(Ab,1,ha)|0)>>3];c[ga>>2]=1;dc=ec-ac*+h[(Baa(Fb,1,ga)|0)>>3];ga=fa;h[k>>3]=cc;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=dc;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];Aaa(Kb,3,bc,fa);fa=Ib;ga=Kb;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];c[ea>>2]=3;vaa(Lb,1,ea);c[da>>2]=1;bc=+h[(Baa(Ib,1,da)|0)>>3];c[ca>>2]=2;dc=+h[(Baa(Ib,1,ca)|0)>>3];c[ba>>2]=3;cc=+h[(Baa(Ib,1,ba)|0)>>3];c[aa>>2]=1;ac=+h[(Baa(Ib,1,aa)|0)>>3];c[$>>2]=2;ec=+h[(Baa(Ib,1,$)|0)>>3];c[_>>2]=3;fc=+h[(Baa(Ib,1,_)|0)>>3];c[Z>>2]=1;gc=+h[(Baa(Ib,1,Z)|0)>>3];c[Y>>2]=2;hc=+h[(Baa(Ib,1,Y)|0)>>3];c[X>>2]=3;ic=+h[(Baa(Ib,1,X)|0)>>3];c[W>>2]=1;jc=+h[(Baa(Ib,1,W)|0)>>3]/+V(+(bc*bc+(dc*dc+cc*cc)));c[T>>2]=2;cc=+h[(Baa(Ib,1,T)|0)>>3]/+V(+(ac*ac+(ec*ec+fc*fc)));c[S>>2]=3;fc=+h[(Baa(Ib,1,S)|0)>>3]/+V(+(gc*gc+(hc*hc+ic*ic)));S=R;h[k>>3]=cc;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];S=R+8|0;h[k>>3]=fc;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];Aaa(Mb,3,jc,R);waa(Mb,Lb);c[Q>>2]=1;jc=+h[(Baa(Ib,1,Q)|0)>>3];c[P>>2]=2;fc=+h[(Baa(Ib,1,P)|0)>>3];c[O>>2]=3;cc=+h[(Baa(Ib,1,O)|0)>>3];c[N>>2]=1;ic=+h[(Baa(Ib,1,N)|0)>>3];c[M>>2]=2;hc=+h[(Baa(Ib,1,M)|0)>>3];c[L>>2]=3;gc=+h[(Baa(Ib,1,L)|0)>>3];c[K>>2]=1;ec=+h[(Baa(Ib,1,K)|0)>>3];c[J>>2]=2;ac=+h[(Baa(Ib,1,J)|0)>>3];c[I>>2]=3;dc=+h[(Baa(Ib,1,I)|0)>>3];c[H>>2]=1;bc=+h[(Baa(Ib,1,H)|0)>>3]/+V(+(jc*jc+(fc*fc+cc*cc)));c[G>>2]=2;cc=+h[(Baa(Ib,1,G)|0)>>3]/+V(+(ic*ic+(hc*hc+gc*gc)));c[F>>2]=3;gc=+h[(Baa(Ib,1,F)|0)>>3]/+V(+(ec*ec+(ac*ac+dc*dc)));F=E;h[k>>3]=cc;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E+8|0;h[k>>3]=gc;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Aaa(Nb,3,bc,E);E=Lb;F=Nb;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[D>>2]=1;Daa(+h[(Baa(Ab,1,D)|0)>>3],2,Pb);c[C>>2]=2;Daa(+h[(Baa(Ab,1,C)|0)>>3],2,Qb);c[B>>2]=3;Daa(+h[(Baa(Ab,1,B)|0)>>3],2,Rb);c[A>>2]=2;bc=+h[(Baa(Lb,1,A)|0)>>3];c[z>>2]=3;gc=bc*+h[(Baa(Ab,1,z)|0)>>3];c[y>>2]=3;bc=+h[(Baa(Lb,1,y)|0)>>3];c[x>>2]=2;Daa(gc-bc*+h[(Baa(Ab,1,x)|0)>>3],2,Tb);c[w>>2]=3;bc=+h[(Baa(Lb,1,w)|0)>>3];c[v>>2]=1;gc=bc*+h[(Baa(Ab,1,v)|0)>>3];c[u>>2]=1;bc=+h[(Baa(Lb,1,u)|0)>>3];c[t>>2]=3;Daa(gc-bc*+h[(Baa(Ab,1,t)|0)>>3],2,Ub);c[s>>2]=1;bc=+h[(Baa(Lb,1,s)|0)>>3];c[r>>2]=2;gc=bc*+h[(Baa(Ab,1,r)|0)>>3];c[q>>2]=2;bc=+h[(Baa(Lb,1,q)|0)>>3];c[p>>2]=1;Daa(gc-bc*+h[(Baa(Ab,1,p)|0)>>3],2,Vb);c[o>>2]=1;Daa(+h[(Baa(Lb,1,o)|0)>>3],2,Xb);c[n>>2]=2;Daa(+h[(Baa(Lb,1,n)|0)>>3],2,Yb);c[m>>2]=3;Daa(+h[(Baa(Lb,1,m)|0)>>3],2,Zb);c[l>>2]=Qb;c[l+4>>2]=Rb;Caa(2,Ob,3,Pb,l);c[j>>2]=Ub;c[j+4>>2]=Vb;Caa(2,Sb,3,Tb,j);c[g>>2]=Yb;c[g+4>>2]=Zb;Caa(2,Wb,3,Xb,g);c[f>>2]=Sb;c[f+4>>2]=Wb;Caa(1,_b,3,Ob,f);waa(_b,zb);waa(zb,$b);$b=a;a=yb;c[$b+0>>2]=c[a+0>>2];c[$b+4>>2]=c[a+4>>2];c[$b+8>>2]=c[a+8>>2];i=b;return}function Fi(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;D9(4,0,5056,b);D9(4,0,5096,a);i=a;return}function Gi(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}aEa(a);c[d>>2]=0;i=b;return}function Hi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;j=d+24|0;k=b+4|0;l=b+416|0;m=Mca(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3])|0;n=b+536|0;Di(e,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);o=+h[e>>3];e=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Ci(f,c[n>>2]|0,+h[e+8648>>3],+h[(c[l>>2]|0)+3960>>3],+h[e+8656>>3],0.0);p=+h[f>>3];Di(g,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);q=+h[g>>3];Di(j,c[n>>2]|0,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8648>>3],+h[(c[l>>2]|0)+3960>>3]);r=+h[j>>3];s=r*r;r=s*s;j=c[c[k>>2]>>2]|0;l=c[j+8>>2]|0;s=+h[l+2240>>3];t=-s;g=m<<24>>24!=0;if(r!=0.0){if(g){u=+h[l+8760>>3]}else{u=0.0}v=l;w=(o*o*u*t+p*p*q*s*2.0)/r;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}if(g){A=+h[l+8760>>3]}else{A=0.0}u=o*o;o=p*p*q;if(u*A*t+o*t*-2.0==0.0){if(g){B=+h[l+8760>>3]}else{B=0.0}v=l;w=u*B*t+o*s*2.0;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}else{if(g){C=+h[l+8760>>3]}else{C=0.0}B=(u*C*t+o*s*2.0)/+J9(c[n>>2]|0,r,5152,5144,+h[j>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[k>>2]>>2]|0)+8>>2]|0;w=B;x=v;y=x+1176|0;z=y;h[z>>3]=w;i=d;return}}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+200>>3]=+h[b+1176>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=-(+h[b+1176>>3]*+h[(c[a+416>>2]|0)+3968>>3]);i=i;return}function Ki(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0,E=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+200>>3];k=b+416|0;l=c[k>>2]|0;m=+h[l+3936>>3];n=+h[g+8648>>3];o=+h[l+3952>>3];do{if(n!=0.0){p=n;q=l;r=g;s=f;t=o/n}else{if(o==0.0){p=n;q=l;r=g;s=f;t=o;break}u=o/+J9(c[b+536>>2]|0,n,5280,5272,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[c[e>>2]>>2]|0;w=c[v+8>>2]|0;p=+h[w+8648>>3];q=c[k>>2]|0;r=w;s=v;t=u}}while(0);n=j*m*t;t=+h[r+176>>3];m=+h[q+3944>>3];j=+h[q+3968>>3];if(p!=0.0){x=r;y=j/p;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}if(j==0.0){x=r;y=j;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}o=j/+J9(c[b+536>>2]|0,p,5280,5272,+h[s>>3],(a[b+319|0]|0)!=0|0);x=c[(c[c[e>>2]>>2]|0)+8>>2]|0;y=o;z=m*y;A=t*z;B=n-A;C=x;D=C+152|0;E=D;h[E>>3]=B;i=d;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=(+h[b+8040>>3]*+h[(c[a+416>>2]|0)+2944>>3]+ +h[b+1840>>3]*.35)*6.602749999999998;i=i;return}function Mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+1840>>3]*.2702863223958332+ +h[b+1792>>3]*.35;i=i;return}function Ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+3656>>3]- +h[b+1776>>3];i=i;return}function Oi(a){a=a|0;var b=0,d=0.0,e=0.0,f=0,g=0.0,j=0.0,k=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3];e=-d;f=c[a+416>>2]|0;g=+h[f+2232>>3];j=+h[b+1840>>3];k=+h[f+2240>>3];h[b+1728>>3]=+h[b+8008>>3]*(d*g*e-j*k)+ +h[b+8032>>3]*(g*j+d*k*e);i=i;return}function Pi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+3968>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1728>>3]- +h[j+160>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}q=k/+J9(c[b+536>>2]|0,e,5304,5296,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1160|0;p=o;h[p>>3]=m;i=d;return}function Qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+1160>>3]*+h[(c[a+416>>2]|0)+3952>>3];i=i;return}



function o5(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=He[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){S4(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function p5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=o5(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=b5(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function q5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ie[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=xe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ie[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function r5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ie[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=He[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=c5(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=x5(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function s5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ie[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;w5(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function t5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){S4(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(xe[c[a+32>>2]&63](a,b)|0)|0;k=e5(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=xe[c[a+36>>2]&63](a,e)|0;e=e5(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){v5(e);Ee[c[g+64>>2]&15](c[g+4>>2]|0,k,e);B4(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function u5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){S4(g,a,b,d)}h=1;j=h;i=f;return j|0}k=e5(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){v5(k);ge[c[g+68>>2]&127](c[g+4>>2]|0,k);B4(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function v5(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function w5(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}w5(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function x5(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=He[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-4:{B=17;break a;break};case 9:{a[p]=le[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){Ee[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=e5(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}D=X4(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){Ee[c[E+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[E+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((D|0)==0){B=41;break a}if((a[D+34|0]|0)==0){B=43;break a}}if((a[D+32|0]|0)!=0){B=50;break a}if((c[D+28>>2]|0)!=0){B=52;break a}C=y;if((c[D+4>>2]|0)!=0){E=y;if((a[C+308|0]|0)!=0){F=r5(E,D,0)|0;if((F|0)!=0){B=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){Ee[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;C=z5(y)|0;a[D+32|0]=0;if((C|0)==0){B=63;break a}if((ye[c[y+112>>2]&63](c[y+116>>2]|0,C,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){H=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{H=ie[c[C+12>>2]&127](48)|0;if((H|0)==0){B=72;break a}c[H+36>>2]=ie[c[y+12>>2]&127](32)|0;if((c[H+36>>2]|0)==0){B=74;break a}c[H+40>>2]=(c[H+36>>2]|0)+32}c[H+44>>2]=0;c[H>>2]=c[y+364>>2];c[y+364>>2]=H;c[H+16>>2]=0;c[H+20>>2]=0;c[H+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[H+8>>2]=xe[c[e+32>>2]&63](e,c[H+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[H+4>>2]|0)+(c[H+8>>2]|0)|0;c[r>>2]=c[H+4>>2];c[q>>2]=c[H+36>>2];while(1){ce[c[e+60>>2]&31](e,r,C,q,(c[H+40>>2]|0)+ -1|0);I=(c[q>>2]|0)-(c[H+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}G=(c[H+40>>2]|0)-(c[H+36>>2]|0)<<1;E=xe[c[y+16>>2]&63](c[H+36>>2]|0,G)|0;if((E|0)==0){B=80;break a}c[H+36>>2]=E;c[H+40>>2]=E+G;c[q>>2]=E+I}c[H+24>>2]=I;c[H+12>>2]=c[H+36>>2];a[c[q>>2]|0]=0;J=A5(y,e,c[m>>2]|0,H+12|0,H+44|0)|0;if((J|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){Ee[c[C+52>>2]&15](c[y+4>>2]|0,c[H+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);B4(y+416|0);break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=e5(y+416|0,e,C,C+(xe[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];K=A5(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ee[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ge[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);B4(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}D=c[y+364>>2]|0;c[y+364>>2]=c[D>>2];c[D>>2]=c[y+368>>2];c[y+368>>2]=D;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;C=xe[c[e+32>>2]&63](e,L)|0;if((C|0)!=(c[D+8>>2]|0)){B=112;break a}if((yEa(c[D+4>>2]|0,L,C)|0)!=0){B=112;break a}C=y+312|0;c[C>>2]=(c[C>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){C=c[D+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((C|0)==0){break}E=(c[D+12>>2]|0)+(c[D+28>>2]|0)|0;while(1){if((a[C]|0)==0){break}G=C;C=G+1|0;M=E;E=M+1|0;a[M]=a[G]|0}G=c[D+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}M=E;E=M+1|0;a[M]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}M=G;G=M+1|0;N=E;E=N+1|0;a[N]=a[M]|0}}}while(0);a[E]=0}}while(0);ge[c[y+56>>2]&127](c[y+4>>2]|0,c[D+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[D+44>>2]|0)==0){break}C=c[D+44>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[D+44>>2]=c[(c[D+44>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case-2:{B=28;break a;break};case-3:{B=6;break a;break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{D=xe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((D|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;M=c[y+4>>2]|0;N=O5(D,u)|0;Ee[G&15](M,u,N);break b}if((c[C+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){fe[c[C+72>>2]&511](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=C5(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ee[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ce[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ee[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((t5(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((u5(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}S4(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=F;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){fe[c[y+20>>2]&511](H);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=J;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=K;Q=P;i=l;return Q|0}else if((B|0)==107){P=B5(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=L;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=B5(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ee[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ce[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ee[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}S4(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function y5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=He[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=c5(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=x5(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=c5(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=x5(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function z5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((U4(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);V4(e,b+60|0);a:while(1){k=W4(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){V4(e,b);b:while(1){b=W4(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((U4(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function A5(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=X4(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=D4(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=X4(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((G5(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=He[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=xe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}He[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=i5(k,b,v,w+(xe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=e5(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=m5(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=$4(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=$4(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=xe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(X4(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((U4(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((U4(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((U4(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ie[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;FEa(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}fe[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;FEa(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;FEa(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function B5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-4:{k=7;break a;break};case 0:{k=14;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}S4(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case 13:{if((u5(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-15:{k=3;break a;break};case 11:{if((t5(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){S4(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function C5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=He[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 40:{r=6;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ee[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}S4(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}S4(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ee[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ce[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ee[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-2:{r=25;break a;break};case 0:{r=24;break a;break};case-4:case-1:{r=28;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){fe[c[n+76>>2]&511](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}S4(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function D5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=C5(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=E5(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=g5(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function E5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=x5(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((F5(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function F5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=xe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}FEa(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function G5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((U4(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((U4(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=X4(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function H5(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(He[c[b+16>>2]&63](b,f,g,l)|0){case 10:{o=xe[c[b+44>>2]&63](b,f)|0;if((o|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((o|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);o=O5(o,m)|0;if((o|0)==0){p=19;break a}q=0;while(1){if((q|0)>=(o|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((U4(h)|0)<<24>>24!=0)){p=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 0:{p=4;break a;break};case-4:{p=3;break a;break};case-1:{p=7;break a;break};case 7:case 39:{p=31;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 9:{q=(le[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((U4(h)|0)<<24>>24!=0)){p=42;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;break b}q=e5(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){p=44;break a}r=X4(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=H5(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){p=74;break a}break};case 6:{if((k5(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((U4(h)|0)<<24>>24!=0)){p=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=y;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function I5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((le[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=P5()|0;c[g+240>>2]=ie[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=He[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){fe[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}fe[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function J5(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=LEa()|0;i=a;return b|0}function K5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=a5(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=b5(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function L5(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ie[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{M5(f+80|0,e);M5(b+104|0,e);N5(b,e);N5(b+20|0,e);N5(b+40|0,e);N5(b+60|0,e);a[b+131|0]=0;N5(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function M5(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function N5(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function O5(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function P5(){i=i;return 1912}function Q5(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[47152+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[47228+l|0]|0|0)!=28){if((d[47228+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[47228+q|0]|0|0)!=28){if((d[47228+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[47228+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((R5(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[41320+(((d[41064+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[41320+(((d[42600+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=O5(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function R5(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[47228+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function S5(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[41320+(((d[42600+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function T5(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[41320+(((d[41064+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function U5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=xe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(R5(a)|0)<0;g=f&1;i=d;return g|0}function V5(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=O5(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function W5(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function X5(){i=i;return 46784}function Y5(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Z5(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Z5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((l6(d,c[46688+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function _5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=j8(45128,a,0,b,c,d)|0;i=e;return f|0}function $5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=j8(45128,a,1,b,c,d)|0;i=e;return f|0}function a6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;I7(45896,b,c,d);i=a;return}function b6(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=c6(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function c6(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(k8(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,46632)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((k8(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,46640)|0)!=0){h=l8(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=le[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((k8(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,46656)|0)!=0){if((a|0)!=0){break}do{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,46672)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,46680)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((m8(l8(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function d6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((l6(h,42856)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Z5(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[45128+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function e6(){i=i;return 44760}function f6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Z5(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function g6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=j8(42864,a,0,b,c,d)|0;i=e;return f|0}function h6(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=j8(42864,a,1,b,c,d)|0;i=e;return f|0}function i6(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=c6(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function j6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((l6(h,42856)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Z5(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[42864+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function k6(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Q5(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function l6(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function m6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}switch(n|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=P6(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 13:{k=P6(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 29:{g=b;if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[41320+((d[42600+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 19:{k=R6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 30:{k=F6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=D6(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{k=L6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=Q6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{o=18;b=b+2|0;p=77;break};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=D6(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=D6(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 34:{p=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=83;break b}break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=D6(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 5:{p=105;break b;break};case 6:{p=108;break b;break};case 7:{p=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=103;break b}break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 6:{p=88;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 5:{p=85;break b;break};case 33:{p=119;break b;break};case 15:{p=122;break b;break};case 7:{p=91;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}function n6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=I6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 3:{k=E6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=D6(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function o6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=D6(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function p6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=D6(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function q6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=D6(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 2:{n=15;break a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=E6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=D6(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function r6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=D6(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 3:{n=12;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 30:{n=15;break a;break};case 10:{n=18;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=E6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=F6(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=D6(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function s6(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=D6(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=D6(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function t6(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function u6(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=D6(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function v6(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=D6(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function w6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=D6(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=D6(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function x6(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=R5(c)|0;k=j;i=b;return k|0}function y6(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){h=a[e]|0}else{h=-1}if((h|0)==103){f=62;g=f;i=b;return g|0}else if((h|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function z6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=D6(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=D6(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function A6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=D6(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function B6(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function C6(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function D6(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 255:{if(!(((b&255)+ -254|0)>>>0<2)){d=6;break a}e=0;break};case 219:case 218:case 217:case 216:{e=7;break};case 223:case 222:case 221:case 220:{e=8;break};default:{d=6}}}while(0);if((d|0)==6){e=29}i=c;return e|0}function E6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=G6(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=D6(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function F6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 29:{if((c[41320+((d[41064+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=D6(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[41320+((d[42600+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function G6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=H6(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=D6(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function H6(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=D6(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=D6(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}



function p4(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(Hba(a,38640)|0)!=0;v=c[(u?f:g)>>2]|0;w=Hba(e,38648)|0;x=Hba(b,38656)|0;c[p>>2]=0;do{if(u){y=4}else{if((Hba(a,38664)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((Hba(b,38640)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((Hba(d,38648)|0)==0){if((Hba(d,38672)|0)!=0){break}if((Hba(d,38680)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((Hba(e,38656)|0)==0){if((Hba(e,38648)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){HEa(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(Hba(d,38648)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(38688,p|0)|0;i=o;return 0}function q4(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}s4(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}t4(38704,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(38696,l|0)|0;i=k;return 0}function r4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+oba(38728);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(k4(l,z,38736)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){m4(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;l4(l,n,d+(x-o+v<<3)|0,38736)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;n4(l,m,38744,d+(B+y<<3)|0,38736,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(38720,k|0)|0;i=j;return 0}function s4(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=38776;u=v4(38760,38752,38768,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;r4(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;u4(k,d,e,m,l,f,38760)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;u4(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,38760)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;p4(38784,38792,38800,38816,n,k,38824,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=38800;o4(H,H,k,l,n,38832,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,38824,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);r4(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(38752,j|0)|0;i=h;return 0}function t4(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(Hba(a,38840)|0)!=0;do{if(n){o=5}else{if((Hba(a,38848)|0)!=0){o=5;break}if((Hba(a,38856)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=38872;u4(d,h,j,q,b,g,q)|0;p4(38880,38888,38896,38912,b,d,38920,e,f,h,j)|0;p4(38880,38928,38896,38936,b,d,38920,e,f,h,j)|0;i=l;return 0}else{p4(38880,38928,38952,38936,b,d,38920,e,f,h,j)|0;p4(38880,38888,38952,38912,b,d,38920,e,f,h,j)|0;u4(d,h,j,38872,b,g,38968)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(38864,m|0)|0;i=l;return 0}function u4(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function v4(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=DEa(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;Kra(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;Kra(t,o+1|0,1,2);l=m;Kra(l,o+3|0,1,3);o=n;Kra(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((Jra(t,38976,1,2)|0)==0){if((Jra(l,38992,1,3)|0)==0){v=128;i=k;return v|0}if((Jra(l,39e3,1,3)|0)==0){v=128;i=k;return v|0}if((Jra(l,39008,1,3)|0)==0){v=128;i=k;return v|0}if((Jra(l,39016,1,3)|0)==0){v=128;i=k;return v|0}if((Jra(l,39024,1,3)|0)==0){v=128;i=k;return v|0}n=(Jra(l,39032,1,3)|0)==0;v=n?128:0;i=k;return v|0}if((Jra(t,39056,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}n=(Jra(l,39064,1,3)|0)==0;v=n?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((Jra(t,39080,1,2)|0)==0){n=(Jra(l,39064,1,3)|0)==0;v=n?32:0;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=141;break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((Jra(t,39088,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((Jra(t,39152,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else if((m|0)==2){if((Jra(t,38976,1,2)|0)==0){if((Jra(l,38992,1,3)|0)==0){v=2;i=k;return v|0}if((Jra(l,39e3,1,3)|0)==0){v=2;i=k;return v|0}if((Jra(l,39008,1,3)|0)==0){v=2;i=k;return v|0}if((Jra(l,39016,1,3)|0)==0){v=2;i=k;return v|0}if((Jra(l,39024,1,3)|0)==0){v=2;i=k;return v|0}if((Jra(l,39032,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((Jra(t,39056,1,2)|0)==0){m=(Jra(l,38984,1,3)|0)==0;if(m|(p|q)^1){v=m?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((Jra(t,39080,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((Jra(t,39088,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}m=a[l]|0;if(m<<24>>24==71){if((Jra(o,39096,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39104,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39112,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39120,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39128,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39136,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==77){if((Jra(o,39096,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39104,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39112,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39120,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39128,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39136,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((Jra(t,39152,1,2)|0)!=0){v=2;i=k;return v|0}m=a[l]|0;if(m<<24>>24==71){if((Jra(o,39096,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39104,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39112,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39120,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39128,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39136,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==77){if((Jra(o,39096,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39104,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39112,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39120,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39128,1,2)|0)==0){v=2;i=k;return v|0}if((Jra(o,39136,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else{if((Jra(t,38976,1,2)|0)==0){if((Jra(l,38984,1,3)|0)==0){v=64;i=k;return v|0}if((Jra(l,38992,1,3)|0)==0){v=32;i=k;return v|0}if((Jra(l,39e3,1,3)|0)==0){v=32;i=k;return v|0}if((Jra(l,39008,1,3)|0)==0){v=32;i=k;return v|0}if((Jra(l,39016,1,3)|0)==0){v=32;i=k;return v|0}if((Jra(l,39024,1,3)|0)==0){v=32;i=k;return v|0}if((Jra(l,39032,1,3)|0)==0){v=32;i=k;return v|0}m=(Jra(l,39040,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((Jra(t,39048,1,2)|0)==0){m=(Jra(l,38984,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((Jra(t,39056,1,2)|0)==0){m=(Jra(l,38984,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(Jra(l,39064,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(Jra(l,39072,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((Jra(t,39080,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((Jra(l,38984,1,3)|0)==0){v=64;i=k;return v|0}if((Jra(l,39064,1,3)|0)==0){v=32;i=k;return v|0}m=(Jra(l,39072,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((Jra(t,39088,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((Jra(t,39152,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((Jra(o,39096,1,2)|0)!=0){if((Jra(o,39104,1,2)|0)==0){break}if((Jra(o,39112,1,2)|0)==0){break}if((Jra(o,39120,1,2)|0)==0){break}if((Jra(o,39128,1,2)|0)==0){break}if((Jra(o,39136,1,2)|0)==0){break}if((Jra(o,39144,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((Jra(t,39160,1,2)|0)==0){if((Jra(l,38984,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((Jra(t,39168,1,2)|0)==0){if((Jra(l,38984,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((Jra(t,39136,1,2)|0)==0){o=(Jra(l,39040,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((Jra(t,39176,1,2)|0)==0){o=(Jra(l,39184,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((Jra(t,39192,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=w4(39208,39216,39224)|0;i=k;return v|0};case 11:{v=w4(39232,39216,39224)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=x4(b,d,e,f,g,h,j)|0;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 4:{v=6;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function w4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function x4(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(Ira(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 12:{p=75;i=j;return p|0};case 15:{p=o;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 14:{p=14;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function y4(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=z4(a,0,0)|0;i=b;return c|0}function z4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=A4(a,b,c,0)|0;i=d;return e|0}function A4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ie[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=$Da(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=268}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ie[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){fe[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ie[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){fe[c[b+20>>2]&511](c[j+392>>2]|0);fe[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=L5(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}fe[c[j+20>>2]&511](c[j+44>>2]|0);fe[c[j+20>>2]&511](c[j+392>>2]|0);fe[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;M5(j+416|0,j+12|0);M5(j+440|0,j+12|0);C4(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}F4(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=e6()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=X5()|0}k=j;l=k;i=g;return l|0}function B4(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function C4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;n8(f+256|0);if((b|0)!=0){g=D4(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Y5(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function D4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((U4(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function E4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=X4(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=D4(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((U4(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((U4(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if(($4(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((U4(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=X4(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function F4(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;fe[c[e+20>>2]&511](c[g+36>>2]|0);G4(c[g+44>>2]|0,e);fe[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;fe[c[e+20>>2]&511](f)}G4(c[h+376>>2]|0,e);G4(c[e+372>>2]|0,e);H4(e+416|0);H4(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}I4(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);fe[c[e+20>>2]&511](c[e+392>>2]|0);fe[c[e+20>>2]&511](c[e+464>>2]|0);fe[c[e+20>>2]&511](c[e+8>>2]|0);fe[c[e+20>>2]&511](c[e+44>>2]|0);fe[c[e+20>>2]&511](c[e+396>>2]|0);fe[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){fe[c[e+252>>2]&511](c[e+244>>2]|0)}fe[c[e+20>>2]&511](e);i=d;return}function G4(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;fe[c[a+20>>2]&511](c[b+16>>2]|0);fe[c[a+20>>2]&511](b)}i=d;return}function H4(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function I4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;V4(f,g+20|0);while(1){d=W4(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}fe[c[b+8>>2]&511](c[d+20>>2]|0)}_4(g);_4(g+132|0);_4(g+20|0);_4(g+40|0);_4(g+60|0);H4(g+80|0);H4(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&511](o);i=e;return}fe[c[b+8>>2]&511](c[g+184>>2]|0);fe[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&511](o);i=e;return}function J4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function K4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function L4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((M4(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=O4(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{FEa(f|0,b|0,d|0)|0;j=P4(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=He[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Ie[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function M4(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=J5()|0}if((a[e+236|0]|0)!=0){f=E4(e,41016)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function N4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function O4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;GEa(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ie[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;FEa(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;fe[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function P4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((M4(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=He[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Ie[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Q4(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function R4(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ie[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function S4(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ce[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function T4(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[39240+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function U4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;FEa((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=xe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ie[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){FEa(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function V4(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function W4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function X4(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ie[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){HEa(c[m>>2]|0,0,g|0)|0;g=Y4(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Y4(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Z4(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ie[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}HEa(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Y4(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}fe[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ie[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){HEa(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Y4(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Z4(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function _4(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}fe[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}fe[e&511](c[d>>2]|0);i=b;return}function $4(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[40824+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[40864+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=xe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ie[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ie[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}fe[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;FEa(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ee[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function a5(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((le[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=I5(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function b5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=c5(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function c5(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ye[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=d5(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=X4(o,l+132|0,40896,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=e5(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}f5(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=e5(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;B4(o+416|0);h=0;break};case 57:{v=d5(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=i5(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);B4(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=X4(o,l+132|0,40896,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}fe[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=h5(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=41e3}else{x=(s|0)==32?40984:41008}if((j5(o+416|0,x)|0)==0){r=111;break a}if((k5(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=40904;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=40912;r=102;break};case 25:{c[o+332>>2]=40920;r=102;break};case 26:{c[o+332>>2]=40928;r=102;break};case 27:{c[o+332>>2]=40936;r=102;break};case 28:{c[o+332>>2]=40944;r=102;break};case 29:{c[o+332>>2]=40960;r=102;break};case 30:{c[o+332>>2]=40968;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((l5(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((U4(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((U4(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);B4(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=e5(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=40896}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=X4(o,l+132|0,40896,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=m5(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((l5(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((U4(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((U4(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);B4(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=n5(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=e5(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;re[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((le[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=e5(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=X4(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=e5(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=X4(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=e5(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){S4(o,b,e,c[n>>2]|0)}h=0;D=o5(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=e5(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}f5(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=e5(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);B4(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);B4(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ie[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=xe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=xe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=q5(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=e5(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=X4(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ee[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=r5(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=h5(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ie[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((u5(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((t5(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=e5(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=q5(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=h5(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=s5(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=e5(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}f5(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}S4(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=He[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ye[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=X4(o,l+132|0,40896,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=g5(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function d5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((he[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=e5(n+440|0,p,b,s+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=e5(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ie[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}S4(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=e5(n+440|0,e,d,m+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=I5(n,f)|0;B4(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){B4(n+440|0)}q=0;r=q;i=g;return r|0}function e5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((k5(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((U4(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function f5(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function g5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=x5(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((F5(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function h5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=e5(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=X4(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((G5(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function i5(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((U4(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=e5(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=X4(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=X4(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((U4(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((U4(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=X4(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function j5(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((U4(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function k5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((U4(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ce[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((U4(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function l5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ie[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=xe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function m5(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=H5(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((U4(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function n5(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((U4(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(He[c[b+20>>2]&63](b,e,f,j)|0){case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=e5(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=X4(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=n5(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ye[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 0:{r=49;break a;break};case 6:case 9:{if((k5(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 10:{s=xe[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=O5(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((U4(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case 7:{r=28;break};case-4:{r=24;break a;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case-1:{r=46;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((U4(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}



function xAa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=123944;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);Ota(b+144|0,123928,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[128836>>2]=0;c[32208]=122424;if(!((c[30612]|0)==-1)){c[G>>2]=122448;c[G+4>>2]=291;c[G+8>>2]=0;Hta(122448,G,292)}yAa(b,128832,(c[122452>>2]|0)+ -1|0);c[128828>>2]=0;c[32206]=122464;if(!((c[30622]|0)==-1)){c[F>>2]=122488;c[F+4>>2]=291;c[F+8>>2]=0;Hta(122488,F,292)}yAa(b,128824,(c[122492>>2]|0)+ -1|0);c[128812>>2]=0;c[32202]=124040;c[128816>>2]=0;a[128820|0]=0;F=c[(yc()|0)>>2]|0;c[128816>>2]=F;if(!((c[31006]|0)==-1)){c[E>>2]=124024;c[E+4>>2]=291;c[E+8>>2]=0;Hta(124024,E,292)}yAa(b,128808,(c[124028>>2]|0)+ -1|0);c[128804>>2]=0;c[32200]=125e3;if(!((c[31004]|0)==-1)){c[D>>2]=124016;c[D+4>>2]=291;c[D+8>>2]=0;Hta(124016,D,292)}yAa(b,128800,(c[124020>>2]|0)+ -1|0);c[128796>>2]=0;c[32198]=125216;if(!((c[31022]|0)==-1)){c[C>>2]=124088;c[C+4>>2]=291;c[C+8>>2]=0;Hta(124088,C,292)}yAa(b,128792,(c[124092>>2]|0)+ -1|0);c[128780>>2]=0;c[32194]=124112;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);c[128784>>2]=c[30978];if(!((c[31024]|0)==-1)){c[B>>2]=124096;c[B+4>>2]=291;c[B+8>>2]=0;Hta(124096,B,292)}yAa(b,128776,(c[124100>>2]|0)+ -1|0);c[128772>>2]=0;c[32192]=125440;if(!((c[31038]|0)==-1)){c[A>>2]=124152;c[A+4>>2]=291;c[A+8>>2]=0;Hta(124152,A,292)}yAa(b,128768,(c[124156>>2]|0)+ -1|0);c[128764>>2]=0;c[32190]=125560;if(!((c[31040]|0)==-1)){c[z>>2]=124160;c[z+4>>2]=291;c[z+8>>2]=0;Hta(124160,z,292)}yAa(b,128760,(c[124164>>2]|0)+ -1|0);c[128740>>2]=0;c[32184]=124192;a[128744|0]=46;a[128745|0]=44;z=128748|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[31042]|0)==-1)){c[y>>2]=124168;c[y+4>>2]=291;c[y+8>>2]=0;Hta(124168,y,292)}yAa(b,128736,(c[124172>>2]|0)+ -1|0);c[128708>>2]=0;c[32176]=124232;c[128712>>2]=46;c[128716>>2]=44;y=128720|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[31044]|0)==-1)){c[x>>2]=124176;c[x+4>>2]=291;c[x+8>>2]=0;Hta(124176,x,292)}yAa(b,128704,(c[124180>>2]|0)+ -1|0);c[128700>>2]=0;c[32174]=122504;if(!((c[30640]|0)==-1)){c[w>>2]=122560;c[w+4>>2]=291;c[w+8>>2]=0;Hta(122560,w,292)}yAa(b,128696,(c[122564>>2]|0)+ -1|0);c[128692>>2]=0;c[32172]=122624;if(!((c[30670]|0)==-1)){c[v>>2]=122680;c[v+4>>2]=291;c[v+8>>2]=0;Hta(122680,v,292)}yAa(b,128688,(c[122684>>2]|0)+ -1|0);c[128684>>2]=0;c[32170]=122696;if(!((c[30686]|0)==-1)){c[u>>2]=122744;c[u+4>>2]=291;c[u+8>>2]=0;Hta(122744,u,292)}yAa(b,128680,(c[122748>>2]|0)+ -1|0);c[128676>>2]=0;c[32168]=122760;if(!((c[30702]|0)==-1)){c[t>>2]=122808;c[t+4>>2]=291;c[t+8>>2]=0;Hta(122808,t,292)}yAa(b,128672,(c[122812>>2]|0)+ -1|0);c[128668>>2]=0;c[32166]=123352;if(!((c[30850]|0)==-1)){c[s>>2]=123400;c[s+4>>2]=291;c[s+8>>2]=0;Hta(123400,s,292)}yAa(b,128664,(c[123404>>2]|0)+ -1|0);c[128660>>2]=0;c[32164]=123416;if(!((c[30866]|0)==-1)){c[r>>2]=123464;c[r+4>>2]=291;c[r+8>>2]=0;Hta(123464,r,292)}yAa(b,128656,(c[123468>>2]|0)+ -1|0);c[128652>>2]=0;c[32162]=123480;if(!((c[30882]|0)==-1)){c[q>>2]=123528;c[q+4>>2]=291;c[q+8>>2]=0;Hta(123528,q,292)}yAa(b,128648,(c[123532>>2]|0)+ -1|0);c[128644>>2]=0;c[32160]=123544;if(!((c[30898]|0)==-1)){c[p>>2]=123592;c[p+4>>2]=291;c[p+8>>2]=0;Hta(123592,p,292)}yAa(b,128640,(c[123596>>2]|0)+ -1|0);c[128636>>2]=0;c[32158]=123608;if(!((c[30908]|0)==-1)){c[o>>2]=123632;c[o+4>>2]=291;c[o+8>>2]=0;Hta(123632,o,292)}yAa(b,128632,(c[123636>>2]|0)+ -1|0);c[128628>>2]=0;c[32156]=123688;if(!((c[30928]|0)==-1)){c[n>>2]=123712;c[n+4>>2]=291;c[n+8>>2]=0;Hta(123712,n,292)}yAa(b,128624,(c[123716>>2]|0)+ -1|0);c[128620>>2]=0;c[32154]=123744;if(!((c[30942]|0)==-1)){c[m>>2]=123768;c[m+4>>2]=291;c[m+8>>2]=0;Hta(123768,m,292)}yAa(b,128616,(c[123772>>2]|0)+ -1|0);c[128612>>2]=0;c[32152]=123792;if(!((c[30954]|0)==-1)){c[l>>2]=123816;c[l+4>>2]=291;c[l+8>>2]=0;Hta(123816,l,292)}yAa(b,128608,(c[123820>>2]|0)+ -1|0);c[128596>>2]=0;c[32148]=122840;c[128600>>2]=122888;if(!((c[30730]|0)==-1)){c[k>>2]=122920;c[k+4>>2]=291;c[k+8>>2]=0;Hta(122920,k,292)}yAa(b,128592,(c[122924>>2]|0)+ -1|0);c[128580>>2]=0;c[32144]=122992;c[128584>>2]=123040;if(!((c[30768]|0)==-1)){c[j>>2]=123072;c[j+4>>2]=291;c[j+8>>2]=0;Hta(123072,j,292)}yAa(b,128576,(c[123076>>2]|0)+ -1|0);c[128564>>2]=0;c[32140]=124936;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);c[128568>>2]=c[30978];c[32140]=123288;if(!((c[30826]|0)==-1)){c[h>>2]=123304;c[h+4>>2]=291;c[h+8>>2]=0;Hta(123304,h,292)}yAa(b,128560,(c[123308>>2]|0)+ -1|0);c[128548>>2]=0;c[32136]=124936;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);c[128552>>2]=c[30978];c[32136]=123320;if(!((c[30834]|0)==-1)){c[g>>2]=123336;c[g+4>>2]=291;c[g+8>>2]=0;Hta(123336,g,292)}yAa(b,128544,(c[123340>>2]|0)+ -1|0);c[128540>>2]=0;c[32134]=123832;if(!((c[30964]|0)==-1)){c[f>>2]=123856;c[f+4>>2]=291;c[f+8>>2]=0;Hta(123856,f,292)}yAa(b,128536,(c[123860>>2]|0)+ -1|0);c[128532>>2]=0;c[32132]=123872;if((c[30974]|0)==-1){N=123896;O=123896;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=128528;yAa(b,T,S);i=e;return}c[H>>2]=123896;c[H+4>>2]=291;c[H+8>>2]=0;Hta(123896,H,292);N=123896;O=123896;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=128528;yAa(b,T,S);i=e;return}function yAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;lta(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){DCa(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}mta(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function zAa(a){a=a|0;var b=0;b=i;AAa(a);hEa(a);i=b;return}function AAa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=123944;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{mta(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Wta(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{hEa(h);i=d;return}}function BAa(){var b=0,d=0,e=0,f=0;b=i;if((a[124e3]|0)!=0){d=123992;e=c[30998]|0;i=b;return e|0}if((Za(124e3)|0)==0){d=123992;e=c[30998]|0;i=b;return e|0}do{if((a[123976]|0)==0){if((Za(123976)|0)==0){break}xAa(128368,1);c[30990]=128368;c[30992]=123960;Tb(123976)}}while(0);f=c[c[30992]>>2]|0;c[30996]=f;lta(f);c[30998]=123984;Tb(124e3);d=123992;e=c[30998]|0;i=b;return e|0}function CAa(a){a=a|0;var b=0,d=0;b=i;d=c[(BAa()|0)>>2]|0;c[a>>2]=d;lta(d);i=b;return}function DAa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;lta(e);i=d;return}function EAa(a){a=a|0;var b=0;b=i;mta(c[a>>2]|0)|0;i=b;return}function FAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=291;c[e+8>>2]=0;Hta(a,e,292)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function GAa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=291;c[e+8>>2]=0;Hta(a,e,292)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;GDa(h);j=139584;k=127;Td(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;GDa(h);j=139584;k=127;Td(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function HAa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function IAa(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}fe[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function JAa(a){a=a|0;var b=0;b=c[31002]|0;c[31002]=1+b;c[a+4>>2]=b+1;i=i;return}function KAa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function LAa(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function MAa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function NAa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function OAa(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function PAa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function QAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function RAa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function SAa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function TAa(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function UAa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function VAa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function WAa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function XAa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=124040;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}iEa(e)}}while(0);hEa(b);i=d;return}function YAa(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=124040;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}iEa(e);i=d;return}function ZAa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function _Aa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function $Aa(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function aBa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Id()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function bBa(a,b){a=a|0;b=b|0;i=i;return b|0}function cBa(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function dBa(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function eBa(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function fBa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function gBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function hBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function iBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function jBa(a){a=a|0;i=i;return 1}function kBa(a){a=a|0;i=i;return 1}function lBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function mBa(a){a=a|0;i=i;return 1}function nBa(a){a=a|0;var b=0;b=i;vAa(a);hEa(a);i=b;return}function oBa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=fDa(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=eDa(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=eDa(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function pBa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=bDa(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=aDa(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=aDa(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function qBa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=eDa(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function rBa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=dDa(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function sBa(a){a=a|0;i=i;return 0}function tBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=$Ca(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function uBa(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function vBa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function wBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=xBa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function xBa(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function yBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=zBa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function zBa(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function ABa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function BBa(a){a=a|0;i=i;return 0}function CBa(a){a=a|0;i=i;return 0}function DBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=EBa(c,d,e,1114111,0)|0;i=b;return a|0}function EBa(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function FBa(a){a=a|0;i=i;return 4}function GBa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function HBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=IBa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function IBa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function JBa(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=KBa(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function KBa(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function LBa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function MBa(a){a=a|0;i=i;return 0}function NBa(a){a=a|0;i=i;return 0}function OBa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=PBa(c,d,e,1114111,0)|0;i=b;return a|0}function PBa(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function QBa(a){a=a|0;i=i;return 4}function RBa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function SBa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function TBa(a){a=a|0;var b=0;b=i;c[a>>2]=124192;Wta(a+12|0);hEa(a);i=b;return}function UBa(a){a=a|0;var b=0;b=i;c[a>>2]=124192;Wta(a+12|0);i=b;return}function VBa(a){a=a|0;var b=0;b=i;c[a>>2]=124232;Wta(a+16|0);hEa(a);i=b;return}function WBa(a){a=a|0;var b=0;b=i;c[a>>2]=124232;Wta(a+16|0);i=b;return}function XBa(b){b=b|0;i=i;return a[b+8|0]|0}function YBa(a){a=a|0;i=i;return c[a+8>>2]|0}function ZBa(b){b=b|0;i=i;return a[b+9|0]|0}function _Ba(a){a=a|0;i=i;return c[a+12>>2]|0}function $Ba(a,b){a=a|0;b=b|0;var c=0;c=i;Mta(a,b+12|0);i=c;return}function aCa(a,b){a=a|0;b=b|0;var c=0;c=i;Mta(a,b+16|0);i=c;return}function bCa(a,b){a=a|0;b=b|0;b=i;Ota(a,124264,4);i=b;return}function cCa(a,b){a=a|0;b=b|0;b=i;wua(a,124272,BDa(124272)|0);i=b;return}function dCa(a,b){a=a|0;b=b|0;b=i;Ota(a,124296,5);i=b;return}function eCa(a,b){a=a|0;b=b|0;b=i;wua(a,124304,BDa(124304)|0);i=b;return}function fCa(b){b=b|0;var d=0,e=0;b=i;if((a[124336]|0)!=0){d=124328;e=c[31082]|0;i=b;return e|0}if((Za(124336)|0)==0){d=124328;e=c[31082]|0;i=b;return e|0}do{if((a[131536]|0)==0){if((Za(131536)|0)==0){break}HEa(131368,0,168)|0;Zd(294,0,q|0)|0;Tb(131536)}}while(0);Zta(131368,131544)|0;Zta(131380|0,131552)|0;Zta(131392|0,131560)|0;Zta(131404|0,131568)|0;Zta(131416|0,131584)|0;Zta(131428|0,131600)|0;Zta(131440|0,131608)|0;Zta(131452|0,131624)|0;Zta(131464|0,131632)|0;Zta(131476|0,131640)|0;Zta(131488|0,131648)|0;Zta(131500|0,131656)|0;Zta(131512|0,131664)|0;Zta(131524|0,131672)|0;c[31082]=131368;Tb(124336);d=124328;e=c[31082]|0;i=b;return e|0}function gCa(b){b=b|0;var d=0,e=0;b=i;if((a[124352]|0)!=0){d=124344;e=c[31086]|0;i=b;return e|0}if((Za(124352)|0)==0){d=124344;e=c[31086]|0;i=b;return e|0}do{if((a[131e3]|0)==0){if((Za(131e3)|0)==0){break}HEa(130832,0,168)|0;Zd(295,0,q|0)|0;Tb(131e3)}}while(0);zua(130832,131008)|0;zua(130844|0,131040)|0;zua(130856|0,131072)|0;zua(130868|0,131104)|0;zua(130880|0,131144)|0;zua(130892|0,131184)|0;zua(130904|0,131216)|0;zua(130916|0,131256)|0;zua(130928|0,131272)|0;zua(130940|0,131288)|0;zua(130952|0,131304)|0;zua(130964|0,131320)|0;zua(130976|0,131336)|0;zua(130988|0,131352)|0;c[31086]=130832;Tb(124352);d=124344;e=c[31086]|0;i=b;return e|0}function hCa(b){b=b|0;var d=0,e=0;b=i;if((a[124368]|0)!=0){d=124360;e=c[31090]|0;i=b;return e|0}if((Za(124368)|0)==0){d=124360;e=c[31090]|0;i=b;return e|0}do{if((a[130608]|0)==0){if((Za(130608)|0)==0){break}HEa(130320,0,288)|0;Zd(296,0,q|0)|0;Tb(130608)}}while(0);Zta(130320,130616)|0;Zta(130332|0,130624)|0;Zta(130344|0,130640)|0;Zta(130356|0,130648)|0;Zta(130368|0,130656)|0;Zta(130380|0,130664)|0;Zta(130392|0,130672)|0;Zta(130404|0,130680)|0;Zta(130416|0,130688)|0;Zta(130428|0,130704)|0;Zta(130440|0,130712)|0;Zta(130452|0,130728)|0;Zta(130464|0,130744)|0;Zta(130476|0,130752)|0;Zta(130488|0,130760)|0;Zta(130500|0,130768)|0;Zta(130512|0,130656)|0;Zta(130524|0,130776)|0;Zta(130536|0,130784)|0;Zta(130548|0,130792)|0;Zta(130560|0,130800)|0;Zta(130572|0,130808)|0;Zta(130584|0,130816)|0;Zta(130596|0,130824)|0;c[31090]=130320;Tb(124368);d=124360;e=c[31090]|0;i=b;return e|0}function iCa(b){b=b|0;var d=0,e=0;b=i;if((a[124384]|0)!=0){d=124376;e=c[31094]|0;i=b;return e|0}if((Za(124384)|0)==0){d=124376;e=c[31094]|0;i=b;return e|0}do{if((a[129768]|0)==0){if((Za(129768)|0)==0){break}HEa(129480,0,288)|0;Zd(297,0,q|0)|0;Tb(129768)}}while(0);zua(129480,129776)|0;zua(129492|0,129808)|0;zua(129504|0,129848)|0;zua(129516|0,129872)|0;zua(129528|0,130192)|0;zua(129540|0,129896)|0;zua(129552|0,129920)|0;zua(129564|0,129944)|0;zua(129576|0,129976)|0;zua(129588|0,130016)|0;zua(129600|0,130048)|0;zua(129612|0,130088)|0;zua(129624|0,130128)|0;zua(129636|0,130144)|0;zua(129648|0,130160)|0;zua(129660|0,130176)|0;zua(129672|0,130192)|0;zua(129684|0,130208)|0;zua(129696|0,130224)|0;zua(129708|0,130240)|0;zua(129720|0,130256)|0;zua(129732|0,130272)|0;zua(129744|0,130288)|0;zua(129756|0,130304)|0;c[31094]=129480;Tb(124384);d=124376;e=c[31094]|0;i=b;return e|0}function jCa(b){b=b|0;var d=0,e=0;b=i;if((a[124400]|0)!=0){d=124392;e=c[31098]|0;i=b;return e|0}if((Za(124400)|0)==0){d=124392;e=c[31098]|0;i=b;return e|0}do{if((a[129456]|0)==0){if((Za(129456)|0)==0){break}HEa(129168,0,288)|0;Zd(298,0,q|0)|0;Tb(129456)}}while(0);Zta(129168,129464)|0;Zta(129180|0,129472)|0;c[31098]=129168;Tb(124400);d=124392;e=c[31098]|0;i=b;return e|0}function kCa(b){b=b|0;var d=0,e=0;b=i;if((a[124416]|0)!=0){d=124408;e=c[31102]|0;i=b;return e|0}if((Za(124416)|0)==0){d=124408;e=c[31102]|0;i=b;return e|0}do{if((a[129128]|0)==0){if((Za(129128)|0)==0){break}HEa(128840,0,288)|0;Zd(299,0,q|0)|0;Tb(129128)}}while(0);zua(128840,129136)|0;zua(128852|0,129152)|0;c[31102]=128840;Tb(124416);d=124408;e=c[31102]|0;i=b;return e|0}function lCa(b){b=b|0;var c=0;b=i;if((a[124440]|0)!=0){c=124424;i=b;return c|0}if((Za(124440)|0)==0){c=124424;i=b;return c|0}Ota(124424,124448,8);Zd(300,124424,q|0)|0;Tb(124440);c=124424;i=b;return c|0}function mCa(b){b=b|0;var c=0;b=i;if((a[124480]|0)!=0){c=124464;i=b;return c|0}if((Za(124480)|0)==0){c=124464;i=b;return c|0}wua(124464,124488,BDa(124488)|0);Zd(301,124464,q|0)|0;Tb(124480);c=124464;i=b;return c|0}function nCa(b){b=b|0;var c=0;b=i;if((a[124544]|0)!=0){c=124528;i=b;return c|0}if((Za(124544)|0)==0){c=124528;i=b;return c|0}Ota(124528,124552,8);Zd(300,124528,q|0)|0;Tb(124544);c=124528;i=b;return c|0}function oCa(b){b=b|0;var c=0;b=i;if((a[124584]|0)!=0){c=124568;i=b;return c|0}if((Za(124584)|0)==0){c=124568;i=b;return c|0}wua(124568,124592,BDa(124592)|0);Zd(301,124568,q|0)|0;Tb(124584);c=124568;i=b;return c|0}function pCa(b){b=b|0;var c=0;b=i;if((a[124648]|0)!=0){c=124632;i=b;return c|0}if((Za(124648)|0)==0){c=124632;i=b;return c|0}Ota(124632,124656,20);Zd(300,124632,q|0)|0;Tb(124648);c=124632;i=b;return c|0}function qCa(b){b=b|0;var c=0;b=i;if((a[124696]|0)!=0){c=124680;i=b;return c|0}if((Za(124696)|0)==0){c=124680;i=b;return c|0}wua(124680,124704,BDa(124704)|0);Zd(301,124680,q|0)|0;Tb(124696);c=124680;i=b;return c|0}function rCa(b){b=b|0;var c=0;b=i;if((a[124808]|0)!=0){c=124792;i=b;return c|0}if((Za(124808)|0)==0){c=124792;i=b;return c|0}Ota(124792,124816,11);Zd(300,124792,q|0)|0;Tb(124808);c=124792;i=b;return c|0}function sCa(b){b=b|0;var c=0;b=i;if((a[124848]|0)!=0){c=124832;i=b;return c|0}if((Za(124848)|0)==0){c=124832;i=b;return c|0}wua(124832,124856,BDa(124856)|0);Zd(301,124832,q|0)|0;Tb(124848);c=124832;i=b;return c|0}function tCa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);l=+xEa(b,g,c[30978]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function uCa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);l=+xEa(b,g,c[30978]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function vCa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);l=+xEa(b,g,c[30978]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function wCa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);n=lb(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function xCa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);m=lb(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function yCa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);m=lb(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function zCa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);m=lb(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function ACa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);n=Gc(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function BCa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[123920]|0)==0){if((Za(123920)|0)==0){break}c[30978]=Zb(2147483647,123928,0)|0;Tb(123920)}}while(0);m=Gc(b|0,h|0,f|0,c[30978]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function CCa(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;fe[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;fe[h&511](a);i=b;return}}function DCa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){wAa(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=fEa(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;FEa(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{hEa(h);i=e;return}}function ECa(a){a=a|0;a=i;yua(129116|0);yua(129104|0);yua(129092|0);yua(129080|0);yua(129068|0);yua(129056|0);yua(129044|0);yua(129032|0);yua(129020|0);yua(129008|0);yua(128996|0);yua(128984|0);yua(128972|0);yua(128960|0);yua(128948|0);yua(128936|0);yua(128924|0);yua(128912|0);yua(128900|0);yua(128888|0);yua(128876|0);yua(128864|0);yua(128852|0);yua(128840);i=a;return}function FCa(a){a=a|0;a=i;Wta(129444|0);Wta(129432|0);Wta(129420|0);Wta(129408|0);Wta(129396|0);Wta(129384|0);Wta(129372|0);Wta(129360|0);Wta(129348|0);Wta(129336|0);Wta(129324|0);Wta(129312|0);Wta(129300|0);Wta(129288|0);Wta(129276|0);Wta(129264|0);Wta(129252|0);Wta(129240|0);Wta(129228|0);Wta(129216|0);Wta(129204|0);Wta(129192|0);Wta(129180|0);Wta(129168);i=a;return}function GCa(a){a=a|0;a=i;yua(129756|0);yua(129744|0);yua(129732|0);yua(129720|0);yua(129708|0);yua(129696|0);yua(129684|0);yua(129672|0);yua(129660|0);yua(129648|0);yua(129636|0);yua(129624|0);yua(129612|0);yua(129600|0);yua(129588|0);yua(129576|0);yua(129564|0);yua(129552|0);yua(129540|0);yua(129528|0);yua(129516|0);yua(129504|0);yua(129492|0);yua(129480);i=a;return}function HCa(a){a=a|0;a=i;Wta(130596|0);Wta(130584|0);Wta(130572|0);Wta(130560|0);Wta(130548|0);Wta(130536|0);Wta(130524|0);Wta(130512|0);Wta(130500|0);Wta(130488|0);Wta(130476|0);Wta(130464|0);Wta(130452|0);Wta(130440|0);Wta(130428|0);Wta(130416|0);Wta(130404|0);Wta(130392|0);Wta(130380|0);Wta(130368|0);Wta(130356|0);Wta(130344|0);Wta(130332|0);Wta(130320);i=a;return}function ICa(a){a=a|0;a=i;yua(130988|0);yua(130976|0);yua(130964|0);yua(130952|0);yua(130940|0);yua(130928|0);yua(130916|0);yua(130904|0);yua(130892|0);yua(130880|0);yua(130868|0);yua(130856|0);yua(130844|0);yua(130832);i=a;return}function JCa(a){a=a|0;a=i;Wta(131524|0);Wta(131512|0);Wta(131500|0);Wta(131488|0);Wta(131476|0);Wta(131464|0);Wta(131452|0);Wta(131440|0);Wta(131428|0);Wta(131416|0);Wta(131404|0);Wta(131392|0);Wta(131380|0);Wta(131368);i=a;return}function KCa(a){a=a|0;var b=0,c=0;b=i;if((QCa(a)|0)==0){c=(LCa(a)|0)!=0|0}else{c=1}i=b;return c|0}function LCa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[131680+((d[131680+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function MCa(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function NCa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function OCa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 9:{d=UCa(a)|0;break};case 3:{d=MCa(a)|0;break};case 8:{d=TCa(a)|0;break};case 7:{d=SCa(a)|0;break};case 6:{d=RCa(a)|0;break};case 4:{d=NCa(a)|0;break};case 12:{d=XCa(a)|0;break};case 1:{d=KCa(a)|0;break};case 11:{d=WCa(a)|0;break};case 10:{d=VCa(a)|0;break};case 2:{d=LCa(a)|0;break};case 5:{d=QCa(a)|0;break};default:{d=0}}i=c;return d|0}function PCa(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=134656;while(1){if(d<<24>>24==e<<24>>24){if((zEa(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function QCa(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function RCa(a){a=a|0;var b=0,c=0;b=i;if((VCa(a)|0)==0){c=(TCa(a)|0)!=0|0}else{c=0}i=b;return c|0}function SCa(a){a=a|0;var b=0,c=0;b=i;if((YCa(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function TCa(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function UCa(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[134736+((d[134736+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function VCa(a){a=a|0;var b=0,c=0;b=i;c=(ADa(137904,a)|0)!=0|0;i=b;return c|0}function WCa(a){a=a|0;var b=0,c=0;b=i;c=(_Ca(a)|0)!=(a|0)|0;i=b;return c|0}function XCa(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function YCa(a){a=a|0;var b=0,c=0;b=i;c=ZCa(a,0)|0;i=b;return c|0}function ZCa(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((LCa(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[137994+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[137992+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[137995+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[138240+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[138240+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[138240+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function _Ca(a){a=a|0;var b=0,c=0;b=i;c=ZCa(a,1)|0;i=b;return c|0}function $Ca(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=aDa(0,a,b,(c|0)!=0?c:138944)|0;i=d;return e|0}function aDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?138952:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[138736+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function bDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=cDa(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=aDa(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function cDa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[138736+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[138736+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function dDa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[138736+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function eDa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function fDa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=gDa(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=eDa(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function gDa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=eDa(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=eDa(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=eDa(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}eDa(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function hDa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=$Da(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=$Da(2048)|0;c[p+16>>2]=s;if((s|0)==0){aEa(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=xDa(0,0)|0;if((s|0)==0){aEa(c[p+16>>2]|0);aEa(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=iDa(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=bEa(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=jDa(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=$Da(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;HEa(y|0,-1,v|0)|0;I=H}else{I=0}H=bEa(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=bEa(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=jDa(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=pDa(q,x)|0;b:do{if((v|0)==0){y=pDa(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==2){T=c[S+4>>2]|0;U=pDa(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{X=L}}if((F|0)==45){F=0;c[j>>2]=0;X=0}Y=X;Z=M+1|0;_=N;break}else if((P|0)==1){T=c[S+4>>2]|0;U=pDa(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=pDa(q,0)|0}else if((P|0)==0){U=c[S+4>>2]|0;T=c[U>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=U+8|0;U=(c[T>>2]|0)+L|0;c[T>>2]=U;if((U|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=U;Y=L;Z=M;_=N;break}else if((P|0)==3){P=c[S+4>>2]|0;U=pDa(q,c[P+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=pDa(q,c[P>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=pDa(q,0)|0}else{Y=L;Z=M;_=N;break}if(($|0)==0){Y=L;Z=M;_=N}else{V=N;W=$;break c}}else if((R|0)==1){U=S+4|0;P=c[U>>2]|0;T=O+ -3|0;c[u>>2]=T;aa=c[Q+(T<<2)>>2]|0;c[j>>2]=aa;T=P+4|0;ba=c[T>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=P;F=51}else{if((c[P+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=P;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=qDa(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=zDa(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=zDa(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[T>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;T=P+8|0;ba=c[T>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=qDa(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=zDa(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=zDa(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=qDa(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=zDa(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=zDa(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=zDa(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=zDa(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=zDa(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=zDa(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[T>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}T=zDa(s,0,0,1,32)|0;if((T|0)==0){J=12;break b}ba=zDa(s,0,0,1,8)|0;P=T+4|0;c[P>>2]=ba;if((ba|0)==0){J=12;break b}c[T>>2]=1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ba>>2]=ia;c[(c[P>>2]|0)+4>>2]=ra;c[T+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=T;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[U>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}T=M+ -1|0;P=da-aa+N|0;if((T|0)!=0){Y=da;Z=T;_=P;break}c[j>>2]=P;Y=P;Z=0;_=P}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=zDa(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=zDa(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=zDa(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=zDa(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=pDa(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=pDa(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==2){M=c[ya+4>>2]|0;L=c[M>>2]|0;Q=L+8|0;if((c[Q>>2]|0)==0){za=0}else{za=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[Q>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Aa=M+4|0}else{Q=oDa(q,L,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Ba=$Da((c[g>>2]<<2)+4|0)|0;Q=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=oDa(q,c[M>>2]|0,Q,h,0)|0;if((Ca|0)!=0){F=150;break g}L=M+4|0;R=nDa(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,Q,c[h>>2]|0)|0;Q=ya+24|0;c[Q>>2]=R;aEa(Ba);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=L}}L=c[Aa>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}Q=oDa(q,L,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Da=$Da((c[g>>2]<<2)+4|0)|0;Q=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=oDa(q,c[Aa>>2]|0,Q,h,0)|0;if((Ea|0)!=0){F=157;break g}L=nDa(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,Q,c[h>>2]|0)|0;Q=ya+28|0;c[Q>>2]=L;aEa(Da);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){Q=c[ya+4>>2]|0;L=c[Q>>2]|0;M=Q+4|0;R=c[M>>2]|0;if((c[L+8>>2]|0)==0){Fa=(c[R+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;P=nDa(s,c[L+24>>2]|0,c[R+24>>2]|0,0,0)|0;c[ya+24>>2]=P;if((P|0)==0){z=0;A=12;B=0;C=D;break a}P=nDa(s,c[(c[Q>>2]|0)+28>>2]|0,c[(c[M>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=P;if((P|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){P=c[ya+4>>2]|0;M=c[P>>2]|0;do{if((c[P+4>>2]|0)==0){F=141}else{if((c[M+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[M+24>>2];c[ya+28>>2]=c[(c[P>>2]|0)+28>>2]}else if((S|0)==0){Q=c[ya>>2]|0;if((Q|0)==3){R=pDa(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=pDa(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=pDa(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((Q|0)==2){L=pDa(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,3)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,c[c[ya+4>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((Q|0)==1){L=pDa(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=pDa(q,2)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=pDa(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=pDa(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=pDa(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=pDa(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((Q|0)==0){Q=c[ya+4>>2]|0;R=c[Q>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;L=Q+8|0;T=c[L>>2]|0;ba=zDa(s,0,0,1,64)|0;if((ba|0)==0){F=104;break g}la=ba;c[ba>>2]=T;c[ba+4>>2]=0;c[ba+8>>2]=1114111;c[ba+20>>2]=0;c[ba+24>>2]=0;T=ba+28|0;ba=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ba>>2]=la;la=c[L>>2]|0;L=c[Q+4>>2]|0;ba=zDa(s,0,0,1,64)|0;if((ba|0)==0){F=106;break g}c[ba>>2]=la;c[ba+4>>2]=0;c[ba+8>>2]=1114111;c[ba+20>>2]=0;c[ba+24>>2]=0;c[ba+28>>2]=L;c[ba+32>>2]=-1;c[ba+36>>2]=-1;c[ba+40>>2]=-1;c[ya+28>>2]=ba;break}ba=ya+8|0;if((R|0)<0){c[ba>>2]=1;L=zDa(s,0,0,1,32)|0;if((L|0)==0){F=110;break g}c[L>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[ya+24>>2]=L;L=zDa(s,0,0,1,32)|0;if((L|0)==0){F=112;break g}c[L>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[ya+28>>2]=L;break}else{c[ba>>2]=0;ba=Q+8|0;L=c[ba>>2]|0;la=Q+4|0;T=c[la>>2]|0;ma=zDa(s,0,0,1,64)|0;if((ma|0)==0){F=115;break g}ka=ma;c[ma>>2]=L;c[ma+4>>2]=R;c[ma+8>>2]=T;c[ma+20>>2]=0;c[ma+24>>2]=0;T=ma+28|0;ma=ya+24|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ma>>2]=ka;ka=c[ba>>2]|0;ba=c[Q>>2]|0;ma=c[la>>2]|0;la=c[Q+12>>2]|0;T=c[Q+16>>2]|0;Q=zDa(s,0,0,1,64)|0;if((Q|0)==0){F=117;break g}R=Q;c[Q>>2]=ka;c[Q+4>>2]=ba;c[Q+8>>2]=ma;c[Q+20>>2]=la;c[Q+24>>2]=T;T=Q+28|0;Q=ya+28|0;c[T+0>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[Q>>2]=R;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){aEa(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){aEa(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=$Da(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=$Da(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){HEa(O|0,0,((E|0)>1?E<<2:4)|0)|0}kDa(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;Q=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=Q}else{Ga=Q;break}}}else{Ga=0}K=bEa(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;Q=kDa(y,S,x,u)|0;if((Q|0)!=0){z=x;A=Q;B=u;C=D;break}c[w+20>>2]=0;Q=v+24|0;S=c[Q>>2]|0;if((c[S>>2]|0)>-1){R=1;T=S;while(1){S=T+32|0;la=R+1|0;if((c[S>>2]|0)>-1){T=S;R=la}else{Ha=la;break}}}else{Ha=1}R=bEa(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;T=c[Q>>2]|0;y=c[T>>2]|0;if((y|0)>-1){la=y;y=T;T=0;while(1){c[R+(T<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[R+(T<<5)+12>>2]=la;S=R+(T<<5)+16|0;c[S>>2]=0;ma=y+12|0;ba=c[ma>>2]|0;if((ba|0)!=0){ka=0;while(1){Ia=ka+1|0;if((c[ba+(ka<<2)>>2]|0)>-1){ka=Ia}else{break}}ka=Ia<<2;ba=$Da(ka)|0;c[S>>2]=ba;if((ba|0)==0){z=x;A=12;B=u;C=D;break a}FEa(ba|0,c[ma>>2]|0,ka|0)|0}c[R+(T<<5)+20>>2]=c[y+16>>2];ka=T+1|0;ba=y+32|0;L=c[ba>>2]|0;if((L|0)>-1){la=L;y=ba;T=ka}else{Ja=ka;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;yDa(s);aEa(c[p+16>>2]|0);aEa(p);aEa(O);aEa(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);yDa(s);aEa(c[p+16>>2]|0);aEa(p);if((z|0)!=0){aEa(z)}if((B|0)!=0){aEa(B)}c[b+4>>2]=C;lDa(b);r=A;i=f;return r|0}



function Sia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((zEa(b,96792)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{Qta(g,v);w=Fia(u,g)|0;Yta(w,c[d+((t|1)<<2)>>2]|0)|0;Wta(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((zEa(b,96816)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{Qta(h,g);u=Fia(t,h)|0;Yta(u,c[d+((v|1)<<2)>>2]|0)|0;Wta(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((zEa(b,96840)|0)!=0){do{if((zEa(b,97096)|0)!=0){if((zEa(b,97104)|0)==0){break}if((zEa(b,97112)|0)==0){break}if((zEa(b,97120)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=Yia(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){Qta(r,c[t>>2]|0);w=Fia(g,r)|0;Yta(w,c[d+((u|1)<<2)>>2]|0)|0;Wta(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=Yia(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}Qta(s,97128);Yta(Fia(x,s)|0,b)|0;Wta(s);i=e;return}fja(j,k);Kta(l);Kta(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{Qta(n,g);t=Fia(j,n)|0;Yta(t,c[d+((x|1)<<2)>>2]|0)|0;Wta(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}Qta(o,96856);Xta(l,Fia(j,o)|0)|0;Wta(o);Qta(p,96872);Xta(m,Fia(j,p)|0)|0;Wta(p);c[k>>2]=Fc(rua(l)|0)|0;if((uua(m,96888)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((uua(m,96896)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((uua(m,96904)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((uua(m,96912)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((uua(m,96920)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((uua(m,96928)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((uua(m,96936)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((uua(m,96944)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((uua(m,96952)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((uua(m,96960)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((uua(m,96968)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((uua(m,96976)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((uua(m,96984)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((uua(m,96992)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=rua(m)|0;Qta(q,93416);N=rua(Fia(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;G9(0,(O|0)!=0|0,97e3,f);Wta(q);soa(Yia(c[b>>2]|0,s)|0,j)|0;Wta(m);Wta(l);nja(j);i=e;return}function Tia(a,b){a=a|0;b=b|0;i=i;return}function Uia(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=dla(a,b)|0;i=c;return d|0}function Via(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;mla(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];ela(a,f);i=e;return}function Wia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;fla(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];ela(a,e);i=d;return}function Xia(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;fja(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){H9(0,96184,n)}if(p){ec=Ad(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;D9(23,0,96328,m);gja(q);hja(q,e,8);if(!(ija(q)|0)){c[l>>2]=e;H9(0,96368,l)}Kta(r);l=q;jja(l,r)|0;Mta(s,r);while(1){e=jja(l,r)|0;if(!(Gua(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}Fua(t,96448,r);lua(s,t)|0;Wta(t)}t=Ad(rua(s)|0)|0;kja(q);Wta(s);Wta(r);lja(q);fc=t}if((fc|0)==0){D9(23,0,96536,g);nja(o);i=f;return}Kta(u);Kta(v);c[k>>2]=fc;D9(23,0,96456,k);k=Xb(fc|0,96448)|0;if((k|0)!=0){g=k;do{k=fEa(12)|0;Qta(k,g);t=sua(k,96488,0)|0;qua(w,k,0,t);Xta(u,w)|0;Wta(w);qua(x,k,t+1|0,(bua(k)|0)+~t|0);Xta(v,x)|0;Wta(x);Xta(Fia(o,u)|0,v)|0;t=rua(u)|0;k=rua(v)|0;c[j>>2]=t;c[j+4>>2]=k;D9(23,0,96496,j);g=Xb(0,96448)|0;}while((g|0)!=0)}aEa(fc);fc=a+12|0;Qta(y,94584);g=Fia(fc,y)|0;Qta(z,94584);if((mja(o,z)|0)==0){Qta(B,94584);gc=1;hc=0;ic=Fia(fc,B)|0}else{Qta(A,94584);gc=0;hc=1;ic=Fia(o,A)|0}Xta(g,ic)|0;if(gc){Wta(B)}if(hc){Wta(A)}Wta(z);Wta(y);Qta(C,94456);y=Fia(fc,C)|0;Qta(D,94456);if((mja(o,D)|0)==0){Qta(F,94456);jc=1;kc=0;lc=Fia(fc,F)|0}else{Qta(E,94456);jc=0;kc=1;lc=Fia(o,E)|0}Xta(y,lc)|0;if(jc){Wta(F)}if(kc){Wta(E)}Wta(D);Wta(C);Qta(G,94488);C=Fia(fc,G)|0;Qta(H,94488);if((mja(o,H)|0)==0){Qta(J,94488);mc=1;nc=0;oc=Fia(fc,J)|0}else{Qta(I,94488);mc=0;nc=1;oc=Fia(o,I)|0}Xta(C,oc)|0;if(mc){Wta(J)}if(nc){Wta(I)}Wta(H);Wta(G);Qta(K,94520);G=Fia(fc,K)|0;Qta(L,94520);if((mja(o,L)|0)==0){Qta(N,94520);pc=0;qc=1;rc=Fia(fc,N)|0}else{Qta(M,94520);pc=1;qc=0;rc=Fia(o,M)|0}Xta(G,rc)|0;if(qc){Wta(N)}if(pc){Wta(M)}Wta(L);Wta(K);Qta(O,94552);K=Fia(fc,O)|0;Qta(P,94552);if((mja(o,P)|0)==0){Qta(R,94552);sc=1;tc=0;uc=Fia(fc,R)|0}else{Qta(Q,94552);sc=0;tc=1;uc=Fia(o,Q)|0}Xta(K,uc)|0;if(sc){Wta(R)}if(tc){Wta(Q)}Wta(P);Wta(O);Qta(S,94616);O=Fia(fc,S)|0;Qta(T,94616);if((mja(o,T)|0)==0){Qta(V,94616);vc=1;wc=0;xc=Fia(fc,V)|0}else{Qta(U,94616);vc=0;wc=1;xc=Fia(o,U)|0}Xta(O,xc)|0;if(vc){Wta(V)}if(wc){Wta(U)}Wta(T);Wta(S);Qta(W,94656);S=Fia(fc,W)|0;Qta(X,94656);if((mja(o,X)|0)==0){Qta(Z,94656);yc=1;zc=0;Ac=Fia(fc,Z)|0}else{Qta(Y,94656);yc=0;zc=1;Ac=Fia(o,Y)|0}Xta(S,Ac)|0;if(yc){Wta(Z)}if(zc){Wta(Y)}Wta(X);Wta(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=Yia(Y,_)|0;Qta($,93560);Ac=Fia(yc,$)|0;c[aa>>2]=Z;yc=Yia(Y,aa)|0;Qta(ba,93416);if((mja(o,Fia(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=Yia(Y,ea)|0;Qta(fa,93560);Bc=1;Cc=0;Dc=Fia(yc,fa)|0}else{c[ca>>2]=Z;yc=Yia(Y,ca)|0;Qta(da,93416);Bc=0;Cc=1;Dc=Fia(o,Fia(yc,da)|0)|0}Xta(Ac,Dc)|0;if(Bc){Wta(fa)}if(Cc){Wta(da)}Wta(ba);Wta($);c[ga>>2]=Z;Ac=Yia(zc,ga)|0;Qta(ha,93560);yc=Fia(Ac,ha)|0;c[ia>>2]=Z;Ac=Yia(zc,ia)|0;Qta(ja,93416);if((mja(o,Fia(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=Yia(zc,ma)|0;Qta(na,93560);Ec=1;Fc=0;Gc=Fia(Ac,na)|0}else{c[ka>>2]=Z;Ac=Yia(zc,ka)|0;Qta(la,93416);Ec=0;Fc=1;Gc=Fia(o,Fia(Ac,la)|0)|0}Xta(yc,Gc)|0;if(Ec){Wta(na)}if(Fc){Wta(la)}Wta(ja);Wta(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=Yia(Hc,oa)|0;Qta(pa,93560);ja=Fia(ha,pa)|0;c[qa>>2]=Z;ha=Yia(Hc,qa)|0;Qta(ra,93416);if((mja(o,Fia(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=Yia(Hc,ua)|0;Qta(va,93560);Ic=1;Jc=0;Kc=Fia(ha,va)|0}else{c[sa>>2]=Z;ha=Yia(Hc,sa)|0;Qta(ta,93416);Ic=0;Jc=1;Kc=Fia(o,Fia(ha,ta)|0)|0}Xta(ja,Kc)|0;if(Ic){Wta(va)}if(Jc){Wta(ta)}Wta(ra);Wta(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=Yia(X,wa)|0;Qta(xa,93560);ra=Fia(pa,xa)|0;c[ya>>2]=Z;pa=Yia(X,ya)|0;Qta(za,93416);if((mja(o,Fia(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=Yia(X,Ca)|0;Qta(Da,93560);Lc=1;Mc=0;Nc=Fia(pa,Da)|0}else{c[Aa>>2]=Z;pa=Yia(X,Aa)|0;Qta(Ba,93416);Lc=0;Mc=1;Nc=Fia(o,Fia(pa,Ba)|0)|0}Xta(ra,Nc)|0;if(Lc){Wta(Da)}if(Mc){Wta(Ba)}Wta(za);Wta(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=Yia(Z,Ea)|0;Qta(Fa,93560);Ba=Fia(za,Fa)|0;c[Ga>>2]=xa;za=Yia(Z,Ga)|0;Qta(Ha,93416);if((mja(o,Fia(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=Yia(Z,Ka)|0;Qta(La,93560);Oc=1;Pc=0;Qc=Fia(za,La)|0}else{c[Ia>>2]=xa;za=Yia(Z,Ia)|0;Qta(Ja,93416);Oc=0;Pc=1;Qc=Fia(o,Fia(za,Ja)|0)|0}Xta(Ba,Qc)|0;if(Oc){Wta(La)}if(Pc){Wta(Ja)}Wta(Ha);Wta(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=Yia(xa,Ma)|0;Qta(Na,93560);Ja=Fia(Ha,Na)|0;c[Oa>>2]=Fa;Ha=Yia(xa,Oa)|0;Qta(Pa,93416);if((mja(o,Fia(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=Yia(xa,Sa)|0;Qta(Ta,93560);Rc=1;Sc=0;Tc=Fia(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=Yia(xa,Qa)|0;Qta(Ra,93416);Rc=0;Sc=1;Tc=Fia(o,Fia(Ha,Ra)|0)|0}Xta(Ja,Tc)|0;if(Rc){Wta(Ta)}if(Sc){Wta(Ra)}Wta(Pa);Wta(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=Yia(Fa,Ua)|0;Qta(Va,93560);Ra=Fia(Pa,Va)|0;c[Wa>>2]=Na;Pa=Yia(Fa,Wa)|0;Qta(Xa,93416);if((mja(o,Fia(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=Yia(Fa,_a)|0;Qta($a,93560);Uc=1;Vc=0;Wc=Fia(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=Yia(Fa,Ya)|0;Qta(Za,93416);Uc=0;Vc=1;Wc=Fia(o,Fia(Pa,Za)|0)|0}Xta(Ra,Wc)|0;if(Uc){Wta($a)}if(Vc){Wta(Za)}Wta(Xa);Wta(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=Yia(Na,ab)|0;Qta(bb,93560);Za=Fia(Xa,bb)|0;c[cb>>2]=Va;Xa=Yia(Na,cb)|0;Qta(db,93416);if((mja(o,Fia(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=Yia(Na,gb)|0;Qta(hb,93560);Xc=1;Yc=0;Zc=Fia(Xa,hb)|0}else{c[eb>>2]=Va;Xa=Yia(Na,eb)|0;Qta(fb,93416);Xc=0;Yc=1;Zc=Fia(o,Fia(Xa,fb)|0)|0}Xta(Za,Zc)|0;if(Xc){Wta(hb)}if(Yc){Wta(fb)}Wta(db);Wta(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=Yia(Va,ib)|0;Qta(jb,93560);fb=Fia(db,jb)|0;c[kb>>2]=bb;db=Yia(Va,kb)|0;Qta(lb,93416);if((mja(o,Fia(db,lb)|0)|0)==0){c[ob>>2]=bb;db=Yia(Va,ob)|0;Qta(pb,93560);_c=1;$c=0;ad=Fia(db,pb)|0}else{c[mb>>2]=bb;db=Yia(Va,mb)|0;Qta(nb,93416);_c=0;$c=1;ad=Fia(o,Fia(db,nb)|0)|0}Xta(fb,ad)|0;if(_c){Wta(pb)}if($c){Wta(nb)}Wta(lb);Wta(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=Yia(bb,qb)|0;Qta(rb,93560);nb=Fia(lb,rb)|0;c[sb>>2]=jb;lb=Yia(bb,sb)|0;Qta(tb,93416);if((mja(o,Fia(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=Yia(bb,wb)|0;Qta(xb,93560);bd=1;cd=0;dd=Fia(lb,xb)|0}else{c[ub>>2]=jb;lb=Yia(bb,ub)|0;Qta(vb,93416);bd=0;cd=1;dd=Fia(o,Fia(lb,vb)|0)|0}Xta(nb,dd)|0;if(bd){Wta(xb)}if(cd){Wta(vb)}Wta(tb);Wta(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=Yia(jb,yb)|0;Qta(zb,93560);vb=Fia(tb,zb)|0;c[Ab>>2]=rb;tb=Yia(jb,Ab)|0;Qta(Bb,93416);if((mja(o,Fia(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=Yia(jb,Eb)|0;Qta(Fb,93560);ed=1;fd=0;gd=Fia(tb,Fb)|0}else{c[Cb>>2]=rb;tb=Yia(jb,Cb)|0;Qta(Db,93416);ed=0;fd=1;gd=Fia(o,Fia(tb,Db)|0)|0}Xta(vb,gd)|0;if(ed){Wta(Fb)}if(fd){Wta(Db)}Wta(Bb);Wta(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=Yia(rb,Gb)|0;Qta(Hb,93560);Db=Fia(Bb,Hb)|0;c[Ib>>2]=zb;Bb=Yia(rb,Ib)|0;Qta(Jb,93416);if((mja(o,Fia(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=Yia(rb,Mb)|0;Qta(Nb,93560);hd=0;id=1;jd=Fia(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=Yia(rb,Kb)|0;Qta(Lb,93416);hd=1;id=0;jd=Fia(o,Fia(Bb,Lb)|0)|0}Xta(Db,jd)|0;if(id){Wta(Nb)}if(hd){Wta(Lb)}Wta(Jb);Wta(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=Yia(zb,Ob)|0;Qta(Pb,93560);Lb=Fia(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=Yia(zb,Qb)|0;Qta(Rb,93416);if((mja(o,Fia(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=Yia(zb,Ub)|0;Qta(Vb,93560);kd=1;ld=0;md=Fia(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=Yia(zb,Sb)|0;Qta(Tb,93416);kd=0;ld=1;md=Fia(o,Fia(Jb,Tb)|0)|0}Xta(Lb,md)|0;if(kd){Wta(Vb)}if(ld){Wta(Tb)}Wta(Rb);Wta(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=Yia(b,Wb)|0;Qta(Yb,93560);Pb=Fia(Hb,Yb)|0;c[Zb>>2]=a;Hb=Yia(b,Zb)|0;Qta(_b,93416);if((mja(o,Fia(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=Yia(b,bc)|0;Qta(cc,93560);nd=1;od=0;pd=Fia(Hb,cc)|0}else{c[$b>>2]=a;Hb=Yia(b,$b)|0;Qta(ac,93416);nd=0;od=1;pd=Fia(o,Fia(Hb,ac)|0)|0}Xta(Pb,pd)|0;if(nd){Wta(cc)}if(od){Wta(ac)}Wta(_b);Wta(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}D9(23,0,96520,h);Wta(v);Wta(u);nja(o);i=f;return}function Yia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Dla(a,f,b)|0;l=c[k>>2]|0;pfa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}Fla(j,a,b);Gla(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Ela(g,e);Hla(j);j=c[f>>2]|0;Ila(a,j,k,Jla(g)|0);k=Kla(g)|0;Hla(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Zia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=fka(a,f,b)|0;l=c[k>>2]|0;pfa(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}hka(j,a,b);ika(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];gka(g,e);jka(j);j=c[f>>2]|0;kka(a,j,k,lka(g)|0);k=mka(g)|0;jka(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function _ia(a,b){a=a|0;b=b|0;var c=0;c=i;Xta(b,a)|0;i=c;return}function $ia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Yja(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Qja(a,f);i=e;return}function aja(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Oja(a,b)|0;i=c;return d|0}function bja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Rja(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Qja(a,e);i=d;return}function cja(a){a=a|0;var b=0,c=0;b=i;c=Lja(a)|0;i=b;return c|0}function dja(a){a=a|0;var b=0;b=i;ioa(a);i=b;return}function eja(a){a=a|0;var b=0;b=i;Xna(a);i=b;return}function fja(a,b){a=a|0;b=b|0;b=i;Ema(a,0);i=b;return}function gja(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;Tua(d);e=a;c[e>>2]=96588;f=d;c[f>>2]=96608;d=a+8|0;Lva(a,96620|0,d);c[e>>2]=96588;c[f>>2]=96608;Yha(d);i=b;return}function hja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(xfa(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Kua(d,4);i=e;return}else{Iua(d,0);i=e;return}}function ija(a){a=a|0;var b=0,c=0;b=i;c=Gja(a+8|0)|0;i=b;return c|0}function jja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=Fja(a,b,Rua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function kja(a){a=a|0;var b=0;b=i;if((zfa(a+8|0)|0)!=0){i=b;return}Kua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function lja(a){a=a|0;var b=0;b=i;Kja(a,96616);Oua(a+108|0);i=b;return}function mja(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=oja(a,b)|0;i=c;return d|0}function nja(a){a=a|0;var b=0;b=i;Mna(a);i=b;return}function oja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=qja(a)|0;pfa(e);if((f|0)==0){g=0;i=d;return g|0}h=rja(a)|0;a=f;while(1){f=a+16|0;if(sja(h,b,f)|0){j=a}else{if(!(tja(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;pfa(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function pja(a){a=a|0;var b=0,c=0;b=i;c=afa(zja(a+4|0)|0)|0;i=b;return c|0}function qja(a){a=a|0;var b=0,d=0;b=i;d=c[(pja(a)|0)>>2]|0;i=b;return d|0}function rja(a){a=a|0;var b=0,c=0;b=i;c=xja(a+8|0)|0;i=b;return c|0}function sja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uja(0,b,c)|0;i=a;return d|0}function tja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uja(0,b,c)|0;i=a;return d|0}function uja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=vja(b,c)|0;i=a;return d|0}function vja(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(tua(a,b)|0)<0;i=c;return d|0}function wja(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=yEa(a,b,c)|0;i=d;return e|0}function xja(a){a=a|0;var b=0,c=0;b=i;c=yja(a)|0;i=b;return c|0}function yja(a){a=a|0;i=i;return a|0}function zja(a){a=a|0;var b=0,c=0;b=i;c=Aja(a)|0;i=b;return c|0}function Aja(a){a=a|0;i=i;return a|0}function Bja(a,b){a=a|0;b=b|0;var c=0;a=i;c=Dja(0,b,0)|0;i=a;return c|0}function Cja(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function Dja(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=fEa(b)|0;i=c;return a|0}function Eja(a){a=a|0;var b=0,c=0;b=i;c=DEa(a|0)|0;i=b;return c|0}function Fja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;Qva(f,a,1);if(!(Tva(f)|0)){i=e;return a|0}kua(b);f=0;while(1){g=Zua(Pua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(jga(g,-1)|0){h=2;j=f;break}k=f+1|0;l=kga(g)|0;if(oga(l,d)|0){h=0;j=k;break}mua(b,l);if((Uta(b)|0)==-17){h=4;j=k;break}else{f=k}}Kua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function Gja(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function Hja(a){a=a|0;var b=0;b=i;lja(a);hEa(a);i=b;return}function Ija(a){a=a|0;var b=0;b=i;lja(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Jja(a){a=a|0;var b=0;b=i;Hja(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Kja(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Zfa(a+8|0);i=d;return}function Lja(a){a=a|0;var b=0,d=0;b=i;d=Mja((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Mja(a){a=a|0;var b=0,c=0;b=i;c=Nja(a)|0;i=b;return c|0}function Nja(a){a=a|0;i=i;return a|0}function Oja(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Pja(a,b)|0)^1;i=c;return d|0}function Pja(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Qja(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Xja(a,e);i=d;return}function Rja(a,b){a=a|0;b=b|0;var c=0;c=i;Sja(a,Tja(b)|0);i=c;return}function Sja(a,b){a=a|0;b=b|0;var c=0;c=i;Wja(a,b);i=c;return}function Tja(a){a=a|0;var b=0,c=0;b=i;c=afa(Uja(a+4|0)|0)|0;i=b;return c|0}function Uja(a){a=a|0;var b=0,c=0;b=i;c=Vja(a)|0;i=b;return c|0}function Vja(a){a=a|0;i=i;return a|0}function Wja(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Xja(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Yja(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=_ja(b)|0;Zja(f,b,d,h,Tja(b)|0);Rja(g,b);do{if(Oja(f,g)|0){h=$ja(b)|0;if(aka(h,d,bka(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Rja(a,b);i=e;return}function Zja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;pfa(h);a:do{if((e|0)==0){j=f}else{k=$ja(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(eka(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;pfa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;pfa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Sja(a,j);i=g;return}function _ja(a){a=a|0;var b=0,d=0;b=i;d=c[(Tja(a)|0)>>2]|0;i=b;return d|0}function $ja(a){a=a|0;var b=0,c=0;b=i;c=cka(a+8|0)|0;i=b;return c|0}function aka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uja(0,b,c)|0;i=a;return d|0}function bka(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function cka(a){a=a|0;var b=0,c=0;b=i;c=dka(a)|0;i=b;return c|0}function dka(a){a=a|0;i=i;return a|0}function eka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uja(0,b,c)|0;i=a;return d|0}function fka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=_ja(h)|0;pfa(e);if((a|0)==0){j=Tja(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(uja(0,d,a)|0){m=l;j=c[m>>2]|0;pfa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(uja(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;pfa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function gka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];bla(a,e);i=d;return}function hka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Ika(d)|0;d=Kka(n,1)|0;Lka(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Jka(j,d,h);Mka(0,Bka((Nka(j)|0)+16|0)|0,e);e=Oka(j)|0;a[e+4|0]=1;Pka(0,zka((Nka(j)|0)+28|0)|0);a[e+5|0]=1;Qka(m,j);ika(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];gka(b,g);jka(m);jka(j);i=f;return}function ika(a,b){a=a|0;b=b|0;var c=0;c=i;Gka(a,b);i=c;return}function jka(a){a=a|0;var b=0;b=i;vka(a);i=b;return}function kka(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;pfa(f);c[e>>2]=0;pfa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=rka(a)|0;b=c[c[e>>2]>>2]|0;pfa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Tja(a)|0)>>2]|0;$ga(e,c[d>>2]|0);d=ska(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function lka(a){a=a|0;var b=0,d=0;b=i;d=c[(pka(a)|0)>>2]|0;i=b;return d|0}function mka(a){a=a|0;var b=0,d=0;b=i;d=nka(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function nka(a){a=a|0;var b=0,c=0;b=i;c=oka(a)|0;i=b;return c|0}function oka(a){a=a|0;i=i;return a|0}function pka(a){a=a|0;var b=0,c=0;b=i;c=qka(a)|0;i=b;return c|0}function qka(a){a=a|0;i=i;return a|0}function rka(a){a=a|0;i=i;return a|0}function ska(a){a=a|0;var b=0,c=0;b=i;c=tka(a+8|0)|0;i=b;return c|0}function tka(a){a=a|0;var b=0,c=0;b=i;c=uka(a)|0;i=b;return c|0}function uka(a){a=a|0;i=i;return a|0}function vka(a){a=a|0;var b=0;b=i;wka(a,0);i=b;return}function wka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=nka(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}yka(xka(e)|0,f);i=d;return}function xka(a){a=a|0;var b=0,c=0;b=i;c=Fka(a)|0;i=b;return c|0}function yka(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;Aka(f,Bka(d+16|0)|0)}if((d|0)==0){i=e;return}Cka(c[b>>2]|0,d,1);i=e;return}function zka(a){a=a|0;i=i;return a|0}function Aka(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Eka(d,0,c);i=b;return}function Bka(a){a=a|0;i=i;return a|0}function Cka(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Dka(0,b,0);i=c;return}function Dka(a,b,c){a=a|0;b=b|0;c=c|0;c=i;hEa(b);i=c;return}function Eka(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Wta(c);i=b;return}function Fka(a){a=a|0;i=i;return a+4|0}function Gka(a,b){a=a|0;b=b|0;var c=0;c=i;Hka(a,b);i=c;return}function Hka(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Ika(a){a=a|0;var b=0,c=0;b=i;c=$ka(a+4|0)|0;i=b;return c|0}function Jka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Tka(a,b,f);i=e;return}function Kka(a,b){a=a|0;b=b|0;var c=0;a=i;c=Ska(0,b,0)|0;i=a;return c|0}function Lka(a,b){a=a|0;b=b|0;var c=0;c=i;Rka(a,b);i=c;return}function Mka(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Mta(b,c);i=a;return}function Nka(a){a=a|0;var b=0,d=0;b=i;d=c[(pka(a)|0)>>2]|0;i=b;return d|0}function Oka(a){a=a|0;var b=0,c=0;b=i;c=xka(a)|0;i=b;return c|0}function Pka(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function Qka(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Gka(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];gka(h,f);ika(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];gka(a,e);jka(h);i=d;return}function Rka(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function Ska(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=fEa(b<<5)|0;i=c;return a|0}function Tka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Vka(g)|0)>>2]|0;g=Wka(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Uka(b,a,f);i=e;return}function Uka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Xka(a,b,f);i=e;return}function Vka(a){a=a|0;i=i;return a|0}function Wka(a){a=a|0;i=i;return a|0}function Xka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Zka(g)|0)>>2]|0;g=_ka(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Yka(b,a,f);i=e;return}function Yka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Zka(f)|0)>>2];f=_ka(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Zka(a){a=a|0;i=i;return a|0}function _ka(a){a=a|0;i=i;return a|0}function $ka(a){a=a|0;var b=0,c=0;b=i;c=ala(a)|0;i=b;return c|0}function ala(a){a=a|0;i=i;return a|0}function bla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=mka(cla(b)|0)|0;h=_ka(Oka(cla(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Uka(g,a,e);i=d;return}function cla(a){a=a|0;i=i;return c[a>>2]|0}function dla(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function ela(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];lla(a,e);i=d;return}function fla(a,b){a=a|0;b=b|0;var c=0;c=i;gla(a,hla(b)|0);i=c;return}function gla(a,b){a=a|0;b=b|0;var c=0;c=i;kla(a,b);i=c;return}function hla(a){a=a|0;var b=0,c=0;b=i;c=afa(ila(a+4|0)|0)|0;i=b;return c|0}function ila(a){a=a|0;var b=0,c=0;b=i;c=jla(a)|0;i=b;return c|0}function jla(a){a=a|0;i=i;return a|0}function kla(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function lla(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function mla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=ola(b)|0;nla(f,b,d,h,hla(b)|0);fla(g,b);do{if(pla(f,g)|0){h=qla(b)|0;if(sja(h,d,rla(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);fla(a,b);i=e;return}function nla(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;pfa(h);a:do{if((e|0)==0){j=f}else{k=qla(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(tja(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;pfa(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;pfa(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);gla(a,j);i=g;return}function ola(a){a=a|0;var b=0,d=0;b=i;d=c[(hla(a)|0)>>2]|0;i=b;return d|0}function pla(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(dla(a,b)|0)^1;i=c;return d|0}function qla(a){a=a|0;var b=0,c=0;b=i;c=sla(a+8|0)|0;i=b;return c|0}function rla(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function sla(a){a=a|0;var b=0,c=0;b=i;c=tla(a)|0;i=b;return c|0}function tla(a){a=a|0;i=i;return a|0}function ula(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vla(a,b);i=b;return}function vla(a,b){a=a|0;b=b|0;b=i;wla(a,0);i=b;return}function wla(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;xla(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;yla(f,0,e);e=Tja(b)|0;c[(rka(b)|0)>>2]=e;i=d;return}function xla(a){a=a|0;var b=0;b=i;Bla(a);i=b;return}function yla(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;zla(b,c,f);i=e;return}function zla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Tha(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Ala(d,b,f);i=e;return}function Ala(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Tha(e)|0)>>2];i=d;return}function Bla(a){a=a|0;var b=0;b=i;Cla(a);i=b;return}function Cla(a){a=a|0;var b=0;b=i;Wha(a);i=b;return}function Dla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=Dma(h)|0;pfa(e);if((a|0)==0){j=Qla(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(mfa(0,d,a)|0){m=l;j=c[m>>2]|0;pfa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(mfa(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;pfa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Ela(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Bma(a,e);i=d;return}function Fla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=gma(d)|0;d=ima(n,1)|0;jma(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];hma(j,d,h);kma(0,lha((lma(j)|0)+16|0)|0,e);e=mma(j)|0;a[e+4|0]=1;nma(0,$la((lma(j)|0)+20|0)|0);a[e+5|0]=1;oma(m,j);Gla(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Ela(b,g);Hla(m);Hla(j);i=f;return}function Gla(a,b){a=a|0;b=b|0;var c=0;c=i;ema(a,b);i=c;return}function Hla(a){a=a|0;var b=0;b=i;Wla(a);i=b;return}function Ila(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;pfa(f);c[e>>2]=0;pfa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Pla(a)|0;b=c[c[e>>2]>>2]|0;pfa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(Qla(a)|0)>>2]|0;$ga(e,c[d>>2]|0);d=Rla(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Jla(a){a=a|0;var b=0,d=0;b=i;d=c[(Nla(a)|0)>>2]|0;i=b;return d|0}function Kla(a){a=a|0;var b=0,d=0;b=i;d=Lla(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Lla(a){a=a|0;var b=0,c=0;b=i;c=Mla(a)|0;i=b;return c|0}function Mla(a){a=a|0;i=i;return a|0}function Nla(a){a=a|0;var b=0,c=0;b=i;c=Ola(a)|0;i=b;return c|0}function Ola(a){a=a|0;i=i;return a|0}function Pla(a){a=a|0;i=i;return a|0}function Qla(a){a=a|0;var b=0,c=0;b=i;c=afa(Ula(a+4|0)|0)|0;i=b;return c|0}function Rla(a){a=a|0;var b=0,c=0;b=i;c=Sla(a+8|0)|0;i=b;return c|0}function Sla(a){a=a|0;var b=0,c=0;b=i;c=Tla(a)|0;i=b;return c|0}function Tla(a){a=a|0;i=i;return a|0}function Ula(a){a=a|0;var b=0,c=0;b=i;c=Vla(a)|0;i=b;return c|0}function Vla(a){a=a|0;i=i;return a|0}function Wla(a){a=a|0;var b=0;b=i;Xla(a,0);i=b;return}function Xla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Lla(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Zla(Yla(e)|0,f);i=d;return}function Yla(a){a=a|0;var b=0,c=0;b=i;c=dma(a)|0;i=b;return c|0}function Zla(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;_la(f,$la(d+20|0)|0)}if((d|0)==0){i=e;return}ama(c[b>>2]|0,d,1);i=e;return}function _la(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;cma(d,0,c);i=b;return}function $la(a){a=a|0;i=i;return a|0}function ama(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bma(0,b,0);i=c;return}function bma(a,b,c){a=a|0;b=b|0;c=c|0;c=i;hEa(b);i=c;return}function cma(a,b,c){a=a|0;b=b|0;c=c|0;b=i;nja(c);i=b;return}function dma(a){a=a|0;i=i;return a+4|0}function ema(a,b){a=a|0;b=b|0;var c=0;c=i;fma(a,b);i=c;return}function fma(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gma(a){a=a|0;var b=0,c=0;b=i;c=zma(a+4|0)|0;i=b;return c|0}function hma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rma(a,b,f);i=e;return}function ima(a,b){a=a|0;b=b|0;var c=0;a=i;c=qma(0,b,0)|0;i=a;return c|0}function jma(a,b){a=a|0;b=b|0;var c=0;c=i;pma(a,b);i=c;return}function kma(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function lma(a){a=a|0;var b=0,d=0;b=i;d=c[(Nla(a)|0)>>2]|0;i=b;return d|0}function mma(a){a=a|0;var b=0,c=0;b=i;c=Yla(a)|0;i=b;return c|0}function nma(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}fja(b,a);i=a;return}function oma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;ema(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Ela(h,f);Gla(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Ela(a,e);Hla(h);i=d;return}function pma(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function qma(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=fEa(b<<5)|0;i=c;return a|0}function rma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tma(g)|0)>>2]|0;g=uma(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sma(b,a,f);i=e;return}function sma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];vma(a,b,f);i=e;return}function tma(a){a=a|0;i=i;return a|0}function uma(a){a=a|0;i=i;return a|0}function vma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(xma(g)|0)>>2]|0;g=yma(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];wma(b,a,f);i=e;return}function wma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(xma(f)|0)>>2];f=yma(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function xma(a){a=a|0;i=i;return a|0}function yma(a){a=a|0;i=i;return a|0}function zma(a){a=a|0;var b=0,c=0;b=i;c=Ama(a)|0;i=b;return c|0}function Ama(a){a=a|0;i=i;return a|0}function Bma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Kla(Cma(b)|0)|0;h=yma(mma(Cma(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];sma(g,a,e);i=d;return}function Cma(a){a=a|0;i=i;return c[a>>2]|0}function Dma(a){a=a|0;var b=0,d=0;b=i;d=c[(Qla(a)|0)>>2]|0;i=b;return d|0}function Ema(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Fma(a,b);i=b;return}function Fma(a,b){a=a|0;b=b|0;b=i;Gma(a,0);i=b;return}function Gma(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Hma(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Ima(f,0,e);e=hla(b)|0;c[(Jma(b)|0)>>2]=e;i=d;return}function Hma(a){a=a|0;var b=0;b=i;Mma(a);i=b;return}function Ima(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Kma(b,c,f);i=e;return}function Jma(a){a=a|0;i=i;return a|0}function Kma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Tha(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Lma(d,b,f);i=e;return}function Lma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Tha(e)|0)>>2];i=d;return}function Mma(a){a=a|0;var b=0;b=i;Nma(a);i=b;return}function Nma(a){a=a|0;var b=0;b=i;Wha(a);i=b;return}function Oma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=ola(h)|0;pfa(e);if((a|0)==0){j=hla(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(uja(0,d,a)|0){m=l;j=c[m>>2]|0;pfa(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(uja(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;pfa(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Pma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Kna(a,e);i=d;return}function Qma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=pna(d)|0;d=rna(n,1)|0;sna(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];qna(j,d,h);tna(0,Bka((una(j)|0)+16|0)|0,e);e=vna(j)|0;a[e+4|0]=1;wna(0,gna((una(j)|0)+28|0)|0);a[e+5|0]=1;xna(m,j);Rma(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Pma(b,g);Sma(m);Sma(j);i=f;return}function Rma(a,b){a=a|0;b=b|0;var c=0;c=i;nna(a,b);i=c;return}function Sma(a){a=a|0;var b=0;b=i;bna(a);i=b;return}function Tma(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;pfa(f);c[e>>2]=0;pfa(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=Jma(a)|0;b=c[c[e>>2]>>2]|0;pfa(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(hla(a)|0)>>2]|0;$ga(e,c[d>>2]|0);d=_ma(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function Uma(a){a=a|0;var b=0,d=0;b=i;d=c[(Yma(a)|0)>>2]|0;i=b;return d|0}function Vma(a){a=a|0;var b=0,d=0;b=i;d=Wma(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Wma(a){a=a|0;var b=0,c=0;b=i;c=Xma(a)|0;i=b;return c|0}function Xma(a){a=a|0;i=i;return a|0}function Yma(a){a=a|0;var b=0,c=0;b=i;c=Zma(a)|0;i=b;return c|0}function Zma(a){a=a|0;i=i;return a|0}function _ma(a){a=a|0;var b=0,c=0;b=i;c=$ma(a+8|0)|0;i=b;return c|0}function $ma(a){a=a|0;var b=0,c=0;b=i;c=ana(a)|0;i=b;return c|0}function ana(a){a=a|0;i=i;return a|0}function bna(a){a=a|0;var b=0;b=i;cna(a,0);i=b;return}function cna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Wma(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ena(dna(e)|0,f);i=d;return}function dna(a){a=a|0;var b=0,c=0;b=i;c=mna(a)|0;i=b;return c|0}function ena(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;fna(f,gna(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;hna(f,Bka(d+16|0)|0)}if((d|0)==0){i=e;return}ina(c[b>>2]|0,d,1);i=e;return}function fna(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lna(d,0,c);i=b;return}function gna(a){a=a|0;i=i;return a|0}function hna(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;kna(d,0,c);i=b;return}function ina(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jna(0,b,0);i=c;return}function jna(a,b,c){a=a|0;b=b|0;c=c|0;c=i;hEa(b);i=c;return}function kna(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Wta(c);i=b;return}function lna(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Wta(c);i=b;return}function mna(a){a=a|0;i=i;return a+4|0}function nna(a,b){a=a|0;b=b|0;var c=0;c=i;ona(a,b);i=c;return}function ona(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function pna(a){a=a|0;var b=0,c=0;b=i;c=Ina(a+4|0)|0;i=b;return c|0}function qna(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Ana(a,b,f);i=e;return}function rna(a,b){a=a|0;b=b|0;var c=0;a=i;c=zna(0,b,0)|0;i=a;return c|0}function sna(a,b){a=a|0;b=b|0;var c=0;c=i;yna(a,b);i=c;return}function tna(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Mta(b,c);i=a;return}function una(a){a=a|0;var b=0,d=0;b=i;d=c[(Yma(a)|0)>>2]|0;i=b;return d|0}function vna(a){a=a|0;var b=0,c=0;b=i;c=dna(a)|0;i=b;return c|0}function wna(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}Kta(b);i=a;return}function xna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;nna(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Pma(h,f);Rma(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Pma(a,e);Sma(h);i=d;return}function yna(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function zna(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=fEa(b*40|0)|0;i=c;return a|0}function Ana(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Cna(g)|0)>>2]|0;g=Dna(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Bna(b,a,f);i=e;return}function Bna(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];Ena(a,b,f);i=e;return}function Cna(a){a=a|0;i=i;return a|0}function Dna(a){a=a|0;i=i;return a|0}function Ena(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Gna(g)|0)>>2]|0;g=Hna(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];Fna(b,a,f);i=e;return}function Fna(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Gna(f)|0)>>2];f=Hna(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Gna(a){a=a|0;i=i;return a|0}function Hna(a){a=a|0;i=i;return a|0}function Ina(a){a=a|0;var b=0,c=0;b=i;c=Jna(a)|0;i=b;return c|0}function Jna(a){a=a|0;i=i;return a|0}function Kna(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Vma(Lna(b)|0)|0;h=Hna(vna(Lna(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];Bna(g,a,e);i=d;return}function Lna(a){a=a|0;i=i;return c[a>>2]|0}function Mna(a){a=a|0;var b=0;b=i;Nna(a);i=b;return}function Nna(a){a=a|0;var b=0;b=i;Ona(a);i=b;return}function Ona(a){a=a|0;var b=0;b=i;Pna(a,ola(a)|0);i=b;return}function Pna(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;pfa(d);if((b|0)==0){i=d;return}Pna(a,c[b>>2]|0);Pna(a,c[b+4>>2]|0);e=pna(a)|0;Qna(e,Rna(b+16|0)|0);ina(e,b,1);i=d;return}function Qna(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Sna(d,0,c);i=b;return}function Rna(a){a=a|0;i=i;return a|0}function Sna(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Tna(c);i=b;return}function Tna(a){a=a|0;var b=0;b=i;Una(a);i=b;return}function Una(a){a=a|0;var b=0;b=i;Vna(a);i=b;return}function Vna(a){a=a|0;var b=0;b=i;Wna(a);i=b;return}function Wna(a){a=a|0;var b=0;b=i;Wta(a+12|0);Wta(a);i=b;return}function Xna(a){a=a|0;var b=0;b=i;Yna(a+180|0);Yna(a+168|0);Yna(a+156|0);Yna(a+144|0);Yna(a+132|0);Yna(a+120|0);Yna(a+108|0);Yna(a+96|0);Yna(a+84|0);Yna(a+72|0);Yna(a+60|0);Yna(a+48|0);Yna(a+36|0);Yna(a+24|0);nja(a+12|0);nja(a);i=b;return}function Yna(a){a=a|0;var b=0;b=i;Zna(a);i=b;return}function Zna(a){a=a|0;var b=0;b=i;_na(a);i=b;return}function _na(a){a=a|0;var b=0;b=i;$na(a);i=b;return}function $na(a){a=a|0;var b=0;b=i;aoa(a,Dma(a)|0);i=b;return}function aoa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;pfa(d);if((b|0)==0){i=d;return}aoa(a,c[b>>2]|0);aoa(a,c[b+4>>2]|0);e=gma(a)|0;boa(e,coa(b+16|0)|0);ama(e,b,1);i=d;return}function boa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;doa(d,0,c);i=b;return}function coa(a){a=a|0;i=i;return a|0}function doa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;eoa(c);i=b;return}function eoa(a){a=a|0;var b=0;b=i;foa(a);i=b;return}function foa(a){a=a|0;var b=0;b=i;goa(a);i=b;return}function goa(a){a=a|0;var b=0;b=i;hoa(a);i=b;return}function hoa(a){a=a|0;var b=0;b=i;nja(a+4|0);i=b;return}function ioa(a){a=a|0;var b=0;b=i;joa(a);i=b;return}function joa(a){a=a|0;var b=0;b=i;koa(a);i=b;return}function koa(a){a=a|0;var b=0;b=i;loa(a,_ja(a)|0);i=b;return}function loa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;pfa(d);if((b|0)==0){i=d;return}loa(a,c[b>>2]|0);loa(a,c[b+4>>2]|0);e=Ika(a)|0;moa(e,Nja(b+16|0)|0);Cka(e,b,1);i=d;return}function moa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;noa(d,0,c);i=b;return}function noa(a,b,c){a=a|0;b=b|0;c=c|0;b=i;ooa(c);i=b;return}function ooa(a){a=a|0;var b=0;b=i;poa(a);i=b;return}function poa(a){a=a|0;var b=0;b=i;qoa(a);i=b;return}function qoa(a){a=a|0;var b=0;b=i;roa(a);i=b;return}function roa(a){a=a|0;var b=0;b=i;Wta(a);i=b;return}function soa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;toa(a);voa(g,b);woa(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];uoa(a,f,e);i=d;return a|0}function toa(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;Pna(a,ola(a)|0);c[(_ma(a)|0)>>2]=0;d=hla(a)|0;c[(Jma(a)|0)>>2]=d;pfa(b);c[d>>2]=0;i=b;return}function uoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;Eoa(h,a);if(!(Foa(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];xoa(j,g);o=Hoa(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];Goa(l,a,f,o);Ioa(b)|0;}while(Foa(b,d)|0);i=e;return}function voa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Coa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];xoa(a,e);i=d;return}function woa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;yoa(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];xoa(a,e);i=d;return}function xoa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Boa(a,e);i=d;return}function yoa(a,b){a=a|0;b=b|0;var c=0;c=i;zoa(a,pja(b)|0);i=c;return}function zoa(a,b){a=a|0;b=b|0;var c=0;c=i;Aoa(a,b);i=c;return}function Aoa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Boa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Coa(a,b){a=a|0;b=b|0;var d=0;d=i;zoa(a,c[(Doa(b)|0)>>2]|0);i=d;return}function Doa(a){a=a|0;i=i;return a|0}function Eoa(a,b){a=a|0;b=b|0;var c=0;c=i;woa(a,b);i=c;return}function Foa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Opa(a,b)|0;i=c;return d|0}function Goa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];Qoa(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];Poa(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];ela(a,g);Tna(l);i=f;return}function Hoa(a){a=a|0;var b=0,c=0;b=i;c=Moa(a)|0;i=b;return c|0}function Ioa(a){a=a|0;var b=0;b=i;Joa(a)|0;i=b;return a|0}function Joa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=Koa(c[d>>2]|0)|0;i=b;return a|0}function Koa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;pfa(b);if((e|0)==0){e=a;while(1){a=dha(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=Loa(c[d>>2]|0)|0;i=b;return g|0}return 0}function Loa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;pfa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;pfa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function Moa(a){a=a|0;var b=0,d=0;b=i;d=Noa((c[a>>2]|0)+16|0)|0;i=b;return d|0}function Noa(a){a=a|0;var b=0,c=0;b=i;c=Ooa(a)|0;i=b;return c|0}function Ooa(a){a=a|0;i=i;return a|0}function Poa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=Uoa(b,h,j,e)|0;h=c[p>>2]|0;pfa(l);if((h|0)!=0){q=h;gla(a,q);i=f;return}Woa(o,b,e);Xoa(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];Voa(m,g);Yoa(o);o=c[j>>2]|0;Tma(b,o,p,Zoa(m)|0);p=_oa(m)|0;Yoa(m);q=p;gla(a,q);i=f;return}function Qoa(a,b){a=a|0;b=b|0;var c=0;c=i;Roa(a,b);i=c;return}function Roa(a,b){a=a|0;b=b|0;var c=0;c=i;Soa(a,b);i=c;return}function Soa(a,b){a=a|0;b=b|0;var c=0;c=i;Toa(a,b);i=c;return}function Toa(a,b){a=a|0;b=b|0;var c=0;c=i;Mta(a,b);Mta(a+12|0,b+12|0);i=c;return}function Uoa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;fla(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];Cpa(l,k);do{if(!(Bpa(b,l)|0)){k=qla(a)|0;x=Epa(b)|0;if(Dpa(k,e,x)|0){break}w=Dpa(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];Ipa(r,h,1,0);fla(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];Cpa(t,g);do{if(!(Bpa(r,t)|0)){if(Dpa(k,e,Epa(r)|0)|0){break}y=Hpa(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;pfa(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;Fpa(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];Cpa(o,j);do{if(!(Bpa(n,o)|0)){j=qla(a)|0;if(Dpa(j,Epa(Gpa(n)|0)|0,e)|0){break}y=Hpa(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;pfa(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function Voa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];zpa(a,e);i=d;return}function Woa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=pna(d)|0;d=rna(n,1)|0;lpa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];kpa(j,d,h);mpa(0,Rna((npa(j)|0)+16|0)|0,e);a[(opa(j)|0)+4|0]=1;ppa(m,j);Xoa(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Voa(b,g);Yoa(m);Yoa(j);i=f;return}function Xoa(a,b){a=a|0;b=b|0;var c=0;c=i;ipa(a,b);i=c;return}function Yoa(a){a=a|0;var b=0;b=i;dpa(a);i=b;return}function Zoa(a){a=a|0;var b=0,d=0;b=i;d=c[(bpa(a)|0)>>2]|0;i=b;return d|0}function _oa(a){a=a|0;var b=0,d=0;b=i;d=$oa(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function $oa(a){a=a|0;var b=0,c=0;b=i;c=apa(a)|0;i=b;return c|0}function apa(a){a=a|0;i=i;return a|0}function bpa(a){a=a|0;var b=0,c=0;b=i;c=cpa(a)|0;i=b;return c|0}function cpa(a){a=a|0;i=i;return a|0}function dpa(a){a=a|0;var b=0;b=i;epa(a,0);i=b;return}function epa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=$oa(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}gpa(fpa(e)|0,f);i=d;return}function fpa(a){a=a|0;var b=0,c=0;b=i;c=hpa(a)|0;i=b;return c|0}function gpa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;Qna(f,Rna(d+16|0)|0)}if((d|0)==0){i=e;return}ina(c[b>>2]|0,d,1);i=e;return}function hpa(a){a=a|0;i=i;return a+4|0}function ipa(a,b){a=a|0;b=b|0;var c=0;c=i;jpa(a,b);i=c;return}function jpa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function kpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];tpa(a,b,f);i=e;return}function lpa(a,b){a=a|0;b=b|0;var c=0;c=i;spa(a,b);i=c;return}function mpa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}qpa(b,c);i=a;return}function npa(a){a=a|0;var b=0,d=0;b=i;d=c[(bpa(a)|0)>>2]|0;i=b;return d|0}function opa(a){a=a|0;var b=0,c=0;b=i;c=fpa(a)|0;i=b;return c|0}function ppa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;ipa(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Voa(h,f);Xoa(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Voa(a,e);Yoa(h);i=d;return}function qpa(a,b){a=a|0;b=b|0;var c=0;c=i;rpa(a,b);i=c;return}function rpa(a,b){a=a|0;b=b|0;var c=0;c=i;Soa(a,b);i=c;return}function spa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function tpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Cna(g)|0)>>2]|0;g=vpa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];upa(b,a,f);i=e;return}function upa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];wpa(a,b,f);i=e;return}function vpa(a){a=a|0;i=i;return a|0}function wpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Gna(g)|0)>>2]|0;g=ypa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];xpa(b,a,f);i=e;return}function xpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Gna(f)|0)>>2];f=ypa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function ypa(a){a=a|0;i=i;return a|0}function zpa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=_oa(Apa(b)|0)|0;h=ypa(opa(Apa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];upa(g,a,e);i=d;return}function Apa(a){a=a|0;i=i;return c[a>>2]|0}function Bpa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Cpa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Npa(a,e);i=d;return}function Dpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uja(0,b,c)|0;i=a;return d|0}function Epa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function Fpa(a,b){a=a|0;b=b|0;var d=0;d=i;gla(a,c[(Jma(b)|0)>>2]|0);i=d;return}function Gpa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=Lpa(c[d>>2]|0)|0;i=b;return a|0}function Hpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=ola(a)|0;pfa(e);if((h|0)==0){j=hla(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=qla(a)|0;a=h;while(1){h=a+16|0;if(Dpa(j,d,h)|0){l=a;m=c[l>>2]|0;pfa(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(Dpa(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;pfa(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Ipa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;Jpa(b,d);c[a>>2]=c[b>>2];i=e;return}function Jpa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;Kpa(b,c,e);i=d;return}function Kpa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{Gpa(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{Joa(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function Lpa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;pfa(b);if((e|0)==0){e=a;while(1){a=dha(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=Mpa(c[d>>2]|0)|0;i=b;return g|0}return 0}function Mpa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;pfa(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;pfa(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function Npa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Opa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(Bpa(a,b)|0)^1;i=c;return d|0}function Ppa(a){a=a|0;var b=0;b=i;i=i+128|0;fja(a,b);fja(a+12|0,b+8|0);Qpa(a+24|0,b+16|0);Qpa(a+36|0,b+24|0);Qpa(a+48|0,b+32|0);Qpa(a+60|0,b+40|0);Qpa(a+72|0,b+48|0);Qpa(a+84|0,b+56|0);Qpa(a+96|0,b+64|0);Qpa(a+108|0,b+72|0);Qpa(a+120|0,b+80|0);Qpa(a+132|0,b+88|0);Qpa(a+144|0,b+96|0);Qpa(a+156|0,b+104|0);Qpa(a+168|0,b+112|0);Qpa(a+180|0,b+120|0);i=b;return}function Qpa(a,b){a=a|0;b=b|0;b=i;Rpa(a,0);i=b;return}function Rpa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Spa(a,b);i=b;return}function Spa(a,b){a=a|0;b=b|0;b=i;Tpa(a,0);i=b;return}function Tpa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Upa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Vpa(f,0,e);e=Qla(b)|0;c[(Pla(b)|0)>>2]=e;i=d;return}function Upa(a){a=a|0;var b=0;b=i;Ypa(a);i=b;return}function Vpa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Wpa(b,c,f);i=e;return}function Wpa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(Tha(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Xpa(d,b,f);i=e;return}function Xpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(Tha(e)|0)>>2];i=d;return}function Ypa(a){a=a|0;var b=0;b=i;Zpa(a);i=b;return}function Zpa(a){a=a|0;var b=0;b=i;Wha(a);i=b;return}function _pa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[106988>>2]|0;if((m|0)==0){n=0}else{o=fEa(12)|0;Qta(o,m);n=o}if((c[106904>>2]|0)!=0){c[12462]=1}if((n|0)==0){c[49860>>2]=1;c[49864>>2]=1;i=b;return}do{if((sua(n,97192,0)|0)==-1){Mta(g,n);Kta(h);o=c[12036]|0;m=(o|0)<28;while(1){p=sua(g,97200,0)|0;q=(p|0)!=-1;if(q){qua(j,g,0,p);Xta(h,j)|0;Wta(j);qua(k,g,p+1|0,-1);Xta(g,k)|0;Wta(k)}else{Xta(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){Qta(l,c[48560+(s<<2)>>2]|0);p=$pa(h,l)|0;Wta(l);if(p){c[49856+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){F9(1,1,97208,f);if(m){v=o}else{w=50408;x=c[12602]|0;fe[x&511](1);y=rua(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=97248;E=D;H9(0,E,a)}do{p=c[49728+(v<<2)>>2]|0;c[e>>2]=c[48560+(v<<2)>>2];c[e+4>>2]=p;F9(1,0,97232,e);v=v+1|0;}while((v|0)<28);w=50408;x=c[12602]|0;fe[x&511](1);y=rua(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=97248;E=D;H9(0,E,a)}else if((t|0)==20){F9(1,1,97208,d);w=50408;x=c[12602]|0;fe[x&511](1);y=rua(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=97248;E=D;H9(0,E,a)}else if((t|0)==23){Wta(h);Wta(g);break}}else{o=1;do{c[49856+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[49860>>2]=1;c[49864>>2]=1;if((c[49892>>2]|0)!=0){c[49952>>2]=1}if((c[49948>>2]|0)==1){c[49956>>2]=1}if((c[49928>>2]|0)!=0){c[49924>>2]=1}if((c[49936>>2]|0)!=0){c[49924>>2]=1}if((c[49888>>2]|0)!=0){c[49884>>2]=1}if((c[49932>>2]|0)!=0){c[49924>>2]=1}if((c[49880>>2]|0)!=0){c[49876>>2]=1}Wta(n);hEa(n);i=b;return}function $pa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=Uta(b)|0;if((e|0)!=(Uta(c)|0)){f=0;i=d;return f|0}g=Vta(b)|0;h=Vta(c)|0;if(Nta(b)|0){f=(wja(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function aqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[106996>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=fEa(12)|0;l=k;Qta(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(bqa(l,c[82288+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=rua(l)|0;F9(1,1,97280,g);g=c[82372>>2]|0;c[f>>2]=c[82292>>2];c[f+4>>2]=g;F9(1,0,97232,f);f=c[82376>>2]|0;c[e>>2]=c[82296>>2];c[e+4>>2]=f;F9(1,0,97232,e);e=c[82380>>2]|0;c[d>>2]=c[82300>>2];c[d+4>>2]=e;F9(1,0,97232,d);fe[c[12602]&511](1);H9(0,97336,a)}else if((n|0)==6){i=b;return j|0}return 0}function bqa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(uua(a,b)|0)==0;i=c;return d|0}function cqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[106980>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=fEa(12)|0;l=k;Qta(l,h);if((k|0)==0){j=1;i=b;return j|0}Qta(f,97360);k=$pa(l,f)|0;Wta(f);if(k){j=1;i=b;return j|0}Qta(g,97368);k=$pa(l,g)|0;Wta(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=rua(l)|0;F9(1,1,97376,e);c[d>>2]=97360;c[d+4>>2]=97432;F9(1,0,97232,d);c[a>>2]=97368;c[a+4>>2]=97448;F9(1,0,97232,a);fe[c[12602]&511](1);H9(0,97336,b)}return 0}function dqa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;dwa(f,a);if(!(gwa(f)|0)){ewa(f);i=d;return a|0}j=Eja(b)|0;qqa(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((tfa(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=Qua(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];tqa(h,e,b,m,k,l,n);if(!(rqa(h)|0)){ewa(f);i=d;return a|0}Kua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);ewa(f);i=d;return a|0}function eqa(a){a=a|0;var b=0;b=i;jwa(a,Rua(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;Sva(a)|0;i=b;return a|0}function fqa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;Qta(h,d);Fua(k,97456,h);Ria(j,k,97464);Wta(k);k=rua(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((zEa(c[n+4>>2]|0,97472)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((zEa(k,97480)|0)==0){Wta(j);Wta(h);i=f;return}d=hDa(g,k,1)|0;if((d|0)!=0){m=l;HEa(m|0,0,2048)|0;uDa(d,g,m,2048)|0;hwa(dqa(dqa(dqa(dqa(dqa(119384,97488)|0,k)|0,97528)|0,m)|0,97544)|0,103)|0;Wta(j);Wta(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(vDa(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(vDa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(vDa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(vDa(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==1){q=(vDa(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(vDa(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){p=b+8|0;s=m;m=0;while(1){l=c[p>>2]|0;if((a[l+(m*48|0)+44|0]|0)==0){k=(vDa(g,c[l+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(m*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=m+1|0;if((k|0)<(t|0)){s=t;m=k}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;p=b+24|0;k=0;do{l=c[t>>2]|0;do{if((a[l+(k*52|0)+48|0]|0)==0){d=a[l+(k*52|0)+8|0]|0;if(d<<24>>24==1){n=(vDa(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[p>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(vDa(g,c[l+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[d+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[m>>2]|0))}m=b+124|0;k=c[m>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){p=c[s>>2]|0;if((a[p+(k*52|0)+48|0]|0)==0){o=(vDa(g,c[p+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==1){p=(vDa(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=p;p=c[u>>2]|0;if((a[p+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[p+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==0){o=(vDa(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}lDa(g);Wta(j);Wta(h);i=f;return}function gqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[106844>>2]|0;H=c[106972>>2]|0;I=c[2]|0;if((c[49956>>2]|0)==0){if(!((c[106792>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;D9(23,0,97592,l);l=c[106916>>2]|0;do{if((l|0)==0){M=0}else{if((zEa(l,97616)|0)==0){M=1;break}if((zEa(l,97624)|0)==0){M=0;break}if((zEa(l,97632)|0)==0){M=2;break}c[j>>2]=l;F9(1,0,97640,j);M=0}}while(0);if((Uaa(M)|0)!=0){c[g>>2]=l;F9(1,0,97712,g)}if((c[2]|0)!=0){ora(d+56|0);Zaa((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Vaa(0);Vaa(6);Waa(3);Waa(4);Waa(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+vEa(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];D9(1,0,97800,f)}do{if((c[106900>>2]|0)!=0){f=fEa(12)|0;J=f;Qta(J,c[107028>>2]|0);if((f|0)==0){break}f=rua(J)|0;c[d+280>>2]=f;c[e>>2]=f;D9(23,0,97856,e)}}while(0);e=c[107024>>2]|0;Kta(m);if((e|0)==0){Qta(p,c[d+88>>2]|0);Qta(q,97904);hqa(o,p,q);Ria(n,o,c[d+284>>2]|0);Xta(m,n)|0;Wta(n);Wta(o);Wta(q);Wta(p)}else{Yta(m,e)|0}Qta(r,97912);Qta(s,97912);Qta(t,97912);Qta(u,97912);Qta(v,97912);Qta(w,97912);e=c[106792>>2]|0;if((c[106812>>2]|0)!=0){Yta(r,c[106940>>2]|0)|0}if((c[106828>>2]|0)!=0){Yta(s,c[106956>>2]|0)|0}if((c[106808>>2]|0)!=0){Yta(t,c[106936>>2]|0)|0}if((c[106816>>2]|0)==0){O=0.0}else{Yta(u,c[106944>>2]|0)|0;O=+vEa(rua(u)|0)}if((c[106820>>2]|0)==0){P=1}else{Yta(v,c[106948>>2]|0)|0;P=Fc(rua(v)|0)|0}if((c[106880>>2]|0)!=0){Yta(w,c[107008>>2]|0)|0}Mta(x,m);Mta(y,r);Mta(z,s);Mta(A,t);Mta(B,w);p=iqa(d,x,y,z,A,O,P,B,e)|0;Wta(B);Wta(A);Wta(z);Wta(y);Wta(x);if((p|0)!=0|g^1){Q=p}else{Vaa(5);p=Fqa(d)|0;Yaa(5);D9(1,0,97920,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Wta(w);Wta(v);Wta(u);Wta(t);Wta(s);Wta(r);Wta(m);i=b;return R|0}Q=d+88|0;Qta(D,c[Q>>2]|0);Ria(C,D,97952);Wta(D);Qta(F,c[Q>>2]|0);Ria(E,F,97968);Wta(F);Yaa(0);F=c[106992>>2]|0;Q=rua(C)|0;D=rua(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;cra(d,Q,D,(F|0)!=0?F:97984,I,p,rua(m)|0)|0;Wta(E);Wta(C);R=0;Wta(w);Wta(v);Wta(u);Wta(t);Wta(s);Wta(r);Wta(m);i=b;return R|0}function hqa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Lta(a,d);e=Uta(b)|0;f=Uta(c)|0;vua(a,Vta(b)|0,e,f+e|0);nua(a,Vta(c)|0,f)|0;i=d;return}function iqa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((Uta(j)|0)==0){u=0}else{u=rua(j)|0}Mta(r,b);b=(jqa(a,r,k)|0)==0;Wta(r);if(!b){v=-1;i=l;return v|0}Qta(s,97912);b=a+280|0;r=bqa(s,c[b>>2]|0)|0;Wta(s);do{if(r){w=3}else{s=1;k=0;do{Qta(t,c[98128+(s<<2)>>2]|0);j=bqa(t,c[b>>2]|0)|0;Wta(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];F9(1,0,98208,q);F9(1,0,97208,p);s=1;do{j=c[98240+(s<<2)>>2]|0;c[o>>2]=c[98128+(s<<2)>>2];c[o+4>>2]=j;F9(1,0,97232,o);s=s+1|0;}while((s|0)<20);H9(c[a+536>>2]|0,97336,n)}}while(0);c[m>>2]=c[98128+(w<<2)>>2];D9(23,0,98320,m);m=rua(d)|0;d=rua(e)|0;e=Ida(a,m,d,rua(f)|0,g,h,w,u)|0;ge[c[91572>>2]&127](91544,a);v=e;i=l;return v|0}function jqa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[22886]=Ad(rua(b)|0)|0;c[91548>>2]=g;c[91552>>2]=d;d=a+284|0;do{if((c[24296]|0)==0){g=c[d>>2]|0;if((zEa(97992,g)|0)==0){h=0;break}if((zEa(98e3,g)|0)==0){c[91560>>2]=51;c[91564>>2]=52;c[91572>>2]=53;h=0;break}if((zEa(98008,g)|0)==0){c[91560>>2]=54;c[91564>>2]=55;c[91568>>2]=56;c[91572>>2]=57;h=1;break}if((zEa(98016,g)|0)==0){c[91560>>2]=58;c[91564>>2]=59;c[91568>>2]=60;c[91572>>2]=61;h=1;break}if((zEa(98024,g)|0)==0){c[91560>>2]=62;c[91564>>2]=63;c[91572>>2]=64;h=0;break}g=dqa(119384,98032)|0;hwa(dqa(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);fqa(a+8|0,c[a+288>>2]|0,h);ge[c[91560>>2]&127](91544,a);a=c[22886]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;D9(23,0,98056,f);j=0;i=e;return j|0}



function $Da(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[34986]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=139984+(j<<2)|0;l=139984+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[34986]=f&~(1<<h)}else{if(n>>>0<(c[139960>>2]|0)>>>0){hd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{hd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[139952>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=139984+(r<<2)|0;o=139984+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[34986]=f&~(1<<t)}else{if(n>>>0<(c[139960>>2]|0)>>>0){hd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{hd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[139952>>2]|0;if((n|0)!=0){f=c[139964>>2]|0;e=n>>>3;n=e<<1;g=139984+(n<<2)|0;m=c[34986]|0;j=1<<e;do{if((m&j|0)==0){c[34986]=m|j;u=139984+(n+2<<2)|0;v=g}else{e=139984+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[139960>>2]|0)>>>0)){u=e;v=h;break}hd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[139952>>2]=o;c[139964>>2]=s;p=k;i=b;return p|0}n=c[139948>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[140248+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[139960>>2]|0;if(h>>>0<k>>>0){hd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){hd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){hd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){hd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){hd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{hd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=140248+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<h);break a}else{if(s>>>0<(c[139960>>2]|0)>>>0){hd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[139960>>2]|0)>>>0){hd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[139952>>2]|0;if((h|0)!=0){s=c[139964>>2]|0;k=h>>>3;h=k<<1;f=139984+(h<<2)|0;m=c[34986]|0;g=1<<k;do{if((m&g|0)==0){c[34986]=m|g;A=139984+(h+2<<2)|0;B=f}else{k=139984+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[139960>>2]|0)>>>0)){A=k;B=e;break}hd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[139952>>2]=t;c[139964>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[139948>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[140248+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[140248+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[139952>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[139960>>2]|0;if(t>>>0<f>>>0){hd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){hd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){hd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){hd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){hd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{hd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=140248+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<e);break c}else{if(t>>>0<(c[139960>>2]|0)>>>0){hd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[139960>>2]|0)>>>0){hd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=139984+(t<<2)|0;s=c[34986]|0;r=1<<e;do{if((s&r|0)==0){c[34986]=s|r;S=139984+(t+2<<2)|0;T=f}else{e=139984+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[139960>>2]|0)>>>0)){S=e;T=k;break}hd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=140248+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[139948>>2]|0;l=1<<U;if((f&l|0)==0){c[139948>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[139960>>2]|0;if(W>>>0<k>>>0){hd()}if(r>>>0<k>>>0){hd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[139952>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[139964>>2]|0;if(W>>>0>15){c[139964>>2]=X+q;c[139952>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[139952>>2]=0;c[139964>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[139956>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[139956>>2]=W;X=c[139968>>2]|0;c[139968>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[35104]|0)==0){X=ed(30)|0;if((X+ -1&X|0)==0){c[140424>>2]=X;c[140420>>2]=X;c[140428>>2]=-1;c[140432>>2]=-1;c[140436>>2]=0;c[140388>>2]=0;c[35104]=(sc(0)|0)&-16^1431655768;break}else{hd()}}}while(0);X=q+48|0;W=c[140424>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[140384>>2]|0;do{if((U|0)!=0){T=c[140376>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[140388>>2]&4|0)==0){U=c[139968>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=140392|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[139956>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[140420>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[140376>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[140384>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[140424>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[140388>>2]=c[140388>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[140376>>2]|0)+ga|0;c[140376>>2]=ia;if(ia>>>0>(c[140380>>2]|0)>>>0){c[140380>>2]=ia}ia=c[139968>>2]|0;W=140392|0;i:do{if((ia|0)==0){aa=c[139960>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[139960>>2]=fa}c[140392>>2]=fa;c[140396>>2]=ga;c[140404>>2]=0;c[139980>>2]=c[35104];c[139976>>2]=-1;aa=0;do{ha=aa<<1;$=139984+(ha<<2)|0;c[139984+(ha+3<<2)>>2]=$;c[139984+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[139968>>2]=fa+ja;c[139956>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[139972>>2]=c[140432>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[139956>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[139968>>2]=ia+na;c[139956>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[139972>>2]=c[140432>>2];break i}}while(0);if(fa>>>0<(c[139960>>2]|0)>>>0){c[139960>>2]=fa}aa=fa+ga|0;$=140392|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[139968>>2]|0)){ca=(c[139956>>2]|0)+X|0;c[139956>>2]=ca;c[139968>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[139964>>2]|0)){ca=(c[139952>>2]|0)+X|0;c[139952>>2]=ca;c[139964>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=139984+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[139960>>2]|0)>>>0){hd()}if((c[V+12>>2]|0)==(ha|0)){break}hd()}}while(0);if((L|0)==(V|0)){c[34986]=c[34986]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[139960>>2]|0)>>>0){hd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}hd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[139960>>2]|0)>>>0){hd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){hd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{hd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=140248+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<t);break k}else{if(T>>>0<(c[139960>>2]|0)>>>0){hd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[139960>>2]|0)>>>0){hd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=139984+(Z<<2)|0;t=c[34986]|0;T=1<<ca;do{if((t&T|0)==0){c[34986]=t|T;xa=139984+(Z+2<<2)|0;ya=ea}else{ca=139984+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[139960>>2]|0)>>>0)){xa=ca;ya=V;break}hd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=140248+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[139948>>2]|0;L=1<<za;if((ea&L|0)==0){c[139948>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[139960>>2]|0;if(Ba>>>0<S>>>0){hd()}if(T>>>0<S>>>0){hd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=140392|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[139968>>2]=fa+Ha;c[139956>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[139972>>2]=c[140432>>2];c[ba+4>>2]=27;X=140392|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[140392>>2]=fa;c[140396>>2]=ga;c[140404>>2]=0;c[140400>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=139984+(da<<2)|0;aa=c[34986]|0;f=1<<M;do{if((aa&f|0)==0){c[34986]=aa|f;Ia=139984+(da+2<<2)|0;Ja=ha}else{M=139984+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[139960>>2]|0)>>>0)){Ia=M;Ja=T;break}hd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=140248+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[139948>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[139948>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[139960>>2]|0;if(Ma>>>0<f>>>0){hd()}if(M>>>0<f>>>0){hd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[139956>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[139956>>2]=W;ia=c[139968>>2]|0;c[139968>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}function aEa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[139960>>2]|0;if(d>>>0<f>>>0){hd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){hd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){hd()}if((p|0)==(c[139964>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[139952>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=139984+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){hd()}if((c[m+12>>2]|0)==(p|0)){break}hd()}}while(0);if((u|0)==(m|0)){c[34986]=c[34986]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){hd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}hd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){hd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){hd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){hd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{hd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=140248+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[139960>>2]|0)>>>0){hd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[139960>>2]|0)>>>0){hd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){hd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){hd()}do{if((C&2|0)==0){if((l|0)==(c[139968>>2]|0)){f=(c[139956>>2]|0)+t|0;c[139956>>2]=f;c[139968>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[139964>>2]|0)){i=b;return}c[139964>>2]=0;c[139952>>2]=0;i=b;return}if((l|0)==(c[139964>>2]|0)){f=(c[139952>>2]|0)+t|0;c[139952>>2]=f;c[139964>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=139984+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[139960>>2]|0)>>>0){hd()}if((c[E+12>>2]|0)==(l|0)){break}hd()}}while(0);if((w|0)==(E|0)){c[34986]=c[34986]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[139960>>2]|0)>>>0){hd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}hd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[139960>>2]|0)>>>0){hd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){hd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{hd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=140248+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<g);break b}else{if(d>>>0<(c[139960>>2]|0)>>>0){hd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[139960>>2]|0)>>>0){hd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[139964>>2]|0)){J=f;break}c[139952>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=139984+(C<<2)|0;G=c[34986]|0;j=1<<t;do{if((G&j|0)==0){c[34986]=G|j;K=139984+(C+2<<2)|0;L=e}else{t=139984+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[139960>>2]|0)>>>0)){K=t;L=a;break}hd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=140248+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[139948>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[139948>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[139960>>2]|0;if(O>>>0<K>>>0){hd()}if(f>>>0<K>>>0){hd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[139976>>2]|0)+ -1|0;c[139976>>2]=s;if((s|0)==0){Q=140400|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[139976>>2]=-1;i=b;return}function bEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=$Da(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}HEa(b|0,0,e|0)|0;i=d;return b|0}function cEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=$Da(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=dEa(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=$Da(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;FEa(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;aEa(a);e=g;i=d;return e|0}function dEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[139960>>2]|0;if(h>>>0<l>>>0){hd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){hd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){hd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[140424>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;eEa(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[139968>>2]|0)){m=(c[139956>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[139968>>2]=a+b;c[139956>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[139964>>2]|0)){h=(c[139952>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[139952>>2]=r;c[139964>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=139984+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){hd()}if((c[h+12>>2]|0)==(k|0)){break}hd()}}while(0);if((m|0)==(h|0)){c[34986]=c[34986]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){hd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}hd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){hd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){hd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{hd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=140248+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<u);break a}else{if(t>>>0<(c[139960>>2]|0)>>>0){hd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[139960>>2]|0)>>>0){hd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;eEa(a+b|0,r);o=a;i=d;return o|0}return 0}function eEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[139960>>2]|0;if(j>>>0<m>>>0){hd()}if((k|0)==(c[139964>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[139952>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=139984+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){hd()}if((c[q+12>>2]|0)==(k|0)){break}hd()}}while(0);if((r|0)==(q|0)){c[34986]=c[34986]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){hd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}hd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){hd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){hd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{hd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=140248+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[139960>>2]|0)>>>0){hd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[139960>>2]|0)>>>0){hd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[139960>>2]|0;if(e>>>0<z>>>0){hd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[139968>>2]|0)){t=(c[139956>>2]|0)+p|0;c[139956>>2]=t;c[139968>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[139964>>2]|0)){i=d;return}c[139964>>2]=0;c[139952>>2]=0;i=d;return}if((f|0)==(c[139964>>2]|0)){t=(c[139952>>2]|0)+p|0;c[139952>>2]=t;c[139964>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=139984+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){hd()}if((c[u+12>>2]|0)==(f|0)){break}hd()}}while(0);if((h|0)==(u|0)){c[34986]=c[34986]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){hd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}hd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){hd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){hd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){hd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{hd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=140248+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[139948>>2]=c[139948>>2]&~(1<<j);break b}else{if(m>>>0<(c[139960>>2]|0)>>>0){hd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[139960>>2]|0)>>>0){hd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[139960>>2]|0)>>>0){hd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[139964>>2]|0)){G=t;break}c[139952>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=139984+(B<<2)|0;D=c[34986]|0;b=1<<p;do{if((D&b|0)==0){c[34986]=D|b;H=139984+(B+2<<2)|0;I=A}else{p=139984+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[139960>>2]|0)>>>0)){H=p;I=a;break}hd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=140248+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[139948>>2]|0;B=1<<J;if((a&B|0)==0){c[139948>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[139960>>2]|0)>>>0){hd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[139960>>2]|0;if(L>>>0<B>>>0){hd()}if(G>>>0<B>>>0){hd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function fEa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=$Da(d)|0;if((e|0)!=0){f=6;break}a=c[35110]|0;c[35110]=0+a;if((a|0)==0){f=5;break}Fe[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=140456;Td(d|0,140504,135)}else if((f|0)==6){i=b;return e|0}return 0}function gEa(a){a=a|0;var b=0,c=0;b=i;c=fEa(a)|0;i=b;return c|0}function hEa(a){a=a|0;var b=0;b=i;if((a|0)!=0){aEa(a)}i=b;return}function iEa(a){a=a|0;var b=0;b=i;hEa(a);i=b;return}function jEa(a){a=a|0;var b=0;b=i;zb(a|0);hEa(a);i=b;return}function kEa(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function lEa(a){a=a|0;i=i;return 140472}function mEa(){var a=0;a=Ec(4)|0;c[a>>2]=140456;Td(a|0,140504,135)}function nEa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=qEa(b)|0}}while((jd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=qEa(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[140520+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=qEa(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[140536+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=qEa(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=qEa(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=qEa(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=qEa(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=qEa(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=qEa(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=NEa(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=NEa(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=qEa(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){pEa(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=NEa(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=oEa(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){pEa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=IEa(q|0,n|0,2)|0;o=NEa(p|0,J|0,-32,-1)|0;p=NEa(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=NEa(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=MEa(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=NEa(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Rd(+(+rEa(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+sEa(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=qEa(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=qEa(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=qEa(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=NEa(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=NEa(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=qEa(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=oEa(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){pEa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=NEa(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;pEa(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[140552+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[140552+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[140552+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=IEa(c[Ra>>2]|0,0,29)|0;Qa=NEa(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=XEa(Qa|0,Ta|0,1e9,0)|0;pa=YEa(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=IEa(c[Ua>>2]|0,0,29)|0;Ra=NEa(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=XEa(Ra|0,Sa|0,1e9,0)|0;Pa=YEa(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[140544+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Rd(+(+rEa(1.0,105-tc|0)),+sc);vc=+zc(+sc,+(+rEa(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+zc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=yc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+sEa(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=qEa(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=qEa(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;pEa(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;pEa(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function oEa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=qEa(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=qEa(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=qEa(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=WEa(q|0,m|0,10,0)|0;b=J;g=NEa(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=NEa(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=qEa(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=qEa(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=MEa(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function pEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function qEa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=uEa(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function rEa(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=IEa(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function sEa(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+rEa(a,b);i=c;return+d}function tEa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){le[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function uEa(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((tEa(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((le[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function vEa(a){a=a|0;var b=0,c=0.0;b=i;c=+wEa(a,0);i=b;return+c}function wEa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;pEa(e,0);h=+nEa(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function xEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;pEa(e,0);h=+nEa(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function yEa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function zEa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function AEa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function BEa(){c[30214]=p;c[30256]=p;c[34898]=p;c[35128]=p}function CEa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}dc(116);dc(111);dc(111);dc(32);dc(109);dc(97);dc(110);dc(121);dc(32);dc(115);dc(101);dc(116);dc(106);dc(109);dc(112);dc(115);dc(32);dc(105);dc(110);dc(32);dc(97);dc(32);dc(102);dc(117);dc(110);dc(99);dc(116);dc(105);dc(111);dc(110);dc(32);dc(99);dc(97);dc(108);dc(108);dc(44);dc(32);dc(98);dc(117);dc(105);dc(108);dc(100);dc(32);dc(119);dc(105);dc(116);dc(104);dc(32);dc(97);dc(32);dc(104);dc(105);dc(103);dc(104);dc(101);dc(114);dc(32);dc(118);dc(97);dc(108);dc(117);dc(101);dc(32);dc(102);dc(111);dc(114);dc(32);dc(77);dc(65);dc(88);dc(95);dc(83);dc(69);dc(84);dc(74);dc(77);dc(80);dc(83);dc(10);ga(0);return 0}function DEa(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function EEa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function FEa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function GEa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{FEa(b,c,d)|0}return b|0}function HEa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function IEa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function JEa(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function KEa(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function LEa(){return KEa(o)|0}function MEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function NEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function OEa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function PEa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function QEa(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function REa(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function SEa(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function TEa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function UEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=MEa(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=MEa((ZEa(i,b,MEa(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function VEa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=MEa(h^a,j^b,h,j)|0;b=J;ZEa(m,b,MEa(k^d,l^e,k,l)|0,J,g)|0;l=MEa(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function WEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=TEa(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function XEa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=ZEa(a,b,c,d,0)|0;return(J=J,e)|0}function YEa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;ZEa(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function ZEa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((SEa(l|0)|0)>>>0);return(J=n,o)|0}p=(REa(l|0)|0)-(REa(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(REa(l|0)|0)-(REa(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(REa(j|0)|0)+33-(REa(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=SEa(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=NEa(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;MEa(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=MEa(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function _Ea(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return be[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function $Ea(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ce[a&31](b|0,c|0,d|0,e|0,f|0)}function aFa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return de[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function bFa(a,b){a=a|0;b=+b;ee[a&1](+b)}function cFa(a,b){a=a|0;b=b|0;fe[a&511](b|0)}function dFa(a,b,c){a=a|0;b=b|0;c=c|0;ge[a&127](b|0,c|0)}function eFa(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function fFa(a,b){a=a|0;b=b|0;return ie[a&127](b|0)|0}function gFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;je[a&1](b|0,c|0,+d,e|0)}function hFa(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function iFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return le[a&63](b|0,c|0,d|0)|0}function jFa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function kFa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ne[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function lFa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;oe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function mFa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function nFa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function oFa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;re[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function pFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;se[a&3](b|0,c|0,+d,e|0,f|0)}function qFa(a,b,c){a=a|0;b=b|0;c=+c;return te[a&1](b|0,+c)|0}function rFa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ue[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function sFa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ve[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function tFa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;we[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function uFa(a,b,c){a=a|0;b=b|0;c=c|0;return xe[a&63](b|0,c|0)|0}function vFa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ye[a&63](b|0,c|0,d|0,e|0,f|0)|0}function wFa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ze[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function xFa(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ae[a&1](b|0,+c,+d)}function yFa(a,b,c){a=a|0;b=b|0;c=c|0;return+Be[a&1](b|0,c|0)}function zFa(a){a=a|0;return Ce[a&7]()|0}function AFa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return De[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function BFa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ee[a&15](b|0,c|0,d|0)}function CFa(a){a=a|0;Fe[a&7]()}function DFa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ge[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function EFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return He[a&63](b|0,c|0,d|0,e|0)|0}function FFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ie[a&31](b|0,c|0,d|0,e|0)}function GFa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function HFa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function IFa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function JFa(a){a=+a;ga(3)}function KFa(a){a=a|0;ga(4)}function LFa(a){a=a|0;Cd(a|0)}function MFa(a,b){a=a|0;b=b|0;ga(5)}function NFa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function OFa(a){a=a|0;ga(7);return 0}function PFa(a){a=a|0;return Oc(a|0)|0}function QFa(a){a=a|0;return Ld(a|0)|0}function RFa(a){a=a|0;return wc(a|0)|0}function SFa(a){a=a|0;return Ad(a|0)|0}function TFa(a){a=a|0;return md(a|0)|0}function UFa(a){a=a|0;return ud(a|0)|0}function VFa(a){a=a|0;return Yc(a|0)|0}function WFa(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function XFa(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function YFa(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function ZFa(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function _Fa(a,b,c){a=a|0;b=b|0;c=c|0;return hc(a|0,b|0,c|0)|0}function $Fa(a,b,c){a=a|0;b=b|0;c=c|0;return Od(a|0,b|0,c|0)|0}function aGa(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function bGa(a,b,c){a=a|0;b=b|0;c=c|0;return xd(a|0,b|0,c|0)|0}function cGa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function dGa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function eGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function fGa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function gGa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function hGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function iGa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function jGa(a,b){a=a|0;b=+b;ga(18);return 0}function kGa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function lGa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function mGa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function nGa(a,b){a=a|0;b=b|0;ga(22);return 0}function oGa(a,b){a=a|0;b=b|0;return Qd(a|0,b|0)|0}function pGa(a,b){a=a|0;b=b|0;return gc(a|0,b|0)|0}function qGa(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function rGa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function sGa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function tGa(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function uGa(a,b){a=a|0;b=b|0;ga(26);return 0.0}function vGa(){ga(27);return 0}function wGa(){return jb()|0}function xGa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function yGa(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function zGa(){ga(30)}function AGa(){Uc()}function BGa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function CGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function DGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function EGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function FGa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function sz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=0.0;i=i;return}function tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=1.0;i=i;return}function wz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=1.0;i=i;return}function yz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function Az(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=0.0;i=i;return}function Bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=0.0;i=i;return}function Cz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function Dz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function Ez(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=0.0;i=i;return}function Fz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function Gz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=1.0;i=i;return}function Hz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function Iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function Jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function Kz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=1.0;i=i;return}function Lz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function Mz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=0.0;i=i;return}function Nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function Oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function Pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function Qz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function Rz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=1.0;i=i;return}function Sz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=0.0;i=i;return}function Tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=0.0;i=i;return}function Uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function Vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=1.0;i=i;return}function Wz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=0.0;i=i;return}function Xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function Yz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function Zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=0.0;i=i;return}function _z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function $z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=0.0;i=i;return}function aA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=0.0;i=i;return}function bA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=1.0;i=i;return}function cA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=0.0;i=i;return}function dA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function eA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function fA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function gA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function hA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function iA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function jA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=0.0;i=i;return}function kA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=1.0;i=i;return}function lA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=0.0;i=i;return}function mA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=1.0;i=i;return}function nA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function oA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=0.0;i=i;return}function pA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=0.0;i=i;return}function qA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function rA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=0.0;i=i;return}function sA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=0.0;i=i;return}function tA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function uA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=1.0;i=i;return}function vA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function wA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function xA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function yA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=1.0;i=i;return}function zA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function AA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function BA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function CA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=1.0;i=i;return}function DA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=0.0;i=i;return}function EA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=0.0;i=i;return}function FA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=l;i=b;return}function GA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=l;i=b;return}function HA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=l;i=b;return}function IA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function JA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=0.0;i=i;return}function KA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=0.0;i=i;return}function LA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=0.0;i=i;return}function MA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=1.0;i=i;return}function NA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function OA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=0.0;i=i;return}function PA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function QA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=0.0;i=i;return}function RA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function SA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=1.0;i=i;return}function TA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function UA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function VA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function WA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function XA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function YA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=1.0;i=i;return}function ZA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function _A(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function $A(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function aB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function bB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function cB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=0.0;i=i;return}function dB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=-1.0;i=i;return}function eB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function fB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=1.0;i=i;return}function gB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}function hB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function iB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function jB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function kB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function lB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function mB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=1.0;i=i;return}function nB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function oB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function pB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function qB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=1.0;i=i;return}function rB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function sB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function tB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function uB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=1.0;i=i;return}function vB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function wB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=0.0;i=i;return}function xB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=l;i=b;return}function yB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=l;i=b;return}function zB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7312;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=l;i=b;return}function AB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function BB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=0.0;i=i;return}function CB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function DB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=0.0;i=i;return}function EB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=1.0;i=i;return}function FB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=0.0;i=i;return}function GB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function HB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=0.0;i=i;return}function IB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function JB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function KB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=1.0;i=i;return}function LB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function MB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function NB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function OB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function PB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function QB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function RB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=1.0;i=i;return}function SB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=0.0;i=i;return}function TB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function UB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=0.0;i=i;return}function VB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=1.0;i=i;return}function WB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function XB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function YB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function ZB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=0.0;i=i;return}function _B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function $B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=1.0;i=i;return}function aC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function bC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=0.0;i=i;return}function cC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function dC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=1.0;i=i;return}function eC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function fC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function gC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function hC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=1.0;i=i;return}function iC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function jC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=0.0;i=i;return}function kC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=l;i=b;return}function lC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=l;i=b;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=7352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=7296;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Ei(f,g,e,d);l=+taa(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=l;i=b;return}function nC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function oC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=0.0;i=i;return}function pC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function qC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function rC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=1.0;i=i;return}function sC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=0.0;i=i;return}function tC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function uC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function vC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=0.0;i=i;return}function wC(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function xC(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function yC(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function zC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9048>>3]=0.0;i=i;return}function AC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function BC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function CC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=0.0;i=i;return}function DC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=1.0;i=i;return}function EC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=0.0;i=i;return}function FC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=0.0;i=i;return}function GC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function HC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function IC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function JC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function KC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function LC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=1.0;i=i;return}function MC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function NC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function OC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function PC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function QC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=1.0;i=i;return}function RC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function SC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function TC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function UC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=1.0;i=i;return}function VC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=0.0;i=i;return}function WC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function XC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function YC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=1.0;i=i;return}function ZC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function _C(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=0.0;i=i;return}function $C(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=0.0;i=i;return}function aD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3336>>3]=0.0;i=i;return}function bD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=1.0;i=i;return}function cD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function dD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=0.0;i=i;return}function eD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=0.0;i=i;return}function fD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=1.0;i=i;return}function gD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=0.0;i=i;return}function hD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=0.0;i=i;return}function iD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=0.0;i=i;return}function jD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=1.0;i=i;return}function kD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9024>>3]=0.0;i=i;return}function lD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=0.0;i=i;return}function mD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function nD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function oD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=1.0;i=i;return}function pD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=0.0;i=i;return}function qD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function rD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function sD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=1.0;i=i;return}function tD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=0.0;i=i;return}function uD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=0.0;i=i;return}function vD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=0.0;i=i;return}function wD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=1.0;i=i;return}function xD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9016>>3]=0.0;i=i;return}function yD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9008>>3]=0.0;i=i;return}function zD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9e3>>3]=0.0;i=i;return}function AD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function BD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8976>>3]=0.0;i=i;return}function CD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8960>>3]=0.0;i=i;return}function DD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8952>>3]=0.0;i=i;return}function ED(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function FD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function GD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function HD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function ID(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function JD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function KD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function LD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=0.0;i=i;return}function MD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=0.0;i=i;return}function ND(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=1.0;i=i;return}function OD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=0.0;i=i;return}function PD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function QD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function RD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=1.0;i=i;return}function SD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function TD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=0.0;i=i;return}function UD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=0.0;i=i;return}function VD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=1.0;i=i;return}function WD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function XD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function YD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function ZD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function _D(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function $D(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=1.0;i=i;return}function aE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function bE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function cE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=0.0;i=i;return}function dE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=1.0;i=i;return}function eE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function fE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function gE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function hE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=1.0;i=i;return}function iE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function jE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function kE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function lE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function mE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function nE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=1.0;i=i;return}function oE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function pE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function qE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function rE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=1.0;i=i;return}function sE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=0.0;i=i;return}function tE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function uE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=0.0;i=i;return}function vE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=1.0;i=i;return}function wE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function xE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=0.0;i=i;return}function yE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function zE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function AE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function BE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=1.0;i=i;return}function CE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function DE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=0.0;i=i;return}function EE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function FE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=1.0;i=i;return}function GE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=0.0;i=i;return}function HE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=0.0;i=i;return}function IE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=0.0;i=i;return}function JE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=1.0;i=i;return}function KE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function LE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=0.0;i=i;return}function ME(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=0.0;i=i;return}function NE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=0.0;i=i;return}function OE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=0.0;i=i;return}function PE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=1.0;i=i;return}function QE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=0.0;i=i;return}function RE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=0.0;i=i;return}function SE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=0.0;i=i;return}function TE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=1.0;i=i;return}function UE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=0.0;i=i;return}function VE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=0.0;i=i;return}function WE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=0.0;i=i;return}function XE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=1.0;i=i;return}function YE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=0.0;i=i;return}function ZE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function _E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function $E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function aF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function bF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=1.0;i=i;return}function cF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function dF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=0.0;i=i;return}function eF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=0.0;i=i;return}function fF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=1.0;i=i;return}function gF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=0.0;i=i;return}function hF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=0.0;i=i;return}function iF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=0.0;i=i;return}function jF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=1.0;i=i;return}function kF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=0.0;i=i;return}function lF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8808>>3]=0.0;i=i;return}function mF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function nF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function oF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function pF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=1.0;i=i;return}function qF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=0.0;i=i;return}function rF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function sF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function tF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=1.0;i=i;return}function uF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function vF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function wF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=0.0;i=i;return}function xF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=1.0;i=i;return}function yF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function zF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function AF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function BF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function CF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function DF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=1.0;i=i;return}function EF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function FF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=0.0;i=i;return}function GF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function HF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=1.0;i=i;return}function IF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function JF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=0.0;i=i;return}function KF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function LF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=1.0;i=i;return}function MF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function NF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=0.0;i=i;return}function OF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2384>>3]=0.0;i=i;return}function PF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2376>>3]=0.0;i=i;return}function QF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2368>>3]=0.0;i=i;return}function RF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2360>>3]=0.0;i=i;return}function SF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2352>>3]=0.0;i=i;return}function TF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function UF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2344>>3]=0.0;i=i;return}function VF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2336>>3]=0.0;i=i;return}function WF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2328>>3]=0.0;i=i;return}function XF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2320>>3]=0.0;i=i;return}function YF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2312>>3]=0.0;i=i;return}function ZF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8768>>3]=0.0;i=i;return}function _F(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2304>>3]=0.0;i=i;return}function $F(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2296>>3]=0.0;i=i;return}function aG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2288>>3]=0.0;i=i;return}function bG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2280>>3]=0.0;i=i;return}function cG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2272>>3]=0.0;i=i;return}function dG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2184>>3]=0.0;i=i;return}function eG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2176>>3]=0.0;i=i;return}function fG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2168>>3]=0.0;i=i;return}function gG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2160>>3]=0.0;i=i;return}function hG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2152>>3]=0.0;i=i;return}function iG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2144>>3]=0.0;i=i;return}function jG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2120>>3]=0.0;i=i;return}function kG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2096>>3]=0.0;i=i;return}function lG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2088>>3]=0.0;i=i;return}function mG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2136>>3]=0.0;i=i;return}function nG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2128>>3]=0.0;i=i;return}function oG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2064>>3]=0.0;i=i;return}function pG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function qG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function rG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function sG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function tG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=0.0;i=i;return}function uG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function vG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function wG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function xG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=0.0;i=i;return}function yG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function zG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=0.0;i=i;return}function AG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function BG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function CG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function DG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=0.0;i=i;return}function EG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function FG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function GG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function HG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=0.0;i=i;return}function IG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function JG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function KG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function LG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=0.0;i=i;return}function MG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function NG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function OG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=0.0;i=i;return}function PG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function QG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=0.0;i=i;return}function RG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=0.0;i=i;return}function SG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function TG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function UG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function VG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function WG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function XG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function YG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function ZG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=0.0;i=i;return}function _G(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function $G(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function aH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function bH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function cH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function dH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=0.0;i=i;return}function eH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function fH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=0.0;i=i;return}function gH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function hH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function iH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function jH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=0.0;i=i;return}function kH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1600>>3]=0.0;i=i;return}function lH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=0.0;i=i;return}function mH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1568>>3]=0.0;i=i;return}function nH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1552>>3]=0.0;i=i;return}function oH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=0.0;i=i;return}function pH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1576>>3]=0.0;i=i;return}function qH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1504>>3]=0.0;i=i;return}function rH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1480>>3]=0.0;i=i;return}function sH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1472>>3]=0.0;i=i;return}function tH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=0.0;i=i;return}function uH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1560>>3]=0.0;i=i;return}function vH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1512>>3]=0.0;i=i;return}function wH(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);nz(b);oz(b);pz(b);qz(b);rz(b);sz(b);tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);Fz(b);Gz(b);Hz(b);Iz(b);Jz(b);Kz(b);Lz(b);Mz(b);Nz(b);Oz(b);Pz(b);Qz(b);Rz(b);Sz(b);Tz(b);Uz(b);Vz(b);Wz(b);Xz(b);Yz(b);Zz(b);_z(b);$z(b);aA(b);bA(b);cA(b);dA(b);eA(b);fA(b);gA(b);hA(b);iA(b);jA(b);kA(b);lA(b);mA(b);nA(b);oA(b);pA(b);qA(b);rA(b);sA(b);tA(b);uA(b);vA(b);wA(b);xA(b);yA(b);zA(b);AA(b);BA(b);CA(b);DA(b);EA(b);FA(b);GA(b);HA(b);IA(b);JA(b);KA(b);LA(b);MA(b);NA(b);OA(b);PA(b);QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);a[d]=0;i=c;return 0}function xH(a){a=a|0;i=i;return}function yH(a){a=a|0;i=i;return 0}function zH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+536>>3]=+h[(c[a+416>>2]|0)+1200>>3];i=i;return}function AH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+528>>3]=+h[(c[a+416>>2]|0)+1192>>3];i=i;return}function BH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function CH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[(c[a+416>>2]|0)+1520>>3];i=i;return}function DH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+552>>3]=+h[(c[a+416>>2]|0)+1512>>3];i=i;return}function EH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[(c[a+416>>2]|0)+1504>>3];i=i;return}function FH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8648>>3]=+h[(c[a+416>>2]|0)+3920>>3];i=i;return}function GH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8680>>3]=+h[(c[a+416>>2]|0)+3632>>3];i=i;return}function HH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;D9(9,1,7616,r);if((c[49892>>2]|0)!=0){fe[c[12602]&511](9)}D9(9,1,7640,q);if((c[49892>>2]|0)!=0){fe[c[12602]&511](9)}FH(a);GH(a);D9(9,1,7664,p);p=a+4|0;s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+8648>>3];q=a+8|0;r=c[q>>2]|0;h[r+121152>>3]=s;c[o>>2]=c[r+121076>>2];r=o+4|0;h[k>>3]=s;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];D9(9,0,7688,o);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+8680>>3];o=c[q>>2]|0;h[o+121600>>3]=s;c[n>>2]=c[o+121524>>2];o=n+4|0;h[k>>3]=s;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];D9(9,0,7688,n);if((c[49892>>2]|0)!=0){fe[c[12602]&511](9)}zH(a);AH(a);BH(a);CH(a);DH(a);EH(a);D9(9,1,7704,m);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+536>>3];m=c[q>>2]|0;h[m+7600>>3]=s;c[l>>2]=c[m+7508>>2];m=l+4|0;h[k>>3]=s;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];D9(9,0,7728,l);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+528>>3];l=c[q>>2]|0;h[l+7488>>3]=s;c[j>>2]=c[l+7396>>2];l=j+4|0;h[k>>3]=s;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];D9(9,0,7728,j);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+520>>3];j=c[q>>2]|0;h[j+7376>>3]=s;c[g>>2]=c[j+7284>>2];j=g+4|0;h[k>>3]=s;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];D9(9,0,7728,g);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+560>>3];g=c[q>>2]|0;h[g+7936>>3]=s;c[f>>2]=c[g+7844>>2];g=f+4|0;h[k>>3]=s;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];D9(9,0,7728,f);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+552>>3];f=c[q>>2]|0;h[f+7824>>3]=s;c[e>>2]=c[f+7732>>2];f=e+4|0;h[k>>3]=s;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];D9(9,0,7728,e);s=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+544>>3];p=c[q>>2]|0;h[p+7712>>3]=s;c[d>>2]=c[p+7620>>2];p=d+4|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];D9(9,0,7728,d);if((c[49892>>2]|0)==0){i=b;return 0}fe[c[12602]&511](9);i=b;return 0}function IH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1512>>3]=0.0;i=i;return}function JH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1560>>3]=0.0;i=i;return}function KH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=0.0;i=i;return}function LH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1472>>3]=0.0;i=i;return}function MH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1480>>3]=0.0;i=i;return}function NH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1504>>3]=0.0;i=i;return}function OH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1576>>3]=0.0;i=i;return}function PH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=0.0;i=i;return}function QH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1552>>3]=0.0;i=i;return}function RH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1568>>3]=0.0;i=i;return}function SH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=0.0;i=i;return}function TH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1600>>3]=0.0;i=i;return}function UH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=0.0;i=i;return}function VH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function WH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function XH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function YH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=0.0;i=i;return}function ZH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function _H(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=0.0;i=i;return}function $H(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function aI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function bI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function cI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function dI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function eI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=0.0;i=i;return}function fI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function gI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function hI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function iI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function jI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function kI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function lI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function mI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=0.0;i=i;return}function nI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=0.0;i=i;return}function oI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function pI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=0.0;i=i;return}function qI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function rI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function sI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=0.0;i=i;return}function tI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function uI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function vI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function wI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=0.0;i=i;return}function xI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function yI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function zI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function AI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=0.0;i=i;return}function BI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function CI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function DI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function EI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=0.0;i=i;return}function FI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function GI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=0.0;i=i;return}function HI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function II(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function JI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function KI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=0.0;i=i;return}function LI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function MI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function NI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function OI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function PI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2064>>3]=0.0;i=i;return}function QI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2128>>3]=0.0;i=i;return}function RI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2136>>3]=0.0;i=i;return}function SI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2088>>3]=0.0;i=i;return}function TI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2096>>3]=0.0;i=i;return}function UI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2120>>3]=0.0;i=i;return}function VI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2144>>3]=0.0;i=i;return}function WI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2152>>3]=0.0;i=i;return}function XI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2160>>3]=0.0;i=i;return}function YI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2168>>3]=0.0;i=i;return}function ZI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2176>>3]=0.0;i=i;return}function _I(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2184>>3]=0.0;i=i;return}function $I(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2272>>3]=0.0;i=i;return}function aJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2280>>3]=0.0;i=i;return}function bJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2288>>3]=0.0;i=i;return}function cJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2296>>3]=0.0;i=i;return}function dJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2304>>3]=0.0;i=i;return}function eJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8768>>3]=0.0;i=i;return}function fJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2312>>3]=0.0;i=i;return}function gJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2320>>3]=0.0;i=i;return}function hJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2328>>3]=0.0;i=i;return}function iJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2336>>3]=0.0;i=i;return}function jJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2344>>3]=0.0;i=i;return}function kJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function lJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2352>>3]=0.0;i=i;return}function mJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2360>>3]=0.0;i=i;return}function nJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2368>>3]=0.0;i=i;return}function oJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2376>>3]=0.0;i=i;return}function pJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2384>>3]=0.0;i=i;return}function qJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=0.0;i=i;return}function rJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function sJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=1.0;i=i;return}function tJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function uJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=0.0;i=i;return}function vJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function wJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=1.0;i=i;return}function xJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function yJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=0.0;i=i;return}function zJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function AJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=1.0;i=i;return}function BJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function CJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function DJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function EJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function FJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function GJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=1.0;i=i;return}function HJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=0.0;i=i;return}function IJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function JJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function KJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=1.0;i=i;return}function LJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function MJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function NJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=0.0;i=i;return}function OJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=1.0;i=i;return}function PJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function QJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function RJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function SJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8808>>3]=0.0;i=i;return}function TJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=0.0;i=i;return}function UJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=1.0;i=i;return}function VJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=0.0;i=i;return}function WJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=0.0;i=i;return}function XJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=0.0;i=i;return}function YJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=1.0;i=i;return}function ZJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=0.0;i=i;return}function _J(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=0.0;i=i;return}function $J(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function aK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=1.0;i=i;return}function bK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function cK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function dK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function eK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function fK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=0.0;i=i;return}function gK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=1.0;i=i;return}function hK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=0.0;i=i;return}function iK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=0.0;i=i;return}function jK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=0.0;i=i;return}function kK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=1.0;i=i;return}function lK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=0.0;i=i;return}function mK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=0.0;i=i;return}function nK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=0.0;i=i;return}function oK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=1.0;i=i;return}function pK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2760>>3]=0.0;i=i;return}function qK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=0.0;i=i;return}function rK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=0.0;i=i;return}function sK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=0.0;i=i;return}function tK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function uK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=1.0;i=i;return}function vK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=0.0;i=i;return}function wK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=0.0;i=i;return}function xK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=0.0;i=i;return}function yK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=1.0;i=i;return}function zK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function AK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=0.0;i=i;return}function BK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function CK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=1.0;i=i;return}function DK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function EK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function FK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function GK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=0.0;i=i;return}function HK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function IK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=1.0;i=i;return}function JK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=0.0;i=i;return}function KK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function LK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=0.0;i=i;return}function MK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=1.0;i=i;return}function NK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function OK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function PK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function QK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=1.0;i=i;return}function RK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function SK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function TK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function UK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function VK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function WK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=1.0;i=i;return}



function s2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25400]&1){i=d;return}g=b+420|0;b=Nca(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=faa(25408,daa(c[(c[g>>2]|0)+144>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=25640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25400]=1;i=d;return}function t2(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25664]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+2936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(25672,baa(+h[(c[g>>2]|0)+2936>>3],8104)|0)|0;g=c[24792]|0;j=e;k=25856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25664]=1;i=d;return}function u2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25880]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(25888,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25880]=1;i=d;return}function v2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26064]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(26072,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26064]=1;i=d;return}function w2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26248]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(26256,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26248]=1;i=d;return}function x2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26456]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(26464,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26456]=1;i=d;return}function y2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26632]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(26640,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26632]=1;i=d;return}function z2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26808]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(26816,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=26984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26808]=1;i=d;return}function A2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27008]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27016,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=27536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27008]=1;i=d;return}function B2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27184]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27192,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=27536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27184]=1;i=d;return}function C2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27360]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27368,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=27536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27360]=1;i=d;return}function D2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27560]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27568,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27560]=1;i=d;return}function E2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27696]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27704,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27696]=1;i=d;return}function F2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27832]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27840,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27832]=1;i=d;return}function G2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27968]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(27976,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27968]=1;i=d;return}function H2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28104]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28112,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28104]=1;i=d;return}function I2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28240]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28248,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28240]=1;i=d;return}function J2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28376]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28384,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28376]=1;i=d;return}function K2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28496]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28504,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28496]=1;i=d;return}function L2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28616]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28624,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28616]=1;i=d;return}function M2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28736]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28744,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28736]=1;i=d;return}function N2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28856]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28864,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28856]=1;i=d;return}function O2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28976]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(28984,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[28976]=1;i=d;return}function P2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29096]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29104,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29096]=1;i=d;return}function Q2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29256]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29264,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29256]=1;i=d;return}function R2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29416]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29424,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29416]=1;i=d;return}function S2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29576]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29584,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29576]=1;i=d;return}function T2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29704]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29712,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29704]=1;i=d;return}function U2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29832]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29840,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29832]=1;i=d;return}function V2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29960]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(29968,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29960]=1;i=d;return}function W2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30120]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30128,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30120]=1;i=d;return}function X2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30280]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30288,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30280]=1;i=d;return}function Y2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30440]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30448,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30440]=1;i=d;return}function Z2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30560]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30568,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30560]=1;i=d;return}function _2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30680]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30688,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30680]=1;i=d;return}function $2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30800]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30808,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31256;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30800]=1;i=d;return}function a3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30952]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(30960,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31256;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30952]=1;i=d;return}function b3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31104]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31112,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31256;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31104]=1;i=d;return}function c3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31280]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31288,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31280]=1;i=d;return}function d3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31432]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31440,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31432]=1;i=d;return}function e3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31584]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31592,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=31736;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31584]=1;i=d;return}function f3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31760]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31768,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32192;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31760]=1;i=d;return}function g3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31904]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(31912,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32192;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31904]=1;i=d;return}function h3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32048]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32056,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32192;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32048]=1;i=d;return}function i3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32216]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32224,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32216]=1;i=d;return}function j3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32336]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32344,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32336]=1;i=d;return}function k3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32456]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32464,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=32576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32456]=1;i=d;return}function l3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32600]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32608,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32600]=1;i=d;return}function m3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32760]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32768,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32760]=1;i=d;return}function n3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32920]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(32928,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33080;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32920]=1;i=d;return}function o3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33104]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33112,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33104]=1;i=d;return}function p3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33232]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33240,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33232]=1;i=d;return}function q3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33360]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33368,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33360]=1;i=d;return}function r3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33512]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33520,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33512]=1;i=d;return}function s3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33672]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33680,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33672]=1;i=d;return}function t3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33832]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(33840,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=33992;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[33832]=1;i=d;return}function u3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34016]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34024,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34016]=1;i=d;return}function v3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34176]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34184,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34176]=1;i=d;return}function w3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34336]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34344,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34336]=1;i=d;return}function x3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34520]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34528,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34520]=1;i=d;return}function y3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34656]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34664,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34656]=1;i=d;return}function z3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34792]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34800,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=34928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34792]=1;i=d;return}function A3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34952]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(34960,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=35432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34952]=1;i=d;return}function B3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35112]&1){i=d;return}g=b+4|0;b=Nca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(35120,daa(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=35432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35112]=1;i=d;return}function C3(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35272]&1){i=d;return}g=b+4|0;b=Nca(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(Lca(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=faa(35280,daa(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,8760)|0)|0;g=c[24792]|0;h=e;j=35432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35272]=1;i=d;return}function D3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35456]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(35464,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8912>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35456]=1;i=d;return}function E3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35688]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(35696,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8896>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35688]=1;i=d;return}function F3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35840]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(35848,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8880>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35840]=1;i=d;return}function G3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35984]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(35992,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8864>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35984]=1;i=d;return}function H3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36128]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36136,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8848>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36128]=1;i=d;return}function I3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36272]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36280,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8832>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36272]=1;i=d;return}function J3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36416]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36424,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8816>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36416]=1;i=d;return}function K3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36560]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36568,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8800>>3],8104)|0)|0;g=c[24792]|0;j=e;k=36704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36560]=1;i=d;return}function L3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36728]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36736,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8784>>3],8104)|0)|0;g=c[24792]|0;j=e;k=37224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36728]=1;i=d;return}function M3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36952]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(36960,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8776>>3],8104)|0)|0;g=c[24792]|0;j=e;k=37224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36952]=1;i=d;return}function N3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37088]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(37096,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8768>>3],8104)|0)|0;g=c[24792]|0;j=e;k=37224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37088]=1;i=d;return}function O3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37248]&1){i=d;return}g=b+416|0;if(!((Nca(+h[(c[g>>2]|0)+3920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(37256,baa(+h[(c[g>>2]|0)+3920>>3],8104)|0)|0;g=c[24792]|0;j=e;k=37344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37248]=1;i=d;return}function P3(a){a=a|0;var b=0;b=i;IH(a);JH(a);KH(a);LH(a);MH(a);NH(a);OH(a);PH(a);QH(a);RH(a);SH(a);TH(a);UH(a);VH(a);WH(a);XH(a);YH(a);ZH(a);_H(a);$H(a);aI(a);bI(a);cI(a);dI(a);eI(a);fI(a);gI(a);hI(a);iI(a);jI(a);kI(a);lI(a);mI(a);nI(a);oI(a);pI(a);qI(a);rI(a);sI(a);tI(a);uI(a);vI(a);wI(a);xI(a);yI(a);zI(a);AI(a);BI(a);CI(a);DI(a);EI(a);FI(a);GI(a);HI(a);II(a);JI(a);KI(a);LI(a);MI(a);NI(a);OI(a);PI(a);QI(a);RI(a);SI(a);TI(a);UI(a);VI(a);WI(a);XI(a);YI(a);ZI(a);_I(a);$I(a);aJ(a);bJ(a);cJ(a);dJ(a);eJ(a);fJ(a);gJ(a);hJ(a);iJ(a);jJ(a);kJ(a);lJ(a);mJ(a);nJ(a);oJ(a);pJ(a);qJ(a);rJ(a);sJ(a);tJ(a);uJ(a);vJ(a);wJ(a);xJ(a);yJ(a);zJ(a);AJ(a);BJ(a);CJ(a);DJ(a);EJ(a);FJ(a);GJ(a);HJ(a);IJ(a);JJ(a);KJ(a);LJ(a);MJ(a);NJ(a);OJ(a);PJ(a);QJ(a);RJ(a);SJ(a);TJ(a);UJ(a);VJ(a);WJ(a);XJ(a);YJ(a);ZJ(a);_J(a);$J(a);aK(a);bK(a);cK(a);dK(a);eK(a);fK(a);gK(a);hK(a);iK(a);jK(a);kK(a);lK(a);mK(a);nK(a);oK(a);pK(a);qK(a);rK(a);sK(a);tK(a);uK(a);vK(a);wK(a);xK(a);yK(a);zK(a);AK(a);BK(a);CK(a);DK(a);EK(a);FK(a);GK(a);HK(a);IK(a);JK(a);KK(a);LK(a);MK(a);NK(a);OK(a);PK(a);QK(a);RK(a);SK(a);TK(a);UK(a);VK(a);WK(a);XK(a);YK(a);ZK(a);_K(a);$K(a);aL(a);bL(a);cL(a);dL(a);eL(a);fL(a);gL(a);hL(a);iL(a);jL(a);kL(a);lL(a);mL(a);nL(a);oL(a);pL(a);qL(a);rL(a);sL(a);tL(a);uL(a);vL(a);wL(a);xL(a);yL(a);zL(a);AL(a);BL(a);CL(a);DL(a);EL(a);FL(a);GL(a);HL(a);IL(a);JL(a);KL(a);LL(a);ML(a);NL(a);OL(a);PL(a);QL(a);RL(a);SL(a);TL(a);UL(a);VL(a);WL(a);XL(a);YL(a);ZL(a);_L(a);$L(a);aM(a);bM(a);cM(a);dM(a);eM(a);fM(a);gM(a);hM(a);iM(a);jM(a);kM(a);lM(a);mM(a);nM(a);oM(a);pM(a);qM(a);rM(a);sM(a);tM(a);uM(a);vM(a);wM(a);xM(a);yM(a);zM(a);AM(a);BM(a);CM(a);DM(a);EM(a);FM(a);GM(a);HM(a);IM(a);JM(a);KM(a);LM(a);MM(a);NM(a);OM(a);PM(a);QM(a);RM(a);SM(a);TM(a);UM(a);VM(a);WM(a);XM(a);YM(a);ZM(a);_M(a);$M(a);aN(a);bN(a);cN(a);dN(a);eN(a);fN(a);gN(a);hN(a);iN(a);jN(a);kN(a);lN(a);mN(a);nN(a);oN(a);pN(a);qN(a);rN(a);sN(a);tN(a);uN(a);vN(a);wN(a);xN(a);yN(a);zN(a);AN(a);BN(a);CN(a);DN(a);EN(a);FN(a);GN(a);HN(a);IN(a);JN(a);KN(a);LN(a);MN(a);NN(a);ON(a);PN(a);QN(a);RN(a);SN(a);TN(a);UN(a);VN(a);WN(a);XN(a);YN(a);ZN(a);_N(a);$N(a);aO(a);bO(a);cO(a);dO(a);eO(a);fO(a);gO(a);hO(a);iO(a);jO(a);kO(a);lO(a);mO(a);nO(a);oO(a);pO(a);qO(a);rO(a);sO(a);tO(a);uO(a);vO(a);wO(a);xO(a);yO(a);zO(a);AO(a);BO(a);CO(a);DO(a);EO(a);FO(a);GO(a);HO(a);IO(a);JO(a);KO(a);LO(a);MO(a);NO(a);OO(a);PO(a);QO(a);RO(a);SO(a);TO(a);UO(a);VO(a);WO(a);XO(a);YO(a);ZO(a);_O(a);$O(a);aP(a);bP(a);cP(a);dP(a);eP(a);fP(a);gP(a);hP(a);iP(a);jP(a);kP(a);lP(a);mP(a);nP(a);oP(a);pP(a);qP(a);rP(a);sP(a);tP(a);uP(a);vP(a);wP(a);xP(a);yP(a);zP(a);AP(a);BP(a);CP(a);DP(a);EP(a);FP(a);GP(a);HP(a);IP(a);JP(a);KP(a);LP(a);MP(a);NP(a);OP(a);PP(a);QP(a);RP(a);SP(a);TP(a);UP(a);VP(a);WP(a);XP(a);YP(a);ZP(a);_P(a);$P(a);aQ(a);bQ(a);cQ(a);dQ(a);eQ(a);fQ(a);gQ(a);hQ(a);iQ(a);jQ(a);kQ(a);lQ(a);mQ(a);nQ(a);oQ(a);pQ(a);qQ(a);rQ(a);sQ(a);tQ(a);uQ(a);vQ(a);wQ(a);xQ(a);yQ(a);zQ(a);AQ(a);BQ(a);CQ(a);DQ(a);EQ(a);FQ(a);GQ(a);HQ(a);IQ(a);JQ(a);KQ(a);LQ(a);MQ(a);NQ(a);OQ(a);PQ(a);QQ(a);RQ(a);SQ(a);TQ(a);UQ(a);VQ(a);WQ(a);XQ(a);YQ(a);ZQ(a);_Q(a);$Q(a);aR(a);bR(a);cR(a);dR(a);eR(a);fR(a);gR(a);hR(a);iR(a);jR(a);kR(a);lR(a);mR(a);nR(a);oR(a);pR(a);qR(a);rR(a);sR(a);tR(a);uR(a);vR(a);wR(a);xR(a);yR(a);zR(a);AR(a);BR(a);CR(a);DR(a);ER(a);FR(a);GR(a);HR(a);IR(a);JR(a);KR(a);LR(a);MR(a);NR(a);OR(a);PR(a);QR(a);RR(a);SR(a);TR(a);UR(a);VR(a);WR(a);XR(a);YR(a);ZR(a);_R(a);$R(a);aS(a);bS(a);cS(a);dS(a);eS(a);fS(a);gS(a);hS(a);iS(a);jS(a);kS(a);lS(a);mS(a);nS(a);oS(a);pS(a);qS(a);rS(a);sS(a);tS(a);uS(a);vS(a);wS(a);xS(a);yS(a);zS(a);AS(a);BS(a);CS(a);DS(a);ES(a);FS(a);GS(a);HS(a);IS(a);JS(a);KS(a);LS(a);MS(a);NS(a);OS(a);PS(a);QS(a);RS(a);SS(a);TS(a);US(a);VS(a);WS(a);XS(a);YS(a);ZS(a);_S(a);$S(a);aT(a);bT(a);cT(a);dT(a);eT(a);fT(a);gT(a);hT(a);iT(a);jT(a);kT(a);lT(a);mT(a);nT(a);oT(a);pT(a);qT(a);rT(a);sT(a);tT(a);uT(a);vT(a);wT(a);xT(a);yT(a);zT(a);AT(a);BT(a);CT(a);DT(a);ET(a);FT(a);GT(a);HT(a);IT(a);JT(a);KT(a);LT(a);MT(a);NT(a);OT(a);PT(a);QT(a);RT(a);ST(a);TT(a);UT(a);VT(a);WT(a);XT(a);YT(a);ZT(a);_T(a);$T(a);aU(a);bU(a);cU(a);dU(a);eU(a);fU(a);gU(a);hU(a);iU(a);jU(a);kU(a);lU(a);mU(a);nU(a);oU(a);pU(a);qU(a);rU(a);sU(a);tU(a);uU(a);vU(a);wU(a);xU(a);yU(a);zU(a);AU(a);BU(a);CU(a);DU(a);EU(a);FU(a);GU(a);HU(a);IU(a);JU(a);KU(a);LU(a);MU(a);NU(a);OU(a);PU(a);QU(a);RU(a);SU(a);TU(a);UU(a);VU(a);WU(a);XU(a);YU(a);ZU(a);_U(a);$U(a);aV(a);bV(a);cV(a);dV(a);eV(a);fV(a);gV(a);hV(a);iV(a);jV(a);kV(a);lV(a);mV(a);nV(a);oV(a);pV(a);qV(a);rV(a);sV(a);tV(a);uV(a);vV(a);wV(a);xV(a);yV(a);zV(a);AV(a);BV(a);CV(a);DV(a);EV(a);FV(a);GV(a);HV(a);IV(a);JV(a);KV(a);LV(a);MV(a);NV(a);OV(a);PV(a);QV(a);RV(a);SV(a);TV(a);UV(a);VV(a);WV(a);XV(a);YV(a);ZV(a);_V(a);$V(a);aW(a);bW(a);cW(a);dW(a);eW(a);fW(a);gW(a);hW(a);iW(a);jW(a);kW(a);lW(a);mW(a);nW(a);oW(a);pW(a);qW(a);rW(a);sW(a);tW(a);uW(a);vW(a);wW(a);xW(a);yW(a);zW(a);AW(a);BW(a);CW(a);DW(a);EW(a);FW(a);GW(a);HW(a);IW(a);JW(a);KW(a);LW(a);MW(a);NW(a);OW(a);PW(a);QW(a);RW(a);SW(a);TW(a);UW(a);VW(a);WW(a);XW(a);YW(a);ZW(a);_W(a);$W(a);aX(a);bX(a);cX(a);dX(a);eX(a);fX(a);gX(a);hX(a);iX(a);jX(a);kX(a);lX(a);mX(a);nX(a);oX(a);pX(a);qX(a);rX(a);sX(a);tX(a);uX(a);vX(a);wX(a);xX(a);yX(a);zX(a);AX(a);BX(a);CX(a);DX(a);EX(a);FX(a);GX(a);HX(a);IX(a);JX(a);KX(a);LX(a);MX(a);NX(a);OX(a);PX(a);QX(a);RX(a);SX(a);TX(a);UX(a);VX(a);WX(a);XX(a);YX(a);ZX(a);_X(a);$X(a);aY(a);bY(a);cY(a);dY(a);eY(a);fY(a);gY(a);hY(a);iY(a);jY(a);kY(a);lY(a);mY(a);nY(a);oY(a);pY(a);qY(a);rY(a);sY(a);tY(a);uY(a);vY(a);wY(a);xY(a);yY(a);zY(a);AY(a);BY(a);CY(a);DY(a);EY(a);FY(a);GY(a);HY(a);IY(a);JY(a);KY(a);LY(a);MY(a);NY(a);OY(a);PY(a);QY(a);RY(a);SY(a);TY(a);UY(a);VY(a);WY(a);XY(a);YY(a);ZY(a);_Y(a);$Y(a);aZ(a);bZ(a);cZ(a);dZ(a);eZ(a);fZ(a);gZ(a);hZ(a);iZ(a);jZ(a);kZ(a);lZ(a);mZ(a);nZ(a);oZ(a);pZ(a);qZ(a);rZ(a);sZ(a);tZ(a);uZ(a);vZ(a);wZ(a);xZ(a);yZ(a);zZ(a);AZ(a);BZ(a);CZ(a);DZ(a);EZ(a);FZ(a);GZ(a);HZ(a);IZ(a);JZ(a);KZ(a);LZ(a);MZ(a);NZ(a);OZ(a);PZ(a);QZ(a);RZ(a);SZ(a);TZ(a);UZ(a);VZ(a);WZ(a);XZ(a);YZ(a);ZZ(a);_Z(a);$Z(a);a_(a);b_(a);c_(a);d_(a);e_(a);f_(a);g_(a);h_(a);i_(a);j_(a);k_(a);l_(a);m_(a);n_(a);o_(a);p_(a);q_(a);r_(a);s_(a);t_(a);u_(a);v_(a);w_(a);x_(a);y_(a);z_(a);A_(a);B_(a);C_(a);D_(a);E_(a);F_(a);G_(a);H_(a);I_(a);J_(a);K_(a);L_(a);M_(a);N_(a);O_(a);P_(a);Q_(a);R_(a);S_(a);T_(a);U_(a);V_(a);W_(a);X_(a);Y_(a);Z_(a);__(a);$_(a);a$(a);b$(a);c$(a);d$(a);e$(a);f$(a);g$(a);h$(a);i$(a);j$(a);k$(a);l$(a);m$(a);n$(a);o$(a);p$(a);q$(a);r$(a);s$(a);t$(a);u$(a);v$(a);w$(a);x$(a);y$(a);z$(a);A$(a);B$(a);C$(a);D$(a);E$(a);F$(a);G$(a);H$(a);I$(a);J$(a);K$(a);L$(a);M$(a);N$(a);O$(a);P$(a);Q$(a);R$(a);S$(a);T$(a);U$(a);V$(a);W$(a);X$(a);Y$(a);Z$(a);_$(a);$$(a);a0(a);b0(a);c0(a);d0(a);e0(a);f0(a);g0(a);h0(a);i0(a);j0(a);k0(a);l0(a);m0(a);n0(a);o0(a);p0(a);q0(a);r0(a);s0(a);t0(a);u0(a);v0(a);w0(a);x0(a);y0(a);z0(a);A0(a);B0(a);C0(a);D0(a);E0(a);F0(a);G0(a);H0(a);I0(a);J0(a);K0(a);L0(a);M0(a);N0(a);O0(a);P0(a);Q0(a);R0(a);S0(a);T0(a);U0(a);V0(a);W0(a);X0(a);Y0(a);Z0(a);_0(a);$0(a);a1(a);b1(a);c1(a);d1(a);e1(a);f1(a);g1(a);h1(a);i1(a);j1(a);k1(a);l1(a);m1(a);n1(a);o1(a);p1(a);q1(a);r1(a);s1(a);t1(a);u1(a);v1(a);w1(a);x1(a);y1(a);z1(a);A1(a);B1(a);C1(a);D1(a);E1(a);F1(a);G1(a);H1(a);I1(a);J1(a);K1(a);L1(a);M1(a);N1(a);O1(a);P1(a);Q1(a);R1(a);S1(a);T1(a);U1(a);V1(a);W1(a);X1(a);Y1(a);Z1(a);_1(a);$1(a);a2(a);b2(a);c2(a);d2(a);e2(a);f2(a);g2(a);h2(a);i2(a);j2(a);k2(a);l2(a);m2(a);n2(a);o2(a);p2(a);q2(a);r2(a);s2(a);t2(a);u2(a);v2(a);w2(a);x2(a);y2(a);z2(a);A2(a);B2(a);C2(a);D2(a);E2(a);F2(a);G2(a);H2(a);I2(a);J2(a);K2(a);L2(a);M2(a);N2(a);O2(a);P2(a);Q2(a);R2(a);S2(a);T2(a);U2(a);V2(a);W2(a);X2(a);Y2(a);Z2(a);_2(a);$2(a);a3(a);b3(a);c3(a);d3(a);e3(a);f3(a);g3(a);h3(a);i3(a);j3(a);k3(a);l3(a);m3(a);n3(a);o3(a);p3(a);q3(a);r3(a);s3(a);t3(a);u3(a);v3(a);w3(a);x3(a);y3(a);z3(a);A3(a);B3(a);C3(a);D3(a);E3(a);F3(a);G3(a);H3(a);I3(a);J3(a);K3(a);L3(a);M3(a);N3(a);O3(a);i=b;return 0}function Q3(b){b=b|0;var c=0;c=i;a[b+314|0]=0;R3(b);i=c;return 0}function R3(a){a=a|0;var b=0;b=i;df(a);ef(a);ff(a);gf(a);jf(a);kf(a);lf(a);mf(a);tf(a);zf(a);Af(a);Bf(a);Cf(a);Ef(a);Ff(a);Gf(a);Hf(a);Jf(a);Kf(a);Lf(a);Mf(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Wf(a);Xf(a);Yf(a);Zf(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);zg(a);Eg(a);hh(a);jh(a);kh(a);rh(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);bi(a);ci(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);i=b;return}function S3(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37616]&1){i=d;return}g=b+4|0;if(!((Nca(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=faa(37632,baa(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8648>>3],37624)|0)|0;g=c[24792]|0;j=e;k=37800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37616]=1;i=d;return}function T3(a){a=a|0;var b=0;b=i;S3(a);i=b;return 0}function U3(a){a=a|0;i=i;return 1}function V3(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=4;c[a+48>>2]=4;c[a+72>>2]=bEa(4,8)|0;a=bEa(4,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=bEa(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=$Da(16)|0;c[(c[d>>2]|0)+52>>2]=a;a=$Da(24)|0;c[(c[d>>2]|0)+56>>2]=a;a=$Da(16)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=2;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=2;c[e+4>>2]=3;c[e+8>>2]=5;c[e+12>>2]=6;W3(6,c[a+56>>2]|0);a=c[d>>2]|0;X3(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Y3(c[(c[a+52>>2]|0)+4>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Z3(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+12>>2]=1;c[a+4>>2]=1;c[a+8>>2]=2;c[a>>2]=2;i=b;return 0}function W3(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=2;i=i;return}function X3(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function Y3(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=0;i=i;return}function Z3(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=0;c[b+((c[a>>2]|0)+ -1<<2)>>2]=1;i=i;return}function _3(a){a=a|0;i=i;return 1}function $3(a){a=a|0;i=i;return 1}function a4(a){a=a|0;i=i;return 1}function b4(a){a=a|0;i=i;return 0}function c4(a){a=a|0;i=i;return 0}function d4(a){a=a|0;i=i;return 0}function e4(a){a=a|0;i=i;return 0}function f4(a){a=a|0;i=i;return 0}function g4(a,b){a=a|0;b=b|0;i=i;return-1}function h4(a,b){a=a|0;b=b|0;i=i;return-1}function i4(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function j4(){i=i;return 37824}function k4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function l4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function m4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function n4(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(38600,n|0)|0;i=m;return 0}function o4(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=Hba(a,38608)|0;z=Hba(b,38608)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((Hba(a,38616)|0)!=0){C=5;break}if((Hba(a,38624)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((Hba(b,38616)|0)!=0){break}if((Hba(b,38624)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){HEa(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}HEa(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}HEa(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(38632,r|0)|0;i=q;return 0}




// EMSCRIPTEN_END_FUNCS
var be=[GFa,Yba,_ba,dca,cra,GFa,GFa,GFa];var ce=[HFa,B6,C6,f7,g7,K7,L7,g8,h8,i8,XDa,WDa,VDa,Caa,V5,W5,E9,C9,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa,HFa];var de=[IFa,Ida];var ee=[JFa,Kca];var fe=[KFa,Fi,Gi,zj,Ej,xH,Gj,z9,Ufa,Xfa,Wfa,Yfa,awa,$va,cwa,bwa,Zfa,$fa,lja,Hja,Ija,Jja,Nva,Mva,Pva,Ova,Aqa,Nqa,Oqa,Pqa,Rqa,Tqa,Jsa,Ksa,Qsa,Rsa,Xsa,Ysa,cta,dta,pta,ota,uta,tta,wta,xta,Gta,Fta,Nua,Mua,Wua,Vua,yva,xva,Wva,Vva,Yva,Xva,owa,nwa,qwa,pwa,wwa,vwa,Lua,xwa,uwa,ywa,Awa,zwa,IAa,Gwa,Fwa,Lwa,Kwa,ixa,hxa,Mxa,Lxa,_xa,Zxa,mya,lya,Aya,zya,Nya,Mya,Qya,Pya,Uya,Tya,dza,cza,oza,nza,zza,yza,Kza,Jza,Uza,Tza,aAa,$za,gAa,fAa,mAa,lAa,rAa,qAa,AAa,zAa,YAa,XAa,vAa,nBa,UBa,TBa,WBa,VBa,Bwa,HAa,KAa,fBa,vBa,GBa,RBa,SBa,IDa,HDa,KDa,NDa,LDa,MDa,ODa,PDa,kEa,jEa,yi,LFa,Hi,Ii,Ji,Ki,Li,Mi,Ni,Oi,Pi,Qi,Ri,Si,Ti,Ui,Vi,Wi,Xi,Yi,Zi,_i,$i,df,ef,ff,gf,jf,kf,lf,mf,tf,zf,Af,Bf,Cf,Ef,Ff,Gf,Hf,Jf,Kf,Lf,Mf,Pf,Qf,Rf,Sf,Tf,Uf,Wf,Xf,Yf,Zf,ag,bg,cg,dg,eg,fg,gg,hg,ig,jg,kg,lg,mg,ng,og,pg,qg,rg,sg,zg,Eg,hh,jh,kh,rh,uh,vh,wh,xh,yh,zh,Ah,Dh,Eh,Fh,Gh,Hh,Ih,Jh,Kh,Lh,Mh,Nh,Oh,Ph,Qh,Rh,Sh,Th,Uh,Vh,Wh,Xh,Yh,Zh,_h,$h,ai,bi,ci,di,ei,fi,gi,hi,ii,ji,ki,li,mi,ni,oi,pi,qi,ri,si,ti,aEa,B9,Ze,uca,yca,tca,Lda,Aca,Jda,Yaa,Dca,Bca,Cca,zca,Fca,Kda,Gca,vca,Ica,lqa,Jca,hsa,Isa,JAa,CCa,Mza,JCa,ICa,HCa,GCa,FCa,ECa,Wta,yua,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa,KFa];var ge=[MFa,Fj,qea,aga,lva,Lsa,Ssa,Zsa,eta,zva,Xya,Yya,Zya,_ya,aza,bza,gza,hza,iza,jza,lza,mza,rza,sza,tza,uza,wza,xza,Cza,Dza,Eza,Fza,Hza,Iza,pAa,uAa,$Ba,bCa,dCa,aCa,cCa,eCa,lca,aj,xj,Aj,Bj,Cj,Dj,Eca,Tia,sea,rea,tea,zea,Lea,uea,Jea,gia,sia,ria,tia,bia,$ha,dia,qra,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa,MFa];var he=[NFa,i6,b6,Zba,$ba,aca,bca,cca];var ie=[OFa,vi,Q3,ui,$e,af,bf,yH,HH,Mj,wH,P3,T3,Lj,Jj,U3,V3,_3,$3,a4,b4,c4,d4,e4,f4,PFa,QFa,RFa,V9,$Da,SFa,ega,qva,fga,tva,pva,Wqa,Msa,Eva,Gva,Hva,Dva,Tsa,Usa,_sa,sva,fta,gta,qta,vta,swa,nya,fCa,hCa,jCa,pCa,rCa,lCa,nCa,Bya,gCa,iCa,kCa,qCa,sCa,mCa,oCa,Vya,Wya,$ya,eza,fza,kza,pza,qza,vza,Aza,Bza,Gza,rBa,sBa,uBa,XBa,ZBa,YBa,_Ba,jBa,kBa,mBa,BBa,CBa,FBa,MBa,NBa,QBa,JDa,lEa,Sda,TFa,UFa,Qda,Rda,VFa,eqa,Fqa,Oca,Wca,gda,Pca,Zca,hda,Asa,uEa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa,OFa];var je=[WFa,Aaa];var ke=[XFa,Iba];var le=[YFa,Ij,s6,y6,Y6,c7,B7,H7,bga,rva,vva,mva,Ava,Fva,Nsa,Jva,$sa,Ata,Bta,Ewa,Jwa,nAa,sAa,_Aa,aBa,dBa,LAa,QAa,SAa,VAa,QDa,nqa,Baa,f6,Y5,d6,j6,ZFa,_Fa,$Fa,Mda,kqa,gqa,aGa,ssa,bGa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa,YFa];var me=[cGa,Mba];var ne=[dGa,eba];var oe=[eGa,Uxa,Xxa,gya,iya,eGa,eGa,eGa];var pe=[fGa,Oya,Rya,Lza,Pza,Vza,Xza,fGa];var qe=[gGa,Gba];var re=[hGa,w9,cga,Uqa,Bva,nva,Nxa,Oxa,Sxa,Yxa,$xa,aya,eya,jya,oAa,tAa,_Da,ZDa,YDa,x9,hGa,hGa,hGa,hGa,hGa,hGa,hGa,hGa,hGa,hGa,hGa,hGa];var se=[iGa,Xca,Yca,iGa];var te=[jGa,xi];var ue=[kGa,Mwa,Owa,Qwa,Swa,Uwa,Wwa,Ywa,_wa,axa,cxa,exa,jxa,lxa,nxa,pxa,rxa,txa,vxa,xxa,zxa,Bxa,Dxa,Rxa,Txa,dya,fya,oya,pya,qya,rya,sya,Cya,Dya,Eya,Fya,Gya,eAa,kAa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa,kGa];var ve=[lGa,bAa,hAa,lGa];var we=[mGa,tya,Hya,mGa];var xe=[nGa,_e,Nj,Kj,Hj,g4,h4,u6,v6,x6,_6,$6,b7,D7,E7,G7,M7,N7,O7,P7,Q7,R7,S7,T7,gga,hga,Xqa,Yqa,Iva,Osa,Vsa,Kva,uva,ata,hta,wva,ZAa,$Aa,bBa,PAa,RAa,TAa,Ada,jda,$ca,Qca,ida,_ca,oGa,cEa,S5,T5,U5,pGa,gaa,cda,fda,Tca,wda,nda,Vca,qGa,tDa,nGa];var ye=[rGa,Cwa,Hwa,eBa,qBa,tBa,WAa,iBa,lBa,ABa,DBa,LBa,OBa,o8,f9,g9,t8,q8,d9,e9,u8,v8,w8,x8,y8,V8,W8,M8,F8,A8,z8,B8,C8,E8,D8,r8,p8,G8,H8,I8,J8,K8,L8,N8,O8,P8,Q8,U8,S8,R8,T8,$8,X8,Y8,Z8,_8,a9,b9,c9,h9,i9,j9,k9,Pxa];var ze=[sGa,Xda];var Ae=[tGa,kda];var Be=[uGa,oba];var Ce=[vGa,j4,wGa,W9,Fsa,Gsa,Dsa,vGa];var De=[xGa,Lba];var Ee=[yGa,pqa,zta,twa,vaa,H9,lea,nea,Sia,pra,yGa,yGa,yGa,yGa,yGa,yGa];var Fe=[zGa,AGa,U9,n9,Ai,zGa,zGa,zGa];var Ge=[BGa,i4,oBa,pBa,gBa,hBa,wBa,yBa,HBa,JBa,oda,BGa,BGa,BGa,BGa,BGa];var He=[CGa,m6,n6,o6,p6,q6,r6,t6,w6,A6,S6,T6,U6,V6,W6,X6,Z6,a7,e7,v7,w7,x7,y7,z7,A7,C7,F7,J7,cBa,MAa,NAa,OAa,UAa,nca,DGa,Hba,K5,N4,g5,p5,b5,y5,D5,B5,E5,k6,Q5,_5,$5,g6,h6,gxa,Vxa,EGa,CGa,CGa,CGa,CGa,CGa,CGa,CGa,CGa,CGa,CGa];var Ie=[FGa,z6,d7,I7,dga,oqa,Vqa,Cva,ova,Dwa,Iwa,RDa,SDa,TDa,F9,D9,pca,G9,bj,yj,Kra,a6,I9,FGa,FGa,FGa,FGa,FGa,FGa,FGa,FGa,FGa];return{_testSetjmp:QEa,_saveSetjmp:CEa,_free:aEa,_main:zi,_rand_r:KEa,_realloc:cEa,_i64Add:NEa,_memmove:GEa,_bitshift64Ashr:EEa,_memset:HEa,_malloc:$Da,_strncpy:OEa,_memcpy:FEa,_strlen:DEa,_bitshift64Lshr:PEa,_bitshift64Shl:IEa,_i64Subtract:MEa,_strcpy:JEa,_calloc:bEa,_rand:LEa,__GLOBAL__I_a:jta,runPostSets:BEa,stackAlloc:Je,stackSave:Ke,stackRestore:Le,setThrew:Me,setTempRet0:Pe,setTempRet1:Qe,setTempRet2:Re,setTempRet3:Se,setTempRet4:Te,setTempRet5:Ue,setTempRet6:Ve,setTempRet7:We,setTempRet8:Xe,setTempRet9:Ye,dynCall_iiiiiiii:_Ea,dynCall_viiiii:$Ea,dynCall_iiiiidiii:aFa,dynCall_vd:bFa,dynCall_vi:cFa,dynCall_vii:dFa,dynCall_iiiiiiiiiii:eFa,dynCall_ii:fFa,dynCall_viidi:gFa,dynCall_iiiiiiiiiiiiii:hFa,dynCall_iiii:iFa,dynCall_iiiiiiiiiiiiiiiiiiiiiii:jFa,dynCall_iiiiiiiiiiiiiiiiiiiii:kFa,dynCall_viiiiid:lFa,dynCall_viiiiiiii:mFa,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:nFa,dynCall_viiiiii:oFa,dynCall_viidii:pFa,dynCall_iid:qFa,dynCall_viiiiiii:rFa,dynCall_viiiiiid:sFa,dynCall_viiiiiiiii:tFa,dynCall_iii:uFa,dynCall_iiiiii:vFa,dynCall_iiiiidi:wFa,dynCall_didd:xFa,dynCall_dii:yFa,dynCall_i:zFa,dynCall_iiiiiiiiii:AFa,dynCall_viii:BFa,dynCall_v:CFa,dynCall_iiiiiiiii:DFa,dynCall_iiiii:EFa,dynCall_viiii:FFa}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






